package ModuleLoader;

# --- debuging ---
$debug = 0;
$debug_directory = '/tmp';
$debug_file = "$debug_directory/module_loader.log";

$use_module_preload = 1;
# ------------------

$module_preload_cache = 'modules.preload.cache';
#$module_preload_deps_file = 'modules.preload.deps';

#%modules_deps = ();

`echo ">>> MODULE <ModuleLoader> has been loaded <<<" >> $debug_file` if $debug;

# &preload_module($package_name, $module_name);
sub preload_module {
	my ($pkg, $module) = ($_[0], $_[1]);
	`echo "sub preload_module {" >> $debug_file` if $debug;
	if ($module) {
		my ($config_dir) = ($miniserv::config{'env_WEBMIN_CONFIG'});
		`echo "module name: $module" >> $debug_file` if $debug;
		if (&check_is_loaded($pkg, $module)) {
			`echo "lib is already loaded" >> $debug_file` if $debug;
		}
		else {
			`echo "lib is not loaded" >> $debug_file` if $debug;
			&module_load($pkg, $module);
			`echo "$pkg $module" >> $config_dir/$module_preload_cache` if $use_module_preload;
		}
	}
	`echo "} # sub preload_module" >> $debug_file` if $debug;
}

sub load_module_preload_cache {
	return unless $use_module_preload;
	`echo "sub load_module_preload_cache {" >> $debug_file` if $debug;
	my $config_dir = $miniserv::config{'env_WEBMIN_CONFIG'};
	my $file = "$config_dir/$module_preload_cache";
	if (-e $file) {
		if (open(FILE, "<$file")) {
			while (my $line = <FILE>) {
				chomp($line);
				if ($line =~ /^(\S*)(\s(\S+))?$/) {
					my ($pkg, $module) = ($1, $3);
					`echo "try to load $module into $pkg" >> $debug_file` if $debug;
					&module_load($pkg, $module) unless (&check_is_loaded($pkg, $module));
				}
			}
			close(FILE);
			system("rm -f '$file'");
		}
	}
	`echo "} # sub load_module_preload_cache" >> $debug_file` if $debug;
	`echo >> $debug_file` if $debug;
}

# &check_is_loaded($module_name);
sub check_is_loaded {
	return &miniserv::check_is_loaded(@_);
}

sub module_load {
	&miniserv::module_load(@_);
}


1;
