#!/usr/bin/perl
package ThemefuncsLib;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'ThemefuncsLib');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
%{$self->{'modules_conf_hash'}} = (
'acl' => [],
'adsl-client' => ['K:pppoe', 'K:adsl-start'],
'apache' => ['D:httpd_dir', 'X:httpd_path'],
'at' => ['K:at', 'D:at_dir'],
'amavis' => ['R:amavisd_cmd'],
'backup_config' => [],
'bandwidth' => [],
'bind8' => ['X:named_path'],
'bsdexports' => [],
'cpan' => [],
'cpplus' => [],
'cppluslog' => [],
'cron' => ['D:cron_dir', 'K:crontab'],
'custom' => [],
'cyrus_sasl' => ['X:saslauthd_cmd'],
'clamav' => ['R:clamav_cmd'],
'courier_imap' => ['X:pop3_daemon'],
'dovecot' => ['C:dovecot_config', 'R:dovecot'],
'dg' => ['X:dansguardian_cmd'],
'dhcpd' => ['C:dhcpd_conf', 'R:dhcpd_path'],
'dfsadmin' => [],
'enduser_cf' => ['D:usermin_dir'],
'exports' => ['R:nfs_server'],
'fdisk' => [],
'fetchmail' => ['R:fetchmail_path'],
'file' => [],
'firewall' => ['K:iptables'],
'format' => [],
'frox' => ['C:frox_conf', 'R:frox'],
'fsdump' => [],
'grub' => ['C:menu_file', 'X:grub_path'],
'home' => [],
'hpuxexports' => [],
'htaccess_htpasswd' => ['K:htdigest'],
'idmapd' => ['X:idmapd_path'],
'inetd' => [],
'init' => [], #'D:init_base'
'inittab' => ['C:inittab_file'],
'ipfilter' => ['C:ipf', 'C:ipfilter'],
'ipfw' => ['R:ipfw'],
'ipsec' => ['R:ipsec', 'C:file'],
'jabber' => ['C:jabber_config', 'D:jabber_dir'],
'jakarta_tomcat' => ['D:java_home','D:tomcat_home','X:tomcat_cmd'],
'krb5' => ['C:krb5_conf'],
'ldap-useradmin' => ['C:auth_ldap'],
'lilo' => ['C:lilo_conf', 'R:lilo_cmd'],
'logrotate' => ['C:logrotate_conf', 'R:logrotate'],
'lpadmin' => [],
'lvm' => ['K:vgdisplay'],
'mailboxes' => [],
'mailcap' => ['C:mailcap'],
'mailman' => ['C:mailman_conf'],
'majordomo' => ['C:majordomo_cf', 'D:program_dir'],
'man' => [],
'mon' => ['C:cfbasedir'],
'mount' => ['C:fstab_file'],
'mysql' => ['X:mysqladmin', 'X:mysql'],
'net' => [],
'nis' => [],
'openslp' => ['X:slpd'],
'pam' => ['D:pam_dir'],
'pap' => ['R:mgetty'],
'passwd' => [],
'phpini' => ['M:apache'],
'plugins' => ['M:apache'],
'postfix' => ['X:postfix_control_command'],
'postgresql' => ['X:psql', 'C:hba_conf'],
'ppp-client' => ['K:pppd', 'K:mgetty'],
'pptp_client' => ['R:pptp'],
'pptp_server' => ['R:pptpd'],
'proc' => [],
'procmail' => ['R:procmail'],
'proftpd' => ['X:proftpd_path', 'C:proftpd_conf'],
'pserver' => ['D:cvsroot'],
'qmailadmin' => ['D:qmail_dir'],
'quota' => ['K:quota'],
'raid' => ['C:mdstat', 'K:mdadm'],
'rbac' =>['C:user_attr', 'C:prof_attr', 'C:auth_attr', 'C:exec_attr', 'C:policy_conf', 'C:project'],
'samba' => ['X:samba_server'],
'sarg' => ['C:sarg_conf', 'R:sarg'],
'sendmail' => ['X:sendmail_path', 'S:sendmail_cf'],
'sentry' => ['R:portsentry', 'R:hostsentry', 'R:logcheck'],
'sgiexports' => [],
'shell' => [],
'shorewall' => ['R:shorewall', 'D:config_dir'],
'smart_status' => [],
'software' => [],
'spam' => ['R:spamassassin'],
'squid' => ['C:squid_conf', 'R:squid_path'],
'sshd' => ['C:sshd_config', 'R:sshd_path'],
'status' => [],
'stunnel' => ['X:stunnel_path'],
'swup' => ['C:swup_conf', 'X:swup_path'],
'syslog' => ['C:syslog_conf'],
'syslog_ng' => ['K:syslog_ng'],
'telnet' => [],
'time' => [],
'tunnel' => [],
'updown' => [],
'useradmin' => [],
'virtual_server' => [],
'vsftpd' => ['C:vsftpd_conf', 'X:vsftpd_cmd'],
'webalizer' => ['R:webalizer'],
'wuftpd' => ['X:ftpd_path', 'C:ftpaccess'],
'xinetd' => ['C:xinetd_conf'],
'zones' => ['K:zoneadm'],
);

# --- appliances/servers specific functions ---

# Read the product global config file. 
$self->{'gconfig_file'} = "$self->{'config_directory'}/config";
$self->read_file_cached($self->{'gconfig_file'}, \%{$self->{'gconfig_hash'}});

@{$self->{'ztl_appliances_array'}} = $self->{'gconfig_hash'}->{'ztl_mode'} ? ('web', 'mail', 'dns', 'mysql', 'postgres', 'cifs', 'pdc', 'print', 'proxy', 'dhcp', 'firewall') : ('web', 'mail', 'mailman', 'dns', 'ftp', 'mysql', 'postgres', 'ssl', 'quota');
%{$self->{'ztl_appliances_complex_hash'}} = (
    'samba' => ['cifs', 'pdc', 'print'],
    'databases' => ['mysql', 'postgres'],
);

%{$self->{'ztl_apps_depends_hash'}} = (
	'web' => ['apache'],
	'mail' => ['mailboxes'],
	'mailman' => ['mailman'],
	'dns' => ['bind8'],
	'mysql' => ['mysql'],
	'postgres' => ['postgresql'],
	'samba' => ['samba'],
	'proxy' => ['squid'],
	'dhcp' => ['dhcpd'],
	'firewall' => ['firewall'],
);

%{$self->{'ztl_apps_depends_virt_hash'}} = (
	'web' => ['web'],
	'mail' => ['mail'],
	'mailman' => ['mailman'],
	'dns' => ['dns'],
	'mysql' => ['mysql'],
	'postgres' => ['postgres'],
	'cifs' => ['samba'],
	'print' => ['samba'],
	'pdc' => ['samba'],
	'ssl' => ['ssl'],
	'ftp' => ['ftp'],
	'quota' => ['quota'],
);

$self->{'done_theme_lib_funcs'} = 1;

1;
1;
		return $self;
}

# $self->configured($module_name);
sub configured {
	my $self = shift;

	return 1 unless $_[0];
	my $mod = $_[0];
	$mod =~ s/\-/\_/g unless -r "$self->{'config_directory'}/$mod/config";
	my ($mod_name, $rv) = ($mod, 1);
	my %minfo = $self->get_module_info($mod_name);
	return 0 unless $self->check_os_support(\%minfo);
	foreach my $cmd (@{$self->{'modules_conf_hash'}->{$mod_name}}) {
		my ($type, $check) = split (/:/, $cmd);
		my %config = ();
		$self->read_file("$self->{'config_directory'}/$mod_name/config", \%config);

		if    ($type =~ /^X/) { $rv = ( -x $config{$check} ); }
		elsif ($type =~ /^C/) { $rv = ( -r $config{$check} ); }
		elsif ($type =~ /^D/) { $rv = ( -d $config{$check} ); }
		elsif ($type =~ /^S/) { $rv = ( -s $config{$check} ); }
		elsif ($type =~ /^K/) 
		{ 
		 delete $main::has_command_cache{$check};
		 $rv = $self->has_command($check); 
		}
		elsif ($type =~ /^R/) 
		{ 
		 delete $main::has_command_cache{$config{$check}};
		 $rv = $self->has_command($config{$check}); 
		}
		elsif ($type =~ /^M/) 
		{ 
		 delete $main::has_command_cache{$config{$check}};
		 $rv = $self->configured($check); 
		}

		return 0 unless $rv;
		#else { return 1; }
	}
	return $rv;
}

# &check_plugins()
# return 1 if some plugins configured
sub check_plugins
{
	my $self = shift;

 $self->foreign_require('plugins','plugins-lib.pl');
 foreach (@{$main::plugins_object->{'plugin_list_array'}})
 {
  if ($main::plugins_object->{'config_hash'}->{"configured_$_"})
  {
   # check plugin depends
   my $func = $_."_depends";
	my $dep = $self->foreign_call('plugins',$func);
	my $nodeps;
   foreach my $i (keys %{$dep})
   {
    $nodeps = 1 if ($dep->{$i}->[0] == 0);
   }
	return 1 unless $nodeps;
  }
 }
 return 0;
}

# &accessable($module_name);
sub accessable {
	my $self = shift;

	local (%hash1, %hash2);
	$self->read_acl(\%hash1, \%hash2);
	local $mod;
	($mod = $_[0]) =~ s/\-/\_/g;
	local $rv =  $hash1{$self->{'remote_user'}, $_[0]} || $hash1{$self->{'remote_user'}, $mod};
	return $rv ? 1 : 0;
}

sub get_mode_user {
	my $self = shift;

	local $key = 'mode_'.$self->{'remote_user'};
	return ($self->{'gconfig_hash'}->{$key} ? $self->{'gconfig_hash'}->{$key} : 0);
}

# check_date_string(date_string)
# Checks string with date: Mmm dd yyyy
sub check_date_string {
	my $self = shift;

	return $_[0] =~ /\s\d\d?\s\d{4}$/;
}

# ui_buttons_row_xpressia(script, icon, button-label, description, [hiddens], [after-submit],
#		 [before-submit]) 
sub ui_buttons_row_xpressia
{
	my $self = shift;

# return &theme_ui_buttons_row(@_) if (defined(&theme_ui_buttons_row));
local ($script, $icon, $label, $desc, $hiddens, $after, $before) = @_;
# return "<form action=$script>\n".
return 
	$hiddens.
	"<tr> <td nowrap width=20%>".($before ? $before." " : "").
	"<a href='$script'><img border=0 src='$icon'>".
	$self->quote_escape($label).($after ? " ".$after : "")."</td>\n".
	"<td valign=top width=80%>$desc</td> </tr>\n";
}

# return hash with appliances' complain
# &ztl_get_appliances(\%appliances);
sub ztl_get_appliances {
	my $self = shift;

	local $apps = $_[0];
	# loading virtual_server module's config file
	local $mname = 'virtual_server';
	local ($virtsrv_config_directory, $virtsrv_config_file);
	local %virtsrv_config = ();
	$virtsrv_config_directory = "$self->{'config_directory'}/$mname";
	$virtsrv_config_file = "$virtsrv_config_directory/config";
	$self->read_file_cached($virtsrv_config_file, \%virtsrv_config);
	# checking installed and configured appliances
	local ($a, $d, $v);
	foreach $a (@{$self->{'ztl_appliances_array'}}, @{$self->{'ztl_features_array'}}) {
		$apps->{$a}->{'on'} = $self->{'gconfig_hash'}->{'ztl_mode'} ? $self->{'gconfig_hash'}->{"$a\_app_on"} : 1;
		if ($apps->{$a}->{'on'} && $self->{'ztl_apps_depends_virt_hash'}->{$a}) {
			foreach $v (@{$self->{'ztl_apps_depends_virt_hash'}->{$a}}) {
				$apps->{$a}->{'on'} = $apps->{$a}->{'on'} && $virtsrv_config{$v};
			}
		}
		if ($apps->{$a}->{'on'} && $self->{'ztl_apps_depends_hash'}->{$a}) {
			foreach $d (@{$self->{'ztl_apps_depends_hash'}->{$a}}) {
				$apps->{$a}->{'on'} = $apps->{$a}->{'on'} && $self->configured($d) && $self->accessable($d);
			}
		}
	}
	foreach $a (keys %{$self->{'ztl_appliances_complex_hash'}}) {
		foreach $d (@{$self->{'ztl_appliances_complex_hash'}->{$a}}) {
			$apps->{$a}->{'on'} = $apps->{$a}->{'on'} || $apps->{$d}->{'on'};
		}
	}
}

# &ztl_check_condition(\%appliances, $condition);
sub ztl_check_condition {
	my $self = shift;

	local $apps = $_[0];
	local $condition = $_[1];
	my $a;
	foreach $a (@{$self->{'ztl_appliances_array'}}, @{$self->{'ztl_features_array'}}) {
		my $v = $apps->{$a}->{'on'} ? 1 : 0;
		$condition =~ s/\$$a\b/$v/g;
	}
	while ($condition =~ /\$M(\S+)/) {
		my $var = $1;
		my $v = $self->configured($var) && $self->accessable($var);
		$condition =~ s/\$M$var\b/$v/g;
	}
	if ($condition =~ /\$P(\S+)/) {
	   # plugin configured ?
		$condition = $self->check_plugins($var);
	}
	local $rv = eval("$condition");
	return $rv;
}

# &ztl_get_text(\%appliances, text1, [...])
# e.g., &ztl_get_text(\%appliances, "website_backup:$web && $dns", "domain_backup:$dns");
sub ztl_get_text {
	my $self = shift;

	local $apps = shift(@_);
	foreach my $p (@_) {
		next if $p =~ /^#/;
		if ($p =~ /^([^:]+):(.*)$/) {
			my ($label, $cond) = ($1, $2);
			if ($self->ztl_check_condition($apps, $cond)) {
				return $self->{'text_hash'}->{$label};
			}
		}
	}
	return undef;
}

# $self->ztl_get_text(\%appliances, $text)
sub ztl_get_jointext {
	my $self = shift;

	local $apps = shift(@_);
	local @texts = split(';', shift(@_));
	return $self->ztl_get_text($apps, @texts);
}

sub ztl_get_uptime {
	my $self = shift;

	local $uptime_cmd = '/usr/bin/uptime';
	return '' unless -e $uptime_cmd;
	local $result;
	local $rv = `$uptime_cmd`;
	$rv =~ m/up\s+(.*?),[^,]*?user/i;
	( $result = $1 ) =~ tr/,//d;
	return $result;
}

# &get_access_level ($username)
# returns access level number or array (access_level, ref domain)
sub ztl_get_access_level {
	my $self = shift;

	my $user = $_[0];
	my (%hash1, %hash2);
	$self->read_acl(\%hash1, \%hash2);
	if ($hash1{$user, 'useradmin'} && $hash1{$user, 'acl'} && $hash1{$user, 'virtual_server'}) {
		return (wantarray ? (0, undef) : 0);
}
	elsif ($hash1{$user, 'virtual_server'}) {
		return 1 unless (wantarray);
		$self->foreign_require("virtual_server", "virtual-server-lib.pl");
		my @domains = $self->foreign_call("virtual_server", "get_domain_by", "user", "$user");
		my ($dom) = grep {!$_->{'parent'}}@domains;
		return (1, $dom);
	}
}


1;

