#!/usr/bin/perl
package WebLib;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'WebLib');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# web-lib.pl
# Common functions and definitions for web admin programs

# Configuration and spool directories
if (!defined($ENV{'WEBMIN_CONFIG'})) {
	die "WEBMIN_CONFIG not set";
	}
$self->{'config_directory'} = $ENV{'WEBMIN_CONFIG'};
if (!defined($ENV{'WEBMIN_VAR'})) {
	open(VARPATH, "$self->{'config_directory'}/var-path");
	chop($self->{'var_directory'} = <VARPATH>);
	close(VARPATH);
	}
else {
	$self->{'var_directory'} = $ENV{'WEBMIN_VAR'};
	}

if ($ENV{'SESSION_ID'}) {
	# Hide this variable from called programs, but keep it for internal use
	$self->{'session_id'} = $ENV{'SESSION_ID'};
	delete($ENV{'SESSION_ID'});
	}
if ($ENV{'REMOTE_PASS'}) {
	# Hide the password too
	$self->{'remote_pass'} = $ENV{'REMOTE_PASS'};
	delete($ENV{'REMOTE_PASS'});
	}

if ($> == 0 && $< != 0 && !$ENV{'FOREIGN_MODULE_NAME'}) {
	# Looks like we are running setuid, but the real UID hasn't been set.
	# Do so now, so that executed programs don't get confused
	$( = $);
	$< = $>;
	}

# On Windows, always do IO in binary mode
#binmode(STDIN);
#binmode(STDOUT);

$self->{'remote_error_handler'} = "error";
@INC = $self->unique(@INC, ".");
%{$self->{'month_to_number_map_hash'}} = ( 'jan' => 0, 'feb' => 1, 'mar' => 2, 'apr' => 3,
                	 'may' => 4, 'jun' => 5, 'jul' => 6, 'aug' => 7,
                	 'sep' => 8, 'oct' => 9, 'nov' =>10, 'dec' =>11 );
%{$self->{'number_to_month_map_hash'}} = reverse(%{$self->{'month_to_number_map_hash'}});
$self->{'initial_process_id'} ||= $$;
$self->{'http_cache_directory'} = $ENV{'WEBMIN_VAR'}."/cache";

if (!$self->{'done_web_lib_funcs'}) {
	 $self->{'script'} = -r '../web-lib-funcs.pl' ? '../web-lib-funcs.pl'
						 : 'web-lib-funcs.pl';
	{
    my $pkg = $self->lib_to_pkg($self->{script}, "");
    &ModuleLoader::preload_module(ref($self), "$pkg");
    $pkg .= '::';
    eval "\$self = new $pkg ref(\$self),\%\$self;"; 
}
	}
if (!$self->{'done_theme_lib_funcs'}) {
	 $self->{'script'} = -r '../theme-lib-funcs.pl' ? '../theme-lib-funcs.pl'
						 : 'theme-lib-funcs.pl';
	{
    my $pkg = $self->lib_to_pkg($self->{script}, "");
    &ModuleLoader::preload_module(ref($self), "$pkg");
    $pkg .= '::';
    eval "\$self = new $pkg ref(\$self),\%\$self;"; 
}
	}

1;

1;
		return $self;
}

# unique
# Returns the unique elements of some array
sub unique
{
	my $self = shift;

local(%found, @rv, $e);
foreach $e (@_) {
	if (!$found{$e}++) { push(@rv, $e); }
	}
return @rv;
}

sub lib_to_pkg {
shift;
my ($file_require, $cur_module) = @_;
my @mas = split ('/', $file_require);
my $lib  = pop @mas;
my $mod = pop @mas if (scalar (@mas) > 0 );
$mod =~ s/\-/_/;
$cur_module = '' if ($mod =~ m/../);
$cur_module = $mod if ($mod =~ m/^[A-Za-z0-9_]+$/);

$lib =~ s/(.+)\.pl.*/$1/;
# detect package name
if ($lib =~ /(.+)-lib/) {
    $lib =~ s/(.+)-lib/\u$1/;
    $lib .= 'Lib';
} elsif ($lib =~ /(.+)/) {
    $lib =~ s/(.+)/\u$1/;
}
$lib =~ s/[^a-zA-Z0-9_]//g;

my $pkg = $cur_module ? "$cur_module\:\:$lib" : "$lib";
return $pkg;
}

1;

