#!/usr/bin/perl
package acl::Backup_config;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'acl::Backup_config');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;

&ModuleLoader::preload_module(ref($self), "acl::AclLib");
$self = new acl::AclLib:: ref($self), %$self; 

1;

1;
		return $self;
}

# backup_config_files()
# Returns files and directories that can be backed up
sub backup_config_files
{
	my $self = shift;

local @rv;

# Add primary user and group files
local %miniserv;
$self->get_miniserv_config(\%miniserv);
push(@rv, $miniserv{'userfile'});
push(@rv, $self->acl_filename());

# Add all .acl files for users and groups
local $u;
foreach $u ($self->list_users(), $self->list_groups()) {
	push(@rv, "$self->{'config_directory'}/$u->{'name'}.acl",
		  glob("$self->{'config_directory'}/*/$u->{'name'}.acl"));
	}

# Add /etc/webmin/config
system("cp $self->{'config_directory'}/config $self->{'config_directory'}/config.aclbackup");
push(@rv, "$self->{'config_directory'}/config.aclbackup");

# Add /etc/webmin/miniserv.conf
system("cp $self->{'config_directory'}/miniserv.conf $self->{'config_directory'}/miniserv.conf.aclbackup");
push(@rv, "$self->{'config_directory'}/miniserv.conf.aclbackup");

return @rv;
}

# pre_backup(&files)
# Called before the files are actually read
sub pre_backup
{
	my $self = shift;

return undef;
}

# post_backup(&files)
# Called after the files are actually read
sub post_backup
{
	my $self = shift;

unlink("$self->{'config_directory'}/config.aclbackup");
unlink("$self->{'config_directory'}/miniserv.conf.aclbackup");
return undef;
}

# pre_restore(&files)
# Called before the files are restored from a backup
sub pre_restore
{
	my $self = shift;

# Remove user and group .acl files
local $u;
foreach $u ($self->list_users(), $self->list_groups()) {
	unlink("$self->{'config_directory'}/$u->{'name'}.acl",
	       glob("$self->{'config_directory'}/*/$u->{'name'}.acl"));
	}
return undef;
}

# post_restore(&files)
# Called after the files are restored from a backup
sub post_restore
{
	my $self = shift;

# Splice global config entries for users into real config
local %aclbackup;
$self->read_file("$self->{'config_directory'}/config.aclbackup", \%aclbackup);
unlink("$self->{'config_directory'}/config.aclbackup");
local $k;
foreach $k (keys %{$self->{'gconfig_hash'}}) {
	delete($self->{'gconfig_hash'}->{$k}) if ($k =~ /^(lang_|notabs_|skill_|risk_|theme_|ownmods_)/);
	}
foreach $k (keys %aclbackup) {
	$self->{'gconfig_hash'}->{$k} = $aclbackup{$k} if ($k =~ /^(lang_|notabs_|skill_|risk_|theme_|ownmods_)/);
	}
$self->write_file("$self->{'config_directory'}/config", \%{$self->{'gconfig_hash'}});

# Splice miniserv.conf entries for users into real config
%aclbackup = ( );
$self->read_file("$self->{'config_directory'}/miniserv.conf.aclbackup", \%aclbackup);
unlink("$self->{'config_directory'}/miniserv.conf.aclbackup");
local %miniserv;
$self->get_miniserv_config(\%miniserv);
foreach $k (keys %miniserv) {
	delete($miniserv{$k}) if ($k =~ /^(preroot_)/);
	}
foreach $k (keys %aclbackup) {
	$miniserv{$k} = $aclbackup{$k} if ($k =~ /^(preroot_)/);
	}
$self->put_miniserv_config(\%miniserv);

$self->restart_miniserv();
return undef;
}


1;

