#!/usr/bin/perl
package acl::Log_parser;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'acl::Log_parser');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# log_parser.pl
# Functions for parsing this module's logs

&ModuleLoader::preload_module(ref($self), "acl::AclLib");
$self = new acl::AclLib:: ref($self), %$self; 

1;
		return $self;
}

# parse_webmin_log(user, script, action, type, object, &params)
# Converts logged information from this module into human-readable form
sub parse_webmin_log
{
	my $self = shift;

local ($user, $script, $action, $type, $object, $p) = @_;
local $g = $type eq 'group' ? "_g" : "";
if ($action eq 'modify') {
	if ($p->{'old'} ne $p->{'name'}) {
		return $self->text('log_rename'.$g, "<tt>$p->{'old'}</tt>",
					      "<tt>$p->{'name'}</tt>");
		}
	else {
		return $self->text('log_modify'.$g,
			     "<tt>".$self->html_escape($object)."</tt>");
		}
	}
elsif ($action eq 'create') {
	if ($p->{'clone'}) {
		return $self->text('log_clone'.$g, "<tt>$p->{'clone'}</tt>",
			     "<tt>".$self->html_escape($object)."</tt>");
		}
	else {
		return $self->text('log_create'.$g,
			     "<tt>".$self->html_escape($object)."</tt>");
		}
	}
elsif ($action eq 'delete') {
	if ($type eq "users" || $type eq "groups") {
		return $self->text('log_delete_'.$type, $object);
		}
	else {
		return $self->text('log_delete'.$g, "<tt>$object</tt>");
		}
	}
elsif ($action eq 'acl') {
	return $self->text('log_acl', "<tt>$object</tt>",
		     "<i>".$self->html_escape($p->{'moddesc'})."</i>");
	}
elsif ($action eq 'reset') {
	return $self->text('log_reset', "<tt>$object</tt>",
		     "<i>".$self->html_escape($p->{'moddesc'})."</i>");
	}
elsif ($action eq 'cert') {
	return $self->text('log_cert', "<tt>".$self->html_escape($object)."</tt>");
	}
elsif ($action eq 'switch') {
	return $self->text('log_switch', "<tt>".$self->html_escape($object)."</tt>");
	}
else {
	return undef;
	}
}


1;

