#!/usr/bin/perl
package acl::Postinstall;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'acl::Postinstall');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;

&ModuleLoader::preload_module(ref($self), "acl::AclLib");
$self = new acl::AclLib:: ref($self), %$self; 

1;
		return $self;
}

# Rename the .acl files for any groups to .gacl files
sub module_install
{
	my $self = shift;

# Fix up .acl files
local @mods = $self->get_all_module_infos();
local %isuser = map { $_->{'name'}, 1 } $self->list_users();
local $g;
foreach $g ($self->list_groups()) {
	next if ($isuser{$g->{'name'}});
	local $m;
	foreach $m (@mods) {
		if (-r "$self->{'config_directory'}/$m->{'dir'}/$g->{'name'}.acl") {
			print STDERR "renaming $self->{'config_directory'}/$m->{'dir'}/$g->{'name'}.acl $self->{'config_directory'}/$m->{'dir'}/$g->{'name'}.gacl\n";
			rename("$self->{'config_directory'}/$m->{'dir'}/$g->{'name'}.acl",
			       "$self->{'config_directory'}/$m->{'dir'}/$g->{'name'}.gacl");
			}
		}
	}

# Update sub-groups in webmin.groups file to use @ names
foreach $g ($self->list_groups()) {
	local ($u, @newmembers, $any);
	foreach $u (@{$g->{'members'}}) {
		if ($u !~ /^\@/ && !$isuser{$u}) {
			push(@newmembers, '@'.$u);
			$any = 1;
			}
		else {
			push(@newmembers, $u);
			}
		}
	$g->{'members'} = \@newmembers;
	if ($any) {
		print STDERR "Changing members of $g->{'name'} to ",join(" ", @newmembers),"\n";
		$self->modify_group($g->{'name'}, $g);
		}
	}
}


1;

