#!/usr/bin/perl
package acl::Useradmin_update;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'acl::Useradmin_update');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;

&ModuleLoader::preload_module(ref($self), "acl::AclLib");
$self = new acl::AclLib:: ref($self), %$self; 

1;

1;
		return $self;
}

# useradmin_create_user(&details)
# Create a new webmin user in the group
sub useradmin_create_user
{
	my $self = shift;

return if (!$self->{'config_hash'}->{'sync_create'});
local ($group) = grep { $_->{'name'} eq $self->{'config_hash'}->{'sync_group'} }
		      $self->list_groups();
return if (!$group);
local ($clash) = grep { $_->{'name'} eq $_[0]->{'user'} }
			($self->list_users(), $self->list_groups());
return if ($clash);
return if ($_[0]->{'user'} !~ /^[A-z0-9\-\_\.]+$/);
local $user = { 'name' => $_[0]->{'user'},
		'pass' => $self->{'config_hash'}->{'sync_unix'} ? 'x' : $_[0]->{'pass'},
		'sync' => 1,
		'modules' => $group->{'modules'} };
$self->create_user($user);
push(@{$group->{'members'}}, $user->{'name'});
$self->modify_group($group->{'name'}, $group);

foreach $m (@{$group->{'modules'}}, "") {
	local %groupacl;
	unlink("$self->{'config_directory'}/$m/$user->{'name'}.acl");
	if ($self->read_file("$self->{'config_directory'}/$m/$group->{'name'}.gacl",
		       \%groupacl)) {
		$self->write_file("$self->{'config_directory'}/$m/$user->{'name'}.acl",
			    \%groupacl);
		}
	}
$self->reload_miniserv();
}

# useradmin_delete_user(&details)
# Delete this webmin user if in sync
sub useradmin_delete_user
{
	my $self = shift;

return if (!$self->{'config_hash'}->{'sync_delete'});
local @list = $self->list_users();
foreach $u (@list) {
	if ($u->{'name'} eq $_[0]->{'user'}) {
		$self->delete_user($u->{'name'});
		$self->reload_miniserv();
		}
	}
foreach $g ($self->list_groups()) {
	local @mems = @{$g->{'members'}};
	local $i = $self->indexof($_[0]->{'user'}, @mems);
	if ($i >= 0) {
		splice(@mems, $i, 1);
		$g->{'members'} = \@mems;
		$self->modify_group($g->{'name'}, $g);
		}
	}
}

# useradmin_modify_user(&details)
# Update this users password if in sync
sub useradmin_modify_user
{
	my $self = shift;

return if ($_[0]->{'passmode'} == 4 && $_[0]->{'olduser'} eq $_[0]->{'user'});
foreach $u ($self->list_users()) {
	if ($u->{'name'} eq $_[0]->{'olduser'} && $u->{'sync'}) {
		if ($_[0]->{'user'} ne $_[0]->{'olduser'}) {
			# New name might clash (or be invalid)
			local ($clash) =grep { $_->{'name'} eq $_[0]->{'user'} }
						($self->list_users(), $self->list_groups());
			return if ($clash);
			return if ($_[0]->{'user'} !~ /^[A-z0-9\-\_\.]+$/);
			}
		$u->{'name'} = $_[0]->{'user'};
		if ($u->{'pass'} ne 'x') {
			$u->{'pass'} = $_[0]->{'passmode'} == 3 ?
			   $self->encrypt_password($_[0]->{'plainpass'}) :
			   $_[0]->{'pass'};
			}
		$self->modify_user($_[0]->{'olduser'}, $u);
		$self->reload_miniserv();
		}

	# Check other users' acl module acls
	local %uaccess = $self->get_module_acl($u->{'name'});
	local @au = split(/\s+/, $uaccess{'users'});
	local $idx = $self->indexof($_[0]->{'olduser'}, @au);
	if ($idx != -1) {
		$au[$idx] = $_[0]->{'user'};
		$uaccess{'users'} = join(" ", @au);
		$self->save_module_acl(\%uaccess, $u->{'name'});
		}
	}

# Rename the user in his group
if ($_[0]->{'user'} ne $_[0]->{'olduser'}) {
	foreach $g ($self->list_groups()) {
		local @mems = @{$g->{'members'}};
		local $i = $self->indexof($_[0]->{'olduser'}, @mems);
		if ($i >= 0) {
			$mems[$i] = $_[0]->{'user'};
			$g->{'members'} = \@mems;
			$self->modify_group($g->{'name'}, $g);
			}
		}
	}
}


1;

