#!/usr/bin/perl

&MAIN();

 sub MAIN {
# cert_issue.cgi

&ModuleLoader::preload_module('acl_class', "acl::AclLib");
$self = new acl::AclLib:: 'acl_class',%$self;

$self->ReadParse();

$self->error_setup($self->{'text_hash'}->{'cert_err'});
$self->{'in_hash'}->{'key'} || $self->error($self->{'text_hash'}->{'cert_ekey'});
$self->get_miniserv_config(\%{$self->{'miniserv_hash'}});

# Create the new key
$self->{'temp1'} = $self->transname();
$self->{'temp2'} = $self->tempname();
open(IN, ">$self->{'temp1'}");
foreach $k ("emailAddress", "organizationalUnitName", "organizationName",
	    "stateOrProvinceName", "countryName", "commonName") {
	print IN "$k = $self->{'in_hash'}->{$k}\n";
	}
$self->{'in_hash'}->{'key'} =~ s/\s//g;
print IN "SPKAC = $self->{'in_hash'}->{'key'}\n";
close(IN);
$self->{'cmd'} = $self->get_ssleay();
$self->{'ssleay'} = $self->backquote_logged("$self->{'cmd'} ca -spkac $self->{'temp1'} -out $self->{'temp2'} -config $self->{'module_config_directory'}/openssl.cnf -days 1095 2>&1");
unlink($self->{'temp1'});
if ($?) {
	$self->error("<pre>$self->{'ssleay'}</pre>");
	}
else {
	# Display status and redirect to actual cert file
	$| = 1;
	$self->ui_print_header(undef, $self->{'text_hash'}->{'cert_title'}, "");
	print "<p>",$self->text('cert_done', $self->{'in_hash'}->{'commonName'}),"<p>\n";
	print "<font size=+1>",$self->text('cert_pickup', "cert_output.cgi?file=$self->{'temp2'}"),"</font><p>\n";
	$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

	# Update the miniserv users file
	$self->lock_file($self->{'miniserv_hash'}->{'userfile'});
	$self->{'lref'} = $self->read_file_lines($self->{'miniserv_hash'}->{'userfile'});
	foreach $l (@{$self->{'lref'}}) {
		@u = split(/:/, $l);
		if ($u[0] eq $self->{'base_remote_user'}) {
			$l = "$u[0]:$u[1]:$u[2]:/C=$self->{'in_hash'}->{'countryName'}/ST=$self->{'in_hash'}->{'stateOrProvinceName'}/O=$self->{'in_hash'}->{'organizationName'}/OU=$self->{'in_hash'}->{'organizationalUnitName'}/CN=$self->{'in_hash'}->{'commonName'}/Email=$self->{'in_hash'}->{'emailAddress'}";
			}
		}
	$self->flush_file_lines();
	$self->unlock_file($self->{'miniserv_hash'}->{'userfile'});

	sleep(1);
	$self->restart_miniserv();
	$self->webmin_log("cert", undef, $self->{'base_remote_user'}, \%{$self->{'in_hash'}});
	}

1;
		
}


1;

