#!/usr/bin/perl

&MAIN();

 sub MAIN {
# cert_issue_ie.cgi

&ModuleLoader::preload_module('acl_class', "acl::AclLib");
$self = new acl::AclLib:: 'acl_class',%$self;

$self->ReadParse();

$self->error_setup($self->{'text_hash'}->{'cert_err'});
$self->get_miniserv_config(\%{$self->{'miniserv_hash'}});

# Save certificate request to a file
$self->{'req'} = $self->{'in_hash'}->{'data'};
$self->{'req'} =~ s/\r|\n//g;
$self->{'temp'} = $self->transname();
open(TEMP, ">$self->{'temp'}");
print TEMP "-----BEGIN CERTIFICATE REQUEST-----\n";
$self->{'result'} = 1;
while($self->{'result'}) {
    $self->{'result'} = substr($self->{'req'}, 0, 72);
    if($self->{'result'}) {
	print TEMP "$self->{'result'}\n";
	$self->{'req'} = substr($self->{'req'}, 72);
    }
}
print TEMP "-----END CERTIFICATE REQUEST-----\n";
close(TEMP);

# Call the openssl CA command to process the request
$self->{'temp2'} = $self->transname();
$self->{'cmd'} = $self->get_ssleay();
$self->{'out'} = $self->backquote_logged("yes | $self->{'cmd'} ca -in $self->{'temp'} -out $self->{'temp2'} -config $self->{'module_config_directory'}/openssl.cnf -days 1095 2>&1");
if ($?) {
	unlink($self->{'temp'});
	$self->error("<pre>$self->{'out'}</pre>");
	}
unlink($self->{'temp'});

# Create CRL if needed
$self->{'crl'} = "$self->{'module_config_directory'}/crl.pem";
if (!-r $self->{'crl_file'}) {
	$self->{'out'} = $self->backquote_logged("$self->{'config_hash'}->{'ssleay'} ca -gencrl -out $self->{'crl'} -config $self->{'module_config_directory'}/openssl.cnf 2>&1");
	if ($?) {
		$self->error("<pre>$self->{'out'}</pre>");
		}
	}

# Call the openssl crl2pkcs7 command to add to the CRL
$self->{'temp3'} = $self->transname();
$self->{'out'} = $self->backquote_logged("$self->{'config_hash'}->{'ssleay'} crl2pkcs7 -certfile $self->{'temp2'} -in $self->{'crl'} -out $self->{'temp3'} 2>&1");
if ($?) {
	unlink($self->{'temp2'});
	$self->error("<pre>$self->{'out'}</pre>");
	}
unlink($self->{'temp2'});
open(OUT, $self->{'temp3'});
while(<OUT>) {
	s/\r|\n//g;
	if (/BEGIN PKCS7/) {
		$self->{'started'}++;
		}
	elsif (/END PKCS7/) {
		last;
		}
	elsif ($self->{'started'}) {
		$self->{'certificate'} .= $_;
		}
	}
close(OUT);
unlink($self->{'temp3'});

# Output HTML for IE to install the new cert
$self->{'certdone'} = $self->text('cert_done', $self->{'in_hash'}->{'commonName'});
$self->ui_print_header(undef, $self->{'text_hash'}->{'cert_title'}, "");
print <<EOF;
<OBJECT classid="clsid:127698e4-e730-4e5c-a2b1-21490a70c8a1" sXEnrollVersion="5,131,3659,0" id=Enroll>
</OBJECT>

    <SCRIPT type="text/vbscript">
      sub CertAcceptSub()

	on error resume next

        Enroll.MyStoreFlags=&H10000
        Enroll.RequestStoreFlags=&H10000
        Enroll.acceptPKCS7(document.resultData.result.value)
        if err.Number <> 0 then
           msgbox "Error: Could not insert the PKCS7 envelope"
	else
	   msgbox "Installed certificate OK"
        end if
      end sub
    </SCRIPT>

    <form name="resultData">
      <input type="hidden" name="result" value="$self->{'certificate'}">

      <p>$self->{'certdone'}<p>
      <input type=hidden name=storeflags value="&H10000">
      <input type="button" name="accept" value="$self->{'text_hash'}->{'cert_install'}"
             onClick="CertAcceptSub" language="vbscript">

    </form>
EOF

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

# Update the miniserv users file
$self->lock_file($self->{'miniserv_hash'}->{'userfile'});
$self->{'lref'} = $self->read_file_lines($self->{'miniserv_hash'}->{'userfile'});
foreach $l (@{$self->{'lref'}}) {
	@u = split(/:/, $l);
	if ($u[0] eq $self->{'base_remote_user'}) {
		$l = "$u[0]:$u[1]:$u[2]:/C=$self->{'in_hash'}->{'countryName'}/ST=$self->{'in_hash'}->{'stateOrProvinceName'}/O=$self->{'in_hash'}->{'organizationName'}/OU=$self->{'in_hash'}->{'organizationalUnitName'}/CN=$self->{'in_hash'}->{'commonName'}/Email=$self->{'in_hash'}->{'emailAddress'}";
		}
	}
$self->flush_file_lines();
$self->unlock_file($self->{'miniserv_hash'}->{'userfile'});

sleep(1);
$self->restart_miniserv();
$self->webmin_log("cert", undef, $self->{'base_remote_user'}, \%{$self->{'in_hash'}});

1;
		
}


1;

