#!/usr/bin/perl

&MAIN();

 sub MAIN {
# convert.cgi
# Convert unix to webmin users

&ModuleLoader::preload_module('acl_class', "acl::AclLib");
$self = new acl::AclLib:: 'acl_class',%$self;

$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'convert_err'});
$self->{'access_hash'}->{'sync'} && $self->{'access_hash'}->{'create'} || $self->error($self->{'text_hash'}->{'convert_ecannot'});
$self->foreign_require("useradmin", "user-lib.pl");

# Validate inputs
if ($self->{'access_hash'}->{'gassign'} ne '*') {
	@{$self->{'gcan_array'}} = split(/\s+/, $self->{'access_hash'}->{'gassign'});
	$self->indexof($self->{'in_hash'}->{'wgroup'}, @{$self->{'gcan_array'}}) >= 0 ||
		$self->error($self->{'text_hash'}->{'convert_ewgroup2'});
	}
if ($self->{'in_hash'}->{'conv'} == 1) {
	$self->{'in_hash'}->{'users'} =~ /\S/ || $self->error($self->{'text_hash'}->{'convert_eusers'});
	map { $self->{'users_hash'}->{$_}++ } split(/\s+/, $self->{'in_hash'}->{'users'});
	}
elsif ($self->{'in_hash'}->{'conv'} == 2) {
	map { $self->{'nusers_hash'}->{$_}++ } split(/\s+/, $self->{'in_hash'}->{'nusers'});
	}
elsif ($self->{'in_hash'}->{'conv'} == 3) {
	$self->{'gid'} = getgrnam($self->{'in_hash'}->{'group'});
	defined($self->{'gid'}) || $self->error($self->{'text_hash'}->{'convert_egroup'});
	}
elsif ($self->{'in_hash'}->{'conv'} == 4) {
	$self->{'in_hash'}->{'min'} =~ /^\d+$/ || $self->error($self->{'text_hash'}->{'convert_emin'});
	$self->{'in_hash'}->{'max'} =~ /^\d+$/ || $self->error($self->{'text_hash'}->{'convert_emax'});
	}

# Get the group to add to
foreach $g ($self->list_groups()) {
	$self->{'group'} = $g if ($g->{'name'} eq $self->{'in_hash'}->{'wgroup'});
	$self->{'exists_hash'}->{$g->{'name'}}++;
	}
$self->{'group'} || $self->error($self->{'text_hash'}->{'convert_ewgroup'});

if ($self->{'in_hash'}->{'conv'} == 3) {
	# Find secondary members of group
	@{$self->{'ginfo_array'}} = getgrnam($self->{'in_hash'}->{'group'});
	@{$self->{'members_array'}} = split(/,/, $self->{'ginfo_array'}->[3]);
	}

# Convert matching users
$self->ui_print_header(undef, $self->{'text_hash'}->{'convert_title'}, "");
print $self->ui_subheading($self->{'text_hash'}->{'convert_msg'});
print "<table border width=100%><tr><td bgcolor=#c0c0c0><pre>\n";
map { $self->{'exists_hash'}->{$_->{'name'}}++ } $self->list_users();
foreach $u ($self->foreign_call("useradmin", "list_users")) {
	local $ok;
	if ($self->{'in_hash'}->{'conv'} == 0) {
		$ok = 1;
		}
	elsif ($self->{'in_hash'}->{'conv'} == 1) {
		$ok = $self->{'users_hash'}->{$u->{'user'}};
		}
	elsif ($self->{'in_hash'}->{'conv'} == 2) {
		$ok = !$self->{'nusers_hash'}->{$u->{'user'}};
		}
	elsif ($self->{'in_hash'}->{'conv'} == 3) {
		$ok = $u->{'gid'} == $self->{'gid'} ||
		      $self->indexof($u->{'user'}, @{$self->{'members_array'}}) >= 0;
		}
	elsif ($self->{'in_hash'}->{'conv'} == 4) {
		$ok = $u->{'uid'} >= $self->{'in_hash'}->{'min'} &&
		      $u->{'uid'} <= $self->{'in_hash'}->{'max'};
		}
	if (!$ok) {
		print $self->text('convert_skip', $u->{'user'}),"\n";
		}
	elsif ($self->{'exists_hash'}->{$u->{'user'}}) {
		print "<i>",$self->text('convert_exists', $u->{'user'}),"</i>\n";
		}
	elsif ($u->{'user'} !~ /^[A-z0-9\-\_\.]+$/) {
		print "<i>",$self->text('convert_invalid', $u->{'user'}),"</i>\n";
		}
	else {
		# Actually add the user
		print "<b>",$self->text('convert_added', $u->{'user'}),"</b>\n";
		local $user = { 'name' => $u->{'user'},
				'pass' => $self->{'in_hash'}->{'sync'} ? 'x' : $u->{'pass'},
				'modules' => $self->{'group'}->{'modules'} };
		$self->create_user($user);
		foreach $m (@{$self->{'group'}->{'modules'}}, "") {
			local %groupacl;
			if ($self->read_file("$self->{'config_directory'}/$m/$self->{'in_hash'}->{'wgroup'}.gacl",
				       \%groupacl)) {
				$self->write_file(
					"$self->{'config_directory'}/$m/$u->{'user'}.acl",
					\%groupacl);
				}
			}

		push(@{$self->{'group'}->{'members'}}, $u->{'user'});
		$self->{'exists_hash'}->{$u->{'user'}}++;
		}
	}
endpwent() if ($self->{'gconfig_hash'}->{'os_type'} ne 'hpux');

# Finish off
$self->modify_group($self->{'group'}->{'name'}, $self->{'group'});
$self->restart_miniserv();

print "</pre></td></tr></table><br>\n";
$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

