#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Delete a bunch of Webmin groups

&ModuleLoader::preload_module('acl_class', "acl::AclLib");
$self = new acl::AclLib:: 'acl_class',%$self;

$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'gdeletes_err'});
$self->{'access_hash'}->{'groups'} || $self->error($self->{'text_hash'}->{'gdelete_ecannot'});

# Validate inputs
@{$self->{'d_array'}} = split(/\0/, $self->{'in_hash'}->{'d'});
@{$self->{'d_array'}} || $self->error($self->{'text_hash'}->{'udeletes_enone'});
@{$self->{'glist_array'}} = $self->list_groups();
$self->{'ucount'} = 0;
foreach $g (@{$self->{'d_array'}}) {
	($self->{'group'}) = grep { $_->{'name'} eq $g } @{$self->{'glist_array'}};
	foreach $m (@{$self->{'group'}->{'members'}}) {
		$self->error($self->{'text_hash'}->{'gdelete_esub'}) if ($m =~ /^\@/);
		$self->error($self->{'text_hash'}->{'gdelete_euser'}) if ($m eq $self->{'base_remote_user'});
		$self->{'ucount'}++;
		}
	}

if ($self->{'in_hash'}->{'confirm'}) {
	# Do it
	foreach $g (@{$self->{'d_array'}}) {
		($self->{'group'}) = grep { $_->{'name'} eq $g } @{$self->{'glist_array'}};
		$self->delete_group($g);
		foreach $m (@{$self->{'group'}->{'members'}}) {
			if ($self->{'u'} =~ /^\@(.*)/) {
				$self->delete_group("$1");
				}
			else {
				$self->delete_user($self->{'u'});
				}
			}
		$self->delete_from_groups("\@".$g);
		}

	$self->reload_miniserv();
	$self->webmin_log("delete", "groups", scalar(@{$self->{'d_array'}}));
	$self->redirect("");
	}
else {
	# Ask the user if he is sure
	$self->ui_print_header(undef, $self->{'text_hash'}->{'gdeletes_title'}, "");

	print "<center>\n";
	print $self->ui_form_start("delete_groups.cgi", "post");
	foreach $g (@{$self->{'d_array'}}) {
		print $self->ui_hidden("d", $g),"\n";
		}
	print $self->text('gdeletes_rusure', scalar(@{$self->{'d_array'}}), $self->{'ucount'}),"<p>\n";

	print $self->ui_form_end([ [ "confirm", $self->{'text_hash'}->{'gdeletes_ok'} ] ]);

	print $self->text('gdeletes_users', join(" ", map { "<tt>$_</tt>" } @{$self->{'d_array'}})),
	      "<p>\n";
	print "</center>\n";

	$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
	}

1;
		
}


1;

