#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_acl.cgi
# Display a form for editing the access control options for some module

&ModuleLoader::preload_module('acl_class', "acl::AclLib");
$self = new acl::AclLib:: 'acl_class',%$self;

$self->ReadParse();
$self->{'access_hash'}->{'acl'} || $self->error($self->{'text_hash'}->{'acl_emod'});
if ($self->{'in_hash'}->{'group'}) {
	$self->{'access_hash'}->{'groups'} || $self->error($self->{'text_hash'}->{'acl_egroup'});
	$self->{'who'} = $self->{'in_hash'}->{'group'};
	}
else {
	foreach $u ($self->list_users()) {
		$self->{'me'} = $u if ($u->{'name'} eq $self->{'base_remote_user'});
		}
	@{$self->{'mcan_array'}} = $self->{'access_hash'}->{'mode'} == 1 ? @{$self->{'me'}->{'modules'}} :
		$self->{'access_hash'}->{'mode'} == 2 ? split(/\s+/, $self->{'access_hash'}->{'mods'}) :
				       ( $self->list_modules() , "" );
	$self->indexof($self->{'in_hash'}->{'mod'}, @{$self->{'mcan_array'}}) >= 0 || $self->error($self->{'text_hash'}->{'acl_emod'});
	$self->can_edit_user($self->{'in_hash'}->{'user'}) || $self->error($self->{'text_hash'}->{'acl_euser'});
	$self->{'who'} = $self->{'in_hash'}->{'user'};
	}

%{$self->{'minfo_hash'}} = $self->{'in_hash'}->{'mod'} ? $self->get_module_info($self->{'in_hash'}->{'mod'})
		    : ( 'desc' => $self->{'text_hash'}->{'index_global'} );
$self->{'below'} = $self->text($self->{'in_hash'}->{'group'} ? 'acl_title3' : 'acl_title2', "<tt>$self->{'who'}</tt>",
	       "<tt>$self->{'minfo_hash'}->{'desc'}</tt>");
$self->ui_print_header($self->{'below'}, $self->{'text_hash'}->{'acl_title'}, "",
		 -r $self->help_file($self->{'in_hash'}->{'mod'}, "acl_info") ?
			[ "acl_info", $self->{'in_hash'}->{'mod'} ] : undef);
%{$self->{'access_hash'}} = $self->{'in_hash'}->{'group'} ? $self->get_group_module_acl($self->{'who'}, $self->{'in_hash'}->{'mod'})
		       : $self->get_module_acl($self->{'who'}, $self->{'in_hash'}->{'mod'}, 1);

# display the form
print $self->ui_form_start("save_acl.cgi", "post");
print $self->ui_hidden("_acl_mod", $self->{'in_hash'}->{'mod'}),"\n";
if ($self->{'in_hash'}->{'group'}) {
	print $self->ui_hidden("_acl_group", $self->{'who'}),"\n";
	}
else {
	print $self->ui_hidden("_acl_user", $self->{'who'}),"\n";
	}
print $self->ui_table_start($self->text('acl_options', $self->{'minfo_hash'}->{'desc'}), "width=100%", 4);

if ($self->{'in_hash'}->{'mod'} && $self->{'in_hash'}->{'user'} && $self->supports_rbac($self->{'in_hash'}->{'mod'}) &&
    !$self->{'gconfig_hash'}->{'rbacdeny_'.$self->{'who'}}) {
	# Show RBAC option
	print $self->ui_table_row($self->{'text_hash'}->{'acl_rbac'},
		$self->ui_radio("rbac", $self->{'access_hash'}->{'rbac'} ? 1 : 0,
			[ [ 1, $self->{'text_hash'}->{'acl_rbacyes'} ],
			  [ 0, $self->{'text_hash'}->{'no'} ] ]), 3);
	}

if ($self->{'in_hash'}->{'mod'}) {
	# Show module config editing option
	print $self->ui_table_row($self->{'text_hash'}->{'acl_config'},
		$self->ui_radio("noconfig", $self->{'access_hash'}->{'noconfig'} ? 1 : 0,
			[ [ 0, $self->{'text_hash'}->{'yes'} ], [ 1, $self->{'text_hash'}->{'no'} ] ]), 3);
	}

$self->{'mdir'} = $self->module_root_directory($self->{'in_hash'}->{'mod'});
if (-r "$self->{'mdir'}/acl_security.pl") {
	print $self->ui_table_hr() if ($self->{'in_hash'}->{'mod'});
	$self->foreign_require($self->{'in_hash'}->{'mod'}, "acl_security.pl");
	$main::postfix_object->{'ui_table_cols'} = $self->{'ui_table_cols'};
	$main::postfix_object->{'ui_table_pos'} = $self->{'ui_table_pos'};
	$self->foreign_call($self->{'in_hash'}->{'mod'}, "acl_security_form", \%{$self->{'access_hash'}});
	}

print $self->ui_table_end();

print "<table width=100%><tr>\n";
print "<td>",$self->ui_submit($self->{'text_hash'}->{'save'}),"</td>\n";
print "<td align=right>",$self->ui_submit($self->{'text_hash'}->{'acl_reset'}, "reset"),"</td>\n";
print "</table>\n";
print $self->ui_form_end();
$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

