#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_group.cgi
# Edit or create a webmin group

&ModuleLoader::preload_module('acl_class', "acl::AclLib");
$self = new acl::AclLib:: 'acl_class',%$self;

$self->ReadParse();
$self->{'access_hash'}->{'groups'} || $self->error($self->{'text_hash'}->{'gedit_ecannot'});
if ($self->{'in_hash'}->{'group'}) {
	# Editing an existing group
	$self->ui_print_header(undef, $self->{'text_hash'}->{'gedit_title'}, "");
	foreach $g ($self->list_groups()) {
		if ($g->{'name'} eq $self->{'in_hash'}->{'group'}) {
			%{$self->{'group_hash'}} = %$g;
			}
		}
	}
else {
	# Creating a new group
	$self->ui_print_header(undef, $self->{'text_hash'}->{'gedit_title2'}, "");
	foreach $g ($self->list_groups()) {
		if ($g->{'name'} eq $self->{'in_hash'}->{'clone'}) {
			$self->{'group_hash'}->{'modules'} = $g->{'modules'};
			}
		}
	}

print "<form action=save_group.cgi method=post>\n";
print "<input type=hidden name=old value=\"$self->{'in_hash'}->{'group'}\">\n";
if ($self->{'in_hash'}->{'clone'}) {
	print "<input type=hidden name=clone value=\"$self->{'in_hash'}->{'clone'}\">\n";
	}
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'gedit_rights'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

# Show the group name
print "<tr> <td><b>$self->{'text_hash'}->{'gedit_group'}</b></td>\n";
print "<td><input name=name size=25 value=\"$self->{'group_hash'}->{'name'}\"></td>\n";

# Find and show the parent group
@{$self->{'glist_array'}} = grep { $_->{'name'} ne $self->{'group_hash'}->{'name'} } $self->list_groups();
@{$self->{'mcan_array'}} = $self->{'access_hash'}->{'gassign'} eq '*' ?
		( ( map { $_->{'name'} } @{$self->{'glist_array'}} ), '_none' ) :
		split(/\s+/, $self->{'access_hash'}->{'gassign'});
map { $self->{'gcan_hash'}->{$_}++ } @{$self->{'mcan_array'}};
if (@{$self->{'glist_array'}} && %{$self->{'gcan_hash'}}) {
	print "<td><b>$self->{'text_hash'}->{'edit_group'}</b></td>\n";
	print "<td><select name=group>\n";
	foreach $g (@{$self->{'glist_array'}}) {
		local $mem = $self->indexof('@'.$self->{'group_hash'}->{'name'},
				      @{$g->{'members'}}) >= 0;
		next if (!$self->{'gcan_hash'}->{$g->{'name'}} && !$mem);
		printf "<option %s>%s\n",
			$mem ?  'selected' : '', $g->{'name'};
		$self->{'group'} = $g if ($mem);
		}
	printf "<option value='' %s>&lt;%s&gt;\n",
		$self->{'group'} ? '' : 'selected', $self->{'text_hash'}->{'edit_none'}
			if ($self->{'gcan_hash'}->{'_none'});
	print "</select></td>\n";
	}
print "</tr>\n";

if ($self->{'in_hash'}->{'group'}) {
	# Show all current members
	print "<tr> <td valign=top><b>$self->{'text_hash'}->{'gedit_members'}</b></td>\n";
	print "<td colspan=3><table width=100%>\n";
	$self->{'i'} = 0;
	foreach $m (@{$self->{'group_hash'}->{'members'}}) {
		print "<tr>\n" if ($self->{'i'}%4 == 0);
		print "<td width=25%>",($m =~ /^\@(.*)$/ ? "<i>$1</i>" : $m),
		      "</td>\n";
		print "<tr>\n" if ($self->{'i'}%4 == 3);
		$self->{'i'}++;
		}
	print "</table></td> </tr>\n";
	}

@{$self->{'mlist_array'}} = $self->list_module_infos();
map { $self->{'has_hash'}->{$_}++ } @{$self->{'group_hash'}->{'modules'}};
print "<tr> <td valign=top><b>$self->{'text_hash'}->{'gedit_modules'}</b></td>\n";
print "<td colspan=3>\n";
print $self->select_all_link("mod", 0, $self->{'text_hash'}->{'edit_selall'}),"&nbsp;\n";
print $self->select_invert_link("mod", 0, $self->{'text_hash'}->{'edit_invert'}),"<br>\n";
@{$self->{'cats_array'}} = $self->unique(map { $_->{'category'} } @{$self->{'mlist_array'}});
$self->read_file("$self->{'config_directory'}/cpplus.catnames", \%{$self->{'catnames_hash'}});
print "<table width=100% cellpadding=0 cellspacing=0>\n";
foreach $c (sort { $b cmp $a } @{$self->{'cats_array'}}) {
	@{$self->{'cmlist_array'}} = grep { $_->{'category'} eq $c } @{$self->{'mlist_array'}};
	print "<tr> <td colspan=2 $self->{'tb'}><b>",
		$self->{'catnames_hash'}->{$c} || $self->{'text_hash'}->{'category_'.$c},
		"</b></td> </tr>\n";
	$self->{'sw'} = 0;
	foreach $m (@{$self->{'cmlist_array'}}) {
		local $md = $m->{'dir'};
		if (!$self->{'sw'}) { print "<tr>\n"; }
		print "<td width=50%>";
		printf"<input type=checkbox name=mod value=$md %s>\n",
		      $self->{'has_hash'}->{$md} ? "checked" : "";
		if ($self->{'access_hash'}->{'acl'} && $self->{'in_hash'}->{'group'}) {
			# Show link for editing ACL
			printf "<a href='edit_acl.cgi?mod=%s&%s=%s'>".
			       "%s</a>\n",
				$self->urlize($m->{'dir'}),
				"group", $self->urlize($self->{'in_hash'}->{'group'}),
				$m->{'desc'};
			}
		else {
			print "$m->{'desc'}\n";
			}
		print "</td>";
		if ($self->{'sw'}) { print "<tr>\n"; }
		$self->{'sw'} = !$self->{'sw'};
		}
	}
print "</table>\n";
print $self->select_all_link("mod", 0, $self->{'text_hash'}->{'edit_selall'}),"&nbsp;\n";
print $self->select_invert_link("mod", 0, $self->{'text_hash'}->{'edit_invert'}),"\n";
print "</td> </tr>\n";
print "</table></td> </tr></table>\n";

print "<table width=100%> <tr>\n";
print "<td><input type=submit value='$self->{'text_hash'}->{'save'}'></td></form>\n";
if ($self->{'in_hash'}->{'group'}) {
	print "<form action=hide_form.cgi>\n";
	print "<input type=hidden name=group value=\"$self->{'in_hash'}->{'group'}\">\n";
	print "<td align=center>",
	      "<input type=submit value=\"$self->{'text_hash'}->{'edit_hide'}\"></td></form>\n";

	print "<form action=edit_group.cgi>\n";
	print "<input type=hidden name=clone value=\"$self->{'in_hash'}->{'group'}\">\n";
	print "<td align=center>",
	      "<input type=submit value=\"$self->{'text_hash'}->{'edit_clone'}\">",
	      "</td></form>\n";

	print "<form action=delete_group.cgi>\n";
	print "<input type=hidden name=group value=\"$self->{'in_hash'}->{'group'}\">\n";
	print "<td align=right><input type=submit name=delete ",
	      "value='$self->{'text_hash'}->{'delete'}'></td></form>\n";
	}
print "</tr></table>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

