#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_unix.cgi
# Choose a user whose permissions will be used for logins that don't
# match any webmin user, but have unix accounts

&ModuleLoader::preload_module('acl_class', "acl::AclLib");
$self = new acl::AclLib:: 'acl_class',%$self;

$self->{'access_hash'}->{'unix'} && $self->{'access_hash'}->{'create'} && $self->{'access_hash'}->{'delete'} ||
	$self->error($self->{'text_hash'}->{'unix_ecannot'});
$self->ui_print_header(undef, $self->{'text_hash'}->{'unix_title'}, "");

print "$self->{'text_hash'}->{'unix_desc'}<p>\n";
$self->get_miniserv_config(\%{$self->{'miniserv_hash'}});

print "<form action=save_unix.cgi>\n";
print "<table>\n";

# Enable Unix auth
@{$self->{'unixauth_array'}} = $self->get_unixauth(\%{$self->{'miniserv_hash'}});
print "<tr> <td colspan=2>\n";
print $self->ui_radio("unix_def", @{$self->{'unixauth_array'}} ? 0 : 1,
	[ [ 1, $self->{'text_hash'}->{'unix_def'} ], [ 0, $self->{'text_hash'}->{'unix_sel'} ] ]),"<br>\n";
print $self->ui_columns_start([ $self->{'text_hash'}->{'unix_mode'}, $self->{'text_hash'}->{'unix_who'},
			  $self->{'text_hash'}->{'unix_to'} ]);
$self->{'i'} = 0;
@{$self->{'webmins_array'}} = map { [ $_->{'name'} ] }
	       sort { $a->{'name'} cmp $b->{'name'} } $self->list_users();
foreach $ua (@{$self->{'unixauth_array'}}, [ ], [ ]) {
	print $self->ui_columns_row([
		$self->ui_select("mode_$self->{'i'}", $ua->[0] eq "" ? 0 :
				      $ua->[0] eq "*" ? 1 :
				      $ua->[0] =~ /^\@/ ? 2 : 3,
			   [ [ 0, " " ],
			     [ 1, $self->{'text_hash'}->{'unix_mall'} ],
			     [ 2, $self->{'text_hash'}->{'unix_group'} ],
			     [ 3, $self->{'text_hash'}->{'unix_user'} ] ]),
		$self->ui_textbox("who_$self->{'i'}", $ua->[0] eq "*" || $ua->[0] eq "" ? "" :
			      $ua->[0] =~ /^\@(.*)$/ ? $1 : $ua->[0], 20),
		$self->ui_select("to_$self->{'i'}", $ua->[1], \@{$self->{'webmins_array'}}),
		]);
	$self->{'i'}++;
	}
print $self->ui_columns_end(),"\n";

# Allow users who can sudo to root?
print $self->ui_checkbox("sudo", 1, $self->{'text_hash'}->{'unix_sudo'},
		   $self->{'miniserv_hash'}->{'sudo'}),"<br>\n";

# Allow PAM-only users?
print $self->ui_checkbox("pamany", 1, $self->text('unix_pamany',
				      $self->ui_select("pamany_user",
						 $self->{'miniserv_hash'}->{'pamany'}, 
						 \@{$self->{'webmins_array'}})),
		   $self->{'miniserv_hash'}->{'pamany'}),"<br>\n";
print "</td> </tr>\n";

print "<tr> <td colspan=2><hr></td> </tr>\n";
print "<tr> <td colspan=2>$self->{'text_hash'}->{'unix_restrict'}<p></td> </tr>\n";

# Who can do Unix auth?
print "<tr> <td valign=top>\n";
printf "<input type=radio name=access value=0 %s>\n",
	$self->{'miniserv_hash'}->{"allowusers"} || $self->{'miniserv_hash'}->{"denyusers"} ? "" : "checked";
print "$self->{'text_hash'}->{'unix_all'}<br>\n";
printf "<input type=radio name=access value=1 %s>\n",
	$self->{'miniserv_hash'}->{"allowusers"} ? "checked" : "";
print "$self->{'text_hash'}->{'unix_allow'}<br>\n";
printf "<input type=radio name=access value=2 %s>\n",
	$self->{'miniserv_hash'}->{"denyusers"} ? "checked" : "";
print "$self->{'text_hash'}->{'unix_deny'}<br>\n";
print "</td> <td valign=top>\n";
printf "<textarea name=users rows=6 cols=30>%s</textarea></td> </tr>\n",
 $self->{'miniserv_hash'}->{"allowusers"} ? join("\n", split(/\s+/, $self->{'miniserv_hash'}->{"allowusers"})) :
 $self->{'miniserv_hash'}->{"denyusers"} ? join("\n", split(/\s+/, $self->{'miniserv_hash'}->{"denyusers"})) : "";

# Block login by shell?
print "<tr> <td colspan=2>\n";
printf "<input type=checkbox name=shells_deny value=1 %s> %s\n",
	$self->{'miniserv_hash'}->{'shells_deny'} ? "checked" : "",$self->{'text_hash'}->{'unix_shells'};
printf "<input name=shells size=25 value='%s'> %s</td> </tr>\n",
	$self->{'miniserv_hash'}->{'shells_deny'} || "/etc/shells",
	$self->file_chooser_button("shells");

print "</table>\n";
print "<input type=submit value='$self->{'text_hash'}->{'save'}'></form>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

