#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_user.cgi
# Edit a new or existing webmin user

&ModuleLoader::preload_module('acl_class', "acl::AclLib");
$self = new acl::AclLib:: 'acl_class',%$self;

$self->foreign_require("cpplus", "cpplus-lib.pl");

$self->ReadParse();
if ($self->{'in_hash'}->{'user'}) {
	# Editing an existing user
	$self->can_edit_user($self->{'in_hash'}->{'user'}) || $self->error($self->{'text_hash'}->{'edit_euser'});
	$self->ui_print_header(undef, $self->{'text_hash'}->{'edit_title'}, "");
	foreach $u ($self->list_users()) {
		if ($u->{'name'} eq $self->{'in_hash'}->{'user'}) {
			%{$self->{'user_hash'}} = %$u;
			}
		if ($u->{'name'} eq $self->{'base_remote_user'}) {
			$self->{'me'} = $u;
			}
		}
	}
else {
	# Creating a new user
	$self->{'access_hash'}->{'create'} || $self->error($self->{'text_hash'}->{'edit_ecreate'});
	$self->ui_print_header(undef, $self->{'text_hash'}->{'edit_title2'}, "");
	foreach $u ($self->list_users()) {
		if ($u->{'name'} eq $self->{'in_hash'}->{'clone'}) {
			$self->{'user_hash'}->{'modules'} = $u->{'modules'};
			$self->{'user_hash'}->{'lang'} = $u->{'lang'};
			}
		if ($u->{'name'} eq $self->{'base_remote_user'}) {
			$self->{'me'} = $u;
			}
		}
	$self->{'user_hash'}->{'skill'} = $self->{'user_hash'}->{'risk'} = 'high' if ($self->{'in_hash'}->{'risk'});
	}

# Give up if readonly
if ($self->{'user_hash'}->{'readonly'} && !$self->{'in_hash'}->{'readwrite'}) {
	%{$self->{'minfo_hash'}} = $self->get_module_info($self->{'user_hash'}->{'readonly'});
	print $self->text('edit_readonly', $self->{'minfo_hash'}->{'desc'},
		    "edit_user.cgi?user=$self->{'in_hash'}->{'user'}&readwrite=1"),"<p>\n";
	$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
	exit;
	}

print "<form action=save_user.cgi method=post>\n";
if ($self->{'in_hash'}->{'user'}) {
	print "<input type=hidden name=old value=\"$self->{'user_hash'}->{'name'}\">\n";
	print "<input type=hidden name=oldpass value=\"$self->{'user_hash'}->{'pass'}\">\n";
	}
if ($self->{'in_hash'}->{'clone'}) {
	print "<input type=hidden name=clone value=\"$self->{'in_hash'}->{'clone'}\">\n";
	}
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'edit_rights'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'edit_user'}</b></td>\n";
if ($self->{'access_hash'}->{'rename'} || !$self->{'in_hash'}->{'user'}) {
	print "<td><input name=name size=25 ",
	      "value=\"$self->{'user_hash'}->{'name'}\"></td>\n";
	}
else {
	print "<td>$self->{'user_hash'}->{'name'}</td>\n";
	}

# Find and show parent group
@{$self->{'glist_array'}} = $self->list_groups();
@{$self->{'mcan_array'}} = $self->{'access_hash'}->{'gassign'} eq '*' ?
		( ( map { $_->{'name'} } @{$self->{'glist_array'}} ), '_none' ) :
		split(/\s+/, $self->{'access_hash'}->{'gassign'});
map { $self->{'gcan_hash'}->{$_}++ } @{$self->{'mcan_array'}};
if (@{$self->{'glist_array'}} && %{$self->{'gcan_hash'}} && !$self->{'in_hash'}->{'risk'} && !$self->{'user_hash'}->{'risk'}) {
	print "<td><b>$self->{'text_hash'}->{'edit_group'}</b></td>\n";
	print "<td><select name=group>\n";
	foreach $g (@{$self->{'glist_array'}}) {
		local $mem = $self->indexof($self->{'user_hash'}->{'name'}, @{$g->{'members'}}) >= 0;
		next if (!$self->{'gcan_hash'}->{$g->{'name'}} && !$mem);
		printf "<option %s>%s\n",
			$mem ?  'selected' : '', $g->{'name'};
		$self->{'group'} = $g if ($mem);
		}
	printf "<option value='' %s>&lt;%s&gt;\n",
		$self->{'group'} ? '' : 'selected', $self->{'text_hash'}->{'edit_none'}
			if ($self->{'gcan_hash'}->{'_none'});
	print "</select></td>\n";
	}
print "</tr>\n";

# Show password type menu and current password
$self->{'passmode'} = !$self->{'in_hash'}->{'user'} ? 0 :
	    $self->{'user_hash'}->{'pass'} eq 'x' ? 3 :
	    $self->{'user_hash'}->{'sync'} ? 2 :
	    $self->{'user_hash'}->{'pass'} eq 'e' ? 5 :
	    $self->{'user_hash'}->{'pass'} eq '*LK*' ? 4 : 1;
print "<tr> <td><b>$self->{'text_hash'}->{'edit_pass'}</b></td> <td colspan=3>\n";
print "<select name=pass_def>\n";
printf "<option value=0 %s> $self->{'text_hash'}->{'edit_set'} ..\n",
	$self->{'passmode'} == 0 ? "selected" : "";
if ($self->{'in_hash'}->{'user'}) {
	printf "<option value=1 %s> %s\n",
		$self->{'passmode'} == 1 ? "selected" : "", $self->{'text_hash'}->{'edit_dont'};
	}
printf "<option value=3 %s> $self->{'text_hash'}->{'edit_unix'}\n",
	$self->{'passmode'} == 3 ? "selected" : "";
if ($self->{'user_hash'}->{'sync'}) {
	printf "<option value=2 %s> $self->{'text_hash'}->{'edit_same'}\n",
		$self->{'passmode'} == 2 ? "selected" : "";
	}
$self->get_miniserv_config(\%{$self->{'miniserv_hash'}});
if ($self->{'miniserv_hash'}->{'extauth'}) {
	printf "<option value=5 %s> $self->{'text_hash'}->{'edit_extauth'}\n",
		$self->{'passmode'} == 5 ? "selected" : "";
	}
printf "<option value=4 %s> $self->{'text_hash'}->{'edit_lock'}\n",
	$self->{'passmode'} == 4 ? "selected" : "";
print "</select><input type=password name=pass size=25>\n";
if ($self->{'passmode'} == 1) {
	# Show temporary lock option
	print $self->ui_checkbox("lock", 1, $self->{'text_hash'}->{'edit_templock'},
			   $self->{'user_hash'}->{'pass'} =~ /^\!/ ? 1 : 0);
	}
print "</td> </tr>\n";

if ($self->{'access_hash'}->{'chcert'}) {
	# SSL certificate name
	print "<tr> <td><b>$self->{'text_hash'}->{'edit_cert'}</b></td> <td colspan=3>\n";
	print $self->ui_opt_textbox("cert", $self->{'user_hash'}->{'cert'}, 50, $self->{'text_hash'}->{'edit_none'}),
	      "</td></tr>\n";
	}

if ($self->{'access_hash'}->{'lang'}) {
	# Current language
	print "<tr> <td><b>$self->{'text_hash'}->{'edit_lang'}</b></td> <td colspan=3>\n";
	printf "<input type=radio name=lang_def value=1 %s> %s\n",
		$self->{'user_hash'}->{'lang'} ? '' : 'checked', $self->{'text_hash'}->{'default'};
	printf "<input type=radio name=lang_def value=0 %s>\n",
		$self->{'user_hash'}->{'lang'} ? 'checked' : '';
	print "<select name=lang>\n";
	foreach $l ($self->list_languages()) {
		printf "<option value=%s %s>%s (%s)\n",
			$l->{'lang'},
			$self->{'user_hash'}->{'lang'} eq $l->{'lang'} ? 'selected' : '',
			$l->{'desc'}, uc($l->{'lang'});
		}
	print "</select></td> </tr>\n";
	}

if ($self->{'access_hash'}->{'logouttime'}) {
	# Show logout time
	print "<tr> <td><b>$self->{'text_hash'}->{'edit_logout'}</b></td> <td colspan=2>\n";
	print $self->ui_opt_textbox("logouttime", $self->{'user_hash'}->{'logouttime'}, 5,
		      $self->{'text_hash'}->{'default'})," $self->{'text_hash'}->{'edit_mins'}</td> </tr>\n";
	}

if ($self->{'access_hash'}->{'ips'}) {
	# Allowed IP addresses
	print "<tr> <td>",$self->hlink("<b>$self->{'text_hash'}->{'edit_ips'}</b>", "ips"),"</td>\n";
	print "<td colspan=3><table><tr>\n";
	printf "<td nowrap><input name=ipmode type=radio value=0 %s> %s<br>\n",
		$self->{'user_hash'}->{'allow'} || $self->{'user_hash'}->{'deny'} ? '' : 'checked',
		$self->{'text_hash'}->{'edit_all'};
	printf "<input name=ipmode type=radio value=1 %s> %s<br>\n",
		$self->{'user_hash'}->{'allow'} ? 'checked' : '', $self->{'text_hash'}->{'edit_allow'};
	printf "<input name=ipmode type=radio value=2 %s> %s</td> <td>\n",
		$self->{'user_hash'}->{'deny'} ? 'checked' : '', $self->{'text_hash'}->{'edit_deny'};
	print "<textarea name=ips rows=4 cols=30>",
	      join("\n", split(/\s+/, $self->{'user_hash'}->{'allow'} ? $self->{'user_hash'}->{'allow'}
						     : $self->{'user_hash'}->{'deny'})),
	      "</textarea></td>\n";
	print "</td></tr></table> </tr>\n";
	}

if ($self->supports_rbac() && $self->{'access_hash'}->{'mode'} == 0) {
	# Deny access to modules not managed by RBAC?
	print "<tr> <td><b>$self->{'text_hash'}->{'edit_rbacdeny'}</b></td> <td colspan=3>\n";
	print $self->ui_radio("rbacdeny", $self->{'user_hash'}->{'rbacdeny'} ? 1 : 0,
			[ [ 0, $self->{'text_hash'}->{'edit_rbacdeny0'} ],
			  [ 1, $self->{'text_hash'}->{'edit_rbacdeny1'} ] ]); 
	print "</td> </tr>\n";
	}

if ($self->{'access_hash'}->{'times'}) {
	# Show allowed days of the week
	%{$self->{'days_hash'}} = map { $_, 1 } split(/,/, $self->{'user_hash'}->{'days'});
	print "<tr> <td valign=top><b>$self->{'text_hash'}->{'edit_days'}</b></td>\n";
	print "<td colspan=3>\n";
	print $self->ui_radio("days_def", $self->{'user_hash'}->{'days'} eq '' ? 1 : 0,
			[ [ 1, $self->{'text_hash'}->{'edit_alldays'} ],
			  [ 0, $self->{'text_hash'}->{'edit_seldays'} ] ]),"<br>\n";
	for(local $i=0; $i<7; $i++) {
		print $self->ui_checkbox("days", $i, $self->{'text_hash'}->{'day_'.$i}, $self->{'days_hash'}->{$i});
		}
	print "</td> </tr>\n";

	# Show allow hour/minute range
	($self->{'hf'}, $self->{'mf'}) = split(/\./, $self->{'user_hash'}->{'hoursfrom'});
	($self->{'ht'}, $self->{'mt'}) = split(/\./, $self->{'user_hash'}->{'hoursto'});
	print "<tr> <td valign=top><b>$self->{'text_hash'}->{'edit_hours'}</b></td>\n";
	print "<td colspan=3>\n";
	print $self->ui_radio("hours_def", $self->{'user_hash'}->{'hoursfrom'} eq '' ? 1 : 0,
		[ [ 1, $self->{'text_hash'}->{'edit_allhours'} ],
		  [ 0, $self->text('edit_selhours',
			$self->ui_textbox("hours_hfrom", $self->{'hf'}, 2),
			$self->ui_textbox("hours_mfrom", $self->{'mf'}, 2),
			$self->ui_textbox("hours_hto", $self->{'ht'}, 2),
			$self->ui_textbox("hours_mto", $self->{'mt'}, 2)) ] ]);
	print "</td> </tr>\n";
	}

if ($self->{'user_hash'}->{'risk'} || $self->{'in_hash'}->{'risk'}) {
	# Creating or editing a risk-level user
	print "<tr> <td><b>$self->{'text_hash'}->{'edit_risk'}</b></td> <td colspan=3>\n";
	foreach $s ('high', 'medium', 'low') {
		printf "<input type=radio name=risk value='%s' %s> %s\n",
		    $s, $self->{'user_hash'}->{'risk'} eq $s ? 'checked' : '',
		    $self->{'text_hash'}->{"edit_risk_$s"};
		}
	print "</td> </tr>\n";

	print "<tr> <td><b>$self->{'text_hash'}->{'edit_skill'}</b></td> <td colspan=3>\n";
	foreach $s ('high', 'medium', 'low') {
		printf "<input type=radio name=skill value='%s' %s> %s\n",
		    $s, $self->{'user_hash'}->{'skill'} eq $s ? 'checked' : '',
		    $self->{'text_hash'}->{"skill_$s"};
		}
	print "</td> </tr>\n";
	}
else {
	# Creating or editing a normal user
	@{$self->{'mcan_array'}} = $self->{'access_hash'}->{'mode'} == 1 ? @{$self->{'me'}->{'modules'}} :
		$self->{'access_hash'}->{'mode'} == 2 ? split(/\s+/, $self->{'access_hash'}->{'mods'}) :
				       $self->list_modules();
	map { $self->{'mcan_hash'}->{$_}++ } @{$self->{'mcan_array'}};
	map { $self->{'has_hash'}->{$_}++ } @{$self->{'user_hash'}->{'modules'}};
	map { $self->{'has_hash'}->{$_} = 0 } $self->{'group'} ? @{$self->{'group'}->{'modules'}} : ();

	# Show all modules, under categories
	@{$self->{'mlist_array'}} = grep { $self->{'access_hash'}->{'others'} || $self->{'has_hash'}->{$_->{'dir'}} || $self->{'mcan_hash'}->{$_->{'dir'}} } $self->list_module_infos();
	print "<tr> <td valign=top><b>$self->{'text_hash'}->{'edit_modules'}</b><br>",
	      "$self->{'text_hash'}->{'edit_groupmods'}</td>\n";
	print "<td colspan=3>\n";
	print $self->select_all_link("mod", 0, $self->{'text_hash'}->{'edit_selall'}),"&nbsp;\n";
	print $self->select_invert_link("mod", 0, $self->{'text_hash'}->{'edit_invert'}),"<br>\n";
	@{$self->{'cats_array'}} = $self->unique(map { $_->{'category'} } @{$self->{'mlist_array'}});
	$self->read_file("$self->{'config_directory'}/cpplus.catnames", \%{$self->{'catnames_hash'}});
	print "<table width=100% cellpadding=0 cellspacing=0>\n";
	foreach $c (sort { $b cmp $a } @{$self->{'cats_array'}}) {
		@{$self->{'cmlist_array'}} = grep { $_->{'category'} eq $c } @{$self->{'mlist_array'}};
		print "<tr> <td colspan=2 $self->{'tb'}><b>",
			$self->{'catnames_hash'}->{$c} || $self->{'text_hash'}->{'category_'.$c},
			"</b></td> </tr>\n";
		$self->{'sw'} = 0;
		foreach $m (@{$self->{'cmlist_array'}}) {
			local $md = $m->{'dir'};
			if (!$self->{'sw'}) { print "<tr>\n"; }
			print "<td width=50%>";
			if ($self->{'mcan_hash'}->{$md}) {
				printf"<input type=checkbox name=mod value=$md %s>\n",
				      $self->{'has_hash'}->{$md} ? "checked" : "";
				if ($self->{'access_hash'}->{'acl'} && $self->{'in_hash'}->{'user'}) {
					# Show link for editing ACL
					printf "<a href='edit_acl.cgi?mod=%s&%s=%s'>".
					       "%s</a>\n",
						$self->urlize($m->{'dir'}),
						"user", $self->urlize($self->{'in_hash'}->{'user'}),
						$m->{'desc'};
					}
				else {
					print "$m->{'desc'}\n";
					}
				}
			else {
				printf "<img src=images/%s.gif> %s\n",
				    $self->{'has_hash'}->{$md} ? 'tick' : 'empty', $m->{'desc'};
				}
			print "</td>";
			if ($self->{'sw'}) { print "<tr>\n"; }
			$self->{'sw'} = !$self->{'sw'};
			}
		}
	if ($self->{'access_hash'}->{'acl'}) {
		print "<tr> <td colspan=2 $self->{'tb'}><b>",
		      $self->{'text_hash'}->{'edit_special'},"</b></td> </tr>\n";
		print "<tr>\n";
		print "<td><a href='edit_acl.cgi?mod=&user=",$self->urlize($self->{'in_hash'}->{'user'}),
		      "'>",$self->{'text_hash'}->{'index_global'},"</a></td>\n";
		print "</tr>\n";
		}
	print "</table>\n";
	print $self->select_all_link("mod", 0, $self->{'text_hash'}->{'edit_selall'}),"&nbsp;\n";
	print $self->select_invert_link("mod", 0, $self->{'text_hash'}->{'edit_invert'}),"\n";
	print "</td> </tr>\n";
	}
print "</table></td> </tr></table>\n";

print "<table width=100%> <tr>\n";
print "<td align=left width=16%><input type=submit value=\"$self->{'text_hash'}->{'save'}\"></td></form>\n";
if ($self->{'in_hash'}->{'user'}) {
	if (!$self->{'group'}) {
		print "<form action=hide_form.cgi>\n";
		print "<input type=hidden name=user value=\"$self->{'in_hash'}->{'user'}\">\n";
		print "<td align=center width=16%>",
		      "<input type=submit value=\"$self->{'text_hash'}->{'edit_hide'}\"></td></form>\n";
		}
	else { print "<td width=16%></td>\n"; }

	if ($self->{'access_hash'}->{'create'} && !$self->{'group'}) {
		print "<form action=edit_user.cgi>\n";
		print "<input type=hidden name=clone value=\"$self->{'in_hash'}->{'user'}\">\n";
		print "<td align=center width=16%>",
		      "<input type=submit value=\"$self->{'text_hash'}->{'edit_clone'}\">",
		      "</td></form>\n";
		}
	else { print "<td width=16%></td>\n"; }

	$self->read_acl(\%{$self->{'acl_hash'}});
	if ($self->foreign_check("cppluslog") &&
	    $self->{'acl_hash'}->{$self->{'base_remote_user'},'cppluslog'}) {
		print "<form action=/cppluslog/search.cgi>\n";
		print "<input type=hidden name=uall value=0>\n";
		print "<input type=hidden name=user value='$self->{'in_hash'}->{'user'}'>\n";
		print "<input type=hidden name=mall value=1>\n";
		print "<input type=hidden name=tall value=0>\n";
		print "<td align=center width=16%>",
		      "<input type=submit value=\"$self->{'text_hash'}->{'edit_log'}\">",
		      "</td></form>\n";
		}
	else { print "<td width=16%></td>\n"; }

	if ($self->{'access_hash'}->{'switch'} && $self->{'session_id'}) {
		print "<form action=switch.cgi>\n";
		print "<input type=hidden name=user value=\"$self->{'in_hash'}->{'user'}\">\n";
		print "<td align=center width=16%>",
		      "<input type=submit value=\"$self->{'text_hash'}->{'edit_switch'}\">",
		      "</td></form>\n";
		}
	else { print "<td width=16%></td>\n"; }

	if ($self->{'access_hash'}->{'delete'}) {
		print "<form action=delete_user.cgi>\n";
		print "<input type=hidden name=user value=\"$self->{'in_hash'}->{'user'}\">\n";
		print "<td align=right width=16%>",
		      "<input type=submit value=\"$self->{'text_hash'}->{'delete'}\"></td></form>\n";
		}
	else { print "<td width=16%></td>\n"; }
	}
print "</tr> </table>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

