#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_acl.cgi
# Save access control options for some module

&ModuleLoader::preload_module('acl_class', "acl::AclLib");
$self = new acl::AclLib:: 'acl_class',%$self;

$self->ReadParse();
if ($self->{'in_hash'}->{'_acl_group'}) {
	$self->{'access_hash'}->{'groups'} || $self->error($self->{'text_hash'}->{'acl_egroup'});
	$self->{'who'} = $self->{'in_hash'}->{'_acl_group'};
	}
else {
	foreach $u ($self->list_users()) {
		$self->{'me'} = $u if ($u->{'name'} eq $self->{'base_remote_user'});
		}
	@{$self->{'mcan_array'}} = $self->{'access_hash'}->{'mode'} == 1 ? @{$self->{'me'}->{'modules'}} :
		$self->{'access_hash'}->{'mode'} == 2 ? split(/\s+/, $self->{'access_hash'}->{'mods'}) :
				       ( $self->list_modules(), "" );
	$self->indexof($self->{'in_hash'}->{'_acl_mod'}, @{$self->{'mcan_array'}}) >= 0 || $self->error($self->{'text_hash'}->{'acl_emod'});
	$self->can_edit_user($self->{'in_hash'}->{'_acl_user'}) || $self->error($self->{'text_hash'}->{'acl_euser'});
	$self->{'who'} = $self->{'in_hash'}->{'_acl_user'};
	}

$self->{'aclfile'} = $self->{'in_hash'}->{'_acl_group'} ? "$self->{'config_directory'}/$self->{'in_hash'}->{'_acl_mod'}/$self->{'who'}.gacl"
			     : "$self->{'config_directory'}/$self->{'in_hash'}->{'_acl_mod'}/$self->{'who'}.acl";
if ($self->{'in_hash'}->{'reset'}) {
	# Just remove the .acl file
	$self->unlink_logged($self->{'aclfile'});
	$self->{'in_hash'}->{'moddesc'} = $self->{'minfo_hash'}->{'desc'};
	$self->webmin_log("reset", undef, $self->{'who'}, \%{$self->{'in_hash'}});
	}
else {
	# Validate and store ACL settings
	$self->error_setup($self->{'text_hash'}->{'acl_err'});
	$self->{'maccess_hash'}->{'noconfig'} = $self->{'in_hash'}->{'noconfig'};
	if ($self->{'in_hash'}->{'rbac'}) {
		# RBAC overrides everything
		$self->{'maccess_hash'}->{'rbac'} = 1;
		}
	elsif (-r "../$self->{'in_hash'}->{'_acl_mod'}/acl_security.pl") {
		# Use user inputs
		$self->{'maccess_hash'}->{'rbac'} = 0 if (defined($self->{'in_hash'}->{'rbac'}));
		$self->foreign_require($self->{'in_hash'}->{'_acl_mod'}, "acl_security.pl");
		if ($self->{'in_hash'}->{'_acl_mod'}) {
			local $pkg = $self->{'in_hash'}->{'_acl_mod'};
			$pkg =~ s/[^A-Za-z0-9]/_/g;
			eval "\%${pkg}::in = \%{$self->{'in_hash'}}";
			}
		else {
			%global::in = %{$self->{'in_hash'}};
			}
		$self->foreign_call($self->{'in_hash'}->{'_acl_mod'}, "acl_security_save",
			      \%{$self->{'maccess_hash'}}, \%{$self->{'in_hash'}});
		}
	$self->lock_file($self->{'aclfile'});
	$self->write_file($self->{'aclfile'}, \%{$self->{'maccess_hash'}});
	chmod(0640, $self->{'aclfile'});
	$self->unlock_file($self->{'aclfile'});
	%{$self->{'minfo_hash'}} = $self->{'in_hash'}->{'_acl_mod'} ? $self->get_module_info($self->{'in_hash'}->{'_acl_mod'})
				 : ( 'desc' => $self->{'text_hash'}->{'index_global'} );

	if ($self->{'in_hash'}->{'_acl_group'}) {
		# Recursively update the ACL for all member users and groups
		@{$self->{'ulist_array'}} = $self->list_users();
		@{$self->{'glist_array'}} = $self->list_groups();
		($self->{'group'}) = grep { $_->{'name'} eq $self->{'in_hash'}->{'_acl_group'} } @{$self->{'glist_array'}};
		$self->set_acl_files(\@{$self->{'ulist_array'}}, \@{$self->{'glist_array'}}, $self->{'in_hash'}->{'_acl_mod'},
			       $self->{'group'}->{'members'}, \%{$self->{'maccess_hash'}});
		}

	$self->{'in_hash'}->{'moddesc'} = $self->{'minfo_hash'}->{'desc'};
	$self->webmin_log("acl", undef, $self->{'who'}, \%{$self->{'in_hash'}});
	}
if ($self->{'config_hash'}->{'display'}) {
	if ($self->{'in_hash'}->{'_acl_group'}) {
		$self->redirect("edit_group.cgi?group=$self->{'in_hash'}->{'_acl_group'}");
		}
	else {
		$self->redirect("edit_user.cgi?user=$self->{'in_hash'}->{'_acl_user'}&readwrite=1");
		}
	}
else {
	$self->redirect("");
	}

1;
		
}


1;

