#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_group.cgi
# Create, modify or delete a webmin group

&ModuleLoader::preload_module('acl_class', "acl::AclLib");
$self = new acl::AclLib:: 'acl_class',%$self;

$self->ReadParse();
@{$self->{'glist_array'}} = $self->list_groups();
@{$self->{'ulist_array'}} = $self->list_users();
if ($self->{'in_hash'}->{'old'}) {
	foreach $g (@{$self->{'glist_array'}}) {
		$self->{'old'} = $g if ($g->{'name'} eq $self->{'in_hash'}->{'old'});
		}
	$self->{'group_hash'}->{'members'} = $self->{'old'}->{'members'};
	}
$self->error_setup($self->{'text_hash'}->{'gsave_err'});

# Check for duplicate group names
$self->{'in_hash'}->{'name'} =~ /^[A-z0-9\-\_\.\@]+$/ && $self->{'in_hash'}->{'name'} !~ /^\@/ ||
	$self->error($self->text('gsave_ename', $self->{'in_hash'}->{'name'}));
$self->{'in_hash'}->{'name'} eq 'webmin' && $self->error($self->{'text_hash'}->{'gsave_enamewebmin'});
if (!$self->{'in_hash'}->{'old'} || $self->{'in_hash'}->{'old'} ne $self->{'in_hash'}->{'name'}) {
	foreach $g (@{$self->{'glist_array'}}) {
		if ($g->{'name'} eq $self->{'in_hash'}->{'name'}) {
			$self->error($self->text('gsave_edup', $self->{'in_hash'}->{'name'}));
			}
		}
	}

# Find the current group
if ($self->{'in_hash'}->{'old'}) {
	foreach $g ($self->list_groups()) {
		if ($self->indexof('@'.$self->{'in_hash'}->{'old'}, @{$g->{'members'}}) >= 0) {
			$self->{'oldgroup'} = $g;
			}
		}
	}

if (defined($self->{'in_hash'}->{'group'})) {
	# Check if group is allowed
	if ($self->{'access_hash'}->{'gassign'} ne '*') {
		local @gcan = split(/\s+/, $self->{'access_hash'}->{'gassign'});
		$self->{'in_hash'}->{'group'} && $self->indexof($self->{'in_hash'}->{'group'}, @gcan) >= 0 ||
		  !$self->{'in_hash'}->{'group'} && $self->indexof('_none', @gcan) >= 0 ||
		  $self->{'oldgroup'} && $self->{'oldgroup'}->{'name'} eq $self->{'in_hash'}->{'group'} ||
			$self->error($self->{'text_hash'}->{'save_egroup'});
		}

	# Store parent group membership
	@{$self->{'glist_array'}} = $self->list_groups();
	($self->{'group'}) = grep { $_->{'name'} eq $self->{'in_hash'}->{'group'} } @{$self->{'glist_array'}};
	if ($self->{'in_hash'}->{'group'} ne ($self->{'oldgroup'} ? $self->{'oldgroup'}->{'name'} : '')) {
		# Group has changed - update the member lists
		if ($self->{'oldgroup'}) {
			$self->{'oldgroup'}->{'members'} =
				[ grep { $_ ne '@'.$self->{'in_hash'}->{'old'} }
				  @{$self->{'oldgroup'}->{'members'}} ];
			$self->modify_group($self->{'oldgroup'}->{'name'}, $self->{'oldgroup'});
			}
		if ($self->{'group'}) {
			push(@{$self->{'group'}->{'members'}}, '@'.$self->{'in_hash'}->{'name'});
			$self->modify_group($self->{'in_hash'}->{'group'}, $self->{'group'});
			}
		}
	}

# Work out group modules
@{$self->{'mods_array'}} = split(/\0/, $self->{'in_hash'}->{'mod'});

if ($self->{'oldgroup'}) {
	# Remove modules from the old parent group
	@{$self->{'mods_array'}} = grep { $self->indexof($_, @{$self->{'oldgroup'}->{'modules'}}) < 0 } @{$self->{'mods_array'}};
	}

if ($self->{'group'}) {
	# Add modules from parent group to list
	local @ownmods;
	foreach $m (@{$self->{'mods_array'}}) {
		push(@ownmods, $m)
			if ($self->indexof($m, @{$self->{'group'}->{'modules'}}) < 0);
		}
	@{$self->{'mods_array'}} = $self->unique(@{$self->{'mods_array'}}, @{$self->{'group'}->{'modules'}});
	$self->{'group_hash'}->{'ownmods'} = \@ownmods;

	# Copy ACL files for parent group
	local $name = $self->{'in_hash'}->{'old'} ? $self->{'in_hash'}->{'old'} : $self->{'in_hash'}->{'name'};
	$self->copy_group_acl_files($self->{'in_hash'}->{'group'}, $name,
			      [ @{$self->{'group'}->{'modules'}}, "" ]);
	}

# Store group options
$self->{'group_hash'}->{'modules'} = \@{$self->{'mods_array'}};
$self->{'group_hash'}->{'name'} = $self->{'in_hash'}->{'name'};

if ($self->{'in_hash'}->{'old'}) {
	# update group
	$self->modify_group($self->{'in_hash'}->{'old'}, \%{$self->{'group_hash'}});

	# recursively update all member users and groups
	$self->update_members(\@{$self->{'ulist_array'}}, \@{$self->{'glist_array'}}, $self->{'group_hash'}->{'modules'},
			$self->{'old'}->{'members'});
	}
else {
	# create group
	$self->create_group(\%{$self->{'group_hash'}}, $self->{'in_hash'}->{'clone'});
	}
$self->reload_miniserv();
if ($self->{'in_hash'}->{'old'}) {
	$self->webmin_log("modify", "group", $self->{'in_hash'}->{'old'}, \%{$self->{'in_hash'}});
	}
else {
	$self->webmin_log("create", "group", $self->{'group_hash'}->{'name'}, \%{$self->{'in_hash'}});
	}
$self->redirect("");

1;
		
}


1;

