#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_unix.cgi
# Save automatic unix user authentication options

&ModuleLoader::preload_module('acl_class', "acl::AclLib");
$self = new acl::AclLib:: 'acl_class',%$self;

$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'unix_err'});
$self->{'access_hash'}->{'unix'} && $self->{'access_hash'}->{'create'} && $self->{'access_hash'}->{'delete'} ||
	$self->error($self->{'text_hash'}->{'unix_ecannot'});

# Parse Unix auth table
if (!$self->{'in_hash'}->{'unix_def'}) {
	for($i=0; defined($self->{'mode'} = $self->{'in_hash'}->{"mode_$i"}); $i++) {
		next if (!$self->{'mode'});
		$self->{'who'} = $self->{'in_hash'}->{"who_$i"};
		if ($self->{'mode'} == 2 && !$self->{'who'}) {
			$self->error($self->text('unix_ewhogroup', $i+1));
			}
		elsif ($self->{'mode'} == 3 && !$self->{'who'}) {
			$self->error($self->text('unix_ewhouser', $i+1));
			}
		$self->{'to'} = $self->{'in_hash'}->{"to_$i"};
		push(@{$self->{'unix_array'}}, [ $self->{'mode'} == 1 ? "*" :
			      $self->{'mode'} == 2 ? "\@$self->{'who'}" : $self->{'who'}, $self->{'to'} ]);
		}
	@{$self->{'unix_array'}} || $self->error($self->{'text_hash'}->{'unix_enone'});
	}

# Parse list of allowed users
@{$self->{'users_array'}} = split(/\s+/, $self->{'in_hash'}->{"users"});
if ($self->{'in_hash'}->{"access"}) {
	foreach $u (@{$self->{'users_array'}}) {
		if ($u =~ /^\@(\S+)$/) {
			defined(getgrnam($1)) ||
				$self->error($self->text('unix_egroup', "$1"));
			}
		elsif ($u =~ /^(\d*)-(\d*)$/ && ($1 || $2)) {
			# Assume UIDs are ok
			}
		else {
			defined(getpwnam($u)) ||
				$self->error($self->text('unix_euser', $u));
			}
		}
	}
if ($self->{'in_hash'}->{'shells_deny'}) {
	-r $self->{'in_hash'}->{'shells'} || $self->error($self->{'text_hash'}->{'unix_eshell'});
	}

$self->lock_file($ENV{'MINISERV_CONFIG'});
$self->get_miniserv_config(\%{$self->{'miniserv_hash'}});
$self->save_unixauth(\%{$self->{'miniserv_hash'}}, \@{$self->{'unix_array'}});
delete($self->{'miniserv_hash'}->{"allowusers"});
delete($self->{'miniserv_hash'}->{"denyusers"});
if ($self->{'in_hash'}->{"access"} == 1) { $self->{'miniserv_hash'}->{"allowusers"} = join(' ', @{$self->{'users_array'}}); }
elsif ($self->{'in_hash'}->{"access"} == 2) { $self->{'miniserv_hash'}->{"denyusers"} = join(' ', @{$self->{'users_array'}}); }
if ($self->{'in_hash'}->{'shells_deny'}) {
	$self->{'miniserv_hash'}->{'shells_deny'} = $self->{'in_hash'}->{'shells'};
	}
else {
	delete($self->{'miniserv_hash'}->{'shells_deny'});
	}
if ($self->{'in_hash'}->{'sudo'}) {
	$self->has_command("sudo") || $self->error($self->text('unix_esudo', "<tt>sudo</tt>"));
	eval "use IO::Pty";
	$@ && $self->error($self->text('unix_esudomod', "<tt>IO::Pty</tt>"));
	}
$self->{'miniserv_hash'}->{'sudo'} = $self->{'in_hash'}->{'sudo'};
$self->{'miniserv_hash'}->{'pamany'} = $self->{'in_hash'}->{'pamany'} ? $self->{'in_hash'}->{'pamany_user'} : undef;
$self->put_miniserv_config(\%{$self->{'miniserv_hash'}});
$self->unlock_file($ENV{'MINISERV_CONFIG'});
if ($self->{'oldsudo'} != $self->{'in_hash'}->{'sudo'}) {
	$self->restart_miniserv();
	}
else {
	$self->reload_miniserv();
	}
$self->redirect("");

1;
		
}


1;

