#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_user.cgi
# Modify or create a cpplus user

$| = 1;
&ModuleLoader::preload_module('acl_class', "acl::AclLib");
$self = new acl::AclLib:: 'acl_class',%$self;

$self->foreign_require("cpplus", "cpplus-lib.pl");
$self->ReadParse();
@{$self->{'ulist_array'}} = $self->list_users();
if ($self->{'in_hash'}->{'old'}) {
	$self->{'in_hash'}->{'name'} = $self->{'in_hash'}->{'old'} if (!$self->{'access_hash'}->{'rename'});
	$self->can_edit_user($self->{'in_hash'}->{'old'}) || $self->error($self->{'text_hash'}->{'save_euser'});
	foreach $u (@{$self->{'ulist_array'}}) {
		$self->{'old'} = $u if ($u->{'name'} eq $self->{'in_hash'}->{'old'});
		}
	}
else {
	$self->{'access_hash'}->{'create'} || $self->error($self->{'text_hash'}->{'save_ecreate'});
	}
$self->error_setup($self->{'text_hash'}->{'save_err'});

# Validate username, and check for a clash
$self->{'in_hash'}->{'name'} =~ /^[A-z0-9\-\_\.\@]+$/ && $self->{'in_hash'}->{'name'} !~ /^\@/ ||
	$self->error($self->text('save_ename', $self->{'in_hash'}->{'name'}));
$self->{'in_hash'}->{'name'} eq 'cpplus' && $self->error($self->{'text_hash'}->{'save_enamewebmin'});
if (!$self->{'in_hash'}->{'old'} || $self->{'in_hash'}->{'old'} ne $self->{'in_hash'}->{'name'}) {
	foreach $u (@{$self->{'ulist_array'}}) {
		if ($u->{'name'} eq $self->{'in_hash'}->{'name'}) {
			$self->error($self->text('save_edup', $self->{'in_hash'}->{'name'}));
			}
		}
	}
!$self->{'access_hash'}->{'logouttime'} || $self->{'in_hash'}->{'logouttime_def'} ||
	$self->{'in_hash'}->{'logouttime'} =~ /^\d+$/ || $self->error($self->{'text_hash'}->{'save_elogouttime'});

# Find logged-in cpplus user
foreach $u (@{$self->{'ulist_array'}}) {
	if ($u->{'name'} eq $self->{'base_remote_user'}) {
		$self->{'me'} = $u;
		}
	}

# Find the current group
if ($self->{'in_hash'}->{'old'}) {
	foreach $g ($self->list_groups()) {
		if ($self->indexof($self->{'in_hash'}->{'old'}, @{$g->{'members'}}) >= 0) {
			$self->{'oldgroup'} = $g;
			}
		}
	}

if ($self->supports_rbac()) {
	# Save RBAC mode
	$self->{'user_hash'}->{'rbacdeny'} = $self->{'in_hash'}->{'rbacdeny'};
	}

if ($self->{'in_hash'}->{'risk'}) {
	# Just store the skill and risk levels
	$self->{'user_hash'}->{'skill'} = $self->{'in_hash'}->{'skill'};
	$self->{'user_hash'}->{'risk'} = $self->{'in_hash'}->{'risk'};
	delete($self->{'user_hash'}->{'modules'});
	}
else {
	if (defined($self->{'in_hash'}->{'group'})) {
		# Check if group is allowed
		if ($self->{'access_hash'}->{'gassign'} ne '*') {
			local @gcan = split(/\s+/, $self->{'access_hash'}->{'gassign'});
			$self->{'in_hash'}->{'group'} && $self->indexof($self->{'in_hash'}->{'group'}, @gcan) >= 0 ||
			  !$self->{'in_hash'}->{'group'} && $self->indexof('_none', @gcan) >= 0 ||
			  $self->{'oldgroup'} && $self->{'oldgroup'}->{'name'} eq $self->{'in_hash'}->{'group'} ||
				$self->error($self->{'text_hash'}->{'save_egroup'});
			}

		# Store group membership
		@{$self->{'glist_array'}} = $self->list_groups();
		($self->{'group'}) = grep { $_->{'name'} eq $self->{'in_hash'}->{'group'} } @{$self->{'glist_array'}};
		if ($self->{'in_hash'}->{'group'} ne ($self->{'oldgroup'} ? $self->{'oldgroup'}->{'name'} : '')) {
			# Group has changed - update the member lists
			if ($self->{'oldgroup'}) {
				# Take out of old
				$self->{'oldgroup'}->{'members'} =
					[ grep { $_ ne $self->{'in_hash'}->{'old'} }
					  @{$self->{'oldgroup'}->{'members'}} ];
				$self->modify_group($self->{'oldgroup'}->{'name'}, $self->{'oldgroup'});
				}
			if ($self->{'group'}) {
				# Put into new
				push(@{$self->{'group'}->{'members'}}, $self->{'in_hash'}->{'name'});
				$self->modify_group($self->{'in_hash'}->{'group'}, $self->{'group'});
				}
			}
		elsif ($self->{'in_hash'}->{'old'} ne $self->{'in_hash'}->{'name'} && $self->{'oldgroup'} && $self->{'group'}) {
			# Name has changed - rename in group
			local $idx = $self->indexof(
				$self->{'in_hash'}->{'old'}, @{$self->{'oldgroup'}->{'members'}});
			$self->{'oldgroup'}->{'members'}->[$idx] = $self->{'in_hash'}->{'name'};
			$self->modify_group($self->{'oldgroup'}->{'name'}, $self->{'oldgroup'});
			}
		}

	# Store manually selected modules
	@{$self->{'mcan_array'}} = $self->{'access_hash'}->{'mode'} == 1 ? @{$self->{'me'}->{'modules'}} :
		$self->{'access_hash'}->{'mode'} == 2 ? split(/\s+/, $self->{'access_hash'}->{'mods'}) :
				       $self->list_modules();
	map { $self->{'mcan_hash'}->{$_}++ } @{$self->{'mcan_array'}};

	@{$self->{'mods_array'}} = split(/\0/, $self->{'in_hash'}->{'mod'});
	foreach $m (@{$self->{'mods_array'}}) {
		$self->{'mcan_hash'}->{$m} || $self->error($self->text('save_emod', $m));
		}
	if ($self->{'in_hash'}->{'old'}) {
		# Add modules that this user already has, but were not
		# allowed to be changed or are not available for this OS
		foreach $m (@{$self->{'old'}->{'modules'}}) {
			push(@{$self->{'mods_array'}}, $m) if (!$self->{'mcan_hash'}->{$m});
			}
		}
	if ($self->{'base_remote_user'} eq $self->{'in_hash'}->{'old'} &&
	    $self->indexof("acl", @{$self->{'mods_array'}}) == -1 &&
	    (!$self->{'group'} || $self->indexof("acl", @{$self->{'group'}->{'modules'}}) == -1)) {
		$self->error($self->{'text_hash'}->{'save_edeny'});
		}

	if ($self->{'oldgroup'}) {
		# Remove modules from the old group
		@{$self->{'mods_array'}} = grep { $self->indexof($_, @{$self->{'oldgroup'}->{'modules'}}) < 0 }
			     @{$self->{'mods_array'}};
		}

	if (!$self->{'in_hash'}->{'old'} && $self->{'access_hash'}->{'perms'}) {
		# Copy .acl files from creator to new user
		$self->copy_acl_files($self->{'me'}->{'name'}, $self->{'in_hash'}->{'name'}, $self->{'me'}->{'modules'});
		}

	if ($self->{'group'}) {
		# Add modules from group to list
		local @ownmods;
		foreach $m (@{$self->{'mods_array'}}) {
			push(@ownmods, $m)
				if ($self->indexof($m, @{$self->{'group'}->{'modules'}}) < 0);
			}
		@{$self->{'mods_array'}} = $self->unique(@{$self->{'mods_array'}}, @{$self->{'group'}->{'modules'}});
		$self->{'user_hash'}->{'ownmods'} = \@ownmods;

		# Copy ACL files for group
		local $name = $self->{'in_hash'}->{'old'} ? $self->{'in_hash'}->{'old'} : $self->{'in_hash'}->{'name'};
		$self->copy_group_user_acl_files($self->{'in_hash'}->{'group'}, $name,
				      [ @{$self->{'group'}->{'modules'}}, "" ]);
		}
	$self->{'user_hash'}->{'modules'} = \@{$self->{'mods_array'}};
	delete($self->{'user_hash'}->{'skill'});
	delete($self->{'user_hash'}->{'risk'});
	}

# Update user object
$self->{'salt'} = chr(int(rand(26))+65).chr(int(rand(26))+65);
$self->{'user_hash'}->{'name'} = $self->{'in_hash'}->{'name'};
$self->{'user_hash'}->{'lang'} = !$self->{'access_hash'}->{'lang'} ? $self->{'old'}->{'lang'} :
		$self->{'in_hash'}->{'lang_def'} ? undef : $self->{'in_hash'}->{'lang'};
$self->{'user_hash'}->{'theme'} = !$self->{'access_hash'}->{'theme'} ? $self->{'old'}->{'theme'} :
		 $self->{'in_hash'}->{'theme_def'} ? undef : $self->{'in_hash'}->{'theme'};
$self->{'user_hash'}->{'cert'} = !$self->{'access_hash'}->{'chcert'} ? $self->{'old'}->{'cert'} :
		$self->{'in_hash'}->{'cert_def'} ? undef : $self->{'in_hash'}->{'cert'};
$self->{'user_hash'}->{'notabs'} = !$self->{'access_hash'}->{'cats'} ? $self->{'old'}->{'notabs'} : $self->{'in_hash'}->{'notabs'};
$self->{'user_hash'}->{'logouttime'} = !$self->{'access_hash'}->{'logouttime'} ? $self->{'old'}->{'logouttime'} :
			$self->{'in_hash'}->{'logouttime_def'} ? undef : $self->{'in_hash'}->{'logouttime'};
$self->{'raddr'} = $ENV{'REMOTE_ADDR'};
if ($self->{'access_hash'}->{'ips'}) {
	if ($self->{'in_hash'}->{'ipmode'}) {
		@{$self->{'hosts_array'}} = split(/\s+/, $self->{'in_hash'}->{"ips"});
		if (!@{$self->{'hosts_array'}}) { $self->error($self->{'text_hash'}->{'save_enone'}); }
		foreach $h (@{$self->{'hosts_array'}}) {
			$self->{'err'} = &webmin::valid_allow($h);
			$self->error($self->{'err'}) if ($self->{'err'});
			push(@{$self->{'ips_array'}}, $h);
			}
		}
	if ($self->{'in_hash'}->{'ipmode'} == 1) {
		$self->{'user_hash'}->{'allow'} = join(" ", @{$self->{'ips_array'}});
		if ($self->{'old'}->{'name'} eq $self->{'base_remote_user'} &&
		    !&webmin::ip_match($self->{'raddr'}, @{$self->{'ips_array'}})) {
			$self->error($self->text('save_eself', $self->{'raddr'}));
			}
		}
	elsif ($self->{'in_hash'}->{'ipmode'} == 2) {
		$self->{'user_hash'}->{'deny'} = join(" ", @{$self->{'ips_array'}});
		if ($self->{'old'}->{'name'} eq $self->{'base_remote_user'} &&
		    &webmin::ip_match($self->{'raddr'}, @{$self->{'ips_array'}})) {
			$self->error($self->text('save_eself', $self->{'raddr'}));
			}
		}
	}
else {
	$self->{'user_hash'}->{'allow'} = $self->{'old'}->{'allow'};
	$self->{'user_hash'}->{'deny'} = $self->{'old'}->{'deny'};
	}
if ($self->{'in_hash'}->{'pass_def'} == 0) {
	# New password
	if($self->{'in_hash'}->{'pass'} eq $self->{'in_hash'}->{'re_pass'}){
		$self->{'in_hash'}->{'pass'} =~ /:/ && $self->error($self->{'text_hash'}->{'save_ecolon'});
	}else{
		$self->error($self->{'text_hash'}->{'edit_lock'});
	}
	$self->{'user_hash'}->{'pass'} = $self->encrypt_password($self->{'in_hash'}->{'pass'});
	$self->{'user_hash'}->{'sync'} = 0;
	}
elsif ($self->{'in_hash'}->{'pass_def'} == 1) {
	# No change in password
	$self->{'user_hash'}->{'pass'} = $self->{'in_hash'}->{'oldpass'};
	$self->{'user_hash'}->{'sync'} = 0;
	}
elsif ($self->{'in_hash'}->{'pass_def'} == 3) {
	# Unix authentication
	$self->{'user_hash'}->{'pass'} = 'x';
	$self->{'user_hash'}->{'sync'} = 0;
	}
elsif ($self->{'in_hash'}->{'pass_def'} == 4) {
	# Account is locked
	$self->{'user_hash'}->{'pass'} = '*LK*';
	$self->{'user_hash'}->{'sync'} = 0;
	}
elsif ($self->{'in_hash'}->{'pass_def'} == 5) {
	# External authentcation
	$self->{'user_hash'}->{'pass'} = 'e';
	$self->{'user_hash'}->{'sync'} = 0;
	}
else {
	# Password synchronization (deprecated)
	$self->foreign_check("useradmin") || $self->error($self->{'text_hash'}->{'save_eos'});
	$self->foreign_require("useradmin", "user-lib.pl");
	foreach $uu ($self->foreign_call("useradmin", "list_users")) {
		$self->{'user_hash'}->{'pass'} = $uu->{'pass'}
			if ($uu->{'user'} eq $self->{'in_hash'}->{'name'});
		}
	defined($self->{'user_hash'}->{'pass'}) ||
		$self->error($self->text('save_eunix', $self->{'in_hash'}->{'name'}));
	$self->{'user_hash'}->{'sync'} = 1;
	}

# Update allowed days and hours
if ($self->{'access_hash'}->{'times'}) {
	# Save the allowed days
	if (!$self->{'in_hash'}->{'days_def'}) {
		@{$self->{'days_array'}} = split(/\0/, $self->{'in_hash'}->{'days'});
		@{$self->{'days_array'}} || $self->error($self->{'text_hash'}->{'save_edays'});
		$self->{'user_hash'}->{'days'} = join(",", @{$self->{'days_array'}});
		}
	if (!$self->{'in_hash'}->{'hours_def'}) {
		foreach $t ('from', 'to') {
			$h = $self->{'in_hash'}->{'hours_h'.$t};
			$m = $self->{'in_hash'}->{'hours_m'.$t};
			$h =~ /^\d+$/ && $h >= 0 &&
			  $h < 24 || $self->error($self->{'text_hash'}->{'save_ehours'});
			$m =~ /^\d+$/ && $m >= 0 &&
			  $m < 60 || $self->error($self->{'text_hash'}->{'save_ehours'});
			$self->{'user_hash'}->{'hours'.$t} = "$h.$m";
			$self->{'mins_hash'}->{$t} = $h*60+$m;
			}
		$self->{'mins_hash'}->{'from'} < $self->{'mins_hash'}->{'to'} || $self->error($self->{'text_hash'}->{'save_ehours2'});
		}
	}
else {
	$self->{'user_hash'}->{'days'} = $self->{'old'}->{'days'};
	$self->{'user_hash'}->{'hoursfrom'} = $self->{'old'}->{'hoursfrom'};
	$self->{'user_hash'}->{'hoursto'} = $self->{'old'}->{'hoursto'};
	}

# Check for temporary password lock
if (!$self->{'in_hash'}->{'lock'} && $self->{'user_hash'}->{'pass'} =~ /^\!(.*)$/) {
	$self->{'user_hash'}->{'pass'} = $1;
	}
elsif ($self->{'in_hash'}->{'lock'} && $self->{'user_hash'}->{'pass'} !~ /^\!/ && $self->{'in_hash'}->{'pass_def'} <= 1) {
	$self->{'user_hash'}->{'pass'} = "!".$self->{'user_hash'}->{'pass'};
	}

if ($self->{'in_hash'}->{'old'}) {
	# update user and all ACLs
	$self->modify_user($self->{'in_hash'}->{'old'}, \%{$self->{'user_hash'}});
	foreach $u ($self->list_users()) {
		%{$self->{'uaccess_hash'}} = $self->get_module_acl($u->{'name'});
		local @au = split(/\s+/, $self->{'uaccess_hash'}->{'users'});
		local $idx = $self->indexof($self->{'in_hash'}->{'old'}, @au);
		if ($idx != -1) {
			$au[$idx] = $self->{'in_hash'}->{'name'};
			$self->{'uaccess_hash'}->{'users'} = join(" ", @au);
			$self->save_module_acl(\%{$self->{'uaccess_hash'}}, $u->{'name'});
			}
		}
	}
else {
	# create and add to access list
	$self->create_user(\%{$self->{'user_hash'}}, $self->{'in_hash'}->{'clone'});
	if ($self->{'access_hash'}->{'users'} ne '*') {
		$self->{'access_hash'}->{'users'} .= " ".$self->{'in_hash'}->{'name'};
		$self->save_module_acl(\%{$self->{'access_hash'}});
		}
	#%aclacl = $self->get_module_acl();
	#$self->save_module_acl(\%aclacl, $self->{'in_hash'}->{'name'});
	}
delete($self->{'in_hash'}->{'pass'});
if ($self->{'in_hash'}->{'old'}) {
	$self->webmin_log("modify", "user", $self->{'in_hash'}->{'old'}, \%{$self->{'in_hash'}});
	}
else {
	$self->webmin_log("create", "user", $self->{'user_hash'}->{'name'}, \%{$self->{'in_hash'}});
	}
$self->reload_miniserv();
if($self->{'in_hash'}->{'re_pass'}){ $self->redirect($self->{'text_hash'}->{'index_mainpage_url'});}
$self->redirect("");

1;
		
}


1;

