#!/usr/bin/perl

&MAIN();

 sub MAIN {
# index.cgi
# display the icons for various types of amavisd config options

# main part
&ModuleLoader::preload_module('amavis_class', "amavis::AmavisLib");
$self = new amavis::AmavisLib:: 'amavis_class',%$self;

%{$self->{'access_hash'}} = $self->get_module_acl();
$self->ReadParse();

# start, restart or stop service
if ($self->{'in_hash'}->{'start'}) { $self->start_amavisd; }
elsif ($self->{'in_hash'}->{'stop'}) { $self->stop_amavisd; }
elsif ($self->{'in_hash'}->{'restart'}) { $self->restart_amavisd; }

# print header
local $version = $self->get_version_amavisd();
$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, undef, undef, 1, 1,undef, undef, undef, undef, $version ? $self->text('index_version',"$version") : 0);

# error config messeges
if (!$self->has_command($self->{'config_hash'}->{'amavisd_cmd'})) 
{
 $self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", undef, 1, 1);
 $self->ui_print_endpage($self->ui_config_link('index_ecmd',[ "<tt>$self->{'config_hash'}->{'amavisd_cmd'}</tt>", undef ]));
}

# print section icons
# get option list for installed version
local $options = $self->get_option_list();

# get section list
local (%temp,@section);
foreach (@{$options})
{
 $temp{$_->[0]}++;
}
@section = keys %temp;

# print section icons
print $self->ui_subheading($self->{'text_hash'}->{'options'});
print "<TABLE width=100% cellpadding=5><TR>\n";
local $i;
foreach (@section)
{
 print "<TD width=20% valign=top align=center nowrap>\n";
 $self->generate_icon("images/$_.gif",$self->{'text_hash'}->{"index_$_"},"options.cgi?section=$_",undef, undef, undef,undef);
 print "</TD>\n";
 $i++;
 if ($i == 5)
 {
  print "</TR><TR>\n";
  $i = 0;
 }
}
print "</TABLE>\n";

# print other icons
print $self->ui_subheading($self->{'text_hash'}->{'viewers'});
print "<TABLE width=100% cellpadding=5><TR>\n";
print "<TD width=20% valign=top align=center nowrap>\n";
$self->generate_icon("images/logs.gif",$self->{'text_hash'}->{"index_log"},"log_view.cgi",undef, undef, undef,undef);
print "</TD><TD width=20% valign=top align=center nowrap>\n";
$self->generate_icon("images/quarantine_view.gif",$self->{'text_hash'}->{"index_quarantine_view"},"quarantin.cgi",undef, undef, undef,undef);
print "</TD></TR></TABLE>\n";

# print submit start,restart or stop
print "<TABLE width=100% border=1>\n";
print $self->ui_subheading($self->{'text_hash'}->{'process_managment'});

# index proces status
if ($self->status_amavisd())
{
 # service started
 print "<FORM action=index.cgi><TR>\n";
 print "<TD width=15%><INPUT type=hidden name=stop value=1>\n";
 print "<INPUT style=width:120 type=submit value='$self->{'text_hash'}->{'index_stop'}'>\n";
 print "<TD>$self->{'text_hash'}->{'index_stopmsg'}</TD></FORM>\n";
 print "<FORM action=index.cgi><TR>\n";
 print "<TD width=15%><INPUT type=hidden name=restart value=1>\n";
 print "<INPUT style=width:120 type=submit value='$self->{'text_hash'}->{'index_restart'}'>\n";
 print "<TD>$self->{'text_hash'}->{'index_restartmsg'}</TD></TR></FORM>\n";
}
else
{
 # service stoped
 print "<FORM action=index.cgi><TR>\n";
 print "<TD width=15%><INPUT type=hidden name=start value=1>\n";
 print "<INPUT style=width:120 type=submit value='$self->{'text_hash'}->{'index_start'}'>\n";
 print "<TD>$self->{'text_hash'}->{'index_startmsg'}</TD></TR></FORM>\n";
}
print "</TABLE>\n";

# print main page url
$self->ui_print_footer($self->{'text_hash'}->{'index_mainpage_url'}, $self->{'text_hash'}->{'index_mainpage'});
1;
		
}


1;

