#!/usr/bin/perl
package apache::Autoindex;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'apache::Autoindex');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# autoindex.pl
# Directives in both mod_dir.pl and mod_autoindex.pl

@{$self->{'AddIcon_dirs_array'}} = ("AddIcon", "AddIconByType", "AddIconByEncoding");
@{$self->{'AddIcon_descs_array'}} = ("$self->{'text_hash'}->{'autoindex_fname'}", "$self->{'text_hash'}->{'autoindex_mime'}", "$self->{'text_hash'}->{'autoindex_enc'}");

@{$self->{'AddAlt_dirs_array'}} = ("AddAlt", "AddAltByType", "AddAltByEncoding");
@{$self->{'AddAlt_descs_array'}} = ("Filename", "MIME type", "Encoding");

@{$self->{'IndexOptions_v_array'}} =
	( "FancyIndexing", "ScanHTMLTitles", "IconHeight", "IconWidth",
	  "SuppressColumnSorting", "SuppressDescription",
	  "SuppressHTMLPreamble", "SuppressLastModified", "SuppressSize",
	  "IconsAreLinks", "NameWidth", "DescriptionWidth", "FoldersFirst",
	  "HTMLTable", "IgnoreClient", "SuppressIcon", "SuppressRules",
	  "TrackModified", "VersionSort" );
@{$self->{'IndexOptions_d_array'}} =
	( $self->{'text_hash'}->{'autoindex_fancy'},
	  $self->{'text_hash'}->{'autoindex_htmltitle'},
	  $self->{'text_hash'}->{'autoindex_iheight'},
	  $self->{'text_hash'}->{'autoindex_iwidth'},
	  $self->{'text_hash'}->{'autoindex_sort'},
	  $self->{'text_hash'}->{'autoindex_fildesc'},
	  $self->{'text_hash'}->{'autoindex_htags'},
	  $self->{'text_hash'}->{'autoindex_mtime'},
	  $self->{'text_hash'}->{'autoindex_size'},
	  $self->{'text_hash'}->{'autoindex_iconlink'},
	  $self->{'text_hash'}->{'autoindex_fwidth'},
	  $self->{'text_hash'}->{'autoindex_dwidth'},
	  $self->{'text_hash'}->{'autoindex_dirfirst'},
	  $self->{'text_hash'}->{'autoindex_html'},
	  $self->{'text_hash'}->{'autoindex_client'},
	  $self->{'text_hash'}->{'autoindex_sicon'},
	  $self->{'text_hash'}->{'autoindex_srules'},
	  $self->{'text_hash'}->{'autoindex_track'},
	  $self->{'text_hash'}->{'autoindex_version'} );
@{$self->{'IndexOptions_i_array'}} = ( 0, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0 );
@{$self->{'IndexOptions_n_array'}} = ( 0, 0, 1.3, 1.3,
	            1.3, 0,
		    1.3, 0, 0,
		    1.302, 1.302, 1.310, 1.310,
		    2.023, 2.023, 2.023, 2.023,
		    2.023, 2.0 );

1;

1;
		return $self;
}

sub edit_AddIcon_AddIconByType_AddIconByEncoding
{
	my $self = shift;

local($rv, @all, $i, $j, $icon, $alt, $mode, $file);
$rv = "<table border>\n".
"<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'autoindex_icon'}</b></td> <td><b>$self->{'text_hash'}->{'autoindex_alt'}</b></td>\n".
"<td><b>$self->{'text_hash'}->{'autoindex_match'}</b></td> <td><b>$self->{'text_hash'}->{'autoindex_fte'}</b></td></tr>\n";
@all = (@{$_[0]}, @{$_[1]}, @{$_[2]});
for($i=0; $i<=@all; $i++) {
	$self->{'d'} = $all[$i];
	if ($self->{'d'}) {
		if ($self->{'d'}->{'value'} =~ /^\((.*),(\S+)\)\s*(.*)$/) {
			$alt = $1; $icon = $2; $file = $3;
			}
		elsif ($self->{'d'}->{'value'} =~ /^(\S+)\s*(.*)$/) {
			$alt = ""; $icon = $1; $file = $2;
			}
		$mode = $self->indexof($self->{'d'}->{'name'}, @{$self->{'AddIcon_dirs_array'}});
		}
	else { $alt = $icon = $file = ""; $mode = 0; }

	$rv .="<tr $self->{'cb'}>\n";
	$rv .="<td><input name=AddIcon_icon_$i size=25 value=\"$icon\"></td>\n";
	$rv .="<td><input name=AddIcon_alt_$i size=10 value=\"$alt\"></td>\n";
	$rv .="<td><select name=AddIcon_mode_$i>\n";
	for($j=0; $j<@{$self->{'AddIcon_descs_array'}}; $j++) {
		$rv .= sprintf "<option value=$j %s>%s\n",
		        $mode == $j ? "selected" : "", $self->{'AddIcon_descs_array'}->[$j];
		}
	$rv .="</select></td>\n";
	$rv .="<td><input name=AddIcon_file_$i size=20 value=\"$file\"></td>\n";
	$rv .="</tr>\n";
	}
$rv .= "</table>\n";
return (2, "$self->{'text_hash'}->{'autoindex_diricon'}", $rv);
}

sub save_AddIcon_AddIconByType_AddIconByEncoding
{
	my $self = shift;

local($i, $icon, $alt, $file, $mode, $aref, @ai, @ait, @aie);
for($i=0; defined($self->{'in_hash'}->{"AddIcon_icon_$i"}); $i++) {
	$icon = $self->{'in_hash'}->{"AddIcon_icon_$i"}; $alt = $self->{'in_hash'}->{"AddIcon_alt_$i"};
	$mode = $self->{'in_hash'}->{"AddIcon_mode_$i"}; $file = $self->{'in_hash'}->{"AddIcon_file_$i"};
	if ($icon !~ /\S/ && $file !~ /\S/) { next; }
	$icon =~ /^\S+$/ || $self->error($self->text('autoindex_eiconurl', $icon));
	$file =~ /\S/ || $self->error($self->text('autoindex_emiss', $self->{'AddIcon_descs_array'}->[$mode], $icon));
	$aref = $mode==0 ? \@ai : $mode==1 ? \@ait : \@aie;
	if ($alt) { push(@$aref, "($alt,$icon) $file"); }
	else { push(@$aref, "$icon $file"); }
	}
return ( \@ai, \@ait, \@aie );
}

sub edit_DefaultIcon
{
	my $self = shift;

return (1, "$self->{'text_hash'}->{'autoindex_deficon'}",
        $self->opt_input($_[0]->{'value'}, "DefaultIcon", "$self->{'text_hash'}->{'autoindex_default'}", 20));
}

sub save_DefaultIcon
{
	my $self = shift;

return $self->parse_opt("DefaultIcon", '^\S+$', "$self->{'text_hash'}->{'autoindex_edeficon'}");
}

sub edit_AddAlt_AddAltByType_AddAltByEncoding
{
	my $self = shift;

local($rv, @all, $i, $j, $alt, $mode, $file);
$rv = "<table border>\n".
"<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'autoindex_alt'}</b></td>\n".
"<td><b>$self->{'text_hash'}->{'autoindex_match'}</b></td> <td><b>$self->{'text_hash'}->{'autoindex_fte'}</b></td></tr>\n";
@all = (@{$_[0]}, @{$_[1]}, @{$_[2]});
for($i=0; $i<=@all; $i++) {
	$self->{'d'} = $all[$i];
	if ($self->{'d'}->{'value'}) {
		$alt = $self->{'d'}->{'words'}->[0];
		@{$self->{'w_array'}} = @{$self->{'d'}->{'words'}};
		$file = join(' ', @{$self->{'w_array'}}[1..$#{$self->{'w_array'}}]);
		$mode = $self->indexof($self->{'d'}->{'name'}, @{$self->{'AddAlt_dirs_array'}});
		}
	else { $alt = $file = ""; $mode = 0; }

	$rv .="<tr $self->{'cb'}>\n";
	$rv .="<td><input name=AddAlt_alt_$i size=20 value=\"$alt\"></td>\n";
	$rv .="<td><select name=AddAlt_mode_$i>\n";
	for($j=0; $j<@{$self->{'AddAlt_descs_array'}}; $j++) {
		$rv .= sprintf "<option value=$j %s>%s\n",
		        $mode == $j ? "selected" : "", $self->{'AddAlt_descs_array'}->[$j];
		}
	$rv .="</select></td>\n";
	$rv .="<td><input name=AddAlt_file_$i size=20 value=\"$file\"></td>\n";
	$rv .="</tr>\n";
	}
$rv .= "</table>\n";
return (2, "$self->{'text_hash'}->{'autoindex_diralt'}", $rv);
}

sub save_AddAlt_AddAltByType_AddAltByEncoding
{
	my $self = shift;

local($i, $alt, $file, $mode, $aref, @ai, @ait, @aie);
for($i=0; defined($alt = $self->{'in_hash'}->{"AddAlt_alt_$i"}); $i++) {
	$mode = $self->{'in_hash'}->{"AddAlt_mode_$i"}; $file = $self->{'in_hash'}->{"AddAlt_file_$i"};
	if ($alt !~ /\S/ && $file !~ /\S/) { next; }
	$file =~ /\S/ || $self->error($self->text('autoindex_emissquot', $self->{'AddAlt_descs_array'}->[$mode], $alt));
	$aref = $mode==0 ? \@ai : $mode==1 ? \@ait : \@aie;
	push(@$aref, "\"$alt\" $file");
	}
return ( \@ai, \@ait, \@aie );
}

sub edit_AddDescription
{
	my $self = shift;

local($rv, $i, $desc, $file);
$rv = "<table border>\n".
      "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'autoindex_desc'}</b></td> <td><b>$self->{'text_hash'}->{'autoindex_fnames'}</b></td> </tr>\n";
for($i=0; $i<=@{$_[0]}; $i++) {
	if ($_[0]->[$i] && $_[0]->[$i]->{'value'} =~ /^"(.*)"\s*(.*)$/)
		{ $desc = $1; $file = $2; }
	else { $desc = $file = ""; }
	$rv .= "<tr $self->{'cb'}> <td><input size=40 name=AddDescription_desc_$i ".
	       "value=\"$desc\"></td>\n";
	$rv .= "<td><input size=20 name=AddDescription_file_$i ".
	       "value=\"$file\"></td> </tr>\n";
	}
$rv .= "</table>\n";
return (2, "$self->{'text_hash'}->{'autoindex_dirdesc'}", $rv);
}

sub save_AddDescription
{
	my $self = shift;

local($i, $desc, $file, @rv);
for($i=0; defined($self->{'in_hash'}->{"AddDescription_desc_$i"}); $i++) {
	$desc = $self->{'in_hash'}->{"AddDescription_desc_$i"};
	$file = $self->{'in_hash'}->{"AddDescription_file_$i"};
	if ($desc !~ /\S/ && $file !~ /\S/) { next; }
	$desc =~ /\S/ || $self->error($self->text('autoindex_enodesc', $file));
	$file =~ /\S/ || $self->error($self->text('autoindex_enofile', $desc));
	push(@rv, "\"$desc\" $file");
	}
return ( \@rv );
}

sub edit_IndexOptions_FancyIndexing
{
	my $self = shift;

local($o, %opts, $i, $rv);
$rv = $self->choice_input($_[0] || $_[1] ? 0 : 1, "IndexOptions_def", 1,
		    "$self->{'text_hash'}->{'autoindex_default2'},1", "$self->{'text_hash'}->{'autoindex_select'},0");
foreach $o (split(/\s+/, $_[0]->{'value'})) {
	if ($o =~ /^(\S+)=(\S+)$/) { $opts{$1} = $2; }
	else { $opts{$o} = -1; }
	}
if ($_[1]->{'value'} eq "on") { $opts{'FancyIndexing'} = -1; }
$rv .= "<table border><tr><td><table cellpadding=0>\n";
local $sw = 0;
for($i=0; $i<@{$self->{'IndexOptions_v_array'}}; $i++) {
	$o = $self->{'IndexOptions_v_array'}->[$i];
	next if ($_[2]->{'version'} < $self->{'IndexOptions_n_array'}->[$i]);

	$rv .= "<tr>\n" if (!$sw);
	if ($self->{'IndexOptions_i_array'}->[$i]) { $opts{$o} = -$opts{$o}-1; }
	$rv .= sprintf "<td><input type=checkbox name=Index_$o value=1 %s> %s\n",
	        $opts{$o} ? "checked" : "", $self->{'IndexOptions_d_array'}->[$i];
	if ($o =~ /IconWidth|IconHeight/) {
		$rv .= "&nbsp;";
		$rv .= sprintf 
		        "<input type=radio name=Index_${o}_def value=1 %s> $self->{'text_hash'}->{'autoindex_default3'}\n",
		        $opts{$o} < 0 ? "checked" : "";
		$rv .= sprintf
		        "&nbsp;<input type=radio name=Index_${o}_def value=0 %s>\n",
		        $opts{$o} < 0 ? "" : "checked";
		$rv .= sprintf
		        "<input name=Index_${o}_wh size=5 value=\"%s\"> $self->{'text_hash'}->{'autoindex_pixels'}\n",
		        $opts{$o} < 0 ? "" : $opts{$o};
		}
	elsif ($o =~ /NameWidth|DescriptionWidth/) {
		$rv .= "&nbsp;";
		$rv .= sprintf
		        "<input name=Index_${o}_w size=5 value=\"%s\"> $self->{'text_hash'}->{'autoindex_chars'}\n",
		        $opts{$o} < 0 ? "" : $opts{$o};
		}
	$rv .= "</td>";
	$rv .= "</tr>\n" if ($sw);
	$sw = !$sw;
	}
$rv .= "</table></td></tr></table>\n";
return (2, "$self->{'text_hash'}->{'autoindex_diropt'}", $rv);
}

sub save_IndexOptions_FancyIndexing
{
	my $self = shift;

local($i, $o, @rv, %opts);
if ($self->{'in_hash'}->{'IndexOptions_def'}) { return ( [ ], [ ] ); }
for($i=0; $i<@{$self->{'IndexOptions_v_array'}}; $i++) {
	$o = $self->{'IndexOptions_v_array'}->[$i];
	next if ($_[0]->{'version'} < $self->{'IndexOptions_n_array'}->[$i]);

	if ($self->{'in_hash'}->{"Index_$o"}) { $opts{$o} = -1; }
	if ($o =~ /IconWidth|IconHeight/ &&
	    $self->{'in_hash'}->{"Index_${o}"} && !$self->{'in_hash'}->{"Index_${o}_def"}) {
		$self->{'in_hash'}->{"Index_${o}_wh"} =~ /^[1-9]\d*$/ ||
			$self->error($self->text('autoindex_eiconsize', $self->{'in_hash'}->{"Index_${o}_wh"}));
		$opts{$o} = $self->{'in_hash'}->{"Index_${o}_wh"};
		}
	elsif ($o =~ /NameWidth|DescriptionWidth/ && $self->{'in_hash'}->{"Index_${o}"}) {
		$self->{'in_hash'}->{"Index_${o}_w"} =~ /^[1-9]\d*$/ ||
		    $self->{'in_hash'}->{"Index_${o}_w"} eq '*' ||
			$self->error($self->text('autoindex_ewidth', $self->{'in_hash'}->{"Index_$(o)_h"}));
		$opts{$o} = $self->{'in_hash'}->{"Index_${o}_w"};
		}
	if ($self->{'IndexOptions_i_array'}->[$i]) { $opts{$o} = -$opts{$o}-1; }
	if ($opts{$o} < 0) { push(@rv, "$o"); }
	elsif ($opts{$o} > 0) { push(@rv, "$o=$opts{$o}"); }
	}
return ( [ join(' ', @rv) ], [ ] );
}

sub edit_HeaderName
{
	my $self = shift;

return (1, "$self->{'text_hash'}->{'autoindex_dirhead'}",
        $self->opt_input($_[0]->{'value'}, "HeaderName", "$self->{'text_hash'}->{'autoindex_default4'}", 20));
}

sub save_HeaderName
{
	my $self = shift;

return $self->parse_opt("HeaderName", '^\S+$', "$self->{'text_hash'}->{'autoindex_edirhead'}");
}

sub edit_ReadmeName
{
	my $self = shift;

return (1, "$self->{'text_hash'}->{'autoindex_dirfoot'}",
        $self->opt_input($_[0]->{'value'}, "ReadmeName", "$self->{'text_hash'}->{'autoindex_default4'}", 20));
}

sub save_ReadmeName
{
	my $self = shift;

return $self->parse_opt("ReadmeName", '^\S+$', "$self->{'text_hash'}->{'autoindex_edirfoot'}");
}

sub edit_IndexIgnore
{
	my $self = shift;

local($rv, $i, @ii);
foreach $i (@{$_[0]}) { push(@ii, split(/\s+/, $i->{'value'})); }
$rv = join("\n", @ii);
return (1, "$self->{'text_hash'}->{'autoindex_ignore'}",
        "<textarea name=IndexIgnore rows=5 cols=20>$rv</textarea>");
}

sub save_IndexIgnore
{
	my $self = shift;

local(@rv); @rv = split(/\s+/, $self->{'in_hash'}->{'IndexIgnore'});
if (!@rv) { return ( [ ] ); }
else { return ( [ join(' ', @rv) ] ); }
}


1;

