#!/usr/bin/perl
package apache::Backup_config;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'apache::Backup_config');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;

&ModuleLoader::preload_module(ref($self), "apache::ApacheLib");
$self = new apache::ApacheLib:: ref($self), %$self; 

1;

1;
		return $self;
}

# backup_config_files()
# Returns files and directories that can be backed up
sub backup_config_files
{
	my $self = shift;

local @rv;

# Add main config files
local $conf = $self->get_config();
push(@rv, map { $_->{'file'} } @$conf);

# Add mime types file
local $mfile = $self->find_directive("TypesConfig", $conf);
if (!$mfile) { $mfile = $self->{'config_hash'}->{'mime_types'}; }
if (!$mfile) { $mfile = $self->server_root("etc/mime.types", $conf); }
if (!-r $mfile) { $mfile = $self->server_root("conf/mime.types", $conf); }
if ($mfile) {
	push(@rv, $self->server_root($mfile, $conf));
	}

# Add mime magic file
local $magic = $self->find_directive("MimeMagicFile", $conf);
if ($magic) {
	push(@rv, $self->server_root($magic, $conf));
	}

# Add all auth files
local $auth;
foreach $auth ($self->find_all_directives($conf, "AuthUserFile"),
	       $self->find_all_directives($conf, "AuthGroupFile")) {
	push(@rv, $self->server_root($auth, $conf));
	}

return $self->unique(@rv);
}

# pre_backup(&files)
# Called before the files are actually read
sub pre_backup
{
	my $self = shift;

return undef;
}

# post_backup(&files)
# Called after the files are actually read
sub post_backup
{
	my $self = shift;

return undef;
}

# pre_restore(&files)
# Called before the files are restored from a backup
sub pre_restore
{
	my $self = shift;

return undef;
}

# post_restore(&files)
# Called after the files are restored from a backup
sub post_restore
{
	my $self = shift;

local $pidfile = $self->get_pid_file();
if ($self->check_pid_file($pidfile)) {
	return $self->restart_apache();
	}
return undef;
}


1;

