#!/usr/bin/perl
package apache::Cache;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'apache::Cache');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# cache.pl
# Functions used by both mod_proxy.pl and the new apache caching modules

1;

1;
		return $self;
}

sub edit_CacheRoot
{
	my $self = shift;

return (1, $self->{'text_hash'}->{'mod_proxy_dir'},
        $self->opt_input($_[0]->{'value'}, "CacheRoot", $self->{'text_hash'}->{'mod_proxy_none'}, 20).
        $self->file_chooser_button("CacheRoot", 0));
}

sub save_CacheRoot
{
	my $self = shift;

$self->{'in_hash'}->{'CacheRoot_def'} || $self->allowed_auth_file($self->{'in_hash'}->{'CacheRoot'}) ||
	$self->error($self->{'text_hash'}->{'mod_proxy_eunder'});
return $self->parse_opt("CacheRoot", '^\S+$', $self->{'text_hash'}->{'mod_proxy_edir'});
}

sub edit_CacheSize
{
	my $self = shift;

return (1, $self->{'text_hash'}->{'mod_proxy_size'},
        $self->opt_input($_[0]->{'value'}, "CacheSize", $self->{'text_hash'}->{'mod_proxy_default'}, 8)." kB");
}

sub save_CacheSize
{
	my $self = shift;

return $self->parse_opt("CacheSize", '^\d+$', $self->{'text_hash'}->{'mod_proxy_esize'});
}

sub edit_CacheGcInterval
{
	my $self = shift;

return (1, $self->{'text_hash'}->{'mod_proxy_garbage'},
        $self->opt_input($_[0]->{'value'}, "CacheGcInterval", $self->{'text_hash'}->{'mod_proxy_nogc'}, 6).
	$self->{'text_hash'}->{'mod_proxy_hours'});
}

sub save_CacheGcInterval
{
	my $self = shift;

return $self->parse_opt("CacheGcInterval", '^\d+$',
                  $self->{'text_hash'}->{'mod_proxy_egarbage'});
}

sub edit_CacheMaxExpire
{
	my $self = shift;

return (1, $self->{'text_hash'}->{'mod_proxy_maxexp'},
        $self->opt_input($_[0]->{'value'}, "CacheMaxExpire", $self->{'text_hash'}->{'mod_proxy_default'}, 6).
	$self->{'text_hash'}->{'mod_proxy_hours'});
}

sub save_CacheMaxExpire
{
	my $self = shift;

return $self->parse_opt("CacheMaxExpire", '^\d+$',
                  $self->{'text_hash'}->{'mod_proxy_emaxexp'});
}

sub edit_CacheLastModifiedFactor
{
	my $self = shift;

return (1, $self->{'text_hash'}->{'mod_proxy_expfac'},
        $self->opt_input($_[0]->{'value'}, "CacheLastModifiedFactor", $self->{'text_hash'}->{'mod_proxy_default'}, 6));
}

sub save_CacheLastModifiedFactor
{
	my $self = shift;

return $self->parse_opt("CacheLastModifiedFactor", '^\d+$',
                  $self->{'text_hash'}->{'mod_proxy_eexpfac'});
}

sub edit_CacheDirLevels
{
	my $self = shift;

return (1, $self->{'text_hash'}->{'mod_proxy_levels'},
        $self->opt_input($_[0]->{'value'}, "CacheDirLevels", $self->{'text_hash'}->{'mod_proxy_default'}, 6));
}

sub save_CacheDirLevels
{
	my $self = shift;

return $self->parse_opt("CacheDirLevels", '^\d+$',
                  $self->{'text_hash'}->{'mod_proxy_elevels'});
}

sub edit_CacheDirLength
{
	my $self = shift;

return (1, $self->{'text_hash'}->{'mod_proxy_length'},
        $self->opt_input($_[0]->{'value'}, "CacheDirLength", $self->{'text_hash'}->{'mod_proxy_default'}, 4));
}

sub save_CacheDirLength
{
	my $self = shift;

return $self->parse_opt("CacheDirLength", '^\d+$',
                  $self->{'text_hash'}->{'mod_proxy_elength'});
}

sub edit_CacheDefaultExpire
{
	my $self = shift;

return (1, $self->{'text_hash'}->{'mod_proxy_defexp'},
        $self->opt_input($_[0]->{'value'}, "CacheDefaultExpire", $self->{'text_hash'}->{'mod_proxy_default'}, 6).
	$self->{'text_hash'}->{'mod_proxy_hours'});
}

sub save_CacheDefaultExpire
{
	my $self = shift;

return $self->parse_opt("CacheDefaultExpire", '^\d+$', $self->{'text_hash'}->{'mod_proxy_edefexp'});
}

sub edit_CacheForceCompletion
{
	my $self = shift;

return (1, $self->{'text_hash'}->{'mod_proxy_finish'},
        $self->opt_input($_[0]->{'value'}, "CacheForceCompletion", $self->{'text_hash'}->{'mod_proxy_default'}, 6)."%");
}

sub save_CacheForceCompletion
{
	my $self = shift;

return $self->parse_opt("CacheForceCompletion", '^\d+$',
		  $self->{'text_hash'}->{'mod_proxy_efinish'});
}

sub edit_NoCache
{
	my $self = shift;

local($n, @n);
foreach $n (@{$_[0]}) { push(@n, $n->{'value'}); }
return (1, $self->{'text_hash'}->{'mod_proxy_nocache'},
        $self->opt_input(@n ? join(' ', @n) : undef, "NoCache", $self->{'text_hash'}->{'mod_proxy_none2'}, 20));
}

sub save_NoCache
{
	my $self = shift;

return $self->parse_opt("NoCache", '\S', $self->{'text_hash'}->{'mod_proxy_enocache'});
}


1;

