#!/usr/bin/perl
package apache::Log_parser;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'apache::Log_parser');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# log_parser.pl
# Functions for parsing this module's logs

&ModuleLoader::preload_module(ref($self), "apache::ApacheLib");
$self = new apache::ApacheLib:: ref($self), %$self; 

1;
		return $self;
}

# parse_webmin_log(user, script, action, type, object, &params)
# Converts logged information from this module into human-readable form
sub parse_webmin_log
{
	my $self = shift;

local ($user, $script, $action, $type, $object, $p, $long) = @_;
local $typestr = "<i>".$self->{'text_hash'}->{"type_$type"}."</i>";
if ($action eq 'global') {
	return $self->text('log_global', $typestr);
	}
elsif ($action eq 'manual') {
	return $self->text('log_manual', "<tt>$p->{'file'}</tt>");
	}
elsif ($action eq 'virt') {
	$object = $self->html_escape($object);
	if ($type eq 'create') {
		return $self->text('log_virtc', "<tt>$object</tt>");
		}
	elsif ($type eq 'save') {
		return $self->text('log_virts', "<tt>$object</tt>");
		}
	elsif ($type eq 'delete') {
		return $self->text('log_virtd', "<tt>$object</tt>");
		}
	elsif ($type eq 'manual') {
		return $self->text('log_virtm', "<tt>$object</tt>");
		}
	else {
		return $self->text('log_virt', $typestr, "<tt>$object</tt>");
		}
	}
elsif ($action eq 'dir') {
	local ($virt, $dir);
	if ($object =~ /^([^:]+):(\d+):(.*)$/) {
		$virt = "$1:$2"; $dir = $3;
		}
	elsif ($object =~ /^([^:]+):(.*)$/) {
		$virt = $1; $dir = $2;
		}
	$virt = $self->html_escape($virt);
	$dir = $self->html_escape($dir);
	if ($type eq 'create') {
		return $self->text($long ? 'log_dirc_l' : 'log_dirc',
			     "<tt>$dir</tt>", "<tt>$virt</tt>");
		}
	elsif ($type eq 'save') {
		return $self->text($long ? 'log_dirs_l' : 'log_dirs',
			     "<tt>$dir</tt>", "<tt>$virt</tt>");
		}
	elsif ($type eq 'delete') {
		return $self->text($long ? 'log_dird_l' : 'log_dird',
			     "<tt>$dir</tt>", "<tt>$virt</tt>");
		}
	elsif ($type eq 'manual') {
		return $self->text($long ? 'log_dirm_l' : 'log_dirm',
			     "<tt>$dir</tt>", "<tt>$virt</tt>");
		}
	else {
		return $self->text($long ? 'log_dir_l' : 'log_dir', $typestr,
			     "<tt>$dir</tt>", "<tt>$virt</tt>");
		}
	}
elsif ($action eq 'htaccess') {
	$object = $self->html_escape($object);
	$virt = $self->html_escape($virt);
	if ($type eq 'create') {
		return $self->text('log_htaccessc',
			     "<tt>$object</tt>", "<tt>$virt</tt>");
		}
	elsif ($type eq 'delete') {
		return $self->text('log_htaccessd',
			     "<tt>$object</tt>", "<tt>$virt</tt>");
		}
	elsif ($type eq 'manual') {
		return $self->text('log_htaccessm',
			     "<tt>$object</tt>", "<tt>$virt</tt>");
		}
	else {
		return $self->text('log_htaccess', $typestr,
			     "<tt>$object</tt>", "<tt>$virt</tt>");
		}
	}
elsif ($action eq 'files') {
	local ($file, $path);
	if ($object =~ /^([^:]+):(.*)$/) {
		$file = $1; $path = $2;
		}
	$file = $self->html_escape($file);
	$path = $self->html_escape($path);
	if ($type eq 'create') {
		return $self->text($long ? 'log_filesc_l' : 'log_filesc',
			     "<tt>$path</tt>", "<tt>$file</tt>");
		}
	elsif ($type eq 'save') {
		return $self->text($long ? 'log_filess_l' : 'log_filess',
			     "<tt>$path</tt>", "<tt>$file</tt>");
		}
	elsif ($type eq 'delete') {
		return $self->text($long ? 'log_filesd_l' : 'log_filesd',
			     "<tt>$path</tt>", "<tt>$file</tt>");
		}
	elsif ($type eq 'manual') {
		return $self->text($long ? 'log_filesm_l' : 'log_filesm',
			     "<tt>$path</tt>", "<tt>$file</tt>");
		}
	else {
		return $self->text($long ? 'log_files_l' : 'log_files', $typestr,
			     "<tt>$path</tt>", "<tt>$file</tt>");
		}
	}
elsif ($action eq 'mime') {
	$object = $self->html_escape($object);
	return $self->text("log_mime_$type", "<tt>$object</tt>");
	}
elsif ($action eq 'defines') {
	return $self->{'text_hash'}->{'log_defines'};
	}
elsif ($action eq 'reconfig') {
	return $self->{'text_hash'}->{'log_reconfig'};
	}
elsif ($action eq 'stop') {
	return $self->{'text_hash'}->{'log_stop'};
	}
elsif ($action eq 'start') {
	return $self->{'text_hash'}->{'log_start'};
	}
elsif ($action eq 'apply') {
	return $self->{'text_hash'}->{'log_apply'};
	}
elsif ($action eq 'virts') {
	return $self->text('log_virts_'.$type, $object);
	}
else {
	return undef;
	}
}


1;

