#!/usr/bin/perl
package apache::Mod_actions;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'apache::Mod_actions');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# mod_actions.pl
# Defines editors for CGI actions

1;

1;
		return $self;
}

sub mod_actions_directives
{
	my $self = shift;

$self->{'rv'} = [ [ 'Action', 1, 11, 'virtual directory htaccess', undef, 5 ],
        [ 'Script', 1, 11, 'virtual directory' ] ];
return $self->make_directives($self->{'rv'}, $_[0], "mod_actions");
}

sub mod_actions_handlers
{
	my $self = shift;

local($d, @rv);
foreach $d ($self->find_all_directives($_[0], "Action")) {
	if ($d->{'words'}->[0] =~ /^[A-z0-9\-\_]+$/) {
		push(@rv, $d->{'words'}->[0]);
		}
	}
return @rv;
}

sub edit_Action
{
	my $self = shift;

local($rv, $len, $i, $type, $cgi);
$rv = "<table border>\n".
      "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'mod_actions_mime'}</b></td> <td><b>$self->{'text_hash'}->{'mod_actions_cgiurl'}</b></td> </tr>";
$len = @{$_[0]}+1;
for($i=0; $i<$len; $i++) {
	if ($_[0]->[$i]->{'value'} =~ /^(\S+)\s+(\S+)$/) {
		$type = $1; $cgi = $2;
		}
	else { $type = $cgi = ""; }
	$rv .= "<tr $self->{'cb'}>\n";
	$rv .= "<td><input name=Action_type_$i size=20 value=\"$type\"></td>\n";
	$rv .= "<td><input name=Action_cgi_$i size=40 value=\"$cgi\"></td>\n";
	$rv .= "</tr>\n";
	}
$rv .= "</table>\n";
return (2, "$self->{'text_hash'}->{'mod_actions_mimecgi'}", $rv);
}

sub save_Action
{
	my $self = shift;

local($i, $cgi, $type, @rv);
for($i=0; defined($self->{'in_hash'}->{"Action_type_$i"}); $i++) {
	$type = $self->{'in_hash'}->{"Action_type_$i"}; $cgi = $self->{'in_hash'}->{"Action_cgi_$i"};
	if ($type !~ /\S/ && $cgi !~ /\S/) { next; }
	$type =~ /^(\S+)$/ || $self->error($self->text('mod_actions_emime', $type));
	$cgi =~ /^\/(\S+)$/ || $self->error($self->text('mod_actions_ecgi', $cgi));
	push(@rv, "$type $cgi");
	}
return ( \@rv );
}

sub edit_Script
{
	my $self = shift;

local($rv, $len, $i, $meth, $cgi, $m, $found);
$rv = "<table border>\n".
      "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'mod_actions_http'}</b></td> <td><b>$self->{'text_hash'}->{'mod_actions_cgi'}</b></td> </tr>";
$len = @{$_[0]}+1;
for($i=0; $i<$len; $i++) {
	if ($_[0]->[$i]->{'value'} =~ /^(\S+)\s+(\S+)$/) {
		$meth = $1; $cgi = $2;
		}
	else { $meth = $cgi = ""; }
	$rv .= "<tr $self->{'cb'}><td><select name=Script_meth_$i>\n";
	foreach $m ("", "GET", "POST", "PUT", "DELETE") {
		$rv .= sprintf "<option %s>$m\n", $meth eq $m ? "selected" : "";
		$found++ if ($meth eq $m);
		}
	printf "<option selected>$meth\n" if (!$found);
	$rv .= "</select></td>\n";
	$rv .= "<td><input name=Script_cgi_$i size=40 value=\"$cgi\"></td>\n";
	$rv .= "</tr>\n";
	}
$rv .= "</table>\n";
return (2, "$self->{'text_hash'}->{'mod_actions_httpcgi'}", $rv);
}

sub save_Script
{
	my $self = shift;

local($i, @rv, $meth, $cgi);
for($i=0; defined($self->{'in_hash'}->{"Script_meth_$i"}); $i++) {
	$meth = $self->{'in_hash'}->{"Script_meth_$i"}; $cgi = $self->{'in_hash'}->{"Script_cgi_$i"};
	if (!$meth && $cgi !~ /\S/) { next; }
	$meth || $self->error($self->text('mod_actions_enometh', $cgi));
	$cgi =~ /^\/(\S+)$/ || $self->error($self->text('mod_actions_ecgi', $cgi));
	push(@rv, "$meth $cgi");
	}
return ( \@rv );
}


1;

