#!/usr/bin/perl
package apache::Mod_alias;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'apache::Mod_alias');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# mod_alias.pl
# Defines editors for alias module directives

%{$self->{'alias_statmap_hash'}} = ("permanent", 301,  "temp", 302,
		  "seeother", 303,   "gone", 410);
#$self->{'url_regexp'} = '^(http|ftp|gopher|https|mailto|telnet):(\S+)$';
$self->{'url_regexp'} = '^\S+$';

1;
1;
		return $self;
}

sub mod_alias_directives
{
	my $self = shift;

$self->{'rv'} = [ [ 'Alias', 1, 10, 'virtual' ],
	[ 'AliasMatch', 1, 10, 'virtual', 1.3 ],
	[ 'Redirect', 1, 10, 'virtual directory htaccess', 1.2 ],
	[ 'Redirect', 1, 10, 'virtual', '-1.2' ],
	[ 'RedirectMatch', 1, 10, 'virtual', 1.3 ],
	[ 'RedirectTemp', 1, 10, 'virtual directory htaccess', 1.2 ],
	[ 'RedirectPermanent', 1, 10, 'virtual directory htaccess', 1.2 ],
	[ 'ScriptAlias', 1, 11, 'virtual', undef, 10 ],
	[ 'ScriptAliasMatch', 1, 11, 'virtual', 1.3, 10 ] ];
return $self->make_directives($self->{'rv'}, $_[0], "mod_alias");
}

# alias_input(array, name, title)
sub alias_input
{
	my $self = shift;

local($rv, $len, $i, $from, $to);
$rv = "<table border>\n".
      "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'mod_alias_from'}</b></td> <td><b>$self->{'text_hash'}->{'mod_alias_to'}</b></td> </tr>\n";
$len = @{$_[0]} + 1;
for($i=0; $i<$len; $i++) {
	$from = $_[0]->[$i]->{'words'}->[0];
	$to = $_[0]->[$i]->{'words'}->[1];
	$rv .= "<tr $self->{'cb'}>\n";
	$rv .= "<td><input name=$_[1]_from_$i size=20 value=\"$from\"></td>\n";
	$rv .= "<td><input name=$_[1]_to_$i size=40 value=\"$to\"></td>\n";
	$rv .= "</tr>\n";
	}
$rv .= "</table>\n";
return (2, $_[2], $rv);
}

# alias_status_input(array, name, title)
sub alias_status_input
{
	my $self = shift;

local($rv, $len, $i, $from, $to, $stat);
$rv = "<table border>\n".
      "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'mod_alias_from'}</b></td> <td><b>$self->{'text_hash'}->{'mod_alias_status'}</b></td> <td><b>$self->{'text_hash'}->{'mod_alias_to'}</b></td> </tr>\n";
$len = @{$_[0]} + 1;
for($i=0; $i<$len; $i++) {
	if ($_[0]->[$i]->{'words'}->[0] =~ /^(permanent|temp|seeother|gone|\d+)$/) {
		$stat = $_[0]->[$i]->{'words'}->[0];
		$from = $_[0]->[$i]->{'words'}->[1];
		$to = $_[0]->[$i]->{'words'}->[2];
		if ($self->{'alias_statmap_hash'}->{$stat}) { $stat = $self->{'alias_statmap_hash'}->{$stat}; }
		}
	else {
		$stat = "";
		$from = $_[0]->[$i]->{'words'}->[0];
		$to = $_[0]->[$i]->{'words'}->[1];
		}
	$rv .= "<tr $self->{'cb'}>\n";
	$rv .= "<td><input name=$_[1]_from_$i size=20 value=\"$from\"></td>\n";
	$rv .= "<td><input name=$_[1]_stat_$i size=4 value=\"$stat\"></td>\n";
	$rv .= "<td><input name=$_[1]_to_$i size=40 value=\"$to\"></td>\n";
	$rv .= "</tr>\n";
	}
$rv .= "</table>\n";
return (2, $_[2], $rv);
}

# parse_alias(name, title, regexp)
sub parse_alias
{
	my $self = shift;

local($re, @rv, $i, $from, $to);
$re = $_[2];
for($i=0; defined($self->{'in_hash'}->{"$_[0]_from_$i"}); $i++) {
	$from = $self->{'in_hash'}->{"$_[0]_from_$i"}; $to = $self->{'in_hash'}->{"$_[0]_to_$i"};
	if ($from !~ /\S/ && $to !~ /\S/) { next; }
	if ($from !~ /^\S+$/) { $self->error($self->text('mod_alias_efrom', $from, $_[1])); }
	if ($to !~ /$re/) { $self->error($self->text('mod_alias_edest', $to, $_[1])); }
	$self->allowed_doc_dir($to) || $self->error($self->text('mod_alias_edest2', $to, $_[1]));
	push(@rv, "$from \"$to\"");
	}
return ( \@rv );
}

# parse_alias_status(name, title, regexp)
sub parse_alias_status
{
	my $self = shift;

local($re, @rv, $i, $from, $to, $stat);
$re = $_[2];
for($i=0; defined($self->{'in_hash'}->{"$_[0]_from_$i"}); $i++) {
	$from = $self->{'in_hash'}->{"$_[0]_from_$i"};
	$to = $self->{'in_hash'}->{"$_[0]_to_$i"};
	$stat = $self->{'in_hash'}->{"$_[0]_stat_$i"};
	if ($from !~ /\S/ && $to !~ /\S/) { next; }
	if ($from !~ /^\S+$/) { $self->error($self->text('mod_alias_efrom', $from, $_[1])); }
	if ($stat !~ /^(\d*)$/) { $self->error($self->text('mod_alias_estatus', $stat)); }
	if (!$stat || $stat >= 300 && $stat <= 399) {
		if ($to !~ /$re/) {
			$self->error($self->text('mod_alias_edest', $to, $_[1]));
			}
		$self->allowed_doc_dir($to) ||
			$self->error($self->text('mod_alias_edest2', $to, $_[1]));
		}
	else { $to = ""; }
	if ($stat) { push(@rv, "$stat $from \"$to\""); }
	else { push(@rv, "$from \"$to\""); }
	}
return ( \@rv );
}

sub edit_Alias
{
	my $self = shift;

return $self->alias_input($_[0], "Alias", $self->{'text_hash'}->{'mod_alias_alias'});
}

sub save_Alias
{
	my $self = shift;

return $self->parse_alias("Alias", $self->{'text_hash'}->{'mod_alias_alias2'}, '\S');
}

sub edit_AliasMatch
{
	my $self = shift;

return $self->alias_input($_[0], "AliasMatch", $self->{'text_hash'}->{'mod_alias_regexp'});
}

sub save_AliasMatch
{
	my $self = shift;

return $self->parse_alias("AliasMatch", $self->{'text_hash'}->{'mod_alias_regexp2'}, '\S');
}

sub edit_Redirect
{
	my $self = shift;

if ($_[1]->{'version'} >= 1.2) {
	return $self->alias_status_input($_[0], "Redirect", $self->{'text_hash'}->{'mod_alias_redir'});
	}
else { return $self->alias_input($_[0], "Redirect", $self->{'text_hash'}->{'mod_alias_redir'}); }
}

sub save_Redirect
{
	my $self = shift;

if ($_[0]->{'version'} >= 1.2) {
	return $self->parse_alias_status("Redirect", $self->{'text_hash'}->{'mod_alias_redir2'}, $self->{'url_regexp'});
	}
else { return $self->parse_alias("Redirect", $self->{'text_hash'}->{'mod_alias_redir2'}, $self->{'url_regexp'}); }
}

sub edit_RedirectMatch
{
	my $self = shift;

return $self->alias_status_input($_[0], "RedirectMatch", $self->{'text_hash'}->{'mod_alias_rredir'});
}

sub save_RedirectMatch
{
	my $self = shift;

return $self->parse_alias_status("RedirectMatch", $self->{'text_hash'}->{'mod_alias_rredir2'}, $self->{'url_regexp'});
}

sub edit_RedirectTemp
{
	my $self = shift;

return $self->alias_input($_[0], "RedirectTemp", $self->{'text_hash'}->{'mod_alias_tredir'});
}

sub save_RedirectTemp
{
	my $self = shift;

return $self->parse_alias("RedirectTemp", $self->{'text_hash'}->{'mod_alias_tredir2'}, $self->{'url_regexp'});
}

sub edit_RedirectPermanent
{
	my $self = shift;

return $self->alias_input($_[0], "RedirectPermanent", $self->{'text_hash'}->{'mod_alias_predir'});
}

sub save_RedirectPermanent
{
	my $self = shift;

return $self->parse_alias("RedirectPermanent", $self->{'text_hash'}->{'mod_alias_predir2'}, $self->{'url_regexp'});
}

sub edit_ScriptAlias
{
	my $self = shift;

return $self->alias_input($_[0], "ScriptAlias", $self->{'text_hash'}->{'mod_alias_cgi'});
}

sub save_ScriptAlias
{
	my $self = shift;

return $self->parse_alias("ScriptAlias", $self->{'text_hash'}->{'mod_alias_cgi2'}, '^\S+$');
}

sub edit_ScriptAliasMatch
{
	my $self = shift;

return $self->alias_input($_[0], "ScriptAliasMatch", $self->{'text_hash'}->{'mod_alias_rcgi'});
}

sub save_ScriptAliasMatch
{
	my $self = shift;

return $self->parse_alias("ScriptAliasMatch", $self->{'text_hash'}->{'mod_alias_rcgi2'}, '^\S+$');
}


1;

