#!/usr/bin/perl
package apache::Mod_apachessl;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'apache::Mod_apachessl');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# nodo50 v0.1 - Change 000003 - New Script. Define Editors for mod_apachessl directives (Apache-ssl not use mod_ssl)
# nodo50 v0.1 - Change 000003 - Nuevo Script. Define edicin de directivas de mod_apachessl (Apache-ssl no usa mod_ssl)
# mod_apachessl.pl (http://www.apache-ssl.org/)
# Defines editors for mod_apachessl directives

#Cipher Suites (from http://www.apache-ssl.org/docs.html)
@{$self->{'mod_apachessl_ciphers_array'}} = ("IDEA-CBC-SHA",
"NULL-MD5",
"NULL-SHA",
"EXP-RC4-MD5",
"RC4-MD5",
"RC4-SHA",
"EXP-RC2-CBC-MD5",
"IDEA-CBC-MD5",
"EXP-DES-CBC-SHA",
"DES-CBC-SHA",
"DES-CBC3-SHA",
"EXP-DH-DSS-DES-CBC-SHA",
"DH-DSS-DES-CBC-SHA",
"DH-DSS-DES-CBC3-SHA",
"EXP-DH-RSA-DES-CBC-SHA",
"DH-RSA-DES-CBC-SHA",
"DH-RSA-DES-CBC3-SHA",
"EXP-EDH-DSS-DES-CBC-SHA",
"EDH-DSS-DES-CBC-SHA",
"EDH-DSS-DES-CBC3-SHA",
"EXP-EDH-RSA-DES-CBC",
"EDH-RSA-DES-CBC-SHA",
"EDH-RSA-DES-CBC3-SHA",
"EXP-ADH-RC4-MD5",
"ADH-RC4-MD5",
"EXP-ADH-DES-CBC-SHA",
"ADH-DES-CBC-SHA",
"ADH-DES-CBC3-SHA",
"FZA-NULL-SHA",
"FZA-FZA-CBC-SHA",
"FZA-RC4-SHA",
"DES-CFB-M1",
"RC2-CBC-MD5",
"DES-CBC-MD5",
"DES-CBC3-MD5",
"RC4-64-MD5",
"NULL"
);
1;
		return $self;
}

sub mod_apachessl_directives
{
	my $self = shift;

local($rv);
$rv = [ [ 'SSLCacheServerPath', 0, 14, 'global', undef, 59 ],
	[ 'SSLCacheServerPort', 0, 14, 'global', 1.3, 58 ],
	[ 'SSLCacheServerRunDir', 0, 14, 'global', undef, 57 ],
	[ 'SSLRandomFile', 0, 14, 'global', 1.3, 56 ],
	[ 'SSLRandomFilePerConnection', 0, 14, 'global', 1.3, 55 ],
	[ 'SSLEnable SSLDisable', 0, 14, 'virtual', undef, 49 ],
	[ 'SSLNoV2', 0, 14, 'virtual', 1.3, 48 ],
	[ 'SSLRequireSSL SSLDenySSL', 0, 14, 'virtual directory htaccess', 1.3, 47 ],
	[ 'SSLCertificateFile', 0, 14, 'virtual', undef, 39 ],
	[ 'SSLCertificateKeyFile', 0, 14, 'virtual', undef, 38 ],
	[ 'SSLNoCAList', 0, 14, 'virtual', 1.3, 37 ],
	[ 'SSLCACertificatePath', 0, 14, 'virtual', undef, 36 ],
	[ 'SSLCACertificateFile', 0, 14, 'virtual', undef, 35 ],
	[ 'SSLVerifyClient', 0, 14, 'virtual', undef, 29 ],
	[ 'SSLVerifyDepth', 0, 14, 'virtual', undef, 28 ],
	[ 'SSLExportClientCertificates', 0, 14, 'virtual directory htaccess', undef, 27 ],
	[ 'SSLSessionCacheTimeout', 0, 14, 'virtual', undef, 26 ],
	[ 'SSLCheckClientDN', 0, 14, 'virtual', 1.3, 25 ],
	[ 'SSLFakeBasicAuth', 0, 14, 'virtual', undef, 24 ],
	[ 'SSLUseCRL', 0, 14, 'virtual', undef, 23 ],
	[ 'SSLCRLCheckAll', 0, 14, 'virtual', 1.3, 22 ],
	[ 'SSLOnNoCRLSetEnv', 0, 14, 'virtual', 1.3, 21 ],
	[ 'SSLOnCRLExpirySetEnv', 0, 14, 'virtual', 1.3, 20 ],
	[ 'SSLOnRevocationSetEnv', 0, 14, 'virtual', 1.3, 19 ],
	[ 'SSLRequiredCiphers', 0, 14, 'virtual', undef, 3 ],
	[ 'SSLRequireCipher', 0, 14, 'virtual directory htaccess', undef, 2 ],
	[ 'SSLBanCipher', 0, 14, 'virtual directory htaccess', undef, 1 ]
];
return $self->make_directives($rv, $_[0], "mod_apachessl");
}

sub edit_SSLCacheServerPath
{
	my $self = shift;

return (2, $self->{'text_hash'}->{'mod_apachessl_cachepaht'},
	$self->opt_input($_[0]->{'value'}, "SSLCacheServerPath", $self->{'text_hash'}->{'mod_ssl_default'}, 35).
	$self->file_chooser_button("SSLCacheServerPath", 0));SSLRandomFile
}

sub save_SSLCacheServerPath
{
	my $self = shift;

return $self->parse_opt("SSLCacheServerPath", '\S', $self->{'text_hash'}->{'mod_apachessl_ecachepath'});
}

sub edit_SSLCacheServerPort
{
	my $self = shift;

return (2, $self->{'text_hash'}->{'mod_apachessl_cacheport'},
	$self->opt_input($_[0]->{'value'}, "SSLCacheServerPort", $self->{'text_hash'}->{'mod_ssl_default'}, 35).
	$self->file_chooser_button("SSLCacheServerPort", 0));
}

sub save_SSLCacheServerPort
{
	my $self = shift;

return $self->{'in_hash'}->{SSLCacheServerPort} =~ /^\d+$/ ? $self->parse_opt("SSLCacheServerPort", '^\d+$', $self->{'text_hash'}->{'mod_apachessl_ecacheport'}) :
	$self->parse_opt("SSLCacheServerPort", '\S', $self->{'text_hash'}->{'mod_apachessl_ecacheport'});
}

sub edit_SSLCacheServerRunDir
{
	my $self = shift;

return (2, $self->{'text_hash'}->{'mod_apachessl_cacherundir'},
	$self->opt_input($_[0]->{'value'}, "SSLCacheServerRunDir", $self->{'text_hash'}->{'mod_ssl_default'}, 35).
	$self->file_chooser_button("SSLCacheServerRunDir", 0));
}

sub save_SSLCacheServerRunDir
{
	my $self = shift;

return $self->parse_opt("SSLCacheServerRunDir", '\S', $self->{'text_hash'}->{'mod_apachessl_ecacherundir'});
}

sub edit_SSLRandomFile
{
	my $self = shift;

local @sel = split(/\ /, $_[0]->{'value'});
return (2, $self->{'text_hash'}->{'mod_apachessl_ramdomfile'},
	$self->choice_input($sel[0], "SSLRandomFile", "",
		      "$self->{'text_hash'}->{'mod_ssl_default'},", "$self->{'text_hash'}->{'mod_apachessl_ramdomfilef'},file", "$self->{'text_hash'}->{'mod_apachessl_ramdomfilee'},egd").
	'<input name=SSLRandomFileF size=35 value='.$sel[1].'>'.
	$self->file_chooser_button("SSLRandomFileF", 0).
	'<input name=SSLRandomFileB size=10 value='.$sel[2].'>&nbsp;bytes');
}

sub save_SSLRandomFile
{
	my $self = shift;

if (!$self->{'in_hash'}->{SSLRandomFile}) {
	return ( [ ] );
	}
if ($self->{'in_hash'}->{SSLRandomFileF} !~ /\S/) {
	$self->error($self->{'text_hash'}->{'mod_apachessl_eramdomfilef'});
	}
if ($self->{'in_hash'}->{SSLRandomFileB} !~ /^\d+$/) {
	$self->error($self->{'text_hash'}->{'mod_apachessl_eramdomfileb'});
	}
return ( [ $self->{'in_hash'}->{SSLRandomFile}.' '.$self->{'in_hash'}->{SSLRandomFileF}.' '.$self->{'in_hash'}->{SSLRandomFileB} ] );
}

sub edit_SSLRandomFilePerConnection
{
	my $self = shift;

local @sel = split(/\ /, $_[0]->{'value'});
return (2, $self->{'text_hash'}->{'mod_apachessl_ramdomfilepc'},
	$self->choice_input($sel[0], "SSLRandomFilePerConnection", "",
		      "$self->{'text_hash'}->{'mod_ssl_default'},", "$self->{'text_hash'}->{'mod_apachessl_ramdomfilef'},file", "$self->{'text_hash'}->{'mod_apachessl_ramdomfilee'},egd").
	'<input name=SSLRandomFilePerConnectionF size=35 value='.$sel[1].'>'.
	$self->file_chooser_button("SSLRandomFileF", 0).
	'<input name=SSLRandomFilePerConnectionB size=10 value='.$sel[2].'>&nbsp;bytes');
}

sub save_SSLRandomFilePerConnection
{
	my $self = shift;

if (!$self->{'in_hash'}->{SSLRandomFilePerConnection}) {
	return ( [ ] );
	}
if ($self->{'in_hash'}->{SSLRandomFilePerConnectionF} !~ /\S/) {
	$self->error($self->{'text_hash'}->{'mod_apachessl_eramdomfilef'});
	}
if ($self->{'in_hash'}->{SSLRandomFilePerConnectionB} !~ /^\d+$/) {
	$self->error($self->{'text_hash'}->{'mod_apachessl_eramdomfileb'});
	}
return ( [ $self->{'in_hash'}->{SSLRandomFilePerConnection}.' '.$self->{'in_hash'}->{SSLRandomFilePerConnectionF}.' '.$self->{'in_hash'}->{SSLRandomFilePerConnectionB} ] );
}

sub edit_SSLEnable_SSLDisable
{
	my $self = shift;

return (1, $self->{'text_hash'}->{'mod_ssl_enable'},
	$self->choice_input($_[0] ? "1" : "0", "SSLEnable", "",
		      "$self->{'text_hash'}->{'yes'},1", "$self->{'text_hash'}->{'no'},0", "$self->{'text_hash'}->{'default'},"));
}

sub save_SSLEnable_SSLDisable
{
	my $self = shift;

return $self->{'in_hash'}->{'SSLEnable'} ? ( [ "" ], [ ] ) : ( [ ], [ "" ] );
}

sub edit_SSLNoV2
{
	my $self = shift;

return (1, $self->{'text_hash'}->{'mod_apachessl_nov2'},
	$self->choice_input($_[0] ? 1 : 0, "SSLNoV2", "",
		      "$self->{'text_hash'}->{'yes'},1", "$self->{'text_hash'}->{'no'},0"));
}

sub save_SSLNoV2
{
	my $self = shift;

return $self->{'in_hash'}->{'SSLNoV2'} ? ( [ "" ] ) : ( [ ] );
}

sub edit_SSLRequireSSL_SSLDenySSL
{
	my $self = shift;

return (2, $self->{'text_hash'}->{'mod_apachessl_forcessl'},
	$self->choice_input($_[0] ? "Require" : $_[1] ? "Deny" : "",
	"SSLRequireSSL", "", "$self->{'text_hash'}->{'mod_ssl_onlyssl'},Require", "$self->{'text_hash'}->{'mod_apachessl_notssl'},Deny", "$self->{'text_hash'}->{'default'},"));
}

sub save_SSLRequireSSL_SSLDenySSL
{
	my $self = shift;

return $self->{'in_hash'}->{'SSLRequireSSL'} eq "Require" ? ( [ "" ], [ ] ) : $self->{'in_hash'}->{'SSLRequireSSL'} eq "Deny" ? ( [ ], [ "" ]) : ( [ ], [ ] );
}

sub edit_SSLCertificateFile
{
	my $self = shift;

return (2, $self->{'text_hash'}->{'mod_ssl_cfile'},
	$self->opt_input($_[0]->{'value'}, "SSLCertificateFile", $self->{'text_hash'}->{'mod_ssl_default'}, 35).
	$self->file_chooser_button("SSLCertificateFile", 0));
}

sub save_SSLCertificateFile
{
	my $self = shift;

return $self->parse_opt("SSLCertificateFile", '\S', $self->{'text_hash'}->{'mod_ssl_ecfile'});
}

sub edit_SSLCertificateKeyFile
{
	my $self = shift;

return (2, $self->{'text_hash'}->{'mod_ssl_kfile'},
	$self->opt_input($_[0]->{'value'}, "SSLCertificateKeyFile", $self->{'text_hash'}->{'mod_ssl_default'}, 35).
	$self->file_chooser_button("SSLCertificateKeyFile", 0));
}

sub save_SSLCertificateKeyFile
{
	my $self = shift;

return $self->parse_opt("SSLCertificateKeyFile", '\S', $self->{'text_hash'}->{'mod_ssl_ekfile'});
}

sub edit_SSLNoCAList
{
	my $self = shift;

return (1, $self->{'text_hash'}->{'mod_apachessl_nocalist'},
	$self->choice_input($_[0] ? 1 : 0, "SSLNoCAList", "",
		      "$self->{'text_hash'}->{'yes'},1", "$self->{'text_hash'}->{'no'},0"));
}

sub save_SSLNoCAList
{
	my $self = shift;

return $self->{'in_hash'}->{'SSLNoCAList'} ? ( [ "" ] ) : ( [ ] );
}

sub edit_SSLCACertificatePath
{
	my $self = shift;

return (2, $self->{'text_hash'}->{'mod_apachessl_capath'},
	$self->opt_input($_[0]->{'value'}, "SSLCACertificatePath", $self->{'text_hash'}->{'mod_ssl_default'}, 35).
	$self->file_chooser_button("SSLCACertificatePath", 0));
}

sub save_SSLCACertificatePath
{
	my $self = shift;

return $self->parse_opt("SSLCACertificatePath", '\S', $self->{'text_hash'}->{'mod_ssl_ecfile'});
}

sub edit_SSLCACertificateFile
{
	my $self = shift;

return (2, $self->{'text_hash'}->{'mod_apachessl_cafile'},
	$self->opt_input($_[0]->{'value'}, "SSLCACertificateFile", $self->{'text_hash'}->{'mod_ssl_default'}, 35).
	$self->file_chooser_button("SSLCACertificateFile", 0));
}

sub save_SSLCACertificateFile
{
	my $self = shift;

return $self->parse_opt("SSLCACertificateFile", '\S', $self->{'text_hash'}->{'mod_ssl_ecfile'});
}

sub edit_SSLVerifyClient
{
	my $self = shift;

return (1, $self->{'text_hash'}->{'mod_ssl_clcert'},
	$self->select_input($_[0]->{'value'}, "SSLVerifyClient", "",
		      "$self->{'text_hash'}->{'default'},", "$self->{'text_hash'}->{'mod_ssl_nreq'},",
		      "$self->{'text_hash'}->{'mod_ssl_opt'},1",
		      "$self->{'text_hash'}->{'mod_ssl_req'},2",
		      "$self->{'text_hash'}->{'mod_ssl_optca'},3"));
}

sub save_SSLVerifyClient
{
	my $self = shift;

return $self->parse_select("SSLVerifyClient");
}

sub edit_SSLVerifyDepth
{
	my $self = shift;

return (1, $self->{'text_hash'}->{'mod_ssl_cdepth'},
	$self->opt_input($_[0]->{'value'}, "SSLVerifyDepth", $self->{'text_hash'}->{'mod_ssl_default'}, 6));
}

sub save_SSLVerifyDepth
{
	my $self = shift;

return $self->parse_opt("SSLVerifyDepth", '^\d+$', $self->{'text_hash'}->{'mod_ssl_ecdepth'});
}

sub edit_SSLExportClientCertificates
{
	my $self = shift;

return (1, $self->{'text_hash'}->{'mod_apachessl_exportcert'},
	$self->choice_input($_[0] ? 1 : 0, "SSLExportClientCertificates", "",
		      "$self->{'text_hash'}->{'yes'},1", "$self->{'text_hash'}->{'no'},0"));
}

sub save_SSLExportClientCertificates
{
	my $self = shift;

return $self->{'in_hash'}->{'SSLExportClientCertificates'} ? ( [ "" ] ) : ( [ ] );
}

sub edit_SSLSessionCacheTimeout
{
	my $self = shift;

return (1, $self->{'text_hash'}->{'mod_apachessl_sesstimeout'},
	$self->opt_input($_[0]->{'value'}, "SSLSessionCacheTimeout", $self->{'text_hash'}->{'mod_ssl_default'}, 6));
}

sub save_SSLSessionCacheTimeout
{
	my $self = shift;

return $self->parse_opt("SSLSessionCacheTimeout", '^\d+$', $self->{'text_hash'}->{'mod_ssl_esesstimeout'});
}

sub edit_SSLCheckClientDN
{
	my $self = shift;

return (1, $self->{'text_hash'}->{'mod_apachessl_cdnfile'},
	$self->opt_input($_[0]->{'value'}, "SSLCheckClientDN", $self->{'text_hash'}->{'mod_ssl_default'}, 35).
	$self->file_chooser_button("SSLCheckClientDN", 0));
}

sub save_SSLCheckClientDN
{
	my $self = shift;

return $self->parse_opt("SSLCheckClientDN", '\S', $self->{'text_hash'}->{'mod_apachessl_ecdnfile'});
}

sub edit_SSLFakeBasicAuth
{
	my $self = shift;

return (1, $self->{'text_hash'}->{'mod_apachessl_fake'},
	$self->choice_input($_[0] ? 1 : 0, "SSLFakeBasicAuth", "",
		      "$self->{'text_hash'}->{'yes'},1", "$self->{'text_hash'}->{'no'},0"));
}

sub save_SSLFakeBasicAuth
{
	my $self = shift;

return $self->{'in_hash'}->{'SSLFakeBasicAuth'} ? ( [ "" ] ) : ( [ ] );
}

sub edit_SSLUseCRL
{
	my $self = shift;

return (1, $self->{'text_hash'}->{'mod_apachessl_usecrl'},
	$self->choice_input($_[0] ? 1 : 0, "SSLUseCRL", "",
		      "$self->{'text_hash'}->{'yes'},1", "$self->{'text_hash'}->{'no'},0"));
}

sub save_SSLUseCRL
{
	my $self = shift;

return $self->{'in_hash'}->{'SSLUseCRL'} ? ( [ "" ] ) : ( [ ] );
}

sub edit_SSLCRLCheckAll
{
	my $self = shift;

return (1, $self->{'text_hash'}->{'mod_apachessl_crlcheckall'},
	$self->choice_input($_[0] ? 1 : 0, "SSLCRLCheckAll", "",
		      "$self->{'text_hash'}->{'yes'},1", "$self->{'text_hash'}->{'no'},0"));
}

sub save_SSLCRLCheckAll
{
	my $self = shift;

return $self->{'in_hash'}->{'SSLCRLCheckAll'} ? ( [ "" ] ) : ( [ ] );
}

sub edit_SSLOnNoCRLSetEnv
{
	my $self = shift;

return (1, $self->{'text_hash'}->{'mod_apachessl_onnocrl'},
	$self->opt_input($_[0]->{'value'}, "SSLOnNoCRLSetEnv", $self->{'text_hash'}->{'mod_ssl_default'}, 6));
}

sub save_SSLOnNoCRLSetEnv
{
	my $self = shift;

return $self->parse_choice("SSLOnNoCRLSetEnv");
}

sub edit_SSLOnCRLExpirySetEnv
{
	my $self = shift;

return (1, $self->{'text_hash'}->{'mod_apachessl_oncrlexpiry'},
	$self->opt_input($_[0]->{'value'}, "SSLOnCRLExpirySetEnv", $self->{'text_hash'}->{'mod_ssl_default'}, 6));
}

sub save_SSLOnCRLExpirySetEnv
{
	my $self = shift;

return $self->parse_choice("SSLOnCRLExpirySetEnv");
}

sub edit_SSLOnRevocationSetEnv
{
	my $self = shift;

return (1, $self->{'text_hash'}->{'mod_apachessl_onrevocation'},
	$self->opt_input($_[0]->{'value'}, "SSLOnRevocationSetEnv", $self->{'text_hash'}->{'mod_ssl_default'}, 6));
}

sub save_SSLOnRevocationSetEnv
{
	my $self = shift;

return $self->parse_choice("SSLOnRevocationSetEnv");
}

sub edit_SSLRequiredCiphers
{
	my $self = shift;

local $rows = 3;
local $sw = 0;
local ($o, $i, $l, $rv);
$l = ':'.$_[0]->{'value'}.':';
$rv .= "<table border><tr><td><table cellpadding=0>\n";
for($i=0; $i<@{$self->{'mod_apachessl_ciphers_array'}}; $i++) {
	$rv .= $sw ? '' : '<tr>';
	$o = $self->{'mod_apachessl_ciphers_array'}->[$i];
	$rv .= sprintf "<td><input type=checkbox name=SSLRequiredCiphers_%s value='%s' %s> %s</td>",
			$o, $o, index($l, ":$o:") < 0 ? "" : "checked", $o;
	$rv .= $sw eq $rows-1 ? "</tr>\n" : '';
	$sw = $sw eq $rows-1 ? 0 : $sw+1;
	}
for($i=$sw; $i<=$rows-1; $i++) {
	$rv .= '<td>&nbsp;</td>';
	}
$rv .= $sw eq $rows-1 ? '' : "</tr>\n";
$rv .= '</table></td></tr></table>';
return (2,"$self->{'text_hash'}->{'mod_apachessl_requiredcifher'}",$rv);
}

sub save_SSLRequiredCiphers
{
	my $self = shift;

local ($i, $rv);
for($i=0; $i<@{$self->{'mod_apachessl_ciphers_array'}}; $i++) {
	$rv .= $self->{'in_hash'}->{"SSLRequiredCiphers_".$self->{'mod_apachessl_ciphers_array'}->[$i]} ? ':'.$self->{'mod_apachessl_ciphers_array'}->[$i] : '';
	}
return $rv ? ( [ substr($rv,1) ] ) : ( [ ] );
}

sub edit_SSLRequireCipher
{
	my $self = shift;

local $rows = 3;
local $sw = 0;
local ($o, $i, $l, $rv);
$l = ' '.$_[0]->{'value'}.' ';
$rv .= "<table border><tr><td><table cellpadding=0>\n";
for($i=0; $i<@{$self->{'mod_apachessl_ciphers_array'}}; $i++) {
	$rv .= $sw ? '' : '<tr>';
	$o = $self->{'mod_apachessl_ciphers_array'}->[$i];
	$rv .= sprintf "<td><input type=checkbox name=SSLRequireCipher_%s value='%s' %s> %s</td>",
			$o, $o, index($l, " $o ") < 0 ? "" : "checked", $o;
	$rv .= $sw eq $rows-1 ? "</tr>\n" : '';
	$sw = $sw eq $rows-1 ? 0 : $sw+1;
	}
for($i=$sw; $i<=$rows-1; $i++) {
	$rv .= '<td>&nbsp;</td>';
	}
$rv .= $sw eq $rows-1 ? '' : "</tr>\n";
$rv .= '</table></td></tr></table>';
return (2,"$self->{'text_hash'}->{'mod_apachessl_requirecifher'}",$rv);
}

sub save_SSLRequireCipher
{
	my $self = shift;

local ($i, $rv);
for($i=0; $i<@{$self->{'mod_apachessl_ciphers_array'}}; $i++) {
	$rv .= $self->{'in_hash'}->{"SSLRequireCipher_".$self->{'mod_apachessl_ciphers_array'}->[$i]} ? ' '.$self->{'mod_apachessl_ciphers_array'}->[$i] : '';
	}
return $rv ? ( [ substr($rv,1) ] ) : ( [ ] );
}

sub edit_SSLBanCipher{
local $rows = 3;
local $sw = 0;
local ($o, $i, $l, $rv);
$l = ' '.$_[0]->{'value'}.' ';
$rv .= "<table border><tr><td><table cellpadding=0>\n";
for($i=0; $i<@{$self->{'mod_apachessl_ciphers_array'}}; $i++) {
	$rv .= $sw ? '' : '<tr>';
	$o = $self->{'mod_apachessl_ciphers_array'}->[$i];
	$rv .= sprintf "<td><input type=checkbox name=SSLBanCipher_%s value='%s' %s> %s</td>",
			$o, $o, index($l, " $o ") < 0 ? "" : "checked", $o;
	$rv .= $sw eq $rows-1 ? "</tr>\n" : '';
	$sw = $sw eq $rows-1 ? 0 : $sw+1;
	}
for($i=$sw; $i<=$rows-1; $i++) {
	$rv .= '<td>&nbsp;</td>';
	}
$rv .= $sw eq $rows-1 ? '' : "</tr>\n";
$rv .= '</table></td></tr></table>';
return (2,"$self->{'text_hash'}->{'mod_apachessl_bancifher'}",$rv);
}

sub save_SSLBanCipher
{
	my $self = shift;

local ($i, $rv);
for($i=0; $i<@{$self->{'mod_apachessl_ciphers_array'}}; $i++) {
	$rv .= $self->{'in_hash'}->{"SSLBanCipher_".$self->{'mod_apachessl_ciphers_array'}->[$i]} ? ' '.$self->{'mod_apachessl_ciphers_array'}->[$i] : '';
	}
return $rv ? ( [ substr($rv,1) ] ) : ( [ ] );
}


1;

