#!/usr/bin/perl
package apache::Mod_auth;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'apache::Mod_auth');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# mod_auth.pl
# Defines editors for text-file authentication directives

1;

1;
		return $self;
}

sub mod_auth_directives
{
	my $self = shift;

local($rv);
$rv = [ [ 'AuthUserFile AuthGroupFile AuthAuthoritative', 0, 4, 'directory htaccess' ] ];
return $self->make_directives($rv, $_[0], "mod_auth");
}

sub edit_AuthUserFile_AuthGroupFile_AuthAuthoritative
{
	my $self = shift;

local($rv, $uf, $gf);
$uf = $_[0] && -r "list_authusers.cgi" ? 1 : 0;
$gf = $_[1] && -r "list_authgroups.cgi" ? 1 : 0;
$rv = "<table border><tr><td><table>\n";

$rv .= "<tr> <td><b>$self->{'text_hash'}->{'mod_auth_ufile'}</b></td> <td>".
       $self->opt_input($_[0]->{'value'}, "AuthUserFile", $self->{'text_hash'}->{'default'}, 45).
       $self->file_chooser_button("AuthUserFile", 0).
       ($uf ? "&nbsp;<a href=\"list_authusers.cgi?file=".$_[0]->{'value'}.
       "&url=".$self->urlize($self->this_url())."\">$self->{'text_hash'}->{'mod_auth_uedit'}</a>" : "")."</td></tr>\n";

$rv .= "<tr> <td><b>$self->{'text_hash'}->{'mod_auth_gfile'}</b></td> <td>".
       $self->opt_input($_[1]->{'value'}, "AuthGroupFile", $self->{'text_hash'}->{'default'}, 45).
       $self->file_chooser_button("AuthGroupFile", 0).
       ($gf ? "&nbsp;<a href=\"list_authgroups.cgi?file=".$_[1]->{'value'}.
       "&url=".$self->urlize($self->this_url())."\">$self->{'text_hash'}->{'mod_auth_gedit'}</a>" : "")."</td></tr>\n";

$rv .= "<tr> <td><b>$self->{'text_hash'}->{'mod_auth_pass'}</b></td> <td>".
       $self->choice_input($_[2]->{'value'}, "AuthAuthoritative", "",
       "$self->{'text_hash'}->{'yes'},off", "$self->{'text_hash'}->{'no'},on", "$self->{'text_hash'}->{'default'},").
       "</td> </tr>\n";
$rv .= "</table></td></tr></table>\n";
return (2, "$self->{'text_hash'}->{'mod_auth_auth'}", $rv);
}

sub save_AuthUserFile_AuthGroupFile_AuthAuthoritative
{
	my $self = shift;

$self->{'in_hash'}->{'AuthUserFile_def'} || $self->allowed_auth_file($self->{'in_hash'}->{'AuthUserFile'}) ||
	$self->error($self->{'text_hash'}->{'mod_auth_eudir'});
$self->{'in_hash'}->{'AuthGroupFile_def'} || $self->allowed_auth_file($self->{'in_hash'}->{'AuthGroupFile'}) ||
	$self->error($self->{'text_hash'}->{'mod_auth_egdir'});
return ($self->parse_opt("AuthUserFile", '^\S+$', $self->{'text_hash'}->{'mod_auth_eufile'}) ,
        $self->parse_opt("AuthGroupFile", '^\S+$', $self->{'text_hash'}->{'mod_auth_egfile'}) ,
        $self->parse_choice("AuthAuthoritative", ""));
}


1;

