#!/usr/bin/perl
package apache::Mod_auth_basic;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'apache::Mod_auth_basic');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# mod_auth_basic.pl
# Defines editors for basic authentication directives

1;
		return $self;
}

sub mod_auth_basic_directives
{
	my $self = shift;

local($rv);
$rv = [ [ 'AuthBasicAuthoritative', 0, 4, 'directory htaccess' ],
	[ 'AuthBasicProvider', 0, 4, 'directory htaccess' ],
      ];
return $self->make_directives($rv, $_[0], "mod_auth_basic");
}

sub edit_AuthBasicAuthoritative
{
	my $self = shift;

return (1, $self->{'text_hash'}->{'mod_auth_basic_pass'},
       $self->choice_input($_[0]->{'value'}, "AuthBasicAuthoritative", "",
       "$self->{'text_hash'}->{'yes'},off", "$self->{'text_hash'}->{'no'},on", "$self->{'text_hash'}->{'default'},") );
}

sub save_AuthBasicAuthoritative
{
	my $self = shift;

return $self->parse_choice("AuthBasicAuthoritative", "");
}

sub edit_AuthBasicProvider
{
	my $self = shift;

return (1, $self->{'text_hash'}->{'mod_auth_basic_prov'},
	$self->ui_select("AuthBasicProvider", $_[0] ? $_[0]->{'words'} : [ ],
		   [ [ "file", $self->{'text_hash'}->{'mod_auth_basic_file'} ],
		     [ "dbm", $self->{'text_hash'}->{'mod_auth_basic_dbm'} ] ],
		   3, 1, 1));
}

sub save_AuthBasicProvider
{
	my $self = shift;

local $p = $self->{'in_hash'}->{'AuthBasicProvider'};
return ( $p ? [ join(" ", split(/\0/, $p)) ] : [ ] );
}


1;

