#!/usr/bin/perl
package apache::Mod_auth_dbm;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'apache::Mod_auth_dbm');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# mod_auth_dbm.pl
# Defines editors for DBM file authentication directives

1;

1;
		return $self;
}

sub mod_auth_dbm_directives
{
	my $self = shift;

local($rv);
$rv = [ [ 'AuthDBMUserFile AuthDBMGroupFile AuthDBMAuthoritative', 0, 4, 'directory htaccess' ],
	[ 'AuthDBMType', 0, 4, 'directory htaccess', 2.030, -1 ] ];
return $self->make_directives($rv, $_[0], "mod_auth_dbm");
}

sub edit_AuthDBMUserFile_AuthDBMGroupFile_AuthDBMAuthoritative
{
	my $self = shift;

local($rv, $uf, $gf);
$uf = $_[0] ? 1 : 0; $gf = $_[1] ? 1 : 0;
$rv = "<table border><tr><td><table>\n";

$rv .= "<tr> <td><b>$self->{'text_hash'}->{'mod_auth_dbm_ufile'}</b></td> <td>".
       $self->opt_input($_[0]->{'value'}, "AuthDBMUserFile", $self->{'text_hash'}->{'default'}, 25).
       $self->file_chooser_button("AuthDBMUserFile", 0)."</td></tr>\n";

$rv .= "<tr> <td><b>$self->{'text_hash'}->{'mod_auth_dbm_gfile'}</b></td> <td>".
       $self->opt_input($_[1]->{'value'}, "AuthDBMGroupFile", $self->{'text_hash'}->{'default'}, 25).
       $self->file_chooser_button("AuthDBMGroupFile", 0)."</td></tr>\n";

$rv .= "<tr> <td><b>$self->{'text_hash'}->{'mod_auth_dbm_pass'}</b></td> <td>".
       $self->choice_input($_[2]->{'value'}, "AuthDBMAuthoritative", "",
       "$self->{'text_hash'}->{'yes'},off", "$self->{'text_hash'}->{'no'},on", "$self->{'text_hash'}->{'default'},").
       "</td> </tr>\n";
$rv .= "</table></td></tr></table>\n";
return (2, $self->{'text_hash'}->{'mod_auth_dbm_auth'}, $rv);
}

sub save_AuthDBMUserFile_AuthDBMGroupFile_AuthDBMAuthoritative
{
	my $self = shift;

local(@rv);
@rv = ($self->parse_opt("AuthDBMUserFile", '^\S+$', $self->{'text_hash'}->{'mod_auth_dbm_eufile'}) ,
       $self->parse_opt("AuthDBMGroupFile", '^\S+$', $self->{'text_hash'}->{'mod_auth_dbm_egfile'}) ,
       $self->parse_choice("AuthDBMAuthoritative", ""));
return @rv;
}

sub edit_AuthDBMType
{
	my $self = shift;

return (1, $self->{'text_hash'}->{'mod_auth_dbm_type'},
	$self->select_input($_[0]->{'value'}, "AuthDBMType", "",
		      "$self->{'text_hash'}->{'default'},", "GDBM,GDBM", "SDBM,SDBM", "DB,DB",
		      "$self->{'text_hash'}->{'mod_auth_dbm_default'},default"));
}

sub save_AuthDBMType
{
	my $self = shift;

return $self->parse_select("AuthDBMType", "");
}


1;

