#!/usr/bin/perl
package apache::Mod_authn_dbm;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'apache::Mod_authn_dbm');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# mod_authn_dbm.pl
# Defines editors for user text-file authentication directives

1;
		return $self;
}

sub mod_authn_dbm_directives
{
	my $self = shift;

local($rv);
$rv = [ [ 'AuthDBMUserFile', 0, 4, 'directory htaccess' ],
	[ 'AuthDBMType', 0, 4, 'directory htaccess', 2.030, -1 ] ];
return $self->make_directives($rv, $_[0], "mod_authn_dbm");
}

sub edit_AuthDBMUserFile
{
	my $self = shift;

return (2, $self->{'text_hash'}->{'mod_auth_dbm_ufile'},
       $self->opt_input($_[0]->{'value'}, "AuthDBMUserFile", $self->{'text_hash'}->{'default'}, 45).
       $self->file_chooser_button("AuthDBMUserFile", 0));
}

sub save_AuthDBMUserFile
{
	my $self = shift;

$self->{'in_hash'}->{'AuthDBMUserFile_def'} || $self->allowed_auth_file($self->{'in_hash'}->{'AuthDBMUserFile'}) ||
        $self->error($self->{'text_hash'}->{'mod_auth_eudir'});
return $self->parse_opt("AuthDBMUserFile", '^\S+$', $self->{'text_hash'}->{'mod_auth_dbm_eufile'});
}

sub edit_AuthDBMType
{
	my $self = shift;

return (1, $self->{'text_hash'}->{'mod_auth_dbm_type'},
	$self->select_input($_[0]->{'value'}, "AuthDBMType", "",
		      "$self->{'text_hash'}->{'default'},", "GDBM,GDBM", "SDBM,SDBM",
					   "NDBM,NDBM", "DB,DB",
		      "$self->{'text_hash'}->{'mod_auth_dbm_default'},default"));
}

sub save_AuthDBMType
{
	my $self = shift;

return $self->parse_select("AuthDBMType", "");
}


1;

