#!/usr/bin/perl
package apache::Mod_autoindex;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'apache::Mod_autoindex');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# mod_autoindex.pl
# Defines editors automatic index generation

&ModuleLoader::preload_module(ref($self), "apache::Autoindex");
$self = new apache::Autoindex:: ref($self), %$self; 

1;

1;
		return $self;
}

sub mod_autoindex_directives
{
	my $self = shift;

local($rv, $all); $all = 'virtual directory htaccess';
$rv = [ [ 'AddIcon AddIconByType AddIconByEncoding', 1, 12, $all, 1.3, 1 ],
        [ 'DefaultIcon', 0, 12, $all, 1.3, 5 ],
        [ 'AddAlt AddAltByType AddAltByEncoding', 1, 12, $all, 1.3 ],
        [ 'AddDescription', 1, 12, $all, 1.3 ],
        [ 'IndexOptions FancyIndexing', 0, 12, $all, 1.3, 10 ],
        [ 'HeaderName', 0, 12, $all, 1.3, 4 ],
        [ 'ReadmeName', 0, 12, $all, 1.3, 3 ],
        [ 'IndexIgnore', 1, 12, $all, 1.3, 6 ],
	[ 'IndexOrderDefault', 0, 12, $all, 1.304, 2 ] ];
return $self->make_directives($rv, $_[0], "mod_autoindex");
}

sub edit_IndexOrderDefault
{
	my $self = shift;

local $rv = sprintf
	"<input type=radio name=IndexOrderDefault_def value=1 %s> $self->{'text_hash'}->{'mod_autoindex_default'}\n",
	$_[0] ? "" : "checked";
$rv .= sprintf "<input type=radio name=IndexOrderDefault_def value=0 %s>\n",
	$_[0] ? "checked" : "";
$rv .= "<select name=IndexOrderDefault_asc>\n";
$rv .= sprintf "<option value=Ascending %s>$self->{'text_hash'}->{'mod_autoindex_asc'}\n",
		$_[0]->{'words'}->[0] eq "Ascending" ? "selected" : "";
$rv .= sprintf "<option value=Descending %s>$self->{'text_hash'}->{'mod_autoindex_descend'}\n",
		$_[0]->{'words'}->[0] eq "Descending" ? "selected" : "";
$rv .= "</select>\n";
$rv .= "<select name=IndexOrderDefault_what>\n";
$rv .= sprintf "<option value=Name %s>$self->{'text_hash'}->{'mod_autoindex_name'}\n",
		$_[0]->{'words'}->[1] eq "Name" ? "selected" : "";
$rv .= sprintf "<option value=Date %s>$self->{'text_hash'}->{'mod_autoindex_date'}\n",
		$_[0]->{'words'}->[1] eq "Date" ? "selected" : "";
$rv .= sprintf "<option value=Size %s>$self->{'text_hash'}->{'mod_autoindex_size'}\n",
		$_[0]->{'words'}->[1] eq "Size" ? "selected" : "";
$rv .= sprintf "<option value=Description %s>$self->{'text_hash'}->{'mod_autoindex_desc'}\n",
		$_[0]->{'words'}->[1] eq "Description" ? "selected" : "";
$rv .= "</select>\n";
return (2, "$self->{'text_hash'}->{'mod_autoindex_sort'}", $rv);
}

sub save_IndexOrderDefault
{
	my $self = shift;

if ($self->{'in_hash'}->{'IndexOrderDefault_def'}) { return ( [ ] ); }
else { return ( [ "$self->{'in_hash'}->{'IndexOrderDefault_asc'} $self->{'in_hash'}->{'IndexOrderDefault_what'}" ] ); }
}


1;

