#!/usr/bin/perl
package apache::Mod_bandwidth;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'apache::Mod_bandwidth');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# mod_bandwidth.pl
# Editors for bandwidth-limiting directives

1;

1;
		return $self;
}

sub mod_bandwidth_directives
{
	my $self = shift;

local $rv;
$rv = [ [ 'BandWidthDataDir', 0, 1, 'global', undef, -1 ],
	[ 'BandWidthModule', 0, 1, 'virtual' ],
	[ 'BandWidth', 1, 1, 'directory htaccess' ],
	[ 'LargeFileLimit', 1, 1, 'directory htaccess' ],
	[ 'MaxConnection', 0, 1, 'directory htaccess' ],
#	[ 'MinBandWidth', 1, 1, 'directory htaccess' ]
	[ 'BandWidthPulse', 0, 1, 'virtual' ]
      ];
return $self->make_directives($rv, $_[0], "mod_bandwidth");
}

sub edit_BandWidthDataDir
{
	my $self = shift;

return (2,
	$self->{'text_hash'}->{'mod_band_dir'},
	$self->opt_input($_[0]->{'value'}, "BandWidthDataDir", $self->{'text_hash'}->{'default'}, 40));
}

sub save_BandWidthDataDir
{
	my $self = shift;

if (!$self->{'in_hash'}->{'BandWidthDataDir_def'}) {
	-d $self->{'in_hash'}->{'BandWidthDataDir'} || $self->error($self->{'text_hash'}->{'mod_band_edir'});
	local $sd;
	foreach $sd ('master', 'link') {
		-d "$self->{'in_hash'}->{'BandWidthDataDir'}/$sd" ||
			$self->error($self->text('mod_band_esubdir', $sd));
		}
	}
return $self->parse_opt("BandWidthDataDir");
}

sub edit_BandWidthModule
{
	my $self = shift;

return (1, $self->{'text_hash'}->{'mod_band_enable'},
	$self->choice_input($_[0]->{'value'}, "BandWidthModule", "",
	      "$self->{'text_hash'}->{'yes'},on", "$self->{'text_hash'}->{'no'},off", "$self->{'text_hash'}->{'default'},"));
}

sub save_BandWidthModule
{
	my $self = shift;

return $self->parse_choice("BandWidthModule");
}

sub edit_BandWidth
{
	my $self = shift;

local ($rv, $i, $max);
$rv = "<table border>\n".
      "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'mod_band_bw'}</b></td>\n".
      "<td><b>$self->{'text_hash'}->{'mod_band_client'}</b></td> </tr>\n";
$max = @{$_[0]}+1;
for($i=0; $i<$max; $i++) {
	$rv .= "<tr $self->{'cb'}>\n";
	$rv .= "<td><input name=BandWidth_bw_$i size=10 ".
	       "value=\"$_[0]->[$i]->{'words'}->[1]\"></td>\n";
	local $client = $_[0]->[$i]->{'words'}->[0];
	$rv .= sprintf
	        "<td><input type=radio name=BandWidth_all_$i value=1 %s> $self->{'text_hash'}->{'mod_band_all'}\n",
	        $client eq "all" ? "checked" : "";
	$rv .= sprintf
	        "<input type=radio name=BandWidth_all_$i value=0 %s> $self->{'text_hash'}->{'mod_band_ent'}\n",
	        $client eq "all" ? "" : "checked";
	$rv .= sprintf
	        "<input name=BandWidth_$i size=20 value=\"%s\"></td>\n",
	        $client eq "all" ? "" : $client;
	$rv .= "</tr>\n";
	}
$rv .= "</table>\n";
return (2, $self->{'text_hash'}->{'mod_band_bandwidth'}, $rv);
}

sub save_BandWidth
{
	my $self = shift;

local ($i, $bw, $client, $all, @rv);
for($i=0; defined($bw = $self->{'in_hash'}->{"BandWidth_bw_$i"}); $i++) {
	$client = $self->{'in_hash'}->{"BandWidth_$i"};
	$all = $self->{'in_hash'}->{"BandWidth_all_$i"};
	next if ($bw eq "");
	$bw =~ /^\d+$/ || $self->error($self->text('mod_band_ebw', $bw));
	$all || $client =~ /^[a-z0-9\.\-\_\/]+$/i ||
		$self->error($self->text('mod_band_eclient', $bw));
	push(@rv, ($all ? "all" : $client)." ".$bw);
	}
return ( \@rv );
}

sub edit_LargeFileLimit
{
	my $self = shift;

local ($rv, $i, $max);
$rv = "<table border>\n".
      "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'mod_band_bw'}</b></td>\n".
      "<td><b>$self->{'text_hash'}->{'mod_band_size'}</b></td> </tr>\n";
$max = @{$_[0]}+1;
for($i=0; $i<$max; $i++) {
	$rv .= "<tr $self->{'cb'}>\n";
	$rv .= "<td><input name=LargeFileLimit_bw_$i size=10 ".
	       "value=\"$_[0]->[$i]->{'words'}->[1]\"></td>\n";
	$rv .= "<td><input name=LargeFileLimit_$i size=10 ".
	       "value=\"$_[0]->[$i]->{'words'}->[0]\"></td>\n";
	$rv .= "</tr>\n";
	}
$rv .= "</table>\n";
return (2, $self->{'text_hash'}->{'mod_band_sizelimit'}, $rv);
}

sub save_LargeFileLimit
{
	my $self = shift;

local ($i, $bw, $size, @rv);
for($i=0; defined($bw = $self->{'in_hash'}->{"LargeFileLimit_bw_$i"}); $i++) {
	$size = $self->{'in_hash'}->{"LargeFileLimit_$i"};
	next if ($bw eq "");
	$bw =~ /^\d+$/ || $self->error($self->text('mod_band_ebw', $bw));
	$size =~ /^\d+$/ || $size == -1 || $self->error($self->text('mod_band_esize', $bw));
	push(@rv, "$size $bw");
	}
return ( \@rv );
}

sub edit_MaxConnection
{
	my $self = shift;

return (1,
	$self->{'text_hash'}->{'mod_band_max'},
	$self->opt_input($_[0]->{'value'}, "MaxConnections", $self->{'text_hash'}->{'default'}, 4));
}

sub save_MaxConnection
{
	my $self = shift;

return $self->parse_opt("MaxConnections", '^\d+$',
		  $self->{'text_hash'}->{'mod_band_emax'});
}

sub edit_BandWidthPulse
{
	my $self = shift;

return (1,
	$self->{'text_hash'}->{'mod_band_pulse'},
	$self->opt_input($_[0]->{'value'}, "BandWidthPulse", $self->{'text_hash'}->{'default'}, 4));
}

sub save_BandWidthPulse
{
	my $self = shift;

return $self->parse_opt("BandWidthPulse", '^\d+$',
		  $self->{'text_hash'}->{'mod_band_epulse'});
}


1;

