#!/usr/bin/perl
package apache::Mod_cpplus;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'apache::Mod_cpplus');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# mod_alias.pl
# In this part are defined options to work with Advanced Website Settings

1;
1;
		return $self;
}

sub mod_cpplus_directives
{
	my $self = shift;

local $rv = [
	[ 'AddType', 1, 101, 'virtual directory htaccess', undef ],
	[ 'Redirect', 1, 102, 'virtual directory htaccess', 1.2 ],
	[ 'Alias', 1, 103, 'virtual' ],
	[ 'AddHandler', 1, 104, 'virtual directory htaccess', undef ], 
	[ 'ErrorDocument', 1, 105, 'virtual apache_errordoc' ]
	];

return $self->make_directives($rv, $_[0], "mod_cpplus");
}

# generate_inputs_home(&editors, &directives)
# Displays a one column list of options, for use inside a table
sub generate_inputs_home
{
	my $self = shift;

local($e, $sw, @args, @rv, $func, $lastsub);
foreach $e (@{$_[0]}) {
	if (defined($lastsub) && $lastsub != $e->{'subtype'}) {
		print "<tr><td colspan=4><hr></td></tr>\n";
		}
	$lastsub = $e->{'subtype'};
	if (!$sw) { print "<tr $self->{'cb'}>\n"; }

	# Build arg list for the editing function. Each arg can be a single
	# directive struct, or a reference to an array of structures.
	$func = "edit";
	undef(@args);
	foreach $ed (split(/\s+/, $e->{'name'})) {
		local(@vals);
		$func .= "_$ed";
		@vals = $self->find_directive_struct($ed, $_[1]);
		if ($e->{'multiple'}) { push(@args, \@vals); }
		elsif (!@vals) { push(@args, undef); }
		else { push(@args, $vals[$#vals]); }
		}
	push(@args, $e);

	# call the function
	@rv = $self->$func(@args);
	#print "0: $rv[0] : 1: $rv[1]<br>";
	local $names;
	if ($self->{'mconfig_hash'}->{'show_names'} || $self->{'userconfig_hash'}->{'show_names'}) {
		$names = " (";
		foreach $ed (split(/\s+/, $e->{'name'})) {
			# nodo50 v0.1 - Change 000004 - Open new window for Help in Apache module and mod_apachessl Help from http://www.apache-ssl.org and
			# nodo50 v0.1 - Change 000004 - Abre nueva ventana para Ayuda del mdulo Apache y para mod_apachessl busca la Ayuda en http://www.apache-ssl.org and
			$names .= "<tt><a href='".($e->{'module'} eq 'mod_apachessl' ? 'http://www.apache-ssl.org/docs.html#'.$ed : $self->{'apache_docbase'}."/".$e->{'module'}.".html#".lc($ed))."'>".$ed."</a></tt> ";
			#$names .= "<tt><a href='".$self->{'apache_docbase'}."/".$e->{'module'}.".html#".lc($ed)."'>".$ed."</a></tt> ";
			# nodo50 v0.1 - Change 000004 - End
			}
		$names .= ")";
		}
	if ($rv[0] >= 2) {
		# spans 2 columns..
		if ($sw) {
			# need to end this row
			print "<td colspan=2></td> </tr><tr>\n";
			}
		else { $sw = !$sw; }
		if ($rv[0] == 3) {
			# Takes up whole row
			print "<td colspan=4>$rv[2]</td>\n";
			}
		else {
			# Has title on left
			#print "<td valign=top align=left colspan=4><b>$rv[1]</b>$names</td></tr>\n";
			print "<td nowrap valign=top colspan=4>$rv[2]</td>\n";
			#print "<td valign=top align=left width=25%><b>$rv[1]</b>$names</td>\n";
			#print "<td nowrap valign=top colspan=3 width=75%>$rv[2]</td>\n";
			}
		}
	else {
		# only spans one column
		print "<td valign=top align=left width=25%><b>$rv[1]</b>$names</td>\n";
		print "<td nowrap valign=top width=25%>$rv[2]</td>\n";
		print "<td colspan=2>&nbsp;</td>\n";
		$sw = 1;
		#print "<td valign=top align=left width=25%><b>$rv[1]</b>$names</td>\n";
		#print "<td nowrap valign=top width=25%>$rv[2]</td>\n";
		}

	if ($sw) { print "</tr>\n"; }
	$sw = !$sw;
	}
}

# generate_outputs_hand(&editors, &directives)
# Displays a 2-column list of options, for use inside a table
sub generate_outputs_hand
{
	my $self = shift;

local($e, $sw, @args, @rv, $func, $lastsub);
@{$self->{'mas_array'}} = @{$_[0]};
$e = $self->{'mas_array'}->[0];

#if (defined($lastsub) && $lastsub != $e->{'subtype'}) {
#	print "<tr> <td colspan=4><hr></td> </tr>\n";
#	}
$lastsub = $e->{'subtype'};

# Build arg list for the editing function. Each arg can be a single
# directive struct, or a reference to an array of structures.
$func = "edit";
undef(@args);
foreach $ed (split(/\s+/, $e->{'name'})) {
	local(@vals);
	$func .= "_$ed";
	@vals = $self->find_directive_struct($ed, $_[1]);
	if ($e->{'multiple'}) { push(@args, \@vals); }
	elsif (!@vals) { push(@args, undef); }
	else { push(@args, $vals[$#vals]); }
	}
push(@args, $e);

print "<h3>$self->{'text_hash'}->{global_handlers_list}</h3>";
print "<hr>";

print  $self->handler_output('imap-file', 'AddHandler_type_0');

}

sub handler_output
{
	my $self = shift;

local($m, $func, @hl, $rv, $h);
local $conf = $self->get_config();
push(@hl, "");
foreach $m (keys %{$self->{'httpd_modules_hash'}}) {
	$func = $m."_handlers";
	if ($self->foreign_defined('apache', $func)) {
		push(@hl, $self->foreign_call('apache', $func, $conf, $self->{'httpd_modules_hash'}->{$m}));
		}
	}

if ($self->indexof($_[0], @hl) < 0) { push(@hl, $_[0]); }

local $lnk_val;
@{$self->{'ar_array'}} = @{$args[0]};

 $rv .= "<TABLE border=1 width=100%>\n";
 $rv .= "<tr $self->{'tb'}>";
 $rv .= "<td width=25%><b>$self->{'text_hash'}->{'mod_mime_handler'}</b></td><td><b>$self->{'text_hash'}->{'mod_mime_ext'}</b></td>";
 $rv .= "<td width=25%><b>$self->{'text_hash'}->{'mod_mime_handler'}</b></td>";
 $rv .= "<td><b>$self->{'text_hash'}->{'mod_mime_ext'}</b></td>";
 $rv .= "</tr>";
 $self->{'sw'} = 1;
 foreach $h ($self->unique(@hl)) {
 		if ($h) {
 		if ($self->{'sw'}) { $rv .= "<tr $self->{'cb'}>"; }
 		$lnk_val = "&nbsp;";
 		foreach $value (@{$self->{'ar_array'}}) {
 			@{$self->{'val_array'}} = split (/\s+/, $value->{value});
 			if ($self->{'val_array'}->[0] eq $h) {
 				   $lnk_val = $self->{'val_array'}->[1];
 				}
 			}
 	   	$rv .= "<td>$h</td><td>$lnk_val</td>";
 		if (!$self->{'sw'}) { $rv .= "</tr>"; }
 		$self->{'sw'} = !($self->{'sw'});
 		}
 	}
 if (!$self->{'sw'}) {$rv .= "<td>&nbsp;</td><td>&nbsp;</td></tr>";}
 $rv .= "</TABLE>\n";
return $rv;
}

# Error handling directives
sub edit_ErrorDocument {
	my $self = shift;

local($rv, $len, $i);
$rv = "<table border width=100%>\n";
$rv .= "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'core_error'}</b></td> <td><b>$self->{'text_hash'}->{'core_resp'}</b></td> ".
       "<td><b>$self->{'text_hash'}->{'core_urlmsg'}</b></td> </tr>\n";
$len = @{$_[0]} + 1;
for($i=0; $i<$len; $i++) {
	$self->{'v'} = $_[0]->[$i]->{'value'};
	if ($self->{'v'} =~ /^(\d+)\s+((http|ftp|gopher):\S+)$/)
		{ $self->{'code'} = $1; $self->{'type'} = 0; $self->{'url'} = $2; }
	elsif ($self->{'v'} =~ /^(\d+)\s+(\/.*)$/) { $self->{'code'} = $1; $self->{'type'} = 0; $self->{'url'} = $2; }
	elsif ($self->{'v'} =~ /^(\d+)\s+"(.*)"$/) { $self->{'code'} = $1; $self->{'type'} = 1; $self->{'url'} = $2; }
	elsif ($self->{'v'} =~ /^(\d+)\s+"?(.*)$/) { $self->{'code'} = $1; $self->{'type'} = 1; $self->{'url'} = $2; }
	else { $self->{'code'} = ""; $self->{'type'} = 0; $self->{'url'} = ""; }
	$rv .= "<tr $self->{'cb'}>\n";
	$rv .= "<td><input name=ErrorDocument_code_$i size=3 value=$self->{'code'}></td>\n";
	$rv .= "<td><input type=radio name=ErrorDocument_type_$i value=0 ".
	       ($self->{'type'}==0 ? "checked" : "").">$self->{'text_hash'}->{'core_tourl'}\n";
	$rv .= "<input type=radio name=ErrorDocument_type_$i value=1 ".
	       ($self->{'type'}==1 ? "checked" : "").">$self->{'text_hash'}->{'core_mesg'}</td>\n";
	$rv .= "<td><input name=ErrorDocument_url_$i size=40 value=\"$self->{'url'}\"></td>\n";
	$rv .= "</tr>\n";
	}
$rv .= "</table>\n";
return (2, $self->{'text_hash'}->{'core_custom'}, $rv);
}


1;

