#!/usr/bin/perl
package apache::Mod_dir;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'apache::Mod_dir');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# mod_dir.pl
# Defines editors for mod_dir directives

&ModuleLoader::preload_module(ref($self), "apache::Autoindex");
$self = new apache::Autoindex:: ref($self), %$self; 

1;

1;
		return $self;
}

sub mod_dir_directives
{
	my $self = shift;

local($rv, $all); $all = 'virtual directory htaccess';
$rv = [ [ 'DirectoryIndex', 0, 12, 'virtual directory htaccess', undef, 8 ],
	[ 'AddIcon AddIconByType AddIconByEncoding', 1, 12, $all, -1.3, 1 ],
        [ 'DefaultIcon', 0, 12, $all, -1.3, 4 ],
        [ 'AddAlt AddAltByType AddAltByEncoding', 1, 12, $all, -1.3 ],
        [ 'AddDescription', 1, 12, $all, -1.3 ],
        [ 'IndexOptions FancyIndexing', 0, 12, $all, -1.3, 10 ],
        [ 'HeaderName', 0, 12, $all, -1.3, 3 ],
        [ 'ReadmeName', 0, 12, $all, -1.3, 2 ],
        [ 'IndexIgnore', 1, 12, $all, -1.3, 6 ] ];
return $self->make_directives($rv, $_[0], "mod_dir");
}

sub edit_DirectoryIndex
{
	my $self = shift;

local($rv);
$rv = sprintf "<textarea name=DirectoryIndex rows=5 cols=20>%s</textarea>\n",
        join("\n", split(/\s+/, $_[0]->{'value'}));
return (1, "$self->{'text_hash'}->{'mod_dir_txt'}", $rv);
}

sub save_DirectoryIndex
{
	my $self = shift;

local(@di);
@di = split(/\s+/, $self->{'in_hash'}->{'DirectoryIndex'});
return @di ? ( [ join(' ', @di) ] ) : ( [ ] );
}


1;

