#!/usr/bin/perl
package apache::Mod_disk_cache;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'apache::Mod_disk_cache');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# mod_disk_cache.pl
# Disk-caching related functions

&ModuleLoader::preload_module(ref($self), "apache::Cache");
$self = new apache::Cache:: ref($self), %$self; 

# XXX new stuff in mod_proxy

1;
		return $self;
}

sub mod_disk_cache_directives
{
	my $self = shift;

local $rv;
$rv = [ [ 'CacheRoot', 0, 13.1, 'virtual', 2.0 ],
        [ 'CacheSize', 0, 13.1, 'virtual', 2.0 ],
        [ 'CacheGcInterval', 0, 13.1, 'virtual', 2.0 ],
        [ 'CacheDirLevels', 0, 13.1, 'virtual', 2.0 ],
        [ 'CacheDirLength', 0, 13.1, 'virtual', 2.0 ],
	[ 'CacheMinFileSize', 0, 13.1, 'virtual', 2.0 ],
	[ 'CacheMaxFileSize', 0, 13.1, 'virtual', 2.0 ] ];
return $self->make_directives($rv, $_[0], "mod_disk_cache");
}

sub edit_CacheMinFileSize
{
	my $self = shift;

return (1, $self->{'text_hash'}->{'cache_minfs'},
	$self->opt_input($_[0]->{'value'}, "CacheMinFileSize", $self->{'text_hash'}->{'default'}, 8));
}

sub save_CacheMinFileSize
{
	my $self = shift;

return $self->parse_opt("CacheMinFileSize", '^\d+$', $self->{'text_hash'}->{'cache_eminfs'});
}

sub edit_CacheMaxFileSize
{
	my $self = shift;

return (1, $self->{'text_hash'}->{'cache_maxfs'},
	$self->opt_input($_[0]->{'value'}, "CacheMaxFileSize", $self->{'text_hash'}->{'default'}, 8));
}

sub save_CacheMaxFileSize
{
	my $self = shift;

return $self->parse_opt("CacheMaxFileSize", '^\d+$', $self->{'text_hash'}->{'cache_emaxfs'});
}


1;

