#!/usr/bin/perl
package apache::Mod_env;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'apache::Mod_env');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# mod_env.pl
# Defines editors for passing variables to CGI scripts

1;

1;
		return $self;
}

sub mod_env_directives
{
	my $self = shift;

local($rv);
$rv = [ [ 'PassEnv UnsetEnv SetEnv', 1, 11, 'virtual', -1.309 ],
	[ 'PassEnv UnsetEnv SetEnv', 1, 11, 'virtual directory', 1.309 ] ];
return $self->make_directives($rv, $_[0], "mod_env");
}

sub edit_PassEnv_UnsetEnv_SetEnv
{
	my $self = shift;

local($d, $e, @var, @mode, @val, $i, $rv);
foreach $d (@{$_[0]}, @{$_[1]}, @{$_[2]}) {
	if ($d->{'name'} ne "SetEnv") {
		foreach $e (@{$d->{'words'}}) {
			push(@var, $e);
			push(@mode, $d->{'name'} eq "PassEnv" ? 0 : 1);
			push(@val, "");
			}
		}
	else {
		push(@var, $d->{'words'}->[0]);
		push(@mode, 2);
		push(@val, $d->{'words'}->[1]);
		}
	}
push(@var, ""); push(@mode, 0); push(@val, "");
$rv = "<table border>\n".
      "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'mod_env_var'}</b></td> <td><b>$self->{'text_hash'}->{'mod_env_value'}</b></td> </tr>\n";
for($i=0; $i<@var; $i++) {
	$rv .= "<tr $self->{'cb'}>\n";
	$rv .= "<td><input name=Env_var_$i size=20 value=\"$var[$i]\"></td>\n";
	$rv .= "<td>".$self->choice_input($mode[$i], "Env_mode_$i", 0,
	                            "$self->{'text_hash'}->{'mod_env_pass'},0", "$self->{'text_hash'}->{'mod_env_clear'},1", "$self->{'text_hash'}->{'mod_env_set'},2");
	$rv .= "<input name=Env_val_$i size=20 value=\"$val[$i]\"></td>\n";
	$rv .= "</tr>\n";
	}
$rv .= "</table>\n";
return (2, "$self->{'text_hash'}->{'mod_env_cgivar'}", $rv);
}

sub save_PassEnv_UnsetEnv_SetEnv
{
	my $self = shift;

local($i, $var, $mode, $val, @pa, @uns, @se);
for($i=0; defined($var = $self->{'in_hash'}->{"Env_var_$i"}); $i++) {
	$mode = $self->{'in_hash'}->{"Env_mode_$i"}; $val = $self->{'in_hash'}->{"Env_val_$i"};
	if ($var !~ /\S/ && $val !~ /\S/) { next; }
	$var =~ /^\S+$/ || $self->error($self->text('mod_env_evar', $var));
	if ($mode == 0) { push(@pa, $var); }
	elsif ($mode == 1) { push(@uns, $var); }
	elsif ($var !~ /^\S+$/) {
		$self->error($self->text('mod_env_evalue', $var));
		}
	else { push(@se, "$var \"$val\""); }
	}
return ( \@pa, \@uns, \@se );
}

sub edit_PassEnvAll
{
	my $self = shift;

return (1, "$self->{'text_hash'}->{'mod_env_passall'}",
	$self->choice_input($_[0]->{'value'}, "PassEnvAll",
		      "", "$self->{'text_hash'}->{'yes'},on", "$self->{'text_hash'}->{'no'},off", "$self->{'text_hash'}->{'mod_env_default'},"));
}

sub save_PassEnvAll
{
	my $self = shift;

return $self->parse_choice("PassEnvAll");
}


1;

