#!/usr/bin/perl
package apache::Mod_ext_filter;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'apache::Mod_ext_filter');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# mod_ext_filter.pl
# Module for defining filters that are external commands

1;
		return $self;
}

sub mod_ext_filter_directives
{
	my $self = shift;

local $rv;
$rv = [ [ 'ExtFilterDefine', 1, 18, 'global', 2.0 ] ];
return $self->make_directives($rv, $_[0], "mod_ext_filter");
}

sub mod_ext_filter_filters
{
	my $self = shift;

local($d, @rv);
print STDERR "looking for ExtFilterDefine\n";
foreach $d ($self->find_all_directives($_[0], "ExtFilterDefine")) {
	push(@rv, $d->{'words'}->[0]);
	}
return @rv;
}

sub edit_ExtFilterDefine
{
	my $self = shift;

local ($inrv, $outrv);
$outrv = $inrv = "<table border>\n".
	"<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'filter_name'}</b></td>\n".
	"<td><b>$self->{'text_hash'}->{'filter_cmd'}</b></td>\n".
	"<td><b>$self->{'text_hash'}->{'filter_intype'}</b></td>\n".
	"<td><b>$self->{'text_hash'}->{'filter_outtype'}</b></td>\n".
	"<td><b>$self->{'text_hash'}->{'filter_preserve'}</b></td> </tr>\n";
local ($e, $i = 0);
foreach $e (@{$_[0]}, { 'value' => 'mode=output' },
		      { 'value' => 'mode=input' }) {
	local (%p, $str = $e->{'value'});
	while($str =~ /^\s*([^=\s]+)="([^"]*)"(.*)$/ ||
	      $str =~ /^\s*([^=\s]+)=([^=\s]+)(.*)$/ ||
	      $str =~ /^\s*([^=\s]+)()(.*)$/) {
		$p{lc($1)} = $2;
		$str = $3;
		}
	local $l = "<tr $self->{'cb'}>\n";
	local $m = $p{'mode'} ? $p{'mode'} : "output";
	$l .= "<input name=ExtFilterDefine_m_$i type=hidden value='$m'>\n";
	$l .= "<td><input name=ExtFilterDefine_n_$i size=10 value='$e->{'words'}->[0]'></td>\n";
	$l .= "<td><input name=ExtFilterDefine_c_$i size=30 value='$p{'cmd'}'></td>\n";
	$l .= "<td><input name=ExtFilterDefine_i_$i size=12 value='$p{'intype'}'></td>\n";
	$l .= "<td><input name=ExtFilterDefine_o_$i size=12 value='$p{'outtype'}'></td>\n";
	$l .= "<td><input type=checkbox name=ExtFilterDefine_p_$i value=1 ".
		(defined($p{'preservescontentlength'}) ? "checked" : "").
		"> $self->{'text_hash'}->{'yes'}</td>\n";
	$l .= "</tr>\n";
	if ($p{'mode'} eq 'input') { $inrv .= $l; }
	else { $outrv .= $l; }
	$i++;
	}
$inrv .= "</table>\n";
$outrv .= "</table>\n";
return (3, undef, "<b>$self->{'text_hash'}->{'filter_in'}</b><br>".$inrv."<p>\n".
		  "<b>$self->{'text_hash'}->{'filter_out'}</b><br>".$outrv);
}

sub save_ExtFilterDefine
{
	my $self = shift;

local (@rv, $i);
for($i=0; defined($self->{'in_hash'}->{"ExtFilterDefine_n_$i"}); $i++) {
	next if (!$self->{'in_hash'}->{"ExtFilterDefine_n_$i"});
	$self->{'in_hash'}->{"ExtFilterDefine_n_$i"} =~ /^\S+$/ ||
		$self->error($self->text('filter_ename', $self->{'in_hash'}->{"ExtFilterDefine_n_$i"}));
	$self->{'in_hash'}->{"ExtFilterDefine_c_$i"} ||
		$self->error($self->text('filter_ecmd', $self->{'in_hash'}->{"ExtFilterDefine_n_$i"}));
	local $l = $self->{'in_hash'}->{"ExtFilterDefine_n_$i"}." mode=".
		   $self->{'in_hash'}->{"ExtFilterDefine_m_$i"}." cmd=\"".
		   $self->{'in_hash'}->{"ExtFilterDefine_c_$i"}."\"";
	if ($self->{'in_hash'}->{"ExtFilterDefine_i_$i"}) {
		$l .= " intype=".$self->{'in_hash'}->{"ExtFilterDefine_i_$i"};
		}
	if ($self->{'in_hash'}->{"ExtFilterDefine_o_$i"}) {
		$l .= " outtype=".$self->{'in_hash'}->{"ExtFilterDefine_o_$i"};
		}
	if ($self->{'in_hash'}->{"ExtFilterDefine_p_$i"}) {
		$l .= " PreservesContentLength";
		}
	push(@rv, $l);
	}
return ( \@rv );
}


1;

