#!/usr/bin/perl
package apache::Mod_log_config;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'apache::Mod_log_config');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# mod_log_config.pl
# Defines editors for logging

1;

1;
		return $self;
}

sub mod_log_config_directives
{
	my $self = shift;

$self->{'rv'} = [ [ 'LogFormat', 1, 3, 'virtual', 1.2 ],
        [ 'TransferLog CustomLog', 1, 3, 'virtual', 1.2 ] ];
return $self->make_directives($self->{'rv'}, $_[0], "mod_log_config");
}

sub edit_LogFormat
{
	my $self = shift;

if ($_[1]->{'version'} >= 1.3) {
	local($i, $v, $deffmt, @nick, @fmt, $rv);
	for($i=0; $_[0]->[$i]; $i++) {
		$self->{'vv'} = $_[0]->[$i]->{'words'};
		if ($self->{'vv'}->[1]) {
			push(@nick, $self->{'vv'}->[1]); push(@fmt, $self->{'vv'}->[0]);
			}
		else { $deffmt = $self->{'vv'}->[0]; }
		}
	$rv = $self->opt_input($deffmt, "LogFormat", "$self->{'text_hash'}->{'mod_log_config_common'}", 20);
	$rv .= "<br><b>$self->{'text_hash'}->{'mod_log_config_named'}</b><br>\n";
	$rv .= "<table border>\n".
	       "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'mod_log_config_nick'}</b></td> <td><b>$self->{'text_hash'}->{'mod_log_config_format'}</b></td> </tr>\n";
	for($i=0; $i<=@nick; $i++) {
		$rv .= "<tr $self->{'cb'}> <td><input name=LogFormat_nick_$i size=10 ".
		       "value=\"$nick[$i]\"></td>\n";
		$rv .= "<td><input name=LogFormat_fmt_$i size=40 ".
		       "value='$fmt[$i]'></td> </tr>\n";
		}
	$rv .= "</table>\n";
	return (2, "$self->{'text_hash'}->{'mod_log_config_deflog'}", $rv);
	}
else {
	return (1, "$self->{'text_hash'}->{'mod_log_config_deflog'}",
		$self->opt_input($_[0]->[0]->{'words'}->[0],
			   "LogFormat", "$self->{'text_hash'}->{'mod_log_config_default'}", 25));
	}
}

sub save_LogFormat
{
	my $self = shift;

$self->{'in_hash'}->{'LogFormat'} =~ s/\"/\\\"/g;
if ($_[0]->{'version'} >= 1.3) {
	local(@rv, $i, $nick, $fmt);
	if (!$self->{'in_hash'}->{'LogFormat_def'}) { push(@rv, "\"$self->{'in_hash'}->{'LogFormat'}\""); }
	for($i=0; defined($self->{'in_hash'}->{"LogFormat_nick_$i"}); $i++) {
		$nick = $self->{'in_hash'}->{"LogFormat_nick_$i"}; $fmt =$self->{'in_hash'}->{"LogFormat_fmt_$i"};
		$fmt =~ s/\"/\\\"/g;
		if ($nick !~ /\S/ && $fmt !~ /\S/) { next; }
		$nick =~ /^\S+$/ || $self->error($self->text('mod_log_config_enick', $nick));
		push(@rv, "\"$fmt\" $nick");
		}
	return ( \@rv );
	}
else {
	if ($self->{'in_hash'}->{'LogFormat_def'}) { return ( [ ] ); }
	elsif ($self->{'in_hash'}->{'LogFormat'} =~ /^\S+$/) { return ( [ $self->{'in_hash'}->{'LogFormat'} ] ); }
	else { return ( [ "\"$self->{'in_hash'}->{'LogFormat'}\"" ] ); }
	}
}

sub edit_TransferLog_CustomLog
{
	my $self = shift;

local($rv, @all, $d, $i, $format, $dest);
$rv = "<table border>\n".
      "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'mod_log_config_format'}</b></td> <td><b>$self->{'text_hash'}->{'mod_log_config_write'}</b></td> ".
      "<td><b>$self->{'text_hash'}->{'mod_log_config_filprog'}</b></td> ";
if ($_[2]->{'version'} >= 1.305) {
	$rv .= "<td><b>If set</b></td> ";
	}
$rv .= "</tr>\n";
@all = (@{$_[0]}, @{$_[1]});
for($i=0; $i<=@all; $i++) {
	$d = $all[$i];
	if (!$d) { $format = ""; $dest = ""; }
	elsif ($d->{'name'} eq "CustomLog") {
		$format = $d->{'words'}->[1];
		$dest = $d->{'words'}->[0];
		}
	else { $format = ""; $dest = $d->{'value'}; }
	$rv .= "<tr $self->{'cb'}>\n";
	$rv .= "<td><input type=radio name=Log_def_$i value=1 ".
              ($format ? "" : "checked")."> $self->{'text_hash'}->{'mod_log_config_default'}&nbsp;\n";
	$rv .= "<input type=radio name=Log_def_$i value=0 ".
	       ($format ? "checked" : "")."> <input name=Log_cust_$i size=15 ".
	       "value='$format'></td>\n";

	$rv .= "<td><input type=radio name=Log_prog_$i value=0 ".
	       ($dest =~ /^\|/ ? "" : "checked")."> $self->{'text_hash'}->{'mod_log_config_file'}&nbsp;\n";
	$rv .= "<input type=radio name=Log_prog_$i value=1 ".
	       ($dest =~ /^\|/ ? "checked" : "")."> $self->{'text_hash'}->{'mod_log_config_program'}</td>\n";

	$dest =~ s/^\|//g;
	$rv .= "<td><input name=Log_dest_$i size=30 value=\"".
	       $self->html_escape($dest)."\"></td>\n";
	if ($_[2]->{'version'} >= 1.305) {
		local $ev = $d->{'words'}->[2] =~ /^env=(.*)$/ ? $1 : "";
		$rv .= "<td><input name=Log_env_$i size=8 value=\"$ev\"></td>";
		}
	$rv .= "</tr>\n";
	}
$rv .= "</table>\n";
return (2, "$self->{'text_hash'}->{'mod_log_config_log'}", $rv);
}

sub save_TransferLog_CustomLog
{
	my $self = shift;

local($i, $def, $cust, $prog, $dest, $fileprog, @tl, @cl);
for($i=0; defined($self->{'in_hash'}->{"Log_dest_$i"}); $i++) {
	$def = $self->{'in_hash'}->{"Log_def_$i"}; $cust = $self->{'in_hash'}->{"Log_cust_$i"};
	$prog = $self->{'in_hash'}->{"Log_prog_$i"}; $dest = $self->{'in_hash'}->{"Log_dest_$i"};
	$self->{'env'} = $self->{'in_hash'}->{"Log_env_$i"};
	$cust =~ s/\"/\\\"/g;
	if ($cust !~ /\S/ && $dest !~ /\S/) { next; }
	if (!$def && $cust !~ /\S/) { $self->error($self->text('mod_log_config_eformat', $dest)); }
	if ($dest !~ /\S/) { $self->error($self->{'text_hash'}->{'mod_log_config_enofilprog'}); }
	$self->allowed_auth_file($dest) ||
		$self->error($self->text('mod_log_config_efilprog', $dest));
	$prog || $self->directory_exists($dest) ||
		$self->error($self->text('mod_log_config_edir', $dest));

	$fileprog = !$prog ? $dest :
		     $dest =~ /^\S+$/ ? "|$dest" : "\"|$dest\"";
	if ($def) {
		if ($self->{'env'}) { $self->error($self->{'text_hash'}->{'mod_log_config_eifset'}); }
		push(@tl, "$fileprog");
		}
	else {
		if ($self->{'env'}) { push(@cl, "$fileprog \"$cust\" env=$self->{'env'}"); }
		else { push(@cl, "$fileprog \"$cust\""); }
		}
	}
return ( \@tl, \@cl );
}


1;

