#!/usr/bin/perl
package apache::Mod_mime;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'apache::Mod_mime');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# mod_mime.pl
# Defines MIME module directives

1;

1;
		return $self;
}

sub mod_mime_directives
{
	my $self = shift;

local $rv;
$rv = [ [ 'AddType', 1, 6, 'virtual directory htaccess', undef, 10 ],
	[ 'AddHandler', 1, 6, 'virtual directory htaccess', undef, 6 ],
	[ 'AddOutputFilter', 1, 18, 'virtual directory htaccess', 2.0 ],
	[ 'AddInputFilter', 1, 18, 'virtual directory htaccess', 2.0 ],
	[ 'DefaultLanguage', 0, 19, 'virtual directory htaccess', 1.304 ],
	[ 'RemoveHandler', 1, 6, 'directory htaccess', 1.304, 5 ],
	[ 'RemoveType', 1, 6, 'directory htaccess', 1.313, 5 ],
	[ 'RemoveEncoding', 1, 6, 'directory htaccess', 1.313, 5 ],
	[ 'AddLanguage', 1, 19, 'virtual directory htaccess', undef, 4 ],
	[ 'AddEncoding', 1, 6, 'virtual directory htaccess', undef, 8 ],
	[ 'AddCharset', 1, 19, 'virtual directory htaccess', 1.310, 2 ],
	[ 'ForceType', 0, 6, 'directory htaccess', -2.0 ],
	[ 'SetHandler', 0, 6, 'directory htaccess' ],
	[ 'TypesConfig', 0, 6, 'global' ] ];
return $self->make_directives($rv, $_[0], "mod_mime");
}

# extmap_input(directive, title, size, desc, list)
sub extmap_input
{
	my $self = shift;

local($rv, $i, $type, $exts);
$rv = "<table border>\n".
      "<tr $self->{'tb'}> <td><b>$_[1]</b></td> <td><b>$self->{'text_hash'}->{'mod_mime_ext'}</b></td>\n";
#      "<td><b>$_[1]</b></td> <td><b>$self->{'text_hash'}->{'mod_mime_ext'}</b></td> </tr>\n";
$self->{'len'} = scalar(@{$_[4]}) + 1;
for($i=0; $i<$self->{'len'}; $i++) {
	$rv .= "<tr $self->{'cb'}>\n";
	if ($_[4]->[$i]) {
		$_[4]->[$i]->{'value'} =~ /^(\S+)\s*(.*)$/;
		$type = $1; $exts = $2;
		}
	else { $type = $exts = ""; }
	$rv .= "<td>";
	if ($_[2] eq "h") { $rv .= $self->handler_input($type, "$_[0]_type_$i"); }
	else { $rv .= "<input name=$_[0]_type_$i size=$_[2] value=$type>"; }
	$rv .= "</td>\n";
	$rv .= "<td><input name=$_[0]_exts_$i size=10 value=\"$exts\"></td>\n";
	$rv .= "</tr>\n";
	}
$rv .= "</table>\n";
return (2, $_[3], $rv);
}

# parse_extmap(directive, regexp, desc)
sub parse_extmap
{
	my $self = shift;

local($i, $type, $exts, @rv, $re); $re = $_[1];
for($i=0; defined($self->{'in_hash'}->{"$_[0]_type_$i"}); $i++) {
	$type = $self->{'in_hash'}->{"$_[0]_type_$i"}; $exts = $self->{'in_hash'}->{"$_[0]_exts_$i"};
	if ($type !~ /\S/ && $exts !~ /\S/) { next; }
	if ($type !~ /$re/) { $self->error($self->text('mod_mime_einvalid', $type, $_[2])); }
	if ($exts !~ /\S/) { $self->error($self->text('mod_mime_eext', $_[2], $type)); }
	push(@rv, "$type $exts");
	}
return ( \@rv );
}

sub edit_AddType
{
	my $self = shift;

$self->extmap_input("AddType", $self->{'text_hash'}->{'mod_mime_type'}, 20, $self->{'text_hash'}->{'mod_mime_xtype'}, $_[0]);
}

sub save_AddType
{
	my $self = shift;

return $self->parse_extmap("AddType", '^(\S+)\/(\S+)$',
		     $self->{'text_hash'}->{'mod_mime_mtype'});
}

sub edit_AddHandler
{
	my $self = shift;

$self->extmap_input("AddHandler", $self->{'text_hash'}->{'mod_mime_handler'}, "h", $self->{'text_hash'}->{'mod_mime_chandl'}, $_[0]);
}

sub save_AddHandler
{
	my $self = shift;

return $self->parse_extmap("AddHandler");
}

sub edit_AddEncoding
{
	my $self = shift;

$self->extmap_input("AddEncoding", $self->{'text_hash'}->{'mod_mime_cenc'}, 20, $self->{'text_hash'}->{'mod_mime_cencs'}, $_[0]);
}

sub save_AddEncoding
{
	my $self = shift;

return $self->parse_extmap("AddEncoding", '^(\S+)$',
		     $self->{'text_hash'}->{'mod_mime_cenc'});
}

sub edit_AddLanguage
{
	my $self = shift;

$self->extmap_input("AddLanguage", $self->{'text_hash'}->{'mod_mime_lang'}, 5, $self->{'text_hash'}->{'mod_mime_clangs'}, $_[0]);
}

sub save_AddLanguage
{
	my $self = shift;

return $self->parse_extmap("AddLanguage", '^\S+$', $self->{'text_hash'}->{'mod_mime_clang'});
}

sub edit_ForceType
{
	my $self = shift;

return (1, $self->{'text_hash'}->{'mod_mime_defmime'},
	$self->opt_input($_[0]->{'value'}, "ForceType", $self->{'text_hash'}->{'mod_mime_real'}, 15));
}

sub save_ForceType
{
	my $self = shift;

return $self->parse_opt("ForceType", '^\S+\/\S+$', $self->{'text_hash'}->{'mod_mime_etype'});
}

sub edit_SetHandler
{
	my $self = shift;

return (1, $self->{'text_hash'}->{'mod_mime_pass'},
	$self->handler_input($_[0]->{'value'}, "SetHandler"));
}

sub save_SetHandler
{
	my $self = shift;

return $self->parse_handler("SetHandler");
}

sub edit_TypesConfig
{
	my $self = shift;

return (2,
	$self->{'text_hash'}->{'mod_mime_file'},
	$self->opt_input($_[0]->{'value'}, "TypesConfig", $self->{'text_hash'}->{'mod_mime_default'}, 40).
	$self->file_chooser_button("TypesConfig", 0));
}

sub save_TypesConfig
{
	my $self = shift;

return $self->parse_opt("TypesConfig");
}

sub edit_RemoveHandler
{
	my $self = shift;

local @list;
foreach $v (@{$_[0]}) {
	push(@list, @{$v->{'words'}});
	}
return (2, "$self->{'text_hash'}->{'mod_mime_ignhand'}",
	$self->opt_input(@list ? join(" ", @list) : undef,
		   "RemoveHandler", "$self->{'text_hash'}->{'mod_mime_none'}", 40));
}

sub save_RemoveHandler
{
	my $self = shift;

return $self->parse_opt("RemoveHandler");
}

sub edit_RemoveType
{
	my $self = shift;

local @list;
foreach $v (@{$_[0]}) {
	push(@list, @{$v->{'words'}});
	}
return (2, "$self->{'text_hash'}->{'mod_mime_igntype'}",
	$self->opt_input(@list ? join(" ", @list) : undef,
		   "RemoveType", "$self->{'text_hash'}->{'mod_mime_none'}", 40));
}

sub save_RemoveType
{
	my $self = shift;

return $self->parse_opt("RemoveType");
}

sub edit_RemoveEncoding
{
	my $self = shift;

local @list;
foreach $v (@{$_[0]}) {
	push(@list, @{$v->{'words'}});
	}
return (2, "$self->{'text_hash'}->{'mod_mime_ignenc'}",
	$self->opt_input(@list ? join(" ", @list) : undef,
		   "RemoveEncoding", "$self->{'text_hash'}->{'mod_mime_none'}", 40));
}

sub save_RemoveEncoding
{
	my $self = shift;

return $self->parse_opt("RemoveEncoding");
}

sub edit_AddCharset
{
	my $self = shift;

$self->extmap_input("AddCharset", "$self->{'text_hash'}->{'mod_mime_chars'}", 12, "$self->{'text_hash'}->{'mod_mime_xchars'}", $_[0]);
}

sub save_AddCharset
{
	my $self = shift;

return $self->parse_extmap("AddCharset");
}

sub edit_DefaultLanguage
{
	my $self = shift;

return (1, $self->{'text_hash'}->{'mod_mime_deflang'},
	$self->opt_input($_[0]->{'value'}, "DefaultLanguage", $self->{'text_hash'}->{'mod_mime_none'},
		   10));
}

sub save_DefaultLanguage
{
	my $self = shift;

return $self->parse_opt("DefaultLanguage", '\S', $self->{'text_hash'}->{'mod_mime_edeflang'});
}

sub edit_AddOutputFilter
{
	my $self = shift;

return (2, $self->{'text_hash'}->{'mod_mime_outfilter'},
	$self->filtmap_input("AddOutputFilter", $_[0]));
}

sub save_AddOutputFilter
{
	my $self = shift;

return $self->parse_filtmap("AddOutputFilter");
}

sub edit_AddInputFilter
{
	my $self = shift;

return (2, $self->{'text_hash'}->{'mod_mime_infilter'},
	$self->filtmap_input("AddInputFilter", $_[0]));
}

sub save_AddInputFilter
{
	my $self = shift;

return $self->parse_filtmap("AddInputFilter");
}

# filtmap_input(name, &values)
sub filtmap_input
{
	my $self = shift;

local $rv = "<table border>\n".
	    "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'mod_mime_filters'}</b></td>\n".
	    "<td><b>$self->{'text_hash'}->{'mod_mime_ext'}</b></td> </tr>\n";
local ($d, $i = 0);
foreach $d (@{$_[1]}, { }) {
	local @w = @{$d->{'words'}};
	local @v = split(/;/, shift(@w));
	$rv .= "<tr $self->{'cb'}>\n";
	$rv .= "<td>".$self->filters_input(\@v, $_[0]."_f_$i")."</td>\n";
	$rv .= "<td><input name=$_[0]_e_$i size=30 value='".
		join(" ", @w)."'></td>\n";
	$rv .= "</tr>\n";
	$i++;
	}
$rv .= "</table>\n";
return $rv;
}

# parse_filtmap(name)
sub parse_filtmap
{
	my $self = shift;

local ($i, @rv);
for($i=0; defined($self->{'in_hash'}->{"$_[0]_e_$i"}); $i++) {
	local @f = split(/\0/, $self->{'in_hash'}->{"$_[0]_f_$i"});
	next if (!@f);
	local $exts = $self->{'in_hash'}->{"$_[0]_e_$i"};
	$exts || $self->error($self->text('mod_mime_efext', join(" ", @f)));
	push(@rv, join(";", @f)." ".$exts);
	}
return ( \@rv );
}


1;

