#!/usr/bin/perl
package apache::Mod_negotiation;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'apache::Mod_negotiation');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# mod_negotiation.pl
# Defines editors content negotiation directives

1;

1;
		return $self;
}

sub mod_negotiation_directives
{
	my $self = shift;

$self->{'rv'} = [ [ 'CacheNegotiatedDocs', 0, 6, 'global' ],
        [ 'LanguagePriority', 0, 19, 'virtual directory htaccess' ] ];
return $self->make_directives($self->{'rv'}, $_[0], "mod_negotiation");
}

sub mod_negotiation_handlers
{
	my $self = shift;

return ("type-map");
}

sub edit_CacheNegotiatedDocs
{
	my $self = shift;

if ($_[1]->{'version'} < 2.0) {
	local $v = $_[0] ? "1" : "0";
	return (1, $self->{'text_hash'}->{'mod_negotiation_cache'},
		$self->choice_input($v, "CacheNegotiatedDocs", "0",
		"$self->{'text_hash'}->{'yes'},1", "$self->{'text_hash'}->{'no'},0"));
	}
else {
	return (1, $self->{'text_hash'}->{'mod_negotiation_cache'},
		$self->choice_input($_[0]->{'value'}, "CacheNegotiatedDocs", "off",
			      "$self->{'text_hash'}->{'yes'},on", "$self->{'text_hash'}->{'no'},off"));
	}
}

sub save_CacheNegotiatedDocs
{
	my $self = shift;

if ($_[0]->{'version'} < 2.0) {
	return $self->{'in_hash'}->{'CacheNegotiatedDocs'} ? ( [ "" ] ) : ( [ ] );
	}
else {
	return $self->parse_choice("CacheNegotiatedDocs", "off");
	}
}

sub edit_LanguagePriority
{
	my $self = shift;

return (2, "$self->{'text_hash'}->{'mod_negotiation_pri'}",
        $self->opt_input($_[0]->{'value'}, "LanguagePriority", "$self->{'text_hash'}->{'mod_negotiation_def'}", 40));
}

sub save_LanguagePriority
{
	my $self = shift;

local $rv = $self->parse_opt("LanguagePriority", '\S', $self->{'text_hash'}->{'mod_negotiation_epri'});
if ($rv) {
	$rv->[0] =~ s/^"(.*)"/$1/g;
	}
return $rv;
}


1;

