#!/usr/bin/perl
package apache::Mod_php5;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'apache::Mod_php5');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# mod_php5.pl

1;
1;
		return $self;
}

sub mod_php5_directives
{
	my $self = shift;

$self->{'rv'} = [ [ 'php_value', 1, 16, 'virtual directory htaccess', undef, 10 ],
	[ 'php_flag', 1, 16, 'virtual directory htaccess', undef, 2 ],
	[ 'php_admin_value', 1, 16, 'virtual directory htaccess', undef, 10 ],
	[ 'php_admin_flag', 1, 16, 'virtual directory htaccess', undef, 2 ],
      ];
return $self->make_directives($self->{'rv'}, $_[0], "mod_php5");
}

sub mod_php5_handlers
{
	my $self = shift;

return ("php5-script");
}

sub edit_php_value
{
	my $self = shift;

return $self->php_value_form($_[0], "php_value");
}

sub edit_php_admin_value
{
	my $self = shift;

return $self->php_value_form($_[0], "php_admin_value");
}

# php_value_form(&values, name)
sub php_value_form
{
	my $self = shift;

local($rv, $name, $value, $len);
$rv = "";

$len = @{$_[0]} + 1;
for($i=0; $i<$len; $i++) {
	if ($_[0]->[$i]->{'value'} =~ /^(\S+)\s+(.+)$/) {
		$name = $1; $value = $2;
		}
	else { $name = $value = ""; }
	$rv .= "<input name=mod_$_[1]_name_$i size=20 value='$name'>&nbsp;";
	$rv .= "<input name=mod_$_[1]_value_$i size=30 value='$value'><BR>\n";
	}
return (2, "$self->{'text_hash'}->{'mod_'.$_[1]}", $rv);
}

sub save_php_value
{
	my $self = shift;

return $self->php_value_save("php_value");
}

sub save_php_admin_value
{
	my $self = shift;

return $self->php_value_save("php_admin_value");
}

# php_value_save(name)
sub php_value_save
{
	my $self = shift;

local($i, $name, $value, @rv);
for($i=0; defined($self->{'in_hash'}->{"mod_$_[0]_name_$i"}); $i++) {
	$name = $self->{'in_hash'}->{"mod_$_[0]_name_$i"}; $value = $self->{'in_hash'}->{"mod_$_[0]_value_$i"};
	if ($name !~ /\S/ && $value !~ /\S/) { next; }
	$name =~ /^(\S+)$/ || $self->error($self->text('mod_php_ename', $name));
	$value =~ /^(.+)$/ || $self->error($self->text('mod_php_evalue', $name, $value));
	push(@rv, "$name $value");
	}
return ( \@rv );
}

sub edit_php_flag
{
	my $self = shift;

return $self->php_flag_form($_[0], "php_flag");
}

sub edit_php_admin_flag
{
	my $self = shift;

return $self->php_flag_form($_[0], "php_admin_flag");
}

# php_flag_form(&values, name)
sub php_flag_form
{
	my $self = shift;

local($rv, $name, $value, $len);
$rv = "";

$len = @{$_[0]} + 1;
for($i=0; $i<$len; $i++) {
	if ($_[0]->[$i]->{'value'} =~ /^(\S+)\s+(on|off)$/) {
		$name = $1; $value = $2;
		}
	else { $name = $value = ""; }
	$rv .= "<input name=mod_$_[1]_name_$i size=20 value='$name'>&nbsp;";
	$rv .= "<input name=mod_$_[1]_value_$i type=radio value=on" . ($value eq "on" ? " checked" : "" ) . ">on&nbsp;";
	$rv .= "<input name=mod_$_[1]_value_$i type=radio value=off" . ($value eq "off" ? " checked" : "" ) . ">off&nbsp;<BR>";
	}
return (2, "$self->{'text_hash'}->{'mod_'.$_[1]}", $rv);
}

sub save_php_flag
{
	my $self = shift;

return $self->php_flag_save("php_flag");
}

sub save_php_admin_flag
{
	my $self = shift;

return $self->php_flag_save("php_admin_flag");
}

# php_flag_save(name)
sub php_flag_save
{
	my $self = shift;

local($i, $name, $value, @rv);
for($i=0; defined($self->{'in_hash'}->{"mod_$_[0]_name_$i"}); $i++) {
	$name = $self->{'in_hash'}->{"mod_$_[0]_name_$i"}; $value = $self->{'in_hash'}->{"mod_$_[0]_value_$i"};
	if ($name !~ /\S/ ) { next; }
	$name =~ /^(\S+)$/ || $self->error($self->text('mod_php_ename', $name));
	$value =~ /^(on|off)$/i || $self->error($self->text('mod_php_evalue', $name, $value));
	push(@rv, "$name $value");
	}
return ( \@rv );
}


1;

