#!/usr/bin/perl
package apache::Mod_proxy;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'apache::Mod_proxy');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# mod_proxy.pl
# Editors for proxy directives

&ModuleLoader::preload_module(ref($self), "apache::Cache");
$self = new apache::Cache:: ref($self), %$self; 

1;

1;
		return $self;
}

sub mod_proxy_directives
{
	my $self = shift;

local $rv;
$rv = [ [ 'ProxyRequests', 0, 13, 'virtual', undef, 11 ],
        [ 'ProxyRemote', 1, 13, 'virtual', undef, 7 ],
        [ 'ProxyPass', 1, 10, 'virtual', undef, 0 ],
        [ 'ProxyPassReverse', 1, 10, 'virtual', 1.306, 0 ],
        [ 'ProxyBlock', 1, 13, 'virtual', 1.2, 9 ],
        [ 'NoProxy', 1, 13, 'virtual', 1.3, 5 ],
        [ 'ProxyDomain', 0, 13, 'virtual', 1.3, 4 ],
	[ 'AllowCONNECT', 0, 13, 'virtual', 1.302, 2 ],
        [ 'CacheRoot', 0, 13, 'virtual', -2.0, 10 ],
        [ 'CacheSize', 0, 13, 'virtual', -2.0 ],
        [ 'CacheGcInterval', 0, 13, 'virtual', -2.0 ],
        [ 'CacheMaxExpire', 0, 13, 'virtual', -2.0 ],
        [ 'CacheLastModifiedFactor', 0, 13, 'virtual', -2.0 ],
        [ 'CacheDirLevels', 0, 13, 'virtual', -2.0 ],
        [ 'CacheDirLength', 0, 13, 'virtual', -2.0 ],
        [ 'CacheDefaultExpire', 0, 13, 'virtual', -2.0 ],
        [ 'CacheForceCompletion', 0, 13, 'virtual', '1.301-2.0' ],
        [ 'NoCache', 1, 13, 'virtual', -2.0, 3 ],
	[ 'ProxyMaxForwards', 0, 13, 'virtual', 2.0 ],
	[ 'ProxyPreserveHost', 0, 13, 'virtual', 2.031 ],
	[ 'ProxyTimeout', 0, 13, 'virtual', 2.031 ],
	[ 'ProxyVia', 0, 13, 'virtual', 2.0 ] ];
return $self->make_directives($rv, $_[0], "mod_proxy");
}

sub edit_ProxyRequests
{
	my $self = shift;

return (1, $self->{'text_hash'}->{'mod_proxy_proxy'},
        $self->choice_input($_[0]->{'value'}, "ProxyRequests", "off",
                      "$self->{'text_hash'}->{'yes'},on", "$self->{'text_hash'}->{'no'},off"));
}

sub save_ProxyRequests
{
	my $self = shift;

return $self->parse_choice("ProxyRequests", "off");
}

sub edit_ProxyRemote
{
	my $self = shift;

local($rv, $i, $match, $proxy, $max);
$rv = "<table border>\n".
      "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'mod_proxy_req'}</b></td> <td><b>$self->{'text_hash'}->{'mod_proxy_forw'}</b></td> </tr>\n";
$max = @{$_[0]}+1;
for($i=0; $i<$max; $i++) {
	if ($_[0]->[$i]->{'value'} =~ /^(\S+)\s+(\S+)$/) {
		$match = $1; $proxy = $2;
		}
	else { $match = "*"; $proxy = ""; }
	$rv .= "<tr $self->{'cb'}>\n";
	$rv .= sprintf
	        "<td><input type=radio name=ProxyRemote_match_all_$i %s> $self->{'text_hash'}->{'mod_proxy_all'}\n",
	        $match eq "*" ? "checked" : "";
	$rv .= sprintf
	        "<input type=radio name=ProxyRemote_match_all_$i %s> $self->{'text_hash'}->{'mod_proxy_match'}\n",
	        $match eq "*" ? "" : "checked";
	$rv .= sprintf
	        "<input name=ProxyRemote_match_$i size=20 value=\"%s\"></td>\n",
	        $match eq "*" ? "" : $match;
	$rv .= "<td><input name=ProxyRemote_proxy_$i size=20 ".
	       "value=\"$proxy\"></td>\n";
	$rv .= "</tr>\n";
	}
$rv .= "</table>\n";
return (2, $self->{'text_hash'}->{'mod_proxy_pass'}, $rv);
}

sub save_ProxyRemote
{
	my $self = shift;

local($i, $match, $match_all, $proxy, @rv);
for($i=0; defined($proxy = $self->{'in_hash'}->{"ProxyRemote_proxy_$i"}); $i++) {
	$match = $self->{'in_hash'}->{"ProxyRemote_match_$i"};
	$match_all = $self->{'in_hash'}->{"ProxyRemote_match_all_$i"};
	if ($match !~ /\S/ && $proxy !~ /\S/) { next; }
	if ($match_all) { $match = "*"; }
	elsif ($match !~ /^\S+$/) { $self->error($self->text('mod_proxy_erequest', $match)); }
	$proxy =~ /^http:\/\/\S+$/ || $self->error($self->text('mod_proxy_epurl', $proxy));
	push(@rv, "$match $proxy");
	}
return ( \@rv );
}

sub edit_ProxyPass
{
	my $self = shift;

return (2, $self->{'text_hash'}->{'mod_proxy_map'},
	$self->proxy_pass_input($_[0], "ProxyPass", $_[1]));
}

sub save_ProxyPass
{
	my $self = shift;

return $self->parse_proxy_pass("ProxyPass");
}

sub edit_ProxyPassReverse
{
	my $self = shift;

return (2, $self->{'text_hash'}->{'mod_proxy_headers'},
	$self->proxy_pass_input($_[0], "ProxyPassReverse", $_[1]));
}

sub save_ProxyPassReverse
{
	my $self = shift;

return $self->parse_proxy_pass("ProxyPassReverse");
}

# proxy_pass_input(&directives, name, &config)
sub proxy_pass_input
{
	my $self = shift;

local($rv, $i, $path, $url, $max);
$rv = "<table border>\n".
      "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'mod_proxy_local'}</b></td> <td><b>$self->{'text_hash'}->{'mod_proxy_remote'}</b></td> </tr>\n";
$max = @{$_[0]} + 1;
for($i=0; $i<$max; $i++) {
	if ($_[0]->[$i]->{'value'} =~ /^(\S+)\s+(\S+)$/) {
		$path = $1; $url = $2;
		}
	else { $path = $url = ""; }
	$rv .= "<tr $self->{'cb'}>\n";
	$rv .= "<td>".$self->ui_textbox("$_[1]_path_$i", $path, 20)."</td>\n";
	if ($_[2]->{'version'} >= 2.0) {
		$rv .= "<td>".$self->ui_opt_textbox("$_[1]_url_$i",
				$url eq "!" ? undef : $url, 30,
				$self->{'text_hash'}->{'mod_proxy_not'})."</td>\n";
		}
	else {
		$rv .= "<td>".$self->ui_textbox("$_[1]_url_$i", $url, 30),"</td>";
		}
	$rv .= "</tr>\n";
	}
$rv .= "</table>\n";
return $rv;
}

# parse_proxy_pass(name)
sub parse_proxy_pass
{
	my $self = shift;

local($i, $url, $path, @rv, @notrv);
for($i=0; defined($path = $self->{'in_hash'}->{"$_[0]_path_$i"}); $i++) {
	$url = $self->{'in_hash'}->{"$_[0]_url_${i}_def"} ? "!" : $self->{'in_hash'}->{"$_[0]_url_$i"};
	next if (!$path);
	$path =~ /^\/\S*$/ || $self->error($self->text('mod_proxy_elurl', $path));
	$url =~ /^(http|https):\/\/(\S+)$/ || $url eq "!" ||
		$self->error($self->text('mod_proxy_erurl', $url));
	if ($url eq "!") {
		push(@notrv, "$path $url");
		}
	else {
		push(@rv, "$path $url");
		}
	}
return ( [ @notrv, @rv ] );
}

sub edit_ProxyBlock
{
	my $self = shift;

local($b, @b);
foreach $b (@{$_[0]}) { push(@b, split(/\s+/, $b->{'value'})); }
return (2, $self->{'text_hash'}->{'mod_proxy_block'},
        $self->opt_input(@b ? join(' ', @b) : undef, "ProxyBlock", $self->{'text_hash'}->{'mod_proxy_none3'}, 50));
}

sub save_ProxyBlock
{
	my $self = shift;

return $self->parse_opt("ProxyBlock", '\S', $self->{'text_hash'}->{'mod_proxy_eblock'});
}

sub edit_NoProxy
{
	my $self = shift;

local($n, @n, $i, $rv);
foreach $n (@{$_[0]}) { push(@n, split(/\s+/, $n->{'value'})); }
$rv = "<table border>\n".
      "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'mod_proxy_type'}</b></td> <td><b>$self->{'text_hash'}->{'mod_proxy_noproxy'}</b></td> </tr>\n";
for($i=0; $i<=@n; $i++) {
	$rv .= "<tr $self->{'cb'}>\n";
	if ($i>=@n) { $self->{'type'} = 0; }
	elsif ($n[$i] =~ /^(\d+)\.(\d+)\.(\d+)\.(\d+)$/) {
		if ($4 == 0) { $self->{'type'} = 3; }
		else { $self->{'type'} = 0; }
		}
	elsif ($n[$i] =~ /^([0-9\.]+)\/(\d+)$/) { $self->{'type'} = 4; }
	elsif ($n[$i] =~ /^([0-9\.]+)$/) { $self->{'type'} = 3; }
	elsif ($n[$i] =~ /^\.(\S+)$/) { $self->{'type'} = 2; }
	else { $self->{'type'} = 1; }
	$rv .= "<td>".$self->select_input($self->{'type'}, "NoProxy_type_$i", 0,
		"$self->{'text_hash'}->{'mod_proxy_ip'},0", "$self->{'text_hash'}->{'mod_proxy_host'},1",
		"$self->{'text_hash'}->{'mod_proxy_domain'},2", "$self->{'text_hash'}->{'mod_proxy_net'},3",
		"$self->{'text_hash'}->{'mod_proxy_netbit'},4")."</td>\n";
	$rv .= "<td><input name=NoProxy_for_$i size=30 value=\"$n[$i]\"></td>\n";
	$rv .= "</tr>\n";
	}
$rv .= "</table>\n";
return (2, $self->{'text_hash'}->{'mod_proxy_nopass'}, $rv);
}

sub save_NoProxy
{
	my $self = shift;

local($i, $type, $for, @rv);
for($i=0; defined($type = $self->{'in_hash'}->{"NoProxy_type_$i"}); $i++) {
	$for = $self->{'in_hash'}->{"NoProxy_for_$i"};
	if ($for !~ /\S/) { next; }
	if ($type == 0) {
		$self->check_ipaddress($for) || 
		    $self->check_ip6address($for) || 
			$self->error($self->text('mod_proxy_eip', $for));
		}
	elsif ($type == 1) {
		$for =~ /^[A-z0-9\-][A-z0-9\-\.]+[A-z0-9\-]$/ ||
			$self->error($self->text('mod_proxy_ehost', $for));
		}
	elsif ($type == 2) {
		$for =~ /^\.[A-z0-9\-\.]+[A-z0-9\-]$/ ||
			$self->error($self->text('mod_proxy_edomain', $for));
		}
	elsif ($type == 3) {
		if ($for =~ /^(\d+)$/) { $for .= ".0.0.0"; }
		elsif ($for =~ /^(\d+)\.(\d+)$/) { $for .= ".0.0"; }
		elsif ($for =~ /^(\d+)\.(\d+)\.(\d+)$/) { $for .= ".0"; }
		$self->check_ipaddress($for) || $self->error($self->text('mod_proxy_enet', $for));
		}
	elsif ($type == 4) {
		($for =~ /^(\S+)\/(\d+)$/ &&
	          ($self->check_ipaddress($1) || $self->check_ip6address($1)) && $2 < 32) ||
			$self->error($self->text('mod_proxy_enetbit', $for));
		}
	push(@rv, $for);
	}
return @rv ? ( [ join(' ', @rv) ] ) : ( [ ] );
}

sub edit_ProxyDomain
{
	my $self = shift;

return (1, $self->{'text_hash'}->{'mod_proxy_nodomain'},
        $self->opt_input($_[0]->{'value'}, "ProxyDomain", $self->{'text_hash'}->{'mod_proxy_none'}, 20));
}

sub save_ProxyDomain
{
	my $self = shift;

return $self->parse_opt("ProxyDomain", '^[A-z0-9\-]+$', $self->{'text_hash'}->{'mod_proxy_enodomain'});
}

sub edit_AllowCONNECT
{
	my $self = shift;

return (1, $self->{'text_hash'}->{'mod_proxy_connect'},
        $self->opt_input($_[0]->{'value'}, "AllowCONNECT", $self->{'text_hash'}->{'mod_proxy_default'}, 10));
}

sub save_AllowCONNECT
{
	my $self = shift;

return $self->parse_opt("AllowCONNECT", '^[\d ]+$', $self->{'text_hash'}->{'mod_proxy_econnect'});
}

sub edit_ProxyMaxForwards
{
	my $self = shift;

return (1, $self->{'text_hash'}->{'mod_proxy_maxfw'},
	$self->opt_input($_[0]->{'value'}, "ProxyMaxForwards", $self->{'text_hash'}->{'default'}, 5));
}

sub save_ProxyMaxForwards
{
	my $self = shift;

return $self->parse_opt("ProxyMaxForwards", '^\d+$', $self->{'text_hash'}->{'mod_proxy_emaxfw'});
}

sub edit_ProxyPreserveHost
{
	my $self = shift;

return (1, $self->{'text_hash'}->{'mod_proxy_preserve'},
	$self->choice_input($_[0]->{'value'}, "ProxyPreserveHost", "",
	      "$self->{'text_hash'}->{'yes'},on", "$self->{'text_hash'}->{'no'},off", "$self->{'text_hash'}->{'default'},"));
}

sub save_ProxyPreserveHost
{
	my $self = shift;

return $self->parse_choice("ProxyPreserveHost", "");
}

sub edit_ProxyTimeout
{
	my $self = shift;

return (1, $self->{'text_hash'}->{'mod_proxy_timeout'},
	$self->opt_input($_[0]->{'value'}, "ProxyTimeout", $self->{'text_hash'}->{'default'}, 5));
}

sub save_ProxyTimeout
{
	my $self = shift;

return $self->parse_opt("ProxyTimeout", '^\d+$', $self->{'text_hash'}->{'mod_proxy_etimeout'});
}

sub edit_ProxyVia
{
	my $self = shift;

return (1, $self->{'text_hash'}->{'mod_proxy_via'},
	$self->choice_input($_[0]->{'value'}, "ProxyVia", "",
	      "$self->{'text_hash'}->{'yes'},on", "$self->{'text_hash'}->{'no'},off", "$self->{'text_hash'}->{'default'},"));
}

sub save_ProxyVia
{
	my $self = shift;

return $self->parse_choice("ProxyVia", "");
}


1;

