#!/usr/bin/perl
package apache::Mod_setenvif;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'apache::Mod_setenvif');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# mod_setenvif.pl
# Defines editors for directives to set environment variables

&ModuleLoader::preload_module(ref($self), "apache::Browsermatch");
$self = new apache::Browsermatch:: ref($self), %$self; 

1;

1;
		return $self;
}

sub mod_setenvif_directives
{
	my $self = shift;

local($rv);
$rv = [ [ 'BrowserMatch BrowserMatchNoCase', 1, 11, 'global', '-1.313' ],
	[ 'BrowserMatch BrowserMatchNoCase', 1, 11, 'virtual directory htaccess', 1.313 ],
        [ 'SetEnvIf SetEnvIfNoCase', 1, 11, 'global', '1.3-1.313' ],
        [ 'SetEnvIf SetEnvIfNoCase', 1, 11, 'virtual directory htaccess', 1.313 ] ];
return $self->make_directives($rv, $_[0], "mod_setenvif");
}

sub edit_SetEnvIf_SetEnvIfNoCase
{
	my $self = shift;

local($d, @w, $i, @head, @regex, @var, @val, @case, $rv);
foreach $d (@{$_[0]}, @{$_[1]}) {
	@w = @{$d->{'words'}};
	for($i=2; $i<@w; $i++) {
		push(@head, $w[0]);
		push(@regex, $w[1]);
		if ($w[$i] =~ /^\!(\S+)$/)
			{ push(@var, $1); push(@val, undef); }
		elsif ($w[$i] =~ /^(\S+)=(\S*)$/)
			{ push(@var, $1); push(@val, $2); }
		else { push(@var, $w[$i]); push(@val, 1); }
		if ($d->{'name'} eq "SetEnvIf") { push(@case, 1); }
		else { push(@case, 0); }
		}
	}
push(@head, ""); push(@regex, ""); push(@var, ""); push(@val, ""); push(@case, 0);
$rv = "<table border>\n".
      "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'mod_setenvif_header'}</b></td> <td><b>$self->{'text_hash'}->{'mod_setenvif_match'}</b></td>\n".
      "<td><b>$self->{'text_hash'}->{'mod_setenvif_case'}</b></td> <td><b>$self->{'text_hash'}->{'mod_setenvif_var'}</b></td>\n".
      "<td><b>$self->{'text_hash'}->{'mod_setenvif_value'}</b></td> </tr>\n";
for($i=0; $i<@head; $i++) {
	$rv .= "<tr $self->{'cb'}>\n";
	$rv .= sprintf
	        "<td><input size=15 name=SetEnvIf_head_$i value=\"%s\"></td>\n",
	        $head[$i];
	$rv .= sprintf
	        "<td><input size=10 name=SetEnvIf_regex_$i value=\"%s\"></td>\n",
	        $regex[$i];
	$rv .= "<td>".$self->choice_input($case[$i], "SetEnvIf_case_$i", 1,
	       "$self->{'text_hash'}->{'yes'},1", "$self->{'text_hash'}->{'no'},0")."</td>\n";
	$rv .= sprintf
	        "<td><input size=20 name=SetEnvIf_var_$i value=\"%s\"></td>\n",
	        $var[$i];
	$rv .= "<td>".$self->opt_input($val[$i], "SetEnvIf_val_$i",
	       "$self->{'text_hash'}->{'mod_setenvif_clear'}", 10)."</td>\n";
	$rv .= "</tr>\n";
	}
$rv .= "</table>\n";
return (2, "$self->{'text_hash'}->{'mod_setenvif_txt'}", $rv);
}

sub save_SetEnvIf_SetEnvIfNoCase
{
	my $self = shift;

local($i, $head, $regex, $case, $var, $val,
      $set, $lastsi, $lastsnc, @si, @sinc);
for($i=0; defined($head = $self->{'in_hash'}->{"SetEnvIf_head_$i"}); $i++) {
	$regex = $self->{'in_hash'}->{"SetEnvIf_regex_$i"}; $case = $self->{'in_hash'}->{"SetEnvIf_case_$i"};
	$var = $self->{'in_hash'}->{"SetEnvIf_var_$i"};
	$val = $self->{'in_hash'}->{"SetEnvIf_val_${i}_def"} ? undef : $self->{'in_hash'}->{"SetEnvIf_val_$i"};
	if ($head !~ /\S/ && $regex !~ /\S/ && $var !~ /\S/) { next; }
	$head =~ /^\S+$/ || $self->error($self->text('mod_setenvif_eheader', $head));
	$regex =~ /^\S+$/ || $self->error($self->text('mod_setenvif_eregex', $regex));
	$var =~ /^\S+$/ || $self->error($self->text('mod_setenvif_evar', $var));
	$set = !defined($val) ? "!$var" : $val eq "1" ? $var : "$var=$val";
	if ($case) {
		if ("$head $regex" eq $lastsi) { $si[$#si] .= " $set"; }
		else { push(@si, "$head $regex $set"); }
		$lastsi = "$head $regex";
		}
	else {
		if ("$head $regex" eq $self->{'lastsinc'}) { $sinc[$#sinc] .= " $set"; }
		else { push(@sinc, "$head $regex $set"); }
		$self->{'lastsinc'} = "$head $regex";
		}
	}
return ( \@si, \@sinc );
}


1;

