#!/usr/bin/perl
package apache::Mod_vhost_alias;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'apache::Mod_vhost_alias');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# mod_vhost_alias.pl
# Defines editors for vhost_alias module directives

1;
		return $self;
}

sub mod_vhost_alias_directives
{
	my $self = shift;

$self->{'rv'} = [ [ 'VirtualDocumentRoot VirtualDocumentRootIP', 0, 17, 'virtual', 1.307 ],
	[ 'VirtualScriptAlias VirtualScriptAliasIP', 0, 17, 'virtual', 1.307 ] ];
return $self->make_directives($self->{'rv'}, $_[0], "mod_vhost_alias");
}

sub edit_VirtualDocumentRoot_VirtualDocumentRootIP
{
	my $self = shift;

local $rv;

$rv = sprintf "<input type=radio name=VirtualDocumentRoot_def value=1 %s> %s\n",
	$_[0] || $_[1] ? '' : 'checked', $self->{'text_hash'}->{'mod_vhost_alias_none'};
$rv .= sprintf "<input type=radio name=VirtualDocumentRoot_def value=0 %s>\n",
	$_[0] || $_[1] ? 'checked' : '';
$rv .= sprintf "<input name=VirtualDocumentRoot size=50 value='%s'><br>\n",
	$_[0] ? $_[0]->{'value'} : $_[1] ? $_[1]->{'value'} : '';
$rv .= sprintf "<input type=checkbox name=VirtualDocumentRoot_ip value=1 %s> %s\n",
	$_[1] ? 'checked' : '', $self->{'text_hash'}->{'mod_vhost_alias_ip'};

return (2, "$self->{'text_hash'}->{'mod_vhost_alias_root'}", $rv);
}

sub save_VirtualDocumentRoot_VirtualDocumentRootIP
{
	my $self = shift;

if ($self->{'in_hash'}->{'VirtualDocumentRoot_def'}) {
	return ( [ ], [ ] );
	}
$self->{'in_hash'}->{'VirtualDocumentRoot'} =~ /^\S+$/ || $self->error($self->{'text_hash'}->{'mod_vhost_alias_eroot'});
$self->allowed_doc_dir($self->{'in_hash'}->{'VirtualDocumentRoot'}) ||
	$self->error($self->{'text_hash'}->{'mod_vhost_alias_eroot2'});
if ($self->{'in_hash'}->{'VirtualDocumentRoot_ip'}) {
	return ( [ ], [ $self->{'in_hash'}->{'VirtualDocumentRoot'} ] );
	}
else {
	return ( [ $self->{'in_hash'}->{'VirtualDocumentRoot'} ], [ ] );
	}
}

sub edit_VirtualScriptAlias_VirtualScriptAliasIP
{
	my $self = shift;

$self->{'rv'} = sprintf "<input type=radio name=VirtualScriptAlias_def value=1 %s> %s\n",
	$_[0] || $_[1] ? '' : 'checked', $self->{'text_hash'}->{'mod_vhost_alias_none'};
$self->{'rv'} .= sprintf "<input type=radio name=VirtualScriptAlias_def value=0 %s>\n",
	$_[0] || $_[1] ? 'checked' : '';
$self->{'rv'} .= sprintf "<input name=VirtualScriptAlias size=50 value='%s'><br>\n",
	$_[0] ? $_[0]->{'value'} : $_[1] ? $_[1]->{'value'} : '';
$self->{'rv'} .= sprintf "<input type=checkbox name=VirtualScriptAlias_ip value=1 %s> %s\n",
	$_[1] ? 'checked' : '', $self->{'text_hash'}->{'mod_vhost_alias_ip'};

return (2, "$self->{'text_hash'}->{'mod_vhost_alias_script'}", $self->{'rv'});
}

sub save_VirtualScriptAlias_VirtualScriptAliasIP
{
	my $self = shift;

if ($self->{'in_hash'}->{'VirtualScriptAlias_def'}) {
	return ( [ ], [ ] );
	}
$self->{'in_hash'}->{'VirtualScriptAlias'} =~/^\S+$/ || $self->error($self->{'text_hash'}->{'mod_vhost_alias_escript'});
if ($self->{'in_hash'}->{'VirtualScriptAlias_ip'}) {
	return ( [ ], [ $self->{'in_hash'}->{'VirtualScriptAlias'} ] );
	}
else {
	return ( [ $self->{'in_hash'}->{'VirtualScriptAlias'} ], [ ] );
	}
}


1;

