#!/usr/bin/perl
package apache::Postinstall;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'apache::Postinstall');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;

$self->{'no_acl_check'}++;
&ModuleLoader::preload_module(ref($self), "apache::ApacheLib");
$self = new apache::ApacheLib:: ref($self), %$self; 

1;
		return $self;
}

sub module_install {
	my $self = shift;


local $site_file = ($self->{'config_hash'}->{'webmin_apache'} || $self->{'module_config_directory'})."/site";

if (!-r $site_file && $self->{'module_name'} ne 'htaccess') {
	# Need to build list of supported modules
	local $httpd = $self->find_httpd();
	local ($ver, $mods) = $self->httpd_info($httpd);
	if ($ver) {
		local @mods = map { "$_/$ver" } $self->configurable_modules();
		local @st = stat($httpd);
		local %site = ( 'size' => $st[7],
				'modules' => join(' ', @mods) );
		$self->lock_file($site_file);
		$self->write_file($site_file, \%site);
		chmod(0644, $site_file);
		$self->unlock_file($site_file);
		}
	}
	
# Configures End User htaccess module
local %htconfig = ();
local $htconfig_name = "$self->{'config_directory'}/enduser_cp/htaccess/config";
if (-r $htconfig_name) {
	$self->read_file($htconfig_name, \%htconfig);
	$self->lock_file($htconfig_name);
	$htconfig{'webmin_apache'} = $self->{'module_config_directory'};
	$self->write_file($htconfig_name, \%htconfig);
	$self->unlock_file($htconfig_name);
	}
}


1;

