#!/usr/bin/perl
package apache::Useradmin_update;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'apache::Useradmin_update');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;

&ModuleLoader::preload_module(ref($self), "apache::ApacheLib");
$self = new apache::ApacheLib:: ref($self), %$self; 
&ModuleLoader::preload_module(ref($self), "apache::AuthLib");
$self = new apache::AuthLib:: ref($self), %$self; 

foreach $k (keys %{$self->{'config_hash'}}) {
	if ($k =~ /^sync_(.*)$/) {
		push(@{$self->{'sync_array'}}, [ $1, $self->{'config_hash'}->{$k} ]);
		}
	}

1;

1;
		return $self;
}

# useradmin_create_user(&details)
sub useradmin_create_user
{
	my $self = shift;

foreach $s (@{$self->{'sync_array'}}) {
	if ($s->[1] =~ /create/ && !$self->get_authuser($s->[0], $_[0]->{'user'})) {
		$self->lock_file($s->[0]);
		$self->create_authuser($s->[0], { 'user' => $_[0]->{'user'},
					    'pass' => $_[0]->{'pass'} });
		$self->unlock_file($s->[0]);
		}
	}
}

# useradmin_delete_user(&details)
sub useradmin_delete_user
{
	my $self = shift;

foreach $s (@{$self->{'sync_array'}}) {
	if ($s->[1] =~ /delete/) {
		$self->lock_file($s->[0]);
		$self->delete_authuser($s->[0], $_[0]->{'user'});
		$self->unlock_file($s->[0]);
		}
	}
}

# useradmin_modify_user(&details)
sub useradmin_modify_user
{
	my $self = shift;

foreach $s (@{$self->{'sync_array'}}) {
	if ($s->[1] =~ /modify/) {
		$self->lock_file($s->[0]);
		$self->save_authuser($s->[0], $_[0]->{'olduser'},
			       { 'user' => $_[0]->{'user'},
				 'pass' => $_[0]->{'pass'} });
		$self->unlock_file($s->[0]);
		}
	}
}


1;

