#!/usr/bin/perl
package apache::Worker;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'apache::Worker');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# worker.pl
# Defines editors for the fork/thread module in apache 2.0
# The actual functions for most of these are still in core.pl

1;
		return $self;
}

sub worker_directives
{
	my $self = shift;

local $rv;
$rv = [ [ 'CoreDumpDirectory', 0, 9, 'global', 2.0 ],
	[ 'BindAddress Listen Port', 1, 1, 'global', 2.0, 10 ],
	[ 'ListenBacklog', 0, 1, 'global', 2.0 ],
	[ 'LockFile', 0, 9, 'global', 2.0 ],
	[ 'MaxClients', 0, 0, 'global', 2.0 ],
	[ 'MaxRequestsPerChild', 0, 0, 'global', 2.0 ],
	[ 'MinSpareThreads', 0, 0, 'global', 2.0 ],
	[ 'MaxSpareThreads', 0, 0, 'global', 2.0 ],
	[ 'PidFile', 0, 9, 'global', 2.0 ],
	[ 'ScoreBoardFile', 0, 9, 'global', 2.0 ],
	[ 'SendBufferSize', 0, 1, 'global', 2.0 ],
	[ 'StartServers', 0, 0, 'global', 2.0 ],
	[ 'ThreadsPerChild', 0, 0, 'global', 2.0 ],
	[ 'Group', 0, 8, 'global', 2.0 ],
	[ 'User', 0, 8, 'global', 2.0, 10 ] ];
return $self->make_directives($rv, $_[0], "worker");
}

sub edit_MinSpareThreads
{
	my $self = shift;

return (1,
	$self->{'text_hash'}->{'worker_minspare'},
	$self->opt_input($_[0]->{'value'},"MinSpareThreads",$self->{'text_hash'}->{'default'}, 4));
}

sub save_MinSpareThreads
{
	my $self = shift;

return $self->parse_opt("MinSpareThreads", '^\d+$',
		  $self->{'text_hash'}->{'worker_eminspare'});
}

sub edit_MaxSpareThreads
{
	my $self = shift;

return (1,
	$self->{'text_hash'}->{'worker_maxspare'},
	$self->opt_input($_[0]->{'value'},"MaxSpareThreads",$self->{'text_hash'}->{'default'}, 4));
}

sub save_MaxSpareThreads
{
	my $self = shift;

return $self->parse_opt("MaxSpareThreads", '^\d+$',
		  $self->{'text_hash'}->{'worker_emaxspare'});
}

sub edit_ThreadsPerChild
{
	my $self = shift;

return (1,
	$self->{'text_hash'}->{'worker_threads'},
	$self->opt_input($_[0]->{'value'},"ThreadsPerChild",$self->{'text_hash'}->{'default'}, 4));
}

sub save_ThreadsPerChild
{
	my $self = shift;

return $self->parse_opt("ThreadsPerChild", '^\d+$',
		  $self->{'text_hash'}->{'worker_ethreads'});
}


1;

