#!/usr/bin/perl

&MAIN();

 sub MAIN {
# change_files.cgi
# Modify or delete a <Files> clause in a .htaccess file

&ModuleLoader::preload_module('apache_class', "apache::ApacheLib");
$self = new apache::ApacheLib:: 'apache_class',%$self;

$self->ReadParse();
$self->{'access_hash'}->{'global'} || $self->error($self->{'text_hash'}->{'htaccess_ecannot'});
$self->allowed_auth_file($self->{'in_hash'}->{'file'}) ||
	$self->error($self->{'text_hash'}->{'htindex_ecannot'});
$self->{'hconf'} = $self->get_htaccess_config($self->{'in_hash'}->{'file'});
$self->{'d'} = $self->{'hconf'}->[$self->{'in_hash'}->{'idx'}];
$self->lock_file($self->{'d'}->{'file'});
$self->before_changing();
$self->{'lref'} = $self->read_file_lines($self->{'d'}->{'file'});

if ($self->{'in_hash'}->{'delete'}) {
	# deleting a directive
	$self->{'gap'} = $self->{'d'}->{'eline'} - $self->{'d'}->{'line'} + 1;
	splice(@{$self->{'lref'}}, $self->{'d'}->{'line'}, $self->{'d'}->{'eline'} - $self->{'d'}->{'line'} + 1);
	splice(@{$self->{'hconf'}}, $self->{'in_hash'}->{'idx'}, 1);
	$self->renumber($self->{'hconf'}, $self->{'d'}->{'line'}, $self->{'d'}->{'file'}, -$self->{'gap'});
	}
else {
	# changing a directive
	if ($self->{'in_hash'}->{'regexp'}) {
		if ($self->{'httpd_modules_hash'}->{'core'} >= 1.3) {
			$self->{'newdir'} = "<FilesMatch \"$self->{'in_hash'}->{'path'}\">";
			$self->{'enddir'} = "</FilesMatch>";
			}
		else {
			$self->{'newdir'} = "<Files ~ \"$self->{'in_hash'}->{'path'}\">";
			$self->{'enddir'} = "</Files>";
			}
		}
	else {
		$self->{'newdir'} = "<Files \"$self->{'in_hash'}->{'path'}\">";
		$self->{'enddir'} = "</Files>";
		}
	$self->{'lref'}->[$self->{'d'}->{'line'}] = $self->{'newdir'};
	$self->{'lref'}->[$self->{'d'}->{'eline'}] = $self->{'enddir'};
	}
$self->flush_file_lines();
$self->unlock_file($self->{'d'}->{'file'});
$self->after_changing();
$self->webmin_log("files", $self->{'in_hash'}->{'delete'} ? 'delete' : 'save',
	    "$self->{'in_hash'}->{'file'}:$self->{'d'}->{'words'}->[0]", \%{$self->{'in_hash'}});
$self->redirect("htaccess_index.cgi?file=".$self->urlize($self->{'in_hash'}->{'file'}));

1;
		
}


1;

