#!/usr/bin/perl

&MAIN();

 sub MAIN {
# create_htaccess.cgi
# Creates a new .htaccess file for some directory

&ModuleLoader::preload_module('apache_class', "apache::ApacheLib");
$self = new apache::ApacheLib:: 'apache_class',%$self;

$self->ReadParse();
$self->{'access_hash'}->{'global'} || $self->error($self->{'text_hash'}->{'htaccess_ecannot'});
$self->{'conf'} = $self->get_config();

if (-d $self->{'in_hash'}->{'file'}) {
	# user entered a directory.. create a file in that directory
	$self->{'accfile'} = $self->find_directive("AccessFile", $self->{'conf'});
	if (!$self->{'accfile'}) { $self->{'accfile'} = ".htaccess"; }
	$self->{'file'} = "$self->{'in_hash'}->{'file'}/$self->{'accfile'}";
	}
else { $self->{'file'} = $self->{'in_hash'}->{'file'}; }
$self->allowed_auth_file($self->{'file'}) ||
	$self->error($self->{'text_hash'}->{'htaccess_ecreate'});

# create the file (if needed), and add to the known list
$self->lock_file($self->{'file'});
if (!(-r $self->{'file'})) {
	$self->open_tempfile(HTACCESS, ">$self->{'file'}");
	$self->close_tempfile(HTACCESS);
	chmod(0755, $self->{'file'});

	$self->{'u'} = $self->find_directive("User", $self->{'conf'});
	if ($self->{'u'} =~ /#(\d+)/) { $self->{'u'} = $1; }
	elsif (defined($self->{'u'})) { $self->{'u'} = getpwnam($self->{'u'}); }

	$self->{'g'} = $self->find_directive("Group", $self->{'conf'});
	if ($self->{'g'} =~ /#(\d+)/) { $self->{'g'} = $1; }
	elsif (defined($self->{'g'})) { $self->{'g'} = getgrnam($self->{'g'}); }

	chown(defined($self->{'u'}) ? $self->{'u'} : $< , defined($self->{'g'}) ? $self->{'g'} : $( , $self->{'file'});
	}
$self->read_file("$self->{'module_config_directory'}/site", \%{$self->{'site_hash'}});
@{$self->{'ht_array'}} = split(/\s+/, $self->{'site_hash'}->{'htaccess'});
$self->{'site_hash'}->{'htaccess'} = join(' ', $self->unique(@{$self->{'ht_array'}}, $self->{'file'}));
$self->write_file("$self->{'module_config_directory'}/site", \%{$self->{'site_hash'}});
$self->unlock_file($self->{'file'});
$self->webmin_log("htaccess", "create", $self->{'file'});

# redirect to editing index
$self->redirect("htaccess_index.cgi?file=".$self->urlize($self->{'file'}));

1;
		
}


1;

