#!/usr/bin/perl

&MAIN();

 sub MAIN {
# create_virt.cgi
# Create a new virtual host.

&ModuleLoader::preload_module('apache_class', "apache::ApacheLib");
$self = new apache::ApacheLib:: 'apache_class',%$self;

$self->ReadParse();
$self->{'access_hash'}->{'create'} || $self->error($self->{'text_hash'}->{'cvirt_ecannot'});
$self->error_setup($self->{'text_hash'}->{'cvirt_err'});
$self->{'conf'} = $self->get_config();

# get directives from clone
if ($self->{'in_hash'}->{'clone'} ne '') {
	$self->{'clone'} = $self->{'conf'}->[$self->{'in_hash'}->{'clone'}];
	@{$self->{'cmems_array'}} = grep { $_->{'name'} ne 'ServerName' &&
		        $_->{'name'} ne 'Port' &&
		        $_->{'name'} ne 'DocumentRoot' &&
		        $_->{'name'} ne 'ServerAlias' } @{$self->{'clone'}->{'members'}};
	@{$self->{'clines_array'}} = $self->directive_lines(@{$self->{'cmems_array'}});
	}

# Parse and find the specified address to listen on
if ($self->{'in_hash'}->{'addr_def'} == 1) {
	if ($self->{'httpd_modules_hash'}->{'core'} >= 1.2) { $self->{'addr'} = "_default_"; }
	else { $self->{'addr'} = "*"; }
	}
elsif ($self->{'in_hash'}->{'addr_def'} == 2) {
	$self->{'addr'} = "*";
	}
elsif ($self->{'in_hash'}->{'addr'} !~ /\S/) {
	$self->error($self->{'text_hash'}->{'cvirt_eaddr1'});
	}
else {
	@{$self->{'addrs_array'}} = split(/\s+/, $self->{'in_hash'}->{'addr'});
	foreach $a (@{$self->{'addrs_array'}}) {
		gethostbyname($a) || $self->check_ipaddress($a) ||
		    $self->check_ip6address($a) ||
			$self->error($self->text('cvirt_eaddr2', $a));
		}
	$self->{'addr'} = $self->{'in_hash'}->{'addr'};
	}

# Parse and find the specified port
$self->{'defport'} = $self->find_directive("Port", $self->{'conf'}) || 80;
if ($self->{'in_hash'}->{'port_mode'} == 0) {
	$self->{'port'} = "";
	$self->{'portnum'} = $self->{'defport'};
	}
elsif ($self->{'in_hash'}->{'port_mode'} == 1) {
	$self->{'port'} = ":*";
	$self->{'portnum'} = "*";
	}
elsif ($self->{'in_hash'}->{'port'} !~ /^\d+$/) {
	$self->error($self->text('cvirt_eport', $self->{'in_hash'}->{'port'}));
	}
else {
	$self->{'port'} = ":$self->{'in_hash'}->{'port'}";
	$self->{'portnum'} = $self->{'in_hash'}->{'port'};
	}

if (!$self->{'in_hash'}->{'name_def'}) {
	@{$self->{'names_array'}} = split(/\s+/, $self->{'in_hash'}->{'name'});
	@{$self->{'names_array'}} || $self->error($self->text('cvirt_ename', $self->{'in_hash'}->{'name'}));
	}

# Check if the virtual server already exists
if (!$self->{'in_hash'}->{'name_def'}) {
	$self->{'aclname'} = "$self->{'in_hash'}->{'name'}$self->{'port'}";
	@{$self->{'virt_array'}} = $self->find_directive_struct("VirtualHost", $self->{'conf'});
	foreach $v (@{$self->{'virt_array'}}) {
		local ($clash) = grep { $_ eq $self->{'aclname'} } $self->virt_acl_name($v);
		$clash && $self->error($self->{'text_hash'}->{'cvirt_etaken'});
		}
	}

# Check if the root directory is allowed
!$self->{'in_hash'}->{'root'} || $self->allowed_auth_file($self->{'in_hash'}->{'root'}) ||
	$self->error($self->text('cvirt_eroot3', $self->{'in_hash'}->{'root'}));

if ($self->{'in_hash'}->{'root'} && !-d $self->{'in_hash'}->{'root'}) {
	# create the document root
	mkdir($self->{'in_hash'}->{'root'}, 0755) ||
		$self->error($self->text('cvirt_eroot2', $self->{'in_hash'}->{'root'}, $!));
	$self->{'user'} = $self->find_directive("User", $self->{'conf'});
	$self->{'group'} = $self->find_directive("Group", $self->{'conf'});
	$self->{'uid'} = $self->{'user'} ? getpwnam($self->{'user'}) : 0;
	$self->{'gid'} = $self->{'group'} ? getgrnam($self->{'group'}) : 0;
	chown($self->{'uid'}, $self->{'gid'}, $self->{'in_hash'}->{'root'});
	}

# find file to add to
if ($self->{'in_hash'}->{'fmode'} == 0) {
	# Use the first file in config (usually httpd.conf)
	$self->{'vconf'} = $self->get_virtual_config();
	$self->{'f'} = $self->{'vconf'}->[0]->{'file'};
	for($j=0; $self->{'vconf'}->[$j]->{'file'} eq $self->{'f'}; $j++) { }
	$l = $self->{'vconf'}->[$j-1]->{'eline'}+1;
	}
elsif ($self->{'in_hash'}->{'fmode'} == 1) {
	# Use the standard file/directory for virtual hosts
	local $vfile = $self->server_root($self->{'config_hash'}->{'virt_file'});
	if (!-d $vfile) {
		# Just appending to a file
		$self->{'f'} = $vfile;
		}
	elsif ($self->{'in_hash'}->{'name_def'}) {
		# No server name, so use cpplus.UTIME.conf
		$self->{'f'} = "$vfile/cpplus.".time().".conf";
		$self->{'f'} = "$vfile/$self->{'linkfile'}";
		}
	else {
		# Work out a filename
		$self->{'tmpl'} = $self->{'config_hash'}->{'virt_name'} || '${DOM}.conf';
		%{$self->{'hash_hash'}} = ( 'dom' => $self->{'in_hash'}->{'name'},
			  'ip' => $self->{'addr'} );
		$self->{'linkfile'} = $self->substitute_template($self->{'tmpl'}, \%{$self->{'hash_hash'}});
		$self->{'f'} = "$vfile/$self->{'linkfile'}";
		}
	}
else {
	# Use a user-specified file
	$self->{'f'} = $self->{'in_hash'}->{'file'};
	}
-r $self->{'f'} || open(FILE, ">>$self->{'f'}") || $self->error($self->text('cvirt_efile', $self->{'f'}, $!));
close(FILE);

$self->lock_apache_files();
$self->lock_file($self->{'f'});
$self->before_changing();
 
# Check each IP address for a needed Listen and NameVirtualHost directive
foreach $a (@{$self->{'addrs_array'}}) {
	local $ip = $self->to_ipaddress($a);
	if ($self->{'in_hash'}->{'listen'} && $ip) {
		# add Listen if needed
		local @listen = $self->find_directive("Listen", $self->{'conf'});
		local $lfound;
		foreach $l (@listen) {
			if ($self->{'portnum'} eq "*") {
				# Look for any Listen directive that would match the IP
				$lfound++ if ($l eq "*" ||
					      $l =~ /^\d+$/ ||
					      ($l =~ /^(\S+):(\d+)$/ &&
					       $self->to_ipaddress("$1") eq $ip) ||
					      $self->to_ipaddress($l) eq $ip);
				}
			else {
				# Look for a Listen directive that would match
				# the specified port and IP
				$lfound++ if (($l eq '*' && $self->{'portnum'} == $self->{'defport'}) ||
					      ($l =~ /^\*:(\d+)$/ && $self->{'portnum'} == $1) ||
					      ($l =~ /^0\.0\.0\.0:(\d+)$/ && $self->{'portnum'} == $1) ||
					      ($l =~ /^\d+$/ && $self->{'portnum'} == $l) ||
					      ($l =~ /^(\S+):(\d+)$/ &&
					       $self->to_ipaddress("$1") eq $ip &&
					       $2 == $self->{'portnum'}) ||
					      ($self->to_ipaddress($l) eq $ip));
				}
			}
		if (!$lfound && @listen > 0) {
			# Apache is listening on some IP addresses, but not the
			# entered one.
			local $lip;
			if ($self->{'httpd_modules_hash'}->{'core'} >= 2) {
				$lip = $self->{'in_hash'}->{'port_mode'} == 2 ? "$ip:$self->{'in_hash'}->{'port'}"
							     : "$ip:80";
				}
			else {
				$lip = $self->{'in_hash'}->{'port_mode'} == 2 ? "$ip:$self->{'in_hash'}->{'port'}" : $ip;
				}
			$self->save_directive("Listen", [ @listen, $lip ], $self->{'conf'}, $self->{'conf'});
			}
		}

	# add NameVirtualHost if needed
	if ($self->{'in_hash'}->{'nv'} && !$self->{'in_hash'}->{'addr_def'} && $ip) {
		local $found;
		local @nv = $self->find_directive("NameVirtualHost", $self->{'conf'});
		foreach $nv (@nv) {
			$found++ if ($self->to_ipaddress($nv) eq $ip ||
				     $nv =~ /^(\S+):(\S+)/ &&
				      $self->to_ipaddress("$1") eq $ip ||
				     $nv eq '*' ||
				     $nv =~ /^\*:(\d+)$/ && $1 eq $self->{'portnum'} ||
				     $nv =~ /^0\.0\.0\.0:(\d+)$/ && $1 eq $self->{'portnum'});
			}
		if (!$found) {
			$self->save_directive("NameVirtualHost", [ @nv, $ip ], $self->{'conf'}, $self->{'conf'});
			}
		}
	}

# Write out the file
$self->{'lref'} = $self->read_file_lines($self->{'f'});
push(@{$self->{'lref'}}, "");
if (@{$self->{'addrs_array'}}) {
	$self->{'ap'} = join(" ", map { $_.$self->{'port'} } @{$self->{'addrs_array'}});
	}
else {
	$self->{'ap'} = $self->{'addr'}.$self->{'port'};
	}
push(@{$self->{'lref'}}, "<VirtualHost $self->{'ap'}>");
push(@{$self->{'lref'}}, "DocumentRoot \"$self->{'in_hash'}->{'root'}\"") if ($self->{'in_hash'}->{'root'});
if (@{$self->{'names_array'}}) {
	push(@{$self->{'lref'}}, "ServerName $self->{'names_array'}->[0]");
	shift(@{$self->{'names_array'}});
	foreach $sa (@{$self->{'names_array'}}) {
		push(@{$self->{'lref'}}, "ServerAlias $sa");
		}
	}
push(@{$self->{'lref'}}, @{$self->{'clines_array'}});
if ($self->{'in_hash'}->{'adddir'} && $self->{'in_hash'}->{'root'}) {
	# Add a <Directory> section for the root
	push(@{$self->{'lref'}}, "<Directory \"$self->{'in_hash'}->{'root'}\">");
	push(@{$self->{'lref'}}, "allow from all");
	push(@{$self->{'lref'}}, "Options +Indexes");
	push(@{$self->{'lref'}}, "</Directory>");
	}
push(@{$self->{'lref'}}, "</VirtualHost>");
$self->flush_file_lines();
$self->unlock_file($self->{'f'});
$self->unlock_apache_files();

# Create a symlink from another dir, if requested (as in Debian)
if ($self->{'linkfile'}) {
	$self->create_webfile_link($self->{'f'});
	}

# Make sure it was really added
undef(@{$self->{'get_config_cache_array'}});
$self->{'conf'} = $self->get_config();
$found = 0;
foreach $v ($self->find_directive_struct("VirtualHost", $self->{'conf'})) {
	next if ($v->{'value'} ne $self->{'ap'});
	if (@{$self->{'names_array'}}) {
		$self->{'nsn'} = $self->find_directive("ServerName", $v->{'members'});
		next if ($self->{'nsn'} ne $self->{'names_array'}->[0]);
		}
	$found = 1;
	}
if (!$found) {
	$self->rollback_apache_config();
	$self->error($self->text('cvirt_emissing', $self->{'f'}, "../config.cgi?$self->{'module_name'}"));
	}

$self->after_changing();
$self->webmin_log("virt", "create", ($self->{'in_hash'}->{'name_def'} ? $self->{'addr'} : $self->{'in_hash'}->{'name'}).$self->{'port'},
	    \%{$self->{'in_hash'}});

# add to acl
if ($self->{'access_hash'}->{'virts'} ne '*') {
	$self->{'access_hash'}->{'virts'} .= " $self->{'aclname'}";
	$self->save_module_acl(\%{$self->{'access_hash'}});
	}
$self->redirect("");

1;
		
}


1;

