#!/usr/bin/perl

&MAIN();

 sub MAIN {
# find_htaccess.cgi
# Finds all per-directory options files under the all the document roots

&ModuleLoader::preload_module('apache_class', "apache::ApacheLib");
$self = new apache::ApacheLib:: 'apache_class',%$self;

$self->ReadParse();
$self->{'access_hash'}->{'global'} || $self->error($self->{'text_hash'}->{'htaccess_ecannot'});

$self->{'in_hash'}->{'from'}=1 if ($self->{'access_hash'}->{'dir'} ne '/');
if ($self->{'in_hash'}->{'from'} == 1 && !(-d $self->{'in_hash'}->{'dir'})) {
	$self->error($self->text('htaccess_edir', $self->{'in_hash'}->{'dir'}));
	}
$self->read_file("$self->{'module_config_directory'}/site", \%{$self->{'site_hash'}});
foreach $f (split(/\s+/, $self->{'site_hash'}->{'htaccess'})) {
	if (-r $f) { push(@{$self->{'rv_array'}}, $f); }
	}

# Find the default document root and access file
$self->{'conf'} = $self->get_config();
$self->{'def_htaccess'} = $self->find_directive("AccessFileName", $self->{'conf'});
if (!$self->{'def_htaccess'}) { $self->{'def_htaccess'} = ".htaccess"; }
$self->{'def_root'} = $self->find_directive("DocumentRoot", $self->{'conf'});
if (!$self->{'def_root'}) { $self->{'def_root'} = "/"; }

# find virtual server doc roots and access files
push(@{$self->{'dirs_array'}}, $self->{'def_root'}); push(@{$self->{'files_array'}}, $self->{'def_htaccess'});
foreach $v ($self->find_directive_struct("VirtualHost", $self->{'conf'})) {
	$self->{'root'} = $self->find_directive("DocumentRoot", $v->{'members'});
	push(@{$self->{'dirs_array'}}, $self->{'root'} ? $self->{'root'} : $self->{'def_root'});
	$self->{'htaccess'} = $self->find_directive("AccessFileName", $v->{'members'});
	push(@{$self->{'files_array'}}, $self->{'htaccess'} ? $self->{'htaccess'} : $self->{'def_htaccess'});
	}

if ($self->{'in_hash'}->{'from'} == 0) {
	# search under all directories
	for($i=0; $i<@{$self->{'dirs_array'}}; $i++) {
		open(FIND, "find $self->{'dirs_array'}->[$i] -name $self->{'files_array'}->[$i] -print |");
		while(<FIND>) {
			s/\r|\n//g;
			push(@{$self->{'rv_array'}}, $_);
			}
		close(FIND);
		}
	}
else {
	# search under the given directory only
	foreach $f ($self->unique(@{$self->{'files_array'}})) { push(@{$self->{'args_array'}}, "-name $f"); }
	$self->{'args'} = join(' -o ', @{$self->{'args_array'}});
	open(FIND, "find $self->{'in_hash'}->{'dir'} $self->{'args'} -print |");
	while(<FIND>) {
		s/\r|\n//g;
		push(@{$self->{'rv_array'}}, $_);
		}
	close(FIND);
	}

# save results
$self->{'site_hash'}->{'htaccess'} = join(' ', $self->unique(@{$self->{'rv_array'}}));
$self->write_file("$self->{'module_config_directory'}/site", \%{$self->{'site_hash'}});
$self->redirect("htaccess.cgi");

1;
		
}


1;

