#!/usr/bin/perl

&MAIN();

 sub MAIN {
# htaccess_index.cgi
# Display a menu of icons for a per-directory options file

&ModuleLoader::preload_module('apache_class', "apache::ApacheLib");
$self = new apache::ApacheLib:: 'apache_class',%$self;

$self->ReadParse();
$self->{'access_hash'}->{'global'} || $self->error($self->{'text_hash'}->{'htaccess_ecannot'});
$self->allowed_auth_file($self->{'in_hash'}->{'file'}) ||
	$self->error($self->{'text_hash'}->{'htindex_ecannot'});
$self->{'conf'} = $self->get_htaccess_config($self->{'in_hash'}->{'file'});
$self->{'desc'} = $self->html_escape($self->{'in_hash'}->{'file'});
$self->ui_print_header($self->{'desc'}, $self->{'text_hash'}->{'htindex_title'}, "",
	undef, undef, undef, undef, "<a href=\"delete_htaccess.cgi?file=".
	$self->urlize($self->{'in_hash'}->{'file'})."\">$self->{'text_hash'}->{'htindex_delete'}</a>");

print $self->ui_subheading($self->{'text_hash'}->{'htindex_opts'});
$self->{'sw_icon'} = { "icon" => "images/show.gif",
	     "name" => $self->{'text_hash'}->{'htindex_show'},
	     "link" => "show.cgi?file=".$self->urlize($self->{'in_hash'}->{'file'}) };
if ($self->{'access_hash'}->{'types'} eq '*') {
	$self->{'ed_icon'} = { "icon" => "images/edit.gif",
		     "name" => $self->{'text_hash'}->{'htindex_edit'},
		     "link" => "manual_form.cgi?file=".$self->urlize($self->{'in_hash'}->{'file'}) };
	}
$self->config_icons("htaccess", "edit_htaccess.cgi?file=".$self->urlize($self->{'in_hash'}->{'file'})."&",
	      $self->{'sw_icon'}, $self->{'ed_icon'} ? ( $self->{'ed_icon'} ) : ( ));

@{$self->{'file_array'}} = ( $self->find_directive_struct("Files", $self->{'conf'}),
          $self->find_directive_struct("FilesMatch", $self->{'conf'}) );
if (@{$self->{'file_array'}} && $self->{'httpd_modules_hash'}->{'core'} >= 1.2) {
	# Files sub-directives
	print "<hr>\n";
	print $self->ui_subheading($self->{'text_hash'}->{'htindex_file'});
	foreach $f (@{$self->{'file_array'}}) {
		$self->{'what'} = $self->dir_name($f);
		substr($self->{'what'}, 0, 1) = uc(substr($self->{'what'}, 0, 1));
		push(@{$self->{'links_array'}}, "files_index.cgi?idx=".$self->indexof($f, @{$self->{'conf'}}).
                             "&file=".$self->urlize($self->{'in_hash'}->{'file'}));
		push(@{$self->{'titles_array'}}, $self->{'what'});
		push(@{$self->{'icons_array'}}, "images/dir.gif");
		push(@{$self->{'types_array'}}, $f->{'name'});
		}
	if ($self->{'config_hash'}->{'show_list'}) {
		# Show as list
		print $self->ui_columns_start([ $self->{'text_hash'}->{'virt_path'},
					  $self->{'text_hash'}->{'virt_type'} ]);
		for($i=0; $i<@{$self->{'links_array'}}; $i++) {
			print $self->ui_columns_row([
			  "<a href='$self->{'links_array'}->[$i]'>$self->{'titles_array'}->[$i]</a>",
			  $self->{'text_hash'}->{'virt_'.$self->{'types_array'}->[$i]} ]);
			}
		print $self->ui_columns_end();
		}
	else {
		$self->icons_table(\@{$self->{'links_array'}}, \@{$self->{'titles_array'}}, \@{$self->{'icons_array'}}, 3);
		}
	print "<p>\n";
	}

if ($self->{'httpd_modules_hash'}->{'core'} >= 1.2) {
	print $self->ui_form_start("create_files.cgi");
	print $self->ui_hidden("file", $self->{'in_hash'}->{'file'});
	print $self->ui_table_start($self->{'text_hash'}->{'htindex_create'}, undef, 2);

	print $self->ui_table_row($self->{'text_hash'}->{'htindex_regexp'},
		$self->ui_radio("regexp", 0,
			  [ [ 0, $self->{'text_hash'}->{'htindex_exact'} ],
			    [ 1, $self->{'text_hash'}->{'htindex_re'} ] ]));

	print $self->ui_table_row($self->{'text_hash'}->{'htindex_path'},
		$self->ui_textbox("path", undef, 50));

	print $self->ui_table_end();
	print $self->ui_form_end([ [ undef, $self->{'text_hash'}->{'create'} ] ]);
	}

$self->ui_print_footer("htaccess.cgi", $self->{'text_hash'}->{'htaccess_return'});

1;
		
}


1;

