#!/usr/bin/perl

&MAIN();

 sub MAIN {
# index.cgi
# Display a list of all virtual servers, and links for various types
# of global configuration

&ModuleLoader::preload_module('apache_class', "apache::ApacheLib");
$self = new apache::ApacheLib:: 'apache_class',%$self;

$self->ReadParse();

# check for the executable
if (!($self->{'httpd'} = $self->find_httpd())) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", undef, 1, 1);
	print $self->text('index_eserver', "<tt>$self->{'config_hash'}->{'httpd_path'}</tt>",
		    "$self->{'gconfig_hash'}->{'webprefix'}/config.cgi?$self->{'module_name'}"),"<p>\n";
	$self->foreign_require("software", "software-lib.pl");
	$self->{'lnk'} = $main::software_object->missing_install_link("apache", $self->{'text_hash'}->{'index_apache'},
			"../$self->{'module_name'}/", $self->{'text_hash'}->{'index_title'});
	print $self->{'lnk'},"<p>\n" if ($self->{'lnk'});
	$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});
	exit;
	}

# check for the base directory
if (!(-d $self->{'config_hash'}->{'httpd_dir'})) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", undef, 1, 1);
	print $self->text('index_eroot', "<tt>$self->{'config_hash'}->{'httpd_dir'}</tt>",
		    "$self->{'gconfig_hash'}->{'webprefix'}/config.cgi?$self->{'module_name'}"),"<p>\n";
	$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});
	exit;
	}

# check if this is a new apache install, by looking for -dist files
$self->{'conf'} = "$self->{'config_hash'}->{'httpd_dir'}/etc";
if (!-d $self->{'conf'}) { $self->{'conf'} = "$self->{'config_hash'}->{'httpd_dir'}/conf"; }
if (!$self->{'config_hash'}->{'httpd_conf'} && !(-e "$self->{'conf'}/httpd.conf") &&
    (-e "$self->{'conf'}/httpd.conf-dist") &&
    (-d $self->{'conf'})) {
	# copy all the .dist files and fix up @@ServerRoot@@ references
	# Only needed for apache versions < 1.3, which don't do this as part
	# of the 'make install'
	$self->{'sroot'} = $self->{'config_hash'}->{'httpd_dir'};
	opendir(CONF, $self->{'conf'});
	foreach $f (readdir(CONF)) {
		if ($f =~ /^(.*)-dist$/) {
			open(DIST, "$self->{'conf'}/$f");
			@{$self->{'dist_array'}} = <DIST>;
			close(DIST);
			$self->open_tempfile(REAL, ">$self->{'conf'}/$1");
			foreach (@{$self->{'dist_array'}}) {
				s/\/usr\/local\/etc\/httpd/$self->{'sroot'}/g;
				s/\@\@ServerRoot\@\@/$self->{'sroot'}/g;
				$self->print_tempfile(REAL, $_);
				}
			$self->close_tempfile(REAL);
			}
		}
	close(CONF);
	}

# check for an -example file
if ($self->{'config_hash'}->{'httpd_conf'} && !-e $self->{'config_hash'}->{'httpd_conf'} &&
    -e $self->{'config_hash'}->{'httpd_conf'}."-example") {
	system("cp ".quotemeta($self->{'config_hash'}->{'httpd_conf'}."-example")." ".
		     quotemeta($self->{'config_hash'}->{'httpd_conf'}));
	}

# check for the httpd.conf file
($self->{'htconf'}, $self->{'htconfchecked'}) = $self->find_httpd_conf();
if (!$self->{'htconf'}) {
	# still doesn't exist!
	$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", undef, 1, 1);
	print "<p>\n";
	print $self->text('index_econf', "<tt>$self->{'htconfchecked'}</tt>",
		    "$self->{'gconfig_hash'}->{'webprefix'}/config.cgi?$self->{'module_name'}"),"<p>\n";
	$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});
	exit;
	}

# check for multiple port directives
$self->{'conf'} = $self->get_config();
@{$self->{'prt_array'}} = $self->find_directive("Port", $self->{'conf'});
if (@{$self->{'prt_array'}} > 1 && $self->{'httpd_modules_hash'}->{'core'} < 1.3) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", undef, 1, 1);
	print "<p>\n";
	print $self->text('index_eports', 'Port'),"<p>\n";
	$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});
	exit;
	}

# add default server
$self->{'defport'} = $self->find_directive("Port", $self->{'conf'}, 1);
if ($self->can_edit_virt()) {
	local $sn = $self->find_directive("ServerName", $self->{'conf'}, 1);
	push(@{$self->{'vidx_array'}}, undef);
	push(@{$self->{'vname_array'}}, $self->{'text_hash'}->{'index_defserv'});
	push(@{$self->{'vlink_array'}}, "virt_index.cgi");
	push(@{$self->{'vdesc_array'}}, $self->{'text_hash'}->{'index_defdesc1'});
	push(@{$self->{'vaddr_array'}}, $self->{'text_hash'}->{'index_any'});
	push(@{$self->{'vport_array'}}, $self->{'text_hash'}->{'index_any'});
	push(@{$self->{'vserv_array'}}, $self->def($sn, $self->{'text_hash'}->{'index_auto'}));
	push(@{$self->{'vroot_array'}}, $self->def($self->find_directive("DocumentRoot", $self->{'conf'}, 1),
			  $self->{'text_hash'}->{'index_auto'}));
	push(@{$self->{'vproxy_array'}}, undef);
	$sn ||= $self->get_system_hostname();
	push(@{$self->{'vurl_array'}}, $self->{'defport'} ? "http://$sn:$self->{'defport'}/" : "http://$sn/");
	$self->{'showing_default'}++;
	}

# add other servers
@{$self->{'virt_array'}} = $self->find_directive_struct("VirtualHost", $self->{'conf'});
if ($self->{'httpd_modules_hash'}->{'core'} >= 1.3) {
	# build list of name-based virtual host IP addresses
	@nv = $self->find_directive("NameVirtualHost", $self->{'conf'});
	foreach $nv (@nv) {
		$nv{$nv =~ /^\*/ ? "*" : $self->to_ipaddress($nv)}++;
		}
	}
elsif ($self->{'httpd_modules_hash'}->{'core'} >= 1.2) {
	# only one name-based virtual host IP address - the default address
	$self->{'ba'} = $self->find_directive("ServerName", $self->{'conf'});
	$nv{$self->to_ipaddress($self->{'ba'} ? $self->{'ba'} : $self->get_system_hostname())}++;
	}
@{$self->{'virt_array'}} = grep { $self->can_edit_virt($_) } @{$self->{'virt_array'}};
if ($self->{'config_hash'}->{'show_order'} == 1) {
	# sort by server name
	@{$self->{'virt_array'}} = sort { &server_name_sort($a) cmp &server_name_sort($b) } @{$self->{'virt_array'}};
	}
elsif ($self->{'config_hash'}->{'show_order'} == 2) {
	# sort by IP address
	@{$self->{'virt_array'}} = sort { &server_ip_sort($a) cmp &server_ip_sort($b) } @{$self->{'virt_array'}};
	}
foreach $v (@{$self->{'virt_array'}}) {
	$self->{'vm'} = $v->{'members'};
	if ($v->{'words'}->[0] =~ /^(\S+):(\S+)$/) {
		$self->{'addr'} = $1;
		$self->{'port'} = $2;
		}
	else {
		$self->{'addr'} = $v->{'words'}->[0];
		if ($self->{'httpd_modules_hash'}->{'core'} < 2.0) {
			$self->{'port'} = $self->def($self->find_directive("Port", $self->{'conf'}), 80);
			}
		else {
			$self->{'port'} = "*";
			}
		}
	$self->{'idx'} = $self->indexof($v, @{$self->{'conf'}});
	push(@{$self->{'vidx_array'}}, $self->{'idx'});
	push(@{$self->{'vname_array'}}, $self->{'text_hash'}->{'index_virt'});
	push(@{$self->{'vlink_array'}}, "virt_index.cgi?virt=$self->{'idx'}");
	$self->{'sname'} = $self->find_directive("ServerName", $self->{'vm'});
	local $daddr = $self->{'addr'} eq "_default_" ||
                       ($self->{'addr'} eq "*" && $self->{'httpd_modules_hash'}->{'core'} < 1.2);
	if ($nv{"*"}) {
		if ($daddr) {
			push(@{$self->{'vdesc_array'}}, $self->text('index_vnamed', "<tt>$self->{'sname'}</tt>"));
			}
		else {
			push(@{$self->{'vdesc_array'}}, $self->text('index_vname', "<tt>$self->{'sname'}</tt>",
					   "<tt>$self->{'addr'}</tt>"));
			}
		}
	elsif (!$daddr && $nv{$self->to_ipaddress($self->{'addr'})}) {
		push(@{$self->{'vdesc_array'}}, $self->text('index_vname', "<tt>$self->{'sname'}</tt>",
				   "<tt>$self->{'addr'}</tt>"));
		}
	elsif (!$daddr && $self->{'addr'} eq "*") {
		push(@{$self->{'vdesc_array'}}, $self->text('index_vnamed', "<tt>$self->{'sname'}</tt>"));
		}
	elsif ($daddr && $self->{'port'} eq "*") {
		push(@{$self->{'vdesc_array'}}, $self->{'text_hash'}->{'index_vdef'});
		$self->{'vdesc_array'}->[0] = $self->{'text_hash'}->{'index_defdesc2'};
		}
	elsif ($daddr) {
		push(@{$self->{'vdesc_array'}}, $self->text('index_vport', $self->{'port'}));
		}
	elsif ($self->{'port'} eq "*") {
		push(@{$self->{'vdesc_array'}}, $self->text('index_vaddr', "<tt>$self->{'addr'}</tt>"));
		}
	else {
		push(@{$self->{'vdesc_array'}}, $self->text('index_vaddrport', "<tt>$self->{'addr'}</tt>", $self->{'port'}));
		}
	push(@{$self->{'vaddr_array'}}, $self->{'addr'} eq "_default_" || $self->{'addr'} eq "*" ? $self->{'text_hash'}->{'index_any'}
							  : $self->{'addr'});
	push(@{$self->{'vport_array'}}, $self->{'port'} eq "*" ? $self->{'text_hash'}->{'index_any'} : $self->{'port'});
	local $sn = $self->find_vdirective("ServerName", $self->{'vm'}, $self->{'conf'}, 1);
	push(@{$self->{'vserv_array'}}, $self->def($sn, $self->{'text_hash'}->{'index_auto'}));
	$self->{'pp'} = $self->find_directive_struct("ProxyPass", $self->{'vm'});
	if ($self->{'pp'}->{'words'}->[0] eq "/") {
		push(@{$self->{'vproxy_array'}}, $self->{'pp'}->{'words'}->[1]);
		push(@{$self->{'vroot_array'}}, undef);
		}
	else {
		push(@{$self->{'vproxy_array'}}, undef);
		push(@{$self->{'vroot_array'}}, $self->def($self->find_vdirective("DocumentRoot",$self->{'vm'},$self->{'conf'},1),
				  $self->{'text_hash'}->{'index_default'}));
		}
	$self->{'cname_hash'}->{$v} = sprintf "%s:%s (%s)", $self->{'vserv_array'}->[$#{$self->{'vserv_array'}}], $self->{'vport_array'}->[$#{$self->{'vport_array'}}],
					   $self->{'vproxy_array'}->[$#{$self->{'vproxy_array'}}] || $self->{'vroot_array'}->[$#{$self->{'vroot_array'}}];
	local $sp = $self->{'port'} eq "*" ? $self->{'defport'} : $self->{'port'};
	local $prot = "http";
	if ($self->find_vdirective("SSLEngine", $self->{'vm'}, $self->{'conf'}, 1) eq "on") {
		$prot = "https";
		}
	push(@{$self->{'vurl_array'}}, $sp ? "$prot://$sn:$sp/" : "$prot://$sn/");
	}

if (@{$self->{'vlink_array'}} == 1 && !$self->{'access_hash'}->{'global'} && $self->{'access_hash'}->{'virts'} ne "*" &&
    !$self->{'access_hash'}->{'create'} && $self->{'access_hash'}->{'noconfig'}) {
	# Can only manage one vhost, so go direct to it
	$self->redirect($self->{'vlink_array'}->[0]);
	exit;
	}

# Page header
$self->{'ver'} = $self->{'httpd_modules_hash'}->{'core'};
$self->{'ver'} =~ s/^(\d+)\.(\d)(\d+)$/$1.$2.$3/;
$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", undef, 1, 1, undef,
	$self->restart_button()."<br>".
	$self->help_search_link("apache", "man", "doc", "google"), undef, undef,
	$self->text('index_version', $self->{'ver'}));

# Show tabs
@{$self->{'tabs_array'}} = map { [ $_, $self->{'text_hash'}->{'index_tab'.$_}, "index.cgi?mode=$_" ] }
	    ( $self->{'access_hash'}->{'global'} ? ( "global" ) : ( ),
	      "list",
	      $self->{'access_hash'}->{'create'} ? ( "create" ) : ( ) );
print $self->ui_tabs_start(\@{$self->{'tabs_array'}}, "mode", $self->{'in_hash'}->{'mode'} || "list", 1);

# global config options
if ($self->{'access_hash'}->{'global'}) {
	print $self->ui_tabs_start_tab("mode", "global");
	#print $self->{'text_hash'}->{'index_descglobal'},"<p>\n";
	if ($self->{'access_hash'}->{'global'} == 1) {
		$self->{'ht_icon'} = { "icon" => "images/dir.gif",
			     "name" => $self->{'text_hash'}->{'htaccess_title'},
			     "link" => "htaccess.cgi" };
		$self->{'rc_icon'} = { "icon" => "images/recon.gif",
			     "name" => $self->{'text_hash'}->{'reconfig_title'},
			     "link" =>
				"reconfig_form.cgi?size=$self->{'httpd_size'}&vol=1" };
		$self->{'df_icon'} = { "icon" => "images/defines.gif",
			     "name" => $self->{'text_hash'}->{'defines_title'},
			     "link" => "edit_defines.cgi" };
		$self->{'ed_icon'} = { "icon" => "images/edit.gif",
			     "name" => $self->{'text_hash'}->{'manual_configs'},
			     "link" => "allmanual_form.cgi" };
		$self->{'ds_icon'} = { "icon" => "images/virt.gif",
			     "name" => $self->{'text_hash'}->{'index_defserv'},
			     "link" => "virt_index.cgi" };
		$self->config_icons("global", "edit_global.cgi?",
			      $self->{'ht_icon'}, $self->{'rc_icon'}, $self->{'df_icon'},
			      $self->{'access_hash'}->{'types'} eq '*' &&
			      $self->{'access_hash'}->{'virts'} eq "*" ? ( $self->{'ed_icon'} ) : ( ),
			      $self->{'showing_default'} &&
			      @{$self->{'vname_array'}} > $self->{'config_hash'}->{'max_servers'} &&
			      $self->{'config_hash'}->{'max_servers'} ? ( $self->{'ds_icon'} ) : ( ) );
		}
	else {
		$self->icons_table([ "htaccess.cgi" ],
			     [ $self->{'text_hash'}->{'htaccess_title'} ],
			     [ "images/dir.gif" ]);
		}
	print $self->ui_tabs_end_tab();
	}

# work out select links
print $self->ui_tabs_start_tab("mode", "list");
#print $self->{'text_hash'}->{'index_desclist'},"<p>\n";
$self->{'showdel'} = $self->{'access_hash'}->{'vaddr'} && ($self->{'vidx_array'}->[0] || $self->{'vidx_array'}->[1]);
@{$self->{'links_array'}} = ( );
if ($self->{'showdel'}) {
	push(@{$self->{'links_array'}}, $self->select_all_link("d"),
		     $self->select_invert_link("d"));
	}

# display servers
$self->{'formno'} = 0;
if ($self->{'config_hash'}->{'max_servers'} && @{$self->{'vname_array'}} > $self->{'config_hash'}->{'max_servers'}) {
	# as search form for people with lots and lots of servers
	print "<b>$self->{'text_hash'}->{'index_toomany'}</b><p>\n";
	print "<form action=search_virt.cgi>\n";
	print "<b>$self->{'text_hash'}->{'index_find'}</b> <select name=field>\n";
	print "<option value=name checked> $self->{'text_hash'}->{'index_name'}\n";
	print "<option value=port> $self->{'text_hash'}->{'index_port'}\n";
	print "<option value=addr> $self->{'text_hash'}->{'index_addr'}\n";
	print "<option value=root> $self->{'text_hash'}->{'index_root'}\n";
	print "</select> <select name=match>\n";
	print "<option value=0 checked>$self->{'text_hash'}->{'index_equals'}\n";
	print "<option value=1>$self->{'text_hash'}->{'index_matches'}\n";
	print "<option value=2>$self->{'text_hash'}->{'index_nequals'}\n";
	print "<option value=3>$self->{'text_hash'}->{'index_nmatches'}\n";
	print "</select> <input name=what size=15>&nbsp;&nbsp;\n";
	print "<input type=submit value=\"$self->{'text_hash'}->{'find'}\"></form><p>\n";
	$self->{'formno'}++;
	}
elsif ($self->{'config_hash'}->{'show_list'} && scalar(@{$self->{'vname_array'}})) {
	# as list for people with lots of servers
	if ($self->{'showdel'}) {
		print $self->ui_form_start("delete_vservs.cgi", "post");
		}
	print $self->ui_links_row(\@{$self->{'links_array'}});
	print $self->ui_columns_start([
		$self->{'showdel'} ? ( "" ) : ( ),
		$self->{'text_hash'}->{'index_type'},
		$self->{'text_hash'}->{'index_addr'},
		$self->{'text_hash'}->{'index_port'},
		$self->{'text_hash'}->{'index_name'},
		$self->{'text_hash'}->{'index_root'},
		$self->{'text_hash'}->{'index_url'} ], 100);
	for($i=0; $i<@{$self->{'vname_array'}}; $i++) {
		local @cols;
		push(@cols, "<a href=\"$self->{'vlink_array'}->[$i]\">$self->{'vname_array'}->[$i]</a>");
		push(@cols, $self->html_escape($self->{'vaddr_array'}->[$i]));
		push(@cols, $self->html_escape($self->{'vport_array'}->[$i]));
		push(@cols, $self->html_escape($self->{'vserv_array'}->[$i]));
		push(@cols, $self->html_escape($self->{'vproxy_array'}->[$i]) ||
			    $self->html_escape($self->{'vroot_array'}->[$i]));
		push(@cols, "<a href=$self->{'vurl_array'}->[$i]>$self->{'text_hash'}->{'index_view'}</a>");
		if ($self->{'showdel'} && $self->{'vidx_array'}->[$i]) {
			print $self->ui_checked_columns_row(\@cols, undef,
						      "d", $self->{'vidx_array'}->[$i]);
			}
		elsif ($self->{'showdel'}) {
			print $self->ui_columns_row([ "", @cols ]);
			}
		else {
			print $self->ui_columns_row(\@cols);
			}
		}
	print $self->ui_columns_end();
	print $self->ui_links_row(\@{$self->{'links_array'}});
	if ($self->{'showdel'}) {
		print $self->ui_form_end([ [ "delete", $self->{'text_hash'}->{'index_delete'} ] ]);
		}
	}
else {
	# as icons for niceness
	if ($self->{'showdel'}) {
		print $self->ui_form_start("delete_vservs.cgi", "post");
		}
	print $self->ui_links_row(\@{$self->{'links_array'}});
	print "<table width=100% cellpadding=5>\n";
	for($i=0; $i<@{$self->{'vname_array'}}; $i++) {
		print "<tr> <td valign=top align=center nowrap>";
		$self->generate_icon("images/virt.gif", $self->{'vname_array'}->[$i], $self->{'vlink_array'}->[$i],
			       undef, undef, undef,
			       $self->{'vidx_array'}->[$i] && $self->{'access_hash'}->{'vaddr'} ?
					$self->ui_checkbox("d", $self->{'vidx_array'}->[$i]) : "");
		print "</td> <td valign=top>\n";
		print "$self->{'vdesc_array'}->[$i]<br>\n";
		print "<table width=100%><tr>\n";
		print "<td width=30%><b>$self->{'text_hash'}->{'index_addr'}</b> ",
		      $self->html_escape($self->{'vaddr_array'}->[$i]),"<br>\n";
		print "<b>$self->{'text_hash'}->{'index_port'}</b> ",
		      $self->html_escape($self->{'vport_array'}->[$i]),"</td>\n";
		print "<td width=70%><b>$self->{'text_hash'}->{'index_name'}</b> ",
		      $self->html_escape($self->{'vserv_array'}->[$i]),"<br>\n";
		if ($self->{'vproxy_array'}->[$i]) {
			print "<b>$self->{'text_hash'}->{'index_proxy'}</b> ",
			      $self->html_escape($self->{'vproxy_array'}->[$i]),"</td> </tr>\n";
			}
		else {
			print "<b>$self->{'text_hash'}->{'index_root'}</b> ",
			      $self->html_escape($self->{'vroot_array'}->[$i]),"</td> </tr>\n";
			}
		print "</table></td> </tr>\n";
		}
	print "</table>\n";
	print $self->ui_links_row(\@{$self->{'links_array'}});
	if ($self->{'showdel'}) {
		print $self->ui_form_end([ [ "delete", $self->{'text_hash'}->{'index_delete'} ] ]);
		}
	}
print $self->ui_tabs_end_tab();

if ($self->{'access_hash'}->{'create'}) {
	print $self->ui_tabs_start_tab("mode", "create");
	#print $self->{'text_hash'}->{'index_desccreate'},"<p>\n";
	print $self->ui_form_start("create_virt.cgi");
	print $self->ui_table_start($self->{'text_hash'}->{'index_create'}, undef, 2);

	# IP address
	print $self->ui_table_row($self->{'text_hash'}->{'index_newaddr'},
		$self->ui_radio("addr_def", 2,
		  [ [ 1, "$self->{'text_hash'}->{'index_any1'}<br>" ],
		    [ 2, "$self->{'text_hash'}->{'index_any2'}<br>" ],
		    [ 0, $self->{'text_hash'}->{'index_any0'}." ".
			 $self->ui_textbox("addr", undef, 20) ] ])."<br>\n".
		$self->ui_checkbox("nv", 1, $self->{'text_hash'}->{'index_nv'}, 1)."<br>".
		$self->ui_checkbox("listen", 1, $self->{'text_hash'}->{'index_listen'}, 1));

	# Port
	print $self->ui_table_row($self->{'text_hash'}->{'index_port'},
		$self->choice_input("0", "port_mode", "0",
				   "$self->{'text_hash'}->{'index_default'},0",
				   "$self->{'text_hash'}->{'index_any'},1", ",2").
		$self->ui_textbox("port", undef, 5));

	# Document root
	print $self->ui_table_row($self->{'text_hash'}->{'index_root'},
		$self->ui_textbox("root", undef, 40)." ".
		$self->file_chooser_button("root", 1, $self->{'formno'})."<br>".
		$self->ui_checkbox("adddir", 1, $self->{'text_hash'}->{'index_adddir'}, 1));

	# Server name
	print $self->ui_table_row($self->{'text_hash'}->{'index_name'},
		$self->opt_input("", "name", $self->{'text_hash'}->{'index_auto'}, 30));

	# Add to file
	print $self->ui_table_row($self->{'text_hash'}->{'index_file'},
		$self->ui_radio("fmode", $self->{'config_hash'}->{'virt_file'} ? 1 : 0,
		  [ [ 0, $self->text('index_fmode0', "<tt>httpd.conf</tt>")."<br>" ],
		    $self->{'config_hash'}->{'virt_file'} ? (
		      [ 1, $self->text(-d $self->{'config_hash'}->{'virt_file'} ? 'index_fmode1d'
                                                      : 'index_fmode1',
                              "<tt>$self->{'config_hash'}->{'virt_file'}</tt>")."<br>" ] ) : ( ),
		    [ 2, $self->{'text_hash'}->{'index_fmode2'}." ".
			 $self->ui_textbox("file", undef, 40)." ".
			 $self->file_chooser_button("file", 0, $self->{'formno'}) ] ]));

	# Server to clone
	print $self->ui_table_row($self->{'text_hash'}->{'index_clone'},
		$self->ui_select("clone", undef,
		  [ [ undef, $self->{'text_hash'}->{'index_noclone'} ],
		    map { [ $self->indexof($_, @{$self->{'conf'}}), $self->{'cname_hash'}->{$_} ] } @{$self->{'virt_array'}} ]));

	print $self->ui_table_end();
	print $self->ui_form_end([ [ undef, $self->{'text_hash'}->{'index_crnow'} ] ]);
	print $self->ui_tabs_end_tab();
	}

$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});

1;
		
}

sub server_name_sort
{
	shift if ($self == $_[0]);

return $self->def($self->find_vdirective("ServerName", $_[0]->{'members'}, $self->{'conf'}),
	    $_[0]->{'value'});
}

sub server_ip_sort
{
	shift if ($self == $_[0]);

local $addr = $_[0]->{'words'}->[0] =~ /^(\S+):(\S+)/ ? $1 :
		$_[0]->{'words'}->[0];
return $addr eq '_default_' || $addr eq '*' ? undef :
       $self->check_ipaddress($addr) ? $addr :
       $self->check_ip6address($addr) ? $addr :
			         $self->to_ipaddress($addr);
}


1;

