#!/usr/bin/perl

&MAIN();

 sub MAIN {
# manual.cgi
# Display a text box for manually editing directives

&ModuleLoader::preload_module('apache_class', "apache::ApacheLib");
$self = new apache::ApacheLib:: 'apache_class',%$self;

$self->ReadParse();
$self->{'access_hash'}->{'types'} eq '*' || $self->error($self->{'text_hash'}->{'manual_ecannot'});
if (defined($self->{'in_hash'}->{'virt'})) {
	if (defined($self->{'in_hash'}->{'idx'})) {
		# directory within virtual server
		($self->{'vconf'}, $self->{'v'}) = $self->get_virtual_config($self->{'in_hash'}->{'virt'});
		$self->{'d'} = $self->{'vconf'}->[$self->{'in_hash'}->{'idx'}];
		$self->{'title'} = $self->text('dir_header', $self->dir_name($self->{'d'}), $self->virtual_name($self->{'v'}));
		$self->{'return'} = "dir_index.cgi"; $self->{'rmsg'} = $self->{'text_hash'}->{'dir_return'};
		$self->{'file'} = $self->{'d'}->{'file'};
		$self->{'start'} = $self->{'d'}->{'line'}+1; $self->{'end'} = $self->{'d'}->{'eline'}-1;
		}
	else {
		# virtual server (which can have multiple files!)
		($self->{'conf'}, $self->{'v'}) = $self->get_virtual_config($self->{'in_hash'}->{'virt'});
		@{$self->{'files_array'}} = $self->unique((map { $_->{'file'} } @{$self->{'conf'}}), $self->{'v'}->{'file'});
		$self->{'title'} = $self->text('virt_header', $self->virtual_name($self->{'v'}));
		$self->{'return'} = "virt_index.cgi"; $self->{'rmsg'} = $self->{'text_hash'}->{'virt_return'};
		$self->{'file'} = $self->{'in_hash'}->{'editfile'} || $self->{'v'}->{'file'};
		$self->indexof($self->{'file'}, @{$self->{'files_array'}}) >= 0 ||
			$self->error($self->{'text_hash'}->{'manual_efile'});
		if ($self->{'file'} eq $self->{'v'}->{'file'}) {
			# Edit stuff include <Virtualhost>
			$self->{'start'} = $self->{'v'}->{'line'}+1; $self->{'end'} = $self->{'v'}->{'eline'}-1;
			}
		else {
			# Edit whole file
			$self->{'start'} = $self->{'end'} = undef;
			}
		}
	}
else {
	if (defined($self->{'in_hash'}->{'idx'})) {
		# files within .htaccess file
		$self->{'hconf'} = $self->get_htaccess_config($self->{'in_hash'}->{'file'});
		$self->{'d'} = $self->{'hconf'}->[$self->{'in_hash'}->{'idx'}];
		$self->{'file'} = $self->{'in_hash'}->{'file'};
		$self->{'start'} = $self->{'d'}->{'line'}+1; $self->{'end'} = $self->{'d'}->{'eline'}-1;
		$self->{'title'} = $self->text('htfile_header', $self->dir_name($self->{'d'}),
			       "<tt>$self->{'in_hash'}->{'file'}</tt>");
		$self->{'return'} = "htaccess_index.cgi"; $self->{'rmsg'} = $self->{'text_hash'}->{'htindex_return'};
		}
	else {
		# .htaccess file
		$self->{'file'} = $self->{'in_hash'}->{'file'};
		$self->{'title'} = $self->text('htindex_header', "<tt>$self->{'in_hash'}->{'file'}</tt>");
		$self->{'return'} = "htaccess_index.cgi"; $self->{'rmsg'} = $self->{'text_hash'}->{'htindex_return'};
		$self->{'dir'} = "files_index.cgi";
		}
	}
@{$self->{'files_array'}} = ( $self->{'file'} ) if (!@{$self->{'files_array'}});
$self->ui_print_header($self->{'title'}, $self->{'text_hash'}->{'manual_title'}, "");

foreach $h ('virt', 'idx', 'file') {
	if (defined($self->{'in_hash'}->{$h})) {
		$self->{'hiddens'} .= $self->ui_hidden($h, $self->{'in_hash'}->{$h}),"\n";
		push(@{$self->{'args_array'}}, "$h=$self->{'in_hash'}->{$h}");
		}
	}
$self->{'args'} = join('&', @{$self->{'args_array'}});

# Show file selector (if needed)
if (@{$self->{'files_array'}} > 1) {
	print $self->ui_form_start("manual_form.cgi");
	print $self->{'text_hash'}->{'manual_editfile'},"\n";
	print $self->ui_select("editfile", $self->{'file'},
			 [ map { [ $_ ] } @{$self->{'files_array'}} ]),"\n";
	print $self->ui_submit($self->{'text_hash'}->{'manual_switch'});
	print $self->{'hiddens'};
	print $self->ui_form_end();
	}
else {
	print $self->text('manual_header', "<tt>$self->{'file'}</tt>"),"<p>\n";
	}

# Show actual editor form
print $self->ui_form_start("manual_save.cgi", "form-data");
print $self->{'hiddens'};
print $self->ui_hidden("editfile", $self->{'in_hash'}->{'editfile'}),"\n";

$self->{'lref'} = $self->read_file_lines($self->{'file'});
if (!defined($self->{'start'})) {
	$self->{'start'} = 0;
	$self->{'end'} = @{$self->{'lref'}} - 1;
	}
for($i=$self->{'start'}; $i<=$self->{'end'}; $i++) {
	$self->{'buf'} .= $self->{'lref'}->[$i]."\n";
	}
print $self->ui_textarea("directives", $self->{'buf'}, 15, 80, undef, undef,
		   "style='width:100%'"),"<br>\n";
print $self->ui_submit($self->{'text_hash'}->{'save'});
print $self->ui_form_end();

$self->ui_print_footer("$self->{'return'}?$self->{'args'}", $self->{'rmsg'});

1;
		
}

# print_directives(&list, indent)
sub print_directives
{
	shift if ($self == $_[0]);

foreach $c (@{$_[0]}) {
	next if ($c->{'name'} eq 'dummy');
	if ($c->{'type'}) {
		print $_[1],"<",$c->{'name'}," ",$c->{'value'},">\n";
		&print_directives($c->{'members'}, $_[1].' ');
		print $_[1],"</",$c->{'name'},">\n";
		}
	else {
		print $_[1],$c->{'name'}," ",$c->{'value'},"\n";
		}
	}
}


1;

