#!/usr/bin/perl

&MAIN();

 sub MAIN {
# manual_save.cgi
# Save manually entered directives

&ModuleLoader::preload_module('apache_class', "apache::ApacheLib");
$self = new apache::ApacheLib:: 'apache_class',%$self;

$self->ReadParseMime();
$self->{'access_hash'}->{'types'} eq '*' || $self->error($self->{'text_hash'}->{'manual_ecannot'});
if (defined($self->{'in_hash'}->{'virt'})) {
	if (defined($self->{'in_hash'}->{'idx'})) {
		# directory within virtual server
		($self->{'vconf'}, $self->{'v'}) = $self->get_virtual_config($self->{'in_hash'}->{'virt'});
		$self->{'d'} = $self->{'vconf'}->[$self->{'in_hash'}->{'idx'}];
		$self->{'file'} = $self->{'d'}->{'file'};
		$self->{'return'} = "dir_index.cgi";
		$self->{'start'} = $self->{'d'}->{'line'}+1; $self->{'end'} = $self->{'d'}->{'eline'}-1;
		$self->{'logtype'} = 'dir';
		$self->{'logname'} = $self->virtual_name($self->{'v'}, 1).":".$self->{'d'}->{'words'}->[0];
		}
	else {
		# virtual server (which can have multiple files!)
		($self->{'conf'}, $self->{'v'}) = $self->get_virtual_config($self->{'in_hash'}->{'virt'});
		@{$self->{'files_array'}} = $self->unique((map { $_->{'file'} } @{$self->{'conf'}}), $self->{'v'}->{'file'});
		$self->{'return'} = "virt_index.cgi";
		$self->{'file'} = $self->{'in_hash'}->{'editfile'} || $self->{'v'}->{'file'};
		$self->indexof($self->{'file'}, @{$self->{'files_array'}}) >= 0 ||
			$self->error($self->{'text_hash'}->{'manual_efile'});
		if ($self->{'file'} eq $self->{'v'}->{'file'}) {
			$self->{'start'} = $self->{'v'}->{'line'}+1; $self->{'end'} = $self->{'v'}->{'eline'}-1;
			}
		else {
			$self->{'start'} = $self->{'end'} = undef;
			}
		$self->{'logtype'} = 'virt'; $self->{'logname'} = $self->virtual_name($self->{'v'}, 1);
		}
	}
else {
	if (defined($self->{'in_hash'}->{'idx'})) {
		# files within .htaccess file
		$self->{'hconf'} = $self->get_htaccess_config($self->{'in_hash'}->{'file'});
		$self->{'d'} = $self->{'hconf'}->[$self->{'in_hash'}->{'idx'}];
		$self->{'file'} = $self->{'in_hash'}->{'file'};
		$self->{'return'} = "files_index.cgi";
		$self->{'start'} = $self->{'d'}->{'line'}+1; $self->{'end'} = $self->{'d'}->{'eline'}-1;
		$self->{'logtype'} = 'files';
		$self->{'logname'} = "$self->{'in_hash'}->{'file'}:$self->{'d'}->{'words'}->[0]";
		}
	else {
		# .htaccess file
		$self->{'file'} = $self->{'in_hash'}->{'file'};
		$self->{'return'} = "htaccess_index.cgi";
		$self->{'logtype'} = 'htaccess'; $self->{'logname'} = $self->{'in_hash'}->{'file'};
		}
	}

$self->lock_file($self->{'file'});
$self->{'temp'} = $self->transname();
$self->copy_source_dest($self->{'file'}, $self->{'temp'});
$self->{'in_hash'}->{'directives'} =~ s/\r//g;
$self->{'in_hash'}->{'directives'} =~ s/\s+$//;
@{$self->{'dirs_array'}} = split(/\n/, $self->{'in_hash'}->{'directives'});
$self->{'lref'} = $self->read_file_lines($self->{'file'});
if (!defined($self->{'start'})) {
	$self->{'start'} = 0;
	$self->{'end'} = @{$self->{'lref'}} - 1;
	}
splice(@{$self->{'lref'}}, $self->{'start'}, $self->{'end'}-$self->{'start'}+1, @{$self->{'dirs_array'}});
$self->flush_file_lines();
if ($self->{'config_hash'}->{'test_manual'}) {
	$self->{'err'} = $self->test_config();
	if ($self->{'err'}) {
		$self->copy_source_dest($self->{'temp'}, $self->{'file'});
		$self->error($self->text('manual_etest', "<pre>$self->{'err'}</pre>"));
		}
	}
unlink($self->{'temp'});
$self->unlock_file($self->{'file'});
$self->webmin_log($self->{'logtype'}, "manual", $self->{'logname'}, \%{$self->{'in_hash'}});

foreach $h ('virt', 'idx', 'file') {
	push(@{$self->{'args_array'}}, "$h=$self->{'in_hash'}->{$h}") if (defined($self->{'in_hash'}->{$h}));
	}
$self->redirect("$self->{'return'}?".join("&", @{$self->{'args_array'}}));

1;
		
}


1;

