# mod_alias.pl
# In this part are defined options to work with Advanced Website Settings

sub mod_cpplus_directives
{
local $rv = [
	[ 'AddType', 1, 101, 'virtual directory htaccess', undef ],
	[ 'Redirect', 1, 102, 'virtual directory htaccess', 1.2 ],
	[ 'Alias', 1, 103, 'virtual' ],
	[ 'AddHandler', 1, 104, 'virtual directory htaccess', undef ], 
	[ 'ErrorDocument', 1, 105, 'virtual apache_errordoc' ]
	];

return &make_directives($rv, $_[0], "mod_cpplus");
}

# generate_inputs_home(&editors, &directives)
# Displays a one column list of options, for use inside a table
sub generate_inputs_home
{
local($e, $sw, @args, @rv, $func, $lastsub);
foreach $e (@{$_[0]}) {
	if (defined($lastsub) && $lastsub != $e->{'subtype'}) {
		print "<tr><td colspan=4><hr></td></tr>\n";
		}
	$lastsub = $e->{'subtype'};
	if (!$sw) { print "<tr $cb>\n"; }

	# Build arg list for the editing function. Each arg can be a single
	# directive struct, or a reference to an array of structures.
	$func = "edit";
	undef(@args);
	foreach $ed (split(/\s+/, $e->{'name'})) {
		local(@vals);
		$func .= "_$ed";
		@vals = &find_directive_struct($ed, $_[1]);
		if ($e->{'multiple'}) { push(@args, \@vals); }
		elsif (!@vals) { push(@args, undef); }
		else { push(@args, $vals[$#vals]); }
		}
	push(@args, $e);

	# call the function
	@rv = &$func(@args);
	#print "0: $rv[0] : 1: $rv[1]<br>";
	local $names;
	if ($mconfig{'show_names'} || $userconfig{'show_names'}) {
		$names = " (";
		foreach $ed (split(/\s+/, $e->{'name'})) {
			# nodo50 v0.1 - Change 000004 - Open new window for Help in Apache module and mod_apachessl Help from http://www.apache-ssl.org and
			# nodo50 v0.1 - Change 000004 - Abre nueva ventana para Ayuda del mdulo Apache y para mod_apachessl busca la Ayuda en http://www.apache-ssl.org and
			$names .= "<tt><a href='".($e->{'module'} eq 'mod_apachessl' ? 'http://www.apache-ssl.org/docs.html#'.$ed : $apache_docbase."/".$e->{'module'}.".html#".lc($ed))."'>".$ed."</a></tt> ";
			#$names .= "<tt><a href='".$apache_docbase."/".$e->{'module'}.".html#".lc($ed)."'>".$ed."</a></tt> ";
			# nodo50 v0.1 - Change 000004 - End
			}
		$names .= ")";
		}
	if ($rv[0] >= 2) {
		# spans 2 columns..
		if ($sw) {
			# need to end this row
			print "<td colspan=2></td> </tr><tr>\n";
			}
		else { $sw = !$sw; }
		if ($rv[0] == 3) {
			# Takes up whole row
			print "<td colspan=4>$rv[2]</td>\n";
			}
		else {
			# Has title on left
			#print "<td valign=top align=left colspan=4><b>$rv[1]</b>$names</td></tr>\n";
			print "<td nowrap valign=top colspan=4>$rv[2]</td>\n";
			#print "<td valign=top align=left width=25%><b>$rv[1]</b>$names</td>\n";
			#print "<td nowrap valign=top colspan=3 width=75%>$rv[2]</td>\n";
			}
		}
	else {
		# only spans one column
		print "<td valign=top align=left width=25%><b>$rv[1]</b>$names</td>\n";
		print "<td nowrap valign=top width=25%>$rv[2]</td>\n";
		print "<td colspan=2>&nbsp;</td>\n";
		$sw = 1;
		#print "<td valign=top align=left width=25%><b>$rv[1]</b>$names</td>\n";
		#print "<td nowrap valign=top width=25%>$rv[2]</td>\n";
		}

	if ($sw) { print "</tr>\n"; }
	$sw = !$sw;
	}
}



# generate_outputs_hand(&editors, &directives)
# Displays a 2-column list of options, for use inside a table
sub generate_outputs_hand
{
local($e, $sw, @args, @rv, $func, $lastsub);
@mas = @{$_[0]};
$e = $mas[0];

#if (defined($lastsub) && $lastsub != $e->{'subtype'}) {
#	print "<tr> <td colspan=4><hr></td> </tr>\n";
#	}
$lastsub = $e->{'subtype'};

# Build arg list for the editing function. Each arg can be a single
# directive struct, or a reference to an array of structures.
$func = "edit";
undef(@args);
foreach $ed (split(/\s+/, $e->{'name'})) {
	local(@vals);
	$func .= "_$ed";
	@vals = &find_directive_struct($ed, $_[1]);
	if ($e->{'multiple'}) { push(@args, \@vals); }
	elsif (!@vals) { push(@args, undef); }
	else { push(@args, $vals[$#vals]); }
	}
push(@args, $e);

print "<h3>$text{global_handlers_list}</h3>";
print "<hr>";

print  &handler_output('imap-file', 'AddHandler_type_0');

}

sub handler_output
{
local($m, $func, @hl, $rv, $h);
local $conf = &get_config();
push(@hl, "");
foreach $m (keys %httpd_modules) {
	$func = $m."_handlers";
	if (&foreign_defined('apache', $func)) {
		push(@hl, &foreign_call('apache', $func, $conf, $httpd_modules{$m}));
		}
	}

if (&indexof($_[0], @hl) < 0) { push(@hl, $_[0]); }

local $lnk_val;
@ar = @{$args[0]};

 $rv .= "<TABLE border=1 width=100%>\n";
 $rv .= "<tr $tb>";
 $rv .= "<td width=25%><b>$text{'mod_mime_handler'}</b></td><td><b>$text{'mod_mime_ext'}</b></td>";
 $rv .= "<td width=25%><b>$text{'mod_mime_handler'}</b></td>";
 $rv .= "<td><b>$text{'mod_mime_ext'}</b></td>";
 $rv .= "</tr>";
 $sw = 1;
 foreach $h (&unique(@hl)) {
 		if ($h) {
 		if ($sw) { $rv .= "<tr $cb>"; }
 		$lnk_val = "&nbsp;";
 		foreach $value (@ar) {
 			@val = split (/\s+/, $value->{value});
 			if ($val[0] eq $h) {
 				   $lnk_val = $val[1];
 				}
 			}
 	   	$rv .= "<td>$h</td><td>$lnk_val</td>";
 		if (!$sw) { $rv .= "</tr>"; }
 		$sw = !($sw);
 		}
 	}
 if (!$sw) {$rv .= "<td>&nbsp;</td><td>&nbsp;</td></tr>";}
 $rv .= "</TABLE>\n";
return $rv;
}

# Error handling directives
sub edit_ErrorDocument {
local($rv, $len, $i);
$rv = "<table border width=100%>\n";
$rv .= "<tr $tb> <td><b>$text{'core_error'}</b></td> <td><b>$text{'core_resp'}</b></td> ".
       "<td><b>$text{'core_urlmsg'}</b></td> </tr>\n";
$len = @{$_[0]} + 1;
for($i=0; $i<$len; $i++) {
	$v = $_[0]->[$i]->{'value'};
	if ($v =~ /^(\d+)\s+((http|ftp|gopher):\S+)$/)
		{ $code = $1; $type = 0; $url = $2; }
	elsif ($v =~ /^(\d+)\s+(\/.*)$/) { $code = $1; $type = 0; $url = $2; }
	elsif ($v =~ /^(\d+)\s+"(.*)"$/) { $code = $1; $type = 1; $url = $2; }
	elsif ($v =~ /^(\d+)\s+"?(.*)$/) { $code = $1; $type = 1; $url = $2; }
	else { $code = ""; $type = 0; $url = ""; }
	$rv .= "<tr $cb>\n";
	$rv .= "<td><input name=ErrorDocument_code_$i size=3 value=$code></td>\n";
	$rv .= "<td><input type=radio name=ErrorDocument_type_$i value=0 ".
	       ($type==0 ? "checked" : "").">$text{'core_tourl'}\n";
	$rv .= "<input type=radio name=ErrorDocument_type_$i value=1 ".
	       ($type==1 ? "checked" : "").">$text{'core_mesg'}</td>\n";
	$rv .= "<td><input name=ErrorDocument_url_$i size=40 value=\"$url\"></td>\n";
	$rv .= "</tr>\n";
	}
$rv .= "</table>\n";
return (2, $text{'core_custom'}, $rv);
}

1;
1;
