#!/usr/bin/perl

$no_acl_check++;
require 'apache-lib.pl';

sub module_install {

local $site_file = ($config{'webmin_apache'} || $module_config_directory)."/site";

if (!-r $site_file && $module_name ne 'htaccess') {
	# Need to build list of supported modules
	local $httpd = &find_httpd();
	local ($ver, $mods) = &httpd_info($httpd);
	if ($ver) {
		local @mods = map { "$_/$ver" } &configurable_modules();
		local @st = stat($httpd);
		local %site = ( 'size' => $st[7],
				'modules' => join(' ', @mods) );
		&lock_file($site_file);
		&write_file($site_file, \%site);
		chmod(0644, $site_file);
		&unlock_file($site_file);
		}
	}
	
# Configures End User htaccess module
local %htconfig = ();
local $htconfig_name = "$config_directory/enduser_cp/htaccess/config";
if (-r $htconfig_name) {
	&read_file($htconfig_name, \%htconfig);
	&lock_file($htconfig_name);
	$htconfig{'webmin_apache'} = $module_config_directory;
	&write_file($htconfig_name, \%htconfig);
	&unlock_file($htconfig_name);
	}
}

1;
