#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_vserv.cgi
# Save virtual server options such as the port and address

&ModuleLoader::preload_module('apache_class', "apache::ApacheLib");
$self = new apache::ApacheLib:: 'apache_class',%$self;

$self->ReadParse();
$self->{'access_hash'}->{'vaddr'} || $self->error($self->{'text_hash'}->{'vserv_ecannot'});
$self->{'conf'} = $self->get_config();
($self->{'vmembers'}, $self->{'vconf'}) = $self->get_virtual_config($self->{'in_hash'}->{'virt'});
$self->can_edit_virt($self->{'vconf'}) || $self->error($self->{'text_hash'}->{'virt_ecannot'});

if ($self->{'in_hash'}->{'delete'}) {
	# Delete a virtual server
	%{$self->{'vnames_hash'}} = map { $_, 1 } $self->virt_acl_name($self->{'vconf'});
	$self->lock_file($self->{'vconf'}->{'file'});
	$self->before_changing();
	$self->{'lref'} = $self->read_file_lines($self->{'vconf'}->{'file'});
	if ($self->{'vconf'}->{'line'} && $self->{'lref'}->[$self->{'vconf'}->{'line'}-1] !~ /\S/) {
		# Remove one blank line before vserv
		$self->{'vconf'}->{'line'}--;
		}
	splice(@{$self->{'lref'}}, $self->{'vconf'}->{'line'},
	       $self->{'vconf'}->{'eline'} - $self->{'vconf'}->{'line'} + 1);
	foreach $l (@{$self->{'lref'}}) {
		$self->{'nonblank'}++ if ($l =~ /\S/);
		}
	$self->flush_file_lines();
	if (!$self->{'nonblank'}) {
		# Can lose the entire file
		unlink($self->{'vconf'}->{'file'});

		# Delete the link too
		$self->delete_webfile_link($self->{'vconf'}->{'file'});
		}
	$self->unlock_file($self->{'vconf'}->{'file'});

	$self->after_changing();

	# Remove from acls
	$self->read_acl(undef, \%{$self->{'wusers_hash'}});
	foreach $u (keys %{$self->{'wusers_hash'}}) {
		%{$self->{'uaccess_hash'}} = $self->get_module_acl($u);
		if ($self->{'uaccess_hash'}->{'virts'} ne '*') {
			$self->{'uaccess_hash'}->{'virts'} = join(' ', grep { !$self->{'vnames_hash'}->{$_} }
					      split(/\s+/, $self->{'uaccess_hash'}->{'virts'}));
			$self->save_module_acl(\%{$self->{'uaccess_hash'}}, $u);
			}
		}
	$self->webmin_log("virt", "delete", $self->virtual_name($self->{'vconf'}, 1));
	$self->redirect("");
	}
else {
	# Update virtual server and directives
	$self->error_setup($self->{'text_hash'}->{'vserv_err'});

	# Check address
	if (defined($self->{'in_hash'}->{'addrs'})) {
		local @addrs = split(/\s+/, $self->{'in_hash'}->{'addrs'});
		@addrs || $self->error($self->{'text_hash'}->{'vserv_eaddrs'});
		foreach $a (@addrs) {
			local $ac = $a;
			$ac =~ s/:(\d+)$//;
			$ac eq '*' || $ac eq '_default_' ||
			    gethostbyname($ac) ||
				$self->error($self->text('vserv_eaddr2', $ac));
			}
		$self->{'addr'} = join(" ", @addrs);
		}
	else {
		if ($self->{'in_hash'}->{'addr_def'} == 1) {
			if ($self->{'httpd_modules_hash'}->{'core'} >= 1.2)
				{ $self->{'addr'} = "_default_"; }
			else { $self->{'addr'} = "*"; }
			}
		elsif ($self->{'in_hash'}->{'addr_def'} == 2) {
			$self->{'addr'} = "*";
			}
		elsif ($self->{'in_hash'}->{'addr'} !~ /\S/) {
			$self->error($self->{'text_hash'}->{'vserv_eaddr1'});
			}
		elsif (!gethostbyname($self->{'in_hash'}->{'addr'})) {
			$self->error($self->text('vserv_eaddr2', $self->{'in_hash'}->{'addr'}));
			}
		else {
			$self->{'addr'} = $self->{'in_hash'}->{'addr'};
			}
		}

	# Check port
	if ($self->{'in_hash'}->{'port_mode'} == 0) { $self->{'port'} = ""; }
	elsif ($self->{'in_hash'}->{'port_mode'} == 1) { $self->{'port'} = ":*"; }
	elsif ($self->{'in_hash'}->{'port'} !~ /^\d+$/) {
		$self->error($self->text('vserv_eport', $self->{'in_hash'}->{'port'}));
		}
	else { $self->{'port'} = ":$self->{'in_hash'}->{'port'}"; }

	# Check document root
	if (!$self->{'in_hash'}->{'root_def'}) {
		(-d $self->{'in_hash'}->{'root'}) ||
			$self->error($self->text('vserv_eroot', $self->{'in_hash'}->{'root'}));
		$self->{'root'} = $self->{'in_hash'}->{'root'};
		$self->{'root'} = "\"$self->{'root'}\"" if ($self->{'root'} =~ /\s/);
		}

	# Check server name
	if (!$self->{'in_hash'}->{'name_def'}) {
		$self->{'in_hash'}->{'name'} =~ /^\S+$/ ||
			$self->error($self->text('vserv_ename', $self->{'in_hash'}->{'name'}));
		$self->{'name'} = $self->{'in_hash'}->{'name'};
		}

	# Update <VirtualHost> directive
	$self->lock_file($self->{'vconf'}->{'file'});
	$self->before_changing();
	$self->{'lref'} = $self->read_file_lines($self->{'vconf'}->{'file'});
	$self->{'lref'}->[$self->{'vconf'}->{'line'}] = "<VirtualHost $self->{'addr'}$self->{'port'}>";

	# Update DocumentRoot and ServerName
	$self->save_directive("DocumentRoot", $self->{'root'} ? [ $self->{'root'} ] : [ ],
			$self->{'vconf'}->{'members'}, $self->{'conf'});
	$self->save_directive("ServerName", $self->{'name'} ? [ $self->{'name'} ] : [ ],
			$self->{'vconf'}->{'members'}, $self->{'conf'});

	# write out file
	$self->flush_file_lines();
	$self->after_changing();
	$self->unlock_file($self->{'vconf'}->{'file'});
	$self->webmin_log("virt", "save", $self->virtual_name($self->{'vconf'}, 1), \%{$self->{'in_hash'}});
	$self->redirect("");
	}

1;
		
}


1;

