#!/usr/bin/perl

&MAIN();

 sub MAIN {
# search_virt.cgi
# Display a list of virtual servers matching some search

&ModuleLoader::preload_module('apache_class', "apache::ApacheLib");
$self = new apache::ApacheLib:: 'apache_class',%$self;

$self->ReadParse();

# add the default server
$self->{'conf'} = $self->get_config();
if ($self->can_edit_virt()) {
	push(@{$self->{'vname_array'}}, $self->{'text_hash'}->{'index_defserv'});
	push(@{$self->{'vlink_array'}}, "virt_index.cgi");
	push(@{$self->{'vdesc_array'}}, $self->{'text_hash'}->{'index_defdesc1'});
	push(@{$self->{'vaddr_array'}}, $self->{'text_hash'}->{'index_any'});
	push(@{$self->{'vaddr2_array'}}, '');
	push(@{$self->{'vport_array'}}, $self->{'text_hash'}->{'index_any'});
	push(@{$self->{'vport2_array'}}, '');
	push(@{$self->{'vserv_array'}}, $self->def(scalar($self->find_directive("ServerName", $self->{'conf'})),
			  $self->{'text_hash'}->{'index_auto'}));
	push(@{$self->{'vserv2_array'}}, scalar($self->find_directive("ServerName", $self->{'conf'})));
	push(@{$self->{'vroot_array'}}, $self->def(scalar($self->find_directive("DocumentRoot", $self->{'conf'})),
			  $self->{'text_hash'}->{'index_auto'}));
	push(@{$self->{'vroot2_array'}}, scalar($self->find_directive("DocumentRoot", $self->{'conf'})));
	}

# add other servers
@{$self->{'virt_array'}} = $self->find_directive_struct("VirtualHost", $self->{'conf'});
if ($self->{'httpd_modules_hash'}->{'core'} >= 1.3) {
	# build list of name-based virtual host IP addresses
	@nv = $self->find_directive("NameVirtualHost", $self->{'conf'});
	foreach $nv (@nv) {
		$nv{$self->to_ipaddress($nv)}++;
		}
	}
elsif ($self->{'httpd_modules_hash'}->{'core'} >= 1.2) {
	# only one name-based virtual host IP address - the default address
	$self->{'ba'} = $self->find_directive("ServerName", $self->{'conf'});
	$nv{$self->to_ipaddress($self->{'ba'} ? $self->{'ba'} : $self->get_system_hostname())}++;
	}
@{$self->{'virt_array'}} = grep { $self->can_edit_virt($_) } @{$self->{'virt_array'}};
foreach $v (@{$self->{'virt_array'}}) {
	$self->{'vm'} = $v->{'members'};
	if ($v->{'value'} =~ /^(\S+):(\S+)$/) {
		$self->{'addr'} = $1;
		$self->{'port'} = $2;
		}
	else {
		$self->{'addr'} = $v->{'value'};
		if ($self->{'httpd_modules_hash'}->{'core'} < 2.0) {
			$self->{'port'} = $self->def($self->find_directive("Port", $self->{'conf'}), 80);
			}
		else {
			$self->{'port'} = "*";
			}
		}
	push(@{$self->{'vname_array'}}, $self->{'text_hash'}->{'index_virt'});
	push(@{$self->{'vlink_array'}}, "virt_index.cgi?virt=".$self->indexof($v, @{$self->{'conf'}}));
	$self->{'sname'} = scalar($self->find_directive("ServerName", $self->{'vm'}));
	if ($self->{'addr'} ne "_default_" && $self->{'addr'} ne "*" && $nv{$self->to_ipaddress($self->{'addr'})}) {
		push(@{$self->{'vdesc_array'}}, $self->text('index_vname', "<tt>$self->{'sname'}</tt>",
				   "<tt>$self->{'addr'}</tt>"));
		}
	elsif (($self->{'addr'} eq "_default_" || $self->{'addr'} eq "*") && $self->{'port'} eq "*") {
		push(@{$self->{'vdesc_array'}}, $self->{'text_hash'}->{'index_vdef'});
		$self->{'vdesc_array'}->[0] = $self->{'text_hash'}->{'index_defdesc2'};
		}
	elsif ($self->{'addr'} eq "_default_" || $self->{'addr'} eq "*") {
		push(@{$self->{'vdesc_array'}}, $self->text('index_vport', $self->{'port'}));
		}
	elsif ($self->{'port'} eq "*") {
		push(@{$self->{'vdesc_array'}}, $self->text('index_vaddr', "<tt>$self->{'addr'}</tt>"));
		}
	else {
		push(@{$self->{'vdesc_array'}}, $self->text('index_vaddrport', "<tt>$self->{'addr'}</tt>", $self->{'port'}));
		}
	push(@{$self->{'vaddr_array'}}, $self->{'addr'} eq "_default_" || $self->{'addr'} eq "*" ? $self->{'text_hash'}->{'index_any'}
							  : $self->{'addr'});
	push(@{$self->{'vaddr2_array'}}, $self->{'addr'} eq "_default_" || $self->{'addr'} eq '*' ? '' : $self->{'addr'});
	push(@{$self->{'vport_array'}}, $self->{'port'} eq "*" ? $self->{'text_hash'}->{'index_any'} : $self->{'port'});
	push(@{$self->{'vport2_array'}}, $self->{'port'} eq "*" ? '' : $self->{'port'});
	push(@{$self->{'vserv_array'}}, $self->def($self->find_vdirective("ServerName", $self->{'vm'}, $self->{'conf'}),
			  $self->{'text_hash'}->{'index_auto'}));
	push(@{$self->{'vserv2_array'}}, scalar($self->find_vdirective("ServerName", $self->{'vm'}, $self->{'conf'})));
	push(@{$self->{'vroot_array'}}, $self->def($self->find_vdirective("DocumentRoot", $self->{'vm'}, $self->{'conf'}),
			  $self->{'text_hash'}->{'index_default'}));
	push(@{$self->{'vroot2_array'}}, scalar($self->find_vdirective("DocumentRoot", $self->{'vm'}, $self->{'conf'})));
	}

# do the search
for($i=0; $i<@{$self->{'vname_array'}}; $i++) {
	local $f = $self->{'in_hash'}->{'field'} eq 'name' ? $self->{'vserv2_array'}->[$i] :
		   $self->{'in_hash'}->{'field'} eq 'port' ? $self->{'vport2_array'}->[$i] :
		   $self->{'in_hash'}->{'field'} eq 'addr' ? $self->{'vaddr2_array'}->[$i] : $self->{'vroot2_array'}->[$i];
	if ($self->{'in_hash'}->{'match'} == 0 && $f eq $self->{'in_hash'}->{'what'} ||
	    $self->{'in_hash'}->{'match'} == 1 && eval { $f =~ /\Q$self->{'in_hash'}->{'what'}\E/i } ||
	    $self->{'in_hash'}->{'match'} == 2 && $f ne $self->{'in_hash'}->{'what'} ||
	    $self->{'in_hash'}->{'match'} == 3 && eval { $f !~ /\Q$self->{'in_hash'}->{'what'}\E/i }) {
		push(@{$self->{'match_array'}}, $i);
		}
	}

# show the results
if (@{$self->{'match_array'}} == 1 && 0) {
	$self->redirect($self->{'vlink_array'}->[$vmatch[0]]);
	}
else {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'search_title'}, "");
	if (@{$self->{'match_array'}} == 0) {
		print "<p><b>$self->{'text_hash'}->{'search_notfound'}</b>. <p>\n";
		}
	else {
		print "<table width=100% border=1>\n";
		print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'index_type'}</b></td> ",
		      "<td><b>$self->{'text_hash'}->{'index_addr'}</b></td> ",
		      "<td><b>$self->{'text_hash'}->{'index_port'}</b></td> ",
		      "<td><b>$self->{'text_hash'}->{'index_name'}</b></td> ",
		      "<td><b>$self->{'text_hash'}->{'index_root'}</b></td> </tr>\n";
		foreach $i (@{$self->{'match_array'}}) {
			print "<tr $self->{'cb'}>\n";
			print "<td><a href='$self->{'vlink_array'}->[$i]'>$self->{'vname_array'}->[$i]</a></td>\n";
			print "<td>$self->{'vaddr_array'}->[$i]</td>\n";
			print "<td>$self->{'vport_array'}->[$i]</td>\n";
			print "<td>$self->{'vserv_array'}->[$i]</td>\n";
			print "<td>$self->{'vroot_array'}->[$i]</td>\n";
			print "</tr>\n";
			}
		print "</table><br>\n";
		}
	$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
	}

1;
		
}


1;

