#!/usr/bin/perl

&MAIN();

 sub MAIN {
# show.cgi
# Show directives from a virtualhost, directory or .htaccess

&ModuleLoader::preload_module('apache_class', "apache::ApacheLib");
$self = new apache::ApacheLib:: 'apache_class',%$self;

$self->ReadParse();
if (defined($self->{'in_hash'}->{'virt'})) {
	if (defined($self->{'in_hash'}->{'idx'})) {
		# directory within virtual server
		($self->{'vconf'}, $self->{'v'}) = $self->get_virtual_config($self->{'in_hash'}->{'virt'});
		$self->{'d'} = $self->{'vconf'}->[$self->{'in_hash'}->{'idx'}];
		$self->{'conf'} = $self->{'d'}->{'members'};
		$self->{'title'} = $self->text('dir_header', $self->dir_name($self->{'d'}), $self->virtual_name($self->{'v'}));
		$self->{'edit'} = "edit_dir.cgi"; $self->{'return'} = "dir_index.cgi";
		$self->{'editable'} = 'directory'; $self->{'rmsg'} = $self->{'text_hash'}->{'dir_return'};
		}
	else {
		# virtual server
		($self->{'conf'}, $self->{'v'}) = $self->get_virtual_config($self->{'in_hash'}->{'virt'});
		$self->{'title'} = $self->text('virt_header', $self->virtual_name($self->{'v'}));
		$self->{'edit'} = "edit_virt.cgi"; $self->{'return'} = "virt_index.cgi";
		$self->{'editable'} = 'virtual'; $self->{'rmsg'} = $self->{'text_hash'}->{'virt_return'};
		$self->{'dir'} = "dir_index.cgi";
		}
	}
else {
	if (defined($self->{'in_hash'}->{'idx'})) {
		# files within .htaccess file
		$self->{'hconf'} = $self->get_htaccess_config($self->{'in_hash'}->{'file'});
		$self->{'d'} = $self->{'hconf'}->[$self->{'in_hash'}->{'idx'}];
		$self->{'conf'} = $self->{'d'}->{'members'};
		$self->{'title'} = $self->text('htfile_header', $self->dir_name($self->{'d'}),
			       "<tt>$self->{'in_hash'}->{'file'}</tt>");
		$self->{'edit'} = "edit_files.cgi"; $self->{'return'} = "htaccess_index.cgi";
		$self->{'editable'} = "directory"; $self->{'rmsg'} = $self->{'text_hash'}->{'htindex_return'};
		}
	else {
		# .htaccess file
		$self->{'conf'} = $self->get_htaccess_config($self->{'in_hash'}->{'file'});
		$self->{'title'} = $self->text('htindex_header', "<tt>$self->{'in_hash'}->{'file'}</tt>");
		$self->{'edit'} = "edit_htaccess.cgi"; $self->{'return'} = "htaccess_index.cgi";
		$self->{'editable'} = 'htaccess'; $self->{'rmsg'} = $self->{'text_hash'}->{'htindex_return'};
		$self->{'dir'} = "files_index.cgi";
		}
	}
$self->ui_print_header($self->{'title'}, $self->{'text_hash'}->{'show_title'}, "");

foreach $h ('virt', 'idx', 'file') {
	if (defined($self->{'in_hash'}->{$h})) {
		$self->{'s'} .= "<input type=hidden name=$h value='$self->{'in_hash'}->{$h}'>\n";
		push(@{$self->{'args_array'}}, "$h=$self->{'in_hash'}->{$h}");
		}
	}
$self->{'args'} = join('&', @{$self->{'args_array'}});

for($i=0; $i<$self->{'directive_type_count'}; $i++) {
	foreach $e ($self->editable_directives($i, $self->{'editable'})) {
		foreach $n (split(/\s+/, $e->{'name'})) {
			$self->{'edit_hash'}->{lc($n)} = $e;
			push(@{$self->{'elist_array'}}, { 'name' => $n, 'edit' => $e });
			}
		}
	}
@{$self->{'elist_array'}} = sort { $a->{'name'} cmp $b->{'name'} } @{$self->{'elist_array'}};

print "<table><tr $self->{'tb'}><td colspan=2><b>",$self->text('virt_header2', $self->{'text_hash'}->{'show_title'},
			       $self->virtual_name($self->{'v'})),"</b></td></tr>";
print "<tr><td colspan=2>\n";
print "<table border><tr><td $self->{'cb'}><pre>\n\n";
&show_directives($self->{'conf'}, 0);
print "</pre></td></tr></table>\n";
print "</td></tr>\n";
if ($self->{'in_hash'}->{'virt'} || $self->{'in_hash'}->{'file'} || defined($self->{'in_hash'}->{'idx'})) {
	print "<tr><form action=manual_form.cgi>\n";
	print $self->{'s'};
	print "<td><input type=submit name=these ",
	      "value='$self->{'text_hash'}->{'show_these'}'></td>\n";
	print "</form>\n";
	}
else {
	print "<tr> <td></td>\n";
	}

print "<form action=$self->{'edit'}>\n";
print $self->{'s'};
print "<td align=right>",$self->ui_submit($self->{'text_hash'}->{'show_edit'}),"\n";
print "<select name=type>\n";
foreach $e (@{$self->{'elist_array'}}) {
	print "<option value=",$e->{'edit'}->{'type'},">",
	      $e->{'name'},"\n";
	}
print "</select></td>\n";
print "</form></tr></table>\n";

$self->ui_print_footer("$self->{'return'}?$self->{'args'}", $self->{'rmsg'});

1;
		
}

# show_directives(list, indent)
sub show_directives
{
	shift if ($self == $_[0]);

local ($list, $ind) = @_;
local $idx;
for($idx=0; $idx<@$list; $idx++) {
	local $d = $list->[$idx];
	next if ($d->{'name'} eq "dummy");
	$self->{'t'} = $self->{'edit_hash'}->{lc($d->{'name'})};
	if ($d->{'type'}) {
		# Recurse into section
		local ($ed1, $ed2);
		print " " x $ind;
		if ($d->{'name'} eq "VirtualHost") { next; }
		elsif ($d->{'name'} =~ /Location|Files|Directory/) {
			$ed1 = "<a href=\"$self->{'dir'}?$self->{'args'}&".
			       "idx=$idx\">";
			$ed2 = "</a>";
			}
		print $ed1,"&lt;",$d->{'name'}," ",$d->{'value'},
		      "&gt;",$ed2,"\n";
		&show_directives($d->{'members'}, $ind+1);
		print " " x $ind;
		print "&lt;/",$d->{'name'},"&gt;\n";
		}
	elsif ($_[1] || !$self->{'access_types_hash'}->{$self->{'t'}->{'type'}}) {
		# Directives in section are not editable
		$self->print_line($d, [ $d->{'name'}," ",$d->{'value'} ], $ind);
		}
	else {
		next if (!$self->{'t'});
		$self->print_line($d, [ $d->{'name'}," ",$d->{'value'} ], $ind,
			    "$self->{'edit'}?$self->{'args'}&type=$self->{'t'}->{'type'}");
		}
	}
}


1;

