#!/usr/bin/perl

&MAIN();

 sub MAIN {
# show_dir.cgi
# Show directives from a directory (or equivalent) section

&ModuleLoader::preload_module('apache_class', "apache::ApacheLib");
$self = new apache::ApacheLib:: 'apache_class',%$self;

$self->ReadParse();
($self->{'vconf'}, $self->{'v'}) = $self->get_virtual_config($self->{'in_hash'}->{'virt'});
$self->{'d'} = $self->{'vconf'}->[$self->{'in_hash'}->{'idx'}];
$self->{'conf'} = $self->{'d'}->{'members'};
$self->{'desc'} = $self->text('dir_header', $self->dir_name($self->{'d'}), $self->virtual_name($self->{'v'}));
$self->ui_print_header($self->{'desc'}, $self->{'text_hash'}->{'show_title'}, "");

for($i=0; $i<$self->{'directive_type_count'}; $i++) {
	foreach $e ($self->editable_directives($i, 'directory')) {
		foreach $n (split(/\s+/, $e->{'name'})) {
			$self->{'edit_hash'}->{lc($n)} = $e;
			push(@{$self->{'elist_array'}}, { 'name' => $n, 'edit' => $e });
			}
		}
	}
@{$self->{'elist_array'}} = sort { $a->{'name'} cmp $b->{'name'} } @{$self->{'elist_array'}};

print "<table border><tr><td $self->{'cb'}><pre>\n\n";
&show_directives($self->{'conf'}, 0);
print "</pre></td></tr></table><p>\n";

print "<form action=edit_dir.cgi>\n";
print "<input type=hidden name=virt value=\"$self->{'in_hash'}->{'virt'}\">\n";
print "<input type=hidden name=idx value=\"$self->{'in_hash'}->{'idx'}\">\n";
print "<b>$self->{'text_hash'}->{'show_edit'}</b>\n";
print "<select name=type>\n";
foreach $e (@{$self->{'elist_array'}}) {
	print "<option value=",$e->{'edit'}->{'type'},">",
	      $e->{'name'},"\n";
	}
print "</select> <input type=submit value=\"$self->{'text_hash'}->{'show_ok'}\">\n";
print "</form>\n";

$self->ui_print_footer("dir_index.cgi?virt=$self->{'in_hash'}->{'virt'}&idx=$self->{'in_hash'}->{'idx'}", $self->{'text_hash'}->{'dir_return'});

1;
		
}

# show_directives(list, indent)
sub show_directives
{
	shift if ($self == $_[0]);

local ($list, $ind) = @_;
local $idx;
for($idx=0; $idx<@$list; $idx++) {
	local $d = $list->[$idx];
	next if ($d->{'name'} eq "dummy");
	$self->{'t'} = $self->{'edit_hash'}->{lc($d->{'name'})};
	if ($d->{'type'}) {
		# Recurse into section
		print " " x $ind;
		print "&lt;",$d->{'name'}," ",$d->{'value'},"&gt;\n";
		&show_directives($d->{'members'}, $ind+1);
		print " " x $ind;
		print "&lt;/",$d->{'name'},"&gt;\n";
		}
	elsif ($_[1] || !$self->{'access_types_hash'}->{$self->{'t'}->{'type'}}) {
		# Directives in section are not editable
		$self->print_line($d, [ $d->{'name'}," ",$d->{'value'} ], $ind);
		}
	else {
		next if (!$self->{'t'});
		$self->print_line($d, [ $d->{'name'}," ",$d->{'value'} ], $ind,
			    "edit_dir.cgi?virt=$self->{'in_hash'}->{'virt'}&type=$self->{'t'}->{'type'}&idx=$self->{'in_hash'}->{'idx'}");
		}
	}
}


1;

