#!/usr/bin/perl

&MAIN();

 sub MAIN {
# show_htaccess.cgi
# Show directives from a .htaccess

&ModuleLoader::preload_module('apache_class', "apache::ApacheLib");
$self = new apache::ApacheLib:: 'apache_class',%$self;

$self->ReadParse();
$self->{'conf'} = $self->get_htaccess_config($self->{'in_hash'}->{'file'});
$self->{'desc'} = $self->text('htindex_header', "<tt>$self->{'in_hash'}->{'file'}</tt>");
$self->ui_print_header($self->{'desc'}, $self->{'text_hash'}->{'show_title'}, "");

for($i=0; $i<$self->{'directive_type_count'}; $i++) {
	foreach $e ($self->editable_directives($i, 'htaccess')) {
		foreach $n (split(/\s+/, $e->{'name'})) {
			$self->{'edit_hash'}->{lc($n)} = $e;
			push(@{$self->{'elist_array'}}, { 'name' => $n, 'edit' => $e });
			}
		}
	}
@{$self->{'elist_array'}} = sort { $a->{'name'} cmp $b->{'name'} } @{$self->{'elist_array'}};

print "<table border><tr><td $self->{'cb'}><pre>\n\n";
&show_directives($self->{'conf'}, 0);
print "</pre></td></tr></table><p>\n";

print "<form action=edit_htaccess.cgi>\n";
print "<input type=hidden name=file value=\"$self->{'in_hash'}->{'file'}\">\n";
print "<b>$self->{'text_hash'}->{'show_edit'}</b>\n";
print "<select name=type>\n";
foreach $e (@{$self->{'elist_array'}}) {
	print "<option value=",$e->{'edit'}->{'type'},">",
	      $e->{'name'},"\n";
	}
print "</select> <input type=submit value=\"$self->{'text_hash'}->{'show_ok'}\">\n";
print "</form>\n";

$self->ui_print_footer("htaccess_index.cgi?file=$self->{'in_hash'}->{'file'}", $self->{'text_hash'}->{'htindex_return'});

1;
		
}

# show_directives(list, indent)
sub show_directives
{
	shift if ($self == $_[0]);

local ($list, $ind) = @_;
local $idx;
for($idx=0; $idx<@$list; $idx++) {
	local $d = $list->[$idx];
	next if ($d->{'name'} eq "dummy");
	$self->{'t'} = $self->{'edit_hash'}->{lc($d->{'name'})};
	if ($d->{'type'}) {
		# Recurse into section
		local ($ed1, $ed2);
		print " " x $ind;
		if ($d->{'name'} =~ /Files/) {
			$ed1 = "<a href=\"files_index.cgi?idx=$idx&".
			       "file=$self->{'in_hash'}->{'file'}\">";
			$ed2 = "</a>";
			}
		print $ed1,"&lt;",$d->{'name'}," ",$d->{'value'},
		      "&gt;",$ed2,"\n";
		&show_directives($d->{'members'}, $ind+1);
		print " " x $ind;
		print "&lt;/",$d->{'name'},"&gt;\n";
		}
	elsif ($_[1] || !$self->{'access_types_hash'}->{$self->{'t'}->{'type'}}) {
		# Directives in section are not editable
		$self->print_line($d, [ $d->{'name'}," ",$d->{'value'} ], $ind);
		}
	else {
		next if (!$self->{'t'});
		$self->print_line($d, [ $d->{'name'}," ",$d->{'value'} ], $ind,
			    "edit_htaccess.cgi?file=$self->{'in_hash'}->{'file'}&type=$self->{'t'}->{'type'}");
		}
	}
}


1;

