#!/usr/bin/perl

&MAIN();

 sub MAIN {
# virt_index.cgi
# Display a menu for some specific virtual server, or the default server

&ModuleLoader::preload_module('apache_class', "apache::ApacheLib");
$self = new apache::ApacheLib:: 'apache_class',%$self;

$self->ReadParse();
($self->{'conf'}, $self->{'v'}) = $self->get_virtual_config($self->{'in_hash'}->{'virt'});
$self->can_edit_virt($self->{'v'}) || $self->error($self->{'text_hash'}->{'virt_ecannot'});
$self->{'desc'} = $self->text('virt_header', $self->virtual_name($self->{'v'}));
$self->ui_print_header($self->{'desc'}, $self->{'text_hash'}->{'virt_title'}, "", undef, undef, undef, undef, $self->restart_button());

# Display header and icons
print $self->ui_subheading($self->{'text_hash'}->{'virt_opts2'});
$self->{'sw_icon'} = { "icon" => "images/show.gif",
	     "name" => $self->{'text_hash'}->{'virt_show'},
	     "link" => "show.cgi?virt=$self->{'in_hash'}->{'virt'}" };
if ($self->{'in_hash'}->{'virt'} && $self->{'access_hash'}->{'types'} eq '*') {
	$self->{'ed_icon'} = { "icon" => "images/edit.gif",
		     "name" => $self->{'text_hash'}->{'virt_edit'},
		     "link" => "manual_form.cgi?virt=$self->{'in_hash'}->{'virt'}" };
	}
$self->config_icons("virtual", "edit_virt.cgi?virt=$self->{'in_hash'}->{'virt'}&", $self->{'sw_icon'},
	      $self->{'ed_icon'} ? $self->{'ed_icon'} : ());

# Display per-directory options
@{$self->{'dir_array'}} = ( $self->find_directive_struct("Directory", $self->{'conf'}) ,
         $self->find_directive_struct("DirectoryMatch", $self->{'conf'}),
	 $self->find_directive_struct("Files", $self->{'conf'}),
	 $self->find_directive_struct("FilesMatch", $self->{'conf'}),
	 $self->find_directive_struct("Location", $self->{'conf'}),
	 $self->find_directive_struct("LocationMatch", $self->{'conf'}),
	 $self->find_directive_struct("Proxy", $self->{'conf'}) );
if (@{$self->{'dir_array'}}) {
	print "<hr>\n";
	print $self->ui_subheading($self->{'text_hash'}->{'dir_title'});
	foreach $d (@{$self->{'dir_array'}}) {
		$self->{'what'} = $self->dir_name($d);
		substr($self->{'what'}, 0, 1) = uc(substr($self->{'what'}, 0, 1));
		push(@{$self->{'links_array'}}, "dir_index.cgi?idx=".$self->indexof($d, @{$self->{'conf'}}).
			     "&virt=$self->{'in_hash'}->{'virt'}");
		push(@{$self->{'titles_array'}}, $self->{'what'});
		push(@{$self->{'icons_array'}}, "images/dir.gif");
		push(@{$self->{'types_array'}}, $d->{'name'});
		}
	if ($self->{'config_hash'}->{'show_list'}) {
		# Show as list
		print $self->ui_columns_start([ $self->{'text_hash'}->{'virt_path'},
					  $self->{'text_hash'}->{'virt_type'} ]);
		for($i=0; $i<@{$self->{'links_array'}}; $i++) {
			print $self->ui_columns_row([
			  "<a href='$self->{'links_array'}->[$i]'>$self->{'titles_array'}->[$i]</a>",
			  $self->{'text_hash'}->{'virt_'.$self->{'types_array'}->[$i]} ]);
			}
		print $self->ui_columns_end();
		}
	else {
		# Show as icons
		$self->icons_table(\@{$self->{'links_array'}}, \@{$self->{'titles_array'}}, \@{$self->{'icons_array'}}, 3);
		}
	print "<p>\n";
	}

# Show form to create a dir
print $self->ui_form_start("create_dir.cgi", "post");
print $self->ui_hidden("virt", $self->{'in_hash'}->{'virt'});
print $self->ui_table_start($self->{'text_hash'}->{'virt_adddir'}, undef, 2);

print $self->ui_table_row($self->{'text_hash'}->{'virt_type'},
	$self->ui_select("type", undef,
	  [ map { [ $_, $self->{'text_hash'}->{'virt_'.$_} ] }
		  $self->{'httpd_modules_hash'}->{'core'} >= 2.0 ?
			( "Directory", "Files", "Location", "Proxy" ) :
		  $self->{'httpd_modules_hash'}->{'core'} >= 1.2 ?
			( "Directory", "Files", "Location" ) :
			( "Directory", "Location" ) ]));

if ($self->{'httpd_modules_hash'}->{'core'} >= 1.2) {
	print $self->ui_table_row($self->{'text_hash'}->{'virt_regexp'},
		$self->ui_radio("regexp", 0, [ [ 0, $self->{'text_hash'}->{'virt_exact'} ],
					 [ 1, $self->{'text_hash'}->{'virt_re'} ] ]));
	}

print $self->ui_table_row($self->{'text_hash'}->{'virt_path'},
	$self->ui_textbox("path", undef, 50));

print $self->ui_table_end();
print $self->ui_form_end([ [ "", $self->{'text_hash'}->{'create'} ] ]);

if ($self->{'in_hash'}->{'virt'} && $self->{'access_hash'}->{'vaddr'}) {
	# Show form for changing virtual server
	print "<hr>\n";
	print $self->ui_form_start("save_vserv.cgi");
	print $self->ui_hidden("virt", $self->{'in_hash'}->{'virt'});
	print $self->ui_table_start($self->{'text_hash'}->{'virt_opts'}, undef, 2);

	$self->{'val'} = $self->{'v'}->{'value'};
	if ($self->{'val'} =~ /\s/) {
		$self->{'addrs'} = $self->{'val'};
		}
	if ($self->{'val'} =~ /^(\S+):(\S+)$/) {
		$self->{'addr'} = $1; $self->{'port'} = $2;
		}
	else { $self->{'addr'} = $self->{'val'}; }

	if ($self->{'addrs'}) {
		print $self->ui_table_row($self->{'text_hash'}->{'vserv_addrs'},
			$self->ui_textbox("addrs", join("\n", split(/\s+/, $self->{'addrs'})),
				    4, 30));
		}
	else {
		# Address and port
		print $self->ui_table_row($self->{'text_hash'}->{'vserv_addr'},
			$self->ui_radio("addr_def", $self->{'addr'} eq "_default_" ? 1 :
					      $self->{'addr'} eq "*" ? 2 : 0,
			  [ [ 1, $self->{'text_hash'}->{'vserv_addr1'} ],
			    [ 2, $self->{'text_hash'}->{'vserv_any'} ],
			    [ 0, $self->ui_textbox("addr",
					$self->{'addr'} eq "*" || $self->{'addr'} eq "_default_" ?
						"" : $self->{'addr'}, 20) ] ]));

		print $self->ui_table_row($self->{'text_hash'}->{'vserv_port'},
		     $self->choice_input($self->{'port'} eq "*" ? 1 : $self->{'port'} > 0 ? 2 : 0,
				   "port_mode", "0", "$self->{'text_hash'}->{'vserv_default'},0",
				   "$self->{'text_hash'}->{'vserv_any'},1", ",2").
		     $self->ui_textbox("port", $self->{'port'} > 0 ? $self->{'port'} : "", 5));
		}

	# Document directory
	$self->{'root'} = $self->find_directive_struct("DocumentRoot", $self->{'v'}->{'members'});
	print $self->ui_table_row($self->{'text_hash'}->{'vserv_root'},
		$self->opt_input($self->{'root'}->{'words'}->[0], "root",
					  $self->{'text_hash'}->{'vserv_default'}, 50).
		$self->file_chooser_button("root", 1, 1));

	# Server name
	$self->{'name'} = $self->find_directive("ServerName", $self->{'v'}->{'members'});
	print $self->ui_table_row($self->{'text_hash'}->{'vserv_name'},
		$self->opt_input($self->{'name'}, "name", $self->{'text_hash'}->{'vserv_default'}, 30));

	print $self->ui_table_end();
	print $self->ui_form_end([ [ undef, $self->{'text_hash'}->{'save'} ],
			     [ "delete", $self->{'text_hash'}->{'delete'} ] ]);
	}

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

