#!/usr/bin/perl
package at::LinuxLib;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'at::LinuxLib');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# linux-lib.pl

1;
		return $self;
}

sub list_atjobs
{
	my $self = shift;

local @rv;
opendir(DIR, $self->{'config_hash'}->{'at_dir'});
while($self->{'f'} = readdir(DIR)) {
	local $p = "$self->{'config_hash'}->{'at_dir'}/$self->{'f'}";
	if ($self->{'f'} =~ /^a(\S{5})(\S+)$/) {
		local @st = stat($p);
		local $job = { 'id' => hex($1),
			       'date' => hex($2) * 60,
			       'user' => scalar(getpwuid($st[4])),
			       'created' => $st[9] };
		open(FILE, $p);
		while(<FILE>) {
			$job->{'cmd'} .= $_;
			}
		close(FILE);
		$job->{'realcmd'} = $job->{'cmd'};
		$job->{'realcmd'} =~ s/^[\000-\177]+cd\s+(\S+)\s+\|\|\s+{\n.*\n.*\n.*\n//;
		$job->{'realcmd'} =~ s/\$\{SHELL:.*\n\n?//;
		push(@rv, $job);
		}
	}
closedir(DIR);
return @rv;
}

# create_atjob(user, time, commands, directory)
sub create_atjob
{
	my $self = shift;

local @tm = localtime($_[1]);
local $date = sprintf "%2.2d:%2.2d %d.%d.%d",
		$tm[2], $tm[1], $tm[3], $tm[4]+1, $tm[5]+1900;
local $cmd = "cd $_[3]; at $date";
local @uinfo = getpwnam($_[0]);
if ($uinfo[2] != $<) {
	# Only SU if we are not already the user
	$cmd = "su \"$_[0]\" -c \"$cmd\"";
	}
$self->open_execute_command(*AT, "$cmd >/dev/null 2>&1", 0);
print AT $_[2];
close(AT);
$self->additional_log('exec', undef, $cmd);
}

# delete_atjob(id)
sub delete_atjob
{
	my $self = shift;

$self->system_logged("atrm \"$_[0]\" >/dev/null 2>&1");
}


1;

