#!/usr/bin/perl
package at::SolarisLib;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'at::SolarisLib');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# solaris-lib.pl

use POSIX;

1;
		return $self;
}

sub list_atjobs
{
	my $self = shift;

local @rv;
opendir(DIR, $self->{'config_hash'}->{'at_dir'});
while($self->{'f'} = readdir(DIR)) {
	local $p = "$self->{'config_hash'}->{'at_dir'}/$self->{'f'}";
	if ($self->{'f'} =~ /^(\d+)\.a$/) {
		local @st = stat($p);
		local $job = { 'id' => $self->{'f'},
			       'date' => $1,
			       'user' => scalar(getpwuid($st[4])),
			       'created' => $st[9] };
		open(FILE, $p);
		while(<FILE>) {
			$job->{'cmd'} .= $_;
			}
		close(FILE);
		$job->{'realcmd'} = $job->{'cmd'};
		$job->{'realcmd'} =~ s/^[\000-\177]+#ident.*\ncd\s+\S+\numask\s+\S+\n//;
		$job->{'realcmd'} =~ s/^ulimit\s+\S+\n//;
		push(@rv, $job);
		}
	}
closedir(DIR);
return @rv;
}

# create_atjob(user, time, commands, directory)
sub create_atjob
{
	my $self = shift;

local @tm = localtime($_[1]);
local $date = strftime "%H:%M %b %d", @tm;
local $cmd = "cd $_[3]; at $date";
local @uinfo = getpwnam($_[0]);
if ($uinfo[2] != $<) {
	# Only SU if we are not already the user
	$cmd = "su \"$_[0]\" -c \"$cmd\"";
	}
$self->open_execute_command(*AT, "$cmd ; at $date\"", 0); 
print AT $_[2];
close(AT);
$self->additional_log('exec', undef, $cmd);
}

# delete_atjob(id)
sub delete_atjob
{
	my $self = shift;

$self->system_logged("atrm \"$_[0]\"");
}


1;

