#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Do an immediate backup

&ModuleLoader::preload_module('backup_config_class', "backup_config::BackupconfigLib");
$self = new backup_config::BackupconfigLib:: 'backup_config_class',%$self;

$self->ReadParse();

# Validate inputs
$self->error_setup($self->{'text_hash'}->{'backup_err'});
$self->{'dest'} = $self->parse_backup_destination("dest", \%{$self->{'in_hash'}});
($self->{'configfile'}, $self->{'nofiles'}, $self->{'others'}) = $self->parse_backup_what("what", \%{$self->{'in_hash'}});
@{$self->{'mods_array'}} = split(/\0/, $self->{'in_hash'}->{'mods'});
@{$self->{'mods_array'}} || ($self->{'nofiles'} && !$self->{'configfile'}) || $self->error($self->{'text_hash'}->{'backup_emods'});

# Go for it
($self->{'mode'}, $self->{'user'}, $self->{'pass'}, $self->{'server'}, $self->{'path'}) = $self->parse_backup_url($self->{'dest'});
if ($self->{'mode'} != 4) {
	# Save somewhere, and tell the user
	$self->ui_print_header(undef, $self->{'text_hash'}->{'backup_title'}, "");
	print $self->text('backup_doing', $self->nice_dest($self->{'dest'}, 1)),"<p>\n";
	$self->{'err'} = $self->execute_backup(\@{$self->{'mods_array'}}, $self->{'dest'}, \$self->{'size'}, \@{$self->{'files_array'}},
			       $self->{'configfile'}, $self->{'nofiles'},
			       [ split(/\t+/, $self->{'others'}) ]);
	if ($self->{'err'}) {
		print $self->text('backup_failed', $self->{'err'}),"<p>\n";
		}
	else {
		print $self->text('backup_done', $self->nice_size($self->{'size'}),
			    scalar(@{$self->{'files_array'}})),"<p>\n";
		}
	$self->ui_print_footer("", $self->{'text_hash'}->{'index_return2'});
	}
else {
	# Output file in browser
	$self->{'temp'} = $self->transname();
	$self->{'err'} = $self->execute_backup(\@{$self->{'mods_array'}}, $self->{'temp'}, \$self->{'size'}, undef,
			       $self->{'configfile'}, $self->{'nofiles'});
	if ($self->{'err'}) {
		$self->unlink_file($self->{'temp'});
		$self->error($self->{'err'});
		}
	print "Content-type: application/octet-stream\n\n";
	open(TEMP, $self->{'temp'});
	while(read(TEMP, $self->{'buf'}, 1024)) {
		print $self->{'buf'};
		}
	close(TEMP);
	$self->unlink_file($self->{'temp'});
	}

if (!$self->{'err'}) {
	# Save config
	$self->{'config_hash'}->{'dest'} = $self->{'dest'};
	$self->{'config_hash'}->{'mods'} = join(" ", @{$self->{'mods_array'}});
	$self->{'config_hash'}->{'configfile'} = $self->{'in_hash'}->{'configfile'};
	$self->{'config_hash'}->{'nofiles'} = $self->{'in_hash'}->{'nofiles'};
	$self->lock_file($self->{'module_config_file'});
	$self->save_module_config();
	$self->unlock_file($self->{'module_config_file'});
	$self->webmin_log("backup", undef, $self->{'dest'}, { 'mods' => \@{$self->{'mods_array'}} });
	}

1;
		
}


1;

