#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Show all scheduled backups, and a form for doing an immediate one

&ModuleLoader::preload_module('backup_config_class', "backup_config::BackupconfigLib");
$self = new backup_config::BackupconfigLib:: 'backup_config_class',%$self;

$self->ReadParse();
$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", undef, 1, 1);
@{$self->{'mods_array'}} = $self->list_backup_modules();
if (!@{$self->{'mods_array'}}) {
	$self->ui_print_endpage($self->{'text_hash'}->{'index_emods'});
	}
%{$self->{'mods_hash'}} = map { $_->{'dir'}, $_ } @{$self->{'mods_array'}};

# Show tabs
@{$self->{'tabs_array'}} = ( [ "backup", $self->{'text_hash'}->{'index_tabbackup'}, "index.cgi?mode=clone" ],
	  [ "sched", $self->{'text_hash'}->{'index_tabsched'}, "index.cgi?mode=install" ],
	  [ "restore", $self->{'text_hash'}->{'index_tabrestore'}, "index.cgi?mode=delete" ],
	);
print $self->ui_tabs_start(\@{$self->{'tabs_array'}}, "tab", $self->{'in_hash'}->{'mode'} || "backup", 1);

print $self->ui_tabs_start_tab("tab", "sched");
@{$self->{'backups_array'}} = $self->list_backups();
if (@{$self->{'backups_array'}}) {
	# Show all scheduled backups
	print "<a href='edit.cgi?new=1'>$self->{'text_hash'}->{'index_add'}</a><br>\n";
	print $self->ui_columns_start([ $self->{'text_hash'}->{'index_dest'},
			    	  $self->{'text_hash'}->{'index_mods'},
			    	  $self->{'text_hash'}->{'index_sched'} ], 100);
	foreach $b (@{$self->{'backups_array'}}) {
		local @m = map { $self->{'mods_hash'}->{$_}->{'desc'} }
			       split(/\s+/, $b->{'mods'});
		print $self->ui_columns_row(
			[ "<a href='edit.cgi?id=$b->{'id'}'>".
			  $self->nice_dest($b->{'dest'})."</a>",
			  @m > 5 ? $self->text('index_count', scalar(@m))
				 : join(", ", @m),
			  $b->{'sched'} ? $self->text('index_when',
				$main::cron_object->when_text($b)) : $self->{'text_hash'}->{'no'} ]);
		$self->{'using_strftime'}++ if ($b->{'dest'} =~ /%/);
		}
	print $self->ui_columns_end();
	}
else {
	print "<b>$self->{'text_hash'}->{'index_none'}</b><p>\n";
	}
print "<a href='edit.cgi?new=1'>$self->{'text_hash'}->{'index_add'}</a><p>\n";
if ($self->{'using_strftime'} && !$self->{'config_hash'}->{'date_subs'}) {
	print "<font color=#ff0000><b>$self->{'text_hash'}->{'index_nostrftime'}",
	      "</b></font><p>\n";
	}
print $self->ui_tabs_end_tab();

# Show immediate form
print $self->ui_tabs_start_tab("tab", "backup");
print $self->ui_form_start("backup.cgi/backup.tgz", "post");
print $self->ui_table_start($self->{'text_hash'}->{'index_header'}, undef, 2);

@{$self->{'dmods_array'}} = split(/\s+/, $self->{'config_hash'}->{'mods'});
print $self->ui_table_row($self->{'text_hash'}->{'edit_mods'},
		    $self->ui_select("mods", \@{$self->{'dmods_array'}},
		       [ map { [ $_->{'dir'}, $_->{'desc'} ] } @{$self->{'mods_array'}} ],
		       5, 1));

print $self->ui_table_row($self->{'text_hash'}->{'edit_dest'},
		    $self->show_backup_destination("dest", $self->{'config_hash'}->{'dest'}, 2));

print $self->ui_table_row($self->{'text_hash'}->{'edit_what'},
		    $self->show_backup_what("what", $self->{'config_hash'}->{'configfile'},
					      $self->{'config_hash'}->{'nofiles'}));

print $self->ui_table_end();
print $self->ui_form_end([ [ 'backup', $self->{'text_hash'}->{'index_now'} ] ]);

print $self->ui_tabs_end_tab();

# Show restore form
print $self->ui_tabs_start_tab("tab", "restore");
print $self->ui_form_start("restore.cgi", "form-data");
print $self->ui_table_start($self->{'text_hash'}->{'index_header2'}, undef, 2);

@{$self->{'dmods_array'}} = split(/\s+/, $self->{'config_hash'}->{'mods'});
print $self->ui_table_row($self->{'text_hash'}->{'edit_mods2'},
		    $self->ui_select("mods", \@{$self->{'dmods_array'}},
		       [ map { [ $_->{'dir'}, $_->{'desc'} ] } @{$self->{'mods_array'}} ],
		       5, 1));

print $self->ui_table_row($self->{'text_hash'}->{'edit_dest2'},
		    $self->show_backup_destination("src", $self->{'config_hash'}->{'dest'}, 1));

print $self->ui_table_row($self->{'text_hash'}->{'index_apply'},
		    $self->ui_radio("apply", $self->{'config_hash'}->{'apply'} ? 1 : 0,
			      [ [ 1, $self->{'text_hash'}->{'yes'} ],
				[ 0, $self->{'text_hash'}->{'no'} ] ]));

print $self->ui_table_end();
print $self->ui_form_end([ [ 'restore', $self->{'text_hash'}->{'index_now2'} ] ]);

print $self->ui_tabs_end_tab();
print $self->ui_tabs_end(1);

$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});

1;
		
}


1;

