#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Do an immediate restore

&ModuleLoader::preload_module('backup_config_class', "backup_config::BackupconfigLib");
$self = new backup_config::BackupconfigLib:: 'backup_config_class',%$self;

$self->ReadParseMime();

# Validate inputs
$self->error_setup($self->{'text_hash'}->{'restore_err'});
$self->{'src'} = $self->parse_backup_destination("src", \%{$self->{'in_hash'}});
@{$self->{'mods_array'}} = split(/\0/, $self->{'in_hash'}->{'mods'});
@{$self->{'mods_array'}} || $self->error($self->{'text_hash'}->{'restore_emods'});

# Do it ..
($self->{'mode'}, $self->{'user'}, $self->{'pass'}, $self->{'server'}, $self->{'path'}) = $self->parse_backup_url($self->{'src'});
if ($self->{'mode'} == 3) {
	# Create temp file for uploaded file
	$self->{'temp'} = $self->transname();
	open(TEMP, ">$self->{'temp'}");
	print TEMP $self->{'in_hash'}->{$self->{'path'}};
	close(TEMP);
	$self->{'src'} = $self->{'temp'};
	}
$self->ui_print_header(undef, $self->{'text_hash'}->{'restore_title'}, "");
print $self->text('restore_doing', $self->nice_dest($self->{'src'})),"<p>\n";
$self->{'err'} = $self->execute_restore(\@{$self->{'mods_array'}}, $self->{'src'}, \@{$self->{'files_array'}}, $self->{'in_hash'}->{'apply'});
$self->unlink_file($self->{'temp'}) if ($self->{'mode'} == 3);
if ($self->{'err'}) {
	print $self->text('restore_failed', $self->{'err'}),"<p>\n";
	}
else {
	print $self->text('restore_done', scalar(@{$self->{'files_array'}})),"<p>\n";
	}
$self->{'config_hash'}->{'apply'} = $self->{'in_hash'}->{'apply'};
$self->lock_file($self->{'module_config_file'});
$self->save_module_config();
$self->unlock_file($self->{'module_config_file'});
$self->webmin_log("restore", undef, $self->{'src'}, { 'mods' => \@{$self->{'mods_array'}} });
$self->ui_print_footer("", $self->{'text_hash'}->{'index_return2'});

1;
		
}


1;

