#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Create, update or delete a scheduled backup

&ModuleLoader::preload_module('backup_config_class', "backup_config::BackupconfigLib");
$self = new backup_config::BackupconfigLib:: 'backup_config_class',%$self;

$self->ReadParse();

# Find the backup job
if (!$self->{'in_hash'}->{'new'}) {
	$self->{'backup'} = $self->get_backup($self->{'in_hash'}->{'id'});
	$self->{'job'} = $self->find_cron_job($self->{'backup'});
	}
else {
	$self->{'backup'} = { };
	}

if ($self->{'in_hash'}->{'delete'}) {
	# Delete the backup
	$self->delete_backup($self->{'backup'});
	if ($self->{'job'}) {
		$self->lock_file($main::cron_object->cron_file($self->{'job'}));
		$main::cron_object->delete_cron_job($self->{'job'});
		$self->unlock_file($main::cron_object->cron_file($self->{'job'}));
		}
	}
else {
	# Validate inputs
	$self->error_setup($self->{'text_hash'}->{'save_err'});
	@{$self->{'mods_array'}} = split(/\0/, $self->{'in_hash'}->{'mods'});
	$self->{'backup'}->{'mods'} = join(" ", @{$self->{'mods_array'}});
	$self->{'backup'}->{'dest'} = $self->parse_backup_destination("dest", \%{$self->{'in_hash'}});
	$main::cron_object->parse_times_input($self->{'backup'}, \%{$self->{'in_hash'}});
	$self->{'backup'}->{'emode'} = $self->{'in_hash'}->{'emode'};
	$self->{'backup'}->{'email'} = $self->{'in_hash'}->{'email'};
	$self->{'backup'}->{'sched'} = $self->{'in_hash'}->{'sched'};
	($self->{'backup'}->{'configfile'}, $self->{'backup'}->{'nofiles'}, $self->{'backup'}->{'others'}) =
		$self->parse_backup_what("what", \%{$self->{'in_hash'}});
	@{$self->{'mods_array'}} || ($self->{'backup'}->{'nofiles'} && !$self->{'backup'}->{'configfile'}) ||
		$self->error($self->{'text_hash'}->{'save_emods'});

	# Save or create
	$self->save_backup($self->{'backup'});
	if ($self->{'job'}) {
		$self->lock_file($main::cron_object->cron_file($self->{'job'}));
		$main::cron_object->delete_cron_job($self->{'job'});
		}
	if ($self->{'in_hash'}->{'sched'}) {
		$main::cron_object->create_wrapper($self->{'cron_cmd'}, $self->{'module_name'}, "backup.pl");
		$self->{'job'} = { 'user' => 'root',
			 'command' => "$self->{'cron_cmd'} $self->{'backup'}->{'id'}",
			 'active' => 1,
			 'mins' => $self->{'backup'}->{'mins'},
			 'hours' => $self->{'backup'}->{'hours'},
			 'days' => $self->{'backup'}->{'days'},
			 'months' => $self->{'backup'}->{'months'},
			 'weekdays' => $self->{'backup'}->{'weekdays'},
			 'special' => $self->{'backup'}->{'special'} };
		$self->lock_file($main::cron_object->cron_file($self->{'job'}));
		$main::cron_object->create_cron_job($self->{'job'});
		}
	$self->unlock_file($main::cron_object->cron_file($self->{'job'})) if ($self->{'job'});
	}
$self->webmin_log($self->{'in_hash'}->{'new'} ? 'create' : $self->{'in_hash'}->{'delete'} ? 'delete' : 'modify',
	    'backup', $self->{'backup'}->{'dest'}, $self->{'backup'});

if ($self->{'in_hash'}->{'run'}) {
	# Execute the backup now
	$self->ui_print_unbuffered_header(undef, $self->{'text_hash'}->{'run_title'}, "");
	@{$self->{'mods_array'}} = split(/\s+/, $self->{'backup'}->{'mods'});
	$self->{'nice'} = $self->nice_dest($self->{'backup'}->{'dest'}, 1);
	print $self->text('run_doing', scalar(@{$self->{'mods_array'}}), "<tt>$self->{'nice'}</tt>"),"<br>\n";
	$self->{'err'} = $self->execute_backup(\@{$self->{'mods_array'}}, $self->{'backup'}->{'dest'}, \$self->{'size'}, undef,
			       $self->{'backup'}->{'configfile'}, $self->{'backup'}->{'nofiles'},
			       [ split(/\t+/, $self->{'backup'}->{'others'}) ]);
	if ($self->{'err'}) {
		print "<pre>$self->{'err'}</pre>";
		print "$self->{'text_hash'}->{'run_failed'}<p>\n";
		}
	else {
		print "$self->{'text_hash'}->{'run_ok'}<p>\n";
		}
	$self->webmin_log("run", "backup", $self->{'backup'}->{'dest'}, $self->{'backup'});
	$self->ui_print_footer("edit.cgi?id=$self->{'in_hash'}->{'id'}", $self->{'text_hash'}->{'edit_return'},
			 "", $self->{'text_hash'}->{'index_return'});
	exit;
	}
else {
	$self->redirect("");
	}

1;
		
}


1;

