#!/usr/bin/perl
package bandwidth::Backup_config;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'bandwidth::Backup_config');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;

&ModuleLoader::preload_module(ref($self), "bandwidth::BandwidthLib");
$self = new bandwidth::BandwidthLib:: ref($self), %$self; 
$self->foreign_require("firewall", "backup_config.pl");
$self->foreign_require($self->{'syslog_module'}, "backup_config.pl");

1;

1;
		return $self;
}

# backup_config_files()
# Returns files and directories that can be backed up
sub backup_config_files
{
	my $self = shift;

# Just backup syslog and firewall
return ( $main::firewall_object->backup_config_files(),
	 $self->foreign_call($self->{'syslog_module'}, "backup_config_files") );
}

# pre_backup(&files)
# Called before the files are actually read
sub pre_backup
{
	my $self = shift;

return $main::firewall_object->pre_backup() &&
       $self->foreign_call($self->{'syslog_module'}, "pre_backup");
}

# post_backup(&files)
# Called after the files are actually read
sub post_backup
{
	my $self = shift;

return $main::firewall_object->post_backup() &&
       $self->foreign_call($self->{'syslog_module'}, "post_backup");
}

# pre_restore(&files)
# Called before the files are restored from a backup
sub pre_restore
{
	my $self = shift;

return $main::firewall_object->pre_restore() &&
       $self->foreign_call($self->{'syslog_module'}, "pre_restore");
}

# post_restore(&files)
# Called after the files are restored from a backup
sub post_restore
{
	my $self = shift;

return $main::firewall_object->post_restore() &&
       $self->foreign_call($self->{'syslog_module'}, "post_restore");
}


1;

