#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Remove firewall rules and syslog entry

&ModuleLoader::preload_module('bandwidth_class', "bandwidth::BandwidthLib");
$self = new bandwidth::BandwidthLib:: 'bandwidth_class',%$self;

$self->ReadParse();
$self->{'access_hash'}->{'setup'} || $self->error($self->{'text_hash'}->{'turnoff_ecannot'});

# Remove firewall rules
$self->{'err'} = $self->delete_rules();
$self->error($self->{'err'}) if ($self->{'err'});

if ($self->{'syslog_module'} eq "syslog") {
	# Remove syslog entry
	$self->{'conf'} = $main::syslog_object->get_config();
	$self->{'sysconf'} = $self->find_sysconf($self->{'conf'});
	if ($self->{'sysconf'}) {
		$self->lock_file($main::syslog_object->{'config_hash'}->{'syslog_conf'});
		$main::syslog_object->delete_log($self->{'sysconf'});
		$self->unlock_file($main::syslog_object->{'config_hash'}->{'syslog_conf'});
		$self->{'err'} = $main::syslog_object->restart_syslog();
		$self->error($self->{'err'}) if ($self->{'err'});
		}
	}
else {
	# Remove syslog_ng entries
	$self->{'conf'} = $main::syslog_ng_object->get_config();
	($self->{'dest'}, $self->{'filter'}, $self->{'log'}) = $self->find_sysconf_ng($self->{'conf'});
	$self->lock_file($main::syslog_ng_object->{'config_hash'}->{'syslogng_conf'});
	if ($self->{'dest'}) {
		$main::syslog_ng_object->save_directive($self->{'conf'}, undef, $self->{'dest'}, undef, 0);
		}
	if ($self->{'filter'}) {
		$main::syslog_ng_object->save_directive($self->{'conf'}, undef, $self->{'filter'}, undef, 0);
		}
	if ($self->{'log'}) {
		$main::syslog_ng_object->save_directive($self->{'conf'}, undef, $self->{'log'}, undef, 0);
		}
	$self->unlock_file($main::syslog_ng_object->{'config_hash'}->{'syslogng_conf'});
	}

# Remove rotation cron job
$self->{'job'} = $self->find_cron_job();
if ($self->{'job'}) {
	$self->lock_file($main::cron_object->cron_file($self->{'job'}));
	$main::cron_object->delete_cron_job($self->{'job'});
	$self->unlock_file($main::cron_object->cron_file($self->{'job'}));
	}

$self->webmin_log("turnoff");
$self->redirect("");

1;
		
}


1;

