#!/usr/bin/perl
package bind8::Acl_security;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'bind8::Acl_security');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;

&ModuleLoader::preload_module(ref($self), "bind8::Bind8Lib");
$self = new bind8::Bind8Lib:: ref($self), %$self; 

1;
		return $self;
}

# acl_security_form(&options)
# Output HTML for editing security options for the bind8 module
sub acl_security_form
{
	my $self = shift;

local $m = $_[0]->{'zones'} eq '*' ? 1 :
	   $_[0]->{'zones'} =~ /^\!/ ? 2 : 0;
print "<tr> <td valign=top><b>$self->{'text_hash'}->{'acl_zones'}</b></td>\n";
print "<td colspan=3><table cellpadding=0 cellspacing=0> <tr><td valign=top>\n";
printf "<input type=radio name=zones_def value=1 %s> %s<br>\n",
	$m == 1 ? 'checked' : '', $self->{'text_hash'}->{'acl_zall'};
printf "<input type=radio name=zones_def value=0 %s> %s<br>\n",
	$m == 0 ? 'checked' : '', $self->{'text_hash'}->{'acl_zsel'};
printf "<input type=radio name=zones_def value=2 %s> %s</td>\n",
	$m == 2 ? 'checked' : '', $self->{'text_hash'}->{'acl_znsel'};

print "<td><select name=zones multiple size=4 width=150>\n";
local $conf = $self->get_config();
local @zones = grep { $_->{'value'} ne "." }
		    $self->find("zone", $conf);
local @views = $self->find("view", $conf);
local $v;
foreach $v (@views) {
	push(@zones, grep { $_->{'value'} ne "." }
			  $self->find("zone", $v->{'members'}));
	}
local ($z, %zcan);
map { $zcan{$_}++ } split(/\s+/, $_[0]->{'zones'});
foreach $z (sort { $a->{'value'} cmp $b->{'value'} } @zones) {
	printf "<option value='%s' %s>%s\n",
		$z->{'value'},
		$zcan{$z->{'value'}} ? "selected" : "",
		$self->arpa_to_ip($z->{'value'});
	}
foreach $v (sort { $a->{'value'} cmp $b->{'value'} } @views) {
	printf "<option value='%s' %s>%s\n",
		'view_'.$v->{'value'},
		$zcan{'view_'.$v->{'value'}} ? "selected" : "",
		$self->text('acl_inview', $v->{'value'});
	}
print "</select></td> </tr></table></td></tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'acl_types'}</b></td> <td colspan=3>\n";
printf "<input type=radio name=types_def value=1 %s> %s\n",
	$_[0]->{'types'} ? "" : "checked", $self->{'text_hash'}->{'acl_types1'};
printf "<input type=radio name=types_def value=0 %s> %s\n",
	$_[0]->{'types'} ? "checked" : "", $self->{'text_hash'}->{'acl_types0'};
printf "<input name=types size=40 value='%s'></td> </tr>\n",
	$_[0]->{'types'};

print "<tr> <td valign=top><b>$self->{'text_hash'}->{'acl_dir'}</b></td>\n";
printf "<td colspan=3><input name=dir size=30 value='%s'> %s<br>\n",
	$_[0]->{'dir'}, $self->file_chooser_button("dir", 1);
printf "<input type=checkbox name=dironly value=1 %s> %s</td> </tr>\n",
	$_[0]->{'dironly'} ? "checked" : "", $self->{'text_hash'}->{'acl_dironly'};

print "<tr> <td><b>$self->{'text_hash'}->{'acl_defaults'}</b></td> <td nowrap>\n";
printf "<input type=radio name=defaults value=1 %s> $self->{'text_hash'}->{'yes'}\n",
	$_[0]->{'defaults'} ? "checked" : "";
printf "<input type=radio name=defaults value=0 %s> $self->{'text_hash'}->{'no'}</td> </tr>\n",
	$_[0]->{'defaults'} ? "" : "checked";

print "<tr> <td><b>$self->{'text_hash'}->{'acl_ztypes'}</b></td> <td colspan=3>\n";
foreach $t ("master", "slave", "forward", "delegation") {
	printf "<input type=checkbox name=%s %s> %s\n",
		$t, $_[0]->{$t} ? "checked" : "", $self->{'text_hash'}->{'acl_ztypes_'.$t};
	}
print "</td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'acl_reverse'}</b></td> <td nowrap>\n";
printf "<input type=radio name=reverse value=1 %s> $self->{'text_hash'}->{'yes'}\n",
	$_[0]->{'reverse'} ? "checked" : "";
printf "<input type=radio name=reverse value=0 %s> $self->{'text_hash'}->{'no'}</td>\n",
	$_[0]->{'reverse'} ? "" : "checked";

print "<td><b>$self->{'text_hash'}->{'acl_multiple'}</b></td> <td nowrap>\n";
printf "<input type=radio name=multiple value=1 %s> $self->{'text_hash'}->{'yes'}\n",
	$_[0]->{'multiple'} ? "checked" : "";
printf "<input type=radio name=multiple value=0 %s> $self->{'text_hash'}->{'no'}</td> </tr>\n",
	$_[0]->{'multiple'} ? "" : "checked";

print "<tr> <td><b>$self->{'text_hash'}->{'acl_ro'}</b></td> <td nowrap>\n";
printf "<input type=radio name=ro value=1 %s> $self->{'text_hash'}->{'yes'}\n",
	$_[0]->{'ro'} ? "checked" : "";
printf "<input type=radio name=ro value=0 %s> $self->{'text_hash'}->{'no'}</td>\n",
	$_[0]->{'ro'} ? "" : "checked";

print "<td><b>$self->{'text_hash'}->{'acl_apply'}</b></td> <td nowrap>\n";
print $self->ui_select("apply", $_[0]->{'apply'},
		[ [ 1, $self->{'text_hash'}->{'yes'} ],
		  [ 2, $self->{'text_hash'}->{'acl_applyonly'} ],
		  [ 3, $self->{'text_hash'}->{'acl_applygonly'} ],
		  [ 0, $self->{'text_hash'}->{'no'} ] ]),"</td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'acl_file'}</b></td> <td nowrap>\n";
printf "<input type=radio name=file value=1 %s> $self->{'text_hash'}->{'yes'}\n",
	$_[0]->{'file'} ? "checked" : "";
printf "<input type=radio name=file value=0 %s> $self->{'text_hash'}->{'no'}</td>\n",
	$_[0]->{'file'} ? "" : "checked";

print "<td><b>$self->{'text_hash'}->{'acl_params'}</b></td> <td nowrap>\n";
printf "<input type=radio name=params value=1 %s> $self->{'text_hash'}->{'yes'}\n",
	$_[0]->{'params'} ? "checked" : "";
printf "<input type=radio name=params value=0 %s> $self->{'text_hash'}->{'no'}</td> </tr>\n",
	$_[0]->{'params'} ? "" : "checked";

print "<tr> <td><b>$self->{'text_hash'}->{'acl_opts'}</b></td> <td nowrap>\n";
printf "<input type=radio name=opts value=1 %s> $self->{'text_hash'}->{'yes'}\n",
	$_[0]->{'opts'} ? "checked" : "";
printf "<input type=radio name=opts value=0 %s> $self->{'text_hash'}->{'no'}</td>\n",
	$_[0]->{'opts'} ? "" : "checked";

print "<td><b>$self->{'text_hash'}->{'acl_delete'}</b></td> <td nowrap>\n";
printf "<input type=radio name=delete value=1 %s> $self->{'text_hash'}->{'yes'}\n",
	$_[0]->{'delete'} ? "checked" : "";
printf "<input type=radio name=delete value=0 %s> $self->{'text_hash'}->{'no'}</td> </tr>\n",
	$_[0]->{'delete'} ? "" : "checked";

print "<tr> <td><b>$self->{'text_hash'}->{'acl_gen'}</b></td> <td nowrap>\n";
printf "<input type=radio name=gen value=1 %s> $self->{'text_hash'}->{'yes'}\n",
	$_[0]->{'gen'} ? "checked" : "";
printf "<input type=radio name=gen value=0 %s> $self->{'text_hash'}->{'no'}</td>\n",
	$_[0]->{'gen'} ? "" : "checked";

print "<td><b>$self->{'text_hash'}->{'acl_whois'}</b></td> <td nowrap>\n";
printf "<input type=radio name=whois value=1 %s> $self->{'text_hash'}->{'yes'}\n",
	$_[0]->{'whois'} ? "checked" : "";
printf "<input type=radio name=whois value=0 %s> $self->{'text_hash'}->{'no'}</td> </tr>\n",
	$_[0]->{'whois'} ? "" : "checked";

print "<tr> <td><b>$self->{'text_hash'}->{'acl_findfree'}</b></td> <td nowrap>\n";
printf "<input type=radio name=findfree value=1 %s> $self->{'text_hash'}->{'yes'}\n",
	$_[0]->{'findfree'} ? "checked" : "";
printf "<input type=radio name=findfree value=0 %s> $self->{'text_hash'}->{'no'}</td>\n",
	$_[0]->{'findfree'} ? "" : "checked";

print "<td><b>$self->{'text_hash'}->{'acl_remote'}</b></td> <td nowrap>\n";
printf "<input type=radio name=remote value=1 %s> $self->{'text_hash'}->{'yes'}\n",
	$_[0]->{'remote'} ? "checked" : "";
printf "<input type=radio name=remote value=0 %s> $self->{'text_hash'}->{'no'}</td> </tr>\n",
	$_[0]->{'remote'} ? "" : "checked";

print "<tr> <td><b>$self->{'text_hash'}->{'acl_slaves'}</b></td> <td nowrap>\n";
printf "<input type=radio name=slaves value=1 %s> $self->{'text_hash'}->{'yes'}\n",
	$_[0]->{'slaves'} ? "checked" : "";
printf "<input type=radio name=slaves value=0 %s> $self->{'text_hash'}->{'no'}</td>\n",
	$_[0]->{'slaves'} ? "" : "checked";

print "</tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'acl_views'}</b></td> <td colspan=3>\n";
printf "<input type=radio name=views value=1 %s> $self->{'text_hash'}->{'yes'}\n",
	$_[0]->{'views'} == 1 ? "checked" : "";
printf "<input type=radio name=views value=2 %s> $self->{'text_hash'}->{'acl_edonly'}\n",
	$_[0]->{'views'} == 2 ? "checked" : "";
printf "<input type=radio name=views value=0 %s> $self->{'text_hash'}->{'no'}</td> </tr>\n",
	$_[0]->{'views'} ? "" : "checked";

if (@views) {
	local $m = $_[0]->{'vlist'} eq '*' ? 1 :
		   $_[0]->{'vlist'} =~ /^\!/ ? 2 : 0;
	print "<tr> <td valign=top><b>$self->{'text_hash'}->{'acl_vlist'}</b></td>\n";
	print "<td colspan=3><table cellpadding=0 cellspacing=0> <tr><td valign=top>\n";
	printf "<input type=radio name=vlist_def value=1 %s> %s<br>\n",
		$m == 1 ? 'checked' : '', $self->{'text_hash'}->{'acl_vall'};
	printf "<input type=radio name=vlist_def value=0 %s> %s<br>\n",
		$m == 0 ? 'checked' : '', $self->{'text_hash'}->{'acl_vsel'};
	printf "<input type=radio name=vlist_def value=2 %s> %s</td>\n",
		$m == 2 ? 'checked' : '', $self->{'text_hash'}->{'acl_vnsel'};

	print "<td><select name=vlist multiple size=4 width=150>\n";
	local ($v, %vcan);
	map { $vcan{$_}++ } split(/\s+/, $_[0]->{'vlist'});
	foreach $v (sort { $a->{'value'} cmp $b->{'value'} } @views) {
		printf "<option value='%s' %s>%s\n",
			$v->{'value'},
			$vcan{$v->{'value'}} ? "selected" : "", $v->{'value'};
		}
	print "</select></td> </tr></table></td></tr>\n";
	}
}

# acl_security_save(&options)
# Parse the form for security options for the bind8 module
sub acl_security_save
{
	my $self = shift;

if ($self->{'in_hash'}->{'zones_def'} == 1) {
	$_[0]->{'zones'} = "*";
	}
elsif ($self->{'in_hash'}->{'zones_def'} == 2) {
	$_[0]->{'zones'} = join(" ", "!", split(/\0/, $self->{'in_hash'}->{'zones'}));
	}
else {
	$_[0]->{'zones'} = join(" ", split(/\0/, $self->{'in_hash'}->{'zones'}));
	}
$_[0]->{'types'} = $self->{'in_hash'}->{'types_def'} ? undef : $self->{'in_hash'}->{'types'};
$_[0]->{'master'} = $self->{'in_hash'}->{'master'} || 0;
$_[0]->{'slave'} = $self->{'in_hash'}->{'slave'} || 0;
$_[0]->{'forward'} = $self->{'in_hash'}->{'forward'} || 0;
$_[0]->{'delegation'} = $self->{'in_hash'}->{'delegation'} || 0;
$_[0]->{'defaults'} = $self->{'in_hash'}->{'defaults'};
$_[0]->{'reverse'} = $self->{'in_hash'}->{'reverse'};
$_[0]->{'multiple'} = $self->{'in_hash'}->{'multiple'};
$_[0]->{'ro'} = $self->{'in_hash'}->{'ro'};
$_[0]->{'apply'} = $self->{'in_hash'}->{'apply'};
$_[0]->{'dir'} = $self->{'in_hash'}->{'dir'};
$_[0]->{'dironly'} = $self->{'in_hash'}->{'dironly'};
$_[0]->{'file'} = $self->{'in_hash'}->{'file'};
$_[0]->{'params'} = $self->{'in_hash'}->{'params'};
$_[0]->{'opts'} = $self->{'in_hash'}->{'opts'};
$_[0]->{'delete'} = $self->{'in_hash'}->{'delete'};
$_[0]->{'findfree'} = $self->{'in_hash'}->{'findfree'};
$_[0]->{'slaves'} = $self->{'in_hash'}->{'slaves'};
$_[0]->{'views'} = $self->{'in_hash'}->{'views'};
$_[0]->{'remote'} = $self->{'in_hash'}->{'remote'};
$_[0]->{'gen'} = $self->{'in_hash'}->{'gen'};
$_[0]->{'whois'} = $self->{'in_hash'}->{'whois'};
$_[0]->{'vlist'} = $self->{'in_hash'}->{'vlist_def'} == 1 ? "*" :
		   $self->{'in_hash'}->{'vlist_def'} == 2 ? join(" ", "!",split(/\0/, $self->{'in_hash'}->{'vlist'}))
					 : join(" ", split(/\0/, $self->{'in_hash'}->{'vlist'}));
}


1;

