#!/usr/bin/perl
package bind8::Backup_config;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'bind8::Backup_config');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;

&ModuleLoader::preload_module(ref($self), "bind8::Bind8Lib");
$self = new bind8::Bind8Lib:: ref($self), %$self; 

1;

1;
		return $self;
}

# backup_config_files()
# Returns files and directories that can be backed up
sub backup_config_files
{
	my $self = shift;

local @rv;

# Add main .conf files
local $conf = $self->get_config();
push(@rv, map { $_->{'file'} } @$conf);

# Add all master zone files
local @views = $self->find("view", $conf);
local ($v, @zones);
foreach $v (@views) {
	local @vz = $self->find("zone", $v->{'members'});
	push(@zones, @vz);
	}
push(@zones, $self->find("zone", $conf));
local $z;
foreach $z (@zones) {
	local $tv = $self->find_value("type", $z->{'members'});
	next if ($tv ne "master");
	local $file = $self->find_value("file", $z->{'members'});
	next if (!$file);
	local @recs = $self->read_zone_file($file, $z->{'value'});
	push(@rv, map { $_->{'file'} } @recs);
	}

return $self->unique(@rv);
}

# pre_backup(&files)
# Called before the files are actually read
sub pre_backup
{
	my $self = shift;

return undef;
}

# post_backup(&files)
# Called after the files are actually read
sub post_backup
{
	my $self = shift;

return undef;
}

# pre_restore(&files)
# Called before the files are restored from a backup
sub pre_restore
{
	my $self = shift;

return undef;
}

# post_restore(&files)
# Called after the files are restored from a backup
sub post_restore
{
	my $self = shift;

local $pidfile = $self->get_pid_file();
if ($self->check_pid_file($self->make_chroot($pidfile, 1))) {
	return $self->restart_bind();
	}
return undef;
}


1;

