#!/usr/bin/perl
package bind8::Log_parser;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'bind8::Log_parser');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# log_parser.pl
# Functions for parsing this module's logs

&ModuleLoader::preload_module(ref($self), "bind8::Bind8Lib");
$self = new bind8::Bind8Lib:: ref($self), %$self; 

1;
		return $self;
}

# parse_webmin_log(user, script, action, type, object, &params)
# Converts logged information from this module into human-readable form
sub parse_webmin_log
{
	my $self = shift;

local ($user, $script, $action, $type, $object, $p) = @_;
if ($type eq 'record') {
	if ($p->{'type'} eq 'PTR') {
		return $self->text("log_${action}_record", $self->{'text_hash'}->{"type_$p->{'type'}"},
			     "<tt>".$self->arpa_to_ip($p->{'name'})."</tt>",
			     "<tt>".$self->arpa_to_ip($object)."</tt>");
		}
	else {
		$p->{'name'} =~ s/\.$object\.*$//;
		if (($action eq "modify" || $action eq "create") &&
		    $p->{'newvalues'}) {
			return $self->text("log_${action}_record_v",
				     $self->{'text_hash'}->{"type_$p->{'type'}"},
				     "<tt>$p->{'name'}</tt>",
				     "<tt>$object</tt>",
				     "<tt>$p->{'newvalues'}</tt>");
			}
		else {
			return $self->text("log_${action}_record",
				     $self->{'text_hash'}->{"type_$p->{'type'}"},
				     "<tt>$p->{'name'}</tt>",
				     "<tt>$object</tt>");
			}
		}
	}
elsif ($type eq 'recs') {
	return $self->text("log_${action}_recs", $object);
	}
elsif ($type eq 'zones') {
	return $self->text("log_${action}_zones", $object);
	}
elsif ($type eq "host" || $type eq "group") {
	return $self->text("log_${action}_${type}", "<tt>$object</tt>");
	}
elsif ($action eq 'create') {
	return $self->text("log_${type}", "<tt>$object</tt>");
	}
elsif ($action eq 'delete') {
	return $self->text("log_delete_${type}", "<tt>$object</tt>");
	}
elsif ($action eq 'text') {
	return $self->text("log_text", "<tt>$object</tt>");
	}
elsif ($action eq 'soa') {
	return $self->text("log_soa", "<tt>$object</tt>");
	}
elsif ($action eq 'opts') {
	return $self->text("log_opts", "<tt>$object</tt>");
	}
elsif ($action eq 'view') {
	return $self->text("log_review", "<tt>$object</tt>");
	}
elsif ($action eq 'move') {
	return $self->text("log_move", "<tt>$object</tt>");
	}
elsif ($action eq 'apply' && $type && $type ne '-') {
	return $self->text("log_apply2", "<tt>$type</tt>");
	}
elsif ($action eq 'mass') {
	return $self->text("log_mass", $object);
	}
elsif ($action eq 'manual') {
	return $self->text("log_manual", "<tt>$object</tt>");
	}
elsif ($self->{'text_hash'}->{"log_${action}"}) {
	return $self->{'text_hash'}->{"log_${action}"};
	}
else {
	return undef;
	}
}


1;

