#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Display NDC control interface options

&ModuleLoader::preload_module('bind8_class', "bind8::Bind8Lib");
$self = new bind8::Bind8Lib:: 'bind8_class',%$self;

$self->{'access_hash'}->{'defaults'} || $self->error($self->{'text_hash'}->{'controls_ecannot'});
$self->ui_print_header(undef, $self->{'text_hash'}->{'controls_title'}, "");

$self->{'conf'} = $self->get_config();
$self->{'controls'} = $self->find("controls", $self->{'conf'});
$self->{'inet'} = $self->find("inet", $self->{'controls'}->{'members'});
$unix = $self->find("unix", $self->{'controls'}->{'members'});

print $self->ui_form_start("save_controls.cgi");
print $self->ui_table_start($self->{'text_hash'}->{'controls_header'}, undef, 2);

# Show options for inet control
if ($self->{'inet'}) {
	@{$self->{'v_array'}} = @{$self->{'inet'}->{'values'}};
	$self->{'ip'} = shift(@{$self->{'v_array'}});
	while(@{$self->{'v_array'}}) {
		$self->{'n'} = shift(@{$self->{'v_array'}});
		if ($self->{'n'} eq "port") { $self->{'port'} = shift(@{$self->{'v_array'}}); }
		}
	}
print $self->ui_table_row($self->{'text_hash'}->{'controls_inetopt'},
	    $self->ui_radio("inet", $self->{'inet'} ? 1 : 0,
		      [ [ 0, $self->{'text_hash'}->{'no'} ],
			[ 1, $self->text('controls_inetyes',
				   $self->ui_textbox("ip", $self->{'ip'}, 15),
				   $self->ui_textbox("port", $self->{'port'}, 6)) ] ]));

# Show allowed addresses for inet control
print $self->ui_table_row($self->{'text_hash'}->{'controls_allowips'},
	    $self->ui_textarea("allow",
			join("\n", map { $_->{'name'} }
				@{$self->{'inet'}->{'members'}->{'allow'}}), 5, 20));

# Show keys for inet control
print $self->ui_table_row($self->{'text_hash'}->{'controls_keys'},
	    $self->ui_textarea("keys",
			join("\n", map { $_->{'name'} }
				@{$self->{'inet'}->{'members'}->{'keys'}}), 3, 20));

print $self->ui_table_hr();

# Show options for local socket control
if ($unix) {
	@{$self->{'v_array'}} = @{$unix->{'values'}};
	$self->{'path'} = shift(@{$self->{'v_array'}});
	while(@{$self->{'v_array'}}) {
		$self->{'n'} = shift(@{$self->{'v_array'}});
		if ($self->{'n'} eq "perm") { $self->{'perm'} = shift(@{$self->{'v_array'}}); }
		elsif ($self->{'n'} eq "owner") { $self->{'owner'} = getpwuid(shift(@{$self->{'v_array'}})); }
		elsif ($self->{'n'} eq "group") { $self->{'group'} = getgrgid(shift(@{$self->{'v_array'}})); }
		}
	}
print $self->ui_table_row($self->{'text_hash'}->{'controls_unixopt'},
	    $self->ui_radio("unix", $unix ? 1 : 0,
		      [ [ 0, $self->{'text_hash'}->{'no'} ],
			[ 1, $self->text('controls_unixyes',
				   $self->ui_textbox("path", $self->{'path'}, 30)) ] ]));
print $self->ui_table_row($self->{'text_hash'}->{'controls_unixperm'},
		    $self->ui_textbox("perm", $self->{'perm'}, 4));
print $self->ui_table_row($self->{'text_hash'}->{'controls_unixowner'},
		    $self->ui_user_textbox("owner", $self->{'owner'}, 4));
print $self->ui_table_row($self->{'text_hash'}->{'controls_unixgroup'},
		    $self->ui_group_textbox("group", $self->{'group'}, 4));

print $self->ui_table_end();
print $self->ui_form_end([ [ "save", $self->{'text_hash'}->{'save'} ] ]);

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

