#!/usr/bin/perl

&MAIN();

 sub MAIN {
# conf_logging.cgi
# Display global logging options

&ModuleLoader::preload_module('bind8_class', "bind8::Bind8Lib");
$self = new bind8::Bind8Lib:: 'bind8_class',%$self;

$self->{'access_hash'}->{'defaults'} || $self->error($self->{'text_hash'}->{'logging_ecannot'});
$self->ui_print_header(undef, $self->{'text_hash'}->{'logging_title'}, "");

$self->ReadParse();
$self->{'conf'} = $self->get_config();
$self->{'logging'} = $self->find("logging", $self->{'conf'});
$self->{'mems'} = $self->{'logging'} ? $self->{'logging'}->{'members'} : [ ];

print "<form action=save_logging.cgi>\n";
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'logging_header'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";
print "<tr> <td valign=top><b>$self->{'text_hash'}->{'logging_chans'}</b></td> <td>\n";

# display default channels
@{$self->{'defchans_array'}} = ( { 'name' => 'default_syslog',
		'syslog' => 'daemon',
		'severity' => 'info' },
	      { 'name' => 'default_debug',
		'file' => 'named.run',
		'severity' => 'dynamic' },
	      { 'name' => 'default_stderr',
		'fd' => 'stderr',
		'severity' => 'info' },
	      { 'name' => 'null',
		'null' => 1 } );
foreach $c (@{$self->{'defchans_array'}}) {
	print "<table width=100% border><tr><td><table>\n";
	print "<tr> <td><b>$self->{'text_hash'}->{'logging_cname'}</b></td>\n";
	print "<td colspan=3><i>$c->{'name'}</i></td> </tr>\n";

	print "<tr> <td><b>$self->{'text_hash'}->{'logging_to'}</b></td>\n";
	if ($c->{'syslog'}) {
		print "<td>$self->{'text_hash'}->{'logging_syslog'} ",
		      "<i>$c->{'syslog'}</i></td>\n";
		}
	elsif ($c->{'file'}) {
		print "<td>$self->{'text_hash'}->{'logging_file'} <i>$c->{'file'}</i></td>\n";
		}
	elsif ($c->{'fd'}) {
		print "<td>$self->{'text_hash'}->{'logging_fd'} <i>$c->{'fd'}</i></td>\n";
		}
	else {
		print "<td>$self->{'text_hash'}->{'logging_null'}</td>\n";
		}
	print "</tr>\n";

	print "<tr> <td><b>$self->{'text_hash'}->{'logging_sev'}</b></td>\n";
	if ($c->{'severity'}) {
		print "<td><i>$c->{'severity'}</i></td> </tr>\n";
		}
	else {
		print "<td><i>$self->{'text_hash'}->{'logging_any'}</i></td> </tr>\n";
		}
	print "</table></td></tr></table><br>\n";
	}

# display user-defined channels
@{$self->{'chans_array'}} = $self->find("channel", $self->{'mems'});
@{$self->{'channames_array'}} = ( (map { $_->{'value'} } @{$self->{'chans_array'}}) ,
	       'default_syslog', 'default_debug', 'default_stderr', 'null' );
push(@{$self->{'chans_array'}}, { }) if ($self->{'in_hash'}->{'add'});
for($i=0; $i<@{$self->{'chans_array'}}; $i++) {
	$self->{'cmems'} = $self->{'chans_array'}->[$i]->{'members'};
	$self->{'file'} = $self->find("file", $self->{'cmems'});
	$self->{'filestr'} = $self->{'file'} ? join(" ", @{$self->{'file'}->{'values'}}) : "";
	$self->{'syslog'} = $self->find_value("syslog", $self->{'cmems'});
	$self->{'null'} = $self->find("null", $self->{'cmems'});

	print "<br>\n" if ($i);
	print "<table width=100% border><tr><td><table width=100%>\n";
	print "<tr> <td><b>$self->{'text_hash'}->{'logging_cname'}</b></td>\n";
	printf "<td colspan=3><input name=cname_$i value='%s'></td> </tr>\n",
		$self->{'chans_array'}->[$i]->{'value'};

	print "<tr> <td valign=top><b>$self->{'text_hash'}->{'logging_to'}</b></td>\n";
	print "<td colspan=3>\n";
	printf "<input type=radio name=to_$i value=0 %s> %s\n",
		$self->{'file'} ? "checked" : "", $self->{'text_hash'}->{'logging_file'};
	printf "<input name=file_$i size=40 value='%s'> %s<br>\n",
		$self->{'file'}->{'value'}, $self->file_chooser_button("file_$i");

	print "&nbsp;&nbsp;&nbsp;&nbsp;<b>$self->{'text_hash'}->{'logging_versions'}</b>\n";
	printf "<input type=radio name=vmode_$i value=0 %s> %s\n",
		$self->{'filestr'} =~ /\sversions\s/i ? "" : "checked",
		$self->{'text_hash'}->{'logging_ver1'};
	printf "<input type=radio name=vmode_$i value=1 %s> %s\n",
		$self->{'filestr'} =~ /\sversions\s+unlimited/i ? "checked" : "",
		$self->{'text_hash'}->{'logging_ver2'};
	printf "<input type=radio name=vmode_$i value=2 %s>\n",
		$self->{'filestr'} =~ /\sversions\s+(\d+)/i ? "checked" : "";
	printf "<input name=ver_$i size=5 value='%s'><br>\n",
		$self->{'filestr'} =~ /\sversions\s+(\d+)/i ? $1 : "";

	$self->{'size'} = $self->{'filestr'} =~ /\ssize\s+(\S+)/ ? $1 : '';
	$self->{'size'} = undef if ($self->{'size'} eq 'unlimited');
	print "&nbsp;&nbsp;&nbsp;&nbsp;<b>$self->{'text_hash'}->{'logging_size'}</b>\n";
	printf "<input type=radio name=smode_$i value=0 %s> %s\n",
		$self->{'size'} ? "" : "checked", $self->{'text_hash'}->{'logging_sz1'};
	printf "<input type=radio name=smode_$i value=1 %s>\n",
		$self->{'size'} ? "checked" : "";
	printf "<input name=size_$i size=5 value='%s'><br>\n", $self->{'size'};

	printf "<input type=radio name=to_$i value=1 %s> %s\n",
		$self->{'syslog'} ? "checked" : "", $self->{'text_hash'}->{'logging_syslog'};
	print "<select name=syslog_$i>\n";
	print "<option selected>\n" if (!$self->{'syslog'});
	foreach $s (@{$self->{'syslog_levels_array'}}) {
		printf "<option %s>%s\n",
			$self->{'syslog'} eq $s ? "selected" : "", $s;
		}
	print "</select>&nbsp;&nbsp;\n";

	printf "<input type=radio name=to_$i value=2 %s> %s</td> </tr>\n",
		$self->{'null'} ? "checked" : "", $self->{'text_hash'}->{'logging_null'};

	$self->{'sev'} = $self->find("severity", $self->{'cmems'});
	print "<tr> <td><b>$self->{'text_hash'}->{'logging_sev'}</b></td>\n";
	print "<td colspan=3><select name=sev_$i>\n";
	printf "<option %s>\n", $self->{'sev'} ? "" : "selected";
	foreach $s (@{$self->{'severities_array'}}) {
		printf "<option value=%s %s>%s\n",
			$s, $self->{'sev'}->{'value'} eq $s ? "selected" : "",
			$s eq 'debug' ? $self->{'text_hash'}->{'logging_debug'} :
			$s eq 'dynamic' ? $self->{'text_hash'}->{'logging_dyn'} : $s;
		}
	print "</select>\n";
	printf "<input name=debug_$i size=5 value='%s'></td> </tr>\n",
		$self->{'sev'}->{'value'} eq 'debug' ? $self->{'sev'}->{'values'}->[1] : "";

	print "<tr> <td><b>$self->{'text_hash'}->{'logging_pcat'}</b></td> <td>\n";
	&yes_no_default("print-category-$i",
			$self->find_value("print-category", $self->{'cmems'}));
	print "</td> <td><b>$self->{'text_hash'}->{'logging_psev'}</b></td> <td>\n";
	&yes_no_default("print-severity-$i",
			$self->find_value("print-severity", $self->{'cmems'}));
	print "</td> </tr>\n";

	print "<tr> <td><b>$self->{'text_hash'}->{'logging_ptime'}</b></td> <td>\n";
	&yes_no_default("print-time-$i",
			$self->find_value("print-time", $self->{'cmems'}));
	print "</td> </tr>\n";

	print "</table></td></tr></table>\n";
	}
print "<a href='conf_logging.cgi?add=1'>$self->{'text_hash'}->{'logging_add'}</a>\n";
print "</td> </tr>\n";

print "<tr> <td valign=top><b>$self->{'text_hash'}->{'logging_cats'}</b></td>\n";
print "<td><table border>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'logging_cat'}</b></td> ",
      "<td><b>$self->{'text_hash'}->{'logging_cchans'}</b></td> </tr>\n";
@{$self->{'cats_array'}} = ( $self->find("category", $self->{'mems'}), { } );
for($i=0; $i<@{$self->{'cats_array'}}; $i++) {
	print "<tr $self->{'cb'}> <td><select name=cat_$i>\n";
	print "<option>\n";
	local $found;
	foreach $c (@{$self->{'cat_list_array'}}) {
		printf "<option %s>%s\n",
			$self->{'cats_array'}->[$i]->{'value'} eq $c ? "selected" : "", $c;
		$found++ if ($self->{'cats_array'}->[$i]->{'value'} eq $c);
		}
	if (!$found && $self->{'cats_array'}->[$i]->{'value'}) {
		print "<option selected>",$self->{'cats_array'}->[$i]->{'value'},"\n";
		}
	print "</select></td> <td>\n";
	local %cchan;
	foreach $c (@{$self->{'cats_array'}->[$i]->{'members'}}) {
		$cchan{$c->{'name'}}++;
		}
	foreach $c (@{$self->{'channames_array'}}) {
		printf "<input type=checkbox name=cchan_$i value=%s %s> %s\n",
			$c, $cchan{$c} ? "checked" : "", $c;
		}
	print "</td> </tr>\n";
	}
print "</table></td> </tr>\n";

print "</table></td></tr></table>\n";
print "<input type=submit value=\"$self->{'text_hash'}->{'save'}\"></form>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}

# yes_no_default(name, value)
sub yes_no_default
{
	shift if ($self == $_[0]);

printf "<input type=radio name=$_[0] value=yes %s> $self->{'text_hash'}->{'yes'}\n",
	lc($_[1]) eq 'yes' ? 'checked' : '';
printf "<input type=radio name=$_[0] value=no %s> $self->{'text_hash'}->{'no'}\n",
	lc($_[1]) eq 'no' ? 'checked' : '';
printf "<input type=radio name=$_[0] value='' %s> $self->{'text_hash'}->{'default'}\n",
	!$_[1] ? 'checked' : '';
}


1;

