#!/usr/bin/perl

&MAIN();

 sub MAIN {
# create_forward.cgi
# Create a new forward zone

&ModuleLoader::preload_module('bind8_class', "bind8::Bind8Lib");
$self = new bind8::Bind8Lib:: 'bind8_class',%$self;

$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'fcreate_err'});
$self->{'access_hash'}->{'forward'} || $self->error($self->{'text_hash'}->{'fcreate_ecannot'});
$self->{'access_hash'}->{'ro'} && $self->error($self->{'text_hash'}->{'master_ero'});
$self->{'conf'} = $self->get_config();
if ($self->{'in_hash'}->{'view'} ne '') {
	$self->{'view'} = $self->{'conf'}->[$self->{'in_hash'}->{'view'}];
	$self->can_edit_view($self->{'view'}) || $self->error($self->{'text_hash'}->{'master_eviewcannot'});
	$self->{'vconf'} = $self->{'view'}->{'members'};
	}
else {
	$self->{'vconf'} = $self->{'conf'};
	}

# validate inputs
if ($self->{'in_hash'}->{'rev'}) {
	local($ipv4);
	($ipv4 = $self->check_net_ip($self->{'in_hash'}->{'zone'})) ||
	$self->{'config_hash'}->{'support_aaaa'} &&
	(($self->{'in_hash'}->{'zone'} =~ /^([\w:]+)(\/\d+)$/) || $self->check_ip6address($1)) ||
		$self->error($self->text('create_enet', $self->{'in_hash'}->{'zone'}));
	if ($ipv4) {
		$self->{'in_hash'}->{'zone'} = $self->ip_to_arpa($self->{'in_hash'}->{'zone'});
		}
	else {
		$self->{'in_hash'}->{'zone'} = $self->net_to_ip6int($1, ($2 ? substr($2, 1) : "" ));
		}
	}
else {
	($self->{'in_hash'}->{'zone'} =~ /^[\d\.]+$/ || $self->{'in_hash'}->{'zone'} =~ /^[\d\:]+(\/[\d]+)?$/) &&
		$self->error($self->text('create_edom2', $self->{'in_hash'}->{'zone'}));
	$self->valdnsname($self->{'in_hash'}->{'zone'}, 0, ".") ||
		$self->error($self->text('create_edom', $self->{'in_hash'}->{'zone'}));
	}
$self->{'in_hash'}->{'zone'} =~ s/\.$//;
@{$self->{'masters_array'}} = split(/\s+/, $self->{'in_hash'}->{'masters'});
foreach $m (@{$self->{'masters_array'}}) {
	$self->check_ipaddress($m) ||
		$self->error($self->text('create_emaster', $m));
	}
#if (!@{$self->{'masters_array'}}) {
#	$self->error($self->{'text_hash'}->{'create_enone'});
#	}
foreach $z ($self->find("zone", $self->{'vconf'})) {
	if ($z->{'value'} eq $self->{'in_hash'}->{'zone'}) {
		$self->error($self->{'text_hash'}->{'master_etaken'});
		}
	}

# Create structure
@{$self->{'mdirs_array'}} = map { { 'name' => $_ } } @{$self->{'masters_array'}};
$self->{'dir'} = { 'name' => 'zone',
	 'values' => [ $self->{'in_hash'}->{'zone'} ],
	 'type' => 1,
	 'members' => [ { 'name' => 'type',
			  'values' => [ 'forward' ] },
			{ 'name' => 'forwarders',
			  'type' => 1,
			  'members' => \@{$self->{'mdirs_array'}} }
		      ]
	};

# Create zone directive
$self->create_zone($self->{'dir'}, $self->{'conf'}, $self->{'in_hash'}->{'view'});
$self->webmin_log("create", "forward", $self->{'in_hash'}->{'zone'}, \%{$self->{'in_hash'}});

# If zone in the included file
# we must find $self->{'in_hash'}->{'view'} for that zone:
if( ! $self->{'in_hash'}->{'view'} && $self->find("view",$self->{'conf'})) {
    $self->{'in_hash'}->{'view'} = $self->get_view_by_name($self->{'in_hash'}->{'zone'});
    }

# Get the new zone's index
$self->{'idx'} = $self->get_zone_index($self->{'in_hash'}->{'zone'}, $self->{'in_hash'}->{'view'});

$self->add_zone_access($self->{'in_hash'}->{'zone'});
$self->redirect("edit_forward.cgi?index=$self->{'idx'}&view=$self->{'in_hash'}->{'view'}");

1;
		
}


1;

