#!/usr/bin/perl

&MAIN();

 sub MAIN {
# create_master.cgi
# Create a new master zone

&ModuleLoader::preload_module('bind8_class', "bind8::Bind8Lib");
$self = new bind8::Bind8Lib:: 'bind8_class',%$self;

$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'mcreate_err'});
$self->{'access_hash'}->{'master'} || $self->error($self->{'text_hash'}->{'mcreate_ecannot'});
$self->{'access_hash'}->{'ro'} && $self->error($self->{'text_hash'}->{'master_ero'});
$self->{'conf'} = $self->get_config();
if ($self->{'in_hash'}->{'view'} ne '') {
	$self->{'view'} = $self->{'conf'}->[$self->{'in_hash'}->{'view'}];
	$self->can_edit_view($self->{'view'}) || $self->error($self->{'text_hash'}->{'master_eviewcannot'});
	$self->{'vconf'} = $self->{'view'}->{'members'};
	}
else {
	$self->{'vconf'} = $self->{'conf'};
	}

# validate inputs
if ($self->{'in_hash'}->{'rev'}) {
	local($ipv4);
	($ipv4 = $self->check_net_ip($self->{'in_hash'}->{'zone'})) ||
	$self->{'config_hash'}->{'support_aaaa'} &&
	($self->{'in_hash'}->{'zone'} =~ /^([\w:]+)(\/\d+)$/ || $self->check_ip6address($1)) ||
		$self->error($self->text('create_enet', $self->{'in_hash'}->{'zone'}));
	if ($ipv4) {
		$self->{'in_hash'}->{'zone'} = $self->ip_to_arpa($self->{'in_hash'}->{'zone'});
		}
	else {
		$self->{'in_hash'}->{'zone'} = $self->net_to_ip6int($1, ($2 ? substr($2, 1) : "" ));
		}
	}
else {
	($self->{'in_hash'}->{'zone'} =~ /^[\d\.]+$/ || $self->{'in_hash'}->{'zone'} =~ /^[\d\:]+(\/[\d]+)?$/) &&
		$self->error($self->text('create_edom2', $self->{'in_hash'}->{'zone'}));
	$self->valdnsname($self->{'in_hash'}->{'zone'}, 0, ".") ||
		$self->error($self->text('create_edom', $self->{'in_hash'}->{'zone'}));
	}
$self->{'in_hash'}->{'zone'} =~ s/\.$//;
$self->valdnsname($self->{'in_hash'}->{'master'}, 0, ".") ||
	$self->error($self->text('master_emaster', $self->{'in_hash'}->{'master'}));
if ($self->{'in_hash'}->{'master'} !~ /\.$/) { $self->{'in_hash'}->{'master'} .= "."; }
$self->valemail($self->{'in_hash'}->{'email'}) || $self->valemail($self->dotted_to_email($self->{'in_hash'}->{'email'})) ||
	$self->error($self->text('master_eemail', $self->{'in_hash'}->{'email'}));
$self->{'in_hash'}->{'email'} = $self->email_to_dotted($self->{'in_hash'}->{'email'});
$self->{'in_hash'}->{'refresh'} =~ /^\d+$/ ||
        $self->error($self->text('master_erefresh', $self->{'in_hash'}->{'refresh'}));
$self->{'in_hash'}->{'retry'} =~ /^\d+$/ ||
        $self->error($self->text('master_eretry', $self->{'in_hash'}->{'retry'}));
$self->{'in_hash'}->{'expiry'} =~ /^\d+$/ ||
        $self->error($self->text('master_eexpiry', $self->{'in_hash'}->{'expiry'}));
$self->{'in_hash'}->{'minimum'} =~ /^\d+$/ ||
        $self->error($self->text('master_eminimum', $self->{'in_hash'}->{'minimum'}));
$self->{'base'} = $self->{'access_hash'}->{'dir'} ne '/' ? $self->{'access_hash'}->{'dir'} :
	$self->{'config_hash'}->{'master_dir'} ? $self->{'config_hash'}->{'master_dir'} :
				$self->base_directory($self->{'conf'});
$self->{'base'} =~ s/\/+$// if ($self->{'base'} ne '/');
if ($self->{'in_hash'}->{'tmpl'}) {
	for($i=0; $self->{'config_hash'}->{"tmpl_$i"}; $i++) {
		@c = split(/\s+/, $self->{'config_hash'}->{"tmpl_$i"}, 3);
		if ($c[1] eq 'A' && !$c[2] && !$self->check_ipaddress($self->{'in_hash'}->{'ip'})) {
			$self->error($self->{'text_hash'}->{'master_eip'});
			}
		}
	}
foreach $z ($self->find("zone", $self->{'vconf'})) {
	if ($z->{'value'} eq $self->{'in_hash'}->{'zone'}) {
		$self->error($self->{'text_hash'}->{'master_etaken'});
		}
	}
if (!$self->{'in_hash'}->{'file_def'}) {
	$self->{'in_hash'}->{'file'} =~ /^\S+$/ ||
		$self->error($self->text('create_efile', $self->{'in_hash'}->{'file'}));
	if ($self->{'in_hash'}->{'file'} !~ /^\//) {
		$self->{'in_hash'}->{'file'} = $self->{'base'}."/".$self->{'in_hash'}->{'file'};
		}
	$self->allowed_zone_file(\%{$self->{'access_hash'}}, $self->{'in_hash'}->{'file'}) ||
		$self->error($self->text('create_efile2', $self->{'in_hash'}->{'file'}));
	}
else {
	$self->{'in_hash'}->{'file'} = $self->automatic_filename($self->{'in_hash'}->{'zone'}, $self->{'in_hash'}->{'rev'}, $self->{'base'},
					  $self->{'view'} ? $self->{'view'}->{'value'} : undef);
	}
-r $self->make_chroot($self->{'in_hash'}->{'file'}) && $self->error($self->text('create_efile4', $self->{'in_hash'}->{'file'}));
if ($self->{'in_hash'}->{'onslave'}) {
	@{$self->{'mips_array'}} = split(/\s+/, $self->{'in_hash'}->{'mip'});
	@{$self->{'mips_array'}} || $self->error($self->{'text_hash'}->{'master_emips'});
	foreach $m (@{$self->{'mips_array'}}) {
		$self->check_ipaddress($m) || $self->error($self->text('master_emip', $m));
		}
	}

# Create the zone file and initial records
$self->create_master_records($self->{'in_hash'}->{'file'}, $self->{'in_hash'}->{'zone'}, $self->{'in_hash'}->{'master'}, $self->{'in_hash'}->{'email'},
		       $self->{'in_hash'}->{'refresh'}.$self->{'in_hash'}->{'refunit'},
		       $self->{'in_hash'}->{'retry'}.$self->{'in_hash'}->{'retunit'},
		       $self->{'in_hash'}->{'expiry'}.$self->{'in_hash'}->{'expunit'},
		       $self->{'in_hash'}->{'minimum'}.$self->{'in_hash'}->{'minunit'},
		       $self->{'in_hash'}->{'master_ns'},
		       $self->{'in_hash'}->{'onslave'} && $self->{'access_hash'}->{'remote'},
		       $self->{'in_hash'}->{'tmpl'}, $self->{'in_hash'}->{'ip'}, $self->{'in_hash'}->{'addrev'});

if ($self->{'config_hash'}->{'relative_paths'}) {
	# Make path relative to BIND base directory
	$self->{'bdir'} = $self->base_directory($self->{'conf'});
	$self->{'in_hash'}->{'file'} =~ s/^\Q$self->{'bdir'}\/\E//;
	}

# create the zone directive
$self->{'dir'} = { 'name' => 'zone',
	 'values' => [ $self->{'in_hash'}->{'zone'} ],
	 'type' => 1,
	 'members' => [ { 'name' => 'type',
			  'values' => [ 'master' ] },
			{ 'name' => 'file',
			  'values' => [ $self->{'in_hash'}->{'file'} ] } ]
	};

# create the zone
$self->create_zone($self->{'dir'}, $self->{'conf'}, $self->{'in_hash'}->{'view'});
$self->set_ownership($self->make_chroot($self->{'config_hash'}->{'named_conf'}));
$self->webmin_log("create", "master", $self->{'in_hash'}->{'zone'}, \%{$self->{'in_hash'}});

$self->add_zone_access($self->{'in_hash'}->{'zone'});

# If zone in the included file
# we must find $self->{'in_hash'}->{'view'} for that zone:
if( ! $self->{'in_hash'}->{'view'} && $self->find("view",$self->{'conf'})) {
    $self->{'in_hash'}->{'view'} = $self->get_view_by_name($self->{'in_hash'}->{'zone'});
    }

# Get the new zone's index
$self->{'idx'} = $self->get_zone_index($self->{'in_hash'}->{'zone'}, $self->{'in_hash'}->{'view'});

# Create on slave servers
if ($self->{'in_hash'}->{'onslave'} && $self->{'access_hash'}->{'remote'}) {
	@{$self->{'slaveerrs_array'}} = $self->create_on_slaves($self->{'in_hash'}->{'zone'}, $self->{'mips_array'}->[0],
			$self->{'in_hash'}->{'sfile_def'} == 1 ? "none" :
			$self->{'in_hash'}->{'sfile_def'} == 2 ? undef : $self->{'in_hash'}->{'sfile'});
	if (@{$self->{'slaveerrs_array'}}) {
		$self->error($self->text('master_errslave',
		     "<p>".join("<br>", map { "$_->[0]->{'host'} : $_->[1]" }
				      	    @{$self->{'slaveerrs_array'}})));
		}
	}

$self->redirect("edit_master.cgi?index=$self->{'idx'}&view=$self->{'in_hash'}->{'view'}");

1;
		
}


1;

