#!/usr/bin/perl

&MAIN();

 sub MAIN {
# create_slave.cgi
# Create a new slave zone
# Modified by Howard Wilkinson <howard@cohtech.co.uk> 7th NOvember 2001
#        Added a facility to create a slave zone with the master(s)
#        on a non-standard port

&ModuleLoader::preload_module('bind8_class', "bind8::Bind8Lib");
$self = new bind8::Bind8Lib:: 'bind8_class',%$self;

$self->ReadParse();
$self->error_setup($self->{'in_hash'}->{'type'} ? $self->{'text_hash'}->{'screate_err1'} : $self->{'text_hash'}->{'screate_err2'});
$self->{'access_hash'}->{'slave'} || $self->error($self->{'in_hash'}->{'type'} ? $self->{'text_hash'}->{'screate_ecannot1'}
				       : $self->{'text_hash'}->{'screate_ecannot2'});
$self->{'access_hash'}->{'ro'} && $self->error($self->{'text_hash'}->{'master_ero'});
$self->{'conf'} = $self->get_config();
if ($self->{'in_hash'}->{'view'} ne '') {
	$self->{'view'} = $self->{'conf'}->[$self->{'in_hash'}->{'view'}];
	$self->can_edit_view($self->{'view'}) || $self->error($self->{'text_hash'}->{'master_eviewcannot'});
	$self->{'vconf'} = $self->{'view'}->{'members'};
	}
else {
	$self->{'vconf'} = $self->{'conf'};
	}

# validate inputs
if ($self->{'in_hash'}->{'rev'}) {
	local($ipv4);
	($ipv4 = $self->check_net_ip($self->{'in_hash'}->{'zone'})) ||
	$self->{'config_hash'}->{'support_aaaa'} &&
	($self->{'in_hash'}->{'zone'} =~ /^([\w:]+)(\/\d+)$/ || $self->check_ip6address($1)) ||
                $self->error($self->text('create_enet', $self->{'in_hash'}->{'zone'}));
	if ($ipv4) {
		$self->{'in_hash'}->{'zone'} = $self->ip_to_arpa($self->{'in_hash'}->{'zone'});
		}
	else {
		$self->{'in_hash'}->{'zone'} = $self->net_to_ip6int($1, ($2 ? substr($2, 1) : "" ));
		}
	}
else {
	($self->{'in_hash'}->{'zone'} =~ /^[\d\.]+$/ || $self->{'in_hash'}->{'zone'} =~ /^[\d\:]+(\/[\d]+)?$/) &&
		$self->error($self->text('create_edom2', $self->{'in_hash'}->{'zone'}));
	$self->valdnsname($self->{'in_hash'}->{'zone'}, 0, ".") ||
		$self->error($self->text('create_edom', $self->{'in_hash'}->{'zone'}));
        }
$self->{'in_hash'}->{'zone'} =~ s/\.$//;
foreach $z ($self->find("zone", $self->{'vconf'})) {
	if ($z->{'value'} eq $self->{'in_hash'}->{'zone'}) {
		$self->error($self->{'text_hash'}->{'master_etaken'});
		}
	}
$self->{'masterport'} = $self->{'in_hash'}->{'port_def'} ? undef : $self->{'in_hash'}->{'port'};
@{$self->{'masters_array'}} = split(/\s+/, $self->{'in_hash'}->{'masters'});
foreach $m (@{$self->{'masters_array'}}) {
	$self->check_ipaddress($m) ||
		$self->error($self->text('create_emaster', $m));
	}
if (!@{$self->{'masters_array'}}) {
	$self->error($self->{'text_hash'}->{'create_enone'});
	}
$self->{'base'} = $self->{'access_hash'}->{'dir'} ne '/' ? $self->{'access_hash'}->{'dir'} :
	$self->{'config_hash'}->{'slave_dir'} ? $self->{'config_hash'}->{'slave_dir'} :
			       $self->base_directory($self->{'conf'});
$self->{'base'} =~ s/\/+$// if ($self->{'base'} ne '/');
if ($self->{'in_hash'}->{'file_def'} == 0) {
	# Use the entered filename
	$self->{'in_hash'}->{'file'} =~ /^\S+$/ ||
		$self->error($self->text('create_efile', $self->{'in_hash'}->{'file'}));
	if ($self->{'in_hash'}->{'file'} !~ /^\//) {
		$self->{'file'} = $self->{'base'}."/".$self->{'in_hash'}->{'file'};
		}
	else { $self->{'file'} = $self->{'in_hash'}->{'file'}; }
	$self->allowed_zone_file(\%{$self->{'access_hash'}}, $self->{'file'}) ||
		$self->error($self->text('create_efile2', $self->{'file'}));
	}
elsif ($self->{'in_hash'}->{'file_def'} == 2) {
	$self->{'file'} = $self->automatic_filename($self->{'in_hash'}->{'zone'}, $self->{'in_hash'}->{'rev'}, $self->{'base'},
				    $self->{'view'} ? $self->{'view'}->{'value'} : undef);
	}
if ($self->{'file'}) {
	$self->open_tempfile(ZONE, ">".$self->make_chroot($self->{'file'}), 1, 1) ||
		$self->error($self->text('create_efile3', $self->{'file'}, $!));
	$self->close_tempfile(ZONE);
	$self->set_ownership($self->make_chroot($self->{'file'}));
	}

# Create the structure
@{$self->{'mdirs_array'}} = map { { 'name' => $_ } } @{$self->{'masters_array'}};
$self->{'masters'} = { 'name' => 'masters',
	     'type' => 1,
	     'members' => \@{$self->{'mdirs_array'}} };
if (defined($self->{'masterport'})) {
	$self->{'masters'}->{'values'} = [ 'port', $self->{'masterport'} ];
	}
$self->{'dir'} = { 'name' => 'zone',
	 'values' => [ $self->{'in_hash'}->{'zone'} ],
	 'type' => 1,
	 'members' => [ { 'name' => 'type',
			  'values' => [ $self->{'in_hash'}->{'type'} ? 'slave'
						    : 'stub' ] },
			$self->{'masters'}
		      ]
	};
if ($self->{'file'}) {
	push(@{$self->{'dir'}->{'members'}},
		{ 'name' => 'file',
		  'values' => [ $self->{'file'} ] });
	}

# Create zone directive
$self->create_zone($self->{'dir'}, $self->{'conf'}, $self->{'in_hash'}->{'view'});
$self->webmin_log("create", $self->{'in_hash'}->{'type'} ? 'slave' : 'stub', $self->{'in_hash'}->{'zone'}, \%{$self->{'in_hash'}});

# If zone in the included file
# we must find $self->{'in_hash'}->{'view'} for that zone:
if( ! $self->{'in_hash'}->{'view'} && $self->find("view",$self->{'conf'})) {
    $self->{'in_hash'}->{'view'} = $self->get_view_by_name($self->{'in_hash'}->{'zone'});
    }

# Get the new zone's index
$self->{'idx'} = $self->get_zone_index($self->{'in_hash'}->{'zone'}, $self->{'in_hash'}->{'view'});

$self->add_zone_access($self->{'in_hash'}->{'zone'});

# Create on slave servers
if ($self->{'in_hash'}->{'onslave'} && $self->{'access_hash'}->{'remote'}) {
	@{$self->{'slaveerrs_array'}} = $self->create_on_slaves($self->{'in_hash'}->{'zone'}, $self->{'masters_array'}->[0],
			$self->{'in_hash'}->{'file_def'} == 1 ? "none" :
			$self->{'in_hash'}->{'file_def'} == 2 ? undef : $self->{'in_hash'}->{'sfile'});
	if (@{$self->{'slaveerrs_array'}}) {
		$self->error($self->text('master_errslave',
		     "<p>".join("<br>", map { "$_->[0]->{'host'} : $_->[1]" }
				      	    @{$self->{'slaveerrs_array'}})));
		}
	}

$self->redirect(($self->{'in_hash'}->{'type'} ? "edit_slave.cgi" : "edit_stub.cgi").
	  "?index=$self->{'idx'}&view=$self->{'in_hash'}->{'view'}");

1;
		
}


1;

