#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Delete multiple records from a zone file

&ModuleLoader::preload_module('bind8_class', "bind8::Bind8Lib");
$self = new bind8::Bind8Lib:: 'bind8_class',%$self;

$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'drecs_err'});
$self->{'zone'} = $self->get_zone_name($self->{'in_hash'}->{'index'}, $self->{'in_hash'}->{'view'});
$self->{'dom'} = $self->{'zone'}->{'name'};
$self->can_edit_zone($self->{'zone'}) ||
	$self->error($self->{'text_hash'}->{'recs_ecannot'});
$self->can_edit_type($self->{'in_hash'}->{'type'}, \%{$self->{'access_hash'}}) ||
	$self->error($self->{'text_hash'}->{'recs_ecannottype'});

# Find the records
@d = split(/\0/, $self->{'in_hash'}->{'d'});
@d || $self->error($self->{'text_hash'}->{'drecs_enone'});

# Check if confirmation is needed
if (!$self->{'in_hash'}->{'confirm'} && $self->{'config_hash'}->{'confirm_rec'}) {
	# Ask first
	$self->ui_print_header(undef, $self->{'text_hash'}->{'drecs_title'}, "");
	print $self->ui_form_start("delete_recs.cgi");
	print $self->ui_hidden("index", $self->{'in_hash'}->{'index'}),"\n";
	print $self->ui_hidden("view", $self->{'in_hash'}->{'view'}),"\n";
	print $self->ui_hidden("rev", $self->{'in_hash'}->{'rev'}),"\n";
	foreach $d (@d) {
		print $self->ui_hidden("d", $d),"\n";
		}
	print "<center>\n";
	print $self->text('drecs_rusure', scalar(@d), $self->{'dom'}),"<p>\n";
	print $self->ui_submit($self->{'text_hash'}->{'drecs_ok'}, "confirm");
	print "</center>\n";
	print $self->ui_form_end();
        if ($self->{'in_hash'}->{'dom'}) {
               $self->ui_print_footer("edit_recs.cgi?index=$self->{'in_hash'}->{'index'}&view=$self->{'in_hash'}->{'view'}&type=$self->{'in_hash'}->{'type'}&dom=$self->{'in_hash'}->{'dom'}", $self->{'text_hash'}->{'recs_return'});
               } else {
                       $self->ui_print_footer("edit_recs.cgi?index=$self->{'in_hash'}->{'index'}&view=$self->{'in_hash'}->{'view'}&type=$self->{'in_hash'}->{'type'}", $self->{'text_hash'}->{'recs_return'});
                       }
	}
else {
	# Delete them
	@{$self->{'recs_array'}} = $self->read_zone_file($self->{'zone'}->{'file'}, $self->{'dom'});

	foreach $d (sort { $b cmp $a } @d) {
		$self->{'r'} = $self->{'recs_array'}->[$d];
		if ($self->{'in_hash'}->{'rev'}) {
			# Find the reverse
			$self->{'fulloldvalue0'} = $self->convert_to_absolute(
						$self->{'r'}->{'values'}->[0], $self->{'dom'});
			$self->{'fulloldname'} = $self->convert_to_absolute(
						$self->{'r'}->{'name'}, $self->{'dom'});
			($self->{'orevconf'}, $self->{'orevfile'}, $self->{'orevrec'}) = $self->find_reverse(
					$self->{'r'}->{'values'}->[0], $self->{'in_hash'}->{'view'});

			if ($self->{'orevrec'} && $self->can_edit_reverse($self->{'orevconf'}) &&
			    $self->{'fulloldname'} eq $self->{'orevrec'}->{'values'}->[0] &&
			    ($self->{'r'}->{'type'} eq "A" &&
			     $self->{'r'}->{'values'}->[0] eq $self->arpa_to_ip($self->{'orevrec'}->{'name'}) ||
			     $self->{'r'}->{'type'} eq "AAAA" &&
			     $self->expandall_ip6($self->{'r'}->{'values'}->[0]) eq $self->expandall_ip6($self->ip6int_to_net($self->{'orevrec'}->{'name'})))) {
				$self->lock_file($self->make_chroot($self->{'orevrec'}->{'file'}));
				$self->delete_record($self->{'orevrec'}->{'file'} , $self->{'orevrec'});
				$self->lock_file($self->make_chroot($self->{'orevfile'}));
				@{$self->{'orrecs_array'}} = $self->read_zone_file($self->{'orevfile'}, $self->{'orevconf'}->{'name'});
				if (!$self->{'bumpedrev_hash'}->{$self->{'orevfile'}}++) {
					$self->bump_soa_record($self->{'orevfile'}, \@{$self->{'orrecs_array'}});
					}
				}
			}

		# Delete the actual record
		$self->lock_file($self->make_chroot($self->{'r'}->{'file'}));
		$self->delete_record($self->{'r'}->{'file'}, $self->{'r'});
		splice(@{$self->{'recs'}}, $d, 1);
		}
	$self->unlock_all_files();
	$self->bump_soa_record($self->{'zone'}->{'file'}, \@{$self->{'recs_array'}});

	$self->webmin_log("delete", "recs", scalar(@d));
       if ($self->{'in_hash'}->{'dom'}) {
               $self->redirect("edit_recs.cgi?index=$self->{'in_hash'}->{'index'}&view=$self->{'in_hash'}->{'view'}&type=$self->{'in_hash'}->{'type'}&dom=$self->{'in_hash'}->{'dom'}");
               } else {
                   $self->redirect("edit_recs.cgi?index=$self->{'in_hash'}->{'index'}&view=$self->{'in_hash'}->{'view'}&type=$self->{'in_hash'}->{'type'}");
                   }
	}

1;
		
}


1;

