#!/usr/bin/perl

&MAIN();

 sub MAIN {
# delete_zone.cgi
# Delete an existing master, slave or secondary zone, and it's records file

&ModuleLoader::preload_module('bind8_class', "bind8::Bind8Lib");
$self = new bind8::Bind8Lib:: 'bind8_class',%$self;

$self->ReadParse();
$self->{'conf'} = $self->get_config();
if ($self->{'in_hash'}->{'view'} ne '') {
	$self->{'view'} = $self->{'conf'}->[$self->{'in_hash'}->{'view'}];
	$self->{'conf'} = $self->{'view'}->{'members'};
	}
$self->{'zconf'} = $self->{'conf'}->[$self->{'in_hash'}->{'index'}];
$self->can_edit_zone($self->{'zconf'}, $self->{'view'}) ||
	$self->error($self->{'text_hash'}->{'master_edelete'});
$self->{'access_hash'}->{'ro'} && $self->error($self->{'text_hash'}->{'master_ero'});
$self->{'access_hash'}->{'delete'} || $self->error($self->{'text_hash'}->{'master_edeletecannot'});

$self->{'rev'} = ($self->{'zconf'}->{'value'} =~ /in-addr\.arpa/i || $self->{'zconf'}->{'value'} =~ /\.$self->{'ipv6revzone'}/i);
$self->{'type'} = $self->find("type", $self->{'zconf'}->{'members'})->{'value'};
if (!$self->{'in_hash'}->{'confirm'} && $self->{'config_hash'}->{'confirm_zone'}) {
	# Ask the user if he is sure ..
	$self->ui_print_header(undef, $self->{'text_hash'}->{'delete_title'}, "");

	print "<center><p>\n";
	if ($self->{'type'} eq 'hint') {
		print $self->{'text_hash'}->{'delete_mesg2'},"<p>\n";
		}
	else {
		print $self->text('delete_mesg', "<tt>".$self->ip6int_to_net($self->arpa_to_ip(
			$self->{'zconf'}->{'value'}))."</tt>"),"<p>\n";
		}
	print "<form action=delete_zone.cgi>\n";
	print "<input type=hidden name=index value=$self->{'in_hash'}->{'index'}>\n";
	print "<input type=hidden name=view value=$self->{'in_hash'}->{'view'}>\n";
	print "<input type=submit name=confirm value='$self->{'text_hash'}->{'delete'}'><br>\n";
	if ($self->{'type'} eq 'master') {
		print $self->{'text_hash'}->{$self->{'rev'} ? 'delete_fwd' : 'delete_rev'},"\n";
		print $self->ui_yesno_radio("rev", 1),"<br>\n";
		}

	# Ask if zone should be deleted on slaves too
	#@{$self->{'servers_array'}} = &list_slave_servers();
	@{$self->{'servers_array'}} = ();
	if ($self->{'type'} eq 'slave' || $self->{'type'} eq 'stub') {
		@{$self->{'servers_array'}} = grep { $_->{'sec'} } @{$self->{'servers_array'}};
		}
	elsif ($self->{'type'} ne 'master') {
		@{$self->{'servers_array'}} = ( );
		}
	if (@{$self->{'servers_array'}} && $self->{'access_hash'}->{'remote'}) {
		print $self->{'text_hash'}->{'delete_onslave'},"\n";
		print $self->ui_yesno_radio("onslave", 1),"<br>\n";
		}
	print "</form></center>\n";
	$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
	exit;
	}

if (!$self->{'rev'} && $self->{'in_hash'}->{'rev'} && $self->{'type'} eq 'master') {
	# find and delete reverse records
	local $file = $self->find("file", $self->{'zconf'}->{'members'})->{'value'};
	$self->lock_file($self->make_chroot($file));
	@{$self->{'recs_array'}} = $self->read_zone_file($file, $self->{'zconf'}->{'value'});
	foreach $r (@{$self->{'recs_array'}}) {
		next if ($r->{'type'} ne "A" && $r->{'type'} ne "AAAA");
		($self->{'orevconf'}, $self->{'orevfile'}, $self->{'orevrec'}) =
			$self->find_reverse($r->{'values'}->[0], $self->{'in_hash'}->{'view'});
		if ($self->{'orevrec'} && $self->can_edit_reverse($self->{'orevconf'}) &&
		    $r->{'name'} eq $self->{'orevrec'}->{'values'}->[0] &&
		    ($r->{'type'} eq "A" &&
		     $r->{'values'}->[0] eq $self->arpa_to_ip($self->{'orevrec'}->{'name'})
		     || $r->{'type'} eq "AAAA" &&
		     $self->expandall_ip6($r->{'values'}->[0]) eq $self->expandall_ip6($self->ip6int_to_net($self->{'orevrec'}->{'name'})))) {
			$self->lock_file($self->make_chroot($self->{'orevrec'}->{'file'}));
			$self->delete_record($self->{'orevrec'}->{'file'} , $self->{'orevrec'});
			$self->lock_file($self->make_chroot($self->{'orevfile'}));
			@{$self->{'orrecs_array'}} = $self->read_zone_file($self->{'orevfile'},
						  $self->{'orevconf'}->{'name'});
			$self->bump_soa_record($self->{'orevfile'}, \@{$self->{'orrecs_array'}});
			}
		}
	}
elsif ($self->{'rev'} && $self->{'in_hash'}->{'rev'} && $self->{'type'} eq 'master') {
	# find and delete forward records
	local $file = $self->find("file", $self->{'zconf'}->{'members'})->{'value'};
	$self->lock_file($self->make_chroot($file));
	@{$self->{'recs_array'}} = $self->read_zone_file($file, $self->{'zconf'}->{'value'});
	foreach $r (@{$self->{'recs_array'}}) {
		next if ($r->{'type'} ne "PTR");
		($self->{'ofwdconf'}, $self->{'ofwdfile'}, $self->{'ofwdrec'}) =
			$self->find_forward($r->{'values'}->[0]);
		if ($self->{'ofwdrec'} && $self->can_edit_zone($self->{'ofwdconf'}) &&
		    ($self->{'ofwdrec'}->{'type'} eq "A" &&
		     $self->arpa_to_ip($r->{'name'}) eq $self->{'ofwdrec'}->{'values'}->[0] 
		     || $self->{'ofwdrec'}->{'type'} eq "AAAA" &&
		     $self->expandall_ip6($self->ip6int_to_net($r->{'name'})) eq $self->expandall_ip6($self->{'ofwdrec'}->{'values'}->[0])) &&
		    $r->{'values'}->[0] eq $self->{'ofwdrec'}->{'name'}) {
			$self->lock_file($self->make_chroot($self->{'ofwdrec'}->{'file'}));
			$self->delete_record($self->{'ofwdrec'}->{'file'} , $self->{'ofwdrec'});
			$self->lock_file($self->make_chroot($self->{'ofwdfile'}));
			@{$self->{'ofrecs_array'}} = $self->read_zone_file($self->{'ofwdfile'},
						  $self->{'ofwdconf'}->{'name'});
			$self->bump_soa_record($self->{'ofwdfile'}, \@{$self->{'ofrecs_array'}});
			}
		}
	}

# delete the records file
$self->{'f'} = $self->find("file", $self->{'zconf'}->{'members'});
if ($self->{'f'} && $self->{'type'} ne 'hint') {
	local $zonefile = $self->make_chroot($self->absolute_path($self->{'f'}->{'value'}));
	$self->lock_file($zonefile);
	unlink($zonefile);
	local $logfile = $zonefile.".log";
	if (!-r $logfile) { $logfile = $zonefile.".jnl"; }
	if (-r $logfile) {
		$self->lock_file($logfile);
		unlink($logfile);
		}
	}

# remove the zone directive
$self->lock_file($self->make_chroot($self->{'zconf'}->{'file'}));
$self->{'lref'} = $self->read_file_lines($self->make_chroot($self->{'zconf'}->{'file'}));
splice(@{$self->{'lref'}}, $self->{'zconf'}->{'line'}, $self->{'zconf'}->{'eline'} - $self->{'zconf'}->{'line'} + 1);
$self->flush_file_lines();
$self->unlock_all_files();
$self->webmin_log("delete", $self->find("type", $self->{'zconf'}->{'members'})->{'value'},
	    $self->{'zconf'}->{'value'}, \%{$self->{'in_hash'}});

# remove from acl files
$self->read_acl(undef, \%{$self->{'wusers_hash'}});
foreach $u (keys %{$self->{'wusers_hash'}}) {
	%{$self->{'uaccess_hash'}} = $self->get_module_acl($u);
	if ($self->{'uaccess_hash'}->{'zones'} ne '*') {
		$self->{'uaccess_hash'}->{'zones'} = join(' ', grep { $_ ne $self->{'zconf'}->{'value'} }
					      split(/\s+/, $self->{'uaccess_hash'}->{'zones'}));
		$self->save_module_acl(\%{$self->{'uaccess_hash'}}, $u);
		}
	}

# Also delete from slave servers
if ($self->{'in_hash'}->{'onslave'} && $self->{'access_hash'}->{'remote'}) {
	@{$self->{'slaveerrs_array'}} = $self->delete_on_slaves($self->{'zconf'}->{'value'});
	if (@{$self->{'slaveerrs_array'}}) {
		$self->error($self->text('delete_errslave',
		     "<p>".join("<br>", map { "$_->[0]->{'host'} : $_->[1]" }
				      @{$self->{'slaveerrs_array'}})));
		}
	}

$self->redirect("");

1;
		
}

sub slave_error_handler
{
	shift if ($self == $_[0]);

$self->{'slave_error'} = $_[0];
}


1;

