#!/usr/bin/perl

&MAIN();

 sub MAIN {
# dns_boot.cgi
# Create an empty named.conf file and start the name server

&ModuleLoader::preload_module('bind8_class', "bind8::Bind8Lib");
$self = new bind8::Bind8Lib:: 'bind8_class',%$self;

$self->error_setup($self->{'text_hash'}->{'boot_err'});
$self->ReadParse();

$self->{'config_hash'}->{'named_conf'} =~ /^(\S+)\/([^\/]+)$/;
$self->{'conf_directory'} = $1;
$self->{'pid_file'} = $self->{'config_hash'}->{'pid_file'} || "/var/run/named.pid";
$self->lock_file($self->make_chroot($self->{'config_hash'}->{'named_conf'}));
$self->lock_file($self->make_chroot("$self->{'conf_directory'}/db.cache"));
$self->{'conf_temp'} = $self->transname("cpplus.named.conf");
open(BOOT, ">$self->{'conf_temp'}");
print BOOT "options {\n";
print BOOT "\tdirectory \"$self->{'conf_directory'}\";\n";
print BOOT "\tpid-file \"$self->{'pid_file'}\";\n";
print BOOT "\t};\n";
print BOOT "\n";
$self->{'chroot'} = $self->get_chroot();
if ($self->{'chroot'} && !-d $self->{'chroot'}) {
	mkdir($self->{'chroot'}, 0755);
	}
if (!-d $self->make_chroot($self->{'conf_directory'})) {
	mkdir($self->make_chroot($self->{'conf_directory'}), 0755);
	}
if ($self->{'config_hash'}->{'master_dir'} && !-d $self->make_chroot($self->{'config_hash'}->{'master_dir'})) {
	mkdir($self->make_chroot($self->{'config_hash'}->{'master_dir'}), 0755);
	}
if ($self->{'config_hash'}->{'slave_dir'} && !-d $self->make_chroot($self->{'config_hash'}->{'slave_dir'})) {
	mkdir($self->make_chroot($self->{'config_hash'}->{'slave_dir'}), 0777);
	}
if ($self->{'pid_file'} =~ /^(.*)\//) {
	$self->{'pid_dir'} = $1;
	if (!-d $self->make_chroot($self->{'pid_dir'})) {
		mkdir($self->make_chroot($self->{'pid_dir'}), 0777);
		}
	}
if (!-r $self->make_chroot($self->{'pid_file'})) {
	$self->open_tempfile(PID, ">".$self->make_chroot($self->{'pid_file'}));
	$self->close_tempfile(PID);
	$self->set_ownership($self->make_chroot($self->{'pid_file'}));
	}
if ($self->{'in_hash'}->{real} == 0) {
	# Create an empty root domain file... no need to do anything here
	}
elsif ($self->{'in_hash'}->{real} == 1) {
	# Try to download the root servers file from
	# ftp://rs.internic.net/domain/named.root
	$self->ftp_download("internic.net", "/domain/named.root", 
		      $self->make_chroot("$self->{'conf_directory'}/db.cache"));
	print BOOT "zone \".\" {\n";
	print BOOT "\ttype hint;\n";
	print BOOT "\tfile \"$self->{'conf_directory'}/db.cache\";\n";
	print BOOT "\t};\n";
	print BOOT "\n";
	}
elsif ($self->{'in_hash'}->{real} == 2) {
	# Use builtin db.cache
	$self->execute_command("cp ./db.cache ".$self->make_chroot("$self->{'conf_directory'}/db.cache"));
	print BOOT "zone \".\" {\n";
	print BOOT "\ttype hint;\n";
	print BOOT "\tfile \"$self->{'conf_directory'}/db.cache\";\n";
	print BOOT "\t};\n";
	print BOOT "\n";
	}
close(BOOT);
$self->execute_command("cp $self->{'conf_temp'} ".$self->make_chroot($self->{'config_hash'}->{'named_conf'}));
unlink($self->{'conf_temp'});
$self->unlock_file($self->make_chroot("$self->{'conf_directory'}/db.cache"));
$self->unlock_file($self->make_chroot($self->{'config_hash'}->{'named_conf'}));
$self->set_ownership($self->make_chroot("$self->{'conf_directory'}/db.cache"))
	if ($self->{'in_hash'}->{'real'} == 2 || $self->{'in_hash'}->{'real'} == 1);
$self->set_ownership($self->make_chroot($self->{'config_hash'}->{'named_conf'}));
$self->webmin_log("boot");
$self->redirect("start.cgi");

1;
		
}


1;

