#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_master.cgi
# Display options and directives in an existing master zone

&ModuleLoader::preload_module('bind8_class', "bind8::Bind8Lib");
$self = new bind8::Bind8Lib:: 'bind8_class',%$self;

$self->ReadParse();
if ($self->{'in_hash'}->{'zone'}) {
	$self->{'zone'} = $self->get_zone_name($self->{'in_hash'}->{'zone'}, 'any');
	$self->{'in_hash'}->{'index'} = $self->{'zone'}->{'index'};
	$self->{'in_hash'}->{'view'} = $self->{'zone'}->{'viewindex'};
	}
else {
	$self->{'zone'} = $self->get_zone_name($self->{'in_hash'}->{'index'}, $self->{'in_hash'}->{'view'});
	}
$self->{'dom'} = $self->{'zone'}->{'name'};
$self->can_edit_zone($self->{'zone'}) || $self->error($self->{'text_hash'}->{'master_ecannot'});
$self->{'desc'} = $self->ip6int_to_net($self->arpa_to_ip($self->{'dom'}));
$self->ui_print_header($self->{'desc'}, $self->{'text_hash'}->{'master_title'}, "");

# Find the record types
if (!$self->{'config_hash'}->{'largezones'}) {
	@{$self->{'recs_array'}} = grep { !$_->{'generate'} && !$_->{'defttl'} }
		     $self->read_zone_file($self->{'zone'}->{'file'}, $self->{'dom'});
	}
if ($self->{'dom'} =~ /in-addr\.arpa/i || $self->{'dom'} =~ /\.$self->{'ipv6revzone'}/i) {
	@{$self->{'rcodes_array'}} = $self->get_reverse_record_types();
	}
else {
	@{$self->{'rcodes_array'}} = $self->get_forward_record_types();
	}
push(@{$self->{'rcodes_array'}}, "ALL");
@{$self->{'rcodes_array'}} = grep { $self->can_edit_type($_, \%{$self->{'access_hash'}}) } @{$self->{'rcodes_array'}};

if (!$self->{'config_hash'}->{'largezones'}) {
	# See what record type we have
	foreach $c (@{$self->{'rcodes_array'}}) { $self->{'rnum_hash'}->{$c} = 0; }
	foreach $r (@{$self->{'recs_array'}}) {
		$self->{'rnum_hash'}->{$r->{'type'}}++;
		$self->{'rnum_hash'}->{"ALL"}++ if ($r->{'type'} ne "SOA");
		if ($r->{'type'} eq "SOA") { $self->{'soa'} = $r; }
		}
	}
else {
	# Just assume that we have all types
	$self->{'soa'} = 1;
	}

if ($self->{'config_hash'}->{'show_list'}) {
	# display as list
	$self->{'mid'} = int((@{$self->{'rcodes_array'}}+1)/2);
	print "<table width=100%> <tr><td width=50% valign=top>\n";
	&types_table(@{$self->{'rcodes_array'}}[0..$self->{'mid'}-1]);
	print "</td><td width=50% valign=top>\n";
	&types_table(@{$self->{'rcodes_array'}}[$self->{'mid'}..$#{$self->{'rcodes_array'}}]);
	print "</td></tr> </table>\n";
	}
else {
	# display as icons
	for($i=0; $i<@{$self->{'rcodes_array'}}; $i++) {
		push(@{$self->{'rlinks_array'}}, "edit_recs.cgi?index=$self->{'in_hash'}->{'index'}&".
			      "view=$self->{'in_hash'}->{'view'}&type=$self->{'rcodes_array'}->[$i]");
		push(@{$self->{'rtitles_array'}}, ($self->{'text_hash'}->{"type_$self->{'rcodes_array'}->[$i]"} || $self->{'rcodes_array'}->[$i]).
			       (defined(%{$self->{'rnum_hash'}}) ? " ($self->{'rnum_hash'}->{$self->{'rcodes_array'}->[$i]})" : ""));
		push(@{$self->{'ricons_array'}}, $self->{'is_extra_hash'}->{$self->{'rcodes_array'}->[$i]} ?
				"images/extra.gif" : "images/$self->{'rcodes_array'}->[$i].gif");
		}
	$self->icons_table(\@{$self->{'rlinks_array'}}, \@{$self->{'rtitles_array'}}, \@{$self->{'ricons_array'}});
	}

# links to forms editing text, soa and zone options
if ($self->{'access_hash'}->{'file'}) {
	push(@{$self->{'links_array'}}, "edit_text.cgi?index=$self->{'in_hash'}->{'index'}&view=$self->{'in_hash'}->{'view'}");
	push(@{$self->{'titles_array'}}, $self->{'text_hash'}->{'master_manual'});
	push(@{$self->{'images_array'}}, "images/text.gif");
	}
if ($self->{'access_hash'}->{'params'}) {
	push(@{$self->{'links_array'}}, "edit_soa.cgi?index=$self->{'in_hash'}->{'index'}&view=$self->{'in_hash'}->{'view'}");
	push(@{$self->{'titles_array'}}, $self->{'text_hash'}->{'master_soa'});
	push(@{$self->{'images_array'}}, "images/soa.gif");
	}
if ($self->{'access_hash'}->{'opts'}) {
	push(@{$self->{'links_array'}}, "edit_options.cgi?index=$self->{'in_hash'}->{'index'}&view=$self->{'in_hash'}->{'view'}");
	push(@{$self->{'titles_array'}}, $self->{'text_hash'}->{'master_options'});
	push(@{$self->{'images_array'}}, "images/options.gif");
	}
if ($self->{'access_hash'}->{'findfree'}) {
	push(@{$self->{'links_array'}}, "find_free.cgi?index=$self->{'in_hash'}->{'index'}&view=$self->{'in_hash'}->{'view'}");
	push(@{$self->{'titles_array'}}, $self->{'text_hash'}->{'findfree_desc'});
	push(@{$self->{'images_array'}}, "images/findfree.gif");
	}
if ($self->{'access_hash'}->{'gen'}) {
	push(@{$self->{'links_array'}}, "list_gen.cgi?index=$self->{'in_hash'}->{'index'}&view=$self->{'in_hash'}->{'view'}");
	push(@{$self->{'titles_array'}}, $self->{'text_hash'}->{'gen_title'});
	push(@{$self->{'images_array'}}, "images/gen.gif");
	}
if ($self->{'access_hash'}->{'whois'} && $self->has_command($self->{'config_hash'}->{'whois_cmd'}) &&
    $self->{'dom'} !~ /in-addr\.arpa/i) {
	push(@{$self->{'links_array'}}, "whois.cgi?index=$self->{'in_hash'}->{'index'}&view=$self->{'in_hash'}->{'view'}");
	push(@{$self->{'titles_array'}}, $self->{'text_hash'}->{'master_whois'});
	push(@{$self->{'images_array'}}, "images/whois.gif");
	}

if (@{$self->{'links_array'}}) {
	print "<hr>\n";
	$self->icons_table(\@{$self->{'links_array'}}, \@{$self->{'titles_array'}}, \@{$self->{'images_array'}});
	}

$self->{'apply'} = $self->{'access_hash'}->{'apply'} && $self->has_ndc();
if (!$self->{'access_hash'}->{'ro'} && ($self->{'access_hash'}->{'delete'} || $self->{'apply'})) {
	print "<hr>\n";
	print "<table width=100%>\n";

	if ($self->{'access_hash'}->{'delete'}) {
		# Show button to delete zome
		print "<form action=delete_zone.cgi>\n";
		print "<input type=hidden name=index value=\"$self->{'in_hash'}->{'index'}\">\n";
		print "<input type=hidden name=view value=\"$self->{'in_hash'}->{'view'}\">\n";
		print "<tr><td>\n";
		print "<input type=submit value=\"$self->{'text_hash'}->{'master_del'}\">\n";
		print "</td> <td>$self->{'text_hash'}->{'master_delmsg'}\n";
		if ($self->{'dom'} !~ /in-addr\.arpa/i && $self->{'dom'} !~ /\.$self->{'ipv6revzone'}/i) {
			print "$self->{'text_hash'}->{'master_delrev'}\n";
			}
		print "</td> </tr></form>\n";
		}

	if ($self->{'apply'}) {
		# Show button to do an NDC reload
		print "<form action=restart_zone.cgi>\n";
		print "<input type=hidden name=index value=\"$self->{'in_hash'}->{'index'}\">\n";
		print "<input type=hidden name=view value=\"$self->{'in_hash'}->{'view'}\">\n";
		print "<tr><td>\n";
		print "<input type=submit value=\"$self->{'text_hash'}->{'master_apply'}\">\n";
		$self->{'args'} = $self->{'view'} ? "$self->{'dom'} IN $self->{'view'}->{'value'}" : $self->{'dom'};
		$self->{'cmd'} = $self->has_ndc() == 2 ? $self->{'config_hash'}->{'rndc_cmd'}
				       : $self->{'config_hash'}->{'ndc_cmd'};
		print "</td> <td>",$self->text('master_applymsg',
			"<tt>$self->{'cmd'} reload $self->{'args'}</tt>");
		print "</td> </tr></form>\n";
		}

	print "</table>\n";
	}

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}

sub types_table
{
	shift if ($self == $_[0]);

if ($_[0]) {
	local($i);
	print $self->ui_columns_start([
		$self->{'text_hash'}->{'master_type'},
		defined(%{$self->{'rnum_hash'}}) ? ( $self->{'text_hash'}->{'master_records'} ) : ( )
		], 100);
	for($i=0; $_[$i]; $i++) {
		local @cols = ( "<a href=\"edit_recs.cgi?".
		      "index=$self->{'in_hash'}->{'index'}&view=$self->{'in_hash'}->{'view'}&type=$_[$i]\">".
		      ($self->{'text_hash'}->{"recs_$_[$i]"} || $_[$i])."</a>" );
		if (defined(%{$self->{'rnum_hash'}})) {
			push(@cols, $self->{'rnum_hash'}->{$_[$i]});
			}
		print $self->ui_columns_row(\@cols);
		}
	print $self->ui_columns_end();
	}
}


1;

