#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_recs.cgi
# Display records of some type from some domain

&ModuleLoader::preload_module('bind8_class', "bind8::Bind8Lib");
$self = new bind8::Bind8Lib:: 'bind8_class',%$self;

$self->ReadParse();

$self->foreign_require('virtual_server', 'virtual-server-lib.pl');

# Read config
$self->{'conf'} = $self->get_config();

# Redirect from virtual_server module
if ($self->{'in_hash'}->{'dom'}) {
    $self->{'d'} = $main::virtual_server_object->get_domain($self->{'in_hash'}->{'dom'});

    # Get zone's index if no any "view" directives present in the named.conf:
    $self->{'zone'} = $main::virtual_server_object->get_bind_zone($self->{'d'}->{'dom'});
    $self->{'in_hash'}->{'index'} = $self->{'zone'}->{'index'};
    # Get name of zone:
    $self->{'dname'} = $self->{'zone'}->{'value'};

    # Check is any "view" directive present into the named.conf
    # If yes - we try to get $self->{'in_hash'}->{'view'} and $self->{'in_hash'}->{'index'} in numeric form    
    # If we can't get $self->{'in_hash'}->{'view'} and $self->{'in_hash'}->{'index'} in numeric form
    # we redirect reguest to bind8/index.cgi
    @{$self->{'views_array'}} = $main::bind8_object->find("view",$self->{'conf'});
    $self->{'in_hash'}->{'view'} = $main::virtual_server_object->{'config_hash'}->{'dns_view'};
    if( @{$self->{'views_array'}} && ! $self->{'in_hash'}->{'view'}) { $self->redirect("/bind8"); exit;}
    elsif( @{$self->{'views_array'}} && $self->{'in_hash'}->{'view'}) {
	$self->{'in_hash'}->{'index'} = '';
	$self->{'ch_view'} = $main::virtual_server_object->get_bind_view( undef, $self->{'in_hash'}->{'view'});	    
	unless( $self->{'ch_view'}) { $self->redirect("/bind8"); exit;}
	@{$self->{'views_array'}} = $main::bind8_object->find("zone", $self->{'ch_view'}->{'members'});
	unless( @{$self->{'views_array'}}) { $self->redirect("/bind8"); exit;}	        	    

	foreach ( @{$self->{'views_array'}}) {
	    if( $_->{'value'} eq $self->{'dname'}) {
		$self->{'in_hash'}->{'index'} = $_->{'index'}; last;
		} 
	    }    
	unless( $self->{'in_hash'}->{'index'}) { $self->redirect("/bind8"); exit;}	        	    

        $self->{'in_hash'}->{'view'} = $self->{'ch_view'}->{'index'};
	$self->{'conf'} = $self->{'ch_view'}->{'members'};
	}
    $self->can_edit_zone($self->{'zone'}) || $self->error($self->{'text_hash'}->{'master_ecannot'});
    }
elsif( ! $self->{'in_hash'}->{'index'}) { $self->redirect("/bind8"); exit;}
# If request came from bind8 module ($self->{'in_hash'}->{'dom'} doesn't defined)
# but directive "view" is existed
elsif( $self->{'in_hash'}->{'view'}) {
    $self->{'view'} = $self->{'conf'}->[$self->{'in_hash'}->{'view'}];
     $self->{'conf'} = $self->{'view'}->{'members'};
    }

$self->{'zconf'} = $self->{'conf'}->[$self->{'in_hash'}->{'index'}]->{'members'};
$self->{'dom'} = $self->{'conf'}->[$self->{'in_hash'}->{'index'}]->{'value'};

%{$self->{'access_hash'}} = $self->get_module_acl();

$self->{'desc'} = $self->text('recs_header', $self->ip6int_to_net($self->arpa_to_ip($self->{'dom'})));
if ($self->{'in_hash'}->{'dom'}) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'recs_dnstitle'}, "", undef, undef, 1);
	}
else {
	$self->ui_print_header($self->{'desc'}, $self->text('recs_title', $self->{'text_hash'}->{"recs_$self->{'in_hash'}->{'type'}"} || $self->{'in_hash'}->{'type'}), "");
	}

# Show form for adding a record
$self->{'type'} = $self->find("type", $self->{'zconf'})->{'value'};
$self->{'file'} = $self->find("file", $self->{'zconf'})->{'value'};
$self->{'form'} = 0;
if (!$self->{'access_hash'}->{'ro'} && $self->{'type'} eq 'master' && $self->{'in_hash'}->{'type'} ne 'ALL') {
	$self->record_input($self->{'in_hash'}->{'index'}, $self->{'in_hash'}->{'view'}, $self->{'in_hash'}->{'type'}, $self->{'file'}, $self->{'dom'});
	$self->{'form'}++;
	}

if ($self->{'config_hash'}->{'largezones'}) {
	# Show search form
	print $self->ui_form_start("edit_recs.cgi");
	print $self->ui_hidden("index", $self->{'in_hash'}->{'index'}),"\n";
	print $self->ui_hidden("view", $self->{'in_hash'}->{'view'}),"\n";
	print $self->ui_hidden("type", $self->{'in_hash'}->{'type'}),"\n";
	print "<b>$self->{'text_hash'}->{'recs_find'}</b>\n";
	print $self->ui_textbox("search", $self->{'in_hash'}->{'search'}, 20),"\n";
	print $self->ui_submit($self->{'text_hash'}->{'recs_search'}),"\n";
	print $self->ui_form_end();
	$self->{'form'}++;
	}

if (!$self->{'config_hash'}->{'largezones'} || $self->{'in_hash'}->{'search'}) {
	# Get all records
	@{$self->{'allrecs_array'}} = grep { !$_->{'generate'} && !$_->{'defttl'} }
		     $self->read_zone_file($self->{'file'}, $self->{'dom'});
	if ($self->{'in_hash'}->{'search'}) {
		# Limit to records matching some search
		foreach $r (@{$self->{'allrecs_array'}}) {
			if ($r->{'name'} =~ /\Q$self->{'in_hash'}->{'search'}\E/i) {
				push(@{$self->{'recs_array'}}, $r);
				}
			else {
				foreach $v (@{$r->{'values'}}) {
					if ($v =~ /\Q$self->{'in_hash'}->{'search'}\E/i) {
						push(@{$self->{'recs_array'}}, $r);
						last;
						}
					}
				}
			}
		}
	else {
		# Show them all
		@{$self->{'recs_array'}} = @{$self->{'allrecs_array'}};
		}
	}

# Actually show the records
if ($self->{'in_hash'}->{'type'} eq "ALL") {
	@{$self->{'recs_array'}} = grep { $_->{'type'} ne "SOA" } @{$self->{'recs_array'}}
	}
else {
	@{$self->{'recs_array'}} = grep { $_->{'type'} eq $self->{'in_hash'}->{'type'} } @{$self->{'recs_array'}}
	}
if (@{$self->{'recs_array'}}) {
	@{$self->{'recs_array'}} = $self->sort_records(@{$self->{'recs_array'}});
	foreach $v (keys %{$self->{'text_hash'}}) {
		if ($v =~ /^value_([A-Z]+)(\d+)/) {
			$self->{'hmap_hash'}->{$1}->[$2-1] = $self->{'text_hash'}->{$v};
			}
		}
	@{$self->{'links_array'}} = ( );
	if (!$self->{'access_hash'}->{'ro'} && $self->{'type'} eq 'master') {
		print $self->ui_form_start("delete_recs.cgi", "post");
		print $self->ui_hidden("index", $self->{'in_hash'}->{'index'}),"\n";
		print $self->ui_hidden("view", $self->{'in_hash'}->{'view'}),"\n";
		print $self->ui_hidden("type", $self->{'in_hash'}->{'type'}),"\n";
		print $self->ui_hidden("sort", $self->{'in_hash'}->{'sort'}),"\n";
		@{$self->{'links_array'}} = ( $self->select_all_link("d", $self->{'form'}),
			   $self->select_invert_link("d", $self->{'form'}) );
		}
	print $self->ui_links_row(\@{$self->{'links_array'}});
	if ($self->{'in_hash'}->{'type'} =~ /HINFO|WKS|RP|KEY|LOC|SPF/ ||
	    $self->{'config_hash'}->{'allow_comments'}) {
		# One-column table
		&recs_table(@{$self->{'recs_array'}});
		}
	else {
		# Two-column table
		print "<table width=100%><tr><td>\n";
		&recs_table(@{$self->{'recs_array'}}[0 .. @{$self->{'recs_array'}}-1]);
		print "</td></tr></table>\n";
		}
	}
	
if ($self->{'in_hash'}->{'dom'}) {
	$self->ui_print_footer($self->{'text_hash'}->{'index_mainpage_url'},$self->{'text_hash'}->{'index_mainpage'});
	} 
else {
	$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'},
	    "edit_$self->{'type'}.cgi?index=$self->{'in_hash'}->{'index'}&view=$self->{'in_hash'}->{'view'}", $self->{'text_hash'}->{'recs_return'});
}

1;
		
}

sub recs_table
{
	shift if ($self == $_[0]);

local($r, $i, $j, $k, $h);

# Generate header, with correct columns for record type
local (@hcols, @tds);
if (!$self->{'access_hash'}->{'ro'} && $self->{'type'} eq 'master') {
	push(@hcols, "");
	push(@tds, "width=5");
	}
push(@hcols, "<a href='edit_recs.cgi?index=$self->{'in_hash'}->{'index'}&view=$self->{'in_hash'}->{'view'}&type=$self->{'in_hash'}->{'type'}&sort=1'>".($self->{'in_hash'}->{'type'} eq "PTR" ? $self->{'text_hash'}->{'recs_addr'} : $self->{'text_hash'}->{'recs_name'})."</a>");
push(@hcols, $self->{'text_hash'}->{'recs_type'}) if ($self->{'in_hash'}->{'type'} eq "ALL");
#push(@hcols, $self->{'text_hash'}->{'recs_ttl'});
@{$self->{'hmap_array'}} = @{$self->{'hmap_hash'}->{$self->{'in_hash'}->{'type'}}};
foreach $h (@{$self->{'hmap_array'}}) {
	push(@hcols, "<a class=user href='edit_recs.cgi?index=$self->{'in_hash'}->{'index'}&view=$self->{'in_hash'}->{'view'}&type=$self->{'in_hash'}->{'type'}&sort=2'>$h</a>");
	}
if ($self->{'in_hash'}->{'type'} eq "ALL" || $self->{'is_extra_hash'}->{$self->{'in_hash'}->{'type'}}) {
	push(@hcols, $self->{'text_hash'}->{'recs_vals'});
	}
if ($self->{'config_hash'}->{'allow_comments'} && $self->{'in_hash'}->{'type'} ne "WKS") {
	push(@hcols, "<a href='edit_recs.cgi?index=$self->{'in_hash'}->{'index'}&view=$self->{'in_hash'}->{'view'}&type=$self->{'in_hash'}->{'type'}&sort=4'>$self->{'text_hash'}->{'recs_comment'}</a>");
	}
push(@hcols, "<b>$self->{'text_hash'}->{'recs_actionhdr'}</b>");
print $self->ui_columns_start(\@hcols, 100);

# Show the actual records
for($i=0; $i<@_; $i++) {
	$r = $_[$i];
	if ($self->{'in_hash'}->{'type'} eq "PTR") {
		$self->{'name'} = $self->ip6int_to_net($self->arpa_to_ip($r->{'name'}));
		}
	elsif ($self->{'in_hash'}->{'type'} eq "SRV") {
		$self->{'name'} = $r->{'name'};
		$self->{'name'} =~ s/^_//;
		$self->{'name'} =~ s/\._/\./;
		}
	else {
		$self->{'name'} = $r->{'name'};
		}
	local @cols;
	$self->{'name'} = $self->html_escape($self->{'name'});
	if (!$self->{'access_hash'}->{'ro'} && $self->{'type'} eq 'master') {
		push(@cols, 
		      "<a class=user href=\"edit_record.cgi?index=".
		      "$self->{'in_hash'}->{'index'}&type=$self->{'in_hash'}->{'type'}&num=$r->{'num'}&".
		      "sort=$self->{'in_hash'}->{'sort'}&view=$self->{'in_hash'}->{'view'}&dom=$self->{'in_hash'}->{'dom'}\">$self->{'name'}</a>");
		}
	else {
		push(@cols, $self->{'name'});
		}
	if ($self->{'in_hash'}->{'type'} eq 'ALL') {
		push(@cols, $r->{'type'});
		}
	if ($r->{'ttl'} =~ /(\d+)([SMHDW]?)/i) {
		$r->{'ttl'} =~ s/S//i;
		if ($r->{'ttl'} =~ s/M//i) { $r->{'ttl'} *= 60; }
		if ($r->{'ttl'} =~ s/H//i) { $r->{'ttl'} *= 3600; }
		if ($r->{'ttl'} =~ s/D//i) { $r->{'ttl'} *= 86400; }
		if ($r->{'ttl'} =~ s/W//i) { $r->{'ttl'} *= 604800; }
		}
	#push(@cols, $r->{'ttl'} ? $self->html_escape($r->{'ttl'}) : $self->{'text_hash'}->{'default'});
	for($j=0; $j<@{$self->{'hmap_array'}}; $j++) {
		local $v;
		if ($self->{'in_hash'}->{'type'} eq "RP" && $j == 0) {
			$v .= $self->convert_illegal(
				$self->dotted_to_email($r->{'values'}->[$j]));
			}
		elsif ($self->{'in_hash'}->{'type'} eq "WKS" && $j == @{$self->{'hmap_array'}}-1) {
			for($k=$j; $r->{'values'}->[$k]; $k++) {
				$v .= $self->convert_illegal($r->{'values'}->[$k]);
				$v .= ' ';
				}
			}
		elsif ($self->{'in_hash'}->{'type'} eq "LOC") {
			$v = $self->convert_illegal(join(" ", @{$r->{'values'}}));
			}
		elsif ($self->{'in_hash'}->{'type'} eq "KEY" && $j == 3) {
			$v = substr($r->{'values'}->[$j], 0, 20)."...";
			}
		else {
			$v = $self->convert_illegal($r->{'values'}->[$j]);
			}
		push(@cols, $v);
		}
	if ($self->{'in_hash'}->{'type'} eq "ALL" || $self->{'is_extra_hash'}->{$self->{'in_hash'}->{'type'}}) {
		push(@cols, join(" ", @{$r->{'values'}}));
		}
	if ($self->{'config_hash'}->{'allow_comments'} && $self->{'in_hash'}->{'type'} ne "WKS") {
		push(@cols, $self->html_escape($r->{'comment'}));
		}
	@{$self->{'mas_array'}} = @{$r->{values}};
	$self->{'value'} = @{$self->{'mas_array'}}[0];
	$self->{'lnk_param'} =  "delete=Delete&type=$r->{'type'}&file=$r->{'file'}&index=$self->{'in_hash'}->{index}&view=$self->{'in_hash'}->{view}&sort=&dom=$self->{'in_hash'}->{dom}&origin=$self->{'zone'}->{value}& name=$r->{'name'}&value=$self->{'value'}&num=$r->{num}&redirtype=$self->{'in_hash'}->{'type'}";
	push (@cols, "<a class=menu href=\"save_record.cgi?$self->{'lnk_param'}\">$self->{'text_hash'}->{'recs_delrecord'}</a>");
		
	if (!$self->{'access_hash'}->{'ro'} && $self->{'type'} eq 'master') {
		print $self->ui_checked_columns_row(\@cols, \@tds,
					      "d", $r->{'num'});
		}
	else {
		print $self->ui_columns_row(\@cols, \@tds);
		}
	}
print $self->ui_columns_end();
if (!$self->{'access_hash'}->{'ro'} && $self->{'type'} eq 'master') {
	print $self->ui_links_row(\@{$self->{'links_array'}});
	print $self->ui_submit($self->{'text_hash'}->{'recs_delete'}),"\n";
	if ($self->{'in_hash'}->{'type'} eq 'A' || $self->{'in_hash'}->{'type'} eq 'AAAA') {
		print $self->ui_checkbox("rev", 1, $self->{'text_hash'}->{'recs_drev'}, $self->{'config_hash'}->{'rev_def'} != 1),"\n";
		}
	print $self->ui_form_end();
	}
if ($self->{'in_hash'}->{'dom'}) {
	print "<table width= 100%>";
	print "<tr><td colspan=5><b>&nbsp;</b></td></tr>";
	print "<tr $self->{'tb'}><td colspan=5><b>$self->{'text_hash'}->{'recs_adddomrecs'}</b></td></tr>";
local @name_type = ( {key => 'A', form =>
							"<td><input name=name value=\"\" size=20></td>\n
							<td><input type=hidden name=type value='A'><input type=hidden name=redirtype value='A'>A</td>\n
							<td><table width=100%><tr><td width=20%><b>$self->{'text_hash'}->{'value_A1'}</b></td><td><input name=value0 size=20 value=\"\"><input type=button onClick='ifield = document.forms[1].value0; chooser = window.open(\"../bind8/free_chooser.cgi\", \"chooser\", \"toolbar=no,menubar=no,scrollbars=yes,width=150,height=500\"); chooser.ifield = ifield; window.ifield = ifield' value=\"...\"></td></tr></table></td>\n"},
							$self->{'config_hash'}->{'support_aaaa'} ? {key => 'AAAA', form =>
							"<td><input name=name value=\"\" size=20></td>\n
							<td><input type=hidden name=type value='AAAA'><input type=hidden name=redirtype value='AAAA'>AAAA</td>\n
							<td><table width=100%><tr><td width=20%><b>$self->{'text_hash'}->{'edit_AAAA'}</b></td><td><input name=value0 size=20 value=\"\"><input type=button onClick='ifield = document.forms[1].value0; chooser = window.open(\"../bind8/free_chooser.cgi\", \"chooser\", \"toolbar=no,menubar=no,scrollbars=yes,width=150,height=500\"); chooser.ifield = ifield; window.ifield = ifield' value=\"...\"></td></tr></table></td>\n"} : undef,
							{key => 'NS', form =>
							"<td><input name=name size=20></td>\n
							<td><input type=hidden name=type value='NS'><input type=hidden name=redirtype value='NS'>NS</td>\n
							<td><table width=100%><tr><td width=20%><b>$self->{'text_hash'}->{'value_NS1'}</b></td><td><input name=value0 size=20 value=\"\"></td></tr></table></td>\n"},
							{key => 'MX', form =>
							"<td><input name=name size=20></td>\n
							<td><input type=hidden name=type value='MX'><input type=hidden name=redirtype value='MX'>MX</td>\n
							<td><table width=100%><tr><td width=20%><b>$self->{'text_hash'}->{'value_MX2'}</b></td><td><input name=value1 size=20 value=\"\"><b>&nbsp;$self->{'text_hash'}->{'value_MX1'}</b>&nbsp;<input name=value0 size=2 value=\"\"></td></tr></table></td>\n"},
							{key => 'CNAME', form =>
							"<td><input name=name size=20></td>\n
							<td><input type=hidden name=type value='CNAME'><input type=hidden name=redirtype value='CNAME'>CNAME</td>\n
							<td><table width=100%><tr><td width=20%><b>$self->{'text_hash'}->{'value_CNAME1'}</b></td><td><input name=value0 size=20 value=\"\"></td></tr></table></td>\n"},
							{key => 'PTR', form =>
							"<td><input name=name size=20></td>\n
							<td><input type=hidden name=type value='PTR'><input type=hidden name=redirtype value='PTR'>PTR</td>\n
							<td><table width=100%><tr><td width=20%><b>$self->{'text_hash'}->{'value_PTR1'}</b></td><td><input name=value0 size=20 value=\"\"></td></tr></table></td>\n"});
foreach (@name_type) {
	next unless $_;
	print "<tr $self->{'cb'}><form action='save_record.cgi'>";
	print "<input type=hidden name=index value=$self->{'in_hash'}->{index}>";
	print "<input type=hidden name=view value=$self->{'in_hash'}->{'view'}>";
	print "<input type=hidden name=file value=$r->{file}>";
	print "<input type=hidden name=origin value=$self->{'zone'}->{value}>";
	print "<input type=hidden name=sort value=''>";
	print "<input type=hidden name=new value=1>";
	print "<input type=hidden name=ttl_def value=1>";
	print "<input type=hidden name=dom value=$self->{'in_hash'}->{dom}>";
	print $_->{'form'};
	print "<td><input type=submit name=create value=\"$self->{'text_hash'}->{'recs_addrecord'}\"></td>";
	print "</form></tr>";
	}
print "</table>\n";
}
}


1;

