#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_soa.cgi
# Display the SOA for an existing master zone

&ModuleLoader::preload_module('bind8_class', "bind8::Bind8Lib");
$self = new bind8::Bind8Lib:: 'bind8_class',%$self;

$self->ReadParse();
$self->{'zone'} = $self->get_zone_name($self->{'in_hash'}->{'index'}, $self->{'in_hash'}->{'view'});
$self->{'dom'} = $self->{'zone'}->{'name'};
$self->can_edit_zone($self->{'zone'}) ||
	$self->error($self->{'text_hash'}->{'master_ecannot'});
$self->{'access_hash'}->{'params'} || $self->error($self->{'text_hash'}->{'master_esoacannot'});
$self->{'desc'} = $self->ip6int_to_net($self->arpa_to_ip($self->{'dom'}));
$self->ui_print_header($self->{'desc'}, $self->{'text_hash'}->{'master_params'}, "");

@{$self->{'recs_array'}} = $self->read_zone_file($self->{'zone'}->{'file'}, $self->{'dom'});
foreach $r (@{$self->{'recs_array'}}) {
	$self->{'soa'} = $r if ($r->{'type'} eq "SOA");
	$self->{'defttl'} = $r if ($r->{'defttl'});
	}
$self->{'v'} = $self->{'soa'}->{'values'};

# form for editing SOA record
print "<form action=save_soa.cgi>\n";
print "<input type=hidden name=file value=\"$self->{'soa'}->{'file'}\">\n";
print "<input type=hidden name=num value=\"$self->{'soa'}->{'num'}\">\n";
print "<input type=hidden name=origin value=\"$self->{'dom'}\">\n";
print "<input type=hidden name=index value=\"$self->{'in_hash'}->{'index'}\">\n";
print "<input type=hidden name=view value=\"$self->{'in_hash'}->{'view'}\">\n";
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'master_params'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'master_server'}</b></td>\n";
print "<td><input name=master size=20 value=\"$self->{'v'}->[0]\"></td>\n";
$self->{'v'}->[1] = $self->dotted_to_email($self->{'v'}->[1]);
print "<td><b>$self->{'text_hash'}->{'master_email'}</b></td>\n";
print "<td><input name=email size=20 value=\"$self->{'v'}->[1]\"></td> </tr>\n";

@{$self->{'u_array'}} = $self->extract_time_units($self->{'v'}->[3], $self->{'v'}->[4], $self->{'v'}->[5], $self->{'v'}->[6]);
print "<tr> <td><b>$self->{'text_hash'}->{'master_refresh'}</b></td>\n";
print "<td><input name=refresh size=10 value=\"$self->{'v'}->[3]\">\n";
print $self->time_unit_choice("refunit", $self->{'u_array'}->[0]);
print "</td>\n";
print "<td><b>$self->{'text_hash'}->{'master_retry'}</b></td>\n";
print "<td><input name=retry size=10 value=\"$self->{'v'}->[4]\">\n";
print $self->time_unit_choice("retunit", $self->{'u_array'}->[1]);
print "</td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'master_expiry'}</b></td>\n";
print "<td><input name=expiry size=10 value=\"$self->{'v'}->[5]\">\n";
print $self->time_unit_choice("expunit", $self->{'u_array'}->[2]);
print "</td>\n";
print "<td><b>$self->{'text_hash'}->{'master_minimum'}</b></td>\n";
print "<td><input name=minimum size=10 value=\"$self->{'v'}->[6]\">\n";
print $self->time_unit_choice("minunit", $self->{'u_array'}->[3]);
print "</td> </tr>\n";

print "<tr>\n";
print "<td><b>$self->{'text_hash'}->{'master_defttl'}</b></td> <td colspan=3>\n";
printf "<input type=radio name=defttl_def value=1 %s> %s\n",
	$self->{'defttl'} ? "" : "checked", $self->{'text_hash'}->{'default'};
printf "<input type=radio name=defttl_def value=0 %s>\n",
	$self->{'defttl'} ? "checked" : "";
$self->{'ttl'} = $self->{'defttl'}->{'defttl'} if ($self->{'defttl'});
($self->{'ttlu'}) = $self->extract_time_units($self->{'ttl'});
print "<input name=defttl size=10 value=\"$self->{'ttl'}\">\n";
print $self->time_unit_choice("defttlunit", $self->{'ttlu'});
print "</td>\n";

if (!$self->{'config_hash'}->{'updserial_on'}) {
	print "<tr> <td><b>$self->{'text_hash'}->{'master_serial'}</b></td>\n";
	print "<td><input name=serial size=20 value=\"$self->{'v'}->[2]\"></td> </tr>\n";
	}

print "</table></td></tr> </table>\n";
print "<input type=submit value=\"$self->{'text_hash'}->{'save'}\">\n" if (!$self->{'access_hash'}->{'ro'});
print "</form><p>\n";

$self->ui_print_footer("edit_master.cgi?index=$self->{'in_hash'}->{'index'}&view=$self->{'in_hash'}->{'view'}",
	$self->{'text_hash'}->{'master_return'});

1;
		
}


1;

