#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_slave.cgi
# Display records and other info for an existing slave or stub zone

&ModuleLoader::preload_module('bind8_class', "bind8::Bind8Lib");
$self = new bind8::Bind8Lib:: 'bind8_class',%$self;

$self->ReadParse();
$self->{'zone'} = $self->get_zone_name($self->{'in_hash'}->{'index'}, $self->{'in_hash'}->{'view'});
$self->{'dom'} = $self->{'zone'}->{'name'};
$self->can_edit_zone($self->{'zone'}) ||
	$self->error($self->{'text_hash'}->{'slave_ecannot'});
$self->{'desc'} = $self->ip6int_to_net($self->arpa_to_ip($self->{'dom'}));
if ($self->{'zone'}->{'file'}) {
	@{$self->{'st_array'}} = stat($self->make_chroot($self->{'zone'}->{'file'}));
	$self->{'lasttrans'} = $self->text('slave_last', @{$self->{'st_array'}} && $self->{'st_array'}->[7] ? $self->make_date($self->{'st_array'}->[9])
					     	       : $self->{'text_hash'}->{'slave_never'});
	}
$self->ui_print_header($self->{'desc'}, $0 =~ /edit_slave/ ? $self->{'text_hash'}->{'slave_title'}
					   : $self->{'text_hash'}->{'stub_title'},
		 "", undef, 0, 0, 0, undef, undef, undef, $self->{'lasttrans'});

if ($self->{'zone'}->{'file'}) {
	print "<p>\n";
	@{$self->{'recs_array'}} = $self->read_zone_file($self->{'zone'}->{'file'}, $self->{'dom'});
	if ($self->{'dom'} =~ /in-addr\.arpa/i || $self->{'dom'} =~ /\.$self->{'ipv6revzone'}/i) {
		@{$self->{'rcodes_array'}} = $self->get_reverse_record_types();
		}
	else {
		@{$self->{'rcodes_array'}} = $self->get_forward_record_types();
		}
	foreach $c (@{$self->{'rcodes_array'}}) { $self->{'rnum_hash'}->{$c} = 0; }
	foreach $r (@{$self->{'recs_array'}}) {
		$self->{'rnum_hash'}->{$r->{'type'}}++;
		if ($r->{'type'} eq "SOA") { $self->{'soa'} = $r; }
		}
	if ($self->{'config_hash'}->{'show_list'}) {
		# display as list
		$self->{'mid'} = int((@{$self->{'rcodes_array'}}+1)/2);
		print "<table width=100%> <tr><td width=50%>\n";
		&types_table(@{$self->{'rcodes_array'}}[0..$self->{'mid'}-1]);
		print "</td><td width=50%>\n";
		&types_table(@{$self->{'rcodes_array'}}[$self->{'mid'}..$#{$self->{'rcodes_array'}}]);
		print "</td></tr> </table>\n";
		}
	else {
		# display as icons
		for($i=0; $i<@{$self->{'rcodes_array'}}; $i++) {
			push(@{$self->{'rlinks_array'}}, "edit_recs.cgi?index=$self->{'in_hash'}->{'index'}".
				      "&view=$self->{'in_hash'}->{'view'}&type=$self->{'rcodes_array'}->[$i]");
			push(@{$self->{'rtitles_array'}}, $self->{'text_hash'}->{"type_$self->{'rcodes_array'}->[$i]"}.
				       " ($self->{'rnum_hash'}->{$self->{'rcodes_array'}->[$i]})");
			push(@{$self->{'ricons_array'}}, "images/$self->{'rcodes_array'}->[$i].gif");
			}
		$self->icons_table(\@{$self->{'rlinks_array'}}, \@{$self->{'rtitles_array'}}, \@{$self->{'ricons_array'}});
		}
	$self->{'done_recs'} = 1;
	}

# Shut buttons for editing, options and whois
if ($self->{'access_hash'}->{'file'} && $self->{'zone'}->{'file'}) {
	push(@{$self->{'links_array'}}, "view_text.cgi?index=$self->{'in_hash'}->{'index'}&view=$self->{'in_hash'}->{'view'}");
	push(@{$self->{'titles_array'}}, $self->{'text_hash'}->{'slave_manual'});
	push(@{$self->{'images_array'}}, "images/text.gif");
	}
if ($self->{'access_hash'}->{'opts'}) {
	push(@{$self->{'links_array'}}, "edit_soptions.cgi?index=$self->{'in_hash'}->{'index'}&view=$self->{'in_hash'}->{'view'}");
	push(@{$self->{'titles_array'}}, $self->{'text_hash'}->{'master_options'});
	push(@{$self->{'images_array'}}, "images/options.gif");
	}
if ($self->{'access_hash'}->{'whois'} && $self->has_command($self->{'config_hash'}->{'whois_cmd'}) &&
    $self->{'dom'} !~ /in-addr\.arpa/i) {
	push(@{$self->{'links_array'}}, "whois.cgi?index=$self->{'in_hash'}->{'index'}&view=$self->{'in_hash'}->{'view'}");
	push(@{$self->{'titles_array'}}, $self->{'text_hash'}->{'master_whois'});
	push(@{$self->{'images_array'}}, "images/whois.gif");
	}
if (@{$self->{'links_array'}}) {
	print "<hr>\n" if ($self->{'done_recs'});
	$self->icons_table(\@{$self->{'links_array'}}, \@{$self->{'titles_array'}}, \@{$self->{'images_array'}});
	}

$self->{'apply'} = $self->{'access_hash'}->{'apply'} && $self->has_ndc();
if (!$self->{'access_hash'}->{'ro'} && ($self->{'access_hash'}->{'delete'} || $self->{'apply'})) {
	print "<hr>\n";
	print "<table width=100%>\n";

	if ($self->{'access_hash'}->{'delete'}) {
		print "<form action=delete_zone.cgi>\n";
		print "<input type=hidden name=index value=\"$self->{'in_hash'}->{'index'}\">\n";
		print "<input type=hidden name=view value=\"$self->{'in_hash'}->{'view'}\">\n";
		print "<tr><td>\n";
		print "<input type=submit value=\"$self->{'text_hash'}->{'master_del'}\">\n";
		print "</td> <td>$self->{'text_hash'}->{'slave_delmsg'}\n";
		print "</td> </tr></form>\n";
		}

	if ($self->{'apply'}) {
		# Show button to do an NDC reload
		print "<form action=restart_zone.cgi>\n";
		print "<input type=hidden name=index value=\"$self->{'in_hash'}->{'index'}\">\n";
		print "<input type=hidden name=view value=\"$self->{'in_hash'}->{'view'}\">\n";
		print "<tr><td>\n";
		print "<input type=submit value=\"$self->{'text_hash'}->{'slave_apply'}\">\n";
		$self->{'args'} = $self->{'view'} ? "$self->{'dom'} IN $self->{'view'}->{'value'}" : $self->{'dom'};
		$self->{'cmd'} = $self->has_ndc() == 2 ? $self->{'config_hash'}->{'rndc_cmd'}
				       : $self->{'config_hash'}->{'ndc_cmd'};
		print "</td> <td>",$self->text('slave_applymsg',
			"<tt>$self->{'cmd'} reload $self->{'args'}</tt>");
		print "</td> </tr></form>\n";
		}

	print "</table>\n";
	}

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}

sub types_table
{
	shift if ($self == $_[0]);

if ($_[0]) {
	local($i);
	print $self->ui_columns_start([
		$self->{'text_hash'}->{'master_type'},
		$self->{'text_hash'}->{'master_records'},
		], 100);
	for($i=0; $_[$i]; $i++) {
		local @cols = ( "<a href=\"edit_recs.cgi?".
		      "index=$self->{'in_hash'}->{'index'}&view=$self->{'in_hash'}->{'view'}&type=$_[$i]\">".
		      ($self->{'text_hash'}->{"recs_$_[$i]"} || $_[$i])."</a>",
		      $self->{'rnum_hash'}->{$_[$i]} );
		print $self->ui_columns_row(\@cols);
		}
	print $self->ui_columns_end();
	}
}


1;

