#!/usr/bin/perl

&MAIN();

 sub MAIN {
# find_free.cgi
# Looks for free IP numbers
# by Ivan Andrian, <ivan.andrian@elettra.trieste.it>, 11/07/2000

&ModuleLoader::preload_module('bind8_class', "bind8::Bind8Lib");
$self = new bind8::Bind8Lib:: 'bind8_class',%$self;

$self->ReadParse();
$self->{'conf'} = $self->get_config();
if ($self->{'in_hash'}->{'view'} ne '') {
	$self->{'conf'} = $self->{'conf'}->[$self->{'in_hash'}->{'view'}]->{'members'};
	}
$self->{'zconf'} = $self->{'conf'}->[$self->{'in_hash'}->{'index'}]->{'members'};
$self->{'type'} = $self->find("type", $self->{'zconf'})->{'value'};
$self->{'file'} = $self->find("file", $self->{'zconf'})->{'value'};
$self->{'dom'} = $self->{'conf'}->[$self->{'in_hash'}->{'index'}]->{'value'};
if (!$self->{'access_hash'}->{'findfree'}) {$self->error($self->{'text_hash'}->{'findfree_nofind'})};
$self->{'desc'} = $self->text('findfree_header', $self->arpa_to_ip($self->{'dom'}));
$self->ui_print_header($self->{'desc'}, $self->text('findfree_title'), "");

local $cf=1;
if (@{$self->{'in_array'}} == 2) {
	&find_ips ($self->{'in_hash'}->{'index'}, $self->{'in_hash'}->{'from'});
}
elsif (@{$self->{'in_array'}} == 3) {
	&find_ips ($self->{'in_hash'}->{'index'}, $self->{'in_hash'}->{'from'}, $self->{'in_hash'}->{'to'});
}
elsif (@{$self->{'in_array'}} == 4) {
	$cf=$self->{'in_hash'}->{'cf'};
	&find_ips ($self->{'in_hash'}->{'index'}, $self->{'in_hash'}->{'from'}, $self->{'in_hash'}->{'to'}, $self->{'in_hash'}->{'cf'});
}
else {
	&find_ips ($self->{'in_hash'}->{'index'});
}

if (@{$self->{'in_array'}} >= 3) { #we need to do the search!

   @{$self->{'recs_array'}} = $self->read_zone_file($self->{'file'}, $self->{'dom'});
   @{$self->{'recs_array'}} = grep { ($_->{'type'} eq 'A') || ($_->{'type'} eq 'PTR')} @{$self->{'recs_array'}};
   local $freeXXXcount=0;
   local $freemaccount=0;
   if (@{$self->{'recs_array'}}) {
	@{$self->{'recs_array'}} = $self->sort_records(@{$self->{'recs_array'}});
	local %frecs = &build_iprange($self->{'in_hash'}->{'from'}, $self->{'in_hash'}->{'to'});

	for($i=0; $i<@{$self->{'recs_array'}}; $i++) {
		local $hip;	# host IP
		local $hname;	# hostname
		
		if ($self->{'recs_array'}->[$i]->{'type'} eq 'A') {
			$hip=$self->{'recs_array'}->[$i]->{'values'}->[0]; 		# IP no. in 'values' field
			$hname=$self->{'recs_array'}->[$i]->{'name'};				# name   in 'name' field
		}
		else {
			$hip=$self->arpa_to_ip($self->{'recs_array'}->[$i]->{'name'});	# IP no. in 'name' field
			$hname=$self->{'recs_array'}->[$i]->{'values'}->[0];		# name   in 'values' field
		}
		
#	print "evaluating ", $hip, " ", $hname, "...<BR>"; #debug
		
		if($cf & ($hname=~ /^free.*/) & exists $frecs{$hip}) {	# 'freeXXX' hostnames are free IP's!
			# update
#	print "&nbsp;&nbsp;updating: ",$hip, "... <BR>"; #debug
			$frecs{$hip}->{'ttl'}=$self->{'recs_array'}->[$i]->{'ttl'};
			$frecs{$hip}->{'name'}=$hname;
			$freeXXXcount++;
			if($hname=~ /^freemac.*/) {$freemaccount++;}
		}
		else {
#	print "&nbsp;&nbsp;deleting: ",$hip, "... <BR>"; #debug
			delete $frecs{$hip};
		}
	}
	
	local @frecs=sort { $self->{'a'} = $a; $self->{'b'} = $b; &ffree_ip_sort_func } values %frecs; 
	local $mid = int((@frecs+1)/2);
	print "<P align = \"center\"><STRONG>Found <BIG>" . @frecs . "</BIG> free IP number" . (@frecs==1?"\n":"s\n");
	if ($cf) {
		print " (<BIG>$freeXXXcount</BIG> ". ($freeXXXcount==1?" is":"are") .
				" <EM>`freeXXX'</EM>" .
				" of which <BIG>$freemaccount</BIG> ". ($freemaccount==1?" is":"are") . 
				" <EM>`freemac'</EM>)" ;
	print "</STRONG></P>\n";
	}
	print "<table width=100%><tr><td width=50% valign=top>\n";
	&frecs_table(@frecs[0 .. $mid-1]);
	print "</td><td width=50% valign=top>\n";
	if ($mid < @frecs) { &frecs_table(@frecs[$mid .. $#frecs]); }
	print "</td></tr></table><p>\n";
	print "<p>\n";

    } # if(@{$self->{'recs_array'}})
} # if(@{$self->{'in_array'}} >= 3)

$self->ui_print_footer("edit_$self->{'type'}.cgi?index=$self->{'in_hash'}->{'index'}&view=$self->{'in_hash'}->{'view'}",
	$self->{'text_hash'}->{'recs_return'});

#EOF
1;
		
}

# build_iprange(fromIP, toIP)
# Returns a list of IP numbers from fromIP to toIP
sub build_iprange
{
	shift if ($self == $_[0]);

$_[0] =~ /^(\d+)\.(\d+)\.(\d+)\.(\d+)/;
my @from = ($1, $2, $3, $4);
return @from if (@from != 4); #I want a correct IPv4 #
$_[1] =~ /^(\d+)\.(\d+)\.(\d+)\.(\d+)/;
my @to = ($1, $2, $3, $4);
return @to if (@to != 4);

for ($i=0;$i<4;$i++) {
	$from[$i]=$from[$i]==0?1:$from[$i];
	$to[$i]=$to[$i]==255?254:$to[$i];
}

my %frecs;

for ($byte0=$from[0]; $byte0<=$to[0]; $byte0++) {
	for ($byte1=$byte0==$from[0]?$from[1]:1;
			$byte1<=(($byte0==$to[0]?$to[1]:254));
			$byte1++) {
		##print "================<BR>";
		for ($byte2=($byte0==$from[0])&&($byte1==$from[1])?$from[2]:1;
				$byte2<=(($byte0==$to[0])&&($byte1==$to[1])?$to[2]:254);
				$byte2++) {
			##print "----------------<BR>";
			for ($byte3=($byte0==$from[0])&&($byte1==$from[1])&&($byte2==$from[2])?$from[3]:1;
					$byte3<=(($byte0==$to[0])&&($byte1==$to[1])&&($byte2==$to[2])?$to[3]:254);
					$byte3++) {
				$frecs{"$byte0.$byte1.$byte2.$byte3"}->{'ip'}="$byte0.$byte1.$byte2.$byte3";
				$frecs{"$byte0.$byte1.$byte2.$byte3"}->{'ttl'}=$self->{'text_hash'}->{'default'};
				$frecs{"$byte0.$byte1.$byte2.$byte3"}->{'name'}='';
				##push(@frecs, "$byte0.$byte1.$byte2.$byte3");
				##print "$byte0.$byte1.$byte2.$byte3<BR>";
			} #for $byte3
		} #for $byte2
	} #for $byte1
} #for $byte0

return %frecs;
} # sub build_iprange

# find_ips (zoneindex, from_ip, to_ip, consider_freeXX_names)
# Display a form for searching for free IP nos
sub find_ips
{
	shift if ($self == $_[0]);

print "<form action=find_free.cgi>\n";
print "<input type=hidden name=index value='$_[0]'>\n";
print "<input type=hidden name=view value='$self->{'in_hash'}->{'view'}'>\n";

print "<table border>\n";
print "<tr $self->{'tb'}><td><b>$self->{'text_hash'}->{'findfree_sopt'}</b></td> </tr>\n";
print "<tr $self->{'cb'}><td><table>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'findfree_IPrange'}</b></td>\n";
print "<td><b>$self->{'text_hash'}->{'findfree_from'}</b></td>\n";
if (@_ >= 2) { # there is a "from" field on the URL
	print "<td> <input name=from value=\"$_[1]\" size=30></td> </tr>\n";
	}
else {
	print "<td> <input name=from value=\"\" size=30></td> </tr>\n";
	}

print "<tr> <td>&nbsp;</td>\n";
print "<td><b>$self->{'text_hash'}->{'findfree_to'}</b></td>\n";
if (@_ >= 3) { # there is a "to" field on the URL
	print "<td> <input name=to value=\"$_[2]\" size=30></td> </tr>\n";
	}
else {
	print "<td> <input name=to value=\"\" size=30></td> </tr>\n";
	}

print "<tr> <td colspan=3 nowrap><b>$self->{'text_hash'}->{'findfree_cf'}</b>\n";

$self->{'cfy'}=$cf?'checked':'';
$self->{'cfn'}=(!$cf)?'checked':'';

print " &nbsp; <input type=radio name=cf value=1 $self->{'cfy'}> $self->{'text_hash'}->{'yes'}\n";
print "<input type=radio name=cf value=0 $self->{'cfn'}> $self->{'text_hash'}->{'no'}</td></tr>\n";

print "<tr colspan=3><td><input type=submit value=\"$self->{'text_hash'}->{'findfree_search'}\"></td></tr>\n";
print "</table></td></tr></table></form>\n";

} #	end of find_ips

# frecs_table(array_of_freerecords)
sub frecs_table
{
	shift if ($self == $_[0]);

print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>", $self->{'text_hash'}->{'recs_addr'},"</b></td>",
	"<td><b>$self->{'text_hash'}->{'recs_ttl'}</b></td>\n",
	"<td><b>$self->{'text_hash'}->{'recs_name'}</b></td>\n",
	"</tr>\n";

for($i=0; $i<@_; $i++) {
	$self->{'r'} = $_[$i];
	print "<tr $self->{'cb'}> <td>$self->{'r'}->{'ip'}</td>\n",
	"<td>",$self->{'r'}->{'ttl'} ? $self->{'r'}->{'ttl'} : $self->{'text_hash'}->{'default'},"</td>\n",
	"<td>",$self->{'r'}->{'name'}?$self->{'r'}->{'name'}:'&nbsp;',"</td>\n",
	"</tr>\n";
	}
	print "</table>\n";
}

sub ffree_ip_sort_func
{
	shift if ($self == $_[0]);

$self->{'a'}->{'ip'} =~ /^(\d+)\.(\d+)\.(\d+)\.(\d+)/;
local ($a1, $a2, $a3, $a4) = ($1, $2, $3, $4);
$self->{'b'}->{'ip'} =~ /^(\d+)\.(\d+)\.(\d+)\.(\d+)/;
return	$a1 < $1 ? -1 :
	$a1 > $1 ? 1 :
	$a2 < $2 ? -1 :
	$a2 > $2 ? 1 :
	$a3 < $3 ? -1 :
	$a3 > $3 ? 1 :
	$a4 < $4 ? -1 :
	$a4 > $4 ? 1 : 0;
}


1;

