#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Show a list of free IP addresses, within the configured ranges

&ModuleLoader::preload_module('bind8_class', "bind8::Bind8Lib");
$self = new bind8::Bind8Lib:: 'bind8_class',%$self;


# Go through all zones to find IPs in use, and networks
$self->{'conf'} = $self->get_config();
@{$self->{'views_array'}} = $self->find("view", $self->{'conf'});
foreach $v (@{$self->{'views_array'}}) {
	@{$self->{'vz_array'}} = $self->find("zone", $v->{'members'});
	map { $self->{'view_hash'}->{$_} = $v } @{$self->{'vz_array'}};
	push(@{$self->{'zones_array'}}, @{$self->{'vz_array'}});
	}
push(@{$self->{'zones_array'}}, $self->find("zone", $self->{'conf'}));
foreach $z (@{$self->{'zones_array'}}) {
	$self->{'type'} = $self->find_value("type", $z->{'members'});
	next if ($self->{'type'} ne "master");
	$self->{'file'} = $self->find_value("file", $z->{'members'});
	@{$self->{'recs_array'}} = $self->read_zone_file($self->{'file'}, $z->{'value'});
	foreach $r (@{$self->{'recs_array'}}) {
		if ($r->{'type'} eq 'A') {
			$self->{'taken_hash'}->{$r->{'values'}->[0]}++;
			$net = $r->{'values'}->[0];
			$net =~ s/\d+$/0/;
			if ($net ne "127.0.0.0") {
				$self->{'nets_hash'}->{$net}++;
				}
			}
		elsif ($r->{'type'} eq 'PTR') {
			$self->{'taken_hash'}->{$self->arpa_to_ip($r->{'values'}->[0])}++;
			}
		}
	}

# Use configured networks, if any
if ($self->{'config_hash'}->{'free_nets'}) {
	@{$self->{'nets_array'}} = split(/\s+/, $self->{'config_hash'}->{'free_nets'});
	}
else {
	@{$self->{'nets_array'}} = keys %{$self->{'nets_hash'}};
	}
@{$self->{'nets_array'}} = sort { $a cmp $b } @{$self->{'nets_array'}};

# display list of free IPs in the nets
$self->header();
print "<script>\n";
print "function select(f)\n";
print "{\n";
print "top.opener.ifield.value = f;\n";
print "top.close();\n";
print "return false;\n";
print "}\n";
print "</script>\n";
print "<title>$self->{'text_hash'}->{'free_title'}</title>\n";
print "<table width=100%>\n";
foreach $net (@{$self->{'nets_array'}}) {
	@netip = split(/\./, $net);
	if ($netip[3] eq "0") {
		$self->{'start'} = 1;
		$self->{'end'} = 255;
		}
	elsif ($netip[3] =~ /^(\d+)\-(\d+)$/) {
		$self->{'start'} = $1;
		$self->{'end'} = $2;
		}
	else {
		$self->{'start'} = $self->{'end'} = $netip[3];
		}
	for($d=$self->{'start'}; $d<=$self->{'end'}; $d++) {
		$self->{'ip'} = "$netip[0].$netip[1].$netip[2].$d";
		if (!$self->{'taken_hash'}->{$self->{'ip'}}) {
			print "<tr> <td><a href=\"\" onClick='return select(\"$self->{'ip'}\")'>$self->{'ip'}</a></td> </tr>\n";
			}
		}
	}
print "</table>\n";
$self->ui_print_footer();

1;
		
}


1;

