#!/usr/bin/perl

&MAIN();

 sub MAIN {
# index.cgi
# Display a list of domains and links to options

&ModuleLoader::preload_module('bind8_class', "bind8::Bind8Lib");
$self = new bind8::Bind8Lib:: 'bind8_class',%$self;

$self->ReadParse();

$self->{'need_create'} = !-r $self->make_chroot($self->{'config_hash'}->{'named_conf'});

# Check if bind is installed
if (!-x $self->{'config_hash'}->{'named_path'}) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", undef, 1, 1, 0,
		$self->help_search_link("bind", "doc", "google"));
	print "<p>",$self->text('index_enamed', "<tt>$self->{'config_hash'}->{'named_path'}</tt>",
			  "$self->{'gconfig_hash'}->{'webprefix'}/config.cgi?$self->{'module_name'}"),"<p>\n";

	$self->foreign_require("software", "software-lib.pl");
	$self->{'lnk'} = $main::software_object->missing_install_link("bind", $self->{'text_hash'}->{'index_bind'},
			"../$self->{'module_name'}/", $self->{'text_hash'}->{'index_title'});
	print $self->{'lnk'},"<p>\n" if ($self->{'lnk'});

	$self->ui_print_footer("/", $self->{'text_hash'}->{"index"});
	exit;
	}

# Check if BIND is the right version.. Only BIND 8/9 offers the -f option
# Is there a better way to do this?
if ($self->{'out'} = $self->check_bind_8()) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", undef, 1, 1, 0,
		$self->help_search_link("bind", "doc", "google"));
	print "<p>",$self->text('index_eversion', "<tt>$self->{'config_hash'}->{'named_path'}</tt>",
			  "/dnsadmin/", "<tt>$self->{'config_hash'}->{'named_path'} -help</tt>",
			  "<pre>$self->{'out'}</pre>"),"<p>\n";
	$self->ui_print_footer("/", $self->{'text_hash'}->{"index"});
	exit;
	}

# Try to get the version number
$self->{'out'} = `$self->{'config_hash'}->{'named_path'} -v 2>&1`;
if ($self->{'out'} =~ /(bind|named)\s+([0-9\.]+)/i) {
	$self->{'bind_version'} = $2;
	}
$self->open_tempfile(VERSION, ">$self->{'module_config_directory'}/version");
$self->print_tempfile(VERSION, "$self->{'bind_version'}\n");
$self->close_tempfile(VERSION);

# Get the list of zones
@{$self->{'allzones_array'}} = $self->list_zone_names();
@{$self->{'zones_array'}} = grep { $_->{'type'} ne 'view' &&
		$self->can_edit_zone($_) &&
		(!$self->{'access_hash'}->{'ro'} || $_->{'name'} ne '.') } @{$self->{'allzones_array'}};
@{$self->{'views_array'}} = grep { $_->{'type'} eq 'view' } @{$self->{'allzones_array'}};
($self->{'hashint'}) = grep { $_->{'type'} ne 'view' &&
		    $_->{'name'} eq '.' } @{$self->{'allzones_array'}};

if (@{$self->{'zones_array'}} == 1 && $self->{'access_hash'}->{'zones'} ne '*' && !$self->{'access_hash'}->{'defaults'} &&
    !$self->{'access_hash'}->{'views'} && $self->{'access_hash'}->{'apply'} != 1 && !$self->{'access_hash'}->{'master'} &&
    !$self->{'access_hash'}->{'slave'} && !$self->{'access_hash'}->{'forward'} && $self->{'access_hash'}->{'noconfig'}) {
	# Only one zone, so go direct to it
	$self->redirect("edit_master.cgi?index=$self->{'zones_array'}->[0]->{'index'}");
	exit;
	}

$self->{'chroot'} = $self->get_chroot();
$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", undef, 1, 1, 0,
	$self->help_search_link("bind", "doc", "google"), undef, undef,
	$self->text($self->{'chroot'} eq "/" || !$self->{'chroot'} ? 'index_version' : 'index_chroot',
	      $self->{'bind_version'}, "<tt>$self->{'chroot'}</tt>"));

# If the named.conf file does not exist, offer to create it
if ($self->{'need_create'}) {
	print $self->text('index_eempty',
		    "<tt>".$self->make_chroot($self->{'config_hash'}->{'named_conf'})."</tt>"),"<p>\n";
	print "<form action='dns_boot.cgi'>\n";
	print "<input type=hidden name=real value=1>\n";
	print "<input type=submit value=\"$self->{'text_hash'}->{'index_download'}\">\n";
	print "</form>\n";

	$self->ui_print_footer("/", $self->{'text_hash'}->{"index"});
	exit;
	}

if ($self->{'access_hash'}->{'defaults'}) {
	# display global options
	print $self->ui_subheading($self->{'text_hash'}->{'index_opts'});
	@{$self->{'olinks_array'}} = ("conf_servers.cgi", "conf_logging.cgi", "conf_acls.cgi",
		   "conf_files.cgi", "conf_forwarding.cgi", "conf_net.cgi",
		   "conf_misc.cgi", "conf_controls.cgi", "conf_keys.cgi",
		   "conf_zonedef.cgi",
		   ($self->{'bind_version'} >= 9 ? ( "conf_rndc.cgi" ) : ( )),
		   "conf_manual.cgi" );
	@{$self->{'otitles_array'}} = map { /(conf|list)_(\S+).cgi/; $self->{'text_hash'}->{$2."_title"} } @{$self->{'olinks_array'}};
	@{$self->{'oicons_array'}} = map { /^(conf|list)_(\S+).cgi/; "images/$2.gif"; } @{$self->{'olinks_array'}};
	$self->icons_table(\@{$self->{'olinks_array'}}, \@{$self->{'otitles_array'}}, \@{$self->{'oicons_array'}}, 5);
	print "<hr>\n";
	}

# Work out what creation links we have
@{$self->{'crlinks_array'}} = ( );
if ($self->{'access_hash'}->{'master'} && !$self->{'access_hash'}->{'ro'}) {
	push(@{$self->{'crlinks_array'}},
	     "<a href=\"master_form.cgi\">$self->{'text_hash'}->{'index_addmaster'}</a>");
	}
if ($self->{'access_hash'}->{'slave'} && !$self->{'access_hash'}->{'ro'}) {
	push(@{$self->{'crlinks_array'}},
	     "<a href=\"slave_form.cgi\">$self->{'text_hash'}->{'index_addslave'}</a>");
	push(@{$self->{'crlinks_array'}},
	     "<a href=\"stub_form.cgi\">$self->{'text_hash'}->{'index_addstub'}</a>");
	}
if ($self->{'access_hash'}->{'forward'} && !$self->{'access_hash'}->{'ro'}) {
	push(@{$self->{'crlinks_array'}},
	     "<a href=\"forward_form.cgi\">$self->{'text_hash'}->{'index_addfwd'}</a>");
	}
if ($self->{'access_hash'}->{'delegation'} && !$self->{'access_hash'}->{'ro'} && $self->version_atleast(9, 2, 1)) {
	push(@{$self->{'crlinks_array'}},
	     "<a href=\"delegation_form.cgi\">$self->{'text_hash'}->{'index_adddele'}</a>");
	}
if ($self->{'access_hash'}->{'master'} && !$self->{'access_hash'}->{'ro'} &&
    $self->{'hashint'} < (@{$self->{'views_array'}} ? scalar(@{$self->{'views_array'}}) : 1)) {
	push(@{$self->{'crlinks_array'}},
	     "<a href=\"hint_form.cgi\">$self->{'text_hash'}->{'index_addhint'}</a>");
	}
if (@{$self->{'crlinks_array'}}) {
	push(@{$self->{'crlinks_array'}},
	     "<a href=\"mass_form.cgi\">$self->{'text_hash'}->{'index_addmass'}</a>");
	}

if (@{$self->{'zones_array'}} > $self->{'config_hash'}->{'max_zones'}) {
	# Too many zones, show search form
	print $self->ui_subheading($self->{'text_hash'}->{'index_zones'});
	print "<p>$self->{'text_hash'}->{'index_toomany'}<p>\n";
	print "<form action=find_zones.cgi>\n";
	print "<b>$self->{'text_hash'}->{'index_find'}</b>\n";
	print "<input name=search size=20>\n";
	print "<input type=submit value='$self->{'text_hash'}->{'index_search'}'></form>\n";
	print $self->ui_links_row(\@{$self->{'crlinks_array'}});
	}
elsif (@{$self->{'zones_array'}} && (!@{$self->{'views_array'}} || !$self->{'config_hash'}->{'by_view'})) {
	# Show all zones
	print $self->ui_subheading($self->{'text_hash'}->{'index_zones'});
	foreach $z (@{$self->{'zones_array'}}) {
		$v = $z->{'name'};
		$self->{'t'} = $z->{'type'};
		next if (!$self->{'t'});
		$self->{'t'} = "delegation" if ($self->{'t'} eq "delegation-only");
		local $zn = $v eq "." ? "<i>$self->{'text_hash'}->{'index_root'}</i>"
				      : $self->ip6int_to_net($self->arpa_to_ip($v));
		if ($z->{'view'}) {
			local $vw = $z->{'viewindex'};
			push(@zlinks, "edit_$self->{'t'}.cgi?index=$z->{'index'}".
				      "&view=$vw");
			push(@ztitles, $zn." ".
			       $self->text('index_view', "<tt>$z->{'view'}</tt>"));
			push(@zdels, $self->can_edit_zone($z, $vw) ?
				$z->{'index'}." ".$z->{'viewindex'} : undef);
			}
		else {
			push(@zlinks, "edit_$self->{'t'}.cgi?index=$z->{'index'}");
			push(@ztitles, $zn);
			push(@zdels, $self->can_edit_zone($z) ?
				$z->{'index'} : undef);
			}
		push(@zsort, $self->{'t'} eq 'hint' ? undef : $ztitles[$#ztitles]);
		push(@zicons, "images/$self->{'t'}.gif");
		push(@ztypes, $self->{'text_hash'}->{"index_$self->{'t'}"});
		$self->{'zhash_hash'}->{$zn} = $z;
		$self->{'ztitlehash_hash'}->{$zn} = $ztitles[$#ztitles];
		$self->{'zlinkhash_hash'}->{$zn} = $zlinks[$#zlinks];
		$self->{'ztypeshash_hash'}->{$zn} = $ztypes[$#ztypes];
		$len++;
		}

	# sort list of zones
	@zorder = sort { &compare_zones($zsort[$a], $zsort[$b]) } (0 .. $len-1);
	@zlinks = map { $zlinks[$_] } @zorder;
	@ztitles = map { $ztitles[$_] } @zorder;
	@zicons = map { $zicons[$_] } @zorder;
	@ztypes = map { $ztypes[$_] } @zorder;
	@zdels = map { $zdels[$_] } @zorder;

	if ($self->{'config_hash'}->{'show_list'} == 1) {
		# display as list
		$self->{'mid'} = int((@zlinks+1)/2);
		print $self->ui_form_start("mass_delete.cgi", "post");
		@{$self->{'links_array'}} = ( $self->select_all_link("d", 0),
			   $self->select_invert_link("d", 0),
			   @{$self->{'crlinks_array'}} );
		print $self->ui_links_row(\@{$self->{'links_array'}});
		print "<table width=100%><tr><td width=50% valign=top>\n";
		$self->zones_table([ @zlinks[0 .. $self->{'mid'}-1] ],
			     [ @ztitles[0 .. $self->{'mid'}-1] ],
			     [ @ztypes[0 .. $self->{'mid'}-1] ],
			     [ @zdels[0 .. $self->{'mid'}-1] ] );
		print "</td><td width=50% valign=top>\n";
		if ($self->{'mid'} < @zlinks) {
			$self->zones_table([ @zlinks[$self->{'mid'} .. $#zlinks] ],
				     [ @ztitles[$self->{'mid'} .. $#ztitles] ],
				     [ @ztypes[$self->{'mid'} .. $#ztypes] ],
				     [ @zdels[$self->{'mid'} .. $#zdels] ]);
			}
		print "</td></tr></table>\n";
		print $self->ui_links_row(\@{$self->{'links_array'}});
		print $self->ui_form_end([ [ "delete", $self->{'text_hash'}->{'index_massdelete'} ],
				     [ "update", $self->{'text_hash'}->{'index_massupdate'} ] ]);
		}
	elsif ($self->{'config_hash'}->{'show_list'} == 2) {
		# Show as collapsible tree, broken down by domain parts
		%{$self->{'heiropen_hash'}} = map { $_, 1 } $self->get_heiropen();
		$self->{'heiropen_hash'}->{""} = 1;
		foreach $z (grep { $_->{'type'} } @{$self->{'zones_array'}}) {
			local $v = $z->{'name'};
			local @p = split(/\./, $self->ip6int_to_net($self->arpa_to_ip($v)));
			for($self->{'i'}=1; $self->{'i'}<=@p; $self->{'i'}++) {
				local $ch = join(".", @p[$self->{'i'}-1 .. $#p]);
				local $par = $self->{'i'} == @p ?
					"" : join(".", @p[$self->{'i'} .. $#p]);
				@{$self->{'ztree_hash'}->{$par}} = $self->unique(@{$self->{'ztree_hash'}->{$par}}, $ch);
				}
			}
		print $self->ui_links_row(\@{$self->{'crlinks_array'}});
		print "<table>\n";
		&recursive_tree("");
		print "</table>\n";
		print $self->ui_links_row(\@{$self->{'crlinks_array'}});
		}
	else {
		# display as icons
		print $self->ui_links_row(\@{$self->{'crlinks_array'}});
		$self->icons_table(\@zlinks, \@ztitles, \@zicons, 5);
		print $self->ui_links_row(\@{$self->{'crlinks_array'}});
		}
	}
elsif (@{$self->{'zones_array'}}) {
	# Show zones under views
	print $self->ui_subheading($self->{'text_hash'}->{'index_zones'});
	foreach $vw (@{$self->{'views_array'}}) {
		local (@zorder, @zlinks, @ztitles, @zicons, @ztypes, @zsort, @zdels, $len);
		local @zv = grep { $_->{'view'} eq $vw->{'name'} } @{$self->{'zones_array'}};
		next if (!@zv);
		print "<b>",$self->text('index_inview',
				  "<tt>$vw->{'name'}</tt>"),"</b><br>\n";
		foreach $z (@zv) {
			$v = $z->{'name'};
			$self->{'t'} = $z->{'type'};
			local $zn = $v eq "." ? "<i>$self->{'text_hash'}->{'index_root'}</i>"
					      : $self->ip6int_to_net($self->arpa_to_ip($v));
			push(@zlinks, "edit_$self->{'t'}.cgi?index=$z->{'index'}".
				      "&view=$z->{'viewindex'}");
			push(@ztitles, $zn);
			push(@zsort, $self->{'t'} eq 'hint' ? undef : $ztitles[$#ztitles]);
			push(@zicons, "images/$self->{'t'}.gif");
			push(@ztypes, $self->{'text_hash'}->{"index_$self->{'t'}"});
			push(@zdels, $z->{'index'}." ".$z->{'viewindex'});
			$len++;
			}

		# sort list of zones
		@zorder = sort { &compare_zones($zsort[$a], $zsort[$b]) }
			       (0 .. $len-1);
		@zlinks = map { $zlinks[$_] } @zorder;
		@ztitles = map { $ztitles[$_] } @zorder;
		@zicons = map { $zicons[$_] } @zorder;
		@ztypes = map { $ztypes[$_] } @zorder;
		@zdels = map { $zdels[$_] } @zorder;

		print $self->ui_links_row(\@{$self->{'crlinks_array'}});
		if ($self->{'config_hash'}->{'show_list'}) {
			# display as list
			$self->{'mid'} = int((@zlinks+1)/2);
			print $self->ui_form_start("mass_delete.cgi", "post");
			print "<table width=100%><tr><td width=50% valign=top>\n";
			$self->zones_table([ @zlinks[0 .. $self->{'mid'}-1] ],
				     [ @ztitles[0 .. $self->{'mid'}-1] ],
				     [ @ztypes[0 .. $self->{'mid'}-1] ],
				     [ @zdels[0 .. $self->{'mid'}-1] ]);
			print "</td><td width=50% valign=top>\n";
			if ($self->{'mid'} < @zlinks) {
				$self->zones_table([ @zlinks[$self->{'mid'} .. $#zlinks] ],
					     [ @ztitles[$self->{'mid'} .. $#ztitles] ],
					     [ @ztypes[$self->{'mid'} .. $#ztypes] ],
					     [ @zdels[$self->{'mid'} .. $#zdels] ]);
				}
			print "</td></tr></table>\n";
			print $self->ui_form_end([
				[ "delete", $self->{'text_hash'}->{'index_massdelete'} ],
				[ "update", $self->{'text_hash'}->{'index_massupdate'} ] ]);
			}
		else {
			# display as icons
			$self->icons_table(\@zlinks, \@ztitles, \@zicons, 5);
			}
		print $self->ui_links_row(\@{$self->{'crlinks_array'}});
		}
	}
else {
	print "<b>$self->{'text_hash'}->{'index_none'}</b><p>\n";
	print $self->ui_links_row(\@{$self->{'crlinks_array'}});
	}

if ($self->{'access_hash'}->{'views'} && $self->{'bind_version'} >= 9) {
	# Display list of views
	print "<hr>\n";
	print $self->ui_subheading($self->{'text_hash'}->{'index_views'});
	@{$self->{'views_array'}} = grep { $self->can_edit_view($_) } @{$self->{'views_array'}};
	foreach $v (@{$self->{'views_array'}}) {
		push(@{$self->{'vlinks_array'}}, "edit_view.cgi?index=$v->{'index'}");
		push(@{$self->{'vtitles_array'}}, $v->{'name'});
		push(@{$self->{'vicons_array'}}, "images/view.gif");
		}
	@{$self->{'links_array'}} = ( );
	push(@{$self->{'links_array'}}, "<a href=\"view_form.cgi\">$self->{'text_hash'}->{'index_addview'}</a>")
		if (!$self->{'access_hash'}->{'ro'} && $self->{'access_hash'}->{'views'} != 2);
	if (@{$self->{'views_array'}}) {
		print $self->ui_links_row(\@{$self->{'links_array'}});
		$self->icons_table(\@{$self->{'vlinks_array'}}, \@{$self->{'vtitles_array'}}, \@{$self->{'vicons_array'}}, 5);
		}
	else {
		print "<b>$self->{'text_hash'}->{'index_vnone'}</b><p>\n";
		}
	print $self->ui_links_row(\@{$self->{'links_array'}});
	}

# read the PID
if (!$self->{'access_hash'}->{'ro'} && ($self->{'access_hash'}->{'apply'} == 1 || $self->{'access_hash'}->{'apply'} == 3)) {
	print "<hr>\n";
	print $self->ui_buttons_start();
	if ($self->is_bind_running()) {
		# named is running .. show restart and stop button
		if ($self->{'access_hash'}->{'remote'}) {
#			@{$self->{'servers_array'}} = &list_slave_servers();
			@{$self->{'servers_array'}} = ();
			}
		print $self->ui_buttons_row("restart.cgi", $self->{'text_hash'}->{'index_apply'},
				      @{$self->{'servers_array'}} ? $self->{'text_hash'}->{'index_applymsg2'}
					       : $self->{'text_hash'}->{'index_applymsg'});
		if ($self->{'access_hash'}->{'apply'} == 1) {
			print $self->ui_buttons_row("stop.cgi", $self->{'text_hash'}->{'index_stop'},
					      $self->{'text_hash'}->{'index_stopmsg'});
			}
		}
	elsif ($self->{'access_hash'}->{'apply'} == 1) {
		# named is not running .. show start button
		print $self->ui_buttons_row("start.cgi", $self->{'text_hash'}->{'index_start'},
				      $self->{'text_hash'}->{'index_startmsg'});
		}
	print $self->ui_buttons_end();
	}

$self->ui_print_footer("/", $self->{'text_hash'}->{"index"});

1;
		
}

sub dump_config
{
	shift if ($self == $_[0]);

local($c);
foreach $c (@{$_[0]}) {
	print "$_[1]$c->{'name'} ",
		join(',', @{$c->{'values'}});
	if ($c->{'type'}) {
		print " {\n";
		&dump_config($c->{'members'}, "$_[1]\t");
		print "$_[1]}\n";
		}
	else { print "\n"; }
	}
}

sub compare_zones
{
	shift if ($self == $_[0]);

local @sp0 = split(/\./, lc($_[0]));
local @sp1 = split(/\./, lc($_[1]));
for($self->{'i'}=0; $self->{'i'}<@sp0 || $self->{'i'}<@sp1; $self->{'i'}++) {
	if ($sp0[$self->{'i'}] =~ /^\d+$/ && $sp1[$self->{'i'}] =~ /^\d+$/) {
		return -1 if ($sp0[$self->{'i'}] < $sp1[$self->{'i'}]);
		return 1 if ($sp0[$self->{'i'}] > $sp1[$self->{'i'}]);
		}
	else {
		local $c = $sp0[$self->{'i'}] cmp $sp1[$self->{'i'}];
		return $c if ($c);
		}
	}
return 0;
}

sub recursive_tree
{
	shift if ($self == $_[0]);

local ($name, $depth) = @_;
print "<tr> <td>", "&nbsp;&nbsp;" x $depth;
if ($_[0] ne "") {
	print "<a name=\"$name\"></a>\n";
	$name =~ /^([^\.]+)/;
	if (!$self->{'ztree_hash'}->{$name}) {
		# Has no children
		print "<img border=0 src=images/smallicon.gif>&nbsp; $1</td>\n",
		}
	else {
		# Has children
		local $act = $self->{'heiropen_hash'}->{$name} ? "close" : "open";
		print "<a href=\"$act.cgi?what=",$self->urlize($name),"\">";
		print "<img border=0 src=images/$act.gif></a>&nbsp; $1</td>\n",
		}
	}
else {
	# Is the root
	print "<img src=images/close.gif> <i>$self->{'text_hash'}->{'index_all'}</i></td>\n";
	}
if ($self->{'zhash_hash'}->{$name}) {
	print "<td><a href='$self->{'zlinkhash_hash'}->{$name}'>$self->{'ztitlehash_hash'}->{$name} ($self->{'ztypeshash_hash'}->{$name})</a></td> </tr>\n";
	}
else {
	print "<td><br></td> </tr>\n";
	}
if ($self->{'heiropen_hash'}->{$name}) {
	foreach $sz (@{$self->{'ztree_hash'}->{$name}}) {
		&recursive_tree($sz, $depth+1);
		}
	}
}


1;

