#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Show hosts in BIND cluster

&ModuleLoader::preload_module('bind8_class', "bind8::Bind8Lib");
$self = new bind8::Bind8Lib:: 'bind8_class',%$self;

$self->{'access_hash'}->{'slaves'} || $self->error($self->{'text_hash'}->{'slaves_ecannot'});
$self->foreign_require("servers", "servers-lib.pl");
$self->ReadParse();
$self->ui_print_header(undef, $self->{'text_hash'}->{'slaves_title'}, "");

# Show existing servers
@{$self->{'servers_array'}} = $self->list_slave_servers();
if (@{$self->{'servers_array'}}) {
	print $self->ui_form_start("slave_delete.cgi", "post");
	@{$self->{'links_array'}} = ( $self->select_all_link("d"),
		   $self->select_invert_link("d") );
	print $self->ui_links_row(\@{$self->{'links_array'}});
	@{$self->{'tds_array'}} = ( "width=5" );
	print $self->ui_columns_start([
		"",
		$self->{'text_hash'}->{'slaves_host'},
		$self->{'text_hash'}->{'slaves_dosec'},
		$self->{'text_hash'}->{'slaves_view'},
		$self->{'text_hash'}->{'slaves_desc'},
		$self->{'text_hash'}->{'slaves_os'} ], 100, 0, \@{$self->{'tds_array'}});
	foreach $s (@{$self->{'servers_array'}}) {
		local @cols;
		push(@cols, $s->{'host'}.
			    ($s->{'nsname'} ? " ($s->{'nsname'})" : ""));
		push(@cols, $s->{'sec'} ? $self->{'text_hash'}->{'yes'} : $self->{'text_hash'}->{'no'});
		push(@cols, $s->{'bind8_view'} ||
			    "<i>$self->{'text_hash'}->{'slaves_noview'}</i>");
		push(@cols, $s->{'desc'});
		($self->{'type'}) = grep { $_->[0] eq $s->{'type'} }
			       @{$main::servers_object->{'server_types_array'}};
		push(@cols, $self->{'type'}->[1]);
		print $self->ui_checked_columns_row(\@cols, \@{$self->{'tds_array'}}, "d", $s->{'id'});
		}
	print $self->ui_columns_end();
	print $self->ui_links_row(\@{$self->{'links_array'}});
	print $self->ui_form_end([ [ "delete", $self->{'text_hash'}->{'slaves_delete'} ] ]);
	}
else {
	print "<b>$self->{'text_hash'}->{'slaves_none'}</b><p>\n";
	}

# Show buttons to add
@{$self->{'allservers_array'}} = grep { $_->{'user'} } $main::servers_object->list_servers();
if (@{$self->{'allservers_array'}}) {
	print "<form action=slave_add.cgi>\n";
	print "<table width=100%><tr>\n";
	%{$self->{'gothost_hash'}} = map { $_->{'id'}, 1 } @{$self->{'servers_array'}};
	@{$self->{'addservers_array'}} = grep { !$self->{'gothost_hash'}->{$_->{'id'}} } @{$self->{'allservers_array'}};
	if (@{$self->{'addservers_array'}}) {
		print "<td><input type=submit name=add value='$self->{'text_hash'}->{'slaves_add'}'>\n";
		print "<select name=server>\n";
		foreach $s (@{$self->{'addservers_array'}}) {
			print "<option value=$s->{'id'}>",
				$s->{'desc'} ? $s->{'desc'} : $s->{'host'},"\n";
			}
		print "</select>\n";
		print "</td>\n";
		}
	@{$self->{'groups_array'}} = $main::servers_object->list_all_groups(\@{$self->{'allservers_array'}});
	if (@{$self->{'groups_array'}}) {
		print "<td align=right><input type=submit name=gadd ",
		      "value='$self->{'text_hash'}->{'slaves_gadd'}'>\n";
		print "<select name=group>\n";
		foreach $g (@{$self->{'groups_array'}}) {
			print "<option>$g->{'name'}\n";
			}
		print "</select></td>\n";
		}
	print "</tr></table>\n";

	if (@{$self->{'addservers_array'}} || @{$self->{'groups_array'}}) {
		# Show inputs for view and existing create
		print "<table><tr>\n";
		print "<tr> <td><b>$self->{'text_hash'}->{'slaves_toview'}</b></td>\n";
		print "<td>",$self->ui_opt_textbox("view", undef, 15, $self->{'text_hash'}->{'slaves_noview2'},
				      $self->{'text_hash'}->{'slaves_inview'}),"</td> </tr>\n";

		print "<tr> <td><b>$self->{'text_hash'}->{'slaves_sec'}</b></td>\n";
		print "<td>",$self->ui_yesno_radio("sec", 0),"</td> </tr>\n";

		print "<tr> <td><b>$self->{'text_hash'}->{'slaves_sync'}</b></td>\n";
		print "<td>",$self->ui_yesno_radio("sync", 0),"</td> </tr>\n";

		print "<tr> <td><b>$self->{'text_hash'}->{'slaves_name'}</b></td>\n";
		print "<td>",$self->ui_opt_textbox("name", undef, 30,
				$self->{'text_hash'}->{'slaves_same'}),"</td> </tr>\n";

		print "</table>\n";
		}
	print "</form>\n";
	}
else {
	print "<b>",$self->text('slaves_need', '../servers/'),"</b><p>\n";
	}

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

