#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Actually create multiple zones

&ModuleLoader::preload_module('bind8_class', "bind8::Bind8Lib");
$self = new bind8::Bind8Lib:: 'bind8_class',%$self;

$self->ReadParseMime();
$self->ui_print_unbuffered_header(undef, $self->{'text_hash'}->{'mass_title'}, "");
$self->error_setup($self->{'text_hash'}->{'mass_err'});
$self->{'conf'} = $self->get_config();
$self->{'access_hash'}->{'ro'} && $self->error($self->{'text_hash'}->{'master_ero'});

# Check if the template needs IPs
if ($self->{'in_hash'}->{'tmpl'}) {
	for($i=0; $self->{'config_hash'}->{"tmpl_$i"}; $i++) {
		@c = split(/\s+/, $self->{'config_hash'}->{"tmpl_$i"}, 3);
		if ($c[1] eq 'A' && !$c[2]) {
			$self->{'tmpl_ip'}++;
			}
		}
	}

# Build map of taken zones
if ($self->{'in_hash'}->{'view'} ne '') {
	# In some view
	@{$self->{'zones_array'}} = grep { $_->{'viewindex'} eq $self->{'in_hash'}->{'view'} &&
			$_->{'type'} ne 'view' }
		      $self->list_zone_names();
	$self->{'view'} = $self->{'conf'}->[$self->{'in_hash'}->{'view'}];
	$self->can_edit_view($self->{'view'}) || $self->error($self->{'text_hash'}->{'mass_eviewcannot'});
	$self->{'vn'} = $self->{'view'}->{'value'};
	}
else {
	# At top-level
	@{$self->{'zones_array'}} = grep { !$_->{'view'} && $_->{'type'} ne 'view' }
		      $self->list_zone_names();
	}
%{$self->{'taken_hash'}} = map { $_->{'name'}, $_ } @{$self->{'zones_array'}};

# Get zone defaults
$self->get_zone_defaults(\%{$self->{'zd_hash'}});

if ($self->{'in_hash'}->{'local'}) {
	open(LOCAL, $self->{'in_hash'}->{'local'}) || $self->error($self->{'text_hash'}->{'mass_elocal'});
	while(<LOCAL>) {
		$self->{'local'} .= $_;
		}
	close(LOCAL);
	print "<b>",$self->text('mass_dolocal', "<tt>$self->{'in_hash'}->{'local'}</tt>"),"</b><br>\n";
	&execute_batchfile($self->{'local'});
	print "<b>",$self->{'text_hash'}->{'mass_done'},"</b><p>\n";
	}
if ($self->{'in_hash'}->{'upload'}) {
	print "<b>",$self->text('mass_doupload'),"</b><br>\n";
	&execute_batchfile($self->{'in_hash'}->{'upload'});
	print "<b>",$self->{'text_hash'}->{'mass_done'},"</b><p>\n";
	}
if ($self->{'in_hash'}->{'text'}) {
	print "<b>",$self->text('mass_dotext'),"</b><br>\n";
	&execute_batchfile($self->{'in_hash'}->{'text'});
	print "<b>",$self->{'text_hash'}->{'mass_done'},"</b><p>\n";
	}

$self->webmin_log("mass", undef, $self->{'zonecount'});
$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}

# execute_batchfile(data)
sub execute_batchfile
{
	shift if ($self == $_[0]);

local @lines = split(/[\r\n]+/, $_[0]);
local $l;
local $lnum = 0;
foreach $l (@lines) {
	$lnum++;
	local @w = split(/:/, $l);
	local $dom = $w[0];
	if ($dom !~ /^[a-z0-9\.\-\_]+$/) {
		&line_error($l, $self->{'text_hash'}->{'mass_edom'});
		next;
		}
	local $isrev = 0;
	if ($self->check_ipaddress($dom)) {
		$dom = $self->ip_to_arpa($dom);
		$isrev = 1;
		}

	# Check for a clash
	if ($self->{'taken_hash'}->{$dom}) {
		&line_error($l, $self->{'text_hash'}->{'mass_etaken'});
		next;
		}

	# Get the IP addresses
	local @mips = split(/\s+/, $w[3]);
	foreach $mip (@mips) {
		if (!$self->check_ipaddress($mip)) {
			&line_error($l, $self->{'text_hash'}->{'mass_eip'});
			next;
			}
		}

	local $type = $w[1] || "master";
	local $file = $w[2];
	local $dir;
	if ($type eq "master") {
		# Creating a master zone
		if (!$self->{'access_hash'}->{'master'}) {
			&line_error($l, $self->{'text_hash'}->{'mcreate_ecannot'});
			next;
			}

		# Work out the base
		$self->{'base'} = $self->{'config_hash'}->{'master_dir'} ? $self->{'config_hash'}->{'master_dir'} :
			$self->{'access_hash'}->{'dir'} eq '/' ? $self->base_directory($self->{'conf'}) :
						$self->{'access_hash'}->{'dir'};

		# Make sure a template IP was given, if needed
		if ($self->{'tmpl_ip'} && !@mips) {
			&line_error($l, $self->{'text_hash'}->{'mass_etmpl'});
			next;
			}

		# Work out the filename
		if ($file) {
			if ($file !~ /^\//) {
				$file = $self->{'base'}."/".$file;
				}
			if (!$self->allowed_zone_file(\%{$self->{'access_hash'}}, $file)) {
				&line_error($l, $self->text('create_efile2', $file));
				next;
				}
			}
		else {
			$file = $self->automatic_filename($dom, $isrev, $self->{'base'}, $self->{'vn'});
			}
		if (-r $self->make_chroot($file)) {
			&line_error($l, $self->text('create_efile4', $file));
			next;
			}

		# Create the zone file and initial records
		local $master = $self->{'config_hash'}->{'default_prins'} ||
				$self->get_system_hostname();
		$master =~ s/\.$//;
		$master .= ".";
		local $email = $self->{'config_hash'}->{'tmpl_email'} || "root\@$master";
		$email = $self->email_to_dotted($email);
		$self->create_master_records($file, $dom, $master, $email,
				       $self->{'zd_hash'}->{'refresh'}.$self->{'zd_hash'}->{'refunit'},
				       $self->{'zd_hash'}->{'retry'}.$self->{'zd_hash'}->{'retunit'},
				       $self->{'zd_hash'}->{'expiry'}.$self->{'zd_hash'}->{'expunit'},
				       $self->{'zd_hash'}->{'minimum'}.$self->{'zd_hash'}->{'minunit'},
				       1,
				       $self->{'in_hash'}->{'onslave'} && $self->{'access_hash'}->{'remote'},
				       $self->{'in_hash'}->{'tmpl'}, $mips[0]);

		# Create the zone directive
		$dir = { 'name' => 'zone',
			 'values' => [ $dom ],
			 'type' => 1,
			 'members' => [ { 'name' => 'type',
					  'values' => [ 'master' ] },
					{ 'name' => 'file',
					  'values' => [ $file ] } ]
			};
		}
	elsif ($type eq "slave" || $type eq "stub") {
		# Creating a slave or stub zone
		if (!$self->{'access_hash'}->{'slave'}) {
			&line_error($l, $self->{'text_hash'}->{'screate_ecannot1'});
			next;
			}

		# Work out the base
		$self->{'base'} = $self->{'config_hash'}->{'slave_dir'} ? $self->{'config_hash'}->{'slave_dir'} :
			$self->{'access_hash'}->{'dir'} eq '/' ? $self->base_directory($self->{'conf'}) :
						$self->{'access_hash'}->{'dir'};

		# Make sure some master IPs were given
		if (!@mips) {
			&line_error($l, $self->{'text_hash'}->{'mass_emips'});
			next;
			}

		# Work out the filename
		if ($file eq "none") {
			$file = undef;	# no file!
			}
		elsif ($file) {
			if ($file !~ /^\//) {
				$file = $self->{'base'}."/".$file;
				}
			if (!$self->allowed_zone_file(\%{$self->{'access_hash'}}, $file)) {
				&line_error($l, $self->text('create_efile2', $file));
				next;
				}
			}
		else {
			$file = $self->automatic_filename($dom, $isrev, $self->{'base'}, $self->{'vn'});
			}

		# Create the file now
		if ($file) {
			if (!open(ZONE, ">".$self->make_chroot($file))) {
				&line_error($l, $self->text('create_efile3',
						      $file, $!));
				next;
				}
			close(ZONE);
			$self->set_ownership($self->make_chroot($file));
			}

		# Create the structure
		local @mdirs = map { { 'name' => $_ } } @mips;
		local $masters = { 'name' => 'masters',
				   'type' => 1,
				   'members' => \@mdirs };
		$dir = { 'name' => 'zone',
			 'values' => [ $dom ],
			 'type' => 1,
			 'members' => [ { 'name' => 'type',
					  'values' => [ $type ] },
					$masters
				      ]
			};
		if ($file) {
			push(@{$dir->{'members'}},
				{ 'name' => 'file',
				  'values' => [ $file ] });
			}
		}
	elsif ($type eq "forward") {
		# Creating a forward
		if (!$self->{'access_hash'}->{'forward'}) {
			&line_error($l, $self->{'text_hash'}->{'fcreate_ecannot'});
			next;
			}

		# Make sure some master IPs were given
		if (!@mips) {
			&line_error($l, $self->{'text_hash'}->{'mass_emips'});
			next;
			}

		# Create the structure
		local @mdirs = map { { 'name' => $_ } } @mips;
		local $masters = { 'name' => 'forwarders',
				   'type' => 1,
				   'members' => \@mdirs };
		$dir = { 'name' => 'zone',
			 'values' => [ $dom ],
			 'type' => 1,
			 'members' => [ { 'name' => 'type',
					  'values' => [ 'forward' ] },
					$masters
				      ]
			};
		}

	else {
		&line_error($l, $self->{'text_hash'}->{'mass_etype'});
		next;
		}

	if ($dir) {
		# Add the zone structure
		$self->create_zone($dir, $self->{'conf'}, $self->{'in_hash'}->{'view'});
		$self->set_ownership($self->make_chroot($self->{'named_conf'}));
		$self->add_zone_access($dom);
		$self->{'taken_hash'}->{$dom}++;
		&line_ok($dom, $type);
		$self->{'zonecount'}++;
		}

	if ($type eq "master" && $self->{'in_hash'}->{'onslave'} && $self->{'access_hash'}->{'remote'}) {
		# Create on slave servers
		local @slaveerrs = $self->create_on_slaves($dom,
		  $self->{'config_hash'}->{'this_ip'} || $self->to_ipaddress($self->get_system_hostname()));
		print "&nbsp;&nbsp;\n";
		if (@slaveerrs) {
			$self->{'serrs'} = join(", ", map { "$_->[0]->{'host'} : $_->[1]" } @slaveerrs);
			print "<font color=#ff0000>",
			      $self->text('mass_eonslave', $self->{'serrs'}),"</font><br>\n";
			}
		else {
			print $self->text('mass_addedslaves', $dom),"<br>\n";
			}
		}
	}
}

sub line_error
{
	shift if ($self == $_[0]);

print "<font color=#ff0000>",$self->text('mass_eline', $self->{'lnum'}, $_[1], $_[0]),
      "</font><br>\n";
}

sub line_ok
{
	shift if ($self == $_[0]);

print $self->text('mass_added'.$_[1], $_[0]),"<br>\n";
}


1;

