#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Change all instances of some IP 

&ModuleLoader::preload_module('bind8_class', "bind8::Bind8Lib");
$self = new bind8::Bind8Lib:: 'bind8_class',%$self;

$self->ReadParse();
$self->{'conf'} = $self->get_config();

# Get the zones
foreach $d (split(/\0/, $self->{'in_hash'}->{'d'})) {
	($self->{'idx'}, $self->{'viewidx'}) = split(/\s+/, $d);
	$self->{'zone'} = $self->get_zone_name($self->{'idx'}, $self->{'viewidx'});
	$self->{'zone'} || $self->error($self->{'text_hash'}->{'umass_egone'});
	$self->can_edit_zone($self->{'zone'}) ||
		$self->error($self->{'text_hash'}->{'master_edelete'});
	push(@{$self->{'zones_array'}}, $self->{'zone'});
	}
$self->{'access_hash'}->{'ro'} && $self->error($self->{'text_hash'}->{'master_ero'});

# Validate inputs
$self->{'in_hash'}->{'old'} =~ s/\s+/ /g;
$self->{'in_hash'}->{'old'} || $self->error($self->{'text_hash'}->{'umass_eold'});
$self->{'in_hash'}->{'new'} || $self->error($self->{'text_hash'}->{'umass_enew'});
if ($self->{'in_hash'}->{'type'} eq 'A') {
	$self->check_ipaddress($self->{'in_hash'}->{'new'}) ||
		$self->error($self->text('edit_eip', $self->{'in_hash'}->{'new'}));
	}
elsif ($self->{'in_hash'}->{'type'} eq 'AAAA') {
	$self->check_ip6address($self->{'in_hash'}->{'new'}) ||
		$self->error($self->text('edit_eip6', $self->{'in_hash'}->{'new'}));
	}
elsif ($self->{'in_hash'}->{'type'} eq 'NS') {
	&valname($self->{'in_hash'}->{'new'}) ||
		$self->error($self->text('edit_ens', $self->{'in_hash'}->{'new'}));
	}
elsif ($self->{'in_hash'}->{'type'} eq 'CNAME') {
	&valname($self->{'in_hash'}->{'new'}) || $self->{'in_hash'}->{'new'} eq '@' ||
		$self->error($self->text('edit_ecname', $self->{'in_hash'}->{'new'}));
	}
elsif ($self->{'in_hash'}->{'type'} eq 'MX') {
	$self->{'in_hash'}->{'new'} =~ /^(\d+)\s+(\S+)$/ && &valname("$2") ||
		$self->error($self->text('emass_emx', $self->{'in_hash'}->{'new'}));
	}
elsif ($self->{'in_hash'}->{'type'} eq 'TXT') {
	$self->{'in_hash'}->{'new'} = "\"$self->{'in_hash'}->{'new'}\"";
	}
elsif ($self->{'in_hash'}->{'type'} eq 'PTR') {
	&valname($self->{'in_hash'}->{'new'}) ||
		$self->error($self->text('edit_eptr', $self->{'in_hash'}->{'new'}));
	}

# Do each one
$self->ui_print_unbuffered_header(undef, $self->{'text_hash'}->{'umass_title'}, "");

foreach $zi (@{$self->{'zones_array'}}) {
	print $self->text('umass_doing', "<tt>$zi->{'name'}</tt>"),"<br>\n";
	if ($zi->{'type'} ne 'master') {
		# Skip - not a master zone
		print $self->{'text_hash'}->{'umass_notmaster'},"<p>\n";
		next;
		}
	$self->{'rcount'} = 0;
	@{$self->{'recs_array'}} = $self->read_zone_file($zi->{'file'}, $zi->{'name'});
	foreach $r (@{$self->{'recs_array'}}) {
		$self->{'v'} = join(" ", @{$r->{'values'}});
		if ($r->{'type'} eq $self->{'in_hash'}->{'type'} &&
		    $self->{'v'} eq $self->{'in_hash'}->{'old'}) {
			$self->lock_file($self->make_chroot($self->absolute_path($zi->{'file'})));
			$self->modify_record($zi->{'file'}, $r, $r->{'name'},
				       $r->{'ttl'}, $r->{'class'}, $r->{'type'},
				       $self->{'in_hash'}->{'new'}, $r->{'cmt'});
			$self->{'rcount'}++;
			}
		}
	if ($self->{'rcount'}) {
		print $self->text('umass_done', $self->{'rcount'}, scalar(@{$self->{'recs_array'}})),"<p>\n";
		}
	else {
		print $self->text('umass_none', scalar(@{$self->{'recs_array'}})),"<p>\n";
		}
	}

$self->unlock_all_files();
$self->webmin_log("update", "zones", scalar(@{$self->{'zones_array'}}));

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}

# valname(name)
sub valname
{
	shift if ($self == $_[0]);

return $self->valdnsname($_[0], 0, $self->{'in_hash'}->{'origin'});
}


1;

