#!/usr/bin/perl

&MAIN();

 sub MAIN {
# master_form.cgi
# Form for creating a new master zone

&ModuleLoader::preload_module('bind8_class', "bind8::Bind8Lib");
$self = new bind8::Bind8Lib:: 'bind8_class',%$self;

$self->ReadParse();
$self->{'access_hash'}->{'master'} || $self->error($self->{'text_hash'}->{'mcreate_ecannot'});
$self->ui_print_header(undef, $self->{'text_hash'}->{'mcreate_title'}, "");

print $self->ui_form_start("create_master.cgi");
print $self->ui_table_start($self->{'text_hash'}->{'mcreate_opts'}, "width=100%", 4);

# Forward or reverse?
print $self->ui_table_row($self->{'text_hash'}->{'mcreate_type'},
	$self->ui_radio("rev", 0, [ [ 0, $self->{'text_hash'}->{'mcreate_fwd'} ],
			      [ 1, $self->{'text_hash'}->{'mcreate_rev'} ] ]), 3);

# Domain / network name
print $self->ui_table_row($self->{'text_hash'}->{'mcreate_dom'},
	$self->ui_textbox("zone", undef, 40), 3);

$self->{'conf'} = $self->get_config();
@{$self->{'views_array'}} = $self->find("view", $self->{'conf'});
if (@{$self->{'views_array'}}) {
	print $self->ui_table_row($self->{'text_hash'}->{'mcreate_view'},
		$self->ui_select("view", undef,
			[ map ({ [ $_->{'index'}, $_->{'value'} ] }
			      grep { $self->can_edit_view($_) } @{$self->{'views_array'}}) ,
			['', 'in the included file'] ]), 3);
	}

# Records filename
print $self->ui_table_row($self->{'text_hash'}->{'mcreate_file'},
	$self->ui_opt_textbox("file", undef, 30, $self->{'text_hash'}->{'mcreate_auto'})." ".
	$self->file_chooser_button("file"), 3);

# Master server IP
print $self->ui_table_row($self->{'text_hash'}->{'master_server'},
	$self->ui_textbox("master", $self->{'config_hash'}->{'default_prins'} ||
			      $self->get_system_hostname(), 30)."\n".
	$self->ui_checkbox("master_ns", 1, $self->{'text_hash'}->{'master_ns'}, 1), 3);

# Create on slave servers?
#@{$self->{'servers_array'}} = &list_slave_servers();
@{$self->{'servers_array'}} = ();
if (@{$self->{'servers_array'}} && $self->{'access_hash'}->{'remote'}) {
	print $self->ui_table_row($self->{'text_hash'}->{'master_onslave'},
		$self->ui_radio("onslave", 1,
			[ [ 0, $self->{'text_hash'}->{'no'} ],
			  [ 1, $self->{'text_hash'}->{'master_onslaveyes'} ] ])."\n".
		$self->ui_textbox("mip", $self->{'config_hash'}->{'this_ip'} ||
			$self->to_ipaddress($self->get_system_hostname()), 30), 3);

	print $self->ui_table_row($self->{'text_hash'}->{'master_slavefile'},
		$self->ui_radio("sfile_def", 2, 
			[ [ 1, $self->{'text_hash'}->{'slave_none'} ],
			  [ 2, $self->{'text_hash'}->{'slave_auto'} ],
			  [ 0, $self->ui_textbox("sfile", undef, 30) ] ]), 3);
	}

# Master email address
print $self->ui_table_row($self->{'text_hash'}->{'master_email'},
	$self->ui_textbox("email", $self->{'config_hash'}->{'tmpl_email'}, 40), 3);

# Use template?
print $self->ui_table_row($self->{'text_hash'}->{'master_tmpl'},
	$self->ui_yesno_radio("tmpl", $self->{'config_hash'}->{'tmpl_0'} ||
				$self->{'config_hash'}->{'tmpl_include'} ? 1 : 0));

# Template IP
print $self->ui_table_row($self->{'text_hash'}->{'master_ip'},
	$self->ui_textbox("ip", undef, 15));

# Add to reverses?
print $self->ui_table_row($self->{'text_hash'}->{'master_addrev'},
	$self->ui_yesno_radio("addrev", 1), 3);

# SOA options
$self->get_zone_defaults(\%{$self->{'zd_hash'}});
print $self->ui_table_row($self->{'text_hash'}->{'master_refresh'},
	$self->ui_textbox("refresh", $self->{'zd_hash'}->{'refresh'}, 8)." ".
	$self->time_unit_choice("refunit", $self->{'zd_hash'}->{'refunit'}));

print $self->ui_table_row($self->{'text_hash'}->{'master_retry'},
	$self->ui_textbox("retry", $self->{'zd_hash'}->{'retry'}, 8)." ".
	$self->time_unit_choice("retunit", $self->{'zd_hash'}->{'retunit'}));

print $self->ui_table_row($self->{'text_hash'}->{'master_expiry'},
	$self->ui_textbox("expiry", $self->{'zd_hash'}->{'expiry'}, 8)." ".
	$self->time_unit_choice("expunit", $self->{'zd_hash'}->{'expunit'}));

print $self->ui_table_row($self->{'text_hash'}->{'master_minimum'},
	$self->ui_textbox("minimum", $self->{'zd_hash'}->{'minimum'}, 8)." ".
	$self->time_unit_choice("minunit", $self->{'zd_hash'}->{'minunit'}));

print $self->ui_table_end();
print $self->ui_form_end([ [ "create", $self->{'text_hash'}->{'create'} ] ]);

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

