#!/usr/bin/perl

&MAIN();

 sub MAIN {
# conf_controls.cgi
# Display controls options

&ModuleLoader::preload_module('bind8_class', "bind8::Bind8Lib");
$self = new bind8::Bind8Lib:: 'bind8_class',%$self;

$self->{'access_hash'}->{'defaults'} || $self->error($self->{'text_hash'}->{'controls_ecannot'});
$self->ui_print_header(undef, $self->{'text_hash'}->{'controls_title'}, "");

$self->ReadParse();
$self->{'conf'} = $self->get_config();
$self->{'controls'} = $self->find("controls", $self->{'conf'});
$self->{'mems'} = $self->{'controls'}->{'members'};

local ($inet, $unix, $addr, $port, $file, $perms, $owner, $group);
local @addrvals=();

foreach $mem ( @{$self->{'mems'}} ) {
  if ($mem->{'name'} eq "inet") {
    $inet=$mem;
    # Directive reads
    #  INET ( ip_addr | * ) PORT ip_port ALLOW address_match_list
    # the parser will see the address matchlist as a set of members
    # everything else is a value.
    local $v=$inet->{'values'};

    $addr=$v->[0];
    $port=$v->[2];

    foreach $addrmatch (@{$inet->{'members'}}) {
      push @addrvals, $addrmatch->{'name'};
    }
  } elsif ($mem->{'name'} eq "unix") {
    $unix=$mem;
    # Directive reads
    #  UNIX path_name PERM number OWNER number GROUP number;
    local $v=$unix->{'values'};

    $file=$v->[0];
    $perms=$v->[2];
    $owner=$v->[4];
    $group=$v->[6];
  }
}

$self->{'inetdefault'}=defined($inet)?"":" checked";
$self->{'inetset'}=defined($inet)?" checked":"";
$self->{'unixdefault'}=defined($unix)?"":" checked";
$self->{'unixset'}=defined($unix)?" checked":"";

print "<form action=save_controls.cgi>\n";
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'controls_header'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

print "<tr>\n";
print "<td valign=top><b>",
       $self->{'text_hash'}->{'controls_inet'},
      "</b></td>\n";
print "<td nowrap valign=top>\n";
print "<input type=radio name=inet_def value=1$self->{'inetdefault'}> ",
       $self->{'text_hash'}->{'default'},
      "\n";
print "<input type=radio name=inet_def value=0$self->{'inetset'}>\n";
print "<input name=inetaddr size=16 value=$addr></td>\n";
print "<td valign=top>",
       $self->{'text_hash'}->{'controls_port'},
      "</td>\n";
print "<td valign=top>",
      "<input name=inetport size=6 value=$port></td>\n";
print "<td valign=top>",
      $self->{'text_hash'}->{'controls_allow'},
      "</td>\n";
print "<td valign=top>",
      "<textarea name=inetallow rows=4 cols=40 wrap=auto>\n",
       join(" ", @addrvals),
      "</textarea>\n";
print "</td></tr>\n";
print "<tr>\n";
print "<td valign=top><b>",
       $self->{'text_hash'}->{'controls_unix'},
      "</b></td>\n";
print "<td nowrap valign=top>\n";
print "<input type=radio name=unix_def value=1$self->{'unixdefault'}> ",
       $self->{'text_hash'}->{'default'},
      "\n";
print "<input type=radio name=unix_def value=0$self->{'unixset'}>\n";
print "<input name=unixfile size=16 value=$file></td>\n";
print "<td valign=top>",
      $self->{'text_hash'}->{'controls_permissions'},
      "</td>\n";
print "<td valign=top>",
      "<input name=unixperms size=6 value=$perms></td>\n";
print "<td valign=top>",
      $self->{'text_hash'}->{'controls_owner'},
      "</td>\n";
print "<td valign=top>",
      "<input name=unixowner size=8 value=$owner>\n",
      $self->{'text_hash'}->{'controls_group'},
      "<input name=unixgroup size = 8 value=$group>\n";
print "</td></tr>\n";

print "</table></td></tr></table>\n";
print "<input type=submit value=\"$self->{'text_hash'}->{'save'}\"></form>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

