#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_misc.cgi
# Save global miscellaneous options

&ModuleLoader::preload_module('bind8_class', "bind8::Bind8Lib");
$self = new bind8::Bind8Lib:: 'bind8_class',%$self;

$self->{'access_hash'}->{'defaults'} || $self->error($self->{'text_hash'}->{'misc_ecannot'});
$self->error_setup($self->{'text_hash'}->{'controls_err'});
$self->ReadParse();

$self->lock_file($self->make_chroot($self->{'config_hash'}->{'named_conf'}));
$self->{'conf'} = $self->get_config();
local $controls = $self->find("controls", $self->{'conf'});

if ($self->{'in_hash'}->{'inet_def'} && $self->{'in_hash'}->{'unix_def'}) {
  if (defined($controls)) {
    $self->save_directive($self->get_config_parent(), 'controls', [ ], 0);
  }
} else {
  if (!defined($controls)) {
    $controls={ 'name' => 'controls', 'type' => 1 };
    $self->save_directive($self->get_config_parent(), 'controls', [ $controls ], 0);
  }
  if (!$self->{'in_hash'}->{'inet_def'}) {
    local $addr=$self->{'in_hash'}->{'inetaddr'};
    $self->check_ipaddress($addr) || $self->error($self->text('controls_eip', $addr));

    local $port=$self->{'in_hash'}->{'inetport'};
    $port =~ /^\d+$/ || $self->error($self->{'text_hash'}->{'controls_eport'});
    local @allows=();
    foreach $allow (split(/\s+/, $self->{'in_hash'}->{'inetallow'})) {
      # Need to check acl is OK!
      push(@allows, { 'name' => $allow });
    }

    local $inetdir = { 'name' => 'inet', 'type' => 1,
		    'values' => [ $addr,
				  'port', $port,
				  'allow' ],
		    'members' => \@allows };

    $self->save_directive($controls, "inet", [ $inetdir ], 1);
  } else {
    $self->save_directive($controls, "inet", [ ], 1);
  }

  if (!$self->{'in_hash'}->{'unix_def'}) {
    local $file=$self->{'in_hash'}->{'unixfile'};
    local $perms=$self->{'in_hash'}->{'unixperms'};
    local $owner=$self->{'in_hash'}->{'unixowner'};
    local $group=$self->{'in_hash'}->{'unixgroup'};
    $file =~ /^\S+$/ || $self->error($self->{'text_hash'}->{'controls_efile'});
    $perms =~ /^\d+$/ || $self->error($self->{'text_hash'}->{'controls_eperms'});
    $owner =~ /^\d+$/ || $self->error($self->{'text_hash'}->{'controls_eowner'});
    $group =~ /^\d+$/ || $self->error($self->{'text_hash'}->{'controls_egroup'});

    local $unixdir = { 'name' => 'unix', 'type' => 0,
		    'values' => [ "\"$file\"",
				  'perm', $perms,
				  'owner', $owner,
				  'group', $group ] };

    $self->save_directive($controls, "unix", [ $unixdir ], 1);
  } else {
    $self->save_directive($controls, "unix", [ ], 1);
  }
}

$self->flush_file_lines();
$self->unlock_file($self->make_chroot($self->{'config_hash'}->{'named_conf'}));
$self->webmin_log("controls", undef, undef, \%{$self->{'in_hash'}});
$self->redirect("");

1;
		
}


1;

