#!/usr/bin/perl

&MAIN();

 sub MAIN {
# restart_zone.cgi
# Apply changes to one zone only using the ndc command

&ModuleLoader::preload_module('bind8_class', "bind8::Bind8Lib");
$self = new bind8::Bind8Lib:: 'bind8_class',%$self;

$self->ReadParse();
$self->{'access_hash'}->{'ro'} && $self->error($self->{'text_hash'}->{'restart_ecannot'});
$self->{'access_hash'}->{'apply'} || $self->error($self->{'text_hash'}->{'restart_ecannot'});
$self->{'zone'} = $self->get_zone_name($self->{'in_hash'}->{'index'}, $self->{'in_hash'}->{'view'});
if ($self->{'zone'}->{'view'}) {
	# Reload a zone in a view
	$self->{'dom'} = $self->{'zone'}->{'name'};
	$self->can_edit_zone($self->{'zone'}) || $self->error($self->{'text_hash'}->{'restart_ecannot'});
	$self->{'out'} = &try_cmd("reload '$self->{'dom'}' IN '$self->{'zone'}->{'view'}'");
	}
else {
	# Just reload one top-level zone
	$self->{'dom'} = $self->{'zone'}->{'name'};
	$self->can_edit_zone($self->{'zone'}) || $self->error($self->{'text_hash'}->{'restart_ecannot'});
	$self->{'out'} = &try_cmd("reload '$self->{'dom'}' 2>&1 </dev/null");
	}
if ($self->{'out'} =~ /not found/i) {
	# Zone is not known to BIND yet - do a total reload
	$self->{'err'} = $self->restart_bind();
	$self->error($self->{'err'}) if ($self->{'err'});
	if ($self->{'access_hash'}->{'remote'}) {
		# Restart all slaves too
		$self->error_setup();
		@{$self->{'slaveerrs_array'}} = $self->restart_on_slaves();
		if (@{$self->{'slaveerrs_array'}}) {
			$self->error($self->text('restart_errslave',
			     "<p>".join("<br>",
					map { "$_->[0]->{'host'} : $_->[1]" }
					    @{$self->{'slaveerrs_array'}})));
			}
		}
	}
elsif ($? || $self->{'out'} =~ /failed|not found|error/i) {
	$self->error($self->text('restart_endc', "<tt>$self->{'out'}</tt>"));
	}
$self->webmin_log("apply", $self->{'dom'});

$self->{'tv'} = $self->{'zone'}->{'type'};
$self->redirect(($self->{'tv'} eq "master" ? "edit_master.cgi" :
	  $self->{'tv'} eq "forward" ? "edit_forward.cgi" : "edit_slave.cgi").
	  "?index=$self->{'in_hash'}->{'index'}&view=$self->{'in_hash'}->{'view'}");

1;
		
}

# try_cmd(args, [rndc-args])
sub try_cmd
{
	shift if ($self == $_[0]);

local $args = $_[0];
local $rndc_args = $_[1] || $_[0];
local $out;
if ($self->has_ndc() == 2) {
	# Try with rndc
	$out = $self->backquote_logged("$self->{'config_hash'}->{'rndc_cmd'} $rndc_args 2>&1 </dev/null");
	}
if ($self->has_ndc() != 2 || $out =~ /connect\s+failed/i) {
	if ($self->has_ndc(2)) {
		# Try with rndc if rndc is not install or failed
		$out = $self->backquote_logged("$self->{'config_hash'}->{'ndc_cmd'} $args 2>&1 </dev/null");
		}
	}
return $out;
}


1;

