#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Save control interface options

&ModuleLoader::preload_module('bind8_class', "bind8::Bind8Lib");
$self = new bind8::Bind8Lib:: 'bind8_class',%$self;

$self->{'access_hash'}->{'defaults'} || $self->error($self->{'text_hash'}->{'controls_ecannot'});
$self->error_setup($self->{'text_hash'}->{'controls_err'});
$self->ReadParse();

# Validate and store inputs
$self->lock_file($self->make_chroot($self->{'config_hash'}->{'named_conf'}));
$self->{'parent'} = $self->get_config_parent();
$self->{'conf'} = $self->get_config();
$self->{'controls'} = $self->find("controls", $self->{'conf'});
if (!$self->{'controls'}) {
	$self->{'controls'} = { 'name' => 'controls', 'type' => 1 };
	$self->save_directive($self->{'parent'}, "controls", [ $self->{'controls'} ]);
	}
$self->{'inet'} = $self->find("inet", $self->{'controls'}->{'members'});
$self->{'unix'} = $self->find("unix", $self->{'controls'}->{'members'});

# Save inet control options
if ($self->{'in_hash'}->{'inet'}) {
	$self->{'inet'} ||= { 'name' => 'inet', 'type' => 2 };
	$self->check_ipaddress($self->{'in_hash'}->{'ip'}) || $self->error($self->{'text_hash'}->{'controls_einetip'});
	$self->{'in_hash'}->{'port'} =~ /^\d+$/ && $self->{'in_hash'}->{'port'} > 0 && $self->{'in_hash'}->{'port'} < 65536 ||
		$self->error($self->{'text_hash'}->{'controls_einetport'});
	$self->{'inet'}->{'values'} = [ $self->{'in_hash'}->{'ip'}, "port", $self->{'in_hash'}->{'port'} ];
	@{$self->{'allow_array'}} = split(/\s+/, $self->{'in_hash'}->{'allow'});
	foreach $a (@{$self->{'allow_array'}}) {
		$self->check_ipaddress($a) ||
			$self->error($self->text('controls_einetallow', $a));
		}
	@{$self->{'allow_array'}} || $self->error($self->{'text_hash'}->{'controls_einetallows'});
	$self->{'inet'}->{'members'}->{'allow'} =
		[ map { { 'name' => $_ } } @{$self->{'allow_array'}} ];
	@{$self->{'keys_array'}} = split(/\s+/, $self->{'in_hash'}->{'keys'});
	if (@{$self->{'keys_array'}}) {
		$self->{'inet'}->{'members'}->{'keys'} = 
			[ map { { 'name' => $_ } } @{$self->{'keys_array'}} ];
		}
	else {
		delete($self->{'inet'}->{'members'}->{'keys'});
		}
	$self->save_directive($self->{'controls'}, "inet", [ $self->{'inet'} ], 1);
	}
else {
	$self->save_directive($self->{'controls'}, "inet", [ ], 1);
	}

# Save local control options
if ($self->{'in_hash'}->{'unix'}) {
	$self->{'unix'} ||= { 'name' => 'unix', 'type' => 0 };
	$self->{'in_hash'}->{'path'} =~ /^\/\S+$/ || $self->error($self->{'text_hash'}->{'controls_eunixpath'});
	$self->{'in_hash'}->{'perm'} =~ /^[0-7]{3,4}$/ || $self->error($self->{'text_hash'}->{'controls_eunixperm'});
	$self->{'owner'} = getpwnam($self->{'in_hash'}->{'owner'});
	defined($self->{'owner'}) || $self->error($self->{'text_hash'}->{'controls_eunixowner'});
	$self->{'group'} = getgrnam($self->{'in_hash'}->{'group'});
	defined($self->{'group'}) || $self->error($self->{'text_hash'}->{'controls_eunixgroup'});
	$self->{'unix'}->{'values'} = [ $self->{'in_hash'}->{'path'}, "perm", $self->{'in_hash'}->{'perm'},
			      "owner", $self->{'owner'}, "group", $self->{'group'} ];
	$self->save_directive($self->{'controls'}, "unix", [ $self->{'unix'} ], 1);
	}
else {
	$self->save_directive($self->{'controls'}, "unix", [ ], 1);
	}

$self->flush_file_lines();
$self->unlock_file($self->make_chroot($self->{'config_hash'}->{'named_conf'}));
$self->webmin_log("controls", undef, undef, \%{$self->{'in_hash'}});
$self->redirect("");

1;
		
}


1;

