#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_gen.cgi
# Save $generate records

&ModuleLoader::preload_module('bind8_class', "bind8::Bind8Lib");
$self = new bind8::Bind8Lib:: 'bind8_class',%$self;

$self->ReadParse();
$self->{'access_hash'}->{'gen'} || $self->error($self->{'text_hash'}->{'gen_ecannot'});
$self->{'zone'} = $self->get_zone_name($self->{'in_hash'}->{'index'}, $self->{'in_hash'}->{'view'});
$self->{'dom'} = $self->{'zone'}->{'name'};
$self->can_edit_zone($self->{'zone'}) ||
	$self->error($self->{'text_hash'}->{'recs_ecannot'});
$self->{'file'} = $self->{'zone'}->{'file'};
@{$self->{'recs_array'}} = $self->read_zone_file($self->{'file'}, $self->{'dom'});
@{$self->{'gens_array'}} = grep { $_->{'generate'} } @{$self->{'recs_array'}};

if ($self->{'in_hash'}->{'show'}) {
	# Just show what would be generated
	$self->{'desc'} = $self->text('recs_header', $self->ip6int_to_net($self->arpa_to_ip($self->{'dom'})));
	$self->ui_print_header($self->{'desc'}, $self->{'text_hash'}->{'gen_title2'}, "");

	print "<table border width=100%>\n";
	print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'recs_name'}</b></td> ",
	      "<td><b>$self->{'text_hash'}->{'recs_type'}</b></td> ",
	      "<td><b>$self->{'text_hash'}->{'recs_ttl'}</b></td> ",
	      "<td><b>$self->{'text_hash'}->{'recs_vals'}</b></td> ",
	      "<td><b>$self->{'text_hash'}->{'gen_raw'}</b></td> </tr>\n";
	foreach $g (@{$self->{'gens_array'}}) {
		@gv = @{$g->{'generate'}};
		if ($gv[0] =~ /^(\d+)-(\d+)\/(\d+)$/) {
			$self->{'start'} = $1; $self->{'end'} = $2; $self->{'skip'} = $3;
			}
		elsif ($gv[0] =~ /^(\d+)-(\d+)$/) {
			$self->{'start'} = $1; $self->{'end'} = $2; $self->{'skip'} = 1;
			}
		else { next; }
		for($i=$self->{'start'}; $i<=$self->{'end'}; $i+=$self->{'skip'}) {
			$self->{'lhs'} = $gv[1];
			$self->{'lhs'} =~ s/\$\$/\0/g;
			$self->{'lhs'} =~ s/\$/$i/g;
			$self->{'lhs'} =~ s/\0/\$/g;
			$self->{'lhsfull'} = $self->{'lhs'} =~ /\.$/ ? $self->{'lhs'} :
				    $self->{'dom'} eq "." ? "$self->{'lhs'}." : "$self->{'lhs'}.$self->{'dom'}";

			$self->{'rhs'} = $gv[3];
			$self->{'rhs'} =~ s/\$\$/\0/g;
			$self->{'rhs'} =~ s/\$/$i/g;
			$self->{'rhs'} =~ s/\0/\$/g;
			$self->{'rhsfull'} = $self->{'rhs'} =~ /\.$/ ? $self->{'rhs'} :
				    $self->{'dom'} eq "." ? "$self->{'rhs'}." : "$self->{'rhs'}.$self->{'dom'}";

			print "<tr $self->{'cb'}>\n";
			print "<td>",$self->arpa_to_ip($self->{'lhsfull'}),"</td>\n";
			print "<td>$gv[2]</td>\n";
			print "<td>$self->{'text_hash'}->{'default'}</td>\n";
			print "<td>",$self->arpa_to_ip($self->{'rhsfull'}),"</td>\n";
			print "<td><tt>$self->{'lhs'} IN $gv[2] $self->{'rhs'}</tt></td>\n";
			print "</tr>\n";
			}
		}
	print "</table><br>\n";

	$self->ui_print_footer("edit_master.cgi?index=$self->{'in_hash'}->{'index'}&view=$self->{'in_hash'}->{'view'}",
		$self->{'text_hash'}->{'master_return'});
	exit;
	}

# Parse and validate inputs
$self->error_setup($self->{'text_hash'}->{'gen_err'});
for($i=0; defined($self->{'in_hash'}->{"type_$i"}); $i++) {
	if ($self->{'in_hash'}->{"type_$i"}) {
		local @gv;
		$self->{'in_hash'}->{"start_$i"} =~ /^\d+$/ ||
			$self->error($self->text('gen_estart', $i+1));
		$self->{'in_hash'}->{"stop_$i"} =~ /^\d+$/ ||
			$self->error($self->text('gen_estop', $i+1));
		$self->{'in_hash'}->{"start_$i"} <= $self->{'in_hash'}->{"stop_$i"} ||
			$self->error($self->text('gen_erange', $i+1));
		$self->{'in_hash'}->{"skip_$i"} =~ /^\d*$/ ||
			$self->error($self->text('gen_eskip', $i+1));
		push(@gv, $self->{'in_hash'}->{"start_$i"}."-".$self->{'in_hash'}->{"stop_$i"});
		if ($self->{'in_hash'}->{"skip_$i"}) {
			$gv[$#gv] .= "/".$self->{'in_hash'}->{"skip_$i"};
			}
		$self->{'in_hash'}->{"name_$i"} =~ /^[A-Za-z0-9\.\-$self->{'uscore'}$self->{'star'}\$]+$/ ||
			$self->error($self->text('gen_ename', $i+1));
		push(@gv, $self->{'in_hash'}->{"name_$i"});
		push(@gv, $self->{'in_hash'}->{"type_$i"});
		$self->{'in_hash'}->{"value_$i"} =~ /^[A-Za-z0-9\.\-$self->{'uscore'}$self->{'star'}\$]+$/ ||
			$self->error($self->text('gen_evalue', $i+1));
		push(@gv, $self->{'in_hash'}->{"value_$i"});
		push(@gv, $self->{'in_hash'}->{"cmt_$i"}) if ($self->{'in_hash'}->{"cmt_$i"});
		if ($i < @{$self->{'gens_array'}}) {
			$self->modify_generator($self->{'gens_array'}->[$i]->{'file'}, $self->{'gens_array'}->[$i], @gv);
			}
		else {
			$self->create_generator($self->{'file'}, @gv);
			}
		}
	else {
		if ($i < @{$self->{'gens_array'}}) {
			$self->delete_generator($self->{'gens_array'}->[$i]->{'file'}, $self->{'gens_array'}->[$i]);
			foreach $g (@{$self->{'gens_array'}}) {
				if ($g->{'line'} > $self->{'gens_array'}->[$i]->{'line'}) {
					$g->{'line'}--;
					}
				}
			}
		}
	}
$self->bump_soa_record($self->{'file'}, \@{$self->{'recs_array'}});
$self->redirect("edit_master.cgi?index=$self->{'in_hash'}->{'index'}&view=$self->{'in_hash'}->{'view'}");

1;
		
}


1;

