#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_logging.cgi
# Save global logging options

&ModuleLoader::preload_module('bind8_class', "bind8::Bind8Lib");
$self = new bind8::Bind8Lib:: 'bind8_class',%$self;

$self->{'access_hash'}->{'defaults'} || $self->error($self->{'text_hash'}->{'logging_ecannot'});
$self->error_setup($self->{'text_hash'}->{'files_err'});
$self->ReadParse();

$self->lock_file($self->make_chroot($self->{'config_hash'}->{'named_conf'}));
$self->{'conf'} = $self->get_config();
$self->{'logging'} = $self->find("logging", $self->{'conf'});

# save categories
for($i=0; defined($self->{'cat'} = $self->{'in_hash'}->{"cat_$i"}); $i++) {
	next if (!$self->{'cat'});
	@{$self->{'cchan_array'}} = split(/\0/, $self->{'in_hash'}->{"cchan_$i"});
	push(@{$self->{'category_array'}}, { 'name' => 'category',
			  'values' => [ $self->{'cat'} ],
			  'type' => 1,
			  'members' =>
				[ map { { 'name' => $_ } } @{$self->{'cchan_array'}} ] });
	}

# save channels
for($i=0; defined($self->{'cname'} = $self->{'in_hash'}->{"cname_$i"}); $i++) {
	next if (!$self->{'cname'});
	$self->{'cname'} =~ /^\S+$/ || $self->error($self->text('logging_ename', $self->{'cname'}));
	local @mems;
	if ($self->{'in_hash'}->{"to_$i"} == 0) {
		$self->{'in_hash'}->{"file_$i"} || $self->error($self->{'text_hash'}->{'logging_efile'});
		local @fvals = ( $self->{'in_hash'}->{"file_$i"} );
		if ($self->{'in_hash'}->{"vmode_$i"} == 1) {
			push(@fvals, 'versions', 'unlimited');
			}
		elsif ($self->{'in_hash'}->{"vmode_$i"} == 2) {
			$self->{'in_hash'}->{"ver_$i"} =~ /^\d+$/ ||
				$self->error($self->text('logging_ever', $self->{'in_hash'}->{"ver_$i"}));
			push(@fvals, 'versions', $self->{'in_hash'}->{"ver_$i"});
			}
		if ($self->{'in_hash'}->{"smode_$i"}) {
			$self->{'in_hash'}->{"size_$i"} =~ /^\d+[kmg]*$/i ||
				$self->error($self->text('logging_esize', $self->{'in_hash'}->{"size_$i"}));
			push(@fvals, 'size', $self->{'in_hash'}->{"size_$i"});
			}
		push(@mems, { 'name' => 'file',
			      'values' => \@fvals });
		}
	elsif ($self->{'in_hash'}->{"to_$i"} == 1) {
		push(@mems, { 'name' => 'syslog',
			      'values' => [ $self->{'in_hash'}->{"syslog_$i"} ] });
		}
	else {
		push(@mems, { 'name' => 'null' });
		}
	if ($self->{'in_hash'}->{"sev_$i"} eq 'debug') {
		push(@mems, { 'name' => 'severity',
			      'values' => [ 'debug', $self->{'in_hash'}->{"debug_$i"} ] });
		}
	elsif ($self->{'in_hash'}->{"sev_$i"}) {
		push(@mems, { 'name' => 'severity',
			      'values' => [ $self->{'in_hash'}->{"sev_$i"} ] });
		}
	foreach $p ('print-category', 'print-severity', 'print-time') {
		push(@mems, { 'name' => $p,
			      'values' => [ $self->{'in_hash'}->{"$p-$i"} ] }) if ($self->{'in_hash'}->{"$p-$i"});
		}
	push(@{$self->{'channel_array'}}, { 'name' => 'channel',
			 'values' => [ $self->{'cname'} ],
			 'type' => 1,
			 'members' => \@mems } );
	}

if ($self->{'logging'}) {
	$self->save_directive($self->{'logging'}, 'channel', \@{$self->{'channel_array'}}, 1);
	$self->save_directive($self->{'logging'}, 'category', [ ], 1);
	$self->save_directive($self->{'logging'}, 'category', [ reverse(@{$self->{'category_array'}}) ], 1);
	}
else {
	$self->{'logging'} = { 'name' => 'logging',
		     'type' => 1,
		     'members' => [ @{$self->{'channel_array'}}, @{$self->{'category_array'}} ] };
	$self->save_directive($self->get_config_parent(), 'logging', [ $self->{'logging'} ], 0);
	}
$self->flush_file_lines();
$self->unlock_file($self->make_chroot($self->{'config_hash'}->{'named_conf'}));
$self->webmin_log("logging", undef, undef, \%{$self->{'in_hash'}});
$self->redirect("");

1;
		
}


1;

