#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_misc.cgi
# Save global miscellaneous options

&ModuleLoader::preload_module('bind8_class', "bind8::Bind8Lib");
$self = new bind8::Bind8Lib:: 'bind8_class',%$self;

$self->{'access_hash'}->{'defaults'} || $self->error($self->{'text_hash'}->{'misc_ecannot'});
$self->error_setup($self->{'text_hash'}->{'misc_err'});
$self->ReadParse();

$self->lock_file($self->make_chroot($self->{'config_hash'}->{'named_conf'}));
$self->{'conf'} = $self->get_config();
$self->{'options'} = $self->find("options", $self->{'conf'});
$self->save_opt("coresize", \&size_check, $self->{'options'}, 1);
$self->save_opt("datasize", \&size_check, $self->{'options'}, 1);
$self->save_opt("files", \&files_check, $self->{'options'}, 1);
$self->save_opt("stacksize", \&size_check, $self->{'options'}, 1);
$self->save_opt("cleaning-interval", \&mins_check, $self->{'options'}, 1);
$self->save_opt("interface-interval", \&mins_check, $self->{'options'}, 1);
$self->save_opt("statistics-interval", \&mins_check, $self->{'options'}, 1);
$self->save_choice("recursion", $self->{'options'}, 1);
$self->save_choice("multiple-cnames", $self->{'options'}, 1);
$self->save_choice("fetch-glue", $self->{'options'}, 1);
$self->save_choice("auth-nxdomain", $self->{'options'}, 1);

$self->flush_file_lines();
$self->unlock_file($self->make_chroot($self->{'config_hash'}->{'named_conf'}));
$self->webmin_log("misc", undef, undef, \%{$self->{'in_hash'}});
$self->redirect("");

1;
		
}

sub size_check
{
	shift if ($self == $_[0]);

return $_[0] =~ /^\d+[kmg]*$/i ? "" : $self->{'text_hash'}->{'misc_esize'};
}

sub files_check
{
	shift if ($self == $_[0]);

return $_[0] =~ /^\d+$/i ? "" : $self->{'text_hash'}->{'misc_efiles'};
}

sub mins_check
{
	shift if ($self == $_[0]);

return $_[0] =~ /^\d+$/i ? "" : $self->{'text_hash'}->{'misc_emins'};
}


1;

