#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_net.cgi
# Save global address and topology options

&ModuleLoader::preload_module('bind8_class', "bind8::Bind8Lib");
$self = new bind8::Bind8Lib:: 'bind8_class',%$self;

$self->{'access_hash'}->{'defaults'} || $self->error($self->{'text_hash'}->{'net_ecannot'});
$self->error_setup($self->{'text_hash'}->{'net_err'});
$self->ReadParse();

$self->lock_file($self->make_chroot($self->{'config_hash'}->{'named_conf'}));
$self->{'conf'} = $self->get_config();
$self->{'options'} = $self->find("options", $self->{'conf'});
if (!$self->{'in_hash'}->{'listen_def'}) {
	for($i=0; defined($self->{'addr'} = $self->{'in_hash'}->{"addrs_$i"}); $i++) {
		next if (!$self->{'addr'});
		local $l = { 'name' => 'listen-on',
			     'type' => 1 };
		if (!$self->{'in_hash'}->{"pdef_$i"}) {
			$self->{'in_hash'}->{"port_$i"} =~ /^\d+$/ ||
				$self->error($self->text('net_eport', $self->{'in_hash'}->{"port_$i"}));
			$l->{'values'} = [ 'port', $self->{'in_hash'}->{"port_$i"} ];
			}
		$l->{'members'} =
			[ map { { 'name' => $_ } } split(/\s+/, $self->{'addr'}) ];
		push(@{$self->{'listen_array'}}, $l);
		}
	}
$self->save_directive($self->{'options'}, 'listen-on', \@{$self->{'listen_array'}}, 1);
if (!$self->{'in_hash'}->{'saddr_def'}) {
	$self->check_ipaddress($self->{'in_hash'}->{'saddr'}) ||
		$self->error($self->text('net_eaddr', $self->{'in_hash'}->{'saddr'}));
	push(@{$self->{'qvals_array'}}, "address", $self->{'in_hash'}->{'saddr'});
	}
if (!$self->{'in_hash'}->{'sport_def'}) {
	$self->{'in_hash'}->{'sport'} =~ /^\d+$/ || $self->error($self->text('net_eport', $self->{'in_hash'}->{'sport'}));
	push(@{$self->{'qvals_array'}}, "port", $self->{'in_hash'}->{'sport'});
	}
if (@{$self->{'qvals_array'}}) {
	$self->save_directive($self->{'options'}, 'query-source',
			[ { 'name' => 'query-source',
			    'values' => \@{$self->{'qvals_array'}} } ], 1);
	}
else {
	$self->save_directive($self->{'options'}, 'query-source', [ ], 1);
	}
$self->{'in_hash'}->{'topology_def'} || $self->{'in_hash'}->{'topology'} || $self->error($self->{'text_hash'}->{'net_etopology'});
$self->save_addr_match('topology', $self->{'options'}, 1);
$self->{'in_hash'}->{'allow-recursion_def'} || $self->{'in_hash'}->{'allow-recursion'} ||
	$self->error($self->{'text_hash'}->{'net_erecur'});
$self->save_addr_match('allow-recursion', $self->{'options'}, 1);

$self->flush_file_lines();
$self->unlock_file($self->make_chroot($self->{'config_hash'}->{'named_conf'}));
$self->webmin_log("net", undef, undef, \%{$self->{'in_hash'}});
$self->redirect("");
1;
		
}


1;

