#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_record.cgi
# Adds or updates a record of some type

&ModuleLoader::preload_module('bind8_class', "bind8::Bind8Lib");
$self = new bind8::Bind8Lib:: 'bind8_class',%$self;

$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'edit_err'});
$self->{'zone'} = $self->get_zone_name($self->{'in_hash'}->{'index'}, $self->{'in_hash'}->{'view'});
$self->{'dom'} = $self->{'zone'}->{'name'};
@{$self->{'zl_array'}} = $self->list_zone_names();
$self->{'reverse'} = ($self->{'in_hash'}->{'origin'} =~ /\.in-addr\.arpa/i ||
	    $self->{'in_hash'}->{'origin'} =~ /\.$self->{'ipv6revzone'}/i);
$self->can_edit_zone($self->{'zone'}) || $self->error($self->{'text_hash'}->{'recs_ecannot'});
$self->can_edit_type($self->{'in_hash'}->{'type'}) ||
	$self->error($self->{'text_hash'}->{'recs_ecannottype'});
$self->{'access_hash'}->{'ro'} && $self->error($self->{'text_hash'}->{'master_ero'});
$self->lock_file($self->make_chroot($self->absolute_path($self->{'zone'}->{'file'})));

# Read the existing records
if ($self->{'config_hash'}->{'largezones'} && !defined($self->{'in_hash'}->{'num'})) {
	# Adding to a large zone, so only read the SOA
	@{$self->{'recs_array'}} = $self->read_zone_file($self->{'in_hash'}->{'file'}, $self->{'in_hash'}->{'origin'}, undef, 1);
	}
else {
	# Read all records
	@{$self->{'recs_array'}} = $self->read_zone_file($self->{'in_hash'}->{'file'}, $self->{'in_hash'}->{'origin'});
	}

# get the old record if needed
$self->{'r'} = $self->{'recs_array'}->[$self->{'in_hash'}->{'num'}] if (defined($self->{'in_hash'}->{'num'}));

# check for deletion
if ($self->{'in_hash'}->{'delete'}) {
	# Check if confirmation is needed
	if (!$self->{'in_hash'}->{'confirm'} && $self->{'config_hash'}->{'confirm_rec'}) {
		$self->ui_print_header(undef, $self->{'text_hash'}->{'edit_dtitle'}, "");
		print "<form action=save_record.cgi>\n";
		foreach $i (keys %{$self->{'in_hash'}}) {
			print "<input type=hidden name=$i value='",
				$self->html_escape($self->{'in_hash'}->{$i}),"'>\n";
			}
		print "<center>\n";
		print $self->text('edit_rusure', "<tt>$self->{'r'}->{'name'}</tt>",
					   "<tt>$self->{'in_hash'}->{'origin'}</tt>"),"<p>\n";
		print "<input type=submit name=confirm ",
		      "value='$self->{'text_hash'}->{'edit_dok'}'>\n";
		print "</center>\n";
                if ($self->{'in_hash'}->{'dom'}) {
                    $self->ui_print_footer($self->{'text_hash'}->{'index_mainpage_url'},$self->{'text_hash'}->{'index_mainpage'}, "edit_recs.cgi?type=ALL&view=&dom=$self->{'in_hash'}->{'dom'}", $self->{'text_hash'}->{'label_dns'});
                    } else {
                        $self->ui_print_footer("", $self->{'text_hash'}->{'index_return'}, "edit_recs.cgi?index=$self->{'in_hash'}->{'index'}&view=$self->{'in_hash'}->{'view'}&type=$self->{'in_hash'}->{'redirtype'}&sort=$self->{'in_hash'}->{'sort'}", $self->{'text_hash'}->{'recs_return'});
			}	
		}
	else {
		# Delete the record
		$self->lock_file($self->make_chroot($self->{'r'}->{'file'}));
		$self->delete_record($self->{'r'}->{'file'}, $self->{'r'});
		$self->bump_soa_record($self->{'in_hash'}->{'file'}, \@{$self->{'recs_array'}});

		# Update reverse
		$self->{'fulloldvalue0'} = $self->convert_to_absolute(
					$self->{'in_hash'}->{'oldvalue0'}, $self->{'in_hash'}->{'origin'});
		$self->{'fulloldname'} = $self->convert_to_absolute(
					$self->{'in_hash'}->{'oldname'}, $self->{'in_hash'}->{'origin'});
		($self->{'orevconf'}, $self->{'orevfile'}, $self->{'orevrec'}) = $self->find_reverse($self->{'in_hash'}->{'oldvalue0'},
								 $self->{'in_hash'}->{'view'});
		if ($self->{'in_hash'}->{'rev'} && $self->{'orevrec'} && $self->can_edit_reverse($self->{'orevconf'}) &&
		    $self->{'fulloldname'} eq $self->{'orevrec'}->{'values'}->[0] &&
		    ($self->{'in_hash'}->{'type'} eq "A" &&
		     $self->{'in_hash'}->{'oldvalue0'} eq $self->arpa_to_ip($self->{'orevrec'}->{'name'}) ||
		     $self->{'in_hash'}->{'type'} eq "AAAA" &&
		     $self->expandall_ip6($self->{'in_hash'}->{'oldvalue0'}) eq $self->expandall_ip6($self->ip6int_to_net($self->{'orevrec'}->{'name'})))) {
			$self->lock_file($self->make_chroot($self->{'orevrec'}->{'file'}));
			$self->delete_record($self->{'orevrec'}->{'file'} , $self->{'orevrec'});
			$self->lock_file($self->make_chroot($self->{'orevfile'}));
			@{$self->{'orrecs_array'}} = $self->read_zone_file($self->{'orevfile'}, $self->{'orevconf'}->{'name'});
			$self->bump_soa_record($self->{'orevfile'}, \@{$self->{'orrecs_array'}});
			}

		# Update forward
		local($ipv6 = ($self->{'fulloldvalue0'} =~ /\.$self->{'ipv6revzone'}/i));
		($self->{'ofwdconf'}, $self->{'ofwdfile'}, $self->{'ofwdrec'}) = $self->find_forward($self->{'fulloldvalue0'}, $ipv6);
		if ($self->{'in_hash'}->{'fwd'} && $self->{'ofwdrec'} && $self->can_edit_zone($self->{'ofwdconf'}) &&
		    (!$ipv6 && $self->arpa_to_ip($self->{'in_hash'}->{'oldname'}) eq $self->{'ofwdrec'}->{'values'}->[0] ||
		     $ipv6 && $self->expandall_ip6($self->ip6int_to_net($self->{'in_hash'}->{'oldname'})) eq $self->expandall_ip6($self->{'ofwdrec'}->{'values'}->[0])) &&
		    $self->{'fulloldvalue0'} eq $self->{'ofwdrec'}->{'name'}) {
			$self->lock_file($self->make_chroot($self->{'ofwdrec'}->{'file'}));
			$self->delete_record($self->{'ofwdrec'}->{'file'}, $self->{'ofwdrec'});
			$self->lock_file($self->make_chroot($self->{'ofwdfile'}));
			@{$self->{'ofrecs_array'}} = $self->read_zone_file($self->{'ofwdfile'}, $self->{'ofwdconf'}->{'name'});
			$self->bump_soa_record($self->{'ofwdfile'}, \@{$self->{'ofrecs_array'}});
			}

                if ($self->{'in_hash'}->{'dom'}) {
                    $self->redirect("edit_recs.cgi?dom=$self->{'in_hash'}->{'dom'}&view=$self->{'in_hash'}->{'view'}&type=ALL");
                    } else {
                            $self->redirect("edit_recs.cgi?index=$self->{'in_hash'}->{'index'}&view=$self->{'in_hash'}->{'view'}&type=$self->{'in_hash'}->{'redirtype'}&sort=$self->{'in_hash'}->{'sort'}");
                            }
		$self->unlock_all_files();
		$self->webmin_log('delete', 'record', $self->{'in_hash'}->{'origin'}, $self->{'r'});
		}
	exit;
	}

# parse inputs
if (!$self->{'in_hash'}->{'ttl_def'}) {
	$self->{'in_hash'}->{'ttl'} =~ /^\d+$/ ||
		$self->error($self->text('edit_ettl', $self->{'in_hash'}->{'ttl'}));
	$self->{'ttl'} = $self->{'in_hash'}->{'ttl'}.$self->{'in_hash'}->{'ttlunit'};
	}
$vals = $self->{'in_hash'}->{'value0'};
for($i=1; defined($self->{'in_hash'}->{"value$i"}); $i++) {
	$vals .= " ".$self->{'in_hash'}->{"value$i"};
	}
$vals =~ s/^\s+//;
$vals =~ s/\s+$//;
if ($self->{'in_hash'}->{'type'} eq "PTR" && $self->{'reverse'}) {
	# a reverse address
	local($ipv4);
	($ipv4 = $self->{'in_hash'}->{'origin'} =~ /in-addr\.arpa/i) ||
	    $self->{'in_hash'}->{'origin'} =~ /\.$self->{'ipv6revzone'}/i ||
		$self->error($self->text('edit_eip', $self->{'in_hash'}->{'name'}));
	if ($ipv4) {
		if ($self->{'in_hash'}->{'name'} =~ /^\d+$/) {
			$self->{'in_hash'}->{'name'} = $self->arpa_to_ip($self->{'in_hash'}->{'origin'}).".".$self->{'in_hash'}->{'name'};
			}
		$self->check_ipaddress($self->{'in_hash'}->{'name'}) ||
		    ($self->{'in_hash'}->{'name'} =~ /^(.*)\.(\d+)$/ && $self->check_ipaddress("$1")) ||
		    ($self->{'in_hash'}->{'name'} =~ /^(.*)\.(\d+)$/ && $1 eq $self->arpa_to_ip($self->{'in_hash'}->{'origin'})) ||
			$self->error($self->text('edit_eip', $self->{'in_hash'}->{'name'}));
		$self->{'name'} = $self->ip_to_arpa($self->{'in_hash'}->{'name'});
		}
	else {
		$self->check_ip6address($self->{'in_hash'}->{'name'}) ||
			$self->error($self->text('edit_eip6', $self->{'in_hash'}->{'name'}));
		$self->{'name'} = $self->net_to_ip6int($self->{'in_hash'}->{'name'});
		}
	&valname($self->{'in_hash'}->{'value0'}) ||
		$self->error($self->text('edit_ehost', $self->{'vals_array'}->[0]));
	if ($self->{'in_hash'}->{'value0'} !~ /\.$/) { $vals .= "."; }
	}
else {
	# some other kind of record
	$self->{'in_hash'}->{'name'} eq "" || $self->{'in_hash'}->{'name'} eq "@" || &valnamewild($self->{'in_hash'}->{'name'}) ||
		$self->error($self->text('edit_ename', $self->{'in_hash'}->{'name'}));
	if ($self->{'in_hash'}->{'type'} eq "A") {
		$self->check_ipaddress($vals) ||
			$self->error($self->text('edit_eip', $vals));
		if (!$self->{'access_hash'}->{'multiple'}) {
			# Is this address already in use? Search all domains
			# to find out..
			foreach $z (@{$self->{'zl_array'}}) {
				next if ($z->{'type'} ne "master");
				next if ($z->{'name'} =~ /in-addr\.arpa/i);
				$self->{'file'} = $z->{'file'};
				@{$self->{'frecs_array'}} = $self->read_zone_file($self->{'file'}, $z->{'name'});
				foreach $fr (@{$self->{'frecs_array'}}) {
					if ($fr->{'type'} eq "A" &&
					    $fr->{'values'}->[0] eq $vals &&
					    $fr->{'name'} ne $self->{'r'}->{'name'}) {
						$self->error($self->text('edit_edupip',
							     $vals));
						}
					}
				}
			}
		}
	elsif ($self->{'in_hash'}->{'type'} eq "AAAA") {
		$self->check_ip6address($vals) ||
			$self->error($self->text('edit_eip6', $vals));
		if (!$self->{'access_hash'}->{'multiple'}) {
			# Is this address already in use? Search all domains
			# to find out..
			foreach $z (@{$self->{'zl_array'}}) {
				next if ($z->{'type'} ne "master");
				next if ($z->{'name'} =~ /\.$self->{'ipv6revzone'}/i);
				$self->{'file'} = $z->{'file'};
				@{$self->{'frecs_array'}} = $self->read_zone_file($self->{'file'}, $z->{'name'});
				foreach $fr (@{$self->{'frecs_array'}}) {
					if ($fr->{'type'} eq "AAAA" &&
					    $self->expandall_ip6($fr->{'values'}->[0]) eq $self->expandall_ip6($vals) &&
					    $fr->{'name'} ne $self->{'r'}->{'name'}) {
						$self->error($self->text('edit_edupip',
							     $vals));
						}
					}
				}
			}
		}
	elsif ($self->{'in_hash'}->{'type'} eq "NS") {
		&valname($vals) ||
			$self->error($self->text('edit_ens', $vals));
		}
	elsif ($self->{'in_hash'}->{'type'} eq "CNAME") {
		&valname($vals) || $vals eq '@' ||
			$self->error($self->text('edit_ecname', $vals));
		}
	elsif ($self->{'in_hash'}->{'type'} eq "MX") {
		&valname($self->{'in_hash'}->{'value1'}) ||
			$self->error($self->text('edit_emx', $self->{'in_hash'}->{'value1'}));
		$self->{'in_hash'}->{'value0'} =~ /^\d+$/ ||
			$self->error($self->text('edit_epri', $self->{'in_hash'}->{'value0'}));
		}
	elsif ($self->{'in_hash'}->{'type'} eq "HINFO") {
		$self->{'in_hash'}->{'value0'} =~ /^[^\s\";]+$/ ||
			$self->error($self->{'text_hash'}->{'edit_ehard'});
		$self->{'in_hash'}->{'value1'} =~ /^[^\s\";]+$/ ||
			$self->error($self->{'text_hash'}->{'edit_eos'});
		$vals = $self->{'in_hash'}->{'value0'}." ".$self->{'in_hash'}->{'value1'};
		}
	elsif ($self->{'in_hash'}->{'type'} eq "TXT") {
		$vals = $self->{'in_hash'}->{'value0'};
		$vals =~ s/((?:^|[^\\])(?:\\\\)*)[\"]/$1\\\"/g;
		$vals = "\"$vals\"";
		}
	elsif ($self->{'in_hash'}->{'type'} eq "WKS") {
		$self->check_ipaddress($self->{'in_hash'}->{'value0'}) ||
			$self->error($self->text('edit_eip', $self->{'in_hash'}->{'value0'}));
		if (!$self->{'in_hash'}->{'value2'}) {
			$self->error($self->{'text_hash'}->{'edit_eserv'});
			}
		@ws = split(/[\r\n]+|\s+/, $self->{'in_hash'}->{'value2'});
		$vals = "$self->{'in_hash'}->{'value0'} $self->{'in_hash'}->{'value1'} (";
		foreach $ws (@ws) {
			$ws =~ /^[a-z]([\w\-]*\w)?$/i ||
				$self->error($self->text('edit_ebadserv', $ws));
			$vals .= "\n\t\t\t\t\t$ws";
			}
		$vals .= " )";
		}
	elsif ($self->{'in_hash'}->{'type'} eq "RP") {
		if (!$self->{'in_hash'}->{'value0'}) {
			$self->{'in_hash'}->{'value0'} = ".";
			}
		elsif (!$self->valemail($self->{'in_hash'}->{'value0'})) {
			$self->error($self->text('edit_eemail', $self->{'in_hash'}->{'value0'}));
			}
		&valname($self->{'in_hash'}->{'value1'}) ||
			$self->error($self->text('edit_etxt', $self->{'in_hash'}->{'value1'}));
		$self->{'in_hash'}->{'value0'} = $self->email_to_dotted($self->{'in_hash'}->{'value0'});
		$vals = "$self->{'in_hash'}->{'value0'} $self->{'in_hash'}->{'value1'}";
		}
	elsif ($self->{'in_hash'}->{'type'} eq "LOC") {
		$self->{'in_hash'}->{'value0'} =~ /\S/ || $self->error($self->{'text_hash'}->{'edit_eloc'});
		}
	elsif ($self->{'in_hash'}->{'type'} eq 'SRV') {
		$self->{'in_hash'}->{'serv'} =~ /^[A-Za-z0-9\-\_]+$/ ||
			$self->error($self->text('edit_eserv2', $self->{'in_hash'}->{'serv'}));
		$self->{'in_hash'}->{'name'} = join(".", "_".$self->{'in_hash'}->{'serv'}, "_".$self->{'in_hash'}->{'proto'},
				   $self->{'in_hash'}->{'name'} ? ( $self->{'in_hash'}->{'name'} ) : ( ));
		$self->{'in_hash'}->{'value0'} =~ /^\d+$/ ||
			$self->error($self->text('edit_epri', $self->{'in_hash'}->{'value0'}));
		$self->{'in_hash'}->{'value1'} =~ /^\d+$/ ||
			$self->error($self->text('edit_eweight', $self->{'in_hash'}->{'value1'}));
		$self->{'in_hash'}->{'value2'} =~ /^\d+$/ ||
			$self->error($self->text('edit_eport', $self->{'in_hash'}->{'value2'}));
		&valname($self->{'in_hash'}->{'value3'}) ||
			$self->error($self->text('edit_etarget', $self->{'in_hash'}->{'value3'}));
		}
	elsif ($self->{'in_hash'}->{'type'} eq 'KEY') {
		$self->{'in_hash'}->{'value0'} =~ /^(\d+|0x[0-9a-f]+)$/i ||
			$self->error($self->text('edit_eflags', $self->{'in_hash'}->{'value0'}));
		$self->{'in_hash'}->{'value1'} =~ /^\d+$/ ||
			$self->error($self->text('edit_eproto', $self->{'in_hash'}->{'value1'}));
		$self->{'in_hash'}->{'value2'} =~ /^\d+$/ ||
			$self->error($self->text('edit_ealg', $self->{'in_hash'}->{'value2'}));
		$self->{'in_hash'}->{'value3'} =~ s/[ \r\n]//g;
		$self->{'in_hash'}->{'value3'} =~ /^[a-zA-Z0-9\/\+]+$/ ||
			$self->error($self->text('edit_ekey'));
		$vals = join(" ", $self->{'in_hash'}->{'value0'}, $self->{'in_hash'}->{'value1'},
				  $self->{'in_hash'}->{'value2'}, $self->{'in_hash'}->{'value3'});
		}
	elsif ($self->{'in_hash'}->{'type'} eq 'PTR') {
		$vals = $self->{'in_hash'}->{'value0'};
		&valname($vals) ||
			$self->error($self->text('edit_eptr', $vals));
		}
	elsif ($self->{'in_hash'}->{'type'} eq 'SPF') {
		# For SPF records, build the SPF string from the inputs
		$self->{'spf'} = $self->{'r'} ? $self->parse_spf($self->{'r'}->{'values'}->[0]) : { };
		$self->{'spf'}->{'a'} = $self->{'in_hash'}->{'spfa'};
		$self->{'spf'}->{'mx'} = $self->{'in_hash'}->{'spfmx'};
		$self->{'spf'}->{'ptr'} = $self->{'in_hash'}->{'spfptr'};
		$self->{'spf'}->{'a:'} = [ split(/\s+/, $self->{'in_hash'}->{'spfas'}) ];
		foreach my $a (@{$self->{'spf'}->{'a:'}}) {
			gethostbyname($a) || $self->error($self->text('edit_espfa', $a));
			}
		$self->{'spf'}->{'mx:'} = [ split(/\s+/, $self->{'in_hash'}->{'spfmxs'}) ];
		foreach my $mx (@{$self->{'spf'}->{'mx:'}}) {
			&valname($mx) || $self->error($self->text('edit_espfmx', $mx));
			}
		$self->{'spf'}->{'ip4:'} = [ split(/\s+/, $self->{'in_hash'}->{'spfip4s'}) ];
		foreach my $ip (@{$self->{'spf'}->{'ip4:'}}) {
			$self->check_ipaddress($ip) ||
			  ($ip =~ /^(\S+)\/\d+$/ && $self->check_ipaddress($1)) ||
			    $self->error($self->text('edit_espfip', $ip));
			}
		$self->{'spf'}->{'include:'} = [ split(/\s+/, $self->{'in_hash'}->{'spfincludes'}) ];
		foreach my $i (@{$self->{'spf'}->{'include:'}}) {
			&valname($i) || $self->error($self->text('edit_espfinclude', $i));
			}
		$self->{'spf'}->{'all'} = $self->{'in_hash'}->{'spfall'};
		$vals = "\"".$self->join_spf($self->{'spf'})."\"";
		}
	else {
		# For other record types, just save the lines
		$self->{'in_hash'}->{'values'} =~ s/\r//g;
		local @vlines = split(/\n/, $self->{'in_hash'}->{'values'});
		$vals = join(" ",map { $_ =~ /^\S+$/ ? $_ : "\"$_\"" } @vlines);
		}
	$self->{'fullname'} = $self->convert_to_absolute($self->{'in_hash'}->{'name'}, $self->{'in_hash'}->{'origin'});
	if ($self->{'config_hash'}->{'short_names'}) {
		$self->{'name'} = $self->{'in_hash'}->{'name'};
		}
	else {
		$self->{'name'} = $self->{'fullname'};
		}
	}

# check for CNAME collision
if (!defined($self->{'in_hash'}->{'num'}) || $self->{'name'} ne $self->{'r'}->{'name'}) {
	foreach $cr (@{$self->{'recs_array'}}) {
		if ($cr->{'name'} eq $self->{'name'}) {
			if ($self->{'in_hash'}->{'type'} eq CNAME) {
				$self->error($self->{'text_hash'}->{'edit_ecname1'});
				}
			elsif ($cr->{'type'} eq 'CNAME') {
				$self->error($self->{'text_hash'}->{'edit_ecname2'});
				}
			}
		}
	}

if ($self->{'in_hash'}->{'new'}) {
	# adding a new record
	($self->{'revconf'}, $self->{'revfile'}, $self->{'revrec'}) = $self->find_reverse($self->{'in_hash'}->{'value0'},
						      $self->{'in_hash'}->{'view'});
	if ($self->{'in_hash'}->{'rev'} && $self->{'config_hash'}->{'rev_must'} && !$self->{'revconf'}) {
		# Reverse zone must exist, but doesn't
		$self->error($self->{'text_hash'}->{'edit_erevmust'});
		}
	$self->create_record($self->{'in_hash'}->{'file'}, $self->{'name'}, $self->{'ttl'}, "IN", $self->{'in_hash'}->{'type'}, $vals,
		       $self->{'in_hash'}->{'comment'});
	$self->{'r'} = { 'name' => $self->{'name'}, 'ttl' => $self->{'ttl'}, 'class' => 'IN',
	       'type' => $self->{'in_hash'}->{'type'}, 'values' => [ split(/\s+/, $vals) ],
	       'comment' => $self->{'in_hash'}->{'comment'} };
	if ($self->{'in_hash'}->{'rev'} && $self->{'revconf'} && $self->can_edit_reverse($self->{'revconf'}) &&
	    $self->{'in_hash'}->{'value0'} !~ /\*/) {
		local $rname = $self->{'in_hash'}->{'type'} eq "A" ? $self->ip_to_arpa($self->{'in_hash'}->{'value0'})
						: $self->net_to_ip6int($self->{'in_hash'}->{'value0'});
		if ($self->{'revrec'} && $self->{'in_hash'}->{'rev'} == 2) {
			# Upate the existing reverse for the domain
			$self->lock_file($self->make_chroot($self->{'revrec'}->{'file'}));
			$self->modify_record($self->{'revrec'}->{'file'}, $self->{'revrec'},
				       $rname, $self->{'revrec'}->{'ttl'}, "IN", "PTR",
				       $self->{'fullname'});
			@{$self->{'rrecs_array'}} = $self->read_zone_file($self->{'revfile'}, $self->{'revconf'}->{'name'});
			$self->bump_soa_record($self->{'revfile'}, \@{$self->{'rrecs_array'}});
			}
		elsif (!$self->{'revrec'}) {
			# Add a reverse record if we are the master for the
			# reverse domain, and if there is not already a
			# reverse record for the address.
			$self->lock_file($self->make_chroot($self->{'revfile'}));
			$self->create_record($self->{'revfile'}, $rname,
				$self->{'ttl'}, "IN", "PTR", $self->{'fullname'});
			@{$self->{'rrecs_array'}} = $self->read_zone_file($self->{'revfile'}, $self->{'revconf'}->{'name'});
			$self->bump_soa_record($self->{'revfile'}, \@{$self->{'rrecs_array'}});
			}
		}

	($self->{'fwdconf'}, $self->{'fwdfile'}, $self->{'fwdrec'}) = $self->find_forward($vals, $vals =~ /\.$self->{'ipv6revzone'}/i);
	if ($self->{'in_hash'}->{'fwd'} && $self->{'fwdconf'} && !$self->{'fwdrec'} &&
	    $self->can_edit_zone($self->{'fwdconf'})) {
		# Add a forward record if we are the master for the forward
		# domain, and if there is not already an A record
		# for the address
		local($rtype);
		if ($self->check_ipaddress($self->{'in_hash'}->{'name'})) {
			$rtype = "A";
			}
		elsif ($self->{'config_hash'}->{'support_aaaa'} &&
		       $self->check_ip6address($self->{'in_hash'}->{'name'})) {
			$rtype = "AAAA";
			}
		if ($rtype) {
			$self->lock_file($self->make_chroot($self->{'fwdfile'}));
			$self->create_record($self->{'fwdfile'}, $vals,
				       $self->{'ttl'}, "IN", $rtype, $self->{'in_hash'}->{'name'});
			@{$self->{'frecs_array'}} = $self->read_zone_file($self->{'fwdfile'}, $self->{'fwdconf'}->{'name'});
			$self->bump_soa_record($self->{'fwdfile'}, \@{$self->{'frecs_array'}});
			}
		}
	}
else {
	# update an existing record
	$self->{'fulloldvalue0'} = $self->convert_to_absolute($self->{'in_hash'}->{'oldvalue0'}, $self->{'in_hash'}->{'origin'});
	$self->{'fulloldname'} = $self->convert_to_absolute($self->{'in_hash'}->{'oldname'}, $self->{'in_hash'}->{'origin'});
	($self->{'orevconf'}, $self->{'orevfile'}, $self->{'orevrec'}) = $self->find_reverse($self->{'in_hash'}->{'oldvalue0'},
							 $self->{'in_hash'}->{'view'});
	($self->{'revconf'}, $self->{'revfile'}, $self->{'revrec'}) = $self->find_reverse($self->{'in_hash'}->{'value0'},
						      $self->{'in_hash'}->{'view'});
	if ($self->{'in_hash'}->{'rev'} && $self->{'config_hash'}->{'rev_must'} && !$self->{'revconf'}) {
		# Reverse zone must exist, but doesn't
		$self->error($self->{'text_hash'}->{'edit_erevmust'});
		}
	$self->lock_file($self->make_chroot($self->{'r'}->{'file'}));
	$self->modify_record($self->{'r'}->{'file'}, $self->{'r'}, $self->{'name'}, $self->{'ttl'},
		       "IN", $self->{'in_hash'}->{'type'}, $vals, $self->{'in_hash'}->{'comment'});

	if ($self->{'in_hash'}->{'rev'} && $self->{'orevrec'} && $self->can_edit_reverse($self->{'orevconf'}) &&
	    $self->{'fulloldname'} eq $self->{'orevrec'}->{'values'}->[0] &&
	    ($self->{'in_hash'}->{'type'} eq "A" &&
	     $self->{'in_hash'}->{'oldvalue0'} eq $self->arpa_to_ip($self->{'orevrec'}->{'name'}) ||
	     $self->{'in_hash'}->{'type'} eq "AAAA" &&
	     $self->expandall_ip6($self->{'in_hash'}->{'oldvalue0'}) eq $self->expandall_ip6($self->ip6int_to_net($self->{'orevrec'}->{'name'})))) {
		# Updating the reverse record. Either the name, address
		# or both may have changed. Furthermore, the reverse record
		# may now be in a different file!
		$self->lock_file($self->make_chroot($self->{'orevfile'}));
		$self->lock_file($self->make_chroot($self->{'revfile'}));
		@{$self->{'orrecs_array'}} = $self->read_zone_file($self->{'orevfile'}, $self->{'orevconf'}->{'name'});
		@{$self->{'rrecs_array'}} = $self->read_zone_file($self->{'revfile'}, $self->{'revconf'}->{'name'});
		if ($self->{'revconf'} eq $self->{'orevconf'} && $self->can_edit_reverse($self->{'revconf'})) {
			# old and new in the same file
			$self->modify_record($self->{'orevrec'}->{'file'} , $self->{'orevrec'}, 
				       $self->net_to_ip6int($self->ip_to_arpa($self->{'in_hash'}->{'value0'})),
				       $self->{'orevrec'}->{'ttl'}, "IN", "PTR", $self->{'fullname'},
				       $self->{'in_hash'}->{'comment'});
			$self->bump_soa_record($self->{'orevfile'}, \@{$self->{'orrecs_array'}});
			}
		elsif ($self->{'revconf'} && $self->can_edit_reverse($self->{'revconf'})) {
			# old and new in different files
			$self->delete_record($self->{'orevrec'}->{'file'} , $self->{'orevrec'});
			$self->create_record($self->{'revfile'}, $self->net_to_ip6int($self->ip_to_arpa($self->{'in_hash'}->{'value0'})),
				       $self->{'orevrec'}->{'ttl'}, "IN", "PTR", $self->{'fullname'},
				       $self->{'in_hash'}->{'comment'});
			$self->bump_soa_record($self->{'orevfile'}, \@{$self->{'orrecs_array'}});
			$self->bump_soa_record($self->{'revfile'}, \@{$self->{'rrecs_array'}});
			}
		else {
			# we don't handle the new reverse domain.. lose the
			# reverse record
			$self->delete_record($self->{'orevrec'}->{'file'}, $self->{'orevrec'});
			$self->bump_soa_record($self->{'orevfile'}, \@{$self->{'orrecs_array'}});
			}
		}
	elsif ($self->{'in_hash'}->{'rev'} && !$self->{'orevrec'} && $self->{'revconf'} && !$self->{'revrec'} && 
	       $self->can_edit_reverse($self->{'revconf'})) {
		# we don't handle the old reverse domain but handle the new 
		# one.. create a new reverse record
	 	$self->lock_file($self->make_chroot($self->{'revfile'}));
		@{$self->{'rrecs_array'}} = $self->read_zone_file($self->{'revfile'}, $self->{'revconf'}->{'name'});
		$self->create_record($self->{'revfile'}, $self->net_to_ip6int($self->ip_to_arpa($self->{'in_hash'}->{'value0'})),
			       $self->{'ttl'}, "IN", "PTR", $self->{'fullname'}, $self->{'in_hash'}->{'comment'});
		$self->bump_soa_record($self->{'revfile'}, \@{$self->{'rrecs_array'}});
		}

	local($ipv6 = ($self->{'in_hash'}->{'value0'} =~ /\.$self->{'ipv6revzone'}/i));
	($self->{'ofwdconf'}, $self->{'ofwdfile'}, $self->{'ofwdrec'}) = $self->find_forward($self->{'fulloldvalue0'}, $ipv6);
	($self->{'fwdconf'}, $self->{'fwdfile'}, $self->{'fwdrec'}) =	$self->find_forward($self->{'in_hash'}->{'value0'}, $ipv6);
	if ($self->{'in_hash'}->{'fwd'} && $self->{'ofwdrec'} && $self->can_edit_zone($self->{'ofwdconf'}) &&
	    $self->expandall_ip6($self->ip6int_to_net($self->arpa_to_ip($self->{'in_hash'}->{'oldname'}))) eq
	    $self->expandall_ip6($self->{'ofwdrec'}->{'values'}->[0]) &&
	    $self->{'fulloldvalue0'} eq $self->{'ofwdrec'}->{'name'}) {
		# Updating the forward record
		$self->lock_file($self->make_chroot($self->{'ofwdfile'}));
		$self->lock_file($self->make_chroot($self->{'fwdfile'}));
		@{$self->{'ofrecs_array'}} = $self->read_zone_file($self->{'ofwdfile'}, $self->{'ofwdconf'}->{'name'});
		@{$self->{'frecs_array'}} = $self->read_zone_file($self->{'fwdfile'}, $self->{'fwdconf'}->{'name'});
		if ($self->{'fwdconf'} eq $self->{'ofwdconf'} &&
		    $self->can_edit_zone($self->{'fwdconf'})) {
			# old and new are in the same file
			$self->modify_record($self->{'ofwdrec'}->{'file'} , $self->{'ofwdrec'}, $vals,
				       $self->{'ofwdrec'}->{'ttl'}, "IN",
				       $ipv6 ? "AAAA" : "A",
				       $self->{'in_hash'}->{'name'}, $self->{'in_hash'}->{'comment'});
			$self->bump_soa_record($self->{'ofwdfile'}, \@{$self->{'ofrecs_array'}});
			}
		elsif ($self->{'fwdconf'} && $self->can_edit_zone($self->{'fwdconf'})) {
			# old and new in different files
			$self->delete_record($self->{'ofwdrec'}->{'file'} , $self->{'ofwdrec'});
			if (!ipv6 || $self->{'config_hash'}->{'support_aaaa'}) {
				$self->create_record($self->{'fwdfile'}, $vals, $self->{'ofwdrec'}->{'ttl'},
					       "IN", $ipv6 ? "AAAA" : "A",
					       $self->{'in_hash'}->{'name'}, $self->{'in_hash'}->{'comment'});
				$self->bump_soa_record($self->{'fwdfile'}, \@{$self->{'frecs_array'}});
				}
			$self->bump_soa_record($self->{'ofwdfile'}, \@{$self->{'ofrecs_array'}});
			}
		else {
			# lose the forward because it has been moved to
			# a zone not handled by this server
			$self->delete_record($self->{'ofwdrec'}->{'file'} , $self->{'ofwdrec'});
			$self->bump_soa_record($self->{'ofwdfile'}, \@{$self->{'ofrecs_array'}});
			}
		}
	}
$self->bump_soa_record($self->{'in_hash'}->{'file'}, \@{$self->{'recs_array'}});
$self->unlock_all_files();
$self->{'r'}->{'newvalues'} = $vals;
$self->webmin_log($self->{'in_hash'}->{'new'} ? 'create' : 'modify', 'record', $self->{'in_hash'}->{'origin'}, $self->{'r'});
if ($self->{'in_hash'}->{'dom'}) {
    $self->redirect("edit_recs.cgi?dom=$self->{'in_hash'}->{'dom'}&view=$self->{'in_hash'}->{'view'}&type=ALL");
    } else {
	$self->redirect("edit_recs.cgi?index=$self->{'in_hash'}->{'index'}&view=$self->{'in_hash'}->{'view'}&type=$self->{'in_hash'}->{'redirtype'}&sort=$self->{'in_hash'}->{'sort'}");
	}

1;
		
}

# valname(name)
sub valname
{
	shift if ($self == $_[0]);

return $self->valdnsname($_[0], 0, $self->{'in_hash'}->{'origin'});
}

# valnamewild(name)
sub valnamewild
{
	shift if ($self == $_[0]);

return $self->valdnsname($_[0], 1, $self->{'in_hash'}->{'origin'});
}


1;

