#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Actually setup rndc

&ModuleLoader::preload_module('bind8_class', "bind8::Bind8Lib");
$self = new bind8::Bind8Lib:: 'bind8_class',%$self;

$self->{'access_hash'}->{'defaults'} || $self->error($self->{'text_hash'}->{'rndc_ecannot'});
$self->error_setup($self->{'text_hash'}->{'rndc_err'});

# Generate the RNDC config
$self->execute_command($self->{'config_hash'}->{'rndcconf_cmd'}, undef, \$self->{'out'}, \$self->{'err'});
if ($?) {
	$self->error("<pre>$self->{'err'}</pre>");
	}
$self->open_lock_tempfile(CONF, ">$self->{'config_hash'}->{'rndc_conf'}");
$self->print_tempfile(CONF, $self->{'out'});
$self->close_tempfile(CONF);
$self->set_ownership_permissions(0, 0, 0600, $self->{'config_hash'}->{'rndc_conf'});
$self->{'rconf'} = [ $self->read_config_file($self->{'config_hash'}->{'rndc_conf'}, undef, 1) ];

# Get the new key
$self->{'rkey'} = $self->find("key", $self->{'rconf'});
$self->{'rkey'} || $self->error($self->{'text_hash'}->{'rndc_ekey'});
$self->{'secret'} = $self->find_value("secret", $self->{'rkey'}->{'members'});
$self->{'secret'} || $self->error($self->{'text_hash'}->{'rndc_esecret'});
$self->{'options'} = $self->find("options", $self->{'rconf'});
if ($self->{'options'}) {
	$self->{'port'} = $self->find_value("default-port", $self->{'options'}->{'members'});
	}
$self->{'port'} ||= 953;

# Add the key to named.conf
$self->lock_file($self->make_chroot($self->{'config_hash'}->{'named_conf'}));
$self->{'parent'} = $self->get_config_parent();
$self->{'conf'} = $self->get_config();
@{$self->{'keys_array'}} = $self->find("key", $self->{'conf'});
($self->{'key'}) = grep { $_->{'values'}->[0] eq "rndc-key" } @{$self->{'keys_array'}};
if (!$self->{'key'}) {
	# Need to create key
	$self->{'key'} = { 'name' => 'key',
		 'type' => 1,
		 'values' => [ "rndc-key" ],
		 'members' => [ ] };
	push(@{$self->{'keys_array'}}, $self->{'key'});
	}
$self->save_directive($self->{'key'}, "algorithm", [ { 'name' => 'algorithm',
			'values' => [ "hmac-md5" ] } ], 1, 1);
$self->save_directive($self->{'key'}, "secret", [ { 'name' => 'secret',
			'values' => [ $self->{'secret'} ] } ], 1, 1);
$self->save_directive($self->{'parent'}, 'key', \@{$self->{'keys_array'}}, 0);

# Make sure there is a control for the inet port
$self->{'controls'} = $self->find("controls", $self->{'conf'});
if (!$self->{'controls'}) {
	# Need to add controls section
	$self->{'controls'} = { 'name' => 'controls', 'type' => 1 };
	$self->save_directive($self->{'parent'}, 'controls', [ $self->{'controls'} ]);
	}
$self->{'inet'} = $self->find("inet", $self->{'controls'}->{'members'});
if (!$self->{'inet'}) {
	# Need to add inet entry
	$self->{'inet'} = { 'name' => 'inet',
		  'type' => 2,
		  'values' => [ "127.0.0.1", "port", $self->{'port'} ],
		  'members' => { 'allow' => [
				  { 'name' => "127.0.0.1" } ],
				'keys' => [
				  { 'name' => "rndc-key" } ]
			      }
		};
	}
else {
	# Just make sure it is valid
	%{$self->{'keys_hash'}} = map { $_->{'name'}, 1 } @{$self->{'inet'}->{'members'}->{'keys'}};
	if (!$self->{'keys_hash'}->{'rndc-key'}) {
		push(@{$self->{'inet'}->{'members'}->{'keys'}},
		     { 'name' => "rndc-key" });
		}
	}
$self->save_directive($self->{'controls'}, 'inet', [ $self->{'inet'} ], 1);

$self->flush_file_lines();
$self->unlock_file($self->make_chroot($self->{'config_hash'}->{'named_conf'}));
$self->restart_bind();
$self->webmin_log("rndc");
$self->redirect("");

1;
		
}


1;

