#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_slave.cgi
# Save changes to slave zone options in named.conf

&ModuleLoader::preload_module('bind8_class', "bind8::Bind8Lib");
$self = new bind8::Bind8Lib:: 'bind8_class',%$self;

$self->ReadParse();
$self->{'conf'} = $self->get_config();
if ($self->{'in_hash'}->{'view'} ne '') {
	$self->{'view'} = $self->{'conf'}->[$self->{'in_hash'}->{'view'}];
	$self->{'conf'} = $self->{'view'}->{'members'};
	$self->{'indent'} = 2;
	}
else {
	$self->{'indent'} = 1;
	}
$self->{'zconf'} = $self->{'conf'}->[$self->{'in_hash'}->{'index'}];
$self->lock_file($self->make_chroot($self->{'zconf'}->{'file'}));
$self->error_setup($self->{'text_hash'}->{'slave_err'});
$self->can_edit_zone($self->{'zconf'}, $self->{'view'}) ||
	$self->error($self->{'text_hash'}->{'slave_ecannot'});
$self->{'access_hash'}->{'ro'} && $self->error($self->{'text_hash'}->{'master_ero'});
$self->{'access_hash'}->{'opts'} || $self->error($self->{'text_hash'}->{'master_eoptscannot'});

$self->save_port_address("masters", "port", $self->{'zconf'}, $self->{'indent'});
$self->save_opt("max-transfer-time-in", \&mtti_check, $self->{'zconf'}, $self->{'indent'});
$self->save_opt("file", \&file_check, $self->{'zconf'}, $self->{'indent'});
$self->save_choice("check-names", $self->{'zconf'}, $self->{'indent'});
$self->save_choice("notify", $self->{'zconf'}, $self->{'indent'});
$self->save_addr_match("allow-update", $self->{'zconf'}, $self->{'indent'});
$self->save_addr_match("allow-transfer", $self->{'zconf'}, $self->{'indent'});
$self->save_addr_match("allow-query", $self->{'zconf'}, $self->{'indent'});
$self->save_address("also-notify", $self->{'zconf'}, $self->{'indent'});
$self->flush_file_lines();
$self->unlock_file($self->make_chroot($self->{'zconf'}->{'file'}));
$self->webmin_log("opts", undef, $self->{'zconf'}->{'value'}, \%{$self->{'in_hash'}});
$self->redirect("edit_slave.cgi?index=$self->{'in_hash'}->{'index'}&view=$self->{'in_hash'}->{'view'}");

1;
		
}

sub mtti_check
{
	shift if ($self == $_[0]);

return $_[0] =~ /^\d+$/ ? undef : $self->text('slave_emax', $_[0]);
}

sub file_check
{
	shift if ($self == $_[0]);

return $self->{'text_hash'}->{'slave_efile'} if ($_[0] !~ /\S/);
local $file = $_[0];
if ($_[0] !~ /^\//) {
	$file = $self->base_directory($self->{'conf'})."/".$file;
	}
return $self->allowed_zone_file(\%{$self->{'access_hash'}}, $file) ? undef :
	$self->text('slave_efile2', $_[0]);
}


1;

