#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_soa.cgi
# Save changes to an SOA record

&ModuleLoader::preload_module('bind8_class', "bind8::Bind8Lib");
$self = new bind8::Bind8Lib:: 'bind8_class',%$self;

$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'master_err2'});
$self->{'zone'} = $self->get_zone_name($self->{'in_hash'}->{'index'}, $self->{'in_hash'}->{'view'});
$self->{'dom'} = $self->{'zone'}->{'name'};
$self->can_edit_zone($self->{'zone'}) ||
	$self->error($self->{'text_hash'}->{'master_ecannot'});
$self->{'access_hash'}->{'ro'} && $self->error($self->{'text_hash'}->{'master_ero'});
$self->{'access_hash'}->{'params'} || $self->error($self->{'text_hash'}->{'master_esoacannot'});

# check inputs
$self->valdnsname($self->{'in_hash'}->{'master'}, 0, $self->{'in_hash'}->{'origin'}) ||
	$self->error($self->text('master_emaster', $self->{'in_hash'}->{'master'}));
$self->valemail($self->{'in_hash'}->{'email'}) ||
	$self->error($self->text('master_eemail', $self->{'in_hash'}->{'email'}));
$self->{'in_hash'}->{'refresh'} =~ /^\d+$/ ||
	$self->error($self->text('master_erefresh', $self->{'in_hash'}->{'refresh'}));
$self->{'in_hash'}->{'retry'} =~ /^\d+$/ ||
	$self->error($self->text('master_eretry', $self->{'in_hash'}->{'retry'}));
$self->{'in_hash'}->{'expiry'} =~ /^\d+$/ ||
	$self->error($self->text('master_eexpiry', $self->{'in_hash'}->{'expiry'}));
$self->{'in_hash'}->{'minimum'} =~ /^\d+$/ ||
	$self->error($self->text('master_eminimum', $self->{'in_hash'}->{'minimum'}));
if ($self->{'in_hash'}->{'email'} =~ /\@/) {
	$self->{'in_hash'}->{'email'} = $self->email_to_dotted($self->{'in_hash'}->{'email'});
	}
$self->{'in_hash'}->{'defttl_def'} || $self->{'in_hash'}->{'defttl'} =~ /^\d+$/ ||
	$self->error($self->text('master_edefttl', $self->{'in_hash'}->{'defttl'}));

$self->lock_file($self->make_chroot($self->{'in_hash'}->{'file'}));
@{$self->{'recs_array'}} = $self->read_zone_file($self->{'in_hash'}->{'file'}, $self->{'in_hash'}->{'origin'});
$self->{'old'} = $self->{'recs_array'}->[$self->{'in_hash'}->{'num'}];
# already set serial if no acl allow it to update or update is disabled
$self->{'serial'} = $self->{'old'}->{'values'}->[2];
if ($self->{'config_hash'}->{'updserial_on'}) {
	# automatically handle serial numbers ?
	$self->{'serial'} = $self->compute_serial($self->{'old'}->{'values'}->[2]);
	}
else {
	$self->{'in_hash'}->{'serial'} =~ /^\d+$/ || $self->error($self->{'text_hash'}->{'master_eserial'});
	$self->{'serial'} = $self->{'in_hash'}->{'serial'};
	}
$self->{'vals'} = "$self->{'in_hash'}->{'master'} $self->{'in_hash'}->{'email'} (\n".
	"\t\t\t$self->{'serial'}\n".
	"\t\t\t$self->{'in_hash'}->{'refresh'}$self->{'in_hash'}->{'refunit'}\n".
	"\t\t\t$self->{'in_hash'}->{'retry'}$self->{'in_hash'}->{'retunit'}\n".
	"\t\t\t$self->{'in_hash'}->{'expiry'}$self->{'in_hash'}->{'expunit'}\n".
	"\t\t\t$self->{'in_hash'}->{'minimum'}$self->{'in_hash'}->{'minunit'} )";
$self->modify_record($self->{'in_hash'}->{'file'}, $self->{'old'}, $self->{'old'}->{'name'}, $self->{'old'}->{'ttl'},
	       $self->{'old'}->{'class'}, "SOA", $self->{'vals'});

($self->{'defttl'}) = grep { $_->{'defttl'} } @{$self->{'recs_array'}};
if (!$self->{'defttl'} && !$self->{'in_hash'}->{'defttl_def'}) {
	$self->create_defttl($self->{'in_hash'}->{'file'}, $self->{'in_hash'}->{'defttl'}.$self->{'in_hash'}->{'defttlunit'});
	}
elsif ($self->{'defttl'} && !$self->{'in_hash'}->{'defttl_def'}) {
	$self->modify_defttl($self->{'in_hash'}->{'file'}, $self->{'defttl'}, $self->{'in_hash'}->{'defttl'}.$self->{'in_hash'}->{'defttlunit'});
	}
elsif ($self->{'defttl'} && $self->{'in_hash'}->{'defttl_def'}) {
	$self->delete_defttl($self->{'in_hash'}->{'file'}, $self->{'defttl'});
	}

$self->unlock_file($self->make_chroot($self->{'in_hash'}->{'file'}));
$self->webmin_log("soa", undef, $self->{'in_hash'}->{'origin'}, \%{$self->{'in_hash'}});
$self->redirect("edit_master.cgi?index=$self->{'in_hash'}->{'index'}&view=$self->{'in_hash'}->{'view'}");

1;
		
}


1;

