#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_zonedef.cgi
# Save zone defaults

&ModuleLoader::preload_module('bind8_class', "bind8::Bind8Lib");
$self = new bind8::Bind8Lib:: 'bind8_class',%$self;

$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'zonedef_err'});
$self->{'access_hash'}->{'defaults'} || $self->error($self->{'text_hash'}->{'zonedef_ecannot'});

$self->lock_file($self->make_chroot($self->{'config_hash'}->{'named_conf'}));
$self->lock_file("$self->{'module_config_directory'}/zonedef");
$self->{'conf'} = $self->get_config();
$self->{'options'} = $self->find("options", $self->{'conf'});
foreach $c ("master", "slave", "response") {
	push(@{$self->{'check_array'}}, { 'name' => 'check-names',
		       'values' => [ $c, $self->{'in_hash'}->{$c} ] }) if ($self->{'in_hash'}->{$c});
	}
$self->save_directive($self->{'options'}, 'check-names', \@{$self->{'check_array'}}, 1);
$self->save_addr_match("allow-transfer", $self->{'options'}, 1);
$self->save_addr_match("allow-query", $self->{'options'}, 1);
$self->save_choice("notify", $self->{'options'}, 1);

$self->{'in_hash'}->{'refresh'} =~ /^\d+$/ || $self->error($self->text('master_erefresh', $self->{'in_hash'}->{'refresh'}));
$self->{'in_hash'}->{'retry'} =~ /^\d+$/ || $self->error($self->text('master_eretry', $self->{'in_hash'}->{'retry'}));
$self->{'in_hash'}->{'expiry'} =~ /^\d+$/ || $self->error($self->text('master_eexpiry', $self->{'in_hash'}->{'expiry'}));
$self->{'in_hash'}->{'minimum'} =~ /^\d+$/ || $self->error($self->text('master_eminimum', $self->{'in_hash'}->{'minimum'}));
%{$self->{'zonedef_hash'}} = ( 'refresh', $self->{'in_hash'}->{'refresh'},
	     'retry', $self->{'in_hash'}->{'retry'},
	     'expiry', $self->{'in_hash'}->{'expiry'},
	     'minimum', $self->{'in_hash'}->{'minimum'},
	     'refunit', $self->{'in_hash'}->{'refunit'},
	     'retunit', $self->{'in_hash'}->{'retunit'},
	     'expunit', $self->{'in_hash'}->{'expunit'},
	     'minunit', $self->{'in_hash'}->{'minunit'} );

$self->lock_file("$self->{'module_config_directory'}/config");
foreach $k (keys %{$self->{'config_hash'}}) {
	delete($self->{'config_hash'}->{$k}) if ($k =~ /^tmpl_/);
	}
$self->{'j'}=0;
for($i=0; defined($self->{'in_hash'}->{"name_$i"}); $i++) {
	next if (!$self->{'in_hash'}->{"name_$i"});
	$self->{'in_hash'}->{"type_$i"} eq 'A' || !$self->{'in_hash'}->{"def_$i"} ||
		$self->error($self->{'text_hash'}->{'master_eiptmpl'});
	$self->{'config_hash'}->{"tmpl_$self->{'j'}"} = join(' ', $self->{'in_hash'}->{"name_$i"}, $self->{'in_hash'}->{"type_$i"},
				  $self->{'in_hash'}->{"def_$i"} ? () : ( $self->{'in_hash'}->{"value_$i"} ) );
	$self->{'j'}++;
	}
$self->{'config_hash'}->{'tmpl_email'} = $self->{'in_hash'}->{'email'};
$self->{'config_hash'}->{'tmpl_include'} = $self->{'in_hash'}->{'include'};
if ($self->{'in_hash'}->{'prins_def'}) {
	delete($self->{'config_hash'}->{'default_prins'});
	}
else {
	$self->{'in_hash'}->{'prins'} =~ /^[a-z0-9\.\-\_]+$/i ||
		$self->error($self->{'text_hash'}->{'zonedef_eprins'});
	$self->{'config_hash'}->{'default_prins'} = $self->{'in_hash'}->{'prins'};
	}
$self->write_file("$self->{'module_config_directory'}/config", \%{$self->{'config_hash'}});
$self->unlock_file("$self->{'module_config_directory'}/config");

$self->save_zone_defaults(\%{$self->{'zonedef_hash'}});
$self->flush_file_lines();
$self->unlock_file($self->make_chroot($self->{'config_hash'}->{'named_conf'}));
$self->unlock_file("$self->{'module_config_directory'}/zonedef");
$self->webmin_log("zonedef", undef, undef, \%{$self->{'in_hash'}});
$self->redirect("");

1;
		
}


1;

