#!/usr/bin/perl

&MAIN();

 sub MAIN {
# whois.cgi
# Call whois to get zone info

&ModuleLoader::preload_module('bind8_class', "bind8::Bind8Lib");
$self = new bind8::Bind8Lib:: 'bind8_class',%$self;

$self->ReadParse();
$self->{'access_hash'}->{'whois'} || $self->error($self->{'text_hash'}->{'whois_ecannot'});
$self->{'zone'} = $self->get_zone_name($self->{'in_hash'}->{'index'}, $self->{'in_hash'}->{'view'});
$self->{'dom'} = $self->{'zone'}->{'name'};
$self->{'tv'} = $self->{'zone'}->{'type'};
$self->can_edit_zone($self->{'zone'}) ||
	$self->error($self->{'text_hash'}->{'master_ecannot'});
$self->{'desc'} = $self->ip6int_to_net($self->arpa_to_ip($self->{'dom'}));
$self->ui_print_header($self->{'desc'}, $self->{'text_hash'}->{'whois_title'}, "");

# Find the best whois server for the domain
foreach $wf ("$self->{'module_root_directory'}/whois-servers",
	     "$self->{'module_config_directory'}/whois-servers") {
	open(WHOIS, $wf);
	while(<WHOIS>) {
		s/\r|\n//g;
		local ($wdom, $wserv) = split(/\s+/);
		$self->{'whois_hash'}->{$wdom} = $wserv;
		}
	close(WHOIS);
	}
foreach $d (sort { length($b) <=> length($a) } keys %{$self->{'whois_hash'}}) {
	if ($self->{'dom'} =~ /\Q$d\E$/) {
		$self->{'server'} = "-h ".quotemeta($self->{'whois_hash'}->{$d});
		last;
		}
	}

$self->{'qdom'} = quotemeta($self->{'dom'});
$self->{'cmd'} = "$self->{'config_hash'}->{'whois_cmd'} $self->{'server'} $self->{'qdom'}";
$self->{'out'} = `$self->{'cmd'} 2>&1`;
if ($self->{'out'} =~ /whois\s+server:\s+(\S+)/i) {
	$self->{'cmd'} = "$self->{'config_hash'}->{'whois_cmd'} -h $1 '$self->{'dom'}'";
	$self->{'out'} = `$self->{'cmd'} 2>&1`;
	}
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>",$self->text('whois_header', "<tt>$self->{'cmd'}</tt>"),
      "</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><pre>",$self->html_escape($self->{'out'});
print "</pre></td> </tr></table><br>\n";

$self->ui_print_footer(($self->{'tv'} eq "master" ? "edit_master.cgi" :
	 $self->{'tv'} eq "forward" ? "edit_forward.cgi" : "edit_slave.cgi").
	"?index=$self->{'in_hash'}->{'index'}&view=$self->{'in_hash'}->{'view'}", $self->{'text_hash'}->{'master_return'});

1;
		
}


1;

