#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_export.cgi
# Save or create an export

&ModuleLoader::preload_module('bsdexports_class', "bsdexports::BsdexportsLib");
$self = new bsdexports::BsdexportsLib:: 'bsdexports_class',%$self;

$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'save_err'});

if ($self->{'in_hash'}->{'delete'}) {
	# Redirect to delete CGI
	$self->redirect("delete_export.cgi?idx=$self->{'in_hash'}->{'idx'}");
	exit(0);
	}

# Validate and save inputs
@{$self->{'dl_array'}} = split(/\s+/, $self->{'in_hash'}->{'dirs'});
foreach $d (@{$self->{'dl_array'}}) {
	-d $d || $self->error($self->text('save_edir', $d));
	}
@{$self->{'dl_array'}} || $self->error($self->{'text_hash'}->{'save_enone'});
if ($self->{'in_hash'}->{'alldirs'}) {
	@{$self->{'dl_array'}} == 1 || $self->error($self->{'text_hash'}->{'save_esub'});
	if (&root_dir($self->{'dl_array'}->[0]) ne $self->{'dl_array'}->[0]) {
		$self->error($self->{'text_hash'}->{'save_eroot'});
		}
	}
$self->{'exp_hash'}->{'dirs'} = \@{$self->{'dl_array'}};
@{$self->{'devno_array'}} = map { (stat($_))[0] } @{$self->{'dl_array'}};
$self->{'exp_hash'}->{'alldirs'} = $self->{'in_hash'}->{'alldirs'};
$self->{'exp_hash'}->{'ro'} = $self->{'in_hash'}->{'ro'};
$self->{'exp_hash'}->{'kerb'} = $self->{'in_hash'}->{'kerb'};

if (!$self->{'in_hash'}->{'maproot_def'}) {
	$self->{'in_hash'}->{'maproot'} =~ /^-?\d+$/ || defined(getpwnam($self->{'in_hash'}->{'maproot'})) ||
		$self->error($self->text('save_euser', $self->{'in_hash'}->{'maproot'}));
	if ($self->{'in_hash'}->{'maprootg_def'}) {
		@{$self->{'rgl_array'}} = split(/\s+/, $self->{'in_hash'}->{'maprootg'});
		foreach $g (@{$self->{'rgl_array'}}) {
			$g =~ /^-?\d+$/ || defined(getgrnam($g)) ||
				$self->error($self->text('save_egroup', $g));
			}
		$self->{'exp_hash'}->{'maproot'} = "$self->{'in_hash'}->{'maproot'}:".join(':', @{$self->{'rgl_array'}});
		}
	else { $self->{'exp_hash'}->{'maproot'} = $self->{'in_hash'}->{'maproot'}; }
	}

if (!$self->{'in_hash'}->{'mapall_def'}) {
	$self->{'in_hash'}->{'mapall'} =~ /^-?\d+$/ || defined(getpwnam($self->{'in_hash'}->{'mapall'})) ||
		$self->error($self->text('save_euser', $self->{'in_hash'}->{'mapall'}));
	if ($self->{'in_hash'}->{'mapallg_def'}) {
		@{$self->{'rgl_array'}} = split(/\s+/, $self->{'in_hash'}->{'mapallg'});
		foreach $g (@{$self->{'agl_array'}}) {
			$g =~ /^-?\d+$/ || defined(getgrnam($g)) ||
				$self->error($self->text('save_egroup', $g));
			}
		$self->{'exp_hash'}->{'mapall'} = "$self->{'in_hash'}->{'mapall'}:".join(':', @{$self->{'agl_array'}});
		}
	else { $self->{'exp_hash'}->{'mapall'} = $self->{'in_hash'}->{'mapall'}; }
	}

if (!$self->{'in_hash'}->{'maproot_def'} + !$self->{'in_hash'}->{'mapall_def'} + $self->{'in_hash'}->{'kerb'} > 1) {
	$self->error($self->{'text_hash'}->{'save_ekerb'});
	}

if ($self->{'in_hash'}->{'cmode'} == 0) {
	# Exporting to a list of hosts
	@{$self->{'hl_array'}} = split(/\s+/, $self->{'in_hash'}->{'hosts'});
	@{$self->{'hl_array'}} || $self->error($self->{'text_hash'}->{'save_ehosts'});
	$self->{'exp_hash'}->{'hosts'} = \@{$self->{'hl_array'}};
	foreach $h (@{$self->{'hl_array'}}) {
		$self->{'ip'} = gethostbyname($h);
		if ($self->{'ip'}) { push(@{$self->{'iplist_array'}}, $self->{'ip'}); }
		}
	}
else {
	# Exporting to a subnet
	$self->check_ipaddress($self->{'in_hash'}->{'network'}) ||
		$self->error($self->text('save_enetwork', $self->{'in_hash'}->{'network'}));
	$self->check_ipaddress($self->{'in_hash'}->{'mask'}) ||
		$self->error($self->text('save_enetmask', $self->{'in_hash'}->{'netmask'}));
	$self->{'exp_hash'}->{'network'} = $self->{'in_hash'}->{'network'};
	$self->{'exp_hash'}->{'mask'} = $self->{'in_hash'}->{'mask'};
	}

# Check for an export to the same host on the same local filesystem
$self->lock_file($self->{'config_hash'}->{'exports_file'});
@{$self->{'exps_array'}} = $self->list_exports();
for($i=0; $i<@{$self->{'exps_array'}}; $i++) {
	next if (defined($self->{'in_hash'}->{'index'}) && $self->{'in_hash'}->{'index'} == $i);
	$self->{'samefs'} = 0;
	foreach $d (@{$self->{'exps_array'}->[$i]->{'dirs'}}) {
		if ($self->indexof((stat($d))[0], @{$self->{'devno_array'}}) >= 0) {
			# Same filesystem as this export..
			$self->{'samefs'} = $d;
			}
		}
	next if (!$self->{'samefs'});
	foreach $h (@{$self->{'exps_array'}->[$i]->{'hosts'}}) {
		$self->{'ip'} = gethostbyname($h);
		if ($self->{'ip'} && $self->indexof($self->{'ip'}, @{$self->{'iplist_array'}}) >= 0) {
			# Another export on this filesystem is to the same host
			$self->error($self->text('save_esame1', $self->{'samefs'}, $h));
			}
		}
	if ($self->{'exp_hash'}->{'mask'} && $self->{'exp_hash'}->{'mask'} eq $self->{'exps_array'}->[$i]->{'mask'} &&
			    $self->{'exp_hash'}->{'network'} eq $self->{'exps_array'}->[$i]->{'network'}) {
		# Another export on this filesystem to the same net
		$self->error($self->text('save_esame1', $self->{'samefs'}, $self->{'exp_hash'}->{'network'}));
		}
	}

if (defined($self->{'in_hash'}->{'index'})) {
	$self->{'old'} = $self->{'exps_array'}->[$self->{'in_hash'}->{'index'}];
	$self->{'exp_hash'}->{'public'} = $self->{'old'}->{'public'};
	$self->{'exp_hash'}->{'webnfs'} = $self->{'old'}->{'webnfs'};
	$self->{'exp_hash'}->{'index'} = $self->{'old'}->{'index'};
	$self->modify_export($self->{'old'}, \%{$self->{'exp_hash'}});
	}
else {
	$self->create_export(\%{$self->{'exp_hash'}});
	}
$self->unlock_file($self->{'config_hash'}->{'exports_file'});
$self->redirect("");

1;
		
}

# root_dir(path)
# Returns the root directory of the filesystem some path is in
sub root_dir
{
	shift if ($self == $_[0]);

my $dir = $_[0];
my @pst = stat($dir);
while(1) {
	if ($dir eq "/") { return "/"; }
	my $lastdir = $dir;
	$dir =~ s/\/[^\/]+$//g;
	if ($dir eq "") { $dir = "/"; }
	my @ust = stat($dir);
	if ($ust[0] != $pst[0]) { return $lastdir; }
	}
}


1;

