#!/usr/bin/perl
# config.cgi
# Display a form for editing the configuration of a module.

require './web-lib.pl';
require './config-lib.pl';
require './ui-lib.pl';
&init_config();
&ReadParse();
local $m='';
$m = $ARGV[0] if (! %in);
foreach (keys %in) {
    $m = $_ if (! $in{$_});
}
&foreign_available($m) || &error($text{'config_eaccess'});
%access = &get_module_acl(undef, $m);
$access{'noconfig'} &&
	&error($text{'config_ecannot'});
%module_info = &get_module_info($m);
if (-r &help_file($m, "config_intro")) {
	$help = [ "config_intro", $m ];
	}
else {
	$help = undef;
	}
local %mtext;
if (!$in{'title'}) {
    &ui_print_header(&text('config_dir', $module_info{'desc'}),
                         $text{'config_title'}, "", $help, 0, 1);
    } else {
            %mtext = &load_language("/$m");
            &ui_print_header("",
                         $mtext{$in{'title'}}, "", $help, 0, 1);
            }

print &ui_form_start("config_save.cgi", "post");
print &ui_hidden("module", $m),"\n";
print &ui_hidden("conf_file", $in{'conf_file'}),"\n";
print &ui_table_start(&text('config_header', $module_info{'desc'}),
		      "width=100%", 2);
&read_file("$config_directory/$m/config", \%config);

$mdir = &module_root_directory($m);
if (-r "$mdir/config_info.pl") {
	# Module has a custom config editor
	&foreign_require($m, "config_info.pl");
	local $fn = "${m}::config_form";
	if (defined(&$fn)) {
		$func++;
		&foreign_call($m, "config_form", \%config);
		}
	}
if (!$func) {
	# Use config.info to create config inputs
	$conf_file =  $in{'conf_file'} ? $in{'conf_file'} : 'config.info';
	&generate_config(\%config, "$mdir/$conf_file", $m, undef, undef, undef, $in{'ln'}, $in{'mode'});
	}
print &ui_table_end();
print &ui_form_end([ [ "save", $text{'save'} ] ]);

($in{'title'}) ? &ui_print_footer($text{'index_mainpage_url'}, $text{'index_mainpage'}, 'virtual_server/index_config.cgi', $mtext{'config_title'}) :  &ui_print_footer("/$m", $text{'index'});

