#!/usr/bin/perl
# confmaster: configure.cgi

# main part
require './confmaster-lib.pl';
&ReadParse();

my $srv = $in{'srv'};
my ($rpms, $srv_name, $type, $types);
if ($config{'ztl_mode'})
{
 # for ztl
 $srv_name = $text{"server_appl_$srv"};
 $type = $text{"appliance"};
 $types = $text{"appliances"};
}
else
{
 # for cpplus
 $rpms = &get_rpms_list($srv);
 $rpms = &update_rpms_list($srv, $rpms);
 $srv_name = $text{"server_$srv"};
 $type = $text{"server"};
 $types = $text{"servers"};
}

#--- Interface part ---
# main menu
unless ($in{'confirm'} || $in{'confirm_un'} || $in{'confirm_reconf'} || $in{'uninstall'} || $in{'upgrade'} || $in{'reconfigure'})
{
 # print header
 my $rusure;
 if ($config{"configured_$srv"})
 {
  # for installed appliance or servers
  $rusure = $config{'ztl_mode'} ? &text('reconfig_rusure_appl', $srv_name) : &text('reconfig_rusure', $srv_name);
  &ui_print_header(undef, &text('setup_appl_title', $srv_name), undef, undef, undef);
  
  if ($config{'ztl_mode'} && ($srv eq 'mail'))
  {
   my $mta = ($config{'mail_system'} == 3) ? 'postfix' : 'sendmail';
   my $inst = &check_ztl_appliance("mail-$mta");
	if ($inst)
	{
	 print &text('setup_appl_mail_error', $text{$mta},"$gconfig{'webprefix'}/config.cgi?$module_name");
    &ui_print_footer("", &text('index_return', $types));
	 exit;
	}
  }
 }
 else
 {
  # for not installed appliance or servers
  if ($srv eq 'system')
  {
   # for upgrade all packages
   $rusure = $text{'setup_rusure_sys'};
   &ui_print_header(undef, &text('server_appl_system', $srv_name), undef, undef, undef);
  }
  else
  {  
   # for install server or appliance
   $rusure = $config{'ztl_mode'} ? &text('setup_rusure_appl', $srv_name) : &text('setup_rusure', $srv_name);
   &ui_print_header(undef, &text('setup_appl_title', $srv_name), "", undef, undef, undef);
	&print_conf_errors($srv, $types);
  }
 }
 
 # print main form
 print "<table width=100% border=0>\n";
 print "<tr><td colspan=3>$rusure</td></tr>\n";
 print &ui_form_start('configure.cgi');
 print &ui_hidden('srv', $srv);
 if ($config{"configured_$srv"})
 {
  # upgrade, reconfigure & uninstall form
  print "<tr><td colspan=3><hr></td></tr>\n";
  print "<tr><td width=30%>".&ui_submit(&text('upgrade_appl_title', $type), 'upgrade')."</td>\n";
  print "<td align=center>".&ui_submit(&text('reconfigure_appl_title', $type), 'confirm_reconf')."</td>\n";
  print "<td width=30% align=right>".&ui_submit(&text('uninstall_appl_title', $type), 'confirm_un')."</td>\n";
 }
 else
 {
  # install form
  print "<tr><td><b>".join(', ', @$rpms)."</b></td></tr>" if $rpms;
  print "<tr><td colspan=3><hr></td></tr>\n";
  print "<tr><td align=center colspan=3>";
  ($srv eq 'system') ? print &ui_submit($text{'update_system'}, 'confirm') : print &ui_submit(&text('setup_appl_title',$type),'confirm');
 }
 print &ui_form_end()."</td></tr></table>\n";
 
 # print footers
 my $lan = grep {$srv eq $_} @sub_lan_list;
 my $file = grep {$srv eq $_} @sub_file_list;
 my $db = grep {$srv eq $_} @sub_db_list;
 if ($lan)
 {
  &ui_print_footer("index.cgi?srv=lan", &text('index_return', $text{'server_appl_lan'}), "", &text('index_return', $types));
 }
 elsif ($file)
 {
  &ui_print_footer("index.cgi?srv=file", &text('index_return', $text{'server_appl_file'}), "", &text('index_return', $types));
 }
 elsif ($db)
 {
  &ui_print_footer("index.cgi?srv=database", &text('index_return', $text{'server_appl_database'}), "", &text('index_return', $types));
 }
 elsif ($srv eq 'system')
 {
  &ui_print_footer($text{'index_mainpage_url'}, $text{'index_mainpage'});
 }
 else
 {
  &ui_print_footer("", &text('index_return', $types));
 }
 exit;
}

# confirm reconfigure
if ($in{'confirm_reconf'} && !$in{'reconfigure'})
{
 # ztl or cp+ mode
 my $srv_name = $config{'ztl_mode'} ? $text{"server_appl_$srv"} : $text{"server_$srv"};
 my $rusure = $config{'ztl_mode'} ? &text('reconfigure_rusure_appl', $text{"server_appl_$srv"}) : &text('reconfigure_rusure_appl', $text{"server_$srv"});
 
 # print header
 &ui_print_header(undef, &text('reconfigure_appl_title', $srv_name), "", undef, 0, 1);
 
 # print confirm form
 print "<table width=100% border=0>\n";
 print "<tr><td>$rusure</td></tr>";
 print "<tr><td><hr></td></tr>\n";
 print &ui_form_start('configure.cgi');
 print &ui_hidden('srv', $srv);
 print "<tr><td align=center>".&ui_submit($text{'reconfigure_appl_confirm'}, 'reconfigure');
 print &ui_form_end()."</td></tr></table>\n";
 
 # print footers
 &ui_print_footer("configure.cgi?srv=$srv", &text('setup_appl_title', $srv_name),"", &text('index_return', $types));
 exit;
}

# confirm uninstall
if ($in{'confirm_un'} && !$in{'uninstall'})
{
 # ztl or cp+ mode
 my $srv_name = $config{'ztl_mode'} ? $text{"server_appl_$srv"} : $text{"server_$srv"};
 my $rusure = $config{'ztl_mode'} ? &text('uninstall_rusure_appl', $text{"server_appl_$srv"}) : &text('uninstall_rusure_appl', $text{"server_$srv"});
 
 # print header
 &ui_print_header(undef, &text('uninstall_appl_title', $srv_name), "", undef, 0, 1);
 
 # print confirm form
 print "<table width=100% border=0>\n";
 print "<tr><td>$rusure</td></tr>";
 print "<tr><td><hr></td></tr>\n";
 print &ui_form_start('configure.cgi');
 print &ui_hidden('srv', $srv);
 print "<tr><td align=center>".&ui_submit($text{'uninstall_appl_confirm'}, 'uninstall');
 print &ui_form_end()."</td></tr></table>\n";
 
 # print footers
 &ui_print_footer("configure.cgi?srv=$srv", &text('setup_appl_title', $srv_name),"", &text('index_return', $types));
 exit;
}

#--- Actions part ---
# disable SELinux
&selinux_disable();

# print message now
$| = 1;
$theme_no_table = 1;
$SIG{'TERM'} = 'IGNORE';

if ($in{'confirm'})
{
 # install
 # change permissions for temp directory
 &temp_chmod();
 
 # print header and error setup
 &ui_print_unbuffered_header(undef,  ($srv eq 'system') ? &text('server_appl_system', $srv_name) : &text('setup_appl_title', $srv_name), "", undef, 0, 1);
 &error_setup(&text('setup_error', $type));
 print "$text{'waiting'}";
 print "<table width='100%'>\n";
 
 # install and configure appliance or server
 if ($config{'ztl_mode'})
 {
  # for ztl
  &install_appl($srv);
 }
 else
 {
  # for cpplus
  &install_rpms($rpms);
  print "<tr $cb><td colspan=2>&nbsp;</td></tr>\n";
  &run_modules_postinstall($srv);
  print "<tr $cb><td colspan=2>&nbsp;</td></tr>\n";
  &configure_server($srv);
  print "<tr $cb><td colspan=2>&nbsp;</td></tr>\n";
  &websites_configure($srv);
  print "<tr $cb><td colspan=2>&nbsp;</td></tr>\n";
  &set_configured_flag($srv);
 }
 &print_postinstall_log($srv);
 print "</table>\n";
}
elsif ($in{'upgrade'})
{
 # upgrade
 # print header and error setup
 &ui_print_unbuffered_header(undef, &text('upgrade_appl_title', $srv_name), "", undef, 0, 1);
 &error_setup(&text('upgrade_setup_error', $type));
 print "$text{'waiting'}";
 print "<table width='100%'>\n";
 
 # upgrade appliance or server
 if ($config{'ztl_mode'})
 {
  # for ztl
  &upgrade_appl($srv);
 }
 else
 {
  # for cpplus
  &upgrade_rpms($rpms);
 }
 print "</table>\n";
}
elsif ($in{'reconfigure'})
{
 # reconfigure
 $reconf = 1;
 
 # print header and error setup
 &ui_print_unbuffered_header(undef, &text('reconfigure_appl_title', $srv_name), "", undef, 0, 1);
 &error_setup(&text('reconfigure_setup_error', $type));
 print "<table width='100%'>\n";
 
 # reconfigure appliance
 &run_modules_postinstall($srv);
 print "<tr $cb><td colspan=2>&nbsp;</td></tr>\n";
 &configure_server($srv);
 print "<tr $cb><td colspan=2>&nbsp;</td></tr>\n";
 &websites_configure($srv);
 print "<tr $cb><td colspan=2>&nbsp;</td></tr>\n";
 &set_configured_flag($srv);
 &print_postinstall_log($srv);
 print "</table>\n";
}
elsif ($in{'uninstall'})
{
 # uninstall
 # print header and error setup
 &ui_print_unbuffered_header(undef, &text('uninstall_appl_title', $srv_name), "", undef, 0, 1);
 &error_setup(&text('uninstall_setup_error', $type));
 print "$text{'waiting'}";
 print "<table width='100%'>\n";
 
 # uninstall appliance or server
 if ($config{'ztl_mode'})
 {
  # for ztl
  &uninstall_appl($srv);
 }
 else
 {
  # for cpplus
  &del_configured_flag($srv); 
  &uninstall_server($srv);
  print "<tr $cb><td colspan=2>&nbsp;</td></tr>\n";
  &uninstall_websites_configure($srv); 
  print "<tr $cb><td colspan=2>&nbsp;</td></tr>\n";
 }
 &print_postinstall_log($srv,1);
 print "</table>\n";
}

# print footers
($srv eq 'system') ? &ui_print_footer($text{'index_mainpage_url'}, $text{'index_mainpage'}) : &ui_print_footer("configure.cgi?srv=$srv", &text('setup_appl_title', $srv_name),"", &text('index_return', $types));
