#!/usr/bin/perl
# confmaster: configure_servers.cgi

# main part
require './confmaster-lib.pl';
&redirect("index.cgi") if ($config{'ztl_mode'});
&ReadParse();

# text types
my $types = $text{"servers"};
my $type = $text{"server"};

# main menu
unless ($in{'confirm'}) 
{
 &ui_print_header(undef, &text('index_title', $types), undef, undef, undef, 1);
 print "<table align=center border=0>\n";
 print "<tr><td>$text{'setup_massconfig'}</td></tr>\n";
 print &ui_form_start("configure_servers.cgi", "post");
 foreach my $srv (@servers_list) 
 {
  print "<tr><td>".&ui_checkbox($srv, 1, "<font size=+1>".$text{"server_$srv"}."</font><br>".$text{"descr_$srv"}, 0)."</td></tr>\n";
 }
 print "<tr><td><br>$text{'warning_massconfig'}</td></tr>\n";
 print "<tr align=center><td><br>".&ui_submit($text{'setup_confirm'}, 'confirm')."</td></tr>\n";
 print &ui_form_end();
 print "</table>";
 &ui_print_footer($text{'index_mainpage_url'},$text{'index_mainpage'});
 exit;
}

#--- Actions part ---
# disable SELinux
&selinux_disable();

# print message now
$| = 1;
&ui_print_unbuffered_header(undef, &text('index_title', $types), undef, undef, undef, 1);
&error_setup(&text('setup_error', $type));

# install and configure servers
&temp_chmod();
print "<table width='100%'>\n";
print "<tr><td colspan=2>$text{'waiting'}</td></tr>\n";
foreach my $srv (@servers_list) 
{
 next unless $in{$srv};
 my $rpms = &get_rpms_list($srv);
 $rpms = &update_rpms_list($srv, $rpms);
 print "<tr $tb><td colspan=2><h3>".$text{"server_$srv"}."</h3></td></tr>\n";
 &install_rpms($rpms);
 print "<tr $cb><td colspan=2>&nbsp;</td></tr>\n";
 &run_modules_postinstall($srv);
 print "<tr $cb><td colspan=2>&nbsp;</td></tr>\n";
 &configure_server($srv);
 print "<tr $cb><td colspan=2>&nbsp;</td></tr>\n";
 &websites_configure($srv);
 print "<tr $cb><td colspan=2>&nbsp;</td></tr>\n";
 &set_configured_flag($srv);
 &print_postinstall_log($srv);
 print "<tr $cb><td colspan=2>&nbsp;</td></tr>\n";
}
print "</table>\n";
&ui_print_footer($text{'index_mainpage_url'},$text{'index_mainpage'});
