#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Manages certificates for POP3 / IMAP over SSL

&ModuleLoader::preload_module('courier_imap_class', "courier_imap::CourierimapLib");
$self = new courier_imap::CourierimapLib:: 'courier_imap_class',%$self;

$self->ReadParse();
%{$self->{'access_hash'}} = $self->get_module_acl();

$self->{'dmn'} = $self->{'in_hash'}->{'dmn'};
$self->{'dmn'} eq 'imap' || $self->{'dmn'} eq 'pop3' || $self->error($self->{'text_hash'}->{'pop3_ein'});
$self->{'pop3'} = $self->{'dmn'} eq 'pop3';

$self->ui_print_header(undef, $self->{'pop3'} ? $self->{'text_hash'}->{'certpop3_title'} : $self->{'text_hash'}->{'certimap_title'}, "");

print "$self->{'text_hash'}->{'cert_desc1'}<p>\n";
print $self->ui_table_start($self->{'text_hash'}->{'cert_header1'}, "width=100%");
$self->{'certfile'} = $self->is_certificate_file($self->{'dmn'});
if ( !$self->{'certfile'} ) {
	print $self->ui_form_start("save_cert.cgi", "post");
	print $self->ui_hidden('dmn', $self->{'dmn'});
	printf "<tr><td colspan=4><p>$self->{'text_hash'}->{'cert_nocert'}<br>%s</p></td></tr>\n", $self->text('cert_gendesc', $self->get_daemon_title($self->{'dmn'}));
	print "<tr><td colspan=4>", $self->ui_submit($self->{'text_hash'}->{"cert_gen"}, 'gencert'), "</td></tr>\n";
	print $self->ui_form_end();
}
else {
	# Details of current certificate
	if ($self->{'info'} = $self->get_certificate_info($self->{'certfile'})) {
		foreach my $k ('cn', 'o', 'issuer_cn', 'issuer_o', 'notafter', 'type') {
			if ($self->{'info'}->{$k}) {
				print $self->ui_table_row($self->{'text_hash'}->{"cert_$k"}, $self->{'info'}->{$k});
			}
		}
	}
}
print $self->ui_table_end();
print "<hr>\n";

# Installs new key and certificate
print "$self->{'text_hash'}->{'cert_desc3'}<p>\n";
print $self->ui_form_start("save_cert.cgi", "post");
print $self->ui_hidden('dmn', $self->{'dmn'});
print $self->ui_table_start($self->{'text_hash'}->{'cert_header3'}, "width=100%", 2);
print $self->ui_table_row($self->{'text_hash'}->{'cert_cert'}, $self->ui_textarea('cert', undef, 8, 70));
$self->{'newkey'} = '';
if (-r $self->{'newkey'}) {
	$self->{'newkey_ctx'} = `cat $self->{'newkey'}`;
}
print $self->ui_table_row($self->{'text_hash'}->{'cert_newkey'}, $self->ui_textarea('newkey', undef, 8, 70));
print $self->ui_table_end();
print $self->ui_form_end([ [ "install", $self->{'text_hash'}->{'cert_install'} ] ]);

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

