#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Shows IMAP / IMAP SSL daemon options

&ModuleLoader::preload_module('courier_imap_class', "courier_imap::CourierimapLib");
$self = new courier_imap::CourierimapLib:: 'courier_imap_class',%$self;

$self->ReadParse();
%{$self->{'access_hash'}} = $self->get_module_acl();

$self->{'dmn'} = $self->{'in_hash'}->{'dmn'};
$self->{'dmn'} eq 'imap' || $self->{'dmn'} eq 'imapssl' || $self->error($self->{'text_hash'}->{'pop3_ein'});
$self->{'ssl'} = $self->{'dmn'} =~ /ssl/;

$self->ui_print_header(undef, $self->{'ssl'} ? $self->{'text_hash'}->{'imapssl_title'} : $self->{'text_hash'}->{'imap_title'}, "");

if ($self->{'ssl'}) {
	$self->{'conf'} = $self->get_daemon_config('imapssl');
	$self->{'conf2'} = $self->get_daemon_config('imap');
}
else {
	$self->{'conf'} = $self->get_daemon_config('imap');
	$self->{'conf2'} = $self->get_daemon_config('imapssl');
}

print $self->ui_form_start("save_imap.cgi", "post");
print $self->ui_hidden('dmn', $self->{'dmn'});
print $self->ui_table_start($self->{'text_hash'}->{'pop3_header1'}, "width=100%", 2);

# Address to listen on
$self->{'address'} = $self->{'ssl'} ? $self->get_value('SSLADDRESS', $self->{'conf'}) : $self->get_value('ADDRESS', $self->{'conf'});
$self->{'addr_def'} = $self->{'address'} ? 0 : 1;
print $self->ui_table_row($self->{'text_hash'}->{'pop3_addr'},
		$self->ui_radio('addr_def', $self->{'addr_def'},
			[ [ 1, $self->{'text_hash'}->{'pop3_addr0'} ],
			[ 0, $self->{'text_hash'}->{'pop3_addr1'} ] ]) . "\n" .
		$self->ui_textbox('addr', $self->{'addr_def'} ? "" : $self->{'address'}, 15),
		undef,
		['width=50%']);
		
# Port to listen on for connections
$self->{'port'} = $self->{'ssl'} ? $self->get_value('SSLPORT', $self->{'conf'}) : $self->get_value('PORT', $self->{'conf'});
print $self->ui_table_row($self->{'text_hash'}->{'pop3_port'},
		$self->ui_textbox('port', $self->{'port'}, 5));

# Maximum number of POP3 servers started
$self->{'maxd'} = $self->get_value('MAXDAEMONS', $self->{'conf'});
$self->{'maxd_def'} = $self->get_value('MAXDAEMONS', $self->{'conf2'});
print $self->ui_table_row($self->{'text_hash'}->{'pop3_maxd'},
		$self->default_text_input('maxd', $self->{'maxd'}, $self->{'ssl'} ? $self->text('index_defvalue', $self->{'maxd_def'}) : $self->{'text_hash'}->{'index_default'}, 5));

# Maximum number of connections to accept from the same IP address
$self->{'maxip'} = $self->get_value('MAXPERIP', $self->{'conf'});
$self->{'maxip_def'} = $self->get_value('MAXPERIP', $self->{'conf2'});
print $self->ui_table_row($self->{'text_hash'}->{'pop3_maxip'},
		$self->default_text_input('maxip', $self->{'maxip'}, $self->{'ssl'} ? $self->text('index_defvalue', $self->{'maxip_def'}) : $self->{'text_hash'}->{'index_default'}, 5));

# Maildir directory name
$self->{'maildir'} = $self->get_value('MAILDIRPATH', $self->{'conf'});
$self->{'maildir_def'} = $self->get_value('MAILDIRPATH', $self->{'conf2'});
print $self->ui_table_row($self->{'text_hash'}->{'pop3_maildir'},
		$self->default_text_input('maildir', $self->{'maildir'}, $self->{'ssl'} ? $self->text('index_defvalue', $self->{'maildir_def'}) : $self->{'text_hash'}->{'index_default'}, 15));

unless ($self->{'ssl'}) {
# To advertise the SASL capability
$self->{'auth'} = $self->get_real_value('IMAP_CAPABILITY', $self->{'conf'});
@{$self->{'auth_array'}} = split(/\s+/, $self->{'auth'});
$self->{'auth_orig'} = $self->get_value('IMAP_CAPABILITY_ORIG', $self->{'conf'}) || $self->get_value('IMAP_CAPABILITY_ORIG', $self->{'conf2'});
@{$self->{'auth_meth_array'}} = split(/\s+/, $self->{'auth_orig'});
print $self->ui_table_row($self->{'text_hash'}->{'pop3_auth'},
		$self->ui_select('auth', \@{$self->{'auth_array'}}, [ map { [$_] } @{$self->{'auth_meth_array'}} ], scalar(@{$self->{'auth_mech_array'}}), 1));

# Sets to disable the THREAD and SORT commands.
$self->{'threadsort'} = $self->get_value('IMAP_DISABLETHREADSORT', $self->{'conf'});
print print $self->ui_table_row($self->{'text_hash'}->{'imap_threadsort'},
		$self->ui_yesno_radio('threadsort', $self->{'threadsort'}));

# This setting controls how often
# the server polls for changes to the folder, in IDLE mode (in seconds).
# IMAP_IDLE_TIMEOUT=60

# Sets the server to check for new mail in every folder.
$self->{'checkfolders'} = $self->get_real_value('IMAP_CHECK_ALL_FOLDERS', $self->{'conf'});
print print $self->ui_table_row($self->{'text_hash'}->{'imap_checkfolders'},
		$self->ui_yesno_radio('checkfolders', $self->{'checkfolders'}));

# Sets the maximum size of the data segment of the server process.
$self->{'ulimit'} = $self->get_value('IMAP_ULIMITD', $self->{'conf'});
print $self->ui_table_row($self->{'text_hash'}->{'imap_ulimit'},
		$self->ui_bytesbox('ulimit', $self->{'ulimit'}));

# IMAP_SHAREDINDEXFILE
# IMAP_ENHANCEDIDLE

# The name of the magic trash Folder.
$self->{'trash'} = $self->get_value('IMAP_TRASHFOLDERNAME', $self->{'conf'});
print $self->ui_table_row($self->{'text_hash'}->{'imap_trash'},
		$self->ui_textbox('trash', $self->{'trash'}, 15));

# IMAP_EMPTYTRASH
# OUTBOX

# The return address, $SENDER will also be saved in the X-IMAP-Sender mail header.
# HEADERFROM=X-IMAP-Sender

# Sets to support concurrent multiple access to the same folder. 
$self->{'uselocks'} = $self->get_value('IMAP_USELOCKS', $self->{'conf'});
print print $self->ui_table_row($self->{'text_hash'}->{'imap_uselocks'},
		$self->ui_yesno_radio('uselocks', $self->{'uselocks'}));

}

print $self->ui_table_end();

print "<hr>";

if ($self->{'ssl'}) {
# POP3 SSL Options
print $self->ui_table_start($self->{'text_hash'}->{'pop3_header3'}, "width=100%", 2);

# TSL Protocol
$self->{'protocol'} = $self->get_real_value('TLS_PROTOCOL', $self->{'conf'});
print $self->ui_table_row($self->{'text_hash'}->{'pop3_tlsprot'},
		$self->ui_select('protocol', $self->{'protocol'}, [ map { [$_] } @{$self->{'tls_protocols_list_array'}} ]),
		undef,
		['width=50%']);

# Certificate file path
$self->{'cert'} = $self->get_value('TLS_CERTFILE', $self->{'conf'});
print $self->ui_table_row($self->{'text_hash'}->{'pop3_cert'},
		$self->ui_textbox('cert', $self->{'cert'}, 30));

# Trusted Certificate file path / directory
$self->{'trust'} = $self->get_value('TLS_TRUSTCERTS', $self->{'conf'});
print $self->ui_table_row($self->{'text_hash'}->{'pop3_trust'},
		$self->ui_textbox('trust', $self->{'trust'}, 30));

# Verify client certificates
$self->{'vpeer'} = $self->get_real_value('TLS_VERIFYPEER', $self->{'conf'});
print $self->ui_table_row($self->{'text_hash'}->{'pop3_vpeer'},
		$self->ui_select('vpeer', $self->{'vpeer'}, [ map { [$_] } @{$self->{'verifypeer_list_array'}} ]));

# TLS cache file name
$self->{'cache'} = $self->get_value('TLS_CACHEFILE', $self->{'conf'});
print $self->ui_table_row($self->{'text_hash'}->{'pop3_cache'},
		$self->ui_textbox('cache', $self->{'cache'}, 30));

# TLS cache file size
$self->{'cachesize'} = $self->get_value('TLS_CACHESIZE', $self->{'conf'});
print $self->ui_table_row($self->{'text_hash'}->{'pop3_cachesize'},
		$self->ui_bytesbox('cachesize', $self->{'cachesize'}));

print $self->ui_table_end();
}
else {
# IMAP STLS extension
print $self->ui_table_start($self->{'text_hash'}->{'pop3_header2'}, "width=100%", 2);

$self->{'tlsext'} = $self->get_real_value('IMAPDSTARTTLS', $self->{'conf2'});
print print $self->ui_table_row($self->{'text_hash'}->{'pop3_tlsstart'},
		$self->ui_yesno_radio('tlsstart', $self->bool_to_int($self->{'tlsext'})),
		undef,
		['width=50%']);
		
# TSL Protocol
$self->{'protocol'} = $self->get_real_value('TLS_STARTTLS_PROTOCOL', $self->{'conf2'});
print $self->ui_table_row($self->{'text_hash'}->{'pop3_tlsprot'},
		$self->ui_select('protocol', $self->{'protocol'}, [ map { [$_] } @{$self->{'tls_protocols_list_array'}} ]));

# SASL capability for enable SSL
$self->{'authtls'} = $self->get_real_value('IMAP_CAPABILITY_TLS', $self->{'conf'});
@{$self->{'authtls_array'}} = split(/\s+/, $self->{'authtls'});
$self->{'authtls_orig'} = $self->get_real_value('IMAP_CAPABILITY_TLS_ORIG', $self->{'conf'}) || $self->get_real_value('IMAP_CAPABILITY_TLS_ORIG', $self->{'conf2'});
@{$self->{'authtls_meth_array'}} = split(/\s+/, $self->{'authtls_orig'});
print $self->ui_table_row($self->{'text_hash'}->{'pop3_authtls'},
		$self->ui_select('authtls', \@{$self->{'authtls_array'}}, [ map { [$_] } @{$self->{'authtls_meth_array'}} ], scalar(@{$self->{'authtls_mech_array'}}), 1));

print $self->ui_table_end();
}

print $self->ui_form_end([ [ "save", $self->{'text_hash'}->{'save'} ] ]);

# Shows edit manual button
if ($self->{'access_hash'}->{'edit_manual'}) {
	print "<hr>\n";
	print $self->ui_buttons_start();
	print $self->ui_buttons_row("edit_manual.cgi", $self->{'text_hash'}->{'edit_manual'},
			      $self->text('edit_manualdesc', $name), $self->ui_hidden('dmn', $self->{'dmn'}));
	print $self->ui_buttons_end();
}

# Shows start/stop and atboot buttons
print "<hr>\n";
print $self->ui_buttons_start();

local $name = $self->get_daemon_title($self->{'dmn'});
if ($self->is_daemon_running($self->{'dmn'})) {
	print $self->ui_buttons_row("apply.cgi", $self->text('edit_apply', $name),
			      $self->text('edit_applydesc', $name), $self->ui_hidden('dmn', $self->{'dmn'}));
	print $self->ui_buttons_row("stop.cgi", $self->text('edit_stop', $name),
			      $self->text('edit_stopdesc', $name), $self->ui_hidden('dmn', $self->{'dmn'}));
	}
else {
	print $self->ui_buttons_row("start.cgi", $self->text('edit_start', $name),
			      $self->text('edit_startdesc', $name), $self->ui_hidden('dmn', $self->{'dmn'}));
	}

if ($self->{'init_script'} = $self->get_daemon_init($self->{'dmn'})) {
	print $self->ui_buttons_hr();
	$self->foreign_require("init", "init-lib.pl");
	$self->{'atboot'} = $main::init_object->action_status($self->{'init_script'});
	print $self->ui_buttons_row("bootup.cgi", $self->{'text_hash'}->{'index_boot'},
			      $self->text('index_bootdesc2', $name), $self->ui_hidden('dmn', $self->{'dmn'}) . $self->ui_hidden('edit', 1),
			      $self->ui_radio("boot", $self->{'atboot'} == 2 ? 1 : 0,
					[ [ 1, $self->{'text_hash'}->{'yes'} ],
					  [ 0, $self->{'text_hash'}->{'no'} ] ]));
	}
print $self->ui_buttons_end();

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

