#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Shows feature icons what allow to edit daemons options and SSL certificates

&ModuleLoader::preload_module('courier_imap_class', "courier_imap::CourierimapLib");
$self = new courier_imap::CourierimapLib:: 'courier_imap_class',%$self;

$self->ReadParse();
%{$self->{'access_hash'}} = $self->get_module_acl();

$self->{'ver'} = $self->get_courier_version();
$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", undef, 1, 1, 0,
		 $self->help_search_link("courier", "man", "doc", "google"),
		 undef, undef,
		 $self->{'ver'} ? $self->text('index_version', $self->{'ver'}) : undef);

# Checks for config files
local $dmn;
local $noconfig = undef;
local @daemons = $self->get_used_daemons();
foreach $dmn (@daemons) {
	local $cfile = $self->get_daemon_config_file($dmn);
	if (! -r $cfile) {
		print $self->ui_config_link('index_econf', [ "<tt>$cfile</tt>", undef, $self->get_daemon_title($dmn) ]),"<p>\n";
		$noconfig++;
	}
}
local $noexec = undef;
foreach $dmn (@daemons) {
	local $execfile = $self->get_daemon_exec_file($dmn);
	if (! -x $execfile) {
		print $self->ui_config_link('index_eexec', [ "<tt>$execfile</tt>", undef, $self->get_daemon_title($dmn) ]),"<p>\n";
		$noexec++;
	}
}
if ($noconfig || $noexec) {
	$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});
	exit;
}

# Show icons for page features
@{$self->{'pages_array'}} = ( "pop3", "pop3ssl", "imap", "imapssl", "authlib", "certpop3", "certimap");
@{$self->{'titles_array'}} = map { $self->{'text_hash'}->{$_."_title"} } @{$self->{'pages_array'}};
@{$self->{'icons_array'}} = map { "images/".$_.".gif" } @{$self->{'pages_array'}};
@{$self->{'links_array'}} = (
	$self->get_daemon_edit_link('pop3'),
	$self->get_daemon_edit_link('pop3ssl'),
	$self->get_daemon_edit_link('imap'),
	$self->get_daemon_edit_link('imapssl'),
	'edit_authlib.cgi',
	'edit_cert.cgi?dmn=pop3', 'edit_cert.cgi?dmn=imap'
	);
# @{$self->{'links_array'}} = map { "edit_".$_.".cgi" } @{$self->{'pages_array'}};
$self->icons_table(\@{$self->{'links_array'}}, \@{$self->{'titles_array'}}, \@{$self->{'icons_array'}});

# Show start/stop and atboot buttons
print "<hr>\n";
print $self->ui_buttons_start();

if ($self->are_used_daemons_running()) {
	print $self->ui_buttons_row("apply.cgi", $self->{'text_hash'}->{'index_apply'},
			      $self->{'text_hash'}->{'index_applydesc'});
	print $self->ui_buttons_row("stop.cgi", $self->{'text_hash'}->{'index_stop'},
			      $self->{'text_hash'}->{'index_stopdesc'});
	}
else {
	print $self->ui_buttons_row("start.cgi", $self->{'text_hash'}->{'index_start'},
			      $self->{'text_hash'}->{'index_startdesc'});
	}

@{$self->{'used_daemons_array'}} = $self->get_used_daemons();
if (scalar(@{$self->{'used_daemons_array'}}) == 1 && ($self->{'daemon'} = $self->{'used_daemons_array'}->[0]) && ($self->{'init_script'} = $self->get_daemon_init($self->{'daemon'}))) {
	print $self->ui_buttons_hr();
	$self->foreign_require("init", "init-lib.pl");
	$self->{'atboot'} = $main::init_object->action_status($self->{'init_script'});
	print $self->ui_buttons_row("bootup.cgi", $self->{'text_hash'}->{'index_boot'},
			      $self->{'text_hash'}->{'index_bootdesc'}, $self->ui_hidden('dmn', $self->{'daemon'}),
			      $self->ui_radio("boot", $self->{'atboot'} == 2 ? 1 : 0,
					[ [ 1, $self->{'text_hash'}->{'yes'} ],
					  [ 0, $self->{'text_hash'}->{'no'} ] ]));
	}

print $self->ui_buttons_end();

if ($self->{'text_hash'}->{'index_mainpage_url'} && $self->{'text_hash'}->{'index_mainpage'}) {
	$self->ui_print_footer($self->{'text_hash'}->{'index_mainpage_url'}, $self->{'text_hash'}->{'index_mainpage'});
}
else {
	$self->ui_print_footer();
}
1;
		
}


1;

