#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Generates new self-signed SSL certificate.
# Installs new CA SSL certificate.

&ModuleLoader::preload_module('courier_imap_class', "courier_imap::CourierimapLib");
$self = new courier_imap::CourierimapLib:: 'courier_imap_class',%$self;

$self->ReadParse();

$self->{'dmn'} = $self->{'in_hash'}->{'dmn'};
$self->{'dmn'} eq 'imap' || $self->{'dmn'} eq 'pop3' || $self->error($self->{'text_hash'}->{'pop3_ein'});

$self->{'pop3'} = $self->{'dmn'} eq 'pop3';

$self->{'certfile'} = $self->get_certificate_file($self->{'dmn'});
if ($self->{'in_hash'}->{'gencert'}) {
	$self->error_setup($self->{'text_hash'}->{'gencert_err'});
	local $err = $self->generate_certificate($self->{'dmn'});
	$self->error($err) if ($err);
	$self->webmin_log("gencert", $self->{'in_hash'}->{'dmn'});
	$self->redirect("edit_cert.cgi?dmn=$self->{'in_hash'}->{'dmn'}");
}
elsif ($self->{'in_hash'}->{'install'}) {
	$self->error_setup($self->{'text_hash'}->{'newkey_err'});
	$self->{'in_hash'}->{'cert'} =~ /BEGIN CERTIFICATE/ && $self->{'in_hash'}->{'cert'} =~ /END CERTIFICATE/ || $self->error($self->{'text_hash'}->{'newkey_ecert'});
	$self->{'in_hash'}->{'newkey'} =~ /BEGIN RSA PRIVATE KEY/ && $self->{'in_hash'}->{'newkey'} =~ /END RSA PRIVATE KEY/ || $self->error($self->{'text_hash'}->{'newkey_ekey'});
	$self->copy_source_dest($self->{'certfile'}, "$self->{'certfile'}.backup");
	$self->{'in_hash'}->{'cert'} =~ s/\r//g;
	$self->{'in_hash'}->{'newkey'} =~ s/\r//g;
	$self->lock_file($self->{'certfile'});
# 	unlink($d->{'ssl_key'});
	$self->open_tempfile(CERT, ">$self->{'certfile'}");
	$self->print_tempfile(CERT, $self->{'in_hash'}->{'newkey'});
	$self->print_tempfile(CERT, $self->{'in_hash'}->{'cert'});
	$self->close_tempfile(CERT);
	$self->unlock_file($self->{'certfile'});
	$self->redirect("edit_cert.cgi?dmn=$self->{'in_hash'}->{'dmn'}");
}
else {
	$self->error("Invalid command!");
}
1;
		
}


1;

