#!/usr/bin/perl

&MAIN();

 sub MAIN {
# cpan.cgi
# Display known perl modules and categories

&ModuleLoader::preload_module('cpan_class', "cpan::CpanLib");
$self = new cpan::CpanLib:: 'cpan_class',%$self;

$self->ReadParse();

# re-fetch modules list if non-existant or it timeout has expired
@{$self->{'st_array'}} = $self->{'packages_file'};
$self->{'now'} = time();
if (!-r $self->{'packages_file'} ||
    $self->{'st_array'}->[9]+$self->{'config_hash'}->{'refresh_days'}*24*60*60 < $self->{'now'}) {
	$self->download_packages_file();
	}

# Read the modules list
open(LIST, "gunzip -c $self->{'packages_file'} |");
while(<LIST>) {
	s/\r|\n//g;
	if ($_ eq '') { $self->{'found_blank'}++; }
	elsif ($self->{'found_blank'} && /^(\S+)\s+(\S+)\s+(.*)/) {
		#next if ($donefile{$3}++);
		$self->{'mod'} = $1; $self->{'ver'} = $2;
		next if ($self->{'mod'} eq 'about');
		local @mod = split(/::/, $self->{'mod'});
		if (@mod > 1) {
			local @cat = @mod[0 .. $#mod-1];
			if (!$self->{'donecat_hash'}->{join("::", @cat)}++) {
				push(@{$self->{'mods_array'}}, { 'name' => \@cat,
					      'cat' => 1 } );
				}
			}
		push(@{$self->{'mods_array'}}, { 'name' => \@mod,
			      'full' => $self->{'mod'},
			      'ver' => $self->{'ver'} eq 'undef' ? '' : $self->{'ver'} } );
		}
	}
close(LIST);

# Display the current level of modules
$self->{'bgcolor'} = defined($self->{'gconfig_hash'}->{'cs_page'}) ? $self->{'gconfig_hash'}->{'cs_page'} : "ffffff";
$self->{'link'} = defined($self->{'gconfig_hash'}->{'cs_link'}) ? $self->{'gconfig_hash'}->{'cs_link'} : "0000ee";
$self->{'text'} = defined($self->{'gconfig_hash'}->{'cs_text'}) ? $self->{'gconfig_hash'}->{'cs_text'} : "000000";
@{$self->{'sel_array'}} = split(/\0/, $self->{'in_hash'}->{'sel'});
$self->PrintHeader();
print <<EOF;
<html>
<head><title>$self->{'text_hash'}->{'cpan_title'}</title>
<script>
function sel(m)
{
window.opener.ifield.value = m;
window.close();
return false;
}
</script>
</head><body bgcolor=#$self->{'bgcolor'} link=#$self->{'link'} vlink=#$self->{'link'} text=#$self->{'text'}>
EOF
if ($self->{'in_hash'}->{'search'}) {
	# Search for modules matching some name
	print "<b>",$self->text('cpan_match', "<tt>$self->{'in_hash'}->{'search'}</tt>"),"</b><p>\n";
	print "<table width=100% cellpadding=1 cellspacing=1>\n";
	foreach $m (@{$self->{'mods_array'}}) {
		if (!$m->{'cat'} && $m->{'full'} =~ /$self->{'in_hash'}->{'search'}/i) {
			$self->{'name'} = join("::",@{$m->{'name'}});
			print "<tr>\n";
			print "<td><a href='' onClick='sel(\"$self->{'name'}\")'><img src=images/mod.gif border=0></a></td>\n";
			print "<td><a href='' onClick='sel(\"$self->{'name'}\")'>",
				$self->html_escape($self->{'name'}),"</a></td>\n";
			print "<td align=right>",$self->html_escape($m->{'ver'}),"</td>\n";
			print "</tr>\n";
			$self->{'matches'}++;
			}
		}
	print "</table>\n";
	print "$self->{'text_hash'}->{'cpan_none'}<br>\n" if (!$self->{'matches'});
	}
else {
	# Show module tree
	if (@{$self->{'sel_array'}}) {
		print "<b>",$self->text('cpan_sel', join("::",@{$self->{'sel_array'}})),"</b><p>\n";
		}
	else {
		# Show search form
		print "<form action=cpan.cgi>\n";
		print "<input type=submit value='$self->{'text_hash'}->{'cpan_search'}'>\n";
		print "<input name=search size=15></form>\n";
		}
	print "<table width=100% cellpadding=1 cellspacing=1>\n";
	if (@{$self->{'sel_array'}}) {
		local @up = @{$self->{'sel_array'}}[0..$#{$self->{'sel_array'}}-1];
		print "<tr>\n";
		print "<td><a href='cpan.cgi?",join("&",map { "sel=$_" } @up),"#",join("::",@{$self->{'sel_array'}}),"'><img src=images/cat.gif border=0></a></td>\n";
		print "<td><a href='cpan.cgi?",join("&",map { "sel=$_" } @up),"#",join("::",@{$self->{'sel_array'}}),"'>..</a></td>\n";
		print "</tr>\n";
		}
	MOD: foreach $m (@{$self->{'mods_array'}}) {
		for($i=0; $i<@{$self->{'sel_array'}}; $i++) {
			next MOD if ($self->{'sel_array'}->[$i] ne $m->{'name'}->[$i]);
			}
		next if (scalar(@{$self->{'sel_array'}}) != scalar(@{$m->{'name'}}-1));
		$self->{'name'} = join("::",@{$m->{'name'}});
		$self->{'pars'} = join("&",map { "sel=$_" } @{$m->{'name'}});
		print "<tr>\n";
		if ($m->{'cat'}) {
			print "<td><a name=$self->{'name'}><a href='cpan.cgi?$self->{'pars'}'><img src=images/cat.gif border=0></a></td>\n";
			print "<td><a href='cpan.cgi?$self->{'pars'}'>",$self->html_escape($self->{'name'}),"</a></td>\n";
			}
		else {
			print "<td><a href='' onClick='sel(\"$self->{'name'}\")'><img src=images/mod.gif border=0></a></td>\n";
			print "<td><a href='' onClick='sel(\"$self->{'name'}\")'>",$self->html_escape($self->{'name'}),"</a></td>\n";
			print "<td align=right>",$self->html_escape($m->{'ver'}),"</td>\n";
			}
		print "</tr>\n";
		}
	}
print "</table>\n";
print "</body></html>\n";

1;
		
}


1;

