#!/usr/bin/perl

&MAIN();

 sub MAIN {
# download.cgi
# Get a perl module from somewhere

&ModuleLoader::preload_module('cpan_class', "cpan::CpanLib");
$self = new cpan::CpanLib:: 'cpan_class',%$self;

%{$self->{'access_hash'}} = $self->get_module_acl();
$self->{'access_hash'}->{'download'} || $self->error($self->{'text_hash'}->{'download_ecannot'});

if ($ENV{REQUEST_METHOD} eq "POST") { $self->ReadParseMime(); }
else { $self->ReadParse(); $self->{'no_upload'} = 1; }
$self->error_setup($self->{'text_hash'}->{'download_err'});

if ($self->{'in_hash'}->{'source'} >= 2) {
	$self->ui_print_unbuffered_header(undef, $self->{'text_hash'}->{'download_title'}, "");
	}
else {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'download_title'}, "");
	}

$self->tempname();
if ($self->{'in_hash'}->{'source'} == 0) {
	# installing from local file (or maybe directory)
	if (!$self->{'in_hash'}->{'local'})
		{ &install_error($self->{'text_hash'}->{'download_elocal'}); }
	if (!-r $self->{'in_hash'}->{'local'})
		{ &install_error($self->text('download_elocal2', $self->{'in_hash'}->{'local'})); }
	$source = $self->{'in_hash'}->{'local'};
	@pfile = ( $self->{'in_hash'}->{'local'} );
	$self->{'need_unlink'} = 0;
	}
elsif ($self->{'in_hash'}->{'source'} == 1) {
	# installing from upload .. store file in temp location
	if ($self->{'no_upload'}) {
		&install_error($self->{'text_hash'}->{'download_eupload'});
		}
	$self->{'in_hash'}->{'upload_filename'} =~ /([^\/\\]+$)/;
	@pfile = ( $self->tempname("$1") );
	open(PFILE, ">$pfile[0]");
	print PFILE $self->{'in_hash'}->{'upload'};
	close(PFILE);
	$source = $self->{'in_hash'}->{'upload_filename'};
	$self->{'need_unlink'} = 1;
	}
elsif ($self->{'in_hash'}->{'source'} == 2) {
	# installing from URL.. store downloaded file in temp location
	$self->{'in_hash'}->{'url'} =~ /\/([^\/]+)\/*$/;
	@pfile = ( $self->tempname("$1") );
	$self->{'progress_callback_url'} = $self->{'in_hash'}->{'url'};
	if ($self->{'in_hash'}->{'url'} =~ /^(http|https):\/\/([^\/]+)(\/.*)$/) {
		# Make a HTTP request
		$self->{'ssl'} = $1 eq 'https';
		$self->{'host'} = $2; $self->{'page'} = $3; $self->{'port'} = $self->{'ssl'} ? 443 : 80;
		if ($self->{'host'} =~ /^(.*):(\d+)$/) { $self->{'host'} = $1; $self->{'port'} = $2; }
		$self->http_download($self->{'host'}, $self->{'port'}, $self->{'page'}, $pfile[0], \$self->{'error'},
			       'progress_callback', $self->{'ssl'});
		}
	elsif ($self->{'in_hash'}->{'url'} =~ /^ftp:\/\/([^\/]+)(:21)?(\/.*)$/) {
		$self->{'host'} = $1; $self->{'file'} = $3;
		$self->ftp_download($self->{'host'}, $self->{'file'}, $pfile[0], \$self->{'error'},
			      'progress_callback');
		}
	else { &install_error($self->text('download_eurl', $self->{'in_hash'}->{'url'})); }
	&install_error($self->{'error'}) if ($self->{'error'});
	$source = $self->{'in_hash'}->{'url'};
	$self->{'need_unlink'} = 1;
	}
elsif ($self->{'in_hash'}->{'source'} == 3) {
	# installing from CPAN.. find the module, and then install it
	$self->{'in_hash'}->{'cpan'} || $self->error($self->{'text_hash'}->{'download_emodname'});
	@{$self->{'cpan_array'}} = split(/\s+|\0/, $self->{'in_hash'}->{'cpan'});

	# First check if YUM or APT can install this module for us
	@yum = $self->list_packaged_modules();
	foreach $c (@{$self->{'cpan_array'}}) {
		($yum) = grep { lc($_->{'mod'}) eq lc($c) } @yum;
		push(@{$self->{'cpanyum_array'}}, $yum) if ($yum);
		}
	if (scalar(@{$self->{'cpan_array'}}) == scalar(@{$self->{'cpanyum_array'}})) {
		# Can install from YUM or APT .. do it!
		$i = 0;
		foreach $yum (@{$self->{'cpanyum_array'}}) {
			print $self->text('download_yum', "<tt>$self->{'cpan_array'}->[$i]</tt>",
				    "<tt>$yum->{'package'}</tt>"),"<br>\n";
			print "<ul>\n";
			$main::software_object->update_system_install($yum->{'package'});
			print "</ul>\n";
			$i++;
			}
		$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
		exit;
		}

	$self->{'progress_callback_url'} = $self->{'config_hash'}->{'packages'};
	if (!-r $self->{'packages_file'} || $self->{'in_hash'}->{'refresh'}) {
		# Need to download the modules list from CPAN first
		$self->download_packages_file('progress_callback');
		print "<p>\n";

		# Make sure it is valid
		open(PFILE, $self->{'packages_file'});
		read(PFILE, $self->{'two'}, 2);
		close(PFILE);
		if ($self->{'two'} ne "\037\213") {
			&install_error($self->text('download_ecpangz',
					 "<tt>$self->{'config_hash'}->{'packages'}</tt>"));
			}
		}

	# Find each module in the modules list
	open(LIST, "gunzip -c $self->{'packages_file'} |");
	while(<LIST>) {
		s/\r|\n//g;
		if ($_ eq '') { $self->{'found_blank'}++; }
		elsif ($self->{'found_blank'} && /^(\S+)\s+(\S+)\s+(.*)/) {
			local $i = $self->indexof($1, @{$self->{'cpan_array'}});
			if ($i >= 0 && !$self->{'source_array'}->[$i]) {
				$self->{'source_array'}->[$i] = "$self->{'config_hash'}->{'cpan'}/$3";
				$self->{'source_array'}->[$i] =~ /\/perl-[0-9\.]+\.tar\.gz$/ &&
				    &install_error($self->text('download_eisperl',
						"<tt>$self->{'in_hash'}->{'cpan'}</tt>"));
				$self->{'sourcec'}++;
				}
			}
		}
	close(LIST);
	for($i=0; $i<@{$self->{'cpan_array'}}; $i++) {
		push(@{$self->{'missing_array'}}, "<tt>$self->{'cpan_array'}->[$i]</tt>") if (!$self->{'source_array'}->[$i]);
		}
	&install_error($self->text('download_ecpan', join(" ", @{$self->{'missing_array'}})))
		if (@{$self->{'missing_array'}});
	$source = join("<br>", @{$self->{'source_array'}});

	# Download the actual modules
	foreach $m (@{$self->{'source_array'}}) {
		$m =~ /\/([^\/]+)\/*$/;
		$pfile = $self->tempname("$1");
		$self->{'progress_callback_url'} = $m;
		if ($m =~ /^http:\/\/([^\/]+)(\/.*)$/) {
			# Make a HTTP request
			$self->{'host'} = $1; $self->{'page'} = $2; $self->{'port'} = 80;
			if ($self->{'host'} =~ /^(.*):(\d+)$/) { $self->{'host'} = $1; $self->{'port'} = $2; }
			$self->http_download($self->{'host'}, $self->{'port'}, $self->{'page'}, $pfile, \$self->{'error'},
				       'progress_callback');
			}
		elsif ($m =~ /^ftp:\/\/([^\/]+)(:21)?(\/.*)$/) {
			$self->{'host'} = $1; $self->{'file'} = $3;
			$self->ftp_download($self->{'host'}, $self->{'file'}, $pfile, \$self->{'error'},
				      'progress_callback');
			}
		else { &install_error($self->text('download_eurl', $m)); }
		&install_error($self->{'error'}) if ($self->{'error'});
		push(@pfile, $pfile);
		}
	$self->{'need_unlink'} = 1;
	}

# XXX fix rest of pfile refererences
# XXX pass on to next CGI

# Check if the file looks like a perl module
foreach $pfile (@pfile) {
	open(TAR, "( gunzip -c $pfile | tar tf - ) 2>&1 |");
	while($self->{'line'} = <TAR>) {
		if ($self->{'line'} =~ /^\.\/([^\/]+)\/(.*)$/ ||
		    $self->{'line'} =~ /^([^\/]+)\/(.*)$/) {
			if (!$self->{'dirs_hash'}->{$1}) {
				$self->{'dirs_hash'}->{$1} = $pfile;
				push(@{$self->{'dirs_array'}}, $1);
				}
			$self->{'file_hash'}->{$2}++;
			}
		$self->{'tar'} .= $self->{'line'};
		}
	close(TAR);
	if ($?) {
		unlink(@pfile) if ($self->{'need_unlink'});
		&install_error($self->text('download_etar', "<tt>$self->{'tar'}</tt>"));
		}
	}
if (@{$self->{'dirs_array'}} == 0 || $self->{'file_hash'}->{'Makefile.PL'}+$self->{'file_hash'}->{'Build.PL'} < @{$self->{'dirs_array'}}) {
	# Not all files were Perl modules
	unlink(@pfile) if ($self->{'need_unlink'});
	&install_error($self->{'text_hash'}->{'download_emod'});
	}
if ($self->{'file_hash'}->{'Build.PL'} && $self->{'file_hash'}->{'Makefile.PL'} < @{$self->{'dirs_array'}}) {
	# Make sure we have Module::Build if using Build.PL
	eval "use Module::Build";
	if ($@) {
		unlink(@pfile) if ($self->{'need_unlink'});
		&install_error($self->text('download_ebuild',
				     "<tt>Module::Build</tt>"));
		}
	}
foreach $d (@{$self->{'dirs_array'}}) {
	if ($d =~ /^(\S+)\-([0-9\.]+)$/) {
		push(@{$self->{'mods_array'}}, $1);
		push(@{$self->{'vers_array'}}, $2);
		}
	else {
		push(@{$self->{'mods_array'}}, $m);
		push(@{$self->{'vers_array'}}, undef);
		}
	$self->{'mods_array'}->[$#{$self->{'mods_array'}}] =~ s/-/::/g;
	}

# Extract all module files to look for depends
$self->{'mtemp'} = $self->tempname();
mkdir($self->{'mtemp'}, 0755);
foreach $d (@{$self->{'dirs_array'}}) {
	system("cd $self->{'mtemp'} ; gunzip -c $self->{'dirs_hash'}->{$d} | tar xf - >/dev/null");
	local $testargs;
	if ($d =~ /^Net_SSLeay/) {
		$testargs = $self->has_command("openssl");
		$testargs =~ s/\/bin\/openssl$//;
		}
	local $cmd = "cd $self->{'mtemp'}/$d ; $self->{'perl_path'} Makefile.PL $testargs --skip";
	if ($self->foreign_check("proc")) {
		# Run in a PTY, to handle CPAN prompting
		$self->foreign_require("proc", "proc-lib.pl");
		local ($fh, $fpid) = $main::proc_object->pty_process_exec($cmd);
		$self->sysprint($fh, "no\n");    # For CPAN manual config question
		while(<$fh>) {
			# Wait till it completes
			}
		close($fh);
		}
	else {
		system("$cmd >/dev/null 2>&1 </dev/null");
		}
	local @prereqs;
	open(MAKEFILE, "$self->{'mtemp'}/$d/Makefile");
	while(<MAKEFILE>) {
		last if /MakeMaker post_initialize section/;
		if (/^#\s+PREREQ_PM\s+=>\s+(.+)/) {
			local $prereq = $1;
			while($prereq =~ m/(?:\s)([\w\:]+)=>q\[.*?\],?/g) {
				push(@prereqs, $1);
				}
			}
		}
	close(MAKEFILE);
	push(@{$self->{'allreqs_array'}}, @prereqs);
	}
system("rm -rf $self->{'mtemp'}");

# Work out which pre-requesites are missing
@{$self->{'allreqs_array'}} = $self->unique(@{$self->{'allreqs_array'}});
%{$self->{'needreqs_hash'}} = map { eval "use $_"; $@ ? ($_, 1) : ($_, 0) } @{$self->{'allreqs_array'}};
foreach $m (@{$self->{'mods_array'}}) {
	# Don't need modules in tar files
	delete($self->{'needreqs_hash'}->{$m});
	}
foreach $c (@{$self->{'cpan_array'}}) {
	# Don't need modules we are getting from CPAN
	delete($self->{'needreqs_hash'}->{$c});
	}

# Display install options
print "<p><form action=install.cgi>\n";
print "<input type=hidden name=source value='$self->{'in_hash'}->{'source'}'>\n";
print "<input type=hidden name=need_unlink value='$self->{'need_unlink'}'>\n";
foreach $pfile (@pfile) {
	print "<input type=hidden name=pfile value='$pfile'>\n";
	}
foreach $m (@{$self->{'mods_array'}}) {
	print "<input type=hidden name=mod value='$m'>\n";
	}
foreach $v (@{$self->{'vers_array'}}) {
	print "<input type=hidden name=ver value='$v'>\n";
	}
foreach $d (@{$self->{'dirs_array'}}) {
	print "<input type=hidden name=dir value='$d'>\n";
	}
print "<input type=hidden name=return value='$self->{'in_hash'}->{'return'}'>\n";
print "<input type=hidden name=returndesc value='$self->{'in_hash'}->{'returndesc'}'>\n";

if (@{$self->{'allreqs_array'}}) {
	@{$self->{'needreqs_array'}} = grep { $self->{'needreqs_hash'}->{$_} } @{$self->{'allreqs_array'}};
	foreach $n (@{$self->{'needreqs_array'}}) {
		print "<input type=hidden name=needreq value='$n'>\n";
		}
	}

printf "<input type=hidden name=act value=%s>\n", $self->{'in_hash'}->{'act'} ne "" ? $self->{'in_hash'}->{'act'} : "3";

print "<input type=hidden name=args value=''>\n";
for($i=0; $i<4; $i++) {
	print "<input type=hidden name=name_$i value='' >\n";
	print "<input type=hidden name=value_$i value='' >\n";
	}

print "<input type=submit value='$self->{'text_hash'}->{'download_cont'}'>\n";
print "</form>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}

sub install_error
{
	shift if ($self == $_[0]);

print "<br><b>$self->{'whatfailed'} : $_[0]</b> <p>\n";
$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
exit;
}


1;

