#!/usr/bin/perl

&MAIN();

 sub MAIN {
# index.cgi
# Display installed perl modules and a form for installing new ones

&ModuleLoader::preload_module('cpan_class', "cpan::CpanLib");
$self = new cpan::CpanLib:: 'cpan_class',%$self;

$self->{'ver'} = join(".", map { ord($_) } split(//, $^V));
$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", undef, 1, 1, 0,undef, undef, undef, $self->text('index_pversion', $self->{'ver'}));

# read ACL
%{$self->{'access_hash'}}= $self->get_module_acl();

# Display perl modules
@{$self->{'mods_array'}} = $self->list_perl_modules();
if (@{$self->{'mods_array'}}) 
{
 @{$self->{'mods_array'}} = sort { lc($a->{'mods'}->[$a->{'master'}]) cmp lc($b->{'mods'}->[$b->{'master'}]) } @{$self->{'mods_array'}};
 local $ln = @{$self->{'mods_array'}}/2;
 local $i;
 foreach (@{$self->{'mods_array'}}) {
 	$i++;
 	if ($i > ($ln + 1)) { push (@{$self->{'mods2_array'}}, $_); }
	else { push (@{$self->{'mods1_array'}}, $_); }
 	}
 if ($self->{'access_hash'}->{'uninstall'})
 {
  print $self->ui_form_start("uninstall_mods.cgi", "post");
  print $self->select_all_link("d", 0),"\n";
  print $self->select_invert_link("d", 0),"<br>\n";
 }
 print "<table width=100% cellpadding=0 cellspacing=0>\n";
 print "<tr ><td $self->{'cb'} valign=top width=50>";
 @{$self->{'tds_array'}} = ( "width=5", undef, undef, undef, undef, "nowrap" );
 &print_modules(\@{$self->{'mods1_array'}});
 print "</td><td $self->{'cb'} valign=top width=50>";
 &print_modules(\@{$self->{'mods2_array'}});
 print "</td></tr>";
 print $self->ui_table_end();
 if ($self->{'access_hash'}->{'uninstall'})
 {
	print $self->select_all_link("d", 0),"\n";
	print $self->select_invert_link("d", 0),"<br>\n";
	print $self->ui_form_end([[ "delete", $self->{'text_hash'}->{'index_delete'} ],[ "upgrade", $self->{'text_hash'}->{'index_upgrade'} ]]);
 }
 print "<hr>\n";
}

if ($self->{'access_hash'}->{'install'}) 
{
 # Display install form
 print "$self->{'text_hash'}->{'index_installmsg'}<p>\n";
 print "<form action=download.cgi name=ch method=post enctype=multipart/form-data>\n";
 print "$self->{'text_hash'}->{'index_cpan'}\n";
 print "<input type=hidden name=source value=3 >\n";
 print "<input name=cpan size=40>\n";
 print "<input type=button onClick='name=\"ch\"; window.ifield = document.forms[name].cpan; chooser = window.open(\"cpan.cgi\", \"chooser\", \"toolbar=no,menubar=no,scrollbars=yes,width=400,height=300\")' value=\"...\">\n";
@{$self->{'st_array'}} = stat($self->{'packages_file'});
 print "<br><br>\n";
 print "<input type=submit value=\"$self->{'text_hash'}->{'index_installok'}\">\n";
 print "</form>\n";

 # Show button to install recommended Perl modules
 @{$self->{'allrecs_array'}} = $self->get_recommended_modules();
 @{$self->{'recs_array'}} = grep { eval "use $_->[0]"; $@ } @{$self->{'allrecs_array'}};
 if (@{$self->{'recs_array'}}) {
	print "<hr>\n";
	print $self->ui_form_start("download.cgi");
	print $self->ui_hidden("source", 3),"\n";
	print "$self->{'text_hash'}->{'index_recs'}<p>\n";
	print $self->ui_select("cpan", [ map { $_->[0] } @{$self->{'recs_array'}} ],
		 [ map { [ $_->[0], "$_->[0] ($_->[1]->{'desc'})" ] } @{$self->{'allrecs_array'}}],
		 5, 1),"<br>\n";
	print $self->ui_submit($self->{'text_hash'}->{'index_recsok'});
	print $self->ui_form_end();
	}
 elsif (@{$self->{'allrecs_array'}}) {
	print "<hr>\n";
	print $self->text('index_recsgot',"<tt>".join(" ", map { $_->[0] } @{$self->{'allrecs_array'}})."</tt>"),"<p>\n";
	}
}

$self->ui_print_footer("$self->{'text_hash'}->{'index_mainpage_url'}", $self->{'text_hash'}->{'index_mainpage'});

1;
		
}

# &print_modules(\@mods)
# print modules list
sub print_modules
{
	shift if ($self == $_[0]);

 unless ($self->{'access_hash'}->{'uninstall'}) {
 	print $self->ui_columns_start([ $self->{'text_hash'}->{'index_name'}, $self->{'text_hash'}->{'index_desc'}], 100, 0, \@{$self->{'tds_array'}});
	}
 else {
 	print $self->ui_columns_start([ "", $self->{'text_hash'}->{'index_name'}, $self->{'text_hash'}->{'index_desc'}], 100, 0, \@{$self->{'tds_array'}});
	}
 foreach my $m (@{$_[0]}) 
 {
	local $mi = $m->{'master'};
	local @cols;
	local $master = $m->{'mods'}->[$mi];
	local $name = $self->html_escape($master);
	if ($m->{'pkg'}) {
		$name = "<b>$name</b>";
		}
	push(@cols, "<a href='edit_mod.cgi?idx=$m->{'index'}&"."midx=$mi&name=$self->{'mod'}->{'name'}'>$name</a>");
	local ($desc, $ver) = $self->module_desc($m, $mi);
	push(@cols, $self->html_escape($desc));
	unless ($self->{'access_hash'}->{'uninstall'}) {
		print $self->ui_columns_row(\@cols, \@{$self->{'tds_array'}});
		}
	else {
		print $self->ui_checked_columns_row(\@cols, \@{$self->{'tds_array'}}, "d", $m->{'name'});
		}
 }
 print $self->ui_columns_end();
}


1;

