#!/usr/bin/perl

&MAIN();

 sub MAIN {
# install.cgi
# Install a downloaded perl module

&ModuleLoader::preload_module('cpan_class', "cpan::CpanLib");
$self = new cpan::CpanLib:: 'cpan_class',%$self;

%{$self->{'access_hash'}} = $self->get_module_acl();
$self->{'access_hash'}->{'install'} || $self->error($self->{'text_hash'}->{'install_ecannot'});
$self->ReadParse();
@pfile = split(/\0/, $self->{'in_hash'}->{'pfile'});

if ($self->{'in_hash'}->{'need'}) {
	# Some pre-reqs are needed .. return to the download form
	@{$self->{'cpan_array'}} = ( split(/\0/, $self->{'in_hash'}->{'needreq'}), split(/\0/, $self->{'in_hash'}->{'mod'}) );
	unlink(@pfile);		# will re-get
	$self->redirect("download.cgi?source=3&cpan=".$self->urlize(join(" ", @{$self->{'cpan_array'}})));
	}

foreach $pfile (@pfile) {
	-r $pfile || $self->error($self->text('install_efile', "<tt>$pfile</tt>"));
	}
$self->ui_print_unbuffered_header(undef, $self->{'text_hash'}->{'install_title'}, "");

# Set environment variables
for($i=0; defined($self->{'in_hash'}->{"name_$i"}); $i++) {
	if ($self->{'in_hash'}->{"name_$i"} ne "") {
		$ENV{$self->{'in_hash'}->{"name_$i"}} = $self->{'in_hash'}->{"value_$i"};
		}
	}

# Go through all the modules
@{$self->{'mods_array'}} = split(/\0/, $self->{'in_hash'}->{'mod'});
@{$self->{'dirs_array'}} = split(/\0/, $self->{'in_hash'}->{'dir'});
$self->{'perl_path'} = $self->get_perl_path();
for($i=0; $i<@{$self->{'mods_array'}}; $i++) {
	print $self->text('install_doing_'.$self->{'in_hash'}->{'act'}, "<tt>$self->{'mods_array'}->[$i]</tt>"),"<p>\n";

	# Untar the perl module
	$self->{'mod_dir'} = $self->transname($self->{'dirs_array'}->[$i]);
	($self->{'mod_par'} = $self->{'mod_dir'}) =~ s/\/[^\/]+$//;
	system("rm -rf $self->{'mod_dir'} >/dev/null 2>&1");
	&show_output($self->{'text_hash'}->{'install_untar'}, $self->{'mod_par'},
		     "gunzip -c $pfile[$i] | tar xvf -");

	if (-r "$self->{'mod_dir'}/Makefile.PL") {
		# Run Makefile.PL and make
		&show_output($self->{'text_hash'}->{'install_make'}, $self->{'mod_dir'},
			     "$self->{'perl_path'} Makefile.PL $self->{'in_hash'}->{'args'} && make") ||
			&build_error();

		# Run make test (if requested)
		if ($self->{'in_hash'}->{'act'} == 1 || $self->{'in_hash'}->{'act'} == 3) {
			&show_output($self->{'text_hash'}->{'install_test'}, $self->{'mod_dir'},
				     "make test") || &build_error();
			}

		# Run make install (if requested)
		if ($self->{'in_hash'}->{'act'} == 2 || $self->{'in_hash'}->{'act'} == 3) {
			&show_output($self->{'text_hash'}->{'install_install'}, $self->{'mod_dir'},
				     "make install") || &build_error();
			}
		}
	else {
		# Run Build.PL and Build
		&show_output($self->{'text_hash'}->{'install_make'}, $self->{'mod_dir'},
			     "$self->{'perl_path'} Build.PL $self->{'in_hash'}->{'args'} && ./Build") ||
			&build_error();

		# Run Build test (if requested)
		if ($self->{'in_hash'}->{'act'} == 1 || $self->{'in_hash'}->{'act'} == 3) {
			&show_output($self->{'text_hash'}->{'install_test'}, $self->{'mod_dir'},
				     "./Build test") || &build_error();
			}

		# Run Build install (if requested)
		if ($self->{'in_hash'}->{'act'} == 2 || $self->{'in_hash'}->{'act'} == 3) {
			&show_output($self->{'text_hash'}->{'install_install'}, $self->{'mod_dir'},
				     "./Build install") || &build_error();
			}
		}

	# Clean up files
	print "<p>",$self->text('install_done_'.$self->{'in_hash'}->{'act'}, "<tt>$self->{'mods_array'}->[$i]</tt>"),
	      "<p>\n";
	system("rm -rf $self->{'mod_dir'}") if ($self->{'mod_dir'} && -d $self->{'mod_dir'});
	}
&clean_up(1);

1;
		
}

# clean_up(success)
sub clean_up
{
	shift if ($self == $_[0]);

system("rm -rf $self->{'mod_dir'}") if ($self->{'mod_dir'} && -d $self->{'mod_dir'});
unlink(@pfile) if ($self->{'in_hash'}->{'need_unlink'} && (!$self->{'config_hash'}->{'save_partial'} || $_[0]));
if ($self->{'in_hash'}->{'return'}) {
	$self->ui_print_footer($self->{'in_hash'}->{'return'}, $self->{'in_hash'}->{'returndesc'});
	}
else {
	$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
	}
}

# show_output(desc, dir, command)
sub show_output
{
	shift if ($self == $_[0]);

local (%seen, $endless_loop);
print "<table border>\n";
print "<tr $self->{'tb'}> <td><b>$_[0]</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><pre>",$self->text('install_exec', $_[2]),"\n";
print " " x 100,"\n";
open(CMD, "(cd $_[1] ; $_[2]) 2>&1 </dev/null |");
while(<CMD>) {
	if ($seen{$_}++ > 100) {
		$endless_loop = 1;
		print "\n$self->{'text_hash'}->{'install_loop'}\n";
		last;
		}
	while(length($_) > 100) {
		s/^(.{100})//;
		print $self->html_escape($1),"\n";
		}
	print;
	}
close(CMD);
print "</pre></td></tr> </table><p>\n";
return $? || $endless_loop ? 0 : 1;
}

sub build_error
{
	shift if ($self == $_[0]);

print "<p>",$self->text('install_err', "<tt>$self->{'mods_array'}->[$i]</tt>"),"<br>\n";
if ($self->{'in_hash'}->{'source'} == 3) {
	print $self->text('install_err2', "<tt>perl -MCPAN -e shell</tt>"),"\n";
	}
print "<p>\n";
if ($self->{'in_hash'}->{'need_unlink'} && $self->{'config_hash'}->{'save_partial'}) {
	# File needs to be deleted
	print $self->text('install_needunlink',
		"delete_file.cgi?".
		join("&", map { "file=".$self->urlize($_) } @pfile)),"<p>\n";
	}
&clean_up(0);
exit;
}


1;

