#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Uninstall a bunch of perl module groups, after asking for confirmation 

&ModuleLoader::preload_module('cpan_class', "cpan::CpanLib");
$self = new cpan::CpanLib:: 'cpan_class',%$self;

$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'uninstalls_err'});
@d = split(/\0/, $self->{'in_hash'}->{'d'});
@d || $self->error($self->{'text_hash'}->{'uninstalls_enone'});

if ($self->{'in_hash'}->{'upgrade'}) {
	# Just redirect to the install page from CPAN
	$self->redirect("download.cgi?source=3&cpan=".
		  $self->urlize(join(" ", @d)));
	exit;
	}

# Get the modules
@{$self->{'allmods_array'}} = $self->list_perl_modules();
foreach $d (@d) {
	($mod) = grep { $_->{'name'} eq $d } @{$self->{'allmods_array'}};
	if ($mod) {
		push(@{$self->{'mods_array'}}, $mod);
		}
	}

if ($self->{'in_hash'}->{'confirm'}) {
	# Go ahead and do it
	foreach $mod (@{$self->{'mods_array'}}) {
		$self->{'err'} = $self->remove_module($mod);
		$self->error($self->text('uninstalls_emod', "<tt>$mod</tt>", $self->{'err'}))
			if ($self->{'err'});
		}
	$self->redirect("");
	}
else {
	# Ask the user if he is sure
	$self->ui_print_header(undef, $self->{'text_hash'}->{'uninstalls_title'}, "");

	print $self->ui_form_start("uninstall_mods.cgi", "post");
	foreach $d (@d) {
		print $self->ui_hidden("d", $d),"\n";
		}
	$self->{'mcount'} = 0;
	$self->{'fcount'} = 0;
	foreach $mod (@{$self->{'mods_array'}}) {
		$self->{'mcount'} += scalar(@{$mod->{'mods'}})-1;
		$self->{'fcount'} += scalar(@{$mod->{'packlist'}})+1;
		}
	print $self->text('uninstalls_rusure', scalar(@{$self->{'mods_array'}}), $self->{'mcount'}, $self->{'fcount'}),"\n";
	print "<center><input type=submit name=confirm ",
	      "value='$self->{'text_hash'}->{'uninstall_ok'}'></center></form>\n";

	$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
	}

1;
		
}


1;

