#!/usr/bin/perl
package cpplus::Backup_config;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'cpplus::Backup_config');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;

&ModuleLoader::preload_module(ref($self), "cpplus::CpplusLib");
$self = new cpplus::CpplusLib:: ref($self), %$self; 

1;

1;
		return $self;
}

# backup_config_files()
# Returns files and directories that can be backed up
sub backup_config_files
{
	my $self = shift;

$self->get_miniserv_config(\%{$self->{'miniserv_hash'}});
local @rv = ( "$self->{'config_directory'}/config",
	      "$self->{'config_directory'}/miniserv.conf",
	      "$self->{'config_directory'}/cpplus.cats",
	      "$self->{'config_directory'}/cpplus.catnames",
	      $self->{'miniserv_hash'}->{'keyfile'},
	      $self->{'miniserv_hash'}->{'certfile'},
	      $self->{'miniserv_hash'}->{'ca'},
	      $self->{'newmodule_users_file'},
	    );
return @rv;
}

# pre_backup(&files)
# Called before the files are actually read
sub pre_backup
{
	my $self = shift;

return undef;
}

# post_backup(&files)
# Called after the files are actually read
sub post_backup
{
	my $self = shift;

return undef;
}

# pre_restore(&files)
# Called before the files are restored from a backup
sub pre_restore
{
	my $self = shift;

# Get current configs, for later merging
$self->get_miniserv_config(\%{$self->{'oldminiserv_hash'}});
$self->read_file("$self->{'config_directory'}/config", \%{$self->{'oldconfig_hash'}});
return undef;
}

# post_restore(&files)
# Called after the files are restored from a backup
sub post_restore
{
	my $self = shift;

# Merge in local settings that cannot be copied
local %miniserv;
$self->get_miniserv_config(\%miniserv);
foreach my $k (keys %oldminiserv) {
	my $copy = 0;
	foreach my $keep ("root", "mimetypes", "logfile", "pidfile",
			  "env_WEBMIN_CONFIG", "env_WEBMIN_VAR", "logout",
			  "userfile", "passwd_.*") {
		$copy = 1 if ($k =~ /^$keep$/);
		}
	$miniserv{$k} = $oldminiserv{$k} if ($copy);
	}
$self->put_miniserv_config(\%miniserv);

local %gconfig;
$self->read_file("$self->{'config_directory'}/config", \%gconfig);
foreach my $k (keys %oldconfig) {
	my $copy = 0;
	foreach my $nocopy ("os_type", "os_version",
			    "real_os_type", "real_os_version",
			    "find_pid_command", "ld_env", "passwd_.*") {
		$copy = 1 if ($k =~ /^$keep$/);
		}
	$self->{'config_hash'}->{$k} = $oldconfig{$k} if ($copy);
	}
$self->write_file("$self->{'config_directory'}/config", \%gconfig);

unlink("$self->{'config_directory'}/module.infos.cache");
$self->restart_miniserv();
return undef;
}


1;

