#!/usr/bin/perl
package cpplus::CpplusLib;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'cpplus::CpplusLib');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# cpplus-lib.pl
# Common functions for configuring miniserv

&ModuleLoader::preload_module(ref($self), "WebLib");
$self = new WebLib:: ref($self), %$self; 
$self->init_config();
&ModuleLoader::preload_module(ref($self), "UiLib");
$self = new UiLib:: ref($self), %$self; 
use Socket;

@{$self->{'cs_codes_array'}} = ( 'cs_page', 'cs_text', 'cs_table', 'cs_header', 'cs_link' );
@{$self->{'cs_names_array'}} = map { $self->{'text_hash'}->{$_} } @{$self->{'cs_codes_array'}};

$self->{'osdn_host'} = "prdownloads.sourceforge.net";
$self->{'osdn_port'} = 80;

$self->{'update_host'} = "www.cpplus.info";
$self->{'update_port'} = 80;
$self->{'update_page'} = "/updates/updates.txt";
$self->{'update_url'} = "http://$update_host:$self->{'update_port'}$self->{'update_page'}";
$self->{'redirect_url'} = "http://$self->{'update_host'}/cgi-bin/redirect.cgi";

$self->{'webmin_key_email'} = "cpplus\@psoft.net";
$self->{'webmin_key_fingerprint'} = "7C2C B7DC 49BC 515D 1C6B C1EF B54E 900D 0A63 5547";

$self->{'standard_host'} = $self->{'update_host'};
$self->{'standard_port'} = $self->{'update_port'};
$self->{'standard_page'} = "/download/modules/standard.txt";
$self->{'standard_ssl'} = 0;

$self->{'third_host'} = $self->{'update_host'};
$self->{'third_port'} = $self->{'update_port'};
$self->{'third_page'} = "/cgi-bin/third.cgi";
$self->{'third_ssl'} = 0;

$self->{'default_key_size'} = "512";

$self->{'cron_cmd'} = "$self->{'module_config_directory'}/update.pl";

$self->{'os_info_address'} = "cpplus\@psoft.net";

$self->{'detect_operating_system_cache'} = "$self->{'module_config_directory'}/oscache";

$self->{'newmodule_users_file'} = "$self->{'config_directory'}/newmodules";

1;
1;
		return $self;
}

sub setup_ca
{
	my $self = shift;

local $adir = $self->module_root_directory("acl");
local $conf = `cat $adir/openssl.cnf`;
local $acl = "$self->{'config_directory'}/acl";
$conf =~ s/DIRECTORY/$acl/g;

$self->lock_file("$acl/openssl.cnf");
$self->open_tempfile(CONF, ">$acl/openssl.cnf");
$self->print_tempfile(CONF, $conf);
$self->close_tempfile(CONF);
chmod(0600, "$acl/openssl.cnf");
$self->unlock_file("$acl/openssl.cnf");

$self->lock_file("$acl/index.txt");
$self->open_tempfile(INDEX, ">$acl/index.txt");
$self->close_tempfile(INDEX);
chmod(0600, "$acl/index.txt");
$self->unlock_file("$acl/index.txt");

$self->lock_file("$acl/serial");
$self->open_tempfile(SERIAL, ">$acl/serial");
$self->print_tempfile(SERIAL, "011E\n");
$self->close_tempfile(SERIAL);
chmod(0600, "$acl/serial");
$self->unlock_file("$acl/serial");

$self->lock_file("$acl/newcerts");
mkdir("$acl/newcerts", 0700);
chmod(0700, "$acl/newcerts");
$self->unlock_file("$acl/newcerts");
$self->{'miniserv_hash'}->{'ca'} = "$acl/ca.pem";
}

# list_themes()
# Returns an array of all installed themes
sub list_themes
{
	my $self = shift;

local (@rv, $o);
opendir(DIR, $self->{'root_directory'});
foreach $m (readdir(DIR)) {
	local %tinfo;
	next if ($m =~ /^\./);
	next if (!$self->read_file_cached("$self->{'root_directory'}/$m/theme.info", \%tinfo));
	next if (!$self->check_os_support(\%tinfo));
	foreach $o (@{$self->{'lang_order_list_array'}}) {
		if ($tinfo{'desc_'.$o}) {
			$tinfo{'desc'} = $tinfo{'desc_'.$o};
			}
		}
	$tinfo{'dir'} = $m;
	push(@rv, \%tinfo);
	}
closedir(DIR);
return sort { lc($a->{'desc'}) cmp lc($b->{'desc'}) } @rv;
}

# install_webmin_module(file, unlink, nodeps, &users|groups)
# Installs a webmin module or theme, and returns either an error message
# or references to three arrays for descriptions, directories and sizes.
# On success or failure, the file is deleted if the unlink parameter is set.
sub install_webmin_module
{
	my $self = shift;

local ($file, $need_unlink, $nodeps, $grant) = @_;
local (@mdescs, @mdirs, @msizes);
local (@newmods, $m);
local $install_root_directory = $self->{'gconfig_hash'}->{'install_root'} || $self->{'root_directory'};

# Uncompress the module file if needed
open(MFILE, $file);
read(MFILE, $self->{'two'}, 2);
close(MFILE);
if ($self->{'two'} eq "\037\235") {
	if (!$self->has_command("uncompress")) {
		unlink($file) if ($need_unlink);
		return $self->text('install_ecomp', "<tt>uncompress</tt>");
		}
	local $temp = $file =~ /\/([^\/]+)\.Z/i ? $self->transname("$1")
						: $self->transname();
	local $out = `uncompress -c "$file" 2>&1 >$temp`;
	unlink($file) if ($need_unlink);
	if ($?) {
		unlink($temp);
		return $self->text('install_ecomp2', $out);
		}
	$file = $temp;
	$need_unlink = 1;
	}
elsif ($self->{'two'} eq "\037\213") {
	if (!$self->has_command("gunzip")) {
		unlink($file) if ($need_unlink);
		return $self->text('install_egzip', "<tt>gunzip</tt>");
		}
	local $temp = $file =~ /\/([^\/]+)\.gz/i ? $self->transname("$1")
						 : $self->transname();
	local $out = `gunzip -c "$file" 2>&1 >$temp`;
	unlink($file) if ($need_unlink);
	if ($?) {
		unlink($temp);
		return $self->text('install_egzip2', $out);
		}
	$file = $temp;
	$need_unlink = 1;
	}
elsif ($self->{'two'} eq "BZ") {
	if (!$self->has_command("bunzip2")) {
		unlink($file) if ($need_unlink);
		return $self->text('install_ebunzip', "<tt>bunzip2</tt>");
		}
	local $temp = $file =~ /\/([^\/]+)\.gz/i ? $self->transname("$1")
						 : $self->transname();
	local $out = `bunzip2 -c "$file" 2>&1 >$temp`;
	unlink($file) if ($need_unlink);
	if ($?) {
		unlink($temp);
		return $self->text('install_ebunzip2', $out);
		}
	$file = $temp;
	$need_unlink = 1;
	}

# Check if this is an RPM webmin module or theme
local ($type, $redirect_to);
open(TYPE, "$self->{'root_directory'}/install-type");
chop($type = <TYPE>);
close(TYPE);
if ($type eq 'rpm' && $file =~ /\.rpm$/i &&
    ($out = `rpm -qp $file 2>/dev/null`)) {
	# Looks like an RPM of some kind, hopefully an RPM webmin module
	# or theme
	local (%minfo, %tinfo);
	if ($out !~ /(^|\n)(wbm|wbt)-([a-z\-]+)/) {
		unlink($file) if ($need_unlink);
		return $self->{'text_hash'}->{'install_erpm'};
		}
	$redirect_to = $self->{'name'} = $3;
	$out = $self->backquote_logged("rpm -U \"$file\" 2>&1");
	if ($?) {
		unlink($file) if ($need_unlink);
		return $self->text('install_eirpm', "<tt>$out</tt>");
		}
	unlink("$self->{'config_directory'}/module.infos.cache");

	$mdirs[0] = $self->module_root_directory($self->{'name'});
	if (%minfo = $self->get_module_info($self->{'name'})) {
		# Get the new module info
		$mdescs[0] = $minfo{'desc'};
		$msizes[0] = $self->disk_usage_kb($mdirs[0]);
		@newmods = ( $self->{'name'} );

		# Update the ACL for this user
		$self->grant_user_module($grant, [ $self->{'name'} ]);
		$self->webmin_log("install", undef, $self->{'name'},
			    { 'desc' => $mdescs[0] });
		}
	elsif (%tinfo = $self->get_theme_info($self->{'name'})) {
		# Get the theme info
		$mdescs[0] = $tinfo{'desc'};
		$msizes[0] = $self->disk_usage_kb($mdirs[0]);
		$self->webmin_log("tinstall", undef, $self->{'name'},
			    { 'desc' => $mdescs[0] });
		}
	else {
		unlink($file) if ($need_unlink);
		return $self->{'text_hash'}->{'install_eneither'};
		}
	}
else {
	# Check if this is a valid module (a tar file of multiple module or
	# theme directories)
	local (%mods, %hasfile);
	$self->has_command("tar") || return $self->{'text_hash'}->{'install_enotar'};
	local $tar = `tar tf "$file" 2>&1`;
	if ($?) {
		unlink($file) if ($need_unlink);
		return $self->text('install_etar', $tar);
		}
	foreach $f (split(/\n/, $tar)) {
		if ($f =~ /^\.\/([^\/]+)\/(.*)$/ || $f =~ /^([^\/]+)\/(.*)$/) {
			$redirect_to = $1 if (!$redirect_to);
			$mods{$1}++;
			$hasfile{$1,$2}++;
			}
		}
	foreach $m (keys %mods) {
		if (!$hasfile{$m,"module.info"} && !$hasfile{$m,"theme.info"}) {
			unlink($file) if ($need_unlink);
			return $self->text('install_einfo', "<tt>$m</tt>");
			}
		}
	if (!%mods) {
		unlink($file) if ($need_unlink);
		return $self->{'text_hash'}->{'install_enone'};
		}

	# Get the module.info files to check dependancies
	local $ver = $self->get_webmin_version();
	local $tmpdir = $self->transname();
	mkdir($tmpdir, 0700);
	local $err;
	local @realmods;
	foreach $m (keys %mods) {
		next if (!$hasfile{$m,"module.info"});
		push(@realmods, $m);
		local %minfo;
		system("cd $tmpdir ; tar xf \"$file\" $m/module.info ./$m/module.info >/dev/null 2>&1");
		if (!$self->read_file("$tmpdir/$m/module.info", \%minfo)) {
			$err = $self->text('install_einfo', "<tt>$m</tt>");
			}
		elsif (!$self->check_os_support(\%minfo)) {
			$err = $self->text('install_eos', "<tt>$m</tt>",
				     $self->{'gconfig_hash'}->{'real_os_type'},
				     $self->{'gconfig_hash'}->{'real_os_version'});
			}
		elsif ($minfo{'enduser_cf'} && !$minfo{'cpplus'}) {
			$err = $self->text('install_eusermin', "<tt>$m</tt>");
			}
		elsif (!$nodeps) {
			local $deps = $minfo{'webmin_depends'} ||
				      $minfo{'depends'};
			foreach $dep (split(/\s+/, $deps)) {
				if ($dep =~ /^[0-9\.]+$/) {
					# Depends on some version of webmin
					if ($dep > $ver) {
						$err = $self->text('install_ever',
							"<tt>$m</tt>",
							"<tt>$dep</tt>");
						}
					}
				elsif ($dep =~ /^(\S+)\/([0-9\.]+)$/) {
					# Depends on a specific version of
					# some other module
					local ($dmod, $dver) = ($1, $2);
					local %dinfo = $self->get_module_info($dmod);
					if (!$mods{$dmod} &&
					    (!%dinfo ||
					     $dinfo{'version'} < $dver)) {
						$err = $self->text('install_edep2',
							"<tt>$m</tt>",
							"<tt>$dmod</tt>",
							"<tt>$dver</tt>");
						}
					}
				elsif (!$self->foreign_exists($dep) &&
				       !$mods{$dep}) {
					# Depends on some other module
					$err = $self->text('install_edep',
					        "<tt>$m</tt>", "<tt>$dep</tt>");
					}
				}
			foreach $dep (split(/\s+/, $minfo{'perldepends'})) {
				eval "use $dep";
				if ($@) {
					$err = $self->text('install_eperldep',
					     "<tt>$m</tt>", "<tt>$dep</tt>",
					     "$self->{'gconfig_hash'}->{'webprefix'}/cpan/download.cgi?source=3&cpan=$dep");
					}
				}
			}
		last if ($err);
		}
	system("rm -rf $tmpdir >/dev/null 2>&1");
	if ($err) {
		unlink($file) if ($need_unlink);
		return $err;
		}

	# Delete modules or themes being replaced
	local $oldpwd = $self->get_current_dir();
	chdir($self->{'root_directory'});
	local @grantmods;
	foreach $m (@realmods) {
		push(@grantmods, $m) if (!$self->foreign_exists($m));
		if ($m ne "cpplus") {
			system("rm -rf ".quotemeta("$install_root_directory/$m")." 2>&1 >/dev/null");
			}
		}

	# Extract all the modules and update perl path and ownership
	local $out = `cd $install_root_directory ; tar xf "$file" 2>&1 >/dev/null`;
	chdir($oldpwd);
	if ($?) {
		unlink($file) if ($need_unlink);
		return $self->text('install_eextract', $out);
		}
	if ($need_unlink) { unlink($file); }
	local $perl = $self->get_perl_path();
	local @st = stat("$self->{'module_root_directory'}/index.cgi");
	foreach $moddir (keys %mods) {
		local $pwd = $self->module_root_directory($moddir);
		if ($hasfile{$moddir,"module.info"}) {
			local %minfo = $self->get_module_info($moddir);
			push(@mdescs, $minfo{'desc'});
			push(@mdirs, $pwd);
			push(@msizes, $self->disk_usage_kb($pwd));
			$self->webmin_log("install", undef, $moddir,
				    { 'desc' => $minfo{'desc'} });
			push(@newmods, $moddir);
			}
		else {
			local %tinfo = $self->get_theme_info($moddir);
			push(@mdescs, $tinfo{'desc'});
			push(@mdirs, $pwd);
			push(@msizes, $self->disk_usage_kb($pwd));
			$self->webmin_log("tinstall", undef, $moddir,
				    { 'desc' => $tinfo{'desc'} });
			}
		system("cd $install_root_directory ; (find $pwd -name '*.cgi' ; find $pwd -name '*.pl') 2>/dev/null | $perl $self->{'root_directory'}/perlpath.pl $perl -");
		system("cd $install_root_directory ; chown -R $st[4]:$st[5] $pwd");
		}

	# Copy appropriate config file from modules to /etc/webmin
	system("cd $self->{'root_directory'} ; $perl $self->{'root_directory'}/copyconfig.pl '$self->{'gconfig_hash'}->{'os_type'}/$self->{'gconfig_hash'}->{'real_os_type'}' '$self->{'gconfig_hash'}->{'os_version'}/$self->{'gconfig_hash'}->{'real_os_version'}' '$install_root_directory' '$self->{'config_directory'}' ".join(' ', @realmods));

	# Update ACL for this user so they can access the new modules
	$self->grant_user_module($grant, \@grantmods);
	}
$self->flush_webmin_caches();

# Run post-install scripts
foreach $m (@newmods) {
	next if (!-r $self->module_root_directory($m)."/postinstall.pl");
	eval {
		$self->foreign_require($m, "postinstall.pl");
		$self->foreign_call($m, "module_install");
		};
	}

return [ \@mdescs, \@mdirs, \@msizes ];
}

# grant_user_module(&users/groups, &modules)
sub grant_user_module
{
	my $self = shift;

# Grant to appropriate users
local %acl;
$self->read_acl(undef, \%acl);
$self->open_tempfile(ACL, ">".$self->acl_filename()); 
local $u;
foreach $u (keys %acl) {
	local @mods = @{$acl{$u}};
	if (!$_[0] || $self->indexof($u, @{$_[0]}) >= 0) {
		@mods = $self->unique(@mods, @{$_[1]});
		}
	$self->print_tempfile(ACL, "$u: ",join(' ', @mods),"\n");
	}
$self->close_tempfile(ACL);

# Grant to appropriate groups
if ($_[1] && $self->foreign_check("acl")) {
	$self->foreign_require("acl", "acl-lib.pl");
	local @groups = $main::acl_object->list_groups();
	local @users = $main::acl_object->list_users();
	local $g;
	foreach $g (@groups) {
		if ($self->indexof($g->{'name'}, @{$_[0]}) >= 0) {
			$g->{'modules'} = [ $self->unique(@{$g->{'modules'}},
					    	    @{$_[1]}) ];
			$main::acl_object->modify_group($g->{'name'}, $g);
			$main::acl_object->update_members(\@users, \@groups, $g->{'modules'},
					     $g->{'members'});
			}
		}
	}
}

# delete_webmin_module(module, [delete-acls])
# Deletes some webmin module, clone or theme, and return a description of
# the thing deleted.
sub delete_webmin_module
{
	my $self = shift;

local $m = $_[0];
return undef if (!$m);
local %minfo = $self->get_module_info($m);
%minfo = $self->get_theme_info($m) if (!%minfo);
return undef if (!%minfo);
local ($mdesc, @aclrm);
@aclrm = ( $m ) if ($_[1]);
if ($minfo{'clone'}) {
	# Deleting a clone
	local %cinfo;
	$self->read_file("$self->{'config_directory'}/$m/clone", \%cinfo);
	unlink($self->module_root_directory($m));
	system("rm -rf $self->{'config_directory'}/$m");
	if ($self->{'gconfig_hash'}->{'theme'}) {
		unlink("$self->{'root_directory'}/$self->{'gconfig_hash'}->{'theme'}/$m");
		}
	$mdesc = $self->text('delete_desc1', $minfo{'desc'}, $minfo{'clone'});
	}
else {
	# Delete any clones of this module
	local @clones;
	local $mdir = $self->module_root_directory($m);
	local @mst = stat($mdir);
	local $r;
	foreach $r (@{$self->{'root_directories_array'}}) {
		opendir(DIR, $r);
		foreach $l (readdir(DIR)) {
			@{$self->{'lst_array'}} = stat("$r/$l");
			if (-l "$r/$l" && $self->{'lst_array'}->[1] == $mst[1]) {
				unlink("$r/$l");
				system("rm -rf $self->{'config_directory'}/$l");
				push(@clones, $l);
				}
			}
		closedir(DIR);
		}

	open(TYPE, "$mdir/install-type");
	chop($self->{'type'} = <TYPE>);
	close(TYPE);

	# Run the module's uninstall script
	if ($self->check_os_support(\%minfo) &&
	    -r "$mdir/uninstall.pl") {
		eval {
			$self->foreign_require($m, "uninstall.pl");
			$self->foreign_call($m, "module_uninstall");
			};
		}

	# Deleting the real module
	local $size = $self->disk_usage_kb($mdir);
	$mdesc = $self->text('delete_desc2', "<b>$minfo{'desc'}</b>",
			   "<tt>$mdir</tt>", $size);
	if ($self->{'type'} eq 'rpm') {
		# This module was installed from an RPM .. rpm -e it
		$self->system_logged("rpm -e wbm-$m");
		}
	else {
		# Module was installed from a .wbm file .. just rm it
		$self->system_logged("rm -rf ".quotemeta($mdir));
		}

	if ($_[1]) {
		# Delete any .acl files
		$self->system_logged("rm -f $self->{'config_directory'}/$m/*.acl");
		push(@aclrm, @clones);
		}
	}

# Delete from all users and groups
if (@aclrm) {
	$self->foreign_require("acl", "acl-lib.pl");
	local ($u, $g, $m);
	foreach $u ($main::acl_object->list_users()) {
		local $changed;
		foreach $m (@aclrm) {
			local $mi = $self->indexof($m, @{$u->{'modules'}});
			local $oi = $self->indexof($m, @{$u->{'ownmods'}});
			splice(@{$u->{'modules'}}, $mi, 1) if ($mi >= 0);
			splice(@{$u->{'ownmods'}}, $oi, 1) if ($oi >= 0);
			$changed++ if ($mi >= 0 || $oi >= 0);
			}
		$main::acl_object->modify_user($u->{'name'}, $u) if ($changed);
		}
	foreach $g ($main::acl_object->list_groups()) {
		local $changed;
		foreach $m (@aclrm) {
			local $mi = $self->indexof($m, @{$g->{'modules'}});
			local $oi = $self->indexof($m, @{$g->{'ownmods'}});
			splice(@{$g->{'modules'}}, $mi, 1) if ($mi >= 0);
			splice(@{$g->{'ownmods'}}, $oi, 1) if ($oi >= 0);
			$changed++ if ($mi >= 0 || $oi >= 0);
			}
		$main::acl_object->modify_group($g->{'name'}, $g) if ($changed);
		}
	}

$self->webmin_log("delete", undef, $m, { 'desc' => $minfo{'desc'} });
return $mdesc;
}

# file_basename(name)
sub file_basename
{
	my $self = shift;

local $rv = $_[0];
$rv =~ s/^.*[\/\\]//;
return $rv;
}

# gnupg_setup()
# Setup gnupg so that rpms and .tar.gz files can be verified.
# Returns 0 if ok, 1 if gnupg is not installed, or 2 if something went wrong
# Assumes that gnupg-lib.pl is available
sub gnupg_setup
{
	my $self = shift;

return ( 1, $self->text('enogpg', "<tt>gpg</tt>") ) if (!$self->has_command("gpg"));

# Check if we already have the key
local @keys = $self->list_keys();
foreach $k (@keys) {
	return ( 0 ) if ($k->{'email'}->[0] eq $self->{'webmin_key_email'} &&
		         $self->key_fingerprint($k) eq $self->{'webmin_key_fingerprint'});
	}

# Import it if not
$self->list_keys();
$self->{'out'} = `gpg --import $self->{'module_root_directory'}/psoft_cpplus-key.asc 2>&1`;
if ($?) {
	return (2, $self->{'out'});
	}
return 0;
}

# list_standard_modules()
# Returns a list containing the short names, URLs and descriptions of the
# standard Webmin modules from www.webmin.com. If an error occurs, returns the
# message instead.
sub list_standard_modules
{
	my $self = shift;

local $temp = $self->transname();
local $error;
local ($host, $port, $page, $ssl);
if ($self->{'config_hash'}->{'standard_url'}) {
	($host, $port, $page, $ssl) = $self->parse_http_url($self->{'config_hash'}->{'standard_url'});
	return $self->{'text_hash'}->{'standard_eurl'} if (!$host);
	}
else {
	($host, $port, $page, $ssl) = ($self->{'standard_host'}, $self->{'standard_port'},
				       $self->{'standard_page'}, $self->{'standard_ssl'});
	}
$self->http_download($host, $port, $page, $temp, \$error);
return $error if ($error);
local @rv;
open(TEMP, $temp);
while(<TEMP>) {
	s/\r|\n//g;
	local @l = split(/\t+/, $_);
	push(@rv, \@l);
	}
close(TEMP);
unlink($temp);
return \@rv;
}

# standard_chooser_button(input, [form])
sub standard_chooser_button
{
	my $self = shift;

local $form = @_ > 1 ? $_[1] : 0;
return "<input type=button onClick='ifield = document.forms[$form].$_[0]; chooser = window.open(\"standard_chooser.cgi?mod=\"+escape(ifield.value), \"chooser\", \"toolbar=no,menubar=no,scrollbars=yes,width=600,height=300\"); chooser.ifield = ifield; window.ifield = ifield' value=\"...\">\n";
}

# list_third_modules()
# Returns a list containing the names, versions, URLs and descriptions of the
# third-party Webmin modules from thirdpartymodules.webmin.com. If an error
# occurs, returns the message instead.
sub list_third_modules
{
	my $self = shift;

local $temp = $self->transname();
local $error;
local ($host, $port, $page, $ssl);
if ($self->{'config_hash'}->{'third_url'}) {
	($host, $port, $page, $ssl) = $self->parse_http_url($self->{'config_hash'}->{'third_url'});
	return $self->{'text_hash'}->{'third_eurl'} if (!$host);
	}
else {
	($host, $port, $page, $ssl) = ($self->{'third_host'}, $self->{'third_port'},
				       $self->{'third_page'}, $self->{'third_ssl'});
	}
$self->http_download($host, $port, $page, $temp, \$error);
return $error if ($error);
local @rv;
open(TEMP, $temp);
while(<TEMP>) {
	s/\r|\n//g;
	local @l = split(/\t+/, $_);
	push(@rv, \@l);
	}
close(TEMP);
unlink($temp);
return \@rv;
}

# third_chooser_button(input, [form])
sub third_chooser_button
{
	my $self = shift;

local $form = @_ > 1 ? $_[1] : 0;
return "<input type=button onClick='ifield = document.forms[$form].$_[0]; chooser = window.open(\"third_chooser.cgi?mod=\"+escape(ifield.value), \"chooser\", \"toolbar=no,menubar=no,scrollbars=yes,width=700,height=300\"); chooser.ifield = ifield; window.ifield = ifield' value=\"$self->{'text_hash'}->{'mods_thsel'}\">\n";
}

# get_webmin_base_version()
# Gets the webmin version, rounded to the nearest .01
sub get_webmin_base_version
{
	my $self = shift;

return $self->base_version($self->get_webmin_version());
}

# base_version()
# Rounds a version number down to the nearest .01
sub base_version
{
	my $self = shift;

my $r = $_[0];
if ($r =~ /^(\d+)\.(\d+)$/) { # decoding old-format ztl version number
    my ($hi, $lo) = ($1, $2);
    $lo = sprintf("0.%d", $1) if $lo =~ /^0(\d+)$/;
    $r = "$hi.$lo";
}
my $ver;
while ($r =~ /(\d+)/g) {
    $ver .= ($ver ? '.' : '') . sprintf("%02d", $1);
}
return $ver;
}

# get_newmodule_users()
# Returns a ref to an array of users to whom new modules are granted, or undef
sub get_newmodule_users
{
	my $self = shift;

if (open(NEWMODS, $self->{'newmodule_users_file'})) {
	local @rv;
	while(<NEWMODS>) {
		s/\r|\n//g;
		push(@rv, $_) if (/\S/);
		}
	close(NEWMODS);
	return \@rv;
	}
else {
	return undef;
	}
}

# save_newmodule_users(&users)
# Saves the list of users to whom new modules are granted. If undef is given,
# the default behavious is used
sub save_newmodule_users
{
	my $self = shift;

$self->lock_file($self->{'newmodule_users_file'});
if ($_[0]) {
	$self->open_tempfile(NEWMODS, ">$self->{'newmodule_users_file'}");
	foreach $u (@{$_[0]}) {
		$self->print_tempfile(NEWMODS, "$u\n");
		}
	$self->close_tempfile(NEWMODS);
	}
else {
	unlink($self->{'newmodule_users_file'});
	}
$self->unlock_file($self->{'newmodule_users_file'});
}

# get_miniserv_sockets(&miniserv)
sub get_miniserv_sockets
{
	my $self = shift;

local @sockets;
push(@sockets, [ $_[0]->{'bind'} || "*", $_[0]->{'port'} ]);
foreach $s (split(/\s+/, $_[0]->{'sockets'})) {
	if ($s =~ /^(\d+)$/) {
		# Just listen on another port on the main IP
		push(@sockets, [ $sockets[0]->[0], $s ]);
		}
	elsif ($s =~ /^(\S+):(\d+)$/) {
		# Listen on a specific port and IP
		push(@sockets, [ $1, $2 ]);
		}
	elsif ($s =~ /^([0-9\.]+):\*$/ || $s =~ /^([0-9\.]+)$/) {
		# Listen on the main port on another IP
		push(@sockets, [ $1, "*" ]);
		}
	}
return @sockets;
}

# fetch_updates(url, [login, pass])
# Returns a list of updates from some URL, or calls &error.
# Format is  module version url support description
sub fetch_updates
{
	my $self = shift;

local ($host, $port, $page, $ssl) = $self->parse_http_url($_[0]);
$host || $self->error($self->{'text_hash'}->{'update_eurl'});

local $temp = $self->transname();
local @updates;
$self->http_download($host, $port, $page, $temp, undef, undef, $ssl, $_[1], $_[2]);
open(UPDATES, $temp);
while(<UPDATES>) {
	if (/^([^\t]+)\t+([^\t]+)\t+([^\t]+)\t+([^\t]+)\t+(.*)/) {
		push(@updates, [ $1, $2, $3, $4, $5 ]);
		}
	}
close(UPDATES);
unlink($temp);
@updates || $self->error($self->{'text_hash'}->{'update_efile'});

return ( \@updates, $host, $port, $page, $ssl );
}

# find_cron_job(\@jobs)
sub find_cron_job
{
	my $self = shift;

local ($job) = grep { $_->{'user'} eq 'root' &&
		      $_->{'command'} eq $self->{'cron_cmd'} } @{$_[0]};
return $job;
}

# get_ipkeys(&miniserv)
# Returns a list of IP address to key file mappings from a miniserv.conf entry
sub get_ipkeys
{
	my $self = shift;

local (@rv, $k);
foreach $k (keys %{$_[0]}) {
	if ($k =~ /^ipkey_(\S+)/) {
		local $ipkey = { 'ips' => [ split(/,/, $1) ],
				 'key' => $_[0]->{$k},
				 'index' => scalar(@rv) };
		$ipkey->{'cert'} = $_[0]->{'ipcert_'.$1};
		push(@rv, $ipkey);
		}
	}
return @rv;
}

# save_ipkeys(&miniserv, &keys)
# Updates miniserv.conf entries from the given list of keys
sub save_ipkeys
{
	my $self = shift;

local $k;
foreach $k (keys %{$_[0]}) {
	if ($k =~ /^(ipkey_|ipcert_)/) {
		delete($_[0]->{$k});
		}
	}
foreach $k (@{$_[1]}) {
	local $ips = join(",", @{$k->{'ips'}});
	$_[0]->{'ipkey_'.$ips} = $k->{'key'};
	if ($k->{'cert'}) {
		$_[0]->{'ipcert_'.$ips} = $k->{'cert'};
		}
	}
}

# validate_key_cert(key, [cert])
# Call &error if some key and cert file don't look correct
sub validate_key_cert
{
	my $self = shift;

local $key = $self->read_file_contents($_[0]);
$key =~ /BEGIN RSA PRIVATE KEY/i || $self->error($self->text('ssl_ekey', $_[0]));
if (!$_[1]) {
	$key =~ /BEGIN CERTIFICATE/ || $self->error($self->text('ssl_ecert', $_[0]));
	}
else {
	local $cert = $self->read_file_contents($_[1]);
	$cert =~ /BEGIN CERTIFICATE/ || $self->error($self->text('ssl_ecert', $_[1]));
	}
}

# detect_operating_system([os-list-file], [with-cache])
# Returns a hash containing os_type, os_version, real_os_type and
# real_os_version
sub detect_operating_system
{
	my $self = shift;

local $file = $_[0] || "$self->{'root_directory'}/os_list.txt";
local $cache = $_[1];
if ($cache) {
	# Check the cache file, and only re-check the OS if older than
	# 1 day, or if we have rebooted recently
	local %cache;
	local $uptime = $self->get_system_uptime();
	local $lastreboot = $uptime ? time()-$uptime : undef;
	if ($self->read_file($self->{'detect_operating_system_cache'}, \%cache)) {
		if ($cache{'time'} > time()-24*60*60 &&
		    $cache{'time'} > $lastreboot) {
			return %cache;
			}
		}
	}
local $temp = $self->transname();
local $perl = $self->get_perl_path();
system("$perl $self->{'root_directory'}/oschooser.pl $file $temp 1");
local %rv;
$self->read_env_file($temp, \%rv);
$rv{'time'} = time();
$self->write_file($self->{'detect_operating_system_cache'}, \%rv);
return %rv;
}

# get_system_uptime()
# Returns the number of seconds the system has been up, or undef if un-available
sub get_system_uptime
{
	my $self = shift;

# Try Linux /proc/uptime first
if (open(UPTIME, "/proc/uptime")) {
	local $line = <UPTIME>;
	close(UPTIME);
	local ($uptime, $dummy) = split(/\s+/, $line);
	if ($uptime > 0) {
		return int($uptime);
		}
	}

# Try to parse uptime command output
if ($self->{'gconfig_hash'}->{'os_type'} ne 'windows') {
	local $out = $self->backquote_command("uptime");
	if ($out =~ /up\s+(\d+)\s+day/) {
		return $1*24*60*60;
		}
	elsif ($out =~ /up\s+(\d+)\s+min/) {
		return $1*60;
		}
	elsif ($out =~ /up\s+(\d+)\s+hour/) {
		return $1*60*60;
		}
	elsif ($out =~ /up\s+(\d+):(\d+)/) {
		return $1*60*60 + $2*60;
		}
	}

return undef;
}

# list_operating_systems([os-list-file])
# Returns a list of know OS's
sub list_operating_systems
{
	my $self = shift;

local $file = $_[0] || "$self->{'root_directory'}/os_list.txt";
local @rv;
open(OSLIST, $file);
while(<OSLIST>) {
	if (/^([^\t]+)\t+([^\t]+)\t+([^\t]+)\t+([^\t]+)\t+(.*)/) {
		push(@rv, { 'realtype' => $1,
			    'realversion' => $2,
			    'type' => $3,
			    'version' => $4,
			    'code' => $5 });
		}
	}
close(OSLIST);
return @rv;
}

# shared_root_directory()
# Returns 1 if the Webmin root directory is shared with another system, such as
# via NFS, or in a Solaris zone. If so, updates and module installs are not
# allowed.
sub shared_root_directory
{
	my $self = shift;

return 1 if ($self->{'gconfig_hash'}->{'shared_root'});
if ($self->running_in_zone()) {
	# In a Solaris zone .. is the root directory loopback mounted?
	if ($self->foreign_exists("mount")) {
		$self->foreign_require("mount", "mount-lib.pl");
		local @rst = stat($self->{'root_directory'});
		local $m;
		foreach $m ($main::mount_object->list_mounted()) {
			local @mst = stat($m->[0]);
			if ($mst[0] == $rst[0] &&
			    $self->is_under_directory($m->[0], $self->{'root_directory'})) {
				# Found the mount!
				if ($m->[2] eq "lofs" || $m->[2] eq "nfs") {
					return 1;
					}
				}
			}
		}
	}
return 0;
}

# submit_os_info(id)
# Send via email a message about this system's OS and Perl version. Returns
# undef if OK, or an error message
sub submit_os_info
{
	my $self = shift;

if (!$self->foreign_installed("mailboxes", 1)) {
	return $self->{'text_hash'}->{'submit_emailboxes'};
	}
$self->foreign_require("mailboxes", "mailboxes-lib.pl");
local $mail = { 'headers' => [ [ 'From', $main::mailboxes_object->get_from_address() ],
			       [ 'To', $self->{'os_info_address'} ],
			       [ 'Subject', "cpplus OS Information" ] ],
		'attach' => [ {
		   'headers' => [ [ 'Content-type', 'text/plain' ] ],
		   'data' => "OS: $self->{'gconfig_hash'}->{'real_os_type'}\n".
			     "Version: $self->{'gconfig_hash'}->{'real_os_version'}\n".
		 	     "OS code: $self->{'gconfig_hash'}->{'os_type'}\n".
		 	     "Version code: $self->{'gconfig_hash'}->{'os_version'}\n".
			     "Perl: $]\n".
			     "cpplus: ".$self->get_webmin_version()."\n".
			     "ID: ".$self->get_webmin_id()."\n" } ],
		};
eval { $main::mailboxes_object->send_mail($mail); };
return $@ ? $@ : undef;
}

# get_webmin_id()
# Returns a (hopefully) unique ID for this Webmin install
sub get_webmin_id
{
	my $self = shift;

if (!$self->{'config_hash'}->{'webminid'}) {
	local $salt = substr(time(), -2);
	$self->{'config_hash'}->{'webminid'} = $self->unix_crypt($self->get_system_hostname(), $salt);
	$self->save_module_config();
	}
return $self->{'config_hash'}->{'webminid'};
}

# ip_match(ip, [match]+)
# Checks an IP address against a list of IPs, networks and networks/masks
sub ip_match
{
	my $self = shift;

local(@io, @mo, @ms, $i, $j);
@io = split(/\./, $_[0]);
local $hn = gethostbyaddr(inet_aton($_[0]), AF_INET);
undef($hn) if (($self->to_ipaddress($hn))[0] ne $_[0]);
for($i=1; $i<@_; $i++) {
	local $mismatch = 0;
	local $ip = $_[$i];
        if ($ip =~ /^(\S+)\/(\d+)$/) {
                # Convert CIDR to netmask format
                $ip = $1."/".$self->prefix_to_mask($2);
                }
	if ($ip =~ /^(\S+)\/(\S+)$/) {
		# Compare with network/mask
		@mo = split(/\./, $1); @ms = split(/\./, $2);
		for($j=0; $j<4; $j++) {
			if ((int($io[$j]) & int($ms[$j])) != int($mo[$j])) {
				$mismatch = 1;
				}
			}
		}
	elsif ($ip =~ /^\*(\.\S+)$/) {
		# Compare with hostname regexp
		$mismatch = 1 if ($hn !~ /$1$/);
		}
	elsif ($ip eq 'LOCAL') {
		# Just assume OK for now
		}
	elsif ($ip !~ /^[0-9\.]+$/) {
		# Compare with hostname
		$mismatch = 1 if ($_[0] ne $self->to_ipaddress($ip));
		}
	else {
		# Compare with IP or network
		@mo = split(/\./, $ip);
		while(@mo && !$mo[$#mo]) { pop(@mo); }
		for($j=0; $j<@mo; $j++) {
			if ($mo[$j] != $io[$j]) {
				$mismatch = 1;
				}
			}
		}
	return 1 if (!$mismatch);
	}
return 0;
}

# prefix_to_mask(prefix)
# Converts a number like 24 to a mask like 255.255.255.0
sub prefix_to_mask
{
	my $self = shift;

return $_[0] >= 24 ? "255.255.255.".(256-(2 ** (32-$_[0]))) :
       $_[0] >= 16 ? "255.255.".(256-(2 ** (24-$_[0]))).".0" :
       $_[0] >= 16 ? "255.".(256-(2 ** (16-$_[0]))).".0.0" :
                     (256-(2 ** (8-$_[0]))).".0.0.0";
}

# valid_allow(text)
# Returns undef if some text is a valid IP, hostname or network for use in
# allowed IPs, or an error message if not
sub valid_allow
{
	my $self = shift;

local ($h) = @_;
local $i;
if ($h =~ /^([0-9\.]+)\/(\d+)$/) {
	$self->check_ipaddress($1) ||
		return $self->text('access_enet', "$1");
	$2 >= 0 && $2 <= 32 ||
		return $self->text('access_ecidr', "$2");
	}
elsif ($h =~ /^([0-9\.]+)\/([0-9\.]+)$/) {
	$self->check_ipaddress($1) ||
		return $self->text('access_enet', "$1");
	$self->check_ipaddress($2) ||
		return $self->text('access_emask', "$2");
	}
elsif ($h =~ /^[0-9\.]+$/) {
	$self->check_ipaddress($h) ||
		return $self->text('access_eip', $h);
	}
elsif ($h =~ /^\*\.(\S+)$/) {
	# *.domain is OK
	}
elsif ($h eq 'LOCAL') {
	# Local means any on local nets
	}
elsif ($i = join('.', unpack("CCCC", inet_aton($h)))) {
	# Resolve a hostname
	$h = $i;
	}
else {
	return $self->text('access_ehost', $h);
	}
return undef;
}

# get_preloads(&miniserv)
# Returns a list of module names and files to pre-load
sub get_preloads
{
	my $self = shift;

local @rv = map { [ split(/=/, $_) ] } split(/\s+/, $_[0]->{'preload'});
return @rv;
}

# save_preloads(&miniserv, &preloads)
sub save_preloads
{
	my $self = shift;

$_[0]->{'preload'} = join(" ", map { "$_->[0]=$_->[1]" } @{$_[1]});
}

# get_tempdirs(&gconfig)
# Returns a list of per-module temp directories
sub get_tempdirs
{
	my $self = shift;

local ($gconfig) = @_;
local @rv;
foreach my $k (keys %$gconfig) {
	if ($k =~ /^tempdir_(.*)$/) {
		push(@rv, [ $1, $gconfig->{$k} ]);
		}
	}
return sort { $a->[0] cmp $b->[0] } @rv;
}

# save_tempdirs(&gconfig, &tempdirs)
# Updates the global config with a list of per-module temp dirs
sub save_tempdirs
{
	my $self = shift;

local ($gconfig, $dirs) = @_;
foreach my $k (keys %$gconfig) {
	if ($k =~ /^tempdir_(.*)$/) {
		delete($gconfig->{$k});
		}
	}
foreach my $d (@$dirs) {
	$gconfig->{'tempdir_'.$d->[0]} = $d->[1];
	}
}

# get_module_install_type(dir)
# Returns the installation method used for some module (such as 'rpm'), or undef
# if it was installed from a .wbm
sub get_module_install_type
{
	my $self = shift;

local ($mod) = @_;
local $it = $self->module_root_directory($mod)."/install-type";
open(TYPE, $it) || return undef;
local $type = <TYPE>;
chop($type);
close(TYPE);
return $type;
}

# get_install_type()
# Returns the package type Webmin was installed form (rpm, deb, solaris-pkg
# or undef for tar.gz)
sub get_install_type
{
	my $self = shift;

local $mode;
if (open(MODE, "$self->{'root_directory'}/install-type")) {
	chop($mode = <MODE>);
	close(MODE);
	}
return $mode;
}

# list_cached_files()
# Returns a list of cached filenames, full paths and urls
sub list_cached_files
{
	my $self = shift;

local @rv;
opendir(DIR, $self->{'http_cache_directory'});
foreach my $cfile (readdir(DIR)) {
	next if ($cfile eq "." || $cfile eq "..");
	$self->{'curl'} = $cfile;
	$self->{'curl'} =~ s/_/\//g;
	push(@rv, [ $cfile, "$self->{'http_cache_directory'}/$cfile", $self->{'curl'} ]);
	}
closedir(DIR);
return @rv;
}

sub show_restart_page
{
	my $self = shift;

$self->ui_print_header(undef, $self->{'text_hash'}->{'restart_title'}, "");

print "<p>$self->{'text_hash'}->{'restart_done'}<p>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
$self->restart_miniserv(1);
}


1;

