#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Save advanced options

&ModuleLoader::preload_module('cpplus_class', "cpplus::CpplusLib");
$self = new cpplus::CpplusLib:: 'cpplus_class',%$self;

$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'advanced_err'});
$self->get_miniserv_config(\%{$self->{'miniserv_hash'}});

# Save global temp dir setting
if ($self->{'in_hash'}->{'tempdir_def'}) {
	delete($self->{'gconfig_hash'}->{'tempdir'});
	}
else {
	-d $self->{'in_hash'}->{'tempdir'} || $self->error($self->{'text_hash'}->{'advanced_etemp'});
	$self->{'gconfig_hash'}->{'tempdir'} = $self->{'in_hash'}->{'tempdir'};
	}

# Save per-module temp dirs
for($i=0; defined($self->{'tmod'} = $self->{'in_hash'}->{'tmod_'.$i}); $i++) {
	next if (!$self->{'tmod'});
	$self->{'tdir'} = $self->{'in_hash'}->{'tdir_'.$i};
	%{$self->{'minfo_hash'}} = $self->get_module_info($self->{'tmod'});
	-d $self->{'tdir'} || $self->error($self->text('advanced_etdir', $self->{'minfo_hash'}->{'desc'}));
	push(@{$self->{'tdirs_array'}}, [ $self->{'tmod'}, $self->{'tdir'} ]);
	}
$self->save_tempdirs(\%{$self->{'gconfig_hash'}}, \@{$self->{'tdirs_array'}});

# Save stack trace option
$self->{'gconfig_hash'}->{'error_stack'} = $self->{'in_hash'}->{'stack'};

# Save showing of stderr
$self->{'miniserv_hash'}->{'noshowstderr'} = !$self->{'in_hash'}->{'showstderr'};

# Save umask
if ($self->{'in_hash'}->{'umask_def'}) {
	delete($self->{'gconfig_hash'}->{'umask'});
	}
else {
	$self->{'in_hash'}->{'umask'} =~ /^[0-7]{3}$/ || $self->error($self->{'text_hash'}->{'advanced_eumask'});
	$self->{'gconfig_hash'}->{'umask'} = $self->{'in_hash'}->{'umask'};
	}

$self->lock_file("$self->{'config_directory'}/config");
$self->write_file("$self->{'config_directory'}/config", \%{$self->{'gconfig_hash'}});
$self->unlock_file("$self->{'config_directory'}/config");

if (defined($self->{'in_hash'}->{'preload'})) {
	# Save preload option
	@{$self->{'preload_array'}} = $self->{'in_hash'}->{'preload'} ? ( [ "main", "web-lib-funcs.pl" ] ) : ( );
	$self->save_preloads(\%{$self->{'miniserv_hash'}}, \@{$self->{'preload_array'}});
	}

# Save password pass option
$self->{'miniserv_hash'}->{'pass_password'} = $self->{'in_hash'}->{'pass'};

$self->lock_file($ENV{'MINISERV_CONFIG'});
$self->put_miniserv_config(\%{$self->{'miniserv_hash'}});
$self->unlock_file($ENV{'MINISERV_CONFIG'});

$self->show_restart_page();
$self->webmin_log("advanced");

1;
		
}


1;

