#!/usr/bin/perl

&MAIN();

 sub MAIN {
# change_bind.cgi
# Update the binding IP address and port for miniserv

&ModuleLoader::preload_module('cpplus_class', "cpplus::CpplusLib");
$self = new cpplus::CpplusLib:: 'cpplus_class',%$self;

#use Socket;
$self->ReadParse();
$self->get_miniserv_config(\%{$self->{'miniserv_hash'}});
%{$self->{'oldminiserv_hash'}} = %{$self->{'miniserv_hash'}};
$self->error_setup($self->{'text_hash'}->{'bind_err'});

# Validate inputs
for($i=0; defined($self->{'in_hash'}->{"ip_def_$i"}); $i++) {
	next if (!$self->{'in_hash'}->{"ip_def_$i"});
	if ($self->{'in_hash'}->{"ip_def_$i"} == 1) {
		$self->{'ip'} = "*";
		}
	else {
		$self->{'ip'} = $self->{'in_hash'}->{"ip_$i"};
		$self->check_ipaddress($self->{'ip'}) || $self->error($self->text('bind_eip2', $self->{'ip'}));
		}
	if ($self->{'in_hash'}->{"port_def_$i"} == 1) {
		$self->{'port'} = $self->{'in_hash'}->{"port_$i"};
		$self->{'port'} =~ /^\d+$/ && $self->{'port'} < 65536 ||
			$self->error($self->text('bind_eport2', $self->{'port'}));
		}
	else {
		$self->{'port'} = "*";
		}
	push(@{$self->{'sockets_array'}}, [ $self->{'ip'}, $self->{'port'} ]);
	}
@{$self->{'sockets_array'}} || $self->error($self->{'text_hash'}->{'bind_enone'});
$self->{'in_hash'}->{'listen_def'} || $self->{'in_hash'}->{'listen'} =~ /^\d+$/ || $self->error($self->{'text_hash'}->{'bind_elisten'});
$self->{'in_hash'}->{'hostname_def'} || $self->{'in_hash'}->{'hostname'} =~ /^[a-z0-9\.\-]+$/i ||
	$self->error($self->{'text_hash'}->{'bind_ehostname'});

# Update config file
$self->lock_file($ENV{'MINISERV_CONFIG'});
$self->{'first'} = shift(@{$self->{'sockets_array'}});
$self->{'miniserv_hash'}->{'port'} = $self->{'first'}->[1];
if ($self->{'first'}->[0] eq "*") {
	delete($self->{'miniserv_hash'}->{'bind'});
	}
else {
	$self->{'miniserv_hash'}->{'bind'} = $self->{'first'}->[0];
	}
$self->{'miniserv_hash'}->{'sockets'} = join(" ", map { "$_->[0]:$_->[1]" } @{$self->{'sockets_array'}});
if ($self->{'in_hash'}->{'listen_def'}) {
	delete($self->{'miniserv_hash'}->{'listen'});
	}
else {
	$self->{'miniserv_hash'}->{'listen'} = $self->{'in_hash'}->{'listen'};
	}
if ($self->{'in_hash'}->{'hostname_def'}) {
	delete($self->{'miniserv_hash'}->{'host'});
	}
else {
	$self->{'miniserv_hash'}->{'host'} = $self->{'in_hash'}->{'hostname'};
	}
$self->put_miniserv_config(\%{$self->{'miniserv_hash'}});
$self->unlock_file($ENV{'MINISERV_CONFIG'});

# Attempt to re-start miniserv
$SIG{'TERM'} = 'ignore';
$self->system_logged("$self->{'config_directory'}/stop >/dev/null 2>&1 </dev/null");
$self->{'temp'} = $self->transname();
$self->{'rv'} = $self->system_logged("$self->{'config_directory'}/start >$self->{'temp'} 2>&1 </dev/null");
$self->{'out'} = `cat $self->{'temp'}`;
$self->{'out'} =~ s/^Starting CP+ server in.*\n//;
$self->{'out'} =~ s/at.*line.*//;
unlink($self->{'temp'});
if ($self->{'rv'}) {
	# Failed! Roll back config and start again
	$self->lock_file($ENV{'MINISERV_CONFIG'});
	$self->put_miniserv_config(\%{$self->{'oldminiserv_hash'}});
	$self->unlock_file($ENV{'MINISERV_CONFIG'});
	$self->system_logged("$self->{'config_directory'}/start >/dev/null 2>&1 </dev/null");
	$self->error($self->text('bind_erestart', $self->{'out'}));
	}
$self->webmin_log("bind", undef, undef, \%{$self->{'in_hash'}});

if ($self->{'miniserv_hash'}->{'musthost'}) { $self->{'miniserv_hash'}->{'musthost'}; }
elsif ($self->{'miniserv_hash'}->{'bind'}) { $self->{'url'} = $self->{'miniserv_hash'}->{'bind'}; }
else { $self->{'url'} = $ENV{'SERVER_NAME'}; }
$self->{'url'} .= ":$self->{'miniserv_hash'}->{'port'}/cpplus/";
if ($ENV{'HTTPS'} eq "ON") { $self->redirect("https://$self->{'url'}"); }
else { $self->redirect("http://$self->{'url'}"); }

1;
		
}


1;

