#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Change OSDN download settings

&ModuleLoader::preload_module('cpplus_class', "cpplus::CpplusLib");
$self = new cpplus::CpplusLib:: 'cpplus_class',%$self;

$self->error_setup($self->{'text_hash'}->{'proxy_err'});
$self->ReadParse();

if ($self->{'in_hash'}->{'clear'}) {
	# Just clearing Webmin's cache
	$self->ui_print_header(undef, $self->{'text_hash'}->{'clear_title'}, "");

	$self->{'sz'} = $self->disk_usage_kb($self->{'http_cache_directory'})*1024;
	if ($self->{'sz'} > 0) {
		opendir(DIR, $self->{'http_cache_directory'});
		@{$self->{'files_array'}} = readdir(DIR);
		closedir(DIR);
		$self->system_logged("rm -rf ".
			       quotemeta($self->{'http_cache_directory'}));
		print $self->text('clear_done', $self->nice_size($self->{'sz'}), @{$self->{'files_array'}}-2),"<p>\n";
		$self->webmin_log("osdnclear");
		}
	else {
		print $self->text('clear_none'),"<p>\n";
		}
	
	$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
	exit;
	}

$self->lock_file("$self->{'config_directory'}/config");
if ($self->{'config_hash'}->{'osdn'}) {
	# Parse mirror selection from list
	if ($self->{'in_hash'}->{'mirror'} eq "*") {
		$self->{'in_hash'}->{'other'} =~ /^\S+$/ || $self->error($self->{'text_hash'}->{'proxy_eother'});
		$self->{'gconfig_hash'}->{'osdn_mirror'} = $self->{'in_hash'}->{'other'};
		}
	else {
		$self->{'gconfig_hash'}->{'osdn_mirror'} = $self->{'in_hash'}->{'mirror'};
		}
	}
else {
	# Use manually entered mirror
	if ($self->{'in_hash'}->{'mirror_def'}) {
		$self->{'gconfig_hash'}->{'osdn_mirror'} = undef;
		}
	else {
		$self->{'in_hash'}->{'mirror'} =~ /^\S+$/ || $self->error($self->{'text_hash'}->{'proxy_eother'});
		$self->{'gconfig_hash'}->{'osdn_mirror'} = $self->{'in_hash'}->{'mirror'};
		}
	}

# Save cache size
if ($self->{'in_hash'}->{'cache_def'}) {
	delete($self->{'gconfig_hash'}->{'cache_size'});
	}
else {
	$self->{'in_hash'}->{'cache'} =~ /^\d+$/ || $self->error($self->{'text_hash'}->{'proxy_ecache'});
	$self->{'gconfig_hash'}->{'cache_size'} = $self->{'in_hash'}->{'cache_units'}*$self->{'in_hash'}->{'cache'};
	}

# Save cache days
if ($self->{'in_hash'}->{'days_def'}) {
	delete($self->{'gconfig_hash'}->{'cache_days'});
	}
else {
	$self->{'in_hash'}->{'days'} =~ /^\d+$/ || $self->error($self->{'text_hash'}->{'proxy_edays'});
	$self->{'gconfig_hash'}->{'cache_days'} = $self->{'in_hash'}->{'days'};
	}

# Save modules
if ($self->{'in_hash'}->{'mods_def'} == 0) {
	delete($self->{'gconfig_hash'}->{'cache_mods'});
	}
else {
	@{$self->{'mods_array'}} = split(/\0/, $self->{'in_hash'}->{'mods'});
	@{$self->{'mods_array'}} || $self->error($self->{'text_hash'}->{'proxy_emods'});
	if ($self->{'in_hash'}->{'mods_def'} == 1) {
		$self->{'gconfig_hash'}->{'cache_mods'} = join(" ", @{$self->{'mods_array'}});
		}
	else {
		$self->{'gconfig_hash'}->{'cache_mods'} = "!".join(" ", @{$self->{'mods_array'}});
		}
	}

# Write out the file
$self->write_file("$self->{'config_directory'}/config", \%{$self->{'gconfig_hash'}});
$self->unlock_file("$self->{'config_directory'}/config");
$self->webmin_log('osdn', undef, undef, \%{$self->{'in_hash'}});

$self->redirect("");

1;
		
}


1;

