#!/usr/bin/perl

&MAIN();

 sub MAIN {
# change_session.cgi
# Enable or disable session authentication

&ModuleLoader::preload_module('cpplus_class', "cpplus::CpplusLib");
$self = new cpplus::CpplusLib:: 'cpplus_class',%$self;

$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'session_err'});

$self->lock_file($ENV{'MINISERV_CONFIG'});
$self->get_miniserv_config(\%{$self->{'miniserv_hash'}});
$self->{'miniserv_hash'}->{'passdelay'} = $self->{'in_hash'}->{'passdelay'};
if ($self->{'in_hash'}->{'blockhost_on'}) {
	$self->{'in_hash'}->{'blockhost_time'} =~ /^\d+$/ && $self->{'in_hash'}->{'blockhost_time'} > 0 ||
		$self->error($self->{'text_hash'}->{'session_eblockhost_time'});
	$self->{'in_hash'}->{'blockhost_failures'} =~ /^\d+$/ && $self->{'in_hash'}->{'blockhost_failures'} > 0 ||
		$self->error($self->{'text_hash'}->{'session_eblockhost_failures'});
	$self->{'miniserv_hash'}->{'blockhost_time'} = $self->{'in_hash'}->{'blockhost_time'};
	$self->{'miniserv_hash'}->{'blockhost_failures'} = $self->{'in_hash'}->{'blockhost_failures'};
	}
else {
	$self->{'miniserv_hash'}->{'blockhost_time'} = $self->{'miniserv_hash'}->{'blockhost_failures'} = undef;
	}
$self->{'miniserv_hash'}->{'syslog'} = $self->{'in_hash'}->{'syslog'};
if ($self->{'in_hash'}->{'session'} && $ENV{'HTTP_COOKIE'} !~ /sessiontest=1/i) {
	$self->error($self->{'text_hash'}->{'session_ecookie'});
	}
$self->{'miniserv_hash'}->{'session'} = $self->{'in_hash'}->{'session'};
if ($self->{'in_hash'}->{'logouttime_on'}) {
	$self->{'in_hash'}->{'logouttime'} =~ /^\d+$/ && $self->{'in_hash'}->{'logouttime'} > 0 ||
		$self->error($self->{'text_hash'}->{'session_elogouttime'});
	}
$self->{'miniserv_hash'}->{'logouttime'} = $self->{'in_hash'}->{'logouttime_on'} ? $self->{'in_hash'}->{'logouttime'} : undef;
if ($self->{'in_hash'}->{'localauth'}) {
	$self->{'lsof'} = $self->has_command("lsof");
	$self->error($self->{'text_hash'}->{'session_elsof'}) if (!$self->{'lsof'});
	$self->{'miniserv_hash'}->{'localauth'} = $self->{'lsof'};
	}
else {
	delete($self->{'miniserv_hash'}->{'localauth'});
	}
$self->{'miniserv_hash'}->{'no_pam'} = $self->{'in_hash'}->{'no_pam'};
if ($self->{'in_hash'}->{'passwd_file'}) {
	$self->{'in_hash'}->{'passwd_file'} =~ /\|$/ || -r $self->{'in_hash'}->{'passwd_file'} ||
		$self->error($self->{'text_hash'}->{'session_epasswd_file'});
	$self->{'in_hash'}->{'passwd_uindex'} =~ /^\d+$/ ||
		$self->error($self->{'text_hash'}->{'session_epasswd_uindex'});
	$self->{'in_hash'}->{'passwd_pindex'} =~ /^\d+$/ ||
		$self->error($self->{'text_hash'}->{'session_epasswd_pindex'});
	$self->{'miniserv_hash'}->{'passwd_file'} = $self->{'in_hash'}->{'passwd_file'};
	$self->{'miniserv_hash'}->{'passwd_uindex'} = $self->{'in_hash'}->{'passwd_uindex'};
	$self->{'miniserv_hash'}->{'passwd_pindex'} = $self->{'in_hash'}->{'passwd_pindex'};
	}
else {
	delete($self->{'miniserv_hash'}->{'passwd_file'});
	delete($self->{'miniserv_hash'}->{'passwd_uindex'});
	delete($self->{'miniserv_hash'}->{'passwd_pindex'});
	}
$self->{'miniserv_hash'}->{'pam_conv'} = $self->{'in_hash'}->{'pam_conv'};
if ($self->{'in_hash'}->{'extauth'}) {
	$self->{'in_hash'}->{'extauth'} =~ /^(\S+)/ && -x $1 ||
		$self->error($self->{'text_hash'}->{'session_eextauth'});
	$self->{'miniserv_hash'}->{'extauth'} = $self->{'in_hash'}->{'extauth'};
	}
else {
	delete($self->{'miniserv_hash'}->{'extauth'});
	}
if (defined($self->{'in_hash'}->{'passwd_mode'})) {
	$self->{'miniserv_hash'}->{'passwd_mode'} = $self->{'in_hash'}->{'passwd_mode'};
	}
$self->{'miniserv_hash'}->{'utmp'} = $self->{'in_hash'}->{'utmp'};
$self->put_miniserv_config(\%{$self->{'miniserv_hash'}});
$self->unlock_file($ENV{'MINISERV_CONFIG'});

$self->lock_file("$self->{'config_directory'}/config");
#$self->{'gconfig_hash'}->{'locking'} = $self->{'in_hash'}->{'locking'};
$self->{'gconfig_hash'}->{'noremember'} = !$self->{'in_hash'}->{'remember'};
$self->{'gconfig_hash'}->{'nohostname'} = !$self->{'in_hash'}->{'hostname'};
$self->{'gconfig_hash'}->{'realname'} = $self->{'in_hash'}->{'realname'};
if ($self->{'in_hash'}->{'passwd_file'}) {
	$self->{'gconfig_hash'}->{'passwd_file'} = $self->{'in_hash'}->{'passwd_file'};
	$self->{'gconfig_hash'}->{'passwd_uindex'} = $self->{'in_hash'}->{'passwd_uindex'};
	$self->{'gconfig_hash'}->{'passwd_pindex'} = $self->{'in_hash'}->{'passwd_pindex'};
	}
else {
	delete($self->{'gconfig_hash'}->{'passwd_file'});
	delete($self->{'gconfig_hash'}->{'passwd_uindex'});
	delete($self->{'gconfig_hash'}->{'passwd_pindex'});
	}
if ($self->{'in_hash'}->{'banner_def'}) {
	delete($self->{'gconfig_hash'}->{'loginbanner'});
	}
else {
	-r $self->{'in_hash'}->{'banner'} || $self->error($self->{'text_hash'}->{'session_ebanner'});
	$self->{'gconfig_hash'}->{'loginbanner'} = $self->{'in_hash'}->{'banner'};
	}
if ($self->{'in_hash'}->{'md5pass'}) {
	# MD5 enabled .. but is it supported by crypt?
	if ($self->unix_crypt('test', '$1$A9wB3O18$zaZgqrEmb9VNltWTL454R/') ne
	    '$1$A9wB3O18$zaZgqrEmb9VNltWTL454R/') {
		$self->error($self->{'text_hash'}->{'session_emd5'});
		}
	}
$self->{'gconfig_hash'}->{'md5pass'} = $self->{'in_hash'}->{'md5pass'};
$self->write_file("$self->{'config_directory'}/config", \%{$self->{'gconfig_hash'}});
$self->unlock_file("$self->{'config_directory'}/config");

$self->show_restart_page();
$self->webmin_log("session", undef, undef, \%{$self->{'in_hash'}});

1;
		
}


1;

