#!/usr/bin/perl

&MAIN();

 sub MAIN {
# delete_mod.cgi
# Delete selected modules from webmin, after asking first

&ModuleLoader::preload_module('cpplus_class', "cpplus::CpplusLib");
$self = new cpplus::CpplusLib:: 'cpplus_class',%$self;

$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'delete_err'});
@{$self->{'mods_array'}} = split(/\0/, $self->{'in_hash'}->{'mod'});
@{$self->{'mods_array'}} || $self->error($self->{'text_hash'}->{'delete_enone'});

# check if any other module depends on those to be deleted
foreach $minfo ($self->get_all_module_infos()) {
	if ($self->check_os_support($minfo) && $self->indexof($minfo->{'dir'}, @{$self->{'mods_array'}}) < 0) {
		foreach $d (split(/\s+/, $minfo->{'depends'})) {
			$self->{'depends_hash'}->{$d} = $minfo->{'desc'};
			}
		}
	}
foreach $m (@{$self->{'mods_array'}}) {
	%minfo = $self->get_module_info($m);
	%minfo = $self->get_theme_info($m) if (!%minfo);
	if (!$self->{'in_hash'}->{'nodeps'} && !-l $self->module_root_directory($m) && $self->{'depends_hash'}->{$m}) {
		$self->error($self->text('delete_edep', "<tt>$minfo{'desc'}</tt>",
			     "<tt>$self->{'depends_hash'}->{$m}</tt>"));
		}
	}

# ask the user if he is sure
if (!$self->{'in_hash'}->{'confirm'}) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'delete_title'}, "");
	print "<p><form action=delete_mod.cgi>\n";
	foreach $m (@{$self->{'mods_array'}}) {
		local %minfo = $self->get_module_info($m);
		if (%minfo) {
			$self->{'module'}++;
			}
		else {
			$self->{'theme'}++;
			%minfo = $self->get_theme_info($m);
			}
		print "<input type=hidden name=mod value=$m>\n";
		$self->{'total'} += $self->disk_usage_kb($self->module_root_directory($m))
			if (!-l $self->module_root_directory($m));
		$self->{'descs'} .= " , " if ($self->{'descs'});
		$self->{'descs'} .= "<b>$minfo{'desc'}</b>";
		}
	print "<center>",$self->text($self->{'theme'} ? 'delete_rusure2' :
			       $self->{'total'} ? 'delete_rusure' : 'delete_rusure3',
			       int($self->{'total'}), $self->{'descs'}),"<p>",
	      "<input type=submit name=confirm value='$self->{'text_hash'}->{'delete'}'><br>\n";
	print "<input type=checkbox name=acls value=1> $self->{'text_hash'}->{'delete_acls'}\n"
		if ($self->{'module'});
	print $self->ui_hidden("nodeps", $self->{'in_hash'}->{'nodeps'}),"\n";
	print "</form></center>\n";
	$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
	exit;
	}

# delete the selected modules or themes
foreach $m (split(/\0/, $self->{'in_hash'}->{'mod'})) {
	next if (!$m || !-d $self->module_root_directory($m));
	push(@{$self->{'mdesc_array'}}, $self->delete_webmin_module($m, $self->{'in_hash'}->{'acls'}));
	}
$self->flush_webmin_caches();

$self->ui_print_header(undef, $self->{'text_hash'}->{'delete_title'}, "");
print $self->{'text_hash'}->{'delete_msg'},"<p>\n";
print "<ul>\n";
for($i=0; $i<@{$self->{'mdesc_array'}}; $i++) {
	print $self->{'mdesc_array'}->[$i],"<p>\n";
	}
print "</ul><p>\n";
$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

