#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Display the advanced options form

&ModuleLoader::preload_module('cpplus_class', "cpplus::CpplusLib");
$self = new cpplus::CpplusLib:: 'cpplus_class',%$self;

$self->ui_print_header(undef, $self->{'text_hash'}->{'advanced_title'}, "");
$self->get_miniserv_config(\%{$self->{'miniserv_hash'}});

print $self->ui_form_start("change_advanced.cgi", "post");
print $self->ui_table_start($self->{'text_hash'}->{'advanced_header'}, undef, 2);

# Global temp directory
print $self->ui_table_row($self->{'text_hash'}->{'advanced_temp'},
		    $self->ui_opt_textbox("tempdir", $self->{'gconfig_hash'}->{'tempdir'},
				    30, $self->{'text_hash'}->{'advanced_tempdef'}));

# Per-module temp directories
@{$self->{'mods_array'}} = sort { $a->{'desc'} cmp $b->{'desc'} } $self->get_all_module_infos();
$self->{'ttable'} = $self->ui_columns_start([ $self->{'text_hash'}->{'advanced_tmod'},
			      $self->{'text_hash'}->{'advanced_tdir'} ]);
$self->{'i'} = 0;
foreach $d ($self->get_tempdirs(\%{$self->{'gconfig_hash'}}), [ ]) {
	$self->{'ttable'} .= $self->ui_columns_row([
		$self->ui_select("tmod_$self->{'i'}", $d->[0],
			[ [ "", "&nbsp;" ],
			  map { [ $_->{'dir'}, $_->{'desc'} ] } @{$self->{'mods_array'}} ]),
		$self->ui_textbox("tdir_$self->{'i'}", $d->[1], 30)
		]);
	$self->{'i'}++;
	}
$self->{'ttable'} .= $self->ui_columns_end();
print $self->ui_table_row($self->{'text_hash'}->{'advanced_tempmods'}, $self->{'ttable'});

@{$self->{'preloads_array'}} = $self->get_preloads(\%{$self->{'miniserv_hash'}});
if (!@{$self->{'preloads_array'}} ||
    $self->{'preloads_array'}->[0]->[0] eq "main" && $self->{'preloads_array'}->[0]->[1] eq "web-lib-funcs.pl") {
	# Only show preload option if in supported mode
	print $self->ui_hidden("preload",0);
	}

# Show call stack on error
print $self->ui_table_row($self->{'text_hash'}->{'advanced_stack'},
		    $self->ui_yesno_radio("stack", int($self->{'gconfig_hash'}->{'error_stack'})));

# Show CGI errors
print $self->ui_table_row($self->{'text_hash'}->{'advanced_showstderr'},
	    $self->ui_yesno_radio("showstderr", int(!$self->{'miniserv_hash'}->{'noshowstderr'})));

# Pass passwords to CGI programs
print $self->ui_hidden("pass",0);	    

# Umask for created files
print $self->ui_table_row($self->{'text_hash'}->{'advanced_umask'},
	    $self->ui_opt_textbox("umask", $self->{'gconfig_hash'}->{'umask'}, 5, $self->{'text_hash'}->{'default'}));

print $self->ui_table_end();
print $self->ui_form_end([ [ "save", $self->{'text_hash'}->{'save'} ] ]);

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

