#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_log.cgi
# Logging config form

&ModuleLoader::preload_module('cpplus_class', "cpplus::CpplusLib");
$self = new cpplus::CpplusLib:: 'cpplus_class',%$self;

$self->ui_print_header(undef, $self->{'text_hash'}->{'log_title'}, "");
$self->foreign_require("acl", "acl-lib.pl");
$self->get_miniserv_config(\%{$self->{'miniserv_hash'}});

print $self->text('log_desc', "<tt>$self->{'miniserv_hash'}->{'logfile'}</tt>"),"<p>\n";
print $self->text('log_desc2', "<tt>$self->{'webmin_logfile'}</tt>"),"<p>\n";

print $self->ui_form_start("change_log.cgi", "post");
print $self->ui_table_start($self->{'text_hash'}->{'log_header'}, undef, 2);

# Is logging enabled?
print $self->ui_table_row($self->{'text_hash'}->{'log_status'},
	$self->ui_radio("log", $self->{'miniserv_hash'}->{'log'} ? 1 : 0,
		  [ [ 0, $self->{'text_hash'}->{'log_disable'} ],
		    [ 1, $self->{'text_hash'}->{'log_enable'} ] ]));

# Log resolved hostnames
print $self->ui_table_row($self->{'text_hash'}->{'log_resolv'},
	$self->ui_yesno_radio("loghost", int($self->{'miniserv_hash'}->{'loghost'})));

# Use common log format
print $self->ui_table_row($self->{'text_hash'}->{'log_clf'},
	$self->ui_yesno_radio("logclf", int($self->{'miniserv_hash'}->{'logclf'})));

# Clear logs regularly
print $self->ui_table_row($self->{'text_hash'}->{'log_clear2'},
	$self->ui_radio("logclear", int($self->{'miniserv_hash'}->{'logclear'}),
		  [ [ 1, $self->text('log_period',
			$self->ui_textbox("logtime", $self->{'miniserv_hash'}->{'logtime'}, 10)) ],
		    [ 0, $self->{'text_hash'}->{'no'} ] ]));

# Webmin users to log for
print $self->ui_table_row($self->{'text_hash'}->{'log_forusers'},
	$self->ui_radio("uall", $self->{'gconfig_hash'}->{'logusers'} ? 0 : 1,
		  [ [ 1, $self->{'text_hash'}->{'log_uall'} ], [ 0, $self->{'text_hash'}->{'log_users'} ] ]).
	"<br>\n".
	$self->ui_select("users", [ split(/\s+/, $self->{'gconfig_hash'}->{'logusers'}) ],
		   [ map { [ $_->{'name'} ] }
			 sort { $a->{'name'} cmp $b->{'name'} } 
			      $main::acl_object->list_users() ],
		   5, 1));

# Modules to log in
print $self->ui_table_row($self->{'text_hash'}->{'log_inmods'},
	$self->ui_radio("mall", $self->{'gconfig_hash'}->{'logmodules'} ? 0 : 1,
		  [ [ 1, $self->{'text_hash'}->{'log_mall'} ], [ 0, $self->{'text_hash'}->{'log_modules'} ] ]).
	"<br>\n".
	$self->ui_select("modules", [ split(/\s+/, $self->{'gconfig_hash'}->{'logmodules'}) ],
		   [ map { [ $_->{'dir'}, $_->{'desc'} ] }
			 grep { -r $self->module_root_directory($_)."/log_parser.pl" }
			      sort { $a->{'desc'} cmp $b->{'desc'} }
				   $self->get_all_module_infos() ],
		   5, 1));

print $self->ui_table_row($self->{'text_hash'}->{'log_files'},
	$self->ui_yesno_radio("logfiles", int($self->{'gconfig_hash'}->{'logfiles'})));

print $self->ui_table_row($self->{'text_hash'}->{'log_fullfiles'},
	$self->ui_yesno_radio("logfullfiles", int($self->{'gconfig_hash'}->{'logfullfiles'})));

print $self->ui_table_row($self->{'text_hash'}->{'log_perms'},
	$self->ui_opt_textbox("perms", $self->{'gconfig_hash'}->{'logperms'}, 5, $self->{'text_hash'}->{'default'}));

eval "use Sys::Syslog qw(:DEFAULT setlogsock)";
if (!$@) {
	print $self->ui_table_row($self->{'text_hash'}->{'log_syslog'},
		$self->ui_yesno_radio("logsyslog", int($self->{'gconfig_hash'}->{'logsyslog'})));
	}

print $self->ui_table_end();
print $self->ui_form_end([ [ "save", $self->{'text_hash'}->{'save'} ] ]);

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

