#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_os.cgi
# Show the current OS according to Webmin, and some environment settings

&ModuleLoader::preload_module('cpplus_class', "cpplus::CpplusLib");
$self = new cpplus::CpplusLib:: 'cpplus_class',%$self;

$self->ui_print_header(undef, $self->{'text_hash'}->{'os_title'}, "");

print $self->{'text_hash'}->{'os_desc3'},"<br>\n";
print $self->{'text_hash'}->{'os_desc2'},"<p>\n";

print $self->ui_form_start("change_os.cgi", "post");
print $self->ui_table_start($self->{'text_hash'}->{'os_header'}, undef, 2);

# OS according to Webmin
print $self->ui_table_row($self->{'text_hash'}->{'os_webmin'},
   $self->ui_select("type", $self->{'gconfig_hash'}->{'real_os_type'},
	[ map { [ $_ ] } sort { $a cmp $b } $self->unique(map { $_->{'realtype'} }
				 $self->list_operating_systems()) ])." ".
   $self->ui_textbox("version", $self->{'gconfig_hash'}->{'real_os_version'}, 10));

# Internal OS code
print $self->ui_table_row($self->{'text_hash'}->{'os_iwebmin'},
    $self->ui_select("itype", $self->{'gconfig_hash'}->{'os_type'},
	[ map { [ $_ ] } sort { $a cmp $b } $self->unique(map { $_->{'type'} }
				 $self->list_operating_systems()) ])." ".
    $self->ui_textbox("iversion", $self->{'gconfig_hash'}->{'os_version'}, 10));

# Detected OS
%{$self->{'osinfo_hash'}} = $self->detect_operating_system();
if ($self->{'osinfo_hash'}->{'real_os_type'}) {
	print $self->ui_table_row($self->{'text_hash'}->{'os_detect'},
		"$self->{'osinfo_hash'}->{'real_os_type'} $self->{'osinfo_hash'}->{'real_os_version'}\n".
		($self->{'osinfo_hash'}->{'os_type'} ne $self->{'gconfig_hash'}->{'os_type'} ||
		 $self->{'osinfo_hash'}->{'os_version'} ne $self->{'gconfig_hash'}->{'os_version'} ?
			"<br>".$self->ui_checkbox("update", 1, $self->{'text_hash'}->{'os_update'}) :
			""));
	}
else {
	print $self->ui_table_row($self->{'text_hash'}->{'os_detect'},
			    "<i>$self->{'text_hash'}->{'os_cannot'}</i>");
	}

print $self->ui_table_hr();

# Search path
print $self->ui_table_row($self->{'text_hash'}->{'os_path'},
	$self->ui_textarea("path",
		     join("\n", split($self->{'path_separator'}, $self->{'gconfig_hash'}->{'path'})),
		     5, 30));

# Shared library path
if ($self->{'gconfig_hash'}->{'ld_env'}) {
	print $self->ui_table_row($self->{'text_hash'}->{'os_ld_path'},
		$self->ui_textarea("ld_path",
		     join("\n", split($self->{'path_separator'}, $self->{'gconfig_hash'}->{'ld_path'})),
		     5, 30));
	}

# Global environment variables
$self->get_miniserv_config(\%{$self->{'miniserv_hash'}});
$self->{'atable'} = $self->ui_columns_start([ $self->{'text_hash'}->{'os_name'}, $self->{'text_hash'}->{'os_value'} ]);
$self->{'i'} = 0;
foreach $e (keys %{$self->{'miniserv_hash'}}) {
	if ($e =~ /^env_(\S+)$/ &&
	    $1 ne "WEBMIN_CONFIG" && $1 ne "WEBMIN_VAR") {
		$self->{'atable'} .= $self->ui_columns_row([
			$self->ui_textbox("name_$self->{'i'}", $1, 20),
			$self->ui_textbox("value_$self->{'i'}", $self->{'miniserv_hash'}->{$e}, 30)
			]);
		$self->{'i'}++;
		}
	}
$self->{'atable'} .= $self->ui_columns_row([ $self->ui_textbox("name_$self->{'i'}", undef, 20),
			     $self->ui_textbox("value_$self->{'i'}", undef, 30) ]);
$self->{'atable'} .= $self->ui_columns_end();
print $self->ui_table_row($self->{'text_hash'}->{'os_envs'}, $self->{'atable'});

print $self->ui_table_end();
print $self->ui_form_end([ [ "", $self->{'text_hash'}->{'save'} ] ]);

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

