#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_proxy.cgi
# Proxy servers config form

&ModuleLoader::preload_module('cpplus_class', "cpplus::CpplusLib");
$self = new cpplus::CpplusLib:: 'cpplus_class',%$self;

$self->ReadParse();
$self->ui_print_header(undef, $self->{'text_hash'}->{'proxy_title'}, "");

# Show tabs
@{$self->{'tabs_array'}} = ( [ "proxy", $self->{'text_hash'}->{'proxy_tabproxy'}, "edit_proxy.cgi?mode=proxy" ],
	  [ "down", $self->{'text_hash'}->{'proxy_tabdown'}, "edit_proxy.cgi?mode=down" ] );
print $self->ui_tabs_start(\@{$self->{'tabs_array'}}, "pd", $self->{'in_hash'}->{'mode'} || "proxy", 1);

print $self->ui_tabs_start_tab("pd", "proxy");
print $self->{'text_hash'}->{'proxy_desc'},"<p>\n";
print $self->ui_form_start("change_proxy.cgi", "post");
print $self->ui_table_start($self->{'text_hash'}->{'proxy_header'}, undef, 2);

# HTTP proxy
print $self->ui_table_row($self->{'text_hash'}->{'proxy_http'},
	$self->ui_opt_textbox("http", $self->{'gconfig_hash'}->{'http_proxy'}, 50,
			$self->{'text_hash'}->{'proxy_none'}));

# FTP proxy
print $self->ui_table_row($self->{'text_hash'}->{'proxy_ftp'},
	$self->ui_opt_textbox("ftp", $self->{'gconfig_hash'}->{'ftp_proxy'}, 50,
			$self->{'text_hash'}->{'proxy_none'}));

# No proxy for domains
print $self->ui_table_row($self->{'text_hash'}->{'proxy_nofor'},
	$self->ui_textbox("noproxy", $self->{'gconfig_hash'}->{'noproxy'}, 60));

# User and password
print $self->ui_table_row($self->{'text_hash'}->{'proxy_user'},
	$self->ui_textbox("puser", $self->{'gconfig_hash'}->{'proxy_user'}, 20));
print $self->ui_table_row($self->{'text_hash'}->{'proxy_pass'},
	$self->ui_password("ppass", $self->{'gconfig_hash'}->{'proxy_pass'}, 20));

# Bind to address for outgoing connections
print $self->ui_table_row($self->{'text_hash'}->{'proxy_bind'},
	$self->ui_opt_textbox("bind", $self->{'gconfig_hash'}->{'bind_proxy'}, 35, $self->{'text_hash'}->{'default'}));

print $self->ui_table_end();
print $self->ui_form_end([ [ "save", $self->{'text_hash'}->{'save'} ] ]);
print $self->ui_tabs_end_tab();

# OSDN mirror form
print $self->ui_tabs_start_tab("pd", "down");
print $self->{'text_hash'}->{'proxy_desc2'},"<p>\n";
print $self->ui_form_start("change_osdn.cgi");
print $self->ui_table_start($self->{'text_hash'}->{'proxy_header2'}, undef, 2);

if ($self->{'config_hash'}->{'osdn'}) {
	# Show list of mirrors to choose from
	$self->{'base'} = $self->get_webmin_base_version();
	@{$self->{'mirrors_array'}} = ();
	@{$self->{'codes_array'}} = map { $_->{'mirror'} } @{$self->{'mirrors_array'}};
	$self->{'inlist'} = !$self->{'gconfig_hash'}->{'osdn_mirror'} ||
		  $self->indexof($self->{'gconfig_hash'}->{'osdn_mirror'}, @{$self->{'codes_array'}}) >= 0;
	print $self->ui_table_row($self->{'text_hash'}->{'proxy_osdn'},
	   $self->ui_select("mirror", $self->{'inlist'} ? $self->{'gconfig_hash'}->{'osdn_mirror'} : "*",
			[ [ "", $self->{'text_hash'}->{'proxy_mirrordef'} ],
			  (map { [ $_->{'mirror'},
				   $_->{'country'} ? "$_->{'mirror'} ($_->{'country'})" : $_->{'mirror'} ] } @{$self->{'mirrors_array'}}),
			  [ "*", $self->{'text_hash'}->{'proxy_other'} ] ])." ".
		     $self->ui_textbox("other",
			$self->{'inlist'} ? "" : $self->{'gconfig_hash'}->{'osdn_mirror'}, 10));
	}
else {
	# Just show text field for mirror code
	print $self->ui_table_row($self->{'text_hash'}->{'proxy_osdn'},
	   $self->ui_opt_textbox("mirror", $self->{'gconfig_hash'}->{'osdn_mirror'}, 10,
			      $self->{'text_hash'}->{'proxy_mirrordef2'}));
	}

# Cache size
print $self->ui_table_row($self->{'text_hash'}->{'proxy_cache'},
		    $self->ui_radio("cache_def", $self->{'gconfig_hash'}->{'cache_size'} ? 0 : 1,
			      [ [ 1, $self->{'text_hash'}->{'proxy_cache1'} ],
				[ 0, $self->{'text_hash'}->{'proxy_cache0'} ] ])."\n".
		    $self->ui_bytesbox("cache", $self->{'gconfig_hash'}->{'cache_size'}, 8));

# Cache time
print $self->ui_table_row($self->{'text_hash'}->{'proxy_daysmax'},
		    $self->ui_opt_textbox("days", $self->{'gconfig_hash'}->{'cache_days'}, 5,
			    $self->{'text_hash'}->{'proxy_daysdef'})." ".$self->{'text_hash'}->{'proxy_days'});

# Modules to cache in
$self->{'excl'} = ($self->{'gconfig_hash'}->{'cache_mods'} =~ s/^\!//);
@{$self->{'mods_array'}} = split(/\s+/, $self->{'gconfig_hash'}->{'cache_mods'});
print $self->ui_table_row($self->{'text_hash'}->{'proxy_mods'},
		    $self->ui_radio("mods_def", !$self->{'gconfig_hash'}->{'cache_mods'} ? 0 :
					  $self->{'excl'} ? 2 : 1,
			      [ [ 0, $self->{'text_hash'}->{'proxy_mods0'} ],
				[ 1, $self->{'text_hash'}->{'proxy_mods1'} ],
				[ 2, $self->{'text_hash'}->{'proxy_mods2'} ] ])."<br>\n".
		    $self->ui_select("mods", \@{$self->{'mods_array'}},
			       [ map { [ $_->{'dir'}, $_->{'desc'} ] }
				  sort { lc($a->{'desc'}) cmp lc($b->{'desc'}) }
				   $self->get_all_module_infos() ],
			       10, 1));

print $self->ui_table_end();
print $self->ui_form_end([ [ "save", $self->{'text_hash'}->{'save'} ],
		     [ "clear", $self->{'text_hash'}->{'proxy_clear'} ] ]);

@{$self->{'cached_array'}} = $self->list_cached_files();
if (@{$self->{'cached_array'}}) {
	# Show cache management and clearing buttons
	print "<hr>\n";
	print $self->ui_buttons_start();
	print $self->ui_buttons_row("cache.cgi", $self->{'text_hash'}->{'proxy_cacheb'},
					   $self->{'text_hash'}->{'proxy_cachebdesc'});
	$self->{'sz'} = $self->nice_size($self->disk_usage_kb($self->{'http_cache_directory'})*1024);
	print $self->ui_buttons_row("clear_cache.cgi", $self->{'text_hash'}->{'proxy_clear'},
			      $self->text('proxy_cleardesc', scalar(@{$self->{'cached_array'}}), $self->{'sz'}));
	print $self->ui_buttons_end();
	}
print $self->ui_tabs_end_tab();

print $self->ui_tabs_end(1);

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

