#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_ssl.cgi
# Webserver SSL form

&ModuleLoader::preload_module('cpplus_class', "cpplus::CpplusLib");
$self = new cpplus::CpplusLib:: 'cpplus_class',%$self;

$self->ui_print_header(undef, $self->{'text_hash'}->{'ssl_title'}, "");
$self->ReadParse();
$self->get_miniserv_config(\%{$self->{'miniserv_hash'}});

# Check if we even *have* SSL support
eval "use Net::SSLeay";
if ($@) {
	print $self->text('ssl_essl', "www.cpplus.info"),"<p>\n";
	if ($self->foreign_available("cpan")) {
		print $self->text('ssl_cpan', "../cpan/download.cgi?source=3&cpan=Net::SSLeay&mode=2&return=/$self->{'module_name'}/&returndesc=".$self->urlize($self->{'text_hash'}->{'index_return'})),"<p>\n";
		}
	$self->{'err'} = $@;
	$self->{'err'} =~ s/\s+at.*line\s+\d+[\000-\377]*$//;
	print $self->text('ssl_emessage', "<tt>$self->{'err'}</tt>"),"<p>\n";
	$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
	exit;
	}

# Show tabs
@{$self->{'tabs_array'}} = map { [ $_, $self->{'text_hash'}->{'ssl_tab'.$_}, "edit_upgrade.cgi?mode=$_" ] }
	    ( "ssl", "ips", "create", "upload" );
print $self->ui_tabs_start(\@{$self->{'tabs_array'}}, "mode", $self->{'in_hash'}->{'mode'} || $self->{'tabs_array'}->[0]->[0], 1);

# Basic SSL settings
print $self->ui_tabs_start_tab("mode", "ssl");
print $self->{'text_hash'}->{'ssl_desc1'},"<p>\n";
print $self->{'text_hash'}->{'ssl_desc2'},"<p>\n";

print $self->ui_form_start("change_ssl.cgi", "post");
print $self->ui_table_start($self->{'text_hash'}->{'ssl_header'}, undef, 2);

print $self->ui_table_row($self->{'text_hash'}->{'ssl_on'},
	$self->ui_yesno_radio("ssl", $self->{'miniserv_hash'}->{'ssl'}));

print $self->ui_table_row($self->{'text_hash'}->{'ssl_key'},
	$self->ui_textbox("key", $self->{'miniserv_hash'}->{'keyfile'}, 40)." ".
	$self->file_chooser_button("key"));

print $self->ui_table_row($self->{'text_hash'}->{'ssl_cert'},
	$self->ui_opt_textbox("cert", $self->{'miniserv_hash'}->{'certfile'}, 40,
			$self->{'text_hash'}->{'ssl_cert_def'}."<br>",$self->{'text_hash'}->{'ssl_cert_oth'})." ".
	$self->file_chooser_button("cert"));

print $self->ui_table_row($self->{'text_hash'}->{'ssl_redirect'},
	$self->ui_yesno_radio("ssl_redirect", $self->{'miniserv_hash'}->{'ssl_redirect'}));

print $self->ui_table_row($self->{'text_hash'}->{'ssl_version'},
	$self->ui_opt_textbox("version", $self->{'miniserv_hash'}->{'ssl_version'}, 4,
			$self->{'text_hash'}->{'ssl_auto'}));

print $self->ui_table_row($self->{'text_hash'}->{'ssl_extracas'},
	$self->ui_textarea("extracas", join("\n",split(/\s+/, $self->{'miniserv_hash'}->{'extracas'})),
		     3, 60));

print $self->ui_table_end();
print $self->ui_form_end([ [ "", $self->{'text_hash'}->{'save'} ] ]);
print $self->ui_tabs_end_tab();

# Table listing per-IP SSL certs
print $self->ui_tabs_start_tab("mode", "ips");
print "$self->{'text_hash'}->{'ssl_ipkeys'}<p>\n";
@{$self->{'ipkeys_array'}} = $self->get_ipkeys(\%{$self->{'miniserv_hash'}});
if (@{$self->{'ipkeys_array'}}) {
	print $self->ui_columns_start([ $self->{'text_hash'}->{'ssl_ips'}, $self->{'text_hash'}->{'ssl_key'},
				  $self->{'text_hash'}->{'ssl_cert'} ]);
	foreach $k (@{$self->{'ipkeys_array'}}) {
		print $self->ui_columns_row([
			"<a href='edit_ipkey.cgi?idx=$k->{'index'}'>".
			join(", ", @{$k->{'ips'}})."</a>",
			"<tt>$k->{'key'}</tt>",
			$k->{'cert'} ? "<tt>$k->{'cert'}</tt>" : "<br>"
			]);
		}
	print $self->ui_columns_end();
	}
else {
	print "<b>$self->{'text_hash'}->{'ssl_ipkeynone'}</b><p>\n";
	}
print "<a href='edit_ipkey.cgi?new=1'>$self->{'text_hash'}->{'ssl_addipkey'}</a><p>\n";
print $self->ui_tabs_end_tab();

# SSL key generation form
print $self->ui_tabs_start_tab("mode", "create");
print "$self->{'text_hash'}->{'ssl_newkey'}<p>\n";
local $curkey = `cat $self->{'miniserv_hash'}->{'keyfile'} 2>/dev/null`;
local $origkey = `cat $self->{'root_directory'}/miniserv.pem 2>/dev/null`;
if ($curkey eq $origkey) {
	# System is using the original (insecure) CP+ key!
	print "<b>$self->{'text_hash'}->{'ssl_hole'}</b><p>\n";
	}

print $self->ui_form_start("newkey.cgi");
print $self->ui_table_start($self->{'text_hash'}->{'ssl_header1'}, undef, 2);

$self->{'host'} = $ENV{'HTTP_HOST'};
$self->{'host'} =~ s/:.*//;
print $self->ui_table_row($self->{'text_hash'}->{'ssl_cn'},
		    $self->ui_opt_textbox("commonName", $self->{'host'}, 30,
				    $self->{'text_hash'}->{'ssl_all'}));

print $self->ui_table_row($self->{'text_hash'}->{'ca_email'},
		    $self->ui_textbox("emailAddress", $self->{'d'}->{'emailto'}, 30));

print $self->ui_table_row($self->{'text_hash'}->{'ca_ou'},
		    $self->ui_textbox("organizationalUnitName", undef, 30));

$self->{'o'} = "CP+ Webserver on ".$self->get_system_hostname();
print $self->ui_table_row($self->{'text_hash'}->{'ca_o'},
		    $self->ui_textbox("organizationName", $self->{'o'}, 30));

print $self->ui_table_row($self->{'text_hash'}->{'ca_city'},
		    $self->ui_textbox("cityName", undef, 30));

print $self->ui_table_row($self->{'text_hash'}->{'ca_sp'},
		    $self->ui_textbox("stateOrProvinceName", undef, 15));

print $self->ui_table_row($self->{'text_hash'}->{'ca_c'},
		    $self->ui_textbox("countryName", undef, 2));

print $self->ui_table_row($self->{'text_hash'}->{'ssl_size'},
		    $self->ui_opt_textbox("size", undef, 6,
				    "$self->{'text_hash'}->{'default'} ($self->{'default_key_size'})").
			" ".$self->{'text_hash'}->{'ssl_bits'});

print $self->ui_table_row($self->{'text_hash'}->{'ssl_days'},
		    $self->ui_textbox("days", 1825, 8));

print $self->ui_table_row($self->{'text_hash'}->{'ssl_newfile'},
	    $self->ui_textbox("newfile", "$self->{'config_directory'}/miniserv.pem", 40));

print $self->ui_table_row($self->{'text_hash'}->{'ssl_usenew'},
		    $self->ui_yesno_radio("usenew", 1));

print $self->ui_table_end();
print $self->ui_form_end([ [ "", $self->{'text_hash'}->{'ssl_create'} ] ]);
print $self->ui_tabs_end_tab();

# SSL key upload form
print $self->ui_tabs_start_tab("mode", "upload");
print "$self->{'text_hash'}->{'ssl_savekey'}<p>\n";
print $self->ui_form_start("savekey.cgi", "form-data");
print $self->ui_table_start($self->{'text_hash'}->{'ssl_saveheader'}, undef, 2);

print $self->ui_table_row($self->{'text_hash'}->{'ssl_privkey'},
		    $self->ui_textarea("key", undef, 7, 60)."<br>\n".
		    "<b>$self->{'text_hash'}->{'ssl_upload'}</b>\n".
		    $self->ui_upload("keyfile"));

print $self->ui_table_row($self->{'text_hash'}->{'ssl_privcert'},
		    $self->ui_radio("cert_def", 1,
			[ [ 1, $self->{'text_hash'}->{'ssl_same'} ],
			  [ 0, $self->{'text_hash'}->{'ssl_below'} ] ])."<br>\n".
		    $self->ui_textarea("cert", undef, 7, 60)."<br>\n".
		    "<b>$self->{'text_hash'}->{'ssl_upload'}</b>\n".
		    $self->ui_upload("certfile"));

print $self->ui_table_end();
print $self->ui_form_end([ [ "save", $self->{'text_hash'}->{'save'} ] ]);
print $self->ui_tabs_end_tab();

print $self->ui_tabs_end(1);

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

