#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Create and output a wbm.gz file of selected modules

&ModuleLoader::preload_module('cpplus_class', "cpplus::CpplusLib");
$self = new cpplus::CpplusLib:: 'cpplus_class',%$self;

$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'export_err'});
@{$self->{'mods_array'}} = split(/\0/, $self->{'in_hash'}->{'mod'});
@{$self->{'mods_array'}} || $self->error($self->{'text_hash'}->{'delete_enone'});

# Make sure we have the needed commands
$self->has_command("tar") || $self->error($self->text('export_ecmd', "<tt>tar</tt>"));
$self->has_command("gzip") || $self->error($self->text('export_ecmd', "<tt>gzip</tt>"));
$self->{'in_hash'}->{'to'} == 0 || $self->{'in_hash'}->{'file'} =~ /^\// || $self->error($self->{'text_hash'}->{'export_efile'});

# Make the tar.gz file
$self->{'temp'} = $self->{'in_hash'}->{'to'} ? $self->{'in_hash'}->{'file'} : $self->transname();
chdir($self->module_root_directory($self->{'mods_array'}->[0])."/..");
$self->{'cmd'} = "tar chf -";
foreach $m (@{$self->{'mods_array'}}) {
	$self->{'cmd'} .= " $m";
	}
$self->{'cmd'} .= " | gzip -c >".quotemeta($self->{'temp'});
$self->{'out'} = $self->backquote_logged("($self->{'cmd'}) 2>&1 </dev/null");
$? && $self->error("<pre>$self->{'out'}</pre>");

if ($self->{'in_hash'}->{'to'} == 0) {
	# Output the file
	print "Content-type: application/octet-stream\n\n";
	open(TEMP, $self->{'temp'});
	while(<TEMP>) {
		print $_;
		}
	close(TEMP);
	unlink($self->{'temp'});
	}
else {
	# Tell the user
	$self->ui_print_header(undef, $self->{'text_hash'}->{'export_title'}, "");

	print $self->text('export_done', "<tt>$self->{'in_hash'}->{'file'}</tt>"),"<p>\n";

	$self->ui_print_footer("/$self->{'module_name'}/edit_mods.cgi", $self->{'text_hash'}->{'mods_return'},
			 "", $self->{'text_hash'}->{'index_return'});
	}

1;
		
}


1;

