#!/usr/bin/perl

&MAIN();

 sub MAIN {
# index.cgi
# Display a table of icons for different types of webmin configuration

&ModuleLoader::preload_module('cpplus_class', "cpplus::CpplusLib");
$self = new cpplus::CpplusLib:: 'cpplus_class',%$self;

$self->{'ver'} = $self->get_webmin_version();
$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", undef, 1, 1, 0);
%{$self->{'access_hash'}} = $self->get_module_acl();

@{$self->{'wlinks_array'}} = ( "edit_access.cgi", "edit_bind.cgi", "edit_log.cgi",
	    "edit_proxy.cgi",
	    "edit_os.cgi", "edit_lang.cgi",
	    "edit_session.cgi",
	    "edit_referers.cgi", "edit_anon.cgi", "edit_lock.cgi",
	    "edit_advanced.cgi" );
@{$self->{'wtitles_array'}} = ( $self->{'text_hash'}->{'access_title'}, $self->{'text_hash'}->{'bind_title'},
	     $self->{'text_hash'}->{'log_title'}, $self->{'text_hash'}->{'proxy_title'},
	     $self->{'text_hash'}->{'os_title'}, $self->{'text_hash'}->{'lang_title'},
	     $self->{'text_hash'}->{'session_title'},
		  $self->{'text_hash'}->{'referers_title'},
	     $self->{'text_hash'}->{'anon_title'}, $self->{'text_hash'}->{'lock_title'},
	     $self->{'text_hash'}->{'advanced_title'} );
@{$self->{'wicons_array'}} = ( "images/access.gif", "images/bind.gif", "images/log.gif",
	    "images/proxy.gif",
	    "images/os.gif", "images/lang.gif",
            "images/session.gif",
	    "images/referers.gif",
	    "images/anon.gif", "images/lock.gif", "images/advanced.gif" );
if ($self->{'gconfig_hash'}->{'eazel'}) {
	push(@{$self->{'wlinks_array'}}, "edit_syslet.cgi");
	push(@{$self->{'wtitles_array'}}, $self->{'text_hash'}->{'syslet_title'});
	push(@{$self->{'wicons_array'}}, "images/syslet.gif");
	}
push(@{$self->{'wlinks_array'}}, "edit_ssl.cgi", "edit_ca.cgi");
push(@{$self->{'wtitles_array'}}, $self->{'text_hash'}->{'ssl_title'}, $self->{'text_hash'}->{'ca_title'});
push(@{$self->{'wicons_array'}}, "images/ssl.gif", "images/ca.gif");

# Hide dis-allowed pages
%{$self->{'allow_hash'}} = map { $_, 1 } split(/\s+/, $self->{'access_hash'}->{'allow'});
%{$self->{'disallow_hash'}} = map { $_, 1 } split(/\s+/, $self->{'access_hash'}->{'disallow'});
for($i=0; $i<@{$self->{'wlinks_array'}}; $i++) {
	$self->{'wlinks_array'}->[$i] =~ /edit_(\S+)\.cgi/;
	if (%{$self->{'allow_hash'}} && !$self->{'allow_hash'}->{$1} ||
	    $self->{'disallow_hash'}->{$1} ||
	    $1 eq "webmin" && $self->{'gconfig_hash'}->{'os_type'} eq 'windows') {
		splice(@{$self->{'wlinks_array'}}, $i, 1);
		splice(@{$self->{'wtitles_array'}}, $i, 1);
		splice(@{$self->{'wicons_array'}}, $i, 1);
		$i--;
		}
	}
$self->icons_table(\@{$self->{'wlinks_array'}}, \@{$self->{'wtitles_array'}}, \@{$self->{'wicons_array'}});

print "<hr>\n";

print $self->ui_buttons_start();

if ($self->foreign_check("init")) {
	$self->foreign_require("init", "init-lib.pl");
	if ($main::init_object->{'init_mode'} eq "init" ||
	    $main::init_object->{'init_mode'} eq "win32" ||
	    $main::init_object->{'init_mode'} eq "rc") {
		$self->{'starting'} = $main::init_object->action_status("cpplus");
		print $self->ui_buttons_row("bootup.cgi",
		      $self->{'text_hash'}->{'index_boot'},
		      $self->{'text_hash'}->{'index_bootmsg'}.
		      ($self->{'miniserv_hash'}->{'inetd'} ? "<b>$self->{'text_hash'}->{'index_inetd'}</b>" :
		       !$ENV{'MINISERV_CONFIG'} ? "<b>$self->{'text_hash'}->{'index_apache'}</b>" : ""),
		      $self->ui_hidden("starting", $self->{'starting'}),
		      $self->ui_radio("boot", $self->{'starting'} == 2 ? 1 : 0,
				[ [ 1, $self->{'text_hash'}->{'yes'} ],
				  [ 0, $self->{'text_hash'}->{'no'} ] ]));
		}
	}

if (!$self->{'miniserv_hash'}->{'inetd'} && $ENV{'MINISERV_CONFIG'}) {
	print $self->ui_buttons_row("restart.cgi",
		      $self->{'text_hash'}->{'index_restart'}, $self->{'text_hash'}->{'index_restartmsg'});
	}

print $self->ui_buttons_end();

$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});

1;
		
}


1;

