#!/usr/bin/perl

&MAIN();

 sub MAIN {
# install_mod.cgi
# Download and install a webmin module

&ModuleLoader::preload_module('cpplus_class', "cpplus::CpplusLib");
$self = new cpplus::CpplusLib:: 'cpplus_class',%$self;

if ($ENV{REQUEST_METHOD} eq "POST") { $self->ReadParseMime(); }
else { $self->ReadParse(); $self->{'no_upload'} = 1; }

$| = 1;
$self->{'theme_no_table'} = 1 if ($self->{'in_hash'}->{'source'} == 2 || $self->{'in_hash'}->{'source'} == 4);
$self->ui_print_header(undef, $self->{'text_hash'}->{'install_title'}, "");

if ($self->{'in_hash'}->{'source'} == 0) {
	# from local file
	$self->error_setup($self->text('install_err1', $self->{'in_hash'}->{'file'}));
	$self->{'file'} = $self->{'in_hash'}->{'file'};
	if (!(-r $self->{'file'})) { &inst_error($self->{'text_hash'}->{'install_efile'}); }
	}
elsif ($self->{'in_hash'}->{'source'} == 1) {
	# from uploaded file
	$self->error_setup($self->{'text_hash'}->{'install_err2'});
	$self->{'need_unlink'} = 1;
	if ($self->{'no_upload'}) {
                &inst_error($self->{'text_hash'}->{'install_ebrowser'});
                }
	$self->{'file'} = $self->transname($self->file_basename($self->{'in_hash'}->{'upload_filename'}));
	open(MOD, ">$self->{'file'}");
	binmode(MOD);
	print MOD $self->{'in_hash'}->{'upload'};
	close(MOD);
	}
elsif ($self->{'in_hash'}->{'source'} == 2 || $self->{'in_hash'}->{'source'} == 4) {
	# from ftp or http url (possible third-party)
	$self->{'url'} = $self->{'in_hash'}->{'source'} == 2 ? $self->{'in_hash'}->{'url'} : $self->{'in_hash'}->{'third'};
	$self->error_setup($self->text('install_err3', $self->{'url'}));
	$self->{'file'} = $self->transname($self->file_basename($self->{'url'}));
	$self->{'need_unlink'} = 1;
	local $error;
	$self->{'progress_callback_url'} = $self->{'url'};
	if ($self->{'url'} =~ /^(http|https):\/\/([^\/]+)(\/.*)$/) {
		$self->{'ssl'} = $1 eq 'https';
		$self->{'host'} = $2; $self->{'page'} = $3; $self->{'port'} = $self->{'ssl'} ? 443 : 80;
		if ($self->{'host'} =~ /^(.*):(\d+)$/) { $self->{'host'} = $1; $self->{'port'} = $2; }
		$self->http_download($self->{'host'}, $self->{'port'}, $self->{'page'}, $self->{'file'}, \$error,
			       'progress_callback', $self->{'ssl'});
		}
	elsif ($self->{'url'} =~ /^ftp:\/\/([^\/]+)(:21)?\/(.*)$/) {
		$self->{'host'} = $1; $self->{'ffile'} = $3;
		$self->ftp_download($self->{'host'}, $self->{'ffile'}, $self->{'file'}, \$error, 'progress_callback');
		}
	else { &inst_error($self->{'text_hash'}->{'install_eurl'}); }
	&inst_error($error) if ($error);
	}
elsif ($self->{'in_hash'}->{'source'} == 3) {
	# from www.webmin.com
	$self->error_setup($self->{'text_hash'}->{'install_err4'});
	$self->{'in_hash'}->{'standard'} =~ /^\S+$/ || $self->error($self->{'text_hash'}->{'install_estandard'});
	$self->{'need_unlink'} = 1;
	local $error;

	# Find the URL of the package
	$self->{'mods'} = $self->list_standard_modules();
	ref($self->{'mods'}) || $self->error($self->text('standard_failed', $error));
	local ($info) = grep { $_->[0] eq $self->{'in_hash'}->{'standard'} } @{$self->{'mods'}};
	$info || $self->error($self->{'text_hash'}->{'install_emissing'});
	if ($self->{'config_hash'}->{'standard_url'}) {
		($self->{'host'}, $self->{'port'}, $self->{'page'}, $self->{'ssl'}) = $self->parse_http_url(
						$self->{'config_hash'}->{'standard_url'});
		$self->{'host'} || $self->error($self->{'text_hash'}->{'standard_eurl'});
		}
	else {
		($self->{'host'}, $self->{'port'}, $self->{'page'}, $self->{'ssl'}) = ($self->{'standard_host'}, $self->{'standard_port'},
					       $self->{'standard_page'}, $self->{'standard_ssl'});
		}
	($self->{'host'}, $self->{'port'}, $self->{'page'}, $self->{'ssl'}) = $self->parse_http_url(
		$info->[2], $self->{'host'}, $self->{'port'}, $self->{'page'}, $self->{'ssl'});
	$self->{'progress_callback_url'} = $info->[2];
	$self->{'file'} = $self->transname($info->[2]);
	$self->http_download($self->{'host'}, $self->{'port'}, $self->{'page'}, $self->{'file'}, \$error,
		       'progress_callback', $self->{'ssl'});
	&inst_error($error) if ($error);
	}

# Install the module(s)
$self->{'rv'} = $self->install_webmin_module($self->{'file'}, $self->{'need_unlink'}, $self->{'in_hash'}->{'nodeps'},
		       $self->{'in_hash'}->{'grant'} ? undef : [ split(/\s+/, $self->{'in_hash'}->{'grantto'}) ]);
if (ref($self->{'rv'})) {
	@{$self->{'mdescs_array'}} = @{$self->{'rv'}->[0]};
	@{$self->{'mdirs_array'}} = @{$self->{'rv'}->[1]};
	@{$self->{'msizes_array'}} = @{$self->{'rv'}->[2]};
	}
else {
	&inst_error($self->{'rv'});
	}

# Display something nice for the user
$self->read_file("$self->{'config_directory'}/cpplus.catnames", \%{$self->{'catnames_hash'}});
print "$self->{'text_hash'}->{'install_desc'} <p>\n";
print "<ul>\n";
for($i=0; $i<@{$self->{'mdescs_array'}}; $i++) {
	$self->{'mdirs_array'}->[$i] =~ /\/([^\/]+)$/;
	if (%{$self->{'minfo_hash'}} = $self->get_module_info($1)) {
		# Installed a module
		local $cat = $self->{'catnames_hash'}->{$self->{'minfo_hash'}->{'category'}};
		$cat = $self->{'text_hash'}->{"category_".$self->{'minfo_hash'}->{'category'}} if (!$cat);
		$cat = $self->{'text_hash'}->{"category_"} if (!$cat);
		print $self->text($self->{'minfo_hash'}->{'hidden'} ? 'install_line3' :
				'install_line2', "<b>$self->{'mdescs_array'}->[$i]</b>",
			    "<tt>$self->{'mdirs_array'}->[$i]</tt>", $self->{'msizes_array'}->[$i], $cat,
			    "../$self->{'minfo_hash'}->{'dir'}/"),
			    "<br>\n";
		}
	elsif (%{$self->{'tinfo_hash'}} = $self->get_theme_info($1)) {
		# Installed a theme
		print $self->text('themes_line', "<b>$self->{'mdescs_array'}->[$i]</b>",
			    "<tt>$self->{'mdirs_array'}->[$i]</tt>", $self->{'msizes_array'}->[$i]),
			    "<br>\n";
		}
	}
print "</ul><p>\n";
$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}

sub inst_error
{
	shift if ($self == $_[0]);

print "<b>$self->{'whatfailed'} : $_[0]</b> <p>\n";
$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
exit;
}


1;

