#!/usr/bin/perl

&MAIN();

 sub MAIN {
# newkey.cgi
# Create a new SSL key

&ModuleLoader::preload_module('cpplus_class', "cpplus::CpplusLib");
$self = new cpplus::CpplusLib:: 'cpplus_class',%$self;

$self->ReadParse();

# Validate inputs
$self->error_setup($self->{'text_hash'}->{'newkey_err'});
$self->{'in_hash'}->{'commonName_def'} || $self->{'in_hash'}->{'commonName'} =~ /^[A-Za-z0-9\.\-\*]+$/ ||
	$self->error($self->{'text_hash'}->{'newkey_ecn'});
$self->{'in_hash'}->{'newfile'} || $self->error($self->{'text_hash'}->{'newkey_efile'});
$self->{'in_hash'}->{'size_def'} || $self->{'in_hash'}->{'size'} =~ /^\d+$/ || $self->error($self->{'text_hash'}->{'newkey_esize'});
$self->{'in_hash'}->{'days'} =~ /^\d+$/ || $self->error($self->{'text_hash'}->{'newkey_edays'});

$self->ui_print_header(undef, $self->{'text_hash'}->{'newkey_title'}, "");

%{$self->{'aclconfig_hash'}} = $self->foreign_config('acl');
$self->foreign_require("acl", "acl-lib.pl");
if (!($self->{'cmd'} = $main::acl_object->get_ssleay())) {
	print "<p>",$self->text('newkey_ecmd', "<tt>$self->{'aclconfig_hash'}->{'ssleay'}</tt>",
			  "$self->{'gconfig_hash'}->{'webprefix'}/config.cgi?acl"),"<p>\n";
	$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
	exit;
	}

# Create key file
$self->{'ctemp'} = $self->transname();
$self->{'ktemp'} = $self->transname();
$self->{'outtemp'} = $self->transname();
$self->{'size'} = $self->{'in_hash'}->{'size_def'} ? $self->{'default_key_size'} : $self->{'in_hash'}->{'size'};
open(CA, "| $self->{'cmd'} req -newkey rsa:$self->{'size'} -x509 -nodes -out $self->{'ctemp'} -keyout $self->{'ktemp'} -days $self->{'in_hash'}->{'days'} >$self->{'outtemp'} 2>&1");
print CA ($self->{'in_hash'}->{'countryName'} || "."),"\n";
print CA ($self->{'in_hash'}->{'stateOrProvinceName'} || "."),"\n";
print CA ($self->{'in_hash'}->{'cityName'} || "."),"\n";
print CA ($self->{'in_hash'}->{'organizationName'} || "."),"\n";
print CA ($self->{'in_hash'}->{'organizationalUnitName'} || "."),"\n";
print CA ($self->{'in_hash'}->{'commonName_def'} ? "*" : $self->{'in_hash'}->{'commonName'}),"\n";
print CA ($self->{'in_hash'}->{'emailAddress'} || "."),"\n";
close(CA);
$self->{'rv'} = $?;
$self->{'out'} = `cat $self->{'outtemp'}`;
unlink($self->{'outtemp'});
if (!-r $self->{'ctemp'} || !-r $self->{'ktemp'} || $?) {
	print "<p>$self->{'text_hash'}->{'newkey_essl'}<br>\n";
	print "<pre>$self->{'out'}</pre>\n";
	$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
	exit;
	}
$self->lock_file($self->{'in_hash'}->{'newfile'});
$self->{'catout'} = `cat $self->{'ctemp'} $self->{'ktemp'} 2>&1 >'$self->{'in_hash'}->{'newfile'}'`;
unlink($self->{'ctemp'});
unlink($self->{'ktemp'});
if ($self->{'catout'} || $?) {
	print "<p>$self->{'text_hash'}->{'newkey_ecat'}<br>\n";
	print "<pre>$self->{'catout'}</pre>\n";
	$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
	exit;
	}
chmod(0600, $self->{'in_hash'}->{'newfile'});
$self->unlock_file($self->{'in_hash'}->{'newfile'});

print "<p>$self->{'text_hash'}->{'newkey_ok'}<br>\n";
$self->{'key'} = `cat '$self->{'in_hash'}->{'newfile'}'`;
print "<pre>$self->{'key'}</pre>";
$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

# Configure webmin to use the new file
if ($self->{'in_hash'}->{'usenew'}) {
	$self->lock_file($ENV{'MINISERV_CONFIG'});
	$self->get_miniserv_config(\%{$self->{'miniserv_hash'}});
	$self->{'miniserv_hash'}->{'keyfile'} = $self->{'in_hash'}->{'newfile'};
	delete($self->{'miniserv_hash'}->{'certfile'});
	$self->put_miniserv_config(\%{$self->{'miniserv_hash'}});
	$self->unlock_file($ENV{'MINISERV_CONFIG'});
	$self->restart_miniserv(1);
	$self->webmin_log("newkey", undef, undef, \%{$self->{'in_hash'}});
	}

1;
		
}


1;

