#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Replace the existing Webmin SSL key

&ModuleLoader::preload_module('cpplus_class', "cpplus::CpplusLib");
$self = new cpplus::CpplusLib:: 'cpplus_class',%$self;

$self->ReadParseMime();
$self->error_setup($self->{'text_hash'}->{'savekey_err'});

# Validate inputs
$self->{'key'} = $self->{'in_hash'}->{'key'} || $self->{'in_hash'}->{'keyfile'};
$self->{'key'} =~ s/\r//g;
$self->{'key'} =~ /BEGIN RSA PRIVATE KEY/ &&
  $self->{'key'} =~ /END RSA PRIVATE KEY/ || $self->error($self->{'text_hash'}->{'savekey_ekey'});
if (!$self->{'in_hash'}->{'cert_def'}) {
	# Make sure cert is valid
	$self->{'cert'} = $self->{'in_hash'}->{'cert'} || $self->{'in_hash'}->{'certfile'};
	$self->{'cert'} =~ s/\r//g;
	$self->{'cert'} =~ /BEGIN CERTIFICATE/ &&
	  $self->{'cert'} =~ /END CERTIFICATE/ || $self->error($self->{'text_hash'}->{'savekey_ecert'});
	}
else {
	# Make sure key contains cert
	$self->{'key'} =~ /BEGIN CERTIFICATE/ &&
	  $self->{'key'} =~ /END CERTIFICATE/ || $self->error($self->{'text_hash'}->{'savekey_ecert2'});
	}

# Save config and key file
$self->lock_file($ENV{'MINISERV_CONFIG'});
$self->get_miniserv_config(\%{$self->{'miniserv_hash'}});
$self->{'miniserv_hash'}->{'keyfile'} ||= "$config_directory/miniserv.pem";
$self->lock_file($self->{'miniserv_hash'}->{'keyfile'});
$self->open_tempfile(KEY, ">$self->{'miniserv_hash'}->{'keyfile'}");
$self->print_tempfile(KEY, $self->{'key'});
$self->close_tempfile(KEY);
$self->unlock_file($self->{'miniserv_hash'}->{'keyfile'});
if ($self->{'in_hash'}->{'cert_def'}) {
	delete($self->{'miniserv_hash'}->{'certfile'});
	}
else {
	$self->{'miniserv_hash'}->{'certfile'} ||= "$config_directory/miniserv.cert";
	$self->lock_file($self->{'miniserv_hash'}->{'certfile'});
	$self->open_tempfile(CERT, ">$self->{'miniserv_hash'}->{'certfile'}");
	$self->print_tempfile(CERT, $self->{'cert'});
	$self->close_tempfile(CERT);
	$self->unlock_file($self->{'miniserv_hash'}->{'certfile'});
	}
$self->put_miniserv_config(\%{$self->{'miniserv_hash'}});
$self->unlock_file($ENV{'MINISERV_CONFIG'});

# Tell the user
$self->ui_print_header(undef, $self->{'text_hash'}->{'savekey_title'}, "");

if ($self->{'miniserv_hash'}->{'certfile'}) {
	print $self->text('savekey_done2', "<tt>$self->{'miniserv_hash'}->{'keyfile'}</tt>",
				     "<tt>$self->{'miniserv_hash'}->{'certfile'}</tt>"),"<p>\n";
	}
else {
	print $self->text('savekey_done', "<tt>$self->{'miniserv_hash'}->{'keyfile'}</tt>"),"<p>\n";
	}

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

$self->webmin_log("savekey");
$self->restart_miniserv(1);
1;
		
}


1;

