#!/usr/bin/perl

&MAIN();

 sub MAIN {
# setup_ca.cgi
# Setup a new certificate authority

&ModuleLoader::preload_module('cpplus_class', "cpplus::CpplusLib");
$self = new cpplus::CpplusLib:: 'cpplus_class',%$self;

$self->foreign_require("acl", "acl-lib.pl");
$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'ca_err'});
$self->{'in_hash'}->{'size_def'} || $self->{'in_hash'}->{'size'} =~ /^\d+$/ || $self->error($self->{'text_hash'}->{'newkey_esize'});

$self->lock_file($ENV{'MINISERV_CONFIG'});
$self->get_miniserv_config(\%{$self->{'miniserv_hash'}});
$self->setup_ca() if (!-r $self->{'miniserv_hash'}->{'ca'});
$self->lock_file($self->{'miniserv_hash'}->{'ca'});
$self->{'ctemp'} = $self->transname();
$self->{'ktemp'} = $self->transname();
$self->{'outtemp'} = $self->transname();
%{$self->{'aclconfig_hash'}} = $self->foreign_config('acl');
$self->{'size'} = $self->{'in_hash'}->{'size_def'} ? $self->{'default_key_size'} : $self->{'in_hash'}->{'size'};
$self->{'cmd'} = $main::acl_object->get_ssleay();
open(CA, "| $self->{'cmd'} req -newkey rsa:$self->{'size'} -x509 -nodes -out $self->{'ctemp'} -keyout $self->{'ktemp'} -config $self->{'config_directory'}/acl/openssl.cnf -days 1825 >$self->{'outtemp'} 2>&1");
print CA $self->{'in_hash'}->{'countryName'},"\n";
print CA $self->{'in_hash'}->{'stateOrProvinceName'},"\n";
print CA "\n";
print CA $self->{'in_hash'}->{'organizationName'},"\n";
print CA $self->{'in_hash'}->{'organizationalUnitName'},"\n";
print CA $self->{'in_hash'}->{'commonName'},"\n";
print CA $self->{'in_hash'}->{'emailAddress'},"\n";
close(CA);
$self->{'out'} = `cat $self->{'outtemp'}`;
unlink($self->{'outtemp'});
if (!-r $self->{'ctemp'} || !-r $self->{'ktemp'}) {
	$self->error("<pre>$self->{'out'}</pre>");
	}
system("cat $self->{'ctemp'} $self->{'ktemp'} >$self->{'miniserv_hash'}->{'ca'}");
unlink($self->{'ctemp'});
unlink($self->{'ktemp'});
unlink("$self->{'config_directory'}/acl/crl.pem");
chmod(0700, $self->{'miniserv_hash'}->{'ca'});
$self->unlock_file($self->{'miniserv_hash'}->{'ca'});

$self->put_miniserv_config(\%{$self->{'miniserv_hash'}});
$self->unlock_file($ENV{'MINISERV_CONFIG'});
$self->ui_print_header(undef, $self->{'text_hash'}->{'ca_title'}, "");
print "<p>$self->{'text_hash'}->{'ca_setupok'}<p>\n";
$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
$self->restart_miniserv(1);
$self->webmin_log("setupca", undef, undef, \%{$self->{'in_hash'}});

1;
		
}


1;

