#!/usr/bin/perl

&MAIN();

 sub MAIN {
# update.cgi
# Find and install modules that need updating

&ModuleLoader::preload_module('cpplus_class', "cpplus::CpplusLib");
$self = new cpplus::CpplusLib:: 'cpplus_class',%$self;

$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'update_err'});

# Display the results and maybe take action
$| = 1;
$self->{'theme_no_table'} = 1;
$self->ui_print_header(undef, $self->{'text_hash'}->{'update_title'}, "");

print "<b>",$self->text('update_info'),"</b><p>\n";

# Fetch updates
@{$self->{'urls_array'}} = $self->{'in_hash'}->{'source'} == 0 ? ( $self->{'update_url'} ) : split(/\r?\n/, $self->{'in_hash'}->{'other'});
foreach $url (@{$self->{'urls_array'}}) {
	($self->{'updates'}, $self->{'host'}, $self->{'port'}, $self->{'page'}, $self->{'ssl'}) =
		$self->fetch_updates($url, $self->{'in_hash'}->{'upuser'}, $self->{'in_hash'}->{'uppass'});
	foreach $u (@{$self->{'updates'}}) {
		# Skip modules that are not for this version of Webmin, IF the
		# module is a core module or is not installed
		local %minfo = $self->get_module_info($u->[0]);
		local %tinfo = $self->get_theme_info($u->[0]);
		local %info = %minfo ? %minfo : %tinfo;
		next if (($u->[1] >= $self->get_webmin_base_version() + .01 ||
			  $u->[1] < $self->get_webmin_base_version()) &&
			 (!%info || $info{'longdesc'} || !$self->{'in_hash'}->{'third'}));

		$self->{'count'}++;
		if (!%info && !$self->{'in_hash'}->{'missing'}) {
			# Module is not installed on this system
			print $self->text('update_mmissing',
				    "<b>$u->[0]</b>"),"<p>\n";
			next;
			}
		if (%info && $info{'version'} >= $u->[1]) {
			# Module is already up to date
			if (!$self->{'donemodule_hash'}->{$u->[0]}) {
				print $self->text('update_malready',
					    "<b>$u->[0]</b>"),"<p>\n";
				}
			next;
			}
		local $osinfo = { 'os_support' => $u->[3] };
		if (!$self->check_os_support($osinfo)) {
			# Module does not support this OS
			print $self->text('update_mos', "<b>$u->[0]</b>"),"<p>\n";
			next;
			}
		if ($self->{'itype'} = $self->get_module_install_type($u->[0])) {
			# Module was installed from an RPM/DEB - only allow if
			# update is in the same format
			if ($u->[2] !~ /\.$self->{'itype'}$/i) {
				print $self->text('update_mtype', "<b>$u->[0]</b>",
							    uc($self->{'itype'})),"<p>\n";
				next;
				}
			}
		if ($self->{'in_hash'}->{'show'}) {
			# Just tell the user what would be done
			print $self->text('update_mshow', "<b>$u->[0]</b>", "<b>$u->[1]</b>"),
			      "<br>\n";
			print "&nbsp;" x 10;
			print "$self->{'text_hash'}->{'update_fixes'} : " if ($info{'longdesc'});
			print $u->[4],"<p>\n";
			$self->{'donemodule_hash'}->{$u->[0]} = 1;
			}
		else {
			# Actually do the update ..
			local (@mdescs, @mdirs, @msizes);
			print $self->text('update_mok', "<b>$u->[0]</b>", "<b>$u->[1]</b>"),
			      "<br>\n";
			print "&nbsp;" x 10;
			print "$self->{'text_hash'}->{'update_fixes'} : " if ($info{'longdesc'});
			print $u->[4],"<br>\n";
			($self->{'mhost'}, $self->{'mport'}, $self->{'mpage'}, $self->{'mssl'}) =
				$self->parse_http_url($u->[2], $self->{'host'}, $self->{'port'}, $self->{'page'}, $self->{'ssl'});
			($self->{'mfile'} = $self->{'mpage'}) =~ s/^(.*)\///;
			$self->{'mtemp'} = $self->transname($self->{'mfile'});
			$self->{'progress_callback_url'} = $u->[2];
			$self->{'progress_callback_prefix'} = "&nbsp;" x 10;
			$self->http_download($self->{'mhost'}, $self->{'mport'}, $self->{'mpage'}, $self->{'mtemp'}, undef,
				       'progress_callback', $self->{'mssl'},
				       $self->{'in_hash'}->{'upuser'}, $self->{'in_hash'}->{'uppass'});
			$self->{'irv'} = $self->install_webmin_module($self->{'mtemp'}, 1, 0,
						      [ $self->{'base_remote_user'} ]);
			print "&nbsp;" x 10;
			if (!ref($self->{'irv'})) {
				print $self->text('update_failed', $self->{'irv'}),"<p>\n";
				}
			else {
				print $self->text('update_mdesc', "<b>$self->{'irv'}->[0]->[0]</b>",
					    "<b>$self->{'irv'}->[2]->[0]</b>"),"<p>\n";
				$self->{'donemodule_hash'}->{$self->{'irv'}->[0]->[0]} = 1;
				}
			}
		}
	}
print $self->text('update_none'),"<br>\n" if (!$self->{'count'});

# Check if a new version of webmin itself is available
$self->{'file'} = $self->transname();
$self->http_download('www.webmin.com', 80, '/', $self->{'file'});
open(FILE, $self->{'file'});
while(<FILE>) {
	if (/webmin-([0-9\.]+)\.tar\.gz/) {
		$self->{'version'} = $1;
		last;
		}
	}
close(FILE);
unlink($self->{'file'});
if ($self->{'version'} > $self->get_webmin_version()) {
	print "<b>",$self->text('update_version', $self->{'version'}),"</b><p>\n";
	}

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

