#!/usr/bin/perl

&MAIN();

 sub MAIN {
# update_sched.cgi
# Schedule the auto-updating of webmin modules

&ModuleLoader::preload_module('cpplus_class', "cpplus::CpplusLib");
$self = new cpplus::CpplusLib:: 'cpplus_class',%$self;

$self->foreign_require("cron", "cron-lib.pl");
$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'update_err'});

# Validate inputs
$self->lock_file("$self->{'module_config_directory'}/config");
if ($self->{'in_hash'}->{'source'} == 0) {
	$self->{'config_hash'}->{'upsource'} = undef;
	}
else {
	@{$self->{'urls_array'}} = ( );
	foreach $url (split(/\r?\n/, $self->{'in_hash'}->{'other'})) {
		$url =~ /^http:\/\/([^:\/]+)(:(\d+))?(\/\S*)$/ ||
			$self->error($self->{'text_hash'}->{'update_eurl'});
		push(@{$self->{'urls_array'}}, $url);
		}
	@{$self->{'urls_array'}} || $self->error($self->{'text_hash'}->{'update_eurl'});
	$self->{'config_hash'}->{'upsource'} = join("\t", @{$self->{'urls_array'}});
	}
$self->{'config_hash'}->{'update'} = $self->{'in_hash'}->{'enabled'};
if ($self->{'config_hash'}->{'cron_mode'} == 0) {
	$self->{'in_hash'}->{'hour'} =~ /^\d+$/ && $self->{'in_hash'}->{'hour'} < 24 ||
		$self->error($self->{'text_hash'}->{'update_ehour'});
	$self->{'config_hash'}->{'uphour'} = $self->{'in_hash'}->{'hour'};
	$self->{'in_hash'}->{'mins'} =~ /^\d+$/ && $self->{'in_hash'}->{'mins'} < 60 ||
		$self->error($self->{'text_hash'}->{'update_emins'});
	$self->{'config_hash'}->{'upmins'} = $self->{'in_hash'}->{'mins'};
	$self->{'in_hash'}->{'days'} =~ /^\d+$/ ||
		$self->error($self->{'text_hash'}->{'update_edays'});
	$self->{'config_hash'}->{'updays'} = $self->{'in_hash'}->{'days'};
	}
$self->{'config_hash'}->{'upshow'} = $self->{'in_hash'}->{'show'};
$self->{'config_hash'}->{'upmissing'} = $self->{'in_hash'}->{'missing'};
$self->{'config_hash'}->{'upthird'} = $self->{'in_hash'}->{'third'};
$self->{'config_hash'}->{'upquiet'} = $self->{'in_hash'}->{'quiet'};
$self->{'config_hash'}->{'upemail'} = $self->{'in_hash'}->{'email'};
$self->{'config_hash'}->{'upuser'} = $self->{'in_hash'}->{'upuser'};
$self->{'config_hash'}->{'uppass'} = $self->{'in_hash'}->{'uppass'};
!$self->{'in_hash'}->{'show'} || $self->{'in_hash'}->{'email'} || $self->error($self->{'text_hash'}->{'update_eemail'});
$self->write_file("$self->{'module_config_directory'}/config", \%{$self->{'config_hash'}});
$self->unlock_file("$self->{'module_config_directory'}/config");

# Setup the cron job
@{$self->{'jobs_array'}} = $main::cron_object->list_cron_jobs();
$self->{'job'} = $self->find_cron_job(\@{$self->{'jobs_array'}});
$self->lock_file($self->{'cron_cmd'});
if ($self->{'job'}) {
	$main::cron_object->delete_cron_job($self->{'job'});
	unlink($self->{'cron_cmd'});
	}
if ($self->{'in_hash'}->{'enabled'}) {
	# Create the program that cron calls
	$main::cron_object->create_wrapper($self->{'cron_cmd'}, $self->{'module_name'}, "update.pl");

	$self->{'njob'} = { 'user' => 'root', 'active' => 1,
		  'command' => $self->{'cron_cmd'} };
	if ($self->{'config_hash'}->{'cron_mode'} == 0) {
		# Setup the actual cron job, simply
		if ($self->{'in_hash'}->{'days'} == 1) {
			@{$self->{'days_array'}} = ( "*" );
			}
		else {
			for($i=1; $i<=31; $i+=$self->{'in_hash'}->{'days'}) {
				push(@{$self->{'days_array'}}, $i);
				}
			}
		$self->{'njob'}->{'mins'} = $self->{'in_hash'}->{'mins'};
		$self->{'njob'}->{'hours'} = $self->{'in_hash'}->{'hour'};
		$self->{'njob'}->{'days'} = join(",",@{$self->{'days_array'}});
		$self->{'njob'}->{'months'} = '*';
		$self->{'njob'}->{'weekdays'} = '*';
		}
	else {
		# Create complex cron job
		$main::cron_object->parse_times_input($self->{'njob'}, \%{$self->{'in_hash'}});
		}
	$self->foreign_call("cron", "create_cron_job", $self->{'njob'});
	}
$self->unlock_file($self->{'cron_cmd'});
$self->redirect("");

1;
		
}


1;

