#!/usr/bin/perl

&MAIN();

 sub MAIN {
# rollback.cgi
# Revert all changed config files, after asking for confirmation

&ModuleLoader::preload_module('cppluslog_class', "cppluslog::CppluslogLib");
$self = new cppluslog::CppluslogLib:: 'cppluslog_class',%$self;

$self->ReadParse();

$self->{'act'} = $self->get_action($self->{'in_hash'}->{'id'});
$self->{'access_hash'}->{'rollback'} ||  $self->error($self->{'text_hash'}->{'rollback_ecannot'});
$self->can_user($self->{'act'}->{'user'}) || $self->error($self->{'text_hash'}->{'view_ecannot'});
$self->can_mod($self->{'act'}->{'module'}) || $self->error($self->{'text_hash'}->{'view_ecannot'});
%r = map { $_, 1 } split(/\0/, $self->{'in_hash'}->{'r'});
%r || $self->error($self->{'text_hash'}->{'rollback_enone'});
@{$self->{'files_array'}} = grep { $r{$_->{'file'}} } $self->list_files($self->{'act'});

$self->ui_print_header(undef, $self->{'text_hash'}->{'rollback_title'}, "");
if ($self->{'in_hash'}->{'confirm'}) {
	# Do it!
	foreach $f (@{$self->{'files_array'}}) {
		next if ($self->{'done_hash'}->{$f->{'file'}});
		if (-d $f->{'file'} || $f->{'type'} == 1) {
			# Skip directory
			print $self->text('rollback_skipdir',"<tt>$f->{'file'}</tt>");
			}
		elsif (-l $f->{'file'} && $f->{'type'} == 2 ||
		       !-e $f->{'file'} && $f->{'type'} == 2 ||
		       !-l $f->{'file'} && $f->{'type'} == 2) {
			# Modify or create link
			$self->unlink_file($f->{'file'});
			$self->symlink_file($f->{'data'}, $f->{'file'});
			print $self->text('rollback_madelink',
				    "<tt>$f->{'file'}</tt>",
				    "<tt>$f->{'data'}</tt>");
			}
		elsif (-e $f->{'file'} && -l $f->{'file'} &&
		       $f->{'type'} == 0) {
			# Remove link and create file
			$self->unlink_file($f->{'file'});
			$self->open_tempfile(FILE, ">$f->{'file'}");
			$self->print_tempfile(FILE, $f->{'data'});
			$self->close_tempfile(FILE);
			print $self->text('rollback_madefile',
				    "<tt>$f->{'file'}</tt>");
			}
		elsif ($f->{'type'} == -1) {
			if (-e $f->{'file'}) {
				# Remove file
				unlink($f->{'file'});
				print $self->text('rollback_deleted',
					    "<tt>$f->{'file'}</tt>");
				}
			else {
				print $self->text('rollback_nodeleted',
					    "<tt>$f->{'file'}</tt>");
				}
			}
		else {
			# Replace file with old contents
			$self->open_tempfile(FILE, ">$f->{'file'}");
			$self->print_tempfile(FILE, $f->{'data'});
			$self->close_tempfile(FILE);
			print $self->text('rollback_modfile',
				    "<tt>$f->{'file'}</tt>");
			}
		print "<br>\n";
		$self->{'done_hash'}->{$f->{'file'}}++;
		}
	}
else {
	# Show the user what will be done
	print $self->ui_form_start("rollback.cgi");
	print $self->ui_hidden("id", $self->{'in_hash'}->{'id'}),"\n";
	foreach $r (keys %r) {
		print $self->ui_hidden("r", $r);
		}
	print $self->{'text_hash'}->{'rollback_rusure'},"<p>\n";
	foreach $f (@{$self->{'files_array'}}) {
		next if ($self->{'done_hash'}->{$f->{'file'}});
		print $self->ui_table_start("<tt>$f->{'file'}</tt>", "width=100%", 2);
		print "<tr> <td colspan=2>";
		if (-d $f->{'file'} || $f->{'type'} == 1) {
			# Is a directory
			print $self->text('rollback_isdir');
			}
		elsif (-l $f->{'file'} && $f->{'type'} == 2 ||
		       !-e $f->{'file'} && $f->{'type'} == 2) {
			# Was a link, and is one now
			local $lnk = readlink($f->{'file'});
			if (!-e $f->{'file'}) {
				print $self->text('rollback_clink', "<tt>$f->{'data'}</tt>");
				$self->{'count'}++;
				}
			elsif ($lnk ne $f->{'data'}) {
				print $self->text('rollback_link', "<tt>$f->{'data'}</tt>", "<tt>$lnk</tt>");
				$self->{'count'}++;
				}
			else {
				print $self->text('rollback_nolink');
				}
			}
		elsif (-e $f->{'file'} && -l $f->{'file'} &&
		       $f->{'type'} == 0) {
			# Was a file, but is now a link
			local $lnk = readlink($f->{'file'});
			print $self->text('rollback_makefile', "<tt>$lnk</tt>");
			print "<pre>$f->{'data'}</pre>";
			$self->{'count'}++;
			}
		elsif (!-l $f->{'file'} && $f->{'type'} == 2) {
			# Was a link, but is now a file
			print $self->text('rollback_makelink', "<tt>$f->{'data'}</tt>");
			$self->{'count'}++;
			}
		elsif ($f->{'type'} == -1) {
			# Was created
			if (-e $f->{'file'}) {
				print $self->text('rollback_delete',
					    "<tt>$f->{'file'}</tt>");
				$self->{'count'}++;
				}
			else {
				print $self->text('rollback_nodelete',
					    "<tt>$f->{'file'}</tt>");
				}
			}
		elsif (!-e $f->{'file'}) {
			# No longer exists
			print $self->{'text_hash'}->{'rollback_fillfile'};
			print "<pre>$f->{'data'}</pre>";
			$self->{'count'}++;
			}
		else {
			# Was a file, and is one now
			local $qnew = quotemeta($f->{'file'});
			local $temp = $self->transname();
			open(TEMP, ">$temp");
			print TEMP $f->{'data'};
			close(TEMP);
			local $out = `diff $qnew $temp`;
			if ($out) {
				print $self->{'text_hash'}->{'rollback_changes'};
				print "<pre>$out</pre>";
				$self->{'count'}++;
				}
			else {
				print $self->{'text_hash'}->{'rollback_nochanges'};
				}
			}
		$self->{'done_hash'}->{$f->{'file'}}++;
		print "</td> </tr>\n";
		print $self->ui_table_end();
		print "<br>\n";
		}
	if ($self->{'count'}) {
		print $self->ui_form_end([ [ "confirm", $self->{'text_hash'}->{'rollback_ok'} ] ]);
		}
	else {
		print "<b>$self->{'text_hash'}->{'rollback_none'}</b>\n";
		print $self->ui_form_end();
		}
	}
$self->ui_print_footer("view.cgi?id=$self->{'in_hash'}->{'id'}", $self->{'text_hash'}->{'view_return'},
		 "", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

