#!/usr/bin/perl

&MAIN();

 sub MAIN {
# search.cgi
# Find webmin actions

&ModuleLoader::preload_module('cppluslog_class', "cppluslog::CppluslogLib");
$self = new cppluslog::CppluslogLib:: 'cppluslog_class',%$self;

require 'timelocal.pl';
$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'search_err'});

# Parse entered time ranges
if ($self->{'in_hash'}->{'tall'} == 2) {
	@{$self->{'now_array'}} = localtime(time());
	$from = timelocal(0, 0, 0, $self->{'now_array'}->[3], $self->{'now_array'}->[4], $self->{'now_array'}->[5]);
	$to = timelocal(59, 59, 23, $self->{'now_array'}->[3], $self->{'now_array'}->[4], $self->{'now_array'}->[5]);
	$self->{'in_hash'}->{'tall'} = 0;
	}
elsif ($self->{'in_hash'}->{'tall'} == 3) {
	@{$self->{'now_array'}} = localtime(time()-24*60*60);
	$from = timelocal(0, 0, 0, $self->{'now_array'}->[3], $self->{'now_array'}->[4], $self->{'now_array'}->[5]);
	$to = timelocal(59, 59, 23, $self->{'now_array'}->[3], $self->{'now_array'}->[4], $self->{'now_array'}->[5]);
	$self->{'in_hash'}->{'tall'} = 0;
	}
elsif ($self->{'in_hash'}->{'tall'} == 0) {
	$from = &parse_time('from');
	$to = &parse_time('to');
	$to = $to ? $to + 24*60*60 - 1 : time();
	}

$self->ui_print_header(undef, $self->{'text_hash'}->{'search_title'}, "");

# Perform initial search in index
$self->build_log_index(\%{$self->{'index_hash'}});
open(LOG, $self->{'webmin_logfile'});
while(($self->{'id'}, $self->{'idx'}) = each %{$self->{'index_hash'}}) {
	local ($pos, $time, $user, $module, $sid) = split(/\s+/, $self->{'idx'});
	if (($self->{'in_hash'}->{'uall'} == 1 ||
	     $self->{'in_hash'}->{'uall'} == 0 && $self->{'in_hash'}->{'user'} eq $user ||
	     $self->{'in_hash'}->{'uall'} == 2 && $self->{'in_hash'}->{'nuser'} ne $user) &&
	    ($self->{'in_hash'}->{'mall'} || $self->{'in_hash'}->{'module'} eq $module) &&
	    (!$self->{'in_hash'}->{'sid'} || $self->{'in_hash'}->{'sid'} eq $sid) &&
	    ($self->{'in_hash'}->{'tall'} || $from < $time && $to > $time)) {
		# Passed index check .. now look at actual log entry
		seek(LOG, $pos, 0);
		$self->{'line'} = <LOG>;
		$act = $self->parse_logline($self->{'line'});

		# Check Webmin server
		next if (!$self->{'in_hash'}->{'wall'} && $self->{'in_hash'}->{'webmin'} ne $act->{'webmin'});

		# Check modified files
		if ($self->{'gconfig_hash'}->{'logfiles'} && !$self->{'in_hash'}->{'fall'}) {
			# Make sure the specified file was modified
			local $found = 0;
			foreach $d ($self->list_diffs($act)) {
				if ($d->{'object'} &&
				    $d->{'object'} eq $self->{'in_hash'}->{'file'}) {
					$found++;
					last;
					}
				}
			next if (!$found);
			}
		next if (!$self->can_user($act->{'user'}));
		next if (!$self->can_mod($act->{'module'}));
		push(@{$self->{'match_array'}}, $act);
		}
	}
close(LOG);

# Build search description
@{$self->{'from_array'}} = localtime($from);
@{$self->{'to_array'}} = localtime($to);
$self->{'fromstr'} = sprintf "%2.2d/%s/%4.4d",
	$self->{'from_array'}->[3], $self->{'text_hash'}->{"smonth_".($self->{'from_array'}->[4]+1)}, $self->{'from_array'}->[5]+1900;
$self->{'tostr'} = sprintf "%2.2d/%s/%4.4d",
	$self->{'to_array'}->[3], $self->{'text_hash'}->{"smonth_".($self->{'to_array'}->[4]+1)}, $self->{'to_array'}->[5]+1900;
if (!$self->{'in_hash'}->{'mall'}) {
	%minfo = $self->get_module_info($self->{'in_hash'}->{'module'});
	}
$self->{'searchmsg'} = join(" ",
	$self->{'in_hash'}->{'uall'} == 0 ? $self->text('search_critu',
		 "<tt>".$self->html_escape($self->{'in_hash'}->{'user'})."</tt>") :
	$self->{'in_hash'}->{'uall'} == 2 ? $self->text('search_critnu',
		 "<tt>".$self->html_escape($self->{'in_hash'}->{'nuser'})."</tt>") : "",
	$self->{'in_hash'}->{'mall'} ? '' : $self->text('search_critm',
		 "<tt>".$self->html_escape($minfo{'desc'})."</tt>"),
	$self->{'in_hash'}->{'tall'} ? '' : 
	  $self->{'fromstr'} eq $self->{'tostr'} ? $self->text('search_critt2', $self->{'tostr'}) :
	    $self->text('search_critt', $self->{'fromstr'}, $self->{'tostr'}));

if (@{$self->{'match_array'}}) {
	if ($self->{'in_hash'}->{'sid'}) {
		print "<b>",$self->text('search_sid', "<tt>$self->{'match_array'}->[0]->{'user'}</tt>",
				  "<tt>$self->{'in_hash'}->{'sid'}</tt>")," ..</b><p>\n";
		}
	elsif ($self->{'in_hash'}->{'uall'} == 1 && $self->{'in_hash'}->{'mall'} && $self->{'in_hash'}->{'tall'}) {
		print "<b>$self->{'text_hash'}->{'search_critall'} ..</b><p>\n";
		}
	else {
		@{$self->{'from_array'}} = localtime($from); @{$self->{'to_array'}} = localtime($to);
		$self->{'fromstr'} = sprintf "%2.2d/%s/%4.4d",
			$self->{'from_array'}->[3], $self->{'text_hash'}->{"smonth_".($self->{'from_array'}->[4]+1)}, $self->{'from_array'}->[5]+1900;
		$self->{'tostr'} = sprintf "%2.2d/%s/%4.4d",
			$self->{'to_array'}->[3], $self->{'text_hash'}->{"smonth_".($self->{'to_array'}->[4]+1)}, $self->{'to_array'}->[5]+1900;
		%minfo = $self->get_module_info($self->{'in_hash'}->{'module'}) if (!$self->{'in_hash'}->{'mall'});
		print "<b>$self->{'text_hash'}->{'search_crit'} $self->{'searchmsg'} ...</b><p>\n";
		}
	print $self->ui_columns_start(
		[ $self->{'text_hash'}->{'search_action'},
		  $self->{'text_hash'}->{'search_module'},
		  $self->{'text_hash'}->{'search_user'},
		  $self->{'text_hash'}->{'search_host'},
		  $self->{'config_hash'}->{'host_search'} ? ( $self->{'text_hash'}->{'search_webmin'} ) : ( ),
		  $self->{'text_hash'}->{'search_date'},
		  $self->{'text_hash'}->{'search_time'} ], "100");
	foreach $act (sort { $b->{'time'} <=> $a->{'time'} } @{$self->{'match_array'}}) {
		local @tm = localtime($act->{'time'});
		local $m = $act->{'module'};
		local $d;
		$self->{'minfo'} = $self->{'minfo_cache_hash'}->{$m};
		if (!$self->{'minfo'}) {
			# first time seeing module ..
			local %minfo = $self->get_module_info($m);
			$self->{'minfo'} = $self->{'minfo_cache_hash'}->{$m} = \%minfo;
			if (-r "../$m/log_parser.pl") {
				$self->foreign_require($m, "log_parser.pl");
				$self->{'parser_hash'}->{$m}++;
				}
			}

		local @cols;
		$d = $self->foreign_call($m, "parse_webmin_log",
				  $act->{'user'}, $act->{'script'},
				  $act->{'action'}, $act->{'type'},
				  $act->{'object'}, $act->{'param'})
					if ($self->{'parser_hash'}->{$m});
		local $desc;
		if ($d) {
			$desc = $d;
			}
		elsif ($act->{'action'} eq '_config_') {
			$desc = $self->{'text_hash'}->{'search_config'};
			}
		else {
			$desc = sprintf "%s %s %s\n",
				$act->{'action'},
				$act->{'type'} ? $act->{'type'} : '',
				$act->{'object'} ? $act->{'object'} : '';
			}
		push(@cols, "<a href='view.cgi?id=$act->{'id'}".
		      "&return=".$self->urlize($self->{'in_hash'}->{'return'}).
		      "&returndesc=".$self->urlize($self->{'in_hash'}->{'returndesc'}).
		      "'>$desc</a>");
		push(@cols, $self->{'minfo'}->{'desc'}, $act->{'user'}, $act->{'ip'});
		if ($self->{'config_hash'}->{'host_search'}) {
			push(@cols, $act->{'webmin'});
			}
		push(@cols, split(/\s+/, $self->make_date($act->{'time'})));
		print $self->ui_columns_row(\@cols);
		}
	print $self->ui_columns_end();
	}
else {
	# Tell the user that nothing matches
	print "<p><b>$self->{'text_hash'}->{'search_none2'} $self->{'searchmsg'}.</b><p>\n";
	}

if ($self->{'in_hash'}->{'return'}) {
	$self->ui_print_footer($self->{'in_hash'}->{'return'}, $self->{'in_hash'}->{'returndesc'});
	}
else {
	$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
	}

1;
		
}

sub parse_time
{
	shift if ($self == $_[0]);

local $d = $self->{'in_hash'}->{"$_[0]_d"};
local $m = $self->{'in_hash'}->{"$_[0]_m"};
local $y = $self->{'in_hash'}->{"$_[0]_y"};
return 0 if (!$d && !$y);
local $rv;
eval { $rv = timelocal(0, 0, 0, $d, $m, $y-1900) };
$self->error($self->{'text_hash'}->{'search_etime'}) if ($@);
return $rv;
}


1;

