#!/usr/bin/perl

&MAIN();

 sub MAIN {
# view.cgi
# Show details of the action, including changed files

&ModuleLoader::preload_module('cppluslog_class', "cppluslog::CppluslogLib");
$self = new cppluslog::CppluslogLib:: 'cppluslog_class',%$self;

$self->ReadParse();

# find the log record to view
$self->{'act'} = $self->get_action($self->{'in_hash'}->{'id'});
if (-r "../$self->{'act'}->{'module'}/log_parser.pl") {
	$self->foreign_require($self->{'act'}->{'module'}, "log_parser.pl");
	$self->{'parser'}++;
	}
$self->can_user($self->{'act'}->{'user'}) || $self->error($self->{'text_hash'}->{'view_ecannot'});
$self->can_mod($self->{'act'}->{'module'}) || $self->error($self->{'text_hash'}->{'view_ecannot'});

# display info about the action
$self->ui_print_header(undef, $self->{'text_hash'}->{'view_title'}, "");

@{$self->{'files_array'}} = $self->list_files($self->{'act'});
if (@{$self->{'files_array'}}) {
	print $self->ui_form_start("rollback.cgi");
	print $self->ui_hidden("id", $self->{'in_hash'}->{'id'});
	}

print $self->ui_table_start($self->text('view_header', $self->{'act'}->{'id'}),
		      "width=100%", 4);

$d = $self->foreign_call($self->{'act'}->{'module'}, "parse_webmin_log",
		   $self->{'act'}->{'user'}, $self->{'act'}->{'script'},
		   $self->{'act'}->{'action'}, $self->{'act'}->{'type'},
		   $self->{'act'}->{'object'}, $self->{'act'}->{'param'}, 1) if ($self->{'parser'});
print $self->ui_table_row($self->{'text_hash'}->{'view_action'},
	$d ? $d :
	$self->{'act'}->{'action'} eq '_config_' ? $self->{'text_hash'}->{'search_config'} :
		join(" ", $self->{'act'}->{'action'}, $self->{'act'}->{'type'}, $self->{'act'}->{'object'}),
	3);

%{$self->{'minfo_hash'}} = $self->get_module_info($self->{'act'}->{'module'});
print $self->ui_table_row($self->{'text_hash'}->{'view_module'},
		    $self->{'minfo_hash'}->{'desc'});

print $self->ui_table_row($self->{'text_hash'}->{'view_script'},
		    "<tt>$self->{'act'}->{'module'}/$self->{'act'}->{'script'}</tt>");

print $self->ui_table_row($self->{'text_hash'}->{'view_user'},
		    $self->{'act'}->{'user'});

print $self->ui_table_row($self->{'text_hash'}->{'view_ip'},
		    $self->{'act'}->{'ip'});

if ($self->{'act'}->{'sid'} ne '-') {
	print $self->ui_table_row($self->{'text_hash'}->{'view_sid'},
		"<a href='search.cgi?sid=$self->{'act'}->{'sid'}&uall=1&mall=1&tall=1&fall=1&return=".$self->urlize($self->{'in_hash'}->{'return'})."&returndesc=".$self->urlize($self->{'in_hash'}->{'returndesc'})."'>$self->{'act'}->{'sid'}</a>");
	}

@{$self->{'tm_array'}} = localtime($self->{'act'}->{'time'});
print $self->ui_table_row($self->{'text_hash'}->{'view_time'},
		    sprintf("%2.2d/%s/%4.4d %2.2d:%2.2d:%2.2d",
			$self->{'tm_array'}->[3], $self->{'text_hash'}->{"smonth_".($self->{'tm_array'}->[4]+1)}, $self->{'tm_array'}->[5]+1900,
			$self->{'tm_array'}->[2], $self->{'tm_array'}->[1], $self->{'tm_array'}->[0]));

if ($self->{'act'}->{'webmin'}) {
	print $self->ui_table_row($self->{'text_hash'}->{'view_host'},
			    $self->{'act'}->{'webmin'});
	}

print $self->ui_table_end(),"<p>\n";

# display modified files
$self->{'rbcount'} = 0;
foreach $d ($self->list_diffs($self->{'act'})) {
	local $t = $self->{'text_hash'}->{"view_type_".$d->{'type'}};
	local $rb;
	if ($d->{'type'} eq 'create' || $d->{'type'} eq 'modify' ||
	    $d->{'type'} eq 'delete') {
		($rb) = grep { $_->{'file'} eq $d->{'object'} } @{$self->{'files_array'}};
		}
	local $cbox = @{$self->{'files_array'}} ?
		$self->ui_checkbox("r", $d->{'object'}, "", 1, undef, !$rb) : undef;
	$self->{'rbcount'}++ if ($rb);
	if ($t =~ /\$2/ || !$d->{'diff'}) {
		# Diff is just a single line message
		print "<table border width=100%>\n";
		print "<tr $self->{'tb'}> <td><b>",$cbox,
		      $self->text("view_type_".$d->{'type'},
			    "<tt>$d->{'object'}</tt>",
			    "<tt>".$self->html_escape($d->{'diff'})."</tt>"),"</b></td> </tr>\n";
		print "</table><p>\n";
		}
	else {
		# Show multi-line diff
		print "<table border width=100%>\n";
		print "<tr $self->{'tb'}> <td><b>",$cbox,$self->text("view_type_".$d->{'type'},
		      "<tt>$d->{'object'}</tt>"),"</b></td> </tr>\n";
		print "<tr $self->{'cb'}> <td><pre>";
		print $self->html_escape($d->{'diff'});
		print "</pre></td> </tr>\n";
		if ($d->{'input'}) {
			# And input too
			print "<tr $self->{'tb'}> <td><b>",$self->text('view_input'),
			      "</b></td> </tr>\n";
			print "<tr $self->{'cb'}> <td><pre>";
			print $self->html_escape($d->{'input'});
			print "</pre></td> </tr>\n";
			}
		print "</table><p>\n";
		}
	$self->{'anydiffs'}++;
	}
if ($self->{'rbcount'}) {
	print $self->ui_links_row([ $self->select_all_link("r"),
			      $self->select_invert_link("r") ]);
	}

print "<b>$self->{'text_hash'}->{'view_nofiles'}</b><p>\n" if (!$self->{'anydiffs'});

# Show rollback button
if (@{$self->{'files_array'}} && $self->{'rbcount'}) {
	print $self->ui_form_end([ [ "rollback", $self->{'text_hash'}->{'view_rollback2'} ] ]);
	}

$self->ui_print_footer($ENV{'HTTP_REFERER'}, $self->{'text_hash'}->{'search_return'},
	"", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

