#!/usr/bin/perl
package cron::Acl_security;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'cron::Acl_security');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;

&ModuleLoader::preload_module(ref($self), "cron::CronLib");
$self = new cron::CronLib:: ref($self), %$self; 
&ModuleLoader::preload_module(ref($self), "UiLib");
$self = new UiLib:: ref($self), %$self; 

1;
		return $self;
}

# acl_security_form(&options)
# Output HTML for editing security options for the cron module
sub acl_security_form
{
	my $self = shift;

print "<tr> <td valign=top><b>$self->{'text_hash'}->{'acl_users'}</b></td> <td colspan=3>\n";
printf "<input type=radio name=mode value=0 %s> $self->{'text_hash'}->{'acl_all'}<br>\n",
	$_[0]->{'mode'} == 0 ? "checked" : "";

printf "<input type=radio name=mode value=3 %s> $self->{'text_hash'}->{'acl_this'}<br>\n",
	$_[0]->{'mode'} == 3 ? "checked" : "";

printf "<input type=radio name=mode value=1 %s> $self->{'text_hash'}->{'acl_only'}\n",
	$_[0]->{'mode'} == 1 ? "checked" : "";
printf "<input name=userscan size=40 value='%s'> %s<br>\n",
	$_[0]->{'mode'} == 1 ? $_[0]->{'users'} : "",
	$self->user_chooser_button("userscan", 1);

printf "<input type=radio name=mode value=2 %s> $self->{'text_hash'}->{'acl_except'}\n",
	$_[0]->{'mode'} == 2 ? "checked" : "";
printf "<input name=userscannot size=40 value='%s'> %s<br>\n",
	$_[0]->{'mode'} == 2 ? $_[0]->{'users'} : "",
	$self->user_chooser_button("userscannot", 1);

printf "<input type=radio name=mode value=5 %s> $self->{'text_hash'}->{'acl_gid'}\n",
	$_[0]->{'mode'} == 5 ? "checked" : "";
printf "<input name=gid size=8 value='%s'> %s<br>\n",
	$_[0]->{'mode'} == 5 ? scalar(getgrgid($_[0]->{'users'})) : "",
	$self->group_chooser_button("gid", 0);

printf "<input type=radio name=mode value=4 %s> $self->{'text_hash'}->{'acl_uid'}\n",
	$_[0]->{'mode'} == 4 ? "checked" : "";
printf "<input name=uidmin size=6 value='%s'> -\n",
	$_[0]->{'mode'} == 4 ? $_[0]->{'uidmin'} : "";
printf "<input name=uidmax size=6 value='%s'></td> </tr>\n",
	$_[0]->{'mode'} == 4 ? $_[0]->{'uidmax'} : "";

print "<tr> <td><b>$self->{'text_hash'}->{'acl_control'}</b></td>\n";
print "<td>",$self->ui_radio("allow", $_[0]->{'allow'},
	[ [ 1, $self->{'text_hash'}->{'yes'} ], [ 0, $self->{'text_hash'}->{'no'} ] ]),"</td>\n";

print "<td><b>$self->{'text_hash'}->{'acl_command'}</b></td>\n";
print "<td>",$self->ui_radio("command", $_[0]->{'command'},
	[ [ 1, $self->{'text_hash'}->{'yes'} ], [ 0, $self->{'text_hash'}->{'no'} ] ]),"</td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'acl_create'}</b></td>\n";
print "<td>",$self->ui_radio("create", $_[0]->{'create'},
	[ [ 1, $self->{'text_hash'}->{'yes'} ], [ 0, $self->{'text_hash'}->{'no'} ] ]),"</td>\n";

print "<td><b>$self->{'text_hash'}->{'acl_delete'}</b></td>\n";
print "<td>",$self->ui_radio("delete", $_[0]->{'delete'},
	[ [ 1, $self->{'text_hash'}->{'yes'} ], [ 0, $self->{'text_hash'}->{'no'} ] ]),"</td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'acl_move'}</b></td>\n";
print "<td>",$self->ui_radio("move", $_[0]->{'move'},
	[ [ 1, $self->{'text_hash'}->{'yes'} ], [ 0, $self->{'text_hash'}->{'no'} ] ]),"</td>\n";

print "<td><b>$self->{'text_hash'}->{'acl_kill'}</b></td>\n";
print "<td>",$self->ui_radio("kill", $_[0]->{'kill'},
	[ [ 1, $self->{'text_hash'}->{'yes'} ], [ 0, $self->{'text_hash'}->{'no'} ] ]),"</td> </tr>\n";

print "</tr>\n";
}

# acl_security_save(&options)
# Parse the form for security options for the cron module
sub acl_security_save
{
	my $self = shift;

$_[0]->{'mode'} = $self->{'in_hash'}->{'mode'};
$_[0]->{'users'} = $self->{'in_hash'}->{'mode'} == 0 || $self->{'in_hash'}->{'mode'} == 3 ||
		   $self->{'in_hash'}->{'mode'} == 4 ? "" :
		   $self->{'in_hash'}->{'mode'} == 5 ? scalar(getgrnam($self->{'in_hash'}->{'gid'})) :
		   $self->{'in_hash'}->{'mode'} == 1 ? $self->{'in_hash'}->{'userscan'}
				    : $self->{'in_hash'}->{'userscannot'};
$_[0]->{'uidmin'} = $self->{'in_hash'}->{'mode'} == 4 ? $self->{'in_hash'}->{'uidmin'} : "";
$_[0]->{'uidmax'} = $self->{'in_hash'}->{'mode'} == 4 ? $self->{'in_hash'}->{'uidmax'} : "";
$_[0]->{'allow'} = $self->{'in_hash'}->{'allow'};
$_[0]->{'command'} = $self->{'in_hash'}->{'command'};
$_[0]->{'create'} = $self->{'in_hash'}->{'create'};
$_[0]->{'delete'} = $self->{'in_hash'}->{'delete'};
$_[0]->{'move'} = $self->{'in_hash'}->{'move'};
$_[0]->{'kill'} = $self->{'in_hash'}->{'kill'};
}


1;

