#!/usr/bin/perl
package cron::Backup_config;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'cron::Backup_config');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;

&ModuleLoader::preload_module(ref($self), "cron::CronLib");
$self = new cron::CronLib:: ref($self), %$self; 

1;

1;
		return $self;
}

# backup_config_files()
# Returns files and directories that can be backed up
sub backup_config_files
{
	my $self = shift;

local @rv;
push(@rv, map { $_->{'file'} } $self->list_cron_jobs());
push(@rv, $self->{'config_hash'}->{'cron_allow_file'}) if ($self->{'config_hash'}->{'cron_allow_file'});
push(@rv, $self->{'config_hash'}->{'cron_deny_file'}) if ($self->{'config_hash'}->{'cron_deny_file'});
push(@rv, $self->{'config_hash'}->{'system_crontab'}) if ($self->{'config_hash'}->{'system_crontab'});
return $self->unique(@rv);
}

# pre_backup(&files)
# Called before the files are actually read
sub pre_backup
{
	my $self = shift;

return undef;
}

# post_backup(&files)
# Called after the files are actually read
sub post_backup
{
	my $self = shift;

return undef;
}

# pre_restore(&files)
# Called before the files are restored from a backup
sub pre_restore
{
	my $self = shift;

return undef;
}

# post_restore(&files)
# Called after the files are restored from a backup
sub post_restore
{
	my $self = shift;

if (!$self->{'fcron'}) {
	# Re-activate all user cron jobs
	local $user;
	opendir(DIR, $self->{'config_hash'}->{'cron_dir'});
	while($user = readdir(DIR)) {
		system("cp $self->{'config_hash'}->{'cron_dir'}/$user $self->{'cron_temp_file'}");
		$self->copy_crontab($user);
		}
	closedir(DIR);
	}
return undef;
}


1;

