#!/usr/bin/perl
package cron::Log_parser;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'cron::Log_parser');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# log_parser.pl
# Functions for parsing this module's logs

&ModuleLoader::preload_module(ref($self), "cron::CronLib");
$self = new cron::CronLib:: ref($self), %$self; 

1;
		return $self;
}

# parse_webmin_log(user, script, action, type, object, &params, [long])
# Converts logged information from this module into human-readable form
sub parse_webmin_log
{
	my $self = shift;

local ($user, $script, $action, $type, $object, $p, $long) = @_;
if ($type eq "env") {
	return $self->text('log_env_'.$action, "<tt>$object</tt>");
	}
elsif ($type eq "crons") {
	return $self->text('log_crons_'.$action, $object);
	}
elsif ($action eq "move") {
	return $self->text('log_move', "<tt>$object</tt>");
	}
elsif ($action eq 'modify') {
	return $self->text($long ? 'log_modify_l' : 'log_modify',
		     "<tt>$object</tt>",
		     "<tt>".$self->html_escape($p->{'cmd'})."</tt>");
	}
elsif ($action eq 'create') {
	return $self->text($long ? 'log_create_l' : 'log_create',
		     "<tt>$object</tt>",
		     "<tt>".$self->html_escape($p->{'cmd'})."</tt>");
	}
elsif ($action eq 'delete') {
	return $self->text($long ? 'log_delete_l' : 'log_delete',
		     "<tt>$object</tt>",
		     "<tt>".$self->html_escape($p->{'command'})."</tt>");
	}
elsif ($action eq 'exec' || $action eq 'kill') {
	return $self->text($long ? 'log_'.$action.'_l' : 'log_'.$action,
		     "<tt>$object</tt>",
		     "<tt>".$self->html_escape($p->{'command'})."</tt>");
	}
elsif ($action eq 'allow') {
	return $self->{'text_hash'}->{'log_allow'};
	}
else {
	return undef;
	}
}


1;

