#!/usr/bin/perl
package cron::Range;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'cron::Range');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# Only runs the specified cron job if within the date range
# XXX support in usermin

use Time::Local;

# Parse args
($self->{'start'}, $self->{'end'}, @{$self->{'cmd_array'}}) = @ARGV;
$self->{'start'} && $self->{'end'} && scalar(@{$self->{'cmd_array'}}) || die "usage: range.pl dd-mm-yyyy dd-mm-yyyy command ...";
$self->{'stime'} = $self->parse_date($self->{'start'});
$self->{'stime'} || die "Invalid start date $self->{'start'}";
$self->{'etime'} = $self->parse_date($self->{'end'});
$self->{'etime'} || die "Invalid ending date $self->{'end'}";

# Check time range (inclusive)
$self->{'now'} = time();
if ($self->{'now'} < $self->{'stime'} || $self->{'now'} >= $self->{'etime'}+24*60*60) {
	exit(0);
	}

# Run the rest
exec("/bin/sh", "-c", join(" ", @{$self->{'cmd_array'}}));

1;
		return $self;
}

sub parse_date
{
	my $self = shift;

($d, $m, $y) = split(/\-/, $_[0]);
$y =~ /^\d+$/ && $m =~ /^\d+$/ && $d =~ /^\d+$/ || return undef;
return eval { timelocal(0, 0, 0, $d, $m-1, $y-1900) };
}


1;

