#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_cron.cgi
# Save an existing cron job, or create a new one

&ModuleLoader::preload_module('cron_class', "cron::CronLib");
$self = new cron::CronLib:: 'cron_class',%$self;

$self->error_setup($self->{'text_hash'}->{'save_err'});
$self->ReadParse();

@{$self->{'jobs_array'}} = $self->list_cron_jobs();
if ($self->{'in_hash'}->{'new'}) {
	$self->{'access_hash'}->{'create'} || $self->error($self->{'text_hash'}->{'save_ecannot2'});
	$self->{'job'} = { 'type' => 0 };
	}
else {
	$self->{'oldjob'} = $self->{'jobs_array'}->[$self->{'in_hash'}->{'idx'}];
	$self->{'job'}->{'type'} = $self->{'oldjob'}->{'type'};
	$self->{'job'}->{'file'} = $self->{'oldjob'}->{'file'};
	$self->{'job'}->{'line'} = $self->{'oldjob'}->{'line'};
	$self->{'job'}->{'nolog'} = $self->{'oldjob'}->{'nolog'};
	}

@{$self->{'files_array'}} = $self->unique((map { $_->{'file'} } @{$self->{'jobs_array'}}),
	         "$self->{'config_hash'}->{'cron_dir'}/$self->{'in_hash'}->{'user'}");
foreach $f (@{$self->{'files_array'}}) { $self->lock_file($f); }

# Check and parse inputs
if ($self->{'in_hash'}->{"cmd"} !~ /\S/ && $self->{'access_hash'}->{'command'}) {
	$self->error($self->{'text_hash'}->{'save_ecmd'});
	}
if ($self->supports_users()) {
	if (!$self->{'in_hash'}->{'user'}) {
		$self->error($self->{'text_hash'}->{'save_euser'});
		}
	if (!defined(getpwnam($self->{'in_hash'}->{'user'}))) {
		$self->error($self->text('save_euser2', $self->{'in_hash'}->{'user'}));
		}
	}
$self->parse_times_input($self->{'job'}, \%{$self->{'in_hash'}});
$self->{'in_hash'}->{input} =~ s/\r//g; $self->{'in_hash'}->{input} =~ s/%/\\%/g;
$self->{'in_hash'}->{cmd} =~ s/%/\\%/g;
$self->{'job'}->{'active'} = $self->{'in_hash'}->{'active'};
if ($self->{'access_hash'}->{'command'}) {
	$self->{'job'}->{'command'} = $self->{'in_hash'}->{'cmd'};
	if ($self->{'in_hash'}->{input} =~ /\S/) {
		@{$self->{'inlines_array'}} = split(/\n/ , $self->{'in_hash'}->{input});
		$self->{'job'}->{'command'} .= '%'.join('%' , @{$self->{'inlines_array'}});
		}
	}
else {
	$self->{'job'}->{'command'} = $self->{'oldjob'}->{'command'};
	}
$self->{'job'}->{'comment'} = $self->{'in_hash'}->{'comment'};
$self->unconvert_comment($self->{'job'});

if ($self->supports_users()) {
	# Check if this user is allowed to execute cron jobs
	$self->can_use_cron($self->{'in_hash'}->{'user'}) ||
		$self->error($self->text('save_eallow', $self->{'in_hash'}->{'user'}));
	$self->{'job'}->{'user'} = $self->{'in_hash'}->{'user'};
	}

if (defined($self->{'in_hash'}->{'range_def'})) {
	# Save range to run
	$self->parse_range_input($self->{'job'}, \%{$self->{'in_hash'}});
	$self->unconvert_range($self->{'job'});
	}

# Check module access control
$self->can_edit_user(\%{$self->{'access_hash'}}, $self->{'in_hash'}->{'user'}) ||
	$self->error($self->text('save_ecannot', $self->{'in_hash'}->{'user'}));

if (!$self->{'in_hash'}->{'new'}) {
	# Editing an existing job
	$self->can_edit_user(\%{$self->{'access_hash'}}, $self->{'oldjob'}->{'user'}) ||
		$self->error($self->text('save_ecannot', $self->{'oldjob'}->{'user'}));
	if ($self->{'job'}->{'user'} eq $self->{'oldjob'}->{'user'}) {
		$self->change_cron_job($self->{'job'});
		}
	else {
		$self->delete_cron_job($self->{'oldjob'});
		$self->create_cron_job($self->{'job'});
		}
	}
else {
	# Creating a new job
	$self->create_cron_job($self->{'job'});
	}

foreach $f (@{$self->{'files_array'}}) { $self->unlock_file($f); }
if ($self->{'in_hash'}->{'new'}) {
	$self->webmin_log("create", "cron", $self->{'in_hash'}->{'user'}, \%{$self->{'in_hash'}});
	}
else {
	$self->webmin_log("modify", "cron", $self->{'in_hash'}->{'user'}, \%{$self->{'in_hash'}});
	}
$self->redirect("");

1;
		
}


1;

