#!/usr/bin/perl
package custom::CustomLib;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'custom::CustomLib');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# custom-lib.pl
# Functions for storing custom commands
# XXX variable in file editors
# XXX don't need quoting option
# XXX don't need upload type, or password, or text box, or option

&ModuleLoader::preload_module(ref($self), "WebLib");
$self = new WebLib:: ref($self), %$self; 
$self->init_config();
%{$self->{'access_hash'}} = $self->get_module_acl();
&ModuleLoader::preload_module(ref($self), "UiLib");
$self = new UiLib:: ref($self), %$self; 

1;
1;
		return $self;
}

# list_commands()
# Returns a list of all custom commands
sub list_commands
{
	my $self = shift;

local (@rv, $f);
local $mcd = $self->{'module_info_hash'}->{'usermin'} ? $self->{'config_hash'}->{'webmin_config'}
				     : $self->{'module_config_directory'};
opendir(DIR, $mcd);
while($f = readdir(DIR)) {
	local %cmd;
	if ($f =~ /^(\d+)\.cmd$/) {
		# Read custom-command file
		$cmd{'file'} = "$mcd/$f";
		$cmd{'id'} = $1;
		open(FILE, $cmd{'file'});
		chop($cmd{'cmd'} = <FILE>);
		chop($cmd{'desc'} = <FILE>);
		local @o = split(/\s+/, <FILE>);
		$cmd{'user'} = $o[0];
		$cmd{'raw'} = int($o[1]);
		$cmd{'su'} = int($o[2]);
		$cmd{'order'} = int($o[3]);
		$cmd{'noshow'} = int($o[4]);
		$cmd{'usermin'} = int($o[5]);
		$cmd{'timeout'} = int($o[6]);
		$cmd{'clear'} = int($o[7]);
		}
	elsif ($f =~ /^(\d+)\.edit$/) {
		# Read file-editor file
		$cmd{'file'} = "$mcd/$f";
		$cmd{'id'} = $1;
		open(FILE, $cmd{'file'});
		chop($cmd{'edit'} = <FILE>);
		chop($cmd{'desc'} = <FILE>);
		chop($cmd{'user'} = <FILE>);
		chop($cmd{'group'} = <FILE>);
		chop($cmd{'perms'} = <FILE>);
		chop($cmd{'before'} = <FILE>);
		chop($cmd{'after'} = <FILE>);
		chop($cmd{'order'} = <FILE>);
		$cmd{'order'} = int($cmd{'order'});
		chop($cmd{'usermin'} = <FILE>);
		chop($cmd{'envs'} = <FILE>);
		}
	elsif ($f =~ /^(\d+)\.sql$/) {
		# Read SQL file
		$cmd{'file'} = "$mcd/$f";
		$cmd{'id'} = $1;
		open(FILE, $cmd{'file'});
		chop($cmd{'desc'} = <FILE>);
		chop($cmd{'type'} = <FILE>);
		chop($cmd{'db'} = <FILE>);
		chop($cmd{'user'} = <FILE>);
		chop($cmd{'pass'} = <FILE>);
		chop($cmd{'host'} = <FILE>);
		chop($cmd{'sql'} = <FILE>);
		$cmd{'sql'} =~ s/\t/\n/g;
		}
	if (%cmd) {
		# Read common stuff
		while(<FILE>) {
			s/\r|\n//g;
			local @a = split(/:/, $_, 5);
			push(@{$cmd{'args'}}, { 'name' => $a[0],
						'type' => $a[1],
						'opts' => $a[2],
						'quote' => $a[3],
						'desc' => $a[4] });
			}
		close(FILE);
		$cmd{'index'} = scalar(@rv);
		open(HTML, "$mcd/$cmd{'id'}.html");
		while(<HTML>) {
			$cmd{'html'} .= $_;
			}
		close(HTML);

		# Read cluster hosts file
		open(CLUSTER, "$mcd/$cmd{'id'}.hosts");
		while(<CLUSTER>) {
			s/\r|\n//g;
			push(@{$cmd{'hosts'}}, $_);
			}
		close(CLUSTER);

		push(@rv, \%cmd);
		}
	}
closedir(DIR);
return @rv;
}

# save_command(&command)
sub save_command
{
	my $self = shift;

local $c = $_[0];
if ($c->{'edit'}) {
	# Save a file editor
	$self->open_lock_tempfile(FILE, ">$self->{'module_config_directory'}/$c->{'id'}.edit");
	$self->print_tempfile(FILE, $c->{'edit'},"\n");
	$self->print_tempfile(FILE, $c->{'desc'},"\n");
	$self->print_tempfile(FILE, $c->{'user'},"\n");
	$self->print_tempfile(FILE, $c->{'group'},"\n");
	$self->print_tempfile(FILE, $c->{'perms'},"\n");
	$self->print_tempfile(FILE, $c->{'before'},"\n");
	$self->print_tempfile(FILE, $c->{'after'},"\n");
	$self->print_tempfile(FILE, $c->{'order'},"\n");
	$self->print_tempfile(FILE, $c->{'usermin'},"\n");
	$self->print_tempfile(FILE, $c->{'envs'},"\n");
	}
elsif ($c->{'sql'}) {
	# Save an SQL command
	$self->open_lock_tempfile(FILE, ">$self->{'module_config_directory'}/$c->{'id'}.sql");
	$self->print_tempfile(FILE, $c->{'desc'},"\n");
	$self->print_tempfile(FILE, $c->{'type'},"\n");
	$self->print_tempfile(FILE, $c->{'db'},"\n");
	$self->print_tempfile(FILE, $c->{'user'},"\n");
	$self->print_tempfile(FILE, $c->{'pass'},"\n");
	$self->print_tempfile(FILE, $c->{'host'},"\n");
	local $sql = $c->{'sql'};
	$sql =~ s/\n/\t/g;
	$self->print_tempfile(FILE, $sql,"\n");
	}
else {
	# Save a custom command
	$self->open_lock_tempfile(FILE, ">$self->{'module_config_directory'}/$c->{'id'}.cmd");
	$self->print_tempfile(FILE, $c->{'cmd'},"\n");
	$self->print_tempfile(FILE, $c->{'desc'},"\n");
	$self->print_tempfile(FILE,
		   $c->{'user'}," ",int($c->{'raw'})," ",int($c->{'su'})," ",
		   int($c->{'order'})," ",int($c->{'noshow'})," ",
		   int($c->{'usermin'})," ",int($c->{'timeout'})," ",
		   int($c->{'clear'}),"\n");
	}


# Save parameters
foreach $a (@{$c->{'args'}}) {
	$self->print_tempfile(FILE, $a->{'name'},":",$a->{'type'},":",
	   $a->{'opts'},":",$a->{'quote'},":",$a->{'desc'},"\n");
	}
$self->close_tempfile(FILE);

# Save HTML description file
$self->lock_file("$self->{'module_config_directory'}/$c->{'id'}.html");
if ($self->{'cmd'}->{'html'}) {
	$self->open_tempfile(HTML, ">$self->{'module_config_directory'}/$c->{'id'}.html");
	$self->print_tempfile(HTML, $self->{'cmd'}->{'html'});
	$self->close_tempfile(HTML);
	}
else {
	unlink("$self->{'module_config_directory'}/$c->{'id'}.html");
	}
$self->unlock_file("$self->{'module_config_directory'}/$c->{'id'}.html");

# Save cluster hosts
$self->lock_file("$self->{'module_config_directory'}/$c->{'id'}.hosts");
if (@{$self->{'cmd'}->{'hosts'}}) {
	$self->open_tempfile(CLUSTER, ">$self->{'module_config_directory'}/$c->{'id'}.hosts");
	foreach my $h (@{$self->{'cmd'}->{'hosts'}}) {
		$self->print_tempfile(CLUSTER, "$h\n");
		}
	$self->close_tempfile(CLUSTER);
	}
else {
	unlink("$self->{'module_config_directory'}/$c->{'id'}.hosts");
	}
$self->unlock_file("$self->{'module_config_directory'}/$c->{'id'}.hosts");
}

# delete_command(&command)
sub delete_command
{
	my $self = shift;

local $f = "$self->{'module_config_directory'}/$_[0]->{'id'}".
	   ($_[0]->{'edit'} ? ".edit" : $_[0]->{'sql'} ? ".sql" : ".cmd");
$self->lock_file($f);
unlink($f);
$self->unlock_file($f);

# Delete HTML file
local $hf = "$self->{'module_config_directory'}/$_[0]->{'id'}.html";
if (-r $hf) {
	$self->lock_file($hf);
	unlink($hf);
	$self->unlock_file($hf);
	}

# Delete cluster file
local $cf = "$self->{'module_config_directory'}/$_[0]->{'id'}.hosts";
if (-r $cf) {
	$self->lock_file($cf);
	unlink($cf);
	$self->unlock_file($cf);
	}
}

sub can_run_command
{
	my $self = shift;

if ($self->{'module_info_hash'}->{'usermin'}) {
	# Only modules marked as for Usermin are considered
	return 0 if (!$_[0]->{'usermin'});

	# Check detailed access control list (if any)
	return 1 if (!$self->{'config_hash'}->{'access'});
	local @uinfo = @{$self->{'remote_user_info_array'}};
	@uinfo = getpwnam($self->{'remote_user'}) if (!@uinfo);
	local $l;
	foreach $l (split(/\t/, $self->{'config_hash'}->{'access'})) {
		if ($l =~ /^(\S+):\s*(.*)$/) {
			local ($user, $ids) = ($1, $2);
			local $applies;
			if ($user =~ /^\@(.*)$/) {
				# Check if user is in group
				local @ginfo = getgrnam($1);
				$applies++
				   if (@ginfo && ($ginfo[2] == $uinfo[3] ||
				       $self->indexof($self->{'remote_user'},
						split(/\s+/, $ginfo[3])) >= 0));
				}
			elsif ($user eq $self->{'remote_user'} || $user eq "*") {
				$applies++;
				}
			if ($applies) {
				# Rule is for this user - check list
				local @ids = split(/\s+/, $ids);
				local $d;
				foreach $d (@ids) {
					return 1 if ($d eq '*' ||
						     $_[0]->{'id'} eq $d);
					return 0 if ("!".$_[0]->{'id'} eq $d);
					}
				return 0;
				}
			}
		}
	return 0;
	}
else {
	# Just use Webmin user's list of databases
	local $c;
	local $found;
	return 1 if ($self->{'access_hash'}->{'cmds'} eq '*');
	local @cmds = split(/\s+/, $self->{'access_hash'}->{'cmds'});
	foreach $c (@cmds) {
		$found++ if ($c eq $_[0]->{'id'});
		}
	return $cmds[0] eq '!' ? !$found : $found;
	}
}

# read_opts_file(file)
sub read_opts_file
{
	my $self = shift;

local @rv;
local $file = $_[0];
if ($file !~ /^\// && $file !~ /\|\s*$/) {
	local @uinfo = getpwnam($self->{'remote_user'});
	if (@uinfo) {
		$file = "$uinfo[7]/$file";
		}
	}
open(FILE, $file);
while(<FILE>) {
	s/\r|\n//g;
	if (/^"([^"]*)"\s+"([^"]*)"$/) {
		push(@rv, [ $1, $2 ]);
		}
	elsif (/^"([^"]*)"$/) {
		push(@rv, [ $1, $1 ]);
		}
	elsif (/^(\S+)\s+(\S.*)/) {
		push(@rv, [ $1, $2 ]);
		}
	else {
		push(@rv, [ $_, $_ ]);
		}
	}
close(FILE);
return @rv;
}

# show_params_inputs(&command, no-quote, editor-mode)
sub show_params_inputs
{
	my $self = shift;

local ($cmd, $noquote, $editor) = @_;
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'edit_params'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'edit_name'}</b></td> ",
      "<td><b>$self->{'text_hash'}->{'edit_desc'}</b></td> <td><b>$self->{'text_hash'}->{'edit_type'}</b></td> ";
if (!$noquote) {
	print "<td><b>$self->{'text_hash'}->{'edit_quote'}</b></td> ";
	}
print "</tr>\n";
local @a = (@{$cmd->{'args'}}, { });
for(my $i=0; $i<@a; $i++) {
	print "<tr>\n";
	printf "<td><input name=name_$i size=10 value='%s'></td>\n",
		$a[$i]->{'name'};
	printf "<td><input name=desc_$i size=40 value='%s'></td>\n",
		$self->html_escape($a[$i]->{'desc'});
	print "<td><select name=type_$i>\n";
	for(my $j=0; $self->{'text_hash'}->{"edit_type$j"}; $j++) {
		next if ($editor &&
			 ($j == 7 || $j == 8 || $j == 10 || $j == 11));
		printf "<option value=%d %s>%s\n",
			$j, $a[$i]->{'type'} == $j ? "selected" : "",
			$self->{'text_hash'}->{"edit_type$j"};
		}
	print "</select>\n";
	print $self->ui_textbox("opts_$i", $a[$i]->{'opts'}, 20),"</td>\n";
	if (!$noquote) {
		print "<td>",$self->ui_yesno_radio("quote_$i",
					     int($a[$i]->{'quote'})),"</td>\n";
		}
	print "</tr>\n";
	}

print "</table></td></tr></table>\n";
}

# parse_params_inputs(&command)
sub parse_params_inputs
{
	my $self = shift;

local ($cmd) = @_;
$cmd->{'args'} = [ ];
my ($i, $name);
for($i=0; defined($name = $self->{'in_hash'}->{"name_$i"}); $i++) {
	if ($name) {
		push(@{$cmd->{'args'}}, { 'name' => $name,
					  'desc' => $self->{'in_hash'}->{"desc_$i"},
					  'type' => $self->{'in_hash'}->{"type_$i"},
					  'quote' => int($self->{'in_hash'}->{"quote_$i"}),
					  'opts' => $self->{'in_hash'}->{"opts_$i"} });
		}
	}
}

# set_parameter_envs(&command, command-str, &uinfo)
# Sets $ENV variables based on parameter inputs, and returns the list of
# environment variable commands, the export commands, the command string,
# and the command string to display.
sub set_parameter_envs
{
	my $self = shift;

local ($cmd, $str, $uinfo) = @_;
local $displaystr = $str;
local ($env, $export, @vals);
foreach my $a (@{$cmd->{'args'}}) {
	my $n = $a->{'name'};
	my $rv;
	if ($a->{'type'} == 0 || $a->{'type'} == 5 ||
	    $a->{'type'} == 6 || $a->{'type'} == 8) {
		$rv = $self->{'in_hash'}->{$n};
		}
	elsif ($a->{'type'} == 11) {
		$rv = $self->{'in_hash'}->{$n};
		$rv =~ s/\r//g;
		$rv =~ s/\n/ /g;
		}
	elsif ($a->{'type'} == 1 || $a->{'type'} == 2) {
		(@{$self->{'u_array'}} = getpwnam($self->{'in_hash'}->{$n})) || $self->error($self->{'text_hash'}->{'run_euser'});
		$rv = $a->{'type'} == 1 ? $self->{'in_hash'}->{$n} : $self->{'u_array'}->[2];
		}
	elsif ($a->{'type'} == 3 || $a->{'type'} == 4) {
		(@{$self->{'g_array'}} = getgrnam($self->{'in_hash'}->{$n})) || $self->error($self->{'text_hash'}->{'run_egroup'});
		$rv = $a->{'type'} == 3 ? $self->{'in_hash'}->{$n} : $self->{'g_array'}->[2];
		}
	elsif ($a->{'type'} == 7) {
		$rv = $self->{'in_hash'}->{$n} ? $a->{'opts'} : "";
		}
	elsif ($a->{'type'} == 9) {
		local $found;
		foreach my $l ($self->read_opts_file($a->{'opts'})) {
			$found++ if ($l->[0] eq $self->{'in_hash'}->{$n});
			}
		$found || $self->error($self->{'text_hash'}->{'run_eopt'});
		$rv = $self->{'in_hash'}->{$n};
		}
	elsif ($a->{'type'} == 10) {
		$self->{'in_hash'}->{$n} || $self->error($self->{'text_hash'}->{'run_eupload'});
		if ($self->{'in_hash'}->{$n."_filename"} =~ /([^\/\\]+$)/ && $1) {
			$rv = $self->transname("$1");
			}
		else {
			$rv = $self->transname();
			}
		$self->open_tempfile(TEMP, ">$rv");
		$self->print_tempfile(TEMP, $self->{'in_hash'}->{$n});
		$self->close_tempfile(TEMP);
		chown($uinfo->[2], $uinfo->[3], $rv);
		push(@{$self->{'unlink_array'}}, $rv);
		}
	$ENV{$n} = $rv;
	$env .= "$n='$rv'\n";
	$export .= " $n";
	if ($a->{'quote'}) {
		$str =~ s/\$$n/"\$$n"/g;
		$displaystr =~ s/\$$n/"$rv"/g;
		}
	else {
		$displaystr =~ s/\$$n/$rv/g;
		}
	push(@vals, $rv);
	}
return ($env, $export, $str, $displaystr, \@vals);
}

# list_dbi_drivers()
# Returns a list of DBI driver details, which are actually installed
sub list_dbi_drivers
{
	my $self = shift;

local @rv = ( { 'name' => 'MySQL',
		'driver' => 'mysql',
		'dbparam' => 'database' },
	      { 'name' => 'PostgreSQL',
		'driver' => 'Pg',
		'dbparam' => 'dbname' },
	    );
@rv = grep { eval "use DBD::$_->{'driver'}"; !$@ } @rv;
return @rv;
}

# list_servers()
# Returns a list of servers that a command can run on
sub list_servers
{
	my $self = shift;

if ($self->foreign_installed("servers")) {
	$self->foreign_require("servers", "servers-lib.pl");
	@{$self->{'servers_array'}} = grep { $_->{'user'} } $main::servers_object->list_servers();
	if (@{$self->{'servers_array'}}) {
		return ( { 'id' => 0, 'desc' => $self->{'text_hash'}->{'edit_this'} }, @{$self->{'servers_array'}});
		}
	}
return ( { 'id' => 0, 'desc' => $self->{'text_hash'}->{'edit_this'} } );
}

# execute_custom_command(&command, environment, exports, string, print-output)
# Runs some command, and returns the bytes, output and timeout flag
sub execute_custom_command
{
	my $self = shift;

local ($cmd, $env, $export, $str, $print) = @_;
$self->foreign_require("proc", "proc-lib.pl");

$self->clean_environment() if ($cmd->{'clear'});
local $got;
local $outtemp = $self->transname();
open(OUTTEMP, ">$outtemp");
local $fh = $print ? STDOUT : *OUTTEMP;
if ($cmd->{'su'}) {
	local $temp = $self->transname();
	$self->open_tempfile(TEMP, ">$temp");
	$self->print_tempfile(TEMP, "#!/bin/sh\n");
	$self->print_tempfile(TEMP, $env);
	$self->print_tempfile(TEMP, "export $export\n") if ($export);
	$self->print_tempfile(TEMP, "$str\n");
	$self->close_tempfile(TEMP);
	chmod(0755, $temp);
	local $shell = $self->{'config_hash'}->{'su_shell'} ? "-s /bin/sh" : "";
	$got = $self->foreign_call("proc", "safe_process_exec",
	   		     "su - $self->{'user'} $shell -c $temp", 0, 0,
			     $fh, undef, !$cmd->{'raw'}, 0,
			     $cmd->{'timeout'});
	unlink($temp);
	}
else {
	$got = $self->foreign_call("proc", "safe_process_exec", $str,
			     $self->{'user_info_array'}->[2], undef, $fh, undef,
			     !$cmd->{'raw'}, 0, $cmd->{'timeout'});
	}
$self->reset_environment() if ($cmd->{'clear'});
close(OUTTEMP);
local $rv = $self->read_file_contents($outtemp);
unlink($outtemp);
return ($got, $rv, $main::proc_object->{'safe_process_exec_timeout'} ? 1 : 0);
}


1;

