#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Display an SQL command

&ModuleLoader::preload_module('custom_class', "custom::CustomLib");
$self = new custom::CustomLib:: 'custom_class',%$self;

$self->ReadParse();

# Work out which DBI drivers we have
@{$self->{'drivers_array'}} = $self->list_dbi_drivers();
if (!@{$self->{'drivers_array'}}) {
	# None! Offer to install
	$self->ui_print_header(undef, $self->{'text_hash'}->{'sql_title1'}, "");
	eval "use DBI";
	if ($@) {
		@{$self->{'need_array'}} = ( "DBI" );
		}
	$self->{'myneed'} = $self->urlize(join(" ", @{$self->{'need_array'}}, "DBD::mysql"));
	$self->{'pgneed'} = $self->urlize(join(" ", @{$self->{'need_array'}}, "DBD::Pg"));
	print $self->text('sql_edrivers',
		"../cpan/download.cgi?source=3&cpan=$self->{'myneed'}&return=/$self->{'module_name'}/&returndesc=".$self->urlize($self->{'text_hash'}->{'index_return'}),
		"../cpan/download.cgi?source=3&cpan=$self->{'pgneed'}&return=/$self->{'module_name'}/&returndesc=".$self->urlize($self->{'text_hash'}->{'index_return'})),"<p>\n";
	}

$self->{'access_hash'}->{'edit'} || $self->error($self->{'text_hash'}->{'edit_ecannot'});
if ($self->{'in_hash'}->{'new'}) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'sql_title1'}, "");
	}
else {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'sql_title2'}, "");
	@{$self->{'cmds_array'}} = $self->list_commands();
	$self->{'cmd'} = $self->{'cmds_array'}->[$self->{'in_hash'}->{'idx'}];
	}

print $self->ui_form_start("save_sql.cgi", "post");
print $self->ui_hidden("new", $self->{'in_hash'}->{'new'}),"\n";
print $self->ui_hidden("idx", $self->{'in_hash'}->{'idx'}),"\n";
print $self->ui_table_start($self->{'text_hash'}->{'sql_header'}, "width=100%", 2);

# Show command info
if (!$self->{'in_hash'}->{'new'}) {
	print $self->ui_table_row($self->{'text_hash'}->{'edit_id'}, "<tt>$self->{'cmd'}->{'id'}</tt>");
	}
print $self->ui_table_row($self->{'text_hash'}->{'edit_desc'},
		    $self->ui_textbox("desc", $self->{'cmd'}->{'desc'}, 50)."<br>\n".
		    $self->ui_textarea("html", $self->{'cmd'}->{'html'}, 2, 50));

# Show databse type and name
print $self->ui_table_row($self->{'text_hash'}->{'sql_type'},
		    $self->ui_select("type", $self->{'cmd'}->{'type'},
			[ map { [ $_->{'driver'}, $_->{'name'} ] } @{$self->{'drivers_array'}} ]));
print $self->ui_table_row($self->{'text_hash'}->{'sql_db'},
		    $self->ui_textbox("db", $self->{'cmd'}->{'db'}, 20));

# Show command to run
print $self->ui_table_row($self->{'text_hash'}->{'sql_cmd'},
		    $self->ui_textarea("sql", $self->{'cmd'}->{'sql'}, 10, 70));

# Show login and password
print $self->ui_table_row($self->{'text_hash'}->{'sql_user'},
		    $self->ui_textbox("dbuser", $self->{'cmd'}->{'user'}, 20));
print $self->ui_table_row($self->{'text_hash'}->{'sql_pass'},
		    $self->ui_password("dbpass", $self->{'cmd'}->{'pass'}, 20));

# Show host to connect to
print $self->ui_table_row($self->{'text_hash'}->{'sql_host'},
		    $self->ui_opt_textbox("host", $self->{'cmd'}->{'host'}, 20,
				    $self->{'text_hash'}->{'sql_local'}));

print $self->ui_table_end(),"<p>\n";

# Show section for parameters
$self->show_params_inputs($self->{'cmd'});

# End of form
if ($self->{'in_hash'}->{'new'}) {
	print $self->ui_form_end([ [ "create", $self->{'text_hash'}->{'create'} ] ]);
	}
else {
	print $self->ui_form_end([ [ "save", $self->{'text_hash'}->{'save'} ],
			     [ "delete", $self->{'text_hash'}->{'delete'} ] ]);
	}

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

