#!/usr/bin/perl

&MAIN();

 sub MAIN {
# run.cgi
# Run some command with the given parameters

&ModuleLoader::preload_module('custom_class', "custom::CustomLib");
$self = new custom::CustomLib:: 'custom_class',%$self;

$self->{'theme_no_table'} = 1;
if ($ENV{'CONTENT_TYPE'} =~ /multipart\/form-data/i) {
	$self->ReadParseMime();
	}
else {
	$self->ReadParse();
	}
$| = 1;
$self->error_setup($self->{'text_hash'}->{'run_err'});
@{$self->{'cmds_array'}} = $self->list_commands();
$self->{'cmd'} = $self->{'cmds_array'}->[$self->{'in_hash'}->{'idx'}];
$self->can_run_command($self->{'cmd'}) || $self->error($self->{'text_hash'}->{'run_ecannot'});
if ($self->supports_users()) {
	local $u=$self->accessable("custom") ? "root" : $self->{'remote_user'};
	$self->{'user'} = $self->{'cmd'}->{'user'} eq '*' ? $u : $self->{'cmd'}->{'user'};
	@{$self->{'user_info_array'}} = getpwnam($self->{'user'});
	@{$self->{'user_info_array'}} || $self->error($self->text('run_ecmduser', $self->{'user'}));
	}
else {
	@{$self->{'user_info_array'}} = ( "root", undef, 0, 0 );
	}

# substitute parameters into command
($self->{'env'}, $self->{'export'}, $self->{'str'}, $self->{'displaystr'}) = $self->set_parameter_envs(
					$self->{'cmd'}, $self->{'cmd'}->{'cmd'}, \@{$self->{'user_info_array'}});

# work out hosts
@{$self->{'hosts_array'}} = @{$self->{'cmd'}->{'hosts'}};
@{$self->{'hosts_array'}} = ( 0 ) if (!@{$self->{'hosts_array'}});
@{$self->{'servers_array'}} = $self->list_servers();

# Run and display output
$self->ui_print_unbuffered_header($self->{'cmd'}->{'desc'}, $self->{'text_hash'}->{'run_title'}, "", -d "help" ? "run" : undef);

$self->remote_error_setup(\&remote_custom_handler);

foreach $h (@{$self->{'hosts_array'}}) {
	($self->{'server'}) = grep { $_->{'id'} eq $h } @{$self->{'servers_array'}};
	next if (!$self->{'server'});
	$self->{'txt'} = $self->{'cmd'}->{'noshow'} ? 'run_out2' : 'run_out';
	if (@{$self->{'cmd'}->{'hosts'}}) {
		$self->{'txt'} .= 'on';
		}
	print $self->text($self->{'txt'}, "<tt>".$self->html_escape($self->{'displaystr'})."</tt>",
		  $self->{'server'}->{'desc'} || "<tt>$self->{'server'}->{'host'}</tt>"),"\n";
	print "<pre>" if (!$self->{'cmd'}->{'raw'});
	$self->{'remote_custom_error'} = undef;
	if ($h == 0) {
		# Run locally
		($self->{'got'}, $self->{'out'}, $self->{'timeout'}) = $self->execute_custom_command($self->{'cmd'}, $self->{'env'}, $self->{'export'}, $self->{'str'}, 1);
		}
	else {
		# Foreign call
		$self->remote_foreign_require($self->{'server'}->{'host'}, "custom", "custom-lib.pl");
		($self->{'got'}, $self->{'out'}, $self->{'timeout'}) = $self->remote_foreign_call($self->{'server'}->{'host'}, "custom", "execute_custom_command", $self->{'cmd'}, $self->{'env'}, $self->{'export'}, $self->{'str'});
		}
	if ($h == 0) {
		$self->additional_log('exec', undef, $self->{'displaystr'});
		}
	if (!$self->{'remote_custom_error'}) {
		print $self->{'out'} if ($h != 0);
		if (!$self->{'got'}) {
			print "<i>$self->{'text_hash'}->{'run_noout'}</i>\n";
			}
		}
	print "</pre>\n" if (!$self->{'cmd'}->{'raw'});
	if ($self->{'remote_custom_error'}) {
		print "<b>$self->{'remote_custom_error'}</b><p>\n";
		}
	elsif ($self->{'timeout'}) {
		print "<b>",$self->text('run_timeout', $self->{'cmd'}->{'timeout'}),"</b><p>\n";
		}

	# Only log non-upload inputs
	%{$self->{'cmdin_hash'}} = ( %{$self->{'cmd'}} );
	foreach $i (keys %{$self->{'in_hash'}}) {
		($self->{'arg'}) = grep { $_->{'name'} eq $i } @{$self->{'cmd'}->{'args'}};
		if ($self->{'arg'}->{'type'} != 10) {
			$self->{'cmdin_hash'}->{$i} = $self->{'in_hash'}->{$i};
			}
		}
	}
$self->webmin_log("exec", "command", $self->{'cmd'}->{'id'}, \%{$self->{'cmdin_hash'}});
unlink(@{$self->{'unlink_array'}}) if (@{$self->{'unlink_array'}});
$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}

sub remote_custom_handler
{
	shift if ($self == $_[0]);

$self->{'remote_custom_error'} = join("", @_);
}


1;

