#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Execute some SQL and display the result

&ModuleLoader::preload_module('custom_class', "custom::CustomLib");
$self = new custom::CustomLib:: 'custom_class',%$self;

if ($ENV{'CONTENT_TYPE'} =~ /multipart\/form-data/i) {
	$self->ReadParseMime();
	}
else {
	$self->ReadParse();
	}
$self->error_setup($self->{'text_hash'}->{'srun_err'});
@{$self->{'cmds_array'}} = $self->list_commands();
$self->{'cmd'} = $self->{'cmds_array'}->[$self->{'in_hash'}->{'idx'}];
$self->can_run_command($self->{'cmd'}) || $self->error($self->{'text_hash'}->{'run_ecannot'});

# Connect to the DB
use DBI;
$self->{'drh'} = DBI->install_driver($self->{'cmd'}->{'type'});
$self->{'drh'} || $self->error($self->{'text_hash'}->{'srun_edriver'});
($self->{'driver'}) = grep { $_->{'driver'} eq $self->{'cmd'}->{'type'} } $self->list_dbi_drivers();
$self->{'dbh'} = $self->{'drh'}->connect($self->{'driver'}->{'dbparam'}."=".$self->{'cmd'}->{'db'}.
		     ($self->{'cmd'}->{'host'} ? ";host=$self->{'cmd'}->{'host'}" : ""),
		     $self->{'cmd'}->{'user'}, $self->{'cmd'}->{'pass'}, { });
$self->{'dbh'} || $self->error($self->text('srun_econnect', $self->{'drh'}->errstr));

# Show header
$self->ui_print_unbuffered_header(undef, $self->{'text_hash'}->{'srun_title'}, "");
print $self->text('srun_cmd', "<tt>$self->{'cmd'}->{'sql'}</tt>"),"<p>\n";

# Work out params
($self->{'env'}, $self->{'export'}, $self->{'str'}, $self->{'displaystr'}, $self->{'args'}) = $self->set_parameter_envs($self->{'cmd'}, $self->{'cmd'}->{'sql'}, undef);

# Run it
$self->{'cmd'} = $self->{'dbh'}->prepare($self->{'cmd'}->{'sql'});
if (!$self->{'cmd'}) {
	print $self->text('srun_eprepare', $self->{'dbh'}->errstr),"<p>\n";
	}
elsif (!$self->{'cmd'}->execute(@{$self->{'args'}})) {
	print $self->text('srun_eexecute', $self->{'dbh'}->errstr),"<p>\n";
	}
else {
	# Show results
	if (@{$self->{'titles_array'}} = @{$self->{'cmd'}->{'NAME'}}) {
		print $self->ui_columns_start(\@{$self->{'titles_array'}});

		# Show results
		while(local @r = $self->{'cmd'}->fetchrow()) {
			print $self->ui_columns_row(\@r);
			}

		print $self->ui_columns_end();
		$self->{'cmd'}->finish();
		}
	else {
		$self->{'r'} = $self->{'cmd'}->finish();
		print $self->text('srun_none', $self->{'r'}),"<p>\n";
		}
	}

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

