#!/usr/bin/perl

&MAIN();

 sub MAIN {

&ModuleLoader::preload_module('cyrus_sasl_class', "cyrus_sasl::CyrussaslLib");
$self = new cyrus_sasl::CyrussaslLib:: 'cyrus_sasl_class',%$self;


################################ BEGIN ##############################
local ( $socketdir_name, $mech_name, $flags_name);
$self->error_setup($self->{'text_hash'}->{'error'});

# Init default config if unset
unless( $self->{'config_hash'}->{'socketdir'}) { 
    $self->{'config_hash'}->{'socketdir'} = "/var/run/saslauthd/";
    }
unless( $self->{'config_hash'}->{'saslauthd_conf'}) { 
    $self->{'config_hash'}->{'saslauthd_conf'} = "/etc/sysconfig/saslauthd";
    }

# Replace name of some vars if need
if( $self->{'config_hash'}->{'MECH'}) { $mech_name = $self->{'config_hash'}->{'MECH'};}
else { $mech_name = 'MECH';}
if( $self->{'config_hash'}->{'SOCKETDIR'}) { $socketdir_name = $self->{'config_hash'}->{'SOCKETDIR'};}
else { $socketdir_name = 'SOCKETDIR';}
if( $self->{'config_hash'}->{'FLAGS'}) { $flags_name = $self->{'config_hash'}->{'FLAGS'};}
else { $flags_name = 'FLAGS';}

if( $ENV{'CONTENT_TYPE'} =~ /boundary=(.*)$/) { $self->ReadParseMime();}
else { $self->ReadParse();}

if($self->{'in_hash'}->{'sysreq'} == 1) { &save_config($self->{'config_hash'}->{'saslauthd_conf'}); }
elsif($self->{'in_hash'}->{'sysreq'} == 2) { $self->show_manually_edit($self->{'config_hash'}->{'saslauthd_conf'}, 
$self->get_script_name(), 20, 80, $self->{'text_hash'}->{'index_daemon'}, '', 1); }
elsif($self->{'in_hash'}->{'sysreq'} == 3) { $self->save_manually_edit($self->{'config_hash'}->{'saslauthd_conf'},
1, $self->{'text_hash'}->{'index_daemon'}); }
else { &show_saslauthd_conf(); }

##################################### END ###############################

############################# End Function #################################
    
1;
		
}

############################### Function ###########################
sub get_config()
{
	shift if ($self == $_[0]);

my ($is, %mech, %sasld_conf);

# Init default value:
%mech = $self->get_auth_id();
$sasld_conf{$mech_name} = $mech{'0'};
$sasld_conf{$socketdir_name} = $self->{'config_hash'}->{'socketdir'};

# Read config file
$self->read_file($self->{'config_hash'}->{'saslauthd_conf'}, \%sasld_conf) ||
$self->error("$self->{'text_hash'}->{'error_open'}: $self->{'config_hash'}->{'saslauthd_conf'}");  

# Remove any double quotas(") from values in %sasld_conf
foreach (keys(%sasld_conf)) { $sasld_conf{$_} =~ tr/\"//d;}

# Check is MECH supported by saslauthd
# If not, set default auth mechanism
foreach (values(%mech)) {
    if($_ eq $sasld_conf{$mech_name}) { $is = 1; last;}
    }    
unless(defined($is)) { $sasld_conf{$mech_name} =  $mech{'0'}; }

# Parsing line FLAGS
if($sasld_conf{$flags_name}) { 
    $sasld_conf{$flags_name} =~ tr/[a-zA-Z 0-9\-.\/]//cd;
    foreach  (split(/ /, $sasld_conf{$flags_name})) {
	if(! /^\-/) { ${$self->{'value'}} = $_; next; }
	if(/^\-c/) { $sasld_conf{'ENCACHE'} = 1; next; }
	if(/^\-T/) { $sasld_conf{'TRESTRICT'} = 1; next; }
	if(/^\-l/) { $sasld_conf{'UNLOCK'} = 1; next; }
	if(/^\-s/) { $self->{'value'} = \$sasld_conf{'CSIZE'}; next; }
	if(/^\-t/) { $self->{'value'} = \$sasld_conf{'CTTL'}; next; }
	if(/^\-n/) { $self->{'value'} = \$sasld_conf{'NTHREADS'}; next; }
	if(/^\-O/) { $self->{'value'} = \$sasld_conf{'MOPTION'}; next; }
	if(/^\-m/) { $self->{'value'} = \$sasld_conf{$socketdir_name}; next; }
	}
    }

# Check cache options (must be only digits) and remove it if cache no set
if($sasld_conf{'ENCACHE'}) {
    if($sasld_conf{'CSIZE'} !~ /^\d{1,}/) { delete($sasld_conf{'CSIZE'}); }
    if($sasld_conf{'CTTL'} !~ /^\d{1,}/) { delete($sasld_conf{'CTTL'}); }
    }
else { delete($sasld_conf{'CSIZE'}); delete($sasld_conf{'CTTL'}); }          

# Check options -n (must be only digits) and remove it if not
if ($sasld_conf{'NTHREADS'} !~ /^\d{1,}/) { delete($sasld_conf{'NTHREADS'}); }

# Check mechanism specific options (-O)
# if rimap - must be ip address or fqdn (and may be port as /143 or /name)
# if other - must be some config file
if($sasld_conf{$mech_name} eq "rimap") {
    unless( exists($sasld_conf{'MOPTION'})) 
	{ $sasld_conf{'MOPTION'} = "127.0.0.1"; }
    if( $sasld_conf{'MOPTION'} =~ /^(.*)\/\d+$/ or
    $sasld_conf{'MOPTION'} =~ /^(.*)\/\w+$/) { $is = $1;}
    else { $is = $sasld_conf{'MOPTION'};}
    if( ! $self->check_ipaddress($is) && $is !~ /^\w{1,}\.\w*$/ ) 
	{ $sasld_conf{'MOPTION'} = "127.0.0.1"; }
    }    
return %sasld_conf;
}

sub show_saslauthd_conf() 
# Show table for saslauthd.conf
{
my (@var, $value, $i, %sasld_conf, %mech);

$self->ui_print_header( $self->{'text_hash'}->{'index_daemon'}, $self->{'text_hash'}->{'index_daemon'});
%sasld_conf = &get_config(); 
print $self->ui_table_start("$self->{'text_hash'}->{'form_general_header'}", 
"width='100%' align='center'");
print $self->ui_form_start($self->get_script_name(),"post");

if($sasld_conf{$socketdir_name} eq $self->{'config_hash'}->{'socketdir'}) { $value = 0; }
else { $value = 1; }

@var = ( $self->hlink("<b>$self->{'text_hash'}->{'form_psock'}</b>","socketdir"),
$self->ui_radio("psock", $value, [ [ 0, 'Default' ], [ 1, 'Another' ] ]));
print $self->ui_columns_row( [ "$var[0]", "$var[1]" ] ,
    ["width='50%' rowspan='2' align='right'" , "align='left'" ]);

@var = ( $self->ui_textbox("socketdir", $sasld_conf{$socketdir_name}, 30));
print $self->ui_columns_row( [ "$var[0]" ], ["align='left'"]);

%mech = $self->get_auth_id(); undef @var; $i = 0;
foreach (keys(%mech)) {
    unless($_) { next; }
    @{$var[$i]} =  ("$_", "$mech{$_}");
    if($sasld_conf{$mech_name} eq $mech{$_}) { $value = $_; }
    $i++;
    }      

$value = $self->ui_select("mech", $value, \@var);
print $self->ui_columns_row([ $self->hlink("<b>$self->{'text_hash'}->{'form_mech'}</b>","mech"), "$value" ],
    ["width='50%' align='right'","align='left'"]);

@var = ( $self->hlink("<b>$self->{'text_hash'}->{'form_option'}</b>", "moption"),
$self->ui_textbox("moption", $sasld_conf{'MOPTION'}, 30));
print $self->ui_columns_row( [ "$var[0]", "$var[1]" ],
        ["width='50%' align='right'","align='left'"]);

print $self->ui_table_hr();

# Show cache options
print $self->ui_table_start("$self->{'text_hash'}->{'form_cache_header'}", "width='100%' align='center'");

@var = ( $self->hlink("<b>$self->{'text_hash'}->{'form_enable_cache'}</b>", "encache"),
$self->ui_checkbox("encache", 1, '', $sasld_conf{'ENCACHE'}) );
print $self->ui_columns_row( [ "$var[0]", "$var[1]" ],
       ["width='50%' align='right'", "align='left'"]);

@var = ( $self->hlink("<b>$self->{'text_hash'}->{'form_size_cache'}</b>", "csize"),
$self->ui_textbox("csize", $sasld_conf{'CSIZE'}, 10));
print $self->ui_columns_row( [ "$var[0]", "$var[1]" ],
        ["width='50%' align='right'","align='left'"]);

@var = ( $self->hlink("<b>$self->{'text_hash'}->{'form_ttl_cache'}</b>", "cttl"),
$self->ui_textbox("cttl", $sasld_conf{'CTTL'}, 10));
print $self->ui_columns_row( [ "$var[0]", "$var[1]" ],
        ["width='50%' align='right'","align='left'"]);

print $self->ui_table_hr();
print $self->ui_table_end();

# Show other options
print $self->ui_table_start("$self->{'text_hash'}->{'form_other_header'}", "width='100%' align='center'");

@var = ( $self->hlink("<b>$self->{'text_hash'}->{'form_nthreads'}</b>", "nthreads"),
$self->ui_textbox("nthreads", $sasld_conf{'NTHREADS'}, 10));
print $self->ui_columns_row( [ "$var[0]", "$var[1]" ],
        ["width='50%' align='right'","align='left'"]);

@var = ( $self->hlink("<b>$self->{'text_hash'}->{'form_time_restriction'}</b>", "trestrict"),
$self->ui_checkbox("trestrict", 1, '', $sasld_conf{'TRESTRICT'}) );
print $self->ui_columns_row( [ "$var[0]", "$var[1]" ],
       ["width='50%' align='right'", "align='left'"]);

@var = ( $self->hlink("<b>$self->{'text_hash'}->{'form_lock_file'}</b>", "unlock"),
$self->ui_checkbox("unlock", 1, '', $sasld_conf{'UNLOCK'}) );
print $self->ui_columns_row( [ "$var[0]", "$var[1]" ],
       ["width='50%' align='right'", "align='left'"]);

print $self->ui_table_hr();
print $self->ui_table_hr();

@var = ( $self->ui_hidden("sysreq",1) . $self->ui_submit($self->{'text_hash'}->{'form_button_submit'}) . 
$self->ui_form_end() . $self->ui_form_start($self->get_script_name(),"post") . 
$self->ui_hidden("sysreq",2) . $self->ui_submit($self->{'text_hash'}->{'form_button_edit'}) . 
$self->ui_form_end() );

print $self->ui_columns_row( [ "$var[0]" ], ["align='left'"]);
print $self->ui_table_end();
print $self->ui_table_end();
$self->ui_print_footer($self->{'text_hash'}->{'index_mainpage_url'}, $self->{'text_hash'}->{'index_mainpage'},
"", "$self->{'module_name'} page");
}

sub save_config($)
# Save content from form to some file
# $1 -name of file
{
my($var, $line, $value, @new_content, %mech, %sasld_conf);

# Get auth mechanism
%mech = $self->get_auth_id();
if( $self->{'in_hash'}->{'mech'} && $mech{$self->{'in_hash'}->{'mech'}}) { 
    $sasld_conf{$mech_name} = $mech{$self->{'in_hash'}->{'mech'}};
    }
else { $sasld_conf{$mech_name} = $mech{'0'}; }    

# Get socketdir
if( $self->{'in_hash'}->{'psock'} && $self->{'in_hash'}->{'socketdir'}) { 
    if($self->{'in_hash'}->{'socketdir'} !~ /.*\/$/ ) { 
	$self->{'in_hash'}->{'socketdir'} = $self->{'in_hash'}->{'socketdir'} . "/";
	}	
    unless( -d $self->{'in_hash'}->{'socketdir'}) { 
        $self->ui_print_header( $self->{'text_hash'}->{'index_daemon'}, $self->{'text_hash'}->{'index_daemon'});
	$self->error($self->text('error_nodir', $self->{'in_hash'}->{'socketdir'}));
	}
    $sasld_conf{$socketdir_name} = $self->{'in_hash'}->{'socketdir'};

    # Add socketdir in the command line too for other linux distr
    $sasld_conf{$flags_name} .= "-m $self->{'in_hash'}->{'socketdir'} ";  
    }    	  
else { 
    $sasld_conf{$socketdir_name} = $self->{'config_hash'}->{'socketdir'};

    # Add socketdir in the command line too for other linux distr
    $sasld_conf{$flags_name} .= "-m $self->{'in_hash'}->{'socketdir'} ";  
     }

# Get authmech options
# for rimap - fqdn or ip
# for other - config file (must exists!)
if( $self->{'in_hash'}->{'moption'} && ($sasld_conf{$mech_name} eq "rimap")) { 
    if( $self->{'in_hash'}->{'moption'} =~ /^(.*)\/\d+$/ or 
	$self->{'in_hash'}->{'moption'} =~ /^(.*)\/\w+$/) { $line = $1;}
    else { $line = $self->{'in_hash'}->{'moption'};}

    if( $line =~ /^\w{1,}\.\w+$/ ) {
	 $sasld_conf{$flags_name} .= "-O $self->{'in_hash'}->{'moption'} ";  
	}
    elsif( $self->check_ipaddress($line)) {
	 $sasld_conf{$flags_name} .= "-O $self->{'in_hash'}->{'moption'} ";  
	}
    else { $sasld_conf{$flags_name} .= "-O 127.0.0.1 "; }
    }
elsif( $sasld_conf{$mech_name} eq "rimap") { 
    $sasld_conf{$flags_name} .= "-O 127.0.0.1 "; }
elsif( -r $self->{'in_hash'}->{'moption'}) { $sasld_conf{$flags_name} .= "-O $self->{'in_hash'}->{'moption'} "; }

# Get cache options
if( $self->{'in_hash'}->{'encache'}) {
    $sasld_conf{$flags_name} .= "-c ";
    if( $self->{'in_hash'}->{'csize'} && $self->{'in_hash'}->{'csize'} =~ /^\d{1,}$/) {
	$sasld_conf{$flags_name} .= "-s $self->{'in_hash'}->{'csize'} ";
	}
    if( $self->{'in_hash'}->{'cttl'} && $self->{'in_hash'}->{'cttl'} =~ /^\d{1,}$/) {
	$sasld_conf{$flags_name} .= "-t $self->{'in_hash'}->{'cttl'} ";
	}
    }    

# Get other options
if( defined($self->{'in_hash'}->{'nthreads'}) && $self->{'in_hash'}->{'nthreads'} =~ /^\d{1,}$/) {
	$sasld_conf{$flags_name} .= "-n $self->{'in_hash'}->{'nthreads'} ";
     }
if( $self->{'in_hash'}->{'trestrict'}) { $sasld_conf{$flags_name} .= "-T "; }   	
if( $self->{'in_hash'}->{'unlock'}) { $sasld_conf{$flags_name} .= "-l "; }   	

# Get extra options, needed for concrete distr
if( $self->{'config_hash'}->{'EXTRA_VAR'}) {
    $self->{'config_hash'}->{'EXTRA_VAR'} =~ tr/\"\'//d;
    @new_content = split(' ', $self->{'config_hash'}->{'EXTRA_VAR'});
    foreach ( @new_content) {
	if( defined( $self->{'config_hash'}->{$_})) { $sasld_conf{$_} = $self->{'config_hash'}->{$_};}
	}
    }	

# Replacement config line if need
$var = $self->read_file_lines($self->{'config_hash'}->{'saslauthd_conf'});
$line = 0;
foreach (@$var) {
    foreach $value ( keys(%sasld_conf)) {
        if( /^$value/) { 
	    $$var[$line] = qq($value="$sasld_conf{$value}"); 
	    delete($sasld_conf{$value}); last;
	    }
	}
    $line++;
    }	

# Adding strings with variables that don't exist in config file
if( %sasld_conf) { 
    $line = $#{$var} + 1;
    foreach $value ( keys(%sasld_conf)) {
        $$var[$line] = qq($value="$sasld_conf{$value}"); $line++;
	}
    }    	    
$self->flush_file_lines($_[0]);

# Restart server
$var = $self->restart_sasld();
unless(defined($var)) { $self->redirect("index.cgi"); return 1; }
$self->ui_print_header( $self->{'text_hash'}->{'index_daemon'}, $self->{'text_hash'}->{'index_daemon'});
print $self->text('form_save_action', $_[0]);
print "<br><br>$var<br>";
$self->ui_print_footer($self->{'text_hash'}->{'index_mainpage_url'}, $self->{'text_hash'}->{'index_mainpage'}, 
"", "$self->{'module_name'} page", $ENV{'HTTP_REFERER'}, $self->{'text_hash'}->{'error_previous'});
}


1;

