#!/usr/bin/perl
# postconfig.pl
#configure SASL for Sendmail & Postfix

#main part
$no_acl_check++;
require './cyrus-sasl-lib.pl';
do '../common-lib.pl';
$main::error_must_die = 1;

#configure module
sub module_configure
{
 return -1 unless &configured('cyrus-sasl');
 %fconfig=&foreign_config('virtual-server');
 &foreign_require('init','init-lib.pl');
 my ($dir,@dir);

 #configure postfix
 @dir=split (/\//,$config{'sasl2_postfix2'});
 pop (@dir);
 $dir=join ("\/",@dir);
 if (-e $dir)
 {
  eval {mailserv_sasl_set(undef,$config{'sasl2_postfix2'},'saslauthd',$config{'saslauthd_conf'});};
  return $@ if ($@);
 }
 else
 {
  eval {mailserv_sasl_set($config{'sasl_postfix'},$config{'sasl2_postfix'},					'saslauthd',$config{'saslauthd_conf'});};
  return $@ if ($@);
 }

 #configure sendmail
 eval {mailserv_sasl_set($config{'sasl_sendmail'},$config{'sasl2_sendmail'},'saslauthd');};
 return $@ if ($@);

 #chkconfig & start saslauthd
 eval
 {
  &foreign_call('init','enable_at_boot','saslauthd');
  &start_saslauthd ();
 };
 return $@ if ($@);
 return 0;
}
