#!/usr/bin/perl

&MAIN();

 sub MAIN {

&ModuleLoader::preload_module('cyrus_sasl_class', "cyrus_sasl::CyrussaslLib");
$self = new cyrus_sasl::CyrussaslLib:: 'cyrus_sasl_class',%$self;


################################ BEGIN ##############################
local( $ver, $conf_file, $label);

$self->error_setup($self->{'text_hash'}->{'error'});

if( $ENV{'CONTENT_TYPE'} =~ /boundary=(.*)$/) { $self->ReadParseMime();}
else { $self->ReadParse();}

($ver, undef) = $self->get_version_sasld();
$ver =~ tr/[0-9\.]//cd;
if($self->{'in_hash'}->{'conf'} eq 'sendmail') {
    $label = $self->{'text_hash'}->{'index_sendmail'};
    if( $ver =~ /^1/ && ( -r $self->{'config_hash'}->{'sasl_sendmail'})) { 
	$conf_file = $self->{'config_hash'}->{'sasl_sendmail'};
	}
    elsif( $ver =~ /^2/ && ( -r $self->{'config_hash'}->{'sasl2_sendmail'})) { 
	$conf_file = $self->{'config_hash'}->{'sasl2_sendmail'};
	}
    else { $self->error($self->text('error_optfile', "Sendmail.conf"));}
    }
elsif($self->{'in_hash'}->{'conf'} eq 'mta') {
    $label = $self->{'text_hash'}->{'index_mta'};
    if( $ver =~ /^1/ && ( -r $self->{'config_hash'}->{'sasl_postfix'})) { 
	$conf_file = $self->{'config_hash'}->{'sasl_postfix'};
	}
    elsif( $ver =~ /^2/ && ( -r $self->{'config_hash'}->{'sasl2_postfix'})) { 
	$conf_file = $self->{'config_hash'}->{'sasl2_postfix'};
	}
    else { $self->error($self->text('error_optfile', "smtpd.conf"));}
    }
else { $self->redirect("index.cgi");}

if($self->{'in_hash'}->{'sysreq'} == 1) { &save_config($conf_file); }
elsif($self->{'in_hash'}->{'sysreq'} == 2) { 
    $self->show_manually_edit($conf_file, $self->get_script_name(), 20, 80,
    $label, { 'conf' => $self->{'in_hash'}->{'conf'}}); }
elsif($self->{'in_hash'}->{'sysreq'} == 3) { $self->save_manually_edit($conf_file); }
else {  &show_conf();}

##################################### END ###############################

############################# End Function #################################
1;
		
}

############################### Function ###########################
sub get_opts($) 
# Get available(default) value for some options
# $1 -available option
{
my %conf_opt = ( 'pwcheck_method' => [  'auxprop',
				    'pwcheck',
				    'saslauthd',
				    'authdaemon',
				    'alwaystrue'] ,
				    				 
	    'log_level'		=> [ 'error=1', 'warn=2', 'info=3'],
	    'auxprop_plugin'	=> [ 'sasldb', 'sql'],
	    'mech_list'		=> [ 'plain', 'login', 'digest-md5', 'cram-md5', 'anonymous' ],
	    'sasldb_path'	=> [ ''],
	    'authdaemond_path'	=> [ '/dev/null'],
	    'auto_transition'	=> [ 'no', 'yes', 'noplain'],
	    'saslauthd_path'	=> [ ''] );

return ${conf_opt{$_[0]}};
}

sub get_config($)
# Read config and fix data records
# $1 -config file
{
my (%appl_conf);

# Read config file
$self->read_file($_[0], \%appl_conf,'','',':') || 
$self->error($self->text('error_optfile', $_[0]));
foreach ( keys(%appl_conf)) {
    $appl_conf{$_} = $self->trunc_space( $appl_conf{$_});
    unless(/.*_path$/ or /^sql_.*/) { $appl_conf{$_} = lc($appl_conf{$_});}
    }
return %appl_conf;
}

sub show_conf() 
# Show table for appl.conf
{
my (@var, $value, $radio, $ref, $i, %appl_conf, %cross, %union);

$self->ui_print_header( $label, $label);

%appl_conf = &get_config($conf_file);

print $self->ui_table_start("$self->{'text_hash'}->{'form_general_header'}", 
"width='100%' align='center'");
print $self->ui_form_start($self->get_script_name(),"post");

# Check options pwcheck_method 	
$ref = &get_opts('pwcheck_method');
if( $ver =~ /^1/) { 
    for( $i = 0; $i <= $#{$ref}; $i++) 
	# Change name of method for old version cyrus_sasl 
        # auxprop (for 2.x.x) -> sasldb (for 1.x.x) 
	{ $$ref[$i] =~ s/auxprop/sasldb/;}
    } 
$value = ''; $radio = 0; %cross = (); %union = ();
if( $appl_conf{'pwcheck_method'})  {
    @var = split(" ", $appl_conf{'pwcheck_method'});
    foreach ( @var, @{$ref}) { $union{$_}++ && $cross{$_}++;}
    $value = join(' ', keys(%cross));
    $radio = 1 if( $value && ( $value ne $$ref[0]));
    }
unless( $value) { $value = $$ref[0];}

@var = ( $self->hlink("<b>$self->{'text_hash'}->{'config_pwmech'}</b>","pwcheck_method"),
$self->ui_radio("pwcheck_method_def", $radio, [ [ 0, 'Default' ], [ 1, 'Another' ] ]) .
$self->ui_textbox("pwcheck_method", $value, 30));
print $self->ui_columns_row( [ "$var[0]", "$var[1]" ] ,
    ["width='50%' align='right'" , "align='left'" ]);

# Check options authdaemond_path
$ref = &get_opts('authdaemond_path');
$value = $$ref[0]; $radio = 0;
if( $appl_conf{'authdaemond_path'} && 
    ( $appl_conf{'authdaemond_path'} ne $value)) {
	if( -p $appl_conf{'authdaemond_path'} or 
	    -S $appl_conf{'authdaemond_path'}) {
		$value = $appl_conf{'authdaemond_path'};
		$radio = 1;
		} 
    }

@var = ( $self->hlink("<b>$self->{'text_hash'}->{'config_authdpath'}</b>","authdaemond_path"),
$self->ui_radio("authdaemond_path_def", $radio, [ [ 0, 'Default' ], [ 1, 'Another' ] ]) .
$self->ui_textbox("authdaemond_path", $value, 30));
print $self->ui_columns_row( [ "$var[0]", "$var[1]" ] ,
    ["width='50%' align='right'" , "align='left'" ]);

# Check options saslauthd_path
$ref = &get_opts('saslauthd_path');
$value = $$ref[0]; $radio = 0;
if( $appl_conf{'saslauthd_path'}) {
	if( $appl_conf{'saslauthd_path'} =~ /.*\/mux$/ and 
	    ( -p $appl_conf{'saslauthd_path'} or 
	    -S $appl_conf{'saslauthd_path'})) {
	    $value = $appl_conf{'saslauthd_path'}; $radio = 1;
	    } 
    }

@var = ( $self->hlink("<b>$self->{'text_hash'}->{'config_sasldpath'}</b>","saslauthd_path"),
$self->ui_radio("saslauthd_path_def", $radio, [ [ 0, 'Default' ], [ 1, 'Another' ] ]) .
$self->ui_textbox("saslauthd_path", $value, 30));
print $self->ui_columns_row( [ "$var[0]", "$var[1]" ] ,
    ["width='50%' align='right'" , "align='left'" ]);

# Check option  mech_list
$ref = &get_opts('mech_list');

$value = ''; $radio = 0; %cross = (); %union = ();
if( $appl_conf{'mech_list'}) {
    @var = split(" ", $appl_conf{'mech_list'});
    foreach ( @{$ref}, @var) { $union{$_}++ && $cross{$_}++;}
    $value = join(' ', keys(%cross));
    $radio = 1 if($value);
    }

@var = ( $self->hlink("<b>$self->{'text_hash'}->{'config_mech_list'}</b>","mech_list"),
$self->ui_radio("mech_list_def", $radio, [ [ 0, 'Default' ], [ 1, 'Another' ] ]) .
$self->ui_textbox("mech_list", $value, 30));
print $self->ui_columns_row( [ "$var[0]", "$var[1]" ] ,
    ["width='50%' align='right'" , "align='left'" ]);
    
# Check option auto_transition
$ref = &get_opts('auto_transition');
$value = $$ref[0]; $radio = 0;
if( $appl_conf{'auto_transition'}) { 
    foreach (@{$ref}) {
        if( $appl_conf{'auto_transition'} eq $_) { $value = $_; $radio = 1;}
	}	    
    }
@var = ( $self->hlink("<b>$self->{'text_hash'}->{'config_auto_transition'}</b>", "auto_transition"),
$self->ui_radio("auto_transition_def", $radio, [ [ 0, 'Default' ], [ 1, 'Another' ] ]) .
$self->ui_textbox("auto_transition", $value, 30));
print $self->ui_columns_row( [ "$var[0]", "$var[1]" ] ,
    ["width='50%' align='right'" , "align='left'" ]);

# Check options log_level 	
$ref = &get_opts('log_level');
(undef, $value) = split('=', $$ref[0]);
if( $appl_conf{'log_level'})  {
    foreach (@{$ref}) {
        if(/\b\w+=$appl_conf{'log_level'}\b/) { 
	    (undef, $value) = split('=', $_);
	    }
	}	    
    }

@var = ();
for( $i = 0; $i <= $#{$ref}; $i++) {
    $var[$i] = [ reverse(split("=", $$ref[$i])) ];
    }         	 

$value = $self->ui_select("log_level", $value, \@var);
print $self->ui_columns_row([ $self->hlink("<b>$self->{'text_hash'}->{'config_log_level'}</b>",
"log_level"),"$value" ], ["width='50%' align='right'","align='left'"]);

print $self->ui_table_hr();

# Show auxprop options
print $self->ui_table_start("$self->{'text_hash'}->{'config_header_auxprop'}", "width='100%' align='center'");

# Check option auxprop_plugin
$ref = &get_opts('auxprop_plugin');
$value = ''; $radio = 0; %cross = (); %union = ();
if( $appl_conf{'auxprop_plugin'}) {
    @var = split(" ", $appl_conf{'auxprop_plugin'});
    foreach ( @var, @{$ref}) { $union{$_}++ && $cross{$_}++;}
    $value = join(' ', keys(%cross));
    $radio = 1 if($value);
    }

@var = ( $self->hlink("<b>$self->{'text_hash'}->{'config_auxprop_plugin'}</b>","auxprop_plugin"),
$self->ui_radio("auxprop_plugin_def", $radio, [ [ 0, 'Default' ], [ 1, 'Another' ] ]) .
$self->ui_textbox("auxprop_plugin", $value, 30));
print $self->ui_columns_row( [ "$var[0]", "$var[1]" ] ,
    ["width='50%' align='right'" , "align='left'" ]);

# Check option sasldb_path
$ref = &get_opts('sasldb_path');
$value = $$ref[0]; $radio = 0;
if( $appl_conf{'sasldb_path'} && ( -e $appl_conf{'sasldb_path'})) {
	    $value = $appl_conf{'sasldb_path'}; $radio = 1;
	    } 

@var = ( $self->hlink("<b>$self->{'text_hash'}->{'config_sasldb_path'}</b>","sasldb_path"),
$self->ui_radio("sasldb_path_def", $radio, [ [ 0, 'Default' ], [ 1, 'Another' ] ]) .
$self->ui_textbox("sasldb_path", $value, 30));
print $self->ui_columns_row( [ "$var[0]", "$var[1]" ] ,
    ["width='50%' align='right'" , "align='left'" ]);

# Check SQL option
@var = grep(/^sql_/, keys(%appl_conf));
if(@var) {
    foreach (@var) { $value .= "$_:$appl_conf{$_}\n";} $radio = 1;
    }
else { $value = $self->{'text_hash'}->{'config_sql_engine'}. "\n" . $self->{'text_hash'}->{'config_sql_hostnames'} ."\n" .
$self->{'text_hash'}->{'config_sql_user'}. "\n" . $self->{'text_hash'}->{'config_sql_passwd'} ."\n" . 
$self->{'text_hash'}->{'config_sql_database'} . "\n" . $self->{'text_hash'}->{'config_sql_select'} ."\n" . 
$self->{'text_hash'}->{'config_sql_usessl'}. "\n" . $self->{'text_hash'}->{'config_sql_insert'} ."\n" . 
$self->{'text_hash'}->{'config_sql_update'} ."\n"; $radio = 0;} 

@var = ( $self->hlink("<b>$self->{'text_hash'}->{'config_sql_option'}</b>","sql_option"),
$self->ui_radio("sql_option_def", $radio, [ [ 0, 'Not used' ], [ 1, 'Real config' ] ]));
print $self->ui_columns_row( [ "$var[0]", "$var[1]" ] ,
    ["width='50%' align='right'" , "align='left'" ]);

@var = ( $self->ui_textarea("sql_option", $value, 12, 85));
print $self->ui_columns_row( [ "$var[0]" ] ,
    ["width='50%' colspan='2' align='center'" ]);

print $self->ui_table_hr();
print $self->ui_table_hr();

@var = ( $self->ui_hidden("sysreq",1) . $self->ui_hidden("conf", $self->{'in_hash'}->{'conf'}) . 
$self->ui_submit($self->{'text_hash'}->{'save'}) . $self->ui_form_end() . 
$self->ui_form_start($self->get_script_name(),"get") . $self->ui_hidden("sysreq",2) . 
$self->ui_hidden("conf", $self->{'in_hash'}->{'conf'},1) . $self->ui_submit($self->{'text_hash'}->{'form_button_edit'}) . 
$self->ui_form_end() );

print $self->ui_columns_row( [ "$var[0]" ], ["align='left'"]);
print $self->ui_table_end();
print $self->ui_table_end();
$self->ui_print_footer($self->{'text_hash'}->{'index_mainpage_url'}, $self->{'text_hash'}->{'index_mainpage'},
"", "$self->{'module_name'} page");
}

sub save_config($)
# Save content from form to some file
# $1 -name of file
{
my(@var, $value, $ref, %union, %cross, %appl_conf);

# Get pwcheck_method 
$ref = &get_opts('pwcheck_method');
if( $ver =~ /^1/) { 
    for( $self->{'i'} = 0; $self->{'i'} <= $#{$ref}; $self->{'i'}++) 
	# Change name of method for old version cyrus_sasl 
        # auxprop (for 2.x.x) -> sasldb (for 1.x.x) 
	{ $$ref[$self->{'i'}] =~ s/auxprop/sasldb/;}
    } 
if( $self->{'in_hash'}->{'pwcheck_method_def'} && $self->{'in_hash'}->{'pwcheck_method'}) { 
    $value = ''; %cross = (); %union = ();
    @var = split(' ', $self->{'in_hash'}->{'pwcheck_method'});
    foreach ( @var, @{$ref}) { $union{$_}++ && $cross{$_}++;}
    $value = join(' ', keys(%cross));
    if( $value) { $appl_conf{'pwcheck_method'} = $value;}
    }
unless( $appl_conf{'pwcheck_method'})  { 
	$appl_conf{'pwcheck_method'} = $$ref[0];
	}
          
# Get options authdaemond_path
if( $self->{'in_hash'}->{'authdaemond_path_def'} && $self->{'in_hash'}->{'authdaemond_path'}) { 
    if( -p $self->{'in_hash'}->{'authdaemond_path'} or -S $self->{'in_hash'}->{'authdaemond_path'}) {
	$appl_conf{'authdaemond_path'} = $self->{'in_hash'}->{'authdaemond_path'};
	} 
    else { $self->error($self->text('error_option', 'authdaemond_path', 
    $self->{'in_hash'}->{'authdaemond_path'}));}
    }    

# Get options saslauthd_path
if( $self->{'in_hash'}->{'saslauthd_path_def'} && $self->{'in_hash'}->{'saslauthd_path'}) { 
    if( $self->{'in_hash'}->{'saslauthd_path'} =~ /.*\/mux$/ and 
	( -p $self->{'in_hash'}->{'saslauthd_path'} or -S $self->{'in_hash'}->{'saslauthd_path'})) {
	$appl_conf{'saslauthd_path'} = $self->{'in_hash'}->{'saslauthd_path'};
	} 
    else { $self->error($self->text('error_option', 'saslauthd_path', 
    $self->{'in_hash'}->{'saslauthd_path'}));}
    }

# Get option  mech_list
if( $self->{'in_hash'}->{'mech_list_def'} && $self->{'in_hash'}->{'mech_list'}) { 
    $ref = &get_opts('mech_list');
    @var = split(" ", $self->{'in_hash'}->{'mech_list'}); %cross = (); %union = ();
    foreach ( @var, @{$ref}) { $union{$_}++ && $cross{$_}++;}
    $value = join(' ', keys(%cross));
    $appl_conf{'mech_list'} = $value if($value);
    }

# Get option auto_transition
if( $self->{'in_hash'}->{'auto_transition_def'} && $self->{'in_hash'}->{'auto_transition'}) { 
    $ref = &get_opts('auto_transition');
    foreach (@{$ref}) {
        if( $self->{'in_hash'}->{'auto_transition'} eq $_) { 
	$appl_conf{'auto_transition'} = $self->{'in_hash'}->{'auto_transition'}; last;}
	}	    
    }

# Get options log_level 
if( $self->{'in_hash'}->{'log_level'}) {
    $ref = &get_opts('log_level');
    foreach (@{$ref}) {
        if(/^\w+=$self->{'in_hash'}->{'log_level'}$/) { 
	    $appl_conf{'log_level'} = $self->{'in_hash'}->{'log_level'}; last; }
	}	    
    }

# Get option auxprop_plugin
if( $self->{'in_hash'}->{'auxprop_plugin_def'} && $self->{'in_hash'}->{'auxprop_plugin'}) { 
    $ref = &get_opts('auxprop_plugin'); %cross = (); %union = ();
    @var = split(" ", $self->{'in_hash'}->{'auxprop_plugin'});
    foreach ( @var, @{$ref}) { $union{$_}++ && $cross{$_}++;}
    $value = join(' ', keys(%cross));
    $appl_conf{'auxprop_plugin'} = $value if($value);
    }

# Get option sasldb_path
if( $self->{'in_hash'}->{'sasldb_path_def'} && $self->{'in_hash'}->{'sasldb_path'}) { 
    if( -e $self->{'in_hash'}->{'sasldb_path'})  {
	$appl_conf{'sasldb_path'} = $self->{'in_hash'}->{'sasldb_path'};
	} 
    else { $self->error($self->text('error_option', 'sasldb_path', 
    $self->{'in_hash'}->{'sasldb_path'}));}
    }    

# Get SQL plugin option
if( $self->{'in_hash'}->{'sql_option_def'} && $self->{'in_hash'}->{'sql_option'}) { 
    @var = split('\n', $self->{'in_hash'}->{'sql_option'});
    @var = grep(/^sql_/, @var);
    if(@var) {
	foreach (@var) {  ($value, $ref) = split(':', $_); 
	    $appl_conf{$value} = $ref;
	    }
	}
    }	

$self->write_file($_[0], \%appl_conf, ':');
$self->redirect("index.cgi");
}


1;

