#!/usr/bin/perl
package dfsadmin::Log_parser;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'dfsadmin::Log_parser');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# log_parser.pl
# Functions for parsing this module's logs

&ModuleLoader::preload_module(ref($self), "dfsadmin::DfsLib");
$self = new dfsadmin::DfsLib:: ref($self), %$self; 

1;
		return $self;
}

# parse_webmin_log(user, script, action, type, object, &params)
# Converts logged information from this module into human-readable form
sub parse_webmin_log
{
	my $self = shift;

local ($user, $script, $action, $type, $object, $p) = @_;
if ($action eq 'modify') {
	if ($p->{'old'} ne $p->{'directory'}) {
		return $self->text('log_rename',
			     "<tt>".$self->html_escape($p->{'old'})."</tt>",
			     "<tt>".$self->html_escape($p->{'directory'})."</tt>");
		}
	else {
		return $self->text('log_modify',
			     "<tt>".$self->html_escape($object)."</tt>");
		}
	}
elsif ($action eq 'create') {
	return $self->text('log_create', "<tt>".$self->html_escape($object)."</tt>");
	}
elsif ($action eq 'delete') {
	return $self->text('log_delete', "<tt>".$self->html_escape($object)."</tt>");
	}
elsif ($action eq 'apply') {
	return $self->{'text_hash'}->{'log_apply'};
	}
else {
	return undef;
	}
}


1;

