#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_share.cgi
# Save changes to a shared directory

&ModuleLoader::preload_module('dfsadmin_class', "dfsadmin::DfsLib");
$self = new dfsadmin::DfsLib:: 'dfsadmin_class',%$self;

$self->error_setup($self->{'text_hash'}->{'save_err'});
use Socket;
$self->ReadParse();
@{$self->{'shlist_array'}} = $self->list_shares();

if ($self->{'in_hash'}->{'delete'}) {
	# Redirect to deletion CGI
	$self->redirect("delete_share.cgi?idx=$self->{'in_hash'}->{'idx'}");
	exit;
	}

# check inputs
if ($self->{'in_hash'}->{directory} !~ /^\/.*/) {
	$self->error($self->text('save_edirectory', $self->{'in_hash'}->{'directory'}));
	}
if (!(-d $self->{'in_hash'}->{directory})) {
	$self->error($self->text('save_edirectory2', $self->{'in_hash'}->{'directory'}));
	}
@{$self->{'rolist_array'}} = split(/\s+/, $self->{'in_hash'}->{rolist}); &check_hosts(@{$self->{'rolist_array'}});
@{$self->{'rwlist_array'}} = split(/\s+/, $self->{'in_hash'}->{rwlist}); &check_hosts(@{$self->{'rwlist_array'}});
@{$self->{'rtlist_array'}} = split(/\s+/, $self->{'in_hash'}->{rtlist}); &check_hosts(@{$self->{'rtlist_array'}});
if ($self->{'in_hash'}->{readwrite} == 2 && !@{$self->{'rwlist_array'}}) {
	$self->error($self->{'text_hash'}->{'save_erw'});
	}
if ($self->{'in_hash'}->{readonly} == 2 && !@{$self->{'rolist_array'}}) {
	$self->error($self->{'text_hash'}->{'save_ero'});
	}
if ($self->{'in_hash'}->{root} == 2 && !@{$self->{'rtlist_array'}}) {
	$self->error($self->{'text_hash'}->{'save_eroot'});
	}

# Remove from the read-only list any hosts shared read-write as well
if ($self->{'in_hash'}->{readwrite} == 1) {
	$self->{'in_hash'}->{readonly} = 0;
	}
elsif ($self->{'in_hash'}->{readwrite} == 2) {
	foreach $rwh (@{$self->{'rwlist_array'}}) {
		if (($self->{'idx'} = $self->indexof($rwh, @{$self->{'rolist_array'}})) != -1) {
			splice(@{$self->{'rolist_array'}}, $self->{'idx'}, 1);
			}
		}
	if (@{$self->{'rolist_array'}} == 0 && $self->{'in_hash'}->{readonly} == 2) {
		$self->{'in_hash'}->{readonly} = 0;
		}
	}

$self->lock_file($self->{'config_hash'}->{dfstab_file});
foreach $s (@{$self->{'shlist_array'}}) {
	$self->{'taken'} = $s if ($s->{'dir'} eq $self->{'in_hash'}->{directory});
	}

if (defined($self->{'in_hash'}->{'idx'})) {
	$self->{'share'} = $self->{'shlist_array'}->[$self->{'in_hash'}->{'idx'}];
	$self->{'olddir'} = $self->{'share'}->{'dir'};
	}
$self->{'share'}->{'dir'} = $self->{'in_hash'}->{'directory'};
$self->{'share'}->{'desc'} = $self->{'in_hash'}->{'desc'};
$self->{'share'}->{'type'} = 'nfs';

if (defined($self->{'in_hash'}->{'idx'})) {
	# Changing an existing share
	if ($self->{'taken'} && $self->{'taken'}->{'index'} != $self->{'in_hash'}->{'idx'}) {
		$self->error($self->text('save_ealready', $self->{'in_hash'}->{'directory'}));
		}
	$self->parse_options($self->{'share'}->{'opts'});
	&set_options();
	$self->{'share'}->{'opts'} = $self->join_options();
	$self->modify_share($self->{'share'});
	}
else {
	# Creating a new share
	if ($self->{'taken'}) {
		$self->error($self->text('save_ealready', $self->{'in_hash'}->{'directory'}));
		}
	&set_options();
	$self->{'share'}->{'opts'} = $self->join_options();
	$self->create_share($self->{'share'});
	}
$self->unlock_file($self->{'config_hash'}->{dfstab_file});
if (defined($self->{'in_hash'}->{'idx'})) {
	$self->webmin_log('modify', 'share', $self->{'olddir'}, \%{$self->{'in_hash'}});
	}
else {
	$self->webmin_log('create', 'share', $self->{'share'}->{'dir'}, \%{$self->{'in_hash'}});
	}
$self->redirect("");

1;
		
}

# set_options()
# Fill in the options associative array
sub set_options
{
	shift if ($self == $_[0]);

if ($self->{'in_hash'}->{readonly} == 0) { delete($self->{'options_hash'}->{"ro"}); }
elsif ($self->{'in_hash'}->{readonly} == 1) { $self->{'options_hash'}->{"ro"} = ""; }
elsif ($self->{'in_hash'}->{readonly} == 2) { $self->{'options_hash'}->{"ro"} = join(':', @{$self->{'rolist_array'}}); }

if ($self->{'in_hash'}->{readwrite} == 0) { delete($self->{'options_hash'}->{"rw"}); }
elsif ($self->{'in_hash'}->{readwrite} == 1) { $self->{'options_hash'}->{"rw"} = ""; }
elsif ($self->{'in_hash'}->{readwrite} == 2) { $self->{'options_hash'}->{"rw"} = join(':', @{$self->{'rwlist_array'}}); }

if ($self->{'in_hash'}->{root} == 0) { delete($self->{'options_hash'}->{"root"}); }
elsif ($self->{'in_hash'}->{root} == 2) { $self->{'options_hash'}->{"root"} = join(':', @{$self->{'rtlist_array'}}); }

if (!$self->{'access_hash'}->{'simple'}) {
	if ($self->{'in_hash'}->{nosub}) { $self->{'options_hash'}->{"nosub"} = ""; }
	else { delete($self->{'options_hash'}->{"nosub"}); }

	if ($self->{'in_hash'}->{nosuid}) { $self->{'options_hash'}->{"nosuid"} = ""; }
	else { delete($self->{'options_hash'}->{"nosuid"}); }

	if ($self->{'in_hash'}->{secure}) { $self->{'options_hash'}->{"secure"} = ""; }
	else { delete($self->{'options_hash'}->{"secure"}); }

	if ($self->{'in_hash'}->{kerberos}) { $self->{'options_hash'}->{"kerberos"} = ""; }
	else { delete($self->{'options_hash'}->{"kerberos"}); }

	if ($self->{'in_hash'}->{'anon_m'} == 0) { delete($self->{'options_hash'}->{"anon"}); }
	elsif ($self->{'in_hash'}->{'anon_m'} == 1) { $self->{'options_hash'}->{"anon"} = -1; }
	else { $self->{'options_hash'}->{"anon"} = getpwnam($self->{'in_hash'}->{"anon"}); }

	if ($self->{'in_hash'}->{aclok}) { $self->{'options_hash'}->{"aclok"} = ""; }
	else { delete($self->{'options_hash'}->{"aclok"}); }

	if ($self->{'gconfig_hash'}->{'os_version'} >= 7) {
		if ($self->{'in_hash'}->{'public'}) { $self->{'options_hash'}->{'public'} = ""; }
		else { delete($self->{'options_hash'}->{'public'}); }
		if (!$self->{'in_hash'}->{'index_def'}) { $self->{'options_hash'}->{'index'} = $self->{'in_hash'}->{'index'}; }
		else { delete($self->{'options_hash'}->{'index'}); }
		}
	}
}

# check_hosts(host, host, ...)
# Die if any of the listed hosts does not exist
sub check_hosts
{
	shift if ($self == $_[0]);

local $h;
if ($self->{'gconfig_hash'}->{'os_version'} < 7) {
	foreach $h (@_) {
		gethostbyname($h) || $self->error($self->text('save_ehost', $h));
		}
	}
}


1;

