#!/usr/bin/perl

&MAIN();

 sub MAIN {
# index.cgi
# display the icons for various types of dansguardian config options

# main part
&ModuleLoader::preload_module('dg_class', "dg::DgLib");
$self = new dg::DgLib:: 'dg_class',%$self;

$self->ReadParse();

# start, restart or stop service
if ($self->{'in_hash'}->{'start'}) { $self->start_dansguardian; }
elsif ($self->{'in_hash'}->{'stop'}) { $self->stop_dansguardian; }
elsif ($self->{'in_hash'}->{'restart'}) { $self->restart_dansguardian; }

# add new filter group
if ($self->{'in_hash'}->{'add_group'}) { $self->add_filter_group(); }

# print header
local $version = $self->get_version();
$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, undef, undef, 1, undef, undef, undef, undef, undef, $version ? $self->text('index_version', $version) : 0);

if (!$self->has_command($self->{'config_hash'}->{'dansguardian_cmd'})) 
{
 # error config messeges
 $self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, undef, undef, 1);
 $self->ui_print_endpage($self->ui_config_link('index_ecmd',[ "<tt>$self->{'config_hash'}->{'dansguardian_cmd'}</tt>", undef ]));
}

# print section icons
# get option list for installed version
local $options = $self->get_option_list();

# get section list
local (%temp, @section);
foreach (@{$options})
{
 $temp{$_->[0]}++;
}
@section = keys %temp;

# print section icons
print $self->ui_subheading($self->{'text_hash'}->{'options'})."\n";
print "<TABLE width=100% cellpadding=5><TR>\n";
local $i;
foreach (@section)
{
 print "<TD width=25% valign=top align=center nowrap>\n";
 $self->generate_icon("images/$_.gif",$self->{'text_hash'}->{"index_$_"},"options.cgi?section=$_")."</TD>\n";
 $i++;
 if ($i == 4)
 {
  print "</TR><TR>\n";
  $i = 0;
 }
}
print "<TD width=25% valign=top align=center nowrap>\n";
$self->generate_icon("images/blacklist.gif",$self->text('index_blacklist',$_->{'name'}),"blacklist.cgi")."</TD>\n";
print "</TR></TABLE>\n";

# get filter groups files
local $filters = $self->list_filter_files();

# print filter groups icons
print $self->ui_subheading($self->{'text_hash'}->{'index_filter_groups'});
print "<TABLE width=100% cellpadding=5><TR>\n";
local $i;
foreach (@{$filters})
{
 print "<TD width=25% valign=top align=center nowrap>\n";
 $self->generate_icon("images/group.gif",$self->text('index_group',$_->{'name'}),"filter_group.cgi?idx=$_->{'idx'}")."</TD>\n";
 $i++;
 if ($i == 4)
 {
  print "</TR><TR>\n";
  $i = 0;
 }
}

# print add group form
print $self->ui_form_start('index.cgi','post')."\n";
print "<TR><TD>".$self->ui_hidden('add_group',1)."\n";
print "<INPUT style=width:140 type=submit value='$self->{'text_hash'}->{'add_group'}'></TD>\n";
print "<TD colspan=3></TD></TR></TABLE>\n";
print $self->ui_form_end();

# print submit start,restart or stop
print $self->ui_subheading($self->{'text_hash'}->{'process_managment'})."\n";
print "<TABLE width=100% border=1>\n";

# index proces status
if ($self->status_dansguardian())
{
 # service started
 print $self->ui_form_start('index.cgi','post')."\n";
 print "<TR><TD width=15%>".$self->ui_hidden('stop',1)."\n";
 print "<INPUT style=width:140 type=submit value='$self->{'text_hash'}->{'index_stop'}'>\n";
 print "<TD>$self->{'text_hash'}->{'index_stopmsg'}</TD>\n";
 print $self->ui_form_end();
 print $self->ui_form_start('index.cgi','post')."\n";
 print "<TR><TD width=15%>".$self->ui_hidden('restart',1)."\n";
 print "<INPUT style=width:140 type=submit value='$self->{'text_hash'}->{'index_restart'}'>\n";
 print "<TD>$self->{'text_hash'}->{'index_restartmsg'}</TD></TR>\n";
}
else
{
 # service stoped
 print $self->ui_form_start('index.cgi','post')."\n";
 print "<TR><TD width=15%>".$self->ui_hidden('start',1)."\n";
 print "<INPUT style=width:140 type=submit value='$self->{'text_hash'}->{'index_start'}'>\n";
 print "<TD>$self->{'text_hash'}->{'index_startmsg'}</TD></TR>\n";
}
print $self->ui_form_end();
print "</TABLE>\n";

# print main page url
$self->ui_print_footer($self->{'text_hash'}->{'index_mainpage_url'}, $self->{'text_hash'}->{'index_mainpage'});
1;
		
}


1;

