#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Show user and login options

&ModuleLoader::preload_module('dovecot_class', "dovecot::DovecotLib");
$self = new dovecot::DovecotLib:: 'dovecot_class',%$self;

$self->ui_print_header(undef, $self->{'text_hash'}->{'login_title'}, "");
$self->{'conf'} = $self->get_config();

print $self->ui_form_start("save_login.cgi", "post");
print $self->ui_table_start($self->{'text_hash'}->{'login_header'}, "width=100%", 4);

# SASL authentication realms
$self->{'realms'} = $self->find_value("auth_realms", $self->{'conf'});
print $self->ui_table_row($self->{'text_hash'}->{'login_realms'},
	    $self->ui_opt_textbox("realms", $self->{'realms'}, 40, $self->{'text_hash'}->{'login_none'}), 3);

# Default authentication realm
$self->{'realm'} = $self->find_value("auth_default_realm", $self->{'conf'});
print $self->ui_table_row($self->{'text_hash'}->{'login_realm'},
	    $self->ui_opt_textbox("realm", $self->{'realm'}, 10, $self->{'text_hash'}->{'default'}));

# Authentication mechanisms (MD5, etc..)
if ($self->find("auth_mechanisms", $self->{'conf'}, 2)) {
	# Version 0.99 format
	@{$self->{'mechs_array'}} = split(/\s+/, $self->find_value("auth_mechanisms", $self->{'conf'}));
	}
else {
	# version 1.0 format
	@{$self->{'mechs_array'}} = split(/\s+/, $self->find_value("mechanisms", $self->{'conf'}, undef,
					  "auth", "default"));
	}
print $self->ui_table_row($self->{'text_hash'}->{'login_mechs'},
		    $self->ui_select("mechs", \@{$self->{'mechs_array'}},
			[ map { [ $_, $self->{'text_hash'}->{'login_'.$_} ] } @{$self->{'supported_auths_array'}} ],
			4, 1, 1));

print $self->ui_table_hr();

# User database, for mapping usernames to UIDs and homes
if ($self->find("auth_userdb", $self->{'conf'}, 2)) {
	# Version 0.99 format
	$self->{'userdb'} = $self->find_value("auth_userdb", $self->{'conf'});
	}
elsif ($self->{'usec'} = $self->find_section("userdb", $self->{'conf'}, undef, "auth", "default")) {
	# Version 1.0.alpha format
	$self->{'userdb'} = $self->{'usec'}->{'value'};
	$self->{'args'} = $self->find_value("args", $self->{'conf'}, undef, "userdb", $self->{'usec'}->{'value'});
	$self->{'userdb'} .= " $self->{'args'}" if ($self->{'args'});
	}
else {
	# Version 1.0 format
	$self->{'userdb'} = $self->find_value("userdb", $self->{'conf'}, undef, "auth", "default");
	}
if ($self->{'userdb'} eq "passwd") {
	$self->{'usermode'} = "passwd";
	}
elsif ($self->{'userdb'} =~ /^passwd-file\s+(.*)/) {
	$self->{'usermode'} = "passwd-file";
	$self->{'passwdfile'} = $1;
	}
elsif ($self->{'userdb'} =~ /^static\s+uid=(\d+)\s+gid=(\d+)\s+home=(.*)/) {
	$self->{'usermode'} = "static";
	$self->{'uid'} = $1;
	$self->{'gid'} = $2;
	$self->{'home'} = $3;
	}
elsif ($self->{'userdb'} eq "vpopmail") {
	$self->{'usermode'} = "vpopmail";
	}
elsif ($self->{'userdb'} =~ /^ldap\s+(.*)/) {
	$self->{'usermode'} = "ldap";
	$self->{'ldap'} = $1;
	}
elsif ($self->{'userdb'} =~ /^pgsql\s+(.*)/) {
	$self->{'usermode'} = "pgsql";
	$self->{'pgsql'} = $1;
	}
elsif ($self->{'userdb'} =~ /^sql\s+(.*)/) {
	$self->{'usermode'} = "sql";
	$self->{'sql'} = $1;
	}
else {
	$self->{'other'} = $self->{'userdb'};
	}
print $self->ui_table_row($self->{'text_hash'}->{'login_userdb'},
   $self->ui_radio("usermode", $self->{'usermode'},
	[ [ "passwd", $self->{'text_hash'}->{'login_passwd'}."<br>" ],
	  [ "passwd-file", $self->text('login_passwdfile',
		$self->ui_textbox("passwdfile", $self->{'passwdfile'}, 30))."<br>" ],
	  [ "static", $self->text('login_static',
		$self->ui_textbox("uid", $self->{'uid'}, 6),
		$self->ui_textbox("gid", $self->{'gid'}, 6),
		$self->ui_textbox("home", $self->{'home'}, 20))."<br>" ],
	  [ "vpopmail", $self->{'text_hash'}->{'login_vpopmail'}."<br>" ],
	  [ "ldap", $self->text('login_ldap',
		$self->ui_textbox("ldap", $self->{'ldap'}, 30))."<br>" ],
	  [ "pgsql", $self->text('login_pgsql',
		$self->ui_textbox("pgsql", $self->{'pgsql'}, 30))."<br>" ],
	  [ "sql", $self->text('login_sql',
		$self->ui_textbox("sql", $self->{'sql'}, 30))."<br>" ],
	  [ "", $self->text('login_other',
		$self->ui_textbox("other", $self->{'other'}, 30))."<br>" ],
	 ]), 3);

# Password authentication system
if ($self->find("auth_passdb", $self->{'conf'}, 2)) {
	# Version 0.99 format
	$self->{'passdb'} = $self->find_value("auth_passdb", $self->{'conf'});
	}
elsif ($self->{'psec'} = $self->find_section("passdb", $self->{'conf'}, undef, "auth", "default")) {
	# Version 1.0.alpha format
	$self->{'passdb'} = $self->{'psec'}->{'value'};
	$self->{'args'} = $self->find_value("args", $self->{'conf'}, undef, "passdb", $self->{'psec'}->{'value'});
	$self->{'passdb'} .= " $self->{'args'}" if ($self->{'args'});
	$self->{'alpha_opts'} = 1;
	}
else {
	# Version 1.0 format
	$self->{'passdb'} = $self->find_value("passdb", $self->{'conf'}, undef, "auth", "default");
	}
if ($self->{'passdb'} eq "passwd") {
	$self->{'passmode'} = "passwd";
	}
elsif ($self->{'passdb'} eq "shadow") {
	$self->{'passmode'} = "shadow";
	}
elsif ($self->{'passdb'} eq "pam") {
	$self->{'passmode'} = "dpam";
	}
elsif ($self->{'passdb'} =~ /^pam(\s+\-session)?(\s+cache_key=(\S+))?\s+(\S*)$/) {
	$self->{'passmode'} = "pam";
	$self->{'ppam'} = $4;
	$self->{'psession'} = $1 ? 1 : 0;
	$self->{'pckey'} = $3;
	}
elsif ($self->{'passdb'} =~ /^passwd-file\s+(.*)/) {
	$self->{'passmode'} = "passwd-file";
	$self->{'ppasswdfile'} = $1;
	}
elsif ($self->{'passdb'} eq "vpopmail") {
	$self->{'passmode'} = "vpopmail";
	}
elsif ($self->{'passdb'} =~ /^ldap\s+(.*)/) {
	$self->{'passmode'} = "ldap";
	$self->{'pldap'} = $1;
	}
elsif ($self->{'passdb'} =~ /^pgsql\s+(.*)/) {
	$self->{'passmode'} = "pgsql";
	$self->{'ppgsql'} = $1;
	}
elsif ($self->{'passdb'} =~ /^sql\s+(.*)/) {
	$self->{'passmode'} = "sql";
	$self->{'psql'} = $1;
	}
elsif ($self->{'passdb'} =~ /^bsdauth(\s+cache_key=(\S+))?$/) {
	$self->{'passmode'} = "bsdauth";
	$self->{'pbckey'} = $2;
	}
elsif ($self->{'passdb'} =~ /^checkpassword\s+(.*)$/) {
	$self->{'passmode'} = "checkpassword";
	$self->{'checkpassword'} = $1;
	}
else {
	$self->{'pother'} = $self->{'passdb'};
	}
print $self->ui_table_row($self->{'text_hash'}->{'login_passdb'},
   $self->ui_radio("passmode", $self->{'passmode'},
	[ [ "passwd", $self->{'text_hash'}->{'login_passwd2'}."<br>" ],
	  [ "shadow", $self->{'text_hash'}->{'login_shadow'}."<br>" ],
	  [ "dpam", $self->text('login_dpam')."<br>" ],
	  $self->{'alpha_opts'} ?
	    ( [ "pam", $self->text('login_pam2',
		  $self->ui_textbox("ppam", $self->{'ppam'}, 10),
		  $self->ui_checkbox("ppam_session", 1,
			       $self->{'text_hash'}->{'login_session'}, $self->{'psession'}),
		  $self->ui_opt_textbox("ppam_ckey", $self->{'pckey'}, 10,
				  $self->{'text_hash'}->{'login_none'}))."<br>" ]
 	    ) :
	    ( [ "pam", $self->text('login_pam',
		  $self->ui_textbox("ppam", $self->{'ppam'}, 10))."<br>" ]
	    ),
	  [ "passwd-file", $self->text('login_passwdfile',
		$self->ui_textbox("ppasswdfile", $self->{'ppasswdfile'}, 30))."<br>" ],
	  [ "vpopmail", $self->{'text_hash'}->{'login_vpopmail'}."<br>" ],
	  [ "ldap", $self->text('login_ldap',
		$self->ui_textbox("pldap", $self->{'pldap'}, 30))."<br>" ],
	  [ "pgsql", $self->text('login_pgsql',
		$self->ui_textbox("ppgsql", $self->{'ppgsql'}, 30))."<br>" ],
	  [ "sql", $self->text('login_sql',
		$self->ui_textbox("psql", $self->{'psql'}, 30))."<br>" ],
	  $self->{'alpha_opts'} ?
	    ( [ "bsdauth",
	        $self->text('login_bsdauth',
		      $self->ui_opt_textbox("bsdauth_ckey", $self->{'pbckey'}, 10,
				      $self->{'text_hash'}->{'login_none'}))."<br>" ],
	      [ "checkpassword",
	        $self->text('login_checkpassword',
		 $self->ui_textbox("checkpassword", $self->{'checkpassword'}, 40))."<br>" ],
	    ) :
	    ( ),
	  [ "", $self->text('login_other',
		$self->ui_textbox("pother", $self->{'pother'}, 30))."<br>" ],
	 ]), 3);

print $self->ui_table_hr();

$self->{'fuid'} = $self->find_value("first_valid_uid", $self->{'conf'});
print $self->ui_table_row($self->{'text_hash'}->{'login_fuid'},
    $self->ui_opt_textbox("fuid", $self->{'fuid'}, 6, $self->getdef("first_valid_uid")));

$self->{'luid'} = $self->find_value("last_valid_uid", $self->{'conf'});
@{$self->{'mmap_array'}} = ( [ 0, $self->{'text_hash'}->{'login_none'} ] );
print $self->ui_table_row($self->{'text_hash'}->{'login_luid'},
    $self->ui_opt_textbox("luid", $self->{'luid'}, 6, $self->getdef("last_valid_uid", \@{$self->{'mmap_array'}})));

$self->{'fgid'} = $self->find_value("first_valid_gid", $self->{'conf'});
print $self->ui_table_row($self->{'text_hash'}->{'login_fgid'},
    $self->ui_opt_textbox("fgid", $self->{'fgid'}, 6, $self->getdef("first_valid_gid")));

$self->{'lgid'} = $self->find_value("last_valid_gid", $self->{'conf'});
print $self->ui_table_row($self->{'text_hash'}->{'login_lgid'},
    $self->ui_opt_textbox("lgid", $self->{'lgid'}, 6, $self->getdef("last_valid_gid", \@{$self->{'mmap_array'}})));

$self->{'extra'} = $self->find_value("mail_extra_groups", $self->{'conf'});
print $self->ui_table_row($self->{'text_hash'}->{'login_extra'},
	    $self->ui_opt_textbox("extra", $self->{'extra'}, 50, $self->{'text_hash'}->{'login_none'})."\n".
	    $self->group_chooser_button("extra", 1), 3);

$self->{'chroot'} = $self->find_value("mail_chroot", $self->{'conf'});
print $self->ui_table_row($self->{'text_hash'}->{'login_chroot'},
	    $self->ui_opt_textbox("chroot", $self->{'chroot'}, 40, $self->{'text_hash'}->{'login_none'})."\n".
	    $self->file_chooser_button("chroot", 1), 3);

# Number of login processes
if ($self->find("login_max_processes_count", $self->{'conf'}, 2)) {
	print $self->ui_table_hr();
	$self->{'procs'} = $self->find_value("login_max_processes_count", $self->{'conf'});
	print $self->ui_table_row($self->{'text_hash'}->{'login_procs'},
	    $self->ui_opt_textbox("procs", $self->{'procs'}, 6,
			    $self->getdef("login_max_processes_count")), 3);
	}
if ($self->find("login_processes_count", $self->{'conf'}, 2)) {
	$self->{'count'} = $self->find_value("login_processes_count", $self->{'conf'});
	print $self->ui_table_row($self->{'text_hash'}->{'login_count'},
	    $self->ui_opt_textbox("count", $self->{'count'}, 6,
			    $self->getdef("login_processes_count")), 3);
	}

print $self->ui_table_end();
print $self->ui_form_end([ [ "save", $self->{'text_hash'}->{'save'} ] ]);

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

