#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Show mail file options

&ModuleLoader::preload_module('dovecot_class', "dovecot::DovecotLib");
$self = new dovecot::DovecotLib:: 'dovecot_class',%$self;

$self->ui_print_header(undef, $self->{'text_hash'}->{'mail_title'}, "");
$self->{'conf'} = $self->get_config();

print $self->ui_form_start("save_mail.cgi", "post");
print $self->ui_table_start($self->{'text_hash'}->{'mail_header'}, "width=100%", 4);

# Mail file location
$self->{'envmode'} = 4;
$self->{'env'} = $self->find_value("default_mail_env", $self->{'conf'});
for($i=0; $i<@{$self->{'mail_envs_array'}}; $i++) {
	$self->{'envmode'} = $i if ($self->{'mail_envs_array'}->[$i] eq $self->{'env'});
	}
print $self->ui_table_row($self->{'text_hash'}->{'mail_env'},
	$self->ui_radio("envmode", $self->{'envmode'},
		[ ( map { [ $_, $self->{'text_hash'}->{'mail_env'.$_}."<br>" ] } (0.. 3) ),
		  [ 4, $self->text('mail_env4',
			$self->ui_textbox("other", $self->{'envmode'} == 4 ? $self->{'env'} : undef, 30)) ] ],
		), 3);

# Check interval
$self->{'check'} = $self->find_value("mailbox_check_interval", $self->{'conf'});
print $self->ui_table_row($self->{'text_hash'}->{'mail_check'},
	$self->ui_radio("check", $self->{'check'} eq '' ? 0 : $self->{'check'} == 0 ? 1 : 2,
		  [ [ 1, $self->{'text_hash'}->{'mail_never'} ],
		    [ 2, $self->ui_textbox("checki", $self->{'check'} ? $self->{'check'} : "", 10).
			 " ".$self->{'text_hash'}->{'mail_secs'} ],
		    [ 0, $self->getdef("mailbox_check_interval",
				 [ [ 0, $self->{'text_hash'}->{'mail_never'} ] ]) ] ]), 3);

# Idle interval
$self->{'idle'} = $self->find_value("mailbox_idle_check_interval", $self->{'conf'});
print $self->ui_table_row($self->{'text_hash'}->{'mail_idle'},
	$self->ui_radio("idle", $self->{'idle'} eq '' ? 0 : $self->{'idle'} == 0 ? 1 : 2,
		  [ [ 1, $self->{'text_hash'}->{'mail_never'} ],
		    [ 2, $self->ui_textbox("idlei", $self->{'idle'} ? $self->{'idle'} : "", 10).
			 " ".$self->{'text_hash'}->{'mail_secs'} ],
		    [ 0, $self->getdef("mailbox_idle_check_interval",
				 [ [ 0, $self->{'text_hash'}->{'mail_never'} ] ]) ] ]), 3);

# Full FS access
@{$self->{'opts_array'}} = ( [ "yes", $self->{'text_hash'}->{'yes'} ], [ "no", $self->{'text_hash'}->{'no'} ] );
$self->{'full'} = $self->find_value("mail_full_filesystem_access", $self->{'conf'});
print $self->ui_table_row($self->{'text_hash'}->{'mail_full'},
	$self->ui_radio("full", $self->{'full'},
	  [ @{$self->{'opts_array'}},
	    [ "", $self->getdef("mail_full_filesystem_access", \@{$self->{'opts_array'}}) ] ]), 3);

# CRLF save mode
$self->{'crlf'} = $self->find_value("mail_save_crlf", $self->{'conf'});
@{$self->{'opts_array'}} = ( [ "yes", $self->{'text_hash'}->{'yes'} ], [ "no", $self->{'text_hash'}->{'no'} ] );
print $self->ui_table_row($self->{'text_hash'}->{'mail_crlf'},
	$self->ui_radio("crlf", $self->{'crlf'},
	  [ @{$self->{'opts_array'}},
	    [ "", $self->getdef("mail_save_crlf", \@{$self->{'opts_array'}}) ] ]), 3);

# Allow changing of files
$self->{'dirty'} = $self->find("mbox_dirty_syncs", $self->{'conf'}, 2) ?
		"mbox_dirty_syncs" : "maildir_check_content_changes";
$self->{'change'} = $self->find_value($self->{'dirty'}, $self->{'conf'});
print $self->ui_table_row($self->{'text_hash'}->{'mail_change'},
	$self->ui_radio("change", $self->{'change'},
	  [ @{$self->{'opts_array'}},
	    [ "", $self->getdef($self->{'dirty'}, \@{$self->{'opts_array'}}) ] ]), 3);

# Permissions on files
$self->{'umask'} = $self->find_value("umask", $self->{'conf'});
print $self->ui_table_row($self->{'text_hash'}->{'mail_umask'},
	$self->ui_opt_textbox("umask", $self->{'umask'}, 5, $self->getdef("umask")), 3);

# UIDL format
if ($self->find("pop3_uidl_format", $self->{'conf'}, 2)) {
	$self->{'uidl'} = $self->find_value("pop3_uidl_format", $self->{'conf'});
	@{$self->{'opts_array'}} = ( $self->{'uidl'} ? ( ) : ( [ "", $self->{'text_hash'}->{'mail_uidl_none'} ] ),
		  [ "%v.%u", $self->{'text_hash'}->{'mail_uidl_dovecot'} ],
		  [ "%08Xv%08Xu", $self->{'text_hash'}->{'mail_uidl_uw'} ],
		  [ "%f", $self->{'text_hash'}->{'mail_uidl_courier0'} ],
		  [ "%u", $self->{'text_hash'}->{'mail_uidl_courier1'} ],
		  [ "%v-%u", $self->{'text_hash'}->{'mail_uidl_courier2'} ],
		  [ "%Mf", $self->{'text_hash'}->{'mail_uidl_tpop3d'} ] );
	($self->{'got'}) = grep { $_->[0] eq $self->{'uidl'} } @{$self->{'opts_array'}};
	print $self->ui_table_row($self->{'text_hash'}->{'mail_uidl'},
		$self->ui_select("pop3_uidl_format", $self->{'got'} ? $self->{'uidl'} : "*",
			   [ @{$self->{'opts_array'}}, [ "*", $self->{'text_hash'}->{'mail_uidl_other'} ] ])."\n".
		$self->ui_textbox("pop3_uidl_format_other", $self->{'got'} ? "" : $self->{'uidl'}, 10),
		3);
	}

print $self->ui_table_end();
print $self->ui_form_end([ [ "save", $self->{'text_hash'}->{'save'} ] ]);

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

