#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Show networking options

&ModuleLoader::preload_module('dovecot_class', "dovecot::DovecotLib");
$self = new dovecot::DovecotLib:: 'dovecot_class',%$self;

$self->ui_print_header(undef, $self->{'text_hash'}->{'net_title'}, "");
$self->{'conf'} = $self->get_config();

print $self->ui_form_start("save_net.cgi", "post");
print $self->ui_table_start($self->{'text_hash'}->{'net_header'}, "width=100%", 4);

# Mail protocols
@{$self->{'protos_array'}} = split(/\s+/, $self->find_value("protocols", $self->{'conf'}));
print $self->ui_table_row($self->{'text_hash'}->{'net_protocols'},
	    $self->ui_select("protocols", \@{$self->{'protos_array'}},
		[ map { [ $_, $self->{'text_hash'}->{'net_'.$_} ] } @{$self->{'supported_protocols_array'}} ],
		scalar(@{$self->{'supported_protocols_array'}}), 1, 1));

$self->{'dis'} = $self->find_value("ssl_disable", $self->{'conf'});
@{$self->{'opts_array'}} = ( [ "no", $self->{'text_hash'}->{'yes'} ], [ "yes", $self->{'text_hash'}->{'no'} ] );
print $self->ui_table_row($self->{'text_hash'}->{'net_ssl_disable'},
	    $self->ui_radio("ssl_disable", $self->{'dis'},
		      [ @{$self->{'opts_array'}},
			[ "", $self->getdef("ssl_disable", \@{$self->{'opts_array'}}) ] ]));

@{$self->{'listens_array'}} = $self->find("imap_listen", $self->{'conf'}, 2) ?
		("imap_listen", "pop3_listen", "imaps_listen", "pop3s_listen") :
		("listen", "ssl_listen");
foreach $l (@{$self->{'listens_array'}}) {
	$self->{'listen'} = $self->find_value($l, $self->{'conf'});
	$self->{'mode'} = !$self->{'listen'} ? 0 :
	        $self->{'listen'} eq "[::]" ? 1 :
	        $self->{'listen'} eq "*" ? 2 : 3,
	print $self->ui_table_row($self->{'text_hash'}->{'net_'.$l},
		$self->ui_radio($l."_mode", $self->{'mode'},
			  [ [ 0, $self->{'text_hash'}->{'net_listen0'} ],
			    [ 1, $self->{'text_hash'}->{'net_listen1'} ],
			    [ 2, $self->{'text_hash'}->{'net_listen2'} ],
			    [ 3, $self->{'text_hash'}->{'net_listen3'} ] ])."\n".
		$self->ui_textbox($l, $self->{'mode'} == 3 ? $self->{'listen'} : "", 20), 3);
	}

print $self->ui_table_end();
print $self->ui_form_end([ [ "save", $self->{'text_hash'}->{'save'} ] ]);

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

