#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Show SSL options

&ModuleLoader::preload_module('dovecot_class', "dovecot::DovecotLib");
$self = new dovecot::DovecotLib:: 'dovecot_class',%$self;

$self->ui_print_header(undef, $self->{'text_hash'}->{'ssl_title'}, "");
$self->{'conf'} = $self->get_config();

print $self->ui_form_start("save_ssl.cgi", "post");
print $self->ui_table_start($self->{'text_hash'}->{'ssl_header'}, "width=100%", 4);

# SSL cert and key files
$self->{'cert'} = $self->find_value("ssl_cert_file", $self->{'conf'});
print $self->ui_table_row($self->{'text_hash'}->{'ssl_cert'},
	    $self->ui_opt_textbox("cert", $self->{'cert'}, 40, $self->getdef("ssl_cert_file")), 3,
	    [ undef, "nowrap" ]);

$self->{'key'} = $self->find_value("ssl_key_file", $self->{'conf'});
print $self->ui_table_row($self->{'text_hash'}->{'ssl_key'},
	    $self->ui_opt_textbox("key", $self->{'key'}, 40, $self->getdef("ssl_key_file")), 3,
	    [ undef, "nowrap" ]);

# Parameter regen time
$self->{'regen'} = $self->find_value("ssl_parameters_regenerate", $self->{'conf'});
print $self->ui_table_row($self->{'text_hash'}->{'ssl_regen'},
		    $self->ui_opt_textbox("regen", $self->{'regen'}, 5,
				    $self->getdef("ssl_parameters_regenerate")).
				    " ".$self->{'text_hash'}->{'ssl_hours'}, 3);

# Disable plaintext passwords when not SSL
@{$self->{'opts_array'}} = ( [ 'yes', $self->{'text_hash'}->{'yes'} ], [ 'no', $self->{'text_hash'}->{'no'} ] );
$self->{'plain'} = $self->find_value("disable_plaintext_auth", $self->{'conf'});
print $self->ui_table_row($self->{'text_hash'}->{'ssl_plain'},
    $self->ui_radio("plain", $self->{'plain'},
	      [ @{$self->{'opts_array'}},
		[ '', $self->getdef("disable_plaintext_auth", \@{$self->{'opts_array'}}) ] ]), 3);

print $self->ui_table_end();
print $self->ui_form_end([ [ "save", $self->{'text_hash'}->{'save'} ] ]);

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

