#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Show the dovecot config menu

&ModuleLoader::preload_module('dovecot_class', "dovecot::DovecotLib");
$self = new dovecot::DovecotLib:: 'dovecot_class',%$self;

$self->{'ver'} = $self->get_dovecot_version();
$self->ui_print_header(undef, $self->{'module_info_hash'}->{'desc'}, "", undef, 1, 1, 0,
		 $self->help_search_link("dovecot", "man", "doc", "google"),
		 undef, undef,
		 $self->{'ver'} ? $self->text('index_version', $self->{'ver'}) : undef);

# Make sure dovecot is installed
if (!$self->has_command($self->{'config_hash'}->{'dovecot'})) {
	print $self->ui_config_link('index_ecmd',
		        [ "<tt>$self->{'config_hash'}->{'dovecot'}</tt>", undef ]),"<p>\n";

	$self->foreign_require("software", "software-lib.pl");
	$self->{'lnk'} = $main::software_object->missing_install_link(
			"dovecot", $self->{'text_hash'}->{'index_dovecot'},
			"../$self->{'module_name'}/", $self->{'module_info_hash'}->{'desc'});
	print $self->{'lnk'},"<p>\n" if ($self->{'lnk'});

	$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});
	exit;
	}

# Check for config file
if (!-r $self->{'config_hash'}->{'dovecot_config'}) {
	print $self->ui_config_link('index_econf',
		[ "<tt>$self->{'config_hash'}->{'dovecot_config'}</tt>", undef ]),"<p>\n";
	$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});
	exit;
	}

# Show icons for option categories
@{$self->{'pages_array'}} = ( "net", "login", "mail", "ssl", "manual" );
@{$self->{'titles_array'}} = map { $self->{'text_hash'}->{$_."_title"} } @{$self->{'pages_array'}};
@{$self->{'icons_array'}} = map { "images/".$_.".gif" } @{$self->{'pages_array'}};
@{$self->{'links_array'}} = map { "edit_".$_.".cgi" } @{$self->{'pages_array'}};
$self->icons_table(\@{$self->{'links_array'}}, \@{$self->{'titles_array'}}, \@{$self->{'icons_array'}}, scalar(@{$self->{'titles_array'}}));

# Show start/stop and atboot buttons
print "<hr>\n";
print $self->ui_buttons_start();

if ($self->is_dovecot_running()) {
	print $self->ui_buttons_row("apply.cgi", $self->{'text_hash'}->{'index_apply'},
			      $self->{'text_hash'}->{'index_applydesc'});
	print $self->ui_buttons_row("stop.cgi", $self->{'text_hash'}->{'index_stop'},
			      $self->{'text_hash'}->{'index_stopdesc'});
	}
else {
	print $self->ui_buttons_row("start.cgi", $self->{'text_hash'}->{'index_start'},
			      $self->{'text_hash'}->{'index_startdesc'});
	}

if ($self->{'config_hash'}->{'init_script'}) {
	$self->foreign_require("init", "init-lib.pl");
	$self->{'atboot'} = $main::init_object->action_status($self->{'config_hash'}->{'init_script'});
	print $self->ui_buttons_row("bootup.cgi", $self->{'text_hash'}->{'index_boot'},
			      $self->{'text_hash'}->{'index_bootdesc'}, undef,
			      $self->ui_radio("boot", $self->{'atboot'} == 2 ? 1 : 0,
					[ [ 1, $self->{'text_hash'}->{'yes'} ],
					  [ 0, $self->{'text_hash'}->{'no'} ] ]));
	}

print $self->ui_buttons_end();

$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});

1;
		
}


1;

