#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Update mail file options

&ModuleLoader::preload_module('dovecot_class', "dovecot::DovecotLib");
$self = new dovecot::DovecotLib:: 'dovecot_class',%$self;

$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'mail_err'});
$self->lock_file($self->{'config_hash'}->{'dovecot_config'});
$self->{'conf'} = $self->get_config();

# Mail file location
if ($self->{'in_hash'}->{'envmode'} == 4) {
	$self->{'in_hash'}->{'other'} =~ /^\S+$/ || $self->error($self->{'text_hash'}->{'mail_eenv'});
	$self->{'env'} = $self->{'in_hash'}->{'other'};
	}
else {
	$self->{'env'} = $self->{'mail_envs_array'}->[$self->{'in_hash'}->{'envmode'}];
	}
$self->save_directive($self->{'conf'}, "default_mail_env", $self->{'env'} eq "" ? undef : $self->{'env'});

# Check and idle intervals
$self->{'in_hash'}->{'check'} != 2 || $self->{'in_hash'}->{'checki'} =~ /^\d+$/ || $self->error($self->{'text_hash'}->{'mail_echeck'});
$self->save_directive($self->{'conf'}, "mailbox_check_interval",
	$self->{'in_hash'}->{'check'} == 1 ? 0 : $self->{'in_hash'}->{'check'} == 2 ? $self->{'in_hash'}->{'checki'} : undef);
$self->{'in_hash'}->{'idle'} != 2 || $self->{'in_hash'}->{'idlei'} =~ /^\d+$/ || $self->error($self->{'text_hash'}->{'mail_eidle'});
$self->save_directive($self->{'conf'}, "mailbox_idle_check_interval",
	$self->{'in_hash'}->{'idle'} == 1 ? 0 : $self->{'in_hash'}->{'idle'} == 2 ? $self->{'in_hash'}->{'idlei'} : undef);

# Yes/no options
$self->save_directive($self->{'conf'}, "mail_full_filesystem_access",
		$self->{'in_hash'}->{'full'} ? $self->{'in_hash'}->{'full'} : undef);
$self->save_directive($self->{'conf'}, "mail_save_crlf",
		$self->{'in_hash'}->{'crlf'} ? $self->{'in_hash'}->{'crlf'} : undef);
if ($self->find("mbox_dirty_syncs", $self->{'conf'}, 2)) {
	$self->save_directive($self->{'conf'}, "mbox_dirty_syncs",
			$self->{'in_hash'}->{'change'} ? $self->{'in_hash'}->{'change'} : undef);
	}
else {
	$self->save_directive($self->{'conf'}, "maildir_check_content_changes",
			$self->{'in_hash'}->{'change'} ? $self->{'in_hash'}->{'change'} : undef);
	}

# Umask
$self->{'in_hash'}->{'umask_def'} || $self->{'in_hash'}->{'umask'} =~ /^[0-7]{4}$/ ||$self->error($self->{'text_hash'}->{'mail_eumask'});
$self->save_directive($self->{'conf'}, "umask",
		$self->{'in_hash'}->{'umask_def'} ? undef : $self->{'in_hash'}->{'umask'});

# UIDL format
if ($self->find("pop3_uidl_format", $self->{'conf'}, 2)) {
	$self->{'uidl'} = $self->{'in_hash'}->{'pop3_uidl_format'} eq '*' ?
			$self->{'in_hash'}->{'pop3_uidl_format_other'} : $self->{'in_hash'}->{'pop3_uidl_format'};
	$self->{'uidl'} =~ /^\S+$/ || $self->error($self->{'text_hash'}->{'mail_euid'});
	$self->save_directive($self->{'conf'}, "pop3_uidl_format", $self->{'uidl'});
	}

$self->flush_file_lines();
$self->unlock_file($self->{'config_hash'}->{'dovecot_config'});
$self->webmin_log("mail");
$self->redirect("");

1;
		
}


1;

