#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Update SSL options

&ModuleLoader::preload_module('dovecot_class', "dovecot::DovecotLib");
$self = new dovecot::DovecotLib:: 'dovecot_class',%$self;

$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'ssl_err'});
$self->lock_file($self->{'config_hash'}->{'dovecot_config'});
$self->{'conf'} = $self->get_config();

$self->{'in_hash'}->{'cert_def'} || -r $self->{'in_hash'}->{'cert'} || $self->error($self->{'text_hash'}->{'ssl_ecert'});
$self->{'in_hash'}->{'key_def'} || -r $self->{'in_hash'}->{'key'} || $self->error($self->{'text_hash'}->{'ssl_ekey'});
$self->save_directive($self->{'conf'}, "ssl_cert_file", $self->{'in_hash'}->{'cert_def'} ? undef : $self->{'in_hash'}->{'cert'});
$self->save_directive($self->{'conf'}, "ssl_key_file", $self->{'in_hash'}->{'key_def'} ? undef : $self->{'in_hash'}->{'key'});

$self->{'in_hash'}->{'regen_def'} || $self->{'in_hash'}->{'regen'} =~ /^\d+$/ || $self->error($self->{'text_hash'}->{'ssl_eregen'});
$self->save_directive($self->{'conf'}, "ssl_parameters_regenerate",
		$self->{'in_hash'}->{'regen_def'} ? undef : $self->{'in_hash'}->{'regen'});

$self->save_directive($self->{'conf'}, "disable_plaintext_auth",
		$self->{'in_hash'}->{'plain'} ? $self->{'in_hash'}->{'plain'} : undef);

$self->flush_file_lines();
$self->unlock_file($self->{'config_hash'}->{'dovecot_config'});
$self->webmin_log("ssl");
$self->redirect("");

1;
		
}


1;

