#!/usr/bin/perl
package enduser_cf::Enduser_cfLib;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'enduser_cf::Enduser_cfLib');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# enduser_cf-lib.pl
# Common functions for configuring usermin
# XXX share text with cpplus!

&ModuleLoader::preload_module(ref($self), "WebLib");
$self = new WebLib:: ref($self), %$self; 
$self->init_config();
&ModuleLoader::preload_module(ref($self), "UiLib");
$self = new UiLib:: ref($self), %$self; 
%{$self->{'access_hash'}} = $self->get_module_acl();
$self->{'access_hash'}->{'upgrade'} = 0 if ($self->is_readonly_mode());	# too hard to fake
$self->foreign_require("cpplus", "cpplus-lib.pl");
$self->foreign_require("acl", "acl-lib.pl");

$self->{'usermin_miniserv_config'} = "$self->{'config_hash'}->{'usermin_dir'}/miniserv.conf";
$self->{'usermin_config'} = "$self->{'config_hash'}->{'usermin_dir'}/config";

$self->{'update_host'} = "www.webmin.com";
$self->{'update_port'} = 80;
$self->{'update_page'} = "/uupdates/uupdates.txt";

$self->{'standard_usermin_dir'} = "/etc/usermin";
$self->{'latest_rpm'} = "http://www.webmin.com/download/usermin-latest.noarch.rpm";
$self->{'latest_tgz'} = "http://www.webmin.com/download/usermin-latest.tar.gz";

$self->{'default_key_size'} = 512;

$self->{'cron_cmd'} = "$self->{'module_config_directory'}/update.pl";

1;

1;
		return $self;
}

# get_usermin_miniserv_config(&array)
sub get_usermin_miniserv_config
{
	my $self = shift;

$self->read_file($self->{'usermin_miniserv_config'}, \%{$self->{'usermin_miniserv_config_cache_hash'}})
	if (!%{$self->{'usermin_miniserv_config_cache_hash'}});
%{$_[0]} = %{$self->{'usermin_miniserv_config_cache_hash'}};
}

# put_usermin_miniserv_config(&array)
sub put_usermin_miniserv_config
{
	my $self = shift;

%{$self->{'usermin_miniserv_config_cache_hash'}} = %{$_[0]};
$self->write_file($self->{'usermin_miniserv_config'}, \%{$self->{'usermin_miniserv_config_cache_hash'}});
}

# get_usermin_version()
sub get_usermin_version
{
	my $self = shift;

local %miniserv;
$self->get_usermin_miniserv_config(\%miniserv);
open(VERSION, "$miniserv{'root'}/version");
local $version = <VERSION>;
close(VERSION);
$version =~ s/\r|\n//g;
return $version;
}

# restart_usermin_miniserv()
# Send a HUP signal to miniserv
sub restart_usermin_miniserv
{
	my $self = shift;

return undef if ($self->is_readonly_mode());
local($pid, %miniserv, $addr, $i);
$self->get_usermin_miniserv_config(\%miniserv) || return;
$miniserv{'inetd'} && return;
open(PID, $miniserv{'pidfile'}) || $self->error("Failed to open PID file");
chop($pid = <PID>);
close(PID);
if (!$pid) { $self->error("Invalid PID file"); }
return $self->kill_logged('HUP', $pid);
}

# reload_usermin_miniserv()
# Sends a USR1 signal to the miniserv process
sub reload_usermin_miniserv
{
	my $self = shift;

return undef if ($self->is_readonly_mode());
local %miniserv;
$self->get_miniserv_config(\%miniserv) || return;
$miniserv{'inetd'} && return;

local($pid, $addr, $i);
open(PID, $miniserv{'pidfile'}) || $self->error("Failed to open PID file");
chop($pid = <PID>);
close(PID);
if (!$pid) { $self->error("Invalid PID file"); }
return $self->kill_logged('USR1', $pid);
}

# get_usermin_config(&array)
sub get_usermin_config
{
	my $self = shift;

$self->read_file($self->{'usermin_config'}, \%{$self->{'usermin_config_cache_hash'}})
	if (!%{$self->{'usermin_config_cache_hash'}});
%{$_[0]} = %{$self->{'usermin_config_cache_hash'}};
}

# put_usermin_config(&array)
sub put_usermin_config
{
	my $self = shift;

%{$self->{'usermin_config_cache_hash'}} = %{$_[0]};
$self->write_file($self->{'usermin_config'}, \%{$self->{'usermin_config_cache_hash'}});
}

# list_themes()
# Returns an array of all usermin themes
sub list_themes
{
	my $self = shift;

local @rv;
local %miniserv;
$self->get_usermin_miniserv_config(\%miniserv);
opendir(DIR, $miniserv{'root'});
foreach $m (readdir(DIR)) {
	next if ($m =~ /^\./);
	local %tinfo = $self->get_usermin_theme_info($m);
	next if (!%tinfo);
	next if (!$self->check_usermin_os_support(\%tinfo));
	push(@rv, \%tinfo);
	}
closedir(DIR);
return @rv;
}

# list_modules()
# Returns a list of all usermin modules
sub list_modules
{
	my $self = shift;

local (@mlist, $m, %miniserv);
$self->get_usermin_miniserv_config(\%miniserv);
local %cats;
$self->read_file_cached("$self->{'config_hash'}->{'usermin_dir'}/cpplus.cats", \%cats);
opendir(DIR, $miniserv{'root'});
foreach $m (readdir(DIR)) {
	local %minfo;
	if ((%minfo = $self->get_usermin_module_info($m)) &&
	    $self->check_usermin_os_support(\%minfo)) {
		$minfo{'realcategory'} = $minfo{'category'};
		$minfo{'category'} = $cats{$m} if (defined($cats{$m}));
		push(@mlist, \%minfo);
		}
	}
closedir(DIR);
@mlist = sort { $a->{'desc'} cmp $b->{'desc'} } @mlist;
return @mlist;
}

# get_usermin_module_info(module, [noclone])
# Returns a hash containg a module name, desc and os_support
sub get_usermin_module_info
{
	my $self = shift;

return () if ($_[0] =~ /^\./);
local (%rv, $clone, %miniserv, $o);
$self->get_usermin_miniserv_config(\%miniserv);
$self->read_file("$miniserv{'root'}/$_[0]/module.info", \%rv) || return ();
$clone = -l "$miniserv{'root'}/$_[0]";
foreach $o (@{$self->{'lang_order_list_array'}}) {
	$rv{"desc"} = $rv{"desc_$o"} if ($rv{"desc_$o"});
	}
if ($clone && !$_[1] && $self->{'config_directory'}) {
	$rv{'clone'} = $rv{'desc'};
	$self->read_file("$self->{'config_hash'}->{'usermin_dir'}/$_[0]/clone", \%rv);
	}
$rv{'dir'} = $_[0];
$rv{'realcategory'} = $rv{'category'};

# Apply description overrides
$rv{'realdesc'} = $rv{'desc'};
local %descs;
$self->read_file_cached("$self->{'config_hash'}->{'usermin_dir'}/webmin.descs", \%descs);
if ($descs{$_[0]." ".$self->{'current_lang'}}) {
	$rv{'desc'} = $descs{$_[0]." ".$self->{'current_lang'}};
	}
elsif ($descs{$_[0]}) {
	$rv{'desc'} = $descs{$_[0]};
	}

return %rv;
}

# get_usermin_theme_info(theme)
sub get_usermin_theme_info
{
	my $self = shift;

local (%tinfo, $o);
local %miniserv;
$self->get_usermin_miniserv_config(\%miniserv);
$self->read_file("$miniserv{'root'}/$_[0]/theme.info", \%tinfo) || return ();
foreach $o (@{$self->{'lang_order_list_array'}}) {
	$tinfo{"desc"} = $self->{'rv_hash'}->{"desc_$o"} if ($tinfo{"desc_$o"});
	}
$tinfo{'dir'} = $_[0];
return %tinfo;
}

# check_usermin_os_support(&minfo)
sub check_usermin_os_support
{
	my $self = shift;

local $oss = $_[0]->{'os_support'};
return 1 if (!$oss || $oss eq '*');
local %uconfig;
$self->get_usermin_config(\%uconfig);
while(1) {
	local ($os, $ver, $codes);
	if ($oss =~ /^([^\/\s]+)\/([^\{\s]+)\{([^\}]*)\}\s*(.*)$/) {
		$os = $1; $ver = $2; $codes = $3; $oss = $4;
		}
	elsif ($oss =~ /^([^\/\s]+)\/([^\/\s]+)\s*(.*)$/) {
		$os = $1; $ver = $2; $oss = $3;
		}
	elsif ($oss =~ /^([^\{\s]+)\{([^\}]*)\}\s*(.*)$/) {
		$os = $1; $codes = $2; $oss = $3;
		}
	elsif ($oss =~ /^\{([^\}]*)\}\s*(.*)$/) {
		$codes = $1; $oss = $2;
		}
	elsif ($oss =~ /^(\S+)\s*(.*)$/) {
		$os = $1; $oss = $2;
		}
	else { last; }
	next if ($os && !($os eq $uconfig{'os_type'} ||
		 $uconfig{'os_type'} =~ /^(\S+)-(\S+)$/ && $os eq "*-$2"));
	next if ($ver && $ver ne $uconfig{'os_version'});
	next if ($codes && !eval $codes);
	return 1;
	}
return 0;
}

# read_usermin_acl(&array, &array)
# Reads the acl file into the given associative arrays
sub read_usermin_acl
{
	my $self = shift;

local($user, $_, @mods);
if (!defined(%{$self->{'usermin_acl_hash_cache_hash'}})) {
	open(ACL, $self->usermin_acl_filename());
	while(<ACL>) {
		if (/^(\S+):\s*(.*)/) {
			local(@mods);
			$user = $1;
			@mods = split(/\s+/, $2);
			foreach $m (@mods) {
				$self->{'usermin_acl_hash_cache_hash'}->{$user,$m}++;
				}
			$self->{'usermin_acl_array_cache_hash'}->{$user} = \@mods;
			}
		}
	close(ACL);
	}
if ($_[0]) { %{$_[0]} = %{$self->{'usermin_acl_hash_cache_hash'}}; }
if ($_[1]) { %{$_[1]} = %{$self->{'usermin_acl_array_cache_hash'}}; }
}

# usermin_acl_filename()
# Returns the file containing the CP+ ACL
sub usermin_acl_filename
{
	my $self = shift;

return "$self->{'config_hash'}->{'usermin_dir'}/cpplus.acl";
}

# save_usermin_acl(user, &modules)
sub save_usermin_acl
{
	my $self = shift;

$self->open_tempfile(ACL, ">".$self->usermin_acl_filename());
$self->print_tempfile(ACL, $_[0],": ",join(" ", @{$_[1]}),"\n");
$self->close_tempfile(ACL);
}

# install_usermin_module(file, unlink, nodeps)
# Installs a usermin module or theme, and returns either an error message
# or references to three arrays for descriptions, directories and sizes.
# On success or failure, the file is deleted if the unlink parameter is set.
sub install_usermin_module
{
	my $self = shift;

local ($file, $need_unlink, $nodeps) = @_;
local (@mdescs, @mdirs, @msizes);
if ($self->is_readonly_mode()) {
	return "Module installs are not allowed in readonly mode";
	}

# Uncompress the module file if needed
open(MFILE, $file);
read(MFILE, $self->{'two'}, 2);
close(MFILE);
if ($self->{'two'} eq "\037\235") {
	if (!$self->has_command("uncompress")) {
		unlink($file) if ($need_unlink);
		return $self->text('install_ecomp', "<tt>uncompress</tt>");
		}
	local $temp = $file =~ /\/([^\/]+)\.Z/i ? $self->transname("$1")
						: $self->transname();
	local $out = `uncompress -c "$file" 2>&1 >$temp`;
	unlink($file) if ($need_unlink);
	if ($?) {
		unlink($temp);
		return $self->text('install_ecomp2', $out);
		}
	$file = $temp;
	$need_unlink = 1;
	}
elsif ($self->{'two'} eq "\037\213") {
	if (!$self->has_command("gunzip")) {
		unlink($file) if ($need_unlink);
		return $self->text('install_egzip', "<tt>gunzip</tt>");
		}
	local $temp = $file =~ /\/([^\/]+)\.gz/i ? $self->transname("$1")
						 : $self->transname();
	local $out = `gunzip -c "$file" 2>&1 >$temp`;
	unlink($file) if ($need_unlink);
	if ($?) {
		unlink($temp);
		return $self->text('install_egzip2', $out);
		}
	$file = $temp;
	$need_unlink = 1;
	}

local %miniserv;
$self->get_usermin_miniserv_config(\%miniserv);

# Check if this is an RPM usermin module or theme
local ($type, $redirect_to);
open(TYPE, "../install-type");
chop($type = <TYPE>);
close(TYPE);
if ($type eq 'rpm' && $file =~ /\.rpm$/i &&
    ($out = `rpm -qp $file 2>/dev/null`)) {
	# Looks like an RPM of some kind, hopefully an RPM usermin module
	# or theme
	local ($out, %minfo, %tinfo);
	if ($out !~ /^(wbm|wbt)-([^\s\-]+)/) {
		unlink($file) if ($need_unlink);
		return $self->{'text_hash'}->{'install_erpm'};
		}
	$redirect_to = $self->{'name'} = $2;
	$out = $self->backquote_logged("rpm -U \"$file\" 2>&1");
	if ($?) {
		unlink($file) if ($need_unlink);
		return $self->text('install_eirpm', "<tt>$out</tt>");
		}

	$mdirs[0] = "$miniserv{'root'}/$self->{'name'}";
	if (%minfo = $self->get_usermin_module_info($self->{'name'})) {
		# Get the new module info
		$mdescs[0] = $minfo{'desc'};
		$msizes[0] = $self->disk_usage_kb($mdirs[0]);

		# Update the ACL for the usermin user
		local %acl;
		$self->read_usermin_acl(undef, \%acl);
		$self->open_tempfile(ACL, "> ".$self->usermin_acl_filename());
		foreach $u (keys %acl) {
			local @mods = @{$acl{$u}};
			if ($u eq 'user') {
				push(@mods, $self->{'name'});
				@mods = $self->unique(@mods);
				}
			$self->print_tempfile(ACL, "$u: ",join(' ', @mods),"\n");
			}
		$self->close_tempfile(ACL);
		$self->webmin_log("install", undef, $self->{'name'},
			    { 'desc' => $mdescs[0] });
		}
	elsif (%tinfo = $self->get_usermin_theme_info($self->{'name'})) {
		# Get the theme info
		$mdescs[0] = $tinfo{'desc'};
		$msizes[0] = $self->disk_usage_kb($mdirs[0]);
		$self->webmin_log("tinstall", undef, $self->{'name'},
			    { 'desc' => $mdescs[0] });
		}
	else {
		unlink($file) if ($need_unlink);
		return $self->{'text_hash'}->{'install_eneither'};
		}
	}
else {
	# Check if this is a valid module (a tar file of multiple module or
	# theme directories)
	local (%mods, %hasfile);
	local $tar = `tar tf "$file" 2>&1`;
	if ($?) {
		unlink($file) if ($need_unlink);
		return $self->text('install_etar', $tar);
		}
	foreach $f (split(/\n/, $tar)) {
		if ($f =~ /^\.\/([^\/]+)\/(.*)$/ || $f =~ /^([^\/]+)\/(.*)$/) {
			$redirect_to = $1 if (!$redirect_to);
			$mods{$1}++;
			$hasfile{$1,$2}++;
			}
		}
	foreach $m (keys %mods) {
		if (!$hasfile{$m,"module.info"} && !$hasfile{$m,"theme.info"}) {
			unlink($file) if ($need_unlink);
			return $self->text('install_einfo', "<tt>$m</tt>");
			}
		}
	if (!%mods) {
		unlink($file) if ($need_unlink);
		return $self->{'text_hash'}->{'install_enone'};
		}

	# Get the module.info files to check dependancies
	local $ver = $self->get_usermin_version();
	local $tmpdir = $self->transname();
	mkdir($tmpdir, 0700);
	local $err;
	local @realmods;
	foreach $m (keys %mods) {
		next if (!$hasfile{$m,"module.info"});
		push(@realmods, $m);
		local %minfo;
		system("cd $tmpdir ; tar xf \"$file\" $m/module.info ./$m/module.info >/dev/null 2>&1");
		if (!$self->read_file("$tmpdir/$m/module.info", \%minfo)) {
			$err = $self->text('install_einfo', "<tt>$m</tt>");
			}
		elsif (!$self->check_usermin_os_support(\%minfo)) {
			$err = $self->text('install_eos', "<tt>$m</tt>",
				     $self->{'gconfig_hash'}->{'real_os_type'},
				     $self->{'gconfig_hash'}->{'real_os_version'});
			}
		elsif (!$minfo{'usermin'}) {
			$err = $self->text('install_eusermin', "<tt>$m</tt>");
			}
		elsif (!$nodeps) {
			local $deps = $minfo{'usermin_depends'} ||
				      $minfo{'depends'};
			foreach $dep (split(/\s+/, $minfo{'depends'})) {
				if ($dep =~ /^[0-9\.]+$/) {
					if ($dep > $ver) {
						$err = $self->text('install_ever',
							"<tt>$m</tt>",
							"<tt>$dep</tt>");
						}
					}
				elsif (!-r "$miniserv{'root'}/$dep/module.info"
				       && !$mods{$dep}) {
					$err = $self->text('install_edep',
					        "<tt>$m</tt>", "<tt>$dep</tt>");
					}
				}
			foreach $dep (split(/\s+/, $minfo{'perldepends'})) {
				eval "use $dep";
				if ($@) {
					$err = $self->text('install_eperldep',
					     "<tt>$m</tt>", "<tt>$dep</tt>",
					     "/cpan/download.cgi?source=3&cpan=$dep");
					}
				}
			}
		last if ($err);
		}
	system("rm -rf $tmpdir >/dev/null 2>&1");
	if ($err) {
		unlink($file) if ($need_unlink);
		return $err;
		}

	# Delete modules or themes being replaced
	foreach $m (@realmods) {
		system("rm -rf '$miniserv{'root'}/$m' 2>&1 >/dev/null") if ($m ne 'cpplus');
		}

	# Extract all the modules and update perl path and ownership
	local $out = `cd $miniserv{'root'} ; tar xf "$file" 2>&1 >/dev/null`;
	if ($?) {
		unlink($file) if ($need_unlink);
		return $self->text('install_eextract', $out);
		}
	if ($need_unlink) { unlink($file); }
	local $perl;
	open(PERL, "$miniserv{'root'}/miniserv.pl");
	<PERL> =~ /^#!(\S+)/; $perl = $1;
	close(PERL);
	local @st = stat($0);
	foreach $moddir (keys %mods) {
		local $pwd = "$miniserv{'root'}/$moddir";
		if ($hasfile{$moddir,"module.info"}) {
			local %minfo = $self->get_usermin_module_info($moddir);
			push(@mdescs, $minfo{'desc'});
			push(@mdirs, $pwd);
			push(@msizes, $self->disk_usage_kb($pwd));
			$self->webmin_log("install", undef, $moddir,
				    { 'desc' => $minfo{'desc'} });
			}
		else {
			local %tinfo = $self->get_usermin_theme_info($moddir);
			$self->read_file("theme.info", \%tinfo);
			push(@mdescs, $tinfo{'desc'});
			push(@mdirs, $pwd);
			push(@msizes, $self->disk_usage_kb($pwd));
			$self->webmin_log("tinstall", undef, $moddir,
				    { 'desc' => $tinfo{'desc'} });
			}
		system("(find $pwd -name '*.cgi' ; find $pwd -name '*.pl') 2>/dev/null | $perl $miniserv{'root'}/perlpath.pl $perl -");
		system("chown -R $st[4]:$st[5] $pwd");
		}

	# Copy appropriate config file from modules to /etc/cpplus
	local %ugconfig;
	$self->get_usermin_config(\%ugconfig);
	system("$perl $miniserv{'root'}/copyconfig.pl '$ugconfig{'os_type'}/$ugconfig{'real_os_type'}' '$ugconfig{'os_version'}/$ugconfig{'real_os_version'}' $miniserv{'root'} $self->{'config_hash'}->{'usermin_dir'} ".join(' ', @realmods));

	# Update ACL for this user so they can access the new modules
	local %acl;
	$self->read_usermin_acl(undef, \%acl);
	$self->open_tempfile(ACL, "> ".$self->usermin_acl_filename());
	foreach $u (keys %acl) {
		local @mods = @{$acl{$u}};
		if ($u eq 'user') {
			push(@mods, @realmods);
			@mods = $self->unique(@mods);
			}
		$self->print_tempfile(ACL, "$u: ",join(' ', @mods),"\n");
		}
	$self->close_tempfile(ACL);
	}
$self->flush_modules_cache();

return [ \@mdescs, \@mdirs, \@msizes ];
}

# list_usermin_usermods()
# Returns the list of additional module restrictions for usermin
sub list_usermin_usermods
{
	my $self = shift;

local @rv;
open(USERMODS, "$self->{'config_hash'}->{'usermin_dir'}/usermin.mods");
while(<USERMODS>) {
	if (/^([^:]+):(\+|-|):(.*)/) {
		push(@rv, [ $1, $2, [ split(/\s+/, $3) ] ]);
		}
	}
close(USERMODS);
return @rv;
}

# save_usermin_usermods(&usermods)
# Saves the list of additional module restrictions
sub save_usermin_usermods
{
	my $self = shift;

$self->open_tempfile(USERMODS, ">$self->{'config_hash'}->{'usermin_dir'}/usermin.mods");
foreach $u (@{$_[0]}) {
	$self->print_tempfile(USERMODS,
		join(":", $u->[0], $u->[1], join(" ", @{$u->[2]})),"\n");
	}
$self->close_tempfile(USERMODS);
}

# get_usermin_miniserv_users()
sub get_usermin_miniserv_users
{
	my $self = shift;

local %miniserv;
$self->get_usermin_miniserv_config(\%miniserv);
local @rv;
open(USERS, $miniserv{'userfile'});
while(<USERS>) {
	s/\r|\n//g;
	local @u = split(/:/, $_);
	push(@rv, { 'name' => $u[0],
		    'pass' => $u[1],
		    'sync' => $u[2],
		    'cert' => $u[3],
		    'allow' => $u[4] });
	}
close(USERS);
return @rv;
}

# save_usermin_miniserv_users(user, ...)
sub save_usermin_miniserv_users
{
	my $self = shift;

local %miniserv;
$self->get_usermin_miniserv_config(\%miniserv);
$self->open_tempfile(USERS, ">$miniserv{'userfile'}");
local $u;
foreach $u (@_) {
	$self->print_tempfile(USERS,
		join(":", $u->{'name'}, $u->{'pass'}, $u->{'sync'},
			  $u->{'cert'}, $u->{'allow'}),"\n");
	}
$self->close_tempfile(USERS);
}

# can_use_module(module)
sub can_use_module
{
	my $self = shift;

return 1 if ($self->{'access_hash'}->{'mods'} eq '*');
local @mods = split(/\s+/, $self->{'access_hash'}->{'mods'});
return $self->indexof($_[0], @mods) >= 0;
}

# get_usermin_base_version()
# Gets the usermin version, rounded to the nearest .01
sub get_usermin_base_version
{
	my $self = shift;

return $self->base_version($self->get_usermin_version());
}

# base_version()
# Rounds a version number to the nearest .01
sub base_version
{
	my $self = shift;

return sprintf("%.2f0", $_[0]);
}

# find_cron_job(\@jobs)
sub find_cron_job
{
	my $self = shift;

local ($job) = grep { $_->{'user'} eq 'root' &&
		      $_->{'command'} eq $self->{'cron_cmd'} } @{$_[0]};
return $job;
}

# delete_usermin_module(module, [delete-acls])
# Deletes some usermin module, clone or theme, and return a description of
# the thing deleted.
sub delete_usermin_module
{
	my $self = shift;

local $m = $_[0];
return undef if (!$m);
local %minfo = $self->get_usermin_module_info($m);
%minfo = $self->get_usermin_theme_info($m) if (!%minfo);
return undef if (!%minfo);
local ($mdesc, @aclrm);
@aclrm = ( $m ) if ($_[1]);
local %miniserv;
$self->get_usermin_miniserv_config(\%miniserv);
local %ugconfig;
$self->get_usermin_config(\%{$self->{'uconfig_hash'}});
local $mdir = "$miniserv{'root'}/$m";
local $cdir = "$self->{'config_hash'}->{'usermin_dir'}/$m";
if ($minfo{'clone'}) {
	# Deleting a clone
	local %cinfo;
	$self->read_file("$self->{'config_hash'}->{'usermin_dir'}/$m/clone", \%cinfo);
	$self->unlink_logged($mdir);
	$self->system_logged("rm -rf ".quotemeta($cdir));
	if ($ugconfig{'theme'}) {
		$self->unlink_logged("$miniserv{'root'}/$ugconfig{'theme'}/$m");
		}
	$mdesc = &{$PRODUCT::text}('delete_desc1', $minfo{'desc'}, $minfo{'clone'});
	}
else {
	# Delete any clones of this module
	local @clones;
	local @mst = stat($mdir);
	opendir(DIR, $miniserv{'root'});
	local $l;
	foreach $l (readdir(DIR)) {
		@{$self->{'lst_array'}} = stat("$miniserv{'root'}/$l");
		if (-l "$miniserv{'root'}/$l" && $self->{'lst_array'}->[1] == $mst[1]) {
			$self->unlink_logged("$miniserv{'root'}/$l");
			$self->system_logged("rm -rf $self->{'config_hash'}->{'usermin_dir'}/$l");
			push(@clones, $l);
			}
		}
	closedir(DIR);

	open(TYPE, "$mdir/install-type");
	chop($self->{'type'} = <TYPE>);
	close(TYPE);

	# Deleting the real module
	local $size = $self->disk_usage_kb($mdir);
	$mdesc = &{$PRODUCT::text}('delete_desc2', "<b>$minfo{'desc'}</b>",
			   "<tt>$mdir</tt>", $size);
	if ($self->{'type'} eq 'rpm') {
		# This module was installed from an RPM .. rpm -e it
		$self->system_logged("rpm -e ubm-$m");
		}
	else {
		# Module was installed from a .wbm file .. just rm it
		$self->system_logged("rm -rf ".quotemeta($mdir));
		}
	}

$self->webmin_log("delete", undef, $m, { 'desc' => $minfo{'desc'} });
return $mdesc;
}

# flush_modules_cache()
# Forces a rebuild of the Usermin module cache
sub flush_modules_cache
{
	my $self = shift;

$self->unlink_file("$self->{'config_hash'}->{'usermin_dir'}/module.infos.cache");
}

# stop_usermin()
# Kills the running Usermin server process, returning undef on sucess or an
# error message on failure.
sub stop_usermin
{
	my $self = shift;

local %miniserv;
$self->get_usermin_miniserv_config(\%miniserv);
local $pid;
if (open(PID, $miniserv{'pidfile'}) && ($pid = int(<PID>))) {
	$self->kill_logged('TERM', $pid) || return $self->text('stop_ekill', $!);
	close(PID);
	}
else {
	return $self->{'text_hash'}->{'stop_efile'};
	}
return undef;
}

# start_usermin()
# Starts the Usermin server process
sub start_usermin
{
	my $self = shift;

$self->system_logged("$self->{'config_hash'}->{'usermin_dir'}/start >/dev/null 2>&1 </dev/null");
return undef;
}

# get_install_type()
# Returns the package type Usermin was installed form (rpm, deb, solaris-pkg
# or undef for tar.gz)
sub get_install_type
{
	my $self = shift;

local (%miniserv, $mode);
$self->get_usermin_miniserv_config(\%miniserv);
if (open(MODE, "$miniserv{'root'}/install-type")) {
	chop($mode = <MODE>);
	close(MODE);
	}
else {
	if ($miniserv{'root'} eq "/usr/libexec/usermin") {
		$mode = "rpm";
		}
	elsif ($miniserv{'root'} eq "/usr/share/usermin") {
		$mode = "deb";
		}
	else {
		$mode = undef;
		}
	}
return $mode;
}


1;

