#!/usr/bin/perl
package enduser_cf::Log_parser;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'enduser_cf::Log_parser');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# log_parser.pl
# Functions for parsing this module's logs

&ModuleLoader::preload_module(ref($self), "enduser_cf::Enduser_cfLib");
$self = new enduser_cf::Enduser_cfLib:: ref($self), %$self; 

1;
		return $self;
}

# parse_webmin_log(user, script, action, type, object, &params)
# Converts logged information from this module into human-readable form
sub parse_webmin_log
{
	my $self = shift;

local ($user, $script, $action, $type, $object, $p) = @_;
if ($type eq "restrict") {
	return $self->text("log_restrict_$action",
		$object eq "*" ? $self->{'text_hash'}->{'log_all'} :
		$object =~ /^\@(.*)$/ ? $self->text('log_group', "<tt>$1</tt>")
				      : "<tt>$object</tt>");
	}
elsif ($action eq 'install') {
	return $self->text('log_install', "<i>$p->{'desc'}</i>");
	}
elsif ($action eq 'tinstall') {
	return $self->text('log_tinstall', "<i>$p->{'desc'}</i>");
	}
elsif ($action eq 'clone') {
	return $self->text('log_clone', "<i>$p->{'desc'}</i>",
				  "<i>$p->{'dstdesc'}</i>");
	}
elsif ($action eq 'delete') {
	return $self->text('log_delete', "<i>$p->{'desc'}</i>");
	}
elsif ($action eq 'upgrade') {
	return $self->text('log_upgrade', $p->{'version'});
	}
elsif ($action eq 'uinstall') {
	return $self->text('log_uinstall', $p->{'version'});
	}
elsif ($action eq 'theme') {
	return $p->{'theme'} ? $self->text('log_theme', "<tt>$p->{'theme'}</tt>")
			     : $self->{'text_hash'}->{'log_theme_def'};
	}
elsif ($action eq "config") {
	return $self->text('log_config', "<tt>$p->{'mod'}</tt>");
	}
elsif ($action eq "uconfig") {
	return $self->text('log_uconfig', "<tt>$p->{'mod'}</tt>");
	}
elsif ($action eq 'switch') {
	return $self->text('log_switch', "<tt>$object</tt>");
	}
elsif ($self->{'text_hash'}->{"log_$action"}) {
	return $self->{'text_hash'}->{"log_$action"};
	}
else {
	return undef;
	}
}


1;

