#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Save advanced options

&ModuleLoader::preload_module('enduser_cf_class', "enduser_cf::Enduser_cfLib");
$self = new enduser_cf::Enduser_cfLib:: 'enduser_cf_class',%$self;

$self->ReadParse();
$self->error_setup($main::cpplus_object->{'text_hash'}->{'advanced_err'});
$self->get_usermin_miniserv_config(\%{$self->{'miniserv_hash'}});
$self->get_usermin_config(\%{$self->{'uconfig_hash'}});

# Save global temp dir setting
if ($self->{'in_hash'}->{'tempdir_def'}) {
	delete($self->{'uconfig_hash'}->{'tempdir'});
	}
else {
	-d $self->{'in_hash'}->{'tempdir'} || $self->error($main::cpplus_object->{'text_hash'}->{'advanced_etemp'});
	$self->{'uconfig_hash'}->{'tempdir'} = $self->{'in_hash'}->{'tempdir'};
	}

# Save per-module temp dirs
for($i=0; defined($self->{'tmod'} = $self->{'in_hash'}->{'tmod_'.$i}); $i++) {
	next if (!$self->{'tmod'});
	$self->{'tdir'} = $self->{'in_hash'}->{'tdir_'.$i};
	%{$self->{'minfo_hash'}} = $self->get_usermin_module_info($self->{'tmod'});
	-d $self->{'tdir'} || $self->error($main::cpplus_object->text('advanced_etdir', $self->{'minfo_hash'}->{'desc'}));
	push(@{$self->{'tdirs_array'}}, [ $self->{'tmod'}, $self->{'tdir'} ]);
	}
$main::cpplus_object->save_tempdirs(\%{$self->{'uconfig_hash'}}, \@{$self->{'tdirs_array'}});

# Save stack trace option
$self->{'uconfig_hash'}->{'error_stack'} = $self->{'in_hash'}->{'stack'};

# Save umask
if ($self->{'in_hash'}->{'umask_def'}) {
	delete($self->{'uconfig_hash'}->{'umask'});
	}
else {
	$self->{'in_hash'}->{'umask'} =~ /^[0-7]{3}$/ ||
		$self->error($main::cpplus_object->{'text_hash'}->{'advanced_eumask'});
	$self->{'uconfig_hash'}->{'umask'} = $self->{'in_hash'}->{'umask'};
	}

$self->lock_file($self->{'usermin_config'});
$self->write_file($self->{'usermin_config'}, \%{$self->{'uconfig_hash'}});
$self->unlock_file($self->{'usermin_config'});

# Save password pass option
$self->{'miniserv_hash'}->{'pass_password'} = $self->{'in_hash'}->{'pass'};

$self->lock_file($self->{'usermin_miniserv_config'});
$self->put_usermin_miniserv_config(\%{$self->{'miniserv_hash'}});
$self->unlock_file($self->{'usermin_miniserv_config'});
$self->restart_usermin_miniserv();

$self->webmin_log("advanced");
$self->redirect("");

1;
		
}


1;

