#!/usr/bin/perl

&MAIN();

 sub MAIN {
# change_session.cgi
# Enable or disable session authentication

&ModuleLoader::preload_module('enduser_cf_class', "enduser_cf::Enduser_cfLib");
$self = new enduser_cf::Enduser_cfLib:: 'enduser_cf_class',%$self;

$self->{'access_hash'}->{'session'} || $self->error($self->{'text_hash'}->{'acl_ecannot'});
$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'session_err'});
$self->{'ver'} = $self->get_usermin_version();

$self->lock_file($self->{'usermin_miniserv_config'});
$self->get_usermin_miniserv_config(\%{$self->{'miniserv_hash'}});
$self->{'miniserv_hash'}->{'passdelay'} = $self->{'in_hash'}->{'passdelay'};
if ($self->{'in_hash'}->{'blockhost_on'}) {
	$self->{'in_hash'}->{'blockhost_time'} =~ /^\d+$/ && $self->{'in_hash'}->{'blockhost_time'} > 0 ||
		$self->error($main::cpplus_object->{'text_hash'}->{'session_eblockhost_time'});
	$self->{'in_hash'}->{'blockhost_failures'} =~ /^\d+$/ && $self->{'in_hash'}->{'blockhost_failures'} > 0 ||
		$self->error($main::cpplus_object->{'text_hash'}->{'session_eblockhost_failures'});
	$self->{'miniserv_hash'}->{'blockhost_time'} = $self->{'in_hash'}->{'blockhost_time'};
	$self->{'miniserv_hash'}->{'blockhost_failures'} = $self->{'in_hash'}->{'blockhost_failures'};
	}
else {
	$self->{'miniserv_hash'}->{'blockhost_time'} = $self->{'miniserv_hash'}->{'blockhost_failures'} = undef;
	}
$self->{'miniserv_hash'}->{'syslog'} = $self->{'in_hash'}->{'syslog'};
if ($self->{'in_hash'}->{'session'} && $ENV{'HTTP_COOKIE'} !~ /sessiontest=1/i) {
	$self->error($main::cpplus_object->{'text_hash'}->{'session_ecookie'});
	}
$self->{'miniserv_hash'}->{'session'} = $self->{'in_hash'}->{'session'};
if ($self->{'in_hash'}->{'logouttime_on'}) {
	$self->{'in_hash'}->{'logouttime'} =~ /^\d+$/ && $self->{'in_hash'}->{'logouttime'} > 0 ||
		$self->error($main::cpplus_object->{'text_hash'}->{'session_elogouttime'});
	}
$self->{'miniserv_hash'}->{'logouttime'} = $self->{'in_hash'}->{'logouttime_on'} ? $self->{'in_hash'}->{'logouttime'} : undef;
if ($self->{'in_hash'}->{'localauth'}) {
	$self->{'lsof'} = $self->has_command("lsof");
	$self->error($main::cpplus_object->{'text_hash'}->{'session_elsof'}) if (!$self->{'lsof'});
	$self->{'miniserv_hash'}->{'localauth'} = $self->{'lsof'};
	}
else {
	delete($self->{'miniserv_hash'}->{'localauth'});
	}
if ($self->{'in_hash'}->{'passwd_file'}) {
	$self->{'in_hash'}->{'passwd_file'} =~ /\|$/ || -r $self->{'in_hash'}->{'passwd_file'} ||
		$self->error($main::cpplus_object->{'text_hash'}->{'session_epasswd_file'});
	$self->{'in_hash'}->{'passwd_uindex'} =~ /^\d+$/ ||
		$self->error($main::cpplus_object->{'text_hash'}->{'session_epasswd_uindex'});
	$self->{'in_hash'}->{'passwd_pindex'} =~ /^\d+$/ ||
		$self->error($main::cpplus_object->{'text_hash'}->{'session_epasswd_pindex'});
	$self->{'miniserv_hash'}->{'passwd_file'} = $self->{'in_hash'}->{'passwd_file'};
	$self->{'miniserv_hash'}->{'passwd_uindex'} = $self->{'in_hash'}->{'passwd_uindex'};
	$self->{'miniserv_hash'}->{'passwd_pindex'} = $self->{'in_hash'}->{'passwd_pindex'};
	}
else {
	delete($self->{'miniserv_hash'}->{'passwd_file'});
	delete($self->{'miniserv_hash'}->{'passwd_uindex'});
	delete($self->{'miniserv_hash'}->{'passwd_pindex'});
	}
if ($self->{'in_hash'}->{'extauth'}) {
	$self->{'in_hash'}->{'extauth'} =~ /^(\S+)/ && -x $1 ||
		$self->error($self->{'text_hash'}->{'session_eextauth'});
	$self->{'miniserv_hash'}->{'extauth'} = $self->{'in_hash'}->{'extauth'};
	}
else {
	delete($self->{'miniserv_hash'}->{'extauth'});
	}

if ($self->{'ver'} >= 1.047 && defined($self->{'in_hash'}->{'passwd_mode'})) {
	$self->{'miniserv_hash'}->{'passwd_mode'} = $self->{'in_hash'}->{'passwd_mode'};
	}
if ($self->{'ver'} >= 1.087) {
	$self->{'miniserv_hash'}->{'passwd_blank'} = $self->{'in_hash'}->{'passwd_blank'};
	}

if ($self->{'ver'} >= 1.003) {
	$self->{'miniserv_hash'}->{'domainuser'} = $self->{'in_hash'}->{'domainuser'};
	}
if ($self->{'ver'} >= 1.021) {
	$self->{'miniserv_hash'}->{'domainstrip'} = $self->{'in_hash'}->{'domainstrip'};
	if ($self->{'in_hash'}->{'user_mapping_on'}) {
		-r $self->{'in_hash'}->{'user_mapping'} || $self->{'in_hash'}->{'user_mapping'} =~ /\|$/ ||
			$self->error($self->{'text_hash'}->{'session_eusermap'});
		$self->{'miniserv_hash'}->{'user_mapping'} = $self->{'in_hash'}->{'user_mapping'};
		}
	else {
		delete($self->{'miniserv_hash'}->{'user_mapping'});
		}
	$self->{'miniserv_hash'}->{'user_mapping_reverse'} = $self->{'in_hash'}->{'user_mapping_reverse'};
	}
$self->lock_file($self->{'miniserv_hash'}->{'userfile'});
@{$self->{'users_array'}} = $self->get_usermin_miniserv_users();
if ($self->{'in_hash'}->{'authmode'} == 0) {
	delete($self->{'miniserv_hash'}->{'no_pam'});
	$self->{'users_array'}->[0]->{'pass'} = 'x';
	}
elsif ($self->{'in_hash'}->{'authmode'} == 1) {
	$self->{'in_hash'}->{'passwd_file'} || $self->error($self->{'text_hash'}->{'session_eauthmode1'});
	$self->{'miniserv_hash'}->{'no_pam'} = 1;
	$self->{'users_array'}->[0]->{'pass'} = 'x';
	}
else {
	$self->{'in_hash'}->{'extauth'} || $self->error($self->{'text_hash'}->{'session_eauthmode2'});
	$self->{'users_array'}->[0]->{'pass'} = 'e';
	}
$self->{'miniserv_hash'}->{'pam_conv'} = $self->{'in_hash'}->{'pam_conv'};
if ($self->{'ver'} >= 1.153) {
	$self->{'miniserv_hash'}->{'utmp'} = $self->{'in_hash'}->{'utmp'};
	}
$self->save_usermin_miniserv_users(@{$self->{'users_array'}});
$self->unlock_file($self->{'miniserv_hash'}->{'userfile'});
$self->put_usermin_miniserv_config(\%{$self->{'miniserv_hash'}});
$self->unlock_file($self->{'usermin_miniserv_config'});

$self->lock_file($self->{'usermin_config'});
$self->get_usermin_config(\%{$self->{'uconfig_hash'}});
#$self->{'uconfig_hash'}->{'locking'} = $self->{'in_hash'}->{'locking'};
$self->{'uconfig_hash'}->{'noremember'} = !$self->{'in_hash'}->{'remember'};
$self->{'uconfig_hash'}->{'nohostname'} = !$self->{'in_hash'}->{'hostname'};
$self->{'uconfig_hash'}->{'realname'} = $self->{'in_hash'}->{'realname'};
if ($self->{'in_hash'}->{'passwd_file'}) {
	$self->{'uconfig_hash'}->{'passwd_file'} = $self->{'in_hash'}->{'passwd_file'};
	$self->{'uconfig_hash'}->{'passwd_uindex'} = $self->{'in_hash'}->{'passwd_uindex'};
	$self->{'uconfig_hash'}->{'passwd_pindex'} = $self->{'in_hash'}->{'passwd_pindex'};
	}
else {
	delete($self->{'uconfig_hash'}->{'passwd_file'});
	delete($self->{'uconfig_hash'}->{'passwd_uindex'});
	delete($self->{'uconfig_hash'}->{'passwd_pindex'});
	}
if ($self->{'in_hash'}->{'banner_def'}) {
	delete($self->{'uconfig_hash'}->{'loginbanner'});
	}
else {
	-r $self->{'in_hash'}->{'banner'} || $self->error($main::cpplus_object->{'text_hash'}->{'session_ebanner'});
	$self->{'uconfig_hash'}->{'loginbanner'} = $self->{'in_hash'}->{'banner'};
	}
$self->{'uconfig_hash'}->{'create_homedir'} = $self->{'in_hash'}->{'create_homedir'};
if ($self->{'in_hash'}->{'create_homedir_perms_def'}) {
	delete($self->{'uconfig_hash'}->{'create_homedir_perms'});
	}
else {
	$self->{'in_hash'}->{'create_homedir_perms'} =~ /^[0-7]{3,4}$/ ||
		$self->error($self->{'text_hash'}->{'session_ehomedir_perms'});
	$self->{'uconfig_hash'}->{'create_homedir_perms'} = $self->{'in_hash'}->{'create_homedir_perms'};
	}
$self->put_usermin_config(\%{$self->{'uconfig_hash'}});
$self->unlock_file($self->{'usermin_config'});

$self->restart_usermin_miniserv();
$self->webmin_log("session", undef, undef, \%{$self->{'in_hash'}});
$self->redirect("");

1;
		
}


1;

