#!/usr/bin/perl

&MAIN();

 sub MAIN {
# clone_mod.cgi
# Clone an existing usermin module under a new name

&ModuleLoader::preload_module('enduser_cf_class', "enduser_cf::Enduser_cfLib");
$self = new enduser_cf::Enduser_cfLib:: 'enduser_cf_class',%$self;

$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'clone_err'});
$self->{'access_hash'}->{'umods'} || $self->error($self->{'text_hash'}->{'acl_ecannot'});

# Symlink the code directory
$self->get_usermin_miniserv_config(\%{$self->{'miniserv_hash'}});
$self->{'src'} = $self->{'in_hash'}->{'mod'};
%{$self->{'minfo_hash'}} = $self->get_usermin_module_info($self->{'src'});
$self->{'count'} = 2;
do {
	$self->{'dst'} = $self->{'src'}.$self->{'count'};
	$self->{'count'}++;
	} while(-d "$self->{'miniserv_hash'}->{'root'}/$self->{'dst'}");
$self->symlink_logged($self->{'src'}, "$self->{'miniserv_hash'}->{'root'}/$self->{'dst'}") ||
	$self->error($self->text('clone_elink', $!));

# Copy the config directory
mkdir("$self->{'config_hash'}->{'usermin_dir'}/$self->{'dst'}", 0755);
$self->{'out'} = $self->backquote_logged("( (cd $self->{'config_hash'}->{'usermin_dir'}/$self->{'src'} ; tar cf - .) | (cd $self->{'config_hash'}->{'usermin_dir'}/$self->{'dst'} ; tar xpf -) ) 2>&1");
if ($?) {
	$self->error($self->text('clone_ecopy', $self->{'out'}));
	}
$self->{'in_hash'}->{'desc'} = $self->text('clone_desc', $self->{'minfo_hash'}->{'desc'}) if (!$self->{'in_hash'}->{'desc'});
$self->open_tempfile(CLONE, ">$self->{'config_hash'}->{'usermin_dir'}/$self->{'dst'}/clone");
$self->print_tempfile(CLONE, "desc=$self->{'in_hash'}->{'desc'}\n");
$self->close_tempfile(CLONE);

# Grant access to the clone to this user
$self->read_usermin_acl(undef, \%{$self->{'acl_hash'}});
@{$self->{'mods_array'}} = $self->unique(@{$self->{'acl_hash'}->{"user"}}, $self->{'dst'});
$self->save_usermin_acl("user", \@{$self->{'mods_array'}});

if ($self->{'in_hash'}->{'cat'} ne '*') {
	# Assign to category
	$self->lock_file("$self->{'config_hash'}->{'usermin_dir'}/cpplus.cats");
	$self->read_file("$self->{'config_hash'}->{'usermin_dir'}/cpplus.cats", \%{$self->{'cats_hash'}});
	$self->{'cats_hash'}->{$self->{'dst'}} = $self->{'in_hash'}->{'cat'};
	$self->write_file("$self->{'config_hash'}->{'usermin_dir'}/cpplus.cats", \%{$self->{'cats_hash'}});
	$self->unlock_file("$self->{'config_hash'}->{'usermin_dir'}/cpplus.cats");
	}

$self->webmin_log("clone", undef, $self->{'in_hash'}->{'mod'}, { 'desc' => $self->{'minfo_hash'}->{'desc'},
					  'dst' => $self->{'dst'},
					  'dstdesc' => $self->{'in_hash'}->{'desc'} });
$self->redirect("");

1;
		
}


1;

