#!/usr/bin/perl

&MAIN();

 sub MAIN {
# delete_mod.cgi
# Delete selected modules from usermin

&ModuleLoader::preload_module('enduser_cf_class', "enduser_cf::Enduser_cfLib");
$self = new enduser_cf::Enduser_cfLib:: 'enduser_cf_class',%$self;

$self->{'access_hash'}->{'umods'} || $self->error($self->{'text_hash'}->{'acl_ecannot'});
$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'delete_err'});
@{$self->{'mods_array'}} = split(/\0/, $self->{'in_hash'}->{'mod'});
@{$self->{'mods_array'}} || $self->error($self->{'text_hash'}->{'delete_enone'});

local %miniserv;
$self->get_usermin_miniserv_config(\%miniserv);

# check if any other module depends on those to be deleted
foreach $minfo ($self->list_modules()) {
	if ($self->check_usermin_os_support($minfo)) {
		foreach $d (split(/\s+/, $minfo->{'depends'})) {
			$self->{'depends_hash'}->{$d} = $minfo->{'desc'};
			}
		}
	}
foreach $m (@{$self->{'mods_array'}}) {
	%minfo = $self->get_usermin_module_info($m);
	%minfo = $self->get_usermin_theme_info($m) if (!%minfo);
	if (!-l "$miniserv{'root'}/$m" && $self->{'depends_hash'}->{$m}) {
		$self->error($self->text('delete_edep', "<tt>$minfo{'desc'}</tt>",
			     "<tt>$self->{'depends_hash'}->{$m}</tt>"));
		}
	}

# ask the user if he is sure
if (!$self->{'in_hash'}->{'confirm'}) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'delete_title'}, "");
	print "<p><form action=delete_mod.cgi>\n";
	foreach $m (@{$self->{'mods_array'}}) {
		local %minfo = $self->get_usermin_module_info($m);
		if (!%minfo) {
			$self->{'theme'}++;
			%minfo = $self->get_usermin_theme_info($m);
			}
		print "<input type=hidden name=mod value=$m>\n";
		$self->{'total'} += $self->disk_usage_kb("$miniserv{'root'}/$m")
			if (!-l "$miniserv{'root'}/$m");
		$self->{'descs'} .= " , " if ($self->{'descs'});
		$self->{'descs'} .= "<b>$minfo{'desc'}</b>";
		}
	print "<center>",$self->text($self->{'theme'} ? 'delete_rusure2' : 'delete_rusure',
			       int($self->{'total'}), $self->{'descs'}),"<p>",
	      "<input type=submit name=confirm value='$self->{'text_hash'}->{'delete'}'>",
	      "</form></center>\n";
	$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
	exit;
	}

# delete the selected modules or themes
foreach $m (split(/\0/, $self->{'in_hash'}->{'mod'})) {
	next if (!$m || !-d "$miniserv{'root'}/$m");
	local $mdesc = $self->delete_usermin_module($m);
	if ($mdesc) {
		push(@{$self->{'mdesc_array'}}, $mdesc);
		}
	}
$self->flush_modules_cache();

$self->ui_print_header(undef, $self->{'text_hash'}->{'delete_title'}, "");
print $self->{'text_hash'}->{'delete_msg'},"<p>\n";
print "<ul>\n";
for($i=0; $i<@{$self->{'mdesc_array'}}; $i++) {
	print $self->{'mdesc_array'}->[$i],"<p>\n";
	}
print "</ul><p>\n";
$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

