#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Display the advanced options form

&ModuleLoader::preload_module('enduser_cf_class', "enduser_cf::Enduser_cfLib");
$self = new enduser_cf::Enduser_cfLib:: 'enduser_cf_class',%$self;

$self->ui_print_header(undef, $self->{'text_hash'}->{'advanced_title'}, "");
$self->get_usermin_miniserv_config(\%{$self->{'miniserv_hash'}});
$self->get_usermin_config(\%{$self->{'uconfig_hash'}});

print $self->ui_form_start("change_advanced.cgi", "post");
print $self->ui_table_start($main::cpplus_object->{'text_hash'}->{'advanced_header'}, undef, 2);

# Global temp directory
print $self->ui_table_row($main::cpplus_object->{'text_hash'}->{'advanced_temp'},
		    $self->ui_opt_textbox("tempdir", $self->{'uconfig_hash'}->{'tempdir'},
				    30, $main::cpplus_object->{'text_hash'}->{'advanced_tempdef'}));

# Per-module temp directories
@{$self->{'mods_array'}} = sort { $a->{'desc'} cmp $b->{'desc'} } $self->list_modules();
$self->{'ttable'} = $self->ui_columns_start([ $main::cpplus_object->{'text_hash'}->{'advanced_tmod'},
			      $main::cpplus_object->{'text_hash'}->{'advanced_tdir'} ]);
$self->{'i'} = 0;
foreach $d ($main::cpplus_object->get_tempdirs(\%{$self->{'uconfig_hash'}}), [ ]) {
	$self->{'ttable'} .= $self->ui_columns_row([
		$self->ui_select("tmod_$self->{'i'}", $d->[0],
			[ [ "", "&nbsp;" ],
			  map { [ $_->{'dir'}, $_->{'desc'} ] } @{$self->{'mods_array'}} ]),
		$self->ui_textbox("tdir_$self->{'i'}", $d->[1], 30)
		]);
	$self->{'i'}++;
	}
$self->{'ttable'} .= $self->ui_columns_end();
print $self->ui_table_row($main::cpplus_object->{'text_hash'}->{'advanced_tempmods'}, $self->{'ttable'});

# Show call stack on error
print $self->ui_table_row($main::cpplus_object->{'text_hash'}->{'advanced_stack'},
		    $self->ui_yesno_radio("stack", int($self->{'uconfig_hash'}->{'error_stack'})));

# Pass passwords to CGI programs
print $self->ui_table_row($self->{'text_hash'}->{'advanced_pass'},
		    $self->ui_yesno_radio("pass", int($self->{'miniserv_hash'}->{'pass_password'})));

# Umask for created files
print $self->ui_table_row($main::cpplus_object->{'text_hash'}->{'advanced_umask'},
	    $self->ui_opt_textbox("umask", $self->{'uconfig_hash'}->{'umask'}, 5, $self->{'text_hash'}->{'default'}));

print $self->ui_table_end();
print $self->ui_form_end([ [ "save", $self->{'text_hash'}->{'save'} ] ]);

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

