#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_configs.cgi
# Display the configs for a usermin module

&ModuleLoader::preload_module('enduser_cf_class', "enduser_cf::Enduser_cfLib");
$self = new enduser_cf::Enduser_cfLib:: 'enduser_cf_class',%$self;

&ModuleLoader::preload_module('enduser_cf_class', "ConfigLib");
$self = new ConfigLib:: 'enduser_cf_class',%$self;

$self->{'access_hash'}->{'configs'} || $self->error($self->{'text_hash'}->{'acl_ecannot'});
$self->ReadParse();
$self->can_use_module($self->{'in_hash'}->{'mod'}) || $self->error($self->{'text_hash'}->{'configs_ecannot'});
$self->ui_print_header(undef, $self->{'text_hash'}->{'configs_title2'}, "");
$self->get_usermin_miniserv_config(\%{$self->{'miniserv_hash'}});

$self->read_file("$self->{'config_hash'}->{'usermin_dir'}/$self->{'in_hash'}->{'mod'}/config", \%{$self->{'mconfig_hash'}});
if (-r "$self->{'miniserv_hash'}->{'root'}/$self->{'in_hash'}->{'mod'}/config.info") {
	# Display config form for the module
	%{$self->{'minfo_hash'}} = $self->get_usermin_module_info($self->{'in_hash'}->{'mod'});
	print $self->ui_form_start("save_configs.cgi", "post");
	print $self->ui_hidden("mod", $self->{'in_hash'}->{'mod'}),"\n";
	print $self->ui_table_start($self->text('config_header', $self->{'minfo_hash'}->{'desc'}),
			      "width=100%", 2);

	# Use config.info to create config inputs
	$self->generate_config(\%{$self->{'mconfig_hash'}}, "$self->{'miniserv_hash'}->{'root'}/$self->{'in_hash'}->{'mod'}/config.info");
	print $self->ui_table_end();
	print $self->ui_form_end([ [ "save", $self->{'text_hash'}->{'save'} ] ]);
	}

if (-r "$self->{'miniserv_hash'}->{'root'}/$self->{'in_hash'}->{'mod'}/config.info" &&
    -r "$self->{'miniserv_hash'}->{'root'}/$self->{'in_hash'}->{'mod'}/uconfig.info") {
	print "<hr>\n";
	}

if (-r "$self->{'miniserv_hash'}->{'root'}/$self->{'in_hash'}->{'mod'}/uconfig.info") {
	# Display default user config form for the module
	%{$self->{'minfo_hash'}} = $self->get_usermin_module_info($self->{'in_hash'}->{'mod'});
	print $self->ui_form_start("save_uconfigs.cgi", "post");
	print $self->ui_hidden("mod", $self->{'in_hash'}->{'mod'}),"\n";
	print $self->ui_table_start($self->text('configs_uheader', $self->{'minfo_hash'}->{'desc'}),
			      "width=100%", 2);

	$self->read_file("$self->{'miniserv_hash'}->{'root'}/$self->{'in_hash'}->{'mod'}/defaultuconfig", \%{$self->{'uconfig_hash'}});
	$self->read_file("$self->{'config_hash'}->{'usermin_dir'}/$self->{'in_hash'}->{'mod'}/uconfig", \%{$self->{'uconfig_hash'}});

	# Can edit prefs?
	$self->read_file("$self->{'config_hash'}->{'usermin_dir'}/$self->{'in_hash'}->{'mod'}/canconfig", \%{$self->{'canconfig_hash'}});
	$self->{'noprefs'} = $self->{'mconfig_hash'}->{'noprefs'} == 1 ? 1 :
		   %{$self->{'canconfig_hash'}} ? 2 : 0;

	print $self->ui_table_row($self->{'text_hash'}->{'configs_prefs'},
		$self->ui_radio("noprefs", $self->{'noprefs'},
			[ [ 0, $self->{'text_hash'}->{'yes'} ], [ 1, $self->{'text_hash'}->{'no'} ],
			  [ 2, $self->{'text_hash'}->{'configs_sels'} ] ]));
	print $self->ui_table_hr();

	# Use uconfig.info to create config inputs
	$self->generate_config(\%{$self->{'uconfig_hash'}},
			 "$self->{'miniserv_hash'}->{'root'}/$self->{'in_hash'}->{'mod'}/uconfig.info",
			 undef, $self->{'noprefs'} == 2 ? \%{$self->{'canconfig_hash'}} : undef, "_can");
	print $self->ui_table_end();
	print $self->ui_form_end([ [ "save", $self->{'text_hash'}->{'save'} ] ]);
	}

$self->ui_print_footer("list_configs.cgi", $self->{'text_hash'}->{'configs_return'});

1;
		
}


1;

