#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Display DAV server options

&ModuleLoader::preload_module('enduser_cf_class', "enduser_cf::Enduser_cfLib");
$self = new enduser_cf::Enduser_cfLib:: 'enduser_cf_class',%$self;

$self->ui_print_header(undef, $self->{'text_hash'}->{'dav_title'}, "");
$self->get_usermin_miniserv_config(\%{$self->{'miniserv_hash'}});

print $self->{'text_hash'}->{'dav_desc'},"<p>\n";

# Check for need Perl modules
foreach $m ("Filesys::Virtual::Plain", "Filesys::Virtual", "Net::DAV::Server",
	    "HTTP::Request") {
	eval "use $m";
	if ($@) {
		# Missing!
		print $self->text('dav_emodule', "<tt>$m</tt>"),"\n";
		if ($self->foreign_available("cpan")) {
			print $self->text('dav_cpan', "../cpan/download.cgi?source=3&cpan=$m&mode=2&return=/$self->{'module_name'}/&returndesc=".$self->urlize($self->{'text_hash'}->{'index_return'})),"\n";
			}
		print "<p>\n";
		$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
		exit;
		}
	}

print $self->ui_form_start("save_dav.cgi", "post");
print $self->ui_table_start($self->{'text_hash'}->{'dav_header'}, undef, 2);

# Allowed paths
print $self->ui_table_row($self->{'text_hash'}->{'dav_path'},
	$self->ui_radio("path_def", $self->{'miniserv_hash'}->{'davpaths'} ? 0 : 1,
	  [ [ 1, $self->{'text_hash'}->{'dav_disabled'} ],
	    [ 0, $self->text('dav_enabled',
		   $self->ui_textbox("path", $self->{'miniserv_hash'}->{'davpaths'} || "/dav", 30)) ] ]
		));

# Root directory
$self->{'rmode'} = $self->{'miniserv_hash'}->{'dav_root'} eq '' ? 0 :
	 $self->{'miniserv_hash'}->{'dav_root'} eq '*' ? 1 : 2;
print $self->ui_table_row($self->{'text_hash'}->{'dav_root'},
	$self->ui_radio("root_def", $self->{'rmode'},
	  [ [ 0, $self->{'text_hash'}->{'dav_root0'} ],
	    [ 1, $self->{'text_hash'}->{'dav_root1'} ],
	    [ 2, $self->text('dav_root2',
		$self->ui_textbox("root", $self->{'rmode'} == 2 ? $self->{'miniserv_hash'}->{'dav_root'} : undef,
			     30)) ] ]));

# Allowed users
print $self->ui_table_row($self->{'text_hash'}->{'dav_users'},
	$self->ui_radio("users_def", $self->{'miniserv_hash'}->{'dav_users'} ? 0 : 1,
		  [ [ 1, $self->{'text_hash'}->{'dav_users1'} ],
		    [ 0,  $self->{'text_hash'}->{'dav_users0'} ] ])."<br>\n".
	$self->ui_textarea("users", join("\n", split(/\s+/, $self->{'miniserv_hash'}->{'dav_users'})),
		     5, 40));

print $self->ui_table_end();
print $self->ui_form_end([ [ "save", $self->{'text_hash'}->{'save'} ] ]);

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

