#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_ssl.cgi
# Configure whether Usermin uses SSL or not

&ModuleLoader::preload_module('enduser_cf_class', "enduser_cf::Enduser_cfLib");
$self = new enduser_cf::Enduser_cfLib:: 'enduser_cf_class',%$self;

$self->{'access_hash'}->{'ssl'} || $self->error($self->{'text_hash'}->{'acl_ecannot'});
$self->ui_print_header(undef, $self->{'text_hash'}->{'ssl_title'}, "");
$self->get_usermin_miniserv_config(\%{$self->{'miniserv_hash'}});

eval "use Net::SSLeay";
if ($@) {
	print $self->text('ssl_essl', "http://www.webmin.com/ssl.html"),"\n";
	}
else {
	print $self->{'text_hash'}->{'ssl_desc1'},"<p>\n";
	print $self->{'text_hash'}->{'ssl_desc2'},"<br>\n";

	print "<form action=change_ssl.cgi>\n";
	print "<table border>\n";
	print "<tr $self->{'tb'}> <td><b>$main::cpplus_object->{'text_hash'}->{'ssl_header'}</b></td> </tr>\n";
	print "<tr $self->{'cb'}> <td><table>\n";

	print "<tr> <td><b>$main::cpplus_object->{'text_hash'}->{'ssl_on'}</b></td>\n";
	printf "<td><input type=radio name=ssl value=1 %s> %s\n",
		$self->{'miniserv_hash'}->{'ssl'} ? "checked" : "", $self->{'text_hash'}->{'yes'};
	printf "<input type=radio name=ssl value=0 %s> %s</td> </tr>\n",
		$self->{'miniserv_hash'}->{'ssl'} ? "" : "checked", $self->{'text_hash'}->{'no'};

	print "<tr> <td><b>$main::cpplus_object->{'text_hash'}->{'ssl_key'}</b></td>\n";
	printf "<td><input name=key size=40 value='%s'> %s</td> </tr>\n",
		$self->{'miniserv_hash'}->{'keyfile'}, $self->file_chooser_button("key");

	print "<tr> <td valign=top><b>$main::cpplus_object->{'text_hash'}->{'ssl_cert'}</b></td>\n";
	printf "<td><input type=radio name=cert_def value=1 %s> %s<br>\n",
		$self->{'miniserv_hash'}->{'certfile'} ? "" : "checked",
		$main::cpplus_object->{'text_hash'}->{'ssl_cert_def'};
	printf "<input type=radio name=cert_def value=0 %s> %s\n",
		$self->{'miniserv_hash'}->{'certfile'} ? "checked" : "",
		$main::cpplus_object->{'text_hash'}->{'ssl_cert_oth'};
	printf "<input name=cert size=40 value='%s'> %s</td> </tr>\n",
		$self->{'miniserv_hash'}->{'certfile'}, $self->file_chooser_button("cert");

	print "<tr> <td><b>$main::cpplus_object->{'text_hash'}->{'ssl_redirect'}</b></td>\n";
	printf "<td><input type=radio name=ssl_redirect value=1 %s> %s\n",
		$self->{'miniserv_hash'}->{'ssl_redirect'} ? "checked" : "", $self->{'text_hash'}->{'yes'};
	printf "<input type=radio name=ssl_redirect value=0 %s> %s</td></tr>\n",
		$self->{'miniserv_hash'}->{'ssl_redirect'} ? "" : "checked", $self->{'text_hash'}->{'no'};

	print "<tr> <td><b>$main::cpplus_object->{'text_hash'}->{'ssl_version'}</b></td>\n";	
	print "<td>",$self->ui_opt_textbox("version", $self->{'miniserv_hash'}->{'ssl_version'}, 4,
				     $main::cpplus_object->{'text_hash'}->{'ssl_auto'}),"</td> </tr>\n";

	print "<tr> <td><b>$main::cpplus_object->{'text_hash'}->{'ssl_no2'}</b></td>\n";	
	print "<td>",$self->ui_radio("no_ssl2", int($self->{'miniserv_hash'}->{'no_ssl2'}),
		[ [ 0, $self->{'text_hash'}->{'yes'} ], [ 1, $self->{'text_hash'}->{'no'} ] ]),"</td> </tr>\n";

	print "<tr> <td valign=top><b>$main::cpplus_object->{'text_hash'}->{'ssl_extracas'}</b></td>\n";
	print "<td><textarea name=extracas rows=3 cols=40>";
	foreach $e (split(/\s+/, $self->{'miniserv_hash'}->{'extracas'})) {
		print "$e\n";
		}
	print "</textarea></td> </tr>\n";

	print "</table></td></tr></table>\n";
	print "<input type=submit value=\"$self->{'text_hash'}->{'save'}\"></form>\n";

	print "<hr>\n";

	# Table listing per-IP SSL certs
	print "$main::cpplus_object->{'text_hash'}->{'ssl_ipkeys'}<p>\n";
	@{$self->{'ipkeys_array'}} = $main::cpplus_object->get_ipkeys(\%{$self->{'miniserv_hash'}});
	if (@{$self->{'ipkeys_array'}}) {
		print $self->ui_columns_start([ $main::cpplus_object->{'text_hash'}->{'ssl_ips'},
					  $main::cpplus_object->{'text_hash'}->{'ssl_key'},
					  $main::cpplus_object->{'text_hash'}->{'ssl_cert'} ]);
		foreach $k (@{$self->{'ipkeys_array'}}) {
			print $self->ui_columns_row([
				"<a href='edit_ipkey.cgi?idx=$k->{'index'}'>".
				join(", ", @{$k->{'ips'}})."</a>",
				"<tt>$k->{'key'}</tt>",
				$k->{'cert'} ? "<tt>$k->{'cert'}</tt>" : "<br>"
				]);
			}
		print $self->ui_columns_end();
		}
	else {
		print "<b>$main::cpplus_object->{'text_hash'}->{'ssl_ipkeynone'}</b><p>\n";
		}
	print "<a href='edit_ipkey.cgi?new=1'>$main::cpplus_object->{'text_hash'}->{'ssl_addipkey'}</a><p>\n";

	# SSL key generation form
	print "<hr>\n";
	print "$self->{'text_hash'}->{'ssl_newkey'}\n";
	local $curkey = `cat $self->{'miniserv_hash'}->{'keyfile'} 2>/dev/null`;
	local $origkey = `cat $self->{'miniserv_hash'}->{'root'}/miniserv.pem 2>/dev/null`;
	if ($curkey eq $origkey) {
		# System is using the original (insecure) Usermin key!
		print "<b>$self->{'text_hash'}->{'ssl_hole'}</b>\n";
		}
	print "<p>\n";

	print "<form action=newkey.cgi>\n";
	print "<table border>\n";
	print "<tr $self->{'tb'}> <td><b>$main::cpplus_object->{'text_hash'}->{'ssl_header1'}</b></td> </tr>\n";
	print "<tr $self->{'cb'}> <td><table>\n";
	print "<tr> <td><b>$main::cpplus_object->{'text_hash'}->{'ssl_cn'}</b></td>\n";
	print "<td><input type=radio name=commonName_def value=1 checked> ",
	      "$main::cpplus_object->{'text_hash'}->{'ssl_all'}\n";
	print "<input type=radio name=commonName_def value=0>\n";
	$self->{'host'} = $ENV{'HTTP_HOST'};
	$self->{'host'} =~ s/:.*//;
	print "<input name=commonName size=30 value='$self->{'host'}'></td> </tr>\n";

	print "<tr> <td><b>$main::cpplus_object->{'text_hash'}->{'ca_email'}</b></td>\n";
	printf "<td><input name=emailAddress size=30 value='%s'></td> </tr>\n",
		"usermin\@".$self->get_system_hostname();

	print "<tr> <td><b>$main::cpplus_object->{'text_hash'}->{'ca_ou'}</b></td>\n";
	print "<td><input name=organizationalUnitName size=30></td> </tr>\n";

	$self->{'hostname'} = $self->get_system_hostname();
	print "<tr> <td><b>$main::cpplus_object->{'text_hash'}->{'ca_o'}</b></td>\n";
	print "<td><input name=organizationName size=30 ",
	      "value='Usermin Webserver on $self->{'hostname'}'></td> </tr>\n";

	print "<tr> <td><b>$main::cpplus_object->{'text_hash'}->{'ca_city'}</b></td>\n";
	print "<td><input name=cityName size=30></td> </tr>\n";

	print "<tr> <td><b>$main::cpplus_object->{'text_hash'}->{'ca_sp'}</b></td>\n";
	print "<td><input name=stateOrProvinceName size=15></td> </tr>\n";

	print "<tr> <td><b>$main::cpplus_object->{'text_hash'}->{'ca_c'}</b></td>\n";
	print "<td><input name=countryName size=2></td> </tr>\n";

	print "<tr> <td><b>$main::cpplus_object->{'text_hash'}->{'ssl_size'}</b></td>\n";
	print "<td><input type=radio name=size_def value=1 checked> ",
	      "$self->{'text_hash'}->{'default'} ($self->{'default_key_size'})\n";
	print "<input type=radio name=size_def value=0> ",
	      "$main::cpplus_object->{'text_hash'}->{'ssl_custom'}\n";
	print "<input name=size size=6> $main::cpplus_object->{'text_hash'}->{'ssl_bits'}</td> </tr>\n";

	print "<tr> <td><b>$main::cpplus_object->{'text_hash'}->{'ssl_days'}</b></td>\n";
	print "<td><input name=days size=8 value='1825'></td> </tr>\n";

	print "<tr> <td><b>$main::cpplus_object->{'text_hash'}->{'ssl_newfile'}</b></td>\n";
	printf "<td><input name=newfile size=40 value='%s'></td> </tr>\n",
		"$self->{'config_hash'}->{'usermin_dir'}/miniserv.pem";

	print "<tr> <td><b>$main::cpplus_object->{'text_hash'}->{'ssl_usenew'}</b></td> <td>\n";
	print "<input type=radio name=usenew value=1 checked> $self->{'text_hash'}->{'yes'}\n";
	print "<input type=radio name=usenew value=0> $self->{'text_hash'}->{'no'}</td> </tr>\n";

	print "</table></td></tr></table>\n";
	print "<input type=submit value='$main::cpplus_object->{'text_hash'}->{'ssl_create'}'></form>\n";
	}

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

