#!/usr/bin/perl

&MAIN();

 sub MAIN {
# install_mod.cgi
# Download and install a usermin module

&ModuleLoader::preload_module('enduser_cf_class', "enduser_cf::Enduser_cfLib");
$self = new enduser_cf::Enduser_cfLib:: 'enduser_cf_class',%$self;

$self->{'access_hash'}->{'umods'} || $self->error($self->{'text_hash'}->{'acl_ecannot'});
if ($ENV{REQUEST_METHOD} eq "POST") { $self->ReadParseMime(); }
else { $self->ReadParse(); $self->{'no_upload'} = 1; }

$| = 1;
$self->{'theme_no_table'} = 1 if ($self->{'in_hash'}->{'source'} == 2);
$self->ui_print_header(undef, $self->{'text_hash'}->{'install_title'}, "");

if ($self->{'in_hash'}->{'source'} == 0) {
	# from local file
	$self->error_setup($self->text('install_err1', $self->{'in_hash'}->{'file'}));
	$self->{'file'} = $self->{'in_hash'}->{'file'};
	if (!(-r $self->{'file'})) { &inst_error($self->{'text_hash'}->{'install_efile'}); }
	}
elsif ($self->{'in_hash'}->{'source'} == 1) {
	# from uploaded file
	$self->error_setup($self->{'text_hash'}->{'install_err2'});
	$self->{'file'} = $self->transname();
	$self->{'need_unlink'} = 1;
	if ($self->{'no_upload'}) {
                &inst_error($self->{'text_hash'}->{'install_ebrowser'});
                }
	$self->open_tempfile(MOD, ">$self->{'file'}", 0, 1);
	$self->print_tempfile(MOD, $self->{'in_hash'}->{'upload'});
	$self->close_tempfile(MOD);
	}
elsif ($self->{'in_hash'}->{'source'} == 2) {
	# from ftp or http url
	$self->error_setup($self->text('install_err3', $self->{'in_hash'}->{'url'}));
	$self->{'file'} = $self->transname();
	$self->{'need_unlink'} = 1;
	local $error;
	$self->{'progress_callback_url'} = $self->{'in_hash'}->{'url'};
	if ($self->{'in_hash'}->{'url'} =~ /^(http|https):\/\/([^\/]+)(\/.*)$/) {
		$self->{'ssl'} = $1 eq 'https';
		$self->{'host'} = $2; $self->{'page'} = $3; $self->{'port'} = $self->{'ssl'} ? 443 : 80;
		if ($self->{'host'} =~ /^(.*):(\d+)$/) { $self->{'host'} = $1; $self->{'port'} = $2; }
		$self->http_download($self->{'host'}, $self->{'port'}, $self->{'page'}, $self->{'file'}, \$error,
			       'progress_callback', $self->{'ssl'});
		}
	elsif ($self->{'in_hash'}->{'url'} =~ /^ftp:\/\/([^\/]+)(:21)?\/(.*)$/) {
		$self->{'host'} = $1; $self->{'ffile'} = $3;
		$self->ftp_download($self->{'host'}, $self->{'ffile'}, $self->{'file'}, \$error, 'progress_callback');
		}
	else { &inst_error($self->{'text_hash'}->{'install_eurl'}); }
	&inst_error($error) if ($error);
	}

# Install the module(s)
$self->{'rv'} = $self->install_usermin_module($self->{'file'}, $self->{'need_unlink'}, $self->{'in_hash'}->{'nodeps'});
if (ref($self->{'rv'})) {
        @{$self->{'mdescs_array'}} = @{$self->{'rv'}->[0]};
        @{$self->{'mdirs_array'}} = @{$self->{'rv'}->[1]};
        @{$self->{'msizes_array'}} = @{$self->{'rv'}->[2]};
        }
else {
        &inst_error($self->{'rv'});
        }

# Display something nice for the user
print "$self->{'text_hash'}->{'install_desc'} <p>\n";
print "<ul>\n";
for($i=0; $i<@{$self->{'mdescs_array'}}; $i++) {
	$self->{'mdirs_array'}->[$i] =~ /\/([^\/]+)$/;
	if (%{$self->{'minfo_hash'}} = $self->get_usermin_module_info($1)) {
		# Installed a module
		local $cat = $self->{'text_hash'}->{"category_".$self->{'minfo_hash'}->{'category'}};
		$cat = $self->{'text_hash'}->{"category_"} if (!$cat);
		print $self->text($self->{'minfo_hash'}->{'hidden'} ? 'install_line3' :
				'install_line2', "<b>$self->{'mdescs_array'}->[$i]</b>",
			    "<tt>$self->{'mdirs_array'}->[$i]</tt>", $self->{'msizes_array'}->[$i], $cat),
			    "<br>\n";
		}
	elsif (%{$self->{'tinfo_hash'}} = $self->get_usermin_theme_info($1)) {
		# Installed a theme
		print $self->text('themes_line', "<b>$self->{'mdescs_array'}->[$i]</b>",
			    "<tt>$self->{'mdirs_array'}->[$i]</tt>", $self->{'msizes_array'}->[$i]),
			    "<br>\n";
		}
	}
print "</ul><p>\n";
$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}

sub inst_error
{
	shift if ($self == $_[0]);

print "<b>$self->{'whatfailed'} : $_[0]</b> <p>\n";
$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
exit;
}


1;

