#!/usr/bin/perl

&MAIN();

 sub MAIN {
# install_theme.cgi
# Download and install a usermin theme

&ModuleLoader::preload_module('enduser_cf_class', "enduser_cf::Enduser_cfLib");
$self = new enduser_cf::Enduser_cfLib:: 'enduser_cf_class',%$self;

$self->{'access_hash'}->{'themes'} || $self->error($self->{'text_hash'}->{'acl_ecannot'});
if ($ENV{REQUEST_METHOD} eq "POST") { $self->ReadParseMime(); }
else { $self->ReadParse(); $self->{'no_upload'} = 1; }

$| = 1;
$self->{'theme_no_table'} = 1 if ($self->{'in_hash'}->{'source'} == 2);
$self->ui_print_header(undef, $self->{'text_hash'}->{'install_title'}, "");

if ($self->{'in_hash'}->{'source'} == 0) {
	# from local file
	$self->error_setup($self->text('themes_err1', $self->{'in_hash'}->{'file'}));
	$self->{'file'} = $self->{'in_hash'}->{'file'};
	if (!(-r $self->{'file'})) { &inst_error($self->{'text_hash'}->{'themes_efile'}); }
	}
elsif ($self->{'in_hash'}->{'source'} == 1) {
	# from uploaded file
	$self->error_setup($self->{'text_hash'}->{'themes_err2'});
	$self->{'file'} = $self->transname();
	$self->{'need_unlink'} = 1;
	if ($self->{'no_upload'}) {
                &inst_error($self->{'text_hash'}->{'themes_ebrowser'});
                }
	$self->open_tempfile(MOD, ">$self->{'file'}", 0, 1);
	$self->print_tempfile(MOD, $self->{'in_hash'}->{'upload'});
	$self->close_tempfile(MOD);
	}
elsif ($self->{'in_hash'}->{'source'} == 2) {
	# from ftp or http url
	$self->error_setup($self->text('themes_err3', $self->{'in_hash'}->{'url'}));
	$self->{'file'} = $self->transname();
	$self->{'need_unlink'} = 1;
	$self->{'progress_callback_url'} = $self->{'in_hash'}->{'url'};
	if ($self->{'in_hash'}->{'url'} =~ /^(http|https):\/\/([^\/]+)(\/.*)$/) {
		$self->{'ssl'} = $1 eq 'https';
		$self->{'host'} = $2; $self->{'page'} = $3; $self->{'port'} = $self->{'ssl'} ? 443 : 80;
		if ($self->{'host'} =~ /^(.*):(\d+)$/) { $self->{'host'} = $1; $self->{'port'} = $2; }
		$self->http_download($self->{'host'}, $self->{'port'}, $self->{'page'}, $self->{'file'}, \$self->{'error'},
			       'progress_callback', $self->{'ssl'});
		}
	elsif ($self->{'in_hash'}->{'url'} =~ /^ftp:\/\/([^\/]+)(:21)?\/(.*)$/) {
		$self->{'host'} = $1; $self->{'ffile'} = $3;
		$self->ftp_download($self->{'host'}, $self->{'ffile'}, $self->{'file'}, \$self->{'error'},
			      'progress_callback');
		}
	else { &inst_error($self->{'text_hash'}->{'themes_eurl'}); }
	&inst_error($self->{'error'}) if ($self->{'error'});
	}

# Install the theme(s)
$self->{'rv'} = $self->install_usermin_module($self->{'file'}, $self->{'need_unlink'}, 0);
if (ref($self->{'rv'})) {
        @{$self->{'mdescs_array'}} = @{$self->{'rv'}->[0]};
        @{$self->{'mdirs_array'}} = @{$self->{'rv'}->[1]};
        @{$self->{'msizes_array'}} = @{$self->{'rv'}->[2]};
        }
else {
        &inst_error($self->{'rv'});
        }

# Display something nice for the user
print "$self->{'text_hash'}->{'themes_done'} <p>\n";
print "<ul>\n";
for($i=0; $i<@{$self->{'mdescs_array'}}; $i++) {
	print $self->text('themes_line', "<b>$self->{'mdescs_array'}->[$i]</b>",
		    "<tt>$self->{'mdirs_array'}->[$i]</tt>", $self->{'msizes_array'}->[$i]),"<p>\n";
	}
print "</ul><p>\n";
$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}

sub inst_error
{
	shift if ($self == $_[0]);

print "<br><b>$self->{'whatfailed'} : $_[0]</b> <p>\n";
print "<hr>\n";
$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
exit;
}


1;

