#!/usr/bin/perl

&MAIN();

 sub MAIN {
# update.cgi
# Find and install usermin modules that need updating

&ModuleLoader::preload_module('enduser_cf_class', "enduser_cf::Enduser_cfLib");
$self = new enduser_cf::Enduser_cfLib:: 'enduser_cf_class',%$self;

$self->{'access_hash'}->{'upgrade'} || $self->error($self->{'text_hash'}->{'acl_ecannot'});
$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'update_err'});

# Validate inputs
if ($self->{'in_hash'}->{'source'} == 0) {
	$self->{'host'} = $self->{'update_host'};
	$self->{'port'} = $self->{'update_port'};
	$self->{'page'} = $self->{'update_page'};
	}
else {
	$self->{'in_hash'}->{'other'} =~ /^(http|https):\/\/([^:\/]+)(:(\d+))?(\/\S+)$/ ||
		$self->error($self->{'text_hash'}->{'update_eurl'});
	$self->{'ssl'} = $1 eq 'https';
	$self->{'host'} = $2;
	$self->{'port'} = $3 ? $4 : $self->{'ssl'} ? 443 : 80;
	$self->{'page'} = $5;
	}

# Retrieve the updates list (format is  module version url support description )
$self->{'temp'} = $self->transname();
$self->http_download($self->{'host'}, $self->{'port'}, $self->{'page'}, $self->{'temp'}, undef, undef, $self->{'ssl'});
open(UPDATES, $self->{'temp'});
while(<UPDATES>) {
	if (/^([^\t]+)\t+([^\t]+)\t+([^\t]+)\t+([^\t]+)\t+(.*)/) {
		push(@{$self->{'updates_array'}}, [ $1, $2, $3, $4, $5 ]);
		}
	}
close(UPDATES);
unlink($self->{'temp'});
@{$self->{'updates_array'}} || $self->error($self->{'text_hash'}->{'update_efile'});

# Display the results and maybe take action
$self->ui_print_unbuffered_header(undef, $self->{'text_hash'}->{'update_title'}, "");

print "<b>",$self->text('update_info'),"</b><p>\n";
foreach $u (@{$self->{'updates_array'}}) {
	next if ($u->[1] >= $self->get_usermin_base_version() + .01 ||
		 $u->[1] < $self->get_usermin_base_version());
	$self->{'count'}++;
	local %minfo = $self->get_usermin_module_info($u->[0]);
	local %tinfo = $self->get_usermin_theme_info($u->[0]);
	if (!%minfo && !%tinfo && !$self->{'in_hash'}->{'missing'}) {
		print $self->text('update_mmissing', "<b>$u->[0]</b>"),"<p>\n";
		next;
		}
	if (%minfo && $minfo{'version'} >= $u->[1]) {
		print $self->text('update_malready', "<b>$u->[0]</b>"),"<p>\n";
		next;
		}
	if (%tinfo && $tinfo{'version'} >= $u->[1]) {
		print $self->text('update_malready', "<b>$u->[0]</b>"),"<p>\n";
		next;
		}
	local $osinfo = { 'os_support' => $u->[3] };
	if (!$self->check_usermin_os_support($osinfo)) {
		print $self->text('update_mos', "<b>$u->[0]</b>"),"<p>\n";
		next;
		}
	if ($self->{'in_hash'}->{'show'}) {
		# Just tell the user what would be done
		print $self->text('update_mshow', "<b>$u->[0]</b>", "<b>$u->[1]</b>"),
		      "<br>\n";
		print "&nbsp;" x 10;
		print $self->{'text_hash'}->{'update_fixes'}," : ",$u->[4],"<p>\n";
		}
	else {
		# Actually do the update ..
		local (@mdescs, @mdirs, @msizes);
		print $self->text('update_mok', "<b>$u->[0]</b>", "<b>$u->[1]</b>"),
		      "<br>\n";
		print "&nbsp;" x 10;
		print $self->{'text_hash'}->{'update_fixes'}," : ",$u->[4],"<br>\n";
		$self->{'mssl'} = $self->{'ssl'};
		if ($u->[2] =~ /^(http|https):\/\/([^:\/]+)(:(\d+))?(\/\S+)$/) {
			$self->{'mssl'} = $1 eq 'https';
			$self->{'mhost'} = $2;
			$self->{'mport'} = $3 ? $4 : $self->{'mssl'} ? 443 : 80;
			$self->{'mpage'} = $5;
			}
		elsif ($u->[2] =~ /^\/\S+$/) {
			$self->{'mhost'} = $self->{'host'};
			$self->{'mport'} = $self->{'port'};
			$self->{'mpage'} = $u->[2];
			}
		else {
			$self->{'mhost'} = $self->{'host'};
			$self->{'mport'} = $self->{'port'};
			($self->{'mpage'} = $self->{'page'}) =~ s/[^\/]+$//;
			$self->{'mpage'} .= $u->[2];
			}
		$self->{'mtemp'} = $self->transname();
		$self->{'progress_callback_url'} = $u->[2];
		$self->{'progress_callback_prefix'} = "&nbsp;" x 10;
		$self->http_download($self->{'mhost'}, $self->{'mport'}, $self->{'mpage'}, $self->{'mtemp'}, undef,
			       'progress_callback', $self->{'mssl'});
		$self->{'irv'} = $self->install_usermin_module($self->{'mtemp'}, 1, 0);
		print "&nbsp;" x 10;
		if (!ref($self->{'irv'})) {
			print $self->text('update_failed', $self->{'irv'}),"<p>\n";
			}
		else {
			print $self->text('update_mdesc', "<b>$self->{'irv'}->[0]->[0]</b>",
				    "<b>$self->{'irv'}->[2]->[0]</b>"),"<p>\n";
			}
		}
	}
print $self->text('update_none'),"<br>\n" if (!$self->{'count'});

# Check if a new version of webmin itself is available
$self->{'file'} = $self->transname();
$self->http_download('www.webmin.com', 80, '/index6.html', $self->{'file'});
open(FILE, $self->{'file'});
while(<FILE>) {
	if (/usermin-([0-9\.]+)\.tar\.gz/) {
		$self->{'version'} = $1;
		last;
		}
	}
close(FILE);
unlink($self->{'file'});
if ($self->{'version'} > $self->get_usermin_version()) {
	print "<b>",$self->text('update_version', $self->{'version'}),"</b><p>\n";
	}

print "<p>\n";
$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

