#!/usr/bin/perl

&MAIN();

 sub MAIN {
# upgrade.cgi
# Upgrade usermin if possible

&ModuleLoader::preload_module('enduser_cf_class', "enduser_cf::Enduser_cfLib");
$self = new enduser_cf::Enduser_cfLib:: 'enduser_cf_class',%$self;

$self->{'access_hash'}->{'upgrade'} || $self->error($self->{'text_hash'}->{'acl_ecannot'});
$self->foreign_require("proc", "proc-lib.pl");
$self->ReadParseMime();
$self->get_usermin_miniserv_config(\%{$self->{'miniserv_hash'}});

$self->ui_print_unbuffered_header(undef, $self->{'in_hash'}->{'install'} ? $self->{'text_hash'}->{'upgrade_title2'} : $self->{'text_hash'}->{'upgrade_title'}, "");

if ($self->{'in_hash'}->{'source'} == 0) {
	# from local file
	$self->error_setup($self->text('upgrade_err1', $self->{'in_hash'}->{'file'}));
	$self->{'file'} = $self->{'in_hash'}->{'file'};
	if (!(-r $self->{'file'})) { &inst_error($self->{'text_hash'}->{'upgrade_efile'}); }
	}
elsif ($self->{'in_hash'}->{'source'} == 1) {
	# from uploaded file
	$self->error_setup($self->{'text_hash'}->{'upgrade_err2'});
	$self->{'file'} = $self->transname();
	$self->{'need_unlink'} = 1;
	if ($self->{'no_upload'}) {
                &inst_error($self->{'text_hash'}->{'upgrade_ebrowser'});
                }
	$self->open_tempfile(MOD, ">$self->{'file'}", 0, 1);
	$self->print_tempfile(MOD, $self->{'in_hash'}->{'upload'});
	$self->close_tempfile(MOD);
	}
elsif ($self->{'in_hash'}->{'source'} == 2) {
	# find latest version at www.webmin.com by looking at index page
	$self->error_setup($self->{'text_hash'}->{'upgrade_err3'});
	$self->{'file'} = $self->transname();
	$self->http_download('www.webmin.com', 80, '/index6.html', $self->{'file'}, \$self->{'error'});
	$self->{'error'} && &inst_error($self->{'error'});
	open(FILE, $self->{'file'});
	while(<FILE>) {
		if (/usermin-([0-9\.]+)\.tar\.gz/) {
			$self->{'version'} = $1;
			last;
			}
		}
	close(FILE);
	unlink($self->{'file'});
	if (!$self->{'in_hash'}->{'force'}) {
		if ($self->{'version'} == $self->get_usermin_version()) {
			&inst_error($self->text('upgrade_elatest', $self->{'version'}));
			}
		elsif ($self->{'version'} <= $self->get_usermin_version()) {
			&inst_error($self->text('upgrade_eversion', $self->{'version'}));
			}
		}
	if ($self->{'in_hash'}->{'mode'} eq 'rpm') {
		$self->{'progress_callback_url'} = $self->convert_osdn_url(
		    "http://$main::cpplus_object->{'osdn_host'}/webadmin/usermin-$self->{'version'}-1.noarch.rpm");
		}
	elsif ($self->{'in_hash'}->{'mode'} eq 'deb') {
		$self->{'progress_callback_url'} = $self->convert_osdn_url(
		    "http://$main::cpplus_object->{'osdn_host'}/webadmin/usermin_$self->{'version'}.deb");
		}
	else {
		$self->{'progress_callback_url'} = $self->convert_osdn_url(
		    "http://$main::cpplus_object->{'osdn_host'}/webadmin/usermin-$self->{'version'}.tar.gz");
		}
	($self->{'host'}, $self->{'port'}, $self->{'page'}, $self->{'ssl'}) = $self->parse_http_url($self->{'progress_callback_url'});
	$self->http_download($self->{'host'}, $self->{'port'}, $self->{'page'}, $self->{'file'}, \$self->{'error'},
		       'progress_callback', $self->{'ssl'});
	$self->{'error'} && &inst_error($self->{'error'});
	$self->{'need_unlink'} = 1;
	}
elsif ($self->{'in_hash'}->{'source'} == 5) {
	# Download from some URL
	$self->error_setup($self->text('upgrade_err5', $self->{'in_hash'}->{'url'}));
	$self->{'file'} = $self->transname();
	$self->{'progress_callback_url'} = $self->{'in_hash'}->{'url'};
	if ($self->{'in_hash'}->{'url'} =~ /^(http|https):\/\/([^\/]+)(\/.*)$/) {
		$self->{'ssl'} = $1 eq 'https';
		$self->{'host'} = $2; $self->{'page'} = $3; $self->{'port'} = $self->{'ssl'} ? 443 : 80;
		if ($self->{'host'} =~ /^(.*):(\d+)$/) { $self->{'host'} = $1; $self->{'port'} = $2; }
		$self->http_download($self->{'host'}, $self->{'port'}, $self->{'page'}, $self->{'file'}, \$self->{'error'},
			       'progress_callback', $self->{'ssl'});
		}
	elsif ($self->{'in_hash'}->{'url'} =~ /^ftp:\/\/([^\/]+)(:21)?\/(.*)$/) {
		$self->{'host'} = $1; $self->{'ffile'} = $3;
		$self->ftp_download($self->{'host'}, $self->{'ffile'}, $self->{'file'},
			      \$self->{'error'}, 'progress_callback');
		}
	else { &inst_error($self->{'text_hash'}->{'upgrade_eurl'}); }
	$self->{'need_unlink'} = 1;
	$self->{'error'} && &inst_error($self->{'error'});
	}
$self->{'qfile'} = quotemeta($self->{'file'});

# gunzip the file if needed
open(FILE, $self->{'file'});
read(FILE, $self->{'two'}, 2);
close(FILE);
if ($self->{'two'} eq "\037\213") {
	if (!$self->has_command("gunzip")) {
		&inst_error($self->{'text_hash'}->{'upgrade_egunzip'});
		}
	$self->{'newfile'} = $self->transname();
	$self->{'out'} = `gunzip -c $self->{'file'} 2>&1 >$self->{'newfile'}`;
	if ($?) {
		unlink($self->{'newfile'});
		&inst_error($self->text('upgrade_egzip', "<tt>$self->{'out'}</tt>"));
		}
	unlink($self->{'file'}) if ($self->{'need_unlink'});
	$self->{'need_unlink'} = 1;
	$self->{'file'} = $self->{'newfile'};
	}
$self->{'qfile'} = quotemeta($self->{'file'});

# Get list of updates
$self->{'updatestemp'} = $self->transname();
$self->http_download($self->{'update_host'}, $self->{'update_port'}, $self->{'update_page'}, $self->{'updatestemp'},
               \$self->{'updates_error'});

if ($self->{'in_hash'}->{'mode'} eq 'rpm') {
	# Check if it is an RPM package
	$self->{'out'} = `rpm -qp $self->{'qfile'}`;
	$self->{'out'} =~ /^usermin-(\d+\.\d+)/ ||
		&inst_error($self->{'text_hash'}->{'upgrade_erpm'});
	$self->{'version'} = $1;
	if ($self->{'version'} <= $self->get_usermin_version() && !$self->{'in_hash'}->{'force'}) {
		&inst_error($self->text('upgrade_eversion', $self->{'version'}));
		}

	# Install the RPM
	if ($self->{'in_hash'}->{'force'}) {
		$cmd = "rpm -U --force $self->{'qfile'}";
		}
	else {
		$cmd = "rpm -U --ignoreos --ignorearch --nodeps $self->{'qfile'}";
		}
	print "<p>",$self->text($self->{'in_hash'}->{'install'} ? 'upgrade_setup2' : 'upgrade_setup',
			  "<tt>$cmd</tt>"),"<br>\n";
	print "<pre>";
	$main::proc_object->safe_process_exec($cmd, 0, 0, STDOUT, undef, 1);
	print "</pre>";
	unlink($self->{'file'}) if ($self->{'need_unlink'});
	}
elsif ($self->{'in_hash'}->{'mode'} eq 'deb') {
	# Check if it is a Debian package
	$self->{'debname'} = "usermin";
	$self->{'out'} = `dpkg --info $self->{'qfile'}`;
	$self->{'out'} =~ /Package:\s+(\S+)/ && $1 eq $self->{'debname'} ||
		&inst_error($self->{'text_hash'}->{'upgrade_edeb'});
	$self->{'out'} =~ /Version:\s+(\S+)/ ||
		&inst_error($self->{'text_hash'}->{'upgrade_edeb'});
	$self->{'version'} = $1;
	if ($self->{'version'} <= $self->get_usermin_version() && !$self->{'in_hash'}->{'force'}) {
		&inst_error($self->text('upgrade_eversion', $self->{'version'}));
		}

	# Install the package
	$cmd = "dpkg --install $self->{'qfile'}";
	print "<p>",$self->text($self->{'in_hash'}->{'install'} ? 'upgrade_setup2' : 'upgrade_setup',
			  "<tt>$cmd</tt>"),"<br>\n";
	print "<pre>";
	$main::proc_object->safe_process_exec($cmd, 0, 0, STDOUT, undef, 1);
	print "</pre>";
	unlink($self->{'file'}) if ($self->{'need_unlink'});
	}
else {
	# Check if it is a usermin tarfile
	open(TAR, "tar tf $self->{'file'} 2>&1 |");
	while(<TAR>) {
		if (/^usermin-([0-9\.]+)\//) {
			$self->{'version'} = $1;
			}
		if (/^webmin-([0-9\.]+)\//) {
			$self->{'webmin_version'} = $1;
			}
		if (/^[^\/]+\/(\S+)$/) {
			$self->{'hasfile_hash'}->{$1}++;
			}
		}
	close(TAR);
	if ($self->{'webmin_version'}) {
		&inst_error($self->text('upgrade_ewebmin', $self->{'webmin_version'}));
		}
	if (!$self->{'version'}) {
		if ($self->{'hasfile_hash'}->{'module.info'}) {
			&inst_error($self->text('upgrade_emod', 'edit_mods.cgi'));
			}
		else {
			&inst_error($self->{'text_hash'}->{'upgrade_etar'});
			}
		}
	if (!$self->{'in_hash'}->{'force'}) {
		if ($self->{'version'} <= $self->get_usermin_version()) {
			&inst_error($self->text('upgrade_eversion', $self->{'version'}));
			}
		}

	$| = 1;
	local $cmd;
	if ($self->{'in_hash'}->{'install'}) {
		# Installing .. extract it in /usr/local and run setup.sh
		local $root = "/usr/local";
		mkdir($root, 0755);
		$self->{'out'} = `cd $root ; tar xf $self->{'file'} 2>&1 >/dev/null`;
		if ($?) {
			&inst_error($self->text('upgrade_euntar', "<tt>$self->{'out'}</tt>"));
			}
		unlink($self->{'file'}) if ($self->{'need_unlink'});
		$ENV{'config_dir'} = $self->{'standard_usermin_dir'};
		$ENV{'var_dir'} = "/var/usermin";
		$self->{'perl'} = $self->get_perl_path();
		$ENV{'perl'} = $self->{'perl'};
		$ENV{'autoos'} = 3;
		$ENV{'port'} = 20000;
		$ENV{'ssl'} = 1;
		$ENV{'os_type'} = $self->{'gconfig_hash'}->{'os_type'};
		$ENV{'os_version'} = $self->{'gconfig_hash'}->{'os_version'};
		$ENV{'real_os_type'} = $self->{'gconfig_hash'}->{'real_os_type'};
		$ENV{'real_os_version'} = $self->{'gconfig_hash'}->{'real_os_version'};
		$cmd = "(cd $root/usermin-$self->{'version'} && ./setup.sh)";
		print "<p>",$self->text('upgrade_setup2', "<tt>setup.sh</tt>"),"<br>\n";
		}
	else {
		# Upgrading .. work out where to extract
		if ($self->{'in_hash'}->{'dir'}) {
			# Since we are currently installed in a fixed directory,
			# just extract to a temporary location
			$self->{'extract'} = $self->transname();
			mkdir($self->{'extract'}, 0755);
			}
		else {
			# Next to the current directory
			$self->{'extract'} = "$self->{'miniserv_hash'}->{'root'}/..";
			}

		# Extract it next to the current directory and run setup.sh
		$self->{'out'} = `cd $self->{'extract'} ; tar xf $self->{'file'} 2>&1 >/dev/null`;
		if ($?) {
			&inst_error($self->text('upgrade_euntar', "<tt>$self->{'out'}</tt>"));
			}
		unlink($self->{'file'}) if ($self->{'need_unlink'});
		$ENV{'config_dir'} = $self->{'config_hash'}->{'usermin_dir'};
		$ENV{'webmin_upgrade'} = 1;
		$ENV{'autothird'} = 1;
		$self->{'setup'} = $self->{'in_hash'}->{'dir'} ? "./setup.sh '$self->{'in_hash'}->{'dir'}'" : "./setup.sh";
		if ($self->{'in_hash'}->{'delete'}) {
			$ENV{'deletedold'} = 1;
			$cmd = "(cd $self->{'extract'}/usermin-$self->{'version'} && $self->{'setup'} && rm -rf \"$self->{'miniserv_hash'}->{'root'}\")";
			}
		else {
			$cmd = "(cd $self->{'extract'}/usermin-$self->{'version'} && $self->{'setup'})";
			}
		print "<p>",$self->text('upgrade_setup', "<tt>setup.sh</tt>"),"<br>\n";
		}
	print "<pre>";
	$main::proc_object->safe_process_exec($cmd, 0, 0, STDOUT, undef, 1);
	print "</pre>";
	if ($self->{'in_hash'}->{'dir'}) {
		# Can delete the temporary source directory
		system("rm -rf \"$self->{'extract'}\"");
		}
	}
$self->webmin_log($self->{'in_hash'}->{'install'} ? "uinstall" : "upgrade", undef, undef,
	    { 'version' => $self->{'version'}, 'mode' => $self->{'in_hash'}->{'mode'} });

# Find out about any updates for this new version.
if ($self->{'updates_error'}) {
        print "<br>",$self->text('upgrade_eupdates', $self->{'updates_error'}),"<p>\n";
        }
else {
        open(UPDATES, $self->{'updatestemp'});
        while(<UPDATES>) {
                if (/^([^\t]+)\t+([^\t]+)\t+([^\t]+)\t+([^\t]+)\t+(.*)/) {
                        push(@{$self->{'updates_array'}}, [ $1, $2, $3, $4, $5 ]);
                        }
                }
        close(UPDATES);
        unlink($self->{'updatestemp'});
        $self->{'bversion'} = $self->base_version($self->{'version'});
        foreach $u (@{$self->{'updates_array'}}) {
                next if ($u->[1] >= $self->{'bversion'} + .01 || $u->[1] <= $self->{'bversion'} ||
			 $u->[1] <= $self->{'version'});
                local $osinfo = { 'os_support' => $u->[3] };
                next if (!$self->check_usermin_os_support($osinfo));
                $self->{'ucount'}++;
                }
        if ($self->{'ucount'}) {
                print "<br>",$self->text('upgrade_updates', $self->{'ucount'},
                        "update.cgi?source=0&show=0&missing=0"),"<p>\n";
                }
        }

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}

sub inst_error
{
	shift if ($self == $_[0]);

unlink($self->{'file'}) if ($self->{'need_unlink'});
print "<br><b>$self->{'whatfailed'} : $_[0]</b> <p>\n";
$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
exit;
}


1;

