#!/usr/bin/perl
package QmailLib;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'QmailLib');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
%{$self->{'qmail_config_hash'}} = ();
$self->read_file("$self->{'config_directory'}/../qmailadmin/config", \%{$self->{'qmail_config_hash'}});

$self->{'qmail_alias_dir'} = "$self->{'qmail_config_hash'}->{'qmail_dir'}/alias";
$self->{'qmail_bin_dir'} = "$self->{'qmail_config_hash'}->{'qmail_dir'}/bin";
$self->{'qmail_control_dir'} = "$self->{'qmail_config_hash'}->{'qmail_dir'}/control";
$self->{'qmail_routes_file'} = "$self->{'qmail_control_dir'}/smtproutes";
$self->{'qmail_virts_file'} = "$self->{'qmail_control_dir'}/virtualdomains";
$self->{'qmail_start_cmd'} = "$self->{'qmail_config_hash'}->{'qmail_dir'}/rc";
$self->{'qmail_mess_dir'} = "$self->{'qmail_config_hash'}->{'qmail_dir'}/queue/mess";
$self->{'qmail_info_dir'} = "$self->{'qmail_config_hash'}->{'qmail_dir'}/queue/info";
$self->{'qmail_local_dir'} = "$self->{'qmail_config_hash'}->{'qmail_dir'}/queue/local";
$self->{'qmail_remote_dir'} = "$self->{'qmail_config_hash'}->{'qmail_dir'}/queue/remote";
$self->{'qmail_assigns_file'} = "$self->{'qmail_config_hash'}->{'qmail_dir'}/users/assign";

$self->{'can_alias_types_hash'}->{2} = 0;
$self->{'can_alias_types_hash'}->{7} = 0;

1;
1;
		return $self;
}

# list_aliases()
# Returns a list of qmail alias file names
sub qmail_list_aliases
{
	my $self = shift;

local @rv;
opendir(DIR, $self->{'qmail_alias_dir'});
foreach $f (readdir(DIR)) {
	next if ($f !~ /^\.qmail-(\S+)$/);
	push(@rv, $1);
	}
closedir(DIR);
return @rv;
}

# get_alias(name)
sub qmail_get_alias
{
	my $self = shift;

local $alias = { 'name' => $_[0],
		 'file' => "$self->{'qmail_alias_dir'}/.qmail-$_[0]",
		 'values' => [ ] };
open(ALIAS, $alias->{'file'});
while(<ALIAS>) {
	s/\r|\n//g;
	s/#.*$//g;
	if (/\S/) {
		push(@{$alias->{'values'}}, $_);
		}
	}
close(ALIAS);
return $alias;
}

# list_control_file()
# Returns the contents of a multi-line control file
sub qmail_list_control_file
{
	my $self = shift;

local @lines;
open(FILE, "$self->{'qmail_control_dir'}/$_[0]") || return undef;
while(<FILE>) {
	s/\r|\n//g;
	s/#.*$//g;
	push(@lines, $_) if (/\S/);
	}
close(FILE);
return \@lines;
}

# list_virts()
# Returns a list of all virtualdomains file entries
sub qmail_list_virts
{
	my $self = shift;

local $lnum = 0;
local @rv;
open(VIRTS, $self->{'qmail_virts_file'});
while(<VIRTS>) {
	s/\r|\n//g;
	s/#.*$//;
	if (/^(\S+)\@(\S+):(\S*)/) {
		push(@rv, { 'user' => $1,
			    'domain' => $2,
			    'from' => "$1\@$2",
			    'prepend' => $3,
			    'line' => $lnum,
			    'idx' => scalar(@rv) } );
		}
	elsif (/^(\S*):(\S*)/) {
		push(@rv, { 'domain' => $1,
			    'from' => $1,
			    'prepend' => $2,
			    'line' => $lnum,
			    'idx' => scalar(@rv) } );
		}
	$lnum++;
	}
close(VIRTS);
return @rv;
}


1;

