#!/usr/bin/perl
package ThemefuncsLib;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'ThemefuncsLib');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
%{$self->{'modules_conf_hash'}} = (
'chpass' => [],
'chfn' => [],
'commands' => [],
'cron' => ['D:cron_dir', 'K:crontab'],
'cshrc' => [],
'fetchmail' => ['R:fetchmail_path'],
'file' => [],
'filter' => [],
'forward' => [],
'gnupg' => ['K:gpg'],
'home' => [],
'htaccess' => [],
'htaccess_htpasswd' => [],
'language' => [],
'mailbox' => [],
'man' => [],
'mysql' => ['X:mysqladmin', 'X:mysql'],
'plan' => [],
'postgresql' => ['X:psql', 'C:hba_conf'],
'proc' => [],
'procmail' => [],
'quota' => ['K:quota'],
'schedule' => [],
'shell' => [],
'spam' => ['R:spamassassin'],
'ssh' => [],
'telnet' => [],
'updown' => [],
'usermount' => ['C:fstab_file'],
);

# # &accessable($module_name);
# sub accessable {
# 	 (%hash1, %hash2);
# 	&read_acl(\%hash1, \%hash2);
# 	return $hash1{$remote_user, $_[0]};
# }

# --- appliances/servers specific functions ---

$self->{'done_theme_lib_funcs'} = 1;

1;
1;
		return $self;
}

# configured($module_dir_name);
sub configured {
	my $self = shift;

	return 1 unless $_[0];
	my ($mod_name, $rv) = ($_[0], 1);
	foreach my $cmd (@{$self->{'modules_conf_hash'}->{$mod_name}}) {
		my ($type, $check) = split (/:/, $cmd);
		my %config = ();
		$self->read_file("$self->{'config_directory'}/$mod_name/config", \%config);

		if    ($type =~ /^X/) { $rv = ( -x $config{$check} ); }
		elsif ($type =~ /^C/) { $rv = ( -r $config{$check} ); }
		elsif ($type =~ /^D/) { $rv = ( -d $config{$check} ); }
		elsif ($type =~ /^S/) { $rv = ( -s $config{$check} ); }
		elsif ($type =~ /^K/) { $rv = $self->has_command($check); }
		elsif ($type =~ /^R/) { $rv = $self->has_command($config{$check}); }

		return 0 unless $rv;
		#else { return 1; }
	}
	return $rv;
}

sub get_mode_user {
	my $self = shift;

	local $key = 'mode_'.$self->{'remote_user'};
	return ($self->{'gconfig_hash'}->{$key} ? $self->{'gconfig_hash'}->{$key} : 0);
}

# &check_plugin($plugin);
# return global config key
sub check_plugin
{
	my $self = shift;

 return $self->{'gconfig_hash'}->{$_[0]};
}

# return hash with appliances' complain
# &ztl_get_appliances(\%appliances);
sub ztl_get_appliances {
	my $self = shift;

	local $apps = $_[0];
}

# &ztl_check_condition(\%appliances, $condition);
sub ztl_check_condition {
	my $self = shift;

	local $apps = $_[0];
	local $condition = $_[1];
	my $a;
	foreach $a (@{$self->{'ztl_appliances_array'}}) {
		my $v = $apps->{$a}->{'on'} ? 1 : 0;
		$condition =~ s/\$$a/$v/g;
	}
	while ($condition =~ /\$M(\S+)/) {
		# module configured ?
		my $var = $1;
		my $v = $self->configured($var); #&accessable($var);
		$condition =~ s/\$M$var/$v/g;
	}
	while ($condition =~ /\$P(\S+)/) {
	   # plugin configured ?
		my $var = $1;
		my $v = $self->check_plugin($var);
		$condition =~ s/\$P$var/$v/g;
	}
	local $rv = eval("$condition");
	return $rv;
}

# &ztl_get_text(\%appliances, text1, [...])
# e.g., &ztl_get_text(\%appliances, "website_backup:$web && $dns", "domain_backup:$dns");
sub ztl_get_text {
	my $self = shift;

	local $apps = shift(@_);
	foreach my $p (@_) {
		next if $p =~ /^#/;
		if ($p =~ /^([^:]+):(.*)$/) {
			my ($label, $cond) = ($1, $2);
			if ($self->ztl_check_condition($apps, $cond)) {
				return $self->{'text_hash'}->{$label};
			}
		}
	}
	return undef;
}

# $self->ztl_get_text(\%appliances, $text)
sub ztl_get_jointext {
	my $self = shift;

	local $apps = shift(@_);
	local @texts = split(';', shift(@_));
	return $self->ztl_get_text($apps, @texts);
}

sub ztl_get_uptime {
	my $self = shift;

	local $uptime_cmd = '/usr/bin/uptime';
	return '' unless -e $uptime_cmd;
	local $result;
	local $rv = `$uptime_cmd`;
	$rv =~ m/up\s+(.*?),[^,]*?user/i;
	( $result = $1 ) =~ tr/,//d;
	return $result;
}

# &get_access_level ($username)
# returns access level number or array (access_level, ref domain)
sub ztl_get_access_level {
	my $self = shift;

	local $user = $_[0];
	local (%hash1, %hash2);
	$self->read_acl(\%hash1, \%hash2);
	if ($hash1{$user, 'useradmin'} && $hash1{$user, 'acl'} && $hash1{$user, 'virtual_server'}) {
		return (wantarray ? (0, undef) : 0);
	}
	elsif ($hash1{$user, 'virtual_server'}) {
		return 1 unless (wantarray);
		$self->foreign_require("virtual_server", "virtual-server-lib.pl");
		return (1, $self->foreign_call("virtual_server", "get_domain_by", "user", "$user"));
	}
}


1;

