#!/usr/bin/perl
package at::AtLib;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'at::AtLib');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# at-lib.pl
# Functions for listing and creating at jobs

&ModuleLoader::preload_module(ref($self), "WebLib");
$self = new WebLib:: ref($self), %$self; 
$self->init_config();
&ModuleLoader::preload_module(ref($self), "UiLib");
$self = new UiLib:: ref($self), %$self; 

{
    my $pkg = $self->lib_to_pkg("$self->{config_hash}->{at_style}-lib.pl", "at");
    &ModuleLoader::preload_module(ref($self), "$pkg");
    $pkg .= '::';
    eval "\$self = new $pkg ref(\$self),\%\$self;"; 
}

1;

1;
		return $self;
}

# wrap_lines(text, width)
# Given a multi-line string, return an array of lines wrapped to
# the given width
sub wrap_lines
{
	my $self = shift;

local @rv;
local $w = $_[1];
foreach $rest (split(/\n/, $_[0])) {
	if ($rest =~ /\S/) {
		while(length($rest) > $w) {
			push(@rv, substr($rest, 0, $w));
			$rest = substr($rest, $w);
			}
		push(@rv, $rest);
		}
	else {
		# Empty line .. keep as it is
		push(@rv, $rest);
		}
	}
return @rv;
}

# can_edit_user(&access, user)
sub can_edit_user
{
	my $self = shift;

local %umap;
map { $umap{$_}++; } split(/\s+/, $_[0]->{'users'});
if ($_[0]->{'mode'} == 1 && !$umap{$_[1]} ||
    $_[0]->{'mode'} == 2 && $umap{$_[1]}) { return 0; }
elsif ($_[0]->{'mode'} == 3) {
	return $self->{'remote_user'} eq $_[1];
	}
else {
	return 1;
	}
}

# list_allowed()
# Returns a list of all users in the cron allow file
sub list_allowed
{
	my $self = shift;

local(@rv, $_);
$self->open_readfile(*ALLOW, $self->{'config_hash'}->{allow_file});
while(<ALLOW>) {
	next if (/^\s*#/);
	chop; push(@rv, $_) if (/\S/);
	}
close(ALLOW);
return @rv;
}

# list_denied()
# Return a list of users from the cron deny file
sub list_denied
{
	my $self = shift;

local(@rv, $_);
$self->open_readfile(*DENY, $self->{'config_hash'}->{deny_file});
while(<DENY>) {
	next if (/^\s*#/);
	chop; push(@rv, $_) if (/\S/);
	}
close(DENY);
return @rv;
}

# save_allowed(user, user, ...)
# Save the list of allowed users
sub save_allowed
{
	my $self = shift;

$self->lock_file($self->{'config_hash'}->{allow_file});
if (@_) {
	local($_);
	$self->open_tempfile(ALLOW, ">$self->{'config_hash'}->{allow_file}");
	foreach (@_) {
		$self->print_tempfile(ALLOW, $_,"\n");
		}
	$self->close_tempfile(ALLOW);
	chmod(0444, $self->{'config_hash'}->{allow_file});
	}
else {
	$self->unlink_file($self->{'config_hash'}->{allow_file});
	}
$self->unlock_file($self->{'config_hash'}->{allow_file});
}

# save_denied(user, user, ...)
# Save the list of denied users
sub save_denied
{
	my $self = shift;

$self->lock_file($self->{'config_hash'}->{deny_file});
if (@_) {
	local($_);
	$self->open_tempfile(DENY, "> $self->{'config_hash'}->{deny_file}");
	foreach (@_) {
		$self->print_tempfile(DENY, $_,"\n");
		}
	$self->close_tempfile(DENY);
	chmod(0444, $self->{'config_hash'}->{deny_file});
	}
else {
	$self->unlink_file($self->{'config_hash'}->{deny_file});
	}
$self->unlock_file($self->{'config_hash'}->{deny_file});
}

# can_use_at(user)
# Returns 1 if some user is allowed to use At jobs, based on the allow
# any deny files.
sub can_use_at
{
	my $self = shift;

local ($user) = @_;
if (!$self->{'config_hash'}->{'allow_file'}) {
	return 1;	# not supported by OS
	}
elsif (@{$self->{'allow_array'}} = $self->list_allowed()) {
	return $self->indexof($user, @{$self->{'allow_array'}}) >= 0;	# check allowed list
	}
elsif (@{$self->{'deny_array'}} = $self->list_denied()) {
	return $self->indexof($user, @{$self->{'denied_array'}}) < 0;	# check denied list
	}
else {
	return 1;	# if neither exists, fall back to allowing all
	}
}


1;

