#!/usr/bin/perl

&MAIN();

 sub MAIN {
# index.cgi
# List all at jobs and display a form for creating a new one
#
# F&AS : default parameters can be set 
#   ext_user : default user
#   ext_cmd  : default command

&ModuleLoader::preload_module('at_class', "at::AtLib");
$self = new at::AtLib:: 'at_class',%$self;

use POSIX;
$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", undef, 1, 1);
%{$self->{'access_hash'}} = $self->get_module_acl();
$self->ReadParse();

# Show list of existing jobs
@{$self->{'jobs_array'}} = $self->list_atjobs();
@{$self->{'jobs_array'}} = grep { $self->can_edit_user(\%{$self->{'access_hash'}}, $_->{'user'}) } @{$self->{'jobs_array'}};
if (@{$self->{'jobs_array'}}) {
	print $self->ui_form_start("delete_jobs.cgi", "post");
	@{$self->{'jobs_array'}} = sort { $a->{'id'} <=> $b->{'id'} } @{$self->{'jobs_array'}};
	@{$self->{'tds_array'}} = ( "width=5" );
	@{$self->{'links_array'}} = ( $self->select_all_link("d"), $self->select_invert_link("d") );
	print $self->ui_links_row(\@{$self->{'links_array'}});
	print $self->ui_columns_start([
		"",
		$self->{'text_hash'}->{'index_id'},
		$self->{'text_hash'}->{'index_user'},
		$self->{'text_hash'}->{'index_exec'},
		$self->{'text_hash'}->{'index_created'},
		$self->{'text_hash'}->{'index_cmd'} ], 100, 0, \@{$self->{'tds_array'}});
	foreach $j (@{$self->{'jobs_array'}}) {
		local @cols;
		push(@cols, "<a href='edit_job.cgi?id=$j->{'id'}'>".
			    "$j->{'id'}</a>");
		push(@cols, $self->html_escape($j->{'user'}));
		$self->{'date'} = localtime($j->{'date'});
		push(@cols, "<tt>$self->{'date'}</tt>");
		$self->{'created'} = localtime($j->{'created'});
		push(@cols, "<tt>$self->{'created'}</tt>");
		push(@cols, join("<br>", split(/\n/,
				$self->html_escape($j->{'realcmd'}))));
		print $self->ui_checked_columns_row(\@cols, \@{$self->{'tds_array'}}, "d", $j->{'id'});
		}
	print $self->ui_columns_end();
	print $self->ui_links_row(\@{$self->{'links_array'}});
	print $self->ui_form_end([ [ "delete", $self->{'text_hash'}->{'index_delete'} ] ]);
	print "<hr>\n";
	}

# Show form for creating a new At job
print "<form action=create_job.cgi>\n";
print "<table border>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'index_header'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'index_user'}</b></td>\n";
$self->{'dir'} = "/";
if ($self->{'access_hash'}->{'mode'} == 1) {
	print "<td><select name=user>\n";
	foreach $u (split(/\s+/, $self->{'access_hash'}->{'users'})) {
		print "<option>$u\n";
		}
	print "</select></td>\n";
	}
elsif ($self->{'access_hash'}->{'mode'} == 3) {
	print "<td><tt>$self->{'remote_user'}</tt></td>\n";
	print "<input type=hidden name=user value='$self->{'remote_user'}'>\n";
	@{$self->{'uinfo_array'}} = getpwnam($self->{'remote_user'});
	$self->{'dir'} = $self->{'uinfo_array'}->[7];
	}
else {
	print "<td><input name=user value=\"$self->{'in_hash'}->{ext_user}\" size=8>",
		$self->user_chooser_button("user", 0),"</td>\n";
	}

@{$self->{'now_array'}} = localtime(time());
print "<tr> <td><b>$self->{'text_hash'}->{'index_date'}</b></td>\n";
printf "<td><input name=day size=2 value='%d'>/", $self->{'now_array'}->[3];
print "<select name=month>\n";
for($i=0; $i<12; $i++) {
	printf "<option value=%s %s>%s\n",
		$i, $self->{'now_array'}->[4] == $i ? 'selected' : '', $self->{'text_hash'}->{"smonth_".($i+1)};
	}
print "</select>/";
printf "<input name=year size=4 value='%d'>\n", $self->{'now_array'}->[5] + 1900;
print $self->date_chooser_button("day", "month", "year"),"</td>\n";

print "<td><b>$self->{'text_hash'}->{'index_time'}</b></td>\n";
print "<td><input name=hour size=2>:<input name=min size=2 value='00'></td> </tr>\n";

($self->{'date'}, $self->{'time'}) = split(/\s+/, $self->make_date(time()));

print "<tr> <td><b>$self->{'text_hash'}->{'index_cdate'}</b></td>\n";
print "<td>$self->{'date'}</td>\n";

print "<td><b>$self->{'text_hash'}->{'index_ctime'}</b></td>\n";
print "<td>$self->{'time'}</td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'index_dir'}</b></td>\n";
print "<td colspan=3><input name=dir size=40 value='$self->{'dir'}'></td> </tr>\n";

print "<tr> <td valign=top><b>$self->{'text_hash'}->{'index_cmd'}</b></td>\n";
print "<td colspan=3><textarea rows=5 cols=40 name=cmd>$self->{'in_hash'}->{ext_cmd}</textarea></td></tr>\n";

print "<tr> <td colspan=4 align=right>",
      "<input type=submit value='$self->{'text_hash'}->{'create'}'></td> </tr>\n";

print "</table></td></tr></table></form>\n";

if ($self->{'access_hash'}->{'allow'} && $self->{'config_hash'}->{'allow_file'}) {
	# Show form to manage allowed and denied users
	@{$self->{'allow_array'}} = $self->list_allowed();
	@{$self->{'deny_array'}} = $self->list_denied();
	print "<hr>\n";
	print $self->ui_form_start("save_allow.cgi", "post");
	print $self->ui_table_start($self->{'text_hash'}->{'index_allow'}, undef, 2);
	print $self->ui_table_row($self->{'text_hash'}->{'index_amode'},
		    $self->ui_radio("amode", 
			@{$self->{'allow_array'}} ? 1 : @{$self->{'deny_array'}} ? 2 : 0,
			[ [ 0, $self->{'text_hash'}->{'index_amode0'} ],
			  [ 1, $self->{'text_hash'}->{'index_amode1'} ],
			  [ 2, $self->{'text_hash'}->{'index_amode2'} ] ]));
	print $self->ui_table_row("",
		    $self->ui_textarea("ausers", @{$self->{'allow_array'}} ? join("\n", @{$self->{'allow_array'}}) :
					  @{$self->{'deny_array'}} ? join("\n", @{$self->{'deny_array'}}) : undef,
				5, 50));
	print $self->ui_table_end();
	print $self->ui_form_end([ [ "save", $self->{'text_hash'}->{'save'} ] ]);
	}

$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});

1;
		
}


1;

