#!/usr/bin/perl
package changepass::ChangepassLib;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'changepass::ChangepassLib');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# changepass-lib.pl

&ModuleLoader::preload_module(ref($self), "WebLib");
$self = new WebLib:: ref($self), %$self; 
$self->init_config();
&ModuleLoader::preload_module(ref($self), "UiLib");
$self = new UiLib:: ref($self), %$self; 
&ModuleLoader::preload_module(ref($self), "changepass::Md5Lib");
$self = new changepass::Md5Lib:: ref($self), %$self; 

1;

1;
		return $self;
}

# check_password(password, username)
sub check_password
{
	my $self = shift;

return $self->text('change_epasswd_min', $self->{'config_hash'}->{'passwd_min'})
	if (length($_[0]) < $self->{'config_hash'}->{'passwd_min'});
local $re = $self->{'config_hash'}->{'passwd_re'};
return $self->text('change_epasswd_re', $re)
	if ($re && !eval { $_[0] =~ /$re/ });
if ($self->{'config_hash'}->{'passwd_same'}) {
	return $self->text('change_epasswd_same')
		if ($_[0] =~ /\Q$_[1]\E/i);
	}
if ($self->{'config_hash'}->{'passwd_new'}) {
	return $self->text('change_epasswd_new')
		if (lc($_[0]) eq lc($self->{'in_hash'}->{'old'}));
	}
if ($self->{'config_hash'}->{'passwd_dict'} && $_[0] =~ /^[A-Za-z\'\-]+$/ &&
    ($self->has_command("ispell") || $self->has_command("spell"))) {
	local $temp = $self->transname();
	open(TEMP, ">$temp");
	print TEMP $_[0],"\n";
	close(TEMP);
	if ($self->has_command("ispell")) {
		open(SPELL, "ispell -a <$temp |");
		while(<SPELL>) {
			if (/^(#|\&|\?)/) {
				$self->{'unknown'}++;
				}
			}
		close(SPELL);
		}
	else {
		open(SPELL, "spell <$temp |");
		local $line = <SPELL>;
		$self->{'unknown'}++ if ($line);
		close(SPELL);
		}
	unlink($temp);
	return $self->text('change_epasswd_dict') if (!$self->{'unknown'});
	}
if ($self->{'config_hash'}->{'passwd_prog'}) {
        # Run external program with username and password as args
        local $qu = quotemeta($_[1]);
        local $qp = quotemeta($_[0]);
        local $out = `$self->{'config_hash'}->{'passwd_prog'} $qu $qp 2>&1 </dev/null`;
        if ($?) {
                return $out;
                }
        }
return undef;
}

# get_samba_version(&out)
sub get_samba_version
{
	my $self = shift;

local $flag;
foreach $flag ("-V", "-v") {
	$self->execute_command("$self->{'config_hash'}->{'samba_server'} $flag", undef, $_[0], $_[0]);
	if (${$_[0]} =~ /(Version|Samba)\s+(CVS\s+)?[^0-9 ]*(\d+)\.(\S+)/i) {
		local $v1 = $3;
		local $v2 = $4;
		$v2 =~ s/[^0-9]//g;
		return "$v1.$v2";
		}
	}
return undef;
}

# list_users()
# Returns an array of all the users from the samba password file
sub list_users
{
	my $self = shift;

# Get the samba version
if (open(VERSION, "$self->{'module_config_directory'}/version")) {
	chop($self->{'samba_version'} = <VERSION>);
	close(VERSION);
	}
else
{
 my $out;
 $self->{'samba_version'}=$self->get_samba_version(\$out);
}

local(@rv, @b, $_, $lnum);
local $has_pdbedit = ( $self->{'samba_version'} >= 3 && $self->has_command($self->{'config_hash'}->{'pdbedit'}) );
if ($has_pdbedit) {
	# Get list of users from the pdbedit command, which uses a configurable
	# back-end for storage
	$self->open_execute_command(*PASS, "cd / && $self->{'config_hash'}->{'pdbedit'} -L -w -s $self->{'config_hash'}->{'smb_conf'}", 1);
	}
else {
	# Read the password file directly
	$self->open_readfile(*PASS, $self->{'config_hash'}->{'smb_passwd'});
	}
while(<PASS>) {
	$lnum++;
	chop;
	s/#.*$//g;
	local @b = split(/:/, $_);
	next if (@b < 4);
	local $u = { 'name' => $b[0],  'uid' => $b[1],
		     'pass1' => $b[2], 'pass2' => $b[3] };
	if ($self->{'samba_version'} >= 2 && $b[4] =~ /^\[/) {
		$b[4] =~ s/[\[\] ]//g;
		$u->{'opts'} = [ split(//, $b[4]) ];
		$u->{'change'} = $b[5];
		}
	else {
		$u->{'real'} = $b[4];
		$u->{'home'} = $b[5];
		$u->{'shell'} = $b[6];
		}
	$u->{'index'} = scalar(@rv);
	$u->{'line'} = $lnum-1;
	push(@rv, $u);
	}
close(PASS);
return @rv;
}

# Gets Samba client
# get_samba_user(username);
sub get_samba_user
{
	my $self = shift;

#&require_samba();
local @ulist = $self->list_users();
local $u;
foreach $u (@ulist) {
	return $u if ($u->{'name'} eq $_[0]);
	}
return undef;
}


1;

