#!/usr/bin/perl

&MAIN();

 sub MAIN {
# changepass.cgi
# Change the user's password now, using PAM and the passwd service

&ModuleLoader::preload_module('changepass_class', "changepass::ChangepassLib");
$self = new changepass::ChangepassLib:: 'changepass_class',%$self;

$self->error_setup($self->{'text_hash'}->{'change_err'});
$self->ReadParse();

# Validate inputs
$self->{'in_hash'}->{'new1'} ne '' || $self->error($self->{'text_hash'}->{'change_enew1'});
$self->{'in_hash'}->{'new1'} eq $self->{'in_hash'}->{'new2'} || $self->error($self->{'text_hash'}->{'change_enew2'});

# Make sure minimum length and other restrictions are met
$self->{'err'} = $self->check_password($self->{'in_hash'}->{'new1'}, $self->{'remote_user'});
$self->error($self->{'err'}) if ($self->{'err'});

eval "use Authen::PAM";
$self->{'has_pam'}++ if (!$@);
$@ = undef;

if ($self->{'config_hash'}->{'passwd_cmd'} eq 'file') {
	# Directly update shadow file to do the change

	# Read shadow file and find user
	$self->get_miniserv_config(\%{$self->{'miniserv_hash'}});
	$self->lock_file($self->{'miniserv_hash'}->{'passwd_file'});
	$self->{'lref'} = $self->read_file_lines($self->{'miniserv_hash'}->{'passwd_file'});
	for($i=0; $i<@{$self->{'lref'}}; $i++) {
		@{$self->{'line_array'}} = split(/:/, $self->{'lref'}->[$i], -1);
		local $u = $self->{'line_array'}->[$self->{'miniserv_hash'}->{'passwd_uindex'}];
		if ($u eq $self->{'remote_user'}) {
			$self->{'idx'} = $i;
			last;
			}
		}
	defined($self->{'idx'}) || $self->error($self->{'text_hash'}->{'change_euser'});

	# Work out password encryption type
	if ($self->{'config_hash'}->{'md5'} && !$self->check_md5()) {
		$type = 1;
		}
	else {
		$type = 0;
		}

	# Validate old password
	$self->{'oldpass'} = $self->{'line_array'}->[$self->{'miniserv_hash'}->{'passwd_pindex'}];
	$self->unix_crypt($self->{'in_hash'}->{'old'}, $self->{'oldpass'}) eq $self->{'oldpass'} ||
	    $type == 1 && $self->encrypt_md5($self->{'in_hash'}->{'old'}, $self->{'oldpass'}) eq $self->{'oldpass'} ||
			$self->error($self->{'text_hash'}->{'change_eold'});

	# Set new password and save file
	if ($type == 0) {
		# Do Unix encryption
		$self->{'salt'} = chr(int(rand(26))+65) . chr(int(rand(26))+65);
		$self->{'line_array'}->[$self->{'miniserv_hash'}->{'passwd_pindex'}] = $self->unix_crypt($self->{'in_hash'}->{'new1'},
								$self->{'salt'});
		}
	else {
		# Do MD5 encryption
		$self->{'line_array'}->[$self->{'miniserv_hash'}->{'passwd_pindex'}] = $self->encrypt_md5($self->{'in_hash'}->{'new1'});
		}
	if ($self->{'miniserv_hash'}->{'passwd_cindex'} ne '') {
		$self->{'days'} = int(time()/(24*60*60));
		$self->{'line_array'}->[$self->{'miniserv_hash'}->{'passwd_cindex'}] = $self->{'days'};
		}
	$self->{'lref'}->[$self->{'idx'}] = join(":", @{$self->{'line_array'}});
	$self->flush_file_lines();
	$self->unlock_file($self->{'miniserv_hash'}->{'passwd_file'});
	}
elsif ($self->{'config_hash'}->{'passwd_cmd'} || !$self->{'has_pam'}) {
	# Call passwd program to do the change
	if ($self->{'config_hash'}->{'passwd_cmd'}) {
		$self->{'passwd_cmd'} = $self->{'config_hash'}->{'passwd_cmd'};
		}
	else {
		$self->{'passwd_cmd'} = $self->has_command("passwd");
		$self->{'passwd_cmd'} ||
			$self->error($self->text('change_epasswd', "<tt>passwd</tt>"));
		}
	$self->foreign_require("proc", "proc-lib.pl");
	$self->clean_environment();
	$ENV{'REMOTE_USER'} = $self->{'remote_user'};	# some programs need this
	if ($self->{'config_hash'}->{'cmd_mode'} == 0) {
		# Command is run as the user
		$ENV{'USER'} = $ENV{'LOGNAME'} = $self->{'remote_user'};
		@{$self->{'uinfo_array'}} = getpwnam($self->{'remote_user'});
		$ENV{'HOME'} = $self->{'uinfo_array'}->[7];
		chdir($self->{'uinfo_array'}->[7]);
		($self->{'fh'}, $self->{'fpid'}) = $main::proc_object->pty_process_exec(
					$self->{'passwd_cmd'}, $self->{'uinfo_array'}->[2], $self->{'uinfo_array'}->[3]);
		chdir($self->{'module_root_directory'});
		}
	else {
		# Command is being run as root
		$self->{'passwd_cmd'} .= " ".quotemeta($self->{'remote_user'});
		($self->{'fh'}, $self->{'fpid'}) = $main::proc_object->pty_process_exec($self->{'passwd_cmd'}, 0, 0);
		}
	$self->reset_environment();
	while(1) {
		local $rv = $self->wait_for($self->{'fh'},
			   '(new|re-enter).*:',
			   '(old|current|login).*:',
			   'pick a password',
			   'too\s+many\s+failures',
			   'attributes\s+changed\s+on|successfully\s+changed',
			   'pick your passwords');
		$self->{'out'} .= $self->{'wait_for_input'};
		sleep(1);
		if ($rv == 0) {
			# Prompt for the new password
			syswrite($self->{'fh'}, $self->{'in_hash'}->{'new1'}."\n", length($self->{'in_hash'}->{'new1'})+1);
			}
		elsif ($rv == 1) {
			# Prompt for the old password
			syswrite($self->{'fh'}, $self->{'in_hash'}->{'old'}."\n", length($self->{'in_hash'}->{'old'})+1);
			}
		elsif ($rv == 2) {
			# Request for a menu option (SCO?)
			syswrite($self->{'fh'}, "1\n", 2);
			}
		elsif ($rv == 3) {
			# Failed too many times
			last;
			}
		elsif ($rv == 4) {
			# All done
			last;
			}
		elsif ($rv == 5) {
			# Request for a menu option (HP/UX)
			syswrite($self->{'fh'}, "p\n", 2);
			}
		else {
			last;
			}
		last if (++$self->{'count'} > 10);
		}
	$self->{'crv'} = close($self->{'fh'});
	sleep(1);
	waitpid($self->{'fpid'}, 1);
	$self->error($self->text('change_ecmd', "<tt>$self->{'passwd_cmd'}</tt>", "<pre>$self->{'out'}</pre>"))
		if ($? || $self->{'count'} > 10 ||
		    $self->{'out'} =~ /error|failed/i ||
		    $self->{'out'} =~ /bad\s+password/i && !$self->{'config_hash'}->{'cmd_mode'});
	}
else {
	# Use PAM to make the change..
	# Check if the old password is correct
	$self->get_miniserv_config(\%{$self->{'miniserv_hash'}});
	@{$self->{'uinfo_array'}} = getpwnam($self->{'remote_user'});
	$self->{'service'} = $self->{'miniserv_hash'}->{'pam'} ? $self->{'miniserv_hash'}->{'pam'} : "webmin";
	$self->{'pamh'} = new Authen::PAM($self->{'service'}, $self->{'remote_user'}, \&pam_check_func);
	$rv = $self->{'pamh'}->pam_authenticate();
	$rv == PAM_SUCCESS || $self->error($self->{'text_hash'}->{'change_eold'});
	$self->{'pamh'} = undef;

	# Change the password with PAM, in a sub-process. This is needed because
	# the UID must be changed to properly signal to the PAM libraries that
	# the password change is not being done by the root user.
	$temp = $self->transname();
	$self->{'pid'} = fork();
	if (!$self->{'pid'}) {
		($>, $<) = (0, $self->{'uinfo_array'}->[2]);
		$self->{'pamh'} = new Authen::PAM("passwd", $self->{'remote_user'}, \&pam_change_func);
		$rv = $self->{'pamh'}->pam_chauthtok();
		open(TEMP, ">$temp");
		print TEMP "$rv\n";
		print TEMP ($self->{'messages'} || $self->{'pamh'}->pam_strerror($rv)),"\n";
		close(TEMP);
		exit(0);
		}
	waitpid($self->{'pid'}, 0);
	open(TEMP, $temp);
	chop($rv = <TEMP>);
	chop($self->{'messages'} = <TEMP>);
	close(TEMP);
	unlink($temp);
	$rv == PAM_SUCCESS || $self->error($self->text('change_epam2', $self->{'messages'}));
	}

# Run any post-change command. This must be done before the calls to the
# MySQL and mailboxes module, while we are still root.
if ($self->{'config_hash'}->{'post_command'}) {
	$ENV{'CHANGEPASS_USER'} = $self->{'remote_user'};
	$ENV{'CHANGEPASS_PASS'} = $self->{'in_hash'}->{'new1'};
	system("($self->{'config_hash'}->{'post_command'}) >/dev/null 2>&1 </dev/null");
	}

# Change samba password as well
if ($self->has_command($self->{'config_hash'}->{'smbpasswd'}) && $self->get_samba_user($self->{'remote_user'})) {
	local $user = quotemeta($self->{'remote_user'});
	local $hout = `$self->{'config_hash'}->{'smbpasswd'} -h 2>&1`;
	if ($hout =~ /\s-s\s/) {
		# New version of smbpasswd which accepts the -s option
		local $temp = $self->transname();
		open(TEMP, ">$temp");
		print TEMP $self->{'in_hash'}->{'new1'},"\n",$self->{'in_hash'}->{'new1'},"\n";
		close(TEMP);
		$self->{'smbout'} = `$self->{'config_hash'}->{'smbpasswd'} -s $user 2>&1 <$temp`;
		unlink($temp);
		}
	else {
		# Old version of smbpasswd which takes password on command line
		local $pass = quotemeta($self->{'in_hash'}->{'new1'});
		$self->{'smbout'} = `$self->{'config_hash'}->{'smbpasswd'} $user $pass 2>&1 </dev/null`;
		}
	}

# Change MySQL password too, if possible
if ($self->{'config_hash'}->{'mysql'} && $self->foreign_check("mysql")) {
	$self->foreign_require("mysql", "mysql-lib.pl");
	$self->{'myr'} = $main::mysql_object->is_mysql_running();
	if ($self->{'myr'} == 1) {
		# Running and can login .. change it
		($self->{'db'}) = grep { $main::mysql_object->can_edit_db($_) }
			     $main::mysql_object->list_databases();
		$self->{'db'} ||= "mysql";
		local $main::error_must_die = 1;
		eval {
			$self->{'mypass'} = $self->{'in_hash'}->{'new1'};
			$self->{'mypass'} =~ s/'/''/g;
			$main::mysql_object->execute_sql($self->{'db'},
				"set password = password('$self->{'mypass'}')");
			};
		if ($@) {
			$self->{'mysql_error'} = $@;
			}
		else {
			# Worked! Save in MySQL config too
			$self->{'mysql_ok'} = 1;
			$main::mysql_object->{'userconfig_hash'}->{'pass'} = $self->{'in_hash'}->{'new1'};
			$main::mysql_object->save_user_module_config();
			}
		}
	elsif ($self->{'myr'} == -1) {
		# Running but cannot login
		$self->{'mysql_error'} = $self->{'text_hash'}->{'change_emysql'};
		}
	}

# Change matching stored POP3 passwords in read mail module
if ($self->{'config_hash'}->{'mailbox'} && $self->foreign_check("mailbox")) {
	$self->foreign_require("mailbox", "mailbox-lib.pl");
	foreach $f ($main::mailbox_object->list_folders()) {
		if (($f->{'type'} == 2 || $f->{'type'} == 4) &&
		    $f->{'user'} eq $self->{'remote_user'} &&
		    $f->{'pass'} eq $self->{'in_hash'}->{'old'}) {
			# Found one to change
			local $type = $f->{'type'} == 2 ? "pop3" : "imap";
			if ($f->{'inbox'}) {
				# Need to change special inbox password file
				$self->{'file'} = "$main::mailbox_object->{'user_module_config_directory'}/inbox";
				push(@pc, $self->text('change_inbox', uc($type)));
				}
			else {
				# Need to change folder's file
				$self->{'file'} = "$main::mailbox_object->{'user_module_config_directory'}/$f->{'id'}";
				push(@pc, $self->text('change_folder', uc($type), $f->{'server'}));
				}
			$self->{'file'} .= ".".$type;
			local %data;
			$self->read_file($self->{'file'}, \%data);
			$data{'pass'} = $self->{'in_hash'}->{'new1'};
			$self->write_file($self->{'file'}, \%data);
			}
		}
	}

$self->ui_print_header(undef, $self->{'text_hash'}->{'change_title'}, "");

print "<p>",$self->text('change_ok', "<tt>$self->{'remote_user'}</tt>"),"<p>\n";
if ($self->{'smbout'} =~ /changed/) {
	print "<p>",$self->text('change_samba'),"<p>\n";
	}
elsif ($self->{'smbout'}) {
	print "<p>",$self->text('change_samba2', "<pre>$self->{'smbout'}</pre>"),"<p>\n";
	}
if ($self->{'mysql_ok'}) {
	print "<p>",$self->text('change_mysql'),"<p>\n";
	}
elsif ($self->{'mysql_error'}) {
	print "<p>",$self->text('change_mysql2', $self->{'mysql_error'}),"<p>\n";
	}
foreach $pc (@pc) {
	print "$pc<br>\n";
	}
print "<p>\n" if (@pc);

$self->ui_print_footer($self->{'text_hash'}->{'index_mainpage_url'}, $self->{'text_hash'}->{'index_mainpage'});

1;
		
}

sub pam_check_func
{
	shift if ($self == $_[0]);

my @res;
while ( @_ ) {
	my $code = shift;
	my $msg = shift;
	my $ans = "";

	$ans = $self->{'remote_user'} if ($code == $self->PAM_PROMPT_ECHO_ON());
	$ans = $self->{'in_hash'}->{'old'} if ($code == $self->PAM_PROMPT_ECHO_OFF());

	push @res, $self->PAM_SUCCESS();
	push @res, $ans;
	}
push @res, $self->PAM_SUCCESS();
return @res;
}

sub pam_change_func
{
	shift if ($self == $_[0]);

my @res;
while ( @_ ) {
	my $code = shift;
	my $msg = shift;
	my $ans = "";
	$self->{'messages'} = $msg;
	print STDERR "code=$code msg=$msg\n";

	if ($code == $self->PAM_PROMPT_ECHO_ON()) {
		# Assume asking for username
		push @res, $self->PAM_SUCCESS();
		push @res, $self->{'remote_user'};
		}
	elsif ($code == $self->PAM_PROMPT_ECHO_OFF()) {
		# Assume asking for a password (old first, then new)
		push @res, $self->PAM_SUCCESS();
		if ($msg =~ /old|current/i) {
			push @res, $self->{'in_hash'}->{'old'};
			}
		else {
			push @res, $self->{'in_hash'}->{'new1'};
			}
		}
	else {
		# Some message .. ignore it
		push @res, $self->PAM_SUCCESS();
		push @res, undef;
		}
	}
push @res, $self->PAM_SUCCESS();
return @res;
}


1;

