#!/usr/bin/perl

&MAIN();

 sub MAIN {
# index.cgi
# Display buttons for custom commands from webmin

&ModuleLoader::preload_module('commands_class', "commands::CustomLib");
$self = new commands::CustomLib:: 'commands_class',%$self;

$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", undef, 0, 1);

if (!-d $self->{'config_hash'}->{'webmin_config'}) {
	print $self->text('index_nodir', "<tt>$self->{'config_hash'}->{'webmin_config'}</tt>"),
	      "<p>\n";
	$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});
	exit;
	}

@{$self->{'cust_array'}} = grep { $self->can_run_command($_) } $self->list_commands();
@{$self->{'cust_array'}} = sort { local $o = $b->{'order'} <=> $a->{'order'};
	       $o ? $o : $a->{'id'} <=> $b->{'id'} } @{$self->{'cust_array'}};

if (!@{$self->{'cust_array'}}) {
	print "<b>$self->{'text_hash'}->{'index_none'}</b> <p>\n";
	}
elsif ($self->{'config_hash'}->{'display_mode'} == 0) {
	# Show command buttons
	print "<table width=100%><tr><td valign=top>\n";
	$self->{'form'} = 0;
	for($i=0; $i<@{$self->{'cust_array'}}; $i++) {
		$c = $self->{'cust_array'}->[$i];
		if ($c->{'edit'}) {
			@a = ( );
			print "<form action=view.cgi>\n";
			}
		else {
			@a = @{$c->{'args'}};
			local ($up) = grep { $_->{'type'} == 10 } @a;
			if ($up) {
				print "<form action=run.cgi method=post enctype=multipart/form-data>\n";
				}
			elsif (@a) {
				print "<form action=run.cgi method=post>\n";
				}
			else {
				print "<form action=run.cgi method=get>\n";
				}
			}
		print "<input type=hidden name=idx value='$c->{'index'}'>\n";
		print "<table border cellpadding=3><tr $self->{'cb'}><td>\n";
		print "<input type=submit value='",$self->html_escape($c->{'desc'}),
		      "'><br>\n";
		print $self->filter_javascript($c->{'html'}),"\n";
		print "<table>\n";
		foreach $a (@a) {
			print "<tr> <td><b>",$self->html_escape($a->{'desc'}),
			      "</b></td> <td>\n";
			$self->{'n'} = $a->{'name'};
			if ($a->{'type'} == 0) {
				print "<input name=$self->{'n'} size=30>\n";
				}
			elsif ($a->{'type'} == 1 || $a->{'type'} == 2) {
				print "<input name=$self->{'n'} size=8> ",
					$self->user_chooser_button($self->{'n'}, 0, $self->{'form'});
				}
			elsif ($a->{'type'} == 3 || $a->{'type'} == 4) {
				print "<input name=$self->{'n'} size=8> ",
					$self->group_chooser_button($self->{'n'}, 0, $self->{'form'});
				}
			elsif ($a->{'type'} == 5 || $a->{'type'} == 6) {
				print "<input name=$self->{'n'} size=30 ",
				      "value='$a->{'opts'}'> ",
					$self->file_chooser_button(
					  $self->{'n'}, $a->{'type'}-5, $self->{'form'});
				}
			elsif ($a->{'type'} == 7) {
				print "<input type=radio name=$self->{'n'} value=1> $self->{'text_hash'}->{'yes'}\n";
				print "<input type=radio name=$self->{'n'} value=0 checked> $self->{'text_hash'}->{'no'}\n";
				}
			elsif ($a->{'type'} == 8) {
				print "<input name=$self->{'n'} type=password size=30>\n";
				}
			elsif ($a->{'type'} == 9) {
				print "<select name=$self->{'n'}>\n";
				foreach $l ($self->read_opts_file($a->{'opts'})) {
					print "<option value='$l->[0]'>",
					      "$l->[1]\n";
					}
				print "</select>\n";
				}
			elsif ($a->{'type'} == 10) {
				print "<input name=$self->{'n'} type=file size=20>\n";
				}
			elsif ($a->{'type'} == 11) {
				print "<textarea name=$self->{'n'} rows=4 cols=30>".
				      "</textarea>\n";
				}
			print "</td> </tr>\n";
			}
		print "</table></td></tr></table></form>\n";
		$self->{'form'}++;
		if ($i == int((@{$self->{'cust_array'}}-1)/2) && $self->{'config_hash'}->{'columns'} == 2) {
			print "</td><td valign=top>\n";
			}
		}
	print "</td></tr></table>\n";
	}
else {
	# Just show table of commands
	print "<table border width=100%>\n";
	print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'index_cmd'}</b></td>\n";
	print "<td><b>$self->{'text_hash'}->{'index_desc'}</b></td> </tr>\n";
	foreach $c (@{$self->{'cust_array'}}) {
		if ($c->{'edit'} && !@{$c->{'args'}}) {
			print "<tr $self->{'cb'}> <td><a href='view.cgi?idx=$c->{'index'}'>",
			      $self->html_escape($c->{'desc'}),"</a>\n";
			}
		else {
			print "<tr $self->{'cb'}> <td><a href='form.cgi?idx=$c->{'index'}'>",
			      $self->html_escape($c->{'desc'}),"</a></td>\n";
			}
		print "</td> <td>$c->{'html'}<br></td>\n";
		print "</tr>\n";
		}
	print "</table>\n";
	}

$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});

1;
		
}


1;

