#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_cron.cgi
# Edit an existing or new cron job

&ModuleLoader::preload_module('cron_class', "cron::CronLib");
$self = new cron::CronLib:: 'cron_class',%$self;

$self->ReadParse();

if (!$self->{'in_hash'}->{'new'}) {
	@{$self->{'jobs_array'}} = $self->list_cron_jobs();
	$self->{'job'} = $self->{'jobs_array'}->[$self->{'in_hash'}->{'idx'}];
	$self->can_edit_user(\%{$self->{'access_hash'}}, $self->{'job'}->{'user'}) ||
		$self->error($self->{'text_hash'}->{'edit_ecannot'});
	$self->ui_print_header(undef, $self->{'text_hash'}->{'edit_title'}, "");
	}
else {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'create_title'}, "");
	if ($self->{'config_hash'}->{'vixie_cron'}) {
		# Default to hourly, using @ format
		$self->{'job'} = { 'special' => 'hourly',
			 'active' => 1 };
		}
	else {
		# Default to hourly, using standard notation
		$self->{'job'} = { 'mins' => '0',
			 'hours' => '*',
			 'days' => '*',
			 'months' => '*',
			 'weekdays' => '*',
			 'active' => 1 };
		}
	}

print "<form action=save_cron.cgi>\n";
print "<input type=hidden name=new value='$self->{'in_hash'}->{'new'}'>\n";
print "<input type=hidden name=idx value='$self->{'in_hash'}->{'idx'}'>\n";
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'edit_details'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table>\n";

if ($self->supports_users()) {
	# Allow selection of user
	print "<tr> <td><b>$self->{'text_hash'}->{'edit_user'}</b></td>\n";
	if ($self->{'access_hash'}->{'mode'} == 1) {
		print "<td><select name=user>\n";
		foreach $u (split(/\s+/, $self->{'access_hash'}->{'users'})) {
			printf "<option %s>$u\n",
				$self->{'job'}->{'user'} eq $u ? "selected" : "";
			}
		print "</select></td>\n";
		}
	elsif ($self->{'access_hash'}->{'mode'} == 3) {
		print "<td><tt>$self->{'remote_user'}</tt></td>\n";
		print "<input type=hidden name=user value='$self->{'remote_user'}'>\n";
		}
	else {
		print "<td><input name=user size=8 value=\"$self->{'job'}->{'user'}\"> ",
			$self->user_chooser_button("user", 0),"</td>\n";
		}
	}
else {
	# No such thing as users!
	print "<tr>\n";
	}

print "<td> <b>$self->{'text_hash'}->{'edit_active'}</b></td>\n";
printf "<td><input type=radio name=active value=1 %s> $self->{'text_hash'}->{'yes'}\n",
	$self->{'job'}->{'active'} ? "checked" : "";
printf "<input type=radio name=active value=0 %s> $self->{'text_hash'}->{'no'}</td> </tr>\n",
	$self->{'job'}->{'active'} ? "" : "checked";

$self->convert_comment($self->{'job'});
$self->{'rpd'} = $self->is_run_parts($self->{'job'}->{'command'});
if ($self->{'rpd'}) {
	# run-parts command.. just show scripts that will be run
	print "<tr> <td valign=top><b>$self->{'text_hash'}->{'edit_commands'}</b></td>\n";
	print "<td><tt>",join("<br>",$self->expand_run_parts($self->{'rpd'})),
	      "</tt></td> </tr>\n";
	print "<input type=hidden name=cmd value='$self->{'job'}->{'command'}'>\n";
	}
elsif (!$self->{'access_hash'}->{'command'}) {
	# Just show command, which cannot be edited
	print "<tr> <td><b>$self->{'text_hash'}->{'edit_command'}</b></td>\n";
	print "<td colspan=3><tt>$self->{'job'}->{'command'}</tt></td> </tr>\n";
	}
else {
	# Normal cron job.. can edit command
	$self->convert_range($self->{'job'});
	$self->{'rangeable'} = 1;
	($self->{'command'}, $self->{'input'}) = $self->extract_input($self->{'job'}->{'command'});
	@{$self->{'lines_array'}} = split(/%/, $self->{'input'});
	print "<tr> <td><b>$self->{'text_hash'}->{'edit_command'}</b></td>\n";
	print "<td colspan=3><input name=cmd size=60 ",
	      "value='",$self->html_escape($self->{'command'}),"'></td> </tr>\n";

	if ($self->{'config_hash'}->{'cron_input'}) {
		print "<tr> <td valign=top><b>$self->{'text_hash'}->{'edit_input'}</b></td>\n";
		print "<td colspan=3><textarea name=input rows=3 cols=50>",
		      join("\n" , @{$self->{'lines_array'}}),"</textarea></td> </tr>\n";
		}
	}

# Show comment
print "<tr> <td><b>$self->{'text_hash'}->{'edit_comment'}</b></td>\n";
print "<td colspan=3>",$self->ui_textbox("comment", $self->{'job'}->{'comment'}, 60),
      "</td> </tr>\n";

print "</table></td></tr></table><p>\n";

# Show times and days to run
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td colspan=5><b>$self->{'text_hash'}->{'edit_when'}</b></td> </tr>\n";
$self->show_times_input($self->{'job'});
print "</table>\n";

if ($self->{'rangeable'}) {
	# Show date range to run
	print "<p><table border width=100%>\n";
	print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'edit_range'}</b></td> </tr>\n";
	print "<tr $self->{'cb'}><td>";
	$self->show_range_input($self->{'job'});
	print "</td></tr></table>\n";
	}

if (!$self->{'in_hash'}->{'new'}) {
	print "<table width=100%>\n";
	print "<tr> <td align=left width=33%><input type=submit value=\"$self->{'text_hash'}->{'save'}\"></td>\n";
	if (!$self->{'rpd'}) {
		print "</form><form action=\"exec_cron.cgi\">\n";
		print "<input type=hidden name=idx value=\"$self->{'in_hash'}->{'idx'}\">\n";
		print "<td align=center width=33%>",
		      "<input type=submit value=\"$self->{'text_hash'}->{'edit_run'}\"></td>\n";
		}
	if ($self->{'access_hash'}->{'delete'}) {
		print "</form><form action=\"delete_cron.cgi\">\n";
		print "<input type=hidden name=idx value=\"$self->{'in_hash'}->{'idx'}\">\n";
		print "<td align=right width=33%><input type=submit value=\"$self->{'text_hash'}->{'delete'}\"></td> </tr>\n";
		}
	else {
		print "<td align=right width=33%></td>\n";
		}
	print "</form></table><p>\n";
	}
else {
	print "<input type=submit value=\"$self->{'text_hash'}->{'create'}\"></form><p>\n";
	}

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

