#!/usr/bin/perl

&MAIN();

 sub MAIN {
# exec_cron.cgi
# Execute an existing cron job, and display the output

&ModuleLoader::preload_module('cron_class', "cron::CronLib");
$self = new cron::CronLib:: 'cron_class',%$self;

$self->ReadParse();

@{$self->{'jobs_array'}} = $self->list_cron_jobs();
$self->{'job'} = $self->{'jobs_array'}->[$self->{'in_hash'}->{'idx'}];
$self->can_edit_user(\%{$self->{'access_hash'}}, $self->{'job'}->{'user'}) || $self->error($self->{'text_hash'}->{'exec_ecannot'});
$self->foreign_require("proc", "proc-lib.pl");

# split command into command and input
$self->convert_range($self->{'job'});
$self->convert_comment($self->{'job'});
$self->{'job'}->{'command'} =~ s/\\%/\0/g;
@{$self->{'lines_array'}} = split(/%/ , $self->{'job'}->{'command'});
foreach (@{$self->{'lines_array'}}) { s/\0/%/g; }
for($i=1; $i<@{$self->{'lines_array'}}; $i++) {
	$self->{'input'} .= $self->{'lines_array'}->[$i]."\n";
	}

if ($self->{'in_hash'}->{'bg'}) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'exec_title'}, "");
	}
else {
	$self->ui_print_unbuffered_header(undef, $self->{'text_hash'}->{'exec_title'}, "");
	}
$self->additional_log('exec', undef, $self->{'lines_array'}->[0]);
$self->webmin_log("exec", "cron", $self->{'job'}->{'user'}, $self->{'job'});

# Remove variables that wouldn't be in the 'real' cron
$self->clean_environment();

# Set cron environment variables
foreach $e ($self->read_envs($self->{'job'}->{'user'})) {
	$ENV{$1} = $2 if ($e =~ /^(\S+)\s+(.*)$/);
	}

if ($self->supports_users()) {
	# Get command and switch uid/gid
	@{$self->{'uinfo_array'}} = getpwnam($self->{'job'}->{'user'});
	$ENV{"HOME"} = $self->{'uinfo_array'}->[7];
	$ENV{"SHELL"} = "/bin/sh";
	$ENV{"LOGNAME"} = $ENV{"USER"} = $self->{'job'}->{'user'};
	$( = $self->{'uinfo_array'}->[3];
	$) = "$self->{'uinfo_array'}->[3] ".join(" ", $self->{'uinfo_array'}->[3], $self->other_groups($self->{'uinfo_array'}->[0]));
	($>, $<) = ($self->{'uinfo_array'}->[2], $self->{'uinfo_array'}->[2]);
	}

if ($self->{'in_hash'}->{'bg'}) {
	# Run in background
	print $self->text('exec_cmdbg', "<tt>$self->{'lines_array'}->[0]</tt>"),"<p>\n";
	if (defined($self->{'input'})) {
		local $temp = $self->tempname();
		$self->open_tempfile(TEMP, ">$temp");
		print TEMP $self->{'input'};
		close(TEMP);
		$self->execute_command("(($self->{'lines_array'}->[0]) ; rm -f $temp) &", $temp,
				 undef, undef);
		}
	else {
		$self->execute_command("($self->{'lines_array'}->[0]) &", undef, undef, undef);
		}
	}
else {
	# Execute cron command and display output..
	print $self->text('exec_cmd', "<tt>$self->{'lines_array'}->[0]</tt>"),"<p>\n";
	print "<pre>";
	$self->{'got'} = $self->foreign_call("proc", "safe_process_exec",
			     $self->{'lines_array'}->[0], 0, 0, STDOUT, $self->{'input'}, 1);
	print "<i>$self->{'text_hash'}->{'exec_none'}</i>\n" if (!$self->{'got'});
	print "</pre>\n";
	}

$self->ui_print_footer("edit_cron.cgi?idx=$self->{'in_hash'}->{'idx'}", $self->{'text_hash'}->{'edit_return'},
	"", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

