#!/usr/bin/perl

&MAIN();

 sub MAIN {
# index.cgi
# Display a list of all cron jobs, with the username and command for each one

&ModuleLoader::preload_module('cron_class', "cron::CronLib");
$self = new cron::CronLib:: 'cron_class',%$self;


$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", undef, 1, 1);

# Make sure cron is installed (very likely!)
if ($self->{'config_hash'}->{'single_file'} && !-r $self->{'config_hash'}->{'single_file'}) {
	$self->{'err'} = $self->text('index_esingle', "<tt>$self->{'config_hash'}->{'single_file'}</tt>");
	}
if ($self->{'config_hash'}->{'cron_get_command'} =~ /^(\S+)/ && !$self->has_command("$1")) {
	$self->{'err'} = $self->text('index_ecmd', "<tt>$1</tt>");
	}
if ($self->{'err'}) {
	print $self->{'err'},"<p>\n";
	$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});
	exit;
	}

# Work out which users can be viewed
map { $self->{'ucan_hash'}->{$_}++ } split(/\s+/, $self->{'access_hash'}->{'users'});
@{$self->{'jobs_array'}} = $self->list_cron_jobs();
@{$self->{'ulist_array'}} = $self->unique(map { $_->{'user'} } @{$self->{'jobs_array'}});
if ($self->{'access_hash'}->{'mode'} == 1) {
	@{$self->{'ulist_array'}} = grep { $self->{'ucan_hash'}->{$_} } @{$self->{'ulist_array'}};
	}
elsif ($self->{'access_hash'}->{'mode'} == 2) {
	@{$self->{'ulist_array'}} = grep { !$self->{'ucan_hash'}->{$_} } @{$self->{'ulist_array'}};
	}
elsif ($self->{'access_hash'}->{'mode'} == 3) {
	@{$self->{'ulist_array'}} = ( $self->{'remote_user'} );
	}
elsif ($self->{'access_hash'}->{'mode'} == 4) {
	@{$self->{'ulist_array'}} = grep { local @u = getpwnam($_);
			(!$self->{'access_hash'}->{'uidmin'} || $u[2] >= $self->{'access_hash'}->{'uidmin'}) &&
			(!$self->{'access_hash'}->{'uidmax'} || $u[2] <= $self->{'access_hash'}->{'uidmax'}) }
		      @{$self->{'ulist_array'}};
	}
elsif ($self->{'access_hash'}->{'mode'} == 5) {
	@{$self->{'ulist_array'}} = grep { local @u = getpwnam($_);
			$u[3] == $self->{'access_hash'}->{'users'} } @{$self->{'ulist_array'}};
	}

if ($self->{'config_hash'}->{'show_run'}) {
	$self->foreign_require("proc", "proc-lib.pl");
	@{$self->{'procs_array'}} = $main::proc_object->list_processes();
	}

# Work out creation links
@{$self->{'crlinks_array'}} = ( );

# Show cron jobs by user
$self->{'single_file'} = !$self->supports_users() || !(@{$self->{'ulist_array'}} != 1 || $self->{'access_hash'}->{'mode'} != 3);
@{$self->{'links_array'}} = ( $self->select_all_link("d"),
	   $self->select_invert_link("d"),
	   @{$self->{'crlinks_array'}} );
foreach $u (@{$self->{'ulist_array'}}) {
	if (!$self->{'config_hash'}->{'single_file'}) {
		# Get the Unix user's real name
		if ((@{$self->{'uinfo_array'}} = getpwnam($u)) && $self->{'uinfo_array'}->[5] =~ /\S/) {
			$self->{'uname'} = "$u ($self->{'uinfo_array'}->[5])";
			}
		else { $self->{'uname'} = $u; }
		}

	@{$self->{'jlist_array'}} = grep { $_->{'user'} eq $u } @{$self->{'jobs_array'}};
	@{$self->{'plist_array'}} = ();
	for($i=0; $i<@{$self->{'jlist_array'}}; $i++) {
		local $rpd = $self->is_run_parts($self->{'jlist_array'}->[$i]->{'command'});
		local @exp = $rpd ? $self->expand_run_parts($rpd) : ();
		if (!$rpd || @exp) {
			push(@{$self->{'plist_array'}}, [ $self->{'jlist_array'}->[$i], \@exp ]);
			}
		}
	for($i=0; $i<@{$self->{'plist_array'}}; $i++) {
		local $job = $self->{'plist_array'}->[$i]->[0];
		$self->convert_range($job);
		$self->convert_comment($job);
		local @exp = @{$self->{'plist_array'}->[$i]->[1]};
		local $idx = $job->{'index'};
		if (!$self->{'donehead'}) {
			print $self->ui_form_start("delete_jobs.cgi", "post");
			print $self->ui_links_row(\@{$self->{'links_array'}});
			print "<table border width=100%> <tr $self->{'tb'}>\n";
			if (!$self->{'single_file'}) {
				print "<td><b>$self->{'text_hash'}->{'index_user'}</b></td>\n";
				}
			print "<td width=5><br></td>\n";
			print "<td><b>$self->{'text_hash'}->{'index_active'}</b></td>\n";
			if ($self->{'access_hash'}->{'command'}) {
				print "<td><b>$self->{'text_hash'}->{'index_command'}</b></td>\n";
				}
			if (!$self->{'access_hash'}->{'command'} || $self->{'config_hash'}->{'show_time'} || $self->{'userconfig_hash'}->{'show_time'}) {
				print "<td><b>$self->{'text_hash'}->{'index_when'}</b></td>\n";
				}
			if ($self->{'config_hash'}->{'show_comment'} || $self->{'userconfig_hash'}->{'show_comment'}) {
				print "<td><b>$self->{'text_hash'}->{'index_comment'}</b></td>\n";
				}
			if ($self->{'config_hash'}->{'show_run'}) {
				print "<td width=5%><b>$self->{'text_hash'}->{'index_run'}</b></td>\n";
				}
			if ($self->{'access_hash'}->{'move'}) {
				print "<td width=5%><b>$self->{'text_hash'}->{'index_move'}</b></td>\n";
				}
			print "</tr>\n";
			$self->{'donehead'} = 1;
			}
		print "<tr $self->{'cb'}>\n";
		if ($i == 0 && !$self->{'single_file'}) {
			printf "<td valign=top rowspan=%d>", scalar(@{$self->{'plist_array'}});
			print $self->html_escape($self->{'uname'});
			print "</td>\n";
			}
		print "<td>",$self->ui_checkbox("d", $idx),"</td>\n";
		printf "<td valign=top>%s</td>\n",
			$job->{'active'} ? $self->{'text_hash'}->{'yes'}
				: "<font color=#ff0000>$self->{'text_hash'}->{'no'}</font>";
		$self->{'donelink'} = 0;
		if ($job->{'name'}) {
			# An environment variable - show the name only
			print "<td><a href=\"edit_env.cgi?idx=$idx\">",
			      "<i>$self->{'text_hash'}->{'index_env'}</i> ",
			     "<tt>$job->{'name'} = $job->{'value'}</tt></td>\n";
			$self->{'donelink'} = 1;
			}
		elsif (@exp && $self->{'access_hash'}->{'command'}) {
			# A multi-part command
			@exp = map { $self->html_escape($_) } @exp;
			print "<td><a href=\"edit_cron.cgi?idx=$idx\">",
			      join("<br>",@exp),"</a></td>\n";
			$self->{'donelink'} = 1;
			}
		elsif ($self->{'access_hash'}->{'command'}) {
			# A simple command
			local $max = $self->{'config_hash'}->{'max_len'} || 10000;
			local ($cmd, $input) =
				$self->extract_input($job->{'command'});
			$cmd = 
			  length($cmd) > $max ?
				$self->html_escape(substr($cmd, 0, $max))." ..." :
			  $cmd !~ /\S/ ? "BLANK" : $self->html_escape($cmd);
			print "<td><a href=\"edit_cron.cgi?idx=$idx\">$cmd</a></td>\n";
			$self->{'donelink'} = 1;
			}

		# Show cron time
		if (!$self->{'access_hash'}->{'command'} || $self->{'config_hash'}->{'show_time'} || $self->{'userconfig_hash'}->{'show_time'}) {
			$self->{'when'} = $self->when_text($job, 1);
			if ($job->{'name'}) {
				print "<td><br></td>\n";
				}
			elsif ($self->{'donelink'}) {
				print "<td>$self->{'when'}</td>\n";
				}
			else {
				print "<td><a href='edit_cron.cgi?idx=$idx'>$self->{'when'}</a></td>\n";
				}
			}

		# Show comment
		if ($self->{'config_hash'}->{'show_comment'} || $self->{'userconfig_hash'}->{'show_comment'}) {
			print "<td>",($job->{'comment'} || "<br>"),"</td>\n";
			}

		# Show running indicator
		if ($self->{'config_hash'}->{'show_run'}) {
			print "<td>";
			if ($job->{'name'}) {
				# An environment variable
				print "<br>\n";
				}
			else {
				# Try to find the process
				local $proc = $self->find_cron_process($job, \@{$self->{'procs_array'}});
				$self->{'txt'} = $proc ?
				    "<font color=#00aa00>$self->{'text_hash'}->{'yes'}</font>" :
				    $self->{'text_hash'}->{'no'};
				if ($self->{'config_hash'}->{'show_run'} == 2 &&
				    ($self->{'access_hash'}->{'kill'} || !$proc)) {
					$self->{'lnk'} = $proc ? "kill_cron.cgi?idx=$idx" : "exec_cron.cgi?idx=$idx&bg=1";
					print "<a href='$self->{'lnk'}'>$self->{'txt'}</a>";
					}
				else {
					print $self->{'txt'};
					}
				}
			print "</td>\n";
			}

		# Show mover buttons
		local $prv = $i > 0 ? $self->{'plist_array'}->[$i-1]->[0] : undef;
		local $nxt = $i != $#{$self->{'plist_array'}} ? $self->{'plist_array'}->[$i+1]->[0] : undef;
		if ($self->{'access_hash'}->{'move'}) {
			print "<td width=5%>";
			if ($prv && $prv->{'file'} eq $job->{'file'} &&
			    ($job->{'type'} == 0 || $job->{'type'} == 3)) {
				print "<a href='move.cgi?idx=$idx&up=1'>",
				      "<img src=images/up.gif border=0></a>";
				}
			else {
				print "<img src=images/gap.gif>";
				}
			if ($nxt && $nxt->{'file'} eq $job->{'file'} &&
			    ($job->{'type'} == 0 || $job->{'type'} == 3)) {
				print "<a href='move.cgi?idx=$idx&down=1'>",
				      "<img src=images/down.gif border=0></a>";
				}
			else {
				print "<img src=images/gap.gif>";
				}
			print "</td>\n";
			}
		print "</tr>\n";
		}
	}
if ($self->{'donehead'}) {
	print "</table>\n";
	print $self->ui_links_row(\@{$self->{'links_array'}});
	}
else {
	print $self->{'module_info_hash'}->{'usermin'} ? "<b>$self->{'text_hash'}->{'index_none3'}</b> <p>\n" :
	      $self->{'access_hash'}->{'mode'} ? "<b>$self->{'text_hash'}->{'index_none2'}</b> <p>\n"
			      : "<b>$self->{'text_hash'}->{'index_none'}</b> <p>\n";
	print $self->ui_links_row(\@{$self->{'crlinks_array'}});
	}
if ($self->{'donehead'}) {
	print $self->ui_form_end([ [ "delete", $self->{'text_hash'}->{'index_delete'} ],
			     [ "disable", $self->{'text_hash'}->{'index_disable'} ],
			     [ "enable", $self->{'text_hash'}->{'index_enable'} ] ]);
	}

if ($self->{'access_hash'}->{'create'}) {
	print "<hr>";
	print "<table width=100% border=0><tr><td>";
	print $self->ui_form_start("edit_cron.cgi?new=1", "post");
	print $self->ui_form_end([ [ "submit_edit", $self->{'text_hash'}->{'index_create'} ] ]);
	print "</td><td>";
	if ($self->{'config_hash'}->{cron_allow_file} && $self->{'config_hash'}->{cron_deny_file} && $self->{'access_hash'}->{'allow'}) {
		print $self->ui_form_start("edit_allow.cgi", "post");
		print $self->ui_form_end([ [ "submit_allow", $self->{'text_hash'}->{'index_allow'} ] ]);
		print "</td><td>";
		}
	if ($self->{'env_support'}) {
		print $self->ui_form_start("edit_env.cgi?new=1", "post");
		print $self->ui_form_end([ [ "submit_env", $self->{'text_hash'}->{'index_ecreate'} ] ]);
		print "</td>";
		}
		print "</tr><table>";
	}
print "<br>\n";

$self->ui_print_footer($self->{'text_hash'}->{'index_mainpage_url'}, $self->{'text_hash'}->{'index_mainpage'});

1;
		
}


1;

