#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_env.cgi
# Save an existing environment variable, or create a new one

&ModuleLoader::preload_module('cron_class', "cron::CronLib");
$self = new cron::CronLib:: 'cron_class',%$self;

$self->error_setup($self->{'text_hash'}->{'env_err'});
$self->ReadParse();

@{$self->{'jobs_array'}} = $self->list_cron_jobs();
if ($self->{'in_hash'}->{'new'}) {
	$self->{'job'} = { };
	}
else {
	$self->{'oldjob'} = $self->{'jobs_array'}->[$self->{'in_hash'}->{'idx'}];
	$self->{'job'}->{'file'} = $self->{'oldjob'}->{'file'};
	$self->{'job'}->{'line'} = $self->{'oldjob'}->{'line'};
	}

@{$self->{'files_array'}} = $self->unique((map { $_->{'file'} } @{$self->{'jobs_array'}}),
	         "$self->{'config_hash'}->{'cron_dir'}/$self->{'in_hash'}->{'user'}");
foreach $f (@{$self->{'files_array'}}) { $self->lock_file($f); }

# Check and parse inputs
if ($self->{'in_hash'}->{'name'} !~ /^\S+$/) {
	$self->error($self->{'text_hash'}->{'save_ename'});
	}
if (!$self->{'in_hash'}->{'user'}) {
	$self->error($self->{'text_hash'}->{'save_euser'});
	}
if (!defined(getpwnam($self->{'in_hash'}->{'user'}))) {
	$self->error($self->text('save_euser2', $self->{'in_hash'}->{'user'}));
	}
$self->{'job'}->{'active'} = $self->{'in_hash'}->{'active'};
$self->{'job'}->{'name'} = $self->{'in_hash'}->{'name'};
$self->{'job'}->{'value'} = $self->{'in_hash'}->{'value'};

# Check if this user is allowed to execute cron jobs
$self->can_use_cron($self->{'in_hash'}->{'user'}) ||
	$self->error($self->text('save_eallow', $self->{'in_hash'}->{'user'}));
$self->{'job'}->{'user'} = $self->{'in_hash'}->{'user'};

# Check module access control
$self->can_edit_user(\%{$self->{'access_hash'}}, $self->{'in_hash'}->{'user'}) ||
	$self->error($self->text('save_ecannot', $self->{'in_hash'}->{'user'}));

if (!$self->{'in_hash'}->{'new'}) {
	# Editing an existing variable
	$self->can_edit_user(\%{$self->{'access_hash'}}, $self->{'oldjob'}->{'user'}) ||
		$self->error($self->text('save_ecannot', $self->{'oldjob'}->{'user'}));
	if ($self->{'job'}->{'user'} eq $self->{'oldjob'}->{'user'}) {
		# Not changing user
		if ($self->{'in_hash'}->{'where'}) {
			$self->delete_cron_job($self->{'job'});
			$self->insert_cron_job($self->{'job'});
			}
		else {
			$self->change_cron_job($self->{'job'});
			}
		}
	else {
		# Changing user
		$self->delete_cron_job($self->{'oldjob'});
		if ($self->{'in_hash'}->{'where'}) {
			$self->insert_cron_job($self->{'job'});
			}
		else {
			$self->create_cron_job($self->{'job'});
			}
		}
	}
else {
	# Creating a new variable
	if ($self->{'in_hash'}->{'where'}) {
		$self->insert_cron_job($self->{'job'});
		}
	else {
		$self->create_cron_job($self->{'job'});
		}
	}

foreach $f (@{$self->{'files_array'}}) { $self->unlock_file($f); }
if ($self->{'in_hash'}->{'new'}) {
	$self->webmin_log("create", "env", $self->{'in_hash'}->{'user'}, \%{$self->{'in_hash'}});
	}
else {
	$self->webmin_log("modify", "env", $self->{'in_hash'}->{'user'}, \%{$self->{'in_hash'}});
	}
$self->redirect("");

1;
		
}


1;

