#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_cron.cgi
# Create, update or delete a cron job for fetchmail

&ModuleLoader::preload_module('fetchmail_class', "fetchmail::FetchmailLib");
$self = new fetchmail::FetchmailLib:: 'fetchmail_class',%$self;

$self->foreign_require("cron", "cron-lib.pl");
$self->{'access_hash'}->{'cron'} || $self->error($self->{'text_hash'}->{'cron_ecannot2'});
$self->error_setup($self->{'text_hash'}->{'cron_err'});
$self->ReadParse();

@{$self->{'jobs_array'}} = $main::cron_object->list_cron_jobs();
($self->{'job'}) = grep { $_->{'user'} eq $self->{'cron_user'} &&
		$_->{'command'} =~ /^$self->{'cron_cmd'}/ } @{$self->{'jobs_array'}};
	   
# Validate inputs
$self->{'cmd'} = $self->{'cron_cmd'};
if ($self->{'in_hash'}->{'output'} == 0) {
	$self->{'cmd'} .= " --null";
	}
elsif ($self->{'in_hash'}->{'output'} == 1) {
	$self->{'in_hash'}->{'file'} =~ /^\/.+$/ || $self->error($self->{'text_hash'}->{'cron_efile'});
	$self->{'cmd'} .= " --file ".quotemeta($self->{'in_hash'}->{'file'});
	}
elsif ($self->{'in_hash'}->{'output'} == 2) {
	$self->{'in_hash'}->{'mail'} =~ /^\S+$/ || $self->error($self->{'text_hash'}->{'cron_efile'});
	$self->{'cmd'} .= " --mail ".quotemeta($self->{'in_hash'}->{'mail'});
	}
elsif ($self->{'in_hash'}->{'output'} == 3) {
	$self->{'cmd'} .= " --output";
	}
elsif ($self->{'in_hash'}->{'output'} == 4) {
	$self->{'cmd'} .= " --owner";
	}
if ($self->{'in_hash'}->{'errors'}) {
	$self->{'cmd'} .= " --errors";
	}
if ($self->{'cron_user'} eq "root" && $self->{'fetchmail_config'}) {
	defined(getpwnam($self->{'in_hash'}->{'user'})) || $self->error($self->{'text_hash'}->{'cron_euser'});
	$self->{'cmd'} .= " --user $self->{'in_hash'}->{'user'}";
	}

if ($self->{'job'} && $self->{'in_hash'}->{'enabled'}) {
	# Update cron job
	$self->{'job'}->{'command'} = $self->{'cmd'};
	$main::cron_object->parse_times_input($self->{'job'}, \%{$self->{'in_hash'}});
	$self->lock_file($main::cron_object->cron_file($self->{'job'}));
	$main::cron_object->change_cron_job($self->{'job'});
	$self->{'what'} = "update";
	}
elsif (!$self->{'job'} && $self->{'in_hash'}->{'enabled'}) {
	# Create job
	$self->{'job'} = { 'user' => $self->{'cron_user'},
		 'command' => $self->{'cmd'},
		 'active' => 1 };
	$main::cron_object->parse_times_input($self->{'job'}, \%{$self->{'in_hash'}});
	$self->lock_file($self->{'cron_cmd'});
	$self->lock_file($main::cron_object->cron_file($self->{'job'}));
	$main::cron_object->create_cron_job($self->{'job'});
	$self->{'what'} = "create";
	}
elsif ($self->{'job'} && !$self->{'in_hash'}->{'enabled'}) {
	# Delete job
	$self->lock_file($main::cron_object->cron_file($self->{'job'}));
	$main::cron_object->delete_cron_job($self->{'job'});
	$self->{'what'} = "delete";
	}
$main::cron_object->create_wrapper($self->{'cron_cmd'}, $self->{'module_name'}, "check.pl");
$self->unlock_all_files();
$self->webmin_log($self->{'what'}, "cron");
$self->redirect("");

1;
		
}


1;

