#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_poll.cgi
# Update, create or delete a server to poll

&ModuleLoader::preload_module('fetchmail_class', "fetchmail::FetchmailLib");
$self = new fetchmail::FetchmailLib:: 'fetchmail_class',%$self;

$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'poll_err'});
if ($self->{'config_hash'}->{'config_file'}) {
	$self->{'file'} = $self->{'config_hash'}->{'config_file'};
	}
else {
	$self->can_edit_user($self->{'in_hash'}->{'user'}) || $self->error($self->{'text_hash'}->{'poll_ecannot'});
	@uinfo = getpwnam($self->{'in_hash'}->{'user'});
	$self->{'file'} = "$uinfo[7]/.fetchmailrc";
	}
@{$self->{'conf_array'}} = $self->parse_config_file($self->{'file'});
if (!$self->{'in_hash'}->{'new'}) {
	$self->{'poll'} = $self->{'conf_array'}->[$self->{'in_hash'}->{'idx'}];
	}

$self->lock_file($self->{'file'});
if ($self->{'in_hash'}->{'adduser'}) {
	# Go back to the edit form
	$self->redirect("edit_poll.cgi?file=$self->{'file'}&idx=$self->{'in_hash'}->{'idx'}&adduser=1&user=$self->{'in_hash'}->{'user'}");
	exit;
	}
elsif ($self->{'in_hash'}->{'check'}) {
	# Go to the mail checking CGI
	$self->redirect("check.cgi?file=$self->{'file'}&idx=$self->{'in_hash'}->{'idx'}&adduser=1&user=$self->{'in_hash'}->{'user'}");
	exit;
	}
elsif ($self->{'in_hash'}->{'delete'}) {
	# Just delete the poll
	$self->delete_poll($self->{'poll'}, $self->{'file'});
	}
else {
	# Validate poll inputs
	$self->{'in_hash'}->{'poll'} =~ /^\S+$/ || $self->error($self->{'text_hash'}->{'poll_epoll'});
	$self->{'in_hash'}->{'via_def'} || &check_host($self->{'in_hash'}->{'via'}) ||
		$self->error($self->{'text_hash'}->{'poll_evia'});
	!$self->{'in_hash'}->{'via_def'} || &check_host($self->{'in_hash'}->{'poll'}) ||
		$self->error($self->{'text_hash'}->{'poll_epoll'});
	$self->{'in_hash'}->{'port_def'} || $self->{'in_hash'}->{'port'} =~ /^\d+$/ ||
		$self->error($self->{'text_hash'}->{'poll_eport'});
	if (!$self->{'in_hash'}->{'interface_def'}) {
		$self->{'in_hash'}->{'interface'} =~ /^\S+$/ || $self->error($self->{'text_hash'}->{'poll_einterface'});
		$self->check_ipaddress($self->{'in_hash'}->{'interface_net'}) ||
			$self->error($self->{'text_hash'}->{'poll_enet'});
		$self->check_ipaddress($self->{'in_hash'}->{'interface_mask'}) ||
		    !$self->{'in_hash'}->{'interface_mask'} ||
			$self->error($self->{'text_hash'}->{'poll_emask'});
		}

	# Create the poll structure
	$self->{'poll'}->{'poll'} = $self->{'in_hash'}->{'poll'};
	$self->{'poll'}->{'skip'} = $self->{'in_hash'}->{'skip'};
	$self->{'poll'}->{'via'} = $self->{'in_hash'}->{'via_def'} ? undef : $self->{'in_hash'}->{'via'};
	$self->{'poll'}->{'proto'} = $self->{'in_hash'}->{'proto'};
	$self->{'poll'}->{'auth'} = $self->{'in_hash'}->{'auth'};
	$self->{'poll'}->{'port'} = $self->{'in_hash'}->{'port_def'} ? undef : $self->{'in_hash'}->{'port'};
	if ($self->{'in_hash'}->{'interface_def'}) {
		delete($self->{'poll'}->{'interface'});
		}
	else {
		local @interface = ( $self->{'in_hash'}->{'interface'}, $self->{'in_hash'}->{'interface_net'} );
		push(@interface, $self->{'in_hash'}->{'interface_mask'})
			if ($self->{'in_hash'}->{'interface_mask'});
		$self->{'poll'}->{'interface'} = join("/", @interface);
		}

	# Validate user inputs
	for($i=0; defined($self->{'in_hash'}->{"user_$i"}); $i++) {
		$self->{'user'} = $self->{'poll'}->{'users'}->[$i];
		next if (!$self->{'in_hash'}->{"user_$i"});
		$self->{'in_hash'}->{"user_$i"} =~ /^\S*$/ || $self->error($self->{'text_hash'}->{'poll_euser'});
		$self->{'user'}->{'user'} = $self->{'in_hash'}->{"user_$i"};
		$self->{'user'}->{'pass'} = $self->{'in_hash'}->{"pass_$i"};
		local @is = split(/\s+/, $self->{'in_hash'}->{"is_$i"});
		$self->{'user'}->{'is'} = \@is;
		$self->{'user'}->{'keep'} = $self->{'in_hash'}->{"keep_$i"};
		$self->{'user'}->{'fetchall'} = $self->{'in_hash'}->{"fetchall_$i"};
		if ($self->{'in_hash'}->{"keep_$i"} == 1 && $self->{'in_hash'}->{"fetchall_$i"} == 1) {
			$self->error($self->{'text_hash'}->{'poll_eboth'});
			}
		$self->{'user'}->{'ssl'} = $self->{'in_hash'}->{"ssl_$i"};
		$self->{'user'}->{'preconnect'} = $self->{'in_hash'}->{"preconnect_$i"};
		$self->{'user'}->{'postconnect'} = $self->{'in_hash'}->{"postconnect_$i"};
		push(@{$self->{'users_array'}}, $self->{'user'});
		}
	$self->{'poll'}->{'users'} = \@{$self->{'users_array'}};

	if ($self->{'in_hash'}->{'new'}) {
		$self->create_poll($self->{'poll'}, $self->{'file'});
		if ($self->{'in_hash'}->{'user'} && $< == 0) {
			local @uinfo = getpwnam($self->{'in_hash'}->{'user'});
			$self->system_logged("chown $uinfo[2]:$uinfo[3] $self->{'file'}");
			}
		$self->system_logged("chmod 700 $self->{'file'}");
		}
	else {
		$self->modify_poll($self->{'poll'}, $self->{'file'});
		}
	}

$self->unlock_file($self->{'file'});
$self->webmin_log($self->{'in_hash'}->{'new'} ? 'create' : $self->{'in_hash'}->{'delete'} ? 'delete' : 'modify',
	    'poll', $self->{'poll'}->{'poll'},
	    $self->{'config_hash'}->{'config_file'} ? { 'file' => $self->{'file'} }
				   : { 'user' => $self->{'in_hash'}->{'user'} } );
$self->redirect(!$self->{'fetchmail_config'} && $self->{'config_hash'}->{'view_mode'} ?
	"edit_user.cgi?user=$self->{'in_hash'}->{'user'}" : "");

1;
		
}

sub check_host
{
	shift if ($self == $_[0]);

return 1 if (gethostbyname($_[0]));
return 0 if (gethostbyname("www.webmin.com"));	# only fail if we are online
return 1;
}


1;

