#!/usr/bin/perl
package filter::AutoreplyfileLib;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'filter::AutoreplyfileLib');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# Functions for reading and writing autoreply files

1;

1;
		return $self;
}

# read_autoreply(file, &simple)
# Fills in the autoreply parts of a simple alias structure from a file
sub read_autoreply
{
	my $self = shift;

local ($file, $simple) = @_;
local @lines;
open(FILE, $file);
while(<FILE>) {
	if (/^Reply-Tracking:\s*(.*)/) {
		$simple->{'replies'} = $1;
		}
	elsif (/^Reply-Period:\s*(.*)/) {
		$simple->{'period'} = $1;
		}
	elsif (/^No-Autoreply:\s*(.*)/) {
		$simple->{'no_autoreply'} = $1;
		}
	elsif (/^No-Autoreply-Regexp:\s*(.*)/) {
		push(@{$simple->{'no_autoreply_regexp'}}, $1);
		}
	elsif (/^Autoreply-File:\s*(.*)/) {
		push(@{$simple->{'autoreply_file'}}, $1);
		}
	elsif (/^From:\s*(.*)/) {
		$simple->{'from'} = $1;
		}
	else {
		push(@lines, $_);
		}
	}
close(FILE);
$simple->{'autotext'} = join("", @lines);
}

# write_autoreply(&file, &simple)
# Writes the autoreply parts of a simple alias structure to a file
sub write_autoreply
{
	my $self = shift;

local ($file, $simple) = @_;
$self->open_tempfile(AUTO, ">$file");
if ($simple->{'replies'}) {
	$self->print_tempfile(AUTO,
		"Reply-Tracking: $simple->{'replies'}\n");
	}
if ($simple->{'period'}) {
	$self->print_tempfile(AUTO,
		"Reply-Period: $simple->{'period'}\n");
	}
if ($simple->{'no_autoreply'}) {
	$self->print_tempfile(AUTO,
		"No-Autoreply: $simple->{'no_autoreply'}\n");
	}
foreach my $r (@{$simple->{'no_autoreply_regexp'}}) {
	$self->print_tempfile(AUTO, "No-Autoreply-Regexp: $r\n");
	}
foreach my $f (@{$simple->{'autoreply_file'}}) {
	$self->print_tempfile(AUTO, "Autoreply-File: $f\n");
	}
if ($simple->{'from'}) {
	$self->print_tempfile(AUTO, "From: $simple->{'from'}\n");
	}
$self->print_tempfile(AUTO, $simple->{'autotext'});
$self->close_tempfile(AUTO);
}


1;

