#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Show details of one filter

&ModuleLoader::preload_module('filter_class', "filter::FilterLib");
$self = new filter::FilterLib:: 'filter_class',%$self;

$self->ReadParse();

# Show page header and get the filter
if ($self->{'in_hash'}->{'new'}) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'edit_title1'}, "");
	$self->{'filter'} = { 'actiondefault' => 1 };
	}
else {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'edit_title2'}, "");
	@{$self->{'filters_array'}} = $self->list_filters();
	($self->{'filter'}) = grep { $_->{'index'} == $self->{'in_hash'}->{'idx'} } @{$self->{'filters_array'}};
	}

@{$self->{'tds_array'}} = ( "nowrap width=30%", "width=70%" );
print $self->ui_form_start("save.cgi", "post");
print $self->ui_hidden("new", $self->{'in_hash'}->{'new'});
print $self->ui_hidden("idx", $self->{'in_hash'}->{'idx'});

# Start of condition section
$self->{'cmode'} = $self->{'filter'}->{'condspam'} ? 5 :
         $self->{'filter'}->{'condheader'} ? 4 :
	 $self->{'filter'}->{'condtype'} eq '<' ? 3 :
	 $self->{'filter'}->{'condtype'} eq '>' ? 2 :
	 $self->{'filter'}->{'cond'} ? 1 : 0;
print $self->ui_table_start($self->{'text_hash'}->{'edit_header1'}, "width=100%", 2);

# Always do action
print $self->ui_table_row(
	$self->ui_oneradio("cmode", 0, $self->{'text_hash'}->{'edit_cmode0'}, $self->{'cmode'} == 0),
	"", undef, \@{$self->{'tds_array'}});

# Is spam
print $self->ui_table_row(
	$self->ui_oneradio("cmode", 5, $self->{'text_hash'}->{'edit_cmode5'}, $self->{'cmode'} == 5),
	"", undef, \@{$self->{'tds_array'}});

# Check some header
@{$self->{'headers_array'}} = ( "From", "To", "Subject", "Cc" );
$self->{'common'} = $self->indexoflc($self->{'filter'}->{'condheader'}, @{$self->{'headers_array'}}) >= 0;
print $self->ui_table_row(
	$self->ui_oneradio("cmode", 4, $self->{'text_hash'}->{'edit_cmode4'}, $self->{'cmode'} == 4),
	$self->text('edit_cheader',
	      $self->ui_select("condmenu", $self->{'cmode'} != 4 ? "From" :
				     $self->{'common'} ? $self->{'filter'}->{'condheader'} : "",
			 [ (map { [ $_ ] } @{$self->{'headers_array'}}),
			   [ "", $self->{'text_hash'}->{'edit_other'} ] ],
			 1, 0, 0, 0,
			 "onChange='form.condheader.disabled = (form.condmenu.value!=\"\")'"),
	      $self->ui_textbox("condheader",
			  $self->{'common'} ? "" : $self->{'filter'}->{'condheader'}, 20,
			  $self->{'cmode'} != 4 || $self->{'common'}),
	      $self->ui_textbox("condvalue",
			  $self->{'filter'}->{'condvalue'}, 20)),
	undef, \@{$self->{'tds_array'}});

# Smaller
print $self->ui_table_row(
	$self->ui_oneradio("cmode", 3, $self->{'text_hash'}->{'edit_cmode3'}, $self->{'cmode'} == 3),
	$self->ui_bytesbox("condsmall", $self->{'cmode'} == 3 ? $self->{'filter'}->{'cond'} : ""),
	undef, \@{$self->{'tds_array'}});

# Larger
print $self->ui_table_row(
	$self->ui_oneradio("cmode", 2, $self->{'text_hash'}->{'edit_cmode2'}, $self->{'cmode'} == 2),
	$self->ui_bytesbox("condlarge", $self->{'cmode'} == 2 ? $self->{'filter'}->{'cond'} : ""),
	undef, \@{$self->{'tds_array'}});

# Matches regexp
print $self->ui_table_row(
	$self->ui_oneradio("cmode", 1, $self->{'text_hash'}->{'edit_cmode1'}, $self->{'cmode'} == 1),
	$self->ui_textbox("cond", $self->{'cmode'} == 1 ? $self->{'filter'}->{'cond'} : "", 70)."<br>".
	$self->ui_checkbox("body", 1, $self->{'text_hash'}->{'edit_cbody'}, $self->{'filter'}->{'body'}),
	undef, \@{$self->{'tds_array'}});

print $self->ui_table_end();

# Start of action section
$self->{'amode'} = $self->{'filter'}->{'actionreply'} ? 6 :
	 $self->{'filter'}->{'actionspam'} ? 5 :
	 $self->{'filter'}->{'actionthrow'} ? 4 :
	 $self->{'filter'}->{'actiondefault'} ? 3 :
	 $self->{'filter'}->{'actionreply'} ? 2 :
	 $self->{'filter'}->{'actiontype'} eq '!' ? 1 : 0;
print $self->ui_table_start($self->{'text_hash'}->{'edit_header2'}, "width=100%", 2);

# Deliver normally
print $self->ui_table_row(
	$self->ui_oneradio("amode", 3, $self->{'text_hash'}->{'edit_amode3'}, $self->{'amode'} == 3),
	"", undef, \@{$self->{'tds_array'}});

if ($self->{'amode'} == 5 || $self->has_spamassassin()) {
	# Run spamassassin
	print $self->ui_table_row(
		$self->ui_oneradio("amode", 5, $self->{'text_hash'}->{'edit_amode5'}, $self->{'amode'} == 5),
		"", undef, \@{$self->{'tds_array'}});
	}

# Throw away
print $self->ui_table_row(
	$self->ui_oneradio("amode", 4, $self->{'text_hash'}->{'edit_amode4'}, $self->{'amode'} == 4),
	"", undef, \@{$self->{'tds_array'}});

# Forward to some address
print $self->ui_table_row(
	$self->ui_oneradio("amode", 1, $self->{'text_hash'}->{'edit_amode1'}, $self->{'amode'} == 1),
	$self->ui_textbox("forward", $self->{'amode'} == 1 ? $self->{'filter'}->{'action'} : "", 70),
	undef, \@{$self->{'tds_array'}});

# Save to a folder or file
@{$self->{'folders_array'}} = grep { $_->{'file'} } $main::mailbox_object->list_folders();
if ($self->{'amode'} == 0) {
	$self->{'folder'} = $self->file_to_folder($self->{'filter'}->{'action'}, \@{$self->{'folders_array'}});
	}
else {
	$self->{'folder'} = $self->{'folders_array'}->[0];
	}
print $self->ui_table_row(
	$self->ui_oneradio("amode", 0, $self->{'text_hash'}->{'edit_amode0'}, $self->{'amode'} == 0),
	$self->ui_select("folder", $self->{'folder'} ? $main::mailbox_object->folder_name($self->{'folder'}) : "",
		   [ (map { [ $main::mailbox_object->folder_name($_), $_->{'name'} ] }
			  @{$self->{'folders_array'}}),
		     [ "", $self->{'text_hash'}->{'edit_file'} ] ],
		   1, 0, 0, 0,
                   "onChange='form.file.disabled = (form.folder.value!=\"\")'").
		   "\n".
	$self->ui_textbox("file", $self->{'folder'} ? "" : $self->{'filter'}->{'action'}, 50,
		    $self->{'folder'} ? 1 : 0),
	undef, \@{$self->{'tds_array'}});

# Save to a new folder
print $self->ui_table_row(
	$self->ui_oneradio("amode", 7, $self->{'text_hash'}->{'edit_amode7'}, 0),
	$self->ui_textbox("newfolder", undef, 20),
	undef, \@{$self->{'tds_array'}});

# Send autoreply
if ($self->{'amode'} == 6) {
	$self->{'r'} = $self->{'filter'}->{'reply'};
	$self->{'period'} = $self->{'r'}->{'replies'} && $self->{'r'}->{'period'} ? int($self->{'r'}->{'period'}/60) :
		  $self->{'r'}->{'replies'} ? 60 : undef;
	}
print $self->ui_table_row(
	$self->ui_oneradio("amode", 6, $self->{'text_hash'}->{'edit_amode6'}, $self->{'amode'} == 6),
	$self->ui_textarea("reply", $self->{'filter'}->{'reply'}->{'autotext'}, 5, 60)."<br>".
	"<b>$self->{'text_hash'}->{'index_period'}</b> ".
	  $self->ui_opt_textbox("period", $self->{'period'}, 3,
			  $self->{'text_hash'}->{'index_noperiod'})." ".$self->{'text_hash'}->{'index_mins'},
	undef, \@{$self->{'tds_array'}});

# Continue checkbox
print $self->ui_table_row(
	undef, $self->ui_checkbox("continue", 1, $self->{'text_hash'}->{'edit_continue'},
			    $self->{'filter'}->{'continue'}), 2);

print $self->ui_table_end();

# End of the form, with buttons
if ($self->{'in_hash'}->{'new'}) {
	print $self->ui_form_end([ [ "create", $self->{'text_hash'}->{'create'} ] ]);
	}
else {
	print $self->ui_form_end([ [ "save", $self->{'text_hash'}->{'save'} ],
			     [ "delete", $self->{'text_hash'}->{'delete'} ] ]);
	}

# Show page footer
$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

