#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Show a table of simple actions

&ModuleLoader::preload_module('filter_class', "filter::FilterLib");
$self = new filter::FilterLib:: 'filter_class',%$self;

$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", undef, 0, 1);

# Warn if procmail is not installed
if ($self->{'config_hash'}->{'warn_procmail'} && !$self->has_command("procmail")) {
	print "$self->{'text_hash'}->{'index_warn'}<p>\n";
	}

# Check for an override alias
$self->{'alias'} = $self->get_override_alias();
if ($self->{'alias'}) {
	# Got one .. but does it deliver locally
	$self->{'noat'} = $self->{'remote_user'};
	$self->{'noat'} =~ s/\@/-/g;
	@{$self->{'values_array'}} = @{$self->{'alias'}->{'values'}};
	($self->{'tome'}) = grep { $_ eq "\\$self->{'remote_user'}" ||
			 $_ eq "\\$self->{'noat'}" } @{$self->{'values_array'}};
	if ($self->{'tome'}) {
		@{$self->{'values_array'}} = grep { $_ ne $self->{'tome'} } @{$self->{'values_array'}};
		$self->{'msg'} = 'index_aliasme';
		}
	else {
		$self->{'msg'} = 'index_alias';
		}
	print $self->{'text_hash'}->{$self->{'msg'}},"<br>\n";
	print "<ul>\n";
	foreach $dest ($self->describe_alias_dest(\@{$self->{'values_array'}})) {
		print "<li>$dest\n";
		}
	print "</ul>\n";
	}

@{$self->{'filters_array'}} = $self->list_filters();
@{$self->{'links_array'}} = ( $self->select_all_link("d"), $self->select_invert_link("d"),
	   "<a href='edit.cgi?new=1'>$self->{'text_hash'}->{'index_add'}</a>" );

@{$self->{'folders_array'}} = $main::mailbox_object->list_folders();
if (@{$self->{'filters_array'}}) {
	# Show table of filters
	print $self->ui_form_start("delete.cgi", "post");
	@{$self->{'tds_array'}} = ( "width=5", "width=50%", "width=50%", "width=32" );
	print $self->ui_links_row(\@{$self->{'links_array'}});
	print $self->ui_columns_start([ "",
				  $self->{'text_hash'}->{'index_condition'},
				  $self->{'text_hash'}->{'index_action'},
				  @{$self->{'filters_array'}} > 1 ? ( $self->{'text_hash'}->{'index_move'} ) : ( ),
				], 100, 0, \@{$self->{'tds_array'}});

	# Add a magic non-editable row for global spamassassin run
	if ($self->get_global_spamassassin()) {
		print $self->ui_columns_row(
			[ "", $self->{'text_hash'}->{'index_calways'}, $self->{'text_hash'}->{'index_aspam'},
			  @{$self->{'filters_array'}} > 1 ? ( "" ) : ( ) ],
			\@{$self->{'tds_array'}});
		}

	# Show editable rows
	foreach $f (@{$self->{'filters_array'}}) {
		# Work out nice condition and action descriptions
		local $cond;
		($cond, $self->{'lastalways'}) = $self->describe_condition($f);
		$cond = "<a href='edit.cgi?idx=$f->{'index'}'>$cond</a>";
		local $action = $self->describe_action($f, \@{$self->{'folders_array'}});

		# Create mover links
		local $mover;
		if ($f eq $self->{'filters_array'}->[0]) {
			$mover .= "<img src=images/gap.gif>";
			}
		else {
			$mover .= "<a href='up.cgi?idx=$f->{'index'}'>".
			      "<img src=images/up.gif border=0></a>";
			}
		if ($f eq $self->{'filters_array'}->[$#{$self->{'filters_array'}}]) {
			$mover .= "<img src=images/gap.gif>";
			}
		else {
			$mover .= "<a href='down.cgi?idx=$f->{'index'}'>".
			      "<img src=images/down.gif border=0></a>";
			}

		# Show the row
		print $self->ui_checked_columns_row(
			[ $cond,
			  $action,
			  @{$self->{'filters_array'}} > 1 ? ( $mover ) : ( ) ],
			\@{$self->{'tds_array'}}, "d", $f->{'index'}
			);

		}

	# Add a magic non-editable row for default delivery
	if (!$self->{'lastalways'}) {
		print $self->ui_columns_row(
			[ "", $self->{'text_hash'}->{'index_calways'}, $self->{'text_hash'}->{'index_adefault'},
			  @{$self->{'filters_array'}} > 1 ? ( "" ) : ( ) ],
			\@{$self->{'tds_array'}});
		}

	print $self->ui_columns_end();
	print $self->ui_links_row(\@{$self->{'links_array'}});
	print $self->ui_form_end([ [ "delete", $self->{'text_hash'}->{'index_delete'} ] ]);
	}
else {
	# Tell the user there are none
	@{$self->{'pmrc_array'}} = $main::procmail_object->get_procmailrc();
	if (@{$self->{'pmrc_array'}}) {
		print "<b>$self->{'text_hash'}->{'index_none2'}</b><p>\n";
		}
	elsif ($self->get_global_spamassassin()) {
		print "<b>$self->{'text_hash'}->{'index_none3'}</b><p>\n";
		}
	else {
		print "<b>$self->{'text_hash'}->{'index_none'}</b><p>\n";
		}
	shift(@{$self->{'links_array'}});
	shift(@{$self->{'links_array'}});
	print $self->ui_links_row(\@{$self->{'links_array'}});
	}

$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});

1;
		
}


1;

