#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Create, update or delete a filter

&ModuleLoader::preload_module('filter_class', "filter::FilterLib");
$self = new filter::FilterLib:: 'filter_class',%$self;

$self->ReadParse();

# Find existing filter object
$self->lock_file($main::procmail_object->{'procmailrc'});
@{$self->{'filters_array'}} = $self->list_filters();
if (!$self->{'in_hash'}->{'new'}) {
	($self->{'filter'}) = grep { $_->{'index'} == $self->{'in_hash'}->{'idx'} } @{$self->{'filters_array'}};
	}
else {
	$self->{'filter'} = { 'index' => scalar(@{$self->{'filters_array'}}) };
	}

if ($self->{'in_hash'}->{'delete'}) {
	# Just remove
	$self->delete_filter($self->{'filter'});
	}
else {
	# Validate and store inputs
	$self->error_setup($self->{'text_hash'}->{'save_err'});

	# Parse condition first
	delete($self->{'filter'}->{'condspam'});
	delete($self->{'filter'}->{'condheader'});
	delete($self->{'filter'}->{'condtype'});
	delete($self->{'filter'}->{'cond'});
	$self->{'filter'}->{'body'} = 0;
	if ($self->{'in_hash'}->{'cmode'} == 0) {
		# Always enabled, so nothing to set!
		}
	elsif ($self->{'in_hash'}->{'cmode'} == 5) {
		# Need to run spamassassin
		$self->{'filter'}->{'condspam'} = 1;
		}
	elsif ($self->{'in_hash'}->{'cmode'} == 4) {
		# Check some header
		$self->{'filter'}->{'condheader'} = $self->{'in_hash'}->{'condmenu'} || $self->{'in_hash'}->{'condheader'};
		$self->{'filter'}->{'condheader'} =~ /^[a-zA-Z0-9\-]+$/ ||
			$self->error($self->{'text_hash'}->{'save_econdheader'});
		$self->{'filter'}->{'condvalue'} = $self->{'in_hash'}->{'condvalue'};
		}
	elsif ($self->{'in_hash'}->{'cmode'} == 3) {
		# Smaller than some size
		$self->{'in_hash'}->{'condsmall'} =~ /^\d+$/ || $self->error($self->{'text_hash'}->{'save_esmall'});
		$self->{'filter'}->{'cond'} = $self->{'in_hash'}->{'condsmall'}*$self->{'in_hash'}->{'condsmall_units'};
		$self->{'filter'}->{'condtype'} = '<';
		}
	elsif ($self->{'in_hash'}->{'cmode'} == 2) {
		# Larger than some size
		$self->{'in_hash'}->{'condlarge'} =~ /^\d+$/ || $self->error($self->{'text_hash'}->{'save_elarge'});
		$self->{'filter'}->{'cond'} = $self->{'in_hash'}->{'condlarge'}*$self->{'in_hash'}->{'condlarge_units'};
		$self->{'filter'}->{'condtype'} = '>';
		}
	elsif ($self->{'in_hash'}->{'cmode'} == 1) {
		# Matches regexp
		$self->{'in_hash'}->{'cond'} || $self->error($self->{'text_hash'}->{'save_econd'});
		$self->{'filter'}->{'cond'} = $self->{'in_hash'}->{'cond'};
		$self->{'filter'}->{'body'} = $self->{'in_hash'}->{'body'};
		}

	# Parse action section
	delete($self->{'filter'}->{'actionreply'});
	delete($self->{'filter'}->{'actionspam'});
	delete($self->{'filter'}->{'actionthrow'});
	delete($self->{'filter'}->{'actiondefault'});
	delete($self->{'filter'}->{'actionreply'});
	delete($self->{'filter'}->{'actiontype'});
	delete($self->{'filter'}->{'continue'});
	if ($self->{'in_hash'}->{'amode'} == 3) {
		# Deliver normally
		$self->{'filter'}->{'actiondefault'} = 1;
		}
	elsif ($self->{'in_hash'}->{'amode'} == 5) {
		# Run spamassassin
		$self->{'filter'}->{'actionspam'} = 1;
		}
	elsif ($self->{'in_hash'}->{'amode'} == 4) {
		# Throw away
		$self->{'filter'}->{'actionthrow'} = 1;
		}
	elsif ($self->{'in_hash'}->{'amode'} == 1) {
		# Forward to an address
		$self->{'in_hash'}->{'forward'} =~ /^\S+$/ || $self->error($self->{'text_hash'}->{'save_eforward'});
		$self->{'filter'}->{'action'} = $self->{'in_hash'}->{'forward'};
		$self->{'filter'}->{'actiontype'} = '!';
		}
	elsif ($self->{'in_hash'}->{'amode'} == 0) {
		# Write to a folder or file
		@{$self->{'folders_array'}} = $main::mailbox_object->list_folders();
		if ($self->{'in_hash'}->{'folder'}) {
			$self->{'folder'} = $main::mailbox_object->find_named_folder($self->{'in_hash'}->{'folder'},
							      \@{$self->{'folders_array'}});
			$self->{'file'} = $self->{'folder'}->{'file'};
			}
		else {
			$self->{'in_hash'}->{'file'} =~ /\S/ || $self->error($self->{'text_hash'}->{'save_efile'});
			$self->{'file'} = $self->{'in_hash'}->{'file'};
			}
		$self->{'file'} =~ s/^\Q$self->{'remote_user_info_array'}->[7]\/\E/\$HOME\//;
		$self->{'filter'}->{'action'} = $self->{'file'};
		if ($self->{'folder'}->{'type'} == 1) {
			# Maildir has to end with /
			$self->{'filter'}->{'action'} .= '/';
			}
		}
	elsif ($self->{'in_hash'}->{'amode'} == 6) {
		# Send autoreply
		$self->{'filter'}->{'actionreply'} = 1;
		$self->{'in_hash'}->{'reply'} =~ /\S/ || $self->error($self->{'text_hash'}->{'save_ereply'});
		$self->{'in_hash'}->{'reply'} =~ s/\r//g;
		$self->{'filter'}->{'reply'}->{'autotext'} = $self->{'in_hash'}->{'reply'};
		($self->{'froms'}, $self->{'doms'}) = $main::mailbox_object->list_from_addresses();
		$self->{'filter'}->{'reply'}->{'from'} = $self->{'froms'}->[0];
		$self->{'filter'}->{'reply'}->{'autoreply'} ||=
			"$self->{'remote_user_info_array'}->[7]/autoreply.$self->{'filter'}->{'index'}.txt";
		if ($self->{'in_hash'}->{'period_def'}) {
			# No autoreply period
			delete($self->{'filter'}->{'reply'}->{'replies'});
			delete($self->{'filter'}->{'reply'}->{'period'});
			}
		else {
			# Set reply period and tracking file
			$self->{'in_hash'}->{'period'} =~ /^\d+$/ ||
				$self->error($self->{'text_hash'}->{'save_eperiod'});
			$self->{'filter'}->{'reply'}->{'period'} = $self->{'in_hash'}->{'period'}*60;
			$self->{'filter'}->{'reply'}->{'replies'} ||=
				"$user_module_config_directory/replies";
			}
		}
	elsif ($self->{'in_hash'}->{'amode'} == 7) {
		# Create a new folder for saving (always in Maildir format)
		$self->{'in_hash'}->{'newfolder'} =~ /\S/ || $self->error($self->{'text_hash'}->{'save_enewfolder'});
		$self->{'in_hash'}->{'newfolder'} !~ /^\// && $self->{'in_hash'}->{'newfolder'} !~ /\.\./ ||
			$self->error($self->{'text_hash'}->{'save_enewfolder2'});
		($self->{'clash'}) = grep { $_->{'name'} eq $self->{'in_hash'}->{'newfolder'} } 
				@{$self->{'folders_array'}};
		$self->{'clash'} && $self->error($self->{'text_hash'}->{'save_enewfolder3'});
		$self->{'folder'} = { 'name' => $self->{'in_hash'}->{'newfolder'},
			    'mode' => 0,
			    'type' => 1 };
		$main::mailbox_object->save_folder($self->{'folder'});
		$self->{'filter'}->{'action'} = $self->{'folder'}->{'file'}."/";
		$self->{'filter'}->{'action'} =~ s/^\Q$self->{'remote_user_info_array'}->[7]\/\E/\$HOME\//;
		}
	$self->{'filter'}->{'continue'} = $self->{'in_hash'}->{'continue'};

	# Save or create
	if ($self->{'in_hash'}->{'new'}) {
		$self->create_filter($self->{'filter'});
		}
	else {
		$self->modify_filter($self->{'filter'});
		}
	}
$self->unlock_file($main::procmail_object->{'procmailrc'});
$self->redirect("");
1;
		
}


1;

