#!/usr/bin/perl
package forward::ForwardLib;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'forward::ForwardLib');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# forward-lib.pl
# Common functions for editing .forward

&ModuleLoader::preload_module(ref($self), "WebLib");
$self = new WebLib:: ref($self), %$self; 
$self->init_config();
&ModuleLoader::preload_module(ref($self), "UiLib");
$self = new UiLib:: ref($self), %$self; 
&ModuleLoader::preload_module(ref($self), "forward::AutoreplyfileLib");
$self = new forward::AutoreplyfileLib:: ref($self), %$self; 

# Copy scripts to /etc/usermin and set up smrsh if needed while we still can
# (before a user switch)
foreach $script ("autoreply.pl", "filter.pl") {
	 $self->{'rpath'} = "$self->{'module_root_directory'}/$script";
	 $self->{'cpath'} = "$self->{'module_config_directory'}/$script";
	 @{$self->{'rst_array'}} = stat($self->{'rpath'});
	 @{$self->{'cst_array'}} = stat($self->{'cpath'});
	if (!@{$self->{'cst_array'}} || $self->{'cst_array'}->[7] != $self->{'rst_array'}->[7]) {
		system("cp $self->{'rpath'} $self->{'cpath'}");
		}
	if ($self->{'config_hash'}->{'smrsh_dir'} && !-r "$self->{'config_hash'}->{'smrsh_dir'}/$script") {
		symlink($self->{'cpath'}, "$self->{'config_hash'}->{'smrsh_dir'}/$script");
		}
	}

# If vacation is installed, link it from /etc/smrsh too
$self->{'vacation_path'} = $self->has_command("vacation");
if ($self->{'vacation_path'}) {
	if ($self->{'config_hash'}->{'smrsh_dir'} && !-r "$self->{'config_hash'}->{'smrsh_dir'}/vacation") {
		symlink($self->{'vacation_path'}, "$self->{'config_hash'}->{'smrsh_dir'}/vacation");
		}
	}

$self->switch_to_remote_user();
$self->create_user_config_dirs();

$self->{'forward_file'} = "$self->{'remote_user_info_array'}->[7]/.forward";
$self->foreign_require("mailbox", "mailbox-lib.pl");
$self->{'mail_path'} = $main::mailbox_object->mailbox_file();

1;

1;
		return $self;
}

# list_aliases()
# Returns an array of data structures, each containing information about
# one sendmail alias from .forward
sub list_aliases
{
	my $self = shift;

local($lnum, @rv, $file, $lalias);
$lnum = 0;
open(AFILE, $self->{'forward_file'});
while(<AFILE>) {
	s/\r|\n//g;	# remove newlines
	if (/^(#*)\s*(.*)$/) {
		local(%alias, @values, $v);
		$alias{'eline'} = $alias{'line'} = $lnum;
		$alias{'file'} = $self->{'forward_file'};
		$alias{'enabled'} = $1 ? 0 : 1;
		$v = $alias{'value'} = $2;
		while($v =~ /^\s*,?\s*()"([^"]+)"(.*)$/ ||
		      $v =~ /^\s*,?\s*(\|)"([^"]+)"(.*)$/ ||
		      $v =~ /^\s*,?\s*()([^,\s]+)(.*)$/) {
			push(@values, $1.$2); $v = $3;
			}
		$alias{'values'} = \@values;
		$alias{'num'} = scalar(@rv);
		if ($self->indexof($alias{'name'}, @{$self->{'skip_array'}}) < 0) {
			push(@rv, \%alias);
			$lalias = \%alias;
			}
		}
	elsif (/^(#*)\s+(\S.*)$/ && $lalias &&
	       ($1 && !$lalias->{'enabled'} ||
		!$1 && $lalias->{'enabled'})) {
		# continuation of last alias
		$lalias->{'eline'} = $lnum;
		local $v = $2;
		$lalias->{'value'} .= $v;
		while($v =~ /^\s*,?\s*()"([^"]+)"(.*)$/ ||
		      $v =~ /^\s*,?\s*(\|)"([^"]+)"(.*)$/ ||
		      $v =~ /^\s*,?\s*()([^,\s]+)(.*)$/) {
			push(@{$lalias->{'values'}}, $1.$2); $v = $3;
			}
		}
	else { $lalias = undef; }
	$lnum++;
	}
close(AFILE);
return @rv;
}

# alias_form([alias])
# Display a form for editing or creating an alias. Each alias can map to
# 1 or more programs, files, lists or users
sub alias_form
{
	my $self = shift;

local($a, @values, $v, $type, $val, @typenames);

$a = $_[1];
if ($a) { @values = @{$a->{'values'}}; }
@typenames = map { $self->{'text_hash'}->{"aform_type$_"} } (0 .. 8);
$typenames[0] = "&lt;$typenames[0]&gt;";

my @js; for($i=0; $i<=@values; $i++) {
	($type, $val) = $values[$i] ? $self->alias_type($values[$i]) : (0, "");
	push @js,"document.forms[0].val_$i.disabled=".(($type==0||$type==7||$type==8)?"true":"false")
	}

$self->ui_print_header(undef, $_[0],"", undef, undef, undef, undef, undef,undef, "onload=\"".join(";",@js)."\"");
print "<form method=post action=save_alias.cgi name=edit_aliases>\n";
if ($a) {
	print "<input type=hidden name=num value='$a->{'num'}'>\n";
	print "<input type=hidden name=file value='$a->{'file'}'>\n";
	}
else { print "<input type=hidden name=new value=1>\n"; }
print "<table border>\n";
print "<tr $self->{'tb'}> <td><b>",$a ? $self->{'text_hash'}->{'aform_edit'}
			    : $self->{'text_hash'}->{'aform_create'},"</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table>\n";
if ($self->{'config_hash'}->{'mail_system'} == 0) {
	print "<tr> <td><b>$self->{'text_hash'}->{'aform_enabled'}</b></td>\n";
	printf "<td><input type=radio name=enabled value=1 %s> $self->{'text_hash'}->{'yes'}\n",
		!$a || $a->{'enabled'} ? "checked" : "";
	printf "<input type=radio name=enabled value=0 %s> $self->{'text_hash'}->{'no'}</td></tr>\n",
		!$a || $a->{'enabled'} ? "" : "checked";
	}
else {
	print "<tr> <td><b>$self->{'text_hash'}->{'aform_name'}</b></td>\n";
	printf "<td><input type=radio name=name_def value=1 %s> <tt>%s</tt>\n",
		$a->{'name'} ? '' : 'checked', $self->{'remote_user'};
	print "&nbsp;" x 3;
	printf "<input type=radio name=name_def value=0 %s> <tt>%s-</tt>",
		$a->{'name'} ? 'checked' : '', $self->{'remote_user'};
	printf "<input name=name size=20 value='%s'></td> </tr>\n",
		$a->{'name'};
	}

local %types = map { $_, 1 } split(/\,/, $self->{'config_hash'}->{'types'});
$types{8} = $types{5};
for($i=0; $i<=@values; $i++) {
	($type, $val) = $values[$i] ? $self->alias_type($values[$i]) : (0, "");
	print "<tr> <td valign=top><b>$self->{'text_hash'}->{'aform_val'}</b></td>\n";
	print "<td><select name=type_$i onchange=\"".
		"document.forms[0].val_$i.disabled=(this.value=='0'||this.value=='7'||this.value=='8');\">\n";
	for($j=0; $j<@typenames; $j++) {
		next if ($j == 2 && $self->{'config_hash'}->{'mail_system'} == 1);
		next if ($j == 7 && $self->{'config_hash'}->{'mail_system'} == 1 && !$self->{'mail_path'});
		next if ($j == 8 && !$self->{'vacation_path'});
		next if ($j && !$types{$j});
		printf "<option value=$j %s>$typenames[$j]\n",
			$type == $j ? "selected" : "";
		}
	print "</select>\n";
	print "<input name=val_$i size=30 value=\"$val\">\n";
	local $lnk = $self->{'config_hash'}->{'mail_system'} == 1 ? "file=$a->{'file'}"
						 : "num=$a->{'num'}";
	if ($type == 2 && $a) {
		print "<a href='edit_afile.cgi?$lnk&vfile=$val'>",
		      "$self->{'text_hash'}->{'aform_afile'}</a>\n";
		}
	elsif ($type == 5 && $a) {
		print "<a href='edit_rfile.cgi?$lnk&vfile=$val'>",
		      "$self->{'text_hash'}->{'aform_afile'}</a>\n";
		}
	elsif ($type == 6 && $a) {
		print "<a href='edit_ffile.cgi?$lnk&vfile=$val'>",
		      "$self->{'text_hash'}->{'aform_afile'}</a>\n";
		}
	elsif ($type == 8 && $a) {
		print "<a href='edit_vacation.cgi?$lnk&idx=$i'>$self->{'text_hash'}->{'aform_vacation'}</a>\n";
		}
	print "</td></tr>\n";
	}
print "<tr> <td colspan=2 align=right>\n";
if ($a) {
	print "<input type=submit value=$self->{'text_hash'}->{'save'}>\n";
	print "<input type=submit name=delete value=$self->{'text_hash'}->{'delete'}>\n";
	}
else { print "<input type=submit value=$self->{'text_hash'}->{'create'}>\n"; }
print "</td> </tr>\n";
print "</table></td></tr></table></form>\n";
$self->ui_print_footer("index.cgi?simple=0", $self->{'text_hash'}->{'index_return'});
}

# create_alias(&details)
# Create a new alias
sub create_alias
{
	my $self = shift;

if ($self->{'config_hash'}->{'mail_system'} == 0) {
	$self->open_tempfile(AFILE, ">>$self->{'forward_file'}");
	$self->print_tempfile(AFILE, $_[0]->{'enabled'} ? "" : "# ",
	    join(',', map { /\s/ ? "\"$_\"" : $_ } @{$_[0]->{'values'}}),"\n");
	$self->close_tempfile(AFILE);
	$self->set_forward_perms();
	}
else {
	$self->open_tempfile(AFILE, ">$self->{'remote_user_info_array'}->[7]/".
		($_[0]->{'name'} ? ".qmail-$_[0]->{'name'}" : ".qmail"));
	foreach $v (@{$_[0]->{'values'}}) {
		$self->print_tempfile(AFILE, $v,"\n");
		}
	$self->close_tempfile(AFILE);
	}
}

# delete_alias(&details)
sub delete_alias
{
	my $self = shift;

if ($self->{'config_hash'}->{'mail_system'} == 0) {
	local $lref = $self->read_file_lines($_[0]->{'file'});
	local $len = $_[0]->{'eline'} - $_[0]->{'line'} + 1;
	splice(@$lref, $_[0]->{'line'}, $len);
	$self->flush_file_lines();
	}
else {
	unlink("$self->{'remote_user_info_array'}->[7]/$_[0]->{'file'}");
	}
}

# modify_alias(&old, &details)
# Update some existing alias
sub modify_alias
{
	my $self = shift;

if ($self->{'config_hash'}->{'mail_system'} == 0) {
	local $str = ($_[1]->{'enabled'} ? "" : "# ") .
		     join(',', map { /\s/ ? "\"$_\"" : $_ } @{$_[1]->{'values'}});
	local $lref = $self->read_file_lines($_[0]->{'file'});
	local $len = $_[0]->{'eline'} - $_[0]->{'line'} + 1;
	splice(@$lref, $_[0]->{'line'}, $len, $str);
	$self->flush_file_lines();
	}
else {
	$self->delete_alias($_[0]);
	$self->create_alias($_[1]);
	}
}

# alias_type(string)
# Return the type and destination of some alias string
sub alias_type
{
	my $self = shift;

local @rv;
if ($_[0] =~ /^\|($self->{'user_module_config_directory'}|$self->{'module_config_directory'})\/autoreply.pl\s+(\S+)/) {
	@rv = (5, $2);
	}
elsif ($_[0] =~ /^\|($self->{'user_module_config_directory'}|$self->{'module_config_directory'})\/filter.pl\s+(\S+)/) {
	@rv = (6, $2);
	}
elsif ($self->{'vacation_path'} && $_[0] =~ /^\|$self->{'vacation_path'}\s*(.*)/) {
	@rv = (8, $1);
	}
elsif ($_[0] =~ /^\|(.*)$/) {
	@rv = (4, $1);
	}
elsif ($_[0] eq $self->{'mail_path'}) {
	@rv = (7, undef);
	}
elsif ($_[0] =~ /^(\..*)$/ && $self->{'config_hash'}->{'mail_system'} == 1) {
	@rv = (3, $1);
	}
elsif ($_[0] =~ /^(\/.*)$/) {
	@rv = (3, $1);
	}
elsif ($_[0] =~ /^:include:(.*)$/ && $self->{'config_hash'}->{'mail_system'} == 0) {
	@rv = (2, $1);
	}
elsif ($_[0] =~ /^\\($self->{'remote_user'})$/ && $self->{'config_hash'}->{'mail_system'} == 0) {
	@rv = (7, undef);
	}
elsif ($self->{'remote_user'} =~ /^(\S+)\@(\S+)$/ &&
       $_[0] eq "\\$1-$2" && $self->{'config_hash'}->{'mail_system'} == 0) {
	# Virtualmin created user for Postfix when username contains @
	@rv = (7, undef);
	}
elsif ($_[0] =~ /^&(.*)$/) {
	@rv = (1, $1);
	}
else {
	@rv = (1, $_[0]);
	}
return wantarray ? @rv : $rv[0];
}

# list_dotqmails()
# Returns a list of .qmail* files in the user's home directory
sub list_dotqmails
{
	my $self = shift;

local @rv;
opendir(DIR, $self->{'remote_user_info_array'}->[7]);
while($self->{'f'} = readdir(DIR)) {
	next if ($self->{'f'} !~ /^\.qmail(-(\S+))?$/);
	push(@rv, $self->get_dotqmail($self->{'f'}));
	}
closedir(DIR);
return @rv;
}

sub get_dotqmail
{
	my $self = shift;

$_[0] =~ /^\.qmail(-(\S+))?$/;
local $alias = { 'file' => $_[0],
		 'name' => $2 };
open(AFILE, "$self->{'remote_user_info_array'}->[7]/$_[0]");
while(<AFILE>) {
	s/\r|\n//g;
	s/#.*$//g;
	if (/\S/) {
		push(@{$alias->{'values'}}, $_);
		}
	}
close(AFILE);
return $alias;
}

sub set_forward_perms
{
	my $self = shift;

chmod(0644, $self->{'forward_file'});
}

sub make_absolute
{
	my $self = shift;

if ($_[0] =~ /^\//) {
	return $_[0];
	}
else {
	return "$self->{'remote_user_info_array'}->[7]/$_[0]";
	}
}

sub make_relative
{
	my $self = shift;

if ($_[0] =~ /^\Q$self->{'remote_user_info_array'}->[7]\/\E(.*)$/) {
	return $1;
	}
else {
	return $_[0];
	}
}

# get_simple()
# If the current forwarding rules are simple (local delivery, autoreply
# and forwarding only), return a hash ref containing the settings. Otherwise,
# return undef.
sub get_simple
{
	my $self = shift;

local @aliases = $self->list_aliases();
local $simple;
foreach my $a (@aliases) {
	foreach my $v (@{$a->{'values'}}) {
		local ($atype, $aval) = $self->alias_type($v);
		if ($atype == 1) {
			# Forward to an address
			return undef if ($simple->{'forward'});
			$simple->{'forward'} = $aval;
			}
		elsif ($atype == 7) {
			# Local delivery
			$simple->{'local'} = 1;
			}
		elsif ($atype == 5) {
			# Usermin autoreply program
			return undef if ($simple->{'autoreply'});
			$simple->{'autoreply'} = $self->make_absolute($aval);
			$simple->{'auto'} = 1;
			$self->read_autoreply($simple->{'autoreply'}, $simple);
			}
		else {
			# Some un-supported rule
			return undef;
			}
		}
	}
$simple ||= { 'local' => 1 };	# if no settings, assume local delivery
if (!$simple->{'autoreply'}) {
	# Get autoreply message from default file
	$simple->{'autoreply'} = $self->make_absolute("autoreply.txt");
	$self->read_autoreply($simple->{'autoreply'}, $simple);
	}
return $simple;
}

# save_simple(&simple)
# Creates a .forward file with the given simple settings
sub save_simple
{
	my $self = shift;

local ($simple) = @_;
if ($simple->{'local'} && !$simple->{'forward'} && !$simple->{'auto'}) {
	$self->unlink_file($self->{'forward_file'});
	}
else {
	# Need to create .forward
	$self->open_tempfile(FORWARD, ">$self->{'forward_file'}");
	if ($simple->{'local'}) {
		if ($self->{'remote_user'} =~ /^(\S+)\@(\S+)$/ &&
		    defined(getpwnam("$1-$2"))) {
			# Handle users created by Virtualmin for Postfix
			# with @ in names
			$self->print_tempfile(FORWARD, "\\$1-$2\n");
			}
		else {
			$self->print_tempfile(FORWARD, "\\$self->{'remote_user'}\n");
			}
		}
	if ($simple->{'forward'}) {
		$self->print_tempfile(FORWARD, $simple->{'forward'},"\n");
		}
	if ($simple->{'auto'}) {
		local $afile = $simple->{'autoreply'};
		$self->print_tempfile(FORWARD, "\"|$self->{'module_config_directory'}/autoreply.pl $afile $self->{'remote_user'}\"\n");
		}
	$self->close_tempfile(FORWARD);
	$self->set_forward_perms();
	}

if ($simple->{'autotext'}) {
	# Save autoreply text
	if (!$simple->{'autoreply'}) {
		# Create autoreply file
		$simple->{'autoreply'} =
			"$self->{'remote_user_info_array'}->[7]/autoreply.txt";
		}
	$self->write_autoreply($simple->{'autoreply'}, $simple);
	}
}


1;

