#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Show form for editing vacation command options

&ModuleLoader::preload_module('forward_class', "forward::ForwardLib");
$self = new forward::ForwardLib:: 'forward_class',%$self;

$self->ReadParse();

$self->ui_print_header(undef, $self->{'text_hash'}->{'vacation_title'}, "");

if ($self->{'config_hash'}->{'mail_system'} == 0) {
	@{$self->{'aliases_array'}} = $self->list_aliases();
	$self->{'a'} = $self->{'aliases_array'}->[$self->{'in_hash'}->{'num'}];
	}
else {
	$self->{'a'} = $self->get_dotqmail($self->{'in_hash'}->{'file'});
	}
$self->{'dst'} = $self->{'a'}->{'values'}->[$self->{'in_hash'}->{'idx'}];
($self->{'type'}, $self->{'args'}) = $self->alias_type($self->{'dst'});
$self->{'type'} == 8 || $self->error("Not a vacation alias!");

# Parse command-line args
@{$self->{'args_array'}} = split(/\s+/, $self->{'args'});
$self->{'user'} = pop(@{$self->{'args_array'}});
while(@{$self->{'args_array'}}) {
	$self->{'arg'} = shift(@{$self->{'args_array'}});
	if ($self->{'arg'} eq "-m") {
		$self->{'msg'} = shift(@{$self->{'args_array'}});
		}
	elsif ($self->{'arg'} eq "-a") {
		$self->{'alias'} = shift(@{$self->{'args_array'}});
		push(@{$self->{'als_array'}}, $self->{'alias'});
		}
	elsif ($self->{'arg'} eq "-r") {
		$self->{'interval'} = shift(@{$self->{'args_array'}});
		}
	else {
		push(@{$self->{'unknown_array'}}, $self->{'arg'});
		}
	}

print $self->ui_form_start("save_vacation.cgi", "post");
print $self->ui_table_start($self->{'text_hash'}->{'vacation_header'}, undef, 2);
print $self->ui_hidden("file", $self->{'in_hash'}->{'file'});
print $self->ui_hidden("num", $self->{'in_hash'}->{'num'});
print $self->ui_hidden("idx", $self->{'in_hash'}->{'idx'});
foreach $u (@{$self->{'unknown_array'}}) {
	print $self->ui_hidden("unknown", $u);
	}

# Username for this user
print $self->ui_table_row($self->{'text_hash'}->{'vacation_user'},
		    $self->ui_radio("user_def", $self->{'user'} eq $self->{'remote_user'} ? 1 : 0,
			      [ [ 1, $self->{'text_hash'}->{'default'} ],
				[ 0, $self->{'text_hash'}->{'vacation_usersel'} ] ])."\n".
		    $self->ui_textbox("user", $self->{'user'} eq $self->{'remote_user'} ? undef : $self->{'user'},
				20));

# Extra aliases
print $self->ui_table_row($self->{'text_hash'}->{'vacation_aliases'},
		    $self->ui_textarea("aliases", join("\n", @{$self->{'als_array'}}), 5, 30));

# Message file
$self->{'defmsg'} = ".vacation.msg";
print $self->ui_table_row($self->{'text_hash'}->{'vacation_msg'},
		    $self->ui_radio("msg_def", $self->{'msg'} ? 0 : 1,
			      [ [ 1, $self->{'text_hash'}->{'default'}." (<tt>$self->{'defmsg'}</tt>)" ],
				[ 0, " " ] ])."\n".
		    $self->ui_textbox("msg", $self->{'msg'}, 30)." ".
		    "<a href='edit_vfile.cgi?vfile=".
		    $self->urlize($self->{'msg'} || $self->{'defmsg'})."&num=$self->{'a'}->{'num'}&".
		    "file=$self->{'in_hash'}->{'file'}&idx=$self->{'in_hash'}->{'idx'}'>".
		    "$self->{'text_hash'}->{'aform_afile'}</a>\n");

# Autoreply interval
print $self->ui_table_row($self->{'text_hash'}->{'vacation_interval'},
		    $self->ui_radio("interval_def", $self->{'interval'} ? 0 : 1,
			      [ [ 1, $self->{'text_hash'}->{'default'} ],
				[ 0, " " ] ])."\n".
		    $self->ui_textbox("interval", $self->{'interval'}, 5)." ".
			        $self->{'text_hash'}->{'vacation_days'});

print $self->ui_table_end();
print $self->ui_form_end([ [ "save", $self->{'text_hash'}->{'save'} ] ]);

$self->ui_print_footer("edit_alias.cgi?num=$self->{'in_hash'}->{'num'}file=$self->{'in_hash'}->{'file'}",
		 $self->{'text_hash'}->{'aform_return'});

1;
		
}


1;

