#!/usr/bin/perl

&MAIN();

 sub MAIN {
# index.cgi
# Display mail forwarding from .forward file

&ModuleLoader::preload_module('forward_class', "forward::ForwardLib");
$self = new forward::ForwardLib:: 'forward_class',%$self;

$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", undef, 0, 1);
$self->ReadParse();

if ($self->{'config_hash'}->{'mail_system'} == 0) {
	# See if we can use or offer simple mode
	$self->{'simple'} = $self->get_simple();
	}
if ($self->{'simple'}) {
	# Possible .. show selector
	$self->{'in_hash'}->{'simple'} = 1 if (!defined($self->{'in_hash'}->{'simple'}));
	print $self->{'text_hash'}->{'index_mode'},"\n";
	foreach $s (1, 0) {
		if ($s == $self->{'in_hash'}->{'simple'}) {
			print $self->{'text_hash'}->{'index_simple'.$s},"\n";
			}
		else {
			print "<a href='index.cgi?simple=$s'>",$self->{'text_hash'}->{'index_simple'.$s},"</a>\n";
			}
		print "&nbsp;|&nbsp;\n" if ($s != 0);
		}
	print "<p>\n";
	}

if ($self->{'in_hash'}->{'simple'} && $self->{'simple'}) {
	# Simple mode for Sendmail
	print $self->ui_form_start("save_simple.cgi", "post");
	print $self->ui_table_start($self->{'text_hash'}->{'index_header'}, undef, 2);

	print $self->ui_table_row($self->{'text_hash'}->{'index_local'},
			    $self->ui_checkbox("local", 1, $self->{'text_hash'}->{'index_localyes'},
					 $self->{'simple'}->{'local'}));

	print $self->ui_table_row($self->{'text_hash'}->{'index_forward'},
			    $self->ui_checkbox("forward", 1,$self->{'text_hash'}->{'index_forwardyes'},
					 $self->{'simple'}->{'forward'})." ".
			    $self->ui_textbox("forwardto", $self->{'simple'}->{'forward'} ||
					     $self->{'userconfig_hash'}->{'forwardto'}, 40));

	# Autoreply active and text
	print $self->ui_table_row($self->{'text_hash'}->{'index_auto'},
			    $self->ui_checkbox("auto", 1,$self->{'text_hash'}->{'index_autoyes'},
					 $self->{'simple'}->{'auto'})."<br>\n".
			    $self->ui_textarea("autotext", $self->{'simple'}->{'autotext'},
					 5, 70));

	# Attached files
	if ($self->{'config_hash'}->{'attach'}) {
		$self->{'ftable'} = "";
		$i = 0;
		foreach $f (@{$self->{'simple'}->{'autoreply_file'}}, undef) {
			$self->{'ftable'} .= $self->ui_textbox("file_$i", $f, 50)." ".
				   $self->file_chooser_button("file_$i")."<br>\n";
			$i++;
			}
		print $self->ui_table_row($self->{'text_hash'}->{'index_files'}, $self->{'ftable'});
		}

	$self->{'period'} = $self->{'simple'}->{'replies'} && $self->{'simple'}->{'period'} ?
			int($self->{'simple'}->{'period'}/60) :
		  $self->{'simple'}->{'replies'} ? 60 : undef;
	print $self->ui_table_row($self->{'text_hash'}->{'index_period'},
	    $self->ui_opt_textbox("period", $self->{'period'}, 3, $self->{'text_hash'}->{'index_noperiod'})." ".
	    $self->{'text_hash'}->{'index_mins'});

	($self->{'froms'}, $self->{'doms'}) = $main::mailbox_object->list_from_addresses();
	$self->{'df'} = $self->{'froms'}->[0];
	print $self->ui_table_row($self->{'text_hash'}->{'index_from'},
		$self->ui_radio("from_def", $self->{'simple'}->{'from'} ? 0 : 1,
			  [ [ 1, $self->{'text_hash'}->{'index_fromauto'} ],
			    [ 0, $self->ui_textbox("from", $self->{'simple'}->{'from'} || $self->{'df'},
					     40) ] ]));
	
	print $self->ui_table_end();
	print $self->ui_form_end([ [ "save", $self->{'text_hash'}->{'save'} ] ]);
	}
elsif ($self->{'config_hash'}->{'mail_system'} == 0) {
	# Sendmail forwarding
	print "$self->{'text_hash'}->{'index_desc'}<p>\n";
	@{$self->{'aliases_array'}} = $self->list_aliases();
	if (@{$self->{'aliases_array'}}) {
		# find a good place to split
		$self->{'lines'} = 0;
		for($i=0; $i<@{$self->{'aliases_array'}}; $i++) {
			$self->{'aline_array'}->[$i] = $self->{'lines'};
			$self->{'al'} = scalar(@{$self->{'aliases_array'}->[$i]->{'values'}});
			$self->{'lines'} += ($self->{'al'} ? $self->{'al'} : 1);
			}
		$self->{'midline'} = int(($self->{'lines'}+1) / 2);
		for($mid=0; $mid<@{$self->{'aliases_array'}} && $self->{'aline_array'}->[$mid] < $self->{'midline'}; $mid++) { }

		# render tables
		print "<table width=100%> <tr><td width=50% valign=top>\n";
		&aliases_table(@{$self->{'aliases_array'}}[0..$mid-1]);
		print "</td><td width=50% valign=top>\n";
		if ($mid < @{$self->{'aliases_array'}}) { &aliases_table(@{$self->{'aliases_array'}}[$mid..$#{$self->{'aliases_array'}}]); }
		print "</td></tr> </table>\n";
		}
	else {
		print "<b>$self->{'text_hash'}->{'index_none'}</b> <p>\n";
		}
	}
else {
	# Qmail forwarding
	print "$self->{'text_hash'}->{'index_desc'}<p>\n";
	@{$self->{'aliases_array'}} = $self->list_dotqmails();
	if (@{$self->{'aliases_array'}}) {
		# find a good place to split
		$self->{'lines'} = 0;
		for($i=0; $i<@{$self->{'aliases_array'}}; $i++) {
			$self->{'aline_array'}->[$i] = $self->{'lines'};
			$self->{'al'} = scalar(@{$self->{'aliases_array'}->[$i]->{'values'}});
			$self->{'lines'} += ($self->{'al'} ? $self->{'al'} : 1);
			}
		$self->{'midline'} = int(($self->{'lines'}+1) / 2);
		for($mid=0; $mid<@{$self->{'aliases_array'}} && $self->{'aline_array'}->[$mid] < $self->{'midline'}; $mid++) { }

		# render tables
		print "<table width=100%> <tr><td width=50% valign=top>\n";
		&dotqmail_table(@{$self->{'aliases_array'}}[0..$mid-1]);
		print "</td><td width=50% valign=top>\n";
		if ($mid < @{$self->{'aliases_array'}}) { &dotqmail_table(@{$self->{'aliases_array'}}[$mid..$#{$self->{'aliases_array'}}]); }
		print "</td></tr> </table>\n";
		}
	else {
		print "<b>$self->{'text_hash'}->{'index_none'}</b> <p>\n";
		}
	}

if (!$self->{'in_hash'}->{'simple'} || !$self->{'simple'}) {
	print "<a href='edit_alias.cgi?new=1'>$self->{'text_hash'}->{'index_add'}</a>\n";
	print "&nbsp;&nbsp;&nbsp;<a href='edit_forward.cgi'>",
	      $self->text('index_edit', "<tt>.forward</tt>"),"</a>\n"
		if ($self->{'config_hash'}->{'mail_system'} == 0 && $self->{'config_hash'}->{'edit'});
	print "<p>\n";
	}

$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});

1;
		
}

sub aliases_table
{
	shift if ($self == $_[0]);

print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'aliases_to'}</b></td> <td><b>$self->{'text_hash'}->{'aliases_enabled'}</b></td> </tr>\n";
foreach $a (@_) {
	print "<tr $self->{'cb'}>\n";
	print "<td><a href=\"edit_alias.cgi?num=$a->{'num'}\">";
	foreach $v (@{$a->{'values'}}) {
		($self->{'anum'}, $self->{'astr'}) = $self->alias_type($v);
		print $self->text("aliases_type$self->{'anum'}", "<tt>$self->{'astr'}</tt>"),"<br>\n";
		}
	print "</td>\n";
	printf "<td>%s</td>\n", $a->{'enabled'} ? $self->{'text_hash'}->{'yes'} :
		"<font color=#ff0000>$self->{'text_hash'}->{'no'}</font>";
	print "</tr>\n";
	}
print "</table>\n";
}

sub dotqmail_table
{
	shift if ($self == $_[0]);

print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'aliases_from'}</b></td> <td><b>$self->{'text_hash'}->{'aliases_to'}</b></td> </tr>\n";
foreach $a (@_) {
	print "<tr $self->{'cb'}>\n";
	print "<td><a href=\"edit_alias.cgi?file=$a->{'file'}\">",
	      $a->{'name'} ? "$self->{'remote_user'}-$a->{'name'}" : $self->{'remote_user'},
	      "</td> <td>\n";
	foreach $v (@{$a->{'values'}}) {
		($self->{'anum'}, $self->{'astr'}) = $self->alias_type($v);
		print $self->text("aliases_type$self->{'anum'}", "<tt>$self->{'astr'}</tt>"),"<br>\n";
		}
	print "</td> </tr>\n";
	}
print "</table>\n";

}


1;

