#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_alias.cgi
# Save or delete a new or existing .forward entry

&ModuleLoader::preload_module('forward_class', "forward::ForwardLib");
$self = new forward::ForwardLib:: 'forward_class',%$self;

$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'asave_err'});
if (!$self->{'in_hash'}->{'new'}) {
	if ($self->{'config_hash'}->{'mail_system'} == 0) {
		@{$self->{'aliases_array'}} = $self->list_aliases();
		$self->{'a'} = $self->{'aliases_array'}->[$self->{'in_hash'}->{'num'}];
		}
	else {
		$self->{'a'} = $self->get_dotqmail($self->{'in_hash'}->{'file'});
		}
	}

if ($self->{'in_hash'}->{'delete'}) {
	# delete some alias
	$self->{'loga'} = $self->{'a'};
	$self->delete_alias($self->{'a'});
	}
else {
	# saving or creating .. check inputs
	local %types = map { $_, 1 } split(/\,/, $self->{'config_hash'}->{'types'});
	$types{8} = $types{5};
	for($i=0; defined($self->{'t'} = $self->{'in_hash'}->{"type_$i"}); $i++) {
		!$self->{'t'} || $types{$self->{'t'}} || $self->error($self->{'text_hash'}->{'asave_ecannot'});
		$self->{'v'} = $self->{'in_hash'}->{"val_$i"};
		if ($self->{'t'} == 1 && $self->{'v'} !~ /^([^\/\|:]\S*)$/) {
			$self->error($self->text('asave_etype1', $self->{'v'}));
			}
		elsif ($self->{'t'} == 3 && $self->{'v'} !~ /^\/(\S+)$/ && $self->{'config_hash'}->{'mail_system'} == 0) {
			$self->error($self->text('asave_etype3', $self->{'v'}));
			}
		elsif ($self->{'t'} == 3 && $self->{'v'} !~ /^[\/\.](\S+)$/ && $self->{'config_hash'}->{'mail_system'} == 1) {
			$self->error($self->text('asave_etype3', $self->{'v'}));
			}
		elsif ($self->{'t'} == 4) {
			$self->{'v'} =~ /^(\S+)/ || $self->error($self->{'text_hash'}->{'asave_etype4none'});
			-x $1 || $self->error($self->text('asave_etype4', $1));
			}
		elsif ($self->{'t'} == 5 && !$self->{'v'}) {
			$self->error($self->text('asave_etype5'));
			}
		elsif ($self->{'t'} == 6 && !$self->{'v'}) {
			$self->error($self->text('asave_etype6'));
			}
		elsif ($self->{'t'} == 2 &&  $self->{'config_hash'}->{'mail_system'} == 1) {
			$self->error($self->text('asave_etype1q', $self->{'v'}));
			}
		elsif ($self->{'t'} == 7 &&  $self->{'config_hash'}->{'mail_system'} == 1 && !$self->{'mail_path'}) {
			$self->error($self->text('asave_etype2q', $self->{'v'}));
			}
		if ($self->{'t'} >= 2 && $self->{'t'} <= 6 && $self->{'v'} !~ /^\//) {
			# Path is relative to home dir
			$self->{'v'} = "$self->{'remote_user_info_array'}->[7]/$self->{'v'}";
			}
		if ($self->{'t'} == 1 || $self->{'t'} == 3) { push(@{$self->{'values_array'}}, $self->{'v'}); }
		elsif ($self->{'t'} == 2) { push(@{$self->{'values_array'}}, ":include:$self->{'v'}"); }
		elsif ($self->{'t'} == 4) { push(@{$self->{'values_array'}}, "|$self->{'v'}"); }
		elsif ($self->{'t'} == 5) {
			# Setup autoreply script
			push(@{$self->{'values_array'}}, "|$self->{'module_config_directory'}/autoreply.pl $self->{'v'} $self->{'remote_user'}");
			}
		elsif ($self->{'t'} == 6) {
			# Setup filter script
			push(@{$self->{'values_array'}}, "|$self->{'module_config_directory'}/filter.pl $self->{'v'} $self->{'remote_user'}");
			}
		elsif ($self->{'t'} == 7) {
			# Just write to user's mail file
			push(@{$self->{'values_array'}}, $self->{'config_hash'}->{'mail_system'} ? $self->{'mail_path'} : "\\$self->{'remote_user'}");
			}
		elsif ($self->{'t'} == 8) {
			# Set up vacation program
			if ($self->{'a'} && $self->{'a'}->{'values'}->[$i] &&
			    $self->alias_type($self->{'a'}->{'values'}->[$i]) == 8) {
				# Use old settings
				push(@{$self->{'values_array'}}, $self->{'a'}->{'values'}->[$i]);
				}
			else {
				# Default vacation setup
				push(@{$self->{'values_array'}}, "|$self->{'vacation_path'} $self->{'remote_user'}");
				system("vacation -i >/dev/null 2>&1");
				}
			}
		}

	@{$self->{'values_array'}} || $self->error($self->{'text_hash'}->{'asave_enone'});
	$self->{'newa_hash'}->{'values'} = \@{$self->{'values_array'}};
	if ($self->{'config_hash'}->{'mail_system'} == 0) {
		$self->{'newa_hash'}->{'enabled'} = $self->{'in_hash'}->{'enabled'};
		}
	else {
		$self->{'in_hash'}->{'name_def'} || $self->{'in_hash'}->{'name'} =~ /^\S+$/ ||
			$self->error($self->{'text_hash'}->{'asave_ename'});
		$self->{'newa_hash'}->{'name'} = $self->{'in_hash'}->{'name_def'} ? undef : $self->{'in_hash'}->{'name'};
		if ($self->{'in_hash'}->{'new'} || $self->{'newa_hash'}->{'name'} ne $self->{'a'}->{'name'}) {
			@{$self->{'aliases_array'}} = $self->list_dotqmails();
			($self->{'same'}) = grep { $_->{'name'} eq $self->{'newa_hash'}->{'name'} } @{$self->{'aliases_array'}};
			$self->{'same'} && $self->error($self->{'text_hash'}->{'asave_esame'});
			}
		}
	if ($self->{'in_hash'}->{'new'}) { $self->create_alias(\%{$self->{'newa_hash'}}); }
	else { $self->modify_alias($self->{'a'}, \%{$self->{'newa_hash'}}); }
	$self->{'loga'} = \%{$self->{'newa_hash'}};
	}
$self->redirect("");

1;
		
}


1;

