#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_key.cgi
# Display the details of a key, including the exported format

&ModuleLoader::preload_module('gnupg_class', "gnupg::GnupgLib");
$self = new gnupg::GnupgLib:: 'gnupg_class',%$self;

$self->ReadParse();
@{$self->{'keys_array'}} = $self->list_keys();
if ($self->{'in_hash'}->{'key'}) {
	($self->{'key'}) = grep { $_->{'key'} eq $self->{'in_hash'}->{'key'} } @{$self->{'keys_array'}};
	$self->{'in_hash'}->{'idx'} = $self->indexof($self->{'key'}, @{$self->{'keys_array'}});
	}
else {
	$self->{'key'} = $self->{'keys_array'}->[$self->{'in_hash'}->{'idx'}];
	}

$self->ui_print_header(undef, $self->{'text_hash'}->{'key_title'}, "");

print "$self->{'text_hash'}->{'key_desc'}<p>\n";

print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'key_header'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'key_id'}</b></td>\n";
print "<td><tt>$self->{'key'}->{'key'}</tt></td>\n";

print "<td><b>$self->{'text_hash'}->{'key_date'}</b></td>\n";
print "<td>$self->{'key'}->{'date'}</tt></td> </tr>\n";

if ($self->{'key'}->{'secret'}) {
	print "<form action=owner.cgi>\n";
	print "<input type=hidden name=idx value='$self->{'in_hash'}->{'idx'}'>\n";
	}
print "<tr> <td valign=top><b>$self->{'text_hash'}->{'key_owner'}</b></td>\n";
print "<td valign=top colspan=3><table border=0>\n";
print "<tr> <td><b>$self->{'text_hash'}->{'key_oname'}</b></td> ",
      "<td><b>$self->{'text_hash'}->{'key_oemail'}</b></td> </tr>\n";
for($i=0; $i<@{$self->{'key'}->{'name'}}; $i++) {
	print "<tr>\n";
	print "<td>",$self->{'key'}->{'name'}->[$i],"</td>\n";
	print "<td>",$self->{'key'}->{'email'}->[$i] || "<br>","</td>\n";
	if ($self->{'key'}->{'secret'}) {
		print "<td><input type=submit name=$i value='$self->{'text_hash'}->{'delete'}'></td>\n";
		}
	print "</tr>\n";
	}
if ($self->{'key'}->{'secret'}) {
	print "</form>\n";
	print "<form action=owner.cgi>\n";
	print "<input type=hidden name=idx value='$self->{'in_hash'}->{'idx'}'>\n";
	print "<tr>\n";
	print "<td><input name=name size=30></td>\n";
	print "<td><input name=email size=30></td>\n";
	print "<td><input name=add type=submit value='$self->{'text_hash'}->{'key_addowner'}'></td>\n";
	print "</tr>\n";
	}
print "</table>\n";
print "</form>\n" if ($self->{'key'}->{'secret'});
print "</td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'key_finger'}</b></td>\n";
print "<td colspan=3><tt>",$self->key_fingerprint($self->{'key'}),"</tt></td> </tr>\n";

#print "<tr> <td valign=top><b>$self->{'text_hash'}->{'key_ascii'}</b>",
#      "<br>$self->{'text_hash'}->{'key_asciidesc'}</td>\n";
#print "<td colspan=3><pre>";
#open(GPG, "$gpgpath --armor --export \"$self->{'key'}->{'name'}->[0]\" |");
#while(<GPG>) {
#	print &html_escape($_);
#	}
#close(GPG);
#print "</pre></td> </tr>\n";

if ($self->{'key'}->{'secret'}) {
	# Offer to change usermin's passphrase
	$self->{'pass'} = $self->get_passphrase($self->{'key'});
	print "<form action=save_pass.cgi>\n";
	print "<input type=hidden name=idx value='$self->{'in_hash'}->{'idx'}'>\n";
	print "<tr> <td valign=top><b>",defined($self->{'pass'}) ? $self->{'text_hash'}->{'key_changepass'}
					    : $self->{'text_hash'}->{'key_setpass'},"</b></td>\n";
	print "<td colspan=3><input type=password name=pass size=20> ",
	      "<input type=submit value='$self->{'text_hash'}->{'save'}'><br>\n";
	print defined($self->{'pass'}) ? $self->{'text_hash'}->{'key_passdesc2'} : $self->{'text_hash'}->{'key_passdesc'},"\n";
	print "</td></tr></form>\n";
	}
else {
	# Offer to set trust level
	$self->{'tr'} = $self->get_trust_level($self->{'key'});
	print "<form action=change_trust.cgi>\n";
	print "<input type=hidden name=idx value='$self->{'in_hash'}->{'idx'}'>\n";
	print "<tr> <td><b>$self->{'text_hash'}->{'key_trust'}</b></td>\n";
	print "<td><select name=trust>\n";
	foreach $t (0 .. 4) {
		printf "<option value=%d %s>%s\n",
			$t, $t eq $self->{'tr'} ? "selected" : "", $self->{'text_hash'}->{"key_trust_$t"};
		}
	print "</select>\n";
	print "<input type=submit value='$self->{'text_hash'}->{'key_changetrust'}'>\n";
	print "</td></tr></form>\n";
	}

print "</table></td></tr></table>\n";

print "<table width=100%><tr>\n";
print "<form action=edit_export.cgi>\n";
print "<input type=hidden name=idx value='$self->{'key'}->{'index'}'>\n";
print "<td width=25%><input type=submit value='$self->{'text_hash'}->{'key_exportform'}'></td></form>\n";

print "<form action=send.cgi>\n";
print "<input type=hidden name=idx value='$self->{'key'}->{'index'}'>\n";
print "<td align=middle width=25%><input type=submit value='$self->{'text_hash'}->{'key_send'}'></td></form>\n";

print "<form action=signkey.cgi>\n";
print "<input type=hidden name=idx value='$self->{'key'}->{'index'}'>\n";
print "<td align=middle width=25%><input type=submit value='$self->{'text_hash'}->{'key_sign'}'></td></form>\n";

print "<form action=delkey.cgi>\n";
print "<input type=hidden name=idx value='$self->{'key'}->{'index'}'>\n";
print "<td align=right width=25%><input type=submit value='$self->{'text_hash'}->{'key_del'}'></td></form>\n";
print "</tr></table>\n";

$self->ui_print_footer("list_keys.cgi", $self->{'text_hash'}->{'keys_return'},
	"", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

