#!/usr/bin/perl

&MAIN();

 sub MAIN {
# list_keys.cgi
# Display all keys in your keyring

&ModuleLoader::preload_module('gnupg_class', "gnupg::GnupgLib");
$self = new gnupg::GnupgLib:: 'gnupg_class',%$self;

$self->ui_print_header(undef, $self->{'text_hash'}->{'keys_title'}, "");

@{$self->{'keys_array'}} = $self->list_keys();
print "$self->{'text_hash'}->{'keys_desc'}<p>\n";

# List of existing keys
print $self->ui_form_start("delete_keys.cgi", "post");
@{$self->{'links_array'}} = ( $self->select_all_link("d"),
	   $self->select_invert_link("d") );
print $self->ui_links_row(\@{$self->{'links_array'}});
@{$self->{'tds_array'}} = ( "width=5" );
print $self->ui_columns_start([ "",
			  $self->{'text_hash'}->{'keys_id'},
			  $self->{'text_hash'}->{'keys_secret'},
			  $self->{'text_hash'}->{'keys_date'},
			  $self->{'text_hash'}->{'keys_name'},
			  $self->{'text_hash'}->{'keys_email'} ], 100);
foreach $k (@{$self->{'keys_array'}}) {
	local @cols;
	push(@cols, "<a href='edit_key.cgi?idx=$k->{'index'}'>$k->{'key'}</a>");
	push(@cols, $k->{'secret'} ? "<b>$self->{'text_hash'}->{'yes'}</b>"
				   : $self->{'text_hash'}->{'no'});
	push(@cols, $k->{'date'});
	push(@cols, join("<br>", map { $self->html_escape($_) } @{$k->{'name'}}));
	push(@cols, join("<br>", map { $self->html_escape($_) } @{$k->{'email'}}));
	if ($k->{'secret'}) {
		# Cannot delete secret keys this way
		print $self->ui_columns_row([ "", @cols ], \@{$self->{'tds_array'}});
		}
	else {
		print $self->ui_checked_columns_row(\@cols, \@{$self->{'tds_array'}}, "d",$k->{'index'});
		}
	}
print $self->ui_columns_end();
print $self->ui_links_row(\@{$self->{'links_array'}});
print $self->ui_form_end([ [ "delete", $self->{'text_hash'}->{'keys_delete'} ] ]);

# Form for adding a key
print "<hr>\n";
print "$self->{'text_hash'}->{'keys_importdesc'}<p>\n";
print "<form action=import.cgi method=post enctype=multipart/form-data>\n";
print "<table>\n";

print "<tr> <td valign=top><b>$self->{'text_hash'}->{'keys_from'}</b></td>\n";
print "<td><input type=radio name=mode value=0 checked> $self->{'text_hash'}->{'keys_mode0'}\n";
print "<input type=file name=key><br>\n";

print "<input type=radio name=mode value=1> $self->{'text_hash'}->{'keys_mode1'}\n";
print "<input name=file size=35> ",$self->file_chooser_button("to"),"</td> </tr>\n";

print "</table>\n";
print "<input type=submit value='$self->{'text_hash'}->{'keys_import'}'></form>\n";

print "<hr>\n";
print $self->text('keys_recvdesc', "<tt>$self->{'config_hash'}->{'keyserver'}</tt>"),"<p>\n";
print "<form action=recv.cgi>\n";
print "<input type=submit value='$self->{'text_hash'}->{'keys_recv'}'>\n";
print "<input name=id size=10></form>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

