#!/usr/bin/perl

&MAIN();

 sub MAIN {
# signkey.cgi
# Sign a key, after asking the user if he is sure

&ModuleLoader::preload_module('gnupg_class', "gnupg::GnupgLib");
$self = new gnupg::GnupgLib:: 'gnupg_class',%$self;

$self->ReadParse();
$self->ui_print_header(undef, $self->{'text_hash'}->{'signkey_title'}, "");

@{$self->{'keys_array'}} = $self->list_keys();
$self->{'key'} = $self->{'keys_array'}->[$self->{'in_hash'}->{'idx'}];
($self->{'secret'}) = grep { $_->{'secret'} } @{$self->{'keys_array'}};

if ($self->{'in_hash'}->{'confirm'}) {
	# Do it!
	$self->{'cmd'} = "$self->{'gpgpath'} --edit-key \"$self->{'key'}->{'name'}->[0]\"";
	($fh, $self->{'fpid'}) = $self->foreign_call("proc", "pty_process_exec", $self->{'cmd'});
	$self->wait_for($fh, "command>");
	syswrite($fh, "sign\n");
	while(1) {
		$self->{'rv'} = $self->wait_for($fh, "really sign all",
				'really sign\?', "already", "your selection",
				"passphrase", "nothing to sign", "command>",
				"(error|failed).*", "expire at the same time");
		sleep(1);
		if ($self->{'rv'} == 0 || $self->{'rv'} == 1) {
			syswrite($fh, "y\n");
			}
		elsif ($self->{'rv'} == 2 || $self->{'rv'} == 5) {
			print "<p>",$self->text('signkey_already',
				  "<tt>$self->{'key'}->{'name'}->[0]</tt>"),"<p>\n";
			last;
			}
		elsif ($self->{'rv'} == 3) {
			syswrite($fh, $self->{'in_hash'}->{'trust'}."\n");
			}
		elsif ($self->{'rv'} == 4) {
			$self->{'pass'} = $self->get_passphrase();
			syswrite($fh, "$self->{'pass'}\n");
			}
		elsif ($self->{'rv'} == 6) {
			print "<p>",$self->text('signkey_success',
			  "<tt>$self->{'key'}->{'name'}->[0]</tt>"),"<p>\n";
			last;
			}
		elsif ($self->{'rv'} == 7) {
			print "<p>",$self->text('signkey_failed',
			  "<tt>$self->{'key'}->{'name'}->[0]</tt>",
			  "<pre>$self->{'wait_for_input'}</pre>"),"<p>\n";
			last;
			}
		elsif ($self->{'rv'} == 8) {
			syswrite($fh, "y\n");
			}
		else {
			# Unknown response!
			last;
			}
		}
	syswrite($fh, "quit\n");
	$self->{'rv'} = $self->wait_for($fh, "save changes");
	if ($self->{'rv'} == 0) {
		syswrite($fh, "y\n");
		sleep(1);
		}
	close($fh);
	}
else {
	# Ask the user if he is sure
	print $self->text('signkey_confirm', "<tt>$self->{'key'}->{'name'}->[0]</tt>",
	  $self->{'key'}->{'email'}->[0] ? "&lt;<tt>$self->{'key'}->{'email'}->[0]</tt>&gt;" : "",
	  "<tt>".$self->key_fingerprint($self->{'key'})."</tt>"),"<p>\n";
	print "<center><form action=signkey.cgi>\n";
	print "<input type=hidden name=idx value='$self->{'key'}->{'index'}'>\n";
	print "<input type=hidden name=confirm value=1>\n";
	print "<input type=submit value='$self->{'text_hash'}->{'key_sign'}'>\n";
	print "$self->{'text_hash'}->{'signkey_trust'}\n";
	print "<select name=trust>\n";
	print "<option selected value=0>$self->{'text_hash'}->{'signkey_trust0'}\n";
	print "<option value=1>$self->{'text_hash'}->{'signkey_trust1'}\n";
	print "<option value=2>$self->{'text_hash'}->{'signkey_trust2'}\n";
	print "<option value=3>$self->{'text_hash'}->{'signkey_trust3'}\n";
	print "</select>\n";
	print "</form></center>\n";
	}

$self->ui_print_footer("list_keys.cgi", $self->{'text_hash'}->{'keys_return'},
	"", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

