#!/usr/bin/perl

&MAIN();

 sub MAIN {
# verify.cgi
# Verify the signature on a file

&ModuleLoader::preload_module('gnupg_class', "gnupg::GnupgLib");
$self = new gnupg::GnupgLib:: 'gnupg_class',%$self;

$self->ReadParseMime();

# Get file data
if ($self->{'in_hash'}->{'mode'} == 0) {
	$self->{'in_hash'}->{'upload'} || $self->error($self->{'text_hash'}->{'verify_eupload'});
	$self->{'data'} = $self->{'in_hash'}->{'upload'};
	}
else {
	$self->{'in_hash'}->{'local'} || $self->error($self->{'text_hash'}->{'verify_eupload'});
	-r $self->{'in_hash'}->{'local'} || $self->error($self->{'text_hash'}->{'verify_elocal'});
	$self->{'data'} = $self->read_entire_file($self->{'in_hash'}->{'local'});
	}

# Get signature data
if ($self->{'in_hash'}->{'sigmode'} == 0) {
	$self->{'in_hash'}->{'sigupload'} || $self->error($self->{'text_hash'}->{'verify_esigupload'});
	$self->{'sigdata'} = $self->{'in_hash'}->{'sigupload'};
	}
elsif ($self->{'in_hash'}->{'sigmode'} == 1) {
	$self->{'in_hash'}->{'siglocal'} || $self->error($self->{'text_hash'}->{'verify_esigupload'});
	-r $self->{'in_hash'}->{'siglocal'} || $self->error($self->{'text_hash'}->{'verify_esiglocal'});
	$self->{'sigdata'} = $self->read_entire_file($self->{'in_hash'}->{'siglocal'});
	}
else {
	$self->{'sigdata'} = undef;
	}

($self->{'code'}, $self->{'message'}) = $self->verify_data($self->{'data'}, $self->{'sigdata'});

$self->ui_print_header(undef, $self->{'text_hash'}->{'verify_title'}, "");

$self->{'red'} = "<font color=#ff0000>";
$self->{'end'} = "</font>";
if ($self->{'code'} == 0 || $self->{'code'} == 1) {
	print $self->text('verify_good', $self->html_escape($self->{'message'})),"<p>\n";
	if ($self->{'code'} == 1) {
		print "<b>$self->{'red'}$self->{'text_hash'}->{'verify_warning'}$self->{'end'}</b><p>\n";
		}
	}
elsif ($self->{'code'} == 2) {
	print "$self->{'red'}",$self->text('verify_bad', $self->html_escape($self->{'message'})),"$self->{'end'}<p>\n";
	}
elsif ($self->{'code'} == 3) {
	print "$self->{'red'}",$self->text('verify_noid', $self->html_escape($self->{'message'})),"$self->{'end'}<p>\n";
	}
else {
	print "$self->{'red'}",$self->text('verify_failed', "<pre>$self->{'message'}</pre>"),"$self->{'end'}<p>\n";
	}

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

