#!/usr/bin/perl
package home::HomeLib;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'home::HomeLib');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
&ModuleLoader::preload_module(ref($self), "WebLib");
$self = new WebLib:: ref($self), %$self; 
$self->init_config();
&ModuleLoader::preload_module(ref($self), "UiLib");
$self = new UiLib:: ref($self), %$self; 

1;
1;
		return $self;
}

# --- ZTL specific functions ---
# &print_menu(\%apps, $file);
# %apps - appliances' hash
# $file - menu file name
sub print_menu {
	my $self = shift;

	local $apps = shift(@_);
	local $file = shift(@_);
	local (%m_data, @m_order, @menu);
	$self->read_file($file, \%m_data, \@m_order);
	local $title = $self->ztl_get_jointext($apps, $m_data{'title'});
	delete($m_data{'title'});
	#local $title = $m_data{'title'};
	return unless $title;
	foreach my $k (@m_order) {
		next if $m_data{$k} =~ /^#/ || !$m_data{$k};
		# expected format: "col:icon:href:text_formatted_string"
		if ($m_data{$k} =~ /^([^:]+):([^:]+):([^:]+):(.*)$/) {
			my ($col, $icon, $href, $text) = ($1, $2, $3, $self->ztl_get_jointext($apps, $4));
			$href = "http://$ENV{'SERVER_NAME'}/$1" if ($href =~ /\$P(\S+)/);
			push(@menu, {'col' => $col, 'icon' => $icon, 'href' => $href, 'text' => $text}) if $text;
		}
	}
	if (@menu) {
		$self->print_icons_menu($title, \@menu);
	}
	print "<hr>\n";
}

# &print_icons_menu(\@items);
sub print_icons_menu {
	my $self = shift;

	local $icon_size = 24;
	local $title = shift(@_);
	local $items = shift(@_);
	# separating of items using their columns numbers
	local @columns = ();
	foreach my $i (@{$items}) {
		my $c = $i->{'col'};
		@columns[$c - 1] = [] unless @columns[$c - 1];
		push(@{@columns[$c - 1]}, $i);
	}
	local $max = 0;
	foreach my $c (@columns) {
		if (scalar(@{$c}) > $max) {$max = scalar(@{$c})}
	}
	local $cols = scalar(@columns);
	local $width = int(100 / $cols);
	print "<table cellspacing=0 cellpadding=5 width='100%' class=contframe>\n";
	print "<tr class=conttitle><td colspan=$cols width=100%>$title</td></tr>";
	foreach $idx (0 .. $max - 1) {
		print "<tr>\n";
		foreach my $c (@columns) {
			my $item = $c->[$idx];
			unless ($item) {
				print "<td>&nbsp;</td>\n";
			}
			else {
				my $href = $item->{'href'};
				print "<td width='$width%' align=left nowrap>";
				print "<a class=homeimg href='$href'><img src='images/$item->{'icon'}' border=0 width=$icon_size height=$icon_size></a>" if ($item->{'icon'});
				print "<a class=hometxt href='$href'>$item->{'text'}</a></td>\n";
			}
		}
		print "</tr>\n";
	}
	print "</table>\n";
}


1;

