do '../web-lib.pl';
&init_config();
require '../ui-lib.pl';

# --- ZTL specific functions ---
# &print_menu(\%apps, $file);
# %apps - appliances' hash
# $file - menu file name
sub print_menu {
	local $apps = shift(@_);
	local $file = shift(@_);
	local (%m_data, @m_order, @menu);
	&read_file($file, \%m_data, \@m_order);
	local $title = &ztl_get_jointext($apps, $m_data{'title'});
	delete($m_data{'title'});
	#local $title = $m_data{'title'};
	return unless $title;
	foreach my $k (@m_order) {
		next if $m_data{$k} =~ /^#/ || !$m_data{$k};
		# expected format: "col:icon:href:text_formatted_string"
		if ($m_data{$k} =~ /^([^:]+):([^:]+):([^:]+):(.*)$/) {
			my ($col, $icon, $href, $text) = ($1, $2, $3, &ztl_get_jointext($apps, $4));
			$href = "http://$ENV{'SERVER_NAME'}/$1" if ($href =~ /\$P(\S+)/);
			push(@menu, {'col' => $col, 'icon' => $icon, 'href' => $href, 'text' => $text}) if $text;
		}
	}
	if (@menu) {
		&print_icons_menu($title, \@menu);
	}
	print "<hr>\n";
}

# &print_icons_menu(\@items);
sub print_icons_menu {
	local $icon_size = 24;
	local $title = shift(@_);
	local $items = shift(@_);
	# separating of items using their columns numbers
	local @columns = ();
	foreach my $i (@{$items}) {
		my $c = $i->{'col'};
		@columns[$c - 1] = [] unless @columns[$c - 1];
		push(@{@columns[$c - 1]}, $i);
	}
	local $max = 0;
	foreach my $c (@columns) {
		if (scalar(@{$c}) > $max) {$max = scalar(@{$c})}
	}
	local $cols = scalar(@columns);
	local $width = int(100 / $cols);
	print "<table cellspacing=0 cellpadding=5 width='100%' class=contframe>\n";
	print "<tr class=conttitle><td colspan=$cols width=100%>$title</td></tr>";
	foreach $idx (0 .. $max - 1) {
		print "<tr>\n";
		foreach my $c (@columns) {
			my $item = $c->[$idx];
			unless ($item) {
				print "<td>&nbsp;</td>\n";
			}
			else {
				my $href = $item->{'href'};
				print "<td width='$width%' align=left nowrap>";
				print "<a class=homeimg href='$href'><img src='images/$item->{'icon'}' border=0 width=$icon_size height=$icon_size></a>" if ($item->{'icon'});
				print "<a class=hometxt href='$href'>$item->{'text'}</a></td>\n";
			}
		}
		print "</tr>\n";
	}
	print "</table>\n";
}

1;
1;
