#!/usr/bin/perl
package htaccess::HtaccessLib;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'htaccess::HtaccessLib');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# htaccess-lib.pl

@{$self->{'remote_user_info_array'}};

&ModuleLoader::preload_module(ref($self), "WebLib");
$self = new WebLib:: ref($self), %$self; 
$self->init_config();
&ModuleLoader::preload_module(ref($self), "UiLib");
$self = new UiLib:: ref($self), %$self; 
&ModuleLoader::preload_module(ref($self), "htaccess::ApacheLib");
$self = new htaccess::ApacheLib:: ref($self), %$self; 
$self->switch_to_remote_user();
$self->create_user_config_dirs();

$self->{'www_root'} = $self->{'userconfig_hash'}->{'www_root'};
$self->{'www_root'} = "$self->{'remote_user_info_array'}->[7]/$self->{'www_root'}" if ($self->{'www_root'} !~ /^\//);

1;

1;
		return $self;
}

sub get_htaccess_files
{
	my $self = shift;

local @rv;
open(HTACCESS, "$self->{'user_module_config_directory'}/htlist");
while(<HTACCESS>) {
	s/\r|\n//g;
	push(@rv, $_) if (-r $_);
	}
close(HTACCESS);
return @rv;
}

sub set_htaccess_files
{
	my $self = shift;

local $f;
$self->open_tempfile(HTACCESS, ">$self->{'user_module_config_directory'}/htlist");
foreach $f (@_) {
	$self->print_tempfile(HTACCESS, $f,"\n");
	}
$self->close_tempfile(HTACCESS);
}


1;

