#!/usr/bin/perl
package htaccess::Mod_access;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'htaccess::Mod_access');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# mod_access.pl
# Defines editors for host restriction directives

1;

1;
		return $self;
}

sub mod_access_directives
{
	my $self = shift;

local($rv);
$rv = [ [ 'allow deny order', 1, 4, 'directory htaccess' ] ];
return $self->make_directives($rv, $_[0], "mod_access");
}

sub edit_allow_deny_order
{
	my $self = shift;

local($d, @w, $i, @type, @mode, @what, $rv);
foreach $d (@{$_[0]}, @{$_[1]}) {
	@w = split(/\s+/, $d->{'value'});
	for($i=1; $i<@w; $i++) {
		push(@type, lc($d->{'name'}) eq "allow" ? 1 : 2);
		push(@what, $w[$i]);
		if ($w[$i] =~ /^env=(\S+)$/) {
			$what[$#what] = $1;
			push(@mode, 6);
			}
		elsif ($w[$i] =~ /^[0-9\.]+\/[0-9]+$/) { push(@mode, 5); }
		elsif ($w[$i] =~ /^[0-9\.]+\/[0-9\.]+$/) { push(@mode, 4); }
		elsif ($w[$i] =~ /^\d+\.\d+\.\d+\.\d+$/) { push(@mode, 2); }
		elsif ($w[$i] =~ /^[0-9\.]+$/) { push(@mode, 3); }
		elsif ($w[$i] eq "all") { push(@mode, 0); }
		else { push(@mode, 1); }
		}
	}
push(@type, ""); push(@what, ""); push(@mode, 0);
$rv = "<i>$self->{'text_hash'}->{'mod_access_order'}</i>\n".
      $self->choice_input($_[2]->[0]->{'value'}, "order", "",
       "$self->{'text_hash'}->{'mod_access_denyallow'},deny,allow", "$self->{'text_hash'}->{'mod_access_allowdeny'},allow,deny",
       "$self->{'text_hash'}->{'mod_access_mutual'},mutual-failure", "$self->{'text_hash'}->{'mod_access_default'},")."<br>\n";
$rv .= "<table border>\n".
       "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'mod_access_action'}</b></td> <td><b>$self->{'text_hash'}->{'mod_access_cond'}</b></td> </tr>\n";
@{$self->{'sels_array'}} = ("$self->{'text_hash'}->{'mod_access_all'},0", "$self->{'text_hash'}->{'mod_access_host'},1",
	 "$self->{'text_hash'}->{'mod_access_ip'},2", "$self->{'text_hash'}->{'mod_access_pip'},3");
if ($_[3]->{'version'} >= 1.3) {
	push(@{$self->{'sels_array'}}, "$self->{'text_hash'}->{'mod_access_mask'},4",
		    "$self->{'text_hash'}->{'mod_access_cidr'},5");
	}
if ($_[3]->{'version'} >= 1.2) {
	push(@{$self->{'sels_array'}}, "$self->{'text_hash'}->{'mod_access_var'},6");
	}
for($i=0; $i<@type; $i++) {
	$rv .= "<tr $self->{'cb'}> <td>".$self->select_input($type[$i], "allow_type_$i", "",
	       ",0", "$self->{'text_hash'}->{'mod_access_allow'},1", "$self->{'text_hash'}->{'mod_access_deny'},2")."</td>\n";
	$rv .= "<td>".$self->select_input($mode[$i], "allow_mode_$i", "0", @{$self->{'sels_array'}});
	$rv .= sprintf "<input name=allow_what_$i size=20 value=\"%s\"></td>\n",
	        $mode[$i] ? $what[$i] : "";
	$rv .= "</tr>\n";
	}
$rv .= "</table>\n";
return (2, "$self->{'text_hash'}->{'mod_access_restr'}", $rv);
}

sub save_allow_deny_order
{
	my $self = shift;

local($i, $type, $mode, $what, @allow, @deny);
for($i=0; defined($type = $self->{'in_hash'}->{"allow_type_$i"}); $i++) {
	$mode = $self->{'in_hash'}->{"allow_mode_$i"}; $what = $self->{'in_hash'}->{"allow_what_$i"};
	if (!$type) { next; }
	if ($mode == 0) { $what = "all"; }
	elsif ($mode == 2 && !$self->check_ipaddress($what) &&
			     !$self->check_ip6address($what)) {
		$self->error($self->text('mod_access_eip', $what));
		}
	elsif ($mode == 3 && $what !~ /^[0-9\.]+$/) {
		$self->error($self->text('mod_access_epip', $what));
		}
	elsif ($mode == 4 && ($what !~ /^([0-9\.:]+)\/([0-9\.:]+)$/ ||
	       (!$self->check_ipaddress($1) && !$self->check_ip6address($1)) ||
	       (!$self->check_ipaddress($2) && !$self->check_ip6address($2)))) {
		$self->error($self->text('mod_access_emask', $what));
		}
	elsif ($mode == 5 && ($what !~ /^([0-9\.:]+)\/([0-9]+)$/ ||
	       !$self->check_ipaddress($1) || $2 > 32)) {
		$self->error($self->text('mod_access_ecidr', $what));
		}
	elsif ($mode == 6) {
		$what =~ /^\S+$/ ||
			$self->error($self->text('mod_access_evar', $what));
		$what = "env=$what";
		}
	if ($type == 1) { push(@allow, "from $what"); }
	else { push(@deny, "from $what"); }
	}
return ( \@allow, \@deny, $self->parse_choice("order", ""));
}


1;

