#!/usr/bin/perl
package htaccess::Mod_auth_digest;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'htaccess::Mod_auth_digest');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# mod_auth_digest.pl
# Defines editors for digest authentication directives

1;
		return $self;
}

sub mod_auth_digest_directives
{
	my $self = shift;

local($rv);
$rv = [ [ 'AuthDigestAuthoritative', 0, 4, 'directory htaccess' ],
	[ 'AuthDigestProvider', 0, 4, 'directory htaccess' ],
	[ 'AuthDigestAlgorithm', 0, 4, 'directory htaccess' ],
      ];
return $self->make_directives($rv, $_[0], "mod_auth_digest");
}

sub edit_AuthDigestAuthoritative
{
	my $self = shift;

return (1, $self->{'text_hash'}->{'mod_auth_digest_pass'},
       $self->choice_input($_[0]->{'value'}, "AuthDigestAuthoritative", "",
       "$self->{'text_hash'}->{'yes'},off", "$self->{'text_hash'}->{'no'},on", "$self->{'text_hash'}->{'default'},") );
}

sub save_AuthDigestAuthoritative
{
	my $self = shift;

return $self->parse_choice("AuthDigestAuthoritative", "");
}

sub edit_AuthDigestProvider
{
	my $self = shift;

return (1, $self->{'text_hash'}->{'mod_auth_digest_prov'},
	$self->ui_select("AuthDigestProvider", $_[0] ?  $_[0]->{'words'} : [ ],
		   [ [ "file", $self->{'text_hash'}->{'mod_auth_basic_file'} ],
		     [ "dbm", $self->{'text_hash'}->{'mod_auth_basic_dbm'} ] ],
		   3, 1, 1));
}

sub save_AuthDigestProvider
{
	my $self = shift;

local $p = $self->{'in_hash'}->{'AuthDigestProvider'};
return ( $p ? [ join(" ", split(/\0/, $p)) ] : [ ] );
}

sub edit_AuthDigestAlgorithm
{
	my $self = shift;

return (1, $self->{'text_hash'}->{'mod_auth_digest_al'},
       $self->choice_input($_[0]->{'value'}, "AuthDigestAlgorithm", "",
       "MD5", "MD5-sess", "$self->{'text_hash'}->{'default'},") );
}

sub save_AuthDigestAlgorithm
{
	my $self = shift;

return $self->parse_choice("AuthDigestAlgorithm", "");
}

sub edit_AuthDigestDomain
{
	my $self = shift;

return (2,
	$self->{'text_hash'}->{'mod_auth_digest_domain'},
	$self->opt_input($_[0]->{'value'}, "AuthDigestDomain", $self->{'text_hash'}->{'core_default'}, 50));
}

sub save_AuthDigestDomain
{
	my $self = shift;

return $self->parse_opt("AuthDigestDomain", '\S',
		  $self->{'text_hash'}->{'mod_auth_digest_edomain'});
}


1;

