#!/usr/bin/perl
package htaccess::Mod_authz_dbm;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'htaccess::Mod_authz_dbm');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# mod_authz_dbm.pl
# Defines editors for user text-file authentication directives

1;
		return $self;
}

sub mod_authz_dbm_directives
{
	my $self = shift;

local($rv);
$rv = [ [ 'AuthDBMGroupFile', 0, 4, 'directory htaccess' ],
	[ 'AuthzDBMAuthoritative', 0, 4, 'directory htaccess' ],
	[ 'AuthzDBMType', 0, 4, 'directory htaccess', 2.030, -1 ] ];
return $self->make_directives($rv, $_[0], "mod_authz_dbm");
}

sub edit_AuthDBMGroupFile
{
	my $self = shift;

return (2, $self->{'text_hash'}->{'mod_auth_dbm_gfile'},
       $self->opt_input($_[0]->{'value'}, "AuthDBMGroupFile", $self->{'text_hash'}->{'default'}, 45).
       $self->file_chooser_button("AuthDBMGroupFile", 0));
}

sub save_AuthDBMGroupFile
{
	my $self = shift;

$self->{'in_hash'}->{'AuthDBMGroupFile_def'} || $self->allowed_auth_file($self->{'in_hash'}->{'AuthDBMGroupFile'}) ||
        $self->error($self->{'text_hash'}->{'mod_auth_egdir'});
return $self->parse_opt("AuthDBMGroupFile", '^\S+$', $self->{'text_hash'}->{'mod_auth_dbm_egfile'});
}

sub edit_AuthzDBMAuthoritative
{
	my $self = shift;

return (2, $self->{'text_hash'}->{'mod_auth_dbm_gpass'},
       $self->choice_input($_[2]->{'value'}, "AuthzDBMAuthoritative", "",
       "$self->{'text_hash'}->{'yes'},off", "$self->{'text_hash'}->{'no'},on", "$self->{'text_hash'}->{'default'},"));
}

sub save_AuthzDBMAuthoritative
{
	my $self = shift;

return $self->parse_choice("AuthzDBMAuthoritative", "");
}

sub edit_AuthzDBMType
{
	my $self = shift;

return (1, $self->{'text_hash'}->{'mod_auth_dbm_gtype'},
	$self->select_input($_[0]->{'value'}, "AuthzDBMType", "",
		      "$self->{'text_hash'}->{'default'},", "GDBM,GDBM", "SDBM,SDBM",
					   "NDBM,NDBM", "DB,DB",
		      "$self->{'text_hash'}->{'mod_auth_dbm_default'},default"));
}

sub save_AuthzDBMType
{
	my $self = shift;

return $self->parse_select("AuthzDBMType", "");
}


1;

