#!/usr/bin/perl
package htaccess::Mod_authz_groupfile;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'htaccess::Mod_authz_groupfile');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# mod_authz_groupfile.pl
# Defines editors for user text-file authentication directives

1;
		return $self;
}

sub mod_authz_groupfile_directives
{
	my $self = shift;

local($rv);
$rv = [ [ 'AuthGroupFile', 0, 4, 'directory htaccess' ] ];
return $self->make_directives($rv, $_[0], "mod_authz_groupfile");
}

sub edit_AuthGroupFile
{
	my $self = shift;

local $uf = $_[0] && -r "list_authgroups.cgi" ? 1 : 0;
return (2, $self->{'text_hash'}->{'mod_auth_gfile'},
       $self->opt_input($_[0]->{'value'}, "AuthGroupFile", $self->{'text_hash'}->{'default'}, 45).
       $self->file_chooser_button("AuthGroupFile", 0).
       ($uf ? "&nbsp;<a href=\"list_authgroups.cgi?file=".$_[0]->{'value'}.
       "&url=".$self->urlize($self->this_url())."\">$self->{'text_hash'}->{'mod_auth_gedit'}</a>" : ""));
}

sub save_AuthGroupFile
{
	my $self = shift;

$self->{'in_hash'}->{'AuthGroupFile_def'} || $self->allowed_auth_file($self->{'in_hash'}->{'AuthGroupFile'}) ||
        $self->error($self->{'text_hash'}->{'mod_auth_egdir'});
return $self->parse_opt("AuthGroupFile", '^\S+$', $self->{'text_hash'}->{'mod_auth_egfile'});
}


1;

