#!/usr/bin/perl
package htaccess::Mod_cache;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'htaccess::Mod_cache');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# mod_cache.pl
# Functions that have been moved out of mod_proxy in apache 2.0

&ModuleLoader::preload_module(ref($self), "htaccess::Cache");
$self = new htaccess::Cache:: ref($self), %$self; 

1;
		return $self;
}

sub mod_cache_directives
{
	my $self = shift;

local $rv;
$rv = [ [ 'CacheDefaultExpire', 0, 13.1, 'virtual', 2.0 ],
	[ 'CacheEnable CacheDisable', 1, 13.1, 'virtual', 2.0 ],
#	[ 'CacheIgnoreCacheControl', 0, 13.1, 'virtual', 2.0 ],
#	[ 'CacheIgnoreNoLastMod', 0, 13.1, 'virtual', 2.0 ],
        [ 'CacheLastModifiedFactor', 0, 13.1, 'virtual', 2.0 ],
	[ 'CacheMaxExpire', 0, 13.1, 'virtual', 2.0 ],
	[ 'CacheOn', 0, 13.1, 'virtual', 2.0, 10 ] ];
return $self->make_directives($rv, $_[0], "mod_cache");
}

sub edit_CacheEnable_CacheDisable
{
	my $self = shift;

local $rv = "<table border>\n".
	    "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'cache_enable'}</b></td>\n".
	    "<td><b>$self->{'text_hash'}->{'cache_type'}</b></td>\n".
	    "<td><b>$self->{'text_hash'}->{'cache_url'}</b></td> </tr>\n";
local ($c, $i = 0);
foreach $c (@{$_[0]}, @{$_[1]}, { }) {
	$rv .= "<tr $self->{'cb'}>\n";
	$rv .= "<td><select name=CacheEnable_e_$i>\n";
	$rv .= sprintf "<option value=0 %s>&nbsp;\n",
			$c ? "" : "selected";
	$rv .= sprintf "<option value=1 %s>%s\n",
			$c->{'name'} eq 'CacheEnable' ? 'selected' : '',
			$self->{'text_hash'}->{'yes'};
	$rv .= sprintf "<option value=2 %s>%s\n",
			$c->{'name'} eq 'CacheDisable' ? 'selected' : '',
			$self->{'text_hash'}->{'no'};
	$rv .= "</select></td> <td><select name=CacheEnable_t_$i>\n";
	$rv .= sprintf "<option value=disk %s> %s\n",
			$c->{'words'}->[0] eq 'disk' ? 'selected' : '',
			$self->{'text_hash'}->{'cache_disk'};
	$rv .= sprintf "<option value=mem %s> %s\n",
			$c->{'words'}->[0] eq 'mem' ? 'selected' : '',
			$self->{'text_hash'}->{'cache_mem'};
	$rv .= "</select></td>\n";
	$rv .= sprintf "<td><input name=CacheEnable_u_$i size=20 value='%s'></td>\n", $c->{'name'} eq 'CacheEnable' ? $c->{'words'}->[1] : $c->{'words'}->[0];
	$rv .= "</tr>\n";
	$i++;
	}
$rv .= "</table>\n";
return (2, $self->{'text_hash'}->{'cache_endis'}, $rv);
}

sub save_CacheEnable_CacheDisable
{
	my $self = shift;

local ($i, @en, @dis);
for($i=0; defined($self->{'in_hash'}->{"CacheEnable_e_$i"}); $i++) {
	next if (!$self->{'in_hash'}->{"CacheEnable_e_$i"});
	$self->{'in_hash'}->{"CacheEnable_u_$i"} =~ /^\S+$/ || $self->error($self->{'text_hash'}->{'cache_eurl'});
	if ($self->{'in_hash'}->{"CacheEnable_e_$i"} == 1) {
		push(@en, $self->{'in_hash'}->{"CacheEnable_t_$i"}." ".$self->{'in_hash'}->{"CacheEnable_u_$i"});
		}
	else {
		push(@dis, $self->{'in_hash'}->{"CacheEnable_u_$i"});
		}
	}
return ( \@en, \@dis );
}

sub edit_CacheIgnoreCacheControl
{
	my $self = shift;

return (1, $self->{'text_hash'}->{'cache_control'},
        $self->choice_input($_[0]->{'value'}, "CacheIgnoreCacheControl", "off",
                      "$self->{'text_hash'}->{'yes'},on", "$self->{'text_hash'}->{'no'},off"));
}

sub save_CacheIgnoreCacheControl
{
	my $self = shift;

return $self->parse_choice("CacheIgnoreCacheControl", "off");
}

sub edit_CacheIgnoreNoLastMod
{
	my $self = shift;

return (1, $self->{'text_hash'}->{'cache_lastmod'},
        $self->choice_input($_[0]->{'value'}, "CacheIgnoreNoLastMod", "off",
                      "$self->{'text_hash'}->{'yes'},on", "$self->{'text_hash'}->{'no'},off"));
}

sub save_CacheIgnoreNoLastMod
{
	my $self = shift;

return $self->parse_choice("CacheIgnoreNoLastMod", "off");
}

sub edit_CacheOn
{
	my $self = shift;

return (1, $self->{'text_hash'}->{'cache_on'},
        $self->choice_input($_[0]->{'value'}, "CacheOn", "off",
                      "$self->{'text_hash'}->{'yes'},on", "$self->{'text_hash'}->{'no'},off"));
}

sub save_CacheOn
{
	my $self = shift;

return $self->parse_choice("CacheOn", "off");
}


1;

