#!/usr/bin/perl
package htaccess::Mod_cgi;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'htaccess::Mod_cgi');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# mod_cgi.pl
# Defines editors CGI logging directives

1;

1;
		return $self;
}

sub mod_cgi_directives
{
	my $self = shift;

local($rv);
$rv = [ [ 'ScriptLog', 0, 11, 'global', 1.2 ],
        [ 'ScriptLogLength', 0, 11, 'global', 1.2 ],
        [ 'ScriptLogBuffer', 0, 11, 'global', 1.2 ] ];
return $self->make_directives($rv, $_[0], "mod_cgi");
}

sub mod_cgi_handlers
{
	my $self = shift;

return ("cgi-script");
}

sub edit_ScriptLog
{
	my $self = shift;

return (1, "$self->{'text_hash'}->{'mod_cgi_logname'}",
        $self->opt_input($_[0]->{'value'}, "ScriptLog", "$self->{'text_hash'}->{'mod_cgi_none'}", 20).
        $self->file_chooser_button("ScriptLog", 0));
}

sub save_ScriptLog
{
	my $self = shift;

$self->{'in_hash'}->{'ScriptLog_def'} || $self->allowed_auth_file($self->{'in_hash'}->{'ScriptLog'}) ||
	$self->error($self->{'text_hash'}->{'mod_cgi_eunder'});
return $self->parse_opt("ScriptLog", '^\S+$', "$self->{'text_hash'}->{'mod_cgi_elogname'}");
}

sub edit_ScriptLogLength
{
	my $self = shift;

return (1, "$self->{'text_hash'}->{'mod_cgi_logsize'}",
        $self->opt_input($_[0]->{'value'}, "ScriptLogLength", "$self->{'text_hash'}->{'mod_cgi_default'}", 8)
		.$self->{'text_hash'}->{'bytes'});
}

sub save_ScriptLogLength
{
	my $self = shift;

return $self->parse_opt("ScriptLogLength", '^\d+$', "$self->{'text_hash'}->{'mod_cgi_elogsize'}");
}

sub edit_ScriptLogBuffer
{
	my $self = shift;

return (1, "$self->{'text_hash'}->{'mod_cgi_post'}",
        $self->opt_input($_[0]->{'value'}, "ScriptLogBuffer", "$self->{'text_hash'}->{'mod_cgi_default'}", 6)
		.$self->{'text_hash'}->{'bytes'});
}

sub save_ScriptLogBuffer
{
	my $self = shift;

return $self->parse_opt("ScriptLogBuffer", '^\d+$', "$self->{'text_hash'}->{'mod_cgi_epost'}");
}


1;

