#!/usr/bin/perl
package htaccess::Mod_dav;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'htaccess::Mod_dav');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# mod_dav.pl
# Editors for DAV directives

1;

1;
		return $self;
}

sub mod_dav_directives
{
	my $self = shift;

local $rv;
$rv = [ [ 'Dav', 0, 5, 'directory' ],
	[ 'DavDepthInfinity', 0, 5, 'virtual directory' ],
	[ 'DavMinTimeout', 0, 5, 'virtual directory' ],
      ];
return $self->make_directives($rv, $_[0], "mod_dav");
}

sub edit_Dav
{
	my $self = shift;

local @extra;
push(@extra, "$_[0]->{'value'},$_[0]->{'value'}")
	if ($_[0]->{'value'} && $_[0]->{'value'} !~ /^(on|off)$/i);
return (1, $self->{'text_hash'}->{'mod_dav_active'},
	$self->choice_input($_[0]->{'value'}, "Dav", "",
	      "$self->{'text_hash'}->{'yes'},on", "$self->{'text_hash'}->{'no'},off", @extra, "$self->{'text_hash'}->{'default'},"));
}

sub save_Dav
{
	my $self = shift;

return $self->parse_choice("Dav");
}

sub edit_DavDepthInfinity
{
	my $self = shift;

return (1, $self->{'text_hash'}->{'mod_dav_inf'},
	$self->choice_input($_[0]->{'value'}, "DavDepthInfinity", "",
	      "$self->{'text_hash'}->{'yes'},on", "$self->{'text_hash'}->{'no'},off", "$self->{'text_hash'}->{'default'},"));
}

sub save_DavDepthInfinity
{
	my $self = shift;

return $self->parse_choice("DavDepthInfinity");
}

sub edit_DavMinTimeout
{
	my $self = shift;

return (1,
	$self->{'text_hash'}->{'mod_dav_timeout'},
	$self->opt_input($_[0]->{'value'}, "DavMinTimeout", $self->{'text_hash'}->{'default'}, 4));
}

sub save_DavMinTimeout
{
	my $self = shift;

return $self->parse_opt("DavMinTimeout", '^\d+$',
		  $self->{'text_hash'}->{'mod_dav_etimeout'});
}


1;

