#!/usr/bin/perl
package htaccess::Mod_imap;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'htaccess::Mod_imap');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# mod_imap.pl
# Defines editors for imagemap directives

1;

1;
		return $self;
}

sub mod_imap_directives
{
	my $self = shift;

$self->{'rv'} = [ [ 'ImapMenu', 0, 20, 'virtual directory htaccess' ],
        [ 'ImapDefault', 0, 20, 'virtual directory htaccess' ],
        [ 'ImapBase', 0, 20, 'virtual directory htaccess' ] ];
return $self->make_directives($self->{'rv'}, $_[0], "mod_imap");
}

sub mod_imap_handlers
{
	my $self = shift;

return ("imap-file");
}

sub edit_ImapMenu
{
	my $self = shift;

return (2, "$self->{'text_hash'}->{'mod_imap_action'}",
        $self->select_input($_[0]->{'value'}, "ImapMenu", "", "$self->{'text_hash'}->{'mod_imap_default'},",
         "$self->{'text_hash'}->{'mod_imap_godefurl'},none", "$self->{'text_hash'}->{'mod_imap_form'},formatted",
         "$self->{'text_hash'}->{'mod_imap_semiform'},semiformatted",
         "$self->{'text_hash'}->{'mod_imap_unform'},unformatted"));
}

sub save_ImapMenu
{
	my $self = shift;

return $self->parse_select("ImapMenu", "");
}

sub edit_ImapDefault
{
	my $self = shift;

local($rv, $v);
if ($_[0]->{'value'} =~ /^\S+:/) { $v = "url"; }
else { $v = $_[0]->{'value'}; }
$rv = $self->select_input($v, "ImapDefault", "", "$self->{'text_hash'}->{'mod_imap_default'},",
       "$self->{'text_hash'}->{'mod_imap_disperr'},error",  "$self->{'text_hash'}->{'mod_imap_donoth'},nocontent",
       "$self->{'text_hash'}->{'mod_imap_goimap'},map", "$self->{'text_hash'}->{'mod_imap_goref'},referer",
       "$self->{'text_hash'}->{'mod_imap_gourl'},url");
$rv .= sprintf "&nbsp;<input name=ImapDefault_url size=30 value=\"%s\">\n",
        $v eq "url" ? $_[0]->{'value'} : "";
return (2, "$self->{'text_hash'}->{'mod_imap_defact'}", $rv);
}

sub save_ImapDefault
{
	my $self = shift;

if ($self->{'in_hash'}->{'ImapDefault'} eq "") { return ( [ ] ); }
elsif ($self->{'in_hash'}->{'ImapDefault'} ne "url") { return ( [ $self->{'in_hash'}->{'ImapDefault'} ] ); }
elsif ($self->{'in_hash'}->{'ImapDefault_url'} !~ /^\S+$/) {
	$self->error($self->text('mod_imap_eurl', $self->{'in_hash'}->{'ImapDefault_url'}));
	}
else { return ( [ $self->{'in_hash'}->{'ImapDefault_url'} ] ); }
}

sub edit_ImapBase
{
	my $self = shift;

local($rv, $v);
if ($_[0]->{'value'} =~ /^\S+:/) { $v = "url"; }
else { $v = $_[0]->{'value'}; }
$rv = $self->select_input($v, "ImapBase", "", "$self->{'text_hash'}->{'mod_imap_default2'},",
       "$self->{'text_hash'}->{'mod_imap_root'},root", "$self->{'text_hash'}->{'mod_imap_imapurl'},map",
       "$self->{'text_hash'}->{'mod_imap_refurl'},referer", "$self->{'text_hash'}->{'mod_imap_url'},url");
$rv .= sprintf "&nbsp;<input name=ImapBase_url size=30 value=\"%s\">\n",
        $v eq "url" ? $_[0]->{'value'} : "";
return (2, "$self->{'text_hash'}->{'mod_imap_defbase'}", $rv);
}

sub save_ImapBase
{
	my $self = shift;

if ($self->{'in_hash'}->{'ImapBase'} eq "") { return ( [ ] ); }
elsif ($self->{'in_hash'}->{'ImapBase'} ne "url") { return ( [ $self->{'in_hash'}->{'ImapBase'} ] ); }
elsif ($self->{'in_hash'}->{'ImapBase_url'} !~ /^\S+$/) {
	$self->error($self->text('mod_imap_eurl', $self->{'in_hash'}->{'ImapBase_url'}));
	}
else { return ( [ $self->{'in_hash'}->{'ImapBase_url'} ] ); }
}


1;

