#!/usr/bin/perl
package htaccess::Mod_log_common;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'htaccess::Mod_log_common');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# mod_log_common.pl
# Defines editors for logging

1;

1;
		return $self;
}

sub mod_log_common_directives
{
	my $self = shift;

$self->{'rv'} = [ [ 'TransferLog', 0, 3, 'virtual', -1.2 ] ];
return $self->make_directives($self->{'rv'}, $_[0], "mod_log_common");
}

sub edit_TransferLog
{
	my $self = shift;

local($rv);
$rv = sprintf "<input type=radio name=TransferLog_mode value=0 %s> Default\n",
       $_[0] ? "" : "checked";
$rv .= sprintf "<input type=radio name=TransferLog_mode value=1 %s> File..",
	 $_[0] && $_[0]->{'value'} !~ /^\|/ ? "checked" : "";
$rv .= sprintf "<input type=radio name=TransferLog_mode value=2 %s> Program..",
	 $_[0]->{'value'} =~ /^\|/ ? "checked" : "";
$rv .= sprintf "<input name=TransferLog size=20 value=\"%s\">\n",
        $_[0]->{'value'} =~ /^\|(.*)$/ ? $1 : $_[0]->{'value'};
return (1, "Access log file", $rv); 
}

sub save_TransferLog
{
	my $self = shift;

if ($self->{'in_hash'}->{'TransferLog_mode'} == 0) { return ( [ ] ); }
$self->{'in_hash'}->{'TransferLog'} =~ /^\S+$/ ||
	$self->error("$self->{'in_hash'}->{'TransferLog'} is not a valid access log filename");
$self->allowed_auth_file($self->{'in_hash'}->{'TransferLog'}) ||
	$self->error("access log is not under the allowed directory");
if ($self->{'in_hash'}->{'TransferLog_mode'} == 1) { return ( [ $self->{'in_hash'}->{'TransferLog'} ] ); }
else { return ( [ "|$self->{'in_hash'}->{'TransferLog'}" ] ); }
}


1;

