#!/usr/bin/perl
package htaccess::Mod_log_referer;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'htaccess::Mod_log_referer');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# mod_log_referer.pl
# Defines editors for logging

1;

1;
		return $self;
}

sub mod_log_referer_directives
{
	my $self = shift;

$self->{'rv'} = [ [ 'RefererLog', 0, 3, 'virtual' ],
        [ 'RefererIgnore', 0, 3, 'virtual' ] ];
return $self->make_directives($self->{'rv'}, $_[0], "mod_log_referer");
}

sub edit_RefererLog
{
	my $self = shift;

local($rv);
$rv = sprintf "<input type=radio name=RefererLog_mode value=0 %s> $self->{'text_hash'}->{'mod_log_referer_default'}\n",
       $_[0] ? "" : "checked";
$rv .= sprintf "<input type=radio name=RefererLog_mode value=1 %s> $self->{'text_hash'}->{'mod_log_referer_file'}",
	 $_[0] && $_[0]->{'value'} !~ /^\|/ ? "checked" : "";
$rv .= sprintf "<input type=radio name=RefererLog_mode value=2 %s> $self->{'text_hash'}->{'mod_log_referer_program'}",
	 $_[0]->{'value'} =~ /^\|/ ? "checked" : "";
$rv .= sprintf "<input name=RefererLog size=20 value=\"%s\">\n",
        $_[0]->{'value'} =~ /^\|(.*)$/ ? $1 : $_[0]->{'value'};
return (1, "$self->{'text_hash'}->{'mod_log_referer_log'}", $rv); 
}

sub save_RefererLog
{
	my $self = shift;

if ($self->{'in_hash'}->{'RefererLog_mode'} == 0) { return ( [ ] ); }
$self->{'in_hash'}->{'RefererLog'} =~ /^\S+$/ ||
	$self->error($self->text('mod_log_referer_elog', $self->{'in_hash'}->{'RefererLog'}));
$self->allowed_auth_file($self->{'in_hash'}->{'RefererLog'}) ||
	$self->error($self->{'text_hash'}->{'mod_log_referer_edir'});
if ($self->{'in_hash'}->{'RefererLog_mode'} == 1) { return ( [ $self->{'in_hash'}->{'RefererLog'} ] ); }
else { return ( [ "|$self->{'in_hash'}->{'RefererLog'}" ] ); }
}

sub edit_RefererIgnore
{
	my $self = shift;

local($rv);
$rv = "<textarea name=RefererIgnore rows=3 cols=20>".
      join("\n", split(/\s+/, $_[0]->{'value'})).
      "</textarea>\n";
return (1, "$self->{'text_hash'}->{'mod_log_referer_nolog'}", $rv);
}

sub save_RefererIgnore
{
	my $self = shift;

local(@rv);
@rv = split(/\s+/, $self->{'in_hash'}->{'RefererIgnore'});
if (@rv) { return ( [ join(' ', @rv) ] ); }
else { return ( [ ] ); }
}


1;

