#!/usr/bin/perl
package htaccess::Mod_mem_cache;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'htaccess::Mod_mem_cache');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# mod_mem_cache.pl
# Memory-caching related functions

&ModuleLoader::preload_module(ref($self), "htaccess::Cache");
$self = new htaccess::Cache:: ref($self), %$self; 

1;
		return $self;
}

sub mod_mem_cache_directives
{
	my $self = shift;

local $rv;
$rv = [ [ 'CacheSize', 0, 13.1, 'virtual', 2.0 ],
	[ 'CacheMaxObjectCount', 0, 13.1, 'virtual', 2.0 ],
	[ 'CacheMinObjectSize', 0, 13.1, 'virtual', 2.0 ],
	[ 'CacheMaxObjectSize', 0, 13.1, 'virtual', 2.0 ] ];
return $self->make_directives($rv, $_[0], "mod_mem_cache");
}

sub edit_CacheMaxObjectCount
{
	my $self = shift;

return (1, $self->{'text_hash'}->{'cache_maxoc'},
	$self->opt_input($_[0]->{'value'}, "CacheMaxObjectCount", $self->{'text_hash'}->{'default'},8));
}

sub save_CacheMaxObjectCount
{
	my $self = shift;

return $self->parse_opt("CacheMaxObjectCount", '^\d+$', $self->{'text_hash'}->{'cache_emaxoc'});
}

sub edit_CacheMinObjectSize
{
	my $self = shift;

return (1, $self->{'text_hash'}->{'cache_minos'},
	$self->opt_input($_[0]->{'value'}, "CacheMinObjectSize", $self->{'text_hash'}->{'default'},8));
}

sub save_CacheMinObjectSize
{
	my $self = shift;

return $self->parse_opt("CacheMinObjectSize", '^\d+$', $self->{'text_hash'}->{'cache_eminos'});
}

sub edit_CacheMaxObjectSize
{
	my $self = shift;

return (1, $self->{'text_hash'}->{'cache_maxos'},
	$self->opt_input($_[0]->{'value'}, "CacheMaxObjectSize", $self->{'text_hash'}->{'default'},8));
}

sub save_CacheMaxObjectSize
{
	my $self = shift;

return $self->parse_opt("CacheMaxObjectSize", '^\d+$', $self->{'text_hash'}->{'cache_emaxos'});
}


1;

