#!/usr/bin/perl
package htaccess::Mod_suexec;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'htaccess::Mod_suexec');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# mod_suexec.pl
# Editors for per-virtuser suexec directives

1;
		return $self;
}

sub mod_suexec_directives
{
	my $self = shift;

local $rv;
$rv = [ [ 'SuexecUserGroup', 0, 8, 'virtual', 2.0 ] ];
return $self->make_directives($rv, $_[0], "mod_suexec");
}

sub edit_SuexecUserGroup
{
	my $self = shift;

local $rv;
$rv .= sprintf "<input type=radio name=SuexecUserGroup_def value=1 %s> %s\n",
		$_[0] ? "" : "checked", $self->{'text_hash'}->{'suexec_none'};
$rv .= sprintf "<input type=radio name=SuexecUserGroup_def value=0 %s>\n",
		$_[0] ? "checked" : "";
$rv .= sprintf "%s <input name=SuexecUserGroup_u size=8 value='%s'> %s\n",
		$self->{'text_hash'}->{'suexec_user'}, $_[0]->{'words'}->[0],
		$self->user_chooser_button("SuexecUserGroup_u");
$rv .= sprintf "%s <input name=SuexecUserGroup_g size=8 value='%s'> %s\n",
		$self->{'text_hash'}->{'suexec_group'}, $_[0]->{'words'}->[1],
		$self->group_chooser_button("SuexecUserGroup_g");
return (2, $self->{'text_hash'}->{'suexec_su'}, $rv);
}

sub save_SuexecUserGroup
{
	my $self = shift;

if ($self->{'in_hash'}->{'SuexecUserGroup_def'}) {
	return ( [ ] );
	}
else {
	$self->{'in_hash'}->{'SuexecUserGroup_u'} =~ /^#-?\d+$/ ||
		defined(getpwnam($self->{'in_hash'}->{'SuexecUserGroup_u'})) ||
			$self->error($self->{'text_hash'}->{'suexec_euser'});
	$self->{'in_hash'}->{'SuexecUserGroup_g'} =~ /^#-?\d+$/ ||
		defined(getgrnam($self->{'in_hash'}->{'SuexecUserGroup_g'})) ||
			$self->error($self->{'text_hash'}->{'suexec_egroup'});
	return ( [ $self->{'in_hash'}->{'SuexecUserGroup_u'}." ".$self->{'in_hash'}->{'SuexecUserGroup_g'} ] );
	}
}


1;

