#!/usr/bin/perl
package htaccess::Mod_userdir;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'htaccess::Mod_userdir');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# mod_userdir.pl
# Defines editors user WWW dir directives

1;

1;
		return $self;
}

sub mod_userdir_directives
{
	my $self = shift;

local($rv);
$rv = [ [ 'UserDir', 1, 5, 'virtual', 1.3, 6 ],
	[ 'UserDir', 0, 5, 'virtual', -1.3, 6 ] ];
return $self->make_directives($rv, $_[0], "mod_userdir");
}

sub edit_UserDir
{
	my $self = shift;

$self->{'fmt'} = "<input type=radio name=UserDir_def value=1 %s> $self->{'text_hash'}->{'mod_userdir_default'}&nbsp\n".
       "<input type=radio name=UserDir_def value=0 %s>\n".
       "<input name=UserDir size=20 value=\"%s\"><br>\n";
if ($_[1]->{'version'} >= 1.3) {
	local($d, $v, $ud, $rv, @uinfo, $mode, @disabled, @enabled, $_, @ulist);
	foreach $d (@{$_[0]}) {
		$v = $d->{'value'};
		if ($v =~ /^(disabled|enabled)\s*(.*)$/) {
			if ($1 eq "disabled" && !$2) { $mode = 2; }
			elsif ($1 eq "disabled")
				{ $mode = 1; push(@disabled, split(/\s+/, $2)); }
			else { push(@enabled, split(/\s+/, $2)); }
			}
		else { $ud = $d->{'words'}->[0]; }
		}
	if ($mode == 1) {
		# only selected users disabled
		@ulist = @disabled;
		}
	elsif ($mode == 2) {
		# only selected users enabled
		local %dis;
		foreach (@disabled) { $dis{$_}++; }
		@ulist = grep { !$dis{$_} } @enabled;
		}
	$rv = sprintf $self->{'fmt'}, $ud ? "" : "checked", $ud ? "checked" : "", $ud;
	$rv .= sprintf "<input type=radio name=UserDir_mode value=0 %s>\n",
			$mode==0 ? "checked" : "";
	$rv .= "$self->{'text_hash'}->{'mod_userdir_all'}<br>\n";
	$rv .= sprintf "<input type=radio name=UserDir_mode value=1 %s>\n",
			$mode==1 ? "checked" : "";
	$rv .= "$self->{'text_hash'}->{'mod_userdir_except'} <input name=UserDir_deny size=20 value=\"".
	       ($mode==1 ? join(" ", @ulist) : "")."\"> ".
	       $self->user_chooser_button("UserDir_deny",1)."<br>\n";
	$rv .= sprintf "<input type=radio name=UserDir_mode value=2 %s>\n",
			$mode==2 ? "checked" : "";
	$rv .= "Only users <input name=UserDir_allow size=20 value=\"".
	       ($mode==2 ? join(" ", @ulist) : "")."\"> ".
	       $self->user_chooser_button("UserDir_allow",1);
	return (2, "$self->{'text_hash'}->{'mod_userdir_dir'}", $rv);
	}
else {
	return (1, "$self->{'text_hash'}->{'mod_userdir_dir'}",
	        sprintf $self->{'fmt'}, $_[0] ? "" : "checked", $_[0] ? "checked" : "",
	                      $_[0]->{'value'} );
	}
}

sub save_UserDir
{
	my $self = shift;

if ($_[0]->{'version'} >= 1.3) {
	local(@ud);
	if ($self->{'in_hash'}->{'UserDir_mode'} == 1)
		{ @ud = ("disabled $self->{'in_hash'}->{'UserDir_deny'}"); }
	elsif ($self->{'in_hash'}->{'UserDir_mode'} == 2)
		{ @ud = ("disabled", "enabled $self->{'in_hash'}->{'UserDir_allow'}"); }
	if (!$self->{'in_hash'}->{'UserDir_def'}) {
		$self->{'in_hash'}->{'UserDir'} !~ /^\// ||
		  $self->allowed_doc_dir($self->{'in_hash'}->{'UserDir'}) ||
		    $self->error($self->{'text_hash'}->{'mod_userdir_edir'});
		push(@ud, "\"$self->{'in_hash'}->{'UserDir'}\"");
		}
	return ( \@ud );
	}
else {
	if ($self->{'in_hash'}->{'UserDir_def'}) { return ( [ ] ); }
	else { return ( [ $self->{'in_hash'}->{'UserDir'} ] ); }
	}
}


1;

