#!/usr/bin/perl

&MAIN();

 sub MAIN {
# manual.cgi
# Display a text box for manually editing directives

&ModuleLoader::preload_module('htaccess_class', "htaccess::HtaccessLib");
$self = new htaccess::HtaccessLib:: 'htaccess_class',%$self;

$self->ReadParse();
if (defined($self->{'in_hash'}->{'idx'})) {
	# files within .htaccess file
	$self->{'hconf'} = $self->get_htaccess_config($self->{'in_hash'}->{'file'});
	$self->{'d'} = $self->{'hconf'}->[$self->{'in_hash'}->{'idx'}];
	$self->{'file'} = $self->{'in_hash'}->{'file'};
	$self->{'start'} = $self->{'d'}->{'line'}+1; $self->{'end'} = $self->{'d'}->{'eline'}-1;
	$self->{'title'} = $self->text('htfile_header', $self->dir_name($self->{'d'}),
		       "<tt>$self->{'in_hash'}->{'file'}</tt>");
	$self->{'return'} = "htaccess_index.cgi"; $self->{'rmsg'} = $self->{'text_hash'}->{'htindex_return'};
	}
else {
	# .htaccess file
	$self->{'file'} = $self->{'in_hash'}->{'file'};
	$self->{'title'} = $self->text('htindex_header', "<tt>$self->{'in_hash'}->{'file'}</tt>");
	$self->{'return'} = "htaccess_index.cgi"; $self->{'rmsg'} = $self->{'text_hash'}->{'htindex_return'};
	$self->{'dir'} = "files_index.cgi";
	}
$self->ui_print_header($self->{'title'}, $self->{'text_hash'}->{'manual_title'}, "");

print $self->text('manual_header', "<tt>$self->{'file'}</tt>"),"<p>\n";
print "<form action=manual_save.cgi method=post enctype=multipart/form-data>\n";
foreach $h ('virt', 'idx', 'file') {
	if (defined($self->{'in_hash'}->{$h})) {
		print "<input type=hidden name=$h value='$self->{'in_hash'}->{$h}'>\n";
		push(@{$self->{'args_array'}}, "$h=$self->{'in_hash'}->{$h}");
		}
	}
$self->{'args'} = join('&', @{$self->{'args_array'}});

print "<textarea rows=15 cols=80 name=directives>\n";
$self->{'lref'} = $self->read_file_lines($self->{'file'});
if (!defined($self->{'start'})) {
	$self->{'start'} = 0;
	$self->{'end'} = @{$self->{'lref'}} - 1;
	}
for($i=$self->{'start'}; $i<=$self->{'end'}; $i++) {
	print $self->html_escape($self->{'lref'}->[$i]),"\n";
	}
print "</textarea><br><input type=submit value=\"$self->{'text_hash'}->{'save'}\"></form>\n";

$self->ui_print_footer("$self->{'return'}?$self->{'args'}", $self->{'rmsg'});

1;
		
}

# print_directives(&list, indent)
sub print_directives
{
	shift if ($self == $_[0]);

foreach $c (@{$_[0]}) {
	next if ($c->{'name'} eq 'dummy');
	if ($c->{'type'}) {
		print $_[1],"<",$c->{'name'}," ",$c->{'value'},">\n";
		&print_directives($c->{'members'}, $_[1].' ');
		print $_[1],"</",$c->{'name'},">\n";
		}
	else {
		print $_[1],$c->{'name'}," ",$c->{'value'},"\n";
		}
	}
}


1;

