#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Create, update or delete a group

&ModuleLoader::preload_module('htaccess_htpasswd_class', "htaccess_htpasswd::HtaccessLib");
$self = new htaccess_htpasswd::HtaccessLib:: 'htaccess_htpasswd_class',%$self;

$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'gsave_err'});
@{$self->{'dirs_array'}} = $self->list_directories();
($self->{'dir'}) = grep { $_->[0] eq $self->{'in_hash'}->{'dir'} } @{$self->{'dirs_array'}};
$self->can_access_dir($self->{'dir'}->[0]) || $self->error($self->{'text_hash'}->{'dir_ecannot'});
$self->lock_file($self->{'dir'}->[1]);

$self->switch_user();
$self->{'groups'} = $self->list_groups($self->{'dir'}->[4]);
if (!$self->{'in_hash'}->{'new'}) {
	$self->{'group'} = $self->{'groups'}->[$self->{'in_hash'}->{'idx'}];
	$self->{'loggroup'} = $self->{'group'}->{'group'};
	}
else {
	$self->{'loggroup'} = $self->{'in_hash'}->{'group'};
	}

if ($self->{'in_hash'}->{'delete'}) {
	# Just delete this group
	$self->delete_group($self->{'group'});
	}
else {
	# Validate inputs
	$self->{'in_hash'}->{'group'} || $self->error($self->{'text_hash'}->{'gsave_egroup1'});
	$self->{'in_hash'}->{'group'} =~ /:/ && $self->error($self->{'text_hash'}->{'gsave_egroup2'});
	$self->{'in_hash'}->{'group'} =~ /^\S+$/ || $self->error($self->{'text_hash'}->{'gsave_egroup2'});
	if ($self->{'in_hash'}->{'new'} || $self->{'group'}->{'group'} ne $self->{'in_hash'}->{'group'}) {
		($self->{'clash'}) = grep { $_->{'group'} eq $self->{'in_hash'}->{'group'} } @{$self->{'groups'}};
		$self->{'clash'} && $self->error($self->{'text_hash'}->{'gsave_eclash'});
		}

	# Actually save
	$self->{'group'}->{'group'} = $self->{'in_hash'}->{'group'};
	$self->{'group'}->{'enabled'} = $self->{'in_hash'}->{'enabled'};
	$self->{'group'}->{'members'} = [ split(/\s+/, $self->{'in_hash'}->{'members'}) ];
	if ($self->{'in_hash'}->{'new'}) {
		$self->create_group($self->{'group'}, $self->{'dir'}->[4]);
		}
	else {
		$self->modify_group($self->{'group'});
		}
	}
$self->switch_back();

$self->unlock_file($self->{'dir'}->[1]);
$self->webmin_log($self->{'in_hash'}->{'delete'} ? "delete" : $self->{'in_hash'}->{'new'} ? "create" : "modify",
	    "group", $self->{'loggroup'}, $self->{'group'});
$self->redirect("");

1;
		
}


1;

