#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_user.cgi
# Create, update or delete a password file user

&ModuleLoader::preload_module('htaccess_htpasswd_class', "htaccess_htpasswd::HtaccessLib");
$self = new htaccess_htpasswd::HtaccessLib:: 'htaccess_htpasswd_class',%$self;

$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'save_err'});
@{$self->{'dirs_array'}} = $self->list_directories();
($self->{'dir'}) = grep { $_->[0] eq $self->{'in_hash'}->{'dir'} } @{$self->{'dirs_array'}};
$self->can_access_dir($self->{'dir'}->[0]) || $self->error($self->{'text_hash'}->{'dir_ecannot'});
$self->lock_file($self->{'dir'}->[1]);

$self->switch_user();
$self->{'users'} = $self->{'dir'}->[2] == 3 ? $self->list_digest_users($self->{'dir'}->[1])
			: $self->list_users($self->{'dir'}->[1]);
if (!$self->{'in_hash'}->{'new'}) {
	$self->{'user'} = $self->{'users'}->[$self->{'in_hash'}->{'idx'}];
	$self->{'loguser'} = $self->{'user'}->{'user'};
	}
else {
	$self->{'loguser'} = $self->{'in_hash'}->{'htuser'};
	}

if ($self->{'in_hash'}->{'delete'}) {
	# Just delete this user
	$self->delete_user($self->{'user'});
	}
else {
	# Validate inputs
	$self->{'in_hash'}->{'htuser'} || $self->error($self->{'text_hash'}->{'save_euser1'});
	$self->{'in_hash'}->{'htuser'} =~ /:/ && $self->error($self->{'text_hash'}->{'save_euser2'});
	if ($self->{'in_hash'}->{'new'} || $self->{'user'}->{'user'} ne $self->{'in_hash'}->{'htuser'}) {
		($self->{'clash'}) = grep { $_->{'user'} eq $self->{'in_hash'}->{'htuser'} } @{$self->{'users'}};
		$self->{'clash'} && $self->error($self->{'text_hash'}->{'save_eclash'});
		}
	!$self->{'in_hash'}->{'htpass_def'} && $self->{'in_hash'}->{'htpass'} =~ /:/ &&
		$self->error($self->{'text_hash'}->{'save_epass'});

	# Actually save
	$self->{'user'}->{'user'} = $self->{'in_hash'}->{'htuser'};
	if (!$self->{'in_hash'}->{'htpass_def'}) {
		if ($self->{'dir'}->[2] == 3) {
			$self->{'user'}->{'pass'} = $self->digest_password($self->{'in_hash'}->{'htuser'},
					$self->{'in_hash'}->{'dom'}, $self->{'in_hash'}->{'htpass'});
			}
		else {
			$self->{'user'}->{'pass'} = $self->encrypt_password(
					$self->{'in_hash'}->{'htpass'}, undef, $self->{'dir'}->[2]);
			}
		}
	$self->{'user'}->{'enabled'} = $self->{'in_hash'}->{'enabled'};
	if ($self->{'dir'}->[2] == 3) {
		$self->{'in_hash'}->{'dom'} =~ /^\S+$/ && $self->{'in_hash'}->{'dom'} !~ /:/ ||
			$self->error($self->{'text_hash'}->{'save_edom'});
		$self->{'user'}->{'dom'} = $self->{'in_hash'}->{'dom'};
		$self->{'user'}->{'digest'} = 1;
		}
	if ($self->{'in_hash'}->{'new'}) {
		$self->create_user($self->{'user'}, $self->{'dir'}->[1]);
		}
	else {
		$self->modify_user($self->{'user'});
		}
	}
$self->switch_back();

$self->unlock_file($self->{'dir'}->[1]);
$self->webmin_log($self->{'in_hash'}->{'delete'} ? "delete" : $self->{'in_hash'}->{'new'} ? "create" : "modify",
	    "user", $self->{'loguser'}, $self->{'user'});
$self->redirect("");

1;
		
}


1;

