#!/usr/bin/perl

&MAIN();

 sub MAIN {
# index.cgi
# List the mail messages for the user

&ModuleLoader::preload_module('mailbox_class', "mailbox::MailboxLib");
$self = new mailbox::MailboxLib:: 'mailbox_class',%$self;

$self->ReadParse();

$self->open_read_hash();
$self->open_dsn_hash();

@{$self->{'folders_array'}} = $self->list_folders_sorted();
if (defined($self->{'in_hash'}->{'id'})) {
	# Folder ID specified .. convert to index
	$self->{'idf'} = $self->find_named_folder($self->{'in_hash'}->{'id'}, \@{$self->{'folders_array'}});
	$self->{'in_hash'}->{'folder'} = $self->{'idf'}->{'index'} if ($self->{'idf'});
	}
elsif (!defined($self->{'in_hash'}->{'folder'}) && $self->{'userconfig_hash'}->{'default_folder'}) {
	# No folder specified .. find the default by preferences
	$self->{'df'} = $self->find_named_folder($self->{'userconfig_hash'}->{'default_folder'}, \@{$self->{'folders_array'}});
	$self->{'in_hash'}->{'folder'} = $self->{'df'}->{'index'} if ($self->{'df'});
	}
# Get the folder by index
($self->{'folder'}) = grep { $_->{'index'} == $self->{'in_hash'}->{'folder'} } @{$self->{'folders_array'}};

# Show page header
print "Refresh: $self->{'userconfig_hash'}->{'refresh'}\r\n"
	if ($self->{'userconfig_hash'}->{'refresh'});
($self->{'qtotal'}, $self->{'qcount'}, $self->{'totalquota'}, $self->{'countquota'}) = $self->get_user_quota();
if ($self->{'totalquota'}) {
	push(@{$self->{'topright_array'}}, $self->text('mail_quota', $self->nice_size($self->{'qtotal'}),
				     $self->nice_size($self->{'totalquota'})));
	}
if (($self->{'folder'}->{'type'} == 2 || $self->{'folder'}->{'type'} == 4) &&
    $self->{'folder'}->{'mode'} == 3 && defined($self->{'folder'}->{'user'}) &&
    !$self->{'folder'}->{'autouser'}) {
	push(@{$self->{'topright_array'}}, "<a href='inbox_logout.cgi?folder=$self->{'folder'}->{'index'}'>".
			($self->{'folder'}->{'type'} == 2 ? $self->{'text_hash'}->{'mail_logout'}
						: $self->{'text_hash'}->{'mail_logout2'}).
			"</a>");
	}
$self->ui_print_header(undef, $self->{'text_hash'}->{'mail_title'}, "", undef, 1, 1, 0, join("<br>", @{$self->{'topright_array'}}));
print $self->check_clicks_function();

# Check if this is a POP3 or IMAP inbox with no login set
if (($self->{'folder'}->{'type'} == 2 || $self->{'folder'}->{'type'} == 4) &&
    $self->{'folder'}->{'mode'} == 3 && !$self->{'folder'}->{'autouser'} && !$self->{'folder'}->{'user'}) {
	print "<center>\n";
	print $self->ui_form_start("inbox_login.cgi", "post");
	print $self->ui_hidden("folder", $self->{'folder'}->{'index'}),"\n";
	print $self->ui_table_start(
	      $self->{'folder'}->{'type'} == 2 ? $self->{'text_hash'}->{'mail_loginheader'}
				     : $self->{'text_hash'}->{'mail_loginheader2'}, undef, 2);
	print "<tr $self->{'cb'}> <td align=middle colspan=2>",$self->text('mail_logindesc',
			"<tt>$self->{'folder'}->{'server'}</tt>"),"</td> </tr>\n";

	print $self->ui_table_row($self->{'text_hash'}->{'mail_loginuser'},
			    $self->ui_textbox("user", $self->{'remote_user'}, 30));
	print $self->ui_table_row($self->{'text_hash'}->{'mail_loginpass'},
			    $self->ui_password("pass", $self->{'remote_pass'}, 30));

	#if ($self->{'folder'}->{'type'} == 4) {
	#	print "<tr> <td valign=top><b>$self->{'text_hash'}->{'mail_loginmailbox'}",
	#	      "</b></td> <td>\n";
	#	printf"<input type=radio name=mailbox_def value=1 %s> %s<br>\n",
	#		"checked", $self->{'text_hash'}->{'edit_imapinbox'};
	#	printf"<input type=radio name=mailbox_def value=0> %s\n",
	#		$self->{'text_hash'}->{'edit_imapother'};
	#	print "<input name=mailbox size=20></td> </tr>\n";
	#	}

	print $self->ui_table_end();
	print $self->ui_form_end([ [ "login", $self->{'text_hash'}->{'mail_login'} ] ]);
	print "</center>\n";

	$self->ui_print_footer($self->{'text_hash'}->{'index_mainpage_url'}, $self->{'text_hash'}->{'index_mainpage'});
	exit;
	}

# Get folder-selection HTML
$self->{'sel'} = $self->folder_select(\@{$self->{'folders_array'}}, $self->{'folder'}, "id", undef, 1);

# Work out start from jump page
$self->{'perpage'} = $self->{'folder'}->{'perpage'} || $self->{'userconfig_hash'}->{'perpage'} || 20;
if ($self->{'in_hash'}->{'jump'} =~ /^\d+$/ && $self->{'in_hash'}->{'jump'} > 0) {
	$self->{'in_hash'}->{'start'} = ($self->{'in_hash'}->{'jump'}-1)*$self->{'perpage'};
	}

# View mail in sort order
@{$self->{'mail_array'}} = $self->mailbox_list_mails_sorted(
		int($self->{'in_hash'}->{'start'}), int($self->{'in_hash'}->{'start'})+$self->{'perpage'}-1,
	        $self->{'folder'}, 1, \@{$self->{'error_array'}});
if ($self->{'in_hash'}->{'start'} >= @{$self->{'mail_array'}} && $self->{'in_hash'}->{'jump'}) {
	# Jumped too far!
	$self->{'in_hash'}->{'start'} = @{$self->{'mail_array'}} - $self->{'perpage'};
	@{$self->{'mail_array'}} = $self->mailbox_list_mails_sorted(int($self->{'in_hash'}->{'start'}),
					   int($self->{'in_hash'}->{'start'})+$self->{'perpage'}-1,
					   $self->{'folder'}, 1, \@{$self->{'error_array'}});
	}

# Show page flipping arrows
&show_arrows();

print "<form action=delete_mail.cgi method=post name='DELETE'>\n";
print "<input type=hidden name=folder value='$self->{'folder'}->{'index'}'>\n";
print "<input type=hidden name=mod value=",$self->modification_time($self->{'folder'}),">\n";
print "<input type=hidden name=start value='$self->{'in_hash'}->{'start'}'>\n";
if ($self->{'userconfig_hash'}->{'top_buttons'} && @{$self->{'mail_array'}}) {
	# $self->show_mailbox_buttons(1, \@{$self->{'folders_array'}}, $self->{'folder'}, \@{$self->{'mail_array'}});
	@{$self->{'links_array'}} = ( $self->select_all_by_name_link("d", "DELETE"),
		   $self->select_invert_by_name_link("d", "DELETE") );
	($self->{'sortfield'}, $self->{'sortdir'}) = $self->get_sort_field($self->{'folder'});
	if ($self->{'sortfield'}) {
		# Show un-sort link
		push(@{$self->{'links_array'}}, "<a href='sort.cgi?folder=$self->{'folder'}->{'index'}&start=$self->{'start'}'>$self->{'text_hash'}->{'mail_nosort'}</a>");
		}
	print $self->ui_links_row(\@{$self->{'links_array'}});
	}

# Generate mail list headers
$self->{'showto'} = $self->{'folder'}->{'show_to'};
$self->{'showfrom'} = $self->{'folder'}->{'show_from'};
if (@{$self->{'mail_array'}}) {
	@cols = ( "" );
	@{$self->{'tds_array'}} = ( "width=5" );
	if ($self->{'showfrom'}) {
		push(@cols, $self->field_sort_link($self->{'text_hash'}->{'mail_from'}, "from",
					     $self->{'folder'}, $self->{'in_hash'}->{'start'}));
		push(@{$self->{'tds_array'}}, $self->{'showto'} ? "nowrap width=15%"
				   : "nowrap width=30%");
		}
	if ($self->{'showto'}) {
		push(@cols, $self->field_sort_link($self->{'text_hash'}->{'mail_to'}, "to",
					     $self->{'folder'}, $self->{'in_hash'}->{'start'}));
		push(@{$self->{'tds_array'}}, $self->{'showfrom'} ? "nowrap width=15%"
				     : "nowrap width=30%");
		}
	push(@cols, $self->field_sort_link($self->{'text_hash'}->{'mail_date'}, "date",
                                      $self->{'folder'}, $self->{'in_hash'}->{'start'}));
	push(@{$self->{'tds_array'}}, "nowrap width=15%");
	push(@cols, $self->field_sort_link($self->{'text_hash'}->{'mail_size'}, "size",
                                      $self->{'folder'}, $self->{'in_hash'}->{'start'}));
	push(@{$self->{'tds_array'}}, "nowrap width=10%");
	if ($self->{'folder'}->{'spam'}) {
		push(@cols, $self->field_sort_link($self->{'text_hash'}->{'mail_level'}, "x-spam-status",
					      $self->{'folder'}, $self->{'in_hash'}->{'start'}));
		push(@{$self->{'tds_array'}}, "width=2%");
		}
	push(@cols, $self->field_sort_link($self->{'text_hash'}->{'mail_subject'}, "subject",
                                      $self->{'folder'}, $self->{'in_hash'}->{'start'}));
	push(@{$self->{'tds_array'}}, "width=50%");
	print $self->ui_columns_start(\@cols, "100", 0, \@{$self->{'tds_array'}});
	}
if (@{$self->{'error_array'}}) {
	print "<center><b><font color=#ff0000>\n";
	print $self->text('mail_err', $self->{'error_array'}->[0] == 0 ? $self->{'error_array'}->[1] :
			      $self->text('save_elogin', $self->{'error_array'}->[1])),"\n";
	print "</font></b></center>\n";
	}

# Show the actual email
for($i=int($self->{'in_hash'}->{'start'}); $i<@{$self->{'mail_array'}} && $i<$self->{'in_hash'}->{'start'}+$self->{'perpage'}; $i++) {
	local ($bs, $be);
	$self->{'m'} = $self->{'mail_array'}->[$i];
	$self->{'mid'} = $self->{'m'}->{'header'}->{'message-id'};
	if ($self->{'read_hash'}->{$self->{'mid'}} == 2) {
		# Special
		($bs, $be) = ("<b><i>", "</i></b>");
		}
	elsif ($self->{'read_hash'}->{$self->{'mid'}} == 0) {
		# Unread
		($bs, $be) = ("<b>", "</b>");
		}
	$self->notes_decode($self->{'m'}, $self->{'folder'});
	local $idx = $self->{'m'}->{'idx'};
	local @cols;

	# From and To columns, with links
	if ($self->{'showfrom'}) {
		push(@cols, $bs.$self->view_mail_link($self->{'folder'}, $i, $self->{'in_hash'}->{'start'},
				      $self->{'m'}->{'header'}->{'from'}, $self->{'mid'}).$be);
		}
	if ($self->{'showto'}) {
		push(@cols, $bs.$self->view_mail_link($self->{'folder'}, $i, $self->{'in_hash'}->{'start'},
		      $self->{'m'}->{'header'}->{'to'}, $self->{'mid'}).$be);
		}

	# Date and size columns
	push(@cols, $bs.$self->simplify_date($self->{'m'}->{'header'}->{'date'}).$be);
	push(@cols, $bs.$self->nice_size($self->{'m'}->{'size'}, 1024).$be);

	# Spam score
	if ($self->{'folder'}->{'spam'}) {
		if ($self->{'m'}->{'header'}->{'x-spam-status'} =~ /(hits|score)=([0-9\.]+)/) {
			push(@cols, $bs.$2.$be);
			}
		else {
			push(@cols, "");
			}
		}

	# Subject column, with read/special icons
	local @icons = $self->message_icons($self->{'m'}, $self->{'folder'}->{'sent'});
	push(@cols, $bs.$self->simplify_subject($self->{'m'}->{'header'}->{'subject'}).
		    " ".join("&nbsp;", @icons).$be);

	if ($self->editable_mail($self->{'m'})) {
		print $self->ui_checked_columns_row(\@cols, \@{$self->{'tds_array'}}, "d", "$i/$self->{'mid'}");
		}
	else {
		print $self->ui_columns_row([ "", @cols ], \@{$self->{'tds_array'}});
		}
	$self->update_delivery_notification($self->{'mail_array'}->[$i], $self->{'folder'});

	# Show part of the body too
	if ($self->{'userconfig_hash'}->{'show_body'}) {
		$self->parse_mail($self->{'m'});
		local $data = $self->mail_preview($self->{'m'});
                if ($data) {
                        print "<tr $self->{'cb'}> <td colspan=",(scalar(@cols)+1),"><tt>",
                                $self->html_escape($data),"</tt></td> </tr>\n";
                        }
		}
	}
if (@{$self->{'mail_array'}}) {
	print $self->ui_columns_end();
	print $self->ui_links_row(\@{$self->{'links_array'}});
	}

$self->show_mailbox_buttons(2, \@{$self->{'folders_array'}}, $self->{'folder'}, \@{$self->{'mail_array'}});
print "</form>\n";
if ($self->{'userconfig_hash'}->{'arrows'}) {
	# Show page flipping arrows
	print "<br>\n";
	&show_arrows();
	}

# Show search form
print "<hr>\n";
print "<table width=100%><tr>\n";

if ($self->{'folder'}->{'searchable'}) {
	# Simple search
	print "<form action=mail_search.cgi><td width=33%>\n";
	print "<input type=hidden name=folder value='$self->{'folder'}->{'index'}'>\n";
	print "<input type=hidden name=simple value=1>\n";
	print "<input type=submit value='$self->{'text_hash'}->{'mail_search2'}'>\n";
	print "<input name=search size=20></td></form>\n";

	# Advanced search
	# $jumpform = (@{$self->{'mail_array'}} > $self->{'perpage'});
	print "<form action=search_form.cgi>\n";
	print "<input type=hidden name=folder value='$self->{'folder'}->{'index'}'>\n";
	print "<td width=33% align=center><input type=submit name=advanced ",
	      "value='$self->{'text_hash'}->{'mail_advanced'}'></td>\n";
	print "</form>\n";
	}

if ($self->{'folder'}->{'spam'}) {
	# Spam level search
	print "<form action=mail_search.cgi><td width=33% align=right>\n";
	print "<input type=hidden name=folder value='$self->{'folder'}->{'index'}'>\n";
	print "<input type=hidden name=spam value=1>\n";
	print "<input type=submit value='$self->{'text_hash'}->{'mail_search3'}'>\n";
	print "<input name=score size=5></td></form>\n";
	}
print "</tr>\n";

# Show various buttons for the address book, folders, sig and searches
print "<tr>\n";

print "<form action=list_addresses.cgi>\n";
print "<td align=left width=33%><input type=submit value='$self->{'text_hash'}->{'mail_addresses'}'></td>\n";
print "</form>\n";

if ($self->{'config_hash'}->{'mail_system'} == 4) {
	print "<form action=list_ifolders.cgi>\n";
	}
else {
	print "<form action=list_folders.cgi>\n";
	}
print "<td align=",($self->{'bc'} == 2 ? "right" : "center"),
      " width=33%><input type=submit value='$self->{'text_hash'}->{'mail_folders'}'></td>\n";
print "</form>\n";

if ($self->get_signature_file()) {
	print "<form action=edit_sig.cgi>\n";
	print "<td width=33% align=right>",
	      "<input type=submit value='$self->{'text_hash'}->{'mail_sig'}'></td>\n";
	print "</form>\n";
	}
else {
	print "<td width=33% align=right></td>\n";
	}
print "</tr>\n";

print "<tr>\n";
if ($self->{'folder'}->{'trash'} || $self->{'userconfig_hash'}->{'show_delall'}) {
	# Show button to delete all mail in folder
	print "<form action=delete_mail.cgi>\n";
	print "<input type=hidden name=folder value='$self->{'folder'}->{'index'}'>\n";
	print "<input type=hidden name=all value=1>\n";
	print "<td width=33%><input type=submit name=delete value='",
		($self->{'folder'}->{'trash'} ? $self->{'text_hash'}->{'mail_deltrash'}
				    : $self->{'text_hash'}->{'mail_delall'}),"'></td>\n";
	print "</form>\n";
	}
else {
	print "<td width=33%></td>\n";
	}

print "<td align=center width=33%></td>\n";

print "</tr>\n";

print "</table>\n";

$self->ui_print_footer($self->{'text_hash'}->{'index_mainpage_url'}, $self->{'text_hash'}->{'index_mainpage'});
$self->pop3_logout();

1;
		
}

# show_arrows()
# Prints HTML for previous/next page arrows
sub show_arrows
{
	shift if ($self == $_[0]);

print "<br><center>\n";
print "<form action=index.cgi style='display:inline'><font size=+1>\n";

# Show left arrow to go to start of folder
if ($self->{'in_hash'}->{'start'}) {
	printf "<a href='index.cgi?start=%d&folder=%d'>%s</a>\n",
		0, $self->{'in_hash'}->{'folder'},
		'<img src=../images/first.gif border=0 align=middle>';
	}
else {
	print "<img src=../images/first-grey.gif align=middle>\n";
	}

# Show left arrow to decrease start
if ($self->{'in_hash'}->{'start'}) {
	printf "<a href='index.cgi?start=%d&folder=%d'>%s</a>\n",
		$self->{'in_hash'}->{'start'}-$self->{'perpage'}, $self->{'in_hash'}->{'folder'},
		'<img src=../images/left.gif border=0 align=middle>';
	}
else {
	print "<img src=../images/left-grey.gif align=middle>\n";
	}

local $s = $self->{'in_hash'}->{'start'}+1;
local $e = $self->{'in_hash'}->{'start'}+$self->{'perpage'};
$e = scalar(@{$self->{'mail_array'}}) if ($e > @{$self->{'mail_array'}});
if (@{$self->{'mail_array'}}) {
	print $self->text('mail_pos', $s, $e, scalar(@{$self->{'mail_array'}}), $self->{'sel'});
	}
else {
	print $self->text('mail_none', $self->{'sel'});
	}
print "</font><input type=submit value='$self->{'text_hash'}->{'mail_fchange'}'>\n";

# Show right arrow to increase start
if ($self->{'in_hash'}->{'start'}+$self->{'perpage'} < @{$self->{'mail_array'}}) {
	printf "<a href='index.cgi?start=%d&folder=%d'>%s</a>\n",
		$self->{'in_hash'}->{'start'}+$self->{'perpage'}, $self->{'in_hash'}->{'folder'},
		'<img src=../images/right.gif border=0 align=middle>';
	}
else {
	print "<img src=../images/right-grey.gif align=middle>\n";
	}

# Show right arrow to go to end
if ($self->{'in_hash'}->{'start'}+$self->{'perpage'} < @{$self->{'mail_array'}}) {
	printf "<a href='index.cgi?start=%d&folder=%d'>%s</a>\n",
		int((scalar(@{$self->{'mail_array'}})-$self->{'perpage'}-1)/$self->{'perpage'} + 1)*$self->{'perpage'}, $self->{'in_hash'}->{'folder'},
		'<img src=../images/last.gif border=0 align=middle>';
	}
else {
	print "<img src=../images/last-grey.gif align=middle>\n";
	}

if ($self->{'folder'}->{'msg'}) {
	print "<br>$self->{'folder'}->{'msg'}\n";
	}
print "</form>";

# Show page jump form
$self->{'jumpform'} = (@{$self->{'mail_array'}} > $self->{'perpage'});
if ($self->{'jumpform'}) {
       print "<form style='display:inline'><input type=hidden name=folder value='$self->{'folder'}->{'index'}'>\n";
       print "<input type=submit value='$self->{'text_hash'}->{'mail_jump'}'>\n";
       printf "<input name=jump size=3 value='%s'> %s %s\n",
               int($self->{'in_hash'}->{'start'} / $self->{'perpage'})+1, $self->{'text_hash'}->{'mail_of'},
               int(@{$self->{'mail_array'}} / $self->{'perpage'});
       print "</form>";
       }
print "</center><br>\n";
}


1;

