#!/usr/bin/perl

&MAIN();

 sub MAIN {
# list_folders.cgi
# Display a list of all folders and allows additional and deletion

&ModuleLoader::preload_module('mailbox_class', "mailbox::MailboxLib");
$self = new mailbox::MailboxLib:: 'mailbox_class',%$self;

$self->ui_print_header(undef, $self->{'text_hash'}->{'folders_title'}, "");

print "$self->{'text_hash'}->{'folders_desc2'}<br>\n";
print "<ul>\n";
foreach $ft ('sys', 'local', 'ext', 'pop3', 'imap', 'comp', 'virt') {
	print "<li>",$self->{'text_hash'}->{'folders_desc'.$ft},"\n"
		if ($ft eq "sys" || $self->{'folder_types_hash'}->{$ft});
	}
print "</ul>\n";

print $self->ui_form_start("delete_folders.cgi", "post");
@{$self->{'tds_array'}} = ( "width=5" );
@{$self->{'folders_array'}} = $self->list_folders_sorted();
print $self->ui_columns_start([ "",
			  $self->{'text_hash'}->{'folders_name'},
			  $self->{'text_hash'}->{'folders_path'},
			  $self->{'text_hash'}->{'folders_type'},
			  $self->{'text_hash'}->{'folders_size'},
			  $self->{'text_hash'}->{'folders_action'} ], undef, 0, \@{$self->{'tds_array'}});
foreach $f (@{$self->{'folders_array'}}) {
	local @cols;
	local $deletable = 0;
	if ($f->{'inbox'} || $f->{'drafts'} || $f->{'spam'}) {
		# Inbox, drafs or spam folder which cannot be edited
		push(@cols, $f->{'name'});
		}
	elsif ($f->{'type'} == 2) {
		# Link for editing POP3 folder
		push(@cols, "<a href='edit_pop3.cgi?idx=$f->{'index'}'>".
			    "$f->{'name'}</a>");
		$deletable = 1;
		}
	elsif ($f->{'type'} == 4) {
		# Link for editing IMAP folder
		push(@cols, "<a href='edit_imap.cgi?idx=$f->{'index'}'>".
			    "$f->{'name'}</a>");
		$deletable = 1;
		}
	elsif ($f->{'mode'} == 2 && !$self->{'folder_types_hash'}->{'ext'}) {
		# Sent mail folder can only be changed if external folders
		# are allowed
		push(@cols, $f->{'name'});
		}
	elsif ($f->{'type'} == 5) {
		# Link for editing composite folder
		push(@cols, "<a href='edit_comp.cgi?idx=$f->{'index'}'>".
			    "$f->{'name'}</a>");
		$deletable = 1;
		}
	elsif ($f->{'type'} == 6) {
		# Link for editing virtual folder
		push(@cols, "<a href='edit_virt.cgi?idx=$f->{'index'}'>".
			    "$f->{'name'}</a>");
		$deletable = 1;
		}
	else {
		# Link for editing local or external folder
		push(@cols, "<a href='edit_folder.cgi?idx=$f->{'index'}'>".
			    "$f->{'name'}</a>");
		$deletable = 1;
		}
	if ($f->{'type'} == 2 || $f->{'type'} == 4) {
		# Show mail server
		push(@cols, $self->text(
			$f->{'port'} ? 'folders_servp' : 'folders_serv',
			"<tt>$f->{'user'}</tt>", "<tt>$f->{'server'}</tt>",
			"<tt>$f->{'port'}</tt>"));
		push(@cols, $f->{'type'} == 2 ? "POP3" : "IMAP");
		push(@cols, undef);
		}
	elsif ($f->{'type'} == 5) {
		# Show number of sub-folders and total size
		push(@cols, $self->text('folders_num',
				   scalar(@{$f->{'subfolders'}}),
				   $self->mailbox_folder_size($f, 1)));
		push(@cols, $self->{'text_hash'}->{'folders_comp'});
		push(@cols, $self->nice_size($self->folder_size($f)));
		}
	elsif ($f->{'type'} == 6) {
		# Show number of messages
		push(@cols, $self->text('folders_vnum', $self->mailbox_folder_size($f, 1)));
		push(@cols, $self->{'text_hash'}->{'folders_virt'});
		push(@cols, undef);
		}
	else {
		# Show folder directory and size
		local $mf = $self->folder_file($f);
		push(@cols, $mf);
		push(@cols, $f->{'type'} == 1 ? $self->{'text_hash'}->{'folders_maildir'} :
			    $f->{'type'} == 3 ? $self->{'text_hash'}->{'folders_mhdir'} :
					        $self->{'text_hash'}->{'folders_mbox'});
		push(@cols, $self->nice_size($self->folder_size($f)));
		}

	# Action links
	local @acts;
	push(@acts, "<a href='index.cgi?folder=$f->{'index'}'>".
		    "$self->{'text_hash'}->{'folders_view'}</a>");
	if (!$f->{'nowrite'}) {
		local ($is, $ie);
		$self->{'auto'} = $self->get_auto_schedule($f);
		if ($self->{'auto'} && $self->{'auto'}->{'enabled'}) {
			($is, $ie) = ("<b>", "</b>");
			}
		push(@acts, $is."<a href='edit_auto.cgi?idx=$f->{'index'}'>".
			    "$self->{'text_hash'}->{'folders_auto'}</a>".$ie);
		}
	push(@acts, "<a href='copy_form.cgi?idx=$f->{'index'}'>".
		    "$self->{'text_hash'}->{'folders_copy'}</a>");
	push(@cols, join(" | ", @acts));
	if ($deletable) {
		print $self->ui_checked_columns_row(\@cols, \@{$self->{'tds_array'}},
					      "d", $f->{'index'});
		}
	else {
		print $self->ui_columns_row([ "", @cols ], \@{$self->{'tds_array'}});
		}
	}
print $self->ui_columns_end();
print $self->ui_form_end([ [ "delete", $self->{'text_hash'}->{'folders_delete'} ] ]);

# Show form for adding a folder
print $self->ui_form_start("newfolder.cgi");
@{$self->{'folder_progs_array'}} = ( [ "edit_folder.cgi?new=1&mode=0", "local" ],
		  [ "edit_folder.cgi?new=1&mode=1", "ext" ],
		  [ "edit_pop3.cgi?new=1", "pop3" ],
		  [ "edit_imap.cgi?new=1", "imap" ],
		  [ "edit_comp.cgi?new=1", "comp" ],
		  [ "edit_virt.cgi?new=1", "virt" ] );
@{$self->{'can_folder_progs_array'}} = grep { $self->{'folder_types_hash'}->{$_->[1]} } @{$self->{'folder_progs_array'}};
if (@{$self->{'can_folder_progs_array'}}) {
	print $self->ui_submit($self->{'text_hash'}->{'folders_newfolder'}),"\n";
	print $self->ui_select("prog", $self->{'can_folder_progs_array'}->[0]->[0],
			 [ map { [ $_->[0], $self->{'text_hash'}->{'folders_type_'.$_->[1]} ] }
			       @{$self->{'can_folder_progs_array'}} ]),"\n";
	print "<br>\n";
	}
print $self->ui_form_end();

$self->ui_print_footer("", $self->{'text_hash'}->{'index'});

1;
		
}


1;

