#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Display a list of IMAP folders, and allow addition and deletion

&ModuleLoader::preload_module('mailbox_class', "mailbox::MailboxLib");
$self = new mailbox::MailboxLib:: 'mailbox_class',%$self;

$self->ui_print_header(undef, $self->{'text_hash'}->{'folders_title'}, "");

print $self->ui_form_start("delete_folders.cgi", "post");
@{$self->{'tds_array'}} = ( "width=5" );
@{$self->{'folders_array'}} = $self->list_folders_sorted();
$self->{'adders'} = "<a href='edit_ifolder.cgi?new=1'>$self->{'text_hash'}->{'folders_addimap'}</a>\n".
	  "<a href='edit_comp.cgi?new=1'>$self->{'text_hash'}->{'folders_addcomp'}</a>\n".
	  "<a href='edit_virt.cgi?new=1'>$self->{'text_hash'}->{'folders_addvirt'}</a>\n";
print $self->{'adders'};
print $self->ui_columns_start([ "",
			  $self->{'text_hash'}->{'folders_name'},
			  $self->{'text_hash'}->{'folders_type'},
			  $self->{'text_hash'}->{'folders_size'},
			  $self->{'text_hash'}->{'folders_action'} ], undef, 0, \@{$self->{'tds_array'}});
foreach $f (@{$self->{'folders_array'}}) {
	local @cols;
	local $deletable = 0;
	if ($f->{'inbox'} || $f->{'drafts'} || $f->{'spam'}) {
		# Inbox, drafs or spam folder which cannot be edited
		push(@cols, $f->{'name'});
		push(@cols, "IMAP");
		push(@cols, $self->nice_size($self->folder_size($f)));
		}
	elsif ($f->{'type'} == 5) {
		# Link for editing composite folder
		push(@cols, "<a href='edit_comp.cgi?idx=$f->{'index'}'>".
			    "$f->{'name'}</a>");
		push(@cols, $self->{'text_hash'}->{'folders_comp'});
		push(@cols, $self->nice_size($self->folder_size($f)));
		$deletable = 1;
		}
	elsif ($f->{'type'} == 6) {
		# Link for editing virtual folder
		push(@cols, "<a href='edit_virt.cgi?idx=$f->{'index'}'>".
			    "$f->{'name'}</a>");
		push(@cols, $self->{'text_hash'}->{'folders_virt'});
		push(@cols, undef);
		$deletable = 1;
		}
	else {
		# Edit an IMAP folder
		push(@cols, "<a href='edit_ifolder.cgi?idx=$f->{'index'}'>".
			    "$f->{'name'}</a>");
		push(@cols, "IMAP");
		push(@cols, $self->nice_size($self->folder_size($f)));
		$deletable = 1;
		}

	# Action links
	local @acts;
	push(@acts, "<a href='index.cgi?folder=$f->{'index'}'>".
		    "$self->{'text_hash'}->{'folders_view'}</a>");
	if (!$f->{'nowrite'}) {
		local ($is, $ie);
		$self->{'auto'} = $self->get_auto_schedule($f);
		if ($self->{'auto'} && $self->{'auto'}->{'enabled'}) {
			($is, $ie) = ("<b>", "</b>");
			}
		push(@acts, $is."<a href='edit_auto.cgi?idx=$f->{'index'}'>".
			    "$self->{'text_hash'}->{'folders_auto'}</a>".$ie);
		}
	push(@acts, "<a href='copy_form.cgi?idx=$f->{'index'}'>".
		    "$self->{'text_hash'}->{'folders_copy'}</a>");
	push(@cols, join(" | ", @acts));
	if ($deletable) {
		print $self->ui_checked_columns_row(\@cols, \@{$self->{'tds_array'}},
					      "d", $f->{'index'});
		}
	else {
		print $self->ui_columns_row([ "", @cols ], \@{$self->{'tds_array'}});
		}
	}
print $self->ui_columns_end();
print $self->{'adders'};
print $self->ui_form_end([ [ "delete", $self->{'text_hash'}->{'folders_delete'} ] ]);

$self->ui_print_footer("", $self->{'text_hash'}->{'index'});

1;
		
}


1;

