#!/usr/bin/perl

&MAIN();

 sub MAIN {
# mail_search.cgi
# Find mail messages matching some pattern

&ModuleLoader::preload_module('mailbox_class', "mailbox::MailboxLib");
$self = new mailbox::MailboxLib:: 'mailbox_class',%$self;

$self->ReadParse();
$self->{'limit'} = { };
if (!$self->{'in_hash'}->{'status_def'} && defined($self->{'in_hash'}->{'status'})) {
	$self->{'statusmsg'} = $self->text('search_withstatus',
			   $self->{'text_hash'}->{'view_mark'.$self->{'in_hash'}->{'status'}});
	}
if ($self->{'in_hash'}->{'simple'}) {
	# Make sure a search was entered
	$self->{'in_hash'}->{'search'} || $self->error($self->{'text_hash'}->{'search_ematch'});
	if ($self->{'userconfig_hash'}->{'search_latest'}) {
		$self->{'limit'}->{'latest'} = $self->{'userconfig_hash'}->{'search_latest'};
		}
	}
elsif ($self->{'in_hash'}->{'spam'}) {
	# Make sure a spam score was entered
	$self->{'in_hash'}->{'score'} =~ /^\d+$/ || $self->error($self->{'text_hash'}->{'search_escore'});
	}
else {
	# Validate search fields
	for($i=0; defined($self->{'in_hash'}->{"field_$i"}); $i++) {
		if ($self->{'in_hash'}->{"field_$i"}) {
			$self->{'in_hash'}->{"what_$i"} || $self->error($self->text('search_ewhat', $i+1));
			$self->{'neg'} = $self->{'in_hash'}->{"neg_$i"} ? "!" : "";
			push(@{$self->{'fields_array'}}, [ $self->{'neg'}.$self->{'in_hash'}->{"field_$i"}, $self->{'in_hash'}->{"what_$i"} ]);
			}
		}
	@{$self->{'fields_array'}} || $self->{'statusmsg'} || $self->error($self->{'text_hash'}->{'search_enone'});
	if (!defined($self->{'in_hash'}->{'limit'})) {
		if ($self->{'userconfig_hash'}->{'search_latest'}) {
			$self->{'limit'} = { 'latest' => $self->{'userconfig_hash'}->{'search_latest'} };
			}
		}
	elsif (!$self->{'in_hash'}->{'limit_def'}) {
		$self->{'in_hash'}->{'limit'} =~ /^\d+$/ || $self->error($self->{'text_hash'}->{'search_elatest'});
		$self->{'limit'}->{'latest'} = $self->{'in_hash'}->{'limit'};
		}
	}
if ($self->{'limit'} && $self->{'limit'}->{'latest'}) {
	$self->{'limitmsg'} = $self->text('search_limit', $self->{'limit'}->{'latest'});
	}

@{$self->{'folders_array'}} = $self->list_folders();
if ($self->{'in_hash'}->{'id'}) {
	$self->{'folder'} = $self->find_named_folder($self->{'in_hash'}->{'id'}, \@{$self->{'folders_array'}});
	$self->{'folder'} || $self->error("Failed to find folder $self->{'in_hash'}->{'id'}");
	$self->{'in_hash'}->{'folder'} = $self->{'folder'}->{'index'};
	}
elsif ($self->{'in_hash'}->{'folder'} >= 0) {
	$self->{'folder'} = $self->{'folders_array'}->[$self->{'in_hash'}->{'folder'}];
	}

if ($self->{'in_hash'}->{'simple'}) {
	# Just search by Subject and From (or To) in one folder
	($self->{'mode'}, $self->{'words'}) = $self->parse_boolean($self->{'in_hash'}->{'search'});
	local $who = $self->{'folder'}->{'sent'} ? 'to' : 'from';
	if ($self->{'mode'} == 0) {
		# Search was like 'foo' or 'foo bar'
		# Can just do a single 'or' search
		@{$self->{'searchlist_array'}} = map { ( [ 'subject', $_ ],
				      [ $who, $_ ] ) } @{$self->{'words'}};
		@{$self->{'rv_array'}} = $self->mailbox_search_mail(\@{$self->{'searchlist_array'}}, 0, $self->{'folder'}, $self->{'limit'});
		}
	elsif ($self->{'mode'} == 1) {
		# Search was like 'foo and bar'
		# Need to do two 'and' searches and combine
		@{$self->{'searchlist1_array'}} = map { ( [ 'subject', $_ ] ) } @{$self->{'words'}};
		@{$self->{'rv1_array'}} = $self->mailbox_search_mail(\@{$self->{'searchlist1_array'}}, 1, $self->{'folder'}, $self->{'limit'});
		@{$self->{'searchlist2_array'}} = map { ( [ $who, $_ ] ) } @{$self->{'words'}};
		@{$self->{'rv2_array'}} = $self->mailbox_search_mail(\@{$self->{'searchlist2_array'}}, 1, $self->{'folder'}, $self->{'limit'});
		@{$self->{'rv_array'}} = @{$self->{'rv1_array'}};
		%{$self->{'gotidx_hash'}} = map { $_->{'idx'}, 1 } @{$self->{'rv_array'}};
		foreach $mail (@{$self->{'rv2_array'}}) {
			push(@{$self->{'rv_array'}}, $mail) if (!$self->{'gotidx_hash'}->{$mail->{'idx'}});
			}
		}
	else {
		$self->error($self->{'text_hash'}->{'search_eboolean'});
		}
	foreach $mail (@{$self->{'rv_array'}}) {
		$mail->{'folder'} = $self->{'folder'};
		}
	if ($self->{'statusmsg'}) {
		@{$self->{'rv_array'}} = $self->filter_by_status(\@{$self->{'rv_array'}}, $self->{'in_hash'}->{'status'});
		}
	$self->{'msg'} = $self->text('search_msg2', $self->{'in_hash'}->{'search'});
	}
elsif ($self->{'in_hash'}->{'spam'}) {
	# Search by spam score, using X-Spam-Level header
	$self->{'stars'} = "*" x $self->{'in_hash'}->{'score'};
	@{$self->{'rv_array'}} = $self->mailbox_search_mail([ [ "x-spam-level", $self->{'stars'} ] ], 0, $self->{'folder'}, $self->{'limit'});
	foreach $mail (@{$self->{'rv_array'}}) {
		$mail->{'folder'} = $self->{'folder'};
		}
	$self->{'msg'} = $self->text('search_msg5', $self->{'in_hash'}->{'score'});
	}
else {
	# Complex search, perhaps over multiple folders!
	if ($self->{'in_hash'}->{'folder'} == -2) {
		@{$self->{'sfolders_array'}} = grep { !$_->{'remote'} } @{$self->{'folders_array'}};
		$self->{'multi_folder'} = 1;
		}
	elsif ($self->{'in_hash'}->{'folder'} == -1) {
		@{$self->{'sfolders_array'}} = @{$self->{'folders_array'}};
		$self->{'multi_folder'} = 1;
		}
	else {
		@{$self->{'sfolders_array'}} = ( $self->{'folder'} );
		}
	foreach $sf (@{$self->{'sfolders_array'}}) {
		local @frv = $self->mailbox_search_mail(\@{$self->{'fields_array'}}, $self->{'in_hash'}->{'and'}, $sf, $self->{'limit'});
		foreach $mail (@frv) {
			$mail->{'folder'} = $sf;
			}
		push(@{$self->{'rv_array'}}, @frv);
		}
	if ($self->{'statusmsg'}) {
		@{$self->{'rv_array'}} = $self->filter_by_status(\@{$self->{'rv_array'}}, $self->{'in_hash'}->{'status'});
		}
	$self->{'msg'} = $self->{'text_hash'}->{'search_msg4'};
	}
$self->{'msg'} .= " $self->{'limitmsg'}" if ($self->{'limitmsg'});
$self->{'msg'} .= " $self->{'statusmsg'}" if ($self->{'statusmsg'});

# Create a virtual folder for the search results
if ($self->{'in_hash'}->{'dest_def'} || !defined($self->{'in_hash'}->{'dest'})) {
	# Use the default search results folder
	($self->{'virt'}) = grep { $_->{'type'} == 6 && $_->{'id'} == 1 } @{$self->{'folders_array'}};
	if (!$self->{'virt'}) {
		$self->{'virt'} = { 'id' => $self->{'search_folder_id'},
			  'type' => 6,
			};
		}
	$self->{'virt'}->{'name'} = $self->{'text_hash'}->{'search_title'};
	}
else {
	# Create a new virtual folder
	$self->{'in_hash'}->{'dest'} || $self->error($self->{'text_hash'}->{'search_edest'});
	$self->{'virt'} = { 'type' => 6,
		  'name' => $self->{'in_hash'}->{'dest'} };
	}
$self->{'virt'}->{'delete'} = 1;
$self->{'virt'}->{'members'} = [ map { [ $_->{'folder'}, $_->{'idx'}, $_->{'header'}->{'message-id'} ] } @{$self->{'rv_array'}} ];
$self->{'virt'}->{'msg'} = $self->{'msg'};
if ($self->{'folder'}) {
	# Use same From/To display mode as original folder
	$self->{'virt'}->{'show_to'} = $self->{'folder'}->{'show_to'};
	$self->{'virt'}->{'show_from'} = $self->{'folder'}->{'show_from'};
	}
else {
	# Use default From/To mode
	delete($self->{'virt'}->{'show_to'});
	delete($self->{'virt'}->{'show_from'});
	}
$self->delete_sort_index($self->{'virt'});
$self->save_folder($self->{'virt'}, $self->{'virt'});

# Redirect to it
$self->redirect("index.cgi?id=$self->{'virt'}->{'id'}");
$self->pop3_logout_all();

1;
		
}


1;

