#!/usr/bin/perl

&MAIN();

 sub MAIN {
# mail_search.cgi
# Find mail messages matching some pattern

&ModuleLoader::preload_module('mailbox_class', "mailbox::MailboxLib");
$self = new mailbox::MailboxLib:: 'mailbox_class',%$self;

$self->ReadParse();
$self->{'limit'} = { };
if (!$self->{'in_hash'}->{'status_def'} && defined($self->{'in_hash'}->{'status'})) {
	$self->{'statusmsg'} = $self->text('search_withstatus',
			   $self->{'text_hash'}->{'view_mark'.$self->{'in_hash'}->{'status'}});
	}
if ($self->{'in_hash'}->{'simple'}) {
	# Make sure a search was entered
	$self->{'in_hash'}->{'search'} || $self->error($self->{'text_hash'}->{'search_ematch'});
	if ($self->{'userconfig_hash'}->{'search_latest'}) {
		$self->{'limit'}->{'latest'} = $self->{'userconfig_hash'}->{'search_latest'};
		}
	}
else {
	# Validate search fields
	for($i=0; defined($self->{'in_hash'}->{"field_$i"}); $i++) {
		if ($self->{'in_hash'}->{"field_$i"}) {
			$self->{'in_hash'}->{"what_$i"} || $self->error($self->text('search_ewhat', $i+1));
			$self->{'neg'} = $self->{'in_hash'}->{"neg_$i"} ? "!" : "";
			push(@{$self->{'fields_array'}}, [ $self->{'neg'}.$self->{'in_hash'}->{"field_$i"}, $self->{'in_hash'}->{"what_$i"} ]);
			}
		}
	@{$self->{'fields_array'}} || $self->{'statusmsg'} || $self->error($self->{'text_hash'}->{'search_enone'});
	if (!defined($self->{'in_hash'}->{'limit'})) {
		if ($self->{'userconfig_hash'}->{'search_latest'}) {
			$self->{'limit'} = { 'latest' => $self->{'userconfig_hash'}->{'search_latest'} };
			}
		}
	elsif (!$self->{'in_hash'}->{'limit_def'}) {
		$self->{'in_hash'}->{'limit'} =~ /^\d+$/ || $self->error($self->{'text_hash'}->{'search_elatest'});
		$self->{'limit'}->{'latest'} = $self->{'in_hash'}->{'limit'};
		}
	}
if ($self->{'limit'} && $self->{'limit'}->{'latest'}) {
	$self->{'limitmsg'} = $self->text('search_limit', $self->{'limit'}->{'latest'});
	}

$self->set_module_index($self->{'in_hash'}->{'folder'} < 0 ? 0 : $self->{'in_hash'}->{'folder'});
$self->ui_print_header(undef, $self->{'text_hash'}->{'search_title'}, "");
@{$self->{'folders_array'}} = $self->list_folders();
if ($self->{'in_hash'}->{'folder'} == -2) {
	print "<center><font size=+2>$self->{'text_hash'}->{'search_local'}</font></center>\n";
	}
elsif ($self->{'in_hash'}->{'folder'} == -1) {
	print "<center><font size=+2>$self->{'text_hash'}->{'search_all'}</font></center>\n";
	}
else {
	$self->{'folder'} = $self->{'folders_array'}->[$self->{'in_hash'}->{'folder'}];
	print "<center><font size=+2>",
	      $self->text('mail_for', $self->{'folder'}->{'name'}),"</font></center>\n";
	}

if ($self->{'in_hash'}->{'simple'}) {
	# Just search by Subject and From (or To) in one folder
	($self->{'mode'}, $self->{'words'}) = $self->parse_boolean($self->{'in_hash'}->{'search'});
	local $who = $self->{'folder'}->{'sent'} ? 'to' : 'from';
	if ($self->{'mode'} == 0) {
		# Can just do a single 'or' search
		@{$self->{'searchlist_array'}} = map { ( [ 'subject', $_ ],
				      [ $who, $_ ] ) } @{$self->{'words'}};
		@{$self->{'rv_array'}} = $self->mailbox_search_mail(\@{$self->{'searchlist_array'}}, 0, $self->{'folder'}, $self->{'limit'});
		}
	elsif ($self->{'mode'} == 1) {
		# Need to do two 'and' searches and combine
		@{$self->{'searchlist1_array'}} = map { ( [ 'subject', $_ ] ) } @{$self->{'words'}};
		@{$self->{'rv1_array'}} = $self->mailbox_search_mail(\@{$self->{'searchlist1_array'}}, 1, $self->{'folder'}, $self->{'limit'});
		@{$self->{'searchlist2_array'}} = map { ( [ $who, $_ ] ) } @{$self->{'words'}};
		@{$self->{'rv2_array'}} = $self->mailbox_search_mail(\@{$self->{'searchlist2_array'}}, 1, $self->{'folder'}, $self->{'limit'});
		@{$self->{'rv_array'}} = @{$self->{'rv1_array'}};
		%{$self->{'gotidx_hash'}} = map { $_->{'idx'}, 1 } @{$self->{'rv_array'}};
		foreach $mail (@{$self->{'rv2_array'}}) {
			push(@{$self->{'rv_array'}}, $mail) if (!$self->{'gotidx_hash'}->{$mail->{'idx'}});
			}
		}
	else {
		$self->error($self->{'text_hash'}->{'search_eboolean'});
		}
	foreach $mail (@{$self->{'rv_array'}}) {
		$mail->{'folder'} = $self->{'folder'};
		}
	if ($self->{'statusmsg'}) {
		@{$self->{'rv_array'}} = $self->filter_by_status(\@{$self->{'rv_array'}}, $self->{'in_hash'}->{'status'});
		}
	print "<p><b>",$self->text('search_results2', scalar(@{$self->{'rv_array'}}),
		     "<tt>$self->{'in_hash'}->{'search'}</tt>")," ",$self->{'limitmsg'}," ",$self->{'statusmsg'},
		     " ..</b><p>\n";
	}
else {
	# Complex search, perhaps over multiple folders!
	if ($self->{'in_hash'}->{'folder'} == -2) {
		@{$self->{'sfolders_array'}} = grep { !$_->{'remote'} } @{$self->{'folders_array'}};
		$self->{'multi_folder'} = 1;
		}
	elsif ($self->{'in_hash'}->{'folder'} == -1) {
		@{$self->{'sfolders_array'}} = @{$self->{'folders_array'}};
		$self->{'multi_folder'} = 1;
		}
	else {
		@{$self->{'sfolders_array'}} = ( $self->{'folder'} );
		}
	foreach $sf (@{$self->{'sfolders_array'}}) {
		local @frv = $self->mailbox_search_mail(\@{$self->{'fields_array'}}, $self->{'in_hash'}->{'and'}, $sf, $self->{'limit'});
		foreach $mail (@frv) {
			$mail->{'folder'} = $sf;
			}
		push(@{$self->{'rv_array'}}, @frv);
		}
	if ($self->{'statusmsg'}) {
		@{$self->{'rv_array'}} = $self->filter_by_status(\@{$self->{'rv_array'}}, $self->{'in_hash'}->{'status'});
		}
	print "<p><b>",$self->text('search_results4', scalar(@{$self->{'rv_array'}})),
	      " ",$self->{'limitmsg'}," ",$self->{'statusmsg'}," ..</b><p>\n";
	}
@{$self->{'rv_array'}} = reverse(@{$self->{'rv_array'}});

$self->{'showto'} = $self->{'folder'}->{'sent'} || $self->{'folder'}->{'drafts'} || $self->{'userconfig_hash'}->{'show_to'};
$self->{'showfrom'} = !($self->{'folder'}->{'sent'} || $self->{'folder'}->{'drafts'}) || $self->{'userconfig_hash'}->{'show_to'};
if (@{$self->{'rv_array'}}) {
	print "<form action=delete_mail.cgi method=post>\n";
	print "<input type=hidden name=folder value='$self->{'in_hash'}->{'folder'}'>\n";
	if ($self->{'userconfig_hash'}->{'top_buttons'}) {
		if (!$self->{'multi_folder'}) {
			$self->show_mailbox_buttons(1, \@{$self->{'folders_array'}}, $self->{'folder'}, \@{$self->{'rv_array'}});

			print $self->select_all_link("d", 0, $self->{'text_hash'}->{'mail_all'}),"\n";
			print $self->select_invert_link("d", 0, $self->{'text_hash'}->{'mail_invert'});
			print "<br>\n";
			}
		}
	print "<table border width=100%>\n";
	print "<tr $self->{'tb'}> ",
	      $self->{'multi_folder'} ? "<td><b>$self->{'text_hash'}->{'mail_folder'}</b></td>"
			    : "<td>&nbsp;</td> ",
	      ($self->{'showfrom'} ? "<td><b>$self->{'text_hash'}->{'mail_from'}</b></td> " : ""),
	      ($self->{'showto'} ? "<td><b>$self->{'text_hash'}->{'mail_to'}</b></td> " : ""),
	      "<td><b>$self->{'text_hash'}->{'mail_date'}</b></td> ",
	      "<td><b>$self->{'text_hash'}->{'mail_size'}</b></td> ",
	      "<td><b>$self->{'text_hash'}->{'mail_subject'}</b></td> </tr>\n";
	}
foreach $m (@{$self->{'rv_array'}}) {
	local $idx = $m->{'idx'};
	local $mf = $m->{'folder'};
	print "<tr $self->{'cb'}>\n";
	if ($self->{'multi_folder'}) {
		print "<td>$mf->{'name'}</td>\n";
		}
	else {
		print "<td><input type=checkbox name=d value=$idx></td>\n";
		}
	if ($self->{'showfrom'}) {
		print "<td nowrap><a href='view_mail.cgi?idx=$idx&".
		      "folder=$mf->{'index'}'>",
		      $self->simplify_from($m->{'header'}->{'from'}),"</td>\n";
		}
	if ($self->{'showto'}) {
		print "<td nowrap><a href='view_mail.cgi?idx=$idx&".
		      "folder=$mf->{'index'}'>",
		      $self->simplify_from($m->{'header'}->{'to'}),"</td>\n";
		}
	print "<td nowrap>",$self->simplify_date($m->{'header'}->{'date'}),"</td>\n";
	print "<td nowrap>",int($m->{'size'}/1000)+1," kB","</td>\n";
	print "<td><table border=0 cellpadding=0 cellspacing=0 width=100%>",
	      "<tr><td>",$self->simplify_subject($m->{'header'}->{'subject'}),
	      "</td> <td align=right>";
	local @icons = $self->message_icons($m,
				      $mf->{'drafts'} || $mf->{'sent'});
	print join("&nbsp;", @icons);
	print "</td></tr></table></td> </tr>\n";
	$self->update_delivery_notification($m, $m->{'folder'});
	$self->{'anyvirt'}++ if ($m->{'folder'}->{'type'} == 6);
	}
if (@{$self->{'rv_array'}}) {
	print "</table>\n";
	if (!$self->{'multi_folder'}) {
		print $self->select_all_link("d", 0, $self->{'text_hash'}->{'mail_all'}),"\n";
		print $self->select_invert_link("d", 0, $self->{'text_hash'}->{'mail_invert'});
		print "<br>\n";

		$self->show_mailbox_buttons(2, \@{$self->{'folders_array'}}, $self->{'folder'}, \@{$self->{'rv_array'}});
		}
	print "</form><p>\n";

	if (!$self->{'anyvirt'}) {
		# Show button to turn into virtual folder
		print "<hr>\n";
		print $self->ui_form_start("virtualize.cgi");
		$i = 0;
		foreach $m (reverse(@{$self->{'rv_array'}})) {
			print $self->ui_hidden("idx_$i", $m->{'idx'}." ".$m->{'folder'}->{'index'}),"\n";
			$i++;
			}
		print $self->ui_submit($self->{'text_hash'}->{'search_virtualize'}),"\n";
		print $self->ui_textbox("virtual", "", 40),"\n";
		print $self->ui_form_end();
		}
	}
else {
	print "<b>$self->{'text_hash'}->{'search_none'}</b> <p>\n";
	}

$self->ui_print_footer($self->{'in_hash'}->{'simple'} ? ( ) : ( "search_form.cgi?folder=$self->{'in_hash'}->{'folder'}",
				$self->{'text_hash'}->{'sform_return'} ),
	"index.cgi?folder=$self->{'in_hash'}->{'folder'}", $self->{'text_hash'}->{'mail_return'});
$self->pop3_logout_all();

1;
		
}


1;

