#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Display a form for replying to or composing an email

&ModuleLoader::preload_module('mailbox_class', "mailbox::MailboxLib");
$self = new mailbox::MailboxLib:: 'mailbox_class',%$self;


$self->ReadParse();
$self->set_module_index($self->{'in_hash'}->{'folder'});
@{$self->{'folders_array'}} = $self->list_folders();
$self->{'folder'} = $self->{'folders_array'}->[$self->{'in_hash'}->{'folder'}];
if ($self->{'in_hash'}->{'new'}) {
	# Composing a new email
	$self->{'html_edit'} = 1 if ($self->{'userconfig_hash'}->{'html_edit'} == 2);
	$self->{'sig'} = $self->get_signature();
	if ($self->{'html_edit'}) {
		$self->{'sig'} =~ s/\n/<br>\n/g;
		$self->{'quote'} = "<html><body>$self->{'sig'}</body></html>";
		}
	else {
		$self->{'quote'} = "\n\n$self->{'sig'}" if ($self->{'sig'});
		}
	$self->{'to'} = $self->{'in_hash'}->{'to'};
	$self->mail_page_header($self->{'text_hash'}->{'compose_title'},
			  undef,
			  $self->{'html_edit'} ? "onload='initEditor()'" : "");
	}
else {
	# Replying or forwarding
	if ($self->{'in_hash'}->{'mailforward'} ne '') {
		# Forwarding multiple .. get the messages
		@{$self->{'mailforwardboth_array'}} = split(/\0/, $self->{'in_hash'}->{'mailforward'});
		@{$self->{'fwdmail_array'}} = $self->messages_from_indexes($self->{'folder'}, \@{$self->{'mailforwardboth_array'}});
		@{$self->{'fwdmail_array'}} || $self->error($self->{'text_hash'}->{'reply_efwdnone'});
		$self->{'mail'} = $self->{'fwdmail_array'}->[0];
		}
	else {
		# Replying or forwarding one .. get it
		@{$self->{'mail_array'}} = $self->mailbox_list_mails_sorted(
				$self->{'in_hash'}->{'idx'}, $self->{'in_hash'}->{'idx'}, $self->{'folder'}, 0, undef);
		$self->{'mail'} = $self->find_message_by_index(\@{$self->{'mail_array'}}, $self->{'folder'}, $self->{'in_hash'}->{'idx'}, $self->{'in_hash'}->{'mid'});
		$self->{'mail'} || $self->error($self->{'text_hash'}->{'view_egone'});
		&decode_and_sub();
		}
	$self->{'viewlink'} = "view_mail.cgi?idx=$self->{'in_hash'}->{'idx'}&folder=$self->{'in_hash'}->{'folder'}&mid=".
		    $self->urlize($self->{'in_hash'}->{'mid'});
	$self->{'mail'} || $self->error($self->{'text_hash'}->{'mail_eexists'});

	if ($self->{'in_hash'}->{'delete'}) {
		# Just delete the email
		if (!$self->{'in_hash'}->{'confirm'} && $self->need_delete_warn($self->{'folder'})) {
			# Need to ask for confirmation before deleting
			$self->mail_page_header($self->{'text_hash'}->{'confirm_title'});
			print $self->check_clicks_function();

			print "<form action=reply_mail.cgi>\n";
			foreach $i (keys %{$self->{'in_hash'}}) {
				foreach $v (split(/\0/, $self->{'in_hash'}->{$i})) {
					print $self->ui_hidden($i, $v),"\n";
					}
				}
			print "<center><b>$self->{'text_hash'}->{'confirm_warn3'}<br>\n";
			if ($self->{'userconfig_hash'}->{'delete_warn'} ne 'y') {
				print "$self->{'text_hash'}->{'confirm_warn2'}<p>\n"
				}
			elsif ($self->{'folder'}->{'type'} == 0) {
				print "$self->{'text_hash'}->{'confirm_warn4'}<p>\n"
				}
			print "</b><p><input type=submit name=confirm ",
			      "value='$self->{'text_hash'}->{'confirm_ok'}' ",
			      "onClick='return check_clicks(form)'></center></form>\n";
			
			$self->ui_print_footer($self->{'text_hash'}->{'index_mainpage_url'}, $self->{'text_hash'}->{'index_mainpage'},
				"view_mail.cgi?idx=$self->{'in_hash'}->{'idx'}&folder=$self->{'in_hash'}->{'folder'}",$self->{'text_hash'}->{'view_return'},
				"index.cgi?folder=$self->{'in_hash'}->{'folder'}",$self->{'text_hash'}->{'index'});
			exit;
			}
		$self->lock_folder($self->{'folder'});
		$self->mailbox_delete_mail($self->{'folder'}, $self->{'mail'});
		$self->unlock_folder($self->{'folder'});
		$self->pop3_logout_all();
		&redirect_to_previous();
		exit;
		}
	elsif ($self->{'in_hash'}->{'print'}) {
		# Extract the mail body
		($self->{'textbody'}, $self->{'htmlbody'}, $self->{'body'}) =
			$self->find_body($self->{'mail'}, $self->{'userconfig_hash'}->{'view_html'});

		# Output HTML header
		$self->PrintHeader();
		print "<html><head>\n";
		print "<title>",$self->html_escape($self->decode_mimewords(
			$self->{'mail'}->{'header'}->{'subject'})),"</title></head>\n";
		print "<body bgcolor=#ffffff onLoad='window.print()'>\n";

		# Display the headers
		print "<table width=100% border=1>\n";
		print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'view_headers'}</b></td> </tr>\n";
		print "<tr $self->{'cb'}> <td><table width=100%>\n";
		print "<tr> <td><b>$self->{'text_hash'}->{'mail_from'}</b></td> ",
		      "<td>",$self->eucconv_and_escape($self->{'mail'}->{'header'}->{'from'}),"</td> </tr>\n";
		print "<tr> <td><b>$self->{'text_hash'}->{'mail_to'}</b></td> ",
		      "<td>",$self->eucconv_and_escape($self->{'mail'}->{'header'}->{'to'}),"</td> </tr>\n";
		print "<tr> <td><b>$self->{'text_hash'}->{'mail_cc'}</b></td> ",
		      "<td>",$self->eucconv_and_escape($self->{'mail'}->{'header'}->{'cc'}),"</td> </tr>\n"
			if ($self->{'mail'}->{'header'}->{'cc'});
		print "<tr> <td><b>$self->{'text_hash'}->{'mail_date'}</b></td> ",
		      "<td>",$self->eucconv_and_escape($self->html_escape($self->{'mail'}->{'header'}->{'date'})),
		      "</td> </tr>\n";
		print "<tr> <td><b>$self->{'text_hash'}->{'mail_subject'}</b></td> ",
		      "<td>",$self->eucconv_and_escape($self->decode_mimewords(
			$self->{'mail'}->{'header'}->{'subject'})),"</td> </tr>\n";
		print "</table></td></tr></table><p>\n";

		# Just display the mail body for printing
		if ($self->{'body'} eq $self->{'textbody'}) {
			print "<table border width=100%><tr $self->{'cb'}><td><pre>";
			foreach $l ($self->wrap_lines($self->{'body'}->{'data'},
						$self->{'userconfig_hash'}->{'wrap_width'})) {
				print $self->eucconv_and_escape($l),"\n";
				}
			print "</pre></td></tr></table>\n";
			}
		elsif ($self->{'body'} eq $self->{'htmlbody'}) {
			print "<table border width=100%><tr><td>\n";
			print $self->safe_html($self->{'body'}->{'data'});
			print "</td></tr></table>\n";
			}

		print "</body></html>\n";
		exit;
		}
	elsif ($self->{'in_hash'}->{'mark1'} || $self->{'in_hash'}->{'mark2'}) {
		# Just mark the message
		$self->open_read_hash();
		$self->{'mode'} = $self->{'in_hash'}->{'mark1'} ? $self->{'in_hash'}->{'mode1'} : $self->{'in_hash'}->{'mode2'};
		if ($self->{'mode'}) {
			$self->{'read_hash'}->{$self->{'mail'}->{'header'}->{'message-id'}} = $self->{'mode'};
			}
		else {
			delete($self->{'read_hash'}->{$self->{'mail'}->{'header'}->{'message-id'}});
			}
		&redirect_to_previous();
		exit;
		}
	elsif ($self->{'in_hash'}->{'move1'} || $self->{'in_hash'}->{'move2'}) {
		# Move to another folder
		$self->error_setup($self->{'text_hash'}->{'reply_errm'});
		$self->{'mfolder'} = $self->{'folders_array'}->[$self->{'in_hash'}->{'move1'} ? $self->{'in_hash'}->{'mfolder1'} : $self->{'in_hash'}->{'mfolder2'}];
		$self->{'mfolder'}->{'noadd'} && $self->error($self->{'text_hash'}->{'delete_enoadd'});
		$self->lock_folder($self->{'folder'});
		$self->lock_folder($self->{'mfolder'});
		$self->mailbox_move_mail($self->{'folder'}, $self->{'mfolder'}, $self->{'mail'});
		$self->unlock_folder($self->{'mfolder'});
		$self->unlock_folder($self->{'folder'});
		&redirect_to_previous();
		exit;
		}
	elsif ($self->{'in_hash'}->{'copy1'} || $self->{'in_hash'}->{'copy2'}) {
		# Copy to another folder
		$self->error_setup($self->{'text_hash'}->{'reply_errc'});
		$self->{'mfolder'} = $self->{'folders_array'}->[$self->{'in_hash'}->{'copy1'} ? $self->{'in_hash'}->{'mfolder1'} : $self->{'in_hash'}->{'mfolder2'}];
		$self->{'qerr'} = $self->would_exceed_quota($self->{'mfolder'}, $self->{'mail'});
		$self->error($self->{'qerr'}) if ($self->{'qerr'});
		$self->lock_folder($self->{'folder'});
		$self->lock_folder($self->{'mfolder'});
		$self->mailbox_copy_mail($self->{'folder'}, $self->{'mfolder'}, $self->{'mail'});
		$self->unlock_folder($self->{'mfolder'});
		$self->unlock_folder($self->{'folder'});
		&redirect_to_previous();
		exit;
		}
	elsif ($self->{'in_hash'}->{'detach'} && $self->{'config_hash'}->{'server_attach'} == 2) {
		# Detach some attachment to a directory on the server
		$self->error_setup($self->{'text_hash'}->{'detach_err'});
		$self->{'in_hash'}->{'dir'} || $self->error($self->{'text_hash'}->{'detach_edir'});
		$self->{'in_hash'}->{'dir'} = "$self->{'remote_user_info_array'}->[7]/$self->{'in_hash'}->{'dir'}"
			if ($self->{'in_hash'}->{'dir'} !~ /^\//);

		if ($self->{'in_hash'}->{'attach'} eq '*') {
			# Detaching all attachments (except the body and any
			# signature) under their filenames
			@{$self->{'dattach_array'}} = grep { $_->{'idx'} ne $self->{'in_hash'}->{'bindex'} &&
					  $_->{'header'}->{'content-type'} !~
					  	/^multipart\//i }
					@{$self->{'mail'}->{'attach'}};
			if (defined($self->{'in_hash'}->{'sindex'})) {
				@{$self->{'dattach_array'}} = grep { $_->{'idx'} ne $self->{'in_hash'}->{'sindex'} }
						@{$self->{'dattach_array'}};
				}
			}
		else {
			# Just one attachment
			@{$self->{'dattach_array'}} = ( $self->{'mail'}->{'attach'}->[$self->{'in_hash'}->{'attach'}] );
			}

		local @paths;
		foreach $attach (@{$self->{'dattach_array'}}) {
			local $path;
			if (-d $self->{'in_hash'}->{'dir'}) {
				# Just write to the filename in the directory
				local $fn;
				if ($attach->{'filename'}) {
					$fn = $self->decode_mimewords(
						$attach->{'filename'});
					$fn =~ s/^.*[\/\\]//;
					}
				else {
					$attach->{'type'} =~ /\/(\S+)$/;
					$fn = "file.$1";
					}
				$path = "$self->{'in_hash'}->{'dir'}/$fn";
				}
			else {
				# Assume a full path was given
				$path = $self->{'in_hash'}->{'dir'};
				}
			push(@paths, $path);
			}

		for($i=0; $i<@{$self->{'dattach_array'}}; $i++) {
			# Try to write the files
			open(FILE, ">$paths[$i]") ||
				$self->error($self->text('detach_eopen',
					     "<tt>$paths[$i]</tt>", $!));
			(print FILE $self->{'dattach_array'}->[$i]->{'data'}) ||
				$self->error($self->text('detach_ewrite',
					     "<tt>$paths[$i]</tt>", $!));
			close(FILE) ||
				$self->error($self->text('detach_ewrite',
					     "<tt>$paths[$i]</tt>", $!));
			}

		# Show a message about the new files
		$self->mail_page_header($self->{'text_hash'}->{'detach_title'});

		for($i=0; $i<@{$self->{'dattach_array'}}; $i++) {
			local $sz = (int(length($self->{'dattach_array'}->[$i]->{'data'}) /
					 1000)+1)." Kb";
			print "<p>",$self->text('detach_ok',
					  "<tt>$paths[$i]</tt>", $sz),"<p>\n";
			}

			$self->ui_print_footer($self->{'text_hash'}->{'index_mainpage_url'}, $self->{'text_hash'}->{'index_mainpage'},
			"view_mail.cgi?idx=$self->{'in_hash'}->{'idx'}&folder=$self->{'in_hash'}->{'folder'}",$self->{'text_hash'}->{'view_return'},
			"index.cgi?folder=$self->{'in_hash'}->{'folder'}", $self->{'text_hash'}->{'mail_return'});
		exit;
		}
	elsif ($self->{'in_hash'}->{'black'} || $self->{'in_hash'}->{'white'}) {
		# Add sender to SpamAssassin black/write list, and tell user
		$self->{'mode'} = $self->{'in_hash'}->{'black'} ? "black" : "white";
		$self->mail_page_header($self->{'text_hash'}->{$self->{'mode'}.'_title'});

		$self->foreign_require("spam", "spam-lib.pl");
		local $conf = $main::spam_object->get_config();
		local @from = map { @{$_->{'words'}} }
			    	  $main::spam_object->find($self->{'mode'}."list_from", $conf);
		local %already = map { $_, 1 } @from;
		local ($spamfrom) = $self->address_parts($self->{'mail'}->{'header'}->{'from'});
		if ($already{$spamfrom}) {
			print $self->text($self->{'mode'}.'_already',
					  "<tt>$spamfrom</tt>"),"</b><p>\n";
			}
		else {
			push(@from, $spamfrom);
			$main::spam_object->save_directives($conf, $self->{'mode'}.'list_from',
					       \@from, 1);
			$self->flush_file_lines();
			print $self->text($self->{'mode'}.'_done',
					  "<tt>$spamfrom</tt>"),"</b><p>\n";
			}

		$self->mail_page_footer(
			$self->{'viewlink'}, $self->{'text_hash'}->{'view_return'},
			"index.cgi?folder=$self->{'in_hash'}->{'folder'}", $self->{'text_hash'}->{'mail_return'});
		exit;
		}
	elsif ($self->{'in_hash'}->{'razor'} || $self->{'in_hash'}->{'ham'}) {
		# Report message to Razor as spam/ham and tell user
		$self->{'mode'} = $self->{'in_hash'}->{'razor'} ? "razor" : "ham";
		$self->mail_page_header($self->{'text_hash'}->{$self->{'mode'}.'_title'});

		print "<b>",$self->{'text_hash'}->{$self->{'mode'}.'_report'},"</b>\n";
		print "<pre>";
		local $temp = $self->transname();
		$self->send_mail($self->{'mail'}, $temp, 0, 1);
		local $cmd = $self->{'mode'} eq "razor" ? $self->spam_report_cmd() 
					      : $self->ham_report_cmd();
		open(OUT, "$cmd <$temp 2>&1 |");
		local $error;
		while(<OUT>) {
			print $self->html_escape($_);
			$error++ if (/failed/i);
			}
		close(OUT);
		unlink($temp);
		print "</pre>\n";
		$self->{'deleted'} = 0;
		if ($? || $error) {
			print "<b>",$self->{'text_hash'}->{'razor_err'},"</b><p>\n";
			}
		else {
			if ($self->{'userconfig_hash'}->{'spam_del'} && $self->{'mode'} eq "razor") {
				# Delete message too
				$self->lock_folder($self->{'folder'});
				$self->mailbox_delete_mail($self->{'folder'}, $self->{'mail'});
				$self->unlock_folder($self->{'folder'});
				print "<b>$self->{'text_hash'}->{'razor_deleted'}</b><p>\n";
				$self->{'deleted'} = 1;
				}
			else {
				print "<b>",$self->{'text_hash'}->{'razor_done'},"</b><p>\n";
				}
			}

		$self->ui_print_footer($self->{'text_hash'}->{'index_mainpage_url'}, $self->{'text_hash'}->{'index_mainpage'},
			$self->{'deleted'} ? ( ) : ( "view_mail.cgi?idx=$self->{'in_hash'}->{'idx'}&folder=$self->{'in_hash'}->{'folder'}",$self->{'text_hash'}->{'view_return'} ),
			"index.cgi?folder=$self->{'in_hash'}->{'folder'}", $self->{'text_hash'}->{'mail_return'});
		exit;
		}
	elsif ($self->{'in_hash'}->{'dsn'}) {
		# Send DSN to sender
		dbmopen(%{$self->{'dsn_hash'}}, "$self->{'user_module_config_directory'}/dsn", 0600);
		$self->{'dsnaddr'} = $self->send_delivery_notification($self->{'mail'}, undef, 1);
		if ($self->{'dsnaddr'}) {
			$self->{'mid'} = $self->{'mail'}->{'header'}->{'message-id'};
                        $self->{'dsn_hash'}->{$self->{'mid'}} = time()." ".$self->{'dsnaddr'};
                        }
		dbmclose(%{$self->{'dsn_hash'}});
		&redirect_to_previous();
		exit;
		}

	if (!@{$self->{'fwdmail_array'}}) {
		$self->parse_mail($self->{'mail'});
		$self->decrypt_attachments($self->{'mail'});
		@attach = @{$self->{'mail'}->{'attach'}};
		}

	if ($self->{'in_hash'}->{'enew'}) {
		# Editing an existing message, so keep same fields
		$self->{'to'} = $self->{'mail'}->{'header'}->{'to'};
		$self->{'rto'} = $self->{'mail'}->{'header'}->{'reply-to'};
		$self->{'from'} = $self->{'mail'}->{'header'}->{'from'};
		$self->{'cc'} = $self->{'mail'}->{'header'}->{'cc'};
		$self->{'ouser'} = $1 if ($self->{'from'} =~ /^(\S+)\@/);
		}
	else {
		if (!$self->{'in_hash'}->{'forward'} && !@{$self->{'fwdmail_array'}}) {
			# Replying to a message, so set To: field
			$self->{'to'} = $self->{'mail'}->{'header'}->{'reply-to'};
			$self->{'to'} = $self->{'mail'}->{'header'}->{'from'} if (!$self->{'to'});
			}
		if ($self->{'in_hash'}->{'rall'}) {
			# If replying to all, add any addresses in the original
			# To: or Cc: to our new Cc: address.
			$self->{'cc'} = $self->{'mail'}->{'header'}->{'to'};
			$self->{'cc'} .= ", ".$self->{'mail'}->{'header'}->{'cc'}
				if ($self->{'mail'}->{'header'}->{'cc'});
			}
		}

	# Work out new subject, depending on whether we are replying
	# our forwarding a message (or neither)
	local $qu = !$self->{'in_hash'}->{'enew'} &&
		    (!$self->{'in_hash'}->{'forward'} || !$self->{'userconfig_hash'}->{'fwd_mode'});
	$self->{'subject'} = $self->decode_mimewords($self->{'mail'}->{'header'}->{'subject'});
	$self->{'subject'} = "Re: ".$self->{'subject'} if ($self->{'subject'} !~ /^Re/i && !$self->{'in_hash'}->{'forward'} &&
				       !@{$self->{'fwdmail_array'}} && !$self->{'in_hash'}->{'enew'});
	$self->{'subject'} = "Fwd: ".$self->{'subject'} if ($self->{'subject'} !~ /^Fwd/i &&
					($self->{'in_hash'}->{'forward'} || @{$self->{'fwdmail_array'}}));

	# Construct the initial mail text
	$self->{'sig'} = $self->get_signature();
	($self->{'quote'}, $self->{'html_edit'}, $self->{'body'}) = $self->quoted_message($self->{'mail'}, $qu, $self->{'sig'},
						      $self->{'in_hash'}->{'body'});
	if ($self->{'in_hash'}->{'forward'} || $self->{'in_hash'}->{'enew'}) {
		@attach = grep { $_ ne $self->{'body'} } @attach;
		}
	else {
		undef(@attach);
		}

	$self->mail_page_header(
		$self->{'in_hash'}->{'forward'} || @{$self->{'fwdmail_array'}} ? $self->{'text_hash'}->{'forward_title'} :
		$self->{'in_hash'}->{'enew'} ? $self->{'text_hash'}->{'enew_title'} :
			      $self->{'text_hash'}->{'reply_title'},
		undef,
		$self->{'html_edit'} ? "onload='initEditor()'" : "");
	}

# Show form start, with upload progress tracker hook
$self->{'upid'} = time().$$;
print $self->ui_form_start("send_mail.cgi?id=$self->{'upid'}", "form-data", undef,
      $self->read_parse_mime_javascript($self->{'upid'}, [ map { "attach$_" } (0..10) ]));

# Output various hidden fields
print "<input type=hidden name=ouser value='$self->{'ouser'}'>\n";
print "<input type=hidden name=idx value='$self->{'in_hash'}->{'idx'}'>\n";
print "<input type=hidden name=mid value='$self->{'in_hash'}->{'mid'}'>\n";
print "<input type=hidden name=folder value='$self->{'in_hash'}->{'folder'}'>\n";
print "<input type=hidden name=new value='$self->{'in_hash'}->{'new'}'>\n";
print "<input type=hidden name=enew value='$self->{'in_hash'}->{'enew'}'>\n";
foreach $s (@{$self->{'sub_array'}}) {
	print "<input type=hidden name=sub value='$s'>\n";
	}
if ($self->{'in_hash'}->{'reply'}) {
	print "<input type=hidden name=rid value='".
		$self->html_escape($self->{'mail'}->{'header'}->{'message-id'})."'>\n";
	}

# Start tabs for from / to / cc / bcc / signing / options
# Subject is separate
print $self->ui_table_start($self->{'text_hash'}->{'reply_headers'}, "width=100%", 2);
if ($self->has_command("gpg") && $self->foreign_check("gnupg")) {
	$self->foreign_require("gnupg", "gnupg-lib.pl");
	@{$self->{'keys_array'}} = $self->foreign_call("gnupg", "list_keys");
	$self->{'has_gpg'} = @{$self->{'keys_array'}} ? 1 : 0;
	}
@{$self->{'tds_array'}} = ( "width=10%", "width=90% nowrap" );
@{$self->{'tabs_array'}} = ( [ "from", $self->{'text_hash'}->{'reply_tabfrom'} ],
	  $self->{'userconfig_hash'}->{'reply_to'} ne 'x' ?
		( [ "rto", $self->{'text_hash'}->{'reply_tabreplyto'} ] ) : ( ),
	  [ "to", $self->{'text_hash'}->{'reply_tabto'} ],
	  [ "cc", $self->{'text_hash'}->{'reply_tabcc'} ],
	  [ "bcc", $self->{'text_hash'}->{'reply_tabbcc'} ],
	  $self->{'has_gpg'} ? ( [ "signing", $self->{'text_hash'}->{'reply_tabsigning'} ] ) : ( ),
	  [ "options", $self->{'text_hash'}->{'reply_taboptions'} ] );
print $self->ui_table_row(undef, $self->ui_tabs_start(\@{$self->{'tabs_array'}}, "tab", "to", 0), 2);

# From address tab
if ($self->{'from'}) {
	# Got From address
	@{$self->{'froms_array'}} = ( $self->{'from'} );
	}
else {
	# Work out From: address
	local ($froms, $doms) = $self->list_from_addresses();
	@{$self->{'froms_array'}} = @$froms;
	}

@{$self->{'faddrs_array'}} = grep { $_->[3] } $self->list_addresses();
($self->{'defaddr'}) = grep { $_->[3] == 2 } @{$self->{'faddrs_array'}};
if ($self->{'folder'}->{'fromaddr'}) {
	# Folder has a specified From: address
	($self->{'defaddr'}) = $self->split_addresses($self->{'folder'}->{'fromaddr'});
	}
if ($self->{'config_hash'}->{'edit_from'} == 1) {
	# User can enter any from address he wants
	if ($self->{'defaddr'}) {
		# Address book contains a default from address
		$self->{'froms_array'}->[0] = $self->{'defaddr'}->[1] ? "\"$self->{'defaddr'}->[1]\" <$self->{'defaddr'}->[0]>"
					  : $self->{'defaddr'}->[0];
		}
	$self->{'frominput'} = $self->ui_address_field("from", $self->{'froms_array'}->[0], 1, 0);
	}
elsif ($self->{'config_hash'}->{'edit_from'} == 2) {
	# Only the real name and username part is editable
	local ($real, $user, $dom);
	local ($sp) = $self->{'defaddr'} || $self->split_addresses($self->{'froms_array'}->[0]);
	$real = $sp->[1];
	if ($sp->[0] =~ /^(\S+)\@(\S+)$/) {
		$user = $1; $dom = $2;
		}
	else {
		$user = $sp->[0];
		}
	$self->{'frominput'} = $self->ui_textbox("real", $real, 15)."\n".
		     "&lt;".$self->ui_textbox("user", $user, 10)."\@";
	if (@$doms > 1) {
		$self->{'frominput'} .= $self->ui_select("dom", undef,
				[ map { [ $_ ] } @$doms ])."&gt;";
		}
	else {
		$self->{'frominput'} .= "$dom&gt;".
			      $self->ui_hidden("dom", $dom);
		}
	$self->{'frominput'} .= $self->address_button("user", 0, 2, "real") if (@{$self->{'faddrs_array'}});
	}
else {
	# A fixed From address, or a choice of fixed options
	if (@{$self->{'froms_array'}} > 1) {
		$self->{'frominput'} = $self->ui_select("from", undef,
				[ map { [ $_, $self->html_escape($_) ] } @{$self->{'froms_array'}} ]);
		}
	else {
		$self->{'frominput'} = "<tt>".$self->html_escape($self->{'froms_array'}->[0])."</tt>".
			     $self->ui_hidden("from", $self->{'froms_array'}->[0]);
		}
	}
print $self->ui_tabs_start_tabletab("tab", "from");
print $self->ui_table_row($self->{'text_hash'}->{'mail_from'}, $self->{'frominput'}, 1, \@{$self->{'tds_array'}});
print $self->ui_tabs_end_tabletab();

# Show the Reply-To field
if ($self->{'userconfig_hash'}->{'reply_to'} ne 'x') {
	$self->{'rto'} = $self->{'userconfig_hash'}->{'reply_to'} if ($self->{'userconfig_hash'}->{'reply_to'} ne '*');
	print $self->ui_tabs_start_tabletab("tab", "rto");
	print $self->ui_table_row($self->{'text_hash'}->{'mail_replyto'},
			    $self->ui_address_field("replyto", $self->{'rto'}, 1, 0), 1, \@{$self->{'tds_array'}});
	print $self->ui_tabs_end_tabletab();
	}

# Show To: field
print $self->ui_tabs_start_tabletab("tab", "to");
print $self->ui_table_row($self->{'text_hash'}->{'mail_to'}, $self->ui_address_field("to", $self->{'to'}, 0, 1),
		    1, \@{$self->{'tds_array'}});
print $self->ui_tabs_end_tabletab();

# Show Cc: field
print $self->ui_tabs_start_tabletab("tab", "cc");
print $self->ui_table_row($self->{'text_hash'}->{'mail_cc'}, $self->ui_address_field("cc", $self->{'cc'}, 0, 1),
		    1, \@{$self->{'tds_array'}});
print $self->ui_tabs_end_tabletab();

# Show Bcc: field
$self->{'bcc'} = $self->{'userconfig_hash'}->{'bcc_to'};
print $self->ui_tabs_start_tabletab("tab", "bcc");
print $self->ui_table_row($self->{'text_hash'}->{'mail_bcc'}, $self->ui_address_field("bcc", $self->{'bcc'}, 0, 1),
		    1, \@{$self->{'tds_array'}});
print $self->ui_tabs_end_tabletab();

# Ask for signing and encryption
if ($self->{'has_gpg'}) {
	print $self->ui_tabs_start_tabletab("tab", "signing");
	@{$self->{'signs_array'}} = ( );
	foreach $k (@{$self->{'keys_array'}}) {
		local $n = $k->{'name'}->[0];
		$n = substr($n, 0, 40)."..." if (length($n) > 40);
		if ($k->{'secret'}) {
			push(@{$self->{'signs_array'}}, [ $k->{'index'}, $n ]);
			}
		push(@{$self->{'crypts_array'}}, [ $k->{'index'}, $n ]);
		}
	print $self->ui_table_row($self->{'text_hash'}->{'mail_sign'},
		$self->ui_select("sign", "", 
		   [ [ "", $self->{'text_hash'}->{'mail_nosign'} ], @{$self->{'signs_array'}} ]), 1, \@{$self->{'tds_array'}});
	print $self->ui_table_row($self->{'text_hash'}->{'mail_crypt'},
		$self->ui_select("crypt", "",
		   [ [ "", $self->{'text_hash'}->{'mail_nocrypt'} ],
		     [ -1, $self->{'text_hash'}->{'mail_samecrypt'} ], @{$self->{'crypts_array'}} ]), 1, \@{$self->{'tds_array'}});
	print $self->ui_tabs_end_tabletab();
	}

# Show tabs for options
print $self->ui_tabs_start_tabletab("tab", "options");
print $self->ui_table_row($self->{'text_hash'}->{'mail_pri'},
		$self->ui_select("pri", "",
			[ [ 1, $self->{'text_hash'}->{'mail_highest'} ],
			  [ 2, $self->{'text_hash'}->{'mail_high'} ],
			  [ "", $self->{'text_hash'}->{'mail_normal'} ],
			  [ 4, $self->{'text_hash'}->{'mail_low'} ],
			  [ 5, $self->{'text_hash'}->{'mail_lowest'} ] ]), 1, \@{$self->{'tds_array'}});

if ($self->{'userconfig_hash'}->{'req_dsn'} == 2) {
	# Ask for a disposition (read) status
	print $self->ui_table_row($self->{'text_hash'}->{'reply_dsn'},
		$self->ui_radio("dsn", 0, [ [ 1, $self->{'text_hash'}->{'yes'} ],
				      [ 0, $self->{'text_hash'}->{'no'} ] ]), 1, \@{$self->{'tds_array'}});
	}

if ($self->{'userconfig_hash'}->{'req_del'} == 2) {
	# Ask for a delivery status
	print $self->ui_table_row($self->{'text_hash'}->{'reply_del'},
		$self->ui_radio("del", 0, [ [ 1, $self->{'text_hash'}->{'yes'} ],
				      [ 0, $self->{'text_hash'}->{'no'} ] ]), 1, \@{$self->{'tds_array'}});
	}

# Ask if should add to address book
print $self->ui_table_row(" ",
    $self->ui_checkbox("abook", 1, $self->{'text_hash'}->{'reply_aboot'}, $self->{'userconfig_hash'}->{'add_abook'}),
    1, \@{$self->{'tds_array'}});
print $self->ui_tabs_end_tabletab();

print $self->ui_tabs_end();

# Field for subject is always at the bottom
print $self->ui_table_row($self->{'text_hash'}->{'mail_subject'},
	$self->ui_textbox("subject", $self->{'subject'}, 40, 0, undef, "style='width:70%'").
	"&nbsp;".$self->ui_submit($self->{'text_hash'}->{'reply_send'}).
	"&nbsp;".$self->ui_submit($self->{'text_hash'}->{'reply_draft'}, "draft"),
	1, \@{$self->{'tds_array'}});
print $self->ui_table_end(),"<p>\n";

# Output message body input
print $self->ui_table_start($self->{'text_hash'}->{'reply_body'}, "width=100%", 2);
if ($self->{'html_edit'}) {
	# Output HTML editor textarea
	print <<EOF;
<script type="text/javascript">
  _editor_url = "$self->{'gconfig_hash'}->{'webprefix'}/$self->{'module_name'}/xinha/";
  _editor_lang = "en";
</script>
<script type="text/javascript" src="xinha/htmlarea.js"></script>

<script type="text/javascript">
var editor = null;
function initEditor() {
  editor = new HTMLArea("body");
  editor.generate();
  return false;
}
</script>
EOF
	print $self->ui_table_row(undef,
		$self->ui_textarea("body", $self->{'quote'}, 20, 80, undef, 0,
		  	     "style='width:100%' id=body"), 2);
	}
else {
	# Show text editing area
	$self->{'wm'} = $self->{'config_hash'}->{'wrap_mode'};
	$self->{'wm'} =~ s/^wrap=//g;
	print $self->ui_table_row(undef,
		$self->ui_textarea("body", $self->{'quote'}, 20, 80, $self->{'wm'}, 0,
			     "style='width:100%'"), 2);
	}
if ($self->has_command("ispell") && !$self->{'userconfig_hash'}->{'nospell'}) {
	print $self->ui_table_row(undef,
	      $self->ui_checkbox("spell", 1, $self->{'text_hash'}->{'reply_spell'},
			   $self->{'userconfig_hash'}->{'spell_check'}), 2);
	}
print $self->ui_table_end(),"<p>\n";
print $self->ui_hidden("html_edit", $self->{'html_edit'});

# Display forwarded attachments
if (@attach) {
	print "<table width=100% border=1>\n";
	print "<tr> <td $self->{'tb'}><b>$self->{'text_hash'}->{'reply_attach'}</b></td> </tr>\n";
	print "<tr> <td $self->{'cb'}>\n";
	foreach $a (@attach) {
		push(@{$self->{'titles_array'}}, "<input type=checkbox name=forward value=$a->{'idx'} checked> ".($a->{'filename'} ? $a->{'filename'} : $a->{'type'}));
		push(@{$self->{'links_array'}}, "detach.cgi?idx=$self->{'in_hash'}->{'idx'}&mid=".$self->urlize($self->{'in_hash'}->{'mid'})."&folder=$self->{'in_hash'}->{'folder'}&attach=$a->{'idx'}$self->{'subs'}");
		push(@{$self->{'icons_array'}}, "images/boxes.gif");
		}
	$self->icons_table(\@{$self->{'links_array'}}, \@{$self->{'titles_array'}}, \@{$self->{'icons_array'}}, 8);
	print "</td></tr></table><p>\n";
	}

# Display forwarded mails
if (@{$self->{'fwdmail_array'}}) {
	print "<table width=100% border=1>\n";
	print "<tr> <td $self->{'tb'}><b>$self->{'text_hash'}->{'reply_mailforward'}</b></td> </tr>\n";
	print "<tr> <td $self->{'cb'}>\n";
	foreach $f (@{$self->{'fwdmail_array'}}) {
		push(@{$self->{'titles_array'}}, $self->simplify_subject($f->{'header'}->{'subject'}));
		push(@{$self->{'links_array'}}, "view_mail.cgi?idx=$f->{'sortidx'}&folder=$self->{'in_hash'}->{'folder'}&mid=".$self->urlize($f->{'header'}->{'message-id'}));
		push(@{$self->{'icons_array'}}, "images/boxes.gif");
		print $self->ui_hidden("mailforward",
			 "$f->{'sortidx'}/$f->{'header'}->{'message-id'}");
		}
	$self->icons_table(\@{$self->{'links_array'}}, \@{$self->{'titles_array'}}, \@{$self->{'icons_array'}}, 8);
	print "</td></tr></table><p>\n";
	}

# Add form for more attachments
print "<table width=100% border=1>\n";
print "<tr $self->{'tb'}> <td colspan=3><b>$self->{'text_hash'}->{'reply_attach2'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><input type=file size=20 name=attach0></td>\n";
print "<td><input type=file size=20 name=attach1></td>\n";
print "<td><input type=file size=20 name=attach2></td> </tr>\n";
print "<tr $self->{'cb'}> <td><input type=file size=20 name=attach3></td>\n";
print "<td><input type=file size=20 name=attach4></td>\n";
print "<td><input type=file size=20 name=attach5></td> </tr>\n";
if ($self->{'config_hash'}->{'server_attach'}) {
    print "<tr $self->{'cb'}> <td><input name=file0 size=20> ",
           $self->file_chooser_button("file0"),"</td>\n";
    print "<td><input name=file1 size=20> ",
        $self->file_chooser_button("file1"),"</td>\n";
    print "<td><input name=file2 size=20> ",
        $self->file_chooser_button("file2"),"</td> </tr>\n";
    }
print "</table><p>\n";

print $self->ui_form_end([ [ "send", $self->{'text_hash'}->{'reply_send'} ],
		     [ "draft", $self->{'text_hash'}->{'reply_draft'} ] ]);

$self->ui_print_footer($self->{'text_hash'}->{'index_mainpage_url'}, $self->{'text_hash'}->{'index_mainpage'},
			"view_mail.cgi?idx=$self->{'in_hash'}->{'idx'}&folder=$self->{'in_hash'}->{'folder'}",$self->{'text_hash'}->{'view_return'},
			"index.cgi?folder=$self->{'in_hash'}->{'folder'}",$self->{'text_hash'}->{'index'});
$self->pop3_logout_all();

1;
		
}

sub decode_and_sub
{
	shift if ($self == $_[0]);

return if (!$self->{'mail'});
$self->notes_decode($self->{'mail'}, $self->{'folder'});
$self->parse_mail($self->{'mail'});
@{$self->{'sub_array'}} = split(/\0/, $self->{'in_hash'}->{'sub'});
$self->{'subs'} = join("", map { "&sub=$_" } @{$self->{'sub_array'}});
foreach $s (@{$self->{'sub_array'}}) {
	# We are looking at a mail within a mail ..
	$self->decrypt_attachments($self->{'mail'});
	local $amail = $self->extract_mail(
			$self->{'mail'}->{'attach'}->[$s]->{'data'});
	$self->parse_mail($amail);
	$self->{'mail'} = $amail;
	}
($self->{'deccode'}, $self->{'decmessage'}) = $self->decrypt_attachments($self->{'mail'});
}

sub redirect_to_previous
{
	shift if ($self == $_[0]);

local $perpage = $self->{'folder'}->{'perpage'} || $self->{'userconfig_hash'}->{'perpage'};
local $s = int($self->{'in_hash'}->{'idx'} / $perpage) * $perpage;
if ($self->{'userconfig_hash'}->{'open_mode'}) {
	$self->redirect($self->{'viewlink'});
	}
else {
	$self->redirect("index.cgi?folder=$self->{'in_hash'}->{'folder'}&start=$s");
	}
}


1;

