#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_folder.cgi
# Create, modify or delete a folder
# XXX check for external clash

## 2007/02/19 kabe:
##  do not "keys(%isdir)==3" for Maildir/ check; Courier-IMAP et al
##  could add other things beside tmp/, new/, cur/.
##  (Usermin also adds .usermin-maildircache by itself)

&ModuleLoader::preload_module('mailbox_class', "mailbox::MailboxLib");
$self = new mailbox::MailboxLib:: 'mailbox_class',%$self;

$self->ReadParse();
@{$self->{'folders_array'}} = $self->list_folders();
if (!$self->{'in_hash'}->{'new'}) {
	$self->{'folder'} = $self->{'folders_array'}->[$self->{'in_hash'}->{'idx'}];
	$self->{'old'} = { %{$self->{'folder'}} };
	}
else {
	$self->{'folder'}->{'mode'} = $self->{'in_hash'}->{'mode'};
	}
$self->error_setup($self->{'text_hash'}->{'save_err'});

# Validate inputs
if (!$self->{'in_hash'}->{'delete'}) {
	$self->parse_folder_options($self->{'folder'}, $self->{'in_hash'}->{'mode'}, \%{$self->{'in_hash'}});
	}

# Can this type of folder be edited?
if ($self->{'in_hash'}->{'mode'} == 0) {
	$self->{'folder_types_hash'}->{'local'} || $self->error($self->{'text_hash'}->{'save_ecannot'});
	}
elsif ($self->{'in_hash'}->{'mode'} == 1) {
	$self->{'folder_types_hash'}->{'ext'} || $self->error($self->{'text_hash'}->{'save_ecannot'});
	}

if ($self->{'in_hash'}->{'mode'} == 0) {
	if ($self->{'in_hash'}->{'delete'} && $self->{'in_hash'}->{'confirm'}) {
		# Deleting a folder within ~/mail
		$self->delete_folder($self->{'folder'});
		}
	elsif ($self->{'in_hash'}->{'delete'} && !$self->{'in_hash'}->{'confirm'}) {
		# Confirming a delete
		$self->ui_print_header(undef, $self->{'text_hash'}->{'save_title'}, "");

		print "<form action=save_folder.cgi>\n";
		print "<input type=hidden name=idx value='$self->{'in_hash'}->{'idx'}'>\n";
		print "<input type=hidden name=mode value='$self->{'in_hash'}->{'mode'}'>\n";
		print "<input type=hidden name=confirm value='1'>\n";
		$self->{'sz'} = $self->nice_size($self->folder_size($self->{'folder'}));
		print "<center><b>",$self->text('save_rusure', $self->{'folder'}->{'name'},
			  "<tt>$self->{'folder'}->{'file'}</tt>", $self->{'sz'}),"</b><p>\n";
		print "<input type=submit name=delete ",
		      "value='$self->{'text_hash'}->{'save_delete'}'>\n";
		print "</center></form>\n";

		$self->ui_print_footer("list_folders.cgi", $self->{'text_hash'}->{'folders_return'});
		exit;
		}
	else {
		# Creating or renaming a folder within ~/mail
		$self->{'in_hash'}->{'name'} =~ /^\S+$/ || $self->error($self->{'text_hash'}->{'save_ename'});
		$self->{'in_hash'}->{'name'} =~ /\.\./ && $self->error($self->{'text_hash'}->{'save_ename2'});
		$self->{'in_hash'}->{'name'} ne 'sentmail' && $self->{'in_hash'}->{'name'} ne 'drafts' ||
			$self->error($self->{'text_hash'}->{'save_esys'});
		$self->{'path'} = "$self->{'folders_dir'}/$self->{'in_hash'}->{'name'}";
		if ($self->{'folders_dir'} eq "$self->{'remote_user_info_array'}->[7]/Maildir") {
			# Maildir sub-folder .. put a . in the name
			$self->{'path'} =~ s/([^\/]+)$/.$1/;
			}
		if ($self->{'old'} && $self->{'old'}->{'name'} ne $self->{'in_hash'}->{'name'}) {
			($self->{'clash'}) = grep { $_->{'file'} eq $self->{'path'} } @{$self->{'folders_array'}};
			$self->{'clash'} && $self->error($self->{'text_hash'}->{'save_eclash'});
			}
		$self->{'folder'}->{'type'} = $self->{'in_hash'}->{'type'};
		$self->{'folder'}->{'name'} = $self->{'in_hash'}->{'name'};
		$self->save_folder($self->{'folder'}, $self->{'old'});
		}
	}
elsif ($self->{'in_hash'}->{'mode'} == 1) {
	if ($self->{'in_hash'}->{'delete'}) {
		# Just remove from list of external folders
		$self->delete_folder($self->{'folder'});
		}
	else {
		# Adding or updating an external folder
		&verify_external($self->{'in_hash'}->{'file'});
		if ($self->{'old'} && $self->{'in_hash'}->{'file'} ne $self->{'old'}->{'file'}) {
			($self->{'clash'}) = grep { $_->{'file'} eq $self->{'in_hash'}->{'file'} }
					@{$self->{'folders_array'}};
			$self->{'clash'} && $self->error($self->{'text_hash'}->{'save_eclash'});
			}
		$self->{'in_hash'}->{'name'} || $self->error($self->{'text_hash'}->{'save_ename'});
		$self->{'folder'}->{'name'} = $self->{'in_hash'}->{'name'};
		$self->{'folder'}->{'file'} = $self->{'in_hash'}->{'file'};
		$self->save_folder($self->{'folder'}, $self->{'old'});
		}
	}
elsif ($self->{'in_hash'}->{'mode'} == 2) {
	# Changing the path to the sent mail folder
	if ($self->{'in_hash'}->{'sent_def'}) {
		$self->{'folder'}->{'file'} = "$self->{'folders_dir'}/sentmail";
		}
	else {
		&verify_external($self->{'in_hash'}->{'sent'});
		$self->{'folder'}->{'file'} = $self->{'in_hash'}->{'sent'};
		}
	$self->save_folder($self->{'folder'});
	}
$self->redirect("list_folders.cgi");

1;
		
}

sub verify_external
{
	shift if ($self == $_[0]);

if (-d $_[0]) {
	local ($f, %isdir);
	opendir(DIR, $_[0]);
	foreach $f (readdir(DIR)) {
		$isdir{$f}++ if (-d "$_[0]/$f" && $f ne "." && $f ne "..");
		}
	closedir(DIR);
	if (keys(%isdir)) {
		$isdir{'cur'} && $isdir{'new'} && $isdir{'tmp'} ||
			$self->error($self->text('save_emaildir', $_[0]));
		}
	}
elsif (-r $_[0]) {
	open(FOLDER, $_[0]);
	local $line = <FOLDER>;
	close(FOLDER);
	!$line || $line =~ /^From\s+(\S+).*\d+/ ||
		$self->error($self->text('save_embox', $_[0]));
	}
else {
	$self->error($self->text('save_efile', $_[0]));
	}
$_[0] =~ /^\Q$self->{'folders_dir'}\E\// && $self->error($self->text('save_eindir', $self->{'folders_dir'}));
}


1;

