#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Create, update or delete an IMAP folder

&ModuleLoader::preload_module('mailbox_class', "mailbox::MailboxLib");
$self = new mailbox::MailboxLib:: 'mailbox_class',%$self;

$self->ReadParse();
@{$self->{'folders_array'}} = $self->list_folders();

# Get or create the folder object
if ($self->{'in_hash'}->{'new'}) {
	$self->{'folder'} = { 'type' => 4,
		    'imapauto' => 1,
		    'server' => $self->{'folders_array'}->[0]->{'server'},
		    'user' => $self->{'folders_array'}->[0]->{'user'},
		    'pass' => $self->{'folders_array'}->[0]->{'pass'},
		  };
	}
else {
	$self->{'folder'} = $self->{'folders_array'}->[$self->{'in_hash'}->{'idx'}];
	}

if ($self->{'in_hash'}->{'delete'}) {
	# Delete the folder (on the server), after asking for confirmation
	if ($self->{'in_hash'}->{'confirm'}) {
		# Do the delete
		$self->delete_folder($self->{'folder'});
		}
	else {
		# Ask first
		$self->ui_print_header(undef, $self->{'text_hash'}->{'save_title'}, "");

		print "<center>\n";
		print $self->ui_form_start("save_ifolder.cgi");
		print $self->ui_hidden("idx", $self->{'in_hash'}->{'idx'}),"\n";
		print $self->ui_hidden("delete", 1),"\n";
		$self->{'sz'} = $self->nice_size($self->folder_size($self->{'folder'}));
		print $self->text('save_rusure2', $self->{'folder'}->{'name'}, $self->{'sz'}),"<p>\n";
		print $self->ui_form_end([ [ "confirm", $self->{'text_hash'}->{'save_delete'} ] ]);
		print "</center>\n";

		$self->ui_print_footer("list_ifolders.cgi", $self->{'text_hash'}->{'folders_return'});
		exit;
		}
	}
else {
	# Validate and store inputs
	if ($self->{'in_hash'}->{'new'} || $self->{'in_hash'}->{'name'} ne $self->{'folder'}->{'name'}) {
		$self->{'in_hash'}->{'name'} =~ /^[a-z0-9\.\-\/]+$/ ||
			$self->error($self->{'text_hash'}->{'save_ename'});
		$self->{'in_hash'}->{'name'} =~ /\.\./ && 
			$self->error($self->{'text_hash'}->{'save_ename2'});
		lc($self->{'in_hash'}->{'name'}) eq 'inbox' && 
			$self->error($self->{'text_hash'}->{'save_ename3'});
		($self->{'clash'}) = grep { lc($_->{'name'}) eq lc($self->{'in_hash'}->{'name'}) }
				@{$self->{'folders_array'}};
		$self->{'clash'} && $self->error($self->{'text_hash'}->{'save_eclash'});
		$self->{'folder'}->{'name'} = $self->{'in_hash'}->{'name'};
		}
	$self->parse_folder_options($self->{'folder'}, 4, \%{$self->{'in_hash'}});
	$self->save_folder($self->{'folder'});
	}

$self->redirect("list_ifolders.cgi");

1;
		
}


1;

