#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_imap.cgi
# Create, modify or delete an IMAP folder

&ModuleLoader::preload_module('mailbox_class', "mailbox::MailboxLib");
$self = new mailbox::MailboxLib:: 'mailbox_class',%$self;

$self->ReadParse();
@{$self->{'folders_array'}} = $self->list_folders();
if (!$self->{'in_hash'}->{'new'}) {
	$self->{'folder'} = $self->{'folders_array'}->[$self->{'in_hash'}->{'idx'}];
	$self->{'old'} = { %{$self->{'folder'}} };
	}
else {
	$self->{'folder'} = { 'type' => 4,
		    'mode' => 0 };
	}
$self->error_setup($self->{'text_hash'}->{'save_err'});
$self->{'folder_types_hash'}->{'imap'} || $self->error($self->{'text_hash'}->{'save_ecannot'});

if ($self->{'in_hash'}->{'delete'}) {
	# Just delete this folder and cache
	$self->delete_folder($self->{'folder'});
	}
else {
	# Validate inputs
	$self->{'in_hash'}->{'name'} =~ /\S/ || $self->error($self->{'text_hash'}->{'save_ename'});
	gethostbyname($self->{'in_hash'}->{'server'}) || $self->check_ipaddress($self->{'in_hash'}->{'server'}) ||
		$self->error($self->{'text_hash'}->{'save_eserver'});
	$self->{'in_hash'}->{'port_def'} || $self->{'in_hash'}->{'port'} =~ /^\d+$/ ||
		$self->error($self->{'text_hash'}->{'save_eport'});
	$self->{'in_hash'}->{'user'} =~ /\S/ || $self->error($self->{'text_hash'}->{'save_euser'});
	$self->{'in_hash'}->{'mailbox_def'} || $self->{'in_hash'}->{'mailbox'} =~ /^\S+$/ ||
		$self->error($self->{'text_hash'}->{'save_emailbox2'});
	$self->parse_folder_options($self->{'folder'}, 0, \%{$self->{'in_hash'}});

	# Save the folder
	$self->{'folder'}->{'name'} = $self->{'in_hash'}->{'name'};
	$self->{'folder'}->{'server'} = $self->{'in_hash'}->{'server'};
	$self->{'folder'}->{'port'} = $self->{'in_hash'}->{'port_def'} ? undef : $self->{'in_hash'}->{'port'};
	$self->{'folder'}->{'user'} = $self->{'in_hash'}->{'user'};
	$self->{'folder'}->{'pass'} = $self->{'in_hash'}->{'pass'};
	$self->{'folder'}->{'perpage'} = $self->{'in_hash'}->{'perpage_def'} ? undef : $self->{'in_hash'}->{'perpage'};
	$self->{'folder'}->{'fromaddr'} = $self->{'in_hash'}->{'fromaddr_def'} ? undef : $self->{'in_hash'}->{'fromaddr'};
	$self->{'folder'}->{'sent'} = $self->{'in_hash'}->{'sent'};
	local @err = $self->imap_login($self->{'folder'});
	if ($err[0] == 0) {
		$self->error($err[1]);
		}
	elsif ($err[0] == 2) {
		$self->error($self->text('save_elogin2', $err[1]));
		}
	elsif ($err[0] == 3) {
		$self->error($self->text('save_emailbox', $err[1]));
		}
	else {
		$self->imap_logout($err[1], 1);
		}
	$self->save_folder($self->{'folder'}, $self->{'old'});
	}
$self->redirect("list_folders.cgi");

1;
		
}


1;

