#!/usr/bin/perl

&MAIN();

 sub MAIN {
# send_mail.cgi
# Send off an email message

&ModuleLoader::preload_module('mailbox_class', "mailbox::MailboxLib");
$self = new mailbox::MailboxLib:: 'mailbox_class',%$self;


# Check inputs
$self->ReadParse(\%{$self->{'getin_hash'}}, "GET");
$self->ReadParseMime(undef, 'read_parse_mime_callback', [ $self->{'getin_hash'}->{'id'} ]);
$self->set_module_index($self->{'in_hash'}->{'folder'});
@{$self->{'folders_array'}} = $self->list_folders();
$self->{'folder'} = $self->{'folders_array'}->[$self->{'in_hash'}->{'folder'}];
$self->error_setup($self->{'text_hash'}->{'send_err'});
$self->{'in_hash'}->{'draft'} || $self->{'in_hash'}->{'to'} || $self->error($self->{'text_hash'}->{'send_eto'});
if (!$self->{'in_hash'}->{'subject'}) {
	if ($self->{'userconfig_hash'}->{'force_subject'} eq 'error') {
		$self->error($self->{'text_hash'}->{'send_esubject'});
		}
	elsif ($self->{'userconfig_hash'}->{'force_subject'}) {
		$self->{'in_hash'}->{'subject'} = $self->{'userconfig_hash'}->{'force_subject'};
		}
	}
@{$self->{'sub_array'}} = split(/\0/, $self->{'in_hash'}->{'sub'});
$self->{'subs'} = join("", map { "&sub=$_" } @{$self->{'sub_array'}});

# Construct the email
if ($self->{'config_hash'}->{'edit_from'} == 2) {
	$self->{'in_hash'}->{'user'} || $self->error($self->{'text_hash'}->{'send_efrom'});
	$self->{'in_hash'}->{'from'} = $self->{'in_hash'}->{'dom'} ? "$self->{'in_hash'}->{'user'}\@$self->{'in_hash'}->{'dom'}" : $self->{'in_hash'}->{'user'};
	if ($self->{'in_hash'}->{'real'}) {
		$self->{'in_hash'}->{'from'} = "\"$self->{'in_hash'}->{'real'}\" do { my $t=$self->{'in_hash'}->{'from'}; <$t> }";
		}
	}
else {
	$self->{'in_hash'}->{'from'} || $self->error($self->{'text_hash'}->{'send_efrom'});
	}
$self->{'in_hash'}->{'to'} = $self->expand_to($self->{'in_hash'}->{'to'});
$self->{'in_hash'}->{'cc'} = $self->expand_to($self->{'in_hash'}->{'cc'});
$self->{'in_hash'}->{'bcc'} = $self->expand_to($self->{'in_hash'}->{'bcc'});
$self->{'newmid'} = "<".time().".".$$."\@".$self->get_system_hostname().">";
$self->{'mail'}->{'headers'} = [ [ 'From', $self->{'in_hash'}->{'from'} ],
		       [ 'Subject', $self->{'in_hash'}->{'subject'} ],
		       [ 'To', $self->{'in_hash'}->{'to'} ],
		       [ 'Cc', $self->{'in_hash'}->{'cc'} ],
		       [ 'Bcc', $self->{'in_hash'}->{'bcc'} ],
		       [ 'X-Originating-IP', $ENV{'REMOTE_ADDR'} ],
		       [ 'X-Mailer', "Usermin ".$self->get_webmin_version() ],
		       [ 'Message-Id', $self->{'newmid'} ] ];
push(@{$self->{'mail'}->{'headers'}}, [ 'X-Priority', $self->{'in_hash'}->{'pri'} ]) if ($self->{'in_hash'}->{'pri'});
push(@{$self->{'mail'}->{'headers'}}, [ 'In-Reply-To', $self->{'in_hash'}->{'rid'} ]) if ($self->{'in_hash'}->{'rid'});
if ($self->{'userconfig_hash'}->{'req_dsn'} == 1 ||
    $self->{'userconfig_hash'}->{'req_dsn'} == 2 && $self->{'in_hash'}->{'dsn'}) {
	push(@{$self->{'mail'}->{'headers'}}, [ 'Disposition-Notification-To', $self->{'in_hash'}->{'from'} ]);
	push(@{$self->{'mail'}->{'headers'}}, [ 'Read-Receipt-To', $self->{'in_hash'}->{'from'} ]);
	}
if ($self->{'in_hash'}->{'replyto'}) {
	# Add real name to reply-to address, if not given and if possible
	local $r2 = $self->{'in_hash'}->{'replyto'};
	local ($r2parts) = $self->split_addresses($r2);
	$r2 = $r2parts->[1] || !$self->{'userconfig_hash'}->{'real_name'} ||
		    !$self->{'remote_user_info_array'}->[6] ? $self->{'in_hash'}->{'replyto'} :
			"\"$self->{'remote_user_info_array'}->[6]\" <$r2parts->[0]>";
	push(@{$self->{'mail'}->{'headers'}}, [ 'Reply-To', $r2 ]);
	}
$self->{'in_hash'}->{'body'} =~ s/\r//g;
if ($self->{'in_hash'}->{'body'} =~ /\S/) {
	# Perform spell check if requested
	local $plainbody = $self->{'in_hash'}->{'html_edit'} ? $self->html_to_text($self->{'in_hash'}->{'body'})
					    : $self->{'in_hash'}->{'body'};
	if ($self->{'in_hash'}->{'spell'}) {
		pipe(INr, INw);
		pipe(OUTr, OUTw);
		select(INw); $| = 1; select(OUTr); $| = 1; select(STDOUT);
		if (!fork()) {
			close(INw);
			close(OUTr);
			untie(*STDIN);
			untie(*STDOUT);
			untie(*STDERR);
			open(STDOUT, ">&OUTw");
			open(STDERR, ">/dev/null");
			open(STDIN, "<&INr");
			exec("ispell -a");
			exit;
			}
		close(INr);
		close(OUTw);
		local $indent = "&nbsp;" x 4;
		local @errs;
		foreach $line (split(/\n+/, $plainbody)) {
			next if ($line !~ /\S/);
			print INw $line,"\n";
			local @lerrs;
			while(1) {
				($self->{'spell'} = <OUTr>) =~ s/\r|\n//g;
				last if (!$self->{'spell'});
				if ($self->{'spell'} =~ /^#\s+(\S+)/) {
					# Totally unknown word
					push(@lerrs, $indent.$self->text('send_eword', "<i>".$self->html_escape($1)."</i>"));
					}
				elsif ($self->{'spell'} =~ /^&\s+(\S+)\s+(\d+)\s+(\d+):\s+(.*)/) {
					# Maybe possible word, with options
					push(@lerrs, $indent.$self->text('send_eword2', "<i>".$self->html_escape($1)."</i>", "<i>".$self->html_escape($4)."</i>"));
					}
				elsif ($self->{'spell'} =~ /^\?\s+(\S+)/) {
					# Maybe possible word
					push(@lerrs, $indent.$self->text('send_eword', "<i>".$self->html_escape($1)."</i>"));
					}
				}
			if (@lerrs) {
				push(@errs, $self->text('send_eline', "<tt>".$self->html_escape($line)."</tt>")."<br>".join("<br>", @lerrs)."<p>\n");
				}
			}
		close(INw);
		close(OUTr);
		if (@errs) {
			# Spelling errors found!
			$self->mail_page_header($self->{'text_hash'}->{'compose_title'});
			print "<b>$self->{'text_hash'}->{'send_espell'}</b><p>\n";
			print @errs;
			$self->ui_print_footer(
				"javascript:back()", $self->{'text_hash'}->{'reply_return'},
				"index.cgi?folder=$self->{'in_hash'}->{'folder'}",
				$self->{'text_hash'}->{'mail_return'});
			exit;
			}
		}
	local $mt = $self->{'in_hash'}->{'html_edit'} ? "text/html" : "text/plain";
	$mt .= "; charset=$self->{'userconfig_hash'}->{'charset'}";
	if ($self->{'in_hash'}->{'body'} =~ /[\177-\377]/) {
		# Contains 8-bit characters .. need to make quoted-printable
		$self->{'quoted_printable'}++;
		@{$self->{'attach_array'}} = ( { 'headers' => [ [ 'Content-Type', $mt ],
					     [ 'Content-Transfer-Encoding',
					       'quoted-printable' ] ],
			      'data' => $self->quoted_encode($self->{'in_hash'}->{'body'}) } );
		}
	else {
		# Plain 7-bit ascii text
		@{$self->{'attach_array'}} = ( { 'headers' => [ [ 'Content-Type', $mt ],
					     [ 'Content-Transfer-Encoding',
					       '7bit' ] ],
			      'data' => $self->{'in_hash'}->{'body'} } );
		}
	$self->{'bodyattach'} = $self->{'attach_array'}->[0];
	}
$self->{'attachsize'} = 0;
for($i=0; defined($self->{'in_hash'}->{"attach$i"}); $i++) {
	# Add uploaded attachment
	next if (!$self->{'in_hash'}->{"attach$i"});
	&test_max_attach($self->{'attachsize'});
	if ($self->{'config_hash'}->{'max_attach'} && $self->{'attachsize'} > $self->{'config_hash'}->{'max_attach'}) {
		$self->error($self->text('send_eattachsize', $self->{'config_hash'}->{'max_attach'}));
		}
	local $filename = $self->{'in_hash'}->{"attach${i}_filename"};
	$filename =~ s/^.*(\\|\/)//;
	local $type = $self->{'in_hash'}->{"attach${i}_content_type"}."; name=\"".
		      $filename."\"";
	local $disp = "inline; filename=\"".$filename."\"";
	push(@{$self->{'attach_array'}}, { 'data' => $self->{'in_hash'}->{"attach${i}"},
			'headers' => [ [ 'Content-type', $type ],
				       [ 'Content-Disposition', $disp ],
				       [ 'Content-Transfer-Encoding',
					 'base64' ] ] });
	}
for($i=0; defined($self->{'in_hash'}->{"file$i"}); $i++) {
	# Add server-side attachment
	next if (!$self->{'in_hash'}->{"file$i"} || !$self->{'config_hash'}->{'server_attach'});
	if ($self->{'in_hash'}->{"file$i"} !~ /^\//) {
		$self->{'in_hash'}->{"file$i"} = $self->{'remote_user_info_array'}->[7]."/".$self->{'in_hash'}->{"file$i"};
		}
	-r $self->{'in_hash'}->{"file$i"} && !-d $self->{'in_hash'}->{"file$i"} ||
		$self->error($self->text('send_efile', $self->{'in_hash'}->{"file$i"}));
	local @st = stat($self->{'in_hash'}->{"file$i"});
	&test_max_attach($st[7]);
	local $data;
	open(DATA, "<".$self->{'in_hash'}->{"file$i"}) ||
		$self->error($self->text('send_efile', $self->{'in_hash'}->{"file$i"}));
	while(<DATA>) {
		$data .= $_;
		}
	close(DATA);
	$self->{'in_hash'}->{"file$i"} =~ s/^.*\///;
	local $type = $self->guess_mime_type($self->{'in_hash'}->{"file$i"}).
		      "; name=\"".$self->{'in_hash'}->{"file$i"}."\"";
	local $disp = "inline; filename=\"".$self->{'in_hash'}->{"file$i"}."\"";
	push(@{$self->{'attach_array'}}, { 'data' => $data,
			'headers' => [ [ 'Content-type', $type ],
				       [ 'Content-Disposition', $disp ],
				       [ 'Content-Transfer-Encoding',
					 'base64' ] ] });
	$i++;
	}

# Add forwarded attachments
@{$self->{'fwd_array'}} = split(/\0/, $self->{'in_hash'}->{'forward'});
($self->{'sortfield'}, $self->{'sortdir'}) = $self->get_sort_field($self->{'folder'});
if (@{$self->{'fwd_array'}}) {
	@{$self->{'mail_array'}} = $self->mailbox_list_mails_sorted($self->{'in_hash'}->{'idx'}, $self->{'in_hash'}->{'idx'}, $self->{'folder'},
					   0, undef, $self->{'sortfield'}, $self->{'sortdir'});
	$fwdmail = $self->find_message_by_index(\@{$self->{'mail_array'}}, $self->{'folder'},
					  $self->{'in_hash'}->{'idx'}, $self->{'in_hash'}->{'mid'});
	$self->parse_mail($fwdmail);
	$self->decrypt_attachments($fwdmail);

	foreach $s (@{$self->{'sub_array'}}) {
		# We are looking at a mail within a mail ..
		$self->decrypt_attachments($fwdmail);
		local $amail = $self->extract_mail($fwdmail->{'attach'}->[$s]->{'data'});
		$self->parse_mail($amail);
		$fwdmail = $amail;
		}

	foreach $f (@{$self->{'fwd_array'}}) {
		&test_max_attach(length($fwdmail->{'attach'}->[$f]->{'data'}));
		push(@{$self->{'attach_array'}}, $fwdmail->{'attach'}->[$f]);
		}
	}

# Add forwarded emails
@{$self->{'mailfwdboth_array'}} = split(/\0/, $self->{'in_hash'}->{'mailforward'});
if (@{$self->{'mailfwdboth_array'}}) {
	@{$self->{'mailfwd_array'}} = $self->messages_from_indexes($self->{'folder'}, \@{$self->{'mailfwdboth_array'}});
	foreach $fwdmail (@{$self->{'mailfwd_array'}}) {
		local $headertext;
		foreach $h (@{$fwdmail->{'headers'}}) {
			$headertext .= $h->[0].": ".$h->[1]."\n";
			}
		push(@{$self->{'attach_array'}}, { 'data' => $headertext."\n".$fwdmail->{'body'},
				'headers' => [ [ 'Content-type', 'message/rfc822' ],
					       [ 'Content-Description',
						  $fwdmail->{'header'}->{'subject'} ] ]
			      });
		}
	}
if ($self->{'in_hash'}->{'sign'} ne '' && !$self->{'in_hash'}->{'draft'}) {
	# Put all the attachments into a single attachment, with the signature
	# as the second attachment
	$self->foreign_require("gnupg", "gnupg-lib.pl");
	local @keys = $self->foreign_call("gnupg", "list_keys");
	$key = $keys[$self->{'in_hash'}->{'sign'}];

	# Create the new attachment
	push(@{$self->{'mail'}->{'headers'}}, [ 'Content-Type', 'multipart/signed; micalg=pgp-sha1; protocol="application/pgp-signature"' ] );
	local ($tempdata, $tempbody);
	if (@{$self->{'attach_array'}} == 1) {
		# Just use one part
		$tempdata = &write_attachment($self->{'attach_array'}->[0]);
		$self->{'tempheaders'} = $self->{'attach_array'}->[0]->{'headers'};
		$tempbody = $self->{'attach_array'}->[0]->{'data'};
		}
	else {
		# Create new attachment containing all the parts
		local $bound = "sign".time();
		foreach $a (@{$self->{'attach_array'}}) {
			$tempbody .= "\r\n";
			$tempbody .= "--".$bound."\r\n";
			$tempbody .= &write_attachment($a);
			}
		$tempbody .= "\r\n";
		$tempbody .= "--".$bound."--\r\n";
		$tempdata ="Content-Type: multipart/mixed; boundary=\"$bound\"\r\n".
			   "\r\n".
			   $tempbody;
		$self->{'tempheaders'} = [ [ "Content-Type", "multipart/mixed; boundary=\"$bound\"" ] ];
		}

	# Sign the file
	local $sigdata;
	local $rv = $self->foreign_call("gnupg", "sign_data", $tempdata, \$sigdata,
				  $key, 2);
	if ($rv) {
		$self->error($self->text('send_esign', $rv));
		}

	@{$self->{'attach_array'}} = ( { 'data' => $tempbody,
		      'headers' => $self->{'tempheaders'} },
		    { 'data' => $sigdata,
		      'headers' => [ [ "Content-Type", "application/pgp-signature; name=signature.asc" ] ] }
		  );
	}
$self->{'mail'}->{'attach'} = \@{$self->{'attach_array'}};

if ($self->{'in_hash'}->{'crypt'} ne '' && !$self->{'in_hash'}->{'draft'}) {
	# Encrypt the entire mail
	$self->foreign_require("gnupg", "gnupg-lib.pl");
	local @keys = $self->foreign_call("gnupg", "list_keys");
	local @ekeys;
	local $key;
	if ($self->{'in_hash'}->{'crypt'} == -1) {
		# Find the keys for the To:, Cc: and Bcc: address
		local @addrs = ( $self->address_parts($self->{'in_hash'}->{'to'}),
				 $self->address_parts($self->{'in_hash'}->{'cc'}),
				 $self->address_parts($self->{'in_hash'}->{'bcc'}) );
		local $a;
		foreach $a (@addrs) {
			local $found;
			foreach $k (@keys) {
				if ($self->indexof($a, @{$k->{'email'}}) >= 0) {
					push(@ekeys, $k);
					$found++;
					last;
					}
				}
			$self->error($self->text('send_ekey', $a)) if (!$found);
			}
		}
	else {
		@ekeys = ( $keys[$self->{'in_hash'}->{'crypt'}] );
		}
	if ($self->{'userconfig_hash'}->{'self_crypt'}) {
		local ($skey) = grep { $_->{'secret'} } @keys;
		push(@ekeys, $skey);
		}
	local $temp = $self->transname();
	$self->send_mail($self->{'mail'}, $temp);
	local ($tempdata, $buf);
	open(TEMP, $temp);
	local $dummy = <TEMP>;	# skip From line
	while(read(TEMP, $buf, 1024) > 0) {
		$tempdata .= $buf;
		}
	close(TEMP);
	unlink($temp);
	local $crypted;
	local $rv = $self->foreign_call("gnupg", "encrypt_data", $tempdata,
				  \$crypted, \@ekeys, 1);
	$rv && $self->error($self->text('send_ecrypt', $rv));

	# Put into new attachments format
	$self->{'mail'}->{'headers'} =
	       [ ( grep { lc($_->[0]) ne 'content-type' } @{$self->{'mail'}->{'headers'}} ),
	         [ 'Content-Type',
		   'multipart/encrypted; protocol="application/pgp-encrypted"' ] ];
	$self->{'mail'}->{'attach'} =
		[ { 'headers' => [ [ 'Content-Transfer-Encoding', '7bit' ],
				   [ 'Content-Type', 'application/pgp-encrypted'] ],
		    'data' => "Version: 1\n" },
		  { 'headers' => [ [ 'Content-Transfer-Encoding', '7bit' ],
				   [ 'Content-Type', 'application/octet-stream' ] ],
		    'data' => $crypted }
		];
	}

# Check for text-only email
$self->{'textonly'} = $self->{'userconfig_hash'}->{'no_mime'} && !$self->{'quoted_printable'} &&
	    @{$self->{'mail'}->{'attach'}} == 1 &&
	    $self->{'mail'}->{'attach'}->[0] eq $self->{'bodyattach'} && !$self->{'in_hash'}->{'html_edit'};

if (!$self->{'userconfig_hash'}->{'send_return'}) {
	# Tell the user what is happening
	$self->mail_page_header($self->{'text_hash'}->{'send_title'});
	@{$self->{'tos_array'}} = ( split(/,/, $self->{'in_hash'}->{'to'}), split(/,/, $self->{'in_hash'}->{'cc'}), split(/,/, $self->{'in_hash'}->{'bcc'}) );
	$self->{'tos'} = join(" , ", map { "<tt>".$self->html_escape($_)."</tt>" } @{$self->{'tos_array'}});
	print $self->text($self->{'in_hash'}->{'draft'} ? 'send_draft' : 'send_sending',
			  $self->{'tos'} || $self->{'text_hash'}->{'send_nobody'}),"<p>\n";
	}

if ($self->{'in_hash'}->{'draft'}) {
	# Save in the drafts folder
	($self->{'dfolder'}) = grep { $_->{'drafts'} } @{$self->{'folders_array'}};
	$self->{'qerr'} = $self->would_exceed_quota($self->{'dfolder'}, $self->{'mail'});
	$self->error($self->{'qerr'}) if ($self->{'qerr'});
	$self->lock_folder($self->{'dfolder'});
	if ($self->{'in_hash'}->{'enew'} && $self->{'folder'} eq $self->{'dfolder'}) {
		# Update existing draft mail
		($self->{'dsortfield'}, $self->{'dsortdir'}) = $self->get_sort_field($self->{'dfolder'});
		@{$self->{'oldmail_array'}} = $self->mailbox_list_mails_sorted($self->{'in_hash'}->{'idx'}, $self->{'in_hash'}->{'idx'},
			       $self->{'dfolder'}, 0, undef, $self->{'dsortfield'}, $self->{'dsortdir'});
		$self->{'oldmail'} = $self->find_message_by_index(\@{$self->{'oldmail_array'}}, $self->{'dfolder'}, $self->{'in_hash'}->{'idx'}, $self->{'in_hash'}->{'mid'});
		$self->{'oldmail'} || $self->error($self->{'text_hash'}->{'view_egone'});
		$self->mailbox_modify_mail($self->{'oldmail'}, $self->{'mail'}, $self->{'dfolder'}, $self->{'textonly'});
		}
	else {
		# Save as a new draft
		$self->write_mail_folder($self->{'mail'}, $self->{'dfolder'}, $self->{'textonly'});
		}
	$self->unlock_folder($self->{'dfolder'});
	}
else {
	# Send it off and optionally save in sent mail
	local $sfolder;
	if ($self->{'userconfig_hash'}->{'save_sent'}) {
		($sfolder) = grep { $_->{'sent'} } @{$self->{'folders_array'}};
		if ($sfolder) {
			$self->{'qerr'} = $self->would_exceed_quota($sfolder, $self->{'mail'});
			$self->error($self->{'qerr'}) if ($self->{'qerr'});
			}
		}
	$self->{'notify'} = $self->{'userconfig_hash'}->{'req_del'} == 1 ||
		  $self->{'userconfig_hash'}->{'req_del'} == 2 && $self->{'in_hash'}->{'del'} ?
			[ "SUCCESS","FAILURE" ] : undef;
	$self->send_mail($self->{'mail'}, undef, $self->{'textonly'}, $self->{'config_hash'}->{'no_crlf'},
		   undef, undef, undef, undef,
		   $self->{'notify'});
	if ($sfolder) {
		$self->lock_folder($sfolder);
		$self->write_mail_folder($self->{'mail'}, $sfolder, $self->{'textonly'}) if ($sfolder);
		$self->unlock_folder($sfolder);
		}
	}

# Mark the new message as read
$self->open_read_hash();
if ($self->{'userconfig_hash'}->{'auto_mark'}) {
	$self->{'read_hash'}->{$self->{'newmid'}} ||= 1;
	}

if ($self->{'in_hash'}->{'abook'}) {
	# Add all recipients to the address book, if missing
	local @recips = ( $self->split_addresses($self->{'in_hash'}->{'to'}),
		    	  $self->split_addresses($self->{'in_hash'}->{'cc'}),
		    	  $self->split_addresses($self->{'in_hash'}->{'bcc'}) );
	local @addrs = $self->list_addresses();
	foreach $r (@recips) {
		local ($already) = grep { $_->[0] eq $r->[0] } @addrs;
		if (!$already) {
			$self->create_address($r->[0], $r->[1]);
			push(@addrs, [ $r->[0], $r->[1] ]);
			}
		}
	}

if ($self->{'userconfig_hash'}->{'send_return'}) {
	# Return to mail list
	$self->redirect("index.cgi?folder=$self->{'in_hash'}->{'folder'}");
	}
else {
	# Print footer
	print "$self->{'text_hash'}->{'send_done'}<p>\n";
	if ($self->{'in_hash'}->{'idx'} ne '') {
		$self->mail_page_footer(
		    "view_mail.cgi?idx=$self->{'in_hash'}->{'idx'}&folder=$self->{'in_hash'}->{'folder'}&mid=".
		    $self->urlize($self->{'in_hash'}->{'mid'})."$self->{'subs'}", $self->{'text_hash'}->{'view_return'},
		    "index.cgi?folder=$self->{'in_hash'}->{'folder'}", $self->{'text_hash'}->{'mail_return'});
		}
	else {
		$self->mail_page_footer(
		       "reply_mail.cgi?new=1&folder=$self->{'in_hash'}->{'folder'}",
				 $self->{'text_hash'}->{'reply_return'},
				 "index.cgi?folder=$self->{'in_hash'}->{'folder'}",
				 $self->{'text_hash'}->{'mail_return'});
		}
	}

1;
		
}

# write_attachment(&attach)
sub write_attachment
{
	shift if ($self == $_[0]);

local ($a) = @_;
local ($enc, $rv);
foreach $h (@{$a->{'headers'}}) {
	$rv .= $h->[0].": ".$h->[1]."\r\n";
	$enc = $h->[1]
	    if (lc($h->[0]) eq 'content-transfer-encoding');
	}
$rv .= "\r\n";
if (lc($enc) eq 'base64') {
	local $encoded = $self->encode_base64($a->{'data'});
	$encoded =~ s/\r//g;
	$encoded =~ s/\n/\r\n/g;
	$rv .= $encoded;
	}
else {
	$a->{'data'} =~ s/\r//g;
	$a->{'data'} =~ s/\n/\r\n/g;
	$rv .= $a->{'data'};
	if ($a->{'data'} !~ /\n$/) {
		$rv .= "\r\n";
		}
	}
return $rv;
}

sub test_max_attach
{
	shift if ($self == $_[0]);

$self->{'attachsize'} += $_[0];
if ($self->{'config_hash'}->{'max_attach'} && $self->{'attachsize'} > $self->{'config_hash'}->{'max_attach'}) {
	$self->error($self->text('send_eattachsize', $self->{'config_hash'}->{'max_attach'}));
	}
}


1;

