#!/usr/bin/perl

&MAIN();

 sub MAIN {
# view_mail.cgi
# View a single email message 

## kabe 2007/02/19:
##  fixed display of ISO-2022-JP encoded From: display 

&ModuleLoader::preload_module('mailbox_class', "mailbox::MailboxLib");
$self = new mailbox::MailboxLib:: 'mailbox_class',%$self;


$self->ReadParse();
foreach $a ($self->list_addresses()) {
	$self->{'inbook_hash'}->{$a->[0]}++;
	}

@{$self->{'folders_array'}} = $self->list_folders_sorted();
($self->{'folder'}) = grep { $_->{'index'} == $self->{'in_hash'}->{'folder'} } @{$self->{'folders_array'}};
$self->{'qmid'} = $self->urlize($self->{'in_hash'}->{'mid'});
if ($self->{'in_hash'}->{'idx'} =~ /^(\d+)\/(.*)$/) {
	# Fix links where idx contains index and message ID (when in open_mode)
	$self->{'in_hash'}->{'idx'} = $1;
	$self->{'in_hash'}->{'mid'} = $2;
	}
@{$self->{'mail_array'}} = $self->mailbox_list_mails_sorted($self->{'in_hash'}->{'idx'}, $self->{'in_hash'}->{'idx'}, $self->{'folder'},
				   0, undef);
$self->{'mail'} = $self->find_message_by_index(\@{$self->{'mail_array'}}, $self->{'folder'}, $self->{'in_hash'}->{'idx'}, $self->{'in_hash'}->{'mid'});
$self->{'mail'} || $self->error($self->{'text_hash'}->{'view_egone'});
$self->notes_decode($self->{'mail'}, $self->{'folder'});
$self->parse_mail($self->{'mail'}, undef, $self->{'in_hash'}->{'raw'});
@{$self->{'sub_array'}} = split(/\0/, $self->{'in_hash'}->{'sub'});
$self->{'subs'} = join("", map { "&sub=$_" } @{$self->{'sub_array'}});
foreach $s (@{$self->{'sub_array'}}) {
        # We are looking at a mail within a mail ..
	$self->decrypt_attachments($self->{'mail'});
        local $amail = $self->extract_mail($self->{'mail'}->{'attach'}->[$s]->{'data'});
        $self->parse_mail($amail, undef, $self->{'in_hash'}->{'raw'});
        $self->{'mail'} = $amail;
        }

# Mark this mail as read
$self->open_read_hash();
$self->{'mid'} = $self->{'mail'}->{'header'}->{'message-id'};
if ($self->{'userconfig_hash'}->{'auto_mark'}) {
	eval { $self->{'read_hash'}->{$self->{'mid'}} = 1 } if (!$self->{'read_hash'}->{$self->{'mid'}});
	}

# Possibly send a DSN, or check if one is needed
$self->{'dsn_req'} = $self->requires_delivery_notification($self->{'mail'});
if (!@{$self->{'sub_array'}} && $self->{'dsn_req'} && !$self->{'folder'}->{'sent'} && !$self->{'folder'}->{'drafts'}) {
	dbmopen(%{$self->{'dsn_hash'}}, "$self->{'user_module_config_directory'}/dsn", 0600);
	if ($self->{'userconfig_hash'}->{'send_dsn'} == 1 && !$self->{'dsn_hash'}->{$self->{'mid'}}) {
		# Send a DSN for this mail now
		local $dsnaddr = $self->send_delivery_notification($self->{'mail'}, undef, 0);
		if ($dsnaddr) {
			$self->{'dsn_hash'}->{$self->{'mid'}} = time()." ".$dsnaddr;
			$self->{'sent_dsn'} = 1;
			}
		}
	elsif ($self->{'userconfig_hash'}->{'send_dsn'} == 2 && !$self->{'dsn_hash'}->{$self->{'mid'}}) {
		# User may want to send one
		$self->{'send_dsn_button'} = 1;
		}
	($self->{'sent_dsn_at'}, $self->{'sent_dsn_to'}) = split(/\s+/, $self->{'dsn_hash'}->{$self->{'mid'}}, 2);
	dbmclose(%{$self->{'dsn_hash'}});
	}

# Check if we have gotten back a DSN for *this* email
$self->update_delivery_notification($self->{'mail'}, $self->{'folder'});
$self->open_dsn_hash();
if (defined($self->{'dsnreplies_hash'}->{$self->{'mid'}}) && $self->{'dsnreplies_hash'}->{$self->{'mid'}} != 1) {
	($self->{'got_dsn'}, $self->{'got_dsn_from'}) = split(/\s+/, $self->{'dsnreplies_hash'}->{$self->{'mid'}}, 2);
	}
if (defined($self->{'delreplies_hash'}->{$self->{'mid'}}) && $self->{'delreplies_hash'}->{$self->{'mid'}} != 1) {
	local @del = split(/\s+/, $self->{'delreplies_hash'}->{$self->{'mid'}});
	local $i;
	for($i=0; $i<@del; $i+=2) {
		local $tm = localtime($del[$i]);
		if ($del[$i+1] =~ /^\!(.*)$/) {
			push(@{$self->{'delmsgs_array'}}, $self->text('view_delfailed', "$1", $tm));
			}
		else {
			push(@{$self->{'delmsgs_array'}}, $self->text('view_delok', $del[$i+1], $tm));
			}
		}
	}

if ($self->{'in_hash'}->{'raw'}) {
	# Special mode - viewing whole raw message
	print "Content-type: text/plain\n\n";
	if ($self->{'mail'}->{'fromline'}) {
		print $self->{'mail'}->{'fromline'},"\n";
		}
	if (defined($self->{'mail'}->{'rawheaders'})) {
		#$self->{'mail'}->{'rawheaders'} =~ s/(\S)\t/$1\n\t/g;
		print $self->{'mail'}->{'rawheaders'};
		}
	else {
		foreach $h (@{$self->{'mail'}->{'headers'}}) {
			#$h->[1] =~ s/(\S)\t/$1\n\t/g;
			print "$h->[0]: $h->[1]\n";
			}
		}
	print "\n";
	print $self->{'mail'}->{'body'};
	exit;
	}

# Check for encryption
($self->{'deccode'}, $self->{'decmessage'}) = $self->decrypt_attachments($self->{'mail'});
@{$self->{'attach_array'}} = @{$self->{'mail'}->{'attach'}};

# Find body attachment and type
($self->{'textbody'}, $self->{'htmlbody'}, $self->{'body'}) = $self->find_body($self->{'mail'}, $self->{'userconfig_hash'}->{'view_html'});
$self->{'body'} = $self->{'htmlbody'} if ($self->{'in_hash'}->{'body'} == 2);
$self->{'body'} = $self->{'textbody'} if ($self->{'in_hash'}->{'body'} == 1);

# Show pre-body HTML
if ($self->{'body'} && $self->{'body'} eq $self->{'htmlbody'} && $self->{'userconfig_hash'}->{'head_html'}) {
	$self->{'headstuff'} = $self->head_html($self->{'body'}->{'data'});
	}

# Get the character set
if ($self->{'body'}) {
	$self->{'ctype'} = $self->{'body'}->{'header'}->{'content-type'} ||
		 $self->{'mail'}->{'header'}->{'content-type'};
	if ($self->{'ctype'} =~ /charset="([a-z0-9\-]+)"/i ||
	    $self->{'ctype'} =~ /charset='([a-z0-9\-]+)'/i ||
	    $self->{'ctype'} =~ /charset=([a-z0-9\-]+)/i) {
		$self->{'charset'} = $1;
		}
	}
## Special handling of HTML header charset ($self->{'force_charset'}):
## For japanese $self->text(ISO-2022-JP/EUC=JP/SJIS), the HTML output and
## text contents ($self->{'bodycontents'}) are already converted to EUC,
## so overriding HTML charset to that in the mail header ($self->{'charset'})
## is generally wrong. (cf. mailbox/boxes-lib.pl:eucconv())
if ( $self->get_charset() =~ /^EUC/i ) {	# EUC-JP,EUC-KR
	# use default charset output for HTML
} else {
	$self->{'force_charset'} = $self->{'charset'};
}

$self->set_module_index($self->{'in_hash'}->{'folder'});
$self->mail_page_header($self->{'text_hash'}->{'view_title'}, $self->{'headstuff'});
print $self->check_clicks_function();
&show_arrows();
print "<br>\n";

print "<form action=reply_mail.cgi>\n";
print $self->ui_hidden("idx", $self->{'in_hash'}->{'idx'}),"\n";
print $self->ui_hidden("mid", $self->{'in_hash'}->{'mid'}),"\n";
print $self->ui_hidden("folder", $self->{'in_hash'}->{'folder'}),"\n";
print $self->ui_hidden("mod", $self->modification_time($self->{'folder'})),"\n";
print $self->ui_hidden("body", $self->{'in_hash'}->{'body'}),"\n";
foreach $s (@{$self->{'sub_array'}}) {
	print $self->ui_hidden("sub", $s),"\n";
	}

# Find any delivery status attachment
($self->{'dstatus'}) = grep { $_->{'type'} eq 'message/delivery-status' } @{$self->{'attach_array'}};

# XXX look for text/calendar body

# Check for signing
if ($self->has_command("gpg") && $self->foreign_check("gnupg")) {
	# Check for GnuPG signatures
	local $sig;
	foreach $a (@{$self->{'attach_array'}}) {
		$sig = $a if ($a->{'type'} =~ /^application\/pgp-signature/);
		}
	if ($sig) {
		# Verify the signature against the rest of the attachment
		$self->foreign_require("gnupg", "gnupg-lib.pl");
		local $rest = $sig->{'parent'}->{'attach'}->[0];
		$rest->{'raw'} =~ s/\r//g;
		$rest->{'raw'} =~ s/\n/\r\n/g;
		($self->{'sigcode'}, $self->{'sigmessage'}) = $self->foreign_call("gnupg",
				"verify_data", $rest->{'raw'}, $sig->{'data'});
		@{$self->{'attach_array'}} = grep { $_ ne $sig } @{$self->{'attach_array'}};
		$self->{'sindex'} = $sig->{'idx'};
		}
	elsif ($self->{'textbody'} && $self->{'textbody'}->{'data'} =~ /(-+BEGIN PGP SIGNED MESSAGE-+\n(Hash:\s+(\S+)\n\n)?([\000-\377]+\n)-+BEGIN PGP SIGNATURE-+\n([\000-\377]+)-+END PGP SIGNATURE-+\n)/i) {
		# Signature is in body text!
		local $sig = $1;
		local $text = $4;
		$self->foreign_require("gnupg", "gnupg-lib.pl");
		($self->{'sigcode'}, $self->{'sigmessage'}) = $self->foreign_call("gnupg",
							"verify_data", $sig);
		$self->{'body'} = $self->{'textbody'};
		if ($self->{'sigcode'} == 0 || $self->{'sigcode'} == 1) {
			# XXX what about replying?
			$self->{'body'}->{'data'} = $text;
			}
		}
	}

# Strip out attachments not to display as icons
@{$self->{'attach_array'}} = grep { $_ ne $self->{'body'} && $_ ne $self->{'dstatus'} } @{$self->{'attach_array'}};
@{$self->{'attach_array'}} = grep { !$_->{'attach'} } @{$self->{'attach_array'}};

if ($self->{'userconfig_hash'}->{'top_buttons'} == 2 && $self->editable_mail($self->{'mail'})) {
	&show_buttons(1, scalar(@{$self->{'sub_array'}}));
	print "<p>\n";
	}

print "<table width=100% border=1>\n";
print "<tr> <td><table width=100% cellpadding=0 cellspacing=0><tr $self->{'tb'}>",
      "<td><b>$self->{'text_hash'}->{'view_headers'}</b></td> <td align=right>\n";
if ($self->{'in_hash'}->{'headers'}) {
	print "<a href='view_mail.cgi?idx=$self->{'in_hash'}->{'idx'}&mid=$self->{'qmid'}&body=$self->{'in_hash'}->{'body'}&headers=0&folder=$self->{'in_hash'}->{'folder'}$self->{'subs'}'>$self->{'text_hash'}->{'view_noheaders'}</a>\n";
	}
else {
	print "<a href='view_mail.cgi?idx=$self->{'in_hash'}->{'idx'}&mid=$self->{'qmid'}&body=$self->{'in_hash'}->{'body'}&headers=1&folder=$self->{'in_hash'}->{'folder'}$self->{'subs'}'>$self->{'text_hash'}->{'view_allheaders'}</a>\n";
	}
print "&nbsp;&nbsp;<a href='view_mail.cgi?idx=$self->{'in_hash'}->{'idx'}&mid=$self->{'qmid'}&raw=1&folder=$self->{'in_hash'}->{'folder'}$self->{'subs'}'>$self->{'text_hash'}->{'view_raw'}</a></td>\n";
print "</tr></table></td> </tr>\n";

print "<tr $self->{'cb'}> <td><table width=100%>\n";
if ($self->{'in_hash'}->{'headers'}) {
	# Show all the headers
	if ($self->{'mail'}->{'fromline'}) {
		print "<tr> <td><b>$self->{'text_hash'}->{'mail_rfc'}</b></td>",
		      "<td>",$self->eucconv_and_escape($self->{'mail'}->{'fromline'}),
		      "</td> </tr>\n";
		}
	foreach $h (@{$self->{'mail'}->{'headers'}}) {
		print "<tr> <td><b>$h->[0]:</b></td> ",
		      "<td>",$self->eucconv_and_escape($self->decode_mimewords($h->[1])),
		      "</td> </tr>\n";
		}
	}
else {
	# Just show the most useful headers
	local @addrs = $self->split_addresses($self->decode_mimewords(
				$self->{'mail'}->{'header'}->{'from'}));
	local @toaddrs = $self->split_addresses($self->decode_mimewords(
				$self->{'mail'}->{'header'}->{'to'}));
	print "<tr> <td valign=top><b>$self->{'text_hash'}->{'mail_from'}</b></td> ",
	      "<td>",&address_link($self->{'mail'}->{'header'}->{'from'}),"</td>",
	      "<td align=right>",&search_link("from", $addrs[0]->[0],
			$self->{'text_hash'}->{'mail_fromsrch'}),"</td> </tr>\n";
	print "<tr> <td valign=top><b>$self->{'text_hash'}->{'mail_to'}</b></td> ",
	      "<td>",&address_link($self->{'mail'}->{'header'}->{'to'}),"</td>",
	      "<td align=right>",&search_link("to", $toaddrs[0]->[0],
			$self->{'text_hash'}->{'mail_tosrch'}),"</td> </tr>\n";
	print "<tr> <td valign=top><b>$self->{'text_hash'}->{'mail_cc'}</b></td> ",
	      "<td>",&address_link($self->{'mail'}->{'header'}->{'cc'}),"</td> </tr>\n"
		if ($self->{'mail'}->{'header'}->{'cc'});
	print "<tr> <td valign=top><b>$self->{'text_hash'}->{'mail_bcc'}</b></td> ",
	      "<td>",&address_link($self->{'mail'}->{'header'}->{'bcc'}),"</td> </tr>\n"
		if ($self->{'mail'}->{'header'}->{'bcc'});
	print "<tr> <td><b>$self->{'text_hash'}->{'mail_date'}</b></td> ",
	      "<td>",$self->eucconv_and_escape($self->{'mail'}->{'header'}->{'date'}),
	      "</td> </tr>\n";
	local $subj = $self->{'mail'}->{'header'}->{'subject'};
	$subj =~ s/^((Re:|Fwd:|\[\S+\])\s*)+//g;
	print "<tr> <td><b>$self->{'text_hash'}->{'mail_subject'}</b></td> ",
	      "<td>",$self->eucconv_and_escape($self->decode_mimewords(
			$self->{'mail'}->{'header'}->{'subject'})),"</td> ",
	      "<td align=right>",&search_link("subject", $subj,
			$self->{'text_hash'}->{'mail_subsrch'}),"</td> </tr>\n";
	}
print "</table></td></tr></table><p>\n";

# Show body attachment, with properly linked URLs
if ($self->{'body'} && $self->{'body'}->{'data'} =~ /\S/) {
	if ($self->{'body'} eq $self->{'textbody'}) {
		# Show plain text
		$self->{'bodycontents'} = "<pre>";
		foreach $l ($self->wrap_lines($self->eucconv($self->{'body'}->{'data'}),
					$self->{'userconfig_hash'}->{'wrap_width'})) {
			$self->{'bodycontents'} .= $self->link_urls_and_escape($l,
						$self->{'userconfig_hash'}->{'link_mode'})."\n";
			}
		$self->{'bodycontents'} .= "</pre>";
		if ($self->{'htmlbody'}) {
			$self->{'bodyright'} = "<a href='view_mail.cgi?idx=$self->{'in_hash'}->{'idx'}&mid=$self->{'qmid'}&body=2&headers=$self->{'in_hash'}->{'headers'}&folder=$self->{'in_hash'}->{'folder'}$self->{'subs'}'>$self->{'text_hash'}->{'view_ashtml'}</a>";
			}
		}
	elsif ($self->{'body'} eq $self->{'htmlbody'}) {
		# Attempt to show HTML
		($self->{'bodycontents'}, $self->{'bodystuff'}) = $self->safe_html($self->{'body'}->{'data'});
		$self->{'bodycontents'} = $self->fix_cids($self->{'bodycontents'}, \@{$self->{'attach_array'}},
			"detach.cgi?idx=$self->{'in_hash'}->{'idx'}&folder=$self->{'in_hash'}->{'folder'}$self->{'subs'}",
			\@{$self->{'cidattach_array'}});
		if ($self->{'textbody'}) {
			$self->{'bodyright'} = "<a href='view_mail.cgi?idx=$self->{'in_hash'}->{'idx'}&mid=$self->{'qmid'}&body=1&headers=$self->{'in_hash'}->{'headers'}&folder=$self->{'in_hash'}->{'folder'}$self->{'subs'}'>$self->{'text_hash'}->{'view_astext'}</a>";
			}
		%{$self->{'ciddone_hash'}} = map { $_->{'index'}, 1 } @{$self->{'cidattach_array'}};
		@{$self->{'attach_array'}} = grep { !$self->{'ciddone_hash'}->{$_->{'index'}} } @{$self->{'attach_array'}};
		}
	}
if ($self->{'bodycontents'}) {
	print "<table width=100% border=1>\n";
	print "<tr $self->{'tb'}> <td><table width=100% cellpadding=0 cellspacing=0><tr>",
	      "<td><b>$self->{'text_hash'}->{'view_body'}</b></td> ",
	      "<td align=right>$self->{'bodyright'}</td> </tr></table></td> </tr>\n";
	print "<tr $self->{'cb'}> <td $self->{'bodystuff'}>\n";
	print $self->{'bodycontents'};
	print "</td></tr></table><p>\n";
	}

# If *this* message is a delivery status, display it
if ($self->{'dstatus'}) {
	local $ds = $self->parse_delivery_status($self->{'dstatus'}->{'data'});
	$self->{'dtxt'} = $ds->{'status'} =~ /^2\./ ? $self->{'text_hash'}->{'view_dstatusok'}
					  : $self->{'text_hash'}->{'view_dstatus'};
	print "<table width=100% border=1>\n";
	print "<tr $self->{'tb'}> <td><b>$self->{'dtxt'}</b></td> </tr>\n";
	print "<tr $self->{'cb'}> <td><table>\n";

	foreach $dsh ('final-recipient', 'diagnostic-code',
		      'remote-mta', 'reporting-mta') {
		if ($ds->{$dsh}) {
			$ds->{$dsh} =~ s/^\S+;//;
			print "<tr> <td nowrap valign=top><b>",
			      $self->{'text_hash'}->{'view_'.$dsh},"</b></td>\n";
			print "<td>",$self->html_escape($ds->{$dsh}),"</td> </tr>\n";
			}
		}

	print "</table></td></tr></table><p>\n";
	}

# Display other attachments
if (@{$self->{'attach_array'}}) {
	print "<table width=100% border=1>\n";
	print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'view_attach'}</b></td> </tr>\n";
	print "<tr $self->{'cb'}> <td>\n";
	foreach $a (@{$self->{'attach_array'}}) {
		local $fn;
		$self->{'size'} = (int(length($a->{'data'})/1000)+1)." Kb";
		if ($a->{'type'} eq 'message/rfc822') {
			push(@{$self->{'titles_array'}}, "$self->{'text_hash'}->{'view_sub'}<br>$self->{'size'}");
			}
		elsif ($a->{'filename'}) {
			push(@{$self->{'titles_array'}}, $self->decode_mimewords($a->{'filename'}).
				      "<br>$self->{'size'}");
			$fn = $self->decode_mimewords($a->{'filename'});
			push(@{$self->{'detach_array'}}, [ $a->{'idx'}, $fn ]);
			}
		else {
			push(@{$self->{'titles_array'}}, "$a->{'type'}<br>$self->{'size'}");
			$a->{'type'} =~ /\/(\S+)$/;
			$fn = "file.$1";
			push(@{$self->{'detach_array'}}, [ $a->{'idx'}, $fn ]);
			}
		if ($a->{'error'}) {
			$self->{'titles_array'}->[$#{$self->{'titles_array'}}] .= "<br><font size=-1>($a->{'error'})</font>";
			}
		$fn =~ s/ /_/g;
		$fn =~ s/\#/_/g;
		$fn = $self->html_escape($fn);
		if ($a->{'type'} eq 'message/rfc822') {
			push(@{$self->{'links_array'}}, "view_mail.cgi?idx=$self->{'in_hash'}->{'idx'}&mid=$self->{'qmid'}&folder=$self->{'in_hash'}->{'folder'}$self->{'subs'}&sub=$a->{'idx'}");
			}
		else {
			push(@{$self->{'links_array'}}, "detach.cgi/$fn?idx=$self->{'in_hash'}->{'idx'}&mid=$self->{'qmid'}&folder=$self->{'in_hash'}->{'folder'}&attach=$a->{'idx'}$self->{'subs'}");
			}
		if ($self->{'userconfig_hash'}->{'thumbnails'} &&
		    ($a->{'type'} =~ /image\/gif/i && $self->has_command("giftopnm")&&
		     $self->has_command("pnmscale") && $self->has_command("cjpeg") ||
		     $a->{'type'} =~ /image\/jpeg/i && $self->has_command("djpeg") &&
		     $self->has_command("pnmscale") && $self->has_command("cjpeg"))) {
			# Can show an image icon
			push(@{$self->{'icons_array'}}, "detach.cgi?scale=1&idx=$self->{'in_hash'}->{'idx'}&folder=$self->{'in_hash'}->{'folder'}&attach=$a->{'idx'}$self->{'subs'}");
			$self->{'imgicons'}++;
			}
		else {
			push(@{$self->{'icons_array'}}, "images/boxes.gif");
			}
		}
	$self->icons_table(\@{$self->{'links_array'}}, \@{$self->{'titles_array'}}, \@{$self->{'icons_array'}}, 6, undef,
		     $self->{'imgicons'} ? ( 0, 0 ) : ( ));
	if ($self->{'config_hash'}->{'server_attach'} == 2 && @{$self->{'detach_array'}}) {
		print "<input type=submit name=detach value='$self->{'text_hash'}->{'view_detach'}'>\n";
		print "<input type=hidden name=bindex value='$self->{'body'}->{'idx'}'>\n" if ($self->{'body'});
		print "<input type=hidden name=sindex value='$self->{'sindex'}'>\n" if (defined($self->{'sindex'}));
		print "<select name=attach>\n";
		print "<option value=*>$self->{'text_hash'}->{'view_dall'}\n";
		foreach $a (@{$self->{'detach_array'}}) {
			printf "<option value=%s>%s\n",
				$a->[0], $a->[1];
			}
		print "</select>\n";
		print "<b>$self->{'text_hash'}->{'view_dir'}</b>\n";
		print "<input name=dir size=40> ",
			$self->file_chooser_button("dir", 1),"\n";
		}
	print "</td></tr></table><p>\n";
	}

# Display GnuPG results
if (defined($self->{'sigcode'})) {
	print "<table border width=100%>\n";
	print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'view_gnupg'}</b></td> </tr>\n";
	print "<tr $self->{'cb'}> <td>";
	$self->{'sigmessage'} = $self->html_escape($self->{'sigmessage'});
	$self->{'sigmessage'} = $self->{'sigmessage'} if ($self->{'sigcode'} == 4);
	print $self->text('view_gnupg_'.$self->{'sigcode'}, $self->{'sigmessage'}),"\n";
	if ($self->{'sigcode'} == 3) {
		local $url = "/$self->{'module_name'}/view_mail.cgi?idx=$self->{'in_hash'}->{'idx'}&mid=$self->{'qmid'}&folder=$self->{'in_hash'}->{'folder'}$self->{'subs'}";
		print "<p>",$self->text('view_recv', $self->{'sigmessage'}, "/gnupg/recv.cgi?id=$self->{'sigmessage'}&return=".$self->urlize($url)."&returnmsg=".$self->urlize($self->{'text_hash'}->{'view_return'})),"\n";
		}
	print "</td> </tr></table><p>\n";
	}
if ($self->{'deccode'}) {
	print "<table border width=100%>\n";
	print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'view_crypt'}</b></td> </tr>\n";
	print "<tr $self->{'cb'}> <td>";
	print $self->text('view_crypt_'.$self->{'deccode'}, "<pre>$self->{'decmessage'}</pre>");
	print "</td> </tr></table><p>\n";
	}

# Display DSN status
if ($self->{'sent_dsn_to'} || $self->{'send_dsn_button'} || $self->{'got_dsn'} || @{$self->{'delmsgs_array'}}) {
	print "<table border width=100%>\n";
	print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'view_dsn'}</b></td> </tr>\n";
	print "<tr $self->{'cb'}> <td>";
	if ($self->{'sent_dsn_to'}) {
		print $self->text($self->{'sent_dsn'} ? 'view_dnsnow' : 'view_dsnbefore',
			    $self->html_escape($self->{'sent_dsn_to'}),
			    ($self->{'dsntm'} = localtime($self->{'sent_dsn_at'})));
		}
	elsif ($self->{'send_dsn_button'}) {
		print $self->text('view_dsnreq', $self->html_escape($self->{'dsn_req'})),"<br>\n";
		print $self->ui_submit($self->{'text_hash'}->{'view_dsnsend'}, "dsn");
		}
	elsif ($self->{'got_dsn'}) {
		print $self->text('view_dsngot', $self->html_escape($self->{'got_dsn_from'}),
			    ($self->{'dsntm'} = localtime($self->{'got_dsn'}))),"<br>\n";
		}
	elsif (@{$self->{'delmsgs_array'}}) {
		print join("<br>\n", @{$self->{'delmsgs_array'}}),"<br>\n";
		}
	print "</td> </tr></table><p>\n";
	}

&show_buttons(2, scalar(@{$self->{'sub_array'}})) if ($self->editable_mail($self->{'mail'}));
if ($self->{'userconfig_hash'}->{'arrows'} == 2 && !@{$self->{'sub_array'}}) {
	print "<br>\n";
	&show_arrows();
	}
print "</form>\n";

dbmclose(%{$self->{'read_hash'}});

# Show footer links
$self->ui_print_footer($self->{'text_hash'}->{'index_mainpage_url'}, $self->{'text_hash'}->{'index_mainpage'});

$self->pop3_logout_all();

1;
		
}

# show_buttons(pos, submode)
sub show_buttons
{
	shift if ($self == $_[0]);

local $spacer = "&nbsp;\n";

if ($self->{'userconfig_hash'}->{'open_mode'}) {
	# Compose button needs to pop up a window
	print "<input type=submit name=new value=\"$self->{'text_hash'}->{'mail_compose'}\" ",
	      "onClick='window.open(\"reply_mail.cgi?new=1\", \"compose\", \"toolbar=no,menubar=no,scrollbars=yes,width=1024,height=768\"); return false'>";
	}
else {
	# Compose button can just submit and redirect
	print "<input type=submit name=new value=\"$self->{'text_hash'}->{'mail_compose'}\">";
	}
print $spacer;

if (!$_[1]) {
	if (!$self->{'folder'}->{'sent'} && !$self->{'folder'}->{'drafts'}) {
		$self->{'m'} = $self->{'read_hash'}->{$self->{'mail'}->{'header'}->{'message-id'}};
		print "<input name=mark$_[0] type=submit value=\"$self->{'text_hash'}->{'view_mark'}\">";
		print "<select name=mode$_[0]>\n";
		foreach $i (0 .. 2) {
			printf "<option value=%d %s>%s\n",
				$i, $self->{'m'} == $i ? 'selected' : '', $self->{'text_hash'}->{"view_mark$i"};
			}
		print "</select>";
		print $spacer;
		}
       }

print "<input type=submit value=\"$self->{'text_hash'}->{'view_delete'}\" name=delete ","onClick='return check_clicks(form)'>";
print $spacer;

if ($self->{'folder'}->{'sent'} || $self->{'folder'}->{'drafts'}) {
       print "<input type=submit value=\"$self->{'text_hash'}->{'view_enew'}\" name=enew>";
       }
else {
       print "<input type=submit value=\"$self->{'text_hash'}->{'view_reply'}\" name=reply>";
       }
print $spacer;

print "<input type=submit value=\"$self->{'text_hash'}->{'view_forward'}\" name=forward>";
print $spacer;

print "<input type=submit value=\"$self->{'text_hash'}->{'view_print'}\" name=print>";
print $spacer;

if (!$_[1]) {
       print "<hr>\n";		

	if (@{$self->{'folders_array'}} > 1) {
		print $self->movecopy_select($_[0], \@{$self->{'folders_array'}}, $self->{'folder'});
		print $spacer;
		}
	}
	
else {
	print "<hr>\n";
	if (@{$self->{'folders_array'}} > 1) {
		print $self->movecopy_select($_[0], \@{$self->{'folders_array'}}, $self->{'folder'}, 1);
		print $spacer;
		}
	}

if (!$_[1]) {
	# Show spam and/or ham report buttons
	if ($self->can_report_spam($self->{'folder'}) &&
	    $self->{'userconfig_hash'}->{'spam_buttons'} =~ /mail/) {
		print "<input type=submit value=\"$self->{'text_hash'}->{'view_black'}\" name=black>";
		if ($self->{'userconfig_hash'}->{'spam_del'}) {
			print "<input type=submit value=\"$self->{'text_hash'}->{'view_razordel'}\" name=razor>";
			}
		else {
			print "<input type=submit value=\"$self->{'text_hash'}->{'view_razor'}\" name=razor>";
			}
		print $spacer;
		}
	if ($self->can_report_ham($self->{'folder'}) &&
	    $self->{'userconfig_hash'}->{'ham_buttons'} =~ /mail/) {
		print "<input type=submit value=\"$self->{'text_hash'}->{'view_white'}\" name=white>";
		print "<input type=submit value=\"$self->{'text_hash'}->{'view_ham'}\" name=ham>";
		print $spacer;
		}
	}
print "<br>\n";
}

# address_link(address)
sub address_link
{
	shift if ($self == $_[0]);

## $self->split_addresses() pattern-matches "[<>]", so 7-bit encodings
## such as ISO-2022-JP must be converted to EUC before feeding.
local @addrs = $self->split_addresses($self->eucconv($self->decode_mimewords($_[0])));
local @rv;
foreach $a (@addrs) {
	## TODO: is $self->{'inbook_hash'}->{} MIME or locale-encoded?
	if ($self->{'inbook_hash'}->{$a->[0]}) {
		push(@rv, $self->eucconv_and_escape($a->[2]));
		}
	else {
		## name= will be EUC encoded now since $self->split_addresses()
		## is feeded with EUC converted value.
		push(@rv, "<a href='add_address.cgi?addr=".$self->urlize($a->[0]).
			  "&name=".$self->urlize($a->[1])."&idx=$self->{'in_hash'}->{'idx'}".
			  "&folder=$self->{'in_hash'}->{'folder'}$self->{'subs'}'>".
			  $self->eucconv_and_escape($a->[2])."</a>");
		}
	}
return join(" , ", @rv);
}

sub show_arrows
{
	shift if ($self == $_[0]);

print "<center>\n";
if (!@{$self->{'sub_array'}}) {
	# Get next and previous emails, where they exist
	local $c = scalar(@{$self->{'mail_array'}});
	local $prv = $self->{'mail'}->{'sortidx'} == 0 ? 0 : $self->{'mail'}->{'sortidx'}-1;
	local $nxt = $self->{'mail'}->{'sortidx'} == $c-1 ? $c-1 : $self->{'mail'}->{'sortidx'}+1;
	local @beside = $self->mailbox_list_mails_sorted($prv, $nxt, $self->{'folder'}, 1);

	if ($self->{'mail'}->{'sortidx'} != 0) {
		local $mailprv = $beside[$prv];
		print "<a href='view_mail.cgi?idx=",($self->{'mail'}->{'sortidx'}-1),
		      "&mid=",$self->urlize($mailprv->{'header'}->{'message-id'}),
		      "&folder=$self->{'in_hash'}->{'folder'}'>",
		      "<img src=../images/left.gif border=0 ",
		      "align=middle></a>\n";
		}
	else {
		print "<img src=../images/left-grey.gif align=middle>\n";
		}
	print "<font size=+1>",$self->text('view_desc', $self->{'mail'}->{'sortidx'}+1,
			$self->{'folder'}->{'name'}),"</font>\n";
	if ($self->{'mail'}->{'sortidx'} < $c-1) {
		local $mailnxt = $beside[$nxt];
		print "<a href='view_mail.cgi?idx=",($self->{'mail'}->{'sortidx'}+1),
		      "&mid=",$self->urlize($mailnxt->{'header'}->{'message-id'}),
		      "&folder=$self->{'in_hash'}->{'folder'}'>",
		      "<img src=../images/right.gif border=0 ",
		      "align=middle></a>\n";
		}
	else {
		print "<img src=../images/right-grey.gif align=middle>\n";
		}
	}
else {
	print "<font size=+1>$self->{'text_hash'}->{'view_sub'}</font>\n";
	}
print "</center>\n";
}

# search_link(field, what, text)
sub search_link
{
	shift if ($self == $_[0]);

local $fid;
if ($self->{'userconfig_hash'}->{'related_search'}) {
	# Search is across all folders
	$fid = -$self->{'userconfig_hash'}->{'related_search'};
	}
elsif (!$self->{'folder'}->{'searchable'}) {
	# Search is source folder
	if ($self->{'mail'}->{'subfolder'}) {
		$fid = $self->{'mail'}->{'subfolder'}->{'index'};
		}
	else {
		return undef;
		}
	}
else {
	# Search is in this folder
	$fid = $self->{'in_hash'}->{'folder'};
	}
if ($_[1]) {
	return "<a href='mail_search.cgi?field_0=".$self->urlize($_[0]).
	       "&what_0=".$self->urlize($_[1]).
	       "&folder=".$fid."'>$_[2]</a>";
	}
else {
	return undef;
	}
}


1;

