#!/usr/bin/perl
package man::ManLib;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'man::ManLib');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# man-lib.pl

&ModuleLoader::preload_module(ref($self), "WebLib");
$self = new WebLib:: ref($self), %$self; 
$self->init_config();
&ModuleLoader::preload_module(ref($self), "UiLib");
$self = new UiLib:: ref($self), %$self; 
$self->switch_to_remote_user();

$self->{'google_host'} = "www.google.com";
$self->{'google_port'} = 80;
$self->{'google_page'} = "/search";

# Get the paths to perl and perldoc
open(PERL, "$self->{'config_directory'}/perl-path");
chop($self->{'perl_path'} = <PERL>);
close(PERL);
if ($self->has_command("perldoc")) {
	$self->{'perl_doc'} = "perldoc";
	}
else {
	$self->{'perl_path'} =~ /^(.*)\/[^\/]+$/;
	if (-x "$1/perldoc") {
		$self->{'perl_doc'} = "$1/perldoc";
		}
	}
if ($self->{'perl_doc'} && $] >= 5.006) {
	$self->{'perl_doc'} = "$self->{'perl_doc'} -U";
	}

1;

1;
		return $self;
}

# set_manpath(extra)
sub set_manpath
{
	my $self = shift;

$ENV{'MANPATH'} = join(":", split(/:/, $self->{'config_hash'}->{'man_dir'}),
			    split(/:/, $_[0]));
}


1;

