#!/usr/bin/perl

&MAIN();

 sub MAIN {
# search.cgi
# Search for manual pages, and display a list of matches or an exact page

&ModuleLoader::preload_module('man_class', "man::ManLib");
$self = new man::ManLib:: 'man_class',%$self;

use Config;
$self->ReadParse();
$self->{'in_hash'}->{'for'} || $self->error($self->{'text_hash'}->{'search_efor'});

@{$self->{'for_array'}} = split(/\s+/, $self->{'in_hash'}->{'for'});
@{$self->{'howto_array'}} = split(/\s+/, $self->{'config_hash'}->{'howto_dir'});
@{$self->{'doc_array'}} = split(/\s+/, $self->{'config_hash'}->{'doc_dir'});
foreach $s (split(/\0/, $self->{'in_hash'}->{'section'})) {
	if ($s =~ /^([^:]+):(.*)/) {
		$self->{'section_hash'}->{$1}++;
		$self->{'opts_hash'}->{$1} = $2;
		}
	else {
		$self->{'section_hash'}->{$s}++;
		}
	}
if ($self->{'in_hash'}->{'check'} && $self->{'config_hash'}->{'check'}) {
	@{$self->{'check_array'}} = split(/\s+/, $self->{'config_hash'}->{'check'});
	foreach $s (keys %{$self->{'section_hash'}}) {
		delete($self->{'section_hash'}->{$s}) if ($self->indexof($s, @{$self->{'check_array'}}) < 0);
		}
	}

if ($self->{'section_hash'}->{'doc'}) {
	# Look in the system documentation directory (usually /usr/doc)
	foreach $d (@{$self->{'doc_array'}}) {
		push(@{$self->{'rv_array'}}, map { [ $self->{'text_hash'}->{'search_doc'},
				   "view_doc.cgi?file=".$self->urlize($_->[0]),
				   substr($_->[0], length($d)+1),
				   $_->[1], 1 ] }
			     &find_contents($d, \@{$self->{'for_array'}},
					    $self->{'howto_array'}->[0], 1, $self->{'in_hash'}->{'exact'}));
		}
	}
if ($self->{'section_hash'}->{'custom'}) {
	# Look in the custom documentation directory
	push(@{$self->{'rv_array'}}, map { [ $self->{'text_hash'}->{'search_custom'},
			   "view_doc.cgi?file=".$self->urlize($_->[0]),
			   substr($_->[0], length($self->{'config_hash'}->{'custom_dir'})+1),
			   $_->[1], 1 ] }
		     &find_contents($self->{'config_hash'}->{'custom_dir'}, \@{$self->{'for_array'}},
				    $self->{'howto_array'}->[0], 1, $self->{'in_hash'}->{'exact'}));
	}
if ($self->{'section_hash'}->{'howto'}) {
	# Look in the HOWTO directory
	foreach $h (@{$self->{'howto_array'}}) {
		push(@{$self->{'rv_array'}}, map { [ $self->{'text_hash'}->{'search_howto'},
			      "view_howto.cgi?file=".$self->urlize($_->[0]),
			      $_->[2], $_->[1], 2 ] }
		     &find_contents($h, \@{$self->{'for_array'}}, undef, 0, $self->{'in_hash'}->{'exact'}));
		}
	@{$self->{'rv_array'}} = grep { $_->[2] !~ /^index/i } @{$self->{'rv_array'}};
	}
if ($self->{'section_hash'}->{'kernel'}) {
	# Look in the linux kernel Documentation directory
	 push(@{$self->{'rv_array'}}, map { [ $self->{'text_hash'}->{'search_kernel'},
			   "view_kernel.cgi?file=".$self->urlize($_->[0]),
			   substr($_->[0], length($self->{'config_hash'}->{'kernel_dir'})+1),
			   $_->[1], 1 ] }
		     &find_contents($self->{'config_hash'}->{'kernel_dir'}, \@{$self->{'for_array'}},
				    undef, 1, $self->{'in_hash'}->{'exact'}));
	}
if ($self->{'section_hash'}->{'kde'}) {
	# Look in the KDE documentation directory
	 push(@{$self->{'rv_array'}}, map { [ $self->{'text_hash'}->{'search_kde'},
			   "view_kde.cgi?file=".$self->urlize($_->[0]),
			   substr($_->[0], length($self->{'config_hash'}->{'kde_dir'})+1),
			   $_->[1], 1 ] }
		     &find_contents($self->{'config_hash'}->{'kde_dir'}, \@{$self->{'for_array'}},
				    undef, 1, $self->{'in_hash'}->{'exact'}));
	}
if ($self->{'section_hash'}->{'perl'}) {
	if ($self->{'in_hash'}->{'exact'}) {
		# Check for an exact module name match
		local @f = $self->{'in_hash'}->{'and'} ? ( $self->{'for_array'}->[0] ) : @{$self->{'for_array'}};
		foreach $f (@f) {
			chop($self->{'out'} = $self->backquote_command("$self->{'perl_doc'} -l ".quotemeta($f)." 2>/dev/null", 1));
			if ($self->{'out'}) {
				local $doc = &parse_perl_module($self->{'out'});
				$doc->{'name'} =~ s/^\s*(\S+)\s+-\s+//;
				push(@{$self->{'rv_array'}}, [ $self->{'text_hash'}->{'search_perl'},
					    "view_perl.cgi?mod=$f",
					    $f, $doc->{'name'}, 1 ]);
				}
			}
		}
	else {
		# Search the text of all perl modules
		foreach $d ($Config{'sitelib'}, $Config{'privlib'}) {
			$self->open_execute_command(*FIND, "find $d -name '*.pm' -print", 1, 1);
			while($self->{'path'} = <FIND>) {
				chop($self->{'path'});
				local $doc = &parse_perl_module($self->{'path'});
				local ($any = 0, $all = 1);
				foreach $f (@{$self->{'for_array'}}) {
					if ($doc->{'name'} !~ /$f/i &&
					    $doc->{'description'} !~ /$f/i) {
						$all = 0;
						}
					else {
						$any = 1;
						}
					}
				next if (!$all && $self->{'in_hash'}->{'and'} || !$any);

				$doc->{'name'} =~ s/^\s*(\S+)\s+-\s+//;
				local $modfile =
				   $self->backquote_command("$self->{'perl_doc'} -l ".quotemeta($doc->{'package'})." 2>/dev/null", 1);
				if ($doc->{'package'} && $modfile) {
					push(@{$self->{'rv_array'}}, [ $self->{'text_hash'}->{'search_perl'},
					  "view_perl.cgi?mod=$doc->{'package'}",
					  $doc->{'package'}, $doc->{'name'},
					  1 ]);
					}
				}
			close(FIND);
			}
		}
	}
if ($self->{'section_hash'}->{'help'}) {
	# Look in the webmin module help pages
	opendir(DIR, $self->{'root_directory'});
	foreach my $m (readdir(DIR)) {
		# Is this a module with help
		local $dir = "$self->{'root_directory'}/$m/help";
		next if (!-d $dir || $m =~ /^\./ || -l "$self->{'root_directory'}/$m");
		local %minfo = $self->get_module_info($m);
		next if (!%minfo || !$self->check_os_support(\%minfo));

		# Check the help pages
		local @pfx;
		opendir(DIR2, $dir);
		while($f = readdir(DIR2)) {
			push(@pfx, $1) if ($f =~ /^([^\.]+)\.html$/);
			}
		closedir(DIR2);
		HELP: foreach $p ($self->unique(@pfx)) {
			local $file = $self->help_file($m, $p);
			open(HELP, $file);
			local @st = stat($file);
			read(HELP, $self->{'help'}, $st[7]);
			close(HELP);
			if ($self->{'help'} =~ /<header>([^<]+)<\/header>/) {
				$self->{'header'} = $1;
				}
			else { next; }
			$self->{'help'} =~ s/<include\s+(\S+)>/inchelp($1, $m)/ge;
			$self->{'help'} =~ s/<[^>]+>//g;
			local $matches = 0;
			if ($self->{'in_hash'}->{'exact'}) {
				# Just check header
				foreach $f (@{$self->{'for_array'}}) {
					$matches++ if ($self->{'header'} =~ /\Q$f\E/i);
					}
				}
			else {
				# Check entire body
				foreach $f (@{$self->{'for_array'}}) {
					$matches++ if ($self->{'help'} =~ /\Q$f\E/i);
					}
				}
			if (($self->{'in_hash'}->{'and'} && $matches == @{$self->{'for_array'}}) ||
			    (!$self->{'in_hash'}->{'and'} && $matches)) {
				push(@{$self->{'rv_array'}}, [ $self->{'text_hash'}->{'search_help'},
					    "/help.cgi/$m/$p?x=1",
					    "$m/$p", $self->{'header'},
					    2 ]);
				}
			}
		}
	}
if ($self->{'section_hash'}->{'man'}) {
	# Look in manual pages (searches are never exact)
	$self->{'cmd'} = $self->{'config_hash'}->{'search_cmd'};
	map { s/\\/\\\\/g; s/'/\\'/g; } @{$self->{'for_array'}};
	if ($self->{'in_hash'}->{'and'}) {
		local $qm = quotemeta($self->{'for_array'}->[0]);
		$self->{'cmd'} =~ s/PAGE/$qm/;
		}
	else {
		local $fors = join(" ", map { quotemeta($_) } @{$self->{'for_array'}});
		$self->{'cmd'} =~ s/PAGE/$fors/;
		}
	$self->set_manpath($self->{'opts_hash'}->{'man'});
	$self->open_execute_command(*MAN, $self->{'cmd'}, 1, 1);
	while(<MAN>) {
		$self->{'got'} .= $_;
		if (/(([^,\s]+).*)\s*\((\S+)\)\s+-\s+(.*)/ &&
		    !$self->{'done_hash'}->{$2,$3}++) {
			local ($page, $sect, $desc) = ($1, $3, $4);
			$page = $1 if ($page =~ /\[(.*)\]/);
			local @pp = split(/[\s+,]/, $page);
			map { s/\((\S+)\)//; } @pp;

			# Keywords must be page name or desc
			local ($any = 0, $all = 1, $exact);
			foreach $f (@{$self->{'for_array'}}) {
				if ($desc !~ /$f/i && $page !~ /$f/i &&
				    $self->indexof($f, @pp) < 0) {
					$all = 0;
					}
				else {
					$any = 1;
					}
				$exact++ if ($self->indexof($f, @pp) >= 0);
				}
			next if (!$all && $self->{'in_hash'}->{'and'} || !$any);

			push(@{$self->{'rv_array'}}, [ $self->{'text_hash'}->{'search_man'},
				    "view_man.cgi?page=$pp[0]&sec=$3&opts=".
				    $self->{'opts_hash'}->{'man'}, "$pp[0] ($sect)", $desc,
				    $exact ? 4 : 3 ]);
			}
		}
	close(MAN);
	}
if ($self->{'section_hash'}->{'google'}) {
	# Try to call the Google search engine
	local ($grv, $error);
	local $j = $self->{'in_hash'}->{'and'} ? ' and ' : ' or ';
	$self->http_download($self->{'google_host'}, $self->{'google_port'}, "$self->{'google_page'}?q=".
		       $self->urlize(join($j, @{$self->{'for_array'}}))."&sourceid=webmin&num=20",
		       \$grv, \$error);
	if (!$error) {
		# Parse the results
		while($grv =~ /(<p[^>]*>|<div[^>]*>)<a[^>]+href=([^>]+)>([\000-\377]+?)<\/a>([\000-\377]*)$/i) {
			$grv = $4;
			local ($url = $2, $desc = $3);
			$url =~ s/^"(.*)".*$/$1/;
			$url =~ s/^'(.*)'.*$/$1/;
			$desc =~ s/<\/?b>//g;
			local $matches = 0;
			foreach $f (@{$self->{'for_array'}}) {
				$matches++ if ($desc =~ /\Q$f\E/i);
				}
			if (!$self->{'in_hash'}->{'exact'} ||
			    ($self->{'in_hash'}->{'and'} && $matches == @{$self->{'for_array'}}) ||
			    (!$self->{'in_hash'}->{'and'} && $matches)) {
				push(@{$self->{'rv_array'}}, [ $self->{'text_hash'}->{'search_google'}, $url, length($url) > 60 ? substr($url, 0, 60)."..." : $url, $desc, 0.5 ]);
				}
			}
		}
	}

if (@{$self->{'rv_array'}} == 1 && !$self->{'in_hash'}->{'check'}) {
	# redirect to the exact page
	$self->redirect($self->{'in_hash'}->{'exact'} ? $self->{'rv_array'}->[0]->[1]
			       : "$self->{'rv_array'}->[0]->[1]&for=".$self->urlize($self->{'in_hash'}->{'for'}));
	exit;
	}

# Display search results
$self->{'for'} = join($self->{'in_hash'}->{'and'} ? " and " : " or ", map { "<tt>$_</tt>" } @{$self->{'for_array'}});
$self->ui_print_header($self->text('search_for', $self->{'for'}), $self->{'text_hash'}->{'search_title'}, "");
if (@{$self->{'rv_array'}}) {
	#@{$self->{'rv_array'}} = sort { $b->[4] <=> $a->[4] } @{$self->{'rv_array'}};
	@{$self->{'rv_array'}} = sort { &ranking($b) <=> &ranking($a) } @{$self->{'rv_array'}};
	print $self->ui_columns_start([ $self->{'text_hash'}->{'search_file'},
				  $self->{'text_hash'}->{'search_type'},
				  $self->{'text_hash'}->{'search_desc'} ], 100);
	foreach $r (@{$self->{'rv_array'}}) {
		local @cols;
		if ($r->[1] =~ /^(http|ftp|https):/) {
			push(@cols, "<a href='$r->[1]'>".
				    $self->html_escape($r->[2])."</a>");
			}
		else {
			push(@cols, "<a href='$r->[1]&for=".$self->urlize($self->{'in_hash'}->{'for'}).
				    "'>".$self->html_escape($r->[2])."</a>");
			}
		push(@cols, $r->[0]);
		push(@cols, $self->html_escape($r->[3]));
		print $self->ui_columns_row(\@cols, [ undef, "nowrap", undef ]);
		}
	print $self->ui_columns_end();
	}
else {
	print "<p><b>",$self->text('search_none', "<tt>$self->{'in_hash'}->{'for'}</tt>"),"</b><p>\n";
	}

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}

# find_contents(directory, &strings, [exclude], [descend], [nameonly])
# Find some string in a directory of files
sub find_contents
{
	shift if ($self == $_[0]);

opendir(DIR, $_[0]);
local @f = readdir(DIR);
closedir(DIR);
local @rv;
foreach $f (@f) {
	next if ($f =~ /^\./);
	local $p = "$_[0]/$f";
	next if ($p eq $_[2]);
	if (-d $p) {
		# go into subdirectory
		push(@rv, &find_contents($p, $_[1], $_[2], $_[3], $_[4]))
			if ($_[3]);
		}
	else {
		# Skip non-text or HTML files
		local $ff = $f;
		$ff =~ s/\.(gz|bz|bz2)$//i;
		next if ($ff !~ /\.(txt|htm|html|doc)$/ &&
			 $ff =~ /\.[A-Za-z0-9]+$/);
		next if ($ff =~ /(^makefile$)|(^core$)/i);

		local $matches = 0;
		foreach $s (@{$_[1]}) {
			$matches++ if ($p =~ /\Q$s\E/i);
			}
		if ($_[4]) {
			# just compare filename
			if ($self->{'in_hash'}->{'and'} && $matches == @{$_[1]} ||
			    !$self->{'in_hash'}->{'and'} && $matches) {
				local ($desc, $data) = &read_doc_file($p);
				if ($desc !~ /^#!/ && $desc !~ /^#\%/) {
					push(@rv, [ $p, $desc, $f, $matches ]);
					}
				}
			}
		else {
			# compare file contents
			local ($desc, $data) = &read_doc_file($p);
			local $dmatches = 0;
			foreach $s (@{$_[1]}) {
				$dmatches++ if ($data =~ /\Q$s\E/i);
				}
			if (($self->{'in_hash'}->{'and'} && $dmatches == @{$_[1]} ||
			     !$self->{'in_hash'}->{'and'} && $dmatches) &&
			    $desc !~ /^#!/ && $desc !~ /^#\%/) {
				push(@rv, [ $p, $desc, $f, $matches ]);
				}
			}
		}
	}
return @rv;
}

# read_doc_file(filename)
# Returns desc, data
sub read_doc_file
{
	shift if ($self == $_[0]);

local ($two, $first, $title, $data);
open(FILE, $_[0]);
read(FILE, $two, 2);
local $qm = quotemeta($_[0]);
if ($two eq "\037\213") {
	close(FILE);
	$self->open_execute_command(*FILE, "gunzip -c $qm", 1, 1);
	}
elsif ($two eq "BZ") {
	close(FILE);
	$self->open_execute_command(*FILE, "bunzip2 -c $qm", 1, 1);
	}
seek(FILE, 0, 0);
while(<FILE>) {
	$data .= $_;
	if (/[A-Za-z0-9]/ && !/\$\S+:/ && !$first) {
		chop($first = $_);
		$first =~ s/.\010//g;
		}
	}
close(FILE);
if ($data =~ /<\s*title\s*>([\000-\177]{0,200})<\s*\/\s*title\s*>/i) {
	$title = $1;
	}
return ($title ? $title : $first =~ /<.*>/ ? undef : $first, $data);
}

# parse_perl_module(file)
sub parse_perl_module
{
	shift if ($self == $_[0]);

local (%doc, $inside);
open(MOD, $_[0]);
while(<MOD>) {
	if (/^\s*package\s+(\S+)\s*;/ && !$doc{'package'}) {
		$doc{'package'} = $1;
		}
	elsif (/^=head1\s+(\S+)/i) {
		$inside = $1;
		}
	elsif (/^=cut/i) {
		undef($inside);
		}
	elsif ($inside) {
		$doc{lc($inside)} .= $_;
		}
	}
close(MOD);
return \%doc;
}

# inchelp(path, module)
sub inchelp
{
	shift if ($self == $_[0]);

local $inc;
local $ipath = $self->help_file($_[1], $_[0]);
open(INC, $ipath) || return "<i>".$self->text('search_einclude', $_[0])."</i><br>\n";
local @st = stat(INC);
read(INC, $inc, $st[7]);
close(INC);
return $inc;
}

sub ranking
{
	shift if ($self == $_[0]);

local ($name = 0, $desc = 0);
foreach $f (@{$self->{'for_array'}}) {
	$desc++ if ($_[0]->[3] =~ /$f/i);
	$name++ if ($_[0]->[1] =~ /$f/i);
	}
return $name ? $_[0]->[4] * 10 :
       $desc ? $_[0]->[4] :
	       $_[0]->[4] / 10;
}


1;

