#!/usr/bin/perl

&MAIN();

 sub MAIN {
# view_man.cgi
# Display a single manual page

&ModuleLoader::preload_module('man_class', "man::ManLib");
$self = new man::ManLib:: 'man_class',%$self;

$self->ReadParse();
$self->ui_print_header(undef, $self->{'text_hash'}->{'man_title'}, "");

if ($self->has_command($self->{'config_hash'}->{'man2html_path'})) {
	$self->{'ocmd'} = $self->{'in_hash'}->{'sec'} ? $self->{'config_hash'}->{'list_cmd_sect'}
			   : $self->{'config_hash'}->{'list_cmd'};
	}
else {
	$self->{'ocmd'} = $self->{'in_hash'}->{'sec'} ? $self->{'config_hash'}->{'man_cmd_sect'}
			   : $self->{'config_hash'}->{'man_cmd'};
	}
if ($self->{'config_hash'}->{'strip_letters'}) {
	$self->{'in_hash'}->{'sec'} =~ s/^(\d+).*$/$1/;
	}
$self->set_manpath($self->{'in_hash'}->{'opts'});
foreach $page ($self->{'in_hash'}->{'page'}, lc($self->{'in_hash'}->{'page'})) {
	$self->{'qpage'} = quotemeta($page);
	$self->{'qsec'} = quotemeta($self->{'in_hash'}->{'sec'});
	$self->{'cmd'} = $self->{'ocmd'};
	$self->{'cmd'} =~ s/PAGE/$self->{'qpage'}/;
	$self->{'cmd'} =~ s/SECTION/$self->{'qsec'}/;
	$self->{'out'} = $self->backquote_command("$self->{'cmd'} 2>&1", 1);
	if ($self->{'out'} !~ /^.*no manual entry/i && $self->{'out'} !~ /^.*no entry/i &&
	    $self->{'out'} !~ /^.*nothing appropriate/i) {
		# Found it
		$self->{'found'}++;
		last;
		}
	}
if (!$self->{'found'}) {
	print "<p><b>",$self->text('man_noentry', "<tt>$self->{'in_hash'}->{'page'}</tt>"),
	      "</b><p>\n";
	}
else {
	if ($self->has_command($self->{'config_hash'}->{'man2html_path'})) {
		$self->{'out'} =~ s/ .*//;
		$self->{'out'} =~ s/\n//;
		if( $self->{'out'} =~ /^.*\.gz/i ) {
			$self->{'cmd'} = "gunzip -c";
			}
		elsif ($self->{'out'} =~ /^.*\.(bz2|bz)/i) {
			$self->{'cmd'} = "bunzip2 -c";
			}
		else {
			$self->{'cmd'} = "cat";
			}
		$self->{'qout'} = quotemeta($self->{'out'});
		$self->{'manout'} = $self->backquote_command("$self->{'config_hash'}->{'man2html_path'} -v 2>&1", 1);
		if ($self->{'manout'} =~ /Version:\s+([0-9\.]+)/i && $1 >= 3) {
			# New version uses a different syntax!
			$self->{'cmd'} .= " $self->{'qout'} | nroff -mman | $self->{'config_hash'}->{'man2html_path'} --cgiurl \"view_man.cgi?page=\\\${title}&sec=\\\${section}&opts=$self->{'in_hash'}->{'opts'}\" --bare";
			$self->{'out'} = $self->backquote_command("$self->{'cmd'} 2>&1", 1);
			}
		else {
			# Old version of man2html
			$self->{'cmd'} .= " $self->{'qout'} | $self->{'config_hash'}->{'man2html_path'} -H \"\" -M \"view_man.cgi\"";
			$self->{'out'} = $self->backquote_command("$self->{'cmd'} 2>&1", 1);
			$self->{'out'} =~ s/^.*Content-type:.*\n//i;
			$self->{'out'} =~ s/http:\/\///ig;
			$self->{'out'} =~ s/\?/\?sec=/ig;
			$self->{'out'} =~ s/\+/&opts=$self->{'in_hash'}->{'opts'}&page=/ig;
			$self->{'out'} =~ s/<HTML>.*<BODY>//isg;
			$self->{'out'} =~ s/<\/HTML>//ig;
			$self->{'out'} =~ s/<\/BODY>//ig;
			$self->{'out'} =~ s/<A HREF="file:[^"]+">([^<]+)<\/a>/$1/ig;
			$self->{'out'} =~ s/<A HREF="view_man.cgi">/<A HREF=\"\">/i;
			}
		print "<table border width=100%>\n";
		print "<tr $self->{'tb'}> <td><b>",$self->text('man_header', $self->{'in_hash'}->{'page'},
					       $self->{'in_hash'}->{'sec'}),"</b></td> </tr>\n";
		print "<tr $self->{'cb'}> <td>",$self->{'out'},"</td> </tr>\n";
		print "</table>\n";
	} else {
		$self->{'out'} =~ s/.\010//g;
		$self->{'out'} =~ s/^(man:\s*)?(re)?formatting.*//i;
		$self->{'out'} =~ s/&/&amp;/g;
		$self->{'out'} =~ s/</&lt;/g;
		$self->{'out'} =~ s/>/&gt;/g;
		print "<table border width=100%>\n";
		print "<tr $self->{'tb'}> <td><b>",$self->text('man_header', $self->{'in_hash'}->{'page'},
					       $self->{'in_hash'}->{'sec'}),"</b></td> </tr>\n";
		print "<tr $self->{'cb'}> <td><pre>",$self->{'out'},"</pre></td> </tr>\n";
		print "</table><p>\n";
		}
	}

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

