#!/usr/bin/perl

&MAIN();

 sub MAIN {
# backup_db.cgi
# Do the actual backup

&ModuleLoader::preload_module('mysql_class', "mysql::MysqlLib");
$self = new mysql::MysqlLib:: 'mysql_class',%$self;

$self->ReadParse();
if ($self->{'in_hash'}->{'all'}) {
	@{$self->{'alldbs_array'}} = $self->list_databases();
	@{$self->{'dbs_array'}} = grep { $self->can_edit_db($_) } @{$self->{'alldbs_array'}};
	@{$self->{'alldbs_array'}} == @{$self->{'dbs_array'}} || $self->error($self->{'text_hash'}->{'dbase_ecannot'});
	}
else {
	$self->can_edit_db($self->{'in_hash'}->{'db'}) || $self->error($self->{'text_hash'}->{'dbase_ecannot'});
	}
$self->{'access_hash'}->{'edonly'} && $self->error($self->{'text_hash'}->{'dbase_ecannot'});
$self->{'access_hash'}->{'buser'} || $self->error($self->{'text_hash'}->{'dbase_ecannot'});
$self->error_setup($self->{'text_hash'}->{'backup_err'});

if (!$self->{'in_hash'}->{'save'} || $self->{'in_hash'}->{'sched'}) {
	if ($self->{'in_hash'}->{'all'}) {
		-d $self->{'in_hash'}->{'file'} || -d $self->date_subs($self->{'in_hash'}->{'file'}) ||
			$self->error($self->{'text_hash'}->{'backup_efile2'});
		}
	else {
		$self->{'in_hash'}->{'file'} =~ /^\/\S+$/ || $self->error($self->{'text_hash'}->{'backup_efile'});
		}
	$self->{'in_hash'}->{'where_def'} || $self->{'in_hash'}->{'where'} || $self->error($self->{'text_hash'}->{'backup_ewhere'});
	$self->{'in_hash'}->{'charset_def'} || $self->{'in_hash'}->{'charset'} =~ /^\S+$/ ||
		$self->error($self->{'text_hash'}->{'backup_echarset'});
	$self->{'ccmd'} = $self->{'in_hash'}->{'compress'} == 1 ? "gzip" :
		$self->{'in_hash'}->{'compress'} == 2 ? "bzip2" : undef;
	!$self->{'ccmd'} || $self->has_command($self->{'ccmd'}) ||
		$self->error($self->text('backup_eccmd', "<tt>$self->{'ccmd'}</tt>"));
	if (!$self->is_under_directory($self->{'access_hash'}->{'bpath'}, $self->{'in_hash'}->{'file'})) {
		$self->error($self->{'text_hash'}->{'backup_epath'}."<br>".
		       $self->text('backup_eunder', "<tt>$self->{'access_hash'}->{'bpath'}</tt>"));
		}
	if (!$self->{'in_hash'}->{'all'} && !$self->{'in_hash'}->{'tables_def'}) {
		@{$self->{'tables_array'}} = split(/\0/, $self->{'in_hash'}->{'tables'});
		@{$self->{'tables_array'}} || $self->error($self->{'text_hash'}->{'backup_etables'});
		}
	}
@{$self->{'compat_array'}} = $self->{'in_hash'}->{'compatible_def'} ? ( ) : ( $self->{'in_hash'}->{'compatible'} );
push(@{$self->{'compat_array'}}, split(/\0/, $self->{'in_hash'}->{'options'}));
$self->{'cron'} = !$self->{'module_info_hash'}->{'usermin'} && $self->{'access_hash'}->{'buser'} eq 'root' &&
	!$self->{'access_hash'}->{'user'} && $self->foreign_installed("cron");
$self->{'cmode'} = 0;
if ($self->{'cron'}) {
	$self->{'config_hash'}->{'backup_before_'.$self->{'in_hash'}->{'db'}} = $self->{'in_hash'}->{'before'};
	$self->{'config_hash'}->{'backup_after_'.$self->{'in_hash'}->{'db'}} = $self->{'in_hash'}->{'after'};
	if ($self->{'in_hash'}->{'all'}) {
		$self->{'config_hash'}->{'backup_cmode_'.$self->{'in_hash'}->{'db'}} = $self->{'in_hash'}->{'cmode'};
		$self->{'cmode'} = $self->{'in_hash'}->{'cmode'};
		}

	$self->foreign_require("cron", "cron-lib.pl");
	@{$self->{'jobs_array'}} = $main::cron_object->list_cron_jobs();
	$self->{'cmd'} = $self->{'in_hash'}->{'all'} ? "$self->{'cron_cmd'} --all" : "$self->{'cron_cmd'} $self->{'in_hash'}->{'db'}";
	($self->{'job'}) = grep { $_->{'command'} eq $self->{'cmd'} } @{$self->{'jobs_array'}};
	$self->{'oldjob'} = $self->{'job'};
	$self->{'job'} ||= { 'command' => $self->{'cmd'},
		   'user' => 'root',
		   'active' => 1 };
	$main::cron_object->parse_times_input($self->{'job'}, \%{$self->{'in_hash'}});
	}

# Save choices for next time the form is visited (and for the cron job)
if ($self->{'module_info_hash'}->{'usermin'}) {
	$self->{'userconfig_hash'}->{'backup_'.$self->{'in_hash'}->{'db'}} = $self->{'in_hash'}->{'file'};
	$self->{'userconfig_hash'}->{'backup_where_'.$self->{'in_hash'}->{'db'}} =
		$self->{'in_hash'}->{'where_def'} ? undef : $self->{'in_hash'}->{'where'};
	$self->{'userconfig_hash'}->{'backup_charset_'.$self->{'in_hash'}->{'db'}} =
		$self->{'in_hash'}->{'charset_def'} ? undef : $self->{'in_hash'}->{'charset'};
	$self->{'userconfig_hash'}->{'backup_compatible_'.$self->{'in_hash'}->{'db'}} =
		$self->{'in_hash'}->{'compatible_def'} ? undef : $self->{'in_hash'}->{'compatible'};
	$self->{'userconfig_hash'}->{'backup_options_'.$self->{'in_hash'}->{'db'}} =
		join(" ", split(/\0/, $self->{'in_hash'}->{'options'}));
	$self->{'userconfig_hash'}->{'backup_compress_'.$self->{'in_hash'}->{'db'}} = $self->{'in_hash'}->{'compress'};
	$self->{'userconfig_hash'}->{'backup_drop_'.$self->{'in_hash'}->{'db'}} = $self->{'in_hash'}->{'drop'};
	$self->{'userconfig_hash'}->{'backup_tables_'.$self->{'in_hash'}->{'db'}} = join(" ", @{$self->{'tables_array'}});
	$self->write_file("$self->{'user_module_config_directory'}/config", \%{$self->{'userconfig_hash'}});
	}
else {
	$self->{'config_hash'}->{'backup_'.$self->{'in_hash'}->{'db'}} = $self->{'in_hash'}->{'file'};
	$self->{'config_hash'}->{'backup_where_'.$self->{'in_hash'}->{'db'}} =
		$self->{'in_hash'}->{'where_def'} ? undef : $self->{'in_hash'}->{'where'};
	$self->{'config_hash'}->{'backup_charset_'.$self->{'in_hash'}->{'db'}} =
		$self->{'in_hash'}->{'charset_def'} ? undef : $self->{'in_hash'}->{'charset'};
	$self->{'config_hash'}->{'backup_compatible_'.$self->{'in_hash'}->{'db'}} =
		$self->{'in_hash'}->{'compatible_def'} ? undef : $self->{'in_hash'}->{'compatible'};
	$self->{'config_hash'}->{'backup_options_'.$self->{'in_hash'}->{'db'}} =
		join(" ", split(/\0/, $self->{'in_hash'}->{'options'}));
	$self->{'config_hash'}->{'backup_compress_'.$self->{'in_hash'}->{'db'}} = $self->{'in_hash'}->{'compress'};
	$self->{'config_hash'}->{'backup_drop_'.$self->{'in_hash'}->{'db'}} = $self->{'in_hash'}->{'drop'};
	$self->{'config_hash'}->{'backup_tables_'.$self->{'in_hash'}->{'db'}} = join(" ", @{$self->{'tables_array'}});
	$self->write_file("$self->{'module_config_directory'}/config", \%{$self->{'config_hash'}});
	}

$self->ui_print_header(undef, $self->{'text_hash'}->{'backup_title'}, "");
if (!$self->{'in_hash'}->{'save'}) {
	# Actually execute the backup now
	@{$self->{'dbs_array'}} = $self->{'in_hash'}->{'all'} ? @{$self->{'alldbs_array'}} : ( $self->{'in_hash'}->{'db'} );
	if ($self->{'cmode'} == 1) {
		# Run and check before-backup command (for all DBs)
		$self->{'bok'} = $self->execute_before(undef, STDOUT, 1, $self->{'in_hash'}->{'file'}, undef);
		if (!$self->{'bok'}) {
			print "$self->{'whatfailed'} : ",$self->{'text_hash'}->{'backup_ebefore'},"<p>\n";
			goto donebackup;
			}
		}
	foreach $db (@{$self->{'dbs_array'}}) {
		if ($self->{'in_hash'}->{'all'}) {
			$self->{'file'} = $self->date_subs("$self->{'in_hash'}->{'file'}/$db.sql").
				($self->{'in_hash'}->{'compress'} == 1 ? ".gz" :
				 $self->{'in_hash'}->{'compress'} == 2 ? ".bz2" : "");
			}
		else {
			$self->{'file'} = $self->date_subs($self->{'in_hash'}->{'file'});
			}
		if ($self->{'cron'} && $self->{'cmode'} == 0) {
			# Run and check before-backup command (for one DB)
			$self->{'bok'} = $self->execute_before($db, STDOUT, 1, $self->{'file'}, $self->{'in_hash'}->{'all'} ? undef : $db);
			if (!$self->{'bok'}) {
				print "$self->{'whatfailed'} : ",$self->{'text_hash'}->{'backup_ebefore'},"<p>\n";
				next;
				}
			}
		unlink($self->{'file'});
		if ($self->{'in_hash'}->{'compress'} == 0) {
			$self->{'writer'} = ">$self->{'file'}";
			}
		elsif ($self->{'in_hash'}->{'compress'} == 1) {
			$self->{'writer'} = "| gzip -c >$self->{'file'}";
			}
		elsif ($self->{'in_hash'}->{'compress'} == 2) {
			$self->{'writer'} = "| bzip2 -c >$self->{'file'}";
			}
		local $err = $self->backup_database($db, $self->{'file'}, $self->{'in_hash'}->{'compress'},
			$self->{'in_hash'}->{'drop'}, $self->{'in_hash'}->{'where_def'} ? undef : $self->{'in_hash'}->{'where'},
			$self->{'in_hash'}->{'charset_def'} ? undef : $self->{'in_hash'}->{'charset'},
			\@{$self->{'compat_array'}}, \@{$self->{'tables_array'}}, $self->{'access_hash'}->{'buser'});
		if ($err) {
			print "$self->{'whatfailed'} : ",
			      $self->text('backup_ebackup',"<pre>$err</pre>"),"<p>\n";
			}
		else {
			@{$self->{'st_array'}} = stat($self->{'file'});
			print $self->text('backup_done', "<tt>$db</tt>",
				    "<tt>$self->{'file'}</tt>", int($self->{'st_array'}->[7])),"<p>\n";
			}
		$self->execute_after($db, STDOUT, 1, $self->{'file'}, $self->{'in_hash'}->{'all'} ? undef : $db)
			if ($self->{'cron'} && $self->{'cmode'} == 0);
		}
	$self->execute_after(undef, STDOUT, 1, $self->{'in_hash'}->{'file'}, undef) if ($self->{'cmode'} == 1);
	donebackup:
	}

if ($self->{'cron'}) {
	$self->lock_file($self->{'cron_cmd'});
	$main::cron_object->create_wrapper($self->{'cron_cmd'}, $self->{'module_name'}, "backup.pl");
	$self->unlock_file($self->{'cron_cmd'});

	$self->lock_file($main::cron_object->cron_file($self->{'job'}));
	if ($self->{'in_hash'}->{'sched'} && !$self->{'oldjob'}) {
		$main::cron_object->create_cron_job($self->{'job'});
		$self->{'what'} = "backup_ccron";
		}
	elsif (!$self->{'in_hash'}->{'sched'} && $self->{'oldjob'}) {
		# Need to delete cron job
		$main::cron_object->delete_cron_job($self->{'job'});
		$self->{'what'} = "backup_dcron";
		}
	elsif ($self->{'in_hash'}->{'sched'} && $self->{'oldjob'}) {
		# Need to update cron job
		$main::cron_object->change_cron_job($self->{'job'});
		$self->{'what'} = "backup_ucron";
		}
        else {
                $self->{'what'} = "backup_ncron";
                }
	$self->unlock_file($main::cron_object->cron_file($self->{'job'}));

	# Tell the user what was done
	print $self->{'text_hash'}->{$self->{'what'}},"<p>\n" if ($self->{'what'});
	}

$self->webmin_log("backup", undef, $self->{'in_hash'}->{'all'} ? "" : $self->{'in_hash'}->{'db'}, \%{$self->{'in_hash'}});
if ($self->{'in_hash'}->{'all'}) {
	$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
	}
else {
	$self->ui_print_footer("edit_dbase.cgi?db=$self->{'in_hash'}->{'db'}", $self->{'text_hash'}->{'dbase_return'},
		"", $self->{'text_hash'}->{'index_return'});
	}

1;
		
}


1;

