#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_field.cgi
# Display a form for editing an existing field or creating a new one

&ModuleLoader::preload_module('mysql_class', "mysql::MysqlLib");
$self = new mysql::MysqlLib:: 'mysql_class',%$self;

$self->ReadParse();
$self->can_edit_db($self->{'in_hash'}->{'db'}) || $self->error($self->{'text_hash'}->{'dbase_ecannot'});
$self->{'access_hash'}->{'edonly'} && $self->error($self->{'text_hash'}->{'dbase_ecannot'});
$desc = $self->text('field_in', "<tt>$self->{'in_hash'}->{'table'}</tt>", "<tt>$self->{'in_hash'}->{'db'}</tt>");
if ($self->{'in_hash'}->{'type'}) {
	# Creating a new field
	$self->ui_print_header($desc, $self->{'text_hash'}->{'field_title1'}, "", "create_field");
	$self->{'type'} = $self->{'in_hash'}->{'type'};
	}
else {
	# Editing an existing field
	$self->ui_print_header($desc, $self->{'text_hash'}->{'field_title2'}, "", "edit_field");
	@{$self->{'desc_array'}} = $self->table_structure($self->{'in_hash'}->{'db'}, $self->{'in_hash'}->{'table'});
	$self->{'f'} = $self->{'desc_array'}->[$self->{'in_hash'}->{'idx'}];
	$self->{'type'} = $self->{'f'}->{'type'};
	}

print "<form action=save_field.cgi>\n";
print "<input type=hidden name=db value='$self->{'in_hash'}->{'db'}'>\n";
print "<input type=hidden name=table value='$self->{'in_hash'}->{'table'}'>\n";
print "<input type=hidden name=new value='$self->{'in_hash'}->{'type'}'>\n";
print "<table border>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'field_header'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'field_name'}</b></td>\n";
print "<td><input name=field size=20 value='$self->{'f'}->{'field'}'></td> </tr>\n";
print "<input type=hidden name=old value='$self->{'f'}->{'field'}'>\n" if (!$self->{'in_hash'}->{'type'});

if ($self->{'type'} =~ /^(\S+)\((.*)\)(.*)/) {
	$self->{'type'} = $1;
	$self->{'size'} = $2;
	$self->{'extra'} = $3;
	}
print "<input type=hidden name=type value='$self->{'type'}'>\n";
print "<tr> <td><b>$self->{'text_hash'}->{'field_type'}</b></td>\n";
if ($self->{'in_hash'}->{'type'}) {
	# New field .. just show chosen type
	print "<td>$self->{'type'}</td> </tr>\n";
	}
else {
	# Existing field .. allow type change
	print "<td><select name=newtype>\n";
	foreach $t (@{$self->{'type_list_array'}}) {
		printf "<option %s>%s\n",
			$t eq $self->{'type'} ? "selected" : "", $t;
		}
	print "</select> $self->{'text_hash'}->{'field_typewarn'}</td> </tr>\n";
	}

if ($self->{'type'} eq 'enum' || $self->{'type'} eq 'set') {
	# List of values
	local @ev = $self->split_enum($self->{'size'});
	print "<tr> <td valign=top><b>$self->{'text_hash'}->{'field_enum'}</b></td>\n";
	print "<td><textarea name=size rows=4 cols=20>",
		join("\n", @ev),"</textarea></td> </tr>\n";
	}
elsif ($self->{'type'} eq 'float' || $self->{'type'} eq 'double' || $self->{'type'} eq 'decimal') {
	# Two values
	print "<tr> <td><b>$self->{'text_hash'}->{'field_dual'}</b></td>\n";
	printf "<td><input name=size1 size=5 value='%s'>\n",
		$self->{'size'} =~ /^(\d+)/ ? $1 : '';
	printf "<input name=size2 size=5 value='%s'></td> </tr>\n",
		$self->{'size'} =~ /(\d+)$/ ? $1 : '';
	}
elsif ($self->{'type'} eq 'date' || $self->{'type'} eq 'datetime' || $self->{'type'} eq 'time' ||
       $self->{'type'} =~ /(blob|text)$/) {
	# No width!
	}
elsif ($self->{'type'} ne 'varchar' && $self->{'type'} ne 'char' && $self->{'in_hash'}->{'type'}) {
	# Size is optional for new fields of most types
	print "<tr> <td><b>$self->{'text_hash'}->{'field_size'}</b></td>\n";
	print "<td><input type=radio name=size_def value=1 checked> ",
	      "$self->{'text_hash'}->{'default'}\n";
	print "<input type=radio name=size_def value=0>\n";
	print "<input name=size size=10 value='$self->{'size'}'></td> </tr>\n";
	}
else {
	# One single value
	print "<tr> <td><b>$self->{'text_hash'}->{'field_size'}</b></td>\n";
	print "<td><input name=size size=10 value='$self->{'size'}'></td> </tr>\n";
	}

if ($self->{'type'} =~ /int$/) {
	# Display unsigned/zerofill option
	print "<tr> <td><b>$self->{'text_hash'}->{'field_opts'}</b></td>\n";
	printf "<td><input name=opts type=radio value='' %s> %s\n",
		$self->{'extra'} =~ /unsigned/ ? '' : 'checked',
		$self->{'text_hash'}->{'field_none'};
	printf "<input name=opts type=radio value=unsigned %s> %s\n",
		$self->{'extra'} =~ /unsigned/ && $self->{'extra'} !~ /zerofill/ ? 'checked' : '',
		$self->{'text_hash'}->{'field_unsigned'};
	printf "<input name=opts type=radio value=zerofill %s> %s</td> </tr>\n",
		$self->{'extra'} =~ /zerofill/ ? 'checked' : '',
		$self->{'text_hash'}->{'field_zerofill'};

	# Display auto-increment option
	print "<tr> <td><b>$self->{'text_hash'}->{'field_auto'}</b></td>\n";
	printf "<td><input name=ext type=radio value=%s %s> %s\n",
		'auto_increment',
		$self->{'f'}->{'extra'} =~ /auto_increment/ ? 'checked' : '',
		$self->{'text_hash'}->{'yes'};
	printf "<input name=ext type=radio value='' %s> %s</td></tr>\n",
		$self->{'f'}->{'extra'} =~ /auto_increment/ ? '' : 'checked',
		$self->{'text_hash'}->{'no'};
	}
elsif ($self->{'type'} eq 'float' || $self->{'type'} eq 'double' || $self->{'type'} eq 'decimal') {
	# Display zerofill option
	print "<tr> <td><b>$self->{'text_hash'}->{'field_opts'}</b></td>\n";
	printf "<td><input name=opts type=radio value='' %s> %s\n",
		$self->{'extra'} =~ /unsigned/ ? '' : 'checked',
		$self->{'text_hash'}->{'field_none'};
	printf "<input name=opts type=radio value=zerofill %s> %s</td> </tr>\n",
		$self->{'extra'} =~ /zerofill/ ? 'checked' : '',
		$self->{'text_hash'}->{'field_zerofill'};
	}
elsif ($self->{'type'} eq 'char' || $self->{'type'} eq 'varchar') {
	# Display binary option
	print "<tr> <td><b>$self->{'text_hash'}->{'field_opts'}</b></td>\n";
	printf "<td><input name=opts type=radio value='' %s> %s\n",
		$self->{'extra'} =~ /binary/ ? '' : 'checked',
		$self->{'text_hash'}->{'field_ascii'};
	printf "<input name=opts type=radio value=binary %s> %s</td> </tr>\n",
		$self->{'extra'} =~ /binary/ ? 'checked' : '',
		$self->{'text_hash'}->{'field_binary'};
	}

print "<tr> <td><b>$self->{'text_hash'}->{'field_null'}</b></td>\n";
printf "<td><input name=null type=radio value=1 %s> $self->{'text_hash'}->{'yes'}\n",
	$self->{'in_hash'}->{'type'} || $self->{'f'}->{'null'} eq 'YES' ? 'checked' : '';
printf "<input name=null type=radio value=0 %s> $self->{'text_hash'}->{'no'}</td> </tr>\n",
	$self->{'in_hash'}->{'type'} || $self->{'f'}->{'null'} eq 'YES' ? '' : 'checked';

print "<tr> <td><b>$self->{'text_hash'}->{'field_default'}</b></td>\n";
printf "<td><input name=default size=20 value='%s'></td> </tr>\n",
	$self->{'f'}->{'default'} eq 'NULL' ? '' : $self->{'f'}->{'default'};

print "<tr> <td><b>$self->{'text_hash'}->{'field_key'}</b></td>\n";
printf "<td><input type=radio name=key value=1 %s> %s\n",
	$self->{'f'}->{'key'} eq 'PRI' ? 'checked' : '', $self->{'text_hash'}->{'yes'};
printf "<input type=radio name=key value=0 %s> %s</td> </tr>\n",
	$self->{'f'}->{'key'} eq 'PRI' ? '' : 'checked', $self->{'text_hash'}->{'no'};
printf "<input type=hidden name=oldkey value='%d'>\n",
	$self->{'f'}->{'key'} eq 'PRI' ? 1 : 0;

print "</table></td></tr></table>\n";
if ($self->{'in_hash'}->{'type'}) {
	print "<input type=submit value='$self->{'text_hash'}->{'create'}'>\n";
	}
else {
	print "<input type=submit value='$self->{'text_hash'}->{'save'}'>&nbsp;\n";
	print "<input type=submit name=delete value='$self->{'text_hash'}->{'delete'}'>\n"
		if (@{$self->{'desc_array'}} > 1);
	}
print "</form>\n";

$self->ui_print_footer("edit_table.cgi?db=$self->{'in_hash'}->{'db'}&table=".$self->urlize($self->{'in_hash'}->{'table'}),
		 $self->{'text_hash'}->{'table_return'},
		 "edit_dbase.cgi?db=$self->{'in_hash'}->{'db'}", $self->{'text_hash'}->{'dbase_return'},
		 "", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

