#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Show a form for creating or editing index on a table

&ModuleLoader::preload_module('mysql_class', "mysql::MysqlLib");
$self = new mysql::MysqlLib:: 'mysql_class',%$self;

$self->ReadParse();
$self->can_edit_db($self->{'in_hash'}->{'db'}) || $self->error($self->{'text_hash'}->{'dbase_ecannot'});
$self->{'access_hash'}->{'edonly'} && $self->error($self->{'text_hash'}->{'dbase_ecannot'});
$self->{'access_hash'}->{'indexes'} || $self->error($self->{'text_hash'}->{'index_ecannot'});

if ($self->{'in_hash'}->{'index'}) {
	# Editing an index
	$self->{'str'} = $self->index_structure($self->{'in_hash'}->{'db'}, $self->{'in_hash'}->{'index'});
	$self->{'table'} = $self->{'str'}->{'table'};
	}
else {
	# Creating an index
	$self->{'table'} = $self->{'in_hash'}->{'table'};
	}
$self->{'desc'} = $self->text('table_header', "<tt>$self->{'table'}</tt>", "<tt>$self->{'in_hash'}->{'db'}</tt>");
$self->ui_print_header($self->{'desc'}, $self->{'in_hash'}->{'index'} ? $self->{'text_hash'}->{'index_title2'}
				     : $self->{'text_hash'}->{'index_title1'}, "");

print $self->ui_form_start("save_index.cgi", "post");
print $self->ui_hidden("db", $self->{'in_hash'}->{'db'}),"\n";
print $self->ui_hidden("table", $self->{'table'}),"\n";
print $self->ui_hidden("old", $self->{'in_hash'}->{'index'}),"\n";
print $self->ui_table_start($self->{'text_hash'}->{'index_header1'}, undef, 2);

# Index name
print $self->ui_table_row($self->{'text_hash'}->{'index_name'},
		    $self->ui_textbox("name", $self->{'str'}->{'name'}, 20));

# Fields in index
@{$self->{'str_array'}} = $self->table_structure($self->{'in_hash'}->{'db'}, $self->{'table'});
@{$self->{'cols_array'}} = map { $_->{'field'} } @{$self->{'str_array'}};
print $self->ui_table_row($self->{'text_hash'}->{'index_fields'},
   $self->ui_select("cols", $self->{'str'}->{'cols'},
      [ map { [ $_->{'field'},
		"$_->{'field'} - $_->{'type'}" ] } @{$self->{'str_array'}} ], 5, 1));

# Index type
print $self->ui_table_row($self->{'text_hash'}->{'index_type'},
		    $self->ui_select("type", $self->{'str'}->{'type'},
			[ !$self->{'in_hash'}->{'index'} ? ( [ "", "&lt;$self->{'text_hash'}->{'default'}&gt;" ] )
					: ( ),
			  [ "unique", $self->{'text_hash'}->{'index_unique'} ],
			  [ "fulltext", $self->{'text_hash'}->{'index_fulltext'} ],
			  [ "spatial", $self->{'text_hash'}->{'index_spatial'} ] ]));

print $self->ui_table_end();
if ($self->{'in_hash'}->{'index'}) {
	print $self->ui_form_end([ [ "save", $self->{'text_hash'}->{'save'} ],
			     [ "delete", $self->{'text_hash'}->{'delete'} ] ]);
	}
else {
	print $self->ui_form_end([ [ "create", $self->{'text_hash'}->{'create'} ] ]);
	}

$self->ui_print_footer("edit_dbase.cgi?db=$self->{'in_hash'}->{'db'}", $self->{'text_hash'}->{'dbase_return'},
	"", $self->{'text_hash'}->{'index_return'});
1;
		
}


1;

