#!/usr/bin/perl

&MAIN();

 sub MAIN {
# index.cgi
# Display all existing databases

&ModuleLoader::preload_module('mysql_class', "mysql::MysqlLib");
$self = new mysql::MysqlLib:: 'mysql_class',%$self;


# Check for MySQL programs
if (!-x $self->{'config_hash'}->{'mysqladmin'}) {
	&main_header();
	print $self->text('index_eadmin',
			  "<tt>$self->{'config_hash'}->{'mysqladmin'}</tt>"),"<p>\n";
	$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});
	exit;
	}
if (!-x $self->{'config_hash'}->{'mysql'}) {
	&main_header();
	print $self->text('index_esql',
			  "<tt>$self->{'config_hash'}->{'mysql'}</tt>"),"<p>\n";
	$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});
	exit;
	}
$self->{'out'} = `$self->{'config_hash'}->{'mysql'} -V 2>&1`;
if ($self->{'out'} =~ /lib\S+\.so/) {
	&main_header();
	print $self->text('index_elibrary',
			  "<tt>$self->{'config_hash'}->{'mysql'}</tt>"),"<p>\n";
	$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});
	exit;
	}
elsif ($self->{'out'} !~ /distrib\s+((3|4|5)\.[0-9\.]*)/i) {
	&main_header();
	print $self->text('index_ever', "<tt>$self->{'config_hash'}->{'mysql'}</tt>"),"<p>\n";
	print $self->text('index_mysqlver', "$self->{'config_hash'}->{'mysql'} -V"),"\n";
	print "<pre>$self->{'out'}</pre>\n";
	$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});
	exit;
	}
$self->{'mysql_version'} = $1;
open(VERSION, ">$self->{'user_module_config_directory'}/version");
print VERSION $self->{'mysql_version'},"\n";
close(VERSION);

if (!$self->{'userconfig_hash'}->{'login'} && $self->{'config_hash'}->{'useident'} ne "yes") {
	# User has not set his password yet
	$self->{'needpass'} = 1;
	}
else {
	$self->{'r'} = $self->is_mysql_running();
	if ($self->{'r'} == 0) {
		# Not running
		&main_header();
		print "<p> <b>$self->{'text_hash'}->{'index_notrun'}</b> <p>\n";
		}
	elsif ($self->{'r'} == -1) {
		# Running, but wrong password
		$self->{'needpass'} = 1;
		}
	else {
		# Check if we can re-direct to a single DB's page
		@{$self->{'titles_array'}} = grep { $self->can_edit_db($_) } $self->list_databases();
		if (@{$self->{'titles_array'}} == 1) {
			# Only one DB, so go direct to it!
			$self->redirect("edit_dbase.cgi?db=$self->{'titles_array'}->[0]");
			exit;
			}
		
		# Running .. list databases
		$self->ui_print_header("", $self->{'text_hash'}->{'index_title'}, "", undef, 1);
		print $self->ui_subheading($self->{'text_hash'}->{'index_dbs'});
		@{$self->{'icons_array'}} = map { "images/db.gif" } @{$self->{'titles_array'}};
		@{$self->{'links_array'}} = map { "edit_dbase.cgi?db=$_" } @{$self->{'titles_array'}};
		if (!@{$self->{'titles_array'}}) {
			print "<b>$self->{'text_hash'}->{'index_nodbs'}</b> <p>\n";
			}
		elsif ($self->{'config_hash'}->{'style'}) {
			@{$self->{'tables_array'}} = map { @{$self->{'t_array'}} = $self->list_tables($_); scalar(@{$self->{'t_array'}}) }
				      @{$self->{'titles_array'}};
			@{$self->{'titles_array'}} = map { $self->html_escape($_) } @{$self->{'titles_array'}};
			$self->split_table([ $self->{'text_hash'}->{'index_db'}, $self->{'text_hash'}->{'index_tables'} ],
				     \@{$self->{'links_array'}}, \@{$self->{'titles_array'}}, \@{$self->{'tables_array'}}) if (@{$self->{'titles_array'}});
			}
		else {
			@{$self->{'titles_array'}} = map { $self->html_escape($_) } @{$self->{'titles_array'}};
			$self->icons_table(\@{$self->{'links_array'}}, \@{$self->{'titles_array'}}, \@{$self->{'icons_array'}});
			}

		# Check if the user can create databases
		#print "<a href=newdb_form.cgi>$self->{'text_hash'}->{'index_add'}</a> <p>\n";
		}
	}

if ($self->{'needpass'}) {
	# Need to ask for the password
	&main_header();
	print "<center>\n";
	print "<p> <b>$self->{'text_hash'}->{'index_nopass'}</b> <p>\n";
	print "<form action=login.cgi>\n";
	print "<table border>\n";
	print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'index_ltitle'}</b></td> </tr>\n";
	print "<tr $self->{'cb'}> <td><table cellpadding=2>\n";
	print "<tr> <td><b>$self->{'text_hash'}->{'index_login'}</b></td>\n";
	printf "<td><input name=login size=20 value='%s'></td> </tr>\n",
		$self->{'userconfig_hash'}->{'login'} ? $self->{'userconfig_hash'}->{'login'} : $self->{'remote_user'};
	print "<tr> <td><b>$self->{'text_hash'}->{'index_pass'}</b></td>\n";
	printf "<td><input name=pass size=20 type=password value='%s'></td>\n",
		$self->{'userconfig_hash'}->{'pass'};
	print "</tr> </table></td></tr></table>\n";
	print "<input type=submit value='$self->{'text_hash'}->{'save'}'>\n";
	print "<input type=reset value='$self->{'text_hash'}->{'index_clear'}'>\n";
	print "</center></form>\n";

	}

$self->ui_print_footer("$self->{'text_hash'}->{'index_mainpage_url'}", $self->{'text_hash'}->{'index_mainpage'});

1;
		
}

sub main_header
{
	shift if ($self == $_[0]);

$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", undef, 0, 1);
}


1;

