#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Create, re-create or delete an index

&ModuleLoader::preload_module('mysql_class', "mysql::MysqlLib");
$self = new mysql::MysqlLib:: 'mysql_class',%$self;

$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'index_err'});
$self->can_edit_db($self->{'in_hash'}->{'db'}) || $self->error($self->{'text_hash'}->{'dbase_ecannot'});
$self->{'access_hash'}->{'edonly'} && $self->error($self->{'text_hash'}->{'dbase_ecannot'});
$self->{'access_hash'}->{'indexes'} || $self->error($self->{'text_hash'}->{'index_ecannot'});

if ($self->{'in_hash'}->{'delete'}) {
	# Just drop the index
	$self->{'sql'} = "drop index ".$self->quotestr($self->{'in_hash'}->{'old'})." on ".
	 		     $self->quotestr($self->{'in_hash'}->{'table'});
	$self->execute_sql_logged($self->{'in_hash'}->{'db'}, $self->{'sql'});
	$self->webmin_log("delete", "index", $self->{'in_hash'}->{'old'}, \%{$self->{'in_hash'}});
	}
else {
	# Validate inputs
	$self->{'in_hash'}->{'name'} =~ /^\S+$/ || $self->error($self->{'text_hash'}->{'index_ename'});
	if (!$self->{'in_hash'}->{'old'} || $self->{'in_hash'}->{'old'} ne $self->{'in_hash'}->{'name'}) {
		@{$self->{'indexes_array'}} = $self->list_indexes($self->{'in_hash'}->{'db'});
		$self->indexof($self->{'in_hash'}->{'name'}, @{$self->{'indexes_array'}}) >= 0 &&
			$self->error($self->{'text_hash'}->{'index_eclash'});
		}
	@{$self->{'cols_array'}} = split(/\0/, $self->{'in_hash'}->{'cols'});
	@{$self->{'cols_array'}} || $self->error($self->{'text_hash'}->{'index_ecols'});

	# Do it
	if ($self->{'in_hash'}->{'old'}) {
		# Remove the old one first
		$self->{'sql'} = "drop index ".$self->quotestr($self->{'in_hash'}->{'old'})." on ".
				     $self->quotestr($self->{'in_hash'}->{'table'});
		$self->execute_sql_logged($self->{'in_hash'}->{'db'}, $self->{'sql'});
		}
	$self->{'sql'} = "create $self->{'in_hash'}->{'type'} index ".$self->quotestr($self->{'in_hash'}->{'name'})." on ".
	       $self->quotestr($self->{'in_hash'}->{'table'})." (".
	       join(", ", map { $self->quotestr($_) } @{$self->{'cols_array'}}).")";
	$self->execute_sql_logged($self->{'in_hash'}->{'db'}, $self->{'sql'});

	if ($self->{'in_hash'}->{'old'}) {
		$self->webmin_log("modify", "index", $self->{'in_hash'}->{'old'}, \%{$self->{'in_hash'}});
		}
	else {
		$self->webmin_log("create", "index", $self->{'in_hash'}->{'name'}, \%{$self->{'in_hash'}});
		}
	}
$self->redirect("edit_dbase.cgi?db=$self->{'in_hash'}->{'db'}");

1;
		
}


1;

