#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Create, modify or delete a view

&ModuleLoader::preload_module('mysql_class', "mysql::MysqlLib");
$self = new mysql::MysqlLib:: 'mysql_class',%$self;

$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'view_err'});
$self->can_edit_db($self->{'in_hash'}->{'db'}) || $self->error($self->{'text_hash'}->{'dbase_ecannot'});
$self->{'access_hash'}->{'edonly'} && $self->error($self->{'text_hash'}->{'dbase_ecannot'});
$self->{'access_hash'}->{'views'} || $self->error($self->{'text_hash'}->{'view_ecannot'});

if ($self->{'in_hash'}->{'delete'}) {
	# Just drop the view
	$self->{'sql'} = "drop view ".$self->quotestr($self->{'in_hash'}->{'old'});
	$self->execute_sql_logged($self->{'in_hash'}->{'db'}, $self->{'sql'});
	$self->webmin_log("delete", "view", $self->{'in_hash'}->{'old'}, \%{$self->{'in_hash'}});
	}
else {
	# Validate inputs
	if (!$self->{'in_hash'}->{'old'}) {
		$self->{'in_hash'}->{'name'} =~ /^\S+$/ || $self->error($self->{'text_hash'}->{'view_ename'});
		@{$self->{'views_array'}} = $self->list_views($self->{'in_hash'}->{'db'});
		$self->indexof($self->{'in_hash'}->{'name'}, @{$self->{'views_array'}}) >= 0 &&
			$self->error($self->{'text_hash'}->{'view_eclash'});
		@{$self->{'tables_array'}} = $self->list_tables($self->{'in_hash'}->{'db'});
		$self->indexof($self->{'in_hash'}->{'name'}, @{$self->{'tables_array'}}) >= 0 &&
			$self->error($self->{'text_hash'}->{'view_eclash2'});
		}
	$self->{'in_hash'}->{'query'} =~ /\S/ || $self->error($self->{'text_hash'}->{'view_equery'});
	$self->{'in_hash'}->{'query'} =~ s/\r|\n/ /g;
	$self->{'in_hash'}->{'definer_def'} || $self->{'in_hash'}->{'definer'} =~ /\S/ ||
		$self->error($self->{'text_hash'}->{'view_edefiner'});

	if ($self->{'in_hash'}->{'old'}) {
		# Alter the existing view
		$self->{'sql'} = "alter ".
		       "algorithm = $self->{'in_hash'}->{'algorithm'} ".
		       "definer = $self->{'in_hash'}->{'definer'} ".
		       "sql security $self->{'in_hash'}->{'security'} ".
		       "view ".$self->quotestr($self->{'in_hash'}->{'old'})." ".
		       "as $self->{'in_hash'}->{'query'} ".
		       ($self->{'in_hash'}->{'check'} ? "with $self->{'in_hash'}->{'check'} check option" : "");
		}
	else {
		# Create a new view
		$self->{'sql'} = "create ".
		       "algorithm = $self->{'in_hash'}->{'algorithm'} ".
		       ($self->{'in_hash'}->{'definer_def'} ? "" : "definer = $self->{'in_hash'}->{'definer'} ").
		       ($self->{'in_hash'}->{'security'} ? "sql security $self->{'in_hash'}->{'security'} " : "").
		       "view ".$self->quotestr($self->{'in_hash'}->{'name'})." ".
		       "as $self->{'in_hash'}->{'query'} ".
		       ($self->{'in_hash'}->{'check'} ? "with $self->{'in_hash'}->{'check'} check option" : "");
		}
	$self->execute_sql_logged($self->{'in_hash'}->{'db'}, $self->{'sql'});

	if ($self->{'in_hash'}->{'old'}) {
		$self->webmin_log("modify", "view", $self->{'in_hash'}->{'old'}, \%{$self->{'in_hash'}});
		}
	else {
		$self->webmin_log("create", "view", $self->{'in_hash'}->{'name'}, \%{$self->{'in_hash'}});
		}
	}
$self->redirect("edit_dbase.cgi?db=$self->{'in_hash'}->{'db'}");

1;
		
}


1;

