# newmods.pl
# Updates an acl file to include new modules. Called with the parameters
# <config directory> <module>+

for($i=1; $i<@ARGV; $i++) {
	$mod=$ARGV[$i];
	$mod=~s/_/-/;
	if (!(-d "$ARGV[0]/$ARGV[$i]" && -d "$ARGV[0]/$mod")) {
		push(@new, $ARGV[$i]);
		}
	if (!(-d "$ARGV[0]/$ARGV[$i]") && (-d "$ARGV[0]/$mod")) {
		push(@chg, $mod);
		}
	}

if (@new || @chg){
	$i=0;
	# Read in the existing file
	open(ACL, "$ARGV[0]/cpplus.acl");
	while (<ACL>)
	{
	 @temp=split (/\s+/,$_);
	 foreach $j (@temp)
	 {
	  foreach $k (@chg)
	  {
	   $j=~s/-/_/ if ($j eq $k);
	  }
	 }
	 $_=join (" ",@temp);
	 $_.="\n";
	 $acl[$i]=$_;
	 $i++;
	}
	#@acl = <ACL>;
	close(ACL);

	if (open(NEEDMODS, "$ARGV[0]/neededmodules")) {
		# add list of need modules
		while(<NEEDMODS>) {
			s/\r|\n//g;
			push(@need, $_);
			}
		close(NEEDMODS);
		
		for($i=0; $i<@acl; $i++) {
			foreach (@need){
				if ( $acl[$i] !~ m/$_/ ) {
					chop $acl[$i];
					$acl[$i].=" ".$_."\n";
					}
				}
			}
		}

	# Get the list of users to grant new modules to
	if (open(NEWMODS, "$ARGV[0]/newmodules")) {
		while(<NEWMODS>) {
			s/\r|\n//g;
			$users{$_}++ if (/\S/);
			}
		close(NEWMODS);
		$newmods++;
		}

	if ($newmods) {
		# Find the users to add to
		for($i=0; $i<@acl; $i++) {
			if ($acl[$i] =~ /^(\S+):/ && $users{$1}) {
				push(@pos, $i);
				}
			}
		}
	else {
		# Just use 'root' or 'admin' or the first user in the file
		$pos[0] = 0;
		for($i=0; $i<@acl; $i++) {
			if ($acl[$i] =~ /^(\S+):/ &&
			    ($1 eq 'root' || $1 eq 'admin')) {
				$pos[0] = $i;
				last;
				}
			}
		}

	# Update it with new modules
	foreach $pos (@pos) {
		$acl[$pos] =~ /^(\S+):\s*(.*)$/ || next;
		$name = $1; @list = split(/\s+/, $2);
		foreach $o (@list) { $old{$o}++; }
		foreach $n (@new) {
			push(@list, $n) if (!$old{$n});
			}
		$acl[$pos] = "$name: ".join(" ",@list)."\n";
		}

		
	# Write it out
	open(ACL, ">$ARGV[0]/cpplus.acl");
	print ACL @acl;
	close(ACL);
	}

