#!/usr/bin/perl
package postgresql::Useradmin_update;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'postgresql::Useradmin_update');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;

$self->{'use_global_login'} = 1;          # Always login as master user, not the mysql
                                # login of the current Webmin user
&ModuleLoader::preload_module(ref($self), "postgresql::PostgresqlLib");
$self = new postgresql::PostgresqlLib:: ref($self), %$self; 

1;

1;
		return $self;
}

# useradmin_create_user(&details)
# Create a new postgesql user if syncing is enabled
sub useradmin_create_user
{
	my $self = shift;

if ($self->{'config_hash'}->{'sync_create'}) {
	local $version = $self->get_postgresql_version();
	local $sql = "create user $_[0]->{'user'}";
	if ($_[0]->{'passmode'} == 3) {
		$sql .= " with password '$_[0]->{'plainpass'}'";
		}
	$sql .= " nocreatedb nocreateuser";
	$self->execute_sql_logged($self->{'config_hash'}->{'basedb'}, $sql);
	}
}

# useradmin_delete_user(&details)
# Delete a mysql user
sub useradmin_delete_user
{
	my $self = shift;

if ($self->{'config_hash'}->{'sync_delete'}) {
	local $s = $self->execute_sql($self->{'config_hash'}->{'basedb'},
		"select * from pg_shadow where usename = '$_[0]->{'user'}'");
	return if (!@{$s->{'data'}});
	$self->execute_sql_logged($self->{'config_hash'}->{'basedb'}, "drop user $_[0]->{'user'}");
	}
}

# useradmin_modify_user(&details)
# Update a mysql user
sub useradmin_modify_user
{
	my $self = shift;

if ($self->{'config_hash'}->{'sync_modify'}) {
	local $s = $self->execute_sql($self->{'config_hash'}->{'basedb'},
		"select * from pg_shadow where usename = '$_[0]->{'olduser'}'");
	return if (!@{$s->{'data'}});
	local $version = $self->get_postgresql_version();
	if ($_[0]->{'user'} ne $_[0]->{'olduser'}) {
		# Need to delete and re-create to rename :(
		local @user = @{$s->{'data'}->[0]};
		$self->execute_sql_logged($self->{'config_hash'}->{'basedb'},
				    "drop user $_[0]->{'olduser'}");
		local $sql = "create user $_[0]->{'user'}";
		if ($_[0]->{'passmode'} == 3) {
			$sql .= " with password '$_[0]->{'plainpass'}'";
			}
		elsif ($_[0]->{'passmode'} == 4) {
			$sql .= " with password '$user[6]'";
			}
		$self->execute_sql_logged($self->{'config_hash'}->{'basedb'}, $sql);
		}
	elsif ($_[0]->{'passmode'} != 4) {
		# Just change password
		local $sql = "alter user $_[0]->{'user'}";
		if ($_[0]->{'passmode'} == 3) {
			$sql .= " with password '$_[0]->{'plainpass'}'";
			}
		$self->execute_sql_logged($self->{'config_hash'}->{'basedb'}, $sql);
		}
	}
}


1;

