#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Show a form for exporting CSV data

&ModuleLoader::preload_module('postgresql_class', "postgresql::PostgresqlLib");
$self = new postgresql::PostgresqlLib:: 'postgresql_class',%$self;

$self->ReadParse();
$self->can_edit_db($self->{'in_hash'}->{'db'}) || $self->error($self->{'text_hash'}->{'dbase_ecannot'});
$self->{'access_hash'}->{'edonly'} && $self->error($self->{'text_hash'}->{'dbase_ecannot'});

$self->{'desc'} = $self->text('table_header', "<tt>$self->{'in_hash'}->{'table'}</tt>", "<tt>$self->{'in_hash'}->{'db'}</tt>");
$self->ui_print_header($self->{'desc'}, $self->{'text_hash'}->{'csv_title'}, "", "csv");

print $self->ui_form_start("csv.cgi/$self->{'in_hash'}->{'table'}.csv", "post");
print $self->ui_hidden("db", $self->{'in_hash'}->{'db'}),"\n";
print $self->ui_hidden("table", $self->{'in_hash'}->{'table'}),"\n";
print $self->ui_table_start($self->{'text_hash'}->{'csv_header'}, undef, 2);

print $self->ui_table_row($self->{'text_hash'}->{'csv_format'},
		    $self->ui_radio("format", 0, [ [ 0, $self->{'text_hash'}->{'csv_format0'} ],
					     [ 1, $self->{'text_hash'}->{'csv_format1'} ],
					     [ 2, $self->{'text_hash'}->{'csv_format2'} ] ]));

print $self->ui_table_row($self->{'text_hash'}->{'csv_headers'},
		    $self->ui_yesno_radio("headers", 0));

if ($self->{'access_hash'}->{'backup'}) {
	# Only allow saving to file if a backup user is configured
	print $self->ui_table_row($self->{'text_hash'}->{'csv_dest'},
		    $self->ui_radio("dest", 0, [ [ 0, $self->{'text_hash'}->{'csv_browser'}."<br>" ],
					   [ 1, $self->{'text_hash'}->{'csv_file'} ] ])."\n".
		    $self->ui_textbox("file", undef, 40)." ".
		    $self->file_chooser_button("file"));
	}

print $self->ui_table_row($self->{'text_hash'}->{'csv_where'},
		    $self->ui_opt_textbox("where", undef, 30, $self->{'text_hash'}->{'csv_all'}));

# Columns to select
@{$self->{'str_array'}} = $self->table_structure($self->{'in_hash'}->{'db'}, $self->{'in_hash'}->{'table'});
@{$self->{'cols_array'}} = map { $_->{'field'} } @{$self->{'str_array'}};
print $self->ui_table_row($self->{'text_hash'}->{'csv_cols'},
            $self->ui_select("cols", \@{$self->{'cols_array'}},
                       [ map { [ $_->{'field'}, "$_->{'field'} - $_->{'type'}" ] } @{$self->{'str_array'}} ], 5, 1));

print $self->ui_table_end();
print $self->ui_form_end([ [ "ok", $self->{'text_hash'}->{'csv_ok'} ] ]);

$self->ui_print_footer("edit_dbase.cgi?db=$self->{'in_hash'}->{'db'}", $self->{'text_hash'}->{'dbase_return'},
	"", $self->{'text_hash'}->{'index_return'});
1;
		
}


1;

