#!/usr/bin/perl

&MAIN();

 sub MAIN {
# drop_field.cgi
# Drop a field from some table

sub mytext($);

&ModuleLoader::preload_module('postgresql_class', "postgresql::PostgresqlLib");
$self = new postgresql::PostgresqlLib:: 'postgresql_class',%$self;

$self->ReadParse();
$self->can_edit_db($self->{'in_hash'}->{'db'}) || $self->error(mytext('dbase_ecannot'));

$desc = $self->text('table_header', "<tt>$self->{'in_hash'}->{'table'}</tt>", "<tt>$self->{'in_hash'}->{'db'}</tt>");
$self->ui_print_header($desc, mytext('fdrop_title'), "", "field_drop");

@{$self->{'desc_array'}} = $self->table_structure($self->{'in_hash'}->{'db'}, $self->{'in_hash'}->{'table'});

local $table_shuffle;
# If a field drop has been specified using this script
if ( $self->{'in_hash'}->{'dropfld'} && $self->{'in_hash'}->{'dropfldok'} ) {

	# Drop the field by copying the other fields through a temp table
	$self->error_setup(mytext('fdrop_err'));

	local $i;
	local $fld_list = "";

	if( @{$self->{'desc_array'}} > 1 ) {
		for($i=0; $i<scalar(@{$self->{'desc_array'}}); $i++) {
			local $r = $self->{'desc_array'}->[$i];
			if( $self->{'in_hash'}->{'dropfld'} ne $self->html_escape($r->{'field'}) ) {
				# Note PostgreSQL requires quotes for uppercase
				if( $fld_list eq "" ) {
					$fld_list = '"'.$r->{'field'}.'"';
				} else {
					$fld_list = $fld_list . ', "' .$r->{'field'}.'"';
				}
			}
		}
	}
	
	if( $fld_list ne "" ) {
		local $tmp_tbl = "webmin_tmp_table".$self->{'PROCESS_ID'};
		local $qt = $self->quote_table($self->{'in_hash'}->{'table'});
		$table_shuffle = join '',
			"LOCK TABLE $qt;",
			"CREATE TABLE $tmp_tbl AS SELECT $fld_list FROM $qt;",
			"DROP TABLE $qt;",
			"ALTER TABLE $tmp_tbl RENAME TO $qt;";
			
  		$self->execute_sql_logged($self->{'in_hash'}->{'db'}, $table_shuffle);

		$self->webmin_log("delete", "table+field", $self->{'in_hash'}->{'table'}."+".$self->{'in_hash'}->{'dropfld'}, \%{$self->{'in_hash'}});
	}

	@{$self->{'desc_array'}} = $self->table_structure($self->{'in_hash'}->{'db'}, $self->{'in_hash'}->{'table'});

}  # if a field drop has been specified

# Display field selection screen

$self->{'mid'} = int((@{$self->{'desc_array'}} / 2)+0.5);
print "<form action=drop_field.cgi>\n";
print "<input type=hidden name=db value='$self->{'in_hash'}->{'db'}'>\n";
print "<input type=hidden name=table value='$self->{'in_hash'}->{'table'}'>\n";
print "<table border=0 width=100%> <tr><td valign=top width=50%>\n";
&type_table(0, $self->{'mid'});
print "</td><td valign=top width=50%>\n";
&type_table($self->{'mid'}, scalar(@{$self->{'desc_array'}})) if (@{$self->{'desc_array'}} > 1);
print "</td></tr> </table>\n";

print "<table width=100%><tr>\n";

print "<td>\n";
print "<input type=checkbox name=dropfldok",
	" value=dropit>",
	$self->html_escape(mytext('fdrop_lose_data')),
	"</option>",
	"</td>\n";
print "<td align=right width=33%>\n";
print '<input type=submit name="drop_a_fld" value="',
	mytext('fdrop_perform').'"></td>'."\n";

print "</tr></table>\n";
print "</form>\n";

$self->ui_print_footer("edit_table.cgi?db=$self->{'in_hash'}->{'db'}&table=$self->{'in_hash'}->{'table'}",mytext('table_return'),
	"edit_dbase.cgi?db=$self->{'in_hash'}->{'db'}", mytext('dbase_return'),
	"", mytext('index_return'));

1;
		
}

sub type_table
{
	shift if ($self == $_[0]);

print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>".mytext('table_field')."</b></td> ",
      "<td><b>".mytext('table_type')."</b></td> ",
      "<td><b>".mytext('table_arr')."</b></td> ",
      "<td><b>".mytext('fdrop_header')."</b></td> </tr>\n";
local $i;
for($i=$_[0]; $i<$_[1]; $i++) {
	local $r = $self->{'desc_array'}->[$i];
	print "<tr $self->{'cb'}>\n";
	print "<td><a href='edit_field.cgi?db=$self->{'in_hash'}->{'db'}&table=$self->{'in_hash'}->{'table'}&",
	      "idx=$i'>",$self->html_escape($r->{'field'}),"</a></td>\n";
	print "<td>",$self->html_escape($r->{'type'}),"</td>\n";
	print "<td>",$r->{'arr'} eq 'YES' ? mytext('yes')
					  : mytext('no'),"</td>\n";
	print "<td>","<input type=radio name=dropfld value='",
		$self->html_escape($r->{'field'}),"' ></td>\n";
	print "</tr>\n";
	}
print "</table>\n";
}

sub mytext($)
{
	shift if ($self == $_[0]);

	my ($x) = @_;
	my $rv = $self->{'text_hash'}->{"$x"};
	if( ! $rv ) {
		$rv = "$x";	# if unknown text, use the label
	}
	return $rv;
}


1;

