#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_dbase.cgi
# Show database tables

&ModuleLoader::preload_module('postgresql_class', "postgresql::PostgresqlLib");
$self = new postgresql::PostgresqlLib:: 'postgresql_class',%$self;

$self->ReadParse();
$self->can_edit_db($self->{'in_hash'}->{'db'}) || $self->error($self->{'text_hash'}->{'dbase_ecannot'});
@{$self->{'titles_array'}} = grep { $self->can_edit_db($_) } $self->list_databases();
$self->{'desc'} = "<tt>$self->{'in_hash'}->{'db'}</tt>";
if (@{$self->{'titles_array'}} == 1 && $self->{'module_info_hash'}->{'usermin'}) {
	# Single-database mode
	$self->ui_print_header($self->{'desc'}, $self->{'text_hash'}->{'dbase_title'}, "", "edit_dbase", 1, 1);
	$self->{'single'} = 1;
	}
else {
	$self->ui_print_header($self->{'desc'}, $self->{'text_hash'}->{'dbase_title'}, "", "edit_dbase");
	}

# Is this database accepting connections?
if (!$self->accepting_connections($self->{'in_hash'}->{'db'})) {
	print "$self->{'text_hash'}->{'dbase_noconn'}<p>\n";
	$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
	exit;
	}

@{$self->{'titles_array'}} = $self->list_tables($self->{'in_hash'}->{'db'});
if ($self->supports_indexes() && $self->{'access_hash'}->{'indexes'}) {
	@{$self->{'indexes_array'}} = $self->list_indexes($self->{'in_hash'}->{'db'});
	}
if ($self->supports_views() && $self->{'access_hash'}->{'views'}) {
	@{$self->{'views_array'}} = $self->list_views($self->{'in_hash'}->{'db'});
	}
if ($self->supports_sequences() && $self->{'access_hash'}->{'seqs'}) {
	@{$self->{'seqs_array'}} = $self->list_sequences($self->{'in_hash'}->{'db'});
	}

if ($self->{'in_hash'}->{'search'}) {
	# Limit to those matching search
	@{$self->{'titles_array'}} = grep { /\Q$self->{'in_hash'}->{'search'}\E/i } @{$self->{'titles_array'}};
	@{$self->{'indexes_array'}} = grep { /\Q$self->{'in_hash'}->{'search'}\E/i } @{$self->{'indexes_array'}};
	@{$self->{'views_array'}} = grep { /\Q$self->{'in_hash'}->{'search'}\E/i } @{$self->{'views_array'}};
	@{$self->{'seqs_array'}} = grep { /\Q$self->{'in_hash'}->{'search'}\E/i } @{$self->{'seqs_array'}};
	print "<table width=100%><tr>\n";
	print "<td> <b>",$self->text('dbase_showing',
		"<tt>$self->{'in_hash'}->{'search'}</tt>"),"</b></td>\n";
	print "<td align=right><a href='edit_dbase.cgi?db=$self->{'in_hash'}->{'db'}'>",
		"$self->{'text_hash'}->{'view_searchreset'}</a></td>\n";
	print "</tr></table>\n";
	}

if (@{$self->{'titles_array'}}+@{$self->{'indexes_array'}}+@{$self->{'views_array'}}+@{$self->{'seqs_array'}} > $self->{'max_dbs'} && !$self->{'in_hash'}->{'search'}) {
	# Too many tables to show .. display search and jump forms
	print $self->ui_form_start("edit_dbase.cgi");
	print $self->ui_hidden("db", $self->{'in_hash'}->{'db'}),"\n";
	print $self->{'text_hash'}->{'dbase_toomany'},"\n";
	print $self->ui_textbox("search", undef, 20),"\n";
	print $self->ui_submit($self->{'text_hash'}->{'index_search'}),"<br>\n";
	print $self->ui_form_end();

	print $self->ui_form_start("edit_table.cgi");
	print $self->{'text_hash'}->{'dbase_jump'},"\n";
	print $self->ui_hidden("db", $self->{'in_hash'}->{'db'}),"\n";
	print $self->ui_select("table", undef, [ map { [ $_ ] } @{$self->{'titles_array'}} ]),"\n";
	print $self->ui_submit($self->{'text_hash'}->{'index_jumpok'}),"<br>\n";
	print $self->ui_form_end();
	}
elsif (@{$self->{'titles_array'}} || @{$self->{'indexes_array'}} || @{$self->{'views_array'}} || @{$self->{'seqs_array'}}) {
	@{$self->{'icons_array'}} = ( ( map { "images/table.gif" } @{$self->{'titles_array'}} ),
		   ( map { "images/index.gif" } @{$self->{'indexes_array'}} ),
		   ( map { "images/view.gif" } @{$self->{'views_array'}} ),
		   ( map { "images/seq.gif" } @{$self->{'seqs_array'}} ),
		 );
	@{$self->{'links_array'}} = ( ( map { "edit_table.cgi?db=$self->{'in_hash'}->{'db'}&table=".$self->urlize($_) }
		     	 @{$self->{'titles_array'}} ),
		   ( map { "edit_index.cgi?db=$self->{'in_hash'}->{'db'}&index=".$self->urlize($_) }
                         @{$self->{'indexes_array'}} ),
		   ( map { "edit_view.cgi?db=$self->{'in_hash'}->{'db'}&view=".$self->urlize($_) }
                         @{$self->{'views_array'}} ),
		   ( map { "edit_seq.cgi?db=$self->{'in_hash'}->{'db'}&seq=".$self->urlize($_) }
                         @{$self->{'seqs_array'}} ),
		 );
	#&show_buttons();
	@{$self->{'rowlinks_array'}} = ( );
	if ($self->{'access_hash'}->{'tables'}) {
		print $self->ui_form_start("drop_tables.cgi");
		print $self->ui_hidden("db", $self->{'in_hash'}->{'db'});
		push(@{$self->{'rowlinks_array'}}, $self->select_all_link("d", $self->{'form'}),
				$self->select_invert_link("d", $self->{'form'}) );
		@{$self->{'checks_array'}} = ( ( @{$self->{'titles_array'}} ),
			    ( map { "!".$_ } @{$self->{'indexes_array'}} ),
			    ( map { "*".$_ } @{$self->{'views_array'}} ),
			    ( map { "/".$_ } @{$self->{'seqs_array'}} ),
			   );
		}
	print $self->ui_links_row(\@{$self->{'rowlinks_array'}});
	@{$self->{'dtitles_array'}} = map { $self->html_escape($_) } ( @{$self->{'titles_array'}}, @{$self->{'indexes_array'}}, @{$self->{'views_array'}},@{$self->{'seqs_array'}} );
	if ($self->{'config_hash'}->{'style'}) {
		# Show as table
		foreach $t (@{$self->{'titles_array'}}) {
			local $c = $self->execute_sql($self->{'in_hash'}->{'db'},
				"select count(*) from ".$self->quote_table($t));
			push(@{$self->{'rows_array'}}, $c->{'data'}->[0]->[0]);
			local @str = $self->table_structure($self->{'in_hash'}->{'db'}, $t);
			push(@{$self->{'fields_array'}}, scalar(@str));
			}
		foreach $t (@{$self->{'indexes_array'}}) {
			$self->{'str'} = $self->index_structure($self->{'in_hash'}->{'db'}, $t);
			push(@{$self->{'rows_array'}}, "<i>$self->{'text_hash'}->{'dbase_index'}</i>");
			push(@{$self->{'fields_array'}}, scalar(@{$self->{'str'}->{'cols'}}));
			}
		foreach $t (@{$self->{'views_array'}}) {
			push(@{$self->{'rows_array'}}, "<i>$self->{'text_hash'}->{'dbase_view'}</i>");
			push(@{$self->{'fields_array'}}, undef);
			}
		foreach $t (@{$self->{'seqs_array'}}) {
			$self->{'str'} = $self->sequence_structure($self->{'in_hash'}->{'db'}, $t);
			push(@{$self->{'rows_array'}}, "<i>$self->{'text_hash'}->{'dbase_seq'}</i>");
			push(@{$self->{'fields_array'}}, $self->{'str'}->{'last_value'});
			}
		$self->split_table([ "", $self->{'text_hash'}->{'dbase_table'}, $self->{'text_hash'}->{'dbase_rows'},
			       $self->{'text_hash'}->{'dbase_cols'} ],
			     \@{$self->{'checks_array'}}, \@{$self->{'links_array'}}, \@{$self->{'dtitles_array'}},
			     \@{$self->{'rows_array'}}, \@{$self->{'fields_array'}}) if (@{$self->{'titles_array'}});
		}
	else {
		# Show as icons
		@{$self->{'checks_array'}} = map { $self->ui_checkbox("d", $_) } @{$self->{'checks_array'}};
		$self->icons_table(\@{$self->{'links_array'}}, \@{$self->{'dtitles_array'}}, \@{$self->{'icons_array'}}, 5, undef, undef,undef,
			     @{$self->{'checks_array'}} ? \@{$self->{'checks_array'}} : undef);
		}
	print $self->ui_links_row(\@{$self->{'rowlinks_array'}});
	if ($self->{'access_hash'}->{'tables'}) {
		print $self->ui_form_end([ [ "delete", $self->{'text_hash'}->{'dbase_delete'} ] ]);
		}
	}
else {
	print "<b>$self->{'text_hash'}->{'dbase_none'}</b> <p>\n";
	}
&show_buttons();

if ($self->{'single'}) {
	$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});
	}
else {
	$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
	}

1;
		
}

sub show_buttons
{
	shift if ($self == $_[0]);

# Create table, view and sequence buttons
if ($self->{'access_hash'}->{'tables'}) {
	print "<table width=100%> <tr>\n";
	print "<form action=table_form.cgi>\n";
	print "<input type=hidden name=db value='$self->{'in_hash'}->{'db'}'>\n";
	print "<td width=33% nowrap><input type=submit value='$self->{'text_hash'}->{'dbase_add'}'>\n";
	print $self->{'text_hash'}->{'dbase_fields'},"\n";
	print "<input name=fields size=4 value='4'></td>\n";
	print "</form>\n";

	if ($self->supports_views() && $self->{'access_hash'}->{'views'}) {
		print "<form action=edit_view.cgi>\n";
		print "<input type=hidden name=db value='$self->{'in_hash'}->{'db'}'>\n";
		print "<input type=hidden name=new value=1>\n";
		print "<td width=33% nowrap align=center><input type=submit value='$self->{'text_hash'}->{'dbase_vadd'}'></td>\n";
		print "</form>\n";
		}

	if ($self->supports_sequences() && $self->{'access_hash'}->{'seqs'}) {
		print "<form action=edit_seq.cgi>\n";
		print "<input type=hidden name=db value='$self->{'in_hash'}->{'db'}'>\n";
		print "<input type=hidden name=new value=1>\n";
		print "<td width=33% nowrap align=right><input type=submit value='$self->{'text_hash'}->{'dbase_sadd'}'></td>\n";
		print "</form>\n";
		}

	print "</tr></table>\n";
	}
print "<table width=100%> <tr>\n";

# Drop database button
if ($self->{'access_hash'}->{'delete'}) {
	print "<form action=drop_dbase.cgi>\n";
	print "<input type=hidden name=db value='$self->{'in_hash'}->{'db'}'>\n";
	print "<td align=left valign=top width=20%><input type=submit ",
	      "value='$self->{'text_hash'}->{'dbase_drop'}'></td></form>\n";
	}
else {
	print "<td align=left valign=top width=20%></td>\n";
	}

# Backup and restore buttons
if ( $self->get_postgresql_version() >= 7.2 ) {
	if ($self->{'access_hash'}->{'backup'}) {
	    print "<form action=backup_form.cgi>\n" ;
	    print "<input type=hidden name=db value='$self->{'in_hash'}->{'db'}'>\n" ;
	    print "<td align=right valign=top width=20%><input type=submit " ,
		  "value='$self->{'text_hash'}->{'dbase_bkup'}'></td></form>\n"  ;
	}

	if ($self->{'access_hash'}->{'restore'}) {
	    print "<form action=restore_form.cgi>\n" ;
	    print "<input type=hidden name=db value='$self->{'in_hash'}->{'db'}'>\n" ;
	    print "<td align=left valign=top width=20%><input type=submit " ,
		  "value='$self->{'text_hash'}->{'dbase_rstr'}'></td></form>\n" ;
	}
}

print "<form action=exec_form.cgi>\n";
print "<input type=hidden name=db value='$self->{'in_hash'}->{'db'}'>\n";
print "<td align=right valign=top width=20%><input type=submit ",
      "value='$self->{'text_hash'}->{'dbase_exec'}'></td>\n";
print "</form>\n";
print "</tr> </table></form>\n";
}


1;

