#!/usr/bin/perl

&MAIN();

 sub MAIN {
# index.cgi
# Display all existing databases

&ModuleLoader::preload_module('postgresql_class', "postgresql::PostgresqlLib");
$self = new postgresql::PostgresqlLib:: 'postgresql_class',%$self;


# Check for PostgreSQL program
if (!-x $self->{'config_hash'}->{'psql'}) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", undef, 0, 1);
	print $self->text('index_esql', "<tt>$self->{'config_hash'}->{'psql'}</tt>"),"<p>\n";
	$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});
	exit;
	}

local $needpass;
if (!$self->{'userconfig_hash'}->{'login'}) {
 # User has not set his password yet
 $needpass = 1; 
 }
else {	
$self->{'r'} = $self->is_postgresql_running();
 if ($self->{'r'} == 0) {
	# Not running .. need to start it
	&main_header();
	print "<p> <b>$self->{'text_hash'}->{'index_notrun'}</b> <p>\n";
	}
elsif ($self->{'r'} == -1) {
	# Running, but user hasn't logged in yet
	$needpass = 1;
	}
elsif ($self->{'r'} == -2) {
	# Looks like a shared library problem
	&main_header();
	print $self->text('index_elibrary', "<tt>$self->{'config_hash'}->{'psql'}</tt>"),"<p>\n";
	print "<p>",$self->text('index_ldpath', "<tt>$ENV{$self->{'gconfig_hash'}->{'ld_env'}}</tt>",
			  "<tt>$self->{'config_hash'}->{'psql'}</tt>"),"<br>\n";
	print "<pre>$self->{'out'}</pre>\n";
	$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});
	exit;
	}
else {
	# Check if we can re-direct to a single DB's page
	@{$self->{'titles_array'}} = grep { $self->can_edit_db($_) } $self->list_databases();
	if (@{$self->{'titles_array'}} == 1) {
		# Only one DB, so go direct to it!
		$self->redirect("edit_dbase.cgi?db=$self->{'titles_array'}->[0]");
		exit;
		}

	# Running .. check version
	$self->{'postgresql_version'} = $self->get_postgresql_version();
	#&main_header();
	$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", undef, 1, 1, 0, undef, undef, undef, $self->{'postgresql_version'} ? $self->text('index_version', $self->{'postgresql_version'}) : undef);
		
	if (!$self->{'postgresql_version'}) {
	        print $self->text('index_superuser'),"<p>\n";
		$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});
		exit;
		}
	if ($self->{'postgresql_version'} < 6.5) {
		print $self->text('index_eversion', $self->{'postgresql_version'}, 6.5),
		      "<p>\n";
		$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});
		exit;
		}

	# List the databases
	print $self->ui_subheading($self->{'text_hash'}->{'index_dbs'});
	if (!@{$self->{'titles_array'}}) {
		print "<b>$self->{'text_hash'}->{'index_nodbs'}</b> <p>\n";
		}
	else {
		@{$self->{'icons_array'}} = map { "images/db.gif" } @{$self->{'titles_array'}};
		@{$self->{'links_array'}} = map { "edit_dbase.cgi?db=$_" } @{$self->{'titles_array'}};
		@{$self->{'titles_array'}} = map { $self->html_escape($_) } @{$self->{'titles_array'}};
		$self->icons_table(\@{$self->{'links_array'}}, \@{$self->{'titles_array'}}, \@{$self->{'icons_array'}});
		}
	}
}

if ($needpass)
{
 # Need to ask for the password
 &main_header();
 print "<center><p> <b>$self->{'text_hash'}->{'index_nopass'}</b> <p>\n";
 print "<form action=login.cgi method=post>\n";
 print "<table border>\n";
 print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'index_ltitle'}</b></td> </tr>\n";
 print "<tr $self->{'cb'}> <td><table cellpadding=2>\n";

 print "<tr> <td><b>$self->{'text_hash'}->{'index_login'}</b></td>\n";
 printf "<td><input name=login size=20 value='%s'></td> </tr>\n",
 $self->{'userconfig_hash'}->{'login'};

 print "<tr> <td><b>$self->{'text_hash'}->{'index_pass'}</b></td>\n";
 print "<td><input name=pass size=20 type=password></td> </tr>\n";

 print "</table></td></tr></table>\n";
 print "<input type=submit value='$self->{'text_hash'}->{'save'}'>\n";
 print "<input type=reset value='$self->{'text_hash'}->{'index_clear'}'>\n";
 print "</center></form>\n";
}
	
#$self->ui_print_footer("/", "index");
$self->ui_print_footer("$self->{'text_hash'}->{'index_mainpage_url'}", $self->{'text_hash'}->{'index_mainpage'});

1;
		
}

sub main_header
{
	shift if ($self == $_[0]);

$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", undef, 0, 1, 0,
	undef, undef, undef, $self->{'postgresql_version'} ?
		$self->text('index_version', $self->{'postgresql_version'}) : undef);
}


1;

