#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_field.cgi
# Create or rename a field

&ModuleLoader::preload_module('postgresql_class', "postgresql::PostgresqlLib");
$self = new postgresql::PostgresqlLib:: 'postgresql_class',%$self;

$self->ReadParse();
$self->can_edit_db($self->{'in_hash'}->{'db'}) || $self->error($self->{'text_hash'}->{'dbase_ecannot'});

$self->{'qt'} = $self->quote_table($self->{'in_hash'}->{'table'});
if ($self->{'in_hash'}->{'delete'}) {
	# Attempt to remove field
	$self->error_setup($self->{'text_hash'}->{'field_err1'});
	$self->execute_sql_logged($self->{'in_hash'}->{'db'}, "alter table $self->{'qt'} ".
			       "drop column \"$self->{'in_hash'}->{'old'}\"");
	}
else {
	# Validate inputs
	$self->error_setup($self->{'text_hash'}->{'field_err2'});
	$self->{'in_hash'}->{'field'} =~ /^\S+$/ || $self->error($self->text('field_efield', $self->{'in_hash'}->{'field'}));
	if ($self->{'in_hash'}->{'new'}) {
		# Add field
		if (defined($self->{'in_hash'}->{'size'})) {
			$self->{'in_hash'}->{'size'} =~ /^\d+(,\d+)?$/ ||
				$self->error($self->text('field_esize', $self->{'in_hash'}->{'size'}));
			$self->{'size'} = "($self->{'in_hash'}->{'size'})";
			}
		$self->{'arr'} = $self->{'in_hash'}->{'arr'} ? "[]" : "";
		$self->execute_sql_logged($self->{'in_hash'}->{'db'}, "alter table $self->{'qt'} add ".
				       "\"$self->{'in_hash'}->{'field'}\" $self->{'in_hash'}->{'type'}$self->{'size'}$self->{'arr'}");
		}
	elsif ($self->{'in_hash'}->{'old'} ne $self->{'in_hash'}->{'field'}) {
		# Rename field
		$self->execute_sql_logged($self->{'in_hash'}->{'db'}, "alter table $self->{'qt'} rename ".
				       "\"$self->{'in_hash'}->{'old'}\" to \"$self->{'in_hash'}->{'field'}\"");
		}
	}
$self->redirect("edit_table.cgi?db=$self->{'in_hash'}->{'db'}&table=$self->{'in_hash'}->{'table'}");

1;
		
}


1;

