#!/usr/bin/perl
package proc::ProcLib;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'proc::ProcLib');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# proc-lib.pl
# Functions for managing processes

&ModuleLoader::preload_module(ref($self), "WebLib");
$self = new WebLib:: ref($self), %$self; 
$self->init_config();
&ModuleLoader::preload_module(ref($self), "UiLib");
$self = new UiLib:: ref($self), %$self; 
if ($self->{'module_info_hash'}->{'usermin'} && !$ENV{'FOREIGN_MODULE_NAME'}) {
	$self->switch_to_remote_user();
	}
{
    my $pkg = $self->lib_to_pkg("$self->{config_hash}->{ps_style}-lib.pl", "proc");
    &ModuleLoader::preload_module(ref($self), "$pkg");
    $pkg .= '::';
    eval "\$self = new $pkg ref(\$self),\%\$self;"; 
}
use POSIX;
use Config;
if ($self->{'module_info_hash'}->{'usermin'}) {
	%{$self->{'access_hash'}} = ( 'edit' => 1,
		    'run' => 1,
		    'users' => 'x' );
	$self->{'no_module_config'} = 1;
	$self->{'user_processes_only'} = 1;
	$self->{'index_file'} = "$self->{'user_module_config_directory'}/index";
	}
else {
	%{$self->{'access_hash'}} = $self->get_module_acl();
	map { $self->{'hide_hash'}->{$_}++ } split(/\s+/, $self->{'access_hash'}->{'hide'});
	$self->{'index_file'} = "$self->{'module_config_directory'}/index";
	$self->{'user_processes_only'} = $self->{'access_hash'}->{'only'};
	if (!defined($self->{'access_hash'}->{'users'})) {
		$self->{'access_hash'}->{'users'} = $self->{'access_hash'}->{'uid'} < 0 ? "x" :
				   $self->{'access_hash'}->{'uid'} == 0 ? "*" :
					getpwuid($self->{'access_hash'}->{'uid'});
		}
	}
if ($self->{'access_hash'}->{'run'}) {
	if ($self->{'access_hash'}->{'users'} eq "*") {
		$self->{'default_run_user'} = "root";
		}
	elsif ($self->can_edit_process($self->{'remote_user'})) {
		$self->{'default_run_user'} = $self->{'remote_user'};
		}
	else {
		 @canu = split(/\s+/, $self->{'access_hash'}->{'users'});
		if ($canu[0] =~ /^\@(.*)$/) {
			$self->{'default_run_user'} = undef;
			}
		elsif ($can[0] =~ /^(\d+)\-(\d+)$/) {
			$self->{'default_run_user'} = getpwuid($1);
			}
		else {
			$self->{'default_run_user'} = $canu[0];
			}
		}
	}

$self->{'has_lsof_command'} = $self->has_command("lsof");

1;

1;
		return $self;
}

sub process_info
{
	my $self = shift;

local @plist = $self->list_processes($_[0]);
return @plist ? %{$plist[0]} : ();
}

# index_links(current)
sub index_links
{
	my $self = shift;

local(%linkname, $l);
print "<b>$self->{'text_hash'}->{'index_display'} : </b>&nbsp;&nbsp;\n";
foreach $l ("tree", "user", "size", "cpu", ($self->{'has_zone'} ? ("zone") : ()),
	    "search", "run") {
	next if ($l eq "run" && !$self->{'access_hash'}->{'run'});
	if ($l ne $_[0]) { print "<a href=index_$l.cgi>"; }
	else { print "<b>"; }
	print $self->{'text_hash'}->{"index_$l"};
	if ($l ne $_[0]) { print "</a>"; }
	else { print "</b>"; }
	print "&nbsp;\n";
	}
print "<p>\n";
$self->create_user_config_dirs();
open(INDEX, ">$self->{'index_file'}");
$0 =~ /([^\/]+)$/;
print INDEX "$1?$self->{'in'}\n";
close(INDEX);
}

# cut_string(string, [length])
sub cut_string
{
	my $self = shift;

local $len = $_[1] || $self->{'config_hash'}->{'cut_length'};
if ($len && length($_[0]) > $len) {
	return substr($_[0], 0, $len)." ...";
	}
return $_[0];
}

# switch_acl_uid()
sub switch_acl_uid
{
	my $self = shift;

return if ($self->{'module_info_hash'}->{'usermin'});	# already switched!
if ($self->{'access_hash'}->{'uid'} < 0) {
	local @u = getpwnam($self->{'remote_user'});
	@u || $self->error("Failed to find user $self->{'remote_user'}");
	$( = $u[3]; $) = "$u[3] $u[3]";
	($>, $<) = ($u[2], $u[2]);
	}
elsif ($self->{'access_hash'}->{'uid'}) {
	local @u = getpwuid($self->{'access_hash'}->{'uid'});
	$( = $u[3]; $) = "$u[3] $u[3]";
	($>, $<) = ($u[2], $u[2]);
	}
}

# safe_process_exec(command, uid, gid, handle, [input], [fixtags], [bsmode],
#		    [timeout])
# Executes the given command as the given user/group and writes all output
# to the given file handle. Finishes when there is no more output or the
# process stops running. Returns the number of bytes read.
sub safe_process_exec
{
	my $self = shift;

if ($self->is_readonly_mode()) {
	# Veto command in readonly mode
	return 0;
	}

if ($self->{'gconfig_hash'}->{'os_type'} eq 'windows') {
	# For Windows, just run the command and read output
	local $temp = $self->transname();
	open(TEMP, ">$temp");
	print TEMP $_[4];
	close(TEMP);
	$self->open_execute_command(*OUT, "$_[0] <$temp 2>&1", 1);
	local $fh = $_[3];
	while(<OUT>) {
		if ($_[5]) {
			print $fh $self->html_escape($_);
			}
		else {
			print $fh $_;
			}
		}
	close(OUT);
	return $got;
	}
else {
	# setup pipes and fork the process
	local $chld = $SIG{'CHLD'};
	$SIG{'CHLD'} = \&safe_exec_reaper;
	pipe(OUTr, OUTw);
	pipe(INr, INw);
	local $pid = fork();
	if (!$pid) {
		#setsid();
		untie(*STDIN);
		untie(*STDOUT);
		untie(*STDERR);
		open(STDIN, "<&INr");
		open(STDOUT, ">&OUTw");
		open(STDERR, ">&OUTw");
		$| = 1;
		close(OUTr); close(INw);

		if ($_[1]) {
			if (defined($_[2])) {
				# switch to given UID and GID
				$( = $_[2]; $) = "$_[2] $_[2]";
				($>, $<) = ($_[1], $_[1]);
				}
			else {
				# switch to UID and all GIDs
				local @u = getpwuid($_[1]);
				$( = $u[3];
				$) = "$u[3] ".join(" ", $u[3], $self->other_groups($u[0]));
				($>, $<) = ($u[2], $u[2]);
				}
			}

		# run the command
		delete($ENV{'FOREIGN_MODULE_NAME'});
		delete($ENV{'SCRIPT_NAME'});
		exec("/bin/sh", "-c", $_[0]);
		print "Exec failed : $!\n";
		exit 1;
		}
	close(OUTw); close(INr);

	# Feed input (if any)
	print INw $_[4];
	close(INw);

	# Read and show output
	local $fn = fileno(OUTr);
	local $got = 0;
	local $out = $_[3];
	local $line;
	local $start = time();
	$self->{'safe_process_exec_timeout'} = 0;
	while(1) {
		local ($rmask, $buf);
		vec($rmask, $fn, 1) = 1;
		local $sel = select($rmask, undef, undef, 1);
		if ($sel > 0 && vec($rmask, $fn, 1)) {
			# got something to read.. print it
			sysread(OUTr, $buf, 1024) || last;
			$got += length($buf);
			if ($_[5]) {
				$buf = $self->html_escape($buf);
				}
			if ($_[6]) {
				# Convert backspaces and returns and escapes
				$line .= $buf;
				while($line =~ s/^([^\n]*\n)//) {
					local $one = $1;
					while($one =~ s/.\010//) { }
					$one =~ s/\033[^m]+m//g;
					print $out $one;
					}
				}
			else {
				print $out $buf;
				}
			}
		elsif ($sel == 0) {
			# nothing to read. maybe the process is done, and a subprocess
			# is hanging things up
			last if (!kill(0, $pid));
			}
		if ($_[7] && time() - $start > $_[7]) {
			# Timeout exceeded - kill the process
			kill(KILL, $pid);
			$self->{'safe_process_exec_timeout'} = 1;
			}
		}
	close(OUTr);
	print $out $line;
	$SIG{'CHLD'} = $chld;
	return $got;
	}
}

# safe_process_exec_logged(..)
# Like safe_process_exec, but also logs the command
sub safe_process_exec_logged
{
	my $self = shift;

$self->additional_log('exec', undef, $_[0]);
return $self->safe_process_exec(@_);
}

sub safe_exec_reaper
{
	my $self = shift;

local $xp;
do {    local $oldexit = $?;
	$xp = waitpid(-1, WNOHANG);
	$? = $oldexit if ($? < 0);
	} while($xp > 0);
}

# pty_process_exec(command, [uid, gid])
# Starts the given command in a new pty and returns the pty filehandle and PID
sub pty_process_exec
{
	my $self = shift;

local ($cmd, $uid, $gid) = @_;
if ($self->is_readonly_mode()) {
	# When in readonly mode, don't run the command
	$cmd = "/bin/true";
	}

eval "use IO::Pty";
if (!$@) {
	# Use the IO::Pty perl module if installed
	local $ptyfh = new IO::Pty;
	if (!$ptyfh) {
		$self->error("Failed to create new PTY with IO::Pty");
		}
	local $ttyfh = $ptyfh->slave();
	local $tty = $ptyfh->ttyname();
	local $pid = fork();
	if (!$pid) {
		if ($self->UNIVERSAL::can('close_controlling_pty')) {
			$self->close_controlling_pty();
			}
		setsid();	# create a new session group
		$ptyfh->make_slave_controlling_terminal();

		close(STDIN); close(STDOUT); close(STDERR);
		untie(*STDIN); untie(*STDOUT); untie(*STDERR);
		if ($_[1]) {
			$( = $_[2]; $) = "$_[2] $_[2]";
			($>, $<) = ($_[1], $_[1]);
			}

		open(STDIN, "<$tty");
		open(STDOUT, ">$tty");
		open(STDERR, ">&STDOUT");
		close($ptyfh);
		exec($cmd);
		print "Exec failed : $!\n";
		exit 1;
		}
	$ptyfh->close_slave();
	return ($ptyfh, $pid);
	}
else {
	# Need to create a PTY using built-in Webmin code
	local ($ptyfh, $ttyfh, $pty, $tty) = $self->get_new_pty();
	$tty || $self->error("Failed to create new PTY");
	local $pid = fork();
	if (!$pid) {
		if ($self->UNIVERSAL::can('close_controlling_pty')) {
			$self->close_controlling_pty();
			}

		setsid();	# create a new session group

		if (!$ttyfh) {
			# Needs to be opened, as get_new_pty on linux cannot do
			# this so soon
			$ttyfh = "TTY";
			if ($_[1]) {
				chown($_[1], $_[2], $tty);
				}
			open($ttyfh, "+<$tty") || $self->error("Failed to open $tty : $!");
			}

		if ($self->UNIVERSAL::can('open_controlling_pty')) {
			$self->open_controlling_pty($ptyfh, $ttyfh, $pty, $tty);
			}

		close(STDIN); close(STDOUT); close(STDERR);
		untie(*STDIN); untie(*STDOUT); untie(*STDERR);
		#setpgrp(0, $$);
		if ($_[1]) {
			$( = $_[2]; $) = "$_[2] $_[2]";
			($>, $<) = ($_[1], $_[1]);
			}

		open(STDIN, "<$tty");
		open(STDOUT, ">&$ttyfh");
		open(STDERR, ">&STDOUT");
		close($ptyfh);
		exec($cmd);
		print "Exec failed : $!\n";
		exit 1;
		}
	close($ttyfh);
	return ($ptyfh, $pid);
	}
}

# pty_process_exec_logged(..)
# Like pty_process_exec, but logs the command as well
sub pty_process_exec_logged
{
	my $self = shift;

$self->additional_log('exec', undef, $_[0]);
return $self->pty_process_exec(@_);
}

# find_process(name)
# Returns an array of all processes matching some name
sub find_process
{
	my $self = shift;

local $name = $_[0];
local @rv = grep { $_->{'args'} =~ /$name/ } $self->list_processes();
return wantarray ? @rv : $rv[0];
}

# find_socket_processes(protocol, port)
# Returns all processes using some port and protocol
sub find_socket_processes
{
	my $self = shift;

local @rv;
open(LSOF, "lsof -i '$_[0]:$_[1]' |");
while(<LSOF>) {
	if (/^(\S+)\s+(\d+)/) {
		push(@rv, $2);
		}
	}
close(LSOF);
return @rv;
}

# find_ip_processes(ip)
# Returns all processes using some IP address
sub find_ip_processes
{
	my $self = shift;

local @rv;
open(LSOF, "lsof -i '\@$_[0]' |");
while(<LSOF>) {
	if (/^(\S+)\s+(\d+)/) {
		push(@rv, $2);
		}
	}
close(LSOF);
return @rv;
}

# find_process_sockets(pid)
# Returns all network connections made by some process
sub find_process_sockets
{
	my $self = shift;

local @rv;
open(LSOF, "lsof -i tcp -i udp -n |");
while(<LSOF>) {
	if (/^(\S+)\s+(\d+)\s+(\S+)\s+(\S+)\s+(\S+)\s+(\S+).*(TCP|UDP)\s+(.*)/
	    && $2 eq $_[0]) {
		local $n = { 'fd' => $4,
			     'type' => $5,
			     'proto' => $7 };
		local $m = $8;
		if ($m =~ /^([^:\s]+):([^:\s]+)\s+\(listen\)/i) {
			$n->{'lhost'} = $1;
			$n->{'lport'} = $2;
			$n->{'listen'} = 1;
			}
		elsif ($m =~ /^([^:\s]+):([^:\s]+)->([^:\s]+):([^:\s]+)\s+\((\S+)\)/) {
			$n->{'lhost'} = $1;
			$n->{'lport'} = $2;
			$n->{'rhost'} = $3;
			$n->{'rport'} = $4;
			$n->{'state'} = $5;
			}
		elsif ($m =~ /^([^:\s]+):([^:\s]+)/) {
			$n->{'lhost'} = $1;
			$n->{'lport'} = $2;
			}
		push(@rv, $n);
		}
	}
close(LSOF);
return @rv;
}

# find_process_files(pid)
# Returns all files currently held open by some process
sub find_process_files
{
	my $self = shift;

local @rv;
open(LSOF, "lsof -p '$_[0]' |");
while(<LSOF>) {
	if (/^(\S+)\s+(\d+)\s+(\S+)\s+(\S+)\s+(\S+)\s+(\d+),(\d+)\s+(\d+)\s+(\d+)\s+(.*)/) {
		push(@rv, { 'fd' => lc($4),
			    'type' => lc($5),
			    'device' => [ $6, $7 ],
			    'size' => $8,
			    'inode' => $9,
			    'file' => $10 });
		}
	elsif (/^(\S+)\s+(\d+)\s+(\S+)\s+(\S+)\s+(\S+)\s+(\d+),(\d+)\s+(\d+)\s+(.*)/) {
		push(@rv, { 'fd' => lc($4),
			    'type' => lc($5),
			    'device' => [ $6, $7 ],
			    'inode' => $8,
			    'file' => $9 });
		}
	}
close(LSOF);
return @rv;
}

# pty_backquote(cmd, uid, gid)
# Like the normal Perl backquote operator, but executes the command in a PTY
sub pty_backquote
{
	my $self = shift;

local $rv;
local ($fh, $pid) = $self->pty_process_exec(@_);
while(<$fh>) {
	$rv .= $_;
	}
close($fh);
waitpid($pid, WNOHANG);
return $rv;
}

# pty_backquote_logged(cmd, uid, gid)
# Like pty_backquote, but logs the command as well
sub pty_backquote_logged
{
	my $self = shift;

$self->additional_log('exec', undef, $_[0]);
return $self->pty_backquote(@_);
}

# get_cpu_info()
# Returns a list containing the 5, 10 and 15 minute load averages
sub get_cpu_info
{
	my $self = shift;

if ($self->UNIVERSAL::can('os_get_cpu_info')) {
	return $self->os_get_cpu_info();
	}
local $out = `uptime 2>&1`;
return $out =~ /average(s)?:\s+([0-9\.]+),?\s+([0-9\.]+),?\s+([0-9\.]+)/i ?
		( $2, $3, $4 ) : ( );
}

# $self->find_subprocesses(&proc, [&plist])
# Returns a list of all processes under the one given
sub find_subprocesses
{
	my $self = shift;

local $proc = $_[0];
local @plist = $_[1] ? @{$_[1]} : $self->list_processes();
local @sp = grep { $_->{'ppid'} &&
		   $_->{'ppid'} == $proc->{'pid'} } @plist;
local (@rv, $sp);
foreach $sp (@sp) {
	push(@rv, $sp, $self->find_subprocesses($sp, \@plist));
	}
return @rv;
}

# supported_signals()
# Returns signal names known to Perl for the kill function
sub supported_signals
{
	my $self = shift;

if ($self->UNIVERSAL::can('os_supported_signals')) {
	return $self->os_supported_signals();
	}
else {
	return split(/\s+/, $Config{'sig_name'});
	}
}

# can_view_process(user)
# Returns 1 if processes belong to this user can be seen
sub can_view_process
{
	my $self = shift;

local ($user) = @_;
if ($self->{'hide_hash'}->{$user}) {
	return 0;
	}
elsif ($self->{'user_processes_only'}) {
	return $self->can_edit_process($user);
	}
else {
	return 1;
	}
}

# can_edit_process(user)
# Returns 1 if processes belong to this user can be edited. The 'manage as'
# user will still apply though.
sub can_edit_process
{
	my $self = shift;

local ($user) = @_;
if (!$self->{'access_hash'}->{'edit'}) {
	return 0;
	}
elsif ($self->{'hide_hash'}->{$user}) {
	return 0;
	}
elsif ($self->{'access_hash'}->{'users'} eq '*') {
	return 1;
	}
elsif ($self->{'access_hash'}->{'users'} eq 'x') {
	return $user eq $self->{'remote_user'};
	}
else {
	local @uinfo = getpwnam($user);
	foreach my $u (split(/\s+/, $self->{'access_hash'}->{'users'})) {
		if ($u =~ /^\@(.*)$/) {
			# Is he in this group?
			local @ginfo = getgrnam($1);
			return 1 if ($uinfo[3] == $ginfo[2]);
			return 1 if ($self->indexof($ginfo[0],
					      $self->other_groups($user)) >= 0);
			}
		elsif ($u =~ /^(\d+)\-(\d+)$/) {
			# Check UID
			return 1 if ($uinfo[2] >= $1 && $uinfo[2] <= $2);
			}
		else {
			return 1 if ($u eq $user);
			}
		}
	return 0;
	}
}


1;

