#!/usr/bin/perl

&MAIN();

 sub MAIN {
# index_search.cgi
# Allows searching for processes by user or command

&ModuleLoader::preload_module('proc_class', "proc::ProcLib");
$self = new proc::ProcLib:: 'proc_class',%$self;

$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", "search", !$self->{'no_module_config'}, 1);
$self->ReadParse();
$self->index_links("search");

# display search form
print "<form action=index_search.cgi>\n";
print "<table width=100%><tr><td valign=top>\n";

printf "<input type=radio name=mode value=0 %s>\n",
	$self->{'in_hash'}->{mode}==0 ? "checked" : "";
print $self->hlink("<b>$self->{'text_hash'}->{'search_user'}</b>","suser"),"\n";
printf "<input name=user size=8 value=\"%s\"> %s<br>\n",
	$self->{'in_hash'}->{mode}==0 ? $self->{'in_hash'}->{user} : "",
	$self->user_chooser_button("user", 0);

printf "<input type=radio name=mode value=1 %s>\n",
	$self->{'in_hash'}->{mode}==1 ? "checked" : "";
print $self->hlink("<b>$self->{'text_hash'}->{'search_match'}</b>","smatch"),"\n";
printf "<input name=match size=20 value=\"%s\"><br>\n",
	$self->{'in_hash'}->{mode}==1 ? $self->{'in_hash'}->{match} : "";

printf "<input type=radio name=mode value=2 %s>\n",
	$self->{'in_hash'}->{mode}==2 ? "checked" : "";
$self->{'cpu'} = sprintf "<input name=cpu size=4 value=\"%s\">\n",
		$self->{'in_hash'}->{mode}==2 ? $self->{'in_hash'}->{cpu} : "";
print $self->hlink("<b>".$self->text('search_cpupc', $self->{'cpu'})."</b>", "scpu"),"<br>\n";

print "</td><td valign=top>\n";

if ($self->{'has_fuser_command'}) {
	printf "<input type=radio name=mode value=3 %s>\n",
		$self->{'in_hash'}->{mode}==3 ? "checked" : "";
	print $self->hlink("<b>$self->{'text_hash'}->{'search_fs'}</b>","sfs"),"\n";
	if ($self->foreign_check("mount")) {
		$self->foreign_require("mount", "mount-lib.pl");
		print "<select name=fs>\n";
		foreach $fs ($self->foreign_call("mount", "list_mounted")) {
			next if ($fs->[2] eq "swap");
			printf "<option %s>%s\n",
			     $self->{'in_hash'}->{'mode'}==3 && $self->{'in_hash'}->{'fs'} eq $fs->[0] ?
			     "selected" : "", $fs->[0];
			}
		print "</select><br>\n";
		}
	else {
		printf "<input name=fs size=15 value='%s'><br>\n",
			$self->{'in_hash'}->{'mode'}==3 ? $self->{'in_hash'}->{'fs'} : "";
		}

	printf "<input type=radio name=mode value=4 %s>\n",
		$self->{'in_hash'}->{mode}==4 ? "checked" : "";
	print $self->hlink("<b>$self->{'text_hash'}->{'search_files'}</b>","sfiles"),"\n";
	printf "<input name=files size=30 value=\"%s\">\n",
		$self->{'in_hash'}->{mode}==4 ? $self->{'in_hash'}->{'files'} : "";
	print $self->file_chooser_button("files", 0);
	print "<br>\n";
	}
if ($self->{'has_lsof_command'}) {
	# Show input for file in use
	printf "<input type=radio name=mode value=5 %s>\n",
		$self->{'in_hash'}->{mode}==5 ? "checked" : "";
	print $self->hlink("<b>$self->{'text_hash'}->{'search_port'}</b>","ssocket"),"\n";
	printf "<input name=port size=6 value='%s'>\n",
		$self->{'in_hash'}->{mode}==5 ? $self->{'in_hash'}->{port} : "";

	# Show input for protocol and port
	print $self->hlink("<b>$self->{'text_hash'}->{'search_protocol'}</b>","ssocket"),"\n";
	print "<select name=protocol>\n";
	printf "<option value=tcp %s>TCP\n",
		$self->{'in_hash'}->{protocol} eq 'tcp' ? 'selected' : '';
	printf "<option value=udp %s>UDP\n",
		$self->{'in_hash'}->{protocol} eq 'udp' ? 'selected' : '';
	print "</select>\n";
	print "<br>\n";

	# Show input for IP address
	printf "<input type=radio name=mode value=6 %s>\n",
		$self->{'in_hash'}->{mode}==6 ? "checked" : "";
	print $self->hlink("<b>$self->{'text_hash'}->{'search_ip'}</b>","sip"),"\n";
	printf "<input name=ip size=15 value='%s'>\n",
		$self->{'in_hash'}->{mode}==6 ? $self->{'in_hash'}->{ip} : "";
	}

print "</td></tr></table>\n";
print "<input type=submit value=\"$self->{'text_hash'}->{'search_submit'}\">\n";
print "&nbsp;" x 5;
printf "<input type=checkbox name=ignore value=1 %s> %s<br>\n",
	$self->{'in_hash'}->{'ignore'} || !defined($self->{'in_hash'}->{'mode'}) ? 'checked' : '',
	$self->hlink("<b>$self->{'text_hash'}->{'search_ignore'}</b>","signore");
print "</form>\n";

if (%{$self->{'in_hash'}}) {
	# search for processes
	@{$self->{'procs_array'}} = $self->list_processes();
	@{$self->{'procs_array'}} = grep { $self->can_view_process($_->{'user'}) } @{$self->{'procs_array'}};
	if ($self->{'in_hash'}->{mode} == 0) {
		# search by user
		@{$self->{'dis_array'}} = grep { $_->{'user'} eq $self->{'in_hash'}->{'user'} } @{$self->{'procs_array'}};
		}
	elsif ($self->{'in_hash'}->{mode} == 1) {
		# search by regexp
		@{$self->{'dis_array'}} = grep { $_->{'args'} =~ /\Q$self->{'in_hash'}->{match}\E/i } @{$self->{'procs_array'}};
		}
	elsif ($self->{'in_hash'}->{mode} == 2) {
		# search by cpu
		@{$self->{'dis_array'}} = grep { $_->{'cpu'} > $self->{'in_hash'}->{'cpu'} } @{$self->{'procs_array'}};
		@{$self->{'dis_array'}} = sort { $b->{'cpu'} <=> $a->{'cpu'} } @{$self->{'dis_array'}};
		}
	elsif ($self->{'in_hash'}->{mode} == 3 && $self->{'has_fuser_command'}) {
		# search by filesystem
		foreach $p ($self->find_mount_processes($self->{'in_hash'}->{'fs'})) { $self->{'using_hash'}->{$p}++; }
		@{$self->{'dis_array'}} = grep { defined($self->{'using_hash'}->{$_->{'pid'}}) } @{$self->{'procs_array'}};
		}
	elsif ($self->{'in_hash'}->{mode} == 4 && $self->{'has_fuser_command'}) {
		# search by files
		foreach $p ($self->find_file_processes(split(/\s+/, $self->{'in_hash'}->{'files'})))
			{ $self->{'using_hash'}->{$p}++; }
		@{$self->{'dis_array'}} = grep { defined($self->{'using_hash'}->{$_->{'pid'}}) } @{$self->{'procs_array'}};
		}
	elsif ($self->{'in_hash'}->{mode} == 5 && $self->{'has_lsof_command'}) {
		foreach $p ($self->find_socket_processes($self->{'in_hash'}->{'protocol'},$self->{'in_hash'}->{'port'}))
			{ $self->{'using_hash'}->{$p}++; }
		@{$self->{'dis_array'}} = grep { defined($self->{'using_hash'}->{$_->{'pid'}}) } @{$self->{'procs_array'}};
		}
	elsif ($self->{'in_hash'}->{mode} == 6 && $self->{'has_lsof_command'}) {
		foreach $p ($self->find_ip_processes($self->{'in_hash'}->{'ip'}))
			{ $self->{'using_hash'}->{$p}++; }
		@{$self->{'dis_array'}} = grep { defined($self->{'using_hash'}->{$_->{'pid'}}) } @{$self->{'procs_array'}};
		}

	if ($self->{'in_hash'}->{'ignore'}) {
		# Ignore this process and any children
		@{$self->{'dis_array'}} = grep { $_->{'pid'} != $$ && $_->{'ppid'} != $$ } @{$self->{'dis_array'}};
		}

	# display matches
	if (@{$self->{'dis_array'}}) {
		print $self->ui_columns_start([
			  $self->{'text_hash'}->{'pid'},
			  $self->{'text_hash'}->{'owner'},
			  $self->{'text_hash'}->{'cpu'},
			  $self->{'info_arg_map_hash'}->{'_stime'} ? ( $self->{'text_hash'}->{'stime'} ) : ( ),
			  $self->{'text_hash'}->{'command'} ], 100);
		foreach $d (@{$self->{'dis_array'}}) {
			$p = $d->{'pid'};
			push(@{$self->{'pidlist_array'}}, $p);
			local @cols;
			if ($self->can_edit_process($d->{'user'})) {
				push(@cols, "<a href=\"edit_proc.cgi?$p\">$p</a>");
				}
			else {
				push(@cols, $p);
				}
			push(@cols, $d->{user});
			push(@cols, $d->{cpu});
			if ($self->{'info_arg_map_hash'}->{'_stime'}) {
				push(@cols, $d->{'_stime'});
				}
			push(@cols, $self->html_escape($self->cut_string($d->{args})));
			print $self->ui_columns_row(\@cols);
			}
		print $self->ui_columns_end(),"<p>\n";
		}
	else {
		print "<p><b>$self->{'text_hash'}->{'search_none'}</b><p>\n";
		}

	if (@{$self->{'pidlist_array'}} && $self->{'access_hash'}->{'simple'} && $self->{'access_hash'}->{'edit'}) {
		# display form for mass killing with selected signals
		print "<form action=kill_proc_list.cgi>\n";
		print "<input type=hidden name=args value=\"$self->{'in'}\">\n";
		printf "<input type=hidden name=pidlist value=\"%s\">\n",
			join(" ", @{$self->{'pidlist_array'}});
		print "<input type=hidden name=pid value=$self->{'pinfo_hash'}->{pid}>\n";
		foreach $s ('KILL', 'TERM', 'HUP', 'STOP', 'CONT') {
			printf "<input type=submit value=\"%s\" name=%s>\n",
				$self->{'text_hash'}->{"kill_".lc($s)}, $s;
			}
		print "</form>\n";
		}
	elsif (@{$self->{'pidlist_array'}} && $self->{'access_hash'}->{'edit'}) {
		# display form for mass killing with any signal
		print "<form action=kill_proc_list.cgi>\n";
		print "<input type=submit value=\"$self->{'text_hash'}->{'search_kill'}\">\n";
		print "<input type=hidden name=args value=\"$self->{'in'}\">\n";
		printf "<input type=hidden name=pidlist value=\"%s\">\n",
			join(" ", @{$self->{'pidlist_array'}});
		print "<select name=signal>\n";
		foreach $s ($self->supported_signals()) {
			printf "<option value=\"$s\" %s> $s\n",
				$s eq "HUP" ? "selected" : "";
			}
		print "</select>\n";

		print "&nbsp;" x 2;
		print "<input type=submit name=TERM ",
		      "value='$self->{'text_hash'}->{'search_sigterm'}'>\n";
		print "&nbsp;" x 2;
		print "<input type=submit name=KILL ",
		      "value='$self->{'text_hash'}->{'search_sigkill'}'>\n";
		print "</form>\n";
		}
	}

$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});

1;
		
}


1;

