#!/usr/bin/perl

&MAIN();

 sub MAIN {
# index.cgi
# Display a list of all existing processes

&ModuleLoader::preload_module('proc_class', "proc::ProcLib");
$self = new proc::ProcLib:: 'proc_class',%$self;

$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", "tree", !$self->{'no_module_config'}, 1);

$self->index_links("tree");
print $self->ui_columns_start([ $self->{'text_hash'}->{'pid'},
			  $self->{'text_hash'}->{'owner'},
			  $self->{'info_arg_map_hash'}->{'_stime'} ? ( $self->{'text_hash'}->{'stime'} ) : ( ),
			  $self->{'text_hash'}->{'command'} ], 100);
@{$self->{'procs_array'}} = sort { $a->{'pid'} <=> $b->{'pid'} } $self->list_processes();
foreach $pr (@{$self->{'procs_array'}}) {
	$self->{'p'} = $pr->{'pid'}; $self->{'pp'} = $pr->{'ppid'};
	$self->{'argmap_hash'}->{$self->{'p'}} = $pr->{'args'};
	$self->{'usermap_hash'}->{$self->{'p'}} = $pr->{'user'};
	$self->{'stimemap_hash'}->{$self->{'p'}} = $pr->{'_stime'};
	push(@{$self->{'children_hash'}->{$self->{'pp'}}}, $self->{'p'});
	$self->{'inlist_hash'}->{$pr->{'pid'}}++;
	}
foreach $pr (@{$self->{'procs_array'}}) {
	push(@{$self->{'roots_array'}}, $pr->{'pid'}) if (!$self->{'inlist_hash'}->{$pr->{'ppid'}} ||
				       $pr->{'pid'} == $pr->{'ppid'} ||
				       $pr->{'pid'} == 0);
	}
foreach $r ($self->unique(@{$self->{'roots_array'}})) {
	&walk_procs("", $r);
	}
print $self->ui_columns_end();

$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});

1;
		
}

# walk_procs(indent, pid)
sub walk_procs
{
	shift if ($self == $_[0]);

next if ($self->{'done_proc_hash'}->{$_[1]}++);
local(@ch, $_, $args);
if ($self->can_view_process($self->{'usermap_hash'}->{$_[1]})) {
	local @cols;
	if ($self->can_edit_process($self->{'usermap_hash'}->{$_[1]})) {
		push(@cols, "$_[0]<a href=\"edit_proc.cgi?$_[1]\">$_[1]</a>");
		}
	else {
		push(@cols, "$_[0]$_[1]");
		}
	push(@cols, $self->{'usermap_hash'}->{$_[1]});
	if ($self->{'info_arg_map_hash'}->{'_stime'}) {
		push(@cols, $self->{'stimemap_hash'}->{$_[1]});
		}
	$args = $self->cut_string($self->{'argmap_hash'}->{$_[1]});
	push(@cols, $self->html_escape($args));
	print $self->ui_columns_row(\@cols);
	}
foreach (@{$self->{'children_hash'}->{$_[1]}}) {
	&walk_procs("$_[0]&nbsp;&nbsp;&nbsp;", $_);
	}
}


1;

