%qmail_config = ();
&read_file("$config_directory/../qmailadmin/config", \%qmail_config);

$qmail_alias_dir = "$qmail_config{'qmail_dir'}/alias";
$qmail_bin_dir = "$qmail_config{'qmail_dir'}/bin";
$qmail_control_dir = "$qmail_config{'qmail_dir'}/control";
$qmail_routes_file = "$qmail_control_dir/smtproutes";
$qmail_virts_file = "$qmail_control_dir/virtualdomains";
$qmail_start_cmd = "$qmail_config{'qmail_dir'}/rc";
$qmail_mess_dir = "$qmail_config{'qmail_dir'}/queue/mess";
$qmail_info_dir = "$qmail_config{'qmail_dir'}/queue/info";
$qmail_local_dir = "$qmail_config{'qmail_dir'}/queue/local";
$qmail_remote_dir = "$qmail_config{'qmail_dir'}/queue/remote";
$qmail_assigns_file = "$qmail_config{'qmail_dir'}/users/assign";

$can_alias_types{2} = 0;
$can_alias_types{7} = 0;

# list_aliases()
# Returns a list of qmail alias file names
sub qmail_list_aliases
{
local @rv;
opendir(DIR, $qmail_alias_dir);
foreach $f (readdir(DIR)) {
	next if ($f !~ /^\.qmail-(\S+)$/);
	push(@rv, $1);
	}
closedir(DIR);
return @rv;
}

# get_alias(name)
sub qmail_get_alias
{
local $alias = { 'name' => $_[0],
		 'file' => "$qmail_alias_dir/.qmail-$_[0]",
		 'values' => [ ] };
open(ALIAS, $alias->{'file'});
while(<ALIAS>) {
	s/\r|\n//g;
	s/#.*$//g;
	if (/\S/) {
		push(@{$alias->{'values'}}, $_);
		}
	}
close(ALIAS);
return $alias;
}

# list_control_file()
# Returns the contents of a multi-line control file
sub qmail_list_control_file
{
local @lines;
open(FILE, "$qmail_control_dir/$_[0]") || return undef;
while(<FILE>) {
	s/\r|\n//g;
	s/#.*$//g;
	push(@lines, $_) if (/\S/);
	}
close(FILE);
return \@lines;
}

# list_virts()
# Returns a list of all virtualdomains file entries
sub qmail_list_virts
{
local $lnum = 0;
local @rv;
open(VIRTS, $qmail_virts_file);
while(<VIRTS>) {
	s/\r|\n//g;
	s/#.*$//;
	if (/^(\S+)\@(\S+):(\S*)/) {
		push(@rv, { 'user' => $1,
			    'domain' => $2,
			    'from' => "$1\@$2",
			    'prepend' => $3,
			    'line' => $lnum,
			    'idx' => scalar(@rv) } );
		}
	elsif (/^(\S*):(\S*)/) {
		push(@rv, { 'domain' => $1,
			    'from' => $1,
			    'prepend' => $2,
			    'line' => $lnum,
			    'idx' => scalar(@rv) } );
		}
	$lnum++;
	}
close(VIRTS);
return @rv;
}

1;
1;
