#!/usr/bin/perl

&MAIN();

 sub MAIN {
# index.cgi
# Just display the current user's quotas

&ModuleLoader::preload_module('quota_class', "quota::QuotaLib");
$self = new quota::QuotaLib:: 'quota_class',%$self;

$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", undef, 0, 1);

@{$self->{'st_array'}} = stat($self->{'remote_user_info_array'}->[7]);	# force mount of home dir
$self->{'n'} = $self->user_filesystems($self->{'remote_user'});
if ($self->{'n'}) {
	print $self->ui_subheading($self->text('index_quotas', "<tt>$self->{'remote_user'}</tt>"));
	&quotas_table();
	}
else {
	print "<p><b>$self->{'text_hash'}->{'index_none'}</b><p>\n";
	}

if ($self->quotas_supported() >= 2) {
	foreach $gid ($self->{'remote_user_info_array'}->[3], $self->other_groups($self->{'remote_user'})) {
		($self->{'g'} = getgrgid($gid)) || next;
		$self->{'n'} = $self->group_filesystems($self->{'g'});
		if ($self->{'n'} > 0) {
			print $self->ui_subheading($self->text('index_gquotas', "<tt>$self->{'g'}</tt>"));
			&quotas_table();
			}
		}
	}

$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});

1;
		
}

sub quotas_table
{
	shift if ($self == $_[0]);

print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><br></td>\n";
$cols = 3 + ($self->{'config_hash'}->{'show_grace'} ? 1 : 0);
print "<td colspan=$cols align=center><b>$self->{'text_hash'}->{'ufilesys_blocks'}</b></td>\n";
print "<td colspan=$cols align=center><b>$self->{'text_hash'}->{'ufilesys_files'}</b></td> </tr>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'ufilesys_fs'}</b></td>\n";
print "<td><b>$self->{'text_hash'}->{'ufilesys_used'}</b></td> <td><b>$self->{'text_hash'}->{'ufilesys_soft'}</b></td>\n";
print "<td><b>$self->{'text_hash'}->{'ufilesys_hard'}</b></td>\n";
print "<td><b>$self->{'text_hash'}->{'ufilesys_grace'}</b></td>\n"
	if ($self->{'config_hash'}->{'show_grace'});
print "<td><b>$self->{'text_hash'}->{'ufilesys_used'}</b></td> <td><b>$self->{'text_hash'}->{'ufilesys_soft'}</b></td>\n";
print "<td><b>$self->{'text_hash'}->{'ufilesys_hard'}</b></td>\n";
print "<td><b>$self->{'text_hash'}->{'ufilesys_grace'}</b></td>\n"
	if ($self->{'config_hash'}->{'show_grace'});
print "</tr>\n";
for($i=0; $i<$self->{'n'}; $i++) {
	$self->{'f'} = $self->{'filesys_hash'}->{$i,'filesys'};
	$self->{'bsize'} = $self->{'config_hash'}->{'block_size'};
	print "<tr $self->{'cb'}>\n";
	print "<td>$self->{'f'}</td>\n";
	if ($self->{'bsize'}) {
		print "<td>",$self->nice_size($self->{'filesys_hash'}->{$i,'ublocks'}*$self->{'bsize'}),"</td>\n";
		}
	else {
		print "<td>$self->{'filesys_hash'}->{$i,'ublocks'}</td>\n";
		}
	$self->print_limit($self->{'filesys_hash'}->{$i,'sblocks'});
	$self->print_limit($self->{'filesys_hash'}->{$i,'hblocks'});
	$self->print_grace($self->{'filesys_hash'}->{$i,'gblocks'}) if ($self->{'config_hash'}->{'show_grace'});
	print "<td>$self->{'filesys_hash'}->{$i,'ufiles'}</td>\n";
	$self->print_limit($self->{'filesys_hash'}->{$i,'sfiles'});
	$self->print_limit($self->{'filesys_hash'}->{$i,'hfiles'});
	$self->print_grace($self->{'filesys_hash'}->{$i,'gfiles'}) if ($self->{'config_hash'}->{'show_grace'});
	print "</tr>\n";
        if ($self->{'filesys_hash'}->{$i,'sblocks'} or $self->{'filesys_hash'}->{$i,'hblocks'} or $self->{'filesys_hash'}->{$i,'sfiles'} or $self->{'filesys_hash'}->{$i,'hfiles'}) {
		my ($b,$bmax);
		print "<tr $self->{'cb'}><td>&nbsp;</td>";
		my $cols = $self->{'config_hash'}->{'show_grace'} ? 4 : 3;
		if ($bmax = ($self->{'filesys_hash'}->{$i,'hblocks'} or $self->{'filesys_hash'}->{$i,'sblocks'})) {
			$b = int(($self->{'filesys_hash'}->{$i,'ublocks'}/$bmax*100)+0.5);
			print "<td align=left colspan=$cols><table width=\"$b%\"><tr><td bgcolor=#66ff66>&nbsp;</td></tr></table></td>";
			}
		else {
			print "<td colspan=$cols>&nbsp;</td>";
			}
		if ($bmax = ($self->{'filesys_hash'}->{$i,'hfiles'} or $self->{'filesys_hash'}->{$i,'sfiles'})) {
			$b = int(($self->{'filesys_hash'}->{$i,'ufiles'}/$bmax*100)+0.5);
			print "<td align=left colspan=$cols><table width=\"$b%\"><tr><td bgcolor=#66ff66>&nbsp;</td></tr></table></td>";
			}
		else {
			print "<td colspan=$cols>&nbsp;</td>";
			}
		print "</tr>\n";
		}
	}
print "</table><br>\n";
}


1;

