#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Show a form to create or edit a scheduled email

&ModuleLoader::preload_module('schedule_class', "schedule::ScheduleLib");
$self = new schedule::ScheduleLib:: 'schedule_class',%$self;

$self->ReadParse();
if ($self->{'in_hash'}->{'new'}) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'edit_title1'}, "");
	$self->{'sched'} = { 'enabled' => 1,
		   'at' => time(),
		   'mins' => 0,
		   'hours' => 0,
		   'days' => '*',
		   'months' => '*',
		   'weekdays' => '*' };
	}
else {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'edit_title2'}, "");
	$self->{'sched'} = $self->get_schedule($self->{'in_hash'}->{'id'});
	}

print $self->ui_form_start("save.cgi", "form-data");
print $self->ui_hidden("new", $self->{'in_hash'}->{'new'}),"\n";
print $self->ui_hidden("id", $self->{'in_hash'}->{'id'}),"\n";
print $self->ui_table_start($self->{'text_hash'}->{'edit_header'}, "width=100%", 2);

print $self->ui_table_row($self->{'text_hash'}->{'edit_subject'},
		    $self->ui_textbox("subject", $self->{'sched'}->{'subject'}, 50));

$self->{'myaddr'} = $self->my_email_address();
if ($main::mailbox_object->{'config_hash'}->{'edit_from'} == 1) {
	# From address field, if allowed
	print $self->ui_table_row($self->{'text_hash'}->{'edit_from'},
			    $self->ui_radio("from_def", $self->{'sched'}->{'from'} ? 0 : 1,
			      [ [ 1, $self->text('edit_self', $self->{'myaddr'})."<br>" ],
				[ 0, $self->{'text_hash'}->{'edit_addr'} ] ])."\n".
			    $self->ui_textbox("from", $self->{'sched'}->{'from'}, 30)." ".
			    $main::mailbox_object->address_button("from", 0, 1));
	}

# To address
print $self->ui_table_row($self->{'text_hash'}->{'edit_to'},
		    $self->ui_radio("to_def", $self->{'sched'}->{'to'} ? 0 : 1,
			      [ [ 1, $self->text('edit_self', $self->{'myaddr'})."<br>" ],
				[ 0, $self->{'text_hash'}->{'edit_addr'} ] ])."\n".
		    $self->ui_textbox("to", $self->{'sched'}->{'to'}, 60)." ".
		    $main::mailbox_object->address_button("to", 0));

# Cc and Bcc addresses
print $self->ui_table_row($self->{'text_hash'}->{'edit_cc'},
		    $self->ui_textbox("cc", $self->{'sched'}->{'cc'}, 60)." ".
		    $main::mailbox_object->address_button("cc", 0));
print $self->ui_table_row($self->{'text_hash'}->{'edit_bcc'},
		    $self->ui_textbox("bcc", $self->{'sched'}->{'bcc'}, 60)." ".
		    $main::mailbox_object->address_button("bcc", 0));

print $self->ui_table_row($self->{'text_hash'}->{'edit_mail'},
		    $self->ui_textarea("mail", $self->{'sched'}->{'mail'}, 8, 70)."<br>".
		    ($self->{'config_hash'}->{'attach'} ?
		      $self->ui_checkbox("mail_def", 1, $self->{'text_hash'}->{'edit_mailfile'},
				   $self->{'sched'}->{'mailfile'} ? 1 : 0)."\n".
		      $self->ui_textbox("mailfile", $self->{'sched'}->{'mailfile'}, 40)."\n".
		      $self->file_chooser_button("mailfile") : ""));

print $self->ui_table_hr();

if ($self->{'config_hash'}->{'upload'}) {
	# Attached files
	@{$self->{'files_array'}} = $self->list_schedule_files($self->{'sched'});
	if (@{$self->{'files_array'}}) {
		$self->{'ftable'} = $self->ui_columns_start([
			$self->{'text_hash'}->{'delete'}, $self->{'text_hash'}->{'edit_file'}, $self->{'text_hash'}->{'edit_type'} ]);
		foreach $f (@{$self->{'files_array'}}) {
			$self->{'ftable'} .= $self->ui_columns_row([
				$self->ui_checkbox("d", $f->{'id'}),
				"<a href='view.cgi?sched=$self->{'sched'}->{'id'}&id=".$self->urlize($f->{'id'})."'>".$self->html_escape($f->{'id'})."</a>",
				!$f->{'type'} ? "<tt>$f->{'file'}</tt>"
					     : $self->{'text_hash'}->{'edit_uploaded'}
				]);
			}
		$self->{'ftable'} .= $self->ui_columns_end();
		print $self->ui_table_row($self->{'text_hash'}->{'edit_files'}, $self->{'ftable'});
		}

	# Form to add a file
	print $self->ui_table_row($self->{'text_hash'}->{'edit_upload'},
		$self->ui_upload("upload", 60));
	}

print $self->ui_table_hr();

print $self->ui_table_row($self->{'text_hash'}->{'edit_enabled'},
		    $self->ui_radio("enabled", $self->{'sched'}->{'enabled'},
			      [ [ 1, $self->{'text_hash'}->{'yes'} ], [ 0, $self->{'text_hash'}->{'no'} ] ]));

@{$self->{'tm_array'}} = $self->{'sched'}->{'at'} ? localtime($self->{'sched'}->{'at'}) : ( );
if (@{$self->{'tm_array'}}) {
	$self->{'tm_array'}->[1] = sprintf("%2.2d", $self->{'tm_array'}->[1]);
	$self->{'tm_array'}->[2] = sprintf("%2.2d", $self->{'tm_array'}->[2]);
	$self->{'tm_array'}->[3] = sprintf("%2.2d", $self->{'tm_array'}->[3]);
	$self->{'tm_array'}->[4] += 1;
	$self->{'tm_array'}->[5] += 1900;
	}
print $self->ui_table_row($self->{'text_hash'}->{'edit_mode'},
		    $self->ui_oneradio("mode", 1, $self->{'text_hash'}->{'edit_at'},
				 $self->{'sched'}->{'at'} ? 1 : 0)."\n".
		     $self->ui_textbox("hour", $self->{'tm_array'}->[2], 3).":".
		     $self->ui_textbox("min", $self->{'tm_array'}->[1], 3)." &nbsp;&nbsp;&nbsp; ".
		     $self->ui_date_input($self->{'tm_array'}->[3], $self->{'tm_array'}->[4], $self->{'tm_array'}->[5],
				    "day", "month", "year")." ".
		     $self->date_chooser_button("day", "month", "year")."<br>".
		    $self->ui_oneradio("mode", 0, $self->{'text_hash'}->{'edit_cron'},
				 $self->{'sched'}->{'at'} ? 0 : 1));

print "<tr> <td colspan=2><table border width=100%>\n";
$main::cron_object->show_times_input($self->{'sched'});
print "</table></td> </tr>\n";

print $self->ui_table_end();
print $self->ui_form_end($self->{'in_hash'}->{'new'} ? [ [ "create", $self->{'text_hash'}->{'create'} ] ] :
				[ [ "save", $self->{'text_hash'}->{'save'} ],
				  [ "delete", $self->{'text_hash'}->{'delete'} ] ], "100%");

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
1;
		
}


1;

