#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Show all scheduled messages

&ModuleLoader::preload_module('schedule_class', "schedule::ScheduleLib");
$self = new schedule::ScheduleLib:: 'schedule_class',%$self;

$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", undef, 1, 1);

@{$self->{'scheds_array'}} = $self->list_schedules();

# Apply selected sort mode
if ($self->{'userconfig_hash'}->{'sort_mode'} == 0) {
	@{$self->{'scheds_array'}} = sort { $a->{'id'} <=> $b->{'id'} } @{$self->{'scheds_array'}};
	}
elsif ($self->{'userconfig_hash'}->{'sort_mode'} == 1) {
	@{$self->{'scheds_array'}} = sort { &next_run($a) <=> &next_run($b) } @{$self->{'scheds_array'}};
	}
else {
	@{$self->{'scheds_array'}} = sort { $a->{'to'} cmp $b->{'to'} } @{$self->{'scheds_array'}};
	}

@{$self->{'links_array'}} = ( $self->select_all_link("d"),
	   $self->select_invert_link("d"),
	   "<a href='edit.cgi?new=1'>$self->{'text_hash'}->{'index_add'}</a>" );

if (@{$self->{'scheds_array'}}) {
	print $self->ui_form_start("delete.cgi", "post");
	@{$self->{'tds_array'}} = ( "width=5" );
	print $self->ui_links_row(\@{$self->{'links_array'}});
	print $self->ui_columns_start([ "",
				  $self->{'text_hash'}->{'index_subject'},
				  $self->{'text_hash'}->{'index_when'},
				  $self->{'text_hash'}->{'index_to'},
				  $self->{'text_hash'}->{'index_enabled'} ], 100, 0, \@{$self->{'tds_array'}});
	foreach $s (@{$self->{'scheds_array'}}) {
		if ($s->{'at'}) {
			$self->{'when'} = localtime($s->{'at'});
			}
		else {
			$self->{'when'} = $main::cron_object->when_text($s, 1);
			}
		@{$self->{'to_array'}} = ( );
		if ($s->{'to'}) {
			push(@{$self->{'to_array'}}, map { $_->[0] }
				      $main::mailbox_object->split_addresses($s->{'to'}));
			}
		else {
			push(@{$self->{'to_array'}}, $self->{'text_hash'}->{'index_self'});
			}
		push(@{$self->{'to_array'}}, map { $_->[0] }
			      $main::mailbox_object->split_addresses($s->{'cc'}),
			      $main::mailbox_object->split_addresses($s->{'bcc'}));
		print $self->ui_checked_columns_row([
			"<a href='edit.cgi?id=$s->{'id'}'>".
		        $s->{'subject'}."</a>",
			$self->{'when'},
			$self->html_escape(join(", ", @{$self->{'to_array'}})),
			$s->{'at'} &&
			 $s->{'ran'} >= $s->{'at'} ? $self->{'text_hash'}->{'index_ran'} :
			$s->{'enabled'} ? $self->{'text_hash'}->{'yes'}
					: $self->{'text_hash'}->{'no'} ], \@{$self->{'tds_array'}},
			"d", $s->{'id'});
		$self->{'sent'}++ if ($s->{'at'} && $s->{'ran'} >= $s->{'at'});
		}
	print $self->ui_columns_end();
	print $self->ui_links_row(\@{$self->{'links_array'}});
	print $self->ui_form_end([ [ "delete", $self->{'text_hash'}->{'index_delete'} ],
			     [ "disable", $self->{'text_hash'}->{'index_disable'} ],
			     [ "enable", $self->{'text_hash'}->{'index_enable'} ] ]);
	}
else {
	print "<b>$self->{'text_hash'}->{'index_none'}</b><p>\n";
	print $self->ui_links_row([ $self->{'links_array'}->[2] ]);
	}

if ($self->{'sent'}) {
	print "<hr>\n";
	print $self->ui_buttons_start();
	print $self->ui_buttons_row("clear.cgi", $self->{'text_hash'}->{'index_clear'},
					   $self->{'text_hash'}->{'index_cleardesc'});
	print $self->ui_buttons_end();
	}

$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});

1;
		
}


1;

