#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Create, update or delete a scheduled mail

&ModuleLoader::preload_module('schedule_class', "schedule::ScheduleLib");
$self = new schedule::ScheduleLib:: 'schedule_class',%$self;

$self->ReadParseMime();
if (!$self->{'in_hash'}->{'new'}) {
	$self->{'sched'} = $self->get_schedule($self->{'in_hash'}->{'id'});
	$self->{'cron'} = $self->find_cron_job($self->{'sched'});
	}
else {
	$self->{'sched'} = { };
	}

if ($self->{'in_hash'}->{'delete'}) {
	# Just remove schedule
	$self->delete_schedule($self->{'sched'});
	$main::cron_object->delete_cron_job($self->{'cron'}) if ($self->{'cron'});
	}
else {
	# Validate and store inputs
	$self->error_setup($self->{'text_hash'}->{'save_err'});
	$self->{'in_hash'}->{'subject'} || $self->error($self->{'text_hash'}->{'save_esubject'});
	$self->{'sched'}->{'subject'} = $self->{'in_hash'}->{'subject'};
	$self->{'in_hash'}->{'mail'} =~ s/\r//g;
	if ($self->{'in_hash'}->{'mail'} =~ /\S/ && $self->{'in_hash'}->{'mail'} !~ /\n$/) {
		$self->{'in_hash'}->{'mail'} .= "\n";
		}
	$self->{'sched'}->{'mail'} = $self->{'in_hash'}->{'mail'};
	if ($self->{'config_hash'}->{'attach'}) {
		if ($self->{'in_hash'}->{'mail_def'}) {
			-r $self->{'in_hash'}->{'mailfile'} || $self->error($self->{'text_hash'}->{'save_emailfile'});
			$self->{'sched'}->{'mailfile'} = $self->{'in_hash'}->{'mailfile'};
			}
		else {
			$self->{'sched'}->{'mailfile'} = undef;
			}
		}
	if ($self->{'in_hash'}->{'to_def'}) {
		delete($self->{'sched'}->{'to'});
		}
	else {
		$self->{'in_hash'}->{'to'} || $self->error($self->{'text_hash'}->{'save_eto'});
		$self->{'sched'}->{'to'} = $self->{'in_hash'}->{'to'};
		}
	if ($main::mailbox_object->{'config_hash'}->{'edit_from'} == 1) {
		if ($self->{'in_hash'}->{'from_def'}) {
			delete($self->{'sched'}->{'from'});
			}
		else {
			$self->{'in_hash'}->{'from'} || $self->error($self->{'text_hash'}->{'save_efrom'});
			$self->{'sched'}->{'from'} = $self->{'in_hash'}->{'from'};
			}
		}
	$self->{'sched'}->{'cc'} = $self->{'in_hash'}->{'cc'};
	$self->{'sched'}->{'bcc'} = $self->{'in_hash'}->{'bcc'};
	$self->{'sched'}->{'enabled'} = $self->{'in_hash'}->{'enabled'};
	if ($self->{'in_hash'}->{'mode'} == 1) {
		# At time
		eval { $self->{'sched'}->{'at'} = timelocal(0, $self->{'in_hash'}->{'min'}, $self->{'in_hash'}->{'hour'},
						  $self->{'in_hash'}->{'day'}, $self->{'in_hash'}->{'month'}-1, 
						  $self->{'in_hash'}->{'year'}-1900) };
		$@ && $self->error($self->{'text_hash'}->{'save_eat'});
		}
	else {
		# Cron time
		delete($self->{'sched'}->{'at'});
		$main::cron_object->parse_times_input($self->{'sched'}, \%{$self->{'in_hash'}});
		}

	# Create or update the schedule
	$self->save_schedule($self->{'sched'});
	$main::cron_object->delete_cron_job($self->{'cron'}) if ($self->{'cron'});
	if (!$self->{'sched'}->{'at'}) {
		$self->{'job'} = { "command" => "$self->{'cron_cmd'} $self->{'sched'}->{'id'}",
			 "user" => $self->{'remote_user'},
			 "active" => 1,
			 "special" => $self->{'sched'}->{'special'},
			 "mins" => $self->{'sched'}->{'mins'},
			 "hours" => $self->{'sched'}->{'hours'},
			 "days" => $self->{'sched'}->{'days'},
			 "months" => $self->{'sched'}->{'months'},
			 "weekdays" => $self->{'sched'}->{'weekdays'} };
		$main::cron_object->create_cron_job($self->{'job'});
		}

	if ($self->{'config_hash'}->{'upload'}) {
		# Add an attached file
		if ($self->{'in_hash'}->{'upload'}) {
			$self->create_schedule_file($self->{'sched'}, $self->{'in_hash'}->{'upload'}, $self->{'in_hash'}->{'upload_filename'} || "unknown");
			}

		# Remove deleted files
		@{$self->{'files_array'}} = $self->list_schedule_files($self->{'sched'});
		foreach $d (split(/\0/, $self->{'in_hash'}->{'d'})) {
			($self->{'file'}) = grep { $_->{'id'} eq $d } @{$self->{'files_array'}};
			$self->delete_schedule_file($self->{'sched'}, $self->{'file'}) if ($self->{'file'});
			}
		}
	}

# If this is a one-off job, make sure a cron job exists to detect them
$self->create_atmode_job();

$self->redirect("");

1;
		
}


1;

