#!/usr/bin/perl

&MAIN();

 sub MAIN {
# index.cgi
# Show the shell user interface

&ModuleLoader::preload_module('shell_class', "shell::ShellLib");
$self = new shell::ShellLib:: 'shell_class',%$self;

%{$self->{'access_hash'}} = $self->get_module_acl();
$self->ReadParseMime() if ($ENV{'REQUEST_METHOD'} ne 'GET');
$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", undef,
		 $self->{'module_info_hash'}->{'usermin'} ? 0 : 1, 1,
		 undef, undef, undef,
	"onLoad='window.scroll(0, 10000); document.forms[0].cmd.focus()'");

$self->{'prevfile'} = "$self->{'module_config_directory'}/previous.$self->{'remote_user'}";
if ($self->{'in_hash'}->{'clearcmds'}) {
	$self->lock_file($self->{'prevfile'});
	unlink($self->{'prevfile'});
	$self->unlock_file($self->{'prevfile'});
	$self->webmin_log("clear");
	}
else {
	open(PREVFILE, $self->{'prevfile'});
	chop(@{$self->{'previous_array'}} = <PREVFILE>);
	close(PREVFILE);
	}
$self->{'cmd'} = $self->{'in_hash'}->{'doprev'} ? $self->{'in_hash'}->{'pcmd'} : $self->{'in_hash'}->{'cmd'};

if ($self->{'in_hash'}->{'pwd'}) {
	$self->{'pwd'} = $self->{'in_hash'}->{'pwd'};
	}
else {
	if ($self->{'gconfig_hash'}->{'os_type'} eq 'windows') {
		# Initial directory is c:/
		$self->{'pwd'} = "c:/";
		}
	else {
		# Initial directory is user's home
		local @uinfo = getpwnam($self->{'access_hash'}->{'user'} || $self->{'remote_user'});
		$self->{'pwd'} = scalar(@uinfo) && -d $uinfo[7] ? $uinfo[7] : "/";
		}
	}
if (!$self->{'in_hash'}->{'clear'}) {
	$self->{'history'} = $self->un_urlize($self->{'in_hash'}->{'history'});
	if ($self->{'cmd'}) {
		# Execute the latest command
		$self->{'fullcmd'} = $self->{'cmd'};
		$self->{'ok'} = chdir($self->{'pwd'});
		$self->{'history'} .= "<b>&gt; ".$self->html_escape($self->{'cmd'}, 1)."</b>\n";
		if ($self->{'cmd'} =~ /^cd\s+"([^"]+)"\s*(;?\s*(.*))$/ ||
		    $self->{'cmd'} =~ /^cd\s+'([^']+)'\s*(;?\s*(.*))$/ ||
		    $self->{'cmd'} =~ /^cd\s+([^; ]*)\s*(;?\s*(.*))$/) {
			$self->{'cmd'} = undef;
			if (!chdir($1)) {
				$self->{'history'} .= $self->html_escape("$1: $!\n", 1);
				}
			else {
				$self->{'cmd'} = $3 if ($2);
				$self->{'pwd'} = $self->get_current_dir();
				}
			}
		if ($self->{'cmd'}) {
			local $user = $self->{'access_hash'}->{'user'} || $self->{'remote_user'};
			$self->clean_environment() if ($self->{'config_hash'}->{'clear_envs'});
			delete($ENV{'SCRIPT_NAME'});	# So that called Webmin
							# programs get the right
							# module, not this one!
			if ($self->supports_users()) {
				$self->{'out'} = $self->backquote_logged(
				    $self->command_as_user($user, 0, $self->{'cmd'})." 2>&1");
				}
			else {
				$self->{'out'} = $self->backquote_logged("($self->{'cmd'}) 2>&1");
				}
			$self->reset_environment() if ($self->{'config_hash'}->{'clear_envs'});
			$self->{'out'} = $self->html_escape($self->{'out'}, 1);
			$self->{'history'} .= $self->{'out'};
			}
		@{$self->{'previous_array'}} = $self->unique(@{$self->{'previous_array'}}, $self->{'fullcmd'});
		$self->lock_file($self->{'prevfile'});
		$self->open_tempfile(PREVFILE, ">>$self->{'prevfile'}");
		$self->print_tempfile(PREVFILE, $self->{'fullcmd'},"\n");
		$self->close_tempfile(PREVFILE);
		$self->unlock_file($self->{'prevfile'});
		$self->webmin_log("run", undef, undef, { 'cmd' => $self->{'fullcmd'} });
		}
	}

# Show the history and command input
if ($self->{'history'}) {
	print "<table border width=100%>\n";
	print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'index_history'}</b></td> </tr>\n";
	print "<tr $self->{'cb'}> <td><pre>";
	print $self->{'history'};
	print "</pre></td></tr> </table><p>\n";
	print "<hr>\n";
	}

print "$self->{'text_hash'}->{'index_desc'}<br>\n";
print "<form action=index.cgi method=post enctype=multipart/form-data>\n";
print "<table width=100%><tr>\n";
print "<td><input type=submit value='$self->{'text_hash'}->{'index_ok'}'></td>\n";
print "<td><input name=cmd size=50></td>\n";
print "<td align=right><input type=submit name=clear ",
      "value='$self->{'text_hash'}->{'index_clear'}'></td>\n";
print "</tr>\n";
print "<input type=hidden name=pwd value='$self->{'pwd'}'>\n";
print "<input type=hidden name=history value='",$self->urlize($self->{'history'}),"'>\n";
foreach $p (@{$self->{'previous_array'}}) {
	print "<input type=hidden name=previous value='",
	      $self->html_escape($p, 1),"'>\n";
	}

if (@{$self->{'previous_array'}}) {
	print "<tr> <td><input name=doprev type=submit value='$self->{'text_hash'}->{'index_pok'}'></td>\n";
	print "<td><select name=pcmd>\n";
	foreach $p (reverse(@{$self->{'previous_array'}})) {
		printf "<option value='%s'>%s\n",
			$self->html_escape($p, 1),
			$self->html_escape($p, 1);
		}
	print "</select>\n";
	print "<input type=button name=movecmd ",
	      "value='$self->{'text_hash'}->{'index_edit'}' onClick='cmd.value = pcmd.options[pcmd.selectedIndex].value'>\n";
	print "</td> <td align=right><input type=submit name=clearcmds ",
	      "value='$self->{'text_hash'}->{'index_clearcmds'}'></td> </tr>\n";
	}
print "</table>\n";
print "</form>\n";

#$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});
$self->ui_print_footer("$self->{'text_hash'}->{'index_mainpage_url'}", $self->{'text_hash'}->{'index_mainpage'} );
1;
		
}


1;

