#!/usr/bin/perl

&MAIN();

 sub MAIN {
# index.cgi
# Display a menu of spamassassin config category icons

&ModuleLoader::preload_module('spam_class', "spam::SpamLib");
$self = new spam::SpamLib:: 'spam_class',%$self;

$self->{'hsl'} = $self->{'module_info_hash'}->{'usermin'} ? undef :
		$self->help_search_link("spamassassin", "perl", "google");

if (!$self->has_command($self->{'config_hash'}->{'spamassassin'}) ||
    (!$self->{'module_info_hash'}->{'usermin'} && !($self->{'vers'} = $self->get_spamassassin_version(\$self->{'out'})))) {
	# Program not found
	$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", undef, 1, 1,
			 undef, $self->{'hsl'});

	if ($self->{'module_info_hash'}->{'usermin'}) {
		print $self->text('index_ecmd2',
			    "<tt>$self->{'config_hash'}->{'spamassassin'}</tt>"),"<p>\n";
		}
	else {
		print $self->text('index_ecmd', "<tt>$self->{'config_hash'}->{'spamassassin'}</tt>",
		    "$self->{'gconfig_hash'}->{'webprefix'}/config.cgi?$self->{'module_name'}"),"<p>\n";

		# Offer to install package
		$self->foreign_require("software", "software-lib.pl");
		$self->{'lnk'} = $main::software_object->missing_install_link(
				"spamassassin", $self->{'text_hash'}->{'index_spamassassin'},
				"../$self->{'module_name'}/", $self->{'text_hash'}->{'index_title'});
		if ($self->{'lnk'}) {
			print $self->{'lnk'},"<p>\n";
			}
		elsif ($self->foreign_available("cpan")) {
			# Offer to install perl module
			$self->{'modname'} = "Mail::SpamAssassin";
			print $self->text('index_cpan', "<tt>$self->{'modname'}</tt>",
				    "../cpan/download.cgi?source=3&cpan=$self->{'modname'}&mode=2&return=/$self->{'module_name'}/&returndesc=".$self->urlize($self->{'module_info_hash'}->{'desc'})),"<p>\n";
			}
		}
	}
else {
	$self->{'vtext'} = $self->{'module_info_hash'}->{'usermin'} ? undef :
			$self->text('index_version', $self->{'vers'});
	$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", undef, 1, 1, undef,
			 $self->{'hsl'}, undef, undef, $self->{'vtext'});

	if (!-r $self->{'local_cf'} && !-d $self->{'local_cf'} && !$self->{'module_info_hash'}->{'usermin'}) {
		# Config not found
		print "<p>",$self->text('index_econfig',
			"<tt>$self->{'local_cf'}</tt>",
			"$self->{'gconfig_hash'}->{'webprefix'}/config.cgi?$self->{'module_name'}"),
			"<p>\n";
		}
	else {
		# Work out of SpamAssassin is enabled in procmail
		if ($self->{'warn_procmail'} && $self->foreign_check("procmail")) {
			$self->foreign_require("procmail", "procmail-lib.pl");
			$self->{'spam_enabled'} = 0;	# Found call to spamassassin
			$self->{'delivery_enabled'} = 0;	# Found X-Spam: header rule
			@{$self->{'pmrcs_array'}} = $self->get_procmailrc();
			foreach $pmrc (@{$self->{'pmrcs_array'}}) {
				local @recipes =
					$main::procmail_object->parse_procmail_file($pmrc);
				local $isglobal = $pmrc eq
					          $self->{'config_hash'}->{'global_procmailrc'};
				if ($self->find_spam_recipe(\@recipes)) {
					$self->{'spam_enabled'} ||= 1;
					}
				if ($self->find_file_recipe(\@recipes)) {
					if ($isglobal) {
						# Enabled globally, and so
						# cannot be changed by user
						$self->{'delivery_enabled'} ||= -2;
						}
					else {
						$self->{'delivery_enabled'} ||= 1;
						}
					}
				if ($self->find_virtualmin_recipe(\@recipes)) {
					# Controlled by Virtualmin
					if ($isglobal &&
					    $self->find_force_default_receipe(
					      \@recipes)) {
						# User .procmailrc files are
						# prevented
						$self->{'spam_enabled'} ||= -2;
						$self->{'delivery_enabled'} ||= -2;
						}
					else {
						# Users can have a .procmailrc
						$self->{'spam_enabled'} ||= -2;
						$self->{'delivery_enabled'} ||= 1;
						}
					}
				}
			}
		else {
			# don't know, or checking disabled
			$self->{'spam_enabled'} = -1;
			$self->{'delivery_enabled'} = -1;
			}
		if ($self->{'spam_enabled'} == 0) {
			if ($self->{'module_info_hash'}->{'usermin'}) {
				print $self->text('index_warn_usermin',
					    "<tt>$self->{'pmrcs_array'}->[0]</tt>",
					    "<tt>$self->{'pmrcs_array'}->[1]</tt>"),"<p>\n";
				}
			else {
				print $self->text('index_warn_webmin',
					    "<tt>$self->{'pmrcs_array'}->[0]</tt>"),"<p>\n";
				}
			}

		# Check if razor is set up
		if ($self->{'module_info_hash'}->{'usermin'}) {
			$self->{'razor'} = 1
				if (-r "$self->{'remote_user_info_array'}->[7]/.razor/identity");
			}

		# Show icons
		@{$self->{'pages_array'}} = ( 'white', 'score', 'report', 'user' );
		push(@{$self->{'pages_array'}}, 'simple') if (!$self->{'module_info_hash'}->{'usermin'} ||
					   $self->find_default("allow_user_rules",0));
		push(@{$self->{'pages_array'}}, 'priv') if (!$self->{'module_info_hash'}->{'usermin'});
		push(@{$self->{'pages_array'}}, 'mail') if ($self->{'module_info_hash'}->{'usermin'} &&
					 $self->{'userconfig_hash'}->{'spam_file'});
		push(@{$self->{'pages_array'}}, 'razor') if (!$self->{'razor'} && $self->{'module_info_hash'}->{'usermin'});
		push(@{$self->{'pages_array'}}, 'setup') if ($self->{'spam_enabled'} == 0);
		push(@{$self->{'pages_array'}}, 'procmail') if ($self->{'delivery_enabled'} == 1);
		@{$self->{'pages_array'}} = grep { $self->can_use_page($_) } @{$self->{'pages_array'}};
		$self->{'sfolder'} = $self->{'module_info_hash'}->{'usermin'} ? $self->spam_file_folder()
						   : undef;
		@{$self->{'links_array'}} = map { $_ eq "mail" && $self->{'sfolder'} ? "../mailbox/index.cgi?folder=$self->{'sfolder'}->{'index'}" : "edit_${_}.cgi" } @{$self->{'pages_array'}};
		@{$self->{'icons_array'}} = map { "images/${_}.gif" } @{$self->{'pages_array'}};
		@{$self->{'titles_array'}} = map { $self->{'text_hash'}->{"${_}_title"} } @{$self->{'pages_array'}};
		$self->icons_table(\@{$self->{'links_array'}}, \@{$self->{'titles_array'}}, \@{$self->{'icons_array'}});

		# Show buttons for HUPing spamd processes (if any)
		if (!$self->{'module_info_hash'}->{'usermin'} &&
		    (@{$self->{'pids_array'}} = $self->get_process_pids())) {
			print "<hr>\n";
			print "<form action=apply.cgi>\n";
			print "<table>\n";
			print "<tr> <td><input type=submit ",
			      "value='$self->{'text_hash'}->{'index_apply'}'></td>\n";
			print "<td>",$self->text('index_applydesc',
				"<tt>".join(" and ", $self->unique(
				map { $_->[1] } @{$self->{'pids_array'}}))."</tt>"),"</td>\n";
			print "</table>\n";
			}
		}
	}

$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});

1;
		
}


1;

