#!/usr/bin/perl

&MAIN();

 sub MAIN {
# mail_search.cgi
# Find mail messages matching some pattern

&ModuleLoader::preload_module('spam_class', "spam::SpamLib");
$self = new spam::SpamLib:: 'spam_class',%$self;

$self->foreign_require("mailbox", "mailbox-lib.pl");
$self->ReadParse();
if ($self->{'in_hash'}->{'simple'}) {
	# Make sure a search was entered
	$self->{'in_hash'}->{'search'} ne "" || $self->error($main::mailbox_object->{'text_hash'}->{'search_ematch'});
	}
elsif (defined($self->{'in_hash'}->{'score'})) {
	# Make sure a score was entered
	$self->{'in_hash'}->{'score'} =~ /^\d+$/ || $self->error($self->{'text_hash'}->{'search_escore'});
	}
else {
	# Validate search fields
	for($i=0; defined($self->{'in_hash'}->{"field_$i"}); $i++) {
		if ($self->{'in_hash'}->{"field_$i"}) {
			$self->{'in_hash'}->{"what_$i"} || $self->error($main::mailbox_object->text('search_ewhat', $i+1));
			$self->{'neg'} = $self->{'in_hash'}->{"neg_$i"} ? "!" : "";
			push(@{$self->{'fields_array'}}, [ $self->{'neg'}.$self->{'in_hash'}->{"field_$i"}, $self->{'in_hash'}->{"what_$i"} ]);
			}
		}
	@{$self->{'fields_array'}} || $self->error($main::mailbox_object->{'text_hash'}->{'search_enone'});
	}

$self->ui_print_header(undef, $main::mailbox_object->{'text_hash'}->{'search_title'}, "");
$self->{'folder'} = $self->spam_file_folder();

if ($self->{'in_hash'}->{'simple'}) {
	# Just search by Subject and From in one folder, or body, depending
	# on preferences
	($self->{'mode'}, $self->{'words'}) = $main::mailbox_object->parse_boolean($self->{'in_hash'}->{'search'});
	if ($self->{'userconfig_hash'}->{'search_body'} && $self->{'mode'} != 2) {
		# Do an 'and' or 'or' search of body
		@{$self->{'searchlist_array'}} = map { [ 'body', $_ ] } @{$self->{'words'}};
		@{$self->{'rv_array'}} = $main::mailbox_object->mailbox_search_mail(\@{$self->{'searchlist_array'}}, $self->{'mode'},
						    $self->{'folder'});
		}
	elsif ($self->{'mode'} == 0) {
		# Can just do a single 'or' search
		@{$self->{'searchlist_array'}} = map { ( [ 'subject', $_ ],
				      [ 'from', $_ ] ) } @{$self->{'words'}};
		@{$self->{'rv_array'}} = $main::mailbox_object->mailbox_search_mail(\@{$self->{'searchlist_array'}}, 0, $self->{'folder'});
		}
	elsif ($self->{'mode'} == 1) {
		# Need to do two 'and' searches and combine
		@{$self->{'searchlist1_array'}} = map { ( [ 'subject', $_ ] ) } @{$self->{'words'}};
		@{$self->{'rv1_array'}} = $main::mailbox_object->mailbox_search_mail(\@{$self->{'searchlist1_array'}}, 1, $self->{'folder'});
		@{$self->{'searchlist2_array'}} = map { ( [ 'from', $_ ] ) } @{$self->{'words'}};
		@{$self->{'rv2_array'}} = $main::mailbox_object->mailbox_search_mail(\@{$self->{'searchlist2_array'}}, 1, $self->{'folder'});
		@{$self->{'rv_array'}} = @{$self->{'rv1_array'}};
		%{$self->{'gotidx_hash'}} = map { $_->{'idx'}, 1 } @{$self->{'rv_array'}};
		foreach $mail (@{$self->{'rv2_array'}}) {
			push(@{$self->{'rv_array'}}, $mail) if (!$self->{'gotidx_hash'}->{$mail->{'idx'}});
			}
		}
	else {
		$self->error($main::mailbox_object->{'text_hash'}->{'search_eboolean'});
		}
	print "<p><b>",$main::mailbox_object->text('search_results2', scalar(@{$self->{'rv_array'}}),
			     "<tt>$self->{'in_hash'}->{'search'}</tt>"),"</b><p>\n";
	}
elsif (defined($self->{'in_hash'}->{'score'})) {
	# Search by score
	@{$self->{'rv_array'}} = $main::mailbox_object->mailbox_search_mail(
		[ [ 'x-spam-level', '*' x $self->{'in_hash'}->{'score'} ] ], 0, $self->{'folder'});
	print "<p><b>",$self->text('search_results5', scalar(@{$self->{'rv_array'}}), $self->{'in_hash'}->{'score'}),"</b><p>\n";
	}
else {
	# Complex search
	@{$self->{'rv_array'}} = $main::mailbox_object->mailbox_search_mail(\@{$self->{'fields_array'}}, $self->{'in_hash'}->{'and'}, $self->{'folder'});
	print "<p><b>",$main::mailbox_object->text('search_results4', scalar(@{$self->{'rv_array'}})),"</b><p>\n";
	}
@{$self->{'rv_array'}} = reverse(@{$self->{'rv_array'}});
$main::mailbox_object->set_sort_indexes($self->{'folder'}, \@{$self->{'rv_array'}});

print "<form action=process.cgi method=post>\n";
if ($main::mailbox_object->{'userconfig_hash'}->{'top_buttons'} && @{$self->{'rv_array'}}) {
	$self->show_buttons(1);
	print "<a href='' onClick='document.forms[0].d.checked = true; for(i=0; i<document.forms[0].d.length; i++) { document.forms[0].d[i].checked = true; } return false'>$main::mailbox_object->{'text_hash'}->{'mail_all'}</a>&nbsp;\n";
	print "<a href='' onClick='document.forms[0].d.checked = !document.forms[0].d.checked; for(i=0; i<document.forms[0].d.length; i++) { document.forms[0].d[i].checked = !document.forms[0].d[i].checked; } return false'>$main::mailbox_object->{'text_hash'}->{'mail_invert'}</a>&nbsp;\n";
	}
if (@{$self->{'rv_array'}}) {
	print "<table border width=100%>\n";
	print "<tr $self->{'tb'}> <td>&nbsp;</td> ",
	      "<td><b>$main::mailbox_object->{'text_hash'}->{'mail_from'}</b></td> ",
	      "<td><b>$main::mailbox_object->{'text_hash'}->{'mail_date'}</b></td> ",
	      "<td><b>$main::mailbox_object->{'text_hash'}->{'mail_size'}</b></td> ",
	      "<td><b>$self->{'text_hash'}->{'mail_level'}</b></td> ",
	      "<td><b>$main::mailbox_object->{'text_hash'}->{'mail_subject'}</b></td> </tr>\n";
	}
foreach $m (@{$self->{'rv_array'}}) {
	local $idx = $m->{'sortidx'};
	print "<tr $self->{'cb'}>\n";
	print "<td><input type=checkbox name=d value=$idx></td>\n";
	print "<td nowrap><a href='view_mail.cgi?idx=$idx'>",
	      $main::mailbox_object->simplify_from($m->{'header'}->{$self->{'showto'}?'to':'from'}),"</td>\n";
	print "<td nowrap>",$main::mailbox_object->simplify_date($m->{'header'}->{'date'}),"</td>\n";
	print "<td nowrap>",int($m->{'size'}/1000)+1," kB","</td>\n";
	print "<td nowrap>",length($m->{'header'}->{'x-spam-level'}),"</td>\n";
	print "<td><table border=0 cellpadding=0 cellspacing=0 width=100%>",
	      "<tr><td>",$main::mailbox_object->simplify_subject($m->{'header'}->{'subject'}),
	      "</td> <td align=right>";
	if ($m->{'header'}->{'content-type'} =~ /multipart\/\S+/i) {
		print "<img src=/mailbox/images/attach.gif>";
		}
	local $p = int($m->{'header'}->{'x-priority'});
	if ($p == 1) {
		print "&nbsp;<img src=images/p1.gif>";
		}
	elsif ($p == 2) {
		print "&nbsp;<img src=images/p2.gif>";
		}
	print "</td></tr></table></td> </tr>\n";
	}
if (@{$self->{'rv_array'}}) {
	print "</table>\n";
	print "<a href='' onClick='document.forms[0].d.checked = true; for(i=0; i<document.forms[0].d.length; i++) { document.forms[0].d[i].checked = true; } return false'>$main::mailbox_object->{'text_hash'}->{'mail_all'}</a>&nbsp;\n";
	print "<a href='' onClick='document.forms[0].d.checked = !document.forms[0].d.checked; for(i=0; i<document.forms[0].d.length; i++) { document.forms[0].d[i].checked = !document.forms[0].d[i].checked; } return false'>$main::mailbox_object->{'text_hash'}->{'mail_invert'}</a>&nbsp;\n";
	$self->show_buttons(2);
	}
else {
	print "<b>$self->{'text_hash'}->{'search_none'}</b> <p>\n";
	}
print "</form><p>\n";

$self->ui_print_footer("mail.cgi", $self->{'text_hash'}->{'mail_return'});

1;
		
}


1;

