#!/usr/bin/perl

&MAIN();

 sub MAIN {
# process.cgi
# Delete, move or whitelist messages

&ModuleLoader::preload_module('spam_class', "spam::SpamLib");
$self = new spam::SpamLib:: 'spam_class',%$self;

$self->foreign_require("mailbox", "mailbox-lib.pl");
$self->{'folder'} = $self->spam_file_folder();
$self->disable_indexing($self->{'folder'});
$self->ReadParse();

@{$self->{'delete_array'}} = sort { $a <=> $b } split(/\0/, $self->{'in_hash'}->{'d'});
@{$self->{'mail_array'}} = $main::mailbox_object->mailbox_list_mails_sorted($self->{'delete_array'}->[0], $self->{'delete_array'}->[@{$self->{'delete_array'}}-1],
				     $self->{'folder'});
foreach $d (@{$self->{'delete_array'}}) {
	push(@{$self->{'delmail_array'}}, $self->{'mail_array'}->[$d]);
	}

if ($self->{'in_hash'}->{'inbox'} || $self->{'in_hash'}->{'whitelist'} || $self->{'in_hash'}->{'ham'}) {
	# Move mails to inbox
	@{$self->{'delete_array'}} || $self->error($main::mailbox_object->{'text_hash'}->{'delete_emnone'});
	@{$self->{'folders_array'}} = $main::mailbox_object->list_folders();
	($self->{'inbox'}) = grep { $_->{'inbox'} } @{$self->{'folders_array'}};
	if ($self->{'userconfig_hash'}->{'inbox'}) {
		$self->{'mfolder'} = $main::mailbox_object->find_named_folder(
				$self->{'userconfig_hash'}->{'inbox'}, \@{$self->{'folders_array'}});
		}
	$self->{'mfolder'} ||= $self->{'inbox'};
	foreach $d (@{$self->{'delete_array'}}) {
		push(@{$self->{'movemail_array'}}, $self->{'mail_array'}->[$d]);
		push(@{$self->{'addrs_array'}}, map { $_->[0] } $main::mailbox_object->split_addresses($self->{'mail_array'}->[$d]->{'header'}->{'from'}));
		}

	# Pass through spamassassin to remove headers, then add to Inbox
	$main::mailbox_object->lock_folder($self->{'mfolder'});
	foreach $d (@{$self->{'movemail_array'}}) {
		local $temp = $self->transname();
		$main::mailbox_object->send_mail($d, $temp);
		local $newmail = $main::mailbox_object->read_mail_file("$self->{'config_hash'}->{'spamassassin'} -d <$temp |");
		$newmail || $self->error($self->{'text_hash'}->{'process_eclean'});
		$main::mailbox_object->write_mail_folder($newmail, $self->{'mfolder'});
		unlink($temp);
		}
	$main::mailbox_object->unlock_folder($self->{'mfolder'});

	# Delete from spam folder
	$main::mailbox_object->lock_folder($self->{'folder'});
	$main::mailbox_object->mailbox_delete_mail($self->{'folder'}, $self->{'mfolder'}, @{$self->{'movemail_array'}});
	$main::mailbox_object->unlock_folder($self->{'folder'});
	}
if ($self->{'in_hash'}->{'whitelist'}) {
	# Add senders to whitelist
	foreach $d (@{$self->{'delete_array'}}) {
		push(@{$self->{'addrs_array'}}, map { $_->[0] } $main::mailbox_object->split_addresses($self->{'mail_array'}->[$d]->{'header'}->{'from'}));
		}
	$self->lock_file($self->{'local_cf'});
	$self->{'conf'} = $self->get_config();
	@{$self->{'from_array'}} = map { @{$_->{'words'}} } $self->find("whitelist_from", $self->{'conf'});
	%{$self->{'already_hash'}} = map { $_, 1 } @{$self->{'from_array'}};
	@{$self->{'newaddrs_array'}} = grep { !$self->{'already_hash'}->{$_} } $self->unique(@{$self->{'addrs_array'}});
	push(@{$self->{'from_array'}}, @{$self->{'newaddrs_array'}});
	$self->save_directives($self->{'conf'}, 'whitelist_from', \@{$self->{'from_array'}}, 1);
	$self->flush_file_lines();
	$self->unlock_file($self->{'local_cf'});
	}
if ($self->{'in_hash'}->{'ham'}) {
	# Report to spamassassin as ham
	local $temp = $self->transname();
	foreach $d (@{$self->{'delmail_array'}}) {
		$main::mailbox_object->send_mail($d, $temp);
		local $out = `$self->{'config_hash'}->{'sa_learn'} --ham <$temp 2>&1`;
		unlink($temp);
		if ($? || $out =~ /failed/i) {
			$self->error($self->text('process_ereport',
				     "<pre>$out</pre>"));
			}
		}
	}
if ($self->{'in_hash'}->{'delete'} || $self->{'in_hash'}->{'razor'}) {
	# Delete messages
	@{$self->{'delete_array'}} || $self->error($main::mailbox_object->{'text_hash'}->{'delete_enone'});
	$main::mailbox_object->lock_folder($self->{'folder'});
	$main::mailbox_object->mailbox_delete_mail($self->{'folder'}, @{$self->{'delmail_array'}});
	$main::mailbox_object->unlock_folder($self->{'folder'});
	}
if ($self->{'in_hash'}->{'razor'}) {
	# Report to spamassassin as spam
	local $temp = $self->transname();
	foreach $d (@{$self->{'delmail_array'}}) {
		$main::mailbox_object->send_mail($d, $temp);
		local $out = `$self->{'config_hash'}->{'spamassassin'} -r <$temp 2>&1`;
		unlink($temp);
		if ($? || $out =~ /failed/i) {
			$self->error($self->text('process_ereport',
				     "<pre>$out</pre>"));
			}
		}
	}

$self->redirect("mail.cgi");

1;
		
}


1;

