#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_report.cgi
# Save report generation options

&ModuleLoader::preload_module('spam_class', "spam::SpamLib");
$self = new spam::SpamLib:: 'spam_class',%$self;

$self->error_setup($self->{'text_hash'}->{'report_err'});
$self->can_use_check("report");
$self->ReadParse();
$self->execute_before("report");
$self->lock_spam_files();
$self->{'conf'} = $self->get_config();

$self->save_directives($self->{'conf'}, 'clear_report_template',
		$self->{'in_hash'}->{'clear_report'} ? [ "" ] : [ ], 1);
$self->{'in_hash'}->{'report'} =~ s/\r//g;
@{$self->{'report_array'}} = split(/\n/, $self->{'in_hash'}->{'report'});
$self->save_directives($self->{'conf'}, 'report', \@{$self->{'report_array'}}, 1);

$self->save_directives($self->{'conf'}, 'clear_terse_report_template',
		$self->{'in_hash'}->{'clear_terse'} ? [ "" ] : [ ], 1);
$self->{'in_hash'}->{'terse'} =~ s/\r//g;
@{$self->{'terse_array'}} = split(/\n/, $self->{'in_hash'}->{'terse'});
$self->save_directives($self->{'conf'}, 'terse_report', \@{$self->{'terse_array'}}, 1);

if ($self->version_atleast(3.0)) {
	foreach $h ("subject", "from", "to") {
		if (!$self->{'in_hash'}->{"rewrite_header_${h}_def"}) {
			push(@{$self->{'rheader_array'}}, { 'name' => 'rewrite_header',
			    'value' => $h." ".$self->{'in_hash'}->{"rewrite_header_${h}"} });
			}
		}
	$self->save_directives($self->{'conf'}, "rewrite_header", \@{$self->{'rheader_array'}});
	}
else {
	$self->parse_yes_no($self->{'conf'}, "rewrite_subject");
	$self->parse_opt($self->{'conf'}, "subject_tag", undef);
	}
$self->parse_yes_no($self->{'conf'}, "report_header");
$self->parse_yes_no($self->{'conf'}, "use_terse_report");
$self->parse_yes_no($self->{'conf'}, "fold_headers");
$self->parse_yes_no($self->{'conf'}, "detailed_phrase_score");
if (!$self->version_atleast(3.0)) {
	$self->parse_yes_no($self->{'conf'}, "spam_level_stars");
	}
$self->parse_opt($self->{'conf'}, "spam_level_char", \&char_check);
$self->parse_yes_no($self->{'conf'}, "defang_mime");
$self->parse_option($self->{'conf'}, "report_safe") if (defined($self->{'in_hash'}->{'report_safe'}));

if ($self->version_atleast(3)) {
	for($i=0; defined($self->{'addfor'} = $self->{'in_hash'}->{"addfor_$i"}); $i++) {
		next if (!$self->{'addfor'});
		$self->{'addheader'} = $self->{'in_hash'}->{"addheader_$i"};
		$self->{'addtext'} = $self->{'in_hash'}->{"addtext_$i"};
		$self->{'addheader'} =~ /^\S+$/ ||
			$self->error($self->text('report_eaddheader', $i+1));
		push(@{$self->{'adds_array'}}, "$self->{'addfor'} $self->{'addheader'} $self->{'addtext'}");
		}
	$self->save_directives($self->{'conf'}, "add_header", \@{$self->{'adds_array'}}, 1);
	}

$self->flush_file_lines();
$self->unlock_spam_files();
$self->webmin_log("report");
$self->execute_after("report");
$self->redirect("");

1;
		
}

sub char_check
{
	shift if ($self == $_[0]);

$_[0] =~ /^\S$/ || $self->error($self->{'text_hash'}->{'report_echar'});
}


1;

