#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_user.cgi
# Save other user options

&ModuleLoader::preload_module('spam_class', "spam::SpamLib");
$self = new spam::SpamLib:: 'spam_class',%$self;

$self->error_setup($self->{'text_hash'}->{'user_err'});
$self->can_use_check("user");
$self->ReadParse();
$self->execute_before("user");
$self->lock_spam_files();
$self->{'conf'} = $self->get_config();

if ($self->{'in_hash'}->{'dns'} == 1) {
	$self->save_directives($self->{'conf'}, 'dns_available', [ 'yes' ], 1);
	}
elsif ($self->{'in_hash'}->{'dns'} == 0) {
	$self->save_directives($self->{'conf'}, 'dns_available', [ 'no' ], 1);
	}
elsif ($self->{'in_hash'}->{'dns'} == -1) {
	$self->save_directives($self->{'conf'}, 'dns_available', [ ], 1);
	}
else {
	local $test = "test";
	if ($self->{'in_hash'}->{'dnslist'}) {
		$test .= ": $self->{'in_hash'}->{'dnslist'}";
		}
	if ($self->{'config_hash'}->{'defaults'} && !$self->{'in_hash'}->{'dnslist'}) {
		$self->save_directives($self->{'conf'}, 'dns_available', [ ]);
		}
	else {
		$self->save_directives($self->{'conf'}, 'dns_available', [ $test ], 1);
		}
	}

$self->parse_opt($self->{'conf'}, "razor_timeout", \&check_timeout);

$self->parse_opt($self->{'conf'}, "dcc_path", \&check_path);
$self->parse_opt($self->{'conf'}, "dcc_body_max", \&check_max);
$self->parse_opt($self->{'conf'}, "dcc_timeout", \&check_timeout);
$self->parse_opt($self->{'conf'}, "dcc_fuz1_max", \&check_max);
$self->parse_opt($self->{'conf'}, "dcc_fuz2_max", \&check_max);
if (!$self->version_atleast(3)) {
	$self->parse_yes_no($self->{'conf'}, "dcc_add_header");
	}

$self->parse_opt($self->{'conf'}, "pyzor_path", \&check_path);
$self->parse_opt($self->{'conf'}, "pyzor_body_max", \&check_max);
$self->parse_opt($self->{'conf'}, "pyzor_timeout", \&check_timeout);
$self->parse_yes_no($self->{'conf'}, "pyzor_add_header");

$self->flush_file_lines();
$self->unlock_spam_files();
$self->execute_after("user");
$self->webmin_log("user");
$self->redirect("");

1;
		
}

sub check_timeout
{
	shift if ($self == $_[0]);

$_[0] =~ /^\d+$/ || $self->error($self->text('user_etimeout', $_[0]));
}

sub check_path
{
	shift if ($self == $_[0]);

$_[0] =~ /^\// && -r $_[0] || $self->error($self->text('user_epath', $_[0]));
}

sub check_max
{
	shift if ($self == $_[0]);

$_[0] =~ /^\d+$/ || $self->error($self->text('user_emax', $_[0]));
}


1;

