#!/usr/bin/perl

&MAIN();

 sub MAIN {
# setup.cgi
# Actually setup SpamAssassin for the user or globally

&ModuleLoader::preload_module('spam_class', "spam::SpamLib");
$self = new spam::SpamLib:: 'spam_class',%$self;

$self->error_setup($self->{'text_hash'}->{'setup_err'});
$self->can_use_check("setup");
$self->ReadParse();

# Validate inputs
$self->{'type'} = undef;
if ($self->{'in_hash'}->{'to'} == 0) {
	$self->{'file'} = "/dev/null";
	}
elsif ($self->{'in_hash'}->{'to'} == 1) {
	$self->{'in_hash'}->{'file'} =~ /^\S+$/ || $self->error($self->{'text_hash'}->{'setup_efile'});
	$self->{'file'} = $self->{'in_hash'}->{'file'};
	}
elsif ($self->{'in_hash'}->{'to'} == 2) {
	$self->{'in_hash'}->{'maildir'} =~ /^\S+$/ || $self->error($self->{'text_hash'}->{'setup_emaildir'});
	$self->{'file'} = "$self->{'in_hash'}->{'maildir'}/";
	}
elsif ($self->{'in_hash'}->{'to'} == 3) {
	$self->{'in_hash'}->{'mhdir'} =~ /^\S+$/ || $self->error($self->{'text_hash'}->{'setup_emhdir'});
	$self->{'file'} = "$self->{'in_hash'}->{'mhdir'}/.";
	}
elsif ($self->{'in_hash'}->{'to'} == 5) {
	$self->{'in_hash'}->{'email'} =~ /^\S+$/ || $self->error($self->{'text_hash'}->{'setup_eemail'});
	$self->{'file'} = $self->{'in_hash'}->{'email'};
	$self->{'type'} = "!";
	}

if ($self->{'module_info_hash'}->{'usermin'} && $self->{'file'} !~ /^\//) {
	# Create parent directory if needed
	if ($self->{'file'} =~ /^(\S+)\/([^\/]+)(\/(\.)?)?$/ &&
	    !-d "$self->{'remote_user_info_array'}->[7]/$1") {
		$self->system_logged("mkdir -p '$self->{'remote_user_info_array'}->[7]/$1'");
		}
	}

# Add template procmail rules
$self->foreign_require("procmail", "procmail-lib.pl");
@{$self->{'pmrc_array'}} = $self->get_procmailrc();
if (!-s $self->{'pmrc_array'}->[0] && $self->{'config_hash'}->{'extra_procmail'}) {
	$self->open_tempfile(PMRC, ">$self->{'pmrc_array'}->[0]");
	$self->print_tempfile(PMRC, map { "$_\n" } split(/\t/, $self->{'config_hash'}->{'extra_procmail'}));
	$self->close_tempfile(PMRC);
	}

# Add new Procmail directives at the top of config file
$self->{'pmrc'} = $self->{'pmrc_array'}->[$#{$self->{'pmrc_array'}}];
@{$self->{'recipes_array'}} = $main::procmail_object->parse_procmail_file($self->{'pmrc'});
if ($self->{'in_hash'}->{'drop'}) {
	# Environment variable to drop privileges
	$self->{'recipe0'} = { 'name' => 'DROPPRIVS',
		     'value' => 'yes' };
	}
if ($self->{'config_hash'}->{'call_spam'} || !$self->{'module_info_hash'}->{'usermin'}) {
	# Recipe to call spamassassin
	$self->{'recipe1'} = { 'flags' => [ 'f', 'w' ],
		     'conds' => [ ],
		     'type' => '|',
		     'action' => $self->get_procmail_command() };
	}
if ($self->{'file'}) {
	# Recipe to perform actual filtering to a file
	$self->{'recipe2'} = { 'flags' => [ ],
		     'conds' => [ [ '', '^X-Spam-Status: Yes' ] ],
		     'type' => $self->{'type'},
		     'action' => $self->{'file'} };
	}
$self->lock_file($self->{'pmrc'});
if (@{$self->{'recipes_array'}}) {
	# Insert at start of file
	$main::procmail_object->create_recipe_before($self->{'recipe0'}, $self->{'recipes_array'}->[0], $self->{'pmrc'})
		if ($self->{'recipe0'});
	$main::procmail_object->create_recipe_before($self->{'recipe1'}, $self->{'recipes_array'}->[0], $self->{'pmrc'})
		if ($self->{'recipe1'});
	$main::procmail_object->create_recipe_before($self->{'recipe2'}, $self->{'recipes_array'}->[0], $self->{'pmrc'})
		if ($self->{'recipe2'});
	}
else {
	# Just add to file
	$main::procmail_object->create_recipe($self->{'recipe0'}, $self->{'pmrc'}) if ($self->{'recipe0'});
	$main::procmail_object->create_recipe($self->{'recipe1'}, $self->{'pmrc'}) if ($self->{'recipe1'});
	$main::procmail_object->create_recipe($self->{'recipe2'}, $self->{'pmrc'}) if ($self->{'recipe2'});
	}
chmod(0644, $self->{'pmrc'});
$self->unlock_file($self->{'pmrc'});

if ($self->{'module_info_hash'}->{'usermin'} && $self->{'file'} ne "/dev/null") {
	# Remember spam mail file
	$self->{'userconfig_hash'}->{'spam_file'} = $self->{'file'};
	$self->write_file("$self->{'user_module_config_directory'}/config", \%{$self->{'userconfig_hash'}});
	}

# All done!
$self->webmin_log("setup");
$self->redirect("");

1;
		
}


1;

