#!/usr/bin/perl

&MAIN();

 sub MAIN {
# view_mail.cgi
# View a single email message 

&ModuleLoader::preload_module('spam_class', "spam::SpamLib");
$self = new spam::SpamLib:: 'spam_class',%$self;

$self->foreign_require("mailbox", "mailbox-lib.pl");
$self->{'folder'} = $self->spam_file_folder();
$self->disable_indexing($self->{'folder'});

$self->{'force_charset'} = '';
$self->ReadParse();

$self->ui_print_header(undef, $main::mailbox_object->{'text_hash'}->{'view_title'}, "");
@{$self->{'mail_array'}} = $main::mailbox_object->mailbox_list_mails_sorted($self->{'in_hash'}->{'idx'}, $self->{'in_hash'}->{'idx'}, $self->{'folder'});
$self->{'mail'} = $self->{'mail_array'}->[$self->{'in_hash'}->{'idx'}];
$main::mailbox_object->parse_mail($self->{'mail'});
@{$self->{'sub_array'}} = split(/\0/, $self->{'in_hash'}->{'sub'});
$self->{'subs'} = join("", map { "&sub=$_" } @{$self->{'sub_array'}});
foreach $s (@{$self->{'sub_array'}}) {
        # We are looking at a mail within a mail ..
	$main::mailbox_object->decrypt_attachments($self->{'mail'});
        local $amail = $main::mailbox_object->extract_mail($self->{'mail'}->{'attach'}->[$s]->{'data'});
        $main::mailbox_object->parse_mail($amail);
        $self->{'mail'} = $amail;
        }

dbmopen(%{$self->{'read_hash'}}, "$self->{'user_config_directory'}/mailbox/read", 0600);
if ($main::mailbox_object->{'userconfig_hash'}->{'auto_mark'}) {
	eval { $self->{'read_hash'}->{$self->{'mail'}->{'header'}->{'message-id'}} = 1 }
		if (!$self->{'read_hash'}->{$self->{'mail'}->{'header'}->{'message-id'}});
	}

print "<center>\n";
if (!@{$self->{'sub_array'}}) {
	if ($self->{'in_hash'}->{'idx'}) {
		print "<a href='view_mail.cgi?idx=",
		      $self->{'in_hash'}->{'idx'}-1,"'>",
		      "<img src=/images/left.gif border=0 ",
		      "align=middle></a>\n";
		}
	print "<font size=+1>",$main::mailbox_object->text('view_desc', $self->{'in_hash'}->{'idx'}+1,
			$self->{'folder'}->{'name'}),"</font>\n";
	if ($self->{'in_hash'}->{'idx'} < @{$self->{'mail_array'}}-1) {
		print "<a href='view_mail.cgi?idx=",
		      $self->{'in_hash'}->{'idx'}+1,"'>",
		      "<img src=/images/right.gif border=0 ",
		      "align=middle></a>\n";
		}
	}
else {
	print "<font size=+1>$self->{'text_hash'}->{'view_sub'}</font>\n";
	}
print "</center>\n";

# Check for encryption
($self->{'deccode'}, $self->{'decmessage'}) = $main::mailbox_object->decrypt_attachments($self->{'mail'});
@{$self->{'attach_array'}} = @{$self->{'mail'}->{'attach'}};

# Find body attachment and type
($self->{'textbody'}, $self->{'htmlbody'}, $self->{'body'}) = $main::mailbox_object->find_body($self->{'mail'});

# XXX look for text/calendar body

# Check for signing
if ($self->has_command("gpg") && $self->foreign_check("gnupg")) {
	# Check for GnuPG signatures
	local $sig;
	foreach $a (@{$self->{'attach_array'}}) {
		$sig = $a if ($a->{'type'} =~ /^application\/pgp-signature/);
		}
	if ($sig) {
		# Verify the signature against the rest of the attachment
		$self->foreign_require("gnupg", "gnupg-lib.pl");
		local $rest = $sig->{'parent'}->{'attach'}->[0];
		$rest->{'raw'} =~ s/\r//g;
		$rest->{'raw'} =~ s/\n/\r\n/g;
		($self->{'sigcode'}, $self->{'sigmessage'}) = $self->foreign_call("gnupg",
				"verify_data", $rest->{'raw'}, $sig->{'data'});
		@{$self->{'attach_array'}} = grep { $_ ne $sig } @{$self->{'attach_array'}};
		}
	elsif ($self->{'body'} && $self->{'body'} eq $self->{'textbody'} && $self->{'body'}->{'data'} =~ /(-+BEGIN PGP SIGNED MESSAGE-+\n(Hash:\s+(\S+)\n\n)?([\000-\377]+\n)-+BEGIN PGP SIGNATURE-+\n([\000-\377]+)-+END PGP SIGNATURE-+\n)/i) {
		# Signature is in body text!
		local $sig = $1;
		local $text = $4;
		$self->foreign_require("gnupg", "gnupg-lib.pl");
		($self->{'sigcode'}, $self->{'sigmessage'}) = $self->foreign_call("gnupg",
							"verify_data", $sig);
		if ($self->{'sigcode'} == 0 || $self->{'sigcode'} == 1) {
			# XXX what about replying?
			$self->{'body'}->{'data'} = $text;
			}
		}
	}

# Strip out attachments not to display as icons
@{$self->{'attach_array'}} = grep { $_ ne $self->{'body'} } @{$self->{'attach_array'}};
@{$self->{'attach_array'}} = grep { !$_->{'attach'} } @{$self->{'attach_array'}};

print "<table width=100% border=1>\n";
print "<tr> <td $self->{'tb'}><table width=100% cellpadding=0 cellspacing=0><tr>",
      "<td><b>$main::mailbox_object->{'text_hash'}->{'view_headers'}</b></td>\n";
if ($self->{'in_hash'}->{'headers'}) {
	print "<td align=right><a href='view_mail.cgi?idx=$self->{'in_hash'}->{'idx'}&headers=0$self->{'subs'}'>$main::mailbox_object->{'text_hash'}->{'view_noheaders'}</a></td>\n";
	}
else {
	print "<td align=right><a href='view_mail.cgi?idx=$self->{'in_hash'}->{'idx'}&headers=1$self->{'subs'}'>$main::mailbox_object->{'text_hash'}->{'view_allheaders'}</a></td>\n";
	}
print "</tr></table></td> </tr>\n";

print "<tr> <td $cb><table width=100%>\n";
if ($self->{'in_hash'}->{'headers'}) {
	# Show all the headers
	if ($self->{'mail'}->{'fromline'}) {
		print "<tr> <td><b>$self->{'text_hash'}->{'mail_rfc'}</b></td>",
		      "<td>",$main::mailbox_object->eucconv($self->html_escape($self->{'mail'}->{'fromline'})),
		      "</td> </tr>\n";
		}
	foreach $h (@{$self->{'mail'}->{'headers'}}) {
		print "<tr> <td><b>$h->[0]:</b></td> ",
		      "<td>",$main::mailbox_object->eucconv($self->html_escape($main::mailbox_object->decode_mimewords($h->[1]))),
		      "</td> </tr>\n";
		}
	}
else {
	# Just show the most useful headers
	print "<tr> <td><b>$main::mailbox_object->{'text_hash'}->{'mail_from'}</b></td> ",
	      "<td>",&address_link($self->{'mail'}->{'header'}->{'from'}),"</td> </tr>\n";
	print "<tr> <td><b>$main::mailbox_object->{'text_hash'}->{'mail_to'}</b></td> ",
	      "<td>",&address_link($self->{'mail'}->{'header'}->{'to'}),"</td> </tr>\n";
	print "<tr> <td><b>$main::mailbox_object->{'text_hash'}->{'mail_cc'}</b></td> ",
	      "<td>",&address_link($self->{'mail'}->{'header'}->{'cc'}),"</td> </tr>\n"
		if ($self->{'mail'}->{'header'}->{'cc'});
	print "<tr> <td><b>$main::mailbox_object->{'text_hash'}->{'mail_date'}</b></td> ",
	      "<td>",$main::mailbox_object->eucconv($self->html_escape($self->{'mail'}->{'header'}->{'date'})),
	      "</td> </tr>\n";
	print "<tr> <td><b>$main::mailbox_object->{'text_hash'}->{'mail_subject'}</b></td> ",
	      "<td>",$main::mailbox_object->eucconv($self->html_escape($main::mailbox_object->decode_mimewords(
			$self->{'mail'}->{'header'}->{'subject'}))),"</td> </tr>\n";
	if (!@{$self->{'sub_array'}}) {
		print "<tr> <td><b>$self->{'text_hash'}->{'mail_level2'}</b></td> ",
		      "<td>",length($self->{'mail'}->{'header'}->{'x-spam-level'}),"</td> </tr>\n";
		}
	}
print "</table></td></tr></table><p>\n";

# Show body attachment, with properly linked URLs
if ($self->{'body'} && $self->{'body'}->{'data'} =~ /\S/) {
	if ($self->{'body'} eq $self->{'textbody'}) {
		# Show plain text
		print "<table width=100% border=1><tr><td $cb><pre>\n";
		foreach $l ($main::mailbox_object->wrap_lines($self->{'body'}->{'data'},
					$main::mailbox_object->{'userconfig_hash'}->{'wrap_width'})) {
			print $main::mailbox_object->link_urls_and_escape($l),"\n";
			}
		print "</pre></td></tr></table><p>\n";
		}
	elsif ($self->{'body'} eq $self->{'htmlbody'}) {
		# Attempt to show HTML
		print "<table width=100% border=1><tr><td>\n";
		print $main::mailbox_object->safe_html($self->{'body'}->{'data'});
		print "</td></tr></table><p>\n";
		}
	}

# Display other attachments
if (@{$self->{'attach_array'}}) {
	print "<table width=100% border=1>\n";
	print "<tr> <td $self->{'tb'}><b>$main::mailbox_object->{'text_hash'}->{'view_attach'}</b></td> </tr>\n";
	print "<tr> <td $cb>\n";
	foreach $a (@{$self->{'attach_array'}}) {
		local $fn;
		$self->{'size'} = (int(length($a->{'data'})/1000)+1)." Kb";
		local $cb;
		if ($a->{'type'} eq 'message/rfc822') {
			push(@{$self->{'titles_array'}}, "$main::mailbox_object->{'text_hash'}->{'view_sub'}<br>$self->{'size'}");
			}
		elsif ($a->{'filename'}) {
			push(@{$self->{'titles_array'}}, $main::mailbox_object->decode_mimewords($a->{'filename'}).
				      "<br>$self->{'size'}");
			$fn = $main::mailbox_object->decode_mimewords($a->{'filename'});
			push(@{$self->{'detach_array'}}, [ $a->{'idx'}, $fn ]);
			}
		else {
			push(@{$self->{'titles_array'}}, "$a->{'type'}<br>$self->{'size'}");
			$a->{'type'} =~ /\/(\S+)$/;
			$fn = "file.$1";
			push(@{$self->{'detach_array'}}, [ $a->{'idx'}, $fn ]);
			}
		$fn =~ s/ /_/g;
		$fn =~ s/\#/_/g;
		$fn = $self->html_escape($fn);
		if ($a->{'type'} eq 'message/rfc822') {
			push(@{$self->{'links_array'}}, "view_mail.cgi?idx=$self->{'in_hash'}->{'idx'}$self->{'subs'}&sub=$a->{'idx'}");
			}
		else {
			push(@{$self->{'links_array'}}, "detach.cgi/$fn?idx=$self->{'in_hash'}->{'idx'}&attach=$a->{'idx'}$self->{'subs'}");
			}
		push(@{$self->{'icons_array'}}, "/mailbox/images/boxes.gif");
		}
	$self->icons_table(\@{$self->{'links_array'}}, \@{$self->{'titles_array'}}, \@{$self->{'icons_array'}}, 8);
	print "</td></tr></table><p>\n";
	}

# Display GnuPG results
if (defined($self->{'sigcode'})) {
	print "<table border width=100%>\n";
	print "<tr $self->{'tb'}> <td><b>$main::mailbox_object->{'text_hash'}->{'view_gnupg'}</b></td> </tr>\n";
	print "<tr $cb> <td>";
	$self->{'sigmessage'} = $self->html_escape($self->{'sigmessage'});
	$self->{'sigmessage'} = $self->{'sigmessage'} if ($self->{'sigcode'} == 4);
	print $main::mailbox_object->text('view_gnupg_'.$self->{'sigcode'}, $self->{'sigmessage'}),"\n";
	if ($self->{'sigcode'} == 3) {
		local $url = "/$self->{'module_name'}/view_mail.cgi?idx=$self->{'in_hash'}->{'idx'}&folder=$self->{'in_hash'}->{'folder'}$self->{'subs'}";
		print "<p>",$main::mailbox_object->text('view_recv', $self->{'sigmessage'}, "/gnupg/recv.cgi?id=$self->{'sigmessage'}&return=".$self->urlize($url)."&returnmsg=".$self->urlize($self->{'text_hash'}->{'view_return'})),"\n";
		}
	print "</td> </tr></table><p>\n";
	}
if ($self->{'deccode'}) {
	print "<table border width=100%>\n";
	print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'view_crypt'}</b></td> </tr>\n";
	print "<tr $cb> <td>";
	print $main::mailbox_object->text('view_crypt_'.$self->{'deccode'}, "<pre>$self->{'decmessage'}</pre>");
	print "</td> </tr></table><p>\n";
	}

dbmclose(%{$self->{'read_hash'}});

local @sr = !@{$self->{'sub_array'}} ? ( ) :
    ( "view_mail.cgi?idx=$self->{'in_hash'}->{'idx'}", $main::mailbox_object->{'text_hash'}->{'view_return'} ),
$s = int((@{$self->{'mail_array'}} - $self->{'in_hash'}->{'idx'} - 1) / $main::mailbox_object->{'userconfig_hash'}->{'perpage'}) *
	$main::mailbox_object->{'userconfig_hash'}->{'perpage'};
$self->ui_print_footer(@{$self->{'sub_array'}} ? ( "view_mail.cgi?idx=$self->{'in_hash'}->{'idx'}",
		 $main::mailbox_object->{'text_hash'}->{'view_return'} ) : ( ),
	"mail.cgi", $self->{'text_hash'}->{'mail_return'});

1;
		
}

# address_link(address)
sub address_link
{
	shift if ($self == $_[0]);

local @addrs = $main::mailbox_object->split_addresses($main::mailbox_object->decode_mimewords($_[0]));
local @rv;
foreach $a (@addrs) {
	push(@rv, $self->html_escape($a->[2]));
	}
return join(" , ", @rv);
}


1;

