#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_auth.cgi
# Edit or create an authorized key

&ModuleLoader::preload_module('ssh_class', "ssh::SshLib");
$self = new ssh::SshLib:: 'ssh_class',%$self;

$self->ReadParse();
if ($self->{'in_hash'}->{'new'}) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'auth_create'}, "");
	$self->{'msg'} = $self->{'text_hash'}->{'auth_desc1'};
	$self->{'auth'} = { 'keytype' => 'ssh-dss',
		  'type' => $self->{'in_hash'}->{'type'} || 1 };
	}
else {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'auth_edit'}, "");
	@{$self->{'auths_array'}} = $self->list_auths();
	$self->{'auth'} = $self->{'auths_array'}->[$self->{'in_hash'}->{'idx'}];
	}

# Show main key details
print "$self->{'msg'}<p>\n" if ($self->{'msg'});
print $self->ui_form_start("save_auth.cgi", "post");
print $self->ui_hidden("idx", $self->{'in_hash'}->{'idx'}),"\n";
print $self->ui_hidden("new", $self->{'in_hash'}->{'new'}),"\n";
print $self->ui_hidden("type", $self->{'auth'}->{'type'}),"\n";
print $self->ui_table_start($self->{'text_hash'}->{'auth_header'.$self->{'auth'}->{'type'}}, "width=100%", 4);

print $self->ui_table_row($self->{'text_hash'}->{'auth_name'},
		$self->ui_textbox("name", $self->{'auth'}->{'name'}, 40), 3);

if ($self->{'auth'}->{'type'} == 1) {
	# Only SSH 1 has bits and exponent
	print $self->ui_table_row($self->{'text_hash'}->{'auth_bits'},
			    $self->ui_textbox("bits", $self->{'auth'}->{'bits'}, 5), 3);

	print $self->ui_table_row($self->{'text_hash'}->{'auth_exp'},
			    $self->ui_textbox("exp", $self->{'auth'}->{'exp'}, 5), 3);
	}
else {
	# Only SSH 2 has key type
	print $self->ui_table_row($self->{'text_hash'}->{'auth_keytype'},
			$self->ui_select("keytype", $self->{'auth'}->{'keytype'},
				[ [ "ssh-dss", $self->{'text_hash'}->{'auth_dss'} ],
				  [ "ssh-rsa", $self->{'text_hash'}->{'auth_rsa'} ] ],
				1, 0, 1));
	}

print $self->ui_table_row($self->{'text_hash'}->{'auth_key'},
	$self->ui_textarea("key", $self->{'auth'}->{'key'}, 10, 50, "on"), 3);

# Show key options
$self->parse_options($self->{'auth'}->{'opts'}, \%{$self->{'opts_hash'}});
print $self->ui_table_hr();

print $self->ui_table_row($self->{'text_hash'}->{'auth_from'},
	$self->ui_radio("from_def", $self->{'opts_hash'}->{'from'} ? 0 : 1,
		  [ [ 1, $self->{'text_hash'}->{'auth_from_all'} ],
		    [ 0, $self->{'text_hash'}->{'auth_from_sel'} ] ])."<br>".
	$self->ui_textarea("from", join(" ", split(/,/, $self->{'opts_hash'}->{'from'}->[0])),
		     3, 50, "on"), 3);

print $self->ui_table_row($self->{'text_hash'}->{'auth_command'},
	$self->ui_textbox("command", $self->{'opts_hash'}->{'command'}->[0], 50), 3);

print $self->ui_table_row($self->{'text_hash'}->{'auth_noport'},
	$self->ui_radio("noport", $self->{'opts_hash'}->{'no-port-forwarding'} ? 1 : 0,
		  [ [ 0, $self->{'text_hash'}->{'yes'} ], [ 1, $self->{'text_hash'}->{'no'} ] ]));

print $self->ui_table_row($self->{'text_hash'}->{'auth_nox11'},
	$self->ui_radio("nox11", $self->{'opts_hash'}->{'no-x11-forwarding'} ? 1 : 0,
		  [ [ 0, $self->{'text_hash'}->{'yes'} ], [ 1, $self->{'text_hash'}->{'no'} ] ]));

print $self->ui_table_row($self->{'text_hash'}->{'auth_noagent'},
	$self->ui_radio("noagent", $self->{'opts_hash'}->{'no-agent-forwarding'} ? 1 : 0,
		  [ [ 0, $self->{'text_hash'}->{'yes'} ], [ 1, $self->{'text_hash'}->{'no'} ] ]));

print $self->ui_table_row($self->{'text_hash'}->{'auth_nopty'},
	$self->ui_radio("nopty", $self->{'opts_hash'}->{'no-pty'} ? 1 : 0,
		  [ [ 0, $self->{'text_hash'}->{'yes'} ], [ 1, $self->{'text_hash'}->{'no'} ] ]));

print $self->ui_table_end();
if ($self->{'in_hash'}->{'new'}) {
	print $self->ui_form_end([ [ "create", $self->{'text_hash'}->{'create'} ] ]);
	}
else {
	print $self->ui_form_end([ [ "save", $self->{'text_hash'}->{'save'} ],
			     [ "delete", $self->{'text_hash'}->{'delete'} ] ]);
	}

$self->ui_print_footer("list_auths.cgi", $self->{'text_hash'}->{'auths_return'},
	"", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

