#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_auth.cgi
# Save, create or delete an authorized key

&ModuleLoader::preload_module('ssh_class', "ssh::SshLib");
$self = new ssh::SshLib:: 'ssh_class',%$self;

$self->ReadParse();
@{$self->{'auths_array'}} = $self->list_auths();
if ($self->{'in_hash'}->{'new'}) {
	$self->{'auth'} = { 'type' => $self->{'in_hash'}->{'type'} };
	}
else {
	$self->{'auth'} = $self->{'auths_array'}->[$self->{'in_hash'}->{'idx'}];
	}

if ($self->{'in_hash'}->{'delete'}) {
	# Just delete this authorized key
	$self->delete_auth($self->{'auth'});
	}
else {
	# Validate inputs
	$self->error_setup($self->{'text_hash'}->{'auth_err'});
	$self->{'in_hash'}->{'name'} =~ /^\S+$/ || $self->error($self->{'text_hash'}->{'auth_ename'});
	$self->{'auth'}->{'name'} = $self->{'in_hash'}->{'name'};
	if ($self->{'auth'}->{'type'} == 1) {
		$self->{'in_hash'}->{'bits'} =~ /^\d+$/ || $self->error($self->{'text_hash'}->{'auth_ebits'});
		$self->{'auth'}->{'bits'} = $self->{'in_hash'}->{'bits'};
		$self->{'in_hash'}->{'exp'} =~ /^\d+$/ || $self->error($self->{'text_hash'}->{'auth_eexp'});
		$self->{'auth'}->{'exp'} = $self->{'in_hash'}->{'exp'};
		}
	else {
		$self->{'auth'}->{'keytype'} = $self->{'in_hash'}->{'keytype'};
		}
	$self->{'in_hash'}->{'key'} =~ s/\s//g;
	if ($self->{'auth'}->{'type'} == 1) {
		$self->{'in_hash'}->{'key'} =~ /^\d+$/ || $self->error($self->{'text_hash'}->{'auth_ekey'});
		}
	else {
		$self->{'in_hash'}->{'key'} =~ /^[a-z0-9\+\/=]+$/i || $self->error($self->{'text_hash'}->{'auth_ekey2'});
		}
	$self->{'auth'}->{'key'} = $self->{'in_hash'}->{'key'};

	# Validate option inputs
	$self->parse_options($self->{'auth'}->{'opts'}, \%{$self->{'opts_hash'}});
	if ($self->{'in_hash'}->{'from_def'}) {
		delete($self->{'opts_hash'}->{'from'});
		}
	else {
		$self->{'opts_hash'}->{'from'} = [ join(",", split(/\s+/, $self->{'in_hash'}->{'from'})) ];
		}
	if ($self->{'in_hash'}->{'command'}) {
		$self->{'opts_hash'}->{'command'} = [ $self->{'in_hash'}->{'command'} ];
		}
	else {
		delete($self->{'opts_hash'}->{'command'});
		}
	if ($self->{'in_hash'}->{'noport'}) { $self->{'opts_hash'}->{'no-port-forwarding'} = [ undef ]; }
	else { delete($self->{'opts_hash'}->{'no-port-forwarding'}); }
	if ($self->{'in_hash'}->{'nox11'}) { $self->{'opts_hash'}->{'no-x11-forwarding'} = [ undef ]; }
	else { delete($self->{'opts_hash'}->{'no-x11-forwarding'}); }
	if ($self->{'in_hash'}->{'noagent'}) { $self->{'opts_hash'}->{'no-agent-forwarding'} = [ undef ]; }
	else { delete($self->{'opts_hash'}->{'no-agent-forwarding'}); }
	if ($self->{'in_hash'}->{'nopty'}) { $self->{'opts_hash'}->{'no-pty'} = [ undef ]; }
	else { delete($self->{'opts_hash'}->{'no-pty'}); }
	$self->{'auth'}->{'opts'} = $self->join_options(\%{$self->{'opts_hash'}});

	# Create or save the authorized key
	if ($self->{'in_hash'}->{'new'}) {
		$self->create_auth($self->{'auth'});
		}
	else {
		$self->modify_auth($self->{'auth'});
		}
	}
$self->redirect("list_auths.cgi");

1;
		
}


1;

