#!/usr/bin/perl
package updown::UpdownLib;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'updown::UpdownLib');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# updown-lib.pl

&ModuleLoader::preload_module(ref($self), "WebLib");
$self = new WebLib:: ref($self), %$self; 
$self->init_config();
&ModuleLoader::preload_module(ref($self), "UiLib");
$self = new UiLib:: ref($self), %$self; 

if ($self->{'module_info_hash'}->{'usermin'}) {
	# Running under Usermin
	$self->switch_to_remote_user();
	$self->create_user_config_dirs();
	$self->{'downloads_dir'} = "$self->{'user_module_config_directory'}/downloads";
	$self->{'atjob_cmd'} = "$self->{'user_module_config_directory'}/download.pl";

	$self->{'can_upload'} = $self->{'config_hash'}->{'upload'};
	$self->{'can_download'} = $self->{'config_hash'}->{'download'};
	$self->{'can_fetch'} = $self->{'config_hash'}->{'fetch'};
	$self->{'can_schedule'} = 0;
	$self->{'can_background'} = $self->{'config_hash'}->{'background'};
	if ($self->{'config_hash'}->{'home_only'}) {
		@{$self->{'can_dirs_array'}} = ( $self->resolve_links($self->{'remote_user_info_array'}->[7]),
			      split(/\s+/, $self->{'config_hash'}->{'root'}) );
		}
	else {
		@{$self->{'can_dirs_array'}} = ( "/" );
		}
	$self->{'can_mode'} = 3;

	$self->{'download_dir'} = $self->{'userconfig_hash'}->{'ddir'};
	$self->{'download_dir'} = $self->{'remote_user_info_array'}->[7] if ($self->{'download_dir'} eq "~");
	$self->{'upload_dir'} = $self->{'userconfig_hash'}->{'dir'};
	$self->{'upload_dir'} = $self->{'remote_user_info_array'}->[7] if ($self->{'upload_dir'} eq "~");
	$self->{'upload_max'} = $self->{'config_hash'}->{'max'};
	$self->{'fetch_file'} = $self->{'userconfig_hash'}->{'fetch'};
	$self->{'fetch_show'} = $self->{'userconfig_hash'}->{'show'} || 0;
	}
else {
	# Running under Webmin
	$self->{'downloads_dir'} = "$self->{'module_config_directory'}/downloads";
	$self->{'atjob_cmd'} = "$self->{'module_config_directory'}/download.pl";

	%{$self->{'access_hash'}} = $self->get_module_acl();
	$self->{'can_upload'} = $self->{'access_hash'}->{'upload'};
	$self->{'can_download'} = $self->{'access_hash'}->{'download'};
	$self->{'can_fetch'} = $self->{'access_hash'}->{'fetch'} && !$self->is_readonly_mode();
	if ($self->{'access_hash'}->{'download'} != 2) {
		$self->{'can_schedule'} = $self->foreign_check("at");
		$self->{'can_background'} = 1;
		}
	if ($self->supports_users()) {
		$self->{'can_mode'} = $self->{'access_hash'}->{'mode'};
		}
	else {
		$self->{'can_mode'} = 3;
		}
	@can_users = split(/\s+/, $self->{'access_hash'}->{'users'});
	@{$self->{'can_dirs_array'}} = split(/\s+/, $self->{'access_hash'}->{'dirs'});
	if ($self->{'access_hash'}->{'home'}) {
		 @{$self->{'uinfo_array'}} = getpwnam($self->{'remote_user'});
		push(@{$self->{'can_dirs_array'}}, $self->{'uinfo_array'}->[7]) if ($self->{'uinfo_array'}->[7]);
		}

	$self->{'download_dir'} = $self->{'config_hash'}->{'ddir_'.$self->{'remote_user'}} || $self->{'config_hash'}->{'ddir'};
	$self->{'upload_dir'} = $self->{'config_hash'}->{'dir_'.$self->{'remote_user'}} || $self->{'config_hash'}->{'dir'};
	$self->{'upload_user'} = $self->{'config_hash'}->{'user_'.$self->{'remote_user'}} || $self->{'config_hash'}->{'user'};
	$self->{'upload_group'} = $self->{'config_hash'}->{'group_'.$self->{'remote_group'}} || $self->{'config_hash'}->{'group'};
	$self->{'upload_max'} = $self->{'access_hash'}->{'max'};
	$self->{'download_user'} = $self->{'config_hash'}->{'duser_'.$self->{'remote_user'}} || $self->{'config_hash'}->{'duser'};
	$self->{'download_group'} = $self->{'config_hash'}->{'dgroup_'.$self->{'remote_group'}} || $self->{'config_hash'}->{'dgroup'};
	$self->{'fetch_file'} = $self->{'config_hash'}->{'fetch_'.$self->{'remote_user'}};
	$self->{'fetch_show'} = $self->{'config_hash'}->{'show_'.$self->{'remote_user'}} || 0;
	}

1;

1;
		return $self;
}

# list_downloads()
# Returns a list of downloads currently in progress
sub list_downloads
{
	my $self = shift;

local (@rv, $f);
opendir(DIR, $self->{'downloads_dir'});
foreach $f (readdir(DIR)) {
	next if ($f !~ /^(\S+)\.down$/);
	local $down = $self->get_download("$1");
	push(@rv, $down) if ($down);
	}
closedir(DIR);
return @rv;
}

# get_download(id)
sub get_download
{
	my $self = shift;

local %down;
$self->read_file("$self->{'downloads_dir'}/$_[0].down", \%down) || return undef;
$down{'user'} = getpwuid($down{'uid'});
return \%down;
}

# save_download(&download)
sub save_download
{
	my $self = shift;

$_[0]->{'id'} = time().$$ if (!$_[0]->{'id'});
$self->lock_file($self->{'downloads_dir'});
mkdir($self->{'downloads_dir'}, 0755);
$self->unlock_file($self->{'downloads_dir'});
$self->lock_file("$self->{'downloads_dir'}/$_[0]->{'id'}.down");
$self->write_file("$self->{'downloads_dir'}/$_[0]->{'id'}.down", $_[0]);
$self->unlock_file("$self->{'downloads_dir'}/$_[0]->{'id'}.down");
}

# delete_download(&download)
sub delete_download
{
	my $self = shift;

$self->lock_file("$self->{'downloads_dir'}/$_[0]->{'id'}.down");
unlink("$self->{'downloads_dir'}/$_[0]->{'id'}.down");
$self->unlock_file("$self->{'downloads_dir'}/$_[0]->{'id'}.down");
}

# do_download(&download, &callback, &dests)
# Actually download one or more files, and return undef or any error message
sub do_download
{
	my $self = shift;

local $i;
for($i=0; $_[0]->{"url_$i"}; $i++) {
	$self->{'progress_callback_url'} = $_[0]->{"url_$i"};
	$self->{'progress_callback_count'} = $i;
	local $error;
	local $path;
	if (-d $_[0]->{'dir'}) {
		if ($_[0]->{"page_$i"} =~ /([^\/]+)$/) {
			$path = "$_[0]->{'dir'}/$1";
			}
		else {
			$path = "$_[0]->{'dir'}/index.html";
			}
		}
	else {
		$path = $_[0]->{'dir'};
		}
	$self->switch_uid_to($_[0]->{'uid'}, $_[0]->{'gid'});
	$self->{'down'}->{'upto'} = $self->{'progress_callback_count'};
	if ($_[0]->{"proto_$i"} eq "http") {
		$self->http_download($_[0]->{"host_$i"},
			       $_[0]->{"port_$i"},
			       $_[0]->{"page_$i"},
			       $path,
			       \$error,
			       $_[1],
			       $_[0]->{"ssl_$i"},
			       $_[0]->{"user_$i"},
			       $_[0]->{"pass_$i"});
		}
	else {
		$self->ftp_download($_[0]->{"host_$i"},
			      $_[0]->{"page_$i"},
			       $path,
			       \$error,
			       $_[1],
			       $_[0]->{"user_$i"},
			       $_[0]->{"pass_$i"});
		}
	unlink($path) if ($error);
	$self->switch_uid_back();
	return $error if ($error);
	push(@{$_[2]}, $path);
	}
return undef;
}

# can_write_file(file)
# Returns 1 if some path can be written to, 0 if not
sub can_write_file
{
	my $self = shift;

local $d;
foreach $d (@{$self->{'can_dirs_array'}}) {
	return 1 if ($self->is_under_directory($d, $_[0]));
	}
return 0;
}

# can_as_user(username)
# Returns 1 if uploading or downloading can be done as some user
sub can_as_user
{
	my $self = shift;

if ($self->{'can_mode'} == 0) {
	return 1;
	}
elsif ($self->{'can_mode'} == 1) {
	return $self->indexof($_[0], @{$self->{'can_users_array'}}) != -1;
	}
elsif ($self->{'can_mode'} == 2) {
	return $self->indexof($_[0], @{$self->{'can_users_array'}}) == -1;
	}
elsif ($self->{'can_mode'} == 3) {
	return $_[0] eq $self->{'remote_user'};
	}
else {
	return 0;	# shouldn't happen
	}
}

# in_group(&uinfo, &ginfo)
sub in_group
{
	my $self = shift;

return 1 if ($_[0]->[3] == $_[1]->[2]);
foreach $s ($self->other_groups($_[0]->[0])) {
	return 1 if ($s eq $_[1]->[2]);
	}
return 0;
}

# switch_uid_to(uid, gid)
# Temporarily sets the effective UID and GID, if appropriate
sub switch_uid_to
{
	my $self = shift;

if ($< == 0 && ($_[0] || $_[1]) && $self->supports_users()) {
	$self->{'old_uid'} = $>;
	$self->{'old_gid'} = $);
	$) = "$_[1] $_[1]";
	$> = $_[0];
	}
}

# switch_uid_back()
# Undo the switch made by switch_uid_to
sub switch_uid_back
{
	my $self = shift;

if (defined($self->{'old_uid'})) {
	$> = $self->{'old_uid'};
	$) = $self->{'old_gid'};
	$self->{'old_uid'} = $self->{'old_gid'} = undef;
	}
}


1;

