#!/usr/bin/perl

&MAIN();

 sub MAIN {
# upload.cgi
# Upload multiple files

&ModuleLoader::preload_module('updown_class', "updown::UpdownLib");
$self = new updown::UpdownLib:: 'updown_class',%$self;

$self->error_setup($self->{'text_hash'}->{'upload_err'});
$self->ReadParse(\%{$self->{'getin_hash'}}, "GET");
$self->{'upid'} = $self->{'getin_hash'}->{'id'};
$self->ReadParseMime($self->{'upload_max'}, 'read_parse_mime_callback', [ $self->{'upid'} ]);
$self->{'can_upload'} || $self->error($self->{'text_hash'}->{'upload_ecannot'});

# Validate inputs
$self->{'in_hash'}->{'dir'} || $self->error($self->{'text_hash'}->{'upload_edir'});
if ($self->{'can_mode'} != 3) {
	# User can be entered
	defined(@{$self->{'uinfo_array'}} = getpwnam($self->{'in_hash'}->{'user'})) ||
		$self->error($self->{'text_hash'}->{'upload_euser'});
	$self->can_as_user($self->{'in_hash'}->{'user'}) ||
		$self->error($self->text('upload_eucannot', $self->{'in_hash'}->{'user'}));
	$self->{'in_hash'}->{'group_def'} || defined(@{$self->{'ginfo_array'}} = getgrnam($self->{'in_hash'}->{'group'})) ||
		$self->error($self->{'text_hash'}->{'upload_egroup'});
	$self->{'can_mode'} == 0 || $self->{'in_hash'}->{'group_def'} || $self->in_group(\@{$self->{'uinfo_array'}}, \@{$self->{'ginfo_array'}}) ||
		$self->error($self->{'text_hash'}->{'upload_egcannot'});
	}
else {
	# User is fixed
	if ($self->supports_users()) {
		@{$self->{'uinfo_array'}} = getpwnam($self->{'remote_user'});
		}
	}
for($i=0; defined($self->{'d'} = $self->{'in_hash'}->{"upload$i"}); $i++) {
	$self->{'f'} = $self->{'in_hash'}->{"upload${i}_filename"};
	$self->{'found'}++ if ($self->{'d'} && $self->{'f'});
	}
$self->{'found'} || $self->error($self->{'text_hash'}->{'upload_enone'});
$self->can_write_file($self->{'in_hash'}->{'dir'}) ||
	$self->error($self->text('upload_eaccess', "<tt>$self->{'in_hash'}->{'dir'}</tt>", $!));

# Switch to the upload user
$self->switch_uid_to($self->{'uinfo_array'}->[2], defined(@{$self->{'ginfo_array'}}) ? $self->{'ginfo_array'}->[2] : $self->{'uinfo_array'}->[3]);

# Create the directory if needed
if (!-d $self->{'in_hash'}->{'dir'} && $self->{'in_hash'}->{'mkdir'}) {
	mkdir($self->{'in_hash'}->{'dir'}, 0755) || $self->error($self->text('upload_emkdir', $!));
	}

# Save the actual files
for($i=0; defined($self->{'d'} = $self->{'in_hash'}->{"upload$i"}); $i++) {
	$self->{'f'} = $self->{'in_hash'}->{"upload${i}_filename"};
	next if (!$self->{'f'});
	if (-d $self->{'in_hash'}->{'dir'}) {
		$self->{'f'} =~ /([^\\\/]+)$/;
		$self->{'path'} = "$self->{'in_hash'}->{'dir'}/$1";
		}
	else {
		$self->{'path'} = $self->{'in_hash'}->{'dir'};
		}
	if (!$self->open_tempfile(FILE, ">$self->{'path'}", 1)) {
		$self->error($self->text('upload_eopen', "<tt>$self->{'path'}</tt>", $!));
		}
	$self->print_tempfile(FILE, $self->{'d'});
	$self->close_tempfile(FILE);
	push(@{$self->{'uploads_array'}}, $self->{'path'});

	if ($self->{'in_hash'}->{'zip'}) {
		local ($err, $out);
		$self->{'path'} =~ /^(\S*\/)/;
		local $dir = $1;
		local $qdir = quotemeta($dir);
		local $qpath = quotemeta($self->{'path'});
		local @files;
		$self->switch_uid_back();
		if ($self->{'path'} =~ /\.zip$/i) {
			if (!$self->has_command("unzip")) {
				$err = $self->text('upload_ecmd', "unzip");
				}
			else {
				open(OUT, $self->command_as_user($self->{'uinfo_array'}->[0], 0, "(cd $qdir && unzip -o $qpath)")." 2>&1 </dev/null |");
				while(<OUT>) {
					$out .= $_;
					if (/^\s*[a-z]+:\s+(.*)/) {
						push(@files, $1);
						}
					}
				close(OUT);
				$err = $out if ($?);
				}
			}
		elsif ($self->{'path'} =~ /\.tar$/i) {
			if (!$self->has_command("tar")) {
				$err = $self->text('upload_ecmd', "tar");
				}
			else {
				open(OUT, $self->command_as_user($self->{'uinfo_array'}->[0], 0, "(cd $qdir && tar xvf $qpath)")." 2>&1 </dev/null |");
				while(<OUT>) {
					$out .= $_;
					if (/^(.*)/) {
						push(@files, $1);
						}
					}
				close(OUT);
				$err = $out if ($?);
				}
			}
		elsif ($self->{'path'} =~ /\.(tar\.gz|tgz|tar\.bz|tbz|tar\.bz2|tbz2)$/i) {
			local $zipper = $self->{'path'} =~ /bz(2?)$/i ? "bunzip2"
							    : "gunzip";
			if (!$self->has_command("tar")) {
				$err = $self->text('upload_ecmd', "tar");
				}
			elsif (!$self->has_command($zipper)) {
				$err = $self->text('upload_ecmd', $zipper);
				}
			else {
				open(OUT, $self->command_as_user($self->{'uinfo_array'}->[0], 0, "(cd $qdir && $zipper -c $qpath | tar xvf -)")." 2>&1 </dev/null |");
				while(<OUT>) {
					$out .= $_;
					if (/^(.*)/) {
						push(@files, $1);
						}
					}
				close(OUT);
				$err = $out if ($?);
				}
			}
		else {
			# Doesn't look possible
			$err = $self->{'text_hash'}->{'upload_notcomp'};
			}
		$self->switch_uid_to($self->{'uinfo_array'}->[2], defined(@{$self->{'ginfo_array'}}) ? $self->{'ginfo_array'}->[2] : $self->{'uinfo_array'}->[3]);
		if (!$err) {
			local $j = join("<br>",
				map { "&nbsp;&nbsp;<tt>$_</tt>" } @files);
			if ($self->{'in_hash'}->{'zip'} == 2) {
				unlink($self->{'path'});
				$self->{'ext_hash'}->{$self->{'path'}} = $self->{'text_hash'}->{'upload_deleted'}."<br>".$j;
				}
			else {
				$self->{'ext_hash'}->{$self->{'path'}} = $self->{'text_hash'}->{'upload_extracted'}."<br>".$j;
				}
			}
		else {
			$self->{'ext_hash'}->{$self->{'path'}} = $self->text('upload_eextract', $err);
			}
		}
	}

# Switch back to root
$self->switch_uid_back();

$self->ui_print_header(undef, $self->{'text_hash'}->{'upload_title'}, "");

print "<p>$self->{'text_hash'}->{'upload_done'}<p>\n";
foreach $u (@{$self->{'uploads_array'}}) {
	@{$self->{'st_array'}} = stat($u);
	print "<tt>$u</tt> ",@{$self->{'st_array'}} ? "($self->{'st_array'}->[7] bytes)" : "",
	      $self->{'ext_hash'}->{$u} ? " $self->{'ext_hash'}->{$u}" : "","<p>\n";
	}
print "<p>\n";

# Save the settings
if ($self->{'module_info_hash'}->{'usermin'}) {
	$self->lock_file("$self->{'user_module_config_directory'}/config");
	$self->{'userconfig_hash'}->{'dir'} = $self->{'in_hash'}->{'dir'};
	$self->write_file("$self->{'user_module_config_directory'}/config", \%{$self->{'userconfig_hash'}});
	$self->unlock_file("$self->{'user_module_config_directory'}/config");
	}
else {
	$self->lock_file("$self->{'module_config_directory'}/config");
	$self->{'config_hash'}->{'dir_'.$self->{'remote_user'}} = $self->{'in_hash'}->{'dir'};
	$self->{'config_hash'}->{'user_'.$self->{'remote_user'}} = $self->{'in_hash'}->{'user'};
	$self->{'config_hash'}->{'group_'.$self->{'remote_user'}} = $self->{'in_hash'}->{'group_def'} ? undef
							   : $self->{'in_hash'}->{'group'};
	$self->write_file("$self->{'module_config_directory'}/config", \%{$self->{'config_hash'}});
	$self->unlock_file("$self->{'module_config_directory'}/config");
	}

$self->webmin_log("upload", undef, undef, { 'uploads' => \@{$self->{'uploads_array'}} });

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

