#!/usr/bin/perl

&MAIN();

 sub MAIN {
# index.cgi
# Display a table of all filesystems that can be mounted/unmounted by
# a user, due to having the user flag set

&ModuleLoader::preload_module('usermount_class', "usermount::UsermountLib");
$self = new usermount::UsermountLib:: 'usermount_class',%$self;

$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", undef, 0, 1);

@{$self->{'mounts_array'}} = $self->list_mounts();
foreach $m (@{$self->{'mounts_array'}}) {
	$self->parse_options($m->[2], $m->[3]);
	if (defined($self->{'options_hash'}->{'user'})) {
		push(@{$self->{'usermounts_array'}}, $m);
		}
	}
foreach $m ($self->list_mounted()) {
	$self->{'mounted_hash'}->{$m->[0],$m->[1]}++;
	}
if (@{$self->{'usermounts_array'}}) {
	print "<form action=mount.cgi>\n";
	@{$self->{'tds_array'}} = ( "width=25%", "width=25%", "width=25%", "width=10%",
		 "width=15% nowrap" );
	print $self->ui_columns_start([ $self->{'text_hash'}->{'index_dir'},
				  $self->{'text_hash'}->{'index_type'},
				  $self->{'text_hash'}->{'index_dev'},
				  $self->{'text_hash'}->{'index_status'},
				  $self->{'text_hash'}->{'index_action'} ], 100, 0, \@{$self->{'tds_array'}});
	foreach $u (@{$self->{'usermounts_array'}}) {
		local @cols;
		push(@cols, $u->[0]);
		local $fsn = $self->fstype_name($u->[2]);
		push(@cols, $u->[2] eq "*" ? $self->{'text_hash'}->{'index_auto'}
					   : $fsn);
		push(@cols, $self->device_name($u->[1]));
		if ($self->{'mounted_hash'}->{$u->[0],$u->[1]}) {
			# Mounted, show button to un-mount
			push(@cols, $self->{'text_hash'}->{'yes'});
			push(@cols, $self->ui_submit($self->{'text_hash'}->{'index_umount'},
					       "umount_$u->[0]"));
			}
		else {
			# Not mounted
			push(@cols, $self->{'text_hash'}->{'no'});
			if ($u->[3] =~ /encryption/) {
				# Assume a password is needed
				push(@cols, $self->ui_submit($self->{'text_hash'}->{'index_mount2'},
						       "mount_$u->[0]")." ".
					    $self->ui_textbox("pass_$u->[0]",
							undef, 15));
				}
			else {
				push(@cols, $self->ui_submit($self->{'text_hash'}->{'index_mount'},
						       "mount_$u->[0]"));
				}
			}
		print $self->ui_columns_row(\@cols);
		}
	print $self->ui_columns_end();
	print "</form>\n";
	}
else {
	print "<b>$self->{'text_hash'}->{'index_none'}</b><p>\n";
	}

$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});

1;
		
}


1;

