#!/usr/bin/perl

#require './web-lib.pl';

#$domains_dir = "$module_config_directory/domains";
$virtsrv_config_dir = "$config_directory/../virtual-server";
$domains_dir = "$virtsrv_config_dir/domains";
&read_file("$virtsrv_config_dir/config", \%virtsrv_config);
#$domains_dir = "/etc/cpplus/virtual-server/domains";

#do "postfix-lib.pl";

 if ($virtsrv_config{'mail_system'} == 1) {
 	# Using sendmail for email
 	do "sendmail-lib.pl";
 }
 elsif ($virtsrv_config{'mail_system'} == 0) {
 	# Using sendmail for email
 	do "postfix-lib.pl";
 }
 elsif ($virtsrv_config{'mail_system'} == 2) {
 	# Using sendmail for email
 	do "qmail-lib.pl";
 }

do "samba-lib.pl";

# @users = &get_unixusers_list();
# foreach (@users) {
# 	print "==> User: ", $_->{'name'}, "; Group: ", $_->{'gid'}, "; Shell: $_->{shell}", "\n";
# }
# print "=========\nVIRTUAL SERVER USERS\n=========\n";
# @users = &get_virtsrv_users();
# foreach (@users) {
# 	print "==> User: ", $_->{'name'}, "; Group: ", $_->{'gid'}, "; Shell: $_->{shell}", "\n";
# }

# list_domains()
# Returns a list of structures containing information about hosted domains
sub list_domains
{
local (@rv, $d);
opendir(DIR, $domains_dir);
foreach $d (readdir(DIR)) {
	if ($d !~ /^\./ && $d !~ /\.(lock|bak|rpmsave)$/i) {
		push(@rv, &get_domain($d));
		}
	}
closedir(DIR);
return @rv;
}

# get_domain(id, [file])
# Looks up a domain object by ID
sub get_domain
{
local %dom;
local $file = $_[1] || "$domains_dir/$_[0]";
&read_file($file, \%dom) || return undef;
$dom{'file'} = "$domains_dir/$_[0]";
$dom{'id'} = $_[0];
$dom{'mail'} = 1 if (!defined($dom{'mail'}));	# compat - assume mail is on
$dom{'ugid'} = $dom{'gid'} if (!defined($dom{'ugid'}));	# compat - assume same
if ($dom{'disabled'} eq '1') {
	# compat - assume everything was disabled
	$dom{'disabled'} = "unix,web,dns,mail,mysql,postgres";
	}
elsif ($dom{'disabled'}) {
	# compat - user disabled has changed to unix
	$dom{'disabled'} =~ s/user/unix/g;
	}
if (!defined($dom{'created'})) {
	# compat - creation date can be inferred from ID
        $dom{'id'} =~ /^(\d{10})/;
        $dom{'created'} = $1;
        }
if (!defined($dom{'gid'})) {
	# compat - get GID from group name
	$dom{'gid'} = getgrnam($dom{'group'});
	}
if (!defined($dom{'unix'})) {
	# compat - unix is always on
	$dom{'unix'} = 1;
	}
if (!defined($dom{'virt'})) {
	# compat - assume virtual IP if interface assigned
	$dom{'virt'} = $dom{'iface'} ? 1 : 0;
	}
if (!defined($dom{'web_port'}) && $dom{'web'}) {
	# compat - assume web port is current setting
	$dom{'web_port'} = $web_port;
	}
if (!defined($dom{'web_sslport'}) && $dom{'ssl'}) {
	# compat - assume SSL port is current setting
	$dom{'web_sslport'} = $web_sslport;
	}
if (!defined($dom{'prefix'})) {
	# compat - assume that prefix is same as group
	$dom{'prefix'} = $dom{'group'};
	}
if (!defined($dom{'home'})) {
	local @u = getpwnam($dom{'user'});
	$dom{'home'} = $u[7];
	}
return \%dom;
}

# get unix users list
sub list_unixusers {
	my @rv = ();
	my ($name, $pwd, $uid, $gid, $quota, $comment, $gcos, $dir, $shell);
	setpwent();
	while (1) {
		($name, $pwd, $uid, $gid, $quota, $comment, $gcos, $dir, $shell) = getpwent();
		last unless $name;
		push (@rv, {'user' => $name, 'pwd' => $pwd, 'uid' => $uid, 'gid' => $gid, 'shell' => $shell});
	}
	endpwent();
	return @rv;
}

# get virtual server users
sub get_virtsrv_users {
	my @domains = &list_domains();
	my @users = &list_unixusers();
	my @virt_users = ();
	my @tmp_users = ();
	foreach (@domains) {
		my ($dom_gid, $dom_uid) = ($_->{'gid'}, $_->{'uid'});
		@tmp_users = grep {$_->{'gid'} == $dom_gid} @users;
		map {$_->{'owner'}++ if $_->{'uid'} == $dom_uid} @tmp_users;
		push (@virt_users, @tmp_users);
	}
	return @virt_users;
}

# search_virtsrv_user($user, @users)
sub search_virtsrv_user {
	my ($user, @users) = @_;
	foreach (@users) {
		return $_ if $_->{'name'} eq $user;
	}
	return undef;
}

# list_virtusers()
# Returns a list of a virtual mail address mappings. Each may actually have
# an alias as its destination, and is automatically expanded to the
# destinations for that alias.
sub list_virtusers
{
# Build list of unix users, to exclude aliases with same name as users
# (which are picked up by list_domain_users instead).
#&require_mail();
local $u;
setpwent();
while($u = getpwent()) {
	$unix_user{$u}++;
	}
endpwent();

if ($virtsrv_config{'mail_system'} == 1) {
	# Get from sendmail
	local @svirts = &sendmail_list_virtusers($sendmail_vfile);
	local %aliases = map { $_->{'name'}, $_ }
			 grep { $_->{'enabled'} && !$unix_user{$_->{'name'}} }
				&sendmail_list_aliases($sendmail_afiles);
	local ($v, $a, @virts);
	foreach $v (@svirts) {
		local %rv = ( 'virt' => $v,
			      'from' => $v->{'from'} );
		if ($v->{'to'} !~ /\@/ && ($a = $aliases{$v->{'to'}})) {
			# Points to an alias - use its values
			$rv{'to'} = $a->{'values'};
			$rv{'alias'} = $a;
			}
		else {
			# Just the original value
			$rv{'to'} = [ $v->{'to'} ];
			}
		$rv{'user'} = $v->{'to'};
		push(@virts, \%rv);
		}
	return @virts;
	}
elsif ($virtsrv_config{'mail_system'} == 0) {
	# Get from postfix
	local $svirts = &postfix_get_maps($virtual_type);
	local %aliases = map { $_->{'name'}, $_ }
			 grep { $_->{'enabled'} && !$unix_user{$_->{'name'}} }
			     &postfix_list_aliases($postfix_afiles);
	local ($v, $a, @virts);
	foreach $v (@$svirts) {
		local %rv = ( 'from' => $v->{'name'},
			      'virt' => $v );
		if ($v->{'value'} !~ /\@/ && ($a = $aliases{$v->{'value'}})) {
			$rv{'to'} = $a->{'values'};
			$rv{'alias'} = $a;
			}
		else {
			$rv{'to'} = [ $v->{'value'} ];
			}
		local $t;	# postfix format for catchall forward is
				# different from sendmail
		foreach $t (@{$rv{'to'}}) {
			$t =~ s/^\@(\S+)$/\%1\@$1/;
			}
		push(@virts, \%rv);
		}
	return @virts;
	}
elsif ($virtsrv_config{'mail_system'} == 2) {
	# Find all qmail aliases like .qmail-group-user
	local @virtmaps = grep { !$_->{'user'} } &qmail_list_virts();
	local @aliases = &qmail_list_aliases();
	local ($an, $v, @virts);
	foreach $an (@aliases) {
		# Find domain in virtual maps
		local $a = &qmail_get_alias($an);
		local $name = $a->{'name'};
		foreach $v (@virtmaps) {
			if ($a->{'name'} =~ /^\Q$v->{'prepend'}\E\-(.*)$/) {
				$name = $1."\@".$v->{'domain'};
				}
			}
		# XXX need to change alias types?
		push(@virts, { 'from' => $name,
			       'alias' => $a,
			       'to' => [ map { s/^\&//; $_ }
					       @{$a->{'values'}} ] });
		}
	return @virts;
	}
}

# get_virtuser(user_name);
sub get_virtuser {
	#my @users = &list_unixusers();
	my @users = &get_virtsrv_users();
	my @virts = &list_virtusers();
	foreach my $u (@users) {
		foreach my $v (@virts) {
			if (@{$v->{'to'}} == 1 && $v->{'to'}->[0] eq $u->{'user'}) {
				$u->{'email'} = $v->{'from'};
			}
		}
	}
	my ($user) = grep { $_->{'user'} eq $_[0] } @users;
	return $user;
}

1;
1;
