#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_export.cgi
# Allow editing of one export to a client

&ModuleLoader::preload_module('exports_class', "exports::ExportsLib");
$self = new exports::ExportsLib:: 'exports_class',%$self;

$self->ReadParse();
local $via_pfs = 0;
local $nfsv = $self->nfs_max_version("localhost");
if ($self->{'in_hash'}->{'new'}) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'create_title'}, "", "create_export");
	$via_pfs = ($nfsv == 4) ? 1 : 0;
	$self->{'exp'}->{"pfs"} = "/export";
    }
else {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'edit_title'}, "", "edit_export");
	@{$self->{'exps_array'}} = $self->list_exports();
	$self->{'exp'} = $self->{'exps_array'}->[$self->{'in_hash'}->{'idx'}];
	%{$self->{'opts_hash'}} = %{$self->{'exp'}->{'options'}};
	}

# WebNFS doesn't exist on Linux
local $linux = ($self->{'gconfig_hash'}->{'os_type'} =~ /linux/i) ? 1 : 0;

print "<script type=\"text/javascript\">\n";
print "function enable_sec(level) {\n";
print " if (level) {\n";
print "   document.forms[0].sec[1].disabled=0;\n";
print "   document.forms[0].sec[2].disabled=0;\n";
print "   } else {\n";
print "   document.forms[0].sec[1].disabled=1;\n";
print "   document.forms[0].sec[2].disabled=1;\n";
print "   document.forms[0].sec[0].checked=1;\n";
print " }\n}\n";
print "function enable_pfs(enable) {\n";
print" set_pfs_dir();\n";
print "if (enable == 1) {\n";
print "   document.forms[0].pfs.disabled=0;\n";
print "   document.forms[0].pfs_button.disabled=0;\n";
print "   document.forms[0].pfs_dir.disabled=0;\n";
print "   } else {\n";
print "   document.forms[0].pfs.disabled=1;\n";
print "   document.forms[0].pfs_button.disabled=1;\n";
print "   document.forms[0].pfs_dir.disabled=1;\n";
print "   }\n";
print "}\n";
print "function set_pfs_dir() {\n";
print "   var pfs = document.forms[0].pfs.value;\n";
print "   var dir = document.forms[0].dir.value;\n";
print "   if (document.forms[0].via_pfs[0].checked == 0) {\n";
print "      document.forms[0].pfs_dir.value = dir; }\n";
print "   else {\n";
print "      var reg = /\\/\$/;\n";
print "      dir = dir.replace(reg, \"\");\n";
print "      dir = dir.substring(dir.lastIndexOf(\"/\"));\n";
print "      document.forms[0].pfs_dir.value = pfs + dir; }\n";
print "}\n";
print "window.onload = function() {\n";
print "   enable_pfs(document.forms[0].via_pfs[0].checked);\n";
print "   if (document.forms[0].auth[0].checked == 1) {\n";
print "      enable_sec(0); }\n";
print "   else {\n";
print "      enable_sec(1); }\n";
print "   set_pfs_dir();\n";
print "}\n";
print "</script>\n";

print "<form action=save_export.cgi>\n";
print "<input type=hidden name=new value='$self->{'in_hash'}->{'new'}'>\n";
print "<input type=hidden name=idx value='$self->{'in_hash'}->{'idx'}'>\n";

print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'edit_details'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table>\n";

# Show NFS pseudofilesystem (NFSv4)
if ($nfsv == 4) {
    print "<tr> <td>",$self->hlink("<b>$self->{'text_hash'}->{'edit_nfs_vers'}</b>","vers"),"</td>\n";
    printf "<td colspan=3><input type=radio name=via_pfs value=1 %s onclick=enable_pfs(1)> 4\n",
    $via_pfs ? "checked" : "";
    printf "<input type=radio name=via_pfs value=0 %s onclick=enable_pfs(0)> 3 (or lower)</td> </tr>\n",
    $via_pfs ? "" : "checked";
    
    print "<tr> <td>",$self->hlink("<b>$self->{'text_hash'}->{'edit_pfs'}</b>","pfs"),"</td>\n";
    printf "<td colspan=3><input name=pfs size=40 value=\"$self->{'exp'}->{'pfs'}\" onkeyup=set_pfs_dir()>";
    print $self->file_chooser_button2("pfs", 1, "pfs_button", ($via_pfs == 0)),"</td> </tr>\n";
} else {
    printf "<tr><td><input type=hidden name=via_pfs value=0></td></tr>\n";
}

# Show directory input
print "<tr> <td>",$self->hlink("<b>$self->{'text_hash'}->{'edit_dir'}</b>","dir"),"</td>\n";
print "<td colspan=3><input name=dir size=40 value=\"$self->{'exp'}->{'dir'}\" onkeyup=set_pfs_dir()>",
    $self->file_chooser_button("dir", 1);
if ($nfsv == 4) {
    print "$self->{'text_hash'}->{'edit_in'} <input style=\"background: rgb(238, 238, 238)\" name=pfs_dir size=40 readonly></td> </tr>\n";
}

# Show active input
print "<tr> <td>",$self->hlink("<b>$self->{'text_hash'}->{'edit_active'}</b>","active"),"</td>\n";
printf "<td colspan=3><input type=radio name=active value=1 %s> $self->{'text_hash'}->{'yes'}\n",
    $self->{'in_hash'}->{'new'} || $self->{'exp'}->{'active'} ? 'checked' : '';
printf "<input type=radio name=active value=0 %s> $self->{'text_hash'}->{'no'}</td> </tr>\n",
    $self->{'in_hash'}->{'new'} || $self->{'exp'}->{'active'} ? '' : 'checked';

# Show input for export to
local $h = $self->{'exp'}->{'host'};
if ($h eq "=public") { $self->{'mode'} = 0; }
elsif ($h =~ /^gss\//) {$self->{'mode'} = 5; }
elsif ($h =~ /^\@(.*)/) { $self->{'mode'} = 1; $self->{'netgroup'} = $1; }
elsif ($h =~ /^(\S+)\/(\S+)$/) { $self->{'mode'} = 2; $self->{'network'} = $1; $self->{'netmask'} = $2; }
elsif ($h eq "") { $self->{'mode'} = 3; }
else { $self->{'mode'} = 4; $self->{'host'} = $h; }
# and authentication input
local $auth = "", $sec = "";
if ($h =~ /^gss\/krb5/) {
    $auth = "krb5";
    if ($h =~ /i$/) { $sec = "i"; }
    if ($h =~ /p$/) { $sec = "p"; }
}

print "<tr><td rowspan=8 valign=top>",$self->hlink("<b>$self->{'text_hash'}->{'edit_to'}</b>","client");
if ($nfsv == 4) {
    print "<br>",$self->hlink("$self->{'text_hash'}->{'edit_auth'}","auth"),"</td>\n";
    
    printf "<td rowspan=5><input type=radio name=auth value=0 %s onclick=enable_sec(0)> sys</td>\n",
    ($auth eq "") ? "checked" : "";
} else {
    printf "<td><input type=hidden name=auth value=0></td>\n";
}
printf "<tr><td><input type=radio name=mode value=3 %s> $self->{'text_hash'}->{'edit_all'} </td>\n",
	$self->{'mode'} == 3 ? "checked" : "";

printf "<td colspan=2><input type=radio name=mode value=4 %s> $self->{'text_hash'}->{'edit_host'}\n",
	$self->{'mode'} == 4 ? "checked" : "";
print "<input name=host size=35 value='$self->{'host'}'></td> </tr>\n";

printf "<tr><td><input type=radio name=mode value=0 %s %s> $self->{'text_hash'}->{'edit_webnfs'}</td>\n",
	$self->{'mode'} == 0 ? "checked" : "", $linux ? "disabled" : "";

printf "<td colspan=2><input type=radio name=mode value=1 %s> $self->{'text_hash'}->{'edit_netgroup'}\n",
	$self->{'mode'} == 1 ? "checked" : "";
print "<input name=netgroup size=25 value='$self->{'netgroup'}'></td> </tr>\n";

printf "<tr><td colspan=3><input type=radio name=mode value=2 %s> IPv4 $self->{'text_hash'}->{'edit_network'}\n",
	$self->{'mode'} == 2 ? "checked" : "";
print "<input name=network size=15 value='$self->{'network'}'>\n";
print "$self->{'text_hash'}->{'edit_netmask'} <input name=netmask size=15 value='$self->{'netmask'}'></td> </tr>\n";

printf "<tr><td colspan=3><input type=radio name=mode value=6 %s disabled> IPv6 $self->{'text_hash'}->{'edit_address'}\n",
    $self->{'mode'} == 6 ? "checked" : "";
print "<input name=address size=39 value='$self->{'address'}' disabled>\n";
print "$self->{'text_hash'}->{'edit_prefix'}<input name=prefix size=2 value='$self->{'prefix'}' disabled></td> </tr>\n";

if ($nfsv == 4) {
    printf "<tr><td colspan=3><input type=radio name=auth value=1 %s onclick=enable_sec(1)> krb5</td></tr>",
    ($auth eq "krb5") ? "checked" : "";
    printf "<tr><td colspan=3><input type=radio name=auth value=2 %s disabled> lipkey</td></tr>\n",
    ($auth eq "lipkey") ? "checked" : "";
    printf "<tr><td colspan=3><input type=radio name=auth value=3 %s disabled> spkm-3</td></tr>\n",
    ($auth eq "spkm") ? "checked" : "";

# Show security level input
print "<tr> <td>", $self->hlink("<b>$self->{'text_hash'}->{'edit_sec'}</b>", "sec"), "</td>\n";
printf "<td nowrap colspan=3><input type=radio name=sec value=0 %s> $self->{'text_hash'}->{'config_none'}\n",
    ($sec eq "") ? "checked" : "";
printf "<input type=radio name=sec value=1 %s> $self->{'text_hash'}->{'edit_integrity'}\n",
    ($sec eq "i") ? "checked" : "";
printf "<input type=radio name=sec value=2 %s> $self->{'text_hash'}->{'edit_privacy'}</td></tr>\n",
    ($sec eq "p") ? "checked" : "";
}

print "</table></td></tr></table><p>\n";
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'edit_security'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

# Show read-only input
print "<tr> <td>",$self->hlink("<b>$self->{'text_hash'}->{'edit_ro'}</b>","ro"),"</td>\n";
printf "<td><input type=radio name=ro value=1 %s> $self->{'text_hash'}->{'yes'}\n",
	defined($self->{'opts_hash'}->{'rw'}) ? "" : "checked";
printf "<input type=radio name=ro value=0 %s> $self->{'text_hash'}->{'no'}</td>\n",
	defined($self->{'opts_hash'}->{'rw'}) ? "checked" : "";

# Show input for secure port
print "<td>",$self->hlink("<b>$self->{'text_hash'}->{'edit_insecure'}</b>","insecure"),"</td>\n";
printf "<td><input type=radio name=insecure value=0 %s> $self->{'text_hash'}->{'yes'}\n",
	defined($self->{'opts_hash'}->{'insecure'}) ? "" : "checked";
printf "<input type=radio name=insecure value=1 %s> $self->{'text_hash'}->{'no'}</td> </tr>\n",
	defined($self->{'opts_hash'}->{'insecure'}) ? "checked" : "";

# Show subtree check input
print "<tr> <td>",$self->hlink("<b>$self->{'text_hash'}->{'edit_subtree_check'}</b>","subtree_check"),"</td>\n";
printf "<td><input type=radio name=no_subtree_check value=1 %s> $self->{'text_hash'}->{'yes'}\n",
    defined($self->{'opts_hash'}->{'no_subtree_check'}) ? "checked" : "";
printf "<input type=radio name=no_subtree_check value=0 %s> $self->{'text_hash'}->{'no'}\n",
    defined($self->{'opts_hash'}->{'no_subtree_check'}) ? "" : "checked";
print "</td>\n";

# Show nohide check input
print "<td>",$self->hlink("<b>$self->{'text_hash'}->{'edit_hide'}</b>","hide"),"</td>\n";
printf "<td><input type=radio name=nohide value=0 %s> $self->{'text_hash'}->{'yes'}\n",
	defined($self->{'opts_hash'}->{'nohide'}) ? "" : "checked";
printf "<input type=radio name=nohide value=1 %s> $self->{'text_hash'}->{'no'}</td> </tr>\n",
	defined($self->{'opts_hash'}->{'nohide'}) ? "checked" : "";

# Show sync input
local $sync = defined($self->{'opts_hash'}->{'sync'}) ? 1 : defined($self->{'opts_hash'}->{'async'}) ? 2 : 0;
print "<tr> <td>",$self->hlink("<b>$self->{'text_hash'}->{'edit_sync'}</b>","sync"),"</td>\n<td colspan=3>";
foreach $s (1, 2, 0) {
	printf "<input type=radio name=sync value=%d %s> %s\n",
		$s, $sync == $s ? "checked" : "", $self->{'text_hash'}->{'edit_sync'.$s};
	}
print "</td> </tr>\n";

# Show root trust input
print "<tr> <td>",$self->hlink("<b>$self->{'text_hash'}->{'edit_squash'}</b>","squash"),"</td> <td colspan=3>\n";
printf "<input type=radio name=squash value=0 %s> $self->{'text_hash'}->{'edit_everyone'}\n",
	defined($self->{'opts_hash'}->{'no_root_squash'}) ? "checked" : "";
printf "<input type=radio name=squash value=1 %s> $self->{'text_hash'}->{'edit_except'}\n",
	!defined($self->{'opts_hash'}->{'no_root_squash'}) &&
	!defined($self->{'opts_hash'}->{'all_squash'}) ? "checked" : "";
printf "<input type=radio name=squash value=2 %s> $self->{'text_hash'}->{'edit_nobody'}\n";
	defined($self->{'opts_hash'}->{'all_squash'}) ? "checked" : "";
print "</td> </tr>\n";

# Show untrusted user input
print "<tr> <td>",$self->hlink("<b>$self->{'text_hash'}->{'edit_anonuid'}</b>","anonuid"),"</td> <td>\n";
printf "<input type=radio name=anonuid_def value=1 %s> $self->{'text_hash'}->{'edit_default'}\n",
    defined($self->{'opts_hash'}->{'anonuid'}) ? "" : "checked";
printf "<input type=radio name=anonuid_def value=0 %s>\n",
    defined($self->{'opts_hash'}->{'anonuid'}) ? "checked" : "";
printf "<input name=anonuid size=8 value=\"%s\">\n",
    $self->{'opts_hash'}->{'anonuid'} ? getpwuid($self->{'opts_hash'}->{'anonuid'}) : "";
print $self->user_chooser_button("anonuid", 0),"</td>\n";

# Show untrusted group input
print "<td>",$self->hlink("<b>$self->{'text_hash'}->{'edit_anongid'}</b>","anongid"),"</td> <td>\n";
printf "<input type=radio name=anongid_def value=1 %s> $self->{'text_hash'}->{'edit_default'}\n",
    defined($self->{'opts_hash'}->{'anongid'}) ? "" : "checked";
printf "<input type=radio name=anongid_def value=0 %s>\n",
    defined($self->{'opts_hash'}->{'anongid'}) ? "checked" : "";
printf "<input name=anongid size=8 value=\"%s\">\n",
    $self->{'opts_hash'}->{'anongid'} ? getgrgid($self->{'opts_hash'}->{'anongid'}) : "";
print $self->group_chooser_button("anongid", 0),"</td> </tr>\n";

print "<tr $self->{'tb'}> <td colspan=4><b>$self->{'text_hash'}->{'edit_v2opts'}</b></td> </tr>\n";

# Show input for relative symlinks
print "<tr> <td>",$self->hlink("<b>$self->{'text_hash'}->{'edit_relative'}</b>","link_relative"),"</td>\n";
printf "<td><input type=radio name=link_relative value=1 %s> $self->{'text_hash'}->{'yes'}\n",
    defined($self->{'opts_hash'}->{'link_relative'}) ? "checked" : "";
printf "<input type=radio name=link_relative value=0 %s> $self->{'text_hash'}->{'no'}</td>\n",
    defined($self->{'opts_hash'}->{'link_relative'}) ? "" : "checked";

# Show deny access input
print "<td>",$self->hlink("<b>$self->{'text_hash'}->{'edit_noaccess'}</b>","noaccess"),"</td>\n";
printf "<td><input type=radio name=noaccess value=1 %s> $self->{'text_hash'}->{'yes'}\n",
    defined($self->{'opts_hash'}->{'noaccess'}) ? "checked" : "";
printf "<input type=radio name=noaccess value=0 %s> $self->{'text_hash'}->{'no'}</td> </tr>\n",
    defined($self->{'opts_hash'}->{'noaccess'}) ? "" : "checked";

# Show untrusted UIDs input
print "<tr> <td>",$self->hlink("<b>$self->{'text_hash'}->{'edit_uids'}</b>","squash_uids"),"</td> <td>\n";
printf "<input type=radio name=squash_uids_def value=1 %s> $self->{'text_hash'}->{'edit_none'}\n",
    $self->{'opts_hash'}->{'squash_uids'} ? "" : "checked";
printf "<input type=radio name=squash_uids_def value=0 %s>\n",
    $self->{'opts_hash'}->{'squash_uids'} ? "checked" : "";
printf "<input name=squash_uids size=15 value=\"%s\"></td>\n",
    $self->{'opts_hash'}->{'squash_uids'};

# Show untrusted GIDs input
print "<td>",$self->hlink("<b>$self->{'text_hash'}->{'edit_gids'}</b>","squash_gids"),"</td> <td>\n";
printf "<input type=radio name=squash_gids_def value=1 %s> $self->{'text_hash'}->{'edit_none'}\n",
    $self->{'opts_hash'}->{'squash_gids'} ? "" : "checked";
printf "<input type=radio name=squash_gids_def value=0 %s>\n",
    $self->{'opts_hash'}->{'squash_gids'} ? "checked" : "";
printf "<input name=squash_gids size=15 value=\"%s\"></td> </tr>\n",
    $self->{'opts_hash'}->{'squash_gids'};

print "</table></td></tr></table>\n";
if (!$self->{'in_hash'}->{'new'}) {
	print "<table width=100%><tr>\n";
	print "<td><input type=submit value=\"$self->{'text_hash'}->{'save'}\"></td>\n";
	print "<td align=right><input type=submit name=delete ",
	      "value=\"$self->{'text_hash'}->{'delete'}\"></td>\n";
	print "</tr></table>\n";
	}
else {
	print "<input type=hidden name=new value=1>\n";
	print "<input type=submit value=\"$self->{'text_hash'}->{'create'}\">\n";
	}

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
1;
		
}


1;

