#!/usr/bin/perl

&MAIN();

 sub MAIN {
# index.cgi
# Display a list of directories and their client(s)

$| = 1;
&ModuleLoader::preload_module('exports_class', "exports::ExportsLib");
$self = new exports::ExportsLib:: 'exports_class',%$self;

$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", "intro", 1, 1, 0,
	$self->help_search_link("nfs exports", "man", "howto"));

if (!$self->has_nfs_commands()) {
	print $self->{'text_hash'}->{'index_eprog'},"<p>\n";
	$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});
	exit;
	}

# Display table of exports and clients
@{$self->{'exps_array'}} = $self->list_exports();
if (@{$self->{'exps_array'}}) {
	print $self->ui_form_start("delete_exports.cgi", "post");
	@{$self->{'dirs_array'}} = $self->unique(map { $_->{'dir'} } @{$self->{'exps_array'}});

	# Directory list heading
	@{$self->{'links_array'}} = ( $self->select_all_link("d"),
		   $self->select_invert_link("d"),
		   "<a href=\"edit_export.cgi?new=1\">$self->{'text_hash'}->{'index_add'}</a>" );
	print $self->ui_links_row(\@{$self->{'links_array'}});
	@{$self->{'tds_array'}} = ( "width=5" );
	print $self->ui_columns_start([ "",
				  $self->{'text_hash'}->{'index_dir'},
				  $self->{'text_hash'}->{'index_to'} ], 100, 0, \@{$self->{'tds_array'}});

	# Rows for directories and clients
	foreach $d (@{$self->{'dirs_array'}}) {
		local @cols;
		push(@cols, $self->html_escape($d));
		local $dirs;
		@{$self->{'cl_array'}} = grep { $_->{'dir'} eq $d } @{$self->{'exps_array'}};
	    	$self->{'ccount'} = 0;
		foreach $c (@{$self->{'cl_array'}}) {
			$dirs .= "&nbsp;|&nbsp; " if ($self->{'ccount'}++);
			$dirs .= "<a href='edit_export.cgi?idx=$c->{'index'}'>".
				 $self->describe_host($c->{'host'})."</a>\n";
			 if (!$c->{'active'}) {
				$dirs .= "<font color=#ff0000>(".
					 $self->{'text_hash'}->{'index_inactive'}.")</font>\n"
				}
			}
		push(@cols, $dirs);
		print $self->ui_checked_columns_row(\@cols, \@{$self->{'tds_array'}}, "d", $d);
		}
	print $self->ui_columns_end();
	print $self->ui_links_row(\@{$self->{'links_array'}});
	print $self->ui_form_end([ [ "delete", $self->{'text_hash'}->{'index_delete'} ],
			     [ "disable", $self->{'text_hash'}->{'index_disable'} ],
			     [ "enable", $self->{'text_hash'}->{'index_enable'} ] ]);
	}
else {
	print "<b>$self->{'text_hash'}->{'index_none'}</b> <p>\n";
	print "<a href=\"edit_export.cgi?new=1\">$self->{'text_hash'}->{'index_add'}</a> <p>\n";
	}

print "<hr>\n";
print "<table width=100%> <tr>\n";
print "<td><form action=restart_mountd.cgi>\n";
print "<input type=submit value=\"$self->{'text_hash'}->{'index_apply'}\">\n";
print "</form></td>\n";
print "<td valign=top>$self->{'text_hash'}->{'index_applymsg'}</td>\n";
print "</tr> <tr> </table>\n";

$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});

1;
		
}


1;

