#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_export.cgi
# Save, create or delete an export

&ModuleLoader::preload_module('exports_class', "exports::ExportsLib");
$self = new exports::ExportsLib:: 'exports_class',%$self;

$self->ReadParse();
$self->lock_file($self->{'config_hash'}->{'exports_file'});
@{$self->{'exps_array'}} = $self->list_exports();

if ($self->{'in_hash'}->{'delete'}) {
	# Deleting some export
	$self->{'exp'} = $self->{'exps_array'}->[$self->{'in_hash'}->{'idx'}];
	$self->delete_export($self->{'exp'});
	}
else {
	if (!$self->{'in_hash'}->{'new'}) {
		# Get old export
		$self->{'oldexp'} = $self->{'exps_array'}->[$self->{'in_hash'}->{'idx'}];
		%{$self->{'opts_hash'}} = %{$self->{'oldexp'}->{'options'}};
		}

	# Validate and parse inputs
	$self->error_setup($self->{'text_hash'}->{'save_err'});
	$self->{'exp_hash'}->{'via_pfs'} = ($self->{'exp_hash'}->{'pfs'} ne "") ? $self->{'in_hash'}->{'via_pfs'} : 0;
	-d $self->{'in_hash'}->{'dir'} || $self->error($self->text('save_edir', $self->{'in_hash'}->{'dir'}));
	$self->{'exp_hash'}->{'dir'} = $self->{'in_hash'}->{'dir'};
	$self->{'exp_hash'}->{'pfs'} = $self->{'in_hash'}->{'pfs'};
	$self->{'exp_hash'}->{'active'} = $self->{'in_hash'}->{'active'};
	
	if ($self->{'in_hash'}->{'mode'} == 0) { $self->{'exp_hash'}->{'host'} = "=public"; }
	elsif ($self->{'in_hash'}->{'mode'} == 1) {
		$self->{'in_hash'}->{'netgroup'} =~ /^\S+$/ ||
			$self->error($self->{'text_hash'}->{'save_enetgroup'});
		$self->{'exp_hash'}->{'host'} = '@'.$self->{'in_hash'}->{'netgroup'};
		}
	elsif ($self->{'in_hash'}->{'mode'} == 2) {
		$self->check_ipaddress($self->{'in_hash'}->{'network'}) ||
			$self->error($self->text('save_enetwork', $self->{'in_hash'}->{'network'}));
		$self->check_ipaddress($self->{'in_hash'}->{'netmask'}) ||
			$self->error($self->text('save_enetmask', $self->{'in_hash'}->{'netmask'}));
		$self->{'exp_hash'}->{'host'} = $self->{'in_hash'}->{'network'}."/".$self->{'in_hash'}->{'netmask'};
		}
	elsif ($self->{'in_hash'}->{'mode'} == 3) { $self->{'exp_hash'}->{'host'} = ""; }
	else {
		$self->{'in_hash'}->{'host'} =~ /\*/ || gethostbyname($self->{'in_hash'}->{'host'}) ||
			$self->error($self->text('save_ehost', $self->{'in_hash'}->{'host'}));
		$self->{'exp_hash'}->{'host'} = $self->{'in_hash'}->{'host'};
		}

	# Authentication is in the host name
	# Only sys and krb5 for the moment
	local $auth = "";
	if ($self->{'in_hash'}->{'auth'}) {
	    if ($self->{'in_hash'}->{'sec'} == 0) { $auth = "krb5"; }
	    if ($self->{'in_hash'}->{'sec'} == 1) { $auth = "krb5i"; }
	    if ($self->{'in_hash'}->{'sec'} == 2) { $auth = "krb5p"; }
	}
	if ($auth ne "") { $self->{'exp_hash'}->{'host'} = "gss/$auth"; }

	# validate and parse options
	delete($self->{'opts_hash'}->{'rw'}); delete($self->{'opts_hash'}->{'ro'});
	if ($self->{'in_hash'}->{'ro'}) {
	    $self->{'opts_hash'}->{'ro'} = "";
	} else {
	    $self->{'opts_hash'}->{'rw'} = "";
	}
	
	delete($self->{'opts_hash'}->{'secure'}); delete($self->{'opts_hash'}->{'insecure'});
	$self->{'opts_hash'}->{'insecure'} = "" if ($self->{'in_hash'}->{'insecure'});

	delete($self->{'opts_hash'}->{'no_subtree_check'}); delete($self->{'opts_hash'}->{'subtree_check'});
	$self->{'opts_hash'}->{'no_subtree_check'} = "" if ($self->{'in_hash'}->{'no_subtree_check'});

	delete($self->{'opts_hash'}->{'nohide'}); delete($self->{'opts_hash'}->{'hide'});
	$self->{'opts_hash'}->{'nohide'} = "" if ($self->{'in_hash'}->{'nohide'});
	
	delete($self->{'opts_hash'}->{'sync'}); delete($self->{'opts_hash'}->{'async'});
	if ($self->{'in_hash'}->{'sync'} == 1) {
	    $self->{'opts_hash'}->{'sync'} = "";
	} elsif ($self->{'in_hash'}->{'sync'} == 2) {
	    $self->{'opts_hash'}->{'async'} = "";
	}

	delete($self->{'opts_hash'}->{'root_squash'}); delete($self->{'opts_hash'}->{'no_root_squash'});
	delete($self->{'opts_hash'}->{'all_squash'}); delete($self->{'opts_hash'}->{'no_all_squash'});
	$self->{'opts_hash'}->{'no_root_squash'} = "" if ($self->{'in_hash'}->{'squash'} == 0);
	$self->{'opts_hash'}->{'all_squash'} = "" if ($self->{'in_hash'}->{'squash'} == 2);

	if ($self->{'in_hash'}->{'anonuid_def'}) { delete($self->{'opts_hash'}->{'anonuid'}); }
	elsif ($self->{'in_hash'}->{'anonuid'} =~ /^-?[0-9]+$/) {
	    $self->{'opts_hash'}->{'anonuid'} = $self->{'in_hash'}->{'anonuid'}; }
	else { $self->{'opts_hash'}->{'anonuid'} = getpwnam($self->{'in_hash'}->{'anonuid'}); }

	if ($self->{'in_hash'}->{'anongid_def'}) { delete($self->{'opts_hash'}->{'anongid'}); }
	elsif ($self->{'in_hash'}->{'anongid'} =~ /^-?[0-9]+$/) {
	    $self->{'opts_hash'}->{'anongid'} = $self->{'in_hash'}->{'anongid'}; }
	else { $self->{'opts_hash'}->{'anongid'} = getgrnam($self->{'in_hash'}->{'anongid'}); }

	# NFSv2 specific options
	delete($self->{'opts_hash'}->{'link_relative'}); delete($self->{'opts_hash'}->{'link_absolute'});
	delete($self->{'opts_hash'}->{'noaccess'});
	delete($self->{'opts_hash'}->{'squash_uids'});
	delete($self->{'opts_hash'}->{'squash_gids'});
	delete($self->{'opts_hash'}->{'map_daemon'});

	if ($self->nfs_max_version("localhost") == 2) {
	    $self->{'opts_hash'}->{'link_relative'} = "" if ($self->{'in_hash'}->{'link_relative'});
	    $self->{'opts_hash'}->{'noaccess'} = "" if ($self->{'in_hash'}->{'noaccess'});

	    if (!$self->{'in_hash'}->{'squash_uids_def'}) {
		if ($self->{'in_hash'}->{'squash_uids'} !~ /^[\d+\-\,]+$/) {
		    $self->error($self->{'text_hash'}->{'save_euids'});
		} else {
		    $self->{'opts_hash'}->{'squash_uids'} = $self->{'in_hash'}->{'squash_uids'};
		    $self->{'opts_hash'}->{'map_daemon'} = "";
		}
	    }
	    
	    if (!$self->{'in_hash'}->{'squash_gids_def'}) {
		if ($self->{'in_hash'}->{'squash_gids'} !~ /^[\d+\-\,]+$/) {
		    $self->error($self->{'text_hash'}->{'save_egids'});
		} else {
		    $self->{'opts_hash'}->{'squash_gids'} = $self->{'in_hash'}->{'squash_gids'};
		    $self->{'opts_hash'}->{'map_daemon'} = "";
		}
	    }
	}

	$self->{'exp_hash'}->{'options'} = \%{$self->{'opts_hash'}};
	if ($self->{'in_hash'}->{'new'}) {
	    if ($self->{'in_hash'}->{'via_pfs'} == 1) {
		$self->create_export_via_pfs(\%{$self->{'exp_hash'}});
	    } else {
		$self->create_export(\%{$self->{'exp_hash'}});
	    }
	} else {
	    $self->modify_export(\%{$self->{'exp_hash'}}, $self->{'oldexp'});
	}
    }
$self->unlock_file($self->{'config_hash'}->{'exports_file'});
if ($self->{'in_hash'}->{'delete'}) {
	$self->webmin_log("delete", "export", $self->{'exp'}->{'dir'}, $self->{'exp'});
	}
elsif ($self->{'in_hash'}->{'new'}) {
	$self->webmin_log("create", "export", $self->{'exp_hash'}->{'dir'}, \%{$self->{'exp_hash'}});
	}
else {
	$self->webmin_log("modify", "export", $self->{'exp_hash'}->{'dir'}, \%{$self->{'exp_hash'}});
	}
$self->redirect("");

1;
		
}


1;

