#!/usr/bin/perl
package fdisk::Log_parser;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'fdisk::Log_parser');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# log_parser.pl
# Functions for parsing this module's logs

&ModuleLoader::preload_module(ref($self), "fdisk::FdiskLib");
$self = new fdisk::FdiskLib:: ref($self), %$self; 

1;
		return $self;
}

# parse_webmin_log(user, script, action, type, object, &params)
# Converts logged information from this module into human-readable form
sub parse_webmin_log
{
	my $self = shift;

local ($user, $script, $action, $type, $object, $p) = @_;
if ($type eq 'part') {
	return $self->text("log_${action}", $self->part_name2($object, $p->{'np'}));
	}
elsif ($action eq 'mkfs' || $action eq 'tunefs' || $action eq 'fsck') {
	return $self->text("log_${action}", "<tt>".uc($p->{'type'})."</tt>",
		     $self->part_name($object));
	}
elsif ($action eq 'hdparm') {
	return $self->text('log_hdparm', $self->device_name($object));
	}
else {
	return undef;
	}
}

sub part_name2
{
	my $self = shift;

return $_[0] =~ /^\/dev\/(s|h)d([a-z])$/ ?
	$self->text('select_part', $1 eq 's' ? 'SCSI' : 'IDE', uc($2), $_[1]) :
       $_[0] =~ /rd\/c(\d+)d(\d+)$/ ?
	$self->text('select_mpart', "$1", "$2", $_[1]) :
       $_[0] =~ /ida\/c(\d+)d(\d+)$/ ?
	$self->text('select_cpart', "$1", "$2", $_[1]) :
	$_[0];
}

sub part_name
{
	my $self = shift;

return $_[0] =~ /^\/dev\/(s|h)d([a-z])(\d+)$/ ?
	$self->text('select_part', $1 eq 's' ? 'SCSI' : 'IDE', uc($2), "$3") :
       $_[0] =~ /rd\/c(\d+)d(\d+)p(\d+)$/ ?
	$self->text('select_mpart', "$1", "$2", "$3") :
       $_[0] =~ /ida\/c(\d+)d(\d+)p(\d+)$/ ?
	$self->text('select_cpart', "$1", "$2", "$3") :
	$_[0];
}

sub device_name
{
	my $self = shift;

return $_[0] =~ /^\/dev\/(s|h)d([a-z])$/ ?
	$self->text('select_device', $1 eq 's' ? 'SCSI' : 'IDE', uc($2)) :
       $_[0] =~ /rd\/c(\d+)d(\d+)$/ ?
	$self->text('select_mylex', "$1", "$2") :
       $_[0] =~ /ida\/c(\d+)d(\d+)$/ ?
	$self->text('select_cpq', "$1", "$2") :
	$_[0];
}


1;

