#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_part.cgi
# Edit an existing partition, or create a new one

&ModuleLoader::preload_module('fdisk_class', "fdisk::FdiskLib");
$self = new fdisk::FdiskLib:: 'fdisk_class',%$self;

$self->ReadParse();
@{$self->{'dlist_array'}} = $self->list_disks_partitions();
$self->{'dinfo'} = $self->{'dlist_array'}->[$self->{'in_hash'}->{'disk'}];
$self->can_edit_disk($self->{'dinfo'}->{'device'}) ||
	$self->error($self->{'text_hash'}->{'edit_ecannot'});
if ($self->{'in_hash'}->{'new'}) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'create_title'}, "");
	}
else {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'edit_title'}, "");
	}

print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'edit_details'}</b></td> </tr>\n";
print "<form action=save_part.cgi><tr $self->{'cb'}><td><table width=100%>\n";
print "<input type=hidden name=disk value=$self->{'in_hash'}->{'disk'}>\n";
print "<input type=hidden name=part value=$self->{'in_hash'}->{'part'}>\n";
print "<input type=hidden name=new value=$self->{'in_hash'}->{'new'}>\n";
@{$self->{'plist_array'}} = @{$self->{'dinfo'}->{'parts'}};
if ($self->{'in_hash'}->{'new'}) {
	if ($self->{'in_hash'}->{'new'} == 1 || $self->{'in_hash'}->{'new'} == 3) {
		# Adding a new primary or extended partition
		$self->{'np'} = 1;
		for($i=0; $i<@{$self->{'plist_array'}}; $i++) {
			if ($self->{'plist_array'}->[$i]->{'number'} == $self->{'np'}) { $self->{'np'}++; }
			push(@{$self->{'start_array'}}, $self->{'plist_array'}->[$i]->{'start'});
			push(@{$self->{'end_array'}}, $self->{'plist_array'}->[$i]->{'end'});
			}
		$self->{'min'} = 1;
		$self->{'max'} = $self->{'dinfo'}->{'cylinders'};
		}
	else {
		# Adding a new logical partition (inside the extended partition)
		$self->{'np'} = 5;
		for($i=0; $i<@{$self->{'plist_array'}}; $i++) {
			if ($self->{'plist_array'}->[$i]->{'number'} == $self->{'np'}) { $self->{'np'}++; }
			if ($self->{'plist_array'}->[$i]->{'extended'}) {
				$self->{'min'} = $self->{'plist_array'}->[$i]->{'start'};
				$self->{'max'} = $self->{'plist_array'}->[$i]->{'end'};
				}
			else {
				push(@{$self->{'start_array'}}, $self->{'plist_array'}->[$i]->{'start'});
				push(@{$self->{'end_array'}}, $self->{'plist_array'}->[$i]->{'end'});
				}
			}
		}
	print "<input type=hidden name=newpart value=$self->{'np'}>\n";
	print "<input type=hidden name=min value=$self->{'min'}>\n";
	print "<input type=hidden name=max value=$self->{'max'}>\n";

	# find a gap in the partition map
	for($start=$self->{'min'}; $start<=$self->{'max'}; $start++) {
		$self->{'found'} = 1;
		for($i=0; $i<@{$self->{'start_array'}}; $i++) {
			if ($start >= $self->{'start_array'}->[$i] && $start <= $self->{'end_array'}->[$i]) {
				$self->{'found'} = 0;
				last;
				}
			}
		if ($self->{'found'}) { last; }
		}
	if ($self->{'found'}) {
		# starting place found.. find the end
		$self->{'found'} = 0;
		for($end=$start; $end<=$self->{'max'}; $end++) {
			for($i=0; $i<@{$self->{'start_array'}}; $i++) {
				if ($end >= $self->{'start_array'}->[$i] && $end <= $self->{'end_array'}->[$i]) {
					$self->{'found'} = 1;
					last;
					}
				}
			if ($self->{'found'}) { last; }
			}
		$end--;
		}
	else {
		# no place for new partition!
		$start = $end = 0;
		}
	}
else { 
	# Just editing an existing partition
	$self->{'pinfo'} = $self->{'plist_array'}->[$self->{'in_hash'}->{'part'}];
	$self->{'np'} = $self->{'pinfo'}->{'number'};
	}
print "<input type=hidden name=np value=$self->{'np'}>\n";

print "<tr> <td valign=top><b>$self->{'text_hash'}->{'edit_location'}</b></td>\n";
print "<td>",$self->{'dinfo'}->{'device'} =~ /^\/dev\/(s|h)d([a-z])$/ ?
		$self->text('select_part', $1 eq 's' ? 'SCSI' : 'IDE', uc($2), $self->{'np'}) :
	     $self->{'dinfo'}->{'device'} =~ /rd\/c(\d+)d(\d+)$/ ?
		$self->text('select_mpart', "$1", "$2", $self->{'np'}) :
	     $self->{'dinfo'}->{'device'} =~ /ida\/c(\d+)d(\d+)$/ ?
		$self->text('select_cpart', "$1", "$2", $self->{'np'}) :
	     $self->{'dinfo'}->{'device'} =~ /scsi\/host(\d+)\/bus(\d+)\/target(\d+)\/lun(\d+)\/disc/ ?
		$self->text('select_spart', "$1", "$2", "$3", "$4", $self->{'np'}) :
	     $self->{'dinfo'}->{'device'} =~ /ide\/host(\d+)\/bus(\d+)\/target(\d+)\/lun(\d+)\/disc/ ?
		$self->text('select_snewide', "$1", "$2", "$3", "$4", $self->{'np'}) :
		$self->{'dinfo'}->{'device'},"</td>\n";

print "<td><b>$self->{'text_hash'}->{'edit_device'}</b></td>\n";
$self->{'dev'} = $self->{'dinfo'}->{'prefix'}.$self->{'np'};
print "<td>$self->{'dev'}</td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'edit_type'}</b></td>\n";
if ($self->{'pinfo'}->{'extended'} || $self->{'in_hash'}->{'new'} == 3) {
	print "<td>$self->{'text_hash'}->{'extended'}</td>\n";
	}
else {
	print "<td nowrap><select name=type>\n";
	foreach $t (sort { $self->tag_name($a) cmp $self->tag_name($b) } $self->list_tags()) {
		printf "<option value=$t %s> %s\n",
			($self->{'in_hash'}->{'new'} && $t eq "83" ||
			 !$self->{'in_hash'}->{'new'} && $t eq $self->{'pinfo'}->{'type'}) ? "selected"
								: "",
			$self->tag_name($t);
		}
	print "</select></td>\n";
	}

print "<td><b>$self->{'text_hash'}->{'edit_extent'}</b></td>\n";
if ($self->{'in_hash'}->{'new'}) {
	print "<td><input name=start size=4 value=$start> - \n";
	print "<input name=end size=4 value=$end>\n";
	}
else {
	print "<td>$self->{'pinfo'}->{'start'} - $self->{'pinfo'}->{'end'}\n";
	}
print $self->{'text_hash'}->{'edit_of'}," $self->{'dinfo'}->{'cylinders'}</td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'edit_status'}</b></td>\n";
if ($self->{'pinfo'}->{'extended'}) {
	foreach $p (@{$self->{'plist_array'}}) {
		$self->{'ecount'}++ if ($p->{'number'} > 4);
		}
	if ($self->{'ecount'} == 1) {
		print "<td>", $self->{'text_hash'}->{'edit_cont1'}, "</td>\n";
		}
	else {
		if ($self->{'ecount'} > 4) {
			print "<td>", $self->text('edit_cont5', $self->{'ecount'}), "</td>\n";
			}
		else {
			print "<td>", $self->text('edit_cont234', $self->{'ecount'}), "</td>\n";
			}
		}
	}
else {
	@{$self->{'stat_array'}} = $self->device_status($self->{'dev'});
	if ($self->{'in_hash'}->{'new'}) { print "<td>$self->{'text_hash'}->{'edit_notexist'}</td>\n"; }
	elsif (@{$self->{'stat_array'}}) {
		$self->{'msg'} = $self->{'stat_array'}->[2] ? 'edit_mount' : 'edit_umount';
		$self->{'msg'} .= 'vm' if ($self->{'stat_array'}->[1] eq 'swap');
		$self->{'msg'} .= 'raid' if ($self->{'stat_array'}->[1] eq 'raid');
		$self->{'msg'} .= 'lvm' if ($self->{'stat_array'}->[1] eq 'lvm');
		print "<td>",$self->text($self->{'msg'}, "<tt>$self->{'stat_array'}->[0]</tt>",
				   "<tt>$self->{'stat_array'}->[1]</tt>"),"</td>\n";
		}
	else { print "<td>$self->{'text_hash'}->{'edit_notused'}</td>\n"; }
	}

print "<td><b>$self->{'text_hash'}->{'edit_size'}</b></td>\n";
if ($self->{'in_hash'}->{'new'}) {
	print "<td>$self->{'text_hash'}->{'edit_notexist'}</td> </tr>\n";
	}
elsif ($self->{'dinfo'}->{'cylsize'}) {
	print "<td>",$self->nice_size(($self->{'pinfo'}->{'end'} - $self->{'pinfo'}->{'start'} + 1) * $self->{'dinfo'}->{'cylsize'}),"</td> </tr>\n";
	}
else {
	print "<td>",$self->text('edit_blocks', $self->{'pinfo'}->{'blocks'}),"</td> </tr>\n";
	}

# Show field for editing filesystem label
print "<tr>\n";
if (($self->{'has_e2label'} || $self->{'has_xfs_db'}) && $self->{'pinfo'}->{'type'} eq '83' && !$self->{'in_hash'}->{'new'}) {
	local $label = $self->{'in_hash'}->{'new'} ? undef : $self->get_label($self->{'pinfo'}->{'device'});
	print "<td><b>$self->{'text_hash'}->{'edit_label'}</b></td> <td>\n";
	if (@{$self->{'stat_array'}}) {
		print $label ? "<tt>$label</tt>" : $self->{'text_hash'}->{'edit_none'};
		}
	else {
		print "<input name=label size=16 value='$label'>\n";
		}
	print "</td>\n";
	}

# Show current UUID
if ($self->{'has_volid'} && !$self->{'in_hash'}->{'new'}) {
	local $volid = $self->get_volid($self->{'pinfo'}->{'device'});
	print "<td><b>$self->{'text_hash'}->{'edit_volid'}</b></td>\n";
	print "<td><tt>$volid</tt></td>\n";
	}
print "</tr>\n";

print "</table></td></tr></table>\n";
if ($self->{'in_hash'}->{'new'}) {
	print "<input type=submit value=\"$self->{'text_hash'}->{'create'}\">\n";
	}
elsif (@{$self->{'stat_array'}} && $self->{'stat_array'}->[2]) {
	print "<b>$self->{'text_hash'}->{'edit_inuse'}</b><p>\n";
	}
else {
	if (!$self->{'pinfo'}->{'extended'}) {
		print "<input type=submit value=\"$self->{'text_hash'}->{'save'}\">\n";
		}
	print "<input name=delete type=submit value=\"$self->{'text_hash'}->{'delete'}\">\n";
	}
print "</form><p>\n";

if (!$self->{'in_hash'}->{'new'} && !$self->{'pinfo'}->{'extended'}) {
	if (!@{$self->{'stat_array'}} || $self->{'stat_array'}->[2] == 0) {
		# Show form for creating filesystem
		print "<hr><table width=100%>\n" if (!$self->{'donehead'}++);
		print "<tr> <form action=mkfs_form.cgi>\n";
		print "<input type=hidden name=dev value=$self->{'dev'}>\n";
		print "<td nowrap><input type=submit value='$self->{'text_hash'}->{'edit_mkfs2'}'>\n";
		print "<select name=type>\n";
		local $rt = @{$self->{'stat_array'}} ? $self->{'stat_array'}->[1] : $self->conv_type($self->{'pinfo'}->{'type'});
		foreach $f ($self->supported_filesystems()) {
			printf "<option value=%s %s>%s (%s)\n",
				$f, $rt eq $f ? "selected" : "",
				$self->{'text_hash'}->{"fs_$f"}, $f;
			}
		print "</select></td>\n";
		print "<td>$self->{'text_hash'}->{'edit_mkfsmsg2'}</td> </form></tr>\n";
		}

	if (!$self->{'in_hash'}->{'new'} && @{$self->{'stat_array'}} && $self->{'stat_array'}->[2] == 0 && $self->can_fsck($self->{'stat_array'}->[1])) {
		# Show form to fsck filesystem
		print "<hr><table width=100%>\n" if (!$self->{'donehead'}++);
		print "<tr> <form action=fsck_form.cgi>\n";
		print "<td valign=top>\n";
		print "<input type=hidden name=dev value=$self->{'dev'}>\n";
		print "<input type=hidden name=type value=$self->{'stat_array'}->[1]>\n";
		print "<input type=submit value=\"$self->{'text_hash'}->{'edit_fsck'}\"></td>\n";
		print "<td>",$self->text('edit_fsckmsg', "<tt>fsck</tt>"),"</td>\n";
		print "</form> </tr>\n";
		}

	if (!$self->{'in_hash'}->{'new'} && @{$self->{'stat_array'}} && $self->{'stat_array'}->[2] == 0 && $self->can_tune($self->{'stat_array'}->[1])) {
		# Show form to tune filesystem
		print "<hr><table width=100%>\n" if (!$self->{'donehead'}++);
		print "<tr> <form action=tunefs_form.cgi>\n";
		print "<td valign=top>\n";
		print "<input type=hidden name=dev value=$self->{'dev'}>\n";
		print "<input type=hidden name=type value=$self->{'stat_array'}->[1]>\n";
		print "<input type=submit value=\"", $self->{'text_hash'}->{'edit_tune'}, "\"></td>\n";
		print "<td>$self->{'text_hash'}->{'edit_tunemsg'}</td> </tr>\n";
		print "</form> </tr>\n";
		}

	@{$self->{'types_array'}} = $self->conv_type($self->{'pinfo'}->{'type'});
	if (!$self->{'in_hash'}->{'new'} && !@{$self->{'stat_array'}} && @{$self->{'types_array'}}) {
		# Show form to mount filesystem
		print "<hr><table width=100%>\n" if (!$self->{'donehead'}++);
		print "<tr> <form action=../mount/edit_mount.cgi>\n";
		print "<input type=hidden name=newdev value=$self->{'dev'}>\n";
		print "<td valign=top>\n";
		if ($self->{'types_array'}->[0] eq "swap") {
			# Swap partition
			print "<input type=submit value=\"$self->{'text_hash'}->{'edit_newmount2'}\">\n";
			print "</td>\n";
			print $self->ui_hidden("type", $self->{'types_array'}->[0]);
			print "<td>$self->{'text_hash'}->{'edit_mountmsg2'}</td> </tr>\n";
			}
		else {
			# For some filesystem
			print "<input type=submit value=\"$self->{'text_hash'}->{'edit_newmount'}\">\n";
			print "<input name=newdir size=20>\n";
			if (@{$self->{'types_array'}} > 1) {
				print "$self->{'text_hash'}->{'edit_mountas'} <select name=type>\n";
				foreach $t (@{$self->{'types_array'}}) {
					print "<option>$t\n";
					}
				print "</select>\n";
				}
			else {
				print $self->ui_hidden("type", $self->{'types_array'}->[0]);
				}
			print "</td>\n";
			print "<td>$self->{'text_hash'}->{'edit_mountmsg'}</td> </tr>\n";
			}
		print "</form> </tr>\n";
		}

	print "</table><p>\n" if ($self->{'donehead'});
	}

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

