#!/usr/bin/perl

&MAIN();

 sub MAIN {
# index.cgi
# Display a list of known disks and partitions

&ModuleLoader::preload_module('fdisk_class', "fdisk::FdiskLib");
$self = new fdisk::FdiskLib:: 'fdisk_class',%$self;

$self->error_setup($self->{'text_hash'}->{'index_err'});
$self->check_fdisk();
$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", undef, 0, 1, 0,
	$self->help_search_link("fdisk", "man", "doc", "howto"));
$self->{'extwidth'} = 250;

$self->{'smart'} = $self->foreign_installed("smart_status") &&
	 $self->foreign_available("smart_status");
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'index_disk'}</b></td> ",
      "<td><b>$self->{'text_hash'}->{'index_parts'}</b></td> </tr>\n";
foreach $d ($self->list_disks_partitions()) {
	local $ed = $self->can_edit_disk($d->{'device'});
	next if (!$ed && !$self->{'access_hash'}->{'view'});
	print "<tr $self->{'cb'}> <td valign=top><table>\n";
	print "<tr> <td><b>$self->{'text_hash'}->{'index_location'}</b></td> ";
	print "<td>$d->{'desc'}</td>\n";
	print "<tr> <td><b>$self->{'text_hash'}->{'index_cylinders'}</b></td> ",
	      "<td>$d->{'cylinders'}</td> </tr>\n";
	if ($d->{'cylsize'}) {
		print "<tr> <td><b>$self->{'text_hash'}->{'index_size'}</b></td> ",
		      "<td>",$self->nice_size($d->{'cylinders'}*$d->{'cylsize'}),
		      "</td> </tr>\n";
		}
	if ($d->{'model'}) {
		print "<tr> <td><b>$self->{'text_hash'}->{'index_model'}</b></td> ",
		      "<td>$d->{'model'}</td> </tr>\n";
		}
	if (defined($d->{'scsiid'}) && defined($d->{'controller'})) {
		print "<tr> <td><b>$self->{'text_hash'}->{'index_controller'}</b></td> ",
		      "<td>$d->{'controller'}</td> </tr>\n";
		print "<tr> <td><b>$self->{'text_hash'}->{'index_scsiid'}</b></td> ",
		      "<td>$d->{'scsiid'}</td> </tr>\n";
		}
	if ($d->{'raid'}) {
		print "<tr> <td><b>$self->{'text_hash'}->{'index_raid'}</b></td> ",
		      "<td>$d->{'raid'}</td> </tr>\n";
		}

	# Show links to other modules
	@{$self->{'links_array'}} = ( );
	if ($d->{'type'} eq 'ide' && $ed) {
		# Display link to IDE params form
		push(@{$self->{'links_array'}}, "<a href='edit_hdparm.cgi?".
			     "disk=$d->{'index'}'>$self->{'text_hash'}->{'index_hdparm'}</a>");
		}
	if ($self->{'smart'} && $d->{'type'} eq 'ide') {
		# Display link to smart module
		push(@{$self->{'links_array'}}, "<a href='../smart_status/index.cgi?".
			     "drive=$d->{'device'}'>$self->{'text_hash'}->{'index_smart'}</a>");
		}
	if (@{$self->{'links_array'}}) {
		print "<tr> <td colspan=2>",$self->ui_links_row(\@{$self->{'links_array'}}),
		      "</td> </tr>\n";
		}

	print "</table></td> <td valign=top nowrap>\n";

	@{$self->{'parts_array'}} = @{$d->{'parts'}};
	foreach $p (@{$self->{'parts_array'}}) {
		if ($p->{'end'} > $d->{'cylinders'}-1) {
			$d->{'cylinders'} = $p->{'end'}+1;
			}
		}
	local $extended = 0;
	local $usedpri = 0;
	if (!@{$self->{'parts_array'}}) {
		print "<b>$self->{'text_hash'}->{'index_none'}</b><p>\n";
		}
	else {
		print "<table width=100%> ",
		      "<tr> <td width=10%><b>$self->{'text_hash'}->{'index_num'}</b></td> ",
		      "<td width=10%><b>$self->{'text_hash'}->{'index_type'}</b></td> ",
                      "<td><b>$self->{'text_hash'}->{'index_extent'}</b></td> ",
                      "<td width=10%><b>$self->{'text_hash'}->{'index_start'}</b></td> ",
                      "<td width=10%><b>$self->{'text_hash'}->{'index_end'}</b></td> ",
                      "<td width=10%><b>$self->{'text_hash'}->{'index_use'}</b></td> ",
                      "<td width=10%><b>$self->{'text_hash'}->{'index_free'}</b></td> </tr>\n";
		foreach $p (@{$self->{'parts_array'}}) {
			print "<tr>\n";
			if (!$ed) {
				$self->{'lb'} = $self->{'la'} = "";
				}
			else {
				$self->{'lb'} = "<a href=\"edit_part.cgi?disk=$d->{'index'}&part=$p->{'index'}\">";
				$self->{'la'} = "</a>";
				$extended++ if ($p->{'extended'});
				}
			print "<td width=10%>",$self->{'lb'},$p->{'number'},$self->{'la'},"</td>\n";
			$usedpri++ if ($p->{'number'} <= 4);
			print "<td width=10%>",$self->{'lb'},$p->{'extended'} ?
				$self->{'text_hash'}->{'extended'} : $self->tag_name($p->{'type'}),
			        $self->{'la'},"</td> <td>\n";
			printf "<img src=images/gap.gif height=10 width=%d>",
				$self->{'extwidth'}*($p->{'start'} - 1) /
				$d->{'cylinders'};
			printf "<img src=images/%s.gif height=10 width=%d>",
				$p->{'extended'} ? "ext" : "use",
				$self->{'extwidth'}*($p->{'end'} - $p->{'start'}) /
				$d->{'cylinders'};
			printf "<img src=images/gap.gif height=10 width=%d>",
			  $self->{'extwidth'}*($d->{'cylinders'} - ($p->{'end'} - 1)) /
				    $d->{'cylinders'};
			print "</td> <td width=10%>$p->{'start'}</td> ",
			      "<td width=10%>$p->{'end'}</td> <td nowrap>\n";
			@{$self->{'stat_array'}} = $self->device_status($p->{'device'});
			if ($self->{'stat_array'}->[1] eq 'raid') {
				print "<tt>$self->{'stat_array'}->[0]</tt>\n";
				}
			elsif ($self->{'stat_array'}->[1] eq 'lvm') {
				if ($self->foreign_available("lvm")) {
					print "<tt><a href='../lvm/'>VG $self->{'stat_array'}->[0]</a></tt>\n";
					}
				else {
					print "<tt>VG $self->{'stat_array'}->[0]</tt>\n";
					}
				}
			elsif ($self->{'stat_array'}->[0] && !$self->foreign_available("mount")) {
				print "<tt>$self->{'stat_array'}->[0]</tt>\n";
				}
			elsif ($self->{'stat_array'}->[0] && $self->{'stat_array'}->[3] == -1) {
				print "<tt><a href='../mount/edit_mount.cgi?index=$self->{'stat_array'}->[4]&temp=1&return=/$self->{'module_name'}/'>$self->{'stat_array'}->[0]</a></tt>\n";
				}
			elsif ($self->{'stat_array'}->[0]) {
				print "<tt><a href='../mount/edit_mount.cgi?index=$self->{'stat_array'}->[3]&return=/$self->{'module_name'}/'>$self->{'stat_array'}->[0]</a></tt>\n";
				}
			print "</td> <td width=10%>\n";
			if (!$p->{'extended'} && $self->{'stat_array'}->[2] &&
			    $self->indexof($p->{'type'}, @{$self->{'space_type_array'}}) >= 0 &&
			    (@{$self->{'space_array'}} = $self->disk_space($p->{'device'}, $self->{'stat_array'}->[0])) &&
			    $self->{'space_array'}->[0]) {
				printf "%d %%\n", 100 * $self->{'space_array'}->[1] / $self->{'space_array'}->[0];
				}
			print "</td> </tr>\n";
			}
		print "</table>\n";
		}

	# Show links for adding partitions
	@{$self->{'edlinks_array'}} = ( );
	if ($usedpri != 4 && $ed) {
		push(@{$self->{'edlinks_array'}}, "<a href=\"edit_part.cgi?".
		      	       "disk=$d->{'index'}&new=1\">".
		      	       $self->{'text_hash'}->{'index_addpri'}."</a>");
		}
	if ($extended && $ed) {
		push(@{$self->{'edlinks_array'}}, "<a href=\"edit_part.cgi?".
			       "disk=$d->{'index'}&new=2\">".
			       $self->{'text_hash'}->{'index_addlog'}."</a>");
		}
	elsif ($usedpri != 4 && $ed) {
		push(@{$self->{'edlinks_array'}}, "<a href=\"edit_part.cgi?".
			        "disk=$d->{'index'}&new=3\">".
			        $self->{'text_hash'}->{'index_addext'}."</a>");
		}
	print $self->ui_links_row(\@{$self->{'edlinks_array'}});
	print "</td> </tr>\n";
	}
print "</table><p>\n";

$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});

1;
		
}


1;

