#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_part.cgi
# Save changes to an existing or new partition

&ModuleLoader::preload_module('fdisk_class', "fdisk::FdiskLib");
$self = new fdisk::FdiskLib:: 'fdisk_class',%$self;

$self->error_setup($self->{'text_hash'}->{'save_err'});
$self->ReadParse();

@{$self->{'dlist_array'}} = $self->list_disks_partitions();
$self->{'dinfo'} = $self->{'dlist_array'}->[$self->{'in_hash'}->{'disk'}];
$self->can_edit_disk($self->{'dinfo'}->{'device'}) ||
	$self->error($self->{'text_hash'}->{'save_ecannot'});
@{$self->{'plist_array'}} = @{$self->{'dinfo'}->{'parts'}};
if ($self->{'in_hash'}->{'delete'} && $self->{'in_hash'}->{'confirm'}) {
	# deleting a partition
	$pinfo = $self->{'plist_array'}->[$self->{'in_hash'}->{'part'}];
	$self->delete_partition($self->{'dinfo'}->{'device'}, $pinfo->{'number'});
	$self->webmin_log("delete", "part", $self->{'dinfo'}->{'device'}, \%{$self->{'in_hash'}});
	$self->redirect("");
	}
elsif ($self->{'in_hash'}->{'delete'}) {
	# Ask the user if he really wants to delete the partition
	$self->ui_print_header(undef, $self->{'text_hash'}->{'delete_title'}, "");

	$pinfo = $self->{'plist_array'}->[$self->{'in_hash'}->{'part'}];
	$self->{'dname'} = $main::mount_object->device_name($pinfo->{'device'});
	print "<center><form action=save_part.cgi>\n";
	print "<input type=hidden name=disk value='$self->{'in_hash'}->{'disk'}'>\n";
	print "<input type=hidden name=part value='$self->{'in_hash'}->{'part'}'>\n";
	print "<input type=hidden name=delete value=1>\n";
	print "<b>",$self->text('delete_rusure', $self->{'dname'},
			  "<tt>$pinfo->{'device'}</tt>"),"</b><p>\n";
	print "<input type=submit name=confirm value='$self->{'text_hash'}->{'delete_ok'}'>\n";
	print "</form></center>\n";

	$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
	}
elsif (!$self->{'in_hash'}->{'new'}) {
	# changing existing partition
	$pinfo = $self->{'plist_array'}->[$self->{'in_hash'}->{'part'}];
	$self->change_type($self->{'dinfo'}->{'device'}, $pinfo->{'number'}, $self->{'in_hash'}->{'type'});
	if (defined($self->{'in_hash'}->{'label'}) && $self->{'in_hash'}->{'type'} eq '83') {
		$self->set_label($pinfo->{'device'}, $self->{'in_hash'}->{'label'});
		}
	$self->webmin_log("modify", "part", $self->{'dinfo'}->{'device'}, \%{$self->{'in_hash'}});
	$self->redirect("");
	}
else {
	# Adding new partition
	$self->{'in_hash'}->{start} =~ /^\d+$/ ||
		$self->error($self->text('save_estart', $self->{'in_hash'}->{'start'}));
	$self->{'in_hash'}->{end} =~ /^\d+$/ ||
		$self->error($self->text('save_eend', $self->{'in_hash'}->{'end'}));
	$self->{'in_hash'}->{start} >= $self->{'in_hash'}->{'min'} ||
		$self->error($self->text('save_emin', $self->{'in_hash'}->{'min'}));
	$self->{'in_hash'}->{end} <= $self->{'in_hash'}->{'max'} ||
		$self->error($self->text('save_emax', $self->{'in_hash'}->{'max'}));
	$self->{'in_hash'}->{start} < $self->{'in_hash'}->{end} ||
		$self->error($self->{'text_hash'}->{'save_eminmax'});

	# Check for partition overlap..
	foreach $pinfo (@{$self->{'plist_array'}}) {
		if (($self->{'in_hash'}->{'start'} >= $pinfo->{'start'} &&
		     $self->{'in_hash'}->{'start'} <= $pinfo->{'end'} ||
		     $self->{'in_hash'}->{'end'} >= $pinfo->{'start'} &&
		     $self->{'in_hash'}->{'end'} <= $pinfo->{'end'}) &&
		     !($self->{'in_hash'}->{'new'}==2 && $pinfo->{'extended'})) {
			$self->error($self->text('save_eoverlap', $pinfo->{'number'},
				     $pinfo->{'start'}, $pinfo->{'end'}));
			}
		}
	if ($self->{'in_hash'}->{'new'} == 3) {
		$self->create_extended($self->{'dinfo'}->{'device'}, $self->{'in_hash'}->{'newpart'},
				$self->{'in_hash'}->{'start'}, $self->{'in_hash'}->{'end'});
		$self->webmin_log("create", "part", $self->{'dinfo'}->{'device'}, \%{$self->{'in_hash'}});
		}
	else {
		$self->create_partition($self->{'dinfo'}->{'device'}, $self->{'in_hash'}->{'newpart'},
				  $self->{'in_hash'}->{'start'}, $self->{'in_hash'}->{'end'}, $self->{'in_hash'}->{'type'});
		if ($self->{'in_hash'}->{'label'} && $self->{'in_hash'}->{'type'} eq '83') {
			local $dev = $self->{'dinfo'}->{'prefix'}.$self->{'in_hash'}->{'newpart'};
			$self->set_label($dev, $self->{'in_hash'}->{'label'});
			}
		$self->webmin_log("create", "part", $self->{'dinfo'}->{'device'}, \%{$self->{'in_hash'}});
		}
	if ($self->need_reboot($self->{'dinfo'})) { &ask_reboot($self->{'dinfo'}); }
	else { $self->redirect(""); }
	}

1;
		
}

# ask_reboot(disk)
# Display a form asking for a reboot
sub ask_reboot
{
	shift if ($self == $_[0]);

$self->ui_print_header(undef, $self->{'text_hash'}->{'reboot_title'}, "");
print "<hr>\n";
local $what = $self->text('select_device', uc($_[0]->{'type'}),
		    uc(substr($_[0]->{'device'}, -1)));
print "<b>",$self->text('reboot_why', $what),"</b> <p>\n";
print "<form action=reboot.cgi>\n";
print "<center><input type=submit value=\"$self->{'text_hash'}->{'reboot_ok'}\"></center>\n";
print "</form>\n";

print "<hr>\n";
$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
}


1;

