#!/usr/bin/perl
package fetchmail::Log_parser;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'fetchmail::Log_parser');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# log_parser.pl
# Functions for parsing this module's logs

&ModuleLoader::preload_module(ref($self), "fetchmail::FetchmailLib");
$self = new fetchmail::FetchmailLib:: ref($self), %$self; 

1;
		return $self;
}

# parse_webmin_log(user, script, action, type, object, &params)
# Converts logged information from this module into human-readable form
sub parse_webmin_log
{
	my $self = shift;

local ($user, $script, $action, $type, $object, $p, $long) = @_;
if ($type eq 'poll') {
	if ($p->{'user'}) {
		return $self->text("log_${action}_poll_user",
			     "<tt>".$self->html_escape($object)."</tt>",
			     "<tt>".$self->html_escape($p->{'user'})."</tt>");
		}
	else {
		return $self->text("log_${action}_poll_file",
			     "<tt>".$self->html_escape($object)."</tt>",
			     "<tt>".$self->html_escape($p->{'file'})."</tt>");
		}
	}
elsif ($type eq 'cron') {
	return $self->{'text_hash'}->{"log_${action}_cron"};
	}
elsif ($action eq 'check') {
	if ($object =~ /^\//) {
		return $self->text("log_check_file_${type}",
			     "<tt>".$self->html_escape($object)."</tt>",
			     "<tt>".$self->html_escape($p->{'poll'})."</tt>");
		}
	else {
		return $self->text("log_check_user_${type}",
			     "<tt>".$self->html_escape($object)."</tt>",
			     "<tt>".$self->html_escape($p->{'poll'})."</tt>");
		}
	}
elsif ($action eq 'global') {
	return $self->text($object =~ /^\// ? "log_global_file" : "log_global_user",
		     "<tt>".$self->html_escape($object)."</tt>");
	}
elsif ($action eq 'start') {
	return $self->text('log_start', $p->{'interval'});
	}
elsif ($action eq 'stop') {
	return $self->{'text_hash'}->{'log_stop'};
	}
else {
	return undef;
	}
}


1;

