#!/usr/bin/perl

&MAIN();

 sub MAIN {
# index.cgi
# Show fetchmail configurations

&ModuleLoader::preload_module('fetchmail_class', "fetchmail::FetchmailLib");
$self = new fetchmail::FetchmailLib:: 'fetchmail_class',%$self;


# Check if fetchmail is installed
if (!$self->has_command($self->{'config_hash'}->{'fetchmail_path'})) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", undef, 1, 1, 0,
		$self->help_search_link("fetchmail", "doc", "man", "google"));
	print "<p>",$self->text('index_efetchmail',
			  "<tt>$self->{'config_hash'}->{'fetchmail_path'}</tt>",
			  "$self->{'gconfig_hash'}->{'webprefix'}/config.cgi?$self->{'module_name'}"),"<p>\n";
	$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});
	exit;
	}

# Get and show the version
$self->{'ver'} = $self->get_fetchmail_version();
$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", undef, 1, 1, 0,
	$self->help_search_link("fetchmail", "doc", "man", "google"), undef, undef,
	$self->text('index_version', $self->{'ver'}));

if ($self->{'config_hash'}->{'config_file'}) {
	# Just read one config file
	@conf = $self->parse_config_file($self->{'config_hash'}->{'config_file'});
	@conf = grep { $_->{'poll'} } @conf;
	print "<b>",$self->text('index_file',
			  "<tt>$self->{'config_hash'}->{'config_file'}</tt>"),"</b><p>\n";
	$self->show_polls(\@conf, $self->{'config_hash'}->{'config_file'}, $self->{'config_hash'}->{'daemon_user'});

	local @uinfo = getpwnam($self->{'config_hash'}->{'daemon_user'});
	print "<hr>\n";
	print "<table width=100%>\n";

	if ($self->foreign_installed("cron") && $self->{'access_hash'}->{'cron'}) {
		# Show button to manage cron job
		print "<form action=edit_cron.cgi>\n";
		print "<tr> <td><input type=submit ",
		      "value='$self->{'text_hash'}->{'index_cron'}'></td>\n";
		print "<td>$self->{'text_hash'}->{'index_crondesc'}</td> </tr></form>\n";
		}

	# Show the fetchmail daemon form
	foreach $pf ($self->{'config_hash'}->{'pid_file'},
		     "$uinfo[7]/.fetchmail.pid", "$uinfo[7]/.fetchmail") {
		if (open(PID, $pf) && ($self->{'line'}=<PID>) &&
		    (($self->{'pid'},$self->{'interval'}) = split(/\s+/, $self->{'line'})) && $self->{'pid'} &&
		    kill(0, $self->{'pid'})) {
			$self->{'running'}++;
			last;
			}
		}
	print "<tr><td>\n";
	if ($self->{'running'}) {
		# daemon is running - offer to stop it
		print "<form action=stop.cgi>\n";
		print "<input type=submit value='$self->{'text_hash'}->{'index_stop'}'></td>\n";
		print "<td>",$self->text('index_stopmsg',
				   "<tt>$self->{'config_hash'}->{'daemon_user'}</tt>",
				   $self->{'interval'}),"</td>\n";
		}
	else {
		# daemon isn't running - offer to start it
		print "<form action=start.cgi>\n";
		print "<input type=submit value='$self->{'text_hash'}->{'index_start'}'></td>\n";
		print "<td>",$self->text('index_startmsg',
				   "<input name=interval size=5 value='60'>",
				   "<tt>$self->{'config_hash'}->{'daemon_user'}</tt>"),"</td>\n";
		}
	print "</td></tr></table></form>\n";
	}
else {
	# Build a list of users with fetchmail configurations
	$self->{'ucount'} = 0;
	setpwent();
	while(@uinfo = getpwent()) {
		next if ($self->{'donehome_hash'}->{$uinfo[7]}++);
		next if (!$self->can_edit_user($uinfo[0]));
		local @conf = $self->parse_config_file("$uinfo[7]/.fetchmailrc");
		@conf = grep { $_->{'poll'} } @conf;
		if (@conf) {
			push(@{$self->{'users_array'}}, [ \@conf, [ @uinfo ] ]);
			}
		$self->{'ucount'}++;
		last if ($self->{'config_hash'}->{'max_users'} &&
			 $self->{'ucount'} > $self->{'config_hash'}->{'max_users'});
		}
	endpwent() if ($self->{'gconfig_hash'}->{'os_type'} ne 'hpux');
	if (!@{$self->{'users_array'}}) {
		# None found
		print "<br><b>$self->{'text_hash'}->{'index_none'}</b><p>\n";
		}
	elsif ($self->{'config_hash'}->{'max_users'} && $self->{'ucount'} > $self->{'config_hash'}->{'max_users'}) {
		# Show user search form
		print "$self->{'text_hash'}->{'index_toomany'}<p>\n";
		print $self->ui_form_start("edit_user.cgi");
		print "<b>$self->{'text_hash'}->{'index_search'}</b>\n";
		print $self->ui_user_textbox("user", undef, 20),"\n";
		print $self->ui_submit($self->{'text_hash'}->{'index_show'}),"\n";
		print $self->ui_form_end();
		$self->{'toomany'} = 1;
		}
	elsif (!$self->{'config_hash'}->{'view_mode'}) {
		# Full details
		&show_button();
		print "<table border width=100%>\n";
		print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'index_user'}</b></td> <td><b>$self->{'text_hash'}->{'index_conf'}</b></td> </tr>\n";
		foreach $u (@{$self->{'users_array'}}) {
			print "<tr $self->{'cb'}>\n";
			print "<td valign=top><b>",$self->html_escape($u->[1]->[0]),
			      "</b></td> <td>\n";
			$self->show_polls($u->[0], "$u->[1]->[7]/.fetchmailrc",
				    $u->[1]->[0]);
			print "</td> </tr>\n";
			}
		print "</table>\n";
		}
	else {
		# Just show usernames
		print $self->ui_table_start($self->{'text_hash'}->{'index_header'}, "width=100%", 1);
		$self->{'i'} = 0;
		foreach $u (@{$self->{'users_array'}}) {
			print "<tr>\n" if ($self->{'i'}%4 == 0);
			print "<td width=25%><a href='edit_user.cgi?user=$u->[1]->[0]'>$u->[1]->[0]</a></td>\n";
			print "</tr>\n" if ($self->{'i'}%4 == 3);
			$self->{'i'}++;
			}
		print $self->ui_table_end();
		}
	&show_button() if (!$self->{'toomany'});

	if ($self->foreign_installed("cron") && $self->{'access_hash'}->{'cron'}) {
		# Show button to manage global cron job
		print "<hr>\n";
		print $self->ui_buttons_start();
		print $self->ui_buttons_row("edit_cron.cgi",
				      $self->{'text_hash'}->{'index_cron'}, $self->{'text_hash'}->{'index_crondesc2'});
		print $self->ui_buttons_end();
		}
	}

$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});

1;
		
}

sub show_button
{
	shift if ($self == $_[0]);

if ($self->{'access_hash'}->{'mode'} != 3 || !$self->{'doneheader'}) {
	print "<form action=edit_poll.cgi>\n";
	print "<input type=hidden name=new value=1>\n";
	print "<input type=submit value='$self->{'text_hash'}->{'index_ok'}'>\n";
	print $self->unix_user_input("user");
	print "</form>\n";
	}
}


1;

