#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_global.cgi
# Save global options

&ModuleLoader::preload_module('fetchmail_class', "fetchmail::FetchmailLib");
$self = new fetchmail::FetchmailLib:: 'fetchmail_class',%$self;

$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'global_err'});

if ($self->{'config_hash'}->{'config_file'}) {
	$self->{'file'} = $self->{'config_hash'}->{'config_file'};
	}
else {
	$self->can_edit_user($self->{'in_hash'}->{'user'}) || $self->error($self->{'text_hash'}->{'poll_ecannot'});
	@{$self->{'uinfo_array'}} = getpwnam($self->{'in_hash'}->{'user'});
	$self->{'file'} = "$self->{'uinfo_array'}->[7]/.fetchmailrc";
	}

$self->lock_file($self->{'file'});
@{$self->{'conf_array'}} = $self->parse_config_file($self->{'file'});
foreach $c (@{$self->{'conf_array'}}) {
	$self->{'poll'} = $c if ($c->{'defaults'});
	}
$self->{'found'}++ if ($self->{'poll'});

# Validate inputs
$self->{'in_hash'}->{'port_def'} || $self->{'in_hash'}->{'port'} =~ /^\d+$/ ||
	$self->error($self->{'text_hash'}->{'poll_eport'});
if (!$self->{'in_hash'}->{'interface_def'}) {
	$self->{'in_hash'}->{'interface'} =~ /^\S+$/ || $self->error($self->{'text_hash'}->{'poll_einterface'});
	$self->check_ipaddress($self->{'in_hash'}->{'interface_net'}) || $self->error($self->{'text_hash'}->{'poll_enet'});
	$self->check_ipaddress($self->{'in_hash'}->{'interface_mask'}) || !$self->{'in_hash'}->{'interface_mask'} ||
		$self->error($self->{'text_hash'}->{'poll_emask'});
	}

# Create the default structure
$self->{'poll'}->{'defaults'} = 1;
$self->{'poll'}->{'proto'} = $self->{'in_hash'}->{'proto'};
$self->{'poll'}->{'port'} = $self->{'in_hash'}->{'port_def'} ? undef : $self->{'in_hash'}->{'port'};
if ($self->{'in_hash'}->{'interface_def'}) {
	delete($self->{'poll'}->{'interface'});
	}
else {
	local @interface = ( $self->{'in_hash'}->{'interface'}, $self->{'in_hash'}->{'interface_net'} );
	push(@interface, $self->{'in_hash'}->{'interface_mask'}) if ($self->{'in_hash'}->{'interface_mask'});
	$self->{'poll'}->{'interface'} = join("/", @interface);
	}

if ($self->{'found'}) {
	$self->modify_poll($self->{'poll'}, $self->{'file'});
	}
else {
	$self->create_poll($self->{'poll'}, $self->{'file'});
	if ($self->{'in_hash'}->{'user'} && $< == 0) {
		$self->system_logged("chown $self->{'in_hash'}->{'user'} $self->{'file'}");
		}
	$self->system_logged("chmod 700 $self->{'file'}");
	}
$self->unlock_file($self->{'file'});
$self->webmin_log("global", undef, $self->{'config_hash'}->{'config_file'} ? $self->{'file'} : $self->{'in_hash'}->{'user'},
	    \%{$self->{'in_hash'}});
$self->redirect("");

1;
		
}


1;

