#!/usr/bin/perl
package firewall::Acl_security;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'firewall::Acl_security');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;

&ModuleLoader::preload_module(ref($self), "firewall::FirewallLib");
$self = new firewall::FirewallLib:: ref($self), %$self; 
@{$self->{'acl_features_array'}} = ("newchain", "delchain", "policy", "apply", "unapply", "bootup", "setup", "cluster");

1;
		return $self;
}

# acl_security_form(&options)
# Output HTML for editing security options for the acl module
sub acl_security_form
{
	my $self = shift;

# Show editable tables
print "<tr> <td valign=top><b>$self->{'text_hash'}->{'acl_tables'}</b></td> <td colspan=3>\n";
local $t;
foreach $t (@{$self->{'known_tables_array'}}) {
	printf "<input type=checkbox name=%s value=1 %s> %s<br>\n",
		$t, $_[0]->{$t} ? "checked" : "", $self->{'text_hash'}->{'index_table_'.$t};
	}
print "</td> </tr>\n";

# Show allowed target types
print "<tr> <td><b>$self->{'text_hash'}->{'acl_jumps'}</b></td>\n";
print "<td colspan=3>",$self->ui_opt_textbox("jumps", $_[0]->{'jumps'}, 40,
				       $self->{'text_hash'}->{'acl_jall'}),"</td> </tr>\n";

# Show bootup/apply options
local ($f, $i);
foreach $f (@{$self->{'acl_features_array'}}) {
	print "<tr>\n" if ($i%2 == 0);
	print "<td><b>",$self->{'text_hash'}->{'acl_'.$f},"</b></td> <td>\n";
	printf "<input type=radio name=%s value=1 %s> %s\n",
		$f, $_[0]->{$f} ? "checked" : "", $self->{'text_hash'}->{'yes'};
	printf "<input type=radio name=%s value=0 %s> %s</td>\n",
		$f, $_[0]->{$f} ? "" : "checked", $self->{'text_hash'}->{'no'};
	print "</tr>\n" if ($i++%2 == 1);
	}
}

# acl_security_save(&options)
# Parse the form for security options for the acl module
sub acl_security_save
{
	my $self = shift;

local $t;
foreach $t (@{$self->{'known_tables_array'}}) {
	$_[0]->{$t} = $self->{'in_hash'}->{$t};
	}
local $f;
foreach $f (@{$self->{'acl_features_array'}}) {
	$_[0]->{$f} = $self->{'in_hash'}->{$f};
	}
$_[0]->{'jumps'} = $self->{'in_hash'}->{'jumps_def'} ? undef : $self->{'in_hash'}->{'jumps'};
}


1;

