#!/usr/bin/perl
package firewall::CoherentlinuxLib;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'firewall::CoherentlinuxLib');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# coherant-linux-lib.pl
# Deal with redhat's /etc/sysconfig/iptables save file and startup script

$self->foreign_require("init", "init-lib.pl");
$self->{'init_script'} = "$main::init_object->{'config_hash'}->{'init_dir'}/iptables";

$self->{'iptables_save_file'} = "/etc/sysconfig/iptables";

1;

1;
		return $self;
}

# check_iptables()
# Returns an error message if something is wrong with iptables on this system
sub check_iptables
{
	my $self = shift;

if (!-r $self->{'init_script'}) {
	return $self->text('coherent_escript', "<tt>$self->{'init_script'}</tt>");
	}
if (!$self->{'config_hash'}->{'done_check_iptables'}) {
	local $out = `$self->{'init_script'} status 2>&1`;
	if ($out !~ /table:|INPUT|FORWARD|OUTPUT/) {
		return $self->text('coherent_eoutput',
			     "<tt>$self->{'init_script'} status</tt>");
		}
	$self->{'config_hash'}->{'done_check_iptables'} = 1;
	$self->save_module_config();
	}
return undef;
}

# apply_iptables()
# Applies the current iptables configuration from the save file
sub apply_iptables
{
	my $self = shift;

local $out = $self->backquote_logged("cd / ; $self->{'init_script'} restart 2>&1");
$out =~ s/\033[^m]+m//g;
return $? || $out =~ /FAILED/ ? "<pre>$out</pre>" : undef;
}

# unapply_iptables()
# Writes the current iptables configuration to the save file
sub unapply_iptables
{
	my $self = shift;

$self->{'out'} = $self->backquote_logged("cd / ; $self->{'init_script'} save 2>&1 </dev/null");
$self->{'out'} =~ s/\033[^m]+m//g;
return $? || $self->{'out'} =~ /FAILED/ ? "<pre>$self->{'out'}</pre>" : undef;
}

# started_at_boot()
sub started_at_boot
{
	my $self = shift;

return $main::init_object->action_status("iptables") == 2;
}

sub enable_at_boot
{
	my $self = shift;

$main::init_object->enable_at_boot("iptables");	 # Assumes init script exists
}

sub disable_at_boot
{
	my $self = shift;

$main::init_object->disable_at_boot("iptables");
}


1;

