#!/usr/bin/perl
package firewall::GentoolinuxLib;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'firewall::GentoolinuxLib');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# gentoo-linux-lib.pl
# Deal with gentoo's IPtables save file

 %{$self->{'iptconf_hash'}};
$self->read_env_file("/etc/conf.d/iptables", \%{$self->{'iptconf_hash'}});
$self->{'iptables_save_file'} = $self->{'iptconf_hash'}->{'IPTABLES_SAVE'};

1;

1;
		return $self;
}

# check_iptables()
# Returns an error message if something is wrong with iptables on this system
sub check_iptables
{
	my $self = shift;

if (!-r "/etc/init.d/iptables") {
	return $self->text('gentoo_escript', "<tt>/etc/init.d/iptables</tt>");
	}
return undef;
}

# apply_iptables()
# Applies the current iptables configuration from the save file
sub apply_iptables
{
	my $self = shift;

local $out = $self->backquote_logged("cd / ; /etc/init.d/iptables restart 2>&1");
return $? ? "<pre>$out</pre>" : undef;
}


1;

