#!/usr/bin/perl
package firewall::Log_parser;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'firewall::Log_parser');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# log_parser.pl
# Functions for parsing this module's logs

&ModuleLoader::preload_module(ref($self), "firewall::FirewallLib");
$self = new firewall::FirewallLib:: ref($self), %$self; 

1;
		return $self;
}

# parse_webmin_log(user, script, action, type, object, &params)
# Converts logged information from this module into human-readable form
sub parse_webmin_log
{
	my $self = shift;

local ($user, $script, $action, $type, $object, $p) = @_;
if ($type eq "rule") {
	return $self->text("log_${action}_rule", "<tt>$p->{'chain'}</tt>",
					   "<tt>$p->{'table'}</tt>");
	}
elsif ($type eq "chain") {
	return $self->text("log_${action}_chain", "<tt>$p->{'chain'}</tt>",
					    "<tt>$p->{'table'}</tt>",
					    $p->{'count'});
	}
elsif ($type eq "host" || $type eq "group") {
	return $self->text("log_${action}_${type}", "<tt>$object</tt>");
	}
else {
	return $self->{'text_hash'}->{"log_$action"};
	}
}


1;

