#!/usr/bin/perl
package firewall::MandrakelinuxLib;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'firewall::MandrakelinuxLib');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# redhat-linux-lib.pl
# Deal with redhat's /etc/sysconfig/iptables save file and startup script

$self->{'iptables_save_file'} = "/etc/sysconfig/iptables";

# apply_iptables()
# Applies the current iptables configuration from the save file
#sub apply_iptables
#{
# $out = &backquote_logged("cd / ; /etc/rc.d/init.d/iptables restart 2>&1");
#$out =~ s/\033[^m]+m//g;
#return $? || $out =~ /FAILED/ ? "<pre>$out</pre>" : undef;
#}

1;

1;
		return $self;
}

# check_iptables()
# Returns an error message if something is wrong with iptables on this system
sub check_iptables
{
	my $self = shift;

if (!-r "/etc/rc.d/init.d/iptables") {
	return $self->text('redhat_escript', "<tt>/etc/rc.d/init.d/iptables</tt>");
	}
if (!$self->{'config_hash'}->{'done_check_iptables'}) {
	local $out = `/etc/rc.d/init.d/iptables status 2>&1`;
	if ($out !~ /table:|INPUT|FORWARD|OUTPUT/) {
		return $self->text('redhat_eoutput',
			     "<tt>/etc/init.d/iptables status</tt>");
		}
	$self->{'config_hash'}->{'done_check_iptables'} = 1;
	$self->save_module_config();
	}
return undef;
}

# unapply_iptables()
# Writes the current iptables configuration to the save file
sub unapply_iptables
{
	my $self = shift;

$self->{'out'} = $self->backquote_logged("cd / ; /etc/rc.d/init.d/iptables save 2>&1 </dev/null");
$self->{'out'} =~ s/\033[^m]+m//g;
return $? || $self->{'out'} =~ /FAILED/ ? "<pre>$self->{'out'}</pre>" : undef;
}

# started_at_boot()
sub started_at_boot
{
	my $self = shift;

$self->foreign_require("init", "init-lib.pl");
return $main::init_object->action_status("iptables") == 2;
}

sub enable_at_boot
{
	my $self = shift;

$self->foreign_require("init", "init-lib.pl");
$main::init_object->enable_at_boot("iptables");	 # Assumes init script exists
}

sub disable_at_boot
{
	my $self = shift;

$self->foreign_require("init", "init-lib.pl");
$main::init_object->disable_at_boot("iptables");
}


1;

