#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Add or update a server or group from the webmin servers module

&ModuleLoader::preload_module('firewall_class', "firewall::FirewallLib");
$self = new firewall::FirewallLib:: 'firewall_class',%$self;

$self->{'access_hash'}->{'cluster'} || $self->error($self->{'text_hash'}->{'ecluster'});
$self->ReadParse();
$self->foreign_require("servers", "servers-lib.pl");
@{$self->{'allservers_array'}} = grep { $_->{'user'} } $main::servers_object->list_servers();

if ($self->{'in_hash'}->{'add'}) {
	# Add a single host
	@{$self->{'add_array'}} = grep { $_->{'id'} eq $self->{'in_hash'}->{'server'} } @{$self->{'allservers_array'}};
	$self->error_setup($self->{'text_hash'}->{'add_err'});
	$self->{'msg'} = $self->text('add_msg', $self->server_name($self->{'add_array'}->[0]));
	}
else {
	# Add all from a group
	($self->{'group'}) = grep { $_->{'name'} eq $self->{'in_hash'}->{'group'} }
			$main::servers_object->list_all_groups(\@{$self->{'allservers_array'}});
	foreach $m (@{$self->{'group'}->{'members'}}) {
		push(@{$self->{'add_array'}}, grep { $_->{'host'} eq $m } @{$self->{'allservers_array'}});
		}
	$self->error_setup($self->{'text_hash'}->{'add_gerr'});
	$self->{'msg'} = $self->text('add_gmsg', $self->{'in_hash'}->{'group'});
	}

$self->ui_print_header(undef, $self->{'text_hash'}->{'add_title'}, "");
print "<b>$self->{'msg'}</b><p>\n";

$self->remote_error_setup(\&add_error);

# Make sure each host is set up for firewalling
foreach $s (@{$self->{'add_array'}}) {
	$self->{'add_error_msg'} = undef;
	local $host = { 'id' => $s->{'id'} };
	local $firewall = $self->remote_foreign_check($s->{'host'}, "firewall");
	if ($self->{'add_error_msg'}) {
		print "$self->{'add_error_msg'}<p>\n";
		next;
		}
	if (!$firewall) {
		print $self->text('add_echeck', $s->{'host'}),"<p>\n";
		next;
		}
	$self->remote_foreign_require($s->{'host'}, "firewall", "firewall-lib.pl");

	local $missing = $self->remote_foreign_call($s->{'host'}, "firewall",
					      "missing_firewall_commands");
	if ($missing) {
		print $self->text('add_emissing', "<tt>$missing</tt>"),"<p>\n";
		next;
		}

	@{$self->{'livetables_array'}} = $self->remote_foreign_call($s->{'host'}, "firewall",
				   "get_iptables_save", "iptables-save |");
	$self->{'rc'} = 0;
	foreach $t (@{$self->{'livetables_array'}}) {
		$self->{'rc'} += @{$t->{'rules'}};
		}

	print $self->text('add_ok', $s->{'host'}, $self->{'rc'}),"<p>\n";
	$self->add_cluster_server($s);
	}
$self->remote_finished();
if ($self->{'in_hash'}->{'add'}) {
	$self->webmin_log("add", "host", $self->{'add_array'}->[0]->{'host'});
	}
else {
	$self->webmin_log("add", "group", $self->{'in_hash'}->{'group'});
	}

$self->ui_print_footer("cluster.cgi", $self->{'text_hash'}->{'cluster_return'});

1;
		
}

# Setup error handler for down hosts
sub add_error
{
	shift if ($self == $_[0]);

$self->{'add_error_msg'} = join("", @_);
}


1;

