#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_rule.cgi
# Display the details of one firewall rule, or allow the adding of a new one

&ModuleLoader::preload_module('firewall_class', "firewall::FirewallLib");
$self = new firewall::FirewallLib:: 'firewall_class',%$self;

$self->ReadParse();
@{$self->{'tables_array'}} = $self->get_iptables_save();
$self->{'table'} = $self->{'tables_array'}->[$self->{'in_hash'}->{'table'}];
$self->can_edit_table($self->{'table'}->{'name'}) || $self->error($self->{'text_hash'}->{'etable'});
if ($self->{'in_hash'}->{'clone'} ne '') {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'edit_title3'}, "");
	%{$self->{'clone_hash'}} = %{$self->{'table'}->{'rules'}->[$self->{'in_hash'}->{'clone'}]};
	$self->{'rule'} = \%{$self->{'clone_hash'}};
	}
elsif ($self->{'in_hash'}->{'new'}) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'edit_title1'}, "");
	$self->{'rule'} = { 'chain' => $self->{'in_hash'}->{'chain'},
		  'j' => $self->can_jump('DROP') ? 'DROP' : "" };
	}
else {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'edit_title2'}, "");
	$self->{'rule'} = $self->{'table'}->{'rules'}->[$self->{'in_hash'}->{'idx'}];
	$self->can_jump($self->{'rule'}) || $self->error($self->{'text_hash'}->{'ejump'});
	}

print "<form action=save_rule.cgi method=post>\n";
print "<input type=hidden name=table value='$self->{'in_hash'}->{'table'}'>\n";
print "<input type=hidden name=idx value='$self->{'in_hash'}->{'idx'}'>\n";
print "<input type=hidden name=new value='$self->{'in_hash'}->{'new'}'>\n";
print "<input type=hidden name=chain value='$self->{'in_hash'}->{'chain'}'>\n";
print "<input type=hidden name=before value='$self->{'in_hash'}->{'before'}'>\n";
print "<input type=hidden name=after value='$self->{'in_hash'}->{'after'}'>\n";

# Display action section
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'edit_header1'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'edit_chain'}</b></td>\n";
print "<td>",$self->{'text_hash'}->{"index_chain_".lc($self->{'rule'}->{'chain'})} ||
	     $self->text('index_chain', "<tt>$self->{'rule'}->{'chain'}</tt>"),"</td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'edit_cmt'}</b></td>\n";
if ($self->{'config_hash'}->{'comment_mod'}) {
	# Get comment from --comment option
	printf "<td><input name=cmt size=50 value='%s'></td> </tr>\n",
		$self->html_escape($self->{'rule'}->{'comment'}->[1]);
	}
else {
	# Get comment from # at end of line
	printf "<td><input name=cmt size=50 value='%s'></td> </tr>\n",
		$self->html_escape($self->{'rule'}->{'cmt'});
	}

print "<tr> <td valign=top><b>$self->{'text_hash'}->{'edit_jump'}</b></td> <td>\n";
if ($self->{'table'}->{'name'} eq 'nat') {
	@{$self->{'jumps_array'}} = ( undef, 'ACCEPT', 'DROP' );
	if ($self->{'rule'}->{'chain'} eq 'POSTROUTING') {
		push(@{$self->{'jumps_array'}}, 'MASQUERADE', 'SNAT');
		}
	elsif ($self->{'rule'}->{'chain'} eq 'PREROUTING' ||
	       $self->{'rule'}->{'chain'} eq 'OUTPUT') {
		push(@{$self->{'jumps_array'}}, 'REDIRECT', 'DNAT');
		}
	else {
		push(@{$self->{'jumps_array'}}, 'MASQUERADE', 'SNAT', 'REDIRECT', 'DNAT');
		}
	}
else {
	@{$self->{'jumps_array'}} = ( undef, 'ACCEPT', 'DROP', 'REJECT', 'QUEUE', 'RETURN', 'LOG' );
	}
print "<table>\n";
$self->{'i'} = 0;
foreach $j (grep { $self->can_jump($_) } @{$self->{'jumps_array'}}) {
	print "<tr>\n" if ($self->{'i'}%5 == 0);
	printf "<td><input type=radio name=jump value='%s' %s>&nbsp;%s</td>\n",
		$j, $self->{'rule'}->{'j'}->[1] eq $j ? "checked" : "",
		$self->{'text_hash'}->{"index_jump_".lc($j)};
	$self->{'found'}++ if ($self->{'rule'}->{'j'}->[1] eq $j);
	$self->{'i'}++;
	print "</tr>\n" if ($self->{'i'}%5 == 0);
	}
print "<td colspan=2>\n";
printf "<input type=radio name=jump value=* %s>&nbsp;%s&nbsp;",
	$self->{'found'} ? "" : "checked", $self->{'text_hash'}->{'edit_jump_other'};
printf "<input name=other size=12 value='%s'></td> </tr>\n",
	$self->{'found'} ? "" : $self->{'rule'}->{'j'}->[1];
print "</table></td></tr>\n";

if ($self->indexof('REJECT', @{$self->{'jumps_array'}}) >= 0 && $self->can_jump("REJECT")) {
	# Show input for REJECT icmp type
	if ($self->{'rule'}->{'j'}->[1] eq 'REJECT') {
		$self->{'rwith'} = $self->{'rule'}->{'reject-with'}->[1];
		}
	print "<tr> <td><b>$self->{'text_hash'}->{'edit_rwith'}</b></td>\n";
	printf "<td><input type=radio name=rwithdef value=1 %s> %s\n",
		$self->{'rwith'} eq "" ? "checked" : "", $self->{'text_hash'}->{'default'};
	printf "<input type=radio name=rwithdef value=0 %s>\n",
		$self->{'rwith'} eq "" ? "" : "checked";
	local @rtypes = ( "icmp-net-unreachable", "icmp-host-unreachable",
			  "icmp-port-unreachable", "icmp-proto-unreachable",
			  "icmp-net-prohibited", "icmp-host-prohibited",
			  "echo-reply", "tcp-reset" );
	print $self->text('edit_rwithtype',
		    &icmptype_input("rwithtype", $self->{'rwith'}, \@rtypes)),
	            "</td> </tr>\n";
	}

if (($self->{'table'}->{'name'} eq 'nat' && $self->{'rule'}->{'chain'} ne 'POSTROUTING') &&
     $self->can_jump("REDIRECT")) {
	# Show inputs for redirect host and port
	if ($self->{'rule'}->{'j'}->[1] eq 'REDIRECT') {
		($self->{'rtofrom'}, $self->{'rtoto'}) = split(/\-/, $self->{'rule'}->{'to-ports'}->[1]);
		}
	print "<tr> <td><b>$self->{'text_hash'}->{'edit_rtoports'}</b></td>\n";
	printf "<td><input type=radio name=rtodef value=1 %s> %s\n",
		$self->{'rtofrom'} eq "" ? "checked" : "", $self->{'text_hash'}->{'default'};
	printf "<input type=radio name=rtodef value=0 %s>\n",
		$self->{'rtofrom'} eq "" ? "" : "checked";
	print $self->text('edit_prange',
		    "<input name=rtofrom size=6 value='$self->{'rtofrom'}'>",
		    "<input name=rtoto size=6 value='$self->{'rtoto'}'>"),"</td> </tr>\n";
	}

if (($self->{'table'}->{'name'} eq 'nat' && $self->{'rule'}->{'chain'} eq 'POSTROUTING') &&
    $self->can_jump("MASQUERADE")) {
	# Show inputs for masquerading ports
	if ($self->{'rule'}->{'j'}->[1] eq 'MASQUERADE') {
		($self->{'mtofrom'}, $self->{'mtoto'}) = split(/\-/, $self->{'rule'}->{'to-ports'}->[1]);
		}
	print "<tr> <td><b>$self->{'text_hash'}->{'edit_mtoports'}</b></td>\n";
	printf "<td><input type=radio name=mtodef value=1 %s> %s\n",
		$self->{'mtofrom'} eq "" ? "checked" : "", $self->{'text_hash'}->{'edit_any'};
	printf "<input type=radio name=mtodef value=0 %s>\n",
		$self->{'mtofrom'} eq "" ? "" : "checked";
	print $self->text('edit_prange',
		    "<input name=mtofrom size=6 value='$self->{'mtofrom'}'>",
		    "<input name=mtoto size=6 value='$self->{'mtoto'}'>"),"</td> </tr>\n";
	}

if (($self->{'table'}->{'name'} eq 'nat' && $self->{'rule'}->{'chain'} ne 'POSTROUTING') &&
    $self->can_jump("DNAT")) {
	if ($self->{'rule'}->{'j'}->[1] eq 'DNAT') {
		if ($self->{'rule'}->{'to-destination'}->[1] =~
		    /^([0-9\.]+)(\-([0-9\.]+))?(:(\d+)(\-(\d+))?)?$/) {
			$self->{'dipfrom'} = $1;
			$self->{'dipto'} = $3;
			$self->{'dpfrom'} = $5;
			$self->{'dpto'} = $7;
			}
		}
	print "<tr> <td><b>$self->{'text_hash'}->{'edit_dnat'}</b></td>\n";
	printf "<td><input type=radio name=dnatdef value=1 %s> %s\n",
		$self->{'dipfrom'} eq "" ? "checked" : "", $self->{'text_hash'}->{'default'};
	printf "<input type=radio name=dnatdef value=0 %s>\n",
		$self->{'dipfrom'} eq "" ? "" : "checked";
	print $self->text('edit_dnatip',
		    "<input name=dipfrom size=15 value='$self->{'dipfrom'}'>",
		    "<input name=dipto size=15 value='$self->{'dipto'}'>"),"\n";
	print $self->text('edit_prange',
		    "<input name=dpfrom size=6 value='$self->{'dpfrom'}'>",
		    "<input name=dpto size=6 value='$self->{'dpto'}'>"),"</td> </tr>\n";
	}

if (($self->{'table'}->{'name'} eq 'nat' && $self->{'rule'}->{'chain'} eq 'POSTROUTING') &&
    $self->can_jump("SNAT")) {
	if ($self->{'rule'}->{'j'}->[1] eq 'SNAT') {
		if ($self->{'rule'}->{'to-source'}->[1] =~
		    /^([0-9\.]+)(\-([0-9\.]+))?(:(\d+)(\-(\d+))?)?$/) {
			$self->{'sipfrom'} = $1;
			$self->{'sipto'} = $3;
			$self->{'spfrom'} = $5;
			$self->{'spto'} = $7;
			}
		}
	print "<tr> <td><b>$self->{'text_hash'}->{'edit_snat'}</b></td>\n";
	printf "<td><input type=radio name=snatdef value=1 %s> %s\n",
		$self->{'sipfrom'} eq "" ? "checked" : "", $self->{'text_hash'}->{'default'};
	printf "<input type=radio name=snatdef value=0 %s>\n",
		$self->{'sipfrom'} eq "" ? "" : "checked";
	print $self->text('edit_dnatip',
		    "<input name=sipfrom size=15 value='$self->{'sipfrom'}'>",
		    "<input name=sipto size=15 value='$self->{'sipto'}'>"),"\n";
	print $self->text('edit_prange',
		    "<input name=spfrom size=6 value='$self->{'spfrom'}'>",
		    "<input name=spto size=6 value='$self->{'spto'}'>"),"</td> </tr>\n";
	}

print "</table></td></tr></table><br>\n";

# Display conditions section
print "$self->{'text_hash'}->{'edit_desc'}<br>\n";
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'edit_header2'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'edit_source'}</b></td>\n";
print "<td>",&print_mode("source", $self->{'rule'}->{'s'}),"\n";
printf "<input name=source size=30 value='%s'></td> </tr>\n",
	$self->{'rule'}->{'s'}->[1];

print "<tr> <td><b>$self->{'text_hash'}->{'edit_dest'}</b></td>\n";
print "<td>",&print_mode("dest", $self->{'rule'}->{'d'}),"\n";
printf "<input name=dest size=30 value='%s'></td> </tr>\n",
	$self->{'rule'}->{'d'}->[1];

print "<tr> <td><b>$self->{'text_hash'}->{'edit_in'}</b></td>\n";
print "<td>",&print_mode("in", $self->{'rule'}->{'i'}),"\n";
print $self->interface_choice("in", $self->{'rule'}->{'i'}->[1]),"</td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'edit_out'}</b></td>\n";
print "<td>",&print_mode("out", $self->{'rule'}->{'o'}),"\n";
print $self->interface_choice("out", $self->{'rule'}->{'o'}->[1]),"</td> </tr>\n";

$self->{'f'} = !$self->{'rule'}->{'f'} ? 0 : $self->{'rule'}->{'f'}->[0] eq "!" ? 2 : 1;
print "<tr> <td><b>$self->{'text_hash'}->{'edit_frag'}</b></td>\n";
printf "<td><input type=radio name=frag value=0 %s> %s\n",
	$self->{'f'} == 0 ? "checked" : "", $self->{'text_hash'}->{'edit_ignore'};
printf "<input type=radio name=frag value=1 %s> %s\n",
	$self->{'f'} == 1 ? "checked" : "", $self->{'text_hash'}->{'edit_fragis'};
printf "<input type=radio name=frag value=2 %s> %s</td> </tr>\n",
	$self->{'f'} == 2 ? "checked" : "", $self->{'text_hash'}->{'edit_fragnot'};

print "<tr> <td><b>$self->{'text_hash'}->{'edit_proto'}</b></td>\n";
print "<td>",&print_mode("proto", $self->{'rule'}->{'p'}),"\n";
print &protocol_input("proto", $self->{'rule'}->{'p'}->[1]),"</td> </tr>\n";

print "<tr> <td colspan=2><hr></td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'edit_sport'}</b></td>\n";
print "<td>",&print_mode("sport", $self->{'rule'}->{'sports'} || $self->{'rule'}->{'sport'}),"\n";
print &port_input("sport", $self->{'rule'}->{'sports'}->[1] || $self->{'rule'}->{'sport'}->[1]),
      "</td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'edit_dport'}</b></td>\n";
print "<td>",&print_mode("dport", $self->{'rule'}->{'dports'} || $self->{'rule'}->{'dport'}),"\n";
print &port_input("dport", $self->{'rule'}->{'dports'}->[1] || $self->{'rule'}->{'dport'}->[1]),
      "</td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'edit_ports'}</b></td>\n";
print "<td>",&print_mode("ports", $self->{'rule'}->{'ports'}),"\n";
printf "<input name=ports size=20 value='%s'></td> </tr>\n",
	$self->{'rule'}->{'ports'}->[1];

print "<tr> <td><b>$self->{'text_hash'}->{'edit_tcpflags'}</b></td>\n";
print "<td><table><tr><td>",&print_mode("tcpflags", $self->{'rule'}->{'tcp-flags'}),"\n";
print "</td> <td>",$self->text('edit_flags',
	    &tcpflag_input("tcpflags0", $self->{'rule'}->{'tcp-flags'}->[1]),
	    &tcpflag_input("tcpflags1", $self->{'rule'}->{'tcp-flags'}->[2])),
      "</td></tr></table> </td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'edit_tcpoption'}</b></td>\n";
print "<td>",&print_mode("tcpoption", $self->{'rule'}->{'tcp-option'}),"\n";
printf "<input name=tcpoption size=6 value='%s'></td> </tr>\n",
	$self->{'rule'}->{'tcp-option'}->[1];

print "<tr> <td colspan=2><hr></td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'edit_icmptype'}</b></td>\n";
print "<td>",&print_mode("icmptype", $self->{'rule'}->{'icmp-type'}),"\n";
print &icmptype_input("icmptype", $self->{'rule'}->{'icmp-type'}->[1]),"</td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'edit_mac'}</b></td>\n";
print "<td>",&print_mode("macsource", $self->{'rule'}->{'mac-source'}),"\n";
printf "<input name=macsource size=18 value='%s'></td> </tr>\n",
	$self->{'rule'}->{'mac-source'}->[1];

print "<tr> <td colspan=2><hr></td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'edit_limit'}</b></td>\n";
print "<td>",&print_mode("limit", $self->{'rule'}->{'limit'},
			 $self->{'text_hash'}->{'edit_below'}, $self->{'text_hash'}->{'edit_above'}),"\n";
($self->{'n'}, $self->{'u'}) = $self->{'rule'}->{'limit'}->[1] =~ /^(\d+)\/(\S+)$/ ? ($1, $2) : ();
print "<input name=limit0 size=6 value='$self->{'n'}'>\n";
print "/ <select name=limit1>\n";
foreach $l ('second', 'minute', 'hour', 'day') {
	printf "<option value=%s %s>%s\n",
		$l, $self->{'u'} eq $l ? "selected" : "", $l;
	}
print "</select></td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'edit_limitburst'}</b></td>\n";
print "<td>",&print_mode("limitburst", $self->{'rule'}->{'limit-burst'},
			 $self->{'text_hash'}->{'edit_below'}, $self->{'text_hash'}->{'edit_above'}),"\n";
printf "<input name=limitburst size=6 value='%s'></td> </tr>\n",
	$self->{'rule'}->{'limit-burst'}->[1];

if ($self->{'rule'}->{'chain'} eq 'OUTPUT') {
	print "<tr> <td colspan=2><hr></td> </tr>\n";

	print "<tr> <td><b>$self->{'text_hash'}->{'edit_uidowner'}</b></td>\n";
	print "<td>",&print_mode("uidowner", $self->{'rule'}->{'uid-owner'}),"\n";
	printf "<input name=uidowner size=13 value='%s'> %s</td> </tr>\n",
		$self->{'rule'}->{'uid-owner'}->[1], $self->user_chooser_button("uidowner");

	print "<tr> <td><b>$self->{'text_hash'}->{'edit_gidowner'}</b></td>\n";
	print "<td>",&print_mode("gidowner", $self->{'rule'}->{'gid-owner'}),"\n";
	printf "<input name=gidowner size=13 value='%s'> %s</td> </tr>\n",
		$self->{'rule'}->{'gid-owner'}->[1], $self->group_chooser_button("gidowner");

	print "<tr> <td><b>$self->{'text_hash'}->{'edit_pidowner'}</b></td>\n";
	print "<td>",&print_mode("pidowner", $self->{'rule'}->{'pid-owner'}),"\n";
	printf "<input name=pidowner size=6 value='%s'></td> </tr>\n",
		$self->{'rule'}->{'pid-owner'}->[1];

	print "<tr> <td><b>$self->{'text_hash'}->{'edit_sidowner'}</b></td>\n";
	print "<td>",&print_mode("sidowner", $self->{'rule'}->{'sid-owner'}),"\n";
	printf "<input name=sidowner size=6 value='%s'></td> </tr>\n",
		$self->{'rule'}->{'sid-owner'}->[1];
	}

print "<tr> <td colspan=2><hr></td> </tr>\n";

print "<tr> <td valign=top><b>$self->{'text_hash'}->{'edit_state'}</b></td>\n";
print "<td><table cellpadding=0 cellspacing=0><tr><td valign=top>",
      &print_mode("state", $self->{'rule'}->{'state'}),"</td>\n";
print "<td>&nbsp;<select name=state multiple size=4>\n";
%{$self->{'states_hash'}} = map { $_,1 } split(/,/, $self->{'rule'}->{'state'}->[1]);
foreach $s ('NEW', 'ESTABLISHED', 'RELATED', 'INVALID') {
	printf "<option value=%s %s>%s (%s)\n",
		$s, $self->{'states_hash'}->{$s} ? "selected" : "",
		$self->{'text_hash'}->{"edit_state_".lc($s)}, $s;
	}
print "</select></td></tr></table></td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'edit_tos'}</b></td>\n";
print "<td>",&print_mode("tos", $self->{'rule'}->{'tos'}),"\n";
print &tos_input("tos", $self->{'rule'}->{'tos'}->[1]),"</td> </tr>\n";

print "<tr> <td colspan=2><hr></td> </tr>\n";

# Show unknown modules
@{$self->{'mods_array'}} = grep { !/^(tcp|udp|icmp|multiport|mac|limit|owner|state|tos|comment)$/ } map { $_->[1] } @{$self->{'rule'}->{'m'}};
print "<tr> <td><b>$self->{'text_hash'}->{'edit_mods'}</b></td>\n";
printf "<td colspan=3><input name=mods size=50 value='%s'></td> </tr>\n",
	join(" ", @{$self->{'mods_array'}});

# Show unknown parameters
$self->{'rule'}->{'args'} =~ s/^\s+//;
$self->{'rule'}->{'args'} =~ s/\s+$//;
print "<tr> <td><b>$self->{'text_hash'}->{'edit_args'}</b></td>\n";
printf "<td colspan=3><input name=args size=50 value='%s'></td> </tr>\n",
	$self->{'rule'}->{'args'};

print "</table></td></tr></table>\n";
print "<table width=100%><tr>\n";
if ($self->{'in_hash'}->{'new'}) {
	print "<td><input type=submit value='$self->{'text_hash'}->{'create'}'></td>\n";
	}
else {
	print "<td><input type=submit value='$self->{'text_hash'}->{'save'}'></td>\n";
	print "<td align=center><input type=submit name=clone ",
	      "value='$self->{'text_hash'}->{'edit_clone'}'></td>\n";
	print "<td align=right><input type=submit name=delete ",
	      "value='$self->{'text_hash'}->{'delete'}'></td>\n";
	}
print "</tr></table>\n";

$self->ui_print_footer("index.cgi?table=$self->{'in_hash'}->{'table'}", $self->{'text_hash'}->{'index_return'});

1;
		
}

# print_mode(name, &value)
sub print_mode
{
	shift if ($self == $_[0]);

local $m = !$_[1] ? 0 :
	   $_[1]->[0] eq "!" ? 2 : 1;
local $rv = "<select name=$_[0]_mode>\n";
$rv .= sprintf "<option value=0 %s> &lt;%s&gt;\n",
	$m == 0 ? "selected" : "", $self->{'text_hash'}->{'edit_ignore'};
$rv .= sprintf "<option value=1 %s> %s\n",
	$m == 1 ? "selected" : "", $_[2] || $self->{'text_hash'}->{'edit_is'};
$rv .= sprintf "<option value=2 %s> %s\n",
	$m == 2 ? "selected" : "", $_[3] || $self->{'text_hash'}->{'edit_not'};
$rv .= "</select>\n";
return $rv;
}

# port_input(name, value)
sub port_input
{
	shift if ($self == $_[0]);

local ($s, $e, $p);
if ($_[1] =~ /^(\d*):(\d*)$/) {
	$s = $1; $e = $2;
	}
else {
	$p = $_[1] || "";
	}
local $rv = sprintf "<input type=radio name=$_[0]_type value=0 %s> %s\n",
		defined($p) ? "checked" : "", $self->{'text_hash'}->{'edit_port0'};
$rv .= "<input name=$_[0] size=15 value='$p'>\n";
$rv .= sprintf "<input type=radio name=$_[0]_type value=1 %s>\n",
		defined($p) ? "" : "checked";
$rv .= $self->text('edit_port1', "<input name=$_[0]_from size=5 value='$s'>",
			   "<input name=$_[0]_to size=5 value='$e'>");
return $rv;
}

# tcpflag_input(name, value)
sub tcpflag_input
{
	shift if ($self == $_[0]);

local %flags = map { $_, 1 } split(/,/, $_[1]);
local $f;
local $rv = "<font size=-1>\n";
foreach $f ('SYN', 'ACK', 'FIN', 'RST', 'URG', 'PSH') {
	$rv .= sprintf "<input type=checkbox name=$_[0] value=%s %s> %s\n",
		$f, $flags{$f} || $flags{'ALL'} ? "checked" : "",
		"<tt>$f</tt>";
	}
$rv .= "</font>\n";
return $rv;
}

# icmptype_input(name, value, [&types])
sub icmptype_input
{
	shift if ($self == $_[0]);

local ($started, @types, $major, $minor);
$major = -1;
if ($_[2]) {
	@types = @{$_[2]};
	}
else {
	open(IPTABLES, "iptables -p icmp -h |");
	while(<IPTABLES>) {
		if (/valid\s+icmp\s+types:/i) {
			$started = 1;
			}
		elsif (!/\S/) {
			$started = 0;
			}
		elsif ($started && /^\s*(\S+)/) {
			push(@types, $1);
			}
		}
	close(IPTABLES);
	}
if (@types && $_[1] !~ /^\d+$/ && $_[1] !~ /^\d+\/\d+$/) {
	local $rv = "<select name=$_[0]>\n";
	foreach $t (@types) {
		$rv .= sprintf "<option value=%s %s>%s\n",
				$t, $_[1] eq $t ? "selected" : "", $t;
		}
	$rv .= "</select>\n";
	return $rv;
	}
else {
	return "<input name=$_[0] size=6 value='$_[1]'>";
	}
}

# protocol_input(name, value)
sub protocol_input
{
	shift if ($self == $_[0]);

local @stdprotos = ( 'tcp', 'udp', 'icmp', undef );
local @otherprotos;
open(PROTOS, "/etc/protocols");
while(<PROTOS>) {
	s/\r|\n//g;
	s/#.*$//;
	push(@otherprotos, $1) if (/^(\S+)\s+(\d+)/);
	}
close(PROTOS);
@otherprotos = sort { lc($a) cmp lc($b) } @otherprotos;
local $p;
local $rv = "<select name=$_[0]>\n";
local $found = $self->{'rule'}->{'p'}->[1] ? 0 : 1;
foreach $p ($self->unique(@stdprotos, @otherprotos)) {
	$rv .= sprintf "<option value='%s' %s>%s\n",
			$p, $self->{'rule'}->{'p'}->[1] eq $p && $p ? "selected" : "",
			uc($p) || "-------";
	$found++ if ($self->{'rule'}->{'p'}->[1] eq $p && $p);
	}
$rv .= sprintf "<option value='%s' %s>%s\n",
		'', !$found ? "selected" : "", $self->{'text_hash'}->{'edit_oifc'};
$rv .= "</select>\n";
$rv .= $self->ui_textbox($_[0]."_other", $found ? undef : $self->{'rule'}->{'p'}->[1], 5);
return $rv;
}

# tos_input(name, value)
sub tos_input
{
	shift if ($self == $_[0]);

local ($started, @opts);
open(IPTABLES, "iptables -m tos -h |");
while(<IPTABLES>) {
	if (/TOS.*options:/i) {
		$started = 1;
		}
	elsif ($started && /^\s+(\S+)\s+(\d+)\s+\((0x[0-9a-f]+)\)/i) {
		push(@opts, [ $1, $3 ]);
		}
	}
close(IPTABLES);
if (@opts) {
	local $rv = "<select name=$_[0]>\n";
	foreach $o (@opts) {
		$rv .= sprintf "<option value=%s %s>%s\n",
			$o->[0], $o->[0] eq $_[1] ? "selected" : "",
			"$o->[0] ($o->[1])";
		}
	$rv .= "</select>\n";
	return $rv;
	}
else {
	return "<input name=$_[0] size=20 value='$_[1]'>\n";
	}
}


1;

