#!/usr/bin/perl

&MAIN();

 sub MAIN {
# move.cgi
# Swap two rules in some chain

&ModuleLoader::preload_module('firewall_class', "firewall::FirewallLib");
$self = new firewall::FirewallLib:: 'firewall_class',%$self;

$self->ReadParse();
$self->lock_file($self->{'iptables_save_file'});
@{$self->{'tables_array'}} = $self->get_iptables_save();
$self->{'table'} = $self->{'tables_array'}->[$self->{'in_hash'}->{'table'}];
$self->can_edit_table($self->{'table'}->{'name'}) || $self->error($self->{'text_hash'}->{'etable'});
$self->{'r'} = $self->{'table'}->{'rules'};
$self->{'c'} = $self->{'r'}->[$self->{'in_hash'}->{'idx'}]->{'chain'};
@{$self->{'rules_array'}} = grep { lc($_->{'chain'}) eq lc($self->{'c'}) } @{$self->{'r'}};
$self->{'pos'} = $self->indexof($self->{'r'}->[$self->{'in_hash'}->{'idx'}], @{$self->{'rules_array'}});
$self->can_jump($self->{'r'}->[$self->{'in_hash'}->{'idx'}]) || $self->error($self->{'text_hash'}->{'ejump'});
if ($self->{'in_hash'}->{'down'}) {
	# Swap with next rule in this chain
	$self->{'nxt'} = $self->{'rules_array'}->[$self->{'pos'}+1]->{'index'};
	$self->can_jump($self->{'r'}->[$self->{'nxt'}]) || $self->error($self->{'text_hash'}->{'ejump'});
	($self->{'r'}->[$self->{'in_hash'}->{'idx'}], $self->{'r'}->[$self->{'nxt'}]) = ($self->{'r'}->[$self->{'nxt'}], $self->{'r'}->[$self->{'in_hash'}->{'idx'}]);
	}
else {
	# Swap with previous rule in this chain
	$self->{'prv'} = $self->{'rules_array'}->[$self->{'pos'}-1]->{'index'};
	$self->can_jump($self->{'r'}->[$self->{'prv'}]) || $self->error($self->{'text_hash'}->{'ejump'});
	($self->{'r'}->[$self->{'in_hash'}->{'idx'}], $self->{'r'}->[$self->{'prv'}]) = ($self->{'r'}->[$self->{'prv'}], $self->{'r'}->[$self->{'in_hash'}->{'idx'}]);
	}
$self->run_before_command();
$self->save_table($self->{'table'});
$self->run_after_command();
$self->copy_to_cluster();
$self->unlock_file($self->{'iptables_save_file'});
$self->webmin_log("move", "rule", undef, { 'table' => $self->{'table'}->{'name'},
				     'chain' => $self->{'r'}->[$self->{'in_hash'}->{'idx'}]->{'chain'} });
$self->redirect("index.cgi?table=$self->{'in_hash'}->{'table'}");

1;
		
}


1;

