#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_policy.cgi
# Change the default policy for some chain

&ModuleLoader::preload_module('firewall_class', "firewall::FirewallLib");
$self = new firewall::FirewallLib:: 'firewall_class',%$self;

$self->ReadParse();
@{$self->{'tables_array'}} = $self->get_iptables_save();
$self->{'table'} = $self->{'tables_array'}->[$self->{'in_hash'}->{'table'}];
$self->can_edit_table($self->{'table'}->{'name'}) || $self->error($self->{'text_hash'}->{'etable'});

if ($self->{'in_hash'}->{'add'}) {
	# Redirect to the rule page for adding a rule
	$self->redirect("edit_rule.cgi?table=$self->{'in_hash'}->{'table'}&chain=$self->{'in_hash'}->{'chain'}&new=1");
	}
elsif ($self->{'in_hash'}->{'delete'} && $self->{'in_hash'}->{'confirm'}) {
	# Delete this entire chain and all rules in it
	$self->lock_file($self->{'iptables_save_file'});
	$self->{'access_hash'}->{'delchain'} || $self->error($self->{'text_hash'}->{'delete_ecannot'});
	$self->{'table'}->{'rules'} = [ grep { $_->{'chain'} ne $self->{'in_hash'}->{'chain'} }
				   @{$self->{'table'}->{'rules'}} ];
	delete($self->{'table'}->{'defaults'}->{$self->{'in_hash'}->{'chain'}});
	$self->run_before_command();
	$self->save_table($self->{'table'});
	$self->run_after_command();
	$self->copy_to_cluster();
	$self->unlock_file($self->{'iptables_save_file'});
	$self->webmin_log("delete", "chain", undef, { 'chain' => $self->{'in_hash'}->{'chain'},
						'table' => $self->{'table'}->{'name'} });
	$self->redirect("index.cgi?table=$self->{'in_hash'}->{'table'}");
	}
elsif ($self->{'in_hash'}->{'clear'} && $self->{'in_hash'}->{'confirm'}) {
	# Delete all rules from this chain
	$self->{'access_hash'}->{'delchain'} || $self->error($self->{'text_hash'}->{'clear_ecannot'});
	$self->lock_file($self->{'iptables_save_file'});
	$self->{'table'}->{'rules'} = [ grep { $_->{'chain'} ne $self->{'in_hash'}->{'chain'} }
				   @{$self->{'table'}->{'rules'}} ];
	$self->run_before_command();
	$self->save_table($self->{'table'});
	$self->run_after_command();
	$self->copy_to_cluster();
	$self->unlock_file($self->{'iptables_save_file'});
	$self->webmin_log("clear", "chain", undef, { 'chain' => $self->{'in_hash'}->{'chain'},
					       'table' => $self->{'table'}->{'name'} });
	$self->redirect("index.cgi?table=$self->{'in_hash'}->{'table'}");
	}
elsif ($self->{'in_hash'}->{'delete'} || $self->{'in_hash'}->{'clear'}) {
	# Ask for confirmation on deleting the chain
	$self->{'mode'} = $self->{'in_hash'}->{'delete'} ? "delete" : "clear";
	$self->{'access_hash'}->{'delchain'} || $self->error($self->{'text_hash'}->{$self->{'mode'}.'_ecannot'});
	$self->ui_print_header(undef, $self->{'text_hash'}->{$self->{'mode'}.'_title'}, "");

	@{$self->{'rules_array'}} = grep { $_->{'chain'} eq $self->{'in_hash'}->{'chain'} } @{$self->{'table'}->{'rules'}};
	print "<form action=save_policy.cgi>\n";
	print "<input type=hidden name=table value='$self->{'in_hash'}->{'table'}'>\n";
	print "<input type=hidden name=chain value='$self->{'in_hash'}->{'chain'}'>\n";
	print "<input type=hidden name=$self->{'mode'} value=1>\n";
	print "<center><b>",$self->text($self->{'mode'}.'_rusure', "<tt>$self->{'in_hash'}->{'chain'}</tt>",
				  scalar(@{$self->{'rules_array'}})),"</b><p>\n";
	print "<input type=submit name=confirm value='$self->{'text_hash'}->{'delete_ok'}'>\n";
	print "</center></form>\n";

	$self->ui_print_footer("index.cgi?table=$self->{'in_hash'}->{'table'}", $self->{'text_hash'}->{'index_return'});
	}
elsif ($self->{'in_hash'}->{'delsel'}) {
	# Just delete selected rules
	%{$self->{'idxs_hash'}} = map { $_, 1 } split(/\0/, $self->{'in_hash'}->{'d'});
	$self->lock_file($self->{'iptables_save_file'});
	$self->{'table'}->{'rules'} = [ grep { $_->{'chain'} ne $self->{'in_hash'}->{'chain'} ||
				     !$self->{'idxs_hash'}->{$_->{'index'}} }
				   @{$self->{'table'}->{'rules'}} ];
	$self->run_before_command();
	$self->save_table($self->{'table'});
	$self->run_after_command();
	$self->copy_to_cluster();
	$self->unlock_file($self->{'iptables_save_file'});
	$self->webmin_log("delsel", "chain", undef, { 'chain' => $self->{'in_hash'}->{'chain'},
					        'table' => $self->{'table'}->{'name'},
						'count' => scalar(keys %{$self->{'idxs_hash'}})});
	$self->redirect("index.cgi?table=$self->{'in_hash'}->{'table'}");

	}
else {
	# Change the default for this chain
	$self->{'access_hash'}->{'policy'} || $self->error($self->{'text_hash'}->{'policy_ecannot'});
	$self->lock_file($self->{'iptables_save_file'});
	$self->{'table'}->{'defaults'}->{$self->{'in_hash'}->{'chain'}} = $self->{'in_hash'}->{'policy'};
	$self->run_before_command();
	$self->save_table($self->{'table'});
	$self->run_after_command();
	$self->copy_to_cluster();
	$self->unlock_file($self->{'iptables_save_file'});
	$self->webmin_log("modify", "chain", undef, { 'chain' => $self->{'in_hash'}->{'chain'},
					        'table' => $self->{'table'}->{'name'} });
	$self->redirect("index.cgi?table=$self->{'in_hash'}->{'table'}");
	}

1;
		
}


1;

