#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_rule.cgi
# Save, create or delete a rule in a chain

&ModuleLoader::preload_module('firewall_class', "firewall::FirewallLib");
$self = new firewall::FirewallLib:: 'firewall_class',%$self;

$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'save_err'});
@{$self->{'tables_array'}} = $self->get_iptables_save();
$self->{'table'} = $self->{'tables_array'}->[$self->{'in_hash'}->{'table'}];
$self->can_edit_table($self->{'table'}->{'name'}) || $self->error($self->{'text_hash'}->{'etable'});
if ($self->{'in_hash'}->{'new'}) {
	$self->{'rule'} = { 'chain' => $self->{'in_hash'}->{'chain'} };
	}
else {
	$self->{'rule'} = $self->{'table'}->{'rules'}->[$self->{'in_hash'}->{'idx'}];
	$self->can_jump($self->{'rule'}) || $self->error($self->{'text_hash'}->{'ejump'});
	}
if ($self->{'in_hash'}->{'clone'}) {
	# Go back to the editing page
	$self->redirect("edit_rule.cgi?new=1&clone=$self->{'in_hash'}->{'idx'}&table=$self->{'in_hash'}->{'table'}&chain=$self->{'rule'}->{'chain'}");
	}

$self->lock_file($self->{'iptables_save_file'});
if ($self->{'in_hash'}->{'delete'}) {
	# Just delete this rule
	splice(@{$self->{'table'}->{'rules'}}, $self->{'in_hash'}->{'idx'}, 1);
	}
else {
	# Validate and store inputs
	if ($self->{'config_hash'}->{'comment_mod'}) {
		if ($self->{'in_hash'}->{'cmt'}) {
			$self->{'rule'}->{'comment'} = [ "", $self->{'in_hash'}->{'cmt'} ];
			push(@{$self->{'mods_array'}}, "comment");
			}
		else {
			delete($self->{'rule'}->{'comment'});
			}
		}
	else {
		$self->{'rule'}->{'cmt'} = $self->{'in_hash'}->{'cmt'};
		}
	if ($self->{'in_hash'}->{'jump'} eq '*') {
		$self->{'in_hash'}->{'other'} =~ /^\S+$/ || $self->error($self->{'text_hash'}->{'save_echain'});
		$self->{'rule'}->{'j'} = [ "", $self->{'in_hash'}->{'other'} ];
		}
	elsif ($self->{'in_hash'}->{'jump'}) {
		$self->{'rule'}->{'j'} = [ "", $self->{'in_hash'}->{'jump'} ];
		}
	else {
		delete($self->{'rule'}->{'j'});
		}
	$self->can_jump($self->{'rule'}) || $self->error($self->{'text_hash'}->{'save_ecanjump'});
	if (defined($self->{'in_hash'}->{'rwithtype'})) {
		if ($self->{'rule'}->{'j'}->[1] eq 'REJECT' && !$self->{'in_hash'}->{'rwithdef'}) {
			$self->{'rule'}->{'reject-with'} = [ "", $self->{'in_hash'}->{'rwithtype'} ];
			}
		else {
			delete($self->{'rule'}->{'reject-with'});
			}
		}
	if ($self->{'table'}->{'name'} eq 'nat' && $self->{'rule'}->{'chain'} ne 'POSTROUTING' ||
	    $self->{'table'}->{'name'} eq 'nat' && $self->{'rule'}->{'chain'} eq 'POSTROUTING') {
		if ($self->{'rule'}->{'j'}->[1] eq 'REDIRECT' && !$self->{'in_hash'}->{'rtodef'}) {
			$self->{'in_hash'}->{'rtofrom'} =~ /^\d+$/ ||
				$self->error($self->{'text_hash'}->{'save_ertoports'});
			$self->{'in_hash'}->{'rtoto'} =~ /^\d*$/ ||
				$self->error($self->{'text_hash'}->{'save_ertoports'});
			$self->{'rule'}->{'to-ports'} = [ "", $self->{'in_hash'}->{'rtoto'} eq '' ?
			    $self->{'in_hash'}->{'rtofrom'} : $self->{'in_hash'}->{'rtofrom'}."-".$self->{'in_hash'}->{'rtoto'} ];
			}
		elsif ($self->{'rule'}->{'j'}->[1] eq 'MASQUERADE' && !$self->{'in_hash'}->{'mtodef'}) {
			$self->{'in_hash'}->{'mtofrom'} =~ /^\d+$/ ||
				$self->error($self->{'text_hash'}->{'save_emtoports'});
			$self->{'in_hash'}->{'mtoto'} =~ /^\d*$/ ||
				$self->error($self->{'text_hash'}->{'save_emtoports'});
			$self->{'rule'}->{'to-ports'} = [ "", $self->{'in_hash'}->{'mtoto'} eq '' ?
			    $self->{'in_hash'}->{'mtofrom'} : $self->{'in_hash'}->{'mtofrom'}."-".$self->{'in_hash'}->{'mtoto'} ];
			}
		else {
			delete($self->{'rule'}->{'to-ports'});
			}
		}
	if ($self->{'table'}->{'name'} eq 'nat' && $self->{'rule'}->{'chain'} ne 'POSTROUTING') {
		if ($self->{'rule'}->{'j'}->[1] eq 'DNAT' && !$self->{'in_hash'}->{'dnatdef'}) {
			$self->check_ipaddress($self->{'in_hash'}->{'dipfrom'}) ||
				$self->error($self->{'text_hash'}->{'save_edipfrom'});
			!$self->{'in_hash'}->{'dipto'} || $self->check_ipaddress($self->{'in_hash'}->{'dipto'}) ||
				$self->error($self->{'text_hash'}->{'save_edipto'});
			local $v = $self->{'in_hash'}->{'dipfrom'};
			$v .= "-".$self->{'in_hash'}->{'dipto'} if ($self->{'in_hash'}->{'dipto'});
			if ($self->{'in_hash'}->{'dpfrom'} ne '') {
				$self->{'in_hash'}->{'dpfrom'} =~ /^\d+$/ ||
					$self->error($self->{'text_hash'}->{'save_edpfrom'});
				$self->{'in_hash'}->{'dpto'} =~ /^\d*$/ ||
					$self->error($self->{'text_hash'}->{'save_edpto'});
				if ($self->{'in_hash'}->{'dpto'} eq '') {
					$v .= ":".$self->{'in_hash'}->{'dpfrom'};
					}
				else {
					$v .= ":".$self->{'in_hash'}->{'dpfrom'}."-".$self->{'in_hash'}->{'dpto'};
					}
				}
			$self->{'rule'}->{'to-destination'} = [ "", $v ];
			}
		else {
			delete($self->{'rule'}->{'to-destination'});
			}
		}
	if ($self->{'table'}->{'name'} eq 'nat' && $self->{'rule'}->{'chain'} eq 'POSTROUTING') {
		if ($self->{'rule'}->{'j'}->[1] eq 'SNAT' && !$self->{'in_hash'}->{'snatdef'}) {
			$self->check_ipaddress($self->{'in_hash'}->{'sipfrom'}) ||
				$self->error($self->{'text_hash'}->{'save_esipfrom'});
			!$self->{'in_hash'}->{'sipto'} || $self->check_ipaddress($self->{'in_hash'}->{'sipto'}) ||
				$self->error($self->{'text_hash'}->{'save_esipto'});
			local $v = $self->{'in_hash'}->{'sipfrom'};
			$v .= "-".$self->{'in_hash'}->{'sipto'} if ($self->{'in_hash'}->{'sipto'});
			if ($self->{'in_hash'}->{'spfrom'} ne '') {
				$self->{'in_hash'}->{'spfrom'} =~ /^\d+$/ ||
					$self->error($self->{'text_hash'}->{'save_espfrom'});
				$self->{'in_hash'}->{'spto'} =~ /^\d*$/ ||
					$self->error($self->{'text_hash'}->{'save_espto'});
				if ($self->{'in_hash'}->{'spto'} eq '') {
					$v .= ":".$self->{'in_hash'}->{'spfrom'};
					}
				else {
					$v .= ":".$self->{'in_hash'}->{'spfrom'}."-".$self->{'in_hash'}->{'spto'};
					}
				}
			$self->{'rule'}->{'to-source'} = [ "", $v ];
			}
		else {
			delete($self->{'rule'}->{'to-source'});
			}
		}
	if (&parse_mode("source", $self->{'rule'}, "s")) {
		&check_ipmask($self->{'in_hash'}->{'source'}) || $self->error($self->{'text_hash'}->{'save_esource'});
		$self->{'rule'}->{'s'}->[1] = $self->{'in_hash'}->{'source'};
		}
	if (&parse_mode("dest", $self->{'rule'}, "d")) {
		&check_ipmask($self->{'in_hash'}->{'dest'}) || $self->error($self->{'text_hash'}->{'save_edest'});
		$self->{'rule'}->{'d'}->[1] = $self->{'in_hash'}->{'dest'};
		}
	if (&parse_mode("in", $self->{'rule'}, "i")) {
		$self->{'in_hash'}->{'in'} ne '' || $self->{'in_hash'}->{'in_other'} =~ /^\S+$/ ||
			$self->error($self->{'text_hash'}->{'save_ein'});
		$self->{'rule'}->{'i'}->[1] = $self->{'in_hash'}->{'in'} eq '' || $self->{'in_hash'}->{'in'} eq 'other' ?
					$self->{'in_hash'}->{'in_other'} : $self->{'in_hash'}->{'in'};
		}
	if (&parse_mode("out", $self->{'rule'}, "o")) {
		$self->{'in_hash'}->{'out'} ne '' || $self->{'in_hash'}->{'out_other'} =~ /^\S+$/ ||
			$self->error($self->{'text_hash'}->{'save_eout'});
		$self->{'rule'}->{'o'}->[1] = $self->{'in_hash'}->{'out'} eq '' || $self->{'in_hash'}->{'out'} eq 'other' ?
					$self->{'in_hash'}->{'out_other'} : $self->{'in_hash'}->{'out'};
		}
	if ($self->{'in_hash'}->{'frag'} == 0) { delete($self->{'rule'}->{'f'}); }
	elsif ($self->{'in_hash'}->{'frag'} == 1) { $self->{'rule'}->{'f'} = [ "" ]; }
	else { $self->{'rule'}->{'f'} = [ "!" ]; }
	if (&parse_mode("proto", $self->{'rule'}, "p")) {
		$self->{'in_hash'}->{'proto'} || $self->{'in_hash'}->{'proto_other'} =~ /^\d+$/ ||
			$self->error($self->{'text_hash'}->{'save_eproto'});
		$self->{'rule'}->{'p'}->[1] = $self->{'in_hash'}->{'proto'} || $self->{'in_hash'}->{'proto_other'};
		if (!$self->{'rule'}->{'p'}->[0]) {
			$self->{'proto'} = $self->{'in_hash'}->{'proto'};
			push(@{$self->{'mods_array'}}, $self->{'in_hash'}->{'proto'})
				if ($self->{'proto'} eq 'tcp' || $self->{'proto'} eq 'udp' ||
				    $self->{'proto'} eq 'icmp' && $self->{'in_hash'}->{'icmptype_mode'});
			}
		}

	if (&parse_mode("sport", $self->{'rule'}, "sport")) {
		$self->{'proto'} eq "tcp" || $self->{'proto'} eq "udp" ||
			$self->error($self->{'text_hash'}->{'save_etcpudp'});
		if ($self->{'in_hash'}->{"sport_type"} == 0) {
			$self->{'in_hash'}->{"sport"} =~ /^\S+$/ ||
				$self->error($self->{'text_hash'}->{'save_esport'});
			if ($self->{'in_hash'}->{"sport"} =~ /,/) {
				$self->{'rule'}->{'sports'}->[1] = $self->{'in_hash'}->{"sport"};
				push(@{$self->{'mods_array'}}, "multiport");
				delete($self->{'rule'}->{'sport'});
				}
			else {
				$self->{'rule'}->{'sport'}->[1] = $self->{'in_hash'}->{"sport"};
				delete($self->{'rule'}->{'sports'});
				}
			}
		else {
			$self->{'in_hash'}->{"sport_from"} =~ /^\d*$/ ||
				$self->error($self->{'text_hash'}->{'save_esportfrom'});
			$self->{'in_hash'}->{"sport_to"} =~ /^\d*$/ ||
				$self->error($self->{'text_hash'}->{'save_esportto'});
			$self->{'rule'}->{'sport'}->[1] = $self->{'in_hash'}->{"sport_from"}.":".
						$self->{'in_hash'}->{"sport_to"};
			$self->{'rule'}->{'sport'}->[1] eq ":" &&
				$self->error($self->{'text_hash'}->{'save_esportrange'});
			delete($self->{'rule'}->{'sports'});
			}
		}
	else {
		delete($self->{'rule'}->{'sports'});
		}
	if (&parse_mode("dport", $self->{'rule'}, "dport")) {
		$self->{'proto'} eq "tcp" || $self->{'proto'} eq "udp" ||
			$self->error($self->{'text_hash'}->{'save_etcpudp'});
		if ($self->{'in_hash'}->{"dport_type"} == 0) {
			$self->{'in_hash'}->{"dport"} =~ /^\S+$/ ||
				$self->error($self->{'text_hash'}->{'save_edport'});
			if ($self->{'in_hash'}->{"dport"} =~ /,/) {
				$self->{'rule'}->{'dports'}->[1] = $self->{'in_hash'}->{"dport"};
				push(@{$self->{'mods_array'}}, "multiport");
				delete($self->{'rule'}->{'dport'});
				}
			else {
				$self->{'rule'}->{'dport'}->[1] = $self->{'in_hash'}->{"dport"};
				delete($self->{'rule'}->{'dports'});
				}
			}
		else {
			$self->{'in_hash'}->{"dport_from"} =~ /^\d*$/ ||
				$self->error($self->{'text_hash'}->{'save_edportfrom'});
			$self->{'in_hash'}->{"dport_to"} =~ /^\d*$/ ||
				$self->error($self->{'text_hash'}->{'save_edportto'});
			$self->{'rule'}->{'dport'}->[1] = $self->{'in_hash'}->{"dport_from"}.":".
						$self->{'in_hash'}->{"dport_to"};
			$self->{'rule'}->{'dport'}->[1] eq ":" &&
				$self->error($self->{'text_hash'}->{'save_edportrange'});
			delete($self->{'rule'}->{'dports'});
			}
		}
	else {
		delete($self->{'rule'}->{'dports'});
		}
	if (&parse_mode("ports", $self->{'rule'}, "ports")) {
		$self->{'proto'} eq "tcp" || $self->{'proto'} eq "udp" ||
			$self->error($self->{'text_hash'}->{'save_etcpudp'});
		$self->{'in_hash'}->{"ports"} =~ /^\S+$/ || $self->error($self->{'text_hash'}->{'save_eports'});
		$self->{'rule'}->{'ports'}->[1] = $self->{'in_hash'}->{'ports'};
		push(@{$self->{'mods_array'}}, "multiport");
		}
	if (&parse_mode("tcpflags", $self->{'rule'}, "tcp-flags")) {
		$self->{'proto'} eq "tcp" || $self->error($self->{'text_hash'}->{'save_etcp1'});
		local $tcp0 = join(",", split(/\0/, $self->{'in_hash'}->{"tcpflags0"}));
		local $tcp1 = join(",", split(/\0/, $self->{'in_hash'}->{"tcpflags1"}));
		#$tcp0 && $tcp1 || $self->error($self->{'text_hash'}->{'save_etcpflags'});
		$tcp0 || $self->error($self->{'text_hash'}->{'save_etcpflags2'});
		$self->{'rule'}->{'tcp-flags'}->[1] = $tcp0;
		$self->{'rule'}->{'tcp-flags'}->[2] = $tcp1 || "NONE";
		}
	if (&parse_mode("tcpoption", $self->{'rule'}, "tcp-option")) {
		$self->{'proto'} eq "tcp" || $self->error($self->{'text_hash'}->{'save_etcp2'});
		$self->{'in_hash'}->{"tcpoption"} =~ /^\d+$/ ||
			$self->error($self->{'text_hash'}->{'save_etcpoption'});
		$self->{'rule'}->{'tcp-option'}->[1] = $self->{'in_hash'}->{"tcpoption"};
		}
	if (&parse_mode("icmptype", $self->{'rule'}, "icmp-type")) {
		$self->{'proto'} eq "icmp" || $self->error($self->{'text_hash'}->{'save_eicmp'});
		$self->{'rule'}->{'icmp-type'}->[1] = $self->{'in_hash'}->{'icmptype'};
		}
	if (&parse_mode("macsource", $self->{'rule'}, "mac-source")) {
		$self->{'in_hash'}->{"macsource"} =~ /^([0-9a-z]{2}:){5}[[0-9a-z]{2}$/i ||
			$self->error($self->{'text_hash'}->{'save_emac'});
		$self->{'rule'}->{'mac-source'}->[1] = $self->{'in_hash'}->{'macsource'};
		push(@{$self->{'mods_array'}}, "mac");
		}
	if (&parse_mode("limit", $self->{'rule'}, "limit")) {
		$self->{'in_hash'}->{'limit0'} =~ /^\d+$/ || $self->error($self->{'text_hash'}->{'save_elimit'});
		$self->{'rule'}->{'limit'}->[1] = $self->{'in_hash'}->{'limit0'}."/".$self->{'in_hash'}->{'limit1'};
		push(@{$self->{'mods_array'}}, "limit");
		}
	if (&parse_mode("limitburst", $self->{'rule'}, "limit-burst")) {
		$self->{'in_hash'}->{'limitburst'} =~ /^\d+$/ ||
			$self->error($self->{'text_hash'}->{'save_elimitburst'});
		$self->{'rule'}->{'limit-burst'}->[1] = $self->{'in_hash'}->{'limitburst'};
		push(@{$self->{'mods_array'}}, "limit");
		}

	if ($self->{'rule'}->{'chain'} eq 'OUTPUT') {
		if (&parse_mode("uidowner", $self->{'rule'}, "uid-owner")) {
			defined(getpwnam($self->{'in_hash'}->{"uidowner"})) ||
				$self->error($self->{'text_hash'}->{'save_euidowner'});
			$self->{'rule'}->{'uid-owner'}->[1] = $self->{'in_hash'}->{"uidowner"};
			push(@{$self->{'mods_array'}}, "owner");
			}
		if (&parse_mode("gidowner", $self->{'rule'}, "gid-owner")) {
			defined(getgrnam($self->{'in_hash'}->{"gidowner"})) ||
				$self->error($self->{'text_hash'}->{'save_egidowner'});
			$self->{'rule'}->{'gid-owner'}->[1] = $self->{'in_hash'}->{"gidowner"};
			push(@{$self->{'mods_array'}}, "owner");
			}
		if (&parse_mode("pidowner", $self->{'rule'}, "pid-owner")) {
			$self->{'in_hash'}->{"pidowner"} =~ /^\d+$/ ||
				$self->error($self->{'text_hash'}->{'save_epidowner'});
			$self->{'rule'}->{'pid-owner'}->[1] = $self->{'in_hash'}->{"pidowner"};
			push(@{$self->{'mods_array'}}, "owner");
			}
		if (&parse_mode("sidowner", $self->{'rule'}, "sid-owner")) {
			$self->{'in_hash'}->{"sidowner"} =~ /^\d+$/ ||
				$self->error($self->{'text_hash'}->{'save_esidowner'});
			$self->{'rule'}->{'sid-owner'}->[1] = $self->{'in_hash'}->{"sidowner"};
			push(@{$self->{'mods_array'}}, "owner");
			}
		}

	if (&parse_mode("state", $self->{'rule'}, "state")) {
		@{$self->{'states_array'}} = split(/\0/, $self->{'in_hash'}->{'state'});
		@{$self->{'states_array'}} || $self->error($self->{'text_hash'}->{'save_estates'});
		$self->{'rule'}->{'state'}->[1] = join(",", @{$self->{'states_array'}});
		push(@{$self->{'mods_array'}}, "state");
		}
	if (&parse_mode("tos", $self->{'rule'}, "tos")) {
		$self->{'rule'}->{'tos'}->[1] = $self->{'in_hash'}->{'tos'};
		push(@{$self->{'mods_array'}}, "tos");
		}

	# Add custom paramters and modules
	$self->{'rule'}->{'args'} = $self->{'in_hash'}->{'args'};
	push(@{$self->{'mods_array'}}, split(/\s+/, $self->{'in_hash'}->{'mods'}));

	# Save the rule
	if (@{$self->{'mods_array'}}) {
		$self->{'rule'}->{'m'} = [ map { [ "", $_ ] } $self->unique(@{$self->{'mods_array'}}) ];
		}
	else {
		delete($self->{'rule'}->{'m'});
		}
	delete($self->{'rule'}->{'j'}) if (!$self->{'in_hash'}->{'jump'});
	if ($self->{'in_hash'}->{'new'}) {
		if ($self->{'in_hash'}->{'before'} ne '') {
			splice(@{$self->{'table'}->{'rules'}}, $self->{'in_hash'}->{'before'}, 0, $self->{'rule'});
			}
		elsif ($self->{'in_hash'}->{'after'} ne '') {
			splice(@{$self->{'table'}->{'rules'}}, $self->{'in_hash'}->{'after'}+1, 0, $self->{'rule'});
			}
		else {
			push(@{$self->{'table'}->{'rules'}}, $self->{'rule'});
			}
		}
	}

# Write out the new save file
$self->run_before_command();
$self->save_table($self->{'table'});
$self->run_after_command();
$self->copy_to_cluster();
$self->unlock_file($self->{'iptables_save_file'});
$self->webmin_log($self->{'in_hash'}->{'delete'} ? "delete" : $self->{'in_hash'}->{'new'} ? "create" : "modify",
	    "rule", undef, { 'chain' => $self->{'rule'}->{'chain'},
			     'table' => $self->{'table'}->{'name'} });
$self->redirect("index.cgi?table=$self->{'in_hash'}->{'table'}");

1;
		
}

# parse_mode(name, &rule, option)
sub parse_mode
{
	shift if ($self == $_[0]);

if ($self->{'in_hash'}->{"$_[0]_mode"} == 0) {
	delete($_[1]->{$_[2]});
	return 0;
	}
elsif ($self->{'in_hash'}->{"$_[0]_mode"} == 1) {
	$_[1]->{$_[2]} = [ "" ];
	return 1;
	}
else {
	$_[1]->{$_[2]} = [ "!" ];
	return 1;
	}
}

sub check_ipmask
{
	shift if ($self == $_[0]);

return $self->check_ipaddress($_[0]) || gethostbyname($_[0]) ||
	$_[0] =~ /^([0-9\.]+)\/([0-9\.]+)$/ &&
		($self->check_ipaddress("$1") || gethostbyname("$1")) &&
		($self->check_ipaddress("$2") || $2 =~ /^\d+$/);
}


1;

