#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Show form for adding or removing Frox IPtables rule

&ModuleLoader::preload_module('frox_class', "frox::FroxLib");
$self = new frox::FroxLib:: 'frox_class',%$self;

$self->ui_print_header(undef, $self->{'text_hash'}->{'iptables_title'}, "");
$self->foreign_require("firewall", "firewall-lib.pl");
$self->foreign_require("net", "net-lib.pl");

# Is the Linux firewall module setup OK?
$self->{'inst'} = $self->foreign_installed("firewall", 1);
if ($self->{'inst'} == 0) {
	# Not installed at all
	$self->ui_print_endpage($self->text('iptables_inst0', "../firewall/"));
	}
elsif ($self->{'inst'} == 1) {
	# Not properly setup
	$self->ui_print_endpage($self->text('iptables_inst1', "../firewall/"));
	}

# See if a rule redirecting to the port exists
$self->{'conf'} = $self->get_config();
$self->{'port'} = $self->find_value("Port", $self->{'conf'});
@{$self->{'tables_array'}} = $main::firewall_object->get_iptables_save();
($self->{'nat'}) = grep { $_->{'name'} eq 'nat'} @{$self->{'tables_array'}};
foreach $r (@{$self->{'nat'}->{'rules'}}) {
	if ($r->{'chain'} eq 'PREROUTING' &&
	    $r->{'j'}->[1] eq 'REDIRECT' &&
	    $r->{'dport'}->[1] == 21 &&
	    $r->{'to-ports'}->[1] == $self->{'port'}) {
		# Got one!
		$self->{'rule'} = $r;
		}
	}

# Show enabled/disable rule form
print $self->text('iptables_desc', 21, $self->{'port'}, "../firewall/"),"<p>\n";
print $self->ui_form_start("save_iptables.cgi", "post");
print $self->ui_hidden("rule", $self->{'rule'}->{'index'}) if ($self->{'rule'});

print $self->ui_oneradio("enabled", 0, $self->{'text_hash'}->{'iptables_disabled'}, !$self->{'rule'}),"<br>\n";

print $self->ui_oneradio("enabled", 1, $self->text('iptables_enabled',
       	$self->ui_textbox("net", $self->{'rule'} ? $self->{'rule'}->{'s'}->[1] : "", 20)),
	$self->{'rule'} && $self->{'rule'}->{'s'}),"<br>\n";

print $self->ui_oneradio("enabled", 2, $self->text('iptables_enabled2',
	$main::net_object->interface_choice("iface", $self->{'rule'} ? $self->{'rule'}->{'i'}->[1] : "")),
	$self->{'rule'} && $self->{'rule'}->{'i'}),"<br>\n";

print $self->ui_form_end([ [ 'save', $self->{'text_hash'}->{'iptables_save'} ] ], "100%");

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
1;
		
}


1;

