#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Display icons for the various Frox config sections

&ModuleLoader::preload_module('frox_class', "frox::FroxLib");
$self = new frox::FroxLib:: 'frox_class',%$self;


# Make sure frox is installed
if (!-r $self->{'config_hash'}->{'frox_conf'} && -r $self->{'config_hash'}->{'alt_frox_conf'}) {
	system("cp ".quotemeta($self->{'config_hash'}->{'alt_frox_conf'})." ".
		     quotemeta($self->{'config_hash'}->{'frox_conf'}));
	}
if (!-r $self->{'config_hash'}->{'frox_conf'}) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", "intro", 1, 1);
	$self->ui_print_endpage(
		$self->ui_config_link('index_econf',
			[ "<tt>$self->{'config_hash'}->{'frox_conf'}</tt>", undef ]));
	}
if (!$self->has_command($self->{'config_hash'}->{'frox'})) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", "intro", 1, 1);
	$self->ui_print_endpage(
		$self->ui_config_link('index_ecmd',
		        [ "<tt>$self->{'config_hash'}->{'frox'}</tt>", undef ]));
	}

# Get the version
# XXX

# Show icons
$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", "intro", 1, 1, 0,
		 $self->help_search_link("frox", "man", "doc", "google"),
		 undef, undef,
		 $self->text('index_version', $self->{'frox_version'}));

@{$self->{'names_array'}} = ( "net", "general", "ftp", "cache", "acl" );
push(@{$self->{'names_array'}}, "iptables") if ($self->foreign_check("firewall"));
@{$self->{'titles_array'}} = map { $self->{'text_hash'}->{$_."_title"} } @{$self->{'names_array'}};
@{$self->{'icons_array'}} = map { "images/$_.gif" } @{$self->{'names_array'}};
@{$self->{'links_array'}} = map { "edit_${_}.cgi" } @{$self->{'names_array'}};
$self->icons_table(\@{$self->{'links_array'}}, \@{$self->{'titles_array'}}, \@{$self->{'icons_array'}});

# Show start/stop/apply buttons
$self->{'conf'} = $self->get_config();
if ($self->find_value("FromInetd", $self->{'conf'}) ne "yes") {
	print "<hr>\n";
	print $self->ui_buttons_start();
	if ($self->is_frox_running()) {
		print $self->ui_buttons_row("apply.cgi", $self->{'text_hash'}->{'index_apply'},
				      $self->{'text_hash'}->{'index_applydesc'});
		print $self->ui_buttons_row("stop.cgi", $self->{'text_hash'}->{'index_stop'},
				      $self->{'text_hash'}->{'index_stopdesc'});
		}
	else {
		print $self->ui_buttons_row("start.cgi", $self->{'text_hash'}->{'index_start'},
				      $self->{'text_hash'}->{'index_startdesc'});
		}
	print $self->ui_buttons_end();
	}
else {
	print "<b>$self->{'text_hash'}->{'index_inetd'}</b><p>\n";
	}

$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});

1;
		
}


1;

