#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Save access control options

&ModuleLoader::preload_module('frox_class', "frox::FroxLib");
$self = new frox::FroxLib:: 'frox_class',%$self;

$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'acl_err'});
$self->{'conf'} = $self->get_config();

$self->save_opt_textbox($self->{'conf'}, "Timeout", \&check_timeout);
$self->save_opt_textbox($self->{'conf'}, "MaxForks", \&check_forks);
$self->save_opt_textbox($self->{'conf'}, "MaxForksPerHost", \&check_forks);
$self->save_opt_textbox($self->{'conf'}, "MaxTransferRate", \&check_rate);
$self->save_yesno($self->{'conf'}, "DoNTP");
$self->save_opt_textbox($self->{'conf'}, "NTPAddress", \&check_ntp);

for($i=0; defined($self->{'in_hash'}->{"action_$i"}); $i++) {
	next if (!$self->{'in_hash'}->{"action_$i"});
	local @val;
	push(@val, $self->{'in_hash'}->{"action_$i"});
	if ($self->{'in_hash'}->{"src_${i}_def"}) {
		push(@val, "*");
		}
	else {
		&valid_srcdest($self->{'in_hash'}->{"src_$i"}) ||
			$self->error($self->text('acl_esrc', $i+1));
		push(@val, $self->{'in_hash'}->{"src_$i"});
		}
	push(@val, "-");
	if ($self->{'in_hash'}->{"dest_${i}_def"}) {
		push(@val, "*");
		}
	else {
		&valid_srcdest($self->{'in_hash'}->{"dest_$i"}) ||
			$self->error($self->text('acl_edest', $i+1));
		push(@val, $self->{'in_hash'}->{"dest_$i"});
		}
	if (!$self->{'in_hash'}->{"ports_${i}_def"}) {
		foreach $p (split(/,/, $self->{'in_hash'}->{"ports_$i"})) {
			$p =~ /^\d+$/ || $p =~ /^\d+\-\d+$/ ||
				$self->error($self->text('acl_eports', $i+1));
			}
		push(@val, $self->{'in_hash'}->{"ports_$i"});
		}
	push(@{$self->{'acl_array'}}, join(" ", @val));
	}
@{$self->{'acl_array'}} || $self->error($self->{'text_hash'}->{'acl_enone'});
$self->save_directive($self->{'conf'}, "ACL", \@{$self->{'acl_array'}});

$self->lock_file($self->{'config_hash'}->{'frox_conf'});
$self->flush_file_lines();
$self->unlock_file($self->{'config_hash'}->{'frox_conf'});
$self->webmin_log("acl");
$self->redirect("");

1;
		
}

sub check_timeout
{
	shift if ($self == $_[0]);

return $_[0] =~ /^\d+$/ ? undef : $self->{'text_hash'}->{'acl_etimeout'};
}

sub check_forks
{
	shift if ($self == $_[0]);

return $_[0] =~ /^\d+$/ ? undef : $self->{'text_hash'}->{'acl_eforks'};
}

sub check_rate
{
	shift if ($self == $_[0]);

return $_[0] =~ /^\d+$/ ? undef : $self->{'text_hash'}->{'acl_erate'};
}

sub check_ntp
{
	shift if ($self == $_[0]);

return $_[0] =~ /^(\S+):(\d+)$/ && gethostbyname($1) ? undef
						     : $self->{'text_hash'}->{'acl_entp'};
}

sub valid_srcdest
{
	shift if ($self == $_[0]);

return gethostbyname($_[0]) ||
	   ($_[0] =~ /^([0-9\.]+)\/(\d+)$/ &&
	    $self->check_ipaddress($1) && $2 > 0 && $2 <= 32) ||
	   ($_[0] =~ /^([0-9\.]+)\/([0-9\.]+)$/ &&
	    $self->check_ipaddress($1) && $self->check_ipaddress($2));
}


1;

