#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Save caching options

&ModuleLoader::preload_module('frox_class', "frox::FroxLib");
$self = new frox::FroxLib:: 'frox_class',%$self;

$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'cache_err'});
$self->{'conf'} = $self->get_config();

if (!$self->{'in_hash'}->{'CacheModule'}) {
	$self->save_directive($self->{'conf'}, "CacheModule", [ ]);
	}
elsif ($self->{'in_hash'}->{'CacheModule'} eq 'local') {
	$self->save_directive($self->{'conf'}, "CacheModule", [ "local" ]);
	$self->save_textbox($self->{'conf'}, "CacheSize", \&check_size);
	}
else {
	$self->save_directive($self->{'conf'}, "CacheModule", [ "http" ]);
	$self->save_textbox($self->{'conf'}, "HTTPProxy", \&check_proxy);
	$self->save_textbox($self->{'conf'}, "MinCacheSize", \&check_size);
	}

$self->save_yesno($self->{'conf'}, "StrictCaching");
$self->save_yesno($self->{'conf'}, "CacheOnFQDN");
$self->save_yesno($self->{'conf'}, "CacheAll");

$self->save_opt_textbox($self->{'conf'}, "VirusScanner", \&check_scanner);
$self->save_opt_textbox($self->{'conf'}, "VSOK", \&check_int);
$self->save_opt_textbox($self->{'conf'}, "VSProgressMsgs", \&check_int);

$self->lock_file($self->{'config_hash'}->{'frox_conf'});
$self->flush_file_lines();
$self->unlock_file($self->{'config_hash'}->{'frox_conf'});
$self->webmin_log("cache");
$self->redirect("");

1;
		
}

sub check_size
{
	shift if ($self == $_[0]);

return $_[0] =~ /^\d+$/ ? undef : $self->{'text_hash'}->{'cache_esize'};
}

sub check_proxy
{
	shift if ($self == $_[0]);

return $_[0] =~ /^(\S+):(\d+)$/ && gethostbyname($1) ?
	undef : $self->{'text_hash'}->{'cache_eproxy'};
}

sub check_scanner
{
	shift if ($self == $_[0]);

return $_[0] =~ /^"([^"]+)"/ && -x $1 ? undef :
       $_[0] =~ /^(\S+)/ && -x $1 ? undef : $self->{'text_hash'}->{'cache_escanner'};
}

sub check_int
{
	shift if ($self == $_[0]);

return $_[0] =~ /^\d+$/ ? undef : $self->{'text_hash'}->{'cache_eint'};
}


1;

