#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Save general options

&ModuleLoader::preload_module('frox_class', "frox::FroxLib");
$self = new frox::FroxLib:: 'frox_class',%$self;

$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'general_err'});
$self->{'conf'} = $self->get_config();

$self->save_user($self->{'conf'}, "User");
$self->save_group($self->{'conf'}, "Group");
$self->save_textbox($self->{'conf'}, "WorkingDir", \&check_dir);
$self->save_yesno($self->{'conf'}, "DontChroot");
$self->save_opt_textbox($self->{'conf'}, "LogLevel", \&check_level);
$self->save_opt_textbox($self->{'conf'}, "PidFile", \&check_pidfile);

$self->lock_file($self->{'config_hash'}->{'frox_conf'});
$self->flush_file_lines();
$self->unlock_file($self->{'config_hash'}->{'frox_conf'});
$self->webmin_log("general");
$self->redirect("");

1;
		
}

sub check_dir
{
	shift if ($self == $_[0]);

return -d $_[0] ? undef : $self->{'text_hash'}->{'general_edir'};
}

sub check_level
{
	shift if ($self == $_[0]);

return $_[0] =~ /^\d+$/ ? undef : $self->{'text_hash'}->{'general_elevel'};
}

sub check_pidfile
{
	shift if ($self == $_[0]);

return $_[0] =~ /^\/\S+$/ ? undef : $self->{'text_hash'}->{'general_epidfile'};
}


1;

