#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Save networking-related options

&ModuleLoader::preload_module('frox_class', "frox::FroxLib");
$self = new frox::FroxLib:: 'frox_class',%$self;

$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'net_err'});
$self->{'conf'} = $self->get_config();

$self->save_opt_textbox($self->{'conf'}, "Listen", \&check_listen);
$self->save_textbox($self->{'conf'}, "Port", \&check_port);
$self->save_opt_textbox($self->{'conf'}, "BindToDevice", \&check_iface);
$self->save_yesno($self->{'conf'}, "FromInetd");
$self->save_exists($self->{'conf'}, "NoDetach");
$self->save_opt_textbox($self->{'conf'}, "FTPProxy", \&check_proxy);
$self->save_opt_textbox($self->{'conf'}, "TcpOutgoingAddr", \&check_ip);
$self->save_opt_textbox($self->{'conf'}, "PASVAddress", \&check_ip);
$self->save_opt_textbox($self->{'conf'}, "ResolvLoadHack", \&check_resolv);

$self->lock_file($self->{'config_hash'}->{'frox_conf'});
$self->flush_file_lines();
$self->unlock_file($self->{'config_hash'}->{'frox_conf'});
$self->webmin_log("net");
$self->redirect("");

1;
		
}

sub check_listen
{
	shift if ($self == $_[0]);

return gethostbyname($_[0]) ? undef : $self->{'text_hash'}->{'net_ehost'};
}

sub check_port
{
	shift if ($self == $_[0]);

return $_[0] =~ /^\d+$/ ? undef : $self->{'text_hash'}->{'net_eport'};
}

sub check_iface
{
	shift if ($self == $_[0]);

return $_[0] =~ /^[a-z]+(\d*)(:\d+)?$/ ? undef : $self->{'text_hash'}->{'net_eiface'};
}

sub check_proxy
{
	shift if ($self == $_[0]);

return $_[0] =~ /^(\S+):(\d+)$/ && gethostbyname($1) ? undef : $self->{'text_hash'}->{'net_eproxy'};
}

sub check_ip
{
	shift if ($self == $_[0]);

return $self->check_ipaddress($_[0]) ? undef : $self->{'text_hash'}->{'net_eip'};
}

sub check_resolv
{
	shift if ($self == $_[0]);

return $_[0] =~ /^[a-z0-9\.\-\_]+$/i ? undef : $self->{'text_hash'}->{'net_eresolv'};
}


1;

