#!/usr/bin/perl
package fsdump::FreebsdLib;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'fsdump::FreebsdLib');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# freebsd-lib.pl

$self->{'supports_tar'} = 1;
$self->{'tar_command'} = $self->has_command("gtar") || $self->has_command("tar");

1;

1;
		return $self;
}

# supported_filesystems()
# Returns a list of filesystem types on which dumping is supported
sub supported_filesystems
{
	my $self = shift;

local @rv;
push(@rv, "ufs") if ($self->has_command("dump"));
return @rv;
}

# multiple_directory_support(fs)
# Returns 1 if some filesystem dump supports multiple directories
sub multiple_directory_support
{
	my $self = shift;

return 0;
}

# dump_form(&dump)
sub dump_form
{
	my $self = shift;

# Display common options
print "<tr> <td valign=top><b>",$self->hlink($self->{'text_hash'}->{'dump_dest'}, "dest"),
      "</b></td> <td colspan=3>\n";
printf "<input type=radio name=mode value=0 %s> %s\n",
	$_[0]->{'host'} ? '' : 'checked', $self->{'text_hash'}->{'dump_file'};
printf "<input name=file size=50 value='%s'> %s<br>\n",
	$_[0]->{'host'} ? '' : $_[0]->{'file'},
	$self->file_chooser_button("file");
printf "<input type=radio name=mode value=1 %s>\n",
	$_[0]->{'host'} ? 'checked' : '';
print $self->text('dump_host',
	    "<input name=host size=15 value='$_[0]->{'host'}'>",
	    "<input name=huser size=8 value='$_[0]->{'huser'}'>",
	    "<input name=hfile size=20 value='$_[0]->{'hfile'}'>"),
      "</td> </tr>\n";

if ($_[0]->{'fs'} eq 'tar') {
	# Display gnutar options
	print "<tr> <td><b>",$self->hlink($self->{'text_hash'}->{'dump_rsh'},"rsh"),
	      "</b></td>\n";
	print "<td colspan=3>",
	      $self->rsh_command_input("rsh_def", "rsh", $_[0]->{'rsh'}),
	      "</td> </tr>\n";

	# Password option for SSH
	print "<tr> <td><b>",$self->hlink($self->{'text_hash'}->{'dump_pass'},"pass"),
	      "</b></td>\n";
	print "<td colspan=3>",$self->ui_password("pass", $_[0]->{'pass'}, 20),
	      "</td> </tr>\n";
	}
}

sub dump_options_form
{
	my $self = shift;

if ($_[0]->{'fs'} eq 'tar') {
	# Display gnutar options
	print "<tr> <td><b>",$self->hlink($self->{'text_hash'}->{'dump_label'},"label"),"</b></td>\n";
	printf "<td><input name=label size=15 value='%s'></td> </tr>\n",
		$_[0]->{'label'};

	print "<tr> <td><b>",$self->hlink($self->{'text_hash'}->{'dump_blocks'},"blocks"),
	      "</b></td> <td colspan=3>\n";
	printf "<input name=blocks_def type=radio value=1 %s> %s\n",
		$_[0]->{'blocks'} ? '' : 'checked', $self->{'text_hash'}->{'dump_auto'};
	printf "<input name=blocks_def type=radio value=0 %s>\n",
		$_[0]->{'blocks'} ? 'checked' : '';
	printf "<input name=blocks size=8 value='%s'> kB</td> </tr>\n",
		$_[0]->{'blocks'};

	print "<tr><td><b>",$self->hlink($self->{'text_hash'}->{'dump_gzip'},"gzip"),"</b></td>\n";
	printf "<td><input name=gzip type=radio value=1 %s> %s\n",
		$_[0]->{'gzip'} ? 'checked' : '', $self->{'text_hash'}->{'yes'};
	printf "<input name=gzip type=radio value=0 %s> %s</td>\n",
		$_[0]->{'gzip'} ? '' : 'checked', $self->{'text_hash'}->{'no'};

	print "<td><b>",$self->hlink($self->{'text_hash'}->{'dump_multi'},"multi"),"</b></td>\n";
	printf "<td><input name=multi type=radio value=1 %s> %s\n",
		$_[0]->{'multi'} ? 'checked' : '', $self->{'text_hash'}->{'yes'};
	printf "<input name=multi type=radio value=0 %s> %s</td> </tr>\n",
		$_[0]->{'multi'} ? '' : 'checked', $self->{'text_hash'}->{'no'};

	print "<tr><td><b>",$self->hlink($self->{'text_hash'}->{'dump_links'},"links"),"</b></td>\n";
	printf "<td><input name=links type=radio value=1 %s> %s\n",
		$_[0]->{'links'} ? 'checked' : '', $self->{'text_hash'}->{'yes'};
	printf "<input name=links type=radio value=0 %s> %s</td>\n",
		$_[0]->{'links'} ? '' : 'checked', $self->{'text_hash'}->{'no'};

	print "<td><b>",$self->hlink($self->{'text_hash'}->{'dump_xdev'},"xdev"),"</b></td>\n";
	printf "<td><input name=xdev type=radio value=1 %s> %s\n",
		$_[0]->{'xdev'} ? 'checked' : '', $self->{'text_hash'}->{'yes'};
	printf "<input name=xdev type=radio value=0 %s> %s</td> </tr>\n",
		$_[0]->{'xdev'} ? '' : 'checked', $self->{'text_hash'}->{'no'};
	}
else {
	# Display ufs backup options
	print "<tr> <td><b>",$self->hlink($self->{'text_hash'}->{'dump_update'},"update"),
	      "</b></td>\n";
	printf "<td><input name=update type=radio value=1 %s> %s\n",
		$_[0]->{'update'} ? 'checked' : '', $self->{'text_hash'}->{'yes'};
	printf "<input name=update type=radio value=0 %s> %s</td>\n",
		$_[0]->{'update'} ? '' : 'checked', $self->{'text_hash'}->{'no'};

	print "<td><b>",$self->hlink($self->{'text_hash'}->{'dump_level'},"level"),"</b></td>\n";
	print "<td><select name=level>\n";
	foreach $l (0 .. 9) {
		printf "<option value=%d %s>%d %s\n",
			$l, $_[0]->{'level'} == $l ? "selected" : "", $l,
			$self->{'text_hash'}->{'dump_level_'.$l};
		}
	print "</select></td> </tr>\n";

	print "<tr> <td><b>",$self->hlink($self->{'text_hash'}->{'dump_blocks'},"blocks"),
	      "</b></td> <td colspan=3>\n";
	printf "<input name=blocks_def type=radio value=1 %s> %s\n",
		$_[0]->{'blocks'} ? '' : 'checked', $self->{'text_hash'}->{'dump_auto'};
	printf "<input name=blocks_def type=radio value=0 %s>\n",
		$_[0]->{'blocks'} ? 'checked' : '';
	printf "<input name=blocks size=8 value='%s'> kB</td> </tr>\n",
		$_[0]->{'blocks'};

	print "<tr><td><b>",$self->hlink($self->{'text_hash'}->{'dump_honour'},"honour"),"</b></td>\n";
	printf "<td><input name=honour type=radio value=1 %s> %s\n",
		$_[0]->{'honour'} ? 'checked' : '', $self->{'text_hash'}->{'yes'};
	printf "<input name=honour type=radio value=0 %s> %s</td>\n",
		$_[0]->{'honour'} ? '' : 'checked', $self->{'text_hash'}->{'no'};
	}

print "</tr>\n";
}

# parse_dump(&dump)
sub parse_dump
{
	my $self = shift;

# Parse common options
if ($self->{'in_hash'}->{'mode'} == 0) {
	$self->{'in_hash'}->{'file'} =~ /\S/ || $self->error($self->{'text_hash'}->{'dump_efile'});
	$_[0]->{'file'} = $self->{'in_hash'}->{'file'};
	delete($_[0]->{'host'});
	delete($_[0]->{'huser'});
	delete($_[0]->{'hfile'});
	}
else {
	gethostbyname($self->{'in_hash'}->{'host'}) || $self->check_ipaddress($self->{'in_hash'}->{'host'}) ||
		$self->error($self->{'text_hash'}->{'dump_ehost'});
	$_[0]->{'host'} = $self->{'in_hash'}->{'host'};
	$self->{'in_hash'}->{'huser'} =~ /^\S+$/ || $self->error($self->{'text_hash'}->{'dump_ehuser'});
	$_[0]->{'huser'} = $self->{'in_hash'}->{'huser'};
	$self->{'in_hash'}->{'hfile'} || $self->error($self->{'text_hash'}->{'dump_ehfile'});
	$_[0]->{'hfile'} = $self->{'in_hash'}->{'hfile'};
	delete($_[0]->{'file'});
	}

if ($_[0]->{'fs'} eq 'tar') {
	# Parse tar options
	$_[0]->{'rsh'} = $self->rsh_command_parse("rsh_def", "rsh");
	$_[0]->{'pass'} = $self->{'in_hash'}->{'pass'};
	$self->{'in_hash'}->{'label'} =~ /^\S*$/ && length($self->{'in_hash'}->{'label'}) < 16 ||
		$self->error($self->{'text_hash'}->{'dump_elabel'});
	$_[0]->{'label'} = $self->{'in_hash'}->{'label'};
	if ($self->{'in_hash'}->{'blocks_def'}) {
		delete($_[0]->{'blocks'});
		}
	else {
		$self->{'in_hash'}->{'blocks'} =~ /^\d+$/ || $self->error($self->{'text_hash'}->{'dump_eblocks'});
		$_[0]->{'blocks'} = $self->{'in_hash'}->{'blocks'};
		$self->{'in_hash'}->{'gzip'} && $self->error($self->{'text_hash'}->{'dump_egzip'});
		}
	$_[0]->{'gzip'} = $self->{'in_hash'}->{'gzip'};
	$_[0]->{'multi'} = $self->{'in_hash'}->{'multi'};
	$_[0]->{'links'} = $self->{'in_hash'}->{'links'};
	$_[0]->{'xdev'} = $self->{'in_hash'}->{'xdev'};
	if ($self->{'in_hash'}->{'multi'}) {
		!-c $self->{'in_hash'}->{'file'} && !-b $self->{'in_hash'}->{'file'} ||
			$self->error($self->{'text_hash'}->{'dump_emulti'});
		$self->{'in_hash'}->{'gzip'} && $self->error($self->{'text_hash'}->{'dump_egzip2'});
		}
	}
else {
	# Parse ufs options
	local $mp;
	foreach $m ($self->foreign_call("mount", "list_mounted")) {
		$mp++ if ($m->[0] eq $self->{'in_hash'}->{'dir'});
		}
	$mp || $self->error($self->{'text_hash'}->{'dump_emp'});

	$_[0]->{'update'} = $self->{'in_hash'}->{'update'};
	$_[0]->{'level'} = $self->{'in_hash'}->{'level'};
	$_[0]->{'honour'} = $self->{'in_hash'}->{'honour'};
	if ($self->{'in_hash'}->{'blocks_def'}) {
		delete($_[0]->{'blocks'});
		}
	else {
		$self->{'in_hash'}->{'blocks'} =~ /^\d+$/ || $self->error($self->{'text_hash'}->{'dump_eblocks'});
		$_[0]->{'blocks'} = $self->{'in_hash'}->{'blocks'};
		}
	}
}

# execute_dump(&dump, filehandle, escape)
# Executes a dump and displays the output
sub execute_dump
{
	my $self = shift;

local $fh = $_[1];
local ($cmd, $flags);

if ($_[0]->{'huser'}) {
	$flags = "-f '$_[0]->{'huser'}\@$_[0]->{'host'}:".
		$self->date_subs($_[0]->{'hfile'})."'";
	}
elsif ($_[0]->{'host'}) {
	$flags = "-f '$_[0]->{'host'}:".$self->date_subs($_[0]->{'hfile'})."'";
	}
else {
	$flags = "-f '".$self->date_subs($_[0]->{'file'})."'";
	}
local $tapecmd = $_[0]->{'multi'} && $_[0]->{'fs'} eq 'tar' ? $self->{'multi_cmd'} :
		 $_[0]->{'multi'} ? undef :
		 $_[3] && !$self->{'config_hash'}->{'nonewtape'} ? $self->{'newtape_cmd'} : $self->{'notape_cmd'};
if ($_[0]->{'fs'} eq 'tar') {
	# Construct tar command
	$cmd = "$self->{'tar_command'} -c $flags";
	$cmd .= " -V '$_[0]->{'label'}'" if ($_[0]->{'label'});
	$cmd .= " -L $_[0]->{'blocks'}" if ($_[0]->{'blocks'});
	$cmd .= " -z" if ($_[0]->{'gzip'});
	$cmd .= " -M" if ($_[0]->{'multi'});
	$cmd .= " -h" if ($_[0]->{'links'});
	$cmd .= " -l" if ($_[0]->{'xdev'});
	$cmd .= " -F \"$tapecmd $_[0]->{'id'}\"" if (!$_[0]->{'gzip'});
	$cmd .= " --rsh-command=$_[0]->{'rsh'}" if ($_[0]->{'rsh'});
	$cmd .= " $_[0]->{'extra'}" if ($_[0]->{'extra'});
	$cmd .= " '$_[0]->{'dir'}'";
	}
else {
	# Construct ufs dump command
	$cmd = "dump -$_[0]->{'level'} $flags";
	$cmd .= " -u" if ($_[0]->{'update'});
	if ($_[0]->{'blocks'}) {
		$cmd .= " -B $_[0]->{'blocks'}";
		}
	else {
		$cmd .= " -a";
		}
	$cmd .= " -h 0" if ($_[0]->{'honour'});
	$cmd .= " $_[0]->{'extra'}" if ($_[0]->{'extra'});
	$cmd .= " '$_[0]->{'dir'}'";
	}

$self->system_logged("sync");
sleep(1);
local $got = $self->run_ssh_command($cmd, $fh, $_[2], $_[0]->{'pass'});
if ($_[0]->{'multi'} && $_[0]->{'fs'} eq 'tar') {
	# Run multi-file switch command one last time
	$self->execute_command("$self->{'multi_cmd'} $_[0]->{'id'} >/dev/null 2>&1");
	}
return $got ? 0 : 1;
}

# dump_dest(&dump)
sub dump_dest
{
	my $self = shift;

if ($_[0]->{'file'}) {
	return "<tt>".$self->html_escape($_[0]->{'file'})."</tt>";
	}
elsif ($_[0]->{'huser'}) {
	return "<tt>".$self->html_escape("$_[0]->{'huser'}\@$_[0]->{'host'}:$_[0]->{'hfile'}")."</tt>";
	}
else {
	return "<tt>".$self->html_escape("$_[0]->{'host'}:$_[0]->{'hfile'}")."</tt>";
	}
}

# missing_restore_command(filesystem)
sub missing_restore_command
{
	my $self = shift;

return $self->has_command("restore") ? undef : $self->{'cmd'};
}

# restore_form(filesystem, [&dump])
sub restore_form
{
	my $self = shift;

# common options
print "<tr> <td valign=top><b>",$self->hlink($self->{'text_hash'}->{'restore_src'}, "rsrc"),
      "</b></td>\n";
printf "<td colspan=3><input type=radio name=mode value=0 %s> %s\n",
	$_[1]->{'host'} ? "" : "checked", $self->{'text_hash'}->{'dump_file'};
printf "<input name=file size=50 value='%s'> %s<br>\n",
	$_[1]->{'host'} ? "" : $_[1]->{'file'}, $self->file_chooser_button("file");
printf "<input type=radio name=mode value=1 %s>\n",
	$_[1]->{'host'} ? "checked" : "";
print $self->text('dump_host',
	    "<input name=host size=15 value='$_[1]->{'host'}'>",
	    "<input name=huser size=8 value='$_[1]->{'huser'}'>",
	    "<input name=hfile size=20 value='$_[1]->{'hfile'}'>"),
      "</td> </tr>\n";

if ($_[0] eq 'tar') {
	# tar restore options
	print "<tr> <td><b>",$self->hlink($self->{'text_hash'}->{'restore_rsh'},"rrsh"),
	      "</b></td>\n";
	print "<td colspan=3>",
	      $self->rsh_command_input("rsh_def", "rsh", $_[1]->{'rsh'}),
	      "</td> </tr>\n";

	# Password option for SSH
	print "<tr> <td><b>",$self->hlink($self->{'text_hash'}->{'dump_pass'},"pass"),
	      "</b></td>\n";
	print "<td colspan=3>",$self->ui_password("pass", $_[0]->{'pass'}, 20),
	      "</td> </tr>\n";

	print "<tr> <td><b>",$self->hlink($self->{'text_hash'}->{'restore_files'},"rfiles"),
	      "</b></td>\n";
	print "<td colspan=3><input type=radio name=files_def value=1 checked> ",
	      "$self->{'text_hash'}->{'restore_all'}\n";
	print "<input type=radio name=files_def value=0> $self->{'text_hash'}->{'restore_sel'}\n";
	print "<input name=files size=40></td> </tr>\n";

	print "<tr> <td><b>",$self->hlink($self->{'text_hash'}->{'restore_dir'},"rdir"),
	      "</b></td> <td colspan=3>\n";
	print "<input name=dir size=50> ",$self->file_chooser_button("dir", 1),
	      "</td> </tr>\n";

	print "<tr> <td><b>",$self->hlink($self->{'text_hash'}->{'restore_perms'},"perms"),"</td>\n";
	print "<td><input type=radio name=perms value=1> $self->{'text_hash'}->{'yes'}\n";
	print "<input type=radio name=perms value=0 checked> $self->{'text_hash'}->{'no'}</td>\n";

	print "<td><b>",$self->hlink($self->{'text_hash'}->{'restore_gzip'},"rgzip"),"</td>\n";
	print "<td><input type=radio name=gzip value=1> $self->{'text_hash'}->{'yes'}\n";
	print "<input type=radio name=gzip value=0 checked> $self->{'text_hash'}->{'no'}</td> </tr>\n";

	print "<tr> <td><b>",$self->hlink($self->{'text_hash'}->{'restore_keep'},"keep"),"</td>\n";
	print "<td><input type=radio name=keep value=1> $self->{'text_hash'}->{'yes'}\n";
	print "<input type=radio name=keep value=0 checked> $self->{'text_hash'}->{'no'}</td>\n";

	print "<td><b>",$self->hlink($self->{'text_hash'}->{'restore_multi'},"rmulti"),
	      "</b></td>\n";
	print "<td><input type=radio name=multi value=1> $self->{'text_hash'}->{'yes'}\n";
	print "<input type=radio name=multi value=0 checked> $self->{'text_hash'}->{'no'}</td> </tr>\n";

	print "<tr> <td><b>",$self->hlink($self->{'text_hash'}->{'restore_test'},"rtest"),"</td>\n";
	print "<td><input type=radio name=test value=1> $self->{'text_hash'}->{'yes'}\n";
	print "<input type=radio name=test value=0 checked> $self->{'text_hash'}->{'no'}</td> </tr>\n";

	}
else {
	# ufs restore options
	print "<tr> <td><b>",$self->hlink($self->{'text_hash'}->{'restore_files'},"rfiles"),
	      "</b></td>\n";
	print "<td colspan=3><input type=radio name=files_def value=1 checked> ",
	      "$self->{'text_hash'}->{'restore_all'}\n";
	print "<input type=radio name=files_def value=0> $self->{'text_hash'}->{'restore_sel'}\n";
	print "<input name=files size=40></td> </tr>\n";

	print "<tr> <td><b>",$self->hlink($self->{'text_hash'}->{'restore_dir'},"rdir"),"</td>\n";
	print "<td colspan=3><input name=dir size=40> ",
		$self->file_chooser_button("dir", 1),"</td> </tr>\n";

	print "<tr> <td><b>",$self->hlink($self->{'text_hash'}->{'restore_nothing'},"rnothing"),
	      "</b></td>\n";
	print "<td><input type=radio name=nothing value=1> $self->{'text_hash'}->{'yes'}\n";
	print "<input type=radio name=nothing value=0 checked> $self->{'text_hash'}->{'no'}</td>\n";

	print "<td><b>",$self->hlink($self->{'text_hash'}->{'restore_test'},"rtest"),"</td>\n";
	print "<td><input type=radio name=test value=1> $self->{'text_hash'}->{'yes'}\n";
	print "<input type=radio name=test value=0 checked> $self->{'text_hash'}->{'no'}</td> </tr>\n";
	}
}

# parse_restore(filesystem)
# Parses inputs from restore_form() and returns a command to be passed to
# restore_backup()
sub parse_restore
{
	my $self = shift;

local $cmd;
if ($_[0] eq "tar") {
	$cmd = $self->{'tar_command'};
	if ($self->{'in_hash'}->{'test'}) {
		$cmd .= " -t -v";
		}
	else {
		$cmd .= " -x";
		}
	}
else {
	$cmd .= "restore".($self->{'in_hash'}->{'test'} ? " -t" : " -x");
	}
if ($self->{'in_hash'}->{'mode'} == 0) {
	$self->{'in_hash'}->{'file'} || $self->error($self->{'text_hash'}->{'restore_efile'});
	$cmd .= " -f '$self->{'in_hash'}->{'file'}'";
	}
else {
	gethostbyname($self->{'in_hash'}->{'host'}) || $self->check_ipaddress($self->{'in_hash'}->{'host'}) ||
		$self->error($self->{'text_hash'}->{'restore_ehost'});
	$self->{'in_hash'}->{'huser'} =~ /^\S*$/ || $self->error($self->{'text_hash'}->{'restore_ehuser'});
	$self->{'in_hash'}->{'hfile'} || $self->error($self->{'text_hash'}->{'restore_ehfile'});
	if ($self->{'in_hash'}->{'huser'}) {
		$cmd .= " -f '$self->{'in_hash'}->{'huser'}\@$self->{'in_hash'}->{'host'}:$self->{'in_hash'}->{'hfile'}'";
		}
	else {
		$cmd .= " -f '$self->{'in_hash'}->{'host'}:$self->{'in_hash'}->{'hfile'}'";
		}
	}

if ($_[0] eq 'tar') {
	# parse tar options
	$cmd .= " -p" if ($self->{'in_hash'}->{'perms'});
	$cmd .= " -z" if ($self->{'in_hash'}->{'gzip'});
	$cmd .= " -k" if ($self->{'in_hash'}->{'keep'});
	if ($self->{'in_hash'}->{'multi'}) {
		!-c $self->{'in_hash'}->{'file'} && !-b $self->{'in_hash'}->{'file'} ||
			$self->error($self->{'text_hash'}->{'restore_emulti'});
		$self->{'in_hash'}->{'mode'} == 0 || $self->error($self->{'text_hash'}->{'restore_emulti2'});
		$cmd .= " -M -F \"$self->{'rmulti_cmd'} $self->{'in_hash'}->{'file'}\"";
		}
	local $rsh = $self->rsh_command_parse("rsh_def", "rsh");
	if ($rsh) {
		$cmd .= " --rsh-command=".quotemeta($rsh);
		}
	$cmd .= " $self->{'in_hash'}->{'extra'}" if ($self->{'in_hash'}->{'extra'});
	if (!$self->{'in_hash'}->{'files_def'}) {
		$self->{'in_hash'}->{'files'} || $self->error($self->{'text_hash'}->{'restore_efiles'});
		$cmd .= " $self->{'in_hash'}->{'files'}";
		}
	-d $self->{'in_hash'}->{'dir'} || $self->error($self->{'text_hash'}->{'restore_edir'});
	$cmd = "cd '$self->{'in_hash'}->{'dir'}' && $cmd";
	if ($self->{'in_hash'}->{'multi'}) {
		$cmd = "$self->{'rmulti_cmd'} $self->{'in_hash'}->{'file'} 1 && $cmd";
		}
	}
else {
	# parse ufs options
	$cmd .= " -N" if ($self->{'in_hash'}->{'nothing'});
	$cmd .= " $self->{'in_hash'}->{'extra'}" if ($self->{'in_hash'}->{'extra'});
	if (!$self->{'in_hash'}->{'files_def'}) {
		$self->{'in_hash'}->{'files'} || $self->error($self->{'text_hash'}->{'restore_efiles'});
		$cmd .= " $self->{'in_hash'}->{'files'}";
		}
	-d $self->{'in_hash'}->{'dir'} || $self->error($self->{'text_hash'}->{'restore_edir'});
	}

return $cmd;
}

# restore_backup(filesystem, command)
# Restores a backup based on inputs from restore_form(), and displays the results
sub restore_backup
{
	my $self = shift;

$self->additional_log('exec', undef, $_[1]);

# Need to supply prompts
$self->foreign_require("proc", "proc-lib.pl");
local ($fh, $fpid) = $self->foreign_call("proc", "pty_process_exec", "cd '$self->{'in_hash'}->{'dir'}' ; $_[1]");
local $donevolume;
while(1) {
	local $rv = $self->wait_for($fh, "(next volume #)", "(set owner.mode for.*\\[yn\\])", "((.*)\\[yn\\])", "password:", "yes\\/no", "(.*\\n)");
	last if ($rv < 0);
	print $self->html_escape($self->{'matches_array'}->[1]);
	if ($rv == 0) {
		if ($donevolume++) {
			return $self->{'text_hash'}->{'restore_evolume'};
			}
		else {
			syswrite($fh, "1\n", 2);
			}
		}
	elsif ($rv == 1) {
		syswrite($fh, "n\n", 2);
		}
	elsif ($rv == 2) {
		return $self->text('restore_equestion',
			     "<tt>$self->{'matches_array'}->[2]</tt>");
		}
	elsif ($rv == 3) {
		syswrite($fh, "$self->{'in_hash'}->{'pass'}\n");
		}
	elsif ($rv == 4) {
		syswrite($fh, "yes\n");
		}
	}
close($fh);
waitpid($fpid, 0);
return $? || undef;
}


1;

