#!/usr/bin/perl
package fsdump::IrixLib;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'fsdump::IrixLib');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# irix-lib.pl

1;

1;
		return $self;
}

# supported_filesystems()
# Returns a list of filesystem types on which dumping is supported
sub supported_filesystems
{
	my $self = shift;

local @rv;
push(@rv, "xfs") if ($self->has_command("xfsdump"));
return @rv;
}

# multiple_directory_support(fs)
# Returns 1 if some filesystem dump supports multiple directories
sub multiple_directory_support
{
	my $self = shift;

return 0;
}

# dump_form(&dump)
sub dump_form
{
	my $self = shift;

# Display common options
print "<tr> <td valign=top><b>",$self->hlink($self->{'text_hash'}->{'dump_dest'}, "dest"),
      "</b></td> <td colspan=3>\n";
printf "<input type=radio name=mode value=0 %s> %s\n",
	$_[0]->{'host'} ? '' : 'checked', $self->{'text_hash'}->{'dump_file'};
printf "<input name=file size=50 value='%s'> %s<br>\n",
	$_[0]->{'host'} ? '' : $_[0]->{'file'},
	$self->file_chooser_button("file");
printf "<input type=radio name=mode value=1 %s>\n",
	$_[0]->{'host'} ? 'checked' : '';
print $self->text('dump_host',
	    "<input name=host size=15 value='$_[0]->{'host'}'>",
	    "<input name=huser size=8 value='$_[0]->{'huser'}'>",
	    "<input name=hfile size=20 value='$_[0]->{'hfile'}'>"),
      "</td> </tr>\n";
}

sub dump_options_form
{
	my $self = shift;

if ($_[0]->{'fs'} eq 'xfs') {
	# Display xfs dump options
	print "<tr> <td><b>",$self->hlink($self->{'text_hash'}->{'dump_level'},"level"),"</b></td>\n";
	print "<td><select name=level>\n";
	foreach $l (0 .. 9) {
		printf "<option value=%d %s>%d %s\n",
			$l, $_[0]->{'level'} == $l ? "selected" : "", $l,
			$self->{'text_hash'}->{'dump_level_'.$l};
		}
	print "</select></td>\n";

	print "<td><b>",$self->hlink($self->{'text_hash'}->{'dump_label'},"label"),"</b></td>\n";
	printf "<td><input name=label size=15 value='%s'></td> </tr>\n",
		$_[0]->{'label'};

	print "<tr> <td><b>",$self->hlink($self->{'text_hash'}->{'dump_max'},"max"),"</b></td>\n";
	printf "<td><input type=radio name=max_def value=1 %s> %s\n",
		$_[0]->{'max'} ? '' : 'checked', $self->{'text_hash'}->{'dump_unlimited'};
	printf "<input type=radio name=max_def value=0 %s>\n",
		$_[0]->{'max'} ? 'checked' : '';
	printf "<input name=max size=8 value='%s'> kB</td>\n", $_[0]->{'max'};

	print "<td><b>",$self->hlink($self->{'text_hash'}->{'dump_attribs'},"attribs"),"</b></td>\n";
	printf "<td><input type=radio name=noattribs value=0 %s> %s\n",
		$_[0]->{'noattribs'} ? '' : 'checked', $self->{'text_hash'}->{'yes'};
	printf "<input type=radio name=noattribs value=1 %s> %s</td> </tr>\n",
		$_[0]->{'noattribs'} ? 'checked' : '', $self->{'text_hash'}->{'no'};

	print "<tr> <td><b>",$self->hlink($self->{'text_hash'}->{'dump_over'},"over"),"</b></td>\n";
	printf "<td><input type=radio name=over value=0 %s> %s\n",
		$_[0]->{'over'} ? '' : 'checked', $self->{'text_hash'}->{'yes'};
	printf "<input type=radio name=over value=1 %s> %s</td>\n",
		$_[0]->{'over'} ? 'checked' : '', $self->{'text_hash'}->{'no'};

	print "<td><b>",$self->hlink($self->{'text_hash'}->{'dump_invent'},"invent"),"</b></td>\n";
	printf "<td><input type=radio name=noinvent value=0 %s> %s\n",
		$_[0]->{'noinvent'} ? '' : 'checked', $self->{'text_hash'}->{'yes'};
	printf "<input type=radio name=noinvent value=1 %s> %s</td> </tr>\n",
		$_[0]->{'noinvent'} ? 'checked' : '', $self->{'text_hash'}->{'no'};

	print "<tr> <td><b>",$self->hlink($self->{'text_hash'}->{'dump_overwrite'},"overwrite"),
	      "</b></td>\n";
	printf "<td><input type=radio name=overwrite value=1 %s> %s\n",
		$_[0]->{'overwrite'} ? 'checked' : '', $self->{'text_hash'}->{'yes'};
	printf "<input type=radio name=overwrite value=0 %s> %s</td>\n",
		$_[0]->{'overwrite'} ? '' : 'checked', $self->{'text_hash'}->{'no'};

	print "<td><b>",$self->hlink($self->{'text_hash'}->{'dump_erase'},"erase"),"</b></td>\n";
	printf "<td><input type=radio name=erase value=1 %s> %s\n",
		$_[0]->{'erase'} ? 'checked' : '', $self->{'text_hash'}->{'yes'};
	printf "<input type=radio name=erase value=0 %s> %s</td> </tr>\n",
		$_[0]->{'erase'} ? '' : 'checked', $self->{'text_hash'}->{'no'};
	}
else {
	# Display efs filesystem dump options
	# XXX not done!
	print "<tr> <td><b>",$self->hlink($self->{'text_hash'}->{'dump_update'},"update"),
	      "</b></td>\n";
	printf "<td><input name=update type=radio value=1 %s> %s\n",
		$_[0]->{'update'} ? 'checked' : '', $self->{'text_hash'}->{'yes'};
	printf "<input name=update type=radio value=0 %s> %s</td>\n",
		$_[0]->{'update'} ? '' : 'checked', $self->{'text_hash'}->{'no'};

	print "<td><b>",$self->hlink($self->{'text_hash'}->{'dump_multi'},"multi"),"</b></td>\n";
	printf "<td><input name=multi type=radio value=1 %s> %s\n",
		$_[0]->{'multi'} ? 'checked' : '', $self->{'text_hash'}->{'yes'};
	printf "<input name=multi type=radio value=0 %s> %s</td> </tr>\n",
		$_[0]->{'multi'} ? '' : 'checked', $self->{'text_hash'}->{'no'};

	print "<tr> <td><b>",$self->hlink($self->{'text_hash'}->{'dump_level'},"level"),"</b></td>\n";
	print "<td><select name=level>\n";
	foreach $l (0 .. 9) {
		printf "<option value=%d %s>%d %s\n",
			$l, $_[0]->{'level'} == $l ? "selected" : "", $l,
			$self->{'text_hash'}->{'dump_level_'.$l};
		}
	print "</select></td>\n";

	print "<td><b>",$self->hlink($self->{'text_hash'}->{'dump_label'},"label"),"</b></td>\n";
	printf "<td><input name=label size=15 value='%s'></td> </tr>\n",
		$_[0]->{'label'};

	print "<tr> <td><b>",$self->hlink($self->{'text_hash'}->{'dump_blocks'},"blocks"),
	      "</b></td> <td colspan=3>\n";
	printf "<input name=blocks_def type=radio value=1 %s> %s\n",
		$_[0]->{'blocks'} ? '' : 'checked', $self->{'text_hash'}->{'dump_auto'};
	printf "<input name=blocks_def type=radio value=0 %s>\n",
		$_[0]->{'blocks'} ? 'checked' : '';
	printf "<input name=blocks size=8 value='%s'> kB</td>\n",
		$_[0]->{'blocks'};

	if ($self->{'dump_version'} >= 0.424) {
		print "<tr> <td><b>",$self->hlink($self->{'text_hash'}->{'dump_comp'},"comp"),
		      "</b></td> <td colspan=3>\n";
		printf "<input name=comp_def type=radio value=1 %s> %s\n",
			$_[0]->{'comp'} ? '' : 'checked', $self->{'text_hash'}->{'no'};
		printf "<input name=comp_def type=radio value=0 %s> %s\n",
			$_[0]->{'comp'} ? 'checked' : '',$self->{'text_hash'}->{'dump_complvl'};
		printf "<input name=comp size=4 value='%s'></td>\n",
			$_[0]->{'comp'} || 2;
		}
	}
}

# parse_dump(&dump)
sub parse_dump
{
	my $self = shift;

# Parse common options
if ($self->{'in_hash'}->{'mode'} == 0) {
	$self->{'in_hash'}->{'file'} =~ /\S/ || $self->error($self->{'text_hash'}->{'dump_efile'});
	$_[0]->{'file'} = $self->{'in_hash'}->{'file'};
	delete($_[0]->{'host'});
	delete($_[0]->{'huser'});
	delete($_[0]->{'hfile'});
	}
else {
	gethostbyname($self->{'in_hash'}->{'host'}) || $self->check_ipaddress($self->{'in_hash'}->{'host'}) ||
		$self->error($self->{'text_hash'}->{'dump_ehost'});
	$_[0]->{'host'} = $self->{'in_hash'}->{'host'};
	$self->{'in_hash'}->{'huser'} =~ /^\S+$/ || $self->error($self->{'text_hash'}->{'dump_ehuser'});
	$_[0]->{'huser'} = $self->{'in_hash'}->{'huser'};
	$self->{'in_hash'}->{'hfile'} || $self->error($self->{'text_hash'}->{'dump_ehfile'});
	$_[0]->{'hfile'} = $self->{'in_hash'}->{'hfile'};
	delete($_[0]->{'file'});
	}

if ($_[0]->{'fs'} eq 'xfs') {
	# Parse xfs options
	local $mp;
	foreach $m ($self->foreign_call("mount", "list_mounted")) {
		$mp++ if ($m->[0] eq $self->{'in_hash'}->{'dir'});
		}
	$mp || $self->error($self->{'text_hash'}->{'dump_emp'});
	$self->{'in_hash'}->{'label'} =~ /^\S*$/ && length($self->{'in_hash'}->{'label'}) < 256 ||
		$self->error($self->{'text_hash'}->{'dump_elabel2'});
	$_[0]->{'label'} = $self->{'in_hash'}->{'label'};
	$_[0]->{'level'} = $self->{'in_hash'}->{'level'};
	if ($self->{'in_hash'}->{'max_def'}) {
		delete($_[0]->{'max'});
		}
	else {
		$self->{'in_hash'}->{'max'} =~ /^\d+$/ || $self->error($self->{'text_hash'}->{'dump_emax'});
		$_[0]->{'max'} = $self->{'in_hash'}->{'max'};
		}
	$_[0]->{'noattribs'} = $self->{'in_hash'}->{'noattribs'};
	$_[0]->{'over'} = $self->{'in_hash'}->{'over'};
	$_[0]->{'noinvent'} = $self->{'in_hash'}->{'noinvent'};
	$_[0]->{'overwrite'} = $self->{'in_hash'}->{'overwrite'};
	$_[0]->{'erase'} = $self->{'in_hash'}->{'erase'};
	}
else {
	# Parse efs options
	# XXX not done!
	$_[0]->{'update'} = $self->{'in_hash'}->{'update'};
	$_[0]->{'multi'} = $self->{'in_hash'}->{'multi'};
	$_[0]->{'level'} = $self->{'in_hash'}->{'level'};
	$self->{'in_hash'}->{'label'} =~ /^\S*$/ && length($self->{'in_hash'}->{'label'}) < 16 ||
		$self->error($self->{'text_hash'}->{'dump_elabel'});
	$_[0]->{'label'} = $self->{'in_hash'}->{'label'};
	if ($self->{'in_hash'}->{'blocks_def'}) {
		delete($_[0]->{'blocks'});
		}
	else {
		$self->{'in_hash'}->{'blocks'} =~ /^\d+$/ || $self->error($self->{'text_hash'}->{'dump_eblocks'});
		$_[0]->{'blocks'} = $self->{'in_hash'}->{'blocks'};
		}
	if ($self->{'in_hash'}->{'comp_def'} || !defined($self->{'in_hash'}->{'comp'})) {
		delete($_[0]->{'comp'});
		}
	else {
		$self->{'in_hash'}->{'comp'} =~ /^[1-9]\d*$/ || $self->error($self->{'text_hash'}->{'dump_ecomp'});
		$_[0]->{'comp'} = $self->{'in_hash'}->{'comp'};
		}
	}

}

# execute_dump(&dump, filehandle, escape)
# Executes a dump and displays the output
sub execute_dump
{
	my $self = shift;

local $fh = $_[1];
local ($cmd, $flag);
if ($_[0]->{'huser'}) {
	$flag = " -f '$_[0]->{'huser'}\@$_[0]->{'host'}:".
		$self->date_subs($_[0]->{'hfile'})."'";
	}
elsif ($_[0]->{'host'}) {
	$flag = " -f '$_[0]->{'host'}:".$self->date_subs($_[0]->{'hfile'})."'";
	}
else {
	$flag = " -f '".$self->date_subs($_[0]->{'file'})."'";
	}
if ($_[0]->{'fs'} eq 'xfs') {
	# xfs backup
	$cmd = "xfsdump -l $_[0]->{'level'}";
	$cmd .= $flag;
	$cmd .= " -L '$_[0]->{'label'}'" if ($_[0]->{'label'});
	$cmd .= " -M '$_[0]->{'label'}'" if ($_[0]->{'label'});
	$cmd .= " -z '$_[0]->{'max'}'" if ($_[0]->{'max'});
	$cmd .= " -A" if ($_[0]->{'noattribs'});
	$cmd .= " -F" if ($_[0]->{'over'});
	$cmd .= " -J" if ($_[0]->{'noinvent'});
	$cmd .= " -o" if ($_[0]->{'overwrite'});
	$cmd .= " -c \"$_[3] $_[0]->{'id'}\"" if ($_[3]);
	$cmd .= " -E -F" if ($_[0]->{'erase'});
	$cmd .= " $_[0]->{'extra'}" if ($_[0]->{'extra'});
	$cmd .= " '$_[0]->{'dir'}'";
	}
else {
	# efs backup
	# XXX not done!
	$cmd = "dump -$_[0]->{'level'}";
	$cmd .= $flag;
	$cmd .= " -u" if ($_[0]->{'update'});
	$cmd .= " -M" if ($_[0]->{'multi'});
	$cmd .= " -L '$_[0]->{'label'}'" if ($_[0]->{'label'});
	$cmd .= " -B $_[0]->{'blocks'}" if ($_[0]->{'blocks'});
	$cmd .= " -j$_[0]->{'comp'}" if ($_[0]->{'comp'});
	$cmd .= " $_[0]->{'extra'}" if ($_[0]->{'extra'});
	$cmd .= " '$_[0]->{'dir'}'";
	}

$self->system_logged("sync");
sleep(1);
$self->additional_log('exec', undef, $cmd);
$self->open_execute_command(*CMD, "$cmd 2>&1 </dev/null", 1);
while(<CMD>) {
	if ($_[2]) {
		print $fh $self->html_escape($_);
		}
	else {
		print $fh $_;
		}
	}
close(CMD);
return $? ? 0 : 1;
}

# dump_dest(&dump)
sub dump_dest
{
	my $self = shift;

if ($_[0]->{'file'}) {
	return "<tt>".$self->html_escape($_[0]->{'file'})."</tt>";
	}
elsif ($_[0]->{'huser'}) {
	return "<tt>".$self->html_escape("$_[0]->{'huser'}\@$_[0]->{'host'}:$_[0]->{'hfile'}")."</tt>";
	}
else {
	return "<tt>".$self->html_escape("$_[0]->{'host'}:$_[0]->{'hfile'}")."</tt>";
	}
}

# missing_restore_command(filesystem)
sub missing_restore_command
{
	my $self = shift;

local $cmd = $_[0] eq 'xfs' ? 'xfsrestore' : 'restore';
return $self->has_command($cmd) ? undef : $cmd;
}

# restore_form(filesystem)
sub restore_form
{
	my $self = shift;

# common options
print "<tr> <td valign=top><b>",$self->hlink($self->{'text_hash'}->{'restore_src'}, "rsrc"),
      "</b></td>\n";
printf "<td colspan=3><input type=radio name=mode value=0 %s> %s\n",
        $_[1]->{'host'} ? "" : "checked", $self->{'text_hash'}->{'dump_file'};
printf "<input name=file size=50 value='%s'> %s<br>\n",
        $_[1]->{'host'} ? "" : $_[0]->{'file'}, $self->file_chooser_button("file");
printf "<input type=radio name=mode value=1 %s>\n",
        $_[1]->{'host'} ? "checked" : "";
print $self->text('dump_host',
            "<input name=host size=15 value='$_[1]->{'host'}'>",
            "<input name=huser size=8 value='$_[1]->{'huser'}'>",
            "<input name=hfile size=20 value='$_[1]->{'hfile'}'>"),
      "</td> </tr>\n";

if ($_[0] eq 'xfs') {
	# xfs restore options
	print "<tr> <td><b>",$self->hlink($self->{'text_hash'}->{'restore_dir'},"rdir"),
	      "</b></td> <td colspan=3>\n";
	print "<input name=dir size=50> ",$self->file_chooser_button("dir", 1),
	      "</td> </tr>\n";

	print "<tr> <td><b>",$self->hlink($self->{'text_hash'}->{'restore_over'},"rover"),
	      "</b></td>\n";
	print "<td colspan=3><input type=radio name=over value=0 checked> ",
	      "$self->{'text_hash'}->{'restore_over0'}\n";
	print "<input type=radio name=over value=1> $self->{'text_hash'}->{'restore_over1'}\n";
	print "<input type=radio name=over value=2> ",
	      "$self->{'text_hash'}->{'restore_over2'}</td> </tr>\n";

	print "<tr> <td><b>",$self->hlink($self->{'text_hash'}->{'restore_noattribs'},"rnoattribs"),
	      "</b></td> <td>\n";
	print "<input type=radio name=noattribs value=0 checked> $self->{'text_hash'}->{'yes'}\n";
	print "<input type=radio name=noattribs value=1> $self->{'text_hash'}->{'no'}</td>\n";

	print "<td><b>",$self->hlink($self->{'text_hash'}->{'restore_label'},"rlabel"),"</b></td>\n";
	print "<td><input name=label size=20></td> </tr>\n";

	print "<tr> <td><b>",$self->hlink($self->{'text_hash'}->{'restore_test'},"rtest"),"</td>\n";
	print "<td><input type=radio name=test value=1> $self->{'text_hash'}->{'yes'}\n";
	print "<input type=radio name=test value=0 checked> $self->{'text_hash'}->{'no'}</td> </tr>\n";
	}
else {
	# efs restore options
	# XXX not done!
	print "<tr> <td><b>",$self->hlink($self->{'text_hash'}->{'restore_files'},"rfiles"),
	      "</b></td>\n";
	print "<td colspan=3><input type=radio name=files_def value=1 checked> ",
	      "$self->{'text_hash'}->{'restore_all'}\n";
	print "<input type=radio name=files_def value=0> $self->{'text_hash'}->{'restore_sel'}\n";
	print "<input name=files size=40></td> </tr>\n";

	print "<tr> <td><b>",$self->hlink($self->{'text_hash'}->{'restore_dir'},"rdir"),"</td>\n";
	print "<td colspan=3><input name=dir size=40> ",
		$self->file_chooser_button("dir", 1),"</td> </tr>\n";

	print "<tr> <td><b>",$self->hlink($self->{'text_hash'}->{'restore_multi'},"rmulti"),
	      "</b></td>\n";
	print "<td><input type=radio name=multi value=1> $self->{'text_hash'}->{'yes'}\n";
	print "<input type=radio name=multi value=0 checked> $self->{'text_hash'}->{'no'}</td>\n";

	print "<td><b>",$self->hlink($self->{'text_hash'}->{'restore_test'},"rtest"),"</td>\n";
	print "<td><input type=radio name=test value=1> $self->{'text_hash'}->{'yes'}\n";
	print "<input type=radio name=test value=0 checked> $self->{'text_hash'}->{'no'}</td> </tr>\n";
	}
}

# parse_restore(filesystem)
# Parses inputs from restore_form() and returns a command to be passed to
# restore_backup()
sub parse_restore
{
	my $self = shift;

local $cmd;
if ($_[0] eq 'xfs') {
	$cmd = "xfsrestore";
	$cmd .= " -t" if ($self->{'in_hash'}->{'test'});
	}
else {
	$cmd = "restore";
	$cmd .= ($self->{'in_hash'}->{'test'} ? " -t" : " -x");
	}
if ($self->{'in_hash'}->{'mode'} == 0) {
	$self->{'in_hash'}->{'file'} || $self->error($self->{'text_hash'}->{'restore_efile'});
	$cmd .= " -f '$self->{'in_hash'}->{'file'}'";
	}
else {
	gethostbyname($self->{'in_hash'}->{'host'}) || $self->check_ipaddress($self->{'in_hash'}->{'host'}) ||
		$self->error($self->{'text_hash'}->{'restore_ehost'});
	$self->{'in_hash'}->{'huser'} =~ /^\S*$/ || $self->error($self->{'text_hash'}->{'restore_ehuser'});
	$self->{'in_hash'}->{'hfile'} || $self->error($self->{'text_hash'}->{'restore_ehfile'});
	if ($self->{'in_hash'}->{'huser'}) {
		$cmd .= " -f '$self->{'in_hash'}->{'huser'}\@$self->{'in_hash'}->{'host'}:$self->{'in_hash'}->{'hfile'}'";
		}
	else {
		$cmd .= " -f '$self->{'in_hash'}->{'host'}:$self->{'in_hash'}->{'hfile'}'";
		}
	}
if ($_[0] eq 'xfs') {
	# parse xfs options
	$cmd .= " -E" if ($self->{'in_hash'}->{'over'} == 1);
	$cmd .= " -e" if ($self->{'in_hash'}->{'over'} == 2);
	$cmd .= " -A" if ($self->{'in_hash'}->{'noattribs'});
	$cmd .= " -L '$self->{'in_hash'}->{'label'}'" if ($self->{'in_hash'}->{'label'});
	$cmd .= " -F";
	$cmd .= " $self->{'in_hash'}->{'extra'}" if ($self->{'in_hash'}->{'extra'});
	if (!$self->{'in_hash'}->{'test'}) {
		-d $self->{'in_hash'}->{'dir'} || $self->error($self->{'text_hash'}->{'restore_edir'});
		$cmd .= " '$self->{'in_hash'}->{'dir'}'";
		}
	}
else {
	# parse efs options
	# XXX not done!
	$cmd .= " -M" if ($self->{'in_hash'}->{'multi'});
	$cmd .= " $self->{'in_hash'}->{'extra'}" if ($self->{'in_hash'}->{'extra'});
	if (!$self->{'in_hash'}->{'files_def'}) {
		$self->{'in_hash'}->{'files'} || $self->error($self->{'text_hash'}->{'restore_efiles'});
		$cmd .= " $self->{'in_hash'}->{'files'}";
		}
	-d $self->{'in_hash'}->{'dir'} || $self->error($self->{'text_hash'}->{'restore_edir'});
	}
return $cmd;
}

# restore_backup(filesystem, command)
# Restores a backup based on inputs from restore_form(), and displays the results
sub restore_backup
{
	my $self = shift;

$self->additional_log('exec', undef, $_[1]);
if ($_[0] eq 'xfs') {
	# Just run the backup command
	$self->open_execute_command(*CMD, "$_[1] 2>&1 </dev/null", 1);
	while(<CMD>) {
		print $self->html_escape($_);
		}
	close(CMD);
	return $? || undef;
	}
else {
	# Need to supply prompts
	$self->foreign_require("proc", "proc-lib.pl");
	local ($fh, $fpid) = $self->foreign_call("proc", "pty_process_exec", "cd '$self->{'in_hash'}->{'dir'}' ; $_[1]");
	local $donevolume;
	while(1) {
		local $rv = $self->wait_for($fh, "(next volume #)", "(set owner.mode for.*\\[yn\\])", "((.*)\\[yn\\])", "(.*\\n)");
		last if ($rv < 0);
		print $self->html_escape($self->{'matches_array'}->[1]);
		if ($rv == 0) {
			if ($donevolume++) {
				return $self->{'text_hash'}->{'restore_evolume'};
				}
			else {
				syswrite($fh, "1\n", 2);
				}
			}
		elsif ($rv == 1) {
			syswrite($fh, "n\n", 2);
			}
		elsif ($rv == 2) {
			return $self->text('restore_equestion',
				     "<tt>$self->{'matches_array'}->[2]</tt>");
			}
		}
	close($fh);
	waitpid($fpid, 0);
	return $? || undef;
	}
}


1;

