#!/usr/bin/perl

&MAIN();

 sub MAIN {
# backup.cgi
# Run a filesystem backup, either in the background or foreground (and show
# the results)

&ModuleLoader::preload_module('fsdump_class', "fsdump::FsdumpLib");
$self = new fsdump::FsdumpLib:: 'fsdump_class',%$self;

$self->ReadParse();
$self->{'dump'} = $self->get_dump($self->{'in_hash'}->{'id'});
$self->{'dump'}->{'id'} || $self->error($self->{'text_hash'}->{'backup_egone'});
$self->can_edit_dir($self->{'dump'}) || $self->error($self->{'text_hash'}->{'backup_ecannot'});

if ($self->{'config_hash'}->{'run_mode'}) {
	# Background
	$self->ui_print_header(undef, $self->{'text_hash'}->{'backup_title'}, "");

	print "<p>$self->{'text_hash'}->{'backup_bg'}<p>\n";
	$self->clean_environment();
	$self->system_logged("$self->{'cron_cmd'} ".quotemeta($self->{'dump'}->{'id'}).
	       " >/dev/null 2>&1 </dev/null &");
	$self->reset_environment();
	$self->webmin_log("bgbackup", undef, undef, $self->{'dump'});
	}
else {
	# Foreground
	$self->ui_print_unbuffered_header(undef, $self->{'text_hash'}->{'backup_title'}, "");

	# Setup command to be called upon tape change (which is not
	# supported in this mode)
	$self->{'nfile'} = "$self->{'module_config_directory'}/$self->{'dump'}->{'id'}.notape";
	unlink($self->{'nfile'});
	$self->create_wrappers();

	print "<b>",$self->text('backup_desc',
			     "<tt>".$self->html_escape($self->{'dump'}->{'dir'})."</tt>",
			     $self->dump_dest($self->{'dump'})),"</b><p>\n";
	print "<pre>";
	$self->{'bok'} = $self->execute_before($self->{'dump'}, STDOUT, 1);
	if (!$self->{'bok'}) {
		# Before command failed
		print "</pre>\n";
		print "<b>$self->{'text_hash'}->{'backup_beforefailed'}</b><p>\n";
		}
	else {
		# Do the dump
		$self->{'ok'} = $self->execute_dump($self->{'dump'}, STDOUT, 1, 0);
		print "</pre>\n";
		if (!$self->{'bok'}) {
			print "<b>$self->{'text_hash'}->{'backup_afterfailed'}</b><p>\n";
			}
		elsif ($self->{'ok'}) {
			# Worked .. but verify if asked
			if ($self->{'dump'}->{'reverify'}) {
				print "<b>$self->{'text_hash'}->{'backup_reverify'}</b><p>\n";
				print "<pre>";
				$self->{'ok'} = $self->verify_dump($self->{'dump'}, STDOUT, 1, 0);
				print "</pre>";
				}
			if ($self->{'ok'}) {
				print "<b>$self->{'text_hash'}->{'backup_done'}</b><br>\n";
				}
			else {
				print "<b>$self->{'text_hash'}->{'backup_noverify'}</b><br>\n";
				}
			}
		else {
			if (-r $self->{'nfile'}) {
				print "<b>$self->{'text_hash'}->{'backup_notape'}</b><br>\n";
				}
			else {
				print "<b>$self->{'text_hash'}->{'backup_failed'}</b><br>\n";
				}
			}

		# Execute the post-backup command, if any
		if ($self->{'ok'}) {
			print "<pre>";
			$self->{'bok'} = $self->execute_after($self->{'dump'}, STDOUT, 1);
			print "</pre>\n";
			}
		}
	unlink($self->{'nfile'});
	$self->webmin_log("backup", undef, undef, $self->{'dump'});
	}

$self->ui_print_footer($self->{'access_hash'}->{'edit'} ? ( "edit_dump.cgi?id=$self->{'in_hash'}->{'id'}",
			     $self->{'text_hash'}->{'edit_return'} ) : ( ),
	"", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

