#!/usr/bin/perl

&MAIN();

 sub MAIN {
# index.cgi
# Display a list of scheduled dumps

&ModuleLoader::preload_module('fsdump_class', "fsdump::FsdumpLib");
$self = new fsdump::FsdumpLib:: 'fsdump_class',%$self;

$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", "intro", 1, 1);

@{$self->{'fslist_array'}} = $self->supported_filesystems();
if (!@{$self->{'fslist_array'}} && !$self->{'supports_tar'}) {
	print "<p>",$self->text('index_ecommands', "<tt>dump</tt>"),"<p>\n";
	$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});
	exit;
	}

print $self->ui_subheading($self->{'text_hash'}->{'index_jobs'});
@{$self->{'alldumps_array'}} = $self->list_dumps();
@{$self->{'dumps_array'}} = grep { $self->can_edit_dir($_) } @{$self->{'alldumps_array'}};
$self->foreign_require("cron", "cron-lib.pl");
if (@{$self->{'dumps_array'}}) {
	($self->{'nontar'}) = grep { $_->{'fs'} ne 'tar' } @{$self->{'dumps_array'}};
	print $self->ui_form_start("delete_dumps.cgi", "post");
	@{$self->{'links_array'}} = ( $self->select_all_link("d"),
		   $self->select_invert_link("d") );
	print $self->ui_links_row(\@{$self->{'links_array'}});
	@{$self->{'tds_array'}} = ( "width=5" );
	print $self->ui_columns_start([
		"",
		$self->{'text_hash'}->{'dump_dir'},
		$self->{'text_hash'}->{'dump_fs'},
		$self->{'nontar'} ? ( $self->{'text_hash'}->{'dump_level'} ) : ( ),
		$self->{'text_hash'}->{'dump_dest'},
		$self->{'text_hash'}->{'dump_sched'},
		$self->{'text_hash'}->{'dump_when'},
		$self->{'text_hash'}->{'index_action'} ], 100, 0, \@{$self->{'tds_array'}});
	foreach $d (@{$self->{'dumps_array'}}) {
		local @cols;
		@{$self->{'dirs_array'}} = $self->dump_directories($d);
		$self->{'dirs'} = join("<br>", map { $self->html_escape($_) } @{$self->{'dirs_array'}});
		if ($self->{'access_hash'}->{'edit'}) {
			push(@cols, "<a href='edit_dump.cgi?id=$d->{'id'}'>".
				    "<tt>$self->{'dirs'}</tt></a>");
			}
		else {
			push(@cols, "<tt>$self->{'dirs'}</tt>");
			}
		push(@cols, uc($d->{'fs'}));
		push(@cols, $self->html_escape($d->{'level'})) if ($self->{'nontar'});
		push(@cols, "<tt>".$self->dump_dest($d)."</tt>");
		push(@cols, $d->{'enabled'} ? $self->{'text_hash'}->{'yes'} : $self->{'text_hash'}->{'no'});
		$self->{'using_strftime'}++ if ($d->{'file'} =~ /%/ ||
				      $d->{'hfile'} =~ /%/);
		if ($d->{'follow'}) {
			$self->{'f'} = $self->get_dump($d->{'follow'});
			push(@cols, $self->text('index_follow',
					  "<tt>$self->{'f'}->{'dir'}</tt>"));
			}
		else {
			push(@cols, $main::cron_object->when_text($d, 1));
			}
		push(@cols, "<a href='backup.cgi?id=$d->{'id'}'>".
			    "$self->{'text_hash'}->{'index_now'}</a>");
		print $self->ui_checked_columns_row(\@cols, \@{$self->{'tds_array'}}, "d", $d->{'id'});
		}
	print $self->ui_columns_end();
	print $self->ui_links_row(\@{$self->{'links_array'}});
	print $self->ui_form_end([ [ "delete", $self->{'text_hash'}->{'index_delete'} ] ]);
	}
elsif (!@{$self->{'alldumps_array'}}) {
	print "<b>$self->{'text_hash'}->{'index_none'}</b><p>\n";
	}
else {
	print "<b>$self->{'text_hash'}->{'index_none2'}</b><p>\n";
	}
if ($self->{'using_strftime'} && !$self->{'config_hash'}->{'date_subs'}) {
	print "<font color=#ff0000><b>$self->{'text_hash'}->{'index_nostrftime'}",
	      "</b></font><p>\n";
	}

# Form to add
print "<form action=edit_dump.cgi>\n";
print "<input type=submit value='$self->{'text_hash'}->{'index_add'}'>\n";
print "<input name=dir size=20> ",$self->file_chooser_button("dir"),"\n";
if ($self->{'supports_tar'} && !$self->{'config_hash'}->{'always_tar'}) {
	print $self->ui_checkbox("forcetar", 1, $self->{'text_hash'}->{'index_forcetar'}, 0),"\n";
	}
print "</form>\n";

if ($self->{'access_hash'}->{'restore'}) {
	# Display restore button
	print "<hr>\n";
	print "<form action=restore_form.cgi>\n";
	print "<table width=100%><tr><td nowrap>\n";
	@{$self->{'fstypes_array'}} = ( );
	push(@{$self->{'fstypes_array'}}, $self->supported_filesystems()) if (!$self->{'config_hash'}->{'always_tar'});
	push(@{$self->{'fstypes_array'}}, "tar") if ($self->{'supports_tar'});
	if (@{$self->{'fstypes_array'}} > 1) {
		print $self->ui_submit($self->{'text_hash'}->{'index_restore'});
		print $self->ui_select("fs", undef,
			[ map { [ $_, uc($_) ] } @{$self->{'fstypes_array'}} ]),"</td>\n";
		print "<td>$self->{'text_hash'}->{'index_restoremsg'}</td>\n";
		}
	else {
		print $self->ui_submit($self->{'text_hash'}->{'index_restore2'});
		print $self->ui_hidden("fs", $self->{'fstypes_array'}->[0]),"</td>\n";
		print "<td>$self->{'text_hash'}->{'index_restoremsg2'}</td>\n";
		}
	print "</tr></table></form>\n";
	}

# Display running backup jobs list, if any
$self->foreign_require("proc", "proc-lib.pl");
@{$self->{'procs_array'}} = $main::proc_object->list_processes();
@{$self->{'running_array'}} = grep { $self->can_edit_dir($_) } $self->running_dumps(\@{$self->{'procs_array'}});
if (@{$self->{'running_array'}}) {
	print "<hr>\n";
	print $self->ui_subheading($self->{'text_hash'}->{'index_running'});
	print $self->ui_columns_start([ $self->{'text_hash'}->{'dump_dir'},
				  $self->{'text_hash'}->{'dump_dest'},
				  $self->{'text_hash'}->{'index_start'},
				  $self->{'text_hash'}->{'index_status'},
				  $self->{'text_hash'}->{'index_action'} ], 100);
	foreach $d (@{$self->{'running_array'}}) {
		@{$self->{'dirs_array'}} = $self->dump_directories($d);
		$self->{'dirs'} = join("<br>", map { $self->html_escape($_) } @{$self->{'dirs_array'}});
		local @cols;
		push(@cols, "<tt>$self->{'dirs'}</tt>");
		push(@cols, "<tt>".$self->dump_dest($d)."</tt>");
		push(@cols, $self->make_date($d->{'status'}->{'start'}));
		push(@cols, $self->{'text_hash'}->{'index_status_'.$d->{'status'}->{'status'}});
		local $action;
		if ($d->{'status'}->{'status'} eq 'running' ||
		    $d->{'status'}->{'status'} eq 'tape') {
			$action .= "<a href='kill.cgi?id=$d->{'id'}&pid=$d->{'pid'}'>$self->{'text_hash'}->{'index_kill'}</a>\n";
			}
		if ($d->{'status'}->{'status'} eq 'tape') {
			$action .= "&nbsp;|&nbsp;\n";
			$action .= "<a href='newtape.cgi?id=$d->{'id'}&pid=$d->{'pid'}'>$self->{'text_hash'}->{'index_newtape'}</a>\n";
			}
		if ($d->{'status'}->{'status'} eq 'complete' ||
		    $d->{'status'}->{'status'} eq 'failed' ||
		    $d->{'status'}->{'status'} eq 'verifyfailed') {
			$action .= $self->{'text_hash'}->{'index_noaction'};
			}
		push(@cols, $action);
		print $self->ui_columns_row(\@cols);
		}
	print $self->ui_columns_end();
	}

$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});

1;
		
}


1;

