#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_dump.cgi
# Save the details of a scheduled backup

&ModuleLoader::preload_module('fsdump_class', "fsdump::FsdumpLib");
$self = new fsdump::FsdumpLib:: 'fsdump_class',%$self;

$self->foreign_require("cron", "cron-lib.pl");
$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'save_err'});

# Create wrapper for ftp transfer script
$main::cron_object->create_wrapper($self->{'ftp_cmd'}, $self->{'module_name'}, "ftp.pl");

if ($self->{'in_hash'}->{'id'}) {
	$self->{'dump'} = $self->get_dump($self->{'in_hash'}->{'id'});
	$self->{'access_hash'}->{'edit'} && $self->can_edit_dir($self->{'dump'}) ||
		$self->error($self->{'text_hash'}->{'dump_ecannot2'});
	@{$self->{'jobs_array'}} = $self->foreign_call("cron", "list_cron_jobs");
	foreach $j (@{$self->{'jobs_array'}}) {
		$self->{'job'} = $j if ($j->{'command'} eq "$self->{'cron_cmd'} $self->{'dump'}->{'id'}");
		}
	$self->{'oldenabled'} = $self->{'dump'}->{'enabled'};
	}
else {
	$self->{'access_hash'}->{'edit'} || $self->error($self->{'text_hash'}->{'dump_ecannot1'});
	}

if ($self->{'in_hash'}->{'delete'}) {
	# Just delete this dump
	$self->delete_dump($self->{'dump'});
	if ($self->{'job'}) {
		$self->lock_file($self->{'job'}->{'file'});
		$self->foreign_call("cron", "delete_cron_job", $self->{'job'});
		$self->unlock_file($self->{'job'}->{'file'});
		}
	$self->webmin_log("delete", undef, $self->{'dump'}->{'id'}, $self->{'dump'});
	$self->redirect("");
	}
elsif ($self->{'in_hash'}->{'restore'}) {
	# Redirect to restore form
	$self->redirect("restore_form.cgi?fs=$self->{'dump'}->{'fs'}&id=$self->{'in_hash'}->{'id'}");
	}
else {
	# Validate and store inputs
	if ($self->multiple_directory_support($self->{'in_hash'}->{'fs'})) {
		$self->{'in_hash'}->{'dir'} =~ s/[\r\n]+/\t/g;
		foreach $d (split(/\t+/, $self->{'in_hash'}->{'dir'})) {
			-d $d || $self->error($self->{'text_hash'}->{'save_edir'});
			if ($self->{'in_hash'}->{'fs'} ne 'tar') {
				$self->{'fs'} = $self->directory_filesystem($d);
				$self->same_filesystem($self->{'fs'}, $self->{'in_hash'}->{'fs'}) ||
					$self->error($self->{'text_hash'}->{'save_efs'});
				}
			$self->can_edit_dir($d) || $self->error($self->{'text_hash'}->{'dump_ecannot3'});
			}
		$self->{'in_hash'}->{'dir'} || $self->error($self->{'text_hash'}->{'save_edir'});
		$self->{'dump'}->{'tabs'} = 1;	# tab used to split dirs
		}
	else {
		-d $self->{'in_hash'}->{'dir'} || $self->error($self->{'text_hash'}->{'save_edir'});
		if ($self->{'in_hash'}->{'fs'} ne 'tar') {
			$self->{'fs'} = $self->directory_filesystem($self->{'in_hash'}->{'dir'});
			$self->same_filesystem($self->{'fs'}, $self->{'in_hash'}->{'fs'}) ||
				$self->error($self->{'text_hash'}->{'save_efs'});
			}
		$self->can_edit_dir($self->{'in_hash'}->{'dir'}) || $self->error($self->{'text_hash'}->{'dump_ecannot3'});
		}
	$self->{'dump'}->{'dir'} = $self->{'in_hash'}->{'dir'};
	$self->{'dump'}->{'fs'} = $self->{'in_hash'}->{'fs'};
	$self->{'dump'}->{'email'} = $self->{'in_hash'}->{'email'};
	$self->{'dump'}->{'subject'} = $self->{'in_hash'}->{'subject_def'} ? undef : $self->{'in_hash'}->{'subject'};
	if ($self->{'access_hash'}->{'extra'}) {
		$self->{'dump'}->{'extra'} = $self->{'in_hash'}->{'extra'};
		}
	if ($self->{'access_hash'}->{'cmds'}) {
		$self->{'dump'}->{'before'} = $self->{'in_hash'}->{'before'};
		$self->{'dump'}->{'after'} = $self->{'in_hash'}->{'after'};
		}
	$self->parse_dump($self->{'dump'});
	$self->{'dump'}->{'reverify'} = $self->{'in_hash'}->{'reverify'} if ($self->UNIVERSAL::can('verify_dump'));
	$self->{'dump'}->{'enabled'} = $self->{'in_hash'}->{'enabled'};
	$self->{'dump'}->{'follow'} = $self->{'in_hash'}->{'enabled'} == 2 ? $self->{'in_hash'}->{'follow'} : undef;
	$self->foreign_call("cron", "parse_times_input", $self->{'dump'}, \%{$self->{'in_hash'}});

	# Create or update the dump and cron job
	$self->lock_file($self->{'cron_cmd'});
	$main::cron_object->create_wrapper($self->{'cron_cmd'}, $self->{'module_name'}, "backup.pl");
	$self->unlock_file($self->{'cron_cmd'});
	$self->save_dump($self->{'dump'});
	local $oldjob = $self->{'job'};
	if ($self->{'dump'}->{'enabled'} == 1) {
		# Create cron job and script
		$self->{'job'}->{'user'} = 'root';
		$self->{'job'}->{'active'} = 1;
		$self->{'job'}->{'special'} = $self->{'dump'}->{'special'};
		$self->{'job'}->{'mins'} = $self->{'dump'}->{'mins'};
		$self->{'job'}->{'hours'} = $self->{'dump'}->{'hours'};
		$self->{'job'}->{'days'} = $self->{'dump'}->{'days'};
		$self->{'job'}->{'months'} = $self->{'dump'}->{'months'};
		$self->{'job'}->{'weekdays'} = $self->{'dump'}->{'weekdays'};
		$self->{'job'}->{'command'} = "$self->{'cron_cmd'} $self->{'dump'}->{'id'}";
		}
	$self->lock_file($main::cron_object->cron_file($self->{'job'})) if ($self->{'job'});
	if ($self->{'dump'}->{'enabled'} == 1 && !$oldjob) {
		# Create the cron job
		$self->foreign_call("cron", "create_cron_job", $self->{'job'}); 
		}
	elsif ($self->{'dump'}->{'enabled'} == 1 && $oldjob) {
		# Update the cron job
		$self->foreign_call("cron", "change_cron_job", $self->{'job'}); 
		}
	elsif ($self->{'dump'}->{'enabled'} != 1 && $oldjob) {
		# Delete the cron job
		$self->foreign_call("cron", "delete_cron_job", $self->{'job'});
		}
	$self->unlock_file($main::cron_object->cron_file($self->{'job'})) if ($self->{'job'});

	$self->webmin_log($self->{'in_hash'}->{'id'} ? "modify" : "create", undef, $self->{'dump'}->{'id'}, $self->{'dump'});
	if ($self->{'in_hash'}->{'savenow'}) {
		$self->redirect("backup.cgi?id=$self->{'dump'}->{'id'}");
		}
	else {
		$self->redirect("");
		}
	}

1;
		
}


1;

