#!/usr/bin/perl

&MAIN();

 sub MAIN {
# install.cgi
# Install the GRUB boot loader

&ModuleLoader::preload_module('grub_class', "grub::GrubLib");
$self = new grub::GrubLib:: 'grub_class',%$self;

$self->error_setup($self->{'text_hash'}->{'install_err'});
$self->ReadParse();

# Find out which partition the menu file is on
@{$self->{'st_array'}} = stat($self->{'config_hash'}->{'menu_file'});
$self->foreign_require("mount", "mount-lib.pl");
foreach $d (sort { length($a->[0]) <=> length($b->[0]) }
		 $main::mount_object->list_mounted()) {
	@{$self->{'fst_array'}} = stat($d->[0]);
	$self->{'mount'} = $d->[0] if ($self->{'fst_array'}->[0] == $self->{'st_array'}->[0]);
	}
$self->{'mount'} =~ s/\/$//;
$self->{'menu_file'} = $self->{'config_hash'}->{'menu_file'};
$self->{'menu_file'} =~ s/^\Q$self->{'mount'}\E//;

# Ask grub where the menu.lst file is
$self->{'temp'} = $self->transname();
open(TEMP, ">$self->{'temp'}");
print TEMP "find $self->{'menu_file'}\n";
close(TEMP);
open(GRUB, "$self->{'config_hash'}->{'grub_path'} --batch <$self->{'temp'} |");
while(<GRUB>) {
	if (/find\s+(\S+)/ && $1 eq $self->{'menu_file'}) {
		$self->{'out'} .= $_;
		$_ = <GRUB>;
		if (/^\s*(\(\S+\))/) {
			$self->{'root'} = $1;
			}
		}
	$self->{'out'} .= $_;
	}
close(GRUB);
unlink($self->{'temp'});
if (!$self->{'root'} || $?) {
	# Didn't find it!
	$self->error($self->{'text_hash'}->{'install_efind'},"<pre>",$self->{'out'},"</pre>");
	}

# Setup on the chosen device
$self->ui_print_header(undef, $self->{'text_hash'}->{'install_title'}, "");
print $self->text('install_desc', $self->{'in_hash'}->{'dev'}, "<tt>root $self->{'root'}</tt>",
	    "<tt>setup $self->{'config_hash'}->{'install'}</tt>"),"<p>\n";
print "<pre>";
open(TEMP, ">$self->{'temp'}");
print TEMP "root $self->{'root'}\n";
print TEMP "setup $self->{'config_hash'}->{'install'}\n";
close(TEMP);
open(GRUB, "$self->{'config_hash'}->{'grub_path'} --batch <$self->{'temp'} |");
while(<GRUB>) {
	if (/\d+\s+sectors\s+are\s+embedded/i) {
		$self->{'embedded'}++;
		}
	elsif (/error/) {
		$self->{'error'}++;
		}
	print $self->html_escape($_);
	}
close(GRUB);
print "</pre>\n";
if (!$self->{'embedded'} || $? || $self->{'error'}) {
	print "$self->{'text_hash'}->{'install_failed'}<p>\n";
	}
else {
	print "$self->{'text_hash'}->{'install_ok'}<p>\n";
	}

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

