#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_global.cgi
# Save global GRUB options

&ModuleLoader::preload_module('grub_class', "grub::GrubLib");
$self = new grub::GrubLib:: 'grub_class',%$self;

$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'global_err'});
$self->{'conf'} = $self->get_menu_config();
$self->error_setup($self->{'text_hash'}->{'global_err'});

# validate and save inputs
if ($self->{'in_hash'}->{'default'} eq '') {
	$self->save_directive($self->{'conf'}, 'default', undef);
	}
else {
	$self->save_directive($self->{'conf'}, 'default', { 'name' => 'default',
					    'value' => $self->{'in_hash'}->{'default'} });
	}
if ($self->{'in_hash'}->{'fallback'} eq '') {
	$self->save_directive($self->{'conf'}, 'fallback', undef);
	}
else {
	$self->save_directive($self->{'conf'}, 'fallback', { 'name' => 'fallback',
					     'value' => $self->{'in_hash'}->{'fallback'} });
	}
if ($self->{'in_hash'}->{'timeout_def'}) {
	$self->save_directive($self->{'conf'}, 'timeout', undef);
	}
else {
	$self->{'in_hash'}->{'timeout'} =~ /^\d+$/ || $self->error($self->{'text_hash'}->{'global_etimeout'});
	$self->save_directive($self->{'conf'}, 'timeout', { 'name' => 'timeout',
					    'value' => $self->{'in_hash'}->{'timeout'} });
	}
if ($self->{'in_hash'}->{'password_def'}) {
	$self->save_directive($self->{'conf'}, 'password', undef);
	}
else {
	$self->{'in_hash'}->{'password'} =~ /^\S+$/ || $self->error($self->{'text_hash'}->{'global_epassword'});
	if (!$self->{'in_hash'}->{'password_file'}) {
		$self->save_directive($self->{'conf'}, 'password', { 'name' => 'password',
		    'value' => $self->{'in_hash'}->{'password'} } );
		}
	else {
		$self->{'in_hash'}->{'password_filename'} =~ /^\S+$/ ||
			$self->error($self->{'text_hash'}->{'global_epasswordfile'});
		$self->save_directive($self->{'conf'}, 'password', { 'name' => 'password',
		    'value' => $self->{'in_hash'}->{'password'}.' '.$self->{'in_hash'}->{'password_filename'} } );
		}
	}
if ($self->{'in_hash'}->{'install_mode'} == 1) {
	$self->{'install'} = $self->linux_to_bios($self->{'in_hash'}->{'install'});
	$self->{'install'} || $self->error($self->text('global_edev', $self->{'in_hash'}->{'root'}));
	$self->{'config_hash'}->{'install'} = $self->{'install'};
	}
else {
	$self->{'in_hash'}->{'other'} =~ /^\S+$/ || $self->error($self->{'text_hash'}->{'global_eother'});
	$self->{'config_hash'}->{'install'} = $self->{'in_hash'}->{'other'};
	}
$self->write_file("$self->{'module_config_directory'}/config", \%{$self->{'config_hash'}});
$self->flush_file_lines();
$self->redirect("");

1;
		
}


1;

