#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_title.cgi
# Save a boot menu option

&ModuleLoader::preload_module('grub_class', "grub::GrubLib");
$self = new grub::GrubLib:: 'grub_class',%$self;

$self->ReadParse();
$self->{'conf'} = $self->get_menu_config();
if (!$self->{'in_hash'}->{'new'}) {
	$self->{'old'} = $self->{'title'} = $self->{'conf'}->[$self->{'in_hash'}->{'idx'}];
	}
$self->error_setup($self->{'text_hash'}->{'title_err'});

if ($self->{'in_hash'}->{'delete'}) {
	# Just delete the title
	$self->save_directive($self->{'conf'}, $self->{'title'}, undef);
	}
else {
	# validate inputs
	$self->{'in_hash'}->{'title'} =~ /\S/ || $self->error($self->{'text_hash'}->{'title_etitle'});
	$self->{'in_hash'}->{'root_mode'} != 1 || $self->{'in_hash'}->{'other'} =~ /^\S+$/ ||
		$self->error($self->{'text_hash'}->{'title_eroot'});
	$self->{'in_hash'}->{'boot_mode'} != 2 || $self->{'in_hash'}->{'kernel'} =~ /\S/ ||
		$self->error($self->{'text_hash'}->{'title_ekernel'});
	$self->{'in_hash'}->{'boot_mode'} != 1 || $self->{'in_hash'}->{'chain_def'} || $self->{'in_hash'}->{'chain'} =~ /\S/ ||
		$self->error($self->{'text_hash'}->{'title_echain'});
	$self->{'in_hash'}->{'initrd_def'} || $self->{'in_hash'}->{'initrd'} =~ /\S/ ||
		$self->error($self->{'text_hash'}->{'title_einitrd'});

	# store inputs in title structure
	$self->{'title'}->{'name'} = 'title';
	$self->{'title'}->{'value'} = $self->{'in_hash'}->{'title'};
	local $r = $self->{'in_hash'}->{'noverify'} ? "rootnoverify" : "root";
	delete($self->{'title'}->{'root'});
	delete($self->{'title'}->{'rootnoverify'});
	if ($self->{'in_hash'}->{'root_mode'} == 1) {
		$self->{'title'}->{$r} = $self->{'in_hash'}->{'other'};
		}
	elsif ($self->{'in_hash'}->{'root_mode'} == 2) {
		$self->{'root'} = $self->linux_to_bios($self->{'in_hash'}->{'root'});
		$self->{'root'} || $self->error($self->text('title_edev', $self->{'in_hash'}->{'root'}));
		$self->{'title'}->{$r} = $self->{'root'};
		}
	delete($self->{'title'}->{'kernel'});
	delete($self->{'title'}->{'chainloader'});
	delete($self->{'title'}->{'initrd'});
	if ($self->{'in_hash'}->{'boot_mode'} == 2) {
		$self->{'title'}->{'kernel'} = $self->{'in_hash'}->{'kernel'};
		$self->{'title'}->{'kernel'} .= " $self->{'in_hash'}->{'args'}" if ($self->{'in_hash'}->{'args'});
		$self->{'title'}->{'initrd'} = $self->{'in_hash'}->{'initrd'} if (!$self->{'in_hash'}->{'initrd_def'});
		}
	elsif ($self->{'in_hash'}->{'boot_mode'} == 1) {
		$self->{'title'}->{'chainloader'} = $self->{'in_hash'}->{'chain_def'} ? '+1'
							   : $self->{'in_hash'}->{'chain'};
		}
	if ($self->{'in_hash'}->{'makeactive'}) {
		$self->{'title'}->{'makeactive'} = "";
		}
	else {
		delete($self->{'title'}->{'makeactive'});
		}
	if ($self->{'in_hash'}->{'lock'}) {
		$self->{'title'}->{'lock'} = "";
		}
	else {
		delete($self->{'title'}->{'lock'});
		}

	# create or update the title
	$self->save_directive($self->{'conf'}, $self->{'old'}, $self->{'title'});
	}

$self->flush_file_lines();
$self->redirect("");

1;
		
}


1;

