#!/usr/bin/perl
package home::HomeLib;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'home::HomeLib');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
&ModuleLoader::preload_module(ref($self), "WebLib");
$self = new WebLib:: ref($self), %$self; 
$self->init_config();
#require '../common-lib.pl';
&ModuleLoader::preload_module(ref($self), "UiLib");
$self = new UiLib:: ref($self), %$self; 

1;
1;
		return $self;
}

# return system uptime
sub get_uptime {
	my $self = shift;

	if ( -e '/usr/bin/uptime') {
		my $uptime = `/usr/bin/uptime`;
		$uptime =~ m/up\s+(.*?),[^,]*?user/i;
		( $uptime = $1 ) =~ tr/,//d;
		return $uptime;
	}
	return '';
}

# get_mime(\%mime)
sub get_mime {
	my $self = shift;

	open(MIME, "$self->{'root_directory'}/mime.types");
	while (<MIME>) {
		s/\n|\r//g;
		s/#.*$//g;
		my @s = split(/\s+/);
		if (@s) {
			my $k = shift @s;
			push(@{$_[0]->{$k}}, @s);
		}
	}
	close(MIME);
}

# apache_avail_directives($context, \%avail)
# Displays up to 18 icons, one for each type of configuration directive, for
# some context (global, virtual, directory or htaccess)
sub apache_avail_directives {
	my $self = shift;

local($m, $func, $e, %etype, $i, $c);
$self->foreign_require('apache', 'apache-lib.pl');
foreach $m (sort { $a cmp $b } (keys %{$main::apache_object->{'httpd_modules_hash'}})) {
	$func = $m . "_directives";
	foreach $e ($self->foreign_call('apache', $func, $main::apache_object->{'httpd_modules_hash'}->{$m})) {
		if ($e->{$_[0]}) { $_[1]->{$e->{'type'}}++; }
	}
}
#map {print "$_<br>"} keys(%etype);
#print "<br>";
}

# check_email_address($email);
sub check_email_address {
	my $self = shift;

	return ($_[0] =~ /^[a-z0-9._-]+@([a-z0-9_-]+\.)+(com|net|org|mil|edu|gov|arpa|info|inc|biz|name|[a-z]{2})$/i) ? 1 : 0;
}

# work out apache directives
# extmap_input(directive, title, size, desc, list)
sub extmap_input_home
{
	my $self = shift;

local($rv, $i, $type, $exts);
$rv = "<table border>\n".
      "<tr $self->{'tb'}> <td><b>$_[1]</b></td> <td><b>$self->{'mtext_hash'}->{'mod_mime_ext'}</b></td></tr>\n";
$self->{'len'} = scalar(@{$_[4]}) + 1; #int(@{$_[4]}/2)*2 + 2;
for($i=0; $i<$self->{'len'}; $i++) {
	$rv .= "<tr $self->{'cb'}>\n";
	if ($_[4]->[$i]) {
		$_[4]->[$i]->{'value'} =~ /^(\S+)\s*(.*)$/;
		$type = $1; $exts = $2;
		}
	else { $type = $exts = ""; }
	$rv .= "<td>";
	if ($_[2] eq "handler") {
		$rv .= $main::apache_object->handler_input($type, "$_[0]_type_$i");
	}
	elsif ($_[2] eq "mime") {
		$rv .= $self->get_mime_select($type, "$_[0]_type_$i");
	}
	else {
		$rv .= "<input name=$_[0]_type_$i size=$_[2] value=$type>";
	}
	$rv .= "</td>\n";
	$rv .= "<td><input name=$_[0]_exts_$i size=10 value=\"$exts\"></td>\n";
	$rv .= "</tr>\n";
	}
$rv .= "</table>\n";
return (2, $_[3], $rv);
}

sub edit_AddType_home {
	my $self = shift;

	$self->extmap_input_home("AddType", $self->{'mtext_hash'}->{'mod_mime_type'}, "", $self->{'text_hash'}->{'apache_mime'}, $_[0]);
}

sub edit_AddHandler_home {
	my $self = shift;

	$self->extmap_input_home("AddHandler", $self->{'mtext_hash'}->{'mod_mime_handler'}, "handler", $self->{'text_hash'}->{'apache_handler'}, $_[0]);
}

# Error handling directives
sub edit_ErrorDocument_home {
	my $self = shift;

local($rv, $len, $i);
$rv = "<table border width=100%>\n";
$rv .= "<tr $self->{'tb'}> <td><b>$self->{'mtext_hash'}->{'core_error'}</b></td> <td><b>$self->{'mtext_hash'}->{'core_resp'}</b></td> ".
       "<td><b>$self->{'mtext_hash'}->{'core_urlmsg'}</b></td> </tr>\n";
$len = @{$_[0]} + 1;
for($i=0; $i<$len; $i++) {
	$self->{'v'} = $_[0]->[$i]->{'value'};
	if ($self->{'v'} =~ /^(\d+)\s+((http|ftp|gopher):\S+)$/)
		{ $self->{'code'} = $1; $self->{'type'} = 0; $self->{'url'} = $2; }
	elsif ($self->{'v'} =~ /^(\d+)\s+(\/.*)$/) { $self->{'code'} = $1; $self->{'type'} = 0; $self->{'url'} = $2; }
	elsif ($self->{'v'} =~ /^(\d+)\s+"(.*)"$/) { $self->{'code'} = $1; $self->{'type'} = 1; $self->{'url'} = $2; }
	elsif ($self->{'v'} =~ /^(\d+)\s+"?(.*)$/) { $self->{'code'} = $1; $self->{'type'} = 1; $self->{'url'} = $2; }
	else { $self->{'code'} = ""; $self->{'type'} = 0; $self->{'url'} = ""; }
	$rv .= "<tr $self->{'cb'}>\n";
	$rv .= "<td><input name=ErrorDocument_code_$i size=3 value=$self->{'code'}></td>\n";
	$rv .= "<td><input type=radio name=ErrorDocument_type_$i value=0 ".
	       ($self->{'type'}==0 ? "checked" : "").">$self->{'mtext_hash'}->{'core_tourl'}\n";
	$rv .= "<input type=radio name=ErrorDocument_type_$i value=1 ".
	       ($self->{'type'}==1 ? "checked" : "").">$self->{'mtext_hash'}->{'core_mesg'}</td>\n";
	$rv .= "<td><input name=ErrorDocument_url_$i size=40 value=\"$self->{'url'}\"></td>\n";
	$rv .= "</tr>\n";
	}
$rv .= "</table>\n";
return (2, $self->{'mtext_hash'}->{'core_custom'}, $rv);
}

# -------- SSL -----
sub edit_SSLEngine_home {
	my $self = shift;

return (1, $self->{'mtext_hash'}->{'mod_ssl_enable'},
	$main::apache_object->choice_input($_[0]->{'value'}, "SSLEngine", "",
	      "$self->{'mtext_hash'}->{'yes'},on", "$self->{'mtext_hash'}->{'no'},off", "$self->{'mtext_hash'}->{'default'},"));
}

sub edit_SSLProtocol_home {
	my $self = shift;

local ($rv, $p, %prot);
local @list = $_[0] ? @{$_[0]->{'words'}} : ("all");
foreach $p (@list) {
	if ($p =~ /^\+?all$/i) { map { $prot{lc($_)} = 1 } @{$main::apache_object->{'sslprotos_array'}}; }
	elsif ($p =~ /^\-all$/i) { undef(%prot); }
	elsif ($p =~ /^\-(\S+)/) { $prot{lc($1)} = 0; }
	elsif ($p =~ /^\+(\S+)/) { $prot{lc($1)} = 1; }
	}
foreach $p (@{$main::apache_object->{'sslprotos_array'}}) {
	$rv .= sprintf "<input type=checkbox name=SSLProtocol value=$p %s> $p ",
		$prot{lc($p)} ? "checked" : "";
	}
return (1, $self->{'mtext_hash'}->{'mod_ssl_proto'}, $rv);
}

sub edit_SSLCertificateFile_home {
	my $self = shift;

return (1, $self->{'mtext_hash'}->{'mod_ssl_cfile'},
	#"<b>$self->{'mtext_hash'}->{'mod_ssl_cfile'}</b>" .
	$main::apache_object->opt_input($_[0]->{'value'}, "SSLCertificateFile", $self->{'mtext_hash'}->{'mod_ssl_default'}, 35).
	$self->file_chooser_button("SSLCertificateFile", 0));
}

sub edit_SSLCertificateKeyFile_home {
	my $self = shift;

return (1, $self->{'mtext_hash'}->{'mod_ssl_kfile'},
	#"<b>$self->{'mtext_hash'}->{'mod_ssl_kfile'}</b>" .
	$main::apache_object->opt_input($_[0]->{'value'}, "SSLCertificateKeyFile", $self->{'mtext_hash'}->{'mod_ssl_default'}, 35).
	$self->file_chooser_button("SSLCertificateKeyFile", 0));
}

sub edit_SSLVerifyClient_home {
	my $self = shift;

return (1, $self->{'mtext_hash'}->{'mod_ssl_clcert'},
	$main::apache_object->select_input($_[0]->{'value'}, "SSLVerifyClient", "",
		      "$self->{'mtext_hash'}->{'default'},", "$self->{'mtext_hash'}->{'mod_ssl_nreq'},none",
		      "$self->{'mtext_hash'}->{'mod_ssl_opt'},optional",
		      "$self->{'mtext_hash'}->{'mod_ssl_req'},require",
		      "$self->{'mtext_hash'}->{'mod_ssl_optca'},optional_no_ca"));
}

sub edit_SSLVerifyDepth_home {
	my $self = shift;

return (1, $self->{'mtext_hash'}->{'mod_ssl_cdepth'},
	$main::apache_object->opt_input($_[0]->{'value'}, "SSLVerifyDepth", $self->{'mtext_hash'}->{'mod_ssl_default'}, 6));
}

sub edit_SSLLog_home {
	my $self = shift;

return (1, $self->{'mtext_hash'}->{'mod_ssl_log'},
	$main::apache_object->opt_input($_[0]->{'value'}, "SSLLog", $self->{'mtext_hash'}->{'mod_ssl_default'}, 20));
}

sub edit_SSLRequireSSL_home {
	my $self = shift;

return (1, $self->{'mtext_hash'}->{'mod_ssl_onlyssl'},
	$main::apache_object->choice_input($_[0] ? 1 : 0, "SSLRequireSSL", 0, "$self->{'mtext_hash'}->{'yes'},1", "$self->{'mtext_hash'}->{'no'},0"));
}

# ----------- ServerAlias -------------
sub edit_ServerAlias_home {
	my $self = shift;

local($a, @al);
foreach $a (@{$_[0]}) { push(@al, split(/\s+/, $a->{'value'})); }
return (1, $self->{'text_hash'}->{'apache_serveralias_alt'},
	sprintf "<textarea name=ServerAlias rows=3 cols=25>%s</textarea>\n",
		join("\n", @al) );
}

sub edit_Redirect_home {
	my $self = shift;

if ($_[1]->{'version'} >= 1.2) {
	return $self->alias_status_input_home($_[0], "Redirect", $self->{'mtext_hash'}->{'mod_alias_redir'});
	}
else { return $self->alias_input_home($_[0], "Redirect", $self->{'mtext_hash'}->{'mod_alias_redir'}); }
}

# alias_status_input(array, name, title)
sub alias_status_input_home {
	my $self = shift;

local($rv, $len, $i, $from, $to, $stat);
$rv = "<table border>\n".
                "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'apache_redir_src'}</b></td>".
                #"<td><b>$mtext{'mod_alias_status'}</b></td>".
                "<td><b>$self->{'text_hash'}->{'apache_redir_dest'}</b></td> </tr>\n";
$len = @{$_[0]} + 1;
for($i=0; $i<$len; $i++) {
        if ($_[0]->[$i]->{'words'}->[0] =~ /^(permanent|temp|seeother|gone|\d+)$/) {
                $stat = $_[0]->[$i]->{'words'}->[0];
                $from = $_[0]->[$i]->{'words'}->[1];
                $to = $_[0]->[$i]->{'words'}->[2];
                if ($main::apache_object->{'alias_statmap_hash'}->{$stat}) { $stat = $main::apache_object->{'alias_statmap_hash'}->{$stat}; }
                }
        else {
                $stat = "";
                $from = $_[0]->[$i]->{'words'}->[0];
                $to = $_[0]->[$i]->{'words'}->[1];
                }
        $rv .= "<tr $self->{'cb'}>\n";
        $rv .= "<td><input name=$_[1]_from_$i size=20 value=\"$from\"></td>\n";
        #$rv .= "<td><input name=$_[1]_stat_$i size=4 value=\"$stat\"></td>\n";
        $rv .= "<td><input name=$_[1]_to_$i size=40 value=\"$to\"></td>\n";
        $rv .= "</tr>\n";
        }
$rv .= "</table>\n";
return (2, $_[2], $rv);
}

sub get_countries_info {
	my $self = shift;

	local (@a, @list);
	open (TAB, 'countries.info' );
	while(<TAB>) {
		@a= split(/=/, $_);
		chomp ($a[1]);
		push (@list, {'CC' => $a[0],  'country'=> $a[1] } );
	}
	close (TAB);
	return (@list)
}

sub get_state_info {
	my $self = shift;

	local (@a, @list);
	open (TAB, 'states_and_provinces.info' );
	while(<TAB>) {
		@a= split(/=/, $_);
		chomp ($a[1]);
		push (@list, {'CC' => $a[0],  'state'=> $a[1] } );
	}
	close (TAB);
	return (@list)
}

# --- ZTL specific functions ---
# &print_menu(\%apps, $file);
# %apps - appliances' hash
# $file - menu file name
sub print_menu {
	my $self = shift;

	local $apps = shift(@_);
	local $file = shift(@_);
	local (%m_data, @m_order, @menu);
	$self->read_file($file, \%m_data, \@m_order);
	local $title = $self->ztl_get_jointext($apps, $m_data{'title'});
	delete($m_data{'title'});
	#local $title = $m_data{'title'};
	return unless $title;
	foreach my $k (@m_order) {
		next if $m_data{$k} =~ /^#/ || !$m_data{$k};
		# expected format: "col:icon:href:text_formatted_string"
		if ($m_data{$k} =~ /^([^:]+):([^:]+):([^:]+):(.*)$/) {
			my ($col, $icon, $href, $text) = ($1, $2, $3, $self->ztl_get_jointext($apps, $4));
			push(@menu, {'col' => $col, 'icon' => $icon, 'href' => $href, 'text' => $text}) if $text;
		}
	}
	if (@menu) {
		$self->print_icons_menu($title, \@menu);
	}
	print "<hr>\n";
}

# &print_icons_menu(\@items);
sub print_icons_menu {
	my $self = shift;

	local $icon_size = 24;
	local $title = shift(@_);
	local $items = shift(@_);
	# separating of items using their columns numbers
	local @columns = ();
	foreach my $i (@{$items}) {
		my $c = $i->{'col'};
		@columns[$c - 1] = [] unless @columns[$c - 1];
		push(@{@columns[$c - 1]}, $i);
	}
	local $max = 0;
	foreach my $c (@columns) {
		if (scalar(@{$c}) > $max) {$max = scalar(@{$c})}
	}
	local $cols = scalar(@columns);
	local $width = int(100 / $cols);
	print "<table cellspacing=0 cellpadding=5 width='100%' class=contframe>\n";
	print "<tr class=conttitle><td colspan=$cols width=100%>$title</td></tr>";
	foreach $idx (0 .. $max - 1) {
		print "<tr>\n";
		foreach my $c (@columns) {
			my $item = $c->[$idx];
			unless ($item) {
				print "<td>&nbsp;</td>\n";
			}
			else {
				my $href = $item->{'href'};
				print "<td width='$width%' align=left nowrap>";
				print "<a class=homeimg href='$href'><img src='images/$item->{'icon'}' border=0 width=$icon_size height=$icon_size></a>" if ($item->{'icon'});
				print "<a class=hometxt href='$href'>$item->{'text'}</a></td>\n";
			}
		}
		print "</tr>\n";
	}
	print "</table>\n";
}


1;

