do '../web-lib.pl';
&init_config();
#require '../common-lib.pl';
require '../ui-lib.pl';

# return system uptime
sub get_uptime {
	if ( -e '/usr/bin/uptime') {
		my $uptime = `/usr/bin/uptime`;
		$uptime =~ m/up\s+(.*?),[^,]*?user/i;
		( $uptime = $1 ) =~ tr/,//d;
		return $uptime;
	}
	return '';
}

# get_mime(\%mime)
sub get_mime {
	open(MIME, "$root_directory/mime.types");
	while (<MIME>) {
		s/\n|\r//g;
		s/#.*$//g;
		my @s = split(/\s+/);
		if (@s) {
			my $k = shift @s;
			push(@{$_[0]->{$k}}, @s);
		}
	}
	close(MIME);
}

# apache_avail_directives($context, \%avail)
# Displays up to 18 icons, one for each type of configuration directive, for
# some context (global, virtual, directory or htaccess)
sub apache_avail_directives {
local($m, $func, $e, %etype, $i, $c);
&foreign_require('apache', 'apache-lib.pl');
foreach $m (sort { $a cmp $b } (keys %apache::httpd_modules)) {
	$func = $m . "_directives";
	foreach $e (&foreign_call('apache', $func, $apache::httpd_modules{$m})) {
		if ($e->{$_[0]}) { $_[1]->{$e->{'type'}}++; }
	}
}
#map {print "$_<br>"} keys(%etype);
#print "<br>";
}

# check_email_address($email);
sub check_email_address {
	return ($_[0] =~ /^[a-z0-9._-]+@([a-z0-9_-]+\.)+(com|net|org|mil|edu|gov|arpa|info|inc|biz|name|[a-z]{2})$/i) ? 1 : 0;
}

# work out apache directives
# extmap_input(directive, title, size, desc, list)
sub extmap_input_home
{
local($rv, $i, $type, $exts);
$rv = "<table border>\n".
      "<tr $tb> <td><b>$_[1]</b></td> <td><b>$mtext{'mod_mime_ext'}</b></td></tr>\n";
$len = scalar(@{$_[4]}) + 1; #int(@{$_[4]}/2)*2 + 2;
for($i=0; $i<$len; $i++) {
	$rv .= "<tr $cb>\n";
	if ($_[4]->[$i]) {
		$_[4]->[$i]->{'value'} =~ /^(\S+)\s*(.*)$/;
		$type = $1; $exts = $2;
		}
	else { $type = $exts = ""; }
	$rv .= "<td>";
	if ($_[2] eq "handler") {
		$rv .= &apache::handler_input($type, "$_[0]_type_$i");
	}
	elsif ($_[2] eq "mime") {
		$rv .= &get_mime_select($type, "$_[0]_type_$i");
	}
	else {
		$rv .= "<input name=$_[0]_type_$i size=$_[2] value=$type>";
	}
	$rv .= "</td>\n";
	$rv .= "<td><input name=$_[0]_exts_$i size=10 value=\"$exts\"></td>\n";
	$rv .= "</tr>\n";
	}
$rv .= "</table>\n";
return (2, $_[3], $rv);
}

sub edit_AddType_home {
	&extmap_input_home("AddType", $mtext{'mod_mime_type'}, "", $text{'apache_mime'}, $_[0]);
}

sub edit_AddHandler_home {
	&extmap_input_home("AddHandler", $mtext{'mod_mime_handler'}, "handler", $text{'apache_handler'}, $_[0]);
}

# Error handling directives
sub edit_ErrorDocument_home {
local($rv, $len, $i);
$rv = "<table border width=100%>\n";
$rv .= "<tr $tb> <td><b>$mtext{'core_error'}</b></td> <td><b>$mtext{'core_resp'}</b></td> ".
       "<td><b>$mtext{'core_urlmsg'}</b></td> </tr>\n";
$len = @{$_[0]} + 1;
for($i=0; $i<$len; $i++) {
	$v = $_[0]->[$i]->{'value'};
	if ($v =~ /^(\d+)\s+((http|ftp|gopher):\S+)$/)
		{ $code = $1; $type = 0; $url = $2; }
	elsif ($v =~ /^(\d+)\s+(\/.*)$/) { $code = $1; $type = 0; $url = $2; }
	elsif ($v =~ /^(\d+)\s+"(.*)"$/) { $code = $1; $type = 1; $url = $2; }
	elsif ($v =~ /^(\d+)\s+"?(.*)$/) { $code = $1; $type = 1; $url = $2; }
	else { $code = ""; $type = 0; $url = ""; }
	$rv .= "<tr $cb>\n";
	$rv .= "<td><input name=ErrorDocument_code_$i size=3 value=$code></td>\n";
	$rv .= "<td><input type=radio name=ErrorDocument_type_$i value=0 ".
	       ($type==0 ? "checked" : "").">$mtext{'core_tourl'}\n";
	$rv .= "<input type=radio name=ErrorDocument_type_$i value=1 ".
	       ($type==1 ? "checked" : "").">$mtext{'core_mesg'}</td>\n";
	$rv .= "<td><input name=ErrorDocument_url_$i size=40 value=\"$url\"></td>\n";
	$rv .= "</tr>\n";
	}
$rv .= "</table>\n";
return (2, $mtext{'core_custom'}, $rv);
}

# -------- SSL -----
sub edit_SSLEngine_home {
return (1, $mtext{'mod_ssl_enable'},
	&apache::choice_input($_[0]->{'value'}, "SSLEngine", "",
	      "$mtext{'yes'},on", "$mtext{'no'},off", "$mtext{'default'},"));
}

sub edit_SSLProtocol_home {
local ($rv, $p, %prot);
local @list = $_[0] ? @{$_[0]->{'words'}} : ("all");
foreach $p (@list) {
	if ($p =~ /^\+?all$/i) { map { $prot{lc($_)} = 1 } @apache::sslprotos; }
	elsif ($p =~ /^\-all$/i) { undef(%prot); }
	elsif ($p =~ /^\-(\S+)/) { $prot{lc($1)} = 0; }
	elsif ($p =~ /^\+(\S+)/) { $prot{lc($1)} = 1; }
	}
foreach $p (@apache::sslprotos) {
	$rv .= sprintf "<input type=checkbox name=SSLProtocol value=$p %s> $p ",
		$prot{lc($p)} ? "checked" : "";
	}
return (1, $mtext{'mod_ssl_proto'}, $rv);
}

sub edit_SSLCertificateFile_home {
return (1, $mtext{'mod_ssl_cfile'},
	#"<b>$mtext{'mod_ssl_cfile'}</b>" .
	&apache::opt_input($_[0]->{'value'}, "SSLCertificateFile", $mtext{'mod_ssl_default'}, 35).
	&file_chooser_button("SSLCertificateFile", 0));
}

sub edit_SSLCertificateKeyFile_home {
return (1, $mtext{'mod_ssl_kfile'},
	#"<b>$mtext{'mod_ssl_kfile'}</b>" .
	&apache::opt_input($_[0]->{'value'}, "SSLCertificateKeyFile", $mtext{'mod_ssl_default'}, 35).
	&file_chooser_button("SSLCertificateKeyFile", 0));
}

sub edit_SSLVerifyClient_home {
return (1, $mtext{'mod_ssl_clcert'},
	&apache::select_input($_[0]->{'value'}, "SSLVerifyClient", "",
		      "$mtext{'default'},", "$mtext{'mod_ssl_nreq'},none",
		      "$mtext{'mod_ssl_opt'},optional",
		      "$mtext{'mod_ssl_req'},require",
		      "$mtext{'mod_ssl_optca'},optional_no_ca"));
}

sub edit_SSLVerifyDepth_home {
return (1, $mtext{'mod_ssl_cdepth'},
	&apache::opt_input($_[0]->{'value'}, "SSLVerifyDepth", $mtext{'mod_ssl_default'}, 6));
}

sub edit_SSLLog_home {
return (1, $mtext{'mod_ssl_log'},
	&apache::opt_input($_[0]->{'value'}, "SSLLog", $mtext{'mod_ssl_default'}, 20));
}

sub edit_SSLRequireSSL_home {
return (1, $mtext{'mod_ssl_onlyssl'},
	&apache::choice_input($_[0] ? 1 : 0, "SSLRequireSSL", 0, "$mtext{'yes'},1", "$mtext{'no'},0"));
}


# ----------- ServerAlias -------------
sub edit_ServerAlias_home {
local($a, @al);
foreach $a (@{$_[0]}) { push(@al, split(/\s+/, $a->{'value'})); }
return (1, $text{'apache_serveralias_alt'},
	sprintf "<textarea name=ServerAlias rows=3 cols=25>%s</textarea>\n",
		join("\n", @al) );
}

sub edit_Redirect_home {
if ($_[1]->{'version'} >= 1.2) {
	return &alias_status_input_home($_[0], "Redirect", $mtext{'mod_alias_redir'});
	}
else { return &alias_input_home($_[0], "Redirect", $mtext{'mod_alias_redir'}); }
}

# alias_status_input(array, name, title)
sub alias_status_input_home {
local($rv, $len, $i, $from, $to, $stat);
$rv = "<table border>\n".
                "<tr $tb> <td><b>$text{'apache_redir_src'}</b></td>".
                #"<td><b>$mtext{'mod_alias_status'}</b></td>".
                "<td><b>$text{'apache_redir_dest'}</b></td> </tr>\n";
$len = @{$_[0]} + 1;
for($i=0; $i<$len; $i++) {
        if ($_[0]->[$i]->{'words'}->[0] =~ /^(permanent|temp|seeother|gone|\d+)$/) {
                $stat = $_[0]->[$i]->{'words'}->[0];
                $from = $_[0]->[$i]->{'words'}->[1];
                $to = $_[0]->[$i]->{'words'}->[2];
                if ($apache::alias_statmap{$stat}) { $stat = $apache::alias_statmap{$stat}; }
                }
        else {
                $stat = "";
                $from = $_[0]->[$i]->{'words'}->[0];
                $to = $_[0]->[$i]->{'words'}->[1];
                }
        $rv .= "<tr $cb>\n";
        $rv .= "<td><input name=$_[1]_from_$i size=20 value=\"$from\"></td>\n";
        #$rv .= "<td><input name=$_[1]_stat_$i size=4 value=\"$stat\"></td>\n";
        $rv .= "<td><input name=$_[1]_to_$i size=40 value=\"$to\"></td>\n";
        $rv .= "</tr>\n";
        }
$rv .= "</table>\n";
return (2, $_[2], $rv);
}

sub get_countries_info {
	local (@a, @list);
	open (TAB, 'countries.info' );
	while(<TAB>) {
		@a= split(/=/, $_);
		chomp ($a[1]);
		push (@list, {'CC' => $a[0],  'country'=> $a[1] } );
	}
	close (TAB);
	return (@list)
}

sub get_state_info {
	local (@a, @list);
	open (TAB, 'states_and_provinces.info' );
	while(<TAB>) {
		@a= split(/=/, $_);
		chomp ($a[1]);
		push (@list, {'CC' => $a[0],  'state'=> $a[1] } );
	}
	close (TAB);
	return (@list)
}

# --- ZTL specific functions ---
# &print_menu(\%apps, $file);
# %apps - appliances' hash
# $file - menu file name
sub print_menu {
	local $apps = shift(@_);
	local $file = shift(@_);
	local (%m_data, @m_order, @menu);
	&read_file($file, \%m_data, \@m_order);
	local $title = &ztl_get_jointext($apps, $m_data{'title'});
	delete($m_data{'title'});
	#local $title = $m_data{'title'};
	return unless $title;
	foreach my $k (@m_order) {
		next if $m_data{$k} =~ /^#/ || !$m_data{$k};
		# expected format: "col:icon:href:text_formatted_string"
		if ($m_data{$k} =~ /^([^:]+):([^:]+):([^:]+):(.*)$/) {
			my ($col, $icon, $href, $text) = ($1, $2, $3, &ztl_get_jointext($apps, $4));
			push(@menu, {'col' => $col, 'icon' => $icon, 'href' => $href, 'text' => $text}) if $text;
		}
	}
	if (@menu) {
		&print_icons_menu($title, \@menu);
	}
	print "<hr>\n";
}

# &print_icons_menu(\@items);
sub print_icons_menu {
	local $icon_size = 24;
	local $title = shift(@_);
	local $items = shift(@_);
	# separating of items using their columns numbers
	local @columns = ();
	foreach my $i (@{$items}) {
		my $c = $i->{'col'};
		@columns[$c - 1] = [] unless @columns[$c - 1];
		push(@{@columns[$c - 1]}, $i);
	}
	local $max = 0;
	foreach my $c (@columns) {
		if (scalar(@{$c}) > $max) {$max = scalar(@{$c})}
	}
	local $cols = scalar(@columns);
	local $width = int(100 / $cols);
	print "<table cellspacing=0 cellpadding=5 width='100%' class=contframe>\n";
	print "<tr class=conttitle><td colspan=$cols width=100%>$title</td></tr>";
	foreach $idx (0 .. $max - 1) {
		print "<tr>\n";
		foreach my $c (@columns) {
			my $item = $c->[$idx];
			unless ($item) {
				print "<td>&nbsp;</td>\n";
			}
			else {
				my $href = $item->{'href'};
				print "<td width='$width%' align=left nowrap>";
				print "<a class=homeimg href='$href'><img src='images/$item->{'icon'}' border=0 width=$icon_size height=$icon_size></a>" if ($item->{'icon'});
				print "<a class=hometxt href='$href'>$item->{'text'}</a></td>\n";
			}
		}
		print "</tr>\n";
	}
	print "</table>\n";
}

1;
1;
