#!/usr/bin/perl
package hpuxexports::ExportsLib;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'hpuxexports::ExportsLib');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# export-lib.pl
# Common functions for exports file

&ModuleLoader::preload_module(ref($self), "WebLib");
$self = new WebLib:: ref($self), %$self; 
$self->init_config();
&ModuleLoader::preload_module(ref($self), "UiLib");
$self = new UiLib:: ref($self), %$self; 
&ModuleLoader::preload_module(ref($self), "hpuxexports::HpuxLib");
$self = new hpuxexports::HpuxLib:: ref($self), %$self; 
%{$self->{'access_hash'}} = $self->get_module_acl();

1;

1;
		return $self;
}

# parse_options($options, \%options)
# Parse a mount options string like rw=foo,nosuid,... into a associative
# options array. Parts with no value are given an empty string as the value
# usefull for HPUX and DFS - perhaps for linux, too
sub parse_options
{
	my $self = shift;

local($opt);
foreach $opt (split(/,/, $_[0])) {
        if ($opt =~ /^([^=]+)=(.*)$/) {
                $_[1]->{$1} = $2;
                }
        else {
                $_[1]->{$opt} = "";
                }
        }
}

# join_options(\%options)
# Returns a list of options from a options array, in the form used in
# the exports file
# usefull for HPUX and DFS - perhaps for linux, too
sub join_options
{
	my $self = shift;

local $o = $_[0];
local(@list, $k);
foreach $k (keys %$o) {
        if ($_[0]->{$k} eq "") {
                push(@list, $k);
                }
        else {
                push(@list, "$k=$_[0]->{$k}");
                }
        }
return join(',', @list);
}

# create_export(&export)
sub create_export
{
	my $self = shift;

open(EXP, ">>$self->{'config_hash'}->{'exports_file'}");
print EXP $self->make_exports_line($_[0]),"\n";
close(EXP);
}

# modify_export(&export, &old)
sub modify_export
{
	my $self = shift;

local @exps = $self->list_exports();
local @same = grep { $_->{'line'} eq $_[1]->{'line'} } @exps;
local $lref = $self->read_file_lines($self->{'config_hash'}->{'exports_file'});
if ($_[0]->{'dir'} eq $_[1]->{'dir'} &&
    $_[0]->{'active'} == $_[1]->{'active'} || @same == 1) {
        # directory not changed, or on a line of it's own
        splice(@same, $self->indexof($_[1],@same), 1, $_[0]);
        splice(@$lref, $_[1]->{'line'}, $_[1]->{'eline'}-$_[1]->{'line'}+1,
               $self->make_exports_line(@same));
        }
else {
        # move to a line of it's own
        splice(@same, $self->indexof($_[1],@same), 1);
        splice(@$lref, $_[1]->{'line'}, $_[1]->{'eline'}-$_[1]->{'line'}+1,
               $self->make_exports_line(@same));
        push(@$lref, $self->make_exports_line($_[0]));
        }
$self->flush_file_lines();
}

# delete_export(&export)
# Delete an existing export
sub delete_export
{
	my $self = shift;

local @exps = $self->list_exports();
local @same = grep { $_ ne $_[0] && $_->{'line'} eq $_[0]->{'line'} } @exps;
local $lref = $self->read_file_lines($self->{'config_hash'}->{'exports_file'});
if (@same) {
        # other exports on the same line.. cannot totally delete
        splice(@$lref, $_[0]->{'line'}, $_[0]->{'eline'}-$_[0]->{'line'}+1,
               $self->make_exports_line(@same));
        map { $_->{'line'} = $_->{'eline'} = $_[0]->{'line'} } @same;
        }
else {
        # remove export line
        splice(@$lref, $_[0]->{'line'}, $_[0]->{'eline'}-$_[0]->{'line'}+1);
        }
@{$self->{'list_exports_cache_array'}} = grep { $_ ne $_[0] } @{$self->{'list_exports_cache_array'}};
$self->flush_file_lines();
}

# check_hosts(option, hostlist)
# Die if any of the listed hosts does not exist
# or no hosts listed for specified option
sub check_hosts
{
	my $self = shift;

local @h = split(/\s+/, $_[1]);

if (!@h) {
        $self->error($self->text('save_enohost', $_[0]));
        }

foreach (@h) {
        if (!$self->inet_aton($_)) { $self->error($self->text('save_ehost', $_, $_[0])); }
        }
}

sub has_nfs_commands
{
	my $self = shift;

return !$self->has_command("rpc.nfsd") && !$self->has_command("nfsd") &&
       !$self->has_command("rpc.knfsd") ? 0 : 1;
}


1;

