#!/usr/bin/perl
package hpuxexports::HpuxLib;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'hpuxexports::HpuxLib');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# hpux-lib.pl
# Functions for HPUX exports files

1;

1;
		return $self;
}

# list_exports()
# Return a list of all the directories currently being exported
sub list_exports
{
	my $self = shift;

local (@rv, $pos, $lnum, $h, $o, $line);
return @{$self->{'list_exports_cache_array'}} if (@{$self->{'list_exports_cache_array'}});
open(EXP, $self->{'config_hash'}->{'exports_file'});
$lnum = 0;
while($line = <EXP>) {
        local $slnum = $lnum;
        $line =~ s/\s+$//g;
        while($line =~ /\\$/) {
                # continuation character!
                $line =~ s/\\$//;
                $line .= <EXP>;
                $line =~ s/\s+$//g;
                $lnum++;
                }
        if ($line =~ /^(#*)\s*(\/\S*)\s+-(.*)$/) {
                local %exp;
                $exp{'active'} = !$1;
                $exp{'dir'} = $2;
		# 'host' includes the hole option string!
		# for describe_host needed, only
                $exp{'host'} = $3;
		$self->parse_options($3, $exp{'options'});
                $exp{'line'} = $slnum;
                $exp{'eline'} = $lnum;
		$exp{'pos'} = $pos++;
                $exp{'index'} = scalar(@rv);
                push(@rv, \%exp);
                }
        $lnum++;
        }
close(EXP);
@{$self->{'list_exports_cache_array'}} = @rv;
return @{$self->{'list_exports_cache_array'}};
}

# make_exports_line([&export]+)
sub make_exports_line
{
	my $self = shift;

local ($options, $line);
$options = $self->join_options($_[0]->{'options'});
$line = ($_[0]->{'active'} ? "" : "#").$_[0]->{'dir'};
$line .= ($options ? " -".$options : "");
return $line;
}

# describe_host(host)
# Given a host option string return a human-readable version
sub describe_host
{
	my $self = shift;

local ($desc, %options);
$self->parse_options($_[0], \%options);
if (defined($options{"ro"}) && $options{"access"} ne "") {
	$desc = $self->{'text_hash'}->{'index_sel_ro'};
	}
elsif (defined($options{"ro"}) && !defined($options{"access"})) {
	$desc = $self->{'text_hash'}->{'index_all_ro'};
	}
elsif ($options{"rw"} ne "") {
	$desc = $self->{'text_hash'}->{'index_ro_rw'};
	}
elsif (!defined($options{"ro"}) && $options{"access"} ne "") {
	$desc = $self->{'text_hash'}->{'index_sel_rw'};
	}
elsif (!defined($options{"ro"}) && !defined($options{"rw"}) && !defined($options{"access"})) {
	$desc = $self->{'text_hash'}->{'index_all_rw'};
	}
if ($options{"root"} ne "") {
	$desc .= ", ";
	$desc .= $self->{'text_hash'}->{'index_sel_root'};
	}
return $desc;
}

# more_detail_fields()
sub more_detail_fields
{
	my $self = shift;

print " <td><b>", $self->hlink($self->{'text_hash'}->{'edit_async'}, "async"), "</b></td>\n";
printf "<td nowrap><input type=radio name=async value=1 %s> %s\n",
        defined($self->{'opts_hash'}->{"async"}) ? "checked" : "", $self->{'text_hash'}->{'yes'};
printf "<input type=radio name=nfs_bg value=0 %s> %s</td> </tr>\n",
        defined($self->{'opts_hash'}->{"async"}) ? "" : "checked", $self->{'text_hash'}->{'no'};
}

# security_fields()
sub security_fields
{
	my $self = shift;

print "<tr $self->{'cb'}>\n";
print " <td><b>", $self->hlink($self->{'text_hash'}->{'edit_user_access'}, "user_access"), "</b></td>\n";
print " <td><b>", $self->hlink($self->{'text_hash'}->{'edit_root_access'}, "root_access"), "</b></td>\n";
print " <td><b>", $self->hlink($self->{'text_hash'}->{'edit_anon_access'}, "anon"), "</b></td>\n";
print "</tr>\n";

$self->{'fn'} = "<font size=-1>"; $self->{'efn'} = "</font>";
print "<tr $self->{'cb'}>\n";
printf " <td><input type=radio name=user value=1 %s> $self->{'text_hash'}->{'edit_sel_ro'}<br>\n",
        defined($self->{'opts_hash'}->{"ro"}) && $self->{'opts_hash'}->{"access"} ne "" ? "checked" : "";
printf "<input type=radio name=user value=2 %s> $self->{'text_hash'}->{'edit_all_ro'}<br>\n",
        defined($self->{'opts_hash'}->{"ro"}) && !defined($self->{'opts_hash'}->{"access"}) ? "checked" : "";
printf "<input type=radio name=user value=3 %s> $self->{'text_hash'}->{'edit_ro_rw'}<br>\n",
        $self->{'opts_hash'}->{"rw"} ne "" ? "checked" : "";
printf "<input type=radio name=user value=4 %s> $self->{'text_hash'}->{'edit_sel_rw'}<br>\n",
        !defined($self->{'opts_hash'}->{"ro"}) && $self->{'opts_hash'}->{"access"} ne "" ? "checked" : "";
printf "<input type=radio name=user value=5 %s> $self->{'text_hash'}->{'edit_all_rw'}<br>\n",
        !defined($self->{'opts_hash'}->{"ro"}) && !defined($self->{'opts_hash'}->{"rw"}) && !defined($self->{'opts_hash'}->{"access"}) ? "checked" : "";
print " </td>\n";
printf " <td><input type=radio name=root value=1 %s> $self->{'text_hash'}->{'edit_none'}<br>\n",
        defined($self->{'opts_hash'}->{"root"}) ? "" : "checked";
print "<br>";
print "<br>";
print "<br>";
printf "<input type=radio name=root value=2 %s> $self->{'text_hash'}->{'edit_sel_hosts'}<br>\n",
        $self->{'opts_hash'}->{"root"} ne "" ? "checked" : "";
print " </td>\n";
print " <td>\n";
if ($self->{'in_hash'}->{'new'}) { $self->{'opts_hash'}->{"anon"} = getpwnam("nobody"); }
printf "<input type=radio name=anon value=1 %s> $self->{'text_hash'}->{'edit_anon_noaccess'}<br>\n",
	$self->{'opts_hash'}->{"anon"} == -1 ? "checked" : "";
if (defined($self->{'opts_hash'}->{"anon"}) && $self->{'opts_hash'}->{"anon"} != -1) {
	$self->{'anonuser'} = getpwuid($self->{'opts_hash'}->{'anon'}) ?
		getpwuid($self->{'opts_hash'}->{'anon'}) : $self->{'opts_hash'}->{'anon'};
	}
printf "<input type=radio name=anon value=2 %s>\n",
	$self->{'opts_hash'}->{"anon"} != -1 ? "checked" : "";
print "<input name=anonnam size=8 value=\"$self->{'anonuser'}\"> ",
	$self->user_chooser_button("anonnam", 0),"\n";   
print "<br>";
print "<br>";
print "<br>";
print "<br>";
print " </td>\n";
print "</tr>\n";

print "<tr $self->{'cb'}>\n";
print " <td>$self->{'fn'}<textarea name=ualist rows=6 cols=40 >";
        if ($self->{'opts_hash'}->{"rw"} ne "") {
                $self->{'list'} = join("\n", split(/:/, $self->{'opts_hash'}->{"rw"}));
                }
        if ($self->{'opts_hash'}->{"access"} ne "") {
                $self->{'list'} = join("\n", split(/:/, $self->{'opts_hash'}->{"access"}));
                }
        print $self->{'list'};
print "</textarea>$self->{'efn'}</td>\n";
printf " <td>$self->{'fn'}<textarea name=rtlist rows=6 cols=40 >%s</textarea>$self->{'efn'}</td>\n",
        join("\n", split(/:/, $self->{'opts_hash'}->{"root"}));
print "</tr>\n";
}

# check_inputs()
sub check_inputs
{
	my $self = shift;

if ($self->{'in_hash'}->{user} == 1 || $self->{'in_hash'}->{user} == 3 || $self->{'in_hash'}->{user} == 4) {
	$self->check_hosts($self->{'text_hash'}->{'edit_user_access'}, $self->{'in_hash'}->{ualist});
        @{$self->{'ualist_array'}} = split(/\s+/, $self->{'in_hash'}->{ualist});
        }
if ($self->{'in_hash'}->{root} == 2) {
	$self->check_hosts($self->{'text_hash'}->{'edit_root_access'}, $self->{'in_hash'}->{rtlist});
	@{$self->{'rtlist_array'}} = split(/\s+/, $self->{'in_hash'}->{rtlist});
        }

# Remove from the root list any hosts which not in the user list as well
if (($self->{'in_hash'}->{user} == 1 || $self->{'in_hash'}->{user} == 3 || $self->{'in_hash'}->{user} == 4) && $self->{'in_hash'}->{root} == 2) {
        @{$self->{'tmplist_array'}} = @{$self->{'rtlist_array'}};
        foreach $rth (@{$self->{'tmplist_array'}}) {
                if (($self->{'idx'} = $self->indexof($rth, @{$self->{'ualist_array'}})) == -1) {
                        splice(@{$self->{'rtlist_array'}}, $self->indexof($rth, @{$self->{'rtlist_array'}}), 1);
                        }
                }
        if (@{$self->{'rtlist_array'}} == 0) {
                $self->{'in_hash'}->{root} = 1;
                }
        }
}

# set_options()
# Fill in the options associative array
sub set_options
{
	my $self = shift;

delete($self->{'opts_hash'}->{"ro"});
delete($self->{'opts_hash'}->{"rw"});
delete($self->{'opts_hash'}->{"access"});
if ($self->{'in_hash'}->{user} == 1) { $self->{'opts_hash'}->{"ro"} = ""; $self->{'opts_hash'}->{"access"} = join(':', @{$self->{'ualist_array'}}); }
elsif ($self->{'in_hash'}->{user} == 2) { $self->{'opts_hash'}->{"ro"} = ""; }
elsif ($self->{'in_hash'}->{user} == 3) { $self->{'opts_hash'}->{"rw"} = join(':', @{$self->{'ualist_array'}}); }
elsif ($self->{'in_hash'}->{user} == 4) { $self->{'opts_hash'}->{"access"} = join(':', @{$self->{'ualist_array'}}); }
elsif ($self->{'in_hash'}->{user} == 5) { ; }

if ($self->{'in_hash'}->{root} == 1) { delete($self->{'opts_hash'}->{"root"}); }
elsif ($self->{'in_hash'}->{root} == 2) { $self->{'opts_hash'}->{"root"} = join(':', @{$self->{'rtlist_array'}}); }

if ($self->{'in_hash'}->{async} == 1) { $self->{'opts_hash'}->{"async"} = ""; }
else { delete($self->{'opts_hash'}->{"async"}); }

if ($self->{'in_hash'}->{'anon'} == 1) { $self->{'opts_hash'}->{"anon"} = -1; }
elsif ($self->{'in_hash'}->{'anonnam'} =~ /^[0-9\-]+$/)
	{ $self->{'opts_hash'}->{"anon"} = $self->{'in_hash'}->{"anonnam"}; }
elsif (getpwnam($self->{'in_hash'}->{"anonnam"})) 
	{ $self->{'opts_hash'}->{"anon"} = getpwnam($self->{'in_hash'}->{"anonnam"}); }
else { $self->{'opts_hash'}->{"anon"} = -1; }
}


1;

