#!/usr/bin/perl
package hpuxexports::HpuxexportsLib;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'hpuxexports::HpuxexportsLib');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# hpuxexports-lib.pl
# Common functions for managing exports files

&ModuleLoader::preload_module(ref($self), "WebLib");
$self = new WebLib:: ref($self), %$self; 
$self->init_config();
&ModuleLoader::preload_module(ref($self), "UiLib");
$self = new UiLib:: ref($self), %$self; 

1;

1;
		return $self;
}

# list_exports()
# Return a list of all the directories currently being exported
sub list_exports
{
	my $self = shift;

local(@rv);
open(EXP, $self->{'config_hash'}->{exports_file});
while(<EXP>) {
	chop; s/#.*//g;
	if (!/\S/) { next; }
	/(\/\S*)\s*/; push(@rv, $1);
	}
close(EXP);
return @rv;
}

# get_exports(directory)
# Return an array containing the following for some directory
#  directory, options
sub get_exports
{
	my $self = shift;

local(@rv);
open(EXP, $self->{'config_hash'}->{exports_file});
while(<EXP>) {
	chop; s/#.*//g;
	if (!/\S/) { next; }
	if (/(\/\S*)\s+-(.*)/ && $1 eq $_[0]) {
		# found matching exports with options
		$rv[0] = $1;
                $rv[1] = $2;
		}
	elsif (/(\/\S*)\s+-(.*)/ && $1 eq $_[0]) {
		# found matching exports with options
		$rv[0] = $1;
                $rv[1] = $2;
		}
	}
close(EXP);
return @rv;
}

# create_export(directory, options)
# Add a new exports to the exports file
sub create_export
{
	my $self = shift;

$self->open_tempfile(EXP, ">> $self->{'config_hash'}->{exports_file}");
$self->print_tempfile(EXP, "$_[0] ");
if ($_[1]) { $self->print_tempfile(EXP, "-$_[1]\n"); };
$self->close_tempfile(EXP);
}

# modify_export(old_directory, directory, options)
# Modify an existing exports
sub modify_export
{
	my $self = shift;

local(@exp);
open(EXP, $self->{'config_hash'}->{exports_file});
@exp = <EXP>;
close(EXP);
$self->open_tempfile(EXP, "> $self->{'config_hash'}->{exports_file}");
foreach (@exp) {
	chop; ($self->{'line'} = $_) =~ s/#.*//g;
	if ($self->{'line'} =~ /(\/\S+)\s*/ && $1 eq $_[0]) {
		# found exports to change..
		/\s*(\S+)/;
		$self->print_tempfile(EXP, "$_[1] ");
		if ($_[2]) { $self->print_tempfile(EXP, "-$_[2]\n"); };
		}
	else {
		# leave this line alone
		$self->print_tempfile(EXP, "$_\n");
		}
	}
$self->close_tempfile(EXP);
}

# delete_export(directory)
# Delete the export for a particular directory
sub delete_export
{
	my $self = shift;

local(@exp);
open(EXP, $self->{'config_hash'}->{exports_file});
@exp = <EXP>;
close(EXP);
$self->open_tempfile(EXP, "> $self->{'config_hash'}->{exports_file}");
foreach (@exp) {
	chop; ($self->{'line'} = $_) =~ s/#.*//g;
	if ($self->{'line'} !~ /(\/\S+)\s*/ || $1 ne $_[0]) {
		# Leave this line alone
		$self->print_tempfile(EXP, "$_\n");
		}
	}
$self->close_tempfile(EXP);
}

# parse_options(string)
# Parse a mount options string like rw=foo,nosuid,... into the associative
# array %{$self->{'options_hash'}}. Parts with no value are given an empty string as the value
sub parse_options
{
	my $self = shift;

local($opt);
undef(%{$self->{'options_hash'}});
foreach $opt (split(/,/, $_[0])) {
	if ($opt =~ /^([^=]+)=(.*)$/) {
		$self->{'options_hash'}->{$1} = $2;
		}
	else {
		$self->{'options_hash'}->{$opt} = "";
		}
	}
}

# join_options()
# Returns a list of options from the %{$self->{'options_hash'}} array, in the form used in
# the exports file
sub join_options
{
	my $self = shift;

local(@list, $k);
foreach $k (keys %{$self->{'options_hash'}}) {
	if ($self->{'options_hash'}->{$k} eq "") {
		push(@list, $k);
		}
	else {
		push(@list, "$k=$self->{'options_hash'}->{$k}");
		}
	}
return join(',', @list);
}


1;

