#!/usr/bin/perl
package htaccess_htpasswd::Useradmin_update;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'htaccess_htpasswd::Useradmin_update');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;

&ModuleLoader::preload_module(ref($self), "htaccess_htpasswd::HtaccessLib");
$self = new htaccess_htpasswd::HtaccessLib:: ref($self), %$self; 

1;
		return $self;
}

sub useradmin_create_user
{
	my $self = shift;

foreach $dir ($self->list_directories()) {
	next if ($dir->[3] !~ /create/);
	local $users = $self->list_users($dir->[1]);
	local ($clash) = grep { $_->{'user'} eq $_[0]->{'user'} } @$users;
	return if ($clash);
	$self->lock_file($dir->[1]);
	local $user = { 'user' => $_[0]->{'user'},
			'enabled' => 1 };
	if ($_[0]->{'passmode'} == 0) {
		$user->{'pass'} = "";
		}
	elsif ($_[0]->{'passmode'} == 1) {
		$user->{'pass'} = "*LK*";
		}
	elsif ($_[0]->{'passmode'} == 2) {
		$user->{'pass'} = $_[0]->{'pass'};
		}
	else {
		$user->{'pass'} = $self->encrypt_password($_[0]->{'plainpass'},
						    undef, $self->{'config_hash'}->{'md5'});
		}
	$self->create_user($user, $dir->[1]);
	$self->unlock_file($dir->[1]);
	}
}

sub useradmin_modify_user
{
	my $self = shift;

foreach $dir ($self->list_directories()) {
	next if ($dir->[3] !~ /update/);
	local $users = $self->list_users($dir->[1]);
	local ($user) = grep { $_->{'user'} eq $_[0]->{'olduser'} } @$users;
	return if (!$user);
	$self->lock_file($dir->[1]);
	$user->{'user'} = $_[0]->{'user'};
	if ($_[0]->{'passmode'} == 0) {
		$user->{'pass'} = "";
		}
	elsif ($_[0]->{'passmode'} == 1) {
		$user->{'pass'} = "*LK*";
		}
	elsif ($_[0]->{'passmode'} == 2) {
		$user->{'pass'} = $_[0]->{'pass'};
		}
	elsif ($_[0]->{'passmode'} == 3) {
		$user->{'pass'} = $self->encrypt_password($_[0]->{'plainpass'},
						    undef, $self->{'config_hash'}->{'md5'});
		}
	$self->modify_user($user);
	$self->unlock_file($dir->[1]);
	}
}

sub useradmin_delete_user
{
	my $self = shift;

foreach $dir ($self->list_directories()) {
	next if ($dir->[3] !~ /update/);
	local $users = $self->list_users($dir->[1]);
	local ($user) = grep { $_->{'user'} eq $_[0]->{'user'} } @$users;
	return if (!$user);
	$self->lock_file($dir->[1]);
	$self->delete_user($user);
	$self->unlock_file($dir->[1]);
	}
}


1;

