#!/usr/bin/perl

&MAIN();

 sub MAIN {
# index.cgi
# Display a list of protected directories and their users. The user can
# add more directories, and specify the encryption mode for each.

&ModuleLoader::preload_module('htaccess_htpasswd_class', "htaccess_htpasswd::HtaccessLib");
$self = new htaccess_htpasswd::HtaccessLib:: 'htaccess_htpasswd_class',%$self;

$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", undef, 1, 1);

# Check needed Perl modules
if ($self->{'config_hash'}->{'md5'}) {
	$self->{'missing'} = $self->check_md5();
	if ($self->{'missing'}) {
		print $self->text('index_emd5', "<tt>$self->{'missing'}</tt>"),"\n";
		}
	}
if ($self->{'config_hash'}->{'sha1'} && !$self->{'missing'}) {
	$self->{'missing'} = $self->check_sha1();
	if ($self->{'missing'}) {
		print $self->text('index_sha1', "<tt>$self->{'missing'}</tt>"),"\n";
		}
	}
if ($self->{'missing'}) {
	if (!$self->{'module_info_hash'}->{'usermin'}) {
		print $self->text('index_cpan', "../cpan/download.cgi?source=3&cpan=$self->{'missing'}&mode=2&return=/$self->{'module_name'}/&returndesc=".$self->urlize($self->{'text_hash'}->{'index_return'}));
		}
	print "<p>\n";
	$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});
	exit;
	}

# Check for htdigest command
if ($self->{'config_hash'}->{'digest'} && !$self->{'htdigest_command'}) {
	print $self->text('index_digest', "<tt>htdigest</tt>"),"<p>\n";
	$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});
	exit;
	}

@{$self->{'accessdirs_array'}} || $self->error($self->{'text_hash'}->{'index_eaccess'});

@{$self->{'dirs_array'}} = $self->list_directories();
@{$self->{'dirs_array'}} = grep { $self->can_access_dir($_->[0]) } @{$self->{'dirs_array'}};
if (@{$self->{'dirs_array'}}) {
	@{$self->{'links_array'}} = ( $self->select_all_link("d"),
	   $self->select_invert_link("d"));
	print $self->ui_form_start("delete.cgi", "post");
	@{$self->{'tds_array'}} = ( "width=5", "width=30% valign=top", "width=70% valign=top" );
	print $self->ui_links_row(\@{$self->{'links_array'}});
	print $self->ui_columns_start([ "", $self->{'text_hash'}->{'index_dir'},
				  $self->{'text_hash'}->{'index_usersgroups'} ], 100, 0, \@{$self->{'tds_array'}});
	foreach $d (@{$self->{'dirs_array'}}) {
		local @cols;
		push(@cols, "<a href='edit_dir.cgi?dir=".
			    $self->urlize($d->[0])."'>$d->[0]</a>");

		# Show the users
		$self->{'utable'} = "<table width=100%>\n";
		$self->{'users'} = $d->[2] == 3 ? $self->list_digest_users($d->[1])
				      : $self->list_users($d->[1]);
		if ($self->{'userconfig_hash'}->{'sort'} == 1 || $self->{'config_hash'}->{'sort'} == 1) {
			$self->{'users'} = [ sort { $a->{'user'} cmp $b->{'user'} }
					@{$self->{'users'}} ];
			}
		for($i=0; $i<@{$self->{'users'}}; $i++) {
			$self->{'u'} = $self->{'users'}->[$i];
			$self->{'link'} = "<a href='edit_user.cgi?idx=$self->{'u'}->{'index'}&dir=".
				$self->urlize($d->[0])."'>$self->{'u'}->{'user'}</a>";
			$self->{'utable'} .= "<tr>\n" if ($i%4 == 0);
			if ($self->{'u'}->{'enabled'}) {
				$self->{'utable'} .= "<td width=25%>$self->{'link'}</td>\n";
				}
			else {
				$self->{'utable'} .= "<td width=25%><i>$self->{'link'}</i></td>\n";
				}
			$self->{'utable'} .= "</tr>\n" if ($i%4 == 3);
			}
		if ($i%4) {
			while($i++%4) { $self->{'utable'} .= "<td width=25%></td>\n"; }
			$self->{'utable'} .= "</tr>\n";
			}
		if (!@{$self->{'users'}}) {
			$self->{'utable'} .= "<tr> <td colspan=4><i>".
				   "$self->{'text_hash'}->{'index_nousers'}</i></td> </tr>\n";
			}
		$self->{'utable'} .= "</table>\n";

		# Show the groups
		if ($d->[4]) {
			$self->{'utable'} .= "<table width=100%>\n";
			$self->{'groups'} = $self->list_groups($d->[4]);
			if ($self->{'userconfig_hash'}->{'sort'} == 1 || $self->{'config_hash'}->{'sort'} == 1) {
				$self->{'groups'} = [ sort { $a->{'group'} cmp $b->{'group'} }
						@{$self->{'groups'}} ];
				}
			for($i=0; $i<@{$self->{'groups'}}; $i++) {
				$self->{'u'} = $self->{'groups'}->[$i];
				$self->{'link'}= "<a href='edit_group.cgi?idx=$self->{'u'}->{'index'}&dir=".
				       $self->urlize($d->[0])."'>$self->{'u'}->{'group'} (".
				       scalar(@{$self->{'u'}->{'members'}}).")</a>";
				$self->{'utable'} .= "<tr>\n" if ($i%4 == 0);
				if ($self->{'u'}->{'enabled'}) {
					$self->{'utable'} .= "<td width=25%>$self->{'link'}</td>\n";
					}
				else {
					$self->{'utable'} .= "<td width=25%><i>$self->{'link'}</i></td>\n";
					}
				$self->{'utable'} .= "</tr>\n" if ($i%4 == 3);
				}
			if ($i%4) {
				while($i++%4) { $self->{'utable'} .= "<td width=25%></td>\n"; }
				$self->{'utable'} .= "</tr>\n";
				}
			if (!@{$self->{'groups'}}) {
				$self->{'utable'} .= "<tr> <td colspan=4><i>$self->{'text_hash'}->{'index_nogroups'}</i></td> </tr>\n";
				}
			$self->{'utable'} .= "</table>\n";
			}

		# User / group adder links
		$self->{'utable'} .= "<a href='edit_user.cgi?new=1&dir=".$self->urlize($d->[0]).
			   "'>$self->{'text_hash'}->{'index_uadd'}</a>\n";
		if ($d->[4]) {
			$self->{'utable'} .= "&nbsp;&nbsp;";
			$self->{'utable'} .= "<a href='edit_group.cgi?new=1&dir=".
				 $self->urlize($d->[0])."'>$self->{'text_hash'}->{'index_gadd'}</a>\n";
			}
		push(@cols, $self->{'utable'});
		print $self->ui_checked_columns_row(\@cols, \@{$self->{'tds_array'}}, "d", $d->[0]);
		}
	print $self->ui_columns_end();
	print $self->ui_links_row(\@{$self->{'links_array'}});
	print $self->ui_form_end([ [ "delete", $self->{'text_hash'}->{'index_delete'} ] ]);
	}
else {
	print "<b>$self->{'text_hash'}->{'index_none'}</b><br>\n";
	}
print "<hr>\n";
print "<form action='edit_dir.cgi'>";
print "<input type=hidden name=new value=1>";
print "<input type=submit value=\'$self->{'text_hash'}->{'index_add'}\'>\n";
print "</form><p>\n";

# Form to find existing .htaccess files
print "<hr>\n";
print "<form action=search.cgi>\n";
print "<input type=submit value='$self->{'text_hash'}->{'index_search'}'>\n";
printf "<input name=search size=30 value='%s'> %s<br>\n",
	$self->{'accessdirs_array'}->[0] eq "/" ? "" : $self->{'accessdirs_array'}->[0],
	$self->file_chooser_button("search", 1);
print "</form>\n";

$self->ui_print_footer($self->{'text_hash'}->{'index_mainpage_url'}, $self->{'text_hash'}->{'index_mainpage'});
1;
		
}


1;

