#!/usr/bin/perl

&MAIN();

 sub MAIN {
# search.cgi
# Find .htaccess files under some directory

&ModuleLoader::preload_module('htaccess_htpasswd_class', "htaccess_htpasswd::HtaccessLib");
$self = new htaccess_htpasswd::HtaccessLib:: 'htaccess_htpasswd_class',%$self;

$self->foreign_require($self->{'apachemod'}, "apache-lib.pl");

$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'search_err'});
if ($self->{'in_hash'}->{'search'} !~ /^\// && $accessdirs[0] ne "/") {
	# Make path absolute
	$self->{'in_hash'}->{'search'} = "$accessdirs[0]/$self->{'in_hash'}->{'dir'}";
	}
$self->{'in_hash'}->{'search'} =~ /^\// && $self->{'in_hash'}->{'search'} !~ /\.\./ ||
	$self->error($self->{'text_hash'}->{'search_edir'});
$self->can_access_dir($self->{'in_hash'}->{'search'}) || $self->error($self->{'text_hash'}->{'search_ecannot'});

$self->ui_print_unbuffered_header(undef, $self->{'text_hash'}->{'search_title'}, "");

@{$self->{'dirs_array'}} = $self->list_directories();
%{$self->{'got_hash'}} = map { ( "$_->[0]/$self->{'config_hash'}->{'htaccess'}", 1 ) } @{$self->{'dirs_array'}};
print "<b>",$self->text('search_doing', "<tt>$self->{'in_hash'}->{'search'}</tt>"),"</b><p>\n";

# Use the find command
$self->switch_user();
open(FIND, "find ".quotemeta($self->{'in_hash'}->{'search'})." -name ".
	   quotemeta($self->{'config_hash'}->{'htaccess'})." -print 2>/dev/null |");
while($self->{'f'} = <FIND>) {
	chop($self->{'f'});
	if ($self->{'got_hash'}->{$self->{'f'}}) {
		print $self->text('search_already', "<tt>$self->{'f'}</tt>"),"<br>\n";
		}
	elsif (!open(TEST, $self->{'f'})) {
		print $self->text('search_open', "<tt>$self->{'f'}</tt>", $!),"<br>\n";
		}
	else {
		$self->{'conf'} = $self->foreign_call($self->{'apachemod'}, "get_htaccess_config", $self->{'f'});
		$self->{'currfile'} = $self->foreign_call($self->{'apachemod'}, "find_directive",
					  "AuthUserFile", $self->{'conf'}, 1);
		if ($self->{'currfile'}) {
			print $self->text('search_found', "<tt>$self->{'f'}</tt>",
				    "<tt>$self->{'currfile'}</tt>"),"<br>\n";
			local $d = $self->{'f'};
			$d =~ s/\/$self->{'config_hash'}->{'htaccess'}$//;
			push(@{$self->{'dirs_array'}}, [ $d, $self->{'currfile'} ]);
			}
		else {
			print $self->text('search_noprot', "<tt>$self->{'f'}</tt>"),"<br>\n";
			}
		}
	}
close(FIND);
print "<p><b>$self->{'text_hash'}->{'search_done'}</b><p>\n";
$self->switch_back();

$self->lock_file($self->{'directories_file'});
$self->save_directories(\@{$self->{'dirs_array'}});
$self->unlock_file($self->{'directories_file'});
$self->webmin_log("search", $self->{'in_hash'}->{'search'});

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

