#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_rpc.cgi

&ModuleLoader::preload_module('inetd_class', "inetd::InetdLib");
$self = new inetd::InetdLib:: 'inetd_class',%$self;

$self->error_setup($self->{'text_hash'}->{'error_saverpc'});
$self->ReadParse();

# Check inputs
$self->{'in_hash'}->{name} =~ /^[A-z][A-z0-9\_\-]+$/ ||
	$self->error($self->text('error_invalidprgname', $self->{'in_hash'}->{name}));
$self->{'in_hash'}->{number} =~ /^[0-9]+$/ ||
	$self->error($self->text('error_prgnum', $self->{'in_hash'}->{number}));
if ($self->{'in_hash'}->{'act'}) {
	$self->{'in_hash'}->{vfrom} =~ /^[0-9]+$/ ||
		$self->error("$self->{'in_hash'}->{vfrom} ");
	if ($self->{'in_hash'}->{vto} eq "") { $self->{'in_hash'}->{vto} = $self->{'in_hash'}->{vfrom}; }
	$self->{'in_hash'}->{vto} =~ /^[0-9]+$/ ||
		$self->error($self->text('error_invalidver', $self->{'in_hash'}->{vto}));
	if ($self->{'in_hash'}->{vto} < $self->{'in_hash'}->{vfrom}) {
		$self->{'tmp'} = $self->{'in_hash'}->{vfrom}; $self->{'in_hash'}->{vfrom} = $self->{'in_hash'}->{vto}; $self->{'in_hash'}->{vto} = $self->{'tmp'};
		}
	if ($self->{'in_hash'}->{protocols} eq "") {
		$self->error($self->text('error_noprotocol'));
		}
	if ((!$self->{'in_hash'}->{internal}) | ($self->{'config_hash'}->{'no_internal'})) {
		$self->{'in_hash'}->{program} =~ /^\/.*/ ||
			$self->error($self->text('error_invalidname', $self->{'in_hash'}->{program}));
		if ($self->{'in_hash'}->{'act'} == 2) {
			if (!$self->{'in_hash'}->{'qm'}) {
				-r $self->{'in_hash'}->{program} ||
					$self->error($self->text('error_notexist', $self->{'in_hash'}->{program}));
				-x $self->{'in_hash'}->{program} ||
					$self->error($self->text('error_ntexecutable',$self->{'in_hash'}->{program}));
				}
			}
		$self->{'in_hash'}->{args} =~ /^\S+/ ||
			$self->error($self->text('error_invalidcmd', $self->{'in_hash'}->{args}));
		}
	$self->{'in_hash'}->{'user'} || $self->error($self->text('error_nouser'));
	}

@{$self->{'rargs_array'}} = ($self->{'in_hash'}->{'name'}, $self->{'in_hash'}->{'number'}, $self->{'in_hash'}->{'aliases'});
$self->{'vers'} = ($self->{'in_hash'}->{vfrom} == $self->{'in_hash'}->{vto} ? $self->{'in_hash'}->{vfrom} : "$self->{'in_hash'}->{vfrom}-$self->{'in_hash'}->{vto}");
$self->{'prots'} = join(',', split(/\0/, $self->{'in_hash'}->{protocols}));
@{$self->{'iargs_array'}} = ($self->{'in_hash'}->{'act'} == 2, "$self->{'in_hash'}->{name}/$self->{'vers'}", $self->{'in_hash'}->{type}, "rpc/$self->{'prots'}");
if ($self->{'config_hash'}->{extended_inetd}) {
	push(@{$self->{'iargs_array'}}, ($self->{'in_hash'}->{permin_def} ? $self->{'in_hash'}->{wait} : "$self->{'in_hash'}->{wait}.$self->{'in_hash'}->{permin}"));
	push(@{$self->{'iargs_array'}}, ($self->{'in_hash'}->{group} ? "$self->{'in_hash'}->{user}.$self->{'in_hash'}->{group}" : $self->{'in_hash'}->{user}));
	}
else {
	push(@{$self->{'iargs_array'}}, $self->{'in_hash'}->{wait});
	push(@{$self->{'iargs_array'}}, $self->{'in_hash'}->{user});
	}
if ((!$self->{'config_hash'}->{'no_internal'}) & ($self->{'in_hash'}->{internal})) {
	push(@{$self->{'iargs_array'}}, "internal", undef);
	}
elsif (($self->{'config_hash'}->{'no_internal'}) & ($self->{'in_hash'}->{internal})) {
	$self->error($self->text('error_invalidcmd', $self->{'in_hash'}->{args}));
	}
else {
	push(@{$self->{'iargs_array'}}, ($self->{'in_hash'}->{'qm'} ? "?" : "").$self->{'in_hash'}->{program});
	push(@{$self->{'iargs_array'}}, $self->{'in_hash'}->{args});
	}

$self->lock_inetd_files();
@{$self->{'rpcs_array'}} = $self->list_rpcs();
@{$self->{'inets_array'}} = $self->list_inets();
foreach $r (@{$self->{'rpcs_array'}}) {
	if ($r->[1] eq $self->{'rargs_array'}->[0]) { $self->{'same_name'} = $r; }
	if ($r->[2] == $self->{'rargs_array'}->[1]) { $self->{'same_prog'} = $r; }
	}

if ($self->{'in_hash'}->{'rpos'} =~ /\d/) {
	# Changing a program (and maybe inetd entry)
	@{$self->{'old_rpc_array'}} = @{$self->{'rpcs_array'}->[$self->{'in_hash'}->{'rpos'}]};
        if ($self->{'in_hash'}->{'ipos'} =~ /\d/) {
		@{$self->{'old_inet_array'}} = @{$self->{'inets_array'}->[$self->{'in_hash'}->{'ipos'}]};
		}
	if ($self->{'same_name'} && $self->{'old_rpc_array'}->[1] ne $self->{'rargs_array'}->[0]) {
		$self->error($self->text('error_prgexist', $self->{'rargs_array'}->[0]));
		}
	if ($self->{'same_prog'} && $self->{'old_rpc_array'}->[2] ne $self->{'rargs_array'}->[1]) {
		$self->error($self->text('error_prginuse', $self->{'rargs_array'}->[1]));
		}
	$self->modify_rpc($self->{'old_rpc_array'}->[0], @{$self->{'rargs_array'}});
	if ($self->{'in_hash'}->{'act'} && @{$self->{'old_inet_array'}}) {
		# modify inetd
		$self->modify_inet($self->{'old_inet_array'}->[0], @{$self->{'iargs_array'}}, $self->{'old_inet_array'}->[10]);
		}
	elsif ($self->{'in_hash'}->{'act'} && !@{$self->{'old_inet_array'}}) {
		# add to inetd
		$self->create_inet(@{$self->{'iargs_array'}});
		}
	elsif (!$self->{'in_hash'}->{'act'} && @{$self->{'old_inet_array'}}) {
		# remove from inetd
		$self->delete_inet($self->{'old_inet_array'}->[0], $self->{'old_inet_array'}->[10]);
		}
	$self->unlock_inetd_files();
	$self->webmin_log("modify", "rpc", $self->{'rargs_array'}->[0],
		    { 'name' => $self->{'rargs_array'}->[0], 'number' => $self->{'rargs_array'}->[1],
		      'active' => $self->{'iargs_array'}->[0],
		      'user' => $self->{'iargs_array'}->[5], 'wait' => $self->{'iargs_array'}->[4],
		      'prog' => $self->{'in_hash'}->{'act'} ? join(" ", @{$self->{'iargs_array'}}[6..@{$self->{'iargs_array'}}-1])
					   : undef } );
	}
else {
	# Creating a new program
	if ($self->{'same_name'}) {
		$self->error($self->text('error_prgexist', $self->{'rargs_array'}->[0]));
		}
	if ($self->{'same_prog'}) {
		$self->error($self->text('error_prginuse', $self->{'rargs_array'}->[1]));
		}
	if ($self->{'in_hash'}->{'act'}) {
		foreach $i (@{$self->{'inets_array'}}) {
			if ($i->[2] && $i->[3] eq $self->{'rargs_array'}->[0]) {
				$self->error($self->text('error_prgexist', $self->{'rargs_array'}->[0]));
				}
			}
		}
	$self->create_rpc(@{$self->{'rargs_array'}});
	if ($self->{'in_hash'}->{'act'}) { $self->create_inet(@{$self->{'iargs_array'}}); }
	$self->unlock_inetd_files();
	$self->webmin_log("create", "rpc", $self->{'rargs_array'}->[0],
		    { 'name' => $self->{'rargs_array'}->[0], 'number' => $self->{'rargs_array'}->[1],
		      'active' => $self->{'iargs_array'}->[0],
		      'user' => $self->{'iargs_array'}->[5], 'wait' => $self->{'iargs_array'}->[4],
		      'prog' => $self->{'in_hash'}->{'act'} ? join(" ", @{$self->{'iargs_array'}}[6..@{$self->{'iargs_array'}}-1])
					   : undef } );
	}
$self->redirect("");

1;
		
}


1;

