#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_serv.cgi
# Save or create an internet service. This can be called N ways
#  - create a new services file entry
#  - create a new inetd.conf entry (and maybe update or add to services file)
#  - update inetd.conf (and maybe services)
#  - remove an entry from inetd.conf (and maybe change services)

&ModuleLoader::preload_module('inetd_class', "inetd::InetdLib");
$self = new inetd::InetdLib:: 'inetd_class',%$self;

$self->error_setup($self->{'text_hash'}->{'error_saveservice'});
$self->ReadParse();

# Check inputs
$self->{'in_hash'}->{'name'} =~ /^[A-z][A-z0-9\_\-]+$/ ||
	$self->error($self->text('error_invalidservice' ,$self->{'in_hash'}->{'name'}));
$self->{'in_hash'}->{'port'} =~ /^[0-9]*$/ || $self->error($self->text('error_invalidport', $self->{'in_hash'}->{'port'}));
if ($self->{'in_hash'}->{'port'} <= 0 || $self->{'in_hash'}->{'port'} > 65535) {
	$self->error($self->text('error_portnum', $self->{'in_hash'}->{'port'}));
	}
if ($self->{'in_hash'}->{'act'} && $self->{'in_hash'}->{'serv'} == 2) {
	$self->{'in_hash'}->{'program'} =~ /^\/\S+$/ ||
		$self->error($self->text('error_invalidprg', $self->{'in_hash'}->{program}));
	if ($self->{'in_hash'}->{'act'} == 2) {
		if (!$self->{'in_hash'}->{'qm'}) {
			-r $self->{'in_hash'}->{'program'} ||
				$self->error($self->text('error_notexist', $self->{'in_hash'}->{'program'}));
			-x $self->{'in_hash'}->{'program'} ||
				$self->error($self->text('error_notexecutable', $self->{'in_hash'}->{'program'}));
			}
		}
	$self->{'in_hash'}->{'args'} =~ /^\S+/ ||$self->error($self->text('error_invalidarg', $self->{'in_hash'}->{'args'}));
	}
elsif ($self->{'in_hash'}->{'act'} && $self->{'in_hash'}->{serv} == 3) {
	$self->{'in_hash'}->{tcpd} =~ /^\S+$/ ||
		$self->error($self->text('error_invalidwrapper', $self->{'in_hash'}->{tcpd}));
	}
if ($self->{'in_hash'}->{'act'}) {
	$self->{'in_hash'}->{'user'} || $self->error($self->{'text_hash'}->{'error_nouser'});
	defined(getpwnam($self->{'in_hash'}->{'user'})) || $self->error($self->{'text_hash'}->{'error_user'});
	if ($self->{'config_hash'}->{'extended_inetd'} == 1) {
		$self->{'in_hash'}->{'group_def'} || defined(getgrnam($self->{'in_hash'}->{'group'})) ||
			$self->error($self->{'text_hash'}->{'error_group'});
		}
	}
if ($self->{'config_hash'}->{'extended_inetd'} && !$self->{'in_hash'}->{'permin_def'} && $self->{'in_hash'}->{'permin'}!~/^\d+$/) {
	$self->error($self->text('error_invalidpermin', $self->{'in_hash'}->{'permin'}));
	}
if ($self->{'config_hash'}->{'extended_inetd'} == 2 &&
    !$self->{'in_hash'}->{'child_def'} && $self->{'in_hash'}->{'child'} !~ /^\d+$/) {
	$self->error($self->text('error_invalidchildnum', $self->{'in_hash'}->{'child'}));
	}

# Build argument list
@{$self->{'sargs_array'}} = ($self->{'in_hash'}->{'name'}, $self->{'in_hash'}->{'port'}, $self->{'in_hash'}->{'protocol'},
	  join(' ', split(/\s+/, $self->{'in_hash'}->{'aliases'})) );
@{$self->{'iargs_array'}} = ($self->{'in_hash'}->{'act'} == 2, $self->{'in_hash'}->{'name'},
	  $self->{'in_hash'}->{'protocol'} =~ /^tcp/ ? "stream" : "dgram", $self->{'in_hash'}->{'protocol'});
$self->{'wait'} = $self->{'in_hash'}->{'wait'};
$self->{'user'} = $self->{'in_hash'}->{'user'};
if ($self->{'config_hash'}->{'extended_inetd'} == 1) {
	if (!$self->{'in_hash'}->{'permin_def'}) { $self->{'wait'} .= ".$self->{'in_hash'}->{'permin'}"; }
	if (!$self->{'in_hash'}->{'group_def'}) { $self->{'user'} .= ".$self->{'in_hash'}->{'group'}"; }
	}
elsif ($self->{'config_hash'}->{'extended_inetd'} == 2) {
	if (!$self->{'in_hash'}->{'child_def'}) { $self->{'wait'} .= "/$self->{'in_hash'}->{'child'}"; }
	if (!$self->{'in_hash'}->{'permin_def'} && $self->{'in_hash'}->{'child_def'}) {
		$self->error($self->{'text_hash'}->{'error_childnum'});
		}
	if (!$self->{'in_hash'}->{'permin_def'}) { $self->{'wait'} .= "/$self->{'in_hash'}->{'permin'}"; }
	if ($self->{'in_hash'}->{'group'}) { $self->{'user'} .= ":$self->{'in_hash'}->{'group'}"; }
	if ($self->{'in_hash'}->{'class'}) { $self->{'user'} .= "/$self->{'in_hash'}->{'class'}"; }
	}
push(@{$self->{'iargs_array'}}, $self->{'wait'});
push(@{$self->{'iargs_array'}}, $self->{'user'});
if (($self->{'in_hash'}->{'serv'} == 1) & (!$self->{'config_hash'}->{'no_internal'})) {
	push(@{$self->{'iargs_array'}}, "internal", undef);
	}
elsif (($self->{'in_hash'}->{'serv'} == 1) & ($self->{'config_hash'}->{'no_internal'})) {
	$self->error($self->text('error_invalidcmd', $self->{'in_hash'}->{args}));
	}
elsif ($self->{'in_hash'}->{serv} == 2) {
	push(@{$self->{'iargs_array'}}, ($self->{'in_hash'}->{'qm'} ? "?" : "").$self->{'in_hash'}->{'program'});
	push(@{$self->{'iargs_array'}}, $self->{'in_hash'}->{'args'});
	}
elsif ($self->{'in_hash'}->{serv} == 3) {
	push(@{$self->{'iargs_array'}}, $self->{'config_hash'}->{'tcpd_path'});
	push(@{$self->{'iargs_array'}}, $self->{'in_hash'}->{'tcpd'});
	$self->{'iargs_array'}->[$#{$self->{'iargs_array'}}] .= " $self->{'in_hash'}->{'args2'}" if ($self->{'in_hash'}->{'args2'});
	}

$self->lock_inetd_files();
@{$self->{'servs_array'}} = $self->list_services();
@{$self->{'inets_array'}} = $self->list_inets();
foreach $s (@{$self->{'servs_array'}}) {
	if ($s->[1] eq $self->{'sargs_array'}->[0] && $s->[3] eq $self->{'sargs_array'}->[2]) { $self->{'same_name'} = $s; }
	if ($s->[2] == $self->{'sargs_array'}->[1] && $s->[3] eq $self->{'sargs_array'}->[2]) { $self->{'same_port'} = $s; }
	}

if ($self->{'in_hash'}->{'spos'} =~ /\d/) {
	# Changing a service..
	@{$self->{'old_serv_array'}} = @{$self->{'servs_array'}->[$self->{'in_hash'}->{'spos'}]};
	if ($self->{'in_hash'}->{'ipos'} =~ /\d/) {
		@{$self->{'old_inet_array'}} = @{$self->{'inets_array'}->[$self->{'in_hash'}->{'ipos'}]};
		}
	if ($self->{'old_serv_array'}->[1] ne $self->{'sargs_array'}->[0] || $self->{'old_serv_array'}->[2] != $self->{'sargs_array'}->[1] ||
	    $self->{'old_serv_array'}->[3] ne $self->{'sargs_array'}->[2]) {
		if ($self->{'same_name'} && $self->{'same_name'}->[2] != $self->{'old_serv_array'}->[2]) {
			$self->error($self->text('error_nameexist', $self->{'sargs_array'}->[0], $self->{'sargs_array'}->[2]));
			}
		if ($self->{'same_port'} && $self->{'same_port'}->[1] ne $self->{'old_serv_array'}->[1]) {
			$self->error($self->text('error_serviceexist', $self->{'sargs_array'}->[1], $self->{'sargs_array'}->[2]));
			}
		}
	$self->modify_service($self->{'old_serv_array'}->[0], @{$self->{'sargs_array'}});
	if ($self->{'in_hash'}->{'act'} && @{$self->{'old_inet_array'}}) {
		# modify inetd
		$self->modify_inet($self->{'old_inet_array'}->[0], @{$self->{'iargs_array'}}, $self->{'old_inet_array'}->[10]);
		}
	elsif ($self->{'in_hash'}->{'act'} && !@{$self->{'old_inet_array'}}) {
		# add to inetd
		$self->create_inet(@{$self->{'iargs_array'}});
		}
	elsif (!$self->{'in_hash'}->{'act'} && @{$self->{'old_inet_array'}}) {
		# remove from inetd
		$self->delete_inet($self->{'old_inet_array'}->[0], $self->{'old_inet_array'}->[10]);
		@{$self->{'iargs_array'}} = ();
		}
	$self->unlock_inetd_files();
	$self->webmin_log("modify", "serv", $self->{'sargs_array'}->[0],
		    { 'name' => $self->{'sargs_array'}->[0], 'port' => $self->{'sargs_array'}->[1],
		      'proto' => $self->{'sargs_array'}->[2], 'active' => $self->{'iargs_array'}->[0],
		      'user' => $self->{'iargs_array'}->[5], 'wait' => $self->{'iargs_array'}->[4],
		      'prog' => $self->{'in_hash'}->{'act'} ? join(" ", @{$self->{'iargs_array'}}[6..@{$self->{'iargs_array'}}-1])
					   : undef } );
	}
else {
	# Creating a new service...
	# Check for a service with the same name or port and protocol
	if ($self->{'same_name'}) {
		$self->error($self->text('error_nameexist', $self->{'sargs_array'}->[0], $self->{'sargs_array'}->[2]));
		}
	if ($self->{'same_port'}) {
		$self->error($self->text('error_serviceexist', $self->{'sargs_array'}->[1], $self->{'sargs_array'}->[2]));
		}
	# Check for an existing internet service
	if ($self->{'in_hash'}->{'act'}) {
		foreach $i (@{$self->{'inets_array'}}) {
			if ($i->[3] eq $self->{'iargs_array'}->[1] && $i->[5] eq $self->{'iargs_array'}->[3]) {
				$self->error($self->text('error_inetservice', $i->[3], $i->[5]));
				}
			}
		}
	$self->create_service(@{$self->{'sargs_array'}});
	if ($self->{'in_hash'}->{'act'}) { $self->create_inet(@{$self->{'iargs_array'}}); }
	$self->unlock_inetd_files();
	$self->webmin_log("create", "serv", $self->{'sargs_array'}->[0],
		    { 'name' => $self->{'sargs_array'}->[0], 'port' => $self->{'sargs_array'}->[1],
		      'proto' => $self->{'sargs_array'}->[2], 'active' => $self->{'iargs_array'}->[0],
		      'user' => $self->{'iargs_array'}->[5], 'wait' => $self->{'iargs_array'}->[4],
		      'prog' => $self->{'in_hash'}->{'act'} ? join(" ", @{$self->{'iargs_array'}}[6..@{$self->{'iargs_array'}}-1])
					   : undef } );
	}
$self->redirect("");

1;
		
}


1;

