#!/usr/bin/perl
package init::Log_parser;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'init::Log_parser');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# log_parser.pl
# Functions for parsing this module's logs

&ModuleLoader::preload_module(ref($self), "init::InitLib");
$self = new init::InitLib:: ref($self), %$self; 

1;
		return $self;
}

# parse_webmin_log(user, script, action, type, object, &params)
# Converts logged information from this module into human-readable form
sub parse_webmin_log
{
	my $self = shift;

local ($user, $script, $action, $type, $object, $p) = @_;
if ($action eq 'modify') {
	if ($p->{'old'} ne $p->{'name'}) {
		return $self->text('log_rename', "<tt>$p->{'old'}</tt>",
					   "<tt>$p->{'name'}</tt>");
		}
	else {
		return $self->text('log_modify', "<tt>$object</tt>");
		}
	}
elsif ($action eq 'create') {
	return $self->text('log_create', "<tt>$object</tt>");
	}
elsif ($action eq 'delete') {
	return $self->text('log_delete', "<tt>$object</tt>");
	}
elsif ($action eq 'start') {
	return $self->text('log_start', "<tt>$object</tt>");
	}
elsif ($action eq 'stop') {
	return $self->text('log_stop', "<tt>$object</tt>");
	}
elsif ($action eq 'reboot') {
	return $self->{'text_hash'}->{'log_reboot'};
	}
elsif ($action eq 'shutdown') {
	return $self->{'text_hash'}->{'log_shutdown'};
	}
elsif ($action eq 'local') {
	return $self->{'text_hash'}->{'log_local'};
	}
elsif ($action eq 'bootup') {
	return $self->text('log_bootup', join(", ", map { "<tt>$_</tt>" } keys %$p));
	}
elsif ($action eq 'massstart' || $action eq 'massstop' ||
       $action eq 'massrestart' ||
       $action eq 'massenable' || $action eq 'massdisable') {
	return $self->text('log_'.$action, join(", ", map { "<tt>$_</tt>" } split(/\s+/, $object)));
	}
elsif ($action eq 'telinit') {
	return $self->text('log_telinit', $object);
	}
else {
	return undef;
	}
}


1;

