#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_action.cgi
# Edit or create a bootup action. Existing actions can either be in the
# init.d directory (and linked to from the appropriate runlevels), or
# just plain runlevel files

&ModuleLoader::preload_module('init_class', "init::InitLib");
$self = new init::InitLib:: 'init_class',%$self;

%{$self->{'access_hash'}} = $self->get_module_acl();
$self->{'access_hash'}->{'bootup'} || $self->error($self->{'text_hash'}->{'edit_ecannot'});

$self->{'ty'} = $ARGV[0];
if ($self->{'ty'} == 0) {
	# Editing an action in init.d, linked to from various runlevels
	$self->{'ac'} = $ARGV[1];
	$self->ui_print_header(undef, $self->{'text_hash'}->{'edit_title'}, "");
	$self->{'file'} = $self->action_filename($self->{'ac'});
	open(FILE, $self->{'file'});
	while(<FILE>) {
		$self->{'data'} .= $_;
		if (/^\s*(['"]?)([a-z]+)\1\)/i) {
			$self->{'hasarg_hash'}->{$2}++;
			}
		}
	close(FILE);
	}
elsif ($self->{'ty'} == 1) {
	# Editing an action in one of the runlevels
	$rl = $ARGV[1];
	$self->{'num'} = $ARGV[2];
	$self->{'ac'} = $ARGV[3];
	$self->{'inode'} = $ARGV[4];
	$self->{'ss'} = $ARGV[5];
	$self->ui_print_header(undef, $self->{'text_hash'}->{'edit_title'}, "");
	$self->{'file'} = $self->runlevel_filename($rl, $self->{'ss'}, $self->{'num'}, $self->{'ac'});
	$self->{'data'} = `cat $self->{'file'}`;
	}
else {
	# Creating a new action in init.d
	$self->ui_print_header(undef, $self->{'text_hash'}->{'create_title'}, "");
	}

print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'edit_details'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";
print "<form method=post action=save_action.cgi enctype=multipart/form-data>\n";
print "<input type=hidden name=type value=$self->{'ty'}>\n";
if ($self->{'ty'} != 2) {
	print "<input type=hidden name=old value=\"$self->{'ac'}\">\n";
	if ($self->{'ty'} == 1) {
		print "<input type=hidden name=runlevel value=\"$rl\">\n";
		print "<input type=hidden name=startstop value=\"$self->{'ss'}\">\n";
		print "<input type=hidden name=number value=\"$self->{'num'}\">\n";
		}
	}
print "<tr> <td><b>$self->{'text_hash'}->{'edit_name'}</b></td>\n";
if ($self->{'ac'} =~ /^\// || $self->{'access_hash'}->{'bootup'} == 2) {
	print "<td><tt>$self->{'ac'}</tt></td> </tr>\n";
	print "<input type=hidden name=name value=\"$self->{'ac'}\">\n";
	print "<input type=hidden name=extra value=1>\n";
	}
else {
	print "<td><input size=20 name=name value=\"$self->{'ac'}\"></td> </tr>\n";
	}

$self->{'fs'} = "<font size=-1>"; $self->{'fe'} = "</font>";
if ($self->{'ty'} == 2) {
	# Display fields for a template
	print "<tr> <td valign=top><b>$self->{'text_hash'}->{'edit_desc'}</b></td>\n";
	print "<td>$self->{'fs'}<textarea rows=2 cols=80 name=desc>",
	      "</textarea>$self->{'fe'}</td> </tr>\n";

	if ($self->{'config_hash'}->{'start_stop_msg'}) {
		print "<tr> <td><b>$self->{'text_hash'}->{'edit_startmsg'}</b></td>\n";
		print "<td><input name=start_msg size=40></td> </tr>\n";

		print "<tr> <td><b>$self->{'text_hash'}->{'edit_stopmsg'}</b></td>\n";
		print "<td><input name=stop_msg size=40></td> </tr>\n";
		}

	print "<tr> <td valign=top><b>$self->{'text_hash'}->{'edit_start'}</b></td>\n";
	print "<td>$self->{'fs'}<textarea rows=5 cols=80 name=start>",
	      "</textarea>$self->{'fe'}</td> </tr>\n";

	print "<tr> <td valign=top><b>$self->{'text_hash'}->{'edit_stop'}</b></td>\n";
	print "<td>$self->{'fs'}<textarea rows=5 cols=80 name=stop>",
	      "</textarea>$self->{'fe'}</td> </tr>\n";
	}
elsif ($self->{'access_hash'}->{'bootup'} == 2) {
	# Just show current script
	print "<tr> <td valign=top><b>$self->{'text_hash'}->{'edit_script'}</b></td>\n";
	print "<td>$self->{'fs'}<pre>",$self->html_escape($self->{'data'}),"</pre>$self->{'fe'}</td> </tr>\n";
	}
else {
	# Allow direct editing of the script
	print "<tr> <td valign=top><b>$self->{'text_hash'}->{'edit_script'}</b></td>\n";
	print "<td>$self->{'fs'}<textarea rows=15 cols=80 name=data>",$self->html_escape($self->{'data'}),
	      "</textarea>$self->{'fe'}</td> </tr>\n";
	}

if ($self->{'ty'} == 1 && $self->{'access_hash'}->{'bootup'} == 1) {
	# Display a message about the script being bogus
	print "</table></td></tr></table><p>\n";
	print "<b>",$self->text("edit_bad$self->{'ss'}", $rl),"</b><br>\n";
	print "<a href=\"fix_action.cgi?$rl+$self->{'ss'}+$self->{'num'}+$self->{'ac'}\">",
	      "$self->{'text_hash'}->{'edit_fix'}</a>. <p>\n";
	}
elsif (!$self->{'config_hash'}->{'expert'} || $self->{'access_hash'}->{'bootup'} == 2) {
	# Just tell the user if this action is started at boot time
	local $boot = 0;
	print "<tr> <td><b>$self->{'text_hash'}->{'edit_boot'}</b></td>\n";
	if ($self->{'ty'} == 0) {
		local @boot = $self->get_inittab_runlevel();
		foreach $s ($self->action_levels('S', $self->{'ac'})) {
			local ($l, $p) = split(/\s+/, $s);
			$boot = 1 if ($self->indexof($l, @boot) >= 0);
			}
		if ($boot && $self->{'config_hash'}->{'daemons_dir'} &&
		    $self->read_env_file("$self->{'config_hash'}->{'daemons_dir'}/$self->{'ac'}", \%{$self->{'daemon_hash'}})) {
			$boot = lc($self->{'daemon_hash'}->{'ONBOOT'}) eq 'yes' ? 1 : 0;
			}
		print "<input type=hidden name=oldboot value='$boot'>\n";
		}
	if ($self->{'access_hash'}->{'bootup'} == 1) {
		printf "<td><input name=boot type=radio value=1 %s> %s\n",
			$boot || $self->{'ty'} == 2 ? 'checked' : '', $self->{'text_hash'}->{'yes'};
		printf "<input name=boot type=radio value=0 %s> %s\n",
			$boot || $self->{'ty'} == 2 ? '' : 'checked', $self->{'text_hash'}->{'no'};
		}
	else {
		print "<td>",$boot || $self->{'ty'} == 2 ? $self->{'text_hash'}->{'yes'} : $self->{'text_hash'}->{'no'};
		}
	if ($self->{'hasarg_hash'}->{'status'} && $self->{'config_hash'}->{'status_check'}) {
		# Show if action is currently running
		$self->{'out'} = `$self->{'file'} status </dev/null 2>/dev/null`;
		print "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;",
		      "<b>$self->{'text_hash'}->{'edit_status'}</b>&nbsp;&nbsp;\n";
		if ($self->{'out'} =~ /running/i) {
			print $self->{'text_hash'}->{'yes'};
			}
		elsif ($self->{'out'} =~ /stopped/i) {
			print "<font color=#ff0000>$self->{'text_hash'}->{'no'}</font>";
			}
		else {
			print "<i>$self->{'text_hash'}->{'edit_unknown'}</i>";
			}
		}
	print "</td></tr> </table></td></tr></table>\n";
	}
else {
	if ($self->{'config_hash'}->{'daemons_dir'} && $self->{'ac'} &&
	    $self->read_env_file("$self->{'config_hash'}->{'daemons_dir'}/$self->{'ac'}", \%{$self->{'daemon_hash'}})) {
		# Display onboot flag from daemons file
		$boot = lc($self->{'daemon_hash'}->{'ONBOOT'}) eq 'yes';
		print "<tr> <td><b>$self->{'text_hash'}->{'edit_boot'}</b></td>\n";
		printf "<td><input name=boot type=radio value=1 %s> %s\n",
			$boot ? 'checked' : '', $self->{'text_hash'}->{'yes'};
		printf "<input name=boot type=radio value=0 %s> %s</td></tr>\n",
			$boot ? '' : 'checked', $self->{'text_hash'}->{'no'};
		}

	# Display which runlevels the action is started/stopped in
	print "</table></td></tr></table><p>\n";

	print "<table border width=100%>\n";
	print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'edit_levels'}</b></td> </tr>\n";
	print "<tr $self->{'cb'}> <td><b><table width=100%>\n";
	if ($self->{'ac'}) {
		foreach $s ($self->action_levels('S', $self->{'ac'})) {
			@s = split(/\s+/, $s);
			$self->{'spri_hash'}->{$s[0]} = $s[1];
			}
		foreach $k ($self->action_levels('K', $self->{'ac'})) {
			@k = split(/\s+/, $k);
			$self->{'kpri_hash'}->{$k[0]} = $k[1];
			}
		}
	@boot = $self->get_inittab_runlevel();
	foreach $rl ($self->list_runlevels()) {
		print "<tr>\n" if (!$self->{'sw'});
		if ($self->indexof($rl, @boot) == -1) {
			print "<td><b>",$self->text('edit_rl', $rl),"</b></td>\n";
			}
		else {
			print "<td><b><i>",$self->text('edit_rl', $rl),
			      "</i></b></td>\n";
			}

		$self->{'od'} = $self->{'config_hash'}->{'order_digits'};
		printf "<td><input type=checkbox name=S$rl value=1 %s>\n",
			defined($self->{'spri_hash'}->{$rl}) ? "checked" : "";
		print $self->{'text_hash'}->{'edit_startat'},"\n";
		print "<input name=pri_S$rl size=$self->{'od'} value=$self->{'spri_hash'}->{$rl}></td>\n";

		printf "<td><input type=checkbox name=K$rl value=1 %s>\n",
			defined($self->{'kpri_hash'}->{$rl}) ? "checked" : "";
		print $self->{'text_hash'}->{'edit_stopat'},"\n";
		print "<input name=pri_K$rl size=$self->{'od'} value=$self->{'kpri_hash'}->{$rl}></td>\n";
		print "</tr>\n" if ($self->{'sw'});
		$self->{'sw'} = !$self->{'sw'};
		}
	print "<td colspan=3><br></td> </tr>\n" if ($self->{'sw'});
	print "</table></td></tr></table>\n";
	}

if ($self->{'ty'} != 2) {
	print "<table width=100%><tr>\n";
	if ($self->{'access_hash'}->{'bootup'} == 1) {
		print "<td><input type=submit value=\"$self->{'text_hash'}->{'save'}\"></td>\n";
		}

	print "</form><form action=\"start_stop.cgi\">\n";
	print "<input type=hidden name=file value=\"$self->{'file'}\">\n";
	print "<input type=hidden name=name value=\"$self->{'ac'}\">\n";
	$self->{'args'} = join("+", @ARGV);
	print "<input type=hidden name=back value=\"edit_action.cgi?$self->{'args'}\">\n";
	print "<td align=center>\n";
	print "<input type=submit name=start value=\"$self->{'text_hash'}->{'edit_startnow'}\">\n";
	if ($self->{'hasarg_hash'}->{'restart'}) {
		print "<input type=submit name=restart value=\"$self->{'text_hash'}->{'edit_restartnow'}\">\n";
		}
	if ($self->{'hasarg_hash'}->{'condrestart'}) {
		print "<input type=submit name=condrestart value=\"$self->{'text_hash'}->{'edit_condrestartnow'}\">\n";
		}
	if ($self->{'hasarg_hash'}->{'reload'}) {
		print "<input type=submit name=reload value=\"$self->{'text_hash'}->{'edit_reloadnow'}\">\n";
		}
	if ($self->{'hasarg_hash'}->{'status'}) {
		print "<input type=submit name=status value=\"$self->{'text_hash'}->{'edit_statusnow'}\">\n";
		}
	print "<input type=submit name=stop value=\"$self->{'text_hash'}->{'edit_stopnow'}\">\n";
	print "</td>\n";

	if ($self->{'access_hash'}->{'bootup'} == 1) {
		print "</form><form action=\"delete_action.cgi\">\n";
		print "<input type=hidden name=type value=\"$self->{'ty'}\">\n";
		print "<input type=hidden name=action value=\"$self->{'ac'}\">\n";
		if ($self->{'ty'} == 1) {
			print "<input type=hidden name=runlevel value=\"$rl\">\n";
			print "<input type=hidden name=startstop value=\"$self->{'ss'}\">\n";
			print "<input type=hidden name=number value=\"$self->{'num'}\">\n";
			}
		print "<td align=right><input type=submit ",
		      "value=\"$self->{'text_hash'}->{'delete'}\"></td>\n";
		}
	print "</tr></form></table><p>\n";
	}
else {
	print "<input type=submit value=\"$self->{'text_hash'}->{'create'}\"></form><p>\n";
	}

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

