#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_hostconfig.cgi
#
# Edit the settings in the hostconfig file, or the
# StartupItems script or plist associated with the
# action described in the hostconfig file.
#
# Also create a new startup action with associated script and plist
# and manually modify hostconfig file.

&ModuleLoader::preload_module('init_class', "init::InitLib");
$self = new init::InitLib:: 'init_class',%$self;

&ModuleLoader::preload_module('init_class', "init::HostconfigLib");
$self = new init::HostconfigLib:: 'init_class',%$self;

use File::Basename;
%{$self->{'access_hash'}} = $self->get_module_acl();
$self->{'access_hash'}->{'bootup'} == 1 || $self->error($self->{'text_hash'}->{'edit_ecannot'});

$self->{'ty'} = $ARGV[0];
if ($self->{'ty'} == 0) {
	# Editing an existing action in /etc/hostconfig
	$self->{'action_to_edit'} = $ARGV[1];
	$self->ui_print_header(undef, $self->{'text_hash'}->{'edit_title'}, "");
	%{$self->{'startuphash_hash'}} = $self->hostconfig_gather(startscript);
	$self->{'startscript'} = $self->{'startuphash_hash'}->{"$self->{'action_to_edit'}"};
	if ( $self->{'startscript'} ne "") {
		$self->{'startupdir'} = dirname("$self->{'startscript'}");
		$self->{'plistedit'} = "$self->{'startupdir'}/$self->{'config_hash'}->{'plist'}";
		}
	else {
		$self->{'plistedit'} = "";
		}

	#create the action edit table
	$self->{'actionedit'} = $self->hostconfig_editaction("$self->{'action_to_edit'}", "$self->{'startscript'}");
	print "<form action=modifyhostconfig.cgi method=post name=hostmod>\n";
	print "<table width=\"100%\" border><tr $self->{'tb'}> <td><b>", $self->text('index_action'), "</b></td>\n";
	print "<td><b>", $self->text('index_setting'), "</b></td></tr>\n";
	print "<tr $self->{'cb'}><td valign=middle>$self->{'action_to_edit'}</td>\n";
	print "<td>$self->{'actionedit'}</td></tr></table>\n";
	print "<input type=submit value='$self->{'text_hash'}->{'save'}'></form>\n";
	
	#create the edit file forms
	if ($self->{'startscript'} ne "") {
		print "<hr>\n";
		print $self->text('edit_hostconfig_startup',
			"<tt>$self->{'startscript'}</tt>"),"<br>\n";
		#	}
		print "<form action=save_startscript.cgi method=post>\n";
		print "<textarea name=startup rows=20 cols=80>";
		open(STARTSCRIPT, $self->{'startscript'});
		while(<STARTSCRIPT>) { print; }
		close(STARTSCRIPT);
		print "</textarea><br>\n";
		print "<input type=hidden name=\"action\" value=\"$self->{'action_to_edit'}\">\n";
		print "<input type=submit value='$self->{'text_hash'}->{'save'}'></form>\n";
		}
	if ($self->{'plistedit'} ne "") {
		print "<hr>\n";
		print $self->text('edit_hostconfig_plist',
			"<tt>$self->{'plistedit'}</tt>"),"<br>\n";
		#	}
		print "<form action=save_startscript.cgi method=post>\n";
		print "<textarea name=plist rows=20 cols=80>";
		open(PLIST, $self->{'plistedit'});
		while(<PLIST>) { print; }
		close(PLIST);
		print "</textarea><br>\n";
		print "<input type=hidden name=\"action\" value=\"$self->{'action_to_edit'}\">\n";
#		print "$self->{'plistedit'}</textarea><br>\n";
		print "<input type=submit value='$self->{'text_hash'}->{'save'}'></form>\n";
		}
	}

if ($self->{'ty'} == 1) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'edit_hostconfig_new'}, "");
	print "<HR>\n";

	print "<P>\n", $self->text('edit_hostconfig_noquotes',
		"<tt>$self->{'text_hash'}->{'edit_start'}</tt>"),"\n";

	print "<P>\n", $self->text('edit_hostconfig_startitems',
		"<tt>$self->{'text_hash'}->{'edit_hostconfig_actionname'}</tt>",
		"<tt>$self->{'text_hash'}->{'edit_hostconfig_scriptname'}</tt>"),"\n";

	print "<P>\n", $self->text('edit_hostconfig_array',
		"<tt>Provides</tt>", "<tt>Requires</tt>", "<tt>Uses</tt>"),"\n";
	
	print "<P>\n $self->{'text_hash'}->{'edit_hostconfig_further'}\n";

	#print "<form method=post action=save_hostconfig_action.cgi enctype=multipart/form-data>\n";
	print "<form method=post action=save_hostconfig_action.cgi>\n";
	print "<table border>\n";
	print "<tr $self->{'tb'}><td><b>Action Details</b></td></tr>\n";
	print "<tr $self->{'cb'}><td><table cellpadding=3>\n";

	# create the form fields

	$self->{'textt'}=$self->hostconfig_createtext("Action Name","req");
	print "<tr>", $self->hostconfig_createtext("$self->{'text_hash'}->{'edit_hostconfig_actionname'}","req");
	print "<td><input size=20 name=action_name value=\"\"></td></tr>\n";
	
	print "<tr>", $self->hostconfig_createtext("$self->{'text_hash'}->{'edit_hostconfig_scriptname'}","req");
	print "<td><input size=20 name=script_name value=\"\"></td></tr>\n";

	print "<tr>", $self->hostconfig_createtext("$self->{'text_hash'}->{'edit_start'}","req");
	print "<td><font size=-1><textarea rows=5 cols=80 name=execute></textarea></font></td></tr>\n";

	print "<tr>", $self->hostconfig_createtext("$self->{'text_hash'}->{'index_desc'}","");
	print "<td><input size=60 name=description value=\"\"></td></tr>\n";

	print "<tr>", $self->hostconfig_createtext("Provides","");
	print "<td><input size=60 name=provides value=\"\"></td></tr>\n";

	print "<tr>", $self->hostconfig_createtext("Requires","");
	print "<td><input size=60 name=requires value=\"\"></td></tr>\n";

	print "<tr>", $self->hostconfig_createtext("Uses","");
	print "<td><input size=60 name=uses value=\"\"></td></tr>\n";

	print "<tr>", $self->hostconfig_createtext("OrderPreference","");
	print "<td><SELECT name=order><option value=First>First<option value=Early>Early<option value=None selected>None<option value=Late>Late<option value=Last>Last</select></td></tr>\n";

	print "<tr>", $self->hostconfig_createtext("Start Message","");
	print "<td><input size=60 name=start value=\"\"></td></tr>\n";

	print "<tr>", $self->hostconfig_createtext("Stop Message","");
	print "<td><input size=60 name=stop value=\"\"></td></tr>\n";

	print "<tr>", $self->hostconfig_createtext("Start at boot time?","");
	print "<td><input name=boot type=radio value=\"-YES-\"> Yes\n";
	print "<input name=boot type=radio value=\"-NO-\" checked> No</td></tr>\n";

	print "<tr><td><font size=-1 color=#ff0000>* required field</font></td><td> </td></tr>\n";
	print "</table>";
	print "</td></tr></table>\n";
	print "<input type=submit value=\"Create\"></form>\n";

	}

if ($self->{'ty'} == 2) {
	
	$self->ui_print_header(undef, $self->{'text_hash'}->{'edit_hostconfig_title'}, "");
	print $self->text('edit_hostconfig_hostconfig',
		"<tt>$self->{'config_hash'}->{'hostconfig'}</tt>"),"<br>\n";
	print "<form action=save_startscript.cgi method=post>\n";
	print "<textarea name=hostconfig rows=20 cols=80>";
	open(LOCAL, $self->{'config_hash'}->{'hostconfig'});
	while(<LOCAL>) { print; }
	close(LOCAL);
	print "</textarea><br>\n";
	print "<input type=submit value='$self->{'text_hash'}->{'save'}'></form>\n";
	print "<hr>\n";

	#add reboot and shutdown messages to this page as well...
	print "<table cellpadding=5 width=100%>\n";
	if ($self->{'access_hash'}->{'reboot'}) {
		print "<form action=reboot.cgi>\n";
		print "<tr> <td><input type=submit ",
			"value=\"$self->{'text_hash'}->{'index_reboot'}\"></td>\n";
		print "</form>\n";
		print "<td>$self->{'text_hash'}->{'index_rebootmsg'}</td> </tr>\n";
		}

	if ($self->{'access_hash'}->{'shutdown'}) {
		print "<form action=shutdown.cgi>\n";
		print "<tr> <td><input type=submit ",
			"value=\"$self->{'text_hash'}->{'index_shutdown'}\"></td>\n";
		print "</form>\n";
		print "<td>$self->{'text_hash'}->{'index_shutdownmsg'}</td> </tr>\n";
		}
	print "</table>\n";
	}
	
$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
1;
		
}


1;

