#!/usr/bin/perl

&MAIN();

 sub MAIN {
# index.cgi
# Display a list of run-levels and the actions that are run at boot and
# shutdown time for each level

&ModuleLoader::preload_module('init_class', "init::InitLib");
$self = new init::InitLib:: 'init_class',%$self;

&ModuleLoader::preload_module('init_class', "init::HostconfigLib");
$self = new init::HostconfigLib:: 'init_class',%$self;

$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", undef, 1, 1);
%{$self->{'access_hash'}} = $self->get_module_acl();

if ($self->{'init_mode'} eq "osx" && $self->{'access_hash'}->{'bootup'}) {
	# This hostconfig if block written by Michael A Peters <mpeters@mac.com>
	# for OSX/Darwin.
	# build hostconfig table 
	
	@{$self->{'hconf_set_array'}} = $self->hostconfig_settings();
	%{$self->{'description_list_hash'}} = $self->hostconfig_gather(description);
	
	print "<table border width=100%>\n";
	print "<tr $self->{'tb'}> <td><b>", $self->text('index_action'), "</b></td>\n";
	print "<td><b>", $self->text('index_setting'), "</b></td>\n";
	print "<td> <b>", $self->text('index_desc'), "</b></td> </tr>\n";
	$i = 0;
	while (<@{$self-\>{'hconf_set_array'}}>) {
		$self->{'action_description'} = $self->{'description_list_hash'}->{"$self->{'hconf_set_array'}->[$i][0]"};
		print $self->hostconfig_table($self->{'hconf_set_array'}->[$i][0], $self->{'hconf_set_array'}->[$i][1], $self->{'action_description'});
		$i++;
		}
	print "</table>\n";
	if ($self->{'access_hash'}->{'bootup'} == 1) {
		print "<a href='edit_hostconfig.cgi?1'>$self->{'text_hash'}->{'index_add_mac'}</a><br>\n";
		print "<a href='edit_hostconfig.cgi?2'>", $self->text('index_editconfig',
			"<tt>$self->{'config_hash'}->{'hostconfig'}</tt>"),"</a><P>\n";
		}
	print "<hr>\n"; 
	}
elsif ($self->{'init_mode'} eq "init" && $self->{'access_hash'}->{'bootup'}) {
	# build list of normal and broken actions
	@{$self->{'iacts_array'}} = $self->list_actions();
	foreach $a (@{$self->{'iacts_array'}}) {
		@ac = split(/\s+/, $a);
		$self->{'nodemap_hash'}->{$ac[1]} = $ac[0];
		push(@{$self->{'acts_array'}}, $ac[0]);
		push(@{$self->{'actsl_array'}}, "0+$ac[0]");
		push(@{$self->{'actsf_array'}}, $ac[0] =~ /^\// ? $ac[0]
					     : "$self->{'config_hash'}->{'init_dir'}/$ac[0]");
		}
	@{$self->{'runlevels_array'}} = $self->list_runlevels();
	foreach $r (@{$self->{'runlevels_array'}}) {
		foreach $w ("S", "K") {
			foreach $a ($self->runlevel_actions($r, $w)) {
				@ac = split(/\s+/, $a);
				if (!$self->{'nodemap_hash'}->{$ac[2]}) {
					push(@{$self->{'acts_array'}}, $ac[1]);
					push(@{$self->{'actsl_array'}},
					     "1+$r+$ac[0]+$ac[1]+$ac[2]+$w");
					push(@{$self->{'actsf_array'}}, "$self->{'config_hash'}->{'init_base'}/rc$r.d/$w$ac[0]$ac[1]");
					}
				}
			}
		}
	@{$self->{'boot_array'}} = $self->get_inittab_runlevel();
	for($i=0; $i<@{$self->{'acts_array'}}; $i++) {
		foreach $s ($self->action_levels('S', $self->{'acts_array'}->[$i])) {
			local ($l, $p) = split(/\s+/, $s);
			local ($lvl) = ($self->indexof($l, @{$self->{'boot_array'}}) >= 0);
			local %daemon;
			if ($lvl && $self->{'config_hash'}->{'daemons_dir'} &&
			    $self->read_env_file("$self->{'config_hash'}->{'daemons_dir'}/$self->{'acts_array'}->[$i]",
					   \%daemon)) {
				$lvl = lc($daemon{'ONBOOT'}) eq 'yes' ? 1 : 0;
				}
			push(@{$self->{'actsb_array'}->[$i]}, [ $l, $p, $lvl ]);
			}
		@{$self->{'actsb_array'}->[$i]} = sort { $b->[2] <=> $a->[2] } @{$self->{'actsb_array'}->[$i]};
		}

	# Sort the actions if necessary
	@{$self->{'order_array'}} = ( 0 .. $#{$self->{'acts_array'}} );
	if ($self->{'config_hash'}->{'sort_mode'}) {
		@{$self->{'order_array'}} = sort { local $aa = $self->{'actsb_array'}->[$a]->[0];
				local $bb = $self->{'actsb_array'}->[$b]->[0];
				$bb->[2] <=> $aa->[2] ||
				$bb->[1] <=> $aa->[1] }
			      @{$self->{'order_array'}};
		}
	@{$self->{'acts_array'}} = map { $self->{'acts_array'}->[$_] } @{$self->{'order_array'}};
	@{$self->{'actsl_array'}} = map { $self->{'actsl_array'}->[$_] } @{$self->{'order_array'}};
	@{$self->{'actsf_array'}} = map { $self->{'actsf_array'}->[$_] } @{$self->{'order_array'}};
	@{$self->{'actsb_array'}} = map { $self->{'actsb_array'}->[$_] } @{$self->{'order_array'}};

	@{$self->{'links_array'}} = ( );
	if ($self->{'access_hash'}->{'bootup'} == 1) {
		push(@{$self->{'links_array'}},
			"<a href='edit_action.cgi?2'>$self->{'text_hash'}->{'index_add'}</a>");
		}
	print $self->ui_links_row(\@{$self->{'links_array'}});
	if (!$self->{'config_hash'}->{'desc'}) {
		# Display actions by name only
		print "<table width=100% border>\n";
		print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'index_title'}</b></td> </tr>\n";
		print "<tr $self->{'cb'}> <td><table width=100%>\n";
		$self->{'len'} = @{$self->{'acts_array'}}; $self->{'len'} = int(($self->{'len'}+3)/4)*4;
		for($i=0; $i<$self->{'len'}; $i++) {
			if ($i%4 == 0) { print "<tr>\n"; }
			print "<td width=25%>";
			if ($self->{'acts_array'}->[$i]) {
				print "<a href=\"edit_action.cgi?$self->{'actsl_array'}->[$i]\">",
				      "$self->{'acts_array'}->[$i]</a>\n";
				}
			print "</td>\n";
			if ($i%4 == 3) { print "</tr>\n"; }
			}
		print "</table></td></tr></table>\n";
		}
	else {
		# Display actions and descriptions
		print $self->ui_form_start("mass_start_stop.cgi", "post");
		print $self->ui_columns_start([
			"",
			$self->{'text_hash'}->{'index_action'},
			$self->{'config_hash'}->{'desc'} == 2 ? $self->{'text_hash'}->{'index_levels'}
					     : $self->{'text_hash'}->{'index_boot'},
			$self->{'config_hash'}->{'order'} ? ( $self->{'text_hash'}->{'index_order'} ) : ( ),
			$self->{'config_hash'}->{'status_check'} == 2 ? ( $self->{'text_hash'}->{'index_status'} ) : ( ),
			$self->{'text_hash'}->{'index_desc'} ],
			100);

		for($i=0; $i<@{$self->{'acts_array'}}; $i++) {
			local ($boot, %daemon, @levels, $order);
			foreach $s (@{$self->{'actsb_array'}->[$i]}) {
				if ($s->[2]) {
					$boot = 1;
					push(@levels,
					  "<font color=#ff0000>$s->[0]</font>");
					}
				else {
					push(@levels, $s->[0]);
					}
				}
			$order = $self->{'actsb_array'}->[$i]->[0]->[1];
			local @cols;
			push(@cols, "<a href=\"edit_action.cgi?".
			      	    "$self->{'actsl_array'}->[$i]\">$self->{'acts_array'}->[$i]</a>");
			local %has;
			$self->{'d'} = $self->html_escape($self->init_description($self->{'actsf_array'}->[$i],
				 $self->{'config_hash'}->{'status_check'} == 2 ? \%has : undef));
			if ($self->{'config_hash'}->{'desc'} == 2) {
				push(@cols, join(" ", @levels));
				}
			else {
				push(@cols,$boot ? $self->{'text_hash'}->{'yes'} :
				      "<font color=#ff0000>$self->{'text_hash'}->{'no'}</font>");
				}
			if ($self->{'config_hash'}->{'order'}) {
				push(@cols, $order);
				}
			if ($self->{'config_hash'}->{'status_check'} == 2) {
				if ($self->{'actsl_array'}->[$i] =~ /^0/) {
					local $out = $has{'status'} ?
						`$self->{'actsf_array'}->[$i] status` : '';
					if ($out =~ /running/i) {
						push(@cols, $self->{'text_hash'}->{'yes'});
						}
					elsif ($out =~ /stopped/i) {
						push(@cols,
							"<font color=#ff0000>".
							"$self->{'text_hash'}->{'no'}</font>");
						}
					else {
						push(@cols, undef);
						}
					}
				else {
					push(@cols, undef);
					}
				}
			push(@cols, $self->{'d'});
			if ($self->{'actsl_array'}->[$i] =~ /^0/) {
				print $self->ui_checked_columns_row(
					\@cols, undef, "idx", $self->{'order_array'}->[$i]);
				}
			else {
				print $self->ui_columns_row(\@cols);
				}
			}
		print $self->ui_columns_end();
		print "<input type=submit name=start value='$self->{'text_hash'}->{'index_start'}'>\n";
		print "<input type=submit name=stop value='$self->{'text_hash'}->{'index_stop'}'>\n";
		print "<input type=submit name=restart value='$self->{'text_hash'}->{'index_restart'}'>\n";
		if ($self->{'access_hash'}->{'bootup'} == 1) {
			# Show buttons to enable/disable at boot
			print "&nbsp;&nbsp;\n";
			print "<input type=submit name=addboot value='$self->{'text_hash'}->{'index_addboot'}'>\n";
			print "<input type=submit name=delboot value='$self->{'text_hash'}->{'index_delboot'}'>\n";
			print "&nbsp;&nbsp;\n";
			print "<input type=submit name=addboot_start value='$self->{'text_hash'}->{'index_addboot_start'}'>\n";
			print "<input type=submit name=delboot_stop value='$self->{'text_hash'}->{'index_delboot_stop'}'>\n";
			}
		}
	print "</form>\n";
	print $self->ui_links_row(\@{$self->{'links_array'}});
	print "<hr>\n";

	if ($self->{'access_hash'}->{'bootup'} == 1) {
		# Show runlevel switch form
		print "<form action=change_rl.cgi>\n";
		print "<table width=100%>\n";

		print "<tr> <td nowrap><input type=submit ",
		      "value='$self->{'text_hash'}->{'index_rlchange'}'>\n";
		print "<select name=level>\n";
		foreach $r (@{$self->{'runlevels_array'}}) {
			printf "<option %s>%s\n",
				$r eq $self->{'boot_array'}->[0] ? "selected" : "", $r;
			}
		print "</select></td> <td>$self->{'text_hash'}->{'index_rlchangedesc'}</td> </tr>\n";

		print "</table></form><hr>\n";
		}
	}
elsif ($self->{'init_mode'} eq "local" && $self->{'access_hash'}->{'bootup'} == 1) {
	# Display local bootup script
	if ($self->{'config_hash'}->{'hostconfig'}) {
		# This means a darwin system where
		# daemons are not started in the rc script
		print $self->text('index_script_mac',
			"<tt>$self->{'config_hash'}->{'local_script'}</tt>"),"<br>\n";
		}
	else {
		print $self->text('index_script',
			"<tt>$self->{'config_hash'}->{'local_script'}</tt>"),"<br>\n";
		}
	print "<form action=save_local.cgi method=post>\n";
	print "<textarea name=local rows=15 cols=80>";
	open(LOCAL, $self->{'config_hash'}->{'local_script'});
	while(<LOCAL>) { print $self->html_escape($_) }
	close(LOCAL);
	print "</textarea><br>\n";

	if ($self->{'config_hash'}->{'local_down'}) {
		# Show shutdown script too
		print $self->text('index_downscript',
			"<tt>$self->{'config_hash'}->{'local_down'}</tt>"),"<br>\n";
		print "<textarea name=down rows=15 cols=80>";
		open(LOCAL, $self->{'config_hash'}->{'local_down'});
		while(<LOCAL>) { print $self->html_escape($_) }
		close(LOCAL);
		print "</textarea><br>\n";
		}

	print "<input type=submit value='$self->{'text_hash'}->{'save'}'></form>\n";
	print "<hr>\n";
	}
elsif ($self->{'init_mode'} eq "win32" && $self->{'access_hash'}->{'bootup'}) {
	# Show Windows services
	print $self->ui_form_start("save_services.cgi", "post");
	print $self->select_all_link("d"),"\n";
	print $self->select_invert_link("d"),"<br>\n";
	print $self->ui_columns_start([ "", $self->{'text_hash'}->{'index_sname'},
				  $self->{'text_hash'}->{'index_sdesc'},
				  $self->{'text_hash'}->{'index_sboot'},
				  $self->{'text_hash'}->{'index_sstate'} ]);
	foreach $svc ($self->list_win32_services()) {
		print $self->ui_columns_row([
			$self->ui_checkbox("d", $svc->{'name'}, undef),
			$svc->{'name'},
			$svc->{'desc'},
			$self->{'text_hash'}->{'index_sboot'.$svc->{'boot'}} ||
			  $svc->{'boot_desc'},
			$self->{'text_hash'}->{'index_sstate'.$svc->{'state'}} ||
			  $svc->{'state_desc'},
			]);
		}
	print $self->ui_columns_end();
	print $self->select_all_link("d"),"\n";
	print $self->select_invert_link("d"),"<br>\n";
	print $self->ui_form_end([ [ "start", $self->{'text_hash'}->{'index_start'} ],
			     [ "stop", $self->{'text_hash'}->{'index_stop'} ],
			     undef,
			     [ "addboot", $self->{'text_hash'}->{'index_addboot'} ],
			     [ "delboot", $self->{'text_hash'}->{'index_delboot'} ],
			     undef,
			     [ "addboot_start", $self->{'text_hash'}->{'index_addboot_start'} ],
			     [ "delboot_stop", $self->{'text_hash'}->{'index_delboot_stop'} ],
			    ]);
	print "<hr>\n";
	}
elsif ($self->{'init_mode'} eq "rc" && $self->{'access_hash'}->{'bootup'}) {
	# Show FreeBSD scripts
	print $self->ui_form_start("mass_rcs.cgi", "post");
	@{$self->{'links_array'}} = ( $self->select_all_link("d"),
		   $self->select_invert_link("d"),
		   "<a href='edit_rc.cgi?new=1'>$self->{'text_hash'}->{'index_radd'}</a>" );
	print $self->ui_links_row(\@{$self->{'links_array'}});
	print $self->ui_columns_start([ "", $self->{'text_hash'}->{'index_rname'},
				  $self->{'text_hash'}->{'index_rdesc'},
				  $self->{'text_hash'}->{'index_rboot'} ]);
	foreach $rc ($self->list_rc_scripts()) {
		print $self->ui_columns_row([
			$self->ui_checkbox("d", $rc->{'name'}, undef),
			"<a href='edit_rc.cgi?name=".
			  $self->urlize($rc->{'name'})."'>$rc->{'name'}</a>",
			$rc->{'desc'},
			$rc->{'enabled'} == 1 ? $self->{'text_hash'}->{'yes'} :
			$rc->{'enabled'} == 2 ? "<i>$self->{'text_hash'}->{'index_unknown'}</i>":
				"<font color=#ff0000>$self->{'text_hash'}->{'no'}</font>",
			]);
		}
	print $self->ui_columns_end();
	print $self->ui_links_row(\@{$self->{'links_array'}});
	print $self->ui_form_end([ [ "start", $self->{'text_hash'}->{'index_start'} ],
			     [ "stop", $self->{'text_hash'}->{'index_stop'} ],
			     undef,
			     [ "addboot", $self->{'text_hash'}->{'index_addboot'} ],
			     [ "delboot", $self->{'text_hash'}->{'index_delboot'} ],
			     undef,
			     [ "addboot_start", $self->{'text_hash'}->{'index_addboot_start'} ],
			     [ "delboot_stop", $self->{'text_hash'}->{'index_delboot_stop'} ],
			    ]);
	print "<hr>\n";

	}

# reboot/shutdown buttons
print "<table cellpadding=5 width=100%>\n";
if ($self->{'access_hash'}->{'reboot'}) {
	print "<form action=reboot.cgi>\n";
	print "<tr> <td><input type=submit ",
	      "value=\"$self->{'text_hash'}->{'index_reboot'}\"></td>\n";
	print "</form>\n";
	print "<td>$self->{'text_hash'}->{'index_rebootmsg'}</td> </tr>\n";
	}

if ($self->{'access_hash'}->{'shutdown'}) {
	print "<form action=shutdown.cgi>\n";
	print "<tr> <td><input type=submit ",
	      "value=\"$self->{'text_hash'}->{'index_shutdown'}\"></td>\n";
	print "</form>\n";
	print "<td>$self->{'text_hash'}->{'index_shutdownmsg'}</td> </tr>\n";
	}
print "</table>\n";

$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});

1;
		
}


1;

