#!/usr/bin/perl

&MAIN();

 sub MAIN {
# mass_start_stop.cgi
# Start or stop multiple actions at once

&ModuleLoader::preload_module('init_class', "init::InitLib");
$self = new init::InitLib:: 'init_class',%$self;

%{$self->{'access_hash'}} = $self->get_module_acl();
$self->ReadParse();
@{$self->{'sel_array'}} = split(/\0/, $self->{'in_hash'}->{'idx'});
@{$self->{'sel_array'}} || $self->error($self->{'text_hash'}->{'mass_enone2'});

$self->{'start'} = 1 if ($self->{'in_hash'}->{'start'} || $self->{'in_hash'}->{'addboot_start'});
$self->{'stop'} = 1 if ($self->{'in_hash'}->{'stop'} || $self->{'in_hash'}->{'delboot_stop'});
$self->{'restart'} = 1 if ($self->{'in_hash'}->{'restart'});
$self->{'enable'} = 1 if ($self->{'in_hash'}->{'addboot'} || $self->{'in_hash'}->{'addboot_start'});
$self->{'disable'} = 1 if ($self->{'in_hash'}->{'delboot'} || $self->{'in_hash'}->{'delboot_stop'});

$self->ui_print_unbuffered_header(undef, $self->{'start'} || $self->{'enable'} ? $self->{'text_hash'}->{'mass_start'} :
				   $self->{'restart'} ? $self->{'text_hash'}->{'mass_restart'} :
					      $self->{'text_hash'}->{'mass_stop'}, "");

if ($self->{'start'} || $self->{'stop'} || $self->{'restart'}) {
	# Starting or stopping a bunch of actions
	$self->foreign_require("proc", "proc-lib.pl");
	$self->{'access_hash'}->{'bootup'} || $self->error($self->{'text_hash'}->{'ss_ecannot'});

	# build list of normal and broken actions
	($self->{'initrl'}) = $self->get_inittab_runlevel();
	@{$self->{'iacts_array'}} = $self->list_actions();
	foreach $a (@{$self->{'iacts_array'}}) {
		@{$self->{'ac_array'}} = split(/\s+/, $a);
		push(@{$self->{'acts_array'}}, $self->{'ac_array'}->[0]);
		local $order = "9" x $self->{'config_hash'}->{'order_digits'};
		if ($self->{'ac_array'}->[0] =~ /^\//) {
			push(@{$self->{'actsf_array'}}, $self->{'ac_array'}->[0]);
			}
		else {
			push(@{$self->{'actsf_array'}}, "$self->{'config_hash'}->{'init_dir'}/$self->{'ac_array'}->[0]");
			local @lvls = $self->action_levels(
				$self->{'start'} || $self->{'restart'} ? 'S' : 'K', $self->{'ac_array'}->[0]);
			foreach $lon (@lvls) {
				local ($l, $o, $n) = split(/\s+/, $lon);
				if ($l eq $self->{'initrl'}) {
					$order = $o;
					last;
					}
				}
			}
		push(@{$self->{'orders_array'}}, $order);
		}

	if ($self->{'start'} || $self->{'restart'}) {
		@{$self->{'sel_array'}} = sort { $self->{'orders_array'}->[$a] <=> $self->{'orders_array'}->[$b] } @{$self->{'sel_array'}};
		}
	else {
		@{$self->{'sel_array'}} = sort { $self->{'orders_array'}->[$b] <=> $self->{'orders_array'}->[$a] } @{$self->{'sel_array'}};
		}
	foreach $idx (@{$self->{'sel_array'}}) {
		local $cmd = "$self->{'actsf_array'}->[$idx] ".($self->{'start'} ? "start" :
					      $self->{'restart'} ? "restart" :
						         "stop");
		print $self->text('ss_exec', "<tt>$cmd</tt>"),"<p>\n";
		print "<pre>";
		$self->foreign_call("proc", "safe_process_exec_logged", $cmd, 0, 0, STDOUT, undef, 1);
		print "</pre>\n";
		push(@{$self->{'selacts_array'}}, $self->{'acts_array'}->[$idx]);
		}
	$self->webmin_log($self->{'start'} ? 'massstart' :
		    $self->{'restart'} ? 'massrestart' : 'massstop', 'action',
		    join(" ", @{$self->{'selacts_array'}}));
	}

if ($self->{'enable'} || $self->{'disable'}) {
	# Enabling or disabling a bunch of actions
	$self->{'access_hash'}->{'bootup'} == 1 || $self->error($self->{'text_hash'}->{'edit_ecannot'});
	@{$self->{'iacts_array'}} = $self->list_actions();
	foreach $a (@{$self->{'iacts_array'}}) {
		@{$self->{'ac_array'}} = split(/\s+/, $a);
		push(@{$self->{'acts_array'}}, $self->{'ac_array'}->[0]);
		}
	@{$self->{'toboot_array'}} = map { $self->{'acts_array'}->[$_] } @{$self->{'sel_array'}};
	foreach $b (@{$self->{'toboot_array'}}) {
		if ($b =~ /^\//) {
			$self->error($self->text('mass_ebroken', $self->{'ac_array'}->[0]));
			}
		}
	if ($self->{'enable'}) {
		# Enable them all
		foreach $b (@{$self->{'toboot_array'}}) {
			print $self->text('mass_enable', "<tt>$b</tt>"),"<p>\n";
			$self->enable_at_boot($b);
			}
		}
	else {
		# Disable them all
		foreach $b (@{$self->{'toboot_array'}}) {
			print $self->text('mass_disable', "<tt>$b</tt>"),"<p>\n";
			$self->disable_at_boot($b);
			}
		}
	$self->webmin_log($self->{'enable'} ? 'massenable' : 'massdisable', 'action',
		    join(" ", @{$self->{'toboot_array'}}));
	}

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

