#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_action.cgi
# Save or create an action

&ModuleLoader::preload_module('init_class', "init::InitLib");
$self = new init::InitLib:: 'init_class',%$self;

$self->error_setup($self->{'text_hash'}->{'save_err'});
%{$self->{'access_hash'}} = $self->get_module_acl();
$self->{'access_hash'}->{'bootup'} == 1 || $self->error($self->{'text_hash'}->{'save_ecannot'});
$self->ReadParseMime();

# Check inputs
$self->{'in_hash'}->{'extra'} || $self->{'in_hash'}->{name} =~ /^[A-z0-9\_\-\.]+$/ ||
	$self->error($self->{'text_hash'}->{'save_ename'});
$self->{'dig'} = $self->{'config_hash'}->{'order_digits'};
foreach $rl ($self->list_runlevels()) {
	# If no priority was given for start/stop, make it 99
	if ($self->{'in_hash'}->{"S$rl"}) {
		if (!$self->{'in_hash'}->{"pri_S$rl"}) {
			$self->{'in_hash'}->{"pri_S$rl"} = "9" x $self->{'dig'};
			}
		else {
			$self->{'in_hash'}->{"pri_S$rl"} = sprintf "%{$self->{'dig'}}.$self->{'dig'}d",
						  $self->{'in_hash'}->{"pri_S$rl"};
			}
		}
	if ($self->{'in_hash'}->{"K$rl"}) {
		if (!$self->{'in_hash'}->{"pri_K$rl"}) {
			$self->{'in_hash'}->{"pri_K$rl"} = "9" x $self->{'dig'};
			}
		else {
			$self->{'in_hash'}->{"pri_K$rl"} = sprintf "%{$self->{'dig'}}.$self->{'dig'}d",
						  $self->{'in_hash'}->{"pri_K$rl"};
			}
		}
	}

if ($self->{'in_hash'}->{'old'} && $self->{'in_hash'}->{'type'} == 0) {
	# Changing a 'sane' action
	local $dd = $self->{'config_hash'}->{'daemons_dir'};
	$self->{'in_hash'}->{data} =~ s/\r//g;
	if ($self->{'in_hash'}->{old} ne $self->{'in_hash'}->{name}) {
		# Need to rename the action..
		if (-r $self->action_filename($self->{'in_hash'}->{name})) {
			$self->error($self->text('save_ealready', $self->{'in_hash'}->{name}));
			}
		$self->rename_action($self->{'in_hash'}->{old}, $self->{'in_hash'}->{name});
		if ($dd) {
			# Need to rename the caldera daemons file too
			$self->rename_logged("$dd/$self->{'in_hash'}->{old}", "$dd/$self->{'in_hash'}->{name}");
			$self->lock_file("$dd/$self->{'in_hash'}->{'name'}");
			$self->read_env_file("$dd/$self->{'in_hash'}->{name}", \%{$self->{'daemon_hash'}});
			$self->{'daemon_hash'}->{'IDENT'} = $self->{'in_hash'}->{'name'}
				if ($self->{'daemon_hash'}->{'IDENT'} eq $self->{'in_hash'}->{'old'});
			$self->write_env_file("$dd/$self->{'in_hash'}->{name}", \%{$self->{'daemon_hash'}});
			}
		}
	$self->lock_file("$dd/$self->{'in_hash'}->{'name'}") if ($dd);
	$self->{'file'} = $self->action_filename($self->{'in_hash'}->{name});
	$self->lock_file($self->{'file'});
	foreach ($self->action_levels('S', $self->{'in_hash'}->{name})) {
		/^(\S+)\s+(\S+)\s+(\S+)$/;
		$self->{'slvl_hash'}->{$1} = $2;
		}
	foreach ($self->action_levels('K', $self->{'in_hash'}->{name})) {
		/^(\S+)\s+(\S+)\s+(\S+)$/;
		$self->{'klvl_hash'}->{$1} = $2;
		}
	if ($self->{'config_hash'}->{'expert'}) {
		# Update all runlevels
		foreach $rl ($self->list_runlevels()) {
			if ($self->{'in_hash'}->{"S$rl"} && !$self->{'slvl_hash'}->{$rl}) {
				$self->add_rl_action($self->{'in_hash'}->{name}, $rl,
					       'S', $self->{'in_hash'}->{"pri_S$rl"});
				}
			elsif (!$self->{'in_hash'}->{"S$rl"} && $self->{'slvl_hash'}->{$rl}) {
				$self->delete_rl_action($self->{'in_hash'}->{name}, $rl, 'S');
				}
			elsif ($self->{'in_hash'}->{"pri_S$rl"} != $self->{'slvl_hash'}->{$rl}) {
				$self->reorder_rl_action($self->{'in_hash'}->{name}, $rl,
						   'S', $self->{'in_hash'}->{"pri_S$rl"});
				}
			if ($self->{'in_hash'}->{"K$rl"} && !$self->{'klvl_hash'}->{$rl}) {
				$self->add_rl_action($self->{'in_hash'}->{name}, $rl,
					       'K', $self->{'in_hash'}->{"pri_K$rl"});
				}
			elsif (!$self->{'in_hash'}->{"K$rl"} && $self->{'klvl_hash'}->{$rl}) {
				$self->delete_rl_action($self->{'in_hash'}->{name}, $rl, 'K');
				}
			elsif ($self->{'in_hash'}->{"pri_K$rl"} != $self->{'klvl_hash'}->{$rl}) {
				$self->reorder_rl_action($self->{'in_hash'}->{name}, $rl,
						   'K',$self->{'in_hash'}->{"pri_K$rl"});
				}
			}

		if (defined($self->{'in_hash'}->{'boot'}) && $dd) {
			# Update onboot flag in daemons file
			$self->read_env_file("$dd/$self->{'in_hash'}->{'name'}", \%{$self->{'daemon_hash'}});
			$self->{'daemon_hash'}->{'ONBOOT'} = $self->{'in_hash'}->{'boot'} ? 'yes' : 'no';
			$self->write_env_file("$dd/$self->{'in_hash'}->{'name'}", \%{$self->{'daemon_hash'}});
			}
		}
	else {
		# Just change whether it gets started or not
		if ($self->{'in_hash'}->{'boot'} && !$self->{'in_hash'}->{'oldboot'}) {
			$self->enable_at_boot($self->{'in_hash'}->{'name'});
			}
		elsif (!$self->{'in_hash'}->{'boot'} && $self->{'in_hash'}->{'oldboot'}) {
			$self->disable_at_boot($self->{'in_hash'}->{'name'});
			}
		}
	$self->open_tempfile(ACTION, ">$self->{'file'}");
	$self->print_tempfile(ACTION, $self->{'in_hash'}->{data});
	$self->close_tempfile(ACTION);
	$self->unlock_file($self->{'file'});
	$self->unlock_file("$dd/$self->{'in_hash'}->{'name'}") if ($dd);
	delete($self->{'in_hash'}->{'data'});
	$self->webmin_log("modify", "action", $self->{'in_hash'}->{'name'}, \%{$self->{'in_hash'}});
	}
elsif ($self->{'in_hash'}->{'old'} && $self->{'in_hash'}->{'type'} == 1) {
	# Changing an odd action
	$self->{'in_hash'}->{data} =~ s/\r//g;
	$self->{'file'} = $self->runlevel_filename($self->{'in_hash'}->{runlevel}, $self->{'in_hash'}->{startstop},
				   $self->{'in_hash'}->{number}, $self->{'in_hash'}->{name});
	$self->lock_file($self->{'file'});
	if ($self->{'in_hash'}->{old} ne $self->{'in_hash'}->{name}) {
		if (-r $self->action_filename($self->{'in_hash'}->{name})) {
			$self->error("An action called $self->{'in_hash'}->{name} already exists");
			}
		$self->rename_rl_action($self->{'in_hash'}->{runlevel}, $self->{'in_hash'}->{startstop}, $self->{'in_hash'}->{number},
				  $self->{'in_hash'}->{old}, $self->{'in_hash'}->{name});
		}
	$self->open_tempfile(ACTION, ">$self->{'file'}");
	$self->print_tempfile(ACTION, $self->{'in_hash'}->{data});
	$self->close_tempfile(ACTION);
	$self->unlock_file($self->{'file'});
	delete($self->{'in_hash'}->{'data'});
	$self->webmin_log("modify", "action", $self->{'in_hash'}->{'name'}, \%{$self->{'in_hash'}});
	}
else {
	# Creating a new action, and add it to multiple runlevels
	if (-r $self->action_filename($self->{'in_hash'}->{name})) {
		$self->error($self->text('save_ealready', $self->{'in_hash'}->{name}));
		}
	@{$self->{'start_array'}} = $self->get_start_runlevels();
	$self->lock_file($self->action_filename($self->{'in_hash'}->{name}));
	$self->{'in_hash'}->{desc} =~ s/\r//g; $self->{'in_hash'}->{start} =~ s/\r//g; $self->{'in_hash'}->{stop} =~ s/\r//g;
	if ($self->{'config_hash'}->{'chkconfig'}) {
		# Redhat-style description: and chkconfig: lines
		$self->{'desc'} = "description:";
		foreach (split(/\n/, $self->{'in_hash'}->{desc})) {
			$self->{'data'} .= "# $self->{'desc'} $_\n";
			$self->{'desc'} = " " x length($self->{'desc'});
			}
		$self->{'startorder'} = "9" x $self->{'dig'};
		$self->{'stoporder'} = "0" x $self->{'dig'};
		foreach $rl ($self->list_runlevels()) {
			$self->{'startorder'} = $self->{'in_hash'}->{"pri_S$rl"} if ($self->{'in_hash'}->{"S$rl"});
			$self->{'stoporder'} = $self->{'in_hash'}->{"pri_K$rl"} if ($self->{'in_hash'}->{"K$rl"});
			}
		$self->{'data'} .= "# chkconfig: $self->{'config_hash'}->{'chkconfig'} ".
			 "$self->{'startorder'} $self->{'stoporder'}\n";
		}
	elsif ($self->{'config_hash'}->{'init_info'}) {
		# Suse-style init info section
		$self->{'data'} .= "### BEGIN INIT INFO\n".
			 "# Provides: $self->{'in_hash'}->{'name'}\n".
		         "# Required-Start: \$network\n".
		         "# Required-Stop: \$network\n".
			 "# Default-Start: ".join(" ", @{$self->{'start_array'}})."\n".
			 "# Description: $self->{'in_hash'}->{'desc'}\n".
			 "### END INIT INFO\n";
		}
	else {
		foreach (split(/\n/, $self->{'in_hash'}->{'desc'})) {
			$self->{'data'} .= "# $_\n";
			}
		}
	$self->{'data'} .= "\ncase \"\$1\" in\n";
	if ($self->{'config_hash'}->{'start_stop_msg'}) {
		$self->{'data'} .= "'start_msg')\n";
		$self->{'data'} .= "\techo \"$self->{'in_hash'}->{'start_msg'}\"\n";
		$self->{'data'} .= "\t;;\n";
		$self->{'data'} .= "'stop_msg')\n";
		$self->{'data'} .= "\techo \"$self->{'in_hash'}->{'stop_msg'}\"\n";
		$self->{'data'} .= "\t;;\n";
		}
	$self->{'subsys'} = $self->{'config_hash'}->{'subsys'};
	$self->{'data'} .= "'start')\n";
	foreach (split(/\n/, $self->{'in_hash'}->{start})) {
		$self->{'data'} .= "\t$_\n";
		}
	if ($self->{'subsys'}) {
		$self->{'data'} .= "\ttouch $self->{'subsys'}/$self->{'in_hash'}->{'name'}\n";
		}
	$self->{'data'} .= "\t;;\n";
	$self->{'data'} .= "'stop')\n";
	foreach (split(/\n/, $self->{'in_hash'}->{stop})) {
		$self->{'data'} .= "\t$_\n";
		}
	if ($self->{'subsys'}) {
		$self->{'data'} .= "\trm -f $self->{'subsys'}/$self->{'in_hash'}->{'name'}\n";
		}
	$self->{'data'} .= "\t;;\n";
	$self->{'data'} .= "*)\n";
	if ($self->{'config_hash'}->{'start_stop_msg'}) {
		$self->{'data'} .= "\techo \"Usage: \$0 { start | stop | start_msg | stop_msg }\"\n";
		}
	else {
		$self->{'data'} .= "\techo \"Usage: \$0 { start | stop }\"\n";
		}
	$self->{'data'} .= "\t;;\n";
	$self->{'data'} .= "esac\n";
	$self->{'data'} .= "exit 0\n";
	$self->{'file'} = $self->action_filename($self->{'in_hash'}->{name});
	$self->open_tempfile(ACTION, ">$self->{'file'}");
	$self->print_tempfile(ACTION, $self->{'data'});
	$self->close_tempfile(ACTION);
	chmod(0755, $self->{'file'});

	if ($self->{'config_hash'}->{'expert'}) {
		# Make links from runlevels
		foreach $rl ($self->list_runlevels()) {
			if ($self->{'in_hash'}->{"S$rl"}) {
				$self->add_rl_action($self->{'in_hash'}->{name}, $rl, 'S',
					       $self->{'in_hash'}->{"pri_S$rl"});
				}
			if ($self->{'in_hash'}->{"K$rl"}) {
				$self->add_rl_action($self->{'in_hash'}->{name}, $rl, 'K',
					       $self->{'in_hash'}->{"pri_K$rl"});
				}
			}
		}
	else {
		# Just make one runlevel link
		if ($self->{'in_hash'}->{'boot'}) {
			$self->enable_at_boot($self->{'in_hash'}->{'name'});
			}
		}
	$self->unlock_file($self->action_filename($self->{'in_hash'}->{name}));
	delete($self->{'in_hash'}->{'data'});
	$self->webmin_log("create", "action", $self->{'in_hash'}->{'name'}, \%{$self->{'in_hash'}});
	}
$self->redirect("");

1;
		
}


1;

