#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_hostconfig_action.cgi
#
# Creates a new StartupItems directory containing a script and
# plist, and adds the appropriate entry into the hostconfig file.
#
# Written by Michael A. Peters <mpeters@mac.com> for the webmin init 
# module for Darwin and OS X.

&ModuleLoader::preload_module('init_class', "init::InitLib");
$self = new init::InitLib:: 'init_class',%$self;

%{$self->{'access_hash'}} = $self->get_module_acl();
$self->{'access_hash'}->{'bootup'} == 1 || $self->error("You are not allowed to edit the bootup script");
$self->ReadParse();

#make sure required fields have been filled out
if ( $self->{'in_hash'}->{'action_name'} eq "" ) {
	$self->error("The $self->{'text_hash'}->{'edit_hostconfig_actionname'} field may not be left blank");
	}
elsif ( $self->{'in_hash'}->{'script_name'} eq "" ) {
	$self->error("The $self->{'text_hash'}->{'edit_hostconfig_scriptname'} field may not be left blank");
	}
elsif ( $self->{'in_hash'}->{'execute'} eq "" ) {
	$self->error("The $self->{'text_hash'}->{'edit_start'} field may not be left blank");
	}
	
#check for legality of action name and script name
if (not $self->{'in_hash'}->{'action_name'}=~ /^[A-Z][A-Z0-9_]*$/ ) {
	$self->error("The $self->{'text_hash'}->{'edit_hostconfig_actionname'} should contain only upper case letters, numbers, and _ and should start with an upper case letter");
	}
else {
	#make sure action name is not in use
	open(LOCAL, $self->{'config_hash'}->{'hostconfig'});
	@{$self->{'temp_array'}} = <LOCAL>;
	close(LOCAL);
	foreach $element (@{$self->{'temp_array'}}) {
		if ($element =~ /^$self->{'in_hash'}->{'action_name'}=(.*)$/ ) {
			$self->error("$self->{'in_hash'}->{'action_name'} is already in use. Please choose another value for $self->{'text_hash'}->{'edit_hostconfig_actionname'}");
			}
		}
	}
if (not $self->{'in_hash'}->{'script_name'}=~ /^[A-Za-z0-9_-]*$/ ) {
	$self->error("The $self->{'text_hash'}->{'edit_hostconfig_scriptname'} should contain only letters, numbers, _, and -");
	}
else {
	if ( -d "$self->{'config_hash'}->{'darwin_setup'}/$self->{'in_hash'}->{'script_name'}" ) {
	# Perl does know about hfs+ preservation but not sensitivity-
	# I checked :)
		$self->error("$self->{'in_hash'}->{'script_name'} is already in use for another action. Please choose another value for $self->{'text_hash'}->{'edit_hostconfig_scriptname'}");
		}
	}

#assign values	
$self->{'in_hash'}->{'execute'} =~ s/\r//g;
if ( $self->{'in_hash'}->{'start'} eq "" ) {
	$self->{'in_hash'}->{'start'} = "Starting $self->{'in_hash'}->{'script_name'}";
	}
if ( $self->{'in_hash'}->{'stop'} eq "" ) {
	$self->{'in_hash'}->{'stop'} = "Stopping $self->{'in_hash'}->{'script_name'}";
	}
if ( $self->{'in_hash'}->{'description'} eq "" ) {
	$self->{'in_hash'}->{'description'} = "No description available";
	}
	
#assign array values
if ( $self->{'in_hash'}->{'provides'} ne "" ) {
	@{$self->{'provides_array_array'}} = split (/:/, $self->{'in_hash'}->{'provides'});
	$self->{'provides'} = "\"$self->{'provides_array_array'}->[0]\"";
	if ( $self->{'provides_array_array'}->[1] ne "" ) {
		shift @{$self->{'provides_array_array'}};
		foreach $element (@{$self->{'provides_array_array'}}) {
			$self->{'provides'} = "$self->{'provides'}, \"$element\""
			}
		}
	}
if ( $self->{'in_hash'}->{'requires'} ne "" ) {
	@{$self->{'requires_array_array'}} = split (/:/, $self->{'in_hash'}->{'requires'});
	$self->{'requires'} = "\"$self->{'requires_array_array'}->[0]\"";
	if ( $self->{'requires_array_array'}->[1] ne "" ) {
		shift @{$self->{'requires_array_array'}};
		foreach $element (@{$self->{'requires_array_array'}}) {
			$self->{'requires'} = "$self->{'requires'}, \"$element\""
			}
		}
	}
if ( $self->{'in_hash'}->{'uses'} ne "" ) {
	@{$self->{'uses_array_array'}} = split (/:/, $self->{'in_hash'}->{'uses'});
	$self->{'uses'} = "\"$self->{'uses_array_array'}->[0]\"";
	if ( $self->{'uses_array_array'}->[1] ne "" ) {
		shift @{$self->{'uses_array_array'}};
		foreach $element (@{$self->{'uses_array_array'}}) {
			$self->{'uses'} = "$self->{'uses'}, \"$element\""
			}
		}
	}

# make array string
$self->{'array'}="";
if ( $self->{'provides'} ne "" ) {
	$self->{'array'} = "\tProvides\t= \($self->{'provides'}\);\n";
	}
if ( $self->{'requires'} ne "" ) {
	$self->{'array'} = "$self->{'array'}\tRequires\t= \($self->{'requires'}\);\n";
	}
if ( $self->{'uses'} ne "" ) {
	$self->{'array'} = "$self->{'array'}\tUses\t= \($self->{'uses'}\);\n";
	}
	
# make plist
$self->{'plist'} = "\{\n\tDescription\t= \"$self->{'in_hash'}->{'description'}\";\n$self->{'array'}\tOrderPreference\t= \"$self->{'in_hash'}->{'order'}\";\n\tMessages =\n\t\{\n\t\tstart\t= \"$self->{'in_hash'}->{'start'}\";\n\t\tstop\t=\"$self->{'in_hash'}->{'stop'}\";\n\t\};\n\}\n";

# make startscript

# So write the files already!
if (not -d "$self->{'config_hash'}->{'darwin_setup'}") {
	mkdir ("$self->{'config_hash'}->{'darwin_setup'}", 0755);
	}
# startup dir for this action should not yet exist
mkdir ("$self->{'config_hash'}->{'darwin_setup'}/$self->{'in_hash'}->{'script_name'}", 0755) || $self->error("Could not create $self->{'config_hash'}->{'darwin_setup'}/$self->{'in_hash'}->{'script_name'}");

$self->open_tempfile(LOCAL, ">$self->{'config_hash'}->{'darwin_setup'}/$self->{'in_hash'}->{'script_name'}/$self->{'config_hash'}->{'plist'}");
$self->print_tempfile(LOCAL, $self->{'plist'});
$self->close_tempfile(LOCAL);
chmod(0644, "$self->{'config_hash'}->{'darwin_setup'}/$self->{'in_hash'}->{'script_name'}/$self->{'config_hash'}->{'plist'}");

$self->open_tempfile(LOCAL, ">$self->{'config_hash'}->{'darwin_setup'}/$self->{'in_hash'}->{'script_name'}/$self->{'in_hash'}->{'script_name'}");
$self->print_tempfile(LOCAL, $self->{'startscript'});
$self->close_tempfile(LOCAL);
chmod(0750, "$self->{'config_hash'}->{'darwin_setup'}/$self->{'in_hash'}->{'script_name'}/$self->{'in_hash'}->{'script_name'}");

$self->lock_file($self->{'config_hash'}->{'hostconfig'});
$self->open_tempfile(LOCAL, ">>$self->{'config_hash'}->{'hostconfig'}");
$self->print_tempfile(LOCAL, "$self->{'in_hash'}->{'action_name'}=$self->{'in_hash'}->{'boot'}\n");
$self->close_tempfile(LOCAL);
$self->unlock_file($self->{'config_hash'}->{'hostconfig'});
$self->webmin_log("new_action", undef, undef, \%{$self->{'in_hash'}});
$self->redirect("edit_hostconfig.cgi?0+$self->{'in_hash'}->{'action_name'}");

#print "Content-type: text/plain", "\n\n";
#print "Debug\n\n";
#print "$self->{'plist'}";
#print "\n\n";
#print "$self->{'startscript'}";
#print "\n";
1;
		
}


1;

