#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Create, update or delete a BSD RC script

&ModuleLoader::preload_module('init_class', "init::InitLib");
$self = new init::InitLib:: 'init_class',%$self;

$self->ReadParse();
%{$self->{'access_hash'}} = $self->get_module_acl();
$self->{'access_hash'}->{'bootup'} || $self->error($self->{'text_hash'}->{'edit_ecannot'});
$self->foreign_require("proc", "proc-lib.pl");

@{$self->{'rcs_array'}} = $self->list_rc_scripts();
if (!$self->{'in_hash'}->{'new'}) {
	($self->{'rc'}) = grep { $_->{'name'} eq $self->{'in_hash'}->{'name'} } @{$self->{'rcs_array'}};
	$self->{'rc'} || $self->error($self->{'text_hash'}->{'edit_egone'});
	}

if ($self->{'in_hash'}->{'delete'}) {
	# Delete the action script
	$self->lock_file($self->{'rc'}->{'file'});
	unlink($self->{'rc'}->{'file'});
	$self->unlock_file($self->{'rc'}->{'file'});
	$self->webmin_log("delete", "action", $self->{'in_hash'}->{'name'});
	$self->redirect("");
	}
elsif ($self->{'in_hash'}->{'start'} || $self->{'in_hash'}->{'stop'} || $self->{'in_hash'}->{'status'}) {
	# Run now
	$self->{'mode'} = $self->{'in_hash'}->{'start'} ? "start" :
		$self->{'in_hash'}->{'stop'} ? "stop" : "status";
	$self->ui_print_header(undef, $self->{'text_hash'}->{'ss_'.$self->{'mode'}}, "");
	print $self->text('ss_doing'.$self->{'mode'}, "<tt>$self->{'in_hash'}->{'name'}</tt>"),"<br>\n";
	$self->{'cmd'} = "$self->{'rc'}->{'file'} $self->{'mode'}";
	print "<pre>";
	$self->foreign_call("proc", "safe_process_exec_logged", $self->{'cmd'}, 0, 0, STDOUT, undef, 1);
	print "</pre>\n";
	$self->webmin_log($self->{'mode'}, 'action', $self->{'in_hash'}->{'name'});
	$self->ui_print_footer("edit_rc.cgi?name=".$self->urlize($self->{'in_hash'}->{'name'}),
			 $self->{'text_hash'}->{'edit_return'});
	}
else {
	# Validate inputs
	if ($self->{'in_hash'}->{'new'}) {
		$self->{'in_hash'}->{'name'} =~ /^[A-z0-9\_\-\.]+$/ ||
			$self->error($self->{'text_hash'}->{'save_ename'});
		($self->{'clash'}) = grep { $_->{'name'} eq $self->{'in_hash'}->{'name'} } @{$self->{'rcs_array'}};
		$self->{'clash'} && $self->error($self->{'text_hash'}->{'save_eclash'});
		$self->{'in_hash'}->{'start_cmd'} =~ /\S/ || $self->error($self->{'text_hash'}->{'save_estartcmd'});

		@{$self->{'dirs_array'}} = split(/\s+/, $self->{'config_hash'}->{'rc_dir'});
		$self->{'file'} = $self->{'dirs_array'}->[$#{$self->{'dir_array'}}]."/".$self->{'in_hash'}->{'name'};
		$self->{'data'} .= "#\n";
		$self->{'data'} .= "# PROVIDE: $self->{'in_hash'}->{'name'}\n";
		$self->{'data'} .= "# REQUIRE: LOGIN\n";
		$self->{'data'} .= "\n";
		$self->{'data'} .= ". /etc/rc.subr\n";
		$self->{'data'} .= "\n";
		$self->{'data'} .= "name=$self->{'in_hash'}->{'name'}\n";
		$self->{'data'} .= "rcvar=`set_rcvar`\n";
		$self->{'data'} .= "start_cmd=\"$self->{'in_hash'}->{'start_cmd'}\"\n";
		if ($self->{'in_hash'}->{'stop_cmd'}) {
			$self->{'data'} .= "stop_cmd=\"$self->{'in_hash'}->{'stop_cmd'}\"\n";
			}
		if ($self->{'in_hash'}->{'status_cmd'}) {
			$self->{'data'} .= "status_cmd=\"$self->{'in_hash'}->{'status_cmd'}\"\n";
			}
		$self->{'data'} .= "\n";
		$self->{'data'} .= "load_rc_config \${name}\n";
		$self->{'data'} .= "run_rc_command \"\$1\"\n";
		}
	else {
		$self->{'data'} = $self->{'in_hash'}->{'script'};
		$self->{'data'} =~ s/\r//g;
		$self->{'data'} =~ /\S/ || $self->error($self->{'text_hash'}->{'save_escript'});
		$self->{'file'} = $self->{'rc'}->{'file'};
		}

	# Write out the file
	$self->open_lock_tempfile(SCRIPT, ">$self->{'file'}");
	$self->print_tempfile(SCRIPT, $self->{'data'});
	$self->close_tempfile(SCRIPT);
	$self->set_ownership_permissions(undef, undef, 0755, $self->{'file'});

	if ($self->{'rc'}->{'enabled'} != 2) {
		# Enable or disable
		$self->lock_rc_files();
		if ($self->{'in_hash'}->{'enabled'}) {
			$self->enable_rc_script($self->{'in_hash'}->{'name'});
			}
		else {
			$self->disable_rc_script($self->{'in_hash'}->{'name'});
			}
		$self->unlock_rc_files();
		}

	$self->webmin_log($self->{'in_hash'}->{'new'} ? "create" : "modify", "action", $self->{'in_hash'}->{'name'});
	$self->redirect("");
	}

1;
		
}


1;

