#!/usr/bin/perl
package ipfilter::Log_parser;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'ipfilter::Log_parser');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# log_parser.pl
# Functions for parsing this module's logs

&ModuleLoader::preload_module(ref($self), "ipfilter::IpfilterLib");
$self = new ipfilter::IpfilterLib:: ref($self), %$self; 

1;
		return $self;
}

# parse_webmin_log(user, script, action, type, object, &params)
# Converts logged information from this module into human-readable form
sub parse_webmin_log
{
	my $self = shift;

local ($user, $script, $action, $type, $object, $p, $long) = @_;
if ($action eq "delsel") {
	return $self->text($type eq "nat" ? 'log_delselnat'
				    : 'log_delsel', $p->{'count'});
	}
elsif ($type eq "rule") {
	return $self->text("log_${action}_rule".($long ? "_l" : ""),
		     $self->{'text_hash'}->{'action_'.$p->{'action'}},
		     $self->describe_rule($p, 1));
	}
elsif ($type eq "nat") {
	return $self->text("log_${action}_nat".($long ? "_l" : ""),
		     $self->{'text_hash'}->{'action_'.$p->{'action'}},
		     $self->describe_from($p, 1),
		     $self->describe_to($p, 1));
	}
elsif ($type eq "host" || $type eq "group") {
        return $self->text("log_${action}_${type}", "<tt>$object</tt>");
        }
else {
	return $self->{'text_hash'}->{"log_$action"};
	}
}


1;

