#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Display a form for editing or creating a NAT rule

&ModuleLoader::preload_module('ipfilter_class', "ipfilter::IpfilterLib");
$self = new ipfilter::IpfilterLib:: 'ipfilter_class',%$self;

$self->ReadParse();
$self->{'rules'} = $self->get_ipnat_config();

if ($self->{'in_hash'}->{'delsel'}) {
	# Special case - deleting selected rules
	@{$self->{'nums_array'}} = sort { $b cmp $a } split(/\0/, $self->{'in_hash'}->{'d'});
	if (@{$self->{'nums_array'}}) {
		$self->lock_file($self->{'rules'}->[$self->{'nums_array'}->[0]]->{'file'});
		foreach $n (@{$self->{'nums_array'}}) {
			$self->delete_rule($self->{'rules'}->[$n]);
			}
		$self->flush_file_lines();
		$self->unlock_file($self->{'rules'}->[$self->{'nums_array'}->[0]]->{'file'});
		$self->webmin_log("delsel", "nat", undef,
			    { 'count' => scalar(@{$self->{'nums_array'}}) });
		}
	$self->redirect("");
	exit;
	}

if ($self->{'in_hash'}->{'newmap'} || $self->{'in_hash'}->{'newrdr'}) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'nat_title1'}, "");
	$self->{'rdr'} = $self->{'in_hash'}->{'newrdr'} ? 1 : 0;
	$self->{'rule'} = { 'action' => $self->{'rdr'} ? 'rdr' : 'map',
		  'active' => 1,
		  'toip' => '0.0.0.0', 'tomask' => 32 };
	}
else {
	$self->{'rule'} = $self->{'rules'}->[$self->{'in_hash'}->{'idx'}];
	$self->ui_print_header(undef, $self->{'text_hash'}->{'nat_title2'}, "");
	$self->{'rdr'} = $self->{'rule'}->{'action'} eq 'rdr' ? 1 : 0;
	}

if (!$self->{'rdr'}) {
	# Javascript for disabling fields
	print <<EOF;
<script>
function from_change(dis)
{
var f = document.forms[0];
for(i=0; i<f.elements.length; i++) {
        e = f.elements[i];
	if (e.name.substring(0, 4) == "from" &&
	    e.name != "frommode" && e.name != "fromip" &&
	    e.name != "frommask") {
		e.disabled = dis;
		}
	}
}
</script>
EOF
	}

print $self->ui_form_start("save_nat.cgi", "post");
print $self->ui_hidden("new", $self->{'in_hash'}->{'newmap'} || $self->{'in_hash'}->{'newrdr'}),"\n";
print $self->ui_hidden("idx", $self->{'in_hash'}->{'idx'}),"\n";
print $self->ui_hidden("before", $self->{'in_hash'}->{'before'}),"\n";
print $self->ui_hidden("after", $self->{'in_hash'}->{'after'}),"\n";
@{$self->{'tds_array'}} = ( "width=20%", undef );

print $self->ui_table_start($self->{'text_hash'}->{'nat_header1'}, "width=100%", 2);

# Comment
print $self->ui_table_row($self->{'text_hash'}->{'edit_cmt'},
		    $self->{'rule'}->{'cmt'} =~ /\n/ ? 
			$self->ui_textarea("cmt", $self->{'rule'}->{'cmt'}, 3, 50) :
			$self->ui_textbox("cmt", $self->{'rule'}->{'cmt'}, 50),
		    undef, \@{$self->{'tds_array'}});

# Enabled
print $self->ui_table_row($self->{'text_hash'}->{'edit_active'},
		    $self->ui_radio("active", $self->{'rule'}->{'active'} ? 1 : 0,
			      [ [ 1, $self->{'text_hash'}->{'edit_active1'} ],
				[ 0, $self->{'text_hash'}->{'edit_active0'} ] ]));

# NAT mode
if ($self->{'rdr'}) {
	print $self->ui_table_row($self->{'text_hash'}->{'nat_action'},
			    $self->{'text_hash'}->{'action_rdr'});
	print $self->ui_hidden("action", "rdr"),"\n";
	}
else {
	print $self->ui_table_row($self->{'text_hash'}->{'nat_action'},
		    $self->ui_select("action", $self->{'rule'}->{'action'},
			       [ [ "map", $self->{'text_hash'}->{'action_map'} ],
				 [ "bimap", $self->{'text_hash'}->{'action_bimap'} ],
				 [ "map-block", $self->{'text_hash'}->{'action_map-block'} ] ]));
	}
print $self->ui_table_end(),"<p>\n";

if (!$self->{'rdr'}) {
	# Show section for source
	print $self->ui_table_start($self->{'text_hash'}->{'nat_header2'}, "width=100%", 2);

	# NAT interface
	print $self->ui_table_row($self->{'text_hash'}->{'nat_iface'},
			    $self->interface_choice("iface", $self->{'rule'}->{'iface'}, 1));

	# Source mode and address
	print $self->ui_table_row($self->{'text_hash'}->{'nat_frommode'},
	    $self->ui_radio("frommode", $self->{'rule'}->{'from'} ? 1 : 0,
		      [ [ 0, $self->text('nat_frommode0',
			           &ipmask_input("from"))."<br>",
			     "onClick='from_change(true)'" ],
			[ 1, $self->{'text_hash'}->{'nat_frommode1'},
			     "onClick='from_change(false)'" ] ]));
	($self->{'ft'}, $self->{'pt'}) = $self->object_input($self->{'rule'}, "from");
	print $self->ui_table_row($self->{'text_hash'}->{'edit_from'}, $self->{'ft'});
	print $self->ui_table_row($self->{'text_hash'}->{'edit_portfrom'}, $self->{'pt'});
	($self->{'ft'}, $self->{'pt'}) = $self->object_input($self->{'rule'}, "fromto");
	print $self->ui_table_row($self->{'text_hash'}->{'edit_to'}, $self->{'ft'});
	print $self->ui_table_row($self->{'text_hash'}->{'edit_portto'}, $self->{'pt'});

	print $self->ui_table_end(),"<p>\n";

	# Show section for destination
	print $self->ui_table_start($self->{'text_hash'}->{'nat_header3'}, "width=100%", 2);

	# Destination address
	print $self->ui_table_row($self->{'text_hash'}->{'nat_tomode'},
	     $self->ui_radio("tomode", $self->{'rule'}->{'tostart'} ? 1 :
				 $self->{'rule'}->{'toip'} eq '0.0.0.0' &&
			          $self->{'rule'}->{'tomask'} == 32 ? 2 : 0,
		      [ [ 2, $self->{'text_hash'}->{'nat_tomode2'}."<br>" ],
			[ 0, $self->text('nat_tomode0',
			           &ipmask_input("to"))."<br>" ],
			[ 1, $self->text('nat_tomode1',
			   $self->ui_textbox("tostart", $self->{'rule'}->{'tostart'}, 15),
			   $self->ui_textbox("toend", $self->{'rule'}->{'toend'}, 15)) ] ]));

	# Port mapping
	print $self->ui_table_row($self->{'text_hash'}->{'nat_portmap'},
		$self->ui_radio("portmapmode", $self->{'rule'}->{'portmap'} ? 1 : 0,
		  [ [ 0, $self->{'text_hash'}->{'nat_portmap0'}."<br>" ],
		    [ 1, $self->text('nat_portmap1',
			$self->protocol_input("portmap", $self->{'rule'}->{'portmap'}, 0, 1),
			$self->ui_checkbox("portmapnoauto", 1,"",
				     $self->{'rule'}->{'portmapfrom'}),
			$self->ui_textbox("portmapfrom", $self->{'rule'}->{'portmapfrom'}, 5),
			$self->ui_textbox("portmapto", $self->{'rule'}->{'portmapto'}, 5)) ] ]));

	# Proxy mapping
	print $self->ui_table_row($self->{'text_hash'}->{'nat_proxy'},
		$self->ui_radio("proxymode", $self->{'rule'}->{'proxyport'} ? 1 : 0,
		  [ [ 0, $self->{'text_hash'}->{'nat_proxy0'}."<br>" ],
		    [ 1, $self->text('nat_proxy1',
			  $self->ui_textbox("proxyport", $self->{'rule'}->{'proxyport'}, 5),
			  $self->ui_textbox("proxyname", $self->{'rule'}->{'proxyname'}, 5),
			  $self->protocol_input("proxyproto",
					  $self->{'rule'}->{'proxyproto'}, 0, 0)) ] ]));

	print $self->ui_table_end(),"<p>\n";

	# Show section for other options
	print $self->ui_table_start($self->{'text_hash'}->{'nat_header4'}, "width=100%", 2);
	print "<table>\n";

	print "<tr> <td>",$self->ui_checkbox("proto", 1, $self->{'text_hash'}->{'nat_proto'},
				       $self->{'rule'}->{'proto'}),"</td>\n";
	print "<td>",$self->protocol_input("protoproto", $self->{'rule'}->{'proto'}, 0, 1),
	      "</td> </tr>\n";

	print "<tr> <td colspan=2>",$self->ui_checkbox("frag", 1, $self->{'text_hash'}->{'nat_frag'},
				       $self->{'rule'}->{'frag'}),"</td> </tr>\n";

	print "<tr> <td>",$self->ui_checkbox("mssclamp", 1, $self->{'text_hash'}->{'nat_clampmss'},
				       $self->{'rule'}->{'mssclamp'}),"</td>\n";
	print "<td>",$self->ui_textbox("mss", $self->{'rule'}->{'mssclamp'}, 5)," ",
	      "$self->{'text_hash'}->{'nat_bytes'}</td> </tr>\n";

	# Proxy mapping
	print "<tr> <td>",$self->ui_checkbox("oproxy", 1, $self->{'text_hash'}->{'nat_oproxy'},
				       $self->{'rule'}->{'oproxyport'}),"</td>\n";
	print "<td>",$self->text('nat_oproxy1',
			  $self->ui_textbox("oproxyport", $self->{'rule'}->{'oproxyport'}, 5),
			  $self->ui_textbox("oproxyname", $self->{'rule'}->{'oproxyname'}, 5),
			  $self->protocol_input("oproxyproto",
					  $self->{'rule'}->{'oproxyproto'}, 0, 0)),"</td> </tr>\n";

	print $self->ui_table_end();
	}
else {
	# Show section for source
	print $self->ui_table_start($self->{'text_hash'}->{'nat_header5'}, "width=100%", 2);

	# NAT interface
	print $self->ui_table_row($self->{'text_hash'}->{'nat_iface'},
			    $self->interface_choice("iface", $self->{'rule'}->{'iface'}, 1));

	# Packets to redirect
	print $self->ui_table_row($self->{'text_hash'}->{'nat_redir'},
			    &ipmask_input("from"));

	# Destination ports
	print $self->ui_table_row($self->{'text_hash'}->{'nat_dports'},
	    $self->ui_radio("dportsmode", $self->{'rule'}->{'dport2'} ? 1 : 0,
		      [ [ 0, $self->text('nat_dports0',
			   $self->ui_textbox("dport", $self->{'rule'}->{'dport1'}, 10)) ],
			[ 1, $self->text('nat_dports1',
			   $self->ui_textbox("dport1", $self->{'rule'}->{'dport1'}, 10),
			   $self->ui_textbox("dport2", $self->{'rule'}->{'dport2'}, 10)) ] ]));

	print $self->ui_table_row($self->{'text_hash'}->{'nat_rdrproto'},
		$self->protocol_input("rprproto",  $self->{'rule'}->{'rdrproto'}, 0, 1));

	print $self->ui_table_end(),"<p>\n";

	# Show section for destination
	print $self->ui_table_start($self->{'text_hash'}->{'nat_header6'}, "width=100%", 2);

	print $self->ui_table_row($self->{'text_hash'}->{'nat_rdrip'},
	    $self->ui_textarea("rdrip", join("\n", @{$self->{'rule'}->{'rdrip'}}), 3, 50));

	print $self->ui_table_row($self->{'text_hash'}->{'nat_rdrport'},
		$self->ui_textbox("rdrport", $self->{'rule'}->{'rdrport'}, 10));

	print $self->ui_table_end(),"<p>\n";

	# Show section for other options
	print $self->ui_table_start($self->{'text_hash'}->{'nat_header4'}, "width=100%", 2);
	print "<table>\n";

	print "<tr> <td colspan=2>",$self->ui_checkbox("round-robin", 1,
						 $self->{'text_hash'}->{'nat_robin'},
				       $self->{'rule'}->{'round-robin'}),"</td> </tr>\n";

	print "<tr> <td colspan=2>",$self->ui_checkbox("frag", 1, $self->{'text_hash'}->{'nat_frag'},
				       $self->{'rule'}->{'frag'}),"</td> </tr>\n";

	print "<tr> <td>",$self->ui_checkbox("mssclamp", 1, $self->{'text_hash'}->{'nat_clampmss'},
				       $self->{'rule'}->{'mssclamp'}),"</td>\n";
	print "<td>",$self->ui_textbox("mss", $self->{'rule'}->{'mssclamp'}, 5)," ",
	      "$self->{'text_hash'}->{'nat_bytes'}</td> </tr>\n";

	print $self->ui_table_end();
	}

if ($self->{'in_hash'}->{'newmap'} || $self->{'in_hash'}->{'newrdr'}) {
	print $self->ui_form_end([ [ 'create', $self->{'text_hash'}->{'create'} ] ], "100%");
	}
else {
	print $self->ui_form_end([ [ 'save', $self->{'text_hash'}->{'save'} ],
			     [ 'delete', $self->{'text_hash'}->{'delete'} ] ], "100%");
	}
if (!$self->{'rdr'}) {
	$self->{'dis'} = $self->{'rule'}->{'from'} ? "false" : "true";
	print "<script>from_change($self->{'dis'});</script>\n";
	}
$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}

# ipmask_input(prefix)
sub ipmask_input
{
	shift if ($self == $_[0]);

local ($pfx) = @_;
return $self->ui_textbox($pfx."ip", $self->{'rule'}->{$pfx."ip"}, 15)." / ".
       $self->ui_textbox($pfx."mask", $self->{'rule'}->{$pfx."mask"}, 15);
}


1;

