#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Display a form for editing or creating a firewall rule

&ModuleLoader::preload_module('ipfilter_class', "ipfilter::IpfilterLib");
$self = new ipfilter::IpfilterLib:: 'ipfilter_class',%$self;

$self->ReadParse();
$self->{'rules'} = $self->get_config();

if ($self->{'in_hash'}->{'delsel'}) {
	# Special case - deleting selected rules
	@{$self->{'nums_array'}} = sort { $b cmp $a } split(/\0/, $self->{'in_hash'}->{'d'});
	if (@{$self->{'nums_array'}}) {
		$self->lock_file($self->{'rules'}->[$self->{'nums_array'}->[0]]->{'file'});
		foreach $n (@{$self->{'nums_array'}}) {
			$self->delete_rule($self->{'rules'}->[$n]);
			}
		$self->flush_file_lines();
		$self->unlock_file($self->{'rules'}->[$self->{'nums_array'}->[0]]->{'file'});
		$self->webmin_log("delsel", "rule", undef,
			    { 'count' => scalar(@{$self->{'nums_array'}}) });
		}
	$self->redirect("");
	exit;
	}

if ($self->{'in_hash'}->{'new'}) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'edit_title1'}, "");
	$self->{'rule'} = { 'action' => 'pass',
		  'all' => 1,
		  'active' => 1,
		  'dir' => 'in',
		  'quick' => 1 };
	}
else {
	$self->{'rule'} = $self->{'rules'}->[$self->{'in_hash'}->{'idx'}];
	$self->ui_print_header(undef, $self->{'text_hash'}->{'edit_title2'}, "");
	}

# Javascript for disabling fields
print <<EOF;
<script>
function all_change(dis)
{
var f = document.forms[0];
for(i=0; i<f.elements.length; i++) {
        e = f.elements[i];
	if (e.name.substring(0, 3) != "tos" &&
	    (e.name.substring(0, 4) == "from" ||
	     e.name.substring(0, 2) == "to")) {
		e.disabled = dis;
		}
	}
}
</script>
EOF

print $self->ui_form_start("save_rule.cgi", "post");
print $self->ui_hidden("new", $self->{'in_hash'}->{'new'}),"\n";
print $self->ui_hidden("idx", $self->{'in_hash'}->{'idx'}),"\n";
print $self->ui_hidden("before", $self->{'in_hash'}->{'before'}),"\n";
print $self->ui_hidden("after", $self->{'in_hash'}->{'after'}),"\n";
@{$self->{'tds_array'}} = ( "width=20%", undef );

print $self->ui_table_start($self->{'text_hash'}->{'edit_header1'}, "width=100%", 2);

# Comment
print $self->ui_table_row($self->{'text_hash'}->{'edit_cmt'},
		    $self->{'rule'}->{'cmt'} =~ /\n/ ? 
			$self->ui_textarea("cmt", $self->{'rule'}->{'cmt'}, 3, 50) :
			$self->ui_textbox("cmt", $self->{'rule'}->{'cmt'}, 50),
		    undef, \@{$self->{'tds_array'}});

# Enabled
print $self->ui_table_row($self->{'text_hash'}->{'edit_active'},
		    $self->ui_radio("active", $self->{'rule'}->{'active'} ? 1 : 0,
			      [ [ 1, $self->{'text_hash'}->{'edit_active1'} ],
				[ 0, $self->{'text_hash'}->{'edit_active0'} ] ]));

# Rule action and argument
$self->{'ra'} = $self->{'rule'}->{'action'};
push(@{$self->{'action_array'}}, $self->{'ra'}) if ($self->{'ra'} && $self->indexof($self->{'ra'}, @{$self->{'actions_array'}}) < 0);
$self->{'acts'} = "<table cellpadding=1 cellspacing=1>\n";
$self->{'i'} = 0;
%{$self->{'action_fields_hash'}} = ( 'block' => [ 'block_return', 'block_return_dest' ],
		   'log' => [ 'log_pri', 'log_fac', 'log_body', 'log_first',
			      'log_orblock' ],
		   'skip' => [ 'skip' ],
		   'call' => [ 'call', 'call_now' ] );
foreach $a (@{$self->{'actions_array'}}) {
	$self->{'acts'} .= "<tr> <td>";
	local $ma = $self->{'rule'}->{'action'} eq $a;
	@{$self->{'myfields_array'}} = @{$self->{'action_fields_hash'}->{$a}};
	@{$self->{'notfields_array'}} = map { @{$self->{'action_fields_hash'}->{$_}} }
			 grep { $_ ne $a } (keys %{$self->{'action_fields_hash'}});
	$self->{'acts'} .= $self->ui_oneradio("action", $a,
			$self->{'text_hash'}->{"laction_".$a} || $self->{'text_hash'}->{"action_".$a} || uc($a),
			$ma,
			$self->js_disable_inputs(\@{$self->{'notfields_array'}}, \@{$self->{'myfields_array'}}, "onClick"));
	if ($a eq "block") {
		# Show ICMP block options
		local @codes = ( [ "", $self->{'text_hash'}->{'edit_none'} ],
				 [ "rst", $self->{'text_hash'}->{'edit_rst'} ] );
		push(@codes, map { [ $_ ] } @{$self->{'icmp_codes_array'}});
		push(@codes, [ $self->{'rule'}->{'block-return'} ])
			if ($self->{'rule'}->{'block-return'} &&
			    $self->{'rule'}->{'block-return'} ne "rst" &&
			    $self->indexof($self->{'rule'}->{'block-return'}, @{$self->{'icmp_codes_array'}}) < 0);
		$self->{'acts'} .= $self->ui_select("block_return", $self->{'rule'}->{'block-return'},
				    \@codes, 0, 0, 1, !$ma)."\n";
		$self->{'acts'} .= $self->ui_checkbox("block_return_dest", 1,
				      $self->{'text_hash'}->{'edit_return_dest'},
				      $self->{'rule'}->{'block-return-dest'},
				      undef, !$ma);
		}
	elsif ($a eq "log") {
		# Show logging options
		$self->{'acts'} .= &logging_options("log", 1, !$ma);
		}
	elsif ($a eq "skip") {
		# Show rule to skip to
		$self->{'acts'} .= $self->ui_textbox("skip", $self->{'rule'}->{'skip'}, 10, !$ma);
		}
	elsif ($a eq "call") {
		# Show function name
		$self->{'acts'} .= $self->ui_textbox("call", $self->{'rule'}->{'call'}, 20, !$ma)."\n".
			 $self->ui_checkbox("call_now", 1, $self->{'text_hash'}->{'edit_callnow'},
				      $self->{'rule'}->{'call-now'}, undef, !$ma);
		}
	$self->{'acts'} .= "</td> </tr>";
	}
$self->{'acts'} .= "</table>\n";
print $self->ui_table_row($self->{'text_hash'}->{'edit_action'}, $self->{'acts'},
		    undef, \@{$self->{'tds_array'}});

print $self->ui_table_end(),"<br>\n";

# Show section for source and destination
print $self->ui_table_start($self->{'text_hash'}->{'edit_header2'}, "width=100%", 2);

print $self->ui_table_row($self->{'text_hash'}->{'edit_all'},
    $self->ui_radio("all", $self->{'rule'}->{'all'} || 0,
	      [ [ 1, $self->{'text_hash'}->{'edit_all1'}, "onClick='all_change(true)'" ],
		[ 0, $self->{'text_hash'}->{'edit_all0'}, "onClick='all_change(false)'" ] ]));

foreach $f ("from", "to") {
	print $self->ui_table_hr();
	($self->{'ft'}, $self->{'pt'}) = $self->object_input($self->{'rule'}, $f);
	print $self->ui_table_row($self->{'text_hash'}->{'edit_'.$f}, $self->{'ft'});
	print $self->ui_table_row($self->{'text_hash'}->{'edit_port'.$f}, $self->{'pt'});
	}

print $self->ui_table_end(),"<br>\n";

# Show section for protocol, ttl, tos
print $self->ui_table_start($self->{'text_hash'}->{'edit_header3'}, "width=100%", 4);

print $self->ui_table_row($self->{'text_hash'}->{'edit_dir'},
    $self->ui_radio("dir", $self->{'rule'}->{'dir'}, [ [ "in", $self->{'text_hash'}->{'dir_in'} ],
				       [ "out", $self->{'text_hash'}->{'dir_out'} ] ]));

print $self->ui_table_row($self->{'text_hash'}->{'edit_proto'},
    $self->protocol_input("proto", $self->{'rule'}->{'proto'}, 1, 0));

print $self->ui_table_row($self->{'text_hash'}->{'edit_tos'},
    $self->ui_opt_textbox("tos", $self->{'rule'}->{'tos'}, 8, $self->{'text_hash'}->{'edit_tosany'}));

print $self->ui_table_row($self->{'text_hash'}->{'edit_ttl'},
    $self->ui_opt_textbox("ttl", $self->{'rule'}->{'ttl'}, 8, $self->{'text_hash'}->{'edit_tosany'}));

print $self->ui_table_row($self->{'text_hash'}->{'edit_on'},
		    $self->interface_choice("on", $self->{'rule'}->{'on'}));

print $self->ui_table_row($self->{'text_hash'}->{'edit_flags'},
    $self->ui_opt_textbox("flags1", $self->{'rule'}->{'flags1'}, 8, $self->{'text_hash'}->{'edit_flagsany'},
		    undef, 0, [ "flags2" ]).
		    " $self->{'text_hash'}->{'edit_flags2'} ".
		    $self->ui_textbox("flags2", $self->{'rule'}->{'flags2'}, 8,
				!$self->{'rule'}->{'flags1'}));

print $self->ui_table_row($self->{'text_hash'}->{'edit_icmp'},
    $self->ui_select("icmptype", $self->{'rule'}->{'icmp-type'},
	       [ [ "", $self->{'text_hash'}->{'edit_icmpany'} ],
		 map { [ $_ ] } @{$self->{'icmp_types_array'}} ],
	       0, 0, $self->{'rule'}->{'icmp-type'} ? 1 : 0).
    " $self->{'text_hash'}->{'edit_icmpcode'} ".
    $self->ui_select("icmpcode", $self->{'rule'}->{'icmp-type-code'},
	       [ [ "", $self->{'text_hash'}->{'edit_codeany'} ],
		 map { [ $_ ] } @{$self->{'icmp_codes_array'}} ],
	       0, 0, $self->{'rule'}->{'icmp-code'} ? 1 : 0), 3);

print $self->ui_table_end(),"<br>\n";

# Show section for other options
print $self->ui_table_start($self->{'text_hash'}->{'edit_header4'}, "width=100%", 2);
print "<table>\n";

print "<tr> <td colspan=2>",$self->ui_checkbox("quick", 1, $self->{'text_hash'}->{'edit_quick'},
			       $self->{'rule'}->{'quick'}),"</td> </tr>\n";

# Show logging options as action
print "<tr> <td>",$self->ui_checkbox("olog", 1, $self->{'text_hash'}->{'edit_olog'},
	       $self->{'rule'}->{'olog'},
	       $self->js_checkbox_disable("olog", [ ], [ "olog_pri", "olog_fac", "olog_body", "olog_first", "olog_block" ], "onClick")),"</td>\n";
print "<td>",&logging_options("olog", 1, !$self->{'rule'}->{'olog'}),"</td> </tr>\n";
 
# Show tagging ID
print "<tr> <td>",$self->ui_checkbox("tag", 1, $self->{'text_hash'}->{'edit_tag'},
	$self->{'rule'}->{'tag'},
	$self->js_checkbox_disable("tag", [ ], [ "tagid" ], "onClick")),"</td>\n";
print "<td>",$self->ui_textbox("tagid", $self->{'rule'}->{'tag'}, 10, !$self->{'rule'}->{'tag'}),
      "</td> </tr>\n";

# Show duplicate destination
print "<tr> <td>",$self->ui_checkbox("dup_to", 1, $self->{'text_hash'}->{'edit_dupto'},
	$self->{'rule'}->{'dup-to'},
	$self->js_checkbox_disable("dup_to", [ ],
			     [ "dup_toiface", "dup_toiface_other",
			       "dup_toip" ], "onClick")),"</td>\n";
($self->{'iface'}, $self->{'ip'}) = split(/:/, $self->{'rule'}->{'dup-to'});
print "<td>",$self->interface_choice("dup_toiface", $self->{'iface'}, 1,
			       !$self->{'rule'}->{'dup-to'}),"\n";
print "$self->{'text_hash'}->{'edit_duptoip'}\n";
print $self->ui_textbox("dup_toip", $self->{'ip'}, 13,
		  !$self->{'rule'}->{'dup-to'})," $self->{'text_hash'}->{'edit_opt'}</td> </tr>\n";

# Show fast routing destination
print "<tr> <td>",$self->ui_checkbox("fastroute", 1, $self->{'text_hash'}->{'edit_fastroute'},
	$self->{'rule'}->{'fastroute'},
	$self->js_checkbox_disable("fastroute", [ ],
			     [ "fastrouteiface", "fastrouteiface_other",
			       "fastrouteip" ], "onClick")),"</td>\n";
print "<td>",$self->interface_choice("fastrouteiface", $self->{'rule'}->{'fastroute'}, 1,
			       !$self->{'rule'}->{'fastroute'}),"\n";
print "$self->{'text_hash'}->{'edit_fastrouteip'}\n";
print $self->ui_textbox("fastrouteip", $self->{'rule'}->{'fastroute-ip'}, 13,
		  !$self->{'rule'}->{'fastroute'})," $self->{'text_hash'}->{'edit_opt'}</td> </tr>\n";

# Show reply destination
print "<tr> <td>",$self->ui_checkbox("reply_to", 1, $self->{'text_hash'}->{'edit_replyto'},
	$self->{'rule'}->{'reply-to'},
	$self->js_checkbox_disable("reply_to", [ ],
			     [ "reply_toiface", "reply_toiface_other",
			       "reply_toip" ], "onClick")),"</td>\n";
print "<td>",$self->interface_choice("reply_toiface", $self->{'rule'}->{'reply-to'}, 1,
			       !$self->{'rule'}->{'reply-to'}),"\n";
print "$self->{'text_hash'}->{'edit_fastrouteip'}\n";
print $self->ui_textbox("reply_toip", $self->{'rule'}->{'reply-to-ip'}, 13,
		  !$self->{'rule'}->{'reply-to'})," $self->{'text_hash'}->{'edit_opt'}</td> </tr>\n";

# Show state keeping options
print "<tr> <td>",$self->ui_checkbox("keep", 1, $self->{'text_hash'}->{'edit_keep'},
       	$self->{'rule'}->{'keep'},
	$self->js_checkbox_disable("keep", [ ] , [ "keepmode" ], "onClick")),"</td>\n";
print "<td>",$self->ui_select("keepmode", $self->{'rule'}->{'keep'} || "state",
		[ [ "state", $self->{'text_hash'}->{'edit_keepstate'} ],
		  [ "frags", $self->{'text_hash'}->{'edit_keepfrags'} ] ],
		1, 0, 0, !$self->{'rule'}->{'keep'}),"<td> </tr>\n";

print $self->ui_table_end();

if ($self->{'in_hash'}->{'new'}) {
	print $self->ui_form_end([ [ 'create', $self->{'text_hash'}->{'create'} ] ], "100%");
	}
else {
	print $self->ui_form_end([ [ 'save', $self->{'text_hash'}->{'save'} ],
			     [ 'delete', $self->{'text_hash'}->{'delete'} ] ], "100%");
	}
$self->{'dis'} = $self->{'rule'}->{'all'} ? "true" : "false";
print "<script>all_change($self->{'dis'});</script>\n";
$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}

# yes_no_ignored_input(name)
sub yes_no_ignored_input
{
	shift if ($self == $_[0]);

local $mode = $self->{'rule'}->{$_[0]} && $self->{'rule'}->{$_[0]."_not"} ? 2 :
	      $self->{'rule'}->{$_[0]} ? 1 : 0;
return $self->ui_radio($_[0], $mode,
		 [ [ 1, $self->{'text_hash'}->{'yes'} ],
		   [ 0, $self->{'text_hash'}->{'no'} ] ]);
}

# logging_options(prefix, split, disable?)
sub logging_options
{
	shift if ($self == $_[0]);

local ($pfx, $split, $dis) = @_;
local $rv;
local $ll = $self->{'rule'}->{$pfx."-level"};
local ($f, $p);
if ($ll =~ /^(\S+)\.(\S+)$/) {
	$p = $2; $f = $1;
	}
elsif ($ll =~ /\S/) {
	$p = $ll;
	}
$rv .= $self->ui_select($pfx."_pri", $p,
	  [ [ "", $self->{'text_hash'}->{'default'} ], map { [ $_ ] } @{$self->{'log_priorities_array'}} ],
	  0, 0, 1, $dis);
$rv .= " $self->{'text_hash'}->{'edit_fac'} ";
$rv .= $self->ui_select($pfx."_fac", $f,
	  [ [ "", $self->{'text_hash'}->{'default'} ], map { [ $_ ] } @{$self->{'log_facilities_array'}} ],
	  0, 0, 1, $dis)."\n";
$rv .= "<br>&nbsp;&nbsp;&nbsp;\n" if ($_[1]);
$rv .= $self->ui_checkbox($pfx."_body", 1, $self->{'text_hash'}->{'edit_log_body'},
		    $self->{'rule'}->{$pfx.'-body'}, undef, $dis)."\n";
$rv .= $self->ui_checkbox($pfx."_first", 1, $self->{'text_hash'}->{'edit_log_first'},
		    $self->{'rule'}->{$pfx.'-first'}, undef, $dis)."\n";
$rv .= $self->ui_checkbox($pfx."_orblock", 1, $self->{'text_hash'}->{'edit_log_orblock'},
		    $self->{'rule'}->{$pfx.'-or-block'}, undef, $dis)."\n";
return $rv;
}


1;

