#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Add or update a server or group from the webmin servers module

&ModuleLoader::preload_module('ipfw_class', "ipfw::IpfwLib");
$self = new ipfw::IpfwLib:: 'ipfw_class',%$self;

$self->ReadParse();
$self->foreign_require("servers", "servers-lib.pl");
@{$self->{'allservers_array'}} = grep { $_->{'user'} } $main::servers_object->list_servers();

if ($self->{'in_hash'}->{'add'}) {
	# Add a single host
	@{$self->{'add_array'}} = grep { $_->{'id'} eq $self->{'in_hash'}->{'server'} } @{$self->{'allservers_array'}};
	$self->error_setup($self->{'text_hash'}->{'add_err'});
	$self->{'msg'} = $self->text('add_msg', $self->server_name($self->{'add_array'}->[0]));
	}
else {
	# Add all from a group
	($self->{'group'}) = grep { $_->{'name'} eq $self->{'in_hash'}->{'group'} }
			$main::servers_object->list_all_groups(\@{$self->{'allservers_array'}});
	foreach $m (@{$self->{'group'}->{'members'}}) {
		push(@{$self->{'add_array'}}, grep { $_->{'host'} eq $m } @{$self->{'allservers_array'}});
		}
	$self->error_setup($self->{'text_hash'}->{'add_gerr'});
	$self->{'msg'} = $self->text('add_gmsg', $self->{'in_hash'}->{'group'});
	}

$self->ui_print_header(undef, $self->{'text_hash'}->{'add_title'}, "");
print "<b>$self->{'msg'}</b><p>\n";

$self->remote_error_setup(\&add_error);

# Make sure each host is set up for firewalling
foreach $s (@{$self->{'add_array'}}) {
	$self->{'add_error_msg'} = undef;
	local $firewall = $self->remote_foreign_check($s, "ipfw");
	if ($self->{'add_error_msg'}) {
		print "$self->{'add_error_msg'}<p>\n";
		next;
		}
	if (!$firewall) {
		print $self->text('add_echeck', $s),"<p>\n";
		next;
		}
	$self->remote_foreign_require($s, "ipfw", "ipfw-lib.pl");

	local $ok = $self->remote_foreign_call($s, "ipfw",
					 "foreign_installed", "ipfw");
	if (!$ok) {
		print $self->text('add_eok'),"<p>\n";
		next;
		}

	$self->{'iconfig'} = $self->remote_foreign_config($s, "ipfw");
	$self->{'live'} = $self->remote_foreign_call($s, "ipfw",
				   "get_config", "$self->{'iconfig'}->{'ipfw'} show |");
	print $self->text('add_ok', $s->{'host'}, scalar(@{$self->{'live'}})),"<p>\n";
	$self->add_cluster_server($s);
	}
$self->remote_finished();
if ($self->{'in_hash'}->{'add'}) {
	$self->webmin_log("add", "host", $self->{'add_array'}->[0]->{'host'});
	}
else {
	$self->webmin_log("add", "group", $self->{'in_hash'}->{'group'});
	}

$self->ui_print_footer("cluster.cgi", $self->{'text_hash'}->{'cluster_return'});

1;
		
}

# Setup error handler for down hosts
sub add_error
{
	shift if ($self == $_[0]);

$self->{'add_error_msg'} = join("", @_);
}


1;

