#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Display a form for editing or creating a firewall rule

&ModuleLoader::preload_module('ipfw_class', "ipfw::IpfwLib");
$self = new ipfw::IpfwLib:: 'ipfw_class',%$self;

$self->ReadParse();
$self->{'rules'} = $self->get_config();

if ($self->{'in_hash'}->{'delsel'}) {
	# Special case - deleting selected rules
	%{$self->{'nums_hash'}} = map { $_, 1 } split(/\0/, $self->{'in_hash'}->{'d'});
	@{$self->{'rules'}} = grep { !$self->{'nums_hash'}->{$_->{'num'}} } @{$self->{'rules'}};
	$self->lock_file($self->{'ipfw_file'});
	$self->save_config($self->{'rules'});
	$self->unlock_file($self->{'ipfw_file'});
	$self->webmin_log("delsel", undef, undef,
		    { 'count' => scalar(keys %{$self->{'nums_hash'}}) });
	$self->redirect("");
	exit;
	}

if ($self->{'in_hash'}->{'new'}) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'edit_title1'}, "");
	$self->{'rule'} = { 'action' => 'allow',
		  'from' => 'any',
		  'to' => 'any' };
	}
else {
	$self->{'rule'} = $self->{'rules'}->[$self->{'in_hash'}->{'idx'}];
	$self->ui_print_header(undef, $self->text('edit_title2', $self->{'rule'}->{'num'}), "");
	}

print $self->ui_form_start("save_rule.cgi", "post");
print $self->ui_hidden("new", $self->{'in_hash'}->{'new'}),"\n";
print $self->ui_hidden("idx", $self->{'in_hash'}->{'idx'}),"\n";
print $self->ui_hidden("before", $self->{'in_hash'}->{'before'}),"\n";
print $self->ui_hidden("after", $self->{'in_hash'}->{'after'}),"\n";
@{$self->{'tds_array'}} = ( "width=20%", undef );

print $self->ui_table_start($self->{'text_hash'}->{'edit_header1'}, "width=100%", 2);

# Comment
print $self->ui_table_row($self->{'text_hash'}->{'edit_cmt'},
		    $self->{'rule'}->{'cmt'} =~ /\n/ ? 
			$self->ui_textarea("cmt", $self->{'rule'}->{'cmt'}, 3, 50) :
			$self->ui_textbox("cmt", $self->{'rule'}->{'cmt'}, 50),
		    undef, \@{$self->{'tds_array'}});

# Number for new rules
if ($self->{'in_hash'}->{'new'} && !$self->{'in_hash'}->{'before'} && !$self->{'in_hash'}->{'after'}) {
	print $self->ui_table_row($self->{'text_hash'}->{'edit_num'},
		$self->ui_opt_textbox("num", undef, 6, $self->{'text_hash'}->{'default'}));
	}

# Rule action and argument
$self->{'ra'} = $self->real_action($self->{'rule'}->{'action'});
push(@{$self->{'action_array'}}, $self->{'ra'}) if ($self->{'ra'} && $self->indexof($self->{'ra'}, @{$self->{'actions_array'}}) < 0);
$self->{'acts'} = "<table cellpadding=1 cellspacing=1>\n";
$i = 0;
foreach $a (@{$self->{'actions_array'}}) {
	$self->{'acts'} .= "<tr>\n" if ($i%2 == 0);
	$self->{'acts'} .= "<td nowrap>";
	local $ma = $self->{'rule'}->{'action'} eq $a;
	$self->{'acts'} .= $self->ui_oneradio("action", $a,
			$self->{'text_hash'}->{"laction_".$a} || $self->{'text_hash'}->{"action_".$a} || uc($a),
			$ma);
	if ($a eq "skipto") {
		$self->{'acts'} .= $self->ui_textbox("action_skipto",
				     $ma ? $self->{'rule'}->{'aarg'} : "", 8);
		}
	elsif ($a eq "fwd") {
		local ($ip, $port) = split(/,/, $self->{'rule'}->{'aarg'});
		$self->{'acts'} .= $self->ui_textbox("action_fwdip", $ma ? $ip : "", 15).":".
			 $self->ui_textbox("action_fwdport", $ma ? $port : "", 5);
		}
	elsif ($a eq "divert" || $a eq "pipe" || $a eq "queue" || $a eq "tee") {
		$self->{'acts'} .= $self->ui_textbox("action_port",
				     $ma ? $self->{'rule'}->{'aarg'} : "", 5);
		}
	elsif ($a eq "unreach") {
		$self->{'acts'} .= $self->ui_select("action_unreach", $ma ? $self->{'rule'}->{'aarg'} :"",
				    [ map { [ $_, $_ ] } @{$self->{'unreaches_array'}} ]);
		}
	$self->{'acts'} .= "</td>";
	$self->{'acts'} .= "</tr>\n" if ($i++%2 == 1);
	}
$self->{'acts'} .= "</table>\n";
print $self->ui_table_row($self->{'text_hash'}->{'edit_action'}, $self->{'acts'},
		    undef, \@{$self->{'tds_array'}});

# Logging field
print $self->ui_table_row($self->{'text_hash'}->{'edit_log'},
		   $self->ui_oneradio("log", 0, $self->{'text_hash'}->{'no'},
				!$self->{'rule'}->{'log'})." ".
		   $self->ui_oneradio("log", 1,
				$self->text('edit_logyes',
			          $self->ui_textbox("logamount",
						$self->{'rule'}->{'logamount'}, 5)),
				$self->{'rule'}->{'log'}));

# State-keeping rule
print $self->ui_table_row($self->{'text_hash'}->{'edit_keep-state'},
		    &yes_no_ignored_input("keep-state"), 1, \@{$self->{'tds_array'}});

print $self->ui_table_end();
print "<p>\n";

# Condition section
print "$self->{'text_hash'}->{'edit_desc'}<br>\n";
print $self->ui_table_start($self->{'text_hash'}->{'edit_header3'}, "width=100%", 4);

# Protocol field
if (ref($self->{'rule'}->{'proto'})) {
	# Multiple or-block values!
	print $self->ui_table_row($self->{'text_hash'}->{'edit_proto'},
			    &orblock_input("proto", $self->{'rule'}->{'proto'}));
	}
else {
	local @protos = $self->list_protocols();
	$self->{'rule'}->{'proto'} = "all" if ($self->{'rule'}->{'proto'} eq "ip");
	print $self->ui_table_row($self->{'text_hash'}->{'edit_proto'},
			    $self->ui_select("proto", $self->{'rule'}->{'proto'},
				       [ [ "all", $self->{'text_hash'}->{'edit_any'} ],
					 map { [ $_, uc($_) ] } @protos ]),
			    undef, \@{$self->{'tds_array'}});
	}

# Incoming / outgoing
$self->{'iomode'} = $self->{'rule'}->{'in'} || $self->{'rule'}->{'out'} && $self->{'rule'}->{'out_not'} ? 1 :
	  $self->{'rule'}->{'out'} || $self->{'rule'}->{'in'} && $self->{'rule'}->{'in_not'} ? 2 : 0;
print $self->ui_table_row($self->{'text_hash'}->{'edit_inout'},
		    $self->ui_select("inout", $self->{'iomode'},
			      [ [ 0, "do { my $t=$self->{'text_hash'}->{'edit_ignored'}; <$t> }" ],
				[ 1, $self->{'text_hash'}->{'edit_inout1'} ],
				[ 2, $self->{'text_hash'}->{'edit_inout2'} ] ]), 1, \@{$self->{'tds_array'}});

# Via interface
print $self->ui_table_row($self->{'text_hash'}->{'edit_via'},
		    $self->interface_choice("via", $self->{'rule'}->{'via'}), 1, \@{$self->{'tds_array'}});

print $self->ui_table_end();
print "<p>\n";

# Source and destination sections
foreach $s ("from", "to") {
	print $self->ui_table_start($self->{'text_hash'}->{'edit_header'.$s}, "width=100%", 2);

	# IP address
	if (ref($self->{'rule'}->{$s})) {
		print $self->ui_table_row($self->{'text_hash'}->{'edit_'.$s},
				    &orblock_input($s, $self->{'rule'}->{$s}));
		}
	else {
		local $mode = $self->{'rule'}->{$s} eq "any" ? 0 :
			      $self->{'rule'}->{$s} eq "me" ? 1 : 2;
		print $self->ui_table_row($self->{'text_hash'}->{'edit_'.$s},
		      $self->ui_oneradio($s."_mode", 0, $self->{'text_hash'}->{'edit_sany'},
				   $mode == 0)."<br>".
		      $self->ui_oneradio($s."_mode", 1, $self->{'text_hash'}->{'edit_sme'},
				   $mode == 1)."<br>".
		      $self->ui_oneradio($s."_mode", 2, $self->{'text_hash'}->{'edit_saddr'},
				   $mode == 2)." ".
		      $self->ui_textbox($s, $mode == 2 ? $self->{'rule'}->{$s} : "", 40),
		      undef, \@{$self->{'tds_array'}});
		print $self->ui_table_row("",
		      $self->ui_checkbox($s."_not", 1, $self->{'text_hash'}->{'edit_snot'},
				   $self->{'rule'}->{$s."_not"}),
		      undef, \@{$self->{'tds_array'}});
		}
	#print &ui_table_hr();

	# Ports within IPs
	if (ref($self->{'rule'}->{$s."_ports"})) {
		print $self->ui_table_row($self->{'text_hash'}->{'edit_port'.$s},
		    &orblock_input($s."_ports", $self->{'rule'}->{$s."_ports"}));
		}
	else {
		local $mode = defined($self->{'rule'}->{$s."_ports"}) ? 1 : 0;
		print $self->ui_table_row($self->{'text_hash'}->{'edit_port'.$s},
		      $self->ui_oneradio($s."_ports_mode", 0, $self->{'text_hash'}->{'edit_pany'},
				   $mode == 0)."<br>".
		      $self->ui_oneradio($s."_ports_mode", 1, $self->{'text_hash'}->{'edit_ports'},
				   $mode == 1)." ".
		      $self->ui_textbox($s."_ports", $mode == 1 ? $self->{'rule'}->{$s."_ports"}
						 : "", 40),
		      undef, \@{$self->{'tds_array'}});
		if ($self->{'ipfw_version'} >= 2) {
			print $self->ui_table_row("",
			      $self->ui_checkbox($s."_ports_not", 1, $self->{'text_hash'}->{'edit_pnot'},
					   $self->{'rule'}->{$s."_ports_not"}),
			      undef, \@{$self->{'tds_array'}});
			}
		}

	# Received interface
	local $rs = $s eq "from" ? "recv" : "xmit";
	print $self->ui_table_row($self->{'text_hash'}->{'edit_'.$rs},
			    $self->interface_choice($rs, $self->{'rule'}->{$rs}), 1, \@{$self->{'tds_array'}});

	print $self->ui_table_end();
	print "<p>\n";
	}

# Options section
@{$self->{'tds_array'}} = ( "", "nowrap" );
# XXX or-block support
print $self->ui_table_start($self->{'text_hash'}->{'edit_header2'}, "width=100%", 4);

# Established traffic
print $self->ui_table_row($self->{'text_hash'}->{'edit_established'},
		    &yes_no_ignored_input("established"), 1, \@{$self->{'tds_array'}});

# TCP setup packets
print $self->ui_table_row($self->{'text_hash'}->{'edit_setup'},
		    &yes_no_ignored_input("setup"), 1, \@{$self->{'tds_array'}});

# Bridged packets
print $self->ui_table_row($self->{'text_hash'}->{'edit_bridged'},
		    &yes_no_ignored_input("bridged"), 1, \@{$self->{'tds_array'}});

# Fragmented packets
print $self->ui_table_row($self->{'text_hash'}->{'edit_frag'},
		    &yes_no_ignored_input("frag"), 1, \@{$self->{'tds_array'}});

# MAC addresses (if supported)
if ($self->{'ipfw_version'} >= 2) {
	local ($md, $ms) = $self->{'rule'}->{'mac'} ? @{$self->{'rule'}->{'mac'}} : ( "any", "any" );
	print $self->ui_table_row($self->{'text_hash'}->{'edit_mac1'},
		    $self->ui_radio("mac1_def", $ms eq "any" ? 1 : 0,
			      [ [ 1, $self->{'text_hash'}->{'edit_ignored'} ],
				[ 0, $self->{'text_hash'}->{'edit_macaddr'} ] ] )." ".
		    $self->ui_textbox("mac1", $ms eq "any" ? "" : $ms, 20), 3, \@{$self->{'tds_array'}});
	print $self->ui_table_row($self->{'text_hash'}->{'edit_mac2'},
		    $self->ui_radio("mac2_def", $md eq "any" ? 1 : 0,
			      [ [ 1, $self->{'text_hash'}->{'edit_ignored'} ],
				[ 0, $self->{'text_hash'}->{'edit_macaddr'} ] ] )." ".
		    $self->ui_textbox("mac2", $md eq "any" ? "" : $md, 20), 3, \@{$self->{'tds_array'}});
	}

# UID and GID
if (defined($self->{'rule'}->{'uid'})) {
	$self->{'user'} = getpwuid($self->{'rule'}->{'uid'});
	$self->{'user'} = "#".$self->{'rule'}->{'uid'} if (!defined($self->{'user'}));
	}
print $self->ui_table_row($self->{'text_hash'}->{'edit_uid'},
		    $self->ui_radio("uid_def", $self->{'user'} ? 0 : 1,
			      [ [ 1, $self->{'text_hash'}->{'edit_ignored'} ],
				[ 0, $self->{'text_hash'}->{'edit_user'} ] ] )." ".
		    $self->ui_user_textbox("uid", $self->{'user'}), 3, \@{$self->{'tds_array'}});
if (defined($self->{'rule'}->{'gid'})) {
	$self->{'group'} = getgrgid($self->{'rule'}->{'gid'});
	$self->{'group'} = "#".$self->{'rule'}->{'gid'} if (!defined($self->{'group'}));
	}
print $self->ui_table_row($self->{'text_hash'}->{'edit_gid'},
		    $self->ui_radio("gid_def", $self->{'group'} ? 0 : 1,
			      [ [ 1, $self->{'text_hash'}->{'edit_ignored'} ],
				[ 0, $self->{'text_hash'}->{'edit_group'} ] ] )." ".
		    $self->ui_group_textbox("gid", $self->{'group'}), 3, \@{$self->{'tds_array'}});

# ICMP types
%{$self->{'gottypes_hash'}} = map { $_, 1 }
		map { $_ =~ /^(\d+)\-(\d+)$/ ? ( $1 .. $2 ) : ( $_ ) }
			split(/,/, $self->{'rule'}->{'icmptypes'});
$icmptypes = "<select name=icmptypes size=5 multiple>\n";
for($i=0; $i<@{$self->{'icmptypes_array'}}; $i++) {
	if ($self->{'icmptypes_array'}->[$i] || $self->{'gottypes_hash'}->{$i}) {
		$icmptypes .= sprintf "<option value=%d %s>%s\n",
			$i, $self->{'gottypes_hash'}->{$i} ? "selected" : "",
			$self->{'icmptypes_array'}->[$i] || "Type $i";
		}
	}
$icmptypes .= "</select>\n";
print $self->ui_table_row($self->{'text_hash'}->{'edit_icmptypes'}, $icmptypes, 1, \@{$self->{'tds_array'}});

# TCP flags
%{$self->{'gotflags_hash'}} = map { $_, 1 } split(/,/, $self->{'rule'}->{'tcpflags'});
$self->{'tcpflags'} = "<select name=tcpflags size=5 multiple>\n";
foreach $i (@{$self->{'tcpflags_array'}}) {
	$self->{'tcpflags'} .= sprintf "<option value=%s %s>%s\n",
		$i, $self->{'gotflags_hash'}->{$i} ? "selected" : "", $i;
	}
foreach $i (@{$self->{'tcpflags_array'}}) {
	$self->{'tcpflags'} .= sprintf "<option value=!%s %s>%s\n",
		$i, $self->{'gotflags_hash'}->{"!$i"} ? "selected" : "", $self->text('edit_not', $i);
	}
$self->{'tcpflags'} .= "</select>\n";
print $self->ui_table_row($self->{'text_hash'}->{'edit_tcpflags'}, $self->{'tcpflags'}, 1, \@{$self->{'tds_array'}});

# Limit directive
print $self->ui_table_row($self->{'text_hash'}->{'edit_limit'},
	      $self->ui_select("limit", $self->{'rule'}->{'limit'} ? $self->{'rule'}->{'limit'}->[0] : "",
			 [ [ "", "do { my $t=$self->{'text_hash'}->{'edit_unlimited'}; <$t> }" ],
			   [ "src-addr", $self->{'text_hash'}->{'edit_src-addr'} ],
			   [ "src-port", $self->{'text_hash'}->{'edit_src-port'} ],
			   [ "dst-addr", $self->{'text_hash'}->{'edit_dst-addr'} ],
			   [ "dst-port", $self->{'text_hash'}->{'edit_dst-port'} ] ])." ".
	      $self->ui_textbox("limit2", $self->{'rule'}->{'limit'} ? $self->{'rule'}->{'limit'}->[1]
						     : "", 6),
	      3, \@{$self->{'tds_array'}});

# Destination ports directive
print $self->ui_table_row($self->{'text_hash'}->{'edit_dstport'},
    $self->ui_opt_textbox("dstport",
	$self->{'rule'}->{'dst-port'} ? join(" ", @{$self->{'rule'}->{'dst-port'}}) : undef,
	30, $self->{'text_hash'}->{'edit_pany'}), 3, \@{$self->{'tds_array'}});

# Source ports directive
print $self->ui_table_row($self->{'text_hash'}->{'edit_srcport'},
    $self->ui_opt_textbox("srcport",
	$self->{'rule'}->{'src-port'} ? join(" ", @{$self->{'rule'}->{'src-port'}}) : undef,
	30, $self->{'text_hash'}->{'edit_pany'}), 3, \@{$self->{'tds_array'}});

print $self->ui_table_end();

if ($self->{'in_hash'}->{'new'}) {
	print $self->ui_form_end([ [ 'create', $self->{'text_hash'}->{'create'} ] ], "100%");
	}
else {
	print $self->ui_form_end([ [ 'save', $self->{'text_hash'}->{'save'} ],
			     [ 'delete', $self->{'text_hash'}->{'delete'} ] ], "100%");
	}

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}

# orblock_input(name, &orblock)
sub orblock_input
{
	shift if ($self == $_[0]);

return $self->{'text_hash'}->{'edit_orblock'}." ".
       $self->ui_textbox($_[0], join(" ", @{$_[1]}), 50).
       $self->ui_hidden($_[0]."_orblock", 1);
}

# yes_no_ignored_input(name)
sub yes_no_ignored_input
{
	shift if ($self == $_[0]);

local $mode = $self->{'rule'}->{$_[0]} && $self->{'rule'}->{$_[0]."_not"} ? 2 :
	      $self->{'rule'}->{$_[0]} ? 1 : 0;
return $self->ui_radio($_[0], $mode,
		 [ [ 1, $self->{'text_hash'}->{'yes'} ],
		   [ 0, $self->{'text_hash'}->{'no'} ] ]);
}


1;

