#!/usr/bin/perl
package ipsec::Log_parser;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'ipsec::Log_parser');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# log_parser.pl
# Functions for parsing this module's logs

&ModuleLoader::preload_module(ref($self), "ipsec::IpsecLib");
$self = new ipsec::IpsecLib:: ref($self), %$self; 

1;
		return $self;
}

# parse_webmin_log(user, script, action, type, object, &params)
# Converts logged information from this module into human-readable form
sub parse_webmin_log
{
	my $self = shift;

local ($user, $script, $action, $type, $object, $p, $long) = @_;
if ($type eq "conn") {
	return $self->text('log_'.$action.'_conn', "<tt>$object</tt>");
	}
elsif ($type eq "secret") {
	if ($p->{'name'}) {
		return $self->text('log_'.$action.'_secret', "<tt>$p->{'name'}</tt>");
		}
	else {
		return $self->text('log_'.$action.'_secret_nn');
		}
	}
elsif ($action eq "up") {
	return $self->text('log_up', "<tt>$object</tt>");
	}
elsif ($action eq "policy") {
	return $self->text('log_policy', $self->{'text_hash'}->{'policy_desc_'.$object} ||
				   $self->text('policy_desc', $object));
	}
else {
	return $self->{'text_hash'}->{'log_'.$action};
	}
}


1;

