#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_config.cgi
# Show global configuration options

&ModuleLoader::preload_module('ipsec_class', "ipsec::IpsecLib");
$self = new ipsec::IpsecLib:: 'ipsec_class',%$self;

$self->ui_print_header(undef, $self->{'text_hash'}->{'config_title'}, "");

@{$self->{'conf_array'}} = $self->get_config();
($self->{'config'}) = grep { $_->{'name'} eq 'config' } @{$self->{'conf_array'}};

print "<form action=save_config.cgi method=post>\n";
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'config_header'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

# Get list of interfaces
$self->foreign_require("net", "net-lib.pl");
@{$self->{'allifaces_array'}} = $self->unique(sort { $a cmp $b }
                (map { $_->{'fullname'} } $main::net_object->active_interfaces()),
                (map { $_->{'fullname'} } $main::net_object->boot_interfaces()) );

# Show interfaces to listen on
$self->{'i'} = $self->{'config'}->{'values'}->{'interfaces'};
$self->{'imode'} = $self->{'i'} eq '%none' ? 1 :
	 $self->{'i'} eq '%defaultroute' ? 2 :
	 $self->{'i'} ? 3 : 0;
print "<tr> <td valign=top><b>$self->{'text_hash'}->{'config_ifaces'}</b></td> <td colspan=3>\n";
foreach $m (0 .. 3) {
	printf "<input type=radio name=ifaces_mode value=%s %s> %s\n",
		$m, $m == $self->{'imode'} ? "checked" : "", $self->{'text_hash'}->{'config_ifaces'.$m};
	}
@{$self->{'iflist_array'}} = $self->{'imode'} == 3 ? split(/\s+/, $self->{'i'}) : ();
print "<br><table border>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'config_riface'}</b></td> ",
      "<td><b>$self->{'text_hash'}->{'config_iiface'}</b></td> </tr>\n";
$self->{'n'} = 0;
foreach $ifc (@{$self->{'iflist_array'}}, "") {
	local ($ii, $ri) = split(/=/, $ifc);
	print "<tr $self->{'cb'}>\n";

	$self->{'found'} = 0;
	print "<td><select name=ri_$self->{'n'}>\n";
	print "<option value=''>&nbsp;\n";
	foreach $r (@{$self->{'allifaces_array'}}) {
		next if ($r =~ /^ipsec/ || $r =~ /:/);
		printf "<option value=%s %s>%s (%s)\n",
			$r, $ri eq $r ? "selected" : "", $r,
			$main::net_object->iface_type($r);
		$self->{'found'}++ if ($ri eq $r);
		}
	print "<option value=$ri selected>$ri\n" if (!$self->{'found'} && $ri);
	print "</select></td>\n";

	$self->{'found'} = 0;
	print "<td><select name=ii_$self->{'n'}>\n";
	foreach $k (0 .. 4) {
		printf "<option value=ipsec%d %s>ipsec%d\n",
			$k, $ii eq "ipsec$k" ? "selected" : "", $k;
		$self->{'found'}++ if ($ii eq "ipsec$k");
		}
	print "<option value=$ii selected>$ii\n" if (!$self->{'found'} && $ii);
	print "</select></td>\n";

	print "</tr>\n";
	$self->{'n'}++;
	}
print "</table></td></tr>\n";

# syslog facility/level
$self->foreign_require("syslog", "syslog-lib.pl");
$self->{'s'} = $self->{'config'}->{'values'}->{'syslog'};
print "<tr> <td><b>$self->{'text_hash'}->{'config_syslog'}</b></td> <td colspan=3>\n";
printf "<input type=radio name=syslog_def value=1 %s> %s (<tt>%s</tt>)\n",
	$self->{'s'} ? "" : "checked", $self->{'text_hash'}->{'default'}, "daemon.error";
printf "<input type=radio name=syslog_def value=0 %s> %s\n",
	$self->{'s'} ? "checked" : "", $self->{'text_hash'}->{'config_fac'};
($self->{'fac'}, $self->{'pri'}) = split(/\./, $self->{'s'});
$self->{'pri'} =~ s/warn$/warning/;
$self->{'pri'} =~ s/panic$/emerg/;
$self->{'pri'} =~ s/error$/err/;
print "<select name=fac>\n";
foreach $f (split(/\s+/, $main::syslog_object->{'config_hash'}->{'facilities'})) {
	printf "<option %s>%s\n", $f eq $self->{'fac'} ? "selected" : "", $f;
	}
print "</select> $self->{'text_hash'}->{'config_pri'}\n";
print "<select name=pri>\n";
foreach $p ($main::syslog_object->list_priorities()) {
	printf "<option %s>%s\n", $p eq $self->{'pri'} ? "selected" : "", $p;
	}
print "</select></td> </tr>\n";

# automatic forwarding enable
$f = $self->{'config'}->{'values'}->{'forwardcontrol'};
print "<tr> <td><b>$self->{'text_hash'}->{'config_fwd'}</b></td>\n";
print "<td>",$self->ui_radio("fwd", $f || "no",
       [ [ "yes", $self->{'text_hash'}->{'yes'} ], [ "no", $self->{'text_hash'}->{'no'} ] ]),"</td>\n";

# nat traversal enable
$self->{'n'} = $self->{'config'}->{'values'}->{'nat_traversal'};
print "<td><b>$self->{'text_hash'}->{'config_nat'}</b></td>\n";
print "<td>",$self->ui_radio("nat", $self->{'n'} || "no",
       [ [ "yes", $self->{'text_hash'}->{'yes'} ], [ "no", $self->{'text_hash'}->{'no'} ] ]),"</td> </tr>\n";

print "<td colspan=2></td>\n";
print "</tr>\n";

print "</table></td></tr></table>\n";
print "<input type=submit value='$self->{'text_hash'}->{'save'}'></form>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

