#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Show one secret key

&ModuleLoader::preload_module('ipsec_class', "ipsec::IpsecLib");
$self = new ipsec::IpsecLib:: 'ipsec_class',%$self;

$self->ReadParse();
if ($self->{'in_hash'}->{'new'}) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'secret_title1'}, "");
	$self->{'sec'} = { 'type' => $self->{'in_hash'}->{'type'} };
	}
else {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'secret_title2'}, "");
	@{$self->{'secs_array'}} = $self->list_secrets();
	$self->{'sec'} = $self->{'secs_array'}->[$self->{'in_hash'}->{'idx'}];
	}

print $self->ui_form_start("save_secret.cgi", "post");
print $self->ui_hidden("new", $self->{'in_hash'}->{'new'});
print $self->ui_hidden("type", $self->{'sec'}->{'type'});
print $self->ui_hidden("idx", $self->{'in_hash'}->{'idx'});
print $self->ui_table_start($self->{'text_hash'}->{'secret_header'}, "100%", 2);

print $self->ui_table_row($self->{'text_hash'}->{'secret_name'},
		    $self->ui_radio("name_def", $self->{'sec'}->{'name'} ? 0 : 1,
			      [ [ 1, $self->{'text_hash'}->{'secrets_any'} ],
				[ 0, $self->{'text_hash'}->{'secret_for'} ] ])."\n".
		    $self->ui_textbox("name", $self->{'sec'}->{'name'}, 30));

print $self->ui_table_row($self->{'text_hash'}->{'secret_type'},
		    $self->{'text_hash'}->{'secrets_'.lc($self->{'sec'}->{'type'})} || uc($self->{'sec'}->{'type'}));

if (lc($self->{'sec'}->{'type'}) eq "psk") {
	# Shared key, with a password
	$self->{'pass'} = $self->{'sec'}->{'value'} =~ /"(.*)"/ ? $1 : $self->{'sec'}->{'value'};
	print $self->ui_table_row($self->{'text_hash'}->{'secret_pass'},
			    $self->ui_textbox("pass", $self->{'pass'}, 20));
	}
elsif (lc($self->{'sec'}->{'type'}) eq "rsa") {
	# RSA key .. show all editable parts
	$self->{'val'} = $self->{'sec'}->{'value'};
	$self->{'val'} =~ s/^\s*{//;
	$self->{'val'} =~ s/{\s*$//;
	while($self->{'val'} =~ /^\s*(\S+):\s+(\S+)((.|\n)*)/) {
		$self->{'rsa_hash'}->{$1} = $2;
		$self->{'val'} = $3;
		}
	foreach $p ($self->unique(@{$self->{'rsa_attribs_array'}}, keys(%{$self->{'rsa_hash'}}))) {
		print $self->ui_table_row($self->text('secret_rsa', $p),
		    $p eq "PublicExponent" ?
			$self->ui_textbox("rsa_$p", $self->{'rsa_hash'}->{$p}, 10) :
			$self->ui_textarea("rsa_$p", &split_line($self->{'rsa_hash'}->{$p}, 60),5,60));
		}
	}
else {
	# Unknown!!
	print $self->ui_table_row($self->{'text_hash'}->{'secret_value'},
			    $self->ui_textarea("value", $self->{'sec'}->{'value'},
					 20, 60));
	}

print $self->ui_table_end();
if ($self->{'in_hash'}->{'new'}) {
	print $self->ui_form_end([ [ "create", $self->{'text_hash'}->{'create'} ] ]);
	}
else {
	print $self->ui_form_end([ [ "save", $self->{'text_hash'}->{'save'} ],
			     [ "delete", $self->{'text_hash'}->{'delete'} ] ], 100);
	}

$self->ui_print_footer("list_secrets.cgi", $self->{'text_hash'}->{'secrets_return'},
		 "", $self->{'text_hash'}->{'index_return'});

1;
		
}

sub split_line
{
	shift if ($self == $_[0]);

local $str = $_[0];
local $rv;
while(length($str) > $_[1]) {
	$rv .= substr($str, 0, $_[1])."\n";
	$str = substr($str, $_[1]);
	}
$rv .= $str."\n";
return $rv;
}


1;

