#!/usr/bin/perl

&MAIN();

 sub MAIN {
# index.cgi
# Display existing IPsec tunnels

&ModuleLoader::preload_module('ipsec_class', "ipsec::IpsecLib");
$self = new ipsec::IpsecLib:: 'ipsec_class',%$self;


# Make sure the ipsec command exists
if (!$self->has_command($self->{'config_hash'}->{'ipsec'}) ||
    !(($self->{'ipsec_version'}, $self->{'ipsec_program'}) = $self->get_ipsec_version(\$self->{'out'}))) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", "intro", 1, 1, 0,
		$self->help_search_link("freeswan", "doc", "google"));
	print "<p>",$self->text('index_eipsec', "<tt>$self->{'config_hash'}->{'ipsec'}</tt>",
		  "$self->{'gconfig_hash'}->{'webprefix'}/config.cgi?$self->{'module_name'}"),"<p>\n";
	if ($self->{'out'}) {
		print $self->text('index_out',
			    "<tt>$self->{'config_hash'}->{'ipsec'} --version</tt>"),"\n";
		print "<pre>$self->{'out'}</pre>\n";
		}
	}
else {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", "intro", 1, 1, 0,
		$self->help_search_link("freeswan", "doc", "google"), undef, undef,
		$self->text('index_version2', $self->{'ipsec_version'}, $self->{'ipsec_program'}));

	# Make sure the config file exists
	if (!-r $self->{'config_hash'}->{'file'}) {
		print "<p>",$self->text('index_econfig', "<tt>$self->{'config_hash'}->{'file'}</tt>",
		  "$self->{'gconfig_hash'}->{'webprefix'}/config.cgi?$self->{'module_name'}"),"<p>\n";
		}
	else {
		# Check for the host secret
		if (!$self->got_secret()) {
			# No key setup yet .. offer to create one
			print "<p><b>",$self->text('index_nokey',
				  "<tt>$self->{'config_hash'}->{'secrets'}</tt>"),"</b><br>\n";
			print "<center><form action=newkey.cgi>\n";
			print "<input type=submit ",
			      "value='$self->{'text_hash'}->{'index_newkey'}'>\n";
			printf "<input name=host size=20 value='%s'>\n",
				$self->get_system_hostname();
			print "</form></center>\n";
			}
		else {
			# Show icons for connections
			print $self->ui_subheading($self->{'text_hash'}->{'index_header1'});
			@{$self->{'conf_array'}} = $self->get_config();
			@{$self->{'conns_array'}} = grep { $_->{'name'} eq 'conn' } @{$self->{'conf_array'}};
			if (@{$self->{'conns_array'}}) {
				foreach $c (@{$self->{'conns_array'}}) {
					push(@{$self->{'links_array'}}, "edit.cgi?idx=".
						     $c->{'index'});
					if ($c->{'value'} eq '%default') {
						push(@{$self->{'titles_array'}}, "<i>$self->{'text_hash'}->{'index_defconn'}</i>");
						$self->{'has_default'}++;
						}
					else {
						push(@{$self->{'titles_array'}},
						    $self->text('index_conn',
						    "<tt>$c->{'value'}</tt>"));
						push(@{$self->{'start_array'}}, $c->{'value'});
						}
					push(@{$self->{'icons_array'}}, "images/conn.gif");
					}
				$self->icons_table(\@{$self->{'links_array'}}, \@{$self->{'titles_array'}}, \@{$self->{'icons_array'}});
				}
			else {
				print "<b>$self->{'text_hash'}->{'index_none'}</b><p>\n";
				}
			print "<a href='edit.cgi?new=1'>$self->{'text_hash'}->{'index_add'}</a>";
			if (!$self->{'has_default'}) {
				print "&nbsp;" x 3;
				print "<a href='edit.cgi?new=2'>$self->{'text_hash'}->{'index_adddef'}</a>";
				}
			print "&nbsp;" x 3;
			print "<a href=import_form.cgi>$self->{'text_hash'}->{'index_import'}</a>";
			print "<p>\n";

			# Show icons for various options
			print "<hr>\n";
			print $self->ui_subheading($self->{'text_hash'}->{'index_header2'});
			@{$self->{'links_array'}} = ( "edit_config.cgi", "showkey.cgi",
				   "list_secrets.cgi" );
			@{$self->{'titles_array'}} = ( $self->{'text_hash'}->{'config_title'},
				    $self->{'text_hash'}->{'showkey_title'},
				    $self->{'text_hash'}->{'secrets_title'} );
			@{$self->{'icons_array'}} = ( "images/config.gif", "images/showkey.gif",
				   "images/secrets.gif" );
			if ($self->{'ipsec_version'} =~ /(\d+)/ && $1 >= 2) {
				@{$self->{'policies_array'}} = $self->list_policies();
				foreach $p (@{$self->{'policies_array'}}) {
					push(@{$self->{'links_array'}}, "edit_policy.cgi?policy=$p");
					push(@{$self->{'titles_array'}}, $self->{'text_hash'}->{'policy_desc_'.$p} ||
						      $self->text('policy_desc', $p));
					push(@{$self->{'icons_array'}}, "images/policy.gif");
					}
				$self->{'got_policies'} = 1;
				}
			$self->icons_table(\@{$self->{'links_array'}}, \@{$self->{'titles_array'}}, \@{$self->{'icons_array'}}, 4);
			if (!@{$self->{'policies_array'}} && $self->{'got_policies'}) {
				print "<b>",$self->text('index_nopol',
					"$self->{'gconfig_hash'}->{'webprefix'}/config.cgi?$self->{'module_name'}"),"</b><p>\n";
				}

			print "<hr>\n";
			print "<table width=100%>\n";

			# Start connection button
			if (@{$self->{'start_array'}} && $self->is_ipsec_running()) {
				print "<form action=up.cgi>\n";
				print "<td><input type=submit ",
				      "value='$self->{'text_hash'}->{'index_up'}'>\n";
				print "<select name=conn>\n";
				foreach $s (@{$self->{'start_array'}}) {
					printf "<option %s>%s\n",
					    $self->{'config_hash'}->{'conn'} eq $s ? "selected"
								  : "", $s;
					}
				print "</select></td>\n";
				print "<td>$self->{'text_hash'}->{'index_updesc'}</td>\n";
				print "</tr></form>\n";
				}

			# Start/stop/restart ipsec buttons
			if ($self->is_ipsec_running()) {
				print "<form action=restart.cgi><tr>\n";
				print "<td><input type=submit ",
				      "value='$self->{'text_hash'}->{'index_restart'}'></td>\n";
				print "<td>$self->{'text_hash'}->{'index_restartdesc'}</td>\n";
				print "</tr></form>\n";

				print "<form action=stop.cgi><tr>\n";
				print "<td><input type=submit ",
				      "value='$self->{'text_hash'}->{'index_stop'}'></td>\n";
				print "<td>$self->{'text_hash'}->{'index_stopdesc'}</td>\n";
				print "</tr></form>\n";
				}
			else {
				print "<form action=start.cgi><tr>\n";
				print "<td><input type=submit ",
				      "value='$self->{'text_hash'}->{'index_start'}'></td>\n";
				print "<td>$self->{'text_hash'}->{'index_startdesc'}</td>\n";
				print "</tr></form>\n";
				}

			# Show boot-time start button
			if ($self->foreign_check("init")) {
			    	$self->foreign_require("init", "init-lib.pl");
				$self->{'starting'} = $main::init_object->action_status("ipsec");
				print "<form action=bootup.cgi>\n";
				print "<input type=hidden name=starting ",
				      "value='$self->{'starting'}'>\n";
				print "<td nowrap><input type=submit ",
				      "value='$self->{'text_hash'}->{'index_boot'}'>\n";
				printf "<input type=radio name=boot ".
				       "value=1 %s> %s\n",
					$self->{'starting'} == 2 ? "checked" : "",
					$self->{'text_hash'}->{'yes'};
				printf "<input type=radio name=boot ".
				       "value=0 %s> %s</td>\n",
					$self->{'starting'} == 2 ? "" : "checked",
					$self->{'text_hash'}->{'no'};
				print "<td>$self->{'text_hash'}->{'index_bootdesc'}</td>\n";
				print "</form></tr>\n";
				}

			print "</table>\n";
			}
		}
	}

$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});

1;
		
}


1;

