#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Show all secret keys

&ModuleLoader::preload_module('ipsec_class', "ipsec::IpsecLib");
$self = new ipsec::IpsecLib:: 'ipsec_class',%$self;

$self->ui_print_header(undef, $self->{'text_hash'}->{'secrets_title'}, "");

@{$self->{'secs_array'}} = $self->list_secrets();
if (@{$self->{'secs_array'}}) {
	print $self->ui_columns_start([ $self->{'text_hash'}->{'secrets_name'},
				  $self->{'text_hash'}->{'secrets_type'},
				  $self->{'text_hash'}->{'secrets_desc'} ]);
	foreach $s (@{$self->{'secs_array'}}) {
		local $desc;
		if (lc($s->{'type'}) eq "psk" &&
		    $s->{'value'} =~ /"(.*)"/) {
			$desc = $self->text('secrets_pass', "<tt>$1</tt>");
			}
		elsif (lc($s->{'type'}) eq "rsa" &&
		       $s->{'value'} =~ /Modulus:\s*(\S+)/i) {
			$desc = $self->text('secrets_mod', "<tt>".substr($1, 0, 20)."..</tt>");
			}
		print $self->ui_columns_row([
			"<a href='edit_secret.cgi?idx=$s->{'idx'}'>".
			($s->{'name'} || $self->{'text_hash'}->{'secrets_any'})."</a>",
			$self->{'text_hash'}->{'secrets_'.lc($s->{'type'})} || uc($s->{'type'}),
			$desc,
			]);
		}
	print $self->ui_columns_end();
	}
else {
	print "<b>$self->{'text_hash'}->{'secrets_none'}</b><p>\n";
	}
print "<a href='edit_secret.cgi?new=1&type=psk'>$self->{'text_hash'}->{'secrets_newpsk'}</a>\n";
print "&nbsp;" x 2;
print "<a href='edit_secret.cgi?new=1&type=rsa'>$self->{'text_hash'}->{'secrets_newrsa'}</a>\n";
print "<br>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
1;
		
}


1;

