#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save.cgi
# Save, create or delete an ipsec connection

&ModuleLoader::preload_module('ipsec_class', "ipsec::IpsecLib");
$self = new ipsec::IpsecLib:: 'ipsec_class',%$self;

$self->ReadParse();
if ($self->{'in_hash'}->{'export'}) {
	# Just redirect to export form
	$self->redirect("export_form.cgi?idx=$self->{'in_hash'}->{'idx'}");
	exit;
	}
@{$self->{'conf_array'}} = $self->get_config();
if ($self->{'in_hash'}->{'new'}) {
	$self->{'conn'} = { 'name' => 'conn',
		  'values' => { } };
	$self->{'conn'}->{'value'} = '%default' if ($self->{'in_hash'}->{'new'} == 2);
	}
else {
	$self->{'conn'} = $self->{'conf_array'}->[$self->{'in_hash'}->{'idx'}];
	}
$self->error_setup($self->{'text_hash'}->{'save_err'});

$self->{'file'} = $self->{'conn'}->{'file'} || $self->{'config_hash'}->{'file'};
$self->lock_file($self->{'file'});
if ($self->{'in_hash'}->{'delete'}) {
	# Just remove this connection
	$self->delete_conn($self->{'conn'});
	}
else {
	# Validate and store general inputs
	if ($self->{'conn'}->{'value'} ne '%default') {
		$self->{'in_hash'}->{'name'} =~ /^\S+$/ || $self->error($self->{'text_hash'}->{'save_ename'});
		$self->{'conn'}->{'value'} = $self->{'in_hash'}->{'name'};
		}
	if ($self->{'in_hash'}->{'auto'}) {
		$self->{'conn'}->{'values'}->{'auto'} = $self->{'in_hash'}->{'auto'};
		}
	else {
		delete($self->{'conn'}->{'values'}->{'auto'});
		}
	if ($self->{'in_hash'}->{'comp'}) {
		$self->{'conn'}->{'values'}->{'compress'} = $self->{'in_hash'}->{'comp'};
		}
	else {
		delete($self->{'conn'}->{'values'}->{'compress'});
		}
	if ($self->{'in_hash'}->{'pfs'}) {
		$self->{'conn'}->{'values'}->{'pfs'} = $self->{'in_hash'}->{'pfs'};
		}
	else {
		delete($self->{'conn'}->{'values'}->{'pfs'});
		}
	if ($self->{'in_hash'}->{'type'}) {
		$self->{'conn'}->{'values'}->{'type'} = $self->{'in_hash'}->{'type'};
		}
	else {
		delete($self->{'conn'}->{'values'}->{'type'});
		}
	if ($self->{'in_hash'}->{'authby'}) {
		$self->{'conn'}->{'values'}->{'authby'} = $self->{'in_hash'}->{'authby'};
		}
	else {
		delete($self->{'conn'}->{'values'}->{'authby'});
		}
	if ($self->{'in_hash'}->{'keying_def'}) {
		delete($self->{'conn'}->{'values'}->{'keyingtries'});
		}
	else {
		$self->{'in_hash'}->{'keying'} =~ /^\d+$/ || $self->error($self->{'text_hash'}->{'save_ekeying'});
		$self->{'conn'}->{'values'}->{'keyingtries'} = $self->{'in_hash'}->{'keying'};
		}
	if ($self->{'in_hash'}->{'auth'}) {
		$self->{'conn'}->{'values'}->{'auth'} = $self->{'in_hash'}->{'auth'};
		}
	else {
		delete($self->{'conn'}->{'values'}->{'auth'});
		}

	if ($self->{'in_hash'}->{'esp'}) {
		$self->{'conn'}->{'values'}->{'esp'} = $self->{'in_hash'}->{'esp'}.$self->{'in_hash'}->{'esp_only'};
		}
	else {
		delete($self->{'conn'}->{'values'}->{'esp'});
		}

	if ($self->{'in_hash'}->{'keylife_def'}) {
		delete($self->{'conn'}->{'values'}->{'keylife'});
		}
	else {
		$self->{'in_hash'}->{'keylife'} =~ /^[0-9\.]+$/ ||
			$self->error($self->{'text_hash'}->{'save_ekeylife'});
		$self->{'conn'}->{'values'}->{'keylife'} =
			$self->{'in_hash'}->{'keylife'}.$self->{'in_hash'}->{'keylife_units'};
		}

	if ($self->{'in_hash'}->{'ikelifetime_def'}) {
		delete($self->{'conn'}->{'values'}->{'ikelifetime'});
		}
	else {
		$self->{'in_hash'}->{'ikelifetime'} =~ /^[0-9\.]+$/ ||
			$self->error($self->{'text_hash'}->{'save_eikelifetime'});
		$self->{'conn'}->{'values'}->{'ikelifetime'} =
			$self->{'in_hash'}->{'ikelifetime'}.$self->{'in_hash'}->{'ikelifetime_units'};
		}

	# Validate and store left/right inputs
	foreach $d ('left', 'right') {
		# left/right
		if ($self->{'in_hash'}->{"${d}_mode"} == -1) {
			delete($self->{'conn'}->{'values'}->{$d});
			}
		elsif ($self->{'in_hash'}->{"${d}_mode"} == 0) {
			$self->{'conn'}->{'values'}->{$d} = '%defaultroute';
			}
		elsif ($self->{'in_hash'}->{"${d}_mode"} == 1) {
			$self->{'conn'}->{'values'}->{$d} = '%any';
			}
		elsif ($self->{'in_hash'}->{"${d}_mode"} == 2) {
			$self->{'conn'}->{'values'}->{$d} = '%opportunistic';
			}
		else {
			gethostbyname($self->{'in_hash'}->{$d}) || $self->error($self->{'text_hash'}->{"save_e${d}"});
			$self->{'conn'}->{'values'}->{$d} = $self->{'in_hash'}->{$d};
			}

		# leftid/rightid
		if ($self->{'in_hash'}->{"${d}_id_mode"} == 0) {
			delete($self->{'conn'}->{'values'}->{"${d}id"});
			}
		elsif ($self->{'in_hash'}->{"${d}_id_mode"} == 1) {
			$self->check_ipaddress($self->{'in_hash'}->{"${d}_id"}) ||
				$self->error($self->{'text_hash'}->{"save_e${d}id1"});
			$self->{'conn'}->{'values'}->{"${d}id"} = $self->{'in_hash'}->{"${d}_id"};
			}
		else {
			$self->{'in_hash'}->{"${d}_id"} =~ /^[a-z0-9\.\-]+$/i ||
				$self->error($self->{'text_hash'}->{"save_e${d}id2"});
			$self->{'conn'}->{'values'}->{"${d}id"} = "@".$self->{'in_hash'}->{"${d}_id"};
			}

		# leftsubnet/rightsubnet
		if ($self->{'in_hash'}->{"${d}_subnet_def"}) {
			delete($self->{'conn'}->{'values'}->{"${d}subnet"});
			}
		else {
			$self->{'in_hash'}->{"${d}_subnet"} =~ /^(\S+)\/(\d+)$/ &&
			    $self->check_ipaddress("$1") && $2 <= 32 ||
				$self->error($self->{'text_hash'}->{"save_e${d}subnet"});
			$self->{'conn'}->{'values'}->{"${d}subnet"} = $self->{'in_hash'}->{"${d}_subnet"};
			}

		# leftrsasigkey/rightrsasigkey
		if ($self->{'in_hash'}->{"${d}_key_mode"} == 0) {
			delete($self->{'conn'}->{'values'}->{"${d}rsasigkey"});
			}
		elsif ($self->{'in_hash'}->{"${d}_key_mode"} == 1) {
			$self->{'conn'}->{'values'}->{"${d}rsasigkey"} = '%dns';
			}
		else {
			$self->{'in_hash'}->{"${d}_key"} =~ s/\s//g;
			$self->{'in_hash'}->{"${d}_key"} || $self->error($self->{'text_hash'}->{"save_e${d}key"});
			$self->{'conn'}->{'values'}->{"${d}rsasigkey"} = $self->{'in_hash'}->{"${d}_key"};
			}

		# leftnexthop/rightnexthop
		if ($self->{'in_hash'}->{"${d}_hop_mode"} == 0) {
			delete($self->{'conn'}->{'values'}->{"${d}nexthop"});
			}
		elsif ($self->{'in_hash'}->{"${d}_hop_mode"} == 1) {
			$self->{'conn'}->{'values'}->{"${d}nexthop"} = '%direct';
			}
		elsif ($self->{'in_hash'}->{"${d}_hop_mode"} == 3) {
			$self->{'conn'}->{'values'}->{"${d}nexthop"} = '%defaultroute';
			}
		else {
			$self->check_ipaddress($self->{'in_hash'}->{"${d}_hop"}) ||
				$self->error($self->{'text_hash'}->{"save_e${d}hop"});
			$self->{'conn'}->{'values'}->{"${d}nexthop"} = $self->{'in_hash'}->{"${d}_hop"};
			}

		# leftcert/rightcert
		if ($self->{'in_hash'}->{"${d}_cert_def"}) {
			delete($self->{'conn'}->{'values'}->{"${d}cert"});
			}
		else {
			$self->{'in_hash'}->{"${d}_cert"} =~ /^(\S+)$/ ||
				$self->error($self->{'text_hash'}->{"save_e${d}cert"});
			$self->{'conn'}->{'values'}->{"${d}cert"} = $self->{'in_hash'}->{"${d}_cert"};
			}
		}

	# Update or add
	if ($self->{'in_hash'}->{'new'}) {
		$self->create_conn($self->{'conn'});
		}
	else {
		$self->modify_conn($self->{'conn'});
		}
	}
$self->unlock_file($self->{'file'});
$self->webmin_log($self->{'in_hash'}->{'new'} ? "create" : $self->{'in_hash'}->{'delete'} ? "delete" : "modify",
	    "conn", $self->{'conn'}->{'value'}, $self->{'conn'}->{'values'});
$self->redirect("");

1;
		
}


1;

