#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_config.cgi
# Update or create the config section

&ModuleLoader::preload_module('ipsec_class', "ipsec::IpsecLib");
$self = new ipsec::IpsecLib:: 'ipsec_class',%$self;

$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'config_err'});
@{$self->{'conf_array'}} = $self->get_config();
($self->{'config'}) = grep { $_->{'name'} eq 'config' } @{$self->{'conf_array'}};
if (!$self->{'config'}) {
	$self->{'config'} = { 'name' => 'config',
		    'value' => 'setup',
		    'values' => { } };
	}

# Validate and store inputs
if ($self->{'in_hash'}->{'ifaces_mode'} == 0) {
	delete($self->{'config'}->{'values'}->{'interfaces'});
	}
elsif ($self->{'in_hash'}->{'ifaces_mode'} == 1) {
	$self->{'config'}->{'values'}->{'interfaces'} = '%none';
	}
elsif ($self->{'in_hash'}->{'ifaces_mode'} == 2) {
	$self->{'config'}->{'values'}->{'interfaces'} = '%defaultroute';
	}
else {
	for($n=0; defined($self->{'ri'} = $self->{'in_hash'}->{"ri_$n"}); $n++) {
		next if (!$self->{'ri'});
		$self->{'ii'} = $self->{'in_hash'}->{"ii_$n"};
		$self->{'done_hash'}->{$self->{'ri'}}++ && $self->error($self->text('config_eri', $self->{'ri'}));
		push(@{$self->{'ifaces_array'}}, "$self->{'ii'}=$self->{'ri'}");
		}
	@{$self->{'ifaces_array'}} || $self->error($self->{'text_hash'}->{'config_enone'});
	$self->{'config'}->{'values'}->{'interfaces'} = join(" ", @{$self->{'ifaces_array'}});
	}

if ($self->{'in_hash'}->{'syslog_def'}) {
	delete($self->{'config'}->{'values'}->{'syslog'});
	}
else {
	$self->{'config'}->{'values'}->{'syslog'} = $self->{'in_hash'}->{'fac'}.".".$self->{'in_hash'}->{'pri'};
	}

if ($self->{'in_hash'}->{'fwd'} eq 'yes' || $self->{'config'}->{'values'}->{'forwardcontrol'}) {
	$self->{'config'}->{'values'}->{'forwardcontrol'} = $self->{'in_hash'}->{'fwd'};
	}
else {
	delete($self->{'config'}->{'values'}->{'forwardcontrol'});
	}

if ($self->{'in_hash'}->{'fwd'} eq 'yes' || $self->{'config'}->{'values'}->{'forwardcontrol'}) {
	$self->{'config'}->{'values'}->{'forwardcontrol'} = $self->{'in_hash'}->{'fwd'};
	}
else {
	delete($self->{'config'}->{'values'}->{'forwardcontrol'});
	}

if ($self->{'in_hash'}->{'nat'} eq 'yes' || $self->{'config'}->{'values'}->{'nat_traversal'}) {
	$self->{'config'}->{'values'}->{'nat_traversal'} = $self->{'in_hash'}->{'nat'};
	}
else {
	delete($self->{'config'}->{'values'}->{'nat_traversal'});
	}

# Create or update the section
$self->{'file'} = $self->{'config'}->{'file'} || $self->{'config_hash'}->{'file'};
$self->lock_file($self->{'file'});
if ($self->{'config'}->{'file'}) {
	$self->modify_conn($self->{'config'});
	}
else {
	$self->create_conn($self->{'config'});
	}
$self->unlock_file($self->{'file'});
$self->webmin_log("config");
$self->redirect("");

1;
		
}


1;

