#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Create, update or delete a secret key

&ModuleLoader::preload_module('ipsec_class', "ipsec::IpsecLib");
$self = new ipsec::IpsecLib:: 'ipsec_class',%$self;

$self->ReadParse();
@{$self->{'secs_array'}} = $self->list_secrets();
if ($self->{'in_hash'}->{'new'}) {
	$self->{'sec'} = { 'type' => $self->{'in_hash'}->{'type'} };
	}
else {
	$self->{'sec'} = $self->{'secs_array'}->[$self->{'in_hash'}->{'idx'}];
	}

if ($self->{'in_hash'}->{'delete'}) {
	# Just kill this key
	@{$self->{'secs_array'}} > 1 || $self->error($self->{'text_hash'}->{'secret_elast'});
	$self->lock_file($self->{'config_hash'}->{'secrets'});
	$self->delete_secret($self->{'sec'});
	$self->unlock_file($self->{'config_hash'}->{'secrets'});
	$self->webmin_log("delete", "secret", undef, { 'name' => $self->{'sec'}->{'name'} });
	}
else {
	# Validate inputs
	$self->error_setup($self->{'text_hash'}->{'secret_err'});
	$self->{'in_hash'}->{'name_def'} || $self->{'in_hash'}->{'name'} =~ /\S/ ||
		$self->error($self->{'text_hash'}->{'secret_ename'});
	$self->{'oldname'} = $self->{'sec'}->{'name'};
	$self->{'sec'}->{'name'} = $self->{'in_hash'}->{'name_def'} ? "" : $self->{'in_hash'}->{'name'};
	if (lc($self->{'sec'}->{'type'}) eq 'psk') {
		$self->{'in_hash'}->{'pass'} || $self->error($self->{'text_hash'}->{'secret_epass'});
		$self->{'sec'}->{'value'} = "\"$self->{'in_hash'}->{'pass'}\"";
		}
	elsif (lc($self->{'sec'}->{'type'}) eq 'rsa') {
		$self->{'sec'}->{'value'} = "{\n";
		@{$self->{'rsa_in_array'}} = map { $_ =~ /^rsa_(\S+)/ ? ( $1 ) : ( ) } keys(%{$self->{'in_hash'}});
		foreach $p ($self->unique(@{$self->{'rsa_attribs_array'}}, @{$self->{'rsa_in_array'}})) {
			$self->{'k'} = "rsa_$p";
			next if (!defined($self->{'in_hash'}->{$self->{'k'}}));
			$self->{'in_hash'}->{$self->{'k'}} =~ s/\s//g;
			$self->{'in_hash'}->{$self->{'k'}} =~ /\S/ || $self->error($self->text('secret_ersa', $p));
			$self->{'sec'}->{'value'} .= "\t".$p.": ".$self->{'in_hash'}->{$self->{'k'}}."\n";
			}
		$self->{'sec'}->{'value'} .= "\t}";
		}

	# Update or create
	$self->lock_file($self->{'config_hash'}->{'secrets'});
	if ($self->{'in_hash'}->{'new'}) {
		$self->create_secret($self->{'sec'});
		$self->{'logname'} = $self->{'sec'}->{'name'};
		}
	else {
		$self->modify_secret($self->{'sec'});
		$self->{'logname'} = $self->{'oldname'};
		}
	$self->unlock_file($self->{'config_hash'}->{'secrets'});
	$self->webmin_log($self->{'in_hash'}->{'new'} ? "create" : "modify", "secret", undef,
		    { 'name' => $self->{'logname'} });
	}
$self->redirect("list_secrets.cgi");

1;
		
}


1;

