#!/usr/bin/perl

&MAIN();

 sub MAIN {
# index.cgi
# Display jabber configuration option categories

&ModuleLoader::preload_module('jabber_class', "jabber::JabberLib");
$self = new jabber::JabberLib:: 'jabber_class',%$self;


# Check if config file exists
if (!-r $self->{'config_hash'}->{'jabber_config'}) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", "intro", 1, 1, undef,
		$self->help_search_link("jabber", "man", "doc", "google"));
	print $self->text('index_econfig', "<tt>$self->{'config_hash'}->{'jabber_config'}</tt>",
		    "$self->{'gconfig_hash'}->{'webprefix'}/config.cgi?$self->{'module_name'}"),"<p>\n";
	$self->ui_print_footer("/", $self->{'text_hash'}->{"index"});
	exit;
	}

# Check if base directory exists
if (!-d $self->{'config_hash'}->{'jabber_dir'}) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", "intro", 1, 1, undef,
		$self->help_search_link("jabber", "man", "doc", "google"));
	print $self->text('index_edir', "<tt>$self->{'config_hash'}->{'jabber_dir'}</tt>",
		    "$self->{'gconfig_hash'}->{'webprefix'}/config.cgi?$self->{'module_name'}"),"<p>\n";
	$self->ui_print_footer("/", $self->{'text_hash'}->{"index"});
	exit;
	}

# Check the version of jabberd
$self->{'jabberd'} = $self->{'config_hash'}->{'jabber_daemon'} ? $self->{'config_hash'}->{'jabber_daemon'}
				    : "$self->{'config_hash'}->{'jabber_dir'}/bin/jabberd";
if (!-x $self->{'jabberd'}) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", "intro", 1, 1, undef,
		$self->help_search_link("jabber", "man", "doc", "google"));
	print $self->text('index_ejabberd', "<tt>$self->{'jabberd'}</tt>",
		    "$self->{'gconfig_hash'}->{'webprefix'}/config.cgi?$self->{'module_name'}"),"<p>\n";
	$self->ui_print_footer("/", $self->{'text_hash'}->{"index"});
	exit;
	}
$self->{'ver'} = $self->get_jabberd_version(\$self->{'out'});
if (!$self->{'ver'}) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", "intro", 1, 1, undef,
		$self->help_search_link("jabber", "man", "doc", "google"));
	print $self->text('index_eversion', "<pre>$self->{'out'}</pre>", "1.4",
		    "<tt>$self->{'jabberd'} -v</tt>"),"<p>\n";
	$self->ui_print_footer("/", $self->{'text_hash'}->{"index"});
	exit;
	}
elsif ($self->{'ver'} >= 2) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", "intro", 1, 1, undef,
		$self->help_search_link("jabber", "man", "doc", "google"));
	print $self->text('index_eversion2', "<pre>$self->{'out'}</pre>", "2.0",
		    "<tt>$self->{'jabberd'} -v</tt>"),"<p>\n";
	$self->ui_print_footer("/", $self->{'text_hash'}->{"index"});
	exit;
	}

$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", "intro", 1, 1, undef,
	$self->help_search_link("jabber", "man", "doc", "google"),
	undef, undef, $self->text('index_version', $self->{'ver'}));

# Check if the needed Perl module are installed
push(@{$self->{'needs_array'}}, "XML::Parser") if (!$self->{'got_xml_parser'});
push(@{$self->{'needs_array'}}, "XML::Generator") if (!$self->{'got_xml_generator'});
if (@{$self->{'needs_array'}}) {
	$self->{'needs'} = $self->urlize(join(" ", @{$self->{'needs_array'}}));
	print $self->text(@{$self->{'needs_array'}} == 2 ? 'index_emodules' : 'index_emodule', @{$self->{'needs_array'}},
	    "/cpan/download.cgi?source=3&cpan=$self->{'needs'}&mode=2&return=/$self->{'module_name'}/&returndesc=".$self->urlize($self->{'text_hash'}->{'index_return'})),"<p>\n";
	print "$self->{'text_hash'}->{'index_expat'}<p>\n";
	print "<hr>\n";
	$self->ui_print_footer("/", $self->{'text_hash'}->{"index"});
	exit;
	}

# Show config category icons
$self->{'conf'} = $self->get_jabber_config();
if (!ref($self->{'conf'})) {
	print $self->text('index_eparse', "<tt>XML::Parser</tt>", $self->{'conf'}),"<p>\n";
	print "<hr>\n";
	$self->ui_print_footer("/", $self->{'text_hash'}->{"index"});
	exit;
	}
@{$self->{'cats_array'}} = ( "general", "messages", "modules", "karma", "ips", "filter", "admin", "file" );
@{$self->{'links_array'}} = map { "edit_${_}.cgi" } @{$self->{'cats_array'}};
@{$self->{'titles_array'}} = map { $self->{'text_hash'}->{"${_}_title"} } @{$self->{'cats_array'}};
@{$self->{'icons_array'}} = map { "images/${_}.gif" } @{$self->{'cats_array'}};
$self->icons_table(\@{$self->{'links_array'}}, \@{$self->{'titles_array'}}, \@{$self->{'icons_array'}});

# Show warning about config file
open(CONFIG, $self->{'config_hash'}->{'jabber_config'});
while(<CONFIG>) {
	if (/\s+<!--/) {
		$self->{'has_comment'}++;
		last;
		}
	}
close(CONFIG);
print "<b>",$self->text('index_comments',
	  "<tt>$self->{'config_hash'}->{'jabber_config'}</tt>"),"</b><p>\n" if ($self->{'has_comment'});

# Check if jabber is running and show the correct buttons
print "<hr>\n";
print "<table width=100%>\n";
if ($self->check_pid_file($self->jabber_pid_file())) {
	# Running .. offer to restart and stop
	print "<form action=restart.cgi><tr>\n";
	print "<td><input type=submit value=\"$self->{'text_hash'}->{'index_restart'}\"></td>\n";
	print "<td>$self->{'text_hash'}->{'index_restartmsg'}</td>\n";
	print "</tr></form>\n";

	print "<form action=stop.cgi><tr>\n";
	print "<td><input type=submit value=\"$self->{'text_hash'}->{'index_stop'}\"></td>\n";
	print "<td>$self->{'text_hash'}->{'index_stopmsg'}</td>\n";
	print "</tr></form>\n";
	}
else {
	# Not running .. offer to start
	print "<form action=start.cgi><tr>\n";
	print "<td><input type=submit value=\"$self->{'text_hash'}->{'index_start'}\"></td>\n";
	print "<td>$self->{'text_hash'}->{'index_startmsg'}</td>\n";
	print "</tr></form>\n";
	}
print "</table>\n";
close(PID);

$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});

1;
		
}


1;

