#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_filter.cgi
# Save user filter options

&ModuleLoader::preload_module('jabber_class', "jabber::JabberLib");
$self = new jabber::JabberLib:: 'jabber_class',%$self;

$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'filter_err'});

$self->{'conf'} = $self->get_jabber_config();
$self->{'session'} = $self->find_by_tag("service", "id", "sessions", $self->{'conf'});
$self->{'jsm'} = $self->find("jsm", $self->{'session'});
$self->{'filter'} = $self->find("filter", $self->{'jsm'});
$self->{'allow'} = $self->find("allow", $self->{'filter'});

# Validate and store inputs
$self->{'in_hash'}->{'max'} =~ /^\d+$/ || $self->error($self->{'text_hash'}->{'filter_emax'});
$self->save_directive($self->{'filter'}, "max_size",
		[ [ "max_size", [ { }, 0, $self->{'in_hash'}->{'max'} ] ] ] );
$self->{'conds'} = $self->find("conditions", $self->{'allow'});
foreach $c (@{$self->{'filter_conds_array'}}) {
	if ($self->{'in_hash'}->{"cond_$c"}) {
		$self->save_directive($self->{'conds'}, $c, [ [ $c, [ { } ] ] ] );
		}
	else {
		$self->save_directive($self->{'conds'}, $c);
		}
	}
$self->{'acts'} = $self->find("actions", $self->{'allow'});
foreach $c (@{$self->{'filter_acts_array'}}) {
	if ($self->{'in_hash'}->{"act_$c"}) {
		$self->save_directive($self->{'acts'}, $c, [ [ $c, [ { } ] ] ] );
		}
	else {
		$self->save_directive($self->{'acts'}, $c);
		}
	}

$self->save_jabber_config($self->{'conf'});
$self->redirect("");

1;
		
}


1;

