#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_general.cgi
# Save general jabber server options

&ModuleLoader::preload_module('jabber_class', "jabber::JabberLib");
$self = new jabber::JabberLib:: 'jabber_class',%$self;

$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'general_err'});

$self->{'conf'} = $self->get_jabber_config();
$self->{'session'} = $self->find_by_tag("service", "id", "sessions", $self->{'conf'});
$self->{'host'} = $self->find("host", $self->{'session'});
$self->{'hostname'} = $self->find_by_tag("jabberd:cmdline", "flag", "h", $self->{'host'});
$self->{'jsm'} = $self->find("jsm", $self->{'session'});
$self->{'update'} = $self->find("update", $self->{'jsm'});
$self->{'updatename'} = $self->find_by_tag("jabberd:cmdline", "flag", "h", $self->{'update'});
$self->{'elogger'} = $self->find_by_tag("log", "id", "elogger", $self->{'conf'});
$self->{'rlogger'} = $self->find_by_tag("log", "id", "rlogger", $self->{'conf'});
$self->{'pidfile'} = $self->find_value("pidfile", $self->{'conf'});

# Validate and store inputs
$self->{'in_hash'}->{'host'} =~ /^[a-z0-9\.\-]+$/ || $self->error($self->{'text_hash'}->{'general_ehost'});
$self->save_directive($self->{'hostname'}, "0", [ [ 0, $self->{'in_hash'}->{'host'} ] ]);
$self->save_directive($self->{'updatename'}, "0", [ [ 0, $self->{'in_hash'}->{'host'} ] ]) if ($self->{'updatename'});
$self->{'in_hash'}->{'elog'} =~ /^\S+$/ || $self->error($self->{'text_hash'}->{'general_eelog'});
$self->{'in_hash'}->{'elogfmt'} =~ /\S/ || $self->error($self->{'text_hash'}->{'general_eelogfmt'});
if ($self->{'elogger'}) {
	$self->save_directive($self->{'elogger'}, "file",
			[ [ 'file', [ { }, 0, $self->{'in_hash'}->{'elog'} ] ] ] );
	$self->save_directive($self->{'elogger'}, "format",
			[ [ 'format', [ { }, 0, $self->{'in_hash'}->{'elogfmt'} ] ] ] );
	}
$self->{'in_hash'}->{'rlog'} =~ /^\S+$/ || $self->error($self->{'text_hash'}->{'general_erlog'});
$self->{'in_hash'}->{'rlogfmt'} =~ /\S/ || $self->error($self->{'text_hash'}->{'general_erlogfmt'});
if ($self->{'rlogger'}) {
	$self->save_directive($self->{'rlogger'}, "file",
			[ [ 'file', [ { }, 0, $self->{'in_hash'}->{'rlog'} ] ] ] );
	$self->save_directive($self->{'rlogger'}, "format",
			[ [ 'format', [ { }, 0, $self->{'in_hash'}->{'rlogfmt'} ] ] ] );
	}
$self->{'in_hash'}->{'pidfile'} =~ /^\S+$/ || $self->error($self->{'text_hash'}->{'general_epidfile'});
$self->save_directive($self->{'conf'}, "pidfile",
		[ [ 'pidfile', [ { }, 0, $self->{'in_hash'}->{'pidfile'} ] ] ] );
$self->{'spool'} = $self->{'config_hash'}->{'jabber_spool'} ? $self->{'config_hash'}->{'jabber_spool'}
				 : "$self->{'config_hash'}->{'jabber_dir'}/spool";
mkdir("$self->{'spool'}/$self->{'in_hash'}->{'host'}", 0755);

$self->save_jabber_config($self->{'conf'});
$self->redirect("");

1;
		
}


1;

