#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_ips.cgi
# Save allowed and denied IP addresses

&ModuleLoader::preload_module('jabber_class', "jabber::JabberLib");
$self = new jabber::JabberLib:: 'jabber_class',%$self;

$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'ips_err'});

$self->{'conf'} = $self->get_jabber_config();
$self->{'io'} = $self->find("io", $self->{'conf'});
@{$self->{'oldallow_array'}} = $self->find("allow", $self->{'io'});
@{$self->{'olddeny_array'}} = $self->find("deny", $self->{'io'});

# Validate and store inputs
if (!$self->{'in_hash'}->{'allow_def'}) {
	foreach $a (split(/\s+/, $self->{'in_hash'}->{'allow'})) {
		push(@{$self->{'allow_array'}}, &check_addr($a, "allow"));
		}
	}
if (!$self->{'in_hash'}->{'deny_def'}) {
	foreach $a (split(/\s+/, $self->{'in_hash'}->{'deny'})) {
		push(@{$self->{'deny_array'}}, &check_addr($a, "deny"));
		}
	}
$self->save_directive($self->{'io'}, "allow", \@{$self->{'allow_array'}});
$self->save_directive($self->{'io'}, "deny", \@{$self->{'deny_array'}});
$self->save_jabber_config($self->{'conf'});
$self->redirect("");

1;
		
}

sub check_addr
{
	shift if ($self == $_[0]);

if ($self->check_ipaddress($_[0])) {
	return [ $_[1], [ {}, "ip", [ { }, "0", $_[0] ] ] ];
	}
elsif ($_[0] =~ /^(\S+)\/(\S+)$/ &&
       $self->check_ipaddress($1) && $self->check_ipaddress($2)) {
	return [ $_[1], [ {}, "ip", [ { }, "0", $1 ],
			      "mask", [ { }, "0", $2 ] ] ];
	}
else {
	$self->error($self->text('ips_eaddr', $_[0]));
	}
}


1;

