#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_karma.cgi
# Save karma traffic control options

&ModuleLoader::preload_module('jabber_class', "jabber::JabberLib");
$self = new jabber::JabberLib:: 'jabber_class',%$self;

$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'karma_err'});

$self->{'conf'} = $self->get_jabber_config();
$self->{'io'} = $self->find("io", $self->{'conf'});
$self->{'karma'} = $self->find("karma", $self->{'io'});

if (!$self->{'karma'}) {
	# Create a new empty karma block
	$self->{'karma'} = [ "karma", [ { } ] ];
	}

# Validate and store inputs
if ($self->{'in_hash'}->{'rate_def'}) {
	$self->save_directive($self->{'io'}, "rate");
	}
else {
	$self->{'in_hash'}->{'points'} =~ /^\d+$/ || $self->error($self->{'text_hash'}->{'karma_epoints'});
	$self->{'in_hash'}->{'time'} =~ /^\d+$/ || $self->error($self->{'text_hash'}->{'karma_etime'});
	$self->save_directive($self->{'io'}, "rate",
			[ [ "rate", [ { 'points' => $self->{'in_hash'}->{'points'},
					'time' => $self->{'in_hash'}->{'time'} } ] ] ] );
	}
if ($self->{'in_hash'}->{'mode'} == -1) {
	# Remove karma section entirely
	$self->save_directive($self->{'io'}, "karma");
	}
elsif ($self->{'in_hash'}->{'mode'} == 3) {
	# Check user karma inputs
	foreach $k ('heartbeat', 'init', 'max', 'dec', 'penalty', 'restore') {
		$self->{'in_hash'}->{$k} =~ /^\d+$/ || $self->error($self->{'text_hash'}->{"karma_e$k"});
		local $v = $k eq 'penalty' ? -$self->{'in_hash'}->{$k} : $self->{'in_hash'}->{$k};
		$self->save_directive($self->{'karma'}, $k, [ [ $k, [ { }, 0, $v ] ] ] );
		}
	}
else {
	# Use pre-defined karma
	$self->{'kp'} = $self->{'karma_presets_array'}->[$self->{'in_hash'}->{'mode'}];
	foreach $k (keys %{$self->{'kp'}}) {
		$self->save_directive($self->{'karma'}, $k, [ [ $k, [ { }, 0, $self->{'kp'}->{$k} ] ] ] );
		}
	$self->save_directive($self->{'io'}, "karma", [ $self->{'karma'} ] );
	}
$self->save_jabber_config($self->{'conf'});
$self->redirect("");

1;
		
}


1;

