#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_messages.cgi
# Save welcome and other messages

&ModuleLoader::preload_module('jabber_class', "jabber::JabberLib");
$self = new jabber::JabberLib:: 'jabber_class',%$self;

$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'messages_err'});

$self->{'conf'} = $self->get_jabber_config();
$self->{'session'} = $self->find_by_tag("service", "id", "sessions", $self->{'conf'});
$self->{'jsm'} = $self->find("jsm", $self->{'session'});
$self->{'welcome'} = $self->find("welcome", $self->{'jsm'});
$self->{'register'} = $self->find("register", $self->{'jsm'});
$self->{'vcard'} = $self->find("vcard", $self->{'jsm'});

# Validate and store inputs
$self->save_directive($self->{'welcome'}, "subject",
		[ [ "subject", [ { }, 0, $self->{'in_hash'}->{'wsubject'} ] ] ] );
$self->save_directive($self->{'welcome'}, "body",
		[ [ "body", [ { }, 0, $self->{'in_hash'}->{'wbody'} ] ] ] );
eval {
	$self->{'xml'} = new XML::Parser('Style' => 'Tree');
	$self->{'in_hash'}->{'vcard'} =~ s/\r//g;
	$self->{'vcxml'} = $self->{'xml'}->parse($self->{'in_hash'}->{'vcard'});
	};
$self->{'register'}->[1]->[0]->{'notify'} = $self->{'in_hash'}->{'rnotify'} ? 'yes' : 'no';
$self->save_directive($self->{'register'}, "instructions",
		[ [ "instructions", [ { }, 0, $self->{'in_hash'}->{'rinstr'} ] ] ] );
foreach $f (@{$self->{'register_fields_array'}}) {
	if ($self->{'in_hash'}->{"rfield_$f"}) {
		$self->save_directive($self->{'register'}, $f, [ [ $f, [ { } ] ] ] );
		}
	else {
		$self->save_directive($self->{'register'}, $f);
		}
	}
$self->error($self->text('messages_evcard', $@)) if ($@);
$self->error($self->{'text_hash'}->{'messages_etag'}) if (lc($self->{'vcxml'}->[0]) ne 'vcard');
$self->save_directive($self->{'jsm'}, [ $self->{'vcard'} ], [ $self->{'vcxml'} ]);
$self->save_directive($self->{'jsm'}, "vcard2jud",
		$self->{'in_hash'}->{'vcard2jud'} ? [ [ 'vcard2jud', [ { } ] ] ] : [ ] );

$self->save_jabber_config($self->{'conf'});
$self->redirect("");

1;
		
}


1;

