#!/usr/bin/perl
package jakarta_tomcat::JakartatomcatLib;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'jakarta_tomcat::JakartatomcatLib');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# jakarta-tomcat-lib.pl
# Common functions for jakarta_tomcat configuration

#main part
&ModuleLoader::preload_module(ref($self), "WebLib");
$self = new WebLib:: ref($self), %$self; 
$self->init_config();
&ModuleLoader::preload_module(ref($self), "UiLib");
$self = new UiLib:: ref($self), %$self; 

eval "use XML::Parser;";
$self->{'got_xml_parser'}++ unless $@;

#++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

#++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

#++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

#++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

#++++++++++++++++++++++++++++++++++++++++++++++

#++++++++++++++++++++++++++++++++++++++++++++++++++++

1;
1;
		return $self;
}

#get version of jakarta_tomcat
sub get_version_tomcat
{
	my $self = shift;

 my $version=`JAVA_HOME=$self->{'config_hash'}->{java_home} $self->{'config_hash'}->{tomcat_cmd} version | grep -i 'version'`;
 $version =~ m/\/(.+)/;
 $version = $1;
 return $version;
}

#status jakarta_tomcat
#return 'start' if Tomcat stop & return 'stop' if Tomcat start
sub status_tomcat
{
	my $self = shift;

 @{$self->{'pids_array'}} = $self->find_byname("tomcat");
 if (@{$self->{'pids_array'}}){return $self->{'status'}='Stop';}
 else {return $self->{'status'}='Start';}
}

#start jakarta_tomcat
sub start_tomcat
{
	my $self = shift;

 my $status=$self->status_tomcat();
 if ($status eq 'Start')
 {
  my $out = $self->backquote_logged("JAVA_HOME=$self->{'config_hash'}->{java_home} $self->{'config_hash'}->{tomcat_cmd} start 2>&1 </dev/null");
  $self->error($out) if ($?);
  $self->webmin_log("start");
 }
 else {$self->{'text_hash'}->{'proces_status'};}
}

#stop jakarta_tomcat
sub stop_tomcat
{
	my $self = shift;

 my $status=$self->status_tomcat();
 if ($status eq 'Stop')
 {
  while ($status eq 'Stop')
  {
   my $out = $self->backquote_logged("JAVA_HOME=$self->{'config_hash'}->{java_home} $self->{'config_hash'}->{tomcat_cmd} stop 2>&1 </dev/null");
   $self->error($out) if ($?);
   $self->webmin_log("stop");
   $status=$self->status_tomcat();
  }
 }
 else {$self->{'text_hash'}->{'proces_status2'};
}

#restart jakarta_tomcat
sub restart_tomcat
{
 my $status=$self->status_tomcat();
 if ($status eq 'Stop')
 {
  while ($status eq 'Stop')
  {
   my $out = $self->backquote_logged("JAVA_HOME=$self->{'config_hash'}->{java_home} $self->{'config_hash'}->{tomcat_cmd} stop 2>&1 </dev/null");
   $self->error($out) if ($?);
   $self->webmin_log("stop");
   $status=$self->status_tomcat();
  }
  my $out = $self->backquote_logged("JAVA_HOME=$self->{'config_hash'}->{java_home} $self->{'config_hash'}->{tomcat_cmd} start 2>&1 </dev/null");
  $self->error($out) if ($?);
  $self->webmin_log("restart");}
 }
}


#delete configuration cache
sub delete_cache
{
	my $self = shift;

 if (-e "$self->{'config_hash'}->{'tomcat_conf_dir'}/$_[0]")
 {
  `rm -rf $self->{'config_hash'}->{'tomcat_conf_dir'}/$_[0]`;
 }
}

#get hosts configuration
sub get_index_conf
{
	my $self = shift;

 my ($port,$hosts)=$self->read_conf_host();
 my (@paths,@links,@icons);
 foreach (@{$hosts})
 {
  $self->{'name'}=@{$_}[1]->{'name'};
  $self->{'base'}=@{$_}[1]->{'appBase'};
  push (@paths,$self->{'name'});
  push (@links,"virt.cgi?name=$self->{'name'}");
  push(@icons, "images/virt.gif");
  }
 return ($port,$hosts,\@paths,\@links,\@icons);
}

#get host $_[0] configuration
sub get_virt_conf
{
	my $self = shift;

 my ($port,$hosts)=$self->read_conf_host();
 my ($name,$base,$alias,@paths,@links,@icons);
 foreach (@{$hosts})
 {
  if (@{$_}[1]->{'name'} eq $_[0])
  {
   $name=@{$_}[1]->{'name'};
   $base=@{$_}[1]->{'appBase'};
   foreach $i (@{$_})
   {
    if (ref ($i) eq "ARRAY")
    {
     if (@{$i}[0] eq 'Alias')
     {
      $alias=@{$i}[2];
     }
     if (@{$i}[0] eq 'Context')
     {
      push (@paths,@{$i}[1]->{'docBase'});
      push (@links,"dir.cgi?name=$name&path=@{$i}[1]->{'path'}");
      push(@icons, "images/dir.gif");
     }
    }
   }
  }
 }
 return ($port,$hosts,$name,$base,$alias,\@paths,\@links,\@icons);
}

#get directory $_[1] configuration for server $_[0]
sub get_dir_conf
{
	my $self = shift;

 ($self->{'port'},$self->{'hosts'})=$self->read_conf_host();
 my ($name,$dir,$path,$reload,$debug);
 foreach (@{$self->{'hosts'}})
 {
  if (@{$_}[1]->{'name'} eq $_[0])
  {
   $name=@{$_}[1]->{'name'};
   foreach $i (@{$_})
   {
    if (ref ($i) eq "ARRAY")
    {
     if (@{$i}[0] eq 'Context')
     {
      if (@{$i}[1]->{'path'} eq $_[1])
      {
       $dir=@{$i}[1]->{'docBase'};
       $path=@{$i}[1]->{'path'};
       $reload=@{$i}[1]->{'reloadable'};
       $debug=@{$i}[1]->{'debug'};
      }
     }
    }
   }
  }
 }
 return ($name,$dir,$path,$reload,$debug);
}

#parse server.xml
sub read_conf_host
{
	my $self = shift;

 $self->error($self->text('jabber_eparser', "<tt>XML::Parser</tt>")) unless $self->{'got_xml_parser'};

 $self->{'level'}=0;
 my $parser=new XML::Parser(Handlers =>
 					{
					 Start=>\&handle_start,
					 End=>\&handle_end,
					 Char=>\&handle_char
 					});
 eval {$parser->parsefile($self->{'config_hash'}->{tomcat_conf})};
 return $@ if ($@);
 return ($self->{'expat'}->{'port'},$self->{'expat'}->{'hosts'});
}

sub handle_start
{
	my $self = shift;

 my (undef,$name,%attr)=@_;
 $self->{'expat'}->{'elem'}=[$name,\%attr] if ($self->{'expat'}->{'level'}==1);
 if ($name eq 'Host')
 {
  $self->{'expat'}->{'host'}=[$name,\%attr];
  $self->{'expat'}->{'level'}=1;
 }
 $self->{'expat'}->{'port'}=$attr{'port'} if ($name eq 'Connector' && !$attr{'protocol'});
}

sub handle_char
{
	my $self = shift;

 if ($self->{'expat'}->{'level'}==1)
 {
  $self->{'text'}=$_[1];
  push (@{$self->{'expat'}->{'elem'}},$self->{'text'});
 }
}

sub handle_end
{
	my $self = shift;

 my (undef,$name)=@_;
 if ($name eq 'Host')
 {
  push (@{$self->{'expat'}->{'hosts'}},$self->{'expat'}->{'host'});
  $self->{'expat'}->{'level'}=0;
 }
 else
 {
  push (@{$self->{'expat'}->{'host'}},$self->{'expat'}->{'elem'});
  $self->{'expat'}->{'elem'}=();
 }
}

#add new host $_[0] into server.xml
sub add_new_host
{
	my $self = shift;

 $self->error($self->text('jakarta_eparser', "<tt>XML::Parser</tt>"))  unless $self->{'got_xml_parser'};
 my $file=$self->tempname();
 open (OUT,">$file");
 my $parser=new XML::Parser(Handlers =>
 					{
					 Start=>\&add_host_start,
					 End=>\&add_host_end,
					 Char=>\&add_host_char,
					 Comment=>\&add_host_comment
 					});
 ($self->{'expat'}->{'name'},$self->{'expat'}->{'alias'},$self->{'expat'}->{'dir'})=@_;
 eval {
       $parser->parsefile($self->{'config_hash'}->{tomcat_conf});
       close (OUT);
       `mv -f $file $self->{'config_hash'}->{tomcat_conf}`;
      };
 return $@ if ($@);
}

sub add_host_start
{
	my $self = shift;

 my (undef,$name,%attr)=@_;
 print OUT ("<$name");
 while (my ($key,$value)=each(%attr))
 {
  print OUT (" $key=\"$value\"");
 }
 print OUT (">");
 if ($name eq 'Engine')
 {
  print OUT ("<Host name=\"$self->{'expat'}->{'name'}\" appBase=\"$self->{'expat'}->{'dir'}\" xmlValidation=\"false\" unpackWARs=\"true\" xmlNamespaceAware=\"false\" autoDeploy=\"true\"  debug=\"0\">\n");
  print OUT ("<Alias>$self->{'expat'}->{'alias'}</Alias>\n");
  print OUT ("<Logger suffix=\".txt\" timestamp=\"true\" className=\"org.apache.catalina.logger.FileLogger\" prefix=\"$self->{'expat'}->{'name'}\.\" directory=\"logs\">\n</Logger>\n</Host>");
 }
}

sub add_host_char
{
	my $self = shift;

 my (undef,$text)=@_;
 print OUT ("$text");
}

sub add_host_comment
{
	my $self = shift;

 my (undef,$data)=@_;
 print OUT ("<!--$data-->");
}

sub add_host_end
{
	my $self = shift;

 my (undef,$name)=@_;
 print OUT ("</$name>");
}

#save host $_[0] configuration into server.xml
sub save_conf_virt
{
	my $self = shift;

 $self->error($self->text('jabber_eparser', "<tt>XML::Parser</tt>"))  unless $self->{'got_xml_parser'};
 my $file=$self->tempname();
 open (OUT,">$file");
 my $parser=new XML::Parser(Handlers =>
 					{
					 Start=>\&write_virt_start,
					 End=>\&write_virt_end,
					 Char=>\&write_virt_char,
					 Comment=>\&write_virt_comment
 					});
 ($self->{'expat'}->{'name'},$self->{'expat'}->{'newname'},$self->{'expat'}->{'port'},$self->{'expat'}->{'alias'}, $self->{'expat'}->{'base'})=@_;
 eval {
       $parser->parsefile($self->{'config_hash'}->{tomcat_conf});
       close (OUT);
       `mv -f $file $self->{'config_hash'}->{tomcat_conf}`;
      };
 return $@ if ($@);
}

sub write_virt_start
{
	my $self = shift;

 my (undef,$name,%attr)=@_;
 $attr{'port'}=$self->{'expat'}->{'port'} if ($name eq 'Connector' && !$attr{'protocol'});
 if ($name eq 'Host' && $attr{'name'} eq $self->{'expat'}->{'name'})
 {
  $attr{'name'}=$self->{'expat'}->{'newname'};
  $attr{'appBase'}=$self->{'expat'}->{'base'};
  $self->{'expat'}->{'virt'}=1;
 }
 $self->{'expat'}->{'als'}=1 if ($name eq 'Alias');
 print OUT ("<$name");
 while (my ($key,$value)=each(%attr))
 {
  print OUT (" $key=\"$value\"");
 }
 print OUT (">");
}

sub write_virt_char
{
	my $self = shift;

 my (undef,$text)=@_;
 $text=$self->{'expat'}->{'alias'} if ($self->{'expat'}->{'virt'}==1 && $self->{'expat'}->{'als'}==1);
 print OUT ("$text");
}

sub write_virt_comment
{
	my $self = shift;

 my (undef,$data)=@_;
 print OUT ("<!--$data-->");
}

sub write_virt_end
{
	my $self = shift;

 my (undef,$name)=@_;
 $self->{'expat'}->{'virt'}=0 if ($name eq 'Host');
 $self->{'expat'}->{'als'}=0 if ($name eq 'Alias');
 print OUT ("</$name>");
}

#delete host $_[0] configuration into server.xml
sub del_virt
{
	my $self = shift;

 $self->error($self->text('jabber_eparser', "<tt>XML::Parser</tt>"))  unless $self->{'got_xml_parser'};
 my $file=$self->tempname();
 open (OUT,">$file");
 my $parser=new XML::Parser(Handlers =>
 					{
					 Start=>\&del_virt_start,
					 End=>\&del_virt_end,
					 Char=>\&del_virt_char,
					 Comment=>\&del_virt_comment
 					});
 $self->{'expat'}->{'name'}=$_[0];
 eval {
       $parser->parsefile($self->{'config_hash'}->{tomcat_conf});
       close (OUT);
       `mv -f $file $self->{'config_hash'}->{tomcat_conf}`;
      };
 return $@ if ($@);
}

sub del_virt_start
{
	my $self = shift;

 my (undef,$name,%attr)=@_;
 unless ($name eq 'Host' && $attr{'name'} eq $self->{'expat'}->{'name'})
 {
  unless ($self->{'expat'}->{'del'}==1)
  {
   print OUT ("<$name");
   while (my ($key,$value)=each(%attr))
   {
    print OUT (" $key=\"$value\"");
   }
   print OUT (">");
  }
 }
 else {$self->{'expat'}->{'del'}=1;}
}

sub del_virt_char
{
	my $self = shift;

 my (undef,$text)=@_;
 print OUT ("$text") unless ($self->{'expat'}->{'del'}==1);
}

sub del_virt_comment
{
	my $self = shift;

 my (undef,$data)=@_;
 print OUT ("<!--$data-->") unless ($self->{'expat'}->{'del'}==1);
}

sub del_virt_end
{
	my $self = shift;

 my (undef,$name)=@_;
 print OUT ("</$name>") unless ($self->{'expat'}->{'del'}==1);
 $self->{'expat'}->{'del'}=0 if ($name eq 'Host');
}

#save context configuration into server.xml for host $_[0]
sub add_new_dir
{
	my $self = shift;

 $self->error($self->text('jabber_eparser', "<tt>XML::Parser</tt>"))  unless $self->{'got_xml_parser'};
 my $file=$self->tempname();
 open (OUT,">$file");
 my $parser=new XML::Parser(Handlers =>
 					{
					 Start=>\&add_dir_start,
					 End=>\&add_dir_end,
					 Char=>\&add_dir_char,
					 Comment=>\&add_dir_comment
 					});
 ($self->{'expat'}->{'name'},$self->{'expat'}->{'dir'},$self->{'expat'}->{'url'},$self->{'expat'}->{'reload'}, $self->{'expat'}->{'debug'})=@_;
 eval {
       $parser->parsefile($self->{'config_hash'}->{tomcat_conf});
       close (OUT);
       `mv -f $file $self->{'config_hash'}->{tomcat_conf}`;
      };
 return $@ if ($@);
}

sub add_dir_start
{
	my $self = shift;

 my (undef,$name,%attr)=@_;
 print OUT ("<$name");
 while (my ($key,$value)=each(%attr))
 {
  print OUT (" $key=\"$value\"");
 }
 print OUT (">");
 if ($name eq 'Host' && $attr{'name'} eq $self->{'expat'}->{'name'})
 {
  my $r;
  if ($self->{'expat'}->{'reload'} eq 'on') {$r='true';}
  else {$r='false';}
  print OUT ("<Context path=\"$self->{'expat'}->{'url'}\" docBase=\"$self->{'expat'}->{'dir'}\" reloadable=\"$r\" debug=\"$self->{'expat'}->{'debug'}\"></Context>");
 }
}

sub add_dir_char
{
	my $self = shift;

 my (undef,$text)=@_;
 print OUT ("$text");
}

sub add_dir_comment
{
	my $self = shift;

 my (undef,$data)=@_;
 print OUT ("<!--$data-->");
}

sub add_dir_end
{
	my $self = shift;

 my (undef,$name)=@_;
 print OUT ("</$name>");
}

#save context configuration into server.xml for host $_[0]
sub save_conf_dir
{
	my $self = shift;

 $self->error($self->text('jabber_eparser', "<tt>XML::Parser</tt>"))  unless $self->{'got_xml_parser'};
 my $file=$self->tempname();
 open (OUT,">$file");
 my $parser=new XML::Parser(Handlers =>
 					{
					 Start=>\&write_start,
					 End=>\&write_end,
					 Char=>\&write_char,
					 Comment=>\&write_comment
 					});
 ($self->{'expat'}->{'name'},$self->{'expat'}->{'path'},$self->{'expat'}->{'dir'},$self->{'expat'}->{'url'},$self->{'expat'}->{'reload'}, $self->{'expat'}->{'debug'})=@_;
 eval {
       $parser->parsefile($self->{'config_hash'}->{tomcat_conf});
       close (OUT);
       `mv -f $file $self->{'config_hash'}->{tomcat_conf}`;
      };
 return $@ if ($@);
}

sub write_start
{
	my $self = shift;

 my (undef,$name,%attr)=@_;
 $self->{'expat'}->{'virt'}=1 if ($name eq 'Host' && $attr{'name'} eq $self->{'expat'}->{'name'});
 if ($self->{'expat'}->{'virt'}==1 && $name eq 'Context' && $attr{'path'} eq $self->{'expat'}->{'path'})
 {
  $attr{'path'}=$self->{'expat'}->{'url'};
  $attr{'docBase'}=$self->{'expat'}->{'dir'};
  if ($self->{'expat'}->{'reload'} eq 'on') {$attr{'reloadable'}='true';}
  else {$attr{'reloadable'}='false';}
  $attr{'debug'}=$self->{'expat'}->{'debug'};
 }
 print OUT ("<$name");
 while (my ($key,$value)=each(%attr))
 {
  print OUT (" $key=\"$value\"");
 }
 print OUT (">");
}

sub write_char
{
	my $self = shift;

 my (undef,$text)=@_;
 print OUT ("$text");
}

sub write_comment
{
	my $self = shift;

 my (undef,$data)=@_;
 print OUT ("<!--$data-->");
}

sub write_end
{
	my $self = shift;

 my (undef,$name)=@_;
 $self->{'expat'}->{'virt'}=0 if ($name eq 'Host');
 print OUT ("</$name>");
}

#delete context configuration into server.xml for host $_[0]
sub del_dir
{
	my $self = shift;

 $self->error($self->text('jabber_eparser', "<tt>XML::Parser</tt>"))  unless $self->{'got_xml_parser'};
 my $file=$self->tempname();
 open (OUT,">$file");
 my $parser=new XML::Parser(Handlers =>
 					{
					 Start=>\&del_dir_start,
					 End=>\&del_dir_end,
					 Char=>\&del_dir_char,
					 Comment=>\&del_dir_comment
 					});
 ($self->{'expat'}->{'name'},$self->{'expat'}->{'path'})=@_;
 eval {
       $parser->parsefile($self->{'config_hash'}->{tomcat_conf});
       close (OUT);
       `mv -f $file $self->{'config_hash'}->{tomcat_conf}`;
      };
 return $@ if ($@);
}

sub del_dir_start
{
	my $self = shift;

 my (undef,$name,%attr)=@_;
 $self->{'expat'}->{'virt'}=1 if ($name eq 'Host' && $attr{'name'} eq $self->{'expat'}->{'name'});
 unless ($self->{'expat'}->{'virt'}==1 && $name eq 'Context' && $attr{'path'} eq $self->{'expat'}->{'path'})
 {
  print OUT ("<$name");
  while (my ($key,$value)=each(%attr))
  {
   print OUT (" $key=\"$value\"");
  }
  print OUT (">");
 }
 else {$self->{'expat'}->{'del'}=1;}
}

sub del_dir_char
{
	my $self = shift;

 my (undef,$text)=@_;
 print OUT ("$text") unless ($self->{'expat'}->{'del'}==1);
}

sub del_dir_comment
{
	my $self = shift;

 my (undef,$data)=@_;
 print OUT ("<!--$data-->") unless ($self->{'expat'}->{'del'}==1);
}

sub del_dir_end
{
	my $self = shift;

 my (undef,$name)=@_;
 print OUT ("</$name>") unless ($self->{'expat'}->{'del'}==1);
 $self->{'expat'}->{'del'}=0 if ($name eq 'Context');
 $self->{'expat'}->{'virt'}=0 if ($name eq 'Host');
}


1;

