#!/usr/bin/perl
package krb5::Krb5Lib;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'krb5::Krb5Lib');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# krb5-lib.pl
# Common functions for the krb5 config

&ModuleLoader::preload_module(ref($self), "WebLib");
$self = new WebLib:: ref($self), %$self; 
$self->init_config();
&ModuleLoader::preload_module(ref($self), "UiLib");
$self = new UiLib:: ref($self), %$self; 

1;
1;
		return $self;
}

# get_config()
# Returns the krb5 config
sub get_config {
	my $self = shift;

    local (%conf, $section, $realm);
    $section = $realm = "";
    open(FILE, $self->{'config_hash'}->{'krb5_conf'});
    while(<FILE>) {
	chomp;
	s/#.*//;
	s/^\s+//;
	s/\s+$//;
	if (/^\[/) { # section name
	    $section = $_;
	    $section =~ s/^\[([^\]]*)\]/\1/;
        }
	s/^\[.*$//;
	next unless length;
	my ($var, $value) = split(/\s*=\s*/, $_, 2);
	if ($section eq "logging") {
	    if ($value =~ /^FILE:/) { $value =~ s/^FILE://; }
	    $var = $var . "_log";
	}
	if (($section eq "domain_realm") and ($value eq $realm)) {
	    $value = $var;
	    $var = "domain";
	}
	if ($section eq "realms") {
	    if ($value =~ /\{/ ) {
		$realm = $var;
		$value = $var;
		$var = "realm";
	    }
	    if ($var eq "admin_server") {
		my $port;
		($value, $port) = split(':', $value, 2);
		$conf{'admin_port'} = $port;
	    }
	    if ($var eq "kdc") {
		my $port;
		($value, $port) = split(':', $value, 2);
		$conf{'kdc_port'} = $port;
	    }
	}
	$conf{$var} = $value;
    }
    close(FILE);
    return %conf;
}


1;

