#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Show the LDAP server's data tree

&ModuleLoader::preload_module('ldap_client_class', "ldap_client::LdapclientLib");
$self = new ldap_client::LdapclientLib:: 'ldap_client_class',%$self;

$self->ui_print_header(undef, $self->{'text_hash'}->{'browser_title'}, "", "browser");
$self->ReadParse();

# Connect to LDAP server, or die trying
$self->{'ldap'} = $self->ldap_connect(1);
if (!ref($self->{'ldap'})) {
	print $self->text('browser_econn', $self->{'ldap'}),"<p>\n";
	$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
	exit;
	}

# Work out the base (current navigation level)
if ($self->{'in_hash'}->{'goparent'}) {
	$self->{'base'} = $self->{'in_hash'}->{'parent'};
	}
elsif (!$self->{'in_hash'}->{'base'}) {
	$self->{'conf'} = $self->get_config();
	$self->{'base'} = $self->find_value("base", $self->{'conf'});
	}
else {
	$self->{'base'} = $self->{'in_hash'}->{'base'};
	}

# Show current base (with option to change), and parent button
print $self->ui_form_start("browser.cgi"),"\n";
print "<b>$self->{'text_hash'}->{'browser_base'}</b>\n";
print $self->ui_textbox("base", $self->{'base'}, 60)," ",$self->ui_submit($self->{'text_hash'}->{'browser_ok'}),"\n";
$self->{'parent'} = $self->{'base'};
$self->{'parent'} =~ s/^[^,]+,\s*//;
if ($self->{'parent'} =~ /\S/) {
	print $self->ui_hidden("parent", $self->{'parent'}),"\n";
	print "&nbsp;&nbsp;\n";
	print $self->ui_submit($self->{'text_hash'}->{'browser_parent'}, "goparent"),"\n";
	}
print $self->ui_form_end();

# Show list of objects under the base, and its attributes
$self->{'rv'} = $self->{'ldap'}->search(base => $self->{'base'},
		    filter => '(objectClass=*)',
		    scope => 'one');
if ($self->{'rv'}->code) {
	# Search failed
	print $self->text('browser_esearch', $self->{'rv'}->error),"<p>\n";
	}
else {
	print "<table width=100%><tr>\n";
	print "<td width=50%><b>$self->{'text_hash'}->{'browser_subs'}</b></td>\n";
	print "<td width=50%><b>$self->{'text_hash'}->{'browser_attrs'}</b></td>\n";
	print "</tr> <tr><td width=50% valign=top>\n";

	# Show sub-objects
	foreach $dn (sort { lc($a->dn()) cmp lc($b->dn()) } $self->{'rv'}->all_entries) {
		print "<a href='browser.cgi?base=".$self->urlize($dn->dn())."'>".
		      $self->html_escape($dn->dn())."</a><br>\n";
		}
	if (!$self->{'rv'}->all_entries) {
		print "<i>$self->{'text_hash'}->{'browser_none'}</i><br>\n";
		}
	
	print "</td><td width=50% valign=top>\n";
	print "<table>\n";

	# Show attributes
	$self->{'rv2'} = $self->{'ldap'}->search(base => $self->{'base'},
			     filter => '(objectClass=*)',
			     score => 'base');
	($self->{'bo'}) = $self->{'rv2'}->all_entries;
	foreach $a (sort { lc($a) cmp lc($b) } $self->{'bo'}->attributes()) {
		@{$self->{'v_array'}} = $self->{'bo'}->get_value($a);
		print "<tr> <td>$a</td> <td>:</td> <td>",
		      join(" , ", @{$self->{'v_array'}}),"</td> </tr>\n";
		}
	if (!$self->{'bo'}->attributes()) {
		print "<tr> <td><i>$self->{'text_hash'}->{'browser_none'}</i></td> </tr>\n";
		}
	print "</table>\n";

	print "</td></tr></table>\n";
	}

$self->{'ldap'}->disconnect();
$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

