#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Check the user's LDAP settings

&ModuleLoader::preload_module('ldap_client_class', "ldap_client::LdapclientLib");
$self = new ldap_client::LdapclientLib:: 'ldap_client_class',%$self;

&ModuleLoader::preload_module('ldap_client_class', "ldap_client::SwitchLib");
$self = new ldap_client::SwitchLib:: 'ldap_client_class',%$self;

$self->ui_print_unbuffered_header(undef, $self->{'text_hash'}->{'check_title'}, "");

# Get the user base
print $self->{'text_hash'}->{'check_base'},"<br>\n";
$self->{'conf'} = $self->get_config();
$self->{'user_base'} = $self->find_svalue("nss_base_passwd", $self->{'conf'}) ||
	     $self->find_svalue("base", $self->{'conf'});
if (!$self->{'user_base'}) {
	print $self->text('check_ebase'),"<p>\n";
	goto END;
	}
else {
	print $self->text('check_based', "<tt>$self->{'user_base'}</tt>"),"<p>\n";
	}

# Attempt to connect to LDAP server
print $self->{'text_hash'}->{'check_connect'},"<br>\n";
$self->{'ldap'} = $self->ldap_connect(1, \$self->{'host'});
if (!ref($self->{'ldap'})) {
	print $self->text('check_econnect', $self->{'ldap'}),"<p>\n";
	goto END;
	}
else {
	print $self->text('check_connected', $self->{'host'}),"<p>\n";
	}

# Work out the scope
$self->{'scope'} = $self->find_svalue("scope", $self->{'conf'});
if ($self->{'user_base'} =~ s/\?([^\?]*)(\?([^\?]*))?$//) {
	$self->{'scope'} = $1;
	}
$self->{'scope'} ||= "one";

# Look for some users
print $self->{'text_hash'}->{'check_search'},"<br>\n";
$self->{'rv'} = $self->{'ldap'}->search(base => $self->{'user_base'},
		    filter => '(objectClass=posixAccount)',
		    scope => $self->{'scope'});
if ($self->{'rv'}->code) {
	# Search failed!
	print $self->text('check_esearch', $self->{'rv'}->error),"<p>\n";
	goto END;
	}
if (!$self->{'rv'}->count) {
	print $self->text('check_eusers', "<tt>$self->{'user_base'}</tt>"),"<p>\n";
	goto END;
	}
else {
	print $self->text('check_found', $self->{'rv'}->count),"<p>\n";
	}

# Check NSS configuration for users
print $self->{'text_hash'}->{'check_nss'},"<br>\n";
$self->{'nss'} = $self->get_nsswitch_config();
($self->{'passwd'}) = grep { $_->{'name'} eq 'passwd' } @{$self->{'nss'}};
($self->{'ldapsrc'}) = grep { $_->{'src'} eq 'ldap' } @{$self->{'passwd'}->{'srcs'}};
if (!$self->{'ldapsrc'}) {
	print $self->{'text_hash'}->{'check_enss'},"<p>\n";
	goto END;
	}
else {
	print $self->{'text_hash'}->{'check_nssok'},"<p>\n";
	}

# Make sure one of the users is a valid Unix user
$self->{'first'} = $self->{'rv'}->entry(0);
print $self->text('check_match', "<tt>".$self->{'first'}->get_value("uid")."</tt>"),"<br>\n";
@{$self->{'uinfo_array'}} = getpwnam($self->{'first'}->get_value("uid"));
if (!@{$self->{'uinfo_array'}}) {
	print $self->{'text_hash'}->{'check_ematch'},"<p>\n";
	goto END;
	}
else {
	print $self->{'text_hash'}->{'check_matched'},"<p>\n";

	print "<b>$self->{'text_hash'}->{'check_done'}</b><p>\n";
	}

END:
$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
1;
		
}


1;

