#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Show a form for editing the LDAP search bases for users, groups other objects

&ModuleLoader::preload_module('ldap_client_class', "ldap_client::LdapclientLib");
$self = new ldap_client::LdapclientLib:: 'ldap_client_class',%$self;

$self->ui_print_header(undef, $self->{'text_hash'}->{'base_title'}, "", "base");

$self->{'conf'} = $self->get_config();
print $self->ui_form_start("save_base.cgi", "post");
print $self->ui_table_start($self->{'text_hash'}->{'base_header'}, "width=100%", 2);

print $self->ui_table_row($self->{'text_hash'}->{'base_base'},
	$self->ui_textbox("base", $self->find_svalue("base", $self->{'conf'}), 50)."\n".
	$self->base_chooser_button("base", 0));

$self->{'scopes'} = [ [ "", $self->{'text_hash'}->{'default'} ],
	    [ "sub", $self->{'text_hash'}->{'base_ssub'} ],
	    [ "one", $self->{'text_hash'}->{'base_sone'} ],
	    [ "base", $self->{'text_hash'}->{'base_sbase'} ] ];
print $self->ui_table_row($self->{'text_hash'}->{'base_scope'},
	$self->ui_select("scope", $self->find_svalue("scope", $self->{'conf'}), $self->{'scopes'}));

print $self->ui_table_row($self->{'text_hash'}->{'base_timelimit'},
	$self->ui_opt_textbox("timelimit", $self->find_svalue("timelimit", $self->{'conf'}), 5,
		 	$self->{'text_hash'}->{'default'})." ".$self->{'text_hash'}->{'base_secs'});

$self->{'sp'} = "&nbsp;" x 5;
foreach $b (@{$self->{'base_types_array'}}) {
	local $base = $self->find_svalue("nss_base_".$b, $self->{'conf'});
	local ($scope, $filter);
	if ($base =~ /^(.*)\?(.*)\?(.*)$/) {
		$base = $1;
		$scope = $2;
		$filter = $3;
		}
	elsif ($base =~ /^(.*)\?(.*)$/) {
		$base = $1;
		$scope = $2;
		}
	print $self->ui_table_row($self->{'text_hash'}->{'base_'.$b},
		$self->ui_opt_textbox("base_$b", $base, 50, $self->{'text_hash'}->{'base_global'})." ".
		$self->base_chooser_button("base_$b", 0).
		"<br><table>\n".
		"<tr> <td>$self->{'sp'}</td> <td><b>$self->{'text_hash'}->{'base_bscope'}</b></td>\n".
		"<td>".$self->ui_select("scope_$b", $scope, $self->{'scopes'})."</td> </tr>\n".
		"<tr> <td>$self->{'sp'}</td> <td><b>$self->{'text_hash'}->{'base_bfilter'}</b></td>\n".
		"<td>".$self->ui_textbox("filter_$b", $filter, 50)."</td> </tr>\n".
		"</table>");
	}

print $self->ui_table_end();
print $self->ui_form_end([ [ "save", $self->{'text_hash'}->{'save'} ] ]);

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

