#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Show a form for editing the LDAP server to connect to

&ModuleLoader::preload_module('ldap_client_class', "ldap_client::LdapclientLib");
$self = new ldap_client::LdapclientLib:: 'ldap_client_class',%$self;

$self->ui_print_header(undef, $self->{'text_hash'}->{'server_title'}, "", "server");

$self->{'conf'} = $self->get_config();
print $self->ui_form_start("save_server.cgi", "post");
print $self->ui_table_start($self->{'text_hash'}->{'server_header'}, "width=100%", 2);

$self->{'uri'} = $self->find_svalue("uri", $self->{'conf'});
if ($self->{'uri'}) {
	# Show LDAP servers as URIs
	$self->{'utable'} = $self->ui_columns_start([
			$self->{'text_hash'}->{'server_uhost'},
			$self->{'text_hash'}->{'server_uport'},
			$self->{'text_hash'}->{'server_uproto'} ]);
	$self->{'i'} = 0;
	foreach $u (split(/\s+/, $self->{'uri'}), undef) {
		local ($proto, $host, $port);
		if ($u =~ /^(ldap|ldaps):\/\/([a-z0-9\_\-\.]+)(:(\d+))?/) {
			($proto, $host, $port) = ($1, $2, $4);
			}
		$self->{'utable'} .= $self->ui_columns_row([
		    $self->ui_textbox("uhost_$self->{'i'}", $host, 20),
		    $self->ui_opt_textbox("uport_$self->{'i'}", $port, 5, $self->{'text_hash'}->{'default'}),
		    $self->ui_select("uproto_$self->{'i'}", $proto,
			       [ [ 'ldap', $self->{'text_hash'}->{'server_ldap'} ],
				 [ 'ldaps', $self->{'text_hash'}->{'server_ldaps'} ] ]),
		    ]);
		$self->{'i'}++;
		}
	$self->{'utable'} .= $self->ui_columns_end();
	print $self->ui_table_row($self->{'text_hash'}->{'server_uri'}, $self->{'utable'});
	}
else {
	# Show LDAP servers from host and port
	print $self->ui_table_row($self->{'text_hash'}->{'server_host'},
		$self->ui_textarea("host", join("\n", split(/\s+/,
				  $self->find_svalue("host", $self->{'conf'}))), 3, 50));

	print $self->ui_table_row($self->{'text_hash'}->{'server_port'},
		$self->ui_opt_textbox("port", $self->find_svalue("port", $self->{'conf'}), 5,
				$self->{'text_hash'}->{'default'}));
	}

print $self->ui_table_row($self->{'text_hash'}->{'server_version'},
	$self->ui_radio("version", $self->find_svalue("ldap_version", $self->{'conf'}),
		  [ [ "", $self->{'text_hash'}->{'default'} ],
		    [ 1, "V1" ], [ 2, "V2" ], [ 3, "V3" ] ]));

print $self->ui_table_row($self->{'text_hash'}->{'server_timelimit'},
	$self->ui_opt_textbox("timelimit", $self->find_svalue("bind_timelimit", $self->{'conf'}), 5,
		 	$self->{'text_hash'}->{'default'})." ".$self->{'text_hash'}->{'base_secs'});

print $self->ui_table_row($self->{'text_hash'}->{'server_binddn'},
	$self->ui_opt_textbox("binddn", $self->find_svalue("binddn", $self->{'conf'}), 40,
			$self->{'text_hash'}->{'server_anon'}));

print $self->ui_table_row($self->{'text_hash'}->{'server_bindpw'},
	$self->ui_opt_textbox("bindpw", $self->find_svalue("bindpw", $self->{'conf'}), 20,
			$self->{'text_hash'}->{'server_none'}));

print $self->ui_table_row($self->{'text_hash'}->{'server_rootbinddn'},
	$self->ui_opt_textbox("rootbinddn", $self->find_svalue("rootbinddn", $self->{'conf'}), 40,
			$self->{'text_hash'}->{'server_same'}));

print $self->ui_table_row($self->{'text_hash'}->{'server_rootbindpw'},
	$self->ui_opt_textbox("rootbindpw", $self->get_rootbinddn_secret(), 20,
			$self->{'text_hash'}->{'server_none'}));

# SSL options
print $self->ui_table_hr();

if (!$self->{'uri'}) {
	print $self->ui_table_row($self->{'text_hash'}->{'server_ssl'},
		$self->ui_radio("ssl", $self->find_svalue("ssl", $self->{'conf'}),
			  [ [ "start_tls", $self->{'text_hash'}->{'yes'} ],
			    [ "", $self->{'text_hash'}->{'no'} ] ]));
	}

print $self->ui_table_row($self->{'text_hash'}->{'server_peer'},
	$self->ui_radio("peer", $self->find_svalue("tls_checkpeer", $self->{'conf'}),
		  [ [ "", $self->text('server_def', $self->{'text_hash'}->{'no'}) ],
		    [ "yes", $self->{'text_hash'}->{'yes'} ],
		    [ "no", $self->{'text_hash'}->{'no'} ] ]));

print $self->ui_table_row($self->{'text_hash'}->{'server_cacert'},
	$self->ui_opt_textbox("cacert", $self->find_svalue("tls_cacertfile", $self->{'conf'}),
			40, $self->{'text_hash'}->{'server_none'})." ".
	$self->file_chooser_button("cacert"));

print $self->ui_table_end();
print $self->ui_form_end([ [ "save", $self->{'text_hash'}->{'save'} ] ]);

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

