#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Show icons for various categories of options

&ModuleLoader::preload_module('ldap_client_class', "ldap_client::LdapclientLib");
$self = new ldap_client::LdapclientLib:: 'ldap_client_class',%$self;

$self->ui_print_header(undef, $self->{'module_info_hash'}->{'desc'}, "", "intro", 1, 1);

# Make sure the config file exists
if (!-r $self->{'config_hash'}->{'auth_ldap'}) {
	$self->ui_print_endpage(
		$self->ui_config_link('index_econf',
			[ "<tt>$self->{'config_hash'}->{'auth_ldap'}</tt>", undef ]));
	}

# Show icons for option categories
@{$self->{'pages_array'}} = ( "server", "base", "pam", "switch", "browser" );
@{$self->{'links_array'}} = map { $_ eq "browser" ? "browser.cgi" :
	       $_ eq "switch" ?  "list_switches.cgi" :
				 "edit_".$_.".cgi" } @{$self->{'pages_array'}};
@{$self->{'titles_array'}} = map { $self->{'text_hash'}->{$_."_title"} } @{$self->{'pages_array'}};
@{$self->{'icons_array'}} = map { "images/".$_.".gif" } @{$self->{'pages_array'}};
$self->icons_table(\@{$self->{'links_array'}}, \@{$self->{'titles_array'}}, \@{$self->{'icons_array'}}, 5);

# Validate button
print "<hr>\n";
print $self->ui_buttons_start();
print $self->ui_buttons_row("check.cgi", $self->{'text_hash'}->{'index_check'},
		      $self->{'text_hash'}->{'index_checkdesc'});
print $self->ui_buttons_end();

$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});

1;
		
}


1;

