#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Show the LDAP tree in a popup browser window, for selecting something

&ModuleLoader::preload_module('ldap_client_class', "ldap_client::LdapclientLib");
$self = new ldap_client::LdapclientLib:: 'ldap_client_class',%$self;

$self->popup_header($self->{'text_hash'}->{'browser_title'});
$self->ReadParse();

# Connect to LDAP server, or die trying
$self->{'ldap'} = $self->ldap_connect(1);
if (!ref($self->{'ldap'})) {
	print $self->text('browser_econn', $self->{'ldap'}),"<p>\n";
	$self->popup_footer();
	exit;
	}

# Work out the base (current navigation level)
if ($self->{'in_hash'}->{'parent'}) {
	$self->{'base'} = $self->{'in_hash'}->{'parent'};
	}
elsif (!$self->{'in_hash'}->{'base'}) {
	$self->{'conf'} = $self->get_config();
	$self->{'base'} = $self->find_value("base", $self->{'conf'});
	}
else {
	$self->{'base'} = $self->{'in_hash'}->{'base'};
	}

# Javascript to update original field
print "<script>\n";
print "function ldap_select(f)\n";
print "{\n";
print "top.opener.ifield.value = f;\n";
print "top.close();\n";
print "window.close();\n";
print "return false;\n";
print "}\n";
print "</script>\n";

# Find the actual base object
$self->{'rv2'} = $self->{'ldap'}->search(base => $self->{'base'},
		     filter => '(objectClass=*)',
		     score => 'base');
if (!$self->{'rv2'}->code) {
	($self->{'bo'}) = $self->{'rv2'}->all_entries;
	($self->{'top'}) = grep { $_ eq "top" } $self->{'bo'}->get_value("objectClass");
	}

# Show current base (with option to change), and parent button
print $self->ui_form_start("popup_browser.cgi"),"\n";
print $self->ui_hidden("node", $self->{'in_hash'}->{'node'}),"\n";
print "<b>$self->{'text_hash'}->{'browser_base'}</b>\n";
print $self->ui_textbox("base", $self->{'base'}, 40)," ",$self->ui_submit($self->{'text_hash'}->{'browser_ok'}),"\n";
$self->{'parent'} = $self->{'base'};
$self->{'parent'} =~ s/^[^,]+,\s*//;

# Show the OK button only if the object type is appropriatye
if ($self->{'in_hash'}->{'node'} == 0 && $self->{'top'} ||
    $self->{'in_hash'}->{'node'} == 1 && !$self->{'top'} ||
    $self->{'in_hash'}->{'node'} == 2) {
	print "<input type=button onClick='return ldap_select(\"$self->{'base'}\")' ",
	      "value='$self->{'text_hash'}->{'browser_sel'}'>\n";
	}
print $self->ui_form_end();

# Find sub-objects
$self->{'rv'} = $self->{'ldap'}->search(base => $self->{'base'},
		    filter => '(objectClass=*)',
		    scope => 'one');
if ($self->{'rv'}->code) {
	# Search failed
	print $self->text('browser_esearch', $self->{'rv'}->error),"<p>\n";
	$self->popup_footer();
	exit;
	}

print "<table width=100%>\n";
if ($self->{'parent'} =~ /\S/) {
	print "<tr> <td><i><a href='popup_browser.cgi?node=$self->{'in_hash'}->{'node'}&base=",
	      $self->urlize($self->{'parent'}),"'><img src=images/up.gif border=0> ",
	      $self->html_escape($self->{'parent'}),"</a></td> </tr>\n";
	}
if ($self->{'rv'}->all_entries) {
	# If this object has sub-objects, show them
	foreach $dn (sort { lc($a->dn()) cmp lc($b->dn()) } $self->{'rv'}->all_entries) {
		print "<tr> <td><a href='popup_browser.cgi?node=$self->{'in_hash'}->{'node'}&",
		      "base=".$self->urlize($dn->dn()).
		      "'><img src=images/open.gif border=0>",
		      " ",$self->html_escape($dn->dn()),"</a></td> </tr>\n";
		}
	}
else {
	# Show attributes
	foreach $a (sort { lc($a) cmp lc($b) } $self->{'bo'}->attributes()) {
		@{$self->{'v_array'}} = $self->{'bo'}->get_value($a);
		print "<tr> <td>$a</td> <td>:</td> <td>",
		      join(" , ", @{$self->{'v_array'}}),"</td> </tr>\n";
		}
	}
print "</table>\n";

$self->popup_footer();
1;
		
}


1;

