#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Save the LDAP search base

&ModuleLoader::preload_module('ldap_client_class', "ldap_client::LdapclientLib");
$self = new ldap_client::LdapclientLib:: 'ldap_client_class',%$self;

$self->error_setup($self->{'text_hash'}->{'base_err'});
$self->ReadParse();

$self->lock_file($self->{'config_hash'}->{'auth_ldap'});
$self->{'conf'} = $self->get_config();

# Validate and save inputs, starting with global base
$self->{'in_hash'}->{'base'} =~ /\S/ || $self->error($self->{'text_hash'}->{'base_ebase'});
$self->save_directive($self->{'conf'}, "base", $self->{'in_hash'}->{'base'});

# Save scope
$self->save_directive($self->{'conf'}, "scope", $self->{'in_hash'}->{'scope'} || undef);

# Save time limit
if ($self->{'in_hash'}->{'timelimit_def'}) {
	$self->save_directive($self->{'conf'}, "timelimit", undef);
	}
else {
	$self->{'in_hash'}->{'timelimit'} =~ /^\d+$/ || $self->error($self->{'text_hash'}->{'base_etimelimit'});
	$self->save_directive($self->{'conf'}, "timelimit", $self->{'in_hash'}->{'timelimit'});
	}

# Save per-service bases
foreach $b (@{$self->{'base_types_array'}}) {
	if ($self->{'in_hash'}->{"base_".$b."_def"}) {
		$self->save_directive($self->{'conf'}, "nss_base_".$b, undef);
		}
	else {
		local $base = $self->{'in_hash'}->{"base_".$b};
		$base =~ /\S/ || $self->error($self->{'text_hash'}->{'base_e'.$b});
		if ($self->{'in_hash'}->{'scope_'.$b}) {
			$base .= "?".$self->{'in_hash'}->{'scope_'.$b};
			}
		if ($self->{'in_hash'}->{'filter_'.$b}) {
			$base .= "?" if ($self->{'in_hash'}->{'scope_'.$b});
			$self->{'file'} .= "?".$self->{'in_hash'}->{'filter_'.$b};
			}
		$self->save_directive($self->{'conf'}, "nss_base_".$b, $base);
		}
	}

# Write out config
$self->flush_file_lines();
$self->unlock_file($self->{'config_hash'}->{'auth_ldap'});

$self->webmin_log("base");
$self->redirect("");

1;
		
}


1;

