#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Save the LDAP server to connect to

&ModuleLoader::preload_module('ldap_client_class', "ldap_client::LdapclientLib");
$self = new ldap_client::LdapclientLib:: 'ldap_client_class',%$self;

$self->error_setup($self->{'text_hash'}->{'server_err'});
$self->ReadParse();

$self->lock_file($self->{'config_hash'}->{'auth_ldap'});
$self->{'conf'} = $self->get_config();

# Validate and save inputs, starting with filter
if ($self->{'in_hash'}->{'filter_def'}) {
	$self->save_directive($self->{'conf'}, "pam_filter", undef);
	}
else {
	$self->{'in_hash'}->{'filter'} =~ /\S/ || $self->error($self->{'text_hash'}->{'pam_efilter'});
	$self->save_directive($self->{'conf'}, "pam_filter", $self->{'in_hash'}->{'filter'});
	}

# Save login attribute
if ($self->{'in_hash'}->{'login_def'}) {
	$self->save_directive($self->{'conf'}, "pam_login_attribute", undef);
	}
else {
	$self->{'in_hash'}->{'login'} =~ /^\S+$/ || $self->error($self->{'text_hash'}->{'pam_elogin'});
	$self->save_directive($self->{'conf'}, "pam_login_attribute", $self->{'in_hash'}->{'login'});
	}

# Save group DN
if ($self->{'in_hash'}->{'groupdn_def'}) {
	$self->save_directive($self->{'conf'}, "pam_groupdn", undef);
	}
else {
	$self->{'in_hash'}->{'groupdn'} =~ /\S/ || $self->error($self->{'text_hash'}->{'pam_egroupdn'});
	$self->save_directive($self->{'conf'}, "pam_groupdn", $self->{'in_hash'}->{'groupdn'});
	}

# Save group member attribute
if ($self->{'in_hash'}->{'member_def'}) {
	$self->save_directive($self->{'conf'}, "pam_member_attribute", undef);
	}
else {
	$self->{'in_hash'}->{'member'} =~ /^\S+$/ || $self->error($self->{'text_hash'}->{'pam_emember'});
	$self->save_directive($self->{'conf'}, "pam_member_attribute", $self->{'in_hash'}->{'member'});
	}

# Save password mode
$self->save_directive($self->{'conf'}, "pam_password", $self->{'in_hash'}->{'password'} || undef);

# Write out config
$self->flush_file_lines();
$self->unlock_file($self->{'config_hash'}->{'auth_ldap'});

$self->webmin_log("pam");
$self->redirect("");

1;
		
}


1;

