#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Update one LDAP switch

if (-r 'ldap-client-lib.pl') {
	&ModuleLoader::preload_module('ldap_client_class', "ldap_client::LdapclientLib");
$self = new ldap_client::LdapclientLib:: 'ldap_client_class',%$self;

	}
else {
	require './nis-lib.pl';
	}
&ModuleLoader::preload_module('ldap_client_class', "ldap_client::SwitchLib");
$self = new ldap_client::SwitchLib:: 'ldap_client_class',%$self;

$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'eswitch_err'});

# Get the current service
$self->lock_file($self->{'nsswitch_config_file'});
$self->{'conf'} = $self->get_nsswitch_config();
($self->{'switch'}) = grep { $_->{'name'} eq $self->{'in_hash'}->{'name'} } @{$self->{'conf'}};
$self->{'switch'} || $self->error($self->{'text_hash'}->{'eswitch_egone'});

# Validate and store inputs
@{$self->{'srcs_array'}} = ( );
for($i=0; defined($self->{'src'} = $self->{'in_hash'}->{"src_$i"}); $i++) {
	next if (!$self->{'src'});
	$self->{'s'} = { 'src' => $self->{'src'} };
	foreach $st ($self->list_switch_statuses()) {
		if ($self->{'in_hash'}->{"status_".$st."_".$i}) {
			$self->{'s'}->{$st} = $self->{'in_hash'}->{"status_".$st."_".$i};
			}
		}
	push(@{$self->{'srcs_array'}}, $self->{'s'});
	}
@{$self->{'srcs_array'}} || $self->error($self->{'text_hash'}->{'eswitch_enone'});
$self->{'switch'}->{'srcs'} = \@{$self->{'srcs_array'}};

# Save it
$self->save_nsswitch_config($self->{'switch'});
$self->unlock_file($self->{'nsswitch_config_file'});
$self->webmin_log("modify", "switch", $self->{'switch'}->{'name'});

$self->redirect("list_switches.cgi");

1;
		
}


1;

