#!/usr/bin/perl
package licmanage::LicmanageLib;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'licmanage::LicmanageLib');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
&ModuleLoader::preload_module(ref($self), "WebLib");
$self = new WebLib:: ref($self), %$self; 
$self->init_config();
&ModuleLoader::preload_module(ref($self), "UiLib");
$self = new UiLib:: ref($self), %$self; 
use Time::Local;

$self->{'module_config_page'} = "/config.cgi?$self->{'module_name'}";
# debug mode flag
$self->{'debug'} = 0;

$self->print_debug("content-type: text/html\n\n");

# Turns on showing log information
$self->{'lic_logging'} = 1;

# standard CP+ licensing
$self->{'lic_host'} = $self->{'config_hash'}->{'lichost'}; #'cpplus.info';
$self->{'lic_port'} = $self->{'config_hash'}->{'licport'}; #80;
$self->{'lic_page'} = $self->{'config_hash'}->{'licpage'}; #'/';

# enhanced CP+ licensing
$self->{'lic_host2'} = $self->{'config_hash'}->{'lichost2'}; #'secure.comodo.net';
$self->{'lic_port2'} = $self->{'config_hash'}->{'licport2'}; #443;
$self->{'lic_page2'} = $self->{'config_hash'}->{'licpage2'}; #'/products/download/CollectLicence';

$self->{'lic_directory'} = "$self->{'config_directory'}/$self->{'module_name'}/licenses";
$self->{'lic_collectionCode'} = '';

mkdir($self->{'lic_directory'}, 0700) unless -d $self->{'lic_directory'};

$self->{'productname'} = $self->{'gconfig_hash'}->{'product'} ? $self->{'gconfig_hash'}->{'product'} : $self->{'gconfig_hash'}->{'ztl_mode'} ? "ztl" : "cpplus";
if (!$self->{'gconfig_hash'}->{'ztl_mode'}) {
	$self->foreign_require("$self->{'productname'}", "$self->{'productname'}-lib.pl");
	$self->foreign_require("$self->{'productname'}", "gnupg-lib.pl");
}
$self->{'no_comodo_mode'}++ if !$self->{'config_hash'}->{'use_ctlicense'};

$self->{'perl_net_ssleay_module'} = 'Net::SSLeay';
$self->{'perl_net_ssleay_swup'} = 'perl-net-ssleay';
if (!$self->{'no_comodo_mode'}) {
	eval "use $self->{'perl_net_ssleay_module'};";
	$self->{'no_net_ssleay'}++ if $@;
}
else {
	$self->{'no_net_ssleay'}++;
}

# if (! $self->{'config_hash'}->{'comodo_mode'}) {
# 	$self->foreign_require("$self->{'productname'}", "$self->{'productname'}-lib.pl");
# 	$self->foreign_require("$self->{'productname'}", "gnupg-lib.pl");
# 	$self->{'no_comodo_mode'}++;
# }

# Defines URL for getting a product license
# $self->{'lic_order_url'} = $self->{'productname'} eq 'ztl' ? "http://ztl.psoft.net/order.html" : "http://cpplus.info/order.html";
$self->{'lic_order_url'} = $self->{'gconfig_hash'}->{'ztl_mode'} ? "http://ztl.psoft.net/order.html" : "http://cpplus.psoft.net/pricing.html";

if ($< == 0) {
	 @{$self->{'user_info_array'}} = getpwuid(0);
	#@remote_user_info || $self->error(&text('switch_remote_euser', $remote_user));
	@{$self->{'user_info_array'}} || $self->error($self->{'text_hash'}->{'index_euserinfo'});
	$self->{'gnupg_directory'} = $self->{'user_info_array'}->[7] . "/.gnupg";
	mkdir ($self->{'gnupg_directory'}, 0700) if ! -d $self->{'gnupg_directory'};
}

# ============================================================================================
# service functions
# ============================================================================================

1;
1;
		return $self;
}

# read_entire_file(file)
# Reads entire file and returns read datas
sub read_entire_file {
	my $self = shift;

	local ($rv, $buf);
	open(FILE, $_[0]) || return undef;
	while(read(FILE, $buf, 1024) > 0) {
		$rv .= $buf;
		}
	close(FILE);
	return $rv;
}

# write_entire_file(file, data)
# Writes data to file
sub write_entire_file {
	my $self = shift;

	$self->open_tempfile(FILE, ">$_[0]");
	$self->print_tempfile(FILE, $_[1]);
	$self->close_tempfile(FILE);
}

sub verify_data {
	my $self = shift;

	$main::cpplus_object->verify_data(@_);
}

sub list_keys {
	my $self = shift;

	$main::cpplus_object->list_keys(@_);
}

sub key_fingerprint {
	my $self = shift;

	$main::cpplus_object->key_fingerprint(@_);
}

# get_licinfo([license file])
# Return a hash what contains a license information
# Key 'ret':
#  0 - ok
#  1 - License is not valid or expired
#  2 - License is not valid
#  3 - Failed to find a License file
sub get_licinfo 
{
	my $self = shift;

 if ($self->{'config_hash'}->{'license_key'}) {
	# Master Key license
	MKEY:
	if (!$self->{'config_hash'}->{'lic_time_check'}) {
		# license time check
		$self->{'config_hash'}->{'lic_time_check'} =  time ();
		$self->{'config_hash'}->{'lic_begin'} = $self->{'config_hash'}->{'lic_time_check'};
		$self->{'config_hash'}->{'lic_expire'} = $self->{'config_hash'}->{'lic_time_check'} + $self->{'tconfig_hash'}->{'billing_expire_limit'};
		$self->save_module_config();
		}
    
	if ((time() - $self->{'config_hash'}->{'lic_time_check'}) > $self->{'tconfig_hash'}->{'billing_check_period'} || $self->{'config_hash'}->{'error_check_lic'}) {
		# check license
		local $version = $self->get_webmin_version();
		local $file = $self->tempname();
		local $vps = $self->check_freevps_server();
		local $param = "software=CP%2B&version=$version&vps=$vps&key=$self->{'config_hash'}->{'license_key'}";
		eval "use Net::SSLeay";
		if ($@) {
			# http download
			$self->http_download($self->{'tconfig_hash'}->{'billing_host'}, 80, "$self->{'tconfig_hash'}->{'billing_check_file'}?$param", $file, \$self->{'error'}, undef, undef, undef, undef, 20, undef, 1);
			} 
		else {
			# https download
			$self->http_download($self->{'tconfig_hash'}->{'billing_host'}, 443, "$self->{'tconfig_hash'}->{'billing_check_file'}?$param", $file, \$self->{'error'}, undef, 1, undef, undef, 20, undef, 1);
			}
		$self->{'config_hash'}->{'error_check_lic'} = 1;
		$self->{'config_hash'}->{'lic_error_desc'} = undef;
		if (!-e $file || -z $file){
			# no answer from server
			$self->{'config_hash'}->{'lic_error_desc'} = $self->text('err_request', $self->{'tconfig_hash'}->{'billing_host'});
			$self->{'config_hash'}->{'try_counter'}++;
			$self->{'config_hash'}->{'error_check_lic'} = 0 if ($self->{'config_hash'}->{'try_counter'} < 3);
			}
		else {
			# check answer
			open(FILE, $file);
			while(<FILE>) {
				$self->{'config_hash'}->{'error_check_lic'} = 0 if (/\s*1\s*/);
				$self->{'config_hash'}->{'lic_error_desc'} = $1 if ($self->{'config_hash'}->{'error_check_lic'} && /^\d*(.+)$/);
				$self->{'config_hash'}->{'try_counter'} = 0;
				}
			close(FILE);
			unlink($file);
			}
			$self->{'config_hash'}->{'lic_time_check'} = time();
			$self->save_module_config();
			return { 'ret' => '-1' } if ($self->{'config_hash'}->{'error_check_lic'});	
		}
		$self->{'expire'} = time() + $self->{'tconfig_hash'}->{'billing_check_period'} * (3 - $self->{'config_hash'}->{'try_counter'});
		$self->{'expire'} = $self->get_date_as_string($self->{'expire'});
		$self->{'begin'} = $self->get_date_as_string(time());
		return {
					'ret' => '0',
					'type' => 'key',
					'd_begin' => $self->{'begin'},
					'd_begin2' => $self->get_date_string($self->{'begin'}),
					'd_expire' => $self->{'expire'},
					'd_expire2' => $self->get_date_string($self->{'expire'}),	
					'err' => $self->{'config_hash'}->{'lic_error_desc'}
		} if (! $self->{'config_hash'}->{'error_check_lic'});
	}

 if ($self->{'tconfig_hash'}->{'type_lic'} == 5) {
	# VPSLAND license
	if ($self->{'tconfig_hash'}->{'reseller_license_key'}){
		# move to Master Key license
		$self->{'config_hash'}->{'license_key'} = $self->{'tconfig_hash'}->{'reseller_license_key'};
		$self->save_module_config();
		goto MKEY;
		}

	if (!$self->{'config_hash'}->{'lic_time_check'}) {
		# license time check
		$self->{'config_hash'}->{'lic_time_check'} =  time ();
		$self->{'config_hash'}->{'lic_begin'} = $self->{'config_hash'}->{'lic_time_check'};
		$self->{'config_hash'}->{'lic_expire'} = $self->{'config_hash'}->{'lic_time_check'} + $self->{'tconfig_hash'}->{'expire_limit'};
		$self->save_module_config();
		}

	if ((time() - $self->{'config_hash'}->{'lic_time_check'}) > $self->{'tconfig_hash'}->{'check_period'} || $self->{'config_hash'}->{'error_check_lic'}) {
		# check license
		local $internal_ip = $self->get_host_id();
		local $brand = uc $self->{'tconfig_hash'}->{'brand'};
		local $version = $self->get_webmin_version();
		local $file = $self->tempname();
		local $param = "internal_ip=$internal_ip&brand=$brand&version=$version&begin=$self->{'config_hash'}->{'lic_begin'}&expire=$self->{'config_hash'}->{'lic_expire'}";
		# http download
		$self->http_download($self->{'tconfig_hash'}->{'check_host'}, $self->{'tconfig_hash'}->{'check_port'}, "$self->{'tconfig_hash'}->{'check_file'}?$param", $file, \$self->{'error'}, undef, undef, undef, undef, 20, undef, 1);
		
		local $self->{'config_hash'}->{'error_check_lic'} = 1;
		if (!-e $file || -z $file){
			# no answer from server
			$self->{'config_hash'}->{'try_counter'}++;
			$self->{'config_hash'}->{'error_check_lic'} = 0 if ($self->{'config_hash'}->{'try_counter'} < 3);
		 	}
		else {
			# check answer
			open(FILE, $file);
			while(<FILE>)  {
				$self->{'config_hash'}->{'error_check_lic'} = 0 if (/CHECK:OK/);
				$self->{'config_hash'}->{'lic_begin'} = $1 if (/BEGIN:(\d+)/);
				$self->{'config_hash'}->{'lic_expire'} = $1 if (/EXPIRE:(\d+)/);
				}
			close(FILE);
			unlink($file);
			}
		$self->{'config_hash'}->{'lic_time_check'} = time();
		$self->save_module_config();
		}
		$self->{'begin'} = $self->get_date_as_string($self->{'config_hash'}->{'lic_begin'});
		$self->{'expire'} = time() + $self->{'tconfig_hash'}->{'billing_check_period'} * (3 - $self->{'config_hash'}->{'try_counter'});
		$self->{'expire'} = $self->get_date_as_string($self->{'expire'});
		return {
					'ret' => '0',
					'type' => 'key',
					'd_begin' => $self->{'config_hash'}->{'lic_begin'},
					'd_begin2' => $self->get_date_string($self->{'begin'}),
					'd_expire' => $self->{'config_hash'}->{'lic_expire'},
					'd_expire2' => $self->get_date_string($self->{'expire'})
		} if (!$self->{'config_hash'}->{'error_check_lic'});
	}
	
	$self->{'fingerprint'} = '70:17:83:C3:60:5E:2F:CD:D4:9A:43:C2:EB:B3:E6:CC';
	
	local $lfile = $_[0] ? $_[0] : "$self->{'lic_directory'}/$self->{'config_hash'}->{'licfile'}";
	-f $lfile || return { 'ret' => '3', 'msg' => $self->{'text_hash'}->{'err_notfound'} };
	local $rv = $self->{'gconfig_hash'}->{'ztl_mode'} ? {'ret' => 4, 'msg' => 'No license'} : $self->check_license_file($lfile);
	return $rv if $self->{'no_comodo_mode'} || $rv->{'ret'} == 0;
	local $err = 0;

	#check chain
	local $chain_file = "$lfile.chain";
	local $lic_file = "$lfile.lic";
	if (! -f $chain_file) {
	    open (FULL_LIC, "$lfile");
	    open (CHAIN, ">$chain_file");
	    open (LIC, ">$lic_file");
	    while (<FULL_LIC>) {
		$self->{'num'}++ if ( $_ =~ m/^-----BEGIN\s+CERTIFICATE-----$/ );
		if ($self->{'num'}<3) { # two first certificate
    		    print CHAIN $_;
		    } else {
			    print LIC $_;
			    }
	    }
	    close (FULL_LIC);
	    close (CHAIN);
	    close (LIC);
	    }
	
	$out = `openssl verify -CAfile $chain_file $lic_file`;
	$self->print_debug($out);
	($out =~ m/$lic_file\:\s+OK/) || return {'ret' => '1', 'msg' => $self->{'text_hash'}->{'err_notvalid'}, 'sysret' => $?, 'output' => $out};
	
	$out = `openssl x509 -in $chain_file -noout -fingerprint`;
	$self->print_debug($out);
	$out =~ s/MD5\s+Fingerprint\=//;
	($out =~ m/$self->{'fingerprint'}/) || return {'ret' => '1', 'msg' => $self->{'text_hash'}->{'err_notvalid'}, 'sysret' => $?, 'output' => $out};

	

	$out = `openssl x509 -in $lic_file -text -noout`;
	$self->print_debug($out);
	foreach my $l (split("\n", $out)) {
		$self->{'before'} = $self->get_full_date($1) if ($l =~ m/NotBefore\>(.+)\<\/NotBefore/i);
		$self->{'after'} = $self->get_full_date($1) if ($l =~ m/NotAfter\>(.+)\<\/NotAfter/i);
		$self->{'descr'} = $1 if $l =~ m/Description\>(.+)\<\/Description/i;
	}
	
	$out = `openssl x509 -in $lic_file -startdate -noout`;
	$self->print_debug($out);
	$self->{'begin'} = $1 if $out =~ m/^notBefore\=(.+)$/;
	
	$out = `openssl x509 -in $lic_file -enddate -noout`;
	$self->print_debug($out);
	$self->{'expire'} = $1 if $out =~ m/^notAfter\=(.+)$/;

	$self->print_debug("BEGIN: $self->{'begin'}   EXPIRE: $self->{'expire'}");
	return { 
		'ret' => '0', 
		'descr' => $self->{'descr'},
		'd_begin' => $self->{'begin'},
		'd_begin2' => $self->get_date_string($self->{'begin'}),
		'd_expire' => $self->{'expire'},
		'd_expire2' => $self->get_date_string($self->{'expire'})
	} if $self->{'begin'} && $self->{'expire'};
	return { 'ret' => '2', 'msg' => $self->{'text_hash'}->{'err_parseoutput'}, 'sysret' => $?, 'output' => $out }
}

# return date as string July 21 05:55:00 1976
# &get_date_as_string(time());
sub get_date_as_string {
	my $self = shift;

    local $date = $_[0];
    my @tm = gmtime($date);
    $tm[4]++;
    my $name_month = "smonth_$tm[4]";
    my $year = $tm[5]+1900;
    return "$self->{'text_hash'}->{$name_month} $tm[3] $tm[2]:$tm[1]:$tm[0] $year";
}

# returns date in form: month_name day year
# &get_date_short($date);
# $date = 'Sat Sep 3 00:00:00 2005';
sub get_date_short {
	my $self = shift;

	local ($date, $rv) = ($_[0]);
	$self->{'str'} = sprintf("%3s %02d %04d", $2, $3, $5) if $date =~ /^\s*(\S+)\s+(\S+)\s+(\S+)\s+(\S+)\s+(\S+)$/;
	return $self->{'str'};
}

# returns date in form: month_name day year
# &get_date_string($date);
# $date = 'May 29 00:00:00 2006';
sub get_date_string {
	my $self = shift;

	local ($date ) = ($_[0]);
	$self->{'str'} = sprintf("%3s %02d %04d", $1, $2, $4) if $date =~ /^\s*(\S+)\s+(\S+)\s+(\S+)\s+(\S+)/;
	return $self->{'str'};
}

# returns date in form: month_name day year
# &get_date_short($date);
# $date = '2007-05-29T23:59:59Z';
sub get_full_date {
	my $self = shift;

	local ($date, $dt) = ($_[0]);
	if ($date =~ /^(\d+)\-(\d+)\-(\d+)\D+(\d+)\:+(\d+)\:+(\d+)/) {
	    $dt->{'year'} = $1;
	    $dt->{'month'} = $2;
	    $dt->{'day'} = $3;
	    $dt->{'h'} = $4;
	    $dt->{'m'} = $5;
	    $dt->{'s'} = $6;
#	    my $name_month = "smonth_$dt->{'month'}";
#	    $dt->{'string'} = "$text{$name_month}";
	}
	return $dt;
}

# download license from $lic_host
# &license_download(collectionCode);
sub license_download {
	my $self = shift;

	local ($out, $error);
	local $params = "queryType=1&collectionCode=$_[0]";
	$self->error_setup($self->{'text_hash'}->{'err_download'});
	print $self->{'text_hash'}->{'getlic_log_dload'} if $self->{'lic_logging'};
	$self->http_download_post($self->{'lic_host2'}, $self->{'lic_port2'}, $self->{'lic_page2'}, \$out, \$error, undef, 1, undef, undef, $params);
	$error && $self->error("$error");
	print $self->{'text_hash'}->{'getlic_log_ok'} if $self->{'lic_logging'};
	local ($ret_code, $ok, $msg, $license, $raw);
	$self->print_debug("Raw Datas:<br><pre>$out</pre>");
	print $self->{'text_hash'}->{'getlic_log_parse'} if $self->{'lic_logging'};
	local @lines = split("\n", $out);
	$ret_code = $1 if @lines && $lines[0] =~ /^(-?\d+)$/;
	$msg = $self->{'text_hash'}->{"ret_status$ret_code"};
	$ok = ($ret_code == 2);
	$license = join("\n", @lines[1 .. scalar(@lines) - 1]) if $ok;
	print $self->{'text_hash'}->{'getlic_log_ok'} if $self->{'lic_logging'};
	return { 'ok' => $ok, 'status' => $ret_code, 'msg' => $msg, 'license' => $license, 'raw' => $raw };
}

# http_download(host, port, page, destfile, [&error], [&callback], [sslmode],
#		[user, pass], [$params])
# Download data from a HTTP url to a local file
sub http_download_post {
	my $self = shift;

$self->print_debug("Host: $_[0]<br>Port: $_[1]</br>Page: $_[2]</br>File: $_[3]");
$self->{'download_timed_out'} = undef;
local $SIG{ALRM} = "download_timeout";
alarm(60);
local $h = $self->make_http_connection($_[0], $_[1], $_[6], "POST", $_[2]);
alarm(0);
$h = $self->{'download_timed_out'} if ($self->{'download_timed_out'});
if (!ref($h)) {
	if ($_[4]) { ${$_[4]} = $h; return; }
	else { $self->error($h); }
	}
local $clen = 0;
$clen = length($_[9]) if $_[9];
$self->write_http_connection($h, "Host: $_[0]\r\n");
$self->write_http_connection($h, "User-agent: $self->{'productname'}\r\n");
# $self->write_http_connection($h, "Accept-Language: en-us\r\n");
# $self->write_http_connection($h, "Content-Type: application/x-www-form-urlencoded\r\n");
$self->write_http_connection($h, "Content-Length: $clen\r\n");
$self->write_http_connection($h, "Pragma: no-cache\r\n");
$self->write_http_connection($h, "Connection: Keep-Alive\r\n");
if ($_[7]) {
	local $auth = $self->encode_base64("$_[7]:$_[8]");
	$auth =~ tr/\r\n//d;
	$self->write_http_connection($h, "Authorization: Basic $auth\r\n");
	}
$self->write_http_connection($h, "\r\n");
$self->print_debug("http_download_post; params: $_[9]");
$self->write_http_connection($h, "$_[9]") if $_[9];
$self->complete_http_download($h, $_[3], $_[4], $_[5]);
}

# saves text to file
# &save_to_file($file, $text);
sub save_to_file {
	my $self = shift;

	$self->lock_file($_[0]);
	open(FILE, ">" . $self->translate_filename($_[0])) || return 0;
	print FILE $_[1];
	close(FILE);
	$self->unlock_file($_[0]);
	return 1;
}

sub get_md5sum {
	my $self = shift;

	local $rv = `md5sum '$_[0]' 2>/dev/null`;
	if ($rv =~ /^\s*(\S+)/) {
		return $1;
	}
	return undef
}

# ============================================================================================
# no ZTL section
# ============================================================================================
# gnupg_setup()
# Setup gnupg so that rpms and .tar.gz files can be verified.
# Returns 0 if ok, 1 if gnupg is not installed, or 2 if something went wrong
# Assumes that gnupg-lib.pl is available
sub gnupg_setup {
	my $self = shift;

	return ( 1, $self->text('index_enogpg', "<tt>gpg</tt>") ) if (!$self->has_command("gpg"));
	# Checks if we already have the key
	local @keys = $self->list_keys();
	foreach $k (@keys) {
		return ( 0 ) if ($k->{'email'}->[0] eq $self->{'webmin_key_email'} &&
		         $self->key_fingerprint($k) eq $self->{'webmin_key_fingerprint'});
		}
	# Imports it if not
	$self->list_keys();
	$self->{'out'} = `gpg --import $self->{'root_directory'}/cpplus/psoft_cpplus-key.asc 2>&1`;
	return (2, $self->{'out'}) if $?;
	# Returns OK if key was imported
	return 0;
}

# key_fingerprint(keyid)
# Returns product key's fingerprint
sub key_fingerprint_id {
	my $self = shift;

	my ($keyid, $fp) = ($_[0]);
	open(GPG, "$self->{'gpgpath'} --fingerprint $keyid >/dev/null |");
	while(<GPG>) {
		if (/fingerprint\s+=\s+(.*)/) {$fp = $1; $fp =~ s/\s+/ /g; last; }
	}
	close(GPG);
	return $fp;
}

# search_key(email, key fingerprint, [secret])
# Searches gpg key
# Returns: key ref
sub search_key {
	my $self = shift;

	my ($email, $fgprn, $sec) = @_;
	my @keys = $self->list_keys();
	foreach $k (@keys) {
		print "KEY INFO: ", $k->{key},  $k->{date}, $k->{email}->[0], $self->key_fingerprint_id($k->{key}), " $k->{secret}<br>" if $self->{'debug'};
		return ($k) if ($k->{email}->[0] eq $email && $self->key_fingerprint_id($k->{key}) eq $fgprn && (!$sec || $k->{secret}));
	}
	return undef;
}

# get_license_info(data)
# Returns information what is contained inside license
# returns: a hash ('id', 'type', 'month', 'day', 'year', 'e_day', 'e_month', 'e_year', 'e_time')
sub get_license_info {
	my $self = shift;

	my $data = $_[0];
	my $src = $self->tempname();
	$self->write_entire_file($src, $data);
	my $dst = $self->tempname();
	my $out = `gpg --armor --output $dst $src 2>&1`;
	$self->print_debug("GPG armor output: <pre>$out</pre>");
	$data = $self->read_entire_file($dst);
	unlink($src);
	unlink($dst);
	chomp($data);
	$self->print_debug("License DATA: $data");
	return undef unless ($data =~ /^(\S{10})(\d)(\d\d)(\d\d)(\d\d\d\d)/); #(#(.*))?/);
	$self->print_debug("DATA WAS READ: $1, $2, $3, $4, $5");
	local $lic = {
		'id' => $1,
		'type' => $2,
		'month' => int($3),
		'day' => int($4),
		'year' => int($5),
	};
	$self->get_expire_date($lic);
	$lic->{'d_begin2'} = sprintf("%s %s %s", $self->{'text_hash'}->{"smonth_$lic->{month}"}, $lic->{'day'}, $lic->{'year'});
	$lic->{'d_expire2'} = sprintf("%s %s %s", $self->{'text_hash'}->{"smonth_$lic->{e_month}"}, $lic->{'e_day'}, $lic->{'e_year'});
	$lic->{'ret'} = 0;
	return $lic;
}

# get_expire_date(&lic);
# return: (expmonth, expday, expyear)
sub get_expire_date {
	my $self = shift;

	local $lic = $_[0];
# 	if ($lic->{'type'} == 3) {
# 		push(@{$lic}, ('e_day' => '', 'e_month' => '', 'e_year' => ''));
# 		return;
# 	}
	my ($tm, $ds) = (&timelocal(0, 0, 0, $lic->{'day'}, $lic->{'month'} - 1, $lic->{'year'}), 24 * 3600);
	$tm += ($lic->{'type'} == 1) ? $ds * 31 : ($lic->{'type'} == 2 || $lic->{'type'} == 4) ? $ds * 366 : 0;
	my @rv = localtime($tm);
	$rv[4]++;
	$rv[5] += 1900;
	%{$lic} = (%{$lic}, ('e_day' => $rv[3], 'e_month' => $rv[4], 'e_year' => $rv[5], 'e_time' => $tm));
	$self->print_debug("Expired date: $lic->{'e_day'}, $lic->{'e_month'}, $lic->{'e_year'}, $lic->{'e_time'}");
}

# check_freevps_server()
# Checks if CP+ is installed on the FreeVPS server
sub check_freevps_server {
	my $self = shift;

	local $ram = pack("llll", ());
	local $callback = syscall(271, 0, 3, $ram);
	if ($callback == -1) {
		# May be not a FreeVPS, checks a file system
		my $rv = `mount -t vfs | awk \'{print $3;}\' | grep -e \'^\/$\'`;
		return $rv ? 1 : 0;
	}
	elsif ($callback == 0) {
		return 0; # Detected FreeVPS Host
	}
	return 1; # FreeVPS Server was detected
}

# check_license_date(&lic)
# Checks expire date
sub check_license_date {
	my $self = shift;

	local $lic = $_[0];
# 	return 1 if $lic->{'type'} == 3;
	my $ctm = time();
# 	&get_expire_date($lic);
	return $ctm < $lic->{'e_time'};
}

# check_license_data(data)
# Checks license's data
# Returns:
#	0 - ok. return: (0, id, type, month, day, year, version)
#	1 - sign error
#	2 - bad info
#	3 - date is expired
#	4 - FreeVPS license on not freeVPS
sub check_license_data {
	my $self = shift;

	local ($sign, $lic) = ($_[0], {});
	local ($v_code, $v_msg) = $self->verify_data($sign);
	if ($v_code > 1) {
		$lic->{'ret'} = 1;
		$self->print_debug("ERROR: Failed to verify license data (code = $v_code)");
	}
	else {
		$lic = $self->get_license_info($sign);
		if (!$lic) {
			$lic->{'ret'} = 2;
			$self->print_debug("ERROR: Could not get license information");
		} elsif (!$self->check_license_date($lic)) {
			$lic->{'ret'} = 3;
		} elsif ($lic->{'type'} == 4 && !$self->check_freevps_server()) {
			$lic->{'ret'} = 4;
		}
	}
	return $lic;
}

# check_license_file(file)
# Checks file
sub check_license_file {
	my $self = shift;

	local $file = $_[0];
	return { 'ret' => 5 } unless -r $file;
	local $sign = $self->read_entire_file($file);
	$self->print_debug("READ DATA: $file<br><pre>$sign</pre>");
	return $self->check_license_data($sign);
}

# Returns:
#	0 - ok. return: (0, id, type, month, day, year, version)
#	1 - sign error
#	2 - bad info
#	3 - license is expired
#	4 - FreeVPS license on not freeVPS
sub check_license {
	my $self = shift;

	local $file = "$self->{'lic_directory'}/$self->{'config_hash'}->{'licfile'}";
	return $self->check_license_file($file);
}

# get_host_id()
# Returns host internal ip address
sub get_host_id {
	my $self = shift;

	my ($hostname, $ip) = ($self->get_system_hostname(), '');
	if ($self->has_command('host')) {
		my $text = `host $hostname`;
		if ($text =~ /(\d+\.\d+\.\d+\.\d+)\s*$/) {
			$ip = $1;
		}
	}
	unless ($ip) {
		$self->foreign_require("net", "net-lib.pl");
		local @ifaces = grep { $_->{'name'} !~ /^lo\d*/ } $main::net_object->active_interfaces();
		$ip = $ifaces[0]->{'address'} if @ifaces;
	}
	return $ip ? $ip : '127.0.0.1';
}

# download trial license from $self->{'lic_host'}
# uses only for CP+-style licenses
# &trial_download(&data);
sub trial_download {
	my $self = shift;

	local ($out, $error);
# 	local $name = &urlize($_[0]->{'nm'});
# 	local $company = &urlize($_[0]->{'cn'});
# 	local $email = &urlize($_[0]->{'em'});
# 	local $ver = &urlize($self->get_webmin_version());
# 	local $hostid = &urlize($self->get_host_id());
	local $name = $_[0]->{'nm'};
	local $company = $_[0]->{'cm'};
	local $email = $_[0]->{'em'};
	local $ver = $self->get_webmin_version();
	local $hostid = $self->get_host_id();

	if ($self->{'gconfig_hash'}->{'real_os_type'}) {
# 	    $self->{'os_type'} = &urlize($self->{'gconfig_hash'}->{'real_os_type'});
# 	    $self->{'os_ver'} = &urlize($self->{'gconfig_hash'}->{'real_os_version'});
	    $self->{'os_type'} = $self->{'gconfig_hash'}->{'real_os_type'};
	    $self->{'os_ver'} = $self->{'gconfig_hash'}->{'real_os_version'};
	} else {
# 	   $self->{'os_type'} = &urlize($self->{'gconfig_hash'}->{'os_type'});
# 	   $self->{'os_ver'} = &urlize($self->{'gconfig_hash'}->{'os_version'});
	   $self->{'os_type'} = $self->{'gconfig_hash'}->{'os_type'};
	   $self->{'os_ver'} = $self->{'gconfig_hash'}->{'os_version'};
	}
	local $params = "nm=$name&cm=$company&em=$email&v=$ver&id=$hostid&os_type=$self->{'os_type'}&os_ver=$self->{'os_ver'}";
	$self->error_setup($self->{'text_hash'}->{'err_download'});
	print $self->{'text_hash'}->{'getlic_log_dload'} if $self->{'lic_logging'};
	$self->http_download_post($self->{'lic_host'}, $self->{'lic_port'}, $self->{'lic_page'}, \$out, \$error, undef, undef, undef, undef, $params);
	$error && $self->error("$error");
	print $self->{'text_hash'}->{'getlic_log_ok'} if $self->{'lic_logging'};
	local ($ret_code, $ok, $msg, $license, $raw, $id);
	$self->print_debug("Raw Datas:<br><pre>$out</pre>");
	print $self->{'text_hash'}->{'getlic_log_parse'} if $self->{'lic_logging'};
	local @lines = split("\n", $out);
	
	if (@lines) {
		if ($lines[0] =~ /^Error:\s*(.*)$/) {
			$ret_code = 2;
			$msg = $1;
		} else {
			$id = $lines[0];
			unless ($id =~ /^\S+$/) {
				$ret_code = 2;
				$msg = $lines[0];
			}
		}
	} else {
		$ret_code = 1;
	}
	$ok = (!$ret_code);
	$license = join("\n", @lines[1 .. scalar(@lines) - 1]) if $ok;
	print $self->{'text_hash'}->{'getlic_log_ok'} if $self->{'lic_logging'};
	return { 'ok' => $ok, 'status' => $ret_code, 'id' => $id, 'msg' => $msg, 'license' => $license, 'raw' => $raw };
}

# check_Net_SSLeay()
# Check if the Net::SSLeay Perl module are installed
sub check_Net_SSLeay {
	my $self = shift;

	if ($self->foreign_available("cpan") && $self->{'no_net_ssleay'}) {
		local $urlmod = $self->urlize($self->{'perl_net_ssleay_module'});
		print "<b>", $self->text('index_enonetssleay', $self->{'perl_net_ssleay_module'}), "</b><br>\n";
		print $self->text('index_netssleayinst', $self->{'text_hash'}->{'index_netssleay'}, $self->{'text_hash'}->{'programname'}, "/cpan/download.cgi?act=2&source=3&cpan=$urlmod&mode=2&return=/$self->{'module_name'}/&returndesc=".$self->urlize($self->{'text_hash'}->{'index_return'})) . "<br>\n";

		if ($self->foreign_check('swup')) {
			local $urlpkg = $self->urlize($self->{'perl_net_ssleay_swup'});
			print $self->text('index_netssleayswup', $self->{'text_hash'}->{'index_netssleay'}, $self->{'text_hash'}->{'programname'}, "/swup/install_pkgs.cgi?pkg=$urlpkg&return=/$self->{'module_name'}/&returndesc=".$self->urlize($self->{'text_hash'}->{'index_return'})) . "<br>\n";
		}
		elsif ($self->foreign_check('software')) {
			$self->foreign_require("software", "software-lib.pl");
			local $lnk = $main::software_object->missing_install_link("perl-Net-SSLeay", $self->{'text_hash'}->{'index_netssleay'},
				"/$self->{'module_name'}/", $self->{'text_hash'}->{'index_title'});
			print $lnk,"<p>\n" if ($lnk);
		}
		return 1;
	}
	return 0;
}

# print_debug(msg)
# Prints debug messages
sub print_debug {
	my $self = shift;

	print "$_[0]<hr>\n" if $self->{'debug'};
}

# check_email_address(email)
# Checks E-Mail address
sub check_email_address {
	my $self = shift;

	return ($_[0] =~ /^[a-z0-9._-]+@([a-z0-9_-]+\.)+(com|net|org|mil|edu|gov|arpa|info|inc|biz|name|[a-z]{2})$/i) ? 1 : 0;
}

# error_lic(msg, [&lic], [show header])
sub error_lic {
	my $self = shift;

	local ($msg, $lic, $header) = @_;
	local $nolic = !$lic || $lic->{'ret'};
	$self->ui_print_header(undef, $self->{'text_hash'}->{'error'}, undef, undef, 0, 1, $nolic) if $header;
	print "<hr>\n";
	print "<h3>",($self->{'whatfailed'} ? "$self->{'whatfailed'} : " : ""), $_[0], "</h3>\n";
	print "<hr>\n";
	
	if ($nolic) {
		$self->ui_print_footer();
	}
	else {
		$self->ui_print_footer($self->{'text_hash'}->{'index_mainpage_url'}, $self->{'text_hash'}->{'index_mainpage'});
	}
	$self->unlock_all_files();
	exit;
}


1;

