
#include <stdio.h>
#include <stdlib.h>
#include <dirent.h>
#include <string.h>
#include <ctype.h>
#include <time.h>
#include <string>
#include <vector>
#include <stack>
#include <map>
#include <time.h>
#include <iostream.h>
#include <expat.h>

#include "license.hpp"      //  class License
#include "licensetag.hpp"   //  class LicenseTag
#include "ctlicense.hpp"    //  'Published' library functions.

#define VERBOSE_TEST 0


namespace CTLicense {
  extern std::string dirLicenses;
  static std::vector<License *> licenses;
//  static std::string eth0Address;
// static std::string macAddress;

  extern void _reloadLicenses(std::vector<License *> &licenses);
  void reloadLicenses(const std::string& dirLic) { dirLicenses = dirLic; _reloadLicenses(licenses); }
  
  static bool _checkModuleLicense(License *license, const std::string& modulename) {
  #if VERBOSE_TEST
	cout<<"The product name: "<<license->getProduct()<<endl;
	cout<<"The product check: "<<(license->getProduct() == modulename)<<endl;
	cout<<"The time check: "<< license->checkTime()<<endl;
	//cout<<"The MAC Address check: "<<license->checkMAC(macAddress)<<endl;
  #endif
	return license->getProduct() == modulename && license->checkTime(); // && license->checkMAC(macAddress);
  }
  
  static std::string maddr;

//  std::string& getSystemKey() {
//    return maddr = getMACaddress();
//  }
  
  bool checkModuleLicense(const std::string& modulename) {
  #if VERBOSE_TEST
    cout<<"Inside checkModuleLicense"<<endl; 
    cout<<"The size is "<<licenses.size()<<endl;   
  #endif
    for (int i = 0; i < licenses.size(); i++) 
      if (_checkModuleLicense(licenses[i], modulename)) return i + 1;
    return 0;
  }

  std::string getModuleLicenseDescription(const std::string& modulename) {
    for (int i = 0; i < licenses.size(); i++) 
      if (_checkModuleLicense(licenses[i], modulename)) 
        return licenses[i]->getDescription();
    return std::string("No valid license");
  }
  
  time_t getModuleBeginDate(const std::string& modulename) {
    for (int i = 0; i < licenses.size(); i++) 
      if (_checkModuleLicense(licenses[i], modulename)) 
	return licenses[i]->getBeginDate();
    return (time_t) -1;
  }
  
  time_t getModuleExpireDate(const std::string& modulename) {
    for (int i = 0; i < licenses.size(); i++) 
      if (_checkModuleLicense(licenses[i], modulename)) 
	return licenses[i]->getExpireDate();
    return (time_t) -1;
  }

  std::string getModuleBeginDateString(const std::string& modulename) {
    for (int i = 0; i < licenses.size(); i++) 
      if (_checkModuleLicense(licenses[i], modulename)) 
	return licenses[i]->getBeginDateString();
    return std::string("No valid license");
  }
  
  std::string getModuleExpireDateString(const std::string& modulename) {
    for (int i = 0; i < licenses.size(); i++) 
      if (_checkModuleLicense(licenses[i], modulename)) 
	return licenses[i]->getExpireDateString();
    return std::string("No valid license");
  }
  
  std::string getModuleStringTerm(const std::string& modulename, const std::string& term) {
    for (int i = 0; i < licenses.size(); i++) 
      if (_checkModuleLicense(licenses[i], modulename)) 
        return licenses[i]->getStringTerm(term);
    return std::string("No valid license");
  }
  
  bool checkModuleBoolTerm(const std::string& modulename, const std::string& term) {
    
    for (int i = 0; i < licenses.size(); i++) 
      if (_checkModuleLicense(licenses[i], modulename) && licenses[i]->getBoolTerm(term)) return true;
    return false;
  }

  int getModuleNumericTerm(const std::string& modulename, const std::string& term) {
    
    int ret = 0;
    bool something = false;
    for (int i = 0; i < licenses.size(); i++) 
      if (_checkModuleLicense(licenses[i], modulename)) {
	int val = licenses[i]->getNumericTerm(term);
	if (val != -1) something = true;
	if (val > ret) ret = val;
      }
    return (something) ? ret : -1;
  }
  
  extern "C" {
    void __attribute__ ((constructor)) lic_init() {
#if VERBOSE_TEST
      printf("INIT\n");
#endif
//      eth0Address = getIPaddress();
//      macAddress  = getMACaddress();
//      reloadLicenses();
    }
    void __attribute__ ((destructor)) lic_fini() {
#if VERBOSE_TEST
      printf("FINISH\n"); 
#endif
    }
  }
  
  void dumpLicense(int i) { licenses[i]->dump(); }
}
