#ifndef ctlicense_license_h
#define ctlicense_license_h

#include <string>
#include <map>

#include "licensetag.hpp"

namespace CTLicense {

  class License {
    std::string prodID;
    std::string prodName;
    std::string prodDescription;
    time_t notbefore;
    time_t notafter;
    time_t issuedate;
    std::string hostAddr;
    std::string hostMAC;
    std::string licenceeName;
    std::string licenceeCompany;
    std::map<std::string,std::string> terms;
    
  public:
    License(LicenseTag *lic);
    
    const std::string getProduct(); // { return prodID; }
    
    bool checkTime();
    bool checkHost(const std::string &compareTo);
    bool checkMAC(const std::string &compareTo);
    
    bool validForID(const std::string &module);
    std::string getStringTerm(const std::string &term);
    bool getBoolTerm(const std::string &term);
    int  getNumericTerm(const std::string &term);
    
    time_t getBeginDate();
    time_t getExpireDate();
    std::string getDescription();
    std::string getBeginDateString();
    std::string getExpireDateString();

    void dump();

    friend class LicenseTag;
  };

}


#endif /* #ndef ctlicense_license_h */
