#!/usr/bin/perl

open(IN,"/usr/lib/rpm/macros") || die "Could not read rpmmacros";

%macros = ();

foreach(<IN>) {
	next if not /^\%([a-zA-Z0-9_]+)\s+([^ \t\n]+)/; 
	$macros{$1} = $2;
}

close(IN);

sub expand() {
	my $src = @_[0];
	while ($src =~ /([^\%]*)\%\{([^\}]+)\}(.*)/) {
		my ($a,$b,$c) = ($1,$2,$3);
		my $res = &expand($macros{$b});
		$src = $a . $res . $c;
	}
	return $src;
}

#print "RPM_SPECDIR="   . &expand($macros{'_specdir'})   . "\r\n";
#dprint "RPM_SOURCEDIR=" . &expand($macros{'_sourcedir'}) . "\r\n";

print &expand($macros{'_sourcedir'}) if $ARGV[0] eq 'src';
print &expand($macros{'_specdir'}) if $ARGV[0] eq 'spec';



