do '../web-lib.pl';
&init_config();
require '../ui-lib.pl';
use Time::Local;

$module_config_page = "/config.cgi?$module_name";
# debug mode flag
$debug = 0;

&print_debug("content-type: text/html\n\n");

# Turns on showing log information
$lic_logging = 1;

# standard CP+ licensing
$lic_host = $config{'lichost'}; #'cpplus.info';
$lic_port = $config{'licport'}; #80;
$lic_page = $config{'licpage'}; #'/';

# enhanced CP+ licensing
$lic_host2 = $config{'lichost2'}; #'secure.comodo.net';
$lic_port2 = $config{'licport2'}; #443;
$lic_page2 = $config{'licpage2'}; #'/products/download/CollectLicence';

$lic_directory = "$config_directory/$module_name/licenses";
$lic_collectionCode = '';

mkdir($lic_directory, 0700) unless -d $lic_directory;

$productname = $gconfig{'product'} ? $gconfig{'product'} : $gconfig{'ztl_mode'} ? "ztl" : "cpplus";
if (!$gconfig{'ztl_mode'}) {
	&foreign_require("$productname", "$productname-lib.pl");
	&foreign_require("$productname", "gnupg-lib.pl");
}
$no_comodo_mode++ if !$config{'use_ctlicense'};

$perl_net_ssleay_module = 'Net::SSLeay';
$perl_net_ssleay_swup = 'perl-net-ssleay';
if (!$no_comodo_mode) {
	eval "use $perl_net_ssleay_module;";
	$no_net_ssleay++ if $@;
}
else {
	$no_net_ssleay++;
}

# if (! $config{'comodo_mode'}) {
# 	&foreign_require("$productname", "$productname-lib.pl");
# 	&foreign_require("$productname", "gnupg-lib.pl");
# 	$no_comodo_mode++;
# }

# Defines URL for getting a product license
# $lic_order_url = $productname eq 'ztl' ? "http://ztl.psoft.net/order.html" : "http://cpplus.info/order.html";
$lic_order_url = $gconfig{'ztl_mode'} ? "http://ztl.psoft.net/order.html" : "http://cpplus.psoft.net/pricing.html";

if ($< == 0) {
	local @user_info = getpwuid(0);
	#@remote_user_info || &error(&text('switch_remote_euser', $remote_user));
	@user_info || &error($text{'index_euserinfo'});
	$gnupg_directory = $user_info[7] . "/.gnupg";
	mkdir ($gnupg_directory, 0700) if ! -d $gnupg_directory;
}

# read_entire_file(file)
# Reads entire file and returns read datas
sub read_entire_file {
	local ($rv, $buf);
	open(FILE, $_[0]) || return undef;
	while(read(FILE, $buf, 1024) > 0) {
		$rv .= $buf;
		}
	close(FILE);
	return $rv;
}

# write_entire_file(file, data)
# Writes data to file
sub write_entire_file {
	&open_tempfile(FILE, ">$_[0]");
	&print_tempfile(FILE, $_[1]);
	&close_tempfile(FILE);
}

sub verify_data {
	&cpplus::verify_data(@_);
}

sub list_keys {
	&cpplus::list_keys(@_);
}

sub key_fingerprint {
	&cpplus::key_fingerprint(@_);
}

# get_licinfo([license file])
# Return a hash what contains a license information
# Key 'ret':
#  0 - ok
#  1 - License is not valid or expired
#  2 - License is not valid
#  3 - Failed to find a License file
sub get_licinfo 
{
 if ($config{'license_key'}) {
	# Master Key license
	MKEY:
	if (!$config{'lic_time_check'}) {
		# license time check
		$config{'lic_time_check'} =  time ();
		$config{'lic_begin'} = $config{'lic_time_check'};
		$config{'lic_expire'} = $config{'lic_time_check'} + $tconfig{'billing_expire_limit'};
		&save_module_config();
		}
    
	if ((time() - $config{'lic_time_check'}) > $tconfig{'billing_check_period'} || $config{'error_check_lic'}) {
		# check license
		local $version = &get_webmin_version();
		local $file = &tempname();
		local $vps = &check_freevps_server();
		local $param = "software=CP%2B&version=$version&vps=$vps&key=$config{'license_key'}";
		eval "use Net::SSLeay";
		if ($@) {
			# http download
			&http_download($tconfig{'billing_host'}, 80, "$tconfig{'billing_check_file'}?$param", $file, \$error, undef, undef, undef, undef, 20, undef, 1);
			} 
		else {
			# https download
			&http_download($tconfig{'billing_host'}, 443, "$tconfig{'billing_check_file'}?$param", $file, \$error, undef, 1, undef, undef, 20, undef, 1);
			}
		$config{'error_check_lic'} = 1;
		$config{'lic_error_desc'} = undef;
		if (!-e $file || -z $file){
			# no answer from server
			$config{'lic_error_desc'} = &text('err_request', $tconfig{'billing_host'});
			$config{'try_counter'}++;
			$config{'error_check_lic'} = 0 if ($config{'try_counter'} < 3);
			}
		else {
			# check answer
			open(FILE, $file);
			while(<FILE>) {
				$config{'error_check_lic'} = 0 if (/\s*1\s*/);
				$config{'lic_error_desc'} = $1 if ($config{'error_check_lic'} && /^\d*(.+)$/);
				$config{'try_counter'} = 0;
				}
			close(FILE);
			unlink($file);
			}
			$config{'lic_time_check'} = time();
			&save_module_config();
			return { 'ret' => '-1' } if ($config{'error_check_lic'});	
		}
		$expire = time() + $tconfig{'billing_check_period'} * (3 - $config{'try_counter'});
		$expire = &get_date_as_string($expire);
		$begin = &get_date_as_string(time());
		return {
					'ret' => '0',
					'type' => 'key',
					'd_begin' => $begin,
					'd_begin2' => &get_date_string($begin),
					'd_expire' => $expire,
					'd_expire2' => &get_date_string($expire),	
					'err' => $config{'lic_error_desc'}
		} if (! $config{'error_check_lic'});
	}

 if ($tconfig{'type_lic'} == 5) {
	# VPSLAND license
	if ($tconfig{'reseller_license_key'}){
		# move to Master Key license
		$config{'license_key'} = $tconfig{'reseller_license_key'};
		&save_module_config();
		goto MKEY;
		}

	if (!$config{'lic_time_check'}) {
		# license time check
		$config{'lic_time_check'} =  time ();
		$config{'lic_begin'} = $config{'lic_time_check'};
		$config{'lic_expire'} = $config{'lic_time_check'} + $tconfig{'expire_limit'};
		&save_module_config();
		}

	if ((time() - $config{'lic_time_check'}) > $tconfig{'check_period'} || $config{'error_check_lic'}) {
		# check license
		local $internal_ip = &get_host_id();
		local $brand = uc $tconfig{'brand'};
		local $version = &get_webmin_version();
		local $file = &tempname();
		local $param = "internal_ip=$internal_ip&brand=$brand&version=$version&begin=$config{'lic_begin'}&expire=$config{'lic_expire'}";
		# http download
		&http_download($tconfig{'check_host'}, $tconfig{'check_port'}, "$tconfig{'check_file'}?$param", $file, \$error, undef, undef, undef, undef, 20, undef, 1);
		
		local $config{'error_check_lic'} = 1;
		if (!-e $file || -z $file){
			# no answer from server
			$config{'try_counter'}++;
			$config{'error_check_lic'} = 0 if ($config{'try_counter'} < 3);
		 	}
		else {
			# check answer
			open(FILE, $file);
			while(<FILE>)  {
				$config{'error_check_lic'} = 0 if (/CHECK:OK/);
				$config{'lic_begin'} = $1 if (/BEGIN:(\d+)/);
				$config{'lic_expire'} = $1 if (/EXPIRE:(\d+)/);
				}
			close(FILE);
			unlink($file);
			}
		$config{'lic_time_check'} = time();
		&save_module_config();
		}
		$begin = &get_date_as_string($config{'lic_begin'});
		$expire = time() + $tconfig{'billing_check_period'} * (3 - $config{'try_counter'});
		$expire = &get_date_as_string($expire);
		return {
					'ret' => '0',
					'type' => 'key',
					'd_begin' => $config{'lic_begin'},
					'd_begin2' => &get_date_string($begin),
					'd_expire' => $config{'lic_expire'},
					'd_expire2' => &get_date_string($expire)
		} if (!$config{'error_check_lic'});
	}
	
	$fingerprint = '70:17:83:C3:60:5E:2F:CD:D4:9A:43:C2:EB:B3:E6:CC';
	
	local $lfile = $_[0] ? $_[0] : "$lic_directory/$config{'licfile'}";
	-f $lfile || return { 'ret' => '3', 'msg' => $text{'err_notfound'} };
	local $rv = $gconfig{'ztl_mode'} ? {'ret' => 4, 'msg' => 'No license'} : &check_license_file($lfile);
	return $rv if $no_comodo_mode || $rv->{'ret'} == 0;
	local $err = 0;

	#check chain
	local $chain_file = "$lfile.chain";
	local $lic_file = "$lfile.lic";
	if (! -f $chain_file) {
	    open (FULL_LIC, "$lfile");
	    open (CHAIN, ">$chain_file");
	    open (LIC, ">$lic_file");
	    while (<FULL_LIC>) {
		$num++ if ( $_ =~ m/^-----BEGIN\s+CERTIFICATE-----$/ );
		if ($num<3) { # two first certificate
    		    print CHAIN $_;
		    } else {
			    print LIC $_;
			    }
	    }
	    close (FULL_LIC);
	    close (CHAIN);
	    close (LIC);
	    }
	
	$out = `openssl verify -CAfile $chain_file $lic_file`;
	&print_debug($out);
	($out =~ m/$lic_file\:\s+OK/) || return {'ret' => '1', 'msg' => $text{'err_notvalid'}, 'sysret' => $?, 'output' => $out};
	
	$out = `openssl x509 -in $chain_file -noout -fingerprint`;
	&print_debug($out);
	$out =~ s/MD5\s+Fingerprint\=//;
	($out =~ m/$fingerprint/) || return {'ret' => '1', 'msg' => $text{'err_notvalid'}, 'sysret' => $?, 'output' => $out};

	

	$out = `openssl x509 -in $lic_file -text -noout`;
	&print_debug($out);
	foreach my $l (split("\n", $out)) {
		$before = &get_full_date($1) if ($l =~ m/NotBefore\>(.+)\<\/NotBefore/i);
		$after = &get_full_date($1) if ($l =~ m/NotAfter\>(.+)\<\/NotAfter/i);
		$descr = $1 if $l =~ m/Description\>(.+)\<\/Description/i;
	}
	
	$out = `openssl x509 -in $lic_file -startdate -noout`;
	&print_debug($out);
	$begin = $1 if $out =~ m/^notBefore\=(.+)$/;
	
	$out = `openssl x509 -in $lic_file -enddate -noout`;
	&print_debug($out);
	$expire = $1 if $out =~ m/^notAfter\=(.+)$/;

	&print_debug("BEGIN: $begin   EXPIRE: $expire");
	return { 
		'ret' => '0', 
		'descr' => $descr,
		'd_begin' => $begin,
		'd_begin2' => &get_date_string($begin),
		'd_expire' => $expire,
		'd_expire2' => &get_date_string($expire)
	} if $begin && $expire;
	return { 'ret' => '2', 'msg' => $text{'err_parseoutput'}, 'sysret' => $?, 'output' => $out }
}

# return date as string July 21 05:55:00 1976
# &get_date_as_string(time());
sub get_date_as_string {
    local $date = $_[0];
    my @tm = gmtime($date);
    $tm[4]++;
    my $name_month = "smonth_$tm[4]";
    my $year = $tm[5]+1900;
    return "$text{$name_month} $tm[3] $tm[2]:$tm[1]:$tm[0] $year";
}

# returns date in form: month_name day year
# &get_date_short($date);
# $date = 'Sat Sep 3 00:00:00 2005';
sub get_date_short {
	local ($date, $rv) = ($_[0]);
	$str = sprintf("%3s %02d %04d", $2, $3, $5) if $date =~ /^\s*(\S+)\s+(\S+)\s+(\S+)\s+(\S+)\s+(\S+)$/;
	return $str;
}

# returns date in form: month_name day year
# &get_date_string($date);
# $date = 'May 29 00:00:00 2006';
sub get_date_string {
	local ($date ) = ($_[0]);
	$str = sprintf("%3s %02d %04d", $1, $2, $4) if $date =~ /^\s*(\S+)\s+(\S+)\s+(\S+)\s+(\S+)/;
	return $str;
}

# returns date in form: month_name day year
# &get_date_short($date);
# $date = '2007-05-29T23:59:59Z';
sub get_full_date {
	local ($date, $dt) = ($_[0]);
	if ($date =~ /^(\d+)\-(\d+)\-(\d+)\D+(\d+)\:+(\d+)\:+(\d+)/) {
	    $dt->{'year'} = $1;
	    $dt->{'month'} = $2;
	    $dt->{'day'} = $3;
	    $dt->{'h'} = $4;
	    $dt->{'m'} = $5;
	    $dt->{'s'} = $6;
#	    my $name_month = "smonth_$dt->{'month'}";
#	    $dt->{'string'} = "$text{$name_month}";
	}
	return $dt;
}

# download license from $lic_host
# &license_download(collectionCode);
sub license_download {
	local ($out, $error);
	local $params = "queryType=1&collectionCode=$_[0]";
	&error_setup($text{'err_download'});
	print $text{'getlic_log_dload'} if $lic_logging;
	&http_download_post($lic_host2, $lic_port2, $lic_page2, \$out, \$error, undef, 1, undef, undef, $params);
	$error && &error("$error");
	print $text{'getlic_log_ok'} if $lic_logging;
	local ($ret_code, $ok, $msg, $license, $raw);
	&print_debug("Raw Datas:<br><pre>$out</pre>");
	print $text{'getlic_log_parse'} if $lic_logging;
	local @lines = split("\n", $out);
	$ret_code = $1 if @lines && $lines[0] =~ /^(-?\d+)$/;
	$msg = $text{"ret_status$ret_code"};
	$ok = ($ret_code == 2);
	$license = join("\n", @lines[1 .. scalar(@lines) - 1]) if $ok;
	print $text{'getlic_log_ok'} if $lic_logging;
	return { 'ok' => $ok, 'status' => $ret_code, 'msg' => $msg, 'license' => $license, 'raw' => $raw };
}

# http_download(host, port, page, destfile, [&error], [&callback], [sslmode],
#		[user, pass], [$params])
# Download data from a HTTP url to a local file
sub http_download_post {
&print_debug("Host: $_[0]<br>Port: $_[1]</br>Page: $_[2]</br>File: $_[3]");
$download_timed_out = undef;
local $SIG{ALRM} = "download_timeout";
alarm(60);
local $h = &make_http_connection($_[0], $_[1], $_[6], "POST", $_[2]);
alarm(0);
$h = $download_timed_out if ($download_timed_out);
if (!ref($h)) {
	if ($_[4]) { ${$_[4]} = $h; return; }
	else { &error($h); }
	}
local $clen = 0;
$clen = length($_[9]) if $_[9];
&write_http_connection($h, "Host: $_[0]\r\n");
&write_http_connection($h, "User-agent: $productname\r\n");
# &write_http_connection($h, "Accept-Language: en-us\r\n");
# &write_http_connection($h, "Content-Type: application/x-www-form-urlencoded\r\n");
&write_http_connection($h, "Content-Length: $clen\r\n");
&write_http_connection($h, "Pragma: no-cache\r\n");
&write_http_connection($h, "Connection: Keep-Alive\r\n");
if ($_[7]) {
	local $auth = &encode_base64("$_[7]:$_[8]");
	$auth =~ tr/\r\n//d;
	&write_http_connection($h, "Authorization: Basic $auth\r\n");
	}
&write_http_connection($h, "\r\n");
&print_debug("http_download_post; params: $_[9]");
&write_http_connection($h, "$_[9]") if $_[9];
&complete_http_download($h, $_[3], $_[4], $_[5]);
}

# saves text to file
# &save_to_file($file, $text);
sub save_to_file {
	&lock_file($_[0]);
	open(FILE, ">" . &translate_filename($_[0])) || return 0;
	print FILE $_[1];
	close(FILE);
	&unlock_file($_[0]);
	return 1;
}

sub get_md5sum {
	local $rv = `md5sum '$_[0]' 2>/dev/null`;
	if ($rv =~ /^\s*(\S+)/) {
		return $1;
	}
	return undef
}

# ============================================================================================
# no ZTL section
# ============================================================================================
# gnupg_setup()
# Setup gnupg so that rpms and .tar.gz files can be verified.
# Returns 0 if ok, 1 if gnupg is not installed, or 2 if something went wrong
# Assumes that gnupg-lib.pl is available
sub gnupg_setup {
	return ( 1, &text('index_enogpg', "<tt>gpg</tt>") ) if (!&has_command("gpg"));
	# Checks if we already have the key
	local @keys = &list_keys();
	foreach $k (@keys) {
		return ( 0 ) if ($k->{'email'}->[0] eq $webmin_key_email &&
		         &key_fingerprint($k) eq $webmin_key_fingerprint);
		}
	# Imports it if not
	&list_keys();
	$out = `gpg --import $root_directory/cpplus/psoft_cpplus-key.asc 2>&1`;
	return (2, $out) if $?;
	# Returns OK if key was imported
	return 0;
}

# key_fingerprint(keyid)
# Returns product key's fingerprint
sub key_fingerprint_id {
	my ($keyid, $fp) = ($_[0]);
	open(GPG, "$gpgpath --fingerprint $keyid >/dev/null |");
	while(<GPG>) {
		if (/fingerprint\s+=\s+(.*)/) {$fp = $1; $fp =~ s/\s+/ /g; last; }
	}
	close(GPG);
	return $fp;
}

# search_key(email, key fingerprint, [secret])
# Searches gpg key
# Returns: key ref
sub search_key {
	my ($email, $fgprn, $sec) = @_;
	my @keys = &list_keys();
	foreach $k (@keys) {
		print "KEY INFO: ", $k->{key},  $k->{date}, $k->{email}->[0], &key_fingerprint_id($k->{key}), " $k->{secret}<br>" if $debug;
		return ($k) if ($k->{email}->[0] eq $email && &key_fingerprint_id($k->{key}) eq $fgprn && (!$sec || $k->{secret}));
	}
	return undef;
}

# get_license_info(data)
# Returns information what is contained inside license
# returns: a hash ('id', 'type', 'month', 'day', 'year', 'e_day', 'e_month', 'e_year', 'e_time')
sub get_license_info {
	my $data = $_[0];
	my $src = &tempname();
	&write_entire_file($src, $data);
	my $dst = &tempname();
	my $out = `gpg --armor --output $dst $src 2>&1`;
	&print_debug("GPG armor output: <pre>$out</pre>");
	$data = &read_entire_file($dst);
	unlink($src);
	unlink($dst);
	chomp($data);
	&print_debug("License DATA: $data");
	return undef unless ($data =~ /^(\S{10})(\d)(\d\d)(\d\d)(\d\d\d\d)/); #(#(.*))?/);
	&print_debug("DATA WAS READ: $1, $2, $3, $4, $5");
	local $lic = {
		'id' => $1,
		'type' => $2,
		'month' => int($3),
		'day' => int($4),
		'year' => int($5),
	};
	&get_expire_date($lic);
	$lic->{'d_begin2'} = sprintf("%s %s %s", $text{"smonth_$lic->{month}"}, $lic->{'day'}, $lic->{'year'});
	$lic->{'d_expire2'} = sprintf("%s %s %s", $text{"smonth_$lic->{e_month}"}, $lic->{'e_day'}, $lic->{'e_year'});
	$lic->{'ret'} = 0;
	return $lic;
}

# get_expire_date(&lic);
# return: (expmonth, expday, expyear)
sub get_expire_date {
	local $lic = $_[0];
# 	if ($lic->{'type'} == 3) {
# 		push(@{$lic}, ('e_day' => '', 'e_month' => '', 'e_year' => ''));
# 		return;
# 	}
	my ($tm, $ds) = (&timelocal(0, 0, 0, $lic->{'day'}, $lic->{'month'} - 1, $lic->{'year'}), 24 * 3600);
	$tm += ($lic->{'type'} == 1) ? $ds * 31 : ($lic->{'type'} == 2 || $lic->{'type'} == 4) ? $ds * 366 : 0;
	my @rv = localtime($tm);
	$rv[4]++;
	$rv[5] += 1900;
	%{$lic} = (%{$lic}, ('e_day' => $rv[3], 'e_month' => $rv[4], 'e_year' => $rv[5], 'e_time' => $tm));
	&print_debug("Expired date: $lic->{'e_day'}, $lic->{'e_month'}, $lic->{'e_year'}, $lic->{'e_time'}");
}

# check_freevps_server()
# Checks if CP+ is installed on the FreeVPS server
sub check_freevps_server {
	local $ram = pack("llll", ());
	local $callback = syscall(271, 0, 3, $ram);
	if ($callback == -1) {
		# May be not a FreeVPS, checks a file system
		my $rv = `mount -t vfs | awk \'{print $3;}\' | grep -e \'^\/$\'`;
		return $rv ? 1 : 0;
	}
	elsif ($callback == 0) {
		return 0; # Detected FreeVPS Host
	}
	return 1; # FreeVPS Server was detected
}

# check_license_date(&lic)
# Checks expire date
sub check_license_date {
	local $lic = $_[0];
# 	return 1 if $lic->{'type'} == 3;
	my $ctm = time();
# 	&get_expire_date($lic);
	return $ctm < $lic->{'e_time'};
}

# check_license_data(data)
# Checks license's data
# Returns:
#	0 - ok. return: (0, id, type, month, day, year, version)
#	1 - sign error
#	2 - bad info
#	3 - date is expired
#	4 - FreeVPS license on not freeVPS
sub check_license_data {
	local ($sign, $lic) = ($_[0], {});
	local ($v_code, $v_msg) = &verify_data($sign);
	if ($v_code > 1) {
		$lic->{'ret'} = 1;
		&print_debug("ERROR: Failed to verify license data (code = $v_code)");
	}
	else {
		$lic = &get_license_info($sign);
		if (!$lic) {
			$lic->{'ret'} = 2;
			&print_debug("ERROR: Could not get license information");
		} elsif (!&check_license_date($lic)) {
			$lic->{'ret'} = 3;
		} elsif ($lic->{'type'} == 4 && !&check_freevps_server()) {
			$lic->{'ret'} = 4;
		}
	}
	return $lic;
}

# check_license_file(file)
# Checks file
sub check_license_file {
	local $file = $_[0];
	return { 'ret' => 5 } unless -r $file;
	local $sign = &read_entire_file($file);
	&print_debug("READ DATA: $file<br><pre>$sign</pre>");
	return &check_license_data($sign);
}

# Returns:
#	0 - ok. return: (0, id, type, month, day, year, version)
#	1 - sign error
#	2 - bad info
#	3 - license is expired
#	4 - FreeVPS license on not freeVPS
sub check_license {
	local $file = "$lic_directory/$config{'licfile'}";
	return &check_license_file($file);
}

# get_host_id()
# Returns host internal ip address
sub get_host_id {
	my ($hostname, $ip) = (&get_system_hostname(), '');
	if (&has_command('host')) {
		my $text = `host $hostname`;
		if ($text =~ /(\d+\.\d+\.\d+\.\d+)\s*$/) {
			$ip = $1;
		}
	}
	unless ($ip) {
		&foreign_require("net", "net-lib.pl");
		local @ifaces = grep { $_->{'name'} !~ /^lo\d*/ } &net::active_interfaces();
		$ip = $ifaces[0]->{'address'} if @ifaces;
	}
	return $ip ? $ip : '127.0.0.1';
}

# download trial license from $lic_host
# uses only for CP+-style licenses
# &trial_download(&data);
sub trial_download {
	local ($out, $error);
# 	local $name = &urlize($_[0]->{'nm'});
# 	local $company = &urlize($_[0]->{'cn'});
# 	local $email = &urlize($_[0]->{'em'});
# 	local $ver = &urlize(&get_webmin_version());
# 	local $hostid = &urlize(&get_host_id());
	local $name = $_[0]->{'nm'};
	local $company = $_[0]->{'cm'};
	local $email = $_[0]->{'em'};
	local $ver = &get_webmin_version();
	local $hostid = &get_host_id();

	if ($gconfig{'real_os_type'}) {
# 	    $os_type = &urlize($gconfig{'real_os_type'});
# 	    $os_ver = &urlize($gconfig{'real_os_version'});
	    $os_type = $gconfig{'real_os_type'};
	    $os_ver = $gconfig{'real_os_version'};
	} else {
# 	   $os_type = &urlize($gconfig{'os_type'});
# 	   $os_ver = &urlize($gconfig{'os_version'});
	   $os_type = $gconfig{'os_type'};
	   $os_ver = $gconfig{'os_version'};
	}
	local $params = "nm=$name&cm=$company&em=$email&v=$ver&id=$hostid&os_type=$os_type&os_ver=$os_ver";
	&error_setup($text{'err_download'});
	print $text{'getlic_log_dload'} if $lic_logging;
	&http_download_post($lic_host, $lic_port, $lic_page, \$out, \$error, undef, undef, undef, undef, $params);
	$error && &error("$error");
	print $text{'getlic_log_ok'} if $lic_logging;
	local ($ret_code, $ok, $msg, $license, $raw, $id);
	&print_debug("Raw Datas:<br><pre>$out</pre>");
	print $text{'getlic_log_parse'} if $lic_logging;
	local @lines = split("\n", $out);
	
	if (@lines) {
		if ($lines[0] =~ /^Error:\s*(.*)$/) {
			$ret_code = 2;
			$msg = $1;
		} else {
			$id = $lines[0];
			unless ($id =~ /^\S+$/) {
				$ret_code = 2;
				$msg = $lines[0];
			}
		}
	} else {
		$ret_code = 1;
	}
	$ok = (!$ret_code);
	$license = join("\n", @lines[1 .. scalar(@lines) - 1]) if $ok;
	print $text{'getlic_log_ok'} if $lic_logging;
	return { 'ok' => $ok, 'status' => $ret_code, 'id' => $id, 'msg' => $msg, 'license' => $license, 'raw' => $raw };
}

# ============================================================================================
# service functions
# ============================================================================================

# check_Net_SSLeay()
# Check if the Net::SSLeay Perl module are installed
sub check_Net_SSLeay {
	if (&foreign_available("cpan") && $no_net_ssleay) {
		local $urlmod = &urlize($perl_net_ssleay_module);
		print "<b>", &text('index_enonetssleay', $perl_net_ssleay_module), "</b><br>\n";
		print &text('index_netssleayinst', $text{'index_netssleay'}, $text{'programname'}, "/cpan/download.cgi?act=2&source=3&cpan=$urlmod&mode=2&return=/$module_name/&returndesc=".&urlize($text{'index_return'})) . "<br>\n";

		if (&foreign_check('swup')) {
			local $urlpkg = &urlize($perl_net_ssleay_swup);
			print &text('index_netssleayswup', $text{'index_netssleay'}, $text{'programname'}, "/swup/install_pkgs.cgi?pkg=$urlpkg&return=/$module_name/&returndesc=".&urlize($text{'index_return'})) . "<br>\n";
		}
		elsif (&foreign_check('software')) {
			&foreign_require("software", "software-lib.pl");
			local $lnk = &software::missing_install_link("perl-Net-SSLeay", $text{'index_netssleay'},
				"/$module_name/", $text{'index_title'});
			print $lnk,"<p>\n" if ($lnk);
		}
		return 1;
	}
	return 0;
}

# print_debug(msg)
# Prints debug messages
sub print_debug {
	print "$_[0]<hr>\n" if $debug;
}

# check_email_address(email)
# Checks E-Mail address
sub check_email_address {
	return ($_[0] =~ /^[a-z0-9._-]+@([a-z0-9_-]+\.)+(com|net|org|mil|edu|gov|arpa|info|inc|biz|name|[a-z]{2})$/i) ? 1 : 0;
}

# error_lic(msg, [&lic], [show header])
sub error_lic {
	local ($msg, $lic, $header) = @_;
	local $nolic = !$lic || $lic->{'ret'};
	&ui_print_header(undef, $text{'error'}, undef, undef, 0, 1, $nolic) if $header;
	print "<hr>\n";
	print "<h3>",($main::whatfailed ? "$main::whatfailed : " : ""), $_[0], "</h3>\n";
	print "<hr>\n";
	
	if ($nolic) {
		&ui_print_footer();
	}
	else {
		&ui_print_footer($text{'index_mainpage_url'}, $text{'index_mainpage'});
	}
	&unlock_all_files();
	exit;
}

1;
1;
