#!/usr/bin/perl
package lilo::Log_parser;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'lilo::Log_parser');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# log_parser.pl
# Functions for parsing this module's logs

&ModuleLoader::preload_module(ref($self), "lilo::LiloLib");
$self = new lilo::LiloLib:: ref($self), %$self; 
$self->foreign_require("mount", "mount-lib.pl");

1;
		return $self;
}

# parse_webmin_log(user, script, action, type, object, &params)
# Converts logged information from this module into human-readable form
sub parse_webmin_log
{
	my $self = shift;

local ($user, $script, $action, $type, $object, $p, $long) = @_;
local $ll = $long ? "_l" : "";
if ($type eq 'image') {
	return $self->text("log_${action}_image${ll}", "<tt>$object</tt>",
		     "<tt>".$self->html_escape($p->{'image'})."</tt>");
	}
elsif ($type eq 'other') {
	local $other = $self->foreign_call("mount", "device_name", $p->{'other'})
		if ($long);
	return $self->text("log_${action}_other${ll}", "<tt>$object</tt>", $other);
	}
elsif ($action eq 'apply') {
	return $self->{'text_hash'}->{'log_apply'};
	}
elsif ($action eq 'global') {
	return $self->{'text_hash'}->{'log_global'};
	}
else {
	return undef;
	}
}


1;

