#!/usr/bin/perl

&MAIN();

 sub MAIN {
# index.cgi
# Display all the boot partitions

&ModuleLoader::preload_module('lilo_class', "lilo::LiloLib");
$self = new lilo::LiloLib:: 'lilo_class',%$self;

$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", undef, 1, 1, 0,
	$self->help_search_link("lilo", "man", "doc", "howto"));

# Check for non-intel architecture
if (!$self->is_x86()) {
	print "<p>$self->{'text_hash'}->{'index_earch'}<p>\n";
	$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});
	exit;
	}

# Check if lilo.conf exists
if (!-r $self->{'config_hash'}->{'lilo_conf'}) {
	print "<p>",$self->text('index_econf',
			  "<tt>$self->{'config_hash'}->{'lilo_conf'}</tt>"),"<p>\n";
	$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});
	exit;
	}

# Get the lilo version
$self->{'out'} = `$self->{'config_hash'}->{'lilo_cmd'} -V 2>&1`;
if ($self->{'out'} =~ /lilo\s+version\s+([0-9\.]+)/i) {
	$self->{'lilo_version'} = $1;
	}
else {
	$self->{'lilo_version'} = 1;
	}
open(VERSION, ">$self->{'module_config_directory'}/version");
print VERSION $self->{'lilo_version'},"\n";
close(VERSION);

$self->{'conf'} = $self->get_lilo_conf();
@{$self->{'images_array'}} = sort { $a->{'index'} <=> $b->{'index'} }
	       ( $self->find("image", $self->{'conf'}), $self->find("other", $self->{'conf'}) );

$self->{'default'} = $self->find_value("default", $self->{'conf'});
foreach $i (@{$self->{'images_array'}}) {
	local $n = $i->{'name'};
	push(@{$self->{'icons_array'}}, $n eq "image" ? "images/image.gif" : "images/other.gif");
	$self->{'l'} = $self->find_value("label", $i->{'members'});
	push(@{$self->{'titles_array'}}, !$self->{'default'} && $i eq $self->{'images_array'}->[0] ? "<b>$self->{'l'}</b>" :
		      $self->{'default'} && $self->{'default'} eq $self->{'l'} ? "<b>$self->{'l'}</b>" : $self->{'l'});
	push(@{$self->{'links_array'}}, "edit_$n.cgi?idx=$i->{'index'}");
	}
print "<a href='edit_image.cgi?new=1'>$self->{'text_hash'}->{'index_addk'}</a> &nbsp;\n";
print "<a href='edit_other.cgi?new=1'>$self->{'text_hash'}->{'index_addp'}</a><br>\n";
$self->icons_table(\@{$self->{'links_array'}}, \@{$self->{'titles_array'}}, \@{$self->{'icons_array'}}, 4);
print "<a href='edit_image.cgi?new=1'>$self->{'text_hash'}->{'index_addk'}</a> &nbsp;\n";
print "<a href='edit_other.cgi?new=1'>$self->{'text_hash'}->{'index_addp'}</a><p>\n";
print "<hr>\n";

print "<table width=100%>\n";
print "<form action=edit_global.cgi>\n";
print "<tr><td><input type=submit value=\"$self->{'text_hash'}->{'index_global'}\"></td>\n";
print "<td>$self->{'text_hash'}->{'index_globalmsg'}</td></tr></form>\n";

%{$self->{'flang_hash'}} = $self->load_language('fdisk');
$self->{'text_hash'}->{'select_part'} = $self->{'flang_hash'}->{'select_part'};
$self->{'text_hash'}->{'select_device'} = $self->{'flang_hash'}->{'select_device'};
$self->{'text_hash'}->{'select_fd'} = $self->{'flang_hash'}->{'select_fd'};
$self->{'dev'} = $self->find_value("boot", $self->{'conf'});
print "<form action=apply.cgi>\n";
print "<tr><td><input type=submit value=\"$self->{'text_hash'}->{'index_apply'}\"></td> <td>\n";
if ($self->{'dev'}) {
	print $self->text('index_applymsg1',
	  $self->{'dev'} =~ /fd(\d+)$/ ? $self->text('select_fd', $1) :
	  $self->{'dev'} =~ /hd([a-z])(\d+)$/ ? $self->text('select_part', 'IDE', uc($1), $2) :
	  $self->{'dev'} =~ /sd([a-z])(\d+)$/ ? $self->text('select_part', 'SCSI', uc($1), $2) :
	  $self->{'dev'} =~ /hd([a-z])$/ ? $self->text('select_device', 'IDE', uc($1)) :
	  $self->{'dev'} =~ /sd([a-z])$/ ? $self->text('select_device', 'SCSI', uc($1)) : $self->{'dev'});
	}
else {
	print $self->{'text_hash'}->{'index_applymsg2'};
	}
print "\n",$self->{'text_hash'}->{'index_applymsg3'},"</td></tr></form>\n";
print "</table>\n";

$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});

1;
		
}


1;

