#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_image.cgi

&ModuleLoader::preload_module('lilo_class', "lilo::LiloLib");
$self = new lilo::LiloLib:: 'lilo_class',%$self;

$self->ReadParse();

$self->lock_file($self->{'config_hash'}->{'lilo_conf'});
$self->{'conf'} = $self->get_lilo_conf();
if ($self->{'in_hash'}->{'delete'}) {
	# deleting an existing image
	$self->{'image'} = $self->{'conf'}->[$self->{'in_hash'}->{'idx'}];
	$self->save_directive($self->{'conf'}, $self->{'image'});
	$self->flush_file_lines();
	$self->unlock_file($self->{'config_hash'}->{'lilo_conf'});
	$self->webmin_log("delete", "image",
		    $self->find_value("label", $self->{'image'}->{'members'}), \%{$self->{'in_hash'}});
	$self->redirect("");
	exit;
	}
elsif ($self->{'in_hash'}->{'new'}) {
	# creating a new kernel image
	$self->{'image'} = { 'name' => 'image',
		   'members' => [ ] };
	}
else {
	# updating an existing image
	$self->{'oldimage'} = $self->{'image'} = $self->{'conf'}->[$self->{'in_hash'}->{'idx'}];
	}

# Validate and store inputs
$self->{'in_hash'}->{'label'} =~ /\S+/ || $self->error($self->{'text_hash'}->{'image_ename'});
$self->save_subdirective($self->{'image'}, "label", $self->{'in_hash'}->{'label'});
$self->{'in_hash'}->{'optional'} || -r $self->{'in_hash'}->{'image'} ||
	$self->error($self->text('image_ekernel', $self->{'in_hash'}->{'image'}));
$self->{'image'}->{'value'} = $self->{'in_hash'}->{'image'};
if ($self->{'in_hash'}->{'opts'} == 0) {
	$self->save_subdirective($self->{'image'}, "append");
	$self->save_subdirective($self->{'image'}, "literal");
	}
elsif ($self->{'in_hash'}->{'opts'} == 1) {
	$self->save_subdirective($self->{'image'}, "append", "\"$self->{'in_hash'}->{'append'}\"");
	$self->save_subdirective($self->{'image'}, "literal");
	}
else {
	$self->save_subdirective($self->{'image'}, "append");
	$self->save_subdirective($self->{'image'}, "literal", "\"$self->{'in_hash'}->{'append'}\"");
	}
if ($self->{'in_hash'}->{'rmode'} == 0) {
	$self->save_subdirective($self->{'image'}, "root");
	}
elsif ($self->{'in_hash'}->{'rmode'} == 1) {
	$self->save_subdirective($self->{'image'}, "root", "current");
	}
elsif ($self->{'in_hash'}->{'rmode'} == 2) {
	$self->save_subdirective($self->{'image'}, "root", $self->{'in_hash'}->{'root'});
	}
if ($self->{'in_hash'}->{'initrd_def'}) {
	$self->save_subdirective($self->{'image'}, "initrd");
	}
else {
	-r $self->{'in_hash'}->{'initrd'} || $self->error($self->text('image_einitrd', $self->{'in_hash'}->{'initrd'}));
	$self->save_subdirective($self->{'image'}, "initrd", $self->{'in_hash'}->{'initrd'});
	}
$self->save_subdirective($self->{'image'}, "read-only", $self->{'in_hash'}->{'ro'} == 1 ? "" : undef);
$self->save_subdirective($self->{'image'}, "read-write", $self->{'in_hash'}->{'ro'} == 2 ? "" : undef);
if ($self->{'in_hash'}->{'vga'} eq "") {
	$self->save_subdirective($self->{'image'}, "vga");
	}
elsif ($self->{'in_hash'}->{'vga'} eq "other") {
	$self->{'in_hash'}->{'vgaother'} =~ /^\d+$/ ||
		$self->error("VGA text mode must be an integer");
	$self->save_subdirective($self->{'image'}, "vga", $self->{'in_hash'}->{'vgaother'});
	}
else {
	$self->save_subdirective($self->{'image'}, "vga", $self->{'in_hash'}->{'vga'});
	}
if ($self->{'in_hash'}->{'passmode'} == 0) {
	$self->save_subdirective($self->{'image'}, "password");
	}
else {
	$self->save_subdirective($self->{'image'}, "password", $self->{'in_hash'}->{'password'});
	}
$self->save_subdirective($self->{'image'}, "restricted", $self->{'in_hash'}->{'restricted'} ? "" : undef);
$self->save_subdirective($self->{'image'}, "lock", $self->{'in_hash'}->{'lock'} ? "" : undef);
$self->save_subdirective($self->{'image'}, "optional", $self->{'in_hash'}->{'optional'} ? "" : undef);

# Save the actual image structure
$self->save_directive($self->{'conf'}, $self->{'oldimage'}, $self->{'image'});
$self->flush_file_lines();
$self->unlock_file($self->{'config_hash'}->{'lilo_conf'});
$self->webmin_log($self->{'in_hash'}->{'new'} ? 'create' : 'modify', "image",
	    $self->find_value("label", $self->{'image'}->{'members'}), \%{$self->{'in_hash'}});
$self->redirect("");

1;
		
}


1;

