#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_log.cgi
# Show a form for creating or editing a log

&ModuleLoader::preload_module('logrotate_class', "logrotate::LogrotateLib");
$self = new logrotate::LogrotateLib:: 'logrotate_class',%$self;

$self->ReadParse();
$self->{'conf'} = $self->get_config();
if ($self->{'in_hash'}->{'global'}) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'global_title'}, "", "global");
	$self->{'lconf'} = $self->{'conf'};
	}
elsif ($self->{'in_hash'}->{'new'}) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'edit_title2'}, "", "create");
	}
else {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'edit_title1'}, "", "edit");
	$self->{'log'} = $self->{'conf'}->[$self->{'in_hash'}->{'idx'}];
	$self->{'lconf'} = $self->{'log'}->{'members'};
	}

print $self->ui_form_start("save_log.cgi", "post");
print $self->ui_hidden("new", $self->{'in_hash'}->{'new'}),"\n";
print $self->ui_hidden("idx", $self->{'in_hash'}->{'idx'}),"\n";
print $self->ui_hidden("global", $self->{'in_hash'}->{'global'}),"\n";

if (!$self->{'in_hash'}->{'global'}) {
	print $self->ui_table_start($self->{'text_hash'}->{'edit_header'}, "width=100%", 2);
	print $self->ui_table_row($self->{'text_hash'}->{'edit_file'},
			    $self->ui_textarea("file",
				join("\n", @{$self->{'log'}->{'name'}}), 3, 60)." ".
			    $self->file_chooser_button("file"));
	}
else {
	print $self->ui_table_start($self->{'text_hash'}->{'global_header'}, "width=100%", 2);
	}

$self->{'period'} = $self->get_period($self->{'lconf'});
$self->{'defperiod'} = $self->get_period($self->{'conf'}) if (!$self->{'in_hash'}->{'global'});
$self->{'dptext'} = $self->{'text_hash'}->{"period_".$self->{'defperiod'}} || $self->{'text_hash'}->{'period_never'};
print $self->ui_table_row($self->{'text_hash'}->{'edit_sched'},
		    $self->ui_select("sched", $self->{'period'},
				[ [ '', &deftext($self->{'dptext'})  ],
				  [ 'daily', $self->{'text_hash'}->{'period_daily'} ],
				  [ 'weekly', $self->{'text_hash'}->{'period_weekly'} ],
				  [ 'monthly', $self->{'text_hash'}->{'period_monthly'} ] ]));

$self->{'size'} = $self->find_value("size", $self->{'lconf'});
print $self->ui_table_row($self->{'text_hash'}->{'edit_size'},
		    $self->ui_opt_textbox("size", $self->{'size'}, 10,
				    &deftext(&find_default("size") ||
					     $self->{'text_hash'}->{'period_never'})));

print $self->ui_table_hr();

$self->{'rotate'} = $self->find_value("rotate", $self->{'lconf'});
print $self->ui_table_row($self->{'text_hash'}->{'edit_rotate'},
		    $self->ui_opt_textbox("rotate", $self->{'rotate'}, 5,
				    &deftext(&find_default("rotate"))));

&yesno_option("compress", "nocompress", $self->{'lconf'});
&yesno_option("delaycompress", "nodelaycompress", $self->{'lconf'});
&yesno_option("copytruncate", "nocopytruncate", $self->{'lconf'});
&yesno_option("ifempty", "notifempty", $self->{'lconf'});
&yesno_option("missingok", "nomissingok", $self->{'lconf'});

print $self->ui_table_hr();

$self->{'create'} = $self->find_value("create", $self->{'lconf'});
$self->{'nocreate'} = $self->find("nocreate", $self->{'lconf'});
($self->{'mode'}, $self->{'user'}, $self->{'group'}) = split(/\s+/, $self->{'create'});
$self->{'dcr'} = &find_default("create");
@{$self->{'crinputs_array'}} = ( "createmode", "createuser", "creategroup" );
print $self->ui_table_row($self->{'text_hash'}->{'edit_create'},
    $self->ui_radio("create", defined($self->{'create'}) ? 2 : $self->{'nocreate'} ? 1 : 0,
	      [ [ 2, $self->text('edit_createas',
		   $self->ui_textbox("createmode", $self->{'mode'}, 4, !defined($self->{'create'})),
		   $self->ui_user_textbox("createuser", $self->{'user'}, 0,
				    !defined($self->{'create'})),
		   $self->ui_group_textbox("creategroup", $self->{'group'}, 0,
				     !defined($self->{'create'})))."<br>",
		   $self->js_disable_inputs([ ], \@{$self->{'crinputs_array'}}, "onClick") ],
		[ 1, $self->{'text_hash'}->{'edit_createno'}."<br>",
		  $self->js_disable_inputs(\@{$self->{'crinputs_array'}}, [ ], "onClick") ],
		[ 0, &deftext($self->{'dcr'} ne '' ? $self->{'dcr'} :
		      defined($self->{'dcr'}) ? $self->{'text_hash'}->{'edit_createsame'} :
				$self->{'text_hash'}->{'edit_createno'}),
		  $self->js_disable_inputs(\@{$self->{'crinputs_array'}}, [ ], "onClick") ] ]));

$self->{'olddir'} = $self->find_value("olddir", $self->{'lconf'});
$self->{'noolddir'} = $self->find("noolddir", $self->{'lconf'});
print $self->ui_table_row($self->{'text_hash'}->{'edit_olddir'},
    $self->ui_radio("olddir", $self->{'olddir'} ? 2 : $self->{'noolddir'} ? 1 : 0,
	      [ [ 2, $self->{'text_hash'}->{'edit_olddirto'}." ".
		     $self->ui_textbox("olddirto", $self->{'olddir'}, 30, !$self->{'olddir'})." ".
		     $self->file_chooser_button("olddirto", 1)."<br>",
		  $self->js_disable_inputs([ ], [ "olddirto" ], "onClick") ],
		[ 1, $self->{'text_hash'}->{'edit_olddirsame'}."<br>",
		  $self->js_disable_inputs([ "olddirto" ], [ ], "onClick") ],
		[ 0, &deftext(&find_default("olddir") ||
			      $self->{'text_hash'}->{'edit_olddirsame'}),
		  $self->js_disable_inputs([ "olddirto" ], [ ], "onClick") ] ]));

$self->{'ext'} = $self->find_value("extension", $self->{'lconf'});
print $self->ui_table_row($self->{'text_hash'}->{'edit_ext'},
    $self->ui_opt_textbox("ext", $self->{'ext'}, 10,
		    &deftext(&find_default("ext"))));

print $self->ui_table_hr();

$self->{'mail'} = $self->find_value("mail", $self->{'lconf'});
$self->{'nomail'} = $self->find("nomail", $self->{'lconf'});
print $self->ui_table_row($self->{'text_hash'}->{'edit_mail'},
	    $self->ui_radio("mail", $self->{'mail'} ? 2 : $self->{'nomail'} ? 1 : 0,
		      [ [ 2, $self->{'text_hash'}->{'edit_mailto'}." ".
			     $self->ui_textbox("mailto", $self->{'mail'}, 30, $self->{'mail'} != 2)."<br>",
			     $self->js_disable_inputs([ ], [ "mailto" ], "onClick") ],
			[ 1, $self->{'text_hash'}->{'edit_mailno'}."<br>",
			  $self->js_disable_inputs([ "mailto" ], [ ], "onClick") ],
			[ 0, &deftext(&find_default("mail") ||
				      $self->{'text_hash'}->{'edit_mailno'}),
			  $self->js_disable_inputs([ "mailto" ], [ ], "onClick") ] ]));

$self->{'mailfirst'} = $self->find("mailfirst", $self->{'lconf'});
$self->{'maillast'} = $self->find("maillast", $self->{'lconf'});
print $self->ui_table_row($self->{'text_hash'}->{'edit_mailfl'},
		    $self->ui_radio("mailfirst", $self->{'mailfirst'} ? 2 : $self->{'maillast'} ? 1 : 0,
			      [ [ 2, $self->{'text_hash'}->{'edit_mailfirst'}."<br>" ],
				[ 1, $self->{'text_hash'}->{'edit_maillast'}."<br>" ],
				[ 0, &deftext(defined(
					&find_default("mailfirst")) ?
						$self->{'text_hash'}->{'edit_mailfirst'} :
						$self->{'text_hash'}->{'edit_maillast'}) ] ]));

if ($self->get_logrotate_version() < 3.6) {
	$self->{'errors'} = $self->find_value("errors", $self->{'lconf'});
	print $self->ui_table_row($self->{'text_hash'}->{'edit_errors'},
			    $self->ui_opt_textbox("errors", $self->{'errors'}, 30,
				    &deftext(&find_default("errors") ||
					     $self->{'text_hash'}->{'edit_errorsno'})."<br>",
				    $self->{'text_hash'}->{'edit_errorsto'}));
	}

print $self->ui_table_hr();

$self->{'pre'} = $self->find_value("prerotate", $self->{'lconf'});
print $self->ui_table_row($self->{'text_hash'}->{'edit_pre'},
		    $self->ui_textarea("pre", $self->{'pre'}, 3, 60));

$self->{'post'} = $self->find_value("postrotate", $self->{'lconf'});
print $self->ui_table_row($self->{'text_hash'}->{'edit_post'},
		    $self->ui_textarea("post", $self->{'post'}, 3, 60));

if ($self->get_logrotate_version() >= 3.4) {
	&yesno_option("sharedscripts", "nosharedscripts", $self->{'lconf'});
	}

print $self->ui_table_end();
if ($self->{'in_hash'}->{'global'}) {
	print $self->ui_form_end([ [ 'save', $self->{'text_hash'}->{'save'} ] ], "100%");
	}
elsif ($self->{'in_hash'}->{'new'}) {
	print $self->ui_form_end([ [ 'create', $self->{'text_hash'}->{'create'} ] ], "100%");
	}
else {
	print $self->ui_form_end([ [ 'save', $self->{'text_hash'}->{'save'} ],
			     [ 'now', $self->{'text_hash'}->{'edit_now'} ],
			     [ 'delete', $self->{'text_hash'}->{'delete'} ] ], "100%");
	}

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}

# yesno_option(name1, name2, &conf)
sub yesno_option
{
	shift if ($self == $_[0]);

local $y = $self->find($_[0], $_[2]);
local $n = $self->find($_[1], $_[2]);
local $yd = &find_default($_[0]);
local $nd = &find_default($_[1]);
print $self->ui_table_row($self->{'text_hash'}->{'edit_'.$_[0]},
		    $self->ui_radio($_[0], $y ? 2 : $n ? 1 : 0,
			      [ [ 2, $self->{'text_hash'}->{'yes'} ],
			 	[ 1, $self->{'text_hash'}->{'no'} ],
			 	[ 0, &deftext(defined($yd) ? $self->{'text_hash'}->{'yes'} : $self->{'text_hash'}->{'no'}) ] ]), 1);
}

# find_default(name, [global])
sub find_default
{
	shift if ($self == $_[0]);

if ($self->{'in_hash'}->{'global'} || $_[1]) {
	# Return global hard-coded default
	return $self->{'global_default_hash'}->{$_[0]};
	}
else {
	# Look at global first
	local $rv = $self->find_value($_[0], $self->{'conf'});
	return $rv if (defined($rv));
	return &find_default($_[0], 1);
	}
}

sub deftext
{
	shift if ($self == $_[0]);

return $_[0] ? $self->text('edit_default', $_[0]) : $self->{'text_hash'}->{'default'};
}


1;

