#!/usr/bin/perl

&MAIN();

 sub MAIN {
# index.cgi
# Show all logs that are being rotated

&ModuleLoader::preload_module('logrotate_class', "logrotate::LogrotateLib");
$self = new logrotate::LogrotateLib:: 'logrotate_class',%$self;


# Make sure config file and program exists
if (!$self->has_command($self->{'config_hash'}->{'logrotate'})) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", "intro", 1, 1);
	print $self->ui_config_link('index_ecmd',
		        [ "<tt>$self->{'config_hash'}->{'logrotate'}</tt>", undef ]),"<p>\n";

	$self->foreign_require("software", "software-lib.pl");
	$self->{'lnk'} = $main::software_object->missing_install_link(
			"logrotate", $self->{'text_hash'}->{'index_logrotate'},
			"../$self->{'module_name'}/", $self->{'text_hash'}->{'index_title'});
	print $self->{'lnk'},"<p>\n" if ($self->{'lnk'});

	$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});
	exit;
	}
if (!-r $self->{'config_hash'}->{'logrotate_conf'} && -r $self->{'config_hash'}->{'sample_conf'}) {
	# No .. but a sample does. Use it
	system("cp $self->{'config_hash'}->{'sample_conf'} $self->{'config_hash'}->{'logrotate_conf'}");
	}
if (!-r $self->{'config_hash'}->{'logrotate_conf'}) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", "intro", 1, 1);
	$self->ui_print_endpage(
		$self->ui_config_link('index_econf',
			[ "<tt>$self->{'config_hash'}->{'logrotate_conf'}</tt>", undef ]));
	}

# Get the version
$self->{'logrotate_version'} = $self->get_logrotate_version(\$self->{'out'});
if (!$self->{'logrotate_version'}) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", "intro", 1, 1);
	$self->ui_print_endpage(
		$self->text('index_eversion', "<tt>$self->{'config_hash'}->{'logrotate'} -v</tt>",
		      "<pre>$self->{'out'}</pre>"));
	}
$self->open_tempfile(VERSION, ">$self->{'module_config_directory'}/version");
$self->print_tempfile(VERSION, "$self->{'logrotate_version'}\n");
$self->close_tempfile(VERSION);
$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", "intro", 1, 1, 0,
		 $self->help_search_link("logrotate", "man", "doc", "google"),
		 undef, undef,
		 $self->text('index_version', $self->{'logrotate_version'}));

# Show table of log files
$self->{'conf'} = $self->get_config();
$self->{'defp'} = $self->get_period($self->{'conf'});
foreach $c ($self->{'config_hash'}->{'sort_mode'} ?
	     (sort { $a->{'name'}->[0] cmp $b->{'name'}->[0] } @{$self->{'conf'}}) :
	     @{$self->{'conf'}}) {
	if ($c->{'members'}) {
		local $p = $self->get_period($c->{'members'}) || $self->{'defp'};
		local $r = $self->find_value("postrotate", $c->{'members'});
		$r =~ s/\n/<br>\n/g;
		push(@{$self->{'table_array'}}, [ "<a href='edit_log.cgi?idx=$c->{'index'}'>".
			       join(" ", map { "<tt>$_</tt><br>" }
					     @{$c->{'name'}})."</a>",
			       $self->{'text_hash'}->{'period_'.$p} ||
				"<i>$self->{'text_hash'}->{'index_notset'}</i>",
			       $r ? "<tt><font size=-1>$r</font></tt>"
				  : "<i>$self->{'text_hash'}->{'index_nocmd'}</i>" ]);
		push(@{$self->{'tablelogs_array'}}, $c);
		}
	}
if (@{$self->{'table_array'}}) {
	print $self->ui_form_start("delete_logs.cgi", "post");
	@{$self->{'links_array'}} = ( $self->select_all_link("d"),
		   $self->select_invert_link("d"),
		   "<a href='edit_log.cgi?new=1'>$self->{'text_hash'}->{'index_add'}</a>" );
	print $self->ui_links_row(\@{$self->{'links_array'}});
	@{$self->{'tds_array'}} = ( "width=5", "nowrap valign=top", "valign=top", "valign=top" );
	print $self->ui_columns_start([ "",
				  $self->{'text_hash'}->{'index_file'},
			    	  $self->{'text_hash'}->{'index_period'},
			    	  $self->{'text_hash'}->{'index_post'} ], 100, 0, \@{$self->{'tds_array'}});
	$self->{'i'} = 0;
	foreach $r (@{$self->{'table_array'}}) {
		print $self->ui_checked_columns_row($r, \@{$self->{'tds_array'}}, "d",
					      $self->{'tablelogs_array'}->[$self->{'i'}]->{'index'});
		$self->{'i'}++;
		}
	print $self->ui_columns_end();
	print $self->ui_links_row(\@{$self->{'links_array'}});
	print $self->ui_form_end([ [ "delete", $self->{'text_hash'}->{'index_delete'} ] ]);
	}
else {
	print "<p><b>$self->{'text_hash'}->{'index_none'}</b><p>\n";
	print "<a href='edit_log.cgi?new=1'>$self->{'text_hash'}->{'index_add'}</a><p>\n";
	}

# Show buttons for editing global config and scheduling
print "<hr>\n";
print $self->ui_buttons_start();
print $self->ui_buttons_row("edit_log.cgi", $self->{'text_hash'}->{'index_global'},
		      $self->{'text_hash'}->{'index_globaldesc'},
		      $self->ui_hidden("global", 1));
print $self->ui_buttons_row("edit_sched.cgi", $self->{'text_hash'}->{'index_sched'},
		      $self->{'text_hash'}->{'index_scheddesc'});
print $self->ui_buttons_row("force.cgi", $self->{'text_hash'}->{'index_force'},
		      $self->{'text_hash'}->{'index_forcedesc'});
print $self->ui_buttons_end();

$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});

1;
		
}


1;

