#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_log.cgi
# Update, create or delete a log, or global settings

&ModuleLoader::preload_module('logrotate_class', "logrotate::LogrotateLib");
$self = new logrotate::LogrotateLib:: 'logrotate_class',%$self;

$self->ReadParse();
$self->{'parent'} = $self->get_config_parent();
$self->{'conf'} = $self->{'parent'}->{'members'};
if ($self->{'in_hash'}->{'global'}) {
	# Editing the global options
	$self->{'log'} = $self->{'parent'};
	}
elsif ($self->{'in_hash'}->{'new'}) {
	# Adding a new section
	$self->{'log'} = { 'members' => [ ],
		 'file' => $self->get_add_file() };
	$self->{'logfile'} = $self->{'in_hash'}->{'file'};
	}
else {
	# Editing a section
	$self->{'oldlog'} = $self->{'log'} = $self->{'conf'}->[$self->{'in_hash'}->{'idx'}];
	$self->{'logfile'} = $self->{'oldlog'}->{'name'};
	}

if ($self->{'in_hash'}->{'delete'}) {
	# Just delete this log entry
	$self->lock_file($self->{'log'}->{'file'});
	$self->save_directive($self->{'parent'}, $self->{'log'}, undef);
	}
elsif ($self->{'in_hash'}->{'now'}) {
	# Rotate log immediately
	$self->ui_print_header(undef, $self->{'text_hash'}->{'force_title'}, "");

	print $self->{'text_hash'}->{'force_doingone'},"\n";
	($self->{'ex'}, $self->{'out'}) = $self->rotate_log_now($self->{'log'});
	print "<pre>$self->{'out'}</pre>";
	if ($?) {
		print $self->{'text_hash'}->{'force_failed'},"<br>\n";
		}
	else {
		print $self->{'text_hash'}->{'force_done'},"<br>\n";
		}

	$self->webmin_log("force", $self->{'logfile'});
	$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
	exit;
	}
else {
	# Validate and store inputs
	$self->lock_file($self->{'log'}->{'file'});
	$self->error_setup($self->{'text_hash'}->{'save_err'});
	if (!$self->{'in_hash'}->{'global'}) {
		@{$self->{'files_array'}} = split(/\s+/, $self->{'in_hash'}->{'file'});
		foreach $f (@{$self->{'files_array'}}) {
			$f =~ /^\/\S+$/ || $self->error($self->{'text_hash'}->{'save_efile'});
			}
		$self->{'in_hash'}->{'file'} =~ s/\r//g;
		$self->{'log'}->{'name'} = [ split(/\n/, $self->{'in_hash'}->{'file'}) ];
		}

	foreach $period ("daily", "weekly", "monthly") {
		$self->save_directive($self->{'log'}, $period,
				$self->{'in_hash'}->{'sched'} eq $period ? "" : undef);
		}

	$self->{'in_hash'}->{'size_def'} || $self->{'in_hash'}->{'size'} =~ /^\d+[kM]?$/ ||
		$self->error($self->{'text_hash'}->{'save_esize'});
	$self->save_directive($self->{'log'}, "size", $self->{'in_hash'}->{'size_def'} ? undef : $self->{'in_hash'}->{'size'});

	$self->{'in_hash'}->{'rotate_def'} || $self->{'in_hash'}->{'rotate'} =~ /^\d+$/ ||
		$self->error($self->{'text_hash'}->{'save_erotate'});
	$self->save_directive($self->{'log'}, "rotate", $self->{'in_hash'}->{'rotate_def'} ? undef
							    : $self->{'in_hash'}->{'rotate'});

	&parse_yesno("compress", "nocompress", $self->{'log'});
	&parse_yesno("delaycompress", "nodelaycompress", $self->{'log'});
	&parse_yesno("copytruncate", "nocopytruncate", $self->{'log'});
	&parse_yesno("ifempty", "notifempty", $self->{'log'});
	&parse_yesno("missingok", "nomissingok", $self->{'log'});

	if ($self->{'in_hash'}->{'create'} == 2) {
		$self->error($self->{'text_hash'}->{'save_emust1'}) if ($self->{'in_hash'}->{'createuser'} ne '' &&
						   $self->{'in_hash'}->{'createmode'} eq '');
		$self->error($self->{'text_hash'}->{'save_emust2'}) if ($self->{'in_hash'}->{'creategroup'} ne '' &&
						   $self->{'in_hash'}->{'createuser'} eq '');
		$self->{'in_hash'}->{'createmode'} eq '' ||
		    $self->{'in_hash'}->{'createmode'} =~ /^[0-7]{3,4}$/ ||
			$self->error($self->{'text_hash'}->{'save_ecreatemode'});
		$self->{'in_hash'}->{'createuser'} eq '' ||
		    defined(getpwnam($self->{'in_hash'}->{'createuser'})) ||
			$self->error($self->{'text_hash'}->{'save_ecreateuser'});
		$self->{'in_hash'}->{'creategroup'} eq '' ||
		    defined(getgrnam($self->{'in_hash'}->{'creategroup'})) ||
			$self->error($self->{'text_hash'}->{'save_ecreategroup'});
		$self->save_directive($self->{'log'}, "create",
				$self->{'in_hash'}->{'createmode'}." ".
				$self->{'in_hash'}->{'createuser'}." ".$self->{'in_hash'}->{'creategroup'});
		$self->save_directive($self->{'log'}, "nocreate");
		}
	elsif ($self->{'in_hash'}->{'create'} == 1) {
		$self->save_directive($self->{'log'}, "create");
		$self->save_directive($self->{'log'}, "nocreate", "");
		}
	elsif ($self->{'in_hash'}->{'create'} == 0) {
		$self->save_directive($self->{'log'}, "create");
		$self->save_directive($self->{'log'}, "nocreate");
		}

	if ($self->{'in_hash'}->{'olddir'} == 2) {
		-d $self->{'in_hash'}->{'olddirto'} || $self->error($self->{'text_hash'}->{'save_eolddirto'});
		$self->save_directive($self->{'log'}, "olddir", $self->{'in_hash'}->{'olddirto'});
		$self->save_directive($self->{'log'}, "noolddir");
		}
	elsif ($self->{'in_hash'}->{'olddir'} == 1) {
		$self->save_directive($self->{'log'}, "olddir");
		$self->save_directive($self->{'log'}, "noolddir", "");
		}
	elsif ($self->{'in_hash'}->{'olddir'} == 0) {
		$self->save_directive($self->{'log'}, "olddir");
		$self->save_directive($self->{'log'}, "noolddir");
		}

	$self->{'in_hash'}->{'ext_def'} || $self->{'in_hash'}->{'ext'} =~ /^\S+$/ ||
		$self->error($self->{'text_hash'}->{'save_eext'});
	$self->save_directive($self->{'log'}, "extension", $self->{'in_hash'}->{'ext_def'} ? undef : $self->{'in_hash'}->{'ext'});

	if ($self->{'in_hash'}->{'mail'} == 2) {
		$self->{'in_hash'}->{'mailto'} =~ /^\S+$/ || $self->error($self->{'text_hash'}->{'save_emailto'});
		$self->save_directive($self->{'log'}, "mail", $self->{'in_hash'}->{'mailto'});
		$self->save_directive($self->{'log'}, "nomail");
		}
	elsif ($self->{'in_hash'}->{'mail'} == 1) {
		$self->save_directive($self->{'log'}, "mail");
		$self->save_directive($self->{'log'}, "nomail", "");
		}
	elsif ($self->{'in_hash'}->{'mail'} == 0) {
		$self->save_directive($self->{'log'}, "mail");
		$self->save_directive($self->{'log'}, "nomail");
		}

	&parse_yesno("mailfirst", "maillast", $self->{'log'});

	if (defined($self->{'in_hash'}->{'errors'})) {
		$self->{'in_hash'}->{'errors_def'} || $self->{'in_hash'}->{'errors'} =~ /^\S+$/ ||
			$self->error($self->{'text_hash'}->{'save_eerrors'});
		$self->save_directive($self->{'log'}, "errors", $self->{'in_hash'}->{'errors_def'} ? undef
							  : $self->{'in_hash'}->{'errors'});
		}

	if ($self->{'in_hash'}->{'pre'} =~ /\S/) {
		$self->{'in_hash'}->{'pre'} =~ s/\r//g;
		&has_endscript($self->{'in_hash'}->{'pre'}) && $self->error($self->{'text_hash'}->{'save_epre'});
		$self->save_directive($self->{'log'}, "prerotate",
				{ "name" => "prerotate",
				  "script" => $self->{'in_hash'}->{'pre'} });
		}
	else {
		$self->save_directive($self->{'log'}, "prerotate");
		}

	if ($self->{'in_hash'}->{'post'} =~ /\S/) {
		$self->{'in_hash'}->{'post'} =~ s/\r//g;
		&has_endscript($self->{'in_hash'}->{'post'}) && $self->error($self->{'text_hash'}->{'save_epost'});
		$self->save_directive($self->{'log'}, "postrotate",
				{ "name" => "postrotate",
				  "script" => $self->{'in_hash'}->{'post'} });
		}
	else {
		$self->save_directive($self->{'log'}, "postrotate");
		}

	if ($self->get_logrotate_version() >= 3.4) {
		&parse_yesno("sharedscripts", "nosharedscripts", $self->{'log'});
		}

	if (!$self->{'in_hash'}->{'global'}) {
		# Save or create the actual log entry
		$self->save_directive($self->{'parent'}, $self->{'oldlog'}, $self->{'log'});
		}
	}

$self->flush_file_lines();
$self->delete_if_empty($self->{'log'}->{'file'}) if ($self->{'in_hash'}->{'delete'});
$self->unlock_file($self->{'log'}->{'file'});
$self->webmin_log($self->{'in_hash'}->{'delete'} ? "delete" : $self->{'in_hash'}->{'new'} ? "create" : "modify",
	    $self->{'in_hash'}->{'global'} ? "global" : "log", $self->{'logfile'});

$self->redirect("");

1;
		
}

# parse_yesno(yesvalue, novalue, &conf)
sub parse_yesno
{
	shift if ($self == $_[0]);

local $d0 = $self->find($_[0], $_[2]->{'members'});
local $d1 = $self->find($_[1], $_[2]->{'members'});
if ($self->{'in_hash'}->{$_[0]} == 2 && !$d0) {
	# Adding or replacing 'yes' value
	$self->save_directive($_[2], $d1 || $_[0],
			{ 'name' => $_[0], 'value' => '' });
	}
elsif ($self->{'in_hash'}->{$_[0]} == 1 && !$d1) {
	# Adding or replacing 'no' value
	$self->save_directive($_[2], $d0 || $_[1],
			{ 'name' => $_[1], 'value' => '' });
	}
elsif ($self->{'in_hash'}->{$_[0]} == 0) {
	$self->save_directive($_[2], $_[0]);
	$self->save_directive($_[2], $_[1]);
	}
}

sub has_endscript
{
	shift if ($self == $_[0]);

local $l;
foreach $l (split(/\n/, $_[0])) {
	return 1 if ($l =~ /^\s*(endscript|endrotate)\s*$/);
	}
return 0;
}


1;

