#!/usr/bin/perl
package lpadmin::Irixdriver;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'lpadmin::Irixdriver');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# irix-driver.pl
# Functions for webmin print and smb drivers.
# Very similar to the webmin driver, but with a different interface
# program selector

$self->{'webmin_windows_driver'} = 1;
$self->{'webmin_print_driver'} = 1;

1;

1;
		return $self;
}

# is_windows_driver(path)
# Returns a driver structure if some path is a windows driver
sub is_windows_driver
{
	my $self = shift;

return $self->is_webmin_windows_driver(@_);
}

# is_driver(path)
# Returns a structure containing the details of a driver
sub is_driver
{
	my $self = shift;

return $self->is_webmin_driver(@_);
}

# create_windows_driver(&printer, &driver)
# Creates a new windows printer driver
sub create_windows_driver
{
	my $self = shift;

return $self->create_webmin_windows_driver(@_);
}

# create_driver(&printer, &driver)
# Creates a new local printer driver and returns the path
sub create_driver
{
	my $self = shift;

return $self->create_webmin_driver(@_);
}

# delete_driver(name)
sub delete_driver
{
	my $self = shift;

$self->delete_webmin_driver(@_);
}

# driver_input(&printer, &driver)
sub driver_input
{
	my $self = shift;

local ($prn, $drv) = @_;

printf "<tr> <td><input type=radio name=drv value=0 %s> %s</td>\n",
	$drv->{'mode'} == 0 ? "checked" : "", $self->{'text_hash'}->{'webmin_none'};
print "<td>($self->{'text_hash'}->{'webmin_remotemsg'})</td> </tr>\n";

printf "<tr> <td><input type=radio name=drv value=2 %s> %s</td>\n",
	$drv->{'mode'} == 2 ? "checked" : "", $self->{'text_hash'}->{'webmin_model'};
print "<td><select name=iface>\n";
opendir(DIR, $self->{'config_hash'}->{'model_path'});
while($self->{'f'} = readdir(DIR)) {
	if ($self->{'f'} =~ /^\./) { next; }
	$self->{'path'} = "$self->{'config_hash'}->{'model_path'}/$self->{'f'}";
	printf "<option value=\"$self->{'path'}\" %s>$self->{'f'}\n",
		$self->{'path'} eq $self->{'prn_hash'}->{'iface'} ? "selected" : "";
	}
closedir(DIR);
print "</select></td> </tr>\n";

if ($self->has_ghostscript()) {
	local $out = `$self->{'config_hash'}->{'gs_path'} -help 2>&1`;
	if ($out =~ /Available devices:\n((\s+.*\n)+)/) {
		print "<tr> <td valign=top>\n";
		printf "<input type=radio name=drv value=1 %s>\n",
			$drv->{'mode'} == 1 ? "checked" : "";
		print "$self->{'text_hash'}->{'webmin_driver'}</td> <td valign=top>";
		foreach $d (split(/\s+/, $1)) { $self->{'drvsupp_hash'}->{$d}++; }
		print "<select name=driver size=7>\n";
		foreach $d ($self->list_webmin_drivers()) {
			if ($self->{'drvsupp_hash'}->{$d->[0]}) {
				printf "<option %s>%s\n",
				    $d->[1] eq $drv->{'type'} ? "selected" : "",
				    $d->[1];
				}
			}
		print "</select>&nbsp;&nbsp;";
		print "<select name=dpi size=7>\n";
		printf "<option value=\"\" %s>Default\n",
			$drv->{'dpi'} ? "" : "selected";
		foreach $d (75, 100, 150, 200, 300, 600) {
			printf "<option value=\"$d\" %s>$d DPI\n",
				$drv->{'dpi'} == $d ? "selected" : "";
			}
		print "</select></td> </tr>\n";
		}
	else {
		print "<tr> <td colspan=2>",
		      $self->text('webmin_edrivers', "<tt>$self->{'config_hash'}->{'gs_path'}</tt>"),
		      "</td> </tr>\n";
		}
	}
else {
	print "<tr> <td colspan=2>",
	      $self->text('webmin_egs', "<tt>$self->{'config_hash'}->{'gs_path'}</tt>"),
	      "</td> </tr>\n";
	}
return undef;
}

# parse_driver()
# Parse driver selection from %{$self->{'in_hash'}} and return a driver structure
sub parse_driver
{
	my $self = shift;

if ($self->{'in_hash'}->{'drv'} == 0) {
	return { 'mode' => 0 };
	}
elsif ($self->{'in_hash'}->{'drv'} == 2) {
	(-x $self->{'in_hash'}->{'iface'}) || $self->error("'$self->{'in_hash'}->{'iface'}' does not exist");
	return { 'mode' => 2,
		 'program' => $self->{'in_hash'}->{'iface'} };
	}
elsif ($self->{'in_hash'}->{'drv'} == 1) {
	return { 'mode' => 1,
		 'type' => $self->{'in_hash'}->{'driver'},
		 'dpi' => $self->{'in_hash'}->{'dpi'} };
	}
}


1;

