#!/usr/bin/perl
package lpadmin::Log_parser;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'lpadmin::Log_parser');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# log_parser.pl
# Functions for parsing this module's logs

&ModuleLoader::preload_module(ref($self), "lpadmin::LpadminLib");
$self = new lpadmin::LpadminLib:: ref($self), %$self; 

1;
		return $self;
}

# parse_webmin_log(user, script, action, type, object, &params)
# Converts logged information from this module into human-readable form
sub parse_webmin_log
{
	my $self = shift;

local ($user, $script, $action, $type, $object, $p, $long) = @_;
if ($action eq 'cancel') {
	return $self->text("log_cancel_${type}",
		     "<tt>".$self->html_escape($object)."</tt>",
		     "<tt>".$self->html_escape($p->{'id'})."</tt>");
	}
elsif ($action eq 'stop') {
	return $self->{'text_hash'}->{'log_stop'};
	}
elsif ($action eq 'start') {
	return $self->{'text_hash'}->{'log_start'};
	}
elsif ($action eq 'restart') {
	return $self->{'text_hash'}->{'log_restart'};
	}
elsif ($type eq 'printer') {
	return $self->text($long && $p->{'mode'} ? "log_${action}_l" : "log_$action",
		     "<tt>$object</tt>",
		     "<tt>".$self->html_escape($p->{'dest'})."</tt>",
		     $self->html_escape($p->{'driver'}));
	}
else {
	return undef;
	}
}


1;

