#!/usr/bin/perl
package lpadmin::LpadminLib;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'lpadmin::LpadminLib');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# lpadmin-lib.pl
# Functions for configuring and adding printers

&ModuleLoader::preload_module(ref($self), "WebLib");
$self = new WebLib:: ref($self), %$self; 
$self->init_config();
&ModuleLoader::preload_module(ref($self), "UiLib");
$self = new UiLib:: ref($self), %$self; 
{
    my $pkg = $self->lib_to_pkg("$self->{config_hash}->{print_style}-lib.pl", "lpadmin");
    &ModuleLoader::preload_module(ref($self), "$pkg");
    $pkg .= '::';
    eval "\$self = new $pkg ref(\$self),\%\$self;"; 
}
if ($self->{'config_hash'}->{'driver_style'}) {
	{
    my $pkg = $self->lib_to_pkg("$self->{config_hash}->{driver_style}-driver.pl", "lpadmin");
    &ModuleLoader::preload_module(ref($self), "$pkg");
    $pkg .= '::';
    eval "\$self = new $pkg ref(\$self),\%\$self;"; 
}
	}
else {
	&ModuleLoader::preload_module(ref($self), "lpadmin::Webmindriver");
$self = new lpadmin::Webmindriver:: ref($self), %$self; 
	}
%{$self->{'access_hash'}} = $self->get_module_acl();

$self->{'drivers_directory'} = "$self->{'module_config_directory'}/drivers";

1;

1;
		return $self;
}

# dev_name(file)
sub dev_name
{
	my $self = shift;

local($i);
for($i=0; $i<@{$self->{'device_files_array'}}; $i++) {
	if ($self->{'device_files_array'}->[$i] eq $_[0]) { return $self->{'device_names_array'}->[$i]; }
	}
return $_[0];
}

# has_ghostscript()
# Does this system have ghostscript installed?
sub has_ghostscript
{
	my $self = shift;

return $self->has_command($self->{'config_hash'}->{'gs_path'});
}

# has_smbclient()
# Does this system have smbclient installed?
sub has_smbclient
{
	my $self = shift;

return $self->has_command($self->{'config_hash'}->{'smbclient_path'});
}

# has_hpnp()
# Does this system have hpnp installed?
sub has_hpnp
{
	my $self = shift;

return $self->has_command($self->{'config_hash'}->{'hpnp_path'});
}

# create_webmin_driver(&printer, &driver)
# lpadmin drivers are files in /etc/webmin/lpadmin/drivers. Each is a
# dynamically generated shell script which calls GS
sub create_webmin_driver
{
	my $self = shift;

# check for non-driver
if ($_[1]->{'mode'} == 0) {
	return undef;
	}
elsif ($_[1]->{'mode'} == 2) {
	return $_[1]->{'program'};
	}

local($drv, $d, $gsdrv, $res, $perl);
$self->lock_file($self->{'drivers_directory'});
mkdir($self->{'drivers_directory'}, 0755);
$self->unlock_file($self->{'drivers_directory'});
$drv = "$self->{'drivers_directory'}/$_[0]->{'name'}";

# Find ghostscript driver
if ($_[1]->{'mode'} == 3) {
	$gsdrv = 'uniprint';
	}
else {
	foreach $d ($self->list_webmin_drivers()) {
		if ($d->[1] eq $_[1]->{'type'}) {
			$gsdrv = $d->[0];
			}
		}
	}

# Create script to call GS
$self->open_lock_tempfile(DRV, ">$drv");
$self->print_tempfile(DRV, "#!/bin/sh\n");
$self->print_tempfile(DRV, "# Name: $_[0]->{'name'}\n");
$self->print_tempfile(DRV, "# Type: ",$_[1]->{'upp'} ? 'uniprint'
					       : $_[1]->{'type'},"\n");
$self->print_tempfile(DRV, "# DPI: ",$_[1]->{'upp'} ? $_[1]->{'upp'}
					      : $_[1]->{'dpi'},"\n");
if ($self->{'gconfig_hash'}->{'ld_env'}) {
	$self->print_tempfile(DRV, "$self->{'gconfig_hash'}->{'ld_env'}=$self->{'gconfig_hash'}->{'ld_path'}\n");
	}
$self->print_tempfile(DRV, "PATH=$self->{'gconfig_hash'}->{'path'}\n");
if ($self->{'config_hash'}->{'gs_fontpath'}) {
	$self->print_tempfile(DRV, "GS_FONTPATH=$self->{'config_hash'}->{'gs_fontpath'}\n");
	}
if ($self->{'config_hash'}->{'gs_lib'}) {
	$self->print_tempfile(DRV, "GS_LIB=$self->{'config_hash'}->{'gs_lib'}\n");
	}
$self->print_tempfile(DRV, "export $self->{'gconfig_hash'}->{'ld_env'} PATH GS_FONTPATH GS_LIB\n");
$res = $_[1]->{'upp'} ? "\@$_[1]->{'upp'}.upp" :
       $_[1]->{'dpi'} ? "-r$_[1]->{'dpi'}" : "";
$perl = $self->get_perl_path();
if ($self->{'config_hash'}->{'iface_arg'}) {
	for($i=0; $i<$self->{'config_hash'}->{'iface_arg'}-1; $i++) {
		$self->print_tempfile(DRV, "shift\n");
		}
	$self->print_tempfile(DRV, "cat \$* | $perl -e 'while(<STDIN>) { print if (!/^\\s*#####/); }' >/tmp/\$\$.gsin\n");
	}
else {
	$self->print_tempfile(DRV, "$perl -e 'while(<STDIN>) { print if (!/^\\s*#####/); }' >/tmp/\$\$.gsin\n");
	}
$self->print_tempfile(DRV, "$self->{'config_hash'}->{'gs_path'} -sOutputFile=/tmp/\$\$.gs -dSAFER -sDEVICE=$gsdrv $res -dNOPAUSE /tmp/\$\$.gsin </dev/null >/dev/null 2>&1\n");
$self->print_tempfile(DRV, "rm /tmp/\$\$.gsin\n");
$self->print_tempfile(DRV, "cat /tmp/\$\$.gs\n");
$self->print_tempfile(DRV, "rm /tmp/\$\$.gs\n");
$self->close_tempfile(DRV);
if ($self->{'config_hash'}->{'iface_owner'}) {
	$self->system_logged("chown '$self->{'config_hash'}->{'iface_owner'}' '$drv' >/dev/null 2>&1");
	}
$self->system_logged("chmod '$self->{'config_hash'}->{'iface_perms'}' '$drv' >/dev/null 2>&1");
return $drv;
}

# create_webmin_windows_driver(&printer, &driver)
# Create an interface program that can print to a remote windows printer
# using some printer driver
sub create_webmin_windows_driver
{
	my $self = shift;

local($drv, $prog);
$self->lock_file($self->{'drivers_directory'});
mkdir($self->{'drivers_directory'}, 0755);
$self->unlock_file($self->{'drivers_directory'});
$drv = "$self->{'drivers_directory'}/$_[0]->{'name'}.smb";

# Create script to call smbclient
$self->open_lock_tempfile(DRV, ">$drv");
$self->print_tempfile(DRV, "#!/bin/sh\n");
$self->print_tempfile(DRV, "# Name: $_[0]->{'name'}\n");
$self->print_tempfile(DRV, "# Server: $_[1]->{'server'}\n");
$self->print_tempfile(DRV, "# Share: $_[1]->{'share'}\n");
$self->print_tempfile(DRV, "# User: $_[1]->{'user'}\n");
$self->print_tempfile(DRV, "# Password: $_[1]->{'pass'}\n");
$self->print_tempfile(DRV, "# Workgroup: $_[1]->{'workgroup'}\n");
$self->print_tempfile(DRV, "# Program: $_[1]->{'program'}\n");
if ($self->{'gconfig_hash'}->{'ld_env'}) {
	$self->print_tempfile(DRV, "$self->{'gconfig_hash'}->{'ld_env'}=$self->{'gconfig_hash'}->{'ld_path'}\n");
	}
$self->print_tempfile(DRV, "PATH=$self->{'gconfig_hash'}->{'path'}\n");
$self->print_tempfile(DRV, "export $self->{'gconfig_hash'}->{'ld_env'} PATH\n");
if (!$_[1]->{'program'}) {
	if ($self->{'config_hash'}->{'iface_arg'}) {
		for($i=0; $i<$self->{'config_hash'}->{'iface_arg'}-1; $i++) {
			$self->print_tempfile(DRV, "shift\n");
			}
		$self->print_tempfile(DRV, "cat \$* >/tmp/\$\$.smb\n");
		}
	else { $self->print_tempfile(DRV, "cat >/tmp/\$\$.smb\n"); }
	}
else {
	$self->print_tempfile(DRV, "$_[1]->{'program'} \"\$1\" \"\$2\" \"\$3\" \"\$4\" ",
		  "\"\$5\" \"\$6\" \"\$7\" \"\$8\" \"\$9\" ",
		  "\"\$10\" \"\$11\" \"\$12\" \"\$13\" >/tmp/\$\$.smb\n");
	$self->system_logged("chmod a+rx '$_[1]->{'program'}'");
	}
$self->print_tempfile(DRV, "$self->{'config_hash'}->{'smbclient_path'} '//$_[1]->{'server'}/$_[1]->{'share'}' ",
	  $_[1]->{'pass'} ? $_[1]->{'pass'} : "-N",
	  $_[1]->{'user'} ? " -U $_[1]->{'user'}" : "",
	  $_[1]->{'workgroup'} ? " -W $_[1]->{'workgroup'}" : "",
	  " -c \"print /tmp/\$\$.smb\" -P\n");
$self->print_tempfile(DRV, "rm /tmp/\$\$.smb\n");
$self->close_tempfile(DRV);
if ($self->{'config_hash'}->{'iface_owner'}) {
	$self->system_logged("chown '$self->{'config_hash'}->{'iface_owner'}' '$drv' >/dev/null 2>&1");
	}
$self->system_logged("chmod '$self->{'config_hash'}->{'iface_perms'}' '$drv' >/dev/null 2>&1");
return $drv;
}

# create_hpnp_driver(&printer, &driver)
# Create an interface program that can print to a hpnp server using some
# interface program
sub create_hpnp_driver
{
	my $self = shift;

local($drv, $prog);
$self->lock_file($self->{'drivers_directory'});
mkdir($self->{'drivers_directory'}, 0755);
$self->unlock_file($self->{'drivers_directory'});
$drv = "$self->{'drivers_directory'}/$_[0]->{'name'}.hpnp";

# Create script to call hpnp
$self->open_lock_tempfile(DRV, ">$drv");
$self->print_tempfile(DRV, "#!/bin/sh\n");
$self->print_tempfile(DRV, "# Name: $_[0]->{'name'}\n");
$self->print_tempfile(DRV, "# Server: $_[1]->{'server'}\n");
$self->print_tempfile(DRV, "# Port: $_[1]->{'port'}\n");
$self->print_tempfile(DRV, "# Program: $_[1]->{'program'}\n");
if ($self->{'gconfig_hash'}->{'ld_env'}) {
	$self->print_tempfile(DRV, "$self->{'gconfig_hash'}->{'ld_env'}=$self->{'gconfig_hash'}->{'ld_path'}\n");
	}
$self->print_tempfile(DRV, "PATH=$self->{'gconfig_hash'}->{'path'}\n");
$self->print_tempfile(DRV, "export $self->{'gconfig_hash'}->{'ld_env'} PATH\n");
if (!$_[1]->{'program'}) {
	if ($self->{'config_hash'}->{'iface_arg'}) {
		for($i=0; $i<$self->{'config_hash'}->{'iface_arg'}-1; $i++) {
			$self->print_tempfile(DRV, "shift\n");
			}
		$self->print_tempfile(DRV, "cat \$* >/tmp/\$\$.hpnp\n");
		}
	else { $self->print_tempfile(DRV, "cat >/tmp/\$\$.hpnp\n"); }
	}
else {
	$self->print_tempfile(DRV, "$_[1]->{'program'} \"\$1\" \"\$2\" \"\$3\" \"\$4\" ",
		  "\"\$5\" \"\$6\" \"\$7\" \"\$8\" \"\$9\" ",
		  "\"\$10\" \"\$11\" \"\$12\" \"\$13\" >/tmp/\$\$.hpnp\n");
	$self->system_logged("chmod a+rx '$_[1]->{'program'}'");
	}
$self->print_tempfile(DRV, "$self->{'config_hash'}->{'hpnp_path'} -x $_[1]->{'server'}",
	  $_[1]->{'port'} ? " -p $_[1]->{'port'}" : "",
	  " /tmp/\$\$.hpnp\n");
$self->print_tempfile(DRV, "rm /tmp/\$\$.hpnp\n");
$self->close_tempfile(DRV);
if ($self->{'config_hash'}->{'iface_owner'}) {
	$self->system_logged("chown $self->{'config_hash'}->{'iface_owner'} $drv >/dev/null 2>&1");
	}
$self->system_logged("chmod '$self->{'config_hash'}->{'iface_perms'}' '$drv' >/dev/null 2>&1");
$self->unlock_file($drv);
return $drv;
}

# is_webmin_driver(path)
# Returns a structure of driver information
sub is_webmin_driver
{
	my $self = shift;

local($l, $i, $u, $desc);
if (!$_[0]) {
	return { 'mode' => 0,
		 'desc' => 'None' };
	}
if ($self->has_ghostscript()) {
	open(DRV, $_[0]);
	for($i=0; $i<4; $i++) { $l .= <DRV>; }
	close(DRV);
	if ($l =~ /# Name: (.*)\n# Type: (.*)\n# DPI: (.*)\n/) {
		if ($2 eq 'uniprint') {
			local $upp = $3;
			foreach $u ($self->list_uniprint()) {
				$desc = $u->[1] if ($u->[0] eq $upp);
				}
			$desc =~ s/,.*$//;
			return { 'mode' => 3,
				 'upp' => $upp,
				 'desc' => $desc ? $desc : $upp };
			}
		else {
			return { 'type' => $2,
				 'dpi' => $3,
				 'mode' => 1,
				 'desc' => $3 ? "$2 ($3 DPI)" : $2 };
			}
		}
	}
return { 'desc' => $_[0],
	 'prog' => $_[0],
	 'mode' => 2 };
}

# is_webmin_windows_driver(path)
# Returns a structure containing information about a windows driver, or undef
# Returns the server, share, username, password, workgroup, program
# if path is a webmin windows driver
sub is_webmin_windows_driver
{
	my $self = shift;

local($i, $l);
if (!$self->has_smbclient()) { return undef; }
open(DRV, $_[0]);
for($i=0; $i<8; $i++) { $l .= <DRV>; }
close(DRV);
if ($l =~ /# Name: (.*)\n# Server: (.*)\n# Share: (.*)\n# User: (.*)\n# Password: (.*)\n# Workgroup: (.*)\n# Program: (.*)\n/) {
	return { 'server' => $2,
		 'share' => $3,
		 'user' => $4,
		 'pass' => $5,
		 'workgroup' => $6,
		 'program' => $7 };
	}
elsif ($l =~ /# Name: (.*)\n# Server: (.*)\n# Share: (.*)\n# User: (.*)\n# Password: (.*)\n# Program: (.*)\n/) {
	return { 'server' => $2,
		 'share' => $3,
		 'user' => $4,
		 'pass' => $5,
		 'program' => $7 };
	}
else { return undef; }
}

# delete_webmin_driver(name)
# Delete the drivers for some printer
sub delete_webmin_driver
{
	my $self = shift;

$self->lock_file("$self->{'drivers_directory'}/$_[0]");
$self->lock_file("$self->{'drivers_directory'}/$_[0].smb");
$self->lock_file("$self->{'drivers_directory'}/$_[0].hpnp");
unlink("$self->{'drivers_directory'}/$_[0]");
unlink("$self->{'drivers_directory'}/$_[0].smb");
unlink("$self->{'drivers_directory'}/$_[0].hpnp");
$self->unlock_file("$self->{'drivers_directory'}/$_[0]");
$self->unlock_file("$self->{'drivers_directory'}/$_[0].smb");
$self->unlock_file("$self->{'drivers_directory'}/$_[0].hpnp");
}

# is_hpnp_driver(path, &printer)
# Returns a structure of hpnp details if path is a webmin hpnp driver
sub is_hpnp_driver
{
	my $self = shift;

local($i, $l);
if (!$self->has_hpnp()) { return undef; }
open(DRV, $_[0]);
for($i=0; $i<5; $i++) { $l .= <DRV>; }
close(DRV);
if ($l =~ /# Name: (.*)\n# Server: (.*)\n# Port: (.*)\n# Program: (.*)\n/) {
	return { 'server' => $2,
		 'port' => $3,
		 'program' => $4 };
	}
else { return undef; }
}

# webmin_driver_input(&printer, &driver)
sub webmin_driver_input
{
	my $self = shift;

local ($prn, $drv) = @_;

printf "<tr> <td><input type=radio name=drv value=0 %s> %s</td>\n",
	$drv->{'mode'} == 0 ? "checked" : "", $self->{'text_hash'}->{'webmin_none'};
print "<td>($self->{'text_hash'}->{'webmin_nonemsg'})</td> </tr>\n";

printf "<tr> <td><input type=radio name=drv value=2 %s> %s</td>\n",
	$drv->{'mode'} == 2 ? "checked" : "", $self->{'text_hash'}->{'webmin_prog'};
printf "<td><input name=iface value=\"%s\" size=35></td> </tr>\n",
	$drv->{'mode'} == 2 ? $drv->{'prog'} : "";

if ($self->has_ghostscript()) {
	local $out = `$self->{'config_hash'}->{'gs_path'} -help 2>&1`;
	if ($out =~ /Available devices:\n((\s+.*\n)+)/i) {
		print "<tr> <td valign=top>\n";
		printf "<input type=radio name=drv value=1 %s>\n",
			$drv->{'mode'} == 1 ? "checked" : "";
		print "$self->{'text_hash'}->{'webmin_driver'}</td> <td valign=top>";
		foreach $d (split(/\s+/, $1)) { $self->{'drvsupp_hash'}->{$d}++; }
		print "<select name=driver size=7>\n";
		foreach $d ($self->list_webmin_drivers()) {
			if ($self->{'drvsupp_hash'}->{$d->[0]}) {
				printf "<option value='%s' %s>%s&nbsp;&nbsp;&nbsp;(%s)\n",
				    $d->[1],
				    $d->[1] eq $drv->{'type'} ? "selected" : "",
				    $d->[1], $d->[0];
				}
			}
		print "</select>&nbsp;&nbsp;";
		print "<select name=dpi size=7>\n";
		printf "<option value=\"\" %s>Default\n",
			$drv->{'dpi'} ? "" : "selected";
		foreach $d (75, 100, 150, 200, 300, 600, 720, 1440) {
			printf "<option value=\"$d\" %s>$d DPI\n",
				$drv->{'dpi'} == $d ? "selected" : "";
			}
		print "</select></td> </tr>\n";

		if ($self->{'drvsupp_hash'}->{'uniprint'}) {
			print "<tr> <td valign=top>\n";
			printf "<input type=radio name=drv value=3 %s>\n",
				$drv->{'mode'} == 3 ? "checked" : "";
			print "$self->{'text_hash'}->{'webmin_uniprint'}</td> <td valign=top>";
			print "<select name=uniprint size=5>\n";
			foreach $u ($self->list_uniprint()) {
				printf "<option value=%s %s>%s\n",
				    $u->[0],
				    $u->[0] eq $drv->{'upp'} ? 'selected' : '',
				    $u->[1];
				}
			print "</select></td> </tr>\n";
			}
		}
	else {
		print "<tr> <td colspan=2>",
		      $self->text('webmin_edrivers', "<tt>$self->{'config_hash'}->{'gs_path'}</tt>"),
		      "</td> </tr>\n";
		}
	}
elsif ($self->{'config_hash'}->{'gs_path'}) {
	print "<tr> <td colspan=2>",
	      $self->text('webmin_egs', "<tt>$self->{'config_hash'}->{'gs_path'}</tt>"),
	      "</td> </tr>\n";
	}
return undef;
}

# parse_webmin_driver()
# Parse driver selection from %{$self->{'in_hash'}} and return a driver structure
sub parse_webmin_driver
{
	my $self = shift;

if ($self->{'in_hash'}->{'drv'} == 0) {
	return { 'mode' => 0 };
	}
elsif ($self->{'in_hash'}->{'drv'} == 2) {
	(-x $self->{'in_hash'}->{'iface'}) || $self->error($self->text('webmin_edriver', $self->{'in_hash'}->{'iface'}));
	return { 'mode' => 2,
		 'program' => $self->{'in_hash'}->{'iface'} };
	}
elsif ($self->{'in_hash'}->{'drv'} == 1) {
	return { 'mode' => 1,
		 'type' => $self->{'in_hash'}->{'driver'},
		 'dpi' => $self->{'in_hash'}->{'dpi'} };
	}
elsif ($self->{'in_hash'}->{'drv'} == 3) {
	return { 'mode' => 3,
		 'upp' => $self->{'in_hash'}->{'uniprint'} };
	}
}

# list_webmin_drivers()
sub list_webmin_drivers
{
	my $self = shift;

local(@rv, $_);
open(DRIVERS, "$self->{'module_root_directory'}/drivers");
while(<DRIVERS>) {
	/^(\S+)\s+(.*)/;
	push(@rv, [ $1, $2 ]);
	}
close(DRIVERS);
return @rv;
}

# can_edit_printer(printer)
sub can_edit_printer
{
	my $self = shift;

foreach $p (split(/\s+/, $self->{'access_hash'}->{'printers'})) {
	return 1 if ($p eq '*' || $p eq $_[0]);
	}
return 0;
}

# can_edit_jobs(printer, user)
sub can_edit_jobs
{
	my $self = shift;

local $rv = 0;
if ($self->{'access_hash'}->{'cancel'} == 1) {
	$rv = 1;
	}
elsif ($self->{'access_hash'}->{'cancel'} == 0) {
	$rv = 0;
	}
else {
	foreach $p (split(/\s+/, $self->{'access_hash'}->{'jobs'})) {
		$rv = 1 if ($p eq $_[0]);
		}
	}
if ($rv) {
	if ($self->{'access_hash'}->{'user'} eq '*') {
		return 1;
		}
	elsif ($self->{'access_hash'}->{'user'} eq $_[1]) {
		return 1;
		}
	elsif (!$self->{'access_hash'}->{'user'} && $self->{'remote_user'} eq $_[1]) {
		return 1;
		}
	}
return 0;
}

# list_uniprint()
# Returns a list of uniprint drivers support by the installed ghostscript
sub list_uniprint
{
	my $self = shift;

local (@rv, $f, $d);
local $out = `$self->{'config_hash'}->{'gs_path'} -help 2>&1`;
if ($out =~ /Search path:\n((\s+.*\n)+)/i) {
	foreach $d (split(/\s+/, $1)) {
		next if ($d !~ /^\//);
		opendir(DIR, $d);
		while($f = readdir(DIR)) {
			next if ($f !~ /^(.*)\.upp$/);
			local $upp = $1;
			open(UPP, "$d/$f");
			local $line = <UPP>;
			close(UPP);
			next if ($line !~ /upModel="(.*)"/i);
			push(@rv, [ $upp, $1 ]);
			}
		closedir(DIR);
		}
	}
return sort { $a->[0] cmp $b->[0] } @rv;
}

sub log_info
{
	my $self = shift;

local ($drv, $wdrv, $hdrv);
if (!$self->{'webmin_windows_driver'}) {
	$wdrv = $self->is_webmin_windows_driver($_[0]->{'iface'}, $_[0]);
	}
$wdrv = $self->is_windows_driver($_[0]->{'iface'}, $_[0]) if (!$wdrv);
$hdrv = $self->is_hpnp_driver($_[0]->{'iface'}, $_[0]);
local $iface = $wdrv ? $wdrv->{'program'} :
	       $hdrv ? $hdrv->{'program'} : $_[0]->{'iface'};

if (!$self->{'webmin_print_driver'}) {
	$drv = $self->is_webmin_driver($iface, $_[0]);
	}
$drv = $self->is_driver($iface, $_[0])
	if ($drv->{'mode'} == 0 || $drv->{'mode'} == 2);
$drv->{'desc'} =~ s/\([^\)]+\)$//;

return { 'driver' => $drv->{'desc'},
	 'mode' => $drv->{'mode'},
	 'dest' => $wdrv ? "\\\\$wdrv->{'server'}\\$wdrv->{'share'}" :
		   $hdrv ? "HPNP $hdrv->{'server'}:$hdrv->{'port'}" :
		   $_[0]->{'rhost'} ? "$_[0]->{'rhost'}:$_[0]->{'rqueue'}" :
		   $_[0]->{'dhost'} ? "$_[0]->{'dhost'}:$_[0]->{'dport'}" :
		   $self->dev_name($_[0]->{'dev'}) };
}

# parse_cups_ppd(file)
# Converts a CUPS-style .ppd file into a hash of names and values
sub parse_cups_ppd
{
	my $self = shift;

local %ppd;
if ($_[0] =~ /\.gz$/) {
	open(PPD, "gunzip -c '$_[0]' |");
	}
else {
	open(PPD, $_[0]);
	}
while(<PPD>) {
	if (/^\s*\*(\S+):\s*"(.*)"/ || /^\s*\*(\S+):\s*(\S+)/) {
		$ppd{$1} = $2;
		}
	elsif (/^\s*\*(\S+)\s+(\S+)\/([^:]+):/) {
		$ppd{$1}->{$2} = $3 if (!defined($ppd{$1}->{$2}));
		}
	}
close(PPD);
return \%ppd;
}

# list_cluster_servers()
# Returns a list of servers on which printers are managed
sub list_cluster_servers
{
	my $self = shift;

$self->foreign_require("servers", "servers-lib.pl");
local %ids = map { $_, 1 } split(/\s+/, $self->{'config_hash'}->{'servers'});
return grep { $ids{$_->{'id'}} } $main::servers_object->list_servers();
}

# add_cluster_server(&server)
sub add_cluster_server
{
	my $self = shift;

local @sids = split(/\s+/, $self->{'config_hash'}->{'servers'});
$self->{'config_hash'}->{'servers'} = join(" ", @sids, $_[0]->{'id'});
$self->save_module_config();
}

# delete_cluster_server(&server)
sub delete_cluster_server
{
	my $self = shift;

local @sids = split(/\s+/, $self->{'config_hash'}->{'servers'});
$self->{'config_hash'}->{'servers'} = join(" ", grep { $_ != $_[0]->{'id'} } @sids);
$self->save_module_config();
}

# server_name(&server)
sub server_name
{
	my $self = shift;

return $_[0]->{'desc'} ? $_[0]->{'desc'} : $_[0]->{'host'};
}

# save_printer_cluster(new, &printer, &driver, &connection, webmin-driver, mode)
# Creates or updates the specified printer on all cluster hosts, and returns a
# list of error messages
sub save_on_cluster
{
	my $self = shift;

return ( ) if (!$self->{'config_hash'}->{'servers'});
local ($new, $prn, $drv, $conn, $webmin, $mode) = @_;
$self->remote_error_setup(\&slave_error_handler);
local $slave;
local @slaveerrs;
foreach $slave ($self->list_cluster_servers()) {
	# Connect to server
        $self->{'slave_error'} = undef;
        $self->remote_foreign_require($slave, "lpadmin", "lpadmin-lib.pl");
        if ($self->{'slave_error'}) {
                push(@slaveerrs, [ $slave, $self->{'slave_error'} ]);
                next;
                }

	# Create the driver and the printer
	local $err = $self->remote_foreign_call($slave,
		"lpadmin", "save_printer_and_driver",
		$new, $prn, $drv, $conn, $webmin, $mode);
	if ($self->{'slave_error'}) {
                push(@slaveerrs, [ $slave, $self->{'slave_error'} ]);
		}
	elsif ($err == 1) {
		push(@slaveerrs, [ $slave, $self->text('save_edup', $prn->{'name'}) ]);
		}
	elsif ($err == 2) {
		push(@slaveerrs, [ $slave, $self->{'text_hash'}->{'save_evalid'} ]);
		}
	elsif ($err == 3) {
		push(@slaveerrs, [ $slave, $self->text('save_egone', $prn->{'name'}) ]);
		}
	}
return @slaveerrs;
}

# delete_on_cluster(&printer)
# Deletes the specified printer on all cluster hosts, and returns a list of
# error messages.
sub delete_on_cluster
{
	my $self = shift;

return ( ) if (!$self->{'config_hash'}->{'servers'});
local ($prn) = @_;
$self->remote_error_setup(\&slave_error_handler);
local $slave;
local @slaveerrs;
foreach $slave ($self->list_cluster_servers()) {
	# Connect to server
        $self->{'slave_error'} = undef;
        $self->remote_foreign_require($slave, "lpadmin", "lpadmin-lib.pl");
        if ($self->{'slave_error'}) {
                push(@slaveerrs, [ $slave, $self->{'slave_error'} ]);
                next;
                }

	# Call the delete function
	local $err = $self->remote_foreign_call($slave,
		"lpadmin", "delete_printer_and_driver", $prn);
	if ($self->{'slave_error'}) {
                push(@slaveerrs, [ $slave, $self->{'slave_error'} ]);
		}
	elsif ($err == 3) {
		push(@slaveerrs, [ $slave, $self->text('save_egone', $prn->{'name'}) ]);
		}
	}
return @slaveerrs;
}

# save_printer_and_driver(new, &printer, &driver, &connection, webmin-driver, mode)
# Attempts to setup or modify a printer and driver. Returns 0 if OK, 1 if the
# printer already exists, 2 if some print system error occurred, or 3 if it
# doesn't exist but should.
sub save_printer_and_driver
{
	my $self = shift;

local ($new, $prn, $drv, $conn, $webmin, $mode) = @_;
if ($new && $self->get_printer($prn->{'name'})) {
	return 1;
	}
elsif (!$new && !$self->get_printer($prn->{'name'})) {
	return 2;
	}
local $dfunc = $webmin ? \&create_webmin_driver : 'create_driver';
if ($mode <= 2 || $mode == 5) {
	# Device, file or LPR host
	$prn->{'iface'} = $self->$dfunc($prn, $drv);
	}
elsif ($mode == 3) {
	# Windows server
	$prn->{'dev'} = "/dev/null";
	$prn->{'iface'} = $webmin ? $self->create_webmin_windows_driver($prn, $conn)
				  : $self->create_windows_driver($prn, $conn);
	}
elsif ($mode == 4) {
	# HPNP server
	$prn->{'dev'} = "/dev/null";
	$prn->{'iface'} = $self->create_hpnp_driver($prn, $conn);
	}

# Call os-specific validation function
if ($self->UNIVERSAL::can('validate_printer')) {
	local $err = $self->validate_printer($prn);
	return 2 if ($err);
	}

# Actually create or update it
if ($new) {
	$self->create_printer($prn);
	}
else {
	$self->modify_printer($prn);
	}
$self->system_logged("$self->{'config_hash'}->{'apply_cmd'} >/dev/null 2>&1 </dev/null")
	if ($self->{'config_hash'}->{'apply_cmd'});
return 0;
}

# delete_printer_and_driver(&printer)
# Deletes a printer, returning 1 if it could not be found, or 0 if everything
# went OK.
sub delete_printer_and_driver
{
	my $self = shift;

local ($prn) = @_;
$self->delete_printer($prn->{'name'});
$self->delete_driver($prn->{'name'});
$self->delete_webmin_driver($prn->{'name'});
}

sub slave_error_handler
{
	my $self = shift;

$self->{'slave_error'} = $_[0];
}

# delete_from_acls(name)
# Remove some named printer from all ACLs
sub delete_from_acls
{
	my $self = shift;

local ($name) = @_;
local $wusers;
$self->read_acl(undef, \%wusers);
foreach my $u (keys %wusers) {
	my %uaccess = $self->get_module_acl($u);
	if ($uaccess{'printers'} ne '*') {
		$uaccess{'printers'} =
			join(' ', grep { $_ ne $name }
				  split(/\s+/, $uaccess{'printers'}));
		$self->save_module_acl(\%uaccess, $u);
		}
	}
}


1;

