#!/usr/bin/perl
package lpadmin::Redhatdriver;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'lpadmin::Redhatdriver');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# redhat-driver.pl
# Functions for printer drivers as created by redhat

%{$self->{'paper_sizes_hash'}} = ( 'a4', 'A4',
		 'a3', 'A3',
		 'letter', 'US Letter',
		 'legal', 'Legal',
		 'ledger', 'Ledger' );
$self->{'rhs_drivers_file'} = "/usr/lib/rhs/rhs-printfilters/printerdb";
$self->{'base_driver'} = "/usr/lib/rhs/rhs-printfilters/master-filter";
$self->{'smb_driver'} = "/usr/lib/rhs/rhs-printfilters//smbprint";
$self->{'ncp_driver'} = "/usr/lib/rhs/rhs-printfilters//ncpprint";

1;

1;
		return $self;
}

# is_windows_driver(path, %driver)
# Returns a driver structure if some path is a windows driver
sub is_windows_driver
{
	my $self = shift;

local $sd = "$self->{'config_hash'}->{'spool_dir'}/$_[1]->{'name'}";
if (($_[0] eq $self->{'smb_driver'} || $_[0] eq "$sd/filter") && -r "$sd/.config" &&
    $_[1]->{'comment'} =~ /^##PRINTTOOL3##\s+SMB/) {
	# Looks like a redhat SMB driver
	local %sconfig;
	$self->read_env_file("$sd/.config", \%sconfig);
	$sconfig{'share'} =~ /^\\\\(.*)\\(.*)$/;
	return { 'server' => $1,
		 'share' => $2,
		 'user' => $sconfig{'user'},
		 'pass' => $sconfig{'password'},
		 'workgroup' => $sconfig{'workgroup'},
		 'program' => $_[0] eq "$sd/filter" ? "$sd/filter" : undef };
	}
return undef;
}

# is_driver(path, &printer)
# Returns a structure containing the details of a driver
sub is_driver
{
	my $self = shift;

if (!$_[0]) {
	return { 'mode' => 0,
		 'desc' => "$self->{'text_hash'}->{'redhat_none'}" };
	}
local $sd = "$self->{'config_hash'}->{'spool_dir'}/$_[1]->{'name'}";
if ($_[0] eq "$sd/filter" &&
    $_[1]->{'comment'} =~ /^##PRINTTOOL3##\s+(LOCAL|REMOTE|SMB)\s+(\S+)\s+(\S+)\s+(\S+)\s+\S+\s+(\S+)\s+(\S+)\s+/) {
	# Looks like a redhat driver ..
	local ($r, $rhs);
	foreach $r ($self->read_rhs_drivers()) {
		$rhs = $r if ($r->{'name'} eq $5);
		}
	local (%general, %postscript, %textonly);
	$self->read_env_file("$sd/general.cfg", \%general);
	$self->read_env_file("$sd/postscript.cfg", \%postscript);
	$self->read_env_file("$sd/textonly.cfg", \%textonly);
	return { 'mode' => 1,
		 'gsdevice' => $postscript{'GSDEVICE'},
		 'res' => $postscript{'RESOLUTION'},
		 'paper' => $postscript{'PAPERSIZE'},
		 'gsopts' => $postscript{'EXTRA_GS_OPTIONS'},
		 'eof' => lc($textonly{'TEXT_SEND_EOF'}),
		 'nup' => $postscript{'NUP'},
		 'hmargin' => $postscript{'RTLFTMAR'},
		 'vmargin' => $postscript{'TOPBOTMAR'},
		 'crlf' => $textonly{'CRLFTRANS'},
		 'bpp' => $postscript{'COLOR'} =~ /-dBitsPerPixel=(\d+)/ ? $1
				: $postscript{'COLOR'},
		 'rhsname' => $rhs->{'name'},
		 'desc' => $rhs->{'desc'} };
	}
else {
	# Some other kind of driver
	return { 'mode' => 2,
		 'file' => $_[0],
		 'desc' => $_[0] };
	}
}

# create_windows_driver(&printer, &driver)
# Creates a new windows printer driver
sub create_windows_driver
{
	my $self = shift;

local $sd = "$self->{'config_hash'}->{'spool_dir'}/$_[0]->{'name'}";

# Create the config file and driver
local %sconfig;
$self->read_env_file("$sd/.config", \%sconfig);
$sconfig{'share'} = "\\\\$_[1]->{'server'}\\$_[1]->{'share'}";
$sconfig{'hostip'} = $_[1]->{'server'} eq $self->{'config_hash'}->{'hostip'} ?
			$sconfig{'hostip'} : undef;
$sconfig{'user'} = $_[1]->{'user'};
$sconfig{'password'} = $_[1]->{'pass'};
$sconfig{'workgroup'} = $_[1]->{'workgroup'};
$self->lock_file($sd);
mkdir($sd, 0755);
$self->unlock_file($sd);
$self->open_lock_tempfile(ENV, ">$sd/.config");
$self->print_tempfile(ENV, "share='$sconfig{'share'}'\n");
$self->print_tempfile(ENV, "hostip=$sconfig{'hostip'}\n");
$self->print_tempfile(ENV, "user='$sconfig{'user'}'\n");
$self->print_tempfile(ENV, "password='$sconfig{'password'}'\n");
$self->print_tempfile(ENV, "workgroup='$sconfig{'workgroup'}'\n");
$self->close_tempfile(ENV);

# Setup the comment and return the driver
local $drv = $self->is_driver($_[1]->{'program'}, $_[0]);
if ($drv->{'mode'} == 1) {
	local %general;
	$self->lock_file("$sd/general.cfg");
	$self->read_env_file("$sd/general.cfg", \%general);
	$general{'PRINTER_TYPE'} = 'SMB';
	$self->write_env_file("$sd/general.cfg", \%general, 1);
	$self->unlock_file("$sd/general.cfg");
	$_[0]->{'comment'} =~ s/\s+LOCAL\s+/ SMB /;
	return $_[1]->{'program'};
	}
else {
	$_[0]->{'comment'} = "##PRINTTOOL3## SMB";
	return $self->{'smb_driver'};
	}
}

# create_driver(&printer, &driver)
# Creates a new local printer driver and returns the path
sub create_driver
{
	my $self = shift;

local ($prn, $drv) = @_;
if ($drv->{'mode'} == 0) {
	$prn->{'comment'} =
		join(" ", "##PRINTTOOL3##",
			  $prn->{'rhost'} ? "REMOTE" : "LOCAL");
	return undef;
	}
elsif ($drv->{'mode'} == 2) {
	$prn->{'comment'} =
		join(" ", "##PRINTTOOL3##",
			  $prn->{'rhost'} ? "REMOTE" : "LOCAL");
	return $drv->{'file'};
	}
else {
	if (!-d $self->{'config_hash'}->{'spool_dir'}) {
		$self->lock_file($self->{'config_hash'}->{'spool_dir'});
		mkdir($self->{'config_hash'}->{'spool_dir'}, 0755);
		$self->unlock_file($self->{'config_hash'}->{'spool_dir'});
		$self->system_logged("chown $self->{'config_hash'}->{'iface_owner'} $self->{'config_hash'}->{'spool_dir'}");
		}
	local $sd = "$self->{'config_hash'}->{'spool_dir'}/$_[0]->{'name'}";

	# create the config files
	local (%general, %postscript, %textonly);
	$self->lock_file("$sd/general.cfg");
	$self->lock_file("$sd/postscript.cfg");
	$self->lock_file("$sd/textonly.cfg");
	$self->read_env_file("$sd/general.cfg", \%general);
	$self->read_env_file("$sd/postscript.cfg", \%postscript);
	$self->read_env_file("$sd/textonly.cfg", \%textonly);
	if (!%general) {
		# setup for the first time..
		%general = ( 'DESIRED_TO', 'ps',
			     'ASCII_TO_PS', 'NO' );
		}
	$general{'PAPERSIZE'} = $drv->{'paper'};
	$general{'PRINTER_TYPE'} = $_[0]->{'rhost'} ? "REMOTE" : "LOCAL";
	$postscript{'GSDEVICE'} = $drv->{'gsdevice'};
	$postscript{'RESOLUTION'} = $drv->{'res'} ? $drv->{'res'} : "NAxNA";
	$postscript{'COLOR'} = $drv->{'bpp'} =~ /^\d+$/ ?
			"-dBitsPerPixel=$drv->{'bpp'}" : $drv->{'bpp'};
	$postscript{'PAPERSIZE'} = $drv->{'paper'};
	$postscript{'EXTRA_GS_OPTIONS'} = $drv->{'gsopts'};
	$postscript{'PS_SEND_EOF'} = uc($drv->{'eof'});
	$postscript{'NUP'} = $drv->{'nup'};
	$postscript{'RTLFTMAR'} = $drv->{'hmargin'};
	$postscript{'TOPBOTMAR'} = $drv->{'vmargin'};
	$textonly{'TEXT_SEND_EOF'} = uc($drv->{'eof'});
	$textonly{'CRLFTRANS'} = $drv->{'crlf'};
	$self->lock_file($sd);
	mkdir($sd, 0755);
	$self->unlock_file($sd);
	$self->write_env_file("$sd/general.cfg", \%general, 1);
	$self->write_env_file("$sd/postscript.cfg", \%postscript);
	$self->write_env_file("$sd/textonly.cfg", \%textonly);
	$self->unlock_file("$sd/general.cfg");
	$self->unlock_file("$sd/postscript.cfg");
	$self->unlock_file("$sd/textonly.cfg");

	# create the comment
	$_[0]->{'comment'} =
		join(" ", "##PRINTTOOL3##",
			  $_[0]->{'rhost'} ? "REMOTE" : "LOCAL",
			  $drv->{'gsdevice'},
			  $drv->{'res'} ? $drv->{'res'} : "NAxNA",
			  $drv->{'paper'},
			  "{}",
			  $drv->{'rhsname'},
			  $drv->{'bpp'} ? $drv->{'bpp'} : "Default",
			  $drv->{'crlf'} ? 1 : "{}" );

	# copy the standard filter into place
	$self->lock_file("$sd/filter");
	unlink("$sd/filter");
	system("cp $self->{'base_driver'} $sd/filter");
	$self->unlock_file("$sd/filter");
	return "$sd/filter";
	}
}

# delete_driver(name)
sub delete_driver
{
	my $self = shift;

local $sd = "$self->{'config_hash'}->{'spool_dir'}/$_[0]";
unlink("$sd/.config", "$sd/filter");
unlink("$sd/general.cfg", "$sd/postscript.cfg", "$sd/textonly.cfg");
}

# driver_input(&printer, &driver)
sub driver_input
{
	my $self = shift;

local ($prn, $drv) = @_;

printf "<tr> <td><input type=radio name=mode value=0 %s> %s</td>\n",
	$drv->{'mode'} == 0 ? "checked" : "", $self->{'text_hash'}->{'redhat_none'};
print "<td>($self->{'text_hash'}->{'redhat_nonemsg'})</td> </tr>\n";

printf "<tr> <td><input type=radio name=mode value=2 %s> %s</td>\n",
	$drv->{'mode'} == 2 ? "checked" : "", $self->{'text_hash'}->{'redhat_prog'};
printf "<td><input name=iface value=\"%s\" size=35></td> </tr>\n",
	$drv->{'mode'} == 2 ? $drv->{'file'} : "";

printf "<tr> <td valign=top><input type=radio name=mode value=1 %s>\n",
	$drv->{'mode'} == 1 ? "checked" : "";
print "$self->{'text_hash'}->{'redhat_driver'}</td> <td><table width=100%>";

print "<tr> <td valign=top><b>$self->{'text_hash'}->{'redhat_printer'}</b></td>\n";
print "<td colspan=3><select size=5 name=gsdevice onChange='setres(0)'>\n";
local @rhs = $self->read_rhs_drivers();
local ($r, $select_res, $rr);
local $bpp = $drv->{'bpp'};
local $res = $drv->{'res'};
foreach $r (@rhs) {
	local @res;
	if ($r->{'res'} && $r->{'bpp'}) {
		foreach $rr (@{$r->{'res'}}) {
			push(@res, map { "$rr->[0]x$rr->[1], $_->[0] DPI, $_->[1]" } @{$r->{'bpp'}});
			}
		for($i=0; $i<@res; $i++) {
			$select_res = $i if ($res[$i] =~ /^$res, $bpp / &&
					     $drv->{'rhsname'} eq $r->{'name'});
			}
		}
	elsif ($r->{'res'}) {
		@res = map { "$_->[0]x$_->[1]" } @{$r->{'res'}};
		$select_res = $self->indexof($res, @res)
			if ($drv->{'rhsname'} eq $r->{'name'});
		}
	else {
		@res = map { "$_->[1], $_->[0]" } @{$r->{'bpp'}};
		for($i=0; $i<@res; $i++) {
			$select_res = $i if ($res[$i] =~ / $bpp$/ &&
					     $drv->{'rhsname'} eq $r->{'name'});
			}
		}
	printf "<option value='%s' %s>%s\n",
		$r->{'name'}.";".join(";", @res),
		$drv->{'rhsname'} eq $r->{'name'} ? 'selected' : '',
		$r->{'desc'};
	}
print "</select><select size=5 name=res width=250>\n";
print "</select></td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'redhat_eof'}</b></td>\n";
printf "<td><input type=radio name=eof value=yes %s> $self->{'text_hash'}->{'yes'}\n",
	$drv->{'eof'} eq 'yes' ? 'checked' : '';
printf "<input type=radio name=eof value=no %s> $self->{'text_hash'}->{'no'}</td>\n",
	$drv->{'eof'} eq 'yes' ? '' : 'checked';

print "<td><b>$self->{'text_hash'}->{'redhat_paper'}</b></td> <td><select name=paper>\n";
foreach $p (sort { $a cmp $b } keys %{$self->{'paper_sizes_hash'}}) {
	printf "<option value='%s' %s>%s\n",
		$p, $drv->{'paper'} eq $p ? 'selected' : '',
		$self->{'paper_sizes_hash'}->{$p};
	}
print "</select></td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'redhat_pages'}</b></td>\n";
print "<td><select name=nup>\n";
foreach $p (1, 2, 4, 8) {
	printf "<option %s>%s\n",
		$drv->{'nup'} == $p ? 'selected' : '', $p;
	}
print "</select></td>\n";

print "<td><b>$self->{'text_hash'}->{'redhat_gsopts'}</b></td>\n";
printf "<td><input name=gsopts size=30 value='%s'></td> </tr>\n",
	$drv->{'gsopts'};

print "<tr> <td><b>$self->{'text_hash'}->{'redhat_hmargin'}</b></td>\n";
printf "<td><input name=hmargin size=6 value='%s'></td>\n",
	$drv->{'hmargin'} ? $drv->{'hmargin'} : 18;

print "<td><b>$self->{'text_hash'}->{'redhat_vmargin'}</b></td>\n";
printf "<td><input name=vmargin size=6 value='%s'></td> </tr>\n",
	$drv->{'vmargin'} ? $drv->{'vmargin'} : 18;

print "<tr> <td><b>$self->{'text_hash'}->{'redhat_crlf'}</b></td>\n";
printf "<td><input type=radio name=crlf value=1 %s> $self->{'text_hash'}->{'yes'}\n",
	$drv->{'crlf'} ? 'checked' : '';
printf "<input type=radio name=crlf value=0 %s> $self->{'text_hash'}->{'no'}</td>\n",
	$drv->{'crlf'} ? '' : 'checked';

print "</table></td></tr>\n";

return <<EOF;
<script>
function setres(sel)
{
var idx = document.forms[0].gsdevice.selectedIndex;
var v = new String(document.forms[0].gsdevice.options[idx].value);
var vv = v.split(";");
var res = document.forms[0].res;
res.length = 0;
for(var i=1; i<vv.length; i++) {
	res.options[i-1] = new Option(vv[i], i-1);
	}
if (res.length > 0) {
	res.options[sel].selected = true;
	}
}
setres($select_res);
</script>
EOF

}

# parse_driver()
# Parse driver selection from %{$self->{'in_hash'}} and return a driver structure
sub parse_driver
{
	my $self = shift;

if ($self->{'in_hash'}->{'mode'} == 0) {
	return { 'mode' => 0 };
	}
elsif ($self->{'in_hash'}->{'mode'} == 2) {
	(-x $self->{'in_hash'}->{'iface'}) || $self->error($self->text('redhat_eprog', $self->{'in_hash'}->{'iface'}));
	return { 'mode' => 2,
		 'file' => $self->{'in_hash'}->{'iface'} };
	}
elsif ($self->{'in_hash'}->{'mode'} == 1) {
	$self->{'in_hash'}->{'gsdevice'} || $self->error($self->{'text_hash'}->{'redhat_edriver'});
	$self->{'in_hash'}->{'hmargin'} =~ /^\d+$/ ||
		$self->error($self->{'text_hash'}->{'redhat_ehmargin'});
	$self->{'in_hash'}->{'vmargin'} =~ /^\d+$/ ||
		$self->error($self->{'text_hash'}->{'redhat_evmargin'});
	local $drv = { 'mode' => 1,
		       'eof' => $self->{'in_hash'}->{'eof'},
		       'paper' => $self->{'in_hash'}->{'paper'},
		       'nup' => $self->{'in_hash'}->{'nup'},
		       'gsopts' => $self->{'in_hash'}->{'gsopts'},
		       'hmargin' => $self->{'in_hash'}->{'hmargin'},
		       'vmargin' => $self->{'in_hash'}->{'vmargin'},
		       'crlf' => $self->{'in_hash'}->{'crlf'} };

	local ($r, $rhs);
	$self->{'in_hash'}->{'gsdevice'} =~ s/;.*$//;
	foreach $r ($self->read_rhs_drivers()) {
		$rhs = $r if ($r->{'name'} eq $self->{'in_hash'}->{'gsdevice'});
		}
	if ($rhs->{'res'} && $rhs->{'bpp'}) {
		defined($self->{'in_hash'}->{'res'}) || $self->error($self->{'text_hash'}->{'redhat_eres'});
		local $bc = @{$rhs->{'bpp'}};
		local $rs = $rhs->{'res'}->[$self->{'in_hash'}->{'res'} / $bc];
		local $bp = $rhs->{'bpp'}->[$self->{'in_hash'}->{'res'} % $bc];
		$drv->{'res'} = $rs->[0].'x'.$rs->[1];
		$drv->{'bpp'} = $bp->[0];
		}
	elsif ($rhs->{'res'}) {
		defined($self->{'in_hash'}->{'res'}) || $self->error($self->{'text_hash'}->{'redhat_eres'});
		local $rs = $rhs->{'res'}->[$self->{'in_hash'}->{'res'}];
		$drv->{'res'} = $rs->[0].'x'.$rs->[1];
		}
	elsif ($rhs->{'bpp'}) {
		defined($self->{'in_hash'}->{'res'}) || $self->error($self->{'text_hash'}->{'redhat_eres'});
		$drv->{'bpp'} = $rhs->{'bpp'}->[$self->{'in_hash'}->{'res'}]->[0];
		}
	$drv->{'rhsname'} = $rhs->{'name'};
	$drv->{'gsdevice'} = $rhs->{'gsdriver'};
	return $drv;
	}
}

sub read_rhs_drivers
{
	my $self = shift;

local (@rv, $drv);
open(DRV, $self->{'rhs_drivers_file'});
while(<DRV>) {
	s/#.*$//g;
	s/\r|\n//g;
	if (/^\s*StartEntry:\s+(.*)/) {
		push(@rv, $drv = { 'name' => $1 });
		}
	elsif (/^\s*GSDriver:\s+(\S+)/) {
		$drv->{'gsdriver'} = $1;
		}
	elsif (/^\s*Description:\s+{(.*)}/) {
		$drv->{'desc'} = $1;
		}
	elsif (/^\s*Resolution:\s+{(\d+)}\s+{(\d+)}/) {
		push(@{$drv->{'res'}}, [ $1, $2 ]);
		}
	elsif (/^\s*BitsPerPixel:\s+{(\S+)}\s+{(.*)}/) {
		push(@{$drv->{'bpp'}}, [ $1, $2 ]);
		}
	}
close(DRV);
return @rv;
}


1;

