#!/usr/bin/perl
package lpadmin::Susedriver;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'lpadmin::Susedriver');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# suse-driver.pl
# Functions for APS print filters, as used by SUSE

@{$self->{'paper_sizes_array'}} = ( [ 'a4', 'A4' ],
		 [ 'a4dj', 'A4 inkjet' ],
		 [ 'a3', 'A3' ],
		 [ 'letter', 'US Letter' ],
		 [ 'letterdj', 'US Letter inkjet' ],
		 [ 'note', 'Note' ],
		 [ 'legal', 'Legal' ],
		 [ 'ledger', 'Ledger' ],
		 [ 'a0', 'A0' ],
		 [ 'a1', 'A1' ],
		 [ 'a2', 'A2' ],
		 [ 'a5', 'A5' ],
		 [ 'a6', 'A6' ],
		 [ 'a7', 'A7' ],
		 [ 'a8', 'A8' ],
		 [ 'a9', 'A9' ],
		 [ 'a10', 'A10' ],
		 [ 'b0', 'B0' ],
		 [ 'b1', 'B1' ],
		 [ 'b2', 'B2' ],
		 [ 'b3', 'B3' ],
		 [ 'b4', 'B4' ],
		 [ 'b5', 'B5' ],
		 [ 'archE', 'archE' ],
		 [ 'archD', 'archD' ],
		 [ 'archC', 'archC' ],
		 [ 'archB', 'archB' ],
		 [ 'archA', 'archA' ],
		 [ 'flsa', 'flsa' ],
		 [ 'flse', 'flse' ],
		 [ 'halfletter', 'Half Letter' ],
		 [ '11x17', '11x17' ] );
$self->{'apsfilter_dir'} = "/var/lib/apsfilter/bin";
$self->{'apsfilter_prog'} = "/var/lib/apsfilter/apsfilter";
$self->{'apsfilter_config'} = "/var/lib/apsfilter/template/apsfilterrc.gs_device_name";
$self->{'apsfilter_base'} = "/etc/apsfilterrc";
$self->{'driver_dir'} = "/etc/gs.upp";
$self->{'webmin_windows_driver'} = 1;

open(DRIVERS, "$self->{'module_root_directory'}/drivers");
while(<DRIVERS>) {
	if (/^(\S+)\s+(.*)/) {
		$self->{'driver_hash'}->{$1} = $2 if (!$self->{'driver_hash'}->{$1});
		}
	}
close(DRIVERS);
open(STP, "stp");
while(<STP>) {
	if (/^(\S+)\s+(.*)/) {
		$self->{'stp_hash'}->{$1} = $2 if (!$self->{'stp_hash'}->{$1});
		}
	}
close(STP);
foreach $u ($self->list_uniprint()) {
	$u->[1] =~ s/,.*$//;
	$self->{'driver_hash'}->{"$u->[0].upp"} = $u->[1];
	}

1;

1;
		return $self;
}

# is_windows_driver(path, %driver)
# Returns a driver structure if some path is a windows driver
sub is_windows_driver
{
	my $self = shift;

return $self->is_webmin_windows_driver(@_);
}

# is_driver(path, &printer)
# Returns a structure containing the details of a driver
sub is_driver
{
	my $self = shift;

if (!$_[0]) {
	return { 'mode' => 0,
		 'desc' => "$self->{'text_hash'}->{'suse_none'}" };
	}
elsif ($_[0] =~ /$self->{'apsfilter_dir'}\/([^-]+)-([^-]+)-([^-]+)-([^-]+)-([^-]+)$/) {
	# Looks like an APS driver from suse (old style)
	local $rv =  {	'mode' => 1,
			'device' => $1,
		 	'paper' => $2,
		 	'method' => $3,
			'colour' => $4,
			'res' => $5 };
	local $desc = $self->{'driver_hash'}->{$rv->{'device'}} ? $self->{'driver_hash'}->{$rv->{'device'}} :
		      $rv->{'device'} =~ /^PS_/ ? "Postscript"
						: $rv->{'device'};
	$rv->{'desc'} = $rv->{'res'} ? "$desc ($rv->{'res'} DPI)" : $desc;
	return $rv;
	}
#elsif ($_[0] =~ /$self->{'apsfilter_dir'}\/([^-]+)--([^-]+)-([^-]+)$/ &&
#       -r "$driver_dir/$1") {
#	# Looks like a new-style APS suse driver
#	local $rv = { 'mode' => 3,
#		      'method' => $2 };
#	open(GS, "$driver_dir/$1");
#	while(<GS>) {
#		s/\r|\n//g;
#		if (/^-sDEVICE=(\S+)/) { $rv->{'device'} = $1; }
#		elsif (/^-sPAPERSIZE=(\S+)/) { $rv->{'paper'} = $1; }
#		elsif (/^-sCOLOR=(\S+)/) { $rv->{'colour'} = $1; }
#		elsif (/^-r(\S+)/) { $rv->{'res'} = $1; }
#		elsif (/^-supModel="(.*)"/) { $rv->{'desc'} = $1; }
#		elsif (/^-sModel="(.*)"/) { $rv->{'model'} = $1; }
#		elsif (/^\@(\S+\.upp)/) { $rv->{'device'} = $1; }
#		else { push(@{$rv->{'extra'}}, $_); }
#		}
#	close(GS);
#	return $rv;
#	}
elsif ($_[0] =~ /$self->{'apsfilter_dir'}\/([^-]+)-([^-]+)-([^-]+)$/) {
	# Null APS driver?
	return { 'mode' => 0,
		 'desc' => 'None' };
	}
else {
	# Some other kind of driver
	return { 'mode' => 2,
		 'file' => $_[0],
		 'desc' => $_[0] };
	}
}

# create_windows_driver(&printer, &driver)
# Creates a new windows printer driver
sub create_windows_driver
{
	my $self = shift;

return $self->create_webmin_windows_driver(@_);
}

# create_driver(&printer, &driver)
# Creates a new local printer driver and returns the path
sub create_driver
{
	my $self = shift;

local ($prn, $drv) = @_;
if ($drv->{'mode'} == 0) {
	return undef;
	}
elsif ($drv->{'mode'} == 2) {
	return $drv->{'file'};
	}
else {
	local $device;
	if ($drv->{'device'} eq 'ps') {
		$device = "PS_$drv->{'res'}dpi";
		}
	else {
		$device = $drv->{'device'};
		}
	local $aps = "$self->{'apsfilter_dir'}/$device-$drv->{'paper'}-".
		     "$drv->{'method'}-$drv->{'colour'}-$drv->{'res'}";
	$self->lock_file($aps);
	symlink($self->{'apsfilter_prog'}, $aps);
	$self->unlock_file($aps);
	if (!-r "$self->{'apsfilter_base'}.$device") {
		$self->lock_file("$self->{'apsfilter_base'}.$device");
		local $conf = `cat $self->{'apsfilter_config'}`;
		$conf =~ s/<gs_device_name>/$device/g;
		$self->open_tempfile(CONF, ">$self->{'apsfilter_base'}.$device");
		$self->print_tempfile(CONF, $conf);
		$self->close_tempfile(CONF);
		$self->unlock_file("$self->{'apsfilter_base'}.$device");
		}
	return $aps;
	}
}

# delete_driver(name)
sub delete_driver
{
	my $self = shift;

}

# driver_input(&printer, &driver)
sub driver_input
{
	my $self = shift;

local ($prn, $drv) = @_;
local ($found, $d);

printf "<tr> <td><input type=radio name=mode value=0 %s> %s</td>\n",
	$drv->{'mode'} == 0 ? "checked" : "", $self->{'text_hash'}->{'suse_none'};
print "<td>($self->{'text_hash'}->{'suse_nonemsg'})</td> </tr>\n";

printf "<tr> <td><input type=radio name=mode value=2 %s> %s</td>\n",
	$drv->{'mode'} == 2 ? "checked" : "", $self->{'text_hash'}->{'suse_prog'};
printf "<td><input name=iface value=\"%s\" size=35></td> </tr>\n",
	$drv->{'mode'} == 2 ? $drv->{'file'} : "";

if ($drv->{'mode'} == 2 || 1) {
	# Show input for old-style suse printer
	printf "<tr> <td valign=top><input type=radio name=mode value=1 %s>\n",
		$drv->{'mode'} == 1 ? "checked" : "";
	print "$self->{'text_hash'}->{'suse_driver'}</td> <td><table width=100%>";

	print "<tr> <td valign=top><b>$self->{'text_hash'}->{'suse_printer'}</b></td>\n";
	print "<td colspan=3><select size=10 name=device>\n";
	printf "<option value=ps %s>Postscript\n",
		$drv->{'device'} =~ /^PS_/ ? 'selected' : '';
	$found++ if ($drv->{'device'} =~ /^PS_/);
	foreach $d ($self->list_uniprint()) {
		local $u = "$d->[0].upp";
		printf "<option value=%s %s>%s\n",
			$u, $drv->{'device'} eq $u ? 'selected' : '', $d->[1];
		$found++ if ($drv->{'device'} eq $u);
		}
	local $out = `$self->{'config_hash'}->{'gs_path'} -help 2>&1`;
	$out =~ /Available devices:\n((\s+.*\n)+)/i;
	foreach $d (split(/\s+/, $1)) {
		if ($self->{'driver_hash'}->{$d}) {
			printf "<option value=%s %s>%s\n",
				$d, $drv->{'device'} eq $d ? 'selected' : '',
				$self->{'driver_hash'}->{$d};
			$found++ if ($drv->{'device'} eq $d);
			}
		}
	print "<option selected value=$drv->{'device'}>$drv->{'device'}\n"
		if (!$found && $drv->{'device'});
	print "</select></td> </tr>\n";

	print "<tr> <td><b>$self->{'text_hash'}->{'suse_res'}</b></td>\n";
	print "<td><input name=res size=8 value='$drv->{'res'}'></td>\n";

	print "<td><b>$self->{'text_hash'}->{'suse_colour'}</b></td>\n";
	printf "<td><input name=colour type=radio value=color %s> %s\n",
		$drv->{'colour'} eq 'mono' ? '' : 'checked', $self->{'text_hash'}->{'yes'};
	printf "<input name=colour type=radio value=color %s> %s</td> </tr>\n",
		$drv->{'colour'} eq 'mono' ? 'checked' : '', $self->{'text_hash'}->{'no'};

	print "<tr> <td><b>$self->{'text_hash'}->{'suse_paper'}</b></td>\n";
	print "<td><select name=paper>\n";
	foreach $p (@{$self->{'paper_sizes_array'}}) {
		printf "<option value=%s %s>%s\n",
			$p->[0], $drv->{'paper'} eq $p->[0] ? 'selected' : '',
			$p->[1];
		}
	print "</select></td>\n";

	print "<td><b>$self->{'text_hash'}->{'suse_method'}</b></td>\n";
	printf "<td><input type=radio name=method value=auto %s> %s\n",
		$drv->{'method'} eq 'ascii' ? '' : 'checked',
		$self->{'text_hash'}->{'suse_auto'};
	printf "<input type=radio name=method value=ascii %s> %s</td> </tr>\n",
		$drv->{'method'} eq 'ascii' ? 'checked' : '',
		$self->{'text_hash'}->{'suse_ascii'};

	print "</table></td> </tr>\n";
	}
else {
	# Show input for new-style suse printer (NOT DONE YET!)
	printf "<tr> <td valign=top><input type=radio name=mode value=3 %s>\n",
		$drv->{'mode'} == 3 ? "checked" : "";
	print "$self->{'text_hash'}->{'suse_yast2'}</td> <td><table width=100%>";

	print "<tr> <td valign=top><b>$self->{'text_hash'}->{'suse_printer'}</b></td>\n";
	print "<td colspan=3><select size=10 name=device>\n";
	printf "<option value=ps %s>Postscript\n",
		$drv->{'device'} eq 'PS' ? 'selected' : '';
	$found++ if ($drv->{'device'} eq 'PS');
	local $out = `$self->{'config_hash'}->{'gs_path'} -help 2>&1`;
	$out =~ /Available devices:\n((\s+.*\n)+)/i;
	foreach $d (split(/\s+/, $1)) {
		if ($d ne 'stp' && $self->{'driver_hash'}->{$d}) {
			printf "<option value=%s %s>%s\n",
				$d, $drv->{'device'} eq $d ? 'selected' : '',
				$self->{'driver_hash'}->{$d};
			$found++ if ($drv->{'device'} eq $d);
			}
		}
	foreach $d ($self->list_uniprint()) {
		local $u = "$d->[0].upp";
		printf "<option value=%s %s>%s\n",
			$u, $drv->{'device'} eq $u ? 'selected' : '', $d->[1];
		$found++ if ($drv->{'device'} eq $u);
		}
	foreach $s (sort { $a cmp $b } keys %{$self->{'stp_hash'}}) {
		printf "<option value=%s.stp %s>%s\n",
			$s, $drv->{'device'} eq 'stp' &&
			    $drv->{'model'} eq $s ? 'selected' : '', $self->{'stp_hash'}->{$s};
		$found++ if ($drv->{'device'} eq 'stp' &&
			     $drv->{'model'} eq $s);
		}
	print "<option selected value=$drv->{'device'}>$drv->{'device'}\n"
		if (!$found && $drv->{'device'});
	print "</select></td> </tr>\n";

	print "<tr> <td><b>$self->{'text_hash'}->{'suse_colour'}</b></td>\n";
	printf "<td><input name=colour type=radio value=color %s> %s\n",
		$drv->{'colour'} eq 'mono' ? '' : 'checked', $self->{'text_hash'}->{'yes'};
	printf "<input name=colour type=radio value=color %s> %s</td>\n",
		$drv->{'colour'} eq 'mono' ? 'checked' : '', $self->{'text_hash'}->{'no'};

	print "<td><b>$self->{'text_hash'}->{'suse_paper'}</b></td>\n";
	print "<td><select name=paper>\n";
	foreach $p (@{$self->{'paper_sizes_array'}}) {
		printf "<option value=%s %s>%s\n",
			$p->[0], $drv->{'paper'} eq $p->[0] ? 'selected' : '',
			$p->[1];
		}
	print "</select></td> </tr>\n";

	print "<tr> <td><b>$self->{'text_hash'}->{'suse_res'}</b></td>\n";
	printf "<td><input type=radio name=res_def value=1 %s> %s\n",
		$drv->{'res'} ? '' : 'checked', $self->{'text_hash'}->{'suse_auto'};
	printf "<input type=radio name=res_def value=0 %s>\n",
		$drv->{'res'} ? 'checked' : '';
	print "<input name=res size=8 value='$drv->{'res'}'></td>\n";

	print "<td><b>$self->{'text_hash'}->{'suse_method'}</b></td>\n";
	print "<td><select name=method>\n";
	foreach $m ('auto', 'ascii', 'raw') {
		printf "<option value=%s %s>%s\n",
			$m, $drv->{'method'} eq $m ? 'selected' : '',
			$self->{'text_hash'}->{"suse_$m"};
		}
	print "</select></td> </tr>\n";

	print "<tr> <td><b>$self->{'text_hash'}->{'suse_extra'}</b></td>\n";
	print "<td colspan=3><input name=extra size=50 value='",
	      join(" ", @{$drv->{'extra'}}),"'></td> </tr>\n";

	print "</table></td> </tr>\n";
	}
}

# parse_driver()
# Parse driver selection from %{$self->{'in_hash'}} and return a driver structure
sub parse_driver
{
	my $self = shift;

if ($self->{'in_hash'}->{'mode'} == 0) {
	return { 'mode' => 0 };
	}
elsif ($self->{'in_hash'}->{'mode'} == 2) {
	(-x $self->{'in_hash'}->{'iface'}) || $self->error($self->text('suse_eprog', $self->{'in_hash'}->{'iface'}));
	return { 'mode' => 2,
		 'file' => $self->{'in_hash'}->{'iface'} };
	}
elsif ($self->{'in_hash'}->{'mode'} == 3) {
	# New suse printer (NOT DONE YET!)
	# All the other odd files created by yast2 need to be supported
	$self->{'in_hash'}->{'device'} || $self->error($self->{'text_hash'}->{'suse_edriver'});
	$self->{'in_hash'}->{'res_def'} || $self->{'in_hash'}->{'res'} =~ /^\d+$/ ||
		$self->{'in_hash'}->{'res'} =~ /^\d+x\d+$/ || $self->error($self->{'text_hash'}->{'suse_eres'});
	}
elsif ($self->{'in_hash'}->{'mode'} == 1) {
	# Old-style suse printer
	$self->{'in_hash'}->{'device'} || $self->error($self->{'text_hash'}->{'suse_edriver'});
	$self->{'in_hash'}->{'res'} =~ /^\d+$/ || $self->error($self->text('suse_eres', $self->{'in_hash'}->{'res'}));
	return { 'mode' => 1,
		 'device' => $self->{'in_hash'}->{'device'},
		 'paper' => $self->{'in_hash'}->{'paper'},
		 'method' => $self->{'in_hash'}->{'method'},
		 'colour' => $self->{'in_hash'}->{'colour'},
		 'res' => $self->{'in_hash'}->{'res'} };
	}
}


1;

