#!/usr/bin/perl

&MAIN();

 sub MAIN {
# index.cgi
# Display a list of all known printers

&ModuleLoader::preload_module('lpadmin_class', "lpadmin::LpadminLib");
$self = new lpadmin::LpadminLib:: 'lpadmin_class',%$self;

$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", undef, 1, 1, 0,
		 undef, undef, undef,
		 $self->text('index_style',
			$self->{'text_hash'}->{'style_'.$self->{'config_hash'}->{'print_style'}} ||
			uc($self->{'config_hash'}->{'print_style'})));
@{$self->{'plist_array'}} = $self->list_printers();

# Check the print system (if possible)
if ($self->UNIVERSAL::can('check_print_system')) {
	$self->{'pserr'} = $self->check_print_system();
	if ($self->{'pserr'}) {
		print $self->{'pserr'},"\n";
		print $self->text('index_esystem',
		    "$self->{'gconfig_hash'}->{'webprefix'}/config.cgi?$self->{'module_name'}"),"<p>\n";
		$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});
		exit;
		}
	}

# Create links to select / add
@{$self->{'links_array'}} = ( );
if (@{$self->{'plist_array'}} && !$self->{'config_hash'}->{'display_mode'}) {
	push(@{$self->{'links_array'}}, $self->select_all_link("d"),
		     $self->select_invert_link("d") );
	}
push(@{$self->{'links_array'}}, "<a href=edit_printer.cgi?new=1>$self->{'text_hash'}->{'index_add'}</a>")
	if ($self->{'access_hash'}->{'add'});

if ($self->{'config_hash'}->{'sort_mode'}) {
	@{$self->{'plist_array'}} = sort { $a cmp $b } @{$self->{'plist_array'}};
	}
if (@{$self->{'plist_array'}}) {
	if ($self->{'config_hash'}->{'display_mode'}) {
		# Just show printer names
		print $self->ui_links_row(\@{$self->{'links_array'}});
		print "<table border width=100%>\n";
		print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'index_header'}</b></td> </tr>\n";
		print "<tr $self->{'cb'}> <td><table width=100%>\n";
		$self->{'i'} = 0;
		foreach $p (@{$self->{'plist_array'}}) {
			local $ed = $self->can_edit_printer($p);
			local $jb = $self->can_edit_jobs($p);
			next if (!$ed && !$jb && !$self->{'access_hash'}->{'view'});
			print "<tr>\n" if ($self->{'i'}%4 == 0);
			print "<td width=25%>";
			if ($ed) {
				print "<a href='edit_printer.cgi?name=$p'>",
				      "$p</a>\n";
				}
			else {
				print "$p\n";
				}
			if ($self->{'config_hash'}->{'show_jobs'}) {
				local @jobs = $self->get_jobs($p->{'name'});
				print "&nbsp;<a href='list_jobs.cgi?name=$p'>",
				      "(",$self->text('index_jcount', scalar(@jobs)),
				      ")</a></td>\n";
				}
			else {
				print "&nbsp;<a href='list_jobs.cgi?name=$p'>",
				      "($self->{'text_hash'}->{'index_jlist'})</a></td>\n";
				}
			print "</tr>\n" if ($self->{'i'}%4 == 3);
			$self->{'i'}++;
			}
		print "</table></td></tr></table>\n";
		print $self->ui_links_row(\@{$self->{'links_array'}});
		}
	else {
		# Show full printer details .. table heading first
		print $self->ui_form_start("delete_printers.cgi", "post");
		@{$self->{'tds_array'}} = ( "width=5" );
		print $self->ui_links_row(\@{$self->{'links_array'}});
		print $self->ui_columns_start([
			"",
			$self->{'text_hash'}->{'index_name'},
			$self->{'text_hash'}->{'index_desc'},
			$self->{'text_hash'}->{'index_to'},
			$self->{'config_hash'}->{'show_status'} ? ( $self->{'text_hash'}->{'index_enabled'},
						   $self->{'text_hash'}->{'index_accepting'} )
					       : ( $self->{'text_hash'}->{'index_driver'} ),
			$self->{'text_hash'}->{'index_jobs'} ], 100, 0, \@{$self->{'tds_array'}});

		# One row per printer
		for($self->{'i'}=0; $self->{'i'}<@{$self->{'plist_array'}}; $self->{'i'}++) {
			local ($wdrv, $hdrv, $drv);
			local $ed = $self->can_edit_printer($self->{'plist_array'}->[$self->{'i'}]);
			local $jb = $self->can_edit_jobs($self->{'plist_array'}->[$self->{'i'}]);
			next if (!$ed && !$jb && !$self->{'access_hash'}->{'view'});
			$p = $self->get_printer($self->{'plist_array'}->[$self->{'i'}], !$self->{'config_hash'}->{'show_status'});
			$ed = 0 if ($p->{'ro'});

			local @cols;
			if ($ed) {
				push(@cols, "<a href=\"edit_printer.cgi?".
					    "name=$p->{'name'}\">".
					    $self->html_escape($p->{'name'})."</a>");
				}
			else {
				push(@cols, $self->html_escape($p->{'name'}));
				}
			push(@cols, $self->html_escape($p->{'desc'}));
			if (!$self->{'webmin_windows_driver'}) {
				$wdrv = $self->is_webmin_windows_driver($p->{'iface'}, $p);
				}
			$wdrv = $self->is_windows_driver($p->{'iface'}, $p) if (!$wdrv);
			$hdrv = $self->is_hpnp_driver($p->{'iface'}, $p);
			if ($wdrv) {
				push(@cols, "<tt>\\\\$wdrv->{'server'}".
				      	    "\\$wdrv->{'share'}</tt>");
				$p->{'iface'} = $wdrv->{'program'};
				}
			elsif ($hdrv) {
				push(@cols, "<tt>HPNP $hdrv->{'server'}:".
					    "$hdrv->{'port'}</tt>");
				$p->{'iface'} = $hdrv->{'program'};
				}
			elsif ($p->{'rhost'}) {
				local $qu = $p->{'rqueue'} ? $p->{'rqueue'}
							   : $p->{'name'};
				push(@cols, "<tt>$p->{'rhost'}:$qu</tt>");
				}
			elsif ($p->{'dhost'}) {
				push(@cols, "<tt>$p->{'dhost'}:$p->{'dport'}</tt>");
				}
			else {
				push(@cols, $self->dev_name($p->{'dev'}));
				}
			if (!$self->{'webmin_print_driver'}) {
				$drv = $self->is_webmin_driver($p->{'iface'}, $p);
				}
			$drv = $self->is_driver($p->{'iface'}, $p)
				if ($drv->{'mode'} == 0 || $drv->{'mode'} == 2);
			if ($self->{'config_hash'}->{'show_status'}) {
				push(@cols, $p->{'enabled'} ? $self->{'text_hash'}->{'yes'}
							    : $self->{'text_hash'}->{'no'});
				push(@cols, $p->{'accepting'} ? $self->{'text_hash'}->{'yes'}
							      : $self->{'text_hash'}->{'no'});
				}
			else {
				push(@cols, $self->html_escape($drv->{'desc'}));
				}
			$self->{'jlink'} = "<a href=\"list_jobs.cgi?name=$p->{'name'}\">";
			if ($self->{'config_hash'}->{'show_jobs'}) {
				local @jobs = $self->get_jobs($p->{'name'});
				$self->{'jlink'} .= scalar(@jobs);
				}
			else {
				$self->{'jlink'} .= $self->{'text_hash'}->{'index_list'};
				}
			$self->{'jlink'} .= "</a>";
			push(@cols, $self->{'jlink'});
			if ($ed) {
				print $self->ui_checked_columns_row(\@cols, \@{$self->{'tds_array'}},
							      "d",$p->{'name'});
				}
			else {
				print $self->ui_columns_row([ "", @cols ], \@{$self->{'tds_array'}});
				}
			}
		print $self->ui_columns_end();
		print $self->ui_links_row(\@{$self->{'links_array'}});
		print $self->ui_form_end([ [ "delete", $self->{'text_hash'}->{'index_delete'} ] ]);
		}
	}
else {
	print "<b>$self->{'text_hash'}->{'index_none'}</b><p>\n";
	print $self->ui_links_row(\@{$self->{'links_array'}});
	}

# display button to start or stop the scheduler (lpd, lpsched, etc..)
print "<hr>\n";
print $self->ui_buttons_start();
$self->{'pid'} = $self->sched_running();
if ($self->{'pid'} < 0 || !$self->{'access_hash'}->{'stop'}) {
	# cannot stop or start..
	}
elsif ($self->{'pid'} && $self->{'access_hash'}->{'stop'} == 2) {
	# can only restart
	print $self->ui_buttons_row("restart.cgi",
			      $self->{'text_hash'}->{'index_restart'}, $self->{'text_hash'}->{'index_restartmsg'});
	}
elsif ($self->{'pid'}) {
	print $self->ui_buttons_row("stop.cgi",
			      $self->{'text_hash'}->{'index_stop'}, $self->{'text_hash'}->{'index_stopmsg'});
	}
else {
	print $self->ui_buttons_row("start.cgi",
			      $self->{'text_hash'}->{'index_start'}, $self->{'text_hash'}->{'index_startmsg'});
	}

# Show cluster button, if possible
if ($self->foreign_check("servers")) {
	$self->foreign_require("servers", "servers-lib.pl");
	@{$self->{'allservers_array'}} = grep { $_->{'user'} }
			$main::servers_object->list_servers();
	}
if ($self->{'access_hash'}->{'cluster'} && @{$self->{'allservers_array'}}) {
	print $self->ui_buttons_row("cluster.cgi",
			      $self->{'text_hash'}->{'index_cluster'}, $self->{'text_hash'}->{'index_clusterdesc'});
	}

print $self->ui_buttons_end();

$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});

1;
		
}


1;

