#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_printer.cgi
# Create or modify a printer

&ModuleLoader::preload_module('lpadmin_class', "lpadmin::LpadminLib");
$self = new lpadmin::LpadminLib:: 'lpadmin_class',%$self;

$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'save_err'});

# Check ACL
if ($self->{'in_hash'}->{'new'}) {
	$self->{'access_hash'}->{'add'} || $self->error($self->{'text_hash'}->{'save_eadd'});
	}
else {
	$self->can_edit_printer($self->{'in_hash'}->{'name'}) ||
		$self->error($self->{'text_hash'}->{'save_eedit'});
	}

# validate and store printer details
$self->{'in_hash'}->{'name'} =~ /^[A-z0-9\-\_\.]+$/ ||
	$self->error($self->text('save_ename', $self->{'in_hash'}->{'name'}));
if ($self->{'in_hash'}->{'new'} && $self->get_printer($self->{'in_hash'}->{'name'})) {
	$self->error($self->text('save_edup', $self->{'in_hash'}->{'name'}));
	}
$self->{'prn_hash'}->{'name'} = $self->{'in_hash'}->{'name'};
$self->{'prn_hash'}->{'accepting'} = $self->{'in_hash'}->{'accepting'};
if (!$self->{'prn_hash'}->{'accepting'}) { $self->{'prn_hash'}->{'accepting_why'} = $self->{'in_hash'}->{'accepting_why'}; }
$self->{'prn_hash'}->{'enabled'} = $self->{'in_hash'}->{'enabled'};
if (!$self->{'prn_hash'}->{'enabled'}) { $self->{'prn_hash'}->{'enabled_why'} = $self->{'in_hash'}->{'enabled_why'}; }
$self->{'prn_hash'}->{'desc'} = $self->{'in_hash'}->{'desc'};
if ($self->printer_support('allow')) {
	@{$self->{'ul_array'}} = split(/\s+/, $self->{'in_hash'}->{'users'});
	if ($self->{'in_hash'}->{'access'} == 0) { $self->{'prn_hash'}->{'allow_all'}++; }
	elsif ($self->{'in_hash'}->{'access'} == 1) { $self->{'prn_hash'}->{'deny_all'}++; }
	else {
		$self->{'w'} = $self->{'in_hash'}->{'access'} == 2 ? "allow" : "deny";
		if (!@{$self->{'ul_array'}}) { $self->error($self->{'text_hash'}->{"save_e$self->{'w'}"}); }
		foreach $u (@{$self->{'ul_array'}}) {
			if ($u !~ /^\S+\!\S+$/ && !(@{$self->{'dummy_array'}}=getpwnam($u))) {
				$self->error($self->text('save_euser', $u));
				}
			}
		$self->{'prn_hash'}->{$self->{'w'}} = \@{$self->{'ul_array'}};
		}
	}
if ($self->printer_support('banner')) {
	$self->{'prn_hash'}->{'banner'} = $self->{'in_hash'}->{'prbanner'};
	}
if ($self->printer_support('ctype')) {
	if ($self->{'in_hash'}->{'ctype_simple'}) { push(@{$self->{'ctype_array'}}, "simple"); }
	if ($self->{'in_hash'}->{'ctype_postscript'}) { push(@{$self->{'ctype_array'}}, "postscript"); }
	if ($self->{'in_hash'}->{'ctype_other'}) {
		push(@{$self->{'ctype_array'}}, split(/\s+/, $self->{'in_hash'}->{'ctype_olist'}));
		}
	$self->error($self->{'text_hash'}->{'save_etype'}) if (!@{$self->{'ctype_array'}} && $self->{'in_hash'}->{'dest'} != 2);
	$self->{'prn_hash'}->{'ctype'} = \@{$self->{'ctype_array'}};
	}
$self->{'prn_hash'}->{'default'} = $self->{'in_hash'}->{'default'};
if ($self->printer_support('msize')) {
	if ($self->{'in_hash'}->{'msize_def'} == 2) {
		$self->{'prn_hash'}->{'msize'} = 0;
		}
	elsif ($self->{'in_hash'}->{'msize_def'} == 0) {
		$self->{'in_hash'}->{'msize'} =~ /^\d+$/ ||
			$self->error($self->{'text_hash'}->{'save_emax'});
		$self->{'prn_hash'}->{'msize'} = $self->{'in_hash'}->{'msize'};
		}
	}
if ($self->printer_support('alias')) {
	@{$self->{'alias_array'}} = split(/\s+/, $self->{'in_hash'}->{'alias'});
	$self->{'prn_hash'}->{'alias'} = \@{$self->{'alias_array'}};
	}

if ($self->{'in_hash'}->{'new'} || $self->printer_support('editdest')) {
	if ($self->{'in_hash'}->{'webmin'}) {
		$self->{'drv'} = $self->parse_webmin_driver();
		$self->{'dfunc'} = 'create_webmin_driver';
		}
	else {
		$self->{'drv'} = $self->parse_driver();
		$self->{'dfunc'} = 'create_driver';
		}

	# validate and store destination section
	$SIG{'ALRM'} = \&connect_time_out;
	if ($self->{'in_hash'}->{'dest'} == 0) {
		# printing to some device
		$self->{'prn_hash'}->{'dev'} = $self->{'in_hash'}->{'dev'};
		$self->{'prn_hash'}->{'iface'} = do { my $fn = $self->{'dfunc'}; $self->$fn(\%{$self->{'prn_hash'}}, $self->{'drv'})};
		}
	elsif ($self->{'in_hash'}->{'dest'} == 1) {
		# printing to some file
		(-r $self->{'in_hash'}->{'file'}) || ($self->{'in_hash'}->{'file'} =~ /^\|(.*)/ && -r $1) ||
			$self->error($self->text('save_efile', $self->{'in_hash'}->{'file'}));
		$self->{'prn_hash'}->{'dev'} = $self->{'in_hash'}->{'file'};
		$self->{'prn_hash'}->{'iface'} = do { my $fn = $self->{'dfunc'}; $self->$fn(\%{$self->{'prn_hash'}}, $self->{'drv'})};
		}
	elsif ($self->{'in_hash'}->{'dest'} == 2) {
		# printing to a unix host
		local ($rhost, $rport);
		if ($self->{'in_hash'}->{'rhost'} =~ /^(\S+):(\d+)$/) {
			$rhost = $1;
			$rport = $2;
			}
		else {
			$rhost = $self->{'in_hash'}->{'rhost'};
			$rport = 515;
			}
		gethostbyname($rhost) ||
		    $self->check_ipaddress($rhost) ||
			$self->error($self->text('save_erhost', $rhost));
		$rport =~ /^\d+$/ || $self->error($self->text('save_erport', $rport));
		$self->{'in_hash'}->{'rqueue'} =~ /^[A-z0-9\-\_\.]+$/ ||
			(!$self->{'in_hash'}->{'rqueue'} && $self->printer_support('rnoqueue')) ||
			$self->error($self->text('save_erqueue', $self->{'in_hash'}->{'rqueue'}));
		$self->{'prn_hash'}->{'rhost'} = $self->{'in_hash'}->{'rhost'};
		$self->{'prn_hash'}->{'rqueue'} = $self->{'in_hash'}->{'rqueue'};
		$self->{'prn_hash'}->{'rtype'} = $self->{'in_hash'}->{'rtype'};
		if ($self->{'drv'}->{'mode'} && !$self->printer_support('riface')) {
			$self->error($self->{'text_hash'}->{'save_eremote'});
			}
		if ($self->{'in_hash'}->{'check'} && (!$self->{'in_hash'}->{'rtype'} || $self->{'in_hash'}->{'rtype'} eq 'bsd')) {
			# Try connecting to the LPR port
			alarm(10);
			$self->open_socket($rhost, 515, TEST);
			close(TEST);
			alarm(0);
			}
		$self->{'prn_hash'}->{'iface'} = do { my $fn = $self->{'dfunc'}; $self->$fn(\%{$self->{'prn_hash'}}, $self->{'drv'})};
		}
	elsif ($self->{'in_hash'}->{'dest'} == 3) {
		# printing to windows
		$self->{'sdrv'} = { 'server' => $self->{'in_hash'}->{'server'},
			 'share' => $self->{'in_hash'}->{'share'},
			 'user' => $self->{'in_hash'}->{'suser'},
			 'pass' => $self->{'in_hash'}->{'spass'},
			 'workgroup' => $self->{'in_hash'}->{'wgroup'},
			 'program' => do { my $fn = $self->{'dfunc'}; $self->$fn(\%{$self->{'prn_hash'}}, $self->{'drv'}) }};
		$self->{'prn_hash'}->{'dev'} = "/dev/null";
		$self->{'prn_hash'}->{'iface'} = $self->{'in_hash'}->{'webmin'} ? 
			$self->create_webmin_windows_driver(\%{$self->{'prn_hash'}}, $self->{'sdrv'}) :
			$self->create_windows_driver(\%{$self->{'prn_hash'}}, $self->{'sdrv'});
		if ($self->{'in_hash'}->{'check'}) {
			# Try connecting to the SMB port
			alarm(10);
			$self->open_socket($self->{'sdrv'}->{'server'}, 139, TEST);
			close(TEST);
			alarm(0);
			}
		}
	elsif ($self->{'in_hash'}->{'dest'} == 4) {
		# printing to hpnp server
		$self->{'hdrv'} = { 'server' => $self->{'in_hash'}->{'hpnp'},
			  'port' => $self->{'in_hash'}->{'port'},
			  'program' => do { my $fn = $self->{'dfunc'}; $self->$fn(\%{$self->{'prn_hash'}}, $self->{'drv'}) }};
		$self->{'prn_hash'}->{'iface'} = $self->create_hpnp_driver(\%{$self->{'prn_hash'}}, $self->{'hdrv'});
		$self->{'prn_hash'}->{'dev'} = "/dev/null";
		}
	elsif ($self->{'in_hash'}->{'dest'} == 5) {
		# direct connection printing
		gethostbyname($self->{'in_hash'}->{'dhost'}) || $self->check_ipaddress($self->{'in_hash'}->{'dhost'}) ||
			$self->error($self->text('save_edhost', $self->{'in_hash'}->{'dhost'}));
		$self->{'in_hash'}->{'dport'} =~ /^\d+$/ || $self->error($self->{'text_hash'}->{'save_edport'});
		$self->{'prn_hash'}->{'dhost'} = $self->{'in_hash'}->{'dhost'};
		$self->{'prn_hash'}->{'dport'} = $self->{'in_hash'}->{'dport'};
		$self->{'prn_hash'}->{'iface'} = do { my $fn = $self->{'dfunc'}; $self->$fn(\%{$self->{'prn_hash'}}, $self->{'drv'})};
		if ($self->{'in_hash'}->{'check'}) {
			# Try connecting to the port
			alarm(10);
			$self->open_socket($self->{'prn_hash'}->{'dhost'}, $self->{'prn_hash'}->{'dport'}, TEST);
			close(TEST);
			alarm(0);
			}
		}
	}

# Call os-specific validation function
if ($self->UNIVERSAL::can('validate_printer')) {
	$self->{'err'} = $self->validate_printer(\%{$self->{'prn_hash'}});
	$self->error($self->{'err'}) if ($self->{'err'});
	}

# Create the printer
if ($self->{'in_hash'}->{'new'}) {
	$self->create_printer(\%{$self->{'prn_hash'}});
	$self->system_logged("$self->{'config_hash'}->{'apply_cmd'} >/dev/null 2>&1 </dev/null")
		if ($self->{'config_hash'}->{'apply_cmd'});
	$self->webmin_log("create", "printer", $self->{'prn_hash'}->{'name'}, $self->log_info(\%{$self->{'prn_hash'}}));
	}
else {
	$self->modify_printer(\%{$self->{'prn_hash'}});
	$self->system_logged("$self->{'config_hash'}->{'apply_cmd'} >/dev/null 2>&1 </dev/null")
		if ($self->{'config_hash'}->{'apply_cmd'});
	$self->webmin_log("modify", "printer", $self->{'prn_hash'}->{'name'}, $self->log_info(\%{$self->{'prn_hash'}}));
	}

# Update ACL
if ($self->{'in_hash'}->{'new'} && $self->{'access_hash'}->{'printers'} ne '*') {
	$self->{'access_hash'}->{'printers'} .= " ".$self->{'in_hash'}->{'name'};
	$self->save_module_acl(\%{$self->{'access_hash'}});
	}

# Create on cluster
@{$self->{'slaveerrs_array'}} = $self->save_on_cluster($self->{'in_hash'}->{'new'}, \%{$self->{'prn_hash'}}, $self->{'drv'}, $self->{'sdrv'} || $self->{'hdrv'},
			      $self->{'in_hash'}->{'webmin'}, $self->{'in_hash'}->{'dest'});
if (@{$self->{'slaveerrs_array'}}) {
	$self->error($self->text('save_errslave',
	     "<p>".join("<br>", map { "$_->[0]->{'host'} : $_->[1]" }
				    @{$self->{'slaveerrs_array'}})));
	}

$self->redirect("");

1;
		
}

sub connect_time_out
{
	shift if ($self == $_[0]);

$self->{'connect_timed_out'}++;
}


1;

