#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Display a form for editing an existing logical volume

&ModuleLoader::preload_module('lvm_class', "lvm::LvmLib");
$self = new lvm::LvmLib:: 'lvm_class',%$self;

$self->foreign_require("fdisk", "fdisk-lib.pl");
$self->ReadParse();
($self->{'vg'}) = grep { $_->{'name'} eq $self->{'in_hash'}->{'vg'} } $self->list_volume_groups();
@{$self->{'lvs_array'}} = $self->list_logical_volumes($self->{'in_hash'}->{'vg'});

$self->{'vgdesc'} = $self->text('lv_vg', $self->{'vg'}->{'name'});
if ($self->{'in_hash'}->{'lv'}) {
	($self->{'lv'}) = grep { $_->{'name'} eq $self->{'in_hash'}->{'lv'} } @{$self->{'lvs_array'}};
	$self->ui_print_header($self->{'vgdesc'}, $self->{'lv'}->{'is_snap'} ? $self->{'text_hash'}->{'lv_edit_snap'}
				 : $self->{'text_hash'}->{'lv_edit'}, "");
	@{$self->{'stat_array'}} = $self->device_status($self->{'lv'}->{'device'});
	}
else {
	$self->ui_print_header($self->{'vgdesc'}, $self->{'in_hash'}->{'snap'} ? $self->{'text_hash'}->{'lv_create_snap'} : $self->{'text_hash'}->{'lv_create'},"");
	$self->{'lv'} = { 'perm' => 'rw',
		'alloc' => 'n',
		'is_snap' => $self->{'in_hash'}->{'snap'},
	 	'size' => ($self->{'vg'}->{'pe_total'} - $self->{'vg'}->{'pe_alloc'})*
			  $self->{'vg'}->{'pe_size'} };
	}

print "<form action=save_lv.cgi>\n";
print "<input type=hidden name=vg value='$self->{'in_hash'}->{'vg'}'>\n";
print "<input type=hidden name=lv value='$self->{'in_hash'}->{'lv'}'>\n";
print "<input type=hidden name=snap value='$self->{'in_hash'}->{'snap'}'>\n";
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'lv_header'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

if ($self->{'stat_array'}->[2]) {
	print "<tr> <td><b>$self->{'text_hash'}->{'lv_name'}</b></td>\n";
	print "<td>$self->{'lv'}->{'name'}</td>\n";

	print "<td><b>$self->{'text_hash'}->{'lv_size'}</b></td>\n";
	print "<td>",$self->nice_size($self->{'lv'}->{'size'}*1024),"</td> </tr>\n";
	}
else {
	print "<tr> <td><b>$self->{'text_hash'}->{'lv_name'}</b></td>\n";
	print "<td><input name=name size=15 value='$self->{'lv'}->{'name'}'></td>\n";

	print "<td><b>$self->{'text_hash'}->{'lv_size'}</b></td>\n";
	print "<td><input name=size size=8 value='$self->{'lv'}->{'size'}'> kB</td> </tr>\n";
	}

print "<tr> <td><b>$self->{'text_hash'}->{'lv_petotal'}</b></td>\n";
print "<td>",$self->text('lv_petotals', $self->{'vg'}->{'pe_alloc'}, $self->{'vg'}->{'pe_total'}),
      "</td>\n";

print "<td><b>$self->{'text_hash'}->{'lv_pesize'}</b></td>\n";
print "<td>$self->{'vg'}->{'pe_size'} kB</td> </tr>\n";

if ($self->{'in_hash'}->{'lv'}) {
	print "<tr> <td><b>$self->{'text_hash'}->{'lv_device'}</b></td>\n";
	print "<td><tt>$self->{'lv'}->{'device'}</tt></td>\n";

	print "<td><b>$self->{'text_hash'}->{'lv_status'}</b></td> <td>\n";
	if (!@{$self->{'stat_array'}}) {
		print $self->{'text_hash'}->{'lv_notused'};
		}
	else {
		$self->{'msg'} = $self->device_message(@{$self->{'stat_array'}});
		print $self->{'msg'};
		}
	print "</td> </tr>\n";
	}

if ($self->{'lv'}->{'is_snap'}) {
	print "<tr> <td><b>$self->{'text_hash'}->{'lv_snapof'}</b></td> <td>\n";
	if ($self->{'in_hash'}->{'lv'}) {
		# Show which LV this is a snapshot of
		local @snapof = grep { $_->{'size'} == $self->{'lv'}->{'size'} &&
				       $_->{'has_snap'} } @{$self->{'lvs_array'}};
		if (@snapof == 1) {
			print "<tt>$snapof[0]->{'name'}</tt>";
			}
		else {
			print "<i>$self->{'text_hash'}->{'lv_nosnap'}</i>";
			}
		}
	else {
		# Allow selection of snapshot source
		print "<select name=snapof>\n";
		foreach $l (@{$self->{'lvs_array'}}) {
			print "<option>$l->{'name'}\n" if (!$l->{'is_snap'});
			}
		print "</select>\n";
		}
	print "</td> </tr>\n";
	}
elsif ($self->{'stat_array'}->[2]) {
	# Display current permissons and allocation method
	print "<tr> <td><b>$self->{'text_hash'}->{'lv_perm'}</b></td>\n";
	print "<td>",$self->{'text_hash'}->{"lv_perm".$self->{'lv'}->{'perm'}},"</td>\n";

	print "<td><b>$self->{'text_hash'}->{'lv_alloc'}</b></td>\n";
	print "<td>",$self->{'text_hash'}->{"lv_alloc".$self->{'lv'}->{'alloc'}},"</td> </tr>\n";
	}
else {
	# Allow editing of permissons and allocation method
	print "<tr> <td><b>$self->{'text_hash'}->{'lv_perm'}</b></td>\n";
	printf "<td><input type=radio name=perm value=rw %s> %s\n",
		$self->{'lv'}->{'perm'} eq 'rw' ? 'checked' : '', $self->{'text_hash'}->{'lv_permrw'};
	printf "<input type=radio name=perm value=r %s> %s</td>\n",
		$self->{'lv'}->{'perm'} eq 'r' ? 'checked' : '', $self->{'text_hash'}->{'lv_permr'};

	print "<td><b>$self->{'text_hash'}->{'lv_alloc'}</b></td>\n";
	printf "<td><input type=radio name=alloc value=y %s> %s\n",
		$self->{'lv'}->{'alloc'} eq 'y' ? 'checked' : '', $self->{'text_hash'}->{'lv_allocy'};
	printf "<input type=radio name=alloc value=n %s> %s</td> </tr>\n",
		$self->{'lv'}->{'alloc'} eq 'n' ? 'checked' : '', $self->{'text_hash'}->{'lv_allocn'};
	}

if (!$self->{'in_hash'}->{'lv'} && !$self->{'lv'}->{'is_snap'}) {
	# Allow selection of striping
	print "<tr> <td><b>$self->{'text_hash'}->{'lv_stripe'}</b></td> <td colspan=3>\n";
	printf "<input type=radio name=stripe_def value=1 checked> %s\n",
		$self->{'text_hash'}->{'lv_nostripe'};
	print "<input type=radio name=stripe_def value=0>\n";
	print $self->text('lv_stripes', "<input name=stripe size=4>"),
	      "</td> </tr>\n";
	}
elsif (!$self->{'lv'}->{'is_snap'}) {
	# Show current striping
	print "<tr> <td><b>$self->{'text_hash'}->{'lv_stripe'}</b></td> <td colspan=3>\n";
	if ($self->{'lv'}->{'stripes'} > 1) {
		print $self->text('lv_stripes', $self->{'lv'}->{'stripes'});
		}
	else {
		print $self->{'text_hash'}->{'lv_nostripe'};
		}
	print "</td> </tr>\n";
	}

# Show free disk space
if (@{$self->{'stat_array'}} && $self->{'stat_array'}->[2]) {
	($self->{'total'}, $self->{'free'}) = $main::mount_object->disk_space($self->{'stat_array'}->[1], $self->{'stat_array'}->[0]);

	print "<tr> <td><b>$self->{'text_hash'}->{'lv_freedisk'}</b></td> <td>\n";
	print $self->nice_size($self->{'free'}*1024),"</td>\n";

	print "<td><b>$self->{'text_hash'}->{'lv_free'}</b></td> <td>\n";
	printf "%d %%\n", $self->{'total'} ? 100 * $self->{'free'} / $self->{'total'} : 0;
	print "</td> </tr>\n";
	}

# Show extents on PVs
if ($self->{'in_hash'}->{'lv'}) {
	@{$self->{'pvinfo_array'}} = $self->get_logical_volume_usage($self->{'lv'});
	if (@{$self->{'pvinfo_array'}}) {
		@{$self->{'pvs_array'}} = $self->list_physical_volumes($self->{'in_hash'}->{'vg'});
		print "<tr> <td><b>$self->{'text_hash'}->{'lv_pvs'}</b></td> <td colspan=3>\n";
		foreach $p (@{$self->{'pvinfo_array'}}) {
			print " , \n" if ($p ne $self->{'pvinfo_array'}->[0]);
			($self->{'pv'}) = grep { $_->{'name'} eq $p->[0] } @{$self->{'pvs_array'}};
			print "<a href='edit_pv.cgi?vg=$self->{'in_hash'}->{'vg'}&pv=$self->{'pv'}->{'name'}'>$self->{'pv'}->{'name'}</a> ";
			print $self->nice_size($p->[1]*$self->{'pv'}->{'pe_size'}*1024),"\n";
			}
		print "</td> </tr>\n";
		}
	}

print "</table></td></tr></table>\n";
print "<table width=100%><tr>\n";
if ($self->{'stat_array'}->[2]) {
	print "<td><b>$self->{'text_hash'}->{'lv_cannot'}</b></td>\n";
	}
elsif ($self->{'in_hash'}->{'lv'}) {
	print "<td><input type=submit value='$self->{'text_hash'}->{'save'}'></td>\n";
	print "<td align=right><input type=submit name=delete ",
	      "value='$self->{'text_hash'}->{'delete'}'></td>\n";
	}
else {
	print "<td><input type=submit value='$self->{'text_hash'}->{'create'}'></td>\n";
	}
print "</tr></table></form>\n";

if ($self->{'in_hash'}->{'lv'} && !$self->{'stat_array'}->[2] && !$self->{'lv'}->{'is_snap'}) {
	# Show button for creating filesystems
	print "<hr>\n";
	print "<table width=100%><tr>\n";
	print "<form action=mkfs_form.cgi>\n";
	print "<input type=hidden name=dev value='$self->{'lv'}->{'device'}'>\n";
	print "<td nowrap><input type=submit value='$self->{'text_hash'}->{'lv_mkfs'}'>\n";
	print "<select name=fs>\n";
	foreach $f ($main::fdisk_object->supported_filesystems()) {
		printf "<option value=%s %s>%s (%s)\n",
			$f, $self->{'stat_array'}->[1] eq $f ? "selected" : "",
			$main::fdisk_object->{'text_hash'}->{"fs_$f"}, $f;
		}
	print "</select></td>\n";
	print "<td>$self->{'text_hash'}->{'lv_mkfsdesc'}</td>\n";
	print "</form></tr>\n";

	if (!@{$self->{'stat_array'}}) {
		# Show button for mounting
		$self->{'type'} = $self->{'config_hash'}->{'lasttype_'.$self->{'lv'}->{'device'}} || "ext2";
		print "<tr> <form action=../mount/edit_mount.cgi>\n";
		print "<input type=hidden name=type value=$self->{'type'}>\n";
		print "<input type=hidden name=newdev value=$self->{'lv'}->{'device'}>\n";
		print "<td valign=top>\n";
		print "<input type=submit value=\"",$self->{'text_hash'}->{'lv_newmount'},"\">\n";
		print "<input name=newdir size=20></td>\n";
		print "<td>$self->{'text_hash'}->{'lv_mountmsg'}</td> </tr>\n";
		print "</form> </tr>\n";
		}

	print "</table>\n";
	}

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

