#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_pv.cgi
# Display a form for editing or creating a physical volume

&ModuleLoader::preload_module('lvm_class', "lvm::LvmLib");
$self = new lvm::LvmLib:: 'lvm_class',%$self;

$self->foreign_require("fdisk", "fdisk-lib.pl");
$self->ReadParse();
($self->{'vg'}) = grep { $_->{'name'} eq $self->{'in_hash'}->{'vg'} } $self->list_volume_groups();

$self->{'vgdesc'} = $self->text('pv_vg', $self->{'vg'}->{'name'});
if ($self->{'in_hash'}->{'pv'}) {
	@{$self->{'pvs_array'}} = $self->list_physical_volumes($self->{'in_hash'}->{'vg'});
	($self->{'pv'}) = grep { $_->{'name'} eq $self->{'in_hash'}->{'pv'} } @{$self->{'pvs_array'}};
	$self->ui_print_header($self->{'vgdesc'}, $self->{'text_hash'}->{'pv_edit'}, "");
	}
else {
	$self->ui_print_header($self->{'vgdesc'}, $self->{'text_hash'}->{'pv_create'}, "");
	$self->{'pv'} = { 'alloc' => 'y' };
	}

print "<form action=save_pv.cgi>\n";
print "<input type=hidden name=vg value='$self->{'in_hash'}->{'vg'}'>\n";
print "<input type=hidden name=pv value='$self->{'in_hash'}->{'pv'}'>\n";
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'pv_header'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'pv_device'}</b></td> <td colspan=3>\n";
if ($self->{'in_hash'}->{'pv'}) {
	local $name = $self->foreign_call("mount", "device_name", $self->{'pv'}->{'device'});
	print "$name\n";
	}
else {
	$self->device_input();
	}
print "</td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'pv_alloc'}</b></td>\n";
printf "<td><input type=radio name=alloc value=y %s> %s\n",
	$self->{'pv'}->{'alloc'} eq 'y' ? 'checked' : '', $self->{'text_hash'}->{'yes'};
printf "<input type=radio name=alloc value=n %s> %s</td>\n",
	$self->{'pv'}->{'alloc'} eq 'n' ? 'checked' : '', $self->{'text_hash'}->{'no'};

if ($self->{'in_hash'}->{'pv'}) {
	print "<td><b>$self->{'text_hash'}->{'pv_size'}</b></td>\n";
	print "<td>",$self->nice_size($self->{'pv'}->{'size'}*1024),"</td> </tr>\n";

	print "<tr> <td><b>$self->{'text_hash'}->{'pv_petotal'}</b></td>\n";
	print "<td>",$self->text('lv_petotals', $self->{'pv'}->{'pe_alloc'}, $self->{'pv'}->{'pe_total'}),
	      "</td>\n";

	print "<td><b>$self->{'text_hash'}->{'pv_pesize'}</b></td>\n";
	print "<td>$self->{'pv'}->{'pe_size'} kB</td> </tr>\n";

	print "<tr> <td><b>$self->{'text_hash'}->{'pv_petotal2'}</b></td>\n";
	print "<td>",$self->text('lv_petotals', $self->nice_size($self->{'pv'}->{'pe_alloc'}*$self->{'pv'}->{'pe_size'}*1024), $self->nice_size($self->{'pv'}->{'pe_total'}*$self->{'pv'}->{'pe_size'}*1024)),
	      "</td>\n";

	print "</tr>\n";

	@{$self->{'lvinfo_array'}} = $self->get_physical_volume_usage($self->{'pv'});
	if (@{$self->{'lvinfo_array'}}) {
		@{$self->{'lvs_array'}} = $self->list_logical_volumes($self->{'in_hash'}->{'vg'});
		print "<tr> <td><b>$self->{'text_hash'}->{'pv_lvs'}</b></td> <td colspan=3>\n";
		foreach $l (@{$self->{'lvinfo_array'}}) {
			print " , \n" if ($l ne $self->{'lvinfo_array'}->[0]);
			($self->{'lv'}) = grep { $_->{'name'} eq $l->[0] } @{$self->{'lvs_array'}};
			print "<a href='edit_lv.cgi?vg=$self->{'in_hash'}->{'vg'}&lv=$self->{'lv'}->{'name'}'>$self->{'lv'}->{'name'}</a> ";
			print $self->nice_size($l->[2]*$self->{'pv'}->{'pe_size'}*1024),"\n";
			}
		print "</td> </tr>\n";
		}
	}
else {
	print "</tr>\n";
	}

print "</table></td></tr></table>\n";
print "<table width=100%><tr>\n";
if ($self->{'in_hash'}->{'pv'}) {
	print "<td><input type=submit value='$self->{'text_hash'}->{'save'}'></td>\n";
	print "<td align=right><input type=submit name=delete ",
	      " value='$self->{'text_hash'}->{'pv_delete2'}'></td>\n" if (@{$self->{'pvs_array'}} > 1);
	}
else {
	print "<td><input type=submit value='$self->{'text_hash'}->{'pv_create2'}'></td>\n";
	}
print "</tr></table>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

