#!/usr/bin/perl

&MAIN();

 sub MAIN {
# index.cgi
# Display a table of all volumne groups and their physical and logical volumes.

&ModuleLoader::preload_module('lvm_class', "lvm::LvmLib");
$self = new lvm::LvmLib:: 'lvm_class',%$self;


if (!$self->has_command("vgdisplay")) {
	&lvm_header();
	print "<p>",$self->text('index_ecommands', "<tt>vgdisplay</tt>"),"<p>\n";
	$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});
	exit;
	}
($self->{'lvm_version'}, $self->{'out'}) = $self->get_lvm_version();
if ($self->{'lvm_version'} && $self->{'lvm_version'} < 2) {
	# /proc/lvm doesn't exist in LVM 2
	if (!-d $self->{'lvm_proc'}) {
		system("modprobe lvm-mod >/dev/null 2>&1");
		}
	if (!-d $self->{'lvm_proc'}) {
		&lvm_header();
		print "<p>",$self->text('index_emodule', "<tt>$self->{'lvm_proc'}</tt>",
				  "<tt>lvm-mod</tt>"),"<p>\n";
		$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});
		exit;
		}
	}
if (!$self->{'lvm_version'}) {
	&lvm_header();
	print "<p>",$self->text('index_eversion', "<tt>vgdisplay --version</tt>",
			  "<pre>$self->{'out'}</pre>"),"<p>\n";
	$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});
	exit;
	}
&lvm_header();

# Show table of volume groups
@{$self->{'vgs_array'}} = $self->list_volume_groups();
if (@{$self->{'vgs_array'}}) {
	print "<table border width=100%>\n";
	print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'index_vgs'}</b></td> ",
	      "<td><b>$self->{'text_hash'}->{'index_pvs'}</b></td> ",
	      "<td><b>$self->{'text_hash'}->{'index_lvs'}</b></td> </tr>\n";
	foreach $v (sort { $a->{'number'} <=> $b->{'number'} } @{$self->{'vgs_array'}}) {
		# Show volume group icon
		print "<tr $self->{'cb'}> <td valign=top width=20%>\n";
		$self->icons_table( [ "edit_vg.cgi?vg=".$self->urlize($v->{'name'}) ],
			      [ $self->html_escape($v->{'name'}).
				"<br>".$self->nice_size($v->{'size'}*1024) ],
			      [ "images/vg.gif" ], 1);
		print $self->ui_links_row([
			"<a href='edit_vg.cgi'>$self->{'text_hash'}->{'index_add'}</a>" ]);
		print "</td> <td valign=top width=40%>\n";

		# Show physical volume icons
		local @pvs = sort { $a->{'number'} <=> $b->{'number'} }
				  $self->list_physical_volumes($v->{'name'});
		if (@pvs) {
			local (@icons, @titles, @links);
			@icons = map { "images/pv.gif" } @pvs;
			@titles = map { $self->html_escape($_->{'device'}).
					"<br>".$self->nice_size($_->{'size'}*1024) } @pvs;
			@links = map { "edit_pv.cgi?vg=".$self->urlize($v->{'name'}).
				       "&pv=".$self->urlize($_->{'name'}) } @pvs;
			$self->icons_table(\@links, \@titles, \@icons, 3);
			}
		else {
			print "<b>$self->{'text_hash'}->{'index_nopvs'}</b><p>\n";
			}
		print $self->ui_links_row([
			"<a href='edit_pv.cgi?vg=".$self->urlize($v->{'name'}).
			  "'>$self->{'text_hash'}->{'index_addpv'}</a>" ]);

		# Show logical volume icons
		print "</td> <td valign=top width=40%>\n";
		local @lvs = sort { $a->{'number'} <=> $b->{'number'} }
				  $self->list_logical_volumes($v->{'name'});
		if (@lvs) {
			@icons = map { $_->{'is_snap'} ? "images/snap.gif"
						       : "images/lv.gif" } @lvs;
			@titles = map { $self->html_escape($_->{'name'}).
					"<br>".$self->nice_size($_->{'size'}*1024) } @lvs;
			@links = map { "edit_lv.cgi?vg=".$self->urlize($v->{'name'}).
				       "&lv=".$self->urlize($_->{'name'}) } @lvs;
			$self->icons_table(\@links, \@titles, \@icons, 3);
			}
		else {
			print "<b>$self->{'text_hash'}->{'index_nolvs'}</b><p>\n";
			}
		print $self->ui_links_row([
			"<a href='edit_lv.cgi?vg=".$self->urlize($v->{'name'}).
			  "'>$self->{'text_hash'}->{'index_addlv'}</a>",
			@lvs ? (
			  "<a href='edit_lv.cgi?vg=".$self->urlize($v->{'name'}).
		            "&snap=1'>$self->{'text_hash'}->{'index_addsnap'}</a>" ) : ( )
			]);
		print "</td> </tr>\n";
		}
	print "</table><p>\n";
	}
else {
	print "<b>$self->{'text_hash'}->{'index_none'}</b> <p>\n";
	@{$self->{'tab_array'}} = $self->list_lvmtab();
	if (@{$self->{'tab_array'}}) {
		# Maybe LVM needs to be re-started
		print $self->text('index_init', "init.cgi"),"<p>\n";
		}
	print $self->ui_links_row([
		"<a href='edit_vg.cgi'>$self->{'text_hash'}->{'index_add'}</a>" ]);
	}

$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});

1;
		
}

sub lvm_header
{
	shift if ($self == $_[0]);

$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", undef, 0, 1, 0,
	$self->help_search_link("lvm", "man", "doc", "google"), undef, undef,
	$self->{'lvm_version'} ? $self->text('index_version', $self->{'lvm_version'}) : undef);
}


1;

