#!/usr/bin/perl

&MAIN();

 sub MAIN {
# mkfs.cgi
# Create a new filesystem on a logical volume

&ModuleLoader::preload_module('lvm_class', "lvm::LvmLib");
$self = new lvm::LvmLib:: 'lvm_class',%$self;

$self->foreign_require("proc", "proc-lib.pl");
$self->foreign_require("fdisk", "fdisk-lib.pl");

$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'mkfs_err'});
$self->foreign_call("fdisk", "error_setup", $self->{'text_hash'}->{'mkfs_err'});
$self->foreign_call("fdisk", "ReadParse");
$self->{'cmd'} = $self->foreign_call("fdisk", "mkfs_parse", $self->{'in_hash'}->{'fs'}, $self->{'in_hash'}->{'dev'});

$self->ui_print_unbuffered_header(undef, $self->{'text_hash'}->{'mkfs_title'}, "");
print $self->text('mkfs_exec', "<tt>$self->{'cmd'}</tt>"),"<p>\n";
print "<pre>\n";
$self->foreign_call("proc", "safe_process_exec_logged", $self->{'cmd'}, 0, 0, STDOUT, undef, 1);
print "</pre>\n";

if ($?) { print "<b>$self->{'text_hash'}->{'mkfs_failed'}</b> <p>\n"; }
else { print "$self->{'text_hash'}->{'mkfs_ok'} <p>\n"; }
$self->{'config_hash'}->{'lasttype_'.$self->{'in_hash'}->{'dev'}} = $self->{'in_hash'}->{'fs'};
$self->save_module_config();
$self->webmin_log("mkfs", "lv", $self->{'in_hash'}->{'dev'}, \%{$self->{'in_hash'}});

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

