#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_lv.cgi
# Create, update or delete a logical volume

&ModuleLoader::preload_module('lvm_class', "lvm::LvmLib");
$self = new lvm::LvmLib:: 'lvm_class',%$self;

$self->foreign_require("fdisk", "fdisk-lib.pl");
$self->ReadParse();

($self->{'vg'}) = grep { $_->{'name'} eq $self->{'in_hash'}->{'vg'} } $self->list_volume_groups();
($self->{'lv'}) = grep { $_->{'name'} eq $self->{'in_hash'}->{'lv'} } $self->list_logical_volumes($self->{'in_hash'}->{'vg'})
	if ($self->{'in_hash'}->{'lv'});

if ($self->{'in_hash'}->{'confirm'}) {
	# Delete the logical volume
	$self->error_setup($self->{'text_hash'}->{'lv_err2'});
	$self->{'err'} = $self->delete_logical_volume($self->{'lv'});
	$self->error("<pre>$self->{'err'}</pre>") if ($self->{'err'});
	$self->webmin_log("delete", "lv", $self->{'in_hash'}->{'lv'}, $self->{'lv'});
	$self->redirect("");
	}
elsif ($self->{'in_hash'}->{'delete'}) {
	# Ask the user if he is sure
	$self->ui_print_header(undef, $self->{'text_hash'}->{'lv_delete'}, "");
	print "<center><form action=save_lv.cgi>\n";
	print "<input type=hidden name=vg value='$self->{'in_hash'}->{'vg'}'>\n";
	print "<input type=hidden name=lv value='$self->{'in_hash'}->{'lv'}'>\n";
	print "<b>",$self->text($self->{'lv'}->{'is_snap'} ? 'lv_rusnap' : 'lv_rusure',
			  "<tt>$self->{'lv'}->{'device'}</tt>"),"</b><p>\n";
	print "<input type=submit name=confirm ",
	      "value='$self->{'text_hash'}->{'lv_deleteok'}'>\n";
	print "</center></form>\n";
	$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
	}
else {
	# Validate inputs
	$self->error_setup($self->{'text_hash'}->{'lv_err'});
	$self->{'in_hash'}->{'name'} =~ /^[A-Za-z0-9\.\-\_]+$/ || $self->error($self->{'text_hash'}->{'lv_ename'});
	($self->{'same'}) = grep { $_->{'name'} eq $self->{'in_hash'}->{'name'} }
		       $self->list_logical_volumes($self->{'in_hash'}->{'vg'});
	$self->{'same'} && (!$self->{'in_hash'}->{'lv'} || $self->{'in_hash'}->{'lv'} ne $self->{'in_hash'}->{'name'}) &&
		$self->error($self->{'text_hash'}->{'lv_esame'});
	$self->{'in_hash'}->{'size'} =~ /^\d+$/ || $self->error($self->{'text_hash'}->{'lv_esize'});
	$self->{'in_hash'}->{'snap'} || $self->{'in_hash'}->{'lv'} || $self->{'in_hash'}->{'stripe_def'} ||
		$self->{'in_hash'}->{'stripe'} =~ /^[1-9]\d*$/ || $self->error($self->{'text_hash'}->{'lv_estripe'});

	if (!$self->{'in_hash'}->{'lv'}) {
		# Just create the logical volume
		$self->{'lv'}->{'vg'} = $self->{'in_hash'}->{'vg'};
		$self->{'lv'}->{'name'} = $self->{'in_hash'}->{'name'};
		$self->{'lv'}->{'size'} = $self->{'in_hash'}->{'size'};
		if ($self->{'in_hash'}->{'snap'}) {
			$self->{'lv'}->{'is_snap'} = 1;
			$self->{'lv'}->{'snapof'} = $self->{'in_hash'}->{'snapof'};
			}
		else {
			$self->{'lv'}->{'perm'} = $self->{'in_hash'}->{'perm'};
			$self->{'lv'}->{'alloc'} = $self->{'in_hash'}->{'alloc'};
			$self->{'lv'}->{'stripe'} = $self->{'in_hash'}->{'stripe'} if (!$self->{'in_hash'}->{'stripe_def'});
			}
		$self->{'err'} = $self->create_logical_volume($self->{'lv'});
		$self->error("<pre>$self->{'err'}</pre>") if ($self->{'err'});
		$self->webmin_log("create", "lv", $self->{'in_hash'}->{'name'}, $self->{'lv'});
		}
	elsif ($self->{'lv'}->{'is_snap'}) {
		# Modifying a snapshot
		if ($self->{'lv'}->{'size'} != $self->{'in_hash'}->{'size'}) {
			$self->{'err'} = $self->resize_logical_volume($self->{'lv'}, $self->{'in_hash'}->{'size'});
			$self->error("<pre>$self->{'err'}</pre>") if ($self->{'err'});
			$self->{'lv'}->{'size'} = $self->{'in_hash'}->{'size'};
			}
		if ($self->{'lv'}->{'name'} ne $self->{'in_hash'}->{'name'}) {
			# Need to rename
			$self->{'err'} = $self->rename_logical_volume($self->{'lv'}, $self->{'in_hash'}->{'name'});
			$self->error("<pre>$self->{'err'}</pre>") if ($self->{'err'});
			$self->{'lv'}->{'name'} = $self->{'in_hash'}->{'name'};
			}
		}
	else {
		# Modifying the logical volume
		@{$self->{'stat_array'}} = $self->device_status($self->{'lv'}->{'device'});
		if ($self->{'lv'}->{'size'} != $self->{'in_hash'}->{'size'}) {
			# Is the new size too big?
			local $nblocks = int($self->{'in_hash'}->{'size'} / $self->{'vg'}->{'pe_size'})+1;
			local $oblocks = int($self->{'lv'}->{'size'} / $self->{'vg'}->{'pe_size'})+1;
			if ($self->{'vg'}->{'pe_alloc'} - $oblocks + $nblocks > $self->{'vg'}->{'pe_total'}) {
				#$self->error($self->text('lv_toobig', $nblocks, "$self->{'vg'}->{'pe_size'} kB", $self->{'vg'}->{'pe_total'} - $self->{'vg'}->{'pe_alloc'}));
				}

			local $realsize = $nblocks * $self->{'vg'}->{'pe_size'};
			if ($self->{'in_hash'}->{'sizeconfirm'}) {
				# Just resize the logical volume
				$self->{'err'} = $self->resize_logical_volume($self->{'lv'}, $realsize);
				$self->error("<pre>$self->{'err'}</pre>") if ($self->{'err'});
				}
			else {
				local $can = $self->can_resize_filesystem($self->{'stat_array'}->[1]);
				if ($can == 2 ||
				    $can == 1 && $realsize > $self->{'lv'}->{'size'}) {
					# Attempt to resize properly
					$self->{'err'} = $self->resize_filesystem($self->{'lv'}, $self->{'stat_array'}->[1], $realsize);
					if ($self->{'err'}) {
						$self->{'err'} = $self->text('resize_fs', $self->{'stat_array'}->[1], "</center><pre>$self->{'err'}</pre><center>");
						}
					}
				else {
					# Cannot resize .. ask for confirmation
					$self->{'err'} = @{$self->{'stat_array'}} && $self->{'stat_array'}->[1] ne '*' &&
					       $self->{'stat_array'}->[1] ne 'auto' ?
						$self->text('resize_mesg', $self->{'stat_array'}->[1]) :
						$self->{'text_hash'}->{'resize_mesg2'};
					}
				if ($self->{'err'}) {
					$self->ui_print_header(undef, $self->{'text_hash'}->{'resize_title'}, "");
					print "<center><form action=save_lv.cgi>\n";
					foreach $i (keys %{$self->{'in_hash'}}) {
						print "<input type=hidden name=$i value='$self->{'in_hash'}->{$i}'>\n";
						}
					print "<b>$self->{'err'}</b> <p>\n";
					print "<input type=submit name=sizeconfirm value='$self->{'text_hash'}->{'resize_ok'}'>\n";
					print "</form></center>\n";
					$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
					exit;
					}
				}
			$self->{'lv'}->{'size'} = $realsize;
			}
		if ($self->{'lv'}->{'perm'} ne $self->{'in_hash'}->{'perm'} ||
		    $self->{'lv'}->{'alloc'} ne $self->{'in_hash'}->{'alloc'}) {
			# Need to change options
			$self->{'lv'}->{'perm'} = $self->{'in_hash'}->{'perm'};
			$self->{'lv'}->{'alloc'} = $self->{'in_hash'}->{'alloc'};
			$self->{'err'} = $self->change_logical_volume($self->{'lv'});
			$self->error("<pre>$self->{'err'}</pre>") if ($self->{'err'});
			}
		if ($self->{'lv'}->{'name'} ne $self->{'in_hash'}->{'name'}) {
			# Need to rename
			$self->{'err'} = $self->rename_logical_volume($self->{'lv'}, $self->{'in_hash'}->{'name'});
			$self->error("<pre>$self->{'err'}</pre>") if ($self->{'err'});
			$self->{'lv'}->{'name'} = $self->{'in_hash'}->{'name'};
			}
		$self->webmin_log("modify", "lv", $self->{'in_hash'}->{'lv'}, $self->{'lv'});
		}
	$self->redirect("");
	}

1;
		
}


1;

