#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_vg.cgi
# Create, update or delete a volume group

&ModuleLoader::preload_module('lvm_class', "lvm::LvmLib");
$self = new lvm::LvmLib:: 'lvm_class',%$self;

$self->ReadParse();

($self->{'vg'}) = grep { $_->{'name'} eq $self->{'in_hash'}->{'vg'} } $self->list_volume_groups()
	if ($self->{'in_hash'}->{'vg'});

if ($self->{'in_hash'}->{'confirm'}) {
	# Delete the volume group
	$self->error_setup($self->{'text_hash'}->{'vg_err2'});
	$self->{'err'} = $self->delete_volume_group($self->{'vg'});
	$self->error("<pre>$self->{'err'}</pre>") if ($self->{'err'});
	$self->webmin_log("delete", "vg", $self->{'in_hash'}->{'vg'}, $self->{'vg'});
	$self->redirect("");
	}
elsif ($self->{'in_hash'}->{'delete'}) {
	# Ask the user if he is sure
	$self->ui_print_header(undef, $self->{'text_hash'}->{'vg_delete'}, "");
	@{$self->{'lvs_array'}} = $self->list_logical_volumes($self->{'in_hash'}->{'vg'});
	if (@{$self->{'lvs_array'}}) {
		print "<p><b>",$self->text('vg_cannot', scalar(@{$self->{'lvs_array'}})),"</b> <p>\n";
		}
	else {
		print "<center><form action=save_vg.cgi>\n";
		print "<input type=hidden name=vg value='$self->{'in_hash'}->{'vg'}'>\n";
		print "<b>",$self->text('vg_rusure', $self->{'vg'}->{'name'}),"</b><p>\n";
		print "<input type=submit name=confirm ",
		      "value='$self->{'text_hash'}->{'vg_deleteok'}'>\n";
		print "</center></form>\n";
		}
	$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
	}
else {
	$self->error_setup($self->{'text_hash'}->{'vg_err'});
	$self->{'in_hash'}->{'name'} =~ /^[A-Za-z0-9\.\-\_]+$/ || $self->error($self->{'text_hash'}->{'vg_ename'});
	if (!$self->{'in_hash'}->{'vg'}) {
		# Add the volume group
		$self->{'vg'} = { 'name' => $self->{'in_hash'}->{'name'} };
		local $device;
		if ($self->{'in_hash'}->{'device'}) {
			$device = $self->{'in_hash'}->{'device'};
			}
		else {
			-r $self->{'in_hash'}->{'other'} || $self->error($self->{'text_hash'}->{'pv_eother'});
			$device = $self->{'in_hash'}->{'other'};
			}
		if (!$self->{'in_hash'}->{'pesize_def'}) {
			$self->{'in_hash'}->{'pesize'} =~ /^\d+$/ || $self->error($self->{'text_hash'}->{'vg_epesize'});
			$self->{'vg'}->{'pe_size'} = $self->{'in_hash'}->{'pesize'};
			}
		$self->{'err'} = $self->create_volume_group($self->{'vg'}, $device);
		$self->error("<pre>$self->{'err'}</pre>") if ($self->{'err'});
		$self->webmin_log("create", "vg", $self->{'in_hash'}->{'name'}, $self->{'vg'});
		}
	else {
		# Rename the volume group
		if ($self->{'vg'}->{'name'} ne $self->{'in_hash'}->{'name'}) {
			$self->{'err'} = $self->rename_volume_group($self->{'vg'}, $self->{'in_hash'}->{'name'});
			$self->error("<pre>$self->{'err'}</pre>") if ($self->{'err'});
			$self->{'vg'}->{'name'} = $self->{'in_hash'}->{'name'};
			}
		$self->webmin_log("modify", "vg", $self->{'in_hash'}->{'vg'}, $self->{'vg'});
		}
	$self->redirect("");
	}

1;
		
}


1;

