#!/usr/bin/perl
package mailboxes::Acl_security;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'mailboxes::Acl_security');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;

&ModuleLoader::preload_module(ref($self), "mailboxes::MailboxesLib");
$self = new mailboxes::MailboxesLib:: ref($self), %$self; 

1;
		return $self;
}

# acl_security_form(&options)
# Output HTML for editing security options for the sendmail module
sub acl_security_form
{
	my $self = shift;

# Users whose mail can be read
print "<tr> <td valign=top><b>$self->{'text_hash'}->{'acl_read'}</b></td> <td colspan=3>\n";
printf "<input type=radio name=mmode value=0 %s> $self->{'text_hash'}->{'acl_none'}\n",
	$_[0]->{'mmode'} == 0 ? "checked" : "";

printf "<input type=radio name=mmode value=4 %s> $self->{'text_hash'}->{'acl_same'}\n",
	$_[0]->{'mmode'} == 4 ? "checked" : "";

printf "<input type=radio name=mmode value=1 %s> $self->{'text_hash'}->{'acl_all'}<br>\n",
	$_[0]->{'mmode'} == 1 ? "checked" : "";

printf "<input type=radio name=mmode value=2 %s> $self->{'text_hash'}->{'acl_users'}\n",
	$_[0]->{'mmode'} == 2 ? "checked" : "";
printf "<input name=musers size=40 value='%s'> %s<br>\n",
	$_[0]->{'mmode'} == 2 ? $_[0]->{'musers'} : "",
	$self->user_chooser_button("musers", 1);

printf "<input type=radio name=mmode value=3 %s> $self->{'text_hash'}->{'acl_userse'}\n",
	$_[0]->{'mmode'} == 3 ? "checked" : "";
printf "<input name=muserse size=40 value='%s'> %s<br>\n",
	$_[0]->{'mmode'} == 3 ? $_[0]->{'musers'} : "",
	$self->user_chooser_button("muserse", 1);

printf "<input type=radio name=mmode value=5 %s> $self->{'text_hash'}->{'acl_usersg'}\n",
	$_[0]->{'mmode'} == 5 ? "checked" : "";
printf "<input name=musersg size=30 value='%s'> %s\n",
	$_[0]->{'mmode'} == 5 ? join(" ", map { scalar(getgrgid($_)) }
				     split(/\s+/, $_[0]->{'musers'})) : "",
	$self->group_chooser_button("musersg", 1);
printf "<input type=checkbox name=msec value=1 %s> %s<br>\n",
	$_[0]->{'msec'} ? "checked" : "", $self->{'text_hash'}->{'acl_sec'};

printf "<input type=radio name=mmode value=7 %s> $self->{'text_hash'}->{'acl_usersu'}\n",
	$_[0]->{'mmode'} == 7 ? "checked" : "";
printf "<input name=musersu1 size=6 value='%s'> -\n",
	$_[0]->{'mmode'} == 7 ? $_[0]->{'musers'} : "";
printf "<input name=musersu2 size=6 value='%s'><br>\n",
	$_[0]->{'mmode'} == 7 ? $_[0]->{'musers2'} : "";

printf "<input type=radio name=mmode value=6 %s> $self->{'text_hash'}->{'acl_usersm'}\n",
	$_[0]->{'mmode'} == 6 ? "checked" : "";
printf "<input name=musersm size=15 value='%s'></td> </tr>\n",
	$_[0]->{'mmode'} == 6 ? $_[0]->{'musers'} : "";

# Directory for arbitrary files
print "<tr> <td valign=top><b>$self->{'text_hash'}->{'acl_dir'}</b></td> <td colspan=3>\n";
print $self->ui_opt_textbox("dir", $_[0]->{'dir'}, 40, $self->{'text_hash'}->{'acl_dirauto'}."<br>");
print "</td> </tr>\n";

# Allowed From: addresses
print "<tr> <td valign=top><b>$self->{'text_hash'}->{'acl_from'}</b></td> <td colspan=3>\n";
printf "<input type=radio name=fmode value=0 %s> $self->{'text_hash'}->{'acl_any'}<br>\n",
	$_[0]->{'fmode'} == 0 ? "checked" : "";
printf "<input type=radio name=fmode value=1 %s> $self->{'text_hash'}->{'acl_fdoms'}\n",
	$_[0]->{'fmode'} == 1 ? "checked" : "";
printf "<input name=fdoms size=40 value='%s'><br>\n",
	$_[0]->{'fmode'} == 1 ? $_[0]->{'from'} : '';
printf "<input type=radio name=fmode value=2 %s> $self->{'text_hash'}->{'acl_faddrs'}\n",
	$_[0]->{'fmode'} == 2 ? "checked" : "";
printf "<input name=faddrs size=40 value='%s'><br>\n",
	$_[0]->{'fmode'} == 2 ? $_[0]->{'from'} : '';
printf "<input type=radio name=fmode value=3 %s> $self->{'text_hash'}->{'acl_fdom'}\n",
	$_[0]->{'fmode'} == 3 ? "checked" : "";
printf "<input name=fdom size=20 value='%s'><br>\n",
	$_[0]->{'fmode'} == 3 ? $_[0]->{'from'} : '';
print "</td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'acl_fromname'}</b></td>\n";
print "<td colspan=3><input name=fromname size=40 ",
      "value='$_[0]->{'fromname'}'></td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'acl_attach'}</b></td> <td colspan=3>\n";
printf "<input type=radio name=attach_def value=1 %s> %s\n",
	$_[0]->{'attach'}<0 ? 'checked' : '', $self->{'text_hash'}->{'acl_unlimited'};
printf "<input type=radio name=attach_def value=0 %s>\n",
	$_[0]->{'attach'}<0 ? '' : 'checked';
printf "<input name=attach size=5 value='%s'> kB\n",
	$_[0]->{'attach'}<0 ? '' : $_[0]->{'attach'};
print "</td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'acl_canattach'}</b></td>\n";
printf "<td><input type=radio name=canattach value=1 %s> %s\n",
	$_[0]->{'canattach'} ? 'checked' : '', $self->{'text_hash'}->{'yes'};
printf "<input type=radio name=canattach value=0 %s> %s</td>\n",
	$_[0]->{'canattach'} ? '' : 'checked', $self->{'text_hash'}->{'no'};

print "<td><b>$self->{'text_hash'}->{'acl_candetach'}</b></td>\n";
printf "<td><input type=radio name=candetach value=1 %s> %s\n",
	$_[0]->{'candetach'} ? 'checked' : '', $self->{'text_hash'}->{'yes'};
printf "<input type=radio name=candetach value=0 %s> %s</td> </tr>\n",
	$_[0]->{'candetach'} ? '' : 'checked', $self->{'text_hash'}->{'no'};
}

# acl_security_save(&options)
# Parse the form for security options for the sendmail module
sub acl_security_save
{
	my $self = shift;

$_[0]->{'mmode'} = $self->{'in_hash'}->{'mmode'};
$_[0]->{'musers'} = $self->{'in_hash'}->{'mmode'} == 2 ? $self->{'in_hash'}->{'musers'} :
		    $self->{'in_hash'}->{'mmode'} == 3 ? $self->{'in_hash'}->{'muserse'} :
		    $self->{'in_hash'}->{'mmode'} == 5 ? join(" ", map { scalar(getgrnam($_)) }
					     split(/\s+/, $self->{'in_hash'}->{'musersg'})) :
		    $self->{'in_hash'}->{'mmode'} == 6 ? $self->{'in_hash'}->{'musersm'} :
		    $self->{'in_hash'}->{'mmode'} == 7 ? $self->{'in_hash'}->{'musersu1'} : "";
$_[0]->{'musers2'} = $self->{'in_hash'}->{'mmode'} == 7 ? $self->{'in_hash'}->{'musersu2'} : "";
$_[0]->{'msec'} = $self->{'in_hash'}->{'msec'};
$_[0]->{'fmode'} = $self->{'in_hash'}->{'fmode'};
$_[0]->{'from'} = $self->{'in_hash'}->{'fmode'} == 0 ? undef :
		  $self->{'in_hash'}->{'fmode'} == 1 ? $self->{'in_hash'}->{'fdoms'} :
		  $self->{'in_hash'}->{'fmode'} == 2 ? $self->{'in_hash'}->{'faddrs'} : $self->{'in_hash'}->{'fdom'};
$_[0]->{'fromname'} = $self->{'in_hash'}->{'fromname'};
$_[0]->{'attach'} = $self->{'in_hash'}->{'attach_def'} ? -1 : $self->{'in_hash'}->{'attach'};
$_[0]->{'canattach'} = $self->{'in_hash'}->{'canattach'};
$_[0]->{'candetach'} = $self->{'in_hash'}->{'candetach'};
$_[0]->{'dir'} = $self->{'in_hash'}->{'dir_def'} ? undef : $self->{'in_hash'}->{'dir'};
}


1;

