#!/usr/bin/perl
package mailboxes::Log_parser;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'mailboxes::Log_parser');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# log_parser.pl
# Functions for parsing this module's logs

&ModuleLoader::preload_module(ref($self), "mailboxes::MailboxesLib");
$self = new mailboxes::MailboxesLib:: ref($self), %$self; 

1;
		return $self;
}

# parse_webmin_log(user, script, action, type, object, &params)
# Converts logged information from this module into human-readable form
sub parse_webmin_log
{
	my $self = shift;

local ($user, $script, $action, $type, $object, $p, $long) = @_;
if ($action eq 'delmail') {
	return $self->text("log_delmail", $p->{'count'}, "<tt>$p->{'from'}</tt>");
	}
elsif ($action eq 'movemail') {
	return $self->text("log_movemail", $p->{'count'}, "<tt>$p->{'from'}</tt>",
		     "<tt>$p->{'to'}</tt>");
	}
elsif ($action eq 'copymail') {
	return $self->text("log_copymail", $p->{'count'}, "<tt>$p->{'from'}</tt>",
		     "<tt>$p->{'to'}</tt>");
	}
elsif ($action eq 'send') {
	return $self->text('log_send', $self->html_escape($self->extract_email($p->{'to'})));
	}
elsif ($action eq 'read') {
	return $self->text('log_read', $self->html_escape($object));
	}
else {
	return undef;
	}
}

sub extract_email
{
	my $self = shift;

if ($_[0] =~ /([^<>"' \(\)]+\@[^<>"' \(\)]+)/) {
	return $1;
	}
elsif ($_[0] =~ /<(\S+)>/) {
	return $1;
	}
else {
	return $_[0];
	}
}


1;

