#!/usr/bin/perl
package mailboxes::Makelang;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'mailboxes::Makelang');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;

@ARGV == 1 || die "usage: makelang.pl <language>";

$self->{'usermin'} = "/usr/local/useradmin/mailbox/ulang";
$self->{'mailboxes'} = "/usr/local/webadmin/mailboxes/lang";
$self->{'sendmail'} = "/usr/local/webadmin/sendmail/lang";

$self->read_file("$self->{'mailboxes'}/en", \%{$self->{'emailboxes_hash'}}, \@{$self->{'eorder_array'}});
$self->read_file("$self->{'sendmail'}/en", \%{$self->{'esendmail_hash'}});
$self->read_file("$self->{'usermin'}/en", \%{$self->{'eusermin_hash'}});

$self->read_file("$self->{'mailboxes'}/$ARGV[0]", \%{$self->{'fmailboxes_hash'}});
$self->read_file("$self->{'sendmail'}/$ARGV[0]", \%{$self->{'fsendmail_hash'}});
$self->read_file("$self->{'usermin'}/$ARGV[0]", \%{$self->{'fusermin_hash'}});

foreach $k (@{$self->{'eorder_array'}}) {
	if ($self->{'emailboxes_hash'}->{$k} eq $self->{'esendmail_hash'}->{$k} &&
	    $self->{'fsendmail_hash'}->{$k} &&
	    $self->{'fsendmail_hash'}->{$k} ne $self->{'esendmail_hash'}->{$k}) {
		print "$k=$self->{'fsendmail_hash'}->{$k}\n";
		}
	elsif ($self->{'emailboxes_hash'}->{$k} eq $self->{'eusermin_hash'}->{$k} &&
	       $self->{'fusermin_hash'}->{$k} &&
	       $self->{'fusermin_hash'}->{$k} ne $self->{'eusermin_hash'}->{$k}) {
		print "$k=$self->{'fusermin_hash'}->{$k}\n";
		}
	}

1;
		return $self;
}

# read_file(file, &assoc, [&order], [lowercase])
# Fill an associative array with name=value pairs from a file
sub read_file
{
	my $self = shift;

local $_;
open(ARFILE, $_[0]) || return 0;
while(<ARFILE>) {
	chomp;
	local $hash = index($_, "#");
	local $eq = index($_, "=");
	if ($hash != 0 && $eq >= 0) {
		local $n = substr($_, 0, $eq);
		local $v = substr($_, $eq+1);
		$_[1]->{$_[3] ? lc($n) : $n} = $v;
		push(@{$_[2]}, $n) if ($_[2]);
        	}
        }
close(ARFILE);
if (defined($main::read_file_cache{$_[0]})) {
	%{$main::read_file_cache{$_[0]}} = %{$_[1]};
	}
return 1;
}


1;

