#!/usr/bin/perl
package mailboxes::Useradmin_update;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'mailboxes::Useradmin_update');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;

&ModuleLoader::preload_module(ref($self), "mailboxes::MailboxesLib");
$self = new mailboxes::MailboxesLib:: ref($self), %$self; 

1;

1;
		return $self;
}

# useradmin_create_user(&details)
# Create a new empty mail file
sub useradmin_create_user
{
	my $self = shift;

if ($self->{'config_hash'}->{'sync_create'}) {
	local ($dir, $style, $mailbox, $maildir) = $self->get_mail_style();
	if ($dir && -d $dir) {
		# Create mail file like /var/mail/USERNAME
		local $mf = $self->mail_file_style($_[0]->{'user'}, $dir, $style);
		if (!-e $mf) {
			$self->create_mail_file($_[0], $mf);
			}
		}
	if ($mailbox && !-e "$_[0]->{'home'}/$mailbox") {
		# Create mail file ~USERNAME/Mailbox
		$self->create_mail_file($_[0], "$_[0]->{'home'}/$mailbox");
		}
	if ($maildir && !-e "$_[0]->{'home'}/$maildir") {
		# Create mail directory like ~USERNAME/Maildir
		$self->create_mail_dir($_[0], "$_[0]->{'home'}/$maildir");
		}
	}
}

# create_mail_file(&user, file)
sub create_mail_file
{
	my $self = shift;

open(TOUCH, ">$_[1]");
close(TOUCH);
if ($self->{'config_hash'}->{'sync_perms'}) {
	system("chmod ".
	       quotemeta($self->{'config_hash'}->{'sync_perms'})." ".
	       quotemeta($_[1]));
	}
chown($_[0]->{'uid'}, $_[0]->{'gid'}, $_[1]);
}

# create_mail_dir(&user, dir)
sub create_mail_dir
{
	my $self = shift;

local $d;
foreach $d ($_[1], "$_[0]/cur", "$_[1]/tmp", "$_[1]/new") {
	mkdir($d, 0700);
	if ($self->{'config_hash'}->{'sync_perms'}) {
		system("chmod ".
		       quotemeta($self->{'config_hash'}->{'sync_perms'})." ".
		       quotemeta($d));
		}
	chown($_[0]->{'uid'}, $_[0]->{'gid'}, $d);
	}
}

# useradmin_delete_user(&details)
# Delete the user's mail file
sub useradmin_delete_user
{
	my $self = shift;

if ($self->{'config_hash'}->{'sync_delete'}) {
	local ($dir, $style, $mailbox, $maildir) = $self->get_mail_style();
	if ($dir && -d $dir) {
		local $mf = $self->mail_file_style($_[0]->{'user'}, $dir, $style);
		unlink($mf);
		unlink($mf.".pop");
		}
	}
}

# useradmin_modify_user(&details, &old)
# Rename the user's mail file if necessary, and change it's UID
sub useradmin_modify_user
{
	my $self = shift;

if ($self->{'config_hash'}->{'sync_modify'} &&
    ($_[0]->{'user'} ne $_[1]->{'user'} || $_[0]->{'uid'} != $_[1]->{'uid'})) {
	local ($dir, $style, $mailbox, $maildir) = $self->get_mail_style();
	if ($dir && -d $dir) {
		local $omf = $self->mail_file_style($_[0]->{'olduser'}, $dir, $style);
		local $nmf = $self->mail_file_style($_[0]->{'user'}, $dir, $style);
		local @st = stat($omf);
		if ($st[4] != $_[0]->{'uid'}) {
			chown($_[0]->{'uid'}, $st[5], $omf);
			}
		if ($omf ne $nmf && -e $omf) {
			$self->rename_logged($omf, $nmf);
			}
		}
	}
}


1;

