#!/usr/bin/perl

&MAIN();

 sub MAIN {
# delete_mail.cgi
# Delete, mark, move or copy multiple messages

&ModuleLoader::preload_module('mailboxes_class', "mailboxes::MailboxesLib");
$self = new mailboxes::MailboxesLib:: 'mailboxes_class',%$self;

$self->ReadParse();
$self->can_user($self->{'in_hash'}->{'user'}) || $self->error($self->{'text_hash'}->{'mail_ecannot'});
@{$self->{'delete_array'}} = sort { $a <=> $b } split(/\0/, $self->{'in_hash'}->{'d'});
@{$self->{'folders_array'}} = $self->list_user_folders($self->{'in_hash'}->{'user'});
$self->{'folder'} = $self->{'folders_array'}->[$self->{'in_hash'}->{'folder'}];

if ($self->{'in_hash'}->{'mark1'} || $self->{'in_hash'}->{'mark2'}) {
	# Marking emails with some status
	@{$self->{'delete_array'}} || $self->error($self->{'text_hash'}->{'delete_emnone'});
	@{$self->{'mail_array'}} = $self->mailbox_list_mails($self->{'delete_array'}->[0], $self->{'delete_array'}->[@{$self->{'delete_array'}}-1], $self->{'folder'});
	dbmopen(%{$self->{'read_hash'}}, "$self->{'module_config_directory'}/$self->{'in_hash'}->{'user'}.read", 0600);
	local $m = $self->{'in_hash'}->{'mark1'} ? $self->{'in_hash'}->{'mode1'} : $self->{'in_hash'}->{'mode2'};
	foreach $d (@{$self->{'delete_array'}}) {
		local $hid = $self->{'mail_array'}->[$d]->{'header'}->{'message-id'};
		if ($m) {
			$self->{'read_hash'}->{$hid} = $m;
			}
		else {
			delete($self->{'read_hash'}->{$hid});
			}
		}
	dbmclose(%{$self->{'read_hash'}});
	$self->{'perpage'} = $self->{'folder'}->{'perpage'} || $self->{'config_hash'}->{'perpage'};
	$self->redirect("list_mail.cgi?start=$self->{'in_hash'}->{'start'}&folder=$self->{'in_hash'}->{'folder'}&user=$self->{'in_hash'}->{'user'}");
	}
elsif ($self->{'in_hash'}->{'move1'} || $self->{'in_hash'}->{'move2'}) {
	# Moving mails to some other user's inbox
	$self->check_modification($self->{'folder'});
	@{$self->{'delete_array'}} || $self->error($self->{'text_hash'}->{'delete_emovenone'});
	$self->{'muser'} = $self->{'in_hash'}->{'move1'} ? $self->{'in_hash'}->{'mfolder1'} : $self->{'in_hash'}->{'mfolder2'};
	$self->can_user($self->{'muser'}) || $self->error($self->{'text_hash'}->{'delete_emovecannot'});
	@{$self->{'mfolders_array'}} = $self->list_user_folders($self->{'muser'});
	@{$self->{'mfolders_array'}} || $self->error($self->{'text_hash'}->{'delete_emoveuser'});

	@{$self->{'mail_array'}} = $self->mailbox_list_mails($self->{'delete_array'}->[0], $self->{'delete_array'}->[@{$self->{'delete_array'}}-1], $self->{'folder'});
	foreach $d (@{$self->{'delete_array'}}) {
		$self->{'mail_array'}->[$d] || $self->error($self->{'text_hash'}->{'mail_eexists'});
		push(@{$self->{'movemail_array'}}, $self->{'mail_array'}->[$d]);
		}
	$self->lock_folder($self->{'folder'});
	$self->lock_folder($self->{'mfolder'});
	$self->mailbox_move_mail($self->{'folder'}, $self->{'mfolders_array'}->[0], @{$self->{'movemail_array'}});
	$self->unlock_folder($self->{'mfolder'});
	$self->unlock_folder($self->{'folder'});
	$self->webmin_log("movemail", undef, undef, { 'from' => $self->{'folder'}->{'file'},
						'to' => $self->{'mfolders_array'}->[0]->{'file'},
						'count' => scalar(@{$self->{'delete_array'}}) } );
	$self->redirect("list_mail.cgi?start=$self->{'in_hash'}->{'start'}&folder=$self->{'in_hash'}->{'folder'}&user=$self->{'in_hash'}->{'user'}");
	}
elsif ($self->{'in_hash'}->{'copy1'} || $self->{'in_hash'}->{'copy2'}) {
	# Copying mails to some other folder
	@{$self->{'delete_array'}} || $self->error($self->{'text_hash'}->{'delete_ecopynone'});
	$self->{'cuser'} = $self->{'in_hash'}->{'copy1'} ? $self->{'in_hash'}->{'mfolder1'} : $self->{'in_hash'}->{'mfolder2'};
	$self->can_user($self->{'cuser'}) || $self->error($self->{'text_hash'}->{'delete_ecopycannot'});
	@{$self->{'cfolders_array'}} = $self->list_user_folders($self->{'cuser'});
	@{$self->{'cfolders_array'}} || $self->error($self->{'text_hash'}->{'delete_ecopyuser'});

	@{$self->{'mail_array'}} = $self->mailbox_list_mails($self->{'delete_array'}->[0], $self->{'delete_array'}->[@{$self->{'delete_array'}}-1], $self->{'folder'});
	foreach $d (@{$self->{'delete_array'}}) {
		$self->{'mail_array'}->[$d] || $self->error($self->{'text_hash'}->{'mail_eexists'});
		push(@{$self->{'copymail_array'}}, $self->{'mail_array'}->[$d]);
		}
	$self->lock_folder($self->{'cfolder'});
	$self->mailbox_copy_mail($self->{'folder'}, $self->{'cfolders_array'}->[0], @{$self->{'copymail_array'}});
	$self->unlock_folder($self->{'cfolder'});
	$self->webmin_log("copymail", undef, undef, { 'from' => $self->{'folder'}->{'file'},
						'to' => $self->{'cfolders_array'}->[0]->{'file'},
						'count' => scalar(@{$self->{'delete_array'}}) } );
	$self->redirect("list_mail.cgi?start=$self->{'in_hash'}->{'start'}&folder=$self->{'in_hash'}->{'folder'}&user=$self->{'in_hash'}->{'user'}");
	}
elsif ($self->{'in_hash'}->{'forward'}) {
	# Forwarding selected mails .. redirect
	@{$self->{'delete_array'}} || $self->error($self->{'text_hash'}->{'delete_efnone'});
	$self->redirect("reply_mail.cgi?folder=$self->{'in_hash'}->{'folder'}&user=$self->{'in_hash'}->{'user'}&".
		  join("&", map { "mailforward=$_" } @{$self->{'delete_array'}}));
	}
elsif ($self->{'in_hash'}->{'new'}) {
	# Need to redirect to compose form
	$self->redirect("reply_mail.cgi?new=1&folder=$self->{'in_hash'}->{'folder'}&user=$self->{'in_hash'}->{'user'}");
	}
elsif ($self->{'in_hash'}->{'black'}) {
	# Deny all senders
	@{$self->{'delete_array'}} || $self->error($self->{'text_hash'}->{'delete_ebnone'});
	@{$self->{'mail_array'}} = $self->mailbox_list_mails($self->{'delete_array'}->[0], $self->{'delete_array'}->[@{$self->{'delete_array'}}-1], $self->{'folder'});
	foreach $d (@{$self->{'delete_array'}}) {
		push(@{$self->{'addrs_array'}}, map { $_->[0] } $self->split_addresses($self->{'mail_array'}->[$d]->{'header'}->{'from'}));
		}
	$self->foreign_require("spam", "spam-lib.pl");
	local $conf = $main::spam_object->get_config();
	local @from = map { @{$_->{'words'}} }
			  $main::spam_object->find("blacklist_from", $conf);
	local %already = map { $_, 1 } @from;
	@{$self->{'newaddrs_array'}} = grep { !$already{$_} } $self->unique(@{$self->{'addrs_array'}});
	push(@from, @{$self->{'newaddrs_array'}});
	$main::spam_object->save_directives($conf, 'blacklist_from',
			       \@from, 1);
	$self->flush_file_lines();
	$self->redirect("list_mail.cgi?start=$self->{'in_hash'}->{'start'}&folder=$self->{'in_hash'}->{'folder'}&user=$self->{'in_hash'}->{'user'}");
	}
elsif ($self->{'in_hash'}->{'razor'}) {
	# Report all messages, and show output to the user
	@{$self->{'delete_array'}} || $self->error($self->{'text_hash'}->{'delete_ebnone'});

	$self->ui_print_header(undef, $self->{'text_hash'}->{'razor_title'}, "");
	print "<b>$self->{'text_hash'}->{'razor_report2'}</b>\n";
	print "<pre>";

	# Write all messages to a temp file
	@{$self->{'mail_array'}} = $self->mailbox_list_mails($self->{'delete_array'}->[0], $self->{'delete_array'}->[@{$self->{'delete_array'}}-1], $self->{'folder'});
	$self->{'temp'} = $self->transname();
	$self->{'cmd'} = $self->spam_report_cmd($self->{'in_hash'}->{'user'});
	foreach $d (@{$self->{'delete_array'}}) {
		$self->{'mail_array'}->[$d] || $self->error($self->{'text_hash'}->{'mail_eexists'});
		$self->send_mail($self->{'mail_array'}->[$d], $self->{'temp'});
		push(@{$self->{'delmail_array'}}, $self->{'mail_array'}->[$d]);
		}

	# Call reporting command on them
	$self->open_execute_command(*OUT, "$self->{'cmd'} <$self->{'temp'} 2>&1", 1);
	local $error;
	while(<OUT>) {
		print $self->html_escape($_);
		$error++ if (/failed/i);
		}
	close(OUT);
	unlink($self->{'temp'});
	print "</pre>\n";
	if ($? || $error) {
		print "<b>$self->{'text_hash'}->{'razor_err'}</b><p>\n";
		}
	else {
		if ($self->{'config_hash'}->{'spam_del'}) {
			# Delete spam too
			$self->lock_folder($self->{'folder'});
			$self->mailbox_delete_mail($self->{'folder'}, @{$self->{'delmail_array'}});
			$self->unlock_folder($self->{'folder'});
			print "<b>$self->{'text_hash'}->{'razor_deleted'}</b><p>\n";
			}
		else {
			print "<b>$self->{'text_hash'}->{'razor_done'}</b><p>\n";
			}
		}
	$self->ui_print_footer("list_mail.cgi?folder=$self->{'in_hash'}->{'folder'}&user=$self->{'in_hash'}->{'user'}", $self->{'text_hash'}->{'mail_return'}, "", $self->{'text_hash'}->{'index_return'});
	}
elsif ($self->{'in_hash'}->{'delete'} || $self->{'in_hash'}->{'deleteall'}) {
	# Just deleting emails
	$self->check_modification($self->{'folder'});
	@{$self->{'delete_array'}} || $self->{'in_hash'}->{'deleteall'} || $self->error($self->{'text_hash'}->{'delete_enone'});
	if (!$self->{'in_hash'}->{'confirm'} && $self->need_delete_warn($self->{'folder'})) {
		# Need to ask for confirmation before deleting
		$self->ui_print_header(undef, $self->{'text_hash'}->{'confirm_title'}, "");
		print $self->check_clicks_function();

		print "<form action=delete_mail.cgi method=post>\n";
		foreach $i (keys %{$self->{'in_hash'}}) {
			foreach $v (split(/\0/, $self->{'in_hash'}->{$i})) {
				print "<input type=hidden name=$i value='",
				      $self->html_escape($v),"'>\n";
				}
			}
		print "<center><b>\n";
		if ($self->{'in_hash'}->{'deleteall'}) {
			print $self->text('confirm_warnall'),"<br>\n";
			}
		else {
			print $self->text('confirm_warn', scalar(@{$self->{'delete_array'}})),"<br>\n";
			}
		if ($self->{'config_hash'}->{'delete_warn'} ne 'y') {
			print "$self->{'text_hash'}->{'confirm_warn2'}<p>\n"
			}
		else {
			print "$self->{'text_hash'}->{'confirm_warn4'}<p>\n"
			}
		print "</b><p><input type=submit name=confirm ",
		      "value='$self->{'text_hash'}->{'confirm_oks'}' ",
		      "onClick='return check_clicks(form)'></center></form>\n";
		
		$self->ui_print_footer($self->{'text_hash'}->{'index_mainpage_url'}, $self->{'text_hash'}->{'index_mainpage'},
		"", $self->{'text_hash'}->{'index_return'},
		"list_mail.cgi?folder=$self->{'in_hash'}->{'folder'}&user=$self->{'in_hash'}->{'user'}",$self->{'text_hash'}->{'mail_return'});
		}
	else {
		# Go ahead and delete
		$self->lock_folder($self->{'folder'});
		if ($self->{'in_hash'}->{'deleteall'}) {
			# Clear the whole folder
			$self->{'delcount'} = $self->mailbox_folder_size($self->{'folder'});
			$self->mailbox_empty_folder($self->{'folder'});
			}
		else {
			# Just delete selected messages
			@{$self->{'mail_array'}} = $self->mailbox_list_mails($self->{'delete_array'}->[0],
						    $self->{'delete_array'}->[@{$self->{'delete_array'}}-1],
						    $self->{'folder'});
			foreach $d (@{$self->{'delete_array'}}) {
				$self->{'mail_array'}->[$d] || $self->error($self->{'text_hash'}->{'mail_eexists'});
				push(@{$self->{'delmail_array'}}, $self->{'mail_array'}->[$d]);
				}
			$self->mailbox_delete_mail($self->{'folder'}, @{$self->{'delmail_array'}});
			$self->{'delcount'} = scalar(@{$self->{'delmail_array'}});
			}
		$self->unlock_folder($self->{'folder'});
		$self->webmin_log("delmail", undef, undef,
			    { 'from' => $self->{'folder'}->{'file'},
			      'all' => $self->{'in_hash'}->{'deleteall'},
			      'count' => $self->{'delcount'} } );
		$self->redirect("list_mail.cgi?start=$self->{'in_hash'}->{'start'}&folder=$self->{'in_hash'}->{'folder'}&user=$self->{'in_hash'}->{'user'}");
		}
	}
$self->pop3_logout_all();
1;
		
}


1;

