#!/usr/bin/perl

&MAIN();

 sub MAIN {
# detach.cgi
# View one attachment from a message

use Socket;
&ModuleLoader::preload_module('mailboxes_class', "mailboxes::MailboxesLib");
$self = new mailboxes::MailboxesLib:: 'mailboxes_class',%$self;

$self->ReadParse();
$self->can_user($self->{'in_hash'}->{'user'}) || $self->error($self->{'text_hash'}->{'mail_ecannot'});

@{$self->{'folders_array'}} = $self->list_user_folders($self->{'in_hash'}->{'user'});
$self->{'folder'} = $self->{'folders_array'}->[$self->{'in_hash'}->{'folder'}];
@{$self->{'mail_array'}} = $self->mailbox_list_mails($self->{'in_hash'}->{'idx'}, $self->{'in_hash'}->{'idx'}, $self->{'folder'});
$self->{'mail'} = $self->{'mail_array'}->[$self->{'in_hash'}->{'idx'}];
$self->parse_mail($self->{'mail'});
@{$self->{'sub_array'}} = split(/\0/, $self->{'in_hash'}->{'sub'});
foreach $s (@{$self->{'sub_array'}}) {
        # We are looking at a mail within a mail ..
        local $amail = $self->extract_mail($self->{'mail'}->{'attach'}->[$s]->{'data'});
        $self->parse_mail($amail);
        $self->{'mail'} = $amail;
        }
$self->{'attach'} = $self->{'mail'}->{'attach'}->[$self->{'in_hash'}->{'attach'}];

if ($self->{'in_hash'}->{'scale'}) {
	# Scale the gif or jpeg image to 48 pixels high
	local $temp = $self->transname();
	open(TEMP, ">$temp");
	print TEMP $self->{'attach'}->{'data'};
	close(TEMP);
	$SIG{'CHLD'} = sub { wait; };
	if ($self->{'attach'}->{'type'} eq 'image/gif') {
		($self->{'pnmin'}, $self->{'pnmout'}) = &pipeopen("giftopnm $temp");
		}
	elsif ($self->{'attach'}->{'type'} eq 'image/jpeg') {
		($self->{'pnmin'}, $self->{'pnmout'}) = &pipeopen("djpeg -fast $temp");
		}
	else {
		&dump_erroricon();
		}
	close($self->{'pnmin'});
	$self->{'type'} = do { my $t=$self->{'pnmout'}; <$t> };
	$self->{'size'} = do { my $t=$self->{'pnmout'}; <$t> };
	unlink($temp);
	$self->{'type'} =~ /^P[0-9]/ || &dump_erroricon();
	$self->{'size'} =~ /(\d+)\s+(\d+)/ || &dump_erroricon();
	($self->{'w'}, $self->{'h'}) = ($1, $2);
	if ($self->{'w'} > 48) {
		$self->{'scale'} = 48.0 / $self->{'w'};
		}
	else {
		$self->{'scale'} = 48.0 / $self->{'h'};
		}
	($self->{'jpegin'}, $self->{'jpegout'}) = &pipeopen("pnmscale $self->{'scale'} 2>/dev/null | cjpeg");
	{ my $t=$self->{'jpegin'}; print $t $self->{'type'};}
	{ my $t=$self->{'jpegin'}; print $t $self->{'size'};}
	while(read($self->{'pnmout'}, $self->{'buf'}, 1024)) {
		{ my $t=$self->{'jpegin'}; print $t $self->{'buf'};}
		}
	close($self->{'jpegin'});
	close($self->{'pnmout'});
	print "Content-type: image/jpeg\n\n";
	while(read($self->{'jpegout'}, $self->{'buf'}, 1024)) {
		print $self->{'buf'};
		}
	close($self->{'jpegout'});
	}
else {
	# Just output the attachment
	print "X-no-links: 1\n";
	@{$self->{'download_array'}} = split(/\t+/, $self->{'config_hash'}->{'download'});
	if ($self->indexof($self->{'attach'}->{'type'}, @{$self->{'download_array'}}) >= 0) {
		# Force download in IE
		print "Content-Disposition: Attachment\n";
		}
	if ($self->{'attach'}->{'type'} eq 'message/delivery-status') {
		print "Content-type: text/plain\n\n";
		}
	else {
		print "Content-type: $self->{'attach'}->{'type'}\n\n";
		}
	if ($self->{'attach'}->{'type'} =~ /^text\/html/i) {
		print $self->safe_urls($self->filter_javascript($self->{'attach'}->{'data'}));
		}
	else {
		print $self->{'attach'}->{'data'};
		}
	}
$self->pop3_logout_all();

1;
		
}

sub dump_erroricon
{
	shift if ($self == $_[0]);

print "Content-type: image/gif\n\n";
open(ICON, "images/error.gif");
while(<ICON>) { print; }
close(ICON);
exit;
}

# pipeopen(command)
sub pipeopen
{
	shift if ($self == $_[0]);

$self->{'pipe'}++;
local $inr = "INr$self->{'pipe'}";
local $inw = "INw$self->{'pipe'}";
local $outr = "OUTr$self->{'pipe'}";
local $outw = "OUTw$self->{'pipe'}";
pipe($inr, $inw);
pipe($outr, $outw);
if (!fork()) {
	untie(*STDIN);
	untie(*STDOUT);
	open(STDIN, "<&$inr");
	open(STDOUT, ">&$outw");
	close($inw);
	close($outr);
	exec($_[0]);
	print STDERR "exec failed : $!\n";
	exit 1;
	}
close($inr);
close($outw);
return ($inw, $outr);
}


1;

