#!/usr/bin/perl

&MAIN();

 sub MAIN {
# index.cgi
# Display all users on the system

&ModuleLoader::preload_module('mailboxes_class', "mailboxes::MailboxesLib");
$self = new mailboxes::MailboxesLib:: 'mailboxes_class',%$self;


if ($self->{'config_hash'}->{'mail_system'} == 3) {
	# Need to detect mail server
	$ms = $self->detect_mail_system();
	if ($ms == 3) {
		$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", undef, 1, 1);
		$self->ui_print_endpage($self->text('index_esystem',
					"../config.cgi?$self->{'module_name'}"));
		}
	else {
		$self->{'config_hash'}->{'mail_system'} = $ms;
		$self->save_module_config();
		}
	}
elsif (!$self->{'config_hash'}->{'send_mode'} || !$self->{'config_hash'}->{'auto'}) {
	# Make sure mail system is valid
	local ($ms) = grep { $_->[1] == $self->{'config_hash'}->{'mail_system'} }
			   @{$self->{'mail_system_modules_array'}};
	if (!$self->check_mail_system($ms)) {
		$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", undef, 1, 1);
		$self->ui_print_endpage($self->text('index_esystem2',
					"../config.cgi?$self->{'module_name'}"));
		}
	}

# Make sure mail system is running
$self->{'err'} = $self->test_mail_system();
if ($self->{'err'}) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", undef, 1, 1);
	$self->ui_print_endpage($self->text('index_esystem3',
				"../config.cgi?$self->{'module_name'}", $self->{'err'}));
	}

# Show main page header
$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", undef, 1, 1, 0,
		 undef, undef, undef,
		 $self->{'text_hash'}->{'index_system'.$self->{'config_hash'}->{'mail_system'}});

# Check for Perl modules for SMTP authentication
if ($self->{'config_hash'}->{'smtp_user'}) {
	local @needed = ( "Authen::SASL" );
	local $smode = $self->{'config_hash'}->{'smtp_auth'} || "Cram-MD5";
	$smode = uc($smode);
	$smode =~ s/-/_/g;
	push(@needed, "Authen::SASL::Perl::$smode");
	foreach $n (@needed) {
		eval "use $n";
		if ($@) {
			$self->ui_print_endpage(
				"<p>".$self->text('index_eperl', "<tt>$n</tt>",
				  "/cpan/download.cgi?source=3&cpan=$n&mode=2&".
				  "return=/$self->{'module_name'}/&returndesc=".
				  $self->urlize($self->{'text_hash'}->{'index_return'}))."<p>\n".
				"$self->{'text_hash'}->{'index_eperl2'}\n".
				"<pre>$@</pre>\n");
			}
		}
	}

# Build a list of all available users
@{$self->{'users_array'}} = $self->list_mail_users($self->{'config_hash'}->{'max_records'}, 'can_user');

$self->{'form'} = 0;
if (!@{$self->{'users_array'}}) {
	# No users!
	print "<b>$self->{'text_hash'}->{'index_none'}</b> <p>\n";
	}
elsif ($self->{'config_hash'}->{'max_records'} && @{$self->{'users_array'}} > $self->{'config_hash'}->{'max_records'}) {
	# Show input for searching for a user
	print $self->{'text_hash'}->{'index_toomany'},"<p>\n";
	print $self->ui_form_start("find.cgi");
	print $self->ui_submit($self->{'text_hash'}->{'index_find'}),"\n";
	print $self->ui_select("match", undef, [ [ "0", $self->{'text_hash'}->{'index_equals'} ],
					   [ "1", $self->{'text_hash'}->{'index_contains'} ] ]),"\n";
	print $self->ui_user_textbox("user"),"\n";
	print $self->ui_form_end();
	$self->{'form'}++;
	}
else {
	# Show using selected mode and sort
	$self->show_users_table(\@{$self->{'users_array'}}, $self->{'config_hash'}->{'show_mail'});
	}

if ($self->allowed_directory()) {
	# Show form to view any mail file
	print "<p>\n";
	print $self->ui_form_start("list_mail.cgi");
	print $self->ui_submit($self->{'text_hash'}->{'index_file'}),"\n";
	print $self->ui_textbox("user", undef, 40),"\n",
	      $self->file_chooser_button("user", $self->{'form'}),"<br>\n";
	print $self->ui_form_end();
	}

$self->ui_print_footer($self->{'text_hash'}->{'index_mainpage_url'}, $self->{'text_hash'}->{'index_mainpage'});

1;
		
}


1;

