#!/usr/bin/perl

&MAIN();

 sub MAIN {
# list_mail.cgi
# List the mail messages for some user in some folder

&ModuleLoader::preload_module('mailboxes_class', "mailboxes::MailboxesLib");
$self = new mailboxes::MailboxesLib:: 'mailboxes_class',%$self;

$self->ReadParse();
$self->can_user($self->{'in_hash'}->{'user'}) || $self->error($self->{'text_hash'}->{'mail_ecannot'});
$self->is_user($self->{'in_hash'}->{'user'}) || -e $self->{'in_hash'}->{'user'} || $self->error($self->{'text_hash'}->{'mail_efile'});
$self->{'uuser'} = $self->urlize($self->{'in_hash'}->{'user'});

if ($self->{'config_hash'}->{'track_read'}) {
	dbmopen(%{$self->{'read_hash'}}, "$self->{'module_config_directory'}/$self->{'in_hash'}->{'user'}.read", 0600);
	}

# Make sure the mail system is OK
$self->{'err'} = $self->test_mail_system();
if ($self->{'err'}) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", undef, 1, 1);
	if (!$self->{'access_hash'}->{'noconfig'}) {
		$self->ui_print_endpage($self->text('index_esystem3',
					"../config.cgi?$self->{'module_name'}", $self->{'err'}));
		}
	else {
		$self->ui_print_endpage($self->text('mail_esystem', $self->{'err'}));
		}
	}

$self->ui_print_header(undef, $self->{'text_hash'}->{'mail_title'}, "", undef, undef, 1);
print $self->check_clicks_function();
@{$self->{'folders_array'}} = $self->list_user_folders_sorted($self->{'in_hash'}->{'user'});
($self->{'folder'}) = grep { $_->{'index'} == $self->{'in_hash'}->{'folder'} } @{$self->{'folders_array'}};

# Get folder-selection HTML
$self->{'sel'} = $self->folder_select(\@{$self->{'folders_array'}}, $self->{'folder'}, "folder");

# Work out start from jump page
$self->{'perpage'} = $self->{'folder'}->{'perpage'} || $self->{'config_hash'}->{'perpage'};
if ($self->{'in_hash'}->{'jump'} =~ /^\d+$/ && $self->{'in_hash'}->{'jump'} > 0) {
	$self->{'in_hash'}->{'start'} = ($self->{'in_hash'}->{'jump'}-1)*$self->{'perpage'};
	}

# View mail from the most recent
@{$self->{'mail_array'}} = reverse($self->mailbox_list_mails(-$self->{'in_hash'}->{'start'},
				    -$self->{'in_hash'}->{'start'}-$self->{'perpage'}+1,
				    $self->{'folder'}, 1, \@{$self->{'error_array'}}));
if ($self->{'in_hash'}->{'start'} >= @{$self->{'mail_array'}} && $self->{'in_hash'}->{'jump'}) {
	# Jumped too far!
	$self->{'in_hash'}->{'start'} = @{$self->{'mail_array'}} - $self->{'perpage'};
	@{$self->{'mail_array'}} = reverse($self->mailbox_list_mails(-$self->{'in_hash'}->{'start'},
					    -$self->{'in_hash'}->{'start'}-$self->{'perpage'}+1,
					    $self->{'folder'}, 1, \@{$self->{'error_array'}}));
	}

# Show page flipping arrows
&show_arrows();

# Show page jump form
$self->{'jumpform'} = (@{$self->{'mail_array'}} > $self->{'perpage'});
print "<td width=33% align=right>\n";
if ($self->{'jumpform'}) {
	print "<form action=list_mail.cgi>\n";
	print "<input type=hidden name=user value='$self->{'in_hash'}->{'user'}'>\n";
	print "<input type=hidden name=folder value='$self->{'folder'}->{'index'}'>\n";
	print "<input type=submit value='$self->{'text_hash'}->{'mail_jump'}'>\n";
	printf "<input name=jump size=3 value='%s'> %s %s\n",
		int($self->{'in_hash'}->{'start'} / $self->{'perpage'})+1, $self->{'text_hash'}->{'mail_of'},
		int(@{$self->{'mail_array'}} / $self->{'perpage'});
	print "</form>\n";
	}
print "</td></tr>";

print "<form action=delete_mail.cgi method=post>\n";
print "<input type=hidden name=user value='$self->{'in_hash'}->{'user'}'>\n";
print "<input type=hidden name=folder value='$self->{'folder'}->{'index'}'>\n";
print "<input type=hidden name=mod value=",$self->modification_time($self->{'folder'}),">\n";
print "<input type=hidden name=start value='$self->{'in_hash'}->{'start'}'>\n";
if ($self->{'config_hash'}->{'top_buttons'} && @{$self->{'mail_array'}}) {
	print $self->select_all_link("d", $self->{'jumpform'} ? 2 : 1, $self->{'text_hash'}->{'mail_all'}),"&nbsp;\n";
	print $self->select_invert_link("d", $self->{'jumpform'} ? 2 : 1, $self->{'text_hash'}->{'mail_invert'}),"&nbsp;\n";
	}

# Show error opening folder
if (@{$self->{'error_array'}}) {
	print "<center><b><font color=#ff0000>\n";
	print $self->text('mail_err', $self->{'error_array'}->[0] == 0 ? $self->{'error_array'}->[1] :
			      $self->text('save_elogin', $self->{'error_array'}->[1])),"\n";
	print "</font></b></center>\n";
	}

$self->{'showto'} = $self->{'folder'}->{'sent'} || $self->{'folder'}->{'drafts'};
@{$self->{'tds_array'}} = ( "width=5", "nowrap", "nowrap", "nowrap", "nowrap" );
if (@{$self->{'mail_array'}}) {
	# Show mailbox headers
	local @hcols;
	push(@hcols, "");
	push(@hcols, $self->{'showto'} ? $self->{'text_hash'}->{'mail_to'} : $self->{'text_hash'}->{'mail_from'});
	push(@hcols, $self->{'config_hash'}->{'show_to'} ? $self->{'showto'} ? ( $self->{'text_hash'}->{'mail_from'} ) :
						    ( $self->{'text_hash'}->{'mail_to'} ) : ());
	push(@hcols, $self->{'text_hash'}->{'mail_date'});
	push(@hcols, $self->{'text_hash'}->{'mail_size'});
	push(@hcols, $self->{'text_hash'}->{'mail_subject'});
	print $self->ui_columns_start(\@hcols, 100, 0, \@{$self->{'tds_array'}});
	}
if (@{$self->{'error_array'}}) {
	print "<center><b><font color=#ff0000>\n";
	print $self->text('mail_err', $self->{'error_array'}->[0] == 0 ? $self->{'error_array'}->[1] :
	$self->text('save_elogin', $self->{'error_array'}->[1])),"\n";
	print "</font></b></center>\n";
	}
elsif (@{$self->{'error_array'}} && $self->{'error_array'}->[0] == 2) {
	}

# Show rows for actual mail messages
for($self->{'i'}=$self->{'in_hash'}->{'start'}; $self->{'i'}<@{$self->{'mail_array'}} && $self->{'i'}<$self->{'in_hash'}->{'start'}+$self->{'perpage'}; $self->{'i'}++) {
	local $idx = $self->{'mail_array'}->[$self->{'i'}]->{'idx'};
	local $cols = 0;
	local @cols;
	local $from = $self->{'mail_array'}->[$self->{'i'}]->{'header'}->{$self->{'showto'} ? 'to' : 'from'};
	$from = $self->{'text_hash'}->{'mail_unknown'} if ($from !~ /\S/);
	push(@cols, $self->view_mail_link($self->{'in_hash'}->{'user'}, $self->{'folder'}, $idx, $from));
	if ($self->{'config_hash'}->{'show_to'}) {
		push(@cols, $self->simplify_from(
	   		$self->{'mail_array'}->[$self->{'i'}]->{'header'}->{$self->{'showto'} ? 'from' : 'to'}));
		}
	push(@cols, $self->simplify_date($self->{'mail_array'}->[$self->{'i'}]->{'header'}->{'date'}));
	push(@cols, $self->nice_size($self->{'mail_array'}->[$self->{'i'}]->{'size'}, 1024));
	local $tbl;
	$tbl .= "<table border=0 cellpadding=0 cellspacing=0 width=100%>".
	      "<tr><td>".$self->simplify_subject($self->{'mail_array'}->[$self->{'i'}]->{'header'}->{'subject'}).
	      "</td> <td align=right>";
	if ($self->{'mail_array'}->[$self->{'i'}]->{'header'}->{'content-type'} =~ /multipart\/\S+/i) {
		$tbl .= "<img src=images/attach.gif>";
		}
	local $p = int($self->{'mail_array'}->[$self->{'i'}]->{'header'}->{'x-priority'});
	if ($p == 1) {
		$tbl .= "&nbsp;<img src=images/p1.gif>";
		}
	elsif ($p == 2) {
		$tbl .= "&nbsp;<img src=images/p2.gif>";
		}
	if (!$self->{'showto'}) {
		if ($self->{'read_hash'}->{$self->{'mail_array'}->[$self->{'i'}]->{'header'}->{'message-id'}} == 2) {
			$tbl .= "&nbsp;<img src=images/special.gif>";
			}
		elsif ($self->{'read_hash'}->{$self->{'mail_array'}->[$self->{'i'}]->{'header'}->{'message-id'}} == 1) {
			$tbl .= "&nbsp;<img src=images/read.gif>";
			}
		}
	$tbl .= "</td></tr></table>\n";
	push(@cols, $tbl);

	if ($self->editable_mail($self->{'mail_array'}->[$self->{'i'}])) {
		print $self->ui_checked_columns_row(\@cols, \@{$self->{'tds_array'}}, "d", $idx);
		}
	else {
		print $self->ui_columns_row([ "", @cols ], \@{$self->{'tds_array'}});
		}

	if ($self->{'config_hash'}->{'show_body'}) {
                # Show part of the body too
                $self->parse_mail($self->{'mail_array'}->[$self->{'i'}]);
		local $data = $self->mail_preview($self->{'mail_array'}->[$self->{'i'}]);
		if ($data) {
                        print "<tr $self->{'cb'}> <td colspan=",(scalar(@cols)+1),"><tt>",
				$self->html_escape($data),"</tt></td> </tr>\n";
			}
                }
	}
if (@{$self->{'mail_array'}}) {
	print $self->ui_columns_end();
	print $self->ui_links_row(\@{$self->{'links_array'}});
	}

$self->show_buttons(2, \@{$self->{'folders_array'}}, $self->{'folder'}, \@{$self->{'mail_array'}}, $self->{'in_hash'}->{'user'});
print "</form>\n";
if ($self->{'config_hash'}->{'arrows'} && @{$self->{'mail_array'}}) {
        # Show page flipping arrows at the bottom
        &show_arrows();
        }

if (@{$self->{'mail_array'}}) {
	print "<hr>\n";
	print "<table width=100%><tr>\n";

	# Show simple search form
	print "<form action=mail_search.cgi><td width=30%>\n";
	print "<input type=hidden name=user value='$self->{'in_hash'}->{'user'}'>\n";
	print "<input type=hidden name=folder value='$self->{'folder'}->{'index'}'>\n";
	print "<input type=hidden name=simple value=1>\n";
	print "<input type=submit value='$self->{'text_hash'}->{'mail_search2'}'>\n";
	print "<input name=search size=20></td></form>\n";

	# Show advanced search button
	print "<form action=search_form.cgi>\n";
	print "<input type=hidden name=user value='$self->{'in_hash'}->{'user'}'>\n";
	print "<input type=hidden name=folder value='$self->{'folder'}->{'index'}'>\n";
	print "<td width=20% align=center><input type=submit name=advanced ",
	      "value='$self->{'text_hash'}->{'mail_advanced'}'></td>\n";
	print "</form>\n";

	# Show delete all button
	print "<form action=delete_all.cgi>\n";
	print "<input type=hidden name=user value='$self->{'in_hash'}->{'user'}'>\n";
	print "<input type=hidden name=folder value='$self->{'folder'}->{'index'}'>\n";
	print "<td width=20% align=center><input type=submit ",
	      "value='$self->{'text_hash'}->{'mail_delall'}'></td>\n";
	print "</form>\n";
	}

if (@{$self->{'mail_array'}}) {
	print "</tr>\n";
	print "</table>\n";
	}

if ($self->{'config_hash'}->{'log_read'}) {
	$self->webmin_log("read", undef, $self->{'in_hash'}->{'user'},
		    { 'file' => $self->{'folder'}->{'file'} });
	}
$self->ui_print_footer($self->{'text_hash'}->{'index_mainpage_url'}, $self->{'text_hash'}->{'index_mainpage'},"", $self->{'text_hash'}->{'index_return'});

1;
		
}

sub show_arrows
{
	shift if ($self == $_[0]);

print "<center>\n";
print "<form action=list_mail.cgi><font size=+1>\n";
print "<input type=hidden name=user value='$self->{'in_hash'}->{'user'}'>\n";
if ($self->{'in_hash'}->{'start'}+$self->{'perpage'} < @{$self->{'mail_array'}}) {
	printf "<a href='list_mail.cgi?start=%d&user=%s&folder=%d'>".
	       "<img src=/images/left.gif border=0 align=middle></a>\n",
		$self->{'in_hash'}->{'start'}+$self->{'perpage'}, $self->{'uuser'}, $self->{'in_hash'}->{'folder'};
	}

local $s = @{$self->{'mail_array'}}-$self->{'in_hash'}->{'start'};
local $e = @{$self->{'mail_array'}}-$self->{'in_hash'}->{'start'}-$self->{'perpage'}+1;
if (@{$self->{'mail_array'}}) {
	print $self->text('mail_pos', $s, $e < 1 ? 1 : $e, scalar(@{$self->{'mail_array'}}), $self->{'sel'});
	}
else {
	print $self->text('mail_none', $self->{'sel'});
	}
print "</font><input type=submit value='$self->{'text_hash'}->{'mail_fchange'}'>\n";

if ($self->{'in_hash'}->{'start'}) {
	printf "<a href='list_mail.cgi?start=%d&user=%s&folder=%d'>".
	       "<img src=/images/right.gif border=0 align=middle></a>\n",
		$self->{'in_hash'}->{'start'}-$self->{'perpage'}, $self->{'uuser'}, $self->{'in_hash'}->{'folder'};
	}
print "</form></center>\n";
}


1;

