#!/usr/bin/perl

&MAIN();

 sub MAIN {
# mail_search.cgi
# Find mail messages matching some pattern

&ModuleLoader::preload_module('mailboxes_class', "mailboxes::MailboxesLib");
$self = new mailboxes::MailboxesLib:: 'mailboxes_class',%$self;

$self->ReadParse();
$self->can_user($self->{'in_hash'}->{'user'}) || $self->error($self->{'text_hash'}->{'mail_ecannot'});
@{$self->{'folders_array'}} = $self->list_user_folders($self->{'in_hash'}->{'user'});
$self->{'uuser'} = $self->urlize($self->{'in_hash'}->{'user'});

if ($self->{'in_hash'}->{'simple'}) {
	# Make sure a search was entered
	$self->{'in_hash'}->{'search'} || $self->error($self->{'text_hash'}->{'search_ematch'});
	$self->{'ofolder'} = $self->{'folders_array'}->[$self->{'in_hash'}->{'folder'}];
	}
else {
	# Validate search fields
	for($i=0; defined($self->{'in_hash'}->{"field_$i"}); $i++) {
		if ($self->{'in_hash'}->{"field_$i"}) {
			$self->{'in_hash'}->{"what_$i"} || $self->error($self->text('search_ewhat', $i+1));
			$self->{'neg'} = $self->{'in_hash'}->{"neg_$i"} ? "!" : "";
			push(@{$self->{'fields_array'}}, [ $self->{'neg'}.$self->{'in_hash'}->{"field_$i"}, $self->{'in_hash'}->{"what_$i"} ]);
			}
		}
	@{$self->{'fields_array'}} || $self->error($self->{'text_hash'}->{'search_enone'});
	$self->{'ofolder'} = $self->{'folders_array'}->[$self->{'in_hash'}->{'ofolder'}];
	}

if ($self->{'in_hash'}->{'folder'} == -2) {
	$self->{'desc'} = $self->{'text_hash'}->{'search_local'};
	}
elsif ($self->{'in_hash'}->{'folder'} == -1) {
	$self->{'desc'} = $self->{'text_hash'}->{'search_all'};
	}
else {
	$self->{'folder'} = $self->{'folders_array'}->[$self->{'in_hash'}->{'folder'}];
	$self->{'desc'} = $self->text('mail_for', $self->{'folder'}->{'name'});
	}
$self->ui_print_header($self->{'desc'}, $self->{'text_hash'}->{'search_title'}, "", undef, 0, 0, undef,
	$self->folder_link($self->{'in_hash'}->{'user'}, $self->{'ofolder'}));

if ($self->{'in_hash'}->{'simple'}) {
	if ($self->{'in_hash'}->{'search'} =~ /^(\S+):\s*(.*)$/) {
		# A specific field was entered
		local ($field, $what) = ($1, $2);
		@{$self->{'searchlist_array'}} = ( [ $field, $what ] );
		@{$self->{'rv_array'}} = $self->mailbox_search_mail(\@{$self->{'searchlist_array'}}, 0, $self->{'folder'});
		print "<p><b>",$self->text('search_results5', scalar(@{$self->{'rv_array'}}),
			    "<tt>$field</tt>", "<tt>$what</tt>")," ..</b><p>\n";
		}
	else {
		# Just search by Subject and From in one folder
		($self->{'mode'}, $self->{'words'}) = $self->parse_boolean($self->{'in_hash'}->{'search'});
		if ($self->{'mode'} == 0) {
			# Can just do a single 'or' search
			@{$self->{'searchlist_array'}} = map { ( [ 'subject', $_ ],
					      [ 'from', $_ ] ) } @{$self->{'words'}};
			@{$self->{'rv_array'}} = $self->mailbox_search_mail(\@{$self->{'searchlist_array'}}, 0, $self->{'folder'});
			}
		elsif ($self->{'mode'} == 1) {
			# Need to do two 'and' searches and combine
			@{$self->{'searchlist1_array'}} = map { ( [ 'subject', $_ ] ) } @{$self->{'words'}};
			@{$self->{'rv1_array'}} = $self->mailbox_search_mail(\@{$self->{'searchlist1_array'}}, 1, $self->{'folder'});
			@{$self->{'searchlist2_array'}} = map { ( [ 'from', $_ ] ) } @{$self->{'words'}};
			@{$self->{'rv2_array'}} = $self->mailbox_search_mail(\@{$self->{'searchlist2_array'}}, 1, $self->{'folder'});
			@{$self->{'rv_array'}} = @{$self->{'rv1_array'}};
			%{$self->{'gotidx_hash'}} = map { $_->{'idx'}, 1 } @{$self->{'rv_array'}};
			foreach $mail (@{$self->{'rv2_array'}}) {
				push(@{$self->{'rv_array'}}, $mail) if (!$self->{'gotidx_hash'}->{$mail->{'idx'}});
				}
			}
		else {
			$self->error($self->{'text_hash'}->{'search_eboolean'});
			}
		print "<p><b>",$self->text('search_results2', scalar(@{$self->{'rv_array'}}),
				     "<tt>$self->{'in_hash'}->{'search'}</tt>")," ..</b><p>\n";
		}
	foreach $mail (@{$self->{'rv_array'}}) {
		$mail->{'folder'} = $self->{'folder'};
		}
	}
else {
	# Complex search, perhaps over multiple folders!
	if ($self->{'in_hash'}->{'folder'} == -2) {
		@{$self->{'sfolders_array'}} = grep { !$_->{'remote'} } @{$self->{'folders_array'}};
		$self->{'multi_folder'} = 1;
		}
	elsif ($self->{'in_hash'}->{'folder'} == -1) {
		@{$self->{'sfolders_array'}} = @{$self->{'folders_array'}};
		$self->{'multi_folder'} = 1;
		}
	else {
		@{$self->{'sfolders_array'}} = ( $self->{'folder'} );
		}
	foreach $sf (@{$self->{'sfolders_array'}}) {
		local @frv = $self->mailbox_search_mail(\@{$self->{'fields_array'}}, $self->{'in_hash'}->{'and'}, $sf);
		foreach $mail (@frv) {
			$mail->{'folder'} = $sf;
			}
		push(@{$self->{'rv_array'}}, @frv);
		}
	print "<p><b>",$self->text('search_results4', scalar(@{$self->{'rv_array'}}))," ..</b><p>\n";
	}
@{$self->{'rv_array'}} = reverse(@{$self->{'rv_array'}});

$self->{'showto'} = $self->{'folder'}->{'sent'} || $self->{'folder'}->{'drafts'};
if (@{$self->{'rv_array'}}) {
	print "<form action=delete_mail.cgi method=post>\n";
	print "<input type=hidden name=folder value='$self->{'in_hash'}->{'folder'}'>\n";
	print "<input type=hidden name=user value='$self->{'in_hash'}->{'user'}'>\n";
	if ($self->{'config_hash'}->{'top_buttons'}) {
		if (!$self->{'multi_folder'}) {
			$self->show_buttons(1, \@{$self->{'folders_array'}}, $self->{'folder'}, \@{$self->{'rv_array'}}, $self->{'in_hash'}->{'user'},
				      1);
			@{$self->{'links_array'}} = ( $self->select_all_link("d", 0),
				   $self->select_invert_link("d", 0) );
			print $self->ui_links_row(\@{$self->{'links_array'}});
			}
		}

	# Show mailbox headers
	local @hcols;
	push(@hcols, "");
	push(@hcols, $self->{'showto'} ? $self->{'text_hash'}->{'mail_to'} : $self->{'text_hash'}->{'mail_from'});
	push(@hcols, $self->{'config_hash'}->{'show_to'} ? $self->{'showto'} ? ( $self->{'text_hash'}->{'mail_from'} ) :
						    ( $self->{'text_hash'}->{'mail_to'} ) : ());
	push(@hcols, $self->{'text_hash'}->{'mail_date'});
	push(@hcols, $self->{'text_hash'}->{'mail_size'});
	push(@hcols, $self->{'text_hash'}->{'mail_subject'});
	print $self->ui_columns_start(\@hcols, 100, 0, \@{$self->{'tds_array'}});
	}
foreach $m (@{$self->{'rv_array'}}) {
	local $idx = $m->{'idx'};
	local $mf = $m->{'folder'};
	local @cols;
	local $from = $self->simplify_from($m->{'header'}->{
					$self->{'showto'} ? 'to' : 'from'});
	$from = $self->{'text_hash'}->{'mail_unknown'} if ($from !~ /\S/);
	push(@cols, "<a href='view_mail.cgi?idx=$idx&user=$self->{'uuser'}&folder=$mf->{'index'}'>$from</a>");
	if ($self->{'config_hash'}->{'show_to'}) {
		push(@cols, $self->simplify_from(
	   		$m->{'header'}->{$self->{'showto'} ? 'from' : 'to'}));
		}
	push(@cols, $self->simplify_date($m->{'header'}->{'date'}));
	push(@cols, $self->nice_size($m->{'size'}, 1024));
	local $tbl;
	$tbl .= "<table border=0 cellpadding=0 cellspacing=0 width=100%>".
	      "<tr><td>".$self->simplify_subject($m->{'header'}->{'subject'}).
	      "</td> <td align=right>";
	if ($m->{'header'}->{'content-type'} =~ /multipart\/\S+/i) {
		$tbl .= "<img src=images/attach.gif>";
		}
	local $p = int($m->{'header'}->{'x-priority'});
	if ($p == 1) {
		$tbl .= "&nbsp;<img src=images/p1.gif>";
		}
	elsif ($p == 2) {
		$tbl .= "&nbsp;<img src=images/p2.gif>";
		}
	if (!$self->{'showto'}) {
		if ($self->{'read_hash'}->{$m->{'header'}->{'message-id'}} == 2) {
			$tbl .= "&nbsp;<img src=images/special.gif>";
			}
		elsif ($self->{'read_hash'}->{$m->{'header'}->{'message-id'}} == 1) {
			$tbl .= "&nbsp;<img src=images/read.gif>";
			}
		}
	$tbl .= "</td></tr></table>\n";
	push(@cols, $tbl);

	if ($self->editable_mail($m)) {
		print $self->ui_checked_columns_row(\@cols, \@{$self->{'tds_array'}}, "d", $idx);
		}
	elsif ($self->{'multi_folder'}) {
		print $self->ui_columns_row([ $mf->{'name'}, @cols ], \@{$self->{'tds_array'}});
		}
	else {
		print $self->ui_columns_row([ "", @cols ], \@{$self->{'tds_array'}});
		}

	if ($self->{'config_hash'}->{'show_body'}) {
                # Show part of the body too
                $self->parse_mail($m);
		local $data = $self->mail_preview($m);
		if ($data) {
                        print "<tr $self->{'cb'}> <td colspan=",(scalar(@cols)+1),"><tt>",
				$self->html_escape($data),"</tt></td> </tr>\n";
			}
                }
	}
if (@{$self->{'rv_array'}}) {
	print $self->ui_columns_end();
	if (!$self->{'multi_folder'}) {
		print $self->ui_links_row(\@{$self->{'links_array'}});
		$self->show_buttons(2, \@{$self->{'folders_array'}}, $self->{'folder'}, \@{$self->{'rv_array'}}, $self->{'in_hash'}->{'user'}, 1);
		}
	print "</form><p>\n";
	}
else {
	print "<b>$self->{'text_hash'}->{'search_none'}</b> <p>\n";
	}

$self->ui_print_footer($self->{'in_hash'}->{'simple'} ? ( ) : ( "search_form.cgi?folder=$self->{'in_hash'}->{'folder'}",
				$self->{'text_hash'}->{'sform_return'} ),
	"list_mail.cgi?user=$self->{'in_hash'}->{'user'}&folder=$self->{'in_hash'}->{'folder'}", $self->{'text_hash'}->{'mail_return'},
	"", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

