#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Display a form for replying to or composing an email

&ModuleLoader::preload_module('mailboxes_class', "mailboxes::MailboxesLib");
$self = new mailboxes::MailboxesLib:: 'mailboxes_class',%$self;

$self->ReadParse();
$self->can_user($self->{'in_hash'}->{'user'}) || $self->error($self->{'text_hash'}->{'mail_ecannot'});
@{$self->{'uinfo_array'}} = $self->get_mail_user($self->{'in_hash'}->{'user'});
@{$self->{'uinfo_array'}} || $self->error($self->{'text_hash'}->{'view_eugone'});

@{$self->{'folders_array'}} = $self->list_user_folders($self->{'in_hash'}->{'user'});
$self->{'folder'} = $self->{'folders_array'}->[$self->{'in_hash'}->{'folder'}];
if ($self->{'in_hash'}->{'new'}) {
	# Composing a new email
	$self->{'html_edit'} = 1 if ($self->{'config_hash'}->{'html_edit'} == 2);
	$self->{'sig'} = $self->get_signature($self->{'in_hash'}->{'user'});
	if ($self->{'html_edit'}) {
		$self->{'sig'} =~ s/\n/<br>\n/g;
		$self->{'quote'} = "<html><body></body></html>";
		}
	else {
		$self->{'quote'} = "\n\n$self->{'sig'}" if ($self->{'sig'});
		}
	$self->ui_print_header(undef, $self->{'text_hash'}->{'compose_title'}, "", undef, undef, 1);
	}
else {
	# Replying or forwarding
	if ($self->{'in_hash'}->{'mailforward'} ne '') {
		# Replying to multiple
		@{$self->{'mailforward_array'}} = sort { $a <=> $b }
				    split(/\0/, $self->{'in_hash'}->{'mailforward'});
		@{$self->{'mails_array'}} = $self->mailbox_list_mails(
			     $self->{'mailforward_array'}->[0], $self->{'mailforward_array'}->[@{$self->{'mailforward_array'}}-1],
			     $self->{'folder'});
		$self->{'mail'} = $self->{'mails_array'}->[$self->{'mailforward_array'}->[0]];
		}
	else {
		# Replying to one
		@{$self->{'mails_array'}} = $self->mailbox_list_mails($self->{'in_hash'}->{'idx'}, $self->{'in_hash'}->{'idx'},
					     $self->{'folder'});
		$self->{'mail'} = $self->{'mails_array'}->[$self->{'in_hash'}->{'idx'}];
		&decode_and_sub();
		}
	$self->check_modification($self->{'folder'}) if ($self->{'in_hash'}->{'delete'});
	$self->{'mail'} || $self->error($self->{'text_hash'}->{'mail_eexists'});

	if ($self->{'in_hash'}->{'delete'}) {
		# Just delete the email
		if (!$self->{'in_hash'}->{'confirm'} && $self->need_delete_warn($self->{'folder'})) {
			# Need to ask for confirmation before deleting
			$self->ui_print_header(undef, $self->{'text_hash'}->{'confirm_title'}, "", undef, undef, 1);
			print $self->check_clicks_function();

			print "<form action=reply_mail.cgi>\n";
			foreach $i (keys %{$self->{'in_hash'}}) {
				foreach $v (split(/\0/, $self->{'in_hash'}->{$i})) {
					print "<input type=hidden name=$i ",
					      "value='",$self->html_escape($v),"'>\n";
					}
				}
			print "<center><b>$self->{'text_hash'}->{'confirm_warn3'}<br>\n";
			if ($self->{'config_hash'}->{'delete_warn'} ne 'y') {
				print "$self->{'text_hash'}->{'confirm_warn2'}<p>\n"
				}
			else {
				print "$self->{'text_hash'}->{'confirm_warn4'}<p>\n"
				}
			print "</b><p><input type=submit name=confirm ",
			      "value='$self->{'text_hash'}->{'confirm_ok'}' ",
			      "onClick='return check_clicks(form)'></center></form>\n";
			
			$self->ui_print_footer($self->{'text_hash'}->{'index_mainpage_url'}, $self->{'text_hash'}->{'index_mainpage'},
			"", $self->{'text_hash'}->{'index_return'},
			"list_mail.cgi?folder=$self->{'in_hash'}->{'folder'}&user=$self->{'in_hash'}->{'user'}",$self->{'text_hash'}->{'mail_return'},
			"view_mail.cgi?idx=$self->{'in_hash'}->{'idx'}&folder=$self->{'in_hash'}->{'folder'}&user=$self->{'in_hash'}->{'user'}",$self->{'text_hash'}->{'view_return'});
			exit;
			}
		$self->lock_folder($self->{'folder'});
		$self->mailbox_delete_mail($self->{'folder'}, $self->{'mail'});
		$self->unlock_folder($self->{'folder'});
		$self->webmin_log("delmail", undef, undef,
			    { 'from' => $self->{'folder'}->{'file'},
			      'count' => 1 } );
		$self->redirect("list_mail.cgi?folder=$self->{'in_hash'}->{'folder'}&user=$self->{'in_hash'}->{'user'}");
		exit;
		}
	elsif ($self->{'in_hash'}->{'print'}) {
		# Extract the mail body
		&decode_and_sub();
		($self->{'textbody'}, $self->{'htmlbody'}, $self->{'body'}) =
			$self->find_body($self->{'mail'}, $self->{'config_hash'}->{'view_html'});

		# Output HTML header
		$self->PrintHeader();
		print "<html><head>\n";
		print "<title>",$self->html_escape($self->decode_mimewords(
			$self->{'mail'}->{'header'}->{'subject'})),"</title></head>\n";
		print "<body bgcolor=#ffffff onLoad='window.print()'>\n";

		# Display the headers
		print "<table width=100% border=1>\n";
		print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'view_headers'}</b></td> </tr>\n";
		print "<tr $self->{'cb'}> <td><table width=100%>\n";
		print "<tr> <td><b>$self->{'text_hash'}->{'mail_from'}</b></td> ",
		      "<td>",$self->eucconv_and_escape($self->{'mail'}->{'header'}->{'from'}),"</td> </tr>\n";
		print "<tr> <td><b>$self->{'text_hash'}->{'mail_to'}</b></td> ",
		      "<td>",$self->eucconv_and_escape($self->{'mail'}->{'header'}->{'to'}),"</td> </tr>\n";
		print "<tr> <td><b>$self->{'text_hash'}->{'mail_cc'}</b></td> ",
		      "<td>",$self->eucconv_and_escape($self->{'mail'}->{'header'}->{'cc'}),"</td> </tr>\n"
			if ($self->{'mail'}->{'header'}->{'cc'});
		print "<tr> <td><b>$self->{'text_hash'}->{'mail_date'}</b></td> ",
		      "<td>",$self->eucconv_and_escape($self->html_escape($self->{'mail'}->{'header'}->{'date'})),
		      "</td> </tr>\n";
		print "<tr> <td><b>$self->{'text_hash'}->{'mail_subject'}</b></td> ",
		      "<td>",$self->eucconv_and_escape($self->decode_mimewords(
			$self->{'mail'}->{'header'}->{'subject'})),"</td> </tr>\n";
		print "</table></td></tr></table><p>\n";

		# Just display the mail body for printing
		if ($self->{'body'} eq $self->{'textbody'}) {
			print "<table border width=100%><tr $self->{'cb'}><td><pre>";
			foreach $l ($self->wrap_lines($self->{'body'}->{'data'},
						$self->{'config_hash'}->{'wrap_width'})) {
				print $self->eucconv_and_escape($l),"\n";
				}
			print "</pre></td></tr></table>\n";
			}
		elsif ($self->{'body'} eq $self->{'htmlbody'}) {
			print "<table border width=100%><tr><td>\n";
			print $self->safe_html($self->{'body'}->{'data'});
			print "</td></tr></table>\n";
			}

		print "</body></html>\n";
		exit;
		}
	elsif ($self->{'in_hash'}->{'mark1'} || $self->{'in_hash'}->{'mark2'}) {
		# Just mark the message
		dbmopen(%{$self->{'read_hash'}}, "$self->{'module_config_directory'}/$self->{'in_hash'}->{'user'}.read", 0600);
		$self->{'mode'} = $self->{'in_hash'}->{'mark1'} ? $self->{'in_hash'}->{'mode1'} : $self->{'in_hash'}->{'mode2'};
		if ($self->{'mode'}) {
			$self->{'read_hash'}->{$self->{'mail'}->{'header'}->{'message-id'}} = $self->{'mode'};
			}
		else {
			delete($self->{'read_hash'}->{$self->{'mail'}->{'header'}->{'message-id'}});
			}
		$self->{'perpage'} = $self->{'folder'}->{'perpage'} || $self->{'config_hash'}->{'perpage'};
		$s = int((@{$self->{'mails_array'}} - $self->{'in_hash'}->{'idx'} - 1) / $self->{'perpage'}) * $self->{'perpage'};
		$self->redirect("list_mail.cgi?start=$s&folder=$self->{'in_hash'}->{'folder'}&user=$self->{'in_hash'}->{'user'}");
		exit;
		}
	elsif ($self->{'in_hash'}->{'detach'}) {
		# Detach some attachment to a directory on the server
		$self->error_setup($self->{'text_hash'}->{'detach_err'});
		$self->{'in_hash'}->{'dir'} || $self->error($self->{'text_hash'}->{'detach_edir'});
		$self->{'in_hash'}->{'dir'} = "$self->{'uinfo_array'}->[7]/$self->{'in_hash'}->{'dir'}"
			if ($self->{'in_hash'}->{'dir'} !~ /^\//);
		&decode_and_sub();

		if ($self->{'in_hash'}->{'attach'} eq '*') {
			# Detaching all attachments, under their filenames
			@{$self->{'dattach_array'}} = grep { $_->{'idx'} ne $self->{'in_hash'}->{'bindex'} }
					@{$self->{'mail'}->{'attach'}};
			}
		else {
			# Just one attachment
			@{$self->{'dattach_array'}} = ( $self->{'mail'}->{'attach'}->[$self->{'in_hash'}->{'attach'}] );
			}

		local @paths;
		foreach $attach (@{$self->{'dattach_array'}}) {
			local $path;
			if (-d $self->{'in_hash'}->{'dir'}) {
				# Just write to the filename in the directory
				local $fn;
				if ($attach->{'filename'}) {
					$fn = $self->decode_mimewords(
						$attach->{'filename'});
					}
				else {
					$attach->{'type'} =~ /\/(\S+)$/;
					$fn = "file.$1";
					}
				$path = "$self->{'in_hash'}->{'dir'}/$fn";
				}
			else {
				# Assume a full path was given
				$path = $self->{'in_hash'}->{'dir'};
				}
			push(@paths, $path);
			}

		$self->switch_to_user($self->{'in_hash'}->{'user'});
		for($i=0; $i<@{$self->{'dattach_array'}}; $i++) {
			# Try to write the files
			$self->open_tempfile(FILE, ">$paths[$i]", 1, 1) ||
				$self->error($self->text('detach_eopen',
					     "<tt>$paths[$i]</tt>", $!));
			(print FILE $self->{'dattach_array'}->[$i]->{'data'}) ||
				$self->error($self->text('detach_ewrite',
					     "<tt>$paths[$i]</tt>", $!));
			close(FILE) ||
				$self->error($self->text('detach_ewrite',
					     "<tt>$paths[$i]</tt>", $!));
			}
		$self->switch_user_back();

		# Show a message about the new files
		$self->mail_page_header($self->{'text_hash'}->{'detach_title'}, undef, undef,
				  $self->folder_link($self->{'in_hash'}->{'user'}, $self->{'folder'}));

		for($i=0; $i<@{$self->{'dattach_array'}}; $i++) {
			local $sz = (int(length($self->{'dattach_array'}->[$i]->{'data'}) /
					 1000)+1)." Kb";
			print "<p>",$self->text('detach_ok',
					  "<tt>$paths[$i]</tt>", $sz),"<p>\n";
			}

		$self->mail_page_footer("view_mail.cgi?idx=$self->{'in_hash'}->{'idx'}&folder=$self->{'in_hash'}->{'folder'}&user=$self->{'in_hash'}->{'user'}", $self->{'text_hash'}->{'view_return'},
			"list_mail.cgi?folder=$self->{'in_hash'}->{'folder'}&user=$self->{'in_hash'}->{'user'}", $self->{'text_hash'}->{'mail_return'},
			"", $self->{'text_hash'}->{'index_return'});
		exit;
		}
	elsif ($self->{'in_hash'}->{'black'}) {
		# Add sender to global SpamAssassin blacklist, and tell user
		$self->mail_page_header($self->{'text_hash'}->{'black_title'});

		$self->foreign_require("spam", "spam-lib.pl");
		local $conf = $main::spam_object->get_config();
		local @from = map { @{$_->{'words'}} }
			    	  $main::spam_object->find("blacklist_from", $conf);
		local %already = map { $_, 1 } @from;
		local ($spamfrom) = $self->address_parts($self->{'mail'}->{'header'}->{'from'});
		if ($already{$spamfrom}) {
			print "<b>",$self->text('black_already',
					  "<tt>$spamfrom</tt>"),"</b><p>\n";
			}
		else {
			push(@from, $spamfrom);
			$main::spam_object->save_directives($conf, 'blacklist_from',
					       \@from, 1);
			$self->flush_file_lines();
			print "<b>",$self->text('black_done',
					  "<tt>$spamfrom</tt>"),"</b><p>\n";
			}

		$self->mail_page_footer("list_mail.cgi?folder=$self->{'in_hash'}->{'folder'}&user=$self->{'in_hash'}->{'user'}", $self->{'text_hash'}->{'mail_return'}, "", $self->{'text_hash'}->{'index_return'});
		exit;
		}
	elsif ($self->{'in_hash'}->{'razor'}) {
		# Report message to Razor and tell user
		$self->mail_page_header($self->{'text_hash'}->{'razor_title'});

		print "<b>$self->{'text_hash'}->{'razor_report'}</b>\n";
		print "<pre>";
		local $cmd = $self->spam_report_cmd($self->{'in_hash'}->{'user'});
		local $temp = $self->transname();
		$self->send_mail($self->{'mail'}, $temp, 0, 1);
		$self->open_execute_command(*OUT, "$cmd <$temp 2>&1", 1);
		local $error;
		while(<OUT>) {
			print $self->html_escape($_);
			$error++ if (/failed/i);
			}
		close(OUT);
		unlink($temp);
		print "</pre>\n";
		if ($? || $error) {
			print "<b>$self->{'text_hash'}->{'razor_err'}</b><p>\n";
			}
		else {
			if ($self->{'config_hash'}->{'spam_del'}) {
				# Delete message too
				$self->lock_folder($self->{'folder'});
				$self->mailbox_delete_mail($self->{'folder'}, $self->{'mail'});
				$self->unlock_folder($self->{'folder'});
				print "<b>$self->{'text_hash'}->{'razor_deleted'}</b><p>\n";
				}
			else {
				print "<b>$self->{'text_hash'}->{'razor_done'}</b><p>\n";
				}
			}

		$self->mail_page_footer("list_mail.cgi?folder=$self->{'in_hash'}->{'folder'}&user=$self->{'in_hash'}->{'user'}", $self->{'text_hash'}->{'mail_return'}, "", $self->{'text_hash'}->{'index_return'});
		exit;
		}

	if (!@{$self->{'mailforward_array'}}) {
		$self->parse_mail($self->{'mail'});
		@attach = @{$self->{'mail'}->{'attach'}};
		}

	if ($self->{'in_hash'}->{'strip'}) {
		# Remove all non-body attachments
		local $newmail = { 'headers' => $self->{'mail'}->{'headers'},
				   'header' => $self->{'mail'}->{'header'},
				   'fromline' => $self->{'mail'}->{'fromline'} };
		foreach $a (@attach) {
			if ($a->{'type'} eq 'text/plain' ||
			    $a->{'type'} eq 'text') {
				$newmail->{'attach'} = [ $a ];
				last;
				}
			}
		$self->lock_folder($self->{'folder'});
		$self->mailbox_modify_mail($self->{'mail'}, $newmail, $self->{'folder'});
		$self->unlock_folder($self->{'folder'});
		$self->redirect("list_mail.cgi?user=$self->{'in_hash'}->{'user'}&folder=$self->{'in_hash'}->{'folder'}");
		exit;
		}

	if ($self->{'in_hash'}->{'enew'}) {
		# Editing an existing message, so keep same fields
		$self->{'to'} = $self->{'mail'}->{'header'}->{'to'};
		$self->{'rto'} = $self->{'mail'}->{'header'}->{'reply-to'};
		$self->{'from'} = $self->{'mail'}->{'header'}->{'from'};
		$self->{'cc'} = $self->{'mail'}->{'header'}->{'cc'};
		$self->{'ouser'} = $1 if ($self->{'from'} =~ /^(\S+)\@/);
		}
	else {
		if (!$self->{'in_hash'}->{'forward'} && !@{$self->{'mailforward_array'}}) {
			# Replying to a message, so set To: field
			$self->{'to'} = $self->{'mail'}->{'header'}->{'reply-to'};
			$self->{'to'} = $self->{'mail'}->{'header'}->{'from'} if (!$self->{'to'});
			}
		if ($self->{'in_hash'}->{'rall'}) {
			# If replying to all, add any addresses in the original
			# To: or Cc: to our new Cc: address.
			# XXX should strip own addresses
			$self->{'cc'} = $self->{'mail'}->{'header'}->{'to'};
			$self->{'cc'} .= ", ".$self->{'mail'}->{'header'}->{'cc'}
				if ($self->{'mail'}->{'header'}->{'cc'});
			}
		}

	# Work out new subject, depending on whether we are replying
	# our forwarding a message (or neither)
	local $qu = !$self->{'in_hash'}->{'enew'} &&
		    (!$self->{'in_hash'}->{'forward'} || !$self->{'config_hash'}->{'fwd_mode'});
	$self->{'subject'} = $self->html_escape($self->decode_mimewords(
				$self->{'mail'}->{'header'}->{'subject'}));
	$self->{'subject'} = "Re: ".$self->{'subject'} if ($self->{'subject'} !~ /^Re/i && !$self->{'in_hash'}->{'forward'} &&
				       !@{$self->{'mailforward_array'}} && !$self->{'in_hash'}->{'enew'});
	$self->{'subject'} = "Fwd: ".$self->{'subject'} if ($self->{'subject'} !~ /^Fwd/i &&
					($self->{'in_hash'}->{'forward'} || @{$self->{'mailforward_array'}}));

	# Construct the initial mail text
	$self->{'sig'} = $self->get_signature($self->{'in_hash'}->{'user'});
	($self->{'quote'}, $self->{'html_edit'}, $self->{'body'}) = $self->quoted_message($self->{'mail'}, $qu, $self->{'sig'});
	if ($self->{'in_hash'}->{'forward'} || $self->{'in_hash'}->{'enew'}) {
		@attach = grep { $_ ne $self->{'body'} } @attach;
		}
	else {
		undef(@attach);
		}

	# Show header
#	$self->ui_print_header(undef,
#		$self->{'in_hash'}->{'forward'} || @{$self->{'mailforward_array'}} ? $self->{'text_hash'}->{'forward_title'} :
#		$self->{'in_hash'}->{'enew'} ? $self->{'text_hash'}->{'enew_title'} :
#			      $self->{'text_hash'}->{'reply_title'}, "", undef, 0, 0, undef,
#		$self->folder_link($self->{'in_hash'}->{'user'}, $self->{'folder'}), undef,
#		$self->{'html_edit'} ? "onload='initEditor()'" : "");
	$self->ui_print_header(undef, $self->{'text_hash'}->{'forward_title'}, "", undef, undef, 1);
	}

print "<form action=send_mail.cgi method=post enctype=multipart/form-data>\n";

# Output various hidden fields
print "<input type=hidden name=user value='$self->{'in_hash'}->{'user'}'>\n";
print "<input type=hidden name=ouser value='$self->{'ouser'}'>\n";
print "<input type=hidden name=idx value='$self->{'in_hash'}->{'idx'}'>\n";
print "<input type=hidden name=folder value='$self->{'in_hash'}->{'folder'}'>\n";
print "<input type=hidden name=new value='$self->{'in_hash'}->{'new'}'>\n";
print "<input type=hidden name=enew value='$self->{'in_hash'}->{'enew'}'>\n";
foreach $s (@{$self->{'sub_array'}}) {
	print "<input type=hidden name=sub value='$s'>\n";
	}

print "<table width=100% border=1>\n";
print "<tr> <td $self->{'tb'}><b>$self->{'text_hash'}->{'reply_headers'}</b></td> </tr>\n";
print "<tr> <td $self->{'cb'}><table width=100%>\n";

# Work out and show the From: address
print "<tr> <td><b>$self->{'text_hash'}->{'mail_from'}</b></td>\n";
$self->{'from'} = $self->{'from'} || $self->get_user_from_address(\@{$self->{'uinfo_array'}});
if ($self->{'access_hash'}->{'fmode'} == 0) {
	# Any email addresss
	print "<td><input name=from size=40 value='$self->{'from'}'></td>\n";
	}
elsif ($self->{'access_hash'}->{'fmode'} == 1) {
	# User's name in selected domains
	local $u = $self->{'from'} || $self->{'ouser'} || $self->{'in_hash'}->{'user'};
	$u =~ s/\@.*$//;
	print "<td><select name=from>\n";
	foreach $f (split(/\s+/, $self->{'access_hash'}->{'from'})) {
		printf "<option value=%s %s>%s\n",
		    "$u\@$f", $self->{'from'} eq "$u\@$f" ? 'selected' : '',
		    $self->{'access_hash'}->{'fromname'} ?
			"\"$self->{'access_hash'}->{'fromname'}\" &lt;$u\@$f&gt;" : "$u\@$f";
		}
	print "</select></td>\n";
	}
elsif ($self->{'access_hash'}->{'fmode'} == 2) {
	# Listed from addresses
	print "<td><select name=from>\n";
	foreach $f (split(/\s+/, $self->{'access_hash'}->{'from'})) {
		printf "<option value=%s %s>%s\n",
		    $f, $self->{'from'} eq $f ? 'selected' : '',
		    $self->{'access_hash'}->{'fromname'} ? "$self->{'access_hash'}->{'fromname'} &lt;$f&gt;" : $f;
		}
	print "</select></td>\n";
	}
elsif ($self->{'access_hash'}->{'fmode'} == 3) {
	# Fixed address in fixed domain
	print "<td><input name=from size=10>$self->{'ouser'}\@$self->{'access_hash'}->{'from'}</td>\n";
	}

$self->{'to'} = $self->html_escape($self->{'to'});
print "<td><b>$self->{'text_hash'}->{'mail_to'}</b></td> ",
      "<td><input name=to size=40 value=\"$self->{'to'}\"></td> </tr>\n";

$self->{'cc'} = $self->html_escape($self->{'cc'});
print "<tr> <td><b>$self->{'text_hash'}->{'mail_cc'}</b></td> ",
      "<td><input name=cc size=40 value=\"$self->{'cc'}\"></td>\n";
print "<td><b>$self->{'text_hash'}->{'mail_bcc'}</b></td> ",
      "<td><input name=bcc size=40 value='$self->{'config_hash'}->{'bcc_to'}'></td> </tr>\n";
print "<tr> <td><b>$self->{'text_hash'}->{'mail_subject'}</b></td> ",
      "<td><input name=subject size=40 value=\"$self->{'subject'}\"></td>\n";
print "<td><b>$self->{'text_hash'}->{'mail_pri'}</b></td> ",
      "<td><table cellpadding=0 cellspacing=0 width=100%>\n",
      "<tr><td align=left><select name=pri>\n",
      "<option value=1>$self->{'text_hash'}->{'mail_highest'}\n",
      "<option value=2>$self->{'text_hash'}->{'mail_high'}\n",
      "<option value='' selected>$self->{'text_hash'}->{'mail_normal'}\n",
      "<option value=4>$self->{'text_hash'}->{'mail_low'}\n",
      "<option value=5>$self->{'text_hash'}->{'mail_lowest'}\n",
      "</select></td>\n",
      "<td align=right><input type=submit value=\"$self->{'text_hash'}->{'reply_send'}\">\n",
      "</tr></table></td></tr>\n";
print "</table></td></tr></table><p>\n";

# Output message body input
print "<table width=100% border=1>\n",
      "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'reply_body'}</b></td> </tr>",
      "<tr $self->{'cb'}> <td>";
if ($self->{'html_edit'}) {
	# Output HTML editor textarea
	print <<EOF;
<script type="text/javascript">
  _editor_url = "$self->{'gconfig_hash'}->{'webprefix'}/$self->{'module_name'}/xinha/";
  _editor_lang = "en";
</script>
<script type="text/javascript" src="xinha/htmlarea.js"></script>

<script type="text/javascript">
var editor = null;
function initEditor() {
  editor = new HTMLArea("body");
  editor.generate();
  return false;
}
</script>
EOF
	print "<textarea rows=20 cols=80 style='width:100%' name=body id=body>",
	      $self->html_escape($self->{'quote'}),"</textarea>\n";
	}
else {
	# Show text editing area
	print "<textarea rows=20 cols=80 name=body $self->{'config_hash'}->{'wrap_mode'}>",
	      $self->html_escape($self->{'quote'}),"</textarea>\n";
	if ($self->has_command("ispell")) {
		print "<br>\n";
		print "<input type=checkbox name=spell value=1> $self->{'text_hash'}->{'reply_spell'}\n";
		}
	}
print "</td></tr></table><p>\n";
print "<input type=hidden name=html_edit value='$self->{'html_edit'}'>\n";

# Display forwarded attachments
if (@attach) {
	print "<table width=100% border=1>\n";
	print "<tr> <td $self->{'tb'}><b>$self->{'text_hash'}->{'reply_attach'}</b></td> </tr>\n";
	print "<tr> <td $self->{'cb'}>\n";
	foreach $a (@attach) {
		push(@{$self->{'titles_array'}}, "<input type=checkbox name=forward value=$a->{'idx'} checked> ".($a->{'filename'} ? $a->{'filename'} : $a->{'type'}));
		push(@{$self->{'links_array'}}, "detach.cgi?idx=$self->{'in_hash'}->{'idx'}&folder=$self->{'in_hash'}->{'folder'}&attach=$a->{'idx'}$self->{'subs'}");
		push(@{$self->{'icons_array'}}, "images/boxes.gif");
		}
	$self->icons_table(\@{$self->{'links_array'}}, \@{$self->{'titles_array'}}, \@{$self->{'icons_array'}}, 8);
	print "</td></tr></table><p>\n";
	}

# Display forwarded mails
if (@{$self->{'mailforward_array'}}) {
	print "<table width=100% border=1>\n";
	print "<tr> <td $self->{'tb'}><b>$self->{'text_hash'}->{'reply_mailforward'}</b></td> </tr>\n";
	print "<tr> <td $self->{'cb'}>\n";
	foreach $f (@{$self->{'mailforward_array'}}) {
		push(@{$self->{'titles_array'}}, $self->simplify_subject($self->{'mails_array'}->[$f]->{'header'}->{'subject'}));
		push(@{$self->{'links_array'}}, "view_mail.cgi?idx=$f&folder=$self->{'in_hash'}->{'folder'}&user=$self->{'in_hash'}->{'user'}");
		push(@{$self->{'icons_array'}}, "images/boxes.gif");
		print "<input type=hidden name=mailforward value=$f>\n";
		}
	$self->icons_table(\@{$self->{'links_array'}}, \@{$self->{'titles_array'}}, \@{$self->{'icons_array'}}, 8);
	print "</td></tr></table><p>\n";
	}

# Add form for more attachments
print "<table width=100% border=1>\n";
print "<tr $self->{'tb'}> <td colspan=3><b>$self->{'text_hash'}->{'reply_attach2'}</b></td> </tr>\n";

print "<tr $self->{'cb'}> <td><input type=file size=20 name=attach0></td>\n";
print "<td><input type=file size=20 name=attach1></td>\n";
print "<td><input type=file size=20 name=attach2></td> </tr>\n";

print "<tr $self->{'cb'}> <td><input type=file size=20 name=attach3></td>\n";
print "<td><input type=file size=20 name=attach4></td>\n";
print "<td><input type=file size=20 name=attach5></td> </tr>\n";

if ($self->{'access_hash'}->{'canattach'}) {
	print "<tr $self->{'cb'}> <td><input name=file0 size=20> ",
		$self->file_chooser_button("file0"),"</td>\n";
	print "<td><input name=file1 size=20> ",
		$self->file_chooser_button("file1"),"</td>\n";
	print "<td><input name=file2 size=20> ",
		$self->file_chooser_button("file2"),"</td> </tr>\n";
	}

print "</table><p>\n";
print "<input type=submit value=\"$self->{'text_hash'}->{'reply_send'}\">\n";
print "</form>\n";

$self->ui_print_footer($self->{'text_hash'}->{'index_mainpage_url'}, $self->{'text_hash'}->{'index_mainpage'},
	"", $self->{'text_hash'}->{'index_return'},
	"list_mail.cgi?folder=$self->{'in_hash'}->{'folder'}&user=$self->{'in_hash'}->{'user'}",$self->{'text_hash'}->{'mail_return'});

1;
		
}

sub decode_and_sub
{
	shift if ($self == $_[0]);

return if (!$self->{'mail'});
$self->parse_mail($self->{'mail'});
@{$self->{'sub_array'}} = split(/\0/, $self->{'in_hash'}->{'sub'});
$self->{'subs'} = join("", map { "&sub=$_" } @{$self->{'sub_array'}});
foreach $s (@{$self->{'sub_array'}}) {
	# We are looking at a mail within a mail ..
	local $amail = $self->extract_mail(
			$self->{'mail'}->{'attach'}->[$s]->{'data'});
	$self->parse_mail($amail);
	$self->{'mail'} = $amail;
	}
}


1;

