#!/usr/bin/perl

&MAIN();

 sub MAIN {
# send_mail.cgi
# Send off an email message

&ModuleLoader::preload_module('mailboxes_class', "mailboxes::MailboxesLib");
$self = new mailboxes::MailboxesLib:: 'mailboxes_class',%$self;

$self->ReadParseMime();
$self->can_user($self->{'in_hash'}->{'user'}) || $self->error($self->{'text_hash'}->{'mail_ecannot'});
@{$self->{'uinfo_array'}} = $self->get_mail_user($self->{'in_hash'}->{'user'});
@{$self->{'uinfo_array'}} || $self->error($self->{'text_hash'}->{'view_eugone'});

# Check inputs
@{$self->{'folders_array'}} = $self->list_user_folders($self->{'in_hash'}->{'user'});
$self->{'folder'} = $self->{'folders_array'}->[$self->{'in_hash'}->{'folder'}];
$self->error_setup($self->{'text_hash'}->{'send_err'});
$self->{'in_hash'}->{'to'} || $self->error($self->{'text_hash'}->{'send_eto'});
if ($self->{'access_hash'}->{'fmode'} == 0) {
	# Any from address allowed
	$self->{'in_hash'}->{'from'} || $self->error($self->{'text_hash'}->{'send_efrom'});
	}
elsif ($self->{'access_hash'}->{'fmode'} == 1) {
	# From address must be in an allowed domain, and match username
	$self->{'validfrom'} = $self->get_user_from_address(\@{$self->{'uinfo_array'}});
	foreach $f (split(/\s+/, $self->{'access_hash'}->{'from'})) {
		$self->{'found'}++ if ("$self->{'in_hash'}->{'user'}\@$f" eq $self->{'in_hash'}->{'from'} ||
			     "$self->{'in_hash'}->{'ouser'}\@$f" eq $self->{'in_hash'}->{'from'} ||
			     $self->{'validfrom'} eq $self->{'in_hash'}->{'from'});
		}
	$self->error($self->{'text_hash'}->{'send_efrom'}) if (!$self->{'found'});
	}
elsif ($self->{'access_hash'}->{'fmode'} == 2) {
	# From address must be in allowed list
	foreach $f (split(/\s+/, $self->{'access_hash'}->{'from'})) {
		$self->{'found'}++ if ($f eq $self->{'in_hash'}->{'from'});
		}
	$self->error($self->{'text_hash'}->{'send_efrom'}) if (!$self->{'found'});
	}
elsif ($self->{'access_hash'}->{'fmode'} == 3) {
	$self->{'in_hash'}->{'from'} .= "\@$self->{'access_hash'}->{'from'}";
	}
if ($self->{'in_hash'}->{'from'} =~ /^(\S+)\@(\S+)$/ && $self->{'access_hash'}->{'fromname'}) {
	$self->{'in_hash'}->{'from'} = "$self->{'access_hash'}->{'fromname'} do { my $t=$self->{'in_hash'}->{'from'}; <$t> }";
	}
@{$self->{'sub_array'}} = split(/\0/, $self->{'in_hash'}->{'sub'});
$self->{'subs'} = join("", map { "&sub=$_" } @{$self->{'sub_array'}});

# Construct the email
$self->{'in_hash'}->{'from'} || $self->error($self->{'text_hash'}->{'send_efrom'});
$mail->{'headers'} = [ [ 'From', $self->{'in_hash'}->{'from'} ],
		       [ 'Subject', $self->{'in_hash'}->{'subject'} ],
		       [ 'To', $self->{'in_hash'}->{'to'} ],
		       [ 'Cc', $self->{'in_hash'}->{'cc'} ],
		       [ 'Bcc', $self->{'in_hash'}->{'bcc'} ],
		       [ 'X-Originating-IP', $ENV{'REMOTE_ADDR'} ],
		       [ 'X-Mailer', "Webmin ".$self->get_webmin_version() ] ];
push(@{$mail->{'headers'}}, [ 'X-Priority', $self->{'in_hash'}->{'pri'} ]) if ($self->{'in_hash'}->{'pri'});
$self->{'in_hash'}->{'body'} =~ s/\r//g;
if ($self->{'in_hash'}->{'body'} =~ /\S/) {
	if ($self->{'in_hash'}->{'spell'}) {
		pipe(INr, INw);
		pipe(OUTr, OUTw);
		select(INw); $| = 1; select(OUTr); $| = 1; select(STDOUT);
		if (!fork()) {
			close(INw);
			close(OUTr);
			untie(*STDIN);
			untie(*STDOUT);
			untie(*STDERR);
			open(STDOUT, ">&OUTw");
			open(STDERR, ">/dev/null");
			open(STDIN, "<&INr");
			exec("ispell -a");
			exit;
			}
		close(INr);
		close(OUTw);
		local $indent = "&nbsp;" x 4;
		local @errs;
		foreach $line (split(/\n+/, $self->{'in_hash'}->{'body'})) {
			next if ($line !~ /\S/);
			print INw $line,"\n";
			local @lerrs;
			while(1) {
				($self->{'spell'} = <OUTr>) =~ s/\r|\n//g;
				last if (!$self->{'spell'});
				if ($self->{'spell'} =~ /^#\s+(\S+)/) {
					# Totally unknown word
					push(@lerrs, $indent.$self->text('send_eword', "<i>".$self->html_escape($1)."</i>"));
					}
				elsif ($self->{'spell'} =~ /^&\s+(\S+)\s+(\d+)\s+(\d+):\s+(.*)/) {
					# Maybe possible word, with options
					push(@lerrs, $indent.$self->text('send_eword2', "<i>".$self->html_escape($1)."</i>", "<i>".$self->html_escape($4)."</i>"));
					}
				elsif ($self->{'spell'} =~ /^\?\s+(\S+)/) {
					# Maybe possible word
					push(@lerrs, $indent.$self->text('send_eword', "<i>".$self->html_escape($1)."</i>"));
					}
				}
			if (@lerrs) {
				push(@errs, $self->text('send_eline', "<tt>".$self->html_escape($line)."</tt>")."<br>".join("<br>", @lerrs)."<p>\n");
				}
			}
		close(INw);
		close(OUTr);
		if (@errs) {
			# Spelling errors found!
			$self->mail_page_header($self->{'text_hash'}->{'compose_title'}, undef, undef,
					  $self->folder_link($self->{'in_hash'}->{'user'}, $self->{'folder'}));
			print "<b>$self->{'text_hash'}->{'send_espell'}</b><p>\n";
			print @errs;
			$self->mail_page_footer("index.cgi?user=$self->{'in_hash'}->{'user'}&folder=$self->{'in_hash'}->{'folder'}",
				$self->{'text_hash'}->{'mail_return'});
			exit;
			}
		}
	local $mt = $self->{'in_hash'}->{'html_edit'} ? "text/html" : "text/plain";
	if ($self->{'in_hash'}->{'body'} =~ /[\177-\377]/) {
		# Contains 8-bit characters .. need to make quoted-printable
		$self->{'quoted_printable'}++;
		@{$self->{'attach_array'}} = ( { 'headers' => [ [ 'Content-Type', $mt ],
					     [ 'Content-Transfer-Encoding',
					       'quoted-printable' ] ],
			      'data' => $self->quoted_encode($self->{'in_hash'}->{'body'}) } );
		}
	else {
		# Plain 7-bit ascii text
		@{$self->{'attach_array'}} = ( { 'headers' => [ [ 'Content-Type', $mt ],
					     [ 'Content-Transfer-Encoding',
					       '7bit' ] ],
			      'data' => $self->{'in_hash'}->{'body'} } );
		}
	$self->{'bodyattach'} = $self->{'attach_array'}->[0];
	}
$self->{'attachsize'} = 0;
foreach $i (0 .. 5) {
	# Add uploaded attachment
	next if (!$self->{'in_hash'}->{"attach$i"});
	&test_max_attach($self->{'attachsize'});
	local $filename = $self->{'in_hash'}->{"attach${i}_filename"};
	$filename =~ s/^.*(\\|\/)//;
	local $type = $self->{'in_hash'}->{"attach${i}_content_type"}."; name=\"".
		      $filename."\"";
	local $disp = "inline; filename=\"".$filename."\"";
	push(@{$self->{'attach_array'}}, { 'data' => $self->{'in_hash'}->{"attach${i}"},
			'headers' => [ [ 'Content-type', $type ],
				       [ 'Content-Disposition', $disp ],
				       [ 'Content-Transfer-Encoding',
					 'base64' ] ] });
	$self->{'atotal'} += length($self->{'in_hash'}->{"attach${i}"});
	}
foreach $i (0 .. 2) {
	# Add server-side attachment
	next if (!$self->{'in_hash'}->{"file$i"} || !$self->{'access_hash'}->{'canattach'});
	@{$self->{'uinfo_array'}} = $self->get_mail_user($self->{'in_hash'}->{'user'});
	@{$self->{'uinfo_array'}} || $self->error($self->{'text_hash'}->{'view_eugone'});
	if ($self->{'in_hash'}->{"file$i"} !~ /^\//) {
		$self->{'in_hash'}->{"file$i"} = $self->{'uinfo_array'}->[7]."/".$self->{'in_hash'}->{"file$i"};
		}

	local @st = stat($self->{'in_hash'}->{"file$i"});
	&test_max_attach($st[7]);
	local $data;
	$self->switch_to_user($self->{'in_hash'}->{'user'});
	open(DATA, $self->{'in_hash'}->{"file$i"}) || $self->error($self->text('send_efile', $self->{'in_hash'}->{"file$i"}, $!));
	while(<DATA>) {
		$data .= $_;
		}
	close(DATA);
	$self->switch_user_back();
	$self->{'in_hash'}->{"file$i"} =~ s/^.*\///;
	local $type = $self->guess_mime_type($self->{'in_hash'}->{"file$i"}).
		      "; name=\"".$self->{'in_hash'}->{"file$i"}."\"";
	local $disp = "inline; filename=\"".$self->{'in_hash'}->{"file$i"}."\"";
	push(@{$self->{'attach_array'}}, { 'data' => $data,
			'headers' => [ [ 'Content-type', $type ],
				       [ 'Content-Disposition', $disp ],
				       [ 'Content-Transfer-Encoding',
					 'base64' ] ] });
	$self->{'atotal'} += length($data);
	}
@{$self->{'fwd_array'}} = split(/\0/, $self->{'in_hash'}->{'forward'});
if (@{$self->{'fwd_array'}}) {
	# Add forwarded attachments
	@{$self->{'mail_array'}} = $self->mailbox_list_mails($self->{'in_hash'}->{'idx'}, $self->{'in_hash'}->{'idx'}, $self->{'folder'});
	$self->{'fwdmail'} = $self->{'mail_array'}->[$self->{'in_hash'}->{'idx'}];
	$self->parse_mail($self->{'fwdmail'});

	foreach $s (@{$self->{'sub_array'}}) {
		# We are looking at a mail within a mail ..
		local $amail = $self->extract_mail($self->{'fwdmail'}->{'attach'}->[$s]->{'data'});
		$self->parse_mail($amail);
		$self->{'fwdmail'} = $amail;
		}

	foreach $f (@{$self->{'fwd_array'}}) {
		&test_max_attach(length($self->{'fwdmail'}->{'attach'}->[$f]->{'data'}));
		push(@{$self->{'attach_array'}}, $self->{'fwdmail'}->{'attach'}->[$f]);
		$self->{'atotal'} += length($self->{'fwdmail'}->{'attach'}->[$f]->{'data'});
		}
	}
@{$self->{'mailfwd_array'}} = split(/\0/, $self->{'in_hash'}->{'mailforward'});
if (@{$self->{'mailfwd_array'}}) {
	# Add forwarded emails
	@{$self->{'mail_array'}} = $self->mailbox_list_mails($self->{'mailfwd_array'}->[0], $self->{'mailfwd_array'}->[@{$self->{'mailfwd_array'}}-1], $self->{'folder'});
	foreach $f (@{$self->{'mailfwd_array'}}) {
		$self->{'fwdmail'} = $self->{'mail_array'}->[$f];
		local $headertext;
		foreach $h (@{$self->{'fwdmail'}->{'headers'}}) {
			$headertext .= $h->[0].": ".$h->[1]."\n";
			}
		push(@{$self->{'attach_array'}}, { 'data' => $headertext."\n".$self->{'fwdmail'}->{'body'},
				'headers' => [ [ 'Content-type', 'message/rfc822' ],
					       [ 'Content-Description',
						  $self->{'fwdmail'}->{'header'}->{'subject'} ] ]
			      });
		}
	}
$mail->{'attach'} = \@{$self->{'attach_array'}};
if ($self->{'access_hash'}->{'attach'} >= 0 && $self->{'atotal'} > $self->{'access_hash'}->{'attach'}*1024) {
	$self->error($self->text('send_eattach', $self->{'access_hash'}->{'attach'}));
	}

# Check for text-only email
$self->{'textonly'} = $self->{'config_hash'}->{'no_mime'} && !$self->{'quoted_printable'} &&
	    @{$mail->{'attach'}} == 1 &&
	    $mail->{'attach'}->[0] eq $self->{'bodyattach'} &&
	    !$self->{'in_hash'}->{'html_edit'};

# Send it off
$self->send_mail($mail, undef, $self->{'textonly'}, $self->{'config_hash'}->{'no_crlf'});
$self->webmin_log("send", undef, undef, { 'from' => $self->{'in_hash'}->{'from'}, 'to' => $self->{'in_hash'}->{'to'} });

# Tell the user that email as sent
$self->mail_page_header($self->{'text_hash'}->{'send_title'}, undef, undef,
		  $self->folder_link($self->{'in_hash'}->{'user'}, $self->{'folder'}));

@{$self->{'tos_array'}} = ( split(/,/, $self->{'in_hash'}->{'to'}), split(/,/, $self->{'in_hash'}->{'cc'}), split(/,/, $self->{'in_hash'}->{'bcc'}) );
$self->{'tos'} = join(" , ", map { "<tt>".$self->html_escape($_)."</tt>" } @{$self->{'tos_array'}});
print "<p>",$self->text($self->{'in_hash'}->{'draft'} ? 'send_draft' : 'send_ok', $self->{'tos'}),"<p>\n";

if ($self->{'in_hash'}->{'idx'} ne '') {
	$self->mail_page_footer("view_mail.cgi?idx=$self->{'in_hash'}->{'idx'}&folder=$self->{'in_hash'}->{'folder'}&user=$self->{'in_hash'}->{'user'}$self->{'subs'}",
	        $self->{'text_hash'}->{'view_return'},
		"list_mail.cgi?folder=$self->{'in_hash'}->{'folder'}&user=$self->{'in_hash'}->{'user'}",
		$self->{'text_hash'}->{'mail_return'},
		"", $self->{'text_hash'}->{'index_return'});
	}
else {
	$self->mail_page_footer("list_mail.cgi?folder=$self->{'in_hash'}->{'folder'}&user=$self->{'in_hash'}->{'user'}",
		$self->{'text_hash'}->{'mail_return'},
		"", $self->{'text_hash'}->{'index_return'});
	}

1;
		
}

# write_attachment(&attach)
sub write_attachment
{
	shift if ($self == $_[0]);

local ($a) = @_;
local ($enc, $rv);
foreach $h (@{$a->{'headers'}}) {
	$rv .= $h->[0].": ".$h->[1]."\r\n";
	$enc = $h->[1]
	    if (lc($h->[0]) eq 'content-transfer-encoding');
	}
$rv .= "\r\n";
if (lc($enc) eq 'base64') {
	local $encoded = $self->encode_base64($a->{'data'});
	$encoded =~ s/\r//g;
	$encoded =~ s/\n/\r\n/g;
	$rv .= $encoded;
	}
else {
	$a->{'data'} =~ s/\r//g;
	$a->{'data'} =~ s/\n/\r\n/g;
	$rv .= $a->{'data'};
	if ($a->{'data'} !~ /\n$/) {
		$rv .= "\r\n";
		}
	}
return $rv;
}

sub test_max_attach
{
	shift if ($self == $_[0]);

$self->{'attachsize'} += $_[0];
if ($self->{'access_hash'}->{'attach'} >= 0 && $self->{'attachsize'} > $self->{'access_hash'}->{'attach'}) {
	$self->error($self->text('send_eattachsize', $self->{'access_hash'}->{'attach'}));
	}
}


1;

