#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Create, update or delete a mailcap entry

&ModuleLoader::preload_module('mailcap_class', "mailcap::MailcapLib");
$self = new mailcap::MailcapLib:: 'mailcap_class',%$self;

$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'save_err'});
@{$self->{'mailcap_array'}} = $self->list_mailcap();

if (!$self->{'in_hash'}->{'new'}) {
	($self->{'mailcap'}) = grep { $_->{'index'} == $self->{'in_hash'}->{'index'} } @{$self->{'mailcap_array'}};
	$self->{'mailcap'} || $self->error($self->{'text_hash'}->{'edit_egone'});
	}
else {
	$self->{'mailcap'} = { 'args' => { } };
	}

$self->lock_file($self->{'mailcap_file'});
if ($self->{'in_hash'}->{'delete'}) {
	# Just trash one
	$self->delete_mailcap($self->{'mailcap'});
	}
else {
	# Validate inputs
	$self->{'in_hash'}->{'type'} =~ /([a-z0-9\-]+)\/([a-z0-9\-\*]+)/ ||
		$self->error($self->{'text_hash'}->{'save_etype'});
	#if (($self->{'in_hash'}->{'new'} || $self->{'in_hash'}->{'old'} ne $self->{'in_hash'}->{'type'}) && $self->{'in_hash'}->{'enabled'}) {
	#    ($clash) = grep { $_->{'type'} eq $self->{'in_hash'}->{'type'} &&
	#		      $_->{'enabled'} == 1 } @{$self->{'mailcap_array'}};
	#    $clash && $self->error($self->{'text_hash'}->{'save_eclash'});
	#    }
        $self->{'mailcap'}->{'type'} = $self->{'in_hash'}->{'type'};
        $self->{'mailcap'}->{'enabled'} = $self->{'in_hash'}->{'enabled'};
	$self->{'in_hash'}->{'program'} ||
		$self->error($self->{'text_hash'}->{'save_eprogram'});
        $self->{'mailcap'}->{'program'} = $self->{'in_hash'}->{'program'};
	$self->{'in_hash'}->{'cmt'} =~ s/\r//g;
	$self->{'in_hash'}->{'cmt'} =~ s/\s*$//g;
	$self->{'mailcap'}->{'cmt'} = $self->{'in_hash'}->{'cmt'};

	# Save extra args
	$self->{'args'} = $self->{'mailcap'}->{'args'};
	if ($self->{'in_hash'}->{'test_def'}) {
		delete($self->{'args'}->{'test'});
		}
	else {
		$self->{'in_hash'}->{'test'} =~ /\S/ && $self->{'in_hash'}->{'test'} !~ /;/ ||
			$self->error($self->{'text_hash'}->{'save_etest'});
		$self->{'args'}->{'test'} = $self->{'in_hash'}->{'test'};
		}
	if ($self->{'in_hash'}->{'term'}) {
		$self->{'args'}->{'needsterminal'} = '';
		}
	else {
		delete($self->{'args'}->{'needsterminal'});
		}
	if ($self->{'in_hash'}->{'copious'}) {
		$self->{'args'}->{'copiousoutput'} = '';
		}
	else {
		delete($self->{'args'}->{'copiousoutput'});
		}
	if ($self->{'in_hash'}->{'desc_def'}) {
		delete($self->{'args'}->{'description'});
		}
	else {
		$self->{'in_hash'}->{'desc'} !~ /;/ || $self->error($self->{'text_hash'}->{'save_edesc'});
		$self->{'args'}->{'description'} = $self->{'in_hash'}->{'desc'};
		}
	
	# Update in file
	if ($self->{'in_hash'}->{'new'}) {
	      $self->create_mailcap($self->{'mailcap'});
	      }
	else {
	      $self->modify_mailcap($self->{'mailcap'});
	      }
	}
$self->unlock_file($self->{'mailcap_file'});
$self->webmin_log($self->{'in_hash'}->{'new'} ? "create" : $self->{'in_hash'}->{'delete'} ? "delete" : "modify",
	    "mailcap", $self->{'in_hash'}->{'old'} || $self->{'in_hash'}->{'type'});
$self->redirect("");

1;
		
}


1;

