#!/usr/bin/perl

&MAIN();

 sub MAIN {
# index.cgi
# print mailman lists, service submits

# require funcs library
&ModuleLoader::preload_module('mailman_class', "mailman::MailmanLib");
$self = new mailman::MailmanLib:: 'mailman_class',%$self;


# get %IN & ACL
$self->ReadParse();
%{$self->{'access_hash'}} = $self->get_module_acl();

local $out;
if ($self->{'in_hash'}->{'start'} && !$self->{'access_hash'}->{'nodaemon'}) 
{ 
 # start mailman
 $out = $self->start_mailman(); 
 $self->error($self->text('error_start', $out)) if $out;
 sleep(1);
}
elsif ($self->{'in_hash'}->{'stop'} && !$self->{'access_hash'}->{'nodaemon'}) 
{ 
 # stop mailman
 $out = $self->stop_mailman(); 
 $self->error($self->text('error_stop', $out)) if $out;
 sleep(1);
}
elsif ($self->{'in_hash'}->{'restart'} && !$self->{'access_hash'}->{'nodaemon'}) 
{ 
 # restart mailman
 $out = $self->restart_mailman(); 
 $self->error($self->text('error_restart', $out)) if $out;
 sleep(1);
}
elsif ($self->{'in_hash'}->{'pass'} && !$self->{'access_hash'}->{'nodaemon'}) 
{ 
 # change site password
 $out = $self->set_site_password($self->{'in_hash'}->{'pass'});
 $self->error($self->text('error_pass', $out)) if $out;
}

# print header
local $ver = $self->get_mailman_version();
$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", undef, 1, 1, 0, undef, undef, undef, $ver ? $self->text('index_version', $ver) : undef);

# print non-configured error
local $err = $self->mailman_check();
$self->ui_print_endpage($err) if $err;

# get lists list
local (@lists, @access_dom, @dom, $hostname, $url);
if ($self->{'access_hash'}->{'virts'})
{
 # owner interface
 @access_dom = split(/\s/, $self->{'access_hash'}->{'virts'});
 foreach (@access_dom)
 {
  push (@lists, $self->list_lists($_));
 }
 $hostname = $access_dom[0];
 @dom = map { [ $_ ] } @access_dom;
 (undef, $url) = $self->get_host_options();
}
else
{
 # admin interface
 @lists = $self->list_lists();
 @dom = map { [ $_->{'dom'} ] } sort { $a->{'dom'} cmp $b->{'dom'} } $main::virtual_server_object->list_domains();
 ($hostname, $url) = $self->get_host_options();
}
if (@lists) 
{
 # print all lists	
 print $self->ui_columns_start([ $self->{'text_hash'}->{'index_list'},
 									$self->{'text_hash'}->{'index_dom'},
									$self->{'text_hash'}->{'index_desc'},
									$self->{'text_hash'}->{'index_users'},
									$self->{'text_hash'}->{'index_action'} ],100);
 foreach $l (@lists) 
 {
  local @m = $self->list_members($l);	
  print $self->ui_columns_row(["<a class=menu href='http://$url/mailman/admin/$l->{'list'}'>$l->{'name'}</a>", 
		$l->{'dom'} ? $l->{'dom'} : $hostname, $l->{'desc'} ? $l->{'desc'} : $self->{'text_hash'}->{'list_no_desc'},''.@m.'',
	    "<a class=menu href='maillist.cgi?delete=$l->{'name'}&dom=$l->{'dom'}'>$self->{'text_hash'}->{'delete'}</a> | ".
	    "<a class=menu href='maillist.cgi?members=$l->{'name'}&dom=$l->{'dom'}'>$self->{'text_hash'}->{'index_mems'}</a> | ".
	    "<a class=menu href='maillist.cgi?edit=$l->{'name'}&dom=$l->{'dom'}'>$self->{'text_hash'}->{'index_man'}</a> | ".
	    "<a class=menu href='maillist.cgi?password=$l->{'name'}&dom=$l->{'dom'}'>$self->{'text_hash'}->{'index_reset'}</a>"
	    ]);
 }
 print $self->ui_columns_row(['&nbsp;','&nbsp;','&nbsp;','&nbsp;','&nbsp;']);
 print $self->ui_columns_end();
}
else { print "<b>$self->{'text_hash'}->{'index_none'}</b><p>\n"; }

# create new list
print $self->ui_form_start("add_list.cgi");
print $self->ui_table_start($self->{'text_hash'}->{'index_header'}, 'width=100%', 2);
print $self->ui_table_row("<b>$self->{'text_hash'}->{'index_list'}</b>", $self->ui_textbox("name", undef, 25), 1);
if ($self->{'access_hash'}->{'virts'})
{
 # owner interface
 print $self->ui_hidden('dom', $hostname) if ($#dom == 0);
 print $self->ui_table_row($self->{'text_hash'}->{'index_dom'}, ($#dom == 0 ) ? $hostname : $self->ui_select("dom", $hostname,[@dom]));
}
else
{
 # admin interface
 print $self->ui_table_row($self->{'text_hash'}->{'index_dom'}, @dom ? $self->ui_select("dom", "",[ [""], @dom]) : $hostname);
}
print $self->ui_table_row($self->{'text_hash'}->{'index_desc'}, $self->ui_textbox("desc", undef, 25), 1);
print $self->ui_table_row($self->{'text_hash'}->{'index_lang'}, $self->ui_select("lang", $self->{'current_lang'}, [ [ "", "&lt;$self->{'text_hash'}->{'default'}&gt;" ], map { [ $_, $_ ] } $self->list_mailman_languages() ]));
if (@dom)
{
 print $self->ui_table_row($self->{'text_hash'}->{'index_email'}, $self->ui_opt_textbox("email", undef, 25, $self->{'text_hash'}->{'index_fv'}), 1);
}
else
{
 print $self->ui_table_row($self->{'text_hash'}->{'index_email'}, $self->ui_textbox("email", undef, 25), 1);
}
print $self->ui_table_row($self->{'text_hash'}->{'index_pass'}, $self->ui_password("pass", undef, 15), 1);
print $self->ui_columns_row(['&nbsp;','&nbsp;','&nbsp;','&nbsp;']);
print $self->ui_table_end();
print $self->ui_submit($self->{'text_hash'}->{'create'});
print $self->ui_form_end();

unless ($self->{'access_hash'}->{'nodaemon'})
{
 # proces managment
 print $self->ui_table_start($self->{'text_hash'}->{'process_managment'}, 'width=100%', 2);
 print $self->ui_form_start('edit_conf.cgi','post');
 print $self->ui_table_row($self->ui_submit($self->{'text_hash'}->{'index_edit_gl'}), $self->{'text_hash'}->{'index_editmsg'});
 print $self->ui_form_end();
 print $self->ui_form_start('change_pass.cgi','post');
 print $self->ui_table_row($self->ui_submit($self->{'text_hash'}->{'index_change'}), $self->{'text_hash'}->{'index_changemsg'});
 print $self->ui_form_end();
 print $self->ui_form_start('index.cgi','post');
 if ($self->is_mailman_running())
 {
  # service started
  print $self->ui_hidden('stop',1);
  print $self->ui_table_row($self->ui_submit($self->{'text_hash'}->{'index_stop'}), $self->{'text_hash'}->{'index_stopmsg'});
  print $self->ui_form_end();
  print $self->ui_form_start('index.cgi','post');
  print $self->ui_hidden('restart',1);
  print $self->ui_table_row($self->ui_submit($self->{'text_hash'}->{'index_restart'}), $self->{'text_hash'}->{'index_restartmsg'});
 }
 else
 {
  # service stoped
  print $self->ui_hidden('start',1);
  print $self->ui_table_row($self->ui_submit($self->{'text_hash'}->{'index_start'}), $self->{'text_hash'}->{'index_startmsg'});
 }
 print $self->ui_form_end();
 print $self->ui_table_end();
}

# print footer
$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});
1;
		
}


1;

