#!/usr/bin/perl

&MAIN();

 sub MAIN {
# mailmanlist.cgi
# manage mailman list

# require funcs library
&ModuleLoader::preload_module('mailman_class', "mailman::MailmanLib");
$self = new mailman::MailmanLib:: 'mailman_class',%$self;


# get %IN & ACL
$self->ReadParse();
%{$self->{'access_hash'}} = $self->get_module_acl();

local ($ok, $fullname, $hdr);
if (defined($self->{'in_hash'}->{'delete'}))
{
 # delete list
 if ($self->{'access_hash'}->{'virts'})
 {
  # access control
  $ok = $self->check_dom_acl($self->{'in_hash'}->{'dom'});
  $self->error($self->text('virt_manage_ecannot', $self->{'in_hash'}->{'dom'})) unless $ok;
 }
 # print delete confirm form
 $self->ui_print_header(undef, $self->{'text_hash'}->{'delete_title'}, '');
 print $self->ui_form_start('delete_list.cgi');
 print $self->ui_hidden('name',$self->{'in_hash'}->{'delete'});
 print $self->ui_hidden('dom',$self->{'in_hash'}->{'dom'});
 $hdr = $self->{'in_hash'}->{'dom'} ? "<b>$self->{'in_hash'}->{'delete'}</b> from domain <b>$self->{'in_hash'}->{'dom'}</b>" : "<b>$self->{'in_hash'}->{'delete'}</b>";
 print '<center>',$self->text('delete_rusure', $hdr),"<p>",
 $self->ui_submit($self->{'text_hash'}->{'delete_confirm'}),"</center>";
 print $self->ui_form_end();
 $self->ui_print_footer('', $self->{'text_hash'}->{'index_return'});
} 
elsif (defined($self->{'in_hash'}->{'members'}))
{
 # members manage
 if ($self->{'access_hash'}->{'virts'})
 {
  # access control
  $ok = $self->check_dom_acl($self->{'in_hash'}->{'dom'});
  $self->error($self->text('virt_manage_ecannot', $self->{'in_hash'}->{'dom'})) unless $ok;
 }
 # print members form
 $hdr = $self->{'in_hash'}->{'dom'} ? "<b>$self->{'in_hash'}->{'members'}</b> from domain <b>$self->{'in_hash'}->{'dom'}</b>" : "<b>$self->{'in_hash'}->{'members'}</b>";
 $self->ui_print_header($self->text('mems_sub', $hdr), $self->{'text_hash'}->{'mems_title'}, "");
 local $list = { 'name' => $self->{'in_hash'}->{'members'},
				  'dom' => $self->{'in_hash'}->{'dom'}
				};
 local @mems = $self->list_members($list);
 if (@mems) 
 {
  # print members list
  print $self->ui_columns_start([ $self->{'text_hash'}->{'mems_email'}, $self->{'text_hash'}->{'mems_type'}, $self->{'text_hash'}->{'index_action'} ], 100);
  foreach my $m (@mems) 
  {
	print $self->ui_columns_row([ $m->{'email'}, $m->{'digest'} eq 'y' ? $self->{'text_hash'}->{'mems_digesty'} : $self->{'text_hash'}->{'mems_digestn'},
			"<a class=menu href='delete_member.cgi?name=$self->{'in_hash'}->{'members'}&dom=$self->{'in_hash'}->{'dom'}&email=$m->{'email'}'>$self->{'text_hash'}->{'delete'}</a>"]);
  }
  print $self->ui_columns_end();
 } 
 else 
 {
  # none members
  print "<b>$self->{'text_hash'}->{'mems_none'}</b><p>";
 }
 # print add member form
 print $self->ui_form_start('add_member.cgi', 'post');
 print $self->ui_hidden('name', $self->{'in_hash'}->{'members'});
 print $self->ui_hidden('dom',$self->{'in_hash'}->{'dom'});
 print $self->ui_table_start($self->{'text_hash'}->{'mems_header'}, 'width=100%', 2);
 print $self->ui_table_row($self->{'text_hash'}->{'mems_email'}, 
 		 $self->ui_textbox('email', undef, 30));
 print $self->ui_table_row($self->{'text_hash'}->{'mems_digest'}, 
 		 $self->ui_radio('digest', 'n', [ [ 'y', $self->{'text_hash'}->{'yes'} ], [ 'n', $self->{'text_hash'}->{'no'} ] ]));
 print $self->ui_table_row($self->{'text_hash'}->{'mems_welcome'}, 
 		 $self->ui_radio('welcome', '', [ [ '', $self->{'text_hash'}->{'mems_default'} ], [ 'y', $self->{'text_hash'}->{'yes'} ], [ 'n', $self->{'text_hash'}->{'no'} ] ]));
 print $self->ui_table_row($self->{'text_hash'}->{'mems_admin'}, 
 		 $self->ui_radio('admin', '', [ [ '', $self->{'text_hash'}->{'mems_default'} ], [ 'y', $self->{'text_hash'}->{'yes'} ], [ 'n', $self->{'text_hash'}->{'no'} ] ]));
 print $self->ui_table_end();
 print $self->ui_form_end([ [ '', $self->{'text_hash'}->{'mems_add'} ] ]); 
 $self->ui_print_footer('', $self->{'text_hash'}->{'index_return'});    
} 
elsif (defined($self->{'in_hash'}->{'password'}))
{
 # reset password
 if ($self->{'access_hash'}->{'virts'})
 {
  # access control
  $ok = $self->check_dom_acl($self->{'in_hash'}->{'dom'});
  $self->error($self->text('virt_manage_ecannot', $self->{'in_hash'}->{'dom'})) unless $ok;
 }
 # reset a mailing lists password to a random
 $hdr = $self->{'in_hash'}->{'dom'} ? "<b>$self->{'in_hash'}->{'password'}</b> from domain <b>$self->{'in_hash'}->{'dom'}</b>" : "<b>$self->{'in_hash'}->{'password'}</b>";
 $self->ui_print_header($self->text('mems_sub', $hdr), $self->{'text_hash'}->{'reset_title'}, "");
 print "$self->{'text_hash'}->{'reset_doing'}<br>";    
 $fullname = $self->{'in_hash'}->{'dom'} ? $self->{'in_hash'}->{'password'}.".$self->{'in_hash'}->{'dom'}" : $self->{'in_hash'}->{'password'};
 local $out = $self->chpass_list($fullname);
 if ($?) 
 {
  # error
  print "<pre>$out</pre>";
  print "$self->{'text_hash'}->{'reset_failed'}<p>";
 } 
 else 
 {
  # done
  print "$self->{'text_hash'}->{'reset_done'}<p>";
  local $email = $self->get_list_owner($fullname);
  print $self->text('reset_email', "<b>$email</b>")."<p>";
 }
 $self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
}
elsif (defined($self->{'in_hash'}->{'edit'}))
{
 # maillist mannully edit
 if ($self->{'access_hash'}->{'virts'})
 {
  # access control
  $ok = $self->check_dom_acl($self->{'in_hash'}->{'dom'});
  $self->error($self->text('virt_manage_ecannot', $self->{'in_hash'}->{'dom'})) unless $ok;
 }
 # edit list
 $fullname = $self->{'in_hash'}->{'dom'} ? $self->{'in_hash'}->{'edit'}.".$self->{'in_hash'}->{'dom'}" : $self->{'in_hash'}->{'edit'};
 local $list_conf = $self->get_list_config($fullname);
  
 # print file form
 $hdr = $self->{'in_hash'}->{'dom'} ? "<b>$self->{'in_hash'}->{'edit'}</b> from domain <b>$self->{'in_hash'}->{'dom'}</b>" : "<b>$self->{'in_hash'}->{'edit'}</b>";
 $self->ui_print_header(undef, $self->text('index_edit', $hdr), undef, undef, undef);
 print $self->ui_form_start('save_list.cgi','form-data');
 print $self->ui_hidden('name', $self->{'in_hash'}->{'edit'});
 print $self->ui_hidden('dom', $self->{'in_hash'}->{'dom'});
 print $self->ui_hidden('file', $list_conf);
 print "<TEXTAREA name=data rows=30 cols=85>";
 open(INFL, $list_conf) || $self->error($self->text('error_open_file', $list_conf));
 while(<INFL>)
 {
  print $self->html_escape($_);
 }
 close(INFL);
 print "</TEXTAREA><BR>\n";
 print $self->ui_submit($self->{'text_hash'}->{'save'});
 print $self->ui_form_end();
 $self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
} 

exit;

1;
		
}


1;

