#!/usr/bin/perl
package majordomo::Backup_config;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'majordomo::Backup_config');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;

&ModuleLoader::preload_module(ref($self), "majordomo::MajordomoLib");
$self = new majordomo::MajordomoLib:: ref($self), %$self; 

1;

1;
		return $self;
}

# backup_config_files()
# Returns files and directories that can be backed up
sub backup_config_files
{
	my $self = shift;

local @rv;

# Add main config file
local $conf = $self->get_config();
push(@rv, $self->{'config_hash'}->{'majordomo_cf'});

# Add all lists
local $list;
foreach $list ($self->list_lists($conf)) {
	local $linfo = $self->get_list($list, $conf);
	push(@rv, $linfo->{'members'});
	push(@rv, $linfo->{'config'});
	push(@rv, $linfo->{'info'});
	push(@rv, $linfo->{'intro'});
	}

# Add aliases file
local $afiles = $self->get_aliases_file();
push(@rv, @$afiles);

return @rv;
}

# pre_backup(&files)
# Called before the files are actually read
sub pre_backup
{
	my $self = shift;

return undef;
}

# post_backup(&files)
# Called after the files are actually read
sub post_backup
{
	my $self = shift;

return undef;
}

# pre_restore(&files)
# Called before the files are restored from a backup
sub pre_restore
{
	my $self = shift;

return undef;
}

# post_restore(&files)
# Called after the files are restored from a backup
sub post_restore
{
	my $self = shift;

return undef;
}


1;

