#!/usr/bin/perl
package majordomo::Log_parser;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'majordomo::Log_parser');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# log_parser.pl
# Functions for parsing this module's logs

&ModuleLoader::preload_module(ref($self), "majordomo::MajordomoLib");
$self = new majordomo::MajordomoLib:: ref($self), %$self; 

1;
		return $self;
}

# parse_webmin_log(user, script, action, type, object, &params)
# Converts logged information from this module into human-readable form
sub parse_webmin_log
{
	my $self = shift;

local ($user, $script, $action, $type, $object, $p) = @_;
$object = $self->html_escape($object);
$p->{'addr'} = $self->html_escape($p->{'addr'});
if ($action eq 'global') {
	return $self->{'text_hash'}->{'log_global'};
	}
elsif ($action eq 'create') {
	return $self->text("log_create_${type}", "<tt>$object</tt>");
	}
elsif ($action eq 'delete') {
	return $self->text("log_delete_${type}", "<tt>$object</tt>");
	}
elsif ($action eq 'subscribe') {
	return $self->text('log_subscribe', "<tt>$object</tt>",
				      "<tt>$p->{'addr'}</tt>");
	}
elsif ($action eq 'unsubscribe') {
	return $self->text('log_unsubscribe', "<tt>$object</tt>",
				        "<tt>$p->{'addr'}</tt>");
	}
elsif ($self->{'text_hash'}->{"log_${action}"}) {
	return $self->text("log_${action}", "<tt>$object</tt>");
	}
else {
	return undef;
	}
}


1;

