#!/usr/bin/perl

&MAIN();

 sub MAIN {
# create_list.cgi
# Create a new mailing list

&ModuleLoader::preload_module('majordomo_class', "majordomo::MajordomoLib");
$self = new majordomo::MajordomoLib:: 'majordomo_class',%$self;

require 'ctime.pl';
%{$self->{'access_hash'}} = $self->get_module_acl();
$self->{'access_hash'}->{'create'} || $self->error($self->{'text_hash'}->{'create_ecannot'});
$self->ReadParse();
$self->{'conf'} = $self->get_config();
$self->{'ldir'} = $self->perl_var_replace($self->find_value("listdir", $self->{'conf'}), $self->{'conf'});
$self->{'program_dir'} = $self->{'config_hash'}->{'smrsh_program_dir'} || $self->{'config_hash'}->{'program_dir'};
$self->{'wrapper_path'} = $self->{'config_hash'}->{'wrapper_path'} || "$self->{'program_dir'}/wrapper";
$self->{'wrapper_program_path'} = $self->{'config_hash'}->{'wrapper_path'} || "$self->{'config_hash'}->{'program_dir'}/wrapper";
$self->error_setup($self->{'text_hash'}->{'create_err'});

# Validate inputs
$self->{'in_hash'}->{'name'} =~ /^\S+$/ ||
	$self->error($self->{'text_hash'}->{'create_ename'});
$self->{'in_hash'}->{'name'} = lc($self->{'in_hash'}->{'name'});
if ($self->get_list($self->{'in_hash'}->{'name'}, $self->{'conf'})) {
	$self->error($self->text('create_eexists', $self->{'in_hash'}->{'name'}));
	}
$self->{'aliases_files'} = $self->get_aliases_file();
@{$self->{'aliases_array'}} = $self->foreign_call($self->{'aliases_module'}, "list_aliases", $self->{'aliases_files'});
foreach $a (@{$self->{'aliases_array'}}) {
	if ($a->{'enabled'} && lc($a->{'name'}) eq lc($self->{'in_hash'}->{'name'})) {
		$self->error($self->text('create_ealias', $self->{'in_hash'}->{'name'}));
		}
	}
$self->{'in_hash'}->{'owner'} =~ /^\S+$/ ||
	$self->error($self->{'text_hash'}->{'create_eowner'});
$self->{'in_hash'}->{'password'} =~ /^\S+$/ ||
	$self->error($self->{'text_hash'}->{'create_epassword'});
$self->{'in_hash'}->{'moderator_def'} || $self->{'in_hash'}->{'moderator'} =~ /^\S+$/ ||
	$self->error($self->{'text_hash'}->{'create_emoderator'});
$self->{'in_hash'}->{'info'} =~ s/\r//g;
$self->{'in_hash'}->{'footer'} =~ s/\r//g;

# Create list members file
$self->lock_file("$self->{'ldir'}/$self->{'in_hash'}->{'name'}");
$self->open_tempfile(MEMS, ">$self->{'ldir'}/$self->{'in_hash'}->{'name'}");
$self->close_tempfile(MEMS);
$self->set_permissions("$self->{'ldir'}/$self->{'in_hash'}->{'name'}");
$self->unlock_file("$self->{'ldir'}/$self->{'in_hash'}->{'name'}");

# Have majordomo create the new config file, by fooling the wrapper
# into thinking it has received an email with a resend command
$self->{'lfile'} = "$self->{'ldir'}/$self->{'in_hash'}->{'name'}.config";
$self->{'cmd'} = "$self->{'wrapper_program_path'} resend -l $self->{'in_hash'}->{'name'} nobody";
open(WRAPPER, "|$self->{'cmd'} nobody >/dev/null 2>&1");
print WRAPPER "config $self->{'in_hash'}->{'name'} $self->{'in_hash'}->{'password'}\n\n";
close(WRAPPER);
$self->additional_log("exec", $self->{'cmd'});
sleep(3);

# create the .info file
$self->lock_file($self->{'lfile'});
$self->{'list'} = $self->get_list_config($self->{'lfile'});
chop($self->{'ctime'} = $self->ctime(time()));
$self->{'updated'} = "[Last updated on: $self->{'ctime'}]\n";
$self->lock_file("$self->{'ldir'}/$self->{'in_hash'}->{'name'}.info");
$self->open_tempfile(INFO, ">$self->{'ldir'}/$self->{'in_hash'}->{'name'}.info");
if ($self->find_value("date_info", $self->{'list'}) eq "yes") {
	$self->print_tempfile(INFO, $self->{'updated'});
	}
$self->print_tempfile(INFO, $self->{'in_hash'}->{'info'});
$self->close_tempfile(INFO);
$self->set_permissions("$self->{'ldir'}/$self->{'in_hash'}->{'name'}.info");
$self->unlock_file("$self->{'ldir'}/$self->{'in_hash'}->{'name'}.info");

# create the archive directory
$self->{'adir'} = $self->perl_var_replace($self->find_value("filedir", $self->{'conf'}), $self->{'conf'});
$self->{'aext'} = $self->perl_var_replace($self->find_value("filedir_suffix", $self->{'conf'}), $self->{'conf'});
if ($self->{'adir'} && $self->{'aext'}) {
	$self->lock_file("$self->{'adir'}/$self->{'in_hash'}->{'name'}$self->{'aext'}");
	mkdir("$self->{'adir'}/$self->{'in_hash'}->{'name'}$self->{'aext'}", 0755);
	$self->set_permissions("$self->{'adir'}/$self->{'in_hash'}->{'name'}$self->{'aext'}");
	$self->unlock_file("$self->{'adir'}/$self->{'in_hash'}->{'name'}$self->{'aext'}");
	$self->{'arch'} = "$self->{'adir'}/$self->{'in_hash'}->{'name'}$self->{'aext'}/archive";
	}
elsif ($self->{'in_hash'}->{'archive'}) {
	$self->lock_file("$self->{'ldir'}/$self->{'in_hash'}->{'name'}.archive");
	mkdir("$self->{'ldir'}/$self->{'in_hash'}->{'name'}.archive", 0755);
	$self->set_permissions("$self->{'ldir'}/$self->{'in_hash'}->{'name'}.archive");
	$self->unlock_file("$self->{'ldir'}/$self->{'in_hash'}->{'name'}.archive");
	$self->{'arch'} = "$self->{'ldir'}/$self->{'in_hash'}->{'name'}.archive/archive";
	}

# Create aliases for the new list
$self->foreign_call($self->{'aliases_module'}, "lock_alias_files", $self->{'aliases_files'});
$self->{'lname'} = $self->{'config_hash'}->{'dynamic'} ? time()+$$ : "$self->{'in_hash'}->{'name'}-list";
if ($self->{'in_hash'}->{'archive'}) {
	&newlist_alias($self->{'in_hash'}->{'name'}, "|$self->{'wrapper_path'} resend ".
				    "-l $self->{'in_hash'}->{'name'} $self->{'lname'}", 0,
				    $self->{'in_hash'}->{'name'}."-archive");
	&newlist_alias($self->{'in_hash'}->{'name'}."-archive", "|$self->{'wrapper_path'} archive2.pl -f $self->{'arch'} -$self->{'in_hash'}->{'archive'} -a");
	}
else {
	&newlist_alias($self->{'in_hash'}->{'name'}, "|$self->{'wrapper_path'} resend ".
				    "-l $self->{'in_hash'}->{'name'} $self->{'lname'}");
	}
&newlist_alias($self->{'lname'}, ":include:$self->{'ldir'}/$self->{'in_hash'}->{'name'}");
&newlist_alias("owner-".$self->{'in_hash'}->{'name'}, $self->{'in_hash'}->{'owner'});
&newlist_alias($self->{'in_hash'}->{'name'}."-owner", $self->{'in_hash'}->{'owner'});
&newlist_alias($self->{'in_hash'}->{'name'}."-approval", $self->{'in_hash'}->{'owner'});
&newlist_alias($self->{'in_hash'}->{'name'}."-request", "|$self->{'wrapper_path'} ".
				       "majordomo -l $self->{'in_hash'}->{'name'}", 1);
$self->foreign_call($self->{'aliases_module'}, "unlock_alias_files", $self->{'aliases_files'});

# Update the new config file
$self->save_list_directive($self->{'list'}, $self->{'lfile'}, "description", $self->{'in_hash'}->{'desc'});
$self->save_list_directive($self->{'list'}, $self->{'lfile'}, "admin_passwd", $self->{'in_hash'}->{'password'});
$self->save_list_directive($self->{'list'}, $self->{'lfile'}, "approve_passwd", $self->{'in_hash'}->{'password'});
$self->save_list_directive($self->{'list'}, $self->{'lfile'}, "message_footer", $self->{'in_hash'}->{'footer'}, 1)
	if ($self->{'in_hash'}->{'footer'});
$self->save_list_directive($self->{'list'}, $self->{'lfile'}, "moderate", $self->{'in_hash'}->{'moderate'});
$self->save_list_directive($self->{'list'}, $self->{'lfile'}, "moderator",
		     $self->{'in_hash'}->{'moderator_def'} ? "" : $self->{'in_hash'}->{'moderator'});
$self->flush_file_lines();
$self->unlock_file($self->{'lfile'});
$self->webmin_log("create", "list", $self->{'in_hash'}->{'name'}, \%{$self->{'in_hash'}});

# add to this user's ACL
if ($self->{'access_hash'}->{'lists'} ne '*') {
	$self->{'access_hash'}->{'lists'} .= " $self->{'in_hash'}->{'name'}";
	$self->save_module_acl(\%{$self->{'access_hash'}});
	}
$self->redirect("edit_list.cgi?name=$self->{'in_hash'}->{'name'}");

1;
		
}

# newlist_alias(name, value, last, othervalue)
sub newlist_alias
{
	shift if ($self == $_[0]);

local @v = ( $_[1] );
push(@v, $_[3]) if ($_[3]);
local $al = { 'name' => $_[0],
	      'values' => \@v,
	      'enabled' => 1 };
$self->foreign_call($self->{'aliases_module'}, "create_alias", $al, $self->{'aliases_files'}, !$_[2]);
}


1;

