#!/usr/bin/perl

&MAIN();

 sub MAIN {
# index.cgi
# Display all mailing lists and majordomo options

&ModuleLoader::preload_module('majordomo_class', "majordomo::MajordomoLib");
$self = new majordomo::MajordomoLib:: 'majordomo_class',%$self;

%{$self->{'access_hash'}} = $self->get_module_acl();

# Check for the majordomo config file
if (!-r $self->{'config_hash'}->{'majordomo_cf'}) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", undef, 1, 1, 0,
		$self->help_search_link("majordomo", "man", "doc", "google"));
	print $self->text('index_econfig', "<tt>$self->{'config_hash'}->{'majordomo_cf'}</tt>",
		 "$self->{'gconfig_hash'}->{'webprefix'}/config.cgi?$self->{'module_name'}"),"<p>\n";
	$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});
	exit;
	}

# Check for the programs dir
if (!-d $self->{'config_hash'}->{'program_dir'}) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", undef, 1, 1, 0,
		$self->help_search_link("majordomo", "man", "doc", "google"));
	print $self->text('index_eprograms', "<tt>$self->{'config_hash'}->{'program_dir'}</tt>",
		  "$self->{'gconfig_hash'}->{'webprefix'}/config.cgi?$self->{'module_name'}"),"<p>\n";
	$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});
	exit;
	}

# Check majordomo version
if (!-r "$self->{'config_hash'}->{'program_dir'}/majordomo_version.pl") {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", undef, 1, 1, 0,
		$self->help_search_link("majordomo", "man", "doc", "google"));
	print $self->text('index_eversion2', "majordomo_version.pl",
			  $self->{'config_hash'}->{'program_dir'},
		 	  "$self->{'gconfig_hash'}->{'webprefix'}/config.cgi?$self->{'module_name'}"),
	      "<p>\n";
	$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});
	exit;
	}
{
    my $pkg = $self->lib_to_pkg("$self->{config_hash}->{program_dir}\/majordomo_version.pl", "majordomo");
    &ModuleLoader::preload_module(ref($self), "$pkg");
    $pkg .= '::';
    eval "\$self = new $pkg ref(\$self),\%\$self;"; 
}
$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", undef, 1, 1, 0,
	$self->help_search_link("majordomo", "man", "doc", "google"),
	undef, undef, $self->text('index_version', $self->{'majordomo_version'}));
if ($self->{'majordomo_version'} < 1.94 || $self->{'majordomo_version'} >= 2) {
	print "$self->{'text_hash'}->{'index_eversion'}<p>\n";
	$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});
	exit;
	}

# Check $self->{'homedir'} in majordomo.cf
$self->{'conf'} = $self->get_config();
if (!$self->homedir_valid($self->{'conf'})) {
	print $self->text('index_ehomedir', "<tt>$self->{'homedir'}</tt>"),"<p>\n";
	$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});
	exit;
	}

# Check $self->{'listdir'} in majordomo.cf
$self->{'listdir'} = $self->perl_var_replace($self->find_value("listdir", $self->{'conf'}), $self->{'conf'});
if (!-d $self->{'listdir'}) {
	print $self->text('index_elistdir', "<tt>$self->{'listdir'}</tt>"),"<p>\n";
	$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});
	exit;
	}

# Check if module needed for aliases is OK
if ($self->{'config_hash'}->{'aliases_file'} eq 'postfix') {
	# Postfix has to be installed
	$self->foreign_installed("postfix", 1) ||
		$self->ui_print_endpage($self->text('index_epostfix', '../postfix/'));
	}
elsif ($self->{'config_hash'}->{'aliases_file'} eq '') {
	# Sendmail has to be installed
	$self->foreign_installed("sendmail", 1) ||
		$self->ui_print_endpage($self->text('index_esendmail2', '','../sendmail/'));
	}
else {
	# Only the sendmail module has to be installed
	$self->foreign_check("sendmail") ||
		$self->ui_print_endpage($self->text('index_esendmail3'));
	}

# Check for the majordomo aliases
$self->{'aliases_files'} = $self->get_aliases_file();
$self->{'email'} = $self->find_value("whoami", $self->{'conf'}); $self->{'email'} =~ s/\@.*$//g;
$self->{'owner'} = $self->find_value("whoami_owner", $self->{'conf'}); $self->{'owner'} =~ s/\@.*$//g;
@{$self->{'aliases_array'}} = $self->foreign_call($self->{'aliases_module'}, "list_aliases", $self->{'aliases_files'});
foreach $a (@{$self->{'aliases_array'}}) {
	if ($a->{'enabled'} && lc($a->{'name'}) eq lc($self->{'email'})) {
		$self->{'majordomo_alias'} = 1;
		}
	if ($a->{'enabled'} && lc($a->{'name'}) eq lc($self->{'owner'})) {
		$self->{'majordomo_owner'} = 1;
		}
	}

# Offer to setup aliases
if (!$self->{'majordomo_alias'}) {
	print "<p>$self->{'text_hash'}->{'index_setupdesc'}\n";
	print "<center><form action=alias_setup.cgi>\n";
	if (!$self->{'majordomo_owner'}) {
		print "<b>$self->{'text_hash'}->{'index_owner'}</b>\n";
		print "<input name=owner size=25>\n";
		print "<input type=hidden name=owner_a value='$self->{'owner'}'>\n";
		}
	print "<input type=hidden name=email_a value='$self->{'email'}'>\n";
	print "<input type=submit value=\"$self->{'text_hash'}->{'index_setup'}\">\n";
	print "</form></center>\n";
	print "<hr>\n";
	}

# Display active lists
@{$self->{'lists_array'}} = $self->list_lists($self->{'conf'});
@{$self->{'lists_array'}} = sort { $a cmp $b } @{$self->{'lists_array'}} if ($self->{'config_hash'}->{'sort_mode'});
map { $self->{'lcan_hash'}->{$_}++ } split(/\s+/, $self->{'access_hash'}->{'lists'});
foreach $l (grep { $self->{'lcan_hash'}->{$_} || $self->{'lcan_hash'}->{"*"} } @{$self->{'lists_array'}}) {
	push(@{$self->{'links_array'}}, "edit_list.cgi?name=$l");
	push(@{$self->{'titles_array'}}, $self->html_escape($l));
	push(@{$self->{'icons_array'}}, "images/list.gif");
	}
if (@{$self->{'links_array'}}) {
	print "<a href='create_form.cgi'>$self->{'text_hash'}->{'index_add'}</a>\n";
	if (@{$self->{'links_array'}}) {
		print "&nbsp;&nbsp;\n";
		print "<a href='digest_form.cgi'>$self->{'text_hash'}->{'index_digest'}</a>\n";
		}
	print "<br>\n";
	$self->icons_table(\@{$self->{'links_array'}}, \@{$self->{'titles_array'}}, \@{$self->{'icons_array'}}, 5);
	}
else {
	print "<b>$self->{'text_hash'}->{'index_none'}</b>.<p>\n";
	}
if ($self->{'access_hash'}->{'create'}) {
	print "<a href='create_form.cgi'>$self->{'text_hash'}->{'index_add'}</a>\n";
	if (@{$self->{'links_array'}}) {
		print "&nbsp;&nbsp;\n";
		print "<a href='digest_form.cgi'>$self->{'text_hash'}->{'index_digest'}</a>\n";
		}
	print "<p>\n";
	}

if ($self->{'access_hash'}->{'global'}) {
	print "<hr>\n";
	print "<table> <tr>\n";
	print "<form action=edit_global.cgi>\n";
	print "<td><input type=submit value='$self->{'text_hash'}->{'index_global'}'></td>\n";
	print "<td>$self->{'text_hash'}->{'index_globaldesc'}</td> </tr> </form>\n";
	print "</table>\n";
	}

$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});

1;
		
}


1;

