#!/usr/bin/perl
package mount::Log_parser;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'mount::Log_parser');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# log_parser.pl
# Functions for parsing this module's logs

&ModuleLoader::preload_module(ref($self), "mount::MountLib");
$self = new mount::MountLib:: ref($self), %$self; 

1;
		return $self;
}

# parse_webmin_log(user, script, action, type, object, &params, [long])
# Converts logged information from this module into human-readable form
sub parse_webmin_log
{
	my $self = shift;

local ($user, $script, $action, $type, $object, $p, $long) = @_;
if ($action eq "swap") {
	return $self->text('log_swap', "<tt>".$self->html_escape($object)."</tt>");
	}
else {
	local $text = $long ? "log_${action}_l" : "log_${action}";
	return $self->text($text, "<tt>".$self->html_escape($p->{'dev'})."</tt>",
			    $self->fstype_name($p->{'type'}),
			    "<tt>".$self->html_escape($p->{'dir'})."</tt>");
	}
}


1;

