#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_mount.cgi
# Display a form for editing or creating a permanent or temporary mounting.

&ModuleLoader::preload_module('mount_class', "mount::MountLib");
$self = new mount::MountLib:: 'mount_class',%$self;

$self->error_setup($self->{'text_hash'}->{'edit_err'});
$self->ReadParse();
if (defined($self->{'in_hash'}->{index})) {
	if ($self->{'in_hash'}->{temp}) {
		# Edit a temporary mount, existing only in the mnttab
		@{$self->{'mlist_array'}} = $self->list_mounted();
		@{$self->{'minfo_array'}} = @{$self->{'mlist_array'}->[$self->{'in_hash'}->{index}]};
		$self->{'mnow'} = 1; $self->{'msave'} = 0;
		}
	else {
		# Edit a permanent mount, which may or may not be currently
		# mounted.
		@{$self->{'mlist_array'}} = $self->list_mounts();
		@{$self->{'minfo_array'}} = @{$self->{'mlist_array'}->[$self->{'in_hash'}->{index}]};
		$self->{'msave'} = 1; $self->{'mnow'} = ($self->get_mounted($self->{'minfo_array'}->[0], $self->{'minfo_array'}->[1]) >= 0);
		}
	if ($self->{'in_hash'}->{index} >= @{$self->{'mlist_array'}}) {
		$self->error($self->{'text_hash'}->{'edit_egone'});
		}
	$self->can_edit_fs(@{$self->{'minfo_array'}}) && !$self->{'access_hash'}->{'only'} ||
		$self->error($self->{'text_hash'}->{'edit_ecannot'});
	$self->{'type'} = $self->{'minfo_array'}->[2];
	$self->ui_print_header(undef, $self->{'text_hash'}->{'edit_title'}, "");
	$self->{'newm'} = 0;
	}
else {
	# creating a new mount (temporary or permanent)
	$self->{'type'} = $self->{'in_hash'}->{type};
	$self->ui_print_header(undef, $self->{'text_hash'}->{'create_title'}, "");
	$self->{'newm'} = 1;
	}
@{$self->{'mmodes_array'}} = $self->mount_modes($self->{'type'});
$self->{'msave'} = ($self->{'mmodes_array'}->[0]==0 ? 0 : $self->{'msave'});
$self->{'mnow'} = ($self->{'mmodes_array'}->[1]==0 ? $self->{'msave'} : $self->{'mnow'});

print "<form action=\"save_mount.cgi\">\n";
print "<input name=return type=hidden value='$self->{'in_hash'}->{'return'}'>\n";
if (!$self->{'newm'}) {
	print "<input type=hidden name=old value=\"$self->{'in_hash'}->{index}\">\n";
	print "<input type=hidden name=temp value=\"$self->{'in_hash'}->{temp}\">\n";

	print "<input type=hidden name=oldmnow value=$self->{'mnow'}>\n";
	print "<input type=hidden name=oldmsave value=$self->{'msave'}>\n";
	}
print "<input type=hidden name=type value=\"$self->{'type'}\">\n";
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>",$self->text('edit_header', $self->fstype_name($self->{'type'})),
      "</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table>\n";

print "<tr> <td>",$self->hlink("<b>$self->{'text_hash'}->{'edit_dir'}</b>", "edit_dir"), "</td>\n";
if ($self->{'type'} eq "swap") {
	print "<td colspan=3><i>$self->{'text_hash'}->{'edit_swap'}</i></b>\n";
	}
else {
	local $dir = $self->{'minfo_array'}->[0] || $self->{'in_hash'}->{'newdir'};
	if (@{$self->{'access_fs_array'}} == 1) {
		# Make relative to first allowed dir
		$dir =~ s/^$self->{'access_fs_array'}->[0]\///;
		}
	print "<td colspan=3><input size=30 name=directory value=\"",
		$dir,"\">\n";
	if ($self->{'access_hash'}->{'browse'}) {
		print $self->file_chooser_button("directory", 1);
		}
	}
if (!$self->{'newm'} && (($self->{'size'},$self->{'free'}) = $self->disk_space($self->{'type'}, $self->{'minfo_array'}->[0]))) {
	print "&nbsp;" x 8;
	printf "<b>$self->{'text_hash'}->{'edit_size'}</b> <i>%s</i> / \n",
		$self->nice_size($self->{'size'}*1024);
	printf "<b>$self->{'text_hash'}->{'edit_free'}</b> <i>%s</i></td>\n",
		$self->nice_size($self->{'free'}*1024);
	}
print "</td> </tr>\n";

# Show save mount options
if ($self->{'mmodes_array'}->[0] != 0 && !$self->{'access_hash'}->{'simple'}) {
	print "<tr> <td><b>$self->{'text_hash'}->{'edit_savemount'}</b></td> <td colspan=3>\n";
	printf "<input type=radio name=msave value=2 %s> $self->{'text_hash'}->{'edit_boot'}\n",
		$self->{'minfo_array'}->[5] eq "yes" || $self->{'newm'} ? "checked" : "";
	if ($self->{'mmodes_array'}->[0] != 1) {
		printf "<input type=radio name=msave value=1 %s> %s\n",
			$self->{'minfo_array'}->[5] eq "no" ? "checked" : "", $self->{'text_hash'}->{'edit_save'};
		}
	if (!$self->{'newm'} && $self->{'mmodes_array'}->[1] == 0) {
		printf "<input type=radio name=msave value=0 %s> %s\n",
			$self->{'minfo_array'}->[5] eq "" && !$self->{'newm'} ? "checked" : "",
			$self->{'text_hash'}->{'edit_delete'};
		}
	else {
		printf "<input type=radio name=msave value=0 %s> %s\n",
			$self->{'minfo_array'}->[5] eq "" && !$self->{'newm'} ? "checked" : "",
			$self->{'text_hash'}->{'edit_dont'};
		}
	print "</td> </tr>\n";
	}

# Show mount now options
if ($self->{'mmodes_array'}->[1] == 1 && ($self->{'mmodes_array'}->[3] == 0 || !$self->{'mnow'}) && !$self->{'access_hash'}->{'simple'}) {
	print "<tr> <td><b>$self->{'text_hash'}->{'edit_now'}</b></td> <td colspan=3>\n";
	printf "<input type=radio name=mmount value=1 %s> %s\n",
		$self->{'mnow'} || $self->{'newm'} ? "checked" : "", $self->{'text_hash'}->{'edit_mount'};
	if ($self->{'mmodes_array'}->[0] == 0) {
		printf "<input type=radio name=mmount value=0 %s> %s\n",
			$self->{'mnow'} || $self->{'newm'} ? "" : "checked", $self->{'text_hash'}->{'edit_delete'};
		}
	else {
		printf "<input type=radio name=mmount value=0 %s> %s\n",
			$self->{'mnow'} || $self->{'newm'} ? "" : "checked",
			$self->{'newm'} ? $self->{'text_hash'}->{'edit_dont2'} : $self->{'text_hash'}->{'edit_unmount'};
		}
	print "</td> </tr>\n";
	}

# Show fsck order options
if ($self->{'mmodes_array'}->[2] && !$self->{'access_hash'}->{'simple'}) {
	print "<tr> <td><b>$self->{'text_hash'}->{'edit_order'}</b></td>\n";
	printf "<td colspan=3><input type=radio name=order value=0 %s> %s\n",
		$self->{'newm'} || $self->{'minfo_array'}->[4] == 0 ? "checked" : "", $self->{'text_hash'}->{'no'};
	printf "<input type=radio name=order value=1 %s> %s\n",
		$self->{'minfo_array'}->[4] == 1 ? "checked" : "", $self->{'text_hash'}->{'edit_first'};
	printf "<input type=radio name=order value=%s %s> %s</td\n",
		$self->{'minfo_array'}->[4] > 1 ? $self->{'minfo_array'}->[4] : 2 , $self->{'minfo_array'}->[4] > 1 ? "checked" : "",
		$self->{'text_hash'}->{'edit_second'};
	print "</tr>\n";
	}

# Show filesystem-specific mount source
$self->generate_location($self->{'type'}, $self->{'minfo_array'}->[1] || $self->{'in_hash'}->{'newdev'});
print "</table></td> </tr></table><p>\n";

if (!$self->{'access_hash'}->{'simple'} || !defined($self->{'access_hash'}->{'opts'}) ||
    $self->{'access_hash'}->{'opts'} =~ /$self->{'type'}/) {
	# generate mount options
	if ($self->{'in_hash'}->{'advanced'}) {
		$self->{'access_hash'}->{'simopts'} = 0;
		print $self->ui_hidden("nosimopts", 1),"\n";
		}
	print "<table border width=100%>\n";
	print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'edit_adv'}</b></td> </tr>\n";
	print "<tr $self->{'cb'}> <td><table width=100%>\n";
	$self->parse_options($self->{'type'}, $self->{'minfo_array'}->[3]);
	$self->generate_options($self->{'type'}, $self->{'newm'});
	if ($self->{'access_hash'}->{'simopts'}) {
		print "<tr> <td colspan=4>",
			$self->ui_submit($self->{'text_hash'}->{'edit_advanced'}, "advanced"),
			"</td> </tr>\n";
		}
	print "</table></td> </tr></table>\n";
	}

if ($self->{'access_hash'}->{'simple'}) {
	# buttons for mounting/unmounting
	print "<table width=100%><tr>\n";
	if ($self->{'newm'}) {
		print "<td><input type=submit ",
		      "value=\"$self->{'text_hash'}->{'edit_create'}\"></td>";
		}
	elsif ($self->{'msave'} && $self->{'mnow'}) {
		print "<td width=33%><input type=submit ",
		      "value=\"$self->{'text_hash'}->{'edit_save_apply'}\"></td>\n";
		if ($self->{'mmodes_array'}->[1]) {
			print "<td align=center width=33%><input type=submit ",
			   "value=\"$self->{'text_hash'}->{'edit_umount'}\" name=umount></td>\n";
			}
		print "<td align=right width=33%><input type=submit ",
		      "value=\"$self->{'text_hash'}->{'edit_del_umount'}\" name=delete></td>\n";
		}
	elsif ($self->{'msave'}) {
		print "<td width=33%><input type=submit ",
		      "value=\"$self->{'text_hash'}->{'save'}\"></td>\n";
		print "<td align=center width=33%><input type=submit ",
		      "value=\"$self->{'text_hash'}->{'edit_mount'}\" name=mount></td>\n";
		print "<td align=right width=33%><input type=submit ",
		      "value=\"$self->{'text_hash'}->{'edit_delete'}\" name=delete></td>\n";
		}
	else {
		print "<td width=33%><input type=submit ",
		      "value=\"$self->{'text_hash'}->{'save'}\"></td>\n";
		if ($self->{'mmodes_array'}->[0]) {
			print "<td align=middle width=33%><input type=submit ",
			      "value=\"$self->{'text_hash'}->{'edit_perm'}\" name=perm></td>\n";
			}
		print "<td align=right width=33%><input type=submit ",
		      "value=\"$self->{'text_hash'}->{'edit_umount'}\" name=umount></td>\n";
		}
	print "</tr></table></form>\n";
	}
else {
	# Save and other buttons
	print "<table width=100%><tr>\n";
	if ($self->{'newm'}) {
		print "<td><input type=submit value=\"$self->{'text_hash'}->{'create'}\"></td>";
		}
	elsif ($self->{'mnow'} && $self->{'minfo_array'}->[2] ne "swap") {
		print "<td><input type=submit value=\"$self->{'text_hash'}->{'save'}\"></td>\n";
		print "</form><form action=../proc/index_search.cgi>\n";
		print "<input type=hidden name=mode value=3>\n";
		print "<input type=hidden name=fs value=$self->{'minfo_array'}->[0]>\n";
		print "<td align=right><input type=submit ",
		      "value=\"$self->{'text_hash'}->{'edit_list'}\"></td>\n";
		}
	else {
		print "<td><input type=submit value=\"$self->{'text_hash'}->{'save'}\"></td>";
		}
	print "</tr></table></form>\n";
	}
$self->ui_print_footer($self->{'in_hash'}->{'return'}, $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

