#!/usr/bin/perl

&MAIN();

 sub MAIN {
# index.cgi
# Display a list of known filesystems, and indicate which are currently mounted

&ModuleLoader::preload_module('mount_class', "mount::MountLib");
$self = new mount::MountLib:: 'mount_class',%$self;

$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", undef, 1, 1, 0,
	$self->help_search_link("mount fstab vfstab", "man"));

# List filesystems from fstab and mtab
@{$self->{'mounted_array'}} = $self->list_mounted();
$self->{'yes'} = $self->{'text_hash'}->{'yes'};
$self->{'no'} = "<font color=#ff0000>$self->{'text_hash'}->{'no'}</a>";
foreach ($self->list_fstypes()) { $self->{'can_edit_hash'}->{$_}++; }
$self->{'i'} = 0;
foreach $m ($self->list_mounts()) {
	$m->[0] = "swap" if ($m->[2] eq "swap");
	$self->{'mounts_hash'}->{$m->[0],$m->[1]} = $self->{'i'}++;
	push(@{$self->{'all_array'}}, $m);
	}
$self->{'i'} = 0;
foreach $m ($self->list_mounted()) {
	$m->[0] = "swap" if ($m->[2] eq "swap");
	$self->{'mounted_hash'}->{$m->[0],$m->[1]} = $self->{'i'}++;
	push(@{$self->{'all_array'}}, $m) if (!defined($self->{'mounts_hash'}->{$m->[0],$m->[1]}));
	}

# Sort by chosen mode
if ($self->{'config_hash'}->{'sort_mode'} == 2) {
	@{$self->{'all_array'}} = sort { lc($a->[0]) cmp lc($b->[0]) } @{$self->{'all_array'}};
	}
elsif ($self->{'config_hash'}->{'sort_mode'} == 1) {
	@{$self->{'all_array'}} = sort { $self->fstype_name($a->[2]) cmp $self->fstype_name($b->[2]) } @{$self->{'all_array'}};
	}

# Build visible filesystems list
foreach $m (@{$self->{'all_array'}}) {
	@{$self->{'minfo_array'}} = @$m;
	$self->{'p'} = &simplify_mount_path($self->{'minfo_array'}->[0], $self->{'minfo_array'}->[2]);
	next if ($self->{'ignore_hash'}->{$self->{'minfo_array'}->[2]});
	@{$self->{'mmodes_array'}} = $self->mount_modes($self->{'minfo_array'}->[2], $self->{'minfo_array'}->[0], $self->{'minfo_array'}->[1]);
	$self->{'canedit'} = $self->{'can_edit_hash'}->{$self->{'minfo_array'}->[2]} && !$self->{'mmodes_array'}->[4] &&
            	   $self->can_edit_fs(@{$self->{'minfo_array'}});
	next if (!$self->{'canedit'} && $self->{'access_hash'}->{'hide'});
	push(@{$self->{'visible_array'}}, $m);
	}

if (@{$self->{'visible_array'}}) {
	# Show table of all visible filesystems
	&show_button();
	print $self->ui_columns_start([ $self->{'text_hash'}->{'index_dir'},
				$self->{'text_hash'}->{'index_type'},
				$self->{'text_hash'}->{'index_dev'},
				$self->{'text_hash'}->{'index_use'},
				$self->{'text_hash'}->{'index_perm'} ], 100);
	foreach $m (@{$self->{'visible_array'}}) {
		@{$self->{'minfo_array'}} = @$m;
		$self->{'p'} = &simplify_mount_path($self->{'minfo_array'}->[0], $self->{'minfo_array'}->[2]);

		$self->{'midx'} = $self->{'mounts_hash'}->{$self->{'minfo_array'}->[0],$self->{'minfo_array'}->[1]};
		$self->{'medidx'} = $self->{'mounted_hash'}->{$self->{'minfo_array'}->[0],$self->{'minfo_array'}->[1]};
		@{$self->{'mmodes_array'}} = $self->mount_modes($self->{'minfo_array'}->[2], $self->{'minfo_array'}->[0], $self->{'minfo_array'}->[1]);
		$self->{'canedit'} = $self->{'can_edit_hash'}->{$self->{'minfo_array'}->[2]} && !$self->{'mmodes_array'}->[4] &&
			   $self->can_edit_fs(@{$self->{'minfo_array'}});
		local @cols;
		if ($self->{'canedit'} && !$self->{'access_hash'}->{'only'}) {
			if (defined($self->{'midx'})) {
				push(@cols, "<a href=\"edit_mount.cgi?".
					    "index=$self->{'midx'}\">$self->{'p'}</a>");
				}
			else {
				push(@cols, "<a href=\"edit_mount.cgi?".
					    "temp=1&index=$self->{'medidx'}\">$self->{'p'}</a>");
				}
			}
		else {
			push(@cols, $self->{'p'});
			}
		local $fsn = $self->fstype_name($self->{'minfo_array'}->[2]);
		$fsn .= " ($self->{'minfo_array'}->[2])" if (uc($fsn) ne uc($self->{'minfo_array'}->[2]));
		push(@cols, $self->{'minfo_array'}->[2] eq "*" ? $self->{'text_hash'}->{'index_auto'} : $fsn);
		push(@cols, $self->device_name($self->{'minfo_array'}->[1]));
		if ($self->can_edit_fs(@{$self->{'minfo_array'}})) {
			push(@cols,
				defined($self->{'medidx'}) ?
				"<a href='unmount.cgi?index=$self->{'medidx'}'>$self->{'yes'}</a>" :
				"<a href='mount.cgi?index=$self->{'midx'}'>$self->{'no'}</a>");
			}
		else {
			push(@cols, defined($self->{'medidx'}) ? $self->{'yes'} : $self->{'no'});
			}
		push(@cols, defined($self->{'midx'}) ? $self->{'yes'} : $self->{'no'});
		print $self->ui_columns_row(\@cols);
		}
	print $self->ui_columns_end(),"<br>\n";
	}
else {
	print "<b>$self->{'text_hash'}->{'index_none'}</b><p>\n";
	}
&show_button();

$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});

1;
		
}

sub simplify_mount_path
{
	shift if ($self == $_[0]);

if ($_[1] eq "swap") {
	return "<i>$self->{'text_hash'}->{'index_swap'}</i>";
	}
elsif (length($_[0]) > 20) {
	return $self->html_escape("... ".substr($_[0], length($_[0])-20));
	}
elsif ($_[0] eq "/") {
	return "/ (<i>$self->{'text_hash'}->{'index_root'}</i>)";
	}
else {
	return $self->html_escape($_[0]);
	}
}

sub show_button
{
	shift if ($self == $_[0]);

return if (!$self->{'access_hash'}->{'create'} || $self->{'access_hash'}->{'only'});
local %donefs;
print "<form action=\"edit_mount.cgi\">\n";
print "<input type=submit value=\"$self->{'text_hash'}->{'index_add'}\"> $self->{'text_hash'}->{'index_type'}:\n";
print "<select name=type>\n";
local $fs;
foreach $fs (sort { $self->fstype_name($a) cmp $self->fstype_name($b) } $self->list_fstypes()) {
	local $nm = $self->fstype_name($fs);
	if (!$donefs{$nm}++ && $self->can_fstype($fs)) {
		print "<option value=\"$fs\">$nm ($fs)\n";
		}
	}
print "</select></form>\n";
}


1;

