#!/usr/bin/perl

&MAIN();

 sub MAIN {
# nfs_server.cgi
# Called in a pop-up javascript window to display a list of known NFS
# servers, generated by broadcasting on the NFS port

&ModuleLoader::preload_module('mount_class', "mount::MountLib");
$self = new mount::MountLib:: 'mount_class',%$self;

use Socket;
$self->popup_header($self->{'text_hash'}->{'nfs_server'});
print <<EOF;
<script>
function choose(f)
{
top.opener.ifield.value = f;
window.close();
}
</script>
EOF

# send NFS null procedure call to broadcast address, and wait for
# 2 seconds for all replies
$self->{'msg'} = pack("NNNNNNNNNN",
	time(),	# xid
	0,	# CALL
	2,	# RPC version 2
	100003,	# nfs program
	2,	# nfs version
	0,	# null procedure
	0, 0,	# no authority
	0, 0,	# no credentials
	);
socket(SOCK, PF_INET, SOCK_DGRAM, getprotobyname("udp"));
setsockopt(SOCK, SOL_SOCKET, SO_BROADCAST, pack("l", 1));
send(SOCK, $self->{'msg'}, 0, pack_sockaddr_in(2049, inet_aton($self->broadcast_addr())));
$self->{'tmstart'} = time();
while(time()-$self->{'tmstart'} < 2) {
	$self->{'rin'} = '';
	vec($self->{'rin'}, fileno(SOCK), 1) = 1;
	if (select($self->{'rout'} = $self->{'rin'}, undef, undef, 1)) {
		$self->{'from'} = recv(SOCK, $self->{'buf'}, 1024, 0);
		($self->{'fromport'}, $fromaddr) = unpack_sockaddr_in($self->{'from'});
		$fromip = inet_ntoa($fromaddr);
		if ($fromip !~ /\.(255|0)$/ && !$self->{'already_hash'}->{$fromip}++) {
			push(@{$self->{'fromip_array'}}, $fromip);
			push(@{$self->{'fromaddr_array'}}, $fromaddr);
			}
		}
	}

if (@{$self->{'fromip_array'}}) {
	print "<b>$self->{'text_hash'}->{'nfs_select'}</b><br>\n";
	print "<table border width=100%>\n";
	print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'nfs_ip'}</b></td> ",
	      "<td><b>$self->{'text_hash'}->{'nfs_host'}</b></td> </tr>\n";
	for($i=0; $i<@{$self->{'fromip_array'}}; $i++) {
		$self->{'fromhost'} = gethostbyaddr($self->{'fromaddr_array'}->[$i], AF_INET);
		printf "<tr $self->{'cb'}> <td><a href=\"\" onClick='choose(\"%s\"); ".
		       "return false'>$self->{'fromip_array'}->[$i]</a></td>\n",
			$self->{'fromhost'} ? $self->{'fromhost'} : $self->{'fromip_array'}->[$i];
		printf "<td>%s</td> </tr>\n",
			$self->{'fromhost'} ? $self->{'fromhost'} : "<br>";
		}
	print "</table>\n";
	}
else {
	print "<b>$self->{'text_hash'}->{'nfs_none'}</b>.<p>\n";
	}

$self->popup_footer();

1;
		
}


1;

