#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_mount.cgi
# Save or create a mount. When saving an existing mount, at lot of different
# things can happen. 

&ModuleLoader::preload_module('mount_class', "mount::MountLib");
$self = new mount::MountLib:: 'mount_class',%$self;

$self->error_setup($self->{'text_hash'}->{'save_err'});
$self->ReadParse();
$| = 1;

if ($self->{'in_hash'}->{'advanced'}) {
	# Return to mount form, but force advanced mount option mode
	if ($self->{'in_hash'}->{'old'} eq '') {
		$self->redirect("edit_mount.cgi?type=$self->{'in_hash'}->{'type'}&advanced=1");
		}
	else {
		$self->redirect("edit_mount.cgi?temp=$self->{'in_hash'}->{'temp'}&index=$self->{'in_hash'}->{'old'}&advanced=1");
		}
	exit;
	}

# check inputs
if ($self->{'in_hash'}->{type} ne "swap") {
	if ($self->{'in_hash'}->{directory} !~ /^\//) {
		if (@{$self->{'access_fs_array'}} && $self->{'in_hash'}->{directory}) {
			# Assume relative to allowed dir
			$self->{'in_hash'}->{directory} = $self->{'access_fs_array'}->[0]."/".$self->{'in_hash'}->{directory};
			}
		else {
			$self->error($self->text('save_edirname', $self->{'in_hash'}->{'directory'}));
			}
		}
	if (-r $self->{'in_hash'}->{'directory'} && !(-d $self->{'in_hash'}->{'directory'})) {
		$self->error($self->text('save_edir', $self->{'in_hash'}->{'directory'}));
		}
	# non-existant directories get created later
	}
else {
	# for swap files, set the directory to 'swap'
	$self->{'in_hash'}->{directory} = "swap";
	}
$self->can_edit_fs($self->{'in_hash'}->{'directory'}, undef, $self->{'in_hash'}->{'type'}, undef, 1) &&
	!$self->{'access_hash'}->{'only'} || $self->error($self->{'text_hash'}->{'edit_ecannot'});
$self->{'access_hash'}->{'create'} || defined($self->{'in_hash'}->{'old'}) || $self->error($self->{'text_hash'}->{'edit_ecannot2'});

# Get user choices
@{$self->{'mmodes_array'}} = $self->mount_modes($self->{'in_hash'}->{type});
$self->{'msave'} = ($self->{'mmodes_array'}->[0]==0 ? 0 : $self->{'in_hash'}->{msave});
$self->{'mnow'} = ($self->{'mmodes_array'}->[1]==0 ? $self->{'msave'} : $self->{'in_hash'}->{mmount});
$self->{'access_hash'}->{'simopts'} = 0 if ($self->{'in_hash'}->{'nosimopts'});

foreach $f ($self->files_to_lock()) {
	$self->lock_file($f);
	}
if (defined($self->{'in_hash'}->{old}) && !$self->{'access_hash'}->{'simple'}) {
	# Saving an existing mount
	if ($self->{'in_hash'}->{temp}) { @{$self->{'mlist_array'}} = $self->list_mounted(); }
	else { @{$self->{'mlist_array'}} = $self->list_mounts(); }
	@{$self->{'mold_array'}} = @{$self->{'mlist_array'}->[$self->{'in_hash'}->{old}]};

	if (!$self->{'mnow'} && !$self->{'in_hash'}->{oldmnow} && !$self->{'msave'}) {
		# Not mounted, so remove from fstab without checking
		$self->{'dev'} = $self->{'mold_array'}->[1];
		}
	else {
		# Changing an existing mount
		$self->{'dev'} = $self->check_location($self->{'in_hash'}->{'type'});
		$self->parse_options($self->{'mold_array'}->[2], $self->{'mold_array'}->[3]);
		$self->{'opts'} = $self->check_options($self->{'in_hash'}->{'type'}, $self->{'dev'}, $self->{'in_hash'}->{'directory'});
		@{$self->{'minfo_array'}} = ($self->{'in_hash'}->{'directory'}, $self->{'dev'}, $self->{'in_hash'}->{'type'}, $self->{'opts'},
			  $self->{'mmodes_array'}->[2] ? $self->{'in_hash'}->{'order'} : "-",
			  $self->{'in_hash'}->{'msave'}==2||$self->{'mmodes_array'}->[0]==1 ? "yes" : "no");
		}

	# Check for change in device
	if ($self->{'mold_array'}->[1] ne $self->{'dev'}) {
		# Device has changed..check it
		if (!$self->multiple_mount($self->{'minfo_array'}->[2]) && $self->get_mounted("*", $self->{'dev'})>=0) {
			$self->error($self->text('save_ealready', $self->{'dev'}));
			}
		if (!$self->multiple_mount($self->{'minfo_array'}->[2]) && $self->get_mount("*", $self->{'dev'}) != -1){
			$self->error($self->text('save_ealready2', $self->{'dev'}));
			}
		$self->{'changed'} = 1;
		}

	# Check for change in directory
	if ($self->{'in_hash'}->{type} ne "swap" && $self->{'mold_array'}->[0] ne $self->{'in_hash'}->{directory}) {
		# Directory has changed.. check it too
		if ($self->get_mounted($self->{'in_hash'}->{directory}, "*")>=0) {
			$self->error($self->text('save_ealready3', $self->{'in_hash'}->{'directory'}));
			}
		if ($self->get_mount($self->{'in_hash'}->{directory}, "*") != -1) {
			$self->error($self->text('save_ealready4', $self->{'in_hash'}->{'directory'}));
			}
		$self->{'changed'} = 1;

		if (!(-d $self->{'in_hash'}->{directory})) {
			# Create the new directory
			$self->lock_file($self->{'in_hash'}->{directory});
			$self->make_dir($self->{'in_hash'}->{directory}, 0755) ||
				$self->error($self->text('save_emkdir',
					     $self->{'in_hash'}->{'directory'}, $!));
			$self->unlock_file($self->{'in_hash'}->{directory});
			$self->{'made_dir'} = 1;
			}
		}

	# Check for change in current mount status
	if ($self->{'in_hash'}->{'oldmnow'} && $self->{'mmodes_array'}->[3] == 1) {
		# Mounted, and cannot be unmounted
		}
	elsif ($self->{'in_hash'}->{'oldmnow'} && !$self->{'mnow'}) {
		# Just been unmounted..
		if ($self->{'error'} = $self->unmount_dir($self->{'mold_array'}->[0], $self->{'mold_array'}->[1], $self->{'in_hash'}->{'type'},
					  $self->{'mold_array'}->[3], $self->{'in_hash'}->{'force'})) {
			if (!$self->{'in_hash'}->{'force'} &&
			    $self->{'error'} =~ /busy|Invalid argument/ &&
			    $self->UNIVERSAL::can('can_force_unmount_dir') &&
			    $self->can_force_unmount_dir(@{$self->{'mold_array'}})) {
				# Mount is busy.. most likely because it is
				# currently in use. Offer the user a choice to
				# forcibly un-mount
				$self->ui_print_header(undef, $self->{'text_hash'}->{'edit_title'}, "");
				print $self->text('save_force', "<tt>$self->{'mold_array'}->[0]</tt>"),
				      "<p>\n";
				print "<form action=save_mount.cgi>\n";
				print "<input type=hidden name=force ",
				      "value=1>\n";
				foreach $k (keys %{$self->{'in_hash'}}) {
					print "<input type=hidden name=$k ",
					      "value=\"$self->{'in_hash'}->{$k}\">\n";
					}
				print "<center>\n";
				print $self->ui_submit($self->{'text_hash'}->{'save_fapply'}),"\n";
				print "</center>\n";
				print "</form>\n";

				$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
				exit;
				}
			else {
				$self->error($self->text('save_eumount', $self->{'error'}));
				}
			}
		@{$self->{'tlog_array'}} = ( "umount", "dir", $self->{'mold_array'}->[0],
			  { 'dir' => $self->{'mold_array'}->[0], 'dev' => $self->{'mold_array'}->[1],
			    'type' => $self->{'mold_array'}->[2], 'opts' => $self->{'mold_array'}->[3] } );
		}
	elsif ($self->{'mnow'} && !$self->{'in_hash'}->{oldmnow}) {
		# Just been mounted..
		if ($self->{'error'} = $self->mount_dir(@{$self->{'minfo_array'}})) {
			$self->error($self->text('save_emount', $self->{'error'}));
			}
		@{$self->{'tlog_array'}} = ( "mount", "dir", $self->{'minfo_array'}->[0], 
			  { 'dir' => $self->{'minfo_array'}->[0], 'dev' => $self->{'minfo_array'}->[1],
			    'type' => $self->{'minfo_array'}->[2], 'opts' => $self->{'minfo_array'}->[3] } );
		}
	elsif (!$self->{'mnow'} && !$self->{'in_hash'}->{oldmnow}) {
		# Not mounted, and doesn't need to be
		}
	elsif ($self->{'mold_array'}->[0] eq $self->{'minfo_array'}->[0] && $self->{'mold_array'}->[1] eq $self->{'minfo_array'}->[1] &&
	       &diff_opts($self->{'mold_array'}->[3], $self->{'minfo_array'}->[3]) && !$self->{'in_hash'}->{'perm_only'} &&
	       $self->UNIVERSAL::can('os_remount_dir')) {
		# Only options have changed .. just call remount
		if ($self->{'error'} = $self->remount_dir(@{$self->{'minfo_array'}})) {
			$self->error($self->text('save_eremount', $self->{'error'}));
			}
		@{$self->{'tlog_array'}} = ( "remount", "dir", $self->{'minfo_array'}->[0], 
			  { 'dir' => $self->{'minfo_array'}->[0], 'dev' => $self->{'minfo_array'}->[1],
			    'type' => $self->{'minfo_array'}->[2], 'opts' => $self->{'minfo_array'}->[3] } );
		}
	elsif (($self->{'mold_array'}->[0] ne $self->{'minfo_array'}->[0] || $self->{'mold_array'}->[1] ne $self->{'minfo_array'}->[1] ||
	       &diff_opts($self->{'mold_array'}->[3], $self->{'minfo_array'}->[3])) && !$self->{'in_hash'}->{'perm_only'}) {
		# Need to unmount/mount to apply new options
		if ($self->{'error'} = $self->unmount_dir($self->{'mold_array'}->[0], $self->{'mold_array'}->[1], $self->{'in_hash'}->{type})) {
			if ($self->{'error'} =~ /busy|Invalid argument/ && $self->{'msave'}) {
				# Mount is busy.. most likely because it is
				# currently in use. Offer the user a choice
				# to update only the fstab file, rather than
				# the real mount
				$self->ui_print_header(undef, $self->{'text_hash'}->{'edit_title'}, "");
				print $self->text('save_perm', "<tt>$self->{'mold_array'}->[0]</tt>"),
				      "<p>\n";
				print "<form action=save_mount.cgi>\n";
				print "<input type=hidden name=perm_only ",
				      "value=1>\n";
				foreach $k (keys %{$self->{'in_hash'}}) {
					print "<input type=hidden name=$k ",
					      "value=\"$self->{'in_hash'}->{$k}\">\n";
					}
				print "<center>\n";
				print $self->ui_submit($self->{'text_hash'}->{'save_apply'}),"\n";
				print "</center>\n";
				print "</form>\n";

				$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
				exit;
				}
			else { $self->error($self->text('save_eremount', $self->{'error'})); }
			}
		if ($self->{'error'} = $self->mount_dir(@{$self->{'minfo_array'}})) {
			$self->error($self->text('save_eremount', $self->{'error'}));
			}
		@{$self->{'tlog_array'}} = ( "remount", "dir", $self->{'minfo_array'}->[0], 
			  { 'dir' => $self->{'minfo_array'}->[0], 'dev' => $self->{'minfo_array'}->[1],
			    'type' => $self->{'minfo_array'}->[2], 'opts' => $self->{'minfo_array'}->[3] } );
		}

	# Check for change in permanence
	if ($self->{'in_hash'}->{oldmsave} && !$self->{'msave'}) {
		# Delete from mount table
		$self->delete_mount($self->{'in_hash'}->{old});
		@{$self->{'plog_array'}} = ( "delete", "dir", $self->{'in_hash'}->{'directory'},
			  { 'dir' => $self->{'mold_array'}->[0], 'dev' => $self->{'mold_array'}->[1],
			    'type' => $self->{'mold_array'}->[2], 'opts' => $self->{'mold_array'}->[3] } );
		}
	elsif ($self->{'msave'} && !$self->{'in_hash'}->{oldmsave}) {
		# Add to mount table
		$self->create_mount(@{$self->{'minfo_array'}});
		@{$self->{'plog_array'}} = ( "create", "dir", $self->{'in_hash'}->{'directory'},
			  { 'dir' => $self->{'minfo_array'}->[0], 'dev' => $self->{'minfo_array'}->[1],
			    'type' => $self->{'minfo_array'}->[2], 'opts' => $self->{'minfo_array'}->[3] } );
		}
	elsif (!$self->{'msave'} && !$self->{'in_hash'}->{oldmsave}) {
		# Not in mount table
		}
	elsif ($self->{'mold_array'}->[0] ne $self->{'minfo_array'}->[0] || $self->{'mold_array'}->[1] ne $self->{'minfo_array'}->[1] ||
	       $self->{'mold_array'}->[5] ne $self->{'minfo_array'}->[5] || &diff_opts($self->{'mold_array'}->[3], $self->{'minfo_array'}->[3])) {
		# Apply any changes in mount options
		$self->change_mount($self->{'in_hash'}->{old}, @{$self->{'minfo_array'}});
		@{$self->{'plog_array'}} = ( "modify", "dir", $self->{'in_hash'}->{'directory'},
			  { 'dir' => $self->{'minfo_array'}->[0], 'dev' => $self->{'minfo_array'}->[1],
			    'type' => $self->{'minfo_array'}->[2], 'opts' => $self->{'minfo_array'}->[3] } );
		}

	# If no longer mounted, remove the dir 
	if ($self->get_mounted(@{$self->{'mold_array'}}) < 0) {
		$self->delete_unmounted(@{$self->{'mold_array'}});
		}
	}
elsif (defined($self->{'in_hash'}->{'old'})) {
	# Doing a simple modification to a mount
	if ($self->{'in_hash'}->{temp}) {
		@{$self->{'mlist_array'}} = $self->list_mounted();
		$self->{'mnow'} = 1;
		}
	else {
		@{$self->{'mlist_array'}} = $self->list_mounts();
		$self->{'msave'} = 1;
		$self->{'now'} = 1 if ($self->{'in_hash'}->{'oldmnow'});
		}
	@{$self->{'mold_array'}} = @{$self->{'mlist_array'}->[$self->{'in_hash'}->{old}]};

	if ($self->{'in_hash'}->{'umount'}) {
		# Just unmount the filesystem
		if ($self->{'error'} = $self->unmount_dir($self->{'mold_array'}->[0], $self->{'mold_array'}->[1], $self->{'in_hash'}->{type})) {
			$self->error($self->text('save_eumount', $self->{'error'}));
			}
		$self->delete_unmounted(@{$self->{'mold_array'}});
		$self->{'mnow'} = 0;
		}
	elsif ($self->{'in_hash'}->{'mount'}) {
		# Just mount the filesystem
		if ($self->{'error'} = $self->mount_dir(@{$self->{'mold_array'}})) {
			$self->error($self->text('save_emount', $self->{'error'}));
			}
		$self->{'mnow'} = 1;
		}
	elsif ($self->{'in_hash'}->{'perm'}) {
		# Add to permanent mount list
		$self->create_mount($self->{'mold_array'}->[0], $self->{'mold_array'}->[1], $self->{'mold_array'}->[2], $self->{'mold_array'}->[3],
			      2, "yes");
		$self->{'msave'} = 1;
		}
	elsif ($self->{'in_hash'}->{'delete'}) {
		if ($self->{'in_hash'}->{'oldmnow'}) {
			# Unmount first
			if ($self->{'error'} = $self->unmount_dir($self->{'mold_array'}->[0], $self->{'mold_array'}->[1],
						  $self->{'in_hash'}->{type})) {
				$self->error($self->text('save_eumount', $self->{'error'}));
				}
			$self->{'mnow'} = 0;
			}
		# Remove from permanent list
		$self->delete_mount($self->{'in_hash'}->{'old'});
		$self->delete_unmounted(@{$self->{'mold_array'}});
		$self->{'msave'} = 0;
		}
	else {
		# Updating the mount in some way ..
		# Check the mount source
		$self->{'dev'} = $self->check_location($self->{'in_hash'}->{'type'});
		$self->parse_options($self->{'mold_array'}->[2], $self->{'mold_array'}->[3]);
		if (defined($self->{'access_hash'}->{'opts'}) &&
		    $self->{'access_hash'}->{'opts'} !~ /$self->{'in_hash'}->{'type'}/) {
			# Just use existing options
			local @opts;
			foreach $k (keys %{$self->{'options_hash'}}) {
				if ($self->{'options_hash'}->{$k} eq '') { push(@opts, $k); }
				else { push(@opts, "$k=$self->{'options_hash'}->{$k}"); }
				}
			$self->{'opts'} = @opts ? join(",", @opts) : "-";
			}
		else {
			# Get options from the user
			$self->{'opts'} = $self->check_options($self->{'in_hash'}->{'type'}, $self->{'dev'},
					       $self->{'in_hash'}->{'directory'});
			}
		@{$self->{'minfo_array'}} = ($self->{'in_hash'}->{'directory'}, $self->{'dev'}, $self->{'in_hash'}->{'type'}, $self->{'opts'}, 2, 'yes');

		# Check for change in device
		if ($self->{'mold_array'}->[1] ne $self->{'dev'}) {
			# Device has changed..check it
			if (!$self->multiple_mount($self->{'minfo_array'}->[2]) &&
			    $self->get_mounted("*", $self->{'dev'})>=0) {
				$self->error($self->text('save_ealready', $self->{'dev'}));
				}
			if (!$self->multiple_mount($self->{'minfo_array'}->[2]) &&
			    $self->get_mount("*", $self->{'dev'}) != -1){
				$self->error($self->text('save_ealready2', $self->{'dev'}));
				}
			$self->{'changed'} = 1;
			}

		# Check for change in directory
		if ($self->{'in_hash'}->{type} ne "swap" && $self->{'mold_array'}->[0] ne $self->{'in_hash'}->{directory}) {
			# Directory has changed.. check it too
			if ($self->get_mounted($self->{'in_hash'}->{directory}, "*")>=0) {
				$self->error($self->text('save_ealready3',
					     $self->{'in_hash'}->{'directory'}));
				}
			if ($self->get_mount($self->{'in_hash'}->{directory}, "*") != -1) {
				$self->error($self->text('save_ealready4',
					     $self->{'in_hash'}->{'directory'}));
				}
			$self->{'changed'} = 1;

			if (!(-d $self->{'in_hash'}->{directory})) {
				# Create the new directory
				$self->lock_file($self->{'in_hash'}->{directory});
				$self->make_dir($self->{'in_hash'}->{directory}, 0755) ||
					$self->error($self->text('save_emkdir',
						     $self->{'in_hash'}->{'directory'}, $!));
				$self->unlock_file($self->{'in_hash'}->{directory});
				$self->{'made_dir'} = 1;
				}
			}

		if ($self->{'in_hash'}->{'oldmnow'} && ($self->{'mold_array'}->[0] ne $self->{'minfo_array'}->[0] ||
		    $self->{'mold_array'}->[1] ne $self->{'minfo_array'}->[1] || &diff_opts($self->{'mold_array'}->[3], $self->{'minfo_array'}->[3]))) {
			# Need to unmount/mount to apply new options
			if ($self->{'error'}=$self->unmount_dir($self->{'mold_array'}->[0], $self->{'mold_array'}->[1], $self->{'in_hash'}->{type})){
				$self->error($self->text('save_eremount', $self->{'error'}));
				}
			if ($self->{'error'} = $self->mount_dir(@{$self->{'minfo_array'}})) {
				$self->error($self->text('save_eremount', $self->{'error'}));
				}
			}

		if ($self->{'in_hash'}->{'oldmsave'}) {
			# Change entry in fstab
			$self->change_mount($self->{'in_hash'}->{'old'}, @{$self->{'minfo_array'}});
			}
		}
	}
elsif ($self->{'access_hash'}->{'simple'}) {
	# Create and mounting from the simple interface
	$self->{'dev'} = $self->check_location($self->{'in_hash'}->{type});
	if (!defined($self->{'access_hash'}->{'opts'}) || $self->{'access_hash'}->{'opts'} =~ /$self->{'in_hash'}->{'type'}/) {
		$self->{'opts'} = $self->check_options($self->{'in_hash'}->{'type'}, $self->{'dev'}, $self->{'in_hash'}->{'directory'});
		}
	else {
		$self->{'opts'} = "-";
		}
	@{$self->{'minfo_array'}} = ($self->{'in_hash'}->{directory}, $self->{'dev'}, $self->{'in_hash'}->{type}, $self->{'opts'}, 2, 'yes');

	# Check if the device is in use
	if (!$self->multiple_mount($self->{'minfo_array'}->[2]) && $self->get_mounted("*", $self->{'dev'})>=0) {
		$self->error($self->text('save_ealready', $self->{'dev'}));
		}
	if (!$self->multiple_mount($self->{'minfo_array'}->[2]) && $self->get_mount("*", $self->{'dev'}) != -1) {
		$self->error($self->text('save_ealready2', $self->{'dev'}));
		}

	# Check if the directory is in use
	if ($self->{'in_hash'}->{type} ne "swap") {
		if ($self->get_mounted($self->{'in_hash'}->{directory}, "*")>=0) {
			$self->error($self->text('save_ealready2', $self->{'in_hash'}->{'directory'}));
			}
		if ($self->get_mount($self->{'in_hash'}->{directory}, "*") != -1) {
			$self->error($self->text('save_ealready3', $self->{'in_hash'}->{'directory'}));
			}
		}

	# Create the directory
	if ($self->{'in_hash'}->{type} ne "swap" && !(-d $self->{'in_hash'}->{directory})) {
		$self->lock_file($self->{'in_hash'}->{directory});
		$self->make_dir($self->{'in_hash'}->{directory}, 0755) ||
		  $self->error($self->text('save_emkdir', $self->{'in_hash'}->{'directory'}, $!));
		$self->unlock_file($self->{'in_hash'}->{directory});
		$self->{'made_dir'} = 1;
		}

	# Mount and save
	if ($self->{'error'} = $self->mount_dir($self->{'minfo_array'}->[0], $self->{'minfo_array'}->[1],
				$self->{'minfo_array'}->[2], $self->{'minfo_array'}->[3])) {
		if ($self->{'made_dir'}) { rmdir($self->{'in_hash'}->{directory}); }
		$self->error($self->text('save_emount', $self->{'error'}));
		}
	$self->{'mnow'} = 1;
	if ($self->{'mmodes_array'}->[0]) {
		$self->create_mount(@{$self->{'minfo_array'}});
		$self->{'msave'} = 1;
		}
	}
else {
	# Creating a new mount, complex interface
	$self->{'dev'} = $self->check_location($self->{'in_hash'}->{type});
	$self->parse_options($self->{'minfo_array'}->[3]);
	$self->{'opts'} = $self->check_options($self->{'in_hash'}->{type}, $self->{'dev'}, $self->{'in_hash'}->{'directory'});
	@{$self->{'minfo_array'}} = ($self->{'in_hash'}->{directory}, $self->{'dev'}, $self->{'in_hash'}->{type}, $self->{'opts'},
		  $self->{'mmodes_array'}->[2] ? $self->{'in_hash'}->{order} : "-",
		  $self->{'in_hash'}->{msave}==2||$self->{'mmodes_array'}->[0]==1 ? "yes" : "no");

	# Check if anything is being done
	if (!$self->{'msave'} && !$self->{'mnow'}) {
		$self->error($self->{'text_hash'}->{'save_enone'});
		}

	# Check if the device is in use
	if (!$self->multiple_mount($self->{'minfo_array'}->[2]) && $self->get_mounted("*", $self->{'dev'})>=0) {
		$self->error($self->text('save_ealready', $self->{'dev'}));
		}
	if (!$self->multiple_mount($self->{'minfo_array'}->[2]) && $self->get_mount("*", $self->{'dev'}) != -1) {
		$self->error($self->text('save_ealready2', $self->{'dev'}));
		}

	# Check if the directory is in use
	if ($self->{'in_hash'}->{type} ne "swap") {
		if ($self->get_mounted($self->{'in_hash'}->{directory}, "*")>=0) {
			$self->error($self->text('save_ealready2', $self->{'in_hash'}->{'directory'}));
			}
		if ($self->get_mount($self->{'in_hash'}->{directory}, "*") != -1) {
			$self->error($self->text('save_ealready3', $self->{'in_hash'}->{'directory'}));
			}
		}

	# Create the directory
	if ($self->{'in_hash'}->{type} ne "swap" && !(-d $self->{'in_hash'}->{directory})) {
		$self->lock_file($self->{'in_hash'}->{directory});
		$self->make_dir($self->{'in_hash'}->{directory}, 0755) ||
		  $self->error($self->text('save_emkdir', $self->{'in_hash'}->{'directory'}, $!));
		$self->unlock_file($self->{'in_hash'}->{directory});
		$self->{'made_dir'} = 1;
		}

	# If mounting now, attempt to do it
	if ($self->{'mnow'}) {
		# If the mount fails, give up totally
		if ($self->{'error'} = $self->mount_dir($self->{'minfo_array'}->[0], $self->{'minfo_array'}->[1],
					$self->{'minfo_array'}->[2], $self->{'minfo_array'}->[3])) {
			if ($self->{'made_dir'}) { rmdir($self->{'in_hash'}->{directory}); }
			$self->error($self->text('save_emount', $self->{'error'}));
			}
		@{$self->{'tlog_array'}} = ( "mount", "dir", $self->{'in_hash'}->{'directory'},
			  { 'dir' => $self->{'minfo_array'}->[0], 'dev' => $self->{'minfo_array'}->[1],
			    'type' => $self->{'minfo_array'}->[2], 'opts' => $self->{'minfo_array'}->[3] } );
		}

	# If saving, save now
	if ($self->{'msave'}) {
		$self->create_mount(@{$self->{'minfo_array'}});
		@{$self->{'plog_array'}} = ( "create", "dir", $self->{'in_hash'}->{'directory'},
			  { 'dir' => $self->{'minfo_array'}->[0], 'dev' => $self->{'minfo_array'}->[1],
			    'type' => $self->{'minfo_array'}->[2], 'opts' => $self->{'minfo_array'}->[3] } );
		}
	}
foreach $f ($self->files_to_lock()) {
	$self->unlock_file($f);
	}
$self->webmin_log(@{$self->{'plog_array'}}) if (@{$self->{'plog_array'}});
%{$self->{'tpmap_hash'}} = ( 'create', 'mount',  'delete', 'umount',  'modify', 'remount' );
if (@{$self->{'tlog_array'}} && $self->{'tpmap_hash'}->{$self->{'plog_array'}->[0]} ne $self->{'tlog_array'}->[0]) {
	$self->webmin_log(@{$self->{'tlog_array'}});
	}

# Mark this mount and owned by this current user
$self->{'users'} = $self->get_filesystem_users();
if ($self->{'msave'} || $self->{'mnow'}) {
	$self->{'users'}->{$self->{'in_hash'}->{'directory'}} ||= $remote_user;
	}
else {
	delete($self->{'users'}->{$self->{'in_hash'}->{'directory'}});
	}
$self->save_filesystem_users($self->{'users'});

$self->redirect($self->{'in_hash'}->{'return'});

1;
		
}

# undo_changes
# Put back any changes to the fstab file
sub undo_changes
{
	shift if ($self == $_[0]);

if ($self->{'in_hash'}->{temp} && $self->{'in_hash'}->{mboot}) {
	# a mount was made permanent.. undo by deleting it
	$self->delete_mount($self->{'idx'});
	}
elsif (!$self->{'in_hash'}->{temp} && !$self->{'in_hash'}->{mboot}) {
	# a permanent mount was made temporary.. undo by making it permanent
	$self->create_mount(@{$self->{'mold_array'}});
	}
elsif ($self->{'in_hash'}->{mboot}) {
	# some mount options were changed.. undo by changing back
	$self->change_mount($self->{'in_hash'}->{old}, @{$self->{'mold_array'}});
	}
if ($self->{'made_dir'}) {
	# A directory for mounting was created.. delete it
	rmdir($self->{'in_hash'}->{directory});
	}
}

# diff_opts(string1, string2)
sub diff_opts
{
	shift if ($self == $_[0]);

local $o1 = join(",", sort { $a cmp $b } split(/,/, $_[0]));
local $o2 = join(",", sort { $a cmp $b } split(/,/, $_[1]));
return $o1 ne $o2;
}


1;

