#!/usr/bin/perl
package mysql::Log_parser;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'mysql::Log_parser');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# log_parser.pl
# Functions for parsing this module's logs

&ModuleLoader::preload_module(ref($self), "mysql::MysqlLib");
$self = new mysql::MysqlLib:: ref($self), %$self; 

1;
		return $self;
}

# parse_webmin_log(user, script, action, type, object, &params)
# Converts logged information from this module into human-readable form
sub parse_webmin_log
{
	my $self = shift;

local ($user, $script, $action, $type, $object, $p, $long) = @_;
if ($action eq 'stop') {
	return $self->{'text_hash'}->{'log_stop'};
	}
elsif ($action eq 'start') {
	return $self->{'text_hash'}->{'log_start'};
	}
elsif ($action eq 'cnf') {
	return $self->{'text_hash'}->{'log_cnf'};
	}
elsif ($action eq 'kill') {
	return $self->text('log_kill', $object);
	}
elsif ($action eq 'vars') {
	return $self->text('log_vars', $object);
	}
elsif ($type eq 'db') {
	return $self->text("log_${type}_${action}", "<tt>$object</tt>");
	}
elsif ($type eq 'dbs' || $type eq 'users' || $type eq 'hosts' ||
       $type eq 'cprivs' || $type eq 'tprivs' || $type eq 'dbprivs') {
	return $self->text("log_${type}_${action}", $object);
	}
elsif ($type eq 'table' || $type eq 'index' || $type eq 'view') {
	return $self->text("log_${type}_${action}", "<tt>$object</tt>",
		     "<tt>$p->{'db'}</tt>");
	}
elsif ($type eq 'tables') {
	return $self->text("log_${type}_${action}", $object,
		     "<tt>$p->{'db'}</tt>");
	}
elsif ($type eq 'field') {
	$p->{'size'} =~ s/\s+$//;
	return $self->text("log_${type}_${action}", "<tt>$object</tt>",
		     "<tt>$p->{'table'}</tt>", "<tt>$p->{'db'}</tt>",
		     "<tt>$p->{'type'}$p->{'size'}</tt>");
	}
elsif ($type eq 'fields') {
	return $self->text("log_${type}_${action}", $object,
		     "<tt>$p->{'table'}</tt>", "<tt>$p->{'db'}</tt>");
	}
elsif ($type eq 'data') {
	return $self->text("log_${type}_${action}", "<tt>$object</tt>",
		     "<tt>$p->{'table'}</tt>", "<tt>$p->{'db'}</tt>");
	}
elsif ($action eq 'exec') {
	return $self->text($long ? 'log_exec_l' : 'log_exec', "<tt>$object</tt>",
		     "<tt>".$self->html_escape($p->{'cmd'})."</tt>");
	}
elsif ($type eq 'user' || $type eq 'perm' || $type eq 'host' ||
       $type eq 'tpriv' || $type eq 'cpriv') {
	$p->{'user'} = $self->{'text_hash'}->{'log_anon'}
		if ($p->{'user'} eq '-' || $p->{'user'} eq '%');
	$p->{'db'} = $self->{'text_hash'}->{'log_any'}
		if ($p->{'db'} eq '-' || $p->{'db'} eq '%');
	$p->{'host'} = $self->{'text_hash'}->{'log_any'}
		if ($p->{'host'} eq '-' || $p->{'host'} eq '%');
	local $t = "log_${type}_${action}";
	if ($long && $self->{'text_hash'}->{$t.'_l'}) { $t .= '_l'; }
	return $self->text($t, "<tt>$p->{'user'}</tt>",
		     "<tt>$p->{'host'}</tt>", "<tt>$p->{'db'}</tt>",
		     "<tt>$p->{'table'}</tt>", "<tt>$p->{'field'}</tt>");
	}
elsif ($action eq 'backup') {
	return $self->text($object ? ($long ? 'log_backup_l' : 'log_backup')
			     : ($long ? 'log_backup_all_l' : 'log_backup_all'),
		     "<tt>$object</tt>",
		     "<tt>".$self->html_escape($p->{'file'})."</tt>");
	}
elsif ($action eq 'execfile') {
	return $self->text($p->{'mode'} ? 'log_execupload' : 'log_execfile',
		     "<tt>".$self->html_escape($p->{'file'})."</tt>");
	}
elsif ($action eq 'import') {
	return $self->text($p->{'mode'} ? 'log_importupload' : 'log_importfile',
		     "<tt>".$self->html_escape($p->{'file'})."</tt>");
	}
else {
	return undef;
	}
}


1;

