#!/usr/bin/perl
package mysql::Syslog_logs;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'mysql::Syslog_logs');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# Contains a function to supply the syslog module with extra logs

&ModuleLoader::preload_module(ref($self), "mysql::MysqlLib");
$self = new mysql::MysqlLib:: ref($self), %$self; 

1;
		return $self;
}

# syslog_getlogs()
# Returns a list of structures containing extra log files known to this module
sub syslog_getlogs
{
	my $self = shift;

local $conf = $self->get_mysql_config();
local ($sect) = grep { $_->{'name'} eq 'mysqld_safe' ||
		       $_->{'name'} eq 'safe_mysqld' } @$conf;
local @rv;
if ($sect) {
	local $log = $self->find_value("err-log", $sect->{'members'});
	if ($log) {
		push(@rv, { 'file' => $log,
			    'desc' => $self->{'text_hash'}->{'syslog_desc'},
			    'active' => 1,
			  } );
		}
	local $log = $self->find_value("log", $sect->{'members'});
	if ($log) {
		push(@rv, { 'file' => $log,
			    'desc' => $self->{'text_hash'}->{'syslog_logdesc'},
			    'active' => 1,
			  } );
		}
	}
return @rv;
}


1;

