#!/usr/bin/perl
package mysql::Useradmin_update;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'mysql::Useradmin_update');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;

$self->{'use_global_login'} = 1;		# Always login as master user, not the mysql
				# login of the current Webmin user
&ModuleLoader::preload_module(ref($self), "mysql::MysqlLib");
$self = new mysql::MysqlLib:: ref($self), %$self; 

1;

1;
		return $self;
}

# useradmin_create_user(&details)
# Create a new mysql user if syncing is enabled
sub useradmin_create_user
{
	my $self = shift;

if ($self->{'config_hash'}->{'sync_create'}) {
	local %privs;
	map { $privs{$_}++ } split(/\s+/, $self->{'config_hash'}->{'sync_privs'});
	for($i=3; $i<=$self->user_priv_cols()+3-1; $i++) {
		push(@{$self->{'yesno_array'}}, $privs{$i} ? "'Y'" : "'N'");
		}
	@{$self->{'desc_array'}} = $self->table_structure($self->{'master_db'}, 'user');
	local $sql = sprintf "insert into user (%s) values ('%s', '%s', %s, %s)",
		join(",", map { $self->{'desc_array'}->[$_]->{'field'} } (0 .. $self->user_priv_cols()+3-1)),
		$self->{'config_hash'}->{'sync_host'},
		$_[0]->{'user'},
		$_[0]->{'passmode'} == 3 ? "$self->{'password_func'}('$_[0]->{'plainpass'}')" :
		$_[0]->{'passmode'} == 0 ? "''" : "'*'",
		join(",", @{$self->{'yesno_array'}});
	$self->execute_sql_logged($self->{'master_db'}, $sql);
	$self->execute_sql_logged($self->{'master_db'}, 'flush privileges');
	}
}

# useradmin_delete_user(&details)
# Delete a mysql user
sub useradmin_delete_user
{
	my $self = shift;

if ($self->{'config_hash'}->{'sync_delete'}) {
	$self->execute_sql_logged($self->{'master_db'},
		    "delete from user where user = '$_[0]->{'user'}'");
	$self->execute_sql_logged($self->{'master_db'},
		    "delete from db where user = '$_[0]->{'user'}'");
	$self->execute_sql_logged($self->{'master_db'},
		    "delete from tables_priv where user = '$_[0]->{'user'}'");
	$self->execute_sql_logged($self->{'master_db'},
		    "delete from columns_priv where user = '$_[0]->{'user'}'");
	$self->execute_sql_logged($self->{'master_db'}, 'flush privileges');
	}
}

# useradmin_modify_user(&details)
# Update a mysql user
sub useradmin_modify_user
{
	my $self = shift;

if ($self->{'config_hash'}->{'sync_modify'}) {
	local $sql;
	if ($_[0]->{'passmode'} == 4) {
		# Not changing password
		$sql = sprintf "update user set user = '%s' where user = '%s'", $_[0]->{'user'}, $_[0]->{'olduser'};
		}
	elsif ($_[0]->{'passmode'} == 3) {
		# Setting new password
		$sql = sprintf "update user set user = '%s', password = $self->{'password_func'}('%s') where user = '%s'", $_[0]->{'user'}, $_[0]->{'plainpass'}, $_[0]->{'olduser'};
		}
	elsif ($_[0]->{'passmode'} == 0) {
		# No password
		$sql = sprintf "update user set user = '%s', password = '' where user = '%s'", $_[0]->{'user'}, $_[0]->{'olduser'};
		}
	else {
		# Assume locked
		$sql = sprintf "update user set user = '%s', password = '*' where user = '%s'", $_[0]->{'user'}, $_[0]->{'olduser'};
		}
	$self->execute_sql_logged($self->{'master_db'}, $sql);
	if ($_[0]->{'user'} ne $_[0]->{'olduser'}) {
		$self->execute_sql_logged($self->{'master_db'},
			"update db set user = '$_[0]->{'user'}' ".
			"where user = '$_[0]->{'olduser'}'");
		$self->execute_sql_logged($self->{'master_db'},
			"update tables_priv set user = '$_[0]->{'user'}' ".
			"where user = '$_[0]->{'olduser'}'");
		$self->execute_sql_logged($self->{'master_db'},
			"update columns_priv set user = '$_[0]->{'user'}' ".
			"where user = '$_[0]->{'olduser'}'");
		}
	$self->execute_sql_logged($self->{'master_db'}, 'flush privileges');
	}
}


1;

