#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Export the CSV

&ModuleLoader::preload_module('mysql_class', "mysql::MysqlLib");
$self = new mysql::MysqlLib:: 'mysql_class',%$self;

$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'csv_err'});
$self->can_edit_db($self->{'in_hash'}->{'db'}) || $self->error($self->{'text_hash'}->{'dbase_ecannot'});
$self->{'access_hash'}->{'edonly'} && $self->error($self->{'text_hash'}->{'dbase_ecannot'});

# Validate inputs
if ($self->{'in_hash'}->{'dest'}) {
	$self->{'in_hash'}->{'file'} =~ /^([a-z]:)?\/\S/ || $self->error($self->{'text_hash'}->{'csv_efile'});
	$self->{'access_hash'}->{'buser'} || $self->error($self->{'text_hash'}->{'cvs_ebuser'});
	}
if (!$self->{'in_hash'}->{'where_def'}) {
	$self->{'in_hash'}->{'where'} =~ /\S/ || $self->error($self->{'text_hash'}->{'csv_ewhere'});
	}

# Execute the SQL
@{$self->{'cols_array'}} = split(/\0/, $self->{'in_hash'}->{'cols'});
@{$self->{'cols_array'}} || $self->error($self->{'text_hash'}->{'csv_ecols'});
$self->{'cmd'} = "select ".join(",", @{$self->{'cols_array'}})." from ".$self->quotestr($self->{'in_hash'}->{'table'});
if (!$self->{'in_hash'}->{'where_def'}) {
	$self->{'cmd'} .= " where ".$self->{'in_hash'}->{'where'};
	}
$self->{'rv'} = $self->execute_sql($self->{'in_hash'}->{'db'}, $self->{'cmd'});

# Open the destination
if (!$self->{'in_hash'}->{'dest'}) {
	print "Content-type: text/plain\n\n";
	$self->{'fh'} = STDOUT;
	}
elsif ($self->{'access_hash'}->{'buser'} eq 'root') {
	# Open target file directly
	$self->open_tempfile(OUT, ">$self->{'in_hash'}->{'file'}");
	$self->{'fh'} = OUT;
	}
else {
	# Run through cat command
	$self->{'cmd'} = $self->command_as_user($self->{'access_hash'}->{'buser'}, 0,
				"cat >".$self->quote_path($self->{'in_hash'}->{'file'}));
	$self->open_execute_command(*OUT, $self->{'cmd'}, 0);
	$self->{'fh'} = OUT;
	}

# Send the data
if ($self->{'in_hash'}->{'headers'}) {
	unshift(@{$self->{'rv'}->{'data'}}, $self->{'rv'}->{'titles'});
	}
foreach $r (@{$self->{'rv'}->{'data'}}) {
	if ($self->{'in_hash'}->{'format'} == 0) {
	        local $tmp_mas = join(",", map { "\"".&quote_csv($_, "\"\n")."\"" } @$r);
		{ my $t=$self->{'fh'}; print $t $tmp_mas;}
		}
	elsif ($self->{'in_hash'}->{'format'} == 1) {
		local $tmp_mas = join(",", map { &quote_csv($_, ",\n") } @$r);
		{ my $t=$self->{'fh'}; print $t $tmp_mas;}
		}
	elsif ($self->{'in_hash'}->{'format'} == 2) {
	        local $tmp_mas = join("\t", map { &quote_csv($_, "\t\n") } @$r);
		{ my $t=$self->{'fh'}; print $t $tmp_mas;}
		}
	local $st = "\n";
	{ my $t=$self->{'fh'}; print $t $st;}
	}

# All done .. tell the user
if ($self->{'in_hash'}->{'dest'}) {
	$self->close_tempfile(OUT);
	$self->{'desc'} = $self->text('table_header', "<tt>$self->{'in_hash'}->{'table'}</tt>", "<tt>$self->{'in_hash'}->{'db'}</tt>");
	$self->ui_print_header($self->{'desc'}, $self->{'text_hash'}->{'csv_title'}, "", "csv");

	@{$self->{'st_array'}} = stat($self->{'in_hash'}->{'file'});
	print $self->text('csv_done', "<tt>$self->{'in_hash'}->{'file'}</tt>",
				$self->nice_size($self->{'st_array'}->[7])),"<p>\n";

	$self->ui_print_footer("edit_dbase.cgi?db=$self->{'in_hash'}->{'db'}", $self->{'text_hash'}->{'dbase_return'},
		"", $self->{'text_hash'}->{'index_return'});
	}

1;
		
}

sub quote_csv
{
	shift if ($self == $_[0]);

local ($str, $q) = @_;
$str =~ s/\r//g;
foreach my $c (split(//, $q)) {
	local $qc = $c eq "\"" ? "\\\"" :
		    $c eq "\n" ? "\\n" :
		    $c eq "," ? "\\," :
		    $c eq "\t" ? "\\t" : $c;
	$str =~ s/\Q$c\E/$qc/g;
	}
return $str;
}


1;

