#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Show mysql server configuration options

&ModuleLoader::preload_module('mysql_class', "mysql::MysqlLib");
$self = new mysql::MysqlLib:: 'mysql_class',%$self;

$self->{'access_hash'}->{'perms'} == 1 || $self->error($self->{'text_hash'}->{'cnf_ecannot'});
$self->ui_print_header(undef, $self->{'text_hash'}->{'cnf_title'}, "", "cnf");

# Make sure config exists
$self->{'conf'} = $self->get_mysql_config();
if (!$self->{'conf'}) {
	print $self->text('cnf_efile', "<tt>$self->{'config_hash'}->{'my_cnf'}</tt>",
		    "../config.cgi?$self->{'module_name'}"),"<p>\n";
	$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
	exit;
	}
($self->{'mysqld'}) = grep { $_->{'name'} eq 'mysqld' } @{$self->{'conf'}};
$self->{'mysqld'} || $self->error($self->{'text_hash'}->{'cnf_emysqld'});
$self->{'mems'} = $self->{'mysqld'}->{'members'};

print $self->ui_form_start("save_cnf.cgi", "post");
print $self->ui_table_start($self->{'text_hash'}->{'cnf_header'}, "width=100%", 4);

# Show mysqld section options
$self->{'port'} = $self->find_value("port", $self->{'mems'});
print $self->ui_table_row($self->{'text_hash'}->{'cnf_port'},
		    $self->ui_opt_textbox("port", $self->{'port'}, 5, $self->{'text_hash'}->{'default'}));

$self->{'bind'} = $self->find_value("bind-address", $self->{'mems'});
print $self->ui_table_row($self->{'text_hash'}->{'cnf_bind'},
		    $self->ui_opt_textbox("bind", $self->{'bind'}, 20, $self->{'text_hash'}->{'cnf_all'}));

print $self->ui_table_row($self->{'text_hash'}->{'cnf_skip-locking'},
    $self->ui_yesno_radio("skip-locking", $self->find("skip-locking", $self->{'mems'}) ? 1 : 0));

print $self->ui_table_row($self->{'text_hash'}->{'cnf_big-tables'},
    $self->ui_yesno_radio("big-tables", $self->find("big-tables", $self->{'mems'}) ? 1 : 0));

$self->{'socket'} = $self->find_value("socket", $self->{'mems'});
print $self->ui_table_row($self->{'text_hash'}->{'cnf_socket'},
		    $self->ui_opt_textbox("socket", $self->{'socket'}, 50, $self->{'text_hash'}->{'default'}).
		    " ".$self->file_chooser_button("socket"), 3);

$self->{'datadir'} = $self->find_value("datadir", $self->{'mems'});
print $self->ui_table_row($self->{'text_hash'}->{'cnf_datadir'},
		    $self->ui_opt_textbox("datadir", $self->{'datadir'}, 50, $self->{'text_hash'}->{'default'}).
		    " ".$self->file_chooser_button("datadir"), 3);

# Show set variables
print $self->ui_table_hr();

%{$self->{'vars_hash'}} = $self->parse_set_variables($self->find_value("set-variable", $self->{'mems'}));
foreach $v (@{$self->{'mysql_set_variables_array'}}) {
	print $self->ui_table_row($self->{'text_hash'}->{'cnf_'.$v},
		$self->ui_radio($v."_def", defined($self->{'vars_hash'}->{$v}) ? 0 : 1,
			  [ [ 1, $self->{'text_hash'}->{'default'} ], [ 0, " " ] ])."\n".
		$self->mysql_size_input($v, $self->{'vars_hash'}->{$v}), 3);
	}
foreach $v (@{$self->{'mysql_number_variables_array'}}) {
	print $self->ui_table_row($self->{'text_hash'}->{'cnf_'.$v},
		$self->ui_radio($v."_def", defined($self->{'vars_hash'}->{$v}) ? 0 : 1,
			  [ [ 1, $self->{'text_hash'}->{'default'} ], [ 0, " " ] ])."\n".
		$self->ui_textbox($v, $self->{'vars_hash'}->{$v}, 8), 3);
	}

print $self->ui_table_end();
print $self->ui_form_end([ [ "save", $self->{'text_hash'}->{'save'} ] ]);

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

