#!/usr/bin/perl

&MAIN();

 sub MAIN {
# index.cgi
# Display all existing databases

&ModuleLoader::preload_module('mysql_class', "mysql::MysqlLib");
$self = new mysql::MysqlLib:: 'mysql_class',%$self;

$self->ReadParse();
$self->read_acl(\%{$self->{'hash1_hash'}}, \%{$self->{'hash2_hash'}});

# Check for MySQL programs
foreach $p ( [ $self->{'config_hash'}->{'mysqladmin'}, 'index_eadmin', 'index_mysqladmin' ],
	     [ $self->{'config_hash'}->{'mysql'}, 'index_esql', 'index_mysql' ],
	     [ $self->{'config_hash'}->{'mysqlshow'}, 'index_eshow', 'index_mysqlshow' ]) {
	if (!-x $p->[0]) {
		$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", "intro", 1, 1, 0,
			$self->help_search_link("mysql", "man", "doc", "google"));
		print $self->text($p->[1], "<tt>$p->[0]</tt>",
			  "$self->{'gconfig_hash'}->{'webprefix'}/config.cgi?$self->{'module_name'}"),"<p>\n";

		$self->foreign_require("software", "software-lib.pl");
		$self->{'lnk'} = $main::software_object->missing_install_link(
				"mysql", $self->{'text_hash'}->{$p->[2]},
				"../$self->{'module_name'}/", $self->{'text_hash'}->{'index_title'});
		print $self->{'lnk'},"<p>\n" if ($self->{'lnk'});

		$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});
		exit;
		}
	}

# Try to get the MySQL version
$self->{'mysql_version'} = $self->get_mysql_version(\$self->{'out'});
if ($self->{'mysql_version'} < 0) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", "intro", 1, 1, 0,
		$self->help_search_link("mysql", "man", "doc", "google"));
	print $self->text('index_elibrary', "<tt>$self->{'config_hash'}->{'mysql'}</tt>",
		  "$self->{'gconfig_hash'}->{'webprefix'}/config.cgi?$self->{'module_name'}"),"<p>\n";
	print $self->text('index_mysqlver', "$self->{'config_hash'}->{'mysql'} -V"),"\n";
	print "<pre>$self->{'out'}</pre>\n";
	$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});
	exit;
	}
elsif (!$self->{'mysql_version'}) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", "intro", 1, 1, 0,
		$self->help_search_link("mysql", "man", "doc", "google"));
	print $self->text('index_ever', "<tt>$self->{'config_hash'}->{'mysql'}</tt>",
		  "$self->{'gconfig_hash'}->{'webprefix'}/config.cgi?$self->{'module_name'}"),"<p>\n";
	print $self->text('index_mysqlver', "$self->{'config_hash'}->{'mysql'} -V"),"\n";
	print "<pre>$self->{'out'}</pre>\n";
	$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});
	exit;
	}
open(VERSION, ">$self->{'module_config_directory'}/version");
print VERSION $self->{'mysql_version'},"\n";
close(VERSION);

($self->{'r'}, $self->{'rout'}) = $self->is_mysql_running();
if ($self->{'r'} == 0) {
	# Not running .. need to start it
	&main_header();
	print "<p> <b>$self->{'text_hash'}->{'index_notrun'}</b> <p>\n";

	if ($self->{'access_hash'}->{'stop'} && $self->is_mysql_local()) {
		print "<hr>\n";
		print "<form action=start.cgi>\n";
		print "<table width=100%><tr><td>\n";
		print "<input type=submit ",
		      "value=\"$self->{'text_hash'}->{'index_start'}\"></td>\n";
		print "<td>",$self->text('index_startmsg',
		      "<tt>$self->{'config_hash'}->{'start_cmd'}</tt>"),"</td> </tr></table>\n";
		print "</form>\n";
		}
	}
elsif ($self->{'r'} == -1 && $self->{'access_hash'}->{'user'} && 0) {
	# Running, but the user's password is wrong
	&main_header();
	print "<b>",$self->text('index_nouser', "<tt>$self->{'access_hash'}->{'user'}</tt>"),
	      "</b><p>\n";
	print $self->text('index_emsg', "<tt>$self->{'rout'}</tt>"),"<p>\n";
	}
elsif ($self->{'r'} == -1) {
	# Running, but webmin doesn't know the root (or user's) password!
	&main_header();
	print "<b>$self->{'text_hash'}->{'index_nopass'}</b> <p>\n";
	print "<form action=login.cgi method=post>\n";
	print "<center><table border>\n";
	print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'index_ltitle'}</b></td> </tr>\n";
	print "<tr $self->{'cb'}> <td><table cellpadding=2>\n";
	print "<tr> <td><b>$self->{'text_hash'}->{'index_login'}</b></td>\n";
	printf "<td><input name=login size=20 value='%s'></td> </tr>\n",
		$self->{'access_hash'}->{'user'} || $self->{'config_hash'}->{'login'};
	print "<tr> <td><b>$self->{'text_hash'}->{'index_pass'}</b></td>\n";
	print "<td><input name=pass size=20 type=password></td>\n";
	print "</tr> </table></td></tr></table>\n";
	print "<input type=submit value='$self->{'text_hash'}->{'save'}'>\n";
	print "<input type=reset value='$self->{'text_hash'}->{'index_clear'}'>\n";
	print "</center></form>\n";
	print $self->text('index_emsg', "<tt>$self->{'rout'}</tt>"),"<p>\n";
	}
else {
	# Check if we can re-direct to a single DB's page
	@{$self->{'alldbs_array'}} = $self->list_databases();
	@{$self->{'titles_array'}} = grep { $self->can_edit_db($_) } @{$self->{'alldbs_array'}};
	$can_all = (@{$self->{'alldbs_array'}} == @{$self->{'titles_array'}});
	if (@{$self->{'titles_array'}} == 1 && $self->{'access_hash'}->{'dbs'} ne '*' && !$self->{'access_hash'}->{'perms'} &&
	    !$self->{'access_hash'}->{'stop'} && !$self->{'access_hash'}->{'create'} && $self->{'access_hash'}->{'noconfig'}) {
		# Only one DB, so go direct to it!
		$self->redirect("edit_dbase.cgi?db=$self->{'titles_array'}->[0]");
		exit;
		}

	&main_header();
	print $self->ui_subheading($self->{'text_hash'}->{'index_dbs'});
	if ($self->{'in_hash'}->{'search'}) {
		# Limit to those matching search
		@{$self->{'titles_array'}} = grep { /\Q$self->{'in_hash'}->{'search'}\E/i } @{$self->{'titles_array'}};
		print "<table width=100%><tr>\n";
		print "<td> <b>",$self->text('index_showing',
			"<tt>$self->{'in_hash'}->{'search'}</tt>"),"</b></td>\n";
		print "<td align=right><a href='index.cgi'>",
			"$self->{'text_hash'}->{'view_searchreset'}</a></td>\n";
		print "</tr></table>\n";
		}
	elsif ($self->{'in_hash'}->{'show'}) {
		# Limit to specific databases
		@{$self->{'titles_array'}} = split(/\0/, $self->{'in_hash'}->{'show'});
		}

	# DB is running .. list databases
	@{$self->{'icons_array'}} = map { "images/db.gif" } @{$self->{'titles_array'}};
	@{$self->{'links_array'}} = map { "edit_dbase.cgi?db=$_" } @{$self->{'titles_array'}};
	$self->{'can_create'} = $self->{'access_hash'}->{'create'} == 1 ||
		      $self->{'access_hash'}->{'create'} == 2 && @{$self->{'titles_array'}} < $self->{'access_hash'}->{'max'};

	@{$self->{'rowlinks_array'}} = ( );
	push(@{$self->{'rowlinks_array'}}, "<a href=newdb_form.cgi>$self->{'text_hash'}->{'index_add'}</a>")
		if ($self->{'can_create'});
	if (!@{$self->{'icons_array'}}) {
		# No databases .. tell user
		if (@{$self->{'alldbs_array'}}) {
			print "<b>$self->{'text_hash'}->{'index_nodbs'}</b> <p>\n";
			}
		else {
			print "<b>$self->{'text_hash'}->{'index_nodbs2'}</b> <p>\n";
			}
		}
	elsif (@{$self->{'icons_array'}} > $self->{'max_dbs'} && !$self->{'in_hash'}->{'search'} && !$self->{'in_hash'}->{'show'}) {
		# Too many databases to show .. display search and jump forms
		print $self->ui_form_start("index.cgi");
		print $self->{'text_hash'}->{'index_toomany'},"\n";
		print $self->ui_textbox("search", undef, 20),"\n";
		print $self->ui_submit($self->{'text_hash'}->{'index_search'}),"<br>\n";
		print $self->ui_form_end();

		print $self->ui_form_start("edit_dbase.cgi");
		print $self->{'text_hash'}->{'index_jump'},"\n";
		print $self->ui_select("db", undef, [ map { [ $_ ] } @{$self->{'titles_array'}} ]),"\n";
		print $self->ui_submit($self->{'text_hash'}->{'index_jumpok'}),"<br>\n";
		print $self->ui_form_end();
		}
	else {
		# Show table of databases
		if ($self->{'access_hash'}->{'delete'}) {
			print $self->ui_form_start("drop_dbases.cgi");
			unshift(@{$self->{'rowlinks_array'}}, $self->select_all_link("d", 0),
				           $self->select_invert_link("d", 0));
			}
		print $self->ui_links_row(\@{$self->{'rowlinks_array'}});
		if ($self->{'access_hash'}->{'dbs'} eq '*' && $self->{'access_hash'}->{'perms'} &&
		    $self->{'access_hash'}->{'stop'} && $self->{'access_hash'}->{'create'} && !$self->{'access_hash'}->{'noconfig'}){
			@{$self->{'checks_array'}} = @{$self->{'titles_array'}};
			}
		else {undef(@{$self->{'checks_array'}});}
		if ($self->{'config_hash'}->{'style'}) {
			@{$self->{'tables_array'}} = map { @{$self->{'t_array'}} = $self->list_tables($_); scalar(@{$self->{'t_array'}}) }
				      @{$self->{'titles_array'}};
			@{$self->{'titles_array'}} = map { $self->html_escape($_) } @{$self->{'titles_array'}};
			$self->split_table([ "", $self->{'text_hash'}->{'index_db'},
				       $self->{'text_hash'}->{'index_tables'} ],
				     \@{$self->{'checks_array'}}, \@{$self->{'links_array'}}, \@{$self->{'titles_array'}}, \@{$self->{'tables_array'}})
				if (@{$self->{'titles_array'}});
			}
		else {
			@{$self->{'checks_array'}} = map { $self->ui_checkbox("d", $_) } @{$self->{'checks_array'}};
			@{$self->{'titles_array'}} = map { $self->html_escape($_) } @{$self->{'titles_array'}};
			$self->icons_table(\@{$self->{'links_array'}}, \@{$self->{'titles_array'}}, \@{$self->{'icons_array'}}, 5,
				     undef, undef, undef, \@{$self->{'checks_array'}});
			}
		}
	print $self->ui_links_row(\@{$self->{'rowlinks_array'}});
	if (@{$self->{'icons_array'}} && $self->{'access_hash'}->{'delete'} && @{$self->{'icons_array'}} <= $self->{'max_dbs'}) {
		print $self->ui_form_end([ [ "delete", $self->{'text_hash'}->{'index_drops'} ] ]);
		}

	if ($self->{'access_hash'}->{'perms'}) {
		# Show icons for editing user permissions and server settings
		print "<hr>\n";
		print $self->ui_subheading($self->{'text_hash'}->{'index_global'});
		$self->{'canvars'} = $self->supports_variables();
		@{$self->{'links_array'}} = ( 'list_users.cgi', 'list_dbs.cgi', 'list_hosts.cgi',
			   'list_tprivs.cgi', 'list_cprivs.cgi',
			   'edit_cnf.cgi', 'list_procs.cgi',
			   $self->{'canvars'} ? ( 'list_vars.cgi' ) : ( ),
			 );
		@{$self->{'titles_array'}} = ( $self->{'text_hash'}->{'users_title'}, $self->{'text_hash'}->{'dbs_title'},
			    $self->{'text_hash'}->{'hosts_title'}, $self->{'text_hash'}->{'tprivs_title'},
			    $self->{'text_hash'}->{'cprivs_title'},$self->{'text_hash'}->{'cnf_title'},
			    $self->{'text_hash'}->{'procs_title'},
			    $self->{'canvars'} ? ( $self->{'text_hash'}->{'vars_title'} ) : ( ),
			  );
		@{$self->{'images_array'}} = ( 'images/users.gif', 'images/dbs.gif',
			    'images/hosts.gif', 'images/tprivs.gif',
			    'images/cprivs.gif', 'images/cnf.gif',
			    'images/procs.gif',
			    $self->{'canvars'} ? ( 'images/vars.gif' ) : ( ),
			  );
		if ($self->{'access_hash'}->{'perms'} == 2) {
			# Remove local.cnf and database connections icons
			@{$self->{'links_array'}} = @{$self->{'links_array'}}[0..4];
			@{$self->{'titles_array'}} = @{$self->{'titles_array'}}[0..4];
			@{$self->{'images_array'}} = @{$self->{'images_array'}}[0..4];
			}
		$self->icons_table(\@{$self->{'links_array'}}, \@{$self->{'titles_array'}}, \@{$self->{'images_array'}}, 5);
		}

	if ($self->{'access_hash'}->{'stop'} && $self->is_mysql_local() ||
	    $can_all && !$self->{'access_hash'}->{'edonly'} && $self->{'access_hash'}->{'buser'}) {
		print "<hr>\n";
		print $self->ui_buttons_start();
		$self->{'started_buttons_row'} = 1;
		}

	# Show stop button
	if ($self->{'access_hash'}->{'stop'} && $self->is_mysql_local()) {
		print $self->ui_buttons_row("stop.cgi", $self->{'text_hash'}->{'index_stop'},
				      $self->{'text_hash'}->{'index_stopmsg'});
		}

	# Show backup all button
	if ($can_all && !$self->{'access_hash'}->{'edonly'} && $self->{'access_hash'}->{'buser'}) {
		print $self->ui_buttons_row("backup_form.cgi", $self->{'text_hash'}->{'index_backup'},
				      $self->{'text_hash'}->{'index_backupmsg'},
				      $self->ui_hidden("all", 1));
		}

	print $self->ui_buttons_end() if ($self->{'started_buttons_row'});

	# Check if the optional perl modules are installed
	if ( !$self->{'gconfig_hash'}->{'ztl_mode'} && $self->{'hash1_hash'}->{$self->{'remote_user'}, 'useradmin'})	{
		if ($self->foreign_available("cpan")) {
			eval "use DBI";
			push(@{$self->{'needs_array'}}, "DBI") if ($@);
			$self->{'nodbi'}++ if ($@);
			eval "use DBD::mysql";
			push(@{$self->{'needs_array'}}, "DBD::mysql") if ($@);
			if (@{$self->{'needs_array'}}) {
				$self->{'needs'} = $self->urlize(join(" ", @{$self->{'needs_array'}}));
				print "<center><b>",$self->text(@{$self->{'needs_array'}} == 2 ? 'index_nomods' : 'index_nomod', @{$self->{'needs_array'}},
					"/cpan/download.cgi?source=3&cpan=$self->{'needs'}&mode=2&return=/$self->{'module_name'}/&returndesc=".$self->urlize($self->{'text_hash'}->{'index_return'})),
					"</b></center>\n";
				}
			}
		}
	}
$self->ui_print_footer("$self->{'text_hash'}->{'index_mainpage_url'}", $self->{'text_hash'}->{'index_mainpage'});

1;
		
}

sub main_header
{
	shift if ($self == $_[0]);

$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", "intro", 1, 1, 0,
	$self->help_search_link("mysql", "man", "doc", "google"),
	undef, undef, $self->text('index_version', $self->{'mysql_version'}));
}


1;

