#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Save mysql server configuration options

&ModuleLoader::preload_module('mysql_class', "mysql::MysqlLib");
$self = new mysql::MysqlLib:: 'mysql_class',%$self;

$self->{'access_hash'}->{'perms'} == 1 || $self->error($self->{'text_hash'}->{'cnf_ecannot'});
$self->error_setup($self->{'text_hash'}->{'cnf_err'});
$self->ReadParse();

# Get the mysqld section
$self->lock_file($self->{'config_hash'}->{'my_cnf'});
$self->{'conf'} = $self->get_mysql_config();
($self->{'mysqld'}) = grep { $_->{'name'} eq 'mysqld' } @{$self->{'conf'}};
$self->{'mysqld'} || $self->error($self->{'text_hash'}->{'cnf_emysqld'});

# Parse mysql server inputs
if ($self->{'in_hash'}->{'port_def'}) {
	$self->save_directive($self->{'conf'}, $self->{'mysqld'}, "port", [ ]);
	}
else {
	$self->{'in_hash'}->{'port'} =~ /^\d+$/ && $self->{'in_hash'}->{'port'} > 0 && $self->{'in_hash'}->{'port'} < 65536 ||
		$self->error($self->{'text_hash'}->{'cnf_eport'});
	$self->save_directive($self->{'conf'}, $self->{'mysqld'}, "port", [ $self->{'in_hash'}->{'port'} ]);
	}

if ($self->{'in_hash'}->{'bind_def'}) {
	$self->save_directive($self->{'conf'}, $self->{'mysqld'}, "bind-address", [ ]);
	}
else {
	$self->check_ipaddress($self->{'in_hash'}->{'bind'}) ||
		$self->error($self->{'text_hash'}->{'cnf_ebind'});
	$self->save_directive($self->{'conf'}, $self->{'mysqld'}, "bind-address", [ $self->{'in_hash'}->{'bind'} ]);
	}

if ($self->{'in_hash'}->{'socket_def'}) {
	$self->save_directive($self->{'conf'}, $self->{'mysqld'}, "socket", [ ]);
	}
else {
	$self->{'in_hash'}->{'socket'} =~ /^\/\S+$/ ||
		$self->error($self->{'text_hash'}->{'cnf_esocket'});
	$self->save_directive($self->{'conf'}, $self->{'mysqld'}, "socket", [ $self->{'in_hash'}->{'socket'} ]);
	}

if ($self->{'in_hash'}->{'datadir_def'}) {
	$self->save_directive($self->{'conf'}, $self->{'mysqld'}, "datadir", [ ]);
	}
else {
	-d $self->{'in_hash'}->{'datadir'} || $self->error($self->{'text_hash'}->{'cnf_edatadir'});
	$self->save_directive($self->{'conf'}, $self->{'mysqld'}, "datadir", [ $self->{'in_hash'}->{'datadir'} ]);
	}

$self->save_directive($self->{'conf'}, $self->{'mysqld'}, "skip-locking",
		$self->{'in_hash'}->{'skip-locking'} ? [ "" ] : [ ]);

$self->save_directive($self->{'conf'}, $self->{'mysqld'}, "big-tables",
		$self->{'in_hash'}->{'big-tables'} ? [ "" ] : [ ]);

# Save set variables
%{$self->{'vars_hash'}} = $self->parse_set_variables($self->find_value("set-variable", $self->{'mems'}));
foreach $w (@{$self->{'mysql_set_variables_array'}}, @{$self->{'mysql_number_variables_array'}}) {
	if ($self->{'in_hash'}->{$w."_def"}) {
		delete($self->{'vars_hash'}->{$w});
		}
	else {
		$self->{'in_hash'}->{$w} =~ /^\d+$/ || $self->error($self->{'text_hash'}->{"cnf_e".$w});
		$self->{'vars_hash'}->{$w} = $self->{'in_hash'}->{$w}.$self->{'in_hash'}->{$w."_units"};
		}
	}
@{$self->{'sets_array'}} = ( );
foreach $v (keys %{$self->{'vars_hash'}}) {
	push(@{$self->{'sets_array'}}, $v."=".$self->{'vars_hash'}->{$v});
	}
$self->save_directive($self->{'conf'}, $self->{'mysqld'}, "set-variable", \@{$self->{'sets_array'}});

# Write out file
$self->flush_file_lines();
$self->unlock_file($self->{'config_hash'}->{'my_cnf'});
$self->webmin_log("cnf");
$self->redirect("");

1;
		
}


1;

