#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_db.cgi
# Save, create or delete a db table record

&ModuleLoader::preload_module('mysql_class', "mysql::MysqlLib");
$self = new mysql::MysqlLib:: 'mysql_class',%$self;

$self->ReadParse();
$self->{'access_hash'}->{'perms'} || $self->error($self->{'text_hash'}->{'perms_ecannot'});

if ($self->{'in_hash'}->{'delete'}) {
	# Delete some database
	$self->{'access_hash'}->{'perms'} == 1 || $self->can_edit_db($self->{'in_hash'}->{'olddb'}) ||
		$self->error($self->{'text_hash'}->{'perms_edb'});
	$self->execute_sql_logged($self->{'master_db'},
		"delete from db where user = '$self->{'in_hash'}->{'olduser'}' ".
		"and host = '$self->{'in_hash'}->{'oldhost'}' and db = '$self->{'in_hash'}->{'olddb'}'");
	}
else {
	# Validate inputs
	$self->error_setup($self->{'text_hash'}->{'db_err'});
	$self->{'in_hash'}->{'user_def'} || $self->{'in_hash'}->{'user'} =~ /^\S+$/ ||
		$self->error($self->{'text_hash'}->{'db_euser'});
	$self->{'in_hash'}->{'host'} < 2 || $self->{'in_hash'}->{'host'} =~ /^\S+$/ ||
		$self->error($self->{'text_hash'}->{'db_ehost'});
	if ($self->{'access_hash'}->{'perms'} == 2 && $self->{'access_hash'}->{'dbs'} ne '*') {
		$self->{'db'} = $self->{'in_hash'}->{'dbs'};
		}
	else {
		$self->{'db'} = $self->{'in_hash'}->{'db_def'} == 1 ? "" :
		      $self->{'in_hash'}->{'db_def'} == 2 ? $self->{'in_hash'}->{'dbs'} : $self->{'in_hash'}->{'db'};
		$self->{'db'} =~ /^\S*$/ || $self->error($self->{'text_hash'}->{'db_edb'});
		}
	if ($self->{'access_hash'}->{'perms'} == 2) {
		$self->{'in_hash'}->{'new'} || $self->can_edit_db($self->{'in_hash'}->{'olddb'}) ||
			$self->error($self->{'text_hash'}->{'perms_edb'});
		$self->can_edit_db($self->{'db'}) || $self->error($self->{'text_hash'}->{'perms_edb'});
		}

	map { $self->{'perms_array'}->[$_]++ } split(/\0/, $self->{'in_hash'}->{'perms'});
	@{$self->{'desc_array'}} = $self->table_structure($self->{'master_db'}, 'db');
	if ($self->{'in_hash'}->{'new'}) {
		# Create a new db
		for($i=3; $i<=$self->db_priv_cols()+3-1; $i++) {
			push(@{$self->{'yesno_array'}}, $self->{'perms_array'}->[$i] ? "'Y'" : "'N'");
			}
		$self->{'sql'} = sprintf "insert into db (%s) values ('%s', '%s', '%s', %s)",
			join(",", map { $self->{'desc_array'}->[$_]->{'field'} } (0 .. $self->db_priv_cols()+3-1)),
			$self->{'in_hash'}->{'host_mode'} == 0 ? '' :
			$self->{'in_hash'}->{'host_mode'} == 1 ? '%' : $self->{'in_hash'}->{'host'},
			$self->{'db'}, $self->{'in_hash'}->{'user_def'} ? '' : $self->{'in_hash'}->{'user'},
			join(",", @{$self->{'yesno_array'}});
		}
	else {
		# Update existing user
		for($i=3; $i<=$self->db_priv_cols()+3-1; $i++) {
			push(@{$self->{'yesno_array'}}, $self->{'desc_array'}->[$i]->{'field'}."=".
				     ($self->{'perms_array'}->[$i] ? "'Y'" : "'N'"));
			}
		$self->{'sql'} = sprintf "update db set user = '%s', host = '%s', ".
			       "db = '%s', %s where user = '%s' and ".
			       "host = '%s' and db = '%s'",
			$self->{'in_hash'}->{'user_def'} ? '' : $self->{'in_hash'}->{'user'},
			$self->{'in_hash'}->{'host_mode'} == 0 ? '' :
			$self->{'in_hash'}->{'host_mode'} == 1 ? '%' : $self->{'in_hash'}->{'host'},
			$self->{'db'}, join(" , ", @{$self->{'yesno_array'}}),
			$self->{'in_hash'}->{'olduser'}, $self->{'in_hash'}->{'oldhost'}, $self->{'in_hash'}->{'olddb'};
		}
	$self->execute_sql_logged($self->{'master_db'}, $self->{'sql'});
	}
$self->execute_sql_logged($self->{'master_db'}, 'flush privileges');
if ($self->{'in_hash'}->{'delete'}) {
	$self->webmin_log("delete", "perm", $self->{'in_hash'}->{'olddb'},
		    { 'db' => $self->{'in_hash'}->{'olddb'},
		      'host' => $self->{'in_hash'}->{'oldhost'},
		      'user' => $self->{'in_hash'}->{'olduser'} } );
	}
elsif ($self->{'in_hash'}->{'new'}) {
	$self->webmin_log("create", "perm", $self->{'in_hash'}->{'db_def'} ? '' : $self->{'in_hash'}->{'db'},
		    { 'db' => $self->{'db'},
		      'host' => $self->{'in_hash'}->{'host_mode'}<2 ? '' : $self->{'in_hash'}->{'host'},
		      'user' => $self->{'in_hash'}->{'user_def'} ? '' : $self->{'in_hash'}->{'user'} } );
	}
else {
	$self->webmin_log("modify", "perm", $self->{'in_hash'}->{'db_def'} ? '' : $self->{'in_hash'}->{'db'},
		    { 'db' => $self->{'db'},
		      'host' => $self->{'in_hash'}->{'host_mode'}<2 ? '' : $self->{'in_hash'}->{'host'},
		      'user' => $self->{'in_hash'}->{'user_def'} ? '' : $self->{'in_hash'}->{'user'} } );
	}
$self->redirect("list_dbs.cgi");

1;
		
}


1;

