#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_field.cgi
# Create, modify or delete a field

&ModuleLoader::preload_module('mysql_class', "mysql::MysqlLib");
$self = new mysql::MysqlLib:: 'mysql_class',%$self;

$self->ReadParse();
$self->can_edit_db($self->{'in_hash'}->{'db'}) || $self->error($self->{'text_hash'}->{'dbase_ecannot'});
$self->{'access_hash'}->{'edonly'} && $self->error($self->{'text_hash'}->{'dbase_ecannot'});
$self->error_setup($self->{'text_hash'}->{'field_err'});

if ($self->{'in_hash'}->{'delete'}) {
	# delete this field
	$self->execute_sql_logged($self->{'in_hash'}->{'db'},
		    "alter table ".$self->quotestr($self->{'in_hash'}->{'table'})." drop ".
		    $self->quotestr($self->{'in_hash'}->{'old'}));
	$self->webmin_log("delete", "field", $self->{'in_hash'}->{'old'}, \%{$self->{'in_hash'}});
	}
elsif ($self->{'in_hash'}->{'new'}) {
	# add a new field
	$self->{'in_hash'}->{'field'} =~ /^\S+$/ || $self->error($self->text('field_efield', $self->{'in_hash'}->{'field'}));
	$self->{'in_hash'}->{'null'} && $self->{'in_hash'}->{'key'} && $self->error($self->{'text_hash'}->{'field_ekey'});
	$self->{'in_hash'}->{'size'} = $self->{'size'} = &validate_size();
	$self->{'sql'} = sprintf "alter table %s add %s %s%s %s %s %s",
		$self->quotestr($self->{'in_hash'}->{'table'}), $self->quotestr($self->{'in_hash'}->{'field'}), $self->{'in_hash'}->{'type'},
		$self->{'size'}, $self->{'in_hash'}->{'null'} ? '' : 'not null',
		$self->{'in_hash'}->{'default'} ne '' ? "default '$self->{'in_hash'}->{'default'}'"
				     : "default NULL",
		$self->{'in_hash'}->{'ext'};
	$self->execute_sql_logged($self->{'in_hash'}->{'db'}, $self->{'sql'});
	$self->webmin_log("create", "field", $self->{'in_hash'}->{'field'}, \%{$self->{'in_hash'}});
	}
else {
	# modify an existing field
	$self->{'in_hash'}->{'field'} =~ /^\S+$/ || $self->error($self->text('field_efield', $self->{'in_hash'}->{'field'}));
	$self->{'in_hash'}->{'null'} && $self->{'in_hash'}->{'key'} && $self->error($self->{'text_hash'}->{'field_ekey'});
	$self->{'in_hash'}->{'size'} = $self->{'size'} = &validate_size();
	$self->{'sql'} = sprintf "alter table %s modify %s %s%s %s %s %s",
			$self->quotestr($self->{'in_hash'}->{'table'}), $self->quotestr($self->{'in_hash'}->{'old'}),
			$self->{'in_hash'}->{'type'}, $self->{'size'}, $self->{'in_hash'}->{'null'} ? 'null' : 'not null',
			$self->{'in_hash'}->{'default'} ne '' ? "default '$self->{'in_hash'}->{'default'}'" :
			$self->{'in_hash'}->{'null'} ? "default NULL" : "",
			$self->{'in_hash'}->{'ext'};
	$self->execute_sql_logged($self->{'in_hash'}->{'db'}, $self->{'sql'});
	if ($self->{'in_hash'}->{'old'} ne $self->{'in_hash'}->{'field'} ||
	    $self->{'in_hash'}->{'type'} ne $self->{'in_hash'}->{'newtype'}) {
		# Rename or retype field as well
		if ($self->{'in_hash'}->{'type'} ne $self->{'in_hash'}->{'newtype'}) {
			# Type has changed .. fix size
			if ($self->{'in_hash'}->{'newtype'} eq 'enum' ||
			    $self->{'in_hash'}->{'newtype'} eq 'set') {
				# Convert old size to enum values
				if ($self->{'in_hash'}->{'type'} ne 'enum' &&
				    $self->{'in_hash'}->{'type'} ne 'set') {
					$self->{'size'} = $self->{'size'} =~ /^\((.*)\)/ ?
					    '('.join(",", map { "'$_'" }
						 split(/\n/, $1)).')' : "('')";
					}
				}
			elsif ($self->{'in_hash'}->{'newtype'} eq 'float' ||
			       $self->{'in_hash'}->{'newtype'} eq 'double' ||
			       $self->{'in_hash'}->{'newtype'} eq 'decimal') {
				# Use old sizes or size and opts
				$self->{'size'} = $self->{'size'} =~ /^\((\d+),(\d+)\)/ ? $self->{'size'} :
				  $self->{'size'} =~ /^\((\d+)\)(.*)/ ? "($1,$1)$2" : "";
				}
			elsif ($self->{'in_hash'}->{'newtype'} eq 'date' ||
			       $self->{'in_hash'}->{'newtype'} eq 'datetime' ||
			       $self->{'in_hash'}->{'newtype'} eq 'time' ||
			       $self->{'in_hash'}->{'newtype'} =~ /(blob|text)$/) {
				# New type has no size or opts
				$self->{'size'} = "";
				}
			else {
				# Use old size and opts
				$self->{'size'} = $self->{'size'} =~ /^\((\d+)/ ?
					"($1) $self->{'in_hash'}->{'opts'}" :
					$self->{'in_hash'}->{'newtype'} =~ /char$/ ?
					    "(255) $self->{'in_hash'}->{'opts'}" : $self->{'in_hash'}->{'opts'};
				}
			}
		$self->{'sql'} = sprintf "alter table %s change %s %s %s%s %s",
				$self->quotestr($self->{'in_hash'}->{'table'}), $self->quotestr($self->{'in_hash'}->{'old'}),
				$self->quotestr($self->{'in_hash'}->{'field'}), $self->{'in_hash'}->{'newtype'}, $self->{'size'},
				$self->{'in_hash'}->{'null'} ? '' : 'not null';
		$self->execute_sql_logged($self->{'in_hash'}->{'db'}, $self->{'sql'});
		}
	$self->webmin_log("modify", "field", $self->{'in_hash'}->{'field'}, \%{$self->{'in_hash'}});
	}

if ($self->{'in_hash'}->{'key'} != $self->{'in_hash'}->{'oldkey'}) {
	# Adding or removing a primary key to the table
	foreach $d ($self->table_structure($self->{'in_hash'}->{'db'}, $self->{'in_hash'}->{'table'})) {
		push(@{$self->{'pri_array'}}, $d->{'field'}) if ($d->{'key'} eq 'PRI');
		}
	if ($self->{'in_hash'}->{'key'}) {
		@{$self->{'npri_array'}} = ( @{$self->{'pri_array'}}, $self->{'in_hash'}->{'field'} );
		}
	else {
		@{$self->{'npri_array'}} = grep { $_ ne $self->{'in_hash'}->{'field'} } @{$self->{'pri_array'}};
		}
	$self->execute_sql_logged($self->{'in_hash'}->{'db'},
		    "alter table ".$self->quotestr($self->{'in_hash'}->{'table'})." drop primary key")
		if (@{$self->{'pri_array'}});
	$self->execute_sql_logged($self->{'in_hash'}->{'db'},
		    "alter table ".$self->quotestr($self->{'in_hash'}->{'table'})." add primary key (".
		    join(",", map { $self->quotestr($_) } @{$self->{'npri_array'}}).")") if (@{$self->{'npri_array'}});
	}
$self->redirect("edit_table.cgi?db=$self->{'in_hash'}->{'db'}&table=".$self->urlize($self->{'in_hash'}->{'table'}));

1;
		
}

sub validate_size
{
	shift if ($self == $_[0]);

if ($self->{'in_hash'}->{'type'} eq 'enum' || $self->{'in_hash'}->{'type'} eq 'set') {
	$self->{'in_hash'}->{'size'} || $self->error($self->{'text_hash'}->{'field_eenum'});
	$self->{'in_hash'}->{'size'} =~ s/\r//g;
	return '('.join(",", map { "'$_'" } split(/\n/, $self->{'in_hash'}->{'size'})).')';
	}
elsif ($self->{'in_hash'}->{'type'} eq 'float' || $self->{'in_hash'}->{'type'} eq 'double' ||
       $self->{'in_hash'}->{'type'} eq 'decimal') {
	$self->{'in_hash'}->{'size1'} =~ /^\d+$/ || $self->error($self->text('field_esize', $self->{'in_hash'}->{'size1'}));
	$self->{'in_hash'}->{'size2'} =~ /^\d+$/ || $self->error($self->text('field_esize', $self->{'in_hash'}->{'size2'}));
	return "($self->{'in_hash'}->{'size1'},$self->{'in_hash'}->{'size2'}) $self->{'in_hash'}->{'opts'}";
	}
elsif ($self->{'in_hash'}->{'type'} eq 'date' || $self->{'in_hash'}->{'type'} eq 'datetime' ||
       $self->{'in_hash'}->{'type'} eq 'time' || $self->{'in_hash'}->{'type'} =~ /(blob|text)$/) {
	return "";
	}
elsif ($self->{'in_hash'}->{'size_def'}) {
	return "";
	}
else {
	$self->{'in_hash'}->{'size'} =~ /^\d+$/ || $self->error($self->text('field_esize', $self->{'in_hash'}->{'size'}));
	return "($self->{'in_hash'}->{'size'}) $self->{'in_hash'}->{'opts'}";
	}
}


1;

