#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_host.cgi
# Save, create or delete a host table record

&ModuleLoader::preload_module('mysql_class', "mysql::MysqlLib");
$self = new mysql::MysqlLib:: 'mysql_class',%$self;

$self->ReadParse();
$self->{'access_hash'}->{'perms'} || $self->error($self->{'text_hash'}->{'perms_ecannot'});

if ($self->{'in_hash'}->{'delete'}) {
	# Delete some host
	$self->{'access_hash'}->{'perms'} == 1 || $self->can_edit_db($self->{'in_hash'}->{'olddb'}) ||
		$self->error($self->{'text_hash'}->{'perms_edb'});
	$self->execute_sql_logged($self->{'master_db'},
		     "delete from host where host = '$self->{'in_hash'}->{'oldhost'}' ".
		     "and db = '$self->{'in_hash'}->{'olddb'}'");
	}
else {
	# Validate inputs
	$self->error_setup($self->{'text_hash'}->{'host_err'});
	$self->{'in_hash'}->{'host_def'} || $self->{'in_hash'}->{'host'} =~ /^\S+$/ ||
		$self->error($self->{'text_hash'}->{'host_ehost'});
	if ($self->{'access_hash'}->{'perms'} == 2 && $self->{'access_hash'}->{'dbs'} ne '*') {
		$self->{'db'} = $self->{'in_hash'}->{'dbs'};
		}
	else {
		$self->{'db'} = $self->{'in_hash'}->{'db_def'} == 1 ? "" :
		      $self->{'in_hash'}->{'db_def'} == 2 ? $self->{'in_hash'}->{'dbs'} : $self->{'in_hash'}->{'db'};
		$self->{'db'} =~ /^\S*$/ || $self->error($self->{'text_hash'}->{'host_edb'});
		}
	if ($self->{'access_hash'}->{'perms'} == 2) {
		$self->{'in_hash'}->{'new'} || $self->can_edit_db($self->{'in_hash'}->{'olddb'}) ||
			$self->error($self->{'text_hash'}->{'perms_edb'});
		$self->can_edit_db($self->{'db'}) || $self->error($self->{'text_hash'}->{'perms_edb'});
		}

	map { $self->{'perms_array'}->[$_]++ } split(/\0/, $self->{'in_hash'}->{'perms'});
	@{$self->{'desc_array'}} = $self->table_structure($self->{'master_db'}, 'host');
	if ($self->{'in_hash'}->{'new'}) {
		# Create a new host
		for($i=2; $i<=$self->host_priv_cols()+2-1; $i++) {
			push(@{$self->{'yesno_array'}}, $self->{'perms_array'}->[$i] ? "'Y'" : "'N'");
			}
		$self->{'sql'} = sprintf "insert into host (%s) values ('%s', '%s', %s)",
			join(",", map { $self->{'desc_array'}->[$_]->{'field'} } (0 .. $self->host_priv_cols()+2-1)),
			$self->{'in_hash'}->{'host_def'} ? '' : $self->{'in_hash'}->{'host'}, $self->{'db'},
			join(",", @{$self->{'yesno_array'}});
		}
	else {
		# Update existing host
		for($i=2; $i<=$self->host_priv_cols()+2-1; $i++) {
			push(@{$self->{'yesno_array'}}, $self->{'desc_array'}->[$i]->{'field'}."=".
				     ($self->{'perms_array'}->[$i] ? "'Y'" : "'N'"));
			}
		$self->{'sql'} = sprintf "update host set host = '%s', db = '%s', %s ".
			       "where host = '%s' and db = '%s'",
			$self->{'in_hash'}->{'host_def'} ? '' : $self->{'in_hash'}->{'host'}, $self->{'db'},
			join(" , ", @{$self->{'yesno_array'}}), $self->{'in_hash'}->{'oldhost'}, $self->{'in_hash'}->{'olddb'};
		}
	$self->execute_sql_logged($self->{'master_db'}, $self->{'sql'});
	}
$self->execute_sql_logged($self->{'master_db'}, 'flush privileges');
if ($self->{'in_hash'}->{'delete'}) {
	$self->webmin_log("delete", "host", $self->{'in_hash'}->{'oldhost'},
		    { 'db' => $self->{'in_hash'}->{'olddb'},
		      'host' => $self->{'in_hash'}->{'oldhost'} } );
	}
elsif ($self->{'in_hash'}->{'new'}) {
	$self->webmin_log("create", "host", $self->{'in_hash'}->{'host_def'} ? '' : $self->{'in_hash'}->{'host'},
		    { 'db' => $self->{'db'},
		      'host' => $self->{'in_hash'}->{'host_def'} ? '' : $self->{'in_hash'}->{'host'} } );
	}
else {
	$self->webmin_log("modify", "host", $self->{'in_hash'}->{'host_def'} ? '' : $self->{'in_hash'}->{'host'},
		    { 'db' => $self->{'db'},
		      'host' => $self->{'in_hash'}->{'host_def'} ? '' : $self->{'in_hash'}->{'host'} } );
	}
$self->redirect("list_hosts.cgi");

1;
		
}


1;

