#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_user.cgi
# Save, create or delete a user

&ModuleLoader::preload_module('mysql_class', "mysql::MysqlLib");
$self = new mysql::MysqlLib:: 'mysql_class',%$self;

$self->ReadParse();
$self->{'access_hash'}->{'perms'} == 1 || $self->error($self->{'text_hash'}->{'perms_ecannot'});

if ($self->{'in_hash'}->{'delete'}) {
	# Delete some user
	$self->execute_sql_logged($self->{'master_db'},
		     "delete from user where user = '$self->{'in_hash'}->{'olduser'}' ".
		     "and host = '$self->{'in_hash'}->{'oldhost'}'");
	}
else {
	# Validate inputs
	$self->error_setup($self->{'text_hash'}->{'user_err'});
	$self->{'in_hash'}->{'mysqluser_def'} || $self->{'in_hash'}->{'mysqluser'} =~ /^\S+$/ ||
		$self->error($self->{'text_hash'}->{'user_euser'});
	$self->{'in_hash'}->{'host_def'} || $self->{'in_hash'}->{'host'} =~ /^\S+$/ ||
		$self->error($self->{'text_hash'}->{'user_ehost'});

	map { $self->{'perms_array'}->[$_]++ } split(/\0/, $self->{'in_hash'}->{'perms'});
	@{$self->{'desc_array'}} = $self->table_structure($self->{'master_db'}, 'user');
	$self->{'host'} = $self->{'in_hash'}->{'host_def'} ? '' : $self->{'in_hash'}->{'host'};
	$self->{'user'} = $self->{'in_hash'}->{'mysqluser_def'} ? '' : $self->{'in_hash'}->{'mysqluser'};
	if ($self->{'in_hash'}->{'new'}) {
		# Create a new user
		for($i=3; $i<=$self->user_priv_cols()+3-1; $i++) {
			push(@{$self->{'yesno_array'}}, $self->{'perms_array'}->[$i] ? "'Y'" : "'N'");
			}
		$self->{'sql'} = sprintf "insert into user (%s) values ('%s', '%s', '', %s)",
			join(",", map { $self->{'desc_array'}->[$_]->{'field'} } (0 .. $self->user_priv_cols()+3-1)),
			$self->{'host'}, $self->{'user'},
			join(",", @{$self->{'yesno_array'}});
		}
	else {
		# Update existing user
		for($i=3; $i<=$self->user_priv_cols()+3-1; $i++) {
			push(@{$self->{'yesno_array'}}, $self->{'desc_array'}->[$i]->{'field'}."=".
				     ($self->{'perms_array'}->[$i] ? "'Y'" : "'N'"));
			}
		$self->{'sql'} = sprintf "update user set host = '%s', user = '%s', ".
			       "%s where user = '%s' and host = '%s'",
		    $self->{'host'}, $self->{'user'},
		    join(" , ", @{$self->{'yesno_array'}}), $self->{'in_hash'}->{'olduser'}, $self->{'in_hash'}->{'oldhost'};
		}
	$self->execute_sql_logged($self->{'master_db'}, $self->{'sql'});
	if ($self->{'in_hash'}->{'mysqlpass_mode'} == 0) {
		$self->{'esc'} = $self->escapestr($self->{'in_hash'}->{'mysqlpass'});
		$self->execute_sql_logged($self->{'master_db'},
		    "update user set password = $self->{'password_func'}('$self->{'esc'}') ".
		    "where user = '$self->{'user'}' and host = '$self->{'host'}'");
		}
	elsif ($self->{'in_hash'}->{'mysqlpass_mode'} == 2) {
		$self->execute_sql_logged($self->{'master_db'},
			"update user set password = NULL ".
			"where user = '$self->{'user'}' and host = '$self->{'host'}'");
		}
	}
$self->execute_sql_logged($self->{'master_db'}, 'flush privileges');
if (!$self->{'in_hash'}->{'delete'} && !$self->{'in_hash'}->{'new'} &&
    $self->{'in_hash'}->{'olduser'} eq $self->{'config_hash'}->{'login'} && !$self->{'access_hash'}->{'user'}) {
	# Renamed or changed the password for the Webmin login .. update
	# it too!
	$self->{'config_hash'}->{'login'} = $self->{'in_hash'}->{'mysqluser'};
	if ($self->{'in_hash'}->{'mysqlpass_mode'} == 0) {
		$self->{'config_hash'}->{'pass'} = $self->{'in_hash'}->{'mysqlpass'};
		}
	elsif ($self->{'in_hash'}->{'mysqlpass_mode'} == 2) {
		$self->{'config_hash'}->{'pass'} = undef;
		}
	$self->write_file("$self->{'module_config_directory'}/config", \%{$self->{'config_hash'}});
	}
if ($self->{'in_hash'}->{'delete'}) {
	$self->webmin_log("delete", "user", $self->{'in_hash'}->{'olduser'},
		    { 'user' => $self->{'in_hash'}->{'olduser'},
		      'host' => $self->{'in_hash'}->{'oldhost'} } );
	}
elsif ($self->{'in_hash'}->{'new'}) {
	$self->webmin_log("create", "user",
		    $self->{'in_hash'}->{'mysqluser_def'} ? '' : $self->{'in_hash'}->{'mysqluser'},
		    { 'user' => $self->{'in_hash'}->{'mysqluser_def'} ? '' : $self->{'in_hash'}->{'mysqluser'},
		      'host' => $self->{'in_hash'}->{'host_def'} ? '' : $self->{'in_hash'}->{'host'} } );
	}
else {
	$self->webmin_log("modify", "user",
		    $self->{'in_hash'}->{'mysqluser_def'} ? '' : $self->{'in_hash'}->{'mysqluser'},
		    { 'user' => $self->{'in_hash'}->{'mysqluser_def'} ? '' : $self->{'in_hash'}->{'mysqluser'},
		      'host' => $self->{'in_hash'}->{'host_def'} ? '' : $self->{'in_hash'}->{'host'} } );
	}
$self->redirect("list_users.cgi");

1;
		
}


1;

