#!/usr/bin/perl

&MAIN();

 sub MAIN {
# view_table.cgi
# Display all data in some table

if (-r 'mysql-lib.pl') {
	&ModuleLoader::preload_module('mysql_class', "mysql::MysqlLib");
$self = new mysql::MysqlLib:: 'mysql_class',%$self;

	}
else {
	require './postgresql-lib.pl';
	}
&ModuleLoader::preload_module('mysql_class', "mysql::ViewLib");
$self = new mysql::ViewLib:: 'mysql_class',%$self;


if ($self->{'config_hash'}->{'charset'}) {
	$self->{'force_charset'} = $self->{'config_hash'}->{'charset'};
	}
if ($ENV{'CONTENT_TYPE'} !~ /boundary=/) {
	$self->ReadParse();
	}
else {
	$self->ReadParseMime();
	}
$self->can_edit_db($self->{'in_hash'}->{'db'}) || $self->error($self->{'text_hash'}->{'dbase_ecannot'});
@{$self->{'str_array'}} = $self->table_structure($self->{'in_hash'}->{'db'}, $self->{'in_hash'}->{'table'});
foreach $s (@{$self->{'str_array'}}) {
	$self->{'keyed'}++ if ($s->{'key'} eq 'PRI');
	}
if (!$self->{'keyed'} && $self->{'module_name'} eq "postgresql") {
	# Can use oid as key
	eval { $self->{'error_must_die'} = 1;
	       $d = $self->execute_sql($self->{'in_hash'}->{'db'}, "select oid from ".
					    $self->quotestr($self->{'in_hash'}->{'table'}).
					    " where 0 = 1"); };
	if (!$@) {
		# Has an OID, so use it
		$self->{'use_oids'} = 1;
		$self->{'keyed'} = 1;
		}
	}

# Get search and limiting SQL
($self->{'search'}, $self->{'searchhids'}, $self->{'searchargs'}, $self->{'advcount'}) = $self->get_search_args(\%{$self->{'in_hash'}});
$self->{'limitsql'} = $self->get_search_limit(\%{$self->{'in_hash'}});
($self->{'sortsql'}, $self->{'sorthids'}, $self->{'sortargs'}) = $self->get_search_sort(\%{$self->{'in_hash'}});

# Work out where clause for rows we are operating on
$self->{'where_select'} = "select ".($self->{'use_oids'} ? "oid" : "*").
		" from ".$self->quotestr($self->{'in_hash'}->{'table'})." $self->{'search'} $self->{'sortsql'} $self->{'limitsql'}";

if ($self->{'in_hash'}->{'delete'}) {
	# Deleting selected rows
	$d = $self->execute_sql($self->{'in_hash'}->{'db'}, $self->{'where_select'});
	@{$self->{'t_array'}} = map { $_->{'field'} } @{$self->{'str_array'}};
	$self->{'count'} = 0;
	foreach $r (split(/\0/, $self->{'in_hash'}->{'row'})) {
		local @where;
		local @r = @{$d->{'data'}->[$r]};
		if ($self->{'use_oids'}) {
			# Where clause just uses OID
			push(@where, "oid = $r[0]");
			}
		else {
			# Where clause uses keys
			for($self->{'i'}=0; $self->{'i'}<@{$self->{'t_array'}}; $self->{'i'}++) {
				if ($self->{'str_array'}->[$self->{'i'}]->{'key'} eq 'PRI') {
					if ($r[$self->{'i'}] eq 'NULL') {
						push(@where, $self->quotestr($self->{'t_array'}->[$self->{'i'}]).
							     " is null");
						}
					else {
						$r[$self->{'i'}] =~ s/'/''/g;
						push(@where, $self->quotestr($self->{'t_array'}->[$self->{'i'}]).
							     " = '$r[$self->{'i'}]'");
						}
					}
				}
			}
		$self->execute_sql_logged($self->{'in_hash'}->{'db'},
				    "delete from ".$self->quotestr($self->{'in_hash'}->{'table'}).
				    " where ".join(" and ", @where));
		$self->{'count'}++;
		}
	$self->webmin_log("delete", "data", $self->{'count'}, \%{$self->{'in_hash'}});
	$self->redirect("view_table.cgi?db=$self->{'in_hash'}->{'db'}&".
		  "table=".$self->urlize($self->{'in_hash'}->{'table'})."&start=$self->{'in_hash'}->{'start'}".
		  $self->{'searchargs'}.$self->{'sortargs'});
	}
elsif ($self->{'in_hash'}->{'save'}) {
	# Update edited rows
	$d = $self->execute_sql($self->{'in_hash'}->{'db'}, $self->{'where_select'});
	@{$self->{'t_array'}} = map { $_->{'field'} } @{$self->{'str_array'}};
	$self->{'count'} = 0;
	for($j=0; $j<$self->{'config_hash'}->{'perpage'}; $j++) {
		next if (!defined($self->{'in_hash'}->{"${j}_$self->{'t_array'}->[0]"}));
		local (@where, @set);
		local @r = @{$d->{'data'}->[$j]};
		local @params;
		if ($self->{'use_oids'}) {
			# Where clause just uses OID
			push(@where, "oid = $r[0]");
			}
		for($self->{'i'}=0; $self->{'i'}<@{$self->{'t_array'}}; $self->{'i'}++) {
			if (!$self->{'use_oids'}) {
				# Where clause uses keys
				if ($self->{'str_array'}->[$self->{'i'}]->{'key'} eq 'PRI') {
					if ($r[$self->{'i'}] eq 'NULL') {
						push(@where, $self->quotestr($self->{'t_array'}->[$self->{'i'}]).
							     " is null");
						}
					else {
						$r[$self->{'i'}] =~ s/'/''/g;
						push(@where, $self->quotestr($self->{'t_array'}->[$self->{'i'}]).
							     " = '$r[$self->{'i'}]'");
						}
					}
				}
			local $ij = $self->{'in_hash'}->{"${j}_$self->{'t_array'}->[$self->{'i'}]"};
			local $ijdef = $self->{'in_hash'}->{"${j}_$self->{'t_array'}->[$self->{'i'}]_def"};
			next if ($ijdef || !defined($ij));
			if (!$self->{'config_hash'}->{'blob_mode'} || !$self->is_blob($self->{'str_array'}->[$self->{'i'}])) {
				$ij =~ s/\r//g;
				}
			push(@set, $self->quotestr($self->{'t_array'}->[$self->{'i'}])." = ?");
			push(@params, $ij eq '' ? undef : $ij);
			}
		$self->execute_sql_logged($self->{'in_hash'}->{'db'},
				    "update ".$self->quotestr($self->{'in_hash'}->{'table'})." set ".
				    join(" , ", @set)." where ".
				    join(" and ", @where), @params);
		$self->{'count'}++;
		}
	$self->webmin_log("modify", "data", $self->{'count'}, \%{$self->{'in_hash'}});
	$self->redirect("view_table.cgi?db=$self->{'in_hash'}->{'db'}&".
		  "table=".$self->urlize($self->{'in_hash'}->{'table'})."&start=$self->{'in_hash'}->{'start'}".
		  $self->{'searchargs'}.$self->{'sortargs'});
	}
elsif ($self->{'in_hash'}->{'savenew'}) {
	# Adding a new row
	for($j=0; $j<@{$self->{'str_array'}}; $j++) {
		if (!$self->{'config_hash'}->{'blob_mode'} || !$self->is_blob($self->{'str_array'}->[$j])) {
			$self->{'in_hash'}->{$j} =~ s/\r//g;
			}
		push(@set, $self->{'in_hash'}->{$j} eq '' ? undef : $self->{'in_hash'}->{$j});
		}
	$self->execute_sql_logged($self->{'in_hash'}->{'db'}, "insert into ".$self->quotestr($self->{'in_hash'}->{'table'}).
		    " values (".join(" , ", map { "?" } @set).")", @set);
	$self->redirect("view_table.cgi?db=$self->{'in_hash'}->{'db'}&".
		  "table=".$self->urlize($self->{'in_hash'}->{'table'})."&start=$self->{'in_hash'}->{'start'}".
		  $self->{'searchargs'}.$self->{'sortargs'});
	$self->webmin_log("create", "data", undef, \%{$self->{'in_hash'}});
	}
elsif ($self->{'in_hash'}->{'cancel'} || $self->{'in_hash'}->{'new'}) {
	undef($self->{'in_hash'}->{'row'});
	}

$self->{'desc'} = $self->text('table_header', "<tt>$self->{'in_hash'}->{'table'}</tt>", "<tt>$self->{'in_hash'}->{'db'}</tt>");
$self->ui_print_header($self->{'desc'}, $self->{'text_hash'}->{'view_title'}, "");

$d = $self->execute_sql_safe($self->{'in_hash'}->{'db'},
	"select count(*) from ".$self->quotestr($self->{'in_hash'}->{'table'})." ".$self->{'search'});
$self->{'total'} = int($d->{'data'}->[0]->[0]);
if ($self->{'in_hash'}->{'jump'} > 0) {
	$self->{'in_hash'}->{'start'} = int($self->{'in_hash'}->{'jump'} / $self->{'config_hash'}->{'perpage'}) *
		       $self->{'config_hash'}->{'perpage'};
	if ($self->{'in_hash'}->{'start'} >= $self->{'total'}) {
		$self->{'in_hash'}->{'start'} = $self->{'total'} - $self->{'config_hash'}->{'perpage'};
		$self->{'in_hash'}->{'start'} = int(($self->{'in_hash'}->{'start'} / $self->{'config_hash'}->{'perpage'}) + 1) *
			       $self->{'config_hash'}->{'perpage'};
		}
	}
else {
	$self->{'in_hash'}->{'start'} = int($self->{'in_hash'}->{'start'});
	}
if ($self->{'in_hash'}->{'new'} && $self->{'total'} > $self->{'config_hash'}->{'perpage'}) {
	# go to the last screen for adding a row
	$self->{'in_hash'}->{'start'} = $self->{'total'} - $self->{'config_hash'}->{'perpage'};
	$self->{'in_hash'}->{'start'} = int(($self->{'in_hash'}->{'start'} / $self->{'config_hash'}->{'perpage'}) + 1) *
		       $self->{'config_hash'}->{'perpage'};
	}
if ($self->{'in_hash'}->{'start'} || $self->{'total'} > $self->{'config_hash'}->{'perpage'}) {
	print "<center>\n";
	if ($self->{'in_hash'}->{'start'}) {
		printf "<a href='view_table.cgi?db=%s&table=%s&start=%s%s%s'>".
		       "<img src=/images/left.gif border=0 align=middle></a>\n",
			$self->{'in_hash'}->{'db'}, $self->{'in_hash'}->{'table'},
			$self->{'in_hash'}->{'start'} - $self->{'config_hash'}->{'perpage'},
			$self->{'searchargs'}, $self->{'sortargs'};
		}
	print "<font size=+1>",$self->text('view_pos', $self->{'in_hash'}->{'start'}+1,
	      $self->{'in_hash'}->{'start'}+$self->{'config_hash'}->{'perpage'} > $self->{'total'} ? $self->{'total'} :
	      $self->{'in_hash'}->{'start'}+$self->{'config_hash'}->{'perpage'}, $self->{'total'}),"</font>\n";
	if ($self->{'in_hash'}->{'start'}+$self->{'config_hash'}->{'perpage'} < $self->{'total'}) {
		printf "<a href='view_table.cgi?db=%s&table=%s&start=%s%s%s'>".
		       "<img src=/images/right.gif border=0 align=middle></a> ",
			$self->{'in_hash'}->{'db'}, $self->{'in_hash'}->{'table'},
			$self->{'in_hash'}->{'start'} + $self->{'config_hash'}->{'perpage'},
			$self->{'searchargs'}, $self->{'sortargs'};
		}
	print "</center>\n";
	}

print "<table width=100% cellspacing=0 cellpadding=0>\n";

if ($self->{'in_hash'}->{'field'}) {
	# Show details of simple search
	print "<tr> <td><b>",$self->text('view_searchhead', "<tt>$self->{'in_hash'}->{'for'}</tt>",
			   "<tt>$self->{'in_hash'}->{'field'}</tt>"),"</b></td>\n";
	print "<td align=right><a href='view_table.cgi?db=$self->{'in_hash'}->{'db'}&",
	      "table=$self->{'in_hash'}->{'table'}$self->{'sortargs'}'>$self->{'text_hash'}->{'view_searchreset'}</a></td> </tr>\n";
	}
elsif ($self->{'in_hash'}->{'advanced'}) {
	# Show details of advanced search
	print "<tr> <td><b>",$self->text('view_searchhead2', $self->{'advcount'}),"</b></td>\n";
	print "<td align=right><a href='view_table.cgi?db=$self->{'in_hash'}->{'db'}&",
	      "table=$self->{'in_hash'}->{'table'}$self->{'sortargs'}'>$self->{'text_hash'}->{'view_searchreset'}</a></td> </tr>\n";
	}
if ($self->{'in_hash'}->{'sortfield'}) {
	# Show current sort order
	print "<tr> <td><b>",$self->text($self->{'in_hash'}->{'sortdir'} ? 'view_sorthead2' : 'view_sorthead1',
			      "<tt>$self->{'in_hash'}->{'sortfield'}</tt>"),"</b></td>\n";
	print "<td align=right><a href='view_table.cgi?db=$self->{'in_hash'}->{'db'}&",
	      "table=$self->{'in_hash'}->{'table'}$self->{'searchargs'}'>$self->{'text_hash'}->{'view_sortreset'}</a></td> </tr>\n";
	}

print "</table>\n";

if ($self->{'config_hash'}->{'blob_mode'}) {
	print $self->ui_form_start("view_table.cgi", "form-data");
	}
else {
	print $self->ui_form_start("view_table.cgi", "post");
	}
print $self->ui_hidden("db", $self->{'in_hash'}->{'db'}),"\n";
print $self->ui_hidden("table", $self->{'in_hash'}->{'table'}),"\n";
print $self->ui_hidden("start", $self->{'in_hash'}->{'start'}),"\n";
print $self->{'searchhids'};
print $self->{'sorthids'};
$self->{'check'} = !defined($self->{'in_hash'}->{'row'}) && !$self->{'in_hash'}->{'new'} && $self->{'keyed'};
if ($self->{'total'} || $self->{'in_hash'}->{'new'}) {
	# Get the rows of data, and show the table header
	$d = $self->execute_sql_safe($self->{'in_hash'}->{'db'},
		"select * from ".$self->quotestr($self->{'in_hash'}->{'table'})." $self->{'search'} $self->{'sortsql'} $self->{'limitsql'}");
	@{$self->{'data_array'}} = @{$d->{'data'}};
	@{$self->{'tds_array'}} = $self->{'check'} ? ( "width=5" ) : ( );
	($self->{'has_blob'}) = grep { $self->is_blob($_) } @{$self->{'str_array'}};

	@{$self->{'rowlinks_array'}} = $self->{'check'} ? ( $self->select_all_link("row"),
			       $self->select_invert_link("row") ) : ( );
	print $self->ui_links_row(\@{$self->{'rowlinks_array'}});
	print $self->ui_columns_start([
		$self->{'check'} ? ( "" ) : ( ),
		map { &column_sort_link($_->{'field'}) } @{$self->{'str_array'}}
		], 100, 0, \@{$self->{'tds_array'}});

	# Add an empty row for inserting
	$self->{'realrows'} = scalar(@{$self->{'data_array'}});
	if ($self->{'in_hash'}->{'new'}) {
		push(@{$self->{'data_array'}}, [ map { undef } @{$self->{'str_array'}} ]);
		$self->{'row_hash'}->{$self->{'realrows'}} = 1;
		}

	# Show the rows, some of which may be editable
	map { $self->{'row_hash'}->{$_}++ } split(/\0/, $self->{'in_hash'}->{'row'});
	$self->{'w'} = int(100 / scalar(@{$self->{'str_array'}}));
	$self->{'w'} = 10 if ($self->{'w'} < 10);
	for($self->{'i'}=0; $self->{'i'}<@{$self->{'data_array'}}; $self->{'i'}++) {
		local @d = map { $_ eq "NULL" ? undef : $_ } @{$self->{'data_array'}->[$self->{'i'}]};
		if ($self->{'row_hash'}->{$self->{'i'}} && ($self->{'config_hash'}->{'add_mode'} || $self->{'has_blob'})) {
			# Show multi-line row editor
			$self->{'et'} = "<table border>\n";
			$self->{'et'} .= "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'view_field'}</b></td> ".
			      "<td><b>$self->{'text_hash'}->{'view_data'}</b></td> </tr>\n";
			for($j=0; $j<@{$self->{'str_array'}}; $j++) {
				local $nm = $self->{'i'} == $self->{'realrows'} ? $j :
						"$self->{'i'}_$self->{'str_array'}->[$j]->{'field'}";
				$self->{'et'} .= "<tr $self->{'cb'}> <td><b>$self->{'str_array'}->[$j]->{'field'}</b></td> <td>\n";
				if ($self->{'config_hash'}->{'blob_mode'} &&
				    $self->is_blob($self->{'str_array'}->[$j]) && $d[$j]) {
					# Show as keep/upload inputs
					$self->{'et'} .= $self->ui_radio($nm."_def", 1,
					    [ [ 1, $self->{'text_hash'}->{'view_keep'} ],
					      [ 0, $self->{'text_hash'}->{'view_set'} ] ])." ".
					  $self->ui_upload($nm);
					}
				elsif ($self->{'config_hash'}->{'blob_mode'} &&
				       $self->is_blob($self->{'str_array'}->[$j])) {
					# Show upload input
					$self->{'et'} .= $self->ui_upload($nm);
					}
				elsif ($self->{'str_array'}->[$j]->{'type'} =~ /^enum\((.*)\)$/) {
					# Show as enum list
					$self->{'et'} .= $self->ui_select($nm, $d[$j],
					    [ [ "", "&nbsp;" ],
					      map { [ $_ ] } $self->split_enum($1) ],
					    1, 0, 1);
					}
				elsif ($self->{'str_array'}->[$j]->{'type'} =~ /\((\d+)\)/) {
					# Show as known-size text
					local $nw = $1 > 70 ? 70 : $1;
					$self->{'et'} .= $self->ui_textbox($nm, $d[$j], $nw);
					}
				elsif ($self->is_blob($self->{'str_array'}->[$j])) {
					# Show as multiline text
					$self->{'et'} .= $self->ui_textarea($nm, $d[$j], 5, 70);
					}
				else {
					# Show as fixed-size text
					$self->{'et'} .= $self->ui_textbox($nm, $d[$j], 30);
					}
				$self->{'et'} .= "</td></tr>\n";
				}
			$self->{'et'} .= "</table>";
			print $self->ui_columns_row([ $self->{'check'} ? ( "" ) : ( ), $self->{'et'} ],
					      [ @{$self->{'tds_array'}}, "colspan=".scalar(@d) ] );
			}
		elsif ($self->{'row_hash'}->{$self->{'i'}}) {
			# Show one-line row-editor
			local @cols;
			for($j=0; $j<@d; $j++) {
				local $l = $d[$j] =~ tr/\n/\n/;
				local $nm = $self->{'i'} == $self->{'realrows'} ? $j :
						"$self->{'i'}_$d->{'titles'}->[$j]";
				if ($self->{'config_hash'}->{'blob_mode'} &&
				    $self->is_blob($self->{'str_array'}->[$j])) {
					# Cannot edit this blob
					push(@cols, undef);
					}
				elsif ($self->{'str_array'}->[$j]->{'type'} =~ /^enum\((.*)\)$/) {
					# Show as enum list
					push(@cols, $self->ui_select($nm, $d[$j],
					    [ [ "", "&nbsp;" ],
					      map { [ $_ ] } $self->split_enum($1) ],
					    1, 0, 1));
					}
				elsif ($self->{'str_array'}->[$j]->{'type'} =~ /\((\d+)\)/) {
					# Show as known-size text
					local $nw = $1 > 70 ? 70 : $1;
					push(@cols,
					     $self->ui_textbox($nm, $d[$j], $nw));
					}
				elsif ($l) {
					# Show as multiline text
					$l++;
					push(@cols,
					     $self->ui_textarea($nm, $d[$j], $l, $self->{'w'}));
					}
				else {
					# Show as known size text
					push(@cols,
					     $self->ui_textbox($nm, $d[$j], $self->{'w'}));
					}
				}
			print $self->ui_columns_row([ $self->{'check'} ? ( "" ) : ( ), @cols ],
					      \@{$self->{'tds_array'}});
			}
		else {
			# Show row contents
			local @cols;
			local $j = 0;
			foreach $c (@d) {
				if ($self->{'config_hash'}->{'blob_mode'} &&
				    $self->is_blob($self->{'str_array'}->[$j]) && $c ne '') {
					# Show download link for blob
					push(@cols, "<a href='download.cgi?db=$self->{'in_hash'}->{'db'}&table=$self->{'in_hash'}->{'table'}&start=$self->{'in_hash'}->{'start'}".$self->{'searchargs'}.$self->{'sortargs'}."&row=$self->{'i'}&col=$j'>$self->{'text_hash'}->{'view_download'}</a>");
					}
				else {
					# Just show $self->text(up to limit)
					if ($self->{'config_hash'}->{'max_text'} &&
					    length($c) > $self->{'config_hash'}->{'max_text'}) {
						$c = substr($c, 0,
						  $self->{'config_hash'}->{'max_text'})." ...";
						}
					push(@cols, $self->html_escape($c));
					}
				$j++;
				}
			if ($self->{'check'}) {
				print $self->ui_checked_columns_row(\@cols, \@{$self->{'tds_array'}},
							      "row", $self->{'i'});
				}
			else {
				print $self->ui_columns_row(\@cols, \@{$self->{'tds_array'}});
				}
			}
		}
	print $self->ui_columns_end();
	print $self->ui_links_row(\@{$self->{'rowlinks_array'}});
	}
else {
	print "<b>$self->{'text_hash'}->{'view_none'}</b> <p>\n";
	}

# Show buttons to edit / delete rows
if (!$self->{'keyed'}) {
	print "<b>$self->{'text_hash'}->{'view_nokey'}</b><p>\n";
	print $self->ui_form_end();
	}
elsif (!$self->{'check'}) {
	if ($self->{'in_hash'}->{'new'}) {
		print $self->ui_form_end([ [ "savenew", $self->{'text_hash'}->{'save'} ],
				     [ "cancel", $self->{'text_hash'}->{'cancel'} ] ]);
		}
	else {
		print $self->ui_form_end([ [ "save", $self->{'text_hash'}->{'save'} ],
				     [ "cancel", $self->{'text_hash'}->{'cancel'} ] ]);
		}
	}
elsif ($self->{'total'}) {
	print $self->ui_form_end([ [ "edit", $self->{'text_hash'}->{'view_edit'} ],
			     [ "new", $self->{'text_hash'}->{'view_new'} ],
			     [ "delete", $self->{'text_hash'}->{'view_delete'} ] ]);
	}
else {
	print $self->ui_form_end([ [ "new", $self->{'text_hash'}->{'view_new'} ] ]);
	}

if (!$self->{'in_hash'}->{'field'} && $self->{'total'} > $self->{'config_hash'}->{'perpage'}) {
	# Show search and jump buttons
	print "<hr>\n";
	print "<table width=100%><tr>\n";
	print "<form action=view_table.cgi>\n";
	print "<input type=hidden name=search value=1>\n";
	print $self->ui_hidden("db", $self->{'in_hash'}->{'db'});
	print $self->ui_hidden("table", $self->{'in_hash'}->{'table'});
	$self->{'sel'} = $self->ui_select("field", undef,
			[ map { [ $_->{'field'}, $_->{'field'} ] } @{$self->{'str_array'}} ]);
	$self->{'match'} = $self->ui_select("match", 0,
			[ map { [ $_, $self->{'text_hash'}->{'view_match'.$_} ] } (0.. 3) ]);
	print "<td>",$self->text('view_search2', "<input name=for size=20>", $self->{'sel'},
			   $self->{'match'});
	print "&nbsp;&nbsp;",
	      "<input type=submit value='$self->{'text_hash'}->{'view_searchok'}'></td>\n";
	print "</form>\n";

	print "<form action=view_table.cgi>\n";
	print $self->ui_hidden("db", $self->{'in_hash'}->{'db'});
	print $self->ui_hidden("table", $self->{'in_hash'}->{'table'});
	print "<td align=right><input type=submit value='$self->{'text_hash'}->{'view_jump'}'> ";
	print "<input name=jump size=6></td></form>\n";

	print "</tr><tr>\n";

	print "<form action=search_form.cgi>\n";
	print $self->ui_hidden("db", $self->{'in_hash'}->{'db'});
	print $self->ui_hidden("table", $self->{'in_hash'}->{'table'});
	print "<td><input type=submit value='$self->{'text_hash'}->{'view_adv'}'></td>\n";
	print "</form>\n";

	print "</tr> </table>\n";
	}

if ($self->{'access_hash'}->{'edonly'}) {
	$self->ui_print_footer("edit_dbase.cgi?db=$self->{'in_hash'}->{'db'}",$self->{'text_hash'}->{'dbase_return'},
		"", $self->{'text_hash'}->{'index_return'});
	}
else {
	$self->ui_print_footer("edit_table.cgi?db=$self->{'in_hash'}->{'db'}&table=".
			 $self->urlize($self->{'in_hash'}->{'table'}),
			$self->{'text_hash'}->{'table_return'},
			"edit_dbase.cgi?db=$self->{'in_hash'}->{'db'}", $self->{'text_hash'}->{'dbase_return'},
			"", $self->{'text_hash'}->{'index_return'});
	}

1;
		
}

# column_sort_link(name)
# Returns HTML for a link to switch sorting mode
sub column_sort_link
{
	shift if ($self == $_[0]);

local ($field) = @_;
local $dir = $self->{'in_hash'}->{'sortfield'} eq $field ? !$self->{'in_hash'}->{'sortdir'} : 0;
local $img = $self->{'in_hash'}->{'sortfield'} eq $field && $dir ? "sortascgrey.gif" :
	     $self->{'in_hash'}->{'sortfield'} eq $field && !$dir ? "sortdescgrey.gif" :
	     $dir ? "sortasc.gif" : "sortdesc.gif";
return "<table cellpadding=0 cellspacing=0><tr><td><a href='view_table.cgi?db=$self->{'in_hash'}->{'db'}&table=".
       $self->urlize($self->{'in_hash'}->{'table'})."&start=$self->{'in_hash'}->{'start'}&sortfield=$field&sortdir=$dir$self->{'searchargs'}'>".
       "<b>$field</b></td><td align=right><img valign=middle src=../images/$img border=0></td>".
       "</tr></table>";
}


1;

