#!/usr/bin/perl
package net::Log_parser;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'net::Log_parser');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# log_parser.pl
# Functions for parsing this module's logs

&ModuleLoader::preload_module(ref($self), "net::NetLib");
$self = new net::NetLib:: ref($self), %$self; 

1;
		return $self;
}

# parse_webmin_log(user, script, action, type, object, &params)
# Converts logged information from this module into human-readable form
sub parse_webmin_log
{
	my $self = shift;

local ($user, $script, $action, $type, $object, $p) = @_;
if ($type eq 'host') {
	return $self->text("log_${action}_host", "<tt>$object</tt>");
	}
elsif ($type eq 'ipnode') {
	return $self->text("log_${action}_ipnode", "<tt>$object</tt>");
	}
elsif ($type eq 'hosts' || $type eq 'aifcs' || $type eq 'bifcs') {
	return $self->text("log_${action}_${type}", $object);
	}
elsif ($action eq 'dns') {
	return $self->{'text_hash'}->{'log_dns'};
	}
elsif ($action eq 'routes') {
	return $self->{'text_hash'}->{'log_routes'};
	}
elsif ($type eq 'aifc' || $type eq 'bifc') {
	return $self->text("log_${action}_${type}", "<tt>$object</tt>",
		     $p->{'dhcp'} || $p->{'bootp'} ? $self->{'text_hash'}->{'log_dyn'} :
		     "<tt>$p->{'address'}</tt>");
	}
elsif ($type eq 'route' && $action eq 'create') {
	if ($object) {
		return $self->text('log_create_route',
			     "<tt>".$self->html_escape($object)."</tt>");
		}
	else {
		return $self->text('log_create_defroute');
		}
	}
elsif ($type eq 'routes' && $action eq 'delete') {
	return $self->text('log_delete_routes', $object);
	}
else {
	return undef;
	}
}


1;

