#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Create a new active route

&ModuleLoader::preload_module('net_class', "net::NetLib");
$self = new net::NetLib:: 'net_class',%$self;

$self->{'access_hash'}->{'routes'} || $self->error($self->{'text_hash'}->{'routes_ecannot'});
$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'routes_cerr'});

# Validate and parse inputs
$self->{'route'} = { };
$self->{'in_hash'}->{'dest_def'} || $self->check_ipaddress($self->{'in_hash'}->{'dest'}) ||
	$self->error($self->{'text_hash'}->{'routes_ecdest'});
$self->{'route'}->{'dest'} = $self->{'in_hash'}->{'dest_def'} ? undef : $self->{'in_hash'}->{'dest'};
$self->{'in_hash'}->{'netmask_def'} || $self->check_ipaddress($self->{'in_hash'}->{'netmask'}) ||
	$self->error($self->{'text_hash'}->{'routes_ecnetmask'});
if ($self->{'in_hash'}->{'dest_def'}) {
	$self->{'in_hash'}->{'netmask_def'} || $self->error($self->{'text_hash'}->{'routes_ecnetmask2'});
	}
$self->{'route'}->{'netmask'} = $self->{'in_hash'}->{'netmask_def'} ? undef : $self->{'in_hash'}->{'netmask'};
if ($self->{'in_hash'}->{'via'}) {
	# Via gateway
	$self->check_ipaddress($self->{'in_hash'}->{'gateway'}) || $self->error($self->{'text_hash'}->{'routes_ecgw'});
	$self->{'route'}->{'gateway'} = $self->{'in_hash'}->{'gateway'};
	}
else {
	# Local interface
	$self->{'route'}->{'iface'} = $self->{'in_hash'}->{'iface'};
	}

# Create the route
$self->{'err'} = $self->create_route($self->{'route'});
$self->error($self->{'err'}) if ($self->{'err'});
$self->webmin_log("create", "route", $self->{'route'}->{'dest'}, $self->{'route'});
$self->redirect("list_routes.cgi");

1;
		
}


1;

