#!/usr/bin/perl

&MAIN();

 sub MAIN {
# list_ifcs.cgi
# List active and boot-time interfaces

&ModuleLoader::preload_module('net_class', "net::NetLib");
$self = new net::NetLib:: 'net_class',%$self;

$self->ReadParse();
$self->{'access_hash'}->{'ifcs'} || $self->error($self->{'text_hash'}->{'ifcs_ecannot'});
$self->{'allow_add'} = $self->can_create_iface() && !$self->{'noos_support_add_ifcs'};
$self->ui_print_header(undef, $self->{'text_hash'}->{'ifcs_title'}, "");

# Show interfaces that are currently active
@{$self->{'act_array'}} = $self->active_interfaces();
if (!$self->{'access_hash'}->{'bootonly'}) {
	# Table heading and links
	print $self->ui_subheading($self->{'text_hash'}->{'ifcs_now'});
	local @tds;
	@{$self->{'links_array'}} = ( );
	if ($self->{'access_hash'}->{'ifcs'} >= 2) {
		print $self->ui_form_start("delete_aifcs.cgi", "post");
		push(@{$self->{'links_array'}}, $self->select_all_link("d"),
			     $self->select_invert_link("d") );
		push(@tds, "width=5");
		}
	push(@tds, "width=20%", "width=20%", "width=20%", "width=20%");
	if ($self->{'allow_add'}) {
		push(@{$self->{'links_array'}},
		     "<a href='edit_aifc.cgi?new=1'>$self->{'text_hash'}->{'ifcs_add'}</a>");
		}
	print $self->ui_links_row(\@{$self->{'links_array'}});
	print $self->ui_columns_start([ $self->{'access_hash'}->{'ifcs'} >= 2 ? ( "" ) : ( ),
				  $self->{'text_hash'}->{'ifcs_name'},
				  $self->{'text_hash'}->{'ifcs_type'},
				  $self->{'text_hash'}->{'ifcs_ip'},
				  $self->{'text_hash'}->{'ifcs_mask'},
				  $self->{'text_hash'}->{'ifcs_status'} ], 100, 0, \@tds);

	# Show table of interfaces
	@{$self->{'act_array'}} = sort { $self->{'a'} = $a; $self->{'b'} = $b; &iface_sort } @{$self->{'act_array'}};
	foreach $a (@{$self->{'act_array'}}) {
		next if ($self->{'access_hash'}->{'hide'} &&	# skip hidden
			 (!$a->{'edit'} || !$self->can_iface($a)));
		local $mod = $self->module_for_interface($a);
		local %minfo = $mod ? $self->get_module_info($mod->{'module'}) : ( );
		local @cols;
		if ($a->{'edit'} && $self->can_iface($a)) {
			push(@cols,
			    "<a href=\"edit_aifc.cgi?idx=$a->{'index'}\">".
			    $self->html_escape($a->{'fullname'})."</a>");
			}
		elsif (!$a->{'edit'} && $mod) {
			push(@cols,
			   "<a href=\"mod_aifc.cgi?idx=$a->{'index'}\">".
			   $self->html_escape($a->{'fullname'})."</a>");
			}
		else {
			push(@cols, $self->html_escape($a->{'fullname'}));
			}
		if ($a->{'virtual'} ne "") {
			$cols[0] = "&nbsp;&nbsp;".$cols[0];
			}
		push(@cols, $self->iface_type($a->{'name'}).
		      ($a->{'virtual'} eq "" ||
		       $mod ? "" : " ($self->{'text_hash'}->{'ifcs_virtual'})").
		      (%minfo ? " ($minfo{'desc'})" : ""));
		push(@cols, $self->html_escape($a->{'address'}));
		push(@cols, $self->html_escape($a->{'netmask'}));
		push(@cols, $a->{'up'} ? $self->{'text_hash'}->{'ifcs_up'} :
			"<font color=#ff0000>$self->{'text_hash'}->{'ifcs_down'}</font>");
		if ($a->{'edit'} && $self->can_iface($a)) {
			print $self->ui_checked_columns_row(\@cols, \@tds, "d",
						      $a->{'fullname'});
			}
		else {
			print $self->ui_columns_row([ "", @cols ], \@tds);
			}
		}
	print $self->ui_columns_end();
	print $self->ui_links_row(\@{$self->{'links_array'}});
	if ($self->{'access_hash'}->{'ifcs'} >= 2) {
		print $self->ui_form_end([ [ "delete", $self->{'text_hash'}->{'index_delete1'} ] ]);
		}
	print "<hr>\n";
	}

# Show interfaces that get activated at boot
print $self->ui_subheading($self->{'text_hash'}->{'ifcs_boot'});
print $self->ui_form_start("delete_bifcs.cgi", "post");
@{$self->{'links_array'}} = ( $self->select_all_link("b", 1),
	   $self->select_invert_link("b", 1) );
if ($self->{'allow_add'}) {
	push(@{$self->{'links_array'}}, "<a href='edit_bifc.cgi?new=1'>$self->{'text_hash'}->{'ifcs_add'}</a>");
	}
if ($self->{'allow_add'} && $self->UNIVERSAL::can('supports_ranges') && $self->supports_ranges()) {
	push(@{$self->{'links_array'}}, "<a href='edit_range.cgi?new=1'>$self->{'text_hash'}->{'ifcs_radd'}</a>");
	}
print $self->ui_links_row(\@{$self->{'links_array'}});
@tds = ( "width=5", "width=20%", "width=20%", "width=20%",
	 "width=20%", "width=20%");
print $self->ui_columns_start([ "",
			  $self->{'text_hash'}->{'ifcs_name'},
			  $self->{'text_hash'}->{'ifcs_type'},
			  $self->{'text_hash'}->{'ifcs_ip'},
			  $self->{'text_hash'}->{'ifcs_mask'},
			  $self->{'text_hash'}->{'ifcs_act'} ], 100, 0, \@tds);

@{$self->{'boot_array'}} = $self->boot_interfaces();
@{$self->{'boot_array'}} = sort { $self->{'a'} = $a; $self->{'b'} = $b; &iface_sort } @{$self->{'boot_array'}};
foreach $a (@{$self->{'boot_array'}}) {
	local $can = $a->{'edit'} && $self->can_iface($a);
	next if ($self->{'access_hash'}->{'hide'} && !$can);	# skip hidden
	local @cols;
	local @mytds = @tds;
	if ($a->{'range'} ne "") {
		# A range of addresses
		local $rng = $self->text('ifcs_range', $a->{'range'});
		if ($can) {
			push(@cols, "<a href=\"edit_range.cgi?idx=$a->{'index'}\">".$self->html_escape($rng)."</a>");
			}
		else {
			push(@cols, $self->html_escape($rng));
			}
		push(@cols, $self->iface_type($a->{'name'}));
		push(@cols, "$a->{'start'} - $a->{'end'}");
		splice(@mytds, 3, 2, "colspan=2 width=40%");
		}
	else {
		# A normal single interface
		local $mod = $self->module_for_interface($a);
		local %minfo = $mod ? $self->get_module_info($mod->{'module'}) : ( );
		if ($can) {
			push(@cols, "<a href='edit_bifc.cgi?idx=$a->{'index'}'>"
				    .$self->html_escape($a->{'fullname'})."</a>");
			}
		else {
			push(@cols, $self->html_escape($a->{'fullname'}));
			}
		if ($a->{'virtual'} ne "") {
			$cols[0] = "&nbsp;&nbsp;".$cols[0];
			}
		push(@cols, $self->iface_type($a->{'name'}).
		     ($a->{'virtual'} eq "" ||
		      $mod ? "" : " ($self->{'text_hash'}->{'ifcs_virtual'})").
		     (%minfo ? " ($minfo{'desc'})" : ""));
		push(@cols, $a->{'bootp'} ? $self->{'text_hash'}->{'ifcs_bootp'} :
			    $a->{'dhcp'} ? $self->{'text_hash'}->{'ifcs_dhcp'} :
			    $a->{'address'} ? $self->html_escape($a->{'address'}) :
					       $self->{'text_hash'}->{'ifcs_auto'});
		push(@cols, $a->{'netmask'} ? $self->html_escape($a->{'netmask'})
					    : $self->{'text_hash'}->{'ifcs_auto'});
		}
	push(@cols, $a->{'up'} ? $self->{'text_hash'}->{'yes'} : $self->{'text_hash'}->{'no'});
	if ($can) {
		print $self->ui_checked_columns_row(\@cols, \@mytds, "b",
					      $a->{'fullname'});
		}
	else {
		print $self->ui_columns_row([ "", @cols ], \@tds);
		}
	}
print $self->ui_columns_end();
print $self->ui_links_row(\@{$self->{'links_array'}});
print $self->ui_form_end([ [ "delete", $self->{'text_hash'}->{'index_delete2'} ],
		     [ "deleteapply", $self->{'text_hash'}->{'index_delete3'} ],
		     undef,
		     [ "apply", $self->{'text_hash'}->{'index_apply2'} ] ]);

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}

sub iface_sort
{
	shift if ($self == $_[0]);

return $a->{'name'} cmp $self->{'b'}->{'name'} if ($a->{'name'} cmp $self->{'b'}->{'name'});
return $a->{'virtual'} eq '' ? -1 :
       $self->{'b'}->{'virtual'} eq '' ? 1 : $a->{'virtual'} <=> $self->{'b'}->{'virtual'};
}


1;

