#!/usr/bin/perl

&MAIN();

 sub MAIN {
# list_routes.cgi
# List boot-time routing configuration

&ModuleLoader::preload_module('net_class', "net::NetLib");
$self = new net::NetLib:: 'net_class',%$self;

$self->{'access_hash'}->{'routes'} || $self->error($self->{'text_hash'}->{'routes_ecannot'});
$self->ReadParse();
$self->ui_print_header(undef, $self->{'text_hash'}->{'routes_title'}, "");

# Show boot-time routes
print "<form action=save_routes.cgi method=post>\n";
print "<table border>\n";
print "<tr $self->{'tb'}> <td><b>",
      $self->{'routes_active_now'}? $self->{'text_hash'}->{'routes_now'} : $self->{'text_hash'}->{'routes_boot'},
      "</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table>\n";
$self->routing_input();
print "</table></td></tr></table>\n";
printf "<input type=submit value=\"%s\">\n",
    ($self->{'routes_active_now'}?  $self->{'text_hash'}->{'bifc_apply'} : $self->{'text_hash'}->{'save'})
	if ($self->{'access_hash'}->{'routes'} == 2);
print "</form>\n";

# Show routes active now
print "<hr>\n";
if ($self->UNIVERSAL::can('list_routes')) {
	if ($self->UNIVERSAL::can('delete_route')) {
		# With deletion button
		print $self->ui_form_start("delete_routes.cgi", "post");
		}
	print $self->ui_subheading($self->{'text_hash'}->{'routes_active'});
	local @tds = $self->UNIVERSAL::can('delete_route') ? ( "width=5" ) : ( );
	print $self->ui_columns_start([ $self->UNIVERSAL::can('delete_route') ? ( "" ) : ( ),
				  $self->{'text_hash'}->{'routes_dest'},
				  $self->{'text_hash'}->{'routes_gw'},
				  $self->{'text_hash'}->{'routes_mask'},
				  $self->{'text_hash'}->{'routes_iface'} ], undef, 0, \@tds);
	$self->{'i'} = 0;
	foreach $route ($self->list_routes()) {
		local @cols = (
			$route->{'dest'} eq "0.0.0.0" ? $self->{'text_hash'}->{'routes_def'}
						      : $route->{'dest'},
			$route->{'gateway'} eq "0.0.0.0" ? $self->{'text_hash'}->{'routes_nogw'}
							 : $route->{'gateway'},
			$route->{'netmask'} eq "0.0.0.0" ? ""
							 : $route->{'netmask'},
			$route->{'iface'} || $self->{'text_hash'}->{'routes_any'},
			);
		if ($self->UNIVERSAL::can('delete_route')) {
			print $self->ui_checked_columns_row(\@cols, \@tds, "d", $self->{'i'}++);
			}
		else {
			print $self->ui_columns_row(\@cols, \@tds);
			}
		}
	print $self->ui_columns_end();
	if ($self->UNIVERSAL::can('delete_route')) {
		print $self->ui_form_end([ [ "delete", $self->{'text_hash'}->{'routes_delete'} ] ]);
		}
	}

# Show form to add a route
if ($self->UNIVERSAL::can('create_route')) {
	print $self->ui_form_start("create_route.cgi", "post");
	print $self->ui_table_start($self->{'text_hash'}->{'routes_cheader'}, undef, 2);

	print $self->ui_table_row($self->{'text_hash'}->{'routes_cdest'},
			    $self->ui_opt_textbox("dest", undef, 30,
					    $self->{'text_hash'}->{'routes_cdef'}));

	print $self->ui_table_row($self->{'text_hash'}->{'routes_cnetmask'},
			    $self->ui_opt_textbox("netmask", "255.255.255.255", 30,
					    $self->{'text_hash'}->{'default'}));

	$self->{'ciface'} = $self->ui_select("iface", undef,
		     [ map { [ $_->{'fullname'} ] }
			   grep { $_->{'virtual'} eq '' } $self->boot_interfaces() ]);
	$self->{'cgateway'} = $self->ui_textbox("gateway", undef, 30);
	print $self->ui_table_row($self->{'text_hash'}->{'routes_cvia'},
	    $self->ui_radio("via", 0, [ [ 0, $self->text('routes_ciface', $self->{'ciface'}) ],
				  [ 1, $self->text('routes_cgw', $self->{'cgateway'}) ] ]));

	print $self->ui_table_end();
	print $self->ui_form_end([ [ "create", $self->{'text_hash'}->{'create'} ] ]);
	}

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

