#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_aifc.cgi
# Save, create or delete an active interface

&ModuleLoader::preload_module('net_class', "net::NetLib");
$self = new net::NetLib:: 'net_class',%$self;

$self->ReadParse();
@{$self->{'acts_array'}} = $self->active_interfaces();

if ($self->{'in_hash'}->{'delete'}) {
	# delete an interface
	$self->error_setup($self->{'text_hash'}->{'aifc_err1'});
	$self->{'a'} = $self->{'acts_array'}->[$self->{'in_hash'}->{'idx'}];
	$self->can_iface($self->{'a'}) || $self->error($self->{'text_hash'}->{'ifcs_ecannot_this'});
	$self->deactivate_interface($self->{'a'});
	$self->webmin_log("delete", "aifc", $self->{'a'}->{'fullname'}, $self->{'a'});
	}
else {
	# Validate and save inputs
	$self->error_setup($self->{'text_hash'}->{'aifc_err2'});
	if (!$self->{'in_hash'}->{'new'}) {
		$self->{'olda'} = $self->{'acts_array'}->[$self->{'in_hash'}->{'idx'}];
		$self->can_iface($self->{'olda'}) || $self->error($self->{'text_hash'}->{'ifcs_ecannot_this'});
		$self->{'a'}->{'name'} = $self->{'olda'}->{'name'};
		$self->{'a'}->{'virtual'} = $self->{'olda'}->{'virtual'}
			if (defined($self->{'olda'}->{'virtual'}));
		}
	elsif (defined($self->{'in_hash'}->{'virtual'})) {
		# creating a virtual interface
		$self->{'in_hash'}->{'virtual'} =~ /^\d+$/ ||
			$self->error($self->{'text_hash'}->{'aifc_evirt'});
		$self->{'in_hash'}->{'virtual'} >= $self->{'min_virtual_number'} ||
			$self->error($self->text('aifc_evirtmin', $self->{'min_virtual_number'}));
		foreach $ea (@{$self->{'acts_array'}}) {
			if ($ea->{'name'} eq $self->{'in_hash'}->{'name'} &&
			    $ea->{'virtual'} eq $self->{'in_hash'}->{'virtual'}) {
				$self->error($self->text('aifc_evirtdup',
				       "$self->{'in_hash'}->{'name'}:$self->{'in_hash'}->{'virtual'}"));
				}
			}
		$self->{'a'}->{'name'} = $self->{'in_hash'}->{'name'};
		$self->{'a'}->{'virtual'} = $self->{'in_hash'}->{'virtual'};
		$self->can_create_iface() || $self->error($self->{'text_hash'}->{'ifcs_ecannot'});
		$self->can_iface($self->{'a'}) || $self->error($self->{'text_hash'}->{'ifcs_ecannot'});
		}
	elsif ($self->{'in_hash'}->{'name'} =~ /^([a-z]+\d*(\.\d+)?):(\d+)$/) {
		# also creating a virtual interface
		foreach $ea (@{$self->{'acts_array'}}) {
			if ($ea->{'name'} eq $1 &&
			    $ea->{'virtual'} eq $3) {
				$self->error($self->text('aifc_evirtdup', $self->{'in_hash'}->{'name'}));
				}
			}
		$3 >= $self->{'min_virtual_number'} ||
			$self->error($self->text('aifc_evirtmin', $self->{'min_virtual_number'}));
		$self->{'a'}->{'name'} = $1;
		$self->{'a'}->{'virtual'} = $3;
		$self->can_create_iface() || $self->error($self->{'text_hash'}->{'ifcs_ecannot'});
		$self->can_iface($self->{'a'}) || $self->error($self->{'text_hash'}->{'ifcs_ecannot'});
		}
	elsif ($self->{'in_hash'}->{'name'} =~ /^[a-z]+\d*(\.\d+)?$/) {
		# creating a real interface
		foreach $ea (@{$self->{'acts_array'}}) {
			if ($ea->{'name'} eq $self->{'in_hash'}->{'name'}) {
				$self->error($self->text('aifc_edup', $self->{'in_hash'}->{'name'}));
				}
			}
		$self->{'a'}->{'name'} = $self->{'in_hash'}->{'name'};
		$self->can_create_iface() || $self->error($self->{'text_hash'}->{'ifcs_ecannot'});
		$self->can_iface($self->{'a'}) || $self->error($self->{'text_hash'}->{'ifcs_ecannot'});
		}
	else {
		$self->error($self->{'text_hash'}->{'aifc_ename'});
		}

	# Check for address clash
	$self->{'allow_clash'} = $self->UNIVERSAL::can('allow_interface_clash') ?
			$self->allow_interface_clash($self->{'a'}, 0) : 1;
	if (!$self->{'allow_clash'} &&
	    ($self->{'in_hash'}->{'new'} || $self->{'olda'}->{'address'} ne $self->{'a'}->{'address'})) {
		($self->{'clash'}) = grep { $_->{'address'} eq $self->{'a'}->{'address'} } @{$self->{'acts_array'}};
		$self->{'clash'} && $self->error($self->text('aifc_eclash', $self->{'clash'}->{'fullname'}));
		}

	# Validate and store inputs
	$self->check_ipaddress($self->{'in_hash'}->{'address'}) ||
		$self->error($self->text('aifc_eip', $self->{'in_hash'}->{'address'}));
	$self->{'a'}->{'address'} = $self->{'in_hash'}->{'address'};

	if ($self->{'virtual_netmask'} && $self->{'a'}->{'virtual'} ne "") {
		# Always use this netmask for virtuals
		$self->{'a'}->{'netmask'} = $self->{'virtual_netmask'};
		}
	elsif (!$self->{'access_hash'}->{'netmask'}) {
		# Use default netmask
		$self->{'a'}->{'netmask'} = $self->{'in_hash'}->{'new'} ?
			$self->{'config_hash'}->{'def_netmask'} || "255.255.255.0" :
			$self->{'olda'}->{'netmask'};
		}
	elsif (!$self->{'in_hash'}->{'netmask_def'}) {
		$self->check_ipaddress($self->{'in_hash'}->{'netmask'}) ||
			$self->error($self->text('aifc_emask', $self->{'in_hash'}->{'netmask'}));
		$self->{'a'}->{'netmask'} = $self->{'in_hash'}->{'netmask'};
		}

	if (!$self->{'access_hash'}->{'broadcast'}) {
		# Compute broadcast
		$self->{'a'}->{'netmask'} = $self->{'in_hash'}->{'new'} ?
			$self->compute_broadcast($self->{'a'}->{'address'}, $self->{'a'}->{'netmask'}) :
			$self->{'olda'}->{'broadcast'};
		}
	elsif (!$self->{'in_hash'}->{'broadcast_def'}) {
		$self->check_ipaddress($self->{'in_hash'}->{'broadcast'}) ||
			$self->error($self->text('aifc_ebroad', $self->{'in_hash'}->{'broadcast'}));
		$self->{'a'}->{'broadcast'} = $self->{'in_hash'}->{'broadcast'};
		}

	if (!$self->{'access_hash'}->{'mtu'}) {
		# Use default MTU
		$self->{'a'}->{'mtu'} = $self->{'in_hash'}->{'new'} ? $self->{'config_hash'}->{'def_mtu'}
					 : $self->{'olda'}->{'mtu'};
		}
	elsif (!$self->{'in_hash'}->{'mtu_def'}) {
		$self->{'in_hash'}->{'mtu'} =~ /^\d+$/ ||
			$self->error($self->text('aifc_emtu', $self->{'in_hash'}->{'mtu'}));
		$self->{'a'}->{'mtu'} = $self->{'in_hash'}->{'mtu'} if ($self->{'olda'}->{'mtu'} ne $self->{'in_hash'}->{'mtu'});
		}

	if (!$self->{'access_hash'}->{'up'}) {
		$self->{'a'}->{'up'} = $self->{'in_hash'}->{'new'} ? 1 : $self->{'olda'}->{'up'};
		}
	elsif ($self->{'in_hash'}->{'up'}) {
		$self->{'a'}->{'up'}++;
		}

	if (!$self->{'in_hash'}->{'ether_def'} && $self->{'a'}->{'virtual'} eq "" &&
	    $self->iface_hardware($self->{'a'}->{'name'})) {
		$self->{'in_hash'}->{'ether'} =~ /^[A-Fa-f0-9:]+$/ ||
			$self->error($self->text('aifc_ehard', $self->{'in_hash'}->{'ether'}));
		$self->{'a'}->{'ether'} = $self->{'in_hash'}->{'ether'}
			if ($self->{'olda'}->{'ether'} ne $self->{'in_hash'}->{'ether'});
		}
	$self->{'a'}->{'fullname'} = $self->{'a'}->{'name'}.
			   ($self->{'a'}->{'virtual'} eq '' ? '' : ':'.$self->{'a'}->{'virtual'});

	# Bring it up
	$self->activate_interface($self->{'a'});
	$self->webmin_log($self->{'in_hash'}->{'new'} ? 'create' : 'modify',
		    "aifc", $self->{'a'}->{'fullname'}, $self->{'a'});
	}
$self->redirect("list_ifcs.cgi");

1;
		
}


1;

