#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_bifc.cgi
# Create, save or delete a boot-time interface

&ModuleLoader::preload_module('net_class', "net::NetLib");
$self = new net::NetLib:: 'net_class',%$self;

$self->ReadParse();
@{$self->{'boot_array'}} = $self->boot_interfaces();

if ($self->{'in_hash'}->{'delete'} || $self->{'in_hash'}->{'unapply'}) {
	# Delete interface
	$self->error_setup($self->{'text_hash'}->{'bifc_err1'});
	$self->{'b'} = $self->{'boot_array'}->[$self->{'in_hash'}->{'idx'}];
	$self->can_iface($self->{'b'}) || $self->error($self->{'text_hash'}->{'ifcs_ecannot_this'});

	if ($self->{'in_hash'}->{'unapply'}) {
		# Shut down this interface active (if active)
		$self->error_setup($self->{'text_hash'}->{'bifc_err4'});
		@{$self->{'active_array'}} = $self->active_interfaces();
		($self->{'act'}) = grep { $_->{'fullname'} eq $self->{'b'}->{'fullname'} } @{$self->{'active_array'}};
		if ($self->{'act'}) {
			if ($self->UNIVERSAL::can('unapply_interface')) {
				$self->{'err'} = $self->unapply_interface($self->{'act'});
				$self->{'err'} && $self->error("<pre>$self->{'err'}</pre>");
				}
			else {
				$self->deactivate_interface($self->{'act'});
				}
			}

		}
	$self->delete_interface($self->{'b'});
	$self->webmin_log("delete", "bifc", $self->{'b'}->{'fullname'}, $self->{'b'});
	}
else {
	# Save or create interface
	$self->error_setup($self->{'text_hash'}->{'bifc_err2'});
	if (!$self->{'in_hash'}->{'new'}) {
		# Modifying an interface
		$self->{'oldb'} = $self->{'boot_array'}->[$self->{'in_hash'}->{'idx'}];
		$self->can_iface($self->{'oldb'}) || $self->error($self->{'text_hash'}->{'ifcs_ecannot_this'});
		$self->{'b'}->{'name'} = $self->{'oldb'}->{'name'};
		$self->{'b'}->{'file'} = $self->{'oldb'}->{'file'};
		$self->{'b'}->{'gateway'} = $self->{'oldb'}->{'gateway'};
		$self->{'b'}->{'virtual'} = $self->{'oldb'}->{'virtual'}
			if (defined($self->{'oldb'}->{'virtual'}));
		$self->{'b'}->{'code'} = $self->{'oldb'}->{'code'};
		}
	elsif (defined($self->{'in_hash'}->{'virtual'})) {
		# creating a virtual interface
		$self->{'in_hash'}->{'virtual'} =~ /^\d+$/ ||
			$self->error($self->{'text_hash'}->{'bifc_evirt'});
		$self->{'in_hash'}->{'virtual'} >= $self->{'min_virtual_number'} ||
			$self->error($self->text('aifc_evirtmin', $self->{'min_virtual_number'}));
		foreach $eb (@{$self->{'boot_array'}}) {
			if ($eb->{'name'} eq $self->{'in_hash'}->{'name'} &&
			    $eb->{'virtual'} eq $self->{'in_hash'}->{'virtual'}) {
				$self->error($self->text('bifc_evirtdup',
				       "$self->{'in_hash'}->{'name'}:$self->{'in_hash'}->{'virtual'}"));
				}
			}
		$self->{'b'}->{'name'} = $self->{'in_hash'}->{'name'};
		$self->{'b'}->{'virtual'} = $self->{'in_hash'}->{'virtual'};
		$self->can_create_iface() || $self->error($self->{'text_hash'}->{'ifcs_ecannot'});
		$self->can_iface($self->{'b'}) || $self->error($self->{'text_hash'}->{'ifcs_ecannot'});
		}
	elsif ($self->{'in_hash'}->{'name'} =~ /^([a-z]+\d*(\.\d+)?):(\d+)$/) {
		# also creating a virtual interface
		foreach $eb (@{$self->{'boot_array'}}) {
			if ($eb->{'name'} eq $1 &&
			    $eb->{'virtual'} eq $3) {
				$self->error($self->text('bifc_evirtdup', $self->{'in_hash'}->{'name'}));
				}
			}
		$3 >= $self->{'min_virtual_number'} ||
			$self->error($self->text('aifc_evirtmin', $self->{'min_virtual_number'}));
		$self->{'b'}->{'name'} = $1;
		$self->{'b'}->{'virtual'} = $3;
		$self->can_create_iface() || $self->error($self->{'text_hash'}->{'ifcs_ecannot'});
		$self->can_iface($self->{'b'}) || $self->error($self->{'text_hash'}->{'ifcs_ecannot'});
		}
	elsif ($self->{'in_hash'}->{'name'} =~/^[a-z]+\d*(\.\d+)?$/) {
		# creating a real interface
		foreach $eb (@{$self->{'boot_array'}}) {
			if ($eb->{'fullname'} eq $self->{'in_hash'}->{'name'}) {
				$self->error($self->text('bifc_edup', $self->{'in_hash'}->{'name'}));
				}
			}
		$self->{'b'}->{'name'} = $self->{'in_hash'}->{'name'};
		$self->can_create_iface() || $self->error($self->{'text_hash'}->{'ifcs_ecannot'});
		$self->can_iface($self->{'b'}) || $self->error($self->{'text_hash'}->{'ifcs_ecannot'});
		}
	else {
		$self->error($self->{'text_hash'}->{'bifc_ename'});
		}

	# Check for address clash
	$self->{'allow_clash'} = $self->UNIVERSAL::can('allow_interface_clash') ?
			$self->allow_interface_clash($self->{'b'}, 1) : 1;
	if (!$self->{'allow_clash'} && $self->{'in_hash'}->{'mode'} eq 'address' &&
	    ($self->{'in_hash'}->{'new'} || $self->{'oldb'}->{'address'} ne $self->{'in_hash'}->{'address'})) {
		($self->{'clash'}) = grep { $_->{'address'} eq $self->{'in_hash'}->{'address'} &&
				  $_->{'up'} } @{$self->{'boot_array'}};
		$self->{'clash'} && $self->error($self->text('aifc_eclash', $self->{'clash'}->{'fullname'}));
		}

	# Validate and store inputs
	if ($self->{'in_hash'}->{'mode'} eq 'dhcp' || $self->{'in_hash'}->{'mode'} eq 'bootp') {
		$self->{'in_hash'}->{'activate'} && !$self->UNIVERSAL::can('apply_interface') &&
			$self->error($self->{'text_hash'}->{'bifc_eapply'});
		$self->{'b'}->{$self->{'in_hash'}->{'mode'}}++;
		$self->{'auto'}++;
		}
	else {
		$self->valid_boot_address($self->{'in_hash'}->{'address'}) ||
			$self->error($self->text('bifc_eip', $self->{'in_hash'}->{'address'}));
		$self->{'b'}->{'address'} = $self->{'in_hash'}->{'address'};
		}

	if ($self->{'virtual_netmask'} && $self->{'b'}->{'virtual'} ne "") {
		# Always use this netmask for virtuals
		$self->{'b'}->{'netmask'} = $self->{'virtual_netmask'};
		}
	elsif (!$self->{'access_hash'}->{'netmask'}) {
		# Use default netmask
		$self->{'b'}->{'netmask'} = $self->{'in_hash'}->{'new'} ?
			$self->{'config_hash'}->{'def_netmask'} || "255.255.255.0" :
			$self->{'oldb'}->{'netmask'};
		}
	elsif ($self->can_edit("netmask", $self->{'b'}) && $self->{'access_hash'}->{'netmask'}) {
		$self->{'auto'} && !$self->{'in_hash'}->{'netmask'} || $self->check_ipaddress($self->{'in_hash'}->{'netmask'}) ||
			$self->error($self->text('bifc_emask', $self->{'in_hash'}->{'netmask'}));
		$self->{'b'}->{'netmask'} = $self->{'in_hash'}->{'netmask'};
		}

	if (!$self->{'access_hash'}->{'broadcast'}) {
		# Work out broadcast
		$self->{'b'}->{'broadcast'} = $self->{'in_hash'}->{'new'} ? 
			$self->compute_broadcast($self->{'b'}->{'address'}, $self->{'b'}->{'netmask'}) :
			$self->{'oldb'}->{'broadcast'};
		}
	elsif ($self->can_edit("broadcast", $self->{'b'})) {
		$self->{'auto'} && !$self->{'in_hash'}->{'broadcast'} ||
			$self->check_ipaddress($self->{'in_hash'}->{'broadcast'}) ||
			$self->error($self->text('bifc_ebroad', $self->{'in_hash'}->{'broadcast'}));
		$self->{'b'}->{'broadcast'} = $self->{'in_hash'}->{'broadcast'};
		}

	if (!$self->{'access_hash'}->{'mtu'}) {
		# Use default MTU
		$self->{'b'}->{'mtu'} = $self->{'in_hash'}->{'new'} ? $self->{'config_hash'}->{'def_mtu'}
					 : $self->{'oldb'}->{'mtu'};
		}
	elsif ($self->can_edit("mtu", $self->{'b'}) && $self->{'access_hash'}->{'mtu'}) {
		$self->{'auto'} && !$self->{'in_hash'}->{'mtu'} ||
			$self->{'in_hash'}->{'mtu'} =~ /^\d*$/ ||
			$self->error($self->text('bifc_emtu', $self->{'in_hash'}->{'mtu'}));
		$self->{'b'}->{'mtu'} = $self->{'in_hash'}->{'mtu'};
		}

	if ($self->{'in_hash'}->{'new'} && !$self->{'access_hash'}->{'up'} ||
	    $self->can_edit("up", $self->{'b'}) && $self->{'in_hash'}->{'up'} && $self->{'access_hash'}->{'up'}) {
		$self->{'b'}->{'up'}++;
		}
	elsif (!$self->{'access_hash'}->{'up'}) {
		$self->{'b'}->{'up'} = $self->{'oldb'}->{'up'};
		}

	$self->{'b'}->{'fullname'} = $self->{'b'}->{'name'}.
			   ($self->{'b'}->{'virtual'} eq '' ? '' : ':'.$self->{'b'}->{'virtual'});
	$self->save_interface($self->{'b'});

	if ($self->{'in_hash'}->{'activate'}) {
		# Make this interface active (if possible)
		$self->error_setup($self->{'text_hash'}->{'bifc_err3'});
		$self->{'b'}->{'up'}++;
		$self->{'b'}->{'address'} = $self->to_ipaddress($self->{'b'}->{'address'});
		if ($self->UNIVERSAL::can('apply_interface')) {
			$self->{'err'} = $self->apply_interface($self->{'b'});
			$self->{'err'} && $self->error("<pre>$self->{'err'}</pre>");
			}
		else {
			$self->activate_interface($self->{'b'});
			}
		}
	$self->webmin_log($self->{'in_hash'}->{'new'} ? 'create' : 'modify',
		    "bifc", $self->{'b'}->{'fullname'}, $self->{'b'});
	}
$self->redirect("list_ifcs.cgi");

1;
		
}


1;

