#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_dns.cgi
# Save DNS client configuration

&ModuleLoader::preload_module('net_class', "net::NetLib");
$self = new net::NetLib:: 'net_class',%$self;

$self->{'access_hash'}->{'dns'} == 2 || $self->error($self->{'text_hash'}->{'dns_ecannot'});
$self->error_setup($self->{'text_hash'}->{'dns_err'});
$self->ReadParse();
$self->{'old_hostname'} = $self->get_system_hostname();

$self->{'in_hash'}->{'hostname'} =~ /^[A-z0-9\.\-]+$/ ||
	$self->error($self->text('dns_ehost', $self->{'in_hash'}->{'hostname'}));
$self->{'dns'} = { };
for($i=0; $i<$self->{'max_dns_servers'}; $i++) {
	$self->{'ns'} = $self->{'in_hash'}->{"nameserver_$i"};
	$self->{'ns'} =~ s/^\s+//; $self->{'ns'} =~ s/\s+$//;
	if ($self->{'ns'}) {
		$self->check_ipaddress($self->{'ns'}) ||
			$self->error($self->text('dns_ens', $self->{'ns'}));
		push(@{$self->{'dns'}->{'nameserver'}}, $self->{'ns'});
		}
	}
if ($self->{'in_hash'}->{'name0'}) {
    local $i = 0 ;
    local $namekey="name$i";
    while ($self->{'in_hash'}->{$namekey}) {
	$self->{'dns'}->{'name'}[$i] = $self->{'in_hash'}->{$namekey};
	local $nskey = "nameserver$i";
	local $j = -1;
	while (++$j < $self->{'max_dns_servers'}) {
	    $self->{'ns'} = $self->{'in_hash'}->{"${nskey}_$j"};
	    $self->{'ns'} =~ s/^\s+//; $self->{'ns'} =~ s/\s+$//;
	    if ($self->{'ns'}) {
		$self->check_ipaddress($self->{'ns'}) ||
		    $self->error($self->text('dns_ens', $self->{'ns'}));
		push(@{$self->{'dns'}->{$nskey}}, $self->{'ns'});
	    }
	}
	$i++;
	$namekey="name$i";
    }
}
if (!$self->{'in_hash'}->{'domain_def'}) {
	@{$self->{'dlist_array'}} = split(/\s+/, $self->{'in_hash'}->{'domain'});
	foreach $d (@{$self->{'dlist_array'}}) {
		$d =~ /^[A-z0-9\.\-]+$/ ||
			$self->error($self->text('dns_edomain', $d));
		push(@{$self->{'dns'}->{'domain'}}, $d);
		}
	@{$self->{'dlist_array'}}>0 || $self->error($self->{'text_hash'}->{'dns_esearch'});
	}
$self->parse_order($self->{'dns'});
$self->save_dns_config($self->{'dns'});
$self->save_hostname($self->{'in_hash'}->{'hostname'});

if ($self->{'in_hash'}->{'hosts'} && $self->{'in_hash'}->{'hostname'} ne $self->{'old_hostname'}) {
	# Update hostname in /etc/hosts too
	@{$self->{'hosts_array'}} = $self->list_hosts();
	foreach $h (@{$self->{'hosts_array'}}) {
		local $found = 0;
		foreach $n (@{$h->{'hosts'}}) {
			if (lc($n) eq lc($self->{'old_hostname'})) {
				$n = $self->{'in_hash'}->{'hostname'};
				$found++;
				}
			}
		$self->modify_host($h) if ($found);
		}

	# Update in ipnodes too
	@{$self->{'ipnodes_array'}} = $self->list_ipnodes();
	foreach $h (@{$self->{'ipnodes_array'}}) {
		local $found = 0;
		foreach $n (@{$h->{'ipnodes'}}) {
			if (lc($n) eq lc($self->{'old_hostname'})) {
				$n = $self->{'in_hash'}->{'hostname'};
				$found++;
				}
			}
		$self->modify_ipnode($h) if ($found);
		}
	}

$self->webmin_log("dns", undef, undef, \%{$self->{'in_hash'}});
$self->redirect("");

1;
		
}


1;

