#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Show a form for editing an LDAP switch

if (-r 'ldap-client-lib.pl') {
	require './ldap-client-lib.pl';
	}
else {
	&ModuleLoader::preload_module('nis_class', "nis::NisLib");
$self = new nis::NisLib:: 'nis_class',%$self;

	}
&ModuleLoader::preload_module('nis_class', "nis::SwitchLib");
$self = new nis::SwitchLib:: 'nis_class',%$self;

$self->ReadParse();
$self->ui_print_header(undef, $self->{'text_hash'}->{'eswitch_title'}, "");

# Get the current service
$self->{'conf'} = $self->get_nsswitch_config();
($self->{'switch'}) = grep { $_->{'name'} eq $self->{'in_hash'}->{'name'} } @{$self->{'conf'}};
$self->{'switch'} || $self->error($self->{'text_hash'}->{'eswitch_egone'});

print $self->ui_form_start("save_switch.cgi", "post");
print $self->ui_hidden("name", $self->{'in_hash'}->{'name'}),"\n";
print $self->ui_table_start($self->{'text_hash'}->{'eswitch_header'}, undef, 2);

# Show service name
$self->{'desc'} = $self->{'text_hash'}->{'desc_'.$self->{'switch'}->{'name'}};
print $self->ui_table_row($self->{'text_hash'}->{'eswitch_name'},
		    $self->{'desc'} ? "$self->{'desc'} ($self->{'switch'}->{'name'})" : $self->{'switch'}->{'name'});

# Show sources in order, with fallback modes for each
$self->{'i'} = 0;
($self->{'allsrcs'}, $self->{'allowed'}) = $self->list_switch_sources();
foreach $s (@{$self->{'switch'}->{'srcs'}}, { }) {
	@{$self->{'cansrcs_array'}} = grep { !$self->{'allowed'}->{$_} ||
			  $self->indexof($self->{'switch'}->{'name'}, @{$self->{'allowed'}->{$_}}) >= 0 }
			@{$self->{'allsrcs'}};
	$self->{'stable'} = $self->ui_select("src_$self->{'i'}", $s->{'src'},
		[ [ "", "&lt;$self->{'text_hash'}->{'eswitch_none'}&gt;" ],
		  map { [ $_, $self->{'text_hash'}->{'order_'.$_} || $_ ] } @{$self->{'cansrcs_array'}} ],
		1, 0, 1)."<br>\n";
	$self->{'stable'} .= "<table>\n";
	foreach $st ($self->list_switch_statuses()) {
		$self->{'stable'} .= "<tr> <td>".$self->{'text_hash'}->{'eswitch_'.$st}."</td>\n";
		@{$self->{'acts_array'}} = $self->list_switch_actions($st);
		$self->{'stable'} .= "<td>".$self->ui_select(
			"status_".$st."_".$self->{'i'}, $s->{$st},
			[ [ "", "&lt;$self->{'text_hash'}->{'default'}&gt;" ],
			  map { [ $_, $self->{'text_hash'}->{'eswitch_'.$_} ] } @{$self->{'acts_array'}} ]).
			   "</td> </tr>\n";		 
		}
	$self->{'stable'} .= "</table>\n";
	print $self->ui_table_row($self->{'text_hash'}->{'eswitch_'.$self->{'i'}} ||
			    $self->text('eswitch_nth', $self->{'i'}+1), $self->{'stable'});
	$self->{'i'}++;
	}

print $self->ui_table_end();
print $self->ui_form_end([ [ "save", $self->{'text_hash'}->{'save'} ] ]);

$self->ui_print_footer("list_switches.cgi", $self->{'text_hash'}->{'switch_return'});

1;
		
}


1;

