#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_tables.cgi
# Allow the selection of and display a NIS table for editing

&ModuleLoader::preload_module('nis_class', "nis::NisLib");
$self = new nis::NisLib:: 'nis_class',%$self;

$self->ui_print_header(undef, $self->{'text_hash'}->{'tables_title'}, "");
$self->ReadParse();

$self->{'mode'} = $self->get_server_mode();
if ($self->{'mode'} == 0 || !($self->get_nis_support() & 2)) {
	print "<p>$self->{'text_hash'}->{'tables_emaster'}<p>\n";
	$self->ui_print_footer("", $self->{'text_hash'}->{'index'});
	exit;
	}
elsif ($self->{'mode'} == 2) {
	print "<p>$self->{'text_hash'}->{'tables_eslave'}<p>\n";
	$self->ui_print_footer("", $self->{'text_hash'}->{'index'});
	exit;
	}

@{$self->{'tables_array'}} = $self->list_nis_tables();
@{$self->{'domains_array'}} = $self->unique(map { $_->{'domain'} } @{$self->{'tables_array'}});
$self->{'in_hash'}->{'table'} = int($self->{'in_hash'}->{'table'});

print "<form action=edit_tables.cgi method=post>\n";
print "<input type=submit value='$self->{'text_hash'}->{'tables_switch'}'>\n";
print "<select name=table>\n";
foreach $t (@{$self->{'tables_array'}}) {
	$t->{'desc'} = $self->{'text_hash'}->{"desc_".$t->{'table'}};
	$t->{'desc'} = $t->{'table'} if (!$t->{'desc'});
	$t->{'desc'} .= " ($t->{'domain'})" if (@{$self->{'domains_array'}} > 1);
	printf "<option value=%d %s>%s\n",
		$t->{'index'}, $self->{'in_hash'}->{'table'} eq $t->{'index'} ? 'selected' : '',
		$t->{'desc'};
	}
print "</select></form>\n";

$t = $self->{'tables_array'}->[$self->{'in_hash'}->{'table'}];
$self->{'type'} = $self->{'in_hash'}->{'text'} ? undef : $t->{'type'};
print "<b>",$self->text('tables_header', $t->{'desc'},
		   "<tt>".join(" ", @{$t->{'files'}})."</tt>"),"</b><p>\n";
if ($self->{'type'} eq 'hosts') {
	&show_nis_table([ $self->{'text_hash'}->{'hosts_ip'},
			  $self->{'text_hash'}->{'hosts_name'} ],
			$t, '\s+', [ 0, 1 ]);
	}
elsif ($self->{'type'} eq 'networks') {
	&show_nis_table([ $self->{'text_hash'}->{'networks_name'},
			  $self->{'text_hash'}->{'networks_ip'} ],
			$t, '\s+', [ 0, 1 ]);
	}
elsif ($self->{'type'} eq 'group' || $self->{'type'} eq 'group_shadow') {
	&show_nis_table([ $self->{'text_hash'}->{'group_name'},
			  $self->{'text_hash'}->{'group_gid'},
			  $self->{'text_hash'}->{'group_members'} ],
			$t, ':', [ 0, 2, 3 ], "width=100%");
	}
elsif ($self->{'type'} eq 'passwd_shadow' || $self->{'type'} eq 'passwd_shadow_full' ||
       $self->{'type'} eq 'passwd') {
	&show_nis_table([ $self->{'text_hash'}->{'passwd_name'},
			  $self->{'text_hash'}->{'passwd_uid'},
			  $self->{'text_hash'}->{'passwd_real'},
			  $self->{'text_hash'}->{'passwd_home'},
			  $self->{'text_hash'}->{'passwd_shell'} ],
			$t, ':', [ 0, 2, 4, 5, 6 ], "width=100%");
	}
elsif ($self->{'type'} eq 'services') {
	&show_nis_table([ $self->{'text_hash'}->{'services_name'},
			  $self->{'text_hash'}->{'services_proto'},
			  $self->{'text_hash'}->{'services_port'} ],
			$t, '[\s/]+', [ 0, 2, 1 ]);
	}
elsif ($self->{'type'} eq 'services2') {
	&show_nis_table([ $self->{'text_hash'}->{'services_name'},
			  $self->{'text_hash'}->{'services_proto'},
			  $self->{'text_hash'}->{'services_port'} ],
			$t, '[\s/]+', [ 0, 1, 2 ]);
	}
elsif ($self->{'type'} eq 'protocols') {
	&show_nis_table([ $self->{'text_hash'}->{'protocols_name'},
			  $self->{'text_hash'}->{'protocols_number'},
			  $self->{'text_hash'}->{'protocols_aliases'} ],
			$t, '\s+', [ 0, 1, -2 ]);
	}
elsif ($self->{'type'} eq 'netgroup') {
	&show_nis_table([ $self->{'text_hash'}->{'netgroup_name'},
			  $self->{'text_hash'}->{'netgroup_members'} ],
			$t, '\s+', [ 0, -1 ]);
	}
elsif ($self->{'type'} eq 'ethers') {
	&show_nis_table([ $self->{'text_hash'}->{'ethers_mac'},
			  $self->{'text_hash'}->{'ethers_ip'} ],
			$t, '\s+', [ 0, 1 ]);
	}
elsif ($self->{'type'} eq 'rpc') {
	&show_nis_table([ $self->{'text_hash'}->{'rpc_name'},
			  $self->{'text_hash'}->{'rpc_number'},
			  $self->{'text_hash'}->{'rpc_aliases'} ],
			$t, '\s+', [ 0, 1, -2 ]);
	}
elsif ($self->{'type'} eq 'netmasks') {
	&show_nis_table([ $self->{'text_hash'}->{'netmasks_net'},
			  $self->{'text_hash'}->{'netmasks_mask'} ],
			$t, '\s+', [ 0, 1 ]);
	}
elsif ($self->{'type'} eq 'aliases') {
	&show_nis_table([ $self->{'text_hash'}->{'aliases_from'},
			  $self->{'text_hash'}->{'aliases_to'} ],
			$t, '[\s:]+', [ 0, 1 ]);
	}
else {
	# Allow editing of file directly
	print "<form method=post action=save_file.cgi enctype=multipart/form-data>\n";
	print "<input type=hidden name=table value='$self->{'in_hash'}->{'table'}'>\n";
	$self->{'fnum'} = 0;
	foreach $f (@{$t->{'files'}}) {
		print "<table border>\n";
		print "<tr $self->{'tb'}> <td><b>",$self->text('tables_file', "<tt>$f</tt>"),
		      "</b></td> </tr>\n";
		print "<tr $self->{'cb'}> <td><textarea name=data_$self->{'fnum'} rows=20 cols=80>";
		open(FILE, $f);
		print <FILE>;
		close(FILE);
		print "</textarea></td></tr></table><br>\n";
		$self->{'fnum'}++;
		}
	print "<input type=submit value='$self->{'text_hash'}->{'tables_ok'}'></form>\n";
	}

if ($self->{'config_hash'}->{'manual_build'}) {
	print "<hr>\n";
	print "<table width=100%><tr>\n";
	print "<form action=build.cgi>\n";
	print "<input type=hidden name=table value='$self->{'in_hash'}->{'table'}'>\n";
	print "<td><input type=submit value='$self->{'text_hash'}->{'tables_build'}'></td>\n";
	print "<td>$self->{'text_hash'}->{'tables_buildmsg'}</td>\n";
	print "</form></tr></table>\n";
	}

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}

# show_nis_table(&headers, &table, splitter, &columns, params)
sub show_nis_table
{
	shift if ($self == $_[0]);

local @f = @{$_[1]->{'files'}};
local $lines = 0;
open(FILE, $f[0]);
while(<FILE>) {
	s/\r|\n//g;
	s/^\s*#.*$//;
	push(@{$self->{'lines_array'}}, $_);
	$lines++ if (/\S/);
	$self->{'empty'} = 0 if (/\S/);
	}
close(FILE);
if ($self->{'config_hash'}->{'max_size'} && $lines > $self->{'config_hash'}->{'max_size'}) {
	# Display a search form
	print "<form action=edit_tables.cgi>\n";
	print "<input type=hidden name=table value='$self->{'in_hash'}->{'table'}'>\n";
	local $sel = "<select name=field>\n";
	local $n = 0;
	foreach $f (@{$_[0]}) {
		$sel .= sprintf "<option value=%s %s>%s\n",
			$n, $self->{'in_hash'}->{'field'} == $n ? 'selected' : '', $f;
		$n++;
		}
	$sel .= "</select>\n";
	print $self->text('tables_find', $t->{'desc'}, $sel,
		    "<input name=what size=15 value='$self->{'in_hash'}->{'what'}'>"),
		    "&nbsp;&nbsp;&nbsp;\n";
	print "<input type=submit value='$self->{'text_hash'}->{'tables_search'}'></form>\n";
	}
if ($lines && (defined($self->{'in_hash'}->{'field'}) || !$self->{'config_hash'}->{'max_size'} ||
	       $lines <= $self->{'config_hash'}->{'max_size'})) {
	# Show table records
	print "<a href='edit_$t->{'type'}.cgi?table=$self->{'in_hash'}->{'table'}'>",
	      "$self->{'text_hash'}->{'tables_add'}</a><br>\n";
	print "<table border $_[4]>\n";
	print "<tr $self->{'tb'}> ",(map { "<td><b>$_</b></td>" } @{$_[0]}),"</tr>\n";
	local ($c, @c) = @{$_[3]};
	local $lnum = 0;
	local $matches = 0;
	foreach $l (@{$self->{'lines_array'}}) {
		local @r = split($_[2], $l);
		if ($l =~ /\S/ && (!defined($self->{'in_hash'}->{'field'}) ||
		    $r[$_[3]->[$self->{'in_hash'}->{'field'}]] =~ /$self->{'in_hash'}->{'what'}/i)) {
			print "<tr $self->{'cb'}><td><a href='edit_$t->{'type'}.cgi?",
			      "line=$lnum&table=$self->{'in_hash'}->{'table'}'>",
			      $self->html_escape($r[$c]),"</a></td>\n";
			foreach $i (@c) {
				if ($i < 0) {
					print "<td>",$self->html_escape(join(" ", @r[-$i .. $#r])),"<br></td>\n";
					}
				else {
					print "<td>",$self->html_escape($r[$i]),"<br></td>\n";
					}
				}
			$matches++;
			}
		$lnum++;
		}
	if (!$matches) {
		print "<tr $self->{'cb'}> <td colspan=",scalar(@{$_[3]}),">",
		      "$self->{'text_hash'}->{'tables_nomatch'}</td> </tr>\n";
		}
	print "</table>\n";
	}
else {
	print "<b>",$self->text('tables_none', $t->{'desc'}),"</b><p>\n";
	}
print "<a href='edit_$t->{'type'}.cgi?table=$self->{'in_hash'}->{'table'}'>",
      "$self->{'text_hash'}->{'tables_add'}</a>&nbsp;&nbsp;\n";
print "<a href='edit_tables.cgi?table=$self->{'in_hash'}->{'table'}&text=1'>",
      "$self->{'text_hash'}->{'tables_text'}</a><p>\n";
}


1;

