#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_passwd_shadow.cgi
# Edit a NIS password/shadow files entry

&ModuleLoader::preload_module('nis_class', "nis::NisLib");
$self = new nis::NisLib:: 'nis_class',%$self;

require 'timelocal.pl';
$self->ReadParse();
$self->ui_print_header(undef, $self->{'text_hash'}->{'passwd_title'}, "");

# Build list of available shells
@{$self->{'shlist_array'}} = ("/bin/sh", "/bin/csh", "/bin/false");
open(SHELLS, "/etc/shells");
while(<SHELLS>) {
	s/\r|\n//g;
	s/#.*$//;
	push(@{$self->{'shlist_array'}}, $_) if (/\S/);
	}
close(SHELLS);

($self->{'t'}, $self->{'lnums'}, $self->{'passwd'}, $shadow) =
	$self->table_edit_setup($self->{'in_hash'}->{'table'}, $self->{'in_hash'}->{'line'}, ':');
print "<form action=save_passwd_shadow.cgi>\n";
print "<input type=hidden name=table value='$self->{'in_hash'}->{'table'}'>\n";
print "<input type=hidden name=line value='$self->{'in_hash'}->{'line'}'>\n";

print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'passwd_header1'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'passwd_name'}</b></td>\n";
print "<td><input name=name size=10 value=\"$self->{'passwd'}->[0]\"></td>\n";

print "<td><b>$self->{'text_hash'}->{'passwd_uid'}</b></td>\n";
print "<td><input name=uid size=10 value=\"$self->{'passwd'}->[2]\"></td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'passwd_real'}</b></td>\n";
print "<td><input name=real size=20 value=\"$self->{'passwd'}->[4]\"></td>\n";

print "<td><b>$self->{'text_hash'}->{'passwd_home'}</b></td>\n";
print "<td><input name=home size=25 value=\"$self->{'passwd'}->[5]\"> ",
      $self->file_chooser_button("home", 1),"</td> </tr>\n";

print "<tr> <td valign=top><b>$self->{'text_hash'}->{'passwd_shell'}</b></td>\n";
print "<td valign=top><select name=shell>\n";
foreach $s ($self->unique(@{$self->{'shlist_array'}})) {
	printf "<option %s>%s\n",
		$self->{'passwd'}->[6] eq $s ? 'selected' : '', $s;
	$self->{'found'}++ if ($self->{'passwd'}->[6] eq $s);
	}
printf "<option %s>%s\n", $self->{'found'} ? '' : 'selected', $self->{'text_hash'}->{'passwd_other'};
print "</select><br>\n";
printf "<input name=other size=20 value='%s'> %s</td>\n",
	$self->{'found'} ? '' : $self->{'passwd'}->[6], $self->file_chooser_button("other");

%{$self->{'uconfig_hash'}} = $self->foreign_config("useradmin");
print "<td valign=top rowspan=2><b>$self->{'text_hash'}->{'passwd_pass'}</b></td> <td rowspan=2>\n";
printf"<input type=radio name=passmode value=0 %s> %s<br>\n",
	$self->{'passwd'}->[0] eq "" ? "checked" : "",
	$self->{'uconfig_hash'}->{'empty_mode'} ? $self->{'text_hash'}->{'passwd_none1'} : $self->{'text_hash'}->{'passwd_none2'};
printf"<input type=radio name=passmode value=1 %s> $self->{'text_hash'}->{'passwd_nologin'}<br>\n",
	$self->{'passwd'}->[0] eq $self->{'uconfig_hash'}->{'lock_string'} ? "checked" : "";
print "<input type=radio name=passmode value=3> $self->{'text_hash'}->{'passwd_clear'}\n";
printf "<input %s name=pass size=15><br>\n",
	$self->{'uconfig_hash'}->{'passwd_stars'} ? "type=password" : "";
printf "<input type=radio name=passmode value=2 %s> $self->{'text_hash'}->{'passwd_encrypted'}\n",
	$self->{'passwd'}->[0] && $self->{'passwd'}->[0] ne $self->{'uconfig_hash'}->{'lock_string'} ? "checked" :"";
printf "<input name=encpass size=13 value=\"%s\">\n",
	$self->{'passwd'}->[0] && $self->{'passwd'}->[0] ne $self->{'uconfig_hash'}->{'lock_string'} ? $self->{'pass'} : "";
print "</td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'passwd_gid'}</b></td>\n";
print "<td><input name=gid size=10 value='$self->{'passwd'}->[3]'></td> </tr>\n";

print "</table></td></tr></table><p>\n";
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'passwd_header2'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'passwd_change'}</b></td>\n";
if ($shadow->[2] && $shadow->[2] >= 0) {
	@{$self->{'tm_array'}} = localtime(timelocal(gmtime($shadow->[2] * 60*60*24)));
	printf "<td>%s/%s/%s</td>\n",
		$self->{'tm_array'}->[3], $self->{'text_hash'}->{"smonth_".($self->{'tm_array'}->[4]+1)}, $self->{'tm_array'}->[5]+1900;
	}
elsif ($self->{'in_hash'}->{'line'} eq "") { print "<td>$self->{'text_hash'}->{'passwd_never'}</td>\n"; }
else { print "<td>$self->{'text_hash'}->{'passwd_unknown'}</td>\n"; }

print "<td><b>$self->{'text_hash'}->{'passwd_expire'}</b></td>\n";
if ($shadow->[7] && $shadow->[7] >= 0) {
	@{$self->{'tm_array'}} = localtime($shadow->[7] * 60*60*24);
	$self->{'eday'} = $self->{'tm_array'}->[3];
	$self->{'emon'} = $self->{'tm_array'}->[4]+1;
	$self->{'eyear'} = $self->{'tm_array'}->[5]+1900;
	}
print "<td>";
$self->date_input($self->{'eday'}, $self->{'emon'}, $self->{'eyear'}, 'expire');
print "</td>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'passwd_min'}</b></td>\n";
printf "<td><input size=5 name=min value=\"%s\"></td>\n",
	$shadow->[3] < 0 ? "" : $shadow->[3];

print "<td><b>$self->{'text_hash'}->{'passwd_max'}</b></td>\n";
printf "<td><input size=5 name=max value=\"%s\"></td></tr>\n",
	$shadow->[4] < 0 ? "" : $shadow->[4];

print "<tr> <td><b>$self->{'text_hash'}->{'passwd_warn'}</b></td>\n";
printf "<td><input size=5 name=warn value=\"%s\"></td>\n",
	$shadow->[5] < 0 ? "" : $shadow->[5];

print "<td><b>$self->{'text_hash'}->{'passwd_inactive'}</b></td>\n";
printf "<td><input size=5 name=inactive value=\"%s\"></td></tr>\n",
	$shadow->[6] < 0 ? "" : $shadow->[6];

print "<input type=hidden name=flags value='$shadow->[8]'>\n";
print "</table></td></tr></table>\n";

if (defined($self->{'in_hash'}->{'line'})) {
	print "<input type=submit value='$self->{'text_hash'}->{'save'}'>\n";
	print "<input type=submit name=delete value='$self->{'text_hash'}->{'delete'}'>\n";
	}
else {
	print "<input type=submit value='$self->{'text_hash'}->{'create'}'>\n";
	}
print "</form>\n";
$self->ui_print_footer("edit_tables.cgi?table=$self->{'in_hash'}->{'table'}", $self->{'text_hash'}->{'tables_return'});

1;
		
}


1;

