#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_passwd_shadow.cgi
# Create, update or delete a password/shadow files entry

&ModuleLoader::preload_module('nis_class', "nis::NisLib");
$self = new nis::NisLib:: 'nis_class',%$self;

require 'timelocal.pl';
$self->ReadParse();

($self->{'t'}, $self->{'lnums'}, $passwd, $shadow) =
	$self->table_edit_setup($self->{'in_hash'}->{'table'}, $self->{'in_hash'}->{'line'}, ':');
if ($self->{'in_hash'}->{'delete'}) {
	# Just delete the user
	$self->table_delete($self->{'t'}, $self->{'lnums'});
	}
else {
	# Validate inputs and save the user
	$self->error_setup($self->{'text_hash'}->{'passwd_err'});
	$self->{'in_hash'}->{'name'} =~ /^[^: \t]+$/ || $self->error($self->{'text_hash'}->{'passwd_ename'});
	$self->{'in_hash'}->{'uid'} =~ /^\d+$/ || $self->error($self->{'text_hash'}->{'passwd_euid'});
	$self->{'in_hash'}->{'gid'} =~ /^\d+$/ || $self->error($self->{'text_hash'}->{'passwd_egid'});
	$self->{'in_hash'}->{'real'} =~ /^[^:]*$/ || $self->error($self->{'text_hash'}->{'passwd_ereal'});
	$self->{'in_hash'}->{'home'} =~ /^[^:]+$/ || $self->error($self->{'text_hash'}->{'passwd_ehome'});
	$self->{'in_hash'}->{'shell'} ne '' || $self->{'in_hash'}->{'other'} =~ /^[^:]+$/ ||
		$self->error($self->{'text_hash'}->{'passwd_eshell'});
	$self->{'in_hash'}->{'passmode'} != 2 || $self->{'in_hash'}->{'encpass'} =~ /^[^:]*$/ ||
		$self->error($self->{'text_hash'}->{'passwd_epass'});
	%{$self->{'uconfig_hash'}} = $self->foreign_config("useradmin");
	$self->{'salt'} = chr(int(rand(26))+65) . chr(int(rand(26))+65);
	@{$self->{'passwd_array'}} = ( $self->{'in_hash'}->{'name'}, 'x',
		    $self->{'in_hash'}->{'uid'}, $self->{'in_hash'}->{'gid'}, $self->{'in_hash'}->{'real'},
		    $self->{'in_hash'}->{'home'}, $self->{'in_hash'}->{'shell'} ? $self->{'in_hash'}->{'shell'} : $self->{'in_hash'}->{'other'} );
	$self->{'pass'} = $self->{'in_hash'}->{'passmode'} == 0 ? "" :
		$self->{'in_hash'}->{'passmode'} == 1 ? $self->{'uconfig_hash'}->{'lock_string'} :
		$self->{'in_hash'}->{'passmode'} == 2 ? $self->{'in_hash'}->{'encpass'} :
				       $self->unix_crypt($self->{'in_hash'}->{'pass'}, $self->{'salt'});
	if ($self->{'in_hash'}->{'mode'} == 2) {
		# Parse extra shadow inputs
		if ($self->{'in_hash'}->{'expired'} ne "" && $self->{'in_hash'}->{'expirem'} ne "" &&
		    $self->{'in_hash'}->{'expirey'} ne "") {
			eval { $self->{'expire'} = timelocal(0, 0, 12, $self->{'in_hash'}->{'expired'},
						   $self->{'in_hash'}->{'expirem'}-1,
						   $self->{'in_hash'}->{'expirey'}-1900) };
			$self->error($self->{'text_hash'}->{'passwd_eexpire'}) if ($@);
			$self->{'expire'} = int($self->{'expire'} / (60*60*24));
			}
		$self->{'in_hash'}->{'min'} =~ /^[0-9]*$/ || $self->error($self->{'text_hash'}->{'passwd_emin'});
		$self->{'in_hash'}->{'max'} =~ /^[0-9]*$/ || $self->error($self->{'text_hash'}->{'passwd_emax'});
		$self->{'in_hash'}->{'warn'} =~ /^[0-9]*$/ || $self->error($self->{'text_hash'}->{'passwd_ewarn'});
		$self->{'in_hash'}->{'inactive'} =~ /^[0-9]*$/ || $self->error($self->{'text_hash'}->{'passwd_einactive'});
		@{$self->{'shadow_array'}} = ( $self->{'in_hash'}->{'name'}, $self->{'pass'},
			    undef, $self->{'in_hash'}->{'min'}, $self->{'in_hash'}->{'max'}, $self->{'in_hash'}->{'warn'},
			    $self->{'in_hash'}->{'inactive'}, $self->{'expire'}, $shadow->[8] );
		$self->{'shadow_array'}->[2] = int(time() / (60*60*24))
			if ($self->{'shadow_array'}->[1] ne $shadow->[1]);
		}
	elsif ($self->{'in_hash'}->{'mode'} == 1) {
		@{$self->{'shadow_array'}} = ( $self->{'in_hash'}->{'name'}, $self->{'pass'},
			    @$self->{'shadow_array'}->[2..8] );
		}
	else {
		$self->{'passwd_array'}->[1] = $self->{'pass'};
		}

	if ($self->{'in_hash'}->{'line'} eq '') {
		$self->table_add($self->{'t'}, ":", \@{$self->{'passwd_array'}}, \@{$self->{'shadow_array'}});
		}
	else {
		$self->table_update($self->{'t'}, $self->{'lnums'}, ":", \@{$self->{'passwd_array'}}, \@{$self->{'shadow_array'}});
		}
	}
$self->apply_table_changes() if (!$self->{'config_hash'}->{'manual_build'});
$self->redirect("edit_tables.cgi?table=$self->{'in_hash'}->{'table'}");

1;
		
}


1;

