#!/usr/bin/perl

&MAIN();

 sub MAIN {
#
# An OpenSLP webmin module
# by Monty Charlton <monty@caldera.com>,
#
# Copyright (c) 2000 Caldera Systems
#
# Permission to use, copy, modify, and distribute this software and its
# documentation under the terms of the GNU General Public License is hereby 
# granted. No representations are made about the suitability of this software 
# for any purpose. It is provided "as is" without express or implied warranty.
# See the GNU General Public License for more details.
#
&ModuleLoader::preload_module('openslp_class', "openslp::SlpLib");
$self = new openslp::SlpLib:: 'openslp_class',%$self;


# Check if OpenSLP is actually installed
if (!-x $self->{'config_hash'}->{'slpd'}) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", "english", 1, 1, 0,
		$self->help_search_link("openslp", "man", "doc", "google"));
	print $self->text('index_eslpd', "<tt>$self->{'config_hash'}->{'slpd'}</tt>",
		  "$self->{'gconfig_hash'}->{'webprefix'}/config.cgi?$self->{'module_name'}"),"<p>\n";
	$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});
	exit;
	}

# Get the version number
$self->{'out'} = `$self->{'config_hash'}->{'slpd'} -v 2>&1`;
$self->{'out'} =~ /version:\s+(\S+)/i;
$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", "english", 1, 1, 0,
	$self->help_search_link("openslp", "man", "doc", "google"),
	undef, undef, $self->text('index_version', "$1"));

# Check if the config file exists
if (!-r $self->{'config_hash'}->{'slpd_conf'}) {
	print $self->text('index_econf', "<tt>$self->{'config_hash'}->{'slpd_conf'}</tt>",
		  "$self->{'gconfig_hash'}->{'webprefix'}/config.cgi?$self->{'module_name'}"),"<p>\n";
	$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});
	exit;
	}

@{$self->{'links_array'}} =  ( "edit_snda.cgi", "edit_netcfg.cgi",
	    "edit_dacfg.cgi", "edit_log.cgi" );
@{$self->{'titles_array'}} = ( $self->{'text_hash'}->{'snda_title'}, $self->{'text_hash'}->{'netcfg_title'},
	    $self->{'text_hash'}->{'dacfg_title'}, $self->{'text_hash'}->{'log_title'} );
@{$self->{'icons_array'}} =  ( "images/snda.gif", "images/netcfg.gif",
	    "images/dacfg.gif", "images/log.gif" );
$self->icons_table(\@{$self->{'links_array'}}, \@{$self->{'titles_array'}}, \@{$self->{'icons_array'}});

print "<hr>\n";
if ($self->slpd_is_running()) {
  print "<form action=stop.cgi>\n";
  print "<table width=100%><tr><td>\n";
  print "<input type=submit ",
        "value=\"$self->{'text_hash'}->{'index_stop'}\"></td>\n";
  print "<td>$self->{'text_hash'}->{'index_stopmsg'}</td> </tr></table>\n";
  print "</form>\n";  
}
else {
  print "<form action=start.cgi>\n";
  print "<table width=100%><tr><td>\n";
  print "<input type=submit ",
        "value=\"$self->{'text_hash'}->{'index_start'}\"></td>\n";
  print "<td>$self->{'text_hash'}->{'index_startmsg'}</td> </tr></table>\n";
  print "</form>\n";
}
$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});

1;
		
}


1;

