#!/usr/bin/perl

&MAIN();

 sub MAIN {
#
# An OpenSLP webmin module
# by Monty Charlton <monty@caldera.com>,
#
# Copyright (c) 2000 Caldera Systems
#
# Permission to use, copy, modify, and distribute this software and its
# documentation under the terms of the GNU General Public License is hereby 
# granted. No representations are made about the suitability of this software 
# for any purpose. It is provided "as is" without express or implied warranty.
# See the GNU General Public License for more details.
#

&ModuleLoader::preload_module('openslp_class', "openslp::SlpLib");
$self = new openslp::SlpLib:: 'openslp_class',%$self;

$self->ReadParse();

local @dadisc, @mctime, @inter;
local $val;

# Process List Items
for($i=0; $i<5; $i++) {
	if (!$self->{'in_hash'}->{'DADiscoveryTimeouts'}) {
		push(@dadisc, $val) if ($val=$self->{'in_hash'}->{"DADiscoveryTimeoutsValue_$i"});
		}
	if (!$self->{'in_hash'}->{'multicastTimeouts'}) {
		push(@mctime, $val) if ($val=$self->{'in_hash'}->{"multicastTimeoutsValue_$i"});
		}
	if (!$self->{'in_hash'}->{'interfaces'}) {
		push(@inter, $val) if ($val=$self->{'in_hash'}->{"interfacesValue_$i"});
		}
}
if (!$self->{'in_hash'}->{'DADiscoveryTimeouts'}) {
	$self->enable_list_line(@dadisc,'DADiscoveryTimeouts');
	}
else {
	$self->disable_line('DADiscoveryTimeouts');
	}

if (!$self->{'in_hash'}->{'multicastTimeouts'}) {
	$self->enable_list_line(@mctime,'multicastTimeouts');
	}
else {
	$self->disable_line('multicastTimeouts');
	}

if (!$self->{'in_hash'}->{'interfaces'}) {
	$self->enable_list_line(@inter,'interfaces');
	}
else {
	$self->disable_line('interfaces');
	}

# Process Boolean Items
if ($self->{'in_hash'}->{'isBroadcastOnly'}) {
	$self->enable_single_val_line('true','isBroadcastOnly');
	}
else {
	$self->disable_line('isBroadcastOnly');
}
if (!$self->{'in_hash'}->{'passiveDADetection'}) {
	$self->enable_single_val_line('false','passiveDADetection');
	}
else {
	$self->disable_line('passiveDADetection');
}
if (!$self->{'in_hash'}->{'activeDADetection'}) {
	$self->enable_single_val_line('false','activeDADetection');
	}
else {
	$self->disable_line('activeDADetection');
}

# Process single-value Items
if (!$self->{'in_hash'}->{'DAActiveDiscoveryInterval'}) {
	$self->enable_single_val_line($self->{'in_hash'}->{'DAActiveDiscoveryIntervalValue'},'DAActiveDiscoveryInterval');
	}
else {
	$self->disable_line('DAActiveDiscoveryInterval');
}
if (!$self->{'in_hash'}->{'multicastTTL'}) {
	$self->enable_single_val_line($self->{'in_hash'}->{'multicastTTLValue'},'multicastTTL');
	}
else {
	$self->disable_line('multicastTTL');
}
if (!$self->{'in_hash'}->{'DADiscoveryMaximumWait'}) {
	$self->enable_single_val_line($self->{'in_hash'}->{'DADiscoveryMaximumWaitValue'},'DADiscoveryMaximumWait');
	}
else {
	$self->disable_line('DADiscoveryMaximumWait');
}
if (!$self->{'in_hash'}->{'HintsFile'}) {
	$self->enable_single_val_line($self->{'in_hash'}->{'HintsFileValue'},'HintsFile');
	}
else {
	$self->disable_line('HintsFile');
}
if (!$self->{'in_hash'}->{'multicastMaximumWait'}) {
	$self->enable_single_val_line($self->{'in_hash'}->{'multicastMaximumWaitValue'},'multicastMaximumWait');
	}
else {
	$self->disable_line('multicastMaximumWait');
}
if (!$self->{'in_hash'}->{'unicastMaximumWait'}) {
	$self->enable_single_val_line($self->{'in_hash'}->{'unicastMaximumWaitValue'},'unicastMaximumWait');
	}
else {
	$self->disable_line('unicastMaximumWait');
}
if (!$self->{'in_hash'}->{'randomWaitBound'}) {
	$self->enable_single_val_line($self->{'in_hash'}->{'randomWaitBoundValue'},'randomWaitBound');
	}
else {
	$self->disable_line('randomWaitBound');
}
if (!$self->{'in_hash'}->{'MTU'}) {
	$self->enable_single_val_line($self->{'in_hash'}->{'MTUValue'},'MTU');
	}
else {
	$self->disable_line('MTU');
}

$self->restart();
$self->redirect("");

1;
		
}


1;

