#!/usr/bin/perl
package pam::Log_parser;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'pam::Log_parser');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# log_parser.pl
# Functions for parsing this module's logs

&ModuleLoader::preload_module(ref($self), "pam::PamLib");
$self = new pam::PamLib:: ref($self), %$self; 

1;
		return $self;
}

# parse_webmin_log(user, script, action, type, object, &params)
# Converts logged information from this module into human-readable form
sub parse_webmin_log
{
	my $self = shift;

local ($user, $script, $action, $type, $object, $p, $long) = @_;
if ($type eq 'pam') {
	return $self->text("log_pam_$action", "<tt>".$self->html_escape($object)."</tt>");
	}
elsif ($type eq 'mod') {
	if ($action eq 'move') {
		return $self->text($long ? "log_mod_move_l" : "log_mod_move",
			     $self->short_mod($p->{'1'}), $self->short_mod($p->{'2'}),
			     $self->html_escape($object));
		}
	else {
		return $self->text("log_mod_$action", $self->short_mod($p->{'module'}),
			     $self->html_escape($object));
		}
	}
else {
	return undef;
	}
}

sub short_mod
{
	my $self = shift;

$_[0] =~ /([^\/]+)$/;
return "<tt>".$self->html_escape("$1")."</tt>";
}


1;

