#!/usr/bin/perl

&MAIN();

 sub MAIN {
# create_pam.cgi
# Create a new PAM service

&ModuleLoader::preload_module('pam_class', "pam::PamLib");
$self = new pam::PamLib:: 'pam_class',%$self;

$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'create_err'});

# Create the empty file
$self->{'in_hash'}->{'name'} =~ /^\S+$/ || $self->error($self->{'text_hash'}->{'create_ename'});
$self->{'f'} = "$self->{'config_hash'}->{'pam_dir'}/$self->{'in_hash'}->{'name'}";
$self->lock_file($self->{'f'});
$self->open_tempfile(FILE, ">$self->{'f'}");
$self->print_tempfile(FILE, "#%PAM-1.0\n");
$self->print_tempfile(FILE, "# description: $self->{'in_hash'}->{'desc'}\n") if ($self->{'in_hash'}->{'desc'});
$self->close_tempfile(FILE);
chmod(0644, $self->{'f'});

# Create extra PAM modules
if ($self->{'in_hash'}->{'mods'} == 1) {
	# Setup for unix authentication
	$self->create_module($self->{'in_hash'}->{'name'}, { 'type' => 'auth',
				      'control' => 'required',
				      'module' => 'pam_pwdb.so',
				      'args' => 'shadow nullok' });
	$self->create_module($self->{'in_hash'}->{'name'}, { 'type' => 'account',
				      'control' => 'required',
				      'module' => 'pam_pwdb.so' });
	$self->create_module($self->{'in_hash'}->{'name'}, { 'type' => 'password',
				      'control' => 'required',
				      'module' => 'pam_pwdb.so',
				      'args' => 'shadow nullok use_authtok' });
	$self->create_module($self->{'in_hash'}->{'name'}, { 'type' => 'session',
				      'control' => 'required',
				      'module' => 'pam_pwdb.so' });
	}
elsif ($self->{'in_hash'}->{'mods'} == 2) {
	# Setup to deny access
	$self->create_module($self->{'in_hash'}->{'name'}, { 'type' => 'auth',
				      'control' => 'required',
				      'module' => 'pam_deny.so' });
	$self->create_module($self->{'in_hash'}->{'name'}, { 'type' => 'account',
				      'control' => 'required',
				      'module' => 'pam_deny.so' });
	$self->create_module($self->{'in_hash'}->{'name'}, { 'type' => 'password',
				      'control' => 'required',
				      'module' => 'pam_deny.so' });
	$self->create_module($self->{'in_hash'}->{'name'}, { 'type' => 'session',
				      'control' => 'required',
				      'module' => 'pam_deny.so' });
	}

$self->unlock_file($self->{'f'});
$self->webmin_log("create", "pam", $self->{'in_hash'}->{'name'}, { 'name' => $self->{'in_hash'}->{'name'},
					    'file' => $self->{'f'} });
$self->redirect("");

1;
		
}


1;

