#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_mod.cgi
# Update a module line in a service

&ModuleLoader::preload_module('pam_class', "pam::PamLib");
$self = new pam::PamLib:: 'pam_class',%$self;

$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'mod_err'});
@{$self->{'pam_array'}} = $self->get_pam_config();
$self->{'pam'} = $self->{'pam_array'}->[$self->{'in_hash'}->{'idx'}];

$self->lock_file($self->{'pam'}->{'file'});
if ($self->{'in_hash'}->{'delete'}) {
	# Deleting a module
	$self->{'mod'} = $self->{'pam'}->{'mods'}->[$self->{'in_hash'}->{'midx'}];
	$self->delete_module($self->{'pam'}->{'name'}, $self->{'mod'});
	}
else {
	if ($self->{'in_hash'}->{'_module'}) {
		# Adding a new module
		$self->{'mod'} = { 'type' => $self->{'in_hash'}->{'_type'},
			 'module' => $self->{'in_hash'}->{'_module'} };
		$self->{'module'} = $self->{'in_hash'}->{'_module'};
		}
	else {
		# Existing module entry
		$self->{'mod'} = $self->{'pam'}->{'mods'}->[$self->{'in_hash'}->{'midx'}];
		$self->{'module'} = $self->{'mod'}->{'module'};
		$self->{'module'} =~ s/^.*\///;
		}
	$self->{'mod'}->{'control'} = $self->{'in_hash'}->{'control'};

	if (-r "./$self->{'module'}.pl") {
		# Args selected by UI
		{
    my $pkg = $self->lib_to_pkg(".\/$self->{module}.pl", "pam");
    &ModuleLoader::preload_module(ref($self), "$pkg");
    $pkg .= '::';
    eval "\$self = new $pkg ref(\$self),\%\$self;"; 
}
		if (!$self->{'module_has_no_args'}) {
			foreach $a (split(/\s+/, $self->{'mod'}->{'args'})) {
				if ($a =~ /^([^\s=]+)=(\S*)$/) {
					$self->{'args_hash'}->{$1} = $2;
					}
				else {
					$self->{'args_hash'}->{$a} = "";
					}
				}
			$self->parse_module_args($self->{'pam'}, $self->{'mod'}, \%{$self->{'args_hash'}});
			foreach $a (keys %{$self->{'args_hash'}}) {
				if ($self->{'args_hash'}->{$a} eq "") {
					push(@{$self->{'args_array'}}, $a);
					}
				else {
					push(@{$self->{'args_array'}}, "$a=$self->{'args_hash'}->{$a}");
					}
				}
			$self->{'mod'}->{'args'} = join(" ", @{$self->{'args_array'}});
			}
		}
	else {
		# Args entered manually
		$self->{'mod'}->{'args'} = $self->{'in_hash'}->{'args'};
		}

	if ($self->{'in_hash'}->{'_module'}) {
		# Add the PAM module entry
		$self->create_module($self->{'pam'}->{'name'}, $self->{'mod'});
		}
	else {
		# Update the existing entry
		$self->modify_module($self->{'pam'}->{'name'}, $self->{'mod'});
		}
	}
$self->unlock_file($self->{'pam'}->{'file'});
$self->webmin_log($self->{'in_hash'}->{'delete'} ? "delete" : $self->{'in_hash'}->{'_module'} ? "create" : "modify",
	    "mod", $self->{'pam'}->{'name'}, $self->{'mod'});
$self->redirect("edit_pam.cgi?idx=$self->{'in_hash'}->{'idx'}");

1;
		
}


1;

