#!/usr/bin/perl
package pap::Log_parser;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'pap::Log_parser');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# log_parser.pl
# Functions for parsing this module's logs

&ModuleLoader::preload_module(ref($self), "pap::PapLib");
$self = new pap::PapLib:: ref($self), %$self; 

1;
		return $self;
}

# parse_webmin_log(user, script, action, type, object, &params)
# Converts logged information from this module into human-readable form
sub parse_webmin_log
{
	my $self = shift;

local ($user, $script, $action, $type, $object, $p) = @_;
if ($type eq 'mgetty') {
	return $self->text('log_mgetty_'.$action,
		     "<tt>".$self->html_escape($object)."</tt>");
	}
elsif ($type eq 'dialin') {
	return $self->text('log_dialin_'.$action,
		     "<tt>".$self->html_escape($object)."</tt>");
	}
elsif ($action eq 'options') {
	return $object ne '-' ?
		$self->text('log_options2', "<tt>".$self->html_escape($object)."</tt>") :
		$self->{'text_hash'}->{'log_options'};
	}
elsif ($action eq 'sync') {
	return $self->{'text_hash'}->{'log_sync'};
	}
elsif ($action eq 'mgetty_apply') {
	return $self->{'text_hash'}->{'log_apply'};
	}
elsif ($action eq 'deletes') {
	return $self->text('log_deletes', $object);
	}
else {
	return $self->text('log_'.$action, "<tt>".$self->html_escape($object)."</tt>");
	}
}


1;

