#!/usr/bin/perl
package pap::SecretsLib;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'pap::SecretsLib');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# secrets-lib.pl
# Common functions for editing a PPP users file

1;
		return $self;
}

# list_secrets()
sub list_secrets
{
	my $self = shift;

local(@rv, $line, $_);
open(SEC, $self->{'config_hash'}->{'pap_file'});
$line = 0;
while(<SEC>) {
	chop;
	s/^#.*$//g;
	@{$self->{'w_array'}} = $self->split_words($_);
	if (@{$self->{'w_array'}} >= 3) {
		local(%sec, @ips);
		$sec{'client'} = $self->{'w_array'}->[0];
		$sec{'server'} = $self->{'w_array'}->[1];
		$sec{'secret'} = $self->{'w_array'}->[2];
		@ips = @{$self->{'w_array'}}[3..$#{$self->{'w_array'}}];
		$sec{'ips'} = \@ips;
		$sec{'line'} = $line;
		$sec{'index'} = scalar(@rv);
		push(@rv, \%sec);
		}
	$line++;
	}
close(SEC);
return @rv;
}

# create_secret(&secret)
sub create_secret
{
	my $self = shift;

$self->open_tempfile(SEC, ">>$self->{'config_hash'}->{'pap_file'}");
$self->print_tempfile(SEC, $self->join_words($_[0]->{'client'}, $_[0]->{'server'},
		      $_[0]->{'secret'}, @{$_[0]->{'ips'}}),"\n");
$self->close_tempfile(SEC);
}

# change_secret(&secret)
sub change_secret
{
	my $self = shift;

$self->replace_file_line($self->{'config_hash'}->{'pap_file'}, $_[0]->{'line'},
		   $self->join_words($_[0]->{'client'}, $_[0]->{'server'},
			       $_[0]->{'secret'}, @{$_[0]->{'ips'}})."\n");
}

# delete_secret(&secret)
sub delete_secret
{
	my $self = shift;

$self->replace_file_line($self->{'config_hash'}->{'pap_file'}, $_[0]->{'line'});
}

# split_words(string)
sub split_words
{
	my $self = shift;

local($s, @w);
$s = $_[0];
while($s =~ /^\s*([^"\s]+|"([^"]*)")(.*)$/) {
	push(@w, defined($2) ? $2 : $1);
	$s = $3;
	}
return @w;
}

sub join_words
{
	my $self = shift;

local(@w, $w);
foreach $w (@_) {
	if ($w =~ /^[a-zA-Z0-9\.\-]+$/) { push(@w, $w); }
	else { push(@w, "\"$w\""); }
	}
return join("  ", @w);
}

# opt_crypt(password)
# Returns the given password, crypted if the user has configured it
sub opt_crypt
{
	my $self = shift;

if ($self->{'config_hash'}->{'encrypt_pass'}) {
	local($salt);
	srand(time());
	$salt = chr(int(rand(26))+65).chr(int(rand(26))+65);
	return $self->unix_crypt($_[0], $salt);
	}
return $_[0];
}


1;

