#!/usr/bin/perl
package pap::Useradmin_update;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'pap::Useradmin_update');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;

&ModuleLoader::preload_module(ref($self), "pap::PapLib");
$self = new pap::PapLib:: ref($self), %$self; 

1;

1;
		return $self;
}

# useradmin_create_user(&details)
# Add a PAP user if syncing is enabled
sub useradmin_create_user
{
	my $self = shift;

return if (!$self->{'config_hash'}->{'sync_add'});
@{$self->{'sec_array'}} = $self->list_secrets();
foreach $s (@{$self->{'sec_array'}}) {
	return if ($s->{'client'} eq $_[0]->{'user'});
	}
$self->{'sec_hash'}->{'client'} = $_[0]->{'user'};
$self->{'sec_hash'}->{'server'} = $self->{'config_hash'}->{'sync_server'} ? $self->{'config_hash'}->{'sync_server'} : "*";
$self->compute_password($_[0], \%{$self->{'sec_hash'}});
$self->{'sec_hash'}->{'ips'} = [ ];
$self->create_secret(\%{$self->{'sec_hash'}});
}

# useradmin_delete_user(&details)
# Delete this pap user if syncing
sub useradmin_delete_user
{
	my $self = shift;

return if (!$self->{'config_hash'}->{'sync_delete'});
@{$self->{'sec_array'}} = $self->list_secrets();
for($i=0; $i<@{$self->{'sec_array'}}; $i++) {
	if ($self->{'sec_array'}->[$i]->{'client'} eq $_[0]->{'user'}) {
		$self->delete_secret($self->{'sec_array'}->[$i]);
		return;
		}
	}
}

# useradmin_modify_user(&details)
# Update this user if in sync
sub useradmin_modify_user
{
	my $self = shift;

return if (!$self->{'config_hash'}->{'sync_change'});
@{$self->{'sec_array'}} = $self->list_secrets();
for($i=0; $i<@{$self->{'sec_array'}}; $i++) {
	if ($self->{'sec_array'}->[$i]->{'client'} eq $_[0]->{'olduser'}) {
		$self->{'sec_array'}->[$i]->{'client'} = $_[0]->{'user'};
		$self->compute_password($_[0], $self->{'sec_array'}->[$i]);
		$self->change_secret($self->{'sec_array'}->[$i]);
		return;
		}
	}
}

# compute_password(&user, &secret)
sub compute_password
{
	my $self = shift;

if ($_[0]->{'passmode'} == 0) {
	$_[1]->{'secret'} = $self->opt_crypt("");
	}
elsif ($_[0]->{'passmode'} == 1) {
	$_[1]->{'secret'} = "*LK*";
	}
elsif ($_[0]->{'passmode'} == 2) {
	$_[1]->{'secret'} = $_[0]->{'pass'} if ($self->{'config_hash'}->{'encrypt_pass'});
	}
elsif ($_[0]->{'passmode'} == 3) {
	$_[1]->{'secret'} = $self->opt_crypt($_[0]->{'plainpass'});
	}
}


1;

