#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_options.cgi
# Display list of options for PPP, and show if mgetty has autoPPP mode enabled

&ModuleLoader::preload_module('pap_class', "pap::PapLib");
$self = new pap::PapLib:: 'pap_class',%$self;

$self->{'access_hash'}->{'options'} || $self->error($self->{'text_hash'}->{'options_ecannot'});
$self->ReadParse();
$self->ui_print_header(undef, $self->{'text_hash'}->{'options_title'}, "");
$self->{'of'} = $self->{'config_hash'}->{'ppp_options'};
if ($self->{'in_hash'}->{'file'} =~ /^\Q$self->{'of'}\E\.ttyS(\d+)$/) {
	$self->{'tty'} = "ttyS$1";
	print "<center><font size=+1>",$self->text('options_serial', $1+1),
	      "</font></center>\n";
	}
elsif ($self->{'in_hash'}->{'file'} =~ /^\Q$self->{'of'}\E\.(\S+)$/) {
	$self->{'tty'} = $1;
	$self->{'tty'} =~ s/\./\//g;
	print "<center><font size=+1>",$self->text('options_dev', "<tt>$self->{'tty'}</tt>"),
	      "</font></center>\n";
	}

# Check if the PPP daemon is actually installed
if (!$self->has_command($self->{'config_hash'}->{'pppd'})) {
	print "<p>",$self->text('options_ecmd', "<tt>$self->{'config_hash'}->{'pppd'}</tt>"),"<p>\n";
	$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
	exit;
	}

# Check if the pppd is the linux one
$self->{'out'} = `$self->{'config_hash'}->{'pppd'} -v 2>&1`;
if ($self->{'out'} !~ /version\s+([0-9\.]+)/) {
	print "<p>",$self->text('options_epppd', "<tt>$self->{'config_hash'}->{'pppd'}</tt>"),"<p>\n";
	$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
	exit;
	}

@{$self->{'opts_array'}} = $self->parse_ppp_options($self->{'in_hash'}->{'file'} || $self->{'of'});
if (!$self->{'in_hash'}->{'file'}) {
	# Check for the mgetty login config file
	if (!-r $self->{'config_hash'}->{'login_config'}) {
		print "<p>",$self->text('options_elogin',
		    "<tt>$self->{'config_hash'}->{'login_config'}</tt>",
		    "$self->{'gconfig_hash'}->{'webprefix'}/config.cgi?$self->{'module_name'}"),"<p>\n";
		$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
		exit;
		}
	@{$self->{'login_array'}} = $self->parse_login_config();
	}

print "<p>$self->{'text_hash'}->{'options_desc'}<p>\n" if (!$self->{'in_hash'}->{'file'});

print "<form action=save_options.cgi>\n";
print "<input type=hidden name=file value='$self->{'in_hash'}->{'file'}'>\n";
print "<input type=hidden name=tty value='$self->{'tty'}'>\n";
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'options_header'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

if (!$self->{'in_hash'}->{'file'}) {
	# Show if autoPPP is being used or not
	($self->{'auto'}) = grep { $_->{'user'} eq "/AutoPPP/" } @{$self->{'login_array'}};
	print "<tr> <td colspan=2><b>$self->{'text_hash'}->{'options_autoppp'}</b></td>\n";
	printf "<td><input name=auto type=radio value=1 %s> %s\n",
		$self->{'auto'} ? "checked" : "", $self->{'text_hash'}->{'yes'};
	printf "<input name=auto type=radio value=0 %s> %s</td> </tr>\n",
		$self->{'auto'} ? "" : "checked", $self->{'text_hash'}->{'no'};
	print "<tr> <td colspan=4><hr></td> </tr>\n";
	}

($self->{'ip'}) = grep { $_->{'local'} } @{$self->{'opts_array'}};
print "<tr> <td><b>$self->{'text_hash'}->{'options_ip'}</b></td>\n";
printf "<td colspan=3><input type=radio name=ip_def value=1 %s> %s\n",
	$self->{'ip'} ? "" : "checked", $self->{'text_hash'}->{'options_auto'};
printf "<input type=radio name=ip_def value=0 %s>\n",
	$self->{'ip'} ? "checked" : "";
printf "%s <input name=local size=15 value='%s'>\n",
	$self->{'text_hash'}->{'options_local'}, $self->{'ip'}->{'local'};
printf "%s <input name=remote size=15 value='%s'></td> </tr>\n",
	$self->{'text_hash'}->{'options_remote'}, $self->{'ip'}->{'remote'};

$self->{'nm'} = $self->find("netmask", \@{$self->{'opts_array'}});
print "<tr> <td><b>$self->{'text_hash'}->{'options_netmask'}</b></td>\n";
printf "<td><input type=radio name=netmask_def value=1 %s> %s\n",
	$self->{'nm'} ? "" : "checked", $self->{'text_hash'}->{'default'};
printf "<input type=radio name=netmask_def value=0 %s>\n",
	$self->{'nm'} ? "checked" : "";
printf "<input name=netmask size=15 value='%s'></td>\n", $self->{'nm'}->{'value'};

$self->{'proxy'} = $self->find("proxyarp", \@{$self->{'opts_array'}});
print "<td><b>$self->{'text_hash'}->{'options_proxyarp'}</b></td>\n";
printf "<td><input type=radio name=proxyarp value=1 %s> %s\n",
	$self->{'proxy'} ? "checked" : "", $self->{'text_hash'}->{'yes'};
printf "<input type=radio name=proxyarp value=0 %s> %s</td> </tr>\n",
	$self->{'proxy'} ? "" : "checked", $self->{'text_hash'}->{'no'};

$self->{'lock'} = $self->find("lock", \@{$self->{'opts_array'}});
print "<tr> <td><b>$self->{'text_hash'}->{'options_lock'}</b></td>\n";
printf "<td><input type=radio name=lock value=1 %s> %s\n",
	$self->{'lock'} ? "checked" : "", $self->{'text_hash'}->{'yes'};
printf "<input type=radio name=lock value=0 %s> %s</td>\n",
	$self->{'lock'} ? "" : "checked", $self->{'text_hash'}->{'no'};

$self->{'modem'} = $self->find("modem", \@{$self->{'opts_array'}});
$self->{'local'} = $self->find("local", \@{$self->{'opts_array'}});
print "<td><b>$self->{'text_hash'}->{'options_ctrl'}</b></td>\n";
print "<td><select name=ctrl>\n";
printf "<option value=0 %s> %s\n",
	$self->{'local'} ? "selected" : "", $self->{'text_hash'}->{'options_ctrl0'};
printf "<option value=1 %s> %s\n",
	$self->{'modem'} ? "selected" : "", $self->{'text_hash'}->{'options_ctrl1'};
printf "<option value=2 %s> %s\n",
	$self->{'modem'} || $self->{'local'} ? "" : "selected", $self->{'text_hash'}->{'default'};
print "</select></td> </tr>\n";

$self->{'auth'} = $self->find("auth", \@{$self->{'opts_array'}});
$self->{'noauth'} = $self->find("noauth", \@{$self->{'opts_array'}});
print "<tr> <td><b>$self->{'text_hash'}->{'options_auth'}</b></td>\n";
printf "<td colspan=3><input type=radio name=auth value=0 %s> %s\n",
	$self->{'noauth'} || $self->{'auth'} ? "" : "checked", $self->{'text_hash'}->{'options_auth0'};
printf "<input type=radio name=auth value=1 %s> %s\n",
	$self->{'noauth'} ? "checked" : "", $self->{'text_hash'}->{'options_auth1'};
printf "<input type=radio name=auth value=2 %s> %s</td> </tr>\n",
	$self->{'auth'} ? "checked" : "", $self->{'text_hash'}->{'options_auth2'};

$self->{'login'} = $self->find("login", \@{$self->{'opts_array'}});
print "<tr> <td><b>$self->{'text_hash'}->{'options_login'}</b></td>\n";
printf "<td><input type=radio name=login value=1 %s> %s\n",
	$self->{'login'} ? "checked" : "", $self->{'text_hash'}->{'yes'};
printf "<input type=radio name=login value=0 %s> %s</td>\n",
	$self->{'login'} ? "" : "checked", $self->{'text_hash'}->{'no'};

$self->{'idle'} = $self->find("idle", \@{$self->{'opts_array'}});
print "<td><b>$self->{'text_hash'}->{'options_idle'}</b></td>\n";
printf "<td><input type=radio name=idle_def value=1 %s> %s\n",
	$self->{'idle'} ? "" : "checked", $self->{'text_hash'}->{'options_idle_def'};
printf "<input type=radio name=idle_def value=0 %s>\n",
	$self->{'idle'} ? "checked" : "";
printf "<input name=idle size=8 value='%s'> %s</td> </tr>\n",
	$self->{'idle'}->{'value'}, $self->{'text_hash'}->{'mgetty_secs'};

@{$self->{'dns_array'}} = $self->find("ms-dns", \@{$self->{'opts_array'}});
print "<tr> <td><b>$self->{'text_hash'}->{'options_dns'}</b></td>\n";
printf "<td colspan=3><input name=dns size=50 value='%s'></td> </tr>\n",
	join(" ", map { $_->{'value'} } @{$self->{'dns_array'}});

print "</table></td></tr></table>\n";
print "<input type=submit value='$self->{'text_hash'}->{'save'}'></form>\n";

if ($self->{'in_hash'}->{'file'}) {
	$self->ui_print_footer("list_mgetty.cgi", $self->{'text_hash'}->{'mgetty_return'});
	}
else {
	$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
	}

1;
		
}


1;

