#!/usr/bin/perl

&MAIN();

 sub MAIN {
# list_mgetty.cgi
# Displays a list of serial ports on which mgetty is enabled by searching
# for them in /etc/inittab

&ModuleLoader::preload_module('pap_class', "pap::PapLib");
$self = new pap::PapLib:: 'pap_class',%$self;

$self->{'access_hash'}->{'mgetty'} || $self->error($self->{'text_hash'}->{'mgetty_ecannot'});
$self->foreign_require("inittab", "inittab-lib.pl");
$self->ui_print_header(undef, $self->{'text_hash'}->{'mgetty_title'}, "");

if (!$self->has_command($self->{'config_hash'}->{'mgetty'})) {
	print "<p>",$self->text('mgetty_ecmd', "<tt>$self->{'config_hash'}->{'mgetty'}</tt>"),"<p>\n";
	$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
	exit;
	}
print $self->text('mgetty_desc', "<tt>mgetty</tt>"),"<p>\n";

@{$self->{'mgi_array'}} = $self->mgetty_inittabs();
if (@{$self->{'mgi_array'}}) {
	print "<a href='edit_mgetty.cgi?new=1'>$self->{'text_hash'}->{'mgetty_add'}</a><br>\n";
	print "<table border>\n";
	print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'mgetty_tty'}</b></td> ",
	      "<td><b>$self->{'text_hash'}->{'mgetty_type'}</b></td> ",
	      "<td><b>$self->{'text_hash'}->{'mgetty_speed'}</b></td> ",
	      "<td><b>$self->{'text_hash'}->{'mgetty_answer'}</b></td> ",
	      "<td><b>$self->{'text_hash'}->{'mgetty_config'}</b></td> </tr>\n";
	foreach $m (@{$self->{'mgi_array'}}) {
		print "<tr $self->{'cb'}>\n";
		local $tty = $m->{'tty'} =~ /^ttyS(\d+)$/ ?
			$self->text('mgetty_ts', $1+1) :
			$m->{'tty'} =~ /^term\/(\S+)$/ ?
			$self->text('mgetty_ts', uc($1)) :
			$m->{'tty'} =~ /^\// ? $m->{'tty'} : "/dev/$m->{'tty'}";
		if ($m->{'mgetty'}) {
			print "<td><a href='edit_mgetty.cgi?id=$m->{'id'}'>",
			      "$tty</a></td>\n";
			print "<td>",$m->{'direct'} ? $self->{'text_hash'}->{'mgetty_direct'}
					    : $self->{'text_hash'}->{'mgetty_modem'},"</td>\n";
			print "<td>",$m->{'speed'} ||
				     $self->{'text_hash'}->{'mgetty_auto'},"</td>\n";
			print "<td>",defined($m->{'rings'}) ? $m->{'rings'}
					    : 1," $self->{'text_hash'}->{'mgetty_rings'}</td>\n";
			local $fn = $m->{'tty'};
			$fn =~ s/^\/dev\///;
			$fn =~ s/\//\./g;
			if ($self->{'access_hash'}->{'options'}) {
				print "<td><a href='edit_options.cgi?",
				      "file=$self->{'config_hash'}->{'ppp_options'}.$fn'>",
				      "$self->{'text_hash'}->{'mgetty_cedit'}</a></td>\n";
				}
			else {
				print "<td><br></td>\n";
				}
			}
		else {
			print "<td>$tty</td>\n";
			print "<td colspan=4>$self->{'text_hash'}->{'mgetty_vgetty'}</td>\n";
			}
		print "</tr>\n";
		}
	print "</table>\n";
	}
else {
	print "<b>$self->{'text_hash'}->{'mgetty_none'}</b><p>\n";
	}
print "<a href='edit_mgetty.cgi?new=1'>$self->{'text_hash'}->{'mgetty_add'}</a><p>\n";

print "<hr>\n";
print "<form action=mgetty_apply.cgi>\n";
print "<table width=100%><tr>\n";
print "<td><input type=submit value='$self->{'text_hash'}->{'mgetty_apply'}'></td>\n";
print "<td>",$self->text('mgetty_applydesc', "<tt>telinit q</tt>"),"</td>\n";
print "</tr></table></form>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

