#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_mgetty.cgi
# Save, create or delete a serial port configuration

&ModuleLoader::preload_module('pap_class', "pap::PapLib");
$self = new pap::PapLib:: 'pap_class',%$self;

$self->{'access_hash'}->{'mgetty'} || $self->error($self->{'text_hash'}->{'mgetty_ecannot'});
$self->foreign_require("inittab", "inittab-lib.pl");
$self->ReadParse();
@{$self->{'inittab_array'}} = $main::inittab_object->parse_inittab();
@{$self->{'mgt_array'}} = $self->mgetty_inittabs();
if (!$self->{'in_hash'}->{'new'}) {
	($self->{'init'}) = grep { $_->{'id'} eq $self->{'in_hash'}->{'id'} } @{$self->{'mgt_array'}};
	$self->{'oldtty'} = $self->{'init'}->{'tty'};
	$self->{'oldtty'} = "/dev/$self->{'oldtty'}" if ($self->{'oldtty'} !~ /^\//);
	}

$self->lock_file($main::inittab_object->{'config_hash'}->{'inittab_file'});
if ($self->{'in_hash'}->{'delete'}) {
	# Just deleting an inittab entry
	$main::inittab_object->delete_inittab($self->{'init'});
	}
else {
	# Validate and store inputs
	$self->error_setup($self->{'text_hash'}->{'mgetty_err'});
	$self->{'cmd'} = $self->{'in_hash'}->{'new'} ? $self->has_command($self->{'config_hash'}->{'mgetty'}) : $self->{'init'}->{'mgetty'};
	$self->{'cmd'} .= " -r" if ($self->{'in_hash'}->{'direct'});
	if (!$self->{'in_hash'}->{'speed_def'}) {
		$self->{'in_hash'}->{'speed'} =~ /^\d+$/ || $self->error($self->{'text_hash'}->{'mgetty_espeed'});
		$self->{'cmd'} .= " -s $self->{'in_hash'}->{'speed'}";
		}
	$self->{'in_hash'}->{'rings'} =~ /^\d+$/ || $self->error($self->{'text_hash'}->{'mgetty_eanswer'});
	$self->{'cmd'} .= " -n $self->{'in_hash'}->{'rings'}" if ($self->{'in_hash'}->{'rings'} != 1);
	if ($self->{'in_hash'}->{'mode'} == 1) {
		$self->{'cmd'} .= " -D";
		}
	elsif ($self->{'in_hash'}->{'mode'} == 2) {
		$self->{'cmd'} .= " -F";
		}
	if (!$self->{'in_hash'}->{'back_def'}) {
		$self->{'in_hash'}->{'back'} =~ /^\d+$/ || $self->error($self->{'text_hash'}->{'mgetty_eback'});
		$self->{'cmd'} .= " -R $self->{'in_hash'}->{'back'}";
		}
	if (!$self->{'in_hash'}->{'prompt_def'}) {
		$self->{'cmd'} .= $self->{'in_hash'}->{'prompt'} =~ /"/ ? " -p '$self->{'in_hash'}->{'prompt'}'"
					     : " -p \"$self->{'in_hash'}->{'prompt'}\"";
		}
	if ($self->{'init'}->{'args'}) {
		$self->{'init'}->{'args'} =~ s/^\s+//;
		$self->{'cmd'} .= " $self->{'init'}->{'args'}";
		}
	if ($self->{'in_hash'}->{'tty'}) {
		$self->{'cmd'} .= " $self->{'in_hash'}->{'tty'}";
		$self->{'init'}->{'tty'} = $self->{'in_hash'}->{'tty'};
		}
	else {
		-r $self->{'in_hash'}->{'other'} || $self->error($self->{'text_hash'}->{'mgetty_etty'});
		$self->{'cmd'} .= " $self->{'in_hash'}->{'other'}";
		$self->{'init'}->{'tty'} = $self->{'in_hash'}->{'other'};
		}
	$self->{'newtty'} = $self->{'init'}->{'tty'};
	$self->{'newtty'} = "/dev/$self->{'newtty'}" if ($self->{'newtty'} !~ /^\//);
	if ($self->{'in_hash'}->{'new'} || $self->{'newtty'} ne $self->{'oldtty'}) {
		# Check for tty clash
		foreach $m ($self->mgetty_inittabs()) {
			local $mtty = $m->{'tty'};
			$mtty = "/dev/$mtty" if ($mtty !~ /^\//);
			$self->error($self->text('mgetty_eclash', "<tt>$mtty</tt>"))
				if ($mtty eq $self->{'newtty'});
			}
		}
	$self->{'cmd'} .= " $self->{'init'}->{'ttydefs'}" if ($self->{'init'}->{'ttydefs'});
	$self->{'init'}->{'process'} = $self->{'cmd'};
	
	if ($self->{'in_hash'}->{'new'}) {
		$self->{'maxid'} = 1;
		foreach $i (@{$self->{'inittab_array'}}) {
			$self->{'maxid'} = $i->{'id'} if ($i->{'id'} =~ /^\d+$/ &&
						$i->{'id'} > $self->{'maxid'});
			}
		$self->{'init'}->{'id'} = $self->{'maxid'} + 1;
		$self->{'init'}->{'levels'} = [ 2, 3, 4, 5 ];
		$self->{'init'}->{'action'} = "respawn";
		$main::inittab_object->create_inittab($self->{'init'});
		}
	else {
		$main::inittab_object->modify_inittab($self->{'init'});
		}
	}
$self->unlock_file($main::inittab_object->{'config_hash'}->{'inittab_file'});
$self->webmin_log($self->{'in_hash'}->{'delete'} ? "delete" : $self->{'in_hash'}->{'new'} ? "create" : "modify",
	    "mgetty", $self->{'init'}->{'tty'}, $self->{'init'});

$self->redirect("list_mgetty.cgi");

1;
		
}


1;

