#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_options.cgi
# Save PPP options

&ModuleLoader::preload_module('pap_class', "pap::PapLib");
$self = new pap::PapLib:: 'pap_class',%$self;

$self->{'access_hash'}->{'options'} || $self->error($self->{'text_hash'}->{'options_ecannot'});
$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'options_err'});
$self->{'file'} = $self->{'in_hash'}->{'file'} || $self->{'config_hash'}->{'ppp_options'};
$self->lock_file($self->{'file'});
@{$self->{'opts_array'}} = $self->parse_ppp_options($self->{'file'});

# Validate inputs
if (!$self->{'in_hash'}->{'ip_def'}) {
	$self->check_ipaddress($self->{'in_hash'}->{'local'}) || $self->error($self->{'text_hash'}->{'options_elocal'});
	$self->check_ipaddress($self->{'in_hash'}->{'remote'}) || $self->error($self->{'text_hash'}->{'options_eremote'});
	}
if (!$self->{'in_hash'}->{'netmask_def'}) {
	$self->check_ipaddress($self->{'in_hash'}->{'netmask'}) || $self->error($self->{'text_hash'}->{'options_enetmask'});
	}
if (!$self->{'in_hash'}->{'idle_def'}) {
	$self->{'in_hash'}->{'idle'} =~ /^\d+$/ || $self->error($self->{'text_hash'}->{'options_eidle'});
	}
@{$self->{'dns_array'}} = split(/\s+/, $self->{'in_hash'}->{'dns'});
foreach $d (@{$self->{'dns_array'}}) {
	$self->check_ipaddress($d) || $self->error($self->text('options_edns', $d));
	}

if (!$self->{'in_hash'}->{'file'}) {
	# Save AutoPPP setting
	$self->lock_file($self->{'config_hash'}->{'login_config'});
	@{$self->{'login_array'}} = $self->parse_login_config();
	($self->{'auto'}) = grep { $_->{'user'} eq "/AutoPPP/" } @{$self->{'login_array'}};
	if ($self->{'auto'} && !$self->{'in_hash'}->{'auto'}) {
		# Delete AutoPPP entry
		$self->delete_login_config(\@{$self->{'login_array'}}, $self->{'auto'});
		}
	elsif (!$self->{'auto'} && $self->{'in_hash'}->{'auto'}) {
		$self->create_login_config(\@{$self->{'login_array'}}, 
		    { 'user' => '/AutoPPP/', 'userid' => '-',
		      'utmp' => 'a_ppp', 'program' => $self->has_command("pppd") });
		}
	}

# Save PPP options
($self->{'ip'}) = grep { $_->{'local'} } @{$self->{'opts_array'}};
$self->save_ppp_option(\@{$self->{'opts_array'}}, $self->{'file'}, $self->{'ip'}, $self->{'in_hash'}->{'ip_def'} ? undef :
	{ 'local' => $self->{'in_hash'}->{'local'}, 'remote' => $self->{'in_hash'}->{'remote'} });
$self->save_ppp_option(\@{$self->{'opts_array'}}, $self->{'file'}, "netmask", $self->{'in_hash'}->{'netmask_def'} ? undef :
	{ 'name' => 'netmask', 'value' => $self->{'in_hash'}->{'netmask'} });
$self->save_ppp_option(\@{$self->{'opts_array'}}, $self->{'file'}, "proxyarp",
		 $self->{'in_hash'}->{'proxyarp'} ? { 'name' => 'proxyarp' } : undef);
$self->save_ppp_option(\@{$self->{'opts_array'}}, $self->{'file'}, "lock",
		 $self->{'in_hash'}->{'lock'} ? { 'name' => 'lock' } : undef);
if ($self->{'in_hash'}->{'ctrl'} == 0) {
	$self->save_ppp_option(\@{$self->{'opts_array'}}, $self->{'file'}, "modem", undef);
	$self->save_ppp_option(\@{$self->{'opts_array'}}, $self->{'file'}, "local", { 'name' => 'local' });
	}
elsif ($self->{'in_hash'}->{'ctrl'} == 1) {
	$self->save_ppp_option(\@{$self->{'opts_array'}}, $self->{'file'}, "local", undef);
	$self->save_ppp_option(\@{$self->{'opts_array'}}, $self->{'file'}, "modem", { 'name' => 'modem' });
	}
else {
	$self->save_ppp_option(\@{$self->{'opts_array'}}, $self->{'file'}, "modem", undef);
	$self->save_ppp_option(\@{$self->{'opts_array'}}, $self->{'file'}, "local", undef);
	}
if ($self->{'in_hash'}->{'auth'} == 0) {
	$self->save_ppp_option(\@{$self->{'opts_array'}}, $self->{'file'}, "auth", undef);
	$self->save_ppp_option(\@{$self->{'opts_array'}}, $self->{'file'}, "noauth", undef);
	}
elsif ($self->{'in_hash'}->{'auth'} == 1) {
	$self->save_ppp_option(\@{$self->{'opts_array'}}, $self->{'file'}, "auth", undef);
	$self->save_ppp_option(\@{$self->{'opts_array'}}, $self->{'file'}, "noauth", { 'name' => 'noauth' });
	}
else {
	$self->save_ppp_option(\@{$self->{'opts_array'}}, $self->{'file'}, "noauth", undef);
	$self->save_ppp_option(\@{$self->{'opts_array'}}, $self->{'file'}, "auth", { 'name' => 'auth' });
	}
$self->save_ppp_option(\@{$self->{'opts_array'}}, $self->{'file'}, "login",
		 $self->{'in_hash'}->{'login'} ? { 'name' => 'login' } : undef);
$self->save_ppp_option(\@{$self->{'opts_array'}}, $self->{'file'}, "idle", $self->{'in_hash'}->{'idle_def'} ? undef :
		{ 'name' => 'idle', 'value' => $self->{'in_hash'}->{'idle'} } );
@{$self->{'olddns_array'}} = $self->find("ms-dns", \@{$self->{'opts_array'}});
for($i=0; $i<@{$self->{'dns_array'}} || $i<@{$self->{'olddns_array'}}; $i++) {
	$self->save_ppp_option(\@{$self->{'opts_array'}}, $self->{'file'}, $self->{'olddns_array'}->[$i],
			 $self->{'dns_array'}->[$i] ? { 'name' => 'ms-dns', 'value' => $self->{'dns_array'}->[$i] }
				  : undef);
	}

# All done
$self->flush_file_lines();
$self->unlock_file($self->{'file'});
$self->unlock_file($self->{'config_hash'}->{'login_config'}) if (!$self->{'in_hash'}->{'file'});
$self->webmin_log("options", undef, $self->{'in_hash'}->{'tty'}, \%{$self->{'in_hash'}});
$self->redirect($self->{'in_hash'}->{'file'} ? "list_mgetty.cgi" : "");

1;
		
}


1;

