#!/usr/bin/perl
package passwd::PasswdLib;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'passwd::PasswdLib');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# passwd-lib.pl
# Common functions for the password module

&ModuleLoader::preload_module(ref($self), "WebLib");
$self = new WebLib:: ref($self), %$self; 
$self->init_config();
&ModuleLoader::preload_module(ref($self), "UiLib");
$self = new UiLib:: ref($self), %$self; 
%{$self->{'access_hash'}} = $self->get_module_acl();

1;

1;
		return $self;
}

# can_edit_passwd(&user)
sub can_edit_passwd
{
	my $self = shift;

if ($self->{'access_hash'}->{'mode'} == 0) {
	# Can change any
	return 1;
	}
elsif ($self->{'access_hash'}->{'mode'} == 3) {
	# Only own password
	return $_[0]->[0] eq $self->{'remote_user'};
	}
elsif ($self->{'access_hash'}->{'mode'} == 4) {
	# UID within range
	return (!$self->{'access_hash'}->{'low'} || $_[0]->[2] >= $self->{'access_hash'}->{'low'}) &&
	       (!$self->{'access_hash'}->{'high'} || $_[0]->[2] <= $self->{'access_hash'}->{'high'});
	}
elsif ($self->{'access_hash'}->{'mode'} == 5) {
	# Member of some group (except for exclusion list)
	return 0 if ($self->indexof($_[0]->[0],
			      split(/\s+/, $self->{'access_hash'}->{'notusers'})) >= 0);
	local $g = getgrgid($_[0]->[3]);
	return 1 if ($self->indexof($g, split(/\s+/, $self->{'access_hash'}->{'users'})) >= 0);
	if ($self->{'access_hash'}->{'sec'}) {
		local $gname;
		foreach $gname (split(/\s+/, $self->{'access_hash'}->{'users'})) {
			local @g = getgrnam($gname);
			return 1 if ($self->indexof($_[0]->[0],
					      split(/,/, $g[3])) >= 0);
			}
		}
	return 0;
	}
elsif ($self->{'access_hash'}->{'mode'} == 6) {
	# Users matching regexp
	return $_[0]->[0] =~ /$self->{'access_hash'}->{'users'}/;
	}
else {
	# Users on / not on some list
	local $idx = $self->indexof($_[0]->[0], split(/\s+/, $self->{'access_hash'}->{'users'}));
	return $self->{'access_hash'}->{'mode'} == 1 && $idx >= 0 ||
	       $self->{'access_hash'}->{'mode'} == 2 && $idx < 0;
	}
}

# find_user(name)
# Looks up the user structure for some name, in the useradmin, ldap-useradmin
# and nis modules
sub find_user
{
	my $self = shift;

local $mod;
foreach $mod ([ "useradmin", "user-lib.pl" ],
	      [ "ldap-useradmin", "ldap-useradmin-lib.pl" ],
#             [ "nis", "nis-lib.pl" ],
	     ) {
	next if (!$self->foreign_installed($mod->[0], 1));
	$self->foreign_require($mod->[0], $mod->[1]);
	local @ulist = $self->foreign_call($mod->[0], "list_users");
	local ($user) = grep { $_->{'user'} eq $_[0] } @ulist;
	if ($user) {
		$user->{'mod'} = $mod->[0];
		return $user;
		}
	}
return undef;
}

# change_password(&user, pass, do-others)
# Actually update a user's password
sub change_password
{
	my $self = shift;

local ($user, $pass, $others) = @_;
local $mod = $user->{'mod'} || "useradmin";
local $pft = $mod eq "useradmin" ? $main::useradmin_object->passfiles_type() :
	     $mod eq "ldap-useradmin" ? 1 : 0;

# Do the change!
$user->{'olduser'} = $user->{'user'};
$user->{'pass'} = $self->foreign_call($mod, "encrypt_password", $pass);
$user->{'passmode'} = 3;

# Modification ALain De Witte - on change of the password set
# ADMCHG flag for AIX
$user->{'admchg'} = 1;

$user->{'plainpass'} = $pass;
if ($pft == 2 || $pft == 5) {
	if ($self->{'in_hash'}->{'expire'}) {
		$user->{'change'} = 0;
		}
	else {
		$user->{'change'} = int(time() / (60*60*24));
		}
	}
elsif ($pft == 4) {
	$user->{'change'} = time();
	}
$self->foreign_call($mod, "lock_user_files");
$self->foreign_call($mod, "set_user_envs", $user, 'MODIFY_USER',
	      $self->{'in_hash'}->{'new'});
$self->foreign_call($mod, "making_changes");
$self->foreign_call($mod, "modify_user", $user, $user);
$self->foreign_call($mod, "made_changes");
$self->foreign_call($mod, "unlock_user_files");
if ($others) {
	$self->foreign_call($mod, "other_modules",
		      "useradmin_modify_user", $user);
	}
}


1;

