#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Display a list of users whose passwords can be changed

&ModuleLoader::preload_module('passwd_class', "passwd::PasswdLib");
$self = new passwd::PasswdLib:: 'passwd_class',%$self;

if (!$self->{'config_hash'}->{'passwd_cmd'} && !$self->foreign_check("useradmin")) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", undef, 1, 1);
	print "<p>$self->{'text_hash'}->{'index_euseradmin'}<p>\n";
	$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});
	exit;
	}

if ($self->{'access_hash'}->{'mode'} == 1) {
	if ($self->{'access_hash'}->{'users'} =~ /^\S+$/) {
		# Just one user - go to him
		$self->redirect("edit_passwd.cgi?user=$self->{'access_hash'}->{'users'}&one=1");
		exit;
		}
	map { $self->{'ucan_hash'}->{$_}++ } split(/\s+/, $self->{'access_hash'}->{'users'});
	}
elsif ($self->{'access_hash'}->{'mode'} == 2) {
	map { $self->{'ucannot_hash'}->{$_}++ } split(/\s+/, $self->{'access_hash'}->{'users'});
	}
elsif ($self->{'access_hash'}->{'mode'} == 3) {
	# Just this user - go to him
	$self->redirect("edit_passwd.cgi?user=$self->{'remote_user'}&one=1");
	exit;
	}
elsif ($self->{'access_hash'}->{'mode'} == 5) {
	%{$self->{'notusers_hash'}} = map { $_, 1 } split(/\s+/, $self->{'access_hash'}->{'notusers'});
	foreach $g (split(/\s+/, $self->{'access_hash'}->{'users'})) {
		@g = getgrnam($g);
		$self->{'gcan_hash'}->{$g[2]}++;
		if ($self->{'access_hash'}->{'sec'}) {
			foreach $m (split(/,/, $g[3])) {
				$self->{'insec_hash'}->{$m}++;
				}
			}
		}
	}

$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", undef, 1, 1);

# Show all unix users who can be edited
setpwent();
while(local @u = getpwent()) {
	if ($self->{'access_hash'}->{'mode'} == 0 ||
	    $self->{'access_hash'}->{'mode'} == 1 && $self->{'ucan_hash'}->{$u[0]} ||
	    $self->{'access_hash'}->{'mode'} == 2 && !$self->{'ucannot_hash'}->{$u[0]} ||
	    $self->{'access_hash'}->{'mode'} == 5 && ($self->{'gcan_hash'}->{$u[3]} ||
				     $self->{'access_hash'}->{'sec'} && $self->{'insec_hash'}->{$u[0]}) &&
				    !$self->{'notusers_hash'}->{$u[0]} ||
	    $self->{'access_hash'}->{'mode'} == 6 && $u[0] =~ /$self->{'access_hash'}->{'users'}/ ||
	    $self->{'access_hash'}->{'mode'} == 4 &&
		(!$self->{'access_hash'}->{'low'} || $u[2] >= $self->{'access_hash'}->{'low'}) &&
		(!$self->{'access_hash'}->{'high'} || $u[2] <= $self->{'access_hash'}->{'high'})) {
		push(@{$self->{'ulist_array'}}, \@u);
		if ($self->{'config_hash'}->{'max_users'} && @{$self->{'ulist_array'}} > $self->{'config_hash'}->{'max_users'}) {
			# Reached limit already .. no need to go on
			last;
			}
		}
	}
endpwent() if ($self->{'gconfig_hash'}->{'os_type'} ne 'hpux');
if ($self->{'config_hash'}->{'sort_mode'}) {
	@{$self->{'ulist_array'}} = sort { lc($a->[0]) cmp lc($b->[0]) } @{$self->{'ulist_array'}};
	}
if ($self->{'config_hash'}->{'max_users'} && @{$self->{'ulist_array'}} > $self->{'config_hash'}->{'max_users'}) {
	# Show as form for entering a username
	print "$self->{'text_hash'}->{'index_toomany'}<br>\n";
	print "<form action=edit_passwd.cgi>\n";
	print "<input type=submit value='$self->{'text_hash'}->{'index_user'}'>\n";
	if ($self->{'config_hash'}->{'input_type'}) {
		print "<select name=user>\n";
		foreach $u (@{$self->{'ulist_array'}}) {
			print "<option>$u->[0]\n";
			}
		print "</select>\n";
		}
	else {
		print "<input name=user size=13> ",
		      $self->user_chooser_button("user",0);
		}
	print "</form>\n";
	}
elsif (@{$self->{'ulist_array'}}) {
	# Show as table of users
	print "<table border width=100%>\n";
	print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'index_header'}</b></td> </tr>\n";
	print "<tr $self->{'cb'}> <td><table width=100%>\n";
	for($i=0; $i<@{$self->{'ulist_array'}}; $i++) {
		if ($i%4 == 0) { print "<tr>\n"; }
		print "<td width=25%><a href=\"edit_passwd.cgi?",
		      "user=$self->{'ulist_array'}->[$i]->[0]\">",
		      $self->html_escape($self->{'ulist_array'}->[$i]->[0])."</a></td>\n";
		if ($i%4 == 3) { print "</tr>\n"; }
		}
	while($i++ % 4) { print "<td width=25%></td>\n"; }
	print "</table></td> </tr></table><p>\n";
	}
else {
	# No users available
	print "<b>$self->{'text_hash'}->{'index_none'}</b><p>\n";
	}

$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});

1;
		
}


1;

