#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_passwd.cgi
# Change a user's password

&ModuleLoader::preload_module('passwd_class', "passwd::PasswdLib");
$self = new passwd::PasswdLib:: 'passwd_class',%$self;

$self->error_setup($self->{'text_hash'}->{'passwd_err'});
$self->ReadParse();

if ($self->{'config_hash'}->{'passwd_cmd'}) {
	# Call the passwd program to do the change
	@{$self->{'user_array'}} = getpwnam($self->{'in_hash'}->{'user'});
	@{$self->{'user_array'}} || $self->error($self->{'text_hash'}->{'passwd_euser'});
	$self->can_edit_passwd(\@{$self->{'user_array'}}) || $self->error($self->{'text_hash'}->{'passwd_ecannot'});
	if ($self->{'access_hash'}->{'repeat'}) {
		$self->{'in_hash'}->{'new'} eq $self->{'in_hash'}->{'repeat'} || $self->error($self->{'text_hash'}->{'passwd_erepeat'});
		}
	$self->foreign_require("proc", "proc-lib.pl");
	if ($self->{'access_hash'}->{'old'} == 1 ||
	    $self->{'access_hash'}->{'old'} == 2 && $self->{'in_hash'}->{'user'} ne $self->{'remote_user'}) {
		@{$self->{'cmd_array'}} = ( $self->{'config_hash'}->{'passwd_cmd'}, $self->{'user_array'}->[2], $self->{'user_array'}->[3] );
		}
	else {
		@{$self->{'cmd_array'}} = ( "$self->{'config_hash'}->{'passwd_cmd'} '$self->{'in_hash'}->{'user'}'" );
		}
	$self->additional_log('exec', undef, $self->{'cmd_array'}->[0]);
	local ($fh, $fpid) = $self->foreign_call("proc", "pty_process_exec", @{$self->{'cmd_array'}});
	while(1) {
		local $rv = $self->wait_for($fh, '(new|re-enter).*:',
					   '(old|current|login).*:',
					   'pick a password');
		$self->{'out'} .= $self->{'wait_for_input'};
		sleep(1);
		if ($rv == 0) {
			syswrite($fh, $self->{'in_hash'}->{'new'}."\n", length($self->{'in_hash'}->{'new'})+1);
			}
		elsif ($rv == 1) {
			syswrite($fh, $self->{'in_hash'}->{'old'}."\n", length($self->{'in_hash'}->{'old'})+1);
			}
		elsif ($rv == 2) {
			syswrite($fh, "1\n", 2);
			}
		else {
			last;
			}
		last if (++$self->{'count'} > 10);
		}
	close($fh);
	waitpid($fpid, 0);
	$self->error($self->text('passwd_ecmd', "<tt>$self->{'config_hash'}->{'passwd_cmd'}</tt>", "<pre>$self->{'out'}</pre>")) if ($? || $self->{'count'} > 10);
	$self->webmin_log("passwd", undef, $self->{'in_hash'}->{'user'});
	}
else {
	# Update the config files directly via the useradmin module
	$self->foreign_require("useradmin", "user-lib.pl");

	# Find the user, either in local password file or LDAP
	$user = $self->find_user($self->{'in_hash'}->{'user'});

	if ($user) {
		# Validate inputs
		if ($self->{'access_hash'}->{'old'} == 1 ||
		    $self->{'access_hash'}->{'old'} == 2 && $user->{'user'} ne $self->{'remote_user'}) {
			$self->unix_crypt($self->{'in_hash'}->{'old'}, $user->{'pass'}) eq $user->{'pass'} ||
				$self->error($self->{'text_hash'}->{'passwd_eold'});
			}
		if ($self->{'access_hash'}->{'repeat'}) {
			$self->{'in_hash'}->{'new'} eq $self->{'in_hash'}->{'repeat'} || $self->error($self->{'text_hash'}->{'passwd_erepeat'});
			}
		$self->{'err'} = $main::useradmin_object->check_password_restrictions(
			$self->{'in_hash'}->{'new'}, $self->{'in_hash'}->{'user'});
		$self->error($self->{'err'}) if ($self->{'err'});

		$self->can_edit_passwd([ $user->{'user'}, $user->{'pass'},
				   $user->{'uid'}, $user->{'gid'} ]) ||
			$self->error($self->{'text_hash'}->{'passwd_ecannot'});

		# Actually do the change
		$self->change_password($user, $self->{'in_hash'}->{'new'}, 
			$self->{'access_hash'}->{'others'} == 1 ||
			$self->{'access_hash'}->{'others'} == 2 && $self->{'in_hash'}->{'others'});
		}
	else {
		$self->error($self->{'text_hash'}->{'passwd_euser'});
		}
	delete($user->{'plainpass'});
	delete($user->{'pass'});
	$self->webmin_log("passwd", undef, $user->{'user'}, $user);
	}

# Show a confirmation message
$self->ui_print_header(undef, $self->{'text_hash'}->{'passwd_title'}, "", undef, undef, 1);
if (($user->{'user'} eq $self->{'remote_user'} || $user->{'user'} eq $self->{'base_remote_user'}) &&
    !$self->{'session_id'}) {
	print "<p>",$self->text('passwd_ok', "<tt>$user->{'user'}</tt>"),"<p>\n";
	}
else {
	print "<p>",$self->text('passwd_ok2', "<tt>$user->{'user'}</tt>"),"<p>\n";
	}
$self->ui_print_footer($self->{'text_hash'}->{'index_mainpage_url'}, $self->{'text_hash'}->{'index_mainpage'});

1;
		
}


1;

