#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Show options related to MySQL and other database connections

&ModuleLoader::preload_module('phpini_class', "phpini::PhpiniLib");
$self = new phpini::PhpiniLib:: 'phpini_class',%$self;

$self->ReadParse();
$self->can_php_config($self->{'in_hash'}->{'file'}) || $self->error($self->{'text_hash'}->{'list_ecannot'});
$self->{'conf'} = $self->get_config($self->{'in_hash'}->{'file'});

$self->ui_print_header("<tt>$self->{'in_hash'}->{'file'}</tt>", $self->{'text_hash'}->{'db_title'}, "");
@{$self->{'tds_array'}} = ( "width=30%" );

print $self->ui_form_start("save_db.cgi", "post");
print $self->ui_hidden("file", $self->{'in_hash'}->{'file'}),"\n";

# First section is for MySQL options
print $self->ui_table_start($self->{'text_hash'}->{'db_header1'}, "width=100%", 2);

# Allow persistent MySQL connections
print $self->ui_table_row($self->{'text_hash'}->{'db_persist'},
	    $self->onoff_radio("mysql.allow_persistent"),
	    undef, \@{$self->{'tds_array'}});

# Max persistent connections
$self->{'mp'} = $self->find_value("mysql.max_persistent", $self->{'conf'});
print $self->ui_table_row($self->{'text_hash'}->{'db_maxpersist'},
	    $self->ui_opt_textbox("mysql.max_persistent", $self->{'mp'} <= 0 ? undef : $self->{'mp'},
			    5, $self->{'text_hash'}->{'db_unlimited'}),
	    undef, \@{$self->{'tds_array'}});

# Max total connections
$self->{'mp'} = $self->find_value("mysql.max_links", $self->{'conf'});
print $self->ui_table_row($self->{'text_hash'}->{'db_maxlinks'},
	    $self->ui_opt_textbox("mysql.max_links", $self->{'mp'} <= 0 ? undef : $self->{'mp'},
			    5, $self->{'text_hash'}->{'db_unlimited'}),
	    undef, \@{$self->{'tds_array'}});

# Connection timeout
$self->{'ct'} = $self->find_value("mysql.connect_timeout", $self->{'conf'});
print $self->ui_table_row($self->{'text_hash'}->{'db_timeout'},
	    $self->ui_opt_textbox("mysql.connect_timeout", $self->{'ct'} <= 0 ? undef : $self->{'ct'},
			    5,$self->{'text_hash'}->{'default'})." ".$self->{'text_hash'}->{'db_s'},
	    undef, \@{$self->{'tds_array'}});

# Default host
print $self->ui_table_row($self->{'text_hash'}->{'db_host'},
	    $self->ui_opt_textbox("mysql.default_host",
			    $self->find_value("mysql.default_host", $self->{'conf'}),
			    30, "<tt>localhost</tt>"),
	    undef, \@{$self->{'tds_array'}});

# Default port
print $self->ui_table_row($self->{'text_hash'}->{'db_port'},
	    $self->ui_opt_textbox("mysql.default_port",
			    $self->find_value("mysql.default_port", $self->{'conf'}),
			    5, "<tt>3306</tt>"),
	    undef, \@{$self->{'tds_array'}});

print $self->ui_table_end();

# Second section is for PostgreSQL options
print $self->ui_table_start($self->{'text_hash'}->{'db_header2'}, "width=100%", 2);

# Allow persistent PostgreSQL connections
print $self->ui_table_row($self->{'text_hash'}->{'db_persist'},
	    $self->onoff_radio("pgsql.allow_persistent"),
	    undef, \@{$self->{'tds_array'}});

# Re-open persistent PostgreSQL connections
print $self->ui_table_row($self->{'text_hash'}->{'db_reset'},
	    $self->onoff_radio("pgsql.auto_reset_persistent"),
	    undef, \@{$self->{'tds_array'}});

# Max persistent connections
$self->{'mp'} = $self->find_value("pgsql.max_persistent", $self->{'conf'});
print $self->ui_table_row($self->{'text_hash'}->{'db_maxpersist'},
	    $self->ui_opt_textbox("pgsql.max_persistent", $self->{'mp'} <= 0 ? undef : $self->{'mp'},
			    5, $self->{'text_hash'}->{'db_unlimited'}),
	    undef, \@{$self->{'tds_array'}});

# Max total connections
$self->{'mp'} = $self->find_value("pgsql.max_links", $self->{'conf'});
print $self->ui_table_row($self->{'text_hash'}->{'db_maxlinks'},
	    $self->ui_opt_textbox("pgsql.max_links", $self->{'mp'} <= 0 ? undef : $self->{'mp'},
			    5, $self->{'text_hash'}->{'db_unlimited'}),
	    undef, \@{$self->{'tds_array'}});

print $self->ui_table_end();

print $self->ui_form_end([ [ "save", $self->{'text_hash'}->{'save'} ] ]);

$self->ui_print_footer("list_ini.cgi?file=".$self->urlize($self->{'in_hash'}->{'file'}),
		 $self->{'text_hash'}->{'list_return'});
1;
		
}


1;

