#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Show options related to error reporting and logging

&ModuleLoader::preload_module('phpini_class', "phpini::PhpiniLib");
$self = new phpini::PhpiniLib:: 'phpini_class',%$self;

$self->ReadParse();
$self->can_php_config($self->{'in_hash'}->{'file'}) || $self->error($self->{'text_hash'}->{'list_ecannot'});
$self->{'conf'} = $self->get_config($self->{'in_hash'}->{'file'});

$self->ui_print_header("<tt>$self->{'in_hash'}->{'file'}</tt>", $self->{'text_hash'}->{'errors_title'}, "");

print $self->ui_form_start("save_errors.cgi", "post");
print $self->ui_hidden("file", $self->{'in_hash'}->{'file'}),"\n";
print $self->ui_table_start($self->{'text_hash'}->{'errors_header'}, "width=100%", 4);

# Show and log errors
print $self->ui_table_row($self->{'text_hash'}->{'errors_display'},
		    $self->onoff_radio("display_errors"));
print $self->ui_table_row($self->{'text_hash'}->{'errors_log'},
		    $self->onoff_radio("log_errors"));

# Ignore repeated
print $self->ui_table_row($self->{'text_hash'}->{'errors_ignore'},
		    $self->onoff_radio("ignore_repeated_errors"));
print $self->ui_table_row($self->{'text_hash'}->{'errors_source'},
		    $self->onoff_radio("ignore_repeated_source"));

# Error types to show
$self->{'errs'} = $self->find_value("error_reporting", $self->{'conf'});
if ($self->{'errs'} =~ /^[A-Z_\|]*$/) {
	# An | of error bits
	@{$self->{'errs_array'}} = split(/\|/, $self->{'errs'});
	$self->{'i'} = 0;
	$self->{'etable'} = "<table>\n";
	foreach $et ("E_ALL", "E_ERROR", "E_WARNING", "E_PARSE", "E_NOTICE",
		     "E_CORE_ERROR", "E_CORE_WARNING", "E_COMPILE_ERROR",
		     "E_COMPILE_WARNING", "E_USER_ERROR", "E_USER_WARNING",
		     "E_USER_NOTICE") {
		$self->{'etable'} .= "<tr>\n" if ($self->{'i'}%4 == 0);
		$self->{'etable'} .= "<td>".
		    $self->ui_checkbox("error_bits", $et,
			$self->{'text_hash'}->{'errors_'.$et}, $self->indexof($et, @{$self->{'errs_array'}}) >= 0).
		    "</td>\n";
		$self->{'etable'} .= "</tr>\n" if ($self->{'i'}++%4 == 3);
		}
	$self->{'etable'} .= "</table>\n";
	print $self->ui_table_row($self->{'text_hash'}->{'errors_bits'}, $self->{'etable'}, 3);
	}
else {
	# Custom expression
	print $self->ui_table_row($self->{'text_hash'}->{'errors_reporting'},
	    $self->ui_opt_textbox("error_reporting", $self->{'errs'}, 60, $self->{'text_hash'}->{'default'}), 3);
	}

# Max error length
$self->{'ml'} = $self->find_value("log_errors_max_len", $self->{'conf'});
print $self->ui_table_row($self->{'text_hash'}->{'errors_maxlen'},
		    $self->ui_opt_textbox("log_errors_max_len", $self->{'ml'} || undef, 5,
				    $self->{'text_hash'}->{'errors_unlimited'}));

# Where to log errors
$self->{'el'} = $self->find_value("error_log", $self->{'conf'});
print $self->ui_table_row($self->{'text_hash'}->{'errors_file'},
	$self->ui_radio("error_log_def", $self->{'el'} eq "syslog" ? 1 : $self->{'el'} ? 2 : 0,
		  [ [ 0, $self->{'text_hash'}->{'errors_none'} ],
		    [ 1, $self->{'text_hash'}->{'errors_syslog'} ],
		    [ 2, $self->text('errors_other',
		       $self->ui_textbox("error_log", $self->{'el'} eq "syslog" ? "" : $self->{'el'}, 40))
		    ] ]), 3);

print $self->ui_table_end();
print $self->ui_form_end([ [ "save", $self->{'text_hash'}->{'save'} ] ]);

$self->ui_print_footer("list_ini.cgi?file=".$self->urlize($self->{'in_hash'}->{'file'}),
		 $self->{'text_hash'}->{'list_return'});
1;
		
}


1;

