#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Show options related to session handling

&ModuleLoader::preload_module('phpini_class', "phpini::PhpiniLib");
$self = new phpini::PhpiniLib:: 'phpini_class',%$self;

$self->ReadParse();
$self->can_php_config($self->{'in_hash'}->{'file'}) || $self->error($self->{'text_hash'}->{'list_ecannot'});
$self->{'conf'} = $self->get_config($self->{'in_hash'}->{'file'});

$self->ui_print_header("<tt>$self->{'in_hash'}->{'file'}</tt>", $self->{'text_hash'}->{'session_title'}, "");

print $self->ui_form_start("save_session.cgi", "post");
print $self->ui_hidden("file", $self->{'in_hash'}->{'file'}),"\n";
print $self->ui_table_start($self->{'text_hash'}->{'session_header'}, "width=100%", 2);

# Session saving handler
print $self->ui_table_row($self->{'text_hash'}->{'session_handler'},
	$self->ui_select("session.save_handler",
		   $self->find_value("session.save_handler", $self->{'conf'}),
		   [ [ "files", $self->{'text_hash'}->{'session_files'} ],
		     [ "mm", $self->{'text_hash'}->{'session_mm'} ],
		     [ "users", $self->{'text_hash'}->{'session_users'} ] ]));

# Where to save session files
print $self->ui_table_row($self->{'text_hash'}->{'session_path'},
	$self->ui_opt_textbox("session.save_path",
			$self->find_value("session.save_path", $self->{'conf'}),
			60, $self->{'text_hash'}->{'default'}." (<tt>/tmp</tt>)"));

# Use cookies for sessions?
print $self->ui_table_row($self->{'text_hash'}->{'session_cookies'},
	$self->onoff_radio("session.use_cookies"));
print $self->ui_table_row($self->{'text_hash'}->{'session_only_cookies'},
	$self->onoff_radio("session.use_only_cookies"));

# Cookie lifetime
$self->{'lf'} = $self->find_value("session.cookie_lifetime", $self->{'conf'});
print $self->ui_table_row($self->{'text_hash'}->{'session_life'},
	$self->ui_opt_textbox("session.cookie_lifetime", $self->{'lf'} || undef,
			5, $self->{'text_hash'}->{'session_forever'})." ".$self->{'text_hash'}->{'db_s'});

# Session lifetime
$self->{'lf'} = $self->find_value("session.gc_maxlifetime", $self->{'conf'});
print $self->ui_table_row($self->{'text_hash'}->{'session_maxlife'},
	$self->ui_opt_textbox("session.gc_maxlifetime", $self->{'lf'} || undef,
			5, $self->{'text_hash'}->{'session_forever'})." ".$self->{'text_hash'}->{'db_s'});

print $self->ui_table_end();
print $self->ui_form_end([ [ "save", $self->{'text_hash'}->{'save'} ] ]);

$self->ui_print_footer("list_ini.cgi?file=".$self->urlize($self->{'in_hash'}->{'file'}),
		 $self->{'text_hash'}->{'list_return'});
1;
		
}


1;

