#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Show all editable PHP configuration files

&ModuleLoader::preload_module('phpini_class', "phpini::PhpiniLib");
$self = new phpini::PhpiniLib:: 'phpini_class',%$self;


# Get editable files
@{$self->{'files_array'}} = $self->list_php_configs();
if (!@{$self->{'files_array'}}) {
	# User doesn't have access to any
	$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", undef, 1, 1);
	$self->ui_print_endpage($self->{'text_hash'}->{'index_eaccess'});
	}
@{$self->{'files_array'}} = grep { -r $_->[0] } @{$self->{'files_array'}};
if (!@{$self->{'files_array'}}) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", undef, 1, 1);
	if ($self->{'access_hash'}->{'noconfig'}) {
		$self->ui_print_endpage($self->{'text_hash'}->{'index_efiles'});
		}
	else {
		$self->ui_print_endpage($self->text('index_efiles2',
					"../config.cgi?$self->{'module_name'}"));
		}
	}

if (@{$self->{'files_array'}} == 1 && !$self->{'access_hash'}->{'anyfile'} && $self->{'access_hash'}->{'noconfig'}) {
	# Just re-direct to the one file
	$self->redirect("list_ini.cgi?file=".$self->urlize($self->{'files_array'}->[0]->[0]));
	}
else {
	# Show a table of config files
	$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", undef, 1, 1);

	@{$self->{'tds_array'}} = ( undef, undef, "width=25% nowrap" );
	print $self->ui_columns_start([ $self->{'text_hash'}->{'index_file'},
				  $self->{'text_hash'}->{'index_desc'},
				  $self->{'text_hash'}->{'index_actions'} ],
				100, 0, \@{$self->{'tds_array'}});
	foreach $f (@{$self->{'files_array'}}) {
		local @acts = ( "<a href='list_ini.cgi?file=".
				$self->urlize($f->[0])."'>$self->{'text_hash'}->{'index_edit'}</a>" );
		if ($self->{'access_hash'}->{'manual'}) {
			push(@acts, "<a href='edit_manual.cgi?file=".
			    $self->urlize($f->[0])."'>$self->{'text_hash'}->{'index_manual'}</a>");
			}
		print $self->ui_columns_row([
			"<tt>$f->[0]</tt>",
			$f->[1],
			join(" | ", @acts)
			], \@{$self->{'tds_array'}});
		}
	print $self->ui_columns_end();

	# Allow entering a file to edit
	if ($self->{'access_hash'}->{'anyfile'}) {
		print "<p>\n";
		print $self->ui_form_start("list_ini.cgi");
		print "<b>$self->{'text_hash'}->{'index_anyfile'}</b>\n";
		print $self->ui_textbox("file", undef, 40)." ".
		      $self->file_chooser_button("file")." ".
		      $self->ui_submit($self->{'text_hash'}->{'index_edit'})."\n";
		print $self->ui_form_end();
		}

	$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});
	}

1;
		
}


1;

