#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Update options related to database connections

&ModuleLoader::preload_module('phpini_class', "phpini::PhpiniLib");
$self = new phpini::PhpiniLib:: 'phpini_class',%$self;

$self->error_setup($self->{'text_hash'}->{'db_err'});
$self->ReadParse();
$self->can_php_config($self->{'in_hash'}->{'file'}) || $self->error($self->{'text_hash'}->{'list_ecannot'});

$self->lock_file($self->{'in_hash'}->{'file'});
$self->{'conf'} = $self->get_config($self->{'in_hash'}->{'file'});

# Validate and save MySQL settings
$self->save_directive($self->{'conf'}, "mysql.allow_persistent",
		$self->{'in_hash'}->{"mysql.allow_persistent"} || undef);

if ($self->{'in_hash'}->{"mysql.max_persistent_def"}) {
	$self->save_directive($self->{'conf'}, "mysql.max_persistent", -1);
	}
else {
	$self->{'in_hash'}->{"mysql.max_persistent"} =~ /^\d+$/ ||
		$self->error($self->{'text_hash'}->{'db_emaxpersist'});
	$self->save_directive($self->{'conf'}, "mysql.max_persistent",
			$self->{'in_hash'}->{"mysql.max_persistent"});
	}

if ($self->{'in_hash'}->{"mysql.max_links_def"}) {
	$self->save_directive($self->{'conf'}, "mysql.max_links", -1);
	}
else {
	$self->{'in_hash'}->{"mysql.max_links"} =~ /^\d+$/ ||
		$self->error($self->{'text_hash'}->{'db_emaxlinks'});
	$self->save_directive($self->{'conf'}, "mysql.max_links",
			$self->{'in_hash'}->{"mysql.max_links"});
	}

if ($self->{'in_hash'}->{"mysql.connect_timeout_def"}) {
	$self->save_directive($self->{'conf'}, "mysql.connect_timeout", -1);
	}
else {
	$self->{'in_hash'}->{"mysql.connect_timeout"} =~ /^\d+$/ ||
		$self->error($self->{'text_hash'}->{'db_etimeout'});
	$self->save_directive($self->{'conf'}, "mysql.connect_timeout",
			$self->{'in_hash'}->{"mysql.connect_timeout"});
	}

if ($self->{'in_hash'}->{"mysql.default_host_def"}) {
	$self->save_directive($self->{'conf'}, "mysql.default_host", undef);
	}
else {
	gethostbyname($self->{'in_hash'}->{"mysql.default_host"}) ||
		$self->error($self->{'text_hash'}->{'db_ehost'});
	$self->save_directive($self->{'conf'}, "mysql.default_host",
			$self->{'in_hash'}->{"mysql.default_host"});
	}

if ($self->{'in_hash'}->{"mysql.default_port_def"}) {
	$self->save_directive($self->{'conf'}, "mysql.default_port", undef);
	}
else {
	$self->{'in_hash'}->{"mysql.default_port"} =~ /^\d+$/ ||
		$self->error($self->{'text_hash'}->{'db_eport'});
	$self->save_directive($self->{'conf'}, "mysql.default_port",
			$self->{'in_hash'}->{"mysql.default_port"});
	}

# Validate and save PostgreSQL settings
$self->save_directive($self->{'conf'}, "pgsql.allow_persistent",
		$self->{'in_hash'}->{"pgsql.allow_persistent"} || undef);
$self->save_directive($self->{'conf'}, "pgsql.auto_reset_persistent",
		$self->{'in_hash'}->{"pgsql.auto_reset_persistent"} || undef);

if ($self->{'in_hash'}->{"pgsql.max_persistent_def"}) {
	$self->save_directive($self->{'conf'}, "pgsql.max_persistent", -1);
	}
else {
	$self->{'in_hash'}->{"pgsql.max_persistent"} =~ /^\d+$/ ||
		$self->error($self->{'text_hash'}->{'db_emaxpersist'});
	$self->save_directive($self->{'conf'}, "pgsql.max_persistent",
			$self->{'in_hash'}->{"pgsql.max_persistent"});
	}

if ($self->{'in_hash'}->{"pgsql.max_links_def"}) {
	$self->save_directive($self->{'conf'}, "pgsql.max_links", -1);
	}
else {
	$self->{'in_hash'}->{"pgsql.max_links"} =~ /^\d+$/ ||
		$self->error($self->{'text_hash'}->{'db_emaxlinks'});
	$self->save_directive($self->{'conf'}, "pgsql.max_links",
			$self->{'in_hash'}->{"pgsql.max_links"});
	}

$self->flush_file_lines($self->{'in_hash'}->{'file'});
$self->unlock_file($self->{'in_hash'}->{'file'});
$self->graceful_apache_restart();
$self->webmin_log("db", undef, $self->{'in_hash'}->{'file'});

$self->redirect("list_ini.cgi?file=".$self->urlize($self->{'in_hash'}->{'file'}));

1;
		
}


1;

