#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Update options related to PHP directories

&ModuleLoader::preload_module('phpini_class', "phpini::PhpiniLib");
$self = new phpini::PhpiniLib:: 'phpini_class',%$self;

$self->error_setup($self->{'text_hash'}->{'dirs_err'});
$self->ReadParse();
$self->can_php_config($self->{'in_hash'}->{'file'}) || $self->error($self->{'text_hash'}->{'list_ecannot'});

$self->lock_file($self->{'in_hash'}->{'file'});
$self->{'conf'} = $self->get_config($self->{'in_hash'}->{'file'});

# Validate and save inputs
if ($self->{'in_hash'}->{'include_def'}) {
	$self->save_directive($self->{'conf'}, "include_path", undef);
	}
else {
	@{$self->{'incs_array'}} = split(/\r?\n/, $self->{'in_hash'}->{'include'});
	@{$self->{'incs_array'}} || $self->error($self->{'text_hash'}->{'dirs_eincs'});
	$self->save_directive($self->{'conf'}, "include_path", join(":", @{$self->{'incs_array'}}));
	}

$self->{'in_hash'}->{'ext_def'} || $self->{'in_hash'}->{'ext'} =~ /\S/ || $self->error($self->{'text_hash'}->{'dirs_eext'});
$self->save_directive($self->{'conf'}, "extension_dir", $self->{'in_hash'}->{'ext_def'} ? undef : $self->{'in_hash'}->{'ext'});

$self->save_directive($self->{'conf'}, "file_uploads", $self->{'in_hash'}->{'file_uploads'} || undef);

$self->{'in_hash'}->{'utmp_def'} || -d $self->{'in_hash'}->{'utmp'} || $self->error($self->{'text_hash'}->{'dirs_eutmp'});
$self->save_directive($self->{'conf'}, "upload_tmp_dir", $self->{'in_hash'}->{'utmp_def'} ? undef : $self->{'in_hash'}->{'utmp'});

$self->flush_file_lines($self->{'in_hash'}->{'file'});
$self->unlock_file($self->{'in_hash'}->{'file'});
$self->graceful_apache_restart();
$self->webmin_log("dirs", undef, $self->{'in_hash'}->{'file'});

$self->redirect("list_ini.cgi?file=".$self->urlize($self->{'in_hash'}->{'file'}));

1;
		
}


1;

