#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Update options related to error logging

&ModuleLoader::preload_module('phpini_class', "phpini::PhpiniLib");
$self = new phpini::PhpiniLib:: 'phpini_class',%$self;

$self->error_setup($self->{'text_hash'}->{'errors_err'});
$self->ReadParse();
$self->can_php_config($self->{'in_hash'}->{'file'}) || $self->error($self->{'text_hash'}->{'list_ecannot'});

$self->lock_file($self->{'in_hash'}->{'file'});
$self->{'conf'} = $self->get_config($self->{'in_hash'}->{'file'});

$self->save_directive($self->{'conf'}, "display_errors", $self->{'in_hash'}->{"display_errors"} || undef);
$self->save_directive($self->{'conf'}, "log_errors", $self->{'in_hash'}->{"log_errors"} || undef);
$self->save_directive($self->{'conf'}, "ignore_repeated_errors",
		$self->{'in_hash'}->{"ignore_repeated_errors"} || undef);
$self->save_directive($self->{'conf'}, "ignore_repeated_source",
		$self->{'in_hash'}->{"ignore_repeated_source"} || undef);
if (defined($self->{'in_hash'}->{"error_reporting"})) {
	# Custom expression
	if ($self->{'in_hash'}->{"error_reporting_def"}) {
		$self->save_directive($self->{'conf'}, "error_reporting", undef);
		}
	else {
		$self->{'in_hash'}->{"error_reporting"} =~ /\S/ ||
			$self->error($self->{'text_hash'}->{'errors_ereporting'});
		$self->save_directive($self->{'conf'}, "error_reporting",
				$self->{'in_hash'}->{"error_reporting"});
		}
	}
else {
	# Bitwise
	$self->save_directive($self->{'conf'}, "error_reporting",
			join("|", split(/\0/, $self->{'in_hash'}->{"error_bits"})));
	}

# Save max error length
$self->{'in_hash'}->{"log_errors_max_len_def"} || $self->{'in_hash'}->{"log_errors_max_len"} =~ /^\d+$/ ||
	$self->error($self->{'text_hash'}->{'errors_emaxlen'});
$self->save_directive($self->{'conf'}, "log_errors_max_len", 
	$self->{'in_hash'}->{"log_errors_max_len_def"} ? undef : $self->{'in_hash'}->{"log_errors_max_len"});

# Save log file
if ($self->{'in_hash'}->{"error_log_def"} == 0) {
	$self->save_directive($self->{'conf'}, "error_log", undef);
	}
elsif ($self->{'in_hash'}->{"error_log_def"} == 1) {
	$self->save_directive($self->{'conf'}, "error_log", "syslog");
	}
elsif ($self->{'in_hash'}->{"error_log_def"} == 2) {
	$self->{'in_hash'}->{"error_log"} =~ /\S/ || $self->error($self->{'text_hash'}->{'errors_efile'});
	$self->save_directive($self->{'conf'}, "error_log", $self->{'in_hash'}->{"error_log"});
	}

$self->flush_file_lines($self->{'in_hash'}->{'file'});
$self->unlock_file($self->{'in_hash'}->{'file'});
$self->graceful_apache_restart();
$self->webmin_log("errors", undef, $self->{'in_hash'}->{'file'});

$self->redirect("list_ini.cgi?file=".$self->urlize($self->{'in_hash'}->{'file'}));

1;
		
}


1;

