#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Update options related to memory limits

&ModuleLoader::preload_module('phpini_class', "phpini::PhpiniLib");
$self = new phpini::PhpiniLib:: 'phpini_class',%$self;

$self->error_setup($self->{'text_hash'}->{'limits_err'});
$self->ReadParse();
$self->can_php_config($self->{'in_hash'}->{'file'}) || $self->error($self->{'text_hash'}->{'list_ecannot'});

$self->lock_file($self->{'in_hash'}->{'file'});
$self->{'conf'} = $self->get_config($self->{'in_hash'}->{'file'});

# Save memory limit
$self->{'in_hash'}->{"memory_limit_def"} || $self->{'in_hash'}->{"memory_limit"} =~ /^(\d+)(k|M|G|b|)$/ ||
	$self->error($self->{'text_hash'}->{'limits_emem'});
$self->save_directive($self->{'conf'}, "memory_limit",
		$self->{'in_hash'}->{"memory_limit_def"} ? undef : $self->{'in_hash'}->{"memory_limit"});

# Save POST limit
$self->{'in_hash'}->{"post_max_size_def"} || $self->{'in_hash'}->{"post_max_size"} =~ /^(\d+)(k|M|G|b|)$/ ||
	$self->error($self->{'text_hash'}->{'limits_epost'});
$self->save_directive($self->{'conf'}, "post_max_size",
		$self->{'in_hash'}->{"post_max_size_def"} ? undef : $self->{'in_hash'}->{"post_max_size"});

# Save upload limit
$self->{'in_hash'}->{"upload_max_filesize_def"} ||
    $self->{'in_hash'}->{"upload_max_filesize"} =~ /^(\d+)(k|M|G|b|)$/ ||
	$self->error($self->{'text_hash'}->{'limits_eupload'});
$self->save_directive($self->{'conf'}, "upload_max_filesize",
		$self->{'in_hash'}->{"upload_max_filesize_def"} ? undef
					       : $self->{'in_hash'}->{"upload_max_filesize"});

# Save max run time
$self->{'in_hash'}->{"max_execution_time_def"} || $self->{'in_hash'}->{"max_execution_time"} =~ /^\d+$/ ||
	$self->error($self->{'text_hash'}->{'limits_emem'});
$self->save_directive($self->{'conf'}, "max_execution_time",
	$self->{'in_hash'}->{"max_execution_time_def"} ? undef : $self->{'in_hash'}->{"max_execution_time"});

# Save max parsing time
$self->{'in_hash'}->{"max_input_time_def"} || $self->{'in_hash'}->{"max_input_time"} =~ /^\d+$/ ||
	$self->error($self->{'text_hash'}->{'limits_einput'});
$self->save_directive($self->{'conf'}, "max_input_time",
	$self->{'in_hash'}->{"max_input_time_def"} ? undef : $self->{'in_hash'}->{"max_input_time"});

$self->flush_file_lines($self->{'in_hash'}->{'file'});
$self->unlock_file($self->{'in_hash'}->{'file'});
$self->graceful_apache_restart();
$self->webmin_log("limits", undef, $self->{'in_hash'}->{'file'});

$self->redirect("list_ini.cgi?file=".$self->urlize($self->{'in_hash'}->{'file'}));

1;
		
}


1;

