#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Update misc PHP options

&ModuleLoader::preload_module('phpini_class', "phpini::PhpiniLib");
$self = new phpini::PhpiniLib:: 'phpini_class',%$self;

$self->error_setup($self->{'text_hash'}->{'misc_err'});
$self->ReadParse();
$self->can_php_config($self->{'in_hash'}->{'file'}) || $self->error($self->{'text_hash'}->{'list_ecannot'});

$self->lock_file($self->{'in_hash'}->{'file'});
$self->{'conf'} = $self->get_config($self->{'in_hash'}->{'file'});

# Save tag styles
$self->save_directive($self->{'conf'}, "short_open_tag",
		$self->{'in_hash'}->{"short_open_tag"} || undef);
$self->save_directive($self->{'conf'}, "asp_tags",
		$self->{'in_hash'}->{"asp_tags"} || undef);

# Save output options
$self->save_directive($self->{'conf'}, "zlib.output_compression",
		$self->{'in_hash'}->{"zlib.output_compression"} || undef);
$self->save_directive($self->{'conf'}, "implicit_flush",
		$self->{'in_hash'}->{"implicit_flush"} || undef);

# Save URL open options
$self->save_directive($self->{'conf'}, "allow_url_fopen",
		$self->{'in_hash'}->{"allow_url_fopen"} || undef);

# Save email sending options
$self->{'in_hash'}->{"smtp_def"} || gethostbyname($self->{'in_hash'}->{"smtp"}) || $self->error($self->{'text_hash'}->{'misc_esmtp'});
$self->save_directive($self->{'conf'}, "SMTP",
		$self->{'in_hash'}->{"smtp_def"} ? undef : $self->{'in_hash'}->{"smtp"});
$self->{'in_hash'}->{"smtp_port_def"} || $self->{'in_hash'}->{"smtp_port"} =~ /^\d+$/ ||
	$self->error($self->{'text_hash'}->{'misc_esmtp_port'});
$self->save_directive($self->{'conf'}, "smtp_port",
		$self->{'in_hash'}->{"smtp_port_def"} ? undef : $self->{'in_hash'}->{"smtp_port"});

# Save sendmail program
if ($self->{'in_hash'}->{"sendmail_path_def"}) {
	$self->save_directive($self->{'conf'}, "sendmail_path", undef);
	}
else {
	($self->{'fp'}) = split(/\s+/, $self->{'in_hash'}->{"sendmail_path"});
	$self->{'fp'} || $self->error($self->{'text_hash'}->{'misc_esendmail2'});
	$self->has_command($self->{'fp'}) || $self->error($self->{'text_hash'}->{'misc_esendmail'});
	$self->save_directive($self->{'conf'}, "sendmail_path", $self->{'in_hash'}->{"sendmail_path"});
	}

$self->flush_file_lines($self->{'in_hash'}->{'file'});
$self->unlock_file($self->{'in_hash'}->{'file'});
$self->graceful_apache_restart();
$self->webmin_log("misc", undef, $self->{'in_hash'}->{'file'});

$self->redirect("list_ini.cgi?file=".$self->urlize($self->{'in_hash'}->{'file'}));

1;
		
}


1;

