#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Update options related to safe mode

&ModuleLoader::preload_module('phpini_class', "phpini::PhpiniLib");
$self = new phpini::PhpiniLib:: 'phpini_class',%$self;

$self->error_setup($self->{'text_hash'}->{'safe_err'});
$self->ReadParse();
$self->can_php_config($self->{'in_hash'}->{'file'}) || $self->error($self->{'text_hash'}->{'list_ecannot'});

$self->lock_file($self->{'in_hash'}->{'file'});
$self->{'conf'} = $self->get_config($self->{'in_hash'}->{'file'});

# Validate and store inputs
$self->save_directive($self->{'conf'}, "safe_mode", $self->{'in_hash'}->{"safe_mode"} || undef);
$self->save_directive($self->{'conf'}, "safe_mode_gid", $self->{'in_hash'}->{"safe_mode_gid"} || undef);

foreach $d ([ "safe_mode_include_dir", "safe_einclude" ],
	    [ "safe_mode_exec_dir", "safe_eexec" ],
	    [ "open_basedir", "safe_ebasedir" ]) {
	if ($self->{'in_hash'}->{$d->[0]."_def"}) {
		$self->save_directive($self->{'conf'}, $d->[0], undef);
		}
	else {
		-d $self->{'in_hash'}->{$d->[0]} || $self->error($self->{'text_hash'}->{$d->[1]});
		$self->save_directive($self->{'conf'}, $d->[0], $self->{'in_hash'}->{$d->[0]});
		}
	}

$self->flush_file_lines($self->{'in_hash'}->{'file'});
$self->unlock_file($self->{'in_hash'}->{'file'});
$self->graceful_apache_restart();
$self->webmin_log("safe", undef, $self->{'in_hash'}->{'file'});

$self->redirect("list_ini.cgi?file=".$self->urlize($self->{'in_hash'}->{'file'}));

1;
		
}


1;

