#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Update options related to sessions

&ModuleLoader::preload_module('phpini_class', "phpini::PhpiniLib");
$self = new phpini::PhpiniLib:: 'phpini_class',%$self;

$self->error_setup($self->{'text_hash'}->{'session_err'});
$self->ReadParse();
$self->can_php_config($self->{'in_hash'}->{'file'}) || $self->error($self->{'text_hash'}->{'list_ecannot'});

$self->lock_file($self->{'in_hash'}->{'file'});
$self->{'conf'} = $self->get_config($self->{'in_hash'}->{'file'});

# Validate and store inputs
$self->save_directive($self->{'conf'}, "session.save_handler",
		$self->{'in_hash'}->{"session.save_handler"});
if ($self->{'in_hash'}->{"session.save_path_def"}) {
	$self->save_directive($self->{'conf'}, "session.save_path", undef);
	}
else {
	-d $self->{'in_hash'}->{"session.save_path"} || $self->error($self->{'text_hash'}->{'session_epath'});
	$self->save_directive($self->{'conf'}, "session.save_path",
			$self->{'in_hash'}->{"session.save_path"});
	}
$self->save_directive($self->{'conf'}, "session.use_cookies",
		$self->{'in_hash'}->{"session.use_cookies"} || undef);
$self->save_directive($self->{'conf'}, "session.use_only_cookies",
		$self->{'in_hash'}->{"session.use_only_cookies"} || undef);
if ($self->{'in_hash'}->{"session.cookie_lifetime_def"}) {
	$self->save_directive($self->{'conf'}, "session.cookie_lifetime", undef);
	}
else {
	$self->{'in_hash'}->{"session.cookie_lifetime"} =~ /^\d+$/ ||
		$self->error($self->{'text_hash'}->{'session_elife'});
	$self->save_directive($self->{'conf'}, "session.cookie_lifetime",
			$self->{'in_hash'}->{"session.cookie_lifetime"});
	}
if ($self->{'in_hash'}->{"session.gc_maxlifetime_def"}) {
	$self->save_directive($self->{'conf'}, "session.gc_maxlifetime", undef);
	}
else {
	$self->{'in_hash'}->{"session.gc_maxlifetime"} =~ /^\d+$/ ||
		$self->error($self->{'text_hash'}->{'session_emaxlife'});
	$self->save_directive($self->{'conf'}, "session.gc_maxlifetime",
			$self->{'in_hash'}->{"session.gc_maxlifetime"});
	}

$self->flush_file_lines($self->{'in_hash'}->{'file'});
$self->unlock_file($self->{'in_hash'}->{'file'});
$self->graceful_apache_restart();
$self->webmin_log("session", undef, $self->{'in_hash'}->{'file'});

$self->redirect("list_ini.cgi?file=".$self->urlize($self->{'in_hash'}->{'file'}));

1;
		
}


1;

