#!/usr/bin/perl

&MAIN();

 sub MAIN {
# configure.cgi
# plugins configuration script

# main part
&ModuleLoader::preload_module('plugins_class', "plugins::PluginsLib");
$self = new plugins::PluginsLib:: 'plugins_class',%$self;

$self->ReadParse();

# get ACL
local %access = $self->get_module_acl();
$self->error($self->{'text_hash'}->{'section_ecannot'}) unless ($access{'install'});

# plugin name
local $pl = $self->{'in_hash'}->{'pl'};
local $pl_name = $self->{'text_hash'}->{"plugin_$pl"};

# check plugin depends
local $func = $pl."_depends";
local ($dep, $nodep) = $self->$func();
foreach (keys %{$dep})
{
 if ($dep->{$_}->[0] == 0)
 {
  $nodep = 1;
  last;
 }
}
if ($nodep)
{
 # print depend warnings
 $self->ui_print_header(undef, $self->text('setup_title', $pl_name), "", undef, 0, 1);
 print "<table width=100% border=0>\n";
 print "<tr><td colspan=2>";
 foreach (keys %{$dep}) { $self->check_error($self->text($_."_depnd", "/$dep->{$_}->[1]/"))."<br>" if ($dep->{$_}->[0] == 0); } 
 print "</td></tr>";
 print "</td></tr></table>\n";
 $self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
 exit; 
}

# ------ confirm uninstall ----------
if ($self->{'in_hash'}->{'confirm_un'})
{
 local $rusure =  $self->text('uninstall_rusure', $self->{'text_hash'}->{"plugin_$pl"});
 
 $self->ui_print_header(undef, $self->text('uninstall_title', $pl_name), "", undef, 0, 1);
 print "<table width=100% border=0>\n";
 print "<tr><td colspan=2>";
 print $rusure;
 print "</td></tr>";
 print $self->ui_form_start('configure.cgi'), $self->ui_hidden('pl', $pl);
 print "<tr><td align=center>";
 print $self->ui_submit($self->{'text_hash'}->{'uninstall_confirm'}, 'uninstall');
 print $self->ui_form_end();
 print "</td></tr></table>\n";
 $self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
 exit;
}

# ------ configure ----------
# print at once
$| = 1;
$self->{'theme_no_table'} = 1;

# save this CGI from being killed by the upgrade
$SIG{'TERM'} = 'IGNORE';

if ($self->{'in_hash'}->{'confirm'})
{
 # install
 $self->ui_print_unbuffered_header(undef,$self->text('setup_title', $self->{'text_hash'}->{"plugin_$pl"}), "", undef, 0, 1);
 $self->error_setup($self->{'text_hash'}->{'setup_error'});
 print "$self->{'text_hash'}->{'waiting'}";
 print "<table width='100%'>\n";
  
 # install plugin
 $self->install_plugin($pl);
 $self->set_configured_flag($pl);
 $self->print_postinstall_log($pl);
 print "</table>\n";
}
elsif ($self->{'in_hash'}->{'confirm_up'})
{
 # install
 $self->ui_print_unbuffered_header(undef,$self->text('setup_title', $self->{'text_hash'}->{"plugin_$pl"}), "", undef, 0, 1);
 $self->error_setup($self->{'text_hash'}->{'update_error'});
 print "$self->{'text_hash'}->{'waiting'}";
 print "<table width='100%'>\n";
  
 # install plugin
 $self->install_plugin($pl,1);
 $self->set_configured_flag($pl);
 $self->print_postinstall_log($pl);
 print "</table>\n";
}
elsif ($self->{'in_hash'}->{'uninstall'})
{
 # uninstall
 $self->ui_print_unbuffered_header(undef, $self->text('uninstall_title', $self->{'text_hash'}->{"plugin_$pl"}), "", undef, 0, 1);
 $self->error_setup($self->{'text_hash'}->{'uninstall_error'});
 print "<table width='100%'>\n";
  
 # uninstall plugin
 $self->del_configured_flag($pl);
 $self->uninstall_plugin($pl);
 $self->print_postinstall_log($pl,1);
 print "</table>\n";
}
# print return url
$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
1;
		
}


1;

