#!/usr/bin/perl
package postfix::Backup_config;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'postfix::Backup_config');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;

&ModuleLoader::preload_module(ref($self), "postfix::PostfixLib");
$self = new postfix::PostfixLib:: ref($self), %$self; 

1;

1;
		return $self;
}

# backup_config_files()
# Returns files and directories that can be backed up
sub backup_config_files
{
	my $self = shift;

local @rv;

# Add main config file
push(@rv, $self->{'config_hash'}->{'postfix_config_file'});

# Add known map files
push(@rv, $self->get_maps_files("alias_maps"));
push(@rv, $self->get_maps_files("alias_database"));
push(@rv, $self->get_maps_files("canonical_maps"));
push(@rv, $self->get_maps_files("recipient_canonical_maps"));
push(@rv, $self->get_maps_files("sender_canonical_maps"));
push(@rv, $self->get_maps_files($self->{'virtual_maps'}));
push(@rv, $self->get_maps_files("transport_maps"));
push(@rv, $self->get_maps_files("relocated_maps"));

# Add other files in /etc/postfix
local $cdir = $self->guess_config_dir();
opendir(DIR, $cdir);
foreach $f (readdir(DIR)) {
	next if ($f eq "." || $f eq ".." || $f =~ /\.(db|dir|pag)$/i);
	push(@rv, "$cdir/$f");
	}
closedir(DIR);

return $self->unique(@rv);
}

# pre_backup(&files)
# Called before the files are actually read
sub pre_backup
{
	my $self = shift;

return undef;
}

# post_backup(&files)
# Called after the files are actually read
sub post_backup
{
	my $self = shift;

return undef;
}

# pre_restore(&files)
# Called before the files are restored from a backup
sub pre_restore
{
	my $self = shift;

return undef;
}

# post_restore(&files)
# Called after the files are restored from a backup
sub post_restore
{
	my $self = shift;

if ($self->is_postfix_running()) {
	local $out = `$self->{'config_hash'}->{'postfix_control_command'} -c $self->{'config_dir'} reload 2>&1`;
	return "<tt>$out</tt>" if ($?);
	}
return undef;
}


1;

