#!/usr/bin/perl

&MAIN();

 sub MAIN {
#
# postfix-module by Guillaume Cottenceau <gc@mandrakesoft.com>,
# for webmin by Jamie Cameron
#
# Copyright (c) 2000 by Mandrakesoft
#
# Permission to use, copy, modify, and distribute this software and its
# documentation under the terms of the GNU General Public License is hereby 
# granted. No representations are made about the suitability of this software 
# for any purpose. It is provided "as is" without express or implied warranty.
# See the GNU General Public License for more details.
#
# 
# Manages aliases for Postfix
#
# << Here are all options seen in Postfix sample-aliases.cf >>

&ModuleLoader::preload_module('postfix_class', "postfix::PostfixLib");
$self = new postfix::PostfixLib:: 'postfix_class',%$self;


$self->{'access_hash'}->{'aliases'} || $self->error($self->{'text_hash'}->{'aliases_ecannot'});
$self->ui_print_header(undef, $self->{'text_hash'}->{'aliases_title'}, "", "aliases");

# alias general options

print "<form action=save_opts_aliases.cgi>\n";
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'aliasopts_title'}</b></td></tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

print "<tr>\n";
$self->option_freefield("alias_maps", 60);
print "</tr>\n";

print "<tr>\n";
$self->option_freefield("alias_database", 60);
print "</tr>\n";

print "</table></td></tr></table><p>\n";
print "$self->{'text_hash'}->{'aliases_warning'}<p><br>\n";
print "<input type=submit value=\"$self->{'text_hash'}->{'opts_save'}\"></form>\n";
print "<hr>\n";
print "<br>\n";

# double-table displaying all aliases

local @afiles = $self->get_aliases_files($self->get_current_value("alias_maps"));
local @aliases = $self->list_aliases(\@afiles);
if ($self->{'config_hash'}->{'sort_mode'} == 1) {
	@aliases = sort { lc($a->{'name'}) cmp lc($b->{'name'}) }
			@aliases;
	}

print $self->{'text_hash'}->{'aliases_click'}, "\n<br>\n";

# find a good place to split
$self->{'lines'} = 0;
for($i=0; $i<@aliases; $i++) {
	$self->{'aline_array'}->[$i] = $self->{'lines'};
	$self->{'al'} = scalar(@{$aliases[$i]->{'values'}});
	$self->{'lines'} += ($self->{'al'} ? $self->{'al'} : 1);
	}
$self->{'midline'} = int(($self->{'lines'}+1) / 2);
for($mid=0; $mid<@aliases && $self->{'aline_array'}->[$mid] < $self->{'midline'}; $mid++) { }

# render tables
print $self->ui_form_start("delete_aliases.cgi", "post");
@{$self->{'links_array'}} = ( $self->select_all_link("d", 1),
	   $self->select_invert_link("d", 1) );
print $self->ui_links_row(\@{$self->{'links_array'}});
if ($self->{'config_hash'}->{'columns'} == 2) {
	print "<table width=100%> <tr><td width=50% valign=top>\n";
	&aliases_table(@aliases[0..$mid-1]);
	print "</td><td width=50% valign=top>\n";
	if ($mid < @aliases) { &aliases_table(@aliases[$mid..$#aliases]); }
	print "</td></tr> </table><br>\n";
	}
else {
	&aliases_table(@aliases);
	}
print $self->ui_links_row(\@{$self->{'links_array'}});
print $self->ui_form_end([ [ "delete", $self->{'text_hash'}->{'aliases_delete'} ] ]);

# new alias form
print "<table cellpadding=5 width=100%><tr><td>\n";
print "<form action=edit_alias.cgi>\n";
print "<input type=hidden name=new value=1>\n";
print "<input type=submit value=\"$self->{'text_hash'}->{'new_alias'}\">\n";
print "</td> <td width=\"99%\">$self->{'text_hash'}->{'new_aliasmsg'}\n";
print "</td></tr></table></form>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}

sub aliases_table
{
	shift if ($self == $_[0]);

local @tds = ( "width=5", "valign=top", "valign=top" );
print $self->ui_columns_start([ "",
			  $self->{'text_hash'}->{'aliases_addr'},
			  $self->{'text_hash'}->{'aliases_to'},
			  $self->{'config_hash'}->{'show_cmts'} ? ( $self->{'text_hash'}->{'mapping_cmt'} )
					       : ( ) ], 100, 0, \@tds);
foreach $a (@_) {
	local @cols;
	push(@cols, "<a href=\"edit_alias.cgi?num=$a->{'num'}\">".
	      ($a->{'enabled'} ? "" : "<i>").$self->html_escape($a->{'name'}).
	      ($a->{'enabled'} ? "" : "</i>")."</a>");
	local $vstr;
	foreach $v (@{$a->{'values'}}) {
		($self->{'anum'}, $self->{'astr'}) = $self->alias_type($v);
		$vstr .= $self->text("aliases_type$self->{'anum'}",
			    "<tt>".$self->html_escape($self->{'astr'})."</tt>")."<br>\n";
		}
	$vstr ||= "<i>$self->{'text_hash'}->{'aliases_none'}</i>\n";
	push(@cols, $vstr);
	push(@cols, $self->html_escape($a->{'cmt'})) if ($self->{'config_hash'}->{'show_cmts'});
	print $self->ui_checked_columns_row(\@cols, \@tds, "d", $a->{'name'});
	}
print $self->ui_columns_end();
}


1;

