#!/usr/bin/perl

&MAIN();

 sub MAIN {
# delete_queues.cgi
# Delete multiple messages from the postfix queue

&ModuleLoader::preload_module('postfix_class', "postfix::PostfixLib");
$self = new postfix::PostfixLib:: 'postfix_class',%$self;

$self->{'access_hash'}->{'mailq'} || $self->error($self->{'text_hash'}->{'mailq_ecannot'});
$self->ReadParse();

if ($self->{'in_hash'}->{'move'}) {
	# Re-queuing messages
	foreach $f (split(/\0/, $self->{'in_hash'}->{'file'})) {
		$self->system_logged("$self->{'config_hash'}->{'postfix_super_command'} -r ".
				quotemeta($f));
		}
	}
elsif ($self->{'in_hash'}->{'hold'}) {
	# Holding messages
	foreach $f (split(/\0/, $self->{'in_hash'}->{'file'})) {
		$self->system_logged("$self->{'config_hash'}->{'postfix_super_command'} -h ".
				quotemeta($f));
		}
	}
elsif ($self->{'in_hash'}->{'unhold'}) {
	# Un-holding messages
	foreach $f (split(/\0/, $self->{'in_hash'}->{'file'})) {
		$self->system_logged("$self->{'config_hash'}->{'postfix_super_command'} -H ".
				quotemeta($f));
		}
	}
else {
	@{$self->{'files_array'}} = split(/\0/, $self->{'in_hash'}->{'file'});
	if ($self->{'in_hash'}->{'confirm'}) {
		# Deleting messages
		if ($self->{'postfix_version'} < 1.1) {
			@{$self->{'qfiles_array'}} = $self->recurse_files($self->{'config_hash'}->{'mailq_dir'});
			}
		foreach $f (@{$self->{'files_array'}}) {
			$f =~ /^[A-Za-z0-9]+$/ || next;
			if ($self->{'postfix_version'} >= 1.1) {
				$self->system_logged("$self->{'config_hash'}->{'postfix_super_command'} -d ".quotemeta($f));
				}
			else {
				$self->unlink_file(grep { $_ =~ /\/$f$/ } @{$self->{'qfiles_array'}});
				}
			}
		if ($self->{'postfix_version'} < 1.1) {
			$self->system_logged("$self->{'config_hash'}->{'postfix_super_command'} -p >/dev/null 2>&1");
			}
		$self->webmin_log("delqs", undef, scalar(@{$self->{'files_array'}}));
		}
	else {
		# Ask for confirmation
		$self->ui_print_header(undef, $self->{'text_hash'}->{'delq_titles'}, "");
		print "<center>\n";
		print $self->ui_form_start("delete_queues.cgi", "post");
		print $self->text('delq_rusure', scalar(@{$self->{'files_array'}})),"<p>\n";
		foreach $f (@{$self->{'files_array'}}) {
			print $self->ui_hidden("file", $f),"\n";
			}
		print $self->ui_form_end([ [ "confirm", $self->{'text_hash'}->{'delq_confirm'} ] ]);
		print "</center>\n";
		$self->ui_print_footer("mailq.cgi", $self->{'text_hash'}->{'mailq_return'});
		exit;
		}
	}
$self->redirect("mailq.cgi");

1;
		
}


1;

