#!/usr/bin/perl

&MAIN();

 sub MAIN {
#
# postfix-module by Guillaume Cottenceau <gc@mandrakesoft.com>,
# for webmin by Jamie Cameron
#
# Copyright (c) 2000 by Mandrakesoft
#
# Permission to use, copy, modify, and distribute this software and its
# documentation under the terms of the GNU General Public License is hereby 
# granted. No representations are made about the suitability of this software 
# for any purpose. It is provided "as is" without express or implied warranty.
# See the GNU General Public License for more details.
#
# 
# Edit a mapping

&ModuleLoader::preload_module('postfix_class', "postfix::PostfixLib");
$self = new postfix::PostfixLib:: 'postfix_class',%$self;

$self->ReadParse();

$self->ui_print_header(undef, $self->{'text_hash'}->{'edit_map_title'}, "");

local $new_one = 0;
local $num;
## added to split main_parameter:sub_parameter
local ($mainparm,$subparm)=split /:/,$self->{'in_hash'}->{'map_name'};

if (!exists($self->{'in_hash'}->{'num'}))
{
    $num = $self->init_new_mapping($self->{'in_hash'}->{'map_name'});
    $new_one = 1;
}
else
{
    $num = $self->{'in_hash'}->{'num'};
}

local $maps = $self->get_maps($self->{'in_hash'}->{'map_name'});
local %map;

foreach $trans (@{$maps})
{
    if ($trans->{'number'} == $num) { %map = %{$trans}; }
}    

print $self->ui_form_start("save_map.cgi");
print $self->ui_hidden("num", $num),"\n";
print $self->ui_hidden("map_name", $self->{'in_hash'}->{'map_name'}),"\n";
print $self->ui_table_start($self->{'text_hash'}->{'edit_map_title'}, "width=100%", 2);

# Show map comment
print $self->ui_table_row($self->{'text_hash'}->{'mapping_cmt'},
		    $self->ui_textbox("cmt", $map{'cmt'}, 50));

##$self->{'nfunc'} = "edit_name_".$self->{'in_hash'}->{'map_name'};
## modified to capture subparameters
$self->{'nfunc'}="edit_name_"; $self->{'nfunc'}.=($subparm)? $subparm : $mainparm;
if ($self->UNIVERSAL::can($self->{'nfunc'})) {
	print do { my $fn = $self->{'nfunc'}; $self->$fn(\%map)};
	}
else {
	print $self->ui_table_row($self->{'text_hash'}->{'mapping_name'},
			    $self->ui_textbox("name", $map{'name'}, 40));
	}

##$self->{'vfunc'} = "edit_value_".$self->{'in_hash'}->{'map_name'};
## modified to capture subparameters
$self->{'vfunc'}="edit_value_"; $self->{'vfunc'}.=($subparm)? $subparm : $mainparm;
if ($self->UNIVERSAL::can($self->{'vfunc'})) {
	print do { my $fn = $self->{'vfunc'}; $self->$fn(\%map)};
	}
else {
	print $self->ui_table_row($self->{'text_hash'}->{'mapping_value'},
			    $self->ui_textbox("value", $map{'value'}, 40));
	}

print $self->ui_table_end();
print $self->ui_form_end([ [ "save", $self->{'text_hash'}->{'map_save'} ],
	     $new_one ? ( ) : ( [ "delete", $self->{'text_hash'}->{'delete_map'} ] )
	     ]);

if ($self->{'in_hash'}->{'map_name'} eq $self->{'virtual_maps'}) {
	$self->ui_print_footer("virtual.cgi", $self->{'text_hash'}->{'virtual_return'});
	}
elsif ($self->{'in_hash'}->{'map_name'} eq 'canonical_maps') {
	$self->ui_print_footer($ENV{'HTTP_REFERER'},
			 $self->{'text_hash'}->{'canonical_return'});
	}
elsif ($self->{'in_hash'}->{'map_name'} eq 'sender_canonical_maps') {
	$self->ui_print_footer($ENV{'HTTP_REFERER'},
			 $self->{'text_hash'}->{'canonical_return_sender'});
	}
elsif ($self->{'in_hash'}->{'map_name'} eq 'recipient_canonical_maps') {
	$self->ui_print_footer($ENV{'HTTP_REFERER'},
			 $self->{'text_hash'}->{'canonical_return_recipient'});
	}
elsif ($self->{'in_hash'}->{'map_name'} eq 'transport_maps') {
	$self->ui_print_footer("transport.cgi", $self->{'text_hash'}->{'transport_return'});
	}
elsif ($self->{'in_hash'}->{'map_name'} eq 'relocated_maps') {
	$self->ui_print_footer("relocated.cgi", $self->{'text_hash'}->{'relocated_return'});
	}
elsif ($self->{'in_hash'}->{'map_name'} eq 'header_checks') {
	$self->ui_print_footer("header.cgi", $self->{'text_hash'}->{'header_return'});
	}
elsif ($self->{'in_hash'}->{'map_name'} eq 'body_checks') {
	$self->ui_print_footer("body.cgi", $self->{'text_hash'}->{'body_return'});
	}
elsif ($self->{'in_hash'}->{'map_name'} =~ /check_sender_access/) {
	$self->ui_print_footer("edit_access.cgi?name=smtpd_client_restrictions:check_sender_access&title=Check sender access mapping table", $self->{'text_hash'}->{'access_return'});
	}
else {
	$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
	}

1;
		
}


1;

