#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Edit or create a server process

&ModuleLoader::preload_module('postfix_class', "postfix::PostfixLib");
$self = new postfix::PostfixLib:: 'postfix_class',%$self;

$self->{'access_hash'}->{'master'} || $self->error($self->{'text_hash'}->{'master_ecannot'});
$self->ReadParse();
$self->{'master'} = $self->get_master_config();

if ($self->{'in_hash'}->{'new'}) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'master_create'}, "");
	$self->{'prog'} = { 'enabled' => 1,
		  'type' => 'inet',
		  'private' => '-',
		  'unpriv' => '-',
		  'chroot' => '-',
		  'wakeup' => '-',
		  'maxprocs' => '-',
		};
	}
else {
	($self->{'prog'}) = grep { $_->{'name'} eq $self->{'in_hash'}->{'name'} } @{$self->{'master'}};
	$self->{'prog'} || $self->error($self->{'text_hash'}->{'master_egone'});
	$self->ui_print_header(undef, $self->{'text_hash'}->{'master_edit'}, "");
	}

print $self->ui_form_start("save_master.cgi", "post");
print $self->ui_hidden("new", $self->{'in_hash'}->{'new'}),"\n";
print $self->ui_hidden("old", $self->{'in_hash'}->{'name'}),"\n";
print $self->ui_table_start($self->{'text_hash'}->{'master_header'}, "width=100%", 4);

print $self->ui_table_row($self->{'text_hash'}->{'master_type'},
	    $self->ui_select("type", $self->{'prog'}->{'type'},
		[ [ "inet", $self->{'text_hash'}->{'master_inet'} ],
		  [ "unix", $self->{'text_hash'}->{'master_unix'} ],
		  [ "fifo", $self->{'text_hash'}->{'master_fifo'} ] ]));

print $self->ui_table_row($self->{'text_hash'}->{'master_enabled'},
		    $self->ui_yesno_radio("enabled", int($self->{'prog'}->{'enabled'})));

if ($self->{'prog'}->{'name'} =~ s/^(\S+)://) {
	$self->{'host'} = $1;
	}
print $self->ui_table_row($self->{'text_hash'}->{'master_name2'},
		    $self->ui_textbox("name", $self->{'prog'}->{'name'}, 20));

print $self->ui_table_row($self->{'text_hash'}->{'master_host'},
		    $self->ui_opt_textbox("host", $self->{'host'}, 15, $self->{'text_hash'}->{'master_any'}));

print $self->ui_table_row($self->{'text_hash'}->{'master_command'},
		    $self->ui_textbox("command", $self->{'prog'}->{'command'}, 80), 3);

print $self->ui_table_hr();

print $self->ui_table_row($self->{'text_hash'}->{'master_private2'},
		    $self->ui_radio("private", $self->{'prog'}->{'private'},
			[ [ "y", $self->{'text_hash'}->{'yes'} ],
			  [ "n", $self->{'text_hash'}->{'no'} ],
			  [ "-", $self->{'text_hash'}->{'master_defyes'} ] ]));

print $self->ui_table_row($self->{'text_hash'}->{'master_unpriv2'},
		    $self->ui_radio("unpriv", $self->{'prog'}->{'unpriv'},
			[ [ "y", $self->{'text_hash'}->{'yes'} ],
			  [ "n", $self->{'text_hash'}->{'no'} ],
			  [ "-", $self->{'text_hash'}->{'master_defyes'} ] ]));

print $self->ui_table_row($self->{'text_hash'}->{'master_chroot2'},
		    $self->ui_radio("chroot", $self->{'prog'}->{'chroot'},
			[ [ "y", $self->{'text_hash'}->{'yes'} ],
			  [ "n", $self->{'text_hash'}->{'no'} ],
			  [ "-", $self->{'text_hash'}->{'master_defyes'} ] ]));

$self->{'wmode'} = $self->{'prog'}->{'wakeup'} eq '-' ? 0 :
	 $self->{'prog'}->{'wakeup'} eq '0' ? 1 : 2;
$self->{'wused'} = $self->{'prog'}->{'wakeup'} =~ s/\?$//;
print $self->ui_table_row($self->{'text_hash'}->{'master_wakeup'},
    $self->ui_radio("wakeup", $self->{'wmode'},
	[ [ 0, $self->{'text_hash'}->{'default'} ],
	  [ 1, $self->{'text_hash'}->{'master_unlimit'} ],
	  [ 2, $self->text('master_wtime',
	$self->ui_textbox("wtime", $self->{'wmode'} == 2 ? $self->{'prog'}->{'wakeup'} : "", 6)) ] ]).
        " (".$self->ui_checkbox("wused", 1, $self->{'text_hash'}->{'master_wused'}, $self->{'wused'}).")", 3);

$self->{'pmode'} = $self->{'prog'}->{'maxprocs'} eq '-' ? 0 :
	 $self->{'prog'}->{'maxprocs'} eq '0' ? 1 : 2;
print $self->ui_table_row($self->{'text_hash'}->{'master_max2'},
    $self->ui_radio("maxprocs", $self->{'pmode'},
	[ [ 0, $self->{'text_hash'}->{'default'} ],
	  [ 1, $self->{'text_hash'}->{'master_unlimit'} ],
	  [ 2, $self->text('master_procs',
	$self->ui_textbox("procs", $self->{'pmode'} == 2 ? $self->{'prog'}->{'maxprocs'} : "", 6)) ] ]),
		3);

print $self->ui_table_end();
print $self->ui_form_end([
	$self->{'in_hash'}->{'new'} ? ( [ "create", $self->{'text_hash'}->{'create'} ] )
	   : ( [ "save", $self->{'text_hash'}->{'save'} ], [ "delete", $self->{'text_hash'}->{'delete'} ] ) ] );

$self->ui_print_footer("master.cgi", $self->{'text_hash'}->{'master_return'},
		 "", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

