#!/usr/bin/perl

&MAIN();

 sub MAIN {
#
# postfix-module by Guillaume Cottenceau <gc@mandrakesoft.com>,
# for webmin by Jamie Cameron
#
# Copyright (c) 2000 by Mandrakesoft
#
# Permission to use, copy, modify, and distribute this software and its
# documentation under the terms of the GNU General Public License is hereby 
# granted. No representations are made about the suitability of this software 
# for any purpose. It is provided "as is" without express or implied warranty.
# See the GNU General Public License for more details.
#
#
# A form for controlling general parameters.
#
# << Here are all options seen in Postfix sample-misc.cf >>

&ModuleLoader::preload_module('postfix_class', "postfix::PostfixLib");
$self = new postfix::PostfixLib:: 'postfix_class',%$self;


$self->{'access_hash'}->{'general'} || $self->error($self->{'text_hash'}->{'general_ecannot'});
$self->ui_print_header(undef, $self->{'text_hash'}->{'general_title'}, "", "general_opts");

$self->{'default'} = $self->{'text_hash'}->{'opts_default'};
$self->{'none'} = $self->{'text_hash'}->{'opts_none'};
$self->{'no_'} = $self->{'text_hash'}->{'opts_no'};

print "<form action=save_opts_misc.cgi method=post>\n";
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'general_title_sensible'}</b> <font size=\"-1\">".$self->hlink("$self->{'text_hash'}->{'what_is_it'}", "general_opts")."</font></td></tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

print "<tr>\n";
$self->option_radios_freefield("myorigin", 30, $self->{'text_hash'}->{'opts_myorigin_as_myhostname'},
			                 '$mydomain', $self->{'text_hash'}->{'opts_myorigin_as_mydomain'});
print "</tr>\n";

print "<tr>\n";
$self->option_radios_freefield("mydestination", 60, $self->{'text_hash'}->{'opts_mydestination_default'},
			                      '$myhostname, localhost.$mydomain, $mydomain', $self->{'text_hash'}->{'opts_mydestination_domainwide'});
print "</tr>\n";

print "<tr>\n";
$self->option_radios_freefield("notify_classes", 40, $self->{'default'});
print "</tr>\n";

print "</table></td></tr>\n";
print "<tr $self->{'tb'}><td><b>$self->{'text_hash'}->{'general_title_others'}</b></td></tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

print "<tr>\n";
$self->option_radios_freefield("relayhost", 45, $self->{'text_hash'}->{'opts_direct'});
print "</tr>\n";

print "<tr>\n";
$self->option_radios_freefield("always_bcc", 40, $self->{'text_hash'}->{'opts_always_bcc_none'});
print "</tr>\n";

print "<tr>\n";
$self->option_freefield("daemon_timeout", 15);
$self->option_freefield("default_database_type", 15);
print "</tr>\n";

print "<tr>\n";
$self->option_freefield("default_transport", 15);
$self->option_freefield("double_bounce_sender", 15);
print "</tr>\n";

print "<tr>\n";
$self->option_freefield("hash_queue_depth", 15);
$self->option_freefield("hash_queue_names", 15);
print "</tr>\n";

print "<tr>\n";
$self->option_freefield("hopcount_limit", 15);
$self->option_radios_freefield("delay_warning_time", 15, $self->{'text_hash'}->{'opts_delay_warning_time_default'});
print "</tr>\n";

print "<tr>\n";
$self->option_radios_freefield("inet_interfaces", 40, $self->{'text_hash'}->{'opts_all_interfaces'});
print "</tr>\n";

print "<tr>\n";
$self->option_freefield("ipc_idle", 15);
$self->option_freefield("ipc_timeout", 15);
print "</tr>\n";

print "<tr>\n";
$self->option_freefield("mail_name", 15);
$self->option_freefield("mail_owner", 15);
print "</tr>\n";

print "<tr>\n";
$self->option_freefield("mail_version", 25);
print "</tr>\n";

print "<tr>\n";
$self->option_freefield("max_idle", 15);
$self->option_freefield("max_use", 15);
print "</tr>\n";

print "<tr>\n";
$self->option_radios_freefield("myhostname", 40, $self->{'text_hash'}->{'opts_myhostname_default'});
print "</tr>\n";

print "<tr>\n";
$self->option_radios_freefield("mydomain", 40, $self->{'text_hash'}->{'opts_mydomain_default'});
print "</tr>\n";

print "<tr>\n";
$self->option_radios_freefield("mynetworks", 60, $self->{'text_hash'}->{'opts_mynetworks_default'});
print "</tr>\n";

print "<tr>\n";
$self->option_select("mynetworks_style",
	       [ [ "", $self->{'text_hash'}->{'default'} ],
		 [ "subnet", $self->{'text_hash'}->{'opts_mynetworks_subnet'} ],
		 [ "class", $self->{'text_hash'}->{'opts_mynetworks_class'} ],
		 [ "host", $self->{'text_hash'}->{'opts_mynetworks_host'} ] ]);
print "</tr>\n";

print "<tr>\n";
$self->option_radios_freefield("bounce_notice_recipient", 15, $self->{'default'});
$self->option_radios_freefield("2bounce_notice_recipient", 15, $self->{'default'});
print "<tr>\n";

print "</tr>\n";
$self->option_radios_freefield("delay_notice_recipient", 15, $self->{'default'});
$self->option_radios_freefield("error_notice_recipient", 15, $self->{'default'});
print "</tr>\n";

print "<tr>\n";
$self->option_freefield("queue_directory", 45);
print "</tr>\n";

print "<tr>\n";
$self->option_freefield("process_id_directory", 20);
$self->option_freefield("recipient_delimiter", 20);
print "</tr>\n";

if ($self->{'postfix_version'} < 2.1) {
	print "<tr>\n";
	$self->option_freefield("program_directory", 45);
	print "</tr>\n";
	}

print "<tr>\n";
$self->option_radios_freefield("relocated_maps", 60, $self->{'text_hash'}->{'opts_relocated_maps_default'});
print "</tr>\n";

print "<tr>\n";
$self->option_yesno("sun_mailtool_compatibility", 'help');
$self->option_freefield("trigger_timeout", 15);
print "</tr>\n";

print "<tr>\n";
$self->option_radios_freefield("content_filter", 60, $self->{'text_hash'}->{'opts_content_filter_default'});
print "</tr>\n";

print "</table></td></tr></table><p>\n";
print "<input type=submit value=\"$self->{'text_hash'}->{'opts_save'}\"></form>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
1;
		
}


1;

