#!/usr/bin/perl

&MAIN();

 sub MAIN {
#
# postfix-module by Guillaume Cottenceau <gc@mandrakesoft.com>,
# for webmin by Jamie Cameron
#
# Copyright (c) 2000 by Mandrakesoft
#
# Permission to use, copy, modify, and distribute this software and its
# documentation under the terms of the GNU General Public License is hereby 
# granted. No representations are made about the suitability of this software 
# for any purpose. It is provided "as is" without express or implied warranty.
# See the GNU General Public License for more details.
#
#
# A form for controling ldap lookups.
#
# << Here are all options seen in Postfix sample-ldap.cf >>

&ModuleLoader::preload_module('postfix_class', "postfix::PostfixLib");
$self = new postfix::PostfixLib:: 'postfix_class',%$self;


$self->{'access_hash'}->{'ldap'} || $self->error($self->{'text_hash'}->{'ldap_ecannot'});
$self->ui_print_header(undef, $self->{'text_hash'}->{'ldap_title'}, "");

$self->{'default'} = $self->{'text_hash'}->{'opts_default'};
$self->{'none'} = $self->{'text_hash'}->{'opts_none'};
$self->{'no_'} = $self->{'text_hash'}->{'opts_no'};

if (!($self->is_existing_parameter($self->{'ldap_timeout'})))
{
    print "$self->{'text_hash'}->{'ldap_non_existent'}<p>\n";
    $self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
    exit;
}

print "<form action=save_opts.cgi>\n";
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'ldap_title'}</b></td></tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

print "<tr>\n";
$self->option_freefield($self->{'ldap_timeout'}, 15);
print "</tr>\n";

print "<tr>\n";
$self->option_radios_freefield("ldap_search_base", 65, $self->{'none'});
print "</tr>\n";

print "<tr>\n";
$self->option_radios_freefield("ldap_server_host", 65, $self->{'none'});
print "</tr>\n";

print "</table></td></tr></table><p>\n";
print "<input type=submit value=\"$self->{'text_hash'}->{'opts_save'}\"></form>\n";
$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

