#!/usr/bin/perl

&MAIN();

 sub MAIN {
# mailq.cgi
# Display messages currently in the queue.

&ModuleLoader::preload_module('postfix_class', "postfix::PostfixLib");
$self = new postfix::PostfixLib:: 'postfix_class',%$self;

&ModuleLoader::preload_module('postfix_class', "postfix::BoxesLib");
$self = new postfix::BoxesLib:: 'postfix_class',%$self;

$self->ReadParse();

$self->{'access_hash'}->{'mailq'} || $self->error($self->{'text_hash'}->{'mailq_ecannot'});
$self->ui_print_header(undef, $self->{'text_hash'}->{'mailq_title'}, "");

@{$self->{'qfiles_array'}} = $self->list_queue();
if ($self->{'config_hash'}->{'mailq_sort'} == 0) {
	@{$self->{'qfiles_array'}} = sort { $a->{'id'} cmp $b->{'id'} } @{$self->{'qfiles_array'}};
	}
elsif ($self->{'config_hash'}->{'mailq_sort'} == 1) {
	@{$self->{'qfiles_array'}} = sort { lc($a->{'from'}) cmp lc($b->{'from'}) } @{$self->{'qfiles_array'}};
	}
elsif ($self->{'config_hash'}->{'mailq_sort'} == 2) {
	@{$self->{'qfiles_array'}} = sort { lc($a->{'to'}) cmp lc($b->{'to'}) } @{$self->{'qfiles_array'}};
	}
elsif ($self->{'config_hash'}->{'mailq_sort'} == 4) {
	@{$self->{'qfiles_array'}} = sort { lc($a->{'status'}) cmp lc($b->{'status'}) } @{$self->{'qfiles_array'}};
	}
elsif ($self->{'config_hash'}->{'mailq_sort'} == 5) {
	@{$self->{'qfiles_array'}} = sort { $b->{'size'} <=> $a->{'size'} } @{$self->{'qfiles_array'}};
	}

if (@{$self->{'qfiles_array'}}) {
	if (@{$self->{'qfiles_array'}} > $self->{'config_hash'}->{'perpage'}) {
		# Need to show arrows
		print "<center>\n";
		$self->{'s'} = int($self->{'in_hash'}->{'start'});
		$self->{'e'} = $self->{'in_hash'}->{'start'} + $self->{'config_hash'}->{'perpage'} - 1;
		$self->{'e'} = @{$self->{'qfiles_array'}}-1 if ($self->{'e'} >= @{$self->{'qfiles_array'}});
		if ($self->{'s'}) {
			printf "<a href='mailq.cgi?start=%d'>%s</a>\n",
			    $self->{'s'} - $self->{'config_hash'}->{'perpage'},
			    "<img src=/images/left.gif border=0 align=middle>";
			}
		print "<font size=+1>",$self->text('mail_pos', $self->{'s'}+1, $self->{'e'}+1,
					     scalar(@{$self->{'qfiles_array'}})),"</font>\n";
		if ($self->{'e'} < @{$self->{'qfiles_array'}}-1) {
			printf "<a href='mailq.cgi?start=%d'>%s</a>\n",
			    $self->{'s'} + $self->{'config_hash'}->{'perpage'},
			    "<img src=/images/right.gif border=0 align=middle>";
			}
		print "</center>\n";
		}
	else {
		# Can show them all
		$self->{'s'} = 0;
		$self->{'e'} = @{$self->{'qfiles_array'}} - 1;
		}

	# Show the mails
	$self->mailq_table([ @{$self->{'qfiles_array'}}[$self->{'s'} .. $self->{'e'}] ]);

	# Show queue search form
	print "<form action=mailq_search.cgi>\n";
	print "<b>$self->{'text_hash'}->{'mailq_search'}</b>\n";
	print "<select name=field>\n";
	foreach $f ('from', 'to', 'date', 'size', '',
	    	    '!from', '!to', '!date', '!size') {
		printf "<option value='%s'>%s\n", $f, $self->{'text_hash'}->{"match_$f"};
		}
	print "</select>\n";
	print "<input name=match size=20>\n";
	print "&nbsp;<input type=submit value='$self->{'text_hash'}->{'mail_ok'}'>\n";
	print "</form><p>\n";

	# Show flush button, if the needed command is installed
	if ($self->has_command($self->{'config_hash'}->{'postfix_queue_command'})) {
		print "<hr>\n";
		print "<table width=100%><tr><form action=flushq.cgi>\n";
		print "<td><input type=submit ",
		      "value='$self->{'text_hash'}->{'mailq_flush'}'></td>\n";
		print "<td>$self->{'text_hash'}->{'mailq_flushdesc'}</td>\n";
		print "</form></tr></table>\n";
		}
	}
else {
	print "<b>$self->{'text_hash'}->{'mailq_none'}</b> <p>\n";
	}

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

