#!/usr/bin/perl

&MAIN();

 sub MAIN {
#
# postfix-module by Guillaume Cottenceau <gc@mandrakesoft.com>,
# for webmin by Jamie Cameron
#
# Copyright (c) 2000 by Mandrakesoft
#
# Permission to use, copy, modify, and distribute this software and its
# documentation under the terms of the GNU General Public License is hereby 
# granted. No representations are made about the suitability of this software 
# for any purpose. It is provided "as is" without express or implied warranty.
# See the GNU General Public License for more details.
#
#
# Save, modify, delete an alias for Postfix

&ModuleLoader::preload_module('postfix_class', "postfix::PostfixLib");
$self = new postfix::PostfixLib:: 'postfix_class',%$self;

$self->ReadParse();

$self->{'access_hash'}->{'aliases'} || $self->error($self->{'text_hash'}->{'aliases_ecannot'});
$self->error_setup($self->{'text_hash'}->{'alias_save_err'});

# Get the alias (if editing or deleting)
@{$self->{'afiles_array'}} = $self->get_aliases_files($self->get_current_value("alias_maps"));
@{$self->{'aliases_array'}} = $self->list_aliases(\@{$self->{'afiles_array'}});
if (!$self->{'in_hash'}->{'new'}) {
	$self->{'a'} = $self->{'aliases_array'}->[$self->{'in_hash'}->{'num'}];
	}
$self->lock_alias_files(\@{$self->{'afiles_array'}});

if ($self->{'in_hash'}->{'delete'}) {
	# delete some alias
	$self->delete_alias($self->{'a'}, \@{$self->{'afiles_array'}});
	$self->{'loga'} = $self->{'a'};
	}
else {
	# saving or creating .. check inputs
	$self->{'in_hash'}->{'name'} =~ /^[^:@ ]+$/ ||
		$self->error($self->text('asave_eaddr', $self->{'in_hash'}->{'name'}));
	if ($self->{'in_hash'}->{'new'} || uc($self->{'a'}->{'name'}) ne uc($self->{'in_hash'}->{'name'})) {
		# is this name taken?
		for($i=0; $i<@{$self->{'aliases_array'}}; $i++) {
			if (uc($self->{'in_hash'}->{'name'}) eq uc($self->{'aliases_array'}->[$i]->{'name'})) {
				$self->error($self->text('asave_ealready', $self->{'in_hash'}->{'name'}));
				}
			}
		}
	for($i=0; defined($self->{'t'} = $self->{'in_hash'}->{"type_$i"}); $i++) {
		$self->{'v'} = $self->{'in_hash'}->{"val_$i"};
		$self->{'v'} =~ s/^\s+//;
		$self->{'v'} =~ s/\s+$//;
		if ($self->{'t'} == 1 && $self->{'v'} !~ /^(\S+)$/) {
			$self->error($self->text('asave_etype1', $self->{'v'}));
			}
		elsif ($self->{'t'} == 3 && $self->{'v'} !~ /^\/(\S+)$/) {
			$self->error($self->text('asave_etype3', $self->{'v'}));
			}
		elsif ($self->{'t'} == 4) {
			$self->{'v'} =~ /^(\S+)/ || $self->error($self->{'text_hash'}->{'asave_etype4none'});
			-x $1 || $self->error($self->text('asave_etype4', $1));
			}
		elsif ($self->{'t'} == 5 && $self->{'v'} !~ /^\/(\S+)$/) {
			$self->error($self->text('asave_etype5', $self->{'v'}));
			}
		elsif ($self->{'t'} == 6 && $self->{'v'} !~ /^\/(\S+)$/) {
			$self->error($self->text('asave_etype6', $self->{'v'}));
			}
		if ($self->{'t'} == 1 || $self->{'t'} == 3) { push(@{$self->{'values_array'}}, $self->{'v'}); }
		elsif ($self->{'t'} == 2) { push(@{$self->{'values_array'}}, ":include:$self->{'v'}"); }
		elsif ($self->{'t'} == 4) { push(@{$self->{'values_array'}}, "|$self->{'v'}"); }
		elsif ($self->{'t'} == 5) {
			# Setup autoreply script
			push(@{$self->{'values_array'}}, "|$self->{'module_config_directory'}/autoreply.pl ".
				      "$self->{'v'} $self->{'in_hash'}->{'name'}");
			$self->system_logged("cp autoreply.pl $self->{'module_config_directory'}");
			$self->system_logged("chmod 755 $self->{'module_config_directory'}/config");
			}
		elsif ($self->{'t'} == 6) {
			# Setup filter script
			push(@{$self->{'values_array'}}, "|$self->{'module_config_directory'}/filter.pl ".
				      "$self->{'v'} $self->{'in_hash'}->{'name'}");
			$self->system_logged("cp filter.pl $self->{'module_config_directory'}");
			$self->system_logged("chmod 755 $self->{'module_config_directory'}/config");
			}
		}

	$self->{'newa_hash'}->{'name'} = $self->{'in_hash'}->{'name'};
	$self->{'newa_hash'}->{'values'} = \@{$self->{'values_array'}};
	$self->{'newa_hash'}->{'cmt'} = $self->{'in_hash'}->{'cmt'};
	$self->{'newa_hash'}->{'enabled'} = $self->{'in_hash'}->{'enabled'};
	if ($self->{'in_hash'}->{'new'}) { $self->create_alias(\%{$self->{'newa_hash'}}, \@{$self->{'afiles_array'}}, 1); }
	else { $self->modify_alias($self->{'a'}, \%{$self->{'newa_hash'}}, 1); }
	$self->{'loga'} = \%{$self->{'newa_hash'}};
	}
$self->unlock_alias_files(\@{$self->{'afiles_array'}});

# re-creates aliases database
$self->regenerate_aliases();
$self->reload_postfix();

$self->webmin_log($self->{'in_hash'}->{'new'} ? 'create' : $self->{'in_hash'}->{'delete'} ? 'delete' : 'modify',
	    'alias', $self->{'loga'}->{'name'}, $self->{'loga'});
$self->redirect("aliases.cgi");

1;
		
}


1;

