#!/usr/bin/perl

&MAIN();

 sub MAIN {
#
# postfix-module by Guillaume Cottenceau <gc@mandrakesoft.com>,
# for webmin by Jamie Cameron
#
# Copyright (c) 2000 by Mandrakesoft
#
# Permission to use, copy, modify, and distribute this software and its
# documentation under the terms of the GNU General Public License is hereby 
# granted. No representations are made about the suitability of this software 
# for any purpose. It is provided "as is" without express or implied warranty.
# See the GNU General Public License for more details.
#
#
# Save, modify, delete a map for Postfix

&ModuleLoader::preload_module('postfix_class', "postfix::PostfixLib");
$self = new postfix::PostfixLib:: 'postfix_class',%$self;


$self->ReadParse();

#     &ui_print_header(undef, $self->{'text_hash'}->{'aliases_title'}, "");

$self->error_setup($self->{'text_hash'}->{'map_save_err'});

local $maps = $self->get_maps($self->{'in_hash'}->{'map_name'});
local $add = 1; local %map;
## added to split main_parameter:sub_parameter
local ($mainparm,$subparm)=split /:/,$self->{'in_hash'}->{'map_name'};

foreach $trans (@{$maps})
{
    if ($trans->{'number'} == $self->{'in_hash'}->{'num'}) { $add = 0; %map = %{$trans}; }
}

local @maps_files = $self->get_maps_files($self->get_current_value($self->{'in_hash'}->{'map_name'}));

defined($maps_files[0]) || $self->error($self->{'text_hash'}->{'mapps_no_map_file'});
$self->lock_alias_files(\@maps_files);

if (!$self->{'in_hash'}->{'delete'}) {
	# Validate inputs
	##$self->{'nfunc'} = "parse_name_".$self->{'in_hash'}->{'map_name'};
	## modified to capture subparameters
	$self->{'nfunc'}="parse_name_"; $self->{'nfunc'}.=($subparm)? $subparm : $mainparm;
	if ($self->UNIVERSAL::can($self->{'nfunc'})) {
		$self->{'in_hash'}->{'name'} = do { my $fn = $self->{'nfunc'}; $self->$fn(\%map, \%{$self->{'in_hash'}})};
		}
	else {
		$self->{'in_hash'}->{'name'} =~ /^\S+$/ || $self->error($self->{'text_hash'}->{'map_noname'});
		}
	##$self->{'vfunc'} = "parse_value_".$self->{'in_hash'}->{'map_name'};
	## modified to capture subparameters
	$self->{'vfunc'}="parse_value_"; $self->{'vfunc'}.=($subparm)? $subparm : $mainparm;
	if ($self->UNIVERSAL::can($self->{'vfunc'})) {
		$self->{'in_hash'}->{'value'} = do { my $fn = $self->{'vfunc'}; $self->$fn(\%map, \%{$self->{'in_hash'}})};
		}
	}

if ($self->{'in_hash'}->{'delete'})
{
    if ($add == 1)
    {
	$self->{'whatfailed'} = "";
	$self->error($self->text('map_delete_failed', $self->{'text_hash'}->{'map_delete_create'}));
    }
    $self->delete_mapping($self->{'in_hash'}->{'map_name'}, \%map);
    $self->{'logmap'} = \%map;
    $self->{'action'} = "delete";
}
elsif ($add == 0)
{
    # modify an existing map
    local %newmap = ( 'name' => $self->{'in_hash'}->{'name'},
		      'value' => $self->{'in_hash'}->{'value'},
		      'cmt' => $self->{'in_hash'}->{'cmt'} );
    $self->modify_mapping($self->{'in_hash'}->{'map_name'}, \%map, \%newmap);
    $self->{'logmap'} = \%newmap;
    $self->{'action'} = "modify";
}
else
{
    # add a new map -- much more easy! :-)
    local %newmap = ( 'name' => $self->{'in_hash'}->{'name'},
		      'value' => $self->{'in_hash'}->{'value'},
		      'cmt' => $self->{'in_hash'}->{'cmt'} );
    $self->create_mapping($self->{'in_hash'}->{'map_name'}, \%newmap);
    $self->{'logmap'} = \%newmap;
    $self->{'action'} = "create";
}
$self->unlock_alias_files(\@maps_files);

# re-creates database
$self->regenerate_map_table($self->{'in_hash'}->{'map_name'});
$self->reload_postfix();

$self->webmin_log($self->{'action'}, $self->{'in_hash'}->{'map_name'}, $self->{'logmap'}->{'name'}, $self->{'logmap'});

$self->redirect_to_map_list($self->{'in_hash'}->{'map_name'});

1;
		
}


1;

