#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Create, update or delete a server process

&ModuleLoader::preload_module('postfix_class', "postfix::PostfixLib");
$self = new postfix::PostfixLib:: 'postfix_class',%$self;

$self->{'access_hash'}->{'master'} || $self->error($self->{'text_hash'}->{'master_ecannot'});
$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'master_err'});
$self->{'master'} = $self->get_master_config();
if ($self->{'in_hash'}->{'new'}) {
	$self->{'prog'} = { };
	}
else {
	($self->{'prog'}) = grep { $_->{'name'} eq $self->{'in_hash'}->{'old'} } @{$self->{'master'}};
	$self->{'prog'} || $self->error($self->{'text_hash'}->{'master_egone'});
	}
$self->lock_file($self->{'config_hash'}->{'postfix_master'});

if ($self->{'in_hash'}->{'delete'}) {
	# Just delete this one
	$self->delete_master($self->{'prog'});
	}
else {
	# Validate and store inputs
	$self->{'prog'}->{'type'} = $self->{'in_hash'}->{'type'};
	$self->{'prog'}->{'enabled'} = $self->{'in_hash'}->{'enabled'};
	$self->{'in_hash'}->{'name'} =~ /^\S+$/ || $self->error($self->{'text_hash'}->{'master_ename'});
	if (!$self->{'in_hash'}->{'host_def'}) {
		gethostbyname($self->{'in_hash'}->{'host'}) || $self->error($self->{'text_hash'}->{'master_ehost'});
		$self->{'in_hash'}->{'type'} eq 'inet' || $self->error($self->{'text_hash'}->{'master_einet'});
		$self->{'prog'}->{'name'} = $self->{'in_hash'}->{'host'}.":".$self->{'in_hash'}->{'name'};
		}
	else {
		$self->{'prog'}->{'name'} = $self->{'in_hash'}->{'name'};
		}
	$self->{'in_hash'}->{'command'} =~ /^\S/ || $self->error($self->{'text_hash'}->{'master_ecommand'});
	$self->{'prog'}->{'command'} = $self->{'in_hash'}->{'command'};
	$self->{'prog'}->{'private'} = $self->{'in_hash'}->{'private'};
	$self->{'prog'}->{'unpriv'} = $self->{'in_hash'}->{'unpriv'};
	$self->{'prog'}->{'chroot'} = $self->{'in_hash'}->{'chroot'};
	if ($self->{'in_hash'}->{'wakeup'} == 0) {
		$self->{'prog'}->{'wakeup'} = '-';
		}
	elsif ($self->{'in_hash'}->{'wakeup'} == 1) {
		$self->{'prog'}->{'wakeup'} = '0';
		}
	else {
		$self->{'in_hash'}->{'wtime'} =~ /^\d+$/ || $self->error($self->{'text_hash'}->{'master_ewakeup'});
		$self->{'prog'}->{'wakeup'} = $self->{'in_hash'}->{'wtime'}.($self->{'in_hash'}->{'wused'} ? "?" : "");
		}
	if ($self->{'in_hash'}->{'maxprocs'} == 0) {
		$self->{'prog'}->{'maxprocs'} = '-';
		}
	elsif ($self->{'in_hash'}->{'maxprocs'} == 1) {
		$self->{'prog'}->{'maxprocs'} = '0';
		}
	else {
		$self->{'in_hash'}->{'procs'} =~ /^\d+$/ || $self->error($self->{'text_hash'}->{'master_emaxprocs'});
		$self->{'prog'}->{'maxprocs'} = $self->{'in_hash'}->{'procs'};
		}

	# Save or update
	if ($self->{'in_hash'}->{'new'}) {
		$self->create_master($self->{'prog'});
		}
	else {
		$self->modify_master($self->{'prog'});
		}
	}
$self->unlock_file($self->{'config_hash'}->{'postfix_master'});

# Apply config
$self->reload_postfix();

$self->webmin_log($self->{'in_hash'}->{'delete'} ? "delete" : $self->{'in_hash'}->{'new'} ? "create" : "modify",
	    "master", $self->{'prog'}->{'name'}, $self->{'prog'});
$self->redirect("master.cgi");

1;
		
}


1;

