#!/usr/bin/perl

&MAIN();

 sub MAIN {
#
# postfix-module by Guillaume Cottenceau <gc@mandrakesoft.com>,
# for webmin by Jamie Cameron
#
# Copyright (c) 2000 by Mandrakesoft
#
# Permission to use, copy, modify, and distribute this software and its
# documentation under the terms of the GNU General Public License is hereby 
# granted. No representations are made about the suitability of this software 
# for any purpose. It is provided "as is" without express or implied warranty.
# See the GNU General Public License for more details.
#
#
# Save Postfix options ; special because for canonical tables

&ModuleLoader::preload_module('postfix_class', "postfix::PostfixLib");
$self = new postfix::PostfixLib:: 'postfix_class',%$self;


$self->ReadParse();

$self->{'access_hash'}->{'canonical'} || $self->error($self->{'text_hash'}->{'canonical_ecannot'});

#      &ui_print_header(undef, $self->{'text_hash'}->{'opts_title'}, "");

$self->error_setup($self->{'text_hash'}->{'opts_err'});

$self->lock_postfix_files();
$self->before_save();
$self->save_options(\%{$self->{'in_hash'}});
$self->ensure_map("canonical_maps");
$self->ensure_map("recipient_canonical_maps");
$self->ensure_map("sender_canonical_maps");
$self->after_save();
$self->unlock_postfix_files();

$self->regenerate_canonical_table();

$self->reload_postfix();

$self->webmin_log("canonical");
$self->redirect("");

1;
		
}


1;

