#!/usr/bin/perl

&MAIN();

 sub MAIN {
#
# postfix-module by Guillaume Cottenceau <gc@mandrakesoft.com>,
# for webmin by Jamie Cameron
#
# Copyright (c) 2000 by Mandrakesoft
#
# Permission to use, copy, modify, and distribute this software and its
# documentation under the terms of the GNU General Public License is hereby 
# granted. No representations are made about the suitability of this software 
# for any purpose. It is provided "as is" without express or implied warranty.
# See the GNU General Public License for more details.
#
# A form for SMTP server parameters.
# modified by Roberto Tecchio, 2005 (www.tecchio.net)
#
# << Here are all options seen in Postfix sample-smtpd.cf >>

&ModuleLoader::preload_module('postfix_class', "postfix::PostfixLib");
$self = new postfix::PostfixLib:: 'postfix_class',%$self;


$self->{'access_hash'}->{'smtpd'} || $self->error($self->{'text_hash'}->{'smtpd_ecannot'});
$self->ui_print_header(undef, $self->{'text_hash'}->{'smtpd_title'}, "");

$self->{'default'} = $self->{'text_hash'}->{'opts_default'};
$self->{'none'} = $self->{'text_hash'}->{'opts_none'};
$self->{'no_'} = $self->{'text_hash'}->{'opts_no'};

print "<form action=save_opts.cgi>\n";
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'smtpd_title'}</b></td></tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

print "<tr>\n";
$self->option_radios_freefield("smtpd_banner", 85, $self->{'default'});
print "</tr>\n";

print "<tr>\n";
$self->option_freefield("smtpd_recipient_limit", 15);
$self->option_yesno("disable_vrfy_command", 'help');
print "</tr>\n";

print "<tr>\n";
$self->option_freefield("smtpd_timeout", 15);
$self->option_freefield("smtpd_error_sleep_time", 15);
print "</tr>\n";

print "<tr>\n";
$self->option_freefield("smtpd_soft_error_limit", 15);
$self->option_freefield("smtpd_hard_error_limit", 15);
print "</tr>\n";

print "<tr>\n";
$self->option_yesno("smtpd_helo_required", 'help');
$self->option_yesno("allow_untrusted_routing", 'help');
print "</tr>\n";

print "<tr>\n";
$self->option_radios_freefield("smtpd_etrn_restrictions", 65, $self->{'default'});
print "</tr>\n";

print "<tr>\n";
$self->option_radios_freefield("smtpd_helo_restrictions", 65, $self->{'default'});
print "</tr>\n";

print "<tr>\n";
$self->option_radios_freefield("smtpd_sender_restrictions", 65, $self->{'default'});
print "</tr>\n";

print "<tr>\n";
$self->option_radios_freefield("smtpd_recipient_restrictions", 65, $self->{'default'});
print "</tr>\n";

print "<tr>\n";
$self->option_radios_freefield("relay_domains", 65, $self->{'default'});
print "</tr>\n";

print "<tr>\n";
$self->option_freefield("access_map_reject_code", 15, $self->{'default'});
$self->option_freefield("invalid_hostname_reject_code", 15, $self->{'default'});
print "</tr>\n";

print "<tr>\n";
$self->option_freefield("maps_rbl_reject_code", 15, $self->{'default'});
$self->option_freefield("reject_code", 15, $self->{'default'});
print "</tr>\n";

print "<tr>\n";
$self->option_freefield("relay_domains_reject_code", 15, $self->{'default'});
$self->option_freefield("unknown_address_reject_code", 15, $self->{'default'});
print "</tr>\n";

print "<tr>\n";
$self->option_freefield("unknown_client_reject_code", 15, $self->{'default'});
$self->option_freefield("unknown_hostname_reject_code", 15, $self->{'default'});
print "</tr>\n";

## the form must be divided to avoid sending unexpected fields
print "
    <input type=hidden name=smtpd_client_restrictions_def>
    <input type=hidden name=smtpd_client_restrictions>
    </form>
    <form>
    ";

print "<tr>\n";
## &ui_opt_textarea("check_sender_access", $check_sender_access, undef, 40, $self->{'none'}, 1);
## modified to use the customized ui_opt_textarea
&ui_opt_textarea("smtpd_client_restrictions:check_sender_access", undef, 40, $self->{'none'}, 1);
print "</tr>\n";

print "<tr>\n";
## &ui_opt_textarea("maps_rbl_domains", join(', ',@rbl_domains), 3, 62, $self->{'none'});
## modified to use the customized ui_opt_textarea
&ui_opt_textarea("smtpd_client_restrictions:reject_rbl_client", 3, 62, $self->{'none'});
print "</tr>\n";

print "</table></td></tr></table><p>\n";

## code added for javascript-managed fields
print <<JS;

<SCRIPT>
function check_js_fields()
{
f0=document.forms[0];
f1=document.forms[1];
check_value="";    
if (f1.reject_rbl_client_def[1].checked && f1.reject_rbl_client.value != "")
    {
    aRbls=f1.reject_rbl_client.value.split(',');
    for (var i in aRbls) check_value+="reject_rbl_client "+aRbls[i].replace(/ /g,'')+", "; 
    }
if (f1.check_sender_access_def[1].checked && f1.check_sender_access.value != "") 
    {
    n=f1.check_sender_access.value.indexOf(':');
    if (n>-1) f1.check_sender_access.value=f1.check_sender_access.value.substr(n+1);
    check_value = "check_sender_access hash:" + f1.check_sender_access.value + 
        ", "+check_value;
    }        
if (check_value) 
    {
    check_value="permit_mynetworks, "+check_value+"permit";
    f0.smtpd_client_restrictions_def.value="__USE_FREE_FIELD__";
    f0.smtpd_client_restrictions.value=check_value;
    }
f0.submit();    
}   
</SCRIPT>    
JS
## end of added javascript code

## print "<input type=submit value=\"$self->{'text_hash'}->{'opts_save'}\"></form>\n";
## changed to allow submitting of forms[0]
print "<input type=button onClick=check_js_fields() value=\"$self->{'text_hash'}->{'opts_save'}\"></form>\n";
$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
   
1;
		
}

## a customized version of ui_opt_textbox
sub ui_opt_textarea
{
	shift if ($self == $_[0]);

return $self->theme_ui_opt_textbox(@_) if ($self->UNIVERSAL::can('theme_ui_opt_textbox'));

my ($name, $rows, $cols, $opt1, $btnedit) = @_;
my $value=$self->get_current_value($name);
my ($mainparm,$name)=split /:/, $name;

my $dis1 = $self->js_disable_inputs([ $name], [ ]);
my $dis2 = $self->js_disable_inputs([ ], [ $name ]);
my $key = 'opts_'.$name;

print "<td valign=top>".$self->hlink("<b>$self->{'text_hash'}->{$key}</b>", "opt_".$name)."</td>
    <td valign=top nowrap colspan=3>";
    
print "<table border=0 cellpadding=0 cellspacing=0><tr><td valign=top nowrap>"
    unless $btnedit;

print "<input type=radio name=\"".$self->quote_escape($name."_def")."\" ".
       "value=1 ".($value ne '' ? "" : "checked"). " onClick='$dis1'> ".$opt1."\n";
print "<input type=radio name=\"".$self->quote_escape($name."_def")."\" ".
       "value=0 ".($value ne '' ? "checked" : ""). " onClick='$dis2'> ".$self->{'opt2'}."\n";

if ($btnedit) 
    {
    print "<input name=\"".$self->quote_escape($name)."\" size=$cols".
       ($value eq "" ? " disabled=true" : "")." value=\"".
       $self->quote_escape($value)."\">\n";
    print $self->file_chooser_button($self->quote_escape($name),0,0);
    print "<input type=button value=\"". $self->{'text_hash'}->{edit_map_file}. 
        "\" onClick=\"location.href='edit_access.cgi?name=", $self->quote_escape("$mainparm:$name"),
        "&title=", $self->{'text_hash'}->{$key}, "'\">" if $value;
    }
else
    {    
    print "</td><td>\n<textarea name=\"".$self->quote_escape($name)."\" cols=$cols rows=$rows".
       ($value eq ""? " disabled=true" : "").">".
       $self->quote_escape($value)."</textarea></td></tr></table>\n";
    }
print "</td>";
}


1;

