#!/usr/bin/perl
package postgresql::Log_parser;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'postgresql::Log_parser');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# log_parser.pl
# Functions for parsing this module's logs

&ModuleLoader::preload_module(ref($self), "postgresql::PostgresqlLib");
$self = new postgresql::PostgresqlLib:: ref($self), %$self; 

1;
		return $self;
}

# parse_webmin_log(user, script, action, type, object, &params)
# Converts logged information from this module into human-readable form
sub parse_webmin_log
{
	my $self = shift;

local ($user, $script, $action, $type, $object, $p, $long) = @_;
if ($action eq 'stop') {
	return $self->{'text_hash'}->{'log_stop'};
	}
elsif ($action eq 'start') {
	return $self->{'text_hash'}->{'log_start'};
	}
elsif ($action eq 'setup') {
	return $self->{'text_hash'}->{'log_setup'};
	}
elsif ($type eq 'db') {
	return $self->text("log_${type}_${action}", "<tt>$object</tt>");
	}
elsif ($type eq 'dbs' || $type eq 'users' || $type eq 'hosts') {
	return $self->text("log_${type}_${action}", $object);
	}
elsif ($type eq 'table' || $type eq 'view' || $type eq 'index') {
	return $self->text("log_${type}_${action}", "<tt>$object</tt>",
		     "<tt>$p->{'db'}</tt>");
	}
elsif ($type eq 'tables') {
	return $self->text("log_${type}_${action}", $object, "<tt>$p->{'db'}</tt>");
	}
elsif ($type eq 'field') {
	$p->{'size'} =~ s/\s+$//;
	return $self->text("log_${type}_${action}", "<tt>$object</tt>",
		     "<tt>$p->{'table'}</tt>", "<tt>$p->{'db'}</tt>",
		     "<tt>$p->{'type'}$p->{'size'}</tt>");
	}
elsif ($type eq 'data') {
	return $self->text("log_${type}_${action}", "<tt>$object</tt>",
		     "<tt>$p->{'table'}</tt>", "<tt>$p->{'db'}</tt>");
	}
elsif ($action eq 'exec') {
	return $self->text($long ? 'log_exec_l' : 'log_exec', "<tt>$object</tt>",
		     "<tt>".$self->html_escape($p->{'cmd'})."</tt>");
	}
elsif ($type eq 'user' || $type eq 'group') {
	return $self->text("log_${action}_${type}", "<tt>$object</tt>");
	}
elsif ($type eq 'hba') {
	return $object eq 'local' ? $self->{'text_hash'}->{"log_${action}_local"} :
	       $object eq 'all' ? $self->{'text_hash'}->{"log_${action}_all"} :
	       $self->text("log_${action}_hba", "<tt>$object</tt>");
	}
elsif ($action eq 'grant') {
	return $self->text('log_grant', "<tt>$object</tt>", "<tt>$p->{'db'}</tt>");
	}
elsif ($action eq 'degrant') {
	return $self->text('log_degrant', $object);
	}
elsif ($action eq 'backup') {
	return $self->text($object ? ($long ? 'log_backup_l' : 'log_backup')
			     : ($long ? 'log_backup_all_l' : 'log_backup_all'),
		     "<tt>$object</tt>",
		     "<tt>".$self->html_escape($p->{'file'})."</tt>");
	}
else {
	return undef;
	}
}


1;

