#!/usr/bin/perl

&MAIN();

 sub MAIN {
# backup.cgi
# Backup a database to a local file

&ModuleLoader::preload_module('postgresql_class', "postgresql::PostgresqlLib");
$self = new postgresql::PostgresqlLib:: 'postgresql_class',%$self;


$self->ReadParse( ) ;

$self->error_setup( $self->{'text_hash'}->{'backup_err'} ) ;

# Validate inputs
if ($self->{'in_hash'}->{'all'}) {
	@{$self->{'alldbs_array'}} = $self->list_databases();
	@{$self->{'dbs_array'}} = grep { $self->can_edit_db($_) } @{$self->{'alldbs_array'}};
	@{$self->{'alldbs_array'}} == @{$self->{'dbs_array'}} || $self->error($self->{'text_hash'}->{'dbase_ecannot'});
	}
else {
	$self->can_edit_db($self->{'in_hash'}->{'db'}) || $self->error($self->{'text_hash'}->{'dbase_ecannot'});
	}
$self->{'access_hash'}->{'backup'} || $self->error($self->{'text_hash'}->{'backup_ecannot'});
if (!$self->{'in_hash'}->{'save'} || $self->{'in_hash'}->{'sched'}) {
	if ($self->{'in_hash'}->{'all'}) {
		-d $self->{'in_hash'}->{'path'} || -d $self->date_subs($self->{'in_hash'}->{'path'}) ||
			$self->error($self->text('backup_pe4', $self->{'in_hash'}->{'path'})) ;
		}
	else {
		$self->{'in_hash'}->{'path'} =~ /^\/\S+$/ ||
		  $self->{'in_hash'}->{'path'} =~ /^[a-z]:[\\\/]/i ||
		    $self->error($self->text('backup_pe3', $self->{'in_hash'}->{'path'})) ;
		}
	if (!$self->{'in_hash'}->{'all'} && !$self->{'in_hash'}->{'tables_def'}) {
		@{$self->{'tables_array'}} = split(/\0/, $self->{'in_hash'}->{'tables'});
		@{$self->{'tables_array'}} || $self->error($self->{'text_hash'}->{'backup_etables'});
		}
	}
$self->{'cron'} = !$self->{'module_info_hash'}->{'usermin'} &&
        !$self->{'access_hash'}->{'user'} && $self->foreign_installed("cron");
$self->{'cmode'} = 0;
if ($self->{'cron'}) {
	if ($self->{'access_hash'}->{'cmds'}) {
		$self->{'config_hash'}->{'backup_before_'.$self->{'in_hash'}->{'db'}} = $self->{'in_hash'}->{'before'};
		$self->{'config_hash'}->{'backup_after_'.$self->{'in_hash'}->{'db'}} = $self->{'in_hash'}->{'after'};
		if ($self->{'in_hash'}->{'all'}) {
			$self->{'config_hash'}->{'backup_cmode_'.$self->{'in_hash'}->{'db'}} = $self->{'in_hash'}->{'cmode'};
			$self->{'cmode'} = $self->{'in_hash'}->{'cmode'};
			}
		}

	$self->foreign_require("cron", "cron-lib.pl");
	@{$self->{'jobs_array'}} = $main::cron_object->list_cron_jobs();
	$self->{'cmd'} = $self->{'in_hash'}->{'all'} ? "$self->{'cron_cmd'} --all" : "$self->{'cron_cmd'} $self->{'in_hash'}->{'db'}";
	($self->{'job'}) = grep { $_->{'command'} eq $self->{'cmd'} } @{$self->{'jobs_array'}};
	$self->{'oldjob'} = $self->{'job'};
	$self->{'job'} ||= { 'command' => $self->{'cmd'},
		   'user' => 'root',
		   'active' => 1 };
	$main::cron_object->parse_times_input($self->{'job'}, \%{$self->{'in_hash'}});
	}

if (!$self->{'in_hash'}->{'all'}) {
	# Make sure the database exists
	$self->{'db_find_f'} = 0 ;
	if ( $self->{'in_hash'}->{'db'} ) {
	    foreach ( $self->list_databases() ) {
		if ( $_ eq $self->{'in_hash'}->{'db'} ) { $self->{'db_find_f'} = 1 ; }
	    }
	}
	if ( $self->{'db_find_f'} == 0 ) { $self->error( $self->text( 'backup_edb' ) ) ; }
	}

# Save choices for next time the form is visited (and for the cron job)
if ($self->{'module_info_hash'}->{'usermin'}) {
	$self->{'userconfig_hash'}->{'backup_'.$self->{'in_hash'}->{'db'}} = $self->{'in_hash'}->{'path'};
	$self->{'userconfig_hash'}->{'backup_format_'.$self->{'in_hash'}->{'db'}} = $self->{'in_hash'}->{'format'};
	$self->{'userconfig_hash'}->{'backup_tables_'.$self->{'in_hash'}->{'db'}} = join(" ", @{$self->{'tables_array'}});
	$self->write_file("$self->{'user_module_config_directory'}/config", \%{$self->{'userconfig_hash'}});
	}
else {
	$self->{'config_hash'}->{'backup_'.$self->{'in_hash'}->{'db'}} = $self->{'in_hash'}->{'path'};
	$self->{'config_hash'}->{'backup_format_'.$self->{'in_hash'}->{'db'}} = $self->{'in_hash'}->{'format'};
	$self->{'config_hash'}->{'backup_tables_'.$self->{'in_hash'}->{'db'}} = join(" ", @{$self->{'tables_array'}});
	$self->write_file("$self->{'module_config_directory'}/config", \%{$self->{'config_hash'}});
	}

$self->{'desc'} = "<tt>$self->{'in_hash'}->{'db'}</tt>";
$self->ui_print_header($self->{'desc'}, $self->{'text_hash'}->{'backup_title'}, "");
if (!$self->{'in_hash'}->{'save'}) {
	# Construct and run the backup command
	@{$self->{'dbs_array'}} = $self->{'in_hash'}->{'all'} ? @{$self->{'alldbs_array'}} : ( $self->{'in_hash'}->{'db'} );
	$self->{'suf'} = $self->{'in_hash'}->{'format'} eq "p" ? "sql" :
	       $self->{'in_hash'}->{'format'} eq "t" ? "tar" : "post";
        if ($self->{'cmode'} == 1) {
                # Run and check before-backup command (for all DBs)
                $self->{'bok'} = $self->execute_before(undef, STDOUT, 1, $self->{'in_hash'}->{'file'}, undef);
                if (!$self->{'bok'}) {
                        print "$self->{'whatfailed'} : ",$self->{'text_hash'}->{'backup_ebefore'},"<p>\n";
                        goto donebackup;
                        }
                }
	foreach $db (@{$self->{'dbs_array'}}) {
		if (!$self->accepting_connections($db)) {
			print $self->text('backup_notaccept', "<tt>$db</tt>"),"<p>\n";
			next;
			}
		if ($self->{'in_hash'}->{'all'}) {
			$self->{'path'} = $self->date_subs("$self->{'in_hash'}->{'path'}/$db.$self->{'suf'}");
			}
		else {
			$self->{'path'} = $self->date_subs($self->{'in_hash'}->{'path'});
			}
		if ($self->{'cron'} && $self->{'cmode'} == 0) {
			# Run and check before-backup command
			$self->{'bok'} = $self->execute_before($db, STDOUT, 1, $self->{'path'}, $self->{'in_hash'}->{'all'} ? undef : $db);
			if (!$self->{'bok'}) {
                                print "$self->{'whatfailed'} : ",$self->{'text_hash'}->{'backup_ebefore'},"<p>\n";
                                next;
                                }
			}
		$self->{'err'} = $self->backup_database($db, $self->{'path'}, $self->{'in_hash'}->{'format'}, \@{$self->{'tables_array'}});
		if ($self->{'err'}) {
			print "$self->{'whatfailed'} : ",
			      $self->text('backup_ebackup',"<pre>$self->{'err'}</pre>"),"<p>\n";
			}
		else {
			@{$self->{'st_array'}} = stat($self->{'path'});
			print $self->text('backup_done', "<tt>$db</tt>",
					  "<tt>$self->{'path'}</tt>", $self->{'st_array'}->[7]),"<p>\n";
			}
		$self->execute_after($db, STDOUT, 1, $self->{'path'}, $self->{'in_hash'}->{'all'} ? undef : $db)
			if ($self->{'cron'} && $self->{'cmode'} == 0);
		}
	$self->execute_after(undef, STDOUT, 1, $self->{'in_hash'}->{'file'}, undef) if ($self->{'cmode'} == 1);
	donebackup:
	}

if ($self->{'cron'}) {
	$self->lock_file($self->{'cron_cmd'});
	$main::cron_object->create_wrapper($self->{'cron_cmd'}, $self->{'module_name'}, "backup.pl");
	$self->unlock_file($self->{'cron_cmd'});

	$self->lock_file($main::cron_object->cron_file($self->{'job'}));
	if ($self->{'in_hash'}->{'sched'} && !$self->{'oldjob'}) {
		$main::cron_object->create_cron_job($self->{'job'});
		$self->{'what'} = "backup_ccron";
		}
	elsif (!$self->{'in_hash'}->{'sched'} && $self->{'oldjob'}) {
		# Need to delete cron job
		$main::cron_object->delete_cron_job($self->{'job'});
		$self->{'what'} = "backup_dcron";
		}
	elsif ($self->{'in_hash'}->{'sched'} && $self->{'oldjob'}) {
		# Need to update cron job
		$main::cron_object->change_cron_job($self->{'job'});
		$self->{'what'} = "backup_ucron";
		}
	else {
		$self->{'what'} = "backup_ncron";
		}
	$self->unlock_file($main::cron_object->cron_file($self->{'job'}));

	# Tell the user what was done
	print $self->{'text_hash'}->{$self->{'what'}},"<p>\n" if ($self->{'what'});
	}

$self->webmin_log("backup", undef, $self->{'in_hash'}->{'all'} ? "" : $self->{'in_hash'}->{'db'}, \%{$self->{'in_hash'}});
if ($self->{'in_hash'}->{'all'}) {
	$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
	}
else {
	$self->ui_print_footer("edit_dbase.cgi?db=$self->{'in_hash'}->{'db'}", $self->{'text_hash'}->{'dbase_return'},
		"", $self->{'text_hash'}->{'index_return'});
	}

1;
		
}


1;

