#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_field.cgi
# Display a form for editing an existing field or creating a new one

&ModuleLoader::preload_module('postgresql_class', "postgresql::PostgresqlLib");
$self = new postgresql::PostgresqlLib:: 'postgresql_class',%$self;

$self->ReadParse();
$self->can_edit_db($self->{'in_hash'}->{'db'}) || $self->error($self->{'text_hash'}->{'dbase_ecannot'});
$desc = $self->text('field_in', "<tt>$self->{'in_hash'}->{'table'}</tt>", "<tt>$self->{'in_hash'}->{'db'}</tt>");
if ($self->{'in_hash'}->{'type'}) {
	# Creating a new field
	$self->ui_print_header($desc, $self->{'text_hash'}->{'field_title1'}, "", "create_field");
	$self->{'type'} = $self->{'in_hash'}->{'type'};
	}
else {
	# Editing an existing field
	$self->ui_print_header($desc, $self->{'text_hash'}->{'field_title2'}, "", "edit_field");
	@{$self->{'desc_array'}} = $self->table_structure($self->{'in_hash'}->{'db'}, $self->{'in_hash'}->{'table'});
	$self->{'f'} = $self->{'desc_array'}->[$self->{'in_hash'}->{'idx'}];
	$self->{'type'} = $self->{'f'}->{'type'};
	}

print "<form action=save_field.cgi>\n";
print "<input type=hidden name=db value='$self->{'in_hash'}->{'db'}'>\n";
print "<input type=hidden name=table value='$self->{'in_hash'}->{'table'}'>\n";
print "<input type=hidden name=new value='$self->{'in_hash'}->{'type'}'>\n";
print "<table border>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'field_header'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'field_name'}</b></td>\n";
print "<td><input name=field size=20 value='$self->{'f'}->{'field'}'></td> </tr>\n";
print "<input type=hidden name=old value='$self->{'f'}->{'field'}'>\n" if (!$self->{'in_hash'}->{'type'});

if ($self->{'type'} =~ /^(\S+)\((.*)\)/) {
	$self->{'type'} = $1;
	$self->{'size'} = $2;
	}
print "<input type=hidden name=type value='$self->{'type'}'>\n";
print "<tr> <td><b>$self->{'text_hash'}->{'field_type'}</b></td>\n";
print "<td>$self->{'type'}</td> </tr>\n";

if ($self->{'type'} eq 'char' || $self->{'type'} eq 'varchar' || $self->{'type'} eq 'numeric' ||
    $self->{'type'} eq 'bit') {
	if ($self->{'in_hash'}->{'type'}) {
		# Type has a size
		print "<tr> <td><b>$self->{'text_hash'}->{'field_size'}</b></td>\n";
		print "<td><input name=size size=10 value='$self->{'size'}'></td></tr>\n";
		}
	else {
		# Type cannot be edited
		print "<tr> <td><b>$self->{'text_hash'}->{'field_size'}</b></td>\n";
		print "<td>$self->{'size'}</td> </tr>\n";
		}
	}

print "<tr> <td><b>$self->{'text_hash'}->{'field_arr'}</b></td> <td>\n";
if ($self->{'in_hash'}->{'type'}) {
	# Ask if this is an array
	print "<input name=arr type=radio value=1> $self->{'text_hash'}->{'yes'}\n";
	print "<input name=arr type=radio value=0 checked> $self->{'text_hash'}->{'no'}\n";
	}
else {
	# Display if array or not
	print $self->{'f'}->{'arr'} eq 'YES' ? $self->{'text_hash'}->{'yes'} : $self->{'text_hash'}->{'no'};
	}
print "</td> </tr>\n";

if (!$self->{'in_hash'}->{'type'}) {
	# Display nulls
	print "<tr> <td><b>$self->{'text_hash'}->{'field_null'}</b></td>\n";
	print "<td>",$self->{'f'}->{'null'} eq 'YES' ? $self->{'text_hash'}->{'yes'}
					   : $self->{'text_hash'}->{'no'},"</td> </tr>\n";
	}

print "</table></td></tr></table>\n";
if ($self->{'in_hash'}->{'type'}) {
	print "<input type=submit value='$self->{'text_hash'}->{'create'}'>\n";
	}
else {
	print "<input type=submit value='$self->{'text_hash'}->{'save'}'>\n";
	if ($self->can_drop_fields() && @{$self->{'desc_array'}} > 1) {
		print "<input type=submit name=delete value='$self->{'text_hash'}->{'delete'}'>\n";
		}
	}
print "</form>\n";

$self->ui_print_footer("edit_table.cgi?db=$self->{'in_hash'}->{'db'}&table=$self->{'in_hash'}->{'table'}",$self->{'text_hash'}->{'table_return'},
	"edit_dbase.cgi?db=$self->{'in_hash'}->{'db'}", $self->{'text_hash'}->{'dbase_return'},
	"", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

