#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_grant.cgi
# Display a form for editing or creating a grant

&ModuleLoader::preload_module('postgresql_class', "postgresql::PostgresqlLib");
$self = new postgresql::PostgresqlLib:: 'postgresql_class',%$self;

$self->ReadParse();
$self->{'access_hash'}->{'users'} || $self->error($self->{'text_hash'}->{'grant_ecannot'});
$self->{'force_nodbi'} = 1;
$self->ui_print_header(undef, $self->{'text_hash'}->{'grant_edit'}, "");
if ($self->supports_schemas($self->{'in_hash'}->{'db'})) {
	$self->{'s'} = $self->execute_sql_safe($self->{'in_hash'}->{'db'}, 'select relname, relacl, nspname from pg_class, pg_namespace where relnamespace = pg_namespace.oid and (relkind = \'r\' OR relkind = \'S\') and relname !~ \'^pg_\' order by relname');
	}
else {
	$self->{'s'} = $self->execute_sql_safe($self->{'in_hash'}->{'db'}, 'select relname, relacl, \'public\' from pg_class where (relkind = \'r\' OR relkind = \'S\') and relname !~ \'^pg_\' order by relname');
	}
foreach $g (@{$self->{'s'}->{'data'}}) {
	if ($g->[0] eq $self->{'in_hash'}->{'table'} &&
	    $g->[2] eq $self->{'in_hash'}->{'ns'}) {
		$g->[1] =~ s/^\{//; $g->[1] =~ s/\}$//;
		@{$self->{'grant_array'}} = map { /^"(.*)=(.*)"$/ || /^(.*)=(.*)$/; [ $1, $2 ] }
			     split(/,/, $g->[1]);
		}
	}

print "<form action=save_grant.cgi>\n";
print "<input type=hidden name=db value='$self->{'in_hash'}->{'db'}'>\n";
print "<input type=hidden name=table value='$self->{'in_hash'}->{'table'}'>\n";
print "<input type=hidden name=ns value='$self->{'in_hash'}->{'ns'}'>\n";
print "<input type=hidden name=type value='$self->{'in_hash'}->{'type'}'>\n";
print "<input type=hidden name=search value='$self->{'in_hash'}->{'search'}'>\n";

print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'grant_header'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'grant_db'}</b></td>\n";
print "<td><tt>$self->{'in_hash'}->{'db'}</tt></td> <td colspan=2 width=50%></td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'grant_ns'}</b></td>\n";
print "<td><tt>$self->{'in_hash'}->{'ns'}</tt></td> <td colspan=2 width=50%></td> </tr>\n";

print "<tr> <td><b>",$self->{'text_hash'}->{"grant_$self->{'in_hash'}->{'type'}"},"</b></td>\n";
print "<td><tt>$self->{'in_hash'}->{'table'}</tt></td> <td colspan=2 width=50%></td> </tr>\n";

$u = $self->execute_sql_safe($self->{'config_hash'}->{'basedb'}, "select usename from pg_shadow");
@{$self->{'users_array'}} = map { $_->[0] } @{$u->{'data'}};

$r = $self->execute_sql_safe($self->{'config_hash'}->{'basedb'}, "select groname from pg_group");
@{$self->{'groups_array'}} = map { $_->[0] } @{$r->{'data'}};

print "<tr> <td colspan=4><b>$self->{'text_hash'}->{'grant_users'}</b><br>\n";
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'grant_user'}</b></td> ",
      "<td><b>$self->{'text_hash'}->{'grant_what'}</b></td> </tr>\n";
$self->{'i'} = 0;
foreach $g (@{$self->{'grant_array'}}, [ undef, undef ]) {
	print "<tr> <td><select name=user_$self->{'i'}>\n";
	printf "<option %s value=''>&nbsp;\n",
		defined($g->[0]) ? "" : "selected";
	printf "<option value=public %s>%s\n",
		defined($g->[0]) && $g->[0] eq '' ? 'selected' : '',
		$self->{'text_hash'}->{'grant_public'};
	foreach $r (@{$self->{'groups_array'}}) {
		printf "<option value='%s' %s>%s\n",
			"group $r", $g->[0] eq "group $r" ? 'selected' : '',
			$self->text('grant_group', $r);
		}
	foreach $u (@{$self->{'users_array'}}) {
		printf "<option %s>%s\n",
			$g->[0] eq $u ? 'selected' : '', $u;
		}
	print "</select></td> <td>\n";

	($self->{'acl'} = $g->[1]) =~ s/\/.*//g;
	foreach $p ( [ 'SELECT', 'r' ], [ 'UPDATE', 'w' ],
		     [ 'INSERT', 'a' ], [ 'DELETE', 'd' ],
		     [ 'RULE', 'R' ], [ 'REFERENCES', 'x' ],
		     [ 'TRIGGER', 't' ] ) {
		printf "<input type=checkbox name=what_$self->{'i'} value=%s %s> %s\n",
			$p->[0], $self->{'acl'} =~ /$p->[1]/ ? 'checked' : '', $p->[0];
		}
	print "</td> </tr>\n";
	$self->{'i'}++;
	}
print "</table></td></tr>\n";
print "</table></td></tr></table>\n";
print "<input type=submit value='$self->{'text_hash'}->{'save'}'></form>\n";

$self->ui_print_footer("list_grants.cgi?search=".$self->urlize($self->{'in_hash'}->{'search'}),
		 $self->{'text_hash'}->{'grant_return'});

1;
		
}


1;

