#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_host.cgi
# Display a form for editing or creating an allowed host

&ModuleLoader::preload_module('postgresql_class', "postgresql::PostgresqlLib");
$self = new postgresql::PostgresqlLib:: 'postgresql_class',%$self;

$self->ReadParse();
$self->{'v'} = $self->get_postgresql_version();
if ($self->{'in_hash'}->{'new'}) {
	$self->{'type'} = $self->{'in_hash'}->{'new'};
	$self->ui_print_header(undef, $self->{'text_hash'}->{"host_create"}, "");
	$self->{'host'} = { 'type' => $self->{'type'}, 'netmask' => '0.0.0.0',
		  'auth' => 'trust', 'db' => 'all' };
	}
else {
	@{$self->{'all_array'}} = $self->get_hba_config($self->{'v'});
	$self->{'host'} = $self->{'all_array'}->[$self->{'in_hash'}->{'idx'}];
	$self->{'type'} = $self->{'host'}->{'type'};
	$self->ui_print_header(undef, $self->{'text_hash'}->{"host_edit"}, "");
	}

print "<form action=save_host.cgi>\n";
print "<input type=hidden name=idx value='$self->{'in_hash'}->{'idx'}'>\n";
print "<input type=hidden name=new value='$self->{'in_hash'}->{'new'}'>\n";
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'host_header'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

$self->{'mode'} = $self->{'type'} eq 'local' ? 3 :
	$self->{'host'}->{'cidr'} ne '' ? 4 :
	$self->{'host'}->{'netmask'} eq '0.0.0.0' ? 0 :
	$self->{'host'}->{'netmask'} eq '255.255.255.255' ? 1 : 2;
print "<tr> <td valign=top><b>$self->{'text_hash'}->{'host_address'}</b></td> <td colspan=2>\n";
printf "<input type=radio name=addr_mode value=3 %s> %s<br>\n",
	$self->{'mode'} == 3 ? 'checked' : '', $self->{'text_hash'}->{'host_local'};

printf "<input type=radio name=addr_mode value=0 %s> %s<br>\n",
	$self->{'mode'} == 0 ? 'checked' : '', $self->{'text_hash'}->{'host_any'};

printf "<input type=radio name=addr_mode value=1 %s> %s\n",
	$self->{'mode'} == 1 ? 'checked' : '', $self->{'text_hash'}->{'host_single'};
printf "<input name=host size=20 value='%s'><br>\n",
	$self->{'mode'} == 1 ? $self->{'host'}->{'address'} : '';

printf "<input type=radio name=addr_mode value=2 %s> %s\n",
	$self->{'mode'} == 2 ? 'checked' : '', $self->{'text_hash'}->{'host_network'};
printf "<input name=network size=20 value='%s'> %s\n",
	$self->{'mode'} == 2 ? $self->{'host'}->{'address'} : '', $self->{'text_hash'}->{'host_netmask'};
printf "<input name=netmask size=20 value='%s'><br>\n",
	$self->{'mode'} == 2 ? $self->{'host'}->{'netmask'} : '';

printf "<input type=radio name=addr_mode value=4 %s> %s\n",
	$self->{'mode'} == 4 ? 'checked' : '', $self->{'text_hash'}->{'host_network'};
printf "<input name=network2 size=20 value='%s'> %s\n",
	$self->{'mode'} == 4 ? $self->{'host'}->{'address'} : '', $self->{'text_hash'}->{'host_cidr'};
printf "<input name=cidr size=5 value='%s'></td> </tr>\n",
	$self->{'mode'} == 4 ? $self->{'host'}->{'cidr'} : '';

if ($self->{'type'} eq "hostssl" || $self->{'v'} >= 7.3) {
	print "<tr> <td></td> <td colspan=2>&nbsp;&nbsp;&nbsp;\n";
	printf "<input type=checkbox name=ssl value=1 %s> %s</td> </tr>\n",
		$self->{'typeq'} eq "hostssl" ? "checked" : "", $self->{'text_hash'}->{'host_ssl'};
	}

local $found = !$self->{'host'}->{'db'} || $self->{'host'}->{'db'} eq 'all' ||
	       $self->{'host'}->{'db'} eq 'sameuser';
print "<tr> <td><b>$self->{'text_hash'}->{'host_db'}</b></td>\n";
print "<td colspan=2><select name=db>\n";
printf "<option value=all %s>&lt;$self->{'text_hash'}->{'host_all'}&gt;\n",
	$self->{'host'}->{'db'} eq 'all' ? 'selected' : '';
printf "<option value=sameuser %s>&lt;$self->{'text_hash'}->{'host_same'}&gt;\n",
	$self->{'host'}->{'db'} eq 'sameuser' ? 'selected' : '';
if ($self->{'v'} >= 7.3) {
	printf "<option value=samegroup %s>&lt;$self->{'text_hash'}->{'host_gsame'}&gt;\n",
		$self->{'host'}->{'db'} eq 'samegroup' ? 'selected' : '';
	$found++ if ($self->{'host'}->{'db'} eq 'samegroup');
	}
foreach $d ($self->list_databases()) {
	printf "<option %s>%s\n", $self->{'host'}->{'db'} eq $d ? 'selected' : '', $d;
	$found++ if ($self->{'host'}->{'db'} eq $d);
	}
printf "<option value='' %s>%s\n",
	$found ? "" : "selected", $self->{'text_hash'}->{'host_other'};
print "</select>\n";
printf "<input name=dbother size=20 value='%s'></td> </tr>\n",
	$found ? "" : join(" ", split(/,/, $self->{'host'}->{'db'}));

if ($self->{'v'} >= 7.3) {
	print "<tr> <td><b>$self->{'text_hash'}->{'host_user'}</b></td> <td colspan=2>\n";
	printf "<input type=radio name=user_def value=1 %s> %s\n",
		$self->{'host'}->{'user'} eq 'all' || !$self->{'host'}->{'user'} ? "checked" : "",
		$self->{'text_hash'}->{'host_uall'};
	printf "<input type=radio name=user_def value=0 %s> %s\n",
		$self->{'host'}->{'user'} eq 'all' || !$self->{'host'}->{'user'} ? "" : "checked",
		$self->{'text_hash'}->{'host_usel'};
	printf "<input name=user size=25 value='%s'></td> </tr>\n",
		$self->{'host'}->{'user'} eq 'all' ? ""
					 : join(" ", split(/,/, $self->{'host'}->{'user'}));
	}

print "<tr> <td valign=top><b>$self->{'text_hash'}->{'host_auth'}</b></td> <td valign=top>\n";
foreach $a ('password', 'crypt', ($self->{'v'} >= 7.2 ? ( 'md5' ) : ( )),
	    'trust', 'reject', 'ident', 'krb4', 'krb5',
	    ($self->{'v'} >= 7.3 ? ( 'pam' ) : ( )) ) {
	printf "<input type=radio name=auth value=%s %s> %s\n",
		$a, $self->{'host'}->{'auth'} eq $a ? 'checked' : '', $self->{'text_hash'}->{"host_$a"};
	$self->{'arg'} = $self->{'host'}->{'auth'} eq $a ? $self->{'host'}->{'arg'} : undef;
	if ($a eq 'password') {
		print "<br>&nbsp;&nbsp;&nbsp;\n";
		printf "<input type=checkbox name=passwordarg value=1 %s> %s\n",
			$self->{'arg'} ? 'checked' : '', $self->{'text_hash'}->{'host_passwordarg'};
		print "<input name=password size=20 value='$self->{'arg'}'>\n";
		}
	elsif ($a eq 'ident') {
		print "<br>&nbsp;&nbsp;&nbsp;\n";
		printf "<input type=checkbox name=identarg value=1 %s> %s\n",
			$self->{'arg'} ? 'checked' : '', $self->{'text_hash'}->{'host_identarg'};
		print "<input name=ident size=10 value='$self->{'arg'}'>\n";
		}
	elsif ($a eq 'pam') {
		print "<br>&nbsp;&nbsp;&nbsp;\n";
		printf "<input type=checkbox name=pamarg value=1 %s> %s\n",
			$self->{'arg'} ? 'checked' : '', $self->{'text_hash'}->{'host_pamarg'};
		print "<input name=pam size=10 value='$self->{'arg'}'>\n";
		}
	print "<br>\n";
	if ($a eq 'reject') {
		print "</td><td valign=top>\n";
		}
	}
print "</td></tr>\n";

print "</table></td></tr></table>\n";
print "<table width=100%><tr>\n";
if ($self->{'in_hash'}->{'new'}) {
	print "<td><input type=submit value='$self->{'text_hash'}->{'create'}'></td>\n";
	}
else {
	print "<td><input type=submit value='$self->{'text_hash'}->{'save'}'></td>\n";
	print "<td align=right><input type=submit name=delete ",
	      "value='$self->{'text_hash'}->{'delete'}'></td>\n";
	}
print "</tr></table>\n";

$self->ui_print_footer("list_hosts.cgi", $self->{'text_hash'}->{'host_return'});

1;
		
}


1;

