#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Show a form for creating or editing a sequence

&ModuleLoader::preload_module('postgresql_class', "postgresql::PostgresqlLib");
$self = new postgresql::PostgresqlLib:: 'postgresql_class',%$self;

$self->ReadParse();
$self->can_edit_db($self->{'in_hash'}->{'db'}) || $self->error($self->{'text_hash'}->{'dbase_ecannot'});
$self->{'access_hash'}->{'edonly'} && $self->error($self->{'text_hash'}->{'dbase_ecannot'});
$self->{'access_hash'}->{'seqs'} || $self->error($self->{'text_hash'}->{'seq_ecannot'});

if ($self->{'in_hash'}->{'seq'}) {
	# Editing a sequence
	$self->{'str'} = $self->sequence_structure($self->{'in_hash'}->{'db'}, $self->{'in_hash'}->{'seq'});
	}
else {
	$self->{'str'} = { 'increment_by' => 1,
		 'last_value' => 1 };
	}
$self->{'desc'} = "<tt>$self->{'in_hash'}->{'db'}</tt>";
$self->ui_print_header($self->{'desc'}, $self->{'in_hash'}->{'seq'} ? $self->{'text_hash'}->{'seq_title2'}
				   : $self->{'text_hash'}->{'seq_title1'}, "");

print $self->ui_form_start("save_seq.cgi", "post");
print $self->ui_hidden("db", $self->{'in_hash'}->{'db'}),"\n";
print $self->ui_hidden("old", $self->{'in_hash'}->{'seq'}),"\n";
print $self->ui_table_start($self->{'text_hash'}->{'seq_header1'}, undef, 2);

# Sequence name
print $self->ui_table_row($self->{'text_hash'}->{'seq_name'},
		    $self->{'in_hash'}->{'seq'} ? "<tt>$self->{'in_hash'}->{'seq'}</tt>"
			       : $self->ui_textbox("name", $self->{'str'}->{'name'}, 20));

# Current value
print $self->ui_table_row($self->{'text_hash'}->{'seq_last'},
	$self->{'in_hash'}->{'seq'} && $self->supports_sequences() == 1 ?
   $self->ui_opt_textbox("last", undef, 20, $self->text('seq_leave', $self->{'str'}->{'last_value'}))
   : $self->ui_textbox("last", $self->{'str'}->{'last_value'}, 20)); 

# Min and max
print $self->ui_table_row($self->{'text_hash'}->{'seq_min'},
	    $self->ui_opt_textbox("min", $self->{'str'}->{'min_value'}, 20, $self->{'text_hash'}->{'seq_none'}));
print $self->ui_table_row($self->{'text_hash'}->{'seq_max'},
	    $self->ui_opt_textbox("max", $self->{'str'}->{'max_value'}, 20, $self->{'text_hash'}->{'seq_none'}));

# Increment
print $self->ui_table_row($self->{'text_hash'}->{'seq_inc'},
	    $self->ui_textbox("inc", $self->{'str'}->{'increment_by'}, 5));

# Values to cache
print $self->ui_table_row($self->{'text_hash'}->{'seq_cache'},
	!$self->{'in_hash'}->{'seq'} ? $self->ui_opt_textbox("cache", undef, 5, $self->{'text_hash'}->{'default'})
		    : $self->ui_textbox("cache", $self->{'str'}->{'cache_value'}, 5));

# Wrap at end of cycle
print $self->ui_table_row($self->{'text_hash'}->{'seq_cycle'},
    $self->ui_yesno_radio("cycle",
	$self->{'str'}->{'is_cycled'} eq 't' || $self->{'str'}->{'is_cycled'} eq '1' ? 1 : 0));

print $self->ui_table_end();
if ($self->{'in_hash'}->{'seq'}) {
	print $self->ui_form_end([ [ "save", $self->{'text_hash'}->{'save'} ],
			     [ "delete", $self->{'text_hash'}->{'delete'} ] ]);
	}
else {
	print $self->ui_form_end([ [ "create", $self->{'text_hash'}->{'create'} ] ]);
	}

$self->ui_print_footer("edit_dbase.cgi?db=$self->{'in_hash'}->{'db'}", $self->{'text_hash'}->{'dbase_return'},
	"", $self->{'text_hash'}->{'index_return'});
1;
		
}


1;

