#!/usr/bin/perl

&MAIN();

 sub MAIN {
# import.cgi
# Import data from a text file

&ModuleLoader::preload_module('postgresql_class', "postgresql::PostgresqlLib");
$self = new postgresql::PostgresqlLib:: 'postgresql_class',%$self;

$self->ReadParseMime();
$self->can_edit_db($self->{'in_hash'}->{'db'}) || $self->error($self->{'text_hash'}->{'dbase_ecannot'});
$self->error_setup($self->{'text_hash'}->{'import_err'});

if ($self->{'in_hash'}->{'mode'}) {
	# From uploaded file
	$self->{'in_hash'}->{'upload'} || $self->error($self->{'text_hash'}->{'import_eupload'});
	$self->{'in_hash'}->{'upload_filename'} =~ /([^\/\\\s]+)$/ ||
		$self->error($self->{'text_hash'}->{'import_eupload'});
	$self->{'file'} = $self->transname($1);
	open(TEMP, ">$self->{'file'}");
	print TEMP $self->{'in_hash'}->{'upload'};
	close(TEMP);
	$self->{'need_unlink'} = 1;
	$self->ui_print_header(undef, $self->{'text_hash'}->{'import_title'}, "");
	print "$self->{'text_hash'}->{'import_uploadout'}<p>\n";
	}
else {
	# From local file
	-r $self->{'in_hash'}->{'file'} || $self->error($self->{'text_hash'}->{'import_efile'});
	$self->{'file'} = $self->{'in_hash'}->{'file'};
	$self->ui_print_header(undef, $self->{'text_hash'}->{'import_title'}, "");
	print $self->text('import_fileout', "<tt>$self->{'in_hash'}->{'file'}</tt>"),"<p>\n";
	}

if (!$self->{'in_hash'}->{'delete'}) {
	$self->{'data'} = $self->execute_sql($self->{'in_hash'}->{'db'}, "select * from ".$self->quotestr($self->{'in_hash'}->{'table'}));
	foreach $r (@{$self->{'data'}->{'data'}}) {
		$self->{'done_hash'}->{join("/", @$r)}++;
		}
	}

# Read the file
$self->{'skip'} = 0;
open(FILE, $self->{'file'});
while(<FILE>) {
	s/\r|\n//g;
	next if (!/\S/);
	local @row;
	if ($self->{'in_hash'}->{'format'} == 0) {
		# Quoted and comma-separated
		s/\\\"/\0/g;
		while(/^,?"([^"]*)"(.*)/) {
			$self->{'field'} = $1;
			$_ = $2;
			$self->{'field'} =~ s/\0/"/g;
			push(@row, $self->{'field'});
			}
		}
	elsif ($self->{'in_hash'}->{'format'} == 1) {
		# Just comma-separated
		s/\\,/\0/g;
		@row = split(/,/, $_);
		foreach my $r (@row) {
			$r =~ s/\0/,/g;
			}
		}
	elsif ($self->{'in_hash'}->{'format'} == 2) {
		# Tab separated
		@row = split(/\t/, $_);
		}
	if (!@row) {
		print $self->text('import_erow', "<tt>$_</tt>"),"<p>\n";
		goto failed;
		}
	if ($self->{'in_hash'}->{'ignore'} && $self->{'done_hash'}->{join("/", @row)}++) {
		# Skip duplicate
		$self->{'skip'}++;
		next;
		}
	push(@{$self->{'rv_array'}}, \@row);
	}

# Empty the table, if requested
if ($self->{'in_hash'}->{'delete'}) {
	$self->execute_sql_logged($self->{'in_hash'}->{'db'}, "delete from ".$self->quotestr($self->{'in_hash'}->{'table'}));
	}

# Add the rows
@{$self->{'str_array'}} = $self->table_structure($self->{'in_hash'}->{'db'}, $self->{'in_hash'}->{'table'});
foreach $r (@{$self->{'rv_array'}}) {
	@{$self->{'sets_array'}} = map { "?" } @{$self->{'str_array'}};
	$self->{'cmd'} = "insert into ".$self->quotestr($self->{'in_hash'}->{'table'})." values (".
	       join(",", @{$self->{'sets_array'}}).")";
	$self->execute_sql_logged($self->{'in_hash'}->{'db'}, $self->{'cmd'}, @$r);
	}
print $self->text('import_done', scalar(@{$self->{'rv_array'}}), $self->{'skip'}),"<p>\n";

$self->webmin_log("import", undef, $self->{'in_hash'}->{'db'}, { 'mode' => $self->{'in_hash'}->{'mode'},
					  'file' => $self->{'in_hash'}->{'file'} });

failed:
unlink($self->{'file'}) if ($self->{'need_unlink'});

$self->ui_print_footer("edit_dbase.cgi?db=$self->{'in_hash'}->{'db'}", $self->{'text_hash'}->{'dbase_return'});

1;
		
}


1;

