#!/usr/bin/perl

&MAIN();

 sub MAIN {
# index.cgi
# Display all existing databases

&ModuleLoader::preload_module('postgresql_class', "postgresql::PostgresqlLib");
$self = new postgresql::PostgresqlLib:: 'postgresql_class',%$self;

$self->ReadParse();
$self->read_acl(\%{$self->{'hash1_hash'}}, \%{$self->{'hash2_hash'}});

# Check for PostgreSQL program
if (!-x $self->{'config_hash'}->{'psql'} || -d $self->{'config_hash'}->{'psql'}) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", "intro", 1, 1, 0,
		$self->help_search_link("postgresql", "man", "doc", "google"));
	print $self->text('index_esql', "<tt>$self->{'config_hash'}->{'psql'}</tt>",
		  "$self->{'gconfig_hash'}->{'webprefix'}/config.cgi?$self->{'module_name'}"),"<p>\n";

	$self->foreign_require("software", "software-lib.pl");
	$self->{'lnk'} = $main::software_object->missing_install_link(
			"postgresql", $self->{'text_hash'}->{'index_postgresql'},
			"../$self->{'module_name'}/", $self->{'text_hash'}->{'index_title'});
	print $self->{'lnk'},"<p>\n" if ($self->{'lnk'});

	$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});
	exit;
	}

# Check for the config file
if (!-r $self->{'config_hash'}->{'hba_conf'}) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", "intro", 1, 1, 0,
		$self->help_search_link("postgresql", "man", "doc", "google"));
	if ($self->{'config_hash'}->{'setup_cmd'}) {
		# Offer to setup DB for first time
		print $self->text('index_setup', "<tt>$self->{'config_hash'}->{'hba_conf'}</tt>",
				  "<tt>$self->{'config_hash'}->{'setup_cmd'}</tt>"),"<p>\n";
		print "<form action=setup.cgi><center>\n";
		print "<input type=submit value='$self->{'text_hash'}->{'index_setupok'}'>\n";
		print "</center></form><p>\n";
		}
	else {
		# Config file wasn't found
		print $self->text('index_ehba', "<tt>$self->{'config_hash'}->{'hba_conf'}</tt>",
		    "$self->{'gconfig_hash'}->{'webprefix'}/config.cgi?$self->{'module_name'}"),"<p>\n";
		}
	$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});
	exit;
	}

($self->{'r'}, $self->{'rout'}) = $self->is_postgresql_running();
if ($self->{'r'} == 0) {
	# Not running .. need to start it
	&main_header();
	print "<b>$self->{'text_hash'}->{'index_notrun'}</b> <p>\n";

	if ($self->is_postgresql_local()) {
		if ($self->{'access_hash'}->{'stop'} || $self->{'access_hash'}->{'users'}) {
			print "<hr>\n";
			}
		print $self->ui_buttons_start();
		if ($self->{'access_hash'}->{'stop'}) {
			# Show start button
			print $self->ui_buttons_row("start.cgi", $self->{'text_hash'}->{'index_start'},
			      $self->text('index_startmsg',
				    "<tt>$self->{'config_hash'}->{'start_cmd'}</tt>"));
			}
		if ($self->{'access_hash'}->{'users'}) {
			print $self->ui_buttons_row("list_hosts.cgi",
					      $self->{'text_hash'}->{'host_title'},
					      $self->text('index_hostdesc'));
			}
		print $self->ui_buttons_end();
		}
	}
elsif ($self->{'r'} == -1 && $self->{'access_hash'}->{'user'} && 0) {
	# Running, but the user's password is wrong
	&main_header();
	print "<b>",$self->text('index_nouser', "<tt>$self->{'access_hash'}->{'user'}</tt>"),
	      "</b><p>\n";
	print $self->text('index_emsg', "<tt>$self->{'rout'}</tt>"),"<p>\n";
	}
elsif ($self->{'r'} == -1) {
	# Running, but webmin doesn't know the login/password
	&main_header();
	print "<p> <b>$self->{'text_hash'}->{'index_nopass'}</b> <p>\n";
	print "<form action=login.cgi method=post>\n";
	print "<center><table border>\n";
	print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'index_ltitle'}</b></td> </tr>\n";
	print "<tr $self->{'cb'}> <td><table cellpadding=2>\n";

	print "<tr> <td><b>$self->{'text_hash'}->{'index_login'}</b></td>\n";
	printf "<td><input name=login size=20 value='%s'></td> </tr>\n",
		$self->{'access_hash'}->{'user'} || $self->{'config_hash'}->{'login'};

	if (!$self->{'access_hash'}->{'user'}) {
		print "<tr> <td></td>\n";
		printf "<td><input type=checkbox name=sameunix value=1 %s> %s</td> </tr>\n",
			$self->{'config_hash'}->{'sameunix'} ? "checked" : "", $self->{'text_hash'}->{'index_sameunix'};
		}

	print "<tr> <td><b>$self->{'text_hash'}->{'index_pass'}</b></td>\n";
	print "<td><input name=pass size=20 type=password></td> </tr>\n";

	print "</table></td></tr></table>\n";
	print "<input type=submit value='$self->{'text_hash'}->{'save'}'>\n";
	print "<input type=reset value='$self->{'text_hash'}->{'index_clear'}'>\n";
	print "</center></form>\n";
	print $self->text('index_emsg', "<tt>$self->{'rout'}</tt>"),"<p>\n";
	}
elsif ($self->{'r'} == -2) {
	# Looks like a shared library problem
	&main_header();
	print $self->text('index_elibrary', "<tt>$self->{'config_hash'}->{'psql'}</tt>",
		  "$self->{'gconfig_hash'}->{'webprefix'}/config.cgi?$self->{'module_name'}"),"<p>\n";
	print $self->text('index_ldpath', "<tt>$ENV{$self->{'gconfig_hash'}->{'ld_env'}}</tt>",
		  "<tt>$self->{'config_hash'}->{'psql'}</tt>"),"<br>\n";
	print "<pre>$self->{'out'}</pre>\n";
	print $self->text('index_emsg', "<tt>$self->{'rout'}</tt>"),"<p>\n";
	}
else {
	# Running .. check version
	$self->{'postgresql_version'} = $self->get_postgresql_version();
	if (!$self->{'postgresql_version'}) {
		&main_header();
	        print $self->text('index_superuser',"$self->{'gconfig_hash'}->{'webprefix'}/config.cgi?$self->{'module_name'}"),"<p>\n";
		$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});
		exit;
		}
	if ($self->{'postgresql_version'} < 6.5) {
		&main_header();
		print $self->text('index_eversion', $self->{'postgresql_version'}, 6.5),
		      "<p>\n";
		$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});
		exit;
		}

	# Check if we can re-direct to a single DB's page
	@{$self->{'alldbs_array'}} = $self->list_databases();
	@{$self->{'titles_array'}} = grep { $self->can_edit_db($_) } @{$self->{'alldbs_array'}};
	$self->{'can_all'} = (@{$self->{'alldbs_array'}} == @{$self->{'titles_array'}});
	if (@{$self->{'titles_array'}} == 1 && $self->{'access_hash'}->{'dbs'} ne '*' && !$self->{'access_hash'}->{'users'} &&
	    !$self->{'access_hash'}->{'create'} && !$self->{'access_hash'}->{'stop'}) {
		# Only one DB, so go direct to it!
		$self->redirect("edit_dbase.cgi?db=$self->{'titles_array'}->[0]");
		exit;
		}

	&main_header();
	print $self->ui_subheading($self->{'text_hash'}->{'index_dbs'});
	if ($self->{'in_hash'}->{'search'}) {
		# Limit to those matching search
		@{$self->{'titles_array'}} = grep { /\Q$self->{'in_hash'}->{'search'}\E/i } @{$self->{'titles_array'}};
		print "<table width=100%><tr>\n";
		print "<td> <b>",$self->text('index_showing',
			"<tt>$self->{'in_hash'}->{'search'}</tt>"),"</b></td>\n";
		print "<td align=right><a href='index.cgi'>",
			"$self->{'text_hash'}->{'view_searchreset'}</a></td>\n";
		print "</tr></table>\n";
		}
	elsif ($self->{'in_hash'}->{'show'}) {
		# Limit to specific databases
		@{$self->{'titles_array'}} = split(/\0/, $self->{'in_hash'}->{'show'});
		}

	# List the databases
	@{$self->{'icons_array'}} = map { "images/db.gif" } @{$self->{'titles_array'}};
	@{$self->{'links_array'}} = map { "edit_dbase.cgi?db=$_" } @{$self->{'titles_array'}};
	$self->{'can_create'} = $self->{'access_hash'}->{'create'} == 1 ||
		      $self->{'access_hash'}->{'create'} == 2 && @{$self->{'titles_array'}} < $self->{'access_hash'}->{'max'};

	@{$self->{'rowlinks_array'}} = ( );
	push(@{$self->{'rowlinks_array'}}, "<a href=newdb_form.cgi>$self->{'text_hash'}->{'index_add'}</a>")
		if ($self->{'can_create'});
	if (!@{$self->{'icons_array'}}) {
		print "<b>$self->{'text_hash'}->{'index_nodbs'}</b> <p>\n";
		}
	elsif (@{$self->{'icons_array'}} > $self->{'max_dbs'} && !$self->{'in_hash'}->{'search'}) {
		# Too many databases to show .. display search and jump forms
		print $self->ui_form_start("index.cgi");
		print $self->{'text_hash'}->{'index_toomany'},"\n";
		print $self->ui_textbox("search", undef, 20),"\n";
		print $self->ui_submit($self->{'text_hash'}->{'index_search'}),"<br>\n";
		print $self->ui_form_end();

		print $self->ui_form_start("edit_dbase.cgi");
		print $self->{'text_hash'}->{'index_jump'},"\n";
		print $self->ui_select("db", undef, [ map { [ $_ ] } @{$self->{'titles_array'}} ]),"\n";
		print $self->ui_submit($self->{'text_hash'}->{'index_jumpok'}),"<br>\n";
		print $self->ui_form_end();
		}
	else {
		# Show databases as table
		if ($self->{'access_hash'}->{'delete'}) {
			print $self->ui_form_start("drop_dbases.cgi");
			unshift(@{$self->{'rowlinks_array'}}, $self->select_all_link("d", 0),
					   $self->select_invert_link("d", 0) );
			}
		print $self->ui_links_row(\@{$self->{'rowlinks_array'}});
		if ($self->{'access_hash'}->{'dbs'} eq '*' && $self->{'access_hash'}->{'users'} && $self->{'access_hash'}->{'create'} && $self->{'access_hash'}->{'stop'}) {
			@{$self->{'checks_array'}} = @{$self->{'titles_array'}};
			} else { undef(@{$self->{'checks_array'}}); }
		if ($self->{'config_hash'}->{'style'}) {
			@{$self->{'tables_array'}} = map { if ($self->accepting_connections($_)) {
						local @t = $self->list_tables($_);
						scalar(@t);
						}
					else {
						"-";
						}
					} @{$self->{'titles_array'}};
			@{$self->{'titles_array'}} = map { $self->html_escape($_) } @{$self->{'titles_array'}};
			$self->split_table([ "", $self->{'text_hash'}->{'index_db'},
				       $self->{'text_hash'}->{'index_tables'} ],
				     \@{$self->{'checks_array'}}, \@{$self->{'links_array'}}, \@{$self->{'titles_array'}}, \@{$self->{'tables_array'}})
				if (@{$self->{'titles_array'}});
			}
		else {
			# Show databases as icons
			@{$self->{'checks_array'}} = map { $self->ui_checkbox("d", $_) } @{$self->{'checks_array'}};
			@{$self->{'titles_array'}} = map { $self->html_escape($_) } @{$self->{'titles_array'}};
			$self->icons_table(\@{$self->{'links_array'}}, \@{$self->{'titles_array'}}, \@{$self->{'icons_array'}}, 5,
				     undef, undef, undef, \@{$self->{'checks_array'}});
			}
		}
	print $self->ui_links_row(\@{$self->{'rowlinks_array'}});
	if (@{$self->{'icons_array'}} && $self->{'access_hash'}->{'delete'}) {
		print $self->ui_form_end([ [ "delete", $self->{'text_hash'}->{'index_drops'} ] ]);
		}

	if ($self->{'access_hash'}->{'users'}) {
		print "<hr>\n";
		print $self->ui_subheading($self->{'text_hash'}->{'index_users'});
		@{$self->{'links_array'}} = ( 'list_users.cgi', 'list_groups.cgi',
			   'list_hosts.cgi', 'list_grants.cgi' );
		@{$self->{'titles_array'}} = ( $self->{'text_hash'}->{'user_title'}, $self->{'text_hash'}->{'group_title'},
			    $self->{'text_hash'}->{'host_title'}, $self->{'text_hash'}->{'grant_title'} );
		@{$self->{'images_array'}} = ( 'images/users.gif', 'images/groups.gif',
			    'images/hosts.gif', 'images/grants.gif' );
		$self->icons_table(\@{$self->{'links_array'}}, \@{$self->{'titles_array'}}, \@{$self->{'images_array'}});
		}

	if ($self->{'access_hash'}->{'stop'} && $self->is_postgresql_local()) {
		print "<hr>\n";
		print "<form action=stop.cgi>\n";
		print "<table width=100%><tr><td width=25%>\n";
		print "<input type=submit ",
		      "value=\"$self->{'text_hash'}->{'index_stop'}\"></td>\n";
		print "<td>$self->{'text_hash'}->{'index_stopmsg'}</td> </tr></table>\n";
		print "</form>\n";
		}

	# Show backup all button
	if ($self->{'can_all'} && $self->{'access_hash'}->{'backup'}) {
		print "<hr>\n" if (!$self->{'access_hash'}->{'stop'});
		print "<form action=backup_form.cgi>\n";
		print "<input type=hidden name=all value=1>\n";
		print "<table width=100%><tr><td width=25%>\n";
		print "<input type=submit ",
		      "value=\"$self->{'text_hash'}->{'index_backup'}\"></td>\n";
		print "<td>$self->{'text_hash'}->{'index_backupmsg'}</td> </tr></table>\n";
		print "</form>\n";
		}

	# Check if the optional perl modules are installed
	if ( !$self->{'gconfig_hash'}->{'ztl_mode'} && $self->{'hash1_hash'}->{$self->{'remote_user'}, 'useradmin'}) {
	if ($self->foreign_available("cpan")) {
		eval "use DBI";
		push(@{$self->{'needs_array'}}, "DBI") if ($@);
		$self->{'nodbi'}++ if ($@);
		eval "use DBD::Pg";
		push(@{$self->{'needs_array'}}, "DBD::Pg") if ($@);
		if (@{$self->{'needs_array'}}) {
			$self->{'needs'} = $self->urlize(join(" ", @{$self->{'needs_array'}}));
			print "<center><b>",$self->text(@{$self->{'needs_array'}} == 2 ? 'index_nomods' : 'index_nomod', @{$self->{'needs_array'}},
				"/cpan/download.cgi?source=3&cpan=$self->{'needs'}&mode=2&return=/$self->{'module_name'}/&returndesc=".$self->urlize($self->{'text_hash'}->{'index_return'})),
				"</b></center>\n";
			}
		}
	}
	}

$self->ui_print_footer("/", "index");

1;
		
}

sub main_header
{
	shift if ($self == $_[0]);

$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", "intro", 1, 1, 0,
	$self->help_search_link("postgresql", "man", "doc", "google"),
	undef, undef, $self->{'postgresql_version'} ?
	   $self->text('index_version', $self->{'postgresql_version'}).
	   ($self->supports_schemas($self->{'config_hash'}->{'basedb'}) ? " $self->{'text_hash'}->{'index_sch'}" : "") :
	   undef);
}


1;

