#!/usr/bin/perl

&MAIN();

 sub MAIN {
# list_grants.cgi
# Display all granted privileges

&ModuleLoader::preload_module('postgresql_class', "postgresql::PostgresqlLib");
$self = new postgresql::PostgresqlLib:: 'postgresql_class',%$self;

$self->{'access_hash'}->{'users'} || $self->error($self->{'text_hash'}->{'grant_ecannot'});
$self->{'force_nodbi'} = 1;
$self->ui_print_header(undef, $self->{'text_hash'}->{'grant_title'}, "", "list_grants");
$self->ReadParse();

# Check for down databases
@{$self->{'str_array'}} = $self->table_structure($self->{'config_hash'}->{'basedb'}, "pg_catalog.pg_database");
foreach $f (@{$self->{'str_array'}}) {
	$self->{'hasconn'}++ if ($f->{'field'} eq 'datallowconn');
	}
if ($self->{'hasconn'}) {
	$self->{'rv'} = $self->execute_sql_safe($self->{'config_hash'}->{'basedb'}, "select datname,datallowconn from pg_database");
	foreach $r (@{$self->{'rv'}->{'data'}}) {
		$self->{'dbup_hash'}->{$r->[0]} = ($r->[1] =~ /^(t|1)/i);
		}
	}

# Build a list of tables
@{$self->{'dblist_array'}} = $self->list_databases();
foreach $d (@{$self->{'dblist_array'}}) {
	next if (!$self->{'dbup_hash'}->{$d} && $self->{'hasconn'});
	if ($self->supports_schemas($d)) {
		$self->{'s'} = $self->execute_sql_safe($d, "select relname,relacl,pg_namespace.nspname,reltype,relkind,relhasrules,\'$d\' from pg_class, pg_namespace where relnamespace = pg_namespace.oid and (relkind = \'r\' OR relkind = \'S\') and relname !~ \'^pg_\' order by relname");
		}
	else {
		$self->{'s'} = $self->execute_sql_safe($d, "select relname,relacl,\'public\',reltype,relkind,relhasrules,\'$d\' from pg_class where (relkind = \'r\' OR relkind = \'S\') and relname !~ \'^pg_\' order by relname");
		}
	push(@{$self->{'tables_array'}}, @{$self->{'s'}->{'data'}});
	}

if ($self->{'in_hash'}->{'search'}) {
	# Limit to those matching search
	@{$self->{'tables_array'}} = grep { $_->[0] =~ /\Q$self->{'in_hash'}->{'search'}\E/i ||
			 $_->[6] =~ /\Q$self->{'in_hash'}->{'search'}\E/i } @{$self->{'tables_array'}};
	print "<table width=100%><tr>\n";
	print "<td> <b>",$self->text('grant_showing',
		"<tt>$self->{'in_hash'}->{'search'}</tt>"),"</b></td>\n";
	print "<td align=right><a href='list_grants.cgi'>",
		"$self->{'text_hash'}->{'view_searchreset'}</a></td>\n";
	print "</tr></table>\n";
	}

if (@{$self->{'tables_array'}} > $self->{'max_dbs'} && !$self->{'in_hash'}->{'search'}) {
	# If too many, show a search form
	print $self->ui_form_start("list_grants.cgi");
	print $self->{'text_hash'}->{'grant_toomany'},"\n";
	print $self->ui_textbox("search", undef, 20),"\n";
	print $self->ui_submit($self->{'text_hash'}->{'index_search'}),"<br>\n";
	print $self->ui_form_end();
	}
elsif (@{$self->{'tables_array'}}) {
	# Show the results
	@{$self->{'tds_array'}} = ( "width=5" );
	print $self->ui_form_start("delete_grants.cgi", "post");
	print $self->ui_hidden("search", $self->{'in_hash'}->{'search'});
	@{$self->{'rowlinks_array'}} = ( $self->select_all_link("d"),
		      $self->select_invert_link("d") );
	print $self->ui_links_row(\@{$self->{'rowlinks_array'}});
	print $self->ui_columns_start([ "",
				  $self->{'text_hash'}->{'grant_tvi'},
				  $self->{'text_hash'}->{'grant_type'},
				  $self->{'text_hash'}->{'grant_db'},
				  $self->{'text_hash'}->{'grant_users'} ], 100, 0, \@{$self->{'tds_array'}});
	foreach $g (@{$self->{'tables_array'}}) {
		$self->{'type'} = $g->[4] eq 'r' && $g->[5] eq 't' ? 'v' : $g->[4];
		$self->{'tname'} = $g->[2] eq "public" ? $g->[0] : $g->[2].".".$g->[0];
		$d = $g->[6];
		local @cols;
		push(@cols, "<a href='edit_grant.cgi?db=$d&table=$g->[0]&".
		      "ns=$g->[2]&type=$self->{'type'}&search=".$self->urlize($self->{'in_hash'}->{'search'}).
		      "'>".$self->html_escape($self->{'tname'})."</a>");
		push(@cols, $self->{'text_hash'}->{"grant_$self->{'type'}"});
		push(@cols, $self->html_escape($d));
		$g->[1] =~ s/^\{//; $g->[1] =~ s/\}$//;
		@gr = grep { /=\S/ } map { /^"(.*)"$/ ? $1 : $_ } split(/,/, $g->[1]);
		local $gstr;
		foreach $gr (@gr) {
			$gstr .= "&nbsp;|&nbsp;" if ($gr ne $gr[0]);
			if ($gr =~ /^=(\S+)/) {
				$gstr .= $self->{'text_hash'}->{'grant_public'};
				}
			elsif ($gr =~ /^group\s+(\S+)=(\S+)/) {
				$gstr .= $self->text('grant_group',
					"<tt>".$self->html_escape($1)."</tt>");
				}
			elsif ($gr =~ /^(\S+)=(\S+)$/) {
				$gstr .= "<tt>".$self->html_escape($1)."</tt>";
				}
			}
		push(@cols, $gstr);
		print $self->ui_checked_columns_row(\@cols, \@{$self->{'tds_array'}}, "d",
			join("/", $d, $g->[0], $g->[2], $self->{'type'}));
		}
	print $self->ui_columns_end();
	print $self->ui_links_row(\@{$self->{'rowlinks_array'}});
	print $self->ui_form_end([ [ "delete", $self->{'text_hash'}->{'grant_delete'} ] ]);
	}
else {
	print "<b>$self->{'text_hash'}->{'grant_none'}</b><p>\n";
	}

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

