#!/usr/bin/perl

&MAIN();

 sub MAIN {
# list_hosts.cgi
# Display host access records

&ModuleLoader::preload_module('postgresql_class', "postgresql::PostgresqlLib");
$self = new postgresql::PostgresqlLib:: 'postgresql_class',%$self;

$self->{'access_hash'}->{'users'} || $self->error($self->{'text_hash'}->{'host_ecannot'});
$self->ui_print_header(undef, $self->{'text_hash'}->{'host_title'}, "", "list_hosts");

print "$self->{'text_hash'}->{'host_desc'}<p>\n";

$self->{'v'} = $self->get_postgresql_version();
@{$self->{'hosts_array'}} = $self->get_hba_config($self->{'v'});
print $self->ui_form_start("delete_hosts.cgi", "post");
@{$self->{'rowlinks_array'}} = ( $self->select_all_link("d", 0),
	      $self->select_invert_link("d", 0),
	      "<a href='edit_host.cgi?new=1'>$self->{'text_hash'}->{'host_add'}</a>" );
print $self->ui_links_row(\@{$self->{'rowlinks_array'}});
if ($self->{'v'} >= 7.3) {
	@{$self->{'tds_array'}} = ( "width=5", "width=25%", "width=25%", "width=25%",
		 "width=25%", "width=16" );
	}
else {
	@{$self->{'tds_array'}} = ( "width=5", "width=33%", "width=33%", "width=33%", "width=16" );
	}
print $self->ui_columns_start([ "",
			  $self->{'text_hash'}->{'host_address'},
			  $self->{'text_hash'}->{'host_db'},
			  $self->{'v'} >= 7.3 ? ( $self->{'text_hash'}->{'host_user'} ) : ( ),
			  $self->{'text_hash'}->{'host_auth'},
			  $self->{'text_hash'}->{'host_move'} ], 100, 0, \@{$self->{'tds_array'}});
foreach $h (@{$self->{'hosts_array'}}) {
	local @cols;
	local $ssl = $h->{'type'} eq 'hostssl' ? " ($self->{'text_hash'}->{'host_viassl'})" : "";
	push(@cols, "<a href='edit_host.cgi?idx=$h->{'index'}'>".
	   $self->html_escape(
	      $h->{'type'} eq 'local' ? $self->{'text_hash'}->{'host_local'} :
	      $h->{'netmask'} eq '255.255.255.255' ? $h->{'address'}.$ssl :
	      $h->{'netmask'} eq '0.0.0.0' ? $self->{'text_hash'}->{'host_any'}.$ssl :
	      $h->{'cidr'} ne "" ? $h->{'address'}.'/'.$h->{'cidr'}.$ssl :
	      $h->{'address'}.'/'.$h->{'netmask'}.$ssl)."</a>");
	push(@cols, $h->{'db'} eq 'all' ? $self->{'text_hash'}->{'host_all'} :
		    $h->{'db'} eq 'sameuser' ? $self->{'text_hash'}->{'host_same'} :
					       $h->{'db'});
	if ($self->{'v'} >= 7.3) {
		push(@cols, $h->{'user'} eq 'all' ? $self->{'text_hash'}->{'host_uall'}
						   : $h->{'user'});
		}
	push(@cols, $self->{'text_hash'}->{"host_$h->{'auth'}"} || $h->{'auth'});
	local $mover;
	if ($h eq $self->{'hosts_array'}->[@{$self->{'hosts_array'}}-1]) {
		$mover .= "<img src=images/gap.gif>";
		}
	else {
		$mover .= "<a href='down.cgi?idx=$h->{'index'}'>".
		          "<img src=images/down.gif border=0></a>";
		}
	if ($h eq $self->{'hosts_array'}->[0]) {
		$mover .= "<img src=images/gap.gif>";
		}
	else {
		$mover .= "<a href='up.cgi?idx=$h->{'index'}'>".
		          "<img src=images/up.gif border=0></a>";
		}
	push(@cols, $mover);
	print $self->ui_checked_columns_row(\@cols, \@{$self->{'tds_array'}}, "d", $h->{'index'});
	}
print $self->ui_columns_end();
print $self->ui_links_row(\@{$self->{'rowlinks_array'}});
print $self->ui_form_end([ [ "delete", $self->{'text_hash'}->{'user_delete'} ] ]);

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

