#!/usr/bin/perl

&MAIN();

 sub MAIN {
# list_users.cgi
# Display all users in the database

&ModuleLoader::preload_module('postgresql_class', "postgresql::PostgresqlLib");
$self = new postgresql::PostgresqlLib:: 'postgresql_class',%$self;

$self->{'access_hash'}->{'users'} || $self->error($self->{'text_hash'}->{'user_ecannot'});
$self->ui_print_header(undef, $self->{'text_hash'}->{'user_title'}, "", "list_users");

$self->{'s'} = $self->execute_sql_safe($self->{'config_hash'}->{'basedb'}, "select * from pg_shadow");
print $self->ui_form_start("delete_users.cgi", "post");
@{$self->{'rowlinks_array'}} = ( $self->select_all_link("d", 0),
	      $self->select_invert_link("d", 0),
	      "<a href='edit_user.cgi?new=1'>$self->{'text_hash'}->{'user_add'}</a>" );
print $self->ui_links_row(\@{$self->{'rowlinks_array'}});
print $self->ui_columns_start([ "", $self->{'text_hash'}->{'user_name'},
			  $self->{'text_hash'}->{'user_pass'},
			  $self->{'text_hash'}->{'user_db'},
			  $self->{'text_hash'}->{'user_other'},
			  $self->{'text_hash'}->{'user_until'} ], 100);
foreach $u (sort { $a->[0] cmp $b->[0] } @{$self->{'s'}->{'data'}}) {
	local @cols;
	push(@cols, "<a href='edit_user.cgi?user=$u->[0]'>".
		    $self->html_escape($u->[0])."</a>");
	push(@cols, $u->[5] ? $self->{'text_hash'}->{'yes'} : $self->{'text_hash'}->{'no'});
	push(@cols, $u->[2] =~ /t|1/ ? $self->{'text_hash'}->{'yes'} : $self->{'text_hash'}->{'no'});
	push(@cols, $u->[4] =~ /t|1/ ? $self->{'text_hash'}->{'yes'} : $self->{'text_hash'}->{'no'});
	push(@cols, $u->[7] ? $self->html_escape($u->[7])
			     : $self->{'text_hash'}->{'user_forever'});
	print $self->ui_checked_columns_row(\@cols, undef, "d", $u->[0]);
	}
print $self->ui_columns_end();
print $self->ui_links_row(\@{$self->{'rowlinks_array'}});
print $self->ui_form_end([ [ "delete", $self->{'text_hash'}->{'user_delete'} ] ]);

if ($self->get_postgresql_version() >= 7 && $self->foreign_installed("useradmin")) {
	print "<hr>\n";
	print $self->ui_form_start("save_sync.cgi");
	print "$self->{'text_hash'}->{'user_sync'}<br>\n";

	print $self->ui_checkbox("sync_create", 1, $self->{'text_hash'}->{'user_sync_create'},
			   $self->{'config_hash'}->{'sync_create'}),"<br>\n";
	print $self->ui_checkbox("sync_modify", 1, $self->{'text_hash'}->{'user_sync_modify'},
			   $self->{'config_hash'}->{'sync_modify'}),"<br>\n";
	print $self->ui_checkbox("sync_delete", 1, $self->{'text_hash'}->{'user_sync_delete'},
			   $self->{'config_hash'}->{'sync_delete'}),"<br>\n";

	print $self->ui_form_end([ [ "save", $self->{'text_hash'}->{'save'} ] ]);
	}

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

