#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_grant.cgi
# Update privilege grants on some table/view/index

&ModuleLoader::preload_module('postgresql_class', "postgresql::PostgresqlLib");
$self = new postgresql::PostgresqlLib:: 'postgresql_class',%$self;

$self->ReadParse();
$self->{'access_hash'}->{'users'} || $self->error($self->{'text_hash'}->{'grant_ecannot'});
$self->{'force_nodbi'} = 1;

# Remove old privileges on object
if ($self->supports_schemas($self->{'in_hash'}->{'db'})) {
	$self->{'s'} = $self->execute_sql($self->{'in_hash'}->{'db'}, 'select relname, relacl, nspname from pg_class, pg_namespace where relnamespace = pg_namespace.oid and (relkind = \'r\' OR relkind = \'S\') and relname !~ \'^pg_\' order by relname');
	$self->{'ss'} = 1;
	}
else {
	$self->{'s'} = $self->execute_sql($self->{'in_hash'}->{'db'}, 'select relname, relacl, \'public\' from pg_class where (relkind = \'r\' OR relkind = \'S\') and relname !~ \'^pg_\' order by relname');
	$self->{'ss'} = 0;
	}
foreach $g (@{$self->{'s'}->{'data'}}) {
	if ($g->[0] eq $self->{'in_hash'}->{'table'} &&
	    $g->[2] eq $self->{'in_hash'}->{'ns'}) {
		$g->[1] =~ s/^\{//; $g->[1] =~ s/\}$//;
		@{$self->{'grant_array'}} = map { /^"(.*)=(.*)"$/ || /^(.*)=(.*)$/; [ $1, $2 ] }
			     split(/,/, $g->[1]);
		}
	}
$self->{'qt'} = $self->{'ss'} ? $self->quote_table($self->{'in_hash'}->{'ns'}.".".$self->{'in_hash'}->{'table'})
	  : $self->quote_table($self->{'in_hash'}->{'table'});
foreach $g (@{$self->{'grant_array'}}) {
	next if (!$g->[1]);
	if ($g->[0] eq '') {
		$self->{'who'} = "public";
		}
	elsif ($g->[0] =~ /group\s+(\S+)/) {
		$self->{'who'} = "group \"$1\"";
		}
	else {
		$self->{'who'} = "\"$g->[0]\"";
		}
	$self->execute_sql_logged($self->{'in_hash'}->{'db'}, "revoke all on $self->{'qt'} from $self->{'who'}");
	}

# Grant new privileges
for($i=0; defined($self->{'in_hash'}->{"user_$i"}); $i++) {
	@{$self->{'what_array'}} = split(/\0/, $self->{'in_hash'}->{"what_$i"});
	next if (!$self->{'in_hash'}->{"user_$i"} || !@{$self->{'what_array'}});
	if ($self->{'in_hash'}->{"user_$i"} eq "public") {
		$self->{'who'} = "public";
		}
	elsif ($self->{'in_hash'}->{"user_$i"} =~ /^group\s+(\S+)$/) {
		$self->{'who'} = "group \"$1\"";
		}
	else {
		$self->{'who'} = "\"".$self->{'in_hash'}->{"user_$i"}."\"";
		}
	$self->execute_sql_logged($self->{'in_hash'}->{'db'}, "grant ".join(",", @{$self->{'what_array'}})." on ".
				       "$self->{'qt'} to $self->{'who'}");
	}

$self->webmin_log("grant", undef, $self->{'in_hash'}->{'table'}, \%{$self->{'in_hash'}});
$self->redirect("list_grants.cgi?search=".$self->urlize($self->{'in_hash'}->{'search'}));

1;
		
}


1;

