#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_group.cgi
# Create, update or delete a postgres group

&ModuleLoader::preload_module('postgresql_class', "postgresql::PostgresqlLib");
$self = new postgresql::PostgresqlLib:: 'postgresql_class',%$self;

$self->ReadParse();
$self->{'access_hash'}->{'users'} || $self->error($self->{'text_hash'}->{'group_ecannot'});
$self->error_setup($self->{'text_hash'}->{'group_err'});

if ($self->{'in_hash'}->{'delete'}) {
	# just delete the group
	if ($self->get_postgresql_version() >= 8.0) {
		$self->execute_sql_logged($self->{'config_hash'}->{'basedb'}, "drop group $self->{'in_hash'}->{'oldname'}");
		}
	else {
		$self->execute_sql_logged($self->{'config_hash'}->{'basedb'}, "delete from pg_group where grosysid = $self->{'in_hash'}->{'gid'}");
		}
	$self->webmin_log("delete", "group", $self->{'in_hash'}->{'name'});
	}
else {
	# parse inputs
	$self->{'in_hash'}->{'name'} =~ /^\S+$/ || $self->error($self->{'text_hash'}->{'group_ename'});
	$self->{'s'} = $self->execute_sql($self->{'config_hash'}->{'basedb'}, "select * from pg_group where groname = '$self->{'in_hash'}->{'name'}'");
	$self->{'in_hash'}->{'gid'} =~ /^\d+$/ || $self->error($self->{'text_hash'}->{'group_egid'});
	if ($self->{'in_hash'}->{'new'}) {
		$self->{'s'}->{'data'}->[0]->[0] && $self->error($self->{'text_hash'}->{'group_etaken'});
		}
	else {
		$self->{'s'}->{'data'}->[0]->[0] && $self->{'s'}->{'data'}->[0]->[1] != $self->{'in_hash'}->{'gid'} && $self->error($self->{'text_hash'}->{'group_etaken'});
		}

	# Actually create or update the group
	if ($self->get_postgresql_version() >= 8.0) {
		# Need to use new create group or modify command
		$self->{'s'} = $self->execute_sql($self->{'config_hash'}->{'basedb'}, "select * from pg_shadow");
		foreach $u (@{$self->{'s'}->{'data'}}) {
			$self->{'umap_hash'}->{$u->[1]} = $u->[0];
			}
		@{$self->{'mems_array'}} = split(/\0/, $self->{'in_hash'}->{'mems'});
		if ($self->{'in_hash'}->{'new'}) {
			$self->execute_sql_logged($self->{'config_hash'}->{'basedb'}, "create group $self->{'in_hash'}->{'name'} sysid $self->{'in_hash'}->{'gid'} ".join(" ", map { "user ".$self->{'umap_hash'}->{$_} } @{$self->{'mems_array'}}));
			}
		else {
			if ($self->{'in_hash'}->{'name'} ne $self->{'in_hash'}->{'oldname'}) {
				# Rename first
				$self->execute_sql_logged($self->{'config_hash'}->{'basedb'}, "alter group $self->{'in_hash'}->{'oldname'} rename to $self->{'in_hash'}->{'name'}");
				}
			$self->{'s'} = $self->execute_sql($self->{'config_hash'}->{'basedb'}, "select * from pg_group where groname = '$self->{'in_hash'}->{'name'}'");
			@{$self->{'oldmems_array'}} = $self->split_array($self->{'s'}->{'data'}->[0]->[2]);
			if (@{$self->{'oldmems_array'}} && $self->{'oldmems_array'}->[0] ne '') {
				$self->execute_sql_logged($self->{'config_hash'}->{'basedb'}, "alter group $self->{'in_hash'}->{'name'} drop user ".join(", ", map { $self->{'umap_hash'}->{$_} } @{$self->{'oldmems_array'}}));
				}
			if (@{$self->{'mems_array'}}) {
				$self->execute_sql_logged($self->{'config_hash'}->{'basedb'}, "alter group $self->{'in_hash'}->{'name'} add user ".join(" , ", map { $self->{'umap_hash'}->{$_} } @{$self->{'mems_array'}}));
				}
			}
		}
	else {
		# Can update group table directly
		$self->{'mems'} = $self->join_array(split(/\0/, $self->{'in_hash'}->{'mems'}));
		if ($self->{'in_hash'}->{'new'}) {
			$self->execute_sql_logged($self->{'config_hash'}->{'basedb'}, "insert into pg_group values ('$self->{'in_hash'}->{'name'}', '$self->{'in_hash'}->{'gid'}', '$self->{'mems'}')");
			}
		else {
			$self->execute_sql_logged($self->{'config_hash'}->{'basedb'}, "update pg_group set groname = '$self->{'in_hash'}->{'name'}', grolist = '$self->{'mems'}' where grosysid = $self->{'in_hash'}->{'gid'}");
			}
		}
	$self->webmin_log($self->{'in_hash'}->{'new'} ? "create" : "modify", "group", $self->{'in_hash'}->{'name'});
	}
$self->redirect("list_groups.cgi");

1;
		
}


1;

