#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_user.cgi
# Create, update or delete a postgres user

&ModuleLoader::preload_module('postgresql_class', "postgresql::PostgresqlLib");
$self = new postgresql::PostgresqlLib:: 'postgresql_class',%$self;

$self->ReadParse();
$self->{'access_hash'}->{'users'} || $self->error($self->{'text_hash'}->{'user_ecannot'});
$self->error_setup($self->{'text_hash'}->{'user_err'});

if ($self->{'in_hash'}->{'delete'}) {
	# just delete the user
	$self->execute_sql_logged($self->{'config_hash'}->{'basedb'}, "drop user \"$self->{'in_hash'}->{'user'}\"");
	$self->webmin_log("delete", "user", $self->{'in_hash'}->{'user'});
	}
else {
	# parse inputs
	$self->{'version'} = $self->get_postgresql_version();
	if ($self->{'in_hash'}->{'pass_def'} == 0) {
		$self->{'in_hash'}->{'pass'} =~ /^\S+$/ || $self->error($self->{'text_hash'}->{'user_epass'});
		$self->{'sql'} .= $self->{'version'} >= 7 ? " with password '$self->{'in_hash'}->{'pass'}'"
				      : " with password $self->{'in_hash'}->{'pass'}";
		}
	elsif ($self->{'in_hash'}->{'pass_def'} == 1) {
		$self->{'sql'} .= " with password ''";
		}
	if ($self->{'in_hash'}->{'db'}) {
		$self->{'sql'} .= " createdb";
		}
	else {
		$self->{'sql'} .= " nocreatedb";
		}
	if ($self->{'in_hash'}->{'other'}) {
		$self->{'sql'} .= " createuser";
		}
	else {
		$self->{'sql'} .= " nocreateuser";
		}
	if (!$self->{'in_hash'}->{'until_def'}) {
		$self->{'sql'} .= " valid until '$self->{'in_hash'}->{'until'}'";
		}
	if ($self->{'in_hash'}->{'new'}) {
		$self->{'in_hash'}->{'name'} =~ /^\S+$/ || $self->error($self->{'text_hash'}->{'user_ename'});
		$self->execute_sql_logged($self->{'config_hash'}->{'basedb'},
				    "create user \"$self->{'in_hash'}->{'name'}\" $self->{'sql'}");
		$self->webmin_log("create", "user", $self->{'in_hash'}->{'name'});
		}
	else {
		$self->execute_sql_logged($self->{'config_hash'}->{'basedb'},
				    "alter user \"$self->{'in_hash'}->{'user'}\" $self->{'sql'}");
		if ($self->get_postgresql_version() >= 7.4 &&
		    $self->{'in_hash'}->{'name'} ne $self->{'in_hash'}->{'user'}) {
			# Rename too
			$self->execute_sql_logged($self->{'config_hash'}->{'basedb'},
		    		"alter user \"$self->{'in_hash'}->{'user'}\" ".
				"rename to \"$self->{'in_hash'}->{'name'}\"");
			}
		
		if ($self->{'in_hash'}->{'user'} eq $self->{'config_hash'}->{'login'} && !$self->{'access_hash'}->{'user'}) {
			# Renamed or changed the password for the Webmin login .. 
			# update it too!
			$self->{'config_hash'}->{'login'} = $self->{'in_hash'}->{'name'} if $self->{'in_hash'}->{'name'};
			if ($self->{'in_hash'}->{'pass_def'} == 0) {
				$self->{'config_hash'}->{'pass'} = $self->{'in_hash'}->{'pass'};
				}
			elsif ($self->{'in_hash'}->{'pass_def'} == 1) {
				$self->{'config_hash'}->{'pass'} = undef;
				}
			$self->write_file("$self->{'module_config_directory'}/config", \%{$self->{'config_hash'}});
			}
		$self->webmin_log("modify", "user", $self->{'in_hash'}->{'user'});
		}
	}
$self->redirect("list_users.cgi");

1;
		
}


1;

