#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Create, re-create or delete a view

&ModuleLoader::preload_module('postgresql_class', "postgresql::PostgresqlLib");
$self = new postgresql::PostgresqlLib:: 'postgresql_class',%$self;

$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'view_err'});
$self->can_edit_db($self->{'in_hash'}->{'db'}) || $self->error($self->{'text_hash'}->{'dbase_ecannot'});
$self->{'access_hash'}->{'edonly'} && $self->error($self->{'text_hash'}->{'dbase_ecannot'});
$self->{'access_hash'}->{'views'} || $self->error($self->{'text_hash'}->{'view_ecannot'});

if ($self->{'in_hash'}->{'delete'}) {
	# Just drop the view
	$self->{'sql'} = "drop view ".$self->quotestr($self->{'in_hash'}->{'old'});
	$self->execute_sql_logged($self->{'in_hash'}->{'db'}, $self->{'sql'});
	$self->webmin_log("delete", "view", $self->{'in_hash'}->{'old'}, \%{$self->{'in_hash'}});
	}
else {
	# Validate inputs
	$self->{'in_hash'}->{'name'} =~ /^\S+$/ || $self->error($self->{'text_hash'}->{'view_ename'});
	if (!$self->{'in_hash'}->{'old'} || $self->{'in_hash'}->{'old'} ne $self->{'in_hash'}->{'name'}) {
		@{$self->{'views_array'}} = $self->list_views($self->{'in_hash'}->{'db'});
		$self->indexof($self->{'in_hash'}->{'name'}, @{$self->{'views_array'}}) >= 0 &&
			$self->error($self->{'text_hash'}->{'view_eclash'});
		}
	$self->{'in_hash'}->{'query'} =~ /\S/ || $self->error($self->{'text_hash'}->{'view_equery'});
	$self->{'in_hash'}->{'query'} =~ s/\r|\n/ /g;
	if ($self->{'in_hash'}->{'cols_set'}) {
		$self->{'cols'} = join(",", split(/\s+/, $self->{'in_hash'}->{'cols'}));
		$self->{'cols'} || $self->error($self->{'text_hash'}->{'view_ecols'});
		}

	# Do it
	if ($self->{'in_hash'}->{'old'}) {
		# Remove the old one first
		$self->{'sql'} = "drop view ".$self->quotestr($self->{'in_hash'}->{'old'});
		$self->execute_sql_logged($self->{'in_hash'}->{'db'}, $self->{'sql'});
		}
	$self->{'sql'} = "create view ".$self->quotestr($self->{'in_hash'}->{'name'}).
	       ($self->{'cols'} ? " (".$self->{'cols'}.")" : "")." as ".$self->{'in_hash'}->{'query'};
	$self->execute_sql_logged($self->{'in_hash'}->{'db'}, $self->{'sql'});

	if ($self->{'in_hash'}->{'old'}) {
		$self->webmin_log("modify", "view", $self->{'in_hash'}->{'old'}, \%{$self->{'in_hash'}});
		}
	else {
		$self->webmin_log("create", "view", $self->{'in_hash'}->{'name'}, \%{$self->{'in_hash'}});
		}
	}
$self->redirect("edit_dbase.cgi?db=$self->{'in_hash'}->{'db'}");

1;
		
}


1;

