#!/usr/bin/perl

&MAIN();

 sub MAIN {
# conn.cgi
# Open a PPTP connection and add its routes

&ModuleLoader::preload_module('pptp_client_class', "pptp_client::PptpclientLib");
$self = new pptp_client::PptpclientLib:: 'pptp_client_class',%$self;

$self->error_setup($self->{'text_hash'}->{'conn_err'});
$self->ReadParse();

# Get tunnel details
@{$self->{'tunnels_array'}} = $self->list_tunnels();
($self->{'tunnel'}) = grep { $_->{'name'} eq $self->{'in_hash'}->{'tunnel'} } @{$self->{'tunnels_array'}};
$self->{'tunnel'} || $self->error($self->{'text_hash'}->{'conn_egone'});
$self->parse_comments($self->{'tunnel'});
$self->{'tunnel'}->{'server'} || $self->error($self->{'text_hash'}->{'conn_einvalid'});

# Check if it is already active
@{$self->{'conns_array'}} = $self->list_connected();
($self->{'conn'}) = grep { $_->[0] eq $self->{'in_hash'}->{'tunnel'} } @{$self->{'conns_array'}};
$self->{'conn'} && $self->error($self->{'text_hash'}->{'conn_ealready'});

$self->{'theme_no_table'}++;
$| = 1;
$self->ui_print_header(undef, $self->{'text_hash'}->{'conn_title'}, "");

print "<b>",$self->text('conn_cmd', "<tt>$self->{'config_hash'}->{'pptp'} $self->{'tunnel'}->{'server'} ".
				 "call $self->{'in_hash'}->{'tunnel'}</tt>"),"</b><p>\n";

($self->{'ok'}, @{$self->{'status_array'}}) = $self->connect_tunnel($self->{'tunnel'});
if ($self->{'ok'}) {
	# Worked! Tell user
	print "<b>",$self->text('conn_ok', "<tt>$self->{'status_array'}->[0]</tt>",
			  "<tt>$self->{'status_array'}->[1]</tt>",
			  "<tt>$self->{'status_array'}->[2]</tt>"),"</b><p>\n";
	local @rcmds = @{$self->{'status_array'}->[3]};
	local @rout = @{$self->{'status_array'}->[4]};
	if (@rcmds) {
		print "<b>$self->{'text_hash'}->{'conn_routes'}</b><pre>\n";
		for($i=0; $i<@rcmds; $i++) {
			print $rcmds[$i],"\n";
			print "<i>$rout[$i]</i>";
			}
		print "</pre>\n";
		}
	}
else {
	# Failed! Say why
	print "<b>$self->{'text_hash'}->{'conn_timeout'}</b><p>\n";
	print "<pre>$self->{'status_array'}->[0]</pre>\n";
	if ($self->{'status_array'}->[0] =~ /mppe/) {
		print "<b>",$self->text('conn_mppe', "edit_opts.cgi"),"</b><p>\n";
		}
	}

# Save tunnel as default
$self->lock_file("$self->{'module_config_directory'}/config");
$self->{'config_hash'}->{'tunnel'} = $self->{'in_hash'}->{'tunnel'};
$self->{'config_hash'}->{'iface'} = $self->{'status_array'}->[0] if ($self->{'ok'});
$self->write_file("$self->{'module_config_directory'}/config", \%{$self->{'config_hash'}});
$self->unlock_file("$self->{'module_config_directory'}/config");

$self->webmin_log("conn", undef, $self->{'in_hash'}->{'tunnel'}, $self->{'newiface'});
$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

