#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit.cgi
# Display a form for editing tunnel details

&ModuleLoader::preload_module('pptp_client_class', "pptp_client::PptpclientLib");
$self = new pptp_client::PptpclientLib:: 'pptp_client_class',%$self;

$self->ReadParse();
if ($self->{'in_hash'}->{'new'}) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'edit_title1'}, "");
	}
else {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'edit_title2'}, "");
	($self->{'tunnel'}) = grep { $_->{'name'} eq $self->{'in_hash'}->{'tunnel'} } $self->list_tunnels();
	$self->parse_comments($self->{'tunnel'});
	$self->{'login'} = $self->find("name", $self->{'tunnel'}->{'opts'});
	$self->{'sn'} = $self->{'login'} ? $self->{'login'}->{'value'} : $self->get_system_hostname(1);
	@{$self->{'secs_array'}} = $self->list_secrets();
	($self->{'sec'}) = grep { $_->{'client'} eq $self->{'sn'} } @{$self->{'secs_array'}};
	}

print "<form action=save.cgi method=post>\n";
print "<input type=hidden name=new value='$self->{'in_hash'}->{'new'}'>\n";
print "<input type=hidden name=old value='$self->{'in_hash'}->{'tunnel'}'>\n";
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'edit_header'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'edit_name'}</b></td>\n";
printf "<td><input name=tunnel size=30 value='%s'></td>\n",
	$self->{'tunnel'}->{'name'};

print "<td><b>$self->{'text_hash'}->{'edit_server'}</b></td>\n";
printf "<td><input name=server size=20 value='%s'></td> </tr>\n",
	$self->{'tunnel'}->{'server'};

print "<tr> <td><b>$self->{'text_hash'}->{'edit_login'}</b></td>\n";
printf "<td nowrap><input type=radio name=login_def value=1 %s> %s\n",
	$self->{'login'} ? "" : "checked", $self->{'text_hash'}->{'edit_same'};
printf "<input type=radio name=login_def value=0 %s>\n",
	$self->{'login'} ? "checked" : "";
printf "<input name=login size=15 value='%s'></td>\n",
	$self->{'login'}->{'value'};

print "<td><b>$self->{'text_hash'}->{'edit_pass'}</b></td>\n";
printf "<td><input name=pass type=password value='%s'></td> </tr>\n",
	$self->{'sec'}->{'secret'};

$self->{'remote'} = $self->find("remotename", $self->{'tunnel'}->{'opts'});
print "<tr> <td><b>$self->{'text_hash'}->{'edit_remote'}</b></td>\n";
printf "<td nowrap><input type=radio name=remote_def value=1 %s> %s\n",
	$self->{'remote'} ? "" : "checked", $self->{'text_hash'}->{'edit_auto'};
printf "<input type=radio name=remote_def value=0 %s>\n",
	$self->{'remote'} ? "checked" : "";
printf "<input name=remote size=15 value='%s'></td>\n",
	$self->{'remote'}->{'value'};

print "</tr>\n";

# Show PPP include file
$self->{'file'} = $self->find("file", $self->{'tunnel'}->{'opts'});
$self->{'fmode'} = $self->{'in_hash'}->{'new'} ? 1 : !$self->{'file'} ? 0 :
	 $self->{'file'}->{'value'} eq $self->{'config_hash'}->{'pptp_options'} ? 1 : 2;
print "<tr> <td><b>$self->{'text_hash'}->{'edit_file'}</b></td> <td colspan=3>\n";
printf "<input type=radio name=file_def value=0 %s> %s\n",
	$self->{'fmode'} == 0 ? "checked" : "", $self->{'text_hash'}->{'edit_none'};
printf "<input type=radio name=file_def value=1 %s> %s\n",
	$self->{'fmode'} == 1 ? "checked" : "", $self->{'text_hash'}->{'edit_global'};
printf "<input type=radio name=file_def value=2 %s> %s\n",
	$self->{'fmode'} == 2 ? "checked" : "", $self->{'text_hash'}->{'edit_ofile'};
printf "<input name=file size=30 value='%s'> %s</td> </tr>\n",
	$self->{'fmode'} == 2 ? $self->{'file'}->{'value'} : "", $self->file_chooser_button("file");

print "<tr> <td colspan=4><hr></td> </tr>\n";

# Parse all route comments
foreach $r (@{$self->{'tunnel'}->{'routes'}}) {
	if ($r =~ /^\s*add\s+-net\s+(\S+)\s+netmask\s+(\S+)\s+gw\s+(\S+)\s*$/) {
		# Net route to specific gateway
		push(@{$self->{'kroutes_array'}}, [ 1, $1, $2, $3 ]);
		}
	elsif ($r =~ /^\s*add\s+-net\s+(\S+)\s+gw\s+(\S+)\s+netmask\s+(\S+)\s*$/) {
		# Net route to specific gateway
		push(@{$self->{'kroutes_array'}}, [ 1, $1, $3, $2 ]);
		}
	elsif ($r =~ /^\s*add\s+-net\s+(\S+)\s+netmask\s+(\S+)\s+dev\s+(TUNNEL_DEV)\s*$/) {
		# Net route to other end
		push(@{$self->{'kroutes_array'}}, [ 1, $1, $2, 'GW' ]);
		}
	elsif ($r =~ /^\s*add\s+-net\s+(\S+)\s+dev\s+(TUNNEL_DEV)\s+netmask\s+(\S+)\s*$/) {
		# Net route to other end
		push(@{$self->{'kroutes_array'}}, [ 1, $1, $3, 'GW' ]);
		}

	elsif ($r =~ /^\s*add\s+-host\s+(\S+)\s+gw\s+(\S+)\s*$/) {
		# Host route to specific gateway
		push(@{$self->{'kroutes_array'}}, [ 2, $1, undef, $2 ]);
		}
	elsif ($r =~ /^\s*add\s+-host\s+(\S+)\s+dev\s+(TUNNEL_DEV)\s*$/) {
		# Host route to specific gateway
		push(@{$self->{'kroutes_array'}}, [ 2, $1, undef, 'GW' ]);
		}

	elsif ($r =~ /^\s*add\s+default\s+gw\s+(\S+)\s*$/) {
		# Default route to specific gateway
		$self->{'adddef'} = $1;
		}
	elsif ($r =~ /^\s*add\s+default\s+dev\s+(TUNNEL_DEV)\s*$/) {
		# Default route to other end
		$self->{'adddef'} = 'GW';
		}

	elsif ($r =~ /^\s*delete\s+default\s*$/) {
		# Deleting old default route
		$self->{'deldef'} = 1;
		}
	else {
		push(@{$self->{'uroutes_array'}}, $r);
		}
	}

# Show default route options
print "<tr> <td><b>$self->{'text_hash'}->{'edit_adddef'}</b></td> <td colspan=3>\n";
printf "<input type=radio name=adddef value=1 %s> %s\n",
	$self->{'adddef'} eq "GW" ? "checked" : "", $self->{'text_hash'}->{'edit_def1'};
printf "<input type=radio name=adddef value=2 %s> %s\n",
	$self->{'adddef'} && $self->{'adddef'} ne "GW" ? "checked" : "", $self->{'text_hash'}->{'edit_def2'};
printf "<input name=def size=15 value='%s'>\n",
	$self->{'adddef'} eq "GW" ? "" : $self->{'adddef'};
printf "<input type=radio name=adddef value=0 %s> %s\n",
	$self->{'adddef'} ? "" : "checked", $self->{'text_hash'}->{'no'};
print "</td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'edit_deldef'}</b></td>\n";
printf "<td><input type=radio name=deldef value=1 %s> %s\n",
	$self->{'deldef'} ? "checked" : "", $self->{'text_hash'}->{'yes'};
printf "<input type=radio name=deldef value=0 %s> %s</td> </tr>\n",
	$self->{'deldef'} ? "" : "checked", $self->{'text_hash'}->{'no'};

# Show editable routes
print "<tr> <td valign=top><b>$self->{'text_hash'}->{'edit_routes'}</b></td>\n";
print "<td colspan=3><table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'edit_type'}</b></td> ",
      "<td><b>$self->{'text_hash'}->{'edit_net'}</b></td> ",
      "<td><b>$self->{'text_hash'}->{'edit_mask'}</b></td> ",
      "<td><b>$self->{'text_hash'}->{'edit_gw'}</b></td> </tr>\n";
$self->{'i'} = 0;
foreach $r (@{$self->{'kroutes_array'}}, [ 0, undef, undef, 'GW' ]) {
	print "<tr $self->{'cb'}>\n";
	print "<td><select name=type_$self->{'i'}>\n";
	foreach $o (0 .. 2) {
		printf "<option value=%d %s>%s\n",
			$o, $r->[0] == $o ? "selected" : "",
			$self->{'text_hash'}->{'edit_type'.$o};
		}
	print "</select></td>\n";
	print "<td><input name=net_$self->{'i'} size=15 value='$r->[1]'></td>\n";
	print "<td><input name=mask_$self->{'i'} size=15 value='$r->[2]'></td>\n";
	printf "<td nowrap><input type=radio name=gw_def_$self->{'i'} value=1 %s> %s\n",
		$r->[3] eq 'GW' ? "checked" : "", $self->{'text_hash'}->{'edit_gw_def'};
	printf "<input type=radio name=gw_def_$self->{'i'} value=0 %s>\n",
		$r->[3] eq 'GW' ? "" : "checked";
	printf "<input name=gw_$self->{'i'} size=15 value='%s'></td>\n",
		$r->[3] eq 'GW' ? "" : $r->[3];
	print "</tr>\n";
	$self->{'i'}++;
	}
print "</table></td> </tr>\n";

# Show other route commands
print "<tr> <td valign=top><b>$self->{'text_hash'}->{'edit_unknown'}</b></td>\n";
print "<td colspan=3><textarea name=unknown rows=3 cols=60>",
	join("\n", @{$self->{'uroutes_array'}}),"</textarea></td> </tr>\n";

print "<tr> <td colspan=4><hr></td> </tr>\n";

# Show MPPE options
print "<tr> <td colspan=4 align=center>$self->{'text_hash'}->{'opts_msdesc'}</td> </tr>\n";
$self->mppe_options_form($self->{'tunnel'}->{'opts'});

print "</table></td></tr></table>\n";
print "<table width=100%><tr>\n";
if ($self->{'in_hash'}->{'new'}) {
	print "<td><input type=submit value='$self->{'text_hash'}->{'create'}'></td>\n";
	}
else {
	print "<td><input type=submit value='$self->{'text_hash'}->{'save'}'></td>\n";
	print "<td align=right><input type=submit name=delete ",
	      "value='$self->{'text_hash'}->{'delete'}'></td>\n";
	}
print "</tr></table>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

