#!/usr/bin/perl

&MAIN();

 sub MAIN {
# index.cgi
# Display icons for defined PPTP tunnels

&ModuleLoader::preload_module('pptp_client_class', "pptp_client::PptpclientLib");
$self = new pptp_client::PptpclientLib:: 'pptp_client_class',%$self;


$self->{'vers'} = $self->get_pppd_version(\$self->{'out'});
$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, undef, "intro", 1, 1, 0, undef, undef, undef,
	$self->{'vers'} ? $self->text('index_version', $self->{'vers'}) : undef);

# Create the PPTP options file if non-existent. This ensures that it can be
# used in the peer scripts, even if it is empty
if (!-r $self->{'config_hash'}->{'pptp_options'} && $self->{'config_hash'}->{'pptp_options'}) {
	$self->open_tempfile(OPTS, ">>$self->{'config_hash'}->{'pptp_options'}");
	$self->close_tempfile(OPTS);
	}

if (!$self->has_command($self->{'config_hash'}->{'pptp'})) {
	# The PPTP command is not installed
	print "<p>",$self->text('index_epptp', "<tt>$self->{'config_hash'}->{'pptp'}</tt>",
		  "$self->{'gconfig_hash'}->{'webprefix'}/config.cgi?$self->{'module_name'}"),"<p>\n";
	}
elsif (!$self->{'vers'}) {
	# The PPP daemon is not installed
	print "<p>",$self->text('index_epppd', "<tt>pppd</tt>"),"<p>\n";
	}
else {
	# Show icons
	@{$self->{'tunnels_array'}} = $self->list_tunnels();
	%{$self->{'tunnels_hash'}} = map { $_->{'name'}, 1 } @{$self->{'tunnels_array'}};
	print $self->ui_subheading($self->{'text_hash'}->{'index_header'});
	if (@{$self->{'tunnels_array'}}) {
		@{$self->{'links_array'}} = map { "edit.cgi?tunnel=$_->{'name'}" } @{$self->{'tunnels_array'}};
		@{$self->{'titles_array'}} = map { $_->{'name'} } @{$self->{'tunnels_array'}};
		@{$self->{'icons_array'}} = map { "images/tunnel.gif" } @{$self->{'tunnels_array'}};
		$self->icons_table(\@{$self->{'links_array'}}, \@{$self->{'titles_array'}}, \@{$self->{'icons_array'}});
		}
	else {
		print "<b>$self->{'text_hash'}->{'index_none'}</b><p>\n";
		}
	print "<a href='edit.cgi?new=1'>$self->{'text_hash'}->{'index_add'}</a><p>\n";

	print "<hr>\n";
	print "<table width=100%>\n";
	print "<tr><form action=edit_opts.cgi>\n";
	print "<td><input type=submit ",
	      "value='$self->{'text_hash'}->{'index_opts'}'></td>\n";
	print "<td>$self->{'text_hash'}->{'index_optsdesc'}</td>\n";
	print "</form></tr>\n";

	@{$self->{'conns_array'}} = grep { $self->{'tunnels_hash'}->{$_->[0]} } $self->list_connected();
	%{$self->{'conns_hash'}} = map { @$_ } @{$self->{'conns_array'}};
	@{$self->{'notconns_array'}} = grep { !$self->{'conns_hash'}->{$_->{'name'}} } @{$self->{'tunnels_array'}};

	if (@{$self->{'notconns_array'}}) {
		# Show connect button, if any are disconnected
		print "<tr><form action=conn.cgi><td nowrap>\n";
		print "<input type=submit value='$self->{'text_hash'}->{'index_conn'}'>\n";
		print "<select name=tunnel>\n";
		foreach $t (@{$self->{'notconns_array'}}) {
			printf "<option %s>%s\n",
			  $self->{'config_hash'}->{'tunnel'} eq $t->{'name'} ? "selected" : "",
			  $t->{'name'};
			}
		print "</select></td>\n";
		print "<td>$self->{'text_hash'}->{'index_conndesc'}</td> </form></tr>\n";
		}

	if (@{$self->{'conns_array'}}) {
		# If any tunnels appear to be active, show disconnect button
		print "<tr><form action=disc.cgi><td nowrap>\n";
		print "<input type=submit value='$self->{'text_hash'}->{'index_disc'}'>\n";
		print "<select name=tunnel>\n";
		foreach $t (@{$self->{'conns_array'}}) {
			printf "<option %s>%s\n",
				$self->{'config_hash'}->{'tunnel'} eq $t->[0] ? "selected" : "",
				$t->[0];
			}
		print "</select></td>\n";
		print "<td>$self->{'text_hash'}->{'index_discdesc'}</td> </form></tr>\n";
		}

	# Show at-boot button
	if ($self->foreign_check("init") && @{$self->{'tunnels_array'}}) {
		print "<tr>\n";
		$self->foreign_require("init", "init-lib.pl");
		$self->{'starting'} = $main::init_object->action_status($self->{'module_name'});
		$self->{'config_hash'}->{'boot'} = undef if ($self->{'starting'} != 2);
		print "<form action=bootup.cgi>\n";
		print "<input type=hidden name=starting value='$self->{'starting'}'>\n";
		print "<td nowrap><input type=submit value='$self->{'text_hash'}->{'index_boot'}'>\n";
		print "<select name=tunnel>\n";
		printf "<option value='' %s>%s\n",
			$self->{'config_hash'}->{'boot'} ? "" : "selected",
			$self->{'text_hash'}->{'index_noboot'};
		foreach $t (@{$self->{'tunnels_array'}}) {
			printf "<option value='%s' %s>%s\n",
			  $t->{'name'},
			  $t->{'name'} eq $self->{'config_hash'}->{'boot'} ?
				"selected" : "",
			  $t->{'name'};
			}
		print "</select></td>\n";
		print "<td>$self->{'text_hash'}->{'index_bootdesc'}</td>\n";
		print "</form></tr>\n";
		}

	print "</table>\n";
	}

$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});

1;
		
}


1;

