#!/usr/bin/perl

&MAIN();

 sub MAIN {
# index.cgi
# Display the current PPTP configuration

&ModuleLoader::preload_module('pptp_server_class', "pptp_server::PptpserverLib");
$self = new pptp_server::PptpserverLib:: 'pptp_server_class',%$self;


# Check if it is installed
if (!$self->has_command($self->{'config_hash'}->{'pptpd'}) ||
    !($self->{'vers'} = $self->get_pptpd_version(\$self->{'out'}))) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", "intro", 1, 1);
	print "<p>",$self->text('index_epptpd', "<tt>$self->{'config_hash'}->{'pptpd'}</tt>",
		  "$self->{'gconfig_hash'}->{'webprefix'}/config.cgi?$self->{'module_name'}"),"<p>\n";
	if ($self->{'out'}) {
		print $self->text('index_ver', "$self->{'config_hash'}->{'pptpd'} -v"),"\n";
		print "<pre>$self->{'out'}</pre>\n";
		}
	}
else {
	# Show the title and version
	$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", "intro", 1, 1, 0,
		$self->help_search_link("pptp", "man", "doc"), undef, undef,
		$self->text('index_version', $self->{'vers'}));

	if (!-r $self->{'config_hash'}->{'file'}) {
		# Check for the config file
		print "<p>",$self->text('index_econfig', "<tt>$self->{'config_hash'}->{'file'}</tt>",
		  "$self->{'gconfig_hash'}->{'webprefix'}/config.cgi?$self->{'module_name'}"),"<p>\n";
		}
	elsif (!$self->has_command("pppd")) {
		# Check for PPPd
		print "<p>",$self->text('index_epppd', "<tt>pppd</tt>"),"<p>\n";
		}
	else {
		# Show table of options
		if ($self->{'access_hash'}->{'conf'}) {
                  push(@{$self->{'links_array'}}, "edit_conf.cgi");
                  push(@{$self->{'images_array'}}, "images/conf.gif");
		  push(@{$self->{'titles_array'}}, $self->{'text_hash'}->{'conf_title'});
                }
		if ($self->{'access_hash'}->{'options'}) {
                  push(@{$self->{'links_array'}}, "edit_options.cgi");
                  push(@{$self->{'images_array'}}, "images/options.gif");
                  push(@{$self->{'titles_array'}}, $self->{'text_hash'}->{'options_title'});
                }
                if ($self->{'access_hash'}->{'secrets'}) {
                  push(@{$self->{'links_array'}}, "list_secrets.cgi");
                  push(@{$self->{'images_array'}}, "images/secrets.gif");
                  push(@{$self->{'titles_array'}}, $self->{'text_hash'}->{'secrets_title'});
                }
                if ($self->{'access_hash'}->{'conns'}) {
                  push(@{$self->{'links_array'}}, "list_conns.cgi");
                  push(@{$self->{'images_array'}}, "images/conns.gif");
                  push(@{$self->{'titles_array'}}, $self->{'text_hash'}->{'conns_title'});
                }
		$self->icons_table(\@{$self->{'links_array'}}, \@{$self->{'titles_array'}}, \@{$self->{'images_array'}});

		# Start or stop/apply buttons
		print "<hr>\n";
		print "<table width=100%>\n";
		$self->{'pid'} = $self->get_pptpd_pid();
		if ($self->{'access_hash'}->{'apply'}) {
			if ($self->{'pid'} && kill(0, $self->{'pid'})) {
				print "<form action=apply.cgi>\n";
				print "<tr> <td><input type=submit ",
				      "value='$self->{'text_hash'}->{'index_apply'}'></td>\n";
				print "<td>$self->{'text_hash'}->{'index_applydesc'}</td></tr></form>\n";
				if ($self->{'access_hash'}->{'stop'}) {
					print "<form action=stop.cgi>\n";
					print "<tr> <td><input type=submit ",
					      "value='$self->{'text_hash'}->{'index_stop'}'></td>\n";
					print "<td>$self->{'text_hash'}->{'index_stopdesc'}</td></tr></form>\n";
					}
				}
			else {
				print "<form action=start.cgi>\n";
				print "<tr> <td><input type=submit ",
				      "value='$self->{'text_hash'}->{'index_start'}'></td>\n";
				print "<td>$self->{'text_hash'}->{'index_startdesc'}</td></tr></form>\n";
				}
			}
		}
		print "</table>\n";
	}

$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});

1;
		
}

sub ip_table
{
	shift if ($self == $_[0]);

local @ips = split(/,/, $self->find($_[0], $self->{'conf'}));
print "<tr> <td valign=top><b>",$self->{'text_hash'}->{'index_'.$_[0]},
      "</b></td> <td colspan=3>\n";
print "<textarea name=$_[0] rows=3 cols=50>",
	join("\n", @ips),"</textarea>\n";
print "</td> </tr>\n";
}


1;

