#!/usr/bin/perl

&MAIN();

 sub MAIN {
# list_secrets.cgi
# Displays a list of all PAP secrets

&ModuleLoader::preload_module('pptp_server_class', "pptp_server::PptpserverLib");
$self = new pptp_server::PptpserverLib:: 'pptp_server_class',%$self;

$self->{'access_hash'}->{'secrets'} || $self->error($self->{'text_hash'}->{'secrets_ecannot'});
$self->ui_print_header(undef, $self->{'text_hash'}->{'secrets_title'}, "", "secrets");

if (!-r $self->{'config_hash'}->{'pap_file'}) {
	print "<p>", $self->text('secrets_enopfile', $self->{'config_hash'}->{'pap_file'},
			   "$self->{'gconfig_hash'}->{'webprefix'}/config.cgi?$self->{'module_name'}"),"<p>\n";
	$self->ui_print_footer("/", $self->{'text_hash'}->{'secrets_return'});
	exit;
	}

@{$self->{'links_array'}} = ( $self->select_all_link("d"),
	   $self->select_invert_link("d"),
	  "<a href=edit_secret.cgi>$self->{'text_hash'}->{'secrets_create'}</a>" );

# Get the system's hostname for selecting PPP accounts
$self->{'host'} = $self->get_ppp_hostname();

print $self->text('secrets_desc', "<tt>$self->{'config_hash'}->{'pap_file'}</tt>", "<tt>$self->{'host'}</tt>",
	   $self->{'config_hash'}->{'pap_file'} =~ /pap-secrets/ ? "PAP" : "CHAP"),"<p>\n";

@{$self->{'sec_array'}} = grep { $_->{'server'} eq $self->{'host'} } $self->list_secrets();
if (@{$self->{'sec_array'}}) {
	print $self->ui_form_start("delete_secrets.cgi", "post");
	@{$self->{'tds_array'}} = ( "width=5", "nowrap", "nowrap" );
	print $self->ui_links_row(\@{$self->{'links_array'}});
	print $self->ui_columns_start(
		[ "", $self->{'text_hash'}->{'secrets_user'}, $self->{'text_hash'}->{'secrets_ips'} ],
		undef, 0, \@{$self->{'tds_array'}});
	for($i=0; $i<@{$self->{'sec_array'}}; $i++) {
		$self->{'s'} = $self->{'sec_array'}->[$i];
		local @cols;
		push(@cols, "<a href=\"edit_secret.cgi?$i\">".
			($self->{'s'}->{'client'} ? $self->html_escape($self->{'s'}->{'client'})
				        : $self->{'text_hash'}->{'index_uany'})."</a>");
		@{$self->{'i_array'}} = @{$self->{'s'}->{'ips'}};
		push(@cols, $self->{'i_array'}->[0] eq "*" || $self->{'i_array'}->[0] eq "" ?
				$self->{'text_hash'}->{'edit_secret_aany'} :
			    $self->{'i_array'}->[0] eq "-" ? $self->{'text_hash'}->{'edit_secret_anone'} :
				$self->html_escape(join(" ", @{$self->{'i_array'}})));
		print $self->ui_checked_columns_row(\@cols, \@{$self->{'tds_array'}}, "d", $i);
		}
	print $self->ui_columns_end();
	print $self->ui_links_row(\@{$self->{'links_array'}});
	print $self->ui_form_end([ [ "delete", $self->{'text_hash'}->{'secrets_delete'} ] ]);
	}
else {
	print "<b>$self->{'text_hash'}->{'secrets_none'}</b><p>\n";
	print $self->ui_links_row([ $self->{'links_array'}->[2] ]);
	}

$self->ui_print_footer("", $self->{'text_hash'}->{'secrets_return'});

1;
		
}


1;

