#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_conf.cgi
# Save PPTP server settings

&ModuleLoader::preload_module('pptp_server_class', "pptp_server::PptpserverLib");
$self = new pptp_server::PptpserverLib:: 'pptp_server_class',%$self;

$self->{'access_hash'}->{'conf'} || $self->error($self->{'text_hash'}->{'conf_ecannot'});
$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'conf_err'});

# Validate and store inputs
$self->lock_file($self->{'config_hash'}->{'file'});
$self->{'conf'} = $self->get_config();
if ($self->{'in_hash'}->{'speed_def'}) {
	$self->save_directive($self->{'conf'}, "speed");
	}
else {
	$self->{'in_hash'}->{'speed'} =~ /^\d+$/ || $self->error($self->{'text_hash'}->{'conf_espeed'});
	$self->save_directive($self->{'conf'}, "speed", $self->{'in_hash'}->{'speed'});
	}

if ($self->{'in_hash'}->{'listen_def'}) {
	$self->save_directive($self->{'conf'}, "listen");
	}
else {
	$self->check_ipaddress($self->{'in_hash'}->{'listen'}) || $self->error($self->{'text_hash'}->{'conf_elisten'});
	$self->save_directive($self->{'conf'}, "listen", $self->{'in_hash'}->{'listen'});
	}

if ($self->{'in_hash'}->{'mode'} == 0) {
	$self->save_directive($self->{'conf'}, "option");
	}
elsif ($self->{'in_hash'}->{'mode'} == 1) {
	$self->save_directive($self->{'conf'}, "option", $self->{'options_pptp'});
	}
else {
	$self->{'in_hash'}->{'option'} =~ /^\/\S+$/ || $self->error($self->{'text_hash'}->{'conf_eoption'});
	$self->save_directive($self->{'conf'}, "option", $self->{'in_hash'}->{'option'});
	}

&save_ip_table("localip");

&save_ip_table("remoteip");

if ($self->{'in_hash'}->{'ipxnets_def'}) {
	$self->save_directive($self->{'conf'}, "ipxnets");
	}
else {
	$self->{'in_hash'}->{'from'} =~ /^[A-F0-9]+$/ || $self->error($self->{'text_hash'}->{'conf_efrom'});
	$self->{'in_hash'}->{'to'} =~ /^[A-F0-9]+$/ || $self->error($self->{'text_hash'}->{'conf_eto'});
	$self->save_directive($self->{'conf'}, "ipxnets", $self->{'in_hash'}->{'from'}."-".$self->{'in_hash'}->{'to'});
	}

$self->flush_file_lines();
$self->unlock_file($self->{'config_hash'}->{'file'});
$self->webmin_log("conf");
$self->redirect("");

1;
		
}

# save_ip_table(name)
sub save_ip_table
{
	shift if ($self == $_[0]);

local @ips = split(/\s+/, $self->{'in_hash'}->{$_[0]});
foreach $i (@ips) {
	$self->check_ipaddress($i) || $i =~ /^(\d+)\.(\d+)\.(\d+)\.(\d+)-(\d+)$/ ||
		$self->error($self->text('conf_e'.$_[0], $i));
	}
$self->save_directive($self->{'conf'}, $_[0], @ips ? join(",", @ips) : undef);
}


1;

