#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_options.cgi
# Save PPP server options

&ModuleLoader::preload_module('pptp_server_class', "pptp_server::PptpserverLib");
$self = new pptp_server::PptpserverLib:: 'pptp_server_class',%$self;

$self->{'access_hash'}->{'options'} || $self->error($self->{'text_hash'}->{'options_ecannot'});
$self->error_setup($self->{'text_hash'}->{'options_err'});
$self->ReadParse();

$self->{'conf'} = $self->get_config();
$self->{'option'} = $self->find_conf("option", $self->{'conf'});
$self->{'option'} ||= $config{'ppp_options'};
$self->lock_file($self->{'option'});
@{$self->{'opts_array'}} = $self->parse_ppp_options($self->{'option'});

# Validate inputs
$self->{'in_hash'}->{'mtu_def'} || $self->{'in_hash'}->{'mtu'} =~ /^\d+$/ || $self->error($self->{'text_hash'}->{'options_emtu'});
$self->{'in_hash'}->{'mru_def'} || $self->{'in_hash'}->{'mru'} =~ /^\d+$/ || $self->error($self->{'text_hash'}->{'options_emru'});
$self->{'in_hash'}->{'name_def'} || $self->{'in_hash'}->{'name'} =~ /^[A-Za-z0-9\.\-]+$/ ||
	$self->error($self->{'text_hash'}->{'options_ename'});

# Save options
$self->save_ppp_option(\@{$self->{'opts_array'}}, $self->{'option'}, "proxyarp",
		 $self->{'in_hash'}->{'proxyarp'} ? { 'name' => 'proxyarp' } : undef);
$self->save_ppp_option(\@{$self->{'opts_array'}}, $self->{'option'}, "lock",
		 $self->{'in_hash'}->{'lock'} ? { 'name' => 'lock' } : undef);
$self->save_ppp_option(\@{$self->{'opts_array'}}, $self->{'option'}, "mtu",
		 $self->{'in_hash'}->{'mtu_def'} ? undef : { 'name' => 'mtu',
					    'value' => $self->{'in_hash'}->{'mtu'} });
$self->save_ppp_option(\@{$self->{'opts_array'}}, $self->{'option'}, "mru",
		 $self->{'in_hash'}->{'mru_def'} ? undef : { 'name' => 'mru',
					    'value' => $self->{'in_hash'}->{'mru'} });

if ($self->{'in_hash'}->{'auth'} == 0) {
	$self->save_ppp_option(\@{$self->{'opts_array'}}, $self->{'option'}, "auth", undef);
	$self->save_ppp_option(\@{$self->{'opts_array'}}, $self->{'option'}, "noauth", undef);
	}
elsif ($self->{'in_hash'}->{'auth'} == 1) {
	$self->save_ppp_option(\@{$self->{'opts_array'}}, $self->{'option'}, "auth", undef);
	$self->save_ppp_option(\@{$self->{'opts_array'}}, $self->{'option'}, "noauth", { 'name' => 'noauth' });
	}
else {
	$self->save_ppp_option(\@{$self->{'opts_array'}}, $self->{'option'}, "noauth", undef);
	$self->save_ppp_option(\@{$self->{'opts_array'}}, $self->{'option'}, "auth", { 'name' => 'auth' });
	}
&parse_auth("pap");
&parse_auth("chap");
$self->save_ppp_option(\@{$self->{'opts_array'}}, $self->{'option'}, "login",
		 $self->{'in_hash'}->{'login'} ? { 'name' => 'login' } : undef);
$self->save_ppp_option(\@{$self->{'opts_array'}}, $self->{'option'}, "name",
		$self->{'in_hash'}->{'name_def'} ? undef : { 'name' => 'name',
					    'value' => $self->{'in_hash'}->{'name'} });

$self->foreign_require("pptp_client", "pptp-client-lib.pl");
%{$main::pptp_client_object->{'in_hash'}} = %{$self->{'in_hash'}};
$main::pptp_client_object->parse_mppe_options(\@{$self->{'opts_array'}}, $self->{'option'});

if ($main::pptp_client_object->mppe_support() == 1) {
	&parse_auth("mschap");
	&parse_auth("mschap-v2");
	}
else {
	&parse_auth("chapms");
	&parse_auth("chapms-v2");
	}

# All done
$self->flush_file_lines();
$self->unlock_file($self->{'option'});
$self->webmin_log("options", undef, undef, \%{$self->{'in_hash'}});
$self->redirect("");

1;
		
}

# parse_auth(name)
sub parse_auth
{
	shift if ($self == $_[0]);

local $a = $_[0];
if ($self->{'in_hash'}->{$a} == 2) {
	$self->save_ppp_option(\@{$self->{'opts_array'}}, $self->{'option'}, "require-$a",
			 { 'name' => "require-$a" });
	$self->save_ppp_option(\@{$self->{'opts_array'}}, $self->{'option'}, "refuse-$a", undef);
	}
elsif ($self->{'in_hash'}->{$a} == 1) {
	$self->save_ppp_option(\@{$self->{'opts_array'}}, $self->{'option'}, "require-$a", undef);
	$self->save_ppp_option(\@{$self->{'opts_array'}}, $self->{'option'}, "refuse-$a", undef);
	}
else {
	$self->save_ppp_option(\@{$self->{'opts_array'}}, $self->{'option'}, "require-$a", undef);
	$self->save_ppp_option(\@{$self->{'opts_array'}}, $self->{'option'}, "refuse-$a",
			 { 'name' => "refuse-$a" });
	}
}


1;

