#!/usr/bin/perl
package proc::HpuxLib;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'proc::HpuxLib');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# hpux-lib.pl
# Functions for parsing hpux ps output

foreach $ia (keys %{$self->{'text_hash'}}) {
	if ($ia =~ /^hpux(_\S+)/) {
		$self->{'info_arg_map_hash'}->{$1} = $self->{'text_hash'}->{$ia};
		}
	elsif ($ia =~ /^hpuxstat_(\S+)/) {
		$self->{'stat_map_hash'}->{$1} = $self->{'text_hash'}->{$ia};
		}
	}

@{$self->{'nice_range_array'}} = (0 .. 39);

$self->{'has_fuser_command'} = 1;

1;

1;
		return $self;
}

sub list_processes
{
	my $self = shift;

local($line, $i, $pcmd, $_, $tty, @plist);

foreach (@_) { $pcmd .= "-p $_"; }
if (!$pcmd) { $pcmd = "-e"; }

open(PS, "ps -fl $pcmd |");

for($i=0; $line=<PS>; $i++) {
        chop($line);
        if ($line =~ /ps -fl/ || $line =~ /COMD/) { $i--; next; }
        $line =~ /^\s*(\d+)\s+(\S*)\s+(\S*)\s+(\d+)\s+(\d+)\s+(\d+)\s+([\-\d]+)\s+([\-\d]+)\s+(\S*)\s+(\d+)\s+(\S*)\s+(.*)$/;
        $plist[$i]->{"pid"} = $4;
        $plist[$i]->{"ppid"} = $5;
        $plist[$i]->{"user"} = $3;
        $plist[$i]->{"size"} = "$10 Pg";
        $plist[$i]->{"cpu"} = "0.$6 %";
        $plist[$i]->{"time"} = substr($12,17,6);
        $plist[$i]->{"nice"} = $8;
        $plist[$i]->{"args"} = substr($12,23,60);
        $plist[$i]->{"_pri"} = $7;
        $tty = substr($12,8,8);
        $plist[$i]->{"_tty"} =  $tty eq "?       " ? $self->{'text_hash'}->{'edit_none'} : "/dev/$tty";
        $plist[$i]->{"_status"} = $self->{'stat_map_hash'}->{$2};
        $plist[$i]->{"_wchan"} = $11;
	local $rest = $12;
	if ($rest =~ /^(\d+:\d+:\d+)/) {
		$plist[$i]->{"_stime"} = $1;
		}
	elsif ($rest =~ /^([A-Za-z]+\s+\d+)/) {
		$plist[$i]->{"_stime"} = $1;
		}
        }
close(PS);
return @plist;
}

# renice_proc(pid, nice)
sub renice_proc
{
	my $self = shift;

return undef if ($self->is_readonly_mode());
local($out, $nice);
$nice = $_[1] - 20;
$out = `renice -n $nice -p $_[0] 2>&1`;
if ($?) { return $out; }
return undef;
}

# find_mount_processes(mountpoint)
# Find all processes under some mount point
sub find_mount_processes
{
	my $self = shift;

local($out);
$out = `fuser -c $_[0]`;
$out =~ s/[^0-9 ]//g;
$out =~ s/^\s+//g; $out =~ s/\s+$//g;
return split(/\s+/, $out);
}

# find_file_processes([file]+)
# Find all processes with some file open
sub find_file_processes
{
	my $self = shift;

local($out, $files);
$files = join(' ', @_);
$out = `fuser -f $files`;
$out =~ s/[^0-9 ]//g;
$out =~ s/^\s+//g; $out =~ s/\s+$//g;
return split(/\s+/, $out);
}

# get_new_pty()
# Returns the filehandles and names for a pty and tty
sub get_new_pty
{
	my $self = shift;

opendir(DEV, "/dev");
local @ptys = map { "/dev/$_" } (grep { /^pty/ } readdir(DEV));
closedir(DEV);
local ($pty, $tty);
foreach $pty (@ptys) {
	open(PTY, "+>$pty") || next;
	local $tty = $pty; $tty =~ s/pty/tty/;
	open(TTY, "+>$tty") || next;
	local $old = select(PTY); $| = 1;
	select(TTY); $| = 1; select($old);
	return (*PTY, *TTY, $pty, $tty);
	}
return ();
}


1;

