#!/usr/bin/perl
package proc::Log_parser;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'proc::Log_parser');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# log_parser.pl
# Functions for parsing this module's logs

&ModuleLoader::preload_module(ref($self), "proc::ProcLib");
$self = new proc::ProcLib:: ref($self), %$self; 

1;
		return $self;
}

# parse_webmin_log(user, script, action, type, object, &params)
# Converts logged information from this module into human-readable form
sub parse_webmin_log
{
	my $self = shift;

local ($user, $script, $action, $type, $object, $p, $long) = @_;
if ($action eq 'run') {
	return $self->text('log_run', "<tt>".$self->html_escape($p->{'cmd'})."</tt>");
	}
elsif ($action eq 'kill') {
	local ($desc, $i);
	@{$self->{'pids_array'}} = $p->{'pid'} ? ( $p->{'pid'} ) : split(/\s+/, $p->{'pidlist'});
	if ($long) {
		for($i=0; $i<@{$self->{'pids_array'}}; $i++) {
			$desc .= "<i>".$p->{"args$i"}.
				 "</i>&nbsp;&nbsp;(PID $self->{'pids_array'}->[$i])<br>";
			}
		return $self->text(@{$self->{'pids_array'}} == 1 ? 'log_kill_l' : 'log_kills_l',
			     "<tt>$p->{'signal'}</tt>", $desc);
		}
	else {
		if (@{$self->{'pids_array'}} == 1) {
			return $self->text('log_kill', "<tt>$p->{'signal'}</tt>",
				     $self->{'pids_array'}->[0]);
			}
		else {
			return $self->text('log_kills', "<tt>$p->{'signal'}</tt>",
				     scalar(@{$self->{'pids_array'}}));
			}
		}
	}
else {
	return undef;
	}
}


1;

