#!/usr/bin/perl
package proc::WindowsLib;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'proc::WindowsLib');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# windows-lib.pl
# Functions for parsing Windows process.exe command output

%{$self->{'info_arg_map_hash'}}=(	"_threads", $self->{'text_hash'}->{'windows_threads'} );

@{$self->{'nice_range_array'}} = ( 0 .. 20 );

$self->{'has_fuser_command'} = 0;

1;

1;
		return $self;
}

sub list_processes
{
	my $self = shift;

local($pcmd, $line, $i, %pidmap, @plist);
open(PS, "process -t -c |");
while(<PS>) {
	s/\r|\n//g;
	if (/^\s*(\S+)\s+(\d+)\s+(\d+)\s+(\d+)\s+(\d+)\s+(\S+)\s+(\S+)/) {
		local $proc = { 'pid' => $2,
				'ppid' => 0,
				'time' => $6,
				'args' => $1,
				'_threads' => $3,
				'nice' => $4,
				'cpu' => "$5 %",
				'size' => "Unknown" };
		$pidmap{$proc->{'pid'}} = $proc;
		push(@plist, $proc);
		}
	}
close(PS);
open(PS, "process -v |");
while(<PS>) {
	local $proc;
	s/\r|\n//g;
	if (/^\s*(\S+)\s+(\d+)\s+(\d+)\s+(\d+)\s+(\d+)\s+(.*)/ &&
	    ($proc = $pidmap{$2})) {
		local $user = $6;
		$user = "Unknown" if ($user =~ /^Error/);
		$proc->{'user'} = $user;
		}
	}
close(PS);
if (@_) {
	# Limit to PIDs
	local %want = map { $_, 1 } @_;
	@plist = grep { $want{$_->{'pid'}} } @plist;
	}
return @plist;
}

# renice_proc(pid, nice)
sub renice_proc
{
	my $self = shift;

return undef if ($self->is_readonly_mode());
$self->{'out'} = `process -p $_[0] $_[1] 2>&1`;
if ($?) { return $self->{'out'}; }
return undef;
}

sub os_supported_signals
{
	my $self = shift;

return ("KILL", "TERM", "STOP", "CONT");
}


1;

