#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_proc.cgi
# Display information about a process

&ModuleLoader::preload_module('proc_class', "proc::ProcLib");
$self = new proc::ProcLib:: 'proc_class',%$self;

$self->ui_print_header(undef, $self->{'text_hash'}->{'edit_title'}, "", "edit_proc");
%{$self->{'pinfo_hash'}} = $self->process_info($ARGV[0]);
$self->can_edit_process($self->{'pinfo_hash'}->{'user'}) || $self->error($self->{'text_hash'}->{'edit_ecannot'});
if (!%{$self->{'pinfo_hash'}}) {
	print "<b>$self->{'text_hash'}->{'edit_gone'}</b> <p>\n";
	$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
	exit;
	}

print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'edit_title'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

print "<tr> <td width=20% nowrap><b>$self->{'text_hash'}->{'command'}</b></td>\n";
print "     <td colspan=3><font size=+1>",
      $self->html_escape($self->{'pinfo_hash'}->{args}),"</font></td> </tr>\n";
print "<tr> <td width=20% nowrap><b>$self->{'text_hash'}->{'pid'}</b></td><td>$self->{'pinfo_hash'}->{pid}</td>\n";
print "<td width=20% nowrap><b>$self->{'text_hash'}->{'parent'}</b></td>\n";
if ($self->{'pinfo_hash'}->{ppid}) {
	local %ppinfo = $self->process_info($self->{'pinfo_hash'}->{ppid});
	print "<td><a href=\"edit_proc.cgi?$ppinfo{pid}\">",
		$self->cut_string($ppinfo{'args'}, 30),"</a></td>";
	}
else { print "<td>$self->{'text_hash'}->{'edit_none'}</td>"; }
print " </tr>\n";
print "<tr> <td width=20% nowrap><b>$self->{'text_hash'}->{'owner'}</b></td> ",
      "<td>$self->{'pinfo_hash'}->{'user'}</td>\n";
print "<td width=20% nowrap><b>$self->{'text_hash'}->{'cpu'}</b></td> ",
      "<td>$self->{'pinfo_hash'}->{'cpu'}</td> </tr>\n";
print "<tr> <td width=20% nowrap><b>$self->{'text_hash'}->{'size'}</b></td> ",
      "<td>$self->{'pinfo_hash'}->{'size'}</td>\n";
print "<td width=20% nowrap><b>$self->{'text_hash'}->{'runtime'}</b></td> ",
      "<td>$self->{'pinfo_hash'}->{'time'}</td> </tr>\n";
print "<tr> <td>",$self->hlink("<b>$self->{'text_hash'}->{'nice'}</b>","nice"),"</td>\n";
print "<form action=renice_proc.cgi>\n";
print "<input type=hidden name=pid value=$ARGV[0]>\n";
print "<td colspan=3>\n";
if ($self->indexof($self->{'pinfo_hash'}->{nice}, @{$self->{'nice_range_array'}}) < 0) {
	print $self->{'pinfo_hash'}->{nice};
	}
else {
	print "<select name=nice>\n";
	for($i=0; $i<@{$self->{'nice_range_array'}}; $i++) {
		printf "<option value=%d %s>%d%s\n",
			$self->{'nice_range_array'}->[$i],
			$self->{'pinfo_hash'}->{nice} == $self->{'nice_range_array'}->[$i] ? "selected" : "",
			$self->{'nice_range_array'}->[$i],
			$i==0 ? " ($self->{'text_hash'}->{'edit_prihigh'})" :
			$i==@{$self->{'nice_range_array'}}-1 ? " ($self->{'text_hash'}->{'edit_prilow'})" :
			$self->{'nice_range_array'}->[$i]==0 ? " ($self->{'text_hash'}->{'edit_pridef'})" : "";
		}
	print "</select> <input type=submit value='$self->{'text_hash'}->{'edit_change'}'>\n";
	}
print "</td> </form></tr>\n";
$i = 0;
foreach $k (keys %{$self->{'pinfo_hash'}}) {
	if ($k =~ /^_/) {
		if ($i%2 == 0) { print "<tr>\n"; }
		printf "<td width=20%% nowrap><b>%s</b></td>\n",
			$self->{'info_arg_map_hash'}->{$k};
		print "<td>$self->{'pinfo_hash'}->{$k}</td>\n";
		if ($i%2 == 1) { print "<tr>\n"; }
		$i++;
		}
	}
print "</table></td></tr></table><p>\n";

print "<table width=100%><tr>\n";
if ($self->{'access_hash'}->{'simple'}) {
	# Just display buttons for common signals
	print "<form action=kill_proc.cgi>\n";
	print "<input type=hidden name=pid value=$self->{'pinfo_hash'}->{pid}><td nowrap>\n";
	foreach $s ('KILL', 'TERM', 'HUP', 'STOP', 'CONT') {
		printf "<input type=submit value=\"%s\" name=%s>\n",
			$self->{'text_hash'}->{"kill_".lc($s)}, $s;
		}
	print "</td></form>\n";
	}
else {
	# Allow the sending of any signal
	print "<form action=kill_proc.cgi>\n";
	print "<td nowrap><input type=hidden name=pid value='$self->{'pinfo_hash'}->{'pid'}'>\n";
	print "<input type=submit value=\"$self->{'text_hash'}->{'edit_kill'}\">\n";
	print "<select name=signal>\n";
	foreach $s ($self->supported_signals()) {
		printf "<option value=\"$s\" %s> $s\n",
			$s eq "HUP" ? "selected" : "";
		}
	print "</select>";

	print "&nbsp;" x 4;
	print "<input type=submit name=TERM value='$self->{'text_hash'}->{'edit_sigterm'}'>\n";
	print "<input type=submit name=KILL value='$self->{'text_hash'}->{'edit_sigkill'}'>\n";
	print "&nbsp;" x 4;
	print "<input type=submit name=STOP value='$self->{'text_hash'}->{'edit_sigstop'}'>\n";
	print "<input type=submit name=CONT value='$self->{'text_hash'}->{'edit_sigcont'}'>\n";
	print "</td></form>\n";
	}

if ($self->{'has_trace_command'}) {
	# Show button to trace syscalls
	print "<form action=trace.cgi>\n";
	print "<input type=hidden name=pid value=$self->{'pinfo_hash'}->{'pid'}>\n";
	print "<td align=right width=10><input type=submit value='$self->{'text_hash'}->{'edit_trace'}'>\n";
	print "</td></form>\n";
	}

if ($self->{'has_lsof_command'}) {
	# Show button to display currently open files
	print "<form action=open_files.cgi>\n";
	print "<input type=hidden name=pid value=$self->{'pinfo_hash'}->{'pid'}>\n";
	print "<td align=right width=10><input type=submit value='$self->{'text_hash'}->{'edit_open'}'>\n";
	print "</td></form>\n";
	}

print "</tr></table><p>\n";

@{$self->{'sub_array'}} = grep { $_->{'ppid'} == $self->{'pinfo_hash'}->{pid} } $self->list_processes();
if (@{$self->{'sub_array'}}) {
	print "<table border width=100%>\n";
	print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'edit_sub'}</b></td> </tr>\n";
	print "<tr $self->{'cb'}> <td><table>\n";
	@{$self->{'sub_array'}} = sort { $a->{'pid'} <=> $b->{'pid'} } @{$self->{'sub_array'}};
	foreach $s (@{$self->{'sub_array'}}) {
		local $p = $s->{'pid'};
		print "<tr> <td><a href=\"edit_proc.cgi?$p\">$p</a></td>\n";
		print "<td>",$self->cut_string($s->{args}, 80),"</td> </tr>\n";
		}
	print "</table></td></tr></table><p>\n";
	}

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

