#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_virt.cgi
# Display a form for editing some kind of per-server

#require './home-lib.pl';
&ModuleLoader::preload_module('proc_class', "proc::ProcLib");
$self = new proc::ProcLib:: 'proc_class',%$self;

&ModuleLoader::preload_module('proc_class', "proc::LinuxLib");
$self = new proc::LinuxLib:: 'proc_class',%$self;

#&init_config();
$self->ReadParse();

#local $module = 'proc';
#local %mtext = $self->load_language("/$module");
#local %mconfig = $self->foreign_config("$module");
local %mtext = $self->load_language("/proc");
local %mconfig = $self->foreign_config("proc");

#$self->foreign_require($module, 'proc-lib.pl');

local $module = 'home';
$self->foreign_require($module, 'home-lib.pl');

$self->ui_print_header(undef, $self->{'text_hash'}->{'info_title'}, "");

if ($self->UNIVERSAL::can('get_memory_info')) {
	($self->{'mem_total'}, $self->{'mem_free'}, $self->{'swap_total'}, $self->{'swap_free'}) = $self->get_memory_info();
}

local @info = ();
local %cpu = ();

if ( $self->{'gconfig_hash'}->{'real_os_type'} ) {
	push(@info,
		'info_os_type', $self->{'gconfig_hash'}->{'real_os_type'},
		'info_os_version', $self->{'gconfig_hash'}->{'real_os_version'}
	);
}
else {
	push(@info,
		'info_os_type', $self->{'gconfig_hash'}->{'os_type'},
		'info_os_version', $self->{'gconfig_hash'}->{'os_version'}
	);
}

%cpu = $self->get_full_cpu_info() if $self->UNIVERSAL::can('get_full_cpu_info');

if (%cpu) {
	$cpu{'cachesize'} =~ s/[^\d]//g;
	push(@info,
		'info_cpu_name', $cpu{'modelname'},
		'info_cpu_vendor', $cpu{'vendor_id'},
		'info_cpu_speed', $self->text('info_mhz', $cpu{'cpumhz'}),
		'info_cpu_cache', $self->text('info_kb', $cpu{'cachesize'})
	);
}

push(@info, 'info_mem_total', $self->text('info_kb', $self->{'mem_total'})) if defined($self->{'mem_total'});
push(@info, 'info_mem_free', $self->text('info_kb', $self->{'mem_free'})) if defined($self->{'mem_free'});
push(@info, 'info_swap_total', $self->text('info_kb', $self->{'swap_total'})) if defined($self->{'swap_total'});
push(@info, 'info_swap_free', $self->text('info_kb', $self->{'swap_free'})) if defined($self->{'swap_free'});

push(@info, 'info_uptime', $main::home_object->get_uptime());

# create services list
local @services = ();
$self->{'services_conf'} = 'services.conf';
local @procs = $self->list_processes();
open( SYSMON, "<$self->{'services_conf'}" );
local @temp = <SYSMON>;
close(SYSMON);
chomp @temp;
	local $line      = "";
	local $name      = "";
	local $scr_name  = "";
	local %hash      = ();
	local %proc_list = ();
	local %link_list = ();
	local @proc_keys = ();

foreach $line (@temp) {
	( $name,  $scr_name ) = split "=", $line;
	( $self->{'label'}, $self->{'link'} )     = split ":", $scr_name;
	$link_list{$name} = $self->{'link'};
	$proc_list{$name} = $self->{'label'};
}

@proc_keys = sort keys %proc_list;
foreach $key (@proc_keys) {
	$self->{'value'} = $proc_list{$key};
	$self->{'link'}  = $link_list{$key};
	next if !$self->configured( $self->{'link'} );
	$self->{'status'} = '<font color="red">'.$self->{'text_hash'}->{'info_stopping'}.'</font>';
	foreach $hash (@procs) {
		local %line = %{$hash};
		if ( $line{"args"} =~ /$key/i ) {
			$self->{'status'} = '<font color="green">'.$self->{'text_hash'}->{'info_running'}.'</font>';
		}
	}
	$self->{'text_hash'}->{"info_$self->{'link'}"} = $self->{'value'};
	push(@services, "info_$self->{'link'}", $self->{'status'});
}

print "<table border width='100%'>\n";
print "<tr $self->{'tb'} colspan=2><td><b>$self->{'text_hash'}->{'info_summary'}</b></td></tr>";
print "<tr $self->{'cb'}><td>";
&print_info(\@info);
print "</td></tr>\n";
print "<tr $self->{'cb'} colspan=2><td>&nbsp;</td></tr>";
print "<tr $self->{'tb'} colspan=2><td><b>$self->{'text_hash'}->{'info_services'}</b></td></tr>";
print "<tr $self->{'cb'}><td>";
&print_info(\@services);
print "</td></tr></table>\n";

$self->ui_print_footer($self->{'text_hash'}->{'index_mainpage_url'}, $self->{'text_hash'}->{'index_mainpage'});

1;
		
}

sub print_info {
	shift if ($self == $_[0]);

	my @info = @{$_[0]};
	print "<table border width='100%'>\n";
	for (my $i = 0; $i < scalar @info; $i += 2) {
		my ($k, $value) = @info[$i, $i+1];
		print "<tr><td width=50%>$self->{'text_hash'}->{$k}</td><td>$value</td></tr>\n";
	}
	print "</table>\n";
}


1;

