#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Display syscalls made by this process in real time

&ModuleLoader::preload_module('proc_class', "proc::ProcLib");
$self = new proc::ProcLib:: 'proc_class',%$self;

$self->ReadParse();
if ($self->{'config_hash'}->{'trace_java'}) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'trace_title'}, "", "trace");
	}
else {
	$self->ui_print_unbuffered_header(undef, $self->{'text_hash'}->{'trace_title'}, "", "trace");
	}
%{$self->{'pinfo_hash'}} = $self->process_info($self->{'in_hash'}->{'pid'});
$self->can_edit_process($self->{'pinfo_hash'}->{'user'}) || $self->error($self->{'text_hash'}->{'edit_ecannot'});
if (!%{$self->{'pinfo_hash'}}) {
	print "<b>$self->{'text_hash'}->{'edit_gone'}</b> <p>\n";
	$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
	exit;
	}

$self->{'syscalls'} = $self->ui_form_start("trace.cgi", "post")."\n".
	    $self->ui_hidden("pid", $self->{'in_hash'}->{'pid'})."\n".
	    "<b>$self->{'text_hash'}->{'trace_syscalls'}</b>\n".
	    $self->ui_radio("all", defined($self->{'in_hash'}->{'all'}) ? $self->{'in_hash'}->{'all'} : 1,
		      [ [ 1, $self->{'text_hash'}->{'trace_all'} ],
			[ 0, $self->{'text_hash'}->{'trace_sel'} ] ])."\n".
	    $self->ui_textbox("syscalls", $self->{'in_hash'}->{'syscalls'}, 40)."\n".
	    $self->ui_submit($self->{'text_hash'}->{'trace_change'})."\n".
	    $self->ui_form_end()."\n";

if ($self->{'config_hash'}->{'trace_java'}) {
	# Output Java applet to show trace
	print "<b>",$self->text('trace_doing', "<tt>$self->{'pinfo_hash'}->{'args'}</tt>"),"</b><br>\n";
	print $self->{'syscalls'};
	print "<applet code=Tracer width=800 height=300>\n";
	$self->seed_random();
	$self->{'id'} = int(rand()*1000000000);
	print "<param name=url value='tail.cgi?pid=$self->{'in_hash'}->{'pid'}&id=$self->{'id'}&syscalls=",
	      $self->{'in_hash'}->{'all'} ? "" : $self->urlize($self->{'in_hash'}->{'syscalls'}),"'>\n";
	print "<param name=killurl value='killtail.cgi?id=$self->{'id'}'>\n";
	if ($self->{'session_id'}) {
		print "<param name=session value=\"sid=$self->{'session_id'}\">\n";
		}
	print "$self->{'text_hash'}->{'trace_sorry'}<p>\n";
	print "</applet>\n";
	}
else {
	# Just display here as text
	@{$self->{'syscalls_array'}} = $self->{'in_hash'}->{'all'} ? ( ) : split(/\s+/, $self->{'in_hash'}->{'syscalls'});
	$self->{'trace'} = $self->open_process_trace($self->{'in_hash'}->{'pid'},
				     \@{$self->{'syscalls_array'}});
	$self->{'fmt'} = "%-8.8s %-11.11s %-80.80s %-10.10s";
	print "<b>",$self->text('trace_start', "<tt>$self->{'pinfo_hash'}->{'args'}</tt>"),"</b><br>\n";
	print $self->{'syscalls'};
	print "<pre>";
	printf "$self->{'fmt'}\n", "Time", "System Call", "Parameters", "Return";
	printf "$self->{'fmt'}\n", ("-"x8), ("-"x11), ("-"x80), ("-"x10);
	while($self->{'action'} = $self->read_process_trace($self->{'trace'})) {
		local $tm = $self->strftime("%H:%M:%S", localtime($self->{'action'}->{'time'}));
		printf "$self->{'fmt'}\n", $tm, $self->{'action'}->{'call'},
				 join(", ", @{$self->{'action'}->{'args'}}),
				 $self->{'action'}->{'rv'};
		}
	print "</pre>";
	$self->close_process_trace($self->{'trace'});
	if (!kill(0, $self->{'in_hash'}->{'pid'})) {
		print "<b>$self->{'text_hash'}->{'trace_done'}</b><br>\n";
		}
	else {
		print "<b>$self->{'text_hash'}->{'trace_failed'}</b><br>\n";
		}
	}

$self->ui_print_footer("edit_proc.cgi?$self->{'in_hash'}->{'pid'}", $self->{'text_hash'}->{'edit_return'},
		 "", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

