#!/usr/bin/perl
package procmail::Log_parser;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'procmail::Log_parser');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# log_parser.pl
# Functions for parsing this module's logs

&ModuleLoader::preload_module(ref($self), "procmail::ProcmailLib");
$self = new procmail::ProcmailLib:: ref($self), %$self; 

1;
		return $self;
}

# parse_webmin_log(user, script, action, type, object, &params)
# Converts logged information from this module into human-readable form
sub parse_webmin_log
{
	my $self = shift;

local ($user, $script, $action, $type, $object, $p) = @_;
if ($type eq "recipe") {
	local ($t, $a) = $self->parse_action($p);
	return $self->text('log_'.$action.'_rec',
		     $self->text('log_act'.$t, $self->html_escape($a)));
	}
elsif ($type eq "env") {
	return $self->text('log_'.$action.'_env', $self->html_escape($p->{'name'}));
	}
elsif ($type eq "inc") {
	return $self->text('log_'.$action.'_inc', $self->html_escape($p->{'include'}));
	}
elsif ($type eq "recipes") {
	return $self->text('log_'.$action.'_recs', $object);
	}
else {
	return $self->{'text_hash'}->{'log_'.$action};
	}
}


1;

