#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_receipe.cgi
# Display a form for editing or creating a procmail receipe

&ModuleLoader::preload_module('procmail_class', "procmail::ProcmailLib");
$self = new procmail::ProcmailLib:: 'procmail_class',%$self;

$self->ReadParse();
if ($self->{'in_hash'}->{'new'}) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'edit_title1'}, "");
	$self->{'block'}++ if ($self->{'in_hash'}->{'block'});
	}
else {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'edit_title2'}, "");
	@{$self->{'conf_array'}} = $self->get_procmailrc();
	$self->{'rec'} = $self->{'conf_array'}->[$self->{'in_hash'}->{'idx'}];
	$self->{'block'}++ if (defined($self->{'rec'}->{'block'}));
	}

print "<form action=save_recipe.cgi>\n";
print "<input type=hidden name=new value='$self->{'in_hash'}->{'new'}'>\n";
print "<input type=hidden name=idx value='$self->{'in_hash'}->{'idx'}'>\n";
print "<input type=hidden name=before value='$self->{'in_hash'}->{'before'}'>\n";
print "<input type=hidden name=after value='$self->{'in_hash'}->{'after'}'>\n";
print "<input type=hidden name=block value='$self->{'block'}'>\n";

# Show action section
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'edit_header1'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

if ($self->{'block'}) {
	# Start of a conditional block
	local @lines = split(/\n/, $self->{'rec'}->{'block'});
	local $r = @lines > 5 ? 10 : 5;
	print "<tr> <td valign=top><b>$self->{'text_hash'}->{'edit_block'}</b></td>\n";
	print "<td colspan=3><textarea name=bdata rows=$r cols=80>",
		$self->{'rec'}->{'block'},"</textarea></td> </tr>\n";
	}
else {
	# Simple action
	($self->{'t'}, $self->{'a'}) = $self->parse_action($self->{'rec'});
	print "<tr> <td><b>$self->{'text_hash'}->{'edit_action'}</b></td>\n";
	print "<td colspan=3><select name=amode>\n";
	foreach $i (0, 2, 1, 3, 4, 6) {
		printf "<option value=%d %s>%s\n",
			$i, $self->{'t'} == $i ? "selected" : "", $self->{'text_hash'}->{"edit_amode_$i"};
		}
	print "</select>\n";
	printf "<input name=action size=40 value='%s'></td> </tr>\n",
		$self->html_escape($self->{'t'} == 6 ? $self->{'rec'}->{'action'} : $self->{'a'});
	}

print "<tr> <td colspan=4><table>\n";
$i = 0;
foreach $f (@{$self->{'known_flags_array'}}) {
	print "<tr>\n" if ($i%2 == 0);
	print "<td width=50% nowrap>\n";
	printf "<input type=checkbox name=flag value=%s %s> %s\n",
		$f, $self->indexof($f, @{$self->{'rec'}->{'flags'}}) >= 0 ? "checked" : "",
		$self->{'text_hash'}->{"edit_flag_$f"};
	print "</td>\n";
	print "</tr>\n" if ($i%2 == 1);
	$i++;
	}
print "</table></td> </tr>\n";

$self->{'ldef'} = $self->{'rec'}->{'lockfile'} ? 0 :
	defined($self->{'rec'}->{'lockfile'}) ? 2 : 1;
print "<tr> <td><b>$self->{'text_hash'}->{'edit_lockfile'}</b></td> <td colspan=3>\n";
printf "<input type=radio name=lockfile_def value=1 %s> %s\n",
	$self->{'ldef'} == 1 ? "checked" : "", $self->{'text_hash'}->{'edit_none'};
printf "<input type=radio name=lockfile_def value=2 %s> %s\n",
	$self->{'ldef'} == 2 ? "checked" : "", $self->{'text_hash'}->{'default'};
printf "<input type=radio name=lockfile_def value=0 %s> %s\n",
	$self->{'ldef'} == 0 ? "checked" : "", $self->{'text_hash'}->{'edit_lock'};
printf "<input name=lockfile size=40 value='%s'></td> </tr>\n",
	$self->html_escape($self->{'rec'}->{'lockfile'});

print "</table></td></tr></table><br>\n";

# Show conditions section
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'edit_header2'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td>\n";

print "$self->{'text_hash'}->{'edit_conddesc'}<p>\n";

$i = 0;
foreach $c (@{$self->{'rec'}->{'conds'}}, [ '-' ], [ '-' ] ) {
	print "<select name=cmode_$i>\n";
	printf "<option value='-' %s>&nbsp;\n",
		$c->[0] eq '-' ? "selected" : "";
	printf "<option value='' %s> %s\n",
		$c->[0] eq '' ? "selected" : "", $self->{'text_hash'}->{'edit_cmode_re'};
	printf "<option value='!' %s> %s\n",
		$c->[0] eq '!' ? "selected" : "", $self->{'text_hash'}->{'edit_cmode_nre'};
	printf "<option value='\$' %s> %s\n",
		$c->[0] eq '$' ? "selected" : "", $self->{'text_hash'}->{'edit_cmode_shell'};
	printf "<option value='?' %s> %s\n",
		$c->[0] eq '?' ? "selected" : "", $self->{'text_hash'}->{'edit_cmode_exit'};
	printf "<option value='<' %s> %s\n",
		$c->[0] eq '<' ? "selected" : "", $self->{'text_hash'}->{'edit_cmode_lt'};
	printf "<option value='>' %s> %s\n",
		$c->[0] eq '>' ? "selected" : "", $self->{'text_hash'}->{'edit_cmode_gt'};
	print "</select>\n";
	printf "<input name=cond_$i size=60 value='%s'><br>\n",
		$self->html_escape($c->[1]);
	$i++;
	}

print "</td></tr></table>\n";

# Show save buttons
print "<table width=100%><tr>\n";
if ($self->{'in_hash'}->{'new'}) {
	print "<td><input type=submit value='$self->{'text_hash'}->{'create'}'></td>\n";
	}
else {
	print "<td><input type=submit value='$self->{'text_hash'}->{'save'}'></td>\n";
	print "<td align=right><input type=submit name=delete ",
	      "value='$self->{'text_hash'}->{'delete'}'></td>\n";
	}
print "</tr></table></form>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

