#!/usr/bin/perl

&MAIN();

 sub MAIN {
# index.cgi
# Display the current list of procmail recipes

&ModuleLoader::preload_module('procmail_class', "procmail::ProcmailLib");
$self = new procmail::ProcmailLib:: 'procmail_class',%$self;

if ($self->{'minfo_hash'}->{'usermin'}) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", undef, 1, 1);
	}
else {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", undef, 1, 1);
	}

# Make sure procmail is installed
if (!$self->{'module_info_hash'}->{'usermin'} && !$self->has_command($self->{'config_hash'}->{'procmail'})) {
	print $self->text('index_ecmd', "<tt>$self->{'config_hash'}->{'procmail'}</tt>",
				  "../config.cgi?$self->{'module_name'}"),"<p>\n";

	$self->foreign_require("software", "software-lib.pl");
	$self->{'lnk'} = $main::software_object->missing_install_link(
			"procmail", $self->{'text_hash'}->{'index_procmail'},
			"../$self->{'module_name'}/", $self->{'text_hash'}->{'index_header'});
	print $self->{'lnk'},"<p>\n" if ($self->{'lnk'});

	$self->ui_print_footer("/", $self->{'text_hash'}->{'index_return'});
	exit;
	}

# Tell user when procmail will be used
if ($self->{'module_info_hash'}->{'usermin'}) {
	print $self->text('index_desc', "<tt>$self->{'procmailrc'}</tt>"),"<p>\n";
	}
else {
	$self->{'ms'} = $self->foreign_installed("qmailadmin") ? "qmail" :
	      $self->foreign_installed("postfix") ? "postfix" :
	      $self->foreign_installed("sendmail") ? "sendmail" : "other";
	print $self->text('index_desc_'.$self->{'ms'}, "<tt>$self->{'procmailrc'}</tt>"),"<p>\n";
	}

# Build links for adding things
@{$self->{'links_array'}} = ( "<a href='edit_recipe.cgi?new=1'>$self->{'text_hash'}->{'index_add'}</a>",
	   "<a href='edit_recipe.cgi?new=1&block=1'>$self->{'text_hash'}->{'index_badd'}</a>",
	   "<a href='edit_env.cgi?new=1'>$self->{'text_hash'}->{'index_eadd'}</a>" );
push(@{$self->{'links_array'}}, "<a href='edit_inc.cgi?new=1'>$self->{'text_hash'}->{'index_iadd'}</a>")
	if (!$self->{'includes'});

@{$self->{'conf_array'}} = $self->get_procmailrc();
if (@{$self->{'conf_array'}}) {
	@tds = ( "width=5" );
	print $self->ui_form_start("delete_recipes.cgi", "post");
	unshift(@{$self->{'links_array'}}, $self->select_all_link("d"),
			$self->select_invert_link("d") );
	print $self->ui_links_row(\@{$self->{'links_array'}});
	print $self->ui_columns_start([
		"",
		$self->{'text_hash'}->{'index_action'},
		$self->{'text_hash'}->{'index_conds'},
		$self->{'text_hash'}->{'index_move'},
		$self->{'text_hash'}->{'index_ba'} ], 100, 0, \@tds);
	foreach $c (@{$self->{'conf_array'}}) {
		local @cols;
		local @tds = ( "width=5" );
		if ($c->{'name'}) {
			# Environment variable assignment
			local $v = length($c->{'value'}) > 80 ?
					substr($c->{'value'}, 0, 80)." ..." :
					$c->{'value'};
			push(@cols, "<a href='edit_env.cgi?idx=$c->{'index'}'>".
			      $self->text('index_env',
			    	"<tt>".$self->html_escape($c->{'name'})."</tt>",
				"<tt>".$self->html_escape($v)."</tt>")."</a>");
			push(@tds, "width=100% colspan=2");
			}
		elsif ($c->{'include'}) {
			# Included file
			push(@cols, "<a href='edit_inc.cgi?idx=$c->{'index'}'>".
				$self->text('index_include', 
				"<tt>".$self->html_escape($c->{'include'})."</tt>").
				"</a>");
			push(@tds, "width=100% colspan=2");
			}
		else {
			# Procmail recipe
			local ($t, $a) = $self->parse_action($c);
			push(@cols,
			    "<a href='edit_recipe.cgi?idx=$c->{'index'}'>".
			    $self->text('index_act'.$t,
				    "<tt>".$self->html_escape($a)."</tt>")."</a>");
			push(@tds, "valign=top width=50%");

			local @c = @{$c->{'conds'}};
			if (!@c) {
				push(@cols, $self->{'text_hash'}->{'index_noconds'});
				}
			else {
				local $c;
				foreach $n (@c) {
					local $he ="<tt>".$self->html_escape($n->[1]).
						   "</tt>";
					if ($n->[0] eq '') {
						$c .= $self->text('index_re', $he);
						}
					elsif ($n->[0] eq '!') {
						$c .= $self->text('index_nre', $he);
						}
					elsif ($n->[0] eq '$') {
						$c .= $self->text('index_shell', $he);
						}
					elsif ($n->[0] eq '?') {
						$c .= $self->text('index_exit', $he);
						}
					elsif ($n->[0] eq '<') {
						$c .= $self->text('index_lt',$n->[1]);
						}
					elsif ($n->[0] eq '>') {
						$c .= $self->text('index_gt',$n->[1]);
						}
					$c .= "<br>\n";
					}
				push(@cols, $c);
				}
			push(@tds, "width=50%");
			}

		# Move up/down links
		local $mover;
		if ($c eq $self->{'conf_array'}->[@{$self->{'conf_array'}}-1] ||
		    $c->{'file'} ne $self->{'conf_array'}->[$c->{'index'}+1]->{'file'}) {
			$mover .= "<img src=images/gap.gif>";
			}
		else {
			$mover .= "<a href='down.cgi?idx=$c->{'index'}'>".
			      "<img src=images/down.gif border=0></a>";
			}
		if ($c eq $self->{'conf_array'}->[0] ||
		    $c->{'file'} ne $self->{'conf_array'}->[$c->{'index'}-1]->{'file'}) {
			$mover .= "<img src=images/gap.gif>";
			}
		else {
			$mover .= "<a href='up.cgi?idx=$c->{'index'}'>".
			      "<img src=images/up.gif border=0></a>";
			}
		push(@cols, $mover);
		push(@tds, "width=32");

		# Add before/after links
		push(@cols, "<a href='edit_recipe.cgi?new=1&before=$c->{'index'}'><img src=images/before.gif border=0></a><a href='edit_recipe.cgi?new=1&after=$c->{'index'}'><img src=images/after.gif border=0></a>");
		print $self->ui_checked_columns_row(\@cols, \@tds, "d",$c->{'index'});
		}
	print $self->ui_columns_end();
	print $self->ui_links_row(\@{$self->{'links_array'}});
	print $self->ui_form_end([ [ "delete", $self->{'text_hash'}->{'index_delete'} ] ]);
	}
else {
	print "<b>$self->{'text_hash'}->{'index_none'}</b><p>\n";
	}

# Manual edit button
print "<hr>\n";
print $self->ui_buttons_start();
print $self->ui_buttons_row("manual_form.cgi",
		      $self->{'text_hash'}->{'index_man'}, $self->{'text_hash'}->{'index_mandesc'});
print $self->ui_buttons_end();

print "<a href='manual_form.cgi'>$self->{'text_hash'}->{'index_manual'}</a>\n";
print "<p>\n";

$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});

1;
		
}


1;

