#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_recipe.cgi
# Create, update or delete a procmail recipe

&ModuleLoader::preload_module('procmail_class', "procmail::ProcmailLib");
$self = new procmail::ProcmailLib:: 'procmail_class',%$self;

$self->ReadParse();
$self->lock_file($self->{'procmailrc'});
@{$self->{'conf_array'}} = $self->get_procmailrc();
$self->{'rec'} = $self->{'conf_array'}->[$self->{'in_hash'}->{'idx'}] if (!$self->{'in_hash'}->{'new'});

if ($self->{'in_hash'}->{'delete'}) {
	# Just delete the recipe
	$self->delete_recipe($self->{'rec'});
	}
else {
	# Validate inputs
	$self->error_setup($self->{'text_hash'}->{'save_err'});
	if ($self->{'in_hash'}->{'block'}) {
		# Conditional code block
		$self->{'in_hash'}->{'bdata'} =~ s/\r//g;
		$self->{'rec'}->{'block'} = $self->{'in_hash'}->{'bdata'};
		}
	else {
		# Normal action
		$self->{'in_hash'}->{'action'} =~ /\S/ ||
			$self->error($self->{'text_hash'}->{'save_eaction_'.$self->{'in_hash'}->{'amode'}});
		delete($self->{'rec'}->{'type'});
		if ($self->{'in_hash'}->{'amode'} == 0) {
			$self->{'rec'}->{'action'} = $self->{'in_hash'}->{'action'};
			}
		elsif ($self->{'in_hash'}->{'amode'} == 1) {
			$self->{'rec'}->{'action'} = $self->{'in_hash'}->{'action'}."/.";
			}
		elsif ($self->{'in_hash'}->{'amode'} == 2) {
			$self->{'rec'}->{'action'} = $self->{'in_hash'}->{'action'}."/";
			}
		elsif ($self->{'in_hash'}->{'amode'} == 3) {
			$self->{'rec'}->{'type'} = "!";
			$self->{'rec'}->{'action'} = $self->{'in_hash'}->{'action'};
			}
		elsif ($self->{'in_hash'}->{'amode'} == 6) {
			$self->{'rec'}->{'type'} = "=";
			$self->{'in_hash'}->{'action'} =~ /^(\S+)=(.*)$/ ||
				$self->error($self->{'text_hash'}->{'save_eactionvar'});
			$self->{'rec'}->{'action'} = $self->{'in_hash'}->{'action'};
			}
		else {
			$self->{'rec'}->{'type'} = "|";
			$self->{'rec'}->{'action'} = $self->{'in_hash'}->{'action'};
			}
		}

	map { $self->{'flag_hash'}->{$_}++ } split(/\0/, $self->{'in_hash'}->{'flag'});
	@{$self->{'flags_array'}} = @{$self->{'rec'}->{'flags'}};
	foreach $f (@{$self->{'known_flags_array'}}) {
		if ($self->{'flag_hash'}->{$f}) {
			push(@{$self->{'flags_array'}}, $f);
			}
		else {
			@{$self->{'flags_array'}} = grep { $_ ne $f } @{$self->{'flags_array'}};
			}
		}
	$self->{'rec'}->{'flags'} = [ $self->unique(@{$self->{'flags_array'}}) ];

	if ($self->{'in_hash'}->{'lockfile_def'} == 1) {
		delete($self->{'rec'}->{'lockfile'});
		}
	elsif ($self->{'in_hash'}->{'lockfile_def'} == 2) {
		$self->{'rec'}->{'lockfile'} = "";
		}
	else {
		$self->{'in_hash'}->{'lockfile'} =~ /\S/ || $self->error($self->{'text_hash'}->{'save_elockfile'});
		$self->{'rec'}->{'lockfile'} = $self->{'in_hash'}->{'lockfile'};
		}

	for($i=0; defined($self->{'m'} = $self->{'in_hash'}->{"cmode_$i"}); $i++) {
		next if ($self->{'m'} eq '-');
		$self->{'c'} = $self->{'in_hash'}->{"cond_$i"};
		if ($self->{'m'} eq '<' || $self->{'m'} eq '>') {
			$self->{'c'} =~ /^\d+$/ || $self->error($self->text('save_esize', $i+1));
			}
		elsif ($self->{'m'} eq '$' || $self->{'m'} eq '?') {
			$self->{'c'} =~ /\S/ || $self->error($self->text('save_eshell', $i+1));
			}
		else {
			$self->{'c'} =~ /\S/ || $self->error($self->text('save_ere', $i+1));
			}
		push(@{$self->{'conds_array'}}, [ $self->{'m'}, $self->{'c'} ]);
		}
	$self->{'rec'}->{'conds'} = \@{$self->{'conds_array'}};

	# Save the receipe
	if ($self->{'in_hash'}->{'new'}) {
		if ($self->{'in_hash'}->{'before'} ne '') {
			$self->{'before'} = $self->{'conf_array'}->[$self->{'in_hash'}->{'before'}];
			$self->create_recipe_before($self->{'rec'}, $self->{'before'});
			}
		elsif ($self->{'in_hash'}->{'after'} ne '') {
			if ($self->{'in_hash'}->{'after'} == @{$self->{'conf_array'}}-1) {
				$self->create_recipe($self->{'rec'});
				}
			else {
				$self->{'before'} = $self->{'conf_array'}->[$self->{'in_hash'}->{'after'}+1];
				$self->create_recipe_before($self->{'rec'}, $self->{'before'});
				}
			}
		else {
			$self->create_recipe($self->{'rec'});
			}
		}
	else {
		$self->modify_recipe($self->{'rec'});
		}
	}
$self->unlock_file($self->{'procmailrc'});
$self->webmin_log($self->{'in_hash'}->{'delete'} ? "delete" : $self->{'in_hash'}->{'new'} ? "create" : "modify",
	    "recipe", undef, $self->{'rec'});
$self->redirect("");

1;
		
}


1;

