#!/usr/bin/perl
package proftpd::Mod_auth;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'proftpd::Mod_auth');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# mod_auth.pl

1;
		return $self;
}

sub mod_auth_directives
{
	my $self = shift;

local $rv = [
	[ 'DefaultChdir', 0, 2, 'virtual anon global', 1.20 ],
	[ 'DefaultRoot', 1, 2, 'virtual global', 0.99 ],
	[ 'LoginPasswordPrompt', 0, 3, 'virtual anon global', 1.20 ],
	[ 'RootLogin', 0, 6, 'virtual anon global', 1.15 ]
	];
return $self->make_directives($rv, $_[0], "mod_auth");
}

sub edit_DefaultChdir
{
	my $self = shift;

return (1, $self->{'text_hash'}->{'mod_auth_chdir'},
	$self->opt_input($_[0]->{'value'}, "DefaultChdir", $self->{'text_hash'}->{'default'}, 20));
}

sub save_DefaultChdir
{
	my $self = shift;

return $self->parse_opt("DefaultChdir", '^\S+$', $self->{'text_hash'}->{'mod_auth_echdir'});
}

sub edit_DefaultRoot
{
	my $self = shift;

local $rv = "<table border>\n".
	    "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'mod_auth_dir'}</b></td> ".
	    "<td><b>$self->{'text_hash'}->{'mod_auth_groups'}</b></td> </tr>\n";
local $i = 0;
foreach $r (@{$_[0]}, { }) {
	local @w = @{$r->{'words'}};
	$rv .= "<tr $self->{'cb'}>\n";

	local $dd = $w[0] eq "~" ? 2 : $w[0] ? 0 : 1;
	$rv .= sprintf "<td nowrap><input name=DefaultRoot_dd_$i type=radio value=1 %s> %s\n", $dd == 1 ? "checked" : "", $self->{'text_hash'}->{'mod_auth_none'};
	$rv .= sprintf "<input name=DefaultRoot_dd_$i type=radio value=2 %s> %s\n", $dd == 2 ? "checked" : "", $self->{'text_hash'}->{'mod_auth_home'};
	$rv .= sprintf "<input name=DefaultRoot_dd_$i type=radio value=0 %s>\n", $dd == 0 ? "checked" : "";
	$rv .= sprintf "<input name=DefaultRoot_d_$i size=20 value='%s'></td>\n", $dd ? "" : $w[0];

	$rv .= sprintf "<td nowrap><input name=DefaultRoot_gd_$i type=radio value=1 %s> %s\n", $w[1] ? "" : "checked", $self->{'text_hash'}->{'mod_auth_all'};
	$rv .= sprintf "<input name=DefaultRoot_gd_$i type=radio value=0 %s>\n", $w[1] ? "checked" : "";
	$rv .= sprintf "<input name=DefaultRoot_g_$i size=12 value='%s'></td>\n", join(" ", split(/,/, $w[1]));
	$rv .= "</tr>\n";
	$i++;
	}
$rv .= "</table>\n";
return (2, $self->{'text_hash'}->{'mod_auth_chroot'}, $rv);
}

sub save_DefaultRoot
{
	my $self = shift;

for($i=0; defined($self->{'in_hash'}->{"DefaultRoot_d_$i"}); $i++) {
	next if ($self->{'in_hash'}->{"DefaultRoot_dd_$i"} == 1);
	local $v = $self->{'in_hash'}->{"DefaultRoot_dd_$i"} == 2 ? "~" :$self->{'in_hash'}->{"DefaultRoot_d_$i"};
	$v =~ /^\S+$/ || $self->error($self->{'text_hash'}->{'mod_auth_edir'});
	if (!$self->{'in_hash'}->{"DefaultRoot_gd_$i"}) {
		local @g = split(/\s+/, $self->{'in_hash'}->{"DefaultRoot_g_$i"});
		@g || $self->error($self->{'text_hash'}->{'mod_auth_egroups'});
		$v .= " ".join(",", @g);
		}
	push(@{$self->{'rv_array'}}, $v);
	}
return ( \@{$self->{'rv_array'}} );
}

sub edit_LoginPasswordPrompt
{
	my $self = shift;

return (1, $self->{'text_hash'}->{'mod_auth_login'},
	$self->choice_input($_[0]->{'value'}, "LoginPasswordPrompt", "",
		      "$self->{'text_hash'}->{'yes'},on", "$self->{'text_hash'}->{'no'},off",
		      "$self->{'text_hash'}->{'default'},"));
}

sub save_LoginPasswordPrompt
{
	my $self = shift;

return $self->parse_choice("LoginPasswordPrompt", "");
}

sub edit_RootLogin
{
	my $self = shift;

return (1, $self->{'text_hash'}->{'mod_auth_root'},
	$self->choice_input($_[0]->{'value'}, "RootLogin", "",
		      "$self->{'text_hash'}->{'yes'},on", "$self->{'text_hash'}->{'no'},off",
		      "$self->{'text_hash'}->{'default'},"));
}

sub save_RootLogin
{
	my $self = shift;

return $self->parse_choice("RootLogin", "");
}


1;

