#!/usr/bin/perl
package proftpd::Mod_ldap;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'proftpd::Mod_ldap');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# mod_ldap.pl
use Data::Dumper;

#sub edit_LDAPXort {
# ($rv);
#return (1, "LDAPPort",
#sprintf "<input name=LDAPXPort size=6 value='%s'>\n",
#	 $_[0]->{'value'});
#}

1;
		return $self;
}

sub mod_ldap_directives
{
	my $self = shift;

local $rv = [
	[ 'LDAPServer', 0, 4, 'root', 1.15 ],
	[ 'LDAPDoAuth', 0, 4, 'root', 1.15 ],
        [ 'LDAPDNInfo', 0, 4, 'root', 1.15 ],
        [ 'LDAPDoUIDLookups', 0, 4, 'root', 1.15 ],
        [ 'LDAPDoGIDLookups', 0, 4, 'root', 1.15 ],
        [ 'LDAPAuthBinds', 0, 4, 'root', 1.15 ],
        [ 'LDAPDefaultUID', 0, 4, 'root', 1.15 ],
        [ 'LDAPDefaultGID', 0, 4, 'root', 1.15 ],
        [ 'LDAPHomedirOnDemand', 0, 4, 'root', 1.15 ],
        [ 'LDAPNegativeCache', 0, 4, 'root', 1.15 ],
        [ 'LDAPQueryTimeout', 0, 4, 'root', 1.15 ],
        [ 'LDAPDefaultAuthScheme', 0, 4, 'root', 1.15 ],

		];
return $self->make_directives($rv, $_[0], "mod_ldap");
}

sub edit_LDAPServer {
	my $self = shift;

local ($rv);
my $param = $_[0]->{'value'};
$self->{'name'}="LDAPServerp";
$self->{'namep'}=$self->{'name'}.'_m';
my ($port) =$param =~ /.+:(.+)/;
 (my $serveur,my $port)=$param =~ /([^:]+):?(.*)/;
$rv=sprintf "<b>Server:</b> <input name=LDAPServer size=20 value='%s'>\n",
	 $serveur;
$rv .= sprintf "<b> &nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp Port:</b><input type=radio
  name=$self->{'namep'} value=0 %s> %s\n",
		!$port  ? "checked" : "", $self->{'text_hash'}->{'default'};
$rv .= sprintf "<input type=radio name=$self->{'namep'} value=1 %s> \n",
		$port ? "checked" : "" ;
$rv .= sprintf "<input name=$self->{'name'} size=6 value='%s'><br>\n",
		$port ? $port: "";

return (2, "LDAP  Server info",$rv);


}

sub edit_LDAPQueryTimeout {
	my $self = shift;

local ($rv);
my $param = $_[0]->{'value'};
$self->{'name'}="LDAPQueryTimeout";
$self->{'namep'}=$self->{'name'}.'_m';
$rv = sprintf "<input type=radio
  name=$self->{'namep'} value=0 %s> %s\n",
		!$param  ? "checked" : "", $self->{'text_hash'}->{'default'};
$rv .= sprintf "<input type=radio name=$self->{'namep'} value=1 %s> \n",
		$param ? "checked" : "" ;
$rv .= sprintf "<input name=$self->{'name'} size=6 value='%s'><br>\n",
		$param ? $param: "";

return (2, "LDAP  Query timeout",$rv);


}

sub edit_LDAPDoAuth {
	my $self = shift;


local ($rv);
my @tab =@_;
my $name ='LDAPDoAuthp';
my $param = $tab[0]->{'value'};
my $option = $tab[0]->{'words'}->[0];
my $dn = $tab[0]->{'words'}->[1];

$self->{'namep'}=$name.'_m';

$rv = sprintf "<input type=radio  name=$self->{'namep'} value=0 %s> %s\n",
		!$option  ? "checked" : "", $self->{'text_hash'}->{'default'};
$rv .= sprintf "<input type=radio name=$self->{'namep'} value=1 %s> %s\n",
		$option =~/off/i ? "checked" : "" ,"Off";
$rv .= sprintf "<input type=radio name=$self->{'namep'} value=2 %s> %s \n",
		$option =~/on/i ? "checked" : "" ,"On";


$rv .= sprintf "<input name=$name size=40 value='%s'> %s\n",
		$dn ? $dn: "","<b>auth base prefix</b><br>";

return (2,"LDAP Do authentification",$rv);


}

sub edit_LDAPDefaultUID {
	my $self = shift;


local ($rv);
my @tab =@_;
my $name ='LDAPDefaultUID';
my $param = $tab[0]->{'value'};

$rv = sprintf "<input name=$name size=6 value='%s'> %s\n",
		$param ? $param: "","<br>";

return (1,"LDAP Default UID",$rv);


}

sub edit_LDAPHomedirOnDemand {
	my $self = shift;


local ($rv);
my @tab =@_;
my $name ='LDAPHomedirOnDemand';
my $param = $tab[0]->{'value'};

$self->{'namep'}=$name.'_m';

$rv = sprintf "<input type=radio  name=$self->{'namep'} value=0 %s> %s\n",
		!$param  ? "checked" : "", $self->{'text_hash'}->{'default'};
$rv .= sprintf "<input type=radio name=$self->{'namep'} value=1 %s> %s\n",
		$param =~/off/i ? "checked" : "" ,"Off";
$rv .= sprintf "<input type=radio name=$self->{'namep'} value=2 %s> %s \n",
		$param =~/on/i ? "checked" : "" ,"On";

return (1,"LDAP Homedir on demand",$rv);


}

sub edit_LDAPNegativeCache {
	my $self = shift;


local ($rv);
my @tab =@_;
my $name ='LDAPNegativeCache';
my $param = $tab[0]->{'value'};

$self->{'namep'}=$name.'_m';

$rv = sprintf "<input type=radio  name=$self->{'namep'} value=0 %s> %s\n",
		!$param  ? "checked" : "", $self->{'text_hash'}->{'default'};
$rv .= sprintf "<input type=radio name=$self->{'namep'} value=1 %s> %s\n",
		$param =~/off/i ? "checked" : "" ,"Off";
$rv .= sprintf "<input type=radio name=$self->{'namep'} value=2 %s> %s \n",
		$param =~/on/i ? "checked" : "" ,"On";

return (1,"LDAP negative cache",$rv);


}

sub edit_LDAPDefaultGID {
	my $self = shift;


local ($rv);
my @tab =@_;
my $name ='LDAPDefaultGID';
my $param = $tab[0]->{'value'};

$rv = sprintf "<input name=$name size=6 value='%s'> %s\n",
		$param ? $param: "","<br>";

return (1,"LDAP Default GID",$rv);


}

sub edit_LDAPDoUIDLookups {
	my $self = shift;


local ($rv);
my @tab =@_;
my $name ='LDAPDoUIDLookups';
my $param = $tab[0]->{'value'};
my $option = $tab[0]->{'words'}->[0];
my $dn = $tab[0]->{'words'}->[1];

$self->{'namep'}=$name.'_m';

$rv = sprintf "<input type=radio  name=$self->{'namep'} value=0 %s> %s\n",
		!$option  ? "checked" : "", $self->{'text_hash'}->{'default'};
$rv .= sprintf "<input type=radio name=$self->{'namep'} value=1 %s> %s\n",
		$option =~/off/i ? "checked" : "" ,"Off";
$rv .= sprintf "<input type=radio name=$self->{'namep'} value=2 %s> %s \n",
		$option =~/on/i ? "checked" : "" ,"On";


$rv .= sprintf "<input name=$name size=40 value='%s'> %s\n",
		$dn ? $dn: "","<b>uid base prefix</b><br>";

return (2,"LDAP Do UID Lookups",$rv);


}

sub edit_LDAPDoGIDLookups {
	my $self = shift;


local ($rv);
my @tab =@_;
my $name ='LDAPDoGIDLookups';
my $param = $tab[0]->{'value'};
my $option = $tab[0]->{'words'}->[0];
my $dn = $tab[0]->{'words'}->[1];

$self->{'namep'}=$name.'_m';

$rv = sprintf "<input type=radio  name=$self->{'namep'} value=0 %s> %s\n",
		!$option  ? "checked" : "", $self->{'text_hash'}->{'default'};
$rv .= sprintf "<input type=radio name=$self->{'namep'} value=1 %s> %s\n",
		$option =~/off/i ? "checked" : "" ,"Off";
$rv .= sprintf "<input type=radio name=$self->{'namep'} value=2 %s> %s \n",
		$option =~/on/i ? "checked" : "" ,"On";


$rv .= sprintf "<input name=$name size=40 value='%s'> %s\n",
		$dn ? $dn: "","<b>gid base prefix</b><br>";

return (2,"LDAP Do GID Lookups",$rv);


}

sub edit_LDAPDNInfo {
	my $self = shift;


local ($rv);
#return (2, "LDAPDNinfo",
$rv =sprintf "<b>BindDN:</b><input name=LDAPDNinfodn size=30 value='%s'>\n",
	 $_[0]->{'words'}->[0];
$rv .=sprintf "<b>&nbsp&nbsp&nbsp&nbsp PasswordDN</b><input name=LDAPDNinfopasswd size=20 value='%s'>\n",
	 $_[0]->{'words'}->[1];

return(2,"LDAP DN info",$rv);
}

sub edit_LDAPAuthBinds {
	my $self = shift;

local ($rv);
my @tab =@_;
my $name ='LDAPAuthBinds';
my $option = $tab[0]->{'value'};
#my $dn = $tab[0]->{'words'}->[1];
$rv = sprintf "<br><input type=radio  name=$name value=0 %s> %s\n",
		!$option  ? "checked" : "", $self->{'text_hash'}->{'default'};
$rv .= sprintf "<input type=radio name=$name value=1 %s> %s\n",
		$option =~/off/i ? "checked" : "" ,"Off";
$rv .= sprintf "<input type=radio name=$name value=2 %s> %s \n",
		$option =~/on/i ? "checked" : "" ,"On";


return (2,"LDAP auth bind ",$rv);


}

sub edit_LDAPDefaultAuthScheme {
	my $self = shift;

local ($rv);
my @tab =@_;
my $name ='LDAPDefaultAuthScheme';
my $option = $tab[0]->{'value'};
#my $dn = $tab[0]->{'words'}->[1];
$rv = sprintf "<br><input type=radio  name=$name value=0 %s> %s\n",
		!$option  ? "checked" : "", $self->{'text_hash'}->{'default'};
$rv .= sprintf "<input type=radio name=$name value=1 %s> %s\n",
		$option =~/crypt/i ? "checked" : "" ,"crypt";
$rv .= sprintf "<input type=radio name=$name value=2 %s> %s \n",
		$option =~/clear/i ? "checked" : "" ,"clear";


return (2,"LDAP default auth scheme ",$rv);


}

sub save_LDAPAuthBinds{
my $option =$self->{'in_hash'}->{'LDAPAuthBinds'};

return ([ ]) unless $option;

return (['off']) if $option==1;
return (['on']) if $option==2;;
return ([ ]);
}

sub save_LDAPDefaultUID{
my $option =$self->{'in_hash'}->{'LDAPDefaultUID'};

return ([ ]) unless $option;

return (["$option"]) if $option;
}

sub save_LDAPDefaultGID{
my $option =$self->{'in_hash'}->{'LDAPDefaultGID'};

return ([ ]) unless $option;

return (["$option"]) if $option;
}

sub save_LDAPServer {
	my $self = shift;

my $param =$self->{'in_hash'}->{'LDAPServer'};
if (($self->{'in_hash'}->{'LDAPServerp_m'} == 1) &&  ($self->{'in_hash'}->{'LDAPServerp'})){
$param.=":". $self->{'in_hash'}->{'LDAPServerp'};
}
return ( [ $param ] ) if $param;
return ( [ ] ) unless $param;
}

sub save_LDAPQueryTimeout {
	my $self = shift;

my $param =$self->{'in_hash'}->{'LDAPQueryTimeout'};
if (($self->{'in_hash'}->{'LDAPQueryTimeout_m'} == 1) &&  ($self->{'in_hash'}->{'LDAPQueryTimeout'})){
$param= $self->{'in_hash'}->{'LDAPQueryTimeout'};
} else {undef $param} ;
return ( [ $param ] ) if $param;
return ( [ ] ) unless $param;
}

sub save_LDAPDNInfo {
	my $self = shift;

my $dn = $self->{'in_hash'}->{'LDAPDNinfodn'} ;
my $dnp = $self->{'in_hash'}->{'LDAPDNinfopasswd'} ;

return([ "\"$dn\" \"$dnp\""]) if $dn;
return ([ ]) unless $dn;
}

sub save_LDAPDoAuth {
	my $self = shift;



my $option = $self->{'in_hash'}->{'LDAPDoAuthp_m'} ;
return ([ ]) unless $option;
return (['off']) if $option==1;
my $dn=$self->{'in_hash'}->{'LDAPDoAuthp'}; 
return([ "on \"$dn\""]) if $dn;
return ([ ]);
}

sub save_LDAPHomedirOnDemand {
	my $self = shift;



my $option = $self->{'in_hash'}->{'LDAPHomedirOnDemand_m'} ;
return ([ ]) unless $option;
return (['off']) if $option==1;
return(['on']) if  $option==2;

}

sub save_LDAPDefaultAuthScheme {
	my $self = shift;



my $option = $self->{'in_hash'}->{'LDAPDefaultAuthScheme'} ;
return ([ ]) unless $option;
return ([ ]) if  $option==0;
return (['"crypt"']) if $option==1;
return(['"clear"']) if  $option==2;

}

sub save_LDAPNegativeCache {
	my $self = shift;



my $option = $self->{'in_hash'}->{'LDAPNegativeCache_m'} ;
return ([ ]) unless $option;
return (['off']) if $option==1;
return(['on']) if  $option==2;

}

sub save_LDAPDoUIDLookups {
	my $self = shift;




my $option = $self->{'in_hash'}->{'LDAPDoUIDLookups_m'} ;
return ([ ]) unless $option;
return (['off']) if $option==1;
my $dn=$self->{'in_hash'}->{'LDAPDoUIDLookups'}; 
return([ "on \"$dn\""]) if $dn;
return ([ ]);
}

sub save_LDAPDoGIDLookups {
	my $self = shift;




my $option = $self->{'in_hash'}->{'LDAPDoGIDLookups_m'} ;
return ([ ]) unless $option;
return (['off']) if $option==1;
my $dn=$self->{'in_hash'}->{'LDAPDoGIDLookups'}; 
return([ "on \"$dn\""]) if $dn;
return ([ ]);
}


1;

