#!/usr/bin/perl
package proftpd::Mod_log;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'proftpd::Mod_log');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# mod_log.pl

1;
		return $self;
}

sub mod_log_directives
{
	my $self = shift;

local $rv = [
	[ 'SystemLog', 0, 1, 'root', 1.16 ],
	[ 'ExtendedLog', 1, 1, 'virtual anon global', 1.16 ],
	[ 'LogFormat', 1, 1, 'root', 1.16 ]
	];
return $self->make_directives($rv, $_[0], "mod_log");
}

sub edit_SystemLog
{
	my $self = shift;

return (2, $self->{'text_hash'}->{'mod_log_syslog'},
	$self->opt_input($_[0]->{'value'}, "SystemLog", $self->{'text_hash'}->{'mod_log_sysdef'}, 50,
		   $self->file_chooser_button("TransferLog")));
}

sub save_SystemLog
{
	my $self = shift;

return $self->parse_opt("SystemLog", '^\/\S+$', $self->{'text_hash'}->{'mod_log_esyslog'});
}

sub edit_ExtendedLog
{
	my $self = shift;

local $rv = "<table border>\n".
	    "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'mod_log_file'}</b></td> ".
	    "<td><b>$self->{'text_hash'}->{'mod_log_cmd'}</b></td> ".
	    "<td><b>$self->{'text_hash'}->{'mod_log_nick'}</b></td> </tr>\n";
local $i = 0;
foreach $l (@{$_[0]}, { }) {
	local @w = @{$l->{'words'}};
	$rv .= "<tr $self->{'cb'}>\n";
	$rv .= "<td><input name=ExtendedLog_t_$i size=20 value='$w[0]'></td>\n";
	$rv .= sprintf "<td><input name=ExtendedLog_cd_$i type=radio value=1 %s> %s\n", $w[1] && $w[2] ? "" : "checked", $self->{'text_hash'}->{'mod_log_all'};
	$rv .= sprintf "<input name=ExtendedLog_cd_$i type=radio value=0 %s>\n", $w[1] && $w[2] ? "checked" : "";
	$rv .= sprintf "<input name=ExtendedLog_c_$i size=15 value='%s'></td>\n", $w[1] && $w[2] ? join(" ", split(/,/, $w[1])) : "";
	$rv .= sprintf "<td><input name=ExtendedLog_fd_$i type=radio value=1 %s> %s\n", $w[2] || $w[1] ? "" : "checked", $self->{'text_hash'}->{'default'};
	$rv .= sprintf "<input name=ExtendedLog_fd_$i type=radio value=0 %s>\n", $w[2] || $w[1] ? "checked" : "";
	$rv .= sprintf "<input name=ExtendedLog_f_$i size=15 value='%s'></td>\n", $w[2] ? $w[2] : $w[1];
	$rv .= "</tr>\n";
	$i++;
	}
$rv .= "</table>\n";
return (2, $self->{'text_hash'}->{'mod_log_extended'}, $rv);
}

sub save_ExtendedLog
{
	my $self = shift;

local @rv;
for($i=0; defined($self->{'in_hash'}->{"ExtendedLog_t_$i"}); $i++) {
	next if (!$self->{'in_hash'}->{"ExtendedLog_t_$i"});
	local @w = ( $self->{'in_hash'}->{"ExtendedLog_t_$i"} );
	if (!$self->{'in_hash'}->{"ExtendedLog_cd_$i"}) {
		$self->{'in_hash'}->{"ExtendedLog_fd_$i"} && $self->error($self->{'text_hash'}->{'mod_log_ecmdnick'});
		$self->{'in_hash'}->{"ExtendedLog_c_$i"} =~ /\S/ ||
			$self->error($self->{'text_hash'}->{'mod_log_ecmd'});
		push(@w, join(",", map { uc($_) }
			  split(/\s+/, $self->{'in_hash'}->{"ExtendedLog_c_$i"})));
		}
	if (!$self->{'in_hash'}->{"ExtendedLog_fd_$i"}) {
		$self->{'in_hash'}->{"ExtendedLog_f_$i"} =~ /^\S+$/ ||
			$self->error($self->{'text_hash'}->{'mod_log_enick'});
		push(@w, $self->{'in_hash'}->{"ExtendedLog_f_$i"});
		}
	push(@rv, join(" ", @w));
	}
return ( \@rv );
}

sub edit_LogFormat
{
	my $self = shift;

local $rv = "<table border>\n".
	    "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'mod_log_nickname'}</b></td> ".
	    "<td><b>$self->{'text_hash'}->{'mod_log_fmt'}</b></td> </tr>\n";
local $i = 0;
foreach $f (@{$_[0]}, { }) {
	local @w = @{$f->{'words'}};
	$rv .= "<tr $self->{'cb'}>\n";
	$rv .= "<td><input name=LogFormat_n_$i size=15 value='$w[0]'></td>\n";
	$rv .= "<td><input name=LogFormat_f_$i size=35 value='$w[1]'></td>\n";
	$rv .= "</tr>\n";
	$i++;
	}
$rv .= "</table>\n";
return (2, $self->{'text_hash'}->{'mod_log_format'}, $rv);
}

sub save_LogFormat
{
	my $self = shift;

local @rv;
for($i=0; defined($self->{'in_hash'}->{"LogFormat_n_$i"}); $i++) {
	next if (!$self->{'in_hash'}->{"LogFormat_n_$i"});
	$self->{'in_hash'}->{"LogFormat_n_$i"} =~ /^\S+$/ || $self->error($self->{'text_hash'}->{'mod_log_enickname'});
	$self->{'in_hash'}->{"LogFormat_f_$i"} =~ /\S/ || $self->error($self->{'text_hash'}->{'mod_log_efmt'});
	$self->{'in_hash'}->{"LogFormat_f_$i"} =~ s/"/\\"/g;
	push(@rv, sprintf "%s \"%s\"", $self->{'in_hash'}->{"LogFormat_n_$i"},
				       $self->{'in_hash'}->{"LogFormat_f_$i"});
	}
return ( \@rv );
}


1;

