#!/usr/bin/perl
package proftpd::Mod_ls;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'proftpd::Mod_ls');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# mod_ls.pl

1;
		return $self;
}

sub mod_ls_directives
{
	my $self = shift;

local $rv = [
	[ 'DirFakeUser', 0, 2, 'virtual anon global', 1.15 ],
	[ 'DirFakeGroup', 0, 2, 'virtual anon global', 1.15 ],
	[ 'DirFakeMode', 0, 2, 'virtual anon global', 1.16 ],
	[ 'LsDefaultOptions', 0, 2, 'virtual anon global', 1.16 ],
	[ 'ListOptions', 0, 2, 'virtual anon global directory ftpaccess', 1.208 ],
	[ 'ShowDotFiles', 0, 2, 'virtual anon global', '0.99-1.206' ],
	];
return $self->make_directives($rv, $_[0], "mod_ls");
}

sub edit_DirFakeGroup
{
	my $self = shift;

local $rv;
local $w = $_[0]->{'words'}->[0];
$rv .= sprintf "<input type=radio name=DirFakeGroup value=off %s> %s\n",
	lc($w) eq 'off' ? "checked" : "", $self->{'text_hash'}->{'no'};
$rv .= sprintf "<input type=radio name=DirFakeGroup value='' %s> %s\n",
	lc($w) ? "" : "checked", $self->{'text_hash'}->{'default'};
$rv .= sprintf "<input type=radio name=DirFakeGroup value=on %s> %s\n",
	lc($w) eq 'on' ? "checked" : "", $self->{'text_hash'}->{'mod_ls_fakeasgroup'};

$rv .= "<table border cellpadding=0 cellspacing=0><tr><td>";
local $a = $_[0]->{'words'}->[1];
$rv .= sprintf "<input type=radio name=DirFakeGroup_m value=0 %s> %s\n",
	$a ? "" : "checked", "<tt>ftp</tt>";
$rv .= sprintf "<input type=radio name=DirFakeGroup_m value=1 %s> %s\n",
	$a eq "~" ? "checked" : "", $self->{'text_hash'}->{'mod_ls_fakesamegroup'};
$rv .= sprintf "<input type=radio name=DirFakeGroup_m value=2 %s>\n",
	$a eq "~" || !$a ? "" : "checked";
$rv .= sprintf "<input name=DirFakeGroup_a size=12 value='%s'>\n",
	$a eq "~" ? "" : $a;
$rv .= "</td></tr></table>\n";

return (2, $self->{'text_hash'}->{'mod_ls_fakegroup'}, $rv);
}

sub save_DirFakeGroup
{
	my $self = shift;

if (!$self->{'in_hash'}->{'DirFakeGroup'}) {
	return ( [ ] );
	}
else {
	local $s = $self->{'in_hash'}->{'DirFakeGroup'};
	if ($self->{'in_hash'}->{'DirFakeGroup_m'} == 1) {
		$s .= " ~";
		}
	elsif ($self->{'in_hash'}->{'DirFakeGroup_m'} == 2) {
		$self->{'in_hash'}->{'DirFakeGroup_a'} =~ /^\S+$/ ||
			$self->error($self->{'text_hash'}->{'mod_ls_efakegroup'});
		$s .= " ".$self->{'in_hash'}->{'DirFakeGroup_a'};
		}
	return ( [ $s ] );
	}
}

sub edit_DirFakeUser
{
	my $self = shift;

local $rv;
local $w = $_[0]->{'words'}->[0];
$rv .= sprintf "<input type=radio name=DirFakeUser value=off %s> %s\n",
	lc($w) eq 'off' ? "checked" : "", $self->{'text_hash'}->{'no'};
$rv .= sprintf "<input type=radio name=DirFakeUser value='' %s> %s\n",
	lc($w) ? "" : "checked", $self->{'text_hash'}->{'default'};
$rv .= sprintf "<input type=radio name=DirFakeUser value=on %s> %s\n",
	lc($w) eq 'on' ? "checked" : "", $self->{'text_hash'}->{'mod_ls_fakeasuser'};

$rv .= "<table border cellpadding=0 cellspacing=0><tr><td>";
local $a = $_[0]->{'words'}->[1];
$rv .= sprintf "<input type=radio name=DirFakeUser_m value=0 %s> %s\n",
	$a ? "" : "checked", "<tt>ftp</tt>";
$rv .= sprintf "<input type=radio name=DirFakeUser_m value=1 %s> %s\n",
	$a eq "~" ? "checked" : "", $self->{'text_hash'}->{'mod_ls_fakesameuser'};
$rv .= sprintf "<input type=radio name=DirFakeUser_m value=2 %s>\n",
	$a eq "~" || !$a ? "" : "checked";
$rv .= sprintf "<input name=DirFakeUser_a size=12 value='%s'>\n",
	$a eq "~" ? "" : $a;
$rv .= "</td></tr></table>\n";

return (2, $self->{'text_hash'}->{'mod_ls_fakeuser'}, $rv);
}

sub save_DirFakeUser
{
	my $self = shift;

if (!$self->{'in_hash'}->{'DirFakeUser'}) {
	return ( [ ] );
	}
else {
	local $s = $self->{'in_hash'}->{'DirFakeUser'};
	if ($self->{'in_hash'}->{'DirFakeUser_m'} == 1) {
		$s .= " ~";
		}
	elsif ($self->{'in_hash'}->{'DirFakeUser_m'} == 2) {
		$self->{'in_hash'}->{'DirFakeUser_a'} =~ /^\S+$/ ||
			$self->error($self->{'text_hash'}->{'mod_ls_efakeuser'});
		$s .= " ".$self->{'in_hash'}->{'DirFakeUser_a'};
		}
	return ( [ $s ] );
	}
}

sub edit_DirFakeMode
{
	my $self = shift;

return (1, $self->{'text_hash'}->{'mod_ls_fakemode'},
	$self->opt_input($_[0]->{'value'}, "DirFakeMode", $self->{'text_hash'}->{'mod_ls_nofake'}, 5));
}

sub save_DirFakeMode
{
	my $self = shift;

return $self->parse_opt("DirFakeMode", '0[0-7]{3}', $self->{'text_hash'}->{'mod_ls_efakemode'});
}

sub edit_LsDefaultOptions
{
	my $self = shift;

return (1, $self->{'text_hash'}->{'mod_ls_ls'},
	$self->opt_input($_[0]->{'value'}, "LsDefaultOptions", $self->{'text_hash'}->{'default'}, 20));
}

sub save_LsDefaultOptions
{
	my $self = shift;

return $self->parse_opt("LsDefaultOptions", '\S', $self->{'text_hash'}->{'mod_ls_els'});
}

sub edit_ShowDotFiles
{
	my $self = shift;

return (1, $self->{'text_hash'}->{'mod_ls_dotfiles'},
	$self->choice_input($_[0]->{'value'}, "ShowDotFiles", "",
		      "$self->{'text_hash'}->{'yes'},on", "$self->{'text_hash'}->{'no'},off",
		      "$self->{'text_hash'}->{'default'},"));
}

sub save_ShowDotFiles
{
	my $self = shift;

return $self->parse_choice("ShowDotFiles", "");
}

sub edit_ListOptions
{
	my $self = shift;

local $rv = $self->opt_input($_[0]->{'words'}->[0], "ListOptions",
		       $self->{'text_hash'}->{'default'}, 20);
$rv .= sprintf "<input type=checkbox name=ListOptions_strict value=1 %s> %s\n",
		lc($_[0]->{'words'}->[1]) eq 'strict' ? "checked" : "",
		$self->{'text_hash'}->{'mod_ls_strict'};
return (2, $self->{'text_hash'}->{'mod_ls_options'}, $rv);
}

sub save_ListOptions
{
	my $self = shift;

if ($self->{'in_hash'}->{"ListOptions_def"}) {
	return ( [ ] );
	}
else {
	local $rv = '"'.$self->{'in_hash'}->{"ListOptions"}.'"';
	$rv .= " strict" if ($self->{'in_hash'}->{'ListOptions_strict'});
	return ( [ $rv ] );
	}
}


1;

