#!/usr/bin/perl
package proftpd::Mod_unixpw;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'proftpd::Mod_unixpw');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# mod_unixpw.pl

1;
		return $self;
}

sub mod_unixpw_directives
{
	my $self = shift;

local $rv = [
	[ 'AuthUserFile', 0, 6, 'virtual global', 1.11 ],
	[ 'AuthGroupFile', 0, 6, 'virtual global', 1.11 ],
	[ 'AuthPAMAuthoritative', 0, 6, 'virtual global', 1.20 ],
	[ 'PersistentPasswd', 0, 6, 'root', 1.15 ]
	];
return $self->make_directives($rv, $_[0], "mod_unixpw");
}

sub edit_AuthUserFile
{
	my $self = shift;

return (2, $self->{'text_hash'}->{'mod_unixpw_ufile'},
	$self->opt_input($_[0]->{'value'}, "AuthUserFile", $self->{'text_hash'}->{'mod_unixpw_none'},
		   50, $self->file_chooser_button("AuthUserFile")));
}

sub save_AuthUserFile
{
	my $self = shift;

$self->{'in_hash'}->{'AuthUserFile_def'} || -r $self->{'in_hash'}->{'AuthUserFile'} ||
	$self->error($self->{'text_hash'}->{'mod_unixpw_eufile'});
return $self->parse_opt("AuthUserFile");
}

sub edit_AuthGroupFile
{
	my $self = shift;

return (2, $self->{'text_hash'}->{'mod_unixpw_gfile'},
	$self->opt_input($_[0]->{'value'}, "AuthGroupFile", $self->{'text_hash'}->{'mod_unixpw_none'},
		   50, $self->file_chooser_button("AuthGroupFile")));
}

sub save_AuthGroupFile
{
	my $self = shift;

$self->{'in_hash'}->{'AuthGroupFile_def'} || -r $self->{'in_hash'}->{'AuthGroupFile'} ||
	$self->error($self->{'text_hash'}->{'mod_unixpw_egfile'});
return $self->parse_opt("AuthGroupFile");
}

sub edit_AuthPAMAuthoritative
{
	my $self = shift;

return (1, $self->{'text_hash'}->{'mod_unixpw_pam'},
	$self->choice_input($_[0]->{'value'}, "AuthPAMAuthoritative", "",
		      "$self->{'text_hash'}->{'yes'},on", "$self->{'text_hash'}->{'no'},off",
		      "$self->{'text_hash'}->{'default'},"));
}

sub save_AuthPAMAuthoritative
{
	my $self = shift;

return $self->parse_choice("AuthPAMAuthoritative", "");
}

sub edit_PersistentPasswd
{
	my $self = shift;

return (1, $self->{'text_hash'}->{'mod_unixpw_persist'},
	$self->choice_input($_[0]->{'value'}, "PersistentPasswd", "",
		      "$self->{'text_hash'}->{'yes'},on", "$self->{'text_hash'}->{'no'},off",
		      "$self->{'text_hash'}->{'default'},"));
}

sub save_PersistentPasswd
{
	my $self = shift;

return $self->parse_choice("PersistentPasswd", "");
}


1;

