#!/usr/bin/perl
package proftpd::Postinstall;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'proftpd::Postinstall');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;

$self->{'no_acl_check'}++;
&ModuleLoader::preload_module(ref($self), "proftpd::ProftpdLib");
$self = new proftpd::ProftpdLib:: ref($self), %$self; 

1;
		return $self;
}

sub module_install {
	my $self = shift;

	# Check if it really is proftpd and the right version
	@{$self->{'st_array'}} = stat($self->{'config_hash'}->{'proftpd_path'});
	
	$self->{'site_hash'}->{'size'} = $self->{'st_array'}->[7];
	$self->{'out'} = `$self->{'config_hash'}->{'proftpd_path'} -v 2>&1`;
	return if ($self->{'out'} !~ /ProFTPD\s+Version\s+(\d+)\.([0-9\.]+)/i &&
	    $self->{'out'} !~ /ProFTPD\s+(\d+)\.([0-9\.]+)/i);
	local ($v1, $v2) = ($1, $2);
	$v2 =~ s/\.//g;
	$self->{'site_hash'}->{'version'} = "$v1.$v2";
	return if ($self->{'site_hash'}->{'version'} < 0.99);

	# Get the list of modules
	local @mods;
	open(MODS, "$self->{'config_hash'}->{'proftpd_path'} -l |");
	while(<MODS>) {
		s/\r|\n//g;
		if (/^\s*(\S+)\.c$/) {
			push(@mods, $1);
			}
		}
	close(MODS);
	$self->{'site_hash'}->{'modules'} = join(" ", @mods);
	$self->write_file("$self->{'module_config_directory'}/site", \%{$self->{'site_hash'}});

 	#configure file /etc/shells
 	if (-e '/etc/shells')
 	{
	 $file='/etc/shells';
	 %{$self->{'fconfig_hash'}}=$self->foreign_config('virtual_server');
	 
  	 #add new string into /etc/shells
	 $self->lock_file($file);
  	 @{$self->{'file_array'}}= $self->read_file_lines($file);
  	 foreach (@{$self->{'file_array'}->[0]})
	 {
	  $self->{'add'}=1 if ($_ eq $self->{'fconfig_hash'}->{'ftp_shell'});
	 }
	 push (@{$self->{'file_array'}->[0]},$self->{'fconfig_hash'}->{'ftp_shell'}) if ($self->{'add'}!=1);
	 $self->flush_file_lines();
	 $self->unlock_file($file);
   	 return 0;
	}
}


1;

