#!/usr/bin/perl

&MAIN();

 sub MAIN {
# create_virt.cgi
# Create a new virtual server

&ModuleLoader::preload_module('proftpd_class', "proftpd::ProftpdLib");
$self = new proftpd::ProftpdLib:: 'proftpd_class',%$self;

$self->ReadParse();
$self->{'conf'} = $self->get_config();
$self->error_setup($self->{'text_hash'}->{'vserv_err'});

# Validate inputs
$self->{'in_hash'}->{'addr_def'} || gethostbyname($self->{'in_hash'}->{'addr'}) ||
    $self->check_ipaddress($self->{'in_hash'}->{'addr'}) ||
	$self->error($self->{'text_hash'}->{'vserv_eaddr'});
$self->{'in_hash'}->{'Port_def'} || $self->{'in_hash'}->{'Port'} =~ /^\d+$/ ||
	$self->error($self->{'text_hash'}->{'vserv_eport'});
$self->{'in_hash'}->{'ServerName_def'} || $self->{'in_hash'}->{'ServerName'} =~ /\S/ ||
	$self->error($self->{'text_hash'}->{'vserv_ename'});

# Add the virtual host
$self->{'l'} = $self->{'conf'}->[@{$self->{'conf'}} - 1];
$self->lock_file($self->{'l'}->{'file'});
$self->before_changing();
$self->{'lref'} = $self->read_file_lines($self->{'l'}->{'file'});
@{$self->{'lines_array'}} = ( "<VirtualHost $self->{'in_hash'}->{'addr'}>" );
push(@{$self->{'lines_array'}}, "Port $self->{'in_hash'}->{'Port'}") if (!$self->{'in_hash'}->{'Port_def'});
push(@{$self->{'lines_array'}}, "ServerName \"$self->{'in_hash'}->{'ServerName'}\"") if (!$self->{'in_hash'}->{'ServerName_def'});
push(@{$self->{'lines_array'}}, "</VirtualHost>");
push(@{$self->{'lref'}}, @{$self->{'lines_array'}});
$self->flush_file_lines();
$self->after_changing();
$self->unlock_file($self->{'l'}->{'file'});
$self->webmin_log("virt", "create", $self->{'in_hash'}->{'addr'}, \%{$self->{'in_hash'}});

$self->redirect("virt_index.cgi?virt=".scalar(@{$self->{'conf'}}));

1;
		
}


1;

