#!/usr/bin/perl

&MAIN();

 sub MAIN {
# dir_index.cgi
# Display a menu of icons for per-directory options

&ModuleLoader::preload_module('proftpd_class', "proftpd::ProftpdLib");
$self = new proftpd::ProftpdLib:: 'proftpd_class',%$self;

$self->ReadParse();
if ($self->{'in_hash'}->{'global'}) {
	$self->{'conf'} = $self->get_config();
	$self->{'conf'} = $self->get_or_create_global($self->{'conf'});
	}
else {
	($self->{'conf'}, $self->{'v'}) = $self->get_virtual_config($self->{'in_hash'}->{'virt'});
	}
if ($self->{'in_hash'}->{'anon'}) {
	$self->{'anon'} = $self->find_directive_struct("Anonymous", $self->{'conf'});
	$self->{'conf'} = $self->{'anon'}->{'members'};
	}
$self->{'d'} = $self->{'conf'}->[$self->{'in_hash'}->{'idx'}];
$self->{'dn'} = $self->{'d'}->{'words'}->[0];
$self->{'dconf'} = $self->{'d'}->{'members'};
$self->{'desc'} = $self->{'in_hash'}->{'global'} ? $self->text('dir_header5', $self->{'dn'}) :
	$self->{'in_hash'}->{'anon'} ? $self->text('dir_header4', $self->{'dn'}) :
	$self->{'in_hash'}->{'virt'} ? $self->text('dir_header1', $self->{'dn'}, $self->{'v'}->{'words'}->[0]) :
	$self->text('dir_header2', $self->{'dn'});
$self->ui_print_header($self->{'desc'}, $self->{'text_hash'}->{'dir_title'}, "",
	undef, undef, undef, undef, $self->restart_button());

$self->{'dir_icon'} = { "icon" => "images/dir.gif",
	      "name" => $self->{'text_hash'}->{'dir_dir'},
	      "link" => "edit_dserv.cgi?virt=$self->{'in_hash'}->{'virt'}&idx=$self->{'in_hash'}->{'idx'}&anon=$self->{'in_hash'}->{'anon'}&global=$self->{'in_hash'}->{'global'}" };
$self->{'ed_icon'} = { "icon" => "images/edit.gif",
	     "name" => $self->{'text_hash'}->{'dir_edit'},
	     "link" => "manual_form.cgi?virt=$self->{'in_hash'}->{'virt'}&idx=$self->{'in_hash'}->{'idx'}&anon=$self->{'in_hash'}->{'anon'}&global=$self->{'in_hash'}->{'global'}" };
$self->config_icons("directory", "edit_dir.cgi?virt=$self->{'in_hash'}->{'virt'}&idx=$self->{'in_hash'}->{'idx'}&anon=$self->{'in_hash'}->{'anon'}&global=$self->{'in_hash'}->{'global'}&", $self->{'dir_icon'}, $self->{'ed_icon'});

# Display limit options
@{$self->{'lim_array'}} = $self->find_directive_struct("Limit", $self->{'dconf'});
if (@{$self->{'lim_array'}}) {
	print "<hr>\n";
	print "<h3>$self->{'text_hash'}->{'dir_header'}</h3>\n";
	foreach $l (@{$self->{'lim_array'}}) {
		push(@{$self->{'links_array'}}, "limit_index.cgi?limit=".$self->indexof($l, @{$self->{'dconf'}}).
                        "&virt=$self->{'in_hash'}->{'virt'}&anon=$self->{'in_hash'}->{'anon'}".
                        "&global=$self->{'in_hash'}->{'global'}&idx=$self->{'in_hash'}->{'idx'}");
		push(@{$self->{'titles_array'}}, $self->text('virt_limit', $l->{'value'}));
		push(@{$self->{'icons_array'}}, "images/limit.gif");
		}
	$self->icons_table(\@{$self->{'links_array'}}, \@{$self->{'titles_array'}}, \@{$self->{'icons_array'}}, 3);
	}

print "<form action=create_limit.cgi>\n";
print "<input type=hidden name=virt value='$self->{'in_hash'}->{'virt'}'>\n";
print "<input type=hidden name=idx value='$self->{'in_hash'}->{'idx'}'>\n";
print "<input type=hidden name=anon value='$self->{'in_hash'}->{'anon'}'>\n";
print "<input type=hidden name=global value='$self->{'in_hash'}->{'global'}'>\n";
print "<table border>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'virt_addlimit'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table>\n";
print "<tr> <td><b>$self->{'text_hash'}->{'virt_cmds'}</b></td>\n";
print "<td><input name=cmd size=20>\n";
print "<input type=submit value=\"$self->{'text_hash'}->{'create'}\"></td> </tr>\n";
print "</table></td></tr></table></form>\n";

if ($self->{'in_hash'}->{'global'}) {
	$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
	}
elsif ($self->{'in_hash'}->{'anon'}) {
	$self->ui_print_footer("anon_index.cgi?virt=$self->{'in_hash'}->{'virt'}", $self->{'text_hash'}->{'anon_return'},
		"virt_index.cgi?virt=$self->{'in_hash'}->{'virt'}", $self->{'text_hash'}->{'virt_return'},
		"", $self->{'text_hash'}->{'index_return'});
	}
else {
	$self->ui_print_footer("virt_index.cgi?virt=$self->{'in_hash'}->{'virt'}", $self->{'text_hash'}->{'virt_return'},
		"", $self->{'text_hash'}->{'index_return'});
	}

1;
		
}


1;

