#!/usr/bin/perl

&MAIN();

 sub MAIN {
# find_ftpaccess.cgi
# Finds all per-directory options files under the all the document roots

&ModuleLoader::preload_module('proftpd_class', "proftpd::ProftpdLib");
$self = new proftpd::ProftpdLib:: 'proftpd_class',%$self;

$self->ReadParse();
@{$self->{'rv_array'}} = grep { -r $_ } @{$self->{'ftpaccess_files_array'}};
$self->error_setup($self->{'text_hash'}->{'find_err'});

if ($self->{'in_hash'}->{'from'}) {
	# Look under the given directory
	@{$self->{'dirs_array'}} = ( $self->{'in_hash'}->{'dir'} );
	}
else {
	# Look in Anonymous sections
	$self->{'conf'} = $self->get_config();
	$self->{'anon'} = $self->find_directive("Anonymous", $self->{'conf'});
	push(@{$self->{'dirs_array'}}, $self->{'anon'}) if ($self->{'anon'});
	foreach $v ($self->find_directive_struct("VirtualHost", $self->{'conf'})) {
		$self->{'anon'} = $self->find_directive("Anonymous", $v->{'members'});
		push(@{$self->{'dirs_array'}}, $self->{'anon'}) if ($self->{'anon'});
		}
	$self->error($self->{'text_hash'}->{'find_eanon'}) if (!@{$self->{'dirs_array'}});
	}

foreach $d (@{$self->{'dirs_array'}}) {
	if ($d =~ /^~(\S+)$/) {
		local @u = getpwnam($1);
		$d = $u[7];
		next if (!$u[7]);
		}
	open(FIND, "find '$d' -name .ftpaccess -print |");
	while(<FIND>) {
		s/\r|\n//g;
		push(@{$self->{'rv_array'}}, $_);
		}
	close(FIND);
	}

# save results
$self->{'site_hash'}->{'ftpaccess'} = join(' ', $self->unique(@{$self->{'rv_array'}}));
$self->write_file("$self->{'module_config_directory'}/site", \%{$self->{'site_hash'}});
$self->redirect("ftpaccess.cgi");

1;
		
}


1;

