#!/usr/bin/perl

&MAIN();

 sub MAIN {
# index.cgi
# Display the icons for various types of proftpd config options

&ModuleLoader::preload_module('proftpd_class', "proftpd::ProftpdLib");
$self = new proftpd::ProftpdLib:: 'proftpd_class',%$self;


# Check if proftpd is installed
@{$self->{'st_array'}} = stat($self->{'config_hash'}->{'proftpd_path'});
if (!@{$self->{'st_array'}}) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", undef, 1, 1, 0,
		$self->help_search_link("proftpd", "man", "doc", "google"));
	print $self->text('index_eproftpd', "<tt>$self->{'config_hash'}->{'proftpd_path'}</tt>",
		  "$self->{'gconfig_hash'}->{'webprefix'}/config.cgi?$self->{'module_name'}"),"<p>\n";

	$self->foreign_require("software", "software-lib.pl");
	$self->{'lnk'} = $main::software_object->missing_install_link("proftpd",$self->{'text_hash'}->{'index_proftpd'},
			"../$self->{'module_name'}/", $self->{'text_hash'}->{'index_title'});
	print $self->{'lnk'},"<p>\n" if ($self->{'lnk'});

	$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});
	exit;
	}

# Check if the config file exists
$self->{'conf'} = $self->get_config();
if (!@{$self->{'conf'}}) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", undef, 1, 1, 0,
		$self->help_search_link("proftpd", "man", "doc", "google"));
	print $self->text('index_econf', "<tt>$self->{'config_hash'}->{'proftpd_conf'}</tt>",
		  "$self->{'gconfig_hash'}->{'webprefix'}/config.cgi?$self->{'module_name'}"),"<p>\n";
	$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});
	exit;
	}

# Check if the executable has changed ..
if ($self->{'site_hash'}->{'size'} != $self->{'st_array'}->[7]) {
	# Check if it really is proftpd and the right version
	$self->{'site_hash'}->{'size'} = $self->{'st_array'}->[7];
	$self->{'ver'} = $self->get_proftpd_version(\$self->{'out'});
	if (!$self->{'ver'}) {
		$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", undef, 1, 1, 0,
			$self->help_search_link("proftpd", "man", "doc", "google"));
		print $self->text('index_eproftpd2',
			  "<tt>$self->{'config_hash'}->{'proftpd_path'}</tt>",
			  "$self->{'gconfig_hash'}->{'webprefix'}/config.cgi?$self->{'module_name'}",
			  "<tt>$self->{'config_hash'}->{'proftpd_path'} -v</tt>",
			  "<pre>$self->{'out'}</pre>"),"<p>\n";
		$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});
		exit;
		}
	$self->{'site_hash'}->{'version'} = $self->{'ver'};
	if ($self->{'site_hash'}->{'version'} < 0.99) {
		$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", undef, 1, 1, 0,
			$self->help_search_link("proftpd", "man", "doc", "google"));
		print $self->text('index_eversion',
			  "<tt>$self->{'config_hash'}->{'proftpd_path'}</tt>",
			  "$self->{'gconfig_hash'}->{'webprefix'}/config.cgi?$self->{'module_name'}"),"<p>\n";
		$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});
		exit;
		}

	# Get the list of modules
	local @mods;
	open(MODS, "$self->{'config_hash'}->{'proftpd_path'} -l |");
	while(<MODS>) {
		s/\r|\n//g;
		if (/^\s*(\S+)\.c$/) {
			push(@mods, $1);
			}
		}
	close(MODS);
	$self->{'site_hash'}->{'modules'} = join(" ", @mods);
	$self->write_file("$self->{'module_config_directory'}/site", \%{$self->{'site_hash'}});
	}

$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", undef, 1, 1, undef, $self->restart_button()."<br>".
	$self->help_search_link("apache", "man", "doc", "google"), undef, undef,
	$self->text('index_version', $self->{'site_hash'}->{'version'}));

$self->{'conf'} = $self->get_config();

# Display global category icons
print $self->ui_subheading($self->{'text_hash'}->{'index_global'});
$self->{'ft_icon'} = { "icon" => "images/dir.gif",
	     "name" => $self->{'text_hash'}->{'ftpaccess_title'},
	     "link" => "ftpaccess.cgi" };
$self->{'us_icon'} = { "icon" => "images/ftpusers.gif",
	     "name" => $self->{'text_hash'}->{'ftpusers_title'},
	     "link" => "edit_ftpusers.cgi" };
$self->{'ed_icon'} = { "icon" => "images/edit.gif",
	     "name" => $self->{'text_hash'}->{'manual_configs'},
	     "link" => "allmanual_form.cgi" };
$self->config_icons("root global", "edit_global.cgi?", $self->{'ft_icon'}, $self->{'us_icon'}, $self->{'ed_icon'});

# Display global per-directory/limit options
$self->{'global'} = $self->find_directive_struct("Global", $self->{'conf'});
$self->{'gconf'} = $self->{'global'}->{'members'} if ($self->{'global'});
@{$self->{'dir_array'}} = ( $self->find_directive_struct("Directory", $self->{'gconf'}) ,
	 $self->find_directive_struct("Limit", $self->{'gconf'}) );
if (@{$self->{'dir_array'}}) {
	print "<hr>\n";
	print $self->ui_subheading($self->{'text_hash'}->{'virt_header'});
	foreach $d (@{$self->{'dir_array'}}) {
		if ($d->{'name'} eq 'Limit') {
			push(@{$self->{'links_array'}}, "limit_index.cgi?limit=".
				     $self->indexof($d, @{$self->{'gconf'}})."&global=1");
			push(@{$self->{'titles_array'}}, $self->text('virt_limit', $d->{'value'}));
			push(@{$self->{'icons_array'}}, "images/limit.gif");
			}
		else {
			push(@{$self->{'links_array'}}, "dir_index.cgi?idx=".
				     $self->indexof($d, @{$self->{'gconf'}})."&global=1");
			push(@{$self->{'titles_array'}}, $self->text('virt_dir', $d->{'value'}));
			push(@{$self->{'icons_array'}}, "images/dir.gif");
			}
		}
	$self->icons_table(\@{$self->{'links_array'}}, \@{$self->{'titles_array'}}, \@{$self->{'icons_array'}}, 3);
	}

print "<table width=100%><tr><td>\n";

print "<form action=create_dir.cgi>\n";
print "<input type=hidden name=global value=1>\n";
print "<table border>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'virt_adddir'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table>\n";
print "<tr> <td><b>$self->{'text_hash'}->{'virt_path'}</b></td>\n";
print "<td><input name=dir size=30>\n";
print "<input type=submit value=\"$self->{'text_hash'}->{'create'}\"></td> </tr>\n";
print "</table></td></tr></table></form>\n";

print "</td><td>\n";

print "<form action=create_limit.cgi>\n";
print "<input type=hidden name=global value=1>\n";
print "<table border>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'virt_addlimit'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table>\n";
print "<tr> <td><b>$self->{'text_hash'}->{'virt_cmds'}</b></td>\n";
print "<td><input name=cmd size=20>\n";
print "<input type=submit value=\"$self->{'text_hash'}->{'create'}\"></td> </tr>\n";
print "</table></td></tr></table></form>\n";

print "</td></tr></table>\n";

# Start virtual server list with default
push(@{$self->{'vname_array'}}, $self->{'text_hash'}->{'index_defserv'});
push(@{$self->{'vlink_array'}}, "virt_index.cgi");
push(@{$self->{'vdesc_array'}}, $self->{'text_hash'}->{'index_defdesc'});
push(@{$self->{'vaddr_array'}}, $self->{'text_hash'}->{'index_any'});
push(@{$self->{'vserv_array'}}, $self->def($self->find_directive("ServerName", $self->{'conf'}), $self->{'text_hash'}->{'default'}));

# Add other virtual servers
@{$self->{'virt_array'}} = $self->find_directive_struct("VirtualHost", $self->{'conf'});
foreach $v (@{$self->{'virt_array'}}) {
	$self->{'vm'} = $v->{'members'};
	push(@{$self->{'vname_array'}}, $self->{'text_hash'}->{'index_virt'});
	push(@{$self->{'vlink_array'}}, "virt_index.cgi?virt=".$self->indexof($v, @{$self->{'conf'}}));
	push(@{$self->{'vaddr_array'}}, $v->{'value'});
	$self->{'sname'} = $self->find_directive("ServerName", $self->{'vm'});
	local $ip = $self->to_ipaddress($v->{'value'});
	push(@{$self->{'vdesc_array'}}, $self->text('index_vdesc', $ip ? $ip : $self->{'text_hash'}->{'index_eip'}));
	push(@{$self->{'vserv_array'}}, $self->def($self->find_vdirective("ServerName", $self->{'vm'}, $self->{'conf'}),
			  $self->{'text_hash'}->{'index_auto'}));
	}

# Show virtual servers
print "<hr>\n";
print $self->ui_subheading($self->{'text_hash'}->{'index_virts'});

if ($self->{'config_hash'}->{'show_list'} && scalar(@{$self->{'vname_array'}})) {
	# as list for people with lots of servers
	print "<table width=100% border=1>\n";
	print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'index_type'}</b></td> ",
	      "<td><b>$self->{'text_hash'}->{'index_addr'}</b></td> ",
	      "<td><b>$self->{'text_hash'}->{'index_name'}</b></td> </tr>\n";
	for($i=0; $i<@{$self->{'vname_array'}}; $i++) {
		print "<tr $self->{'cb'}>\n";
		print "<td><a href=\"$self->{'vlink_array'}->[$i]\">",
		      $self->html_escape($self->{'vname_array'}->[$i]),"</a></td>\n";
		print "<td>",$self->html_escape($self->{'vaddr_array'}->[$i]),"</td>\n";
		print "<td>",$self->html_escape($self->{'vserv_array'}->[$i]),"</td>\n";
		print "</tr>\n";
		}
	print "</table>\n";
	}
else {
	# as icons for niceness
	print "<table width=100% cellpadding=5>\n";
	for($i=0; $i<@{$self->{'vname_array'}}; $i++) {
		print "<tr> <td valign=top align=center nowrap>";
		$self->generate_icon("images/virt.gif", $self->html_escape($self->{'vname_array'}->[$i]),
			       $self->{'vlink_array'}->[$i]);
		print "</td> <td valign=top>\n";
		print $self->html_escape($self->{'vdesc_array'}->[$i]),"<br>\n";
		print "<table width=100%><tr>\n";
		print "<td width=30%><b>$self->{'text_hash'}->{'index_addr'}</b> ",
		      $self->html_escape($self->{'vaddr_array'}->[$i]),"</td>\n";
		print "<td width=70%><b>$self->{'text_hash'}->{'index_name'}</b> ",
		      $self->html_escape($self->{'vserv_array'}->[$i]),"</td></tr>\n";
		print "</table></td> </tr>\n";
		}
	print "</table>\n";
	}

print "<form action=create_virt.cgi>\n";
print "<table border>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'index_create'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table>\n";
print "<tr> <td><b>$self->{'text_hash'}->{'index_addr'}</b></td>\n";
print "<td><input name=addr size=25></td> </tr>\n";
print "<tr> <td><b>$self->{'text_hash'}->{'index_port'}</b></td>\n";
print "<td>",$self->opt_input(undef, "Port", $self->{'text_hash'}->{'default'}, 6),"</td> </tr>\n";
print "<tr> <td><b>$self->{'text_hash'}->{'index_name'}</b></td>\n";
print "<td>",$self->opt_input(undef, "ServerName", $self->{'text_hash'}->{'default'}, 25);
print "&nbsp;&nbsp;\n";
print "<input type=submit value=\"$self->{'text_hash'}->{'create'}\"></td> </tr>\n";
print "</table></td></tr></table>\n";
print "</form>\n";

# Find out how ProFTPd is running
($self->{'inet'}, $self->{'inet_mod'}) = $self->running_under_inetd();
if (!$self->{'inet'}) {
	# Get the FTP server pid
	$self->{'pid'} = $self->get_proftpd_pid();
	}

if (!$self->{'inet'}) {
	print "<hr>\n";
	print $self->ui_buttons_start();
	}
if (!$self->{'inet'} && $self->{'pid'}) {
	print $self->ui_buttons_row("apply.cgi",
			      $self->{'text_hash'}->{'index_apply'}, $self->{'text_hash'}->{'index_applymsg'});
	print $self->ui_buttons_row("stop.cgi",
			      $self->{'text_hash'}->{'index_stop'}, $self->{'text_hash'}->{'index_stopmsg'});
	}
elsif (!$self->{'inet'} && !$self->{'pid'}) {
	print $self->ui_buttons_row("start.cgi",
		      $self->{'text_hash'}->{'index_start'},
		      $self->{'inet_mod'} ? $self->text('index_startmsg', "/$self->{'inet_mod'}/")
				: $self->{'text_hash'}->{'index_startmsg2'});
	}
if (!$self->{'inet'}) {
	print $self->ui_buttons_end();
	}

$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});

1;
		
}


1;

