#!/usr/bin/perl

&MAIN();

 sub MAIN {
# limit_index.cgi
# Display a menu of icons for per-command options

&ModuleLoader::preload_module('proftpd_class', "proftpd::ProftpdLib");
$self = new proftpd::ProftpdLib:: 'proftpd_class',%$self;

$self->ReadParse();
if ($self->{'in_hash'}->{'file'}) {
	$self->{'conf'} = $self->get_ftpaccess_config($self->{'in_hash'}->{'file'});
	}
else {
	if ($self->{'in_hash'}->{'global'}) {
		$self->{'conf'} = $self->get_config();
		$self->{'conf'} = $self->get_or_create_global($self->{'conf'});
		}
	else {
		($self->{'conf'}, $self->{'v'}) = $self->get_virtual_config($self->{'in_hash'}->{'virt'});
		}
	if ($self->{'in_hash'}->{'anon'}) {
		$self->{'anon'} = $self->find_directive_struct("Anonymous", $self->{'conf'});
		$self->{'conf'} = $self->{'anon'}->{'members'};
		}
	if ($self->{'in_hash'}->{'idx'} ne '') {
		$self->{'dir'} = $self->{'conf'}->[$self->{'in_hash'}->{'idx'}];
		$self->{'conf'} = $self->{'dir'}->{'members'};
		}
	}
$self->{'l'} = $self->{'conf'}->[$self->{'in_hash'}->{'limit'}];
$self->{'ln'} = $self->{'l'}->{'value'};
$self->{'desc'} = $self->{'in_hash'}->{'file'} ? $self->text('limit_header6', $self->{'ln'}, $self->html_escape($self->{'in_hash'}->{'file'})) :
	$self->{'dir'} ? $self->text('limit_header4', $self->{'ln'}, $self->{'dir'}->{'words'}->[0]) :
	$self->{'in_hash'}->{'global'} ? $self->text('limit_header7', $self->{'ln'}) :
	$self->{'in_hash'}->{'anon'} ? $self->text('limit_header5', $self->{'ln'}) :
	$self->{'in_hash'}->{'virt'} ?  $self->text('limit_header1', $self->{'ln'}, $self->{'v'}->{'words'}->[0]) :
	$self->text('limit_header2', $self->{'ln'});
$self->ui_print_header($self->{'desc'}, $self->{'text_hash'}->{'limit_title'}, "",
	undef, undef, undef, undef, $self->restart_button());

$self->{'limit_icon'} = { "icon" => "images/limit.gif",
	        "name" => $self->{'text_hash'}->{'limit_limit'},
	        "link" => "edit_lserv.cgi?virt=$self->{'in_hash'}->{'virt'}&idx=$self->{'in_hash'}->{'idx'}&limit=$self->{'in_hash'}->{'limit'}&anon=$self->{'in_hash'}->{'anon'}&global=$self->{'in_hash'}->{'global'}&file=$self->{'in_hash'}->{'file'}" };
$self->{'ed_icon'} = { "icon" => "images/edit.gif",
	     "name" => $self->{'text_hash'}->{'limit_edit'},
	     "link" => $self->{'in_hash'}->{'file'} ? "manual_form.cgi?limit=$self->{'in_hash'}->{'limit'}&file=$self->{'in_hash'}->{'file'}" : "manual_form.cgi?virt=$self->{'in_hash'}->{'virt'}&idx=$self->{'in_hash'}->{'idx'}&limit=$self->{'in_hash'}->{'limit'}&anon=$self->{'in_hash'}->{'anon'}&global=$self->{'in_hash'}->{'global'}" };
$self->config_icons("limit", "edit_limit.cgi?virt=$self->{'in_hash'}->{'virt'}&idx=$self->{'in_hash'}->{'idx'}&limit=$self->{'in_hash'}->{'limit'}&anon=$self->{'in_hash'}->{'anon'}&file=$self->{'in_hash'}->{'file'}&global=$self->{'in_hash'}->{'global'}&", $self->{'limit_icon'}, $self->{'ed_icon'});

if ($self->{'in_hash'}->{'file'}) {
	$self->ui_print_footer("ftpaccess_index.cgi?file=$self->{'in_hash'}->{'file'}",$self->{'text_hash'}->{'ftpindex_return'},
		"ftpaccess.cgi", $self->{'text_hash'}->{'ftpaccess_return'},
		"", $self->{'text_hash'}->{'index_return'});
	}
elsif ($self->{'in_hash'}->{'idx'} eq '') {
	if ($self->{'in_hash'}->{'global'}) {
		$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
		}
	elsif ($self->{'in_hash'}->{'anon'}) {
		$self->ui_print_footer("anon_index.cgi?virt=$self->{'in_hash'}->{'virt'}",$self->{'text_hash'}->{'anon_return'},
			"virt_index.cgi?virt=$self->{'in_hash'}->{'virt'}",$self->{'text_hash'}->{'virt_return'},
			"", $self->{'text_hash'}->{'index_return'});
		}
	else {
		$self->ui_print_footer("virt_index.cgi?virt=$self->{'in_hash'}->{'virt'}",$self->{'text_hash'}->{'virt_return'},
			"", $self->{'text_hash'}->{'index_return'});
		}
	}
else {
	if ($self->{'in_hash'}->{'global'}) {

		$self->ui_print_footer("dir_index.cgi?virt=$self->{'in_hash'}->{'virt'}&idx=$self->{'in_hash'}->{'idx'}&global=$self->{'in_hash'}->{'global'}", $self->{'text_hash'}->{'dir_return'},
			"", $self->{'text_hash'}->{'index_return'});
		}
	elsif ($self->{'in_hash'}->{'anon'}) {
		$self->ui_print_footer("dir_index.cgi?virt=$self->{'in_hash'}->{'virt'}&idx=$self->{'in_hash'}->{'idx'}&anon=$self->{'in_hash'}->{'anon'}", $self->{'text_hash'}->{'dir_return'},
			"anon_index.cgi?virt=$self->{'in_hash'}->{'virt'}",$self->{'text_hash'}->{'anon_return'},
			"virt_index.cgi?virt=$self->{'in_hash'}->{'virt'}",$self->{'text_hash'}->{'virt_return'},
			"", $self->{'text_hash'}->{'index_return'});
		}
	else {
		$self->ui_print_footer("dir_index.cgi?virt=$self->{'in_hash'}->{'virt'}&idx=$self->{'in_hash'}->{'idx'}&anon=$self->{'in_hash'}->{'anon'}", $self->{'text_hash'}->{'dir_return'},
			"virt_index.cgi?virt=$self->{'in_hash'}->{'virt'}",$self->{'text_hash'}->{'virt_return'},
			"", $self->{'text_hash'}->{'index_return'});
		}
	}

1;
		
}


1;

