#!/usr/bin/perl

&MAIN();

 sub MAIN {
# manual.cgi
# Display a text box for manually editing directives

&ModuleLoader::preload_module('proftpd_class', "proftpd::ProftpdLib");
$self = new proftpd::ProftpdLib:: 'proftpd_class',%$self;

$self->ReadParse();
if ($self->{'in_hash'}->{'global'}) {
	$self->{'conf'} = $self->get_config();
	$self->{'global'} = $self->find_directive_struct("Global", $self->{'conf'});
	$self->{'conf'} = $self->{'global'}->{'members'};
	if (defined($self->{'in_hash'}->{'limit'})) {
		# limit within the global section
		if ($self->{'in_hash'}->{'idx'}) {
			$self->{'d'} = $self->{'conf'}->[$self->{'in_hash'}->{'idx'}];
			$self->{'l'} = $self->{'d'}->{'members'}->[$self->{'in_hash'}->{'limit'}];
			$self->{'title'} = $self->text('limit_header4', $self->{'l'}->{'value'},
				       $self->{'d'}->{'words'}->[0]);
			}
		else {
			$self->{'l'} = $self->{'conf'}->[$self->{'in_hash'}->{'limit'}];
			$self->{'title'} = $self->text('limit_header7', $self->{'l'}->{'value'});
			}
		$self->{'return'} = "limit_index.cgi"; $self->{'rmsg'} = $self->{'text_hash'}->{'limit_return'};
		$self->{'file'} = $self->{'l'}->{'file'};
		$self->{'start'} = $self->{'l'}->{'line'}+1; $self->{'end'} = $self->{'l'}->{'eline'}-1;
		}
	else {
		# directory in the global section
		$self->{'d'} = $self->{'conf'}->[$self->{'in_hash'}->{'idx'}];
		$self->{'title'} = $self->text('dir_header5', $self->{'d'}->{'words'}->[0]);
		$self->{'return'} = "dir_index.cgi"; $self->{'rmsg'} = $self->{'text_hash'}->{'dir_return'};
		$self->{'file'} = $self->{'d'}->{'file'};
		$self->{'start'} = $self->{'d'}->{'line'}+1; $self->{'end'} = $self->{'d'}->{'eline'}-1;
		}
	}
elsif (defined($self->{'in_hash'}->{'virt'})) {
	if (defined($self->{'in_hash'}->{'limit'})) {
		# limit, maybe within a directory
		($self->{'conf'}, $self->{'v'}) = $self->get_virtual_config($self->{'in_hash'}->{'virt'});
		if ($self->{'in_hash'}->{'anon'}) {
			$self->{'anon'} = $self->find_directive_struct("Anonymous", $self->{'conf'});
			$self->{'conf'} = $self->{'anon'}->{'members'};
			}
		if ($self->{'in_hash'}->{'idx'} ne '') {
			$self->{'dir'} = $self->{'conf'}->[$self->{'in_hash'}->{'idx'}];
			$self->{'conf'} = $self->{'dir'}->{'members'};
			}
		$self->{'l'} = $self->{'conf'}->[$self->{'in_hash'}->{'limit'}];
		$self->{'ln'} = $self->{'l'}->{'value'};
		$self->{'title'} = $self->{'dir'} ?
			$self->text('limit_header4', $self->{'ln'}, $self->{'dir'}->{'words'}->[0]) :
			$self->{'in_hash'}->{'virt'} ?
			$self->text('limit_header1', $self->{'ln'}, $self->{'v'}->{'words'}->[0]) :
			$self->text('limit_header2', $self->{'ln'});
		$self->{'return'} = "limit_index.cgi"; $self->{'rmsg'} = $self->{'text_hash'}->{'limit_return'};
		$self->{'file'} = $self->{'l'}->{'file'};
		$self->{'start'} = $self->{'l'}->{'line'}+1; $self->{'end'} = $self->{'l'}->{'eline'}-1;
		}
	elsif (defined($self->{'in_hash'}->{'idx'})) {
		# directory within virtual server
		($self->{'vconf'}, $self->{'v'}) = $self->get_virtual_config($self->{'in_hash'}->{'virt'});
		if ($self->{'in_hash'}->{'anon'}) {
			$self->{'anon'} = $self->find_directive_struct("Anonymous", $self->{'vconf'});
			$self->{'vconf'} = $self->{'anon'}->{'members'};
			}
		$self->{'d'} = $self->{'vconf'}->[$self->{'in_hash'}->{'idx'}];
		$self->{'dn'} = $self->{'d'}->{'words'}->[0];
		$self->{'title'} = $self->{'in_hash'}->{'anon'} ? $self->text('dir_header4', $self->{'dn'}) : $self->{'in_hash'}->{'virt'} ?
			$self->text('dir_header1', $self->{'dn'}, $self->{'v'}->{'words'}->[0]) :
			$self->text('dir_header2', $self->{'dn'});
		$self->{'return'} = "dir_index.cgi"; $self->{'rmsg'} = $self->{'text_hash'}->{'dir_return'};
		$self->{'file'} = $self->{'d'}->{'file'};
		$self->{'start'} = $self->{'d'}->{'line'}+1; $self->{'end'} = $self->{'d'}->{'eline'}-1;
		}
	else {
		# virtual server
		($self->{'conf'}, $self->{'v'}) = $self->get_virtual_config($self->{'in_hash'}->{'virt'});
		$self->{'title'} = $self->{'in_hash'}->{'virt'} eq '' ? $self->{'text_hash'}->{'virt_header2'} :
		         $self->text('virt_header1', $self->{'v'}->{'value'});
		$self->{'return'} = "virt_index.cgi"; $self->{'rmsg'} = $self->{'text_hash'}->{'virt_return'};
		$self->{'file'} = $self->{'v'}->{'file'};
		$self->{'start'} = $self->{'v'}->{'line'}+1; $self->{'end'} = $self->{'v'}->{'eline'}-1;
		}
	}
else {
	# Something in a .ftpaccess file
	if (defined($self->{'in_hash'}->{'limit'})) {
		# limit within .ftpaccess file
		$self->{'hconf'} = $self->get_ftpaccess_config($self->{'in_hash'}->{'file'});
		$self->{'l'} = $self->{'hconf'}->[$self->{'in_hash'}->{'limit'}];
		$self->{'file'} = $self->{'in_hash'}->{'file'};
		$self->{'start'} = $self->{'l'}->{'line'}+1; $self->{'end'} = $self->{'l'}->{'eline'}-1;
		$self->{'title'} = $self->text('limit_header6', $self->{'l'}->{'value'},
			       "<tt>$self->{'in_hash'}->{'file'}</tt>");
		$self->{'return'} = "limit_index.cgi";
		$self->{'rmsg'} = $self->{'text_hash'}->{'limit_return'};
		}
	else {
		# .ftpaccess file
		$self->{'file'} = $self->{'in_hash'}->{'file'};
		$self->{'title'} = $self->text('ftpindex_header', "<tt>$self->{'in_hash'}->{'file'}</tt>");
		$self->{'return'} = "ftpaccess_index.cgi";
		$self->{'rmsg'} = $self->{'text_hash'}->{'ftpindex_return'};
		}
	}
$self->ui_print_header($self->{'title'}, $self->{'text_hash'}->{'manual_title'}, "",
	undef, undef, undef, undef, $self->restart_button());

print $self->text('manual_header', "<tt>$self->{'file'}</tt>"),"<p>\n";
print "<form action=manual_save.cgi method=post enctype=multipart/form-data>\n";
foreach $h ('virt', 'idx', 'file', 'limit', 'anon', 'global') {
	if (defined($self->{'in_hash'}->{$h})) {
		print "<input type=hidden name=$h value='$self->{'in_hash'}->{$h}'>\n";
		push(@{$self->{'args_array'}}, "$h=$self->{'in_hash'}->{$h}");
		}
	}
$self->{'args'} = join('&', @{$self->{'args_array'}});

print "<textarea rows=15 cols=80 name=directives>\n";
$self->{'lref'} = $self->read_file_lines($self->{'file'});
if (!defined($self->{'start'})) {
	$self->{'start'} = 0;
	$self->{'end'} = @{$self->{'lref'}} - 1;
	}
for($i=$self->{'start'}; $i<=$self->{'end'}; $i++) {
	print $self->html_escape($self->{'lref'}->[$i]),"\n";
	}
print "</textarea><br><input type=submit value=\"$self->{'text_hash'}->{'save'}\"></form>\n";

$self->ui_print_footer("$self->{'return'}?$self->{'args'}", $self->{'rmsg'});

1;
		
}


1;

