#!/usr/bin/perl

&MAIN();

 sub MAIN {
# manual_save.cgi
# Save manually entered directives

&ModuleLoader::preload_module('proftpd_class', "proftpd::ProftpdLib");
$self = new proftpd::ProftpdLib:: 'proftpd_class',%$self;

$self->ReadParseMime();
if ($self->{'in_hash'}->{'global'}) {
	$self->{'conf'} = $self->get_config();
	$self->{'global'} = $self->find_directive_struct("Global", $self->{'conf'});
	$self->{'conf'} = $self->{'global'}->{'members'};
	if (defined($self->{'in_hash'}->{'limit'})) {
		# limit within the global section
		if ($self->{'in_hash'}->{'idx'}) {
			$self->{'d'} = $self->{'conf'}->[$self->{'in_hash'}->{'idx'}];
			$self->{'l'} = $self->{'d'}->{'members'}->[$self->{'in_hash'}->{'limit'}];
			}
		else {
			$self->{'l'} = $self->{'conf'}->[$self->{'in_hash'}->{'limit'}];
			}
		$self->{'file'} = $self->{'l'}->{'file'};
		$self->{'return'} = "limit_index.cgi";
		$self->{'start'} = $self->{'l'}->{'line'}+1; $self->{'end'} = $self->{'l'}->{'eline'}-1;
		}
	else {
		# directory in the global section
		$self->{'d'} = $self->{'conf'}->[$self->{'in_hash'}->{'idx'}];
		$self->{'file'} = $self->{'d'}->{'file'};
		$self->{'return'} = "dir_index.cgi";
		$self->{'start'} = $self->{'d'}->{'line'}+1; $self->{'end'} = $self->{'d'}->{'eline'}-1;
		$self->{'logtype'} = 'dir';
		$self->{'logname'} = $self->{'d'}->{'value'};
		}
	}
elsif (defined($self->{'in_hash'}->{'virt'})) {
	if (defined($self->{'in_hash'}->{'limit'})) {
		# limit, maybe within a directory
		($self->{'conf'}, $self->{'v'}) = $self->get_virtual_config($self->{'in_hash'}->{'virt'});
		if ($self->{'in_hash'}->{'anon'}) {
			$self->{'anon'} = $self->find_directive_struct("Anonymous", $self->{'conf'});
			$self->{'conf'} = $self->{'anon'}->{'members'};
			}
		if ($self->{'in_hash'}->{'idx'} ne '') {
			$self->{'conf'} = $self->{'conf'}->[$self->{'in_hash'}->{'idx'}]->{'members'};
			}
		$self->{'l'} = $self->{'conf'}->[$self->{'in_hash'}->{'limit'}];
		$self->{'file'} = $self->{'l'}->{'file'};
		$self->{'return'} = "limit_index.cgi";
		$self->{'start'} = $self->{'l'}->{'line'}+1; $self->{'end'} = $self->{'l'}->{'eline'}-1;
		$self->{'logtype'} = 'limit';
		$self->{'logname'} = $self->{'l'}->{'value'};
		}
	elsif (defined($self->{'in_hash'}->{'idx'})) {
		# directory within virtual server
		($self->{'vconf'}, $self->{'v'}) = $self->get_virtual_config($self->{'in_hash'}->{'virt'});
		if ($self->{'in_hash'}->{'anon'}) {
			$self->{'anon'} = $self->find_directive_struct("Anonymous", $self->{'vconf'});
			$self->{'vconf'} = $self->{'anon'}->{'members'};
			}
		$self->{'d'} = $self->{'vconf'}->[$self->{'in_hash'}->{'idx'}];
		$self->{'file'} = $self->{'d'}->{'file'};
		$self->{'return'} = "dir_index.cgi";
		$self->{'start'} = $self->{'d'}->{'line'}+1; $self->{'end'} = $self->{'d'}->{'eline'}-1;
		$self->{'logtype'} = 'dir';
		$self->{'logname'} = "$self->{'v'}->{'value'}:$self->{'d'}->{'words'}->[0]";
		}
	else {
		# virtual server
		($self->{'conf'}, $self->{'v'}) = $self->get_virtual_config($self->{'in_hash'}->{'virt'});
		$self->{'return'} = "virt_index.cgi";
		$self->{'file'} = $self->{'v'}->{'file'};
		$self->{'start'} = $self->{'v'}->{'line'}+1; $self->{'end'} = $self->{'v'}->{'eline'}-1;
		$self->{'logtype'} = 'virt'; $self->{'logname'} = $self->{'v'}->{'words'}->[0];
		}
	}
else {
	if (defined($self->{'in_hash'}->{'limit'})) {
		# files within .htaccess file
		$self->{'hconf'} = $self->get_ftpaccess_config($self->{'in_hash'}->{'file'});
		$self->{'l'} = $self->{'hconf'}->[$self->{'in_hash'}->{'limit'}];
		$self->{'file'} = $self->{'in_hash'}->{'file'};
		$self->{'return'} = "limit_index.cgi";
		$self->{'start'} = $self->{'l'}->{'line'}+1; $self->{'end'} = $self->{'l'}->{'eline'}-1;
		$self->{'logtype'} = 'limit';
		$self->{'logname'} = $self->{'l'}->{'value'};
		}
	else {
		# .htaccess file
		$self->{'file'} = $self->{'in_hash'}->{'file'};
		$self->{'return'} = "ftpaccess_index.cgi";
		$self->{'logtype'} = 'ftpaccess'; $self->{'logname'} = $self->{'in_hash'}->{'file'};
		}
	}

$self->lock_file($self->{'file'});
$self->lock_file($self->{'file'});
$self->{'temp'} = $self->transname();
system("cp ".quotemeta($self->{'file'})." $self->{'temp'}");
$self->{'in_hash'}->{'directives'} =~ s/\r//g;
$self->{'in_hash'}->{'directives'} =~ s/\s+$//;
@{$self->{'dirs_array'}} = split(/\n/, $self->{'in_hash'}->{'directives'});
$self->{'lref'} = $self->read_file_lines($self->{'file'});
if (!defined($self->{'start'})) {
	$self->{'start'} = 0;
	$self->{'end'} = @{$self->{'lref'}} - 1;
	}
splice(@{$self->{'lref'}}, $self->{'start'}, $self->{'end'}-$self->{'start'}+1, @{$self->{'dirs_array'}});
$self->flush_file_lines();
if ($self->{'config_hash'}->{'test_manual'}) {
	$self->{'err'} = $self->test_config();
	if ($self->{'err'}) {
		system("mv $self->{'temp'} ".quotemeta($self->{'file'}));
		$self->error($self->text('manual_etest', "<pre>$self->{'err'}</pre>"));
		}
	}
unlink($self->{'temp'});
$self->unlock_file($self->{'file'});
$self->webmin_log($self->{'logtype'}, "manual", $self->{'logname'}, \%{$self->{'in_hash'}});

foreach $h ('virt', 'idx', 'file', 'limit', 'anon', 'global') {
	push(@{$self->{'args_array'}}, "$h=$self->{'in_hash'}->{$h}") if (defined($self->{'in_hash'}->{$h}));
	}
$self->redirect("$self->{'return'}?".join("&", @{$self->{'args_array'}}));

1;
		
}


1;

