#!/usr/bin/perl

$no_acl_check++;
require 'proftpd-lib.pl';

sub module_install {
	# Check if it really is proftpd and the right version
	@st = stat($config{'proftpd_path'});
	
	$site{'size'} = $st[7];
	$out = `$config{'proftpd_path'} -v 2>&1`;
	return if ($out !~ /ProFTPD\s+Version\s+(\d+)\.([0-9\.]+)/i &&
	    $out !~ /ProFTPD\s+(\d+)\.([0-9\.]+)/i);
	local ($v1, $v2) = ($1, $2);
	$v2 =~ s/\.//g;
	$site{'version'} = "$v1.$v2";
	return if ($site{'version'} < 0.99);

	# Get the list of modules
	local @mods;
	open(MODS, "$config{'proftpd_path'} -l |");
	while(<MODS>) {
		s/\r|\n//g;
		if (/^\s*(\S+)\.c$/) {
			push(@mods, $1);
			}
		}
	close(MODS);
	$site{'modules'} = join(" ", @mods);
	&write_file("$module_config_directory/site", \%site);

 	#configure file /etc/shells
 	if (-e '/etc/shells')
 	{
	 $file='/etc/shells';
	 %fconfig=&foreign_config('virtual-server');
	 
  	 #add new string into /etc/shells
	 &lock_file($file);
  	 @file= &read_file_lines($file);
  	 foreach (@{$file[0]})
	 {
	  $add=1 if ($_ eq $fconfig{'ftp_shell'});
	 }
	 push (@{$file[0]},$fconfig{'ftp_shell'}) if ($add!=1);
	 flush_file_lines();
	 &unlock_file($file);
   	 return 0;
	}
}
1;
