#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_aserv.cgi
# Save anonymous section options

&ModuleLoader::preload_module('proftpd_class', "proftpd::ProftpdLib");
$self = new proftpd::ProftpdLib:: 'proftpd_class',%$self;

$self->ReadParse();
$self->{'conf'} = $self->get_config();
if ($self->{'in_hash'}->{'virt'}) {
	$self->{'virt'} = $self->{'conf'}->[$self->{'in_hash'}->{'virt'}];
	$self->{'vconf'} = $self->{'virt'}->{'members'};
	}
else {
	$self->{'vconf'} = $self->{'conf'};
	}
$self->error_setup($self->{'text_hash'}->{'aserv_err'});

# Validate inputs
-d $self->{'in_hash'}->{'root'} || $self->{'in_hash'}->{'root'} =~ /^~/ || $self->error($self->{'text_hash'}->{'aserv_eroot'});
$self->{'in_hash'}->{'User_def'} || scalar(getpwnam($self->{'in_hash'}->{'User'})) ||
	$self->error($self->{'text_hash'}->{'aserv_euser'});
$self->{'in_hash'}->{'Group_def'} || scalar(getgrnam($self->{'in_hash'}->{'Group'})) ||
	$self->error($self->{'text_hash'}->{'aserv_egroup'});

if ($self->{'in_hash'}->{'init'}) {
	# Create a new <Anonymous> directive
	$self->{'l'} = $self->{'vconf'}->[@{$self->{'vconf'}} - 1];
	$self->lock_file($self->{'l'}->{'file'});
	$self->before_changing();
	$self->{'lref'} = $self->read_file_lines($self->{'l'}->{'file'});
	local @l = ( "<Anonymous $self->{'in_hash'}->{'root'}>" );
	push(@l, "User $self->{'in_hash'}->{'User'}") if (!$self->{'in_hash'}->{'User_def'});
	push(@l, "UserAlias anonymous $self->{'in_hash'}->{'User'}") if (!$self->{'in_hash'}->{'User_def'});
	push(@l, "Group $self->{'in_hash'}->{'Group'}") if (!$self->{'in_hash'}->{'Group_def'});
	push(@l, "</Anonymous>");
	splice(@{$self->{'lref'}}, $self->{'l'}->{'eline'}+1, 0, @l);
	$self->after_changing();
	$self->flush_file_lines();
	$self->unlock_file($self->{'l'}->{'file'});
	$self->webmin_log("anon", "create", $self->{'in_hash'}->{'root'}, \%{$self->{'in_hash'}});
	}
else {
	# Update existing directive
	$self->{'anon'} = $self->find_directive_struct("Anonymous", $self->{'vconf'});
	$self->lock_file($self->{'anon'}->{'file'});
	$self->before_changing();
	$self->{'lref'} = $self->read_file_lines($self->{'anon'}->{'file'});
	$self->{'lref'}->[$self->{'anon'}->{'line'}] = "<Anonymous $self->{'in_hash'}->{'root'}>";
	$self->save_directive("User", $self->{'in_hash'}->{'User_def'} ? [ ] : [ $self->{'in_hash'}->{'User'} ],
			$self->{'anon'}->{'members'}, $self->{'vconf'});
	$self->save_directive("Group", $self->{'in_hash'}->{'Group_def'} ? [ ] : [ $self->{'in_hash'}->{'Group'} ],
			$self->{'anon'}->{'members'}, $self->{'vconf'});
	$self->after_changing();
	$self->flush_file_lines();
	$self->unlock_file($self->{'anon'}->{'file'});
	$self->webmin_log("anon", "save", $self->{'anon'}->{'value'}, \%{$self->{'in_hash'}});
	}
$self->redirect("anon_index.cgi?virt=$self->{'in_hash'}->{'virt'}");

1;
		
}


1;

