#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_dserv.cgi
# Save directory section options

&ModuleLoader::preload_module('proftpd_class', "proftpd::ProftpdLib");
$self = new proftpd::ProftpdLib:: 'proftpd_class',%$self;

$self->ReadParse();
if ($self->{'in_hash'}->{'global'}) {
	$self->{'conf'} = $self->get_config();
	$self->{'conf'} = $self->get_or_create_global($self->{'conf'});
	}
else {
	($self->{'conf'}, $self->{'v'}) = $self->get_virtual_config($self->{'in_hash'}->{'virt'});
	}
if ($self->{'in_hash'}->{'anon'}) {
	$self->{'anon'} = $self->find_directive_struct("Anonymous", $self->{'conf'});
	$self->{'conf'} = $self->{'anon'}->{'members'};
	}
$self->{'d'} = $self->{'conf'}->[$self->{'in_hash'}->{'idx'}];
$self->error_setup($self->{'text_hash'}->{'dserv_err'});

if ($self->{'in_hash'}->{'delete'}) {
	# Delete the directory
	$self->lock_file($self->{'d'}->{'file'});
	$self->before_changing();
	$self->{'lref'} = $self->read_file_lines($self->{'d'}->{'file'});
	splice(@{$self->{'lref'}}, $self->{'d'}->{'line'}, $self->{'d'}->{'eline'} - $self->{'d'}->{'line'} + 1);
	$self->flush_file_lines();
	$self->after_changing();
	$self->unlock_file($self->{'d'}->{'file'});
	$self->webmin_log("dir", "delete", "$self->{'v'}->{'value'}:$self->{'d'}->{'words'}->[0]");
	if ($self->{'in_hash'}->{'global'}) {
		$self->redirect("");
		}
	elsif ($self->{'in_hash'}->{'anon'}) {
		$self->redirect("anon_index.cgi?virt=$self->{'in_hash'}->{'virt'}");
		}
	else {
		$self->redirect("virt_index.cgi?virt=$self->{'in_hash'}->{'virt'}");
		}
	}
else {
	# Update the directory
	$self->{'in_hash'}->{'dir'} =~ /^\S+$/ || $self->error($self->{'text_hash'}->{'dserv_edir'});
	$self->lock_file($self->{'d'}->{'file'});
	$self->before_changing();
	$self->{'lref'} = $self->read_file_lines($self->{'d'}->{'file'});
	$self->{'lref'}->[$self->{'d'}->{'line'}] = "<Directory $self->{'in_hash'}->{'dir'}>";
	$self->flush_file_lines();
	$self->after_changing();
	$self->unlock_file($self->{'d'}->{'file'});
	$self->webmin_log("dir", "save", "$self->{'v'}->{'value'}:$self->{'d'}->{'words'}->[0]");
	$self->redirect("dir_index.cgi?virt=$self->{'in_hash'}->{'virt'}&idx=$self->{'in_hash'}->{'idx'}&anon=$self->{'in_hash'}->{'anon'}&global=$self->{'in_hash'}->{'global'}");
	}

1;
		
}


1;

