#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_dserv.cgi
# Save limit section options

&ModuleLoader::preload_module('proftpd_class', "proftpd::ProftpdLib");
$self = new proftpd::ProftpdLib:: 'proftpd_class',%$self;

$self->error_setup($self->{'text_hash'}->{'lserv_err'});
$self->ReadParse();
if ($self->{'in_hash'}->{'file'}) {
	$self->{'conf'} = $self->get_ftpaccess_config($self->{'in_hash'}->{'file'});
	}
else {
	if ($self->{'in_hash'}->{'global'}) {
		$self->{'conf'} = $self->get_config();
		$self->{'conf'} = $self->get_or_create_global($self->{'conf'});
		}
	else {
		($self->{'conf'}, $self->{'v'}) = $self->get_virtual_config($self->{'in_hash'}->{'virt'});
		}
	if ($self->{'in_hash'}->{'anon'}) {
		$self->{'anon'} = $self->find_directive_struct("Anonymous", $self->{'conf'});
		$self->{'conf'} = $self->{'anon'}->{'members'};
		}
	if ($self->{'in_hash'}->{'idx'} ne '') {
		$self->{'conf'} = $self->{'conf'}->[$self->{'in_hash'}->{'idx'}]->{'members'};
		}
	}
$self->{'l'} = $self->{'conf'}->[$self->{'in_hash'}->{'limit'}];
$self->{'ln'} = $self->{'l'}->{'value'};

if ($self->{'in_hash'}->{'delete'}) {
	# Delete the directory
	$self->lock_file($self->{'l'}->{'file'});
	$self->before_changing();
	$self->{'lref'} = $self->read_file_lines($self->{'l'}->{'file'});
	splice(@{$self->{'lref'}}, $self->{'l'}->{'line'}, $self->{'l'}->{'eline'} - $self->{'l'}->{'line'} + 1);
	$self->flush_file_lines();
	$self->after_changing();
	$self->unlock_file($self->{'l'}->{'file'});
	if ($self->{'in_hash'}->{'file'}) {
		$self->redirect("ftpaccess_index.cgi?file=$self->{'in_hash'}->{'file'}");
		}
	elsif ($self->{'in_hash'}->{'idx'} eq '') {
		if ($self->{'in_hash'}->{'global'}) {
			$self->redirect("");
			}
		elsif ($self->{'in_hash'}->{'anon'}) {
			$self->redirect("anon_index.cgi?virt=$self->{'in_hash'}->{'virt'}");
			}
		else {
			$self->redirect("virt_index.cgi?virt=$self->{'in_hash'}->{'virt'}");
			}
		}
	else {
		$self->redirect("dir_index.cgi?virt=$self->{'in_hash'}->{'virt'}&idx=$self->{'in_hash'}->{'idx'}&anon=$self->{'in_hash'}->{'anon'}&global=$self->{'in_hash'}->{'global'}");
		}
	$self->webmin_log("limit", "delete", $self->{'l'}->{'value'});
	}
else {
	# Update the limit
	local @c = split(/\0/, $self->{'in_hash'}->{'cmd'});
	@c || $self->error($self->{'text_hash'}->{'lserv_ecmd'});
	$self->lock_file($self->{'l'}->{'file'});
	$self->before_changing();
	$self->{'lref'} = $self->read_file_lines($self->{'l'}->{'file'});
	$self->{'lref'}->[$self->{'l'}->{'line'}] = "<Limit ".join(" ", @c).">";
	$self->flush_file_lines();
	$self->after_changing();
	$self->unlock_file($self->{'l'}->{'file'});
	$self->redirect("limit_index.cgi?virt=$self->{'in_hash'}->{'virt'}&idx=$self->{'in_hash'}->{'idx'}&limit=$self->{'in_hash'}->{'limit'}&anon=$self->{'in_hash'}->{'anon'}&file=$self->{'in_hash'}->{'file'}&global=$self->{'in_hash'}->{'global'}");
	$self->webmin_log("limit", "save", $self->{'l'}->{'value'}, \%{$self->{'in_hash'}});
	}

1;
		
}


1;

