#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_vserv.cgi
# Save virtual server options such as the port and address

&ModuleLoader::preload_module('proftpd_class', "proftpd::ProftpdLib");
$self = new proftpd::ProftpdLib:: 'proftpd_class',%$self;

$self->ReadParse();
$self->{'conf'} = $self->get_config();
$self->{'vconf'} = $self->{'conf'}->[$self->{'in_hash'}->{'virt'}];

if ($self->{'in_hash'}->{'delete'}) {
	# Delete a virtual server
	$self->lock_file($self->{'vconf'}->{'file'});
	$self->before_changing();
	$self->{'lref'} = $self->read_file_lines($self->{'vconf'}->{'file'});
	splice(@{$self->{'lref'}}, $self->{'vconf'}->{'line'},
	       $self->{'vconf'}->{'eline'} - $self->{'vconf'}->{'line'} + 1);
	$self->flush_file_lines();
	$self->after_changing();
	$self->unlock_file($self->{'vconf'}->{'file'});
	$self->webmin_log("virt", "delete", $self->{'vconf'}->{'value'});
	$self->redirect("");
	}
else {
	# Update virtual server and directives
	$self->error_setup($self->{'text_hash'}->{'vserv_err'});

	# Check inputs
	gethostbyname($self->{'in_hash'}->{'addr'}) || $self->to_ipaddress($self->{'in_hash'}->{'addr'}) ||
		$self->error($self->{'text_hash'}->{'vserv_eaddr'});
	$self->{'in_hash'}->{'Port_def'} || $self->{'in_hash'}->{'Port'} =~ /^\d+$/ ||
		$self->error($self->{'text_hash'}->{'vserv_eport'});
	$self->{'in_hash'}->{'ServerName_def'} || $self->{'in_hash'}->{'ServerName'} =~ /\S/ ||
		$self->error($self->{'text_hash'}->{'vserv_ename'});

	# Update <VirtualHost> directive
	$self->lock_file($self->{'vconf'}->{'file'});
	$self->before_changing();
	$self->{'lref'} = $self->read_file_lines($self->{'vconf'}->{'file'});
	$self->{'lref'}->[$self->{'vconf'}->{'line'}] = "<VirtualHost $self->{'in_hash'}->{'addr'}>";

	# Update DocumentRoot and ServerName
	$self->save_directive("ServerName", $self->{'in_hash'}->{'ServerName_def'} ? [ ] :
				      [ "\"$self->{'in_hash'}->{'ServerName'}\"" ], 
			$self->{'vconf'}->{'members'}, $self->{'conf'});
	$self->save_directive("Port", $self->{'in_hash'}->{'Port_def'} ? [ ] : [ $self->{'in_hash'}->{'Port'} ],
			$self->{'vconf'}->{'members'}, $self->{'conf'});

	# write out file
	$self->flush_file_lines();
	$self->after_changing();
	$self->unlock_file($self->{'vconf'}->{'file'});
	$self->webmin_log("virt", "save", $self->{'vconf'}->{'value'}, \%{$self->{'in_hash'}});
	$self->redirect("virt_index.cgi?virt=$self->{'in_hash'}->{'virt'}");
	}

1;
		
}


1;

