#!/usr/bin/perl
package qmailadmin::Filter;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'qmailadmin::Filter');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# filter.pl

# read qmail module config
$self->{'p'} = -l $0 ? readlink($0) : $0;
$self->{'p'} =~ /^(.*)\/[^\/]+$/;
open(CONF, "$1/config");
while(<CONF>) {
	if (/^(\S+)=(.*)/) {
		$self->{'config_hash'}->{$1} = $2;
		}
	}
close(CONF);

# read headers and body
$self->{'fromline'} = <STDIN>;
while(<STDIN>) {
	$self->{'headers'} .= $_;
	s/\r|\n//g;
	if (/^(\S+):\s+(.*)/) {
		$self->{'header_hash'}->{lc($1)} = $2;
		}
	elsif (!$_) { last; }
	}
while(<STDIN>) {
	$self->{'body'} .= $_;
	}

# read the filter file
if (open(FILTER, $ARGV[0])) {
	while(<FILTER>) {
		s/\r|\n//g;
		if (/^(\S+)\s+(\S+)\s+(\S+)\s+(.*)$/) {
			push(@{$self->{'filter_array'}}, [ $1, $2, $3, $4 ]);
			}
		elsif (/^(\S+)\s+(\S+)$/) {
			push(@{$self->{'filter_array'}}, [ $1, $2 ]);
			}
		}
	close(FILTER);
	}
else {
	print STDERR "Filter file $ARGV[0] does not exist!\n";
	exit 1;
	}

# run the filter to find the first matching rule
open(LOG, ">>$ARGV[0].log");
foreach $f (@{$self->{'filter_array'}}) {
	 $self->{'field'} = $f->[2] eq 'body' ? $self->{'body'} : $self->{'header_hash'}->{$f->[2]};
	 $self->{'st'} = 0;
	if ($f->[0] == 0) {
		$self->{'st'} = ($self->{'field'} !~ /$f->[3]/i);
		}
	elsif ($f->[0] == 1) {
		$self->{'st'} = ($self->{'field'} =~ /$f->[3]/i);
		}
	elsif ($f->[0] == 2) {
		$self->{'st'} = 1;
		}
	if ($self->{'st'}) {
		# The rule matched!
		if ($f->[1] =~ /^\//) {
			# Write to a file
			open(MAIL, ">>$f->[1]");
			print MAIL $self->{'fromline'};
			}
		else {
			# Forward to another address
			$f->[1] =~ s/\\/\\\\/g;
			$f->[1] =~ s/'/\\'/g;
			open(MAIL, "|$self->{'config_hash'}->{'qmail_dir'}/bin/qmail-inject '$f->[1]'");
			}
		print MAIL $self->{'headers'};
		print MAIL $self->{'body'};
		close(MAIL);
		$self->{'now'} = localtime(time());
		print LOG "[$self->{'now'}] [$self->{'header_hash'}->{'from'}] [",join(" ",@$f),"]\n";
		last;
		}
	}

1;
		return $self;
}


1;

