#!/usr/bin/perl
package qmailadmin::Log_parser;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'qmailadmin::Log_parser');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# log_parser.pl
# Functions for parsing this module's logs

&ModuleLoader::preload_module(ref($self), "qmailadmin::QmailLib");
$self = new qmailadmin::QmailLib:: ref($self), %$self; 

1;
		return $self;
}

# parse_webmin_log(user, script, action, type, object, &params, long)
# Converts logged information from this module into human-readable form
sub parse_webmin_log
{
	my $self = shift;

local ($user, $script, $action, $type, $object, $p, $long) = @_;
if ($type eq 'alias') {
	return $self->text("log_alias_$action",
		     "<tt>".$self->html_escape($object)."</tt>");
	}
elsif ($type eq 'virt') {
	return $self->text($object ne '-' ? "log_virt_$action" :
		"log_virtall_$action", "<tt>".$self->html_escape($object)."</tt>");
	}
elsif ($type eq 'route') {
	return $self->text("log_route_$action",
		     "<tt>".$self->html_escape($object)."</tt>");
	}
elsif ($type eq 'assign') {
	local $str = $object =~ /^=(\S*)/ ? $1 :
		     $object =~ /^\+(\S*)/ ? "$1*" : "";
	return $self->text("log_assign_$action", $self->html_escape($str));
	}
elsif ($type eq 'aliases' || $type eq 'virts' || $type eq 'routes' ||
       $type eq 'assigns') {
	return $self->text("log_${action}_${type}", $object);
	}
elsif ($action eq 'delmail') {
	local @d = split(/\0/, $p->{'d'});
	return $self->text("log_delmail", scalar(@d), "<tt>$p->{'user'}</tt>");
	}
elsif ($action eq 'movemail') {
	local @d = split(/\0/, $p->{'d'});
	local $to = $p->{'move1'} ? $p->{'moveto1'} : $p->{'moveto2'};
	return $self->text("log_movemail", scalar(@d), "<tt>$p->{'user'}</tt>",
		     "<tt>$to</tt>");
	}
elsif ($action eq 'send') {
        return $self->text('log_send', $self->html_escape($self->extract_email($p->{'to'})));
        }
else {
	return $self->{'text_hash'}->{"log_$action"};
	}
}


1;

