#!/usr/bin/perl

&MAIN();

 sub MAIN {
# list_aliases.cgi
# Displays a list of all aliases
# XXX .qmail-default and .qmail-foo-default alias support

&ModuleLoader::preload_module('qmailadmin_class', "qmailadmin::QmailLib");
$self = new qmailadmin::QmailLib:: 'qmailadmin_class',%$self;

$self->ReadParse();
$self->ui_print_header(undef, $self->{'text_hash'}->{'aliases_title'}, "");

@{$self->{'aliases_array'}} = $self->list_aliases();
$self->alias_form();

if ($self->{'in_hash'}->{'search'}) {
	# Restrict to search results
	@{$self->{'aliases_array'}} = grep { $_ =~ /$self->{'in_hash'}->{'search'}/ } @{$self->{'aliases_array'}};
	}
elsif ($self->{'config_hash'}->{'max_records'} && @{$self->{'aliases_array'}} > $self->{'config_hash'}->{'max_records'}) {
	# Show search form
	print $self->{'text_hash'}->{'aliases_toomany'},"<br>\n";
	print "<form action=list_aliases.cgi>\n";
	print "<input type=submit value='$self->{'text_hash'}->{'aliases_go'}'>\n";
	print "<input name=search size=20></form>\n";
	undef(@{$self->{'aliases_array'}});
	}

if (@{$self->{'aliases_array'}}) {
	# sort if needed
	if ($self->{'config_hash'}->{'sort_mode'} == 1) {
		@{$self->{'aliases_array'}} = sort { lc($a) cmp lc($b) } @{$self->{'aliases_array'}};
		}
	@{$self->{'aliases_array'}} = map { $self->get_alias($_) } @{$self->{'aliases_array'}};

	# find a good place to split
	$self->{'lines'} = 0;
	for($i=0; $i<@{$self->{'aliases_array'}}; $i++) {
		$self->{'aline_array'}->[$i] = $self->{'lines'};
		$self->{'al'} = scalar(@{$self->{'aliases_array'}->[$i]->{'values'}});
		$self->{'lines'} += ($self->{'al'} ? $self->{'al'} : 1);
		}
	$self->{'midline'} = int(($self->{'lines'}+1) / 2);
	for($mid=0; $mid<@{$self->{'aliases_array'}} && $self->{'aline_array'}->[$mid] < $self->{'midline'}; $mid++) { }

	# render tables
        print $self->ui_form_start("delete_aliases.cgi", "post");
        print $self->select_all_link("d", 1),"\n";
        print $self->select_invert_link("d", 1),"<br>\n";
	if ($self->{'config_hash'}->{'columns'} == 2) {
		print "<table width=100%> <tr><td width=50% valign=top>\n";
		&aliases_table(@{$self->{'aliases_array'}}[0..$mid-1]);
		print "</td><td width=50% valign=top>\n";
		if ($mid < @{$self->{'aliases_array'}}) { &aliases_table(@{$self->{'aliases_array'}}[$mid..$#{$self->{'aliases_array'}}]); }
		print "</td></tr> </table><br>\n";
		}
	else {
		&aliases_table(@{$self->{'aliases_array'}});
		}
        print $self->select_all_link("d", 1),"\n";
        print $self->select_invert_link("d", 1),"<br>\n";
        print $self->ui_form_end([ [ "delete", $self->{'text_hash'}->{'aliases_delete'} ] ]);
	}

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}

sub aliases_table
{
	shift if ($self == $_[0]);

print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td width=5><br></td> <td><b>$self->{'text_hash'}->{'aliases_addr'}</b></td> ",
      "<td><b>$self->{'text_hash'}->{'aliases_to'}</b></td> </tr>\n";
foreach $a (@_) {
	local $n = $a->{'name'};
	$n =~ s/:/\./g;
	print "<tr $self->{'cb'}>\n";
	print "<td width=5>",$self->ui_checkbox("d", $a->{'name'}),"</td>\n";
	print "<td valign=top><a href=\"edit_alias.cgi?name=$a->{'name'}\">",
	      $self->html_escape($n),"</a></td>\n";
	print "<td>\n";
	foreach $v (@{$a->{'values'}}) {
		($self->{'anum'}, $self->{'astr'}) = $self->alias_type($v);
		print $self->text("aliases_type$self->{'anum'}",
			    "<tt>".$self->html_escape($self->{'astr'})."</tt>"),"<br>\n";
		}
	if (!@{$a->{'values'}}) {
		print "<i>$self->{'text_hash'}->{'aliases_none'}</i>\n";
		}
	print "</td> </tr>\n";
	}
print "</table>\n";
}


1;

