#!/usr/bin/perl

&MAIN();

 sub MAIN {
# list_routes.cgi
# Display a list of SMTP routes

&ModuleLoader::preload_module('qmailadmin_class', "qmailadmin::QmailLib");
$self = new qmailadmin::QmailLib:: 'qmailadmin_class',%$self;

$self->ReadParse();
$self->ui_print_header(undef, $self->{'text_hash'}->{'routes_title'}, "");

@{$self->{'routes_array'}} = $self->list_routes();
($self->{'defroute'}) = grep { !$_->{'from'} } @{$self->{'routes_array'}};
@{$self->{'routes_array'}} = grep { $_ ne $self->{'defroute'} } @{$self->{'routes_array'}};
$self->route_form();

if ($self->{'in_hash'}->{'search'}) {
	# Restrict to search results
	@{$self->{'routes_array'}} = grep { $_->{'from'} =~ /$self->{'in_hash'}->{'search'}/ } @{$self->{'routes_array'}};
	}
elsif ($self->{'config_hash'}->{'max_records'} && @{$self->{'routes_array'}} > $self->{'config_hash'}->{'max_records'}) {
	# Show search form
	print $self->{'text_hash'}->{'routes_toomany'},"<br>\n";
	print "<form action=list_routes.cgi>\n";
	print "<input type=submit value='$self->{'text_hash'}->{'routes_go'}'>\n";
	print "<input name=search size=20></form>\n";
	undef(@{$self->{'routes_array'}});
	}

if (@{$self->{'routes_array'}}) {
	# sort if needed
	if ($self->{'config_hash'}->{'sort_mode'} == 1) {
		@{$self->{'routes_array'}} = sort { lc($a->{'from'}) cmp lc($b->{'from'}) }
			       @{$self->{'routes_array'}};
		}

	# render tables
        print $self->ui_form_start("delete_routes.cgi", "post");
        print $self->select_all_link("d", 1),"\n";
        print $self->select_invert_link("d", 1),"<br>\n";
	if ($self->{'config_hash'}->{'columns'} == 2) {
		$self->{'mid'} = int((@{$self->{'routes_array'}}+1)/2);
		print "<table width=100%> <tr><td width=50% valign=top>\n";
		&routes_table(@{$self->{'routes_array'}}[0..$self->{'mid'}-1]);
		print "</td><td width=50% valign=top>\n";
		if ($self->{'mid'} < @{$self->{'routes_array'}}) { &routes_table(@{$self->{'routes_array'}}[$self->{'mid'}..$#{$self->{'routes_array'}}]); }
		print "</td></tr> </table><br>\n";
		}
	else {
		&routes_table(@{$self->{'routes_array'}});
		}
        print $self->select_all_link("d", 1),"\n";
        print $self->select_invert_link("d", 1),"<br>\n";
        print $self->ui_form_end([ [ "delete", $self->{'text_hash'}->{'routes_delete'} ] ]);
	}

print "<hr>\n";
print "<form action=save_defroute.cgi>\n";
print "<input type=hidden name=idx value='$self->{'defroute'}->{'idx'}'>\n"
	if ($self->{'defroute'});
print "<b>$self->{'text_hash'}->{'routes_defroute'}</b>\n";
printf "<input type=radio name=direct value=1 %s> %s\n",
	$self->{'defroute'} ? "" : "checked", $self->{'text_hash'}->{'routes_direct'};
printf "<input type=radio name=direct value=0 %s> %s\n",
	$self->{'defroute'} ? "checked" : "";
printf "<input name=defroute size=30 value='$self->{'defroute'}->{'to'}'>\n";
print "<input type=submit value='$self->{'text_hash'}->{'save'}'></form>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}

sub routes_table
{
	shift if ($self == $_[0]);

print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td width=5><br></td> <td><b>$self->{'text_hash'}->{'routes_from'}</b></td> ",
      "<td><b>$self->{'text_hash'}->{'routes_to'}</b></td> </tr>\n";
foreach $r (@_) {
	print "<tr $self->{'cb'}>\n";
	print "<td width=5>",$self->ui_checkbox("d", $r->{'from'}),"</td>\n";
	print "<td valign=top><a href=\"edit_route.cgi?idx=$r->{'idx'}\">",
	      $self->html_escape($r->{'from'}),"</a></td>\n";
	print "<td>",$r->{'port'} ? $self->html_escape("$r->{'to'}:$r->{'port'}") :
		     $r->{'to'} ? $self->html_escape($r->{'to'}) :
			  "<i>$self->{'text_hash'}->{'routes_direct'}</i>","</td> </tr>\n";
	}
print "</table>\n";
}


1;

