#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_alias.cgi
# Save or delete a new or existing alias

&ModuleLoader::preload_module('qmailadmin_class', "qmailadmin::QmailLib");
$self = new qmailadmin::QmailLib:: 'qmailadmin_class',%$self;

$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'asave_err'});

@{$self->{'aliases_array'}} = $self->list_aliases();
foreach $ex (@{$self->{'aliases_array'}}) {
	$self->{'exists_hash'}->{lc($ex)}++;
	}
$self->{'a'} = $self->get_alias($self->{'in_hash'}->{'old'});

if ($self->{'in_hash'}->{'delete'}) {
	# delete some alias
	$self->{'loga'} = $self->{'a'};
	$self->delete_alias($self->{'a'});
	}
else {
	# saving or creating .. check inputs
	$self->{'in_hash'}->{'name'} =~ /^[^:@ ]+$/ ||
		$self->error($self->text('asave_eaddr', $self->{'in_hash'}->{'name'}));
	local $n = $self->{'in_hash'}->{'name'};
	$n =~ s/\./:/g;
	if ($self->{'in_hash'}->{'virt'}) {
		$self->{'in_hash'}->{'virt'} =~ s/\./:/g;
		$n = $self->{'in_hash'}->{'virt'}.'-'.$n;
		}

	if ($self->{'in_hash'}->{'new'} || lc($self->{'a'}->{'name'}) ne lc($n)) {
		# is this name taken?
		$self->{'exists_hash'}->{$n} &&
			$self->error($self->text('asave_ealready', $self->{'in_hash'}->{'name'}));
		}
	for($i=0; defined($self->{'t'} = $self->{'in_hash'}->{"type_$i"}); $i++) {
		$self->{'v'} = $self->{'in_hash'}->{"val_$i"};
		if ($self->{'t'} == 1 && $self->{'v'} !~ /^(\S+)$/) {
			$self->error($self->text('asave_etype1', $self->{'v'}));
			}
		elsif ($self->{'t'} == 2 && $self->{'v'} !~ /^\/(\S+)[^\/\s]$/) {
			$self->error($self->text('asave_etype2', $self->{'v'}));
			}
		elsif ($self->{'t'} == 3 && $self->{'v'} !~ /^\/(\S+)[^\/\s]$/) {
			$self->error($self->text('asave_etype3', $self->{'v'}));
			}
		elsif ($self->{'t'} == 4) {
			$self->{'v'} =~ /^(\S+)/ || $self->error($self->{'text_hash'}->{'asave_etype4none'});
			-x $1 || $self->error($self->text('asave_etype4', "$1"));
			}
		elsif ($self->{'t'} == 5 && $self->{'v'} !~ /^\/\S+$/) {
			$self->error($self->text('asave_etype5', $self->{'v'}));
			}
		elsif ($self->{'t'} == 6 && $self->{'v'} !~ /^\/\S+$/) {
			$self->error($self->text('asave_etype6', $self->{'v'}));
			}
		if ($self->{'t'} == 1) { push(@{$self->{'values_array'}}, "&$self->{'v'}"); }
		elsif ($self->{'t'} == 2) { push(@{$self->{'values_array'}}, "$self->{'v'}/"); }
		elsif ($self->{'t'} == 3) { push(@{$self->{'values_array'}}, "$self->{'v'}"); }
		elsif ($self->{'t'} == 4) { push(@{$self->{'values_array'}}, "|$self->{'v'}"); }
		elsif ($self->{'t'} == 5) {
			# Setup autoreply script
			push(@{$self->{'values_array'}}, "|$self->{'module_config_directory'}/autoreply.pl ".
				      "$self->{'v'} $self->{'in_hash'}->{'name'}");
			$self->system_logged("cp autoreply.pl $self->{'module_config_directory'}");
			$self->system_logged("chmod 755 $self->{'module_config_directory'}/config");
			}
		elsif ($self->{'t'} == 6) {
			# Setup filter script
			push(@{$self->{'values_array'}}, "|$self->{'module_config_directory'}/filter.pl ".
				      "$self->{'v'} $self->{'in_hash'}->{'name'}");
			$self->system_logged("cp filter.pl $self->{'module_config_directory'}");
			$self->system_logged("chmod 755 $self->{'module_config_directory'}/config");
			}
		}

	$self->{'newa_hash'}->{'name'} = $n;
	$self->{'newa_hash'}->{'values'} = \@{$self->{'values_array'}};
	if ($self->{'in_hash'}->{'new'}) { $self->create_alias(\%{$self->{'newa_hash'}}); }
	else { $self->modify_alias($self->{'a'}, \%{$self->{'newa_hash'}}); }
	$self->{'loga'} = \%{$self->{'newa_hash'}};
	}
$self->webmin_log($self->{'in_hash'}->{'delete'} ? 'delete' : $self->{'in_hash'}->{'new'} ? 'create' : 'modify',
	    "alias", $self->{'loga'}->{'name'}, $self->{'loga'});
$self->redirect("list_aliases.cgi");

1;
		
}


1;

