#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_opts.cgi
# Save global QMail options

&ModuleLoader::preload_module('qmailadmin_class', "qmailadmin::QmailLib");
$self = new qmailadmin::QmailLib:: 'qmailadmin_class',%$self;

$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'opts_err'});

# Validate inputs
$self->{'in_hash'}->{'me'} =~ /^[A-Za-z0-9\.\-]+$/ ||
	$self->error($self->{'text_hash'}->{'opts_eme'});
$self->{'in_hash'}->{'helo_def'} || $self->{'in_hash'}->{'helo'} =~ /^[A-Za-z0-9\.\-]+$/ ||
	$self->error($self->{'text_hash'}->{'opts_ehelo'});
$self->{'in_hash'}->{'toconnect_def'} || $self->{'in_hash'}->{'toconnect'} =~ /^\d+$/ ||
	$self->error($self->{'text_hash'}->{'opts_etoconnect'});
$self->{'in_hash'}->{'toremote_def'} || $self->{'in_hash'}->{'toremote'} =~ /^\d+$/ ||
	$self->error($self->{'text_hash'}->{'opts_etoremote'});
$self->{'in_hash'}->{'bytes_def'} || $self->{'in_hash'}->{'bytes'} =~ /^\d+$/ ||
	$self->error($self->{'text_hash'}->{'opts_ebytes'});
$self->{'in_hash'}->{'timeout_def'} || $self->{'in_hash'}->{'timeout'} =~ /^\d+$/ ||
	$self->error($self->{'text_hash'}->{'opts_etimeout'});
$self->{'in_hash'}->{'localip_def'} || $self->{'in_hash'}->{'localip'} =~ /^[A-Za-z0-9\.\-]+$/ ||
	$self->error($self->{'text_hash'}->{'opts_elocalip'});

# Update config files
$self->set_control_file("me", $self->{'in_hash'}->{'me'});
$self->set_control_file("helohost", $self->{'in_hash'}->{'helo_def'} ? undef : $self->{'in_hash'}->{'helo'});
$self->set_control_file("timeoutconnect", $self->{'in_hash'}->{'toconnect_def'} ? undef
							 : $self->{'in_hash'}->{'toconnect'});
$self->set_control_file("timeoutremote", $self->{'in_hash'}->{'toremote_def'} ? undef
						       : $self->{'in_hash'}->{'toremote'});
$self->set_control_file("timeoutconnect", $self->{'in_hash'}->{'toconnect_def'} ? undef
							 : $self->{'in_hash'}->{'toconnect'});
$self->set_control_file("databytes", $self->{'in_hash'}->{'bytes_def'} ? undef : $self->{'in_hash'}->{'bytes'});
$self->set_control_file("timeoutsmtpd", $self->{'in_hash'}->{'timeout_def'} ? undef
						     : $self->{'in_hash'}->{'timeout'});
$self->set_control_file("localiphost", $self->{'in_hash'}->{'localip_def'} ? undef : $self->{'in_hash'}->{'localip'});
$self->set_control_file("smtpgreeting", $self->{'in_hash'}->{'greet_def'} ? undef : $self->{'in_hash'}->{'greet'});

$self->webmin_log("opts", undef, undef, \%{$self->{'in_hash'}});
$self->redirect("");

1;
		
}


1;

