#!/usr/bin/perl
package quota::Acl_security;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'quota::Acl_security');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;

&ModuleLoader::preload_module(ref($self), "quota::QuotaLib");
$self = new quota::QuotaLib:: ref($self), %$self; 

1;
		return $self;
}

# acl_security_form(&options)
# Output HTML for editing security options for the quota module
sub acl_security_form
{
	my $self = shift;

local $groups = $self->quotas_supported() >= 2;

print "<tr> <td valign=top><b>$self->{'text_hash'}->{'acl_fss'}</b></td>\n";
print "<td colspan=3>\n";
printf "<input type=radio name=filesys_def value=1 %s> %s\n",
	$_[0]->{'filesys'} eq '*' ? 'checked' : '', $self->{'text_hash'}->{'acl_fall'};
printf "<input type=radio name=filesys_def value=0 %s> %s<br>\n",
	$_[0]->{'filesys'} eq '*' ? '' : 'checked', $self->{'text_hash'}->{'acl_fsel'};
print "<select width=150 name=filesys multiple size=3>\n";
local ($f, %qcan);
map { $qcan{$_}++ } split(/\s+/, $_[0]->{'filesys'});
foreach $f ($self->list_filesystems()) {
	if ($f->[4]) {
		printf "<option %s>%s\n",
			$qcan{$f->[0]} ? "selected" : "", $f->[0];
		}
	}
print "</select></td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'acl_ro'}</b></td> <td>\n";
printf "<input type=radio name=ro value=1 %s> $self->{'text_hash'}->{'yes'}\n",
	$_[0]->{'ro'} ? "checked" : "";
printf "<input type=radio name=ro value=0 %s> $self->{'text_hash'}->{'no'}</td> </tr>\n",
	$_[0]->{'ro'} ? "" : "checked";

print "<tr> <td colspan=4><hr></td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'acl_quotaon'}</b></td> <td>\n";
printf "<input type=radio name=enable value=1 %s> $self->{'text_hash'}->{'yes'}\n",
	$_[0]->{'enable'} ? "checked" : "";
printf "<input type=radio name=enable value=0 %s> $self->{'text_hash'}->{'no'}</td>\n",
	$_[0]->{'enable'} ? "" : "checked";

print "<td><b>$self->{'text_hash'}->{'acl_quotanew'}</b></td> <td>\n";
printf "<input type=radio name=default value=1 %s> $self->{'text_hash'}->{'yes'}\n",
	$_[0]->{'default'} ? "checked" : "";
printf "<input type=radio name=default value=0 %s> $self->{'text_hash'}->{'no'}</td> </tr>\n",
	$_[0]->{'default'} ? "" : "checked";

print "<tr> <td><b>$self->{'text_hash'}->{'acl_ugrace'}</b></td> <td>\n";
printf "<input type=radio name=ugrace value=1 %s> $self->{'text_hash'}->{'yes'}\n",
	$_[0]->{'ugrace'} ? "checked" : "";
printf "<input type=radio name=ugrace value=0 %s> $self->{'text_hash'}->{'no'}</td>\n",
	$_[0]->{'ugrace'} ? "" : "checked";

print "<td><b>$self->{'text_hash'}->{'acl_vtotal'}</b></td> <td>\n";
printf "<input type=radio name=diskspace value=1 %s> $self->{'text_hash'}->{'yes'}\n",
	$_[0]->{'diskspace'} ? "checked" : "";
printf "<input type=radio name=diskspace value=0 %s> $self->{'text_hash'}->{'no'}</td> </tr>\n",
	$_[0]->{'diskspace'} ? "" : "checked";

print "<tr> <td><b>$self->{'text_hash'}->{'acl_maxblocks'}</b></td> <td>\n";
printf "<input type=radio name=maxblocks_def value=1 %s> %s\n",
	$_[0]->{'maxblocks'} ? '' : 'checked', $self->{'text_hash'}->{'acl_unlimited'};
printf "<input type=radio name=maxblocks_def value=0 %s>\n",
	$_[0]->{'maxblocks'} ? 'checked' : '';
print "<input name=maxblocks size=8 value='$_[0]->{'maxblocks'}'></td>\n";

print "<td><b>$self->{'text_hash'}->{'acl_maxfiles'}</b></td> <td>\n";
printf "<input type=radio name=maxfiles_def value=1 %s> %s\n",
	$_[0]->{'maxfiles'} ? '' : 'checked', $self->{'text_hash'}->{'acl_unlimited'};
printf "<input type=radio name=maxfiles_def value=0 %s>\n",
	$_[0]->{'maxfiles'} ? 'checked' : '';
print "<input name=maxfiles size=8 value='$_[0]->{'maxfiles'}'></td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'acl_email'}</b></td> <td>\n";
printf "<input type=radio name=email value=1 %s> $self->{'text_hash'}->{'yes'}\n",
	$_[0]->{'email'} ? "checked" : "";
printf "<input type=radio name=email value=0 %s> $self->{'text_hash'}->{'no'}</td>\n",
	$_[0]->{'email'} ? "" : "checked";

if ($groups) {
	print "<td><b>$self->{'text_hash'}->{'acl_ggrace'}</b></td> <td>\n";
	printf "<input type=radio name=ggrace value=1 %s> $self->{'text_hash'}->{'yes'}\n",
		$_[0]->{'ggrace'} ? "checked" : "";
	printf "<input type=radio name=ggrace value=0 %s> $self->{'text_hash'}->{'no'}</td>\n",
		$_[0]->{'ggrace'} ? "" : "checked";
	}
print "</tr>\n";

print "<tr> <td colspan=4><hr></td> </tr>\n";

print "<tr> <td valign=top><b>$self->{'text_hash'}->{'acl_uquota'}",
      "</b></td> <td colspan=3>\n";
printf "<input type=radio name=umode value=0 %s> $self->{'text_hash'}->{'acl_uall'}<br>\n",
	$_[0]->{'umode'} == 0 ? "checked" : "";
printf "<input type=radio name=umode value=1 %s> $self->{'text_hash'}->{'acl_uonly'}\n",
	$_[0]->{'umode'} == 1 ? "checked" : "";
printf "<input name=ucan size=40 value='%s'> %s<br>\n",
	$_[0]->{'umode'} == 1 ? $_[0]->{'users'} : "",
	$self->user_chooser_button("ucan", 1);
printf "<input type=radio name=umode value=2 %s> $self->{'text_hash'}->{'acl_uexcept'}\n",
	$_[0]->{'umode'} == 2 ? "checked" : "";
printf "<input name=ucannot size=40 value='%s'> %s<br>\n",
	$_[0]->{'umode'} == 2 ? $_[0]->{'users'} : "",
	$self->user_chooser_button("ucannot", 1);
printf "<input type=radio name=umode value=3 %s> $self->{'text_hash'}->{'acl_ugroup'}\n",
	$_[0]->{'umode'} == 3 ? "checked" : "";
printf "<input name=upri size=8 value='%s'> %s<br>\n",
	$_[0]->{'umode'} == 3 ? scalar(getgrgid($_[0]->{'users'})) : "",
	$self->group_chooser_button("upri", 0);
printf "<input type=radio name=umode value=4 %s> $self->{'text_hash'}->{'acl_uuid'}\n",
	$_[0]->{'umode'} == 4 ? "checked" : "";
printf "<input name=umin size=6 value='%s'> -\n",
	$_[0]->{'umode'} == 4 ? $_[0]->{'umin'} : "";
printf "<input name=umax size=6 value='%s'></td> </tr>\n",
	$_[0]->{'umode'} == 4 ? $_[0]->{'umax'} : "";

if ($groups) {
	print "<tr> <td colspan=4><hr></td> </tr>\n";

	print "<tr> <td valign=top><b>$self->{'text_hash'}->{'acl_gquota'}",
	      "</b></td> <td colspan=3>\n";
	printf "<input type=radio name=gmode value=0 %s>$self->{'text_hash'}->{'acl_gall'}<br>\n",
		$_[0]->{'gmode'} == 0 ? "checked" : "";
	printf "<input type=radio name=gmode value=3 %s>$self->{'text_hash'}->{'acl_gnone'}<br>\n",
		$_[0]->{'gmode'} == 3 ? "checked" : "";
	printf "<input type=radio name=gmode value=1 %s>$self->{'text_hash'}->{'acl_gonly'}\n",
		$_[0]->{'gmode'} == 1 ? "checked" : "";
	printf "<input name=gcan size=40 value='%s'> %s<br>\n",
		$_[0]->{'gmode'} == 1 ? $_[0]->{'groups'} : "",
		$self->group_chooser_button("gcan", 1);
	printf "<input type=radio name=gmode value=2 %s>$self->{'text_hash'}->{'acl_gexcept'}\n",
		$_[0]->{'gmode'} == 2 ? "checked" : "";
	printf "<input name=gcannot size=40 value='%s'> %s</td> </tr>\n",
		$_[0]->{'gmode'} == 2 ? $_[0]->{'groups'} : "",
		$self->group_chooser_button("gcannot", 1);
	}
}

# acl_security_save(&options)
# Parse the form for security options for the quota module
sub acl_security_save
{
	my $self = shift;

if ($self->{'in_hash'}->{'filesys_def'}) {
	$_[0]->{'filesys'} = "*";
	}
else {
	$_[0]->{'filesys'} = join(" ", split(/\0/, $self->{'in_hash'}->{'filesys'}));
	}
$_[0]->{'ro'} = $self->{'in_hash'}->{'ro'};
$_[0]->{'umode'} = $self->{'in_hash'}->{'umode'};
$_[0]->{'users'} = $self->{'in_hash'}->{'umode'} == 0 ? "" :
		   $self->{'in_hash'}->{'umode'} == 1 ? $self->{'in_hash'}->{'ucan'} :
		   $self->{'in_hash'}->{'umode'} == 2 ? $self->{'in_hash'}->{'ucannot'} :
		   $self->{'in_hash'}->{'umode'} == 3 ? scalar(getgrnam($self->{'in_hash'}->{'upri'})) : "";
$_[0]->{'umin'} = $self->{'in_hash'}->{'umin'};
$_[0]->{'umax'} = $self->{'in_hash'}->{'umax'};
$_[0]->{'gmode'} = $self->{'in_hash'}->{'gmode'};
$_[0]->{'groups'} = $self->{'in_hash'}->{'gmode'} == 0 ? "" :
		    $self->{'in_hash'}->{'gmode'} == 1 ? $self->{'in_hash'}->{'gcan'} : $self->{'in_hash'}->{'gcannot'};
$_[0]->{'enable'} = $self->{'in_hash'}->{'enable'};
$_[0]->{'default'} = $self->{'in_hash'}->{'default'};
$_[0]->{'email'} = $self->{'in_hash'}->{'email'};
$_[0]->{'ugrace'} = $self->{'in_hash'}->{'ugrace'};
$_[0]->{'ggrace'} = $self->{'in_hash'}->{'ggrace'};
$_[0]->{'diskspace'} = $self->{'in_hash'}->{'diskspace'};
$_[0]->{'maxblocks'} = $self->{'in_hash'}->{'maxblocks_def'} ? undef : $self->{'in_hash'}->{'maxblocks'};
$_[0]->{'maxfiles'} = $self->{'in_hash'}->{'maxfiles'};
}


1;

