#!/usr/bin/perl
package quota::Useradmin_update;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'quota::Useradmin_update');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;

&ModuleLoader::preload_module(ref($self), "quota::QuotaLib");
$self = new quota::QuotaLib:: ref($self), %$self; 

1;

1;
		return $self;
}

# useradmin_create_user(&details)
# Sets quotas on chosen filesystems
sub useradmin_create_user
{
	my $self = shift;

local ($anysync) = grep { /^sync_/ } (keys %{$self->{'config_hash'}});
return if (!$anysync);
local ($k, $fs, $i, %fslist);
foreach $fs ($self->list_filesystems()) {
	if ($fs->[4] && $fs->[5]) {
		$fslist{$fs->[0]}++;
		}
	}
foreach $k (keys %{$self->{'config_hash'}}) {
	if ($k =~ /^sync_(\S+)$/ && $fslist{$1}) {
		# found a filesystem to set quotas on
		$fs = $1;
		@{$self->{'quot_array'}} = split(/\s+/, $self->{'config_hash'}->{$k});
		$self->edit_user_quota($_[0]->{'user'}, $fs, @{$self->{'quot_array'}});
		}
	}
}

# useradmin_delete_user(&details)
# Zero the quotas of a deleted user
sub useradmin_delete_user
{
	my $self = shift;

foreach $fs ($self->list_filesystems()) {
	if ($fs->[4] && $fs->[5]) {
		$self->{'fslist_hash'}->{$fs->[0]}++;
		}
	}
$self->{'n'} = $self->user_filesystems($_[0]->{'user'});
for($i=0; $i<$self->{'n'}; $i++) {
	$self->{'f'} = $self->{'filesys_hash'}->{$i,'filesys'};
	if ($self->{'fslist_hash'}->{$self->{'f'}}) {
		# user has quota, and filesystem is local
		$self->edit_user_quota($_[0]->{'user'}, $self->{'f'}, 0, 0, 0, 0);
		}
	}
}

# useradmin_modify_user(&details)
# Quotas are stored by UID, so no need to change anything
# when a username changes.
sub useradmin_modify_user
{
	my $self = shift;

# XXX should change if UID changes?
}

# useradmin_create_group(&details)
# Sets quotas on chosen filesystems
sub useradmin_create_group
{
	my $self = shift;

local ($anysync) = grep { /^gsync_/ } (keys %{$self->{'config_hash'}});
return if (!$anysync);
return if (!$self->UNIVERSAL::can('edit_group_quota') || !$self->UNIVERSAL::can('group_filesystems'));
local ($k, $fs, $i, %fslist);
foreach $fs ($self->list_filesystems()) {
	if ($fs->[4] && $fs->[5]) {
		$fslist{$fs->[0]}++;
		}
	}
foreach $k (keys %{$self->{'config_hash'}}) {
	if ($k =~ /^gsync_(\S+)$/ && $fslist{$1}) {
		# found a filesystem to set quotas on
		$fs = $1;
		@{$self->{'quot_array'}} = split(/\s+/, $self->{'config_hash'}->{$k});
		$self->edit_group_quota($_[0]->{'group'}, $fs, @{$self->{'quot_array'}});
		}
	}
}

# useradmin_delete_group(&details)
# Zero the quotas of a deleted group
sub useradmin_delete_group
{
	my $self = shift;

return if (!$self->UNIVERSAL::can('edit_group_quota') || !$self->UNIVERSAL::can('group_filesystems'));
foreach $fs ($self->list_filesystems()) {
	if ($fs->[4] && $fs->[5]) {
		$self->{'fslist_hash'}->{$fs->[0]}++;
		}
	}
$self->{'n'} = $self->group_filesystems($_[0]->{'group'});
for($i=0; $i<$self->{'n'}; $i++) {
	$self->{'f'} = $self->{'filesys_hash'}->{$i,'filesys'};
	if ($self->{'fslist_hash'}->{$self->{'f'}}) {
		# group has quota, and filesystem is local
		$self->edit_group_quota($_[0]->{'group'}, $self->{'f'}, 0, 0, 0, 0);
		}
	}
}

# useradmin_modify_group(&details)
# Quotas are stored by UID, so no need to change anything
# when a group name changes.
sub useradmin_modify_group
{
	my $self = shift;

return if (!$self->UNIVERSAL::can('edit_group_quota') || !$self->UNIVERSAL::can('group_filesystems'));
# XXX should change if UID changes?
}


1;

