#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Display a form for updating multiple group quotas on a filesystem

&ModuleLoader::preload_module('quota_class', "quota::QuotaLib");
$self = new quota::QuotaLib:: 'quota_class',%$self;

$self->ReadParse();
$self->{'fs'} = $self->{'in_hash'}->{'dir'};
@{$self->{'d_array'}} = split(/\0/, $self->{'in_hash'}->{'d'});
foreach $u (@{$self->{'d_array'}}) {
	$self->can_edit_group($u) ||
		$self->error($self->text('egroup_eallowgr', $u));
	}
$self->{'access_hash'}->{'ro'} && $self->error($self->text('egroup_eallowgr', $u));
$self->can_edit_filesys($self->{'fs'}) ||
	$self->error($self->{'text_hash'}->{'euser_eallowfs'});
$self->ui_print_header(undef, $self->{'text_hash'}->{'gmass_title'}, "", "edit_group_mass");

$self->{'bsize'} = $self->block_size($self->{'fs'});

print $self->text('gmass_count', scalar(@{$self->{'d_array'}})),"<br>\n";
print $self->ui_form_start("save_group_mass.cgi", "post");
foreach $u (@{$self->{'d_array'}}) {
	print $self->ui_hidden("d", $u),"\n";
	}
print $self->ui_hidden("dir", $self->{'fs'}),"\n";
print $self->ui_table_start($self->{'text_hash'}->{'gmass_header'}, undef, 2);

foreach $t ('sblocks', 'hblocks', 'sfiles', 'hfiles') {
	print $self->ui_table_row($self->{'text_hash'}->{'umass_'.$t},
		$self->ui_radio($t.'_def', 0,
		 [ [ 0, $self->{'text_hash'}->{'umass_leave'} ],
		   [ 1, $self->{'text_hash'}->{'umass_unlimited'} ],
		   [ 2, $self->{'text_hash'}->{'umass_set'}." ".
			($t =~ /blocks$/ ? $self->quota_inputbox($t, "", $self->{'bsize'})
					 : $self->ui_textbox($t, "", 10)) ] ]));
	}

print $self->ui_table_end();
print $self->ui_form_end([ [ "ok", $self->{'text_hash'}->{'gmass_ok'} ] ]);

$self->ui_print_footer("list_groups.cgi?dir=".$self->urlize($self->{'fs'}), $self->{'text_hash'}->{'egroup_greturn'});

1;
		
}


1;

