#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_user_quota.cgi
# Display a form for editing the quotas for a user on some filesystem

&ModuleLoader::preload_module('quota_class', "quota::QuotaLib");
$self = new quota::QuotaLib:: 'quota_class',%$self;

$self->ReadParse();
$self->{'u'} = $self->{'in_hash'}->{'user'}; $self->{'fs'} = $self->{'in_hash'}->{'filesys'};
$self->can_edit_user($self->{'u'}) ||
	$self->error($self->text('euser_eallowus', $self->{'u'}));
$self->{'access_hash'}->{'ro'} && $self->error($self->text('euser_eallowus', $self->{'u'}));
$self->can_edit_filesys($self->{'fs'}) ||
	$self->error($self->{'text_hash'}->{'euser_eallowfs'});
$self->ui_print_header(undef, $self->{'text_hash'}->{'euser_title'}, "", "edit_user_quota");

@{$self->{'quot_array'}} = $self->user_quota($self->{'u'}, $self->{'fs'});
$self->{'first'} = (@{$self->{'quot_array'}} == 0);
$self->{'bsize'} = $self->block_size($self->{'fs'});
$self->{'fsbsize'} = $self->block_size($self->{'fs'}, 1);

print "<table border width=100%>\n";
print "<form action=save_user_quota.cgi>\n";
print "<input type=hidden name=user value=\"$self->{'u'}\">\n";
print "<input type=hidden name=filesys value=\"$self->{'fs'}\">\n";
print "<input type=hidden name=source value=$self->{'in_hash'}->{'source'}>\n";
print "<tr $self->{'tb'}> <td colspan=2><b>",$self->text('euser_quotas', $self->html_escape($self->{'u'}), $self->{'fs'}),"</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td width=50%><table width=100%>\n";

if (!$self->{'first'}) {
	if ($self->{'bsize'}) {
		print "<tr> <td><b>$self->{'text_hash'}->{'euser_kused'}</b></td> ",
		      "<td>",$self->nice_size($self->{'quot_array'}->[0]*$self->{'bsize'}),"</td> </tr>\n",
		}
	else {
		print "<tr> <td><b>$self->{'text_hash'}->{'euser_bused'}</b></td> ",
		      "<td>$self->{'quot_array'}->[0]</td> </tr>\n",
		}
	}
print "<tr> <td><b>",$self->{'bsize'} ? $self->{'text_hash'}->{'euser_sklimit'} :
			      $self->{'text_hash'}->{'euser_sblimit'},"</b></td>\n";
$self->quota_input("sblocks", $self->{'quot_array'}->[1], $self->{'bsize'});
print "<tr> <td><b>",$self->{'bsize'} ? $self->{'text_hash'}->{'euser_hklimit'} :
			      $self->{'text_hash'}->{'euser_hblimit'},"</b></td>\n";
$self->quota_input("hblocks", $self->{'quot_array'}->[2], $self->{'bsize'});
if ($self->{'access_hash'}->{'diskspace'}) {
	($self->{'binfo'}, $self->{'finfo'}) = $self->filesystem_info($self->{'fs'}, undef, undef, $self->{'fsbsize'});
	print "<tr> <td><b>",$self->{'bsize'} ? $self->{'text_hash'}->{'euser_sdisk'} :
				      $self->{'text_hash'}->{'euser_bdisk'},"</b></td>\n";
	print "<td>$self->{'binfo'}</td> </tr>\n";
	}

print "</table></td><td width=50%><table width=100%>\n";
if (!$self->{'first'}) {
	print "<tr> <td><b>$self->{'text_hash'}->{'euser_fused'}</b></td> <td>$self->{'quot_array'}->[3]</td> </tr>\n",
	}
print "<tr> <td><b>$self->{'text_hash'}->{'euser_sflimit'}</b></td>\n";
$self->quota_input("sfiles", $self->{'quot_array'}->[4]);
print "<tr> <td><b>$self->{'text_hash'}->{'euser_hflimit'}</b></td>\n";
$self->quota_input("hfiles", $self->{'quot_array'}->[5]);
if ($self->{'access_hash'}->{'diskspace'}) {
	print "<tr> <td><b>$self->{'text_hash'}->{'euser_fdisk'}</b></td>\n";
	print "<td>$self->{'finfo'}</td> </tr>\n";
	}

print "</table></td></tr></table>\n";

print "<table width=100%><tr>\n";
print "<td><input type=submit value=$self->{'text_hash'}->{'euser_update'}></td>\n";
print "</form><form action=user_filesys.cgi>\n";
print "<input type=hidden name=user value=\"$self->{'u'}\">\n";
print "<td align=right><input type=submit value=\"$self->{'text_hash'}->{'euser_listall'}\"></td>\n";
print "</form></tr></table>\n";

if ($self->{'in_hash'}->{'source'}) {
	$self->ui_print_footer("user_filesys.cgi?user=".$self->urlize($self->{'u'}), $self->{'text_hash'}->{'euser_freturn'});
	}
else {
	$self->ui_print_footer("list_users.cgi?dir=".$self->urlize($self->{'fs'}), $self->{'text_hash'}->{'euser_ureturn'});
	}

1;
		
}


1;

