#!/usr/bin/perl

&MAIN();

 sub MAIN {
# index.cgi
# Display a list of all local filesystems, and allow editing of quotas
# on those which have quotas turned on. The actual turning on of quotas must
# be done in the mount module first.

&ModuleLoader::preload_module('quota_class', "quota::QuotaLib");
$self = new quota::QuotaLib:: 'quota_class',%$self;

$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", "intro", 1, 1, 0,
	$self->help_search_link("quota", "man", "howto"));

$self->{'err'} = $self->quotas_init();
if ($self->{'err'}) {
	print "<p><b>$self->{'err'}</b><p>\n";
	$self->ui_print_footer("/", $self->{'text_hash'}->{'index_return'});
	exit;
	}

@{$self->{'list_array'}} = $self->list_filesystems();
if (@{$self->{'list_array'}}) {
	print $self->ui_columns_start([
		$self->{'text_hash'}->{'index_fs'},
		$self->{'text_hash'}->{'index_type'},
		$self->{'text_hash'}->{'index_mount'},
		$self->{'text_hash'}->{'index_status'},
		$self->{'access_hash'}->{'enable'} ? ( $self->{'text_hash'}->{'index_action'} ) : (),
		], 100);
	@{$self->{'tds_array'}} = ( "", "valign=top", "valign=top", "valign=top", "valign=top" );
	foreach $f (@{$self->{'list_array'}}) {
		$self->{'qc'} = $f->[4];
		$self->{'qc'} = $self->{'qc'}&1 if ($self->{'access_hash'}->{'gmode'} == 3);
		next if (!$self->{'qc'});
		next if (!$self->can_edit_filesys($f->[0]));
		$self->{'qn'} = $f->[5];
		if ($self->{'qc'} == 1) { $self->{'msg'} = $self->{'text_hash'}->{'index_quser'}; }
		elsif ($self->{'qc'} == 2) { $self->{'msg'} = $self->{'text_hash'}->{'index_qgroup'}; }
		elsif ($self->{'qc'} == 3) { $self->{'msg'} = $self->{'text_hash'}->{'index_qboth'}; }
		$self->{'canactivate'} = 1;
		if ($self->{'qn'} >= 4) {
			$self->{'chg'} = $self->{'text_hash'}->{'index_mountonly'};
			$self->{'qn'} -= 4;
			$self->{'canactivate'} = 0;
			if ($self->{'qn'}) {
				$self->{'msg'} .= " $self->{'text_hash'}->{'index_active'}";
				}
			else {
				$self->{'msg'} .= " $self->{'text_hash'}->{'index_inactive'}";
				}
			}
		elsif ($self->{'qn'}) {
			$self->{'msg'} .= " $self->{'text_hash'}->{'index_active'}";
			$self->{'chg'} = $self->{'text_hash'}->{'index_disable'};
			}
		else {
			$self->{'msg'} .= " $self->{'text_hash'}->{'index_inactive'}";
			$self->{'chg'} = $self->{'text_hash'}->{'index_enable'};
			}
		if ($self->{'qn'}%2 == 1) { $self->{'useractive'}++; }
		if ($self->{'qn'} > 1) { $self->{'groupactive'}++; }

		local @cols;
		$self->{'dir'} = $f->[0];
		if (!$self->{'qn'}) {
			push(@cols, $self->{'dir'});
			}
		elsif ($self->{'qc'} == 1) {
			push(@cols, "<a href=\"list_users.cgi?dir=".
			   $self->urlize($self->{'dir'})."&can=",$self->urlize($self->{'qc'}),"\">$self->{'dir'}</a>");
			}
		elsif ($self->{'qc'} == 2) {
			push(@cols, "<a href=\"list_groups.cgi?dir=".
			    $self->urlize($self->{'dir'})."&can=",$self->urlize($self->{'qc'}),"\">$self->{'dir'}</a>");
			}
		elsif ($self->{'qc'} == 3) {
			push(@cols, "<a href=\"list_users.cgi?dir=".
			    $self->urlize($self->{'dir'})."&can=".$self->urlize($self->{'qc'}).
			    "\">$self->{'dir'} (users)</a><br>".
			    "<a href=\"list_groups.cgi?dir=".$self->urlize($self->{'dir'}).
			    "&can=".$self->urlize($self->{'qc'})."\">$self->{'dir'} (groups)</a>");
			}

		push(@cols, $self->foreign_call("mount", "fstype_name", $f->[2]));
		push(@cols, $self->foreign_call("mount", "device_name", $f->[1]));
		push(@cols, $self->{'msg'});
		if ($self->{'access_hash'}->{'enable'}) {
			if ($self->{'canactivate'}) {
				push(@cols, "<a href=\"activate.cgi?dir=$self->{'dir'}&active=$self->{'qn'}&mode=$self->{'qc'}\">$self->{'chg'}</a>");
				}
			else {
				push(@cols, $self->{'chg'});
				}
			}
		print $self->ui_columns_row(\@cols, \@{$self->{'tds_array'}});
		}
	print $self->ui_columns_end();
	}
else {
	print "<b>$self->{'text_hash'}->{'index_nosupport'}</b><p>\n";
	if ($self->foreign_available("mount")) {
		print $self->text('index_mountmod', "../mount/"),"<p>\n";
		}
	}

if ($self->{'useractive'} || $self->{'groupactive'}) {
	print "<table width=100%><tr>\n";
	}
if ($self->{'useractive'}) {
	print "<form action=user_filesys.cgi>\n";
	print "<td><input type=submit value=\"$self->{'text_hash'}->{'index_euser'}\">\n";
	print "<input name=user size=8> ",
	      $self->user_chooser_button("user", 0),"</td></form>\n";
	}
else { print "<td></td>\n"; }

if ($self->{'groupactive'}) {
	print "<form action=group_filesys.cgi>\n";
	print "<td align=right>\n";
	print "<input type=submit value=\"$self->{'text_hash'}->{'index_egroup'}\">\n";
	print "<input name=group size=8> ",
	      $self->group_chooser_button("group", 0, $self->{'useractive'} ? 1 : 0),
	      "</td></form>\n";
	}
else { print "<td></td>\n"; }
if ($self->{'useractive'} || $self->{'groupactive'}) {
	print "</tr></table>\n";
	}

$self->ui_print_footer("/", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

