#!/usr/bin/perl

&MAIN();

 sub MAIN {
# list_users.cgi
# Lists all the users with quotas on some filesystem

&ModuleLoader::preload_module('quota_class', "quota::QuotaLib");
$self = new quota::QuotaLib:: 'quota_class',%$self;

$self->ReadParse();
$self->{'f'} = $self->{'in_hash'}->{'dir'};
$self->{'whatfailed'} = $self->{'text_hash'}->{'lusers_failed'};
$self->can_edit_filesys($self->{'f'}) ||
	$self->error($self->{'text_hash'}->{'lusers_eallow'});
$self->{'form'} = 0;

# List quotas
$self->ui_print_header(undef, $self->{'text_hash'}->{'lusers_title'}, "", "list_users");

$self->{'n'} = $self->filesystem_users($self->{'f'});
$self->{'bsize'} = $self->block_size($self->{'f'});
$self->{'fsbsize'} = $self->block_size($self->{'f'}, 1);
if ($self->{'n'} > $self->{'config_hash'}->{'display_max'} && !$self->{'access_hash'}->{'ro'}) {
	print "<b>", $self->text('lusers_toomany', $self->{'f'}), "</b><br>\n";
	}
elsif ($self->{'n'}) {
	# no threshold (default) if <= 0% and >=101%
	local $threshold_pc = $self->{'config_hash'}->{'threshold_pc'} || 101;
	$threshold_pc = 101 if $threshold_pc < 1 or $threshold_pc > 101;
	print $self->ui_subheading($self->text('lusers_qoutas', $self->{'f'}));
	&show_buttons();
	if (!$self->{'access_hash'}->{'ro'}) {
		print $self->ui_form_start("edit_user_mass.cgi", "post");
		print $self->ui_hidden('dir', $self->{'f'}),"\n";
		}

	# Generate select links
	@{$self->{'links_array'}} = ( $self->select_all_link("d", $self->{'form'}),
		   $self->select_invert_link("d", $self->{'form'}) );
	if (!$self->{'access_hash'}->{'ro'}) {
		print $self->ui_links_row(\@{$self->{'links_array'}});
		}

	# Generate first header (with blocks and files)
	local @hcols;
	local @tds;
	if (!$self->{'access_hash'}->{'ro'}) {
		push(@hcols, "");
		push(@tds, "width=5");
		}
	push(@hcols, "");
	push(@tds, "");
	($self->{'binfo'}, $self->{'finfo'}) = $self->filesystem_info($self->{'f'}, \%{$self->{'user_hash'}}, $self->{'n'}, $self->{'fsbsize'});
	$self->{'cols1'} = 3 + ($threshold_pc != 101 ? 1 : 0) +
		     ($self->{'config_hash'}->{'show_grace'} ? 1 : 0);
	$self->{'cols2'} = 3 + ($self->{'config_hash'}->{'show_grace'} ? 1 : 0);
	push(@hcols, ($self->{'bsize'} ? $self->{'text_hash'}->{'lusers_space'} :
			      $self->{'text_hash'}->{'lusers_blocks'}).
		    ($self->{'access_hash'}->{'diskspace'} ? " ($self->{'binfo'})" : ""));
	push(@tds, "colspan=$self->{'cols1'} align=center");
	push(@hcols, $self->{'text_hash'}->{'lusers_files'}.
		    ($self->{'access_hash'}->{'diskspace'} ? " ($self->{'finfo'})" : ""));
	push(@tds, "colspan=$self->{'cols2'} align=center");
	print $self->ui_columns_start(\@hcols, 100, 0, \@tds);

	# Generate second header (with used/soft/hard)
	local @hcols;
	local @tds;
	if (!$self->{'access_hash'}->{'ro'}) {
		push(@hcols, "");
		push(@tds, "width=5");
		}
	push(@hcols, $self->{'text_hash'}->{'lusers_user'});
	if ($threshold_pc != 101) {
		push(@hcols, $self->{'text_hash'}->{'lusers_pc_hblocks'});
		}
	push(@hcols, $self->{'text_hash'}->{'lusers_used'}, $self->{'text_hash'}->{'lusers_soft'},
		    $self->{'text_hash'}->{'lusers_hard'},
		    $self->{'config_hash'}->{'show_grace'} ? ( $self->{'text_hash'}->{'lusers_grace'} ) : ( ));
	push(@hcols, $self->{'text_hash'}->{'lusers_used'}, $self->{'text_hash'}->{'lusers_soft'},
		    $self->{'text_hash'}->{'lusers_hard'},
		    $self->{'config_hash'}->{'show_grace'} ? ( $self->{'text_hash'}->{'lusers_grace'} ) : ( ));
	print $self->ui_columns_header(\@hcols, \@tds);

	# Sort users
	@{$self->{'order_array'}} = (0 .. $self->{'n'}-1);
	if ($self->{'config_hash'}->{'sort_mode'} == 0) {
		@{$self->{'order_array'}} = sort { $self->{'user_hash'}->{$b,'ublocks'} <=> $self->{'user_hash'}->{$a,'ublocks'} }
			      @{$self->{'order_array'}};
		}
	elsif ($self->{'config_hash'}->{'sort_mode'} == 3) {
		@{$self->{'order_array'}} = sort { $self->{'user_hash'}->{$b,'hblocks'} <=> $self->{'user_hash'}->{$a,'hblocks'} }
			      @{$self->{'order_array'}};
		}
	elsif ($self->{'config_hash'}->{'sort_mode'} == 4) {
		@{$self->{'order_array'}} = sort { $self->{'user_hash'}->{$b,'sblocks'} <=> $self->{'user_hash'}->{$a,'sblocks'} }
			      @{$self->{'order_array'}};
		}
	elsif ($self->{'config_hash'}->{'sort_mode'} == 2) {
		@{$self->{'order_array'}} = sort { $self->{'user_hash'}->{$a,'user'} cmp $self->{'user_hash'}->{$b,'user'} }
			      @{$self->{'order_array'}};
		}
	elsif ($self->{'config_hash'}->{'sort_mode'} == 5) {
		@{$self->{'order_array'}} = sort { &to_percent($self->{'user_hash'}->{$b,'ublocks'},
					    $self->{'user_hash'}->{$b,'hblocks'}) <=>
				&to_percent($self->{'user_hash'}->{$a,'ublocks'},
					    $self->{'user_hash'}->{$a,'hblocks'}) }
			      @{$self->{'order_array'}};
		}

	# Generate table of users
	foreach $i (@{$self->{'order_array'}}) {
		next if (!$self->can_edit_user($self->{'user_hash'}->{$i,'user'}));
		local @cols;
		if ($self->{'access_hash'}->{'ro'}) {
			push(@cols, $self->{'user_hash'}->{$i,'user'});
			}
		else {
			push(@cols, "<a href=\"edit_user_quota.cgi?user=".
				$self->urlize($self->{'user_hash'}->{$i,'user'})."&filesys=".
				$self->urlize($self->{'f'})."&source=0\">$self->{'user_hash'}->{$i,'user'}".
				"</a>");
			}
                local $pc_hblocks=0;
                if($self->{'user_hash'}->{$i,'hblocks'}) {
                        $pc_hblocks = 100 * $self->{'user_hash'}->{$i,'ublocks'};
                        $pc_hblocks/= $self->{'user_hash'}->{$i,'hblocks'};
                        $pc_hblocks = int($pc_hblocks);
			}
		if ($threshold_pc != 101) {
			if ($pc_hblocks > $threshold_pc) {
				push(@cols, "<font color=#ff0000>".
					$self->html_escape($pc_hblocks)."%</font>");
				}
			else {
				push(@cols, $self->html_escape($pc_hblocks)."%");
				}
			}
		local $ublocks = $self->{'user_hash'}->{$i,'ublocks'}; 
		if ($self->{'bsize'}) {
			$ublocks = $self->nice_size($ublocks*$self->{'bsize'});
			}
		if ($self->{'user_hash'}->{$i,'hblocks'} &&
		    $self->{'user_hash'}->{$i,'ublocks'} > $self->{'user_hash'}->{$i,'hblocks'}) {
			push(@cols, "<font color=#ff0000>".
				$self->html_escape($ublocks)."</font>");
			}
		elsif ($self->{'user_hash'}->{$i,'sblocks'} &&
		       $self->{'user_hash'}->{$i,'ublocks'} > $self->{'user_hash'}->{$i,'sblocks'}) {
			push(@cols, "<font color=#ff7700>".
				$self->html_escape($ublocks)."</font>");
			}
		else {
			push(@cols, $self->html_escape($ublocks));
			}
		push(@cols, $self->nice_limit($self->{'user_hash'}->{$i,'sblocks'}, $self->{'bsize'}));
		push(@cols, $self->nice_limit($self->{'user_hash'}->{$i,'hblocks'}, $self->{'bsize'}));
		push(@cols, $self->{'user_hash'}->{$i,'gblocks'}) if ($self->{'config_hash'}->{'show_grace'});
		push(@cols, $self->{'user_hash'}->{$i,'ufiles'});
		push(@cols, $self->nice_limit($self->{'user_hash'}->{$i,'sfiles'}, $self->{'bsize'}, 1));
		push(@cols, $self->nice_limit($self->{'user_hash'}->{$i,'hfiles'}, $self->{'bsize'}, 1));
		push(@cols, $self->{'user_hash'}->{$i,'gfiles'}) if ($self->{'config_hash'}->{'show_grace'});
		if ($self->{'access_hash'}->{'ro'}) {
			print $self->ui_columns_row(\@cols, \@tds);
			}
		else {
			print $self->ui_checked_columns_row(\@cols, \@tds, "d",
						      $self->{'user_hash'}->{$i,'user'});
			}
		}
	print $self->ui_columns_end();
	if (!$self->{'access_hash'}->{'ro'}) {
		print $self->ui_links_row(\@{$self->{'links_array'}});
		print $self->ui_submit($self->{'text_hash'}->{'lusers_mass'}, "mass"),"<br>\n";
		print $self->ui_form_end();
		}
	}
else {
	print "<b>",$self->text('lusers_noquota', $self->{'f'}),"</b><br>\n";
	}
&show_buttons();

# Show form for setting default quotas for new users
if ($self->{'access_hash'}->{'default'}) {
	print "<hr>\n";
	print $self->text('lusers_info', $self->{'text_hash'}->{'lusers_useradmin'});
	print "<p>\n";

	@{$self->{'dquot_array'}} = split(/\s+/, $self->{'config_hash'}->{"sync_$self->{'f'}"});
	print "<form action=save_sync.cgi>\n";
	print "<input type=hidden name=filesys value=\"$self->{'f'}\">\n";
	print "<table width=100% border> <tr $self->{'tb'}>\n";
	print "<td colspan=2><b>$self->{'text_hash'}->{'lusers_newuser'}</b></td> </tr> <tr $self->{'cb'}>\n";

	print "<td width=50%><table><tr>\n";
	print "<td><b>$self->{'text_hash'}->{'lusers_sblimit'}</b></td> <td>\n";
	$self->quota_input("sblocks", $self->{'dquot_array'}->[0], $self->{'bsize'});
	print "</td> </tr><tr> <td><b>$self->{'text_hash'}->{'lusers_hblimit'}</b></td> <td>\n";
	$self->quota_input("hblocks", $self->{'dquot_array'}->[1], $self->{'bsize'});
	print "</td> </tr></table></td>\n";

	print "<td width=50%><table><tr>\n";
	print "<td><b>$self->{'text_hash'}->{'lusers_sflimit'}</b></td> <td>\n";
	$self->quota_input("sfiles", $self->{'dquot_array'}->[2]);
	print "</td> </tr><tr> <td><b>$self->{'text_hash'}->{'lusers_hflimit'}</b></td> <td>\n";
	$self->quota_input("hfiles", $self->{'dquot_array'}->[3]);
	print "</td> </tr></table></td>\n";
	print "</tr> </table>\n";
	print "<input type=submit value=$self->{'text_hash'}->{'lusers_apply'}></form>\n";
	}

# Show form for email notifications
if ($self->{'access_hash'}->{'email'} && $self->foreign_check("cron") &&
    $self->foreign_check("mailboxes")) {
	print "<hr>\n";
	print $self->ui_form_start("save_email.cgi");
	print $self->ui_hidden("filesys", $self->{'f'});
	print $self->ui_table_start($self->{'text_hash'}->{'lusers_emailheader'}, "width=100%", 4);

	print $self->ui_table_row($self->{'text_hash'}->{'lusers_email'},
		    $self->ui_radio("email", $self->{'config_hash'}->{"email_$self->{'f'}"} ? 1 : 0,
			      [ [ 1, $self->{'text_hash'}->{'yes'} ], [ 0, $self->{'text_hash'}->{'no'} ] ]));

	print $self->ui_table_row($self->{'text_hash'}->{'lusers_interval'},
		    $self->ui_textbox("interval", $self->{'config_hash'}->{"email_interval_$self->{'f'}"}, 5).
		    " ".$self->{'text_hash'}->{'lusers_hours'});

	print $self->ui_table_row($self->{'text_hash'}->{'lusers_ltype'},
		    $self->ui_radio("type", $self->{'config_hash'}->{"email_type_$self->{'f'}"} ? 1 : 0,
			      [ [ 1, $self->{'text_hash'}->{'lusers_hard'} ],
				[ 0, $self->{'text_hash'}->{'lusers_soft'} ] ]));

	print $self->ui_table_row($self->{'text_hash'}->{'lusers_percent'},
		    $self->ui_textbox("percent", $self->{'config_hash'}->{"email_percent_$self->{'f'}"}, 5).
		    " %");

	print $self->ui_table_row($self->{'text_hash'}->{'lusers_domain'},
		    $self->ui_textbox("domain", $self->{'config_hash'}->{"email_domain_$self->{'f'}"} ||
					  $self->get_system_hostname(), 20)."<br>".
		    $self->ui_checkbox("virtualmin", 1, $self->{'text_hash'}->{'luser_virtualmin'},
				 $self->{'config_hash'}->{"email_virtualmin_$self->{'f'}"}));

	print $self->ui_table_row($self->{'text_hash'}->{'lusers_from'},
		    $self->ui_textbox("from", $self->{'config_hash'}->{"email_from_$self->{'f'}"} ||
					 'cpplus@'.$self->get_system_hostname(), 20));

	print $self->ui_table_end();
	print $self->ui_form_end([ [ 'save', $self->{'text_hash'}->{'lusers_apply'} ] ]);
	}

$self->ui_print_footer("", $self->{'text_hash'}->{'lusers_return'});

1;
		
}

# show_buttons(form)
sub show_buttons
{
	shift if ($self == $_[0]);

print "<table width=100%><tr>\n";
if (!$self->{'access_hash'}->{'ro'}) {
	print "<form action=edit_user_quota.cgi>\n";
	print "<input type=hidden name=filesys value=\"$self->{'f'}\">\n";
	print "<input type=hidden name=source value=0>\n";
	print "<td align=left width=33%>\n";
	print "<input type=submit value=\"$self->{'text_hash'}->{'lusers_equota'}\">\n";
	print "<input name=user size=8> ",
	      $self->user_chooser_button("user", 0, $self->{'form'}),"</td></form>\n";
	$self->{'form'}++;
	}
else { print "<td width=33%></td>\n"; }

if ($self->{'access_hash'}->{'ugrace'}) {
	print "<form action=user_grace_form.cgi>\n";
	print "<input type=hidden name=filesys value=\"$self->{'f'}\">\n";
	print "<td align=center width=33%>\n";
	print "<input type=submit value=\"$self->{'text_hash'}->{'lusers_egrace'}\">\n";
	print "</td></form>\n";
	$self->{'form'}++;
	}
else { print "<td width=33%></td>\n"; }

print "<form action=check_quotas.cgi>\n";
print "<input type=hidden name=filesys value=\"$self->{'f'}\">\n";
print "<input type=hidden name=source value=user>\n";
print "<td align=right width=33%><input type=submit value=\"$self->{'text_hash'}->{'lusers_check'}\">\n";
print "</td></form> </tr></table>\n";
$self->{'form'}++;
}


1;

