#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_email.cgi
# Save scheduled email settings

&ModuleLoader::preload_module('quota_class', "quota::QuotaLib");
$self = new quota::QuotaLib:: 'quota_class',%$self;

$self->{'access_hash'}->{'email'} && $self->can_edit_filesys($self->{'in_hash'}->{'filesys'}) ||
	$self->error($self->{'text_hash'}->{'email_ecannot'});
$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'email_err'});

# Validate inputs
if ($self->{'in_hash'}->{'email'}) {
	$self->{'in_hash'}->{'interval'} =~ /^[0-9\.]+$/ || $self->error($self->{'text_hash'}->{'email_einterval'});
	$self->{'in_hash'}->{'percent'} =~ /^[0-9\.]+$/ || $self->error($self->{'text_hash'}->{'email_epercent'});
	$self->{'in_hash'}->{'domain'} =~ /^[a-z0-9\.\-]+$/i || $self->error($self->{'text_hash'}->{'email_edomain'});
	$self->{'in_hash'}->{'from'} =~ /^\S+$/i || $self->error($self->{'text_hash'}->{'email_efrom'});
	}

# Save settings
$self->lock_file($self->{'module_config_file'});
$self->{'config_hash'}->{"email_".$self->{'in_hash'}->{'filesys'}} = $self->{'in_hash'}->{'email'};
$self->{'config_hash'}->{"email_interval_".$self->{'in_hash'}->{'filesys'}} = $self->{'in_hash'}->{'interval'};
$self->{'config_hash'}->{"email_type_".$self->{'in_hash'}->{'filesys'}} = $self->{'in_hash'}->{'type'};
$self->{'config_hash'}->{"email_percent_".$self->{'in_hash'}->{'filesys'}} = $self->{'in_hash'}->{'percent'};
$self->{'config_hash'}->{"email_domain_".$self->{'in_hash'}->{'filesys'}} = $self->{'in_hash'}->{'domain'};
$self->{'config_hash'}->{"email_virtualmin_".$self->{'in_hash'}->{'filesys'}} = $self->{'in_hash'}->{'virtualmin'};
$self->{'config_hash'}->{"email_from_".$self->{'in_hash'}->{'filesys'}} = $self->{'in_hash'}->{'from'};
$self->save_module_config();
$self->unlock_file($self->{'module_config_file'});

# Create cron job, if needed
if ($self->{'in_hash'}->{'email'}) {
	$self->create_email_job();
	}

$self->webmin_log("email", "user", $self->{'in_hash'}->{'filesys'}, \%{$self->{'in_hash'}});
$self->redirect("list_users.cgi?dir=".$self->urlize($self->{'in_hash'}->{'filesys'}));

1;
		
}


1;

