#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Save scheduled email settings for groups

&ModuleLoader::preload_module('quota_class', "quota::QuotaLib");
$self = new quota::QuotaLib:: 'quota_class',%$self;

$self->{'access_hash'}->{'email'} && $self->can_edit_filesys($self->{'in_hash'}->{'filesys'}) ||
	$self->error($self->{'text_hash'}->{'email_ecannot'});
$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'email_err'});

# Validate inputs
if ($self->{'in_hash'}->{'email'}) {
	$self->{'in_hash'}->{'interval'} =~ /^[0-9\.]+$/ || $self->error($self->{'text_hash'}->{'email_einterval'});
	$self->{'in_hash'}->{'percent'} =~ /^[0-9\.]+$/ || $self->error($self->{'text_hash'}->{'email_epercent'});
	$self->{'in_hash'}->{'from'} =~ /^\S+$/i || $self->error($self->{'text_hash'}->{'email_efrom'});
	$self->{'in_hash'}->{'tomode'} != 1 || $self->{'in_hash'}->{'to'} =~ /^\S+$/ ||
		$self->error($self->{'text_hash'}->{'email_eto'});
	}

# Save settings
$self->lock_file($self->{'module_config_file'});
$self->{'config_hash'}->{"gemail_".$self->{'in_hash'}->{'filesys'}} = $self->{'in_hash'}->{'email'};
$self->{'config_hash'}->{"gemail_interval_".$self->{'in_hash'}->{'filesys'}} = $self->{'in_hash'}->{'interval'};
$self->{'config_hash'}->{"gemail_type_".$self->{'in_hash'}->{'filesys'}} = $self->{'in_hash'}->{'type'};
$self->{'config_hash'}->{"gemail_percent_".$self->{'in_hash'}->{'filesys'}} = $self->{'in_hash'}->{'percent'};
$self->{'config_hash'}->{"gemail_from_".$self->{'in_hash'}->{'filesys'}} = $self->{'in_hash'}->{'from'};
$self->{'config_hash'}->{"gemail_to_".$self->{'in_hash'}->{'filesys'}} = $self->{'in_hash'}->{'to'};
$self->{'config_hash'}->{"gemail_tomode_".$self->{'in_hash'}->{'filesys'}} = $self->{'in_hash'}->{'tomode'};
$self->save_module_config();
$self->unlock_file($self->{'module_config_file'});

# Create cron job, if needed
if ($self->{'in_hash'}->{'email'}) {
	$self->create_email_job();
	}

$self->webmin_log("email", "group", $self->{'in_hash'}->{'filesys'}, \%{$self->{'in_hash'}});
$self->redirect("list_groups.cgi?dir=".$self->urlize($self->{'in_hash'}->{'filesys'}));

1;
		
}


1;

