#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Actually update the users

&ModuleLoader::preload_module('quota_class', "quota::QuotaLib");
$self = new quota::QuotaLib:: 'quota_class',%$self;

$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'umass_err'});
$self->{'fs'} = $self->{'in_hash'}->{'dir'};
@{$self->{'d_array'}} = split(/\0/, $self->{'in_hash'}->{'d'});
foreach $u (@{$self->{'d_array'}}) {
	$self->can_edit_user($u) ||
		$self->error($self->text('euser_eallowus', $u));
	}
$self->{'access_hash'}->{'ro'} && $self->error($self->text('euser_eallowus', $u));
$self->can_edit_filesys($self->{'fs'}) ||
	$self->error($self->{'text_hash'}->{'euser_eallowfs'});

# Validate inputs
foreach $t ('sblocks', 'hblocks', 'sfiles', 'hfiles') {
	$self->{'in_hash'}->{$t."_def"} != 2 || $self->{'in_hash'}->{$t} =~ /^\d+$/ ||
		$self->error($self->{'text_hash'}->{'umass_e'.$t});
	}

# Update the users
$self->{'bsize'} = $self->block_size($self->{'fs'});
$self->{'n'} = $self->filesystem_users($self->{'fs'});
foreach $u (@{$self->{'d_array'}}) {
	# Find the user
	@{$self->{'uinfo_array'}} = ( );
	for($i=0; $i<$self->{'n'}; $i++) {
		if ($self->{'user_hash'}->{$i,'user'} eq $u) {
			@{$self->{'uinfo_array'}} = ( $self->{'user_hash'}->{$i,'sblocks'}, $self->{'user_hash'}->{$i,'hblocks'},
				   $self->{'user_hash'}->{$i,'sfiles'},  $self->{'user_hash'}->{$i,'hfiles'} );
			last;
			}
		}

	# Update his object
	if (@{$self->{'uinfo_array'}}) {
		if ($self->{'in_hash'}->{'sblocks_def'} == 1) {
			$self->{'uinfo_array'}->[0] = 0;
			}
		elsif ($self->{'in_hash'}->{'sblocks_def'} == 2) {
			$self->{'uinfo_array'}->[0] = $self->quota_parse('sblocks', $self->{'bsize'}, 1);
			}
		if ($self->{'in_hash'}->{'hblocks_def'} == 1) {
			$self->{'uinfo_array'}->[1] = 0;
			}
		elsif ($self->{'in_hash'}->{'hblocks_def'} == 2) {
			$self->{'uinfo_array'}->[1] = $self->quota_parse('hblocks', $self->{'bsize'}, 1);
			}
		if ($self->{'in_hash'}->{'sfiles_def'} == 1) {
			$self->{'uinfo_array'}->[2] = 0;
			}
		elsif ($self->{'in_hash'}->{'sfiles_def'} == 2) {
			$self->{'uinfo_array'}->[2] = $self->{'in_hash'}->{'sfiles'};
			}
		if ($self->{'in_hash'}->{'hfiles_def'} == 1) {
			$self->{'uinfo_array'}->[3] = 0;
			}
		elsif ($self->{'in_hash'}->{'hfiles_def'} == 2) {
			$self->{'uinfo_array'}->[3] = $self->{'in_hash'}->{'hfiles'};
			}

		# Update the user
		$self->edit_user_quota($u, $self->{'fs'}, @{$self->{'uinfo_array'}});
		}
	}

$self->redirect("list_users.cgi?dir=".$self->urlize($self->{'fs'}));

1;
		
}


1;

