#!/usr/bin/perl

&MAIN();

 sub MAIN {
# user_filesys.cgi
# List all filesystems for which some user has quotas

&ModuleLoader::preload_module('quota_class', "quota::QuotaLib");
$self = new quota::QuotaLib:: 'quota_class',%$self;

$self->ReadParse();
$self->{'u'} = $self->{'in_hash'}->{'user'};
$self->can_edit_user($self->{'u'}) ||
	$self->error($self->text('ufilesys_ecannot', $self->{'u'}));
$self->ui_print_header(undef, $self->{'text_hash'}->{'ufilesys_title'}, "", "user_filesys");

foreach $f ($self->list_filesystems()) {
	if ($f->[4]%2 && $f->[5] && $self->can_edit_filesys($f->[0])) {
		push(@{$self->{'fslist_array'}}, $f->[0]);
		$self->{'fslist_hash'}->{$f->[0]}++;
		}
	}

# Make sure all block sizes are the same
$self->{'n'} = $self->user_filesystems($self->{'u'});
for($i=0; $i<$self->{'n'}; $i++) {
	$self->{'bsize'} = $self->block_size($self->{'filesys_hash'}->{$i,'filesys'});
	if ($self->{'last_bsize'} && $self->{'last_bsize'} != $self->{'bsize'}) {
		$self->{'variable_bsize'}++;
		}
	}

if ($self->{'n'}) {
	print $self->ui_subheading($self->text('ufilesys_all', $self->html_escape($self->{'u'})));

	# Generate top header (showing blocks/files)
	@{$self->{'hcols_array'}} = ( undef, $self->{'variable_bsize'} ? $self->{'text_hash'}->{'ufilesys_blocks'}
					  : $self->{'text_hash'}->{'ufilesys_space'},
		   $self->{'text_hash'}->{'ufilesys_files'});
	print $self->ui_columns_start(\@{$self->{'hcols_array'}}, 100, 0,
		[ undef, "colspan=3 align=center", "colspan=3 align=center" ]);

	# Generate second header
	@{$self->{'hcols_array'}} = ( $self->{'text_hash'}->{'ufilesys_fs'}, $self->{'text_hash'}->{'ufilesys_used'},
		   $self->{'text_hash'}->{'ufilesys_soft'}, $self->{'text_hash'}->{'ufilesys_hard'},
		   $self->{'config_hash'}->{'show_grace'} ? ( $self->{'text_hash'}->{'ufilesys_grace'} ) : ( ),
		   $self->{'text_hash'}->{'ufilesys_used'},
		   $self->{'text_hash'}->{'ufilesys_soft'}, $self->{'text_hash'}->{'ufilesys_hard'},
		   $self->{'config_hash'}->{'show_grace'} ? ( $self->{'text_hash'}->{'ufilesys_grace'} ) : ( ),
		 );
	print $self->ui_columns_header(\@{$self->{'hcols_array'}});

	# Generate one row per filesystem the user has quota on
	for($i=0; $i<$self->{'n'}; $i++) {
		$f = $self->{'filesys_hash'}->{$i,'filesys'};
		$self->{'bsize'} = $self->block_size($f);
		local @cols;
		if ($self->{'fslist_hash'}->{$f} && !$self->{'access_hash'}->{'ro'}) {
			push(@cols, "<a href=\"edit_user_quota.cgi?filesys=$f&user=$self->{'u'}&source=1\">$f</a>");
			}
		else {
			push(@cols, $f);
			}
		if ($self->{'bsize'}) {
			push(@cols, $self->nice_size($self->{'filesys_hash'}->{$i,'ublocks'}*$self->{'bsize'}));
			}
		else {
			push(@cols, $self->{'filesys_hash'}->{$i,'ublocks'});
			}
		push(@cols, $self->nice_limit($self->{'filesys_hash'}->{$i,'sblocks'}, $self->{'bsize'}));
		push(@cols, $self->nice_limit($self->{'filesys_hash'}->{$i,'hblocks'}, $self->{'bsize'}));
		push(@cols, $self->{'filesys_hash'}->{$i,'gblocks'}) if ($self->{'config_hash'}->{'show_grace'});
		push(@cols, $self->{'filesys_hash'}->{$i,'ufiles'});
		push(@cols, $self->nice_limit($self->{'filesys_hash'}->{$i,'sfiles'}, $self->{'bsize'}, 1));
		push(@cols, $self->nice_limit($self->{'filesys_hash'}->{$i,'hfiles'}, $self->{'bsize'}, 1));
		push(@cols, $self->{'filesys_hash'}->{$i,'gfiles'}) if ($self->{'config_hash'}->{'show_grace'});
		print $self->ui_columns_row(\@cols);
		}
	print $self->ui_columns_end();
	}
else {
	print "<b>",$self->text('ufilesys_nouquota', $self->{'u'}),"</b><p>\n";
	}

if (!$self->{'access_hash'}->{'ro'}) {
	print "<table width=100%><tr>\n";
	print "<form action=edit_user_quota.cgi>\n";
	print "<input type=hidden name=user value=\"$self->{'u'}\">\n";
	print "<input type=hidden name=source value=1>\n";
	print "<td align=left><input type=submit value=\"$self->{'text_hash'}->{'ufilesys_edit'}\">\n";
	print "<select name=filesys>\n";
	foreach $f (@{$self->{'fslist_array'}}) { print "<option>$f\n"; }
	print "</select></td></form>\n";

	if ($self->{'access_hash'}->{'filesys'} eq "*") {
		print "<form action=copy_user_form.cgi>\n";
		print "<input type=hidden name=user value=\"$self->{'u'}\">\n";
		print "<td align=right><input type=submit value=\"$self->{'text_hash'}->{'ufilesys_copy'}\">\n";
		print "</td></form>\n";
		}
	print "</tr></table>\n";
	}

$self->ui_print_footer("", $self->{'text_hash'}->{'ufilesys_return'});

1;
		
}


1;

