#!/usr/bin/perl
package raid::Log_parser;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'raid::Log_parser');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# log_parser.pl
# Functions for parsing this module's logs

&ModuleLoader::preload_module(ref($self), "raid::RaidLib");
$self = new raid::RaidLib:: ref($self), %$self; 

1;
		return $self;
}

# parse_webmin_log(user, script, action, type, object, &params)
# Converts logged information from this module into human-readable form
sub parse_webmin_log
{
	my $self = shift;

local ($user, $script, $action, $type, $object, $p) = @_;
$object = $self->html_escape($object);
if ($action eq 'create') {
	return $self->text('log_create', $p->{'level'} eq 'linear' ? $self->{'text_hash'}->{$p->{'level'}} : $self->{'text_hash'}->{'raid'.$p->{'level'}}, "<tt>$object</tt>");
	}
elsif ($action eq 'stop') {
	return $self->text('log_stop', "<tt>$object</tt>");
	}
elsif ($action eq 'start') {
	return $self->text('log_start', "<tt>$object</tt>");
	}
elsif ($action eq 'delete') {
	return $self->text('log_delete', "<tt>$object</tt>");
	}
elsif ($action eq 'mkfs') {
	return $self->text('log_mkfs', "<tt>$p->{'fs'}</tt>", "<tt>$object</tt>");
	}
elsif ($action eq 'add') {
	return $self->text('log_add', "<tt>$object</tt>", "<tt>$p->{'disk'}</tt>");
	}
elsif ($action eq 'remove') {
	return $self->text('log_remove', "<tt>$object</tt>", "<tt>$p->{'disk'}</tt>");
	}
else {
	return undef;
	}
}


1;

