#!/usr/bin/perl

&MAIN();

 sub MAIN {
# create_raid.cgi
# Create raid set

&ModuleLoader::preload_module('raid_class', "raid::RaidLib");
$self = new raid::RaidLib:: 'raid_class',%$self;

$self->ReadParse();
$self->lock_raid_files();
$self->{'conf'} = $self->get_raidtab();

# Build config file structure
$self->error_setup($self->{'text_hash'}->{'create_err'});
$self->{'raid'} = { 'name' => 'raiddev',
	  'value' => $self->{'in_hash'}->{'device'},
	  'members' => \@{$self->{'members_array'}} };
push(@{$self->{'members_array'}}, { 'name' => 'raid-level',
		 'value' => $self->{'in_hash'}->{'level'} } );
push(@{$self->{'members_array'}}, { 'name' => 'persistent-superblock',
		 'value' => $self->{'in_hash'}->{'super'} } );
push(@{$self->{'members_array'}}, { 'name' => 'chunk-size',
		 'value' => $self->{'in_hash'}->{'chunk'} } );
if ($self->{'in_hash'}->{'parity'}) {
	push(@{$self->{'members_array'}}, { 'name' => 'parity-algorithm',
			 'value' => $self->{'in_hash'}->{'parity'} } );
	}

# Add RAID disks
@{$self->{'disks_array'}} = split(/\0/, $self->{'in_hash'}->{'disks'});
if (!@{$self->{'disks_array'}}) {
	$self->error($self->{'text_hash'}->{'create_edisks'});
	}
elsif ($self->{'in_hash'}->{'level'} == 1 && @{$self->{'disks_array'}} < 2) {
	$self->error($self->{'text_hash'}->{'create_edisks2'});
	}
push(@{$self->{'members_array'}}, { 'name' => 'nr-raid-disks',
		 'value' => scalar(@{$self->{'disks_array'}})+($self->{'in_hash'}->{'pdisk'} ? 1 : 0) } );
for($i=0; $i<@{$self->{'disks_array'}}; $i++) {
	push(@{$self->{'members_array'}}, { 'name' => 'device',
			 'value' => $self->{'disks_array'}->[$i],
			 'members' => [ { 'name' => 'raid-disk',
					  'value' => $i } ] } );
	}

# Add spares
@{$self->{'spares_array'}} = split(/\0/, $self->{'in_hash'}->{'spares'});
if (@{$self->{'spares_array'}}) {
	push(@{$self->{'members_array'}}, { 'name' => 'nr-spare-disks',
			 'value' => scalar(@{$self->{'spares_array'}}) } );
	for($i=0; $i<@{$self->{'spares_array'}}; $i++) {
		if ($self->indexof($self->{'spares_array'}->[$i], @{$self->{'disks_array'}}) != -1) {
			$self->error($self->text('create_espare', $self->{'spares_array'}->[$i]));
			}
		push(@{$self->{'members_array'}}, { 'name' => 'device',
				 'value' => $self->{'spares_array'}->[$i],
				 'members' => [ { 'name' => 'spare-disk',
						  'value' => $i } ] } );
		}
	}

# Add parity disk
if ($self->{'in_hash'}->{'pdisk'}) {
	$self->indexof($self->{'in_hash'}->{'pdisk'}, @{$self->{'disks_array'}}) < 0 || $self->error($self->{'text_hash'}->{'create_epdisk'});
	push(@{$self->{'members_array'}}, { 'name' => 'device',
			 'value' => $self->{'in_hash'}->{'pdisk'},
			 'members' => [ { 'name' => 'parity-disk',
					  'value' => 0 } ] } );
	}

$self->create_raid($self->{'raid'});
$self->unlock_raid_files();
if ($self->{'err'} = $self->make_raid($self->{'raid'}, $self->{'in_hash'}->{'force'})) {
	$self->delete_raid($self->{'raid'});
	$self->error($self->{'err'});
	}
$self->webmin_log("create", undef, $self->{'in_hash'}->{'device'}, \%{$self->{'in_hash'}});
$self->redirect("");

1;
		
}


1;

