#!/usr/bin/perl

&MAIN();

 sub MAIN {
# index.cgi
# Display all RAID devices

&ModuleLoader::preload_module('raid_class', "raid::RaidLib");
$self = new raid::RaidLib:: 'raid_class',%$self;


# Check if raid is installed
if (!-r $self->{'config_hash'}->{'mdstat'}) {
	&error_exit($self->text('index_emdstat', "<tt>$self->{'config_hash'}->{'mdstat'}</tt>"));
	}
if ($self->has_command("mdadm")) {
	# Using mdadm commands
	$self->{'raid_mode'} = "mdadm";
	}
elsif ($self->has_command('mkraid') && $self->has_command('raidstart')) {
	# Using raid tools commands
	$self->{'raid_mode'} = "raidtools";
	}
else {
	&error_exit($self->{'text_hash'}->{'index_eprogs'});
	}
$self->open_tempfile(MODE, ">$self->{'module_config_directory'}/mode");
$self->print_tempfile(MODE, $self->{'raid_mode'},"\n");
$self->close_tempfile(MODE);

$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", undef, 1, 1, 0,
	$self->help_search_link("raid", "man", "doc"),
	undef, undef, $self->text('index_'.$self->{'raid_mode'}));

# Display configured raid devices
$self->{'conf'} = $self->get_raidtab();
if (@{$self->{'conf'}}) {
	&show_button();
	foreach $c (@{$self->{'conf'}}) {
		$self->{'lvl'} = $self->find_value('raid-level', $c->{'members'});
		push(@{$self->{'titles_array'}}, $self->html_escape($c->{'value'}));
		push(@{$self->{'images_array'}}, $c->{'active'} ? "images/$self->{'lvl'}.gif"
					     : "images/$self->{'lvl'}.ia.gif");
		push(@{$self->{'links_array'}}, "view_raid.cgi?idx=$c->{'index'}");
		}
	$self->icons_table(\@{$self->{'links_array'}}, \@{$self->{'titles_array'}}, \@{$self->{'images_array'}});
	}
else {
	print "<p><b>$self->{'text_hash'}->{'index_none'}</b><p>\n";
	}
&show_button();

$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});

1;
		
}

sub show_button
{
	shift if ($self == $_[0]);

print $self->ui_form_start("raid_form.cgi");
print $self->ui_submit($self->{'text_hash'}->{'index_add'});
local @levels = ( 0, 1, 4, 5 );
push(@levels, 6) if ($self->{'raid_mode'} eq "mdadm");
print $self->ui_select("level", "linear",
		 [ [ "linear", $self->{'text_hash'}->{'linear'} ],
		   map { [ $_, $self->{'text_hash'}->{'raid'.$_} ] } @levels ]),"\n";
print $self->ui_form_end();
}

sub error_exit
{
	shift if ($self == $_[0]);

$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", undef, 1, 1, 0,
	$self->help_search_link("raid", "man", "doc"));
print "<p><b>",@_,"</b><p>\n";
$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});
exit;
}


1;

