#!/usr/bin/perl

&MAIN();

 sub MAIN {
# mkfs.cgi
# Create a new linux filesystem

&ModuleLoader::preload_module('raid_class', "raid::RaidLib");
$self = new raid::RaidLib:: 'raid_class',%$self;

$self->foreign_require("proc", "proc-lib.pl");

$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'mkfs_err'});
$self->foreign_call("fdisk", "error_setup", $self->{'text_hash'}->{'mkfs_err'});
$self->foreign_call("fdisk", "ReadParse");
$self->{'conf'} = $self->get_raidtab();
$self->{'raid'} = $self->{'conf'}->[$self->{'in_hash'}->{'idx'}];
$self->{'cmd'} = $self->foreign_call("fdisk", "mkfs_parse", $self->{'in_hash'}->{'fs'}, $self->{'raid'}->{'value'});

$self->{'lvl'} = $self->find_value('raid-level', $self->{'raid'}->{'members'});
$self->{'chunk'} = $self->find_value('chunk-size', $self->{'raid'}->{'members'});
if ($self->{'lvl'} >= 4 && ($self->{'in_hash'}->{'fs'} eq 'ext2' || $self->{'in_hash'}->{'fs'} eq 'ext3')) {
	$self->{'bs'} = $self->{'in_hash'}->{'ext2_b_def'} ? 4096 : $self->{'in_hash'}->{'ext2_b'};
	}

$self->ui_print_unbuffered_header(undef, $self->{'text_hash'}->{'mkfs_title'}, "");
print $self->text('mkfs_exec', "<tt>$self->{'cmd'}</tt>"),"<p>\n";
print "<pre>\n";
$self->foreign_call("proc", "safe_process_exec_logged", $self->{'cmd'}, 0, 0, STDOUT, undef, 1);
print "</pre>\n";

if ($?) { print "<b>$self->{'text_hash'}->{'mkfs_failed'}</b> <p>\n"; }
else { print "$self->{'text_hash'}->{'mkfs_ok'} <p>\n"; }

$self->{'config_hash'}->{'lasttype_'.$self->{'raid'}->{'value'}} = $self->{'in_hash'}->{'fs'};
$self->save_module_config();
$self->webmin_log("mkfs", undef, $self->{'raid'}->{'value'}, \%{$self->{'in_hash'}});

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

