#!/usr/bin/perl

&MAIN();

 sub MAIN {
# raid_form.cgi
# Display a form for creating a raid device

&ModuleLoader::preload_module('raid_class', "raid::RaidLib");
$self = new raid::RaidLib:: 'raid_class',%$self;

$self->foreign_require("mount", "mount-lib.pl");
$self->foreign_require("lvm", "lvm-lib.pl");
$self->ReadParse();
$self->{'conf'} = $self->get_raidtab();

# Display headers
$self->{'max'} = 0;
foreach $c (@{$self->{'conf'}}) {
	if ($c->{'value'} =~ /md(\d+)$/ && $1 >= $self->{'max'}) {
		$self->{'max'} = $1+1;
		}
	}
$self->ui_print_header(undef, $self->{'text_hash'}->{'create_title'}, "");
$self->{'raid'} = { 'value' => "/dev/md$self->{'max'}",
	  'members' => [ { 'name' => 'raid-level',
			   'value' => $self->{'in_hash'}->{'level'} },
			 { 'name' => 'persistent-superblock',
			   'value' => 1 }
		       ] };

# Find available partitions
$self->{'disks'} = $self->find_free_partitions(undef, 1, 1);
if (!$self->{'disks'}) {
	print "<p><b>$self->{'text_hash'}->{'create_nodisks'}</b> <p>\n";
	$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
	exit;
	}

print "<form action=create_raid.cgi>\n";
print "<input type=hidden name=idx value='$self->{'in_hash'}->{'idx'}'>\n";
print "<table border>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'create_header'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'create_device'}</b></td>\n";
print "<td><tt>$self->{'raid'}->{'value'}</tt></td> </tr>\n";
print "<input type=hidden name=device value='$self->{'raid'}->{'value'}'>\n";

$self->{'lvl'} = $self->find_value('raid-level', $self->{'raid'}->{'members'});
print "<tr> <td><b>$self->{'text_hash'}->{'create_level'}</b></td>\n";
print "<td>",$self->{'lvl'} eq 'linear' ? $self->{'text_hash'}->{'linear'}
			      : $self->{'text_hash'}->{"raid$self->{'lvl'}"},"</td> </tr>\n";
print "<input type=hidden name=level value='$self->{'lvl'}'>\n";

$self->{'super'} = $self->find_value('persistent-superblock', $self->{'raid'}->{'members'});
print "<tr> <td><b>$self->{'text_hash'}->{'create_super'}</b></td>\n";
printf "<td><input name=super type=radio value=1 %s> %s\n",
	$self->{'super'} ? 'checked' : '', $self->{'text_hash'}->{'yes'};
printf "<input name=super type=radio value=0 %s> %s</td> </tr>\n",
	$self->{'super'} ? '' : 'checked', $self->{'text_hash'}->{'no'};

if ($self->{'lvl'} >= 5) {
	$self->{'parity'} = $self->find_value('parity-algorithm', $self->{'raid'}->{'members'});
	print "<tr> <td><b>$self->{'text_hash'}->{'create_parity'}</b></td>\n";
	print "<td><select name=parity>\n";
	foreach $a ('', 'left-asymmetric', 'right-asymmetric',
		    'left-symmetric', 'right-symmetric') {
		printf "<option value='%s' %s>%s\n",
			$a, $self->{'parity'} eq $a ? 'selected' : '',
			$a ? $a : $self->{'text_hash'}->{'default'};
		}
	print "</select></td> </tr>\n";
	}

$self->{'chunk'} = $self->find_value('chunk-size', $self->{'raid'}->{'members'});
print "<tr> <td><b>$self->{'text_hash'}->{'create_chunk'}</b></td>\n";
print "<td><select name=chunk>\n";
for($i=4; $i<=4096; $i*=2) {
	printf "<option value=%d %s>%d kB\n",
		$i, $self->{'chunk'} == $i ? 'selected' : '', $i;
	}
print "</select></td> </tr>\n";

# Display partitions in raid, spares and parity
print "<tr> <td valign=top><b>$self->{'text_hash'}->{'create_disks'}</b></td>\n";
print "<td><select name=disks multiple size=4>\n";
print $self->{'disks'};
print "</select></td> </tr>\n";

if ($self->{'lvl'} >= 4) {
	print "<tr> <td valign=top><b>$self->{'text_hash'}->{'create_spares'}</b></td>\n";
	print "<td><select name=spares multiple size=4>\n";
	print $self->{'disks'};
	print "</select></td> </tr>\n";
	}

if ($self->{'lvl'} == 4) {
	print "<tr> <td valign=top><b>$self->{'text_hash'}->{'create_pdisk'}</b></td>\n";
	print "<td><select name=pdisk>\n";
	print "<option value='' selected>$self->{'text_hash'}->{'create_auto'}\n";
	print $self->{'disks'};
	print "</select></td> </tr>\n";
	}

print "<tr> <td><b>$self->{'text_hash'}->{'create_force'}</b></td>\n";
print "<td><input type=radio name=force value=1> $self->{'text_hash'}->{'yes'}\n";
print "<input type=radio name=force value=0 checked> $self->{'text_hash'}->{'no'}\n";
print "</td> </tr>\n";

print "</table></td></tr></table>\n";

print "<input type=submit value='$self->{'text_hash'}->{'create'}'></form>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

