#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_raid.cgi
# Activate, deactivate, delete or make a filesystem on a raid set

&ModuleLoader::preload_module('raid_class', "raid::RaidLib");
$self = new raid::RaidLib:: 'raid_class',%$self;

$self->ReadParse();
$self->{'conf'} = $self->get_raidtab();
$self->{'old'} = $self->{'conf'}->[$self->{'in_hash'}->{'idx'}];

if ($self->{'in_hash'}->{'delete'}) {
	# Delete a RAID set
	$self->lock_raid_files();
	$self->unmake_raid($self->{'old'});
	$self->delete_raid($self->{'old'});
	$self->unlock_raid_files();
	$self->webmin_log("delete", undef, $self->{'old'}->{'value'});
	$self->redirect("");
	}
elsif ($self->{'in_hash'}->{'mkfs'}) {
	# Display form for making a filesystem
	$self->ui_print_header(undef, $self->{'text_hash'}->{'mkfs_title'}, "");

	print "<p>",$self->text('mkfs_header2', "<tt>$self->{'old'}->{'value'}</tt>",
			  $self->{'in_hash'}->{'fs'}),"<br>\n";
	print "<form action=mkfs.cgi>\n";
	print "<input type=hidden name=idx value='$self->{'in_hash'}->{'idx'}'>\n";
	print "<input type=hidden name=fs value='$self->{'in_hash'}->{'fs'}'>\n";
	print "<table border width=100%>\n";
	print "<tr $self->{'tb'}><td><b>$self->{'text_hash'}->{'mkfs_options'}</b></td> </tr>\n";
	print "<tr $self->{'cb'}><td><table width=100%>\n";
	$self->foreign_call("fdisk", "mkfs_options", $self->{'in_hash'}->{'fs'});
	print "</table></td></tr></table>\n";
	print "<input type=submit value='$self->{'text_hash'}->{'create'}'></form>\n";

	$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
	}
elsif ($self->{'in_hash'}->{'start'}) {
	# Start raid device
	$self->activate_raid($self->{'old'});
	$self->webmin_log("start", undef, $self->{'old'}->{'value'});
	$self->redirect("");
	}
elsif ($self->{'in_hash'}->{'stop'}) {
	# Stop raid device
	$self->deactivate_raid($self->{'old'});
	$self->webmin_log("stop", undef, $self->{'old'}->{'value'});
	$self->redirect("");
	}
elsif ($self->{'in_hash'}->{'add'}) {
	# Add a disk to a RAID set
	$self->lock_raid_files();
	$self->add_partition($self->{'old'}, $self->{'in_hash'}->{'disk'});
	$self->unlock_raid_files();
	$self->webmin_log("add", undef, $self->{'old'}->{'value'}, { 'disk' => $self->{'in_hash'}->{'disk'} } );
	$self->redirect("");
	}
elsif ($self->{'in_hash'}->{'remove'}) {
	# Remove a disk from a RAID set
	$self->lock_raid_files();
	$self->remove_partition($self->{'old'}, $self->{'in_hash'}->{'rdisk'});
	$self->unlock_raid_files();
	$self->webmin_log("remove", undef, $self->{'old'}->{'value'}, { 'disk' => $self->{'in_hash'}->{'rdisk'} } );
	$self->redirect("");
	}
elsif ($self->{'in_hash'}->{'mount'} || $self->{'in_hash'}->{'mountswap'}) {
	# Re-direct to mount module
	$self->{'type'} = $self->{'in_hash'}->{'mountswap'} ? "swap" :
		$self->{'config_hash'}->{'lasttype_'.$self->{'old'}->{'value'}} || "ext2";
	$self->redirect("../mount/edit_mount.cgi?newdev=$self->{'old'}->{'value'}&".
		  "newdir=".$self->urlize($self->{'in_hash'}->{'newdir'})."&".
		  "type=".$self->{'type'});
	}

1;
		
}


1;

