#!/usr/bin/perl

&MAIN();

 sub MAIN {
# view_raid.cgi
# Display information about a raid device

&ModuleLoader::preload_module('raid_class', "raid::RaidLib");
$self = new raid::RaidLib:: 'raid_class',%$self;

$self->foreign_require("mount", "mount-lib.pl");
$self->foreign_require("lvm", "lvm-lib.pl");
$self->ReadParse();

print "Refresh: $self->{'config_hash'}->{'refresh'}\r\n"
	if ($self->{'config_hash'}->{'refresh'});
$self->ui_print_header(undef, $self->{'text_hash'}->{'view_title'}, "");
$self->{'conf'} = $self->get_raidtab();
$self->{'raid'} = $self->{'conf'}->[$self->{'in_hash'}->{'idx'}];

print "<form action=save_raid.cgi>\n";
print "<input type=hidden name=idx value='$self->{'in_hash'}->{'idx'}'>\n";
print "<table border>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'view_header'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'view_device'}</b></td>\n";
print "<td><tt>$self->{'raid'}->{'value'}</tt></td> </tr>\n";

$self->{'lvl'} = $self->find_value('raid-level', $self->{'raid'}->{'members'});
print "<tr> <td><b>$self->{'text_hash'}->{'view_level'}</b></td>\n";
print "<td>",$self->{'lvl'} eq 'linear' ? $self->{'text_hash'}->{'linear'}
			      : $self->{'text_hash'}->{"raid$self->{'lvl'}"},"</td> </tr>\n";

@{$self->{'st_array'}} = $self->device_status($self->{'raid'}->{'value'});
print "<tr> <td><b>$self->{'text_hash'}->{'view_status'}</b></td> <td>\n";
print $self->{'st_array'}->[1] eq 'lvm' ? $self->text('view_lvm', "<tt>$self->{'st_array'}->[0]</tt>") :
      $self->{'st_array'}->[2] ? $self->text('view_mounted', "<tt>$self->{'st_array'}->[0]</tt>") :
      @{$self->{'st_array'}} ? $self->text('view_mount', "<tt>$self->{'st_array'}->[0]</tt>") :
      $self->{'raid'}->{'active'} ? $self->{'text_hash'}->{'view_active'} :
			  $self->{'text_hash'}->{'view_inactive'};
print "</td> </tr>\n";

if ($self->{'raid'}->{'size'}) {
	print "<tr> <td><b>$self->{'text_hash'}->{'view_size'}</b></td>\n";
	print "<td>$self->{'raid'}->{'size'} blocks ",
	      "(",$self->nice_size($self->{'raid'}->{'size'}*1024),")</td> </tr>\n";
	}
if ($self->{'raid'}->{'resync'}) {
	print "<tr> <td><b>$self->{'text_hash'}->{'view_resync'}</b></td>\n";
	print "<td>$self->{'raid'}->{'resync'} \%</td> </tr>\n";
	}

$self->{'super'} = $self->find_value('persistent-superblock', $self->{'raid'}->{'members'});
print "<tr> <td><b>$self->{'text_hash'}->{'view_super'}</b></td>\n";
print "<td>",$self->{'super'} ? $self->{'text_hash'}->{'yes'} : $self->{'text_hash'}->{'no'},"</td> </tr>\n";

if ($self->{'lvl'} eq '5') {
	$self->{'parity'} = $self->find_value('parity-algorithm', $self->{'raid'}->{'members'});
	print "<tr> <td><b>$self->{'text_hash'}->{'view_parity'}</b></td>\n";
	print "<td>",$self->{'parity'} ? $self->{'parity'} : $self->{'text_hash'}->{'default'},"</td> </tr>\n";
	}

$self->{'chunk'} = $self->find_value('chunk-size', $self->{'raid'}->{'members'});
print "<tr> <td><b>$self->{'text_hash'}->{'view_chunk'}</b></td>\n";
print "<td>",$self->{'chunk'} ? "$self->{'chunk'} kB" : $self->{'text_hash'}->{'default'},"</td> </tr>\n";

if (ref($self->{'raid'}->{'errors'})) {
	for($i=0; $i<@{$self->{'raid'}->{'errors'}}; $i++) {
		if ($self->{'raid'}->{'errors'}->[$i] ne "U") {
			push(@{$self->{'badlist_array'}}, $self->{'raid'}->{'devices'}->[$i]);
			}
		}
	if (@{$self->{'badlist_array'}}) {
		print "<tr> <td><b>$self->{'text_hash'}->{'view_errors'}</b></td>\n";
		print "<td><font color=#ff0000>",
			$self->text('view_bad', scalar(@{$self->{'badlist_array'}})),
			"</font></td> </tr>\n";
		}
	}

if ($self->{'raid'}->{'state'}) {
	print "<tr> <td><b>$self->{'text_hash'}->{'view_state'}</b></td>\n";
	print "<td>$self->{'raid'}->{'state'}</td> </tr>\n";
	}

if ($self->{'raid'}->{'rebuild'}) {
	print "<tr> <td><b>$self->{'text_hash'}->{'view_rebuild'}</b></td>\n";
	print "<td>$self->{'raid'}->{'rebuild'} \%</td> </tr>\n";
	}

# Display partitions in RAID
print "<tr> <td valign=top><b>$self->{'text_hash'}->{'view_disks'}</b></td> <td>\n";
foreach $d ($self->find('device', $self->{'raid'}->{'members'})) {
	if ($self->find('raid-disk', $d->{'members'}) ||
            $self->find('parity-disk', $d->{'members'})) {
		local $name = $main::mount_object->device_name($d->{'value'});
		print $name,"\n";
		if (!&indevlist($d->{'value'}, $self->{'raid'}->{'devices'}) &&
		    $self->{'raid'}->{'active'}) {
			print "<font color=#ff0000>$self->{'text_hash'}->{'view_down'}</font>\n";
			}
		print "<br>\n";
		$self->{'rdisks'} .= "<option value='$d->{'value'}'>$name\n";
		$self->{'rdisks_count'}++;
		}
	}
print "</td> </tr>\n";

# Display spare partitions
foreach $d ($self->find('device', $self->{'raid'}->{'members'})) {
	if ($self->find('spare-disk', $d->{'members'})) {
		local $name = $main::mount_object->device_name($d->{'value'});
		$self->{'sp'} .= "$name<br>\n";
		$self->{'rdisks'} .= "<option value='$d->{'value'}'>$name\n";
		$self->{'rdisks_count'}++;
		}
	}
if ($self->{'sp'}) {
	print "<tr> <td valign=top><b>$self->{'text_hash'}->{'view_spares'}</b></td> <td>\n";
	print $self->{'sp'},"</td> </tr>\n";
	}

print "</table></td></tr></table>\n";

print "<p><hr>\n";
print "<table width=100%><tr>\n";

if ($self->{'raid_mode'} eq "raidtools" && !$self->{'st_array'}->[2]) {
	# Only classic raid tools can disable a RAID
	local $act = $self->{'raid'}->{'active'} ? "stop" : "start";
	print "<tr> <td><input type=submit name=$act ",
	      "value='",$self->{'text_hash'}->{'view_'.$act},"'></td>\n";
	print "<td>",$self->{'text_hash'}->{'view_'.$act.'desc'},"</td> </tr>\n";
	}

if ($self->{'raid_mode'} eq "mdadm") {
	# Only MDADM can add or remove a device (so far)
	$self->{'disks'} = $self->find_free_partitions([ $self->{'raid'}->{'value'} ], 0, 1);
	if ($self->{'disks'}) {
		print "<tr> <td><input type=submit name=add ",
		      "value='$self->{'text_hash'}->{'view_add'}'>\n";
		print "<select name=disk>\n";
		print $self->{'disks'};
		print "</select></td>\n";
		print "<td>$self->{'text_hash'}->{'view_adddesc'}</td> </tr>\n";
		}

	if ($self->{'rdisks_count'} > 1) {
		print "<tr> <td><input type=submit name=remove ",
		      "value='$self->{'text_hash'}->{'view_remove'}'>\n";
		print "<select name=rdisk>\n";
		print $self->{'rdisks'};
		print "</select></td>\n";
		print "<td>$self->{'text_hash'}->{'view_removedesc'}</td> </tr>\n";
		}
	}

if ($self->{'raid'}->{'active'} && !$self->{'st_array'}->[2]) {
	# Show buttons for creating filesystems
	print "<tr> <td nowrap><input type=submit name=mkfs ",
	      "value='$self->{'text_hash'}->{'view_mkfs2'}'>\n";
	print "<select name=fs>\n";
	foreach $f ($main::fdisk_object->supported_filesystems()) {
		printf "<option value=%s %s>%s (%s)\n",
			$f, $stat[1] eq $f ? "selected" : "",
			$main::fdisk_object->{'text_hash'}->{"fs_$f"}, $f;
		}
	print "</select></td>\n";
	print "<td>$self->{'text_hash'}->{'view_mkfsdesc'}</td> </tr>\n";
	}

if (!@{$self->{'st_array'}}) {
	# Show button for mounting filesystem
	print "<tr> <td valign=top>\n";
	print "<input type=submit name=mount ",
	      "value=\"",$self->{'text_hash'}->{'view_newmount'},"\">\n";
	print "<input name=newdir size=20></td>\n";
	print "<td>$self->{'text_hash'}->{'view_mountmsg'}</td> </tr>\n";

	# Show button for mounting as swap
	print "<tr> <td valign=top>\n";
	print "<input type=submit name=mountswap ",
	      "value=\"",$self->{'text_hash'}->{'view_newmount2'},"\"></td>\n";
	print "<td>$self->{'text_hash'}->{'view_mountmsg2'}</td> </tr>\n";
	}

if (!$self->{'st_array'}->[2]) {
	print "<tr> <td><input type=submit name=delete value='$self->{'text_hash'}->{'view_delete'}'></td>\n";
	print "<td>$self->{'text_hash'}->{'view_deletedesc'}</td> </tr>\n";
	}

if ($self->{'st_array'}->[2]) {
	print "<tr> <td colspan=2><b>$self->{'text_hash'}->{'view_cannot2'}</b></td> </tr>\n";
	}

print "</tr></table>\n";
print "</form>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}

# indevlist(device, &list)
sub indevlist
{
	shift if ($self == $_[0]);

local $d;
foreach $d (@{$_[1]}) {
	return 1 if ($self->same_file($_[0], $d));
	}
return 0;
}


1;

