#!/usr/bin/perl
package rbac::Acl_security;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'rbac::Acl_security');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;

&ModuleLoader::preload_module(ref($self), "rbac::RbacLib");
$self = new rbac::RbacLib:: ref($self), %$self; 

1;
		return $self;
}

# acl_security_form(&options)
# Output HTML for editing security options for the RBAC module
sub acl_security_form
{
	my $self = shift;

$self->{'ui_table_cols'} = 4;
$self->{'ui_table_pos'} = 0;

print $self->ui_table_row($self->{'text_hash'}->{'acl_users'},
		    $self->ui_radio("users", $_[0]->{'users'},
			      [ [ 1, $self->{'text_hash'}->{'yes'} ], [ 0, $self->{'text_hash'}->{'no'} ] ]));

print $self->ui_table_row($self->{'text_hash'}->{'acl_roles'},
		    $self->ui_radio("roles", $_[0]->{'roles'},
			      [ [ 1, $self->{'text_hash'}->{'yes'} ], [ 0, $self->{'text_hash'}->{'no'} ] ]));

local $ra = $_[0]->{'roleassign'} eq "*" ? 0 :
	    $_[0]->{'roleassign'} eq "x" ? 1 : 2;
print $self->ui_table_row($self->{'text_hash'}->{'acl_roleassign'},
		    $self->ui_radio("roleassign_def", $ra,
			      [ [ 0, $self->{'text_hash'}->{'acl_roleassign0'} ],
				[ 1, $self->{'text_hash'}->{'acl_roleassign1'} ],
				[ 2, $self->{'text_hash'}->{'acl_roleassign2'} ] ])."\n".
		    $self->ui_textbox("roleassign",
			$ra == 2 ? join(" ", split(/,/, $_[0]->{'roleassign'})) : "", 40),
		    3);

local $ra = $_[0]->{'profassign'} eq "*" ? 0 :
	    $_[0]->{'profassign'} eq "x" ? 1 : 2;
print $self->ui_table_row($self->{'text_hash'}->{'acl_profassign'},
		    $self->ui_radio("profassign_def", $ra,
			      [ [ 0, $self->{'text_hash'}->{'acl_profassign0'} ],
				[ 1, $self->{'text_hash'}->{'acl_profassign1'} ],
				[ 2, $self->{'text_hash'}->{'acl_profassign2'} ] ])."<br>\n".
		    $self->profiles_input("profassign", $ra == 2 ? $_[0]->{'profassign'} : ""),
		    3);

print $self->ui_table_row($self->{'text_hash'}->{'acl_auths'},
		    $self->ui_radio("auths", $_[0]->{'auths'},
			      [ [ 1, $self->{'text_hash'}->{'yes'} ], [ 0, $self->{'text_hash'}->{'no'} ] ]));

print $self->ui_table_row($self->{'text_hash'}->{'acl_authassign'},
		    $self->ui_radio("authassign", $_[0]->{'authassign'},
			      [ [ 1, $self->{'text_hash'}->{'yes'} ], [ 0, $self->{'text_hash'}->{'no'} ] ]));

print $self->ui_table_row($self->{'text_hash'}->{'acl_profs'},
		    $self->ui_radio("profs", $_[0]->{'profs'},
			      [ [ 1, $self->{'text_hash'}->{'yes'} ], [ 2, $self->{'text_hash'}->{'acl_ro'} ],
				[ 0, $self->{'text_hash'}->{'no'} ] ]));

print $self->ui_table_row($self->{'text_hash'}->{'acl_execs'},
		    $self->ui_radio("execs", $_[0]->{'execs'},
			      [ [ 1, $self->{'text_hash'}->{'yes'} ], [ 0, $self->{'text_hash'}->{'no'} ] ]));

print $self->ui_table_row($self->{'text_hash'}->{'acl_projects'},
		    $self->ui_radio("projects", $_[0]->{'projects'},
			      [ [ 1, $self->{'text_hash'}->{'yes'} ], [ 0, $self->{'text_hash'}->{'no'} ] ]));
}

# acl_security_save(&options)
# Parse the form for security options for the acl module
sub acl_security_save
{
	my $self = shift;

$_[0]->{'roles'} = $self->{'in_hash'}->{'roles'};
$_[0]->{'users'} = $self->{'in_hash'}->{'users'};
$_[0]->{'roleassign'} = $self->{'in_hash'}->{'roleassign_def'} == 0 ? "*" :
			$self->{'in_hash'}->{'roleassign_def'} == 1 ? "x" :
				join(",", split(/\s+/, $self->{'in_hash'}->{'roleassign'}));
$_[0]->{'profassign'} = $self->{'in_hash'}->{'profassign_def'} == 0 ? "*" :
			$self->{'in_hash'}->{'profassign_def'} == 1 ? "x" :
				join(",", split(/\0/, $self->{'in_hash'}->{'profassign'}));
$_[0]->{'profs'} = $self->{'in_hash'}->{'profs'};
$_[0]->{'execs'} = $self->{'in_hash'}->{'execs'};
$_[0]->{'auths'} = $self->{'in_hash'}->{'auths'};
$_[0]->{'authassign'} = $self->{'in_hash'}->{'authassign'};
$_[0]->{'projects'} = $self->{'in_hash'}->{'projects'};
}


1;

