#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Show a list of all authorizations

&ModuleLoader::preload_module('rbac_class', "rbac::RbacLib");
$self = new rbac::RbacLib:: 'rbac_class',%$self;

$self->ReadParse();

$self->header("Select Authorization");
print <<EOF;
<script>
function sel(m)
{
if (window.opener.ifield.value != "") {
	window.opener.ifield.value += "\\n";
	}
window.opener.ifield.value += m;
window.close();
return false;
}
</script>
EOF

# Show Solaris authorizations
$self->{'auths'} = $self->list_auth_attrs();
print "<table width=100% cellpadding=1 cellspacing=1>\n";
print "<tr> <td><b>$self->{'text_hash'}->{'authc_name'}</b></td> ",
      "<td><b>$self->{'text_hash'}->{'authc_desc'}</b></td> </tr>\n";
foreach $a (sort { $a->{'name'} cmp $b->{'name'} } @{$self->{'auths'}}) {
	print "<tr>\n";
	if ($a->{'name'} =~ /\.$/) {
		print "<td><a href='' onClick='sel(\"$a->{'name'}*\")'>",
		      "$a->{'name'}*</td>\n";
		}
	else {
		print "<td><a href='' onClick='sel(\"$a->{'name'}\")'>",
		      "$a->{'name'}</td>\n";
		}
	print "<td>",$a->{'short'} || $a->{'desc'},"</td>\n";
	print "</tr>\n";
	}

# Add Webmin authorizations
print "<tr> <td colspan=2><hr></td> </tr>\n";
foreach $m (sort { $a->{'dir'} cmp $b->{'dir'} } $self->get_all_module_infos()) {
	next if (!$self->check_os_support($m));
	print "<tr>\n";
	print "<td><a href='' onClick='sel(\"webmin.$m->{'dir'}.admin\")'>",
	      "webmin.$m->{'dir'}.admin</td>\n";
	print "<td>$m->{'desc'}</td>\n";
	print "</tr>\n";
	}

print "</table>\n";

1;
		
}


1;

