#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Show one project

&ModuleLoader::preload_module('rbac_class', "rbac::RbacLib");
$self = new rbac::RbacLib:: 'rbac_class',%$self;

$self->{'access_hash'}->{'projects'} || $self->error($self->{'text_hash'}->{'projects_ecannot'});
$self->ReadParse();
$self->{'projects'} = $self->list_projects();
if ($self->{'in_hash'}->{'new'}) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'project_title1'}, "");

	# Pick a free ID
	%{$self->{'taken_hash'}} = map { $_->{'id'}, 1 } @{$self->{'projects'}};
	for($id=$self->{'config_hash'}->{'base_id'}; $self->{'taken_hash'}->{$id}; $id++) { }
	$self->{'project'} = { 'id' => $id };
	}
else {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'project_title2'}, "");
	$self->{'project'} = $self->{'projects'}->[$self->{'in_hash'}->{'idx'}];
	}

print $self->ui_form_start("save_project.cgi", "post");
print $self->ui_hidden("idx", $self->{'in_hash'}->{'idx'}),"\n";
print $self->ui_hidden("new", $self->{'in_hash'}->{'new'}),"\n";
print $self->ui_table_start($self->{'text_hash'}->{'project_header'}, "width=100%", 2);

print $self->ui_table_row($self->{'text_hash'}->{'project_name'},
		    $self->ui_textbox("name", $self->{'project'}->{'name'}, 20));

print $self->ui_table_row($self->{'text_hash'}->{'project_id'},
		    $self->ui_textbox("id", $self->{'project'}->{'id'}, 5));

print $self->ui_table_row($self->{'text_hash'}->{'project_desc'},
		    $self->ui_textbox("desc", $self->{'project'}->{'desc'}, 60));

print $self->ui_table_row($self->{'text_hash'}->{'project_users'},
		    $self->project_members_input("users", $self->{'project'}->{'users'}));

print $self->ui_table_row($self->{'text_hash'}->{'project_groups'},
		    $self->project_members_input("groups", $self->{'project'}->{'groups'}));

# Work out which resources this project has
foreach $a (keys %{$self->{'project'}->{'attr'}}) {
	$self->{'v'} = $self->{'project'}->{'attr'}->{$a};
	if ($a eq "project.pool") {
		# Special case for project pool
		$self->{'pool'} = $self->{'v'};
		}
	elsif ($a eq "rcap.max-rss") {
		# Special case for max RSS
		$self->{'maxrss'} = $self->{'v'};
		}
	elsif ($self->{'v'}) {
		while($self->{'v'} =~ /^\(([^,]+),([^,]+),([^,]+)\),?(.*)$/) {
			push(@{$self->{'res_array'}}, [ $a, $1, $2, $3 ]);
			$self->{'v'} = $4;
			}
		}
	else {
		push(@{$self->{'res_array'}}, [ $a ]);
		}
	}

print $self->ui_table_row($self->{'text_hash'}->{'project_pool'},
		    $self->ui_opt_textbox("pool", $self->{'pool'}, 40, $self->{'text_hash'}->{'default'}));

print $self->ui_table_row($self->{'text_hash'}->{'project_maxrss'},
		    $self->ui_radio("maxrss_def", $self->{'maxrss'} ? 0 : 1,
			      [ [ 1, $self->{'text_hash'}->{'default'} ],
				[ 0, $self->ui_bytesbox("maxrss", $self->{'maxrss'}) ] ]));

print $self->ui_table_end(),"<p>\n";

# Show table for  resources
print $self->ui_table_start($self->{'text_hash'}->{'project_header2'}, "width=100%", 2);
print "<td colspan=2>";
print $self->ui_columns_start([ $self->{'text_hash'}->{'project_rctl'},
			  $self->{'text_hash'}->{'project_priv'},
			  $self->{'text_hash'}->{'project_limit'},
			  $self->{'text_hash'}->{'project_action'} ], "100%");
$i = 0;
foreach $a (@{$self->{'res_array'}}, [ ], [ ], [ ]) {
	print $self->ui_columns_row([
		$self->ui_select("rctl_$i", $a->[0],
		   [ [ "", "&nbsp;" ], map { [ $_ ] } $self->list_rctls() ], 0, 0, 1),
		$self->ui_select("priv_$i", $a->[1],
		   [ [ "", $self->{'text_hash'}->{'project_nopriv'} ],
		     [ "privileged", $self->{'text_hash'}->{'project_privileged'} ],
		     [ "system", $self->{'text_hash'}->{'project_system'} ],
		     [ "basic", $self->{'text_hash'}->{'project_basic'} ] ],
		   0, 0, $a->[1] ? 1 : 0),
		$self->ui_textbox("limit_$i", $a->[2], 10),
		$self->ui_select("action_$i", $a->[3],
			   [ [ "none", $self->{'text_hash'}->{'project_none'} ],
			     [ "deny", $self->{'text_hash'}->{'project_deny'} ],
			     map { [ "signal=$_->[0]", $self->text('project_signal', $_->[0], $_->[1]) ] } $self->list_rctl_signals() ],
			   0, 0, $a->[3] ? 1 : 0),
		]);
	$i++;
	}
print $self->ui_columns_end();

print "</td>\n";
print $self->ui_table_end();
if ($self->{'in_hash'}->{'new'}) {
	print $self->ui_form_end([ [ "create", $self->{'text_hash'}->{'create'} ] ]);
	}
else {
	print $self->ui_form_end([ [ "save", $self->{'text_hash'}->{'save'} ],
			     [ "delete", $self->{'text_hash'}->{'delete'} ] ]);
	}

$self->ui_print_footer("list_projects.cgi", $self->{'text_hash'}->{'projects_return'});

1;
		
}


1;

