#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Show one RBAC user

&ModuleLoader::preload_module('rbac_class', "rbac::RbacLib");
$self = new rbac::RbacLib:: 'rbac_class',%$self;

$self->ReadParse();
if ($self->{'in_hash'}->{'new'}) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'user_title1'}, "");
	$self->{'access_hash'}->{'users'} || $self->{'access_hash'}->{'roles'} || $self->error($self->{'text_hash'}->{'user_ecannot'});
	}
else {
	$self->{'users'} = $self->list_user_attrs();
	$self->{'user'} = $self->{'users'}->[$self->{'in_hash'}->{'idx'}];
	$self->can_edit_user($self->{'user'}) || $self->error($self->{'text_hash'}->{'user_ecannot'});
	$self->ui_print_header(undef, $self->{'text_hash'}->{'user_title2'}, "");
	}

print $self->ui_form_start("save_user.cgi", "post");
print $self->ui_hidden("idx", $self->{'in_hash'}->{'idx'}),"\n";
print $self->ui_hidden("new", $self->{'in_hash'}->{'new'}),"\n";
print $self->ui_table_start($self->{'text_hash'}->{'user_header'}, "width=100%", 2);

print $self->ui_table_row($self->{'text_hash'}->{'user_user'},
		    $self->ui_user_textbox("user", $self->{'user'}->{'user'}));

if ($self->{'access_hash'}->{'users'} && $self->{'access_hash'}->{'roles'}) {
	print $self->ui_table_row($self->{'text_hash'}->{'user_type'},
			    $self->ui_select("type", $self->{'user'}->{'attr'}->{'type'},
				       [ [ "", $self->{'text_hash'}->{'user_tdefault'} ],
					 [ "normal", $self->{'text_hash'}->{'user_tnormal'} ],
					 [ "role", $self->{'text_hash'}->{'user_trole'} ] ]));
	}

print $self->ui_table_row($self->{'text_hash'}->{'user_profiles'},
	    $self->profiles_input("profiles", $self->{'user'}->{'attr'}->{'profiles'}, 1));

if (!$self->{'access_hash'}->{'authassign'}) {
	# Can only view auths
	print $self->ui_table_row($self->{'text_hash'}->{'user_auths'},
		    join("<br>", map { "<tt>$_</tt>" }
				     split(/,/, $self->{'user'}->{'attr'}->{'auths'})) ||
		    $self->{'text_hash'}->{'user_project1'});
	}
else {
	# Can select them
	print $self->ui_table_row($self->{'text_hash'}->{'user_auths'},
		    $self->auths_input("auths", $self->{'user'}->{'attr'}->{'auths'}));
	}

print $self->ui_table_row($self->{'text_hash'}->{'user_roles'},
	    $self->attr_input("roles", $self->{'user'}->{'attr'}->{'roles'}, "role", 1));

$self->{'p'} = $self->{'user'}->{'attr'}->{'project'};
print $self->ui_table_row($self->{'text_hash'}->{'user_project'},
		    $self->ui_radio("project_def", $self->{'p'} ? 0 : 1,
			      [ [ 1, $self->{'text_hash'}->{'user_project1'} ],
				[ 0, $self->{'text_hash'}->{'user_project0'} ] ])."\n".
		    $self->project_input("project", $self->{'p'}));

print $self->ui_table_row($self->{'text_hash'}->{'user_lock'},
		    $self->ui_radio("lock", $self->{'user'}->{'attr'}->{'lock_after_retries'},
			       [ [ "", $self->{'text_hash'}->{'user_ldefault'} ],
				 [ "yes", $self->{'text_hash'}->{'yes'} ],
				 [ "no", $self->{'text_hash'}->{'no'} ] ]));

print $self->ui_table_end();
if ($self->{'in_hash'}->{'new'}) {
	print $self->ui_form_end([ [ "create", $self->{'text_hash'}->{'create'} ] ]);
	}
else {
	print $self->ui_form_end([ [ "save", $self->{'text_hash'}->{'save'} ],
			     [ "delete", $self->{'text_hash'}->{'delete'} ] ]);
	}

$self->ui_print_footer("list_users.cgi", $self->{'text_hash'}->{'users_return'});

1;
		
}


1;

