#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Show active resource limits

&ModuleLoader::preload_module('rbac_class', "rbac::RbacLib");
$self = new rbac::RbacLib:: 'rbac_class',%$self;

$self->ReadParse();
$self->ui_print_header(undef, $self->{'text_hash'}->{'prctl_title'}, "", "prctl", 0, 0, 0,
		 $self->help_search_link("prctl", "man"));

# Show selection form
print $self->ui_form_start("list_prctl.cgi", "get");
print "<table>\n";
print "<tr> <td valign=top rowspan=4>",$self->ui_submit($self->{'text_hash'}->{'prctl_ok'}),"</td>\n";

# For a process
print "<td>",$self->ui_oneradio("mode", 0, $self->{'text_hash'}->{'prctl_mode0'},
			  $self->{'in_hash'}->{'mode'} == 0),"</td>\n";
print "<td>",$self->ui_textbox("pid", $self->{'in_hash'}->{'pid'}, 10),"</td> </tr>\n";

# For a project
print "<td>",$self->ui_oneradio("mode", 1, $self->{'text_hash'}->{'prctl_mode1'},
			  $self->{'in_hash'}->{'mode'} == 1),"</td>\n";
print "<td>",$self->project_input("project", $self->{'in_hash'}->{'project'}),"</td> </tr>\n";

# For a zone
if ($self->foreign_check("zones")) {
	$self->foreign_require("zones", "zones-lib.pl");
	@{$self->{'zones_array'}} = $main::zones_object->list_zones();
	$self->{'nozones'} = 1 if (!@{$self->{'zones_array'}});
	}
if (!$self->{'nozones'}) {
	print "<td>",$self->ui_oneradio("mode", 2, $self->{'text_hash'}->{'prctl_mode2'},
				  $self->{'in_hash'}->{'mode'} == 2),"</td>\n";
	if (@{$self->{'zones_array'}}) {
		print "<td>",$self->ui_select("zone", $self->{'in_hash'}->{'zone'},
			[ map { [ $_->{'name'} ] } $main::zones_object->list_zones() ]),
			"</td> </tr>\n";
		}
	else {
		print "<td>",$self->ui_textbox("zone", $self->{'in_hash'}->{'zone'}, 20),
		      "</td> </tr>\n";
		}
	}

# For a task
print "<td>",$self->ui_oneradio("mode", 3, $self->{'text_hash'}->{'prctl_mode3'},
			  $self->{'in_hash'}->{'mode'} == 3),"</td>\n";
print "<td>",$self->ui_textbox("task", $self->{'in_hash'}->{'task'}, 10),"</td> </tr>\n";

print "</table>\n";
print $self->ui_form_end();

if (defined($self->{'in_hash'}->{'mode'})) {
	# Show the results (if there were no errors in the input)
	if ($self->{'in_hash'}->{'mode'} == 0) {
		$self->{'err'} = $self->{'text_hash'}->{'prctl_epid'} if ($self->{'in_hash'}->{'pid'} !~ /^\d+$/);
		$self->{'id'} = $self->{'in_hash'}->{'pid'};
		$self->{'type'} = "process";
		}
	elsif ($self->{'in_hash'}->{'mode'} == 1) {
		$self->{'id'} = $self->{'in_hash'}->{'project'};
		$self->{'type'} = "project";
		}
	elsif ($self->{'in_hash'}->{'mode'} == 2) {
		$self->{'id'} = $self->{'in_hash'}->{'zone'};
		$self->{'type'} = "zone";
		}
	elsif ($self->{'in_hash'}->{'mode'} == 3) {
		$self->{'err'} = $self->{'text_hash'}->{'prctl_etask'} if ($self->{'in_hash'}->{'task'} !~ /^\d+$/);
		$self->{'id'} = $self->{'in_hash'}->{'task'};
		$self->{'type'} = "task";
		}
	if ($self->{'err'}) {
		print "<b>$self->{'err'}</b><p>\n";
		}
	elsif (@{$self->{'res_array'}} = $self->list_resource_controls($self->{'type'}, $self->{'id'})) {
		# Found some .. show them
		print $self->ui_columns_start([
			$self->{'text_hash'}->{'prctl_res'},
			$self->{'text_hash'}->{'prctl_priv'},
			$self->{'text_hash'}->{'prctl_limit'},
			$self->{'text_hash'}->{'prctl_action'} ]);
		foreach $r (@{$self->{'res_array'}}) {
			print $self->ui_columns_row([
				$r->{'res'},
				$self->{'text_hash'}->{'project_'.$r->{'priv'}} || $r->{'priv'},
				$r->{'limit'},
				$r->{'action'} =~ /^signal=(\S+)$/ ?
					$self->text('prctl_signal', "$1") :
				$self->{'text_hash'}->{'project_'.$r->{'action'}} ||
					$r->{'action'},
				]);
			}
		print $self->ui_columns_end();
		}
	else {
		print "<b>$self->{'text_hash'}->{'prctl_none'}</b><p>\n";
		}
	}

$self->ui_print_footer("", $self->{'text_hash'}->{"index_return"});

1;
		
}


1;

