#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Show a table of all project attributes

&ModuleLoader::preload_module('rbac_class', "rbac::RbacLib");
$self = new rbac::RbacLib:: 'rbac_class',%$self;

$self->ui_print_header(undef, $self->{'text_hash'}->{'projects_title'}, "", "projects", 0, 0, 0,
		 $self->help_search_link("resource_controls", "man"));

$self->{'projects'} = $self->list_projects();
@{$self->{'canprojects_array'}} = @{$self->{'projects'}};
if (@{$self->{'canprojects_array'}}) {
	print "<a href='edit_project.cgi?new=1'>$self->{'text_hash'}->{'projects_add'}</a><br>\n";
	print $self->ui_columns_start(
		[ $self->{'text_hash'}->{'projects_name'},
		  $self->{'text_hash'}->{'projects_desc'},
		  $self->{'text_hash'}->{'projects_users'},
		  $self->{'text_hash'}->{'projects_groups'} ]);
	foreach $p (sort { $a->{'name'} cmp $b->{'name'} } @{$self->{'canprojects_array'}}) {
		print $self->ui_columns_row(
			[ "<a href='edit_project.cgi?idx=$p->{'index'}'>$p->{'name'}</a>",
			  $p->{'desc'},
			  &nice_user_list("users", $p->{'users'}),
			  &nice_user_list("groups", $p->{'groups'}),
			]);
		}
	print $self->ui_columns_end();
	}
else {
	print "<b>$self->{'text_hash'}->{'projects_none'}</b><p>\n";
	}
print "<a href='edit_project.cgi?new=1'>$self->{'text_hash'}->{'projects_add'}</a><br>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{"index_return"});

1;
		
}

# nice_user_list(mode, * or !* or user,user)
sub nice_user_list
{
	shift if ($self == $_[0]);

local $mode = $_[0];
local @users = split(/,/, $_[1]);
local %users = map { $_, 1 } @users;
if ($users{'*'} && @users == 1) {
	return $self->{'text_hash'}->{'projects_all'.$mode};
	}
elsif (@users == 0 || $users{'!*'} && @users == 1) {
	return $self->{'text_hash'}->{'projects_none'.$mode};
	}
elsif ($users{'*'}) {
	# All except some
	return $self->text('projects_except'.$mode,
		     join(", ", map { /^\!(.*)/; "<tt>$1</tt>" }
			  grep { /^\!/ } @users[1..$#users]));
	}
elsif ($users{'!*'}) {
	# Only some
	return $self->text('projects_only'.$mode,
		     join(", ", map { "<tt>$_</tt>" }
			  grep { !/^\!/ } @users[1..$#users]));
	}
else {
	# Only listed
	return $self->text('projects_only'.$mode,
		     join(", ", map { "<tt>$_</tt>" } @users));
	}
}


1;

