#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Create, update or delete one RBAC authorization

&ModuleLoader::preload_module('rbac_class', "rbac::RbacLib");
$self = new rbac::RbacLib:: 'rbac_class',%$self;

$self->{'access_hash'}->{'auths'} || $self->error($self->{'text_hash'}->{'auths_ecannot'});
$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'auth_err'});

$self->lock_rbac_files();
$self->{'auths'} = $self->list_auth_attrs();
if (!$self->{'in_hash'}->{'new'}) {
	$self->{'auth'} = $self->{'auths'}->[$self->{'in_hash'}->{'idx'}];
	$self->{'logname'} = $self->{'auth'}->{'name'};
	}
else {
	$self->{'auth'} = { 'attr' => { } };
	$self->{'logname'} = $self->{'in_hash'}->{'name'};
	}

if (!$self->{'in_hash'}->{'new'}) {
	# Find users of this authorization
	$self->{'users'} = $self->list_user_attrs();
	foreach $u (@{$self->{'users'}}) {
		local @auths =
		    split(/,/, $u->{'attr'}->{'auths'});
		$self->{'idx'} = $self->indexof($self->{'logname'}, @auths);
		if ($self->{'idx'} >= 0) {
			push(@{$self->{'authusers_array'}}, [ $u, $self->{'idx'}, \@auths ]);
			}
		}
	$self->{'profs'} = $self->list_prof_attrs();
	foreach $p (@{$self->{'profs'}}) {
		local @auths =
		    split(/,/, $p->{'attr'}->{'auths'});
		$self->{'idx'} = $self->indexof($self->{'logname'}, @auths);
		if ($self->{'idx'} >= 0) {
			push(@{$self->{'authprofs_array'}}, [ $p, $self->{'idx'}, \@auths ]);
			}
		}
	}

if ($self->{'in_hash'}->{'delete'}) {
	# Just delete this auth
	@{$self->{'authusers_array'}} && $self->error($self->text('auth_einuseu',
				   $self->{'authusers_array'}->[0]->[0]->{'user'}));
	@{$self->{'authprofs_array'}} && $self->error($self->text('auth_einusep',
				   $self->{'authprofs_array'}->[0]->[0]->{'name'}));
	$self->delete_auth_attr($self->{'auth'});
	}
else {
	# Check for clash
	if ($self->{'in_hash'}->{'new'} || $self->{'logname'} ne $self->{'in_hash'}->{'name'}) {
		($self->{'clash'}) = grep { $_->{'name'} eq $self->{'in_hash'}->{'name'} } @{$self->{'auths'}};
		$self->{'clash'} && $self->error($self->{'text_hash'}->{'auth_eclash'});
		}

	# Validate and store inputs
	$self->{'in_hash'}->{'name'} =~ /^[^:]+$/ || $self->error($self->{'text_hash'}->{'auth_ename'});
	$self->{'auth'}->{'name'} = $self->{'in_hash'}->{'name'};
	$self->{'in_hash'}->{'short'} =~ /^[^:]*$/ || $self->error($self->{'text_hash'}->{'auth_eshort'});
	$self->{'auth'}->{'short'} = $self->{'in_hash'}->{'short'};
	$self->{'in_hash'}->{'desc'} =~ /^[^:]*$/ || $self->error($self->{'text_hash'}->{'auth_edesc'});
	$self->{'auth'}->{'desc'} = $self->{'in_hash'}->{'desc'};

	# Save or update authile
	if ($self->{'in_hash'}->{'new'}) {
		$self->create_auth_attr($self->{'auth'});
		}
	else {
		$self->modify_auth_attr($self->{'auth'});

		# Update other users of this authorization, if renamed
		if ($self->{'logname'} ne $self->{'in_hash'}->{'name'}) {
			foreach $au (@{$self->{'authusers_array'}}) {
				$au->[2]->[$au->[1]] = $self->{'in_hash'}->{'name'};
				$au->[0]->{'attr'}->{'auths'} =
					join(",", @{$au->[2]});
				$self->modify_user_attr($au->[0]);
				}
			foreach $ap (@{$self->{'authprofs_array'}}) {
				$ap->[2]->[$ap->[1]] = $self->{'in_hash'}->{'name'};
				$ap->[0]->{'attr'}->{'auths'} =
					join(",", @{$ap->[2]});
				$self->modify_prof_attr($ap->[0]);
				}
			}
		}
	}

$self->unlock_rbac_files();
$self->webmin_log($self->{'in_hash'}->{'delete'} ? "delete" : $self->{'in_hash'}->{'new'} ? "create" : "modify",
	    "auth", $self->{'logname'}, $self->{'auth'});
$self->redirect("list_auths.cgi");

1;
		
}


1;

