#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Create, update or delete one RBAC execution profile

&ModuleLoader::preload_module('rbac_class', "rbac::RbacLib");
$self = new rbac::RbacLib:: 'rbac_class',%$self;

$self->{'access_hash'}->{'execs'} || $self->error($self->{'text_hash'}->{'execs_ecannot'});
$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'exec_err'});

$self->lock_rbac_files();
$self->{'execs'} = $self->list_exec_attrs();
if (!$self->{'in_hash'}->{'new'}) {
	$self->{'exec'} = $self->{'execs'}->[$self->{'in_hash'}->{'idx'}];
	$self->{'logname'} = $self->{'exec'}->{'name'};
	}
else {
	$self->{'exec'} = { 'attr' => { } };
	$self->{'logname'} = $self->{'in_hash'}->{'name'};
	}

if ($self->{'in_hash'}->{'delete'}) {
	# Just delete this execution profile
	$self->delete_exec_attr($self->{'exec'});
	}
else {
	# Validate and store inputs
	$self->{'exec'}->{'name'} = $self->{'in_hash'}->{'name'};
	$self->{'exec'}->{'policy'} = $self->{'in_hash'}->{'policy'};
	if ($self->{'in_hash'}->{'id_def'}) {
		$self->{'exec'}->{'id'} = '*';
		}
	else {
		$self->{'in_hash'}->{'id'} =~ /^\/\S+/ || $self->error($self->{'text_hash'}->{'exec_eid'});
		$self->{'exec'}->{'id'} = $self->{'in_hash'}->{'id'};
		}
	$self->{'exec'}->{'cmd'} ||= 'cmd';
	foreach $i ("uid", "gid", "euid", "egid") {
		if ($self->{'in_hash'}->{$i."_def"}) {
			delete($self->{'exec'}->{'attr'}->{$i});
			}
		else {
			$self->{'in_hash'}->{$i} =~ /\S/ || $self->error($self->{'text_hash'}->{'exec_err'.$i});
			$self->{'exec'}->{'attr'}->{$i} = $self->{'in_hash'}->{$i};
			}
		}

	# Save or update execution profile
	if ($self->{'in_hash'}->{'new'}) {
		$self->create_exec_attr($self->{'exec'});
		}
	else {
		$self->modify_exec_attr($self->{'exec'});
		}
	}

$self->unlock_rbac_files();
$self->webmin_log($self->{'in_hash'}->{'delete'} ? "delete" : $self->{'in_hash'}->{'new'} ? "create" : "modify",
	    "exec", $self->{'logname'}, $self->{'exec'});
$self->redirect("list_execs.cgi");

1;
		
}


1;

