#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Save global policy settings

&ModuleLoader::preload_module('rbac_class', "rbac::RbacLib");
$self = new rbac::RbacLib:: 'rbac_class',%$self;

$self->{'access_hash'}->{'policy'} || $self->error($self->{'text_hash'}->{'policy_ecannot'});
$self->error_setup($self->{'text_hash'}->{'policy_err'});
$self->lock_rbac_files();
$self->{'conf'} = $self->get_policy_config();
$self->ReadParse();

# Validate and save inputs
$self->{'auths'} = $self->auths_parse("auths");
$self->save_policy($self->{'conf'}, "AUTHS_GRANTED", $self->{'auths'});
$self->{'profs'} = $self->profiles_parse("profs");
$self->save_policy($self->{'conf'}, "PROFS_GRANTED", $self->{'profs'});

if ($self->{'in_hash'}->{'allow_def'}) {
	$self->save_policy($self->{'conf'}, "CRYPT_ALGORITHMS_ALLOW", undef);
	}
else {
	$self->{'allow'} = join(",", split(/\0/, $self->{'in_hash'}->{'allow'}));
	$self->{'allow'} || $self->error($self->{'text_hash'}->{'policy_eallow'});
	$self->{'in_hash'}->{'deprecate_def'} || $self->error($self->{'text_hash'}->{'policy_eclash'});
	$self->save_policy($self->{'conf'}, "CRYPT_ALGORITHMS_ALLOW", $self->{'allow'});
	}

if ($self->{'in_hash'}->{'default_def'}) {
	$self->save_policy($self->{'conf'}, "CRYPT_DEFAULT", undef);
	}
else {
	$self->save_policy($self->{'conf'}, "CRYPT_DEFAULT", $self->{'in_hash'}->{'default'});
	}

if ($self->{'in_hash'}->{'deprecate_def'}) {
	$self->save_policy($self->{'conf'}, "CRYPT_ALGORITHMS_DEPRECATE", undef);
	}
else {
	$self->save_policy($self->{'conf'}, "CRYPT_ALGORITHMS_DEPRECATE", $self->{'in_hash'}->{'deprecate'});
	}

$self->flush_file_lines();
$self->unlock_rbac_files();
$self->webmin_log("policy");
$self->redirect("");

1;
		
}


1;

