#!/usr/bin/perl
package samba::Log_parser;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'samba::Log_parser');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# log_parser.pl
# Functions for parsing this module's logs

&ModuleLoader::preload_module(ref($self), "samba::SambaLib");
$self = new samba::SambaLib:: ref($self), %$self; 

1;
		return $self;
}

# parse_webmin_log(user, script, action, type, object, &params)
# Converts logged information from this module into human-readable form
sub parse_webmin_log
{
	my $self = shift;

local ($user, $script, $action, $type, $object, $p, $long) = @_;
$object = $self->html_escape($object);
if ($type eq 'shares') {
	return $self->text("log_delete_${type}", $object);
	}
elsif ($action eq 'save') {
	if ($object eq 'global') {
		return $self->{'text_hash'}->{"log_default_${type}"};
		}
	else {
		return $self->text("log_save_${type}", "<tt>$object</tt>");
		}
	}
elsif ($action eq 'create') {
	return $self->text("log_create_${type}", "<tt>$object</tt>");
	}
elsif ($action eq 'delete') {
	return $self->text("log_delete_${type}", "<tt>$object</tt>");
	}
elsif ($action eq 'manual') {
	return $self->text("log_manual", "<tt>$object</tt>");
	}
elsif ($action eq 'copy') {
	return $self->text('log_copy', "<tt>$object</tt>",
		     "<tt>".$self->html_escape($p->{'copy'})."</tt>");
	}
elsif ($action eq 'epass') {
	return $self->text($long ? 'log_epass_l' : 'log_epass',
		     int($p->{'created'}), int($p->{'modified'}),
		     int($p->{'deleted'}));
	}
elsif ($type eq 'euser') {
	return $self->text("log_${action}_euser", "<tt>$object</tt>");
	}
elsif ($type eq 'group') {
	return $self->text("log_${action}_group", "<tt>$object</tt>");
	}
elsif ($action eq 'kill') {
	if ($p->{'share'}) {
		return $self->text('log_skill', "<tt>$object</tt>",
			     "<tt>".$self->html_escape($p->{'share'})."</tt>");
		}
	else {
		return $self->text('log_kill', "<tt>$object</tt>");
		}
	}
elsif ($action eq 'kills') {
	if ($p->{'share'}) {
		return $self->text('log_skills', $object,
			     "<tt>".$self->html_escape($p->{'share'})."</tt>");
		}
	else {
		return $self->text('log_kills', $object);
		}
	}
elsif ($self->{'text_hash'}->{"log_${action}"}) {
	return $self->{'text_hash'}->{"log_${action}"};
	}
else {
	return undef;
	}
}


1;

