#!/usr/bin/perl

&MAIN();

 sub MAIN {
# index.cgi
# Display a list of available samba shares. Special shares (like [homes] and
# [printers]) are included as well.

&ModuleLoader::preload_module('samba_class', "samba::SambaLib");
$self = new samba::SambaLib:: 'samba_class',%$self;

%{$self->{'access_hash'}} = $self->get_module_acl();

# Check for Samba executable
if (!-x $self->{'config_hash'}->{'samba_server'}) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", undef, 1, 1, 0,
		$self->help_search_link("samba", "man", "doc", "google"));
	print $self->text('error_nosamba', $self->{'config_hash'}->{'samba_server'}, "$self->{'gconfig_hash'}->{'webprefix'}/config.cgi?$self->{'module_name'}"),"<p>\n";

	$self->foreign_require("software", "software-lib.pl");
	$self->{'lnk'} = $main::software_object->missing_install_link("samba", $self->{'text_hash'}->{'index_samba'},
			"../$self->{'module_name'}/", $self->{'text_hash'}->{'index_title'});
	print $self->{'lnk'},"<p>\n" if ($self->{'lnk'});

	$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});
	exit;
	}

# Check the samba version
if ($self->{'samba_version'} = $self->get_samba_version(\$self->{'out'})) {
	# Save version number
	$self->open_tempfile(VERSION, ">$self->{'module_config_directory'}/version");
	$self->print_tempfile(VERSION, $self->{'samba_version'},"\n");
	$self->close_tempfile(VERSION);
	}
else {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", undef, 1, 1, 0,
		$self->help_search_link("samba", "man", "doc", "google"));
	print $self->text('error_version', $self->{'config_hash'}->{'samba_server'}, "$self->{'gconfig_hash'}->{'webprefix'}/config.cgi?$self->{'module_name'}"),"<p>\n";
	print "<pre>$self->{'out'}</pre>\n";
	$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});
	exit;
	}
$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", undef, 1, 1, 0,
	$self->help_search_link("samba", "man", "doc", "google"), undef, undef,
	$self->text('index_version', $self->{'samba_version'}));

@{$self->{'empty_array'}} = $self->list_shares();
if (!@{$self->{'empty_array'}} && (-r $self->{'config_hash'}->{alt_smb_conf})) {
	# Copy the sample smb.conf file to the real location
	# This is a hack for slackware
	system("cp $self->{'config_hash'}->{alt_smb_conf} $self->{'config_hash'}->{smb_conf} >/dev/null 2>&1");
	}
if (!(-r $self->{'config_hash'}->{smb_conf})) {
	print $self->text('error_config', $self->{'config_hash'}->{'smb_conf'}, "$self->{'gconfig_hash'}->{'webprefix'}/config.cgi?$self->{'module_name'}");
	print "<p>\n";
	$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});
	exit;
	}

# Check for 'config' or 'include' directives
$self->get_share("global");
if ($self->getval("config") || $self->getval("include")) {
	print $self->text('index_einclude',
		    "<tt>$self->{'config_hash'}->{'smb_conf'}</tt>",
		    "<tt>config</tt>", "<tt>include</tt>"),"<p>\n";
	}

# Work out links for adding things
@{$self->{'links_array'}} = ( );
push(@{$self->{'links_array'}}, "<a href=edit_fshare.cgi>$self->{'text_hash'}->{'index_createfileshare'}</a>")
	if ($self->{'access_hash'}->{'c_fs'});
push(@{$self->{'links_array'}}, "<a href=edit_pshare.cgi>$self->{'text_hash'}->{'index_createprnshare'}</a>")
	if ($self->{'access_hash'}->{'c_ps'});
push(@{$self->{'links_array'}}, "<a href=create_copy.cgi>$self->{'text_hash'}->{'index_createcopy'}</a>")
	if ($self->{'access_hash'}->{'copy'});
push(@{$self->{'links_array'}}, "<a href=view_users.cgi>$self->{'text_hash'}->{'index_view'}</a>")
	if ($self->{'access_hash'}->{'view_all_con'});

foreach $s ($self->list_shares()) {
	next unless $self->can('r', \%{$self->{'access_hash'}}, $s) || !$self->{'access_hash'}->{'hide'};
	$self->{'us'} = "share=".$self->urlize($s);
	if ($s eq "global") { next; }
	if (!$self->{'donefirst'}) {
		# Show headers
		@{$self->{'tds_array'}} = ( "width=5" );
		print $self->ui_form_start("delete_shares.cgi", "post");
		unshift(@{$self->{'links_array'}}, $self->select_all_link("d"),
				$self->select_invert_link("d"));
		print $self->ui_links_row(\@{$self->{'links_array'}});
		print $self->ui_columns_start([
			"",
			$self->{'text_hash'}->{'index_sharename'},
			$self->{'text_hash'}->{'index_path'},
			$self->{'text_hash'}->{'index_security'} ], 100, 0, \@{$self->{'tds_array'}});
		$self->{'donefirst'} = 1;
		}

	# Show share details
	$self->get_share($s);
	local @cols;
	if ($self->{'cp'} = $self->getval("copy")) { $self->{'cp'} = "(copy of <i>$self->{'cp'}</i>)"; }
	if ($self->istrue("printable")) {
		push(@cols, "<a href=\"edit_pshare.cgi?$self->{'us'}\">".
			    $self->html_escape($s)."</a> $self->{'cp'}");
		}
	else {
		push(@cols, "<a href=\"edit_fshare.cgi?$self->{'us'}\">".
			    $self->html_escape($s)."</a> $self->{'cp'}");
		}

	# Output location / path info
	if ($s eq "homes") {
		$self->{'p'} = "<i>$self->{'text_hash'}->{'index_homedir'}</i>";
		}
	elsif ($s eq "printers") {
		$self->{'p'} = "<i>$self->{'text_hash'}->{'index_allprinter'}</i>";
		}
	elsif ($self->istrue("printable")) {
		$self->{'p'} = $self->getval("printer") ? $self->{'text_hash'}->{'index_printer'}." ".$self->html_escape($self->getval("printer")) : $self->{'text_hash'}->{'index_defaultprn'};
		}
	else {
		$self->{'p'} = $self->html_escape($self->getval("path"));
		}
	push(@cols, $self->{'p'});

	# Output security information
	if ($self->istrue("printable")) {
		if ($self->getval("valid users")) {
			# Only accessible to some users..
			$self->{'sc'} = $self->{'text_hash'}->{'index_printableto'}." ".
				$self->user_list($self->getval("valid users"));
			}
		elsif ($self->istrue("public")) {
			# Accessible to everyone
			$self->{'sc'} = $self->{'text_hash'}->{'index_prneveryone'};
			}
		else {
			$self->{'sc'} = $self->{'text_hash'}->{'index_prnalluser'};
			}
		}
	elsif ($self->istrue("writable")) {
		# Default is read/write access
		if ($self->istrue("public")) {
			# No password needed..
			$self->{'sc'} = $self->{'text_hash'}->{'index_rwpublic'};
			}
		else {
			# Password needed..
			if ($self->getval("read list")) {
				$self->{'sc'} = $self->text('index_readonly', $self->user_list($self->getval("read list")));
				}
			else {
				$self->{'sc'} = $self->{'text_hash'}->{'index_rwalluser'};
				}
			}
		}
	else {
		# Default is read-only access
		if ($self->istrue("public")) {
			# No password needed..
			$self->{'sc'} = $self->{'text_hash'}->{'index_roeveryone'};
			}
		else {
			# Password needed..
			if ($self->getval("write list")) {
				$self->{'sc'} = $self->text('index_readwrite', $self->user_list($self->getval("write list")));
				}
			else {
				$self->{'sc'} = $self->{'text_hash'}->{'index_roalluser'};
				}
			}
		}
	push(@cols, $self->{'sc'});
	print $self->ui_checked_columns_row(\@cols, \@{$self->{'tds_array'}}, "d", $s);
	}
if ($self->{'donefirst'}) {
	print $self->ui_columns_end();
	}
else {
	print "<b>$self->{'text_hash'}->{'index_noshares'}</b>. <p>\n";
	}
print $self->ui_links_row(\@{$self->{'links_array'}});
if ($self->{'donefirst'}) {
	print $self->ui_form_end([ [ "delete", $self->{'text_hash'}->{'index_delete'} ] ]);
	}

@{$self->{'gc_acl_array'}} = qw(conf_net conf_smb conf_pass conf_print conf_misc conf_bind
			  ACLfs_global ACLps_global manual swat);
@{$self->{'gc_progs_array'}} = ("conf_net.cgi", "conf_smb.cgi", "conf_pass.cgi",
	     "conf_print.cgi", "conf_misc.cgi", "conf_bind.cgi",
	     "edit_fshare.cgi?share=global", "edit_pshare.cgi?share=global",
	     "edit_manual.cgi");
@{$self->{'gc_names_array'}} = ($self->{'text_hash'}->{'global_unixnetwork'}, $self->{'text_hash'}->{'global_winnetwork'},
	     $self->{'text_hash'}->{'global_auth'}, $self->{'text_hash'}->{'global_printing'},
	     $self->{'text_hash'}->{'global_misc'}, $self->{'text_hash'}->{'global_bind'},
	     $self->{'text_hash'}->{'global_filedefault'},
	     $self->{'text_hash'}->{'global_prndefault'},
	     $self->{'text_hash'}->{'manual_title'});
@{$self->{'gc_icons_array'}} = ("images/icon_0.gif", "images/icon_1.gif", "images/icon_2.gif",
	     "images/icon_3.gif", "images/icon_4.gif",
	     "images/icon_10.gif", "images/icon_5.gif", "images/icon_6.gif",
	     "images/manual.gif");
if ($self->has_command($self->{'config_hash'}->{'swat_path'})) {
	push(@{$self->{'gc_progs_array'}}, "swat.cgi");
	push(@{$self->{'gc_names_array'}}, "SWAT");
	push(@{$self->{'gc_icons_array'}}, "images/icon_9.gif");
	}

foreach $i (0..$#{$self->{'gc_acl_array'}}) {
	next unless ($self->{'access_hash'}->{$self->{'gc_acl_array'}->[$i]} && $self->{'gc_progs_array'}->[$i]);
	next if ($self->{'gc_acl_array'}->[$i] eq "conf_winbind" && $self->{'samba_version'} < 3);
	push(@{$self->{'gc_progs1_array'}}, $self->{'gc_progs_array'}->[$i]);
	push(@{$self->{'gc_names1_array'}}, $self->{'gc_names_array'}->[$i]);
	push(@{$self->{'gc_icons1_array'}}, $self->{'gc_icons_array'}->[$i]);
	$self->{'disp'}++;
	}

if ($self->{'disp'}) {
	print "<hr>\n";
	print $self->ui_subheading($self->{'text_hash'}->{'global_title'});
	$self->icons_table(\@{$self->{'gc_progs1_array'}}, \@{$self->{'gc_names1_array'}}, \@{$self->{'gc_icons1_array'}}, 4);
	}

# Generate table of accessible user and group editing icons
if ($self->{'access_hash'}->{'view_users'}) {
	push(@{$self->{'utitles_array'}}, $self->{'text_hash'}->{'global_edit'});
	push(@{$self->{'ulinks_array'}}, "edit_epass.cgi");
	push(@{$self->{'uicons_array'}}, "images/editepass.gif");
	}
if ($self->{'access_hash'}->{'maint_makepass'}) {
	push(@{$self->{'utitles_array'}}, $self->{'text_hash'}->{'global_convert'});
	push(@{$self->{'ulinks_array'}}, "ask_epass.cgi");
	push(@{$self->{'uicons_array'}}, "images/askepass.gif");
	}
if ($self->{'access_hash'}->{'maint_sync'}) {
	push(@{$self->{'utitles_array'}}, $self->{'text_hash'}->{'global_sync'});
	push(@{$self->{'ulinks_array'}}, "edit_sync.cgi");
	push(@{$self->{'uicons_array'}}, "images/editsync.gif");
	}
if ($self->{'samba_version'} >= 3) {
	if ($self->{'access_hash'}->{'maint_groups'}) {
		push(@{$self->{'utitles_array'}}, $self->{'text_hash'}->{'global_gedit'});
		push(@{$self->{'ulinks_array'}}, "list_groups.cgi");
		push(@{$self->{'uicons_array'}}, "images/listgroups.gif");
		}
	if ($self->{'access_hash'}->{'maint_gsync'}) {
		push(@{$self->{'utitles_array'}}, $self->{'text_hash'}->{'global_gsync'});
		push(@{$self->{'ulinks_array'}}, "edit_gsync.cgi");
		push(@{$self->{'uicons_array'}}, "images/editgsync.gif");
		}
	if ($self->{'access_hash'}->{'winbind'} && $self->{'has_net'}) {
		push(@{$self->{'utitles_array'}}, $self->{'text_hash'}->{'global_winbind'});
		push(@{$self->{'ulinks_array'}}, "edit_winbind.cgi");
		push(@{$self->{'uicons_array'}}, "images/winbind.gif");
		}
	}

if (@{$self->{'utitles_array'}}) {
	# We have some icons to show
	print "<hr>\n";
	print $self->ui_subheading($self->{'text_hash'}->{'global_users'});
	$self->icons_table(\@{$self->{'ulinks_array'}}, \@{$self->{'utitles_array'}}, \@{$self->{'uicons_array'}}, 3);
	}

if ($self->{'access_hash'}->{'apply'}) {
	$self->{'isrun'} = $self->is_samba_running();
	if ($self->{'isrun'} == 0) {
		print "<hr>\n";
		print "<form action=start.cgi>\n";
		print "<table width=100%><tr>\n";
		print "<td><input type=submit value=\"$self->{'text_hash'}->{'index_start'}\"></td>\n";
		print "<td>$self->{'text_hash'}->{'index_startmsg'}</td>\n";
		print "</tr></table></form>\n";
		}
	elsif ($self->{'isrun'} == 1) {
		print "<hr>\n";
		print "<table width=100%><tr>\n";
		print "<form action=restart.cgi>\n";
		print "<td><input type=submit value=\"$self->{'text_hash'}->{'index_restart'}\"></td>\n";
		print "<td>$self->{'text_hash'}->{'index_restartmsg'}\n";
		print "$self->{'text_hash'}->{'index_restartmsg2'}</td>\n";
		print "</tr></form>\n";

		print "<form action=stop.cgi>\n";
		print "<td><input type=submit value=\"$self->{'text_hash'}->{'index_stop'}\"></td>\n";
		print "<td>$self->{'text_hash'}->{'index_stopmsg'}</td>\n";
		print "</tr></form>\n";
		print "</table>\n";
		}
	}

$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});

1;
		
}

sub show_buttons
{
	shift if ($self == $_[0]);

}


1;

