#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_bind.cgi
# Save inputs from conf_bind.cgi

&ModuleLoader::preload_module('samba_class', "samba::SambaLib");
$self = new samba::SambaLib:: 'samba_class',%$self;

$self->ReadParse();
$self->lock_file($self->{'config_hash'}->{'smb_conf'});
$self->{'global'} = $self->get_share("global");

# check acls
%{$self->{'access_hash'}} = $self->get_module_acl();
$self->error_setup("<blink><font color=red>$self->{'text_hash'}->{'eacl_aviol'}</font></blink>");
$self->error("$self->{'text_hash'}->{'eacl_np'} $self->{'text_hash'}->{'eacl_pcm'}") unless $self->{'access_hash'}->{'conf_bind'};
 
$self->error_setup($self->{'text_hash'}->{'bind_err'});
$self->setval("winbind enable local accounts", $self->{'in_hash'}->{'local'} ? "yes" : "no");

$self->setval("winbind trusted domains only", $self->{'in_hash'}->{'trust'} ? "yes" : "no");

$self->setval("winbind enum users", $self->{'in_hash'}->{'users'} ? "yes" : "no");

$self->setval("winbind enum groups", $self->{'in_hash'}->{'groups'} ? "yes" : "no");

$self->{'in_hash'}->{'realm'} eq "" || $self->{'in_hash'}->{'realm'} =~ /^\S+$/ || $self->error($self->{'text_hash'}->{'bind_erealm'});
$self->setval("realm", $self->{'in_hash'}->{'realm'});

$self->{'in_hash'}->{'cache'} =~ /^\d+$/ || $self->error($self->{'text_hash'}->{'bind_ecache'});
$self->setval("winbind cache time", $self->{'in_hash'}->{'cache'});

$self->{'in_hash'}->{'uid'} eq "" || $self->{'in_hash'}->{'uid'} =~ /^\d+\-\d+$/ || $self->error($self->{'text_hash'}->{'bind_euid'});
$self->setval("idmap uid", $self->{'in_hash'}->{'uid'});

$self->{'in_hash'}->{'gid'} eq "" || $self->{'in_hash'}->{'gid'} =~ /^\d+\-\d+$/ || $self->error($self->{'text_hash'}->{'bind_egid'});
$self->setval("idmap gid", $self->{'in_hash'}->{'gid'});

$self->setval("idmap backend", $self->{'in_hash'}->{'backend_def'} ? "" : $self->{'in_hash'}->{'backend'});

if ($self->{'global'}) { $self->modify_share("global", "global"); }
else { $self->create_share("global"); }
$self->unlock_file($self->{'config_hash'}->{'smb_conf'});
$self->webmin_log("bind", undef, undef, \%{$self->{'in_hash'}});
$self->redirect("");

1;
		
}


1;

