#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_fshare.cgi
# Save a new or edited file share

&ModuleLoader::preload_module('samba_class', "samba::SambaLib");
$self = new samba::SambaLib:: 'samba_class',%$self;

$self->ReadParse();
$self->lock_file($self->{'config_hash'}->{'smb_conf'});
$self->get_share($self->{'in_hash'}->{old_name}) if $self->{'in_hash'}->{old_name};

# check acls
%{$self->{'access_hash'}} = $self->get_module_acl();
$self->error_setup("<blink><font color=red>$self->{'text_hash'}->{'eacl_aviol'}</font></blink>");
if ($self->{'in_hash'}->{old_name}) {
    $self->error("$self->{'text_hash'}->{'eacl_np'} $self->{'text_hash'}->{'eacl_pus'}") 
		unless $self->can('rw', \%{$self->{'access_hash'}}, $self->{'in_hash'}->{old_name});
	}
else {
    $self->error("$self->{'text_hash'}->{'eacl_np'} $self->{'text_hash'}->{'eacl_pcrs'}") unless $self->{'access_hash'}->{'c_fs'};
	}

$self->{'whatfailed'} = $self->{'text_hash'}->{'savefshare_fail'};
# store share options
if ($self->{'in_hash'}->{old_name} eq "global") {
	$self->{'name'} = "global";
	}
else {
	$self->{'name'} = $self->{'in_hash'}->{"homes"} ? "homes" : $self->{'in_hash'}->{"share"};
	if ($self->{'in_hash'}->{"path"} !~ /\S/ && !$self->{'in_hash'}->{"homes"}) {
		$self->error($self->{'text_hash'}->{'savefshare_nopath'});
		}
	}
$self->setval("path", $self->{'in_hash'}->{"path"});
$self->setval("available", $self->{'in_hash'}->{"available"});
$self->setval("browseable", $self->{'in_hash'}->{"browseable"});
$self->setval("comment", $self->{'in_hash'}->{"comment"});

# Check for clash
if ($self->{'name'} ne "global") {
	foreach ($self->list_shares()) {
		$self->{'exists_hash'}->{$_}++;
		}
	if (!$self->{'in_hash'}->{old_name} && $self->{'exists_hash'}->{$self->{'name'}}) {
		$self->error($self->text('savefshare_exist', $self->{'name'}));
		}
	elsif ($self->{'in_hash'}->{old_name} ne $self->{'name'} && $self->{'exists_hash'}->{$self->{'name'}}) {
		$self->error($self->text('savefshare_exist', $self->{'name'}));
		}
	elsif ($self->{'name'} !~ /^[A-Za-z0-9_\$ ]+$/) {
		$self->error($self->text('savefshare_mode', $self->{'name'}));
		}
	elsif ($self->{'name'} eq "global") {   # unreachable code ? EB
		$self->error($self->{'text_hash'}->{'savefshare_global'});
		}
	}

# Check creator
if ($self->{'in_hash'}->{'create'} eq "yes") {
	defined(getpwnam($self->{'in_hash'}->{'createowner'})) ||
		$self->error($self->{'text_hash'}->{'savefshare_owner'});
	}

# Update config file
if ($self->{'in_hash'}->{old_name}) {
	# Changing an existing share
	$self->modify_share($self->{'in_hash'}->{old_name}, $self->{'name'});
	if ($self->{'name'} ne $self->{'in_hash'}->{old_name}) {
		local $oldacl=$self->{'access_hash'}->{'ACLfs_' . $self->{'in_hash'}->{old_name}};
		$self->drop_samba_acl(\%{$self->{'access_hash'}}, $self->{'in_hash'}->{old_name});
		$self->save_samba_acl($oldacl, \%{$self->{'access_hash'}}, $self->{'name'});
		}
	}
else {
	# Creating a new share
	$self->create_share($self->{'name'});
	if ($self->{'in_hash'}->{'create'} eq "yes" && !-d $self->{'in_hash'}->{'path'}) {
		mkdir($self->{'in_hash'}->{'path'}, 0755);
		@{$self->{'uinfo_array'}} = getpwnam($self->{'in_hash'}->{'createowner'});
		chown($self->{'uinfo_array'}->[2], $self->{'uinfo_array'}->[3], $self->{'in_hash'}->{'path'});
	}
	$self->save_samba_acl('rwvVsSpPnNoO', \%{$self->{'access_hash'}}, $self->{'name'});
	}
$self->unlock_file($self->{'config_hash'}->{'smb_conf'});
$self->webmin_log($self->{'in_hash'}->{old_name} ? "save" : "create", "fshare", $self->{'name'}, \%{$self->{'in_hash'}});
$self->redirect("");
1;
		
}


1;

