#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_group.cgi
# Update or delete a Samba group

&ModuleLoader::preload_module('samba_class', "samba::SambaLib");
$self = new samba::SambaLib:: 'samba_class',%$self;

%{$self->{'access_hash'}} = $self->get_module_acl();
$self->{'access_hash'}->{'maint_groups'} || $self->error($self->{'text_hash'}->{'groups_ecannot'});
$self->ReadParse();
@{$self->{'groups_array'}} = $self->list_groups();
$self->{'group'} = $self->{'groups_array'}->[$self->{'in_hash'}->{'idx'}] if (!$self->{'in_hash'}->{'new'});
$self->{'oldname'} = $self->{'group'}->{'name'} || $self->{'in_hash'}->{'name'};

if ($self->{'in_hash'}->{'delete'}) {
	# Just remove this group
	$self->delete_group($self->{'group'});
	}
else {
	# Validate inputs
	$self->error_setup($self->{'text_hash'}->{'gsave_err'});
	if ($self->{'in_hash'}->{'new'}) {
		$self->{'in_hash'}->{'name'} =~ /\S/ || $self->error($self->{'text_hash'}->{'gsave_ename'});
		$self->{'group'}->{'name'} = $self->{'in_hash'}->{'name'};
		}
	$self->{'group'}->{'type'} = $self->{'in_hash'}->{'type'};
	if ($self->{'in_hash'}->{'unix_def'}) {
		$self->{'group'}->{'unix'} = -1;
		}
	else {
		getgrnam($self->{'in_hash'}->{'unix'}) || $self->{'in_hash'}->{'unix'} =~ /^\-?\d+$/ ||
			$self->error($self->{'text_hash'}->{'gsave_eunix'});
		$self->{'group'}->{'unix'} = $self->{'in_hash'}->{'unix'};
		}
	$self->{'group'}->{'desc'} = $self->{'in_hash'}->{'desc'};
	if ($self->{'in_hash'}->{'new'} && !$self->{'in_hash'}->{'priv_def'}) {
		$self->{'in_hash'}->{'priv'} =~ /\S/ || $self->error($self->{'text_hash'}->{'gsave_epriv'});
		$self->{'in_hash'}->{'type'} eq 'l' || $self->error($self->{'text_hash'}->{'gsave_elocal'});
		$self->{'group'}->{'priv'} = $self->{'in_hash'}->{'priv'};
		}

	# Update or create the group
	if ($self->{'in_hash'}->{'new'}) {
		$self->create_group($self->{'group'});
		}
	else {
		$self->modify_group($self->{'group'});
		}
	}
$self->webmin_log($self->{'in_hash'}->{'new'} ? "create" : $self->{'in_hash'}->{'delete'} ? "delete" : "modify",
	    "group", $self->{'oldname'}, \%{$self->{'group_hash'}});
$self->redirect("list_groups.cgi");

1;
		
}


1;

