#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_misc.cgi
# Save inputs from conf_misc.cgi

&ModuleLoader::preload_module('samba_class', "samba::SambaLib");
$self = new samba::SambaLib:: 'samba_class',%$self;

$self->ReadParse();
$self->lock_file($self->{'config_hash'}->{'smb_conf'});
$self->{'global'} = $self->get_share("global");

# check acls
%{$self->{'access_hash'}} = $self->get_module_acl();
$self->error_setup("<blink><font color=red>$self->{'text_hash'}->{'eacl_aviol'}</font></blink>");
$self->error("$self->{'text_hash'}->{'eacl_np'} $self->{'text_hash'}->{'eacl_pcm'}") unless $self->{'access_hash'}->{'conf_misc'};
 
$self->{'whatfailed'} = $self->{'text_hash'}->{'savemisc_fail'};
$self->setval("debug level", $self->{'in_hash'}->{debug_level}, "");

$self->setval("getwd cache", $self->{'in_hash'}->{getwd_cache}, "no");

if (!$self->{'in_hash'}->{lock_directory_def} && !(-d &parent_dir($self->{'in_hash'}->{lock_directory}))) {
	$self->error($self->{'text_hash'}->{'savemisc_lockdir'});
	}
$self->setval("lock directory", $self->{'in_hash'}->{lock_directory_def}?"":$self->{'in_hash'}->{lock_directory}, "");

if (!$self->{'in_hash'}->{log_file_def} && !(-d &parent_dir($self->{'in_hash'}->{log_file}))) {
	$self->error($self->{'text_hash'}->{'savemisc_logdir'});
	}
$self->setval("log file", $self->{'in_hash'}->{log_file_def} ? "" : $self->{'in_hash'}->{log_file}, "");

if (!$self->{'in_hash'}->{max_log_size_def} && $self->{'in_hash'}->{max_log_size} !~ /^\d+$/) {
	$self->error($self->text('savemisc_logsize',$self->{'in_hash'}->{max_log_size}));
	}
$self->setval("max log size", $self->{'in_hash'}->{max_log_size_def} ? 0 : $self->{'in_hash'}->{max_log_size}, 0);

$self->setval("read raw", $self->{'in_hash'}->{read_raw}, "yes");

$self->setval("write raw", $self->{'in_hash'}->{write_raw}, "yes");

if (!$self->{'in_hash'}->{read_size_def} && $self->{'in_hash'}->{read_size} !~ /^\d+$/) {
	$self->error($self->text('savemisc_overlap',$self->{'in_hash'}->{read_size}));
	}
$self->setval("read size", $self->{'in_hash'}->{read_size_def} ? 0 : $self->{'in_hash'}->{read_size}, 0);

if (!$self->{'in_hash'}->{root_directory_def} && !(-d $self->{'in_hash'}->{root_directory})) {
	$self->error($self->text('savemisc_chroot', $self->{'in_hash'}->{root_directory}));
	}
$self->setval("root directory", $self->{'in_hash'}->{root_directory_def}?"":$self->{'in_hash'}->{root_directory}, "");

if (!$self->{'in_hash'}->{smbrun_def} && !(-x $self->{'in_hash'}->{smbrun})) {
	$self->error($self->text('savemisc_smbrun', $self->{'in_hash'}->{smbrun}));
	}
$self->setval("smbrun", $self->{'in_hash'}->{smbrun_def} ? "" : $self->{'in_hash'}->{smbrun}, "");

if (!$self->{'in_hash'}->{time_offset_def} && $self->{'in_hash'}->{time_offset} !~ /^\d+$/) {
	$self->error($self->text('savemisc_time',$self->{'in_hash'}->{time_offset}));
	}
$self->setval("time offset", $self->{'in_hash'}->{time_offset_def} ? 0 : $self->{'in_hash'}->{time_offset}, 0);

$self->setval("read prediction", $self->{'in_hash'}->{read_prediction}, "no");

if ($self->{'global'}) { $self->modify_share("global", "global"); }
else { $self->create_share("global"); }
$self->unlock_file($self->{'config_hash'}->{'smb_conf'});
$self->webmin_log("misc", undef, undef, \%{$self->{'in_hash'}});
$self->redirect("");

1;
		
}

sub parent_dir
{
	shift if ($self == $_[0]);

$_[0] =~ /^(.*\/)[^\/]+$/; return $1;
}


1;

