#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_net.cgi
# Save inputs from conf_net.cgi

&ModuleLoader::preload_module('samba_class', "samba::SambaLib");
$self = new samba::SambaLib:: 'samba_class',%$self;

$self->ReadParse();
$self->lock_file($self->{'config_hash'}->{'smb_conf'});
$self->{'global'} = $self->get_share("global");

# check acls
%{$self->{'access_hash'}} = $self->get_module_acl();
$self->error_setup("<blink><font color=red>$self->{'text_hash'}->{'eacl_aviol'}</font></blink>");
$self->error("$self->{'text_hash'}->{'eacl_np'} $self->{'text_hash'}->{'eacl_pcn'}") unless $self->{'access_hash'}->{'conf_net'};

$self->{'whatfailed'} = $self->{'text_hash'}->{'savenet_fail'};
if (!$self->{'in_hash'}->{dead_time_def} && $self->{'in_hash'}->{dead_time} !~ /^\d+$/) {
	$self->error($self->text('savenet_timeout', $self->{'in_hash'}->{dead_time}));
	}
$self->setval("deadtime", $self->{'in_hash'}->{dead_time_def} ? 0 : $self->{'in_hash'}->{dead_time}, 0);

$self->setval("hosts equiv", $self->{'in_hash'}->{hosts_equiv_def} ? "" : $self->{'in_hash'}->{hosts_equiv}, "");

if ($self->{'in_hash'}->{interfaces_def}) { $self->delval("interfaces"); }
else {
	for($i=0; defined($self->{'in_hash'}->{"interface_ip$i"}); $i++) {
		next if (!$self->{'in_hash'}->{"interface_ip$i"});
		if ($self->{'in_hash'}->{"interface_nm$i"}) {
			push(@{$self->{'ifaces_array'}}, $self->{'in_hash'}->{"interface_ip$i"}."/".
				      $self->{'in_hash'}->{"interface_nm$i"});
			}
		else {
			push(@{$self->{'ifaces_array'}}, $self->{'in_hash'}->{"interface_ip$i"});
			}
		}
	$self->setval("interfaces", join(' ', @{$self->{'ifaces_array'}}), "");
	}

if (!$self->{'in_hash'}->{keepalive_def} && $self->{'in_hash'}->{keepalive} !~ /^\d+$/) {
	$self->error($self->text('savenet_keep', $self->{'in_hash'}->{keepalive}));
	}
$self->setval("keepalive", $self->{'in_hash'}->{keepalive_def} ? 0 : $self->{'in_hash'}->{keepalive}, 0);

if (!$self->{'in_hash'}->{max_xmit_def} && $self->{'in_hash'}->{max_xmit} !~ /^\d+$/) {
	$self->error($self->text('savenet_maxxmit', $self->{'in_hash'}->{max_xmit}));
	}
$self->setval("max xmit", $self->{'in_hash'}->{max_xmit_def} ? 0 : $self->{'in_hash'}->{max_xmit}, 0);

$self->setval("socket address",
	$self->{'in_hash'}->{socket_address_def} ? "" : $self->{'in_hash'}->{socket_address}, "");

foreach (@{$self->{'sock_opts_array'}}) {
	/^([A-Z\_]+)(.*)$/;
	if ($2 eq "*") {
		if ($self->{'in_hash'}->{$1}) { push(@{$self->{'sopts_array'}}, "$1=".$self->{'in_hash'}->{"$1_val"}); }
		}
	else {
		if ($self->{'in_hash'}->{$1}) { push(@{$self->{'sopts_array'}}, $1); }
		}
	}
$self->setval("socket options", join(' ',@{$self->{'sopts_array'}}), "");

if ($self->{'global'}) { $self->modify_share("global", "global"); }
else { $self->create_share("global"); }
$self->unlock_file($self->{'config_hash'}->{'smb_conf'});
$self->webmin_log("net", undef, undef, \%{$self->{'in_hash'}});
$self->redirect("");

1;
		
}


1;

