#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_pass.cgi
# Save inputs from conf_pass.cgi

&ModuleLoader::preload_module('samba_class', "samba::SambaLib");
$self = new samba::SambaLib:: 'samba_class',%$self;

$self->ReadParse();
$self->lock_file($self->{'config_hash'}->{'smb_conf'});
$self->{'global'} = $self->get_share("global");

# check acls
%{$self->{'access_hash'}} = $self->get_module_acl();
$self->error_setup("<blink><font color=red>$self->{'text_hash'}->{'eacl_aviol'}</font></blink>");
$self->error("$self->{'text_hash'}->{'eacl_np'} $self->{'text_hash'}->{'eacl_pcp'}") unless $self->{'access_hash'}->{'conf_pass'};

$self->{'whatfailed'} = $self->{'text_hash'}->{'savepass_fail'};
$self->{'nopass'} = (`$self->{'config_hash'}->{samba_password_program} 2>&1 </dev/null` =~ /encryption not selected/);
if ($self->{'in_hash'}->{encrypt_passwords} eq "yes" && $self->{'nopass'}) {
	$self->error($self->{'text_hash'}->{'savepass_nopass'});
	}
$self->setval("encrypt passwords", $self->{'in_hash'}->{encrypt_passwords}, "no");

$self->setval("null passwords", $self->{'in_hash'}->{null_passwords}, "no");

if (!$self->{'in_hash'}->{passwd_program_def} && !$self->{'in_hash'}->{passwd_program}) {
	$self->error($self->{'text_hash'}->{'savepass_passwd'});
	}
$self->setval("passwd program", $self->{'in_hash'}->{passwd_program_def}?"":$self->{'in_hash'}->{passwd_program}, "");

$self->setval("unix password sync", $self->{'in_hash'}->{'unix_password_sync'}, "no");

if ($self->{'in_hash'}->{passwd_chat_def}) { $self->delval("passwd chat"); }
else {
	for($i=0; defined($self->{'in_hash'}->{"chat_recv_$i"}); $i++) {
		push(@{$self->{'chat_array'}}, $self->{'in_hash'}->{"chat_recv_$i"});
		push(@{$self->{'chat_array'}}, $self->{'in_hash'}->{"chat_send_$i"});
		}
	$self->{'clast'} = -1;
	for($i=0; $i<@{$self->{'chat_array'}}; $i++) {
		if ($self->{'chat_array'}->[$i] =~ /\S/) { $self->{'clast'} = $i; }
		}
	if ($self->{'clast'} < 0) {
		$self->error($self->{'text_hash'}->{'savepass_chat'});
		}
	@{$self->{'chat_array'}} = @{$self->{'chat_array'}}[0 .. $self->{'clast'}];
	@{$self->{'chat_array'}} = map { /^$/ ? "." : /^\S+$/ ? $_ : "\"$_\""; } @{$self->{'chat_array'}};
	$self->setval("passwd chat", join(' ', @{$self->{'chat_array'}}));
	}

$self->{'mapfile'} = $self->getval("username map");
if ($self->{'in_hash'}->{username_map_def}) { $self->delval("username map"); }
else {
	if (!$self->{'mapfile'}) {
		$self->{'config_hash'}->{smb_conf} =~ /^(.*)\/[^\/]+$/;
		$self->{'mapfile'} = "$1/user.map";
		}
	$self->setval("username map", $self->{'mapfile'});
	for($i=0; defined($self->{'in_hash'}->{"umap_unix_$i"}); $i++) {
		if ($self->{'in_hash'}->{"umap_unix_$i"} =~ /\S/ && $self->{'in_hash'}->{"umap_win_$i"} =~ /\S/) {
			if ($self->{'in_hash'}->{"umap_win_$i"} =~ /\s/) {
				push(@{$self->{'umap_array'}}, $self->{'in_hash'}->{"umap_unix_$i"}."=\"".
					    $self->{'in_hash'}->{"umap_win_$i"}."\"");
				}
			else {
				push(@{$self->{'umap_array'}}, $self->{'in_hash'}->{"umap_unix_$i"}."=".
					    $self->{'in_hash'}->{"umap_win_$i"});
				}
			}
		}
	$self->open_lock_tempfile(UMAP, "> $self->{'mapfile'}");
	foreach $line (@{$self->{'umap_array'}}) {
		$self->print_tempfile(UMAP, "$line\n");
		}
	$self->close_tempfile(UMAP);
	}

if ($self->{'global'}) { $self->modify_share("global", "global"); }
else { $self->create_share("global"); }
$self->unlock_file($self->{'config_hash'}->{'smb_conf'});
$self->webmin_log("pass", undef, undef, \%{$self->{'in_hash'}});
$self->redirect("");

1;
		
}


1;

