#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_pshare.cgi
# Save a new or edited printer share

&ModuleLoader::preload_module('samba_class', "samba::SambaLib");
$self = new samba::SambaLib:: 'samba_class',%$self;

$self->ReadParse();
$self->lock_file($self->{'config_hash'}->{'smb_conf'});
$self->get_share($self->{'in_hash'}->{old_name}) if $self->{'in_hash'}->{old_name};

# check acls
%{$self->{'access_hash'}} = $self->get_module_acl();
$self->error_setup("<blink><font color=red>$self->{'text_hash'}->{'eacl_aviol'}</font></blink>");
if ($self->{'in_hash'}->{old_name}) {
    $self->error("$self->{'text_hash'}->{'eacl_np'} $self->{'text_hash'}->{'eacl_pus'}") 
		unless $self->can('rw', \%{$self->{'access_hash'}}, $self->{'in_hash'}->{old_name});
    }
else {
    $self->error("$self->{'text_hash'}->{'eacl_np'} $self->{'text_hash'}->{'eacl_pcrs'}") unless $self->{'access_hash'}->{'c_ps'};
    }

$self->{'whatfailed'} = $self->{'text_hash'}->{'savepshare_fail'};
if ($self->{'in_hash'}->{old_name} eq "global") {
	$self->{'name'} = "global";
	}
else {
	# store share options
	$self->{'name'} = $self->{'in_hash'}->{printers} ? "printers" : $self->{'in_hash'}->{"share"};
	}
#if ($self->{'in_hash'}->{"path"} !~ /\S/ && !$self->{'in_hash'}->{"printers"}) {
#	$self->error("No spool directory given");
#	}
$self->setval("printer", $self->{'in_hash'}->{"printer"});
$self->setval("path", $self->{'in_hash'}->{"path"});
$self->setval("available", $self->{'in_hash'}->{"available"});
$self->setval("browseable", $self->{'in_hash'}->{"browseable"});
if ($self->{'name'} ne "global") { $self->setval("printable", "yes"); }
$self->setval("comment", $self->{'in_hash'}->{"comment"});

# Check for clash
if ($self->{'name'} ne "global") {
	foreach ($self->list_shares()) {
	        $self->{'exists_hash'}->{$_}++;
	        }
	if (!$self->{'in_hash'}->{old_name} && $self->{'exists_hash'}->{$self->{'name'}}) {
	        $self->error($self->text('savepshare_exist', $self->{'name'}));
	        }
	elsif ($self->{'in_hash'}->{old_name} ne $self->{'name'} && $self->{'exists_hash'}->{$self->{'name'}}) {
	        $self->error($self->text('savepshare_exist', $self->{'name'}));
	        }
	elsif ($self->{'name'} !~ /^[A-Za-z0-9_\$ ]+$/) {
		$self->error($self->text('savepshare_name', $self->{'name'}));
		}
	elsif ($self->{'name'} eq "global") {
		$self->error($self->{'text_hash'}->{'savepshare_global'});
		}
	}

# Update config file
if ($self->{'in_hash'}->{old_name}) {
	# Changing an existing share
	$self->modify_share($self->{'in_hash'}->{old_name}, $self->{'name'});
	if ($self->{'name'} ne $self->{'in_hash'}->{old_name}) {
		local $oldacl=$self->{'access_hash'}->{'ACLps_' . $self->{'in_hash'}->{old_name}};
		$self->drop_samba_acl(\%{$self->{'access_hash'}}, $self->{'in_hash'}->{old_name});
		$self->save_samba_acl($oldacl, \%{$self->{'access_hash'}}, $self->{'name'});
	    }
    }
else {
    # Creating a new share
    $self->create_share($self->{'name'});
	$self->save_samba_acl('rwvVsSoO', \%{$self->{'access_hash'}}, $self->{'name'});
    }
$self->unlock_file($self->{'config_hash'}->{'smb_conf'});
$self->webmin_log($self->{'in_hash'}->{old_name} ? "save" : "create", "pshare", $self->{'name'}, \%{$self->{'in_hash'}});
$self->redirect("");

1;
		
}


1;

