#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_net.cgi
# Save inputs from conf_net.cgi

&ModuleLoader::preload_module('samba_class', "samba::SambaLib");
$self = new samba::SambaLib:: 'samba_class',%$self;

$self->ReadParse();
$self->lock_file($self->{'config_hash'}->{'smb_conf'});
$self->{'global'} = $self->get_share("global");

# check acls
%{$self->{'access_hash'}} = $self->get_module_acl();
$self->error_setup("<blink><font color=red>$self->{'text_hash'}->{'eacl_aviol'}</font></blink>");
$self->error("$self->{'text_hash'}->{'eacl_np'} $self->{'text_hash'}->{'eacl_pcs'}") unless $self->{'access_hash'}->{'conf_smb'};

$self->{'whatfailed'} = $self->{'text_hash'}->{'savesmb_fail'};
$self->setval("workgroup", $self->{'in_hash'}->{workgroup_def} ? "" : $self->{'in_hash'}->{workgroup}, "");

if ($self->{'in_hash'}->{'wins'} == 0) {
	$self->delval("wins server");
	$self->setval("wins support", "true");
	}
elsif ($self->{'in_hash'}->{'wins'} == 1) {
	$self->setval("wins support", "false");
	$self->setval("wins server", $self->{'in_hash'}->{'wins_server'}, "");
	}
else {
	$self->delval("wins server");
	$self->setval("wins support", "false");
	}

$self->setval("server string", $self->{'in_hash'}->{server_string_def} ? "" : $self->{'in_hash'}->{server_string}, "");

$self->setval("netbios name", $self->{'in_hash'}->{'netbios_name'}, "");

$self->setval("netbios aliases", $self->{'in_hash'}->{'netbios_aliases'}, "");

$self->setval("default", $self->{'in_hash'}->{default}, "");

$self->setval("auto services", join(' ', split(/\0/, $self->{'in_hash'}->{auto_services})), "");

if (!$self->{'in_hash'}->{max_disk_size_def} && $self->{'in_hash'}->{max_disk_size} !~ /^\d+$/) {
	$self->error($self->text('savesmb_size', $self->{'in_hash'}->{max_disk_size}));
	}
$self->setval("max disk size", $self->{'in_hash'}->{max_disk_size_def} ? 0 : $self->{'in_hash'}->{max_disk_size}, 0);

$self->setval("message command", $self->{'in_hash'}->{message_command}, "");

$self->{'in_hash'}->{os_level} =~ /^\d+$/ ||
	$self->error($self->text('savesmb_oslevel', $self->{'in_hash'}->{os_level}));
$self->setval("os level", $self->{'in_hash'}->{os_level}, 0);

$self->setval("protocol", $self->{'in_hash'}->{protocol}, "");

$self->setval("preferred master", $self->{'in_hash'}->{preferred_master}, "yes");

$self->setval("security", $self->{'in_hash'}->{security}, "");

if ($self->{'in_hash'}->{security} eq "server" && $self->{'in_hash'}->{password_server} !~ /\S/) {
	$self->error($self->{'text_hash'}->{'savesmb_server'});
	}
$self->setval("password server", $self->{'in_hash'}->{password_server}, "");

if ($self->{'in_hash'}->{remote_def}) { $self->delval("remote announce"); }
else {
	for($i=0; defined($self->{'in_hash'}->{"remote_ip$i"}); $i++) {
		if ($self->{'in_hash'}->{"remote_ip$i"} !~ /^(\d+)\.(\d+)\.(\d+)\.(\d+)/)
			{ next; }
		push(@{$self->{'rem_array'}}, $self->{'in_hash'}->{"remote_ip$i"} .
		   ($self->{'in_hash'}->{"remote_wg$i"} =~ /\S/ ? "/".$self->{'in_hash'}->{"remote_wg$i"} : ""));
		}
	$self->setval("remote announce", join(' ', @{$self->{'rem_array'}}), "");
	}

if ($self->{'global'}) { $self->modify_share("global", "global"); }
else { $self->create_share("global"); }
$self->unlock_file($self->{'config_hash'}->{'smb_conf'});
$self->webmin_log("smb", undef, undef, \%{$self->{'in_hash'}});
$self->redirect("");

1;
		
}


1;

