#!/usr/bin/perl

&MAIN();

 sub MAIN {
# swat.cgi
# Pass everything to samba's SWAT tool

&ModuleLoader::preload_module('samba_class', "samba::SambaLib");
$self = new samba::SambaLib:: 'samba_class',%$self;

$self->ReadParse();

# check acls
%{$self->{'access_hash'}} = $self->get_module_acl();
$self->error_setup("<blink><font color=red>$self->{'text_hash'}->{'eacl_aviol'}</font></blink>");
$self->error("$self->{'text_hash'}->{'eacl_np'} $self->{'text_hash'}->{'eacl_pcswat'}") unless $self->{'access_hash'}->{'swat'};

# Check is hosts allow is in force
$self->get_share("global");
if ($self->getval('allow hosts')) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'error'}, "");
	print $self->text('swat_msg3', $self->{'text_hash'}->{'sec_onlyallow'}), "<p>\n";
	$self->foreign_require("inetd", "inetd-lib.pl");
	local @inets = $self->foreign_call("inetd", "list_inets");
	foreach $i (@inets) {
		if ($i->[3] eq 'swat' && $i->[1]) {
			# swat is configured in inetd!
			local $p = getservbyname('swat', 'tcp');
			$self->{'url'} = "http://$ENV{'SERVER_NAME'}:$p/";
			print $self->text('swat_msg4', "<a href='$self->{'url'}'>$self->{'url'}</a>"), "<p>\n";
			}
		}
	$self->ui_print_footer("", $self->{'text_hash'}->{'index_sharelist'});
	exit;
	}

# Check if we have the password
$self->read_file("$self->{'module_config_directory'}/swat", \%{$self->{'swat_hash'}}) || &ask_password();

# Execute SWAT process
pipe(OUTr, OUTw);
pipe(INr, INw);
local $pid = fork();
if (!$pid) {
	untie(*STDIN);
	untie(*STDOUT);
	untie(*STDERR);
	open(STDIN, "<&INr");
	open(STDOUT, ">&OUTw");
	open(STDERR, ">&OUTw");
	close(OUTr); close(INw);
	undef %ENV;
	exec($self->{'config_hash'}->{'swat_path'});
	print "Exec failed : $!\n";
	exit 1;
	}
close(OUTw); close(INr);

# Feed HTTP request and read output
$self->{'auth'} = $self->encode_base64("$self->{'swat_hash'}->{'user'}:$self->{'swat_hash'}->{'pass'}");
$self->{'auth'} =~ s/\n//g;
select(INw); $| = 1; select(STDOUT);
$self->{'path'} = $ENV{'PATH_INFO'} || "/";
if ($ENV{'REQUEST_METHOD'} eq 'GET') {
	print INw "GET $self->{'path'}?$self->{'in'} HTTP/1.0\n";
	print INw "Authorization: basic $self->{'auth'}\n";
	print INw "\n";
	}
else {
	print INw "POST $self->{'path'} HTTP/1.0\r\n";
	print INw "Authorization: basic $self->{'auth'}\r\n";
	print INw "Content-length: ",length($self->{'in'}),"\r\n";
	print INw "Content-type: application/x-www-form-urlencoded\r\n";
	print INw "\r\n",$self->{'in'};
	}
close(INw);
$self->{'reply'} = <OUTr>;
if ($self->{'reply'} =~ /\s401\s/) {
	&ask_password();
	}
if ($ENV{'PATH_INFO'} =~ /\.(gif|jpg|jpeg|png)$/i) {
	# An image .. just output it
	while(<OUTr>) { print; }
	}
else {
	# An HTML page .. fix up links
	$self->{'url'} = "$self->{'gconfig_hash'}->{'webprefix'}/$self->{'module_name'}/swat.cgi";
	while(<OUTr>) {
		s/src="(\/[^"]*)"/src="$self->{'url'}$1"/gi;
		s/href="(\/[^"]*)"/href="$self->{'url'}$1"/gi;
		s/action="(\/[^"]*)"/action="$self->{'url'}$1"/gi;
		s/"(\/status?[^"]*)"/"$self->{'url'}$1"/gi;
		print $_ if (!/<\/body>/i && !/<\/html>/i);
		}
	print "<table width=100% cellpadding=0 cellspacing=0><tr><td>\n";
	$self->ui_print_footer("/$self->{'module_name'}/", $self->{'text_hash'}->{'index_sharelist'}, 1);
	print "</td> <td align=right><a href='/$self->{'module_name'}/logout.cgi'>",
	      "$self->{'text_hash'}->{'swat_logout'}</a></td> </tr></table></body></html>\n";
	}

1;
		
}

sub ask_password
{
	shift if ($self == $_[0]);

$self->ui_print_header(undef, $self->{'text_hash'}->{'swat_title'}, "");
if (%{$self->{'swat_hash'}}) {
	print $self->{'text_hash'}->{'swat_msg1'}, " <br>\n";
	}
else {
	print $self->{'text_hash'}->{'swat_msg2'}, " <br>\n";
	}
print "<form action=swat_save.cgi>\n";
print "<center><table border>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'swat_list'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table cellpadding=2>\n";
print "<tr> <td><b>$self->{'text_hash'}->{'swat_username'}</b></td>\n";
print "<td><input name=user size=20 value='$self->{'swat_hash'}->{'user'}'></td> </tr>\n";
print "<tr> <td><b>$self->{'text_hash'}->{'swat_password'}</b></td>\n";
print "<td><input name=pass size=20 type=password></td> </tr>\n";
print "</table></td></tr></table>\n";
print "<input type=submit value=\"", $self->{'text_hash'}->{'swat_login'},
      "\"> <input type=reset value=\"", $self->{'text_hash'}->{'swat_clear'}, "\">\n";
print "</center></form>\n";
$self->ui_print_footer("", $self->{'text_hash'}->{'index_sharelist'});
exit;
}


1;

