#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Show options for source log file

&ModuleLoader::preload_module('sarg_class', "sarg::SargLib");
$self = new sarg::SargLib:: 'sarg_class',%$self;


$self->{'conf'} = $self->get_config();
$self->ui_print_header(undef, $self->{'text_hash'}->{'log_title'}, "");
print $self->ui_form_start("save_log.cgi", "post");
print $self->ui_table_start($self->{'text_hash'}->{'log_header'}, "width=100%", 4);
$self->{'config_prefix'} = "log_";

if ($self->foreign_check("squid")) {
	$self->foreign_require("squid", "squid-lib.pl");
	local $sconf = $main::squid_object->get_config();
	$self->{'squid_log'} = $main::squid_object->find_value("access_log", $sconf);
	if (-d $main::squid_object->{'config_hash'}->{'log_dir'}) {
		$self->{'squid_log'} ||= "$main::squid_object->{'config_hash'}->{'log_dir'}/access.log";
		}
	}
$self->{'log'} = $self->find_value("access_log", $self->{'conf'});
$self->{'lmode'} = !$self->{'log'} ? 0 : $self->{'log'} eq $self->{'squid_log'} ? 1 : 2;
$self->{'defstr'} = $self->find("access_log", $self->{'conf'}, 2);
$self->{'def'} = $self->{'defstr'} && $self->{'defstr'}->{'value'} ? " ($self->{'defstr'}->{'value'})" : undef;
print $self->ui_table_row($self->{'text_hash'}->{'log_access_log'},
		    $self->ui_radio("access_log_def", $self->{'lmode'},
			      [ [ 0, $self->{'text_hash'}->{'default'}.$self->{'def'}."<br>" ],
				$self->{'squid_log'} ? ( [ 1, $self->text('log_squid', $self->{'squid_log'})."<br>" ] ) : ( ),
				[ 2, $self->{'text_hash'}->{'log_other'} ] ])." ".
		    $self->ui_textbox("access_log", $self->{'lmode'} == 2 ? $self->{'log'} : "",
				40), 3);
print $self->ui_hidden("squid_log", $self->{'squid_log'});

print $self->config_opt_textbox($self->{'conf'}, "output_dir", 40, 3);
print $self->config_opt_textbox($self->{'conf'}, "lastlog", 5, 3, $self->{'text_hash'}->{'log_unlimit'});
print $self->config_opt_textbox($self->{'conf'}, "useragent_log", 40, 3);
print $self->config_opt_textbox($self->{'conf'}, "squidguard_log_path", 40, 3);

print $self->config_opt_textbox($self->{'conf'}, "output_email", 30, 3,
			  $self->{'text_hash'}->{'log_nowhere'});
print $self->config_opt_textbox($self->{'conf'}, "mail_utility", 15, 3,
			  $self->{'text_hash'}->{'default'}." (mailx)");

print $self->ui_table_end();
print $self->ui_form_end([ [ 'save', $self->{'text_hash'}->{'save'} ] ], "100%");
$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

