#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Show options for report style

&ModuleLoader::preload_module('sarg_class', "sarg::SargLib");
$self = new sarg::SargLib:: 'sarg_class',%$self;


$self->{'conf'} = $self->get_config();
$self->ui_print_header(undef, $self->{'text_hash'}->{'report_title'}, "");
print $self->ui_form_start("save_report.cgi", "post");
print $self->ui_table_start($self->{'text_hash'}->{'report_header'}, "width=100%", 4);
$self->{'config_prefix'} = "report_";

print $self->config_select($self->{'conf'}, "report_type",
		     [ [ "topsites", $self->{'text_hash'}->{'report_topsites'} ],
		       [ "sites_users", $self->{'text_hash'}->{'report_sites_users'} ],
		       [ "users_sites", $self->{'text_hash'}->{'report_users_sites'} ],
		       [ "date_time", $self->{'text_hash'}->{'report_date_time'} ],
		       [ "denied", $self->{'text_hash'}->{'report_denied'} ],
		       [ "auth_failures", $self->{'text_hash'}->{'report_auth_failures'} ],
		       [ "site_user_time_date", $self->{'text_hash'}->{'report_site_user_time_date'} ] ],
		     $self->{'text_hash'}->{'report_all'}, 3);

print $self->ui_table_hr();

print $self->config_yesno($self->{'conf'}, "resolve_ip", undef, undef, undef, 3);
print $self->config_yesno($self->{'conf'}, "user_ip", undef, undef, undef, 3);

print $self->config_radio($self->{'conf'}, "records_without_userid",
		    [ [ "ignore", $self->{'text_hash'}->{'report_ignore'} ],
		      [ "ip", $self->{'text_hash'}->{'report_ip'} ],
		      [ "everybody", $self->{'text_hash'}->{'report_everybody'} ] ], 3);

print $self->ui_table_hr();

print $self->config_sortfield($self->{'conf'}, "user_sort_field",
			[ "USER", "CONNECT", "BYTES", "TIME" ]);
print $self->config_sortfield($self->{'conf'}, "topuser_sort_field",
			[ "SITE", "CONNECT", "BYTES", "TIME" ]);
print $self->config_sortfield($self->{'conf'}, "topsites_sort_order",
			[ "CONNECT", "BYTES" ],
			[ [ "A", $self->{'text_hash'}->{'report_sorta'} ],
			  [ "D", $self->{'text_hash'}->{'report_sortd'} ] ]);
print $self->config_radio($self->{'conf'}, "index_sort_order",
		    [ [ "A", $self->{'text_hash'}->{'report_sorta'} ],
		      [ "D", $self->{'text_hash'}->{'report_sortd'} ] ], 3);

print $self->ui_table_hr();

print $self->config_opt_textbox($self->{'conf'}, "exclude_users", 40, 3);
print $self->config_opt_textbox($self->{'conf'}, "exclude_hosts", 40, 3);
print $self->config_opt_textbox($self->{'conf'}, "exclude_codes", 40, 3);
print $self->config_opt_textbox($self->{'conf'}, "usertab", 40, 3);
print $self->config_colons($self->{'conf'}, "include_users", ":", $self->{'text_hash'}->{'report_nostrings'}, 3);
print $self->config_colons($self->{'conf'}, "exclude_string", ":", $self->{'text_hash'}->{'report_allusers'}, 3);

print $self->ui_table_hr();

print $self->config_yesno($self->{'conf'}, "index", undef, undef,
		    [ [ "only", $self->{'text_hash'}->{'report_only'} ] ], 3);
print $self->config_yesno($self->{'conf'}, "overwrite_report", undef, $self->{'text_hash'}->{'report_overno'},
		    undef, 3);

print $self->config_yesno($self->{'conf'}, "use_comma", undef, undef, undef, 3);

print $self->config_opt_textbox($self->{'conf'}, "topsites_num", 5, 3);

print $self->config_opt_textbox($self->{'conf'}, "topuser_num", 5, 3);

print $self->config_opt_textbox($self->{'conf'}, "max_elapsed", 5, 3);

print $self->config_yesno($self->{'conf'}, "long_url", undef, undef, undef, 3);

print $self->config_radio($self->{'conf'}, "date_time_by",
		    [ [ "bytes", $self->{'text_hash'}->{'report_bytes'} ],
		      [ "elap", $self->{'text_hash'}->{'report_elap'} ] ], 3);

print $self->config_radio($self->{'conf'}, "site_user_time_date_type",
		    [ [ "table", $self->{'text_hash'}->{'report_table'} ],
		      [ "list", $self->{'text_hash'}->{'report_list'} ] ], 3);

print $self->config_radio($self->{'conf'}, "displayed_values",
		    [ [ "bytes", $self->{'text_hash'}->{'report_bytes2'} ],
		      [ "abbreviation", $self->{'text_hash'}->{'report_abbrev'} ] ], 3);

print $self->config_opt_textbox($self->{'conf'}, "user_invalid_char", 10, 3);

print $self->ui_table_hr();

print $self->config_yesno($self->{'conf'}, "privacy", undef, undef, undef, 3);
print $self->config_opt_textbox($self->{'conf'}, "privacy_string", 25, 3);
print $self->config_opt_textbox($self->{'conf'}, "privacy_string_color", 20, 3);

print $self->ui_table_hr();

print $self->config_range($self->{'conf'}, "weekdays", 0, 6, 3);
print $self->config_range($self->{'conf'}, "hours", 0, 23, 3);

print $self->ui_table_end();
print $self->ui_form_end([ [ 'save', $self->{'text_hash'}->{'save'} ] ], "100%");
$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
1;
		
}


1;

