#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Show icons for sarg option categories

&ModuleLoader::preload_module('sarg_class', "sarg::SargLib");
$self = new sarg::SargLib:: 'sarg_class',%$self;


if (!-r $self->{'config_hash'}->{'sarg_conf'}) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", undef, 1, 1);
	$self->ui_print_endpage(
		$self->ui_config_link('index_econf',
			[ "<tt>$self->{'config_hash'}->{'sarg_conf'}</tt>", undef ]));
	}
if (!$self->has_command($self->{'config_hash'}->{'sarg'})) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", undef, 1, 1);
	$self->ui_print_endpage(
		$self->ui_config_link('index_ecmd',
		        [ "<tt>$self->{'config_hash'}->{'sarg'}</tt>", undef ]));
	}

# Get the version
$self->{'out'} = `$self->{'config_hash'}->{'sarg'} -v 2>&1 </dev/null`;
if ($self->{'out'} =~ /sarg-([0-9\.]+)\s/ || $self->{'out'} =~ /Version:\s*([0-9\.]+)/i) {
	$self->{'sarg_version'} = $1;
	}
else {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", undef, 1, 1);
	$self->ui_print_endpage(
		$self->text('index_eversion',
		      "<tt>$self->{'config_hash'}->{'sarg'}</tt>", "<pre>$self->{'out'}</pre>"));
	}

# Show icons for options
$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", undef, 1, 1, 0,
		 $self->help_search_link("sarg", "man", "doc", "google"),
		 undef, undef,
		 $self->text('index_version', $self->{'sarg_version'}));
@{$self->{'pages_array'}} = ( "log", "report", "style", "sched" );
@{$self->{'links_array'}} = map { "edit_${_}.cgi" } @{$self->{'pages_array'}};
@{$self->{'titles_array'}} = map { $self->{'text_hash'}->{"${_}_title"} } @{$self->{'pages_array'}};
@{$self->{'icons_array'}} = map { "images/${_}.gif" } @{$self->{'pages_array'}};
$self->icons_table(\@{$self->{'links_array'}}, \@{$self->{'titles_array'}}, \@{$self->{'icons_array'}});

# Show buttons for generating report now and for viewing
$self->{'conf'} = $self->get_config();
$self->{'odir'} = $self->find_value("output_dir", $self->{'conf'});
$self->{'odir'} ||= $self->find_value("output_dir", $self->{'conf'}, 1);
$self->{'sfile'} = $self->find_value("access_log", $self->{'conf'});
if ($self->{'sfile'} || $self->{'odir'} && -r "$self->{'odir'}/index.html") {
	print "<hr>\n";
	print $self->ui_buttons_start();
	}
if ($self->{'sfile'}) {
	print $self->ui_buttons_row("generate.cgi", $self->{'text_hash'}->{'index_generate'},
			      $self->text('index_generatedesc', "<tt>$self->{'odir'}</tt>").
			      "<br><b>$self->{'text_hash'}->{'index_clear'}</b> ".
			      $self->gen_clear_input().
			      "<br><b>$self->{'text_hash'}->{'index_range'}</b> ".
			      $self->gen_range_input());
	print "<tr> <td><p></td> </tr>\n";
	}
if ($self->{'odir'} && -r "$self->{'odir'}/index.html") {
	print $self->ui_buttons_row("view.cgi/index.html", $self->{'text_hash'}->{'index_view'},
			      $self->text('index_viewdesc', "<tt>$self->{'odir'}</tt>"));
	}
if ($self->{'sfile'} || $self->{'odir'} && -r "$self->{'odir'}/index.html") {
	print $self->ui_buttons_end();
	}

$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});
1;
		
}


1;

