#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Save options for report source and dest

&ModuleLoader::preload_module('sarg_class', "sarg::SargLib");
$self = new sarg::SargLib:: 'sarg_class',%$self;

$self->ReadParse();
$self->{'conf'} = $self->get_config();
$self->{'config_prefix'} = "log_";
$self->error_setup($self->{'text_hash'}->{'log_err'});

$self->lock_sarg_files();
if ($self->{'in_hash'}->{'access_log_def'} == 0) {
	$self->save_directive($self->{'conf'}, "access_log", [ ]);
	}
elsif ($self->{'in_hash'}->{'access_log_def'} == 1) {
	$self->save_directive($self->{'conf'}, "access_log", [ $self->{'in_hash'}->{'squid_log'} ]);
	}
else {
	$self->save_textbox($self->{'conf'}, "access_log", \&check_log);
	}
$self->save_opt_textbox($self->{'conf'}, "output_dir", \&check_output_dir);
$self->save_opt_textbox($self->{'conf'}, "lastlog", \&check_lastlog);
$self->save_opt_textbox($self->{'conf'}, "useragent_log", \&check_log);
$self->save_opt_textbox($self->{'conf'}, "squidguard_log_path", \&check_log);
$self->save_opt_textbox($self->{'conf'}, "output_email", \&check_email);
$self->save_opt_textbox($self->{'conf'}, "mail_utility", \&check_mailx);

$self->flush_file_lines();
$self->unlock_sarg_files();
$self->webmin_log("log");
$self->redirect("");

1;
		
}

sub check_log
{
	shift if ($self == $_[0]);

return -r $_[0] ? undef : $self->{'text_hash'}->{'log_elog'};
}

sub check_output_dir
{
	shift if ($self == $_[0]);

return -d $_[0] ? undef : $self->{'text_hash'}->{'log_edir'};
}

sub check_lastlog
{
	shift if ($self == $_[0]);

return $_[0] =~ /^\d+$/ ? undef : $self->{'text_hash'}->{'log_elastlog'};
}

sub check_email
{
	shift if ($self == $_[0]);

return $_[0] =~ /^\S+$/ ? undef : $self->{'text_hash'}->{'log_eemail'};
}

sub check_mailx
{
	shift if ($self == $_[0]);

return $_[0] =~ /^(\S+)/ && $self->has_command($1) ? undef : $self->{'text_hash'}->{'log_emailx'};
}


1;

