#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Save report options

&ModuleLoader::preload_module('sarg_class', "sarg::SargLib");
$self = new sarg::SargLib:: 'sarg_class',%$self;

$self->ReadParse();
$self->{'conf'} = $self->get_config();
$self->{'config_prefix'} = "report_";
$self->error_setup($self->{'text_hash'}->{'report_err'});

$self->lock_sarg_files();
$self->save_select($self->{'conf'}, "report_type");
$self->save_yesno($self->{'conf'}, "resolve_ip");
$self->save_yesno($self->{'conf'}, "user_ip");
$self->save_radio($self->{'conf'}, "records_without_userid");

$self->save_sortfield($self->{'conf'}, "user_sort_field");
$self->save_sortfield($self->{'conf'}, "topuser_sort_field");
$self->save_sortfield($self->{'conf'}, "topsites_sort_order");
$self->save_radio($self->{'conf'}, "index_sort_order");

$self->save_opt_textbox($self->{'conf'}, "exclude_users", \&check_file);
$self->save_opt_textbox($self->{'conf'}, "exclude_hosts", \&check_file);
$self->save_opt_textbox($self->{'conf'}, "exclude_codes", \&check_file);
$self->save_opt_textbox($self->{'conf'}, "usertab", \&check_file);

$self->save_colons($self->{'conf'}, "include_users", ":");
$self->save_colons($self->{'conf'}, "exclude_string", ":");

$self->save_yesno($self->{'conf'}, "index");
$self->save_yesno($self->{'conf'}, "overwrite_report");
$self->save_yesno($self->{'conf'}, "use_comma");
$self->save_opt_textbox($self->{'conf'}, "topsites_num", \&check_num);
$self->save_opt_textbox($self->{'conf'}, "topuser_num", \&check_num);
$self->save_opt_textbox($self->{'conf'}, "max_elapsed", \&check_num);
$self->save_yesno($self->{'conf'}, "long_url");
$self->save_radio($self->{'conf'}, "date_time_by");
$self->save_radio($self->{'conf'}, "site_user_time_date_type");
$self->save_radio($self->{'conf'}, "displayed_values");
$self->save_opt_textbox($self->{'conf'}, "user_invalid_char", \&check_char);

$self->save_yesno($self->{'conf'}, "privacy");
$self->save_opt_textbox($self->{'conf'}, "privacy_string", \&check_string);
$self->save_opt_textbox($self->{'conf'}, "privacy_string_color", \&check_colour);

$self->save_range($self->{'conf'}, "weekdays");
$self->save_range($self->{'conf'}, "hours");

$self->flush_file_lines();
$self->unlock_sarg_files();
$self->webmin_log("report");
$self->redirect("");

1;
		
}

sub check_file
{
	shift if ($self == $_[0]);

return -r $_[0] ? undef : $self->{'text_hash'}->{'report_efile'};
}

sub check_num
{
	shift if ($self == $_[0]);

return $_[0] =~ /^\d+$/ ? undef : $self->{'text_hash'}->{'report_enum'};
}

sub check_char
{
	shift if ($self == $_[0]);

return $_[0] =~ /^\S+$/ ? undef : $self->{'text_hash'}->{'report_echar'};
}

sub check_string
{
	shift if ($self == $_[0]);

return $_[0] =~ /^\S+$/ ? undef : $self->{'text_hash'}->{'report_estring'};
}

sub check_colour
{
	shift if ($self == $_[0]);

return $_[0] =~ /^\S+$/ ? undef : $self->{'text_hash'}->{'style_ecolour'};
}


1;

