#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Setup, update or delete reporting cron job

&ModuleLoader::preload_module('sarg_class', "sarg::SargLib");
$self = new sarg::SargLib:: 'sarg_class',%$self;

$self->foreign_require("cron", "cron-lib.pl");
@{$self->{'jobs_array'}} = $main::cron_object->list_cron_jobs();
($self->{'oldjob'}) = grep { $_->{'user'} eq 'root' &&
		$_->{'command'} eq $self->{'cron_cmd'} } @{$self->{'jobs_array'}};
$self->ReadParse();

# Validate inputs
$self->error_setup($self->{'text_hash'}->{'sched_err'});
if ($self->{'oldjob'}) {
	$self->{'job'} = $self->{'oldjob'};
	}
else {
	$self->{'job'} = { 'active' => 1,
		 'user' => 'root',
		 'command' => $self->{'cron_cmd'} };
	}
if ($self->{'in_hash'}->{'sched'}) {
	$main::cron_object->parse_times_input($self->{'job'}, \%{$self->{'in_hash'}});
	$main::cron_object->create_wrapper($self->{'cron_cmd'}, $self->{'module_name'}, "generate.pl");
	}
if (!$self->{'in_hash'}->{'range_def'}) {
	$self->{'in_hash'}->{'rfrom'} =~ /^\d+$/ || $self->error($self->{'text_hash'}->{'sched_erfrom'});
	$self->{'in_hash'}->{'rto'} =~ /^\d+$/ || $self->error($self->{'text_hash'}->{'sched_erto'});
	}

$self->lock_file($main::cron_object->cron_file($self->{'job'}));
if ($self->{'in_hash'}->{'sched'} && !$self->{'oldjob'}) {
	# Need to create
	$main::cron_object->create_cron_job($self->{'job'});
	$self->{'mode'} = "create";
	}
elsif (!$self->{'in_hash'}->{'sched'} && $self->{'oldjob'}) {
	# Need to delete
	$main::cron_object->delete_cron_job($self->{'job'});
	$self->{'mode'} = "delete";
	}
elsif ($self->{'in_hash'}->{'sched'} && $self->{'oldjob'}) {
	# Need to update
	$main::cron_object->change_cron_job($self->{'job'});
	$self->{'mode'} = "update";
	}
else {
	$self->{'mode'} = "nothing";
	}
$self->unlock_file($main::cron_object->cron_file($self->{'job'}));

# Save config settings
$self->lock_file($self->{'module_config_file'});
$self->{'config_hash'}->{'clear'} = $self->{'in_hash'}->{'clear'};
$self->{'config_hash'}->{'range'} = $self->{'in_hash'}->{'range_def'} ? undef : $self->{'in_hash'}->{'rfrom'}." ".$self->{'in_hash'}->{'rto'};
$self->save_module_config();
$self->unlock_file($self->{'module_config_file'});
$self->webmin_log("sched", undef, $self->{'mode'});

$self->redirect("");

1;
		
}


1;

