#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Save options for report colour styling

&ModuleLoader::preload_module('sarg_class', "sarg::SargLib");
$self = new sarg::SargLib:: 'sarg_class',%$self;

$self->ReadParse();
$self->{'conf'} = $self->get_config();
$self->{'config_prefix'} = "style_";
$self->error_setup($self->{'text_hash'}->{'style_err'});

$self->lock_sarg_files();
$self->save_language($self->{'conf'}, "language");
$self->save_language($self->{'conf'}, "charset");
$self->save_opt_textbox($self->{'conf'}, "title", \&check_title);
$self->save_opt_textbox($self->{'conf'}, "title_color", \&check_colour);
$self->save_opt_textbox($self->{'conf'}, "font_face", \&check_font);
$self->save_opt_textbox($self->{'conf'}, "header_color", \&check_colour);
$self->save_opt_textbox($self->{'conf'}, "header_bgcolor", \&check_colour);
$self->save_opt_textbox($self->{'conf'}, "header_font_size", \&check_fontsize);
$self->save_opt_textbox($self->{'conf'}, "text_color", \&check_colour);
$self->save_opt_textbox($self->{'conf'}, "text_bgcolor", \&check_colour);

$self->save_opt_textbox($self->{'conf'}, "logo_image");
$self->save_opt_textbox($self->{'conf'}, "image_size", \&check_size);
$self->save_opt_textbox($self->{'conf'}, "logo_text");
$self->save_opt_textbox($self->{'conf'}, "logo_text_color", \&check_colour);

$self->save_opt_textbox($self->{'conf'}, "background_image");
$self->save_opt_textbox($self->{'conf'}, "background_color", \&check_colour);

$self->flush_file_lines();
$self->unlock_sarg_files();
$self->webmin_log("style");
$self->redirect("");

1;
		
}

sub check_title
{
	shift if ($self == $_[0]);

return $_[0] =~ /\S/ ? undef : $self->{'text_hash'}->{'style_etitle'};
}

sub check_colour
{
	shift if ($self == $_[0]);

return $_[0] =~ /^\S+$/ ? undef : $self->{'text_hash'}->{'style_ecolour'};
}

sub check_font
{
	shift if ($self == $_[0]);

return $_[0] =~ /^\S+$/ ? undef : $self->{'text_hash'}->{'style_efont'};
}

sub check_fontsize
{
	shift if ($self == $_[0]);

return $_[0] =~ /^\-?\d+$/ ? undef : $self->{'text_hash'}->{'style_efontsize'};
}

sub check_size
{
	shift if ($self == $_[0]);

return $_[0] =~ /^\d+\s+\d+$/ ? undef : $self->{'text_hash'}->{'style_esize'};
}


1;

