#!/usr/bin/perl
package sendmail::Autoreply;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'sendmail::Autoreply');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# autoreply.pl
# Simple autoreply script. Command line arguments are :
# autoreply-file username alternate-file

# read sendmail module config
$ENV{'PATH'} = "/bin:/usr/bin:/sbin:/usr/sbin";
$self->{'p'} = -l $0 ? readlink($0) : $0;
$self->{'p'} =~ /^(.*)\/[^\/]+$/;
if (open(CONF, "$1/config")) {
	while(<CONF>) {
		if (/^(\S+)=(.*)/) {
			$self->{'config_hash'}->{$1} = $2;
			}
		}
	close(CONF);
	}
if (!$self->{'config_hash'}->{'sendmail_path'}) {
	# Make some guesses about sendmail
	if (-x "/usr/sbin/sendmail") {
		%{$self->{'config_hash'}} = ( 'sendmail_path' => '/usr/sbin/sendmail' );
		}
	elsif (-x "/usr/lib/sendmail") {
		%{$self->{'config_hash'}} = ( 'sendmail_path' => '/usr/lib/sendmail' );
		}
	else {
		die "Failed to find sendmail or config file";
		}
	}

# read headers and body
while(<STDIN>) {
	s/\r|\n//g;
	if (/^(\S+):\s+(.*)/) {
		$self->{'header_hash'}->{lc($1)} = $2;
		$self->{'lastheader'} = lc($1);
		}
	elsif (/^\s+(.*)/ && $self->{'lastheader'}) {
		$self->{'header_hash'}->{$self->{'lastheader'}} .= $_;
		}
	elsif (!$_) { last; }
	}
while(<STDIN>) {
	$self->{'body'} .= $_;
	}
if ($self->{'header_hash'}->{'x-webmin-autoreply'} ||
    $self->{'header_hash'}->{'auto-submitted'} && lc($self->{'header_hash'}->{'auto-submitted'}) ne 'no') {
	print STDERR "Cancelling autoreply to an autoreply\n";
	exit 0;
	}
if ($self->{'header_hash'}->{'x-mailing-list'} ||
    $self->{'header_hash'}->{'list-id'} ||
    $self->{'header_hash'}->{'precedence'} =~ /junk|bulk|list/i ||
    $self->{'header_hash'}->{'to'} =~ /Multiple recipients of/i) {
	# Do nothing if post is from a mailing list
	exit 0;
	}
if ($self->{'header_hash'}->{'from'} =~ /postmaster|mailer-daemon/i) {
	# Do nothing if post is a bounce
	exit 0;
	}

# work out the correct to address
@{$self->{'to_array'}} = ( $self->split_addresses($self->{'header_hash'}->{'to'}),
	$self->split_addresses($self->{'header_hash'}->{'cc'}),
	$self->split_addresses($self->{'header_hash'}->{'bcc'}) );
$self->{'to'} = $self->{'to_array'}->[0]->[0];
foreach $t (@{$self->{'to_array'}}) {
	if ($t->[0] =~ /^([^\@\s]+)/ && $1 eq $ARGV[1] ||
	    $t->[0] eq $ARGV[1]) {
		$self->{'to'} = $t->[0];
		}
	}

# build list of default reply headers
$self->{'rheader_hash'}->{'From'} = $self->{'to'};
$self->{'rheader_hash'}->{'To'} = $self->{'header_hash'}->{'reply-to'} ? $self->{'header_hash'}->{'reply-to'}
				     : $self->{'header_hash'}->{'from'};
$self->{'rheader_hash'}->{'Subject'} = "Autoreply to $self->{'header_hash'}->{'subject'}";
$self->{'rheader_hash'}->{'X-Webmin-Autoreply'} = 1;
$self->{'rheader_hash'}->{'X-Originally-To'} = $self->{'header_hash'}->{'to'};
chop($self->{'host'} = `hostname`);
$self->{'rheader_hash'}->{'Message-Id'} = "<".time().".".$$."\@".$self->{'host'}.">";

# read the autoreply file (or alternate)
if (open(AUTO, $ARGV[0]) ||
    $ARGV[2] && open(AUTO, $ARGV[2])) {
	while(<AUTO>) {
		s/\$SUBJECT/$self->{'header_hash'}->{'subject'}/g;
		s/\$FROM/$self->{'header_hash'}->{'from'}/g;
		s/\$TO/$self->{'to'}/g;
		s/\$DATE/$self->{'header_hash'}->{'date'}/g;
		s/\$BODY/$self->{'body'}/g;
		if (/^(\S+):\s*(.*)/ && !$self->{'doneheaders'}) {
			if ($1 eq "No-Autoreply-Regexp") {
				push(@{$self->{'no_regexp_array'}}, $2);
				}
			elsif ($1 eq "Autoreply-File") {
				push(@{$self->{'files_array'}}, $2);
				}
			else {
				$self->{'rheader_hash'}->{$1} = $2;
				$self->{'rheaders'} .= $_;
				}
			}
		else {
			$self->{'rbody'} .= $_;
			$self->{'doneheaders'} = 1;
			}
		}
	close(AUTO);
	}
else {
	$self->{'rbody'} = "Failed to open autoreply file $ARGV[0] : $!";
	}

# Open the replies tracking DBM, if one was set
if ($self->{'rheader_hash'}->{'Reply-Tracking'}) {
	$self->{'track_replies'} = dbmopen(%{$self->{'replies_hash'}}, $self->{'rheader_hash'}->{'Reply-Tracking'}, 0700);
	}
if ($self->{'track_replies'}) {
	# See if we have replied to this address before
	$self->{'period'} = $self->{'rheader_hash'}->{'Reply-Period'} || 60*60;
	($self->{'from'}) = $self->split_addresses($self->{'header_hash'}->{'from'});
	if ($self->{'from'}) {
		$self->{'lasttime'} = $self->{'replies_hash'}->{$self->{'from'}->[0]};
		$self->{'now'} = time();
		if ($self->{'now'} < $self->{'lasttime'}+$self->{'period'}) {
			# Autoreplied already in this period .. just halt
			exit(0);
			}
		$self->{'replies_hash'}->{$self->{'from'}->[0]} = $self->{'now'};
		}
	}
delete($self->{'rheader_hash'}->{'Reply-Tracking'});
delete($self->{'rheader_hash'}->{'Reply-Period'});

# Check if there is a deny list, and if so don't send a reply
@{$self->{'fromsplit_array'}} = $self->split_addresses($self->{'header_hash'}->{'from'});
if (@{$self->{'fromsplit_array'}}) {
	$self->{'from'} = $self->{'fromsplit_array'}->[0]->[0];
	($self->{'fromuser'}, $self->{'fromdom'}) = split(/\@/, $self->{'from'});
	foreach $n (split(/\s+/, $self->{'rheader_hash'}->{'No-Autoreply'})) {
		if ($n =~ /^(\S+)\@(\S+)$/ && lc($self->{'from'}) eq lc($n) ||
		    $n =~ /^\*\@(\S+)$/ && lc($self->{'fromdom'}) eq lc($1) ||
		    $n =~ /^(\S+)\@\*$/ && lc($self->{'fromuser'}) eq lc($1) ||
		    $n =~ /^\*\@\*(\S+)$/ && lc($self->{'fromdom'}) =~ /$1$/i ||
		    $n =~ /^(\S+)\@\*(\S+)$/ && lc($self->{'fromuser'}) eq lc($1) &&
						lc($self->{'fromdom'}) =~ /$2$/i) {
			exit(0);
			}
		}
	delete($self->{'rheader_hash'}->{'No-Autoreply'});
	}

# Check if message matches one of the deny regexps
foreach $re (@{$self->{'no_regexp_array'}}) {
	if ($re =~ /\S/ && $self->{'rheaders'} =~ /$re/i) {
		print STDERR "Skipping due to match on $re\n";
		exit(1);
		}
	}

# Read attached files
foreach $f (@{$self->{'files_array'}}) {
	 $/ = undef;
	if (!open(FILE, $f)) {
		print STDERR "Failed to open $f : $!\n";
		exit(1);
		}
	$self->{'data'} = <FILE>;
	close(FILE);
	$f =~ s/^.*\///;
	$self->{'type'} = $self->guess_mime_type($f)."; name=\"$f\"";
	$self->{'disp'} = "inline; filename=\"$f\"";
	push(@{$self->{'attach_array'}}, { 'headers' => [ [ 'Content-Type', $self->{'type'} ],
				       [ 'Content-Disposition', $self->{'disp'} ],
				       [ 'Content-Transfer-Encoding', 'base64' ]
				     ],
			'data' => $self->{'data'} });
	}

# run sendmail and feed it the reply
($self->{'rfrom'}) = $self->split_addresses($self->{'rheader_hash'}->{'From'});
if ($self->{'rfrom'}->[0]) {
	open(MAIL, "|$self->{'config_hash'}->{'sendmail_path'} -t -f$self->{'rfrom'}->[0]");
	}
else {
	open(MAIL, "|$self->{'config_hash'}->{'sendmail_path'} -t -f$self->{'to'}");
	}
foreach $h (keys %{$self->{'rheader_hash'}}) {
	print MAIL "$h: $self->{'rheader_hash'}->{$h}\n";
	}

# Create the message body
if (!@{$self->{'attach_array'}}) {
	# Just text, so no encoding is needed
	print MAIL "\n";
	print MAIL $self->{'rbody'};
	}
else {
	# Need to send a multi-part MIME message
	print MAIL "MIME-Version: 1.0\n";
	$self->{'bound'} = "bound".time();
	$self->{'ctype'} = "multipart/mixed";
	print MAIL "Content-Type: $self->{'ctype'}; boundary=\"$self->{'bound'}\"\n";
	print MAIL "\n";
	splice(@{$self->{'attach_array'}}, 0, 0, { 'headers' => [ [ 'Content-Type', 'text/plain' ],
					     ],
				'data' => $self->{'rbody'} });

	# Send attachments
	print MAIL "This is a multi-part message in MIME format.","\n";
	$self->{'lnum'}++;
	foreach $a (@{$self->{'attach_array'}}) {
		print MAIL "\n";
		print MAIL "--",$self->{'bound'},"\n";
		 $self->{'enc'};
		foreach $h (@{$a->{'headers'}}) {
			print MAIL $h->[0],": ",$h->[1],"\n";
			$self->{'enc'} = $h->[1]
				if (lc($h->[0]) eq 'content-transfer-encoding');
			$self->{'lnum'}++;
			}
		print MAIL "\n";
		$self->{'lnum'}++;
		if (lc($self->{'enc'}) eq 'base64') {
			 $self->{'enc'} = $self->encode_base64($a->{'data'});
			$self->{'enc'} =~ s/\r//g;
			print MAIL $self->{'enc'};
			}
		else {
			$a->{'data'} =~ s/\r//g;
			$a->{'data'} =~ s/\n\.\n/\n\. \n/g;
			print MAIL $a->{'data'};
			if ($a->{'data'} !~ /\n$/) {
				print MAIL "\n";
				}
			}
		}
	print MAIL "\n";
	print MAIL "--",$self->{'bound'},"--","\n";
	print MAIL "\n";
	}
close(MAIL);

1;
		return $self;
}

# split_addresses(string)
# Splits a comma-separated list of addresses into [ email, real-name ] pairs
sub split_addresses
{
	my $self = shift;

local (@rv, $str = $_[0]);
while(1) {
	if ($str =~ /^[\s,]*(([^<>\(\)\s]+)\s+\(([^\(\)]+)\))(.*)$/) {
		push(@rv, [ $2, $3, $1 ]);
		$str = $4;
		}
	elsif ($str =~ /^[\s,]*("([^"]+)"\s+<([^\s<>]+)>)(.*)$/ ||
	       $str =~ /^[\s,]*(([^<>]+)\s+<([^\s<>]+)>)(.*)$/ ||
	       $str =~ /^[\s,]*(([^<>\[\]]+)\s+\[mailto:([^\s\[\]]+)\])(.*)$/||
	       $str =~ /^[\s,]*(()<([^\s<>]+)>)(.*)/ ||
	       $str =~ /^[\s,]*(()([^\s<>,]+))(.*)/) {
		push(@rv, [ $3, $2, $1 ]);
		$str = $4;
		}
	else {
		last;
		}
	}
return @rv;
}

# encode_base64(string)
# Encodes a string into base64 format
sub encode_base64
{
	my $self = shift;

    local $res;
    pos($_[0]) = 0;                          # ensure start at the beginning
    while ($_[0] =~ /(.{1,57})/gs) {
        $res .= substr(pack('u57', $1), 1)."\n";
        chop($res);
    }
    $res =~ tr|\` -_|AA-Za-z0-9+/|;
    local $padding = (3 - length($_[0]) % 3) % 3;
    $res =~ s/.{$padding}$/'=' x $padding/e if ($padding);
    return $res;
}

# guess_mime_type(filename)
sub guess_mime_type
{
	my $self = shift;

local ($file) = @_;
return $file =~ /\.gif/i ? "image/gif" :
       $file =~ /\.(jpeg|jpg)/i ? "image/jpeg" :
       $file =~ /\.txt/i ? "text/plain" :
       $file =~ /\.(htm|html)/i ? "text/html" :
       $file =~ /\.doc/i ? "application/msword" :
       $file =~ /\.xls/i ? "application/vnd.ms-excel" :
       $file =~ /\.ppt/i ? "application/vnd.ms-powerpoint" :
       $file =~ /\.(mpg|mpeg)/i ? "video/mpeg" :
       $file =~ /\.avi/i ? "video/x-msvideo" :
       $file =~ /\.(mp2|mp3)/i ? "audio/mpeg" :
       $file =~ /\.wav/i ? "audio/x-wav" :
			   "application/octet-stream";
}


1;

