#!/usr/bin/perl
package sendmail::Backup_config;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'sendmail::Backup_config');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;

&ModuleLoader::preload_module(ref($self), "sendmail::SendmailLib");
$self = new sendmail::SendmailLib:: ref($self), %$self; 
&ModuleLoader::preload_module(ref($self), "sendmail::AliasesLib");
$self = new sendmail::AliasesLib:: ref($self), %$self; 
&ModuleLoader::preload_module(ref($self), "sendmail::VirtusersLib");
$self = new sendmail::VirtusersLib:: ref($self), %$self; 
&ModuleLoader::preload_module(ref($self), "sendmail::MailersLib");
$self = new sendmail::MailersLib:: ref($self), %$self; 
&ModuleLoader::preload_module(ref($self), "sendmail::GenericsLib");
$self = new sendmail::GenericsLib:: ref($self), %$self; 
&ModuleLoader::preload_module(ref($self), "sendmail::DomainLib");
$self = new sendmail::DomainLib:: ref($self), %$self; 
&ModuleLoader::preload_module(ref($self), "sendmail::AccessLib");
$self = new sendmail::AccessLib:: ref($self), %$self; 

1;

1;
		return $self;
}

# backup_config_files()
# Returns files and directories that can be backed up
sub backup_config_files
{
	my $self = shift;

# Add main config file
local @rv = ( $self->{'config_hash'}->{'sendmail_cf'} );
local $conf = $self->get_sendmailcf();

# Add files references in .cf
local $f;
foreach $f ($self->find_type("F", $conf)) {
	if ($f->{'value'} =~ /^[wMtGR][^\/]*(\/\S+)/ ||
	    $f->{'value'} =~ /^\{[wMtGR]\}[^\/]*(\/\S+)/) {
		push(@rv, $1);
		}
	}

# Add other maps
local $afiles = $self->aliases_file($conf);
push(@rv, $afiles);
local $vfile = $self->virtusers_file($conf);
push(@rv, $vfile) if ($vfile);
local $mfile = $self->mailers_file($conf);
push(@rv, $mfile) if ($mfile);
local $gfile = $self->generics_file($conf);
push(@rv, $gfile) if ($gfile);
local $dfile = $self->domains_file($conf);
push(@rv, $dfile) if ($dfile);
local $afile = $self->access_file($conf);
push(@rv, $afile) if ($afile);

# Add .m4 files
push(@rv, $self->{'config_hash'}->{'sendmail_mc'}) if ($self->{'config_hash'}->{'sendmail_mc'});

return @rv;
}

# pre_backup(&files)
# Called before the files are actually read
sub pre_backup
{
	my $self = shift;

return undef;
}

# post_backup(&files)
# Called after the files are actually read
sub post_backup
{
	my $self = shift;

return undef;
}

# pre_restore(&files)
# Called before the files are restored from a backup
sub pre_restore
{
	my $self = shift;

return undef;
}

# post_restore(&files)
# Called after the files are restored from a backup
sub post_restore
{
	my $self = shift;

$self->restart_sendmail();
return undef;
}


1;

