#!/usr/bin/perl
package sendmail::Log_parser;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'sendmail::Log_parser');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# log_parser.pl
# Functions for parsing this module's logs

&ModuleLoader::preload_module(ref($self), "sendmail::SendmailLib");
$self = new sendmail::SendmailLib:: ref($self), %$self; 

1;
		return $self;
}

# parse_webmin_log(user, script, action, type, object, &params)
# Converts logged information from this module into human-readable form
sub parse_webmin_log
{
	my $self = shift;

local ($user, $script, $action, $type, $object, $p, $long) = @_;
if ($type eq 'alias' || $type eq 'virtuser' || $type eq 'mailer' ||
    $type eq 'generic' || $type eq 'domain' || $type eq 'access') {
	return $self->text("log_${type}_${action}",
		     "<tt>".$self->html_escape($object)."</tt>");
	}
elsif ($type eq 'aliases' || $type eq 'virtusers' || $type eq 'mailers' ||
       $type eq 'generics' || $type eq 'domains' || $type eq 'accesses') {
	return $self->text("log_${action}_${type}", $object);
	}
elsif ($type eq 'feature') {
	return $self->text("log_feature_${action}",
		     "<tt>".$self->html_escape($p->{'text'})."</tt>");
	}
elsif ($action eq 'delmailq') {
	if ($p->{'from'}) {
		return $self->text("log_delmailq",
			     $self->html_escape($self->extract_email($p->{'from'})));
		}
	else {
		return $self->text("log_delmailqs", $p->{'count'});
		}
	}
elsif ($action eq 'delmail') {
	local @d = split(/\0/, $p->{'d'});
	return $self->text("log_delmail", scalar(@d), "<tt>$p->{'user'}</tt>");
	}
elsif ($action eq 'movemail') {
	local @d = split(/\0/, $p->{'d'});
	local $to = $p->{'move1'} ? $p->{'moveto1'} : $p->{'moveto2'};
	return $self->text("log_movemail", scalar(@d), "<tt>$p->{'user'}</tt>",
		     "<tt>$to</tt>");
	}
elsif ($action eq 'send') {
	return $self->text('log_send', $self->html_escape($self->extract_email($p->{'to'})));
	}
elsif ($self->{'text_hash'}->{"log_$action"}) {
	return $self->{'text_hash'}->{"log_$action"};
	}
else {
	return undef;
	}
}

sub extract_email
{
	my $self = shift;

if ($_[0] =~ /([^<>"' \(\)]+\@[^<>"' \(\)]+)/) {
	return $1;
	}
elsif ($_[0] =~ /<(\S+)>/) {
	return $1;
	}
else {
	return $_[0];
	}
}


1;

