#!/usr/bin/perl

&MAIN();

 sub MAIN {
# del_mailqs.cgi
# Delete some mail messages from the queue

&ModuleLoader::preload_module('sendmail_class', "sendmail::SendmailLib");
$self = new sendmail::SendmailLib:: 'sendmail_class',%$self;

&ModuleLoader::preload_module('sendmail_class', "sendmail::BoxesLib");
$self = new sendmail::BoxesLib:: 'sendmail_class',%$self;

$self->ReadParse();
@{$self->{'files_array'}} = split(/\0/, $self->{'in_hash'}->{'file'});

if ($self->{'in_hash'}->{'flush'}) {
	# Flushing selected messages
	@{$self->{'files_array'}} || $self->error($self->{'text_hash'}->{'delq_enone'});
	$self->{'access_hash'}->{'flushq'} || $self->error($self->{'text_hash'}->{'flushq_ecannot'});
	$self->ui_print_unbuffered_header(undef, $self->{'text_hash'}->{'flushq_title'}, "");

	$self->{'cmd'} = "$self->{'config_hash'}->{'sendmail_path'} -v -C$self->{'config_hash'}->{'sendmail_cf'}";
	foreach $file (@{$self->{'files_array'}}) {
		$file =~ s/^.*\///;
		$self->{'cmd'} .= " -qI$file";
		}
	if ($self->{'config_hash'}->{'mailq_order'}) {
		$self->{'cmd'} .= " -O QueueSortOrder=$self->{'config_hash'}->{'mailq_order'}";
		}
	print $self->text('flushq_desc2', scalar(@{$self->{'files_array'}})),"\n";
	print "<pre>";
	$self->foreign_require("proc", "proc-lib.pl");
	$self->foreign_call("proc", "safe_process_exec_logged", $self->{'cmd'}, 0, 0,
		      STDOUT, undef, 1);
	print "</pre>\n";
	$self->webmin_log("flushq", undef, scalar(@{$self->{'files_array'}}));
	}
else {
	# Deleting selected messages
	$self->error_setup($self->{'text_hash'}->{'delq_err'});
	$self->{'access_hash'}->{'mailq'} == 2 || $self->error($self->{'text_hash'}->{'delq_ecannot'});
	@{$self->{'files_array'}} || $self->error($self->{'text_hash'}->{'delq_enone'});
	$self->ui_print_header(undef, $self->{'text_hash'}->{'delq_titles'}, "");

	if ($self->{'in_hash'}->{'confirm'}) {
		# Do it!
		$self->{'count'} = 0;
		$self->{'conf'} = $self->get_sendmailcf();
		foreach $file (@{$self->{'files_array'}}) {
			print $self->text('delq_file', "<tt>$file</tt>"),"&nbsp;&nbsp;&nbsp;\n";

			local $ok;
			foreach $mqueue ($self->mailq_dir($self->{'conf'})) {
				$ok++ if ($file =~ /^$mqueue\//);
				}
			if (!$ok) {
				print $self->{'text_hash'}->{'delq_efile'},"<br>\n";
				next;
				}

			if ($file =~ /\.\./) {
				print $self->{'text_hash'}->{'delq_efile'},"<br>\n";
				next;
				}
			if (!-r $file) {
				print $self->{'text_hash'}->{'delq_egone'},"<br>\n";
				next;
				}

			$self->{'mail'} = $self->mail_from_queue($file, "auto");
			if (!$self->can_view_qfile($self->{'mail'})) {
				print $self->{'text_hash'}->{'delq_ecannot'},"<br>\n";
				next;
				}

			if (-r $self->{'mail'}->{'lfile'} && !$self->{'in_hash'}->{'locked'}) {
				print $self->{'text_hash'}->{'delq_elocked'},"<br>\n";
				next;
				}

			unlink($self->{'mail'}->{'file'}, $self->{'mail'}->{'dfile'}, $self->{'mail'}->{'lfile'});
			print $self->{'text_hash'}->{'delq_ok'},"<br>\n";
			$self->{'count'}++;
			}
		$self->webmin_log("delmailq", undef, undef, { 'count' => $self->{'count'} }) if ($self->{'count'});
		}
	else {
		# Ask for confirmation first
		print "<center>\n";
		print $self->ui_form_start("del_mailqs.cgi", "post");
		print $self->text('delq_rusure', scalar(@{$self->{'files_array'}})),"<p>\n";
		foreach $f (@{$self->{'files_array'}}) {
			print $self->ui_hidden("file", $f),"\n";
			}
		print $self->ui_hidden("locked", $self->{'in_hash'}->{'locked'}),"\n";
		print $self->ui_form_end([ [ "confirm", $self->{'text_hash'}->{'delq_confirm'} ] ]);
		print "</center>\n";
		}
	}
$self->ui_print_footer("list_mailq.cgi", $self->{'text_hash'}->{'mailq_return'});

1;
		
}


1;

