#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_feature.cgi
# Displays a form for editing or creating some M4 file entry, which may be a
# feature, define, mailer or other line.

&ModuleLoader::preload_module('sendmail_class', "sendmail::SendmailLib");
$self = new sendmail::SendmailLib:: 'sendmail_class',%$self;

&ModuleLoader::preload_module('sendmail_class', "sendmail::FeaturesLib");
$self = new sendmail::FeaturesLib:: 'sendmail_class',%$self;

$self->ReadParse();
$self->{'features_access'} || $self->error($self->{'text_hash'}->{'features_ecannot'});

if ($self->{'in_hash'}->{'manual'}) {
	# Display manual edit form
	$self->ui_print_header(undef, $self->{'text_hash'}->{'feature_manual'}, "");

	print "<form action=manual_features.cgi method=post ",
	      "enctype=multipart/form-data>\n";
	print $self->text('feature_mdesc', "<tt>$self->{'config_hash'}->{'sendmail_mc'}</tt>"),
	      "<br>\n";
	print "<textarea name=data rows=20 cols=80>";
	open(FEAT, $self->{'config_hash'}->{'sendmail_mc'});
	while(<FEAT>) {
		print $self->html_escape($_);
		}
	close(FEAT);
	print "</textarea><br>\n";
	print "<input type=submit value='$self->{'text_hash'}->{'save'}'></form>\n";

	$self->ui_print_footer("list_features.cgi", $self->{'text_hash'}->{'features_return'});
	exit;
	}
if ($self->{'in_hash'}->{'new'}) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'feature_add'}, "");
	$self->{'feature'} = { 'type' => $self->{'in_hash'}->{'type'} };
	}
else {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'feature_edit'}, "");
	@{$self->{'features_array'}} = $self->list_features();
	$self->{'feature'} = $self->{'features_array'}->[$self->{'in_hash'}->{'idx'}];
	}

print "<form action=save_feature.cgi>\n";
print "<input type=hidden name=new value='$self->{'in_hash'}->{'new'}'>\n";
print "<input type=hidden name=idx value='$self->{'in_hash'}->{'idx'}'>\n";
print "<input type=hidden name=type value='$self->{'feature'}->{'type'}'>\n";

print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'feature_header'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table>\n";

if (!$self->{'in_hash'}->{'new'} && $self->{'feature'}->{'type'}) {
	print "<tr> <td><b>$self->{'text_hash'}->{'feature_old'}</b></td>\n";
	print "<td><tt>$self->{'feature'}->{'text'}</tt></td> </tr>\n";
	}

if ($self->{'feature'}->{'type'} == 0) {
	# Unsupported text line
	print "<tr> <td><b>$self->{'text_hash'}->{'feature_text'}</b></td>\n";
	printf "<td><input name=text size=50 value='%s'></td> </tr>\n",
		$self->html_escape($self->{'feature'}->{'text'});
	}
elsif ($self->{'feature'}->{'type'} == 1) {
	# A FEATURE() definition
	print "<tr> <td><b>$self->{'text_hash'}->{'feature_feat'}</b></td>\n";
	print "<td><select name=name>\n";
	foreach $f ($self->list_feature_types()) {
		printf "<option value=%s %s>%s\n",
			$f->[0], $self->{'feature'}->{'name'} eq $f->[0] ? 'selected' : '',
			$f->[1];
		}
	print "</select></td> </tr>\n";

	print "<tr> <td valign=top><b>$self->{'text_hash'}->{'feature_values'}</b></td> <td>\n";
	local @v = @{$self->{'feature'}->{'values'}};
	@v = ( "" ) if (!@v);
	for($i=0; $i<=@v; $i++) {
		print "<input name=value_$i size=50 value='$v[$i]'><br>\n";
		}
	print "</td> </tr>\n";
	}
elsif ($self->{'feature'}->{'type'} == 2 || $self->{'feature'}->{'type'} == 3) {
	# A define() or undefine()
	print "<tr> <td><b>$self->{'text_hash'}->{'feature_def'}</b></td>\n";
	print "<td><select name=name>\n";
	foreach $d ($self->list_define_types()) {
		printf "<option value=%s %s>%s\n",
			$d->[0], $d->[0] eq $self->{'feature'}->{'name'} ? "selected" : "",
			$d->[1];
		$self->{'found'}++ if ($d->[0] eq $self->{'feature'}->{'name'});
		}
	print "<option value=$self->{'feature'}->{'name'} selected>$self->{'feature'}->{'name'}\n"
		if (!$self->{'found'} && !$self->{'in_hash'}->{'new'});
	print "</select>\n";

	print "<tr> <td valign=top><b>$self->{'text_hash'}->{'feature_defval'}</b></td>\n";
	print "<td valign=top>\n";
	printf "<input type=radio name=undef value=0 %s> %s\n",
		$self->{'feature'}->{'type'} == 2 ? "checked" : "", $self->{'text_hash'}->{'feature_defmode1'};
	printf "<input name=value size=50 value='%s'><br>\n",
		$self->{'feature'}->{'value'};
	printf "<input type=radio name=undef value=1 %s> %s\n",
		$self->{'feature'}->{'type'} == 3 ? "checked" : "", $self->{'text_hash'}->{'feature_defmode0'};
	print "</td> </tr>\n";
	}
elsif ($self->{'feature'}->{'type'} == 4) {
	# A MAILER() definition
	print "<tr> <td><b>$self->{'text_hash'}->{'feature_mailer'}</b></td>\n";
	print "<td><select name=mailer>\n";
	foreach $m ($self->list_mailer_types()) {
		printf "<option value=%s %s>%s\n",
			$m->[0], $self->{'feature'}->{'mailer'} eq $m->[0] ? 'selected' : '',
			$m->[1];
		}
	print "</select></td> </tr>\n";
	}
elsif ($self->{'feature'}->{'type'} == 5) {
	# An OSTYPE() definition
	print "<tr> <td><b>$self->{'text_hash'}->{'feature_ostype'}</b></td>\n";
	print "<td><select name=ostype>\n";
	foreach $m ($self->list_ostype_types()) {
		printf "<option value=%s %s>%s\n",
			$m->[0], $self->{'feature'}->{'ostype'} eq $m->[0] ? 'selected' : '',
			$m->[1];
		}
	print "</select></td> </tr>\n";
	}

print "</table></td></tr></table>\n";
print "<table width=100%><tr>\n";
if ($self->{'in_hash'}->{'new'}) {
	print "<td><input type=submit value='$self->{'text_hash'}->{'create'}'></td>\n";
	}
else {
	print "<td><input type=submit value='$self->{'text_hash'}->{'save'}'></td>\n";
	print "<td align=right><input type=submit name=delete ",
	      "value='$self->{'text_hash'}->{'delete'}'></td>\n";
	}
print "</tr></table></form>\n";

$self->ui_print_footer("list_features.cgi", $self->{'text_hash'}->{'features_return'});

1;
		
}


1;

