#!/usr/bin/perl

&MAIN();

 sub MAIN {
# index.cgi
# Display icons for various things that can be configured in sendmail

&ModuleLoader::preload_module('sendmail_class', "sendmail::SendmailLib");
$self = new sendmail::SendmailLib:: 'sendmail_class',%$self;

&ModuleLoader::preload_module('sendmail_class', "sendmail::BoxesLib");
$self = new sendmail::BoxesLib:: 'sendmail_class',%$self;


# Check if sendmail is actually installed
if (!-x $self->{'config_hash'}->{'sendmail_path'}) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", "intro", 1, 1, 0,
		$self->help_search_link("sendmail", "man", "doc", "google"));
	print $self->text('index_epath', "<tt>$self->{'config_hash'}->{'sendmail_path'}</tt>",
			  "$self->{'gconfig_hash'}->{'webprefix'}/config.cgi?$self->{'module_name'}"),"<p>\n";

	$self->foreign_require("software", "software-lib.pl");
	$self->{'lnk'} = $main::software_object->missing_install_link(
			"sendmail", $self->{'text_hash'}->{'index_sendmail'},
			"../$self->{'module_name'}/", $self->{'text_hash'}->{'index_title'});
	print $self->{'lnk'},"<p>\n" if ($self->{'lnk'});

	$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});
	exit;
	}

# Get the executable version number
$self->{'ever'} = $self->get_sendmail_version(\$self->{'out'});

# Check if the config file exists, and is the right version
if (!-s $self->{'config_hash'}->{'sendmail_cf'}) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", "intro", 1, 1, 0,
		$self->help_search_link("sendmail", "man", "doc", "google"));
	print $self->text('index_econfig', "<tt>$self->{'config_hash'}->{'sendmail_cf'}</tt>",
		  "$self->{'gconfig_hash'}->{'webprefix'}/config.cgi?$self->{'module_name'}"),"<p>\n";

	$self->foreign_require("software", "software-lib.pl");
	$self->{'lnk'} = $main::software_object->missing_install_link(
			"sendmail", $self->{'text_hash'}->{'index_sendmail'},
			"../$self->{'module_name'}/", $self->{'text_hash'}->{'index_header'});
	print $self->{'lnk'},"<p>\n" if ($self->{'lnk'});

	$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});
	exit;
	}
$self->{'conf'} = $self->get_sendmailcf();
$self->{'cfgver'} = $self->find_type("V", $self->{'conf'});
$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", "intro", 1, 1, 0,
	$self->help_search_link("sendmail", "man", "doc", "google"), undef, undef,
	$self->{'ever'} && $self->{'cfgver'} ? $self->text('index_version2',$self->{'ever'},"V$self->{'cfgver'}->{'value'}") :
	$self->{'cfgver'} ? $self->text('index_version', "V$self->{'cfgver'}->{'value'}") :
	$self->{'ever'} ? $self->text('index_xversion', $self->{'ever'}) : undef);

if (!$self->check_sendmail_version($self->{'conf'})) {
	print "$self->{'text_hash'}->{'index_eversion'}<p>\n";
	$self->ui_print_footer("/", "index");
	exit;
	}

local $mcount;
if (!$self->{'config_hash'}->{'mailq_count'}) {
	# Check the mail spool
	@{$self->{'qfiles_array'}} = $self->list_mail_queue($self->{'conf'});
	if ($self->{'access_hash'}->{'qdoms'}) {
		# Filter out blocked mails
		@{$self->{'qfiles_array'}} = grep { $self->can_view_qfile($self->mail_from_queue($_)) }
		       	       @{$self->{'qfiles_array'}};
		}
	$mcount = scalar(@{$self->{'qfiles_array'}});
	}

@{$self->{'olinks_array'}} =  ( "list_opts.cgi", "list_aliases.cgi", "list_cws.cgi", "list_masq.cgi", "list_trusts.cgi", "list_virtusers.cgi", "list_mailers.cgi", "list_generics.cgi", "list_cgs.cgi", "list_domains.cgi", "list_access.cgi", "list_relay.cgi", "list_features.cgi", "list_mailq.cgi", "../mailboxes/" );

@{$self->{'otitles_array'}} = ( "$self->{'text_hash'}->{'opts_title'} (O)", "$self->{'text_hash'}->{'aliases_title'} (aliases)", "$self->{'text_hash'}->{'cws_title'} (Cw)", "$self->{'text_hash'}->{'masq_title'} (CM)", "$self->{'text_hash'}->{'trusts_title'} (T)", "$self->{'text_hash'}->{'virtusers_title'} (virtuser)", "$self->{'text_hash'}->{'mailers_title'} (mailertable)", "$self->{'text_hash'}->{'generics_title'} (generics)", "$self->{'text_hash'}->{'cgs_title'} (CG)", "$self->{'text_hash'}->{'domains_title'} (domaintable)", "$self->{'text_hash'}->{'access_title'} (access)", "$self->{'text_hash'}->{'relay_title'} (CR)", $self->{'text_hash'}->{'features_title'}, "$self->{'text_hash'}->{'mailq_title'} (mailq)".(defined($mcount) ? "<br>".$self->text('mailq_count', $mcount) : ""), "$self->{'text_hash'}->{'boxes_title'}"); 

@{$self->{'oicons_array'}} =  ( "images/opts.gif", "images/aliases.gif", "images/cws.gif", "images/masq.gif", "images/trusts.gif", "images/virtusers.gif", "images/mailers.gif", "images/generics.gif", "images/cgs.gif", "images/domains.gif", "images/access.gif", "images/relay.gif", "images/features.gif", "images/mailq.gif", "images/boxes.gif" );

&filter_icons($self->{'access_hash'}->{'opts'}, "list_opts.cgi");
&filter_icons($self->{'access_hash'}->{'cws'}, "list_cws.cgi");
&filter_icons($self->{'access_hash'}->{'masq'}, "list_masq.cgi");
&filter_icons($self->{'access_hash'}->{'trusts'}, "list_trusts.cgi");
&filter_icons($self->{'access_hash'}->{'vmode'}, "list_virtusers.cgi");
&filter_icons($self->{'access_hash'}->{'amode'}, "list_aliases.cgi");
&filter_icons($self->{'access_hash'}->{'omode'}, "list_generics.cgi");
&filter_icons($self->{'access_hash'}->{'cgs'}, "list_cgs.cgi");
&filter_icons($self->{'access_hash'}->{'relay'}, "list_relay.cgi");
&filter_icons($self->{'access_hash'}->{'mailq'}, "list_mailq.cgi");
&filter_icons($self->{'access_hash'}->{'mailers'}, "list_mailers.cgi");
&filter_icons($self->{'access_hash'}->{'access'}, "list_access.cgi");
&filter_icons($self->{'access_hash'}->{'domains'}, "list_domains.cgi");
&filter_icons($self->{'features_access'}, "list_features.cgi");
&filter_icons($self->foreign_available("mailboxes"), "list_boxes.cgi");

$self->icons_table(\@{$self->{'olinks_array'}}, \@{$self->{'otitles_array'}}, \@{$self->{'oicons_array'}});

if ($self->{'access_hash'}->{'stop'}) {
	print "<hr>\n";
	print $self->ui_buttons_start();
	if ($self->is_sendmail_running()) {
		print $self->ui_buttons_row("stop.cgi", $self->{'text_hash'}->{'index_stop'},
				      $self->{'text_hash'}->{'index_stopmsg'});
		}
	else {
		print $self->ui_buttons_row("start.cgi", $self->{'text_hash'}->{'index_start'},
				      $self->text('index_startmsg',
				"<tt>$self->{'config_hash'}->{'sendmail_command'}</tt>"));
		}
	print $self->ui_buttons_end();
	}

$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});

1;
		
}

sub filter_icons
{
	shift if ($self == $_[0]);

if (!$_[0]) {
	local $idx = $self->indexof($_[1], @{$self->{'olinks_array'}});
	splice(@{$self->{'olinks_array'}}, $idx, 1);
	splice(@{$self->{'otitles_array'}}, $idx, 1);
	splice(@{$self->{'oicons_array'}}, $idx, 1);
	}
}


1;

