#!/usr/bin/perl

&MAIN();

 sub MAIN {
# list_access.cgi
# Display a list of all domain and address mappings

&ModuleLoader::preload_module('sendmail_class', "sendmail::SendmailLib");
$self = new sendmail::SendmailLib:: 'sendmail_class',%$self;

&ModuleLoader::preload_module('sendmail_class', "sendmail::AccessLib");
$self = new sendmail::AccessLib:: 'sendmail_class',%$self;

$self->ReadParse();
$self->{'access_hash'}->{'access'} || $self->error($self->{'text_hash'}->{'access_ecannot'});
$self->ui_print_header(undef, $self->{'text_hash'}->{'access_title'}, "");

$self->{'conf'} = $self->get_sendmailcf();
$self->{'afile'} = $self->access_file($self->{'conf'});
($self->{'adbm'}, $self->{'adbmtype'}) = $self->access_dbm($self->{'conf'});
if (!$self->{'adbm'}) {
	# No Kaccess directive in sendmail.cf
	print "<b>",$self->text('access_efeature', 'list_features.cgi'),"</b><p>\n";
	$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
	exit;
	}
if (!-r $self->{'afile'}) {
	# Text file not found
	print "<b>",$self->text('access_efile', "<tt>$self->{'afile'}</tt>",
	      "<tt>$self->{'adbm'}</tt>", "$self->{'gconfig_hash'}->{'webprefix'}/config.cgi?$self->{'module_name'}"),"</b> <p>\n";
	print "<b>",$self->text('virtusers_createfile',
		    	  'create_file.cgi?mode=access'),"</b><p>\n";
	$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
	exit;
	}

# Get list of spam control rules, limited to those the user can edit
@{$self->{'accs_array'}} = $self->list_access($self->{'afile'});
if ($self->{'access_hash'}->{'smode'} == 2) {
	@{$self->{'accs_array'}} = grep { $_->{'from'} =~ /$self->{'access_hash'}->{'saddrs'}/i } @{$self->{'accs_array'}};
	}

$self->access_form();

if ($self->{'in_hash'}->{'search'}) {
	# Restrict to search results
	@{$self->{'accs_array'}} = grep { $_->{'from'} =~ /$self->{'in_hash'}->{'search'}/i ||
		       $_->{'to'} =~ /$self->{'in_hash'}->{'search'}/i } @{$self->{'accs_array'}};
	}
elsif ($self->{'config_hash'}->{'max_records'} && @{$self->{'accs_array'}} > $self->{'config_hash'}->{'max_records'}) {
	# Show search form
	print $self->{'text_hash'}->{'access_toomany'},"<br>\n";
	print "<form action=list_access.cgi>\n";
	print "<input type=submit value='$self->{'text_hash'}->{'access_go'}'>\n";
	print "<input name=search size=20></form>\n";
	undef(@{$self->{'accs_array'}});
	}

if (@{$self->{'accs_array'}}) {
	# sort if needed
	if ($self->{'config_hash'}->{'sort_mode'} == 1) {
		@{$self->{'accs_array'}} = sort { $a->{'from'} cmp $b->{'from'} } @{$self->{'accs_array'}};
		}

	# render table of access rules
	print $self->ui_form_start("delete_access.cgi", "post");
	@{$self->{'links_array'}} = ( $self->select_all_link("d", 1),
		   $self->select_invert_link("d", 1) );
	print $self->ui_links_row(\@{$self->{'links_array'}});
	if ($self->{'config_hash'}->{'columns'} == 2) {
		$self->{'mid'} = int((@{$self->{'accs_array'}}+1)/2);
		print "<table width=100%> <tr><td width=50% valign=top>\n";
		&accs_table(@{$self->{'accs_array'}}[0..$self->{'mid'}-1]);
		print "</td><td width=50% valign=top>\n";
		if ($self->{'mid'} < @{$self->{'accs_array'}}) { &accs_table(@{$self->{'accs_array'}}[$self->{'mid'}..$#{$self->{'accs_array'}}]); }
		print "</td></tr> </table><br>\n";
		}
	else {
		&accs_table(@{$self->{'accs_array'}});
		}
	print $self->ui_links_row(\@{$self->{'links_array'}});
	print $self->ui_form_end([ [ "delete", $self->{'text_hash'}->{'access_delete'} ] ]);
	}
print "<a href='edit_file.cgi?mode=access'>",
	$self->text('file_edit', "<tt>$self->{'afile'}</tt>"),"</a><p>\n"
	if ($self->{'access_hash'}->{'manual'});
print $self->{'text_hash'}->{'access_desc1'},"<p>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}

sub accs_table
{
	shift if ($self == $_[0]);

local @tds = ( "width=5" );
print $self->ui_columns_start([ "",
			  $self->{'text_hash'}->{'access_source'},
			  $self->{'text_hash'}->{'access_action'},
			  $self->{'config_hash'}->{'show_cmts'} ? ( $self->{'text_hash'}->{'virtusers_cmt'} )
					       : ( ) ], 100, 0, \@tds);
foreach $m (@_) {
	$self->{'from'} = $m->{'tag'} ? "$m->{'tag'}: $m->{'from'}" : $m->{'from'};
	local @cols;
	push(@cols, "<a href=\"edit_access.cgi?num=$m->{'num'}\">".
		    $self->html_escape($self->{'from'})."</a>");
	push(@cols, $self->html_escape($m->{'action'}));
	push(@cols, $self->html_escape($m->{'cmt'})) if ($self->{'config_hash'}->{'show_cmts'});
	print $self->ui_checked_columns_row(\@cols, \@tds, "d", $m->{'from'});
	}
print $self->ui_columns_end();
}


1;

