#!/usr/bin/perl

&MAIN();

 sub MAIN {
# list_aliases.cgi
# Displays a list of all aliases

&ModuleLoader::preload_module('sendmail_class', "sendmail::SendmailLib");
$self = new sendmail::SendmailLib:: 'sendmail_class',%$self;

&ModuleLoader::preload_module('sendmail_class', "sendmail::AliasesLib");
$self = new sendmail::AliasesLib:: 'sendmail_class',%$self;

$self->ReadParse();
$self->{'access_hash'}->{'amode'} || $self->error($self->{'text_hash'}->{'aliases_ecannot'});
$self->{'conf'} = $self->get_sendmailcf();
$self->{'afile'} = $self->aliases_file($self->{'conf'});
@{$self->{'afile'}} || $self->error($self->{'text_hash'}->{'aliases_enofile'});
$self->ui_print_header(undef, $self->{'text_hash'}->{'aliases_title'}, "", "aliases");

@{$self->{'aliases_array'}} = $self->list_aliases($self->{'afile'});
if ($self->{'access_hash'}->{'amode'} == 2) {
	@{$self->{'aliases_array'}} = grep { $_->{'name'} =~ /$self->{'access_hash'}->{'aliases'}/ } @{$self->{'aliases_array'}};
	}
elsif ($self->{'access_hash'}->{'amode'} == 3) {
	@{$self->{'aliases_array'}} = grep { $_->{'name'} eq $self->{'remote_user'} } @{$self->{'aliases_array'}};
	}
@{$self->{'aliases_array'}} = grep { local $rv = 1;
		  foreach $v (@{$_->{'values'}}) {
			$rv = 0 if (!$self->{'access_hash'}->{"aedit_".$self->alias_type($v)});
			}
		  $rv;
		} @{$self->{'aliases_array'}};

$self->alias_form();

if ($self->{'in_hash'}->{'search'}) {
	# Restrict to search results
	@{$self->{'aliases_array'}} = grep { $_->{'name'} =~ /$self->{'in_hash'}->{'search'}/ } @{$self->{'aliases_array'}};
	}
elsif ($self->{'config_hash'}->{'max_records'} && @{$self->{'aliases_array'}} > $self->{'config_hash'}->{'max_records'}) {
	# Show search form
	print $self->{'text_hash'}->{'aliases_toomany'},"<br>\n";
	print "<form action=list_aliases.cgi>\n";
	print "<input type=submit value='$self->{'text_hash'}->{'aliases_go'}'>\n";
	print "<input name=search size=20></form>\n";
	undef(@{$self->{'aliases_array'}});
	}

if (@{$self->{'aliases_array'}}) {
	# sort if needed
	if ($self->{'config_hash'}->{'sort_mode'} == 1) {
		@{$self->{'aliases_array'}} = sort { lc($a->{'name'}) cmp lc($b->{'name'}) }
				@{$self->{'aliases_array'}};
		}

	# find a good place to split
	$self->{'lines'} = 0;
	for($i=0; $i<@{$self->{'aliases_array'}}; $i++) {
		$self->{'aline_array'}->[$i] = $self->{'lines'};
		$self->{'al'} = scalar(@{$self->{'aliases_array'}->[$i]->{'values'}});
		$self->{'lines'} += ($self->{'al'} ? $self->{'al'} : 1);
		}
	$self->{'midline'} = int(($self->{'lines'}+1) / 2);
	for($mid=0; $mid<@{$self->{'aliases_array'}} && $self->{'aline_array'}->[$mid] < $self->{'midline'}; $mid++) { }

	# render tables
	print $self->ui_form_start("delete_aliases.cgi", "post");
	@{$self->{'links_array'}} = ( $self->select_all_link("d", 1),
		   $self->select_invert_link("d", 1) );
	print $self->ui_links_row(\@{$self->{'links_array'}});
	if ($self->{'config_hash'}->{'columns'} == 2) {
		print "<table width=100%> <tr><td width=50% valign=top>\n";
		&aliases_table(@{$self->{'aliases_array'}}[0..$mid-1]);
		print "</td><td width=50% valign=top>\n";
		if ($mid < @{$self->{'aliases_array'}}) { &aliases_table(@{$self->{'aliases_array'}}[$mid..$#{$self->{'aliases_array'}}]); }
		print "</td></tr> </table><br>\n";
		}
	else {
		&aliases_table(@{$self->{'aliases_array'}});
		}
	print $self->ui_links_row(\@{$self->{'links_array'}});
	print $self->ui_form_end([ [ "delete", $self->{'text_hash'}->{'aliases_delete'} ] ]);
	}

if ($self->{'access_hash'}->{'amode'} == 1 && $self->{'access_hash'}->{'aedit_1'} && $self->{'access_hash'}->{'aedit_2'} &&
    $self->{'access_hash'}->{'aedit_3'} && $self->{'access_hash'}->{'aedit_4'} && $self->{'access_hash'}->{'aedit_5'} &&
    $self->{'access_hash'}->{'amax'} == 0 && $self->{'access_hash'}->{'apath'} eq '/' &&
    $self->{'access_hash'}->{'manual'}) {
	$i = 0;
	foreach $f (@{$self->aliases_file($self->{'conf'})}) {
		print "<a href='edit_file.cgi?mode=aliases&idx=$i'>",
			$self->text('file_edit', "<tt>$f</tt>"),
			"</a>&nbsp;&nbsp;\n";
		$i++;
		}
	print "<p>\n";
	}

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}

sub aliases_table
{
	shift if ($self == $_[0]);

local @tds = ( "width=5", "valign=top", "valign=top" );
print $self->ui_columns_start([ "",
			  $self->{'text_hash'}->{'aliases_addr'},
			  $self->{'text_hash'}->{'aliases_to'},
			  $self->{'config_hash'}->{'show_cmts'} ? ( $self->{'text_hash'}->{'virtusers_cmt'} )
					       : ( ) ], 100, 0, \@tds);
foreach $a (@_) {
	local @cols;
	push(@cols, "<a href=\"edit_alias.cgi?num=$a->{'num'}\">".
	      ($a->{'enabled'} ? "" : "<i>").$self->html_escape($a->{'name'}).
	      ($a->{'enabled'} ? "" : "</i>")."</a>");
	local $vstr;
	foreach $v (@{$a->{'values'}}) {
		($self->{'anum'}, $self->{'astr'}) = $self->alias_type($v);
		$vstr .= $self->text("aliases_type$self->{'anum'}",
			    "<tt>".$self->html_escape($self->{'astr'})."</tt>")."<br>\n";
		}
	$vstr ||= "<i>$self->{'text_hash'}->{'aliases_none'}</i>\n";
	push(@cols, $vstr);
	push(@cols, $self->html_escape($a->{'cmt'})) if ($self->{'config_hash'}->{'show_cmts'});
	print $self->ui_checked_columns_row(\@cols, \@tds, "d", $a->{'name'});
	}
print $self->ui_columns_end();
}


1;

