#!/usr/bin/perl

&MAIN();

 sub MAIN {
# list_domains.cgi
# Display a list of all domain mappings

&ModuleLoader::preload_module('sendmail_class', "sendmail::SendmailLib");
$self = new sendmail::SendmailLib:: 'sendmail_class',%$self;

&ModuleLoader::preload_module('sendmail_class', "sendmail::DomainLib");
$self = new sendmail::DomainLib:: 'sendmail_class',%$self;

$self->{'access_hash'}->{'domains'} || $self->error($self->{'text_hash'}->{'domains_ecannot'});
$self->ui_print_header(undef, $self->{'text_hash'}->{'domains_title'}, "");

$self->{'conf'} = $self->get_sendmailcf();
$self->{'dfile'} = $self->domains_file($self->{'conf'});
($self->{'ddbm'}, $self->{'ddbmtype'}) = $self->domains_dbm($self->{'conf'});
if (!$self->{'ddbm'}) {
	# No Kdomain directive in sendmail.cf
	print "<b>",$self->text('domains_efeature', 'list_features.cgi'),"</b><p>\n";
	$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
	exit;
	}
if (!-r $self->{'dfile'}) {
	# Text file not found
	print "<b>",$self->text('domains_efile', "<tt>$self->{'dfile'}</tt>",
	      "<tt>$self->{'ddbm'}</tt>", "$self->{'gconfig_hash'}->{'webprefix'}/config.cgi?$self->{'module_name'}"),"</b> <p>\n";
	print "<b>",$self->text('virtusers_createfile',
		    	  'create_file.cgi?mode=domains'),"</b><p>\n";
	$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
	exit;
	}
@{$self->{'doms_array'}} = $self->list_domains($self->{'dfile'});

$self->domain_form();
if (@{$self->{'doms_array'}}) {
	# sort if needed
	if ($self->{'config_hash'}->{'sort_mode'} == 1) {
		@{$self->{'doms_array'}} = sort { $a->{'from'} cmp $b->{'from'} } @{$self->{'doms_array'}};
		}

	# render table of domains
	print $self->ui_form_start("delete_domains.cgi", "post");
	@{$self->{'links_array'}} = ( $self->select_all_link("d", 1),
		   $self->select_invert_link("d", 1) );
	print $self->ui_links_row(\@{$self->{'links_array'}});
	if ($self->{'config_hash'}->{'columns'} == 2) {
		$self->{'mid'} = int((@{$self->{'doms_array'}}+1)/2);
		print "<table width=100%> <tr><td width=50% valign=top>\n";
		&doms_table(@{$self->{'doms_array'}}[0..$self->{'mid'}-1]);
		print "</td><td width=50% valign=top>\n";
		if ($self->{'mid'} < @{$self->{'doms_array'}}) { &doms_table(@{$self->{'doms_array'}}[$self->{'mid'}..$#{$self->{'doms_array'}}]); }
		print "</td></tr> </table><br>\n";
		}
	else {
		&doms_table(@{$self->{'doms_array'}});
		}
	print $self->ui_links_row(\@{$self->{'links_array'}});
	print $self->ui_form_end([ [ "delete", $self->{'text_hash'}->{'domains_delete'} ] ]);
	}
print "<a href='edit_file.cgi?mode=domains'>",
	$self->text('file_edit', "<tt>$self->{'dfile'}</tt>"),"</a><p>\n"
	if ($self->{'access_hash'}->{'manual'});
print $self->{'text_hash'}->{'domains_desc'},"<p>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}

sub doms_table
{
	shift if ($self == $_[0]);

local @tds = ( "width=5" );
print $self->ui_columns_start([ "",
			  $self->{'text_hash'}->{'domains_from'},
			  $self->{'text_hash'}->{'domains_to'},
			  $self->{'config_hash'}->{'show_cmts'} ? ( $self->{'text_hash'}->{'virtusers_cmt'} )
					       : ( ) ], 100, 0, \@tds);
foreach $m (@_) {
	local @cols;
	push(@cols, "<a href=\"edit_domain.cgi?num=$m->{'num'}\">".
		    $self->html_escape($m->{'from'})."</a>");
	push(@cols, $self->html_escape($m->{'to'}));
	push(@cols, $self->html_escape($m->{'cmt'})) if ($self->{'config_hash'}->{'show_cmts'});
	print $self->ui_checked_columns_row(\@cols, \@tds, "d", $m->{'from'});
	}
print $self->ui_columns_end();
}


1;

