#!/usr/bin/perl

&MAIN();

 sub MAIN {
# list_generics.cgi
# Display a list of addresses for outgoing address mapping

&ModuleLoader::preload_module('sendmail_class', "sendmail::SendmailLib");
$self = new sendmail::SendmailLib:: 'sendmail_class',%$self;

&ModuleLoader::preload_module('sendmail_class', "sendmail::GenericsLib");
$self = new sendmail::GenericsLib:: 'sendmail_class',%$self;

$self->ReadParse();
$self->{'access_hash'}->{'omode'} || $self->error($self->{'text_hash'}->{'generics_cannot'});
$self->ui_print_header(undef, $self->{'text_hash'}->{'generics_title'}, "");

$self->{'conf'} = $self->get_sendmailcf();
$self->{'gfile'} = $self->generics_file($self->{'conf'});
($self->{'gdbm'}, $self->{'gdbmtype'}) = $self->generics_dbm($self->{'conf'});
if (!$self->{'gdbm'}) {
	# No Kgenerics directive in sendmail.cf
	print "<b>",$self->text('generics_efeature', 'list_features.cgi'),"</b><p>\n";
	$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
	exit;
	}
if (!-r $self->{'gfile'}) {
	# Text file not found
	print "<b>",$self->text('generics_efile', "<tt>$self->{'gfile'}</tt>",
	      "<tt>$self->{'gdbm'}</tt>", "$self->{'gconfig_hash'}->{'webprefix'}/config.cgi?$self->{'module_name'}"),"</b> <p>\n";
	print "<b>",$self->text('virtusers_createfile',
		    	  'create_file.cgi?mode=generics'),"</b><p>\n";
	$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
	exit;
	}

# Get list of outgoing mappings, limited to those the user can edit
@{$self->{'gens_array'}} = $self->list_generics($self->{'gfile'});
if ($self->{'access_hash'}->{'omode'} == 2) {
	@{$self->{'gens_array'}} = grep { $_->{'from'} =~ /$self->{'access_hash'}->{'oaddrs'}/i ||
		       $_->{'to'} =~ /$self->{'access_hash'}->{'oaddrs'}/i } @{$self->{'gens_array'}};
	}

$self->generic_form();

if ($self->{'in_hash'}->{'search'}) {
	# Restrict to search results
	@{$self->{'gens_array'}} = grep { $_->{'from'} =~ /$self->{'in_hash'}->{'search'}/ } @{$self->{'gens_array'}};
	}
elsif ($self->{'config_hash'}->{'max_records'} && @{$self->{'gens_array'}} > $self->{'config_hash'}->{'max_records'}) {
	# Show search form
	print $self->{'text_hash'}->{'generics_toomany'},"<br>\n";
	print "<form action=list_generics.cgi>\n";
	print "<input type=submit value='$self->{'text_hash'}->{'generics_go'}'>\n";
	print "<input name=search size=20></form>\n";
	undef(@{$self->{'gens_array'}});
	}

if (@{$self->{'gens_array'}}) {
	# sort if needed
	if ($self->{'config_hash'}->{'sort_mode'} == 1) {
		@{$self->{'gens_array'}} = sort sort_by_domain @{$self->{'gens_array'}};
		}

	# render table of generics
	print $self->ui_form_start("delete_generics.cgi", "post");
	@{$self->{'links_array'}} = ( $self->select_all_link("d", 1),
		   $self->select_invert_link("d", 1) );
	print $self->ui_links_row(\@{$self->{'links_array'}});
	if ($self->{'config_hash'}->{'columns'} == 2) {
		$self->{'mid'} = int((@{$self->{'gens_array'}}+1)/2);
		print "<table width=100%> <tr><td width=50% valign=top>\n";
		&gens_table(@{$self->{'gens_array'}}[0..$self->{'mid'}-1]);
		print "</td><td width=50% valign=top>\n";
		if ($self->{'mid'} < @{$self->{'gens_array'}}) { &gens_table(@{$self->{'gens_array'}}[$self->{'mid'}..$#{$self->{'gens_array'}}]); }
		print "</td></tr> </table><br>\n";
		}
	else {
		&gens_table(@{$self->{'gens_array'}});
		}
	print $self->ui_links_row(\@{$self->{'links_array'}});
	print $self->ui_form_end([ [ "delete", $self->{'text_hash'}->{'generics_delete'} ] ]);
	}
if ($self->{'access_hash'}->{'omode'} == 1 && $self->{'access_hash'}->{'manual'}) {
	print "<a href='edit_file.cgi?mode=generics'>",
		$self->text('file_edit', "<tt>$self->{'gfile'}</tt>"),"</a><p>\n";
	}

print $self->{'text_hash'}->{'generics_desc1'},"<p>\n";
print $self->text('generics_desc2', "list_cgs.cgi"),"<br>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

# Notes - The G class lists domains for which outgoing-address translation
# is done. If a mapping for an address like 'foo' exists, it applied for
# from addresses like 'foo' or 'foo@anything'. However, a mapping for
# 'foo@foo.com' applies only for that exact address
# By default, the G class contains only the full local hostname 
# (like florissa.home). Sendmail automatically adds the full hostname
# to unqualified addresses sent locally or through smtp (so <foo> becomes
# <foo@florissa.home>
# The G class can be defined by CG statements in sendmail.cf, or by a
# FG/path line to use an external file..

# If there is a generics mapping from an unqualified name, then it will
# apply for all domains in the G class.

1;
		
}

sub gens_table
{
	shift if ($self == $_[0]);

local @tds = ( "width=5" );
print $self->ui_columns_start([ "",
			  $self->{'text_hash'}->{'generics_from'},
			  $self->{'text_hash'}->{'generics_to'},
			  $self->{'config_hash'}->{'show_cmts'} ? ( $self->{'text_hash'}->{'virtusers_cmt'} )
                                               : ( ) ], 100, 0, \@tds);
foreach $g (@_) {
	local @cols;
	push(@cols, "<a href=\"edit_generic.cgi?num=$g->{'num'}\">".
		    "<tt>".$self->html_escape($g->{'from'})."</tt></a>");
	push(@cols, $self->html_escape($g->{'to'}));
	push(@cols, $self->html_escape($g->{'cmt'})) if ($self->{'config_hash'}->{'show_cmts'});
	print $self->ui_checked_columns_row(\@cols, \@tds, "d", $g->{'from'});
	}
print $self->ui_columns_end();
}


1;

