#!/usr/bin/perl

&MAIN();

 sub MAIN {
# list_mailers.cgi
# Display a list of mailertable domains

&ModuleLoader::preload_module('sendmail_class', "sendmail::SendmailLib");
$self = new sendmail::SendmailLib:: 'sendmail_class',%$self;

&ModuleLoader::preload_module('sendmail_class', "sendmail::MailersLib");
$self = new sendmail::MailersLib:: 'sendmail_class',%$self;


$self->{'access_hash'}->{'mailers'} || $self->error($self->{'text_hash'}->{'mailers_cannot'});
$self->ui_print_header(undef, $self->{'text_hash'}->{'mailers_title'}, "");

$self->{'conf'} = $self->get_sendmailcf();
$self->{'mfile'} = $self->mailers_file($self->{'conf'});
($self->{'mdbm'}, $self->{'mdbmtype'}) = $self->mailers_dbm($self->{'conf'});
if (!$self->{'mdbm'}) {
	# No Kmailertable directive in sendmail.cf
	print "<b>",$self->text('mailers_efeature', 'list_features.cgi'),"</b><p>\n";
	$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
	exit;
	}
if (!-r $self->{'mfile'}) {
	# Text file not found
	print "<b>",$self->text('mailers_efile', "<tt>$self->{'mfile'}</tt>",
	      "<tt>$self->{'mdbm'}</tt>", "$self->{'gconfig_hash'}->{'webprefix'}/config.cgi?$self->{'module_name'}"),"</b> <p>\n";
	print "<b>",$self->text('virtusers_createfile',
		    	  'create_file.cgi?mode=mailers'),"</b><p>\n";
	$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
	exit;
	}
@{$self->{'mailers_array'}} = $self->list_mailers($self->{'mfile'});

$self->mailer_form();
if (@{$self->{'mailers_array'}}) {
	# sort if needed
	if ($self->{'config_hash'}->{'sort_mode'} == 1) {
		@{$self->{'mailers_array'}} = sort { $a->{'domain'} cmp $b->{'domain'} } @{$self->{'mailers_array'}};
		}

	# render table of mailers
	print $self->ui_form_start("delete_mailers.cgi", "post");
	@{$self->{'links_array'}} = ( $self->select_all_link("d", 1),
		   $self->select_invert_link("d", 1) );
	print $self->ui_links_row(\@{$self->{'links_array'}});
	if ($self->{'config_hash'}->{'columns'} == 2) {
		$self->{'mid'} = int((@{$self->{'mailers_array'}}+1)/2);
		print "<table width=100%> <tr><td width=50% valign=top>\n";
		&mailers_table(@{$self->{'mailers_array'}}[0..$self->{'mid'}-1]);
		print "</td><td width=50% valign=top>\n";
		if ($self->{'mid'} < @{$self->{'mailers_array'}}) { &mailers_table(@{$self->{'mailers_array'}}[$self->{'mid'}..$#{$self->{'mailers_array'}}]); }
		print "</td></tr> </table><br>\n";
		}
	else {
		&mailers_table(@{$self->{'mailers_array'}});
		}
	print $self->ui_links_row(\@{$self->{'links_array'}});
	print $self->ui_form_end([ [ "delete", $self->{'text_hash'}->{'mailers_delete'} ] ]);
	}
print "<a href='edit_file.cgi?mode=mailers'>",
	$self->text('file_edit', "<tt>$self->{'mfile'}</tt>"),"</a><p>\n"
	if ($self->{'access_hash'}->{'manual'});
print $self->{'text_hash'}->{'mailers_desc1'},"<p>\n";
print $self->text('mailers_desc2', 'list_cws.cgi')," ",
      $self->text('mailers_desc3', 'list_relay.cgi'),"<br>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}

sub mailers_table
{
	shift if ($self == $_[0]);

local @tds = ( "width=5" );
print $self->ui_columns_start([ "",
			  $self->{'text_hash'}->{'mailers_for'},
			  $self->{'text_hash'}->{'mailers_delivery'},
			  $self->{'text_hash'}->{'mailers_to'},
			  $self->{'config_hash'}->{'show_cmts'} ? ( $self->{'text_hash'}->{'virtusers_cmt'} )
                                               : ( ) ], 100, 0, \@tds);
foreach $m (@_) {
	local @cols;
	push(@cols, "<a href=\"edit_mailer.cgi?num=$m->{'num'}\">".
		    $self->html_escape($m->{'domain'})."</a>");
	$self->{'md'} = $self->{'mailer_desc_hash'}->{$m->{'mailer'}};
	push(@cols, $self->{'md'} ? $self->{'md'} : $m->{'mailer'});
	push(@cols, $self->html_escape($m->{'dest'}));
	push(@cols, $self->html_escape($m->{'cmt'})) if ($self->{'config_hash'}->{'show_cmts'});
	print $self->ui_checked_columns_row(\@cols, \@tds, "d", $m->{'domain'});
	}
print $self->ui_columns_end();
}


1;

