#!/usr/bin/perl

&MAIN();

 sub MAIN {
# list_mailq.cgi
# Display the current mail queue

&ModuleLoader::preload_module('sendmail_class', "sendmail::SendmailLib");
$self = new sendmail::SendmailLib:: 'sendmail_class',%$self;

&ModuleLoader::preload_module('sendmail_class', "sendmail::BoxesLib");
$self = new sendmail::BoxesLib:: 'sendmail_class',%$self;

$self->ReadParse();
$self->{'access_hash'}->{'mailq'} || $self->error($self->{'text_hash'}->{'mailq_ecannot'});
print "Refresh: $self->{'config_hash'}->{'mailq_refresh'}\r\n"
	if ($self->{'config_hash'}->{'mailq_refresh'});
$self->ui_print_header(undef, $self->{'text_hash'}->{'mailq_title'}, "");

$self->{'conf'} = $self->get_sendmailcf();
@{$self->{'qfiles_array'}} = $self->list_mail_queue($self->{'conf'});

if ($self->{'access_hash'}->{'qdoms'}) {
	# Filter out blocked mails
	@{$self->{'qfiles_array'}} = grep { $self->can_view_qfile($self->{'qmails_hash'}->{$_} = $self->mail_from_queue($_)) }
		       @{$self->{'qfiles_array'}};
	}

if ($self->{'config_hash'}->{'mailq_sort'} == 0) {
	# Just sort by ID
	@{$self->{'qfiles_array'}} = sort { $a =~ /\/([^\/]+)$/; local $af = $1;
			 $b =~ /\/([^\/]+)$/; local $bf = $1;
			 $af cmp $bf } @{$self->{'qfiles_array'}};
	}
else {
	# We need the actual mails for sorting
	local $q;
	foreach $q (@{$self->{'qfiles_array'}}) {
		$self->{'qmails_hash'}->{$q} ||= $self->mail_from_queue($q);
		}
	if ($self->{'config_hash'}->{'mailq_sort'} == 1) {
		@{$self->{'qfiles_array'}} = sort { lc(&address_parts($self->{'qmails_hash'}->{$a}->{'header'}->{'from'})) cmp
				 lc(&address_parts($self->{'qmails_hash'}->{$b}->{'header'}->{'from'})) } @{$self->{'qfiles_array'}};
		}
	elsif ($self->{'config_hash'}->{'mailq_sort'} == 2) {
		@{$self->{'qfiles_array'}} = sort { lc(&address_parts($self->{'qmails_hash'}->{$a}->{'header'}->{'to'})) cmp
				 lc(&address_parts($self->{'qmails_hash'}->{$b}->{'header'}->{'to'})) } @{$self->{'qfiles_array'}};
		}
	elsif ($self->{'config_hash'}->{'mailq_sort'} == 3) {
		@{$self->{'qfiles_array'}} = sort { lc($self->{'qmails_hash'}->{$a}->{'header'}->{'subject'}) cmp
				 lc($self->{'qmails_hash'}->{$b}->{'header'}->{'subject'}) } @{$self->{'qfiles_array'}};
		}
	elsif ($self->{'config_hash'}->{'mailq_sort'} == 4) {
		@{$self->{'qfiles_array'}} = sort { lc($self->{'qmails_hash'}->{$a}->{'status'}) cmp
				 lc($self->{'qmails_hash'}->{$b}->{'status'}) } @{$self->{'qfiles_array'}};
		}
	elsif ($self->{'config_hash'}->{'mailq_sort'} == 5) {
		@{$self->{'qfiles_array'}} = sort { $self->{'qmails_hash'}->{$b}->{'size'} <=>
				 $self->{'qmails_hash'}->{$a}->{'size'} } @{$self->{'qfiles_array'}};
		}
	}

if (@{$self->{'qfiles_array'}}) {
	if (@{$self->{'qfiles_array'}} > $self->{'config_hash'}->{'perpage'}) {
		# Need to show arrows
		print "<center>\n";
		$self->{'s'} = int($self->{'in_hash'}->{'start'});
		$self->{'e'} = $self->{'in_hash'}->{'start'} + $self->{'config_hash'}->{'perpage'} - 1;
		$self->{'e'} = @{$self->{'qfiles_array'}}-1 if ($self->{'e'} >= @{$self->{'qfiles_array'}});
		if ($self->{'s'}) {
			printf "<a href='list_mailq.cgi?start=%d'>%s</a>\n",
			    $self->{'s'} - $self->{'config_hash'}->{'perpage'},
			    "<img src=/images/left.gif border=0 align=middle>";
			}
		print "<font size=+1>",$self->text('mail_pos', $self->{'s'}+1, $self->{'e'}+1,
					     scalar(@{$self->{'qfiles_array'}})),"</font>\n";
		if ($self->{'e'} < @{$self->{'qfiles_array'}}-1) {
			printf "<a href='list_mailq.cgi?start=%d'>%s</a>\n",
			    $self->{'s'} + $self->{'config_hash'}->{'perpage'},
			    "<img src=/images/right.gif border=0 align=middle>";
			}
		print "</center>\n";
		}
	else {
		# Can show them all
		$self->{'s'} = 0;
		$self->{'e'} = @{$self->{'qfiles_array'}} - 1;
		}

	# Show the queued mails
	$self->mailq_table([ @{$self->{'qfiles_array'}}[$self->{'s'} .. $self->{'e'}] ], \%{$self->{'qmails_hash'}});

	# Show queue search form
	print "<form action=mailq_search.cgi>\n";
	print "<b>$self->{'text_hash'}->{'mailq_search'}</b>\n";
	print "<select name=field>\n";
	foreach $f ('from', 'subject', 'to', 'cc', 'date', 'status', 'body', 'headers', 'size', '',
	    '!from', '!subject', '!to', '!cc', '!date', '!status', '!body', '!headers', '!size') {
		printf "<option value='%s'>%s\n", $f, $self->{'text_hash'}->{"match_$f"};
		}
	print "</select>\n";
	print "<input name=match size=20>\n";
	print "&nbsp;<input type=submit value='$self->{'text_hash'}->{'mail_ok'}'>\n";
	print "</form>\n";

	# Show flush button(s)
	if ($self->{'access_hash'}->{'flushq'}) {
		print "<hr>\n";
		print $self->ui_buttons_start();
		print $self->ui_buttons_row("flushq.cgi", $self->{'text_hash'}->{'mailq_flush'}, $self->{'text_hash'}->{'mailq_flushdesc'});
		if ($self->{'quarcount'}) {
			print $self->ui_buttons_row("flushq.cgi", $self->{'text_hash'}->{'mailq_flushquar'},
					      $self->{'text_hash'}->{'mailq_flushquardesc'},
					      $self->ui_hidden("quar", 1));
			}
		print $self->ui_buttons_end();
		}
	}
else {
	print "<b>$self->{'text_hash'}->{'mailq_none'}</b> <p>\n";
	}

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

