#!/usr/bin/perl

&MAIN();

 sub MAIN {
# list_opts.cgi
# A form for editing options set with the 'O foo=bar' directive,
# and other things.

&ModuleLoader::preload_module('sendmail_class', "sendmail::SendmailLib");
$self = new sendmail::SendmailLib:: 'sendmail_class',%$self;

$self->{'access_hash'}->{'opts'} || $self->error($self->{'text_hash'}->{'opts_ecannot'});
$self->ui_print_header(undef, $self->{'text_hash'}->{'opts_title'}, "");

$self->{'conf'} = $self->get_sendmailcf();
$self->{'ver'} = $self->check_sendmail_version($self->{'conf'});
$self->{'default'} = $self->{'text_hash'}->{'opts_default'};
print "<form action=save_opts.cgi>\n";
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'opts_title'}</b></td></tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

($self->{'dsstr'}, $self->{'ds'}) = $self->find_type2("D", "S", $self->{'conf'});
print "<tr> <td>",$self->hlink("<b>$self->{'text_hash'}->{'opts_ds'}</b>","opt_DS"),
      "</td> <td colspan=3>\n";
printf "<input type=radio name=DS_def value=1 %s> $self->{'text_hash'}->{'opts_direct'}\n",
	$self->{'ds'} ? "" : "checked";
printf "<input type=radio name=DS_def value=0 %s>\n",
	$self->{'ds'} ? "checked" : "";
print "<input name=DS size=25 value=\"$self->{'ds'}\"></td> </tr>\n";

($self->{'drstr'}, $self->{'dr'}) = $self->find_type2("D", "R", $self->{'conf'});
print "<tr> <td>",$self->hlink("<b>$self->{'text_hash'}->{'opts_dr'}</b>",
			 "opt_DR"),"</td>\n";
print "<td colspan=3>\n";
printf "<input type=radio name=DR_def value=1 %s> $self->{'text_hash'}->{'opts_local'}\n",
	$self->{'dr'} ? "" : "checked";
printf "<input type=radio name=DR_def value=0 %s>\n",
	$self->{'dr'} ? "checked" : "";
print "<input name=DR size=25 value=\"$self->{'dr'}\"></td> </tr>\n";

($self->{'dhstr'}, $self->{'dh'}) = $self->find_type2("D", "H", $self->{'conf'});
print "<tr> <td>",$self->hlink("<b>$self->{'text_hash'}->{'opts_dh'}</b>",
			 "opt_DH"),"</td>\n";
print "<td colspan=3>\n";
printf "<input type=radio name=DH_def value=1 %s> $self->{'text_hash'}->{'opts_local'}\n",
	$self->{'dh'} ? "" : "checked";
printf "<input type=radio name=DH_def value=0 %s>\n",
	$self->{'dh'} ? "checked" : "";
print "<input name=DH size=25 value=\"$self->{'dh'}\"></td> </tr>\n";

($self->{'dmstr'}, $self->{'dm'}) = $self->find_option("DeliveryMode", $self->{'conf'});
print "<tr> <td>",$self->hlink("<b>$self->{'text_hash'}->{'opts_dmode'}</b>","opt_dmode"),
      "</td> <td colspan=3>\n";
printf "<input type=radio name=DeliveryMode value='' %s> $self->{'text_hash'}->{'default'}\n",
	$self->{'dm'} ? '' : 'checked';
foreach $dmo ('background', 'queue-only', 'interactive', 'deferred') {
	local $dmoc = substr($dmo, 0, 1);
	printf "<input type=radio name=DeliveryMode value=%s %s> %s\n",
		$dmo, $self->{'dm'} =~ /^$dmoc/ ? 'checked' : '', $self->{'text_hash'}->{"opts_$dmo"};
	}
print "</td> </tr>\n";

($self->{'qsostr'}, $self->{'qso'}) = $self->find_option("QueueSortOrder", $self->{'conf'});
print "<tr> <td>",$self->hlink("<b>$self->{'text_hash'}->{'opts_qso'}</b>","opt_qso"),
      "</td> <td colspan=3>\n";
printf "<input type=radio name=QueueSortOrder value='' %s> $self->{'text_hash'}->{'default'}\n",
	$self->{'qso'} ? '' : 'checked';
foreach $dmo ('priority', 'host', 'time') {
	local $dmoc = substr($dmo, 0, 1);
	printf "<input type=radio name=QueueSortOrder value=%s %s> %s\n",
		$dmo, $self->{'qso'} =~ /^$dmoc/ ? 'checked' : '', $self->{'text_hash'}->{"opts_$dmo"};
	}
print "</td> </tr>\n";

if ($self->{'ver'} >= 9) {
	print "<tr>\n";
	&options_input($self->{'text_hash'}->{'opts_daemon'}, "DaemonPortOptions", $self->{'conf'},
		      $self->{'default'}, 50);
	print "</tr>\n";
	}

print "<tr>\n";
&option_input($self->{'text_hash'}->{'opts_queuela'}, "QueueLA", $self->{'conf'}, $self->{'default'}, 6);
&option_input($self->{'text_hash'}->{'opts_refusela'}, "RefuseLA", $self->{'conf'}, $self->{'default'},6);
print "</tr>\n";

print "<tr>\n";
&option_input($self->{'text_hash'}->{'opts_maxch'}, "MaxDaemonChildren",
	      $self->{'conf'}, $self->{'default'}, 6);
&option_input($self->{'text_hash'}->{'opts_throttle'}, "ConnectionRateThrottle",
	      $self->{'conf'}, $self->{'default'}, 6);
print "</tr>\n";

print "<tr>\n";
&option_input($self->{'text_hash'}->{'opts_minqueueage'}, "MinQueueAge",
	      $self->{'conf'}, $self->{'default'}, 6);
&option_input($self->{'text_hash'}->{'opts_runsize'}, "MaxQueueRunSize", $self->{'conf'}, $self->{'default'}, 8);
print "</tr>\n";

print "<tr>\n";
&option_input($self->{'text_hash'}->{'opts_queuereturn'}, "Timeout.queuereturn",
	      $self->{'conf'}, $self->{'default'}, 6);
&option_input($self->{'text_hash'}->{'opts_queuewarn'}, "Timeout.queuewarn",
	      $self->{'conf'}, $self->{'default'}, 6);
print "</tr>\n";

print "<tr>\n";
&option_input($self->{'text_hash'}->{'opts_queue'}, "QueueDirectory", $self->{'conf'}, $self->{'default'}, 35);
print "</tr>\n";

print "<tr>\n";
&option_input($self->{'text_hash'}->{'opts_postmaster'}, "PostMasterCopy",
	      $self->{'conf'}, "Postmaster", 35);
print "</tr>\n";

print "<tr>\n";
&option_input($self->{'text_hash'}->{'opts_forward'}, "ForwardPath", $self->{'conf'}, $self->{'default'}, 35);
print "</tr>\n";

print "<tr>\n";
&option_input($self->{'text_hash'}->{'opts_minfree'}, "MinFreeBlocks",
	      $self->{'conf'}, $self->{'default'}, 8, $self->{'text_hash'}->{'opts_blocks'});
&option_input($self->{'text_hash'}->{'opts_maxmessage'}, "MaxMessageSize",
	      $self->{'conf'}, $self->{'default'}, 10, $self->{'text_hash'}->{'opts_bytes'});
print "</tr>\n";

print "<tr>\n";
&option_input($self->{'text_hash'}->{'opts_loglevel'}, "LogLevel", $self->{'conf'}, $self->{'default'}, 4);
($self->{'vstr'}, $self->{'v'}) = $self->find_option("SendMimeErrors", $self->{'conf'});
print "<td>",$self->hlink("<b>$self->{'text_hash'}->{'opts_mimebounce'}</b>","opt_SendMimeErrors"),
      "</td> <td>\n";
printf "<input type=radio name=SendMimeErrors value=True %s> $self->{'text_hash'}->{'yes'}\n",
	$self->{'v'} eq "True" ? "checked" : "";
printf "<input type=radio name=SendMimeErrors value=False %s> $self->{'text_hash'}->{'no'}\n",
	$self->{'v'} eq "True" ? "" : "checked";
print "</td> </tr>\n";

print "<tr>\n";
($self->{'gstr'}, $self->{'g'}) = $self->find_option("MatchGECOS", $self->{'conf'});
print "<td>",$self->hlink("<b>$self->{'text_hash'}->{'opts_gecos'}</b>","opt_MatchGECOS"),
      "</td> <td>\n";
printf "<input type=radio name=MatchGECOS value=True %s> $self->{'text_hash'}->{'yes'}\n",
	$self->{'g'} eq "True" ? "checked" : "";
printf "<input type=radio name=MatchGECOS value=False %s> $self->{'text_hash'}->{'no'}</td>\n",
	$self->{'g'} eq "True" ? "" : "checked";
&option_input($self->{'text_hash'}->{'opts_hops'}, "MaxHopCount", $self->{'conf'}, $self->{'default'}, 4);
print "</tr>\n";

if ($self->{'ver'} >= 10) {
	print "<tr>\n";
	&option_input($self->{'text_hash'}->{'opts_maxrcpt'}, "MaxRecipientsPerMessage", $self->{'conf'}, $self->{'default'}, 4);
	&option_input($self->{'text_hash'}->{'opts_maxbad'}, "BadRcptThrottle", $self->{'conf'}, $self->{'default'}, 4);
	print "</tr>\n";
	}

print "<tr>\n";
($self->{'bstr'}, $self->{'b'}) = $self->find_option("DontBlameSendmail", $self->{'conf'});
print "<td valign=top>",$self->hlink("<b>$self->{'text_hash'}->{'opts_blame'}</b>",
      "opt_DontBlameSendmail"),"</td> <td colspan=3>\n";
printf "<input type=radio name=DontBlameSendmail_def value=1 %s> %s\n",
	$self->{'b'} ? '' : 'checked', $self->{'text_hash'}->{'default'};
printf "<input type=radio name=DontBlameSendmail_def value=0 %s> %s<br>\n",
	$self->{'b'} ? 'checked' : '', $self->{'text_hash'}->{'opts_selected'};
print $self->ui_select("DontBlameSendmail",
	 [ split(/[\s,]+/, $self->{'b'}) ],
	 [ map { [ $_->[0],
		   "$_->[0] (".(length($_->[1]) > 40 ? substr($_->[1], 0, 40)."..." : $_->[1]).")" ] } $self->list_dontblames() ],
	 5, 1, 1);
print "</td> </tr>\n";

print "</table></td></tr></table><p>\n";
print "<input type=submit value=\"$self->{'text_hash'}->{'opts_save'}\"></form>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}

# option_input(desc, name, &config, default, size, units)
sub option_input
{
	shift if ($self == $_[0]);

local ($vstr, $v) = $self->find_option($_[1], $_[2]);
printf "<td>".$self->hlink("<b>$_[0]</b>","opt_".$_[1])."</td> <td %s nowrap>\n",
	$_[4] > 20 ? "colspan=3" : "";
print $self->ui_opt_textbox($_[1], $v, $_[4], $_[3])." $_[5]</td>\n";
}

# options_input(desc, name, &config, default, size, units)
sub options_input
{
	shift if ($self == $_[0]);

local @vals = $self->find_options($_[1], $_[2]);
printf "<td valign=top>".$self->hlink("<b>$_[0]</b>","opt_".$_[1]).
       "</td> <td %s nowrap>\n",
	$_[4] > 20 ? "colspan=3" : "";
print $self->ui_radio("$_[1]_def", @vals ? 0 : 1,
		[ [ 1, $_[3] ], [ 0, $self->{'text_hash'}->{'opts_below'} ] ]),"<br>\n";
print $self->ui_textarea($_[1], join("\n", map { $_->[1] } @vals), 3, $_[4])."</td>\n";
}


1;

