#!/usr/bin/perl

&MAIN();

 sub MAIN {
# list_virtusers.cgi
# Display a list of all domain and address mappings

&ModuleLoader::preload_module('sendmail_class', "sendmail::SendmailLib");
$self = new sendmail::SendmailLib:: 'sendmail_class',%$self;

&ModuleLoader::preload_module('sendmail_class', "sendmail::VirtusersLib");
$self = new sendmail::VirtusersLib:: 'sendmail_class',%$self;

$self->ReadParse();
$self->{'access_hash'}->{'vmode'} || $self->error($self->{'text_hash'}->{'virtusers_ecannot'});
$self->ui_print_header(undef, $self->{'text_hash'}->{'virtusers_title'}, "");

$self->{'conf'} = $self->get_sendmailcf();
$self->{'vfile'} = $self->virtusers_file($self->{'conf'});
($self->{'vdbm'}, $self->{'vdbmtype'}) = $self->virtusers_dbm($self->{'conf'});
if (!$self->{'vdbm'}) {
	# No Kvirtuser directive in sendmail.cf
	print "<b>",$self->text('virtusers_efeature', 'list_features.cgi'),"</b><p>\n";
	$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
	exit;
	}
if (!-r $self->{'vfile'}) {
	# Text file not found
	print "<b>",$self->text('virtusers_efile', "<tt>$self->{'vfile'}</tt>",
	      "<tt>$self->{'vdbm'}</tt>", "$self->{'gconfig_hash'}->{'webprefix'}/config.cgi?$self->{'module_name'}"),"</b><p>\n";
	print "<b>",$self->text('virtusers_createfile',
		    	  'create_file.cgi?mode=virtusers'),"</b><p>\n";
	$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
	exit;
	}
@{$self->{'virts_array'}} = $self->list_virtusers($self->{'vfile'});
if ($self->{'access_hash'}->{'vmode'} == 2) {
	@{$self->{'virts_array'}} = grep { $_->{'from'} =~ /$self->{'access_hash'}->{'vaddrs'}/ } @{$self->{'virts_array'}};
	}
elsif ($self->{'access_hash'}->{'vmode'} == 3) {
	@{$self->{'virts_array'}} = grep { $_->{'from'} =~ /^$self->{'remote_user'}\@/ } @{$self->{'virts_array'}};
	}
@{$self->{'virts_array'}} = grep { $self->{'access_hash'}->{"vedit_".$self->virt_type($_->{'to'})} } @{$self->{'virts_array'}}; 

$self->virtuser_form();

if ($self->{'in_hash'}->{'search'}) {
	# Restrict to search results
	@{$self->{'virts_array'}} = grep { $_->{'from'} =~ /$self->{'in_hash'}->{'search'}/i ||
			$_->{'to'} =~ /$self->{'in_hash'}->{'search'}/i } @{$self->{'virts_array'}};
	}
elsif ($self->{'config_hash'}->{'max_records'} && @{$self->{'virts_array'}} > $self->{'config_hash'}->{'max_records'}) {
	# Show search form
	print $self->{'text_hash'}->{'virtusers_toomany'},"<br>\n";
	print "<form action=list_virtusers.cgi>\n";
	print "<input type=submit value='$self->{'text_hash'}->{'virtusers_go'}'>\n";
	print "<input name=search size=20></form>\n";
	undef(@{$self->{'virts_array'}});
	}

if (@{$self->{'virts_array'}}) {
	# sort if needed
	if ($self->{'config_hash'}->{'sort_mode'} == 1) {
		@{$self->{'virts_array'}} = sort sort_by_domain @{$self->{'virts_array'}};
		}

	# render table of virtusers
	print $self->ui_form_start("delete_virtusers.cgi", "post");
	@{$self->{'links_array'}} = ( $self->select_all_link("d", 1),
		   $self->select_invert_link("d", 1) );
	print $self->ui_links_row(\@{$self->{'links_array'}});
	if ($self->{'config_hash'}->{'columns'} == 2) {
		$self->{'mid'} = int((@{$self->{'virts_array'}}+1)/2);
		print "<table width=100%> <tr><td width=50% valign=top>\n";
		&virts_table(@{$self->{'virts_array'}}[0..$self->{'mid'}-1]);
		print "</td><td width=50% valign=top>\n";
		if ($self->{'mid'} < @{$self->{'virts_array'}}) { &virts_table(@{$self->{'virts_array'}}[$self->{'mid'}..$#{$self->{'virts_array'}}]); }
		print "</td></tr> </table><br>\n";
		}
	else {
		&virts_table(@{$self->{'virts_array'}});
		}
	print $self->ui_links_row(\@{$self->{'links_array'}});
	print $self->ui_form_end([ [ "delete", $self->{'text_hash'}->{'virtusers_delete'} ] ]);
	}
if ($self->{'access_hash'}->{'vmode'} == 1 && $self->{'access_hash'}->{'vedit_0'} && $self->{'access_hash'}->{'vedit_1'} &&
    $self->{'access_hash'}->{'vedit_2'} && $self->{'access_hash'}->{'vmax'} == 0 && $self->{'access_hash'}->{'manual'}) {
	print "<a href='edit_file.cgi?mode=virtusers'>",
		$self->text('file_edit', "<tt>$self->{'vfile'}</tt>"),"</a><p>\n";
	}

print $self->text('virtusers_desc1', 'list_aliases.cgi'),"<p>\n"
	if ($self->{'access_hash'}->{'amode'});
print $self->text('virtusers_desc2', 'list_cws.cgi'),"<br>\n"
	if ($self->{'access_hash'}->{'cws'});

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}

sub virts_table
{
	shift if ($self == $_[0]);

local @tds = ( "width=5" );
print $self->ui_columns_start([ "",
			  $self->{'text_hash'}->{'virtusers_for'},
			  $self->{'text_hash'}->{'virtusers_to'},
			  $self->{'config_hash'}->{'show_cmts'} ? ( $self->{'text_hash'}->{'virtusers_cmt'} )
					       : ( ) ], 100, 0, \@tds);
foreach $m (@_) {
	local @cols;
	push(@cols, "<a href=\"edit_virtuser.cgi?num=$m->{'num'}\">".
		    "<tt>".$self->html_escape($m->{'from'})."</tt></a>");
	if ($m->{'to'} =~ /^error:(.*)$/) {
		push(@cols, $self->text('virtusers_error',
			    "<tt>".$self->html_escape("$1")."</tt>"));
		}
	elsif ($m->{'to'} =~ /^\%1\@(\S+)$/) {
		push(@cols, $self->text('virtusers_domain',
			    "<tt>".$self->html_escape("$1")."</tt>"));
		}
	else {
		push(@cols, $self->text('virtusers_address',
			    "<tt>".$self->html_escape($m->{'to'})."</tt>"));
		}
	push(@cols, $self->html_escape($m->{'cmt'})) if ($self->{'config_hash'}->{'show_cmts'});
	print $self->ui_checked_columns_row(\@cols, \@tds, "d", $m->{'from'});
	}
print $self->ui_columns_end();
}


1;

