#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_alias.cgi
# Save or delete a new or existing alias

&ModuleLoader::preload_module('sendmail_class', "sendmail::SendmailLib");
$self = new sendmail::SendmailLib:: 'sendmail_class',%$self;

&ModuleLoader::preload_module('sendmail_class', "sendmail::AliasesLib");
$self = new sendmail::AliasesLib:: 'sendmail_class',%$self;

$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'asave_err'});
$self->{'access_hash'}->{'amode'} > 0 || $self->error($self->{'text_hash'}->{'asave_ecannot2'});
$self->{'conf'} = $self->get_sendmailcf();
$self->{'afile'} = $self->aliases_file($self->{'conf'});
$self->lock_alias_files($self->{'afile'});
@{$self->{'aliases_array'}} = $self->list_aliases($self->{'afile'});
foreach $ex (@{$self->{'aliases_array'}}) { $self->{'exists_hash'}->{lc($ex->{'name'})}++; }
if (!$self->{'in_hash'}->{'new'}) {
	$self->{'a'} = $self->{'aliases_array'}->[$self->{'in_hash'}->{'num'}];
	$self->can_edit_alias($self->{'a'}) || $self->error($self->{'text_hash'}->{'asave_ecannot'});
	}
elsif ($self->{'access_hash'}->{'amax'}) {
	local @cliases = grep { local $rv = 1;
		  foreach $v (@{$_->{'values'}}) {
			$rv = 0 if (!$self->{'access_hash'}->{"aedit_".$self->alias_type($v)});
			}
		  $rv;
		} @{$self->{'aliases_array'}};
	if ($self->{'access_hash'}->{'amode'} == 2) {
		@cliases = grep { $_->{'name'} =~ /$self->{'access_hash'}->{'aliases'}/ }
				@{$self->{'aliases_array'}};
		}
	elsif ($self->{'access_hash'}->{'amode'} == 3) {
		@cliases = grep { $_->{'name'} eq $self->{'remote_user'} } @{$self->{'aliases_array'}};
		}
	$self->error($self->text('asave_emax', $self->{'access_hash'}->{'amax'}))
		if (@{$self->{'caliases_array'}} >= $self->{'access_hash'}->{'amax'});
	}

if ($self->{'in_hash'}->{'delete'}) {
	# delete some alias
	$self->{'loga'} = $self->{'a'};
	$self->delete_alias($self->{'a'});
	}
else {
	# saving or creating .. check inputs
	$self->{'in_hash'}->{'name'} =~ /^[^:@ ]+$/ ||
		$self->error($self->text('asave_eaddr', $self->{'in_hash'}->{'name'}));
	if ($self->{'in_hash'}->{'new'} || uc($self->{'a'}->{'name'}) ne uc($self->{'in_hash'}->{'name'})) {
		# is this name taken?
		for($i=0; $i<@{$self->{'aliases_array'}}; $i++) {
			if (uc($self->{'in_hash'}->{'name'}) eq uc($self->{'aliases_array'}->[$i]->{'name'})) {
				$self->error($self->text('asave_ealready', $self->{'in_hash'}->{'name'}));
				}
			}
		}
	if ($self->{'access_hash'}->{'amode'} == 2) {
		$self->{'in_hash'}->{'name'} =~ /$self->{'access_hash'}->{'aliases'}/ ||
			$self->error($self->text('asave_ematch', $self->{'access_hash'}->{'aliases'}));
		}
	elsif ($self->{'access_hash'}->{'amode'} == 3) {
		$self->{'in_hash'}->{'name'} eq $self->{'remote_user'} || $self->error($self->{'text_hash'}->{'asave_esame'});
		}
	for($i=0; defined($self->{'t'} = $self->{'in_hash'}->{"type_$i"}); $i++) {
		!$self->{'t'} || $self->{'access_hash'}->{"aedit_$self->{'t'}"} ||
			$self->error($self->{'text_hash'}->{'asave_etype'});
		$v = $self->{'in_hash'}->{"val_$i"};
		$v =~ s/^\s+//;
		$v =~ s/\s+$//;
		if ($self->{'t'} == 1 && $v !~ /^(\S+)$/) {
			$self->error($self->text('asave_etype1', $v));
			}
		elsif ($self->{'t'} == 2 && !&check_aliasfile($v, 1)) {
			$self->error($self->text('asave_etype2', $v));
			}
		elsif ($self->{'t'} == 3 && $v !~ /^\/(\S+)$/) {
			$self->error($self->text('asave_etype3', $v));
			}
		elsif ($self->{'t'} == 4) {
			$v =~ /^'([^']+)'/ || $v =~ /^"([^"]+)"/ ||
			   $v =~ /^(\S+)/ || $self->error($self->{'text_hash'}->{'asave_etype4none'});
			(-x $1) && &check_aliasfile("$1", 0) ||
				$self->error($self->text('asave_etype4', "$1"));
			}
		elsif ($self->{'t'} == 5 && !&check_aliasfile($v, 1)) {
			$self->error($self->text('asave_etype5', $v));
			}
		elsif ($self->{'t'} == 6 && !&check_aliasfile($v, 1)) {
			$self->error($self->text('asave_etype6', $v));
			}
		if ($self->{'t'} == 1 || $self->{'t'} == 3) { push(@{$self->{'values_array'}}, $v); }
		elsif ($self->{'t'} == 2) { push(@{$self->{'values_array'}}, ":include:$v"); }
		elsif ($self->{'t'} == 4) { push(@{$self->{'values_array'}}, "|$v"); }
		elsif ($self->{'t'} == 5) {
			# Setup autoreply script
			push(@{$self->{'values_array'}}, "|$self->{'module_config_directory'}/autoreply.pl ".
				      "$v $self->{'in_hash'}->{'name'}");
			$self->system_logged("cp autoreply.pl $self->{'module_config_directory'}");
			$self->system_logged("chmod 755 $self->{'module_config_directory'}/config $self->{'module_config_directory'}/autoreply.pl");
			if (-d $self->{'config_hash'}->{'smrsh_dir'}) {
				$self->system_logged("ln -s $self->{'module_config_directory'}/autoreply.pl $self->{'config_hash'}->{'smrsh_dir'}/autoreply.pl");
				}
			}
		elsif ($self->{'t'} == 6) {
			# Setup filter script
			push(@{$self->{'values_array'}}, "|$self->{'module_config_directory'}/filter.pl ".
				      "$v $self->{'in_hash'}->{'name'}");
			$self->system_logged("cp filter.pl $self->{'module_config_directory'}");
			$self->system_logged("chmod 755 $self->{'module_config_directory'}/config $self->{'module_config_directory'}/filter.pl");
			if (-d $self->{'config_hash'}->{'smrsh_dir'}) {
				$self->system_logged("ln -s $self->{'module_config_directory'}/filter.pl $self->{'config_hash'}->{'smrsh_dir'}/filter.pl");
				}
			}
		}

	$self->{'newa_hash'}->{'name'} = $self->{'in_hash'}->{'name'};
	$self->{'newa_hash'}->{'values'} = \@{$self->{'values_array'}};
	$self->{'newa_hash'}->{'enabled'} = $self->{'in_hash'}->{'enabled'};
	$self->{'newa_hash'}->{'cmt'} = $self->{'in_hash'}->{'cmt'};
	if ($self->{'in_hash'}->{'new'}) { $self->create_alias(\%{$self->{'newa_hash'}}, $self->{'afile'}); }
	else { $self->modify_alias($self->{'a'}, \%{$self->{'newa_hash'}}); }
	$self->{'loga'} = \%{$self->{'newa_hash'}};
	}
$self->unlock_alias_files($self->{'afile'});
$self->webmin_log($self->{'in_hash'}->{'delete'} ? 'delete' : $self->{'in_hash'}->{'new'} ? 'create' : 'modify',
	    "alias", $self->{'loga'}->{'name'}, $self->{'loga'});
$self->redirect("list_aliases.cgi");

1;
		
}

# check_aliasfile(program, missing-ok)
sub check_aliasfile
{
	shift if ($self == $_[0]);

return 0 if ($_[0] !~ /^\/(\S+)$/);
return 0 if (!-r $_[0] && !$_[1]);
return $self->is_under_directory($self->{'access_hash'}->{'apath'}, $_[0]);
}


1;

