#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_opts.cgi
# Save various sendmail options

&ModuleLoader::preload_module('sendmail_class', "sendmail::SendmailLib");
$self = new sendmail::SendmailLib:: 'sendmail_class',%$self;

$self->ReadParse();
$self->{'access_hash'}->{'opts'} || $self->error($self->{'text_hash'}->{'opts_ecannot'});
$self->error_setup($self->{'text_hash'}->{'opts_err'});
$self->lock_file($self->{'config_hash'}->{'sendmail_cf'});
$self->{'conf'} = $self->get_sendmailcf();
$self->{'ver'} = $self->check_sendmail_version($self->{'conf'});

# Save directives
&save_doption("S", "DS", 1);
&save_doption("R", "DR", 1);
&save_doption("H", "DH", 1);

# Save other options
&save_option("QueueLA", '[\d\.]+', $self->{'text_hash'}->{'opts_queuela'});
&save_option("RefuseLA", '[\d\.]+', $self->{'text_hash'}->{'opts_refusela'});
&save_option("MaxDaemonChildren", '\d+', $self->{'text_hash'}->{'opts_maxch'});
&save_option("ConnectionRateThrottle", '\d+', $self->{'text_hash'}->{'opts_throttle'});
&save_option("MinQueueAge", '\d+\S', $self->{'text_hash'}->{'opts_minqueueage'});
&save_option("MaxQueueRunSize", '\d+', $self->{'text_hash'}->{'opts_runsize'});
&save_option("Timeout.queuereturn", '\d+[dmhwsy]', $self->{'text_hash'}->{'opts_queuereturn'});
&save_option("Timeout.queuewarn", '\d+[dmhwsy]', $self->{'text_hash'}->{'opts_queuewarn'});
&save_option("QueueDirectory", '\/\S+', $self->{'text_hash'}->{'opts_queue'});
&save_option("PostMasterCopy", '\S+', $self->{'text_hash'}->{'opts_postmaster'});
&save_option("ForwardPath", '\S+', $self->{'text_hash'}->{'opts_forward'});
&save_option("MinFreeBlocks", '\d+', $self->{'text_hash'}->{'opts_minfree'});
&save_option("MaxMessageSize", '\d+', $self->{'text_hash'}->{'opts_maxmessage'});
&save_option("LogLevel", '\d+', $self->{'text_hash'}->{'opts_loglevel'});
$self->{'in_hash'}->{'DontBlameSendmail'} =~ s/\0/ /g;
&save_option("DontBlameSendmail", '.*\S.*', $self->{'text_hash'}->{'opts_blame'});
&save_option("SendMimeErrors", '.*');
$self->{'in_hash'}->{'DeliveryMode_def'} = 1 if (!$self->{'in_hash'}->{'DeliveryMode'});
&save_option("DeliveryMode", '.*');
$self->{'in_hash'}->{'QueueSortOrder_def'} = 1 if (!$self->{'in_hash'}->{'QueueSortOrder'});
&save_option("QueueSortOrder", '.*');
&save_option("MaxHopCount", '\d+', $self->{'text_hash'}->{'opts_hops'});
&save_option("MatchGECOS", '.*');
if ($self->{'ver'} >= 10) {
	&save_option("MaxRecipientsPerMessage", '\d+', $self->{'text_hash'}->{'opts_maxrcpt'});
	&save_option("BadRcptThrottle", '\d+', $self->{'text_hash'}->{'opts_maxbad'});
	}
if ($self->{'ver'} >= 9) {
	&save_options("DaemonPortOptions", '.*\S.*', $self->{'text_hash'}->{'opts_daemon'});
	}
$self->flush_file_lines();
$self->unlock_file($self->{'config_hash'}->{'sendmail_cf'});
$self->restart_sendmail();
$self->webmin_log("opts", undef, undef, \%{$self->{'in_hash'}});
$self->redirect("");

1;
		
}

# save_doption(type2, input, blank)
sub save_doption
{
	shift if ($self == $_[0]);

local ($oldstr, $old) = $self->find_type2("D", $_[0], $self->{'conf'});
@{$self->{'oldlist_array'}} = $oldstr ? ( $oldstr ) : ( );
if ($self->{'in_hash'}->{"$_[1]_def"}) {
	@{$self->{'newlist_array'}} = $_[2] && $oldstr ?
			( { 'type' => 'D', 'values' => [ $_[0] ] } ) : ( );
	}
elsif ($self->{'in_hash'}->{$_[1]} !~ /^\S+$/) {
	$self->error($self->text('opts_ehost', $self->{'in_hash'}->{$_[1]}));
	}
else {
	@{$self->{'newlist_array'}} = ( { 'type' => 'D', 'values' => [ $_[0].$self->{'in_hash'}->{$_[1]} ] } );
	}
$self->save_directives($self->{'conf'}, \@{$self->{'oldlist_array'}}, \@{$self->{'newlist_array'}});
}

# save_option(name, regexp, what)
sub save_option
{
	shift if ($self == $_[0]);

local ($oldstr, $old) = $self->find_option($_[0], $self->{'conf'});
local @oldlist = $oldstr ? ( $oldstr ) : ( );
local (@newlist, $re); $re = $_[1];
if ($self->{'in_hash'}->{"$_[0]_def"}) { @newlist = (); }
elsif ($self->{'in_hash'}->{$_[0]} !~ /^$re$/) {
	$self->error($self->text('opts_einvalid', $self->{'in_hash'}->{$_[0]}, $_[2]));
	}
else { @newlist = ( { 'type' => 'O', 'values' => [ " $_[0]=$self->{'in_hash'}->{$_[0]}" ] } ); }
$self->save_directives($self->{'conf'}, \@oldlist, \@newlist);
}

# save_options(name, regexp, what)
sub save_options
{
	shift if ($self == $_[0]);

local @oldlist = map { $_->[0] } $self->find_options($_[0], $self->{'conf'});
local @newlist;
if (!$self->{'in_hash'}->{"$_[0]_def"}) {
	local $re = $_[1];
	foreach my $v (split(/\r?\n/, $self->{'in_hash'}->{$_[0]})) {
		$v =~ /^$re$/ ||
			$self->error($self->text('opts_einvalid', $self->{'in_hash'}->{$_[0]}, $_[2]));
		push(@newlist, { 'type' => 'O', 'values' => [ " $_[0]=$v" ] });
		}
	}
$self->save_directives($self->{'conf'}, \@oldlist, \@newlist);
}


1;

