#!/usr/bin/perl
package sentry::Backup_config;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'sentry::Backup_config');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;

&ModuleLoader::preload_module(ref($self), "sentry::SentryLib");
$self = new sentry::SentryLib:: ref($self), %$self; 

1;

1;
		return $self;
}

# backup_config_files()
# Returns files and directories that can be backed up
sub backup_config_files
{
	my $self = shift;

local @rv;
push(@rv, $self->{'config_hash'}->{'portsentry_config'})
	if ($self->has_command($self->{'config_hash'}->{'portsentry'}));
push(@rv, $self->{'config_hash'}->{'hostsentry_config'})
	if (-r $self->{'config_hash'}->{'hostsentry'});
push(@rv, $self->{'config_hash'}->{'logcheck'})
	if ($self->has_command($self->{'config_hash'}->{'logcheck'}));
return @rv;
}

# pre_backup(&files)
# Called before the files are actually read
sub pre_backup
{
	my $self = shift;

return undef;
}

# post_backup(&files)
# Called after the files are actually read
sub post_backup
{
	my $self = shift;

return undef;
}

# pre_restore(&files)
# Called before the files are restored from a backup
sub pre_restore
{
	my $self = shift;

return undef;
}

# post_restore(&files)
# Called after the files are restored from a backup
sub post_restore
{
	my $self = shift;

if ($self->has_command($self->{'config_hash'}->{'portsentry'})) {
	# Re-start portsentry, if running
	local @pids = $self->get_portsentry_pids();
	if (@pids) {
		$self->stop_portsentry();
		local $err = $self->start_portsentry();
		return $err if ($err);
		}
	}
if ($self->has_command($self->{'config_hash'}->{'hostsentry'})) {
	# Re-start hostsentry, if running
	$self->{'pid'} = $self->get_hostsentry_pid();
	if ($self->{'pid'}) {
		$self->stop_hostsentry();
		local $err = $self->start_hostsentry();
                return $err if ($err);
		}
	}
return undef;
}


1;

