#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_hostsentry.cgi
# Display hostsentry options

&ModuleLoader::preload_module('sentry_class', "sentry::SentryLib");
$self = new sentry::SentryLib:: 'sentry_class',%$self;

$self->ui_print_header(undef, $self->{'text_hash'}->{'hostsentry_title'}, "", "hostsentry", 0, 0, undef,
	$self->help_search_link("hostsentry", "man", "doc"));

if (!-r $self->{'config_hash'}->{'hostsentry'}) {
	print "<p>",$self->text('hostsentry_ecommand',
			  "<tt>$self->{'config_hash'}->{'hostsentry'}</tt>", 
			  "$self->{'gconfig_hash'}->{'webprefix'}/config.cgi?$self->{'module_name'}"),"<p>\n";
	$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
	exit;
	}

# Show configuration form
$self->{'conf'} = $self->get_hostsentry_config();

print "<form action=save_hostsentry.cgi method=post>\n";
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'hostsentry_header'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

# Show wtmp file
print "<tr> <td><b>$self->{'text_hash'}->{'hostsentry_wtmp'}</b></td>\n";
printf "<td colspan=3><input name=wtmp size=50 value='%s'> %s</td> </tr>\n",
	$self->find_value("WTMP_FILE", $self->{'conf'}),
	$self->file_chooser_button("wtmp");

# Show users to ignore
$self->{'ign'} = $self->find_value("IGNORE_FILE", $self->{'conf'});
print "<tr> <td valign=top><b>$self->{'text_hash'}->{'hostsentry_ignore'}</b></td>\n";
print "<td colspan=3><textarea name=ignore rows=5 cols=40>";
open(IGN, $self->{'ign'});
while(<IGN>) {
	s/#.*$//;
	s/\r|\n//g;
	print $self->html_escape($_),"\n" if (/\S/);
	}
close(IGN);
print "</textarea></td> </tr>\n";

# Show configured modules
$mods = $self->find_value("MODULE_FILE", $self->{'conf'});
open(MODS, $mods);
while(<MODS>) {
	s/\r|\n//g;
	s/#.*$//;
	push(@{$self->{'mods_array'}}, $_) if (/\S/);
	}
close(MODS);
@{$self->{'allmods_array'}} = $self->list_hostsentry_modules($self->{'conf'});
print "<tr> <td valign=top><b>$self->{'text_hash'}->{'hostsentry_mods'}</b></td>\n";
print "<td colspan=3 nowrap>\n";
for($i=0; $i<@{$self->{'allmods_array'}} || $i<@{$self->{'mods_array'}}; $i++) {
	print $i+1,". ";
	print "<select name=mod_$i>\n";
	printf "<option value='' %s>%s\n",
		$self->{'mods_array'}->[$i] ? "" : "selected", "&nbsp;";
	foreach $a (@{$self->{'allmods_array'}}) {
		local $t = $self->{'text_hash'}->{'mod_'.$a};
		printf "<option value=%s %s>%s\n",
			$a, $self->{'mods_array'}->[$i] eq $a ? "selected" : "",
			$t ? $t : $a;
		}
	print "<option selected>$self->{'mods_array'}->[$i]\n"
		if ($self->{'mods_array'}->[$i] && $self->indexof($self->{'mods_array'}->[$i], @{$self->{'allmods_array'}}) < 0);
	print "</select>\n";
	print "<br>\n" if ($i%2);
	print "&nbsp;&nbsp;" if (!($i%2));
	}
print "</td> </tr>\n";

# Show module-specific options
print "</table><table width=100%>\n";
print "<tr>\n";
$self->{'basedir'} = $self->get_hostsentry_dir();
if ($self->indexof("moduleForeignDomain", @{$self->{'mods_array'}}) >= 0) {
	print "<td valign=top colspan=2 width=50%><b>$self->{'text_hash'}->{'hostsentry_foreign'}</b><br>\n";
	print "<textarea name=foreign rows=5 cols=30>";
	open(FOREIGN, "$self->{'basedir'}/moduleForeignDomain.allow");
	while(<FOREIGN>) {
		s/\r|\n//g;
		s/#.*$//;
		print $self->html_escape($_),"\n" if (/\S/);
		}
	close(FOREIGN);
	print "</textarea></td>\n";
	}
if ($self->indexof("moduleMultipleLogins", @{$self->{'mods_array'}}) >= 0) {
	print "<td valign=top colspan=2 width=50%><b>$self->{'text_hash'}->{'hostsentry_multiple'}</b><br>\n";
	print "<textarea name=multiple rows=5 cols=30>";
	open(MULTIPLE, "$self->{'basedir'}/moduleMultipleLogins.allow");
	while(<MULTIPLE>) {
		s/\r|\n//g;
		s/#.*$//;
		print $self->html_escape($_),"\n" if (/\S/);
		}
	close(MULTIPLE);
	print "</textarea></td>\n";
	}
print "</tr>\n";

print "</table></td></tr></table>\n";

$self->{'pid'} = $self->get_hostsentry_pid();
if ($self->{'pid'}) {
	print "<input type=submit name=apply value='$self->{'text_hash'}->{'hostsentry_save'}'></form>\n";
	}
else {
	print "<input type=submit value='$self->{'text_hash'}->{'save'}'></form>\n";
	}

# Show start/stop buttons
print "<hr>\n";
print "<table width=100%>\n";
$self->{'cmd'} = $self->hostsentry_start_cmd();
if ($self->{'pid'}) {
	# Running .. offer to stop
	print "<form action=stop_hostsentry.cgi>\n";
	print "<tr> <td><input type=submit ",
	      "value='$self->{'text_hash'}->{'hostsentry_stop'}'></td>\n";
	print "<td>$self->{'text_hash'}->{'hostsentry_stopdesc'}</td> </tr>\n";
	print "</form>\n";
	}
else {
	# Not running .. offer to start
	print "<form action=start_hostsentry.cgi>\n";
	print "<tr> <td><input type=submit ",
	      "value='$self->{'text_hash'}->{'hostsentry_start'}'></td>\n";
	print "<td>",$self->text('hostsentry_startdesc', "<tt>$self->{'cmd'}</tt>"),
	      "</td> </tr> </form>\n";
	}
print "</table>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

