#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_logcheck.cgi
# Display logcheck configuration menu

&ModuleLoader::preload_module('sentry_class', "sentry::SentryLib");
$self = new sentry::SentryLib:: 'sentry_class',%$self;


# Check if logcheck is installed
if (!-x $self->{'config_hash'}->{'logcheck'}) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'logcheck_title'}, "");
	print "<p>",$self->text('logcheck_ecommand',
		  "<tt>$self->{'config_hash'}->{'logcheck'}</tt>", 
		  "$self->{'gconfig_hash'}->{'webprefix'}/config.cgi?$self->{'module_name'}"),"<p>\n";
	$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
	exit;
	}

# Check if it is the right version
$self->{'conf'} = $self->get_logcheck_config();
$self->{'hacking'} = $self->find_value("HACKING_FILE", $self->{'conf'}, 1);
$self->{'hacking'} = $self->find_value("CRACKING_FILE", $self->{'conf'}, 1) if (!$self->{'hacking'});
if (!$self->{'hacking'}) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'logcheck_title'}, "");
	print "<p>",$self->text('logcheck_eversion',
			  "<tt>$self->{'config_hash'}->{'logcheck'}</tt>"),"<p>\n";
	$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
	exit;
	}

$self->ui_print_header(undef, $self->{'text_hash'}->{'logcheck_title'}, "", "logcheck", 0, 0, undef,
	$self->help_search_link("logcheck", "man", "doc"));

# Show configuration form
print "<form action=save_logcheck.cgi method=post>\n";
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'logcheck_header'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

$self->{'to'} = $self->find_value("SYSADMIN", $self->{'conf'}, 1);
print "<tr> <td><b>$self->{'text_hash'}->{'logcheck_to'}</b></td>\n";
printf "<td colspan=2><input name=to size=50 value='%s'></td> </tr>\n", $self->{'to'};

print "<tr> <td width=33% valign=top><b>$self->{'text_hash'}->{'logcheck_hacking'}</b><br>\n";
print "<textarea name=hacking rows=20 cols=30>";
open(HACKING, $self->{'hacking'});
while(<HACKING>) {
	s/\r|\n//g;
	print $self->html_escape($_),"\n";
	}
close(HACKING);
print "</textarea></td>\n";

$self->{'violations'} = $self->find_value("VIOLATIONS_FILE", $self->{'conf'}, 1);
print "<td width=33% valign=top><b>$self->{'text_hash'}->{'logcheck_violations'}</b><br>\n";
print "<textarea name=violations rows=10 cols=30>";
open(VIOLATIONS, $self->{'violations'});
while(<VIOLATIONS>) {
	s/\r|\n//g;
	print $self->html_escape($_),"\n";
	}
close(VIOLATIONS);
print "</textarea><br>\n";
$self->{'violations_ign'} = $self->find_value("VIOLATIONS_IGNORE_FILE", $self->{'conf'}, 1);
print "<b>$self->{'text_hash'}->{'logcheck_violations_ign'}</b><br>\n";
print "<textarea name=violations_ign rows=7 cols=30>";
open(IGNORE, $self->{'violations_ign'});
while(<IGNORE>) {
	s/\r|\n//g;
	print $self->html_escape($_),"\n";
	}
close(IGNORE);
print "</textarea></td>\n";

$self->{'ignore'} = $self->find_value("IGNORE_FILE", $self->{'conf'}, 1);
print "<td width=33% valign=top><b>$self->{'text_hash'}->{'logcheck_ignore'}</b><br>\n";
print "<textarea name=ignore rows=20 cols=20>";
open(IGNORE, $self->{'ignore'});
while(<IGNORE>) {
	s/\r|\n//g;
	print $self->html_escape($_),"\n";
	}
close(IGNORE);
print "</textarea></td> </tr>\n";

# Display files being monitored
open(CHECK, $self->{'config_hash'}->{'logcheck'});
while(<CHECK>) {
	s/\r|\n//g;
	s/#.*$//;
	if (/^\s*(\$LOGTAIL|\S*logtail)\s+(\S+)/) {
		push(@{$self->{'logfiles_array'}}, $2);
		}
	}
close(CHECK);
if (@{$self->{'logfiles_array'}}) {
	print "<tr> <td valign=top><b>$self->{'text_hash'}->{'logcheck_files'}</b></td>\n";
	print "<td colspan=2>",join(" ",
			map { "<tt>$_</tt>" } @{$self->{'logfiles_array'}}),"</td> </tr>\n";
	}

# Display run times for logcheck
$self->foreign_require("cron", "cron-lib.pl");
@{$self->{'jobs_array'}} = $main::cron_object->list_cron_jobs();
JOB: foreach $j (@{$self->{'jobs_array'}}) {
	local $rpd;
	if ($j->{'command'} =~ /$self->{'config_hash'}->{'logcheck'}/) {
		$self->{'job'} = $j;
		last;
		}
	elsif ($rpd = $main::cron_object->is_run_parts($j->{'command'})) {
		local @exp = $main::cron_object->expand_run_parts($rpd);
		foreach $e (@exp) {
			if ($e =~ /logcheck/) {
				# Cannot change this :(
				$self->{'runparts'} = $e;
				last JOB;
				}
			}
		}
	}
if ($self->{'runparts'}) {
	print "<tr> <td colspan=3>",$self->text('logcheck_runparts',
				"<tt>$self->{'runparts'}</tt>"),"</td> </tr>\n";
	print "<input type=hidden name=runparts value='1'>\n";
	}
else {
	print "<input type=hidden name=job value='$self->{'job'}->{'index'}'>\n"
		if ($self->{'job'});
	print "<tr> <td colspan=3>\n";
	$self->{'job'} = { 'mins' => 0,
		 'hours' => '*',
		 'days' => '*',
		 'months' => '*',
		 'weekdays' => '*' } if (!$self->{'job'});
	printf "<input type=radio name=active value=0 %s> %s\n",
		$self->{'job'}->{'active'} ? "" : "checked", $self->{'text_hash'}->{'logcheck_disabled'};
	printf "<input type=radio name=active value=1 %s> %s<br>\n",
		$self->{'job'}->{'active'} ? "checked" : "", $self->{'text_hash'}->{'logcheck_enabled'};
	print "<table border width=100%>\n";
	$main::cron_object->show_times_input($self->{'job'});
	print "</table></td> </tr>\n";
	}

print "</table></td></tr></table><br>\n";
print "<input type=submit value='$self->{'text_hash'}->{'logcheck_save'}'></form>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

