#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_portsentry.cgi
# Display portsentry configuration menu

&ModuleLoader::preload_module('sentry_class', "sentry::SentryLib");
$self = new sentry::SentryLib:: 'sentry_class',%$self;


$self->{'path'} = $self->has_command($self->{'config_hash'}->{'portsentry'});
if (!$self->{'path'}) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'portsentry_title'}, "");
	print "<p>",$self->text('portsentry_ecommand',
			  "<tt>$self->{'config_hash'}->{'portsentry'}</tt>", 
			  "$self->{'gconfig_hash'}->{'webprefix'}/config.cgi?$self->{'module_name'}"),"<p>\n";
	$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
	exit;
	}

if (!-r $self->{'config_hash'}->{'portsentry_config'} && -r $self->{'config_hash'}->{'portsentry_alt_config'}) {
	system("cp $self->{'config_hash'}->{'portsentry_alt_config'} $self->{'config_hash'}->{'portsentry_config'}");
	}

# Get the version, if needed
$self->read_file("$self->{'module_config_directory'}/portsentry", \%{$self->{'portsentry_hash'}});
@{$self->{'st_array'}} = stat($self->{'path'});
if ($self->{'st_array'}->[7] != $self->{'portsentry_hash'}->{'size'} || $self->{'st_array'}->[9] != $self->{'portsentry_hash'}->{'mtime'}) {
	$self->{'out'} = $self->backquote_command("$self->{'config_hash'}->{'portsentry'} -v 2>&1", 1);
	if ($self->{'out'} !~ /Version:\s+(\S+)/) {
		$self->ui_print_header(undef, $self->{'text_hash'}->{'portsentry_title'}, "");
		print "<p>",$self->text('portsentry_eversion',
				  "<tt>$self->{'config_hash'}->{'portsentry'}</tt>", 
				  "$self->{'gconfig_hash'}->{'webprefix'}/config.cgi?$self->{'module_name'}"),"<p>\n";
		$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
		exit;
		}
	$self->{'portsentry_hash'}->{'version'} = $1;
	$self->{'portsentry_hash'}->{'size'} = $self->{'st_array'}->[7];
	$self->{'portsentry_hash'}->{'mtime'} = $self->{'st_array'}->[9];
	$self->write_file("$self->{'module_config_directory'}/portsentry", \%{$self->{'portsentry_hash'}});
	}

$self->ui_print_header(undef, $self->{'text_hash'}->{'portsentry_title'}, "", "portsentry", 0, 0, undef,
	$self->help_search_link("portsentry", "man", "doc"), undef, undef,
	$self->text('portsentry_version', $self->{'portsentry_hash'}->{'version'}));

if ($self->{'portsentry_hash'}->{'version'} >= 2) {
	print "<p>",$self->text('portsentry_eversion2',
			  "<tt>$self->{'config_hash'}->{'portsentry'}</tt>",
			  $self->{'portsentry_hash'}->{'version'}),"<p>\n";
	$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
	exit;
	}

# Show configuration form
$self->{'conf'} = $self->get_portsentry_config();

print "<form action=save_portsentry.cgi method=post>\n";
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'portsentry_header'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

$self->{'tcp_ports'} = $self->find_value("TCP_PORTS", $self->{'conf'});
$self->{'udp_ports'} = $self->find_value("UDP_PORTS", $self->{'conf'});
$self->{'tcp_adv'} = $self->find_value("ADVANCED_PORTS_TCP", $self->{'conf'});
$self->{'udp_adv'} = $self->find_value("ADVANCED_PORTS_UDP", $self->{'conf'});
$self->{'tcp_exc'} = $self->find_value("ADVANCED_EXCLUDE_TCP", $self->{'conf'});
$self->{'udp_exc'} = $self->find_value("ADVANCED_EXCLUDE_UDP", $self->{'conf'});

print "<tr> <td valign=top><b>$self->{'text_hash'}->{'portsentry_tmode'}</b></td> <td>\n";
printf "%s <input name=tports size=50 value='%s'><br>\n",
	$self->{'text_hash'}->{'portsentry_mode0'},
	join(" ", split(/,/, $self->{'tcp_ports'}));
$self->{'tcp_exc'} = join(" ", split(/,/, $self->{'tcp_exc'}));
print $self->text('portsentry_mode1',
	    "<input name=tadv size=8 value='$self->{'tcp_adv'}'>",
	    "<input name=texc size=20 value='$self->{'tcp_exc'}'>"),"</td> </tr>\n";

print "<tr> <td valign=top><b>$self->{'text_hash'}->{'portsentry_umode'}</b></td> <td>\n";
printf "%s <input name=uports size=50 value='%s'><br>\n",
	$self->{'text_hash'}->{'portsentry_mode0'},
	join(" ", split(/,/, $self->{'udp_ports'}));
$self->{'udp_exc'} = join(" ", split(/,/, $self->{'udp_exc'}));
print $self->text('portsentry_mode1',
	    "<input name=uadv size=8 value='$self->{'udp_adv'}'>",
	    "<input name=uexc size=20 value='$self->{'udp_exc'}'>"),"</td> </tr>\n";

$self->{'tblock'} = $self->find_value("BLOCK_TCP", $self->{'conf'});
print "<tr> <td><b>$self->{'text_hash'}->{'portsentry_tblock'}</b></td> <td>\n";
printf "<input type=radio name=tblock value=1 %s> $self->{'text_hash'}->{'yes'}\n",
	$self->{'tblock'} == 1 ? "checked" : "";
printf "<input type=radio name=tblock value=0 %s> $self->{'text_hash'}->{'no'}\n",
	$self->{'tblock'} == 0 ? "checked" : "";
printf "<input type=radio name=tblock value=2 %s> $self->{'text_hash'}->{'portsentry_kill'}\n",
	$self->{'tblock'} == 2 ? "checked" : "";
print "</td> </tr>\n";

$self->{'ublock'} = $self->find_value("BLOCK_UDP", $self->{'conf'});
print "<tr> <td><b>$self->{'text_hash'}->{'portsentry_ublock'}</b></td> <td>\n";
printf "<input type=radio name=ublock value=1 %s> $self->{'text_hash'}->{'yes'}\n",
	$self->{'ublock'} == 1 ? "checked" : "";
printf "<input type=radio name=ublock value=0 %s> $self->{'text_hash'}->{'no'}\n",
	$self->{'ublock'} == 0 ? "checked" : "";
printf "<input type=radio name=ublock value=2 %s> $self->{'text_hash'}->{'portsentry_kill'}\n",
	$self->{'ublock'} == 2 ? "checked" : "";
print "</td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'portsentry_banner'}</b></td>\n";
printf "<td><input name=banner size=50 value='%s'></td> </tr>\n",
	$self->find_value("PORT_BANNER", $self->{'conf'});

print "<tr> <td><b>$self->{'text_hash'}->{'portsentry_trigger'}</b></td>\n";
printf "<td><input name=trigger size=6 value='%s'></td> </tr>\n",
	$self->find_value("SCAN_TRIGGER", $self->{'conf'});

print "<tr> <td valign=top><b>$self->{'text_hash'}->{'portsentry_ignore'}</b></td>\n";
print "<td><textarea name=ignore rows=5 cols=50>\n";
if ($self->{'config_hash'}->{'portsentry_ignore'}) {
	$self->{'ign'} = $self->{'config_hash'}->{'portsentry_ignore'};
	}
else {
	$self->{'ign'} = $self->find_value("IGNORE_FILE", $self->{'conf'});
	}
$self->{'lnum'} = 0;
open(IGN, $self->{'ign'});
while(<IGN>) {
	if (/Do NOT edit below this/i) {
		$self->{'editbelow'} = $self->{'lnum'}-1;
		last;
		}
	s/#.*$//;
	print $self->html_escape($_) if (/\S/);
	$self->{'lnum'}++;
	}
close(IGN);
print "</textarea></td> </tr></table>\n";
print "<input type=hidden name=editbelow value='$self->{'editbelow'}'>\n"
	if (defined($self->{'editbelow'}));
print "</td></tr></table>\n";

@{$self->{'pids_array'}} = $self->get_portsentry_pids();
if (@{$self->{'pids_array'}}) {
	print "<input type=submit name=apply value='$self->{'text_hash'}->{'portsentry_save'}'></form>\n";
	}
else {
	print "<input type=submit value='$self->{'text_hash'}->{'save'}'></form>\n";
	}

# Show start/stop buttons
print "<hr>\n";
print "<table width=100%>\n";
$self->{'cmd'} = $self->portsentry_start_cmd();
if (@{$self->{'pids_array'}}) {
	# Running .. offer to stop
	print "<form action=stop_portsentry.cgi>\n";
	print "<tr> <td><input type=submit ",
	      "value='$self->{'text_hash'}->{'portsentry_stop'}'></td>\n";
	print "<td>$self->{'text_hash'}->{'portsentry_stopdesc'}</td> </tr>\n";
	print "</form>\n";
	}
else {
	# Not running .. offer to start
	print "<form action=start_portsentry.cgi>\n";
	print "<tr> <td><input type=submit ",
	      "value='$self->{'text_hash'}->{'portsentry_start'}'></td>\n";
	print "<td>",$self->text('portsentry_startdesc', "<tt>$self->{'cmd'}</tt>"),
	      "</td> </tr> </form>\n";
	}
print "</table>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

