#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_hostsentry.cgi
# Save hostsentry options

&ModuleLoader::preload_module('sentry_class', "sentry::SentryLib");
$self = new sentry::SentryLib:: 'sentry_class',%$self;

$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'hostsentry_err'});

# Validate inputs
-r $self->{'in_hash'}->{'wtmp'} || $self->error($self->{'text_hash'}->{'hostsentry_ewtmp'});
@{$self->{'ignore_array'}} = split(/\s+/, $self->{'in_hash'}->{'ignore'});
foreach $u (@{$self->{'ignore_array'}}) {
	defined(getpwnam($u)) || $self->error($self->text('hostsentry_eignore', $u));
	}
for($i=0; defined($self->{'in_hash'}->{"mod_$i"}); $i++) {
	push(@{$self->{'mods_array'}}, $self->{'in_hash'}->{"mod_$i"}) if ($self->{'in_hash'}->{"mod_$i"});
	}
if (defined($self->{'in_hash'}->{'foreign'})) {
	@{$self->{'foreign_array'}} = split(/\s+/, $self->{'in_hash'}->{'foreign'});
	}
if (defined($self->{'in_hash'}->{'multiple'})) {
	@{$self->{'multiple_array'}} = split(/\s+/, $self->{'in_hash'}->{'multiple'});
	foreach $m (@{$self->{'multiple_array'}}) {
		gethostbyname($m) || $self->check_ipaddress($m) ||
			$self->error($self->text('hostsentry_emultiple', $m));
		}
	}

# Write to the appropriate files
$self->{'conf'} = $self->get_hostsentry_config();
$self->lock_config_files($self->{'conf'});
$self->save_config($self->{'conf'}, "WTMP_FILE", $self->{'in_hash'}->{'wtmp'});
$self->flush_file_lines();
$self->unlock_config_files($self->{'conf'});

$self->{'ign'} = $self->find_value("IGNORE_FILE", $self->{'conf'});
$self->lock_file($self->{'ign'});
$self->open_tempfile(IGN, ">$self->{'ign'}");
foreach $i (@{$self->{'ignore_array'}}) {
	$self->print_tempfile(IGN, $i,"\n");
	}
$self->close_tempfile(IGN);
$self->unlock_file($self->{'ign'});

$self->{'mods'} = $self->find_value("MODULE_FILE", $self->{'conf'});
$self->lock_file($self->{'mods'});
$self->open_tempfile(MODS, ">$self->{'mods'}");
foreach $m (@{$self->{'mods_array'}}) {
	$self->print_tempfile(MODS, $m,"\n");
	}
$self->close_tempfile(MODS);
$self->unlock_file($self->{'mods'});

$self->{'basedir'} = $self->get_hostsentry_dir();
if (defined(@{$self->{'foreign_array'}})) {
	$self->lock_file("$self->{'basedir'}/moduleForeignDomain.allow");
	$self->open_tempfile(FOREIGN, ">$self->{'basedir'}/moduleForeignDomain.allow");
	foreach $f (@{$self->{'foreign_array'}}) {
		$self->print_tempfile(FOREIGN, $f,"\n");
		}
	$self->close_tempfile(FOREIGN);
	$self->unlock_file("$self->{'basedir'}/moduleForeignDomain.allow");
	}
if (defined(@{$self->{'multiple_array'}})) {
	$self->lock_file("$self->{'basedir'}/moduleMultipleLogins.allow");
	$self->open_tempfile(MULTIPLE, ">$self->{'basedir'}/moduleMultipleLogins.allow");
	foreach $m (@{$self->{'multiple_array'}}) {
		$self->print_tempfile(MULTIPLE, $m,"\n");
		}
	$self->close_tempfile(MULTIPLE);
	$self->unlock_file("$self->{'basedir'}/moduleMultipleLogins.allow");
	}

if ($self->{'in_hash'}->{'apply'}) {
	# Attempt to restart
	$self->stop_hostsentry();
	$self->{'err'} = $self->start_hostsentry();
	$self->error($self->{'err'}) if ($self->{'err'});
	}
$self->webmin_log("hostsentry");

$self->redirect("");

1;
		
}


1;

