#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_logcheck.cgi
# Save logcheck.sh options

&ModuleLoader::preload_module('sentry_class', "sentry::SentryLib");
$self = new sentry::SentryLib:: 'sentry_class',%$self;

$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'logcheck_err'});

# Get the current cron job
$self->foreign_require("cron", "cron-lib.pl");
@{$self->{'jobs_array'}} = $main::cron_object->list_cron_jobs();
foreach $j (@{$self->{'jobs_array'}}) {
	$self->{'job'} = $j if ($j->{'command'} =~ /$self->{'config_hash'}->{'logcheck'}/);
	}

# Validate and save inputs
$self->{'conf'} = $self->get_logcheck_config();
$self->lock_config_files($self->{'conf'});
$self->{'in_hash'}->{'to'} =~ /^\S+$/ || $self->error($self->{'text_hash'}->{'logcheck_eto'});
if ($self->{'in_hash'}->{'runparts'}) {
	# Being run from a script that we cannot change
	}
elsif (!$self->{'in_hash'}->{'active'} && !$self->{'job'}) {
	# Cron job is not setup yet, and doesn't need to be .. do nothing
	}
else {
	# Create or update the cron job
	if (!$self->{'job'}) {
		$self->{'job'} = { 'command' => $self->{'config_hash'}->{'logcheck'},
			 'user' => 'root' };
		$self->{'creating'}++;
		}
	$self->{'job'}->{'active'} = $self->{'in_hash'}->{'active'};
	$main::cron_object->parse_times_input($self->{'job'}, \%{$self->{'in_hash'}});
	$self->lock_file($main::cron_object->cron_file($self->{'job'}));
	if ($self->{'creating'}) {
		$main::cron_object->create_cron_job($self->{'job'});
		}
	else {
		$main::cron_object->change_cron_job($self->{'job'});
		}
	$self->unlock_file($main::cron_object->cron_file($self->{'job'}));
	}
$self->{'to'} = $self->find_value("SYSADMIN", $self->{'conf'});
if ($self->{'to'} =~ /^\$(\S+)$/) {
	$self->save_config($self->{'conf'}, $1, $self->{'in_hash'}->{'to'});
	}
else {
	$self->save_config($self->{'conf'}, "SYSADMIN", $self->{'in_hash'}->{'to'});
	}
$self->flush_file_lines();
$self->unlock_config_files($self->{'conf'});

$self->{'hacking'} = $self->find_value("HACKING_FILE", $self->{'conf'}, 1);
$self->{'hacking'} = $self->find_value("CRACKING_FILE", $self->{'conf'}, 1) if (!$self->{'hacking'});
$self->lock_file($self->{'hacking'});
$self->{'in_hash'}->{'hacking'} =~ s/\r//g;
$self->{'in_hash'}->{'hacking'} =~ s/\n*$/\n/;
$self->open_tempfile(HACKING, ">$self->{'hacking'}");
$self->print_tempfile(HACKING, $self->{'in_hash'}->{'hacking'});
$self->close_tempfile(HACKING);
$self->unlock_file($self->{'hacking'});

$self->{'violations'} = $self->find_value("VIOLATIONS_FILE", $self->{'conf'}, 1);
$self->lock_file($self->{'violations'});
$self->{'in_hash'}->{'violations'} =~ s/\r//g;
$self->{'in_hash'}->{'violations'} =~ s/\n*$/\n/;
$self->open_tempfile(VIOLATIONS, ">$self->{'violations'}");
$self->print_tempfile(VIOLATIONS, $self->{'in_hash'}->{'violations'});
$self->close_tempfile(VIOLATIONS);
$self->unlock_file($self->{'violations'});

$self->{'violations_ign'} = $self->find_value("VIOLATIONS_IGNORE_FILE", $self->{'conf'}, 1);
$self->lock_file($self->{'violations_ign'});
$self->{'in_hash'}->{'violations_ign'} =~ s/\r//g;
$self->{'in_hash'}->{'violations_ign'} =~ s/\n*$/\n/;
$self->open_tempfile(IGNORE, ">$self->{'violations_ign'}");
$self->print_tempfile(IGNORE, $self->{'in_hash'}->{'violations_ign'});
$self->close_tempfile(IGNORE);
$self->unlock_file($self->{'violations_ign'});

$self->{'ignore'} = $self->find_value("IGNORE_FILE", $self->{'conf'}, 1);
$self->lock_file($self->{'ignore'});
$self->{'in_hash'}->{'ignore'} =~ s/\r//g;
$self->{'in_hash'}->{'ignore'} =~ s/\n*$/\n/;
$self->open_tempfile(IGNORE, ">$self->{'ignore'}");
$self->print_tempfile(IGNORE, $self->{'in_hash'}->{'ignore'});
$self->close_tempfile(IGNORE);
$self->unlock_file($self->{'ignore'});

$self->webmin_log("logcheck");
$self->redirect("");

1;
		
}


1;

