#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_config.cgi
# Update the portsentry config file

&ModuleLoader::preload_module('sentry_class', "sentry::SentryLib");
$self = new sentry::SentryLib:: 'sentry_class',%$self;

$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'portsentry_err'});
$self->{'conf'} = $self->get_portsentry_config();
$self->lock_config_files($self->{'conf'});

# Validate and save inputs
@{$self->{'tports_array'}} = split(/\s+/, $self->{'in_hash'}->{'tports'});
foreach $t (@{$self->{'tports_array'}}) {
	$t > 0 && $t < 65535 || $self->error($self->text('portsentry_etports', $t));
	}
$self->save_config($self->{'conf'}, "TCP_PORTS", join(",", @{$self->{'tports_array'}}));
$self->{'in_hash'}->{'tadv'} > 0 && $self->{'in_hash'}->{'tadv'} < 65535 || $self->error($self->{'text_hash'}->{'portsentry_etadv'});
$self->save_config($self->{'conf'}, "ADVANCED_PORTS_TCP", $self->{'in_hash'}->{'tadv'});
@{$self->{'texc_array'}} = split(/\s+/, $self->{'in_hash'}->{'texc'});
foreach $t (@{$self->{'texc_array'}}) {
	$t > 0 && $t < 65535 || $self->error($self->text('portsentry_etexc', $t));
	}
$self->save_config($self->{'conf'}, "ADVANCED_EXCLUDE_TCP", join(",", @{$self->{'texc_array'}}));

@{$self->{'uports_array'}} = split(/\s+/, $self->{'in_hash'}->{'uports'});
foreach $t (@{$self->{'uports_array'}}) {
	$t > 0 && $t < 65535 || $self->error($self->text('portsentry_euports', $t));
	}
$self->save_config($self->{'conf'}, "UDP_PORTS", join(",", @{$self->{'uports_array'}}));
$self->{'in_hash'}->{'uadv'} > 0 && $self->{'in_hash'}->{'uadv'} < 65535 || $self->error($self->{'text_hash'}->{'portsentry_euadv'});
$self->save_config($self->{'conf'}, "ADVANCED_PORTS_UDP", $self->{'in_hash'}->{'uadv'});
@{$self->{'uexc_array'}} = split(/\s+/, $self->{'in_hash'}->{'uexc'});
foreach $t (@{$self->{'uexc_array'}}) {
	$t > 0 && $t < 65535 || $self->error($self->text('portsentry_euexc', $t));
	}
$self->save_config($self->{'conf'}, "ADVANCED_EXCLUDE_UDP", join(",", @{$self->{'uexc_array'}}));

$self->save_config($self->{'conf'}, "BLOCK_TCP", $self->{'in_hash'}->{'tblock'});
$self->save_config($self->{'conf'}, "BLOCK_UDP", $self->{'in_hash'}->{'ublock'});
$self->save_config($self->{'conf'}, "PORT_BANNER", $self->{'in_hash'}->{'banner'});

$self->{'in_hash'}->{'trigger'} =~ /^\d+$/ || $self->error($self->{'text_hash'}->{'portsentry_etrigger'});
$self->save_config($self->{'conf'}, "SCAN_TRIGGER", $self->{'in_hash'}->{'trigger'});

# Save list of ignored hosts
if ($self->{'config_hash'}->{'portsentry_ignore'}) {
	$self->{'ign'} = $self->{'config_hash'}->{'portsentry_ignore'};
	}
else {
	$self->{'ign'} = $self->find_value("IGNORE_FILE", $self->{'conf'});
	}
$self->lock_file($self->{'ign'});
$self->{'in_hash'}->{'ignore'} =~ s/\r//g;
$self->{'in_hash'}->{'ignore'} =~ s/\n*$/\n/;
foreach $h (split(/\s+/, $self->{'in_hash'}->{'ignore'})) {
	gethostbyname($h) || $self->check_ipaddress($h) ||
	  ($h =~ /^([0-9\.]+)\/(\d+)/ && $self->check_ipaddress($1)) ||
		$self->error($self->text('portsentry_eignore', $h));
	}
if (defined($self->{'in_hash'}->{'editbelow'})) {
	open(IGNORE, $self->{'ign'});
	@{$self->{'below_array'}} = <IGNORE>;
	close(IGNORE);
	@{$self->{'below_array'}} = @{$self->{'below_array'}}[$self->{'in_hash'}->{'editbelow'} .. $#{$self->{'below_array'}}];
	}
$self->open_tempfile(IGNORE, ">$self->{'ign'}");
$self->print_tempfile(IGNORE, $self->{'in_hash'}->{'ignore'});
$self->print_tempfile(IGNORE, @{$self->{'below_array'}});
$self->close_tempfile(IGNORE);
$self->unlock_file($self->{'ign'});
$self->flush_file_lines();
$self->unlock_config_files($self->{'conf'});

if ($self->{'in_hash'}->{'apply'}) {
	# Restart portsentry
	$self->stop_portsentry();
	$self->{'err'} = $self->start_portsentry();
	$self->error($self->{'err'}) if ($self->{'err'});
	}
$self->webmin_log("portsentry");

$self->redirect("");

1;
		
}


1;

