#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_export.cgi
# Create, update or delete an NFS export

&ModuleLoader::preload_module('sgiexports_class', "sgiexports::SgiexportsLib");
$self = new sgiexports::SgiexportsLib:: 'sgiexports_class',%$self;

$self->ReadParse();
@{$self->{'exports_array'}} = $self->get_exports();
$self->{'export'} = $self->{'exports_array'}->[$self->{'in_hash'}->{'idx'}] if (!$self->{'in_hash'}->{'new'});

$self->lock_file($self->{'config_hash'}->{'exports_file'});
if ($self->{'in_hash'}->{'delete'}) {
	# Just delete this export
	$self->delete_export($self->{'export'});
	}
else {
	# Validate and store inputs
	$self->error_setup($self->{'text_hash'}->{'save_err'});
	-d $self->{'in_hash'}->{'dir'} || $self->error($self->{'text_hash'}->{'save_edir'});
	$self->{'export'}->{'dir'} = $self->{'in_hash'}->{'dir'};
	$self->{'export'}->{'hosts'} = [ split(/\s+/, $self->{'in_hash'}->{'hosts'}) ];
	if ($self->{'in_hash'}->{'ro'}) { $self->{'export'}->{'opts'}->{'ro'} = ''; }
	else { delete($self->{'export'}->{'opts'}->{'ro'}); }
	if ($self->{'in_hash'}->{'wsync'}) { $self->{'export'}->{'opts'}->{'wsync'} = ''; }
	else { delete($self->{'export'}->{'opts'}->{'wsync'}); }
	if ($self->{'in_hash'}->{'anon_def'} == 1) { delete($self->{'export'}->{'opts'}->{'anon'}); }
	elsif ($self->{'in_hash'}->{'anon_def'} == 2) { $self->{'export'}->{'opts'}->{'anon'} = -1; }
	else {
		$self->{'in_hash'}->{'anon'} =~ /^-?[0-9]+$/ ||
			defined(getpwnam($self->{'in_hash'}->{'anon'})) ||
				$self->error($self->{'text_hash'}->{'save_eanon'});
		$self->{'export'}->{'opts'}->{'anon'} = $self->{'in_hash'}->{'anon'};
		}

	if ($self->{'in_hash'}->{'rw_def'}) {
		delete($self->{'export'}->{'opts'}->{'rw'});
		}
	else {
		@{$self->{'hosts_array'}} = split(/\s+/, $self->{'in_hash'}->{'rw'});
		@{$self->{'hosts_array'}} || $self->error($self->{'text_hash'}->{'save_erw'});
		$self->{'export'}->{'opts'}->{'rw'} = join(":", @{$self->{'hosts_array'}});
		}

	if ($self->{'in_hash'}->{'root_def'}) {
		delete($self->{'export'}->{'opts'}->{'root'});
		}
	else {
		@{$self->{'hosts_array'}} = split(/\s+/, $self->{'in_hash'}->{'root'});
		@{$self->{'hosts_array'}} || $self->error($self->{'text_hash'}->{'save_eroot'});
		$self->{'export'}->{'opts'}->{'root'} = join(":", @{$self->{'hosts_array'}});
		}

	if ($self->{'in_hash'}->{'access_def'}) {
		delete($self->{'export'}->{'opts'}->{'access'});
		}
	else {
		@{$self->{'hosts_array'}} = split(/\s+/, $self->{'in_hash'}->{'access'});
		@{$self->{'hosts_array'}} || $self->error($self->{'text_hash'}->{'save_eaccess'});
		$self->{'export'}->{'opts'}->{'access'} = join(":", @{$self->{'hosts_array'}});
		}

	if ($self->{'in_hash'}->{'new'}) {
		$self->create_export($self->{'export'});
		}
	else {
		$self->modify_export($self->{'export'});
		}
	}
$self->unlock_file($self->{'config_hash'}->{'exports_file'});
$self->webmin_log($self->{'in_hash'}->{'new'} ? "create" : $self->{'in_hash'}->{'delete'} ? "delete" : "modify",
	    "export", $self->{'export'}->{'dir'});
$self->redirect("");

1;
		
}


1;

