#!/usr/bin/perl

&MAIN();

 sub MAIN {
# index.cgi
# Display icons for the various shorewall configuration files

&ModuleLoader::preload_module('shorewall_class', "shorewall::ShorewallLib");
$self = new shorewall::ShorewallLib:: 'shorewall_class',%$self;


if (!$self->has_command($self->{'config_hash'}->{'shorewall'})) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", undef, 1, 1);
	print "<p>",$self->text('index_ecmd', "<tt>$self->{'config_hash'}->{'shorewall'}</tt>",
		  "$self->{'gconfig_hash'}->{'webprefix'}/config.cgi?$self->{'module_name'}"),"<p>\n";
	}
else {
	# Get the version
	$self->{'shorewall_version'} = $self->get_shorewall_version(1);
	$self->open_tempfile(VERSION, ">$self->{'module_config_directory'}/version");
	$self->print_tempfile(VERSION, $self->{'shorewall_version'},"\n");
	$self->close_tempfile(VERSION);

	$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", undef, 1, 1, 0,
		$self->help_search_link("shorewall", "doc", "google"),
		undef, undef, $self->text('index_version', $self->{'shorewall_version'}));

	if (!-d $self->{'config_hash'}->{'config_dir'}) {
		# Config dir not found!
		print "<p>",$self->text('index_edir',
		      "<tt>$self->{'config_hash'}->{'config_dir'}</tt>",
		      "$self->{'gconfig_hash'}->{'webprefix'}/config.cgi?$self->{'module_name'}"),"<p>\n";
		}
	else {
		# Just show the file icons
		@{$self->{'files_array'}} = grep { $self->can_access($_) } @{$self->{'shorewall_files_array'}};
		@{$self->{'titles_array'}} = map { $self->{'text_hash'}->{$_."_title"}."<br>($_)" } @{$self->{'files_array'}};
		@{$self->{'links_array'}} = map { "list.cgi?table=".$_ } @{$self->{'files_array'}};
		@{$self->{'icons_array'}} = map { "images/".$_.".gif" } @{$self->{'files_array'}};
		$self->icons_table(\@{$self->{'links_array'}}, \@{$self->{'titles_array'}}, \@{$self->{'icons_array'}}, 4);

		# Check if shorewall is running by looking for the 'shorewall'
		# chain in the filter table
		print "<hr>\n";
		print "<table width=100%>\n";
		system("iptables -t filter -L shorewall -n >/dev/null 2>&1");
		if ($?) {
		  # Down .. offer to start
		  # unless no permissions
		  unless ($self->{'access_hash'}->{'nochange'}) {
		    print "<form action=start.cgi>\n";
		    print "<tr> <td><input type=submit ",
		      "value='$self->{'text_hash'}->{'index_start'}'></td>\n";
		    print "<td>$self->{'text_hash'}->{'index_startdesc'}</td> </tr>\n";
		    print "</form>\n";
		  }
		}
		else {
		  # Up .. offer to restart, clear and stop
		  # unless nochange is set
		  unless ($self->{'access_hash'}->{'nochange'}) {
		    print "<form action=restart.cgi>\n";
		    print "<tr> <td><input type=submit ",
		      "value='$self->{'text_hash'}->{'index_restart'}'></td>\n";
		    print "<td>$self->{'text_hash'}->{'index_restartdesc'}</td> </tr>\n";
		    print "</form>\n";

		    print "<form action=refresh.cgi>\n";
		    print "<tr> <td><input type=submit ",
		      "value='$self->{'text_hash'}->{'index_refresh'}'></td>\n";
		    print "<td>$self->{'text_hash'}->{'index_refreshdesc'}</td> </tr>\n";
		    print "</form>\n";

		    print "<form action=clear.cgi>\n";
		    print "<tr> <td><input type=submit ",
		      "value='$self->{'text_hash'}->{'index_clear'}'></td>\n";
		    print "<td>$self->{'text_hash'}->{'index_cleardesc'}</td> </tr>\n";
		    print "</form>\n";

		    print "<form action=stop.cgi>\n";
		    print "<tr> <td><input type=submit ",
		      "value='$self->{'text_hash'}->{'index_stop'}'></td>\n";
		    print "<td>$self->{'text_hash'}->{'index_stopdesc'}</td> </tr>\n";
		    print "</form>\n";
		  }
		  print "<form action=status.cgi>\n";
		  print "<tr> <td><input type=submit ",
		    "value='$self->{'text_hash'}->{'index_status'}'></td>\n";
		  print "<td>$self->{'text_hash'}->{'index_statusdesc'}</td> </tr>\n";
		  print "</form>\n";
		}

		# Always offer to check
		print "<form action=check.cgi>\n";
		print "<tr> <td><input type=submit ",
		      "value='$self->{'text_hash'}->{'index_check'}'></td>\n";
		print "<td>$self->{'text_hash'}->{'index_checkdesc'}</td> </tr>\n";
		print "</table>\n";
		}
	}

$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});

1;
		
}


1;

