#!/usr/bin/perl

&MAIN();

 sub MAIN {
# list.cgi
# Display the contents of some table

&ModuleLoader::preload_module('shorewall_class', "shorewall::ShorewallLib");
$self = new shorewall::ShorewallLib:: 'shorewall_class',%$self;

$self->ReadParse();
$self->can_access($self->{'in_hash'}->{'table'}) || $self->error($self->{'text_hash'}->{'list_ecannot'});
$self->ui_print_header(undef, $self->{'text_hash'}->{$self->{'in_hash'}->{'table'}."_title"}, "");

$self->{'desc'} = $self->{'text_hash'}->{$self->{'in_hash'}->{'table'}."_desc"};
print "$self->{'desc'}<p>\n" if ($self->{'desc'});

$self->{'pfunc'} = $self->{'in_hash'}->{'table'}."_parser";
$self->{'pfunc'} = "standard_parser" if (!$self->UNIVERSAL::can($self->{'pfunc'}));
@{$self->{'table_array'}} = $self->read_table_file($self->{'in_hash'}->{'table'}, $self->{'pfunc'});
$self->{'cfunc'} = $self->{'in_hash'}->{'table'}."_columns";
$self->{'cols'} = do { my $fn = $self->{'cfunc'}; $self->$fn() if ($self->UNIVERSAL::can($self->{'cfunc'}))};
$self->{'nfunc'} = $self->{'in_hash'}->{'table'}."_colnames";
if ($self->UNIVERSAL::can($self->{'nfunc'})) {
	@{$self->{'colnames_array'}} = do { my $fn = $self->{'nfunc'}; $self->$fn()};
	}
else {
	@{$self->{'colnames_array'}} = ( );
	for($j=0; defined($self->{'cols'}) ? ($j<$self->{'cols'}) : ($self->{'text_hash'}->{$self->{'in_hash'}->{'table'}."_".$j}); $j++) {
		push(@{$self->{'colnames_array'}}, $self->{'text_hash'}->{$self->{'in_hash'}->{'table'}."_".$j});
		}
	}

# Work out select/create links
@{$self->{'links_array'}} = ( $self->select_all_link("d"),
	   $self->select_invert_link("d"),
	   "<a href='edit.cgi?table=$self->{'in_hash'}->{'table'}&new=1'>".
	    $self->{'text_hash'}->{$self->{'in_hash'}->{'table'}."_add"}."</a>" );
if ($self->version_atleast(3, 3, 3) && $self->indexof($self->{'in_hash'}->{'table'}, @{$self->{'comment_tables_array'}}) >= 0) {
	push(@{$self->{'links_array'}}, "<a href='editcmt.cgi?table=$self->{'in_hash'}->{'table'}&new=1'>".
		     $self->{'text_hash'}->{"comment_add"}."</a>");
	}

# Show the table
if (@{$self->{'table_array'}}) {
	print $self->ui_form_start("delete.cgi", "post");
	print $self->ui_hidden("table", $self->{'in_hash'}->{'table'}),"\n";
	print $self->ui_links_row(\@{$self->{'links_array'}});
	print $self->ui_columns_start([
		"",
		@{$self->{'colnames_array'}},
		(@{$self->{'table_array'}} > 1 ? ( $self->{'text_hash'}->{'list_move'} ) : ( )),
		$self->{'text_hash'}->{'list_add'}
		], undef, 0, [ "width=5" ]);

	$self->{'rfunc'} = $self->{'in_hash'}->{'table'}."_row";
	for($i=0; $i<@{$self->{'table_array'}}; $i++) {
		@{$self->{'t_array'}} = @{$self->{'table_array'}->[$i]};
		local @cols;
		local @tds;
		if ($self->{'t_array'}->[0] eq "COMMENT") {
			# Special case - a comment line
			push(@cols, "<a href='editcmt.cgi?table=$self->{'in_hash'}->{'table'}&".
				    "idx=$i'><i>".join(" ", @{$self->{'t_array'}}[1..$#{$self->{'t_array'}}]).
				    "</i></a>" );
			@tds = ( "width=5", "colspan=".scalar(@{$self->{'colnames_array'}}) );
			}
		else {
			# Some rule or other object
			if ($self->UNIVERSAL::can($self->{'rfunc'})) {
				@{$self->{'t_array'}} = do { my $fn = $self->{'rfunc'}; $self->$fn(@{$self->{'t_array'}})};
				}
			for($j=0; $j<@{$self->{'colnames_array'}}; $j++) {
				if ($j == 0) {
					$self->{'lnk'} = "<a href='edit.cgi?table=$self->{'in_hash'}->{'table'}&idx=$i'>$self->{'t_array'}->[$j]</a>";
					}
				else {
					$self->{'lnk'} = $self->{'t_array'}->[$j];
					}
				push(@cols, $self->{'lnk'});
				}
			@tds = ( "width=5" );
			}
		if (@{$self->{'table_array'}} > 1) {
			$self->{'mover'} = "";
			if ($i == 0) {
				$self->{'mover'} .= "<img src=images/gap.gif>";
				}
			else {
				$self->{'mover'} .= "<a href='up.cgi?table=$self->{'in_hash'}->{'table'}&idx=$i'><img src=images/up.gif border=0></a>\n";
				}
			if ($i == $#{$self->{'table_array'}}) {
				$self->{'mover'} .= "<img src=images/gap.gif>";
				}
			else {
				$self->{'mover'} .= "<a href='down.cgi?table=$self->{'in_hash'}->{'table'}&idx=$i'><img src=images/down.gif border=0></a>\n";
				}
			push(@cols, $self->{'mover'});
			}
		push(@cols, 
		      "<a href='edit.cgi?table=$self->{'in_hash'}->{'table'}&new=1&before=$i'>".
		      "<img src=images/before.gif border=0></a>\n".
		      "<a href='edit.cgi?table=$self->{'in_hash'}->{'table'}&new=1&after=$i'>".
		      "<img src=images/after.gif border=0></a>\n");
		print $self->ui_checked_columns_row(\@cols, \@tds, "d", $i);
		}
	print $self->ui_columns_end();
	}
else {
	print "<b>",$self->{'text_hash'}->{$self->{'in_hash'}->{'table'}."_none"},"</b><p>\n";
	shift(@{$self->{'links_array'}}); shift(@{$self->{'links_array'}});
	}
print $self->ui_links_row(\@{$self->{'links_array'}});
if (@{$self->{'table_array'}}) {
	print $self->ui_form_end([ [ "delete", $self->{'text_hash'}->{'list_delete'} ] ]);
	}

print "<hr>\n";
print $self->ui_buttons_start();
print $self->ui_buttons_row("manual_form.cgi", $self->{'text_hash'}->{'list_manual'},
		      $self->text('list_manualdesc',
			"<tt>$self->{'config_hash'}->{'config_dir'}/$self->{'in_hash'}->{'table'}</tt>"),
		      $self->ui_hidden("table", $self->{'in_hash'}->{'table'}));
print $self->ui_buttons_end();

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
1;
		
}


1;

