#!/usr/bin/perl
package smart_status::Status_monitor;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'smart_status::Status_monitor');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;

&ModuleLoader::preload_module(ref($self), "smart_status::SmartstatusLib");
$self = new smart_status::SmartstatusLib:: ref($self), %$self; 

1;

1;
		return $self;
}

# status_monitor_list()
# Just one type is supported
sub status_monitor_list
{
	my $self = shift;

if ($self->has_command($self->{'config_hash'}->{'smartctl'})) {
	return ( [ "smart", $self->{'text_hash'}->{'monitor_type'} ] );
	}
else {
	return ( );
	}
}

# status_monitor_status(type, &monitor, from-ui)
# Check the drive status
sub status_monitor_status
{
	my $self = shift;

if (!-r $_[1]->{'drive'}) {
	return { 'up' => -1,
		 'desc' => $self->{'text_hash'}->{'monitor_nosuch'} };
	}
local $st = $self->get_drive_status($_[1]->{'drive'});
if (!$st->{'support'} || !$st->{'enabled'}) {
	return { 'up' => -1,
		 'desc' => $self->{'text_hash'}->{'monitor_nosmart'} };
	}
elsif (!$st->{'check'}) {
	return { 'up' => 0 };
	}
elsif ($st->{'errors'} && $_[1]->{'errors'}) {
	return { 'up' => 0 };
	}
else {
	return { 'up' => 1 };
	}
}

# status_monitor_dialog(type, &monitor)
# Return form for selecting a drive
sub status_monitor_dialog
{
	my $self = shift;

local $rv;
$rv = "<tr> <td><b>$self->{'text_hash'}->{'monitor_drive'}</b></td>\n";
$rv .= "<td colspan=3>";
local @drives = grep { $_->{'type'} eq 'ide' } $main::fdisk_object->list_disks_partitions();
@drives = sort { $a->{'device'} cmp $b->{'device'} } @drives;
local ($inlist) = grep { $_->{'device'} eq $_[1]->{'drive'} } @drives;
$inlist = 1 if (!$_[1]->{'drive'});
$rv .= $self->ui_select("drive", !$_[1]->{'drive'} ? $drives[0]->{'device'} :
			   $inlist ? $_[1]->{'drive'} : undef,
		 [ (map { [ $_->{'device'},
			   $_->{'desc'}.($_->{'model'} ?
				" ($_->{'model'})" : "") ] } @drives),
		   [ "", $self->{'text_hash'}->{'monitor_other'} ] ]);
$rv .= $self->ui_textbox("other", $inlist ? "" : $_[1]->{'drive'}, 15);
$rv .= "</td> </tr>\n";

$rv .= "<tr> <td><b>$self->{'text_hash'}->{'monitor_errors'}</b></td>\n";
$rv .= "<td>".$self->ui_radio("errors", $_[1]->{'errors'} || 0,
		[ [ 1, $self->{'text_hash'}->{'yes'} ], [ 0, $self->{'text_hash'}->{'no'} ] ])."</td> </tr>\n";
return $rv;
}

# status_monitor_parse(type, &monitor, &in)
# Parse form for selecting a rule
sub status_monitor_parse
{
	my $self = shift;

$_[1]->{'drive'} = $_[2]->{'drive'} || $_[2]->{'other'};
$_[1]->{'drive'} =~ /^\S+$/ || $self->error($self->{'text_hash'}->{'monitor_edrive'});
$_[1]->{'errors'} = $_[2]->{'errors'};
}


1;

