#!/usr/bin/perl

&MAIN();

 sub MAIN {
# index.cgi
# Display a list of services, built from svcs command

&ModuleLoader::preload_module('smf_class', "smf::SmfLib");
$self = new smf::SmfLib:: 'smf_class',%$self;

$self->ReadParse();
$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", "help", 1, 1, 0,
	$self->help_search_link("smf", "man", "doc", "howto"));

# deal with application of state changes first. this way
# fmri list will show changes...
if (defined($self->{'in_hash'}->{'change_state'})) {
	$self->{'cmd'} = "$self->{'in_hash'}->{'change_state'}";
	# get update fmri list
	@{$self->{'update_fmris_array'}} = split(/\0/, $self->{'in_hash'}->{'applyto'});
	$self->svc_state_cmd("$self->{'cmd'}", \@{$self->{'update_fmris_array'}});
	}

# service type
if (defined($self->{'in_hash'}->{'type'})) {
	$self->{'svc_type'} = $self->{'in_hash'}->{'type'};
} else {
	$self->{'svc_type'} = "All";
	}
if (defined($self->{'in_hash'}->{'include_disabled'})) {
	$self->{'include_disabled'} = $self->{'in_hash'}->{'include_disabled'};
} else {
	$self->{'include_disabled'} = $self->{'default_include_disabled'};
	}
if ($self->{'include_disabled'} == 1) {
	$self->{'checked_include_disabled'} = "checked";
} else {
	$self->{'checked_include_disabled'} = "";
	}
# opts for svcs listing
$self->{'opts'} = "$self->{'default_svc_options'}";

if (defined($self->{'in_hash'}->{'opts'})) {
	@{$self->{'extraopts_array'}} = split(/\0/, $self->{'in_hash'}->{'opts'});
	foreach $extraopt (@{$self->{'extraopts_array'}}) {
		$self->{'opts'} = "$self->{'opts'},$extraopt";
		}
	}
$self->{'sortopt'} = "$self->{'default_sortopt'}";
if (defined($self->{'in_hash'}->{'sortopt'})) {
	$self->{'sortopt'} = $self->{'in_hash'}->{'sortopt'};
	}

print "<h2>";
$self->text_and_whats_this("index_detail");
print "</h2>\n";
# Checkboxes for view update
print "<form method=\"POST\" action=\"index.cgi\">\n";
print "<p><table>\n";
print "<tr><td><b>$self->{'text_hash'}->{'index_svc_type'}</b></td>\n";
print "<td>";
@{$self->{'typelist_array'}} = sort keys %{$self->{'svc_types_hash'}};
$self->print_selection("type", "$self->{'svc_type'}", \@{$self->{'typelist_array'}});
print "</td></tr>\n";
print "<tr><td><b>$self->{'text_hash'}->{'index_extraopts'}</b></td>\n";
print "</b></td>\n";
print "<td>";
@{$self->{'additional_option_names_array'}} = sort keys %{$self->{'svc_options_hash'}};
foreach $o (@{$self->{'additional_option_names_array'}}) {
	if ($self->{'default_svc_options'} =~ /$o/) {
		next;
		}
	$self->{'checked'} = "unchecked";
	if ($self->{'opts'}=~ /$o/) {
		$self->{'checked'} = "checked";
		$self->{'opts_str'}="$self->{'opts_str'}\&opts=$o";
		}
	print "$self->{'svc_options_hash'}->{$o}";
	print "<input type=checkbox name=\"opts\" value=\"$o\" $self->{'checked'}>&nbsp;";
	}
print "</td></tr>\n";
print "<tr><td><b>$self->{'text_hash'}->{'index_include_disabled'}</b></td>\n";
print "<td>";
print
"<input type=checkbox name=\"include_disabled\" value=1 $self->{'checked_include_disabled'}>";
print "</td></tr>\n";
print "<tr><td>&nbsp;</td><td>\n";
print "<input type=submit name=\"submit\" value=\"Update View\"/></td></tr>";
print "</table></p></form>\n";

print "<form method=\"POST\" action=\"index.cgi?include_disabled=$self->{'include_disabled'}&type=$self->{'svc_type'}&sortopt=$self->{'sortopt'}$self->{'opts_str'}\">\n";

print "<table border width=100%>\n";
print "<tr><td><table width=100%>\n";
# multiple select buttons(enable, disable, maintenance, degraded, clear, delete)
print "<tr $self->{'cb'}><td>\n";
print "<input type=\"button\" onClick=location.href=\"smfwizard_service.cgi?clearout=1\" value=\"$self->{'text_hash'}->{'index_create_new_service'}\">";
print "&nbsp;";
print "<input type=\"button\" onClick=location.href=\"search_instance.cgi\" value=\"$self->{'text_hash'}->{'index_search_instance'}\">\n";
print "</td></tr><tr $self->{'cb'}><td><b>$self->{'text_hash'}->{'index_apply'}</b>:&nbsp;";
$self->print_state_buttons();
# add delete/create new buttons in addition to statechange buttons
print "<input type=submit name=\"change_state\" onClick=\"return (confirm(\'$self->{'text_hash'}->{'index_deleteconfirm'}\'))\" value=\"$self->{'text_hash'}->{'index_delete'}\">&nbsp;\n";
print "</td></tr></table></td></tr>\n";
print "<tr><td><table width=100%>\n";
@{$self->{'svcs_info_array'}} = $self->svcs_listing("$self->{'svc_types_hash'}->{$self->{'svc_type'}}", "$self->{'sortopt'}");
@{$self->{'optlist_array'}} = split(/,/, $self->{'opts'});
print "<tr $self->{'cb'}>\n";
print "<td>$self->{'text_hash'}->{'index_select'}</td>\n";
foreach $o (@{$self->{'optlist_array'}}) {
	# clicking should reverse sort option if we`re already sorting by
	# this option...
	if ($self->{'sortopt'} =~/-S$o/) {
		$self->{'new_sortopt'} = "-s$o";
	} elsif ($self->{'sortopt'} =~/-s$o/) {
		$self->{'new_sortopt'} = "-S$o";
	} else {
		$self->{'new_sortopt'} = "-s$o";
		}
	print "<td>";
	print "$self->{'text_hash'}->{'index_sort_by'}:&nbsp;";
	print "<a href=\"index.cgi?include_disabled=$self->{'include_disabled'}&type=$self->{'svc_type'}&sortopt=$self->{'new_sortopt'}$self->{'opts_str'}\">";
	print "$self->{'svc_options_hash'}->{$o}</a></td>\n";
	}
print "</tr>\n";

for $svc_info (@{$self->{'svcs_info_array'}}) {
	# if we are displaying enabled only, skip disabled
	if (($self->{'include_disabled'} != 1) && ($svc_info->{'STATE'} eq "disabled")) {
		next;
		}
	print "<tr $self->{'cb'}>";
	$self->{'fmri'} = $svc_info->{'FMRI'};
	if ("$self->{'fmri'}" =~ /^lrc:\//) {
		print "<td>-</td>\n";
	} else {
		print "<td><input type=checkbox name=\"applyto\" value=\"$svc_info->{'FMRI'}\"></td>\n";
		}
        foreach $opt (@{$self->{'optlist_array'}}) {
		$self->{'field'} = $svc_info->{$opt};
		if ($opt eq "FMRI") {
			$self->{'field'} =~ /$self->{'svc_types_hash'}->{$self->{'svc_type'}}(.*)/;
			$self->{'svc'} = $1;
			# make sure legacy svcs are unclickable!
			if ($self->{'field'} =~ /svc:\//) {
				print "<td>";
				print
		"<a href=\"instance_viewer.cgi?fmri='$self->{'fmri'}'\">$self->{'svc'}</a>";
				print "</td>\n";
			} else {
				print "<td>$self->{'svc'}</td>\n";
				}
		} elsif ($opt eq "STATE") {
			print
			    "<td>";
			print
    "<font color=$self->{'state_colors_hash'}->{$svc_info->{$opt}}>$svc_info->{$opt}</font>\n";
			print "</td>\n";
		} else {
			print "<td>$self->{'field'}</td>"
		}
	}
	print "</tr>\n";
}
print "</table></td></tr></table></form>\n";

$self->print_cmds_run();

$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});

1;
		
}


1;

