#!/usr/bin/perl

&MAIN();

 sub MAIN {
# instance viewer
# Display a form for displaying SMF instance information

&ModuleLoader::preload_module('smf_class', "smf::SmfLib");
$self = new smf::SmfLib:: 'smf_class',%$self;

$self->ReadParse();

# get instance fmri
if (defined($self->{'in_hash'}->{'fmri'})) {
	$self->{'fmri'} = $self->{'in_hash'}->{'fmri'};
	# remove quotes...
	$self->{'fmri'} =~ /\'([^\']*)\'/;
	$self->{'fmri'} = $1;
} else {
	$self->error("No fmri supplied to instance viewer!");
	}

# Gather service description, and state info
$self->{'description'} = $self->run_smf_cmds("/usr/bin/svcs -H -oDESC $self->{'fmri'}", 0);
$self->{'sinfo'} = $self->run_smf_cmds("/usr/bin/svcs -x $self->{'fmri'}", 0);
@{$self->{'state_info_array'}} = split(/\n/, $self->{'sinfo'});

$self->ui_print_header(undef, $self->{'text_hash'}->{'instance_viewer_title'}, "", undef);

print "<h2>$self->{'description'}</h2>\n";
print "<h2>";
$self->text_and_whats_this("instance_viewer_detail");
print "</h2>";

foreach $line (@{$self->{'state_info_array'}}) {
	$self->{'converted'} = $self->convert_links_in_text($line);
	print "<p>$self->{'converted'}</p>\n";
	}

print "<p>";
print "<a href=\"property_group_editor.cgi?fmri='$self->{'fmri'}'\">";
print "$self->{'text_hash'}->{'instance_viewer_goto_pgroup_editor'}</a>";
print "</p>\n";

print "<p>";
print "<a href=\"dep_viewer.cgi?fmri='$self->{'fmri'}'\">";
print "$self->{'text_hash'}->{'instance_viewer_goto_dep_viewer'}</a>";
print "</p>\n";

$self->print_cmds_run();

$self->ui_print_footer("index.cgi", $self->{'text_hash'}->{'index'});

1;
		
}


1;

