#!/usr/bin/perl

&MAIN();

 sub MAIN {
# property_editor.cgi
# Display a list of properties for property group for fmri

&ModuleLoader::preload_module('smf_class', "smf::SmfLib");
$self = new smf::SmfLib:: 'smf_class',%$self;

$self->ReadParse();
$self->ui_print_header(undef, $self->{'text_hash'}->{'property_editor_title'}, "");

# get instance fmri
if (defined($self->{'in_hash'}->{'fmri'})) {
	$self->{'fmri'} = $self->{'in_hash'}->{'fmri'};
	# remove quotes...
	$self->{'fmri'} =~ /\'([^\']*)\'/;
	$self->{'fmri'} = $1;
	if ($self->{'fmri'} =~ /(svc:\/[^:]*):(.*)/) {
		$self->{'svc'} = $1;
		$self->{'inst'} = $2;
	} else {
		$self->error("Invalid fmri: instance must be specified!");
		}
} else {
	$self->error("No fmri supplied to property editor!");
	}
if (defined($self->{'in_hash'}->{'sinst'})) {
	$self->{'sinst'} = "$self->{'in_hash'}->{'sinst'}";
	$self->{'entity'} = ($self->{'sinst'} eq "service") ? "$self->{'svc'}" : "$svc:$self->{'inst'}";
} else {
	$self->error("Service/Instance level not specified for property editor!");
	}
if (defined($self->{'in_hash'}->{'pgroup'})) {
	$self->{'pgroup'} = $self->{'in_hash'}->{'pgroup'};
} else {
	$self->error("No property group supplied to property editor!");
	}

# deal with add/deletion/update of properties first. this way
# prop list will show changes...
if ((defined($self->{'in_hash'}->{'add'})) &&
    (defined($self->{'in_hash'}->{'addname'})) &&
    (defined($self->{'in_hash'}->{'addtype'})) &&
    (defined($self->{'in_hash'}->{'addvalue'}))) {
	$self->{'addname'} = "$self->{'in_hash'}->{'addname'}";
	$self->{'addtype'} = "$self->{'in_hash'}->{'addtype'}";
	$self->{'addvalue'} = "$self->{'in_hash'}->{'addvalue'}";
	if (($self->{'addname'} =~ /.+/) && ($self->{'addtype'} =~ /.+/) && ($self->{'addvalue'} =~ /.+/)) {
		$self->svc_setprop("$self->{'svc'}", "$self->{'sinst'}", "$self->{'pgroup'}", "$self->{'addname'}",
			"$self->{'addtype'}", "$self->{'addvalue'}");
		}
	}
if (defined($self->{'in_hash'}->{'remove'})) {
	# get remove prop list
	@{$self->{'remove_props_array'}} = split(/\0/, $self->{'in_hash'}->{'applyto'});
	foreach $rp (@{$self->{'remove_props_array'}}) {
		$self->svc_delprop("$self->{'svc'}", "$self->{'sinst'}", "$self->{'pgroup'}", "$rp");
		}
	}
@{$self->{'prop_listing_array'}} = $self->svc_listprop("$self->{'svc'}", "$self->{'sinst'}", $self->{'pgroup'});

# need prop listing to match against values for update. if we change
# anything, we`ll regenerate the listing...
$self->{'regenerate_listing'} = 0;
if (defined($self->{'in_hash'}->{'update'})) {
	# update each prop in listing with new value
	foreach $prop (@{$self->{'prop_listing_array'}}) {
		$self->{'prop_name'} = $prop->{'prop_name'};
		$self->{'prop_type'} = $prop->{'prop_type'};
		if (defined($self->{'in_hash'}->{"$self->{'prop_name'}/$self->{'prop_type'}"})) {
			$self->{'prop_value'} = $self->{'in_hash'}->{"$self->{'prop_name'}/$self->{'prop_type'}"};
			$self->svc_setprop("$self->{'svc'}", "$self->{'sinst'}", "$self->{'pgroup'}", "$self->{'prop_name'}",
				"$self->{'prop_type'}", "$self->{'prop_value'}");
			$self->{'regenerate_listing'} = 1;
			}
		}
	}
if ($self->{'regenerate_listing'} == 1) {
	@{$self->{'prop_listing_array'}} = $self->svc_listprop("$self->{'svc'}", "$self->{'sinst'}", $self->{'pgroup'});
	}

print "<h2>";
$self->text_and_whats_this("property_editor_detail");
print " : $self->{'entity'}/$self->{'pgroup'}</h2>\n";

print "<form method=\"POST\" action=\"property_editor.cgi?fmri='$self->{'fmri'}'&sinst=$self->{'sinst'}&pgroup=$self->{'pgroup'}\">\n";

# add prop table first...
print "<p><h3>$self->{'text_hash'}->{'property_editor_addprop'}</h3>\n";
print "<table><tr>";
print "<td><b>$self->{'text_hash'}->{'property_editor_addname'}</b></td>\n";
print "<td><b>$self->{'text_hash'}->{'property_editor_addtype'}</b></td>\n";
print "<td><b>$self->{'text_hash'}->{'property_editor_addvalue'}</b></td></tr>\n";
print "<tr><td>\n";
print "<input size=30 name=\"addname\" value=\"\">\n";
print "</td><td>\n";
$self->print_selection("addtype", "", \@{$self->{'propval_type_values_array'}});
print "</td><td>\n";
print "<input size=60 name=\"addvalue\" value=\"\">\n";
print "</td></tr>\n";
print "<tr><td>&nbsp;</td><td>&nbsp;</td><td>";
print "<input type=submit name=\"add\" value=\"$self->{'text_hash'}->{'property_editor_add'}\">\n";
print "</td></tr></table></b>\n";

print "<table border width=100%>\n";
print "<tr><td><table width=100%>\n";
print "<tr $self->{'cb'}><td><b>$self->{'text_hash'}->{'property_editor_apply'}</b>:&nbsp;";
print "<input type=submit name=\"remove\" onClick=\"return (confirm(\'$self->{'text_hash'}->{'property_editor_deleteconfirm'}\'))\" value=\"$self->{'text_hash'}->{'property_editor_delete'}\">&nbsp;\n";
print "</td></tr></table></td></tr>\n";
print "<tr><td><table width=100%>\n";
print "<tr $self->{'cb'}>\n";
print "<td><b>$self->{'text_hash'}->{'property_editor_select'}</b></td>\n";
print "<td><b>$self->{'text_hash'}->{'property_editor_prop_name'}</b></td>\n";
print "<td><b>$self->{'text_hash'}->{'property_editor_prop_type'}</b></td>\n";
print "<td><b>$self->{'text_hash'}->{'property_editor_prop_value'}</b></td></tr>\n";

foreach $prop (@{$self->{'prop_listing_array'}}) {
	print "<tr $self->{'cb'}>";
	$self->{'name'} = $prop->{'prop_name'};
	$self->{'type'} = $prop->{'prop_type'};
	$self->{'value'} = $prop->{'prop_value'};
	print "<td>\n";
	print "<input type=checkbox name=\"applyto\" value=\"$self->{'name'}\">";
	print "</td>\n";
	print "<td>$self->{'name'}</td>\n";
	print "<td>$self->{'type'}</td>\n";
	print
	    "<td><input size=60 name=\"$self->{'name'}/$self->{'type'}\" value=\"$self->{'value'}\"></td>\n";
	print "</tr>\n";
}
print "<tr $self->{'cb'}><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td><td>\n";
print
"<input type=submit name=\"update\" value=\"$self->{'text_hash'}->{'property_editor_update'}\">";
print "</td></tr>\n";
print "</table></td></tr></table></form>\n";

$self->print_cmds_run();

$self->ui_print_footer("property_group_editor.cgi?fmri='$self->{'fmri'}'",
	$self->{'text_hash'}->{'property_editor_back'});

1;
		
}


1;

