#!/usr/bin/perl

&MAIN();

 sub MAIN {
# index.cgi
# Display a list of services, built from svcs command

&ModuleLoader::preload_module('smf_class', "smf::SmfLib");
$self = new smf::SmfLib:: 'smf_class',%$self;

$self->ReadParse();
$self->ui_print_header(undef, $self->{'text_hash'}->{'property_group_editor_title'}, "");

# get instance fmri
if (defined($self->{'in_hash'}->{'fmri'})) {
	$self->{'fmri'} = $self->{'in_hash'}->{'fmri'};
	# remove quotes...
	$self->{'fmri'} =~ /\'([^\']*)\'/;
	$self->{'fmri'} = $1;
	if ($self->{'fmri'} =~ /(svc:\/[^:]*):(.*)/) {
		$self->{'svc'} = $1;
		$self->{'inst'} = $2;
	} else {
		$self->error("Invalid fmri: instance must be specified!");
		}
} else {
	$self->error("No fmri supplied to property group editor!");
	}

# deal with add/deletion of property groups first. this way
# pgroup list will show changes...
if ((defined($self->{'in_hash'}->{'add'})) &&
    (defined($self->{'in_hash'}->{'addname'})) &&
    (defined($self->{'in_hash'}->{'addtype'})) &&
    (defined($self->{'in_hash'}->{'addsinst'}))) {
	$self->{'addname'} = "$self->{'in_hash'}->{'addname'}";
	$self->{'addtype'} = "$self->{'in_hash'}->{'addtype'}";
	$self->{'addsinst'} = "$self->{'in_hash'}->{'addsinst'}";
	if (($self->{'addname'} =~ /.+/) && ($self->{'addtype'} =~ /.+/) && ($self->{'addsinst'} =~ /.+/)) {
		$self->svc_addpg("$self->{'svc'}", "$self->{'addsinst'}", "$self->{'addname'}", "$self->{'addtype'}");
		}
	}
if (defined($self->{'in_hash'}->{'remove'})) {
	# get remove pg list
	@{$self->{'remove_pgs_array'}} = split(/\0/, $self->{'in_hash'}->{'applyto'});
	foreach $rpg (@{$self->{'remove_pgs_array'}}) { 
		# split into service or instance level/name
		if ($rpg =~ /([^\/]*)\/(.*)/) {
			$self->{'pgsinst'} = $1;
			$self->{'pgname'} = $2;
			$self->svc_delpg("$self->{'svc'}", "$self->{'pgsinst'}", "$self->{'pgname'}");
			}
		}
	}

@{$self->{'pgroup_listing_svc_array'}} = $self->svc_listpg($self->{'svc'}, "service");
@{$self->{'pgroup_listing_inst_array'}} = $self->svc_listpg($self->{'svc'}, $self->{'inst'});
@{$self->{'pgroup_listing_array'}} = (@{$self->{'pgroup_listing_svc_array'}}, @{$self->{'pgroup_listing_inst_array'}});

print "<h2>";
$self->text_and_whats_this("property_group_editor_detail");
print " : $self->{'fmri'} </h2>\n";

print "<form method=\"POST\" action=\"property_group_editor.cgi?fmri='$self->{'fmri'}'\">\n";

# add pg table first...
print "<p><h3>$self->{'text_hash'}->{'property_group_editor_addpg'}</h3>\n";
print "<table><tr>";
print "<td><b>$self->{'text_hash'}->{'property_group_editor_addsinst'}</b></td>\n";
print "<td><b>$self->{'text_hash'}->{'property_group_editor_addname'}</b></td>\n";
print "<td><b>$self->{'text_hash'}->{'property_group_editor_addtype'}</b></td></tr>\n";
print "<tr><td>\n";
@{$self->{'sinstarray_array'}} = ("service", "$self->{'inst'}");
$self->print_selection("addsinst", "service", \@{$self->{'sinstarray_array'}});
print "</td><td>\n";
print "<input size=30 name=\"addname\" value=\"\">\n";
print "</td><td>\n";
print "<input size=30 name=\"addtype\" value=\"\">\n";
print "</td></tr>\n";
print "<tr><td>&nbsp;</td><td>&nbsp;</td><td>";
print "<input type=submit name=\"add\" value=\"$self->{'text_hash'}->{'property_group_editor_add'}\">\n";
print "</td></tr></table></b>\n";

print "<table border width=100%>\n";
print "<tr><td><table width=100%>\n";
print "<tr $self->{'cb'}><td><b>$self->{'text_hash'}->{'property_group_editor_apply'}</b>:&nbsp;";
print "<input type=submit name=\"remove\" onClick=\"return (confirm(\'$self->{'text_hash'}->{'property_group_editor_deleteconfirm'}\'))\" value=\"$self->{'text_hash'}->{'property_group_editor_delete'}\">&nbsp;\n";
print "</td></tr></table></td></tr>\n";
print "<tr><td><table width=100%>\n";
print "<tr $self->{'cb'}>\n";
print "<td><b>$self->{'text_hash'}->{'property_group_editor_select'}</b></td>\n";
print "<td><b>$self->{'text_hash'}->{'property_group_editor_sinst'}</b></td>\n";
print "<td><b>$self->{'text_hash'}->{'property_group_editor_pgroup_name'}</b></td>\n";
print "<td><b>$self->{'text_hash'}->{'property_group_editor_pgroup_type'}</b></td></tr>\n";

foreach $pg (@{$self->{'pgroup_listing_array'}}) {
	print "<tr $self->{'cb'}>";
	$self->{'sinst'} = $pg->{'sinst'};
	$self->{'name'} = $pg->{'pgroup_name'};
	$self->{'type'} = $pg->{'pgroup_type'};
	print "<td>\n";
	print "<input type=checkbox name=\"applyto\" value=\"$self->{'sinst'}/$self->{'name'}\">";
	print "</td><td>\n";
	print "$self->{'sinst'}</td><td>\n";
	# dont allow edit of nonpersistent items!
	if ($self->{'type'} =~ /NONPERSISTENT/) {
		print "$self->{'name'}";
	} else {
		$self->{'entity'} = ($self->{'sinst'} eq "service") ? "$self->{'svc'}" : "$self->{'fmri'}";
		print
	"<a href=\"property_editor.cgi?fmri='$self->{'fmri'}'&sinst=$self->{'sinst'}&pgroup=$self->{'name'}\">$self->{'name'}</a>";
		}
	print "</td><td>$self->{'type'}</td>\n";
	print "</tr>\n";
}
print "</table></td></tr></table></form>\n";

$self->print_cmds_run();

$self->ui_print_footer("instance_viewer.cgi?fmri='$self->{'fmri'}'",
	$self->{'text_hash'}->{'property_group_editor_back'});

1;
		
}


1;

