#!/usr/bin/perl

&MAIN();

 sub MAIN {
# chooser.cgi
# Outputs HTML for a frame-based svc chooser 

&ModuleLoader::preload_module('smf_class', "smf::SmfLib");
$self = new smf::SmfLib:: 'smf_class',%$self;


$self->init_config();
$self->ReadParse();

# type specifies svc, inst or both
$self->{'type'} = "both";
if (defined($self->{'in_hash'}->{'type'})) {
	$self->{'type'} = $self->{'in_hash'}->{'type'};
	}
if ((defined($self->{'in_hash'}->{'add'})) && ($self->{'in_hash'}->{'add'})) {
	# Only use last fmri by default
	$self->{'in_hash'}->{'fmri'} =~ s/\s+$//;
	if ($self->{'in_hash'}->{'fmri'} =~ /\n(.*)$/) {
		$self->{'in_hash'}->{'fmri'} = $1;
		}
	}
$self->{'fmri'} = $self->{'in_hash'}->{'fmri'};
if ($self->{'fmri'} =~ /^svc\:\/([^\:]*)\:*(.*)$/) {
	# fmri entered is valid
	$self->{'svc'} = $1;
	$self->{'inst'} = $2;
	}
else {
	$self->{'fmri'} = "svc:/";
	$self->{'svc'} = "";
	$self->{'inst'} = "";
	}
$self->{'add'} = int($self->{'in_hash'}->{'add'});

$self->{'frame'} = $self->{'in_hash'}->{'frame'};
if ($self->{'frame'} eq "" ) {
	$self->{'frame'} = 0;
}

if ($self->{'in_hash'}->{'frame'} == 0) {
	# base frame
	$self->PrintHeader();
	if ($self->{'in_hash'}->{'type'} eq "svc")
		{ print "<title>$self->{'text_hash'}->{'svc_chooser_titlesvc'}</title>\n"; }
	elsif ($self->{'in_hash'}->{'type'} eq "inst") 
		{ print "<title>$self->{'text_hash'}->{'svc_chooser_titleinst'}</title>\n";}
	else
		{ print "<title>$self->{'text_hash'}->{'svc_chooser_titleboth'}</title>\n";}

	print "<frameset rows='*,50'>\n";
	print "<frame marginwidth=10 marginheight=10 name=topframe ",
	    "src=\"svc_chooser.cgi?frame=1&fmri=$self->{'fmri'}&add=$self->{'add'}&type=$self->{'type'}\">\n";
	print "<frame marginwidth=10 marginheight=10 name=bottomframe ",
	    "src=\"svc_chooser.cgi?frame=2&add=$self->{'add'}&fmri=$self->{'fmri'}&type=$self->{'type'}\" ",
	    "scrolling=no>\n";
	print "</frameset>\n";
	}
elsif ($self->{'in_hash'}->{'frame'} == 1) {
	# List of svcs
	$self->header();
	print <<EOF;
<script>
function svcclick(fmri, inst, expand, isvalid)
{
if ((inst == "") || (inst == ":")) {
	selected_fmri = fmri;
	}
else {
	selected_fmri = fmri+inst;
	}
curr = top.bottomframe.document.forms[0].fmri.value;
if (isvalid ==1) {
	top.bottomframe.document.forms[0].fmri.value = selected_fmri;
	}
if (expand == 1) {
	location ="svc_chooser.cgi?frame=1&add=$self->{'add'}&type=$self->{'type'}&fmri="+fmri+inst;
	}
}

</script>
EOF
	print "<b>", $self->text('svc_chooser_fmri', $self->{'fmri'}),"</b>\n";
	print "<table>\n";
	# filter fmris via fmri var
	@{$self->{'list_array'}} = $self->svcs_listing("$self->{'fmri'}", "-sFMRI");
	foreach $f_hash (@{$self->{'list_array'}}) {
		$self->{'full_fmri'} = $f_hash->{"FMRI"};
		if ($self->{'full_fmri'} =~ /^$self->{'fmri'}([^\/:]+[\/\:]*).*$/) {
			$self->{'elt'} = "$1";
			# check if its an instance, if so add colon
			if ($self->{'fmri'} =~ /.*\:$/) {
				$self->{'elt'} = ":$self->{'elt'}";	
				}
			push(@{$self->{'flist_array'}}, "$self->{'elt'}");
			}
		}
	@{$self->{'fmris_array'}} = $self->unique(@{$self->{'flist_array'}});
	$self->{'uplevel'} = $self->{'fmri'};
	if ($self->{'uplevel'} =~ /^svc\:\/.+$/) {
		$self->{'uplevel'} =~ /^svc\:\/(([^\/\:]+[\:\/])*)[^\/\:]+[\/]*[\:]*$/;
		$self->{'uplevel'} = "svc:/$1";
		unshift(@{$self->{'fmris_array'}}, $self->{'uplevel'});
		}
	foreach $f (@{$self->{'fmris_array'}}) {
		print "<tr>\n";
		# determine img type
		if ($f eq $self->{'uplevel'}) {
			$self->{'img'} = "images/uplevel.gif";
			$self->{'link'} =
		  "<a href='javascript:svcclick(\"$self->{'uplevel'}\",\"\",1,0)'>";
		} elsif ($f =~ /^.*\/$/) {
			$self->{'img'} = "images/nextlevel.gif";
			$self->{'link'} =
		  "<a href='javascript:svcclick(\"$self->{'fmri'}$f\",\"\",1,0)'>";
		} elsif ($f =~ /^\:.*/) {
			# at instance level...
			# remove leading ":"
			$f =~ s/^\:(\S+)$/$1/;
			$self->{'img'} = "images/instance.gif";
			$self->{'link'} =
		  "<a href='javascript:svcclick(\"$self->{'fmri'}\",\"$f\",0,1)'>";
		} else {
			# service
			$self->{'img'} = "images/service.gif";
			# remove final ":" if present
			$f =~ s/^([^\:]+)\:$/$1/;
			$self->{'inst'} = ":";
			if ($self->{'type'} eq "svc") {
				# cannot click to instance level!
				# remove final ":" if present
				$self->{'isvalid'} = 1;
				$self->{'expand'} = 0;
			} elsif ($self->{'type'} eq "inst") {
				# cannnot select svc...
				$self->{'isvalid'} = 0;
				$self->{'expand'} = 1;
			} else {
				# both valid
				$self->{'isvalid'} = 1;
				$self->{'expand'} = 1;
				}
			$self->{'link'} =
  "<a href='javascript:svcclick(\"$self->{'fmri'}$f\",\"$self->{'inst'}\",$self->{'expand'},$self->{'isvalid'})'>";
			}
		print
	"<td>$self->{'link'}<img border=0 width=30 height=30 src=$self->{'img'}></a></td>\n";
		print "<td>$self->{'link'}$f</a></td>\n";
		print "</tr>\n";
		}
	print "</table></td></tr></table>\n";
	$self->footer();
	}
elsif ($self->{'in_hash'}->{'frame'} == 2) {
	# Current fmri and OK/cancel buttons
	$self->header();
	print <<EOF;
<script>
function fmrichosen()
{
if ($self->{'add'} == 0) {
	top.opener.ifield.value = document.forms[0].fmri.value;
	}
else {
	if (top.opener.ifield.value != "") {
		top.opener.ifield.value += " ";
		}
	top.opener.ifield.value += document.forms[0].fmri.value;
	}
top.close();
}
</script>
EOF
	print "<table width=100%><tr><td>\n";
	print "<form onSubmit='fmrichosen(); return false'>\n";
	print
	 "<input name=fmri size=45 value=\"\">\n";
	print
	 "<input type=\"submit\" value=\"$self->{'text_hash'}->{'svc_chooser_ok'}\">\n";
	print "</form>\n";
	print "</td><td>\n";
	print "<form>";
	print
"<input type=\"button\" onClick='top.close()' value=\"$self->{'text_hash'}->{'svc_chooser_cancel'}\">";
	print "</form>";
	print "</td></tr></table></form>\n";
	$self->footer();
	}
1;
		
}


1;

