#!/usr/bin/perl
package software::AptLib;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'software::AptLib');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# apt-lib.pl
# Functions for installing packages from debian APT

$self->{'apt_get_command'} = $self->{'config_hash'}->{'apt_mode'} ? "aptitude" : "apt-get";
$self->{'apt_search_command'} = $self->{'config_hash'}->{'apt_mode'} ? "aptitude" : "apt-cache";

1;
		return $self;
}

# update_system_install([package])
# Install some package with apt
sub update_system_install
{
	my $self = shift;

local (@rv, @newpacks);
local $update = $_[0] || $self->{'in_hash'}->{'update'};
print "<b>",$self->text('apt_install', "<tt>$self->{'apt_get_command'} -y -f install $update</tt>"),"</b><p>\n";
print "<pre>";
$update = join(" ", map { quotemeta($_) } split(/\s+/, $update));
$self->additional_log('exec', undef, "$self->{'apt_get_command'} -y -f install $update");
$self->open_execute_command(*CMD, "$self->{'apt_get_command'} -y -f install $update 2>&1 </dev/null", 1);
while(<CMD>) {
	if (/setting\s+up\s+(\S+)/i && !/as\s+MDA/i) {
		push(@rv, $1);
		}
	elsif (/packages\s+will\s+be\s+upgraded/i ||
	       /new\s+packages\s+will\s+be\s+installed/i) {
		print;
		$self->{'line'} = $_ = <CMD>;
		$self->{'line'} =~ s/^\s+//; $self->{'line'} =~ s/\s+$//;
		push(@newpacks, split(/\s+/, $self->{'line'}));
		}
	print;
	}
close(CMD);
if (!@rv && $self->{'config_hash'}->{'package_system'} ne 'debian' && !$?) {
	# Other systems don't list the packages installed!
	@rv = @newpacks;
	}
print "</pre>\n";
if ($?) { print "<b>$self->{'text_hash'}->{'apt_failed'}</b><p>\n"; }
else { print "<b>$self->{'text_hash'}->{'apt_ok'}</b><p>\n"; }
return @rv;
}

# update_system_form()
# Shows a form for updating all packages on the system
sub update_system_form
{
	my $self = shift;

print "<form action=apt_upgrade.cgi>\n";
print "<table $self->{'cb'} width=100%>\n<tr $self->{'tb'}><td colspan=\"2\">";
print "<b>$self->{'text_hash'}->{'apt_form'}<b3>\n";

print "<tr><td>$self->{'text_hash'}->{'apt_update'}</td>\n";
print "<td><input type=radio name=update value=1 checked> $self->{'text_hash'}->{'yes'}\n";
print "<input type=radio name=update value=0> $self->{'text_hash'}->{'no'}</td></tr>\n";

print "<tr><td>$self->{'text_hash'}->{'apt_mode'}</td>\n";
print "<td><input type=radio name=mode value=2> $self->{'text_hash'}->{'apt_mode2'}\n";
print "<input type=radio name=mode value=1> $self->{'text_hash'}->{'apt_mode1'}\n";
print "<input type=radio name=mode value=0 checked> $self->{'text_hash'}->{'apt_mode0'}</td></tr>\n";

print "<tr><td>$self->{'text_hash'}->{'apt_sim'}</td>\n";
print "<td><input type=radio name=sim value=1> $self->{'text_hash'}->{'yes'}\n";
print "<input type=radio name=sim value=0 checked> $self->{'text_hash'}->{'no'}</td></tr>\n";

print "</table>\n";
print "<input type=submit value='$self->{'text_hash'}->{'apt_apply'}'></form>\n";
}

# update_system_resolve(name)
# Converts a standard package name like apache, sendmail or squid into
# the name used by APT.
sub update_system_resolve
{
	my $self = shift;

local ($name) = @_;
return $name eq "dhcpd" ? "dhcp3-server" :
       $name eq "bind" ? "bind9" :
       $name eq "mysql" ? "mysql-client mysql-server mysql-admin" :
       $name eq "apache" ? "apache2" :
       $name eq "postgresql" ? "postgresql postgresql-client" :
			       $name;
}

# update_system_available()
# Returns a list of package names and versions that are available from YUM
sub update_system_available
{
	my $self = shift;

local (@rv, $pkg);
$self->execute_command("$self->{'apt_get_command'} update");
$self->open_execute_command(*DUMP, "apt-cache dump", 1, 1);
while(<DUMP>) {
	if (/^\s*Package:\s*(\S+)/) {
		$pkg = { 'name' => $1 };
		push(@rv, $pkg);
		}
	elsif (/^\s*Version:\s*(\S+)/ && $pkg && !$pkg->{'version'}) {
		$pkg->{'version'} = $1;
		$pkg->{'version'} =~ s/^\d://;
		}
	}
close(DUMP);
return @rv;
}

# update_system_search(text)
# Returns a list of packages matching some search
sub update_system_search
{
	my $self = shift;

local (@rv, $pkg);
$self->open_execute_command(*DUMP, "$self->{'apt_search_command'} search ".quotemeta($_[0]), 1, 1);
while(<DUMP>) {
	if (/^(\S+)\s*-\s*(.*)/) {
		push(@rv, { 'name' => $1, 'desc' => $2 });
		}
	elsif (/^(\S)\s+(\S+)\s+-\s*(.*)/) {
		push(@rv, { 'name' => $2, 'desc' => $3 });
		}
	}
close(DUMP);
return @rv;
}


1;

