#!/usr/bin/perl
package software::CswLib;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'software::CswLib');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# csw-lib.pl
# Functions for installing packages from Blastwave

$self->{'pkg_get'} = -x "/opt/csw/bin/pkg-get" ? "/opt/csw/bin/pkg-get"
				     : $self->has_command("pkg-get");

1;
		return $self;
}

# update_system_install([file])
# Install some package with pkg-get
sub update_system_install
{
	my $self = shift;

local $update = $_[0] || $self->{'in_hash'}->{'update'};
local (@rv, @newpacks);
print "<b>",$self->text('csw_install', "<tt>$self->{'pkg_get'} -i $update</tt>"),"</b><p>\n";
$| = 1;
print "<pre>";
local ($ph, $ppid) = $self->foreign_call("proc", "pty_process_exec_logged",
				   "$self->{'pkg_get'} -i ".quotemeta($update));
while(1) {
	local $wf = $self->wait_for($ph, '(.*) \[\S+\]',
			     'Installation of <(.*)> failed',
			     'Installation of <(.*)> was successful',
			     'No changes were made to the system',
			     '.*\n', '.*\r');
	if ($self->{'wait_for_input'} !~ /^\s*\d+\%\s+\[/) {
		# Print everything except download line
		print $self->html_escape($self->{'wait_for_input'});
		}
	if ($wf == 0) {
		# some question which should not have appeared before
		if ($self->{'seen_hash'}->{$matches[1]}++) {
			$self->{'failed'}++;
			last;
			}
		$self->sysprint($ph, "y\n");
		}
	elsif ($wf == 1) {
		# This package contains scripts
		$self->{'failed'}++;
		last;
		}
	elsif ($wf == 1 || $wf == 3) {
		# failed for some reason.. give up
		$self->{'failed'}++;
		last;
		}
	elsif ($wf == 2) {
		# done ok!
		push(@rv, $matches[1]);
		}
	elsif ($wf == -1) {
		# No more output
		last;
		}
	}
print "</pre>";
close($ph);
if ($? || $self->{'failed'}) {
	print "<b>$self->{'text_hash'}->{'csw_failed'}</b><p>\n";
	return ( );
	}
else {
	print "<b>$self->{'text_hash'}->{'csw_ok'}</b><p>\n";
	return @rv;
	}
}

# update_system_available()
# Returns a list of all available CSW packages
sub update_system_available
{
	my $self = shift;

local @rv;
open(PKG, "$self->{'pkg_get'} -a |");
while(<PKG>) {
	s/\r|\n//g;
	s/#.*$//;
	next if (/^\s*WARNING:/);
	if (/^\s*(\S+)\s+(\S+)/) {
		push(@rv, { 'name' => $1, 'version' => $2,
			    'select' => "$1-$2" });
		}
	}
close(PKG);
return sort { lc($a->{'name'}) cmp lc($b->{'name'}) } @rv;
}


1;

