#!/usr/bin/perl
package software::Log_parser;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'software::Log_parser');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# log_parser.pl
# Functions for parsing this module's logs

&ModuleLoader::preload_module(ref($self), "software::SoftwareLib");
$self = new software::SoftwareLib:: ref($self), %$self; 

1;
		return $self;
}

# parse_webmin_log(user, script, action, type, object, &params)
# Converts logged information from this module into human-readable form
sub parse_webmin_log
{
	my $self = shift;

local ($user, $script, $action, $type, $object, $p, $long) = @_;
if ($action eq 'install') {
	return $self->text("log_install_package", "<tt>$object</tt>");
	}
elsif ($action eq 'apt') {
	local @p = split(/\0/, $p->{'packages'});
	return $self->text($long || @p < 2 ? "log_${type}_apt_l" : "log_${type}_apt",
		     "<tt>".join(" ",@p)."</tt>", scalar(@p));
	}
elsif ($action eq 'rhn') {
	local @p = @{$p->{'packages'}};
	return $self->text($long || @p < 2 ? "log_${type}_rhn_l" : "log_${type}_rhn",
		     "<tt>".join(" ",@p)."</tt>", scalar(@p));
	}
elsif ($action eq "yum") {
	local @p = @{$p->{'packages'}};
	return $self->text($long || @p < 2 ? "log_${type}_yum_l" : "log_${type}_yum",
		     "<tt>".join(" ",@p)."</tt>", scalar(@p));
	}
elsif ($action eq "urpmi") {
	return $self->{'text_hash'}->{'log_urpmi_'.$type};
	}
elsif ($action eq 'delete') {
	return $self->text('log_delete', "<tt>$object</tt>");
	}
elsif ($action eq 'deletes') {
	local @p = split(/\0/, $p->{'packs'});
	if ($long) {
		return $self->text('log_deletes_l', "<tt>".join(" ", @p)."</tt>");
		}
	else {
		return $self->text('log_deletes', scalar(@p));
		}
	}
else {
	return undef;
	}
}


1;

