#!/usr/bin/perl
package software::RhnLib;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'software::RhnLib');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# rhn-lib.pl
# Functions for installing packages from the redhat network

$self->{'up2date_config'} = "/etc/sysconfig/rhn/up2date";
$self->{'rhn_sysconfig'} = "/etc/sysconfig/rhn/rhnsd";

1;

1;
		return $self;
}

# update_system_install([package])
# Install some package with up2date
sub update_system_install
{
	my $self = shift;

local $update = $_[0] || $self->{'in_hash'}->{'update'};
local @rv;
print "<b>",$self->text('rhn_install', "<tt>up2date $update</tt>"),"</b><p>\n";
print "<pre>";
$self->additional_log('exec', undef, "up2date \"$update\"");
local $qm = quotemeta($update);
$self->open_execute_command(*CMD, "up2date $qm 2>&1", 1);
local $got_error = 0;
while(<CMD>) {
	while(s/^[^\015]+\015([^\012])/$1/) { }
	$got_error++ if (/error|failed/i);
	if (/installing.*\/([^\/\s]+)\-([^\-]+)\-([^\-]+)\.rpm/i) {
		push(@rv, $1);
		}
	print;
	}
close(CMD);
print "</pre>\n";
if ($got_error) {
	print "<b>$self->{'text_hash'}->{'rhn_failed'}</b><p>\n";
	@rv = ( );
	}
else {
	print "<b>$self->{'text_hash'}->{'rhn_ok'}</b><p>\n";
	}
return @rv;
}

# update_system_form()
# Show a form for configuring the redhat update agent
sub update_system_form
{
	my $self = shift;

print "<form action=rhn_check.cgi>\n";
print "<table $self->{'cb'} width=100%>\n<tr $self->{'tb'}><td colspan=\"2\">";
#print "<h3>$self->{'text_hash'}->{'rhn_form'}</h3>\n";
print "<b>$self->{'text_hash'}->{'rhn_form'}</b>\n";

$self->foreign_require("init", "init-lib.pl");
local $auto = $main::init_object->action_status("rhnsd");
print "<tr><td>$self->{'text_hash'}->{'rhn_auto'}</td>\n";
printf "<td><input type=radio name=auto value=1 %s> %s\n",
	$auto == 2 ? 'checked' : '', $self->{'text_hash'}->{'yes'};
printf "<input type=radio name=auto value=0 %s> %s</td> </tr>\n",
	$auto == 2 ? '' : 'checked', $self->{'text_hash'}->{'no'};

local %rhnsd;
$self->read_env_file($self->{'rhn_sysconfig'}, \%rhnsd);
print "<tr><td>$self->{'text_hash'}->{'rhn_interval'}</td>\n";
print "<td><input name=interval size=5 value='$rhnsd{'INTERVAL'}'> ",
      "$self->{'text_hash'}->{'rhn_secs'}</td> </tr>\n";

local $conf = $self->read_up2date_config();
print "<tr><td>$self->{'text_hash'}->{'rhn_proxy'}</td>\n";
printf "<td><input type=radio name=proxy_on value=0 %s> %s\n",
	$conf->{'enableProxy'}->{'value'} ? '' : 'checked', $self->{'text_hash'}->{'rhn_none'};
printf "<input type=radio name=proxy_on value=1 %s> %s\n",
	$conf->{'enableProxy'}->{'value'} ? 'checked' : '';
local $prx = $conf->{'pkgProxy'} ? $conf->{'pkgProxy'}->{'value'}
				 : $conf->{'httpProxy'}->{'value'};
printf "<input name=proxy size=40 value='%s'></td> </tr>\n", $prx;

print "<tr><td valign=top>$self->{'text_hash'}->{'rhn_skip'}</td>\n";
print "<td><textarea name=skip rows=3 cols=40>",
      join("\n", split(/;/, $conf->{'pkgSkipList'}->{'value'})),
      "</textarea></td> </tr>\n";

print "</table>\n";
print "<input type=submit value='$self->{'text_hash'}->{'rhn_apply'}'>\n";
print "<input type=submit name=now value='$self->{'text_hash'}->{'rhn_now'}'></form>\n";
}

# read_up2date_config()
sub read_up2date_config
{
	my $self = shift;

local %conf;
local $lnum = 0;
$self->open_readfile(*CONF, $self->{'up2date_config'});
while(<CONF>) {
	s/\r|\n//g; s/#.*$//;
	if (/^([^=\s]+)=(.*)$/) {
		$conf{$1} = { 'name' => $1,
			      'value' => $2,
			      'line' => $lnum };
		}
	$lnum++;
	}
close(CONF);
return \%conf;
}

# save_up2date_config(&config, name, value)
sub save_up2date_config
{
	my $self = shift;

local $lref = $self->read_file_lines($self->{'up2date_config'});
local $old = $_[0]->{$_[1]};
if ($old) {
	$lref->[$old->{'line'}] = "$_[1]=$_[2]";
	}
}

# update_system_available()
# Returns a list of packages available from RHN
sub update_system_available
{
	my $self = shift;

local @rv;
open(UP2DATE, "up2date -l --showall |");
while(<UP2DATE>) {
	s/\r|\n//g;
	if (/^(\S+)\-([^\-]+)\-([^\-]+)\.([^\.]+)$/) {
		push(@rv, { 'name' => $1,
			    'version' => "$2-$3",
			    'arch' => $4 });
		}
	}
close(UP2DATE);
return @rv;
}


1;

