#!/usr/bin/perl
package software::UrpmiLib;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'software::UrpmiLib');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# urpmi-lib.pl
# Functions for installing packages with Mandrake urpmi

1;
		return $self;
}

# update_system_install([package])
# Install some package with urpmi
sub update_system_install
{
	my $self = shift;

local $update = $_[0] || $self->{'in_hash'}->{'update'};
local (@rv, @newpacks);
local $cmd = "urpmi --force --auto --media main";
print "<b>",$self->text('urpmi_install', "<tt>$cmd $update</tt>"),"</b><p>\n";
print "<pre>";
$self->additional_log('exec', undef, "$cmd $update");
local $qm = join(" ", map { quotemeta($_) } split(/\s+/, $update));
$self->open_execute_command(*CMD, "$cmd $qm 2>&1 </dev/null", 1);
while(<CMD>) {
	s/\r|\n//g;
	if (/installing\s+(\S+)\s+from/) {
		# Found a package
		local $pkg = $1;
		$pkg =~ s/\-\d.*//;	# remove version
		push(@rv, $pkg);
		}
	print $self->html_escape($_."\n");
	}
close(CMD);
print "</pre>\n";
if ($?) {
	print "<b>$self->{'text_hash'}->{'urpmi_failed'}</b><p>\n";
	return ( );
	}
else {
	print "<b>$self->{'text_hash'}->{'urpmi_ok'}</b><p>\n";
	return $self->unique(@rv);
	}
}

# update_system_form()
# Shows a form for updating all packages on the system
sub update_system_form
{
	my $self = shift;

print $self->ui_subheading($self->{'text_hash'}->{'urpmi_form'});
print $self->ui_form_start("urpmi_upgrade.cgi");
print $self->ui_submit($self->{'text_hash'}->{'urpmi_update'}, "update"),"<br>\n";
print $self->ui_submit($self->{'text_hash'}->{'urpmi_upgrade'}, "upgrade"),"<br>\n";
print $self->ui_form_end();
}

# update_system_resolve(name)
# Converts a standard package name like apache, sendmail or squid into
# the name used by YUM.
sub update_system_resolve
{
	my $self = shift;

local ($name) = @_;
return $name eq "apache" ? "apache2" :
       $name eq "dhcpd" ? "dhcp-server" :
       $name eq "mysql" ? "MySQL MySQL-client MySQL-common" :
       $name eq "postgresql" ? "postgresql postgresql-server" :
			   $name;
}

# update_system_available()
# Returns a list of package names and versions that are available from URPMI
sub update_system_available
{
	my $self = shift;

local @rv;
local %done;
$self->open_execute_command(*PKG, "urpmq -f --list", 1, 1);
while(<PKG>) {
	if (/^(\S+)\-(\d[^\-]*)\-([^\.]+)\.(\S+)/) {
		next if ($done{$1,$2}++);
		push(@rv, { 'name' => $1,
			    'version' => $2,
			    'release' => $3,
			    'arch' => $4 });
		}
	}
close(PKG);
return @rv;
}


1;

