#!/usr/bin/perl

&MAIN();

 sub MAIN {
# apt_upgrade.cgi
# Upgrade a debian system

&ModuleLoader::preload_module('software_class', "software::SoftwareLib");
$self = new software::SoftwareLib:: 'software_class',%$self;

$self->ReadParse();

$self->ui_print_unbuffered_header(undef, $self->{'text_hash'}->{'apt_upgrade'}, "");

if ($self->{'in_hash'}->{'update'}) {
	print "<b>",$self->text('apt_updatedesc',
			  "<tt>$self->{'apt_get_command'} update</tt>"),"</b><p>\n";
	print "<pre>";
	$self->additional_log("exec", undef, "$self->{'apt_get_command'} update");
	$self->clean_environment();
	open(CMD, "$self->{'apt_get_command'} update 2>&1 </dev/null |");
	while(<CMD>) {
		print;
		}
	close(CMD);
	$self->reset_environment();
	print "</pre>\n";
	if ($?) {
		print "<b>$self->{'text_hash'}->{'apt_updatefailed'}</b><p>\n";
		$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
		exit;
		}
	else { print "<b>$self->{'text_hash'}->{'apt_updateok'}</b><p>\n"; }
	}

if ($self->{'in_hash'}->{'mode'}) {
	$self->{'opts'} = $self->{'in_hash'}->{'sim'} ? "-s -y -f" : "-y -f";
	$self->{'cmd'} = $self->{'in_hash'}->{'mode'} == 2 ? "dist-upgrade" : "upgrade";
	print "<b>",$self->text($self->{'in_hash'}->{'sim'} ? 'apt_upgradedescsim' : 'apt_upgradedesc', "<tt>$self->{'apt_get_command'} $self->{'opts'} $self->{'cmd'}</tt>"),"</b><p>\n";
	print "<pre>";
	$self->additional_log("exec", undef, "$self->{'apt_get_command'} $self->{'opts'} $self->{'cmd'}");
	$self->clean_environment();
	open(CMD, "$self->{'apt_get_command'} $self->{'opts'} $self->{'cmd'} 2>&1 </dev/null |");
	while(<CMD>) {
		if (/setting\s+up\s+(\S+)/i) {
			push(@{$self->{'packs_array'}}, $1);
			}
		elsif (/packages\s+will\s+be\s+upgraded/i ||
		       /new\s+packages\s+will\s+be\s+installed/i) {
			print;
			$self->{'line'} = $_ = <CMD>;
			$self->{'line'} =~ s/^\s+//; $self->{'line'} =~ s/\s+$//;
			push(@{$self->{'newpacks_array'}}, split(/\s+/, $self->{'line'}));
			}
		print;
		}
	close(CMD);
	$self->reset_environment();
	if (!@{$self->{'rv_array'}} && $self->{'config_hash'}->{'package_system'} ne 'debian' && !$?) {
		# Other systems don't list the packages installed!
		@{$self->{'packs_array'}} = @{$self->{'newpacks_array'}};
		}
	print "</pre>\n";
	if ($?) { print "<b>$self->{'text_hash'}->{'apt_upgradefailed'}</b><p>\n"; }
	else { print "<b>$self->{'text_hash'}->{'apt_upgradeok'}</b><p>\n"; }

	foreach $p (@{$self->{'packs_array'}}) {
		local @pinfo = $self->show_package_info($p);
		}
	$self->webmin_log("apt", "check", undef, { 'packages' => \@{$self->{'packs_array'}} })
		if (@{$self->{'packs_array'}});
	}

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

