#!/usr/bin/perl

&MAIN();

 sub MAIN {
# do_install.cgi
# Do the actual installation of a package from a file

&ModuleLoader::preload_module('software_class', "software::SoftwareLib");
$self = new software::SoftwareLib:: 'software_class',%$self;

$self->ReadParse();
$self->error_setup($self->text('do_err', $self->{'in_hash'}->{'package'}));

if ($self->{'show_install_progress'}) {
	$self->ui_print_unbuffered_header(undef, $self->{'text_hash'}->{'do_title'}, "");
	}
else {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'do_title'}, "");
	}

@{$self->{'packages_array'}} = $self->file_packages($self->{'in_hash'}->{'file'});
if ($self->UNIVERSAL::can('install_packages') && @{$self->{'packages_array'}} > 1) {
	# Can install everything in one hit
	$self->clean_environment();
	$self->{'error'} = $self->install_packages($self->{'in_hash'}->{'file'}, \%{$self->{'in_hash'}});
	$self->reset_environment();
	if ($self->{'error'}) { &install_error($self->{'error'}); }
	if ($self->{'in_hash'}->{'need_unlink'}) { $self->unlink_file($self->{'in_hash'}->{'file'}); }

	foreach $p (@{$self->{'packages_array'}}) {
		# display information
		($self->{'package'}, $self->{'desc'}) = split(/\s+/, $p, 2);
		@{$self->{'pinfo_array'}} = $self->show_package_info($self->{'package'});
		print "<table border width=100%>\n";
		print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'do_files'}</b></td> </tr>\n";
		print "<tr $self->{'cb'}> <td><table width=100%>\n";
		$self->{'n'} = $self->check_files($self->{'package'});
		for($i=0; $i<$self->{'n'}; $i++) {
			if ($i%2 == 0) { print "<tr>\n"; }
			print "<td width=50%>",
				$self->html_escape($self->{'files_hash'}->{$i,'path'}),"</td>\n";
			if ($i%2 == 1) { print "</tr>\n"; }
			}
		print "</table></td></tr></table><p>\n";
		$self->list_packages($self->{'package'});
		$self->webmin_log('install', 'package', $self->{'package'},
			    { 'desc' => $self->{'packages_hash'}->{0,'desc'},
			      'class' => $self->{'packages_hash'}->{0,'class'} });
		}
	}
else {
	# Must install and show one by one
	foreach $p (@{$self->{'packages_array'}}) {
		# attempt to install
		print "<hr>\n" if ($p ne $self->{'packages_array'}->[0]);
		($self->{'package'}, $self->{'desc'}) = split(/\s+/, $p, 2);
		$self->clean_environment();
		if ($self->{'show_install_progress'}) {
			print "<pre>\n";
			$self->{'error'} = $self->install_package(
				$self->{'in_hash'}->{'file'}, $self->html_escape($self->{'package'}), \%{$self->{'in_hash'}}, 1);
			print "</pre>\n";
			}
		else {
			$self->{'error'} = $self->install_package(
				$self->{'in_hash'}->{'file'}, $self->html_escape($self->{'package'}), \%{$self->{'in_hash'}});
			}
		$self->reset_environment();
		if ($self->{'error'}) { &install_error($self->{'error'}); }
		if ($self->{'in_hash'}->{'need_unlink'}) { $self->unlink_file($self->{'in_hash'}->{'file'}); }

		# display information
		@{$self->{'pinfo_array'}} = $self->show_package_info($self->{'package'});

		# Show files in package, if possible
		$self->{'n'} = $self->check_files($self->{'package'});
		if ($self->{'n'}) {
			print "<table border width=100%>\n";
			print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'do_files'}</b></td> </tr>\n";
			print "<tr $self->{'cb'}> <td><table width=100%>\n";
			for($i=0; $i<$self->{'n'}; $i++) {
				if ($i%2 == 0) { print "<tr>\n"; }
				print "<td width=50%>",
				    $self->html_escape($self->{'files_hash'}->{$i,'path'}),"</td>\n";
				if ($i%2 == 1) { print "</tr>\n"; }
				}
			print "</table></td></tr></table><p>\n";
			}
		$self->list_packages($self->{'package'});
		$self->webmin_log('install', 'package', $self->{'package'},
			    { 'desc' => $self->{'packages_hash'}->{0,'desc'},
			      'class' => $self->{'packages_hash'}->{0,'class'} });
		}
	}

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}

sub install_error
{
	shift if ($self == $_[0]);

print "<b>",$self->text('do_efailed', $self->{'error'}),"</b><p>\n";
print $self->{'text_hash'}->{'do_efailedmsg1'},"<p>\n";
if ($self->{'in_hash'}->{'need_unlink'}) {
	print $self->text('do_efailedmsg2',
		"delete_file.cgi?file=".
		$self->urlize($self->{'in_hash'}->{'file'})),"<p>\n";
	}
print "<hr>\n";
$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
exit;
}


1;

