#!/usr/bin/perl

&MAIN();

 sub MAIN {
# file_info.cgi
# Display information about a file owned by the package management system

&ModuleLoader::preload_module('software_class', "software::SoftwareLib");
$self = new software::SoftwareLib:: 'software_class',%$self;

$self->ReadParse();
$self->{'f'} = $self->{'in_hash'}->{'file'};
$self->ui_print_header(undef, $self->{'text_hash'}->{'file_title'}, "", "file_info");

$self->{'f'} =~ s/\/$//;
if ($self->{'f'} !~ /^\//) {
	# if the filename is not absolute, look for it
	foreach $p (split(/:/, $ENV{'PATH'})) {
		last if ($self->installed_file("$p/$self->{'f'}"));
		}
	}
else {
	# absolute path.. must exist in DB
	$self->installed_file($self->{'f'});
	}

if (!%{$self->{'file_hash'}}) {
	print "<b>",$self->text('file_notfound', "<tt>$self->{'f'}</tt>"),"</b><p>\n";
	}
else {
	# display file info
	$self->{'nc'} = "width=10% nowrap";
	print "<table border width=100%>\n";
	print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'file_title'}</b></td> </tr>\n";
	print "<tr $self->{'cb'}> <td><table width=100%>\n";

	print "<tr> <td $self->{'nc'}><b>$self->{'text_hash'}->{'file_path'}</b></td>\n";
	print "<td colspan=3><font size=+1>$self->{'file_hash'}->{'path'}</font></td> </tr>\n";

	print "<tr> <td $self->{'nc'}><b>$self->{'text_hash'}->{'file_type'}</b></td>\n";
	print "<td>$self->{'type_map_array'}->[$self->{'file_hash'}->{'type'}]</td>\n";

	if ($self->{'file_hash'}->{'type'} != 3 && $self->{'file_hash'}->{'type'} != 4) {
		print "<td $self->{'nc'}><b>$self->{'text_hash'}->{'file_perms'}</b></td>\n";
		print "<td>$self->{'file_hash'}->{'mode'}</td> </tr>\n";

		print "<tr> <td $self->{'nc'}><b>$self->{'text_hash'}->{'file_owner'}</b></td>\n";
		print "<td>$self->{'file_hash'}->{'user'}</td>\n";
		print "<td $self->{'nc'}><b>$self->{'text_hash'}->{'file_group'}</b></td>\n";
		print "<td>$self->{'file_hash'}->{'group'}</td> </tr>\n";

		if ($self->{'file_hash'}->{'type'} == 0) {
			print "<tr> <td $self->{'nc'}><b>$self->{'text_hash'}->{'file_size'}</b></td>\n";
			print "<td>$self->{'file_hash'}->{'size'}</td> </tr>\n";
			}
		}
	else {
		print "<td $self->{'nc'}><b>$self->{'text_hash'}->{'file_link'}</b></td>\n";
		print "<td>$self->{'file_hash'}->{'link'}</td> </tr>\n";
		}
	print "</table></tr> </tr></table><p>\n";

	# Show packages containing the file (usually only one)
	print $self->ui_columns_start([ $self->{'text_hash'}->{'file_pack'},
				  $self->{'text_hash'}->{'file_class'},
				  $self->{'text_hash'}->{'file_desc'} ], 100);
	@{$self->{'pkgs_array'}} = split(/\s+/, $self->{'file_hash'}->{'packages'});
	@{$self->{'vers_array'}} = split(/\s+/, $self->{'file_hash'}->{'versions'});
	$self->{'n'} = $self->list_packages(@{$self->{'pkgs_array'}});
	for($j=0; $j<@{$self->{'pkgs_array'}}; $j++) {
		for($i=0; $i<$self->{'n'}; $i++) {
			next if ($self->{'vers_array'}->[$i] &&
				 $self->{'packages_hash'}->{$i,'version'} ne $self->{'vers_array'}->[$j] ||
				 $self->{'packages_hash'}->{$i,'name'} ne $self->{'pkgs_array'}->[$j]);
			local @cols;
			push(@cols, "<a href=\"edit_pack.cgi?package=".
			      $self->urlize($self->{'pkgs_array'}->[$j])."&version=".$self->urlize($self->{'vers_array'}->[$j]).
			      "\">$self->{'pkgs_array'}->[$j]</a>");
			$self->{'c'} = $self->{'packages_hash'}->{$i,'class'};
			push(@cols, $self->{'c'} || $self->{'text_hash'}->{'file_none'});
			push(@cols, $self->{'packages_hash'}->{$i,'desc'});
			print $self->ui_columns_row(\@cols);
			}
		}
	print $self->ui_columns_end();
	}

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

