#!/usr/bin/perl

&MAIN();

 sub MAIN {
# rhn_check.cgi
# Save redhat network checking options

&ModuleLoader::preload_module('software_class', "software::SoftwareLib");
$self = new software::SoftwareLib:: 'software_class',%$self;

$self->ReadParse();
$self->foreign_require("init", "init-lib.pl");
$self->error_setup($self->{'text_hash'}->{'rhn_err'});
$self->{'conf'} = $self->read_up2date_config();

# Validate inputs
$self->{'in_hash'}->{'interval'} =~ /^\d+$/ || $self->error($self->{'text_hash'}->{'rhn_einterval'});
$self->{'in_hash'}->{'interval'} >= 120 || $self->error($self->{'text_hash'}->{'rhn_einterval2'});
!$self->{'in_hash'}->{'proxy_on'} && $self->{'in_hash'}->{'proxy'} eq '' ||
	$self->{'in_hash'}->{'proxy'} =~ /^http:\/\/\S+$/ || $self->error($self->{'text_hash'}->{'rhn_eproxy'});
@{$self->{'skip_array'}} = split(/\s+/, $self->{'in_hash'}->{'skip'});

# Save and apply
$self->save_up2date_config($self->{'conf'}, "enableProxy", $self->{'in_hash'}->{'proxy_on'});
$self->save_up2date_config($self->{'conf'}, $self->{'conf'}->{'pkgProxy[comment]'} ? "pkgProxy" : "httpProxy", $self->{'in_hash'}->{'proxy'});
$self->save_up2date_config($self->{'conf'}, "pkgSkipList", join(";", @{$self->{'skip_array'}}).";");
$self->flush_file_lines();
$self->read_env_file($self->{'rhn_sysconfig'}, \%{$self->{'rhnsd_hash'}});
$self->{'rhnsd_hash'}->{'INTERVAL'} = $self->{'in_hash'}->{'interval'};
$self->write_env_file($self->{'rhn_sysconfig'}, \%{$self->{'rhnsd_hash'}});
if ($self->{'in_hash'}->{'auto'}) {
	$main::init_object->enable_at_boot("rhnsd");
	}
else {
	$main::init_object->disable_at_boot("rhnsd");
	}
local $init = $main::init_object->action_filename("rhnsd");
$self->system_logged("$init stop >/dev/null 2>&1");
if ($self->{'in_hash'}->{'auto'}) {
	$self->system_logged("$init start >/dev/null 2>&1");
	}

if ($self->{'in_hash'}->{'now'}) {
	# Run rhn_check now ..
	$self->ui_print_unbuffered_header(undef, $self->{'text_hash'}->{'rhn_check'}, "");

	print "<b>",$self->text('rhn_checkdesc', "<tt>up2date -u</tt>"),"</b><p>\n";
	print "<pre>";
	$self->additional_log('exec', undef, "rhn_check");
	open(CMD, "up2date -u 2>&1 |");
	while(<CMD>) {
		while(s/^[^\015]+\015([^\012])/$1/) { }
		if (/\/([^\/\s]+)\-([^\-]+)\-([^\-]+)\.rpm/i) {
			push(@{$self->{'packs_array'}}, $1);
			}
		print;
		}
	close(CMD);
	print "</pre>\n";

	@{$self->{'packs_array'}} || print "<b>$self->{'text_hash'}->{'rhn_nocheck'}</b><p>\n";
	foreach $p (@{$self->{'packs_array'}}) {
		local @pinfo = $self->show_package_info($p);
		}
	$self->webmin_log("rhn", "check", undef, { 'packages' => \@{$self->{'packs_array'}} })
		if (@{$self->{'packs_array'}});

	$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
	}
else {
	$self->redirect("");
	}

1;
		
}


1;

