#!/usr/bin/perl

&MAIN();

 sub MAIN {
# rpmfind.cgi
# Display a search window for rpmfind.net

&ModuleLoader::preload_module('software_class', "software::SoftwareLib");
$self = new software::SoftwareLib:: 'software_class',%$self;

$self->ReadParse();

$self->{'rpmfind_host'} = "rpmfind.net";
$self->{'rpmfind_port'} = 80;
$self->{'rpmfind_page'} = "/linux/rpm2html/search.php?query=";

$self->header();
print <<EOF;
<script>
function sel(m)
{
window.opener.ifield.value = m;
window.close();
return false;
}
</script>
EOF

print "<form action=rpmfind.cgi>\n";
print "<input type=submit value='$self->{'text_hash'}->{'rpm_search'}'>\n";
print "<input name=search size=20 value='$self->{'in_hash'}->{'search'}'><br>\n";
print "</form><hr>\n";

if ($self->{'in_hash'}->{'search'}) {
	# Call the rpmfind.net website
	local $temp = $self->transname();
	$self->http_download($self->{'rpmfind_host'}, $self->{'rpmfind_port'},
		       $self->{'rpmfind_page'}.$self->urlize($self->{'in_hash'}->{'search'}), $temp);
	local $out = `cat $temp`;
	unlink($temp);
	while($out =~ /<tr[^>]*>.*?<td[^>]*>([^<]*)<\/td>.*?<td[^>]*>([^<]*)<\/td>.*?((ftp|http|https):[^>]+\.rpm).*?<\/tr>([\000-\377]*)/i) {
		local $pkg = { 'url' => $3,
			       'dist' => $2,
			       'desc' => $1 };
		$out = $5;
		$pkg->{'source'}++ if ($pkg->{'url'} =~ /\.src\.rpm$/ ||
				       $pkg->{'url'} =~ /\.srpm$/);
		if ($pkg->{'url'} =~ /\/(([^\/]+)-([^\-\/]+)-([^-\/]+).([^-\/]+)\.rpm)$/) {
			$pkg->{'file'} = $1;
			$pkg->{'prefix'} = $2;
			$pkg->{'version'} = $3;
			$pkg->{'release'} = $4;
			$pkg->{'arch'} = $5;
			if ($pkg->{'version'} =~ /^(\d+)\.([0-9\.]+)$/){
				local ($v1 = $1, $v2 = $2);
				$v2 =~ s/\.//g;
				$pkg->{'version'} = "$v1.$v2";
				}
			}
		elsif ($pkg->{'file'} =~ /\/([^\/]+)$/) {
			$pkg->{'file'} = $1;
			}
		push(@{$self->{'rv_array'}}, $pkg);
		}

	@{$self->{'rv_array'}} = grep { !$_->{'source'} } @{$self->{'rv_array'}};
	@{$self->{'rv_array'}} = sort { local $vc = $b->{'version'} <=> $a->{'version'};
		     local $rc = $b->{'version'} <=> $a->{'version'};
		     return $vc ? $vc : $rc } @{$self->{'rv_array'}};
	if (@{$self->{'rv_array'}}) {
		print "<table width=100%>\n";
		foreach $r (@{$self->{'rv_array'}}) {
			print "<tr>\n";
			print "<td><a href='' onClick='sel(\"$r->{'url'}\")'>",
			      "$r->{'file'}</a></td>\n";
			print "<td>$r->{'dist'}</td>\n";
			print "<td>$r->{'desc'}</td>\n";
			print "</tr>\n";
			}
		print "</table>\n";
		}
	else {
		print "<b>$self->{'text_hash'}->{'rpm_none'}</b> <p>\n";
		}
	}

$self->ui_print_footer();

1;
		
}


1;

