#!/usr/bin/perl

&MAIN();

 sub MAIN {
# tree.cgi
# Display the package tree

&ModuleLoader::preload_module('software_class', "software::SoftwareLib");
$self = new software::SoftwareLib:: 'software_class',%$self;

$self->ui_print_header(undef, $self->{'text_hash'}->{'index_tree'}, "");

$self->{'spacer'} = "&nbsp;"x3;

# work out the package heirarchy..
$self->{'n'} = $self->list_packages();
for($i=0; $i<$self->{'n'}; $i++) {
	push(@{$self->{'pack_array'}}, $self->{'packages_hash'}->{$i,'name'});
	push(@{$self->{'vers_array'}}, $self->{'packages_hash'}->{$i,'version'});
	push(@{$self->{'class_array'}}, $self->{'packages_hash'}->{$i,'class'});
	push(@{$self->{'desc_array'}}, $self->{'packages_hash'}->{$i,'desc'});
	}
@{$self->{'order_array'}} = sort { lc($self->{'pack_array'}->[$a]) cmp lc($self->{'pack_array'}->[$b]) } (0 .. $self->{'n'}-1);
$self->{'heir_hash'}->{""} = "";
foreach $c (sort { $a cmp $b } $self->unique(@{$self->{'class_array'}})) {
	if (!$c) { next; }
	@{$self->{'w_array'}} = split(/\//, $c);
	$self->{'p'} = join('/', @{$self->{'w_array'}}[0..$#{$self->{'w_array'}}-1]);		# parent class
	if (!defined($self->{'heir_hash'}->{$self->{'p'}})) {
		$self->{'pp'} = join('/', @{$self->{'w_array'}}[0..$#{$self->{'w_array'}}-2]);	# grandparent class
		$self->{'heir_hash'}->{$self->{'pp'}} .= "$self->{'p'}\0";
		$self->{'ppp'} = join('/', @{$self->{'w_array'}}[0..$#{$self->{'w_array'}}-3]);	# great-grandparent class
		if ($self->{'ppp'} || 1) {
			$self->{'heir_hash'}->{$self->{'ppp'}} .= "$self->{'pp'}\0";
			}
		}
	$self->{'heir_hash'}->{$self->{'p'}} .= "$c\0";
	$self->{'hasclasses'}++;
	}

# get the current open list
%{$self->{'heiropen_hash'}} = map { $_, 1 } $self->get_heiropen();
$self->{'heiropen_hash'}->{""} = 1;

# traverse the heirarchy
print "<table width=100%>\n";
&traverse("", 0);
print "</table>\n";
if ($self->{'hasclasses'}) {
	print "<a href=closeall.cgi>$self->{'text_hash'}->{'index_close'}</a>\n";
	print "<a href=openall.cgi>$self->{'text_hash'}->{'index_open'}</a><p>\n";
	}

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}

sub traverse
{
	shift if ($self == $_[0]);

local($s, $act, $i);

# Show the icon and class name
print "<tr> <td>", $self->{'spacer'} x $_[1];
if ($_[0]) {
	print "<a name=\"$_[0]\"></a>\n";
	$act = $self->{'heiropen_hash'}->{$_[0]} ? "close" : "open";
	print "<a href=\"$act.cgi?what=",$self->urlize($_[0]),"\">";
	$_[0] =~ /([^\/]+)$/;
	print "<img border=0 src=images/$act.gif></a>&nbsp; $1</td>\n";
	}
else {
	print "<img src=images/close.gif> <i>$self->{'text_hash'}->{'index_all'}</i></td>\n";
	}

print "<td><br></td> </tr>\n";
if ($self->{'heiropen_hash'}->{$_[0]}) {
	# print packages followed by sub-folders
	foreach $i (@{$self->{'order_array'}}) {
		if ($self->{'class_array'}->[$i] eq $_[0]) {
			print "<tr> <td nowrap>", $self->{'spacer'} x ($_[1]+1);
			print "<img border=0 src=images/pack.gif></a>&nbsp;\n";
			print "<a href=\"edit_pack.cgi?package=",
			      $self->urlize($self->{'pack_array'}->[$i]),"&version=",
			      $self->urlize($self->{'vers_array'}->[$i]),"\">",$self->html_escape($self->{'pack_array'}->[$i].
			      ($self->{'vers_array'}->[$i] ? " $self->{'vers_array'}->[$i]" : "")),"</a></td>\n";
			print "<td>",$self->html_escape($self->{'desc_array'}->[$i]),"</td>\n";
			print "</tr>\n";
			}
		}
	foreach $s ($self->unique(split(/\0+/, $self->{'heir_hash'}->{$_[0]}))) {
		&traverse($s, $_[1]+1);
		}
	}
}


1;

