#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_report.cgi
# Display a form for editing the spam report text

&ModuleLoader::preload_module('spam_class', "spam::SpamLib");
$self = new spam::SpamLib:: 'spam_class',%$self;

$self->can_use_check("report");
$self->ui_print_header(undef, $self->{'text_hash'}->{'report_title'}, "");
$self->{'conf'} = $self->get_config();

print "$self->{'text_hash'}->{'report_desc'}<p>\n";
$self->start_form("save_report.cgi", $self->{'text_hash'}->{'report_header'});

if ($self->version_atleast(3.0)) {
	# New version can replace subject, from and to headers
	@{$self->{'rheader_array'}} = $self->find("rewrite_header", $self->{'conf'});
	foreach $h ("subject", "from", "to") {
		print "<tr> <td><b>",$self->{'text_hash'}->{'report_r'.$h},
		      "</b></td> <td nowrap>";
		($self->{'hn'}) = grep { lc($_->{'words'}->[0]) eq $h } @{$self->{'rheader_array'}};
		$self->opt_field("rewrite_header_${h}",
			   $self->{'hn'} ? join(" ", @{$self->{'hn'}->{'words'}}[1..@{$self->{'hn'}->{'words'}}-1]) : undef, 15);
		}
	}
else {
	# Older versions can only replace subject header
	print "<tr> <td><b>$self->{'text_hash'}->{'report_rewrite'}</b></td> <td nowrap>";
	$self->{'rewrite'} = $self->find("rewrite_subject", $self->{'conf'});
	$self->yes_no_field("rewrite_subject", $self->{'rewrite'}, 1);
	print "</td> </tr>\n";

	print "<tr> <td><b>$self->{'text_hash'}->{'report_subject'}</b></td> <td nowrap>";
	$self->{'subject'} = $self->find("subject_tag", $self->{'conf'});
	$self->opt_field("subject_tag", $self->{'subject'}, 15, "*****SPAM*****");
	print "</td> </tr>\n";
	}

print "<tr> <td><b>$self->{'text_hash'}->{'report_rheader'}</b></td> <td nowrap>";
$header = $self->find("report_header", $self->{'conf'});
$self->yes_no_field("report_header", $header, 0);
print "</td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'report_useterse'}</b></td> <td nowrap>";
$self->{'terse'} = $self->find("use_terse_report", $self->{'conf'});
$self->yes_no_field("use_terse_report", $self->{'terse'}, 0);
print "</td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'report_fold'}</b></td> <td nowrap>";
$self->{'fold'} = $self->find("fold_headers", $self->{'conf'});
$self->yes_no_field("fold_headers", $self->{'fold'}, 1);
print "</td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'report_detail'}</b></td> <td nowrap>";
$self->{'detail'} = $self->find("detailed_phrase_score", $self->{'conf'});
$self->yes_no_field("detailed_phrase_score", $self->{'detail'}, 0);
print "</td> </tr>\n";

if (!$self->version_atleast(3.0)) {
	print "<tr> <td><b>$self->{'text_hash'}->{'report_stars'}</b></td> <td nowrap>";
	$self->{'stars'} = $self->find("spam_level_stars", $self->{'conf'});
	$self->yes_no_field("spam_level_stars", $self->{'stars'}, 1);
	print "</td> </tr>\n";
	}

print "<tr> <td><b>$self->{'text_hash'}->{'report_char'}</b></td> <td nowrap>";
$self->{'char'} = $self->find("spam_level_char", $self->{'conf'});
$self->opt_field("spam_level_char", $self->{'char'}, 2, "*");
print "</td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'report_defang'}</b></td> <td nowrap>";
$self->{'defang'} = $self->find("defang_mime", $self->{'conf'});
$self->yes_no_field("defang_mime", $self->{'defang'}, 1);
print "</td> </tr>\n";

if ($self->version_atleast(2.6)) {
	print "<tr> <td><b>$self->{'text_hash'}->{'report_safe'}</b></td> <td nowrap>";
	$self->{'safe'} = $self->find("report_safe", $self->{'conf'});
	#$self->yes_no_field("report_safe", $self->{'safe'}, 0);
	$self->option_field("report_safe", $self->{'safe'}, 1,
		      [ [ 0, $self->{'text_hash'}->{'no'} ],
			[ 1, $self->{'text_hash'}->{'yes'} ],
			[ 2, $self->{'text_hash'}->{'report_safe2'} ] ]);
	print "</td> </tr>\n";
	}

if ($self->version_atleast(3)) {
	print "<tr> <td colspan=4><hr></td> </tr>\n";
	print "<tr> <td colspan=2><b>$self->{'text_hash'}->{'report_adds'}</b></td> </tr>\n";
	print "<tr> <td colspan=2>\n";
	print $self->ui_columns_start([ $self->{'text_hash'}->{'report_addfor'},
				  $self->{'text_hash'}->{'report_addheader'},
				  $self->{'text_hash'}->{'report_addtext'} ]);
	$self->{'i'} = 0;
	foreach $a ($self->find_value("add_header", $self->{'conf'}), undef) {
		local ($for, $header, $text) = split(/\s+/, $a, 3);
		print $self->ui_columns_row([
			$self->ui_select("addfor_$self->{'i'}", $for,
				   [ [ "", "&nbsp;" ],
				     map { [ $_, $self->{'text_hash'}->{'report_add'.$_} ] }
					 ( "spam", "ham", "all" ) ]),
			$self->ui_textbox("addheader_$self->{'i'}", $header, 30),
			$self->ui_textbox("addtext_$self->{'i'}", $text, 50)
				]);
		$self->{'i'}++;
		}
	print $self->ui_columns_end();
	print "</td> </tr>\n";
	}

print "<tr> <td colspan=4><hr></td> </tr>\n";

@{$self->{'report_array'}} = $self->find_value("report", $self->{'conf'});
$self->{'clear'} = $self->find("clear_report_template", $self->{'conf'});
print "<tr> <td colspan=2><b>$self->{'text_hash'}->{'report_report'}</b></td> </tr>\n";
printf "<tr> <td colspan=2><input type=radio name=clear_report value=0 %s> %s\n",
	$self->{'clear'} ? "" : "checked", $self->{'text_hash'}->{'report_noclear'};
printf "<input type=radio name=clear_report value=1 %s> %s<br>\n",
	$self->{'clear'} ? "checked" : "", $self->{'text_hash'}->{'report_clear'};
print "<textarea name=report rows=5 cols=80>",
      join("\n", @{$self->{'report_array'}}),"</textarea></td> </tr>\n";

@{$self->{'report_array'}} = $self->find_value("terse_report", $self->{'conf'});
$self->{'clear'} = $self->find("clear_terse_report_template", $self->{'conf'});
print "<tr> <td colspan=2><b>$self->{'text_hash'}->{'report_terse'}</b></td> </tr>\n";
printf "<tr> <td colspan=2><input type=radio name=clear_terse value=0 %s> %s\n",
	$self->{'clear'} ? "" : "checked", $self->{'text_hash'}->{'report_noclear'};
printf "<input type=radio name=clear_terse value=1 %s> %s<br>\n",
	$self->{'clear'} ? "checked" : "", $self->{'text_hash'}->{'report_clear'};
print "<textarea name=terse rows=5 cols=80>",
      join("\n", @{$self->{'report_array'}}),"</textarea></td> </tr>\n";

print "</tr>\n";

$self->end_form(undef, $self->{'text_hash'}->{'save'});
$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

