#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_score.cgi
# Display a form for editing spam scoring options

&ModuleLoader::preload_module('spam_class', "spam::SpamLib");
$self = new spam::SpamLib:: 'spam_class',%$self;

$self->can_use_check("score");
$self->ui_print_header(undef, $self->{'text_hash'}->{'score_title'}, "");
$self->{'conf'} = $self->get_config();

print "$self->{'text_hash'}->{'score_desc'}<p>\n";
$self->start_form("save_score.cgi", $self->{'text_hash'}->{'score_header'});

$self->{'hits_param'} = $self->version_atleast(3.0) ? "required_score" : "required_hits";
print "<tr> <td><b>$self->{'text_hash'}->{'score_hits'}</b></td> <td nowrap colspan=2>";
$self->{'hits'} = $self->find($self->{'hits_param'}, $self->{'conf'});
$self->opt_field($self->{'hits_param'}, $self->{'hits'}, 5, "5");
print "</td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'score_auto'}</b></td> <td nowrap colspan=2>";
$self->{'auto'} = $self->find("auto_whitelist_factor", $self->{'conf'});
$self->opt_field("auto_whitelist_factor", $self->{'auto'}, 5, "0.5");
print "</td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'score_bayes'}</b></td> <td nowrap colspan=2>";
$self->{'bayes'} = $self->find("use_bayes", $self->{'conf'});
$self->yes_no_field("use_bayes", $self->{'bayes'}, 1);
print "</td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'score_mx'}</b></td> <td nowrap colspan=2>";
$self->{'mx'} = $self->find("check_mx_attempts", $self->{'conf'});
$self->opt_field("check_mx_attempts", $self->{'mx'}, 4, "2");
print "</td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'score_mxdelay'}</b></td> <td nowrap colspan=2>";
$self->{'mxdelay'} = $self->find("check_mx_delay", $self->{'conf'});
$self->opt_field("check_mx_delay", $self->{'mxdelay'}, 4, "2");
print "</td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'score_rbl'}</b></td> <td nowrap colspan=2>";
$self->{'rbl'} = $self->find("skip_rbl_checks", $self->{'conf'});
$self->yes_no_field("skip_rbl_checks", $self->{'rbl'}, 0);
print "</td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'score_timeout'}</b></td> <td nowrap colspan=2>";
$self->{'timeout'} = $self->find("rbl_timeout", $self->{'conf'});
$self->opt_field("rbl_timeout", $self->{'timeout'}, 5, "30");
print "</td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'score_received'}</b></td> <td nowrap colspan=2>";
$self->{'received'} = $self->find("num_check_received", $self->{'conf'});
$self->opt_field("num_check_received", $self->{'received'}, 5, 2);
print "</td> </tr>\n";

print "<tr> <td colspan=4><hr></td> </tr>\n";

@{$self->{'langs_array'}} = $self->find_value("ok_languages", $self->{'conf'});
%{$self->{'langs_hash'}} = map { $_, 1 } split(/\s+/, join(" ", @{$self->{'langs_array'}}));
$self->{'lmode'} = !@{$self->{'langs_array'}} ? 2 : $self->{'langs_hash'}->{'all'} ? 1 : 0;
print "<tr> <td valign=top><b>$self->{'text_hash'}->{'score_langs'}</b></td> <td valign=top>\n";
printf "<input type=radio name=langs_def value=2 %s> %s (%s)<br>\n",
	$self->{'lmode'} == 2 ? 'checked' : '', $self->{'text_hash'}->{'default'}, $self->{'text_hash'}->{'score_langsall'};
printf "<input type=radio name=langs_def value=1 %s> %s<br>\n",
	$self->{'lmode'} == 1 ? 'checked' : '', $self->{'text_hash'}->{'score_langsall'};
printf "<input type=radio name=langs_def value=0 %s> %s<br>\n",
	$self->{'lmode'} == 0 ? 'checked' : '', $self->{'text_hash'}->{'score_langssel'};
print "</td> <td><select name=langs multiple size=5>\n";
open(LANGS, "$self->{'module_root_directory'}/langs");
while(<LANGS>) {
	if (/^(\S+)\s+(.*)/) {
		printf "<option value=%s %s>%s\n",
			$1, $self->{'langs_hash'}->{$1} ? "selected" : "", $2;
		}
	}
close(LANGS);
print "</select></td> </tr>\n";

@{$self->{'locales_array'}} = $self->find_value("ok_locales", $self->{'conf'});
%{$self->{'locales_hash'}} = map { $_, 1 } split(/\s+/, join(" ", @{$self->{'locales_array'}}));
$self->{'lmode'} = !@{$self->{'locales_array'}} ? 2 : $self->{'locales_hash'}->{'all'} ? 1 : 0;
print "<tr> <td valign=top><b>$self->{'text_hash'}->{'score_locales'}</b></td> <td valign=top>\n";
printf "<input type=radio name=locales_def value=2 %s> %s (%s)<br>\n",
	$self->{'lmode'} == 2 ? 'checked' : '', $self->{'text_hash'}->{'default'},$self->{'text_hash'}->{'score_localesall'};
printf "<input type=radio name=locales_def value=1 %s> %s<br>\n",
	$self->{'lmode'} == 1 ? 'checked' : '', $self->{'text_hash'}->{'score_localesall'};
printf "<input type=radio name=locales_def value=0 %s> %s<br>\n",
	$self->{'lmode'} == 0 ? 'checked' : '', $self->{'text_hash'}->{'score_localessel'};
print "</td> <td><select name=locales multiple size=5>\n";
open(LANGS, "$self->{'module_root_directory'}/locales");
while(<LANGS>) {
	if (/^(\S+)\s+(.*)/) {
		printf "<option value=%s %s>%s\n",
			$1, $self->{'locales_hash'}->{$1} ? "selected" : "", $2;
		}
	}
close(LANGS);
print "</select></td> </tr>\n";

$self->end_form(undef, $self->{'text_hash'}->{'save'});
$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

