#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_priv.cgi
# Save privileged options

&ModuleLoader::preload_module('spam_class', "spam::SpamLib");
$self = new spam::SpamLib:: 'spam_class',%$self;

$self->error_setup($self->{'text_hash'}->{'priv_err'});
$self->can_use_check("priv");
$self->ReadParse();
$self->execute_before("priv");
$self->lock_spam_files();
$self->{'conf'} = $self->get_config();

$self->parse_opt($self->{'conf'}, "auto_whitelist_path", \&check_path);
$self->parse_opt($self->{'conf'}, "auto_whitelist_file_mode", \&check_mode);
$self->parse_opt($self->{'conf'}, "dcc_options", \&check_args);
$self->parse_opt($self->{'conf'}, "timelog_path", \&check_path);
$self->parse_opt($self->{'conf'}, "razor_config", \&check_path);

$self->flush_file_lines();
$self->unlock_spam_files();
$self->execute_after("priv");
$self->webmin_log("priv");
$self->redirect("");

1;
		
}

sub check_path
{
	shift if ($self == $_[0]);

$_[0] =~ /^(\/|\~)\S+$/ || $self->error($self->text('priv_epath', $_[0]));
}

sub check_mode
{
	shift if ($self == $_[0]);

$_[0] =~ /^[0-7]{4}$/ || $self->error($self->text('priv_emode', $_[0]));
}

sub check_args
{
	shift if ($self == $_[0]);

$_[0] =~ /^[A-Za-z \-]+$/ || $self->error($self->text('priv_eargs', $_[0]));
}


1;

