#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Change the procmail rule that delivers spam

&ModuleLoader::preload_module('spam_class', "spam::SpamLib");
$self = new spam::SpamLib:: 'spam_class',%$self;

$self->error_setup($self->{'text_hash'}->{'procmail_err'});
$self->can_use_check("procmail");
$self->ReadParse();

# Validate inputs
$self->{'type'} = undef;
if ($self->{'in_hash'}->{'to'} == 0) {
	$self->{'file'} = "/dev/null";
	}
elsif ($self->{'in_hash'}->{'to'} == 1) {
	$self->{'in_hash'}->{'file'} =~ /^\S+$/ || $self->error($self->{'text_hash'}->{'setup_efile'});
	$self->{'file'} = $self->{'in_hash'}->{'file'};
	}
elsif ($self->{'in_hash'}->{'to'} == 2) {
	$self->{'in_hash'}->{'maildir'} =~ /^\S+$/ || $self->error($self->{'text_hash'}->{'setup_emaildir'});
	$self->{'file'} = "$self->{'in_hash'}->{'maildir'}/";
	}
elsif ($self->{'in_hash'}->{'to'} == 3) {
	$self->{'in_hash'}->{'mhdir'} =~ /^\S+$/ || $self->error($self->{'text_hash'}->{'setup_emhdir'});
	$self->{'file'} = "$self->{'in_hash'}->{'mhdir'}/.";
	}
elsif ($self->{'in_hash'}->{'to'} == 5) {
	$self->{'in_hash'}->{'email'} =~ /^\S+$/ || $self->error($self->{'text_hash'}->{'setup_eemail'});
	$self->{'file'} = $self->{'in_hash'}->{'email'};
	$self->{'type'} = "!";
	}

# Find the existing recipe
$self->foreign_require("procmail", "procmail-lib.pl");
@{$self->{'pmrcs_array'}} = $self->get_procmailrc();
$self->{'pmrc'} = $self->{'pmrcs_array'}->[$#{$self->{'pmrcs_array'}}];
@{$self->{'recipes_array'}} = $main::procmail_object->parse_procmail_file($self->{'pmrc'});
$self->{'spamrec'} = $self->find_file_recipe(\@{$self->{'recipes_array'}});

$self->lock_file($self->{'pmrc'});
if ($self->{'file'}) {
	if ($self->{'spamrec'}) {
		# Update the recipe
		$self->{'spamrec'}->{'action'} = $self->{'file'};
		$self->{'spamrec'}->{'type'} = $self->{'type'};
		$main::procmail_object->modify_recipe($self->{'spamrec'});
		}
	else {
		# Add a new recipe
		$self->{'spamrec'} = { 'flags' => [ ],
			     'conds' => [ [ '', '^X-Spam-Status: Yes' ] ],
			     'type' => $self->{'type'},
			     'action' => $self->{'file'} };
		$main::procmail_object->create_recipe($self->{'spamrec'}, $self->{'pmrc'});
		}
	}
elsif ($self->{'spamrec'}) {
	# Remove the recipe, to fall back to default delivery
	$main::procmail_object->delete_recipe($self->{'spamrec'});
	}
$self->unlock_file($self->{'pmrc'});

if ($self->{'module_info_hash'}->{'usermin'} && $self->{'file'} ne "/dev/null") {
	# Remember spam mail file
	$self->{'userconfig_hash'}->{'spam_file'} = $self->{'file'};
	$self->write_file("$self->{'user_module_config_directory'}/config", \%{$self->{'userconfig_hash'}});
	}

# All done!
$self->webmin_log("procmail");
$self->redirect("");

1;
		
}


1;

