#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_score.cgi
# Save message scoring options

&ModuleLoader::preload_module('spam_class', "spam::SpamLib");
$self = new spam::SpamLib:: 'spam_class',%$self;

$self->error_setup($self->{'text_hash'}->{'score_err'});
$self->can_use_check("score");
$self->ReadParse();
$self->execute_before("score");
$self->lock_spam_files();
$self->{'conf'} = $self->get_config();

$self->{'hits_param'} = $self->version_atleast(3.0) ? "required_score" : "required_hits";
$self->parse_opt($self->{'conf'}, $self->{'hits_param'}, \&hits_check);
$self->parse_opt($self->{'conf'}, "auto_whitelist_factor", \&auto_check);
$self->parse_yes_no($self->{'conf'}, "use_bayes");
$self->parse_opt($self->{'conf'}, "check_mx_attempts", \&mx_check);
$self->parse_opt($self->{'conf'}, "check_mx_delay", \&mxdelay_check);
$self->parse_yes_no($self->{'conf'}, "skip_rbl_checks");
$self->parse_opt($self->{'conf'}, "rbl_timeout", \&timeout_check);
$self->parse_opt($self->{'conf'}, "num_check_received", \&received_check);

if ($self->{'in_hash'}->{'langs_def'} == 2) {
	$self->save_directives($self->{'conf'}, "ok_languages", [ ], 1);
	}
elsif ($self->{'in_hash'}->{'langs_def'} == 1) {
	$self->save_directives($self->{'conf'}, "ok_languages", [ "all" ], 1);
	}
else {
	$self->save_directives($self->{'conf'}, "ok_languages",
			 [ join(" ", split(/\0/, $self->{'in_hash'}->{'langs'})) ], 1);
	}

if ($self->{'in_hash'}->{'locales_def'} == 2) {
	$self->save_directives($self->{'conf'}, "ok_locales", [ ], 1);
	}
elsif ($self->{'in_hash'}->{'locales_def'} == 1) {
	$self->save_directives($self->{'conf'}, "ok_locales", [ "all" ], 1);
	}
else {
	$self->save_directives($self->{'conf'}, "ok_locales",
			 [ join(" ", split(/\0/, $self->{'in_hash'}->{'locales'})) ], 1);
	}

$self->flush_file_lines();
$self->unlock_spam_files();
$self->execute_after("score");
$self->webmin_log("score");
$self->redirect("");

1;
		
}

sub hits_check
{
	shift if ($self == $_[0]);

$_[0] =~ /^\d+(\.\d+)?$/ || $self->error($self->{'text_hash'}->{'score_ehits'});
}

sub auto_check
{
	shift if ($self == $_[0]);

$_[0] =~ /^\d+(\.\d+)?$/ && $_[0] >= 0 && $_[0] <= 1 ||
	$self->error($self->{'text_hash'}->{'score_eauto'});
}

sub mx_check
{
	shift if ($self == $_[0]);

$_[0] =~ /^\d+$/ || $self->error($self->{'text_hash'}->{'score_emx'});
}

sub mxdelay_check
{
	shift if ($self == $_[0]);

$_[0] =~ /^\d+$/ || $self->error($self->{'text_hash'}->{'score_emxdelay'});
}

sub timeout_check
{
	shift if ($self == $_[0]);

$_[0] =~ /^\d+$/ || $self->error($self->{'text_hash'}->{'score_etimeout'});
}

sub received_check
{
	shift if ($self == $_[0]);

$_[0] =~ /^\d+$/ || $self->error($self->{'text_hash'}->{'score_ereceived'});
}


1;

