#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Update simple tests

&ModuleLoader::preload_module('spam_class', "spam::SpamLib");
$self = new spam::SpamLib:: 'spam_class',%$self;

$self->can_use_check("header");
$self->{'conf'} = $self->get_config();
$self->error_setup($self->{'text_hash'}->{'simple_err'});
$self->ReadParse();
$self->execute_before("simple");

# Get existing rules
@{$self->{'simples_array'}} = $self->get_simple_tests($self->{'conf'});
@{$self->{'headers_array'}} = $self->find("header", $self->{'conf'});
@{$self->{'bodies_array'}} = $self->find("body", $self->{'conf'});
@{$self->{'fulls_array'}} = $self->find("full", $self->{'conf'});
@{$self->{'uris_array'}} = $self->find("uri", $self->{'conf'});
@{$self->{'scores_array'}} = $self->find("score", $self->{'conf'});
@{$self->{'describes_array'}} = $self->find("describe", $self->{'conf'});

# Parse and validate inputs
for($i=0; defined($self->{'name'} = $self->{'in_hash'}->{"name_$i"}); $i++) {
	$self->{'simple'} = $i < @{$self->{'simples_array'}} ? $self->{'simples_array'}->[$i] : undef;
	if ($self->{'simple'}) {
		# Take out the directives that would be replaced
		@{$self->{'headers_array'}} = grep { $_ ne $self->{'simple'}->{'header_dir'} } @{$self->{'headers_array'}};
		@{$self->{'bodies_array'}} = grep { $_ ne $self->{'simple'}->{'body_dir'} } @{$self->{'bodies_array'}};
		@{$self->{'fulls_array'}} = grep { $_ ne $self->{'simple'}->{'full_dir'} } @{$self->{'fulls_array'}};
		@{$self->{'uris_array'}} = grep { $_ ne $self->{'simple'}->{'uri_dir'} } @{$self->{'uris_array'}};
		@{$self->{'scores_array'}} = grep { $_ ne $self->{'simple'}->{'score_dir'} } @{$self->{'scores_array'}};
		@{$self->{'describes_array'}} = grep { $_ ne $self->{'simple'}->{'describe_dir'} } @{$self->{'describes_array'}};
		}

	if ($self->{'name'}) {
		$self->{'name'} =~ /^\S+$/ || $self->error($self->text('header_ename', $self->{'name'}));
		$self->{'donename_hash'}->{$self->{'name'}}++ && $self->error($self->text('header_eclash', $self->{'name'}));
		$self->{'header'} = $self->{'in_hash'}->{"header_$i"};
		$self->{'regexp'} = $self->{'in_hash'}->{"regexp_$i"};
		$self->{'regexp'} || $self->error($self->text('header_eregexp2', $self->{'name'}));
		$self->{'flags'} = $self->{'in_hash'}->{"flags_$i"};
		$self->{'flags'} =~ /^[a-z]*$/ || $self->error($self->text('header_eflags', $self->{'flags'}));
		$self->{'score'} = $self->{'in_hash'}->{"score_$i"};
		$self->{'score'} eq "" || $self->{'score'} =~ /^\-?\d+(\.\d+)?$/ ||
				$self->{'score'} =~ /^\-?\.\d+$/ ||
			$self->error($self->text('score_epoints', $self->{'score'}));
		$self->{'describe'} = $self->{'in_hash'}->{"describe_$i"};

		# Update or add the actual directives
		if ($self->{'header'} eq "body") {
			push(@{$self->{'bodies_array'}}, { 'name' => 'body',
				       'value' => "$self->{'name'} /$self->{'regexp'}/$self->{'flags'}" });
			}
		elsif ($self->{'header'} eq "full") {
			push(@{$self->{'fulls_array'}}, { 'name' => 'full',
				       'value' => "$self->{'name'} /$self->{'regexp'}/$self->{'flags'}" });
			}
		elsif ($self->{'header'} eq "uri") {
			push(@{$self->{'uris_array'}}, { 'name' => 'uri',
				       'value' => "$self->{'name'} /$self->{'regexp'}/$self->{'flags'}" });
			}
		else {
			local $ucheader = ucfirst($self->{'header'});
			push(@{$self->{'headers_array'}}, { 'name' => 'header',
				         'value' => "$self->{'name'} $ucheader =~ /$self->{'regexp'}/$self->{'flags'}" });
			}

		# Update the score and describe
		if ($self->{'score'} ne "") {
			push(@{$self->{'scores_array'}}, { 'name' => 'score',
					'value' => "$self->{'name'} $self->{'score'}" });
			}
		if ($self->{'describe'} ne "") {
			push(@{$self->{'describes_array'}}, { 'name' => 'describe',
					   'value' => "$self->{'name'} $self->{'describe'}" });
			}
		}
	}

# Save the directives
$self->lock_spam_files();
$self->save_directives($self->{'conf'}, "header", \@{$self->{'headers_array'}}, 0);
$self->save_directives($self->{'conf'}, "body", \@{$self->{'bodies_array'}}, 0);
$self->save_directives($self->{'conf'}, "full", \@{$self->{'fulls_array'}}, 0);
$self->save_directives($self->{'conf'}, "score", \@{$self->{'scores_array'}}, 0);
$self->save_directives($self->{'conf'}, "describe", \@{$self->{'describes_array'}}, 0);

$self->flush_file_lines();
$self->unlock_spam_files();
$self->execute_after("header");
$self->webmin_log("header");
$self->redirect("");

1;
		
}


1;

