#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_white.cgi
# Save white and black lists of to and from addresses

&ModuleLoader::preload_module('spam_class', "spam::SpamLib");
$self = new spam::SpamLib:: 'spam_class',%$self;

$self->error_setup($self->{'text_hash'}->{'white_err'});
$self->can_use_check("white");
$self->ReadParse();
$self->execute_before("white");
$self->lock_spam_files();
$self->{'conf'} = $self->get_config();

$self->parse_textbox($self->{'conf'}, "whitelist_from");

$self->parse_textbox($self->{'conf'}, 'unwhitelist_from');

if (!$self->{'config_hash'}->{'show_global'}) {
	@{$self->{'rcvd_array'}} = $self->parse_table("whitelist_from_rcvd", \&rcvd_parser);
	$self->save_directives($self->{'conf'}, 'whitelist_from_rcvd', \@{$self->{'rcvd_array'}}, 1);
	}

$self->parse_textbox($self->{'conf'}, 'blacklist_from');

$self->parse_textbox($self->{'conf'}, 'unblacklist_from');

if (!$self->{'config_hash'}->{'show_global'}) {
	@{$self->{'to_array'}} = $self->parse_table("whitelist_to", \&to_parser);
	@{$self->{'oldto_array'}} = ( $self->find("whitelist_to", $self->{'conf'}),
		   $self->find("more_spam_to", $self->{'conf'}),
		   $self->find("all_spam_to", $self->{'conf'}) );
	$self->save_directives($self->{'conf'}, \@{$self->{'oldto_array'}}, \@{$self->{'to_array'}}, 0);
	}

$self->flush_file_lines();
$self->unlock_spam_files();
$self->execute_after("white");
$self->webmin_log("white");
$self->redirect("");

1;
		
}

sub from_parser
{
	shift if ($self == $_[0]);

return undef if (!$_[1]);
$_[1] =~ /^\S+$/ || $self->error($self->text('white_efrom', $_[1]));
return $_[1];
}

sub rcvd_parser
{
	shift if ($self == $_[0]);

local $a = &from_parser($_[0], $_[1]);
return undef if (!$a);
$_[2] =~ /^[A-Za-z0-9\.\-]+$/ || $self->error($self->text('white_ercvd', $_[2]));
return "$a $_[2]";
}

sub to_parser
{
	shift if ($self == $_[0]);

local $a = &from_parser($_[0], $_[1]);
return undef if (!$a);
return { 'name' => $_[2] == 0 ? 'whitelist_to' :
		   $_[2] == 1 ? 'more_spam_to' : 'all_spam_to',
	 'value' => $a };
}


1;

