#!/usr/bin/perl
package squid::Backup_config;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'squid::Backup_config');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;

&ModuleLoader::preload_module(ref($self), "squid::SquidLib");
$self = new squid::SquidLib:: ref($self), %$self; 

1;

1;
		return $self;
}

# backup_config_files()
# Returns files and directories that can be backed up
sub backup_config_files
{
	my $self = shift;

# Add main config file
local @rv = ( $self->{'config_hash'}->{'squid_conf'} );

# Add users file
local $conf = $self->get_config();
local $file = $self->get_auth_file($conf);
push(@rv, $file) if ($file);

# Add files from ACLs
local @acl = $self->find_config("acl", $conf);
local $a;
foreach $a (@acl) {
	if ($a->{'values'}->[2] =~ /^"(.*)"$/) {
		push(@rv, $1);
		}
	}

return $self->unique(@rv);
}

# pre_backup(&files)
# Called before the files are actually read
sub pre_backup
{
	my $self = shift;

return undef;
}

# post_backup(&files)
# Called after the files are actually read
sub post_backup
{
	my $self = shift;

return undef;
}

# pre_restore(&files)
# Called before the files are restored from a backup
sub pre_restore
{
	my $self = shift;

return undef;
}

# post_restore(&files)
# Called after the files are restored from a backup
sub post_restore
{
	my $self = shift;

return $self->apply_configuration();
}


1;

