#!/usr/bin/perl
package squid::Log_parser;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'squid::Log_parser');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# log_parser.pl
# Functions for parsing this module's logs

&ModuleLoader::preload_module(ref($self), "squid::SquidLib");
$self = new squid::SquidLib:: ref($self), %$self; 

1;
		return $self;
}

# parse_webmin_log(user, script, action, type, object, &params)
# Converts logged information from this module into human-readable form
sub parse_webmin_log
{
	my $self = shift;

local ($user, $script, $action, $type, $object, $p) = @_;
$object = $self->html_escape($object);
if ($type eq 'acl') {
	return $self->text("log_acl_$action", "<tt>$object</tt>");
	}
elsif ($type eq 'host') {
	return $self->text("log_host_$action", "<tt>$object</tt>");
	}
elsif ($type eq 'http' || $type eq 'icp' ||
       $type eq 'always' || $type eq 'never' ||
       $type eq 'pool' || $type eq 'delay' ||
       $type eq 'headeracc' || $type eq 'refresh') {
	return $self->text("log_${type}_${action}",
		     "<tt>".$self->html_escape($object)."</tt>");
	}
elsif ($type eq 'pools' || $type eq 'refreshes' || $type eq 'hosts') {
	return $self->text("log_${type}_${action}", $object);
	}
elsif ($type eq 'user') {
	return $self->text("log_user_$action", "<tt>$object</tt>");
	}
elsif ($action eq 'purge') {
	return $self->text('log_purge', "<tt>".$self->html_escape($object)."</tt>");
	}
elsif ($self->{'text_hash'}->{"log_$action"}) {
	return $self->{'text_hash'}->{"log_$action"};
	}
else {
	return undef;
	}
}


1;

