#!/usr/bin/perl
package squid::SquidLib;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'squid::SquidLib');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# squid-lib.pl
# Functions for configuring squid.conf

&ModuleLoader::preload_module(ref($self), "WebLib");
$self = new WebLib:: ref($self), %$self; 
$self->init_config();
&ModuleLoader::preload_module(ref($self), "UiLib");
$self = new UiLib:: ref($self), %$self; 
&ModuleLoader::preload_module(ref($self), "squid::ParserLib");
$self = new squid::ParserLib:: ref($self), %$self; 
%{$self->{'access_hash'}} = $self->get_module_acl();
$self->{'auth_program'} = "$self->{'module_config_directory'}/squid-auth.pl";
$self->{'auth_database'} = "$self->{'module_config_directory'}/users";
@{$self->{'caseless_acl_types_array'}} = ( "url_regex", "urlpath_regex", "proxy_auth_regex",
			"srcdom_regex", "dstdom_regex", "ident_regex" );

# Get the squid version
if (open(VERSION, "$self->{'module_config_directory'}/version")) {
	chop($self->{'squid_version'} = <VERSION>);
	close(VERSION);
	}

%{$self->{'acl_types_hash'}} = ("src", $self->{'text_hash'}->{'lib_aclca'},
	      "dst", $self->{'text_hash'}->{'lib_aclwsa'},
	      "srcdomain", $self->{'text_hash'}->{'lib_aclch'},
	      "dstdomain", $self->{'text_hash'}->{'lib_aclwsh'},
	      "time", $self->{'text_hash'}->{'lib_acldat'},
	      "url_regex", $self->{'text_hash'}->{'lib_aclur'},
	      "urlpath_regex", $self->{'text_hash'}->{'lib_aclupr'},
	      "port", $self->{'text_hash'}->{'lib_aclup'},
	      "proto", $self->{'text_hash'}->{'lib_aclup1'},
	      "method", $self->{'text_hash'}->{'lib_aclrm'},
	      "browser", $self->{'text_hash'}->{'lib_aclbr'},
	      "user", $self->{'text_hash'}->{'lib_aclpl'},
	      "arp", $self->{'text_hash'}->{'lib_aclarp'} );
if ($self->{'squid_version'} >= 2.0) {
	$self->{'acl_types_hash'}->{'src_as'} = $self->{'text_hash'}->{'lib_aclsan'};
	$self->{'acl_types_hash'}->{'dst_as'} = $self->{'text_hash'}->{'lib_acldan'};
	$self->{'acl_types_hash'}->{'proxy_auth'} = $self->{'text_hash'}->{'lib_aclea'};
	$self->{'acl_types_hash'}->{'srcdom_regex'} = $self->{'text_hash'}->{'lib_aclcr'};
	$self->{'acl_types_hash'}->{'dstdom_regex'} = $self->{'text_hash'}->{'lib_aclwsr'};
	}
if ($self->{'squid_version'} >= 2.2) {
	$self->{'acl_types_hash'}->{'ident'} = $self->{'text_hash'}->{'lib_aclru'};
	$self->{'acl_types_hash'}->{'myip'} = $self->{'text_hash'}->{'lib_aclpia'};
	delete($self->{'acl_types_hash'}->{'user'});
	}
if ($self->{'squid_version'} >= 2.3) {
	$self->{'acl_types_hash'}->{'maxconn'} = $self->{'text_hash'}->{'lib_aclmc'};
	$self->{'acl_types_hash'}->{'myport'} = $self->{'text_hash'}->{'lib_aclpp'};
	$self->{'acl_types_hash'}->{'snmp_community'} = $self->{'text_hash'}->{'lib_aclsc'};
	}
if ($self->{'squid_version'} >= 2.4) {
	$self->{'acl_types_hash'}->{'req_mime_type'} = $self->{'text_hash'}->{'lib_aclrmt'};
	$self->{'acl_types_hash'}->{'proxy_auth_regex'} = $self->{'text_hash'}->{'lib_aclear'};
	}
if ($self->{'squid_version'} >= 2.5) {
	$self->{'acl_types_hash'}->{'rep_mime_type'} = $self->{'text_hash'}->{'lib_aclrpmt'};
	$self->{'acl_types_hash'}->{'ident_regex'} = $self->{'text_hash'}->{'lib_aclrur'};
	$self->{'acl_types_hash'}->{'external'} = $self->{'text_hash'}->{'lib_aclext'};
	$self->{'acl_types_hash'}->{'max_user_ip'} = $self->{'text_hash'}->{'lib_aclmuip'};
	}

1;

1;
		return $self;
}

# choice_input(text, name, &config, default, [display, option]+)
# Display a number of radio buttons for selecting some option
sub choice_input
{
	my $self = shift;

local($v, $vv, $rv, $i);
$v = $self->find_config($_[1], $_[2]);
$vv = $v ? $v->{'value'} : $_[3];
$rv = "<td><b>$_[0]</b></td> <td valign=top>";
for($i=4; $i<@_; $i+=2) {
	$rv .= "<input type=radio name=$_[1] value=\"".$_[$i+1]."\" ".
		($vv eq $_[$i+1] ? "checked" : "")."> $_[$i]\n";
	}
return $rv."</td>\n";
}

# select_input(text, name, &config, default, [display, option]+)
# Like choice_input, but uses a drop-down select field
sub select_input
{
	my $self = shift;

local($v, $vv, $rv, $i);
$v = $self->find_config($_[1], $_[2]);
$vv = $v ? $v->{'value'} : $_[3];
$rv = "<td><b>$_[0]</b></td> <td valign=top><select name=$_[1]>";
for($i=4; $i<@_; $i+=2) {
	$rv .= "<option value=\"".$_[$i+1]."\" ".
		($vv eq $_[$i+1] ? "selected" : "")."> $_[$i]\n";
	}
return $rv."</select></td>\n";
}

# save_choice(name, default, &config)
# Save a selection from choice_input()
sub save_choice
{
	my $self = shift;

if ($self->{'in_hash'}->{$_[0]} eq $_[1]) { $self->save_directive($_[2], $_[0], [ ]); }
else { $self->save_directive($_[2], $_[0], [{ 'name' => $_[0],
					'values' => [ $self->{'in_hash'}->{$_[0]} ] }]); }
}

# list_input(text, name, &config, type, [default])
# Display a list of values
sub list_input
{
	my $self = shift;

local($v, $rv, @av);
foreach $v ($self->find_config($_[1], $_[2])) {
	push(@av, @{$v->{'values'}});
	}
if ($_[4]) {
	$self->{'opt'} = sprintf "<input type=radio name=$_[1]_def value=1 %s> $_[4]\n",
		@av ? "" : "checked";
	$self->{'opt'} .= sprintf "<input type=radio name=$_[1]_def value=0 %s>\n",
		@av ? "checked" : "";
	}
if ($_[3] == 0) {
	# text area
	$rv = "<td valign=top><b>$_[0]</b></td> <td valign=top>";
	if ($self->{'opt'}) { $rv .= "$self->{'opt'} Listed..<br>\n"; }
	$rv .= "<textarea name=$_[1] rows=3 cols=15>".
		join("\n", @av)."</textarea></td>\n";
	}
else {
	# one long text field
	$rv = "<td valign=top><b>$_[0]</b></td> <td colspan=3 valign=top>$self->{'opt'}";
	$rv .= "<input name=$_[1] size=50 value=\"".join(' ',@av)."\"></td>\n";
	}
return $rv;
}

# save_list(name, &checkfunc, &config)
sub save_list
{
	my $self = shift;

local($v, @vals, $err);
if (!$self->{'in_hash'}->{"$_[0]_def"}) {
	@vals = split(/\s+/, $self->{'in_hash'}->{$_[0]});
	if ($_[1]) {
		foreach $v (@vals) {
			$self->check_error($_[1], $v);
			}
		}
	}
if (@vals) { $self->save_directive($_[2], $_[0],
		[{ 'name' => $_[0], values => \@vals }]); }
else { $self->save_directive($_[2], $_[0], [ ]); }
}

# check_error(&function, value)
sub check_error
{
	my $self = shift;

return if (!$_[0]);
local $err = &{$_[0]}($_[1]);
if ($err) { $self->error($err); }
}

# address_input(text, name, &config, type)
# Display a text area for entering 0 or more addresses
sub address_input
{
	my $self = shift;

local($v, $rv, @av);
foreach $v ($self->find_config($_[1], $_[2])) {
	push(@av, @{$v->{'values'}});
	}
if ($_[3] == 0) {
	# text area
	$rv = "<td valign=top><b>$_[0]</b></td> <td valign=top>";
	$rv .= "<textarea name=$_[1] rows=3 cols=15>".
		join("\n", @av)."</textarea></td>\n";
	}
else {
	# one long text field
	$rv = "<td valign=top><b>$_[0]</b></td> <td colspan=3 valign=top>";
	$rv .= "<input name=$_[1] size=50 value=\"".join(' ',@av)."\"></td>\n";
	}
return $rv;
}

# save_address(name, config)
sub save_address
{
	my $self = shift;

local($addr, @vals);
foreach $addr (split(/\s+/, $self->{'in_hash'}->{$_[0]})) {
	$self->check_ipaddress($addr) || $self->error($self->text('lib_emsg1',$addr));
	push(@vals, $addr);
	}
if (@vals) { $self->save_directive($_[1], $_[0],
		[{ 'name' => $_[0], values => \@vals }]); }
else { $self->save_directive($_[1], $_[0], [ ]); }
}

# opt_input(text, name, &config, default, size, units)
# Display an optional field for entering something
sub opt_input
{
	my $self = shift;

local($v, $rv);
$v = $self->find_config($_[1], $_[2]);
$rv = "<td valign=top><b>$_[0]</b></td> <td valign=top nowrap";
$rv .= $_[4] > 30 ? " colspan=3>\n" : ">\n";
$rv .= sprintf "<input type=radio name=$_[1]_def value=1 %s> $_[3]\n",
	$v ? "" : "checked";
$rv .= sprintf "<input type=radio name=$_[1]_def value=0 %s> ",
	$v ? "checked" : "";
$rv .= sprintf "<input name=$_[1] size=$_[4] value=\"%s\"> %s</td>\n",
	$v ? $v->{'value'} : "", $_[5];
return $rv;
}

# save_opt(name, &function, &config)
# Save an input from opt_input()
sub save_opt
{
	my $self = shift;

if ($self->{'in_hash'}->{"$_[0]_def"}) { $self->save_directive($_[2], $_[0], [ ]); }
else {
	$self->check_error($_[1], $self->{'in_hash'}->{$_[0]});
	local $dir = { 'name' => $_[0], 'values' => [ $self->{'in_hash'}->{$_[0]} ] };
	$self->save_directive($_[2], $_[0], [ $dir ]);
	}
}

# opt_time_input(text, name, &config, default, size)
sub opt_time_input
{
	my $self = shift;

local($v, $rv, $u, %ts );
$v = $self->find_config($_[1], $_[2]);
$rv = "<td valign=top><b>$_[0]</b></td> <td valign=top nowrap>\n";
$rv .= sprintf "<input type=radio name=$_[1]_def value=1 %s> $_[3]\n",
	$v ? "" : "checked";
$rv .= sprintf "<input type=radio name=$_[1]_def value=0 %s> ",
	$v ? "checked" : "";
$rv .= $self->time_fields($_[1], $_[4], $v ? @{$v->{'values'}} : ( ));
$rv .= "</td>\n";
return $rv;
}

# time_field(name, size, time, units)
sub time_fields
{
	my $self = shift;

local ($rv, %ts);
%ts = (	"second"=>	$self->{'text_hash'}->{"lib_seconds"},
	"minute"=>	$self->{'text_hash'}->{"lib_minutes"},
	"hour"=>	$self->{'text_hash'}->{"lib_hours"},
	"day"=>		$self->{'text_hash'}->{"lib_days"},
	"week"=>	$self->{'text_hash'}->{"lib_weeks"},
	"fortnight"=>	$self->{'text_hash'}->{"lib_fortnights"},
	"month"=>	$self->{'text_hash'}->{"lib_months"},
	"year"=>	$self->{'text_hash'}->{"lib_years"},
	"decade"=>	$self->{'text_hash'}->{"lib_decades"} );
$rv .= sprintf "<input name=$_[0] size=$_[1] value=\"%s\">\n", $_[2];
$rv .= "<select name=$_[0]_u>\n";
foreach $u (keys %ts) {
	$rv .= sprintf "<option value=$u %s>$ts{$u}\n",
		$_[3] =~ /^$u/ ? "selected" : "";
	}
$rv .= "</select>\n";
return $rv;
}

# save_opt_time(name, &config)
sub save_opt_time
{
	my $self = shift;

local %ts = ( "second"=>      $self->{'text_hash'}->{"lib_seconds"},
        "minute"=>      $self->{'text_hash'}->{"lib_minutes"},
        "hour"=>        $self->{'text_hash'}->{"lib_hours"},
        "day"=>         $self->{'text_hash'}->{"lib_days"},
        "week"=>        $self->{'text_hash'}->{"lib_weeks"},
        "fortnight"=>   $self->{'text_hash'}->{"lib_fortnights"},
        "month"=>       $self->{'text_hash'}->{"lib_months"},
        "year"=>        $self->{'text_hash'}->{"lib_years"},
        "decade"=>      $self->{'text_hash'}->{"lib_decades"} );

if ($self->{'in_hash'}->{"$_[0]_def"}) { $self->save_directive($_[1], $_[0], [ ]); }
elsif ($self->{'in_hash'}->{$_[0]} !~ /^[0-9\.]+$/) {
	$self->error($self->text('lib_emsg2', $self->{'in_hash'}->{$_[0]}, $ts{$self->{'in_hash'}->{"$_[0]_u"}}) );
	}
else {
	local $dir = { 'name' => $_[0],
		       'values' => [ $self->{'in_hash'}->{$_[0]}, $self->{'in_hash'}->{"$_[0]_u"} ] };
	$self->save_directive($_[1], $_[0], [ $dir ]);
	}
}

# opt_bytes_input(text, name, &config, default, size)
sub opt_bytes_input
{
	my $self = shift;

local($v, $rv, $u, %ss);
@{$self->{'ss_array'}} = (	[ "KB", $self->{'text_hash'}->{'lib_kb'} ],
	[ "MB", $self->{'text_hash'}->{'lib_mb'} ],
	[ "GB", $self->{'text_hash'}->{'lib_gb'} ] );
$v = $self->find_config($_[1], $_[2]);
$rv = "<td valign=top><b>$_[0]</b></td> <td valign=top nowrap>\n";
$rv .= sprintf "<input type=radio name=$_[1]_def value=1 %s> $_[3]\n",
	$v ? "" : "checked";
$rv .= sprintf "<input type=radio name=$_[1]_def value=0 %s> ",
	$v ? "checked" : "";
$rv .= sprintf "<input name=$_[1] size=$_[4] value=\"%s\">\n",
	$v ? $v->{'values'}->[0] : "";
$rv .= "<select name=$_[1]_u>\n";
foreach $u (@{$self->{'ss_array'}}) {
	$rv .= sprintf "<option value=$u->[0] %s>$u->[1]\n",
		$v && $v->{'values'}->[1] eq $u->[0] ? "selected" : "";
	}
$rv .= sprintf "<option value='' %s>bytes\n",
	$v && $v->{'values'}->[1] eq "" ? "selected" : "";
$rv .= "</select></td>\n";
return $rv;
}

# save_opt_bytes(name, &config)
sub save_opt_bytes
{
	my $self = shift;

local %ss = ( "KB"=>  $self->{'text_hash'}->{'lib_kb'},
        "MB"=>  $self->{'text_hash'}->{'lib_mb'},
        "GB"=>  $self->{'text_hash'}->{'lib_gb'} );

if ($self->{'in_hash'}->{"$_[0]_def"}) { $self->save_directive($_[1], $_[0], [ ]); }
elsif ($self->{'in_hash'}->{$_[0]} !~ /^[0-9\.]+$/) {
	$self->error($self->text('lib_emsg3', $self->{'in_hash'}->{$_[0]}, $ss{$self->{'in_hash'}->{"$_[0]_u"}}) );
	}
else {
	local $dir = { 'name' => $_[0],
		       'values' => [ $self->{'in_hash'}->{$_[0]}, $self->{'in_hash'}->{"$_[0]_u"} ] };
	$self->save_directive($_[1], $_[0], [ $dir ]);
	}
}

# restart_button()
# Returns HTML for a link to put in the top-right corner of every page
sub restart_button
{
	my $self = shift;

return undef if ($self->{'config_hash'}->{'restart_pos'} == 2);
local $pid = $self->is_squid_running();
local $args = "redir=".$self->urlize($self->this_url())."&pid=$pid";
if ($pid) {
	return ($self->{'access_hash'}->{'restart'} ? "<a href=\"restart.cgi?$args\">$self->{'text_hash'}->{'lib_buttac'}</a><br>\n" : "").
	       ($self->{'access_hash'}->{'start'} ? "<a href=\"stop.cgi?$args\">$self->{'text_hash'}->{'lib_buttss'}</a>\n" : "");
	}
else {
	return $self->{'access_hash'}->{'start'} ? "<a href=\"start.cgi?$args\">$self->{'text_hash'}->{'lib_buttss1'}</a>\n" : "";
	}
}

# is_squid_running()
# Returns the process ID if squid is running
sub is_squid_running
{
	my $self = shift;

local $conf = $self->get_config();
local ($pidstruct, $pidfile);
$pidstruct = $self->find_config("pid_filename", $conf);
if (!$pidstruct) {
	$pidstruct = $self->find_config("pid_filename", $conf, 2);
	}
$pidfile = $pidstruct ? $pidstruct->{'values'}->[0] : $self->{'config_hash'}->{'pid_file'};
if ($pidfile eq "none" || !$pidfile) {
	local ($pid) = $self->find_byname("squid");
	return $pid;
	}
else {
	return $self->check_pid_file($pidfile);
	}
}

# this_url()
# Returns the URL in the apache directory of the current script
sub this_url
{
	my $self = shift;

local($url);
$url = $ENV{'SCRIPT_NAME'};
if (defined($ENV{'QUERY_STRING'})) { $url .= "?$ENV{'QUERY_STRING'}"; }
return $url;
}

# list_auth_users(file)
sub list_auth_users
{
	my $self = shift;

local(@rv, $lnum); $lnum = 0;
open(USERS, $_[0]);
while(<USERS>) {
	if (/^(#*)([^:]+):(\S+)/) {
		push(@rv, { 'user' => $2, 'pass' => $3,
			    'enabled' => !$1, 'line' => $lnum });
		}
	$lnum++;
	}
close(USERS);
if ($self->{'config_hash'}->{'sort_conf'}) {
	return sort { $a->{'user'} cmp $b->{'user'} } @rv;
	}
else {
	return @rv;
	}
}

# get_squid_user(&config)
# Returns the effective user and group (if any)
sub get_squid_user
{
	my $self = shift;

if ($self->{'squid_version'} < 2) {
	local $ceu = $self->find_config("cache_effective_user", $_[0]);
	if ($ceu) { return ($ceu->{'values'}->[0], $ceu->{'values'}->[1]); }
	return (undef, undef);
	}
else {
	local $ceu = $self->find_config("cache_effective_user", $_[0]);
	local $ceg = $self->find_config("cache_effective_group", $_[0]);
	return ($ceu->{'values'}->[0], $ceg ? $ceg->{'values'}->[0]
					    : $ceu->{'values'}->[1]);
	}
}

# chown_files(user, group, config)
# Change ownership of all squid log and cache directories
sub chown_files
{
	my $self = shift;

local(@list, $pidstruct, $pidfile);
@list = ( $self->{'config_hash'}->{'log_dir'} );

# add pidfile
if ($str = $self->find_config("pid_filename", $_[2])) {
	$pidfile = $str->{'values'}->[0];
	}
else { $pidfile = $self->{'config_hash'}->{'pid_file'}; }
push(@list, $pidfile);

# add other log directories
foreach $d ("cache_access_log", "access_log", "cache_log",
	    "cache_store_log", "cache_swap_log") {
	if (($str = $self->find_config($d, $_[2])) &&
	    $str->{'values'}->[0] =~ /^(\S+)\/[^\/]+$/) {
		push(@list, $1);
		}
	}

# add cache directories
if (@str = $self->find_config("cache_dir", $_[2])) {
	foreach $str (@str) {
		push(@list, $str->{'values'}->[0]);
		}
	}
else { push(@list, $self->{'config_hash'}->{'cache_dir'}); }
system("chown -Rf $_[0]:$_[1] ".join(" ",@list)." >/dev/null 2>&1");
}

# can_access(file)
sub can_access
{
	my $self = shift;

local @f = grep { $_ ne '' } split(/\//, $_[0]);
return 1 if ($self->{'access_hash'}->{'root'} eq '/');
local @a = grep { $_ ne '' } split(/\//, $self->{'access_hash'}->{'root'});
local $i;
for($i=0; $i<@a; $i++) {
	return 0 if ($a[$i] ne $f[$i]);
	}
return 1;
}

# get_auth_file(&config)
sub get_auth_file
{
	my $self = shift;

if ($self->{'squid_version'} >= 2.5) {
	local @auth = $self->find_config("auth_param", $_[0]);
	local ($program) = grep { $_->{'values'}->[0] eq 'basic' &&
				  $_->{'values'}->[1] eq 'program' } @auth;
	return $program ? $program->{'values'}->[3] : undef;
	}
else {
	local $authprog = $self->find_value("authenticate_program", $_[0]);
	return $authprog =~ /(\S+)\s+(\/\S+)$/ ? $2 : undef;
	}
}

# parse_external(&external_acl_type)
sub parse_external
{
	my $self = shift;

local @v = @{$_[0]->{'values'}};
local $rv = { 'name' => $v[0] };
for($i=1; $v[$i] =~ /^(\S+)=(\S+)$/; $i++) {
	$rv->{'opts'}->{$1} = $2;
	}
if ($v[$i] =~ /^\"(.*)\"$/) {
	$rv->{'format'} = $1;
	}
else {
	$rv->{'format'} = $v[$i];
	}
$i++;
$rv->{'program'} = $v[$i++];
$rv->{'args'} = [ @v[$i .. $#v] ];
return $rv;
}

# check_cache(&config, &caches)
# Returns 1 if the cache directory looks OK, 0 if not. Also fills in the 
# caches list
sub check_cache
{
	my $self = shift;

local (@cachestruct, @caches, $c);
if (@cachestruct = $self->find_config("cache_dir", $_[0])) {
	if ($self->{'squid_version'} >= 2.3) {
		@caches = map { $_->{'values'}->[1] } @cachestruct;
		}
	else {
		@caches = map { $_->{'values'}->[0] } @cachestruct;
		}
	}
else {
	@caches = ( $self->{'config_hash'}->{'cache_dir'} );
	}
@{$_[1]} = @caches;
foreach $c (@caches) {
	return 0 if (!-d $c || !-d "$c/00");
	}
return 1;
}

# get_squid_port()
# Returns the port Squid is listening on
sub get_squid_port
{
	my $self = shift;

local $conf = $self->get_config();
local $port;
if ($self->{'squid_version'} >= 2.3) {
	local ($p, $v);
	LOOP: foreach $p ($self->find_config("http_port", $conf)) {
		foreach $v (@{$p->{'values'}}) {
			if ($v =~ /^(\d+)$/) {
				$port = $1;
				}
			elsif ($v =~ /^(\S+):(\d+)$/) {
				$port = $2;
				}
			last LOOP if ($port);
			}
		}
	}
else {
	$port = $self->find_value("http_port", $conf);
	}
return defined($port) ? $port : 3128;
}

# apply_configuration()
# Activate the current Squid configuration
sub apply_configuration
{
	my $self = shift;

if ($self->{'config_hash'}->{'squid_restart'}) {
	local $out = $self->backquote_logged("$self->{'config_hash'}->{'squid_restart'} 2>&1");
	return "<pre>$out</pre>" if ($?);
	}
else {
	$out = $self->backquote_logged("$self->{'config_hash'}->{'squid_path'} -f $self->{'config_hash'}->{'squid_conf'} -k reconfigure 2>&1");
	return "<pre>$out</pre>" if ($? && $out !~ /warning/i);
	}
return undef;
}


1;

