#!/usr/bin/perl
package squid::Useradmin_update;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'squid::Useradmin_update');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
&ModuleLoader::preload_module(ref($self), "squid::SquidLib");
$self = new squid::SquidLib:: ref($self), %$self; 

sub encryptpwd {
  if ($config{'crypt_conf'}) {
    my $pwd = $_[0];
    my $encryptpwd = new MD5;
    $encryptpwd->add($pwd);
    $pwd = encode_base64($encryptpwd->hexdigest());
    chomp($pwd);
    $pwd = "\$$pwd\$";
    return $pwd;
    }
    else {
      $salt = substr(time(), -2);
      my $pwd = &unix_crypt($_[0], $_[1]);
      return $pwd;
      }
  }

1;

1;
		return $self;
}


# useradmin_create_user(&details)
# Create a new Squid user
sub useradmin_create_user
{
	my $self = shift;

return if (!$self->{'config_hash'}->{'sync_create'});
if ($self->{'config_hash'}->{'crypt_conf'} == 1) {
        eval "use MD5";
	return if ($@);
        }
return if ($_[0]->{'passmode'} != 3);

local $user = $_[0]->{'user'};
local $pass = $_[0]->{'plainpass'};

local $conf = $self->get_config();
local $file = $self->get_auth_file($conf);
return if (!$file);

$self->lock_file($file);
local @users = $self->list_auth_users($file);

local ($same) = grep { $_->{'user'} eq $user } @users;
return if ($same);
$pass = $self->encryptpwd($pass, $self->{'salt'});
open(FILE,">>$file");
print FILE "$user:$pass\n";
close(FILE);
$self->unlock_file($file);

$self->restart_squid();
}

# useradmin_delete_user(&details)
# Delete this Squid user if in sync
sub useradmin_delete_user
{
	my $self = shift;

return if (!$self->{'config_hash'}->{'sync_delete'});

local $name = $_[0]->{'user'};

local $conf = $self->get_config();
local $file = $self->get_auth_file($conf);
return if (!$file);

$self->lock_file($file);
local @users = $self->list_auth_users($file);
local $user;
foreach $u (@users) {
	if ($u->{'user'} eq $name) {
		$user = $u;
		last;
		}
	}
# In the passwd file?
return if (!$user);

$self->replace_file_line($file, $user->{'line'});
$self->unlock_file($file);

$self->restart_squid();
}

# useradmin_modify_user(&details)
# Update this users password if in sync
sub useradmin_modify_user
{
	my $self = shift;

return if (!$self->{'config_hash'}->{'sync_modify'});
if ($self->{'config_hash'}->{'crypt_conf'} == 1) {
        eval "use MD5";
	return if ($@);
        }
local $conf = $self->get_config();
local $file = $self->get_auth_file($conf);
return if (!$file);

local $name = $_[0]->{'user'};
local $oldname = $_[1]->{'user'};
local $pass = $_[0]->{'plainpass'};
return if ($name eq $oldname && $_[0]->{'passmode'} == 4);

$self->lock_file($file);
local @users = $self->list_auth_users($file);
local $user;
foreach $u (@users) {
        if ($u->{'user'} eq $oldname) {
		$user = $u;
		last;
		}
        }
# In the passwd file?
return if (!$user);

local $cmt = $user->{'enabled'} ? "" : "#";
$pass = $_[0]->{'passmode'} == 3 ? $self->encryptpwd($pass, $self->{'salt'})
				 : $user->{'pass'};
$self->replace_file_line($file, $user->{'line'},
		   "$cmt$name:$pass\n");
$self->unlock_file($file);

$self->restart_squid();
}

sub restart_squid
{
	my $self = shift;

$self->system_logged("$self->{'config_hash'}->{'squid_path'} -f $self->{'config_hash'}->{'squid_conf'} -k reconfigure >/dev/null 2>&1 </dev/null");
}


1;

