#!/usr/bin/perl

&MAIN();

 sub MAIN {
# acl.cgi
# Display a form for editing or creating a new ACL

&ModuleLoader::preload_module('squid_class', "squid::SquidLib");
$self = new squid::SquidLib:: 'squid_class',%$self;

$self->{'access_hash'}->{'actrl'} || $self->error($self->{'text_hash'}->{'eacl_ecannot'});
$self->ReadParse();
$self->{'conf'} = $self->get_config();

if ($self->{'in_hash'}->{'type'}) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'acl_header1'}, "", undef, 0, 0, 0, $self->restart_button());
	$self->{'type'} = $self->{'in_hash'}->{'type'};
	}
else {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'acl_header2'}, "", undef, 0, 0, 0, $self->restart_button());
	@{$self->{'acl_array'}} = @{$self->{'conf'}->[$self->{'in_hash'}->{'index'}]->{'values'}};
	$self->{'type'} = $self->{'acl_array'}->[1];
	if (($self->{'type'} eq "external" ||
	     $self->indexof($self->{'type'}, @{$self->{'caseless_acl_types_array'}}) >= 0) &&
	    $self->{'acl_array'}->[3] =~ /^"(.*)"$/) {
		# Extra parameters come from file
		@{$self->{'vals_array'}} = ( $self->{'acl_array'}->[2] );
		$self->{'file'} = $1;
		}
	elsif ($self->{'acl_array'}->[2] =~ /^"(.*)"$/) {
		# All values come from a file
		$self->{'file'} = $1;
		}
	else {
		# All values come from acl parameters
		@{$self->{'vals_array'}} = @{$self->{'acl_array'}}[2..$#{$self->{'acl_array'}}];
		}
	if ($self->{'file'}) {
		open(FILE, $self->{'file'});
		chop(@{$self->{'newvals_array'}} = <FILE>);
		close(FILE);
		push(@{$self->{'vals_array'}}, @{$self->{'newvals_array'}});
		}
	if ($self->{'type'} =~ /^(src|dst|srcdomain|dstdomain|user|myip)$/) {
		@{$self->{'vals_array'}} = sort { $a cmp $b } @{$self->{'vals_array'}};
		}
	elsif ($self->{'type'} eq "port") {
		@{$self->{'vals_array'}} = sort { $a <=> $b } @{$self->{'vals_array'}};
		}
	@{$self->{'deny_array'}} = grep { $_->{'values'}->[1] eq $self->{'acl_array'}->[0] }
			$self->find_config("deny_info", $self->{'conf'});
	}

print "<form action=acl_save.cgi method=post enctype=multipart/form-data>\n";
if (@{$self->{'acl_array'}}) {
	print "<input type=hidden name=index value=$self->{'in_hash'}->{'index'}>\n";
	}
if (@{$self->{'deny_array'}}) {
	print "<input type=hidden name=dindex value=$self->{'deny_array'}->[0]->{'index'}>\n";
	}
print "<input type=hidden name=type value=$self->{'type'}>\n";
print "<table border>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'acl_types_hash'}->{$self->{'type'}} ACL</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table>\n";

print "<tr> <td nowrap><b>$self->{'text_hash'}->{'acl_name'}</b></td>\n";
print "<td><input name=name size=20 value=\"$self->{'acl_array'}->[0]\"></td>\n";

if ($self->{'type'} eq "src" || $self->{'type'} eq "dst") {
	print "<tr> <td colspan=2><table>\n";
	print "<tr> <td><b>$self->{'text_hash'}->{'acl_fromip'}</b></td> ",
		"<td><b>$self->{'text_hash'}->{'acl_toip'}</b></td>\n";
	print "     <td><b>$self->{'text_hash'}->{'acl_nmask'}</b></td> </tr>\n";
	for($i=0; $i<=@{$self->{'vals_array'}}; $i++) {
		if ($self->{'vals_array'}->[$i] =~ /^([\d\.]+)-([\d\.]+)\/([\d\.]+)$/) {
			$self->{'from'} = $1; $self->{'to'} = $2; $self->{'mask'} = $3;
			}
		elsif ($self->{'vals_array'}->[$i] =~ /^([\d\.]+)-([\d\.]+)$/) {
			$self->{'from'} = $1; $self->{'to'} = $2; $self->{'mask'} = "";
			}
		elsif ($self->{'vals_array'}->[$i] =~ /^([\d\.]+)\/([\d\.]+)$/) {
			$self->{'from'} = $1; $self->{'to'} = ""; $self->{'mask'} = $2;
			}
		elsif ($self->{'vals_array'}->[$i] =~ /^([\d\.]+)$/) {
			$self->{'from'} = $1; $self->{'to'} = ""; $self->{'mask'} = "";
			}
		else { $self->{'from'} = $self->{'to'} = $self->{'mask'} = ""; }
		print "<tr>\n";
		print "<td><input name=from_$i size=15 value=\"$self->{'from'}\"></td>\n";
		print "<td><input name=to_$i size=15 value=\"$self->{'to'}\"></td>\n";
		print "<td><input name=mask_$i size=15 value=\"$self->{'mask'}\"></td>\n";
		print "</tr>\n";
		}
	print "</table></td> </tr>\n";
	}
elsif ($self->{'type'} eq "myip") {
	print "<tr> <td colspan=2><table>\n";
	print "<tr> <td><b>$self->{'text_hash'}->{'acl_ipaddr'}</b></td> ",
		"<td><b>$self->{'text_hash'}->{'acl_nmask'}</b></td> </tr>\n";
	for($i=0; $i<=@{$self->{'vals_array'}}; $i++) {
		if ($self->{'vals_array'}->[$i] =~ /^([\d\.]+)\/([\d\.]+)$/) {
			$self->{'ip'} = $1; $self->{'mask'} = $2;
			}
		else { $self->{'ip'} = $self->{'mask'} = ""; }
		print "<tr>\n";
		print "<td><input name=ip_$i size=15 value=\"$self->{'ip'}\"></td>\n";
		print "<td><input name=mask_$i size=15 value=\"$self->{'mask'}\"></td>\n";
		print "</tr>\n";
		}
	print "</table></td> </tr>\n";
	}
elsif ($self->{'type'} eq "srcdomain") {
	print "<tr> <td valign=top><b>$self->{'text_hash'}->{'acl_domains'}</b></td>\n";
	print "<td><textarea name=vals rows=6 cols=40>",join("\n", @{$self->{'vals_array'}}),
	      "</textarea></td> </tr>\n";
	}
elsif ($self->{'type'} eq "dstdomain") {
	print "<tr> <td valign=top><b>$self->{'text_hash'}->{'acl_domains'}</b></td>\n";
	print "<td><textarea name=vals rows=6 cols=40>",join("\n", @{$self->{'vals_array'}}),
	      "</textarea></td> </tr>\n";
	}
elsif ($self->{'type'} eq "time") {
	local $vals = join(' ', @{$self->{'vals_array'}});
	if ($vals =~ /[A-Z]+/) {
		foreach $d (split(//, $vals)) {
			$self->{'day_hash'}->{$d}++;
			}
		}
	if ($vals =~ /(\d+):(\d+)-(\d+):(\d+)/) {
		$self->{'h1'} = $1; $self->{'m1'} = $2;
		$self->{'h2'} = $3; $self->{'m2'} = $4;
		$self->{'hour'}++;
		}
	print "<tr> <td valign=top><b>$self->{'text_hash'}->{'acl_dofw'}</b></td> <td>\n";
	printf "<input type=radio name=day_def value=1 %s> $self->{'text_hash'}->{'acl_all'}\n",
		%{$self->{'day_hash'}} ? "" : "checked";
	printf "<input type=radio name=day_def value=0 %s> $self->{'text_hash'}->{'acl_sel'}<br>\n",
		%{$self->{'day_hash'}} ? "checked" : "";
	%{$self->{'day_name_hash'}} = ( 'S', $self->{'text_hash'}->{'acl_dsun'}, 
                      'M', $self->{'text_hash'}->{'acl_dmon'}, 
                      'T', $self->{'text_hash'}->{'acl_dtue'},
		      'W', $self->{'text_hash'}->{'acl_dwed'}, 
                      'H', $self->{'text_hash'}->{'acl_dthu'}, 
                      'F', $self->{'text_hash'}->{'acl_dfri'},
		      'A', $self->{'text_hash'}->{'acl_dsat'} );
	print "<select name=day multiple size=7>\n";
	foreach $d ('S', 'M', 'T', 'W', 'H', 'F', 'A') {
		printf "<option value=$d %s> $self->{'day_name_hash'}->{$d}\n",
			$self->{'day_hash'}->{$d} ? "selected" : "";
		}
	print "</select></td> </tr>\n";

	print "<tr> <td valign=top><b>$self->{'text_hash'}->{'acl_hofd'}</b></td> <td>\n";
	printf "<input type=radio name=hour_def value=1 %s> $self->{'text_hash'}->{'acl_all'}\n",
		$self->{'hour'} ? "" : "checked";
	printf "&nbsp;<input type=radio name=hour_def value=0 %s>\n",
		$self->{'hour'} ? "checked" : "";
	print "<input name=h1 size=2 value=\"$self->{'h1'}\">:";
	print "<input name=m1 size=2 value=\"$self->{'m1'}\"> $self->{'text_hash'}->{'acl_to'} ";
	print "<input name=h2 size=2 value=\"$self->{'h2'}\">:";
	print "<input name=m2 size=2 value=\"$self->{'m2'}\"></td> </tr>\n";
	}
elsif ($self->{'type'} eq "url_regex") {
	print "<tr> <td valign=top><b>$self->{'text_hash'}->{'acl_regexp'}</b></td>\n";
	local $caseless;
	if ($self->{'vals_array'}->[0] eq '-i') {
		$caseless++;
		shift(@{$self->{'vals_array'}});
		}
	printf "<td><input type=checkbox name=caseless value=1 %s> %s<br>\n",
		$caseless ? 'checked' : '', $self->{'text_hash'}->{'acl_case'};
	print "<textarea name=vals rows=6 cols=40>",join("\n", @{$self->{'vals_array'}}),
	      "</textarea></td> </tr>\n";
	}
elsif ($self->{'type'} eq "urlpath_regex") {
	print "<tr> <td valign=top><b>$self->{'text_hash'}->{'acl_regexp'}</b></td>\n";
	local $caseless;
	if ($self->{'vals_array'}->[0] eq '-i') {
		$caseless++;
		shift(@{$self->{'vals_array'}});
		}
	printf "<td><input type=checkbox name=caseless value=1 %s> %s<br>\n",
		$caseless ? 'checked' : '', $self->{'text_hash'}->{'acl_case'};
	print "<textarea name=vals rows=6 cols=40>",join("\n", @{$self->{'vals_array'}}),
	      "</textarea></td> </tr>\n";
	}
elsif ($self->{'type'} eq "port") {
	print "<tr> <td valign=top><b>$self->{'text_hash'}->{'acl_tcpports'}</b></td>\n";
	printf "<td><input name=vals size=30 value=\"%s\"></td> </tr>\n",
		join(" ", @{$self->{'vals_array'}});
	}
elsif ($self->{'type'} eq "proto") {
	print "<tr> <td valign=top><b>$self->{'text_hash'}->{'acl_urlproto'}</b></td> <td>\n";
	foreach $p (@{$self->{'vals_array'}}) { $self->{'proto_hash'}->{$p}++; }
	foreach $p ('http', 'ftp', 'gopher', 'wais', 'cache_object') {
		printf "<input type=checkbox name=vals value=$p %s> $p\n",
			$self->{'proto_hash'}->{$p} ? "checked" : "";
		}
	print "</td> </tr>\n";
	}
elsif ($self->{'type'} eq "method") {
	print "<tr> <td valign=top><b>$self->{'text_hash'}->{'acl_reqmethods'}</b></td> <td>\n";
	foreach $m (@{$self->{'vals_array'}}) { $self->{'meth_hash'}->{$m}++; }
	foreach $m ('GET', 'POST', 'HEAD', 'CONNECT', 'PUT', 'DELETE') {
		printf "<input type=checkbox name=vals value=$m %s> $m\n",
			$self->{'meth_hash'}->{$m} ? "checked" : "";
		}
	print "</td> </tr>\n";
	}
elsif ($self->{'type'} eq "browser") {
	print "<tr> <td valign=top><b>$self->{'text_hash'}->{'acl_bregexp'}</b></td>\n";
	printf "<td><input name=vals size=30 value=\"%s\"></td> </tr>\n",
		join(' ', @{$self->{'vals_array'}});
	}
elsif ($self->{'type'} eq "user") {
	print "<tr> <td valign=top><b>$self->{'text_hash'}->{'acl_pusers'}</b></td>\n";
	print "<td><textarea name=vals rows=6 cols=40 wrap>",
		join("\n", @{$self->{'vals_array'}}),"</textarea></td> </tr>\n";
	}
elsif ($self->{'type'} eq "src_as" || $self->{'type'} eq "dst_as") {
	print "<tr> <td valign=top><b>$self->{'text_hash'}->{'acl_asnum'}</b></td>\n";
	printf "<td><input name=vals size=20 value=\"%s\"></td> </tr>\n",
		join(' ', @{$self->{'vals_array'}});
	}
elsif ($self->{'type'} eq "proxy_auth" && $self->{'squid_version'} < 2.3) {
	print "<tr> <td valign=top><b>$self->{'text_hash'}->{'acl_rtime'}</b></td>\n";
	print "<td><input name=vals size=8 value=\"$self->{'vals_array'}->[0]\"></td> </tr>\n";
	}
elsif ($self->{'type'} eq "proxy_auth" && $self->{'squid_version'} >= 2.3) {
	print "<tr> <td valign=top><b>$self->{'text_hash'}->{'acl_eusers'}</b></td>\n";
	printf "<td><input type=radio name=authall value=1 %s> %s\n",
		$self->{'vals_array'}->[0] eq 'REQUIRED' || $self->{'in_hash'}->{'type'} ? "checked" : "",
		$self->{'text_hash'}->{'acl_eusersall'};
	printf "<input type=radio name=authall value=0 %s> %s<br>\n",
		$self->{'vals_array'}->[0] eq 'REQUIRED' || $self->{'in_hash'}->{'type'} ? "" : "checked",
		$self->{'text_hash'}->{'acl_euserssel'};
	print "<textarea name=vals rows=6 cols=40 wrap>",
		$self->{'vals_array'}->[0] eq 'REQUIRED' || $self->{'in_hash'}->{'type'} ? "" : join("\n", @{$self->{'vals_array'}}),
		"</textarea></td> </tr>\n";
	}
elsif ($self->{'type'} eq "proxy_auth_regex") {
	print "<tr> <td valign=top><b>$self->{'text_hash'}->{'acl_eusers'}</b></td>\n";
	local $caseless;
	if ($self->{'vals_array'}->[0] eq '-i') {
		$caseless++;
		shift(@{$self->{'vals_array'}});
		}
	printf "<td><input type=checkbox name=caseless value=1 %s> %s<br>\n",
		$caseless ? 'checked' : '', $self->{'text_hash'}->{'acl_case'};
	print "<textarea name=vals rows=6 cols=40 wrap>",
		join("\n", @{$self->{'vals_array'}}),"</textarea></td> </tr>\n";
	}
elsif ($self->{'type'} eq "srcdom_regex" || $self->{'type'} eq "dstdom_regex") {
	print "<tr> <td valign=top><b>$self->{'text_hash'}->{'acl_regexp'}</b></td>\n";
	local $caseless;
	if ($self->{'vals_array'}->[0] eq '-i') {
		$caseless++;
		shift(@{$self->{'vals_array'}});
		}
	printf "<td><input type=checkbox name=caseless value=1 %s> %s<br>\n",
		$caseless ? 'checked' : '', $self->{'text_hash'}->{'acl_case'};
	print "<textarea name=vals rows=6 cols=40>",join("\n", @{$self->{'vals_array'}}),
	      "</textarea></td> </tr>\n";
	}
elsif ($self->{'type'} eq "ident") {
	print "<tr> <td valign=top><b>$self->{'text_hash'}->{'acl_rfcusers'}</b></td>\n";
	print "<td><textarea name=vals rows=6 cols=40 wrap>",
		join(' ', @{$self->{'vals_array'}}),"</textarea></td> </tr>\n";
	}
elsif ($self->{'type'} eq "ident_regex") {
	print "<tr> <td valign=top><b>$self->{'text_hash'}->{'acl_rfcusersr'}</b></td>\n";
	local $caseless;
	if ($self->{'vals_array'}->[0] eq '-i') {
		$caseless++;
		shift(@{$self->{'vals_array'}});
		}
	printf "<td><input type=checkbox name=caseless value=1 %s> %s<br>\n",
		$caseless ? 'checked' : '', $self->{'text_hash'}->{'acl_case'};
	print "<textarea name=vals rows=6 cols=40 wrap>",
		join("\n", @{$self->{'vals_array'}}),"</textarea></td> </tr>\n";
	}
elsif ($self->{'type'} eq "maxconn") {
	print "<tr> <td valign=top><b>$self->{'text_hash'}->{'acl_mcr'}</b></td>\n";
	print "<td><input name=vals size=8 value=\"$self->{'vals_array'}->[0]\"></td> </tr>\n";
	}
elsif ($self->{'type'} eq "max_user_ip") {
	local $mipstrict;
	if ($self->{'vals_array'}->[0] eq '-s') {
		$mipstrict++;
		shift(@{$self->{'vals_array'}});
	}
	print "<tr><td><b>$self->{'text_hash'}->{'acl_mai'}</b></td><td><input name=vals size=8 value=\"$self->{'vals_array'}->[0]\"></td> </tr>\n";
#	print "<tr> <td valign=top><b>$self->{'text_hash'}->{'acl_extargs'}</b></td>\n";
	print "<tr><td>$self->{'text_hash'}->{'acl_maistrict'}</td>";
	printf "<td><input type=checkbox name=strict value=1 %s></td></tr>\n",
		$mipstrict ? 'checked' : '';
	print "<tr><td colspan=2>$self->{'text_hash'}->{'acl_mairemind'}</td></tr>";

#	printf "<td><input name=args size=25 value=\"%s\"></td> </tr>\n",
#		join(" ", @{$self->{'vals_array'}}[0]);
	}

elsif ($self->{'type'} eq "myport") {
	print "<tr> <td valign=top><b>$self->{'text_hash'}->{'acl_psp'}</b></td>\n";
	print "<td><input name=vals size=8 value=\"$self->{'vals_array'}->[0]\"></td> </tr>\n";
	}
elsif ($self->{'type'} eq "snmp_community") {
	print "<tr> <td valign=top><b>$self->{'text_hash'}->{'acl_scs'}</b></td>\n";
	print "<td><input name=vals size=15 value=\"$self->{'vals_array'}->[0]\"></td> </tr>\n";
	}
elsif ($self->{'type'} eq "req_mime_type") {
	print "<tr> <td valign=top><b>$self->{'text_hash'}->{'acl_rmt'}</b></td>\n";
	print "<td><input name=vals size=15 value=\"$self->{'vals_array'}->[0]\"></td> </tr>\n";
	}
elsif ($self->{'type'} eq "rep_mime_type") {
	print "<tr> <td valign=top><b>$self->{'text_hash'}->{'acl_rpmt'}</b></td>\n";
	print "<td><input name=vals size=15 value=\"$self->{'vals_array'}->[0]\"></td> </tr>\n";
	}
elsif ($self->{'type'} eq "arp") {
	print "<tr> <td valign=top><b>$self->{'text_hash'}->{'acl_arp'}</b></td>\n";
	print "<td><textarea name=vals rows=6 cols=40>",join("\n", @{$self->{'vals_array'}}),
	      "</textarea></td> </tr>\n";
	}
elsif ($self->{'type'} eq "external") {
	print "<tr> <td valign=top><b>$self->{'text_hash'}->{'acl_extclass'}</b></td>\n";
	print "<td><select name=class>\n";
	foreach $c ($self->find_config("external_acl_type", $self->{'conf'})) {
		printf "<option %s>%s\n",
			$c->{'values'}->[0] eq $self->{'vals_array'}->[0] ? "selected" : "",
			$c->{'values'}->[0];
		}
	print "</select></td> </tr>\n";
	print "<tr> <td valign=top><b>$self->{'text_hash'}->{'acl_extargs'}</b></td>\n";
	printf "<td><input name=args size=25 value=\"%s\"></td> </tr>\n",
		join(" ", @{$self->{'vals_array'}}[1..$#{$self->{'vals_array'}}]);
	}

# Show URL to redirect on failure
print "<tr> <td><b>$self->{'text_hash'}->{'acl_failurl'}</b></td>\n";
printf "<td><input name=deny size=35 value=\"%s\"></td> </tr>\n",
	@{$self->{'deny_array'}} ? $self->{'deny_array'}->[0]->{'values'}->[0] : "";

# Show file in which ACL is stored
print "<tr> <td><b>$self->{'text_hash'}->{'acl_file'}</b></td>\n";
print "<td>",$self->ui_opt_textbox("file", $self->{'file'}, 40, $self->{'text_hash'}->{'acl_nofile'}),
      " ",$self->file_chooser_button("file"),"</td> </tr>\n";

if ($self->{'in_hash'}->{'type'}) {
	print "<tr> <td></td>\n";
	print "<td>",$self->ui_checkbox("keep", 1, $self->{'text_hash'}->{'acl_keep'}, 0),"</td> </tr>\n";
	}

print "</table></td></tr></table>\n";
print "<input type=submit value=$self->{'text_hash'}->{'acl_buttsave'}>\n";
if (!$self->{'in_hash'}->{'type'}) { print "<input type=submit value=$self->{'text_hash'}->{'acl_buttdel'} name=delete>\n"; }
print "</form>\n";

$self->ui_print_footer("edit_acl.cgi", $self->{'text_hash'}->{'acl_return'},
	"", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

