#!/usr/bin/perl

&MAIN();

 sub MAIN {
# acl_save.cgi
# Save or delete an ACL

&ModuleLoader::preload_module('squid_class', "squid::SquidLib");
$self = new squid::SquidLib:: 'squid_class',%$self;

$self->{'access_hash'}->{'actrl'} || $self->error($self->{'text_hash'}->{'eacl_ecannot'});
$self->ReadParseMime();
$self->lock_file($self->{'config_hash'}->{'squid_conf'});
$self->{'conf'} = $self->get_config();
$self->{'whatfailed'} = $self->{'text_hash'}->{'aclsave_failsave'};

@{$self->{'acls_array'}} = $self->find_config("acl", $self->{'conf'});
@{$self->{'denys_array'}} = $self->find_config("deny_info", $self->{'conf'});
if (defined($self->{'in_hash'}->{'index'})) {
	$self->{'acl'} = $self->{'conf'}->[$self->{'in_hash'}->{'index'}];
	}
if (defined($self->{'in_hash'}->{'dindex'})) {
	$self->{'deny'} = $self->{'conf'}->[$self->{'in_hash'}->{'dindex'}];
	}
if ($self->{'in_hash'}->{'delete'}) {
	# Is there more than one ACL with this name?
	$self->{'name'} = $self->{'acl'}->{'values'}->[0];
	foreach $a ($self->find_config("acl", $self->{'conf'})) {
		$self->{'count'}++ if ($a->{'values'}->[0] eq $self->{'name'});
		}

	# Is this ACL in use?
	$self->{'whatfailed'} = $self->{'text_hash'}->{'aclsave_faildel'};
	if ($self->{'count'} == 1) {
		foreach $h ($self->find_config("http_access", $self->{'conf'})) {
			@v = @{$h->{'values'}};
			for($i=1; $i<@v;  $i++) {
				if ($v[$i] eq $self->{'name'} || $v[$i] eq "!$self->{'name'}") {
					$self->error($self->{'text_hash'}->{'aclsave_epr'});
					}
				}
			}
		foreach $h ($self->find_config("icp_access", $self->{'conf'})) {
			@v = @{$h->{'values'}};
			for($i=1; $i<@v;  $i++) {
				if ($v[$i] eq $self->{'in_hash'}->{'name'} ||
				    $v[$i] eq "!$self->{'in_hash'}->{'name'}") {
					$self->error($self->{'text_hash'}->{'aclsave_eicpr'});
					}
				}
			}
		}
	splice(@{$self->{'acls_array'}}, $self->indexof($self->{'acl'}, @{$self->{'acls_array'}}), 1);
	if ($self->{'deny'}) { splice(@{$self->{'denys_array'}}, $self->indexof($self->{'deny'}, @{$self->{'denys_array'}}), 1); }
	$self->{'logacl'} = $self->{'acl'};
	}
else {
	# Check ACL details
	$self->{'in_hash'}->{'name'} =~ /^\S+$/ || $self->error($self->{'text_hash'}->{'aclsave_ename'});
	$self->{'changed'}++ if ($self->{'acl'} && $self->{'in_hash'}->{'name'} ne $self->{'acl'}->{'values'}->[0]);
	for($i=0; $i<@{$self->{'acls_array'}}; $i++) {
		if ($self->{'changed'} && $self->{'acls_array'}->[$i]->{'values'}->[0] eq $self->{'in_hash'}->{'name'}) {
			$self->error($self->text('aclsave_eexists',$self->{'in_hash'}->{'name'}));
			}
		}

	if ($self->{'in_hash'}->{'type'} eq "src" || $self->{'in_hash'}->{'type'} eq "dst") {
		for($i=0; defined($self->{'from'} = $self->{'in_hash'}->{"from_$i"}); $i++) {
			$self->{'to'} = $self->{'in_hash'}->{"to_$i"}; $self->{'mask'} = $self->{'in_hash'}->{"mask_$i"};
			next if (!$self->{'from'} && !$self->{'to'} && !$self->{'mask'});
			$self->check_ipaddress($self->{'from'}) ||
			       $self->error($self->text('aclsave_efrom',$self->{'from'}));
			!$self->{'to'} || $self->check_ipaddress($self->{'to'}) ||
			       $self->error($self->text('aclsave_eto',$self->{'to'}));
			$self->{'mask'} =~ /^\d*$/ || $self->check_ipaddress($self->{'mask'}) ||
			       $self->error($self->text('aclsave_enmask',$self->{'mask'}));
			if ($self->{'to'} && $self->{'mask'}) { push(@{$self->{'vals_array'}}, "$self->{'from'}-$self->{'to'}/$self->{'mask'}"); }
			elsif ($self->{'to'}) { push(@{$self->{'vals_array'}}, "$self->{'from'}-$self->{'to'}"); }
			elsif ($self->{'mask'}) { push(@{$self->{'vals_array'}}, "$self->{'from'}/$self->{'mask'}"); }
			else { push(@{$self->{'vals_array'}}, $self->{'from'}); }
			}
		}
	elsif ($self->{'in_hash'}->{'type'} eq "myip") {
		for($i=0; defined($self->{'ip'} = $self->{'in_hash'}->{"ip_$i"}); $i++) {
			$self->{'mask'} = $self->{'in_hash'}->{"mask_$i"};
			next if (!$self->{'mask'} || !$self->{'ip'});
			$self->check_ipaddress($self->{'ip'}) ||
				$self->error($self->text('aclsave_eip',$self->{'ip'}));
			$self->{'mask'} =~ /^\d+$/ || $self->check_ipaddress($self->{'mask'}) ||
			       $self->error($self->text('aclsave_enmask',$self->{'mask'}));
			push(@{$self->{'vals_array'}}, "$self->{'ip'}/$self->{'mask'}");
			}
		}
	elsif ($self->{'in_hash'}->{'type'} eq "srcdomain") {
		push(@{$self->{'vals_array'}}, split(/\s+/, $self->{'in_hash'}->{'vals'}));
		if (!@{$self->{'vals_array'}} && !$self->{'in_hash'}->{'keep'}) { $self->error($self->{'text_hash'}->{'aclsave_ecdom'}); }
		}
	elsif ($self->{'in_hash'}->{'type'} eq "dstdomain") {
		push(@{$self->{'vals_array'}}, split(/\s+/, $self->{'in_hash'}->{'vals'}));
		if (!@{$self->{'vals_array'}} && !$self->{'in_hash'}->{'keep'}) { $self->error($self->{'text_hash'}->{'aclsave_esdom'}); }
		}
	elsif ($self->{'in_hash'}->{'type'} eq "time") {
		if (!$self->{'in_hash'}->{'day_def'}) {
			push(@{$self->{'vals_array'}}, join('', split(/\0/, $self->{'in_hash'}->{'day'})));
			}
		if (!$self->{'in_hash'}->{'hour_def'}) {
			$self->{'in_hash'}->{'h1'} =~ /^\d+$/ || $self->error($self->{'text_hash'}->{'aclsave_eshour'});
			$self->{'in_hash'}->{'h2'} =~ /^\d+$/ || $self->error($self->{'text_hash'}->{'aclsave_eehour'});
			$self->{'in_hash'}->{'m1'} =~ /^\d+$/ || $self->error($self->{'text_hash'}->{'aclsave_esmin'});
			$self->{'in_hash'}->{'m2'} =~ /^\d+$/ || $self->error($self->{'text_hash'}->{'aclsave_eemin'});
			push(@{$self->{'vals_array'}}, "$self->{'in_hash'}->{'h1'}:$self->{'in_hash'}->{'m1'}-$self->{'in_hash'}->{'h2'}:$self->{'in_hash'}->{'m2'}");
			}
		}
	elsif ($self->{'in_hash'}->{'type'} eq "url_regex") {
		push(@{$self->{'vals_array'}}, "-i") if ($self->{'in_hash'}->{'caseless'});
		push(@{$self->{'vals_array'}}, split(/\s+/, $self->{'in_hash'}->{'vals'}));
		}
	elsif ($self->{'in_hash'}->{'type'} eq "urlpath_regex") {
		push(@{$self->{'vals_array'}}, "-i") if ($self->{'in_hash'}->{'caseless'});
		push(@{$self->{'vals_array'}}, split(/\s+/, $self->{'in_hash'}->{'vals'}));
		}
	elsif ($self->{'in_hash'}->{'type'} eq "port") {
		push(@{$self->{'vals_array'}}, split(/\s+/, $self->{'in_hash'}->{'vals'}));
		}
	elsif ($self->{'in_hash'}->{'type'} eq "proto") {
		push(@{$self->{'vals_array'}}, split(/\0/, $self->{'in_hash'}->{'vals'}));
		}
	elsif ($self->{'in_hash'}->{'type'} eq "method") {
		push(@{$self->{'vals_array'}}, split(/\0/, $self->{'in_hash'}->{'vals'}));
		}
	elsif ($self->{'in_hash'}->{'type'} eq "browser" || $self->{'in_hash'}->{'type'} eq "snmp_community"
            || $self->{'in_hash'}->{'type'} eq "req_mime_type" || $self->{'in_hash'}->{'type'} eq "rep_mime_type") {
		push(@{$self->{'vals_array'}}, $self->{'in_hash'}->{'vals'});
		}
	elsif ($self->{'in_hash'}->{'type'} eq "user" || $self->{'in_hash'}->{'type'} eq "ident") {
		push(@{$self->{'vals_array'}}, split(/\s+/, $self->{'in_hash'}->{'vals'}));
		}
	elsif ($self->{'in_hash'}->{'type'} eq "src_as" || $self->{'in_hash'}->{'type'} eq "dst_as") {
		push(@{$self->{'vals_array'}}, split(/\s+/, $self->{'in_hash'}->{'vals'}));
		}
	elsif ($self->{'in_hash'}->{'type'} eq "proxy_auth" && $self->{'squid_version'} < 2.3) {
		push(@{$self->{'vals_array'}}, $self->{'in_hash'}->{'vals'}) if ($self->{'in_hash'}->{'vals'});
		}
	elsif ($self->{'in_hash'}->{'type'} eq "proxy_auth" && $self->{'squid_version'} >= 2.3) {
		push(@{$self->{'vals_array'}}, $self->{'in_hash'}->{'authall'} ? "REQUIRED"
					   : split(/\s+/, $self->{'in_hash'}->{'vals'}));
		}
	elsif ($self->{'in_hash'}->{'type'} eq "proxy_auth_regex" ||
	       $self->{'in_hash'}->{'type'} eq "ident_regex") {
		push(@{$self->{'vals_array'}}, "-i") if ($self->{'in_hash'}->{'caseless'});
		push(@{$self->{'vals_array'}}, split(/\s+/, $self->{'in_hash'}->{'vals'}));
		}
	elsif ($self->{'in_hash'}->{'type'} eq "srcdom_regex" || $self->{'in_hash'}->{'type'} eq "dstdom_regex") {
		push(@{$self->{'vals_array'}}, "-i") if ($self->{'in_hash'}->{'caseless'});
		push(@{$self->{'vals_array'}}, split(/\s+/, $self->{'in_hash'}->{'vals'}));
		}
	elsif ($self->{'in_hash'}->{'type'} eq "myport") {
		$self->{'in_hash'}->{'vals'} =~ /^\d+$/ ||
			$self->error("'$self->{'in_hash'}->{'vals'}' is not a valid port number");
		push(@{$self->{'vals_array'}}, $self->{'in_hash'}->{'vals'});
		}
	elsif ($self->{'in_hash'}->{'type'} eq "maxconn") {
		$self->{'in_hash'}->{'vals'} =~ /^\d+$/ ||
		    $self->error("'$self->{'in_hash'}->{'vals'}' is not a valid number of requests");
		push(@{$self->{'vals_array'}}, $self->{'in_hash'}->{'vals'});
		}
	elsif ($self->{'in_hash'}->{'type'} eq "arp") {
		push(@{$self->{'vals_array'}}, split(/\s+/, $self->{'in_hash'}->{'vals'}));
		}
	elsif ($self->{'in_hash'}->{'type'} eq "external") {
		$self->{'in_hash'}->{'class'} || $self->error($self->{'text_hash'}->{'eacl_eclass'});
		push(@{$self->{'vals_array'}}, $self->{'in_hash'}->{'class'});
		push(@{$self->{'vals_array'}}, split(/\s+/, $self->{'in_hash'}->{'args'}));
		}
	elsif ($self->{'in_hash'}->{'type'} eq "max_user_ip") {
		if($self->{'in_hash'}->{'strict'}){
			push(@{$self->{'vals_array'}}, '-s');
		}
		push(@{$self->{'vals_array'}}, $self->{'in_hash'}->{'vals'});
		}

	if (!$self->{'in_hash'}->{'file_def'}) {
		# Writing to an external file
		$self->{'in_hash'}->{'file'} || $self->error($self->{'text_hash'}->{'aclsave_enofile'});
		$self->can_access($self->{'in_hash'}->{'file'}) ||
			$self->error($self->text('aclsave_efile', $self->{'in_hash'}->{'file'}));
		if ($self->{'in_hash'}->{'type'} eq 'external' ||
		    $self->indexof($self->{'in_hash'}->{'type'}, @{$self->{'caseless_acl_types_array'}}) >= 0 &&
		    $self->{'vals_array'}->[0] eq "-i") {
			# Special case .. first parameter does NOT go into file
			@{$self->{'notvals_array'}} = ( shift(@{$self->{'vals_array'}}) );
			}
		if (!$self->{'in_hash'}->{'keep'}) {
			if (!$self->{'acl'} && -e $self->{'in_hash'}->{'file'}) {
				$self->error($self->{'text_hash'}->{'aclsave_ealready'});
				}
			$self->open_lock_tempfile(FILE, ">$self->{'in_hash'}->{'file'}");
			foreach $v (@{$self->{'vals_array'}}) {
				$self->print_tempfile(FILE, $v,"\n");
				}
			$self->close_tempfile(FILE);
			}
		@{$self->{'vals_array'}} = ( $self->{'in_hash'}->{'name'}, $self->{'in_hash'}->{'type'}, @{$self->{'notvals_array'}}, "\"$self->{'in_hash'}->{'file'}\"" );
		}
	else {
		# Just saving in Squid config directly
		if ($self->{'vals_array'}->[0] =~ /^"(.*)"$/) {
			local $f = $1;
			$self->can_access($f) ||
				$self->error($self->text('aclsave_efile', $f));
			if ($f !~ /^\// && $self->{'access_hash'}->{'root'} ne '/') {
				$self->{'vals_array'}->[0] = "\"$self->{'access_hash'}->{'root'}/$f\"";
				}
			
			}
		@{$self->{'vals_array'}} = ( $self->{'in_hash'}->{'name'}, $self->{'in_hash'}->{'type'}, @{$self->{'vals_array'}} );
		}
	$self->{'logacl'} = $self->{'newacl'} = { 'name' => 'acl', 'values' => \@{$self->{'vals_array'}} };
	if ($self->{'acl'}) { splice(@{$self->{'acls_array'}}, $self->indexof($self->{'acl'}, @{$self->{'acls_array'}}), 1, $self->{'newacl'}); }
	else { push(@{$self->{'acls_array'}}, $self->{'newacl'}); }

	$self->{'newdeny'} = { 'name' => 'deny_info',
		     'values' => [ $self->{'in_hash'}->{'deny'}, $self->{'vals_array'}->[0] ] };
	$self->{'didx'} = $self->indexof($self->{'deny'}, @{$self->{'denys_array'}});
	if ($self->{'deny'} && $self->{'in_hash'}->{'deny'}) { $self->{'denys_array'}->[$self->{'didx'}] = $self->{'newdeny'}; }
	elsif ($self->{'deny'}) { splice(@{$self->{'denys_array'}}, $self->{'didx'}, 1); }
	elsif ($self->{'in_hash'}->{'deny'}) { push(@{$self->{'denys_array'}}, $self->{'newdeny'}); }

	# Update http_access and icp_access directives if the ACL was renamed
	if ($self->{'changed'}) {
		@{$self->{'https_array'}} = $self->find_config("http_access", $self->{'conf'});
		@{$self->{'icps_array'}} = $self->find_config("icp_access", $self->{'conf'});
		$self->{'on'} = $self->{'acl'}->{'values'}->[0];
		foreach $c (@{$self->{'https_array'}}, @{$self->{'icps_array'}}) {
			for($j=1; $j<@{$c->{'values'}}; $j++) {
				if ($c->{'values'}->[$j] eq $self->{'on'}) {
					$c->{'values'}->[$j] = $self->{'in_hash'}->{'name'};
					}
				elsif ($c->{'values'}->[$j] eq "!$self->{'on'}") {
					$c->{'values'}->[$j] = "!$self->{'in_hash'}->{'name'}";
					}
				}
			}
		$self->save_directive($self->{'conf'}, "http_access", \@{$self->{'https_array'}});
		$self->save_directive($self->{'conf'}, "icp_access", \@{$self->{'icps_array'}});
		}
	}
$self->save_directive($self->{'conf'}, "acl", \@{$self->{'acls_array'}});
$self->save_directive($self->{'conf'}, "deny_info", \@{$self->{'denys_array'}});
$self->flush_file_lines();
$self->unlock_file($self->{'config_hash'}->{'squid_conf'});
$self->webmin_log($self->{'in_hash'}->{'delete'} ? 'delete' : $self->{'acl'} ? 'modify' : 'create',
	    'acl', $self->{'logacl'}->{'values'}->[0], \%{$self->{'in_hash'}});
$self->redirect("edit_acl.cgi");

1;
		
}


1;

