#!/usr/bin/perl

&MAIN();

 sub MAIN {
# calamaris.cgi
# Run calamaris on the squid logfile(s)

&ModuleLoader::preload_module('squid_class', "squid::SquidLib");
$self = new squid::SquidLib:: 'squid_class',%$self;

$self->{'access_hash'}->{'calamaris'} || $self->error($self->{'text_hash'}->{'calamaris_ecannot'});
$self->ui_print_header(undef, $self->{'text_hash'}->{'calamaris_title'}, "");

# is calamaris installed?
if (!$self->has_command($self->{'config_hash'}->{'calamaris'})) {
	print $self->text('calamaris_eprog', "<tt>$self->{'config_hash'}->{'calamaris'}</tt>",
		  "$self->{'gconfig_hash'}->{'webprefix'}/config.cgi?$self->{'module_name'}"),"<p>\n";
	$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
	exit;
	}

# Work out Calamaris version and args
if (`$self->{'config_hash'}->{'calamaris'} -V 2>&1` =~ /revision:\s+(\S+)/i) {
	$self->{'ver'} = $1;
	}
$self->{'args'} = $self->{'config_hash'}->{'cal_all'} ? " -a" : "";
if ($self->{'ver'} >= 2.5) {
	if ($self->{'config_hash'}->{'cal_fmt'} eq 'w') {
		$self->{'args'} .= " -F html";
		}
	else {
		$self->{'args'} .= " -F mail";
		}
	}
else {
	$self->{'args'} .= " -".$self->{'config_hash'}->{'cal_fmt'};
	}
$self->{'args'} .= " $self->{'config_hash'}->{'cal_extra'}";

# are there any logfiles to analyse?
$self->{'ld'} = $self->{'config_hash'}->{'log_dir'};
opendir(DIR, $self->{'ld'});
while($f = readdir(DIR)) {
	local @st = stat("$self->{'ld'}/$f");
	if ($f =~ /^access.log.*gz$/) {
		push(@{$self->{'files_array'}}, [ "gunzip -c $self->{'ld'}/$f |", $st[9] ]);
		}
	elsif ($f =~ /^access.log.*Z$/) {
		push(@{$self->{'files_array'}}, [ "uncompress -c $self->{'ld'}/$f |", $st[9] ]);
		}
	elsif ($f =~ /^access.log/) {
		push(@{$self->{'files_array'}}, [ "$self->{'ld'}/$f", $st[9] ]);
		}
	}
closedir(DIR);
if (!@{$self->{'files_array'}}) {
	print $self->text('calamaris_elogs', "<tt>$self->{'ld'}</tt>",
		  "$self->{'gconfig_hash'}->{'webprefix'}/config.cgi?$self->{'module_name'}"),"<p>\n";
	$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
	exit;
	}

# run calamaris, parsing newest files and records first
$self->{'temp'} = $self->transname();
open(CAL, "| $self->{'config_hash'}->{'calamaris'} $self->{'args'} >$self->{'temp'} 2>/dev/null");
if ($self->{'config_hash'}->{'cal_max'}) {
	# read only the last N lines
	print $self->text('calamaris_last', $self->{'config_hash'}->{'cal_max'}),"<p>\n";
	@{$self->{'files_array'}} = sort { $b->[1] <=> $a->[1] } @{$self->{'files_array'}};
	$self->{'lnum'} = 0;
	foreach $f (@{$self->{'files_array'}}) {
		$self->{'left'} = $self->{'config_hash'}->{'cal_max'} - $self->{'lnum'};
		last if ($self->{'left'} <= 0);
		if ($f->[0] =~ /\|$/) {
			open(LOG, "$f->[0] tail -$self->{'left'} |");
			}
		else {
			open(LOG, "tail -$self->{'left'} $f->[0] |");
			}
		while(<LOG>) {
			print CAL $_;
			$self->{'lnum'}++;
			}
		close(LOG);
		}
	}
else {
	# read all the log files
	foreach $f (@{$self->{'files_array'}}) {
		open(LOG, $f->[0]);
		while(read(LOG, $self->{'buf'}, 1024) > 0) {
			print CAL $self->{'buf'};
			}
		close(LOG);
		}
	}
close(CAL);

# Put the calamaris output into a nice webmin like table.
$self->{'date'} = localtime(time());
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>",$self->text('calamaris_gen', $self->{'date'}),"</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td>\n";

open(OUT, $self->{'temp'});
if ($self->{'config_hash'}->{'cal_fmt'} eq 'm') {
	print "<pre>";
	while(<OUT>) {
		print $self->html_escape($_);
		}
	print "</pre>\n";
	}
else {
	while(<OUT>) {
		if (/<\s*\/head/i || /<\s*body/i) { $self->{'inbody'} = 1; }
		elsif (/<\s*\/body/i) { $self->{'inbody'} = 0; }
		elsif ($self->{'inbody'}) { print; }
		}
	}
close(OUT);
unlink($self->{'temp'});

# Close it.
print "</td></tr></table><p>";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

