#!/usr/bin/perl

&MAIN();

 sub MAIN {
# clear.cgi
# Delete the cache, chown the directory to the correct user and re-run squid -z

&ModuleLoader::preload_module('squid_class', "squid::SquidLib");
$self = new squid::SquidLib:: 'squid_class',%$self;

$self->{'access_hash'}->{'rebuild'} || $self->error($self->{'text_hash'}->{'clear_ecannot'});
$self->ReadParse();
$self->{'config_hash'}->{'cache_dir'} =~ /^\/\S+/ || $self->error("Cache directory not set");
$self->{'conf'} = $self->get_config();

if (!$self->{'in_hash'}->{'confirm'}) {
	# Ask the user if he is sure
	$self->ui_print_header(undef, $self->{'text_hash'}->{'clear_header'}, "");
	print $self->{'text_hash'}->{'clear_msgclear'},"<br>\n";
	print $self->{'text_hash'}->{'clear_msgclear2'},"<p>\n";
	print "<form action=clear.cgi>\n";
	print "<center><input type=submit name=confirm ",
	      "value=\"$self->{'text_hash'}->{'clear_buttclear'}\"></center></form>\n";

	if ($self->has_command($self->{'config_hash'}->{'squidclient'})) {
		# Show form to clear just one URL
		print "<hr>\n";
		print $self->ui_form_start("purge.cgi");
		print "<b>$self->{'text_hash'}->{'clear_url'}</b>\n";
		print $self->ui_textbox("url", undef, 50),"\n";
		print $self->ui_submit($self->{'text_hash'}->{'clear_ok'}),"\n";
		print $self->ui_form_end();
		}

	$self->ui_print_footer("", $self->{'text_hash'}->{'clear_return'});
	exit;
	}

$self->ui_print_unbuffered_header(undef, $self->{'text_hash'}->{'clear_header'}, "");

# Stop squid (if running)
if ($self->{'pidstruct'} = $self->find_config("pid_filename", $self->{'conf'})) {
	$self->{'pidfile'} = $self->{'pidstruct'}->{'values'}->[0];
	}
else { $self->{'pidfile'} = $self->{'config_hash'}->{'pid_file'}; }
if (open(PID, $self->{'pidfile'})) {
	<PID> =~ /(\d+)/; $self->{'pid'} = $1;
	close(PID);
	}
if ($self->{'pid'} && kill(0, $self->{'pid'})) {
	print "$self->{'text_hash'}->{'clear_stop'}<br>\n";
	$self->system_logged("$self->{'config_hash'}->{'squid_path'} -f $self->{'config_hash'}->{'squid_conf'} ".
	               "-k shutdown >/dev/null 2>&1");
	for($i=0; $i<40; $i++) {
		if (!kill(0, $self->{'pid'})) { last; }
		sleep(1);
		}
	print "$self->{'text_hash'}->{'clear_done'}<p>\n";
	$self->{'stopped'}++;
	}

# Get list of cache dirs
if (@{$self->{'cachestruct_array'}} = $self->find_config("cache_dir", $self->{'conf'})) {
	if ($self->{'squid_version'} >= 2.3) {
		@{$self->{'caches_array'}} = map { $_->{'values'}->[1] } @{$self->{'cachestruct_array'}};
		}
	else {
		@{$self->{'caches_array'}} = map { $_->{'values'}->[0] } @{$self->{'cachestruct_array'}};
		}
	}
else { @{$self->{'caches_array'}} = ( $self->{'config_hash'}->{'cache_dir'} ); }

# Delete old cache files and re-create with same permissions!
print "$self->{'text_hash'}->{'clear_del'}<br>\n";
foreach $c (@{$self->{'caches_array'}}) {
	@{$self->{'st_array'}} = stat($c);
	if (@{$self->{'st_array'}}) {
		$self->system_logged("rm -rf $c/* >/dev/null 2>&1");
		#mkdir($c, 0755);	# only remove contents
		#chown($self->{'st_array'}->[4], $self->{'st_array'}->[5], $c);
		#chmod($self->{'st_array'}->[2], $c);
		}
	}
print "$self->{'text_hash'}->{'clear_done'}<p>\n";

$self->{'cmd'} = "$self->{'config_hash'}->{'squid_path'} -f $self->{'config_hash'}->{'squid_conf'} -z";
print $self->text('clear_init',$self->{'cmd'})."<br>\n";
print "<pre>\n";
$self->additional_log('exec', undef, $self->{'cmd'});
open(INIT, "$self->{'cmd'} 2>&1 |");
while(<INIT>) {
	print $self->html_escape($_);
	}
close(INIT);
print "</pre>\n";
print "$self->{'text_hash'}->{'clear_done'}<p>\n";

# Try to re-start squid
if ($self->{'stopped'}) {
	$self->{'temp'} = $self->transname();
	$self->system_logged("$self->{'config_hash'}->{'squid_path'} -sY -f $self->{'config_hash'}->{'squid_conf'} >$self->{'temp'} 2>&1 </dev/null &");
	sleep(3);
	$self->{'errs'} = `cat $self->{'temp'}`;
	unlink($self->{'temp'});
	if ($self->{'errs'}) {
		$self->system_logged("$self->{'config_hash'}->{'squid_path'} -k shutdown -f $self->{'config_hash'}->{'squid_conf'} >/dev/null 2>&1");
		print "$self->{'text_hash'}->{'clear_failrestart'}<br>\n";
		print "<pre>$self->{'errs'}</pre>\n";
		}
	}

$self->webmin_log("clear");
$self->ui_print_footer("", $self->{'text_hash'}->{'clear_return'});

1;
		
}


1;

