#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Delete a bunch of delay pools

&ModuleLoader::preload_module('squid_class', "squid::SquidLib");
$self = new squid::SquidLib:: 'squid_class',%$self;

$self->error_setup($self->{'text_hash'}->{'dpool_err'});
$self->{'access_hash'}->{'delay'} || $self->error($self->{'text_hash'}->{'delay_ecannot'});
$self->ReadParse();
@d = split(/\0/, $self->{'in_hash'}->{'d'});
@d || $self->error($self->{'text_hash'}->{'dpool_enone'});

# Get the current settings
$self->lock_file($self->{'config_hash'}->{'squid_conf'});
$self->{'conf'} = $self->get_config();
@{$self->{'pools_array'}} = $self->find_config("delay_class", $self->{'conf'});
@{$self->{'params_array'}} = $self->find_config("delay_parameters", $self->{'conf'});
@{$self->{'access_array'}} = $self->find_config("delay_access", $self->{'conf'});
$self->{'pools'} = $self->find_config("delay_pools", $self->{'conf'});

# Do the deletion, highest first
foreach $d (sort { $b <=> $a } @d) {
	($self->{'pool'}) = grep { $_->{'values'}->[0] == $d } @{$self->{'pools_array'}};
	($self->{'param'}) = grep { $_->{'values'}->[0] == $d } @{$self->{'params_array'}};
	@{$self->{'access_array'}} = grep { $_->{'values'}->[0] != $d } @{$self->{'access_array'}};
	@{$self->{'pools_array'}} = grep { $_ ne $self->{'pool'} } @{$self->{'pools_array'}};
	@{$self->{'params_array'}} = grep { $_ ne $self->{'param'} } @{$self->{'params_array'}};
	map { $_->{'values'}->[0]-- if ($_->{'values'}->[0] > $d) } 
		(@{$self->{'access_array'}}, @{$self->{'pools_array'}}, @{$self->{'params_array'}});
	$self->save_directive($self->{'conf'}, "delay_class", \@{$self->{'pools_array'}});
	$self->save_directive($self->{'conf'}, "delay_parameters", \@{$self->{'params_array'}});
	$self->save_directive($self->{'conf'}, "delay_access", \@{$self->{'access_array'}});
	$self->{'pools'}->{'values'}->[0]--;
	$self->save_directive($self->{'conf'}, "delay_pools", [ $self->{'pools'} ]);
	}

$self->flush_file_lines();
$self->unlock_file($self->{'config_hash'}->{'squid_conf'});
$self->webmin_log("delete", "pools", scalar(@d));
$self->redirect("edit_delay.cgi");

1;
		
}


1;

