#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_acl.cgi
# Display a list of all ACLs and restrictions using them

&ModuleLoader::preload_module('squid_class', "squid::SquidLib");
$self = new squid::SquidLib:: 'squid_class',%$self;

$self->{'access_hash'}->{'actrl'} || $self->error($self->{'text_hash'}->{'eacl_ecannot'});
$self->ui_print_header(undef, $self->{'text_hash'}->{'eacl_header'}, "", "edit_acl", 0, 0, 0, $self->restart_button());

$self->{'conf'} = $self->get_config();
print "<table border cellpadding=5 width=100%><tr>\n";
print "<td rowspan=2 valign=top width=50%>\n";

# List all defined access control directives
@{$self->{'acl_array'}} = $self->find_config("acl", $self->{'conf'});
if (@{$self->{'acl_array'}}) {
	print $self->ui_subheading($self->{'text_hash'}->{'eacl_acls'});
	print $self->ui_columns_start([ $self->{'text_hash'}->{'eacl_name'},
				  $self->{'text_hash'}->{'eacl_type'},
				  $self->{'text_hash'}->{'eacl_match'} ], 100);
	foreach $a (@{$self->{'acl_array'}}) {
		@{$self->{'v_array'}} = @{$a->{'values'}};
		local @cols;
		push(@cols, "<a href=\"acl.cgi?index=$a->{'index'}\">".
			    $self->html_escape($self->{'v_array'}->[0])."</a>");
		push(@cols, $self->{'acl_types_hash'}->{$self->{'v_array'}->[1]});
		if ($self->{'v_array'}->[2] =~ /^"(.*)"$/ || $self->{'v_array'}->[3] =~ /^"(.*)"$/) {
			push(@cols, $self->text('eacl_file', "<tt>$1</tt>"));
			}
		else {
			push(@cols, $self->html_escape(join(' ', @{$self->{'v_array'}}[2..$#{$self->{'v_array'}}])));
			}
		print $self->ui_columns_row(\@cols, [ "", "nowrap", "" ]);
		}
	print $self->ui_columns_end();
	}
else {
	print "<b>$self->{'text_hash'}->{'eacl_noacls'}</b><p>\n";
	}
print "<form action=acl.cgi>\n";
print "<input type=submit value=\"$self->{'text_hash'}->{'eacl_buttcreate'}\">\n";
print "<select name=type>\n";
foreach $t (sort { $self->{'acl_types_hash'}->{$a} cmp $self->{'acl_types_hash'}->{$b} } keys %{$self->{'acl_types_hash'}}) {
	print "<option value=$t>$self->{'acl_types_hash'}->{$t}\n";
	}
print "</select></form>\n";

print "</td><td valign=top width=50%>\n";

# List all HTTP restrictions, based on ACLs
@{$self->{'http_array'}} = $self->find_config("http_access", $self->{'conf'});
if (@{$self->{'http_array'}}) {
	print $self->ui_subheading($self->{'text_hash'}->{'eacl_pr'});
	@{$self->{'tds_array'}} = ( "width=5", "width=10%", undef, "width=32" );
	print $self->ui_form_start("delete_http_accesses.cgi", "post");
	print "<a href=http_access.cgi?new=1>$self->{'text_hash'}->{'eacl_addpr'}</a><br>\n";
	print $self->ui_columns_start([ "",
				  $self->{'text_hash'}->{'eacl_act'},
				  $self->{'text_hash'}->{'eacl_acls1'},
				  $self->{'text_hash'}->{'eacl_move'} ], 100, 0, \@{$self->{'tds_array'}});
	$self->{'hc'} = 0;
	foreach $h (@{$self->{'http_array'}}) {
		@{$self->{'v_array'}} = @{$h->{'values'}};
		if ($self->{'v_array'}->[0] eq "allow") {
			$self->{'v_array'}->[0] = $self->{'text_hash'}->{'eacl_allow'};
			}
		else {
			$self->{'v_array'}->[0] = $self->{'text_hash'}->{'eacl_deny'};
			}
		local @cols;
		push(@cols, "<a href=\"http_access.cgi?index=$h->{'index'}\">".
			    "$self->{'v_array'}->[0]</a>");
		push(@cols, $self->html_escape(join(' ', @{$self->{'v_array'}}[1..$#{$self->{'v_array'}}])));
		local $mover;
		if ($self->{'hc'} != @{$self->{'http_array'}}-1) {
			$mover .= "<a href=\"move_http.cgi?$self->{'hc'}+1\">".
			          "<img src=images/down.gif border=0></a>";
			}
		else {
			$mover .= "<img src=images/gap.gif>";
			}
		if ($self->{'hc'} != 0) {
			$mover .= "<a href=\"move_http.cgi?$self->{'hc'}+-1\">".
			          "<img src=images/up.gif border=0></a>";
			}
		else {
			$mover .= "<img src=images/gap.gif>";
			}
		push(@cols, $mover);
		print $self->ui_checked_columns_row(\@cols, \@{$self->{'tds_array'}}, "d",$h->{'index'});
		$self->{'hc'}++;
		}
	print $self->ui_columns_end();
	print "<a href=http_access.cgi?new=1>$self->{'text_hash'}->{'eacl_addpr'}</a><br>\n";
	print $self->ui_form_end([ [ "delete", $self->{'text_hash'}->{'eacl_hdelete'} ] ]);
	}
else {
	print "<b>$self->{'text_hash'}->{'eacl_nopr'}</b><p>\n";
	print "<a href=http_access.cgi?new=1>$self->{'text_hash'}->{'eacl_addpr'}</a><br>\n";
	}

print "</td></tr><tr><td valign=top width=50%>\n";

# List all ICP restrictions, based on ACLs
@{$self->{'icp_array'}} = $self->find_config("icp_access", $self->{'conf'});
if (@{$self->{'icp_array'}}) {
	print $self->ui_subheading($self->{'text_hash'}->{'eacl_icpr'});
	print $self->ui_form_start("delete_icp_accesses.cgi", "post");
	@{$self->{'tds_array'}} = ( "width=5", "width=10%", undef, "width=32" );
	print "<a href=icp_access.cgi?new=1>$self->{'text_hash'}->{'eacl_addicpr'}</a><br>\n";
	print $self->ui_columns_start([ "",
				  $self->{'text_hash'}->{'eacl_act'},
				  $self->{'text_hash'}->{'eacl_acls1'},
				  $self->{'text_hash'}->{'eacl_move'} ], 100, 0, \@{$self->{'tds_array'}});
	$self->{'ic'} = 0;
	foreach $i (@{$self->{'icp_array'}}) {
		@{$self->{'v_array'}} = @{$i->{'values'}};
		if ($self->{'v_array'}->[0] eq "allow") {
			$self->{'v_array'}->[0] = $self->{'text_hash'}->{'eacl_allow'};
			}
		else {
			$self->{'v_array'}->[0] = $self->{'text_hash'}->{'eacl_deny'};
			}
		local @cols;
		push(@cols, "<a href=\"icp_access.cgi?index=$i->{'index'}\">".
			    "$self->{'v_array'}->[0]</a>");
		push(@cols, $self->html_escape(join(' ', @{$self->{'v_array'}}[1..$#{$self->{'v_array'}}])));
		local $mover;
		if ($self->{'hc'} != @{$self->{'icp_array'}}-1) {
			$mover .= "<a href=\"move_icp.cgi?$self->{'hc'}+1\">".
			          "<img src=images/down.gif border=0></a>";
			}
		else {
			$mover .= "<img src=images/gap.gif>";
			}
		if ($self->{'hc'} != 0) {
			$mover .= "<a href=\"move_icp.cgi?$self->{'hc'}+-1\">".
			          "<img src=images/up.gif border=0></a>";
			}
		else {
			$mover .= "<img src=images/gap.gif>";
			}
		push(@cols, $mover);
		print $self->ui_checked_columns_row(\@cols, \@{$self->{'tds_array'}}, "d",$i->{'index'});
		$self->{'ic'}++;
		}
	print $self->ui_columns_end();
	print "<a href=icp_access.cgi?new=1>$self->{'text_hash'}->{'eacl_addicpr'}</a><br>\n";
	print $self->ui_form_end([ [ "delete", $self->{'text_hash'}->{'eacl_hdelete'} ] ]);
	}
else {
	print "<b>$self->{'text_hash'}->{'eacl_noicpr'}</b><p>\n";
	print "<a href=icp_access.cgi?new=1>$self->{'text_hash'}->{'eacl_addicpr'}</a><br>\n";
	}

print "</td></tr>\n";

if ($self->{'squid_version'} >= 2.5) {
	# Show table of external ACL types
	print "<tr> <td colspan=2>\n";
	print $self->ui_subheading($self->{'text_hash'}->{'eacl_ext'});
	@{$self->{'ext_array'}} = $self->find_config("external_acl_type", $self->{'conf'});
	if (@{$self->{'ext_array'}}) {
		print $self->ui_columns_start([ $self->{'text_hash'}->{'eacl_cname'},
					  $self->{'text_hash'}->{'eacl_format'},
					  $self->{'text_hash'}->{'eacl_program'} ], 100);
		foreach $e (@{$self->{'ext_array'}}) {
			$self->{'ea'} = $self->parse_external($e);
			print $self->ui_columns_row([
				"<a href='edit_ext.cgi?index=$e->{'index'}'>".
			         "$self->{'ea'}->{'name'}</a>",
				$self->{'ea'}->{'format'},
				join(" ", $self->{'ea'}->{'program'}, @{$self->{'ea'}->{'args'}})
				]);
			}
		print $self->ui_columns_end();
		}
	else {
		print "<b>$self->{'text_hash'}->{'eacl_noext'}</b><p>\n";
		}
	print "<a href=edit_ext.cgi?new=1>$self->{'text_hash'}->{'eacl_addext'}</a>\n";
	print "</td> </tr>\n";
	}

print "</table><p>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'eacl_return'});

1;
		
}


1;

