#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_delay.cgi
# Displays a list of existing delay pools

&ModuleLoader::preload_module('squid_class', "squid::SquidLib");
$self = new squid::SquidLib:: 'squid_class',%$self;

$self->{'access_hash'}->{'delay'} || $self->error($self->{'text_hash'}->{'delay_ecannot'});
$self->ui_print_header(undef, $self->{'text_hash'}->{'delay_title'}, "", "edit_delay", 0, 0, 0, $self->restart_button());
$self->{'conf'} = $self->get_config();

# Display all known delay pools
$self->{'pools'} = $self->find_value("delay_pools", $self->{'conf'});
@{$self->{'links_array'}} = ( $self->select_all_link("d"),
	   $self->select_invert_link("d"),
	   "<a href='edit_pool.cgi?new=1'>$self->{'text_hash'}->{'delay_add'}</a>" );
if ($self->{'pools'}) {
	@{$self->{'pools_array'}} = sort { $a->{'values'}->[0] <=> $b->{'values'}->[0] }
		      $self->find_config("delay_class", $self->{'conf'});
	@{$self->{'params_array'}} = $self->find_config("delay_parameters", $self->{'conf'});
	print $self->ui_form_start("delete_pools.cgi", "post");
	print $self->ui_links_row(\@{$self->{'links_array'}});
	@{$self->{'tds_array'}} = ( "width=5" );
	print $self->ui_columns_start([ "",
				  $self->{'text_hash'}->{'delay_num'},
				  $self->{'text_hash'}->{'delay_class'},
				  $self->{'text_hash'}->{'delay_agg'},
				  $self->{'text_hash'}->{'delay_ind'},
				  $self->{'text_hash'}->{'delay_net'},
				  $self->{'squid_version'} >= 3 ? (
					$self->{'text_hash'}->{'delay_user'},
					$self->{'text_hash'}->{'delay_tag'} ) : ( ),
				], 100, 0, \@{$self->{'tds_array'}});
	foreach $p (@{$self->{'pools_array'}}) {
		local ($pr) = grep { $_->{'values'}->[0] ==
				     $p->{'values'}->[0] } @{$self->{'params_array'}};
		local @cols;
		push(@cols, "<a href='edit_pool.cgi?idx=$p->{'values'}->[0]'>".
			    "$p->{'values'}->[0]</a>");
		push(@cols, $self->{'text_hash'}->{"delay_class_$p->{'values'}->[1]"});
		if ($p->{'values'}->[1] == 5) {
			push(@cols, "", "", "", "");
			push(@cols, &pool_param($pr->{'values'}->[1]));
			}
		else {
			push(@cols, &pool_param($pr->{'values'}->[1]));
			if ($p->{'values'}->[1] == 2) {
				push(@cols, &pool_param($pr->{'values'}->[2]));
				push(@cols, "");
				}
			else {
				push(@cols, &pool_param($pr->{'values'}->[3]));
				push(@cols, &pool_param($pr->{'values'}->[2]));
				}
			if ($self->{'squid_version'} >= 3) {
				if ($p->{'values'}->[1] == 4) {
					push(@cols, &pool_param(
						$pr->{'values'}->[4]));
					}
				else {
					push(@cols, "");
					}
				push(@cols, "");
				}
			}
		print $self->ui_checked_columns_row(\@cols, \@{$self->{'tds_array'}},
					      "d", $p->{'values'}->[0]);
		}
	print $self->ui_columns_end();
	print $self->ui_links_row(\@{$self->{'links_array'}});
	print $self->ui_form_end([ [ "delete", $self->{'text_hash'}->{'delay_delete'} ] ]);
	}
else {
	print "<b>$self->{'text_hash'}->{'delay_none'}</b><p>\n";
	print $self->ui_links_row([ $self->{'links_array'}->[2] ]);
	}

print "<form action=save_delay.cgi>\n";
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'delay_header'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

print "<tr>\n";
print $self->opt_input($self->{'text_hash'}->{'delay_initial'}, "delay_initial_bucket_level", $self->{'conf'},
		 $self->{'text_hash'}->{'default'}, 4, "%");
print "<td colspan=2 width=50%></td>\n";
print "</tr>\n";

print "</table></td></tr></table>\n";
print "<input type=submit value='$self->{'text_hash'}->{'save'}'></form>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'eicp_return'});

1;
		
}

# pool_param(param)
sub pool_param
{
	shift if ($self == $_[0]);

if ($_[0] =~ /^([0-9\-]+)\/([0-9\-]+)$/) {
	return $1 == -1 ? $self->{'text_hash'}->{'delay_unlimited'} :
		$self->text('delay_param', "$1", "$2");
	}
else {
	return $_[0];	# huh?
	}
}


1;

