#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_icp.cgi
# A form for editing options for communication with other caches

&ModuleLoader::preload_module('squid_class', "squid::SquidLib");
$self = new squid::SquidLib:: 'squid_class',%$self;

$self->{'access_hash'}->{'othercaches'} || $self->error($self->{'text_hash'}->{'eicp_ecannot'});
$self->ui_print_header(undef, $self->{'text_hash'}->{'eicp_header'}, "", "edit_icp", 0, 0, 0, $self->restart_button());
$self->{'conf'} = $self->get_config();
$self->{'cache_host'} = $self->{'squid_version'} >= 2 ? "cache_peer" : "cache_host";

@{$self->{'ch_array'}} = $self->find_config($self->{'cache_host'}, $self->{'conf'});
@{$self->{'links_array'}} = ( $self->select_all_link("d"),
	   $self->select_invert_link("d"),
	   "<a href='edit_cache_host.cgi?new=1'>$self->{'text_hash'}->{'eicp_aac'}</a>" );
if (@{$self->{'ch_array'}}) {
	#print &ui_subheading($self->{'text_hash'}->{'eicp_opcs'});
	$self->{'mid'} = int((@{$self->{'ch_array'}}+1)/2);
	print $self->ui_form_start("delete_icps.cgi", "post");
	print $self->ui_links_row(\@{$self->{'links_array'}});
	print "<table width=100%><tr> <td width=50% valign=top>\n";
	&cache_table(0, $self->{'mid'}-1);
	print "</td><td width=50% valign=top>\n";
	if ($self->{'mid'} < @{$self->{'ch_array'}}) { &cache_table($self->{'mid'}, $#{$self->{'ch_array'}}); }
	print "</td> </tr></table>\n";
	print $self->ui_links_row(\@{$self->{'links_array'}});
	print $self->ui_form_end([ [ "delete", $self->{'text_hash'}->{'eicp_delete'} ] ]);
	}
else {
	print "<b>$self->{'text_hash'}->{'eicp_nocd'}</b>.<p>\n";
	print $self->ui_links_row([ $self->{'links_array'}->[2] ]);
	}

print "<hr>\n";
print "<form action=save_icp.cgi>\n";
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'eicp_cso'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

if ($self->{'squid_version'} < 2) {
	print "<tr>\n";
	print $self->list_input($self->{'text_hash'}->{'eicp_fdfd'}, "local_domain", $self->{'conf'});
	print $self->address_input($self->{'text_hash'}->{'eicp_fdfi'}, "local_ip", $self->{'conf'});
	print "</tr>\n";

	print "<tr>\n";
	print $self->list_input($self->{'text_hash'}->{'eicp_dif'}, "inside_firewall", $self->{'conf'});
	print $self->address_input($self->{'text_hash'}->{'eicp_iif'}, "firewall_ip", $self->{'conf'});
	print "</tr>\n";
	}

print "<tr>\n";
print $self->list_input($self->{'text_hash'}->{'eicp_dfuc'}, "hierarchy_stoplist",
		  $self->{'conf'}, 1, $self->{'text_hash'}->{'default'});
print "</tr>\n";

if ($self->{'squid_version'} < 2) {
	print "<tr>\n";
	print $self->choice_input($self->{'text_hash'}->{'eicp_bpfsp'},
			    "single_parent_bypass",
			    $self->{'conf'}, "off", $self->{'text_hash'}->{'yes'}, "on", $self->{'text_hash'}->{'no'}, "off");
	print $self->choice_input($self->{'text_hash'}->{'eicp_ssip'}, "source_ping", $self->{'conf'}, "off",
			    $self->{'text_hash'}->{'yes'}, "on", $self->{'text_hash'}->{'no'}, "off");
	print "</tr>\n";

	print "<tr>\n";
	print $self->opt_input($self->{'text_hash'}->{'eicp_crt'}, "neighbor_timeout", $self->{'conf'},
			 $self->{'text_hash'}->{'default'}, 4, $self->{'text_hash'}->{'eicp_secs'});
	print "</tr>\n";
	}
else {
	print "<tr>\n";
	print $self->opt_input($self->{'text_hash'}->{'eicp_iqt'}, "icp_query_timeout", $self->{'conf'},
			 $self->{'text_hash'}->{'default'}, 8, "ms");
	print $self->opt_input($self->{'text_hash'}->{'eicp_mit'}, "mcast_icp_query_timeout",
			 $self->{'conf'}, $self->{'text_hash'}->{'default'}, 8, "ms");
	print "</tr>\n";

	print "<tr>\n";
	print $self->opt_input($self->{'text_hash'}->{'eicp_dpt'}, "dead_peer_timeout", $self->{'conf'},
			 $self->{'text_hash'}->{'default'}, 8, $self->{'text_hash'}->{'eicp_secs'});
	print "</tr>\n";
	}

if ($self->{'squid_version'} >= 2.3) {
	# Display always/never_direct options
	print "<tr> <td colspan=4><hr></td> </tr>\n";

	print "<tr> <td colspan=2 valign=top width=50%>\n";
	@{$self->{'always_array'}} = $self->find_config("always_direct", $self->{'conf'});
	if (@{$self->{'always_array'}}) {
		print "<b>$self->{'text_hash'}->{'eicp_always'}</b><p>\n";
		print "<table border>\n";
		print "<tr $self->{'tb'}><td width=10%><b>$self->{'text_hash'}->{'eacl_act'}</b></td>\n";
		print "<td><b>$self->{'text_hash'}->{'eacl_acls1'}</b></td>\n";
		print "<td width=10%><b>$self->{'text_hash'}->{'eacl_move'}</b></td> </tr>\n";
		$self->{'hc'} = 0;
		foreach $h (@{$self->{'always_array'}}) {
			@{$self->{'v_array'}} = @{$h->{'values'}};
			if ($self->{'v_array'}->[0] eq "allow") {
				$self->{'v_array'}->[0] = $self->{'text_hash'}->{'eacl_allow'};
			} else {
				$self->{'v_array'}->[0] = $self->{'text_hash'}->{'eacl_deny'};
			}
			print "<tr $self->{'cb'}>\n";
			print "<td><a href=\"always.cgi?index=$h->{'index'}\">",
			      "$self->{'v_array'}->[0]</a></td>\n";
			print "<td>",$self->html_escape(join(' ', @{$self->{'v_array'}}[1..$#{$self->{'v_array'}}])),
			      "</td>\n";
			print "<td>\n";
			if ($self->{'hc'} != @{$self->{'always_array'}}-1) {
				print "<a href=\"move_always.cgi?$self->{'hc'}+1\">",
				      "<img src=images/down.gif border=0></a>";
				}
			else { print "<img src=images/gap.gif>"; }
			if ($self->{'hc'} != 0) {
				print "<a href=\"move_always.cgi?$self->{'hc'}+-1\">",
				      "<img src=images/up.gif border=0></a>";
				}
			print "</td></tr>\n";
			$self->{'hc'}++;
			}
		print "</table>\n";
		}
	else {
		print "<b>$self->{'text_hash'}->{'eicp_noalways'}</b><p>\n";
		}
	print "<a href=always.cgi?new=1>$self->{'text_hash'}->{'eicp_addalways'}</a>\n";

	print "</td> <td colspan=2 valign=top width=50%>\n";
	@{$self->{'never_array'}} = $self->find_config("never_direct", $self->{'conf'});
	if (@{$self->{'never_array'}}) {
		print "<b>$self->{'text_hash'}->{'eicp_never'}</b><p>\n";
		print "<table border>\n";
		print "<tr $self->{'tb'}><td width=10%><b>$self->{'text_hash'}->{'eacl_act'}</b></td>\n";
		print "<td><b>$self->{'text_hash'}->{'eacl_acls1'}</b></td>\n";
		print "<td width=10%><b>$self->{'text_hash'}->{'eacl_move'}</b></td> </tr>\n";
		$self->{'hc'} = 0;
		foreach $h (@{$self->{'never_array'}}) {
			@{$self->{'v_array'}} = @{$h->{'values'}};
			if ($self->{'v_array'}->[0] eq "allow") {
				$self->{'v_array'}->[0] = $self->{'text_hash'}->{'eacl_allow'};
			} else {
				$self->{'v_array'}->[0] = $self->{'text_hash'}->{'eacl_deny'};
			}
			print "<tr $self->{'cb'}>\n";
			print "<td><a href=\"never.cgi?index=$h->{'index'}\">",
			      "$self->{'v_array'}->[0]</a></td>\n";
			print "<td>",$self->html_escape(join(' ', @{$self->{'v_array'}}[1..$#{$self->{'v_array'}}])),
			      "</td>\n";
			print "<td>\n";
			if ($self->{'hc'} != @{$self->{'never_array'}}-1) {
				print "<a href=\"move_never.cgi?$self->{'hc'}+1\">",
				      "<img src=images/down.gif border=0></a>";
				}
			else { print "<img src=images/gap.gif>"; }
			if ($self->{'hc'} != 0) {
				print "<a href=\"move_never.cgi?$self->{'hc'}+-1\">",
				      "<img src=images/up.gif border=0></a>";
				}
			print "</td></tr>\n";
			$self->{'hc'}++;
			}
		print "</table>\n";
		}
	else {
		print "<b>$self->{'text_hash'}->{'eicp_nonever'}</b><p>\n";
		}
	print "<a href=never.cgi?new=1>$self->{'text_hash'}->{'eicp_addnever'}</a>\n";
	print "</td> </tr>\n";
	}

print "</table></td></tr></table>\n";
print "<input type=submit value=$self->{'text_hash'}->{'buttsave'}></form>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'eicp_return'});

1;
		
}

# cache_table(start, end)
sub cache_table
{
	shift if ($self == $_[0]);

local @tds = ( "width=5" );
print $self->ui_columns_start([ "",
			  $self->{'text_hash'}->{'eicp_thost'},
			  $self->{'text_hash'}->{'eicp_ttype'},
			  $self->{'text_hash'}->{'eicp_tpport'},
			  $self->{'text_hash'}->{'eicp_tiport'} ], 100, 0, \@tds);
for($i=$_[0]; $i<=$_[1]; $i++) {
	@{$self->{'chv_array'}} = @{$self->{'ch_array'}->[$i]->{'values'}};
	print $self->ui_checked_columns_row([
		"<a href=\"edit_cache_host.cgi?num=$i\">".
	        $self->html_escape($self->{'chv_array'}->[0])."</a>",
		$self->html_escape($self->{'chv_array'}->[1]),
		$self->html_escape($self->{'chv_array'}->[2]),
		$self->html_escape($self->{'chv_array'}->[3])
		], \@tds, "d", $i);
	}
print $self->ui_columns_end();
}


1;

