#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_logs.cgi
# A form for editing logging options

&ModuleLoader::preload_module('squid_class', "squid::SquidLib");
$self = new squid::SquidLib:: 'squid_class',%$self;

$self->{'access_hash'}->{'logging'} || $self->error($self->{'text_hash'}->{'elogs_ecannot'});
$self->ui_print_header(undef, $self->{'text_hash'}->{'elogs_header'}, "", "edit_logs", 0, 0, 0, $self->restart_button());
$self->{'conf'} = $self->get_config();

print "<form action=save_logs.cgi>\n";
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'elogs_lalo'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

if ($self->{'squid_version'} < 2.6) {
	# Just a single logging directive
	print "<tr>\n";
	print $self->opt_input($self->{'text_hash'}->{'elogs_alf'}, "cache_access_log", $self->{'conf'}, $self->{'text_hash'}->{'default'}, 50);
	print "</tr>\n";
	}
else {
	# Supports definition of log formats and files
	@{$self->{'logformat_array'}} = $self->find_config("logformat", $self->{'conf'});
	$self->{'ltable'} = $self->ui_radio("logformat_def", @{$self->{'logformat_array'}} ? 0 : 1,
			    [ [ 1, $self->{'text_hash'}->{'elogs_logformat1'} ],
			      [ 0, $self->{'text_hash'}->{'elogs_logformat0'} ] ])."<br>\n";
	$self->{'ltable'} .= $self->ui_columns_start([ $self->{'text_hash'}->{'elogs_fname'},
				      $self->{'text_hash'}->{'elogs_ffmt'} ]);
	$i = 0;
	foreach $f (@{$self->{'logformat_array'}}, { }) {
		($self->{'fname'}, @{$self->{'ffmt_array'}}) = @{$f->{'values'}};
		$self->{'ltable'} .= $self->ui_columns_row([
			$self->ui_textbox("fname_$i", $self->{'fname'}, 20),
			$self->ui_textbox("ffmt_$i", join(" ", @{$self->{'ffmt_array'}}), 60)
			]);
		$i++;
		}
	$self->{'ltable'} .= $self->ui_columns_end();
	print "<tr> <td valign=top><b>$self->{'text_hash'}->{'elogs_logformat'}</b></td>\n";
	print "<td colspan=3>$self->{'ltable'}</td> </tr>\n";

	# Show log files
	@{$self->{'access_array'}} = $self->find_config("access_log", $self->{'conf'});
	$self->{'atable'} = $self->ui_columns_start([ $self->{'text_hash'}->{'elogs_afile'},
				      $self->{'text_hash'}->{'elogs_afmt'},
				      $self->{'text_hash'}->{'elogs_aacls'} ]);
	$i = 0;
	foreach $a (@{$self->{'access_array'}}, { }) {
		($self->{'afile'}, $self->{'afmt'}, @{$self->{'aacls_array'}}) = @{$a->{'values'}};
		$self->{'atable'} .= $self->ui_columns_row([
		  $self->ui_radio("afile_def_$i",
			    !$self->{'afile'} ? 1 : $self->{'afile'} eq "none" ? 2 : 0,
			    [ [ 1, $self->{'text_hash'}->{'elogs_notset'} ],
			      [ 2, $self->{'text_hash'}->{'elogs_dont'} ],
			      [ 0, $self->text('elogs_file',
				    $self->ui_textbox("afile_$i",
						$self->{'afile'} eq "none" ? "" : $self->{'afile'},
						30)) ] ]),
		  $self->ui_select("afmt_$i", $self->{'afmt'},
			     [ [ "", "&lt;".$self->{'text_hash'}->{'default'}."&gt;" ],
			       map { [ $_->{'values'}->[0] ] } @{$self->{'logformat_array'}} ]),
		  $self->ui_textbox("aacls_$i", join(" ", @{$self->{'aacls_array'}}), 20)
		  ]);
		$i++;
		}
	$self->{'atable'} .= $self->ui_columns_end();
	print "<tr> <td valign=top><b>$self->{'text_hash'}->{'elogs_access'}</b></td>\n";
	print "<td colspan=3>$self->{'atable'}</td> </tr>\n";

	print "<tr> <td colspan=4><hr></td> </tr>\n";
	print "</table><table width=100%>\n";
	}

print "<tr>\n";
print $self->opt_input($self->{'text_hash'}->{'elogs_dlf'}, "cache_log", $self->{'conf'}, $self->{'text_hash'}->{'default'}, 50);
print "</tr>\n";

print "<tr>\n";
$self->{'cslv'} = $self->find_config("cache_store_log", $self->{'conf'});
$self->{'cslm'} = $self->{'cslv'}->{'value'} eq 'none' ? 2 : $self->{'cslv'}->{'value'} ? 0 : 1;
print "<td valign=top><b>$self->{'text_hash'}->{'elogs_slf'}</b></td>\n";
print "<td nowrap colspan=3>\n";
printf "<input type=radio name=cache_store_log_def value=1 %s> %s\n",
	$self->{'cslm'} == 1 ? "checked" : "", $self->{'text_hash'}->{'default'};
printf "<input type=radio name=cache_store_log_def value=2 %s> %s\n",
	$self->{'cslm'} == 2 ? "checked" : "", $self->{'text_hash'}->{'elogs_none'};
printf "<input type=radio name=cache_store_log_def value=0 %s>\n",
	$self->{'cslm'} == 0 ? "checked" : "";
printf "<input name=cache_store_log size=50 value=\"%s\"></td>\n",
	$self->{'cslm'} == 0 ? $self->{'cslv'}->{'value'} : "";
print "</tr>\n";

print "<tr>\n";
print $self->opt_input($self->{'text_hash'}->{'elogs_cmf'}, "cache_swap_log", $self->{'conf'}, $self->{'text_hash'}->{'default'}, 50);
print "</tr>\n";

print "<tr>\n";
print $self->choice_input($self->{'text_hash'}->{'elogs_uhlf'}, "emulate_httpd_log", $self->{'conf'},
		    "off", $self->{'text_hash'}->{'yes'}, "on", $self->{'text_hash'}->{'no'}, "off");
print $self->choice_input($self->{'text_hash'}->{'elogs_lmh'}, "log_mime_hdrs", $self->{'conf'},
		    "off", $self->{'text_hash'}->{'yes'}, "on", $self->{'text_hash'}->{'no'}, "off");
print "</tr>\n";

print "<tr>\n";
print $self->opt_input($self->{'text_hash'}->{'elogs_ualf'}, "useragent_log", $self->{'conf'}, $self->{'text_hash'}->{'none'}, 20);
print $self->opt_input($self->{'text_hash'}->{'elogs_pf'}, "pid_filename", $self->{'conf'}, $self->{'text_hash'}->{'default'}, 20);
print "</tr>\n";

if ($self->{'squid_version'} >= 2.2) {
	@{$self->{'ident_array'}} = $self->find_config("ident_lookup_access", $self->{'conf'});
	foreach $i (@{$self->{'ident_array'}}) {
		local @v = @{$i->{'values'}};
		if ($v[0] eq "allow") { map { $self->{'ila_hash'}->{$_}++ } @v[1..$#v]; }
		elsif ($v[0] eq "deny" && $v[1] ne "all") { $self->{'bad_ident'}++; }
		}
	if (!$self->{'bad_ident'}) {
		print "<tr><td valign=top><b>$self->{'text_hash'}->{'elogs_prilfa'}</b></td> <td colspan=3>\n";
		@{$self->{'acls_array'}} = $self->find_config("acl", $self->{'conf'});
		foreach $acl (@{$self->{'acls_array'}}) {
			$self->{'aclv'} = $acl->{'values'}->[0];
			next if ($self->{'doneacl_hash'}->{$self->{'aclv'}}++);
			printf "<input type=checkbox name=ident_lookup_access ".
			       "value=$self->{'aclv'} %s>$self->{'aclv'}\n",
				$self->{'ila_hash'}->{$self->{'aclv'}} ? "checked" : "";
			}
		print "</td> </tr>\n";
		}
	else { print "<input type=hidden name=complex_ident value=1>\n"; }
	print "<tr>\n";
	print $self->opt_time_input($self->{'text_hash'}->{'elogs_rit'}, "ident_timeout",
			      $self->{'conf'}, $self->{'text_hash'}->{'default'}, 6);
	}
else {
	print "<tr>\n";
	print $self->choice_input($self->{'text_hash'}->{'elogs_dril'}, "ident_lookup", $self->{'conf'},
			    "off", $self->{'text_hash'}->{'yes'}, "on", $self->{'text_hash'}->{'no'}, "off");
	}
print $self->choice_input($self->{'text_hash'}->{'elogs_lfh'}, "log_fqdn", $self->{'conf'},
		    "off", $self->{'text_hash'}->{'yes'}, "on", $self->{'text_hash'}->{'no'}, "off");
print "</tr>\n";

print "<tr>\n";
print $self->opt_input($self->{'text_hash'}->{'elogs_ln'}, "client_netmask", $self->{'conf'}, $self->{'text_hash'}->{'default'}, 15);
print $self->opt_input($self->{'text_hash'}->{'elogs_do'}, "debug_options", $self->{'conf'}, $self->{'text_hash'}->{'default'}, 15);
print "</tr>\n";

if ($self->{'squid_version'} >= 2) {
	print "<tr>\n";
	print $self->opt_input($self->{'text_hash'}->{'elogs_mht'}, "mime_table",
			 $self->{'conf'}, $self->{'text_hash'}->{'default'}, 20);
	print "</tr>\n";
	}

print "</table></td></tr></table>\n";
print "<input type=submit value=$self->{'text_hash'}->{'buttsave'}></form>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'elogs_return'});

1;
		
}


1;

