#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_ports.cgi
# A form for editing ports and other networking options

&ModuleLoader::preload_module('squid_class', "squid::SquidLib");
$self = new squid::SquidLib:: 'squid_class',%$self;

$self->{'access_hash'}->{'portsnets'} || $self->error($self->{'text_hash'}->{'eports_ecannot'});
$self->ui_print_header(undef, $self->{'text_hash'}->{'eports_header'}, "", "edit_ports", 0, 0, 0, $self->restart_button());
$self->{'conf'} = $self->get_config();

print "<form action=save_ports.cgi>\n";
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'eports_pano'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

print "<tr>\n";
if ($self->{'squid_version'} >= 2.3) {
	# Display table of normal ports
	print "<td valign=top><b>$self->{'text_hash'}->{'eports_paap'}</b></td><td colspan=3>\n";
	&ports_table("http_port");
	print "</table></td></tr>\n";

	if ($self->{'squid_version'} >= 2.5) {
		# Display table of SSL ports
		print "<tr> <td valign=top><b>$self->{'text_hash'}->{'eports_ssl'}</b></td><td colspan=3>\n";
		&ports_table("https_port");
		print "</table></td></tr>\n";
		}
	print "<tr>\n";
	print $self->opt_input($self->{'text_hash'}->{'eports_ip'}, "icp_port", 
				$self->{'conf'}, $self->{'text_hash'}->{'default'}, 6);
	}
else {
	# Just show single-port inputs
	print $self->opt_input($self->{'text_hash'}->{'eports_pp'}, "http_port", 
				$self->{'conf'}, $self->{'text_hash'}->{'default'}, 6);
	print $self->opt_input($self->{'text_hash'}->{'eports_ip'}, "icp_port", 
				$self->{'conf'}, $self->{'text_hash'}->{'default'}, 6);
	print "</tr>\n";

	print "<tr>\n";
	print $self->opt_input($self->{'text_hash'}->{'eports_ita'}, "tcp_incoming_address",
			 $self->{'conf'}, $self->{'text_hash'}->{'eports_a'}, 15);
	}

print $self->opt_input($self->{'text_hash'}->{'eports_ota'}, "tcp_outgoing_address",
		 $self->{'conf'}, $self->{'text_hash'}->{'eports_a'}, 15);
print "</tr>\n";

print "<tr>\n";
print $self->opt_input($self->{'text_hash'}->{'eports_oua'}, "udp_outgoing_address",
		 $self->{'conf'}, $self->{'text_hash'}->{'eports_a'}, 15);
print $self->opt_input($self->{'text_hash'}->{'eports_iua'}, "udp_incoming_address",
		 $self->{'conf'}, $self->{'text_hash'}->{'eports_a'}, 15);
print "</tr>\n";

print "<tr>\n";
print $self->address_input($self->{'text_hash'}->{'eports_mg'}, "mcast_groups", $self->{'conf'}, 0);
print $self->opt_input($self->{'text_hash'}->{'eports_trb'}, "tcp_recv_bufsize", $self->{'conf'},
		 $self->{'text_hash'}->{'eports_od'}, 6);
print "</tr>\n";

if ($self->{'squid_version'} >= 2.6) {
	print "<tr>\n";
	print $self->choice_input($self->{'text_hash'}->{'eports_checkhost'}, "check_hostnames",
			    $self->{'conf'}, "on", $self->{'text_hash'}->{'yes'}, "on", $self->{'text_hash'}->{'no'},"off");
	print $self->choice_input($self->{'text_hash'}->{'eports_underscore'}, "allow_underscore",
			    $self->{'conf'}, "on", $self->{'text_hash'}->{'yes'}, "on", $self->{'text_hash'}->{'no'},"off");
	print "</tr>\n";
	}

if ($self->{'squid_version'} >= 2.5) {
	print "<tr>\n";
	print $self->choice_input($self->{'text_hash'}->{'eports_unc'}, "ssl_unclean_shutdown",
			    $self->{'conf'}, "off", $self->{'text_hash'}->{'on'},"on", $self->{'text_hash'}->{'off'},"off");
	print "</tr>\n";
	}

print "</table></td></tr></table>\n";
print "<input type=submit value=$self->{'text_hash'}->{'buttsave'}></form>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'eports_return'});

1;
		
}

# ports_table(name)
sub ports_table
{
	shift if ($self == $_[0]);

local ($p, $i, @ports, @opts);
foreach $p ($self->find_config($_[0], $self->{'conf'})) {
	foreach $v (@{$p->{'values'}}) {
		if ($v =~ /^(\S+):\d+$/ || $v =~ /^\d+$/) {
			push(@ports, $v);
			}
		else {
			push(@{$opts[$#ports]}, $v);
			}
		}
	}
printf "<input type=radio name=$_[0]_ports_def value=1 %s> %s\n",
	@ports ? "" : "checked", $self->{'text_hash'}->{'eports_def'};
printf "<input type=radio name=$_[0]_ports_def value=0 %s> %s<br>\n",
	@ports ? "checked" : "", $self->{'text_hash'}->{'eports_sel'};
print "<table border>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'eports_p'}</b></td>\n",
      "<td><b>$self->{'text_hash'}->{'eports_hia'}</b></td> ",
      ($self->{'squid_version'} >= 2.5 ? "<td><b>$self->{'text_hash'}->{'eports_opts'}</b></td> "
			     : ""),"</tr>\n";
$i = 0;
foreach $p (@ports, '') {
	print "<tr $self->{'cb'}>\n";
	printf "<td><input name=$_[0]_port_$i size=6 value='%s'></td> <td>\n",
		$p =~ /(\d+)$/ ? $1 : '';
	printf "<input type=radio name=$_[0]_addr_def_$i value=1 %s> All\n",
		$p =~ /:/ ? '' : 'checked';
	printf "<input type=radio name=$_[0]_addr_def_$i value=0 %s>\n",
		$p =~ /:/ ? 'checked' : '';
	printf "<input name=$_[0]_addr_$i size=20 value='%s'></td>\n",
		$p =~ /^(\S+):/ ? $1 : '';
	if ($self->{'squid_version'} >= 2.5) {
		# Show port options
		printf "<td><input name=$_[0]_opts_$i size=40 value='%s'></td>\n",
			join(" ", @{$opts[$i]});
		}
	print "</tr>\n";
	$i++;
	}
}


1;

