#!/usr/bin/perl

&MAIN();

 sub MAIN {
# index.cgi
# Display a menu of different kinds of options

&ModuleLoader::preload_module('squid_class', "squid::SquidLib");
$self = new squid::SquidLib:: 'squid_class',%$self;


# Check for the squid executable
if (!$self->has_command($self->{'config_hash'}->{'squid_path'})) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'index_header'}, "", undef, 1, 1);
	print $self->text('index_msgnoexe',$self->{'config_hash'}->{'squid_path'},
		$self->{'module_name'}),"<p>\n";

	$self->foreign_require("software", "software-lib.pl");
	$self->{'lnk'} = $main::software_object->missing_install_link("squid", $self->{'text_hash'}->{'index_squid'},
			"../$self->{'module_name'}/", $self->{'text_hash'}->{'index_header'});
	print $self->{'lnk'},"<p>\n" if ($self->{'lnk'});

	$self->ui_print_footer("/", $self->{'text_hash'}->{'index_return'});
	exit;
	}

# Check for squid config file
if (!-r $self->{'config_hash'}->{'squid_conf'}) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'index_header'}, "", undef, 1, 1);
	print $self->text('index_msgnoconfig',$self->{'config_hash'}->{'squid_conf'},
		$self->{'module_name'});
	print "\n<p>\n";
	$self->ui_print_footer("/", $self->{'text_hash'}->{'index_return'});
	exit;
	}

# Check the version number
$self->{'fullver'} = $self->{'ver'} = `$self->{'config_hash'}->{'squid_path'} -v 2>&1`;
if ($self->{'ver'} =~ /version\s+(\S+)/i) {
	$self->{'ver'} = $1;
	}
if ($self->{'ver'} =~ /(1\.1)\.\d+/ || $self->{'ver'} =~ /(1)\.NOVM/ ||
    $self->{'ver'} =~ /(2\.[0123456])\./ || $self->{'ver'} =~ /(3\.0)/) {
	# Save version number
	open(VERSION, ">$self->{'module_config_directory'}/version");
	print VERSION $1,"\n";
	close(VERSION);
	$self->{'squid_version'} = $1;
	}
else {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'index_header'}, "", undef, 1, 1);
	print $self->text('index_msgnosupported2', "<tt>1.1</tt>", "<tt>2.6</tt>"),
	      "<p>\n";
	print $self->text('index_squidver', "$self->{'config_hash'}->{'squid_path'} -v"),"\n";
	print "<pre>$self->{'fullver'}</pre>\n";
	$self->ui_print_footer("/", $self->{'text_hash'}->{'index_return'});
	exit;
	}

# Check for the cache directory
$self->{'conf'} = $self->get_config();
if (!$self->check_cache($self->{'conf'}, \@{$self->{'caches_array'}})) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'index_header'}, "", undef, 1, 1);
	print "<center>\n";
	if (@{$self->{'caches_array'}} > 1) {
		print $self->text('index_msgnodir1', join(", ", @{$self->{'caches_array'}}));
		}
	else {
		print $self->text('index_msgnodir2', $self->{'caches_array'}->[0]);
		}
	print $self->{'text_hash'}->{'index_msgnodir3'},"<br>\n";
	print "<form action=init_cache.cgi>\n";
	print "<input type=submit value=\"$self->{'text_hash'}->{'index_buttinit'}\">\n";
	local $def = defined(getpwnam("squid")) ? "squid" :
		     defined(getpwnam("httpd")) ? "httpd" : undef;
	if (!$self->find_config("cache_effective_user", $self->{'conf'})) {
		print $self->{'text_hash'}->{'index_asuser'}," ",$self->unix_user_input("user", $def),
			"<p>\n";
		}
	else {
		print "<input type=hidden name=nouser value=1>\n";
		}
	print "<input type=hidden name=caches value=\"",
		join(" ",@{$self->{'caches_array'}}),"\">\n";
	print "</form></center>\n";
	print "<hr>\n";
	}
else {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'index_header'}, "", "intro",
		1, 1, 0, $self->restart_button()."<br>".
			 $self->help_search_link("squid", "doc", "google"),
		undef, undef, $self->text('index_version', $self->{'squid_version'}));
	}

if ($self->{'squid_version'} < 2) {
	$self->{'auth'} = 1;
	}
else {
	local $file = $self->get_auth_file($self->{'conf'});
	if ($file) {
		open(AUTH, $file);
		local $line = <AUTH>;
		close(AUTH);
		if (!$line || $line =~ /^(\S+):(\S+)/) {
			$self->{'auth'} = 2;
			}
		}
	}
$self->{'calamaris'} = $self->has_command($self->{'config_hash'}->{'calamaris'});
$self->{'delay'} = $self->{'squid_version'} >= 2.3;
$self->{'authparam'} = $self->{'squid_version'} >= 2;
$self->{'headeracc'} = $self->{'squid_version'} >= 2.5;
$self->{'iptables'} = $self->foreign_check("firewall");

@{$self->{'otitles_array'}} = ( 'portsnets', 'othercaches', 'musage', 'logging',
	     'copts', 'hprogs', 'actrl', 'admopts',
	     ( $self->{'auth'} ? ( 'proxyauth' ) : ( ) ),
	     ( $self->{'authparam'} ? ( 'authparam' ) : ( ) ),
	     ( $self->{'delay'} ? ( 'delay' ) : ( ) ),
	     ( $self->{'headeracc'} ? ( 'headeracc' ) : ( ) ),
	     'refresh',
	     'miscopt',
	     ( $self->{'iptables'} ? ( 'iptables' ) : ( ) ),
	     'cms', 'rebuild',
	     ( $self->{'calamaris'} ? ( 'calamaris' ) : ( ) ) );
@{$self->{'olinks_array'}} =  ( "edit_ports.cgi", "edit_icp.cgi", "edit_mem.cgi",
	     "edit_logs.cgi", "edit_cache.cgi", "edit_progs.cgi",
	     "edit_acl.cgi", "edit_admin.cgi",
	     ( $self->{'auth'} == 1 ? ( "edit_auth.cgi" ) :
	       $self->{'auth'} == 2 ? ( "edit_nauth.cgi" ) : ( ) ),
	     ( $self->{'authparam'} ? ( "edit_authparam.cgi" ) : ( ) ),
	     ( $self->{'delay'} ? ( 'edit_delay.cgi' ) : ( ) ),
	     ( $self->{'headeracc'} ? ( 'list_headeracc.cgi' ) : ( ) ),
	     "list_refresh.cgi",
	     "edit_misc.cgi",
	     ( $self->{'iptables'} ? ( "edit_iptables.cgi" ) : ( ) ),
	     "cachemgr.cgi", "clear.cgi",
	     ( $self->{'calamaris'} ? ( "calamaris.cgi" ) : ( ) ) );
for($i=0; $i<@{$self->{'otitles_array'}}; $i++) {
	if (!$self->{'access_hash'}->{$self->{'otitles_array'}->[$i]}) {
		splice(@{$self->{'otitles_array'}}, $i, 1);
		splice(@{$self->{'olinks_array'}}, $i, 1);
		$i--;
		}
	else {
		$self->{'otitles_array'}->[$i] = $self->{'text_hash'}->{'index_'.$self->{'otitles_array'}->[$i]};
		}
	}
@{$self->{'oicons_array'}} =  map { $self->{'t'}=$_; $self->{'t'}=~s/cgi/gif/; $self->{'t'}=~s/edit_//; "images/$self->{'t'}" } @{$self->{'olinks_array'}};
$self->icons_table(\@{$self->{'olinks_array'}}, \@{$self->{'otitles_array'}}, \@{$self->{'oicons_array'}});

# Show start/stop/apply buttons
if ($self->{'config_hash'}->{'restart_pos'} != 1) {
	print "<hr>\n";
	print $self->ui_buttons_start();
	if ($self->{'pid'} = $self->is_squid_running()) {
		if ($self->{'access_hash'}->{'restart'}) {
			print $self->ui_buttons_row("restart.cgi", $self->{'text_hash'}->{'index_restart'},
					      $self->{'text_hash'}->{'index_restartdesc'},
					      $self->ui_hidden("pid", $self->{'pid'}).
					      $self->ui_hidden("redir", "index.cgi"));
			}
		if ($self->{'access_hash'}->{'start'}) {
			print $self->ui_buttons_row("stop.cgi", $self->{'text_hash'}->{'index_stop'},
					      $self->{'text_hash'}->{'index_stopdesc'},
					      $self->ui_hidden("pid", $self->{'pid'}).
					      $self->ui_hidden("redir", "index.cgi"));
			}
		}
	else {
		if ($self->{'access_hash'}->{'start'}) {
			print $self->ui_buttons_row("start.cgi", $self->{'text_hash'}->{'index_start'},
					      $self->{'text_hash'}->{'index_startdesc'},
					      $self->ui_hidden("redir", "index.cgi"));
			}
		}
	print $self->ui_buttons_end();
	}

$self->ui_print_footer("/", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

