#!/usr/bin/perl

&MAIN();

 sub MAIN {
# init_cache.cgi
# Initialize the cache by running squid with the -z option

&ModuleLoader::preload_module('squid_class', "squid::SquidLib");
$self = new squid::SquidLib:: 'squid_class',%$self;

$self->{'access_hash'}->{'rebuild'} || $self->error($self->{'text_hash'}->{'icache_ecannot'});
$self->ReadParse();
$self->{'whatfailed'} = $self->{'text_hash'}->{'icache_ftic'};

# set user to run squid as..
$self->lock_file($self->{'config_hash'}->{'squid_conf'});
$self->{'conf'} = $self->get_config();
if (!$self->{'in_hash'}->{'nouser'}) {
	$self->{'in_hash'}->{'user'} || $self->error($self->{'text_hash'}->{'icache_ymcautrsa'});
	@{$self->{'uinfo_array'}} = getpwnam($self->{'in_hash'}->{'user'});
	@{$self->{'ginfo_array'}} = getgrgid($self->{'uinfo_array'}->[3]);
	if ($self->{'squid_version'} < 2) {
		$self->{'dir'} = { 'name' => 'cache_effective_user',
			 'values' => [ $self->{'in_hash'}->{'user'}, $self->{'ginfo_array'}->[0] ] };
		$self->save_directive($self->{'conf'}, "cache_effective_user", [ $self->{'dir'} ]);
		}
	else {
		$self->{'dir'} = { 'name' => 'cache_effective_user',
			 'values' => [ $self->{'in_hash'}->{'user'} ] };
		$self->save_directive($self->{'conf'}, "cache_effective_user", [ $self->{'dir'} ]);
		$self->{'dir'} = { 'name' => 'cache_effective_group',
			 'values' => [ $self->{'ginfo_array'}->[0] ] };
		$self->save_directive($self->{'conf'}, "cache_effective_group", [ $self->{'dir'} ]);
		}
	$self->flush_file_lines();
	}
$self->unlock_file($self->{'config_hash'}->{'squid_conf'});

# Stop squid (if running)
$self->ui_print_unbuffered_header(undef, $self->{'text_hash'}->{'icache_title'}, "");
if ($self->{'pidstruct'} = $self->find_config("pid_filename", $self->{'conf'})) {
	$self->{'pidfile'} = $self->{'pidstruct'}->{'values'}->[0];
	}
else { $self->{'pidfile'} = $self->{'config_hash'}->{'pid_file'}; }
if (open(PID, $self->{'pidfile'})) {
	<PID> =~ /(\d+)/; $self->{'pid'} = $1;
	close(PID);
	}
if ($self->{'pid'} && kill(0, $self->{'pid'})) {
	print "<p>$self->{'text_hash'}->{'clear_stop'}<br>\n";
	$self->system_logged("$self->{'config_hash'}->{'squid_path'} -f $self->{'config_hash'}->{'squid_conf'} ".
	               "-k shutdown >/dev/null 2>&1");
	for($i=0; $i<40; $i++) {
		if (!kill(0, $self->{'pid'})) { last; }
		sleep(1);
		}
	print "$self->{'text_hash'}->{'clear_done'}<br>\n";
	$self->{'stopped'}++;
	}

# Initialize the cache
($self->{'user'}, $self->{'group'}) = $self->get_squid_user($self->{'conf'});
if ($self->{'user'}) {
	foreach $c (split(/\s+/, $self->{'in_hash'}->{'caches'})) {
		mkdir($c, 0755);
		}
	}
$self->chown_files($self->{'user'}, $self->{'group'}, $self->{'conf'});
$self->{'cmd'} = "$self->{'config_hash'}->{'squid_path'} -f $self->{'config_hash'}->{'squid_conf'} -z";
print "<p>", $self->text('icache_itscwtc',$self->{'cmd'}), "<br>\n";
print "<pre>\n";
$self->additional_log('exec', undef, $self->{'cmd'});
open(INIT, "$self->{'cmd'} 2>&1 |");
while(<INIT>) {
	print;
	}
close(INIT);
print "</pre>\n";

# Try to re-start squid (if it was running before)
if ($self->{'stopped'}) {
	$self->{'temp'} = $self->transname();
	$self->system_logged("$self->{'config_hash'}->{'squid_path'} -sY -f $self->{'config_hash'}->{'squid_conf'} >$self->{'temp'} 2>&1 </dev/null &");
	sleep(3);
	$self->{'errs'} = `cat $self->{'temp'}`;
	unlink($self->{'temp'});
	if ($self->{'errs'}) {
		$self->system_logged("$self->{'config_hash'}->{'squid_path'} -k shutdown -f $self->{'config_hash'}->{'squid_conf'} >/dev/null 2>&1");
		print "$self->{'text_hash'}->{'clear_failrestart'}<br>\n";
		print "<pre>$self->{'errs'}</pre>\n";
		}
	}

$self->webmin_log("init");
$self->ui_print_footer("", $self->{'text_hash'}->{'icache_return'});

1;
		
}


1;

