#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_admin.cgi
# Save admin options

&ModuleLoader::preload_module('squid_class', "squid::SquidLib");
$self = new squid::SquidLib:: 'squid_class',%$self;

$self->{'access_hash'}->{'admopts'} || $self->error($self->{'text_hash'}->{'eadm_ecannot'});
$self->ReadParse();
$self->lock_file($self->{'config_hash'}->{'squid_conf'});
$self->{'conf'} = $self->get_config();
$self->{'whatfailed'} = $self->{'text_hash'}->{'sadmin_ftsao'};

($self->{'olduser'}, $self->{'oldgroup'}) = $self->get_squid_user($self->{'conf'});
if ($self->{'squid_version'} < 2) {
	if ($self->{'in_hash'}->{'effective_def'}) {
		$self->save_directive($self->{'conf'}, "cache_effective_user", [ ]);
		}
	else {
		%{$self->{'dir_hash'}} = ( 'name', 'cache_effective_user',
			 'values', [ $self->{'in_hash'}->{'effective_u'}, $self->{'in_hash'}->{'effective_g'} ] );
		$self->save_directive($self->{'conf'}, "cache_effective_user", [ \%{$self->{'dir_hash'}} ]);
		}
	}
else {
	$self->save_opt("cache_effective_user", undef, $self->{'conf'});
	$self->save_opt("cache_effective_group", undef, $self->{'conf'});
        }
$self->save_opt("cache_mgr", \&check_email, $self->{'conf'});
$self->save_opt("visible_hostname", \&check_hostname, $self->{'conf'});
if ($self->{'squid_version'} < 2) {
	$self->save_opt("announce_to", undef, $self->{'conf'});
	$self->save_opt("cache_announce", \&check_announce, $self->{'conf'});
	}
else {
	$self->save_opt("unique_hostname", \&check_hostname, $self->{'conf'});
	if ($self->{'squid_version'} >= 2.4) {
		$self->save_opt("hostname_aliases", undef, $self->{'conf'});
		}
	$self->save_opt("announce_host", \&check_hostname, $self->{'conf'});
	$self->save_opt("announce_port", \&check_port, $self->{'conf'});
	$self->save_opt("announce_file", undef, $self->{'conf'});
	$self->save_opt_time("announce_period", $self->{'conf'});
	}
$self->flush_file_lines();
$self->unlock_file($self->{'config_hash'}->{'squid_conf'});
$self->webmin_log("admin", undef, undef, \%{$self->{'in_hash'}});

($self->{'user'}, $self->{'group'}) = $self->get_squid_user($self->{'conf'});
if (($self->{'olduser'} ne $self->{'user'} || $self->{'oldgroup'} ne $self->{'group'}) && $self->{'user'} && $self->{'group'}) {
	# User/group has changed! Ask user if he wants to chown log/cache/pid
	$self->ui_print_header(undef, $self->{'text_hash'}->{'sadmin_header'}, "");
	print $self->{'text_hash'}->{'sadmin_msg1'},"\n"; 
	print "<center><form action=chown.cgi>\n";
	print "<input type=submit value=\"$self->{'text_hash'}->{'sadmin_buttco'}\">\n";
	print "</form></center>\n";
	$self->ui_print_footer("", $self->{'text_hash'}->{'sadmin_return'});
	}
else { $self->redirect(""); }

1;
		
}

sub check_email
{
	shift if ($self == $_[0]);

return $_[0] =~ /^\S+$/ ? undef : $self->text('sadmin_inavea',$_[0]);
}

sub check_hostname
{
	shift if ($self == $_[0]);

return $_[0] =~ /^\S+$/ ? undef : $self->text('sadmin_inavh',$_[0]);
}

sub check_announce
{
	shift if ($self == $_[0]);

return $_[0] =~ /^\d+$/ ? undef : $self->text('sadmin_inavap',$_[0]);
}

sub check_port
{
	shift if ($self == $_[0]);

return $_[0] =~ /^\d+$/ ? undef : $self->text('sadmin_inavp',$_[0]);
}


1;

