#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_auth.cgi
# Save authentication options

&ModuleLoader::preload_module('squid_class', "squid::SquidLib");
$self = new squid::SquidLib:: 'squid_class',%$self;

$self->{'access_hash'}->{'proxyauth'} || $self->error($self->{'text_hash'}->{'eauth_ecannot'});
$self->ReadParse();
$self->lock_file($self->{'config_hash'}->{'squid_conf'});
$self->{'conf'} = $self->get_config();
$self->{'whatfailed'} = $self->{'text_hash'}->{'sauth_ftsao'};

if ($self->{'in_hash'}->{'authfile_def'}) {
	$self->save_directive($self->{'conf'}, "proxy_auth", [ ]);
	}
else {
	$self->{'in_hash'}->{'authfile'} =~ /^\// || $self->error($self->{'text_hash'}->{'sauth_iomuf'});
	if (!-r $self->{'in_hash'}->{'authfile'}) {
		$self->open_tempfile(AUTH, ">$self->{'in_hash'}->{'authfile'}");
		$self->close_tempfile(AUTH);
		($self->{'user'}, $self->{'group'}) = $self->get_squid_user($self->{'conf'});
		if ($self->{'user'}) {
			@{$self->{'uinfo_array'}} = getpwnam($self->{'user'});
			@{$self->{'ginfo_array'}} = getgrnam($self->{'group'});
			chown($self->{'uinfo_array'}->[2], $self->{'ginfo_array'}->[2], $self->{'in_hash'}->{'authfile'});
			chmod(0644, $self->{'in_hash'}->{'authfile'});
			}
		}
	push(@{$self->{'vals_array'}}, $self->{'in_hash'}->{'authfile'});
	if (!$self->{'in_hash'}->{'authdom_def'}) {
		$self->{'in_hash'}->{'authdom'}=~/^\S+$/ || $self->error($self->{'text_hash'}->{'sauth_iomd'});
		push(@{$self->{'vals_array'}}, $self->{'in_hash'}->{'authdom'});
		}
	$self->save_directive($self->{'conf'}, "proxy_auth",
			[ { 'name' => 'proxy_auth',
			    'values' => \@{$self->{'vals_array'}} } ]);
	}
$self->flush_file_lines();

# check if the proxy_auth directive is supported
$self->{'out'} = `$self->{'config_hash'}->{'squid_path'} -f $self->{'config_hash'}->{'squid_conf'} -k check 2>&1`;
if ($self->{'out'} =~ /proxy_auth/) {
	# it isn't .. roll back
	$self->save_directive($self->{'conf'}, "proxy_auth", [ ]);
	$self->flush_file_lines();
	$self->error($self->{'text_hash'}->{'sauth_msg1'});
	}
$self->unlock_file($self->{'config_hash'}->{'squid_conf'});
$self->redirect("");

1;
		
}


1;

