#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_authparam.cgi
# Save authentication program options

&ModuleLoader::preload_module('squid_class', "squid::SquidLib");
$self = new squid::SquidLib:: 'squid_class',%$self;

$self->{'access_hash'}->{'authparam'} || $self->error($self->{'text_hash'}->{'authparam_ecannot'});
$self->ReadParse();
$self->lock_file($self->{'config_hash'}->{'squid_conf'});
$self->{'conf'} = $self->get_config();
$self->error_setup($self->{'text_hash'}->{'authparam_err'});

if ($self->{'squid_version'} >= 2.5) {
	local @auth = $self->find_config("auth_param", $self->{'conf'});

	# Save basic authentication options
	if ($self->{'in_hash'}->{'b_auth_mode'} == 0) {
		&save_auth(\@auth, "basic", "program");
		}
	elsif ($self->{'in_hash'}->{'b_auth_mode'} == 2) {
		$self->system_logged("cp $self->{'module_root_directory'}/squid-auth.pl $self->{'module_config_directory'}");
		&save_auth(\@auth, "basic", "program", "$self->{'auth_program'} $self->{'auth_database'}");
		$self->system_logged("chmod a+rx $self->{'auth_program'} $self->{'auth_database'}");
		}
	else {
		$self->check_error(\&check_prog, $self->{'in_hash'}->{'b_auth'});
		&save_auth(\@auth, "basic", "program", $self->{'in_hash'}->{'b_auth'});
		}
	if ($self->{'in_hash'}->{'b_children_def'}) {
		&save_auth(\@auth, "basic", "children");
		}
	else {
		$self->{'in_hash'}->{'b_children'} =~ /^\d+$/ ||
			$self->error($self->text('sprog_emsg5', $self->{'in_hash'}->{'b_children'}));
		&save_auth(\@auth, "basic", "children", $self->{'in_hash'}->{'b_children'});
		}
	if ($self->{'in_hash'}->{'b_ttl_def'}) {
		&save_auth(\@auth, "basic", "credentialsttl");
		}
	else {
		$self->{'in_hash'}->{'b_ttl'} =~ /^\d+$/ ||
			$self->error($self->text('sprog_emsg6', $self->{'in_hash'}->{'b_ttl'}));
		&save_auth(\@auth, "basic", "credentialsttl",
				 $self->{'in_hash'}->{'b_ttl'}." ".$self->{'in_hash'}->{'b_ttl_u'});
		}
	if ($self->{'in_hash'}->{'b_realm_def'}) {
		&save_auth(\@auth, "basic", "realm");
		}
	else {
		&save_auth(\@auth, "basic", "realm", $self->{'in_hash'}->{'b_realm'});
		}
	if ($self->{'in_hash'}->{'b_aittl_def'}) {
			$self->save_directive($self->{'conf'}, "authenticate_ip_ttl",[ ]);
	}else{
		$self->{'in_hash'}->{'b_aittl'} =~ /^\d+$/ ||$self->error($self->text('sprog_emsg6', $self->{'in_hash'}->{'b_aittl'}));
		@{$self->{'baittl_array'}}[0]= $self->{'in_hash'}->{'b_aittl'}." ".$self->{'in_hash'}->{'b_aittl_u'};
			$self->save_directive($self->{'conf'}, "authenticate_ip_ttl",
				[ { 'name' => 'authenticate_ip_ttl',
			    	'values' => \@{$self->{'baittl_array'}} }]);
	}
	# Save digest authentication options
	if ($self->{'in_hash'}->{'d_auth_mode'} == 0) {
		&save_auth(\@auth, "digest", "program");
		}
	else {
		$self->check_error(\&check_prog, $self->{'in_hash'}->{'d_auth'});
		&save_auth(\@auth, "digest", "program", $self->{'in_hash'}->{'d_auth'});
		}
	if ($self->{'in_hash'}->{'d_children_def'}) {
		&save_auth(\@auth, "digest", "children");
		}
	else {
		$self->{'in_hash'}->{'d_children'} =~ /^\d+$/ ||
			$self->error($self->text('sprog_emsg5', $self->{'in_hash'}->{'d_children'}));
		&save_auth(\@auth, "digest", "children", $self->{'in_hash'}->{'d_children'});
		}
	if ($self->{'in_hash'}->{'d_realm_def'}) {
		&save_auth(\@auth, "digest", "realm");
		}
	else {
		&save_auth(\@auth, "digest", "realm", $self->{'in_hash'}->{'d_realm'});
		}

	# Save NTLM authentication options
	if ($self->{'in_hash'}->{'n_auth_mode'} == 0) {
		&save_auth(\@auth, "ntlm", "program");
		}
	else {
		$self->check_error(\&check_prog, $self->{'in_hash'}->{'n_auth'});
		&save_auth(\@auth, "ntlm", "program", $self->{'in_hash'}->{'n_auth'});
		}
	if ($self->{'in_hash'}->{'n_children_def'}) {
		&save_auth(\@auth, "ntlm", "children");
		}
	else {
		$self->{'in_hash'}->{'n_children'} =~ /^\d+$/ ||
			$self->error($self->text('sprog_emsg5', $self->{'in_hash'}->{'n_children'}));
		&save_auth(\@auth, "ntlm", "children", $self->{'in_hash'}->{'n_children'});
		}
	if ($self->{'in_hash'}->{'n_reuses_def'}) {
		&save_auth(\@auth, "ntlm", "max_challenge_reuses");
		}
	else {
		$self->{'in_hash'}->{'n_reuses'} =~ /^\d+$/ ||
			$self->error($self->text('authparam_ereuses', $self->{'in_hash'}->{'n_reuses'}));
		&save_auth(\@auth, "ntlm", "max_challenge_reuses",
			   $self->{'in_hash'}->{'n_reuses'});
		}
	if ($self->{'in_hash'}->{'n_ttl_def'}) {
		&save_auth(\@auth, "ntlm", "max_challenge_lifetime");
		}
	else {
		$self->{'in_hash'}->{'n_ttl'} =~ /^\d+$/ ||
			$self->error($self->text('authparam_elifetime', $self->{'in_hash'}->{'n_ttl'}));
		&save_auth(\@auth, "ntlm", "max_challenge_lifetime",
				 $self->{'in_hash'}->{'n_ttl'}." ".$self->{'in_hash'}->{'n_ttl_u'});
		}

	$self->save_directive($self->{'conf'}, "auth_param", \@auth);
	}
elsif ($self->{'squid_version'} >= 2) {
	if ($self->{'in_hash'}->{'auth_mode'} == 0) {
		$self->save_directive($self->{'conf'}, "authenticate_program", [ ]);
		}
	elsif ($self->{'in_hash'}->{'auth_mode'} == 2) {
		$self->system_logged("cp $self->{'module_root_directory'}/squid-auth.pl $self->{'module_config_directory'}");
		$self->save_directive($self->{'conf'}, "authenticate_program",
			[ { 'name' => 'authenticate_program',
			    'values' => [ "$self->{'auth_program'} $self->{'auth_database'}" ] } ]);
		$self->system_logged("chmod a+rx $self->{'auth_program'} $self->{'auth_database'}");
		}
	else {
		$self->check_error(\&check_prog, $self->{'in_hash'}->{'auth'});
		$self->save_directive($self->{'conf'}, "authenticate_program",
				[ { 'name' => 'authenticate_program',
				    'values' => [ $self->{'in_hash'}->{'auth'} ] } ]);
		}
	$self->save_opt("authenticate_children", \&check_children, $self->{'conf'});

        $self->save_opt("proxy_auth_realm", undef, $self->{'conf'});

	if ($self->{'squid_version'} >= 2.4) {
		$self->save_opt_time("authenticate_ttl", $self->{'conf'});
		$self->save_opt_time("authenticate_ip_ttl", $self->{'conf'});
		}
	}

$self->flush_file_lines();
$self->unlock_file($self->{'config_hash'}->{'squid_conf'});
$self->webmin_log("authparam", undef, undef, \%{$self->{'in_hash'}});
$self->redirect("");

1;
		
}

sub check_prog
{
	shift if ($self == $_[0]);

$_[0] =~ /^(\/\S+)/ || return $self->text('sprog_emsg2', $_[0]);
return -x $1 ? undef : $self->text('sprog_emsg3',$_[0]); 
}

sub check_children
{
	shift if ($self == $_[0]);

return $_[0] =~ /^\d+$/ ? undef : $self->text('sprog_emsg5',$_[0]);
}

# save_auth(&auth, type, name, [value])
sub save_auth
{
	shift if ($self == $_[0]);

local ($old) = grep { $_->{'values'}->[0] eq $_[1] &&
		      $_->{'values'}->[1] eq $_[2] } @{$_[0]};
if ($old && @_ > 3) {
	# Replace value
	$old->{'values'} = [ $_[1], $_[2], $_[3] ];
	}
elsif (@_ > 3) {
	# Adding
	push(@{$_[0]}, { 'name' => 'auth_param',
			 'values' => [ $_[1], $_[2], $_[3] ] });
	}
elsif ($old) {
	# Removing
	@{$_[0]} = grep { $_ ne $old } @{$_[0]};
	}
}


1;

