#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_cache.cgi
# Save cache and request options

&ModuleLoader::preload_module('squid_class', "squid::SquidLib");
$self = new squid::SquidLib:: 'squid_class',%$self;

$self->{'access_hash'}->{'copts'} || $self->error($self->{'text_hash'}->{'ec_ecannot'});
$self->ReadParse();
$self->lock_file($self->{'config_hash'}->{'squid_conf'});
$self->{'conf'} = $self->get_config();
$self->{'whatfailed'} = $self->{'text_hash'}->{'scache_ftsco'};

if ($self->{'in_hash'}->{'cache_dir_def'}) {
	$self->save_directive($self->{'conf'}, "cache_dir", [ ]);
	}
else {
	for($i=0; defined($self->{'dir'} = $self->{'in_hash'}->{"cache_dir_$i"}); $i++) {
		if ($self->{'squid_version'} >= 2.4) {
			$self->{'lv1'} = $self->{'in_hash'}->{"cache_lv1_$i"}; $self->{'lv2'} = $self->{'in_hash'}->{"cache_lv2_$i"};
			$self->{'size'} = $self->{'in_hash'}->{"cache_size_$i"};
			$self->{'type'} = $self->{'in_hash'}->{"cache_type_$i"};
			$self->{'opts'} = $self->{'in_hash'}->{"cache_opts_$i"};
			next if (!$self->{'dir'} && !$self->{'lv1'} && !$self->{'lv2'} && !$self->{'size'});
			$self->check_error(\&check_dir, $self->{'dir'});
			$self->check_error(\&check_dirsize, $self->{'size'});
			$self->check_error(\&check_dircount, $self->{'lv1'});
			$self->check_error(\&check_dircount, $self->{'lv2'});
			push(@{$self->{'chd_array'}}, { 'name' => 'cache_dir',
				     'values' => [ $self->{'type'}, $self->{'dir'}, $self->{'size'},
						   $self->{'lv1'}, $self->{'lv2'}, $self->{'opts'} ] });
			}
		elsif ($self->{'squid_version'} >= 2.3) {
			$self->{'lv1'} = $self->{'in_hash'}->{"cache_lv1_$i"}; $self->{'lv2'} = $self->{'in_hash'}->{"cache_lv2_$i"};
			$self->{'size'} = $self->{'in_hash'}->{"cache_size_$i"};
			$self->{'type'} = $self->{'in_hash'}->{"cache_type_$i"};
			next if (!$self->{'dir'} && !$self->{'lv1'} && !$self->{'lv2'} && !$self->{'size'});
			$self->check_error(\&check_dir, $self->{'dir'});
			$self->check_error(\&check_dirsize, $self->{'size'});
			$self->check_error(\&check_dircount, $self->{'lv1'});
			$self->check_error(\&check_dircount, $self->{'lv2'});
			push(@{$self->{'chd_array'}}, { 'name' => 'cache_dir',
				     'values' => [ $self->{'type'}, $self->{'dir'}, $self->{'size'},
						   $self->{'lv1'}, $self->{'lv2'} ] });
			}
		elsif ($self->{'squid_version'} >= 2) {
			$self->{'lv1'} = $self->{'in_hash'}->{"cache_lv1_$i"}; $self->{'lv2'} = $self->{'in_hash'}->{"cache_lv2_$i"};
			$self->{'size'} = $self->{'in_hash'}->{"cache_size_$i"};
			next if (!$self->{'dir'} && !$self->{'lv1'} && !$self->{'lv2'} && !$self->{'size'});
			$self->check_error(\&check_dir, $self->{'dir'});
			$self->check_error(\&check_dirsize, $self->{'size'});
			$self->check_error(\&check_dircount, $self->{'lv1'});
			$self->check_error(\&check_dircount, $self->{'lv2'});
			push(@{$self->{'chd_array'}}, { 'name' => 'cache_dir',
				     'values' => [ $self->{'dir'}, $self->{'size'}, $self->{'lv1'}, $self->{'lv2'} ] });
			}
		else {
			next if (!$self->{'dir'});
			$self->check_error(\&check_dir, $self->{'dir'});
			push(@{$self->{'chd_array'}}, { 'name' => 'cache_dir',
				     'values' => [ $self->{'dir'} ] });
			}
		}
	if (!@{$self->{'chd_array'}}) {
		$self->error($self->{'text_hash'}->{'scache_emsg0'});
		}
	$self->save_directive($self->{'conf'}, "cache_dir", \@{$self->{'chd_array'}});
	}
if ($self->{'squid_version'} < 2) {
	$self->save_opt("swap_level1_dirs", \&check_dircount, $self->{'conf'});
	$self->save_opt("swap_level2_dirs", \&check_dircount, $self->{'conf'});
	$self->save_opt("store_avg_object_size", \&check_objsize, $self->{'conf'});
	}
else {
	$self->save_opt_bytes("store_avg_object_size", $self->{'conf'});
	}
$self->save_opt("store_objects_per_bucket", \&check_bucket, $self->{'conf'});
if ($self->{'squid_version'} < 2) {
	$self->save_list("cache_stoplist", undef, $self->{'conf'});
	$self->save_list("cache_stoplist_pattern", undef, $self->{'conf'});
	}
@{$self->{'noch_array'}} = split(/\0/, $self->{'in_hash'}->{'no_cache'});
if (@{$self->{'noch_array'}}) {
	$self->{'nc_array'}->[0] = { 'name' => 'no_cache',
		   'values' => [ "deny", @{$self->{'noch_array'}} ] };
	}
$self->save_directive($self->{'conf'}, "no_cache", \@{$self->{'nc_array'}}, "acl");
$self->save_opt_time("reference_age", $self->{'conf'});
if ($self->{'squid_version'} < 2) {
	$self->save_opt("request_size", \&check_size, $self->{'conf'});
	$self->save_opt("negative_ttl", \&check_ttl, $self->{'conf'});
	$self->save_opt("positive_dns_ttl", \&check_dns_ttl, $self->{'conf'});
	$self->save_opt("negative_dns_ttl", \&check_dns_ttl, $self->{'conf'});
	}
else {
	if ($self->{'squid_version'} >= 2.3) {
		$self->save_opt_bytes("request_body_max_size", $self->{'conf'});
		$self->save_opt_bytes("request_header_max_size", $self->{'conf'});
		if ($self->{'squid_version'} < 2.5) {
			$self->save_opt_bytes("reply_body_max_size", $self->{'conf'});
			}
		else {
			$self->save_opt_bytes("read_ahead_gap", $self->{'conf'});
			}
		}
	else {
		$self->save_opt_bytes("request_size", $self->{'conf'});
		}
	$self->save_opt_time("negative_ttl", $self->{'conf'});
	$self->save_opt_time("positive_dns_ttl", $self->{'conf'});
	$self->save_opt_time("negative_dns_ttl", $self->{'conf'});
	}
if ($self->{'squid_version'} >= 2.5) {
	# Parse list of max reply body sizes
	for($i=0; defined($self->{'s'} = $self->{'in_hash'}->{"reply_body_max_size_$i"}); $i++) {
		next if ($self->{'s'} eq "");
		$self->error($self->text('scache_emaxrs', $i+1)) if ($self->{'s'} !~ /^\d+$/);
		local @a = split(/\s+/, $self->{'in_hash'}->{"reply_body_max_acls_$i"});
		push(@{$self->{'rbms_array'}}, { 'name' => 'reply_body_max_size',
			      'values' => [ $self->{'s'}, @a ] });
		}
	$self->save_directive($self->{'conf'}, "reply_body_max_size", \@{$self->{'rbms_array'}});
	}
if ($self->{'squid_version'} < 2) {
	$self->save_opt("connect_timeout", \&check_timeout, $self->{'conf'});
	$self->save_opt("read_timeout", \&check_timeout, $self->{'conf'});
	$self->save_opt("client_lifetime", \&check_lifetime, $self->{'conf'});
	$self->save_opt("shutdown_lifetime", \&check_lifetime, $self->{'conf'});
	}
else {
	$self->save_opt_time("connect_timeout", $self->{'conf'});
	$self->save_opt_time("read_timeout", $self->{'conf'});
	$self->save_opt_time("siteselect_timeout", $self->{'conf'});
	$self->save_opt_time("request_timeout", $self->{'conf'});
	$self->save_opt_time("client_lifetime", $self->{'conf'});
	$self->save_opt_time("shutdown_lifetime", $self->{'conf'});
	$self->save_choice("half_closed_clients", "on", $self->{'conf'});
	$self->save_opt_time("pconn_timeout", $self->{'conf'});
	}
if ($self->{'squid_version'} < 2) {
	if (!$self->{'in_hash'}->{'wais_relay_def'}) {
		$self->check_error(\&check_host, $self->{'in_hash'}->{'wais_relay1'});
		$self->check_error(\&check_port, $self->{'in_hash'}->{'wais_relay2'});
		$self->{'wr_array'}->[0] = { 'name' => 'wais_relay',
			   'values' =>  [ $self->{'in_hash'}->{'wais_relay1'}, $self->{'in_hash'}->{'wais_relay2'} ] };
		}
	$self->save_directive($self->{'conf'}, "wais_relay", \@{$self->{'wr_array'}});
	}
else {
	$self->save_opt("wais_relay_host", \&check_host, $self->{'conf'});
	$self->save_opt("wais_relay_port", \&check_port, $self->{'conf'});
	}

$self->flush_file_lines();
$self->unlock_file($self->{'config_hash'}->{'squid_conf'});
$self->webmin_log("cache", undef, undef, \%{$self->{'in_hash'}});
$self->redirect("");

1;
		
}

sub check_dir
{
	shift if ($self == $_[0]);

return (-d $_[0]) ? undef : $self->text('scache_emsg1',$_[0]);
}

sub check_size
{
	shift if ($self == $_[0]);

return $_[0] =~ /^\d+$/ ? undef : $self->text('scache_emsg2',$_[0]);
}

sub check_ttl
{
	shift if ($self == $_[0]);

return $_[0] =~ /^\d+$/ ? undef
			: $self->text('scache_emsg3',$_[0]);
}

sub check_dns_ttl
{
	shift if ($self == $_[0]);

return $_[0] =~ /^\d+$/ ? undef : $self->text('scache_emsg4',$_[0]);
}

sub check_timeout
{
	shift if ($self == $_[0]);

return $_[0] =~ /^\d+$/ ? undef : $self->text('scache_emsg5',$_[0]);
}

sub check_lifetime
{
	shift if ($self == $_[0]);

return $_[0] =~ /^\d+$/ ? undef : $self->text('scache_emsg6',$_[0]);
}

sub check_dircount
{
	shift if ($self == $_[0]);

return $_[0] !~ /^\d+$/ ? $self->text('scache_emsg7',$_[0]) : 
       $_[0] < 1 ? $self->{'text_hash'}->{'scache_emsg8'} :
       $_[0] > 256 ? $self->{'text_hash'}->{'scache_emsg9'} : undef;
    
}

sub check_objsize
{
	shift if ($self == $_[0]);

return $_[0] =~ /^\d+/ ? undef : $self->text('scache_emsg10',$_[0]);
}

sub check_bucket
{
	shift if ($self == $_[0]);

return $_[0] =~ /^\d+$/ ? undef : $self->text('scache_emsg11',$_[0]);
}

sub check_dirsize
{
	shift if ($self == $_[0]);

return $_[0] =~ /^\d+$/ ? undef : $self->text('scache_emsg12',$_[0]);
}

sub check_host
{
	shift if ($self == $_[0]);

return gethostbyname($_[0]) || $self->check_ipaddress($_[0]) ? undef
		: $self->text('scache_emsg13',$_[0]);
}

sub check_port
{
	shift if ($self == $_[0]);

return $_[0] =~ /^\d+$/ ? undef : $self->text('scache_emsg14',$_[0]);
}


1;

