#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_cache_host.cgi
# Save, create or delete a cache_host directive

&ModuleLoader::preload_module('squid_class', "squid::SquidLib");
$self = new squid::SquidLib:: 'squid_class',%$self;

$self->{'access_hash'}->{'othercaches'} || $self->error($self->{'text_hash'}->{'eicp_ecannot'});
$self->ReadParse();
$self->lock_file($self->{'config_hash'}->{'squid_conf'});
$self->{'conf'} = $self->get_config();
$self->{'cache_host'} = $self->{'squid_version'} >= 2 ? "cache_peer" : "cache_host";
@{$self->{'ch_array'}} = $self->find_config($self->{'cache_host'}, $self->{'conf'});
@{$self->{'chd_array'}} = $self->find_config($self->{'cache_host'}."_domain", $self->{'conf'});

$self->{'dom'} = $self->{'ch_array'}->[$self->{'in_hash'}->{'num'}]->{'values'}->[0];
if ($self->{'in_hash'}->{'delete'}) {
	# delete some directive
	$self->{'dir'} = $self->{'ch_array'}->[$self->{'in_hash'}->{'num'}];
	splice(@{$self->{'ch_array'}}, $self->{'in_hash'}->{'num'}, 1);

	# delete any cache_host directives as well
	for($i=0; $i<@{$self->{'chd_array'}}; $i++) {
		if ($self->{'chd_array'}->[$i]->{'values'}->[0] eq $self->{'dom'}) {
			splice(@{$self->{'chd_array'}}, $i--, 1);
			}
		}
	}
else {
	# validate inputs
	$self->{'whatfailed'} = $self->{'text_hash'}->{'schost_ftsc'};
	gethostbyname($self->{'in_hash'}->{'host'}) || $self->check_ipaddress($self->{'in_hash'}->{'host'}) ||
		$self->error($self->text('schost_emsg1',$self->{'in_hash'}->{'host'}));
	$self->{'in_hash'}->{'proxy'} =~ /^\d+$/ ||
		$self->error($self->text('schost_emsg2',$self->{'in_hash'}->{'proxy'}));
	$self->{'in_hash'}->{'icp'} =~ /^\d+$/ ||
		$self->error($self->text('schost_emsg3',$self->{'in_hash'}->{'icp'}));
	$self->{'in_hash'}->{'ttl'} =~ /^\d*$/ ||
		$self->error($self->text('schost_emsg4',$self->{'in_hash'}->{'ttl'}));
	$self->{'in_hash'}->{'weight'} =~ /^\d*$/ ||
		$self->error($self->text('schost_emsg5',$self->{'in_hash'}->{'weight'}));

	@{$self->{'vals_array'}} = ($self->{'in_hash'}->{'host'}, $self->{'in_hash'}->{'type'}, $self->{'in_hash'}->{'proxy'}, $self->{'in_hash'}->{'icp'});
	@{$self->{'optlist_array'}} = ("proxy-only", "weight", "ttl", "no-query", "default",
                    "round-robin", "multicast-responder",
		    "closest-only", "no-digest",	# squid 2+
		    "no-netdb-exchange", "no-delay",
		    "connect-timeout", "digest-url",	# squid 3+
		    "allow-miss", "max-conn", "htcp", "forceddomain",
		    "originserver", "ssl");
	foreach $o (@{$self->{'optlist_array'}}) {
		$self->{'def'} = $self->{'in_hash'}->{$o."_def"};
		if (defined($self->{'def'})) {
			if (!$self->{'def'}) { push(@{$self->{'vals_array'}}, "$o=$self->{'in_hash'}->{$o}"); }
			}
		elsif ($self->{'in_hash'}->{$o}) { push(@{$self->{'vals_array'}}, $o); }
		}
	if ($self->{'in_hash'}->{'login'} == 1) {
		push(@{$self->{'vals_array'}}, "login=".$self->{'in_hash'}->{'login_user'}.":".$self->{'in_hash'}->{'login_pass'});
		}
	elsif ($self->{'in_hash'}->{'login'} == 2) {
		push(@{$self->{'vals_array'}}, "login=PASS");
		}
	elsif ($self->{'in_hash'}->{'login'} == 3) {
		push(@{$self->{'vals_array'}}, "login=*:".$self->{'in_hash'}->{'login_pass2'});
		}

	# Add any old options that are not supported
	if (!$self->{'in_hash'}->{'new'}) {
		%{$self->{'supported_hash'}} = map { $_, 1 } @{$self->{'optlist_array'}};
		$self->{'supported_hash'}->{'login'} = 1;
		@{$self->{'ech_array'}} = @{$self->{'ch_array'}->[$self->{'in_hash'}->{'num'}]->{'values'}};
		for($i=4; $i<@{$self->{'ech_array'}}; $i++) {
			if ($self->{'ech_array'}->[$i] =~ /^(\S+)=(\S+)$/ ||
			    $self->{'ech_array'}->[$i] =~ /^(\S+)$/) {
				if (!$self->{'supported_hash'}->{$1}) {
					push(@{$self->{'vals_array'}}, $self->{'ech_array'}->[$i]);
					}
				}
			}
		}

	$self->{'dir'} = { 'name' => $self->{'cache_host'}, 'values' => \@{$self->{'vals_array'}} };
	@{$self->{'chdl_array'}} = split(/\s+/, $self->{'in_hash'}->{'doq'});
	foreach $dontq (split(/\s+/, $self->{'in_hash'}->{'dontq'})) { push(@{$self->{'chdl_array'}}, "!$dontq"); }
	if ($self->{'in_hash'}->{'new'}) {
		# adding a new cache_host and domains
		push(@{$self->{'ch_array'}}, $self->{'dir'});
		if (@{$self->{'chdl_array'}}) {
			push(@{$self->{'chd_array'}}, { 'name' => $self->{'cache_host'}."_domain",
				     'values' => [ $self->{'vals_array'}->[0], @{$self->{'chdl_array'}} ] });
			}
		}
	else {
		# updating existing cache_host and domains
		$self->{'ch_array'}->[$self->{'in_hash'}->{'num'}] = $self->{'dir'};
		if (@{$self->{'chdl_array'}}) {
			# replace the first cache_host_domain directive
			# for this host and remove the rest
			$self->{'newv'} = { 'name' => $self->{'cache_host'}."_domain",
				  'values' => [ $self->{'vals_array'}->[0], @{$self->{'chdl_array'}} ] };
			for($i=0; $i<@{$self->{'chd_array'}}; $i++) {
				if ($self->{'chd_array'}->[$i]->{'values'}->[0] eq $self->{'dom'}) {
					if ($self->{'already'}) {
						splice(@{$self->{'chd_array'}}, $i--, 1);
						}
					else {
						$self->{'chd_array'}->[$i] = $self->{'newv'};
						$self->{'already'}++;
						}
					}
				}
			if (!$self->{'already'}) { push(@{$self->{'chd_array'}}, $self->{'newv'}); }
			}
		elsif (@{$self->{'chd_array'}}) {
			# remove all the old cache_host_domain directives
			# for this host
			@{$self->{'chd_array'}} = grep { $_->{'values'}->[0] ne $self->{'dom'} } @{$self->{'chd_array'}};
			}
		}
	}
$self->save_directive($self->{'conf'}, $self->{'cache_host'}, \@{$self->{'ch_array'}});
$self->save_directive($self->{'conf'}, $self->{'cache_host'}."_domain", \@{$self->{'chd_array'}});
$self->flush_file_lines();
$self->unlock_file($self->{'config_hash'}->{'squid_conf'});
$self->webmin_log($self->{'in_hash'}->{'delete'} ? 'delete' : $self->{'in_hash'}->{'new'} ? 'create' : 'modify',
	    "host", $self->{'dir'}->{'values'}->[0], \%{$self->{'in_hash'}});
$self->redirect("edit_icp.cgi");

1;
		
}


1;

