#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_ext.cgi
# Create, update or delete an external auth program

&ModuleLoader::preload_module('squid_class', "squid::SquidLib");
$self = new squid::SquidLib:: 'squid_class',%$self;

$self->error_setup($self->{'text_hash'}->{'ext_err'});
$self->{'access_hash'}->{'actrl'} || $self->error($self->{'text_hash'}->{'eacl_ecannot'});
$self->ReadParse();
$self->{'conf'} = $self->get_config();
@{$self->{'exts_array'}} = $self->find_config("external_acl_type", $self->{'conf'});
$self->{'ext'} = $self->{'conf'}->[$self->{'in_hash'}->{'index'}] if (!$self->{'in_hash'}->{'new'});

if ($self->{'in_hash'}->{'delete'}) {
	# Just delete it (as long as there are no ACL references)
	@{$self->{'used_array'}} = grep { $_->{'values'}->[1] eq 'external' &&
		       $_->{'values'}->[2] eq $self->{'ext'}->{'values'}->[0] }
		     $self->find_config("acl", $self->{'conf'});
	$self->error($self->{'text_hash'}->{'ext_eused'}) if (@{$self->{'used_array'}});
	splice(@{$self->{'exts_array'}}, $self->indexof($self->{'ext'}, @{$self->{'exts_array'}}), 1);
	$self->{'logext'} = $self->{'ext'};
	}
else {
	# Validate and store inputs
	$self->{'in_hash'}->{'name'} =~ /^\S+$/ || $self->error($self->{'text_hash'}->{'ext_ename'});
	if (!$self->{'ext'} || $self->{'in_hash'}->{'name'} ne $self->{'ext'}->{'values'}->[0]) {
		# Check for a clash
		local ($clash) = grep { $_->{'values'}->[0] eq $self->{'in_hash'}->{'name'} }
				      @{$self->{'exts_array'}};
		$self->error($self->{'text_hash'}->{'ext_eclash'}) if ($clash);
		}
	push(@{$self->{'vals_array'}}, $self->{'in_hash'}->{'name'});
	foreach $on ('ttl', 'negative_ttl', 'concurrency', 'cache') {
		if (!$self->{'in_hash'}->{$on.'_def'}) {
			$self->{'in_hash'}->{$on} =~ /^\d+$/ || $self->error($self->{'text_hash'}->{'ext_e'.$on});
			push(@{$self->{'vals_array'}}, $on."=".$self->{'in_hash'}->{$on});
			}
		}
	$self->{'in_hash'}->{'format'} =~ /^\S+/ || $self->error($self->{'text_hash'}->{'ext_eformat'});
	push(@{$self->{'vals_array'}}, $self->{'in_hash'}->{'format'});
	$self->{'in_hash'}->{'program'} =~ /^(\S+)/ && $self->has_command("$1") ||
		$self->error($self->{'text_hash'}->{'ext_eprogram'});
	push(@{$self->{'vals_array'}}, $self->{'in_hash'}->{'program'});

	# Create or update
	$self->{'logext'} = $self->{'newext'} = { 'name' => 'external_acl_type',
			      'values' => \@{$self->{'vals_array'}} };
	if ($self->{'ext'}) { $self->{'exts_array'}->[$self->indexof($self->{'ext'}, @{$self->{'exts_array'}})] = $self->{'newext'}; }
	else { push(@{$self->{'exts_array'}}, $self->{'newext'}); }

	if ($self->{'ext'} && $self->{'in_hash'}->{'name'} ne $self->{'ext'}->{'values'}->[0]) {
		# Fix any ACLs that referred to this external type
		@{$self->{'acls_array'}} = $self->find_config("acl", $self->{'conf'});
		foreach $a (@{$self->{'acls_array'}}) {
			if ($a->{'values'}->[1] eq 'external' &&
			    $a->{'values'}->[2] eq $self->{'ext'}->{'values'}->[0]) {
				$a->{'values'}->[2] = $self->{'in_hash'}->{'name'};
				}
			}
		$self->save_directive($self->{'conf'}, "acl", \@{$self->{'acls_array'}});
		}
	}

$self->save_directive($self->{'conf'}, "external_acl_type", \@{$self->{'exts_array'}});
$self->flush_file_lines();
$self->unlock_file($self->{'config_hash'}->{'squid_conf'});
$self->webmin_log($self->{'in_hash'}->{'delete'} ? 'delete' : $self->{'ext'} ? 'modify' : 'create',
	    'ext', $self->{'logext'}->{'values'}->[0]);
$self->redirect("edit_acl.cgi");

1;
		
}


1;

