#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_logs.cgi
# Save logging options

&ModuleLoader::preload_module('squid_class', "squid::SquidLib");
$self = new squid::SquidLib:: 'squid_class',%$self;

$self->{'access_hash'}->{'logging'} || $self->error($self->{'text_hash'}->{'elogs_ecannot'});
$self->ReadParse();
$self->lock_file($self->{'config_hash'}->{'squid_conf'});
$self->{'conf'} = $self->get_config();
$self->{'whatfailed'} = $self->{'text_hash'}->{'slogs_ftslo'};

if ($self->{'squid_version'} < 2.6) {
	# Just a single logging directive
	$self->save_opt("cache_access_log", \&check_file, $self->{'conf'});
	}
else {
	# Supports definition of log formats and files
	for($i=0; defined($self->{'fname'} = $self->{'in_hash'}->{"fname_$i"}); $i++) {
		$self->{'ffmt'} = $self->{'in_hash'}->{"ffmt_$i"};
		next if (!$self->{'fname'});
		$self->{'fname'} =~ /^\S+$/ || $self->error($self->text('slogs_efname', $i+1));
		$self->{'ffmt'} =~ /\S/ || $self->error($self->text('slogs_effmt', $i+1));
		push(@{$self->{'logformat_array'}}, { 'name' => 'logformat',
				   'values' => [ $self->{'fname'}, $self->{'ffmt'} ] });
		}
	$self->save_directive($self->{'conf'}, "logformat", \@{$self->{'logformat_array'}});

	# Save log files
	for($i=0; defined($self->{'afile'} = $self->{'in_hash'}->{"afile_$i"}); $i++) {
		$self->{'adef'} = $self->{'in_hash'}->{"afile_def_$i"};
		next if ($self->{'adef'} == 1);
		$self->{'adef'} == 2 || $self->{'afile'} =~ /^\/\S+$/ ||
			$self->error($self->text('slogs_eafile', $i+1));
		$self->{'afmt'} = $self->{'in_hash'}->{"afmt_$i"};
		$self->{'aacls'} = $self->{'in_hash'}->{"aacls_$i"};
		push(@{$self->{'access_array'}},
		  { 'name' => 'access_log',
		    'values' => [ $self->{'adef'} == 2 ? "none" : $self->{'afile'},
				  $self->{'afmt'} ? ( $self->{'afmt'} ) :
				   $self->{'aacls'} ? ( "squid" ) : ( ),
				  split(/\s+/, $self->{'aacls'}) ] } );
		}
	$self->save_directive($self->{'conf'}, "access_log", \@{$self->{'access_array'}});
	}

$self->save_opt("cache_log", \&check_file, $self->{'conf'});
if ($self->{'in_hash'}->{'cache_store_log_def'} == 2) {
	$self->save_directive($self->{'conf'}, "cache_store_log",
			[ { 'name' => 'cache_store_log',
			    'values' => [ "none" ] } ]);
	}
else {
	$self->save_opt("cache_store_log", \&check_file, $self->{'conf'});
	}
$self->save_opt("cache_swap_log", \&check_file, $self->{'conf'});
$self->save_choice("emulate_httpd_log", "off", $self->{'conf'});
$self->save_choice("log_mime_hdrs", "off", $self->{'conf'});
$self->save_opt("useragent_log", \&check_file, $self->{'conf'});
$self->save_opt("pid_filename", \&check_pid_file, $self->{'conf'});
if ($self->{'squid_version'} >= 2.2) {
	if (!$self->{'in_hash'}->{'complex_ident'}) {
		local @ila = split(/\0/, $self->{'in_hash'}->{'ident_lookup_access'});
		$self->save_directive($self->{'conf'}, "ident_lookup_access", !@ila ? [ ] :
				[ { 'name' => 'ident_lookup_access',
				    'values' => [ 'allow', @ila ] } ]);
		}
	$self->save_opt_time("ident_timeout", $self->{'conf'});
	}
else {
	$self->save_choice("ident_lookup", "off", $self->{'conf'});
	}
$self->save_choice("log_fqdn", "off", $self->{'conf'});
$self->save_opt("client_netmask", \&check_netmask, $self->{'conf'});
$self->save_opt("debug_options", \&check_debug, $self->{'conf'});
if ($self->{'squid_version'} >= 2) {
	$self->save_opt("mime_table", \&check_file, $self->{'conf'});
	}

$self->flush_file_lines();
$self->unlock_file($self->{'config_hash'}->{'squid_conf'});
$self->webmin_log("logs", undef, undef, \%{$self->{'in_hash'}});
$self->redirect("");

1;
		
}

sub check_pid_file
{
	shift if ($self == $_[0]);

return $_[0] eq 'none' ? undef : &check_file($_[0]);
}

sub check_file
{
	shift if ($self == $_[0]);

$_[0] =~ /^\// || return $self->text('slogs_emsg1',$_[0]);
$_[0] =~ /^(\S*\/)([^\/\s]+)$/ || return $self->text('slogs_emsg2',$_[0]);
(-d $1) || return $self->text('slogs_emsg3',$1);
return undef;
}

sub check_netmask
{
	shift if ($self == $_[0]);

$self->check_ipaddress($_[0]) || return $self->text('slogs_emsg4',$_[0]);
return undef;
}

sub check_debug
{
	shift if ($self == $_[0]);

$_[0] =~ /\S+/ || return $self->text('slogs_emsg5',$_[0]);
return undef;
}


1;

