#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_mem.cgi
# Save memory usage options

&ModuleLoader::preload_module('squid_class', "squid::SquidLib");
$self = new squid::SquidLib:: 'squid_class',%$self;

$self->{'access_hash'}->{'musage'} || $self->error($self->{'text_hash'}->{'emem_ecannot'});
$self->ReadParse();
$self->lock_file($self->{'config_hash'}->{'squid_conf'});
$self->{'conf'} = $self->get_config();
$self->{'whatfailed'} = $self->{'text_hash'}->{'smem_ftsmo'};

if ($self->{'squid_version'} < 2) {
	$self->save_opt("cache_mem", \&check_size, $self->{'conf'});
	$self->save_opt("cache_swap", \&check_size, $self->{'conf'});
	}
else {
	$self->save_opt_bytes("cache_mem", $self->{'conf'});
	$self->save_opt("fqdncache_size", \&check_size, $self->{'conf'});
	}
if ($self->{'squid_version'} < 2.5) {
	$self->save_opt("cache_mem_high", \&check_high, $self->{'conf'});
	$self->save_opt("cache_mem_low", \&check_low, $self->{'conf'});
	}
$self->save_opt("cache_swap_high", \&check_high, $self->{'conf'});
$self->save_opt("cache_swap_low", \&check_low, $self->{'conf'});
if ($self->{'squid_version'} < 2) {
	$self->save_opt("maximum_object_size", \&check_obj_size, $self->{'conf'});
	}
else {
	$self->save_opt_bytes("maximum_object_size", $self->{'conf'});
	}
$self->save_opt("ipcache_size", \&check_size, $self->{'conf'});
$self->save_opt("ipcache_high", \&check_high, $self->{'conf'});
$self->save_opt("ipcache_low", \&check_low, $self->{'conf'});
if ($self->{'squid_version'} >= 2.4) {
	$self->save_choice("cache_replacement_policy", '', $self->{'conf'});
	$self->save_choice("memory_replacement_policy", '', $self->{'conf'});
	}
$self->flush_file_lines();
$self->unlock_file($self->{'config_hash'}->{'squid_conf'});
$self->webmin_log("mem", undef, undef, \%{$self->{'in_hash'}});
$self->redirect("");

1;
		
}

sub check_size
{
	shift if ($self == $_[0]);

return $_[0] =~ /^\d+$/ ? undef : $self->text('smem_emsg1',$_[0]);
}

sub check_high
{
	shift if ($self == $_[0]);

return $_[0] =~ /^\d+$/ && $_[0] > 0 && $_[0] <= 100
		? undef : $self->text('smem_emsg2',$_[0]);
}

sub check_low
{
	shift if ($self == $_[0]);

return $_[0] =~ /^\d+$/ && $_[0] > 0 && $_[0] <= 100
		? undef : $self->text('smem_emsg3',$_[0]);
}

sub check_obj_size
{
	shift if ($self == $_[0]);

return $_[0] =~ /^\d+$/ ? undef : $self->text('smem_emsg4',$_[0]);
}


1;

