#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_misc.cgi
# Save miscellaneous options

&ModuleLoader::preload_module('squid_class', "squid::SquidLib");
$self = new squid::SquidLib:: 'squid_class',%$self;

$self->{'access_hash'}->{'miscopt'} || $self->error($self->{'text_hash'}->{'emisc_ecannot'});
$self->ReadParse();
$self->lock_file($self->{'config_hash'}->{'squid_conf'});
$self->{'conf'} = $self->get_config();
$self->{'whatfailed'} = $self->{'text_hash'}->{'smisc_ftso'};

$self->save_opt("dns_testnames", undef, $self->{'conf'});
$self->save_opt("logfile_rotate", \&check_rotate, $self->{'conf'});
$self->save_opt("append_domain", \&check_domain, $self->{'conf'});
if ($self->{'squid_version'} < 2) {
	$self->save_opt("ssl_proxy", \&check_proxy, $self->{'conf'});
	$self->save_opt("passthrough_proxy", \&check_proxy, $self->{'conf'});
	}
$self->save_opt("err_html_text", undef, $self->{'conf'});
$self->save_choice("client_db", "on", $self->{'conf'});
$self->save_choice("forwarded_for", "on", $self->{'conf'});
$self->save_choice("log_icp_queries", "on", $self->{'conf'});
$self->save_opt("minimum_direct_hops", \&check_hops, $self->{'conf'});
if ($self->{'squid_version'} >= 2.2 && $self->{'squid_version'} < 2.5) {
	$self->{'m'} = $self->{'in_hash'}->{'anon_mode'};
	if ($self->{'m'} == 0) {
		$self->save_directive($self->{'conf'}, "anonymize_headers", [ ]);
		}
	else {
		$self->save_directive($self->{'conf'}, "anonymize_headers",
			[ { 'name' => 'anonymize_headers',
			    'values' => [ $self->{'m'}==1 ? "allow" : "deny",
					  $self->{'m'}==1 ? $self->{'in_hash'}->{'anon_allow'}
						: $self->{'in_hash'}->{'anon_deny'} ] } ]);
		}
	}
elsif ($self->{'squid_version'} < 2.2) {
	$self->save_choice("http_anonymizer", "off", $self->{'conf'});
	}
$self->save_opt("fake_user_agent", undef, $self->{'conf'});
$self->save_choice("memory_pools", "on", $self->{'conf'});
if ($self->{'squid_version'} < 3.0) {
	if ($self->{'in_hash'}->{'accel'} == 0) {
		$self->save_directive($self->{'conf'}, "httpd_accel_host", [ ]);
		}
	else {
		local $v = $self->{'in_hash'}->{'accel'} == 1 ? "virtual" : $self->{'in_hash'}->{"httpd_accel_host"};
		$self->save_directive($self->{'conf'}, "httpd_accel_host",
				[ { 'name' => "httpd_accel_host", 'values' => [$v] } ]);
		}
	$self->save_opt("httpd_accel_port", undef, $self->{'conf'});
	$self->save_choice("httpd_accel_with_proxy", undef, $self->{'conf'});
	$self->save_choice("httpd_accel_uses_host_header", undef, $self->{'conf'});
	if ($self->{'squid_version'} >= 2.5) {
		$self->save_choice("httpd_accel_single_host", undef, $self->{'conf'});
		}
	}
if ($self->{'squid_version'} >= 2) {
	$self->save_opt_bytes("memory_pools_limit", $self->{'conf'});
	}
if ($self->{'squid_version'} >= 2.3) {
        $self->save_opt("wccp_router", undef, $self->{'conf'});
        $self->save_opt("wccp_incoming_address", undef, $self->{'conf'});
        $self->save_opt("wccp_outgoing_address", undef, $self->{'conf'});
	}
$self->flush_file_lines();
$self->unlock_file($self->{'config_hash'}->{'squid_conf'});
$self->webmin_log("misc", undef, undef, \%{$self->{'in_hash'}});
$self->redirect("");

1;
		
}

sub check_rotate
{
	shift if ($self == $_[0]);

return $_[0] =~ /^\d+$/ ? undef : $self->text('smisc_emsg1',$_[0]);
}

sub check_domain
{
	shift if ($self == $_[0]);

return $_[0] =~ /^[A-z0-9\.\-]+$/ ? undef : $self->text('smisc_emsg2',$_[0]); 
}

sub check_proxy
{
	shift if ($self == $_[0]);

return $_[0] =~ /^\S+$/ ? undef : $self->text('smisc_emsg3',$_[0]); 
}

sub check_hops
{
	shift if ($self == $_[0]);

return $_[0] =~ /^\d+$/ ? undef : $self->text('smisc_emsg4',$_[0]); 
}


1;

