#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_pool.cgi
# Create, update or delete a delay pool

&ModuleLoader::preload_module('squid_class', "squid::SquidLib");
$self = new squid::SquidLib:: 'squid_class',%$self;

$self->{'access_hash'}->{'delay'} || $self->error($self->{'text_hash'}->{'delay_ecannot'});
$self->ReadParse();
$self->lock_file($self->{'config_hash'}->{'squid_conf'});
$self->{'conf'} = $self->get_config();
$self->error_setup($self->{'text_hash'}->{'pool_err'});

@{$self->{'pools_array'}} = $self->find_config("delay_class", $self->{'conf'});
@{$self->{'params_array'}} = $self->find_config("delay_parameters", $self->{'conf'});
@{$self->{'access_array'}} = $self->find_config("delay_access", $self->{'conf'});
$self->{'pools'} = $self->find_config("delay_pools", $self->{'conf'});
$self->{'pools'} = { 'name' => 'delay_pools' } if (!$self->{'pools'});
if (!$self->{'in_hash'}->{'new'}) {
	($self->{'pool'}) = grep { $_->{'values'}->[0] == $self->{'in_hash'}->{'idx'} } @{$self->{'pools_array'}};
	($self->{'param'}) = grep { $_->{'values'}->[0] == $self->{'in_hash'}->{'idx'} } @{$self->{'params_array'}};
	}
else {
	$self->{'pool'} = { 'name' => 'delay_class',
		  'values' => [ $self->{'pools'}->{'values'}->[0] + 1 ] };
	$self->{'param'} = { 'name' => 'delay_parameters',
		   'values' => [ $self->{'pools'}->{'values'}->[0] + 1 ] };
	}

if ($self->{'in_hash'}->{'delete'}) {
	# When deleting, the numbers of any pools 'above' it must be shifted
	# down, any delay_access directives removed and the delay_pools count
	# decreased
	@{$self->{'access_array'}} = grep { $_->{'values'}->[0] != $self->{'in_hash'}->{'idx'} } @{$self->{'access_array'}};
	@{$self->{'pools_array'}} = grep { $_ ne $self->{'pool'} } @{$self->{'pools_array'}};
	@{$self->{'params_array'}} = grep { $_ ne $self->{'param'} } @{$self->{'params_array'}};
	map { $_->{'values'}->[0]-- if ($_->{'values'}->[0] > $self->{'in_hash'}->{'idx'}) } 
		(@{$self->{'access_array'}}, @{$self->{'pools_array'}}, @{$self->{'params_array'}});
	$self->save_directive($self->{'conf'}, "delay_class", \@{$self->{'pools_array'}});
	$self->save_directive($self->{'conf'}, "delay_parameters", \@{$self->{'params_array'}});
	$self->save_directive($self->{'conf'}, "delay_access", \@{$self->{'access_array'}});
	$self->{'pools'}->{'values'}->[0]--;
	$self->save_directive($self->{'conf'}, "delay_pools", [ $self->{'pools'} ]);
	}
else {
	# Validate and store inputs
	$self->{'pool'}->{'values'}->[1] = $self->{'in_hash'}->{'class'};
	if ($self->{'in_hash'}->{'class'} == 1) {
		@{$self->{'v_array'}} = ( &parse_limit("agg") );
		}
	elsif ($self->{'in_hash'}->{'class'} == 2) {
		@{$self->{'v_array'}} = ( &parse_limit("agg"), &parse_limit("ind") );
		}
	elsif ($self->{'in_hash'}->{'class'} == 3) {
		@{$self->{'v_array'}} = ( &parse_limit("agg"), &parse_limit("net"),
		       &parse_limit("ind") );
		}
	elsif ($self->{'in_hash'}->{'class'} == 4) {
		@{$self->{'v_array'}} = ( &parse_limit("agg"), &parse_limit("net"),
		       &parse_limit("ind"), &parse_limit("user") );
		}
	elsif ($self->{'in_hash'}->{'class'} == 5) {
		@{$self->{'v_array'}} = ( &parse_limit("tag") );
		}
	$self->{'param'}->{'values'} = [ $self->{'param'}->{'values'}->[0], @{$self->{'v_array'}} ];

	if ($self->{'in_hash'}->{'new'}) {
		# Add the pool and increment the count
		$self->{'pools'}->{'values'}->[0]++;
		push(@{$self->{'pools_array'}}, $self->{'pool'});
		push(@{$self->{'params_array'}}, $self->{'param'});
		$self->save_directive($self->{'conf'}, "delay_pools", [ $self->{'pools'} ]);
		}
	$self->save_directive($self->{'conf'}, "delay_class", \@{$self->{'pools_array'}});
	$self->save_directive($self->{'conf'}, "delay_parameters", \@{$self->{'params_array'}});
	$self->save_directive($self->{'conf'}, "delay_access", \@{$self->{'access_array'}});
	}

$self->flush_file_lines();
$self->unlock_file($self->{'config_hash'}->{'squid_conf'});
$self->webmin_log($self->{'in_hash'}->{'new'} ? "create" : $self->{'in_hash'}->{'delete'} ? "delete" : "modify",
	    "pool", $self->{'in_hash'}->{'idx'}, \%{$self->{'in_hash'}});
$self->redirect("edit_delay.cgi");

1;
		
}

# parse_limit(name)
sub parse_limit
{
	shift if ($self == $_[0]);

if ($self->{'in_hash'}->{"$_[0]_def"}) {
	return "-1/-1";
	}
else {
	local @ud = ( .125, 1, 125, 1000, 125000, 1000000 );
	local $u1 = $self->{'in_hash'}->{"$_[0]_1_n"};
	local $u2 = $self->{'in_hash'}->{"$_[0]_2_n"};
	$u1 =~ /^\d+$/ || $u1 == -1 || $self->error($self->text('pool_elimit1', $u1));
	$u2 =~ /^\d+$/ || $u2 == -1 || $self->error($self->text('pool_elimit2', $u2));
	$u1 = int($u1 * $ud[$self->{'in_hash'}->{"$_[0]_1_u"}]);
	$u2 = int($u2 * $ud[$self->{'in_hash'}->{"$_[0]_2_u"}]);
	return "$u1/$u2";
	}
}


1;

