#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_ports.cgi
# Save ports and other networking options

&ModuleLoader::preload_module('squid_class', "squid::SquidLib");
$self = new squid::SquidLib:: 'squid_class',%$self;

$self->{'access_hash'}->{'portsnets'} || $self->error($self->{'text_hash'}->{'eports_ecannot'});
$self->ReadParse();
$self->lock_file($self->{'config_hash'}->{'squid_conf'});
$self->{'conf'} = $self->get_config();
$self->{'whatfailed'} = $self->{'text_hash'}->{'sport_ftspo'};

if ($self->{'squid_version'} >= 2.3 && $self->{'in_hash'}->{'ports_def'}) {
	$self->save_directive($self->{'conf'}, 'http_port', [ ]);
	}
elsif ($self->{'squid_version'} >= 2.3) {
	&save_ports("http_port");
	if ($self->{'squid_version'} >= 2.5) {
		&save_ports("https_port");
		}
	}
else {
	$self->save_opt("http_port", \&check_port, $self->{'conf'});
	$self->save_opt("tcp_incoming_address", \&check_address, $self->{'conf'});
	}
$self->save_opt("icp_port", \&check_port, $self->{'conf'});
$self->save_opt("tcp_outgoing_address", \&check_address, $self->{'conf'});
$self->save_opt("udp_outgoing_address", \&check_address, $self->{'conf'});
$self->save_opt("udp_incoming_address", \&check_address, $self->{'conf'});
if (!$self->{'in_hash'}->{'udp_outgoing_address_def'} && !$self->{'in_hash'}->{'udp_incoming_address_def'} &&
     $self->{'in_hash'}->{'udp_outgoing_address'} eq $self->{'in_hash'}->{'udp_incoming_address'}) {
	$self->error("The outgoing and incoming UDP addresses cannot be the same");
	}
$self->save_address("mcast_groups", $self->{'conf'});
$self->save_opt("tcp_recv_bufsize", \&check_bufsize, $self->{'conf'});
if ($self->{'squid_version'} >= 2.6) {
	$self->save_choice("check_hostnames", "on", $self->{'conf'});
	$self->save_choice("allow_underscore", "on", $self->{'conf'});
	}
if ($self->{'squid_version'} >= 2.5) {
	$self->save_choice("ssl_unclean_shutdown", "off", $self->{'conf'});
	}
$self->flush_file_lines();
$self->unlock_file($self->{'config_hash'}->{'squid_conf'});
$self->webmin_log("ports", undef, undef, \%{$self->{'in_hash'}});
$self->redirect("");

1;
		
}

sub check_port
{
	shift if ($self == $_[0]);

return $_[0] =~ /^\d+$/ ? undef : $self->text('sport_emsg1',$_[0]);
}

sub check_address
{
	shift if ($self == $_[0]);

return $self->check_ipaddress($_[0]) || gethostbyname($_[0]) ? undef :
	$self->text('sport_emsg2',$_[0]);

}

sub check_bufsize
{
	shift if ($self == $_[0]);

return $_[0] =~ /^\d+$/ ? undef : $self->text('sport_emsg3',$_[0]);
}

# save_ports(name)
sub save_ports
{
	shift if ($self == $_[0]);

local ($i, $port, $addr, @ports);
for($i=0; defined($port = $self->{'in_hash'}->{"$_[0]_port_$i"}); $i++) {
	next if (!$port);
	$port =~ /^\d+$/ || $self->error("'$port' is not a valid port");
	if ($self->{'in_hash'}->{"$_[0]_addr_def_$i"}) {
		push(@ports, { 'name' => $_[0],
			       'values' => [ $port ] } );
		}
	else {
		$addr = $self->{'in_hash'}->{"$_[0]_addr_$i"};
		gethostbyname($addr) || $self->check_ipaddress($addr) ||
			$self->error("'$addr' is not a valid proxy address");
		push(@ports, { 'name' => $_[0],
			       'values' => [ "$addr:$port" ] } );
		}
	if ($self->{'squid_version'} >= 2.5) {
		push(@{$ports[$#ports]->{'values'}},
		     split(/\s+/, $self->{'in_hash'}->{"$_[0]_opts_$i"}));
		}
	}
$self->save_directive($self->{'conf'}, $_[0], \@ports);
}


1;

