#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_progs.cgi
# Save helper program options

&ModuleLoader::preload_module('squid_class', "squid::SquidLib");
$self = new squid::SquidLib:: 'squid_class',%$self;

$self->{'access_hash'}->{'hprogs'} || $self->error($self->{'text_hash'}->{'eprogs_ecannot'});
$self->ReadParse();
$self->lock_file($self->{'config_hash'}->{'squid_conf'});
$self->{'conf'} = $self->get_config();
$self->{'whatfailed'} = $self->{'text_hash'}->{'sprog_ftshpo'};

if ($self->{'squid_version'} < 2) {
	$self->save_opt("ftpget_program", \&check_prog, $self->{'conf'});
	$self->save_opt("ftpget_options", \&check_opts, $self->{'conf'});
	}
else {
	$self->save_opt("ftp_list_width", \&check_width, $self->{'conf'});
	}
$self->save_opt("ftp_user", \&check_ftpuser, $self->{'conf'});
$self->save_opt("cache_dns_program", \&check_prog, $self->{'conf'});
$self->save_opt("dns_children", \&check_children, $self->{'conf'});
$self->save_choice("dns_defnames", "off", $self->{'conf'});
if ($self->{'squid_version'} >= 2) {
	$self->save_opt("dns_nameservers", \&check_dnsservers, $self->{'conf'});
	}
$self->save_opt("unlinkd_program", \&check_prog, $self->{'conf'});
$self->save_opt("pinger_program", \&check_prog, $self->{'conf'});
$self->save_opt("redirect_program", \&check_prog, $self->{'conf'});
$self->save_opt("redirect_children", \&check_children, $self->{'conf'});

$self->flush_file_lines();
$self->unlock_file($self->{'config_hash'}->{'squid_conf'});
$self->webmin_log("progs", undef, undef, \%{$self->{'in_hash'}});
$self->redirect("");

1;
		
}

sub check_opts
{
	shift if ($self == $_[0]);

return $_[0] =~ /\S/ ? undef : $self->{'text_hash'}->{'sprog_emsg1'};
}

sub check_prog
{
	shift if ($self == $_[0]);

$_[0] =~ /^(\/\S+)/ || return $self->text('sprog_emsg2', $_[0]);
return -x $1 ? undef : $self->text('sprog_emsg3',$_[0]); 
}

sub check_ftpuser
{
	shift if ($self == $_[0]);

return $_[0] =~ /^\S+@\S*$/ ? undef : $self->text('sprog_emsg4',$_[0]);
}

sub check_children
{
	shift if ($self == $_[0]);

return $_[0] =~ /^\d+$/ ? undef : $self->text('sprog_emsg5',$_[0]);
}

sub check_width
{
	shift if ($self == $_[0]);

return $_[0] =~ /^\d+$/ ? undef : $self->text('sprog_emsg6',$_[0]);
}

sub check_dnsservers
{
	shift if ($self == $_[0]);

local $dns;
local @dns = split(/\s+/, $_[0]);
return $self->{'text_hash'}->{'sprog_emsg7'} if (!@dns);
foreach $dns (@dns) {
	$self->check_ipaddress($dns) || return $self->text('sprog_emsg8',$dns);
	}
return undef;
}


1;

