#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_smem.cgi
# Save simple memory usage options

&ModuleLoader::preload_module('squid_class', "squid::SquidLib");
$self = new squid::SquidLib:: 'squid_class',%$self;

$self->{'access_hash'}->{'musage'} || $self->error($self->{'text_hash'}->{'emem_ecannot'});
$self->ReadParse();
$self->lock_file($self->{'config_hash'}->{'squid_conf'});
$self->{'conf'} = $self->get_config();
$self->{'whatfailed'} = $self->{'text_hash'}->{'smem_ftsmo'};

if ($self->{'squid_version'} < 2) {
	$self->save_opt("cache_mem", \&check_size, $self->{'conf'});
	$self->save_opt("cache_swap", \&check_size, $self->{'conf'});
	}
else {
	$self->save_opt_bytes("cache_mem", $self->{'conf'});
	$self->save_opt("fqdncache_size", \&check_size, $self->{'conf'});
	}
if ($self->{'squid_version'} < 2) {
	$self->save_opt("maximum_object_size", \&check_obj_size, $self->{'conf'});
	}
else {
	$self->save_opt_bytes("maximum_object_size", $self->{'conf'});
	}
$self->save_opt("ipcache_size", \&check_size, $self->{'conf'});

if ($self->{'in_hash'}->{'cache_dir_def'}) {
	$self->save_directive($self->{'conf'}, "cache_dir", [ ]);
	}
else {
	for($i=0; defined($self->{'dir'} = $self->{'in_hash'}->{"cache_dir_$i"}); $i++) {
		if ($self->{'squid_version'} >= 2.4) {
			$self->{'lv1'} = $self->{'in_hash'}->{"cache_lv1_$i"}; $self->{'lv2'} = $self->{'in_hash'}->{"cache_lv2_$i"};
			$self->{'size'} = $self->{'in_hash'}->{"cache_size_$i"};
			$self->{'type'} = $self->{'in_hash'}->{"cache_type_$i"};
			$self->{'opts'} = $self->{'in_hash'}->{"cache_opts_$i"};
			next if (!$self->{'dir'} && !$self->{'lv1'} && !$self->{'lv2'} && !$self->{'size'});
			$self->check_error('check_dir', $self->{'dir'});
			$self->check_error('check_dirsize', $self->{'size'});
			$self->check_error('check_dircount', $self->{'lv1'});
			$self->check_error('check_dircount', $self->{'lv2'});
			push(@{$self->{'chd_array'}}, { 'name' => 'cache_dir',
				     'values' => [ $self->{'type'}, $self->{'dir'}, $self->{'size'},
						   $self->{'lv1'}, $self->{'lv2'}, $self->{'opts'} ] });
			}
		elsif ($self->{'squid_version'} >= 2.3) {
			$self->{'lv1'} = $self->{'in_hash'}->{"cache_lv1_$i"}; $self->{'lv2'} = $self->{'in_hash'}->{"cache_lv2_$i"};
			$self->{'size'} = $self->{'in_hash'}->{"cache_size_$i"};
			$self->{'type'} = $self->{'in_hash'}->{"cache_type_$i"};
			next if (!$self->{'dir'} && !$self->{'lv1'} && !$self->{'lv2'} && !$self->{'size'});
			$self->check_error('check_dir', $self->{'dir'});
			$self->check_error('check_dirsize', $self->{'size'});
			$self->check_error('check_dircount', $self->{'lv1'});
			$self->check_error('check_dircount', $self->{'lv2'});
			push(@{$self->{'chd_array'}}, { 'name' => 'cache_dir',
				     'values' => [ $self->{'type'}, $self->{'dir'}, $self->{'size'},
						   $self->{'lv1'}, $self->{'lv2'} ] });
			}
		elsif ($self->{'squid_version'} >= 2) {
			$self->{'lv1'} = $self->{'in_hash'}->{"cache_lv1_$i"}; $self->{'lv2'} = $self->{'in_hash'}->{"cache_lv2_$i"};
			$self->{'size'} = $self->{'in_hash'}->{"cache_size_$i"};
			next if (!$self->{'dir'} && !$self->{'lv1'} && !$self->{'lv2'} && !$self->{'size'});
			$self->check_error('check_dir', $self->{'dir'});
			$self->check_error('check_dirsize', $self->{'size'});
			$self->check_error('check_dircount', $self->{'lv1'});
			$self->check_error('check_dircount', $self->{'lv2'});
			push(@{$self->{'chd_array'}}, { 'name' => 'cache_dir',
				     'values' => [ $self->{'dir'}, $self->{'size'}, $self->{'lv1'}, $self->{'lv2'} ] });
			}
		else {
			next if (!$self->{'dir'});
			$self->check_error('check_dir', $self->{'dir'});
			push(@{$self->{'chd_array'}}, { 'name' => 'cache_dir',
				     'values' => [ $self->{'dir'} ] });
			}
		}
	if (!@{$self->{'chd_array'}}) {
		$self->error($self->{'text_hash'}->{'scache_emsg0'});
		}
	$self->save_directive($self->{'conf'}, "cache_dir", \@{$self->{'chd_array'}});
	}
if ($self->{'squid_version'} < 2) {
	$self->save_opt("swap_level1_dirs", 'check_dircount', $self->{'conf'});
	$self->save_opt("swap_level2_dirs", 'check_dircount', $self->{'conf'});
	$self->save_opt("store_avg_object_size", 'check_objsize', $self->{'conf'});
	}
else {
	$self->save_opt_bytes("store_avg_object_size", $self->{'conf'});
	}
$self->save_opt("store_objects_per_bucket", 'check_bucket', $self->{'conf'});

$self->flush_file_lines();
$self->unlock_file($self->{'config_hash'}->{'squid_conf'});
$self->webmin_log("mem", undef, undef, \%{$self->{'in_hash'}});
$self->redirect("");

1;
		
}

sub check_size
{
	shift if ($self == $_[0]);

return $_[0] =~ /^\d+$/ ? undef : $self->text('smem_emsg1',$_[0]);
}

sub check_high
{
	shift if ($self == $_[0]);

return $_[0] =~ /^\d+$/ && $_[0] > 0 && $_[0] <= 100
		? undef : $self->text('smem_emsg2',$_[0]);
}

sub check_low
{
	shift if ($self == $_[0]);

return $_[0] =~ /^\d+$/ && $_[0] > 0 && $_[0] <= 100
		? undef : $self->text('smem_emsg3',$_[0]);
}

sub check_obj_size
{
	shift if ($self == $_[0]);

return $_[0] =~ /^\d+$/ ? undef : $self->text('smem_emsg4',$_[0]);
}


1;

