#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_sports.cgi
# Save simple ports and other networking options

&ModuleLoader::preload_module('squid_class', "squid::SquidLib");
$self = new squid::SquidLib:: 'squid_class',%$self;

$self->{'access_hash'}->{'portsnets'} || $self->error($self->{'text_hash'}->{'eports_ecannot'});
$self->ReadParse();
$self->lock_file($self->{'config_hash'}->{'squid_conf'});
$self->{'conf'} = $self->get_config();
$self->{'whatfailed'} = $self->{'text_hash'}->{'sport_ftspo'};

if ($self->{'squid_version'} >= 2.3) {
	for($i=0; defined($self->{'port'} = $self->{'in_hash'}->{"port_$i"}); $i++) {
		next if (!$self->{'port'});
		$self->{'port'} =~ /^\d+$/ || $self->error("'$self->{'port'}' is not a valid port");
		if ($self->{'in_hash'}->{"addr_def_$i"}) {
			push(@{$self->{'ports_array'}}, { 'name' => 'http_port',
				       'values' => [ $self->{'port'} ] } );
			}
		else {
			$self->{'addr'} = $self->{'in_hash'}->{"addr_$i"};
			gethostbyname($self->{'addr'}) || $self->check_ipaddress($self->{'addr'}) ||
				$self->error("'$self->{'addr'}' is not a valid proxy address");
			push(@{$self->{'ports_array'}}, { 'name' => 'http_port',
				       'values' => [ "$addr:$self->{'port'}" ] } );
			}
		}
	$self->save_directive($self->{'conf'}, 'http_port', \@{$self->{'ports_array'}});
	}
else {
	$self->save_opt("http_port", \&check_port, $self->{'conf'});
	$self->save_opt("tcp_incoming_address", \&check_address, $self->{'conf'});
	}

$self->save_opt("dns_testnames", undef, $self->{'conf'});
$self->save_opt("httpd_accel_host", undef, $self->{'conf'});
$self->save_opt("httpd_accel_port", undef, $self->{'conf'});
$self->save_choice("httpd_accel_with_proxy", undef, $self->{'conf'});
$self->save_choice("httpd_accel_uses_host_header", undef, $self->{'conf'});

$self->flush_file_lines();
$self->unlock_file($self->{'config_hash'}->{'squid_conf'});
$self->webmin_log("ports", undef, undef, \%{$self->{'in_hash'}});
$self->redirect("");

1;
		
}

sub check_port
{
	shift if ($self == $_[0]);

return $_[0] =~ /^\d+$/ ? undef : $self->text('sport_emsg1',$_[0]);
}

sub check_address
{
	shift if ($self == $_[0]);

return $self->check_ipaddress($_[0]) || gethostbyname($_[0]) ? undef :
	$self->text('sport_emsg2',$_[0]);

}

sub check_bufsize
{
	shift if ($self == $_[0]);

return $_[0] =~ /^\d+$/ ? undef : $self->text('sport_emsg3',$_[0]);
}


1;

