#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_misc.cgi
# Display all other SSHd options

&ModuleLoader::preload_module('sshd_class', "sshd::SshdLib");
$self = new sshd::SshdLib:: 'sshd_class',%$self;

$self->ui_print_header(undef, $self->{'text_hash'}->{'misc_title'}, "", "misc");
$self->{'conf'} = $self->get_sshd_config();

print "<form action=save_misc.cgi>\n";
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'misc_header'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

$self->scmd();
$self->{'x11'} = $self->find_value("X11Forwarding", $self->{'conf'});
print "<td><b>$self->{'text_hash'}->{'misc_x11'}</b></td> <td nowrap>\n";
if ($self->{'version_hash'}->{'type'} eq 'ssh') {
	printf "<input type=radio name=x11 value=1 %s> %s\n",
		lc($self->{'x11'}) eq 'no' ? "" : "checked", $self->{'text_hash'}->{'yes'};
	printf "<input type=radio name=x11 value=0 %s> %s</td>\n",
		lc($self->{'x11'}) eq 'no' ? "checked" : "", $self->{'text_hash'}->{'no'};
	}
else {
	printf "<input type=radio name=x11 value=1 %s> %s\n",
		lc($self->{'x11'}) eq 'yes' ? "checked" : "", $self->{'text_hash'}->{'yes'};
	printf "<input type=radio name=x11 value=0 %s> %s</td>\n",
		lc($self->{'x11'}) eq 'yes' ? "" : "checked", $self->{'text_hash'}->{'no'};
	}
$self->ecmd();

if ($self->{'version_hash'}->{'type'} ne 'ssh' || $self->{'version_hash'}->{'number'} < 2) {
	$self->scmd();
	$self->{'xoff'} = $self->find_value("X11DisplayOffset", $self->{'conf'});
	print "<td><b>$self->{'text_hash'}->{'misc_xoff'}</b></td> <td nowrap>\n";
	printf "<input type=radio name=xoff_def value=1 %s> %s\n",
		$self->{'xoff'} ? "" : "checked", $self->{'text_hash'}->{'default'};
	printf "<input type=radio name=xoff_def value=0 %s>\n",
		$self->{'xoff'} ? "checked" : "";
	print "<input name=xoff size=4 value='$self->{'xoff'}'></td>\n";
	$self->ecmd();

	if ($self->{'version_hash'}->{'type'} eq 'ssh' || $self->{'version_hash'}->{'number'} >= 2) {
		$self->scmd(1);
		$self->{'xauth'} = $self->find_value("XAuthLocation", $self->{'conf'});
		print "<td><b>$self->{'text_hash'}->{'misc_xauth'}</b></td> <td colspan=3>\n";
		printf "<input type=radio name=xauth_def value=1 %s> %s\n",
			$self->{'xauth'} ? "" : "checked", $self->{'text_hash'}->{'default'};
		printf "<input type=radio name=xauth_def value=0 %s>\n",
			$self->{'xauth'} ? "checked" : "";
		print "<input name=xauth size=50 value='$self->{'xauth'}'></td>\n";
		$self->ecmd();
		}
	}

if ($self->{'version_hash'}->{'type'} eq 'ssh' && $self->{'version_hash'}->{'number'} < 2) {
	$self->scmd();
	$self->{'umask'} = $self->find_value("Umask", $self->{'conf'});
	print "<td><b>$self->{'text_hash'}->{'misc_umask'}</b></td> <td nowrap>\n";
	printf "<input type=radio name=umask_def value=1 %s> %s\n",
		$self->{'umask'} ? "" : "checked", $self->{'text_hash'}->{'misc_umask_def'};
	printf "<input type=radio name=umask_def value=0 %s>\n",
		$self->{'umask'} ? "checked" : "";
	print "<input name=umask size=4 value='$self->{'umask'}'></td>\n";
	$self->ecmd();
	}

$self->scmd();
$self->{'syslog'} = $self->find_value("SyslogFacility", $self->{'conf'});
print "<td><b>$self->{'text_hash'}->{'misc_syslog'}</b></td> <td nowrap>\n";
printf "<input type=radio name=syslog_def value=1 %s> %s\n",
	$self->{'syslog'} ? "" : "checked", $self->{'text_hash'}->{'default'};
printf "<input type=radio name=syslog_def value=0 %s>\n",
	$self->{'syslog'} ? "checked" : "";
print "<select name=syslog>\n";
foreach $s (DAEMON, USER, AUTH, LOCAL0,  LOCAL1,  LOCAL2,  LOCAL3,
            LOCAL4,  LOCAL5,  LOCAL6,  LOCAL7) {
	printf "<option %s>%s\n",
		lc($s) eq lc($self->{'syslog'}) ? 'selected' : '', $s;
	}
print "</select></td>\n";
$self->ecmd();

if ($self->{'version_hash'}->{'type'} eq 'openssh') {
	$self->scmd();
	$self->{'loglevel'} = $self->find_value("LogLevel", $self->{'conf'});
	print "<td><b>$self->{'text_hash'}->{'misc_loglevel'}</b></td> <td nowrap>\n";
	printf "<input type=radio name=loglevel_def value=1 %s> %s\n",
		$self->{'loglevel'} ? "" : "checked", $self->{'text_hash'}->{'default'};
	printf "<input type=radio name=loglevel_def value=0 %s>\n",
		$self->{'loglevel'} ? "checked" : "";
	print "<select name=loglevel>\n";
	foreach $s (QUIET, FATAL, ERROR, INFO, VERBOSE, DEBUG) {
		printf "<option %s>%s\n",
			lc($s) eq lc($self->{'loglevel'}) ? 'selected' : '', $s;
		}
	print "</select></td>\n";
	$self->ecmd();
	}

if ($self->{'version_hash'}->{'type'} ne 'ssh' || $self->{'version_hash'}->{'number'} < 2) {
	$self->scmd();
	$self->{'bits'} = $self->find_value("ServerKeyBits", $self->{'conf'});
	print "<td><b>$self->{'text_hash'}->{'misc_bits'}</b></td> <td nowrap>\n";
	printf "<input type=radio name=bits_def value=1 %s> %s\n",
		$self->{'bits'} ? "" : "checked", $self->{'text_hash'}->{'default'};
	printf "<input type=radio name=bits_def value=0 %s>\n",
		$self->{'bits'} ? "checked" : "";
	print "<input name=bits size=4 value='$self->{'bits'}'> $self->{'text_hash'}->{'bits'}</td>\n";
	$self->ecmd();
	}

if ($self->{'version_hash'}->{'type'} eq 'ssh') {
	$self->scmd();
	$self->{'quiet'} = $self->find_value("QuietMode", $self->{'conf'});
	print "<td><b>$self->{'text_hash'}->{'misc_quiet'}</b></td> <td nowrap>\n";
	printf "<input type=radio name=quiet value=1 %s> %s\n",
		lc($self->{'quiet'}) eq 'no' ? "" : "checked", $self->{'text_hash'}->{'yes'};
	printf "<input type=radio name=quiet value=0 %s> %s</td>\n",
		lc($self->{'quiet'}) eq 'no' ? "checked" : "", $self->{'text_hash'}->{'no'};
	$self->ecmd();
	}

if ($self->{'version_hash'}->{'type'} ne 'ssh' || $self->{'version_hash'}->{'number'} < 2) {
	$self->scmd();
	$self->{'regen'} = $self->find_value("KeyRegenerationInterval", $self->{'conf'});
	print "<td><b>$self->{'text_hash'}->{'misc_regen'}</b></td> <td nowrap>\n";
	printf "<input type=radio name=regen_def value=1 %s> %s\n",
		$self->{'regen'} ? "" : "checked", $self->{'text_hash'}->{'misc_regen_def'};
	printf "<input type=radio name=regen_def value=0 %s>\n",
		$self->{'regen'} ? "checked" : "";
	print "<input name=regen size=6 value='$self->{'regen'}'> $self->{'text_hash'}->{'secs'}</td>\n";
	$self->ecmd();
	}

if ($self->{'version_hash'}->{'type'} eq 'ssh' && $self->{'version_hash'}->{'number'} < 2) {
	$self->scmd();
	$self->{'fascist'} = $self->find_value("FascistLogging", $self->{'conf'});
	print "<td><b>$self->{'text_hash'}->{'misc_fascist'}</b></td> <td nowrap>\n";
	printf "<input type=radio name=fascist value=1 %s> %s\n",
		lc($self->{'fascist'}) eq 'yes' ? "checked" : "", $self->{'text_hash'}->{'yes'};
	printf "<input type=radio name=fascist value=0 %s> %s</td>\n",
		lc($self->{'fascist'}) eq 'yes' ? "" : "checked", $self->{'text_hash'}->{'no'};
	$self->ecmd();
	}

if ($self->{'version_hash'}->{'type'} ne 'ssh' || $self->{'version_hash'}->{'number'} < 2) {
	if ($self->{'version_hash'}->{'type'} eq 'ssh' || $self->{'version_hash'}->{'number'} >= 2) {
		$self->scmd(1);
		$self->{'pid'} = $self->find_value("PidFile", $self->{'conf'});
		print "<td><b>$self->{'text_hash'}->{'misc_pid'}</b></td> <td colspan=3>\n";
		printf "<input type=radio name=pid_def value=1 %s> %s\n",
			$self->{'pid'} ? "" : "checked", $self->{'text_hash'}->{'default'};
		printf "<input type=radio name=pid_def value=0 %s>\n",
			$self->{'pid'} ? "checked" : "";
		print "<input name=pid size=50 value='$self->{'pid'}'></td>\n";
		$self->ecmd();
		}
	}

if ($self->{'version_hash'}->{'type'} eq 'openssh' && $self->{'version_hash'}->{'number'} >= 3.2) {
	$self->scmd();
	$self->{'separ'} = $self->find_value("UsePrivilegeSeparation", $self->{'conf'});
	print "<td><b>$self->{'text_hash'}->{'misc_separ'}</b></td> <td nowrap>\n";
	printf "<input type=radio name=separ value=1 %s> %s\n",
		lc($self->{'separ'}) eq 'no' ? "" : "checked", $self->{'text_hash'}->{'yes'};
	printf "<input type=radio name=separ value=0 %s> %s</td>\n",
		lc($self->{'separ'}) eq 'no' ? "checked" : "", $self->{'text_hash'}->{'no'};
	$self->ecmd();
	}

print "</table></td></tr></table>\n";
print "<input type=submit value='$self->{'text_hash'}->{'save'}'></form>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

