#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_net.cgi
# Display networking related SSHd options

&ModuleLoader::preload_module('sshd_class', "sshd::SshdLib");
$self = new sshd::SshdLib:: 'sshd_class',%$self;

$self->ui_print_header(undef, $self->{'text_hash'}->{'net_title'}, "", "net");
$self->{'conf'} = $self->get_sshd_config();

print "<form action=save_net.cgi>\n";
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'net_header'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

if ($self->{'version_hash'}->{'type'} eq 'openssh' && $self->{'version_hash'}->{'number'} >= 3) {
	# Multiple listen addresses supported
	$self->scmd(1);
	@{$self->{'listens_array'}} = $self->find("ListenAddress", $self->{'conf'});
	print "<td valign=top><b>$self->{'text_hash'}->{'net_listen2'}</b></td>\n";
	print "<td colspan=3>\n";
	printf "<input type=radio name=listen_def value=1 %s> %s\n",
		@{$self->{'listens_array'}} ? "" : "checked", $self->{'text_hash'}->{'net_listen_def'};
	printf "<input type=radio name=listen_def value=0 %s> %s<br>\n",
		@{$self->{'listens_array'}} ? "checked" : "", $self->{'text_hash'}->{'net_below'};
	print "<table border>\n";
	print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'net_laddress'}</b></td> ",
	      "<td><b>$self->{'text_hash'}->{'net_lport'}</b></td> </tr>\n";
	$self->{'i'} = 0;
	foreach $l (@{$self->{'listens_array'}}, { }) {
		local ($a, $p) = $l->{'values'}->[0] =~ /^(.*):(\d+)$/ ?
				   ($1, $2) : ($l->{'values'}->[0]);
		print "<tr $self->{'cb'}>\n";
		print "<td><input name=address_$self->{'i'} size=25 value='$a'></td>\n";
		printf "<td><input type=radio name=port_def_$self->{'i'} value=1 %s> %s ",
			$p ? "" : "checked", $self->{'text_hash'}->{'default'};
		printf "<input type=radio name=port_def_$self->{'i'} value=0 %s>\n",
			$p ? "checked" : "";
		print "<input name=port_$self->{'i'} size=6 value='$p'></td>\n";
		print "</tr>\n";
		$self->{'i'}++;
		}
	print "</table>\n";
	$self->ecmd();
	}
else {
	# Just one listen address
	$self->scmd();
	$self->{'listen'} = $self->find_value("ListenAddress", $self->{'conf'});
	$self->{'listen'} = "" if ($self->{'listen'} eq "0.0.0.0");
	print "<td><b>$self->{'text_hash'}->{'net_listen'}</b></td> <td nowrap>\n";
	printf "<input type=radio name=listen_def value=1 %s> %s\n",
		$self->{'listen'} ? "" : "checked", $self->{'text_hash'}->{'net_listen_def'};
	printf "<input type=radio name=listen_def value=0 %s>\n",
		$self->{'listen'} ? "checked" : "";
	print "<input name=listen size=15 value='$self->{'listen'}'></td>\n";
	$self->ecmd();
	}

$self->scmd();
@{$self->{'ports_array'}} = $self->find("Port", $self->{'conf'});
$self->{'port'} = join(" ", map { $_->{'values'}->[0] } @{$self->{'ports_array'}});
print "<td><b>$self->{'text_hash'}->{'net_port'}</b></td> <td nowrap>\n";
printf "<input type=radio name=port_def value=1 %s> %s (22)\n",
	$self->{'port'} ? "" : "checked", $self->{'text_hash'}->{'default'};
printf "<input type=radio name=port_def value=0 %s>\n",
	$self->{'port'} ? "checked" : "";
print "<input name=port size=6 value='$self->{'port'}'></td>\n";
$self->ecmd();

if ($self->{'version_hash'}->{'type'} eq 'openssh' && $self->{'version_hash'}->{'number'} >= 2) {
	$self->scmd();
	$self->{'prots'} = $self->find_value("Protocol", $self->{'conf'});
	@{$self->{'prots_array'}} = $self->{'prots'} ? split(/,/, $self->{'prots'}) :
		 $self->{'version_hash'}->{'number'} >= 2.9 ? (1, 2) : (1);
	print "<td><b>$self->{'text_hash'}->{'net_prots'}</b></td> <td>\n";
	foreach $p (1, 2) {
		printf "<input type=checkbox name=prots value=%s %s> %s\n",
			$p, $self->indexof($p, @{$self->{'prots_array'}}) >= 0 ? "checked" : "",
			$self->{'text_hash'}->{"net_prots_$p"};
		}
	print "</td>\n";
	$self->ecmd();
	}

if ($self->{'version_hash'}->{'type'} eq 'ssh' &&
    ($self->{'version_hash'}->{'number'} < 2 || $self->{'version_hash'}->{'number'} >= 3)) {
	$self->scmd();
	$self->{'idle'} = $self->find_value("IdleTimeout", $self->{'conf'});
	if ($self->{'idle'} =~ /^(\d+)([smhdw])$/i) {
		$self->{'idle'} = $1; $self->{'units'} = $2;
		}
	print "<td><b>$self->{'text_hash'}->{'net_idle'}</b></td> <td>\n";
	printf "<input type=radio name=idle_def value=1 %s> %s\n",
		$self->{'idle'} ? "" : "checked", $self->{'text_hash'}->{'default'};
	printf "<input type=radio name=idle_def value=0 %s>\n",
		$self->{'idle'} ? "checked" : "";
	print "<input name=idle size=6 value='$self->{'idle'}'>\n";
	print "<select name=idle_units>\n";
	foreach $u ('s', 'm', 'h', 'd', 'w') {
		printf "<option value=%s %s>%s\n",
			$u, $self->{'units'} eq $u ? 'selected' : '',
			$self->{'text_hash'}->{"net_idle_$u"};
		}
	print "</select></td>\n";
	$self->ecmd();
	}

$self->scmd();
$self->{'keep'} = $self->find_value("KeepAlive", $self->{'conf'});
print "<td><b>$self->{'text_hash'}->{'net_keep'}</b></td> <td>\n";
printf "<input type=radio name=keep value=1 %s> %s\n",
	lc($self->{'keep'}) eq 'no' ? "" : "checked", $self->{'text_hash'}->{'yes'};
printf "<input type=radio name=keep value=0 %s> %s</td>\n",
	lc($self->{'keep'}) eq 'no' ? "checked" : "", $self->{'text_hash'}->{'no'};
$self->ecmd();

$self->scmd();
$self->{'grace'} = $self->find_value("LoginGraceTime", $self->{'conf'});
print "<td><b>$self->{'text_hash'}->{'net_grace'}</b></td> <td>\n";
printf "<input type=radio name=grace_def value=1 %s> %s\n",
	$self->{'grace'} ? "" : "checked", $self->{'text_hash'}->{'net_grace_def'};
printf "<input type=radio name=grace_def value=0 %s>\n",
	$self->{'grace'} ? "checked" : "";
print "<input name=grace size=6 value='$self->{'grace'}'> $self->{'text_hash'}->{'net_grace_s'}</td>\n";
$self->ecmd();

if ($self->{'version_hash'}->{'type'} ne 'openssh' || $self->{'version_hash'}->{'number'} >= 2) {
	$self->scmd();
	$self->{'tcp'} = $self->find_value("AllowTcpForwarding", $self->{'conf'});
	print "<td><b>$self->{'text_hash'}->{'net_tcp'}</b></td> <td>\n";
	printf "<input type=radio name=tcp value=1 %s> %s\n",
		lc($self->{'tcp'}) eq 'no' ? "" : "checked", $self->{'text_hash'}->{'yes'};
	printf "<input type=radio name=tcp value=0 %s> %s</td>\n",
		lc($self->{'tcp'}) eq 'no' ? "checked" : "", $self->{'text_hash'}->{'no'};
	$self->ecmd();
	}

if ($self->{'version_hash'}->{'type'} eq 'openssh' && $self->{'version_hash'}->{'number'} >= 2) {
	$self->scmd();
	$self->{'gateway'} = $self->find_value("GatewayPorts", $self->{'conf'});
	print "<td><b>$self->{'text_hash'}->{'net_gateway'}</b></td> <td>\n";
	printf "<input type=radio name=gateway value=1 %s> %s\n",
		lc($self->{'gateway'}) eq 'yes' ? "checked" : "", $self->{'text_hash'}->{'yes'};
	printf "<input type=radio name=gateway value=0 %s> %s</td>\n",
		lc($self->{'gateway'}) eq 'yes' ? "" : "checked", $self->{'text_hash'}->{'no'};
	$self->ecmd();

	if ($self->{'version_hash'}->{'number'} > 2.3 && $self->{'version_hash'}->{'number'} < 3.7) {
		$self->scmd();
		$self->{'reverse'} = $self->find_value("ReverseMappingCheck", $self->{'conf'});
		print "<td><b>$self->{'text_hash'}->{'net_reverse'}</b></td> <td>\n";
		printf "<input type=radio name=reverse value=1 %s> %s\n",
			lc($self->{'reverse'}) eq 'yes' ? "checked" : "", $self->{'text_hash'}->{'yes'};
		printf "<input type=radio name=reverse value=0 %s> %s</td>\n",
			lc($self->{'reverse'}) eq 'yes' ? "" : "checked", $self->{'text_hash'}->{'no'};
		$self->ecmd();
		}
	}

print "</table></td></tr></table>\n";
print "<input type=submit value='$self->{'text_hash'}->{'save'}'></form>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

