#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_users.cgi
# save user and group related sshd options

&ModuleLoader::preload_module('sshd_class', "sshd::SshdLib");
$self = new sshd::SshdLib:: 'sshd_class',%$self;

$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'access_err'});
$self->lock_file($self->{'config_hash'}->{'sshd_config'});
$self->{'conf'} = $self->get_sshd_config();

if ($self->{'version_hash'}->{'type'} eq 'ssh') {
	if ($self->{'in_hash'}->{'allowh_def'}) {
		$self->save_directive("AllowHosts", $self->{'conf'});
		}
	else {
		$self->{'in_hash'}->{'allowh'} =~ /\S/ || $self->error($self->{'text_hash'}->{'access_eallowh'});
		$self->save_directive("AllowHosts", $self->{'conf'}, $self->{'in_hash'}->{'allowh'});
		}

	if ($self->{'in_hash'}->{'denyh_def'}) {
		$self->save_directive("DenyHosts", $self->{'conf'});
		}
	else {
		$self->{'in_hash'}->{'denyh'} =~ /\S/ || $self->error($self->{'text_hash'}->{'access_edenyh'});
		$self->save_directive("DenyHosts", $self->{'conf'}, $self->{'in_hash'}->{'denyh'});
		}
	}

$self->{'commas'} = $self->{'version_hash'}->{'type'} eq 'ssh' && $self->{'version_hash'}->{'number'} >= 3.2;
if ($self->{'in_hash'}->{'allowu_def'}) {
	$self->save_directive("AllowUsers", $self->{'conf'});
	}
else {
	$self->{'in_hash'}->{'allowu'} =~ /\S/ || $self->error($self->{'text_hash'}->{'access_eallowu'});
	$self->save_directive("AllowUsers", $self->{'conf'},
	    $self->{'commas'} ? join(",", split(/\s+/, $self->{'in_hash'}->{'allowu'})) : $self->{'in_hash'}->{'allowu'});
	}
if ($self->{'in_hash'}->{'denyu_def'}) {
	$self->save_directive("DenyUsers", $self->{'conf'});
	}
else {
	$self->{'in_hash'}->{'denyu'} =~ /\S/ || $self->error($self->{'text_hash'}->{'access_edenyu'});
	$self->save_directive("DenyUsers", $self->{'conf'},
	    $self->{'commas'} ? join(",", split(/\s+/, $self->{'in_hash'}->{'denyu'})) : $self->{'in_hash'}->{'denyu'});
	}

if ($self->{'in_hash'}->{'allowg_def'}) {
	$self->save_directive("AllowGroups", $self->{'conf'});
	}
else {
	$self->{'in_hash'}->{'allowg'} =~ /\S/ || $self->error($self->{'text_hash'}->{'access_eallowg'});
	$self->save_directive("AllowGroups", $self->{'conf'},
	    $self->{'commas'} ? join(",", split(/\s+/, $self->{'in_hash'}->{'allowg'})) : $self->{'in_hash'}->{'allowg'});
	}
if ($self->{'in_hash'}->{'denyg_def'}) {
	$self->save_directive("DenyGroups", $self->{'conf'});
	}
else {
	$self->{'in_hash'}->{'denyg'} =~ /\S/ || $self->error($self->{'text_hash'}->{'access_edenyg'});
	$self->save_directive("DenyGroups", $self->{'conf'},
	    $self->{'commas'} ? join(",", split(/\s+/, $self->{'in_hash'}->{'denyg'})) : $self->{'in_hash'}->{'denyg'});
	}

if ($self->{'version_hash'}->{'type'} eq 'ssh' && $self->{'version_hash'}->{'number'} < 2) {
	$self->save_directive("SilentDeny", $self->{'conf'}, $self->{'in_hash'}->{'silent'} ? 'yes' : 'no');
	}

$self->flush_file_lines();
$self->unlock_file($self->{'config_hash'}->{'sshd_config'});
$self->webmin_log("access");
$self->redirect("");

1;
		
}


1;

