#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_misc.cgi
# save miscellaneous options

&ModuleLoader::preload_module('sshd_class', "sshd::SshdLib");
$self = new sshd::SshdLib:: 'sshd_class',%$self;

$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'misc_err'});
$self->lock_file($self->{'config_hash'}->{'sshd_config'});
$self->{'conf'} = $self->get_sshd_config();

$self->save_directive("X11Forwarding", $self->{'conf'}, $self->{'in_hash'}->{'x11'} ? 'yes' : 'no');

if ($self->{'version_hash'}->{'type'} ne 'ssh' || $self->{'version_hash'}->{'number'} < 2) {
	if ($self->{'in_hash'}->{'xoff_def'}) {
		$self->save_directive("X11DisplayOffset", $self->{'conf'});
		}
	else {
		$self->{'in_hash'}->{'xoff'} =~ /^\d+$/ || $self->error($self->{'text_hash'}->{'misc_exoff'});
		$self->save_directive("X11DisplayOffset", $self->{'conf'}, $self->{'in_hash'}->{'xoff'});
		}

	if ($self->{'version_hash'}->{'type'} eq 'ssh' || $self->{'version_hash'}->{'number'} >= 2) {
		if ($self->{'in_hash'}->{'xauth_def'}) {
			$self->save_directive("XAuthLocation", $self->{'conf'});
			}
		else {
			-x $self->{'in_hash'}->{'xauth'} || $self->error($self->{'text_hash'}->{'misc_exauth'});
			$self->save_directive("XAuthLocation", $self->{'conf'}, $self->{'in_hash'}->{'xauth'});
			}
		}
	}

if ($self->{'version_hash'}->{'type'} eq 'ssh' && $self->{'version_hash'}->{'number'} < 2) {
	if ($self->{'in_hash'}->{'umask_def'}) {
		$self->save_directive("Umask", $self->{'conf'});
		}
	else {
		$self->{'in_hash'}->{'umask'} =~ /^0[0-7][0-7][0-7]$/ ||
			$self->error($self->{'text_hash'}->{'misc_eumask'});
		$self->save_directive("Umask", $self->{'conf'}, $self->{'in_hash'}->{'umask'});
		}
	}

$self->save_directive("SyslogFacility", $self->{'conf'},
		$self->{'in_hash'}->{'syslog_def'} ? undef : $self->{'in_hash'}->{'syslog'});

if ($self->{'version_hash'}->{'type'} eq 'openssh') {
	$self->save_directive("LogLevel", $self->{'conf'},
			$self->{'in_hash'}->{'loglevel_def'} ? undef : $self->{'in_hash'}->{'loglevel'});
	}

if ($self->{'version_hash'}->{'type'} ne 'ssh' || $self->{'version_hash'}->{'number'} < 2) {
	if ($self->{'in_hash'}->{'bits_def'}) {
		$self->save_directive("ServerKeyBits", $self->{'conf'});
		}
	else {
		$self->{'in_hash'}->{'bits'} =~ /^\d+$/ || $self->error($self->{'text_hash'}->{'misc_ebits'});
		$self->save_directive("ServerKeyBits", $self->{'conf'}, $self->{'in_hash'}->{'bits'});
		}
	}

if ($self->{'version_hash'}->{'type'} eq 'ssh') {
	$self->save_directive("QuietMode", $self->{'conf'}, $self->{'in_hash'}->{'quite'} ? 'yes' : 'no');
	}

if ($self->{'version_hash'}->{'type'} ne 'ssh' || $self->{'version_hash'}->{'number'} < 2) {
	if ($self->{'in_hash'}->{'regen_def'}) {
		$self->save_directive("KeyRegenerationInterval", $self->{'conf'});
		}
	else {
		$self->{'in_hash'}->{'regen'} =~ /^\d+$/ || $self->error($self->{'text_hash'}->{'misc_eregen'});
		$self->save_directive("KeyRegenerationInterval", $self->{'conf'}, $self->{'in_hash'}->{'regen'});
		}
	}

if ($self->{'version_hash'}->{'type'} eq 'ssh' && $self->{'version_hash'}->{'number'} < 2) {
	$self->save_directive("FascistLogging", $self->{'conf'}, $self->{'in_hash'}->{'fascist'} ? 'yes' : 'no');
	}

if ($self->{'version_hash'}->{'type'} ne 'ssh' || $self->{'version_hash'}->{'number'} < 2) {
	if ($self->{'version_hash'}->{'type'} eq 'ssh' || $self->{'version_hash'}->{'number'} >= 2) {
		if ($self->{'in_hash'}->{'pid_def'}) {
			$self->save_directive("PidFile", $self->{'conf'});
			}
		else {
			$self->{'in_hash'}->{'pid'} =~ /^\S+$/ || $self->error($self->{'text_hash'}->{'misc_epid'});
			$self->save_directive("PidFile", $self->{'conf'}, $self->{'in_hash'}->{'pid'});
			}
		}
	}

if ($self->{'version_hash'}->{'type'} eq 'openssh' && $self->{'version_hash'}->{'number'} >= 3.2) {
	$self->save_directive("UsePrivilegeSeparation", $self->{'conf'},
			$self->{'in_hash'}->{'separ'} ? 'yes' : 'no');
	}

$self->flush_file_lines();
$self->unlock_file($self->{'config_hash'}->{'sshd_config'});
$self->webmin_log("misc");
$self->redirect("");

1;
		
}


1;

