#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_net.cgi
# save networking sshd options

&ModuleLoader::preload_module('sshd_class', "sshd::SshdLib");
$self = new sshd::SshdLib:: 'sshd_class',%$self;

$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'net_err'});
$self->lock_file($self->{'config_hash'}->{'sshd_config'});
$self->{'conf'} = $self->get_sshd_config();

if ($self->{'version_hash'}->{'type'} eq 'openssh' && $self->{'version_hash'}->{'number'} >= 3) {
	# Save multiple
	if ($self->{'in_hash'}->{'listen_def'}) {
		$self->save_directive("ListenAddress", $self->{'conf'});
		}
	else {
		for($i=0; defined($self->{'a'} = $self->{'in_hash'}->{"address_$i"}); $i++) {
			next if (!$self->{'a'});
			$self->check_ipaddress($self->{'a'}) || gethostbyname($self->{'a'}) ||
				$self->error($self->text('net_eladdress', $self->{'a'}));
			if ($self->{'in_hash'}->{"port_def_$i"}) {
				push(@{$self->{'listens_array'}}, $self->{'a'});
				}
			else {
				$self->{'in_hash'}->{"port_$i"} =~ /^\d+$/ ||
				    $self->error($self->text('net_elport', $self->{'in_hash'}->{"port_$i"}));
				push(@{$self->{'listens_array'}}, $self->{'a'}.":".$self->{'in_hash'}->{"port_$i"});
				}
			}
		@{$self->{'listens_array'}} || $self->error($self->{'text_hash'}->{'net_elisten2'});
		$self->save_directive("ListenAddress", $self->{'conf'}, @{$self->{'listens_array'}});
		}
	}
else {
	# Save just one address
	if ($self->{'in_hash'}->{'listen_def'}) {
		$self->save_directive("ListenAddress", $self->{'conf'});
		}
	else {
		$self->check_ipaddress($self->{'in_hash'}->{'listen'}) ||
		  ($self->{'version_hash'}->{'number'} >= 2 && gethostbyname($self->{'in_hash'}->{'listen'})) ||
		    $self->error($self->{'text_hash'}->{'net_elisten'});
		$self->save_directive("ListenAddress", $self->{'conf'}, $self->{'in_hash'}->{'listen'});
		}
	}

if ($self->{'in_hash'}->{'port_def'}) {
	$self->save_directive("Port", $self->{'conf'});
	}
else {
	@{$self->{'ports_array'}} = split(/\s+/, $self->{'in_hash'}->{'port'});
	@{$self->{'ports_array'}} || $self->error($self->{'text_hash'}->{'net_eport'});
	foreach $p (@{$self->{'ports_array'}}) {
		$p =~ /^\d+$/ || $self->error($self->{'text_hash'}->{'net_eport'});
		}
	$self->save_directive("Port", $self->{'conf'}, \@{$self->{'ports_array'}}, "ListenAddress");
	}

if ($self->{'version_hash'}->{'type'} eq 'openssh' && $self->{'version_hash'}->{'number'} >= 2) {
	@{$self->{'prots_array'}} = split(/\0/, $self->{'in_hash'}->{'prots'});
	@{$self->{'prots_array'}} || $self->error($self->{'text_hash'}->{'net_eprots'});
	$self->save_directive("Protocol", $self->{'conf'}, join(",", @{$self->{'prots_array'}}));
	}

if ($self->{'version_hash'}->{'type'} eq 'ssh' &&
    ($self->{'version_hash'}->{'number'} < 2 || $self->{'version_hash'}->{'number'} >= 3)) {
	if ($self->{'in_hash'}->{'idle_def'}) {
		$self->save_directive("IdleTimeout", $self->{'conf'});
		}
	else {
		$self->{'in_hash'}->{'idle'} =~ /^\d+$/ || $self->error($self->{'text_hash'}->{'net_eidle'});
		$self->save_directive("IdleTimeout", $self->{'conf'},
				$self->{'in_hash'}->{'idle'}.$self->{'in_hash'}->{'idle_units'});
		}
	}

$self->save_directive("KeepAlive", $self->{'conf'}, $self->{'in_hash'}->{'keep'} ? 'yes' : 'no');

if ($self->{'in_hash'}->{'grace_def'}) {
	$self->save_directive("LoginGraceTime", $self->{'conf'});
	}
else {
	$self->{'in_hash'}->{'grace'} =~ /^\d+$/ || $self->error($self->{'text_hash'}->{'net_egrace'});
	$self->save_directive("LoginGraceTime", $self->{'conf'}, $self->{'in_hash'}->{'grace'});
	}

if ($self->{'version_hash'}->{'type'} ne 'openssh' || $self->{'version_hash'}->{'number'} >= 2) {
	$self->save_directive("AllowTcpForwarding", $self->{'conf'}, $self->{'in_hash'}->{'tcp'} ? 'yes' : 'no');
	}

if ($self->{'version_hash'}->{'type'} eq 'openssh' && $self->{'version_hash'}->{'number'} >= 2) {
	$self->save_directive("GatewayPorts", $self->{'conf'}, $self->{'in_hash'}->{'gateway'} ? 'yes' : 'no');

	if ($self->{'version_hash'}->{'number'} > 2.3 && $self->{'version_hash'}->{'number'} < 3.7) {
		$self->save_directive("ReverseMappingCheck", $self->{'conf'},
				$self->{'in_hash'}->{'reverse'} ? 'yes' : 'no');
		}
	}

$self->flush_file_lines();
$self->unlock_file($self->{'config_hash'}->{'sshd_config'});
$self->webmin_log("net");
$self->redirect("");

1;
		
}


1;

