#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_users.cgi
# save user and group related sshd options

&ModuleLoader::preload_module('sshd_class', "sshd::SshdLib");
$self = new sshd::SshdLib:: 'sshd_class',%$self;

$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'users_err'});
$self->lock_file($self->{'config_hash'}->{'sshd_config'});
$self->{'conf'} = $self->get_sshd_config();

if ($self->{'version_hash'}->{'type'} eq 'ssh' && $self->{'version_hash'}->{'number'} < 2) {
	if ($self->{'in_hash'}->{'expire_def'}) {
		$self->save_directive("AccountExpireWarningDays", $self->{'conf'});
		}
	else {
		$self->{'in_hash'}->{'expire'} =~ /^\d+$/ || $self->error($self->{'text_hash'}->{'users_eexpire'});
		$self->save_directive("AccountExpireWarningDays", $self->{'conf'},
				$self->{'in_hash'}->{'expire'});
		}
	}

if ($self->{'version_hash'}->{'type'} eq 'ssh' || $self->{'version_hash'}->{'number'} < 3.1) {
	$self->save_directive("CheckMail", $self->{'conf'}, $self->{'in_hash'}->{'mail'} ? 'yes' : 'no');
	}

#$self->save_directive("ForcedEmptyPasswdChange", $self->{'conf'}, $self->{'in_hash'}->{'empty'} ? 'yes' : 'no');
#
#$self->save_directive("ForcedPasswdChange", $self->{'conf'}, $self->{'in_hash'}->{'passwd'} ? 'yes' : 'no');

if ($self->{'version_hash'}->{'type'} eq 'ssh' && $self->{'version_hash'}->{'number'} < 2) {
	if ($self->{'in_hash'}->{'pexpire_def'}) {
		$self->save_directive("PasswdExpireWarningDays", $self->{'conf'});
		}
	else {
		$self->{'in_hash'}->{'pexpire'} =~ /^\d+$/ || $self->error($self->{'text_hash'}->{'users_eexpire'});
		$self->save_directive("PasswdExpireWarningDays", $self->{'conf'},
				$self->{'in_hash'}->{'pexpire'});
		}
	}

if ($self->{'version_hash'}->{'type'} ne 'ssh' || $self->{'version_hash'}->{'number'} < 3) {
	$self->save_directive("PasswordAuthentication", $self->{'conf'},
			$self->{'in_hash'}->{'auth'} ? 'yes' : 'no');
	}

$self->save_directive("PermitEmptyPasswords", $self->{'conf'}, $self->{'in_hash'}->{'pempty'} ? 'yes' : 'no');

$self->save_directive("PermitRootLogin", $self->{'conf'}, $self->{'in_hash'}->{'root'});

if ($self->{'version_hash'}->{'type'} ne 'ssh' || $self->{'version_hash'}->{'number'} < 3) {
	$self->save_directive("RSAAuthentication", $self->{'conf'}, $self->{'in_hash'}->{'rsa'} ? 'yes' : 'no');
	}

$self->save_directive("StrictModes", $self->{'conf'}, $self->{'in_hash'}->{'strict'} ? 'yes' : 'no');

$self->save_directive("PrintMotd", $self->{'conf'}, $self->{'in_hash'}->{'motd'} ? 'yes' : 'no');

if ($self->{'version_hash'}->{'type'} eq 'openssh') {
	$self->save_directive("IgnoreUserKnownHosts", $self->{'conf'},
			$self->{'in_hash'}->{'known'} ? 'yes' : 'no');

	if ($self->{'version_hash'}->{'number'} > 2.3) {
		if ($self->{'in_hash'}->{'banner_def'}) {
			$self->save_directive("Banner", $self->{'conf'});
			}
		else {
			-r $self->{'in_hash'}->{'banner'} || $self->error($self->{'text_hash'}->{'users_ebanner'});
			$self->save_directive("Banner", $self->{'conf'}, $self->{'in_hash'}->{'banner'});
			}
		}
	}
elsif ($self->{'version_hash'}->{'type'} eq 'ssh' && $self->{'version_hash'}->{'number'} >= 2) {
	if ($self->{'in_hash'}->{'banner_def'}) {
		$self->save_directive("BannerMessageFile", $self->{'conf'});
		}
	else {
		-r $self->{'in_hash'}->{'banner'} || $self->error($self->{'text_hash'}->{'users_ebanner'});
		$self->save_directive("BannerMessageFile", $self->{'conf'}, $self->{'in_hash'}->{'banner'});
		}
	}

if ($self->{'version_hash'}->{'type'} eq 'openssh' && $self->{'version_hash'}->{'number'} >= 3) {
	if ($self->{'in_hash'}->{'authkeys_def'}) {
		$self->save_directive("AuthorizedKeysFile", $self->{'conf'});
		}
	else {
		$self->{'in_hash'}->{'authkeys'} =~ /^\S+$/ || $self->error($self->{'text_hash'}->{'users_eauthkeys'});
		$self->save_directive("AuthorizedKeysFile", $self->{'conf'}, $self->{'in_hash'}->{'authkeys'});
		}
	}

if ($self->{'version_hash'}->{'type'} eq 'openssh' && $self->{'version_hash'}->{'number'} < 3.7 ||
    $self->{'version_hash'}->{'type'} eq 'ssh' && $self->{'version_hash'}->{'number'} < 2) {
	$self->save_directive("RhostsAuthentication", $self->{'conf'},
			$self->{'in_hash'}->{'rhostsauth'} ? 'yes' : 'no');

	$self->save_directive("RhostsRSAAuthentication", $self->{'conf'},
			$self->{'in_hash'}->{'rhostsrsa'} ? 'yes' : 'no');
	}

$self->save_directive("IgnoreRhosts", $self->{'conf'}, $self->{'in_hash'}->{'rhosts'} ? 'yes' : 'no');

if ($self->{'version_hash'}->{'type'} eq 'ssh') {
	if ($self->{'in_hash'}->{'rrhosts'} == -1) {
		$self->save_directive("IgnoreRootRhosts", $self->{'conf'});
		}
	else {
		$self->save_directive("IgnoreRootRhosts", $self->{'conf'},
				$self->{'in_hash'}->{'rrhosts'} ? 'yes' : 'no');
		}
	}

$self->flush_file_lines();
$self->unlock_file($self->{'config_hash'}->{'sshd_config'});
$self->webmin_log("users");
$self->redirect("");

1;
		
}


1;

