#!/usr/bin/perl
package status::Consumemonitor;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'status::Consumemonitor');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# consume-monitor.pl
# Check the rate at which disk space is being consumed on some filesystem

1;
		return $self;
}

sub get_consume_status
{
	my $self = shift;

return { 'up' => -1 } if (!$self->foreign_check("mount"));
$self->foreign_require("mount", "mount-lib.pl");
local $m;
foreach $f ($main::mount_object->list_mounted()) {
	$m = $f if ($f->[0] eq $_[0]->{'fs'});
	}
local %consume;
$self->read_file("$self->{'module_config_directory'}/consume", \%consume);
if ($m) {
	local @sp = $main::mount_object->disk_space($m->[2], $m->[0]);
	local $now = time();
	local ($lastfree, $lasttime) = split(/\s+/, $consume{$_[0]->{'fs'}});
	local $rv = { 'up' => 1 };
	if ($lasttime) {
		# Compare with last time
		local $diff = ($lastfree - $sp[1]) / ($now - $lasttime);
		if ($diff > $_[0]->{'rate'}) {
			$rv = { 'up' => 0,
				'desc' => $self->text('consume_high',
						$self->nice_size($diff*1024)) };
			}
		}
	$consume{$_[0]->{'fs'}} = "$sp[1] $now";
	$self->write_file("$self->{'module_config_directory'}/consume", \%consume);
	return $rv;
	}
else {
	return { 'up' => -1,
		 'desc' => $self->{'text_hash'}->{'space_nofs'} };
	}
}

sub show_consume_dialog
{
	my $self = shift;

$self->foreign_require("mount", "mount-lib.pl");
local @mounted = $main::mount_object->list_mounted();
local ($got) = grep { $_->[0] eq $_[0]->{'fs'} } @mounted;
print $self->ui_table_row($self->{'text_hash'}->{'space_fs'},
	$self->ui_select("fs", !$_[0]->{'fs'} ? $mounted[0]->[0] :
			 !$got ? "" : $_[0]->{'fs'},
		   [ (map { [ $_->[0] ] } @mounted),
		     [ "", $self->{'text_hash'}->{'space_other'} ] ])."\n".
	$self->ui_textbox("other", $got ? "" : $_[0]->{'fs'}, 30),
	3);

print $self->ui_table_row($self->{'text_hash'}->{'consume_rate'},
	$self->ui_bytesbox("rate", $_[0]->{'rate'}*1024));

}

sub parse_consume_dialog
{
	my $self = shift;

$self->depends_check($_[0], "mount");
if ($self->{'in_hash'}->{'fs'}) {
	$_[0]->{'fs'} = $self->{'in_hash'}->{'fs'};
	}
else {
	$self->{'in_hash'}->{'other'} =~ /^\// || $self->error($self->{'text_hash'}->{'space_eother'});
	$_[0]->{'fs'} = $self->{'in_hash'}->{'other'};
	}
$self->{'in_hash'}->{'rate'} =~ /^[0-9\.]+$/ || $self->error($self->{'text_hash'}->{'consume_erate'});
$_[0]->{'rate'} = $self->{'in_hash'}->{'rate'}*$self->{'in_hash'}->{'rate_units'}/1024;
}


1;

