#!/usr/bin/perl
package status::Dnsadminmonitor;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'status::Dnsadminmonitor');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# dnsadmin-monitor.pl
# Monitor the BIND 4 DNS server on this host

1;

1;
		return $self;
}

# Check the PID file to see if BIND is running
sub get_dnsadmin_status
{
	my $self = shift;

return { 'up' => -1 } if (!$self->foreign_check($_[1]));
$self->foreign_require($_[1], "dns-lib.pl");
local %dconfig = $self->foreign_config($_[1]);
return { 'up' => -1 } if (!-r $dconfig{'named_boot_file'});
if (open(PID, $dconfig{'named_pid_file'}) && <PID> =~ /(\d+)/ && kill(0, $1)) {
	close(PID);
	local @st = stat($dconfig{'named_pid_file'});
	return { 'up' => 1,
		 'desc' => $self->text('up_since', scalar(localtime($st[9]))) };
	}
else {
	return { 'up' => 0 };
	}
}

sub parse_dnsadmin_dialog
{
	my $self = shift;

$self->depends_check($_[0], "dnsadmin");
}


1;

