#!/usr/bin/perl
package status::Dnsmonitor;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'status::Dnsmonitor');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# Check some DNS server

1;
		return $self;
}

sub get_dns_status
{
	my $self = shift;

if ($self->has_command("nslookup")) {
	local $out;
	local $cmd = "server $_[0]->{'server'}\n$_[0]->{'host'}\n";
	$self->execute_command("nslookup", \$cmd, \$out, \$out);
	return $out =~ /\Q$_[0]->{'address'}\E/ ? { 'up' => 1 }
					        : { 'up' => 0 };
	}
elsif ($self->has_command("dig")) {
	local $out;
	$self->execute_command("dig \@".quotemeta($_[0]->{'server'})." ".
			 quotemeta($_[0]->{'host'}), undef, \$out, \$out);
	return $out =~ /\Q$_[0]->{'host'}.\E\s+\S+\s+IN\s+A\s+\Q$_[0]->{'address'}\E/ ? { 'up' => 1 } : { 'up' => 0 };
	}
else {
	return { 'up' => - 1 };
	}
}

sub show_dns_dialog
{
	my $self = shift;

print $self->ui_table_row($self->{'text_hash'}->{'dns_server'},
	$self->ui_textbox("server", $_[0]->{'server'}, 30));

print $self->ui_table_row($self->{'text_hash'}->{'dns_host'},
	$self->ui_textbox("host", $_[0]->{'host'}, 30));

print $self->ui_table_row($self->{'text_hash'}->{'dns_address'},
	$self->ui_textbox("address", $_[0]->{'address'}, 30));
}

sub parse_dns_dialog
{
	my $self = shift;

$self->has_command("nslookup") || $self->has_command("dig") ||
	$self->error($self->{'text_hash'}->{'dns_ecmds'});
gethostbyname($self->{'in_hash'}->{'server'}) || $self->error($self->{'text_hash'}->{'dns_eserver'});
$_[0]->{'server'} = $self->{'in_hash'}->{'server'};
$self->{'in_hash'}->{'host'} =~ /^[a-z0-9\.\-\_]+$/i || $self->error($self->{'text_hash'}->{'dns_ehost'});
$_[0]->{'host'} = $self->{'in_hash'}->{'host'};
$self->check_ipaddress($self->{'in_hash'}->{'address'}) || $self->error($self->{'text_hash'}->{'dns_eaddress'});
$_[0]->{'address'} = $self->{'in_hash'}->{'address'};
}


1;

