#!/usr/bin/perl
package status::Ftpmonitor;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'status::Ftpmonitor');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# ftp-monitor.pl
# Monitor a remote FTP server by doing a test download

1;
		return $self;
}

sub get_ftp_status
{
	my $self = shift;

local $up=0;
local $st = time();
local $error;
local $temp = $self->transname();
eval {
	local $SIG{ALRM} = sub { die "alarm\n" }; # NB: \n required
	alarm($_[0]->{'alarm'} ? $_[0]->{'alarm'} : 10);

	$self->ftp_download($_[0]->{'host'}, $_[0]->{'file'}, $temp, \$error,
		      undef, $_[0]->{'user'}, $_[0]->{'pass'}, $_[0]->{'port'});
	alarm(0);
	$up = $error ? 0 : 1;
	};

if ($@) {
	die unless $@ eq "alarm\n";   # propagate unexpected errors
	return { 'up' => 0 };
	}
else { 
	return { 'up' => $up, 'time' => time() - $st,
		 'desc' => $up ? undef : $error };
	}
}

sub show_ftp_dialog
{
	my $self = shift;

print $self->ui_table_row($self->{'text_hash'}->{'ftp_host'},
	$self->ui_textbox("host", $_[0]->{'host'}, 30));

print $self->ui_table_row($self->{'text_hash'}->{'ftp_port'},
	$self->ui_textbox("port", $_[0]->{'port'} || 21, 5));

print $self->ui_table_row($self->{'text_hash'}->{'ftp_user'},
	$self->ui_opt_textbox("ftpuser", $_[0]->{'user'}, 15, $self->{'text_hash'}->{'ftp_anon'}));

print $self->ui_table_row($self->{'text_hash'}->{'ftp_pass'},
	$self->ui_password("ftppass", $_[0]->{'pass'}, 15));

print $self->ui_table_row($self->{'text_hash'}->{'ftp_file'},
	$self->ui_opt_textbox("file", $_[0]->{'file'}, 50, $self->{'text_hash'}->{'ftp_none'}), 3);

print $self->ui_table_row($self->{'text_hash'}->{'http_alarm'},
	$self->ui_opt_textbox("alarm", $_[0]->{'alarm'}, 5, $self->{'text_hash'}->{'default'}));
}

sub parse_ftp_dialog
{
	my $self = shift;

$self->{'in_hash'}->{'host'} =~ /^[a-z0-9\.\-\_]+$/i || $self->error($self->{'text_hash'}->{'ftp_ehost'});
$_[0]->{'host'} = $self->{'in_hash'}->{'host'};

$self->{'in_hash'}->{'port'} =~ /^\d+$/i || $self->error($self->{'text_hash'}->{'ftp_eport'});
$_[0]->{'port'} = $self->{'in_hash'}->{'port'};

$self->{'in_hash'}->{'ftpuser_def'} || $self->{'in_hash'}->{'ftpuser'} =~ /^\S+$/ || $self->error($self->{'text_hash'}->{'ftp_euser'});
$_[0]->{'user'} = $self->{'in_hash'}->{'ftpuser_def'} ? undef : $self->{'in_hash'}->{'ftpuser'};
$_[0]->{'pass'} = $self->{'in_hash'}->{'ftppass'};

$self->{'in_hash'}->{'file_def'} || $self->{'in_hash'}->{'file'} =~ /^\S+$/ || $self->error($self->{'text_hash'}->{'ftp_efile'});
$_[0]->{'file'} = $self->{'in_hash'}->{'file_def'} ? undef : $self->{'in_hash'}->{'file'};

if ($self->{'in_hash'}->{'alarm_def'}) {
	delete($_[0]->{'alarm'});
	}
else {
	$self->{'in_hash'}->{'alarm'} =~ /^\d+$/ || $self->error($self->{'text_hash'}->{'http_ealarm'});
	$_[0]->{'alarm'} = $self->{'in_hash'}->{'alarm'};
	}
}


1;

