#!/usr/bin/perl
package status::Loadmonitor;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'status::Loadmonitor');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# load-monitor.pl
# Check if the system load exceeds some level

1;
		return $self;
}

sub get_load_status
{
	my $self = shift;

local @u = $self->uptime_output();
if (!@u) {
	return { 'up' => -1 }
	}
elsif ($u[$_[0]->{'time'}] >= $_[0]->{'max'}) {
	return { 'up' => 0 }
	}
else {
	return { 'up' => 1,
		 'desc' => "Load is $u[$_[0]->{'time'}]" };
	}
}

sub show_load_dialog
{
	my $self = shift;

print $self->ui_table_row($self->{'text_hash'}->{'load_time'},
	$self->ui_radio("time", int($_[0]->{'time'}),
		  [ [ 0, $self->{'text_hash'}->{'load_1'} ],
		    [ 1, $self->{'text_hash'}->{'load_5'} ],
		    [ 2, $self->{'text_hash'}->{'load_15'} ] ]));

print $self->ui_table_row($self->{'text_hash'}->{'load_max'},
	$self->ui_textbox("max", $_[0]->{'max'}, 6));
}

sub parse_load_dialog
{
	my $self = shift;

$self->has_command("uptime") || $self->error($self->{'text_hash'}->{'load_ecmd'});
scalar($self->uptime_output()) || $self->error($self->{'text_hash'}->{'load_efmt'});
$self->{'in_hash'}->{'max'} =~ /^[0-9\.]+$/ || $self->error($self->{'text_hash'}->{'load_emax'});
$_[0]->{'time'} = $self->{'in_hash'}->{'time'};
$_[0]->{'max'} = $self->{'in_hash'}->{'max'};
}

sub uptime_output
{
	my $self = shift;

local $out = `uptime 2>&1`;
return $out =~ /average(s)?:\s+([0-9\.]+),?\s+([0-9\.]+),?\s+([0-9\.]+)/i ?
		( $2, $3, $4 ) : ( );
}


1;

