#!/usr/bin/perl
package status::Mailqmonitor;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'status::Mailqmonitor');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# Check if a mail queue is too long

1;
		return $self;
}

sub get_mailq_status
{
	my $self = shift;

local $m = $_[0]->{'mod'};
return { 'up' => -1 } if (!$self->foreign_installed($m));
local @qfiles;
if ($m eq "sendmail") {
	$self->foreign_require("sendmail", "sendmail-lib.pl");
	@qfiles = $main::sendmail_object->list_mail_queue();
	}
elsif ($m eq "qmailadmin") {
	$self->foreign_require("qmailadmin", "qmail-lib.pl");
	@qfiles = $main::qmailadmin_object->list_queue();
	}
elsif ($m eq "postfix") {
	$self->foreign_require("postfix", "postfix-lib.pl");
	@qfiles = $main::postfix_object->list_queue();
	}
if (@qfiles > $_[0]->{'size'}) {
	return { 'up' => 0,
		 'desc' => "<font color=#ff0000>".$self->text('mailq_toomany', scalar(@qfiles))."</font>" };
	}
else {
	return { 'up' => 1,
		 'desc' => $self->text('mailq_ok', scalar(@qfiles)) };
	}
}

sub show_mailq_dialog
{
	my $self = shift;

# Mail system to check
print $self->ui_table_row($self->{'text_hash'}->{'mailq_system'},
	$self->ui_select("mod", $_[0]->{'mod'},
		[ map { [ $_, $self->{'text_hash'}->{'mailq_'.$_} ] }
		  ("sendmail", "qmailadmin", "postfix") ]));

# Max queue size
print $self->ui_table_row($self->{'text_hash'}->{'mailq_size'},
	$self->ui_textbox("size", $_[0]->{'size'}, 10));
}

sub parse_mailq_dialog
{
	my $self = shift;

$_[0]->{'mod'} = $self->{'in_hash'}->{'mod'};
$self->{'in_hash'}->{'size'} =~ /^\d+$/ || $self->error($self->{'text_hash'}->{'mailq_esize'});
$_[0]->{'size'} = $self->{'in_hash'}->{'size'};
}


1;

