#!/usr/bin/perl
package status::Nutmonitor;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'status::Nutmonitor');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# Check if some NUT value is too low or high

1;
		return $self;
}

sub get_nut_status
{
	my $self = shift;

return { 'up' => -1 } if (!$self->has_command("upsc"));
local @sens = $self->get_ups_values($_[0]->{'ups'});
local ($sens) = grep { $_->{'name'} eq $_[0]->{'name'} } @sens;
return { 'up' => 1 } if (!$sens);
if ($_[0]->{'mode'} == 1) {
	return $sens->{'value'} < $_[0]->{'min'} ? { 'up' => 0 }
						 : { 'up' => 1 };
	}
elsif ($_[0]->{'mode'} == 2) {
	return $sens->{'value'} > $_[0]->{'max'} ? { 'up' => 0 }
						 : { 'up' => 1 };
	}
}

sub show_nut_dialog
{
	my $self = shift;

if (!$self->has_command("upsc")) {
	print $self->ui_table_row(undef, $self->{'text_hash'}->{'nut_cmd'}, 4);
	}
else {
	# UPS name
	print $self->ui_table_row($self->{'text_hash'}->{'nut_ups'},
		$self->ui_textbox("ups", $_[0]->{'ups'}, 20));

	# Value to check
	local @sens = $self->get_ups_values();
	if (@sens) {
		print $self->ui_table_row($self->{'text_hash'}->{'nut_name'},
		    $self->ui_select("name", $_[0]->{'name'},
			[ map { [ $_->{'name'},
			    $self->text('nut_cur', $_->{'name'}, $_->{'value'}) ] }
			  @sens ]));
		}
	else {
		print $self->ui_table_row($self->{'text_hash'}->{'nut_name'},
		    $self->ui_textbox("name", $_[0]->{'name'}, 20));
		}

	# Expected value
	print $self->ui_table_row($self->{'text_hash'}->{'nut_value'},
	    $self->ui_radio("mode", $_[0]->{'mode'} || 1,
		[ [ 1, $self->text('sensors_value1',
			     $self->ui_textbox("min", $_[0]->{'min'}, 8)) ],
		  [ 2, $self->text('sensors_value2',
			     $self->ui_textbox("max", $_[0]->{'max'}, 8)) ] ]),
	    3);
	}
}

sub parse_nut_dialog
{
	my $self = shift;

$self->has_command("upsc") || $self->error($self->{'text_hash'}->{'nut_cmd'});
$self->{'in_hash'}->{'ups'} =~ /^\S+$/ || $self->error($self->{'text_hash'}->{'nut_eups'});
$_[0]->{'ups'} = $self->{'in_hash'}->{'ups'};
$_[0]->{'name'} = $self->{'in_hash'}->{'name'};
$_[0]->{'mode'} = $self->{'in_hash'}->{'mode'};
$_[0]->{'max'} = $self->{'in_hash'}->{'max'};
$_[0]->{'min'} = $self->{'in_hash'}->{'min'};
if ($self->{'in_hash'}->{'mode'} == 1) {
	$self->{'in_hash'}->{'min'} =~ /^[0-9\.\+\-]+$/ || $self->error($self->{'text_hash'}->{'nut_emin'});
	}
elsif ($self->{'in_hash'}->{'mode'} == 2) {
	$self->{'in_hash'}->{'max'} =~ /^[0-9\.\+\-]+$/ || $self->error($self->{'text_hash'}->{'nut_emax'});
	}
}

# get_ups_values(ups)
# Returns a list of NUT attribute names and values for some UPS
sub get_ups_values
{
	my $self = shift;

if (!defined(@{$self->{'get_ups_cache_array'}})) {
	local @rv;
	open(SENS, "upsc ".quotemeta($_[0])." |");
	while(<SENS>) {
		if (/^(\S+):\s+(.*)/) {
			push(@rv, { 'name' => $1,
				    'value' => $2 });
			}
		}
	close(SENS);
	@{$self->{'get_ups_cache_array'}} = @rv;
	}
return @{$self->{'get_ups_cache_array'}};
}


1;

