#!/usr/bin/perl
package status::Procmonitor;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'status::Procmonitor');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# proc-monitor.pl
# Check if some process is running

1;

1;
		return $self;
}

sub get_proc_status
{
	my $self = shift;

local (@found, $count);
return { 'up' => -1 } if (!$self->foreign_check("proc"));
$self->foreign_require("proc", "proc-lib.pl");
foreach $p ($self->foreign_call("proc", "list_processes")) {
	if ($p->{'args'} =~ /$_[0]->{'cmd'}/i) {
		push(@found, $p->{'pid'});
		$count++;
		}
	}
local $thresh = $_[0]->{'thresh'} || 1;
if ($_[0]->{'not'}) {
	if ($count >= $thresh) {
		return { 'up' => 0 };
		}
	else {
		return { 'up' => 1 };
		}
	}
else {
	if ($count >= $thresh) {
		return { 'up' => 1, 'desc' => $self->text('proc_pid',
						    join(" ", @found)) };
		}
	else {
		return { 'up' => 0 };
		}
	}
}

sub show_proc_dialog
{
	my $self = shift;

print $self->ui_table_row($self->{'text_hash'}->{'proc_cmd'},
	$self->ui_textbox("cmd", $_[0]->{'cmd'}, 30));

print $self->ui_table_row($self->{'text_hash'}->{'proc_not'},
	$self->ui_radio("not", int($_[0]->{'not'}),
		  [ [ 0, $self->{'text_hash'}->{'proc_not0'} ],
		    [ 1, $self->{'text_hash'}->{'proc_not1'} ] ]));

print $self->ui_table_row($self->{'text_hash'}->{'proc_thresh'},
	$self->ui_textbox("thresh", $_[0]->{'thresh'} || 1, 5));
}

sub parse_proc_dialog
{
	my $self = shift;

$self->depends_check($_[0], "proc");
$self->{'in_hash'}->{'cmd'} || $self->error($self->{'text_hash'}->{'proc_ecmd'});
$_[0]->{'cmd'} = $self->{'in_hash'}->{'cmd'};
$_[0]->{'not'} = $self->{'in_hash'}->{'not'};
$self->{'in_hash'}->{'thresh'} =~ /^\d+$/ || $self->error($self->{'text_hash'}->{'proc_ethresh'});
$_[0]->{'thresh'} = $self->{'in_hash'}->{'thresh'};
}


1;

