#!/usr/bin/perl
package status::Proftpdmonitor;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'status::Proftpdmonitor');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# proftpd-monitor.pl
# Monitor the ProFTPD server on this host

1;

1;
		return $self;
}

# Check the PID file to see if proftpd is running
sub get_proftpd_status
{
	my $self = shift;

return { 'up' => -1 } if (!$self->foreign_check($_[1]));
local %pconfig = $self->foreign_config($_[1]);
-r $pconfig{'proftpd_path'} || return { 'up' => -1 };
$self->foreign_require($_[1], "proftpd-lib.pl");
if ($self->foreign_call($_[1], "get_proftpd_pid")) {
	return { 'up' => 1 };
	}
else {
	return { 'up' => 0 };
	}
}

sub parse_proftpd_dialog
{
	my $self = shift;

$self->error($self->{'text_hash'}->{'proftpd_etype'}) if ($self->run_from_inetd());
}

sub run_from_inetd
{
	my $self = shift;

local $m = $_[0]->{'clone'} || "proftpd";
$self->foreign_require($m, "proftpd-lib.pl");
local $conf = $self->foreign_call($m, "get_config");
local $st = $self->foreign_call($m, "find_directive", "ServerType", $conf);
return lc($st) eq 'inetd';
}


1;

