#!/usr/bin/perl
package status::Raidmonitor;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'status::Raidmonitor');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# raid-monitor.pl
# Check if some RAID device is reporting errors

1;
		return $self;
}

sub get_raid_status
{
	my $self = shift;

return { 'up' => -1 } if (!$self->foreign_check("raid"));
$self->foreign_require("raid", "raid-lib.pl");
local $conf = $main::raid_object->get_raidtab();
local ($raid) = grep { $_->{'value'} eq $_[0]->{'device'} } @$conf;
if ($raid) {
	if (ref($raid->{'errors'})) {
		local ($bad) = grep { $_ eq "_" } @{$raid->{'errors'}};
		if ($bad) {
			return { 'up' => 0,
				 'desc' => $self->{'text_hash'}->{'raid_bad'} };
			}
		else {
			return { 'up' => 1 };
			}
		}
	elsif ($raid->{'resync'}) {
		return { 'up' => 0,
			 'desc' => $self->{'text_hash'}->{'raid_resync'} };
		}
	else {
		return { 'up' => 1 };
		}
	}
else {
	return { 'up' => -1,
		 'desc' => $self->text('raid_notfound', $_[0]->{'device'}) };
	}
}

sub show_raid_dialog
{
	my $self = shift;

$self->foreign_require("raid", "raid-lib.pl");
local $conf = $main::raid_object->get_raidtab();
local @opts;
foreach my $c (@$conf) {
	local $lvl = $main::raid_object->find_value('raid-level', $c->{'members'});
	push(@opts, [ $c->{'value'},
		      $c->{'value'}." - ".
		      ($lvl eq 'linear' ? $main::raid_object->{'text_hash'}->{'linear'}
					: $main::raid_object->{'text_hash'}->{"raid$lvl"}) ]);
	}
local ($got) = grep { $_->[0] eq $_[0]->{'device'} } @opts;
if (!@opts) {
	print $self->ui_table_row($self->{'text_hash'}->{'raid_device'},
			    $self->ui_textbox("other", $_[0]->{'device'}, 10));
	}
else {
	push(@opts, [ "", $self->{'text_hash'}->{'raid_other'} ]);
	print $self->ui_table_row($self->{'text_hash'}->{'raid_device'},
		$self->ui_select("device", !$_[0]->{'device'} ? $opts[0]->[0] :
				     !$got ? "" : $_[0]->{'device'}, \@opts).
		" ".$self->ui_textbox("other", $got ? "" : $_[0]->{'device'}, 10));
	}
}

sub parse_raid_dialog
{
	my $self = shift;

$self->depends_check($_[0], "raid");
$_[0]->{'device'} = $self->{'in_hash'}->{'device'} || $self->{'in_hash'}->{'other'};
$_[0]->{'device'} =~ /^\S+$/ || $self->error($self->{'text_hash'}->{'raid_edevice'});
}


1;

