#!/usr/bin/perl
package status::Rsshmonitor;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'status::Rsshmonitor');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# rssh-monitor.pl
# Test a host by attempting to SSH into it

1;
		return $self;
}

sub get_rssh_status
{
	my $self = shift;

# Run the SSH command
$self->foreign_require("proc", "proc-lib.pl");
local $ruser = $_[0]->{'ruser'} || "root";
local ($fh, $fpid) = $main::proc_object->pty_process_exec(
	"ssh ".quotemeta($ruser)."\@".
	       quotemeta($_[0]->{'host'})." echo ok");
local ($out, $wrong_password, $connect_failed, $got_password);
while(1) {
	local $rv = $self->wait_for($fh, "password:", "yes\\/no", "(^|\\n)\\s*Permission denied.*\n", "ssh: connect.*\n", ".*\n");
	$out .= $self->{'wait_for_input'};
	if ($rv == 0) {
		if ($_[0]->{'rpass'} eq '*') {
			# We got to the password phase, but aren't logging in
			$got_password = 1;
			last;
			}
		else {
			syswrite($fh, "$_[0]->{'rpass'}\n");
			}
		}
	elsif ($rv == 1) {
		syswrite($fh, "yes\n");
		}
	elsif ($rv == 2) {
		$wrong_password++;
		last;
		}
	elsif ($rv == 3) {
		$connect_failed++;
		}
	elsif ($rv < 0) {
		last;
		}
	}
close($fh);
kill('KILL', $fpid);
local $got = waitpid($fpid, 0);
if ($got_password) {
	return { 'up' => 1 };
	}
elsif ($wrong_password) {
	return { 'up' => 0,
		 'desc' => $self->{'text_hash'}->{'rssh_wrongpass'} };
	}
if ($connect_failed) {
	return { 'up' => 0,
		 'desc' => $self->{'text_hash'}->{'rssh_failed'} };
	}
if ($?) {
	return { 'up' => 0,
		 'desc' => $self->{'text_hash'}->{'rssh_error'} };
	}
return { 'up' => 1 };

}

sub show_rssh_dialog
{
	my $self = shift;

print $self->ui_table_row($self->{'text_hash'}->{'rssh_host'},
		    $self->ui_textbox("host", $_[0]->{'host'}, 50), 3);

print $self->ui_table_row($self->{'text_hash'}->{'rssh_ruser'},
		    $self->ui_textbox("ruser", $_[0]->{'ruser'}, 50), 3);

local $pmode = $_[0]->{'rpass'} eq '' ? 1 :
	       $_[0]->{'rpass'} eq '*' ? 2 : 0;
print $self->ui_table_row($self->{'text_hash'}->{'rssh_rpass'},
		    $self->ui_radio("rpass_def", $pmode,
		      [ [ 1, $self->{'text_hash'}->{'rssh_nopass'} ],
			[ 2, $self->{'text_hash'}->{'rssh_nologin'} ],
			[ 0, $self->ui_textbox("rpass",
				$self->{'rpmode'} == 0 ? $_[0]->{'rpass'} : "", 30) ] ]));
}

sub parse_rssh_dialog
{
	my $self = shift;

$self->has_command("ssh") || $self->error($self->{'text_hash'}->{'rssh_ecmd'});
$self->foreign_installed("proc") || $self->error($self->{'text_hash'}->{'rssh_eproc'});
$self->{'in_hash'}->{'host'} =~ /^[a-z0-9\.\-\_]+$/i || $self->error($self->{'text_hash'}->{'rssh_ehost'});
$_[0]->{'host'} = $self->{'in_hash'}->{'host'};
$self->{'in_hash'}->{'rpass_def'} == 2 || $self->{'in_hash'}->{'ruser'} =~ /\S/ || $self->error($self->{'text_hash'}->{'rssh_eruser'});
$_[0]->{'ruser'} = $self->{'in_hash'}->{'ruser'};
$_[0]->{'rpass'} = $self->{'in_hash'}->{'rpass_def'} == 1 ? undef :
		   $self->{'in_hash'}->{'rpass_def'} == 2 ? '*' :
					   $self->{'in_hash'}->{'rpass'};
}


1;

