#!/usr/bin/perl
package status::Sensorsmonitor;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'status::Sensorsmonitor');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# Check if some lm_sensors value is too high

1;
		return $self;
}

sub get_sensors_status
{
	my $self = shift;

return { 'up' => 1 } if (!$self->has_command("sensors"));
local @sens = $self->get_sensors_values();
local ($sens) = grep { $_->{'name'} eq $_[0]->{'name'} } @sens;
return { 'up' => 1 } if (!$sens);
if ($_[0]->{'mode'} == 0) {
	return $sens->{'alarm'} ? { 'up' => 0 } : { 'up' => 1 };
	}
elsif ($_[0]->{'mode'} == 1) {
	return $sens->{'value'} < $_[0]->{'min'} ? { 'up' => 0 }
						 : { 'up' => 1 };
	}
elsif ($_[0]->{'mode'} == 2) {
	return $sens->{'value'} > $_[0]->{'max'} ? { 'up' => 0 }
						 : { 'up' => 1 };
	}
}

sub show_sensors_dialog
{
	my $self = shift;

if (!$self->has_command("sensors")) {
	print $self->ui_table_row(undef, $self->{'text_hash'}->{'sensors_cmd'}, 4);
	}
elsif (@{$self->{'sens_array'}} = $self->get_sensors_values()) {
	print $self->ui_table_row($self->{'text_hash'}->{'sensors_name'},
	   $self->ui_select("name", $_[0]->{'name'},
		[ map { [ $_->{'name'}, $self->text('sensors_cur', $_->{'name'}, $_->{'value'}, $_->{'units'}) ] } @{$self->{'sens_array'}} ]), 3);

	print $self->ui_table_row($self->{'text_hash'}->{'sensors_value'},
	  $self->ui_radio("mode", $_[0]->{'mode'} || 0,
		[ [ 0, $self->{'text_hash'}->{'sensors_value0'} ],
		  [ 1, $self->text('sensors_value1',
			     $self->ui_textbox("min", $_[0]->{'min'}, 8)) ],
		  [ 2, $self->text('sensors_value2',
			     $self->ui_textbox("max", $_[0]->{'max'}, 8)) ] ]), 3);
	}
else {
	print $self->ui_table_row(undef, $self->{'text_hash'}->{'sensors_none'}, 4);
	}
}

sub parse_sensors_dialog
{
	my $self = shift;

$self->has_command("sensors") || $self->error($self->{'text_hash'}->{'sensors_cmd'});
local @sens = $self->get_sensors_values();
@sens || $self->error($self->{'text_hash'}->{'sensors_none'});
$_[0]->{'name'} = $self->{'in_hash'}->{'name'};
$_[0]->{'mode'} = $self->{'in_hash'}->{'mode'};
$_[0]->{'max'} = $self->{'in_hash'}->{'max'};
$_[0]->{'min'} = $self->{'in_hash'}->{'min'};
if ($self->{'in_hash'}->{'mode'} == 1) {
	$self->{'in_hash'}->{'min'} =~ /^[0-9\.\+\-]+$/ || $self->error($self->{'text_hash'}->{'sensors_emin'});
	}
elsif ($self->{'in_hash'}->{'mode'} == 2) {
	$self->{'in_hash'}->{'max'} =~ /^[0-9\.\+\-]+$/ || $self->error($self->{'text_hash'}->{'sensors_emax'});
	}
}

# get_sensors_values()
# Returns a list of lm_sensors names, values and maxes
sub get_sensors_values
{
	my $self = shift;

if (!defined(@{$self->{'get_sensors_cache_array'}})) {
	local @rv;
	open(SENS, "sensors |");
	while(<SENS>) {
		if (/^([^:]+):\s+([0-9\.\+\-]+)\s*(\S+)\s+\(min\s+=\s+([0-9\.\+\-]+)\s*(\S+),\s+max\s+=\s+([0-9\.\+\-]+)/) {
			# Value with min and max
			push(@rv, { 'name' => $1,
				    'value' => $2,
				    'units' => $3,
				    'min' => $4,
				    'max' => $6 });
			$rv[$#rv]->{'alarm'} = 1 if (/ALARM/);
			}
		elsif (/^([^:]+):\s+([0-9\.\+\-]+)\s*(\S+)\s+\(min\s+=\s+([0-9\.\+\-]+)\s*(\S+),\s+div\s+=\s+([0-9\.\+\-]+)/) {
			# Value with min only
			push(@rv, { 'name' => $1,
				    'value' => $2,
				    'units' => $3,
				    'min' => $4,
				    'div' => $6 });
			$rv[$#rv]->{'alarm'} = 1 if (/ALARM/);
			}
		elsif (/^([^:]+):\s+([0-9\.\+\-]+)\s*(\S+)\s+\((limit|high)\s+=\s+([0-9\.\+\-]+)\s*(\S+)/) {
			# Value with max only
			push(@rv, { 'name' => $1,
				    'value' => $2,
				    'units' => $3,
				    'max' => $5 });
			$rv[$#rv]->{'alarm'} = 1 if (/ALARM/);
			}
		elsif (/^([^:]+):\s+([0-9\.\+\-]+)\s*(\S+)\s+\(low\s+=\s+([0-9\.\+\-]+)\s*(\S+)\s*,\s+high\s+=\s+([0-9\.\+\-]+)/) {
			# Value with low and high
			push(@rv, { 'name' => $1,
				    'value' => $2,
				    'units' => $3,
				    'min' => $4,
				    'max' => $6 });
			$rv[$#rv]->{'alarm'} = 1 if (/ALARM/);
			}
		}
	close(SENS);
	@{$self->{'get_sensors_cache_array'}} = @rv;
	}
return @{$self->{'get_sensors_cache_array'}};
}


1;

