#!/usr/bin/perl
package status::Spacemonitor;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'status::Spacemonitor');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# space-monitor.pl
# Check the free space on some filesystem

1;
		return $self;
}

sub get_space_status
{
	my $self = shift;

return { 'up' => -1 } if (!$self->foreign_check("mount"));
$self->foreign_require("mount", "mount-lib.pl");
local $m;
foreach $f ($main::mount_object->list_mounted()) {
	$m = $f if ($f->[0] eq $_[0]->{'fs'});
	}
if ($m) {
	local @sp = $main::mount_object->disk_space($m->[2], $m->[0]);
	if ($sp[1] < $_[0]->{'min'}) {
		return { 'up' => 0 };
		}

	if ($_[0]->{'inode'} && $main::mount_object->UNIVERSAL::can("inode_space")) {
		# Do the inode check too
		local @isp = $main::mount_object->inode_space($m->[2], $m->[0]);
		if ($isp[1] < $_[0]->{'inode'}) {
			return { 'up' => 0,
				 'desc' => $self->text('space_ierr', $isp[1]) };
			}
		}

	return { 'up' => 1,
		 'desc' => $self->text('space_desc', $self->nice_size($sp[1]*1024)) };
	}
else {
	return { 'up' => -1,
		 'desc' => $self->{'text_hash'}->{'space_nofs'} };
	}
}

sub show_space_dialog
{
	my $self = shift;

$self->foreign_require("mount", "mount-lib.pl");
local @mounted = $main::mount_object->list_mounted();
local ($got) = grep { $_->[0] eq $_[0]->{'fs'} } @mounted;
print $self->ui_table_row($self->{'text_hash'}->{'space_fs'},
	$self->ui_select("fs", !$_[0]->{'fs'} ? $mounted[0]->[0] :
			 !$got ? "" : $_[0]->{'fs'},
		   [ (map { [ $_->[0] ] } @mounted),
		     [ "", $self->{'text_hash'}->{'space_other'} ] ])."\n".
	$self->ui_textbox("other", $got ? "" : $_[0]->{'fs'}, 30),
	3);

print $self->ui_table_row($self->{'text_hash'}->{'space_min2'},
	$self->ui_bytesbox("min", $_[0]->{'min'}*1024));

if ($main::mount_object->UNIVERSAL::can("inode_space")) {
	print $self->ui_table_row($self->{'text_hash'}->{'space_inode'},
		$self->ui_textbox("inode", $_[0]->{'inode'}, 10));
	}
}

sub parse_space_dialog
{
	my $self = shift;

$self->depends_check($_[0], "mount");
$self->{'in_hash'}->{'min'} =~ /^[0-9\.]+$/ || $self->error($self->{'text_hash'}->{'space_emin'});
$_[0]->{'min'} = $self->{'in_hash'}->{'min'}*$self->{'in_hash'}->{'min_units'}/1024;
if ($self->{'in_hash'}->{'fs'}) {
	$_[0]->{'fs'} = $self->{'in_hash'}->{'fs'};
	}
else {
	$self->{'in_hash'}->{'other'} =~ /^\// || $self->error($self->{'text_hash'}->{'space_eother'});
	$_[0]->{'fs'} = $self->{'in_hash'}->{'other'};
	}
if (defined($self->{'in_hash'}->{'inode'})) {
	$_[0]->{'inode'} = $self->{'in_hash'}->{'inode'} ? int($self->{'in_hash'}->{'inode'}) : undef;
	}
}


1;

