#!/usr/bin/perl
package status::Squidmonitor;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'status::Squidmonitor');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# squid-monitor.pl
# Monitor the squid server on this host

1;

1;
		return $self;
}

# Check the PID file to see if squid is running
sub get_squid_status
{
	my $self = shift;

return { 'up' => -1 } if (!$self->foreign_check($_[1]));
$self->foreign_require($_[1], "squid-lib.pl");
return { 'up' => -1 } if (!$self->foreign_check($_[1]));
local %sconfig = $self->foreign_config($_[1]);
return { 'up' => -1 } if (!-r $sconfig{'squid_conf'});
local $conf = $self->foreign_call($_[1], "get_config");
local $str = $self->foreign_call($_[1], "find_config", "pid_filename", $conf);
local $file;
if ($str) {
	$file = $str->{'values'}->[0];
	}
else {
	$file = $sconfig{'pid_file'};
	}
if (open(PID, $file) && <PID> =~ /(\d+)/ && kill(0, $1)) {
	close(PID);
	local @st = stat($file);
	return { 'up' => 1,
		 'desc' => $self->text('up_since', scalar(localtime($st[9]))) };
	}
else {
	return { 'up' => 0 };
	}
}

sub parse_squid_dialog
{
	my $self = shift;

$self->depends_check($_[0], "squid");
}


1;

