#!/usr/bin/perl
package status::Tcpmonitor;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'status::Tcpmonitor');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# tcp-monitor.pl
# Monitor a remote TCP server

1;

1;
		return $self;
}

sub get_tcp_status
{
	my $self = shift;

# Connect to the server
socket(SOCK, PF_INET, SOCK_STREAM, getprotobyname("tcp")) ||
	return { 'up' => -1 };
local $addr = $self->inet_aton($_[0]->{'host'});
return { 'up' => -1 } if (!$addr);
local $st = time();
local $rv;
eval {
	local $SIG{'ALRM'} = sub { die "alarm\n" };
	alarm($_[0]->{'alarm'} ? $_[0]->{'alarm'} : 10);
	$rv = connect(SOCK, $self->pack_sockaddr_in($_[0]->{'port'}, $addr));
	close(SOCK);
	alarm(0);
	};
return { 'up' => 0 } if ($@);
return { 'up' => $rv,
	 'time' => time() - $st };
}

sub show_tcp_dialog
{
	my $self = shift;

print $self->ui_table_row($self->{'text_hash'}->{'tcp_host'},
	$self->ui_textbox("host", $_[0]->{'host'}, 25));

print $self->ui_table_row($self->{'text_hash'}->{'tcp_port'},
	$self->ui_textbox("port", $_[0]->{'port'}, 5));

print $self->ui_table_row($self->{'text_hash'}->{'tcp_alarm'},
	$self->ui_opt_textbox("alarm", $_[0]->{'alarm'}, 5, $self->{'text_hash'}->{'default'}));
}

sub parse_tcp_dialog
{
	my $self = shift;

$self->check_ipaddress($self->{'in_hash'}->{'host'}) || gethostbyname($self->{'in_hash'}->{'host'}) ||
	$self->error($self->{'text_hash'}->{'tcp_ehost'});
$_[0]->{'host'} = $self->{'in_hash'}->{'host'};

$self->{'in_hash'}->{'port'} =~ /^\d+$/ || $self->error($self->{'text_hash'}->{'tcp_eport'});
$_[0]->{'port'} = $self->{'in_hash'}->{'port'};

if ($self->{'in_hash'}->{'alarm_def'}) {
	delete($_[0]->{'alarm'});
	}
else {
	$self->{'in_hash'}->{'alarm'} =~ /^\d+$/ || $self->error($self->{'text_hash'}->{'tcp_ealarm'});
	$_[0]->{'alarm'} = $self->{'in_hash'}->{'alarm'};
	}
}


1;

