#!/usr/bin/perl
package status::Trafficmonitor;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'status::Trafficmonitor');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# traffic-monitor.pl
# Check if network traffic is too high

1;
		return $self;
}

sub get_traffic_status
{
	my $self = shift;

local %traffic;
$self->read_file("$self->{'module_config_directory'}/traffic", \%traffic);
local $ifaces = $self->get_traffic_list();
local @i = @{$ifaces->{$_[0]->{'iface'}}};
if (@i) {
	local @l = split(/\s+/, $traffic{$_[0]->{'iface'}.'-'.$_[0]->{'dir'}});
	local $now = time();
	local $diff;
	if ($_[0]->{'dir'} == 0) {
		$diff = ($i[0]+$i[2]) - ($l[0]+$l[2]);
		}
	elsif ($_[0]->{'dir'} == 1) {
		$diff = $i[0] - $l[0];
		}
	else {
		$diff = $i[2] - $l[2];
		}
	if ($now <= $l[4]) {
		return { 'up' => 1 };
		}
	local $up = $diff / ($now - $l[4]) > $_[0]->{'bytes'} ? 0 : 1;
	@l = ( $i[0], $i[1], $i[2], $i[3], $now );
	$traffic{$_[0]->{'iface'}.'-'.$_[0]->{'dir'}} = join(" ", @l);
	$self->write_file("$self->{'module_config_directory'}/traffic", \%traffic);
	return { 'up' => $up };
	}
else {
	# Interface is gone!
	return { 'up' => -1 };
	}
}

sub show_traffic_dialog
{
	my $self = shift;

print $self->ui_table_row(undef, $self->{'text_hash'}->{'traffic_desc'}, 4);

local $ifaces = $self->get_traffic_list();
print $self->ui_table_row($self->{'text_hash'}->{'traffic_iface'},
	$self->ui_select("iface", $_[0]->{'iface'},
		   [ map { [ $_ ] } sort { $a cmp $b } keys %$ifaces ]));

print $self->ui_table_row($self->{'text_hash'}->{'traffic_bytes'},
	$self->ui_textbox("bytes", $_[0]->{'bytes'}, 6));

print $self->ui_table_row($self->{'text_hash'}->{'traffic_dir'},
	$self->ui_radio("dir", int($_[0]->{'dir'}),
		[ [ 0, $self->{'text_hash'}->{'traffic_dir0'} ],
		  [ 1, $self->{'text_hash'}->{'traffic_dir1'} ],
		  [ 2, $self->{'text_hash'}->{'traffic_dir2'} ] ]), 3);
}

sub parse_traffic_dialog
{
	my $self = shift;

local $ifaces = $self->get_traffic_list();
(keys %$ifaces) || $self->error($self->{'text_hash'}->{'traffic_eifaces'});
$self->{'in_hash'}->{'bytes'} =~ /^\d+$/ || $self->error($self->{'text_hash'}->{'traffic_ebytes'});
$_[0]->{'iface'} = $self->{'in_hash'}->{'iface'};
$_[0]->{'bytes'} = $self->{'in_hash'}->{'bytes'};
$_[0]->{'dir'} = $self->{'in_hash'}->{'dir'};
}

# get_traffic_list()
# Returns a map from interface names to arrays of bytes in, packets in,
# bytes out, packets out
sub get_traffic_list
{
	my $self = shift;

local %rv;
if ($self->{'gconfig_hash'}->{'os_type'} eq 'freebsd') {
	# Get interfaces from netstat command
	open(NETSTAT, "netstat -nib |");
	while(<NETSTAT>) {
		if (/^(\S+)\s+(\d+)\s+(\S+)\s+(\d+\.\d+\.\d+\.\d+)\s+(\d+)\s+(\S+)\s+(\d+)\s+(\d+)\s+(\S+)\s+(\d+)/ && !$rv{$1}) {
			$rv{$1} = [ $7, $5, $10, $8 ];
			}
		}
	close(NETSTAT);
	}
else {
	# Get interfaces from Linux proc file
	open(TR, "/proc/net/dev");
	while(<TR>) {
		if (/^\s*([a-z0-9]+):\s*(\d+)\s+(\d+)\s+(\d+)\s+(\d+)\s+(\d+)\s+(\d+)\s+(\d+)\s+(\d+)\s+(\d+)\s+(\d+)/) {
			$rv{$1} = [ $2, $3, $10, $11 ];
			}
		}
	close(TR);
	}
return \%rv;
}


1;

