#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_mon.cgi
# Display a form for editing or creating a monitor

&ModuleLoader::preload_module('status_class', "status::StatusLib");
$self = new status::StatusLib:: 'status_class',%$self;

$self->{'access_hash'}->{'edit'} || $self->error($self->{'text_hash'}->{'mon_ecannot'});
$self->ReadParse();
@{$self->{'handlers_array'}} = $self->list_handlers();
if ($self->{'in_hash'}->{'type'}) {
	# Create a new monitor
	$self->{'type'} = $self->{'in_hash'}->{'type'};
	$self->{'title'} = $self->{'text_hash'}->{'mon_create'};
	if ($self->{'in_hash'}->{'clone'}) {
		# Clone of existing
		$self->{'serv'} = $self->get_service($self->{'in_hash'}->{'clone'});
		}
	else {
		# Totally new
		$self->{'serv'} = { 'notify' => 'email pager snmp sms',
			  'fails' => 1,
			  'nosched' => 0,
			  'remote' => '*' };
		}
	}
else {
	# Editing an existing monitor
	$self->{'serv'} = $self->get_service($self->{'in_hash'}->{'id'});
	$self->{'type'} = $self->{'serv'}->{'type'};
	$self->{'title'} = $self->{'text_hash'}->{'mon_edit'};
	}
($self->{'han'}) = grep { $_->[0] eq $self->{'type'} } @{$self->{'handlers_array'}};
if ($self->{'in_hash'}->{'type'} && !$self->{'in_hash'}->{'clone'}) {
	$self->{'serv'}->{'desc'} = $self->{'han'}->[1];
	}
$self->ui_print_header($self->{'han'}->[1], $self->{'title'}, "");

print $self->ui_form_start("save_mon.cgi", "post");
print $self->ui_hidden("type", $self->{'in_hash'}->{'type'}),"\n";
print $self->ui_hidden("id", $self->{'in_hash'}->{'id'}),"\n";
@{$self->{'tds_array'}} = ( "width=30%" );
print $self->ui_table_start($self->{'text_hash'}->{'mon_header'}, "width=100%", 2, \@{$self->{'tds_array'}});

# Check for clone modules of the monitor type
if (-d "../$self->{'type'}") {
	local @st = stat("../$self->{'type'}");
	opendir(DIR, "..");
	foreach $m (readdir(DIR)) {
		local @lst = stat("../$m");
		if (-l "../$m" && $st[1] == $lst[1]) {
			# found a clone
			push(@{$self->{'clones_array'}}, $m);
			}
		}
	}

# Show input for description
print $self->ui_table_row($self->{'text_hash'}->{'mon_desc'},
		    $self->ui_textbox("desc", $self->{'serv'}->{'desc'}, 50),
		    undef, \@{$self->{'tds_array'}});

# Show current status
if (!$self->{'in_hash'}->{'type'}) {
	@{$self->{'stats_array'}} = $self->service_status($self->{'serv'}, 1);
	$self->{'stable'} = "<table cellpadding=1 cellspacing=1>\n";
	foreach $stat (@{$self->{'stats_array'}}) {
		$self->{'stable'} .= "<tr>\n";
		if (@{$self->{'stats_array'}} > 1 || $stat->{'remote'} ne "*") {
			$self->{'stable'} .=
			    "<td>".
			    ($stat->{'remote'} eq "*" ? $self->{'text_hash'}->{'mon_local'}
						      : $stat->{'remote'}).
			    "</td>\n";
			$self->{'stable'} .= "<td>:</td>\n";
			}
		$self->{'stable'} .= "<td>".
		      ($stat->{'desc'} ? $stat->{'desc'} :
		       $stat->{'up'} == 1 ? $self->{'text_hash'}->{'mon_up'} :
		       $stat->{'up'} == -1 ? $self->{'text_hash'}->{'mon_not'} :
		       $stat->{'up'} == -2 ? $self->{'text_hash'}->{'mon_webmin'} :
		       $stat->{'up'} == -3 ? $self->{'text_hash'}->{'mon_timeout'} :
		       $stat->{'up'} == -4 ? $self->{'text_hash'}->{'mon_skip'} :
			 "<font color=#ff0000>$self->{'text_hash'}->{'mon_down'}</font>").
			"</td>\n";
		$self->{'stable'} .= "</tr>\n";
		}
	$self->{'stable'} .= "</table>\n";
	print $self->ui_table_row($self->{'text_hash'}->{'mon_status'}, $self->{'stable'},
			    undef, \@{$self->{'tds_array'}});
	}

# Show emailing schedule
print $self->ui_table_row($self->{'text_hash'}->{'mon_nosched'},
		    $self->ui_select("nosched", int($self->{'serv'}->{'nosched'}),
			       [ [ 1, $self->{'text_hash'}->{'no'} ],
				 [ 0, $self->{'text_hash'}->{'mon_warndef'} ],
				 [ 3,  $self->{'text_hash'}->{'mon_warn1'} ],
				 [ 2,  $self->{'text_hash'}->{'mon_warn0'} ],
				 [ 4,  $self->{'text_hash'}->{'mon_warn2'} ],
				 [ 5,  $self->{'text_hash'}->{'mon_warn3'} ] ]),
		    undef, \@{$self->{'tds_array'}});

# Show number of failures
print $self->ui_table_row($self->{'text_hash'}->{'mon_fails'},
		    $self->ui_textbox("fails", $self->{'serv'}->{'fails'}, 5),
		    undef, \@{$self->{'tds_array'}});

# Show notification mode
$self->{'notify'} = "";
%{$self->{'notify_hash'}} = map { $_, 1 } split(/\s+/, $self->{'serv'}->{'notify'});
foreach $n ($self->list_notification_modes()) {
	$self->{'notify'} .= $self->ui_checkbox("notify", $n, $self->{'text_hash'}->{'mon_notify'.$n},
				$self->{'notify_hash'}->{$n})."\n";
	delete($self->{'notify_hash'}->{$n});
	}
foreach $n (keys %{$self->{'notify_hash'}}) {
	# Don't clear set but un-usable modes
	print $self->ui_hidden("notify", $n);
	}
print $self->ui_table_row($self->{'text_hash'}->{'mon_notify'}, $self->{'notify'},
		    undef, \@{$self->{'tds_array'}});

# Show extra address to email
print $self->ui_table_row($self->{'text_hash'}->{'mon_email'},
		    $self->ui_textbox("email", $self->{'serv'}->{'email'}, 60),
		    undef, \@{$self->{'tds_array'}});

# Which clone module to use
if (@{$self->{'clones_array'}}) {
	local %minfo = $self->get_module_info($self->{'type'});
	print $self->ui_table_row($self->{'text_hash'}->{'mon_clone'},
		   $self->ui_select("clone", $self->{'serv'}->{'clone'},
			      [ [ "", $minfo{'desc'} ],
				map { local %cminfo = $self->get_module_info($_);
				      [ $_, $cminfo{'desc'} ] } @{$self->{'clones_array'}} ]),
		   undef, \@{$self->{'tds_array'}});
	}

# Skip if some other monitor is down
@{$self->{'servs_array'}} = $self->list_services();
if (@{$self->{'servs_array'}}) {
	print $self->ui_table_row($self->{'text_hash'}->{'mon_depend'},
	  $self->ui_select("depend", $self->{'serv'}->{'depend'},
		 [ [ "", "&nbsp;" ],
		   map { [ $_->{'id'}, $_->{'desc'}.
				       " (".$self->nice_remotes($_).")" ] }
		     sort { $a->{'desc'} cmp $b->{'desc'} } @{$self->{'servs_array'}} ]),
	  undef, \@{$self->{'tds_array'}});
	}

print $self->ui_table_end();
print $self->ui_table_start($self->{'text_hash'}->{'mon_header2'}, "width=100%", 2, \@{$self->{'tds_array'}});

# Show commands to run on up/down
print $self->ui_table_row($self->{'text_hash'}->{'mon_ondown'},
		    $self->ui_textbox("ondown", $self->{'serv'}->{'ondown'}, 60),
		    undef, \@{$self->{'tds_array'}});

print $self->ui_table_row($self->{'text_hash'}->{'mon_onup'},
		    $self->ui_textbox("onup", $self->{'serv'}->{'onup'}, 60),
		    undef, \@{$self->{'tds_array'}});

print $self->ui_table_row(" ", "<font size=-1>$self->{'text_hash'}->{'mon_oninfo'}</font>",
		    undef, \@{$self->{'tds_array'}});
print $self->ui_table_end();

# Display inputs for this monitor type
if ($self->{'type'} =~ /^(\S+)::(\S+)$/) {
	# From another module
	($self->{'mod'}, $self->{'mtype'}) = ($1, $2);
	$self->foreign_require($self->{'mod'}, "status_monitor.pl");
	$self->{'html'} = $self->foreign_call($self->{'mod'}, "status_monitor_dialog", $self->{'mtype'}, $self->{'serv'});
	if ($self->{'html'}) {
		print "<p>\n";
		print $self->ui_table_start($self->{'text_hash'}->{'mon_header3'}, "width=100%", 4,
				      \@{$self->{'tds_array'}});
		print $self->{'html'};
		print $self->ui_table_end();
		}
	}
else {
	# From this module
	{
    my $pkg = $self->lib_to_pkg(".\/$self->{type}-monitor.pl", "status");
    &ModuleLoader::preload_module(ref($self), "$pkg");
    $pkg .= '::';
    eval "\$self = new $pkg ref(\$self),\%\$self;"; 
}
	$self->{'func'} = "show_$self->{'type'}_dialog";
	if ($self->UNIVERSAL::can($self->{'func'})) {
		print "<p>\n";
		print $self->ui_table_start($self->{'text_hash'}->{'mon_header3'}, "width=100%", 4,
				      \@{$self->{'tds_array'}});
		do { my $fn = $self->{'func'}; $self->$fn($self->{'serv'})};
		print $self->ui_table_end();
		}
	}

# Show create/delete buttons
if ($self->{'in_hash'}->{'type'}) {
	print $self->ui_form_end([ [ "create", $self->{'text_hash'}->{'create'} ] ]);
	}
else {
	print $self->ui_form_end([ [ "save", $self->{'text_hash'}->{'save'} ],
			     [ "newclone", $self->{'text_hash'}->{'mon_clone2'} ],
			     [ "delete", $self->{'text_hash'}->{'delete'} ] ]);
	}

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

