#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_sched.cgi
# Configure scheduled checking of services

&ModuleLoader::preload_module('status_class', "status::StatusLib");
$self = new status::StatusLib:: 'status_class',%$self;

$self->{'access_hash'}->{'sched'} || $self->error($self->{'text_hash'}->{'sched_ecannot'});
$self->ui_print_header(undef, $self->{'text_hash'}->{'sched_title'}, "");

print $self->ui_form_start("save_sched.cgi", "post");
print $self->ui_table_start($self->{'text_hash'}->{'sched_header'}, "width=100%", 4);

# Enabled?
print $self->ui_table_row($self->{'text_hash'}->{'sched_mode'},
	$self->ui_yesno_radio("mode", int($self->{'config_hash'}->{'sched_mode'})));

# One email per problem?
print $self->ui_table_row($self->{'text_hash'}->{'sched_single'},
	$self->ui_yesno_radio("single", int($self->{'config_hash'}->{'sched_single'})));

# Checking interval and offset
print $self->ui_table_row($self->{'text_hash'}->{'sched_int'},
	$self->ui_textbox("int", $self->{'config_hash'}->{'sched_int'} || 5, 2)."\n".
	$self->ui_select("period", $self->{'config_hash'}->{'sched_period'},
		   [ map { [ $_, $self->{'text_hash'}->{"sched_period_".$_} ] } (0..3) ])."\n".
	$self->{'text_hash'}->{'sched_offset'}." ".
	$self->ui_textbox("offset", $self->{'config_hash'}->{'sched_offset'}, 2),
	3);

# Hours of the day
@{$self->{'hours_array'}} = split(/\s+/, $self->{'config_hash'}->{'sched_hours'});
@{$self->{'hours_array'}} = ( 0 .. 23 ) if (!@{$self->{'hours_array'}});
for($j=0; $j<24; $j+=6) {
	$self->{'hsel'} .= $self->ui_select("hours", \@{$self->{'hours_array'}},
			    [ map { [ $_, sprintf("%2.2d:00", $_) ] }
				  ($j .. $j+5) ], 6, 1);
	}
print $self->ui_table_row($self->{'text_hash'}->{'sched_hours'}, $self->{'hsel'});

@{$self->{'days_array'}} = split(/\s+/, $self->{'config_hash'}->{'sched_days'});
@{$self->{'days_array'}} = ( 0 .. 6 ) if (!@{$self->{'days_array'}});
print $self->ui_table_row($self->{'text_hash'}->{'sched_days'},
	$self->ui_select("days", \@{$self->{'days_array'}},
	           [ map { [ $_, $self->{'text_hash'}->{'day_'.$_} ] } (0 .. 6) ], 7, 1));

# Send email when up / down / going down
print $self->ui_table_row($self->{'text_hash'}->{'sched_warn'},
	$self->ui_radio("warn", int($self->{'config_hash'}->{'sched_warn'}),
		  [ [ 1, $self->{'text_hash'}->{'sched_warn1'} ],
		    [ 0, $self->{'text_hash'}->{'sched_warn0'} ],
		    [ 2, $self->{'text_hash'}->{'sched_warn2'} ] ]), 3);

# Send email to
print $self->ui_table_row($self->{'text_hash'}->{'sched_email'},
	$self->ui_opt_textbox("email", $self->{'config_hash'}->{'sched_email'}, 30,
			$self->{'text_hash'}->{'sched_none'}, $self->{'text_hash'}->{'sched_email'}), 3);

# From: address
print $self->ui_table_row($self->{'text_hash'}->{'sched_from'},
	$self->ui_opt_textbox("from", $self->{'config_hash'}->{'sched_from'}, 30,
		        "$self->{'text_hash'}->{'default'} (webmin)"), 3);

# SMTP server
print $self->ui_table_row($self->{'text_hash'}->{'sched_smtp'},
	$self->ui_opt_textbox("smtp", $self->{'config_hash'}->{'sched_smtp'}, 30,
			$self->{'text_hash'}->{'sched_smtp_prog'},
			$self->{'text_hash'}->{'sched_smtp_server'}), 3);

if ($self->{'config_hash'}->{'pager_cmd'}) {
	# Pager number
	print $self->ui_table_row($self->{'text_hash'}->{'sched_pager'},
		$self->ui_opt_textbox("pager", $self->{'config_hash'}->{'sched_pager'}, 30,
				$self->{'text_hash'}->{'sched_pnone'}), 3);
	}

# SMS carrier and number
print $self->ui_table_row($self->{'text_hash'}->{'sched_sms'},
	$self->ui_radio("sms_def", $self->{'config_hash'}->{'sched_carrier'} ? 0 : 1,
		  [ [ 1, $self->{'text_hash'}->{'sched_smsno'} ],
		    [ 0, $self->{'text_hash'}->{'sched_smscarrier'} ] ])."\n".
	$self->ui_select("carrier", $self->{'config_hash'}->{'sched_carrier'},
	   [ map { [ $_->{'id'}, $_->{'desc'} ] } $self->list_sms_carriers() ])."\n".
	$self->{'text_hash'}->{'sched_smsnumber'}." ".
	$self->ui_textbox("sms", $self->{'config_hash'}->{'sched_sms'}, 15), 3);

print $self->ui_table_end();
print $self->ui_form_end([ [ "save", $self->{'text_hash'}->{'save'} ] ]);

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

