#!/usr/bin/perl

&MAIN();

 sub MAIN {
# index.cgi
# List all services currently being monitored

&ModuleLoader::preload_module('status_class', "status::StatusLib");
$self = new status::StatusLib:: 'status_class',%$self;

print "Refresh: $self->{'config_hash'}->{'refresh'}\r\n"
	if ($self->{'config_hash'}->{'refresh'});
$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", undef, 1, 1);

# If we are using SNMP for notification, make sure the Perl module is installed
if ($self->{'config_hash'}->{'snmp_server'}) {
	eval "use Net::SNMP";
	if ($@) {
		eval "use SNMP_Session";
		}
	if ($@) {
		$self->ui_print_endpage(
		    $self->ui_config_link('index_esnmp',
			[ "<tt>Net::SNMP</tt>",
			  "../cpan/download.cgi?source=3&cpan=Net::SNMP&mode=2&return=/$self->{'module_name'}/&returndesc=".$self->urlize($self->{'text_hash'}->{'index_return'}),
			  undef ]));
		}
	}

@{$self->{'serv_array'}} = $self->list_services();
$self->{'mid'} = int((@{$self->{'serv_array'}}-1) / 2);
$self->{'oldstatus'} = $self->read_file($self->{'oldstatus_file'}, \%{$self->{'oldstatus_hash'}});

if (@{$self->{'serv_array'}}) {
	&show_button();
	if ($self->{'config_hash'}->{'sort_mode'} == 1) {
		@{$self->{'serv_array'}} = sort { $a->{'desc'} cmp $b->{'desc'} } @{$self->{'serv_array'}};
		}
	elsif ($self->{'config_hash'}->{'sort_mode'} == 2) {
		@{$self->{'serv_array'}} = sort { $a->{'remote'} cmp $b->{'remote'} } @{$self->{'serv_array'}};
		}
	elsif ($self->{'config_hash'}->{'sort_mode'} == 3) {
		@{$self->{'serv_array'}} = sort { $self->{'oldstatus_hash'}->{$a->{'id'}} <=> $self->{'oldstatus_hash'}->{$b->{'id'}} } @{$self->{'serv_array'}};
		}
	if (!$self->{'config_hash'}->{'index_status'} && $self->{'oldstatus'}) {
		local @st = stat("$self->{'module_config_directory'}/oldstatus");
		local $t = localtime($st[9]);
		print $self->text('index_oldtime', $t),"<br>\n";
		}

	# Show table of defined monitors
	@{$self->{'links_array'}} = ( );
	if ($self->{'access_hash'}->{'edit'}) {
		print $self->ui_form_start("delete_mons.cgi", "post");
		push(@{$self->{'links_array'}}, $self->select_all_link("d", 1),
			     $self->select_invert_link("d", 1) );
		}
	print $self->ui_links_row(\@{$self->{'links_array'}});
	if ($self->{'config_hash'}->{'columns'} == 2) {
		print "<table width=100%><tr>\n";
		print "<td width=50% valign=top>\n";
		&service_table(@{$self->{'serv_array'}}[0 .. $self->{'mid'}]);
		print "</td> <td width=50% valign=top>\n";
		&service_table(@{$self->{'serv_array'}}[$self->{'mid'}+1 .. $#{$self->{'serv_array'}}]) if (@{$self->{'serv_array'}} > 1);
		print "</td></tr></table>\n";
		}
	else {
		&service_table(@{$self->{'serv_array'}});
		}
	print $self->ui_links_row(\@{$self->{'links_array'}});
	if ($self->{'access_hash'}->{'edit'}) {
		print $self->ui_form_end([ [ "delete", $self->{'text_hash'}->{'index_delete'} ] ]);
		}
	}
else {
	print "<b>$self->{'text_hash'}->{'index_none'}</b><p>\n";
	}
&show_button();

print "<hr>\n";
print $self->ui_buttons_start();
if ($self->{'access_hash'}->{'sched'}) {
	print $self->ui_buttons_row("edit_sched.cgi",
			      $self->{'text_hash'}->{'index_sched'},
			      $self->{'text_hash'}->{'index_scheddesc'});
	}
if (!$self->{'config_hash'}->{'index_status'}) {
	print $self->ui_buttons_row("refresh.cgi",
			      $self->{'text_hash'}->{'index_refresh'},
			      $self->{'text_hash'}->{'index_refreshdesc'});
	}
print "</tr></table>\n";

$self->remote_finished();
$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});

1;
		
}

sub service_table
{
	shift if ($self == $_[0]);

# Table header
local @tds = $self->{'access_hash'}->{'edit'} ? ( "width=5" ) : ( );
print $self->ui_columns_start([
	$self->{'access_hash'}->{'edit'} ? ( "" ) : ( ),
	$self->{'text_hash'}->{'index_desc'},
	$self->{'text_hash'}->{'index_host'},
	$self->{'config_hash'}->{'index_status'} ? ( $self->{'text_hash'}->{'index_up'} ) :
	 $self->{'oldstatus'} ? ( $self->{'text_hash'}->{'index_last'} ) : ( ),
	], 100, 0, \@tds);

# One row per monitor
foreach $s (@_) {
	local @cols;
	local $esc = $self->html_escape($s->{'desc'});
	$esc = "<i>$esc</i>" if ($s->{'nosched'} == 1);
	if ($self->{'access_hash'}->{'edit'}) {
		push(@cols, "<a href='edit_mon.cgi?id=$s->{'id'}'>$esc</a>");
		}
	else {
		push(@cols, $esc);
		}
	push(@cols, $self->nice_remotes($s));

	# Work out and show all the up icons
	local @ups;
	if ($self->{'config_hash'}->{'index_status'}) {
		# Showing the current status
		@{$self->{'stats_array'}} = $self->service_status($s, 1);
		@ups = map { $_->{'up'} } @{$self->{'stats_array'}};
		}
	elsif ($self->{'oldstatus'}) {
		# Getting status from last check
		$self->{'stat'} = $self->expand_oldstatus($self->{'oldstatus_hash'}->{$s->{'id'}});
		@ups = map { defined($self->{'stat'}->{$_}) ? ( $self->{'stat'}->{$_} ) : ( ) }
			   $self->expand_remotes($s);
		}
	if (!@ups) {
		push(@cols, "");
		}
	else {
		local @icons;
		foreach my $up (@ups) {
			push(@icons, "<img src=images/".
			      ($up == 1 ? "up.gif" :
			      $up == -1 ? "not.gif" :
			      $up == -2 ? "webmin.gif" :
			      $up == -3 ? "timed.gif" :
			      $up == -4 ? "skip.gif" :
					  "down.gif").">");
			}
		push(@cols, join("", @icons));
		}
	if ($self->{'access_hash'}->{'edit'}) {
		print $self->ui_checked_columns_row(\@cols, \@tds, "d", $s->{'id'});
		}
	else {
		print $self->ui_columns_row(\@cols, \@tds);
		}
	}
print $self->ui_columns_end();
}

sub show_button
{
	shift if ($self == $_[0]);

if ($self->{'access_hash'}->{'edit'}) {
	print "<form action=edit_mon.cgi>\n";
	print "<input type=submit value='$self->{'text_hash'}->{'index_add'}'> ",
	      "<select name=type>\n";
	foreach $h (sort { $a->[1] cmp $b->[1] } $self->list_handlers()) {
		printf "<option value=%s>%s\n",
			$h->[0], $h->[1] || $h->[0];
		}
	print "</select></form>\n";
	}
}


1;

