#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_mon.cgi
# Create, update or delete a monitor

&ModuleLoader::preload_module('status_class', "status::StatusLib");
$self = new status::StatusLib:: 'status_class',%$self;

$self->{'access_hash'}->{'edit'} || $self->error($self->{'text_hash'}->{'mon_ecannot'});
$self->ReadParse();
if ($self->{'in_hash'}->{'type'}) {
	$self->{'serv'}->{'type'} = $self->{'in_hash'}->{'type'};
	$self->{'serv'}->{'id'} = time();
	}
else {
	$self->{'serv'} = $self->get_service($self->{'in_hash'}->{'id'});
	$self->{'serv'}->{'oldremote'} = $self->{'serv'}->{'remote'};
	}

if ($self->{'in_hash'}->{'delete'}) {
	# Delete the monitor
	$self->delete_service($self->{'serv'});
	$self->webmin_log("delete", undef, $self->{'serv'}->{'id'}, $self->{'serv'});
	}
elsif ($self->{'in_hash'}->{'newclone'}) {
	# Redirect to creation form, in clone mode
	$self->redirect("edit_mon.cgi?type=$self->{'serv'}->{'type'}&clone=$self->{'in_hash'}->{'id'}");
	exit(0);
	}
else {
	# Parse and validate inputs
	$self->error_setup($self->{'text_hash'}->{'mon_err'});
	$self->{'in_hash'}->{'desc'} || $self->error($self->{'text_hash'}->{'mon_edesc'});
	$self->{'serv'}->{'desc'} = $self->{'in_hash'}->{'desc'};

	# Make sure remote monitors exist on remote systems
	@{$self->{'remotes_array'}} = split(/\0/, $self->{'in_hash'}->{'remotes'});
	$self->{'newremote'} = join(" ", @{$self->{'remotes_array'}});
	if ($self->{'in_hash'}->{'type'} || $self->{'serv'}->{'remote'} ne $self->{'newremote'}) {
		# Only need to check for new monitors
		foreach $r (@{$self->{'remotes_array'}}) {
			next if ($r eq "*");
			eval { $self->{'ch'} = $self->remote_foreign_check($r, 'status') };
			$self->error($self->text('mon_elogin', $r))
			    if ($@ =~ /invalid.*login/i || $@ =~ /HTTP.*401/i);
			$self->error($self->text('mon_eremote', $r)) if ($@);
			$self->{'ch'} || $self->error($self->text('mon_estatus', $r));
			$self->remote_foreign_require($r, 'status',
						'status-lib.pl');
			if ($self->{'in_hash'}->{'type'} =~ /^(\S+)::(\S+)$/) {
				# Check if module is installed
				$self->{'ok'} = $self->remote_foreign_call(
				  $r, 'status', "foreign_check", $1);
				}
			else {
				$self->{'ok'} = $self->remote_eval($r, 'status',
				   "-r \"\$root_directory/status/$self->{'serv'}->{'type'}-monitor.pl\"");
				}
			$self->{'ok'} || $self->error($self->text('mon_ertype', $r));
			}
		}
	$self->{'serv'}->{'remote'} = $self->{'newremote'};
	$self->{'serv'}->{'groups'} = join(" ", split(/\0/, $self->{'in_hash'}->{'groups'}));
	
	$self->{'serv'}->{'nosched'} = $self->{'in_hash'}->{'nosched'};
	$self->{'serv'}->{'notify'} = join(" ", split(/\0/, $self->{'in_hash'}->{'notify'}));
	$self->{'serv'}->{'ondown'} = $self->{'in_hash'}->{'ondown'};
	$self->{'serv'}->{'onup'} = $self->{'in_hash'}->{'onup'};
	$self->{'serv'}->{'runon'} = $self->{'in_hash'}->{'runon'};
	$self->{'serv'}->{'clone'} = $self->{'in_hash'}->{'clone'};
	$self->{'in_hash'}->{'fails'} =~ /^\d+$/ || $self->error($self->{'text_hash'}->{'mon_efails'});
	$self->{'serv'}->{'fails'} = $self->{'in_hash'}->{'fails'};
	$self->{'serv'}->{'email'} = $self->{'in_hash'}->{'email'};
	$self->{'type'} = $self->{'serv'}->{'type'};
	if ($self->{'in_hash'}->{'depend'} && $self->{'in_hash'}->{'depend'} eq $self->{'serv'}->{'id'}) {
		$self->error($self->{'text_hash'}->{'mon_edepend'});
		}
	$self->{'serv'}->{'depend'} = $self->{'in_hash'}->{'depend'};

	# Parse inputs for this monitor type
	if ($self->{'type'} =~ /^(\S+)::(\S+)$/) {
		# From another module
		($self->{'mod'}, $self->{'mtype'}) = ($1, $2);
		$self->foreign_require($self->{'mod'}, "status_monitor.pl");
		$self->foreign_call($self->{'mod'}, "status_monitor_parse", $self->{'mtype'}, $self->{'serv'},\%{$self->{'in_hash'}});
		}
	else {
		# From this module
		{
    my $pkg = $self->lib_to_pkg(".\/$self->{type}-monitor.pl", "status");
    &ModuleLoader::preload_module(ref($self), "$pkg");
    $pkg .= '::';
    eval "\$self = new $pkg ref(\$self),\%\$self;"; 
}
		$self->{'func'} = "parse_$self->{'type'}_dialog";
		if ($self->UNIVERSAL::can($self->{'func'})) {
			do { my $fn = $self->{'func'}; $self->$fn($self->{'serv'})};
			}
		}

	# Save or create the monitor
	$self->save_service($self->{'serv'});
	$self->webmin_log($self->{'in_hash'}->{'type'} ? "create" : "modify", undef,
		    $self->{'serv'}->{'id'}, $self->{'serv'});
	}
$self->redirect("");

1;
		
}


1;

