#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_sched.cgi
# Save scheduled monitoring options

&ModuleLoader::preload_module('status_class', "status::StatusLib");
$self = new status::StatusLib:: 'status_class',%$self;

$self->{'access_hash'}->{'sched'} || $self->error($self->{'text_hash'}->{'sched_ecannot'});
$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'sched_err'});

# Parse and save inputs
$self->{'in_hash'}->{'email_def'} || $self->{'in_hash'}->{'email'} =~ /\S/ || $self->error($self->{'text_hash'}->{'sched_eemail'});
$self->{'config_hash'}->{'sched_email'} = $self->{'in_hash'}->{'email_def'} ? '' : $self->{'in_hash'}->{'email'};
if ($self->{'config_hash'}->{'pager_cmd'}) {
	$self->{'config_hash'}->{'sched_pager'} = $self->{'in_hash'}->{'pager_def'} ? '' : $self->{'in_hash'}->{'pager'};
	}
if ($self->{'in_hash'}->{'sms_def'}) {
	delete($self->{'config_hash'}->{'sched_carrier'});
	delete($self->{'config_hash'}->{'sched_sms'});
	}
else {
	$self->{'config_hash'}->{'sched_carrier'} = $self->{'in_hash'}->{'carrier'};
	$self->{'in_hash'}->{'sms'} =~ /^\d+$/ || $self->error($self->{'text_hash'}->{'sched_esmsnumber'});
	$self->{'config_hash'}->{'sched_sms'} = $self->{'in_hash'}->{'sms'};
	}
if ($self->{'in_hash'}->{'from_def'}) {
	delete($self->{'config_hash'}->{'sched_from'});
	}
else {
	$self->{'in_hash'}->{'from'} =~ /^\S+$/ || $self->error($self->{'text_hash'}->{'sched_efrom'});
	$self->{'config_hash'}->{'sched_from'} = $self->{'in_hash'}->{'from'};
	}
if ($self->{'in_hash'}->{'smtp_def'}) {
	if (!$self->{'in_hash'}->{'from_def'}) {
		$self->foreign_require("mailboxes", "mailboxes-lib.pl");
		$self->{'err'} = $main::mailboxes_object->test_mail_system();
		$self->{'err'} && $self->error($self->text('sched_eemailserver', $self->{'err'}));
		}
	delete($self->{'config_hash'}->{'sched_smtp'});
	}
else {
	if (!$self->{'in_hash'}->{'from_def'}) {
		gethostbyname($self->{'in_hash'}->{'smtp'}) || $self->check_ipaddress($self->{'in_hash'}->{'smtp'}) ||
			$self->error($self->{'text_hash'}->{'sched_esmtp'});
		}
	$self->{'config_hash'}->{'sched_smtp'} = $self->{'in_hash'}->{'smtp'};
	}
$self->{'config_hash'}->{'sched_mode'} = $self->{'in_hash'}->{'mode'};
$self->{'in_hash'}->{'int'} =~ /^\d+$/ || $self->error($self->{'text_hash'}->{'sched_eint'});
$self->{'config_hash'}->{'sched_int'} = $self->{'in_hash'}->{'int'};
$self->{'config_hash'}->{'sched_period'} = $self->{'in_hash'}->{'period'};
$self->{'in_hash'}->{'offset'} =~ /^\d+$/ || $self->error($self->{'text_hash'}->{'sched_eoffset'});
$self->{'config_hash'}->{'sched_offset'} = $self->{'in_hash'}->{'offset'};
$self->{'config_hash'}->{'sched_warn'} = $self->{'in_hash'}->{'warn'};
$self->{'config_hash'}->{'sched_single'} = $self->{'in_hash'}->{'single'};
@{$self->{'hours_array'}} = split(/\0/, $self->{'in_hash'}->{'hours'});
@{$self->{'hours_array'}} || $self->error($self->{'text_hash'}->{'sched_ehours'});
$self->{'config_hash'}->{'sched_hours'} = @{$self->{'hours_array'}} == 24 ? '' : join(" ", @{$self->{'hours_array'}});
@{$self->{'days_array'}} = split(/\0/, $self->{'in_hash'}->{'days'});
@{$self->{'days_array'}} || $self->error($self->{'text_hash'}->{'sched_edays'});
$self->{'config_hash'}->{'sched_days'} = @{$self->{'days_array'}} == 7 ? '' : join(" ", @{$self->{'days_array'}});
$self->lock_file("$self->{'module_config_directory'}/config");
$self->save_module_config();
$self->unlock_file("$self->{'module_config_directory'}/config");

# Setup or remove the cron job
$self->setup_cron_job();

$self->webmin_log("sched");
$self->redirect("");

1;
		
}


1;

