#!/usr/bin/perl
package stunnel::Backup_config;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'stunnel::Backup_config');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;

&ModuleLoader::preload_module(ref($self), "stunnel::StunnelLib");
$self = new stunnel::StunnelLib:: ref($self), %$self; 

1;

1;
		return $self;
}

# backup_config_files()
# Returns files and directories that can be backed up
sub backup_config_files
{
	my $self = shift;

local @tunnels = $self->list_stunnels();
local @rv = map { $_->{'file'} } @tunnels;
local $t;
local $ver = $self->get_stunnel_version();
foreach $t (@tunnels) {
	if ($ver >= 4) {
		if ($t->{'args'} =~ /^(\S+)\s+(\S+)/) {
			local $cfile = $2;
			local @conf = $self->get_stunnel_config($cfile);
			push(@rv, $cfile);
			local ($conf) = grep { !$_->{'name'} } @conf;
			if ($conf->{'values'}->{'cert'}) {
				push(@rv, $conf->{'values'}->{'cert'});
				}
			}
		}
	else {
		if ($t->{'args'} =~ /\s*-p\s+(\S+)/) {
			push(@rv, $1);
			}
		}
	}
return $self->unique(@rv);
}

# pre_backup(&files)
# Called before the files are actually read
sub pre_backup
{
	my $self = shift;

return undef;
}

# post_backup(&files)
# Called after the files are actually read
sub post_backup
{
	my $self = shift;

return undef;
}

# pre_restore(&files)
# Called before the files are restored from a backup
sub pre_restore
{
	my $self = shift;

return undef;
}

# post_restore(&files)
# Called after the files are restored from a backup
sub post_restore
{
	my $self = shift;

return $self->apply_configuration();
}


1;

