#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_stunnel.cgi
# Edit or create an SSL tunnel run from inetd

&ModuleLoader::preload_module('stunnel_class', "stunnel::StunnelLib");
$self = new stunnel::StunnelLib:: 'stunnel_class',%$self;

$self->ReadParse();

if ($self->{'in_hash'}->{'new'}) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'create_title'}, "");
	$self->{'st'} = { 'active' => 1 };
	}
else {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'edit_title'}, "");
	@{$self->{'stunnels_array'}} = $self->list_stunnels();
	$self->{'st'} = $self->{'stunnels_array'}->[$self->{'in_hash'}->{'idx'}];
	}

print "<form action=save_stunnel.cgi>\n";
print "<input type=hidden name=new value='$self->{'in_hash'}->{'new'}'>\n";
print "<input type=hidden name=idx value='$self->{'in_hash'}->{'idx'}'>\n";

print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'edit_header1'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'edit_name'}</b></td>\n";
printf "<td><input name=name size=15 value='%s'></td>\n",
	$self->{'st'}->{'name'};

print "<td><b>$self->{'text_hash'}->{'edit_port'}</b></td>\n";
printf "<td><input name=port size=6 value='%s'></td> </tr>\n",
	$self->{'st'}->{'port'};

print "<tr> <td><b>$self->{'text_hash'}->{'edit_active'}</b></td>\n";
printf "<td><input type=radio name=active value=1 %s> %s\n",
	$self->{'st'}->{'active'} ? "checked" : "", $self->{'text_hash'}->{'yes'};
printf "<input type=radio name=active value=0 %s> %s</td>\n",
	$self->{'st'}->{'active'} ? "" : "checked", $self->{'text_hash'}->{'no'};

if (!$self->{'in_hash'}->{'new'}) {
	print "<td><b>$self->{'text_hash'}->{'edit_type'}</b></td>\n";
	print "<td><tt>$self->{'st'}->{'type'}</tt></td>\n";
	}
elsif ($self->{'has_inetd'} && $self->{'has_xinetd'}) {
	print "<td><b>$self->{'text_hash'}->{'edit_type'}</b></td>\n";
	print "<td><select name=type>\n";
	print "<option selected>xinetd\n";
	print "<option>inetd\n";
	print "</select></td>\n";
	}
print "</tr>\n";

print "</table></td></tr></table><br>\n";
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'edit_header2'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

if ($self->{'in_hash'}->{'new'}) {
	$self->{'ptymode'} = 'l';
	}
elsif ($self->get_stunnel_version() >= 4) {
	# Parse new-style stunnel configuration file
	if ($self->{'st'}->{'args'} =~ /^(\S+)\s+(\S+)/) {
		$self->{'cfile'} = $2;
		@{$self->{'conf_array'}} = $self->get_stunnel_config($self->{'cfile'});
		($self->{'conf'}) = grep { !$_->{'name'} } @{$self->{'conf_array'}};
		if ($self->{'cmd'} = $self->{'conf'}->{'values'}->{'exec'}) {
			$self->{'args'} = $self->{'conf'}->{'values'}->{'execargs'};
			$self->{'ptymode'} = $self->{'conf'}->{'values'}->{'pty'} eq 'yes' ? "L"
								       : "l";
			}
		else {
			$self->{'rport'} = $self->{'conf'}->{'values'}->{'connect'};
			if ($self->{'rport'} =~ /^(\S+):(\d+)/) {
				$self->{'rhost'} = $1;
				$self->{'rport'} = $2;
				}
			}
		$self->{'pem'} = $self->{'conf'}->{'values'}->{'cert'};
		$self->{'cmode'} = $self->{'conf'}->{'values'}->{'client'} =~ /yes/i;
		$self->{'tcpw'} = $self->{'conf'}->{'values'}->{'service'};
		$self->{'iface'} = $self->{'conf'}->{'values'}->{'local'};
		}
	}
else {
	# Parse old-style stunnel parameters
	if ($self->{'st'}->{'args'} =~ s/\s*-([lL])\s+(\S+)\s+--\s+(.*)// ||
	    $self->{'st'}->{'args'} =~ s/\s*-([lL])\s+(\S+)//) {
		$self->{'ptymode'} = $1;
		$self->{'cmd'} = $2;
		$self->{'args'} = $3;
		}
	if ($self->{'st'}->{'args'} =~ s/\s*-r\s+((\S+):)?(\d+)//) {
		$self->{'rhost'} = $2;
		$self->{'rport'} = $3;
		}
	if ($self->{'st'}->{'args'} =~ s/\s*-p\s+(\S+)//) {
		$self->{'pem'} = $1;
		}
	if ($self->{'st'}->{'args'} =~ s/\s*-c//) {
		$self->{'cmode'} = 1;
		}
	if ($self->{'st'}->{'args'} =~ s/\s*-N\s+(\S+)//) {
		$self->{'tcpw'} = $1;
		}
	if ($self->{'st'}->{'args'} =~ s/\s*-I\s+(\S+)//) {
		$self->{'iface'} = $1;
		}
	}

printf "<tr> <td><input type=radio name=mode value=0 %s> %s</td>\n",
	$self->{'ptymode'} eq 'l' ? 'checked' : '', $self->{'text_hash'}->{'edit_mode0'};
printf "<td nowrap><b>%s</b> <input name=cmd0 size=15 value='%s'>\n",
	$self->{'text_hash'}->{'edit_cmd'}, $self->{'ptymode'} eq 'l' ? $self->{'cmd'} : '';
printf "<b>%s</b> <input name=args0 size=20 value='%s'></td> </tr>\n",
	$self->{'text_hash'}->{'edit_args'}, $self->{'ptymode'} eq 'l' ? $self->{'args'} : '';

printf "<tr> <td><input type=radio name=mode value=1 %s> %s</td>\n",
	$self->{'ptymode'} eq 'L' ? 'checked' : '', $self->{'text_hash'}->{'edit_mode1'};
printf "<td nowrap><b>%s</b> <input name=cmd1 size=15 value='%s'>\n",
	$self->{'text_hash'}->{'edit_cmd'}, $self->{'ptymode'} eq 'L' ? $self->{'cmd'} : '';
printf "<b>%s</b> <input name=args1 size=20 value='%s'></td> </tr>\n",
	$self->{'text_hash'}->{'edit_args'}, $self->{'ptymode'} eq 'L' ? $self->{'args'} : '';

printf "<tr> <td><input type=radio name=mode value=2 %s> %s</td>\n",
	$self->{'rport'} ? 'checked' : '', $self->{'text_hash'}->{'edit_mode2'};
printf "<td nowrap><b>%s</b> <input name=rhost size=20 value='%s'>\n",
	$self->{'text_hash'}->{'edit_rhost'}, !$self->{'rport'} ? '' : $self->{'rhost'} ? $self->{'rhost'} : 'localhost';
printf "<b>%s</b> <input name=rport size=6 value='%s'></td> </tr>\n",
	$self->{'text_hash'}->{'edit_rport'}, $self->{'rport'};

print "</table></td></tr></table><br>\n";
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'edit_header3'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'edit_pem'}</b></td> <td nowrap>\n";
$self->{'haspem'} = $self->{'config_hash'}->{'pem_path'} && -r $self->{'config_hash'}->{'pem_path'};
if ($self->{'in_hash'}->{'new'}) {
	printf "<input type=radio name=pmode value=0 %s> %s\n",
		"", $self->{'text_hash'}->{'edit_pem0'};
	printf "<input type=radio name=pmode value=1 %s> %s\n",
		$self->{'haspem'} ? "" : "checked", $self->{'text_hash'}->{'edit_pem1'};
	printf "<input type=radio name=pmode value=2 %s> %s\n",
		$self->{'haspem'} ? "checked" : "", $self->{'text_hash'}->{'edit_pem2'};
	printf "<input name=pem size=25 value='%s'> %s</td> </tr>\n",
		$self->{'haspem'} ? $self->{'config_hash'}->{'pem_path'} : "", $self->file_chooser_button("pem");
	}
else {
	local $pmode = $self->{'pem'} eq $self->{'webmin_pem'} ? 1 :
		       $self->{'pem'} ? 2 : 0;
	printf "<input type=radio name=pmode value=0 %s> %s\n",
		$pmode == 0 ? "checked" : "", $self->{'text_hash'}->{'edit_pem0'};
	printf "<input type=radio name=pmode value=1 %s> %s\n",
		$pmode == 1 ? "checked" : "", $self->{'text_hash'}->{'edit_pem1'};
	printf "<input type=radio name=pmode value=2 %s> %s\n",
		$pmode == 2 ? "checked" : "", $self->{'text_hash'}->{'edit_pem2'};
	printf "<input name=pem size=25 value='%s'> %s</td> </tr>\n",
		$pmode == 2 ? $self->{'pem'} : "", $self->file_chooser_button("pem");
	}

print "<tr> <td><b>$self->{'text_hash'}->{'edit_tcpw'}</b></td> <td>\n";
printf "<input type=radio name=tcpw_def value=1 %s> %s\n",
	$self->{'tcpw'} ? "" : "checked", $self->{'text_hash'}->{'edit_auto'};
printf "<input type=radio name=tcpw_def value=0 %s>\n",
	$self->{'tcpw'} ? "checked" : "";
printf "<input name=tcpw size=15 value='%s'></td> </tr>\n", $self->{'tcpw'};

print "<tr> <td><b>$self->{'text_hash'}->{'edit_cmode'}</b></td> <td>\n";
printf "<input type=radio name=cmode value=0 %s> %s\n",
	$self->{'cmode'} ? "" : "checked", $self->{'text_hash'}->{'edit_cmode0'};
printf "<input type=radio name=cmode value=1 %s> %s</td> </tr>\n",
	$self->{'cmode'} ? "checked" : "", $self->{'text_hash'}->{'edit_cmode1'};

print "<tr> <td><b>$self->{'text_hash'}->{'edit_iface'}</b></td> <td>\n";
printf "<input type=radio name=iface_def value=1 %s> %s\n",
	$self->{'iface'} ? "" : "checked", $self->{'text_hash'}->{'edit_auto'};
printf "<input type=radio name=iface_def value=0 %s>\n",
	$self->{'iface'} ? "checked" : "";
printf "<input name=iface size=25 value='%s'></td> </tr>\n", $self->{'iface'};

print "</table></td></tr></table>\n";
print "<input type=hidden name=args value='$self->{'st'}->{'args'}'>\n";
print "<table width=100%><tr>\n";
if ($self->{'in_hash'}->{'new'}) {
	print "<td><input type=submit value='$self->{'text_hash'}->{'create'}'></td>\n";
	}
else {
	print "<td><input type=submit value='$self->{'text_hash'}->{'save'}'></td>\n";
	print "<td align=right><input type=submit name=delete ",
	      "value='$self->{'text_hash'}->{'delete'}'></td>\n";
	}
print "</tr></table></form>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

