#!/usr/bin/perl

&MAIN();

 sub MAIN {
# index.cgi
# Display all existing SSL tunnels

&ModuleLoader::preload_module('stunnel_class', "stunnel::StunnelLib");
$self = new stunnel::StunnelLib:: 'stunnel_class',%$self;


# Check if stunnel is installed
if (!-x $self->{'config_hash'}->{'stunnel_path'}) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", "intro", 1, 1);
	print $self->text('index_estunnel', "<tt>$self->{'config_hash'}->{'stunnel_path'}</tt>",
		    "$self->{'gconfig_hash'}->{'webprefix'}/config.cgi?$self->{'module_name'}"),"<p>\n";
	$self->ui_print_footer("/", $self->{'text_hash'}->{"index"});
	exit;
	}

# Check if inetd or xinetd is installed
if (!$self->{'has_inetd'} && !$self->{'has_xinetd'}) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", "intro", 1, 1);
	print "$self->{'text_hash'}->{'index_einetd'}<p>\n";
	$self->ui_print_footer("/", $self->{'text_hash'}->{"index"});
	exit;
	}

# Get the version
$self->{'ver'} = $self->get_stunnel_version(\$self->{'out'});
$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", "intro", 1, 1, 0,
	$self->help_search_link("stunnel", "man", "doc"), undef, undef,
	$self->text('index_version', $self->{'ver'}));
#if ($self->{'ver'} >= 4) {
#	print "<p>",$self->text('index_eversion', $self->{'ver'}, 4.0),"<p>\n";
#	print "<hr>\n";
#	$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});
#	exit;
#	}

# List all tunnels currently setup in inetd
@{$self->{'tunnels_array'}} = $self->list_stunnels();
@{$self->{'links_array'}} = ( $self->select_all_link("d"),
	   $self->select_invert_link("d"),
	   "<a href='edit_stunnel.cgi?new=1'>$self->{'text_hash'}->{'index_add'}</a>" );
if (@{$self->{'tunnels_array'}}) {
	print $self->ui_form_start("delete_tunnels.cgi", "post");
	@{$self->{'tds_array'}} = ( "width=5" );
	print $self->ui_links_row(\@{$self->{'links_array'}});
	print $self->ui_columns_start([ "",
				  $self->{'text_hash'}->{'index_name'},
				  $self->{'text_hash'}->{'index_port'},
				  $self->{'text_hash'}->{'index_active'},
				  $self->{'text_hash'}->{'index_action'} ], 100, 0, \@{$self->{'tds_array'}}); 
	foreach $t (@{$self->{'tunnels_array'}}) {
		local @cols;
		if ($self->{'ver'} > 4) {
			# Parse new-style stunnel config file
			if ($t->{'args'} =~ /^(\S+)\s+(\S+)/) {
				$self->{'cfile'} = $2;
				@{$self->{'conf_array'}} = $self->get_stunnel_config($self->{'cfile'});
				($self->{'conf'}) = grep { !$_->{'name'} } @{$self->{'conf_array'}};
				}
			}
		if ($self->{'ver'} > 4 && !$self->{'cfile'}) {
			push(@cols, $self->html_escape($t->{'name'}));
			}
		else {
			push(@cols,
			    "<a href='edit_stunnel.cgi?idx=$t->{'index'}'>".
			    $self->html_escape($t->{'name'})."</a>");
			}
		push(@cols, $self->html_escape($t->{'port'}));
		push(@cols, $t->{'active'} ? $self->{'text_hash'}->{'yes'} :
			"<font color=#ff0000>$self->{'text_hash'}->{'no'}</font>");
		if ($self->{'ver'} > 4) {
			# Parse new-style stunnel config file
			if ($self->{'exec'} = $self->{'conf'}->{'values'}->{'exec'}) {
				$self->{'args'} = $self->{'conf'}->{'values'}->{'execargs'};
				push(@cols, $self->text('index_cmd',
				   $self->{'args'} ? "<tt>".$self->html_escape($self->{'args'})."</tt>"
				         : "<tt>".$self->html_escape($self->{'exec'})."</tt>"));
				}
			elsif ($self->{'conn'} = $self->{'conf'}->{'values'}->{'connect'}) {
				push(@cols, $self->text('index_remote',
				    "<tt>".$self->html_escape($self->{'conn'})."</tt>"));
				}
			elsif ($self->{'cfile'}) {
				push(@cols, $self->text('index_conf',
					"<tt>$self->{'cfile'}</tt>"));
				}
			else {
				push(@cols, $self->{'text_hash'}->{'index_noconf'});
				}
			}
		else {
			# Parse old-style stunnel args
			if ($t->{'args'} =~ /\s*-([lL])\s+(\S+)\s+--\s+(.*)/ ||
			    $t->{'args'} =~ /\s*-([lL])\s+(\S+)/) {
				push(@cols, $self->text('index_cmd',
				    $3 ? "<tt>".$self->html_escape($3)."</tt>"
				       : "<tt>".$self->html_escape($2)."</tt>"));
				}
			elsif ($t->{'args'} =~ /-r\s+(\S+):(\d+)/) {
				push(@cols, $self->text('index_remote',
				    "<tt>".$self->html_escape("$1:$2")."</tt>"));
				}
			elsif ($t->{'args'} =~ /-r\s+(\d+)/) {
				push(@cols, $self->text('index_rport',
				    "<tt>".$self->html_escape($1)."</tt>"));
				}
			else {
				push(@cols,
				    "<tt>".$self->html_escape($t->{'args'})."</tt>");
				}
			}
		print $self->ui_checked_columns_row(\@cols, \@{$self->{'tds_array'}}, "d",$t->{'index'});
		}
	print $self->ui_columns_end();
	print $self->ui_links_row(\@{$self->{'links_array'}});
	print $self->ui_form_end([ [ "delete", $self->{'text_hash'}->{'index_delete'} ] ]);
	}
else {
	print "<b>$self->{'text_hash'}->{'index_none'}</b><p>\n";
	print $self->ui_links_row([ $self->{'links_array'}->[2] ]);
	}

print "<hr>\n";
print "<table width=100%><tr>\n";
print "<form action=apply.cgi>\n";
print "<td><input type=submit value='$self->{'text_hash'}->{'index_apply'}'></td>\n";
if ($self->{'has_inetd'} && $self->{'has_xinetd'}) {
	print "<td>$self->{'text_hash'}->{'index_applymsg1'}</td>\n";
	}
elsif ($self->{'has_inetd'}) {
	print "<td>$self->{'text_hash'}->{'index_applymsg2'}</td>\n";
	}
else {
	print "<td>$self->{'text_hash'}->{'index_applymsg3'}</td>\n";
	}
print "</form></tr></table>\n";

$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});

1;
		
}


1;

