#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_stunnel.cgi
# Save, create or delete an SSL tunnel

&ModuleLoader::preload_module('stunnel_class', "stunnel::StunnelLib");
$self = new stunnel::StunnelLib:: 'stunnel_class',%$self;

$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'save_err'});

if ($self->{'in_hash'}->{'idx'} ne '') {
	@{$self->{'stunnels_array'}} = $self->list_stunnels();
	$self->{'st'} = $self->{'stunnels_array'}->[$self->{'in_hash'}->{'idx'}];
	%{$self->{'old_hash'}} = %{$self->{'st'}};
	}

if ($self->{'in_hash'}->{'delete'}) {
	# Just delete from inetd.conf and xinetd.conf
	$self->lock_file($self->{'st'}->{'file'});
	if ($self->get_stunnel_version(\$self->{'dummy'}) >= 4) {
		if ($self->{'st'}->{'args'} =~ /^(\S+)\s+(\S+)/) {
			$self->{'cfile'} = $2;
			if ($self->{'cfile'} =~ /^\Q$self->{'module_config_directory'}\E\//) {
				$self->lock_file($self->{'cfile'});
				unlink($self->{'cfile'});
				}
			}
		}
	$self->delete_stunnel($self->{'st'});
	}
else {
	# Validate inputs
	$self->{'in_hash'}->{'name'} =~ /^[A-z][A-z0-9\_\-]+$/ || $self->error($self->{'text_hash'}->{'save_ename'});
	$self->{'in_hash'}->{'port'} =~ /^\d+$/ || $self->error($self->{'text_hash'}->{'save_eport'});
	if ($self->{'in_hash'}->{'pmode'} == 2) {
		-r $self->{'in_hash'}->{'pem'} || $self->error($self->text('save_epem', $self->{'in_hash'}->{'pem'}));
		}
	if (!$self->{'in_hash'}->{'tcpw_def'}) {
		$self->{'in_hash'}->{'tcpw'} =~ /^\S+$/ || $self->error($self->{'text_hash'}->{'save_etcpw'});
		}
	if (!$self->{'in_hash'}->{'iface_def'}) {
		gethostbyname($self->{'in_hash'}->{'iface'}) || $self->check_ipaddress($self->{'in_hash'}->{'iface'}) ||
			$self->error($self->{'text_hash'}->{'save_eiface'});
		}
	if ($self->{'in_hash'}->{'mode'} == 0 || $self->{'in_hash'}->{'mode'} == 1) {
		# Running a command
		$self->{'cmd'} = $self->{'in_hash'}->{'mode'} == 0 ? $self->{'in_hash'}->{'cmd0'} : $self->{'in_hash'}->{'cmd1'};
		$self->{'args'} = $self->{'in_hash'}->{'mode'} == 0 ? $self->{'in_hash'}->{'args0'} : $self->{'in_hash'}->{'args1'};
		$self->has_command($self->{'cmd'}) || $self->error($self->{'text_hash'}->{'save_ecmd'});
		}
	else {
		# Connecting to remote host and port
		gethostbyname($self->{'in_hash'}->{'rhost'}) || $self->check_ipaddress($self->{'in_hash'}->{'rhost'}) ||
			$self->error($self->{'text_hash'}->{'save_erhost'});
		$self->{'in_hash'}->{'rport'} =~ /^\d+$/ || $self->error($self->{'text_hash'}->{'save_erport'});
		}

	# Create inetd/xinetd config
	if ($self->get_stunnel_version(\$self->{'dummy'}) >= 4) {
		# New-style args format
		if ($self->{'in_hash'}->{'new'}) {
			$self->{'cfile'} = "$self->{'module_config_directory'}/$self->{'in_hash'}->{'name'}.conf";
			unlink($self->{'cfile'});
			$self->{'conf'} = { };
			$self->{'st'} = { 'args' => "$self->{'stunnel_shortname'} $self->{'cfile'}",
				'command' => $self->{'config_hash'}->{'stunnel_path'},
				'type' => $self->{'in_hash'}->{'type'} };
			}
		else {
			if ($self->{'st'}->{'args'} =~ /^(\S+)\s+(\S+)/) {
				$self->{'cfile'} = $2;
				@{$self->{'conf_array'}} = $self->get_stunnel_config($self->{'cfile'});
				($self->{'conf'}) = grep { !$_->{'name'} } @{$self->{'conf_array'}};
				}
			}
		$self->{'st'}->{'name'} = $self->{'in_hash'}->{'name'};
		$self->{'st'}->{'port'} = $self->{'in_hash'}->{'port'};
		$self->{'st'}->{'active'} = $self->{'in_hash'}->{'active'};
		if ($self->{'in_hash'}->{'pmode'} == 1) {
			$self->{'conf'}->{'values'}->{'cert'} = $self->{'webmin_pem'};
			}
		elsif ($self->{'in_hash'}->{'pmode'} == 2) {
			$self->{'conf'}->{'values'}->{'cert'} = $self->{'in_hash'}->{'pem'};
			}
		else {
			delete($self->{'conf'}->{'values'}->{'cert'});
			}
		$self->{'conf'}->{'values'}->{'client'} = $self->{'in_hash'}->{'cmode'} ? 'yes' : 'no';
		if (!$self->{'in_hash'}->{'tcpw_def'}) {
			$self->{'conf'}->{'values'}->{'service'} = $self->{'in_hash'}->{'tcpw'};
			}
		else {
			delete($self->{'conf'}->{'values'}->{'service'});
			}
		if (!$self->{'in_hash'}->{'iface_def'}) {
			$self->{'conf'}->{'values'}->{'local'} = $self->{'in_hash'}->{'iface'};
			}
		else {
			delete($self->{'conf'}->{'values'}->{'local'});
			}
		if ($self->{'in_hash'}->{'mode'} == 0 || $self->{'in_hash'}->{'mode'} == 1) {
			# Running a command
			$self->{'conf'}->{'values'}->{'exec'} = $self->{'cmd'};
			$self->{'conf'}->{'values'}->{'execargs'} = $self->{'args'} if ($self->{'args'});
			$self->{'conf'}->{'values'}->{'pty'} = $self->{'in_hash'}->{'mode'} ? 'yes' : 'no';
			delete($self->{'conf'}->{'values'}->{'connect'});
			}
		else {
			# Connecting to remote host and port
			if ($self->{'in_hash'}->{'rhost'} eq 'localhost') {
				$self->{'conf'}->{'values'}->{'connect'} = $self->{'in_hash'}->{'rport'};
				}
			else {
				$self->{'conf'}->{'values'}->{'connect'} =
					"$self->{'in_hash'}->{'rhost'}:$self->{'in_hash'}->{'rport'}";
				}
			delete($self->{'conf'}->{'values'}->{'exec'});
			delete($self->{'conf'}->{'values'}->{'execargs'});
			delete($self->{'conf'}->{'values'}->{'pty'});
			}

		# Save this stunnel config file
		if ($self->{'in_hash'}->{'new'}) {
			$self->create_stunnel_service($self->{'conf'}, $self->{'cfile'});
			}
		else {
			$self->modify_stunnel_service($self->{'conf'}, $self->{'cfile'});
			}
		}
	else {
		# Old-style args format
		if ($self->{'in_hash'}->{'new'}) {
			$self->{'st'} = { 'args' => $self->{'stunnel_shortname'},
				'command' => $self->{'config_hash'}->{'stunnel_path'},
				'type' => $self->{'in_hash'}->{'type'} };
			}
		else {
			$self->{'st'}->{'args'} = $self->{'in_hash'}->{'args'};
			}
		$self->{'st'}->{'name'} = $self->{'in_hash'}->{'name'};
		$self->{'st'}->{'port'} = $self->{'in_hash'}->{'port'};
		$self->{'st'}->{'active'} = $self->{'in_hash'}->{'active'};
		if ($self->{'in_hash'}->{'pmode'} == 1) {
			$self->{'st'}->{'args'} .= " -p $self->{'webmin_pem'}";
			}
		elsif ($self->{'in_hash'}->{'pmode'} == 2) {
			$self->{'st'}->{'args'} .= " -p $self->{'in_hash'}->{'pem'}";
			}
		if ($self->{'in_hash'}->{'cmode'}) {
			$self->{'st'}->{'args'} .= " -c";
			}
		if (!$self->{'in_hash'}->{'tcpw_def'}) {
			$self->{'st'}->{'args'} .= " -N $self->{'in_hash'}->{'tcpw'}";
			}
		if (!$self->{'in_hash'}->{'iface_def'}) {
			$self->{'st'}->{'args'} .= " -I $self->{'in_hash'}->{'iface'}";
			}
		if ($self->{'in_hash'}->{'mode'} == 0 || $self->{'in_hash'}->{'mode'} == 1) {
			# Running a command
			if ($self->{'in_hash'}->{'mode'} == 0) {
				$self->{'st'}->{'args'} .= " -l $self->{'cmd'}";
				}
			else {
				$self->{'st'}->{'args'} .= " -L $self->{'cmd'}";
				}
			if ($self->{'args'}) {
				$self->{'st'}->{'args'} .= " -- $self->{'args'}";
				}
			}
		else {
			# Connecting to remote host and port
			if ($self->{'in_hash'}->{'rhost'} eq 'localhost') {
				$self->{'st'}->{'args'} .= " -r $self->{'in_hash'}->{'rport'}";
				}
			else {
				$self->{'st'}->{'args'} .=" -r $self->{'in_hash'}->{'rhost'}:$self->{'in_hash'}->{'rport'}";
				}
			}
		}

	if ($self->{'in_hash'}->{'new'}) {
		$self->lock_create_file();
		$self->create_stunnel($self->{'st'});
		}
	else {
		$self->lock_file($self->{'old_hash'}->{'file'});
		$self->modify_stunnel(\%{$self->{'old_hash'}}, $self->{'st'});
		}
	}
$self->unlock_all_files();
$self->webmin_log($self->{'in_hash'}->{'delete'} ? "delete" : $self->{'in_hash'}->{'new'} ? "create" : "modify",
	    "stunnel", $self->{'st'}->{'name'}, $self->{'st'});
$self->redirect("");

1;
		
}


1;

