#!/usr/bin/perl
package swup::SwupLib;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'swup::SwupLib');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# swup-lib.pl
# Common functions for SWUP

&ModuleLoader::preload_module(ref($self), "WebLib");
$self = new WebLib:: ref($self), %$self; 
$self->init_config();
&ModuleLoader::preload_module(ref($self), "UiLib");
$self = new UiLib:: ref($self), %$self; 

$self->foreign_require('proc', 'proc-lib.pl');

if ($self->{'config_hash'}->{'swup_path'} =~ /([^\/]+)$/) {
	$self->{'swup_shortname'} = $1;
	# get swup version
	$self->{'swup_version'} = $self->get_swup_version(\$self->{'swup_version_output'});
}

if (!$self->{'config_hash'}->{'rpm_path'}) {
	$self->{'config_hash'}->{'rpm_path'} = '/bin/rpm';
}

# --------- upgrade ---------

# --------- install ---------

# --list-upgrade --config-file $self->{'config_hash'}->{'swup_path'}
1;
1;
		return $self;
}

# checkup_swup_path()
sub check_swup_path {
	my $self = shift;

if (!-x $self->{'config_hash'}->{'swup_path'}) {
	$self->header($self->{'text_hash'}->{'index_title'}, "", "intro", 1, 1);
	print "<hr>\n";
	print $self->text('index_e_swup_path', "<tt>$self->{'config_hash'}->{'swup_path'}</tt>",
		    "$self->{'gconfig_hash'}->{'webprefix'}/config.cgi?$self->{'module_name'}"),"<p>\n";
	print "<hr>\n";
	$self->footer("/", $self->{'text_hash'}->{"index"});
	exit;
	}
}

# checkup_rpm_path()
sub check_rpm_path {
	my $self = shift;

if (!-x $self->{'config_hash'}->{'rpm_path'}) {
	$self->header($self->{'text_hash'}->{'index_title'}, "", "intro", 1, 1);
	print "<hr>\n";
	print $self->text('index_e_rpm_path', "<tt>$self->{'config_hash'}->{'rpm_path'}</tt>",
		    "$self->{'gconfig_hash'}->{'webprefix'}/config.cgi?$self->{'module_name'}"),"<p>\n";
	print "<hr>\n";
	$self->footer("/", $self->{'text_hash'}->{"index"});
	exit;
	}
}

# get_swup_version(&out)
sub get_swup_version {
	my $self = shift;

	local $out = `$self->{'config_hash'}->{'swup_path'} --version 2>&1`;
	${$_[0]} = $out;
	return $out =~ /software\s+updater\s+(\S+)/i ? $1 : undef;
}

# get_installed_rpms_list()
sub get_installed_rpms_list {
	my $self = shift;

	local @out = `$self->{'config_hash'}->{'rpm_path'} -qa --queryformat "%{NAME}\t%{VERSION}\t%{RELEASE}\t%{SUMMARY}\t%{INSTALLTIME}\n" 2>/dev/null`;
	local @rv = ();
	foreach my $line (@out) {
		next unless $line =~ /^([^\t]+)\t([^\t]+)\t([^\t]+)\t([^\t]+)\t([^\t]+)$/;
		my $info = {
			'name' => $1,
			'version' => $2,
			'release' => $3,
			'summary' => $4,
			'installtime' => scalar(localtime($5)),
		};
		push(@rv, $info);
	}
	return @rv;
}

# print_installed_rpms_list()
sub print_installed_rpms_list {
	my $self = shift;

	local @rpms = @_;
	print "<table border width=100%>\n";
	print "<tr $self->{'tb'}><td><b>$self->{'text_hash'}->{'index_name'}</b></td> ",
	      "<td><b>$self->{'text_hash'}->{'index_summary'}</b></td> ",
	      "<td><b>$self->{'text_hash'}->{'index_version'}</b></td> ",
	      "<td><b>$self->{'text_hash'}->{'index_installed_on'}</b></td> </tr>\n";
	foreach my $rpm (sort {$a->{name} cmp $b->{name}} @rpms) {
		print "<tr $self->{'cb'}>\n";
		my ($name, $summary, $ver, $date, $name_url) = (
			$self->html_escape($rpm->{name}),
			$self->html_escape($rpm->{summary}),
			$self->html_escape("$rpm->{'version'}-$rpm->{'release'}"),
			$self->html_escape($rpm->{installtime}),
			$self->urlize($rpm->{name})
		);
		print "<td><a href='package_info.cgi?pkg=$name_url'>$name</a></td><td>$summary</td><td>$ver</td><td>$date</td>\n";
		print "</tr>\n";
	}
	print "</table>\n";
}

# get_upgrade_pkgs_list()
sub get_upgrade_pkgs_list {
	my $self = shift;

	local @out = `$self->{'config_hash'}->{'swup_path'} --list-upgrade --config-file $self->{'config_hash'}->{'swup_conf'} 2>/dev/null`;
	local @rv = ();
	foreach my $line (@out) {
		next if $line !~ /^\s*(\S+)\s*$/ && $line !~ /^\s*(\S+)\s+\(.+vs\..+\)\s*$/;
		push(@rv, {'name' => $1});
	}
	return @rv;
}

# print_upgrade_pkgs_list()
sub print_upgrade_pkgs_list {
	my $self = shift;

	local @pkgs = @_;
	my ($cols, $col) = (4, 0);

	print "<form action='upgrade_pkgs.cgi' method=post>";
	print $self->select_all_link("pkg", 0, undef),"&nbsp;\n";
   print $self->select_invert_link("pkg", 0, undef),"&nbsp;\n";
	print "<table border width=100%>\n";
	print "<tr $self->{'tb'}><td colspan=$cols><b>$self->{'text_hash'}->{'upgrade_packages'}</b></td></tr>\n";
	foreach my $p (sort {$a->{'name'} cmp $b->{'name'}} @pkgs) {
		print "<tr $self->{'cb'}>\n" unless $col;
		my ($name, $pkg_url) = ($self->html_escape($p->{'name'}), $self->urlize($p->{'name'}));
		print "<td><input type=checkbox name=pkg value='pkg_$p->{'name'}'>&nbsp;<a href='list_upgrade.cgi?pkg=$pkg_url'>$name</a></td>";
		$col++;
		if ($col == $cols) {print "\n</tr>\n"; $col = 0;};
	}
	if ($col < $cols && $col != 0) {
		foreach ($col .. $cols-1) {
			print "<td>&nbsp;</td>";
		}
		print "</tr>";
	}
	print "<tr><td colspan=$cols></td></tr>";
	print "</table>\n";
	print $self->select_all_link("pkg", 0, undef),"&nbsp;\n";
   print $self->select_invert_link("pkg", 0, undef),"&nbsp;\n";
	print "<br><input type=submit name=do_upgrade value='$self->{'text_hash'}->{upgrade_upgrade}'></form>\n";
}

# get_install_pkgs_list()
sub get_install_pkgs_list {
	my $self = shift;

	local @out = `$self->{'config_hash'}->{'swup_path'} --list-prospect --config-file $self->{'config_hash'}->{'swup_conf'} 2>/dev/null`;
	local @rv = ();
	foreach my $line (@out) {
		my $info;
		if ($line =~ /^([^\s]+)\s+([^\s]+)\s+-\s+(.+)$/) {
			$info = {
				'name' => $1,
				'version' => $2,
				'summary' => $3,
			};
			push(@rv, $info);
		}
		elsif ($line =~ /^([^\s]+)\s+-\s+(.+)$/) {
			$info->{'summary'} = $2;
			next unless $1 =~ /^(\D+)-(\d+.*)$/;
			$info->{'name'} = $1;
			$info->{'version'} = $2;
			push(@rv, $info);
		}
	}
	return @rv;
}

# print_install_pkgs_list()
sub print_install_pkgs_list {
	my $self = shift;

	local @pkgs = @_;

	print "<form action='install_pkgs.cgi' method=post>";
	print $self->select_all_link("pkg", 0, undef),"&nbsp;\n";
	print $self->select_invert_link("pkg", 0, undef),"&nbsp;\n";	
	print "<table border width=100%>\n";
	print "<tr $self->{'tb'}><td><b>$self->{'text_hash'}->{'install_name'}</b></td> ",
	      "<td><b>$self->{'text_hash'}->{'install_version'}</b></td> ",
	      "<td><b>$self->{'text_hash'}->{'install_summary'}</b></td></tr>\n";
	foreach my $p (sort {$a->{name} cmp $b->{name}} @pkgs) {
		print "<tr $self->{'cb'}>\n";
		my ($name, $summary, $ver) = (
			$self->html_escape($p->{name}),
			$self->html_escape($p->{summary}),
			$self->html_escape($p->{version}),
		);
		print "<td><input type=checkbox name=pkg value='pkg_$p->{'name'}'>&nbsp;$name </td><td>$ver</td><td>$summary</td>\n";
		print "</tr>\n";
	}
	print "<tr><td colspan=3></td></tr>\n";
	print "</table>\n";
	print $self->select_all_link("pkg", 0, undef),"&nbsp;\n";
   print $self->select_invert_link("pkg", 0, undef),"&nbsp;\n";
	print "<input type=submit name=do_install value='$self->{'text_hash'}->{install_install}'></form>\n";
}

# get_remote_package_desc(package_name);
sub get_remote_package_desc {
	my $self = shift;

	local $pkg = $_[0];
	local @out = `$self->{'config_hash'}->{'swup_path'} --describe $pkg --config-file $self->{'config_hash'}->{'swup_conf'} 2>/dev/null`;
	return @out;
}

# ========== processing packages ============
# install_package(package_name);
sub install_package {
	my $self = shift;

	local $pkg = $_[0];
	local $dload_first = $self->{'config_hash'}->{'dload_first'} ? "--download-first" : "";
	print "<tr $self->{'tb'}><td colspan=2><b>$self->{'text_hash'}->{'info_installing'}</b></td></tr>\n";
	print "<tr $self->{'cb'}><td colspan=2><pre>";
	$main::proc_object->safe_process_exec("$self->{'config_hash'}->{'swup_path'} --install $pkg $dload_first --config-file $self->{'config_hash'}->{'swup_conf'}", 0, 0, STDOUT, undef, 1, 1);
	print "</pre></td></tr>\n";
}

# install_package_list(\@pkg_list);
sub install_package_list {
	my $self = shift;

	local $pkgs = $_[0];
	if (@{$pkgs}) {
		local $file = $self->transname();
		if (open(TMP, ">$file")) {
			foreach (@{$pkgs}) { print TMP "$_\n"; }
			close(TMP);
		}
		local $dload_first = $self->{'config_hash'}->{'dload_first'} ? "--download-first" : "";
		print "<tr $self->{'tb'}><td colspan=2><b>$self->{'text_hash'}->{'info_installing'}</b></td></tr>\n";
		print "<tr $self->{'cb'}><td colspan=2><pre>";
		$main::proc_object->safe_process_exec("$self->{'config_hash'}->{'swup_path'} --install $pkgs->[0] $dload_first --package-file '$file' --config-file $self->{'config_hash'}->{'swup_conf'}", 0, 0, STDOUT, undef, 1, 1);
		print "</pre>\n";
		$self->error($self->{'text_hash'}->{'install_elist'}) if $?;
		print "</td></tr>\n";

	}
}

# upgrade_package(package_name);
sub upgrade_package {
	my $self = shift;

	local $pkg = $_[0];
	local $dload_first = $self->{'config_hash'}->{'dload_first'} ? "--download-first" : "";
	print "<tr $self->{'tb'}><td colspan=2><b>$self->{'text_hash'}->{'info_upgrading'}</b></td></tr>\n";
	print "<tr $self->{'cb'}><td colspan=2><pre>";
	$main::proc_object->safe_process_exec("$self->{'config_hash'}->{'swup_path'} --upgrade $pkg $dload_first --config-file $self->{'config_hash'}->{'swup_conf'}", 0, 0, STDOUT, undef, 1, 1);
	print "</pre></td></tr>\n";
}

# upgrade_package_list(\@pkg_list);
sub upgrade_package_list {
	my $self = shift;

	local $pkgs = $_[0];
	if (@{$pkgs}) {
		local $file = $self->transname();
		if (open(TMP, ">$file")) {
			foreach (@{$pkgs}) { print TMP "$_\n"; }
			close(TMP);
		}
		local $conf_name = $self->{'config_hash'}->{'swup_conf'};
		local $dload_first = $self->{'config_hash'}->{'dload_first'} ? "--download-first" : "";
		print "<tr $self->{'tb'}><td colspan=2><b>$self->{'text_hash'}->{'info_upgrading'}</b></td></tr>\n";
		print "<tr $self->{'cb'}><td colspan=2><pre>";
		if ($self->{'config_hash'}->{'upgrade_list'}) {
			$main::proc_object->safe_process_exec("$self->{'config_hash'}->{'swup_path'} --upgrade $dload_first --package-file '$file' --config-file $conf_name", 0, 0, STDOUT, undef, 1, 1);
		} else {
			foreach my $p (@{$pkgs}) {
				$main::proc_object->safe_process_exec("$self->{'config_hash'}->{'swup_path'} --upgrade $p $dload_first --config-file $conf_name", 0, 0, STDOUT, undef, 1, 1);
			}
		}
		print "</pre>\n";
		$self->error($self->{'text_hash'}->{'upgrade_elist'}) if $?;
		print "</td></tr>\n";
	}
}

# upgrade_all_packages()
# upgrade all system packages
sub upgrade_all_packages
{
	my $self = shift;

 my $conf_name = $self->{'config_hash'}->{'swup_conf'};
 print "<tr $self->{'tb'}><td colspan=2><b>$self->{'text_hash'}->{'info_upgrading'}</b></td></tr>\n";
 print "<tr $self->{'cb'}><td colspan=2><pre>";
 $main::proc_object->safe_process_exec("$self->{'config_hash'}->{'swup_path'} --upgrade --config-file $conf_name", 0, 0, STDOUT, undef, 1, 1);
 print "</pre>\n";
 $self->error($self->{'text_hash'}->{'upgrade_elist'}) if $?;
 print "</td></tr>\n";
}

# uninstall_package(package_name);
sub uninstall_package {
	my $self = shift;

	local $pkg = $_[0];
	print "<tr $self->{'tb'}><td colspan=2><b>$self->{'text_hash'}->{'info_uninstalling'}</b></td></tr>\n";
	print "<tr $self->{'cb'}><td colspan=2><pre>";
	$main::proc_object->safe_process_exec("$self->{'config_hash'}->{'swup_path'} --remove $pkg --config-file $self->{'config_hash'}->{'swup_conf'}", 0, 0, STDOUT, undef, 1, 1);
	print "</pre></td></tr>\n";
}

# get_installed_rpms_list()
sub get_package_desc {
	my $self = shift;

	local $pkg = $_[0];
	local @out = `$self->{'config_hash'}->{'rpm_path'} -qi $pkg --queryformat "%{NAME}\t%{VERSION}\t%{RELEASE}\t%{INSTALLTIME}\n" 2>/dev/null`;
	local $info = undef;
	$self->{'count'} = scalar(@out) - 1;
	$self->{'line'} = $out[$self->{'count'}];
	if ($self->{'line'} =~ /^([^\t]+)\t([^\t]+)\t([^\t]+)\t([^\t]+)$/) {
		$info = {
			'name' => $1,
			'version' => "$2-$3",
			'installtime' => scalar(localtime($4)),
		};
		pop(@out);
	}
	return ($info, join('', @out));
}

# return list all available package(s) whose name matches  a  given  pattern.
# &search_package($pattern);
sub search_package {
	my $self = shift;

        local $pattern = $_[0];
        local @out = `$self->{'config_hash'}->{'swup_path'} --search-package $pattern --config-file $self->{'config_hash'}->{'swup_conf'} 2>/dev/null`;
        local @rv = ();
        foreach my $line (@out) {
                my $info;
                if ($line =~ /^(\S+)\s+\(([\d\.]+-\S+)\)$/) {
                        $info = {
                                'name' => $1,
                                'version' => $2,
                        };
                        push(@rv, $info);
                }
        }
        return @rv;
}

# parses a file and returns a reference to an array of hashes
# &parse_config_file(\&conf, $config_file_name, [$split_char]);
sub parse_config_file {
	my $self = shift;

	open(INFL, $_[1]) || $self->error($self->{'text_hash'}->{'error_open'});
	local $line = 0;
	local $sp = $_[2] ? $_[2] : "=";
	local $conf = $_[0];
	while (<INFL>) {
		chomp;
		s/#.*$//;
		s/^\s*//;
		if (/^([^$sp]+)$sp(.*)$/) {
		push (@{$conf}, 
				{'line' => $line,
				'name' => $self->trunc_space($1),
				'value' => $self->trunc_space($2)});
		}
		$line++;
	}
	close INFL;
}

# returns a value of a parameter
# &get_config_value(\@conf, $variable);
sub get_config_value {
	my $self = shift;

	foreach (@{$_[0]}) {
		return $_->{'value'} if $_->{'name'} eq $_[1]
	}
}

# sets a new value to the given parameter
# &set_config_value(\@conf, $variable, $value);
sub set_config_value {
	my $self = shift;

	local $conf = $_[0];
	foreach (@{$conf}) {
		if ($_->{'name'} eq $_[1]) {
			$_->{'value'} = $_[2];
			return;
		}
	}
	push(@{$conf}, {'name' => $_[1], 'value' => $_[2]});
}

# saves config file
# &save_config_file(\@conf, $config_file_name, [$splitter]);
sub save_config_file {
	my $self = shift;

	$self->lock_file($_[1]);
	local $conf = $_[0];
	local $sp = $_[2] ? $_[2] : "=";
	local $old_file = $self->read_file_lines($_[1]);
	local ($line, $str_new, $i) = (0, undef, 0);
	
	foreach (@{$old_file}) {
		my $l = $_;
		$l =~ s/#.*$//;
		$l =~ s/^\s*//;
		if ($l =~ /^([^$sp]+)$sp(.*)$/) {
			$str_new = $conf->[$i];
			if ($str_new->{'line'} = $line && $str_new->{'name'} eq $self->trunc_space($1) && $str_new->{'value'} ne $self->trunc_space($2)) {
				$old_file->[$line] = "$str_new->{'name'}$sp$str_new->{'value'}";
			}
			$i++;
		}
		$line++;
	}
	local ($rep_str, $m);
	$m=@{$conf};
	if ($line < $m) {
		for (my $k = $i; $k < $m; $k++) {
			$str_new=@{$conf}[$k];
			$str_new="$str_new->{'name'}$sp$str_new->{'value'}";
			foreach (@{$old_file}) {
				$rep_str = 1 if ($_ eq $str_new);
			}
			push (@{$old_file}, $str_new) if ($rep_str != 1);
		}
	}
	$self->flush_file_lines($_[1]);
	$self->unlock_file($_[1]);
}

#delete spaces from string $_[0]
sub trunc_space
{
	my $self = shift;

 local $rv = $_[0];
 $rv =~ s/^\s+//;
 $rv =~ s/\s+$//;
 return $rv;
}

# &duplicate_config_file($config_file_name);
sub duplicate_config_file {
	my $self = shift;

	local $tmp_file = $self->transname();
	local $lines = $self->read_file_lines($_[0]);
	$self->error("Failed to write to $tmp_file : $!") unless $self->open_tempfile(FILE, ">$tmp_file");
	$self->print_tempfile(FILE, join("\n", @{$lines}));
	$self->close_tempfile(FILE);
	return $tmp_file;
}


1;

