#!/usr/bin/perl
package syslog::Acl_security;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'syslog::Acl_security');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;

&ModuleLoader::preload_module(ref($self), "syslog::SyslogLib");
$self = new syslog::SyslogLib:: ref($self), %$self; 
&ModuleLoader::preload_module(ref($self), "syslog::UiLib");
$self = new syslog::UiLib:: ref($self), %$self; 

1;
		return $self;
}

# acl_security_form(&options)
# Output HTML for editing security options for the syslog module
sub acl_security_form
{
	my $self = shift;

# Can edit syslog settings
print $self->ui_table_row($self->{'text_hash'}->{'acl_noedit'},
		    $self->ui_yesno_radio("noedit", int($_[0]->{'noedit'})));

# Can enter arbitrary filename
print $self->ui_table_row($self->{'text_hash'}->{'acl_any'},
		    $self->ui_yesno_radio("any", int($_[0]->{'any'})));

# Can view syslog logs and logs from other modules
print $self->ui_table_row($self->{'text_hash'}->{'acl_syslog'},
		    $self->ui_yesno_radio("syslog", int($_[0]->{'syslog'})));
print $self->ui_table_row($self->{'text_hash'}->{'acl_others'},
		    $self->ui_yesno_radio("others", int($_[0]->{'others'})));

# Allowed directories
print $self->ui_table_row($self->{'text_hash'}->{'acl_logs'},
	    $self->ui_radio("logs_def", $_[0]->{'logs'} ? 0 : 1,
		      [ [ 1, $self->{'text_hash'}->{'acl_all'} ], [ 0, $self->{'text_hash'}->{'acl_sel'} ] ]).
	    "<br>\n".
	    $self->ui_textarea("logs", join("\n", split(/\t+/, $_[0]->{'logs'})),
			 5, 50), 3);

# Extra per-user log files
print $self->ui_table_row($self->{'text_hash'}->{'acl_extra'},
	    $self->ui_textarea("extras", join("\n", split(/\t+/, $_[0]->{'extras'})),
			 5, 50), 3);

}

# acl_security_save(&options)
# Parse the form for security options for the syslog module
sub acl_security_save
{
	my $self = shift;

$_[0]->{'noedit'} = $self->{'in_hash'}->{'noedit'};
$_[0]->{'any'} = $self->{'in_hash'}->{'any'};
$_[0]->{'syslog'} = $self->{'in_hash'}->{'syslog'};
$_[0]->{'others'} = $self->{'in_hash'}->{'others'};
$self->{'in_hash'}->{'logs'} =~ s/\r//g;
$_[0]->{'logs'} = $self->{'in_hash'}->{'logs_def'} ? undef :
			join("\t", split(/\n/, $self->{'in_hash'}->{'logs'}));
$_[0]->{'extras'} = join("\t", split(/\n/, $self->{'in_hash'}->{'extras'}));
}


1;

