#!/usr/bin/perl

&MAIN();

 sub MAIN {
# index.cgi
# Display syslog rules

&ModuleLoader::preload_module('syslog_class', "syslog::SyslogLib");
$self = new syslog::SyslogLib:: 'syslog_class',%$self;

$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", undef, 1, 1, 0,
	$self->help_search_link("syslog", "man", "doc"));

if ($self->{'config_hash'}->{'m4_conf'}) {
	# Does the config file need to be passed through m4?
	if ($self->needs_m4()) {
		# syslog.conf has m4 directives .. ask the user if he wants
		# to filter the file
		print "<p>",$self->text('index_m4msg',
				  "<tt>$self->{'config_hash'}->{'syslog_conf'}</tt>"),"\n";
		print "<center><form action=m4.cgi>\n";
		print "<input type=submit value='$self->{'text_hash'}->{'index_m4'}'>\n";
		print "</form></center>\n";
		$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});
		exit;
		}
	}

if (!-r $self->{'config_hash'}->{'syslog_conf'}) {
	# Not installed (maybe using syslog_ng)
	$self->ui_print_endpage($self->text('index_econf', "<tt>$self->{'config_hash'}->{'syslog_conf'}</tt>", "../config.cgi?$self->{'module_name'}"));
	}

# Display syslog rules
@{$self->{'links_array'}} = ( );
if ($self->{'access_hash'}->{'syslog'}) {
	$self->{'conf'} = $self->get_config();
	push(@{$self->{'links_array'}}, "<a href='edit_log.cgi?new=1'>$self->{'text_hash'}->{'index_add'}</a>")
		if (!$self->{'access_hash'}->{'noedit'});
	}
print $self->ui_links_row(\@{$self->{'links_array'}});
print $self->ui_columns_start([
	$self->{'text_hash'}->{'index_to'},
	$self->{'config_hash'}->{'tags'} ? ( $self->{'text_hash'}->{'index_tag'} ) : ( ),
	$self->{'text_hash'}->{'index_active'},
	$self->{'text_hash'}->{'index_rule'}, "" ], 100);
if ($self->{'access_hash'}->{'syslog'}) {
	foreach $c (@{$self->{'conf'}}) {
		next if ($c->{'tag'});
		next if (!$self->can_edit_log($c));
		local @cols;
		local $name;
		if ($c->{'file'}) {
			$name = $self->text('index_file',
				"<tt>".$self->html_escape($c->{'file'})."</tt>");
			}
		elsif ($c->{'pipe'} && $self->{'config_hash'}->{'pipe'} == 1) {
			$name = $self->text('index_pipe',
				"<tt>".$self->html_escape($c->{'pipe'})."</tt>");
			}
		elsif ($c->{'pipe'} && $self->{'config_hash'}->{'pipe'} == 2) {
			$name = $self->text('index_pipe2',
				"<tt>".$self->html_escape($c->{'pipe'})."</tt>");
			}
		elsif ($c->{'host'}) {
			$name = $self->text('index_host',
				"<tt>".$self->html_escape($c->{'host'})."</tt>");
			}
		elsif ($c->{'socket'}) {
			$name = $self->text('index_socket',
				"<tt>".$self->html_escape($c->{'socket'})."</tt>");
			}
		elsif ($c->{'all'}) {
			$name = $self->{'text_hash'}->{'index_all'};
			}
		else {
			$name = $self->text('index_users',
				"<tt>".join(" ", map { $self->html_escape($_) }
						 @{$c->{'users'}})."</tt>");
			}
		if ($self->{'access_hash'}->{'noedit'}) {
			push(@cols, $name);
			}
		else {
			push(@cols, "<a href='edit_log.cgi?".
				    "idx=$c->{'index'}'>$name</a>");
			}
		if ($self->{'config_hash'}->{'tags'}) {
			push(@cols, $c->{'section'}->{'tag'} eq '*' ?
				      $self->{'text_hash'}->{'all'} : $c->{'section'}->{'tag'});
			}
		push(@cols, $c->{'active'} ? $self->{'text_hash'}->{'yes'} :
				"<font color=#ff0000>$self->{'text_hash'}->{'no'}</font>");
		push(@cols, join("&nbsp;;&nbsp;",
			   map { $self->html_escape($_) } @{$c->{'sel'}}));
		if ($c->{'file'} && -f $c->{'file'}) {
			push(@cols, "<a href='save_log.cgi?idx=$c->{'index'}&".
			      "view=1'>$self->{'text_hash'}->{'index_view'}</a>\n");
			}
		else {
			push(@cols, "");
			}
		print $self->ui_columns_row(\@cols);
		}
	}

# Display logs from other modules
if ($self->{'config_hash'}->{'others'} && $self->{'access_hash'}->{'others'}) {
	@{$self->{'others_array'}} = $self->get_other_module_logs();
	}
if (@{$self->{'others_array'}}) {
	$self->{'cols'} = $self->{'config_hash'}->{'tags'} ? 5 : 4;
	foreach $o (@{$self->{'others_array'}}) {
		next if (!$self->can_edit_log($o));
		local @cols;
		if ($o->{'file'}) {
			push(@cols, $self->text('index_file',$o->{'file'}));
			}
		else {
			push(@cols, $self->text('index_cmd',$o->{'cmd'}));
			}
		if ($self->{'config_hash'}->{'tags'}) {
			push(@cols, "");
			}
		push(@cols, $o->{'active'} ? $self->{'text_hash'}->{'yes'} :
				    "<font color=#ff0000>$self->{'text_hash'}->{'no'}</font>");
		push(@cols, $o->{'desc'});
		push(@cols, "<a href='save_log.cgi?oidx=$o->{'mindex'}".
			   "&omod=$o->{'mod'}&view=1'>$self->{'text_hash'}->{'index_view'}</a>");
		print $self->ui_columns_row(\@cols);
		}
	}

# Display extra log files
foreach $e ($self->extra_log_files()) {
	next if (!$self->can_edit_log($e));
	local @cols;
	push(@cols, $self->text('index_file', $e->{'file'}));
	if ($self->{'config_hash'}->{'tags'}) {
		push(@cols, "");
		}
	push(@cols, $self->{'text_hash'}->{'yes'});
	push(@cols, $e->{'desc'});
	push(@cols, "<a href='save_log.cgi?extra=$e->{'file'}&view=1'>".
		    "$self->{'text_hash'}->{'index_view'}</a>");
	print $self->ui_columns_row(\@cols);
	}

print $self->ui_columns_end();
print $self->ui_links_row(\@{$self->{'links_array'}});
print "<p>\n";

if ($self->{'access_hash'}->{'any'}) {
	# Can view any log (under allowed dirs)
	print $self->ui_form_start("save_log.cgi");
	print $self->ui_hidden("view", 1),"\n";
	print "<b>$self->{'text_hash'}->{'index_viewfile'}</b>\n",
	      $self->ui_textbox("file", undef, 50),"\n",
	      $self->file_chooser_button("file", 0, 1),"\n",
	      $self->ui_submit($self->{'text_hash'}->{'index_viewok'}),"\n";
	print $self->ui_form_end();
	}

# Buttons to restart/start syslogd
if (!$self->{'access_hash'}->{'noedit'}) {
	print "<hr>\n";
	$self->{'pid'} = $self->get_syslog_pid();
	print $self->ui_buttons_start();
	if ($self->{'pid'}) {
		print $self->ui_buttons_row("restart.cgi",
				      $self->{'text_hash'}->{'index_restart'},
				      $self->{'text_hash'}->{'index_restartmsg'});
		}
	else {
		print $self->ui_buttons_row("start.cgi",
				      $self->{'text_hash'}->{'index_start'},
				      $self->text('index_startmsg',
					    "<tt>$self->{'config_hash'}->{'syslogd'}</tt>"));
		}
	print $self->ui_buttons_end();
	}

$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});

1;
		
}


1;

