#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_log.cgi
# Save, create, delete or view a log

&ModuleLoader::preload_module('syslog_class', "syslog::SyslogLib");
$self = new syslog::SyslogLib:: 'syslog_class',%$self;

$self->ReadParse();
$self->foreign_require("proc", "proc-lib.pl");
$self->{'conf'} = $self->get_config();

if ($self->{'in_hash'}->{'delete'}) {
	# Deleting a log 
	$self->lock_file($self->{'config_hash'}->{'syslog_conf'});
	$self->{'access_hash'}->{'noedit'} && $self->error($self->{'text_hash'}->{'edit_ecannot'});
	$self->{'access_hash'}->{'syslog'} || $self->error($self->{'text_hash'}->{'edit_ecannot'});
	$self->{'log'} = $self->{'conf'}->[$self->{'in_hash'}->{'idx'}];
	$self->can_edit_log($self->{'log'}) || $self->error($self->{'text_hash'}->{'save_ecannot1'});
	$self->delete_log($self->{'log'});
	$self->unlock_file($self->{'config_hash'}->{'syslog_conf'});
	$self->redirect("");
	}
elsif ($self->{'in_hash'}->{'view'}) {
	# Viewing a log file
	if ($self->{'in_hash'}->{'idx'} ne '') {
		# From syslog
		$self->{'log'} = $self->{'conf'}->[$self->{'in_hash'}->{'idx'}];
		$self->can_edit_log($self->{'log'}) && $self->{'access_hash'}->{'syslog'} ||
			$self->error($self->{'text_hash'}->{'save_ecannot2'});
		$self->{'file'} = $self->{'log'}->{'file'};
		}
	elsif ($self->{'in_hash'}->{'oidx'} ne '') {
		# From another module
		@{$self->{'others_array'}} = $self->get_other_module_logs($self->{'in_hash'}->{'omod'});
		($self->{'other'}) = grep { $_->{'mindex'} == $self->{'in_hash'}->{'oidx'} } @{$self->{'others_array'}};
		$self->can_edit_log($self->{'other'}) && $self->{'access_hash'}->{'others'} ||
			$self->error($self->{'text_hash'}->{'save_ecannot2'});
		if ($self->{'other'}->{'file'}) {
			$self->{'file'} = $self->{'other'}->{'file'};
			}
		else {
			$self->{'cmd'} = $self->{'other'}->{'cmd'};
			}
		}
	elsif ($self->{'in_hash'}->{'extra'}) {
		# Extra log file
		@{$self->{'extras_array'}} = $self->extra_log_files();
		($self->{'extra'}) = grep { $_->{'file'} eq $self->{'in_hash'}->{'extra'} } @{$self->{'extras_array'}};
		$self->{'extra'} || $self->error($self->{'text_hash'}->{'save_ecannot7'});
		$self->can_edit_log($self->{'extra'}) || $self->error($self->{'text_hash'}->{'save_ecannot2'});
		$self->{'file'} = $self->{'extra'}->{'file'};
		}
	elsif ($self->{'in_hash'}->{'file'}) {
		# Explicitly named file
		$self->{'access_hash'}->{'any'} || $self->error($self->{'text_hash'}->{'save_ecannot6'});
		$self->{'file'} = $self->{'in_hash'}->{'file'};
		$self->can_edit_log($self->{'file'}) || $self->error($self->{'text_hash'}->{'save_ecannot2'});
		}
	else {
		$self->error($self->{'text_hash'}->{'save_emissing'});
		}
	print "Refresh: $self->{'config_hash'}->{'refresh'}\r\n"
		if ($self->{'config_hash'}->{'refresh'});
	$self->ui_print_header("<tt>".($self->{'file'} || $self->{'cmd'})."</tt>",
			 $self->{'text_hash'}->{'view_title'}, "");

	$self->{'lines'} = $self->{'in_hash'}->{'lines'} ? int($self->{'in_hash'}->{'lines'}) : $self->{'config_hash'}->{'lines'};
	$self->{'filter'} = $self->{'in_hash'}->{'filter'} ? quotemeta($self->{'in_hash'}->{'filter'}) : "";

	&filter_form();

	$| = 1;
	print "<pre>";
	local $tailcmd = $self->{'config_hash'}->{'tail_cmd'} || "tail -n LINES";
	$tailcmd =~ s/LINES/$self->{'lines'}/g;
	if ($self->{'filter'} ne "") {
		# Are we supposed to filter anything? Then use grep.
		local @cats;
		if ($self->{'cmd'}) {
			# Getting output from a command
			push(@cats, $self->{'cmd'});
			}
		elsif ($self->{'config_hash'}->{'compressed'}) {
			# All compressed versions
			foreach $l ($self->all_log_files($self->{'file'})) {
				$self->{'c'} = $self->catter_command($l);
				push(@cats, $self->{'c'}) if ($self->{'c'});
				}
			}
		else {
			# Just the one log
			@cats = ( "cat ".quotemeta($self->{'file'}) );
			}
		$self->{'cat'} = "(".join(" ; ", @cats).")";
		$self->{'got'} = $self->foreign_call("proc", "safe_process_exec",
			"$self->{'cat'} | grep -i $self->{'filter'} | $tailcmd",
			0, 0, STDOUT, undef, 1);
	} else {
		# Not filtering .. so cat the most recent non-empty file
		if ($self->{'cmd'}) {
			# Getting output from a command
			$self->{'catter'} = $self->{'cmd'};
			}
		else {
			# Find the first non-empty file
			$self->{'catter'} = "cat ".quotemeta($self->{'file'});
			if (!-s $self->{'file'} && $self->{'config_hash'}->{'compressed'}) {
				foreach $l ($self->all_log_files($self->{'file'})) {
					next if (!-s $l);
					$self->{'c'} = $self->catter_command($l);
					if ($self->{'c'}) {
						$self->{'catter'} = $self->{'c'};
						last;
						}
					}
				}
			}
		$self->{'got'} = $self->foreign_call("proc", "safe_process_exec",
			$self->{'catter'}." | $tailcmd", 
			0, 0, STDOUT, undef, 1);
		}
	print "<i>$self->{'text_hash'}->{'view_empty'}</i>\n" if (!$self->{'got'});
	print "</pre>\n";
	&filter_form();
	$self->ui_print_footer(
		$self->{'access_hash'}->{'noedit'} || $self->{'other'} || $self->{'in_hash'}->{'file'} || $self->{'in_hash'}->{'extra'} ?
		() : ( "edit_log.cgi?idx=$self->{'in_hash'}->{'idx'}", $self->{'text_hash'}->{'edit_return'} ),
		"", $self->{'text_hash'}->{'index_return'});
	exit;
	}
else {
	# saving or updating a log
	$self->lock_file($self->{'config_hash'}->{'syslog_conf'});
	$self->{'access_hash'}->{'noedit'} && $self->error($self->{'text_hash'}->{'edit_ecannot'});
	$self->{'access_hash'}->{'syslog'} || $self->error($self->{'text_hash'}->{'edit_ecannot'});
	$self->error_setup($self->{'text_hash'}->{'save_err'});

	# Validate destination section
	if ($self->{'in_hash'}->{'mode'} == 0) {
		open(FILE, ">>$self->{'in_hash'}->{'file'}") ||
			$self->error($self->text('save_efile', $self->{'in_hash'}->{'file'}, $!));
		close(FILE);
		$self->system_logged("chmod go-wx ".quotemeta($self->{'in_hash'}->{'file'}));
		$self->{'log'}->{'file'} = $self->{'in_hash'}->{'file'};
		$self->{'log'}->{'sync'} = $self->{'in_hash'}->{'sync'};
		}
	elsif ($self->{'in_hash'}->{'mode'} == 1 && $self->{'config_hash'}->{'pipe'} == 1) {
		-w $self->{'in_hash'}->{'pipe'} || $self->error($self->text('save_epipe', $self->{'in_hash'}->{'pipe'}));
		$self->{'log'}->{'pipe'} = $self->{'in_hash'}->{'pipe'};
		}
	elsif ($self->{'in_hash'}->{'mode'} == 1 && $self->{'config_hash'}->{'pipe'} == 2) {
		$self->{'in_hash'}->{'pipe'} || $self->error($self->{'text_hash'}->{'save_epipe2'});
		$self->{'log'}->{'pipe'} = $self->{'in_hash'}->{'pipe'};
		}
	elsif ($self->{'in_hash'}->{'mode'} == 2) {
		gethostbyname($self->{'in_hash'}->{'host'}) ||
			$self->error($self->text('save_ehost', $self->{'in_hash'}->{'host'}));
		$self->{'log'}->{'host'} = $self->{'in_hash'}->{'host'};
		}
	elsif ($self->{'in_hash'}->{'mode'} == 3) {
		@{$self->{'users_array'}} = split(/\s+/, $self->{'in_hash'}->{'users'});
		@{$self->{'users_array'}} || $self->error($self->{'text_hash'}->{'save_enousers'});
		foreach $u (@{$self->{'users_array'}}) {
			defined(getpwnam($u)) ||
				$self->error($self->text('save_euser', $u));
			}
		$self->{'log'}->{'users'} = \@{$self->{'users_array'}};
		}
	elsif ($self->{'in_hash'}->{'mode'} == 5) {
		-S $self->{'in_hash'}->{'socket'} || $self->error($self->{'text_hash'}->{'save_esocket'});
		$self->{'log'}->{'socket'} = $self->{'in_hash'}->{'socket'};
		}
	else {
		$self->{'log'}->{'all'} = 1;
		}
	$self->{'log'}->{'active'} = $self->{'in_hash'}->{'active'};
	if ($self->{'config_hash'}->{'tags'} && $self->{'in_hash'}->{'tag'} ne '') {
		$self->{'log'}->{'section'} = $self->{'conf'}->[$self->{'in_hash'}->{'tag'}];
		}

	# Parse message types section
	for($i=0; defined($self->{'in_hash'}->{"fmode_$i"}); $i++) {
		local ($f, $p);
		if ($self->{'in_hash'}->{"fmode_$i"} == 0) {
			next if (!$self->{'in_hash'}->{"facil_$i"});
			$f = $self->{'in_hash'}->{"facil_$i"};
			}
		else {
			@{$self->{'facils_array'}} = split(/\s+/, $self->{'in_hash'}->{"facils_$i"});
			@{$self->{'facils_array'}} || $self->error($self->{'text_hash'}->{'save_efacils'});
			$f = join(",", @{$self->{'facils_array'}});
			}
		if ($self->{'in_hash'}->{"pmode_$i"} == 0) {
			$p = 'none';
			}
		elsif ($self->{'in_hash'}->{"pmode_$i"} == 1) {
			$p = '*';
			}
		else {
			$p = $self->{'in_hash'}->{"pdir_$i"}.$self->{'in_hash'}->{"pri_$i"};
			$self->{'in_hash'}->{"pri_$i"} || $self->error($self->{'text_hash'}->{'save_epri'});
			}
		push(@{$self->{'sel_array'}}, "$f.$p");
		}
	@{$self->{'sel_array'}} || $self->error($self->{'text_hash'}->{'save_esel'});
	$self->{'log'}->{'sel'} = \@{$self->{'sel_array'}};
	if ($self->{'in_hash'}->{'new'}) {
		$self->can_edit_log($self->{'log'}) || $self->error($self->{'text_hash'}->{'save_ecannot3'});
		$self->create_log($self->{'log'});
		}
	else {
		$self->can_edit_log($self->{'log'}) || $self->error($self->{'text_hash'}->{'save_ecannot4'});
		$self->{'old'} = $self->{'conf'}->[$self->{'in_hash'}->{'idx'}];
		$self->can_edit_log($self->{'old'}) || $self->error($self->{'text_hash'}->{'save_ecannot5'});
		$self->update_log($self->{'old'}, $self->{'log'});
		}
	$self->unlock_file($self->{'config_hash'}->{'syslog_conf'});
	$self->redirect("");
	}
$self->log_line($self->{'log'}) =~ /(\S+)$/;
$self->webmin_log($self->{'in_hash'}->{'delete'} ? "delete" :
	    $self->{'in_hash'}->{'new'} ? "create" : "modify", "log", "$1", $self->{'log'});

1;
		
}

sub filter_form
{
	shift if ($self == $_[0]);

print "<form action=save_log.cgi style='margin-left:1em'>\n";
print $self->ui_hidden("idx", $self->{'in_hash'}->{'idx'}),"\n";
print $self->ui_hidden("oidx", $self->{'in_hash'}->{'oidx'}),"\n";
print $self->ui_hidden("omod", $self->{'in_hash'}->{'omod'}),"\n";
print $self->ui_hidden("file", $self->{'in_hash'}->{'file'}),"\n";
print $self->ui_hidden("extra", $self->{'in_hash'}->{'extra'}),"\n";
print $self->ui_hidden("view", 1),"\n";

print $self->text('view_header', $self->ui_textbox("lines", $self->{'lines'}, 3),
	    "<tt>".$self->html_escape($self->{'log'}->{'file'})."</tt>"),"\n";
print "&nbsp;&nbsp;\n";
print $self->text('view_filter', $self->ui_textbox("filter", $self->{'in_hash'}->{'filter'}, 25)),"\n";
print "&nbsp;&nbsp;\n";
print "<input type=submit value='$self->{'text_hash'}->{'view_refresh'}'></form>\n";
}


1;

