#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Show a form for editing or creating a log destination

&ModuleLoader::preload_module('syslog_ng_class', "syslog_ng::SyslogngLib");
$self = new syslog_ng::SyslogngLib:: 'syslog_ng_class',%$self;

$self->ReadParse();

# Show title and get the destination
$self->{'conf'} = $self->get_config();
if ($self->{'in_hash'}->{'new'}) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'destination_title1'}, "");
	}
else {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'destination_title2'}, "");
	@{$self->{'dests_array'}} = $self->find("destination", $self->{'conf'});
	($self->{'dest'}) = grep { $_->{'value'} eq $self->{'in_hash'}->{'name'} } @{$self->{'dests_array'}};
	$self->{'dest'} || $self->error($self->{'text_hash'}->{'destination_egone'});
	}

# Form header
print $self->ui_form_start("save_destination.cgi", "post");
print $self->ui_hidden("new", $self->{'in_hash'}->{'new'}),"\n";
print $self->ui_hidden("old", $self->{'in_hash'}->{'name'}),"\n";
print $self->ui_table_start($self->{'text_hash'}->{'destination_header'}, undef, 2);

# Destination name
print $self->ui_table_row($self->{'text_hash'}->{'destination_name'},
		    $self->ui_textbox("name", $self->{'dest'}->{'value'}, 20));

# Work out type
$self->{'file'} = $self->find("file", $self->{'dest'}->{'members'});
$self->{'usertty'} = $self->find("usertty", $self->{'dest'}->{'members'});
$self->{'program'} = $self->find("program", $self->{'dest'}->{'members'});
$self->{'pipe'} = $self->find("pipe", $self->{'dest'}->{'members'});
$self->{'udp'} = $self->find("udp", $self->{'dest'}->{'members'});
$self->{'tcp'} = $self->find("tcp", $self->{'dest'}->{'members'});
$self->{'dgram'} = $self->find("unix-dgram", $self->{'dest'}->{'members'});
$self->{'stream'} = $self->find("unix-stream", $self->{'dest'}->{'members'});
$self->{'type'} = $self->{'file'} ? 0 :
	$self->{'usertty'} ? 1 :
	$self->{'program'} ? 2 :
	$self->{'pipe'} ? 3 :
	$self->{'tcp'} ? 4 :
	$self->{'udp'} ? 5 :
	$self->{'dgram'} ? 6 :
	$self->{'stream'} ? 7 : 0;

$self->{'dtable'} = "<table>\n";

# File destination
if ($self->{'file'}) {
	$self->{'file_name'} = $self->{'file'}->{'value'};
	$self->{'file_owner'} = $self->find_value("owner", $self->{'file'}->{'members'});
	$self->{'file_group'} = $self->find_value("group", $self->{'file'}->{'members'});
	$self->{'file_perm'} = $self->find_value("perm", $self->{'file'}->{'members'});
	$self->{'file_create_dirs'} = $self->find_value("create_dirs", $self->{'file'}->{'members'});
	$self->{'file_dir_perm'} = $self->find_value("dir_perm", $self->{'file'}->{'members'});
	$self->{'file_fsync'} = $self->find_value("fsync", $self->{'file'}->{'members'});
	$self->{'file_sync_freq'} = $self->find_value("sync_freq", $self->{'file'}->{'members'});
	}
$self->{'dtable'} .= "<tr> <td valign=top>".$self->ui_oneradio("type", 0, "<b>$self->{'text_hash'}->{'destinations_typef'}</b>", $self->{'type'} == 0)."</td> <td valign=top><table>\n";
$self->{'dtable'} .= "<tr> <td>$self->{'text_hash'}->{'destination_file'}</td> <td>".
	   $self->ui_textbox("file_name", $self->{'file_name'}, 35)." ".
	   $self->file_chooser_button("file_name")."</td> </tr>\n";
$self->{'dtable'} .= "<tr> <td>$self->{'text_hash'}->{'destination_owner'}</td> <td>".
	   $self->ui_opt_textbox("file_owner", $self->{'file_owner'}, 15, $self->{'text_hash'}->{'default'})." ".
	   $self->user_chooser_button("file_owner").
	   "</td> </tr>\n";
$self->{'dtable'} .= "<tr> <td>$self->{'text_hash'}->{'destination_group'}</td> <td>".
	   $self->ui_opt_textbox("file_group", $self->{'file_group'}, 15, $self->{'text_hash'}->{'default'})." ".
	   $self->group_chooser_button("file_owner").
	   "</td> </tr>\n";
$self->{'dtable'} .= "<tr> <td>$self->{'text_hash'}->{'destination_perm'}</td> <td>".
	   $self->ui_opt_textbox("file_perm", $self->{'file_perm'}, 5, $self->{'text_hash'}->{'default'}).
	   "</td> </tr>\n";
$self->{'dtable'} .= "<tr> <td>$self->{'text_hash'}->{'destination_create_dirs'}</td> <td>".
	   $self->ui_radio("file_create_dirs", $self->{'file_create_dirs'},
		     [ [ 'yes', $self->{'text_hash'}->{'yes'} ],
		       [ 'no', $self->{'text_hash'}->{'no'} ],
		       [ '', $self->{'text_hash'}->{'default'} ] ]).
	   "</td> </tr>\n";
$self->{'dtable'} .= "<tr> <td>$self->{'text_hash'}->{'destination_dir_perm'}</td> <td>".
	   $self->ui_opt_textbox("file_dir_perm", $self->{'file_dir_perm'}, 5,$self->{'text_hash'}->{'default'}).
	   "</td> </tr>\n";
$self->{'dtable'} .= "<tr> <td>$self->{'text_hash'}->{'destination_fsync'}</td> <td>".
	   $self->ui_radio("file_fsync", $self->{'file_fsync'},
		     [ [ 'yes', $self->{'text_hash'}->{'yes'} ],
		       [ 'no', $self->{'text_hash'}->{'no'} ],
		       [ '', $self->{'text_hash'}->{'default'} ] ]).
	   "</td> </tr>\n";
$self->{'dtable'} .= "<tr> <td>$self->{'text_hash'}->{'destination_sync_freq'}</td> <td>".
	   $self->ui_opt_textbox("file_sync_freq", $self->{'file_sync_freq'}, 5, $self->{'text_hash'}->{'default'}).
	   "</td> </tr>\n";
$self->{'dtable'} .= "</table></td> </tr>";

# User TTY destination
if ($self->{'usertty'}) {
	$self->{'usertty_user'} = $self->{'usertty'}->{'value'};
	}
$self->{'dtable'} .= "<tr> <td valign=top>".$self->ui_oneradio("type", 1, "<b>$self->{'text_hash'}->{'destinations_typeu'}</b>", $self->{'type'} == 1)."</td> <td valign=top>\n";
$self->{'dtable'} .= $self->ui_opt_textbox("usertty_user", $self->{'usertty_user'} eq "*" ? undef : $self->{'usertty_user'}, 20, $self->{'text_hash'}->{'destinations_allusers'}, $self->{'text_hash'}->{'destination_users'})." ".$self->user_chooser_button("usertty_user", 1);
$self->{'table'} .= "</td> </tr>";

# Program destination
if ($self->{'program'}) {
	$self->{'program_prog'} = $self->{'program'}->{'value'};
	}
$self->{'dtable'} .= "<tr> <td valign=top>".$self->ui_oneradio("type", 2, "<b>$self->{'text_hash'}->{'destinations_typep'}</b>", $self->{'type'} == 2)."</td> <td valign=top>\n";
$self->{'dtable'} .= $self->ui_textbox("program_prog", $self->{'program_prog'}, 50);
$self->{'table'} .= "</td> </tr>";

# Pipe destination
if ($self->{'pipe'}) {
	$self->{'pipe_name'} = $self->{'pipe'}->{'value'};
	}
$self->{'dtable'} .= "<tr> <td valign=top>".$self->ui_oneradio("type", 3, "<b>$self->{'text_hash'}->{'destinations_typei'}</b>", $self->{'type'} == 3)."</td> <td valign=top>\n";
$self->{'dtable'} .= $self->ui_textbox("pipe_name", $self->{'pipe_name'}, 30)." ".
	   $self->file_chooser_button("pipe_name");
$self->{'dtable'} .= "</td> </tr>";

# TCP or UDP socket
$self->{'net'} = $self->{'tcp'} || $self->{'udp'};
if ($self->{'net'}) {
	$self->{'net_host'} = $self->{'net'}->{'value'};
	$self->{'net_port'} = $self->find_value("port", $self->{'net'}->{'members'});
	$self->{'net_localip'} = $self->find_value("localip", $self->{'net'}->{'members'});
	$self->{'net_localport'} = $self->find_value("localport", $self->{'net'}->{'members'});
	}
$self->{'dtable'} .= "<tr> <td valign=top>".$self->ui_oneradio("type", 4, "<b>$self->{'text_hash'}->{'destination_net'}</b>", $self->{'type'} == 4 || $self->{'type'} == 5)."</td> <td valign=top><table>\n";
$self->{'dtable'} .= "<tr> <td>$self->{'text_hash'}->{'destination_proto'}</td> ".
	   "<td>".$self->ui_select("net_proto", $self->{'type'} == 5 ? "udp" : "tcp",
		     [ [ "tcp", "TCP" ], [ "udp", "UDP" ] ])."</td> </tr>\n";
$self->{'dtable'} .= "<tr> <td>$self->{'text_hash'}->{'destination_host'}</td> ".
	   "<td>".$self->ui_textbox("net_host", $self->{'net_host'}, 20)."</td> </tr>\n";
$self->{'dtable'} .= "<tr> <td>$self->{'text_hash'}->{'destination_port'}</td> ".
	   "<td>".$self->ui_opt_textbox("net_port", $self->{'net_port'}, 5, "$self->{'text_hash'}->{'default'} (514)")."</td> </tr>\n";
$self->{'dtable'} .= "<tr> <td>$self->{'text_hash'}->{'destination_localip'}</td> ".
	   "<td>".$self->ui_opt_textbox("net_localip", $self->{'net_localip'}, 15, $self->{'text_hash'}->{'default'})."</td> </tr>\n";
$self->{'dtable'} .= "<tr> <td>$self->{'text_hash'}->{'destination_localport'}</td> ".
	   "<td>".$self->ui_opt_textbox("net_localport", $self->{'net_localport'}, 5, $self->{'text_hash'}->{'default'})."</td> </tr>\n";
$self->{'dtable'} .= "</table></td> </tr>";

# Datagram or stream socket
$self->{'unix'} = $self->{'dgram'} || $self->{'stream'};
if ($self->{'unix'}) {
	$self->{'unix_name'} = $self->{'unix'}->{'value'};
	}
$self->{'dtable'} .= "<tr> <td valign=top>".$self->ui_oneradio("type", 6, "<b>$self->{'text_hash'}->{'destination_unix'}</b>", $self->{'type'} == 6 || $self->{'type'} == 7)."</td> <td valign=top><table>\n";
$self->{'dtable'} .= "<tr> <td>$self->{'text_hash'}->{'destination_utype'}</td> ".
	   "<td>".$self->ui_select("unix_type",
		     $self->{'type'} == 6 ? "unix-dgram" : "unix-stream",
		     [ [ "unix-stream", $self->{'text_hash'}->{'destinations_types'} ],
		       [ "unix-dgram", $self->{'text_hash'}->{'destinations_typeg'} ] ]).
	   "</td> </tr>\n";
$self->{'dtable'} .= "<tr> <td>$self->{'text_hash'}->{'destination_socket'}</td> ".
	   "<td>".$self->ui_textbox("unix_name", $self->{'unix_name'}, 30)."\n".
		  $self->file_chooser_button("unix_name")."</td> </tr>\n";
$self->{'dtable'} .= "</table></td> </tr>";

# Actually show the destination
$self->{'dtable'} .= "</table>\n";
print $self->ui_table_row($self->{'text_hash'}->{'destination_type'}, $self->{'dtable'});

# Form footer and buttons
print $self->ui_table_end();
if ($self->{'in_hash'}->{'new'}) {
	print $self->ui_form_end([ [ "create", $self->{'text_hash'}->{'create'} ] ]);
	}
else {
	print $self->ui_form_end([ [ "save", $self->{'text_hash'}->{'save'} ],
			     [ "delete", $self->{'text_hash'}->{'delete'} ] ]);
	}
$self->ui_print_footer("list_destinations.cgi", $self->{'text_hash'}->{'destinations_return'});

1;
		
}


1;

