#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Show a form for editing or creating a log filter

&ModuleLoader::preload_module('syslog_ng_class', "syslog_ng::SyslogngLib");
$self = new syslog_ng::SyslogngLib:: 'syslog_ng_class',%$self;

$self->ReadParse();

# Show title and get the filter
$self->{'conf'} = $self->get_config();
if ($self->{'in_hash'}->{'new'}) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'filter_title1'}, "");
	}
else {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'filter_title2'}, "");
	@{$self->{'filters_array'}} = $self->find("filter", $self->{'conf'});
	($self->{'filter'}) = grep { $_->{'value'} eq $self->{'in_hash'}->{'name'} } @{$self->{'filters_array'}};
	$self->{'filter'} || $self->error($self->{'text_hash'}->{'filter_egone'});
	}

# Form header
print $self->ui_form_start("save_filter.cgi", "post");
print $self->ui_hidden("new", $self->{'in_hash'}->{'new'}),"\n";
print $self->ui_hidden("old", $self->{'in_hash'}->{'name'}),"\n";
print $self->ui_table_start($self->{'text_hash'}->{'filter_header'}, undef, 2);

# Filter name
print $self->ui_table_row($self->{'text_hash'}->{'filter_name'},
		    $self->ui_textbox("name", $self->{'filter'}->{'value'}, 20));

# See if the conditions are simple (1 or more of facility, level, matches
# and program, and separated)
$self->{'simple'} = 1;
foreach $m (@{$self->{'filter'}->{'members'}}) {
	if (ref($m)) {
		if ($self->{'simple_hash'}->{$m->{'name'}}) {
			# Already done this type .. not simple any more
			$self->{'simple'} = 0;
		        }
		else {
			$self->{'simple_hash'}->{$m->{'name'}} = $m;
			}
		}
	elsif ($m eq "and") {
		# 'and' separator .. we can handle this
		}
	else {
		$self->{'simple'} = 0;
		}
	}

# Build table for simple mode
%{$self->{'simple_hash'}} = ( ) if (!$self->{'simple'});
$self->{'stable'} = "<table>\n";

# Priority
$p = $self->{'simple_hash'}->{'priority'};
@{$self->{'pris_array'}} = $self->list_priorities();
if ($p) {
	if ($p->{'values'}->[1] eq "..") {
		$self->{'i1'} = $self->indexof(@{$self->{'pris_array'}}, $p->{'values'}->[0]);
		$self->{'i2'} = $self->indexof(@{$self->{'pris_array'}}, $p->{'values'}->[2]);
		if ($self->{'i1'} >= 0 && $self->{'i2'} >= 0) {
			%{$self->{'gotpris_hash'}} = map { $self->{'pris_array'}->[$_], 1 } ($self->{'i1'} .. $self->{'i2'});
			}
		}
	else {
		%{$self->{'gotpris_hash'}} = map { $_, 1 } grep { $_ ne "," } @{$p->{'values'}};
		}
	}
$self->{'stable'} .= "<tr> <td><b>".$self->ui_checkbox("priority", 1, $self->{'text_hash'}->{'filter_priority'},
				       $p ? 1 : 0)."</b></td>\n";
$self->{'stable'} .= "<td>";
foreach $p (@{$self->{'pris_array'}}) {
	$self->{'stable'} .= $self->ui_checkbox("pri", $p, $p, $self->{'gotpris_hash'}->{$p})."\n";
	}
$self->{'stable'} .= "</td> </tr>\n";

# Facility
$p = $self->{'simple_hash'}->{'facility'};
@{$self->{'facs_array'}} = $self->list_facilities();
if ($p) {
	%{$self->{'gotfacs_hash'}} = map { $_, 1 } grep { $_ ne "," } @{$p->{'values'}};
	}
$self->{'stable'} .= "<tr> <td valign=top><b>".
  $self->ui_checkbox("facility", 1, $self->{'text_hash'}->{'filter_facility'}, $p ? 1 : 0).
  "</b></td>\n";
$self->{'stable'} .= "<td><table>";
$self->{'i'} = 0;
foreach $f (@{$self->{'facs_array'}}) {
	$self->{'stable'} .= "<tr>\n" if ($self->{'i'} % 8 == 0);
	$self->{'stable'} .= "<td>".$self->ui_checkbox("fac", $f, $f, $self->{'gotfacs_hash'}->{$f})."</td>\n";
	$self->{'stable'} .= "<tr>\n" if ($self->{'i'} % 8 == 7);
	$self->{'i'}++;
	}
$self->{'stable'} .= "</table></td> </tr>\n";

# Program
$p = $self->{'simple_hash'}->{'program'};
$self->{'stable'} .= "<tr> <td><b>".$self->ui_checkbox("program", 1, $self->{'text_hash'}->{'filter_program'},
				       $p ? 1 : 0)."</b></td>\n";
$self->{'stable'} .= "<td>".$self->ui_textbox("prog", $p ? $p->{'value'} : undef, 30).
	   "</td> </tr>\n";

# Match RE
$p = $self->{'simple_hash'}->{'match'};
$self->{'stable'} .= "<tr> <td><b>".$self->ui_checkbox("match", 1, $self->{'text_hash'}->{'filter_match'},
				       $p ? 1 : 0)."</b></td>\n";
$self->{'stable'} .= "<td>".$self->ui_textbox("re", $p ? $p->{'value'} : undef, 50).
	   "</td> </tr>\n";

# Sending hostname
$p = $self->{'simple_hash'}->{'host'};
$self->{'stable'} .= "<tr> <td><b>".$self->ui_checkbox("host", 1, $self->{'text_hash'}->{'filter_host'},
				       $p ? 1 : 0)."</b></td>\n";
$self->{'stable'} .= "<td>".$self->ui_textbox("hn", $p ? $p->{'value'} : undef, 30).
	   "</td> </tr>\n";

# Sending IP
$p = $self->{'simple_hash'}->{'netmask'};
if ($p) {
      ($self->{'net'}, $self->{'mask'}) = split(/\//, $p->{'value'});
      }
$self->{'stable'} .= "<tr> <td><b>".$self->ui_checkbox("netmask", 1, $self->{'text_hash'}->{'filter_netmask'},
				       $p ? 1 : 0)."</b></td>\n";
$self->{'stable'} .= "<td>".$self->ui_textbox("net", $self->{'net'}, 15)."/".
		  $self->ui_textbox("mask", $self->{'mask'}, 15)."</td> </tr>\n";

$self->{'stable'} .= "</table>\n";

# Build text area for complex mode
local @w;
foreach $m (@{$self->{'filter'}->{'members'}}) {
	if (ref($m)) {
		local ($line) = $self->directive_lines($m);
		$line =~ s/\s*;\s*$//;
		push(@w, $line);
		}
	else {
		push(@w, $m);
		}
	}
$self->{'ctable'} = $self->ui_textarea("bool", join(" ", @w), 5, 80);

# Show the two modes
print "<tr> <td colspan=2>\n";
print $self->ui_oneradio("mode", 0, "<b>$self->{'text_hash'}->{'filter_mode0'}</b>", $self->{'simple'}),"<br>\n";
print $self->{'stable'},"<br>\n";
print $self->ui_oneradio("mode", 1, "<b>$self->{'text_hash'}->{'filter_mode1'}</b>",!$self->{'simple'}),"<br>\n";
print $self->{'ctable'},"<br>\n";
print "</td> </tr>\n";

# Form footer and buttons
print $self->ui_table_end();
if ($self->{'in_hash'}->{'new'}) {
	print $self->ui_form_end([ [ "create", $self->{'text_hash'}->{'create'} ] ]);
	}
else {
	print $self->ui_form_end([ [ "save", $self->{'text_hash'}->{'save'} ],
			     [ "delete", $self->{'text_hash'}->{'delete'} ] ]);
	}
$self->ui_print_footer("list_filters.cgi", $self->{'text_hash'}->{'filters_return'});
1;
		
}


1;

