#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Show a form for editing or creating a log source

&ModuleLoader::preload_module('syslog_ng_class', "syslog_ng::SyslogngLib");
$self = new syslog_ng::SyslogngLib:: 'syslog_ng_class',%$self;

$self->ReadParse();

# Show title and get the source
$self->{'conf'} = $self->get_config();
if ($self->{'in_hash'}->{'new'}) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'source_title1'}, "");
	}
else {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'source_title2'}, "");
	@{$self->{'sources_array'}} = $self->find("source", $self->{'conf'});
	($self->{'source'}) = grep { $_->{'value'} eq $self->{'in_hash'}->{'name'} } @{$self->{'sources_array'}};
	$self->{'source'} || $self->error($self->{'text_hash'}->{'source_egone'});
	}

# Form header
print $self->ui_form_start("save_source.cgi", "post");
print $self->ui_hidden("new", $self->{'in_hash'}->{'new'}),"\n";
print $self->ui_hidden("old", $self->{'in_hash'}->{'name'}),"\n";
print $self->ui_table_start($self->{'text_hash'}->{'source_header'}, undef, 2);

# Source name
print $self->ui_table_row($self->{'text_hash'}->{'source_name'},
		    $self->ui_textbox("name", $self->{'source'}->{'value'}, 20));

# Show internal option
$self->{'ttable'} = "<table>\n";
$self->{'internal'} = $self->find("internal", $self->{'source'}->{'members'});
$self->{'ttable'} .= "<tr> <td colspan=2>".$self->ui_checkbox("internal", 1, "<b>$self->{'text_hash'}->{'sources_typei'}</b>", $self->{'internal'} ? 1 : 0)."</td> </tr>\n";

# Show Unix stream and dgram socket options
foreach $t ("unix-stream", "unix-dgram") {
        $self->{'unix'} = $self->find($t, $self->{'source'}->{'members'});
        local ($unix_name, $unix_owner, $unix_group, $unix_perm,
               $unix_keep, $unix_max);
        if ($self->{'unix'}) {
          $unix_name = $self->{'unix'}->{'value'};
          $unix_owner = $self->find_value("owner", $self->{'unix'}->{'members'});
          $unix_group = $self->find_value("group", $self->{'unix'}->{'members'});
          $unix_perm = $self->find_value("perm", $self->{'unix'}->{'members'});
          $unix_keep = $self->find_value("keep-alive", $self->{'unix'}->{'members'});
          $unix_max = $self->find_value("max-connections", $self->{'unix'}->{'members'});
          }
        $self->{'msg'} = $t eq "unix-stream" ? 'sources_types' : 'sources_typed';
        $self->{'ttable'} .= "<tr> <td valign=top>".$self->ui_checkbox($t, 1, "<b>$self->{'text_hash'}->{$self->{'msg'}}</b>", $self->{'unix'} ? 1 : 0)."</td> <td><table>\n";

        # Socket filename
        $self->{'ttable'} .= "<tr> <td>$self->{'text_hash'}->{'destination_file'}</td> <td>".
                   $self->ui_textbox($t."_name", $unix_name, 35)." ".
                   $self->file_chooser_button("unix_name")."</td> </tr>\n";

        # Socket owner and group
        $self->{'ttable'} .= "<tr> <td>$self->{'text_hash'}->{'source_owner'}</td> <td>".
           $self->ui_opt_textbox($t."_owner", $unix_owner, 15, $self->{'text_hash'}->{'default'})." ".
           $self->user_chooser_button($t."_owner")."</td> </tr>\n";
        $self->{'ttable'} .= "<tr> <td>$self->{'text_hash'}->{'source_group'}</td> <td>".
           $self->ui_opt_textbox($t."_group", $unix_group, 15, $self->{'text_hash'}->{'default'})." ".
           $self->group_chooser_button($t."_group")."</td> </tr>\n";

        # File permissions, keep-alive and max connetions
        $self->{'ttable'} .= "<tr> <td>$self->{'text_hash'}->{'source_perm'}</td> <td>".
                   $self->ui_opt_textbox($t."_perm", $unix_perm, 5,$self->{'text_hash'}->{'default'}).
                   "</td> </tr>\n";
        if ($t eq "unix-stream") {
                $self->{'ttable'} .= "<tr> <td>$self->{'text_hash'}->{'source_keep'}</td> <td>".
                           $self->ui_radio($t."_keep", $unix_keep,
                                 [ [ 'y', $self->{'text_hash'}->{'yes'} ],
                                   [ 'n', $self->{'text_hash'}->{'no'} ],
                                   [ '', $self->{'text_hash'}->{'default'} ] ])."</td> </tr>\n";
                $self->{'ttable'} .= "<tr> <td>$self->{'text_hash'}->{'source_max'}</td> <td>".
                           $self->ui_opt_textbox($t."_max", $unix_max, 5,
                                           $self->{'text_hash'}->{'default'})."</td> </tr>\n";
                }

        $self->{'ttable'} .= "</table>\n";
        $self->{'ttable'} .= "</td> </tr>\n";
        }

# TCP and UDP network sockets
foreach $t ('tcp', 'udp') {
        $self->{'net'} = $self->find($t, $self->{'source'}->{'members'});
        local ($net_ip, $net_port, $net_keep, $net_tkeep, $net_max);
        if ($self->{'net'}) {
                $net_ip = $self->find_value("ip", $self->{'net'}->{'members'}) ||
                          $self->find_value("localip", $self->{'net'}->{'members'});
                $net_port = $self->find_value("port", $self->{'net'}->{'members'}) ||
                            $self->find_value("localport", $self->{'net'}->{'members'});
                $net_keep = $self->find_value("keep-alive", $self->{'net'}->{'members'});
                $net_tkeep = $self->find_value("tcp-keep-alive", $self->{'net'}->{'members'});
                $net_max = $self->find_value("max-connections", $self->{'net'}->{'members'});
                }
        $self->{'msg'} = $t eq "tcp" ? 'sources_typet' : 'sources_typeu';
        $self->{'ttable'} .= "<tr> <td valign=top>".$self->ui_checkbox($t, 1, "<b>$self->{'text_hash'}->{$self->{'msg'}}</b>", $self->{'net'} ? 1 : 0)."</td> <td><table>\n";

        # Local IP and port
        $self->{'ttable'} .= "<tr> <td>$self->{'text_hash'}->{'source_ip'}</td> <td>".
           $self->ui_opt_textbox($t."_ip", $net_ip, 15, $self->{'text_hash'}->{'source_any'}).
           "</td> </tr>\n";
        $self->{'ttable'} .= "<tr> <td>$self->{'text_hash'}->{'source_port'}</td> <td>".
           $self->ui_opt_textbox($t."_port", $net_port, 6, $self->{'text_hash'}->{'default'}." (514)").
           "</td> </tr>\n";

        # TCP-specific options and max connections
        if ($t eq "tcp") {
                $self->{'ttable'} .= "<tr> <td>$self->{'text_hash'}->{'source_keep'}</td> <td>".
                           $self->ui_radio($t."_keep", $net_keep,
                                 [ [ 'y', $self->{'text_hash'}->{'yes'} ],
                                   [ 'n', $self->{'text_hash'}->{'no'} ],
                                   [ '', $self->{'text_hash'}->{'default'} ] ])."</td> </tr>\n";
                $self->{'ttable'} .= "<tr> <td>$self->{'text_hash'}->{'source_tkeep'}</td> <td>".
                           $self->ui_radio($t."_tkeep", $net_tkeep,
                                 [ [ 'y', $self->{'text_hash'}->{'yes'} ],
                                   [ 'n', $self->{'text_hash'}->{'no'} ],
                                   [ '', $self->{'text_hash'}->{'default'} ] ])."</td> </tr>\n";
                }
        $self->{'ttable'} .= "<tr> <td>$self->{'text_hash'}->{'source_max'}</td> <td>".
                   $self->ui_opt_textbox($t."_max", $net_max, 5,
                                   $self->{'text_hash'}->{'default'})."</td> </tr>\n";

        $self->{'ttable'} .= "</table>\n";
        $self->{'ttable'} .= "</td> </tr>\n";
        }

# Kernel log file
$self->{'file'} = $self->find("file", $self->{'source'}->{'members'});
if ($self->{'file'}) {
        $self->{'file_name'} = $self->{'file'}->{'value'};
        $self->{'file_prefix'} = $self->find_value("log_prefix", $self->{'file'}->{'members'});
        }
$self->{'ttable'} .= "<tr> <td valign=top>".$self->ui_checkbox("file", 1, "<b>$self->{'text_hash'}->{'sources_typef'}</b>", $self->{'file'} ? 1 : 0)."</td> <td><table>\n";

# Log filename
$self->{'ttable'} .= "<tr> <td>$self->{'text_hash'}->{'destination_file'}</td> <td>".
           $self->ui_textbox("file_name", $self->{'file_name'}, 35)." ".
           $self->file_chooser_button("file_name")."</td> </tr>\n";

# Message prefix
$self->{'ttable'} .= "<tr> <td>$self->{'text_hash'}->{'source_prefix'}</td> <td>".
           $self->ui_opt_textbox("file_prefix", $self->{'file_prefix'}, 20,
                           $self->{'text_hash'}->{'source_none'})."</td> </tr>\n";
$self->{'ttable'} .= "</table>\n";
$self->{'ttable'} .= "</td> </tr>\n";

# Pipe file
$self->{'pipe'} = $self->find("pipe", $self->{'source'}->{'members'});
if ($self->{'pipe'}) {
        $self->{'pipe_name'} = $self->{'pipe'}->{'value'};
        $self->{'pipe_prefix'} = $self->find_value("log_prefix", $self->{'pipe'}->{'members'});
        $self->{'pad_size'} = $self->find_value("pad_size", $self->{'pipe'}->{'members'});
        }
$self->{'ttable'} .= "<tr> <td valign=top>".$self->ui_checkbox("pipe", 1, "<b>$self->{'text_hash'}->{'sources_typep'}</b>", $self->{'pipe'} ? 1 : 0)."</td> <td><table>\n";

# Log pipename
$self->{'ttable'} .= "<tr> <td>$self->{'text_hash'}->{'destination_file'}</td> <td>".
           $self->ui_textbox("pipe_name", $self->{'pipe_name'}, 35)." ".
           $self->file_chooser_button("pipe_name")."</td> </tr>\n";

# Message prefix and pad size
$self->{'ttable'} .= "<tr> <td>$self->{'text_hash'}->{'source_prefix'}</td> <td>".
           $self->ui_opt_textbox("pipe_prefix", $self->{'pipe_prefix'}, 20,
                           $self->{'text_hash'}->{'source_none'})."</td> </tr>\n";
$self->{'ttable'} .= "<tr> <td>$self->{'text_hash'}->{'source_pad'}</td> <td>".
           $self->ui_opt_textbox("pad_size", $self->{'pad_size'}, 20,
                           $self->{'text_hash'}->{'source_none'})."</td> </tr>\n";
$self->{'ttable'} .= "</table>\n";
$self->{'ttable'} .= "</td> </tr>\n";

if ($self->supports_sun_streams()) {
	# Sun streams file
	$self->{'sun_streams'} = $self->find("sun-streams", $self->{'source'}->{'members'});
	if ($self->{'sun_streams'}) {
		$self->{'sun_streams_name'} = $self->{'sun_streams'}->{'value'};
		$self->{'sun_streams_door'} = $self->find_value("door", $self->{'sun_streams'}->{'members'});
		}
	$self->{'ttable'} .= "<tr> <td valign=top>".$self->ui_checkbox("sun-streams", 1, "<b>$self->{'text_hash'}->{'sources_typen'}</b>", $self->{'sun_streams'} ? 1 : 0)."</td> <td><table>\n";

	# Log filename
	$self->{'ttable'} .= "<tr> <td>$self->{'text_hash'}->{'destination_file'}</td> <td>".
		   $self->ui_textbox("sun_streams_name", $self->{'sun_streams_name'}, 35)." ".
		   $self->file_chooser_button("sun_streams_name")."</td> </tr>\n";

	# Door name
	$self->{'ttable'} .= "<tr> <td>$self->{'text_hash'}->{'source_door'}</td> <td>".
		   $self->ui_textbox("sun_streams_door", $self->{'sun_streams_door'}, 35)." ".
		   $self->file_chooser_button("sun_streams_name")."</td> </tr>\n";
	$self->{'ttable'} .= "</table>\n";
	$self->{'ttable'} .= "</td> </tr>\n";
	}

# Show types table
$self->{'ttable'} .= "</table>\n";
print "<tr> <td colspan=2><b>$self->{'text_hash'}->{'source_type'}</b><br>\n";
print $self->{'ttable'};
print "</td> </tr>\n";

# Form footer and buttons
print $self->ui_table_end();
if ($self->{'in_hash'}->{'new'}) {
	print $self->ui_form_end([ [ "create", $self->{'text_hash'}->{'create'} ] ]);
	}
else {
	print $self->ui_form_end([ [ "save", $self->{'text_hash'}->{'save'} ],
			     [ "delete", $self->{'text_hash'}->{'delete'} ] ]);
	}
$self->ui_print_footer("list_sources.cgi", $self->{'text_hash'}->{'sources_return'});
1;
		
}


1;

