#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Show icons for syslog_ng destinations, filters, logs and options

&ModuleLoader::preload_module('syslog_ng_class', "syslog_ng::SyslogngLib");
$self = new syslog_ng::SyslogngLib:: 'syslog_ng_class',%$self;


# Make sure it is installed
$self->{'ver'} = $self->get_syslog_ng_version();
if (!$self->{'ver'}) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", undef, 1, 1);
	$self->ui_print_endpage($self->text('index_eprog', "<tt>$self->{'config_hash'}->{'syslogng_cmd'}</tt>", "../config.cgi?$self->{'module_name'}"));
	}
if (!-r $self->{'config_hash'}->{'syslogng_conf'} && -r $self->{'config_hash'}->{'alt_syslogng_conf'}) {
	# Copy original template config file
	$self->copy_source_dest($self->{'config_hash'}->{'alt_syslogng_conf'},
			  $self->{'config_hash'}->{'syslogng_conf'});
	}
if (!-r $self->{'config_hash'}->{'syslogng_conf'}) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", undef, 1, 1);
	$self->ui_print_endpage($self->text('index_econf', "<tt>$self->{'config_hash'}->{'syslogng_conf'}</tt>", "../config.cgi?$self->{'module_name'}"));
	}

$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", "intro", 1, 1, 0,
		 $self->help_search_link("syslog_ng", "man", "doc", "google"),
		 undef, undef, $self->text('index_version', $self->{'ver'}));

# Show category icons
@{$self->{'pages_array'}} = ( "options", "sources", "destinations", "filters", "logs" );
@{$self->{'links_array'}} = map { "list_${_}.cgi" } @{$self->{'pages_array'}};
@{$self->{'titles_array'}} = map { $self->{'text_hash'}->{$_."_title"} } @{$self->{'pages_array'}};
@{$self->{'icons_array'}} = map { "images/${_}.gif" } @{$self->{'pages_array'}};
$self->icons_table(\@{$self->{'links_array'}}, \@{$self->{'titles_array'}}, \@{$self->{'icons_array'}}, 5);

# Show start/stop buttons
print "<hr>\n";
print $self->ui_buttons_start();
if ($self->is_syslog_ng_running()) {
	print $self->ui_buttons_row("apply.cgi", $self->{'text_hash'}->{'index_apply'},
			      $self->{'text_hash'}->{'index_applydesc'});
	print $self->ui_buttons_row("stop.cgi", $self->{'text_hash'}->{'index_stop'},
			      $self->{'text_hash'}->{'index_stopdesc'});
	}
else {
	print $self->ui_buttons_row("start.cgi", $self->{'text_hash'}->{'index_start'},
			      $self->{'text_hash'}->{'index_startdesc'});
	}
print $self->ui_buttons_end();

$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});

1;
		
}


1;

