#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Show a list of log destinations

&ModuleLoader::preload_module('syslog_ng_class', "syslog_ng::SyslogngLib");
$self = new syslog_ng::SyslogngLib:: 'syslog_ng_class',%$self;

$self->ui_print_header(undef, $self->{'text_hash'}->{'destinations_title'}, "", "destinations");

$self->{'conf'} = $self->get_config();
@{$self->{'dests_array'}} = $self->find("destination", $self->{'conf'});
@{$self->{'links_array'}} = ( $self->select_all_link("d"),
	   $self->select_invert_link("d"),
	   "<a href='edit_destination.cgi?new=1'>$self->{'text_hash'}->{'destinations_add'}</a>",
	 );
if (@{$self->{'dests_array'}}) {
	@{$self->{'tds_array'}} = ( "width=5" );
	print $self->ui_form_start("delete_destinations.cgi", "post");
	print $self->ui_links_row(\@{$self->{'links_array'}});
	print $self->ui_columns_start([ "",
				  $self->{'text_hash'}->{'destinations_name'},
				  $self->{'text_hash'}->{'destinations_type'},
				  $self->{'text_hash'}->{'destinations_file'},
				  "", ], undef, 0, \@{$self->{'tds_array'}});
	foreach $d (@{$self->{'dests_array'}}) {
		($self->{'type'}, $self->{'typeid'}) = $self->nice_destination_type($d);
		$self->{'file'} = $self->nice_destination_file($d);
		$self->{'realfile'} = $self->find_value("file", $d->{'members'});
		print $self->ui_checked_columns_row([
			"<a href='edit_destination.cgi?name=".
			  $self->urlize($d->{'value'})."'>$d->{'value'}</a>",
			$self->{'type'} || "???",
			$self->{'file'} || "???",
			$self->{'typeid'} == 0 && -f $self->{'realfile'} ?
			  "<a href='view_log.cgi?dest=".$self->urlize($d->{'value'}).
			  "'>$self->{'text_hash'}->{'destinations_view'}</a>" : "",
			], \@{$self->{'tds_array'}}, "d", $d->{'value'});
		}
	print $self->ui_columns_end();
	print $self->ui_links_row(\@{$self->{'links_array'}});
	print $self->ui_form_end([ [ "delete", $self->{'text_hash'}->{'destinations_delete'} ] ]);
	}
else {
	print "<b>$self->{'text_hash'}->{'destinations_none'}</b><p>\n";
	print $self->ui_links_row([ $self->{'links_array'}->[2] ]);
	}

# Show other module's logs
@{$self->{'others_array'}} = $self->get_other_module_logs();
if (@{$self->{'others_array'}}) {
	print "<hr>\n";
	print $self->ui_columns_start([ $self->{'text_hash'}->{'destinations_desc'},
				  $self->{'text_hash'}->{'destinations_file'},
				  "" ]);
	foreach $o (@{$self->{'others_array'}}) {
		print $self->ui_columns_row([
			$o->{'desc'},
			$o->{'file'} ? "<tt>$o->{'file'}</tt>"
				     : $self->text('destinations_cmd', $o->{'cmd'}),
			"<a href='view_log.cgi?oidx=$o->{'mindex'}".
			"&omod=$o->{'mod'}'>$self->{'text_hash'}->{'destinations_view'}</a>",
			]);
		}
	print $self->ui_columns_end();
	}

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

