#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Show global options

&ModuleLoader::preload_module('syslog_ng_class', "syslog_ng::SyslogngLib");
$self = new syslog_ng::SyslogngLib:: 'syslog_ng_class',%$self;

$self->{'conf'} = $self->get_config();
$self->{'options'} = $self->find("options", $self->{'conf'});
$self->{'options'} ||= { 'members' => [ ] };
$self->{'mems'} = $self->{'options'}->{'members'};
$self->ui_print_header(undef, $self->{'text_hash'}->{'options_title'}, "", "options");

print $self->ui_form_start("save_options.cgi", "post");
print $self->ui_table_start($self->{'text_hash'}->{'options_header'}, undef, 2);

$self->{'yesno'} = [ [ 'yes', $self->{'text_hash'}->{'yes'} ], [ 'no', $self->{'text_hash'}->{'no'} ],
	   [ '', $self->{'text_hash'}->{'default'} ] ];

# Hostname options
$self->{'use_fqdn'} = $self->find_value("use_fqdn", $self->{'options'}->{'members'});
print $self->ui_table_row($self->{'text_hash'}->{'options_use_fqdn'},
	  	    $self->ui_radio("use_fqdn", $self->{'use_fqdn'}, $self->{'yesno'}));

$self->{'check_hostname'} = $self->find_value("check_hostname", $self->{'options'}->{'members'});
print $self->ui_table_row($self->{'text_hash'}->{'options_check_hostname'},
	  	    $self->ui_radio("check_hostname", $self->{'check_hostname'}, $self->{'yesno'}));

$self->{'keep_hostname'} = $self->find_value("keep_hostname", $self->{'options'}->{'members'});
print $self->ui_table_row($self->{'text_hash'}->{'options_keep_hostname'},
	  	    $self->ui_radio("keep_hostname", $self->{'keep_hostname'}, $self->{'yesno'}));

$self->{'chain_hostnames'} = $self->find_value("chain_hostnames", $self->{'options'}->{'members'});
print $self->ui_table_row($self->{'text_hash'}->{'options_chain_hostnames'},
	  	    $self->ui_radio("chain_hostnames", $self->{'chain_hostnames'}, $self->{'yesno'}));

$self->{'bad_hostname'} = $self->find_value("bad_hostname", $self->{'options'}->{'members'});
print $self->ui_table_row($self->{'text_hash'}->{'options_bad_hostname'},
    $self->ui_opt_textbox("bad_hostname", $self->{'bad_hostname'}, 30, $self->{'text_hash'}->{'source_none'}));

print $self->ui_table_hr();

# DNS-related options
$self->{'use_dns'} = $self->find_value("use_dns", $self->{'options'}->{'members'});
print $self->ui_table_row($self->{'text_hash'}->{'options_use_dns'},
	  	    $self->ui_radio("use_dns", $self->{'use_dns'}, $self->{'yesno'}));

$self->{'dns_cache'} = $self->find_value("dns_cache", $self->{'options'}->{'members'});
print $self->ui_table_row($self->{'text_hash'}->{'options_dns_cache'},
	  	    $self->ui_radio("dns_cache", $self->{'dns_cache'}, $self->{'yesno'}));

$self->{'dns_cache_size'} = $self->find_value("dns_cache_size", $self->{'options'}->{'members'});
print $self->ui_table_row($self->{'text_hash'}->{'options_dns_cache_size'},
    $self->ui_opt_textbox("dns_cache_size", $self->{'dns_cache_size'}, 6, $self->{'text_hash'}->{'default'}).
    " ".$self->{'text_hash'}->{'options_entries'});

$self->{'dns_cache_expire'} = $self->find_value("dns_cache_expire", $self->{'options'}->{'members'});
print $self->ui_table_row($self->{'text_hash'}->{'options_dns_cache_expire'},
   $self->ui_opt_textbox("dns_cache_expire", $self->{'dns_cache_expire'}, 6, $self->{'text_hash'}->{'default'}).
   " ".$self->{'text_hash'}->{'options_secs'});

$self->{'dns_cache_expire_failed'} = $self->find_value("dns_cache_expire_failed", $self->{'options'}->{'members'});
print $self->ui_table_row($self->{'text_hash'}->{'options_dns_cache_expire_failed'},
   $self->ui_opt_textbox("dns_cache_expire_failed", $self->{'dns_cache_expire_failed'}, 6, $self->{'text_hash'}->{'default'})." ".$self->{'text_hash'}->{'options_secs'});

print $self->ui_table_hr();

# File and directory permission options
$self->{'owner'} = $self->find_value("owner", $self->{'options'}->{'members'});
print $self->ui_table_row($self->{'text_hash'}->{'options_owner'},
      $self->ui_opt_textbox("owner", $self->{'owner'}, 13, $self->{'text_hash'}->{'default'})." ".
      $self->user_chooser_button("owner"));

$self->{'group'} = $self->find_value("group", $self->{'options'}->{'members'});
print $self->ui_table_row($self->{'text_hash'}->{'options_group'},
      $self->ui_opt_textbox("group", $self->{'group'}, 13, $self->{'text_hash'}->{'default'})." ".
      $self->user_chooser_button("group"));

$self->{'perm'} = $self->find_value("perm", $self->{'options'}->{'members'});
print $self->ui_table_row($self->{'text_hash'}->{'options_perm'},
      $self->ui_opt_textbox("perm", $self->{'perm'}, 13, $self->{'text_hash'}->{'default'}));

$self->{'create_dirs'} = $self->find_value("create_dirs", $self->{'options'}->{'members'});
print $self->ui_table_row($self->{'text_hash'}->{'options_create_dirs'},
	  	    $self->ui_radio("create_dirs", $self->{'create_dirs'}, $self->{'yesno'}));

$self->{'dir_owner'} = $self->find_value("dir_owner", $self->{'options'}->{'members'});
print $self->ui_table_row($self->{'text_hash'}->{'options_dir_owner'},
      $self->ui_opt_textbox("dir_owner", $self->{'dir_owner'}, 13, $self->{'text_hash'}->{'default'})." ".
      $self->user_chooser_button("dir_owner"));

$self->{'dir_group'} = $self->find_value("dir_group", $self->{'options'}->{'members'});
print $self->ui_table_row($self->{'text_hash'}->{'options_dir_group'},
      $self->ui_opt_textbox("dir_group", $self->{'dir_group'}, 13, $self->{'text_hash'}->{'default'})." ".
      $self->user_chooser_button("dir_group"));

$self->{'dir_perm'} = $self->find_value("dir_perm", $self->{'options'}->{'members'});
print $self->ui_table_row($self->{'text_hash'}->{'options_dir_perm'},
      $self->ui_opt_textbox("dir_perm", $self->{'dir_perm'}, 13, $self->{'text_hash'}->{'default'}));

print $self->ui_table_hr();

# Other misc options
$self->{'time_reopen'} = $self->find_value("time_reopen", $self->{'options'}->{'members'});
print $self->ui_table_row($self->{'text_hash'}->{'options_time_reopen'},
      $self->ui_opt_textbox("time_reopen", $self->{'time_reopen'}, 6, $self->{'text_hash'}->{'default'}." (60)").
      " ".$self->{'text_hash'}->{'options_secs'});

$self->{'time_reap'} = $self->find_value("time_reap", $self->{'options'}->{'members'});
print $self->ui_table_row($self->{'text_hash'}->{'options_time_reap'},
      $self->ui_opt_textbox("time_reap", $self->{'time_reap'}, 6, $self->{'text_hash'}->{'default'}." (60)").
      " ".$self->{'text_hash'}->{'options_secs'});

$self->{'sync'} = $self->find_value("sync", $self->{'options'}->{'members'});
print $self->ui_table_row($self->{'text_hash'}->{'options_sync'},
      $self->ui_opt_textbox("sync", $self->{'sync'}, 6, $self->{'text_hash'}->{'default'}));

$self->{'stats'} = $self->find_value("stats", $self->{'options'}->{'members'});
print $self->ui_table_row($self->{'text_hash'}->{'options_stats'},
      $self->ui_opt_textbox("stats", $self->{'stats'}, 6, $self->{'text_hash'}->{'default'}." (600)").
      " ".$self->{'text_hash'}->{'options_secs'});

$self->{'log_fifo_size'} = $self->find_value("log_fifo_size", $self->{'options'}->{'members'});
print $self->ui_table_row($self->{'text_hash'}->{'options_log_fifo_size'},
      $self->ui_opt_textbox("log_fifo_size", $self->{'log_fifo_size'}, 6,
		      $self->{'text_hash'}->{'default'}." (100)"));

$self->{'use_time_recvd'} = $self->find_value("use_time_recvd", $self->{'options'}->{'members'});
print $self->ui_table_row($self->{'text_hash'}->{'options_use_time_recvd'},
	  	    $self->ui_radio("use_time_recvd", $self->{'use_time_recvd'}, $self->{'yesno'}));

$self->{'log_msg_size'} = $self->find_value("log_msg_size", $self->{'options'}->{'members'});
print $self->ui_table_row($self->{'text_hash'}->{'options_log_msg_size'},
      $self->ui_opt_textbox("log_msg_size", $self->{'log_msg_size'}, 6,
		      $self->{'text_hash'}->{'default'}." (2048)")." bytes");

$self->{'sanitize_filenames'} = $self->find_value("sanitize_filenames", $self->{'options'}->{'members'});
print $self->ui_table_row($self->{'text_hash'}->{'options_sanitize_filenames'},
		  $self->ui_radio("sanitize_filenames", $self->{'sanitize_filenames'}, $self->{'yesno'}));

print $self->ui_table_end();
print $self->ui_form_end([ [ "save", $self->{'text_hash'}->{'save'} ] ]);

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
1;
		
}


1;

