#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Create, update or delete a log target

&ModuleLoader::preload_module('syslog_ng_class', "syslog_ng::SyslogngLib");
$self = new syslog_ng::SyslogngLib:: 'syslog_ng_class',%$self;

$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'log_err'});

# Get the old log
$self->{'conf'} = $self->get_config();
if (!$self->{'in_hash'}->{'new'}) {
	@{$self->{'logs_array'}} = $self->find("log", $self->{'conf'});
	($self->{'log'}) = grep { $_->{'index'} == $self->{'in_hash'}->{'idx'} } @{$self->{'logs_array'}};
	$self->{'log'} || $self->error($self->{'text_hash'}->{'log_egone'});
	$self->{'old'} = $self->{'log'};
	}
else {
	$self->{'log'} = { 'name' => 'log',
		  'type' => 1,
		  'members' => [ ] };
	}

$self->lock_file($self->{'config_hash'}->{'syslogng_conf'});
if ($self->{'in_hash'}->{'delete'}) {
	# Just delete it!
	$self->save_directive($self->{'conf'}, undef, $self->{'log'}, undef, 0);
	}
else {
	# Save sources
	@{$self->{'oldsources_array'}} = $self->find("source", $self->{'log'}->{'members'});
	foreach $s (split(/\0/, $self->{'in_hash'}->{'source'})) {
		push(@{$self->{'newsources_array'}}, { 'name' => 'source',
				    'type' => 0,
				    'values' => [ $s ] });
		}
	@{$self->{'newsources_array'}} || $self->error($self->{'text_hash'}->{'log_esource'});
	$self->save_multiple_directives($self->{'conf'}, $self->{'log'}, \@{$self->{'oldsources_array'}}, \@{$self->{'newsources_array'}}, 1);

	# Save filters
	@{$self->{'oldfilters_array'}} = $self->find("filter", $self->{'log'}->{'members'});
	foreach $s (split(/\0/, $self->{'in_hash'}->{'filter'})) {
		push(@{$self->{'newfilters_array'}}, { 'name' => 'filter',
				    'type' => 0,
				    'values' => [ $s ] });
		}
	$self->save_multiple_directives($self->{'conf'}, $self->{'log'}, \@{$self->{'oldfilters_array'}}, \@{$self->{'newfilters_array'}}, 1);

	# Save destinations
	@{$self->{'olddestinations_array'}} = $self->find("destination", $self->{'log'}->{'members'});
	foreach $s (split(/\0/, $self->{'in_hash'}->{'destination'})) {
		push(@{$self->{'newdestinations_array'}}, { 'name' => 'destination',
				    'type' => 0,
				    'values' => [ $s ] });
		}
	$self->save_multiple_directives($self->{'conf'}, $self->{'log'}, \@{$self->{'olddestinations_array'}}, \@{$self->{'newdestinations_array'}}, 1);

	# Save flags
	@{$self->{'flags_array'}} = ( );
	foreach $f (@{$self->{'log_flags_array'}}) {
		if ($self->{'in_hash'}->{$f}) {
			push(@{$self->{'flags_array'}}, $f, ",");
			}
		}
	$self->{'fdir'} = undef;
	if (@{$self->{'flags_array'}}) {
		pop(@{$self->{'flags_array'}});  # remove last ,
		$self->{'fdir'} = { 'name' => 'flags',
			  'type' => 0,
			  'values' => \@{$self->{'flags_array'}} };
		}
	$self->save_directive($self->{'conf'}, $self->{'log'}, 'flags', $self->{'fdir'}, 1);

	# Actually update the object
	$self->save_directive($self->{'conf'}, undef, $self->{'old'}, $self->{'log'}, 0);
	}

$self->unlock_file($self->{'config_hash'}->{'syslogng_conf'});
$self->webmin_log($self->{'in_hash'}->{'delete'} ? 'delete' : $self->{'in_hash'}->{'new'} ? 'create' : 'modify',
	    'log');
$self->redirect("list_logs.cgi");

1;
		
}


1;

