#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Update global options

&ModuleLoader::preload_module('syslog_ng_class', "syslog_ng::SyslogngLib");
$self = new syslog_ng::SyslogngLib:: 'syslog_ng_class',%$self;

$self->ReadParse();
$self->{'conf'} = $self->get_config();
$self->{'options'} = $self->find("options", $self->{'conf'});
$self->{'options'} ||= { 'name' => 'options',
	       'type' => 1,
	       'values' => [ ],
	       'members' => [ ] };
$self->{'mems'} = $self->{'options'}->{'members'};
$self->error_setup($self->{'text_hash'}->{'options_err'});

# Validate and store inputs
&save_yesno_option("use_fqdn");
&save_yesno_option("check_hostname");
&save_yesno_option("keep_hostname");
&save_yesno_option("chain_hostnames");
&save_optional_option("bad_hostname", '\S');

&save_yesno_option("use_dns");
&save_yesno_option("dns_cache");
&save_optional_option("dns_cache_size", '^\d+$');
&save_optional_option("dns_cache_expire", '^\d+$');
&save_optional_option("dns_cache_expire_failed", '^\d+$');

&save_optional_option("owner", '\S');
&save_optional_option("group", '\S');
&save_optional_option("perm", '^[0-7]+$');
&save_yesno_option("create_dirs");
&save_optional_option("dir_owner", '\S');
&save_optional_option("dir_group", '\S');
&save_optional_option("dir_perm", '^[0-7]+$');

&save_optional_option("time_reopen", '^\d+$');
&save_optional_option("time_reap", '^\d+$');
&save_optional_option("sync", '^\d+$');
&save_optional_option("stats", '^\d+$');
&save_optional_option("log_fifo_size", '^\d+$');
&save_yesno_option("use_time_recvd");
&save_optional_option("log_msg_size", '^\d+$');
&save_yesno_option("sanitize_filenames");

# Write out options section
$self->lock_file($self->{'config_hash'}->{'syslogng_conf'});
$self->save_directive($self->{'conf'}, undef, "options", $self->{'options'}, 0);
$self->unlock_file($self->{'config_hash'}->{'syslogng_conf'});
$self->webmin_log("options");

$self->redirect("");

1;
		
}

sub save_yesno_option
{
	shift if ($self == $_[0]);

local ($name) = @_;
local $dir = $self->{'in_hash'}->{$name} ?
	{ 'name' => $name,
	  'type' => 0,
	  'values' => [ $self->{'in_hash'}->{$name} ] } : undef;
$self->save_directive($self->{'conf'}, $self->{'options'}, $name, $dir, 1);
}

sub save_optional_option
{
	shift if ($self == $_[0]);

local ($name, $re) = @_;
if ($self->{'in_hash'}->{$name."_def"}) {
	$self->save_directive($self->{'conf'}, $self->{'options'}, $name, undef, 1);
	}
else {
	!$re || $self->{'in_hash'}->{$name} =~ /$re/ || $self->error($self->{'text_hash'}->{'options_e'.$name});
	local $dir = { 'name' => $name,
		       'type' => 0,
		       'values' => [ $self->{'in_hash'}->{$name} ] };
	$self->save_directive($self->{'conf'}, $self->{'options'}, $name, $dir, 1);
	}
}


1;

