#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Show a log file

&ModuleLoader::preload_module('syslog_ng_class', "syslog_ng::SyslogngLib");
$self = new syslog_ng::SyslogngLib:: 'syslog_ng_class',%$self;

$self->ReadParse();
$self->foreign_require("proc", "proc-lib.pl");

# Work out the file
$self->{'conf'} = $self->get_config();
if ($self->{'in_hash'}->{'dest'}) {
	# From a destination
	@{$self->{'dests_array'}} = $self->find("destination", $self->{'conf'});
	($self->{'dest'}) = grep { $_->{'value'} eq $self->{'in_hash'}->{'dest'} } @{$self->{'dests_array'}};
	$self->{'dest'} || $self->error($self->{'text_hash'}->{'destination_egone'});
	$self->{'file'} = $self->find_value("file", $self->{'dest'}->{'members'});
	}
elsif ($self->{'in_hash'}->{'omod'}) {
	# From another module
	@{$self->{'others_array'}} = $self->get_other_module_logs($self->{'in_hash'}->{'omod'});
	($self->{'other'}) = grep { $_->{'mindex'} == $self->{'in_hash'}->{'oidx'} } @{$self->{'others_array'}};
	if ($self->{'other'}->{'file'}) {
		$self->{'file'} = $self->{'other'}->{'file'};
		}
	else {
		$self->{'cmd'} = $self->{'other'}->{'cmd'};
		}
	}

print "Refresh: $self->{'config_hash'}->{'refresh'}\r\n"
	if ($self->{'config_hash'}->{'refresh'});
$self->ui_print_header("<tt>".($self->{'file'} || $self->{'cmd'})."</tt>", $self->{'text_hash'}->{'view_title'}, "");

$self->{'lines'} = $self->{'in_hash'}->{'lines'} ? int($self->{'in_hash'}->{'lines'}) : $self->{'config_hash'}->{'lines'};
$self->{'filter'} = $self->{'in_hash'}->{'filter'} ? quotemeta($self->{'in_hash'}->{'filter'}) : "";

&filter_form();

$| = 1;
print "<pre>";
local $tailcmd = $self->{'config_hash'}->{'tail_cmd'} || "tail -n LINES";
$tailcmd =~ s/LINES/$self->{'lines'}/g;
if ($self->{'filter'} ne "") {
	# Are we supposed to filter anything? Then use grep.
	local @cats;
	if ($self->{'cmd'}) {
		push(@cats, $self->{'cmd'});
		}
	elsif ($self->{'config_hash'}->{'compressed'}) {
		# All compressed versions
		foreach $l ($self->all_log_files($self->{'file'})) {
			$self->{'c'} = $self->catter_command($l);
			push(@cats, $self->{'c'}) if ($self->{'c'});
			}
		}
	else {
		# Just the one log
		@cats = ( "cat ".quotemeta($self->{'file'}) );
		}
	$self->{'cat'} = "(".join(" ; ", @cats).")";
	$self->{'got'} = $self->foreign_call("proc", "safe_process_exec",
		"$self->{'cat'} | grep -i $self->{'filter'} | $tailcmd",
		0, 0, STDOUT, undef, 1);
	}
else {
	# Not filtering .. so cat the most recent non-empty file
	if ($self->{'cmd'}) {
		$self->{'catter'} = $self->{'cmd'};
		}
	else {
		$self->{'catter'} = "cat ".quotemeta($self->{'file'});
		if (!-s $self->{'file'} && $self->{'config_hash'}->{'compressed'}) {
			foreach $l ($self->all_log_files($self->{'file'})) {
				next if (!-s $l);
				$self->{'c'} = $self->catter_command($l);
				if ($self->{'c'}) {
					$self->{'catter'} = $self->{'c'};
					last;
					}
				}
			}
		}
	$self->{'got'} = $self->foreign_call("proc", "safe_process_exec",
		$self->{'catter'}." | $tailcmd", 
		0, 0, STDOUT, undef, 1);
	}
print "<i>$self->{'text_hash'}->{'view_empty'}</i>\n" if (!$self->{'got'});
print "</pre>\n";
&filter_form();

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}

sub filter_form
{
	shift if ($self == $_[0]);

print "<form action=view_log.cgi style='margin-left:1em'>\n";
print $self->ui_hidden("dest", $self->{'in_hash'}->{'dest'}),"\n";
print $self->ui_hidden("oidx", $self->{'in_hash'}->{'oidx'}),"\n";
print $self->ui_hidden("omod", $self->{'in_hash'}->{'omod'}),"\n";

print $self->text('view_header', $self->ui_textbox("lines", $self->{'lines'}, 3),
	    "<tt>".$self->html_escape($self->{'log'}->{'file'})."</tt>"),"\n";
print "&nbsp;&nbsp;\n";
print $self->text('view_filter', $self->ui_textbox("filter", $self->{'in_hash'}->{'filter'}, 25)),"\n";
print "&nbsp;&nbsp;\n";
print "<input type=submit value='$self->{'text_hash'}->{'view_refresh'}'></form>\n";
}


1;

