#!/usr/bin/perl

&MAIN();

 sub MAIN {
# index.cgi
# Display the telnet applet

&ModuleLoader::preload_module('telnet_class', "WebLib");
$self = new WebLib:: 'telnet_class',%$self;

use Socket;
$self->init_config();
&ModuleLoader::preload_module('telnet_class', "UiLib");
$self = new UiLib:: 'telnet_class',%$self;

$self->{'theme_no_table'} = 1 if ($self->{'config_hash'}->{'sizemode'} == 1);
$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", undef, 1, 1);

if ($ENV{'HTTPS'} eq 'ON' && !$self->{'config_hash'}->{'mode'}) {
	print "<center><font color=#ff0000>$self->{'text_hash'}->{'index_warn'}",
	      "</font></center><br>\n";
	}

# Work out real host and port
$self->{'addr'} = $self->{'config_hash'}->{'host'} || $ENV{'SERVER_NAME'} ||
	$self->to_ipaddress($self->get_system_hostname());
$self->{'port'} = $self->{'config_hash'}->{'port'} ? $self->{'config_hash'}->{'port'} :
	$self->{'config_hash'}->{'mode'} ? 22 : 23;

if ($self->{'config_hash'}->{'no_test'}) {
	# Just assume that the telnet server is running
	$self->{'rv'} = 1;
	}
else {
	# Check if the telnet server is running
	if (inet_aton($self->{'addr'})) {
		socket(STEST, PF_INET, SOCK_STREAM, getprotobyname("tcp"));
		$SIG{ALRM} = "connect_timeout";
		alarm(10);
		$self->{'rv'} = connect(STEST, pack_sockaddr_in($self->{'port'}, inet_aton($self->{'addr'})));
		close(STEST);
		}
	}
if (!$self->{'rv'}) {
	# Not running! Show an error
	if (inet_aton($self->{'addr'})) {
		print "<p>",$self->text(
			$self->{'config_hash'}->{'mode'} ? 'index_esocket2' : 'index_esocket',
			$self->{'addr'}, $self->{'port'}),"<p>\n";
		}
	else {
		print "<p>",$self->text('index_elookup', $self->{'addr'}),"<p>\n";
		}
	}
else {
	# If the host is not local, start up a proxy sub-process
	if ($self->{'config_hash'}->{'proxy'}) {
		# Allocate a free port
		$self->get_miniserv_config(\%{$self->{'miniserv_hash'}});
		$self->{'proxyport'} = $self->{'miniserv_hash'}->{'port'} + 1;
		$self->{'err'} = &allocate_socket(MAIN, \$self->{'proxyport'});
		$self->error($self->{'err'}) if ($self->{'err'});

		# Connect to the destination
		$self->open_socket($self->{'addr'}, $self->{'port'}, CONN);

		# Forward traffic in sub-process
		if (!($self->{'pid'} = fork())) {
			# Accept the connection (for up to 60 secs)
			$self->{'rmask'} = undef;
			vec($self->{'rmask'}, fileno(MAIN), 1) = 1;
			$self->{'sel'} = select($self->{'rmask'}, undef, undef, 60);
			$self->{'sel'} >= 0 || die "no connection after 60 seconds";
			$self->{'acptaddr'} = accept(SOCK, MAIN);
			$self->{'acptaddr'} || die "accept failed?!";
			close(MAIN);

			untie(*STDIN);
			untie(*STDOUT);
			#untie(*STDERR);
			close(STDIN);
			close(STDOUT);
			#close(STDERR);

			# Forward traffic in and out
			select(CONN); $| = 1;
			select(SOCK); $| = 1;
			while(1) {
				$self->{'rmask'} = undef;
				vec($self->{'rmask'}, fileno(SOCK), 1) = 1;
				vec($self->{'rmask'}, fileno(CONN), 1) = 1;
				$self->{'sel'} = select($self->{'rmask'}, undef, undef, undef);

				if (vec($self->{'rmask'}, fileno(SOCK), 1)) {
					# Read from applet, send to server
					$self->{'got'} = sysread(SOCK, $self->{'buf'}, 1024);
					$self->{'got'} > 0 || last;
					syswrite(CONN, $self->{'buf'}, $self->{'got'});
					}

				if (vec($self->{'rmask'}, fileno(CONN), 1)) {
					# Read from applet, send to server
					$self->{'got'} = sysread(CONN, $self->{'buf'}, 1024);
					$self->{'got'} > 0 || last;
					syswrite(SOCK, $self->{'buf'}, $self->{'got'});
					}
				}
			print STDERR "exited read loop\n";
			exit(0);
			}

		$SIG{'CHLD'} = \&child_reaper;
		close(CONN);
		close(MAIN);

		# Force applet to connect to proxy
		$self->{'config_hash'}->{'port'} = $self->{'proxyport'};
		delete($self->{'config_hash'}->{'host'});
		}

	# Output the applet
	print "<center>\n";
	if ($self->{'config_hash'}->{'detach'}) {
		$self->{'w'} = 100; $self->{'h'} = 50;
		}
	elsif ($self->{'config_hash'}->{'sizemode'} == 2 &&
	    $self->{'config_hash'}->{'size'} =~ /^(\d+)\s*x\s*(\d+)$/) {
		$self->{'w'} = $1; $self->{'h'} = $2;
		}
	elsif ($self->{'config_hash'}->{'sizemode'} == 1) {
		$self->{'w'} = "100%"; $self->{'h'} = "80%";
		}
	else {
		$self->{'w'} = 590; $self->{'h'} = 360;
		}
	$self->{'jar'} = $self->{'config_hash'}->{'applet'} ? "jta25.jar" : "jta20.jar";
	print "<applet archive=\"$self->{'jar'}\" code=de.mud.jta.Applet ",
	      "width=$self->{'w'} height=$self->{'h'}>\n";
	printf "<param name=config value=%s>\n",
		$self->{'config_hash'}->{'mode'} ? "ssh.conf" : "telnet.conf";
	if ($self->{'config_hash'}->{'port'}) {
		print "<param name=Socket.port value=$self->{'config_hash'}->{'port'}>\n";
		}
	if ($self->{'config_hash'}->{'host'}) {
		print "<param name=Socket.host value=$self->{'config_hash'}->{'host'}>\n";
		}
	elsif ($self->{'config_hash'}->{'applet'}) {
		print "<param name=Socket.host value=$ENV{'SERVER_NAME'}>\n";
		}
	if ($self->{'config_hash'}->{'script'}) {
		print "<param name=Script.script value='$self->{'config_hash'}->{'script'}'>\n";
		}
	if ($self->{'config_hash'}->{'sizemode'}) {
		print "<param name=Terminal.resize value='screen'>\n";
		}
	if ($self->{'config_hash'}->{'fontsize'}) {
		print "<param name=Terminal.fontSize value='$self->{'config_hash'}->{'fontsize'}'>\n";
		}
	if ($self->{'config_hash'}->{'detach'}) {
		print "<param name=Applet.detach value='true'>\n";
		print "<param name=Applet.detach.stopText value='Disconnect'>\n";
		}
	print "$self->{'text_hash'}->{'index_nojava'} <p>\n";
	print "</applet><br>\n";

	print $self->text('index_credits',
		    "http://www.mud.de/se/jta/"),"<br>\n";
	if ($self->{'config_hash'}->{'mode'}) {
		print $self->text('index_sshcredits',
			    "http://www.systemics.com/docs/cryptix/"),"<br>\n";
		}
	print "</center>\n";
	}

$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});

1;
		
}

sub connect_timeout
{
	shift if ($self == $_[0]);

}

# allocate_socket(handle, &port)
sub allocate_socket
{
	shift if ($self == $_[0]);

local ($fh, $port) = @_;
local $proto = getprotobyname('tcp');
if (!socket($fh, PF_INET, SOCK_STREAM, $proto)) {
	return "socket failed : $!";
	}
setsockopt($fh, SOL_SOCKET, SO_REUSEADDR, pack("l", 1));
while(1) {
	$$port++;
	last if (bind($fh, sockaddr_in($$port, INADDR_ANY)));
	}
listen($fh, SOMAXCONN);
return undef;
}

sub child_reaper
{
	shift if ($self == $_[0]);

local $xp;
do {
	$xp = waitpid(-1, WNOHANG);
	} while($xp > 0);
}


1;

