%modules_conf = (
'acl' => [],
'adsl-client' => ['K:pppoe', 'K:adsl-start'],
'apache' => ['D:httpd_dir', 'X:httpd_path'],
'at' => ['K:at', 'D:at_dir'],
'amavis' => ['R:amavisd_cmd'],
'backup-config' => [],
'bandwidth' => [],
'bind8' => ['X:named_path'],
'bsdexports' => [],
'cpan' => [],
'cpplus' => [],
'cppluslog' => [],
'cron' => ['D:cron_dir', 'K:crontab'],
'custom' => [],
'cyrus-sasl' => ['X:saslauthd_cmd'],
'clamav' => ['R:clamav_cmd'],
'courier-imap' => ['X:pop3_daemon'],
'dovecot' => ['C:dovecot_config', 'R:dovecot'],
'dg' => ['X:dansguardian_cmd'],
'dhcpd' => ['C:dhcpd_conf', 'R:dhcpd_path'],
'dfsadmin' => [],
'enduser_cf' => ['D:usermin_dir'],
'exports' => ['R:nfs_server'],
'fdisk' => [],
'fetchmail' => ['R:fetchmail_path'],
'file' => [],
'firewall' => ['K:iptables'],
'format' => [],
'frox' => ['C:frox_conf', 'R:frox'],
'fsdump' => [],
'grub' => ['C:menu_file', 'X:grub_path'],
'home' => [],
'hpuxexports' => [],
'htaccess-htpasswd' => ['K:htdigest'],
'idmapd' => ['X:idmapd_path'],
'inetd' => [],
'init' => [], #'D:init_base'
'inittab' => ['C:inittab_file'],
'ipfilter' => ['C:ipf', 'C:ipfilter'],
'ipfw' => ['R:ipfw'],
'ipsec' => ['R:ipsec', 'C:file'],
'jabber' => ['C:jabber_config', 'D:jabber_dir'],
'jakarta-tomcat' => ['D:java_home','D:tomcat_home','X:tomcat_cmd'],
'krb5' => ['C:krb5_conf'],
'ldap-useradmin' => ['C:auth_ldap'],
'lilo' => ['C:lilo_conf', 'R:lilo_cmd'],
'logrotate' => ['C:logrotate_conf', 'R:logrotate'],
'lpadmin' => [],
'lvm' => ['K:vgdisplay'],
'mailboxes' => [],
'mailcap' => ['C:mailcap'],
'mailman' => ['C:mailman_conf'],
'majordomo' => ['C:majordomo_cf', 'D:program_dir'],
'man' => [],
'mon' => ['C:cfbasedir'],
'mount' => ['C:fstab_file'],
'mysql' => ['X:mysqladmin', 'X:mysql'],
'net' => [],
'nis' => [],
'openslp' => ['X:slpd'],
'pam' => ['D:pam_dir'],
'pap' => ['R:mgetty'],
'passwd' => [],
'phpini' => ['M:apache'],
'plugins' => ['M:apache'],
'postfix' => ['X:postfix_control_command'],
'postgresql' => ['X:psql', 'C:hba_conf'],
'ppp-client' => ['K:pppd', 'K:mgetty'],
'pptp-client' => ['R:pptp'],
'pptp-server' => ['R:pptpd'],
'proc' => [],
'procmail' => ['R:procmail'],
'proftpd' => ['X:proftpd_path', 'C:proftpd_conf'],
'pserver' => ['D:cvsroot'],
'qmailadmin' => ['D:qmail_dir'],
'quota' => ['K:quota'],
'raid' => ['C:mdstat', 'K:mdadm'],
'rbac' =>['C:user_attr', 'C:prof_attr', 'C:auth_attr', 'C:exec_attr', 'C:policy_conf', 'C:project'],
'samba' => ['X:samba_server'],
'sarg' => ['C:sarg_conf', 'R:sarg'],
'sendmail' => ['X:sendmail_path', 'S:sendmail_cf'],
'sentry' => ['R:portsentry', 'R:hostsentry', 'R:logcheck'],
'sgiexports' => [],
'shell' => [],
'shorewall' => ['R:shorewall', 'D:config_dir'],
'smart-status' => [],
'software' => [],
'spam' => ['R:spamassassin'],
'squid' => ['C:squid_conf', 'R:squid_path'],
'sshd' => ['C:sshd_config', 'R:sshd_path'],
'status' => [],
'stunnel' => ['X:stunnel_path'],
'swup' => ['C:swup_conf', 'X:swup_path'],
'syslog' => ['C:syslog_conf'],
'syslog-ng' => ['K:syslog-ng'],
'telnet' => [],
'time' => [],
'tunnel' => [],
'updown' => [],
'useradmin' => [],
'virtual-server' => [],
'vsftpd' => ['C:vsftpd_conf', 'X:vsftpd_cmd'],
'webalizer' => ['R:webalizer'],
'wuftpd' => ['X:ftpd_path', 'C:ftpaccess'],
'xinetd' => ['C:xinetd_conf'],
'zones' => ['K:zoneadm'],
);

# &configured($module_name);
sub configured {
	return 1 unless $_[0];
	my $mod = $_[0];
	$mod =~ s/\-/\_/g unless -r "$config_directory/$mod/config";
	my ($mod_name, $rv) = ($mod, 1);
	my %minfo = &get_module_info($mod_name);
	return 0 unless &check_os_support(\%minfo);
	foreach my $cmd (@{$modules_conf{$mod_name}}) {
		my ($type, $check) = split (/:/, $cmd);
		my %config = ();
		&read_file("$config_directory/$mod_name/config", \%config);

		if    ($type =~ /^X/) { $rv = ( -x $config{$check} ); }
		elsif ($type =~ /^C/) { $rv = ( -r $config{$check} ); }
		elsif ($type =~ /^D/) { $rv = ( -d $config{$check} ); }
		elsif ($type =~ /^S/) { $rv = ( -s $config{$check} ); }
		elsif ($type =~ /^K/) 
		{ 
		 delete $main::has_command_cache{$check};
		 $rv = &has_command($check); 
		}
		elsif ($type =~ /^R/) 
		{ 
		 delete $main::has_command_cache{$config{$check}};
		 $rv = &has_command($config{$check}); 
		}
		elsif ($type =~ /^M/) 
		{ 
		 delete $main::has_command_cache{$config{$check}};
		 $rv = &configured($check); 
		}

		return 0 unless $rv;
		#else { return 1; }
	}
	return $rv;
}

# &check_plugins()
# return 1 if some plugins configured
sub check_plugins
{
 &foreign_require('plugins','plugins-lib.pl');
 foreach (@plugins::plugin_list)
 {
  if ($plugins::config{"configured_$_"})
  {
   # check plugin depends
   my $func = $_."_depends";
	my $dep = &foreign_call('plugins',$func);
	my $nodeps;
   foreach my $i (keys %{$dep})
   {
    $nodeps = 1 if ($dep->{$i}->[0] == 0);
   }
	return 1 unless $nodeps;
  }
 }
 return 0;
}

# &accessable($module_name);
sub accessable {
	local (%hash1, %hash2);
	&read_acl(\%hash1, \%hash2);
	local $mod;
	($mod = $_[0]) =~ s/\-/\_/g;
	local $rv =  $hash1{$remote_user, $_[0]} || $hash1{$remote_user, $mod};
	return $rv ? 1 : 0;
}

sub get_mode_user {
	local $key = 'mode_'.$remote_user;
	return ($gconfig{$key} ? $gconfig{$key} : 0);
}

# check_date_string(date_string)
# Checks string with date: Mmm dd yyyy
sub check_date_string {
	return $_[0] =~ /\s\d\d?\s\d{4}$/;
}

# ui_buttons_row_xpressia(script, icon, button-label, description, [hiddens], [after-submit],
#		 [before-submit]) 
sub ui_buttons_row_xpressia
{
# return &theme_ui_buttons_row(@_) if (defined(&theme_ui_buttons_row));
local ($script, $icon, $label, $desc, $hiddens, $after, $before) = @_;
# return "<form action=$script>\n".
return 
	$hiddens.
	"<tr> <td nowrap width=20%>".($before ? $before." " : "").
	"<a href='$script'><img border=0 src='$icon'>".
	&quote_escape($label).($after ? " ".$after : "")."</td>\n".
	"<td valign=top width=80%>$desc</td> </tr>\n";
}

# --- appliances/servers specific functions ---

# Read the product global config file. 
$gconfig_file = "$config_directory/config";
&read_file_cached($gconfig_file, \%gconfig);

@ztl_appliances = $gconfig{'ztl_mode'} ? ('web', 'mail', 'dns', 'mysql', 'postgres', 'cifs', 'pdc', 'print', 'proxy', 'dhcp', 'firewall') : ('web', 'mail', 'mailman', 'dns', 'ftp', 'mysql', 'postgres', 'ssl', 'quota');
%ztl_appliances_complex = (
    'samba' => ['cifs', 'pdc', 'print'],
    'databases' => ['mysql', 'postgres'],
);

%ztl_apps_depends = (
	'web' => ['apache'],
	'mail' => ['mailboxes'],
	'mailman' => ['mailman'],
	'dns' => ['bind8'],
	'mysql' => ['mysql'],
	'postgres' => ['postgresql'],
	'samba' => ['samba'],
	'proxy' => ['squid'],
	'dhcp' => ['dhcpd'],
	'firewall' => ['firewall'],
);

%ztl_apps_depends_virt = (
	'web' => ['web'],
	'mail' => ['mail'],
	'mailman' => ['mailman'],
	'dns' => ['dns'],
	'mysql' => ['mysql'],
	'postgres' => ['postgres'],
	'cifs' => ['samba'],
	'print' => ['samba'],
	'pdc' => ['samba'],
	'ssl' => ['ssl'],
	'ftp' => ['ftp'],
	'quota' => ['quota'],
);

# return hash with appliances' complain
# &ztl_get_appliances(\%appliances);
sub ztl_get_appliances {
	local $apps = $_[0];
	# loading virtual-server module's config file
	local $mname = 'virtual-server';
	local ($virtsrv_config_directory, $virtsrv_config_file);
	local %virtsrv_config = ();
	$virtsrv_config_directory = "$config_directory/$mname";
	$virtsrv_config_file = "$virtsrv_config_directory/config";
	&read_file_cached($virtsrv_config_file, \%virtsrv_config);
	# checking installed and configured appliances
	local ($a, $d, $v);
	foreach $a (@ztl_appliances, @ztl_features) {
		$apps->{$a}->{'on'} = $gconfig{'ztl_mode'} ? $gconfig{"$a\_app_on"} : 1;
		if ($apps->{$a}->{'on'} && $ztl_apps_depends_virt{$a}) {
			foreach $v (@{$ztl_apps_depends_virt{$a}}) {
				$apps->{$a}->{'on'} = $apps->{$a}->{'on'} && $virtsrv_config{$v};
			}
		}
		if ($apps->{$a}->{'on'} && $ztl_apps_depends{$a}) {
			foreach $d (@{$ztl_apps_depends{$a}}) {
				$apps->{$a}->{'on'} = $apps->{$a}->{'on'} && &configured($d) && &accessable($d);
			}
		}
	}
	foreach $a (keys %ztl_appliances_complex) {
		foreach $d (@{$ztl_appliances_complex{$a}}) {
			$apps->{$a}->{'on'} = $apps->{$a}->{'on'} || $apps->{$d}->{'on'};
		}
	}
}

# &ztl_check_condition(\%appliances, $condition);
sub ztl_check_condition {
	local $apps = $_[0];
	local $condition = $_[1];
	my $a;
	foreach $a (@ztl_appliances, @ztl_features) {
		my $v = $apps->{$a}->{'on'} ? 1 : 0;
		$condition =~ s/\$$a\b/$v/g;
	}
	while ($condition =~ /\$M(\S+)/) {
		my $var = $1;
		my $v = &configured($var) && &accessable($var);
		$condition =~ s/\$M$var\b/$v/g;
	}
	if ($condition =~ /\$P(\S+)/) {
	   # plugin configured ?
		$condition = &check_plugins($var);
	}
	local $rv = eval("$condition");
	return $rv;
}

# &ztl_get_text(\%appliances, text1, [...])
# e.g., &ztl_get_text(\%appliances, "website_backup:$web && $dns", "domain_backup:$dns");
sub ztl_get_text {
	local $apps = shift(@_);
	foreach my $p (@_) {
		next if $p =~ /^#/;
		if ($p =~ /^([^:]+):(.*)$/) {
			my ($label, $cond) = ($1, $2);
			if (&ztl_check_condition($apps, $cond)) {
				return $text{$label};
			}
		}
	}
	return undef;
}

# &ztl_get_text(\%appliances, $text)
sub ztl_get_jointext {
	local $apps = shift(@_);
	local @texts = split(';', shift(@_));
	return &ztl_get_text($apps, @texts);
}

sub ztl_get_uptime {
	local $uptime_cmd = '/usr/bin/uptime';
	return '' unless -e $uptime_cmd;
	local $result;
	local $rv = `$uptime_cmd`;
	$rv =~ m/up\s+(.*?),[^,]*?user/i;
	( $result = $1 ) =~ tr/,//d;
	return $result;
}

# &get_access_level ($username)
# returns access level number or array (access_level, ref domain)
sub ztl_get_access_level {
	my $user = $_[0];
	my (%hash1, %hash2);
	&read_acl(\%hash1, \%hash2);
	if ($hash1{$user, 'useradmin'} && $hash1{$user, 'acl'} && $hash1{$user, 'virtual-server'}) {
		return (wantarray ? (0, undef) : 0);
}
	elsif ($hash1{$user, 'virtual-server'}) {
		return 1 unless (wantarray);
		&foreign_require("virtual-server", "virtual-server-lib.pl");
		my @domains = &foreign_call("virtual-server", "get_domain_by", "user", "$user");
		my ($dom) = grep {!$_->{'parent'}}@domains;
		return (1, $dom);
	}
}

$done_theme_lib_funcs = 1;

1;
1;
