#!/usr/bin/perl

&MAIN();

 sub MAIN {

# Copyright (c) 2005 Positive Software Corporation, a Comodo Group Company
# CP+ / ZTL projects
#
# Shows information panel
# 
# $Id: showinfo.cgi,v 1.15 2007/03/16 16:13:57 vadim Exp $
#

&ModuleLoader::preload_module('theme_xpressia_class', "WebLib");
$self = new WebLib:: 'theme_xpressia_class',%$self;


$self->{'reload_interval'} = 120000;

$self->init_config();

$self->{'product'}   = $self->{'text_hash'}->{'programname'};
$self->{'hostname'}  = $self->get_system_hostname();
$self->{'ver'}       = $self->get_webmin_version();
$self->{'uptime'}    = $self->ztl_get_uptime();
$self->{'username'}  = $ENV{'REMOTE_USER'};
$self->{'ipaddress'} = $ENV{'REMOTE_ADDR'};
$self->{'time'}      = localtime();

if ( $self->{'gconfig_hash'}->{'real_os_type'} ) {
	$self->{'ostr'} = "$self->{'gconfig_hash'}->{'real_os_type'} $self->{'gconfig_hash'}->{'real_os_version'}";
}
else {
	$self->{'ostr'} = "$self->{'gconfig_hash'}->{'os_type'} $self->{'gconfig_hash'}->{'os_version'}";
}

local ($img_yes, $img_no, $img_blank, $img_pass) = (
	'<img width=18 height=16 border=0 src="/images/yes.gif">',
	'<img width=18 height=16 border=0 src="/images/no.gif">',
	'<img width=18 height=16 border=0 src="/images/blank.gif">',
	'<img width=16 height=16 border=0 src="/images/ch_pass.gif" align=middle>'
);

$self->ReadParse();

$self->foreign_require("licmanage", "licmanage-lib.pl");
$self->{'lic'} = $main::licmanage_object->get_licinfo();

$self->header();

if ($self->{'lic'}->{'ret'} || !$self->check_date_string($self->{'lic'}->{'d_begin2'}) || !$self->check_date_string($self->{'lic'}->{'d_expire2'})) {
	print <<EOF;
<script language="javascript">
window.onload=window.setTimeout("parent.fail();", $self->{'reload_interval'});
</script>
EOF
	$self->footer();
	exit;
}
else {
	print <<EOF;
<script language="javascript">
window.onload=window.setTimeout("window.location.reload(true);", $self->{'reload_interval'});
</script>
EOF
}

local $system_admin;
local $user_admin;

$self->{'mode_user'} = $self->get_mode_user();
if (exists($self->{'in_hash'}->{mode}) ) {
	if ($self->{'in_hash'}->{'mode'} != $self->{'mode_user'}) {
		$self->{'gconfig_hash'}->{'mode_'.$self->{'remote_user'}}=$self->{'in_hash'}->{mode};
		$self->lock_file("$self->{'config_directory'}/config");
		$self->write_file("$self->{'config_directory'}/config", \%{$self->{'gconfig_hash'}});
		$self->unlock_file("$self->{'config_directory'}/config");
		$self->{'mode_user'} = $self->{'in_hash'}->{mode};
	}
}
print <<EOF;
<script language="javascript">
	var mode_user=$self->{'mode_user'};
	function mode_value(new_mode)
	{
		if (mode_user != new_mode) {
			parent.info.location.replace('showinfo.cgi?mode='+new_mode);
		}
		if (new_mode == 1) {
			parent.content.location.replace('showcat.cgi');
		} else {
			parent.content.location.replace('/home/index.cgi?noredir=1');
		}
	}
</script>

<table align=center border=0 cellpadding=0 cellspacing=0 width=240 height="100%" class=infofr valign=top>
<tbody><tr><td valign=top>
EOF

$self->foreign_require('virtual_server', 'virtual-server-lib.pl');

local ($ruser_level, $ruser_domain) = $self->ztl_get_access_level($self->{'remote_user'});
local $t_website = $main::virtual_server_object->{'t_website'};

local %mconfig = %{$main::virtual_server_object->{'config_hash'}};
local $quotas_home = $self->{'virtsrv_config_hash'}->{'home_quotas'} ? $self->{'virtsrv_config_hash'}->{'home_quotas'} : '/';

local ($link_usradm, $link_sysadm) = (
	"<a HREF=\"javascript:mode_value(0)\">$self->{'text_hash'}->{'index_mode0'}</a>",
	"<a HREF=\"javascript:mode_value(1)\">$self->{'text_hash'}->{'index_mode1'}</a>"
);

$user_admin = sprintf("<td>%s</td><td>%s</td>", $self->{'mode_user'} ? ($img_no, $link_usradm) : ($img_yes, "<b>$link_usradm</b>"));
$system_admin = sprintf("<td>%s</td><td>%s</td>", $self->{'mode_user'} ? ($img_yes, "<b>$link_sysadm</b>") : ($img_no, $link_sysadm));

local $link_chpass = "$img_pass<a target=content href='/home/edit_passwd.cgi'><b>$self->{'text_hash'}->{'index_chpass'}</b></a>";

$self->{'domain_info'} = {key => "$t_website:", value => $ruser_domain->{'dom'}} if $ruser_domain;

$self->{'access_level'} = "<table cellpadding=0 cellspacing=0><tr>$user_admin$system_admin</tr></table>"
	if $ruser_level == 0;

if ($ruser_level == 1) {
	($self->{'quota'}, $self->{'use_quota'}, $self->{'bw'}, $self->{'bw_limit'}, $self->{'number_mails'}, $self->{'number_ftp'},$self->{'number_smb'}, $self->{'mail_limit'}, $self->{'domscount'}, $self->{'domslimit'},$self->{'number_endusr'}) = &disk_info();
	$self->{'hs_quota'} = defined($self->{'quota'}) ? {key => "$self->{'text_hash'}->{'index_space'}:", value => "<TABLE width=100%><TR><TD width=50%>$self->{'use_quota'}</TD><TD>$self->{'quota'}</TD></TR></TABLE>"} : undef;
	$self->{'bw'} = sprintf ('%0.1f %s', $self->{'bw'}, $self->{'text_hash'}->{'index_mb'});
	$self->{'bw_limit'} =  $self->{'bw_limit'} ? sprintf ('%0.1f %s', $self->{'bw_limit'}, $self->{'text_hash'}->{'index_mb'}) : $self->{'text_hash'}->{'index_unlimited'};
	$self->{'hs_bw'} = defined($self->{'bw'}) ? {key => "$self->{'text_hash'}->{'index_bandwidth'}:", value => "<TABLE width=100%><TR><TD width=50%>$self->{'bw'}</TD><TD>$self->{'bw_limit'}</TD></TR></TABLE>"}: undef;
	}

# User Information group
push (@{$self->{'frames_array'}},
	{
	title => $self->{'text_hash'}->{'index_title_user'},
	data => [
		{key => "$self->{'text_hash'}->{'index_user'}:", value => "$self->{'username'}"},
		{key => "$self->{'text_hash'}->{'index_remoteip'}:", value => "$self->{'ipaddress'}"},
		$self->{'domain_info'},
		{key => '', value => "$link_chpass", colspan => 3},
		]
	}
);

if ($ruser_level == 0) {
	local $uadmin_link = "<table cellpadding=0 cellspacing=0><tr><td>$img_blank</td>$user_admin</tr></table>";
	local $sadmin_link = "<table cellpadding=0 cellspacing=0><tr><td>$img_blank</td>$system_admin</tr></table>";
push (@{$self->{'frames_array'}},
	{
	title => $self->{'text_hash'}->{'index_title_mode'},
	data => [
		{key => '', value => "$uadmin_link", colspan => 3, align => 'left' },
		{key => '', value => "$sadmin_link", colspan => 3, align => 'left' },
		]
	}
);
}

if ($ruser_level == 1) {
#	$self->{'mail_limit'} = $self->{'text_hash'}->{'index_unlimited'} unless (!defined $self->{'mail_limit'});
#	$self->{'domslimit'} = $self->{'text_hash'}->{'index_unlimited'} unless (!defined $self->{'domslimit'});
        local @doms = grep { $main::virtual_server_object->can_edit_domain($_) } $main::virtual_server_object->list_domains();
        local $count_db = map($main::virtual_server_object->domain_databases($_),@doms);
	local $limit_db = $ruser_domain->{'dbslimit'} ? $ruser_domain->{'dbslimit'} : $self->{'text_hash'}->{'index_unlimited'};

	if($ruser_domain->{'samba'} || $self->{'number_smb'}){$self->{'smb_inf'} = {key => "$self->{'text_hash'}->{'index_smb'}:" , value => "<table width=100%><tr><td width=50%>$self->{'number_smb'}</td><td></td></tr></table>"};}
	if($ruser_domain->{'email'} || $self->{'number_mails'}){$self->{'emails_inf'} = {key => "$self->{'text_hash'}->{'index_emails'}:", value => "<table width=100%><tr><td width=50%>$self->{'number_mails'}</td><td></td></tr></table>"};}
	if($mconfig{'ftp'} || $self->{'number_ftp'}){$self->{'ftp_inf'} = {key => "$self->{'text_hash'}->{'index_ftps'}:", value => "<table width=100%><tr><td width=50%>$self->{'number_ftp'}</td><td></td></tr></table>"};	}
        if ($ruser_domain->{'mysql'} || $ruser_domain->{'postgress'}) { $self->{'database_inf'} = {key => "$self->{'text_hash'}->{'index_databases'}:", value => "<table width=100%><tr><td width=50%>$count_db</td><td>$limit_db</td></tr></table>"}; }
	
push (@{$self->{'frames_array'}}, {
	title => $self->text('index_title_website', $t_website),
	data => [
		{key => '', value => "<table width=100%><tr><td width=50%><b>$self->{'text_hash'}->{'index_used'}</b></td><td><b>$self->{'text_hash'}->{'index_max'}</b></td></tr></table>"},
		$self->{'hs_quota'},
		$self->{'hs_bw'},
		{key => "$self->{'text_hash'}->{'index_endusr'}:", value => "<table width=100%><tr><td width=50%>$self->{'number_endusr'}</td><td>$self->{'mail_limit'}</td></tr></table>"},
		$self->{'emails_inf'},
		$self->{'ftp_inf'},
		$self->{'smb_inf'},
		{key => "$self->{'text_hash'}->{'index_subdomains'}:", value => "<table width=100%><tr><td width=50%>$self->{'domscount'}</td><td>$self->{'domslimit'}</td></tr></table>"},
		$self->{'database_inf'},
		]
		}
	);
}

# System Information group
push (@{$self->{'frames_array'}},
	{
	title => $self->{'text_hash'}->{'index_title_system'},
	data => [
		{key => "$self->{'text_hash'}->{'index_os'}:", value => "$self->{'ostr'}"},
		{key => "$self->{'product'} :", value => "$self->{'text_hash'}->{'index_ver'} $self->{'ver'}"},
		{key => "$self->{'text_hash'}->{'index_hostname'}:", value => "$self->{'hostname'}"},
		{key => "$self->{'text_hash'}->{'index_time'}:", value => "$self->{'time'}"},
		{key => "$self->{'text_hash'}->{'index_uptime'}:", value => "$self->{'uptime'}"},
		]
	}
);

# License Information group
if ($ruser_level == 0){
	local %lic_info;
	$lic_info{'title'} = $self->{'text_hash'}->{'index_title_license'};
	if ($self->{'lic'}->{'type'} eq 'key'){
		$lic_info{'data'} = [
			{key => "$self->{'text_hash'}->{'index_lic_status'}:", value => $self->{'lic'}->{'ret'} == 0 ? $self->{'text_hash'}->{'index_lic_valid'} : $self->{'text_hash'}->{'index_lic_invalid'}},
			$self->{'lic'}->{'err'} ? {key => "$self->{'text_hash'}->{'index_lic_expire'}:", value => "<font color=#FF0000>$self->{'lic'}->{'d_expire2'}</font>"} : 0,
			# $self->{'lic'}->{'err'} ? {key => "$self->{'text_hash'}->{'index_lic_desc'}:", value => "<font color=#FF0000>$self->{'lic'}->{'err'}</font>"} : 0
			]
		}
	else {
		$lic_info{'data'} = [
			{key => "$self->{'text_hash'}->{'index_lic_begin'}:", value => "$self->{'lic'}->{'d_begin2'}"},
			{key => "$self->{'text_hash'}->{'index_lic_expire'}:", value => "$self->{'lic'}->{'d_expire2'}"},
			];
		}
	push (@{$self->{'frames_array'}}, \%lic_info);
	}
&drawFrame(@{$self->{'frames_array'}});
print "</td></tr>\n";

# Services List
if ($ruser_level == 0 && $self->UNIVERSAL::can('configured')) {
	$self->foreign_require( "proc", "proc-lib.pl" );
	local @pd = $main::proc_object->list_processes();
	
	local $sys_mon;
	if ($self->{'gconfig_hash'}->{'os_type'} eq 'debian-linux') {
		$sys_mon = 'sys_mon_other.config'; 
		}
	else {
		$sys_mon = 'sys_mon.config';
		}
	
	if ( -e "../theme_xpressia/$sys_mon" ) {
		$self->{'config_path'} = "../theme_xpressia/$sys_mon";
	}
	else {
		$self->{'config_path'} = "./theme_xpressia/$sys_mon";
	}

	open( SYSMON, "< $self->{'config_path'}" );
	local @temp = <SYSMON>;
	close(SYSMON);
	chomp @temp;
	local ($line, $name, $scr_name);
	local ( $label, $link, $cond );
	local %apps = ();
	$self->ztl_get_appliances(\%apps);
	local (%hash, %proc_list, %link_list, %cond_list);
	local @proc_keys = ();

	foreach $line (@temp) {
		( $name,  $scr_name ) = split "=", $line;
		( $label, $link, $cond ) = split ":", $scr_name;
		$link_list{$name} = $link;
		$proc_list{$name} = $label;
		$cond_list{$name} = $cond;
	}

	print "<tr><td>\n";

	print "<table class=infoframe width='100%' align=center border=0 cellspacing=0 cellpadding=2>\n";
	print "<tr><td colspan=3 class=infotitle><img src='/images/arr.png' border=0 align=middle width=16 height=16>&nbsp;$self->{'text_hash'}->{'index_sysmon'}</td></tr>\n";

	@proc_keys = sort keys %proc_list;

	foreach $key (@proc_keys) {
		$self->{'value'} = $proc_list{$key};
		$link  = $link_list{$key};
		$cond  = $cond_list{$key};
		next unless $self->ztl_check_condition(\%apps, $cond);
		#next if !$self->configured( $link, $cats{$link} );
		next if ! -d "$self->{'root_directory'}/$link" || !$self->configured( $link );
		$self->{'status'} = 'off';
		foreach $hash (@pd) {
			local %line = %{$hash};
			if ( $line{"args"} =~ /$key/i ) {
				$self->{'status'} = 'on';
			}
		}
print <<EOF;
    <tr><td>&nbsp;</td>
    <td><img src="images/led_$self->{'status'}.gif" border=0 width=18 height=16></td>
    <td><a class=monlnk href='/$link/' target=content title='$self->{'text_hash'}->{'index_configure_mod'}'>$self->{'value'}</a></td>
    </tr>
EOF

	}
	print "</table>\n";

	print "</td></tr>\n";
	# end of pmon
}

print <<EOF;
<tr><td>
<table class=infoframe width='100%' align=center border=0 cellspacing=0 cellpadding=2 valign=top>
<tr><td class=infotitle><img src="/images/home.gif" border=0 width=16 height=16 align=middle><a href='$self->{'text_hash'}->{'index_mainpage_url'}' target='content'>&nbsp;$self->{'text_hash'}->{'index_mainpage2'}</a></td></tr>
</table></td></tr>
<tr><td height="100%">&nbsp;</td></tr>
</tbody></table>
EOF

$self->footer();

1;
		
}

# drawFrame($title, @args);
sub drawFrame {
	shift if ($self == $_[0]);

	print "<table class=infoframe width='100%' align=center border=0 cellspacing=0 cellpadding=2>\n";
	my ($title, %data);
	foreach $m (@_) {
		($title, @{$self->{'data_array'}}) = ($m->{title}, @{$m->{data}});
		print "<tr><td colspan=3 class=infotitle><img src='/images/arr.png' border=0 align=middle width=16 height=16>&nbsp;$title</td></tr>\n";
		foreach $k (@{$self->{'data_array'}}) {
			next unless $k;
			if (! $k->{colspan}) {
				print "<tr class=smf><td align=right nowrap><b>$k->{key}</></td>";
				print "<td $self->{'param'}>$k->{value}</td></tr>\n";
			} else {
				my $align = $k->{'align'} ? $k->{'align'} : 'center';
	 			print "<tr class=smf><td align='$align' colspan=$k->{colspan} nowrap>$k->{value}</td></tr>\n";
			}
		}
	}
	print "</table>\n";
}

sub disk_info {
	shift if ($self == $_[0]);

	local %domain;
	local $endusr_count = 0;
	local $mail_count = 0;
	local $smb_count = 0;
	local $ftp_count = 1;
	local $ut = 0;
	local ($quota, $bw, $bw_limit) = (0, 0, 0);
	local $mail_limit = 0;
	local $domslimit = 0;
	local $domscount = 0;

	@doms = grep { $main::virtual_server_object->can_edit_domain($_) } $main::virtual_server_object->list_domains();
	foreach my $d (@doms) {
		if (($d->{'user'} eq $self->{'remote_user'})) {
			local @users = $main::virtual_server_object->list_domain_users($d, undef, 0);
			local ($duser) = grep { $_->{'user'} eq $d->{'user'} } @users;
			$ut += $duser->{'uquota'} + $duser->{'umquota'};
			foreach my $u (@users) {
				$smb_count++ if ($u->{'samba'} && $u->{'user'} ne $d->{'user'});
				$mail_count++ if ($u->{'email'} && $u->{'user'} ne $d->{'user'});
				$ftp_count++ if ($u->{'shell'} eq $mconfig{'ftp_shell'});
				$endusr_count++ if ($u->{'user'} ne $d->{'user'} &&
				(($u->{'shell'} eq $mconfig{'ftp_shell'}) ||
				($u->{'shell'} eq $mconfig{'shell'})));
				$ut += $u->{'uquota'} + $u->{'umquota'} if ($u->{'user'} ne $d->{'user'});
			}
			$quota += $d->{'quota'};
			$bw += $d->{'bw_usage'};
			$bw_limit += $d->{'bw_limit'};
			
			
			$domscount++ if ($d->{'parent'});
			if (!$d->{'parent'}) {
				$mail_limit = ("*$d->{'mailboxlimit'}" ne "*") ? $mail_limit += $d->{'mailboxlimit'} : $self->{'text_hash'}->{'index_unlimited'};
				$domslimit = ($d->{'domslimit'} eq '*') ? $self->{'text_hash'}->{'index_unlimited'} : $d->{'domslimit'};
			}
		}
	}

	return (
		$mconfig{'home_quotas'} ? !$quota ? $self->{'text_hash'}->{'index_unlimited'} : $main::virtual_server_object->quota_show($quota, $quotas_home) : undef,
		$mconfig{'home_quotas'} ? $main::virtual_server_object->quota_show($ut, $quotas_home) : undef,
		$bw_limit ? $bw/1024/1024 : undef,
		$bw_limit ? $bw_limit/1024/1024 : undef,
		$mail_count , --$ftp_count,$smb_count, $mail_limit, $domscount, $domslimit,
		$endusr_count
	);
}


1;

