#!/usr/bin/perl
package time::Log_parser;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'time::Log_parser');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# log_parser.pl
# Functions for parsing this module's logs

&ModuleLoader::preload_module(ref($self), "time::TimeLib");
$self = new time::TimeLib:: ref($self), %$self; 

1;
		return $self;
}

# parse_webmin_log(user, script, action, type, object, &params)
# Converts logged information from this module into human-readable form
sub parse_webmin_log
{
	my $self = shift;

local ($user, $script, $action, $type, $object, $p, $long) = @_;
if ($action eq 'remote') {
	local $tm = localtime($object);
	return $self->text($long ? "log_remote_${type}_l" : "log_remote_${type}",
	     "<i>$tm</i>", "<tt>".$self->html_escape($p->{'timeserver'})."</tt>");
	}
elsif ($action eq 'set') {
	local $tm = localtime($object);
	return $self->text("log_set_${type}", "<i>$tm</i>");
	}
elsif ($action eq 'sync') {
	return $self->{'text_hash'}->{'log_sync'};
	}
elsif ($action eq 'sync_s') {
	return $self->{'text_hash'}->{'log_sync_s'};
	}
elsif ($action eq 'timezone') {
	return $self->text('log_timezone', $self->html_escape($object));
	}
else {
	return undef;
	}
}


1;

