#!/usr/bin/perl

&MAIN();

 sub MAIN {

&ModuleLoader::preload_module('time_class', "time::TimeLib");
$self = new time::TimeLib:: 'time_class',%$self;


local ($rawdate, $rawhwdate, %system_date, $rawtime, %hw_date, $txt);
$txt = "";

$self->error( $self->{'text_hash'}->{ 'acl_error' } ) if( $self->{'access_hash'}->{ 'sysdate' } && $self->{'access_hash'}->{ 'hwdate' } );

if (!$self->{'access_hash'}->{'sysdate'} && !$self->{'access_hash'}->{'hwdate'} && $self->{'config_hash'}->{'hwtime'}) {
	$self->{'arr'} = "0,1";
	}
else {
	$self->{'arr'} = "0";
	}
$self->ui_print_header(undef,  $self->{'text_hash'}->{ 'index_title' }, "", "index", 1, 1, undef,
	$self->help_search_link("date hwclock", "man"),
	qq(<script src="time.js"></script>\n),
	qq(onLoad="F=[$self->{'arr'}];timeInit(F); setTimeout('timeUpdate(F)', 5000);"));

if (!$self->{'access_hash'}->{'sysdate'} && !$self->has_command("date")) {
	print $self->text( 'error_cnf', "<tt>date</tt>"),"<p>\n";
	$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});
	exit;
	}
if (!$self->{'access_hash'}->{'hwdate'} && $self->{'config_hash'}->{'hwtime'} && !$self->has_command("hwclock")) {
	print $self->text( 'error_cnf', "<tt>hwclock</tt>"),"<p>\n";
	$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});
	exit;
	}

# Get the system time
@tm = $self->get_system_time();
$system_date{ 'second' } = $tm[0];
$system_date{ 'minute' } = $tm[1];
$system_date{ 'hour' } = $tm[2];
$system_date{ 'date' } = $tm[3];
$system_date{ 'month' } = $self->number_to_month($tm[4]);
$system_date{ 'year' } = $tm[5]+1900;
$system_date{ 'day' } = $self->number_to_weekday($tm[6]);

if( !$self->{'access_hash'}->{'sysdate'} )
{
  # Show system time for editing
  print( 
"<form action=apply.cgi>",
  &tabletime( $self->hlink( $self->{'text_hash'}->{ 'sys_title' }, "system_time" ), 0, %system_date ),
  "<input type=submit name=action value=\"", $self->{'text_hash'}->{ 'action_apply' }, "\">",
  $self->{'config_hash'}->{'hwtime'} ? " <input type=submit name=action value=\"$self->{'text_hash'}->{'action_sync'}\">\n" : "");
print "</form><p>";
}
else
{
   # Just show current time
   print &tabletime( $self->hlink( $self->{'text_hash'}->{ 'sys_title' }, "system_time" ), 1, %system_date ),"<p>\n";
}

# Get the hardware time
if ($self->{'config_hash'}->{'hwtime'}) {
	local @tm = $self->get_hardware_time();
	@tm || $self->error($self->{'text_hash'}->{'index_eformat'});
	$hw_date{ 'second' } = $tm[0];
	$hw_date{ 'minute' } = $tm[1];
	$hw_date{ 'hour' } = $tm[2];
	$hw_date{ 'date' } = $tm[3];
	$hw_date{ 'month' } = $self->number_to_month($tm[4]);
	$hw_date{ 'year'} = $tm[5]+1900;
	$hw_date{ 'day' } = $self->number_to_weekday($tm[6]);

	if(!$self->{'access_hash'}->{'hwdate'}) {
		# Allow editing of hardware time
		if( !$self->{'access_hash'}->{ 'sysdate' } ) {
		    $hw_date{ 'second' } = $system_date{ 'second' } if( $hw_date{ 'second' } - $system_date{ 'second' } <= $self->{'config_hash'}->{ 'lease' } );
			}
	    
		print( 
		"<p><form action=apply.cgi>",
		  &tabletime( $self->hlink( $self->{'text_hash'}->{ 'hw_title' }, "hardware_time" ), 0, %hw_date ),
		  "<input type=submit name=action value=\"", $self->{'text_hash'}->{ 'action_save' }, "\">",
		  $self->{'config_hash'}->{'hwtime'} ? " <input type=submit name=action value=\"".$self->{'text_hash'}->{ 'action_sync_s' }."\">" : "", "</form><p>" );
		}
	else {
		# Show show the hardware time
		print "<p>",&tabletime( $self->hlink( $self->{'text_hash'}->{ 'hw_title' }, "hardware_time" ), 1, %hw_date ),"<p>\n";
		}
	}

if ($self->{'access_hash'}->{'timezone'} && $self->has_timezone()) {
	print "<form action=save_timezone.cgi>\n";
	print "<table border width=100%>\n";
	print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'index_tzheader'}</b></td> </tr>\n";
	print "<tr $self->{'cb'}> <td><table>\n";

	@{$self->{'zones_array'}} = $self->list_timezones();
	$self->{'cz'} = $self->get_current_timezone();
	$self->{'found'} = 0;
	print "<tr> <td><b>$self->{'text_hash'}->{'index_tz'}</b></td>\n";
	print "<td><select name=zone>\n";
	foreach $z (@{$self->{'zones_array'}}) {
		if ($z->[0] =~ /^(.*)\/(.*)$/) {
			$self->{'pfx'} = $1;
			}
		else {
			$self->{'pfx'} = undef;
			}
		if ($self->{'pfx'} ne $self->{'lastpfx'} && $z ne $self->{'zones_array'}->[0]) {
			print "<option value=''>----------\n";
			}
		$self->{'lastpfx'} = $self->{'pfx'};
		printf "<option value=%s %s>%s\n",
			$z->[0], $self->{'cz'} eq $z->[0] ? "selected" : "",
			$z->[1] ? "$z->[0] ($z->[1])" : $z->[0];
		$self->{'found'} = 1 if ($self->{'cz'} eq $z->[0]);
		}
	if (!$self->{'found'} && $self->{'cz'}) {
		printf "<option value=%s %s>%s\n",
			$self->{'cz'}, "selected", $self->{'cz'};
		}
	print "</select></td> </tr>\n";

	print "</table></td></tr></table>\n";
	print "<input type=submit value='$self->{'text_hash'}->{'save'}'></form>\n";
	}

if( ( !$self->{'access_hash'}->{ 'sysdate' } && $self->has_command( "date" ) || !$self->{'access_hash'}->{ 'hwdate' } && $self->has_command( "hwclock" ) ) && $self->{'access_hash'}->{'ntp'} )
{
	# Show time server input
	print(
	"<p><form action=apply.cgi>",
	  "<table nosave border width=\"100%\">",
		"<tr $self->{'tb'}>",
		  "<td colspan=2><b>", $self->hlink( $self->{'text_hash'}->{ 'index_timeserver' }, "timeserver" ), "</b></td>",
		"</tr>",
		"<tr $self->{'cb'}><td><table width=100%>",
		  "<td><b>",$self->{'text_hash'}->{ 'index_addresses' }, "</b></td>",
		  "<td>",$self->p_entry( "timeserver", $self->{'config_hash'}->{'timeserver'}, 40 ),
		  "</td> </tr>\n");

	# Show hardware time checkbox
	if ($self->{'config_hash'}->{'hwtime'}) {
		print "<tr $self->{'cb'}> <td></td> <td>\n";
		printf "<input type=checkbox name=hardware value=1 %s> %s\n",
			$self->{'config_hash'}->{'timeserver_hardware'} ? "checked" : "",
			$self->{'text_hash'}->{'index_hardware2'};
		print "</td> </tr>\n";
		}

	# Show schedule input
	$self->foreign_require("cron", "cron-lib.pl");
	$self->{'job'} = $self->find_cron_job();
	print "<tr $self->{'cb'}> <td><b>$self->{'text_hash'}->{'index_sched'}</b></td>\n";
	printf "<td><input type=radio name=sched value=0 %s> %s\n",
		$self->{'job'} ? "" : "checked", $self->{'text_hash'}->{'no'};
	printf "<input type=radio name=sched value=1 %s> %s</td> </tr>\n",
		$self->{'job'} ? "checked" : "", $self->{'text_hash'}->{'index_schedyes'};

	print "<tr $self->{'cb'}> <td colspan=2><table border width=100%>\n";
	$self->{'job'} ||= { 'mins' => '0',
		   'hours' => '0',
		   'days' => '*',
		   'months' => '*',
		   'weekdays' => '*' };
	$main::cron_object->show_times_input($self->{'job'});
	print "</table></td> </tr>\n";

	print "</table></td></tr></table>\n";
	print "<input type=submit name=action value='$self->{'text_hash'}->{'index_sync'}'></form>";
}

$self->ui_print_footer( "/", $self->{'text_hash'}->{ 'index' } );

1;
		
}

# tabletime(label, read-only, &time)
sub tabletime
{
	shift if ($self == $_[0]);

  my ( $label, $ro, %src ) = @_,
  %assoc_day = ( "Mon", $self->{'text_hash'}->{ 'day_1' }, "Tue", $self->{'text_hash'}->{ 'day_2' }, "Wed", $self->{'text_hash'}->{ 'day_3' }, "Thu", $self->{'text_hash'}->{ 'day_4' }, "Fri", $self->{'text_hash'}->{ 'day_5' }, "Sat", $self->{'text_hash'}->{ 'day_6' }, "Sun", $self->{'text_hash'}->{ 'day_0' } ),
  %{$self->{'assoc_month_hash'}} = ( "Jan", $self->{'text_hash'}->{ 'month_1' }, "Feb", $self->{'text_hash'}->{ 'month_2' }, "Mar", $self->{'text_hash'}->{ 'month_3' }, "Apr", $self->{'text_hash'}->{ 'month_4' }, "May", $self->{'text_hash'}->{ 'month_5' }, "Jun", $self->{'text_hash'}->{ 'month_6' }, "Jul", $self->{'text_hash'}->{ 'month_7' }, "Aug", $self->{'text_hash'}->{ 'month_8' }, "Sep", $self->{'text_hash'}->{ 'month_9' }, "Oct", $self->{'text_hash'}->{ 'month_10' }, "Nov", $self->{'text_hash'}->{ 'month_11' }, "Dec", $self->{'text_hash'}->{ 'month_12' } );

$self->{'rv'} =
"<table nosave border width=\"100%\"><tr ". $self->{'tb'}. "><td>". $label. "</td></tr></table>\n".
"<table nosave border width=\"100%\">".
  "<tr ". $self->{'cb'}. ">".
	"<td nosave><b>". $self->{'text_hash'}->{ 'day' }. "</b></td>\n".
	"<td nosave><b>". $self->{'text_hash'}->{ 'date' }. "</b></td>\n".
	"<td nosave><b>". $self->{'text_hash'}->{ 'month' }. "</b></td>\n".
	"<td nosave><b>". $self->{'text_hash'}->{ 'year' }. "</b></td>\n".
	"<td><b>". $self->{'text_hash'}->{ 'hour' }. "</b></td>\n".
  "</tr>\n";
if (!$ro) {
	$self->{'rv'} .= "<tr ". $self->{'cb'}. ">".
		"<td>". ($assoc_day{ $src{ 'day' } } || $src{'day'})."</td>\n".
		"<td>". $self->p_select( "date", $src{ 'date' }, ( 1..31 ) ). "</td>\n".
		"<td>". $self->p_select_wdl( "month", $self->{'assoc_month_hash'}->{ $src{ 'month' } }, "01",( $self->{'text_hash'}->{ 'month_1' }, "02", $self->{'text_hash'}->{ 'month_2' }, "03", $self->{'text_hash'}->{ 'month_3' }, "04", $self->{'text_hash'}->{ 'month_4' }, "05", $self->{'text_hash'}->{ 'month_5' }, "06", $self->{'text_hash'}->{ 'month_6' }, "07", $self->{'text_hash'}->{ 'month_7' }, "08", $self->{'text_hash'}->{ 'month_8' }, "09", $self->{'text_hash'}->{ 'month_9' }, "10", $self->{'text_hash'}->{ 'month_10' }, "11", $self->{'text_hash'}->{ 'month_11' }, "12", $self->{'text_hash'}->{ 'month_12' } ) ). "</td>\n".
		"<td>". $self->p_select( "year", $src{ 'year' }, ( 1969..2037 ) ). "</td>\n".
		"<td>". $self->p_select( "hour", $self->zeropad($src{ 'hour' }, 2), ( "00", "01", "02", "03", "04", "05", "06", "07", "08", "09", 10..23 ) ). "\n:". $self->p_select( "minute", $self->zeropad($src{ 'minute' }, 2), ( "00", "01", "02", "03", "04", "05", "06", "07", "08", "09", 10..59) ). ":". $self->p_select( "second", $self->zeropad($src{ 'second' }, 2), ( "00", "01", "02", "03", "04", "05", "06", "07", "08", "09", 10..59 ) ). "</td>\n".
	  "</tr>\n".
	"</table>";
	}
else {
	$self->{'rv'} .= "<tr $self->{'cb'}>".
	       "<td>".($assoc_day{ $src{ 'day' } } || $src{'day'})."</td>\n".
	       "<td>".$src{'date'}."</td>\n".
	       "<td>".$src{'month'}."</td>\n".
	       "<td>".$src{'year'}."</td>\n".
	       "<td>".$src{'hour'}.":".$src{'minute'}.":".$src{'second'}."</td>\n".
               "</tr></table>\n";
	}
return $self->{'rv'};
}


1;

