#!/usr/bin/perl

&MAIN();

 sub MAIN {
# link.cgi
# Forward the URL from path_info on to another webmin server

&ModuleLoader::preload_module('tunnel_class', "tunnel::TunnelLib");
$self = new tunnel::TunnelLib:: 'tunnel_class',%$self;

#$ENV{'PATH_INFO'} =~ /^\/(.*)$/ ||
#	$self->error("Bad PATH_INFO : $ENV{'PATH_INFO'}");
$ENV{'PATH_INFO'} =~ /^\/(http|https):\/+([^:\/]+)(:(\d+))?(.*)$/ ||
	$self->error("Bad PATH_INFO : $ENV{'PATH_INFO'}");
$self->{'protocol'} = $1;
$self->{'ssl'} = $self->{'protocol'} eq "https";
$self->{'host'} = $2;
$self->{'port'} = $4 || 80;
$self->{'path'} = $5;
$self->{'openurl'} = "$1://$2$3$5";
$self->{'baseurl'} = "$1://$2$3";
if ($ENV{'QUERY_STRING'}) {
	$self->{'path'} .= '?'.$ENV{'QUERY_STRING'};
	}
elsif (@ARGV) {
	$self->{'path'} .= '?'.join('+', @ARGV);
	}
$self->{'linkurl'} = "/$self->{'module_name'}/link.cgi/";
$self->{'url'} = "/$self->{'module_name'}/link.cgi/$self->{'openurl'}";
$| = 1;
$self->{'meth'} = $ENV{'REQUEST_METHOD'};
if ($self->{'config_hash'}->{'url'}) {
	$self->{'openurl'} eq $self->{'config_hash'}->{'url'} ||
		$self->error($self->text('link_ebadurl', $self->{'openurl'}));
	}

if ($self->{'config_hash'}->{'loginmode'} == 2) {
	# Login is variable .. check if we have it yet
	if ($ENV{'HTTP_COOKIE'} =~ /tunnel=([^\s;]+)/) {
		# Yes - set the login and password to use
		($self->{'user'}, $self->{'pass'}) = split(/:/, $self->decode_base64("$1"));
		}
	else {
		# No - need to display a login form
		$self->ui_print_header(undef, $self->{'text_hash'}->{'login_title'}, "");

		print "<center>",$self->text('login_desc', "<tt>$self->{'openurl'}</tt>"),
		      "</center><p>\n";
		print "<form action=/$self->{'module_name'}/login.cgi method=post>\n";
		print "<input type=hidden name=url value='",
			$self->html_escape($self->{'openurl'}),"'>\n";
		print "<center><table border>\n";
		print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'login_header'}</b></td> </tr>\n";
		print "<tr $self->{'cb'}> <td><table cellpadding=2>\n";
		print "<tr> <td><b>$self->{'text_hash'}->{'login_user'}</b></td>\n";
		print "<td><input name=user size=20></td> </tr>\n";
		print "<tr> <td><b>$self->{'text_hash'}->{'login_pass'}</b></td>\n";
		print "<td><input name=pass size=20 type=password></td>\n";
		print "</tr> </table></td></tr></table>\n";
		print "<input type=submit value='$self->{'text_hash'}->{'login_login'}'>\n";
		print "<input type=reset value='$self->{'text_hash'}->{'login_clear'}'>\n";
		print "</center></form>\n";

		$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
		exit;
		}
	}
elsif ($self->{'config_hash'}->{'loginmode'} == 1) {
	# Login is fixed
	$self->{'user'} = $self->{'config_hash'}->{'user'};
	$self->{'pass'} = $self->{'config_hash'}->{'pass'};
	}

# Connect to the server
$self->{'con'} = $self->make_http_connection($self->{'host'}, $self->{'port'}, $self->{'ssl'}, $self->{'meth'}, $self->{'path'});
$self->error($self->{'con'}) if (!ref($self->{'con'}));

# Send request headers
$self->write_http_connection($self->{'con'}, "Host: $self->{'host'}\r\n");
$self->write_http_connection($self->{'con'}, "User-agent: Webmin\r\n");
if ($self->{'user'}) {
	$self->{'auth'} = $self->encode_base64("$user:$self->{'pass'}");
	$self->{'auth'} =~ s/\n//g;
	$self->write_http_connection($self->{'con'}, "Authorization: basic $self->{'auth'}\r\n");
	}
$self->write_http_connection($self->{'con'}, sprintf(
			"Webmin-servers: %s://%s:%d/$self->{'module_name'}/\n",
			$ENV{'HTTPS'} eq "ON" ? "https" : "http",
			$ENV{'SERVER_NAME'}, $ENV{'SERVER_PORT'}));
$self->{'cl'} = $ENV{'CONTENT_LENGTH'};
$self->write_http_connection($self->{'con'}, "Content-length: $self->{'cl'}\r\n") if ($self->{'cl'});
$self->write_http_connection($self->{'con'}, "Content-type: $ENV{'CONTENT_TYPE'}\r\n")
	if ($ENV{'CONTENT_TYPE'});
$self->write_http_connection($self->{'con'}, "\r\n");
if ($self->{'cl'}) {
	$self->read_fully(STDIN, \$self->{'post'}, $self->{'cl'});
	$self->write_http_connection($self->{'con'}, $self->{'post'});
	}

# read back the headers
$self->{'dummy'} = $self->read_http_connection($self->{'con'});
while(1) {
	($self->{'headline'} = $self->read_http_connection($self->{'con'})) =~ s/\r|\n//g;
	last if (!$self->{'headline'});
	$self->{'headline'} =~ /^(\S+):\s+(.*)$/ || $self->error("Bad header");
	$self->{'header_hash'}->{lc($1)} = $2;
	$self->{'headers'} .= $self->{'headline'}."\n";
	}

$self->{'defport'} = $self->{'ssl'} ? 443 : 80;
if ($self->{'header_hash'}->{'location'}) {
	# fix a redirect
	$self->redirect("/$self->{'module_name'}/link.cgi/$self->{'header_hash'}->{'location'}");
	exit;
	}
if ($self->{'header_hash'}->{'location'} =~ /^(http|https):\/\/$host:$self->{'port'}$self->{'page'}(.*)$/ ||
    $self->{'header_hash'}->{'location'} =~ /^(http|https):\/\/$self->{'host'}$self->{'page'}(.*)/ &&
    $self->{'port'} == $self->{'defport'}) {
	# fix a redirect
	$self->redirect("$self->{'url'}/$2");
	exit;
	}
elsif ($self->{'header_hash'}->{'www-authenticate'}) {
	# Invalid login
	if ($self->{'config_hash'}->{'loginmode'} == 2) {
		print "Set-Cookie: tunnel=; path=/\n";
		$self->error($self->text('link_eautologin', "<tt>$self->{'openurl'}</tt>",
		     "/$self->{'module_name'}/link.cgi/$self->{'path'}"));
		}
	elsif ($self->{'user'}) {
		$self->error($self->text('link_elogin', $self->{'host'}, $self->{'user'}));
		}
	else {
		$self->error($self->text('link_enouser', $self->{'host'}));
		}
	}
else {
	# just output the headers
	print $self->{'headers'},"\n";
	}

# read back the rest of the page
if ($self->{'header_hash'}->{'content-type'} =~ /text\/html/ && !$self->{'header_hash'}->{'x-no-links'}) {
	while($_ = $self->read_http_connection($self->{'con'})) {
		# Fix absolute image links like <img src=/foo.gif>
		s/src='(\/[^']*)'/src='$self->{'baseurl'}$1'/gi;
		s/src="(\/[^"]*)"/src="$self->{'baseurl'}$1"/gi;
		s/src=(\/[^ "'>]*)/src=$self->{'baseurl'}$1/gi;

		# Fix offsite image links <img src=http://www.blah.com/foo.gif>
		s/src='((http|https):\/\/[^']*)'/src='$self->{'linkurl'}$1'/gi;
		s/src="((http|https):\/\/[^"]*)"/src="$self->{'linkurl'}$1"/gi;
		s/src=((http|https):\/\/[^ "'>]*)/src=$self->{'linkurl'}$1/gi;

		# Fix absolute hrefs like <a href=/foo.html>
		s/href='(\/[^']*)'/href='$self->{'baseurl'}$1'/gi;
		s/href="(\/[^"]*)"/href="$self->{'baseurl'}$1"/gi;
		s/href=(\/[^ "'>]*)/href=$self->{'baseurl'}$1/gi;

		# Fix offsite hrefs like <a href=http://www.blah.com/>
		s/href='((http|https):\/\/[^']*)'/href='$self->{'linkurl'}$1'/gi;
		s/href="((http|https):\/\/[^"]*)"/href="$self->{'linkurl'}$1"/gi;
		s/href=((http|https):\/\/[^ "'>]*)/href=$self->{'linkurl'}$1/gi;

		# Fix absolute form actions like <form action=/foo>
		s/action='(\/[^']*)'/action='$self->{'baseurl'}$1'/gi;
		s/action="(\/[^"]*)"/action="$self->{'baseurl'}$1"/gi;
		s/action=(\/[^ "'>]*)/action=$self->{'baseurl'}$1/gi;

		# Fix offsite form actions
		s/action='((http|https):\/\/[^']*)'/action='$self->{'linkurl'}$1'/gi;
		s/action="((http|https):\/\/[^"]*)"/action="$self->{'linkurl'}$1"/gi;
		s/action=((http|https):\/\/[^ "'>]*)/action=$self->{'linkurl'}$1/gi;

		#s/\.location\s*=\s*'$self->{'page'}([^']*)'/.location='$self->{'url'}\/$1'/gi;
		#s/\.location\s*=\s*"$self->{'page'}([^']*)"/.location="$self->{'url'}\/$1"/gi;
		#s/window.open\("$self->{'page'}([^"]*)"/window.open\("$self->{'url'}\/$1"/gi;
		#s/name=return\s+value="$self->{'page'}([^"]*)"/name=return value="$self->{'url'}\/$1"/gi;
		print;
		}
	}
else {
	while($self->{'buf'} = $self->read_http_connection($self->{'con'}, 1024)) {
		print $self->{'buf'};
		}
	}
$self->close_http_connection($self->{'con'});

1;
		
}


1;

