#!/usr/bin/perl

&MAIN();

 sub MAIN {
# download.cgi
# Save a download or start it right now

&ModuleLoader::preload_module('updown_class', "updown::UpdownLib");
$self = new updown::UpdownLib:: 'updown_class',%$self;

require 'timelocal.pl';
$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'download_err'});

# Validate and store inputs
$self->{'i'} = 0;
@{$self->{'urls_array'}} = split(/[\r\n]+/, $self->{'in_hash'}->{'urls'});
@{$self->{'urls_array'}} || $self->error($self->{'text_hash'}->{'download_enone'});
foreach $u (@{$self->{'urls_array'}}) {
	local ($proto, $host, $port, $page, $ssl);
	if ($u =~ /^(http|https):\/\/([^\/]+)(\/.*)$/) {
		$proto = "http";
		$ssl = $1 eq 'https';
		$host = $2; $page = $3; $port = $ssl ? 443 : 80;
		if ($host =~ /^(.*):(\d+)$/) { $host = $1; $port = $2; }
		}
	elsif ($u =~ /^ftp:\/\/([^\/]+)(:21)?(\/.*)$/) {
		$proto = "ftp";
		$host = $1; $page = $3;
		}
	else {
		$self->error($self->text('download_eurl', $u));
		}
	if ($host =~ /^([^:\@]+):([^:\@]+)\@(\S+)/) {
		$self->{'user'} = $1;
		$self->{'pass'} = $2;
		$host = $3;
		}
	$self->{'download_hash'}->{"url_$self->{'i'}"} = $u;
	$self->{'download_hash'}->{"proto_$self->{'i'}"} = $proto;
	$self->{'download_hash'}->{"host_$self->{'i'}"} = $host;
	$self->{'download_hash'}->{"user_$self->{'i'}"} = $self->{'user'};
	$self->{'download_hash'}->{"pass_$self->{'i'}"} = $self->{'pass'};
	$self->{'download_hash'}->{"port_$self->{'i'}"} = $port;
	$self->{'download_hash'}->{"page_$self->{'i'}"} = $page;
	$self->{'download_hash'}->{"ssl_$self->{'i'}"} = $ssl;
	$self->{'i'}++;
	}
$self->{'in_hash'}->{'dir'} || $self->error($self->{'text_hash'}->{'upload_edir'});
$self->can_write_file($self->{'in_hash'}->{'dir'}) ||
	$self->error($self->text('download_eaccess', "<tt>$self->{'in_hash'}->{'dir'}</tt>", $!));
$self->{'download_hash'}->{'dir'} = $self->{'in_hash'}->{'dir'};
if ($self->{'can_mode'} != 3) {
	# User can be entered
	defined(@{$self->{'uinfo_array'}} = getpwnam($self->{'in_hash'}->{'user'})) || $self->error($self->{'text_hash'}->{'upload_euser'});
	$self->can_as_user($self->{'in_hash'}->{'user'}) ||
		$self->error($self->text('download_eucannot', $self->{'in_hash'}->{'user'}));
	$self->{'download_hash'}->{'uid'} = $self->{'uinfo_array'}->[2];
	$self->{'in_hash'}->{'group_def'} || defined(@{$self->{'ginfo_array'}} = getgrnam($self->{'in_hash'}->{'group'})) ||
		$self->error($self->{'text_hash'}->{'upload_egroup'});
	$self->{'can_mode'} == 0 || $self->{'in_hash'}->{'group_def'} || $self->in_group(\@{$self->{'uinfo_array'}}, \@{$self->{'ginfo_array'}}) ||
		$self->error($self->{'text_hash'}->{'download_egcannot'});
	$self->{'download_hash'}->{'gid'} = defined(@{$self->{'ginfo_array'}}) ? $self->{'ginfo_array'}->[2] : $self->{'uinfo_array'}->[3];
	}
else {
	# User is fixed
	if ($self->supports_users()) {
		@{$self->{'uinfo_array'}} = getpwnam($self->{'remote_user'});
		$self->{'download_hash'}->{'uid'} = $self->{'uinfo_array'}->[2];
		$self->{'download_hash'}->{'gid'} = $self->{'uinfo_array'}->[3];
		}
	}
if ($self->{'in_hash'}->{'bg'} && $self->{'can_schedule'}) {
	# Validate time
	$self->{'in_hash'}->{'hour'} =~ /^\d+$/ && $self->{'in_hash'}->{'min'} =~ /^\d+$/ &&
		$self->{'in_hash'}->{'day'} =~ /^\d+$/ && $self->{'in_hash'}->{'year'} =~ /^\d+$/ ||
			$self->error($self->{'text_hash'}->{'download_edate'});
	eval { $self->{'download_hash'}->{'time'} = timelocal(0, $self->{'in_hash'}->{'min'}, $self->{'in_hash'}->{'hour'},
			 $self->{'in_hash'}->{'day'}, $self->{'in_hash'}->{'month'}, $self->{'in_hash'}->{'year'}-1900) };
	$@ && $self->error($self->{'text_hash'}->{'download_edate2'});
	}

# Create the directory if needed
if (!-d $self->{'download_hash'}->{'dir'} && $self->{'in_hash'}->{'mkdir'}) {
	$self->switch_uid_to($self->{'download_hash'}->{'uid'}, $self->{'download_hash'}->{'gid'});
	mkdir($self->{'download_hash'}->{'dir'}, 0755) || $self->error($self->text('upload_emkdir', $!));
	$self->switch_uid_back();
	}

# Save the settings
if ($self->{'module_info_hash'}->{'usermin'}) {
	$self->lock_file("$self->{'user_module_config_directory'}/config");
	$self->{'userconfig_hash'}->{'ddir'} = $self->{'in_hash'}->{'dir'};
	$self->write_file("$self->{'user_module_config_directory'}/config", \%{$self->{'userconfig_hash'}});
	$self->unlock_file("$self->{'user_module_config_directory'}/config");
	}
else {
	$self->lock_file("$self->{'module_config_directory'}/config");
	$self->{'config_hash'}->{'ddir_'.$self->{'remote_user'}} = $self->{'in_hash'}->{'dir'};
	$self->{'config_hash'}->{'duser_'.$self->{'remote_user'}} = $self->{'in_hash'}->{'user'};
	$self->{'config_hash'}->{'dgroup_'.$self->{'remote_user'}} = $self->{'in_hash'}->{'group_def'} ? undef
							   : $self->{'in_hash'}->{'group'};
	$self->write_file("$self->{'module_config_directory'}/config", \%{$self->{'config_hash'}});
	$self->unlock_file("$self->{'module_config_directory'}/config");
	}

if ($self->{'in_hash'}->{'bg'} && $self->{'can_background'}) {
	# Create a script to be called by At
	$self->foreign_require("cron", "cron-lib.pl");
	$self->lock_file($self->{'atjob_cmd'});
	$main::cron_object->create_wrapper($self->{'atjob_cmd'}, $self->{'module_name'}, "download.pl");
	$self->unlock_file($self->{'atjob_cmd'});
	$self->save_download(\%{$self->{'download_hash'}});

	if (!$self->{'can_schedule'}) {
		# Just run this script right now
		system("$self->{'atjob_cmd'} $self->{'download_hash'}->{'id'} >/dev/null 2>&1 </dev/null &");
		}
	else {
		# Create an At job to do the download
		$self->foreign_require("at", "at-lib.pl");
			{
			local %ENV;
			delete($ENV{'FOREIGN_MODULE_NAME'});
			delete($ENV{'FOREIGN_ROOT_DIRECTORY'});
			$self->clean_environment();
			$ENV{'REMOTE_USER'} = $self->{'remote_user'};	# For usermin
			$ENV{'BASE_REMOTE_USER'} = $self->{'base_remote_user'};
			$main::at_object->create_atjob("root", $self->{'download_hash'}->{'time'},
					  "$self->{'atjob_cmd'} $self->{'download_hash'}->{'id'}", "/");
			$self->reset_environment();
			}
		}

	$self->redirect("");
	}
else {
	# Download it now, and show the results
	$self->ui_print_unbuffered_header(undef, $self->{'text_hash'}->{'download_title'}, "");

	$self->{'error'} = $self->do_download(\%{$self->{'download_hash'}}, 'progress_callback', \@{$self->{'paths_array'}});
	@{$self->{'paths_array'}} = grep { $_ } @{$self->{'paths_array'}};
	if (@{$self->{'paths_array'}}) {
		print "<p>$self->{'text_hash'}->{'download_done'}<p>\n";
		foreach $p (@{$self->{'paths_array'}}) {
			@{$self->{'st_array'}} = stat($p);
			print "<tt>$p</tt> ($self->{'st_array'}->[7] bytes)<br>\n";
			}
		}
	if ($self->{'error'}) {
		print "<p><b>",$self->text('download_failed', $self->{'error'}),"</b><p>\n";
		}

	$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
	}
$self->webmin_log("download", undef, undef, { 'urls' => \@{$self->{'urls_array'}},
					'time' => $self->{'download_hash'}->{'time'} });

1;
		
}


1;

