#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Output one file for download

&ModuleLoader::preload_module('updown_class', "updown::UpdownLib");
$self = new updown::UpdownLib:: 'updown_class',%$self;

$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'fetch_err'});
$self->{'can_fetch'} || $self->error($self->{'text_hash'}->{'fetch_ecannot'});

# Validate filename
$self->{'file'} = $ENV{'PATH_INFO'} || $self->{'in_hash'}->{'fetch'};
if ($self->{'file'} !~ /^\// && $can_dirs[0] ne "/") {
	$self->{'file'} = "$can_dirs[0]/$self->{'file'}";
	}
$self->{'file'} || $self->error($self->{'text_hash'}->{'fetch_efile'});
-r $self->{'file'} && !-d $self->{'file'} || $self->error($self->{'text_hash'}->{'fetch_eexists'});
$self->can_write_file($self->{'file'}) ||
	$self->error($self->text('fetch_eaccess', "<tt>$self->{'file'}</tt>", $!));

if ($ENV{'PATH_INFO'}) {
	# Switch to the correct user
	if ($self->{'can_mode'} == 3) {
		@{$self->{'uinfo_array'}} = getpwnam($self->{'remote_user'});
		$self->switch_uid_to($self->{'uinfo_array'}->[2], $self->{'uinfo_array'}->[3]);
		}
	elsif ($self->{'can_mode'} == 1 && @{$self->{'can_users_array'}} == 1) {
		@{$self->{'uinfo_array'}} = getpwnam($self->{'can_users_array'}->[0]);
		$self->switch_uid_to($self->{'uinfo_array'}->[2], $self->{'uinfo_array'}->[3]);
		}

	# Send it
	$self->open_readfile(*FILE, $self->{'file'}) || $self->error($self->text('fetch_eopen', $!));
	if ($self->{'fetch_show'}) {
		$self->{'type'} = $self->guess_mime_type($self->{'file'}, undef);
		if (!$self->{'type'}) {
			# See if it is really text
			$self->{'out'} = $self->backquote_command("file ".quotemeta($self->resolve_links($self->{'file'})));
			$self->{'type'} = "text/plain" if ($self->{'out'} =~ /text|script/);
			}
		}
	else {
		print "Content-Disposition: Attachment\n";
		}
	$self->{'type'} ||= "application/octet-stream";
	print "Content-type: $self->{'type'}\n\n";
	while(<FILE>) {
		print $_;
		}
	close(FILE);

	# Switch back to root
	$self->switch_uid_back();
	}
else {
	# Save file in config
	if ($self->{'module_info_hash'}->{'usermin'}) {
		$self->lock_file("$self->{'user_module_config_directory'}/config");
		$self->{'userconfig_hash'}->{'fetch'} = $self->{'file'};
		$self->{'userconfig_hash'}->{'show'} = $self->{'in_hash'}->{'show'};
		$self->write_file("$self->{'user_module_config_directory'}/config", \%{$self->{'userconfig_hash'}});
		$self->unlock_file("$self->{'user_module_config_directory'}/config");
		}
	else {
		$self->lock_file("$self->{'module_config_directory'}/config");
		$self->{'config_hash'}->{'fetch_'.$self->{'remote_user'}} = $self->{'file'};
		$self->{'config_hash'}->{'show_'.$self->{'remote_user'}} = $self->{'in_hash'}->{'show'};
		$self->write_file("$self->{'module_config_directory'}/config", \%{$self->{'config_hash'}});
		$self->unlock_file("$self->{'module_config_directory'}/config");
		}

	# Redirect to nice URL
	$self->redirect("fetch.cgi".$self->{'file'});
	}

1;
		
}


1;

