#!/usr/bin/perl
package useradmin::Log_parser;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'useradmin::Log_parser');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# log_parser.pl
# Functions for parsing this module's logs

&ModuleLoader::preload_module(ref($self), "useradmin::UserLib");
$self = new useradmin::UserLib:: ref($self), %$self; 

1;
		return $self;
}

# parse_webmin_log(user, script, action, type, object, &params)
# Converts logged information from this module into human-readable form
sub parse_webmin_log
{
	my $self = shift;

local ($user, $script, $action, $type, $object, $p, $long) = @_;
$object = $self->html_escape($object);
if ($type eq 'user') {
	if ($action eq 'modify' && $p->{'old'} ne $object) {
		return $self->text('log_urename',
			     "<tt>".$self->html_escape($p->{'old'})."</tt>",
			     "<tt>$object</tt>");
		}
	elsif ($action eq 'modify') {
		return $self->text('log_umodify', "<tt>$object</tt>");
		}
	elsif ($action eq 'create') {
		return $self->text('log_ucreate', "<tt>$object</tt>");
		}
	elsif ($action eq 'delete' && $p->{'delhome'}) {
		return $self->text('log_udeletehome', "<tt>$object</tt>",
			     "<tt>".$self->html_escape($p->{'home'})."</tt>");
		}
	elsif ($action eq 'delete') {
		return $self->text('log_udelete', "<tt>$object</tt>");
		}
	}
elsif ($type eq 'group') {
	if ($action eq 'modify') {
		return $self->text('log_gmodify', "<tt>$object</tt>");
		}
	elsif ($action eq 'create') {
		return $self->text('log_gcreate', "<tt>$object</tt>");
		}
	elsif ($action eq 'delete') {
		return $self->text('log_gdelete', "<tt>$object</tt>");
		}
	}
elsif ($action eq 'batch') {
	if ($object =~ /^\//) {
		return $self->text($long ? 'log_batch_l' : 'log_batch',
			     "<tt>$object</tt>", $p->{'created'},
			     $p->{'modified'}, $p->{'deleted'});
		}
	else {
		return $self->text($long ? 'log_ubatch_l' : 'log_ubatch',
			     $p->{'created'}, $p->{'modified'},$p->{'deleted'});
		}
	}
return undef;
}


1;

