#!/usr/bin/perl
package useradmin::MacosLib;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'useradmin::MacosLib');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# freebsd-lib.pl
# Functions for freebsd format last output

$self->{'netinfo_domain'} = $self->{'config_hash'}->{'netinfo_domain'} || ".";

1;

1;
		return $self;
}

# passfiles_type()
# Returns 6 for macos netinfo user storage
sub passfiles_type
{
	my $self = shift;

return 6;
}

# groupfiles_type()
# Returns 5 for  macos netinfo group storage
sub groupfiles_type
{
	my $self = shift;

return 5;
}

# open_last_command(handle, user)
sub open_last_command
{
	my $self = shift;

local ($fh, $user) = @_;
open($fh, "last $user |");
}

# read_last_line(handle)
# Parses a line of output from last into an array of
#  user, tty, host, login, logout, period
sub read_last_line
{
	my $self = shift;

$self->{'fh'} = $_[0];
while(1) {
	chop($self->{'line'} = do { my $t=$self->{'fh'}; <$t> });
	if (!$self->{'line'}) { return (); }
	if ($self->{'line'} =~ /^(reboot|shutdown)/) { next; }
	if ($self->{'line'} =~ /^(\S+)\s+(\S+)\s+(\S+)?\s+(\S+\s+\S+\s+\d+\s+\d+:\d+)\s+\-\s+(\S+)\s+\((\d+:\d+)\)/) {
		return ($1, $2, $3, $4, $5 eq "shutdown" ? "Shutdown" :
					$5 eq "crash" ? "Crash" : $5, $6);
		}
	elsif ($self->{'line'} =~ /^(\S+)\s+(\S+)\s+(\S+)?\s+(\S+\s+\S+\s+\d+\s+\d+:\d+)\s+still/) {
		return ($1, $2, $3, $4);
		}
	}
}


1;

