#!/usr/bin/perl
package useradmin::OpenserverLib;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'useradmin::OpenserverLib');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# openserver-lib.pl
# Functions for SCO openserver password file format

1;

1;
		return $self;
}

# passfiles_type()
# Returns 0 for old-style passwords (/etc/passwd only), 1 for FreeBSD-style
# (/etc/master.passwd), 2 for SysV (/etc/passwd & /etc/shadow), 3 for
# /etc/passwd with update via useradd, 4 for AIX (/etc/passwd &
# /etc/security/passwd), and 5 for SCO (/etc/passwd and short /etc/shadow)
sub passfiles_type
{
	my $self = shift;

return 5;
}

# groupfiles_type()
# Returns 0 for normal group file (/etc/group only) and 2 for shadowed
# (/etc/group and /etc/gshadow)
sub groupfiles_type
{
	my $self = shift;

return 0;
}

# open_last_command(handle, user)
sub open_last_command
{
	my $self = shift;

local ($fh, $user) = @_;
open($fh, "last $user |");
}

# read_last_line(handle)
# Parses a line of output from last into an array of
#  user, tty, host, login, logout, period
sub read_last_line
{
	my $self = shift;

local $fh = $_[0];
while(1) {
	chop($self->{'line'} = <$fh>);
	if (!$self->{'line'}) { return (); }
	if ($self->{'line'} =~ /system boot/) { next; }
	if ($self->{'line'} =~ /^(\S+)\s+(\S+)\s+(\S+)?\s+(\S+\s+\S+\s+\d+\s+\d+:\d+)\s+\-\s+(\d+:\d+)\s+\((\d+:\d+)\)/) {
		return ($1, $2, $3, $4, $5, $6);
		}
	elsif ($self->{'line'} =~ /^(\S+)\s+(\S+)\s+(\S+)?\s+(\S+\s+\S+\s+\d+\s+\d+:\d+)\s+still/) {
		return ($1, $2, $3, $4);
		}
	}
}


1;

