#!/usr/bin/perl
package useradmin::SolarisLib;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'useradmin::SolarisLib');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# solaris-lib.pl
# Functions for solaris password file format

1;

1;
		return $self;
}

# passfiles_type()
# Returns 0 for old-style passwords (/etc/passwd only), 1 for FreeBSD-style
# (/etc/master.passwd) and 2 for SysV (/etc/passwd & /etc/shadow)
sub passfiles_type
{
	my $self = shift;

return $self->password_file($self->{'config_hash'}->{'shadow_file'}) ? 2 : 0;
}

# groupfiles_type()
# Returns 0 for normal group file (/etc/group only) and 2 for shadowed
# (/etc/group and /etc/gshadow)
sub groupfiles_type
{
	my $self = shift;

return 0;
}

# open_last_command(handle, user)
sub open_last_command
{
	my $self = shift;

local ($fh, $user) = @_;
open($fh, "last $user |");
}

# read_last_line(handle)
# Parses a line of output from last into an array of
#  user, tty, host, login, logout, period
sub read_last_line
{
	my $self = shift;

local $fh = $_[0];
while(1) {
	chop($self->{'line'} = <$fh>);
	if (!$self->{'line'}) { return (); }
	if ($self->{'line'} =~ /system boot/) { next; }
	if ($self->{'line'} =~ /^(\S+)\s+(\S+)\s+(\S+)?\s+(\S+\s+\S+\s+\d+\s+\d+:\d+)\s+\-\s+(\d+:\d+)\s+\((\d+:\d+)\)/) {
		return ($1, $2, $3, $4, $5, $6);
		}
	elsif ($self->{'line'} =~ /^(\S+)\s+(\S+)\s+(\S+)?\s+(\S+\s+\S+\s+\d+\s+\d+:\d+)\s+still/) {
		return ($1, $2, $3, $4);
		}
	}
}

# logged_in_users()
# Returns a list of hashes containing details of logged-in users
sub logged_in_users
{
	my $self = shift;

local @rv;
open(WHO, "who |");
while(<WHO>) {
	if (/^(\S+)\s+(\S+)\s+(\S+\s+\d+\s+\d+:\d+)\s+(\((\S+)\))?/) {
		push(@rv, { 'user' => $1, 'tty' => $2,
			    'when' => $3, 'from' => $5 });
		}
	}
close(WHO);
return @rv;
}

# use_md5()
# Returns 1 if MD5 encryption should be used
sub use_md5
{
	my $self = shift;

local $lref = $self->read_file_lines("/etc/security/policy.conf");
local $l;
foreach $l (@$lref) {
	if ($l =~ /^CRYPT_DEFAULT\s*=\s*"([^"]*)"/ ||
	    $l =~ /^CRYPT_DEFAULT\s*=\s*'([^']*)'/ ||
	    $l =~ /^CRYPT_DEFAULT\s*=\s*(\S+)/) {
		return 1 if ($1 eq "1");
		}
	}
return 0;
}


1;

