#!/usr/bin/perl

&MAIN();

 sub MAIN {
# batch_exec.cgi
# Execute create/modify/delete commands in a batch file

&ModuleLoader::preload_module('useradmin_class', "useradmin::UserLib");
$self = new useradmin::UserLib:: 'useradmin_class',%$self;

%{$self->{'access_hash'}} = $self->get_module_acl();
$self->{'access_hash'}->{'batch'} || $self->error($self->{'text_hash'}->{'batch_ecannot'});
if ($ENV{'REQUEST_METHOD'} eq 'GET') {
	$self->ReadParse();
	}
else {
	$self->ReadParseMime();
	}
if ($self->{'in_hash'}->{'source'} == 0) {
	$self->{'data'} = $self->{'in_hash'}->{'file'};
	$self->{'data'} =~ /\S/ || $self->error($self->{'text_hash'}->{'batch_efile'});
	}
elsif ($self->{'in_hash'}->{'source'} == 1) {
	open(LOCAL, $self->{'in_hash'}->{'local'}) || $self->error($self->{'text_hash'}->{'batch_elocal'});
	while(<LOCAL>) {
		$self->{'data'} .= $_;
		}
	close(LOCAL);
	}
elsif ($self->{'in_hash'}->{'source'} == 2) {
	$self->{'data'} = $self->{'in_hash'}->{'text'};
	$self->{'data'} =~ /\S/ || $self->error($self->{'text_hash'}->{'batch_etext'});
	}

$self->ui_print_unbuffered_header(undef, $self->{'text_hash'}->{'batch_title'}, "");

# Force defaults for save options
$self->{'in_hash'}->{'makehome'} = 1 if (!$self->{'access_hash'}->{'makehome'});
$self->{'in_hash'}->{'copy'} = 1 if (!$self->{'access_hash'}->{'copy'} && $self->{'config_hash'}->{'user_files'} =~ /\S/);
$self->{'in_hash'}->{'movehome'} = 1 if (!$self->{'access_hash'}->{'movehome'});
$self->{'in_hash'}->{'chuid'} = 1 if (!$self->{'access_hash'}->{'chuid'});
$self->{'in_hash'}->{'chgid'} = 1 if (!$self->{'access_hash'}->{'chgid'});

# Work out a good base UID for new users
$self->build_user_used(\%{$self->{'used_hash'}}, undef, \%{$self->{'taken_hash'}});
$self->{'newuid'} = int($self->{'config_hash'}->{'base_uid'} > $self->{'access_hash'}->{'lowuid'} ?
	      $self->{'config_hash'}->{'base_uid'} : $self->{'access_hash'}->{'lowuid'});

# Work out a good base GID for new groups
$self->build_group_used(\%{$self->{'gused_hash'}}, \%{$self->{'gtaken_hash'}});
if ($self->{'config_hash'}->{'new_user_gid'}) {
	%{$self->{'used_hash'}} = ( %{$self->{'used_hash'}}, %{$self->{'gused_hash'}} );
	}
$self->{'newgid'} = int($self->{'config_hash'}->{'base_gid'} > $self->{'access_hash'}->{'lowgid'} ?
	      $self->{'config_hash'}->{'base_gid'} : $self->{'access_hash'}->{'lowgid'});
@{$self->{'glist_array'}} = $self->list_groups();

# Process the file
$self->batch_start() if ($self->{'in_hash'}->{'batch'});
$self->lock_user_files();
$self->{'lnum'} = $self->{'created'} = $self->{'modified'} = $self->{'deleted'} = 0;
print "<pre>\n";
$self->{'pft'} = $self->passfiles_type();
foreach $line (split(/[\r\n]+/, $self->{'data'})) {
	$self->{'lnum'}++;
	$line =~ s/^\s*#.*$//;
	next if ($line !~ /\S/);
	local @line = split(/:/, $line, -1);
	local %user;
	if ($line[0] eq 'create') {
		# Creating a new user
		if ($self->{'pft'} == 5) {
			# Openserver passwd and short shadow information
			if (@line != 10) {
				print $self->text('batch_elen', $self->{'lnum'}, 10),"\n";
				next;
				}
			$user{'min'} = $line[8];
			$user{'max'} = $line[9];
			}
		elsif ($self->{'pft'} == 4) {
			# AIX passwd and security information
			if (@line != 12) {
				print $self->text('batch_elen', $self->{'lnum'}, 12),"\n";
				next;
				}
			$user{'min'} = $line[8];
			$user{'max'} = $line[9];
			$user{'expire'} = $line[10];
			map { $user{$_}++ } split(/\s+/, $line[11]);
			}
		elsif ($self->{'pft'} == 2) {
			# SYSV-style passwd and shadow information
			if (@line != 13) {
				print $self->text('batch_elen', $self->{'lnum'}, 13),"\n";
				next;
				}
			$user{'min'} = $line[8];
			$user{'max'} = $line[9];
			$user{'warn'} = $line[10];
			$user{'inactive'} = $line[11];
			$user{'expire'} = $line[12];
			$user{'change'} = $line[2] eq '' ? '' :
						int(time() / (60*60*24));
			}
		elsif ($self->{'pft'} == 1 || $self->{'pft'} == 6) {
			# BSD master.passwd information
			if (@line != 11) {
				print $self->text('batch_elen', $self->{'lnum'}, 11),"\n";
				next;
				}
			$user{'class'} = $line[8];
			$user{'change'} = $line[9];
			$user{'expire'} = $line[10];
			}
		else {
			# Classic passwd file information (type 0 and 3)
			if (@line != 8) {
				print $self->text('batch_elen', $self->{'lnum'}, 8),"\n";
				next;
				}
			}

		# Parse common fields
		if (!$line[1]) {
			print $self->text('batch_eline', $self->{'lnum'}),"\n";
			next;
			}
		$user{'user'} = $line[1];
		$self->{'err'} = $self->check_username_restrictions($user{'user'});
		if ($self->{'err'}) {
			print $self->text('batch_echeck', $self->{'lnum'}, $self->{'err'}),"\n";
			next;
			}
		if ($self->{'taken_hash'}->{$user{'user'}}) {
			print $self->text('batch_euser', $self->{'lnum'}, $user{'user'}),"\n";
			next;
			}
		if ($line[3] !~ /^\d+$/) {
			# make up a UID
			while($self->{'used_hash'}->{$self->{'newuid'}}) {
				$self->{'newuid'}++;
				}
			$user{'uid'} = $self->{'newuid'};
			}
		else {
			# use the given UID
			if ($self->{'used_hash'}->{$line[3]} && !$self->{'access_hash'}->{'umultiple'}) {
				print $self->text('batch_ecaccess', $self->{'lnum'},
					    $self->{'text_hash'}->{'usave_euidused2'}),"\n";
				next;
				}
			$user{'uid'} = $line[3];
			}
		$self->{'used_hash'}->{$user{'uid'}}++;
		if (!-r $line[7]) {
			print $self->text('batch_eshell', $self->{'lnum'}, $line[7]),"\n";
			next;
			}
		$user{'shell'} = $line[7];
		$user{'real'} = $line[5];
		local @gids = split(/[ ,]+/, $line[4]);
		$user{'gid'} = $gids[0];
		local $grp = $self->my_getgrgid($gids[0]);

		if ($self->{'access_hash'}->{'autohome'}) {
			# Assign home dir automatically
			$user{'home'} = $self->auto_home_dir($self->{'access_hash'}->{'home'},
						       $user{'user'},
						       $grp);
			}
		else {
			if ($line[6] eq '' && $self->{'config_hash'}->{'home_base'}) {
				# Choose home dir automatically
				$user{'home'} = $self->auto_home_dir(
					$self->{'config_hash'}->{'home_base'}, $user{'user'}, $user{'gid'});
				}
			elsif ($line[6] !~ /^\//) {
				print $self->text('batch_ehome', $self->{'lnum'},$line[6]),"\n";
				next;
				}
			else {
				# Use given home dir
				$user{'home'} = $line[6];
				}
			}

		# Check access control restrictions
		if (!$self->{'access_hash'}->{'ucreate'}) {
			print $self->text('batch_ecaccess', $self->{'lnum'},
				    $self->{'text_hash'}->{'usave_ecreate'});
			next;
			}
		local $ch = &check_user(\%user);
		if ($ch) {
			print $self->text('batch_ecaccess', $self->{'lnum'}, $ch),"\n";
			next;
			}

		# Work out secondary group membership
		local @secs;
		if (@gids > 1) {
			local $i;
			for($i=1; $i<@gids; $i++) {
				local ($group) =
				    grep { $_->{'gid'} eq $gids[$i] } @{$self->{'glist_array'}};
				push(@secs, $group) if ($group);
				}
			}

		# Run the before command
		$self->set_user_envs(\%user, 'CREATE_USER', $user{'plainpass'},
			       [ map { $_->{'gid'} } @secs ]);
		$self->{'merr'} = $self->making_changes();
		$self->error($self->text('usave_emaking', "<tt>$self->{'merr'}</tt>"))
			if (defined($self->{'merr'}));

		if ($user{'gid'} !~ /^\d+$/) {
			# Need to create a new group for the user
			if (!$self->{'access_hash'}->{'gcreate'}) {
				print $self->text('batch_ecaccess', $self->{'lnum'},
					    $self->{'text_hash'}->{'usave_egcreate'}),"\n";
				next;
				}
			if ($self->{'gtaken_hash'}->{$user{'user'}}) {
				print $self->text('batch_egtaken', $self->{'lnum'},
					    $user{'user'}),"\n";
				next;
				}

			if ($self->{'config_hash'}->{'new_user_gid'}) {
				$self->{'newgid'} = $user{'uid'};
				}
			else {
				while($self->{'gused_hash'}->{$self->{'newgid'}}) {
					$self->{'newgid'}++;
					}
				}
			local %group;
			$group{'group'} = $user{'user'};
			$user{'gid'} = $group{'gid'} = $self->{'newgid'};
			$self->create_group(\%group);
			$self->{'gused_hash'}->{$group{'gid'}}++;
			}

		# Create the user!
		if ($self->{'in_hash'}->{'makehome'} && !-d $user{'home'}) {
			$self->create_home_directory(\%user);
			}
		if ($self->{'in_hash'}->{'crypt'}) {
			$user{'pass'} = $line[2];
			$user{'passmode'} = 2;
			}
		elsif ($line[2] eq 'x') {
			# No login allowed
			$user{'pass'} = $self->{'config_hash'}->{'lock_string'};
			$user{'passmode'} = 1;
			}
		elsif ($line[2] eq '') {
			# No password needed
			$user{'pass'} = '';
			$user{'passmode'} = 0;
			}
		else {
			# Normal password
			$user{'pass'} = $self->encrypt_password($line[2]);
			$user{'passmode'} = 3;
			$user{'plainpass'} = $line[2];
			}
		$self->create_user(\%user);

		# Add user to some secondary groups
		local $group;
		foreach $group (@secs) {
			local @mems = split(/,/ , $group->{'members'});
			push(@mems, $user{'user'});
			$group->{'members'} = join(",", @mems);
			$self->modify_group($group, $group);
			}

		# All done
		$self->made_changes();

		# Call other modules, ignoring any failures
		$self->{'error_must_die'} = 1;
		eval {
			$self->other_modules("useradmin_create_user", \%user)
				if ($self->{'access_hash'}->{'cothers'} == 1 && $self->{'in_hash'}->{'others'} ||
				    $self->{'access_hash'}->{'cothers'} == 0);
			};
		$self->{'other_err'} = $@;
		$self->{'error_must_die'} = 0;

		if ($self->{'in_hash'}->{'copy'} && $self->{'in_hash'}->{'makehome'}) {
			# Copy files to user's home directory
			local $groupname = $self->my_getgrgid($user{'gid'});
			local $uf = $self->get_skel_directory(\%user, $groupname);
			$self->copy_skel_files($uf, $user{'home'},
					 $user{'uid'}, $user{'gid'});
			}

		print "<b>",$self->text('batch_created',$user{'user'}),"</b>\n";
		print "<b><i>",$self->text('batch_eother', $self->{'other_err'}),"</i></b>\n"
			if ($self->{'other_err'});
		$self->{'created'}++;
		}
	elsif ($line[0] eq 'delete') {
		# Deleting an existing user
		if (@line != 2) {
			print $self->text('batch_elen', $self->{'lnum'}, 2),"\n";
			next;
			}
		local @ulist = $self->list_users();
		local ($user) = grep { $_->{'user'} eq $line[1] } @ulist;
		if (!$user) {
			print $self->text('batch_enouser', $self->{'lnum'}, $line[1]),"\n";
			next;
			}
		if (!$self->can_edit_user(\%{$self->{'access_hash'}}, $user)) {
			print $self->text('batch_edaccess', $self->{'lnum'},
				    $self->{'text_hash'}->{'udel_euser'}),"\n";
			next;
			}
		if (!$self->{'config_hash'}->{'delete_root'} && $user->{'uid'} <= 10) {
			print $self->text('batch_edaccess', $self->{'lnum'},
				    $self->{'text_hash'}->{'udel_eroot'}),"\n";
			next;
			}

		# Run the before command
		$self->set_user_envs($user, 'DELETE_USER', undef,
			       [ &secondary_groups($user->{'user'}) ]);
		$self->{'merr'} = $self->making_changes();
		$self->error($self->text('usave_emaking', "<tt>$self->{'merr'}</tt>"))
			if (defined($self->{'merr'}));

		# Delete from other modules, ignoring errors
		$self->{'error_must_die'} = 1;
		eval {
			$self->other_modules("useradmin_delete_user", $user)
				if ($self->{'access_hash'}->{'dothers'} == 1 && $self->{'in_hash'}->{'others'} ||
				    $self->{'access_hash'}->{'dothers'} == 0);
			};
		$self->{'other_err'} = $@;
		$self->{'error_must_die'} = 0;

		# Delete the user entry
		$self->delete_user($user);

		# Delete the user from groups
		foreach $g ($self->list_groups()) {
			@mems = split(/,/, $g->{'members'});
			$idx = $self->indexof($user->{'user'}, @mems);
			if ($idx >= 0) {
				splice(@mems, $idx, 1);
				%{$self->{'newg_hash'}} = %$g;
				$self->{'newg_hash'}->{'members'} = join(',', @mems);
				$self->modify_group($g, \%{$self->{'newg_hash'}});
				}
			$self->{'mygroup'} = $g if ($g->{'group'} eq $user->{'user'});
			}

		# Delete the user's group
		if ($self->{'mygroup'} && !$self->{'mygroup'}->{'members'}) {
			local $another;
			foreach $ou ($self->list_users()) {
				$another++
					if ($ou->{'gid'} == $self->{'mygroup'}->{'gid'});
				}
			if (!$another) {
				$self->delete_group($self->{'mygroup'});
				}
			}
		$self->made_changes();

		# Delete his home directory
		if ($self->{'in_hash'}->{'delhome'} && $user->{'home'} !~ /^\/+$/) {
			$self->delete_home_directory($user);
			}

		print "<b>",$self->text('batch_deleted',$user->{'user'}),"</b>\n";
		print "<b><i>",$self->text('batch_eother', $self->{'other_err'}),"</i></b>\n"
			if ($self->{'other_err'});
		$self->{'deleted'}++;
		}
	elsif ($line[0] eq 'modify') {
		# Modifying an existing user
		local $wlen = $self->{'pft'} == 5 ? 11 :
			      $self->{'pft'} == 4 ? 13 :
			      $self->{'pft'} == 2 ? 14 :
			      $self->{'pft'} == 1 || $self->{'pft'} == 6 ? 12 : 9;
		if (@line != $wlen) {
			print $self->text('batch_elen', $self->{'lnum'}, $wlen),"\n";
			next;
			}
		local @ulist = $self->list_users();
		local ($user) = grep { $_->{'user'} eq $line[1] } @ulist;
		if (!$user) {
			print $self->text('batch_enouser', $self->{'lnum'}, $line[1]),"\n";
			next;
			}
		%{$self->{'olduser_hash'}} = %user = %$user;
		$user{'olduser'} = $user->{'user'};
		if (!$self->can_edit_user(\%{$self->{'access_hash'}}, \%user)) {
			print $self->text('batch_emaccess', $self->{'lnum'},
				    $self->{'text_hash'}->{'usave_eedit'}),"\n";
			next;
			}

		# Update supplied fields
		if ($line[2] ne '') {
			if (!$self->{'access_hash'}->{'rename'}) {
				print $self->text('batch_erename', $self->{'lnum'}, $line[1]),"\n";
				}
			$user{'user'} = $line[2];
			}
		if ($self->{'in_hash'}->{'crypt'} && $line[3] ne '') {
			# Changing to pre-encrypted password
			$user{'pass'} = $line[3];
			$user{'passmode'} = 2;
			}
		elsif ($line[3] eq 'x') {
			# No login allowed
			$user{'pass'} = $self->{'config_hash'}->{'lock_string'};
			$user{'passmode'} = 1;
			}
		elsif ($line[3] ne '') {
			# Normal password
			$user{'pass'} = $self->encrypt_password($line[3]);
			$user{'passmode'} = 3;
			$user{'plainpass'} = $line[3];
			}
		else {
			# No change
			$user{'passmode'} = 4;
			}
		$user{'uid'} = $line[4] if ($line[4] ne '');
		$user{'gid'} = $line[5] if ($line[5] ne '');
		$user{'real'} = $line[6] if ($line[6] ne '');
		$user{'home'} = $line[7] if ($line[7] ne '');
		$user{'shell'} = $line[8] if ($line[8] ne '');
		if ($self->{'access_hash'}->{'peopt'}) {
			if ($self->{'pft'} == 5) {
				# Openserver password and short shadow
				$user{'min'}=$line[9] if ($line[9] ne '');
				$user{'max'}=$line[10] if ($line[10] ne '');
				$user{'change'}=int(time() / (60*60*24))
					if ($line[3] ne '');
				}
			elsif ($self->{'pft'} == 4) {
				# AIX password and security information
				$user{'min'}=$line[9] if ($line[9] ne '');
				$user{'max'}=$line[10] if ($line[10] ne '');
				$user{'expire'}=$line[11] if ($line[11] ne '');
				if ($line[12] ne '') {
					delete($user{'admin'});
					delete($user{'admchg'});
					delete($user{'nocheck'});
					map { $user{$_}++ }
					    split(/\s+/, $line[12]);
					}
				$user{'change'}=time() if ($line[3] ne '');
				}
			elsif ($self->{'pft'} == 2) {
				# SYSV-style passwd and shadow information
				$user{'min'}=$line[9] if ($line[9] ne '');
				$user{'max'}=$line[10] if ($line[10] ne '');
				$user{'warn'}=$line[11] if ($line[11] ne '');
				$user{'inactive'}=$line[12]
					if ($line[12] ne '');
				$user{'expire'}=$line[13] if ($line[13] ne '');
				$user{'change'}=int(time() / (60*60*24))
					if ($line[3] ne '');
				}
			elsif ($self->{'pft'} == 1 || $self->{'pft'} == 6) {
				# BSD master.passwd information
				$user{'class'}=$line[9] if ($line[9] ne '');
				$user{'change'}=$line[10] if ($line[10] ne '');
				$user{'expire'}=$line[11] if ($line[11] ne '');
				}
			}

		# Check access control restrictions
		local $ch = &check_user(\%user, \%{$self->{'olduser_hash'}});
		if ($ch) {
			print $self->text('batch_emaccess', $self->{'lnum'}, $ch),"\n";
			next;
			}

		# Run the before command
		$self->set_user_envs(\%user, 'MODIFY_USER', $user{'plainpass'},
			       [ &secondary_groups($user{'user'}) ]);
		$self->{'merr'} = $self->making_changes();
		$self->error($self->text('usave_emaking', "<tt>$self->{'merr'}</tt>"))
			if (defined($self->{'merr'}));

		# Move home directory if needed
		if ($self->{'olduser_hash'}->{'home'} ne $user{'home'} && $self->{'in_hash'}->{'movehome'} &&
		    $user{'home'} ne '/' && $self->{'olduser_hash'}->{'home'} ne '/') {
			if (-d $self->{'olduser_hash'}->{'home'} && !-e $user{'home'}) {
				local $out = $self->backquote_logged(
					"mv \"$self->{'olduser_hash'}->{'home'}\" ".
					"\"$user{'home'}\" 2>&1");
				if ($?) { $self->error($self->text('batch_emove',
						 $self->{'lnum'}, $out)); }
				}
			}

		# Change UIDs and GIDs
		if ($self->{'olduser_hash'}->{'gid'} != $user{'gid'} && $self->{'in_hash'}->{'chgid'}) {
			if ($self->{'in_hash'}->{'chgid'} == 1) {
				$self->recursive_change($user{'home'},$self->{'olduser_hash'}->{'uid'},
					  $self->{'olduser_hash'}->{'gid'}, -1, $user{'gid'});
				}
			else {
				$self->recursive_change("/", $self->{'olduser_hash'}->{'uid'},
					  $self->{'olduser_hash'}->{'gid'}, -1, $user{'gid'});
				}
			}
		if ($self->{'olduser_hash'}->{'uid'} != $user{'uid'} && $self->{'in_hash'}->{'chuid'}) {
			if ($self->{'in_hash'}->{'chuid'} == 1) {
				$self->recursive_change($user{'home'},$self->{'olduser_hash'}->{'uid'},
						  -1, $user{'uid'}, -1);
				}
			else {
				$self->recursive_change("/", $self->{'olduser_hash'}->{'uid'},
						  -1, $user{'uid'}, -1);
				}
			}

		# Actually modify the user
		$self->modify_user(\%{$self->{'olduser_hash'}}, \%user);

		# If the user has been renamed, update any secondary groups
		if ($self->{'olduser_hash'}->{'user'} ne $user{'user'}) {
			foreach $group (@{$self->{'glist_array'}}) {
				local @mems = split(/,/, $group->{'members'});
				local $idx = $self->indexof($self->{'olduser_hash'}->{'user'}, @mems);
				if ($idx >= 0) {
					$mems[$idx] = $user{'user'};
					$group->{'members'} = join(",", @mems);
					$self->modify_group($group, $group);
					}
				}
			}

		$self->made_changes();

		# Modify in other modules, ignoring errors
		$self->{'error_must_die'} = 1;
		eval {
			$self->other_modules("useradmin_modify_user",
				       \%user, \%{$self->{'olduser_hash'}})
				if ($self->{'access_hash'}->{'mothers'} == 1 && $self->{'in_hash'}->{'others'} ||
				    $self->{'access_hash'}->{'mothers'} == 0);
			};
		$self->{'error_must_die'} = 0;
		$self->{'other_err'} = $@;

		print "<b>",$self->text('batch_modified',$self->{'olduser_hash'}->{'user'}),"</b>\n";
		print "<b><i>",$self->text('batch_eother', $self->{'other_err'}),"</i></b>\n"
			if ($self->{'other_err'});
		$self->{'modified'}++;
		}
	else {
		print $self->text('batch_eaction', $self->{'lnum'}, $line[0]),"\n";
		next;
		}
	}
print "</pre>\n";
$self->batch_end() if ($self->{'in_hash'}->{'batch'});
$self->unlock_user_files();
$self->webmin_log("batch", undef, $self->{'in_hash'}->{'source'} == 1 ? $self->{'in_hash'}->{'local'} : undef,
	    { 'created' => $self->{'created'}, 'modified' => $self->{'modified'},
	      'deleted' => $self->{'deleted'}, 'lnum' => $self->{'lnum'} } );

$self->ui_print_footer("batch_form.cgi", $self->{'text_hash'}->{'batch_return'},
		 "", $self->{'text_hash'}->{'index_return'});

1;
		
}

# check_user(\%user, [\%olduser])
# Check access control restrictions for a user
sub check_user
{
	shift if ($self == $_[0]);

# check if uid is within range
if ($self->{'access_hash'}->{'lowuid'} && $_[0]->{'uid'} < $self->{'access_hash'}->{'lowuid'}) {
	return $self->text('usave_elowuid', $self->{'access_hash'}->{'lowuid'});
	}
if ($self->{'access_hash'}->{'hiuid'} && $_[0]->{'uid'} > $self->{'access_hash'}->{'hiuid'}) {
	return $self->text('usave_ehiuid', $self->{'access_hash'}->{'hiuid'});
	}
if ($_[1] && !$self->{'access_hash'}->{'uuid'} && $_[1]->{'uid'} != $_[0]->{'uid'}) {
	return $self->{'text_hash'}->{'usave_euuid'};
	}

# make sure home dir is under the allowed root
if (!$self->{'access_hash'}->{'autohome'}) {
	$self->{'al'} = length($self->{'access_hash'}->{'home'});
	if (length($_[0]->{'home'}) < $self->{'al'} ||
	    substr($_[0]->{'home'}, 0, $self->{'al'}) ne $self->{'access_hash'}->{'home'}) {
		return $self->text('usave_ehomepath', $_[0]->{'home'});
		}
	}

# check for invalid shell
if ($self->{'access_hash'}->{'shells'} ne '*' &&
    $self->indexof($_[0]->{'shell'}, split(/\s+/, $self->{'access_hash'}->{'shells'})) < 0) {
	return $self->text('usave_eshell', $_[0]->{'shell'});
	}

# check for invalid primary group (unless one is dynamically assigned)
if ($user{'gid'} ne '') {
	local $ng = $self->my_getgrgid($_[0]->{'gid'});
	local $ni = $self->can_use_group(\%{$self->{'access_hash'}}, $ng);
	if ($_[1]) {
		if ($_[1]->{'gid'} != $_[0]->{'gid'}) {
			local $og = $self->my_getgrgid($_[1]->{'gid'});
			local $oi = $self->can_use_group(\%{$self->{'access_hash'}}, $og);
			if (!$ni) { return $self->text('usave_eprimary', $ng); }
			if (!$oi) { return $self->text('usave_eprimaryr', $og); }
			}
		}
	else {
		return $self->text('usave_eprimary', $ng) if (!$ni);
		}
	}
return undef;
}

sub secondary_groups
{
	shift if ($self == $_[0]);

local @secs;
foreach $g (@{$self->{'glist_array'}}) {
	@mems = split(/,/, $g->{'members'});
	if ($self->indexof($_[0], @mems) >= 0) {
		push(@secs, $g->{'gid'});
		}
	}
return @secs;
}


1;

