#!/usr/bin/perl

&MAIN();

 sub MAIN {
# delete_group.cgi
# Delete a group, after asking for confirmation

&ModuleLoader::preload_module('useradmin_class', "useradmin::UserLib");
$self = new useradmin::UserLib:: 'useradmin_class',%$self;

$self->ReadParse();
@{$self->{'glist_array'}} = $self->list_groups();
$self->{'group'} = $self->{'glist_array'}->[$self->{'in_hash'}->{'num'}];
$self->{'group'} || $self->error($self->{'text_hash'}->{'gdel_enum'});
$| = 1;
$self->error_setup($self->{'text_hash'}->{'gdel_err'});
%{$self->{'access_hash'}} = $self->get_module_acl();
$self->can_edit_group(\%{$self->{'access_hash'}}, $self->{'group'}) || $self->error($self->{'text_hash'}->{'gdel_egroup'});
$self->{'access_hash'}->{'gdelete'} || $self->error($self->{'text_hash'}->{'gdel_egroup'});

$self->ui_print_header(undef, $self->{'text_hash'}->{'gdel_title'}, "");

if (!$self->{'config_hash'}->{'delete_root'} && $self->{'group'}->{'gid'} <= 10) {
	print "<p> <b>$self->{'text_hash'}->{'gdel_eroot'}</b> <p>\n";
	$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
	exit;
	}

if ($self->{'in_hash'}->{'confirmed'}) {
	# Check for repeat click
	if ($self->{'group'}->{'group'} ne $self->{'in_hash'}->{'group'} || $self->{'in_hash'}->{'group'} eq '') {
		print "<p> <b>$self->{'text_hash'}->{'gdel_ealready'}</b> <p>\n";
		print "<hr>\n";
		$self->footer("", $self->{'text_hash'}->{'index_return'});
		exit;
		}

	# Delete from other modules
	if ($self->{'in_hash'}->{'others'}) {
		print "$self->{'text_hash'}->{'gdel_other'}<br>\n";
		local $error_must_die = 1;
		eval { $self->other_modules("useradmin_delete_group", $self->{'group'}); };
		if ($@) {
			print $self->text('udel_failed', $@),"<p>\n";
			}
		else {
			print "$self->{'text_hash'}->{'gdel_done'}<p>\n";
			}
		}

	# Delete from group file
	$self->lock_user_files();
	print "$self->{'text_hash'}->{'gdel_group'}<br>\n";
	$self->set_group_envs($self->{'group'}, 'DELETE_GROUP');
	$self->{'merr'} = $self->making_changes();
	$self->error($self->text('usave_emaking', "<tt>$self->{'merr'}</tt>")) if (defined($self->{'merr'}));

	$self->delete_group($self->{'group'});
	$self->unlock_user_files();
	$self->made_changes();
	$self->webmin_log("delete", "group", $self->{'group'}->{'group'}, $self->{'group'});
	print "$self->{'text_hash'}->{'gdel_done'}<p>\n";

done:
	$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
	}
else {
	# check if this is anyone's primary group
	foreach $u ($self->list_users()) {
		if ($u->{'gid'} == $self->{'group'}->{'gid'}) {
			print "<b>",$self->text('gdel_eprimary', $u->{'user'}),
			      "</b> <p>\n";
			print "<hr>\n";
			$self->footer("", $self->{'text_hash'}->{'index_return'});
			exit;
			}
		}

	# Ask if the user is sure
	print "<form action=delete_group.cgi>\n";
	print "<input type=hidden name=num value=\"$self->{'in_hash'}->{'num'}\">\n";
	print "<input type=hidden name=group value=\"$self->{'group'}->{'group'}\">\n";
	print "<input type=hidden name=confirmed value=1>\n";
	print "<center><b>",$self->text('gdel_sure', $self->{'group'}->{'group'}),"</b><p>\n";
	print "<input type=submit value=\"$self->{'text_hash'}->{'gdel_del'}\">\n";
	printf "<br><input type=checkbox name=others value=1 %s> %s<br>\n",
		$self->{'config_hash'}->{'default_other'} ? "checked" : "",
		$self->{'text_hash'}->{'gdel_dothers'};
	print "</center><p>\n";
	print "</form>\n";
	$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
	}

1;
		
}


1;

