#!/usr/bin/perl

&MAIN();

 sub MAIN {
# delete_user.cgi
# Delete a user, after asking for confirmation

&ModuleLoader::preload_module('useradmin_class', "useradmin::UserLib");
$self = new useradmin::UserLib:: 'useradmin_class',%$self;

$self->ReadParse();
$self->lock_user_files();
@{$self->{'ulist_array'}} = $self->list_users();
$self->{'user'} = $self->{'ulist_array'}->[$self->{'in_hash'}->{'num'}];
$self->{'user'} || $self->error($self->{'text_hash'}->{'udel_enum'});
$self->error_setup($self->{'text_hash'}->{'udel_err'});
%{$self->{'access_hash'}} = $self->get_module_acl();
$self->can_edit_user(\%{$self->{'access_hash'}}, $self->{'user'}) || $self->error($self->{'text_hash'}->{'udel_euser'});
$self->{'access_hash'}->{'udelete'} || $self->error($self->{'text_hash'}->{'udel_euser'});

$| = 1;
$self->ui_print_header(undef, $self->{'text_hash'}->{'udel_title'}, "");

if (!$self->{'config_hash'}->{'delete_root'} && $self->{'user'}->{'uid'} <= 10) {
	print "<p> <b>$self->{'text_hash'}->{'udel_eroot'}</b> <p>\n";
	print "<hr>\n";
	$self->footer("", $self->{'text_hash'}->{'index_return'});
	exit;
	}

# Check for repeat click
if ($self->{'user'}->{'user'} ne $self->{'in_hash'}->{'user'} || $self->{'in_hash'}->{'user'} eq '') {
	print "<p> <b>$self->{'text_hash'}->{'udel_ealready'}</b> <p>\n";
	print "<hr>\n";
	$self->footer("", $self->{'text_hash'}->{'index_return'});
	exit;
	}

if ($self->{'in_hash'}->{'confirmed'}) {
	# Run the before command
	local @secs;
	foreach $g ($self->list_groups()) {
		@{$self->{'mems_array'}} = split(/,/, $g->{'members'});
		if ($self->indexof($self->{'user'}->{'user'}, @{$self->{'mems_array'}}) >= 0) {
			push(@secs, $g->{'gid'});
			}
		}
	$self->set_user_envs($self->{'user'}, 'DELETE_USER', undef, \@secs);
	$self->{'merr'} = $self->making_changes();
	$self->error($self->text('usave_emaking', "<tt>$self->{'merr'}</tt>")) if (defined($self->{'merr'}));

	# Go ahead and do it!
	$self->{'in_hash'}->{'others'} = !$self->{'access_hash'}->{'dothers'} if ($self->{'access_hash'}->{'dothers'} != 1);
	if ($self->{'in_hash'}->{'others'}) {
		print "$self->{'text_hash'}->{'udel_other'}<br>\n";
		local $error_must_die = 1;
		eval { $self->other_modules("useradmin_delete_user", $self->{'user'}); };
		if ($@) {
			print $self->text('udel_failed', $@),"<p>\n";
			}
		else {
			print "$self->{'text_hash'}->{'udel_done'}<p>\n";
			}
		}
	
	print "$self->{'text_hash'}->{'udel_pass'}<br>\n";
	$self->delete_user($self->{'user'});
	print "$self->{'text_hash'}->{'udel_done'}<p>\n";

	print "$self->{'text_hash'}->{'udel_groups'}<br>\n";
	foreach $g ($self->list_groups()) {
		@{$self->{'mems_array'}} = split(/,/, $g->{'members'});
		$self->{'idx'} = $self->indexof($self->{'user'}->{'user'}, @{$self->{'mems_array'}});
		if ($self->{'idx'} >= 0) {
			splice(@{$self->{'mems_array'}}, $self->{'idx'}, 1);
			%{$self->{'newg_hash'}} = %$g;
			$self->{'newg_hash'}->{'members'} = join(',', @{$self->{'mems_array'}});
			$self->modify_group($g, \%{$self->{'newg_hash'}});
			}
		$self->{'mygroup'} = $g if ($g->{'group'} eq $self->{'user'}->{'user'});
		}
	print "$self->{'text_hash'}->{'udel_done'}<p>\n";

	if ($self->{'mygroup'} && !$self->{'mygroup'}->{'members'}) {
		local $another;
		foreach $ou ($self->list_users()) {
			$another = $ou if ($ou->{'gid'} == $self->{'mygroup'}->{'gid'});
			}
		if (!$another) {
			print "$self->{'text_hash'}->{'udel_ugroup'}<br>\n";
			$self->delete_group($self->{'mygroup'});
			print "$self->{'text_hash'}->{'udel_done'}<p>\n";
			}
		}
	$self->unlock_user_files();

	if ($self->{'in_hash'}->{'delhome'} && $self->{'user'}->{'home'} !~ /^\/+$/ && $self->{'access_hash'}->{'delhome'} != 0) {
		# Delete home directory
		print "$self->{'text_hash'}->{'udel_home'}<br>\n";
		$self->lock_file($self->{'user'}->{'home'});
		$self->delete_home_directory($self->{'user'});
		$self->unlock_file($self->{'user'}->{'home'});
		print "$self->{'text_hash'}->{'udel_done'}<p>\n";
		}

	$self->made_changes();

	%{$self->{'p_hash'}} = ( %{$self->{'in_hash'}}, %{$self->{'user'}} );
	delete($self->{'p_hash'}->{'pass'});
	$self->webmin_log("delete", "user", $self->{'user'}->{'user'}, \%{$self->{'p_hash'}});

done:
	$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
	}
else {
	# Check if something has changed
	if ($self->{'user'}->{'user'} ne $self->{'in_hash'}->{'user'}) {
		print "<p> <b>$self->{'text_hash'}->{'udel_echanged'}</b> <p>\n";
		$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
		exit;
		}

	# Ask if the user is sure
	print "<form action=delete_user.cgi>\n";
	print "<input type=hidden name=num value=\"$self->{'in_hash'}->{'num'}\">\n";
	print "<input type=hidden name=user value=\"$self->{'user'}->{'user'}\">\n";
	print "<input type=hidden name=confirmed value=1>\n";

	if ($self->{'user'}->{'home'} ne "/" && -d $self->{'user'}->{'home'} && $self->{'access_hash'}->{'delhome'} != 0) {
		# Has a home directory, so check for files owned by others
		$self->{'size'} = $self->disk_usage_kb($self->{'user'}->{'home'});
		print "<center><b>",$self->text('udel_sure', $self->{'user'}->{'user'},
			   "<tt>$self->{'user'}->{'home'}</tt>", $self->nice_size($self->{'size'}*1024)),
			   "</b><p>\n";
		if ($self->{'access_hash'}->{'delhome'} != 1) {
			print "<input type=submit value=\"$self->{'text_hash'}->{'udel_del1'}\">\n";
			}
		print "<input name=delhome type=submit ",
		      "value=\"$self->{'text_hash'}->{'udel_del2'}\">\n";

		# check for files owned by other users
		@{$self->{'others_array'}} = $self->backquote_command("find ".quotemeta($self->{'user'}->{'home'})." ! -user $self->{'user'}->{'uid'} 2>/dev/null", 1);
		if (@{$self->{'others_array'}}) {
			print "<br><b><font color=#ff0000>",
			      $self->text('udel_others', "<tt>$self->{'user'}->{'home'}</tt>", scalar(@{$self->{'others_array'}})),
			      "</font></b><br>\n";
			}
		}
	else {
		# No home directory
		print "<center><b>",$self->text('udel_sure2',
					   $self->{'user'}->{'user'}),"</b><p>\n";
		print "<input type=submit value=\"$self->{'text_hash'}->{'udel_del1'}\">\n";
		}
	print "<br>\n";
	if ($self->{'access_hash'}->{'dothers'} == 1) {
		printf "<input type=checkbox name=others value=1 %s> %s<br>\n",
			$self->{'config_hash'}->{'default_other'} ? "checked" : "",
	      		$self->{'text_hash'}->{'udel_dothers'};
		}
	if ($self->{'user'}->{'user'} eq 'root') {
		print "<center><b><font color=#ff0000>$self->{'text_hash'}->{'udel_root'}",
		      "</font></b><p></center>\n";
		}
	print "</form></center>\n";

	$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
	}

1;
		
}


1;

