#!/usr/bin/perl

&MAIN();

 sub MAIN {

&ModuleLoader::preload_module('useradmin_class', "useradmin::UserLib");
$self = new useradmin::UserLib:: 'useradmin_class',%$self;

$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", "intro", 1, 1, 0,
		 $self->help_search_link("passwd group shadow gshadow", "man"));
$self->{'formno'} = 0;
%{$self->{'access_hash'}} = $self->get_module_acl();

# Get the user and group lists
@{$self->{'allulist_array'}} = $self->list_users();
@{$self->{'ulist_array'}} = $self->list_allowed_users(\%{$self->{'access_hash'}}, \@{$self->{'allulist_array'}});
@{$self->{'allglist_array'}} = $self->list_groups();
@{$self->{'glist_array'}} = $self->list_allowed_groups(\%{$self->{'access_hash'}}, \@{$self->{'allglist_array'}});
foreach $g (@{$self->{'allglist_array'}}) {
	$self->{'usedgid_hash'}->{$g->{'gid'}} = $g;
	}

# Show users list header
if (@{$self->{'ulist_array'}} || $self->{'access_hash'}->{'ucreate'}) {
	print "<a name=users></a>\n";
	print "<table width=100% cellpadding=0 cellspacing=0><tr>\n";
	print "<td>".$self->ui_subheading($self->{'text_hash'}->{'index_users'})."</td>\n";
	if (@{$self->{'glist_array'}} || $self->{'access_hash'}->{'gcreate'}) {
		print "<td align=right valign=top>",
		      "<a href=#groups>$self->{'text_hash'}->{'index_gjump'}</a></td>\n";
		}
	print "</tr></table>\n";
	}

if (@{$self->{'ulist_array'}} > $self->{'config_hash'}->{'display_max'}) {
	# Display user search form
	print "<b>$self->{'text_hash'}->{'index_toomany'}</b><p>\n";
	print "<form action=search_user.cgi>\n";
	print $self->hlink("<b>$self->{'text_hash'}->{'index_find'}</b>","findform"),
	      " <select name=field>\n";
	print "<option value=user selected>$self->{'text_hash'}->{'user'}\n";
	print "<option value=real>$self->{'text_hash'}->{'real'}\n";
	print "<option value=shell>$self->{'text_hash'}->{'shell'}\n";
	print "<option value=home>$self->{'text_hash'}->{'home'}\n";
	print "<option value=uid>$self->{'text_hash'}->{'uid'}\n";
	print "<option value=group>$self->{'text_hash'}->{'gid'}\n";
	print "<option value=gid>$self->{'text_hash'}->{'gidnum'}\n";
	print "</select> <select name=match>\n";
	print "<option value=0 checked>$self->{'text_hash'}->{'index_equals'}\n";
	print "<option value=4>$self->{'text_hash'}->{'index_contains'}\n";
	print "<option value=1>$self->{'text_hash'}->{'index_matches'}\n";
	print "<option value=2>$self->{'text_hash'}->{'index_nequals'}\n";
	print "<option value=5>$self->{'text_hash'}->{'index_ncontains'}\n";
	print "<option value=3>$self->{'text_hash'}->{'index_nmatches'}\n";
	print "<option value=6>$self->{'text_hash'}->{'index_lower'}\n";
	print "<option value=7>$self->{'text_hash'}->{'index_higher'}\n";
	print "</select> <input name=what size=15>&nbsp;&nbsp;\n";
	print "<input type=submit value=\"$self->{'text_hash'}->{'find'}\"></form>\n";
	$self->{'formno'}++;
	}
elsif (@{$self->{'ulist_array'}}) {
	# Display a table of all users
	@{$self->{'ulist_array'}} = $self->sort_users(\@{$self->{'ulist_array'}}, $self->{'config_hash'}->{'sort_mode'});
	if ($self->{'access_hash'}->{'icons'}) {
		# Show an icon for each user
		&show_user_buttons();
		local @icons = map { "images/user.gif" } @{$self->{'ulist_array'}};
		local @links = map { "edit_user.cgi?num=$_->{'num'}" } @{$self->{'ulist_array'}};
		local @titles = map { $_->{'user'} } @{$self->{'ulist_array'}};
		$self->icons_table(\@links, \@titles, \@icons, 5);
		}
	elsif ($self->{'config_hash'}->{'display_mode'} == 2) {
		# Show usernames under groups
		foreach $u (@{$self->{'ulist_array'}}) {
			push(@{$self->{'ug_hash'}->{$u->{'gid'}}}, $u);
			}
		&show_user_buttons();
		print "<table width=100% border>\n";
		print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'index_ugroup'}</b></td> ",
		      "<td><b>$self->{'text_hash'}->{'index_users'}</b></td> </tr>\n";
		foreach $g (keys %{$self->{'ug_hash'}}) {
			print "<tr $self->{'cb'}> <td width=20%><b>",
			      $self->html_escape($self->{'usedgid_hash'}->{$g}->{'group'}),
			      "</b></td>\n";
			print "<td width=80%><table width=100% ",
			      "cellpadding=0 cellspacing=0>\n";
			$i = 0;
			foreach $u (@{$self->{'ug_hash'}->{$g}}) {
				if ($i%4 == 0) { print "<tr>\n"; }
				print "<td width=25%>",$self->user_link($u),"</td>\n";
				if ($i%4 == 3) { print "</tr>\n"; }
				$i++;
				}
			print "</table></td> </tr>\n";
			}
		print "</table>\n";
		}
	elsif ($self->{'config_hash'}->{'display_mode'} == 1) {
		# Show names, real names, home dirs and shells
		$self->users_table(\@{$self->{'ulist_array'}}, $self->{'formno'}++, 0, 0, [ &get_user_buttons() ]);
		$self->{'no_user_buttons'} = 1;
		}
	else {
		# Just show names
		&show_user_buttons();
		print "<table width=100% border>\n";
		print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'index_users'}</b></td> </tr>\n";
		print "<tr $self->{'cb'}> <td><table width=100%>\n";
		for($i=0; $i<@{$self->{'ulist_array'}}; $i++) {
			if ($i%4 == 0) { print "<tr>\n"; }
			print "<td width=25%>",$self->user_link($self->{'ulist_array'}->[$i]),"</td>\n";
			if ($i%4 == 3) { print "</tr>\n"; }
			}
		print "</table></td> </tr></table>\n";
		}
	}
elsif ($self->{'access_hash'}->{'ucreate'}) {
	if (@{$self->{'allulist_array'}}) {
		print "<b>$self->{'text_hash'}->{'index_notusers'}</b>. <p>\n";
		}
	else {
		print "<b>$self->{'text_hash'}->{'index_notusers2'}</b>. <p>\n";
		}
	}
&show_user_buttons() if (!$self->{'no_user_buttons'});
print "<p>\n";

if (@{$self->{'glist_array'}} || $self->{'access_hash'}->{'gcreate'}) {
	print "<hr>\n";
	print "<a name=groups></a>\n";
	print "<table width=100% cellpadding=0 cellspacing=0><tr>\n";
	print "<td>".$self->ui_subheading($self->{'text_hash'}->{'index_groups'})."</td>\n";
	if (@{$self->{'ulist_array'}} || $self->{'access_hash'}->{'ucreate'}) {
		print "<td align=right valign=top>",
		      "<a href=#users>$self->{'text_hash'}->{'index_ujump'}</a></td>\n";
		}
	print "</tr></table>\n";
	}
if (@{$self->{'glist_array'}} > $self->{'config_hash'}->{'display_max'}) {
	# Display group search form
	print "<b>$self->{'text_hash'}->{'index_gtoomany'}</b><p>\n";
	print "<form action=search_group.cgi>\n";
	print $self->hlink("<b>$self->{'text_hash'}->{'index_gfind'}</b>","gfindform"),
	      " <select name=field>\n";
	print "<option value=group selected>$self->{'text_hash'}->{'gedit_group'}\n";
	print "<option value=members>$self->{'text_hash'}->{'gedit_members'}\n";
	print "<option value=gid>$self->{'text_hash'}->{'gedit_gid'}\n";
	print "</select> <select name=match>\n";
	print "<option value=0 checked>$self->{'text_hash'}->{'index_equals'}\n";
	print "<option value=4>$self->{'text_hash'}->{'index_contains'}\n";
	print "<option value=1>$self->{'text_hash'}->{'index_matches'}\n";
	print "<option value=2>$self->{'text_hash'}->{'index_nequals'}\n";
	print "<option value=5>$self->{'text_hash'}->{'index_ncontains'}\n";
	print "<option value=3>$self->{'text_hash'}->{'index_nmatches'}\n";
	print "<option value=6>$self->{'text_hash'}->{'index_lower'}\n";
	print "<option value=7>$self->{'text_hash'}->{'index_higher'}\n";
	print "</select> <input name=what size=15>&nbsp;&nbsp;\n";
	print "<input type=submit value=\"$self->{'text_hash'}->{'find'}\"></form>\n";
	$self->{'formno'}++;
	}
elsif (@{$self->{'glist_array'}}) {
	@{$self->{'glist_array'}} = $self->sort_groups(\@{$self->{'glist_array'}}, $self->{'config_hash'}->{'sort_mode'});
	if ($self->{'access_hash'}->{'icons'}) {
		# Show an icon for each group
		&show_group_buttons();
		local @icons = map { "images/group.gif" } @{$self->{'glist_array'}};
		local @links = map { "edit_group.cgi?num=$_->{'num'}" } @{$self->{'glist_array'}};
		local @titles = map { $_->{'group'} } @{$self->{'glist_array'}};
		$self->icons_table(\@links, \@titles, \@icons, 5);
		}
	elsif ($self->{'config_hash'}->{'display_mode'} == 1) {
		# Display group name, ID and members
		$self->groups_table(\@{$self->{'glist_array'}}, $self->{'formno'}++, 0, [ &get_group_buttons() ]);
		$self->{'no_group_buttons'} = 1;
		}
	else {
		# Just display group names
		&show_group_buttons();
		print "<table width=100% border>\n";
		print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'index_groups'}</b></td> </tr>\n";
		print "<tr $self->{'cb'}> <td><table width=100%>\n";
		for($i=0; $i<@{$self->{'glist_array'}}; $i++) {
			if ($i%4 == 0) { print "<tr>\n"; }
			print "<td width=25%>",
			      $self->group_link($self->{'glist_array'}->[$i]),"</td>\n";
			if ($i%4 == 3) { print "</tr>\n"; }
			}
		print "</table></td> </tr></table>\n";
		}
	}
elsif ($self->{'access_hash'}->{'gcreate'} == 1) {
	print "<hr>\n";
	if (@{$self->{'allglist_array'}}) {
		print "<b>$self->{'text_hash'}->{'index_notgroups'}</b>. <p>\n";
		}
	else {
		print "<b>$self->{'text_hash'}->{'index_notgroups2'}</b>. <p>\n";
		}
	}
&show_group_buttons() if (!$self->{'no_group_buttons'});

if ($self->{'access_hash'}->{'logins'}) {
	print "<hr>\n";
	print "<table width=100%><tr>\n";
	print "<form action=list_logins.cgi>\n";
	print "<td><input type=submit value=\"$self->{'text_hash'}->{'index_logins'}\">\n";
	print "<input name=username size=8> ",
	      $self->user_chooser_button("username",0,$self->{'formno'}),"</td></form>\n";

	if ($self->UNIVERSAL::can('logged_in_users')) {
		print "<form action=list_who.cgi>\n";
		print "<td align=right><input type=submit ",
		      "value=\"$self->{'text_hash'}->{'index_who'}\"></td></form>\n";
		}
	print "</tr></table>\n";
	}

$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});
 
1;
		
}

sub get_user_buttons
{
	shift if ($self == $_[0]);

local @rv;
if ($self->{'access_hash'}->{'ucreate'}) {
	local $cancreate;
	if ($self->{'access_hash'}->{'hiuid'} && !$self->{'access_hash'}->{'umultiple'}) {
		foreach $u (@{$self->{'allulist_array'}}) {
			$self->{'useduid_hash'}->{$u->{'uid'}}++;
			}
		for($i=int($self->{'access_hash'}->{'lowuid'}); $i<=$self->{'access_hash'}->{'hiuid'}; $i++) {
			if (!$self->{'useduid_hash'}->{$i}) {
				$cancreate = 1;
				last;
				}
			}
		}
	else { $cancreate = 1; }
	if ($cancreate) {
		push(@rv, "<a href=\"edit_user.cgi\">".
		      	  "$self->{'text_hash'}->{'index_createuser'}</a>");
		}
	else {
		push(@rv, $self->{'text_hash'}->{'index_nomoreusers'});
		}
	}
push(@rv, "<a href=\"batch_form.cgi\">$self->{'text_hash'}->{'index_batch'}</a>")
	if ($self->{'access_hash'}->{'batch'});
push(@rv, "<a href=\"export_form.cgi\">$self->{'text_hash'}->{'index_export'}</a>")
	if ($self->{'access_hash'}->{'export'});
return @rv;
}

sub show_user_buttons
{
	shift if ($self == $_[0]);

local @b = &get_user_buttons();
print $self->ui_links_row(\@b);
}

sub get_group_buttons
{
	shift if ($self == $_[0]);

local @rv;
if ($self->{'access_hash'}->{'gcreate'} == 1) {
	local $cancreate;
	if ($self->{'access_hash'}->{'higid'} && !$self->{'access_hash'}->{'gmultiple'}) {
		for($i=int($self->{'access_hash'}->{'lowgid'}); $i<=$self->{'access_hash'}->{'higid'}; $i++) {
			if (!$self->{'usedgid_hash'}->{$i}) {
				$cancreate = 1;
				last;
				}
			}
		}
	else { $cancreate = 1; }
	if ($cancreate) {
		push(@rv, "<a href=\"edit_group.cgi\">$self->{'text_hash'}->{'index_creategroup'}</a>");
		}
	else {
		push(@rv, $self->{'text_hash'}->{'index_nomoregroups'});
		}
	}
return @rv;
}

sub show_group_buttons
{
	shift if ($self == $_[0]);

local @b = &get_group_buttons();
print $self->ui_links_row(\@b);
}


1;

