#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Delete multiple groups

&ModuleLoader::preload_module('useradmin_class', "useradmin::UserLib");
$self = new useradmin::UserLib:: 'useradmin_class',%$self;

$self->ReadParse();
%{$self->{'access_hash'}} = $self->get_module_acl();
%{$self->{'glist_hash'}} = map { $_->{'group'}, $_ } $self->list_groups();
$self->error_setup($self->{'text_hash'}->{'gmass_err'});
foreach $name (split(/\0/, $self->{'in_hash'}->{'d'})) {
	$group = $self->{'glist_hash'}->{$name};
	if ($group) {
		$self->can_edit_group(\%{$self->{'access_hash'}}, $group) ||
			$self->error($self->text('gmass_egroup', $name));
		push(@{$self->{'dlist_array'}}, $group);
		$self->{'delete_sys'} = $group if ($group->{'gid'} < 10 &&
		    (!$self->{'delete_sys'} || $self->{'user'}->{'gid'} < $self->{'delete_sys'}->{'gid'}));
		}
	}
@{$self->{'dlist_array'}} || $self->error($self->{'text_hash'}->{'gmass_enone'});
$self->{'access_hash'}->{'gdelete'} || $self->error($self->{'text_hash'}->{'gdel_egroup'});

$self->ui_print_header(undef, $self->{'text_hash'}->{'gmass_title'}, "");

# Check for deletion of system group
if (!$self->{'config_hash'}->{'delete_root'} && $self->{'delete_sys'}) {
	print "<p> <b>",$self->text('gmass_eroot',
			      $self->{'delete_root'}->{'group'}),"</b> <p>\n";
	$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
	exit;
	}

if ($self->{'in_hash'}->{'confirmed'}) {
	foreach $group (@{$self->{'dlist_array'}}) {
		# Show username
		print "<b>",$self->text('gmass_doing', $group->{'group'}),"</b><br>\n";
		print "<ul>\n";

		# Delete from other modules
		if ($self->{'in_hash'}->{'others'}) {
			print "$self->{'text_hash'}->{'gdel_other'}<br>\n";
			local $error_must_die = 1;
			eval { $self->other_modules("useradmin_delete_group", $group); };
			if ($@) {
				print $self->text('udel_failed', $@),"<p>\n";
				}
			else {
				print "$self->{'text_hash'}->{'gdel_done'}<p>\n";
				}
			}

		# Delete from group file
		$self->lock_user_files();
		print "$self->{'text_hash'}->{'gdel_group'}<br>\n";
		$self->set_group_envs($group, 'DELETE_GROUP');
		$self->{'merr'} = $self->making_changes();
		$self->error($self->text('usave_emaking', "<tt>$self->{'merr'}</tt>")) if (defined($self->{'merr'}));

		$self->delete_group($group);
		$self->unlock_user_files();
		$self->made_changes();
		print "$self->{'text_hash'}->{'gdel_done'}<p>\n";

		print "</ul>\n";
		}

	$self->webmin_log("delete", "group", $group->{'group'}, $group);

	$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
	}
else {
	foreach $group (@{$self->{'dlist_array'}}) {
		# check if this is anyone's primary group
		foreach $u ($self->list_users()) {
			if ($u->{'gid'} == $group->{'gid'}) {
				print "<b>",$self->text('gmass_eprimary',
					$group->{'group'}, $u->{'user'}),
					"</b> <p>\n";
				$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
				exit;
				}
			}
		}

	# Ask if the user is sure
	print "<form action=mass_delete_group.cgi method=post>\n";
	foreach $group (@{$self->{'dlist_array'}}) {
		print "<input type=hidden name=d value='$group->{'group'}'>\n";
		}
	print "<input type=hidden name=confirmed value=1>\n";
	print "<center><b>",$self->text('gmass_sure', scalar(@{$self->{'dlist_array'}})),"</b><p>\n";
	print "<input type=submit value=\"$self->{'text_hash'}->{'gdel_del'}\">\n";
	print "<br><input type=checkbox name=others value=1 checked> ",
	      "$self->{'text_hash'}->{'gdel_dothers'}<br>\n";
	print "</center><p>\n";
	print "</form>\n";
	$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
	}

1;
		
}


1;

