#!/usr/bin/perl

&MAIN();

 sub MAIN {
# mass_delete_user.cgi
# Delete multiple users, after asking for confirmation

&ModuleLoader::preload_module('useradmin_class', "useradmin::UserLib");
$self = new useradmin::UserLib:: 'useradmin_class',%$self;

$self->ReadParse();
%{$self->{'access_hash'}} = $self->get_module_acl();
%{$self->{'ulist_hash'}} = map { $_->{'user'}, $_ } $self->list_users();
$self->error_setup($self->{'text_hash'}->{'umass_err'});
foreach $name (split(/\0/, $self->{'in_hash'}->{'d'})) {
	$user = $self->{'ulist_hash'}->{$name};
	if ($user) {
		$self->can_edit_user(\%{$self->{'access_hash'}}, $user) ||
			$self->error($self->text('umass_euser', $name));
		push(@{$self->{'dlist_array'}}, $user);
		$self->{'delete_sys'} = $user if ($user->{'uid'} < 10 &&
		    (!$self->{'delete_sys'} || $user->{'uid'} < $self->{'delete_sys'}->{'uid'}));
		}
	}
@{$self->{'dlist_array'}} || $self->error($self->{'text_hash'}->{'umass_enone'});

if ($self->{'in_hash'}->{'disable'}) {
	# Disabling a bunch of users
	$self->ui_print_unbuffered_header(undef, $self->{'text_hash'}->{'dmass_title'}, "");

	if ($self->{'in_hash'}->{'confirmed'}) {
		foreach $user (@{$self->{'dlist_array'}}) {
			# Show username
			print "<b>",$self->text('dmass_doing', $user->{'user'}),"</b><br>\n";
			print "<ul>\n";

			# Run the before command
			local @secs;
			foreach $g ($self->list_groups()) {
				@{$self->{'mems_array'}} = split(/,/, $g->{'members'});
				if ($self->indexof($user->{'user'}, @{$self->{'mems_array'}}) >= 0) {
					push(@secs, $g->{'gid'});
					}
				}
			$self->set_user_envs($user, 'MODIFY_USER', undef, \@secs);
			$self->{'merr'} = $self->making_changes();
			$self->error($self->text('usave_emaking', "<tt>$self->{'merr'}</tt>"))
				if (defined($self->{'merr'}));

			# Do it
			$self->lock_user_files();
			print "$self->{'text_hash'}->{'dmass_pass'}<br>\n";
			if ($user->{'pass'} !~ /^$self->{'disable_string'}/) {
				$user->{'pass'} =
					$self->{'disable_string'}.$user->{'pass'};
				$self->modify_user($user, $user);
				print "$self->{'text_hash'}->{'udel_done'}<p>\n";
				}
			else {
				print "$self->{'text_hash'}->{'dmass_already'}<p>\n";
				}
			$self->unlock_user_files();

			$self->made_changes();
			print "</ul>\n";
			}

		$self->webmin_log("disable", "users", scalar(@{$self->{'dlist_array'}}),
			    { 'user' => [ map { $_->{'user'} } @{$self->{'dlist_array'}} ] });

		$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
		}
	else {
		# Ask if the user is sure
		print "<form action=mass_delete_user.cgi method=post>\n";
		print "<input type=hidden name=confirmed value=1>\n";
		print "<input type=hidden name=disable value=1>\n";
		foreach $user (@{$self->{'dlist_array'}}) {
			print "<input type=hidden name=d value='$user->{'user'}'>\n";
			}

		# Show buttons
		print "<center><b>",$self->text('dmass_sure',
				   scalar(@{$self->{'dlist_array'}})),"</b><p>\n";
		print "<input type=submit value=\"$self->{'text_hash'}->{'dmass_dis'}\">\n";
		print "<br>\n";
		print "</form></center>\n";

		$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
		}
	}
elsif ($self->{'in_hash'}->{'enable'}) {
	# Enabling a bunch of users
	$self->ui_print_unbuffered_header(undef, $self->{'text_hash'}->{'emass_title'}, "");

	foreach $user (@{$self->{'dlist_array'}}) {
		# Show username
		print "<b>",$self->text('emass_doing', $user->{'user'}),"</b><br>\n";
		print "<ul>\n";

		# Run the before command
		local @secs;
		foreach $g ($self->list_groups()) {
			@{$self->{'mems_array'}} = split(/,/, $g->{'members'});
			if ($self->indexof($user->{'user'}, @{$self->{'mems_array'}}) >= 0) {
				push(@secs, $g->{'gid'});
				}
			}
		$self->set_user_envs($user, 'MODIFY_USER', undef, \@secs);
		$self->{'merr'} = $self->making_changes();
		$self->error($self->text('usave_emaking', "<tt>$self->{'merr'}</tt>"))
			if (defined($self->{'merr'}));

		# Do it
		$self->lock_user_files();
		print "$self->{'text_hash'}->{'emass_pass'}<br>\n";
		if ($user->{'pass'} =~ s/^$self->{'disable_string'}//) {
			$self->modify_user($user, $user);
			print "$self->{'text_hash'}->{'udel_done'}<p>\n";
			}
		else {
			print "$self->{'text_hash'}->{'emass_already'}<p>\n";
			}
		$self->unlock_user_files();

		$self->made_changes();
		print "</ul>\n";
		}

	$self->webmin_log("enable", "users", scalar(@{$self->{'dlist_array'}}),
		    { 'user' => [ map { $_->{'user'} } @{$self->{'dlist_array'}} ] });

	$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
	}
else {
	# Deleting a bunch of users
	$self->{'access_hash'}->{'udelete'} || $self->error($self->{'text_hash'}->{'udel_euser'});
	$self->ui_print_unbuffered_header(undef, $self->{'text_hash'}->{'umass_title'}, "");

	# Check for deletion of system user
	if (!$self->{'config_hash'}->{'delete_root'} && $self->{'delete_sys'}) {
		print "<p> <b>",$self->text('umass_eroot',
				      $self->{'delete_root'}->{'user'}),"</b> <p>\n";
		$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
		exit;
		}

	if ($self->{'in_hash'}->{'confirmed'}) {
		foreach $user (@{$self->{'dlist_array'}}) {
			# Show username
			print "<b>",$self->text('umass_doing', $user->{'user'}),"</b><br>\n";
			print "<ul>\n";

			# Run the before command
			local @secs;
			foreach $g ($self->list_groups()) {
				@{$self->{'mems_array'}} = split(/,/, $g->{'members'});
				if ($self->indexof($user->{'user'}, @{$self->{'mems_array'}}) >= 0) {
					push(@secs, $g->{'gid'});
					}
				}
			$self->set_user_envs($user, 'DELETE_USER', undef, \@secs);
			$self->{'merr'} = $self->making_changes();
			$self->error($self->text('usave_emaking', "<tt>$self->{'merr'}</tt>"))
				if (defined($self->{'merr'}));

			# Go ahead and do it!
			$self->{'others'} = $self->{'config_hash'}->{'default_other'};
			$self->{'others'} = !$self->{'access_hash'}->{'dothers'}
				if ($self->{'access_hash'}->{'dothers'} != 1);
			if ($self->{'others'}) {
				print "$self->{'text_hash'}->{'udel_other'}<br>\n";
				local $error_must_die = 1;
				eval { $self->other_modules("useradmin_delete_user",$user); };
				if ($@) {
					print $self->text('udel_failed', $@),"<p>\n";
					}
				else {
					print "$self->{'text_hash'}->{'udel_done'}<p>\n";
					}
				}
			
			$self->lock_user_files();
			print "$self->{'text_hash'}->{'udel_pass'}<br>\n";
			$self->delete_user($user);
			print "$self->{'text_hash'}->{'udel_done'}<p>\n";

			print "$self->{'text_hash'}->{'udel_groups'}<br>\n";
			foreach $g ($self->list_groups()) {
				@{$self->{'mems_array'}} = split(/,/, $g->{'members'});
				$self->{'idx'} = $self->indexof($user->{'user'}, @{$self->{'mems_array'}});
				if ($self->{'idx'} >= 0) {
					splice(@{$self->{'mems_array'}}, $self->{'idx'}, 1);
					%{$self->{'newg_hash'}} = %$g;
					$self->{'newg_hash'}->{'members'} = join(',', @{$self->{'mems_array'}});
					$self->modify_group($g, \%{$self->{'newg_hash'}});
					}
				$self->{'mygroup'} = $g if ($g->{'group'} eq $user->{'user'});
				}
			print "$self->{'text_hash'}->{'udel_done'}<p>\n";

			if ($self->{'mygroup'} && !$self->{'mygroup'}->{'members'}) {
				local $another;
				foreach $ou ($self->list_users()) {
					$another = $ou if ($ou->{'gid'} == $self->{'mygroup'}->{'gid'});
					}
				if (!$another) {
					print "$self->{'text_hash'}->{'udel_ugroup'}<br>\n";
					$self->delete_group($self->{'mygroup'});
					print "$self->{'text_hash'}->{'udel_done'}<p>\n";
					}
				}
			$self->unlock_user_files();

			if ($self->{'in_hash'}->{'delhome'} && $user->{'home'} !~ /^\/+$/) {
				print "$self->{'text_hash'}->{'udel_home'}<br>\n";
				$self->lock_file($user->{'home'});
				$self->delete_home_directory($user);
				$self->unlock_file($user->{'home'});
				print "$self->{'text_hash'}->{'udel_done'}<p>\n";
				}

			$self->made_changes();
			print "</ul>\n";
			}

		$self->webmin_log("delete", "users", scalar(@{$self->{'dlist_array'}}),
			    { 'user' => [ map { $_->{'user'} } @{$self->{'dlist_array'}} ] });

		$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
		}
	else {
		# Ask if the user is sure
		print "<form action=mass_delete_user.cgi method=post>\n";
		print "<input type=hidden name=confirmed value=1>\n";
		foreach $user (@{$self->{'dlist_array'}}) {
			print "<input type=hidden name=d value='$user->{'user'}'>\n";
			}

		# Sum up home directories
		foreach $user (@{$self->{'dlist_array'}}) {
			if ($user->{'home'} ne "/" && -d $user->{'home'}) {
				$self->{'size'} += $self->disk_usage_kb($user->{'home'});
				}
			}

		# Show buttons
		print "<center><b>",$self->text('umass_sure',
			   scalar(@{$self->{'dlist_array'}}), $self->nice_size($self->{'size'}*1024)),"</b><p>\n";

		if ($self->{'access_hash'}->{'delhome'} == 1) {
			# Force home directory deletion
			print $self->ui_hidden("delhome", 1),"\n";
			print $self->ui_submit($self->{'text_hash'}->{'umass_del2'}),"\n";
			}
		elsif ($self->{'access_hash'}->{'delhome'} == 0) {
			# Never allow home directory deletion
			print $self->ui_submit($self->{'text_hash'}->{'umass_del1'}),"\n";
			}
		else {
			print $self->ui_submit($self->{'text_hash'}->{'umass_del1'}),"\n";
			print $self->ui_submit($self->{'text_hash'}->{'umass_del2'}, "delhome"),"\n";
			}

		print "<br>\n";
		printf "<input type=checkbox name=others value=1 %s> %s<br>\n",
			$self->{'config_hash'}->{'default_other'} ? "checked" : "",
	      		$self->{'text_hash'}->{'udel_dothers'};
		if ($self->{'delete_sys'} && $self->{'delete_sys'}->{'user'} eq 'root') {
			print "<center><b><font color=#ff0000>$self->{'text_hash'}->{'udel_root'}",
			      "</font></b><p></center>\n";
			}
		print "</form></center>\n";

		$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
		}
	}

1;
		
}


1;

