#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_group.cgi
# Saves or creates a new group

&ModuleLoader::preload_module('useradmin_class', "useradmin::UserLib");
$self = new useradmin::UserLib:: 'useradmin_class',%$self;

require 'timelocal.pl';
$self->error_setup($self->{'text_hash'}->{'gsave_err'});
$self->ReadParse();
%{$self->{'access_hash'}} = $self->get_module_acl();

# Build list of used GIDs
$self->build_group_used(\%{$self->{'gused_hash'}});

# Strip out \n characters in inputs
$self->{'in_hash'}->{'group'} =~ s/\r|\n//g;
$self->{'in_hash'}->{'pass'} =~ s/\r|\n//g;
$self->{'in_hash'}->{'encpass'} =~ s/\r|\n//g;
$self->{'in_hash'}->{'gid'} =~ s/\r|\n//g;

$self->lock_user_files();
@{$self->{'glist_array'}} = $self->list_groups();
if ($self->{'in_hash'}->{'num'} ne "") {
	# get old group
	%{$self->{'ogroup_hash'}} = %{$self->{'glist_array'}->[$self->{'in_hash'}->{'num'}]};
	$self->{'group_hash'}->{'group'} = $self->{'ogroup_hash'}->{'group'};
	$self->can_edit_group(\%{$self->{'access_hash'}}, \%{$self->{'ogroup_hash'}}) || $self->error($self->{'text_hash'}->{'gsave_eedit'});
	}
else {
	# check group name
	$self->{'access_hash'}->{'gcreate'}==1 || $self->error($self->{'text_hash'}->{'gsave_ecreate'});
	$self->{'in_hash'}->{'group'} =~ /^[^:\t]+$/ ||
		$self->error($self->text('gsave_ebadname', $self->{'in_hash'}->{'group'}));
	$self->{'config_hash'}->{'max_length'} && length($self->{'in_hash'}->{'group'}) > $self->{'config_hash'}->{'max_length'} &&
		$self->error($self->text('gsave_elength', $self->{'config_hash'}->{'max_length'}));
	$self->my_getgrnam($self->{'in_hash'}->{'group'}) &&
		$self->error($self->text('gsave_einuse', $self->{'in_hash'}->{'group'}));
	$self->{'group_hash'}->{'group'} = $self->{'in_hash'}->{'group'};
	}

# Validate and save inputs
if (!$self->{'in_hash'}->{'gid_def'} || $self->{'in_hash'}->{'num'} ne '') {
	# Only do GID checks if not automatic
	$self->{'in_hash'}->{'gid'} =~ /^[0-9]+$/ || $self->error($self->text('gsave_egid', $self->{'in_hash'}->{'gid'}));
	!$self->{'access_hash'}->{'lowgid'} || $self->{'in_hash'}->{'gid'} >= $self->{'access_hash'}->{'lowgid'} ||
		$self->error($self->text('usave_elowgid', $self->{'access_hash'}->{'lowgid'}));
	!$self->{'access_hash'}->{'higid'} || $self->{'in_hash'}->{'gid'} <= $self->{'access_hash'}->{'higid'} ||
		$self->error($self->text('usave_ehigid', $self->{'access_hash'}->{'higid'}));
	if (!$self->{'access_hash'}->{'ggid'} && %{$self->{'ogroup_hash'}} && $self->{'ogroup_hash'}->{'gid'} != $self->{'in_hash'}->{'gid'}) {
		$self->error($self->{'text_hash'}->{'gsave_eggid'});
		}
	if (!$self->{'access_hash'}->{'gmultiple'}) {
		foreach $og (@{$self->{'glist_array'}}) {
			if ($og->{'gid'} == $self->{'in_hash'}->{'gid'} &&
			    $og->{'group'} ne $self->{'ogroup_hash'}->{'group'}) {
				$self->error($self->text('usave_egidused',
					     $og->{'group'}, $self->{'in_hash'}->{'gid'}));
				}
			}
		}
	}
elsif ( $self->{'in_hash'}->{'gid_def'} eq '1' ) {
	# Can assign GID here
	$self->{'in_hash'}->{'gid'} = int($self->{'config_hash'}->{'base_gid'} > $self->{'access_hash'}->{'lowgid'} ?
			 $self->{'config_hash'}->{'base_gid'} : $self->{'access_hash'}->{'lowgid'});
	while($self->{'gused_hash'}->{$self->{'in_hash'}->{'gid'}}) {
		$self->{'in_hash'}->{'gid'}++;
		}
	if ($self->{'access_hash'}->{'higid'} && $self->{'in_hash'}->{'gid'} > $self->{'access_hash'}->{'higid'}) {
		# Out of GIDs!
		$self->error($self->{'text_hash'}->{'gsave_eallgid'});
		}
	}

elsif ( $self->{'in_hash'}->{'gid_def'} eq '2' ) {
	# Can calculate GID here
        if ( $self->{'config_hash'}->{'gid_calc'} ) {
            $self->{'in_hash'}->{'gid'} = $self->mkgid($self->{'in_hash'}->{'group'});
        } else {
            $self->{'in_hash'}->{'gid'} = $self->berkeley_cksum($self->{'in_hash'}->{'group'});
        }
        $self->error("Unable to calculate GID, invalid group name specified") if ( $self->{'in_hash'}->{'gid'} lt 0 );

	while($self->{'used_hash'}->{$self->{'in_hash'}->{'gid'}}) {
		$self->{'in_hash'}->{'gid'}++;
		}
	if ($self->{'access_hash'}->{'higid'} && $self->{'in_hash'}->{'gid'} > $self->{'access_hash'}->{'higid'}) {
		# Out of GIDS!
		$self->error($self->{'text_hash'}->{'gsave_eallgid'});
		}
	}

@{$self->{'mems_array'}} = split(/\s+/, $self->{'in_hash'}->{members});
$self->{'group_hash'}->{'members'} = join(',', @{$self->{'mems_array'}});
$self->{'group_hash'}->{'gid'} = $self->{'in_hash'}->{'gid'};

$self->{'salt'} = chr(int(rand(26))+65) . chr(int(rand(26))+65);
if ($self->{'in_hash'}->{'passmode'} == 0) { $self->{'group_hash'}->{'pass'} = ""; }
elsif ($self->{'in_hash'}->{'passmode'} == 1) { $self->{'group_hash'}->{'pass'} = $self->{'in_hash'}->{'encpass'}; }
elsif ($self->{'in_hash'}->{'passmode'} == 2) { $self->{'group_hash'}->{'pass'} = $self->unix_crypt($self->{'in_hash'}->{'pass'}, $self->{'salt'}); }

if (%{$self->{'ogroup_hash'}}) {
	# Force defaults for save options if necessary
	$self->{'in_hash'}->{'chgid'} = !$self->{'access_hash'}->{'chgid'} if ($self->{'access_hash'}->{'chgid'} != 1);
	$self->{'in_hash'}->{'others'} = !$self->{'access_hash'}->{'mothers'} if ($self->{'access_hash'}->{'mothers'} != 1);

	# Run the pre-change command
	$self->set_group_envs(\%{$self->{'group_hash'}}, 'MODIFY_GROUP');
	$self->{'merr'} = $self->making_changes();
	$self->error($self->text('usave_emaking', "<tt>$self->{'merr'}</tt>")) if (defined($self->{'merr'}));

	if ($self->{'group_hash'}->{'gid'} != $self->{'ogroup_hash'}->{'gid'} && $self->{'in_hash'}->{'chgid'}) {
		# Change GID on files if needed
		if ($self->{'in_hash'}->{'chgid'} == 1) {
			# Do all the home directories of users in this group
			$self->my_setpwent();
			while(@{$self->{'tmp_array'}} = $self->my_getpwent()) {
				if ($self->{'tmp_array'}->[3] == $self->{'ogroup_hash'}->{'gid'} ||
				    $self->indexof($self->{'tmp_array'}->[0], @{$self->{'mems_array'}}) >= 0) {
					$self->recursive_change(
						$self->{'tmp_array'}->[7], -1, $self->{'ogroup_hash'}->{'gid'},
							 -1, $self->{'group_hash'}->{'gid'});
					}
				}
			$self->my_endpwent();
			}
		else {
			# Do all files in this group from the root dir
			$self->recursive_change("/", -1, $self->{'ogroup_hash'}->{'gid'},
					       -1, $self->{'group_hash'}->{'gid'});
			}
		}

	# Save the group
	$self->modify_group(\%{$self->{'ogroup_hash'}}, \%{$self->{'group_hash'}});
	}
else {
	# Force defaults for save options if necessary
	$self->{'in_hash'}->{'others'} = !$self->{'access_hash'}->{'cothers'} if ($self->{'access_hash'}->{'cothers'} != 1);

	# Creating a new group
	$self->set_group_envs(\%{$self->{'group_hash'}}, 'CREATE_GROUP');
	$self->{'merr'} = $self->making_changes();
	$self->error($self->text('usave_emaking', "<tt>$self->{'merr'}</tt>")) if (defined($self->{'merr'}));

	$self->create_group(\%{$self->{'group_hash'}});
	}
$self->made_changes();
$self->unlock_user_files();

# Run other module's scripts
if ($self->{'in_hash'}->{'others'}) {
	local $error_must_die = 1;
	eval {
		if (%{$self->{'ouser_hash'}}) {
			$self->other_modules("useradmin_modify_group",
				       \%{$self->{'group_hash'}}, \%{$self->{'ogroup_hash'}});
			}
		else {
			$self->other_modules("useradmin_create_group", \%{$self->{'group_hash'}});
			}
		};
	$self->{'others_err'} = $@;
	}

delete($self->{'in_hash'}->{'pass'});
delete($self->{'in_hash'}->{'encpass'});
$self->webmin_log(%{$self->{'ogroup_hash'}} ? 'modify' : 'create', 'group', $self->{'group_hash'}->{'group'}, \%{$self->{'in_hash'}});

# Bounce back to the list, if successful
$self->error($self->text('gsave_eothers', $self->{'others_err'})) if ($self->{'others_err'});
$self->redirect("");

1;
		
}


1;

