#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_user.cgi
# Saves or creates a new user. If the changes require moving of the user's
# home directory or changing file ownerships, do that as well

&ModuleLoader::preload_module('useradmin_class', "useradmin::UserLib");
$self = new useradmin::UserLib:: 'useradmin_class',%$self;

require 'timelocal.pl';
$self->error_setup($self->{'text_hash'}->{'usave_err'});
$self->ReadParse();
%{$self->{'access_hash'}} = $self->get_module_acl();

# Build list of used UIDs and GIDs
$self->build_user_used(\%{$self->{'used_hash'}});
$self->build_group_used(\%{$self->{'used_hash'}}) if ($self->{'config_hash'}->{'new_user_gid'});
$self->build_group_used(\%{$self->{'gused_hash'}});

# Strip out \n characters in inputs
$self->{'in_hash'}->{'real'} =~ s/\r|\n//g;
$self->{'in_hash'}->{'user'} =~ s/\r|\n//g;
$self->{'in_hash'}->{'user'} =~ s/\0.*$//;	# some people reports \0 in usernames!
$self->{'in_hash'}->{'pass'} =~ s/\r|\n//g;
$self->{'in_hash'}->{'encpass'} =~ s/\r|\n//g;
$self->{'in_hash'}->{'home'} =~ s/\r|\n//g;
$self->{'in_hash'}->{'gid'} =~ s/\r|\n//g;
$self->{'in_hash'}->{'uid'} =~ s/\r|\n//g;
$self->{'in_hash'}->{'uid'} = int($self->{'in_hash'}->{'uid'});
$self->{'in_hash'}->{'othersh'} =~ s/\r|\n//g;

# Validate username
$self->{'user_hash'}->{'user'} = $self->{'in_hash'}->{'user'};
$self->{'in_hash'}->{'user'} =~ /^[^:\t]+$/ ||
	$self->error($self->text('usave_ebadname', $self->{'in_hash'}->{'user'}));
$err = $self->check_username_restrictions($self->{'in_hash'}->{'user'});
$self->error($err) if ($err);

$self->lock_user_files();
@{$self->{'ulist_array'}} = $self->list_users();
@{$self->{'glist_array'}} = $self->list_groups();
if ($self->{'in_hash'}->{'num'} ne "") {
	# Get old user info
	%{$self->{'ouser_hash'}} = %{$self->{'ulist_array'}->[$self->{'in_hash'}->{'num'}]};
	if (!$self->{'access_hash'}->{'urename'} && $self->{'ouser_hash'}->{'user'} ne $self->{'user_hash'}->{'user'}) {
		$self->error($self->{'text_hash'}->{'usave_erename'});
		}
	$self->{'user_hash'}->{'olduser'} = $self->{'ouser_hash'}->{'user'};
	if ($self->{'user_hash'}->{'user'} ne $self->{'ouser_hash'}->{'user'}) {
		foreach $ou (@{$self->{'ulist_array'}}) {
			$self->error($self->text('usave_einuse', $self->{'in_hash'}->{'user'}))
				if ($ou->{'user'} eq $self->{'in_hash'}->{'user'});
			}
		$self->{'access_hash'}->{'uedit_mode'} == 2 && $self->error($self->{'text_hash'}->{'usave_erename'});
		$self->{'renaming'} = 1;
		}
	$self->can_edit_user(\%{$self->{'access_hash'}}, \%{$self->{'ouser_hash'}}) || $self->error($self->{'text_hash'}->{'usave_eedit'});
	}
else {
	# check new user details
	$self->{'access_hash'}->{'ucreate'} || $self->error($self->{'text_hash'}->{'usave_ecreate'});
	foreach $ou (@{$self->{'ulist_array'}}) {
		$self->error($self->text('usave_einuse', $self->{'in_hash'}->{'user'}))
			if ($ou->{'user'} eq $self->{'in_hash'}->{'user'});
		}
	}
if (($self->{'in_hash'}->{'num'} eq '' || $self->{'user_hash'}->{'user'} ne $self->{'ouser_hash'}->{'user'}) &&
    $self->{'config_hash'}->{'alias_check'} && $self->foreign_check("sendmail")) {
	# Check if the new username conflicts with a sendmail alias
	$self->foreign_require("sendmail", "sendmail-lib.pl");
	$self->foreign_require("sendmail", "aliases-lib.pl");
	local $conf = $self->foreign_call("sendmail", "get_sendmailcf");
	local $afiles = $self->foreign_call("sendmail", "aliases_file", $conf);
	foreach $a ($self->foreign_call("sendmail", "list_aliases", $afiles)) {
		$self->error($self->text('usave_einuse_a', $self->{'in_hash'}->{'user'}))
			if ($a->{'name'} eq $self->{'in_hash'}->{'user'});
		}
	}

# Validate and store basic inputs
if (!$self->{'in_hash'}->{'uid_def'} || $self->{'in_hash'}->{'num'} ne '') {
	# Only do UID checks if not automatic
	$self->{'in_hash'}->{'uid'} =~ /^\-?[0-9]+$/ || $self->error($self->text('usave_euid', $self->{'in_hash'}->{'uid'}));
	if (!%{$self->{'ouser_hash'}} || $self->{'ouser_hash'}->{'uid'} != $self->{'in_hash'}->{'uid'}) {
		!$self->{'access_hash'}->{'lowuid'} || $self->{'in_hash'}->{'uid'} >= $self->{'access_hash'}->{'lowuid'} ||
			$self->error($self->text('usave_elowuid', $self->{'access_hash'}->{'lowuid'}));
		!$self->{'access_hash'}->{'hiuid'} || $self->{'in_hash'}->{'uid'} <= $self->{'access_hash'}->{'hiuid'} ||
			$self->error($self->text('usave_ehiuid', $self->{'access_hash'}->{'hiuid'}));
		}
	if (!$self->{'access_hash'}->{'uuid'} && %{$self->{'ouser_hash'}} && $self->{'ouser_hash'}->{'uid'} != $self->{'in_hash'}->{'uid'}) {
		$self->error($self->{'text_hash'}->{'usave_euuid'});
		}
	if (!$self->{'access_hash'}->{'umultiple'}) {
		foreach $ou (@{$self->{'ulist_array'}}) {
			if ($ou->{'uid'} == $self->{'in_hash'}->{'uid'} &&
			    $ou->{'user'} ne $self->{'ouser_hash'}->{'user'}) {
				$self->error($self->text('usave_euidused',
					     $ou->{'user'}, $self->{'in_hash'}->{'uid'}));
				}
			}
		}
	}
elsif ( $self->{'in_hash'}->{'uid_def'} eq '1' ) {
	# Can assign UID here
	$self->{'in_hash'}->{'uid'} = int($self->{'config_hash'}->{'base_uid'} > $self->{'access_hash'}->{'lowuid'} ?
			 $self->{'config_hash'}->{'base_uid'} : $self->{'access_hash'}->{'lowuid'});
	while($self->{'used_hash'}->{$self->{'in_hash'}->{'uid'}}) {
		$self->{'in_hash'}->{'uid'}++;
		}
	if ($self->{'access_hash'}->{'hiuid'} && $self->{'in_hash'}->{'uid'} > $self->{'access_hash'}->{'hiuid'}) {
		# Out of UIDs!
		$self->error($self->{'text_hash'}->{'usave_ealluid'});
		}
	}

elsif ( $self->{'in_hash'}->{'uid_def'} eq '2' ) {
	# Can calculate UID here
        if ( $self->{'config_hash'}->{'uid_calc'} ) {
            $self->{'in_hash'}->{'uid'} = $self->mkuid($self->{'in_hash'}->{'user'});
        } else {
            $self->{'in_hash'}->{'uid'} = $self->berkeley_cksum($self->{'in_hash'}->{'user'});
        }
        $self->error("Unable to calculate UID, invalid user name specified") if ( $self->{'in_hash'}->{'uid'} lt 0 );
	while($self->{'used_hash'}->{$self->{'in_hash'}->{'uid'}}) {
		$self->{'in_hash'}->{'uid'}++;
		}
	if ($self->{'access_hash'}->{'hiuid'} && $self->{'in_hash'}->{'uid'} > $self->{'access_hash'}->{'hiuid'}) {
		# Out of UIDs!
		$self->error($self->{'text_hash'}->{'usave_ealluid'});
		}
	}

$self->{'in_hash'}->{'real'} =~ /^[^:]*$/ || $self->error($self->text('usave_ereal', $self->{'in_hash'}->{'real'}));
if ($self->{'in_hash'}->{'shell'} eq "*") { $self->{'in_hash'}->{'shell'} = $self->{'in_hash'}->{'othersh'}; }
if ($self->{'access_hash'}->{'shells'} ne "*") {
	if ($self->indexof($self->{'in_hash'}->{'shell'}, split(/\s+/, $self->{'access_hash'}->{'shells'})) < 0 &&
	    (!%{$self->{'ouser_hash'}} || $self->{'in_hash'}->{'shell'} ne $self->{'ouser_hash'}->{'shell'})) {
		$self->error($self->text('usave_eshell', $self->{'in_hash'}->{'shell'}));
		}
	}
$self->{'user_hash'}->{'uid'} = $self->{'in_hash'}->{'uid'};
if ($self->{'in_hash'}->{'num'} ne "" || !$self->{'in_hash'}->{'gidmode'}) {
	# Selecting existing group
	$self->{'user_hash'}->{'gid'} = $self->my_getgrnam($self->{'in_hash'}->{'gid'});
	if ($self->{'user_hash'}->{'gid'} eq "") { $self->error($self->text('usave_egid', $self->{'in_hash'}->{'gid'})); }
	$self->{'grp'} = $self->{'in_hash'}->{'gid'};
	}
else {
	# Creating a new group
	$self->{'access_hash'}->{'gcreate'} || $self->error($self->{'text_hash'}->{'usave_egcreate'});
	if ($self->{'in_hash'}->{'gidmode'} == 2) {
		# New group has same name as user
		$self->{'in_hash'}->{'newgid'} = $self->{'in_hash'}->{'user'};
		}
	else {
		# New group has arbitrary name
		$self->{'in_hash'}->{'newgid'} =~ /^[^: \t]+$/ ||
			$self->error($self->text('gsave_ebadname', $self->{'in_hash'}->{'newgid'}));
		}
	foreach $og (@{$self->{'glist_array'}}) {
		$self->error($self->text('usave_einuseg', $self->{'in_hash'}->{'newgid'}))
			if ($og->{'group'} eq $self->{'in_hash'}->{'newgid'});
		}
	$self->{'grp'} = $self->{'in_hash'}->{'newgid'};
	}
if ($self->{'config_hash'}->{'extra_real'}) {
	$self->{'in_hash'}->{'real'} =~ /^[^:,]*$/ || $self->error($self->text('usave_ereal', $self->{'in_hash'}->{'real'}));
	$self->{'in_hash'}->{'office'} =~ /^[^:,]*$/ || $self->error($self->{'text_hash'}->{'usave_eoffice'});
	$self->{'in_hash'}->{'workph'} =~ /^[^:,]*$/ || $self->error($self->{'text_hash'}->{'usave_eworkph'});
	$self->{'in_hash'}->{'homeph'} =~ /^[^:,]*$/ || $self->error($self->{'text_hash'}->{'usave_ehomeph'});
	$self->{'user_hash'}->{'real'} = join(",", $self->{'in_hash'}->{'real'}, $self->{'in_hash'}->{'office'}, $self->{'in_hash'}->{'workph'},
				  $self->{'in_hash'}->{'homeph'});
	$self->{'user_hash'}->{'real'} .= ",$self->{'in_hash'}->{'extra'}" if ($self->{'in_hash'}->{'extra'});
	}
else {
	$self->{'user_hash'}->{'real'} = $self->{'in_hash'}->{'real'};
	}

if ($self->{'config_hash'}->{'real_base'} &&
    $self->{'user_hash'}->{'home'} eq $self->auto_home_dir($self->{'config_hash'}->{'home_base'},
				    $self->{'ouser_hash'}->{'user'}, $self->{'grp'})) {
	# Work out old real home
	$self->{'old_real_home'} = $self->auto_home_dir($self->{'config_hash'}->{'real_base'},
					$self->{'ouser_hash'}->{'user'}, $self->{'grp'});
	}
if ($self->{'access_hash'}->{'autohome'}) {
	# Home directory is forced to automatic
	if ($self->{'in_hash'}->{'new'} || $self->{'ouser_hash'}->{'user'} ne $self->{'user_hash'}->{'user'}) {
		$self->{'user_hash'}->{'home'} = $self->auto_home_dir($self->{'access_hash'}->{'home'}, $self->{'in_hash'}->{'user'},
					       $self->{'grp'});
		$self->{'real_home'} = $self->auto_home_dir($self->{'config_hash'}->{'real_base'}, $self->{'in_hash'}->{'user'},
					    $self->{'grp'}) if ($self->{'config_hash'}->{'real_base'});
		}
	else {
		$self->{'user_hash'}->{'home'} = $self->{'ouser_hash'}->{'home'};
		}
	}
elsif ($self->{'config_hash'}->{'home_base'} && $self->{'in_hash'}->{'home_base'}) {
	# Automatic home directory option chosen
	$self->{'user_hash'}->{'home'} = $self->auto_home_dir($self->{'config_hash'}->{'home_base'}, $self->{'in_hash'}->{'user'},
				       $self->{'grp'});
	$self->{'real_home'} = $self->auto_home_dir($self->{'config_hash'}->{'real_base'}, $self->{'in_hash'}->{'user'},
				    $self->{'grp'}) if ($self->{'config_hash'}->{'real_base'});
	}
else {
	# Manual home directory chosen
	$self->{'user_hash'}->{'home'} = $self->{'in_hash'}->{'home'};
	}
$self->{'real_home'} ||= $self->{'user_hash'}->{'home'};
if (!$self->{'access_hash'}->{'autohome'}) {
	$self->{'user_hash'}->{'home'} =~ /^\// || $self->error($self->text('usave_ehome', $self->{'in_hash'}->{'home'}));
	$self->{'al'} = length($self->{'access_hash'}->{'home'});
	if (length($self->{'user_hash'}->{'home'}) < $self->{'al'} ||
	    substr($self->{'user_hash'}->{'home'}, 0, $self->{'al'}) ne $self->{'access_hash'}->{'home'}) {
		$self->error($self->text('usave_ehomepath', $self->{'user_hash'}->{'home'}));
		}
	}
$self->{'user_hash'}->{'shell'} = $self->{'in_hash'}->{'shell'};
@{$self->{'sgnames_array'}} = $self->{'config_hash'}->{'secmode'} == 2 ? split(/\s+/, $self->{'in_hash'}->{'sgid'})
                                   : split(/\0/, $self->{'in_hash'}->{'sgid'});
foreach $gname (@{$self->{'sgnames_array'}}) {
	$self->{'ingroup_hash'}->{$gname}++;
	$self->{'gid'} = $self->my_getgrnam($gname);
	defined($self->{'gid'}) || $self->error($self->text('usave_esgname', $gname));
	push(@{$self->{'sgids_array'}}, $self->{'gid'});
	}

if ($self->{'access_hash'}->{'ugroups'} ne "*") {
	if ($self->{'in_hash'}->{'num'} ne "") {
		# existing users can only be added to or removed from
		# allowed groups
		if ($self->{'ouser_hash'}->{'gid'} != $self->{'user_hash'}->{'gid'}) {
			$self->can_use_group(\%{$self->{'access_hash'}}, $self->{'in_hash'}->{'gid'}) ||
				$self->error($self->text('usave_eprimary', $self->{'in_hash'}->{'gid'}));
			local $og = $self->my_getgrgid($self->{'ouser_hash'}->{'gid'});
			$self->can_use_group(\%{$self->{'access_hash'}}, $og) ||
				$self->error($self->text('usave_eprimaryr', $og));
			}
		foreach $g (@{$self->{'glist_array'}}) {
			local @mems = split(/,/ , $g->{'members'});
			local $idx = $self->indexof($self->{'ouser_hash'}->{'user'}, @mems);
			if ($self->{'ingroup_hash'}->{$g->{'group'}} && $idx<0 &&
			    !$self->can_use_group(\%{$self->{'access_hash'}}, $g->{'group'})) {
				$self->error($self->text('usave_esecondary',
					     $g->{'group'}));
				}
			elsif (!$self->{'ingroup_hash'}->{$g->{'group'}} && $idx>=0 &&
			       !$self->can_use_group(\%{$self->{'access_hash'}}, $g->{'group'})) {
				$self->error($self->text('usave_esecondaryr',
					     $g->{'group'}));
				}
			}
		}
	elsif (!$self->{'in_hash'}->{'gidmode'}) {
		# new users can only be added to allowed groups
		# This is skipped if we are creating a new group for
		# new users
		$self->can_use_group(\%{$self->{'access_hash'}}, $self->{'in_hash'}->{'gid'}) ||
			$self->error($self->text('usave_eprimary', $self->{'in_hash'}->{'gid'}));
		foreach $gname (@{$self->{'sgnames_array'}}) {
			$self->can_use_group(\%{$self->{'access_hash'}}, $gname) ||
				$self->error($self->text('usave_esecondary', $self->{'group'}));
			}
		}
	}

# Store password input
if ($self->{'in_hash'}->{'passmode'} == 0) {
	# Password is blank
	if (!$self->{'config_hash'}->{'empty_mode'}) {
		local $err = $self->check_password_restrictions("", $self->{'user_hash'}->{'user'});
		$self->error($err) if ($err);
		}
	$self->{'user_hash'}->{'pass'} = "";
	}
elsif ($self->{'in_hash'}->{'passmode'} == 1) {
	# Password is locked
	$self->{'user_hash'}->{'pass'} = $self->{'config_hash'}->{'lock_string'};
	}
elsif ($self->{'in_hash'}->{'passmode'} == 2) {
	# Specific encrypted password entered, or possibly no change
	$self->{'user_hash'}->{'pass'} = $self->{'in_hash'}->{'encpass'};
	}
elsif ($self->{'in_hash'}->{'passmode'} == 3) {
	# Normal password entered - check restrictions
	local $err = $self->check_password_restrictions($self->{'in_hash'}->{'pass'}, $self->{'user_hash'}->{'user'});
	$self->error($err) if ($err);
	$self->{'user_hash'}->{'pass'} = $self->encrypt_password($self->{'in_hash'}->{'pass'});
	}
if ($self->{'in_hash'}->{'disable'} && ($self->{'in_hash'}->{'passmode'} == 2 || $self->{'in_hash'}->{'passmode'} == 3)) {
	$self->{'user_hash'}->{'pass'} = $self->{'disable_string'}.$self->{'user_hash'}->{'pass'};
	}

$self->{'pft'} = $self->passfiles_type();
if ($self->{'pft'} == 2 || $self->{'pft'} == 5) {
	if ($self->{'access_hash'}->{'peopt'}) {
		# Validate shadow-password inputs
		$self->{'in_hash'}->{'min'} =~ /^\-?[0-9]*$/ ||
			$self->error($self->text('usave_emin', $self->{'in_hash'}->{'min'}));
		$self->{'in_hash'}->{'max'} =~ /^\-?[0-9]*$/ ||
			$self->error($self->text('usave_emax', $self->{'in_hash'}->{'max'}));
		$self->{'user_hash'}->{'min'} = $self->{'in_hash'}->{'min'};
		$self->{'user_hash'}->{'max'} = $self->{'in_hash'}->{'max'};
		if ($self->{'pft'} == 2) {
			if ($self->{'in_hash'}->{'expired'} ne "" && $self->{'in_hash'}->{'expirem'} ne ""
			    && $self->{'in_hash'}->{'expirey'} ne "") {
				eval { $self->{'expire'} = timelocal(0, 0, 12,
							$self->{'in_hash'}->{'expired'},
						   	$self->{'in_hash'}->{'expirem'}-1,
							$self->{'in_hash'}->{'expirey'}-1900); };
				if ($@) { $self->error($self->{'text_hash'}->{'usave_eexpire'}); }
				$self->{'expire'} = int($self->{'expire'} / (60*60*24));
				}
			else { $self->{'expire'} = ""; }
			$self->{'user_hash'}->{'expire'} = $self->{'expire'};
			$self->{'in_hash'}->{'warn'} =~ /^\-?[0-9]*$/ ||
			    $self->error($self->text('usave_ewarn', $self->{'in_hash'}->{'warn'}));
			$self->{'in_hash'}->{'inactive'} =~ /^\-?[0-9]*$/ ||
			    $self->error($self->text('usave_einactive', $self->{'in_hash'}->{'inactive'}));
			$self->{'user_hash'}->{'warn'} = $self->{'in_hash'}->{'warn'};
			$self->{'user_hash'}->{'inactive'} = $self->{'in_hash'}->{'inactive'};
			}
		}
	else {
		$self->{'user_hash'}->{'expire'} = $self->{'ouser_hash'}->{'expire'};
		$self->{'user_hash'}->{'min'} = $self->{'ouser_hash'}->{'min'};
		$self->{'user_hash'}->{'max'} = $self->{'ouser_hash'}->{'max'};
		if ($self->{'pft'} == 2) {
			$self->{'user_hash'}->{'warn'} = $self->{'ouser_hash'}->{'warn'};
			$self->{'user_hash'}->{'inactive'} = $self->{'ouser_hash'}->{'inactive'};
			}
		}
	$self->{'daynow'} = int(time() / (60*60*24));
	$self->{'user_hash'}->{'change'} = $self->{'in_hash'}->{'forcechange'} ? 0 :
			  $self->{'pft'} == 5 && $self->{'in_hash'}->{'ask'} ? 0 :
			  !%{$self->{'ouser_hash'}} ? $self->{'daynow'} :
			  $self->{'in_hash'}->{'passmode'} == 3 ? $self->{'daynow'} :
			  $self->{'in_hash'}->{'passmode'} == 2 &&
			  $self->{'user_hash'}->{'pass'} ne $self->{'ouser_hash'}->{'pass'} ? $self->{'daynow'} :
							    $self->{'ouser_hash'}->{'change'};
	}
elsif ($self->{'pft'} == 1 || $self->{'pft'} == 6) {
	if ($self->{'access_hash'}->{'peopt'}) {
		# Validate BSD-password inputs
		if ($self->{'in_hash'}->{'expired'} ne "" && $self->{'in_hash'}->{'expirem'} ne ""
		    && $self->{'in_hash'}->{'expirey'} ne "") {
			eval { $self->{'expire'} = timelocal(59, $self->{'in_hash'}->{'expiremi'},
						   $self->{'in_hash'}->{'expireh'},
						   $self->{'in_hash'}->{'expired'},
						   $self->{'in_hash'}->{'expirem'}-1,
						   $self->{'in_hash'}->{'expirey'}-1900); };
			if ($@) { $self->error($self->{'text_hash'}->{'usave_eexpire'}); }
			}
		else { $self->{'expire'} = ""; }
		if ($self->{'in_hash'}->{'changed'} ne "" && $self->{'in_hash'}->{'changem'} ne ""
		    && $self->{'in_hash'}->{'changey'} ne "") {
			eval { $self->{'change'} = timelocal(59, $self->{'in_hash'}->{'changemi'},
						   $self->{'in_hash'}->{'changeh'},
						   $self->{'in_hash'}->{'changed'},
						   $self->{'in_hash'}->{'changem'}-1,
						   $self->{'in_hash'}->{'changey'}-1900); };
			if ($@) { $self->error($self->{'text_hash'}->{'usave_echange'}); }
			}
		else { $self->{'change'} = ""; }
		$self->{'in_hash'}->{'class'} =~ /^([^: ]*)$/ ||
			$self->error($self->text('usave_eclass', $self->{'in_hash'}->{'class'}));
		$self->{'user_hash'}->{'expire'} = $self->{'expire'};
		$self->{'user_hash'}->{'change'} = $self->{'change'};
		$self->{'user_hash'}->{'class'} = $self->{'in_hash'}->{'class'};
		}
	else {
		$self->{'user_hash'}->{'expire'} = $self->{'ouser_hash'}->{'expire'};
		$self->{'user_hash'}->{'change'} = $self->{'ouser_hash'}->{'change'};
		$self->{'user_hash'}->{'class'} = $self->{'ouser_hash'}->{'class'};
		}
	}
elsif ($self->{'pft'} == 4) {
	# Validate AIX-style password inputs
	if ($self->{'in_hash'}->{'expired'} ne "" && $self->{'in_hash'}->{'expirem'} ne ""	
		&& $self->{'in_hash'}->{'expirey'} ne "" ) {
		# Add a leading zero if only 1 digit long
		$self->{'in_hash'}->{'expirem'} =~ s/^(\d)$/0$1/;
		$self->{'in_hash'}->{'expired'} =~ s/^(\d)$/0$1/;
		$self->{'in_hash'}->{'expireh'} =~ s/^(\d)$/0$1/;
		$self->{'in_hash'}->{'expiremi'} =~ s/^(\d)$/0$1/;
		
		# Only use the last two digits of the year
		$self->{'in_hash'}->{'expirey'} =~ s/^\d\d(\d\d)$/$1/;
		
		# If the user didn't choose the hour and min make them 01
		$self->{'in_hash'}->{'expireh'} = "01" if $self->{'in_hash'}->{'expireh'} eq "";
		$self->{'in_hash'}->{'expiremi'} = "01" if $self->{'in_hash'}->{'expiremi'} eq "";
		$self->{'expire'}="$self->{'in_hash'}->{'expirem'}$self->{'in_hash'}->{'expired'}$self->{'in_hash'}->{'expireh'}$self->{'in_hash'}->{'expiremi'}$self->{'in_hash'}->{'expirey'}";
		}
	else { $self->{'expire'} = ""; }
	if ($self->{'access_hash'}->{'peopt'}) {
		$self->{'user_hash'}->{'admin'} = $self->{'in_hash'}->{'flags'} =~ /admin/;
		$self->{'user_hash'}->{'admchg'} = $self->{'in_hash'}->{'flags'} =~ /admchg/;
		$self->{'user_hash'}->{'nocheck'} = $self->{'in_hash'}->{'flags'} =~ /nocheck/;
		$self->{'user_hash'}->{'expire'} = $self->{'expire'};
		$self->{'user_hash'}->{'min'} = $self->{'in_hash'}->{'min'};
		$self->{'user_hash'}->{'max'} = $self->{'in_hash'}->{'max'};
		$self->{'user_hash'}->{'warn'} = $self->{'in_hash'}->{'warn'};
		}
	else {
		$self->{'user_hash'}->{'admin'} = $self->{'ouser_hash'}->{'admin'};
		$self->{'user_hash'}->{'admchg'} = $self->{'ouser_hash'}->{'admchg'};
		$self->{'user_hash'}->{'nocheck'} = $self->{'ouser_hash'}->{'nocheck'};
		$self->{'user_hash'}->{'expire'} = $self->{'ouser_hash'}->{'expire'};
		$self->{'user_hash'}->{'min'} = $self->{'ouser_hash'}->{'min'};
		$self->{'user_hash'}->{'max'} = $self->{'ouser_hash'}->{'max'};
		$self->{'user_hash'}->{'warn'} = $self->{'ouser_hash'}->{'warn'};
		}
	$self->{'user_hash'}->{'change'} = !%{$self->{'ouser_hash'}} ? time() :
			  $self->{'in_hash'}->{'passmode'} == 3 ? time() :
			  $self->{'user_hash'}->{'pass'} ne $self->{'ouser_hash'}->{'pass'} ? time() :
							    $self->{'ouser_hash'}->{'change'};
	}

if (%{$self->{'ouser_hash'}}) {
	# We are changing an existing user
	if ($self->{'ouser_hash'}->{'uid'} != $self->{'user_hash'}->{'uid'}) {
		$self->{'changing_uid'} = 1;
		}
	if ($self->{'ouser_hash'}->{'gid'} != $self->{'user_hash'}->{'gid'}) {
		$self->{'changing_gid'} = 1;
		}
	if ($self->{'ouser_hash'}->{'home'} ne $self->{'user_hash'}->{'home'}) {
		$self->{'changing_homedir'} = 1;
		}
	$self->{'in_hash'}->{'old'} = $self->{'ouser_hash'}->{'user'};

	# Force defaults for save options if necessary
	$self->{'in_hash'}->{'movehome'} = !$self->{'access_hash'}->{'movehome'} if ($self->{'access_hash'}->{'movehome'} != 1);
	$self->{'in_hash'}->{'chuid'} = !$self->{'access_hash'}->{'chuid'} if ($self->{'access_hash'}->{'chuid'} != 1);
	$self->{'in_hash'}->{'chgid'} = !$self->{'access_hash'}->{'chgid'} if ($self->{'access_hash'}->{'chgid'} != 1);
	$self->{'in_hash'}->{'others'} = !$self->{'access_hash'}->{'mothers'} if ($self->{'access_hash'}->{'mothers'} != 1);

	# Run the pre-change command
	$self->set_user_envs(\%{$self->{'user_hash'}}, 'MODIFY_USER',
		       $self->{'in_hash'}->{'passmode'} == 3 ? $self->{'in_hash'}->{'pass'} : "", \@{$self->{'sgids_array'}});
	$self->{'merr'} = $self->making_changes();
	$self->error($self->text('usave_emaking', "<tt>$self->{'merr'}</tt>")) if (defined($self->{'merr'}));

	# Move the home directory if needed
	if ($self->{'changing_homedir'} && $self->{'in_hash'}->{'movehome'}) {
		$self->error($self->{'text_hash'}->{'usave_efromroot'}) if ($self->{'ouser_hash'}->{'home'} eq "/");
		$self->error($self->{'text_hash'}->{'usave_etoroot'}) if ($self->{'user_hash'}->{'home'} eq "/");
		if (-d $self->{'ouser_hash'}->{'home'} && !-e $self->{'user_hash'}->{'home'}) {
			# Move home directory if the old one exists and
			# the new one does not.
			if ($self->{'real_home'} && $self->{'old_real_home'}) {
				# Move real home dir
				$self->{'out'} = $self->backquote_logged(
					"mv ".quotemeta($self->{'old_real_home'})." ".
					      quotemeta($self->{'real_home'})." 2>&1");
				}
			else {
				$self->{'out'} = $self->backquote_logged(
					"mv ".quotemeta($self->{'ouser_hash'}->{'home'})." ".
					      quotemeta($self->{'user_hash'}->{'home'})." 2>&1");
				}
			if ($?) { $self->error($self->text('usave_emove', $self->{'out'})); }
			}
		}

	# Change GID on files if needed
	if ($self->{'changing_gid'} && $self->{'in_hash'}->{'chgid'}) {
		if ($self->{'in_hash'}->{'chgid'} == 1) {
			$self->recursive_change($self->{'user_hash'}->{'home'}, $self->{'ouser_hash'}->{'uid'},
					  $self->{'ouser_hash'}->{'gid'}, -1, $self->{'user_hash'}->{'gid'});
			}
		else {
			$self->recursive_change("/", $self->{'ouser_hash'}->{'uid'},
					  $self->{'ouser_hash'}->{'gid'}, -1, $self->{'user_hash'}->{'gid'});
			}
		}

	# Change UID on files if needed
	if ($self->{'changing_uid'} && $self->{'in_hash'}->{'chuid'}) {
		if ($self->{'in_hash'}->{'chuid'} == 1) {
			$self->recursive_change($self->{'user_hash'}->{'home'}, $self->{'ouser_hash'}->{'uid'},
					  -1, $self->{'user_hash'}->{'uid'}, -1);
			}
		else {
			$self->recursive_change("/", $self->{'ouser_hash'}->{'uid'},
					  -1, $self->{'user_hash'}->{'uid'}, -1);
			}
		}

	# Update user details
	$self->modify_user(\%{$self->{'ouser_hash'}}, \%{$self->{'user_hash'}});
	$self->{'user_hash'}->{'passmode'} = $self->{'in_hash'}->{'passmode'};
	if ($self->{'in_hash'}->{'passmode'} == 2 && $self->{'user_hash'}->{'pass'} eq $self->{'ouser_hash'}->{'pass'}) {
		# not changing password
		$self->{'user_hash'}->{'passmode'} = 4;
		}
	$self->{'user_hash'}->{'plainpass'} = $self->{'in_hash'}->{'pass'} if ($self->{'in_hash'}->{'passmode'} == 3);
	}
else {
	# Force defaults for save options if necessary
	$self->{'in_hash'}->{'makehome'} = !$self->{'access_hash'}->{'makehome'} if ($self->{'access_hash'}->{'makehome'} != 1);
	$self->{'in_hash'}->{'copy_files'} = !$self->{'access_hash'}->{'copy'} if ($self->{'access_hash'}->{'copy'} != 1 &&
						 $self->{'config_hash'}->{'user_files'} =~ /\S/);
	$self->{'in_hash'}->{'others'} = !$self->{'access_hash'}->{'cothers'} if ($self->{'access_hash'}->{'cothers'} != 1);

	# Run the pre-change command
	$self->set_user_envs(\%{$self->{'user_hash'}}, 'CREATE_USER',
		       $self->{'in_hash'}->{'passmode'} == 3 ? $self->{'in_hash'}->{'pass'} : "", \@{$self->{'sgids_array'}});
	$self->{'merr'} = $self->making_changes();
	$self->error($self->text('usave_emaking', "<tt>$self->{'merr'}</tt>")) if (defined($self->{'merr'}));

	# Create the home directory
	if ($self->{'in_hash'}->{'makehome'}) {
		$self->create_home_directory(\%{$self->{'user_hash'}}, $self->{'real_home'});
		$self->{'made_home'} = 1;
		}

	if ($self->{'in_hash'}->{'gidmode'}) {
		# New group for the new user ..
		if ($self->{'config_hash'}->{'new_user_gid'}) {
			# gid is the same as the uid
			$self->{'newgid'} = $self->{'user_hash'}->{'uid'};
			}
		else {
			# find the first free GID above the base
			$self->{'newgid'} = int($self->{'config_hash'}->{'base_gid'} > $self->{'access_hash'}->{'lowgid'} ?
				      $self->{'config_hash'}->{'base_gid'} : $self->{'access_hash'}->{'lowgid'});
			while($self->{'gused_hash'}->{$self->{'newgid'}}) {
				$self->{'newgid'}++;
				}
			}

		# create a new group for this user
		$self->{'created_group'} = $self->{'group_hash'}->{'group'} = $self->{'in_hash'}->{'newgid'};
		$self->{'user_hash'}->{'gid'} = $self->{'group_hash'}->{'gid'} = $self->{'newgid'};
		$self->create_group(\%{$self->{'group_hash'}});
		$self->{'created_group'} = \%{$self->{'group_hash'}};
		}

	if ($self->{'made_home'}) {
		$self->set_ownership_permissions($self->{'user_hash'}->{'uid'}, $self->{'user_hash'}->{'gid'},
					   undef, $self->{'real_home'}) ||
			$self->error($self->text('usave_echown', $!));
		}

	# Save user details
	$self->create_user(\%{$self->{'user_hash'}});
	$self->{'user_hash'}->{'passmode'} = $self->{'in_hash'}->{'passmode'};
	$self->{'user_hash'}->{'plainpass'} = $self->{'in_hash'}->{'pass'} if ($self->{'in_hash'}->{'passmode'} == 3);

	# Copy files into user's directory
	if ($self->{'in_hash'}->{'copy_files'} && $self->{'in_hash'}->{'makehome'}) {
		local $uf = $self->get_skel_directory(\%{$self->{'user_hash'}}, $self->{'in_hash'}->{'gid'});
		$self->copy_skel_files($uf, $self->{'real_home'}, $self->{'user_hash'}->{'uid'}, $self->{'user_hash'}->{'gid'});
		}
	}

if ($self->{'config_hash'}->{'secmode'} != 1) {
	# Update secondary groups
	foreach $g (@{$self->{'glist_array'}}) {
		@mems = split(/,/ , $g->{'members'});
		if ($self->{'renaming'}) {
			$idx = $self->indexof($self->{'ouser_hash'}->{'user'}, @mems);
			if ($self->{'ingroup_hash'}->{$g->{'group'}} && $idx<0) {
				# Need to add to the group
				push(@mems, $self->{'user_hash'}->{'user'});
				}
			elsif (!$self->{'ingroup_hash'}->{$g->{'group'}} && $idx>=0) {
				# Need to remove from the group
				splice(@mems, $idx, 1);
				}
			elsif ($idx >= 0) {
				# Need to rename in group
				$mems[$idx] = $self->{'user_hash'}->{'user'};
				}
			else { next; }
			}
		else {
			$idx = $self->indexof($self->{'user_hash'}->{'user'}, @mems);
			if ($self->{'ingroup_hash'}->{$g->{'group'}} && $idx<0) {
				# Need to add to the group
				push(@mems, $self->{'user_hash'}->{'user'});
				}
			elsif (!$self->{'ingroup_hash'}->{$g->{'group'}} && $idx>=0) {
				# Need to remove from the group
				splice(@mems, $idx, 1);
				}
			else { next; }
			}
		%{$self->{'newg_hash'}} = %$g;
		$self->{'newg_hash'}->{'members'} = join(',', @mems);
		$self->modify_group($g, \%{$self->{'newg_hash'}});
		}
	}
$self->unlock_user_files();
$self->made_changes();

# Run other modules' scripts
if ($self->{'in_hash'}->{'others'}) {
	$self->{'error_must_die'} = 1;
	eval {
		if (%{$self->{'ouser_hash'}}) {
			$self->other_modules("useradmin_modify_user", \%{$self->{'user_hash'}},\%{$self->{'ouser_hash'}});
			}
		else {
			$self->other_modules("useradmin_create_user", \%{$self->{'user_hash'}});
			}
		if ($self->{'created_group'}) {
			$self->other_modules("useradmin_create_group",
				       $self->{'created_group'});
			}
		};
	$self->{'error_must_die'} = 0;
	$self->{'others_err'} = $@;
	}

delete($self->{'in_hash'}->{'pass'});
delete($self->{'in_hash'}->{'encpass'});
$self->webmin_log(%{$self->{'ouser_hash'}} ? 'modify' : 'create', 'user', $self->{'in_hash'}->{'user'}, \%{$self->{'in_hash'}});
$self->webmin_log('create', 'group', $self->{'created_group'}->{'group'}, \%{$self->{'in_hash'}})
	if ($self->{'created_group'});

# Bounce back to the list, if everything worked
$self->error($self->text('usave_eothers', $self->{'others_err'})) if ($self->{'others_err'});
$self->redirect("");

1;
		
}


1;

