#!/usr/bin/perl
package virtual_server::Acl_security;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'virtual_server::Acl_security');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;

&ModuleLoader::preload_module(ref($self), "virtual_server::VirtualserverLib");
$self = new virtual_server::VirtualserverLib:: ref($self), %$self; 

1;
		return $self;
}

# acl_security_form(&options)
# Output HTML for editing security options for the virtual server module
sub acl_security_form
{
	my $self = shift;

print "<tr> <td colspan=4>$self->{'text_hash'}->{'acl_warn'}</td> </tr>\n";

print "<tr> <td valign=top rowspan=4><b>$self->{'text_hash'}->{'acl_domains'}</b></td>\n";
printf "<td rowspan=4><input type=radio name=domains_def value=1 %s> %s\n",
	$_[0]->{'domains'} eq '*' ? "checked" : "", $self->{'text_hash'}->{'acl_all'};
printf "<input type=radio name=domains_def value=0 %s> %s<br>\n",
	$_[0]->{'domains'} eq '*' ? "" : "checked", $self->{'text_hash'}->{'acl_sel'};
local %doms = map { $_, 1 } split(/\s+/, $_[0]->{'domains'});
print "<select name=domains multiple size=5>\n";
local $d;
foreach $d ($self->list_domains()) {
	printf "<option value=%s %s>%s\n",
		$d->{'id'}, $doms{$d->{'id'}} ? "selected" : "", $d->{'dom'};
	}
print "</select></td> </tr>\n";

foreach $q ('create', 'import', 'edit', 'local', 'stop') {
	print "<tr> <td><b>",$self->{'text_hash'}->{'acl_'.$q},"</b></td> <td>\n";
	printf "<input type=radio name=%s value=1 %s> %s\n",
		$q, $_[0]->{$q} == 1 ? "checked" : "", $self->{'text_hash'}->{'yes'};
	if ($q eq "create") {
		printf "<input type=radio name=%s value=2 %s> %s\n",
			$q, $_[0]->{$q} == 2 ? "checked" : "",
			$self->{'text_hash'}->{'acl_only'};
		}
	elsif ($q eq "edit") {
		printf "<input type=radio name=%s value=2 %s> %s\n",
			$q, $_[0]->{$q} == 2 ? "checked" : "",
			$self->{'text_hash'}->{'acl_lim'};
		}
	printf "<input type=radio name=%s value=0 %s> %s\n",
		$q, $_[0]->{$q} == 0 ? "checked" : "", $self->{'text_hash'}->{'no'};
	print "</td> </tr>\n";
	}

print "<tr> <td valign=top><b>$self->{'text_hash'}->{'limits_features'}</b></td>\n";
print "<td colspan=3><table>\n";
foreach $f (@{$self->{'opt_features_array'}}) {
	print "<tr>\n" if ($self->{'i'}%2 == 0);
        printf "<td><input type=checkbox name=features value=%s %s> %s</td>\n",
                $f, $_[0]->{"feature_$f"} ? "checked" : "",
                $self->{'text_hash'}->{'feature_'.$f};
        print "</tr>\n" if ($self->{'i'}++%2 == 1);
	}
print "</table></td> </tr>\n";
}

# acl_security_save(&options)
# Parse the form for security options for the useradmin module
sub acl_security_save
{
	my $self = shift;

$_[0]->{'domains'} = $self->{'in_hash'}->{'domains_def'} ? "*" :
			join(" ", split(/\0/, $self->{'in_hash'}->{'domains'}));
$_[0]->{'create'} = $self->{'in_hash'}->{'create'};
$_[0]->{'import'} = $self->{'in_hash'}->{'import'};
$_[0]->{'edit'} = $self->{'in_hash'}->{'edit'};
$_[0]->{'local'} = $self->{'in_hash'}->{'local'};
$_[0]->{'stop'} = $self->{'in_hash'}->{'stop'};
%{$self->{'sel_features_hash'}} = map { $_, 1 } split(/\0/, $self->{'in_hash'}->{'features'});
foreach $f (@{$self->{'opt_features_array'}}) {
        $_[0]->{"feature_".$f} = $self->{'sel_features_hash'}->{$f};
        }
}


1;

