#!/usr/bin/perl
package virtual_server::Backup_config;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'virtual_server::Backup_config');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;

&ModuleLoader::preload_module(ref($self), "virtual_server::VirtualserverLib");
$self = new virtual_server::VirtualserverLib:: ref($self), %$self; 

1;

1;
		return $self;
}

# backup_config_files()
# Returns files and directories that can be backed up
sub backup_config_files
{
	my $self = shift;

local @rv;

# Add all domain files
foreach my $d ($self->list_domains()) {
	push(@rv, $d->{'file'});
	}

# Add all bandwidth files
foreach my $d ($self->list_domains()) {
	push(@rv, "$self->{'bandwidth_dir'}/$d->{'id'}")
		if (-r "$self->{'bandwidth_dir'}/$d->{'id'}");
	}

# Add all templates
foreach my $t ($self->list_templates()) {
	if ($t->{'id'} > 0) {
		push(@rv, "$self->{'templates_dir'}/$t->{'id'}");
		}
	}

# Add mail templates
foreach my $tf (@all_template_files) {
	push(@rv, "$self->{'module_config_directory'}/$tf");
	}

# Add other files
push(@rv, $self->{'custom_fields_file'});

return @rv;
}

# pre_backup(&files)
# Called before the files are actually read
sub pre_backup
{
	my $self = shift;

return undef;
}

# post_backup(&files)
# Called after the files are actually read
sub post_backup
{
	my $self = shift;

return undef;
}

# pre_restore(&files)
# Called before the files are restored from a backup
sub pre_restore
{
	my $self = shift;

# Delete other domains
foreach my $d ($self->list_domains()) {
	$self->delete_domain($d);
	}

return undef;
}

# post_restore(&files)
# Called after the files are restored from a backup
sub post_restore
{
	my $self = shift;

return undef;
}


1;

