#!/usr/bin/perl
package virtual_server::Featuremail;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'virtual_server::Featuremail');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;

1;

1;
		return $self;
}

sub require_mail
{
	my $self = shift;

return if ($self->{'require_mail'}++);
$self->{'can_alias_types_hash'}->{12} = 0;	# this autoreponder for vpopmail only
if ($self->{'config_hash'}->{'mail_system'} == 1) {
	# Using sendmail for email
	$self->foreign_require("sendmail", "sendmail-lib.pl");
	$self->foreign_require("sendmail", "virtusers-lib.pl");
	$self->foreign_require("sendmail", "aliases-lib.pl");
	$self->foreign_require("sendmail", "boxes-lib.pl");
	%{$self->{'sconfig_hash'}} = $self->foreign_config("sendmail");
	$self->{'sendmail_conf'} = $main::sendmail_object->get_sendmailcf();
	$self->{'sendmail_vfile'} = $main::sendmail_object->virtusers_file($self->{'sendmail_conf'});
	($self->{'sendmail_vdbm'}, $self->{'sendmail_vdbmtype'}) =
		$main::sendmail_object->virtusers_dbm($self->{'sendmail_conf'});
	$self->{'sendmail_afiles'} = $main::sendmail_object->aliases_file($self->{'sendmail_conf'});
	if ($self->{'config_hash'}->{'generics'}) {
		$self->foreign_require("sendmail", "generics-lib.pl");
		$self->{'sendmail_gfile'} = $main::sendmail_object->generics_file($self->{'sendmail_conf'});
		($self->{'sendmail_gdbm'}, $self->{'sendmail_gdbmtype'}) =
			$main::sendmail_object->generics_dbm($self->{'sendmail_conf'});
		}
	}
elsif ($self->{'config_hash'}->{'mail_system'} == 0) {
	# Using postfix for email
	$self->foreign_require("postfix", "postfix-lib.pl");
	$self->foreign_require("postfix", "boxes-lib.pl");
	%{$self->{'pconfig_hash'}} = $self->foreign_config("postfix");
	$self->{'virtual_type'} = $main::postfix_object->{'virtual_maps'} || "virtual_maps";
	$self->{'virtual_maps'} = $main::postfix_object->get_real_value($self->{'virtual_type'});
	@{$self->{'virtual_map_files_array'}} = $main::postfix_object->get_maps_files($self->{'virtual_maps'});
	$self->{'postfix_afiles'} = [ $main::postfix_object->get_aliases_files(
				$main::postfix_object->get_real_value("alias_maps")) ];
	if ($self->{'config_hash'}->{'generics'}) {
		$self->{'canonical_type'} = "sender_canonical_maps";
		$self->{'canonical_maps'} = $main::postfix_object->get_real_value($self->{'canonical_type'});
		@{$self->{'canonical_map_files_array'}} =$main::postfix_object->get_maps_files($self->{'canonical_maps'});
		}
	$self->{'can_alias_types_hash'}->{9} = 0;	# bounce not yet supported for postfix
	}
elsif ($self->{'config_hash'}->{'mail_system'} == 2 || $self->{'config_hash'}->{'mail_system'} == 4 ||
       $self->{'config_hash'}->{'mail_system'} == 5) {
	# Using qmail for email
	$self->foreign_require("qmailadmin", "qmail-lib.pl");
	%{$self->{'qmconfig_hash'}} = $self->foreign_config("qmailadmin");
	$self->{'can_alias_types_hash'}->{2} = 0;	# cannot use addresses in file
	$self->{'can_alias_types_hash'}->{8} = 0;	# cannot use same in other domain
	if ($self->{'config_hash'}->{'mail_system'} == 5) {
		$self->{'vpopbin'} = "$self->{'config_hash'}->{'vpopmail_dir'}/bin";
		}
	if ($self->{'config_hash'}->{'mail_system'} == 4) {
		# Qmail+LDAP can only alias to email addresses
		foreach my $t (3, 4, 5, 6, 7, 9, 10, 11) {
			$self->{'can_alias_types_hash'}->{$t} = 0;
			}
		}
	elsif ($self->{'config_hash'}->{'mail_system'} == 5) {
		# VPOPMail can use local addresses, files, mailbox, bouncer,
		# deleter and autoresponder
		foreach my $t (5, 6, 7, 8) {
			$self->{'can_alias_types_hash'}->{$t} = 0;
			}
		$self->{'can_alias_types_hash'}->{12} = 1
			if ($self->has_command($self->{'config_hash'}->{'vpopmail_auto'}));
		}
	else {
		# Plain Qmail cannot use the bouncer
		$self->{'can_alias_types_hash'}->{7} = 0;
		$self->{'can_alias_types_hash'}->{9} = 0;
		$self->{'can_alias_types_hash'}->{10} = 0;
		}
	}
}

# list_domain_aliases(&domain)
# Returns just virtusers for some domain
sub list_domain_aliases
{
	my $self = shift;

$self->require_mail();
local ($u, %foruser);
if ($self->{'config_hash'}->{'mail_system'} != 4) {
	# Filter out aliases that point to users
	foreach $u ($self->list_domain_users($_[0], 0, 1, 1)) {
		local $pop3 = $self->remove_userdom($u->{'user'}, $_[0]);
		$foruser{$pop3."\@".$_[0]->{'dom'}} = $u->{'user'};
		}
	if ($self->{'d'}->{'mailbox'}) {
		$foruser{$self->{'d'}->{'user'}."\@".$_[0]->{'dom'}} = $self->{'d'}->{'user'};
		}
	}
local @virts = $self->list_virtusers();
return grep { $_->{'from'} =~ /\@(\S+)$/ && $1 eq $_[0]->{'dom'} &&
	      ($foruser{$_->{'from'}} ne $_->{'to'}->[0] ||
	       @{$_->{'to'}} != 1) } @virts;
}

# setup_mail(&domain)
# Adds a domain to the list of those accepted by the mail system
sub setup_mail
{
	my $self = shift;

do { my $fn = $self->{'first_print'}; $self->$fn($self->{'text_hash'}->{'setup_doms'})};
$self->require_mail();
local $tmpl = $self->get_template($_[0]->{'template'});
if ($self->{'config_hash'}->{'mail_system'} == 1) {
	# Just add to sendmail local domains file
        local $conf = $main::sendmail_object->get_sendmailcf();
        local $cwfile;
        local @dlist = $main::sendmail_object->get_file_or_config($conf, "w", undef,
                                                     \$cwfile);
        $self->lock_file($cwfile) if ($cwfile);
        $self->lock_file($main::sendmail_object->{'config_hash'}->{'sendmail_cf'});
        @dlist = $self->unique(@dlist, $_[0]->{'dom'});
        $main::sendmail_object->save_file_or_config($conf, "w", \@dlist);
        $self->flush_file_lines();
        $self->unlock_file($main::sendmail_object->{'config_hash'}->{'sendmail_cf'});
        $self->unlock_file($cwfile) if ($cwfile);
	if (!$self->{'no_restart_mail'}) {
		$main::sendmail_object->restart_sendmail();
		}
	}
elsif ($self->{'config_hash'}->{'mail_system'} == 0) {
	# Add a special postfix virtual entry just for the domain
	$self->create_virtuser({ 'from' => $_[0]->{'dom'},
			   'to' => [ $_[0]->{'dom'} ] });
	}
elsif ($self->{'config_hash'}->{'mail_system'} == 2) {
	# Add to qmail rcpthosts file and virtualdomains file
	local $rlist = $main::qmailadmin_object->list_control_file("rcpthosts");
	push(@$rlist, $_[0]->{'dom'});
	$main::qmailadmin_object->save_control_file("rcpthosts", $rlist);

	local $virtmap = { 'domain' => $_[0]->{'dom'},
			   'prepend' => $_[0]->{'prefix'}.'pfx' };
	$main::qmailadmin_object->create_virt($virtmap);
	if (!$self->{'no_restart_mail'}) {
		$main::qmailadmin_object->restart_qmail();
		}
	}
elsif ($self->{'config_hash'}->{'mail_system'} == 4) {
	# Just add to qmail locals file, as virtualdomains is not
	# needed for qmail+ldap
	local $llist = $main::qmailadmin_object->list_control_file("locals");
	push(@$llist, $_[0]->{'dom'});
	$main::qmailadmin_object->save_control_file("locals", $llist);
	$self->execute_command("cd /etc/qmail && make");
	if (!$self->{'no_restart_mail'}) {
		$main::qmailadmin_object->restart_qmail();
		}
	}
elsif ($self->{'config_hash'}->{'mail_system'} == 5) {
	# Call vpopmail domain creation program
	local $qdom = quotemeta($_[0]->{'dom'});
	local $qpass = quotemeta($_[0]->{'pass'});
	local $out = `$self->{'vpopbin'}/vadddomain $qdom $qpass 2>&1`;
	if ($?) {
		do { my $fn = $self->{'second_print'}; $self->$fn($self->text('setup_evadddomain', "<tt>$out</tt>"))};
		return;
		}
	}
do { my $fn = $self->{'second_print'}; $self->$fn($self->{'text_hash'}->{'setup_done'})};
if ($_[0]->{'alias'}) {
	# Alias all mail to this domain to a different domain
	local $aliasdom = $self->get_domain($_[0]->{'alias'});
	$self->create_virtuser({ 'from' => '@'.$_[0]->{'dom'},
			   'to' => [ '%1@'.$aliasdom->{'dom'} ] });
	}
elsif ($tmpl->{'dom_aliases'} && $tmpl->{'dom_aliases'} ne "none") {
	# Setup aliases from this domain based on the template
	do { my $fn = $self->{'first_print'}; $self->$fn($self->{'text_hash'}->{'setup_domaliases'})};
	local @aliases = split(/\t+/, $tmpl->{'dom_aliases'});
	local ($a, %acreate);
	foreach $a (@aliases) {
		local ($from, $to) = split(/=/, $a, 2);
		$to = $self->substitute_template($to, $_[0]);
		$from = $from eq "*" ? "\@$_[0]->{'dom'}" : "$from\@$_[0]->{'dom'}";
		if ($acreate{$from}) {
			push(@{$acreate{$from}->{'to'}}, $to);
			}
		else {
			$acreate{$from} = { 'from' => $from,
					    'to' => [ $to ] };
			}
		}
	foreach $a (values %acreate) {
		$self->create_virtuser($a);
		}
	do { my $fn = $self->{'second_print'}; $self->$fn($self->{'text_hash'}->{'setup_done'})};
	}
}

# delete_mail(&domain)
# Removes a domain from the list of those accepted by the mail system
sub delete_mail
{
	my $self = shift;

do { my $fn = $self->{'first_print'}; $self->$fn($self->{'text_hash'}->{'delete_doms'})};
$self->require_mail();
if ($_[0]->{'alias'}) {
	# Remove whole-domain alias
	local @virts = $self->list_virtusers();
	local ($catchall) = grep { $_->{'from'} eq '@'.$_[0]->{'dom'} } @virts;
	if ($catchall) {
		$self->delete_virtuser($catchall);
		}
	}
if ($self->{'config_hash'}->{'mail_system'} == 1) {
	# Delete domain from sendmail local domains file
        local @virts = $self->list_virtusers();
	local ($lv) = grep { $_->{'from'} eq $_[0]->{'user'}."\@".$_[0]->{'dom'} } @virts;
        if ($lv) {
            $self->delete_virtuser($lv);
                }
        local $conf = $main::sendmail_object->get_sendmailcf();
        local $cwfile;
        local @dlist = $main::sendmail_object->get_file_or_config($conf, "w", undef,
                                                     \$cwfile);
        $self->lock_file($cwfile) if ($cwfile);
        $self->lock_file($main::sendmail_object->{'config_hash'}->{'sendmail_cf'});
        @dlist = grep { lc($_) ne lc($_[0]->{'dom'}) } @dlist;
        $main::sendmail_object->save_file_or_config($conf, "w", \@dlist);
        $self->flush_file_lines();
        $self->unlock_file($main::sendmail_object->{'config_hash'}->{'sendmail_cf'});
        $self->unlock_file($cwfile) if ($cwfile);
	if (!$self->{'no_restart_mail'}) {
		$main::sendmail_object->restart_sendmail();
		}
	}
elsif ($self->{'config_hash'}->{'mail_system'} == 0) {
	# Delete the special postfix virtuser
	local @virts = $self->list_virtusers();
	local ($lv) = grep { $_->{'from'} eq $_[0]->{'dom'} } @virts;
	if ($lv) {
		$self->delete_virtuser($lv);
		}
	local @md = split(/[, ]+/,$main::postfix_object->get_current_value("mydestination"));
	local $idx = $self->indexof($_[0]->{'dom'}, @md);
	if ($idx >= 0) {
		# Delete old-style entry too
		$self->lock_file($main::postfix_object->{'config_hash'}->{'postfix_config_file'});
		splice(@md, $idx, 1);
		$main::postfix_object->set_current_value("mydestination", join(", ", @md));
		$self->unlock_file($main::postfix_object->{'config_hash'}->{'postfix_config_file'});
		if (!$self->{'no_restart_mail'}) {
			$self->shutdown_mail_server();
			$self->startup_mail_server();
			}
		}
	}
elsif ($self->{'config_hash'}->{'mail_system'} == 2 || $self->{'config_hash'}->{'mail_system'} == 4) {
	# Delete domain from qmail locals file, rcpthosts file and virtuals
	local $dlist = $main::qmailadmin_object->list_control_file("locals");
	$dlist = [ grep { $_ ne $_[0]->{'dom'} } @$dlist ];
	$main::qmailadmin_object->save_control_file("locals", $dlist);

	local $rlist = $main::qmailadmin_object->list_control_file("rcpthosts");
	$rlist = [ grep { $_ ne $_[0]->{'dom'} } @$rlist ];
	$main::qmailadmin_object->save_control_file("rcpthosts", $rlist);

	local ($virtmap) = grep { $_->{'domain'} eq $_[0]->{'dom'} &&
				  !$_->{'user'} } $main::qmailadmin_object->list_virts();
	$main::qmailadmin_object->delete_virt($virtmap) if ($virtmap);
	if ($self->{'config_hash'}->{'mail_system'} == 4) {
		$self->execute_command("cd /etc/qmail && make");
		}
	if (!$self->{'no_restart_mail'}) {
		$main::qmailadmin_object->restart_qmail();
		}
	}
elsif ($self->{'config_hash'}->{'mail_system'} == 5) {
	# Call vpopmail domain deletion program
	local $qdom = quotemeta($_[0]->{'dom'});
	local $out = `$self->{'vpopbin'}/vdeldomain $qdom 2>&1`;
	if ($?) {
		do { my $fn = $self->{'second_print'}; $self->$fn($self->text('delete_evdeldomain', "<tt>$out</tt>"))};
		return;
		}
	}
do { my $fn = $self->{'second_print'}; $self->$fn($self->{'text_hash'}->{'setup_done'})};
}

# modify_mail(&domain, &olddomain)
# Deal with a change in domain name
sub modify_mail
{
	my $self = shift;

# Need to update the home directory of all mail users .. but only
# in the Unix object, as their files will have already been moved
# as part of the domain's directory.
# No need to do this for VPOPMail users.
# Also, any users in the user@domain name format need to be renamed
do { my $fn = $self->{'first_print'}; $self->$fn($self->{'text_hash'}->{'save_mailrename'})};
local $u;
local $domhack = { %{$_[0]} };          # This hack is needed to find users
$domhack->{'home'} = $_[1]->{'home'};   # under the old home dir!
foreach $u ($self->list_domain_users($domhack, 1)) {
        local %oldu = %$u;
        if ($_[0]->{'home'} ne $_[1]->{'home'} &&
            $self->{'config_hash'}->{'mail_system'} != 5) {
                $u->{'home'} =~ s/$_[1]->{'home'}/$_[0]->{'home'}/;
                }
        local $olddom = $_[1]->{'dom'};
        if ($_[0]->{'dom'} ne $_[1]->{'dom'} &&
            $self->{'tmpl'}->{'append_style'} == 6 &&
            $u->{'user'} =~ /^(.*)\@\Q$olddom\E$/) {
                # Rename this guy
                local $pop3 = $1;
                $u->{'user'} = $self->userdom_name($pop3, $_[0]);
                if ($u->{'email'}) {
                        $u->{'email'} = "$pop3\@$_[0]->{'dom'}";
                        }
                }
        $self->modify_user($u, \%oldu, $_[0], 1);
        }
do { my $fn = $self->{'second_print'}; $self->$fn($self->{'text_hash'}->{'setup_done'})};

if ($_[0]->{'alias'} && $_[2] && $_[2]->{'dom'} ne $_[3]->{'dom'}) {
	# This is an alias, and the domain it is aliased to has changed ..
	# update the catchall alias
	local @virts = $self->list_virtusers();
	local ($catchall) = grep { $_->{'to'}->[0] eq '%1@'.$_[3]->{'dom'} }
				 @virts;
	if ($catchall) {
		do { my $fn = $self->{'first_print'}; $self->$fn($self->{'text_hash'}->{'save_mailalias'})};
		$catchall->{'to'} = [ '%1@'.$_[2]->{'dom'} ];
		$self->modify_virtuser($catchall, $catchall);
		do { my $fn = $self->{'second_print'}; $self->$fn($self->{'text_hash'}->{'setup_done'})};
		}
	}
if ($_[0]->{'dom'} ne $_[1]->{'dom'}) {
	# Delete the old mail domain and add the new
	local $no_restart_mail = 1;
	$self->delete_mail($_[1]);
	$self->setup_mail($_[0]);
	$self->require_mail();
	if ($self->is_mail_running()) {
		if ($self->{'config_hash'}->{'mail_system'} == 1) {
			$main::sendmail_object->restart_sendmail();
			}
		elsif ($self->{'config_hash'}->{'mail_system'} == 0) {
			$self->shutdown_mail_server();
			$self->startup_mail_server();
			}
		elsif ($self->{'config_hash'}->{'mail_system'} == 2 ||
		       $self->{'config_hash'}->{'mail_system'} == 4) {
			$main::qmailadmin_object->restart_qmail();
			}
		}

	# Update any virtusers with addresses in the old domain
	foreach $v ($self->list_virtusers()) {
		if ($v->{'from'} =~ /^(\S*)\@(\S+)$/ && $2 eq $_[1]->{'dom'}) {
			$v->{'from'} = "$1\@$_[0]->{'dom'}";
                        foreach my $t (@{$v->{'to'}}) {
                                if ($t =~ /^(\S*)\@(\S+)$/ &&
                                    lc($2) eq $_[1]->{'dom'}) {
                                        $t = "$1\@$_[0]->{'dom'}";
                                        }
                                }
			$self->modify_virtuser($v, $v);
			}
		}
	}
}

# disable_mail(&domain)
# Same as deleting ..
sub disable_mail
{
	my $self = shift;

$self->delete_mail($_[0]);

do { my $fn = $self->{'first_print'}; $self->$fn($self->{'text_hash'}->{'disable_users'})};
foreach my $user ($self->list_domain_users($_[0], 1)) {
        if ($user->{'pass'} !~ /^\!/) {
                $user->{'pass'} = "!".$user->{'pass'};
                $self->modify_user($user, $user, $_[0]);
                }
        }
do { my $fn = $self->{'second_print'}; $self->$fn($self->{'text_hash'}->{'setup_done'})};
}

# enable_mail(&domain)
# Same as setting up ..
sub enable_mail
{
	my $self = shift;

$self->setup_mail($_[0]);

do { my $fn = $self->{'first_print'}; $self->$fn($self->{'text_hash'}->{'enable_users'})};
foreach my $user ($self->list_domain_users($_[0], 1)) {
        if ($user->{'pass'} =~ s/^\!//) {
                $self->modify_user($user, $user, $_[0]);
                }
        }
do { my $fn = $self->{'second_print'}; $self->$fn($self->{'text_hash'}->{'setup_done'})};
}

# check_mail_clash()
# Does nothing, because no clash checking is needed
sub check_mail_clash
{
	my $self = shift;

return 0;
}

# is_local_domain(domain)
# Returns 1 if some domain is used for mail on this system, 0 if not
sub is_local_domain
{
	my $self = shift;

local $found = 0;
if ($self->{'config_hash'}->{'mail_system'} == 1) {
	# Check Sendmail local domains file
        local $conf = $main::sendmail_object->get_sendmailcf();
        local @dlist = $main::sendmail_object->get_file_or_config($conf, "w");
        foreach my $d (@dlist) {
                $found++ if (lc($d) eq lc($_[0]));
                }
	}
elsif ($self->{'config_hash'}->{'mail_system'} == 0) {
	# Check Postfix virtusers and mydestination
	local @virts = $self->list_virtusers();
	local ($lv) = grep { $_->{'from'} eq $_[0] } @virts;
	$found++ if ($lv);
	local @md = split(/[, ]+/,$main::postfix_object->get_current_value("mydestination"));
	$found++ if ($self->indexof($_[0], @md) >= 0);
	}
elsif ($self->{'config_hash'}->{'mail_system'} == 2) {
	# Check qmail rcpthosts and virtualdomains files
	local $rlist = $main::qmailadmin_object->list_control_file("rcpthosts");
	local ($virtmap) = grep { $_->{'domain'} eq $_[0]->{'dom'} &&
				  !$_->{'user'} } $main::qmailadmin_object->list_virts();
	$found++ if ($self->indexof($_[0], @$rlist) >= 0 && $virtmap);
	}
elsif ($self->{'config_hash'}->{'mail_system'} == 4) {
	# Check qmail locals file
	local $rlist = $main::qmailadmin_object->list_control_file("locals");
	$found++ if ($self->indexof($_[0], @$rlist) >= 0);
	}
return $found;
}

sub sendmail_locals_file
{
	my $self = shift;

local $conf = $main::sendmail_object->get_sendmailcf();
local ($f, $cwfile);
foreach $f ($main::sendmail_object->find_type("F", $conf)) {
	if ($f->{'value'} =~ /^w[^\/]*(\/\S+)/ ||
	    $f->{'value'} =~ /^\{w\}[^\/]*(\/\S+)/) { $cwfile = $1; }
	}
return $cwfile;
}

# list_virtusers()
# Returns a list of a virtual mail address mappings. Each may actually have
# an alias as its destination, and is automatically expanded to the
# destinations for that alias.
sub list_virtusers
{
	my $self = shift;

# Build list of unix users, to exclude aliases with same name as users
# (which are picked up by list_domain_users instead).
$self->require_mail();
if (!defined(%{$self->{'unix_user_hash'}})) {
	$self->require_useradmin();
	foreach $u ($self->list_all_users()) {
		$self->{'unix_user_hash'}->{$self->escape_alias($u->{'user'})}++;
		}
	}

if ($self->{'config_hash'}->{'mail_system'} == 1) {
	# Get from sendmail
	local @svirts = $main::sendmail_object->list_virtusers($self->{'sendmail_vfile'});
	local %aliases = map { $_->{'name'}, $_ }
			 grep { $_->{'enabled'} && !$self->{'unix_user_hash'}->{$_->{'name'}} }
				$main::sendmail_object->list_aliases($self->{'sendmail_afiles'});
	local ($v, $a, @virts);
	foreach $v (@svirts) {
		local %rv = ( 'virt' => $v,
			      'from' => $v->{'from'} );
		if ($v->{'to'} !~ /\@/ && ($a = $aliases{$v->{'to'}})) {
			# Points to an alias - use its values
			$rv{'to'} = $a->{'values'};
			$rv{'alias'} = $a;
			}
		else { 
			# Just the original value
			$rv{'to'} = [ $v->{'to'} ];
			if ($v->{'to'} eq "error:nouser") {
				$rv{'to'} = [ "BOUNCE" ];
				}
			}
		push(@virts, \%rv);
		}
	return @virts;
	}
elsif ($self->{'config_hash'}->{'mail_system'} == 0) {
	# Get from postfix
	local $svirts = $main::postfix_object->get_maps($self->{'virtual_type'});
	local %aliases = map { $_->{'name'}, $_ }
			 grep { $_->{'enabled'} && !$self->{'unix_user_hash'}->{$_->{'name'}} }
			     $main::postfix_object->list_aliases($self->{'postfix_afiles'});
	local ($v, $a, @virts);
	foreach $v (@$svirts) {
		local %rv = ( 'from' => $v->{'name'},
			      'virt' => $v );
		if ($v->{'value'} !~ /\@/ && ($a = $aliases{$v->{'value'}})) {
			$rv{'to'} = $a->{'values'};
			$rv{'alias'} = $a;
			}
		else {
			$rv{'to'} = [ $v->{'value'} ];
			}
		local $t;	# postfix format for catchall forward is
				# different from sendmail
		foreach $t (@{$rv{'to'}}) {
			$t =~ s/^\@(\S+)$/\%1\@$1/;
			}
		push(@virts, \%rv);
		}
	return @virts;
	}
elsif ($self->{'config_hash'}->{'mail_system'} == 2) {
	# Find all qmail aliases like .qmail-group-user
	local @virtmaps = grep { !$_->{'user'} } $main::qmailadmin_object->list_virts();
	local @aliases = $main::qmailadmin_object->list_aliases();
	local ($an, $v, @virts);
	foreach $an (@aliases) {
		# Find domain in virtual maps
		local $a = $main::qmailadmin_object->get_alias($an);
		local $name = $a->{'name'};
		foreach $v (@virtmaps) {
			if ($a->{'name'} =~ /^\Q$v->{'prepend'}\E\-(.*)$/) {
				$name = ($1 eq "default" ? "" : $1)
					."\@".$v->{'domain'};
				}
			}
		# XXX need to change alias types?
		push(@virts, { 'from' => $name,
			       'alias' => $a,
			       'to' => [ map { s/^\&//; $_ }
					       @{$a->{'values'}} ] });
		}
	return @virts;
	}
elsif ($self->{'config_hash'}->{'mail_system'} == 4) {
	# Looks for psuedo qmail users with no mail store
	local $ldap = $self->connect_qmail_ldap();
	local $rv = $ldap->search(base => $self->{'config_hash'}->{'ldap_base'},
				  filter => "(objectClass=qmailUser)");
	$self->error($rv->error) if ($rv->code);
	local ($u, @virts);
	foreach $u ($rv->all_entries) {
		next if ($u->get_value("mailMessageStore"));	# skip user
		local $mail = $u->get_value("mail");
		if ($mail =~ /^catchall\@(.*)$/) {
			$mail = "\@$1";
			}
		local @to = $u->get_value("mailForwardingAddress");
		push(@virts, { 'from' => $mail,
			       'dn' => $u->dn(),
			       'ldap' => $u,
			       'to' => \@to });
		}
	$ldap->unbind();
	return @virts;
	}
elsif ($self->{'config_hash'}->{'mail_system'} == 5) {
	# Use the valias program to get aliases for all domains
	if (!defined(@{$self->{'vpopmail_aliases_cache_array'}})) {
		@{$self->{'vpopmail_aliases_cache_array'}} = ( );
		opendir(DDIR, "$self->{'config_hash'}->{'vpopmail_dir'}/domains");
		local @doms = grep { $_ !~ /^\./ } readdir(DDIR);
		closedir(DDIR);
		local $dname;
		foreach $dname (@doms) {
			# Get aliases from .qmail files
			local %already;
			local $ddir = "$self->{'config_hash'}->{'vpopmail_dir'}/domains/$dname";
			opendir(DDIR, $ddir);
			while($self->{'qf'} = readdir(DDIR)) {
				next if ($self->{'qf'} !~ /^.qmail-(.*)$/);
				local $alias = { 'from' => $1 eq "default" ?
						    "\@$dname" : "$1\@$dname",
						 'to' => [ ] };
				open(QMAIL, "$ddir/$self->{'qf'}");
				while(<QMAIL>) {
					s/\r|\n//g;
					push(@{$alias->{'to'}},
					     $self->qmail_to_vpopmail($_, $dname));
					}
				close(QMAIL);
				$already{$alias->{'from'}} = $alias;
				push(@{$self->{'vpopmail_aliases_cache_array'}}, $alias);
				}
			closedir(DDIR);

			# Add those from valias command (for sites using MySQL or some
			# other backend)
			local %aliases;
			open(ALIASES, "$self->{'vpopbin'}/valias -s $dname |");
			while(<ALIASES>) {
				s/\r|\n//g;
				if (/^(\S+)\s+\->\s+(.*)/) {
					local ($from, $to) = ($1, $2);
					next if ($already{$from});	# already above
					local $alias;
					$to = $self->qmail_to_vpopmail($to, $dname);
					if ($alias = $aliases{$from}) {
						push(@{$alias->{'to'}}, $to);
						}
					else {
						$alias = { 'from' => $from,
							   'to' => [ $to ] };
						$aliases{$from} = $alias;
						push(@{$self->{'vpopmail_aliases_cache_array'}},
						     $alias);
						}
					}
				}
			close(ALIASES);
			}
		}
	return @{$self->{'vpopmail_aliases_cache_array'}};
	}
}

# qmail_to_vpopmail(line, domain)
# Converts a line from a .qmail file created by vpopmail into the internal
# Virtualmin format. 
sub qmail_to_vpopmail
{
	my $self = shift;

local $ddir = "$self->{'config_hash'}->{'vpopmail_dir'}/domains/$_[1]";
if ($_[0] =~ /^\|\s*$self->{'vpopbin'}\/vdelivermail\s+''\s+(\S+)\@(\S+)$/) {
	# External address
	return $2 eq $_[1] ? $1 : "$1\@$2";
	}
elsif ($_[0] =~ /^\|\s*$self->{'vpopbin'}\/vdelivermail\s+''\s+\Q$ddir\E\/(\S+)$/) {
	# Direct to user
	return "\\$1";
	}
elsif ($_[0] =~ /^\|\s*$self->{'vpopbin'}\/vdelivermail\s+''\s+bounce-no-mailbox$/) {
	# Bouncer
	return "BOUNCE";
	}
elsif ($_[0] =~ /^\|\s*$self->{'vpopbin'}\/vdelivermail\s+''\s+delete$/) {
	# Deleter
	return "/dev/null";
	}
else {
	# Some other line
	return $_[0];
	}
}

# vpopmail_to_qmail(alias, domain)
sub vpopmail_to_qmail
{
	my $self = shift;

local $ddir = "$self->{'config_hash'}->{'vpopmail_dir'}/domains/$_[1]";
if ($_[0] =~ /^\S+\@\S+$/) {
	return $_[0];
	}
elsif ($_[0] eq "BOUNCE") {
	return "| $self->{'vpopbin'}/vdelivermail '' bounce-no-mailbox";
	}
elsif ($_[0] eq "/dev/null") {
	return "| $self->{'vpopbin'}/vdelivermail '' delete";
	}
elsif ($_[0] =~ /^\\(\S+)$/) {
	return "| $self->{'vpopbin'}/vdelivermail '' $ddir/$1";
	}
elsif ($_[0] =~ /^[a-z0-9\.\-\_]+$/) {
	return "| $self->{'vpopbin'}/vdelivermail '' $_[0]\@$_[1]";
	}
else {
	return $_[0];
	}
}

# delete_virtuser(&virtuser)
# Deletes a virtual mail user mapping
sub delete_virtuser
{
	my $self = shift;

$self->require_mail();
if ($self->{'config_hash'}->{'mail_system'} == 1) {
	# Delete from sendmail
	if ($_[0]->{'alias'}) {
		# Delete alias too
		$self->lock_file($_[0]->{'alias'}->{'file'});
		$main::sendmail_object->delete_alias($_[0]->{'alias'});
		$self->unlock_file($_[0]->{'alias'}->{'file'});
		}
	$self->lock_file($_[0]->{'virt'}->{'file'});
	$main::sendmail_object->delete_virtuser($_[0]->{'virt'}, $self->{'sendmail_vfile'},
				   $self->{'sendmail_vdbm'}, $self->{'sendmail_vdbmtype'});
	$self->unlock_file($_[0]->{'virt'}->{'file'});
	}
elsif ($self->{'config_hash'}->{'mail_system'} == 0) {
	# Delete from postfix file
	if ($_[0]->{'alias'}) {
		# Delete alias too
		$self->lock_file($_[0]->{'alias'}->{'file'});
		$main::postfix_object->delete_alias($_[0]->{'alias'});
		$self->unlock_file($_[0]->{'alias'}->{'file'});
		$main::postfix_object->regenerate_aliases();
		}
	$self->lock_file($_[0]->{'virt'}->{'file'});
	$main::postfix_object->delete_mapping($self->{'virtual_type'}, $_[0]->{'virt'});
	$self->unlock_file($_[0]->{'virt'}->{'file'});
	$main::postfix_object->regenerate_virtual_table();
	}
elsif ($self->{'config_hash'}->{'mail_system'} == 2) {
	# Just delete the qmail alias
	$main::qmailadmin_object->delete_alias($_[0]->{'alias'});
	}
elsif ($self->{'config_hash'}->{'mail_system'} == 4) {
	# Remove pseudo Qmail user
	local $ldap = $self->connect_qmail_ldap();
	local $rv = $ldap->delete($_[0]->{'dn'});
	$self->error($rv->error) if ($rv->code);
	$ldap->unbind();
	}
elsif ($self->{'config_hash'}->{'mail_system'} == 5) {
	# Remove all vpopmail aliases
	$_[0]->{'from'} =~ /^(\S*)\@(\S+)$/;
	local ($box, $dom) = ($1 || "default", $2);
	local $qfrom = quotemeta("$box\@$dom");
	local $cmd = "$self->{'vpopbin'}/valias -d $qfrom";
	local $out = $self->backquote_logged("$cmd 2>&1");
	if ($?) {
		$self->error("<tt>$cmd</tt> failed : <pre>$out</pre>");
		}
	}
}

# modify_virtuser(&old, &new)
sub modify_virtuser
{
	my $self = shift;

$self->require_mail();
local @to = @{$_[1]->{'to'}};
if ($self->{'config_hash'}->{'mail_system'} == 1) {
	# Modify in sendmail
	local $alias = $_[0]->{'alias'};
	local @smto = map { $_ eq "BOUNCE" ? "error:nouser" : $_ } @to;
	if ($self->needs_alias(@smto) && !$alias) {
		# Alias needs to be created and virtuser updated
		$_[1]->{'from'} =~ /^(\S*)\@(\S+)$/;
		local $an = ($1 || "default")."-".$2;
		local $alias = { "name" => $an,
				 "enabled" => 1,
				 "values" => \@smto };
		$main::sendmail_object->lock_alias_files($self->{'sendmail_afiles'});
		$main::sendmail_object->create_alias($alias, $self->{'sendmail_afiles'});
		$main::sendmail_object->unlock_alias_files($self->{'sendmail_afiles'});
		local $virt = { "from" => $_[1]->{'from'},
				"to" => $an };
		$self->lock_file($_[0]->{'virt'}->{'file'});
		$main::sendmail_object->modify_virtuser($_[0]->{'virt'}, $virt,
					   $self->{'sendmail_vfile'}, $self->{'sendmail_vdbm'},
					   $self->{'sendmail_vdbmtype'});
		$self->unlock_file($_[0]->{'virt'}->{'file'});
		$_[0]->{'virt'} = $virt;
		}
	elsif ($alias) {
		# Just update alias and maybe virtuser
		$alias->{'values'} = \@smto;
		$self->lock_file($alias->{'file'});
		$main::sendmail_object->modify_alias($alias, $alias);
		$self->unlock_file($alias->{'file'});
		if ($_[1]->{'from'} ne $_[0]->{'from'}) {
			# Re-named .. need to change too
			local $virt = { "from" => $_[1]->{'from'},
					"to" => $smto[0] };
			$self->lock_file($_[0]->{'virt'}->{'file'});
			$main::sendmail_object->modify_virtuser($_[0]->{'virt'}, $virt,
						   $self->{'sendmail_vfile'},
						   $self->{'sendmail_vdbm'},
						   $self->{'sendmail_vdbmtype'});
			$self->unlock_file($_[0]->{'virt'}->{'file'});
			$_[0]->{'virt'} = $virt;
			}
		}
	else {
		# Just update virtuser
		local $virt = { "from" => $_[1]->{'from'},
				"to" => $smto[0] };
		$self->lock_file($_[0]->{'virt'}->{'file'});
		$main::sendmail_object->modify_virtuser($_[0]->{'virt'}, $virt,
					   $self->{'sendmail_vfile'}, $self->{'sendmail_vdbm'},
					   $self->{'sendmail_vdbmtype'});
		$self->unlock_file($_[0]->{'virt'}->{'file'});
		$_[0]->{'virt'} = $virt;
		}
	}
elsif ($self->{'config_hash'}->{'mail_system'} == 0) {
	# Modify in postfix file
	local $alias = $_[0]->{'alias'};
	if ($self->needs_alias(@to) && !$alias) {
		# Alias needs to be created and virtuser updated
		$_[0]->{'from'} =~ /^(\S*)\@(\S+)$/;
		local $an = ($1 || "default")."-".$2;
		local $alias = { "name" => $an,
				 "enabled" => 1,
				 "values" => \@to };
		$main::postfix_object->lock_alias_files($self->{'postfix_afiles'});
		$main::postfix_object->create_alias($alias, $self->{'postfix_afiles'});
		$main::postfix_object->unlock_alias_files($self->{'postfix_afiles'});
		$main::postfix_object->regenerate_aliases();
		local $virt = { "name" => $_[1]->{'from'},
				"value" => $an };
		$self->lock_file($_[0]->{'virt'}->{'file'});
		$main::postfix_object->modify_mapping($self->{'virtual_type'}, $_[0]->{'virt'}, $virt);
		$self->unlock_file($_[0]->{'virt'}->{'file'});
		$_[0]->{'virt'} = $virt;
		$main::postfix_object->regenerate_virtual_table();
		}
	elsif ($alias) {
		# Just update alias
		$alias->{'values'} = \@to;
		$self->lock_file($alias->{'file'});
		$main::postfix_object->modify_alias($alias, $alias);
		$self->unlock_file($alias->{'file'});
		$main::postfix_object->regenerate_aliases();
		if ($_[1]->{'from'} ne $_[0]->{'from'}) {
			# Re-named .. need to change virtuser too
			local $virt = { "name" => $_[1]->{'from'},
					"value" => $_[1]->{'virt'}->{'value'} };
			$self->lock_file($_[0]->{'virt'}->{'file'});
			$main::postfix_object->modify_mapping($self->{'virtual_type'}, $_[0]->{'virt'},
						 $virt);
			$self->unlock_file($_[0]->{'virt'}->{'file'});
			$_[0]->{'virt'} = $virt;
			$main::postfix_object->regenerate_virtual_table();
			}
		}
	else {
		# Just update virtuser
		local $t = $_[1]->{'to'}->[0];
		$t =~ s/^\%1\@/\@/;	# postfix format is different
		local $virt = { "name" => $_[1]->{'from'},
				"value" => $t };
		$self->lock_file($_[0]->{'virt'}->{'file'});
		$main::postfix_object->modify_mapping($self->{'virtual_type'}, $_[0]->{'virt'}, $virt);
		$self->unlock_file($_[0]->{'virt'}->{'file'});
		$_[0]->{'virt'} = $virt;
		$main::postfix_object->regenerate_virtual_table();
		}
	}
elsif ($self->{'config_hash'}->{'mail_system'} == 2) {
	# Just update the qmail alias
	$_[1]->{'from'} =~ /^(\S*)\@(\S+)$/;
	local ($box, $dom) = ($1 || "default", $2);
	local ($virtmap) = grep { $_->{'domain'} eq $dom && !$_->{'user'} }
			        $main::qmailadmin_object->list_virts();
	local $alias = { 'name' => "$virtmap->{'prepend'}-$box",
			 'values' => \@to };
	$main::qmailadmin_object->modify_alias($_[0]->{'alias'}, $alias);
	$_[1]->{'alias'} = $alias;
	}
elsif ($self->{'config_hash'}->{'mail_system'} == 4) {
	# Update the Qmail pseudo-user
	local $ldap = $self->connect_qmail_ldap();
	$_[1]->{'from'} =~ /^(\S*)\@(\S+)$/;
	local ($box, $dom) = ($1 || "catchall", $2);
	local $_[1]->{'dn'} = "uid=$box-$dom,$self->{'config_hash'}->{'ldap_base'}";
	local $attrs = [ "uid" => "$box-$dom",
			 "mail" => $box."\@".$dom,
			 "mailForwardingAddress" => $_[1]->{'to'} ];
	local $rv = $ldap->modify($_[0]->{'dn'},
				  replace => $attrs);
	$self->error($rv->error) if ($rv->code);
	if ($_[0]->{'dn'} ne $_[1]->{'dn'}) {
		# Re-named too!
		$rv = $ldap->moddn($_[0]->{'dn'},
				   newrdn => "uid=$box-$dom");
		$self->error($rv->error) if ($rv->code);
		}
	$ldap->unbind();
	}
elsif ($self->{'config_hash'}->{'mail_system'} == 5) {
	# Just delete the old vpopmail alias, and re-add!
	$self->delete_virtuser($_[0]);
	$self->create_virtuser($_[1]);
	}
}

# create_virtuser(&virtuser)
# Creates a new virtual mail mapping
sub create_virtuser
{
	my $self = shift;

$self->require_mail();
local @to = @{$_[0]->{'to'}};
if ($self->{'config_hash'}->{'mail_system'} == 1) {
	# Create in sendmail
	local $virt;
	local @smto = map { $_ eq "BOUNCE" ? "error:nouser" : $_ } @to;
	if ($self->needs_alias(@smto)) {
		# Need to create an alias, named address-domain
		$_[0]->{'from'} =~ /^(\S*)\@(\S+)$/;
		local $an = ($1 || "default")."-".$2;
		$self->check_alias_clash($an) && $self->error($self->text('alias_eclash2', $an));
		local $alias = { "name" => $an,
				 "enabled" => 1,
				 "values" => \@smto };
		$main::sendmail_object->lock_alias_files($self->{'sendmail_afiles'});
		$main::sendmail_object->create_alias($alias, $self->{'sendmail_afiles'});
		$main::sendmail_object->unlock_alias_files($self->{'sendmail_afiles'});
		$virt = { "from" => $_[0]->{'from'},
			  "to" => $an };
		}
	else {
		# A single virtuser will do
		$virt = { "from" => $_[0]->{'from'},
			  "to" => $smto[0] };
		}
	$self->lock_file($self->{'sendmail_vfile'});
	$main::sendmail_object->create_virtuser($virt, $self->{'sendmail_vfile'},
				   $self->{'sendmail_vdbm'},
				   $self->{'sendmail_vdbmtype'});
	$self->unlock_file($self->{'sendmail_vfile'});
	$_[0]->{'virt'} = $virt;
	}
elsif ($self->{'config_hash'}->{'mail_system'} == 0) {
	# Create in postfix file
	if ($self->needs_alias(@to)) {
		# Need to create an alias, named address-domain
		$_[0]->{'from'} =~ /^(\S*)\@(\S+)$/;
		local $an = ($1 || "default")."-".$2;
		$self->check_alias_clash($an) && $self->error($self->text('alias_eclash2', $an));
		local $alias = { "name" => $an,
				 "enabled" => 1,
				 "values" => \@to };
		$main::postfix_object->lock_alias_files($self->{'postfix_afiles'});
		$main::postfix_object->create_alias($alias, $self->{'postfix_afiles'});
		$main::postfix_object->unlock_alias_files($self->{'postfix_afiles'});
		$main::postfix_object->regenerate_aliases();
		$virt = { 'name' => $_[0]->{'from'},
			  'value' => $an };
		}
	else {
		# A single virtuser will do
		local $t = $_[0]->{'to'}->[0];
		$t =~ s/^\%1\@/\@/;	# postfix format is different
		$virt = { 'name' => $_[0]->{'from'},
			  'value' => $t };
		}
	$self->lock_file($self->{'virtual_map_files_array'}->[0]);
	$self->create_replace_mapping($self->{'virtual_type'}, $virt);
	$self->unlock_file($self->{'virtual_map_files_array'}->[0]);
	$main::postfix_object->regenerate_virtual_table();
	$_[0]->{'virt'} = $virt;
	}
elsif ($self->{'config_hash'}->{'mail_system'} == 2) {
	# Create a single Qmail alias
	$_[0]->{'from'} =~ /^(\S*)\@(\S+)$/;
	local ($box, $dom) = ($1 || "default", $2);
	local ($virtmap) = grep { $_->{'domain'} eq $dom && !$_->{'user'} }
			        $main::qmailadmin_object->list_virts();
	local $alias = { 'name' => "$virtmap->{'prepend'}-$box",
			 'values' => \@to };
	$main::qmailadmin_object->create_alias($alias);
	$_[0]->{'alias'} = $alias;
	}
elsif ($self->{'config_hash'}->{'mail_system'} == 4) {
	# Create a psuedo Qmail user
	local $ldap = $self->connect_qmail_ldap();
	$_[0]->{'from'} =~ /^(\S*)\@(\S+)$/;
	local ($box, $dom) = ($1 || "catchall", $2);
	local $_[0]->{'dn'} = "uid=$box-$dom,$self->{'config_hash'}->{'ldap_base'}";
	local @oc = ( "qmailUser", split(/\s+/, $self->{'config_hash'}->{'ldap_aclasses'}) );
	local $attrs = [ "objectClass" => \@oc,
			 "uid" => "$box-$dom",
		 	 "deliveryMode" => "nolocal",
			 "mail" => $box."\@".$dom,
			 "mailForwardingAddress" => $_[0]->{'to'} ];
	local $rv = $ldap->add($_[0]->{'dn'}, attr => $attrs);
        $self->error($rv->error) if ($rv->code);
        $ldap->unbind();
	}
elsif ($self->{'config_hash'}->{'mail_system'} == 5) {
	# Add one vpopmail alias for each destination
	local $t;
	$_[0]->{'from'} =~ /^(\S*)\@(\S+)$/;
	local ($box, $dom) = ($1 || "default", $2);
	local $maxlen = 0;
	foreach $t (@{$_[0]->{'to'}}) {
		$maxlen = length($t) if (length($t) > $maxlen);
		}
	if ($box eq "default" || $maxlen > 160) {
		# Create .qmail file directly
		local $ddir = "$self->{'config_hash'}->{'vpopmail_dir'}/domains/$dom";
		local $qmf = "$ddir/.qmail-$box";
		$self->lock_file($qmf);
		$self->open_tempfile(QMAIL, ">$qmf");
		foreach $t (@{$_[0]->{'to'}}) {
			$self->print_tempfile(QMAIL, $self->vpopmail_to_qmail($t, $dom),"\n");
			}
		$self->close_tempfile(QMAIL);
		local @uinfo = getpwnam($self->{'config_hash'}->{'vpopmail_user'});
		local @ginfo = getgrnam($self->{'config_hash'}->{'vpopmail_group'});
		chown($uinfo[2], $ginfo[2], $qmf);
		chmod(0600, $qmf);
		$self->unlock_file($qmf);
		}
	else {
		# Create with valias command
		local $qfrom = quotemeta("$box\@$dom");
		foreach $t (@{$_[0]->{'to'}}) {
			local $qto = quotemeta($self->vpopmail_to_qmail($t, $dom));
			local $cmd = "$self->{'vpopbin'}/valias -i $qto $qfrom";
			local $out = $self->backquote_logged("$cmd 2>&1");
			if ($?) {
				$self->error("<tt>$cmd</tt> failed: <pre>$out</pre>");
				}
			}
		}
	}
}

# needs_alias(list..)
sub needs_alias
{
	my $self = shift;

return 1 if (@_ != 1);
local $t;
foreach $t (@_) {
	return 1 if ($self->alias_type($t) != 1 && $self->alias_type($t) != 8 &&
		     $self->alias_type($t) != 9);
	}
return 0;
}

# join_alias(list..)
sub join_alias
{
	my $self = shift;

return join(',', map { /\s/ ? "\"$_\"" : $_ } @_);
}

# is_mail_running()
# Returns 1 if the configured mail server is running, 0 if not
sub is_mail_running
{
	my $self = shift;

$self->require_mail();
if ($self->{'config_hash'}->{'mail_system'} == 1) {
	# Check the sendmail PID
	local $pid;
	open(PID, $self->{'sconfig_hash'}->{'sendmail_pid'}) || return 0;
	chop($pid = <PID>);
	close(PID);
	return kill(0, $pid);
	}
elsif ($self->{'config_hash'}->{'mail_system'} == 0) {
	# Call the postfix module 
	return $main::postfix_object->is_postfix_running();
	}
elsif ($self->{'config_hash'}->{'mail_system'} == 2 || $self->{'config_hash'}->{'mail_system'} == 4 ||
       $self->{'config_hash'}->{'mail_system'} == 5) {
	# Just look for qmail-send
	local ($pid) = $self->find_byname("qmail-send");
	return $pid ? 1 : 0;
	}
}

# shutdown_mail_server()
# Shuts down the mail server, or calls &error
sub shutdown_mail_server
{
	my $self = shift;

$self->require_mail();
if ($self->{'config_hash'}->{'mail_system'} == 1) {
	# Kill or stop sendmail
	if ($self->{'sconfig_hash'}->{'sendmail_stop_command'}) {
		$self->{'out'} = $self->backquote_logged("$self->{'sconfig_hash'}->{'sendmail_stop_command'} </dev/null 2>&1");
		if ($?) { $self->error("<pre>$self->{'out'}</pre>"); }
		}
	else {
		local $pid;
		open(PID, $self->{'sconfig_hash'}->{'sendmail_pid'}) ||
			$self->error($self->{'text_hash'}->{'mstop_edown'});
		chop($pid = <PID>);
		close(PID);
		$self->kill_logged('KILL', $pid) || $self->error($self->{'text_hash'}->{'mstop_edown'});
		unlink($self->{'sconfig_hash'}->{'sendmail_pid'});
		}
	}
elsif ($self->{'config_hash'}->{'mail_system'} == 0) {
	# Run the postfix stop command
	$self->{'out'} = $self->backquote_logged("$self->{'pconfig_hash'}->{'postfix_control_command'} -c $main::postfix_object->{'config_dir'} stop 2>&1");
	if ($?) { $self->error("<tt>$self->{'out'}</tt>"); }
	}
elsif ($self->{'config_hash'}->{'mail_system'} == 2 || $self->{'config_hash'}->{'mail_system'} == 4 ||
       $self->{'config_hash'}->{'mail_system'} == 5) {
	# Call the qmail stop function
	local $err = $main::qmailadmin_object->stop_qmail();
	$self->error($err) if ($err);
	}
}

# startup_mail_server()
# Starts up the mail server, or calls &error
sub startup_mail_server
{
	my $self = shift;

$self->require_mail();
if ($self->{'config_hash'}->{'mail_system'} == 1) {
	# Run the sendmail start command
	$self->{'out'} = $self->backquote_logged("$self->{'sconfig_hash'}->{'sendmail_command'} </dev/null 2>&1");
	if ($?) { $self->error("<pre>$self->{'out'}</pre>"); }
	}
elsif ($self->{'config_hash'}->{'mail_system'} == 0) {
	# Run the postfix start command
	$self->{'out'} = $self->backquote_logged("$self->{'pconfig_hash'}->{'postfix_control_command'} -c $main::postfix_object->{'config_dir'} start 2>&1");
	if ($?) { $self->error("<tt>$self->{'out'}</tt>"); }
	}
elsif ($self->{'config_hash'}->{'mail_system'} == 2 || $self->{'config_hash'}->{'mail_system'} == 4 ||
       $self->{'config_hash'}->{'mail_system'} == 5) {
	# Call the qmail start function
	local $err = $main::qmailadmin_object->start_qmail();
	$self->error($err) if ($err);
	}
}

# create_mail_file(&user)
# Creates a new empty mail file for a user, if necessary
sub create_mail_file
{
	my $self = shift;

$self->require_mail();
local $mf;
local $md;
if ($self->{'config_hash'}->{'mail_system'} == 1) {
	# Sendmail always uses mail files
	$mf = $main::sendmail_object->user_mail_file($_[0]->{'user'});
	}
elsif ($self->{'config_hash'}->{'mail_system'} == 0) {
	# Postfix user
	local ($s, $d) = $main::postfix_object->postfix_mail_system();
	if ($s == 0 || $s == 1) {
		# A mail file
		$mf = $main::postfix_object->postfix_mail_file($_[0]->{'user'});
		}
	elsif ($s == 2) {
		# A mail directory
		$md = $main::postfix_object->postfix_mail_file($_[0]->{'user'});
		}
	}
elsif ($self->{'config_hash'}->{'mail_system'} == 2 ||
       $self->{'config_hash'}->{'mail_system'} == 4 && !$_[0]->{'qmail'}) {
	# Normal Qmail user
	if ($main::qmailadmin_object->{'config_hash'}->{'mail_system'} == 0) {
		$mf = $main::qmailadmin_object->user_mail_file($_[0]->{'user'});
		}
	elsif ($main::qmailadmin_object->{'config_hash'}->{'mail_system'} == 1) {
		$md = $main::qmailadmin_object->user_mail_dir($_[0]->{'user'});
		}
	}
elsif ($self->{'config_hash'}->{'mail_system'} == 4) {
	# Qmail+LDAP mail file comes from DB
	if ($_[0]->{'mailstore'} =~ /^(.*)\/$/) {
		$md = $self->add_ldapmessagestore("$1");
		}
	else {
		$mf = $self->add_ldapmessagestore($_[0]->{'mailstore'});
		}
	}
elsif ($self->{'config_hash'}->{'mail_system'} == 5) {
	# Nothing to do for VPOPMail, because it gets created automatically
	# vadduser
	}
if ($mf && !-r $mf) {
	# Create the mailbox, owned by the user
	$self->open_tempfile(MF, ">$mf");
	$self->close_tempfile(MF);
	chown($_[0]->{'uid'}, $_[0]->{'gid'}, $mf);
	}
if ($md && !-d $md) {
	# Create the Maildir, owned by the user
	local $d;
	foreach $d ($md, "$md/cur", "$md/tmp", "$md/new") {
		mkdir($d, 0700);
		chown($_[0]->{'uid'}, $_[0]->{'gid'}, $d);
		}
	}
}

# add_ldapmessagestore(path)
sub add_ldapmessagestore
{
	my $self = shift;

if ($_[0] =~ /^\//) {
	return $_[0];
	}
else {
	local $pfx = $main::qmailadmin_object->get_control_file("ldapmessagestore");
	return $pfx."/".$_[0];
	}
}

# delete_mail_file(&user)
sub delete_mail_file
{
	my $self = shift;

$self->require_mail();
local $umf = $self->user_mail_file($_[0]);
if ($umf) {
	$self->system_logged("rm -rf ".quotemeta($umf));
	}
}

# rename_mail_file(&user, &olduser)
sub rename_mail_file
{
	my $self = shift;

return if ($self->mail_under_home());
$self->require_mail();
if ($self->{'config_hash'}->{'mail_system'} == 1) {
	# Just rename the Sendmail mail file (if necessary)
	local $of = $main::sendmail_object->user_mail_file($_[1]->{'user'});
	local $nf = $main::sendmail_object->user_mail_file($_[0]->{'user'});
	rename($of, $nf);
	}
elsif ($self->{'config_hash'}->{'mail_system'} == 0) {
	# Find out from Postfix which file to rename (if necessary)
	local $newumf = $main::postfix_object->postfix_mail_file($_[0]->{'user'});
	local $oldumf = $main::postfix_object->postfix_mail_file($_[1]->{'user'});
	rename($oldumf, $newumf);
	}
elsif ($self->{'config_hash'}->{'mail_system'} == 2 ||
       $self->{'config_hash'}->{'mail_system'} == 4 && !$_[0]->{'qmail'}) {
	# Just rename the Qmail mail file (if necessary)
	local $of = $main::qmailadmin_object->user_mail_file($_[1]->{'user'});
	local $nf = $main::qmailadmin_object->user_mail_file($_[0]->{'user'});
	rename($of, $nf);
	}
elsif ($self->{'config_hash'}->{'mail_system'} == 4) {
	# Rename from LDAP property
	rename($_[1]->{'mailstore'}, $_[0]->{'mailstore'});
	}
}

# mail_under_home()
# Returns 1 if mail is stored under use home directories
sub mail_under_home
{
	my $self = shift;

$self->require_mail();
if ($self->{'config_hash'}->{'mail_system'} == 1) {
	return !$self->{'sconfig_hash'}->{'mail_dir'};
	}
elsif ($self->{'config_hash'}->{'mail_system'} == 0) {
	local $s = $main::postfix_object->postfix_mail_system();
	return $s != 0;
	}
elsif ($self->{'config_hash'}->{'mail_system'} == 2) {
	return $self->{'qmconfig_hash'}->{'mail_system'} != 0 || !$self->{'qmconfig_hash'}->{'mail_dir'};
	}
elsif ($self->{'config_hash'}->{'mail_system'} == 4) {
	return $self->{'config_hash'}->{'ldap_mailstore'} =~ /^(\$HOME|\$\{HOME\})/;
	}
elsif ($self->{'config_hash'}->{'mail_system'} == 5) {
	# VPOPMail users always have it under their homes
	return 1;
	}
}

# user_mail_file(&user)
# Returns the full path a user's mail file
sub user_mail_file
{
	my $self = shift;

$self->require_mail();
if ($self->{'config_hash'}->{'mail_system'} == 1) {
	# Just look at the Sendmail mail file
	return $main::sendmail_object->user_mail_file($_[0]->{'user'});
	}
elsif ($self->{'config_hash'}->{'mail_system'} == 0) {
	# Find out from Postfix which file to check
	return $main::postfix_object->postfix_mail_file($_[0]->{'user'});
	}
elsif ($self->{'config_hash'}->{'mail_system'} == 2 ||
       $self->{'config_hash'}->{'mail_system'} == 4 && !$_[0]->{'qmail'}) {
	# Find out from Qmail which file or dir to check
	return $main::qmailadmin_object->user_mail_dir($_[0]->{'user'});
	}
elsif ($self->{'config_hash'}->{'mail_system'} == 4) {
	# Mail file is an LDAP property
	local $rv = $self->add_ldapmessagestore($_[0]->{'mailstore'});
	if (-d "$rv/Maildir") {
		return "$rv/Maildir";
		}
	else {
		return $rv;
		}
	}
elsif ($self->{'config_hash'}->{'mail_system'} == 5) {
	# Mail dir is under VPOPMail home
	return "$_[0]->{'home'}/Maildir";
	}
return undef;
}

# mail_file_size(&user)
sub mail_file_size
{
	my $self = shift;

$self->require_mail();
local $umf = $self->user_mail_file($_[0]);
if (-d $umf) {
	# Need to sum up a maildir-format directory
	local $sz = 0;
	foreach $d ("$umf/cur", "$umf/new", "$umf/tmp") {
		opendir(DIR, $d) || last;
		foreach $f (readdir(DIR)) {
			next if ($f eq "." || $f eq "..");
			local @st = stat("$d/$f");
			$sz += $st[7];
			}
		closedir(DIR);
		}
	return ( $sz, $umf );
	}
else {
	# Just the size of a single mail file
	local @st = stat($umf);
	return ( int($st[7]), $umf );
	}
}

# mail_system_base()
# Returns the base directory under which user mail files can be found
sub mail_system_base
{
	my $self = shift;

$self->require_mail();
if ($self->{'config_hash'}->{'mail_system'} == 1) {
	# Find out from sendmail module config
	if ($self->{'sconfig_hash'}->{'mail_dir'}) {
		return $self->{'sconfig_hash'}->{'mail_dir'};
		}
	}
elsif ($self->{'config_hash'}->{'mail_system'} == 0) {
	# Find out from postfix
	local @s = $main::postfix_object->postfix_mail_system();
	if ($s[0] == 0) {
		return $s[1];
		}
	}
elsif ($self->{'config_hash'}->{'mail_system'} == 2) {
	# Find out from qmail module config
	if ($self->{'qmconfig_hash'}->{'mail_system'} == 0 && $self->{'qmconfig_hash'}->{'mail_dir'}) {
		return $self->{'qmconfig_hash'}->{'mail_dir'};
		}
	}
elsif ($self->{'config_hash'}->{'mail_system'} == 4) {
	# Need to look at template from module config
	local $pfx = $main::qmailadmin_object->get_control_file("ldapmessagestore");
	if ($self->{'config_hash'}->{'ldap_mailstore'} =~ /^(\$HOME|\$\{HOME\})/) {
		# Under home .. return it
		$self->require_useradmin();
		return $self->{'home_base'};
		}
	elsif ($self->{'config_hash'}->{'ldap_mailstore'} !~ /^\//) {
		return $pfx;
		}
	else {
		# Get fixed directory
		local $dir = $self->{'config_hash'}->{'ldap_mailstore'};
		$dir =~ s/\$.*$//;
		$dir =~ s/\/[^\/]*$//;
		return $dir || "/";
		}
	}
# If we get here, assume that mail is under home dirs
local %uconfig = $self->foreign_config("useradmin");
return $self->{'home_base'};
}

# mail_domain_base(&domain)
# Returns the directory under which user mail files are located for some
# domain, or undef
sub mail_domain_base
{
	my $self = shift;

if ($self->{'config_hash'}->{'mail_system'} == 4) {
	# Guess base for domain from mailstore pattern
	local $guess = { 'user' => 'USER', 'home' => 'HOME' };
	$self->userdom_substitutions($guess, $_[0]);
	local $dir = $self->add_ldapmessagestore(
		$self->substitute_template($self->{'config_hash'}->{'ldap_mailstore'}, $guess));
	if ($dir =~ /^(.*)\/\Q$_[0]->{'dom'}\E/) {
		return $1;
		}
	return undef;
	}
elsif ($self->{'config_hash'}->{'mail_system'} == 5) {
	# All mail for VPOPmail is under the domain's directory
	return "$self->{'config_hash'}->{'vpopmail_dir'}/domains/$_[0]->{'dom'}";
	}
elsif ($self->mail_under_home()) {
	return "$_[0]->{'home'}/homes";
	}
else {
	# There is no base directory
	return undef;
	}
}

# read_mail_link(&user, &domain)
sub read_mail_link
{
	my $self = shift;

local %acl;
$self->read_acl(\%acl);
if ($self->foreign_check("mailboxes") && $acl{$self->{'base_remote_user'},'mailboxes'}) {
	# Use mailboxes module if possible
	local %mconfig = $self->foreign_config("mailboxes");
	local %minfo = $self->get_module_info("mailboxes");
	if ($mconfig{'mail_system'} == $self->{'config_hash'}->{'mail_system'}) {
		# Read a Unix user's mail
		if ($self->{'config_hash'}->{'mail_system'} == 5) {
			return "../mailboxes/list_mail.cgi?user=".
			       $_[0]->{'user'}."\@".$_[1]->{'dom'};
			}
		else {
			return "../mailboxes/list_mail.cgi?user=".
			       $_[0]->{'user'};
			}
		}
	elsif ($self->get_webmin_version() >= 1.182 ||
	       $minfo{'version'} >= 1.182) {
		# Access mail file directly
		return "../mailboxes/list_mail.cgi?user=".
			$self->urlize($self->user_mail_file($_[0]));
		}
	}
if ($self->{'config_hash'}->{'mail_system'} == 1 && $acl{$self->{'base_remote_user'},'sendmail'} &&
    $self->get_webmin_version() <= 1.140) {
	return "../sendmail/list_mail.cgi?user=".$_[0]->{'user'};
	}
elsif ($self->{'config_hash'}->{'mail_system'} == 0 && $acl{$self->{'base_remote_user'},'postfix'} &&
       $self->get_webmin_version() <= 1.140) {
	return "../postfix/list_mail.cgi?user=".$_[0]->{'user'};
	}
elsif ($self->{'config_hash'}->{'mail_system'} == 2 && $acl{$self->{'base_remote_user'},'qmailadmin'} &&
       $self->get_webmin_version() <= 1.140) {
	return "../qmailadmin/list_mail.cgi?user=".$_[0]->{'user'};
	}
else {
	return undef;
	}
}

# postfix_installed()
# Returns 1 if postfix is installed
sub postfix_installed
{
	my $self = shift;

return $self->foreign_installed("postfix", 1) == 2;
}

# sendmail_installed()
# Returns 1 if postfix is installed
sub sendmail_installed
{
	my $self = shift;

return $self->foreign_installed("sendmail", 1) == 2;
}

# qmail_installed()
# Returns 1 if qmail is installed
sub qmail_installed
{
	my $self = shift;

return $self->foreign_installed("qmailadmin", 1) == 2;
}

# qmail_ldap_installed()
# Returns 1 if qmail is installed, and supports LDAP
sub qmail_ldap_installed
{
	my $self = shift;

return 0 if (!$self->qmail_installed());
local %qconfig = $self->foreign_config("qmailadmin");
return -r "$qconfig{'qmail_dir'}/control/ldapserver" ? 1 : 0;
}

# qmail_vpopmail_installed()
# Returns 1 if qmail is installed, and the VPOPMail extensions
sub qmail_vpopmail_installed
{
	my $self = shift;

return 0 if (!$self->qmail_installed());
return -x "$self->{'config_hash'}->{'vpopmail_dir'}/bin/vadddomain";
}

# check_alias_clash(name)
# Checks if an alias with the given name already exists
sub check_alias_clash
{
	my $self = shift;

$self->require_mail();
if ($self->{'config_hash'}->{'mail_system'} == 1) {
	local @aliases = $main::sendmail_object->list_aliases($self->{'sendmail_afiles'});
	local ($clash) = grep { lc($_->{'name'}) eq lc($_[0]) &&
				$_->{'enabled'} } @aliases;
	return $clash;
	}
elsif ($self->{'config_hash'}->{'mail_system'} == 0) {
	local @aliases = $main::postfix_object->list_aliases($self->{'postfix_afiles'});
	local ($clash) = grep { lc($_->{'name'}) eq lc($_[0]) &&
				$_->{'enabled'} } @aliases;
	return $clash;
	}
return undef;
}

# backup_mail(&domain, file, &options)
# Saves all mail aliases and mailbox users for this domain
sub backup_mail
{
	my $self = shift;

$self->require_mail();

# Create dummy file
$self->open_tempfile(FILE, ">$_[1]");
$self->close_tempfile(FILE);

# Build file of all virtusers. Each line contains one virtuser address and
# it's destinations, in alias-style format
do { my $fn = $self->{'first_print'}; $self->$fn($self->{'text_hash'}->{'backup_mailaliases'})};
$self->open_tempfile(AFILE, ">$_[1]_aliases");
local $a;
foreach $a ($self->list_domain_aliases($_[0])) {
	unless ($a->{'virt'}->{'file'}=~/\/virtual-mailman$/){
		$self->print_tempfile(AFILE, $a->{'from'},": ");
		$self->print_tempfile(AFILE, join(",", @{$a->{'to'}}),"\n");
		}	
	}
$self->close_tempfile(AFILE);
do { my $fn = $self->{'second_print'}; $self->$fn($self->{'text_hash'}->{'setup_done'})};

# Build file of all mailboxes. Each user has a passwd-file style line with
# the email address and quotas appended, followed by a list of destination
# addresses.
do { my $fn = $self->{'first_print'}; $self->$fn($self->{'text_hash'}->{'backup_mailusers'})};
$self->open_tempfile(UFILE, ">$_[1]_users");
local $u;
foreach $u ($self->list_domain_users($_[0])) {
	$self->print_tempfile(UFILE, join(":", $u->{'user'}, $u->{'pass'},
			      $u->{'uid'}, $u->{'gid'},
			      $u->{'real'}, $u->{'home'}, $u->{'shell'},
			      $u->{'email'}));
	if ($self->{'config_hash'}->{'home_quotas'} && $self->{'user'}->{'unix'}) {
		$self->print_tempfile(UFILE, ":$self->{'user'}->{'quota'}");
		if ($self->{'config_hash'}->{'mail_quotas'} &&
		    $self->{'config_hash'}->{'home_quotas'} ne $self->{'config_hash'}->{'mail_quotas'}) {
			$self->print_tempfile(UFILE, ":$self->{'user'}->{'mquota'}");
			}
		}
	elsif ($self->{'user'}->{'mailquota'}) {
		$self->print_tempfile(UFILE, ":$self->{'user'}->{'qquota'}");
		}
	$self->print_tempfile(UFILE, "\n");
	$self->print_tempfile(UFILE, join(",", @{$u->{'to'}}),"\n");
	}
$self->close_tempfile(UFILE);
do { my $fn = $self->{'second_print'}; $self->$fn($self->{'text_hash'}->{'setup_done'})};

if (!$self->mail_under_home() && $_[2]->{'mailfiles'}) {
	# Backup actual mail files too..
	local $mbase = $self->mail_system_base();
	local @mfiles;
	do { my $fn = $self->{'first_print'}; $self->$fn($self->{'text_hash'}->{'backup_mailfiles'})};
	foreach $u ($self->list_domain_users($_[0])) {
		local $umf = $self->user_mail_file($u);
		if ($umf =~ s/^$mbase\///) {
			push(@mfiles, $umf) if (-r "$mbase/$umf");
			}
		}
	if (!@mfiles) {
		do { my $fn = $self->{'second_print'}; $self->$fn($self->{'text_hash'}->{'backup_mailfilesnone'})};
		}
	else {
		local $mfiles = join(" ", map { quotemeta($_) } @mfiles);
		local $out = `cd '$mbase'; tar cf '$_[1]_files' $mfiles 2>&1`;
		if ($?) {
			do { my $fn = $self->{'second_print'}; $self->$fn($self->text('backup_mailfilesfailed',
					     "<pre>$out</pre>"))};
			return 0;
			}
		else {
			do { my $fn = $self->{'second_print'}; $self->$fn($self->{'text_hash'}->{'setup_done'})};
			}
		}
	}

return 1;
}

# restore_mail(&domain, file, &options, &all-options)
sub restore_mail
{
	my $self = shift;

# Delete all mailboxes (but not home dirs) and re-create
do { my $fn = $self->{'first_print'}; $self->$fn($self->{'text_hash'}->{'restore_mailusers'})};
local ($u, %olduid, @errs);
foreach $u ($self->list_domain_users($_[0], 1)) {
	$olduid{$u->{'user'}} = $u->{'uid'};
	$self->delete_user($u, $_[0]);
	}
local %exists;
foreach $u ($self->list_all_users()) {
	$exists{$u->{'name'},$u->{'unix'}} = $u;
	}
open(UFILE, "$_[1]_users");
while(<UFILE>) {
	s/\r|\n//g;
	local @user = split(/:/, $_);
	$_ = <UFILE>;
	s/\r|\n//g;
	local @to = split(/,/, $_);
	if ($user[0] eq $_[0]->{'user'}) {
		# Domain owner, just update alias list
		local @users = $self->list_domain_users($_[0]);
		local ($uinfo) = grep { $_->{'user'} eq $_[0]->{'user'}} @users;
		local %old = %$uinfo;
		$uinfo->{'email'} = $user[7];
		$uinfo->{'to'} = \@to;
		$self->modify_user($uinfo, \%old, $_[0]);
		}
	else {
		# Need to create user
		local $uinfo = $self->create_initial_user($_[0]);
		if ($exists{$user[0],$uinfo->{'unix'}}) {
			push(@errs, $self->text('restore_mailexists', $user[0]));
			next;
			}
		$uinfo->{'user'} = $user[0];
		$uinfo->{'pass'} = $user[1];
		if ($olduid{$user[0]}) {
			# Use old UID
			$uinfo->{'uid'} = $olduid{$user[0]};
			}
		elsif ($_[3]->{'reuid'}) {
			# Re-allocate UID
			local %taken;
			$self->build_taken(\%taken);
			$uinfo->{'uid'} = $self->allocate_uid(\%taken);
			}
		else {
			# Stick with original
			$uinfo->{'uid'} = $user[2];
			}
		$uinfo->{'gid'} = $_[0]->{'gid'};
		$uinfo->{'real'} = $user[4];
		$uinfo->{'home'} = $user[5];
		$uinfo->{'shell'} = $user[6];
		$uinfo->{'email'} = $user[7];
		$uinfo->{'to'} = \@to;
		if ($uinfo->{'mailquota'}) {
			$uinfo->{'qquota'} = $user[8];
			}
		$self->create_user($uinfo, $_[0]);
		if ($uinfo->{'unix'}) {
			if ($self->{'config_hash'}->{'home_quotas'} && $user[8]) {
				$self->set_quota($user[0], $self->{'config_hash'}->{'home_quotas'},
					   $user[8]);
				}
			if ($self->{'config_hash'}->{'mail_quotas'} && $user[9] &&
			    $self->{'config_hash'}->{'mail_quotas'} ne $self->{'config_hash'}->{'home_quotas'}) {
				$self->set_quota($user[0], $self->{'config_hash'}->{'mail_quotas'},
					   $user[9]);
				}
			}
		}
	}
close(UFILE);
if (@errs) {
	do { my $fn = $self->{'second_print'}; $self->$fn($self->text('restore_mailerrs', join(" ", @errs)))};
	}
else {
	do { my $fn = $self->{'second_print'}; $self->$fn($self->{'text_hash'}->{'setup_done'})};
	}

# Delete all aliases and re-create
do { my $fn = $self->{'first_print'}; $self->$fn($self->{'text_hash'}->{'restore_mailaliases'})};
local $a;
foreach $a ($self->list_domain_aliases($_[0])) {
	$self->delete_virtuser($a);
	}
open(AFILE, "$_[1]_aliases");
while(<AFILE>) {
	if (/^(\S+):\s*(.*)/) {
		local $virt = { 'from' => $1,
				'to' => [ split(/,/, $2) ] };
		$self->create_virtuser($virt);
		}
	}
close(AFILE);
do { my $fn = $self->{'second_print'}; $self->$fn($self->{'text_hash'}->{'setup_done'})};

if (!$self->mail_under_home() && -r "$_[1]_files" && $_[2]->{'mailfiles'}) {
	# Extract all mail files
	local $mbase = $self->mail_system_base();
	do { my $fn = $self->{'first_print'}; $self->$fn($self->{'text_hash'}->{'restore_mailfiles'})};
	local $out = `cd '$mbase' && tar xf '$_[1]_files' 2>&1`;
	if ($?) {
		do { my $fn = $self->{'second_print'}; $self->$fn($self->text('backup_mailfilesfailed',
				     "<pre>$out</pre>"))};
		return 0;
		}
	else {
		do { my $fn = $self->{'second_print'}; $self->$fn($self->{'text_hash'}->{'setup_done'})};
		}
	}

# Set mailbox user home directory permissions
local $hb = "$_[0]->{'home'}/$self->{'config_hash'}->{'homes_dir'}";
foreach $u ($self->list_domain_users($_[0], 1)) {
	if (-d $u->{'home'} && $self->is_under_directory($hb, $u->{'home'})) {
		system("chown -R $u->{'uid'}:$u->{'gid'} ".
		       quotemeta($u->{'home'}));
		}
	}

return 1;
}

# show_backup_mail(&options)
# Returns HTML for mail backup option inputs
sub show_backup_mail
{
	my $self = shift;

if ($self->mail_under_home()) {
	# Option makes no sense in this case, as the home directories backup
	# will catch it
	return "<input type=hidden name=mail_mailfiles value='$self->{'opts_hash'}->{'mailfiles'}'>";
	}
else {
	# Offer to backup mail files
	return sprintf
		"(<input type=checkbox name=mail_mailfiles value=1 %s> %s)",
		$self->{'opts_hash'}->{'mailfiles'} ? "checked" : "", $self->{'text_hash'}->{'backup_mailfiles2'};
	}
}

# parse_backup_mail(&in)
# Parses the inputs for mail backup options
sub parse_backup_mail
{
	my $self = shift;

local %in = %{$_[0]};
return { 'mailfiles' => $in{'mail_mailfiles'} };
}

# show_restore_mail(&options)
# Returns HTML for mail restore option inputs
sub show_restore_mail
{
	my $self = shift;

if ($self->mail_under_home()) {
	# Option makes no sense in this case, as the home directories backup
	# will catch it
	return "<input type=hidden name=mail_mailfiles value='$self->{'opts_hash'}->{'mailfiles'}'>";
	}
else {
	# Offer to restore mail files
	return sprintf
		"(<input type=checkbox name=mail_mailfiles value=1 %s> %s)",
		$self->{'opts_hash'}->{'mailfiles'} ? "checked" : "", $self->{'text_hash'}->{'restore_mailfiles2'};
	}
}

# parse_restore_mail(&in)
# Parses the inputs for mail backup options
sub parse_restore_mail
{
	my $self = shift;

local %in = %{$_[0]};
return { 'mailfiles' => $in{'mail_mailfiles'} };
}

# check_clash(name, dom)
# Returns 1 if a virtuser or user with the name already exists.
# Returns 2 if an alias with the same mailbox name already exists.
sub check_clash
{
	my $self = shift;

$self->require_mail();
local @virts = $self->list_virtusers();
local ($clash) = grep { $_->{'from'} eq $_[0]."\@".$_[1] } @virts;
return 1 if ($clash);
if ($self->{'config_hash'}->{'mail_system'} == 1) {
	local @aliases = $main::sendmail_object->list_aliases($self->{'sendmail_afiles'});
	local $an = $_[0] ? "$_[0]-$_[1]" : "default-$_[1]";
	($clash) = grep { ($self->{'config_hash'}->{'alias_clash'} &&
			   $_[0] && $_->{'name'} eq $_[0]) ||
			  $_->{'name'} eq $an } @aliases;
	return 2 if ($clash);
	}
elsif ($self->{'config_hash'}->{'mail_system'} == 0) {
	local @aliases = $main::postfix_object->list_aliases($self->{'postfix_afiles'});
	local $an = $_[0] ? "$_[0]-$_[1]" : "default-$_[1]";
	($clash) = grep { ($self->{'config_hash'}->{'alias_clash'} &&
			   $_[0] && $_->{'name'} eq $_[0]) ||
			  $_->{'name'} eq $an } @aliases;
	return 2 if ($clash);
	}
elsif ($self->{'config_hash'}->{'mail_system'} == 2) {
	# XXX not done for qmail yet
	}
return 0;
}

# check_depends_mail(&dom)
# Ensure that a mail domain has a home directory and Unix group
sub check_depends_mail
{
	my $self = shift;

if ($_[0]->{'alias'}) {
	# If this is an alias domain, then no home is needed
	return undef;
	}
elsif ($_[0]->{'parent'}) {
	# If this is a sub-domain, then the parent needs a Unix user
	local $parent = $self->get_domain($_[0]->{'parent'});
	return $parent->{'unix'} ? undef : $self->{'text_hash'}->{'setup_edepmail'};
	}
elsif ($self->{'config_hash'}->{'mail_system'} == 5) {
	# For a VPOPMail domain, there are no dependencies!
	return undef;
	}
else {
	# For a top-level domain, it needs a Unix user
	return $_[0]->{'unix'} ? undef : $self->{'text_hash'}->{'setup_edepmail'};
	}
}

# mail_system_name([num])
sub mail_system_name
{
	my $self = shift;

local $num = defined($_[0]) ? $_[0] : $self->{'config_hash'}->{'mail_system'};
return $self->{'text_hash'}->{'mail_system_'.$num} || "???";
}

# create_replace_mapping(mapname, &map, [&force-file])
# Add or replace a Postfix mapping
sub create_replace_mapping
{
	my $self = shift;

local $maps = $main::postfix_object->get_maps($_[0], $_[2]);
local ($clash) = grep { $_->{'name'} eq $_[1]->{'name'} } @$maps;
if ($clash) {
	$main::postfix_object->modify_mapping($_[0], $clash, $_[1]);
	}
else {
	$main::postfix_object->create_mapping($_[0], $_[1], $_[2]);
	}
}

# mail_system_needs_group()
# Returns 1 if the current mail system needs a Unix group for mailboxes
sub mail_system_needs_group
{
	my $self = shift;

return 0 if ($self->{'config_hash'}->{'mail_system'} == 5);	# never for vpopmail
#return 0 if ($self->{'config_hash'}->{'mail_system'} == 4 &&	# not for Qmail+LDAP,
#	     !$self->{'config_hash'}->{'ldap_unix'});		# if users are non-unix
return 1;
}

# bandwidth_mail(&domain, start, &bw-hash)
# Searches through log files for records after some date, and updates the
# day counters in the given hash
sub bandwidth_mail
{
	my $self = shift;

return $_[1] if (!$self->{'config_hash'}->{'bw_maillog'});
require 'timelocal.pl';
local $max_ltime = $_[1];
local %maildoms = map { $_, 1 } ($_[0]->{'dom'},
				 split(/\s+/, $_[0]->{'bw_maildoms'}) );
local $f;
foreach $f ($self->{'config_hash'}->{'bw_maillog_rotated'} ?
	    $self->all_log_files($self->{'config_hash'}->{'bw_maillog'}, $max_ltime) :
	    ( $self->{'config_hash'}->{'bw_maillog'} )) {
	if ($f =~ /\.gz$/i) {
		open(LOG, "gunzip -c ".quotemeta($f)." |");
		}
	elsif ($f =~ /\.Z$/i) {
		open(LOG, "uncompress -c ".quotemeta($f)." |");
		}
	else {
		open(LOG, $f);
		}

	# Scan the log, looking for entries for various mail systems
	local %sizes;
	local $now = time();
	local @tm = localtime($now);
	while(<LOG>) {
		# Sendmail / postfix formats
		s/\r|\n//g;
		if (/^(\S+)\s+(\d+)\s+(\d+):(\d+):(\d+)\s+(\S+)\s+(\S+):\s+(\S+):\s+from=(\S+),\s+size=(\d+)/) {
			# The initial From: line that contains the size
			$sizes{$8} = $10;
			}
		elsif (/^(\S+)\s+(\d+)\s+(\d+):(\d+):(\d+)\s+(\S+)\s+(\S+):\s+(\S+):\s+to=(\S+),(\s+orig_to=(\S+))?/) {
			# A To: line that has the local recipient
			local $ltime = timelocal($5, $4, $3, $2,
			    $self->{'apache_mmap_hash'}->{lc($1)}, $tm[5]);
			if ($ltime > $now+(24*60*60)) {
				# Must have been last year!
				$ltime = timelocal($5, $4, $3, $2,
				     $self->{'apache_mmap_hash'}->{lc($1)}, $tm[5]-1);
				} 
			$max_ltime = $ltime if ($ltime > $max_ltime);
			if ($ltime > $_[1] && $sizes{$8}) {
				local $sz = $sizes{$8};
				local $user = $11 || $9;
				$user =~ s/^<(.*)>/$1/;
				$user =~ s/,$//;
				local ($mb, $dom) = split(/\@/, $user);
				if ($maildoms{$dom}) {
					# To a user in this domain
					local $day =
					    int($ltime / (24*60*60));
					$_[2]->{"mail_".$day} += $sz;
					}
				}
			}

		# Qmail format
		elsif (/^\@(\S+)\s+info\s+msg\s+(\S+):\s+bytes\s+(\d+)\s+from/ ||
		       /(\d+\.\d+)\s+info\s+msg\s+(\S+):\s+bytes\s+(\d+)\s+from/) {
			# From: line with size
			$sizes{$2} = $3;
			}
		elsif (/^\@(\S+)\s+starting\s+delivery\s+(\S+):\s+msg\s+(\S+)\s+to\s+local\s+(\S+)/ ||
		       /(\d+\.\d+)\s+starting\s+delivery\s+(\S+):\s+msg\s+(\S+)\s+to\s+local\s+(\S+)/) {
			# To: line with actual address
			local $sz = $sizes{$3};
			local $user = $4;
			local $ltime = $self->tai64_time($1);
			$max_ltime = $ltime if ($ltime > $max_ltime);
			if ($ltime > $_[1] && $sz) {
				$user =~ s/^<(.*)>/$1/;
				local ($mb, $dom) = split(/\@/, $user);
				if ($maildoms{$dom}) {
					# To a user in this domain
					local $day =
					    int($ltime / (24*60*60));
					$_[2]->{"mail_".$day} += $sz;
					}
				}

			}
		}
	close(LOG);
	}
return $max_ltime;
}

sub tai64_time
{
	my $self = shift;

if ($_[0] =~ /^40000000(\S{8})/) {
	return hex($1);
	}
elsif ($_[0] =~ /^(\d+)\.(\d+)$/) {
        return $1;
        }
return undef;
}


1;

