#!/usr/bin/perl
package virtual_server::Featuremysql;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'virtual_server::Featuremysql');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;

1;

1;
		return $self;
}

sub require_mysql
{
	my $self = shift;

return if ($self->{'require_mysql'}++);
$main::mysql_object->{'use_global_login'} = 1;
$self->foreign_require("mysql", "mysql-lib.pl");
%{$self->{'mconfig_hash'}} = $self->foreign_config("mysql");
$self->{'password_func'} = $main::mysql_object->{'password_func'} || "password";
}

# setup_mysql(&domain, [no-db])
# Create a new MySQL database, user and permissions
sub setup_mysql
{
	my $self = shift;

local $tmpl = $self->get_template($_[0]->{'template'});
$self->require_mysql();

# Create the user
$_[0]->{'mysql_user'} = $self->mysql_user($_[0]);
local $user = $_[0]->{'mysql_user'};
local @hosts = $self->get_mysql_hosts($_[0]);
local $wild = $self->substitute_template($tmpl->{'mysql_wild'}, $_[0]);
if (!$_[0]->{'parent'}) {
	do { my $fn = $self->{'first_print'}; $self->$fn($self->{'text_hash'}->{'setup_mysqluser'})};
	my $pass = $self->mysql_pass($_[0]);
	local $qpass = $self->mysql_escape($pass);
	local $h;
	foreach $h (@hosts) {
		$main::mysql_object->execute_sql_logged($main::mysql_object->{'master_db'}, "insert into user (host, user, password) values ('$h', '$user', $self->{'password_func'}('$qpass'))");
		if ($wild && $wild ne $_[0]->{'db'}) {
			$self->add_db_table($h, $wild, $user);
			}
		}
	do { my $fn = $self->{'second_print'}; $self->$fn($self->{'text_hash'}->{'setup_done'})};
	}
$main::mysql_object->execute_sql_logged($main::mysql_object->{'master_db'}, 'flush privileges');

# Create the initial DB
if (!$_[1] && $tmpl->{'mysql_mkdb'}) {
	$self->create_mysql_database($_[0], $_[0]->{'db'});
	}
else {
	$_[0]->{'db_mysql'} ||= "";
	}
}

# delete_mysql(&domain)
# Delete a mysql database, the domain's mysql user and all permissions for both
sub delete_mysql
{
	my $self = shift;

# First remove the databases
$self->require_mysql();
if ($_[0]->{'db_mysql'}) {
	$self->delete_mysql_database($_[0], $self->unique(split(/\s+/, $_[0]->{'db_mysql'})));
	}

# Then remove the user
local $user = $self->mysql_user($_[0]);
local $tmpl = $self->get_template($_[0]->{'template'});
local $wild = $self->substitute_template($tmpl->{'mysql_wild'}, $_[0]);
if (!$_[0]->{'parent'}) {
	# Delete the user and any database permissions
	do { my $fn = $self->{'first_print'}; $self->$fn($self->{'text_hash'}->{'delete_mysqluser'})};
	$main::mysql_object->execute_sql_logged($main::mysql_object->{'master_db'}, "delete from user where user = '$user'");
	$main::mysql_object->execute_sql_logged($main::mysql_object->{'master_db'}, "delete from db where user = '$user'");
	do { my $fn = $self->{'second_print'}; $self->$fn($self->{'text_hash'}->{'setup_done'})};
	}
if ($wild && $wild ne $_[0]->{'db'}) {
	# Remove any wildcard entry for the user
	$main::mysql_object->execute_sql_logged($main::mysql_object->{'master_db'}, "delete from db where db = '$wild'");
	}
$main::mysql_object->execute_sql_logged($main::mysql_object->{'master_db'}, 'flush privileges');
}

# modify_mysql(&domain, &olddomain)
# Changes the mysql user's password if needed
sub modify_mysql
{
	my $self = shift;

$self->require_mysql();
local $olduser = $self->mysql_user($_[1]);
local $user = $self->mysql_user($_[0], 1);
$_[0]->{'mysql_user'} = $user;
my $oldpass = $self->mysql_pass($_[1]);
my $pass = $self->mysql_pass($_[0]);
local $tmpl = $self->get_template($_[0]->{'id'});
if ($pass ne $oldpass && !$_[0]->{'parent'} && !$tmpl->{'mysql_nopass'}) {
	# Change MySQL password
	do { my $fn = $self->{'first_print'}; $self->$fn($self->{'text_hash'}->{'save_mysqlpass'})};
	if ($self->mysql_user_exists($_[0])) {
		local $qpass = $self->mysql_escape($pass);
		$main::mysql_object->execute_sql_logged($main::mysql_object->{'master_db'}, "update user set password = $self->{'password_func'}('$qpass') where user = '$olduser'");
		$main::mysql_object->execute_sql_logged($self->{'master_db'}, 'flush privileges');
		do { my $fn = $self->{'second_print'}; $self->$fn($self->{'text_hash'}->{'setup_done'})};
		return 1;
		}
	else {
		do { my $fn = $self->{'second_print'}; $self->$fn($self->{'text_hash'}->{'save_nomysql'})};
		}
	}
if ($_[0]->{'user'} ne $_[1]->{'user'} && !$_[0]->{'parent'}) {
	# Rename MySQL user
	do { my $fn = $self->{'first_print'}; $self->$fn($self->{'text_hash'}->{'save_mysqluser'})};
	if ($self->mysql_user_exists($_[1])) {
		$main::mysql_object->execute_sql_logged($main::mysql_object->{'master_db'}, "update user set user = '$user' where user = '$olduser'");
		$main::mysql_object->execute_sql_logged($main::mysql_object->{'master_db'}, "update db set user = '$user' where user = '$olduser'");
		$main::mysql_object->execute_sql_logged($self->{'master_db'}, 'flush privileges');
		do { my $fn = $self->{'second_print'}; $self->$fn($self->{'text_hash'}->{'setup_done'})};
		return 1;
		}
	else {
		do { my $fn = $self->{'second_print'}; $self->$fn($self->{'text_hash'}->{'save_nomysql'})};
		}
	}
return 0;
}

# disable_mysql(&domain)
# Modifies the mysql user for this domain so that he cannot login
sub disable_mysql
{
	my $self = shift;

do { my $fn = $self->{'first_print'}; $self->$fn($self->{'text_hash'}->{'disable_mysqluser'})};
if ($_[0]->{'parent'}) {
	do { my $fn = $self->{'second_print'}; $self->$fn($self->{'text_hash'}->{'save_nomysqlpar'})};
	}
else {
	$self->require_mysql();
	local $user = $self->mysql_user($_[0]);
	if ($self->{'oldpass'} = $self->mysql_user_exists($_[0])) {
		$main::mysql_object->execute_sql_logged($main::mysql_object->{'master_db'}, "update user set password = '*LK*' where user = '$user'");
		$main::mysql_object->execute_sql_logged($self->{'master_db'}, 'flush privileges');
		$_[0]->{'disabled_oldmysql'} = $self->{'oldpass'};
		do { my $fn = $self->{'second_print'}; $self->$fn($self->{'text_hash'}->{'setup_done'})};
		}
	else {
		do { my $fn = $self->{'second_print'}; $self->$fn($self->{'text_hash'}->{'save_nomysql'})};
		}
	}
}

# enable_mysql(&domain)
# Puts back the original password for the mysql user so that he can login again
sub enable_mysql
{
	my $self = shift;

do { my $fn = $self->{'first_print'}; $self->$fn($self->{'text_hash'}->{'enable_mysql'})};
if ($_[0]->{'parent'}) {
	do { my $fn = $self->{'second_print'}; $self->$fn($self->{'text_hash'}->{'save_nomysqlpar'})};
	}
else {
	$self->require_mysql();
	local $user = $self->mysql_user($_[0]);
	if ($self->mysql_user_exists($_[0])) {
		if ($_[0]->{'disabled_oldmysql'}) {
			local $qpass = $self->mysql_escape(
				$_[0]->{'disabled_oldmysql'});
			$main::mysql_object->execute_sql_logged($main::mysql_object->{'master_db'}, "update user set password = '$qpass' where user = '$user'");
			delete($_[0]->{'disabled_oldmysql'});
			}
		else {
			local $pass = $self->mysql_pass($_[0]);
			local $qpass = $self->mysql_escape($pass);
			$main::mysql_object->execute_sql_logged($main::mysql_object->{'master_db'}, "update user set password = $self->{'password_func'}('$qpass') where user = '$user'");
			}
		$main::mysql_object->execute_sql($self->{'master_db'}, 'flush privileges');
		do { my $fn = $self->{'second_print'}; $self->$fn($self->{'text_hash'}->{'setup_done'})};
		}
	else {
		do { my $fn = $self->{'second_print'}; $self->$fn($self->{'text_hash'}->{'save_nomysql'})};
		}
	}
}

# mysql_user_exists(&domain)
# Returns his password if a mysql user exists for the domain's user, or undef
sub mysql_user_exists
{
	my $self = shift;

$self->require_mysql();
local $user = $self->mysql_user($_[0]);
local $u = $main::mysql_object->execute_sql($main::mysql_object->{'master_db'}, "select password from user where user = '$user'");
return @{$u->{'data'}} ? $u->{'data'}->[0]->[0] : undef;
}

# check_mysql_clash(&domain, [field])
# Returns 1 if some MySQL database already exists
sub check_mysql_clash
{
	my $self = shift;

if (!$_[1] || $_[1] eq 'db') {
	$self->require_mysql();
	local @dblist = $main::mysql_object->list_databases();
	return 1 if ($self->indexof($_[0]->{'db'}, @dblist) >= 0);
	}
if (!$_[0]->{'parent'} && (!$_[1] || $_[1] eq 'user')) {
	$self->require_mysql();
	return 1 if ($self->mysql_user_exists($_[0]));
	}
return 0;
}

# backup_mysql(&domain, file)
# Dumps this domain's mysql database to a backup file
sub backup_mysql
{
	my $self = shift;

$self->require_mysql();

# Find all domain's databases
local $tmpl = $self->get_template($_[0]->{'template'});
local $wild = $self->substitute_template($tmpl->{'mysql_wild'}, $_[0]);
local @alldbs = $main::mysql_object->list_databases();
local @dbs;
if ($wild) {
	$wild =~ s/\%/\.\*/g;
	$wild =~ s/_/\./g;
	@dbs = grep { /^$wild$/i } @alldbs;
	}
push(@dbs, split(/\s+/, $_[0]->{'db_mysql'}));
@dbs = $self->unique(@dbs);

# Create empty 'base' backup file
$self->open_tempfile(EMPTY, ">$_[1]");
$self->close_tempfile(EMPTY);

# Back them all up
local $db;
foreach $db (@dbs) {
	do { my $fn = $self->{'first_print'}; $self->$fn($self->text('backup_mysqldump', $db))};
	local $dbfile = $_[1]."_".$db;
	local $cmd = "$main::mysql_object->{'config_hash'}->{'mysqldump'} $main::mysql_object->{'authstr'} --add-drop-table".
		     ($main::mysql_object->supports_quoting() ? " --quote-names" : "").
		     " ".quotemeta($db)." 2>&1 >".quotemeta($dbfile);
	local $out = `$cmd`;
	if ($? || $out) {
		do { my $fn = $self->{'second_print'}; $self->$fn($self->text('backup_mysqldumpfailed', "<pre>$out</pre>"))};
		return 0;
		}
	else {
		do { my $fn = $self->{'second_print'}; $self->$fn($self->{'text_hash'}->{'setup_done'})};
		}
	}
return 1;
}

# restore_mysql(&domain, file)
# Restores this domain's mysql database from a backup file, and re-creates
# the mysql user.
sub restore_mysql
{
	my $self = shift;

do { my $fn = $self->{'first_print'}; $self->$fn($self->{'text_hash'}->{'restore_mysqldrop'})};
	{
	local $first_print_tmp = $self->{'first_print'};	# supress messages
	local $second_print_tmp = $self->{'second_print'};
	$self->{'first_print'} = sub {};
	$self->{'second_print'} = sub {};
	$self->require_mysql();

	# First clear out all current databases and the MySQL login
	$self->delete_mysql($_[0]);

	# Now re-set up the login only
	$self->setup_mysql($_[0], 1);
	$self->{'first_print'} = $first_print_tmp;
	$self->{'second_print'} = $second_print_tmp;
	}
do { my $fn = $self->{'second_print'}; $self->$fn($self->{'text_hash'}->{'setup_done'})};

# Work out which databases are in backup
local ($dbfile, @dbs);
push(@dbs, [ $_[0]->{'db'}, $_[1] ]) if (-s $_[1]);
foreach $dbfile (glob("$_[1]_*")) {
	if (-r $dbfile) {
		$dbfile =~ /\Q$_[1]\E_(.*)$/;
		push(@dbs, [ $1, $dbfile ]);
		}
	}

# Finally, import the data
local $db;
foreach $db (@dbs) {
	$self->create_mysql_database($_[0], $db->[0]);
	do { my $fn = $self->{'first_print'}; $self->$fn($self->text('restore_mysqlload', $db->[0]))};
	local $cmd = "$main::mysql_object->{'config_hash'}->{'mysql'} $main::mysql_object->{'authstr'} -t ".quotemeta($db->[0])." <".quotemeta($db->[1])." 2>&1";
	local $out = $self->backquote_logged($cmd);
	if ($? || $out) {
		do { my $fn = $self->{'second_print'}; $self->$fn($self->text('restore_mysqlloadfailed', "<pre>$out</pre>"))};
		return 0;
		}
	else {
		do { my $fn = $self->{'second_print'}; $self->$fn($self->{'text_hash'}->{'setup_done'})};
		}
	}
return 1;
}

# mysql_user(&domain, [always-new])
sub mysql_user
{
	my $self = shift;

return $_[0]->{'mysql_user'} if (defined($_[0]->{'mysql_user'}) && !$_[1]);
return length($_[0]->{'user'}) > 16 ?
	  substr($_[0]->{'user'}, 0, 16) : $_[0]->{'user'};
}

# mysql_pass(&domain)
sub mysql_pass
{
	my $self = shift;

return defined($_[0]->{'mysql_pass'}) ? $_[0]->{'mysql_pass'} : $_[0]->{'pass'};
}

# mysql_escape(string)
# Returns a string with quotes escaped, for use in SQL
sub mysql_escape
{
	my $self = shift;

local $rv = $_[0];
$rv =~ s/'/''/g;
return $rv;
}

# mysql_size(&domain, dbname)
# Returns the size and number of tables in a database
sub mysql_size
{
	my $self = shift;

$self->require_mysql();
local $size;
if (-d $main::mysql_object->{'config_hash'}->{'mysql_data'}) {
	$size = $self->disk_usage_kb("$main::mysql_object->{'config_hash'}->{'mysql_data'}/$_[1]")*1024;
	}
local @tables = $main::mysql_object->list_tables($_[1], 1);
return ($size, scalar(@tables));
}

# check_mysql_database_clash(&domain, dbname)
# Check if some MySQL database already exists
sub check_mysql_database_clash
{
	my $self = shift;

$self->require_mysql();
local @dblist = $main::mysql_object->list_databases();
return 1 if ($self->indexof($_[1], @dblist) >= 0);
}

# create_mysql_database(&domain, dbname)
# Add one database to this domain, and grants access to it to the user
sub create_mysql_database
{
	my $self = shift;

# Create the database
do { my $fn = $self->{'first_print'}; $self->$fn($self->text('setup_mysqldb', $_[1]))};
local @dbs = split(/\s+/, $_[0]->{'db_mysql'});
$main::mysql_object->execute_sql_logged($main::mysql_object->{'master_db'}, "create database $_[1]");
push(@dbs, $_[1]);
$_[0]->{'db_mysql'} = join(" ", @dbs);

# Add db entries for the user for each host
local $tmpl = $self->get_template($_[0]->{'template'});
local $h;
local @hosts = $self->get_mysql_hosts($_[0]);
local $user = $self->mysql_user($_[0]);
foreach $h (@hosts) {
	$self->add_db_table($h, $_[1], $user);
	}
$main::mysql_object->execute_sql_logged($main::mysql_object->{'master_db'}, 'flush privileges');
do { my $fn = $self->{'second_print'}; $self->$fn($self->{'text_hash'}->{'setup_done'})};
}

# delete_mysql_database(&domain, dbname, ...)
# Remove one or more MySQL database from this domain
sub delete_mysql_database
{
	my $self = shift;

$self->require_mysql();
local @dblist = $main::mysql_object->list_databases();
do { my $fn = $self->{'first_print'}; $self->$fn($self->text('delete_mysqldb', join(", ", @_[1..$#_])))};
local @dbs = split(/\s+/, $_[0]->{'db_mysql'});
foreach $db (@_[1..$#_]) {
	local $qdb = $self->quote_mysql_database($db);
	if ($self->indexof($db, @dblist) >= 0) {
		# Drop the DB
		$main::mysql_object->execute_sql_logged($main::mysql_object->{'master_db'}, "drop database $db");

		# Remove any db permissions for it
		$main::mysql_object->execute_sql_logged($main::mysql_object->{'master_db'}, "delete from db where (db = '$db' or db = '$qdb')");
		}
	@dbs = grep { $_ ne $db } @dbs;
	}
$_[0]->{'db_mysql'} = join(" ", @dbs);
$main::mysql_object->execute_sql_logged($main::mysql_object->{'master_db'}, 'flush privileges');
do { my $fn = $self->{'second_print'}; $self->$fn($self->{'text_hash'}->{'setup_done'})};
}

# get_mysql_hosts(&domain)
# Returns the allowed MySQL hosts for some domain
sub get_mysql_hosts
{
	my $self = shift;

local $tmpl = $self->get_template($_[0]->{'template'});
local @hosts = $tmpl->{'mysql_hosts'} eq "none" ? ( ) :
	split(/\s+/, $self->substitute_template($tmpl->{'mysql_hosts'}, $_[0]));
@hosts = ( 'localhost' ) if (!@hosts);
return @hosts;
}

# add_db_table(host, db, user)
# Adds an entry to the db table, with all permission columns set to Y
sub add_db_table
{
	my $self = shift;

local @str = $main::mysql_object->table_structure($main::mysql_object->{'master_db'}, 'db');
local ($s, @fields, @yeses);
foreach $s (@str) {
        if ($s->{'field'} =~ /_priv$/i) {
                push(@fields, $s->{'field'});
                push(@yeses, "'Y'");
                }
        }
local $qdb = $self->quote_mysql_database($_[1]);
$main::mysql_object->execute_sql_logged($main::mysql_object->{'master_db'}, "insert into db (host, db, user, ".join(", ", @fields).") values ('$_[0]', '$qdb', '$_[2]', ".join(", ", @yeses).")");
}

# quote_mysql_database(name)
# Returns a mysql database name with % and _ characters escaped
sub quote_mysql_database
{
	my $self = shift;

local ($db) = @_;
$db =~ s/_/\\_/g;
$db =~ s/%/\\%/g;
return $db;
}


1;

