#!/usr/bin/perl
package virtual_server::Featuressl;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'virtual_server::Featuressl');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;

$self->{'feature_depends_hash'}->{'ssl'} = [ 'web', 'virt', 'dir' ];
$self->{'default_web_sslport'} = $self->{'config_hash'}->{'web_sslport'} || 443;

1;

1;
		return $self;
}

# setup_ssl(&domain)
# Creates a website with SSL enabled, and a private key and cert it to use.
sub setup_ssl
{
	my $self = shift;

local $tmpl = $self->get_template($_[0]->{'template'});
local $web_sslport = $tmpl->{'web_sslport'} || 443;
$self->require_apache();
local $conf = $main::apache_object->get_config();
if ($main::apache_object->{'config_hash'}->{'virt_file'}) {
	$self->{'f'} = -d $main::apache_object->{'config_hash'}->{'virt_file'} ?
		"$main::apache_object->{'config_hash'}->{'virt_file'}/www.$_[0]->{'dom'}.conf" :
		$main::apache_object->{'config_hash'}->{'virt_file'};
	}
else {
	$vconf = $main::apache_object->get_virtual_config();
	$self->{'f'} = $vconf->[0]->{'file'};
	}
$self->lock_file($self->{'f'});

# Create a self-signed cert and key, if needed
$_[0]->{'ssl_cert'} ||= "$_[0]->{'home'}/ssl.cert";
$_[0]->{'ssl_key'} ||= "$_[0]->{'home'}/ssl.key";
if (!-r $_[0]->{'ssl_cert'} && !-r $_[0]->{'ssl_key'}) {
	# Need to do it
	local $temp = $self->transname();
	do { my $fn = $self->{'first_print'}; $self->$fn($self->{'text_hash'}->{'setup_openssl'})};
	$self->lock_file($_[0]->{'ssl_cert'});
	$self->lock_file($_[0]->{'ssl_key'});
	open(CA, "| openssl req -newkey rsa:512 -x509 -nodes -out $_[0]->{'ssl_cert'} -keyout $_[0]->{'ssl_key'} -days 1825 >$temp 2>&1");
	print CA ".\n";
	print CA ".\n";
	print CA ".\n";
	print CA "$_[0]->{'owner'}\n";
	print CA ".\n";
	print CA "*.$_[0]->{'dom'}\n";
	print CA ($_[0]->{'email'} || "."),"\n";
	close(CA);
	local $rv = $?;
	local $out = `cat $temp`;
	unlink($temp);
	if (!-r $_[0]->{'ssl_cert'} || !-r $_[0]->{'ssl_key'} || $?) {
		do { my $fn = $self->{'second_print'}; $self->$fn($self->text('setup_eopenssl', "<pre>$out</pre>"))};
		}
	else {
		chown($_[0]->{'uid'}, $_[0]->{'ugid'}, $_[0]->{'ssl_cert'}, $_[0]->{'ssl_key'});
		chmod(0755, $_[0]->{'ssl_cert'}, $_[0]->{'ssl_key'});
		do { my $fn = $self->{'second_print'}; $self->$fn($self->{'text_hash'}->{'setup_done'})};
		}
	$self->unlock_file($_[0]->{'ssl_cert'});
	$self->unlock_file($_[0]->{'ssl_key'});
	}

# Add the actual <VirtualHost>
do { my $fn = $self->{'first_print'}; $self->$fn($self->{'text_hash'}->{'setup_ssl'})};
local @dirs = $self->apache_template($tmpl->{'web'}, $_[0], $tmpl->{'web_suexec'});
$self->open_tempfile(FILE, ">>$self->{'f'}");
$self->print_tempfile(FILE, "<VirtualHost $_[0]->{'ip'}:$web_sslport>\n");
foreach (@dirs) {
	$self->print_tempfile(FILE, $_,"\n");
	}
$self->print_tempfile(FILE,  "SSLEngine on\n");
$self->print_tempfile(FILE, "SSLCertificateFile $_[0]->{'ssl_cert'}\n");
$self->print_tempfile(FILE, "SSLCertificateKeyFile $_[0]->{'ssl_key'}\n");
$self->print_tempfile(FILE, "</VirtualHost>\n");
$self->close_tempfile(FILE);

# Update the non-SSL virtualhost to include the port number, to fix old
# hosts that were missing the :80
local ($virt, $vconf) = $self->get_apache_virtual($_[0]->{'dom'},
					    $_[0]->{'web_port'});
$self->lock_file($virt->{'file'});
local $lref = $self->read_file_lines($virt->{'file'});
if (!$_[0]->{'name'} && $lref->[$virt->{'line'}] !~ /:\d+/) {
	$lref->[$virt->{'line'}] =
		"<VirtualHost $_[0]->{'ip'}:$_[0]->{'web_port'}>";
	$self->flush_file_lines();
	}
$self->unlock_file($virt->{'file'});

# Add this IP and cert to Webmin/Usermin's SSL keys list
if ($tmpl->{'web_webmin_ssl'}) {
	$self->setup_ipkeys($_[0], 'get_miniserv_config', 'put_miniserv_config',
		      'restart_webmin');
	}
if ($tmpl->{'web_usermin_ssl'} && $self->foreign_installed("usermin")) {
	$self->foreign_require("usermin", "usermin-lib.pl");
	$self->setup_ipkeys($_[0], \&usermin::get_usermin_miniserv_config,
		      \&usermin::put_usermin_miniserv_config,
		      'restart_usermin');
	}

$self->unlock_file($self->{'f'});
undef(@{$main::apache_object->{'get_config_cache_array'}});
do { my $fn = $self->{'second_print'}; $self->$fn($self->{'text_hash'}->{'setup_done'})};
$self->register_post_action('restart_apache', 1);
$_[0]->{'web_sslport'} = $web_sslport;
}

# modify_ssl(&domain, &olddomain)
sub modify_ssl
{
	my $self = shift;

local $rv = 0;
$self->require_apache();
local $conf = $main::apache_object->get_config();
local ($virt, $vconf) = $self->get_apache_virtual($_[1]->{'dom'},
                                            $_[1]->{'web_sslport'});
local $tmpl = $self->get_template($_[0]->{'template'});
$self->lock_file($virt->{'file'});
if ($_[0]->{'home'} ne $_[1]->{'home'}) {
	# Home directory has changed .. update any directives that referred
	# to the old directory
	do { my $fn = $self->{'first_print'}; $self->$fn($self->{'text_hash'}->{'save_ssl3'})};
	local $lref = $self->read_file_lines($virt->{'file'});
	for($i=$virt->{'line'}; $i<=$virt->{'eline'}; $i++) {
		$lref->[$i] =~ s/$_[1]->{'home'}/$_[0]->{'home'}/g;
		}
	$self->flush_file_lines();
	$rv++;
	do { my $fn = $self->{'second_print'}; $self->$fn($self->{'text_hash'}->{'setup_done'})};
	}
if ($_[0]->{'dom'} ne $_[1]->{'dom'}) {
        # Domain name has changed
        do { my $fn = $self->{'first_print'}; $self->$fn($self->{'text_hash'}->{'save_ssl2'})};
        $main::apache_object->save_directive("ServerName", [ $_[0]->{'dom'} ], $vconf,$conf);
        local @sa = map { s/$_[1]->{'dom'}/$_[0]->{'dom'}/g; $_ }
                        $main::apache_object->find_directive("ServerAlias", $vconf);
        $main::apache_object->save_directive("ServerAlias", \@sa, $vconf, $conf);
        $self->flush_file_lines();
        $rv++;
        do { my $fn = $self->{'second_print'}; $self->$fn($self->{'text_hash'}->{'setup_done'})};
        }
if ($_[0]->{'ip'} ne $_[1]->{'ip'}) {
        # IP address has changed .. fix per-IP SSL cert
	if ($tmpl->{'web_webmin_ssl'}) {
		$self->modify_ipkeys($_[0], $_[1], 'get_miniserv_config',
			       'put_miniserv_config',
			       'restart_webmin');
		}
	if ($tmpl->{'web_usermin_ssl'} && $self->foreign_installed("usermin")) {
		$self->foreign_require("usermin", "usermin-lib.pl");
		$self->modify_ipkeys($_[0], $_[1], \&usermin::get_usermin_miniserv_config,
			      \&usermin::put_usermin_miniserv_config,
			      'restart_usermin');
		}
	}
$self->unlock_file($virt->{'file'});
$self->register_post_action('restart_apache', 1) if ($rv);
return $rv;
}

# delete_ssl(&domain)
# Deletes the SSL virtual server from the Apache config
sub delete_ssl
{
	my $self = shift;

$self->require_apache();
local $conf = $main::apache_object->get_config();
do { my $fn = $self->{'first_print'}; $self->$fn($self->{'text_hash'}->{'delete_ssl'})};
local ($virt, $vconf) = $self->get_apache_virtual($_[0]->{'dom'},
					    $_[0]->{'web_sslport'});
local $tmpl = $self->get_template($_[0]->{'template'});
if ($virt) {
	$self->delete_virtual_server($virt);
	do { my $fn = $self->{'second_print'}; $self->$fn($self->{'text_hash'}->{'setup_done'})};
	$self->register_post_action('restart_apache', 1);
	}
else {
	do { my $fn = $self->{'second_print'}; $self->$fn($self->{'text_hash'}->{'delete_noapache'})};
	}
undef(@{$main::apache_object->{'get_config_cache_array'}});

# Delete per-IP SSL cert
if ($tmpl->{'web_webmin_ssl'}) {
	$self->delete_ipkeys($_[0], 'get_miniserv_config',
		       'put_miniserv_config',
		       'restart_webmin');
	}
if ($tmpl->{'web_usermin_ssl'} && $self->foreign_installed("usermin")) {
	$self->foreign_require("usermin", "usermin-lib.pl");
	$self->delete_ipkeys($_[0], \&usermin::get_usermin_miniserv_config,
		      \&usermin::put_usermin_miniserv_config,
		      'restart_usermin');
	}
}

# check_web_clash(&domain, [field])
# Returns 1 if an SSL Apache webserver already exists for some domain
sub check_ssl_clash
{
	my $self = shift;

if (!$_[1] || $_[1] eq 'dom') {
	local $tmpl = $self->get_template($_[0]->{'template'});
	local $web_sslport = $tmpl->{'web_sslport'} || 443;
	local ($cvirt, $cconf) = $self->get_apache_virtual($_[0]->{'dom'}, $web_sslport);
	return $cvirt ? 1 : 0;
	}
return 0;
}

# disable_ssl(&domain)
# Adds a directive to force all requests to show an error page
sub disable_ssl
{
	my $self = shift;

do { my $fn = $self->{'first_print'}; $self->$fn($self->{'text_hash'}->{'disable_ssl'})};
$self->require_apache();
local ($virt, $vconf) = $self->get_apache_virtual($_[0]->{'dom'},
					    $_[0]->{'web_sslport'});
if ($virt) {
        $self->create_disable_directives($virt, $vconf);
        do { my $fn = $self->{'second_print'}; $self->$fn($self->{'text_hash'}->{'setup_done'})};
	$self->register_post_action('restart_apache');
        }
else {
        do { my $fn = $self->{'second_print'}; $self->$fn($self->{'text_hash'}->{'delete_noapache'})};
        }
}

# enable_ssl(&domain)
sub enable_ssl
{
	my $self = shift;

do { my $fn = $self->{'first_print'}; $self->$fn($self->{'text_hash'}->{'enable_ssl'})};
$self->require_apache();
local ($virt, $vconf) = $self->get_apache_virtual($_[0]->{'dom'},
					    $_[0]->{'web_sslport'});
if ($virt) {
        $self->remove_disable_directives($virt, $vconf);
        do { my $fn = $self->{'second_print'}; $self->$fn($self->{'text_hash'}->{'setup_done'})};
	$self->register_post_action('restart_apache');
        }
else {
        do { my $fn = $self->{'second_print'}; $self->$fn($self->{'text_hash'}->{'delete_noapache'})};
        }
}

# backup_ssl(&domain, file)
# Save the SSL virtual server's Apache config as a separate file
sub backup_ssl
{
	my $self = shift;

do { my $fn = $self->{'first_print'}; $self->$fn($self->{'text_hash'}->{'backup_sslcp'})};

# Save the apache directives
local ($virt, $vconf) = $self->get_apache_virtual($_[0]->{'dom'},
					    $_[0]->{'web_sslport'});
local $lref = $self->read_file_lines($virt->{'file'});
local $l;
$self->open_tempfile(FILE, ">$_[1]");
foreach $l (@$lref[$virt->{'line'} .. $virt->{'eline'}]) {
	$self->print_tempfile(FILE, "$l\n");
	}
$self->close_tempfile(FILE);

# Save the cert and key, if any
local $cert = $main::apache_object->find_directive("SSLCertificateFile", $vconf, 1);
if ($cert) {
	system("cp ".quotemeta($cert)." ".quotemeta("$_[1]_cert"));
	}
local $key = $main::apache_object->find_directive("SSLCertificateKeyFile", $vconf, 1);
if ($key && $key ne $cert) {
	system("cp ".quotemeta($key)." ".quotemeta("$_[1]_key"));
	}

do { my $fn = $self->{'second_print'}; $self->$fn($self->{'text_hash'}->{'setup_done'})};
return 1;
}

# restore_ssl(&domain, file, &options)
# Update the SSL virtual server's Apache configuration from a file. Does not
# change the actual <Virtualhost> lines!
sub restore_ssl
{
	my $self = shift;

do { my $fn = $self->{'first_print'}; $self->$fn($self->{'text_hash'}->{'restore_sslcp'})};

# Restore the Apache directives
local ($virt, $vconf) = $self->get_apache_virtual($_[0]->{'dom'},
					    $_[0]->{'web_sslport'});
local $srclref = $self->read_file_lines($_[1]);
local $dstlref = $self->read_file_lines($virt->{'file'});
$self->lock_file($virt->{'file'});
splice(@$dstlref, $virt->{'line'}+1, $virt->{'eline'}-$virt->{'line'}-1,
       @$srclref[1 .. @$srclref-2]);
if ($_[2]->{'fixip'}) {
	# Fix ip address in <Virtualhost> section (if needed)
	if ($dstlref->[$virt->{'line'}] =~
	    /^(.*<Virtualhost\s+)([0-9\.]+)(.*)$/i) {
		$dstlref->[$virt->{'line'}] = $1.$_[0]->{'ip'}.$3;
		}
	}
$self->flush_file_lines();
$self->unlock_file($virt->{'file'});
undef(@{$main::apache_object->{'get_config_cache_array'}});

# Restore the cert and key, if any and if saved
($virt, $vconf) = $self->get_apache_virtual($_[0]->{'dom'},
				      $_[0]->{'web_sslport'});
local $cert = $main::apache_object->find_directive("SSLCertificateFile", $vconf, 1);
if ($cert && -r "$_[1]_cert") {
	$self->lock_file($cert);
	system("cp ".quotemeta("$_[1]_cert")." ".quotemeta($cert));
	$self->unlock_file($cert);
	}
local $key = $main::apache_object->find_directive("SSLCertificateKeyFile", $vconf, 1);
if ($key && -r "$_[1]_key" && $key ne $cert) {
	$self->lock_file($key);
	system("cp ".quotemeta("$_[1]_key")." ".quotemeta($key));
	$self->unlock_file($key);
	}

do { my $fn = $self->{'second_print'}; $self->$fn($self->{'text_hash'}->{'setup_done'})};

$self->register_post_action('restart_apache');
return 1;
}

# cert_info(&domain)
# Returns a hash of details of a domain's cert
sub cert_info
{
	my $self = shift;

local %rv;
open(OUT, "openssl x509 -in $_[0]->{'ssl_cert'} -issuer -subject -enddate |");
while(<OUT>) {
	s/\r|\n//g;
	if (/subject=.*CN=([^\/]+)/) {
		$rv{'cn'} = $1;
		}
	if (/subject=.*O=([^\/]+)/) {
		$rv{'o'} = $1;
		}
	if (/issuer=.*CN=([^\/]+)/) {
		$rv{'issuer_cn'} = $1;
		}
	if (/issuer=.*O=([^\/]+)/) {
		$rv{'issuer_o'} = $1;
		}
	if (/notAfter=(.*)/) {
		$rv{'notafter'} = $1;
		}
	}
close(OUT);
$rv{'type'} = $rv{'o'} eq $rv{'issuer_o'} ? $self->{'text_hash'}->{'cert_typeself'}
					  : $self->{'text_hash'}->{'cert_typereal'};
return \%rv;
}

# show_restore_ssl(&options)
# Returns HTML for website restore option inputs
sub show_restore_ssl
{
	my $self = shift;

# Offer to update IP
return sprintf
	"(<input type=checkbox name=ssl_fixip value=1 %s> %s)",
	$self->{'opts_hash'}->{'fixip'} ? "checked" : "", $self->{'text_hash'}->{'restore_webfixip'};
}

# parse_restore_ssl(&in)
# Parses the inputs for website restore options
sub parse_restore_ssl
{
	my $self = shift;

local %in = %{$_[0]};
return { 'fixip' => $in{'ssl_fixip'} };
}

# setup_ipkeys(&domain, &miniserv-getter, &miniserv-saver, &post-action)
sub setup_ipkeys
{
	my $self = shift;

local ($dom, $getfunc, $putfunc, $postfunc) = @_;
$self->foreign_require("webmin", "webmin-lib.pl");
if (defined(&webmin::get_ipkeys)) {
	local %miniserv;
	$self->$getfunc(\%miniserv);
	local @ipkeys = &webmin::get_ipkeys(\%miniserv);
	push(@ipkeys, { 'ips' => [ $_[0]->{'ip'} ],
			'key' => $_[0]->{'ssl_key'},
			'cert' => $_[0]->{'ssl_cert'} });
	&webmin::save_ipkeys(\%miniserv, \@ipkeys);
	$self->$putfunc(\%miniserv);
	$self->register_post_action($postfunc);
	return 1;
	}
return 0;
}

# delete_ipkeys(&domain, &miniserv-getter, &miniserv-saver, &post-action)
sub delete_ipkeys
{
	my $self = shift;

local ($dom, $getfunc, $putfunc, $postfunc) = @_;
$self->foreign_require("webmin", "webmin-lib.pl");
if (defined(&webmin::get_ipkeys)) {
	local %miniserv;
	$self->$getfunc(\%miniserv);
	local @ipkeys = &webmin::get_ipkeys(\%miniserv);
	local @newipkeys = grep { $_->{'ips'}->[0] ne $_[0]->{'ip'} } @ipkeys;
	if (@ipkeys != @newipkeys) {
		&webmin::save_ipkeys(\%miniserv, \@newipkeys);
		$self->$putfunc(\%miniserv);
		$self->register_post_action($postfunc);
		return 1;
		}
	}
return 0;
}

# modify_ipkeys(&domain, &olddomain, &miniserv-getter, &miniserv-saver, &post-action)
sub modify_ipkeys
{
	my $self = shift;

local ($dom, $olddom, $getfunc, $putfunc, $postfunc) = @_;
if ($self->delete_ipkeys($olddom, $getfunc, $putfunc, $postfunc)) {
	$self->setup_ipkeys($dom, $getfunc, $putfunc, $postfunc);
	}
}


1;

