#!/usr/bin/perl
package virtual_server::Featureweb;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'virtual_server::Featureweb');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;

$self->{'default_web_port'} = $self->{'config_hash'}->{'web_port'} || 80;
$self->{'writelogs_cmd'} = "$self->{'module_config_directory'}/writelogs.pl";

$self->{'disabled_website'} = "$self->{'module_config_directory'}/disabled.html";

%{$self->{'apache_mmap_hash'}} = ( 'jan' => 0, 'feb' => 1, 'mar' => 2, 'apr' => 3,
	  	 'may' => 4, 'jun' => 5, 'jul' => 6, 'aug' => 7,
	  	 'sep' => 8, 'oct' => 9, 'nov' => 10, 'dec' => 11 );

1;

1;
		return $self;
}

sub require_apache
{
	my $self = shift;

return if ($self->{'require_apache'}++);
$self->foreign_require("apache", "apache-lib.pl");
}

# setup_web(&domain)
# Setup a virtual website for some domain
sub setup_web
{
	my $self = shift;

local $tmpl = $self->get_template($_[0]->{'template'});
local $web_port = $tmpl->{'web_port'} || $self->{'default_web_port'};
if ($_[0]->{'alias'} && $tmpl->{'web_alias'} == 1) {
	do { my $fn = $self->{'first_print'}; $self->$fn($self->{'text_hash'}->{'setup_webalias'})};
	}
else {
	do { my $fn = $self->{'first_print'}; $self->$fn($self->{'text_hash'}->{'setup_web'})};
	}
$self->require_apache();
local $conf = $main::apache_object->get_config();
local $f;
local $newfile;
if ($main::apache_object->{'config_hash'}->{'virt_file'}) {
	if (-d $main::apache_object->{'config_hash'}->{'virt_file'}) {
		$f = "$main::apache_object->{'config_hash'}->{'virt_file'}/www.$_[0]->{'dom'}.conf";
		$newfile = 1;
		}
	else {
		$f = $main::apache_object->{'config_hash'}->{'virt_file'};
		}
	}
else {
	$self->{'vconf'} = $main::apache_object->get_virtual_config();
	$f = $self->{'vconf'}->[0]->{'file'};
	}
$self->lock_file($f);

# add NameVirtualHost if needed
local $nvstar;
if ($_[0]->{'name'} || !$_[0]->{'virt'}) {
	local ($found, $found_no_port);
	local @nv = $main::apache_object->find_directive("NameVirtualHost", $conf);
	foreach $nv (@nv) {
		$found++ if ( #$nv eq $_[0]->{'ip'} ||
			     $nv =~ /^(\S+):(\S+)/ && $1 eq $_[0]->{'ip'} ||
			     $nv eq '*');
		$found_no_port++ if $nv eq $_[0]->{'ip'};
		$nvstar++ if ($nv eq "*");
		}
	if (!$found) {
		@nv = grep { $_ ne $_[0]->{'ip'} } @nv if $found_no_port;
		$main::apache_object->save_directive("NameVirtualHost",
					[ @nv, "$_[0]->{'ip'}:$web_port" ],
					$conf, $conf);
		$self->flush_file_lines();
		}
	}

local @dirs = $self->apache_template($tmpl->{'web'}, $_[0], $tmpl->{'web_suexec'});
if ($_[0]->{'alias'} && $tmpl->{'web_alias'} == 1) {
	# Update the parent virtual host
	local $alias = $self->get_domain($_[0]->{'alias'});
	local ($pvirt, $pconf) = $self->get_apache_virtual($alias->{'dom'},
						     $alias->{'web_port'});
	if (!$pvirt) {
		do { my $fn = $self->{'second_print'}; $self->$fn($self->{'text_hash'}->{'setup_ewebalias'})};
		return 0;
		}
	$self->lock_file($pvirt->{'file'});
	local @sa = $main::apache_object->find_directive("ServerAlias", $pconf);
	local $d;
	foreach $d (@dirs) {
		if ($d =~ /^\s*Server(Name|Alias)\s+(.*)/) {
			push(@sa, $2);
			}
		}
	$main::apache_object->save_directive("ServerAlias", \@sa, $pconf, $conf);
	$self->flush_file_lines();
	$self->unlock_file($pvirt->{'file'});
	$_[0]->{'alias_mode'} = 1;
	}
else {
	# Add the actual <VirtualHost>
	local $vip = $_[0]->{'name'} && $main::apache_object->{'httpd_modules_hash'}->{'core'} >= 1.312 &&
		     $nvstar ? "*" : $_[0]->{'ip'};
	local $lref = $self->read_file_lines($f);
	push(@$lref, "<VirtualHost $vip:$web_port>");
	if ($_[0]->{'alias'}) {
		# Because this is just an alias to an existing virtual server,
		# create a ProxyPass or Redirect
		@dirs = grep { /^\s*Server(Name|Alias)\s/i } @dirs;
		local $aliasdom = $self->get_domain($_[0]->{'alias'});
		local $port = $aliasdom->{'web_port'} == 80 ? "" :
				":$aliasdom->{'web_port'}";
		local $url = "http://www.$aliasdom->{'dom'}$port/";
		if ($main::apache_object->{'httpd_modules_hash'}->{'mod_proxy'} &&
		    $tmpl->{'web_alias'} == 2) {
			push(@dirs, "ProxyPass / $url",
				    "ProxyPassReverse / $url");
			}
		else {
			push(@dirs, "Redirect / $url");
			}
		}
	push(@$lref, @dirs);
	push(@$lref, "</VirtualHost>");
	$self->flush_file_lines();
	$_[0]->{'web_port'} = $web_port;
	undef(@{$main::apache_object->{'get_config_cache_array'}});

        # Create a link from another Apache dir
        if ($newfile && $main::apache_object->UNIVERSAL::can("create_webfile_link")) {
                $main::apache_object->create_webfile_link($f);
                }

	# Create empty access and error log files, world-readable
	local $log = $self->get_apache_log($_[0]->{'dom'}, $_[0]->{'web_port'}, 0);
	local $elog = $self->get_apache_log($_[0]->{'dom'}, $_[0]->{'web_port'}, 1);
	local $l;
	foreach $l ($log, $elog) {
		if ($l && !-r $l) {
			$self->open_tempfile(LOG, ">$l");
			$self->close_tempfile(LOG);
			chmod(0644, $l);
			}
		}
	$_[0]->{'alias_mode'} = 0;
	}
$self->unlock_file($f);
$self->create_framefwd_file($_[0]);
do { my $fn = $self->{'second_print'}; $self->$fn($self->{'text_hash'}->{'setup_done'})};
$self->register_post_action(\&restart_apache);

if ($tmpl->{'web_user'} && !$_[0]->{'alias'} && $_[0]->{'group'}) {
	# Add the Apache user to the group for this virtual server, if missing
	$self->require_useradmin();
	local @groups = $self->list_all_groups();
	local ($group) = grep { $_->{'group'} eq $_[0]->{'group'} } @groups;
	if ($group) {
		local @mems = split(/,/, $group->{'members'});
		if ($self->indexof($tmpl->{'web_user'}, @mems) < 0) {
			# Need to add him
			do { my $fn = $self->{'first_print'}; $self->$fn($self->text('setup_webuser',
					    $tmpl->{'web_user'}))};
			$group->{'members'} =
				join(",", @mems, $tmpl->{'web_user'});
			$self->foreign_call($self->{'usermodule'}, "set_group_envs", $group, 'MODIFY_GROUP');
			$self->foreign_call($self->{'usermodule'}, "making_changes");
			$self->foreign_call($self->{'usermodule'}, "modify_group", $group, $group);
			$self->foreign_call($self->{'usermodule'}, "made_changes");
			do { my $fn = $self->{'second_print'}; $self->$fn($self->{'text_hash'}->{'setup_done'})};
			}
		}
	}

# Make the web directory accessible under SElinux Apache
if ($self->has_command("chcon")) {
	local $hdir = $self->public_html_dir($_[0]);
	system("chcon -R -t httpd_sys_content_t ".quotemeta($hdir).
	       ">/dev/null 2>&1");
	local $cgidir = "$_[0]->{'home'}/cgi-bin";
	system("chcon -R -t httpd_sys_script_exec_t ".quotemeta($cgidir).
	       ">/dev/null 2>&1");
	local $logdir = "$_[0]->{'home'}/logs";
	system("chcon -R -t httpd_log_t ".quotemeta($logdir).
	       ">/dev/null 2>&1");
	}

# Setup the writelogs wrapper
$self->foreign_require("cron", "cron-lib.pl");
$main::cron_object->create_wrapper($self->{'writelogs_cmd'}, $self->{'module_name'}, "writelogs.pl");
}

# delete_web(&domain)
# Delete the virtual server from the Apache config
sub delete_web
{
	my $self = shift;

local $dom = $_[0];
$self->require_apache();
local $conf = $main::apache_object->get_config();
if ($dom->{'alias_mode'}) {
	# Just delete ServerAlias directives from parent
	do { my $fn = $self->{'first_print'}; $self->$fn($self->{'text_hash'}->{'delete_apachealias'})};
	local $alias = $self->get_domain($dom->{'alias'});
	local ($pvirt, $pconf) = $self->get_apache_virtual($alias->{'dom'},
						     $alias->{'web_port'});
	if (!$pvirt) {
		do { my $fn = $self->{'second_print'}; $self->$fn($self->{'text_hash'}->{'setup_ewebalias'})};
		return 0;
		}
	$self->lock_file($pvirt->{'file'});
	local @sa = $main::apache_object->find_directive("ServerAlias", $pconf);
	@sa = grep { !/\Q$dom->{'dom'}\E$/ } @sa;
	$main::apache_object->save_directive("ServerAlias", \@sa, $pconf, $conf);
	$self->flush_file_lines();
	$self->unlock_file($pvirt->{'file'});
	do { my $fn = $self->{'second_print'}; $self->$fn($self->{'text_hash'}->{'setup_done'})};
	$self->register_post_action(\&restart_apache);
	}
elsif ($self->{'config_hash'}->{'delete_indom'}) {
	# Delete all matching virtual servers
	do { my $fn = $self->{'first_print'}; $self->$fn($self->{'text_hash'}->{'delete_apache'})};
	local @virt = reverse($main::apache_object->find_directive_struct("VirtualHost",
							     $conf));
	foreach $v (@virt) {
		local $sn = $main::apache_object->find_directive("ServerName",
						    $v->{'members'});
		if ($sn =~ /\Q$dom->{'dom'}\E$/) {
			$self->delete_virtual_server($v);
			}
		}
	do { my $fn = $self->{'second_print'}; $self->$fn($self->{'text_hash'}->{'setup_done'})};
	$self->register_post_action(\&restart_apache);
	}
else {
	# Just delete one virtual server
	do { my $fn = $self->{'first_print'}; $self->$fn($self->{'text_hash'}->{'delete_apache'})};
	local ($virt, $vconf) = $self->get_apache_virtual($dom->{'dom'},
						    $dom->{'web_port'});
	if ($virt) {
		$self->delete_virtual_server($virt);
		do { my $fn = $self->{'second_print'}; $self->$fn($self->{'text_hash'}->{'setup_done'})};
		$self->register_post_action(\&restart_apache);
		}
	else {
		do { my $fn = $self->{'second_print'}; $self->$fn($self->{'text_hash'}->{'delete_noapache'})};
		}
	}
undef(@{$main::apache_object->{'get_config_cache_array'}});
}

# delete_virtual_server(&vhost)
# Delete a single virtual server from the Apache config
sub delete_virtual_server
{
	my $self = shift;

$self->require_apache();
$self->lock_file($_[0]->{'file'});
local $lref = $self->read_file_lines($_[0]->{'file'});
splice(@$lref, $_[0]->{'line'}, $_[0]->{'eline'} - $_[0]->{'line'} + 1);
$self->flush_file_lines();
if ($self->is_empty($lref)) {
	# Don't keep around empty web files
	unlink($_[0]->{'file'});

        # Delete a link from another Apache dir
        if ($main::apache_object->UNIVERSAL::can("delete_webfile_link")) {
                $main::apache_object->delete_webfile_link($_[0]->{'file'});
                }
	}
$self->unlock_file($_[0]->{'file'});
}

# is_empty(&lref)
sub is_empty
{
	my $self = shift;

local $l;
foreach $l (@{$_[0]}) {
	if ($l =~ /\S/) {
		return 0;
		}
	}
return 1;
}

# modify_web(&domain, &olddomain, [&alias, &oldalias])
# If this server has changed from name-based to IP-based hosting, update
# the Apache configuration
sub modify_web
{
	my $self = shift;

local $rv = 0;
$self->require_apache();
local $conf = $main::apache_object->get_config();
if ($_[0]->{'alias'} && $_[0]->{'alias_mode'}) {
	# Possibly just updating parent virtual server
	if ($_[0]->{'dom'} ne $_[1]->{'dom'}) {
		do { my $fn = $self->{'first_print'}; $self->$fn($self->{'text_hash'}->{'save_apache5'})};
		local $alias = $self->get_domain($_[0]->{'alias'});
		local ($pvirt, $pconf) = $self->get_apache_virtual($alias->{'dom'},
						     $alias->{'web_port'});
		if (!$pvirt) {
			do { my $fn = $self->{'second_print'}; $self->$fn($self->{'text_hash'}->{'setup_ewebalias'})};
			}
		else {
			$self->lock_file($pvirt->{'file'});
			local @sa = $main::apache_object->find_directive("ServerAlias", $pconf);
			local $s;
			foreach $s (@sa) {
				$s =~ s/\Q$_[1]->{'dom'}\E($|\s)/$_[0]->{'dom'}$1/g;
				}
			$main::apache_object->save_directive("ServerAlias", \@sa, $pconf,
						$conf);
			$self->flush_file_lines();
			$self->unlock_file($pvirt->{'file'});
			do { my $fn = $self->{'second_print'}; $self->$fn($self->{'text_hash'}->{'setup_done'})};
			$rv++;
			}
		}
	}
else {
	# Update an actual virtual server
	local ($virt, $vconf) = $self->get_apache_virtual($_[1]->{'dom'},
						    $_[1]->{'web_port'});
	$self->lock_file($virt->{'file'});
	if ($_[0]->{'name'} != $_[1]->{'name'} ||
	    $_[0]->{'ip'} ne $_[1]->{'ip'} ||
	    $_[0]->{'ssl'} != $_[1]->{'ssl'}) {
		# Name-based hosting mode or IP has changed
		do { my $fn = $self->{'first_print'}; $self->$fn($self->{'text_hash'}->{'save_apache'})};
		local $lref = $self->read_file_lines($virt->{'file'});
		$lref->[$virt->{'line'}] =
			$_[0]->{'name'} ? "<VirtualHost *>" :
				"<VirtualHost $_[0]->{'ip'}:$_[1]->{'web_port'}>";
		$self->flush_file_lines();
		$rv++;
		do { my $fn = $self->{'second_print'}; $self->$fn($self->{'text_hash'}->{'setup_done'})};
		}
	if ($_[0]->{'home'} ne $_[1]->{'home'}) {
		# Home directory has changed .. update any directives that
		# referred to the old directory
		do { my $fn = $self->{'first_print'}; $self->$fn($self->{'text_hash'}->{'save_apache3'})};
		local $lref = $self->read_file_lines($virt->{'file'});
		for($i=$virt->{'line'}; $i<=$virt->{'eline'}; $i++) {
			$lref->[$i] =~ s/$_[1]->{'home'}/$_[0]->{'home'}/g;
			}
		$self->flush_file_lines();
		$rv++;
		do { my $fn = $self->{'second_print'}; $self->$fn($self->{'text_hash'}->{'setup_done'})};
		}
	if ($_[0]->{'alias'} && $_[2] && $_[2]->{'dom'} ne $_[3]->{'dom'}) {
		# This is an alias, and the domain it is aliased to has changed.
		# update all Proxy* and Redirect directives
		do { my $fn = $self->{'first_print'}; $self->$fn($self->{'text_hash'}->{'save_apache4'})};
		local $lref = $self->read_file_lines($virt->{'file'});
		for($i=$virt->{'line'}; $i<=$virt->{'eline'}; $i++) {
			if ($lref->[$i] =~ /^\s*(Proxy|Redirect\s)/) {
				$lref->[$i] =~ s/$_[3]->{'dom'}/$_[2]->{'dom'}/g;
				}
			}
		$self->flush_file_lines();
		$rv++;
		do { my $fn = $self->{'second_print'}; $self->$fn($self->{'text_hash'}->{'setup_done'})};
		}
	if ($_[0]->{'proxy_pass_mode'} == 1 && 
	    $_[0]->{'proxy_pass'} ne $_[1]->{'proxy_pass'}) {
		# This is a proxying forwarding website and the URL has
		# changed - update all Proxy* directives
		do { my $fn = $self->{'first_print'}; $self->$fn($self->{'text_hash'}->{'save_apache6'})};
		local $lref = $self->read_file_lines($virt->{'file'});
		for($i=$virt->{'line'}; $i<=$virt->{'eline'}; $i++) {
			if ($lref->[$i] =~ /^\s*ProxyPass(Reverse)?\s/) {
				$lref->[$i] =~ s/$_[1]->{'proxy_pass'}/$_[0]->{'proxy_pass'}/g;
				}
			}
		$self->flush_file_lines();
		$rv++;
		do { my $fn = $self->{'second_print'}; $self->$fn($self->{'text_hash'}->{'setup_done'})};
		}
	if ($_[0]->{'user'} ne $_[1]->{'user'}) {
		# Username has changed .. update SuexecUserGroup and User
		local $suexec = $main::apache_object->find_directive_struct(
			"SuexecUserGroup", $vconf);
		if ($suexec && $suexec->{'words'}->[0] eq $_[1]->{'user'}) {
			do { my $fn = $self->{'first_print'}; $self->$fn($self->{'text_hash'}->{'save_apache7'})};
			$main::apache_object->save_directive("SuexecUserGroup",
					[ "$_[0]->{'user'} $_[0]->{'ugroup'}" ],
					$vconf, $conf);
			$self->flush_file_lines();
			$rv++;
			do { my $fn = $self->{'second_print'}; $self->$fn($self->{'text_hash'}->{'setup_done'})};
			}
		local $user = $main::apache_object->find_directive_struct(
			"User", $vconf);
		if ($user && $user->{'words'}->[0] eq $_[1]->{'user'}) {
			do { my $fn = $self->{'first_print'}; $self->$fn($self->{'text_hash'}->{'save_apache7'})};
			$main::apache_object->save_directive("User",
					[ $_[0]->{'user'} ],
					$vconf, $conf);
			$self->flush_file_lines();
			$rv++;
			do { my $fn = $self->{'second_print'}; $self->$fn($self->{'text_hash'}->{'setup_done'})};
			}
		}
	if ($_[0]->{'dom'} ne $_[1]->{'dom'}) {
		# Domain name has changed .. update ServerName and ServerAlias
		do { my $fn = $self->{'first_print'}; $self->$fn($self->{'text_hash'}->{'save_apache2'})};
		$main::apache_object->save_directive("ServerName", [ $_[0]->{'dom'} ],
					$vconf, $conf);
		local @sa = map { s/$_[1]->{'dom'}/$_[0]->{'dom'}/g; $_ }
				$main::apache_object->find_directive("ServerAlias", $vconf);
		$main::apache_object->save_directive("ServerAlias", \@sa, $vconf, $conf);
		$self->flush_file_lines();
		$rv++;
		if ($virt->{'file'} =~ /$_[1]->{'dom'}/) {
			# Filename contains domain name .. need to re-name
			$self->unlock_file($virt->{'file'});
			if ($main::apache_object->UNIVERSAL::can("delete_webfile_link")) {
				# Remove old debian style web file link
				$main::apache_object->delete_webfile_link($virt->{'file'});
				}
			local $nfn = $virt->{'file'};
			$nfn =~ s/$_[1]->{'dom'}/$_[0]->{'dom'}/;
			$self->rename_logged($virt->{'file'}, $nfn);
			if ($main::apache_object->UNIVERSAL::can("create_webfile_link")) {
				# Re-create debian style web file link
				$main::apache_object->create_webfile_link($nfn);
				}
			}
		do { my $fn = $self->{'second_print'}; $self->$fn($self->{'text_hash'}->{'setup_done'})};
		}
	$self->unlock_file($virt->{'file'});
	if ($rv) {
		undef(@{$main::apache_object->{'get_config_cache_array'}});
		}
	$self->create_framefwd_file($_[0]);
	if (!$_[0]->{'ssl'}) {
		# Only re-start here if we won't re-start later after
		# changing SSL
		$self->register_post_action(\&restart_apache, 1) if ($rv);
		}
	}
return $rv;
}

# disable_web(&domain)
# Adds a directive to force all requests to show an error page
sub disable_web
{
	my $self = shift;

do { my $fn = $self->{'first_print'}; $self->$fn($self->{'text_hash'}->{'disable_apache'})};
$self->require_apache();
local ($virt, $vconf) = $self->get_apache_virtual($_[0]->{'dom'},
					    $_[0]->{'web_port'});
if ($virt) {
	$self->create_disable_directives($virt, $vconf);
	do { my $fn = $self->{'second_print'}; $self->$fn($self->{'text_hash'}->{'setup_done'})};
	$self->register_post_action(\&restart_apache);
	}
else {
	do { my $fn = $self->{'second_print'}; $self->$fn($self->{'text_hash'}->{'delete_noapache'})};
	}
}

# create_disable_directives(&virt, &vconf)
sub create_disable_directives
{
	my $self = shift;

local ($virt, $vconf) = @_;
$self->lock_file($virt->{'file'});
local @am = $main::apache_object->find_directive("AliasMatch", $vconf);
local $conf = $main::apache_object->get_config();
$main::apache_object->save_directive("AliasMatch",
			[ @am, "^/.*\$ $self->{'disabled_website'}" ],
			$vconf, $conf);
$self->flush_file_lines();
if (!-r $self->{'disabled_website'}) {
	$self->open_tempfile(DISABLED, ">$self->{'disabled_website'}");
	$self->print_tempfile(DISABLED, "<h1>Website Disabled</h1>\n");
	$self->close_tempfile(DISABLED);
	chmod(0644, $self->{'disabled_website'});
	}
$self->unlock_file($virt->{'file'});
}

# enable_web(&domain)
# Deletes the special error page directive
sub enable_web
{
	my $self = shift;

do { my $fn = $self->{'first_print'}; $self->$fn($self->{'text_hash'}->{'enable_apache'})};
$self->require_apache();
local ($virt, $vconf) = $self->get_apache_virtual($_[0]->{'dom'},
					    $_[0]->{'web_port'});
if ($virt) {
	$self->remove_disable_directives($virt, $vconf);
	do { my $fn = $self->{'second_print'}; $self->$fn($self->{'text_hash'}->{'setup_done'})};
	$self->register_post_action(\&restart_apache);
	}
else {
	do { my $fn = $self->{'second_print'}; $self->$fn($self->{'text_hash'}->{'delete_noapache'})};
	}
}

# remove_disable_directives(&virt, &vconf)
sub remove_disable_directives
{
	my $self = shift;

local ($virt, $vconf) = @_;
$self->lock_file($virt->{'file'});
local @am = $main::apache_object->find_directive("AliasMatch", $vconf);
@am = grep { $_ ne "^/.*\$ $self->{'disabled_website'}" } @am;
local $conf = $main::apache_object->get_config();
$main::apache_object->save_directive("AliasMatch", \@am, $vconf, $conf);
$self->flush_file_lines();
$self->unlock_file($virt->{'file'});
}

# check_web_clash(&domain, [field])
# Returns 1 if an Apache webserver already exists for some domain
sub check_web_clash
{
	my $self = shift;

if ($_[1] || $_[1] eq 'dom') {
	local $tmpl = $self->get_template($_[0]->{'template'});
	local $web_port = $tmpl->{'web_port'} || 80;
	local ($cvirt, $cconf) = $self->get_apache_virtual($_[0]->{'dom'}, $web_port);
	return $cvirt ? 1 : 0;
	}
return 0;
}

# restart_apache([restart])
# Tell Apache to re-read its config file
sub restart_apache
{
	my $self = shift;

do { my $fn = $self->{'first_print'}; $self->$fn($_[0] ? $self->{'text_hash'}->{'setup_webpid2'} : $self->{'text_hash'}->{'setup_webpid'})};
sleep(1);
local $pid = $self->get_apache_pid();
if (!$pid || !kill(0, $pid)) {
	do { my $fn = $self->{'second_print'}; $self->$fn($self->{'text_hash'}->{'setup_notrun'})};
	return 0;
	}
if ($_[0]) {
	# Totally stop and start
	$self->clean_environment();
	if ($main::apache_object->{'config_hash'}->{'stop_cmd'}) {
		$self->system_logged("$main::apache_object->{'config_hash'}->{'stop_cmd'} >/dev/null 2>&1");
		}
	else {
		$self->system_logged("$main::apache_object->{'config_hash'}->{'apachectl_path'} stop >/dev/null 2>&1");
		}
	sleep(5);
	if ($main::apache_object->{'config_hash'}->{'start_cmd'}) {
		$self->system_logged("$main::apache_object->{'config_hash'}->{'start_cmd'} >/dev/null 2>&1");
		}
	else {
		$self->system_logged("$main::apache_object->{'config_hash'}->{'apachectl_path'} start >/dev/null 2>&1");
		}
	do { my $fn = $self->{'second_print'}; $self->$fn($self->{'text_hash'}->{'setup_done'})};
	$self->reset_environment();
	return 1;
	}
else {
	# Just signal a re-load
	$self->clean_environment();
	if ($main::apache_object->{'config_hash'}->{'apply_cmd'}) {
		# use the configured start command
		$self->system_logged("($main::apache_object->{'config_hash'}->{'apply_cmd'}) >/dev/null 2>&1");
		}
	elsif (-x $main::apache_object->{'config_hash'}->{'apachectl_path'}) {
		# Use apachectl
		$self->system_logged("$main::apache_object->{'config_hash'}->{'apachectl_path'} restart >/dev/null 2>&1");
		}
	else {
		# Just signal the process
		$self->kill_logged('HUP', $pid);
		}
	$self->reset_environment();
	do { my $fn = $self->{'second_print'}; $self->$fn($self->{'text_hash'}->{'setup_done'})};
	return 1;
	}
}

# get_apache_log(domain-name, [port], [errorlog])
# Given a domain name, returns the path to its log file
sub get_apache_log
{
	my $self = shift;

$self->require_apache();
local ($virt, $vconf) = $self->get_apache_virtual($_[0], $_[1]);
if ($virt) {
	local $log;
	if ($_[2]) {
		# Looking for error log
		$log = $main::apache_object->find_directive("ErrorLog", $vconf, 1);
		}
	else {
		# Looking for normal log
		$log = $main::apache_object->find_directive("TransferLog", $vconf, 1) ||
		       $main::apache_object->find_directive("CustomLog", $vconf, 1);
		}
	if ($log =~ /^\|\Q$self->{'writelogs_cmd'}\E\s+(\S+)\s+(\S+)/) {
		# Via writelogs .. return real path
		local $file = $2;
		if ($file =~ /^\//) {
			$log = $file;
			}
		else {
			local $d = $self->get_domain_by("dom", $_[0]);
			if ($d) {
				$log = "$d->{'home'}/$file";
				}
			}
		}
	return $log;
	}
else {
	return undef;
	}
}

# get_apache_virtual(domain, [port])
# Returns the list of configuration directives and the directive for the
# virtual domain itself for some domain
sub get_apache_virtual
{
	my $self = shift;

$self->require_apache();
local $conf = $main::apache_object->get_config();
local $v;
local $sp = $_[1] || $self->{'default_web_port'};
foreach $v ($main::apache_object->find_directive_struct("VirtualHost", $conf)) {
	local $vp = $v->{'words'}->[0] =~ /:(\d+)$/ ? $1 : $self->{'default_web_port'};
	next if ($vp != $sp);
        local $sn = $main::apache_object->find_directive("ServerName", $v->{'members'});
	return ($v, $v->{'members'}) if ($sn eq $_[0] ||
					 $sn eq "www.$_[0]");
	local $n;
	foreach $n ($main::apache_object->find_directive_struct(
			"ServerAlias", $v->{'members'})) {
		return ($v, $v->{'members'})
			if ($self->indexof($_[0], @{$n->{'words'}}) >= 0 ||
			    $self->indexof("www.$_[0]", @{$n->{'words'}}) >= 0);
		}
        }
return ();
}

# get_apache_pid()
sub get_apache_pid
{
	my $self = shift;

$self->require_apache();
local $pidfile = $main::apache_object->get_pid_file();
open(PID, $pidfile) || return undef;
chop($self->{'pid'} = <PID>);
close(PID);
return $self->{'pid'};
}

# apache_template(text, &domain, suexec)
# Returns a suitably substituted Apache template
sub apache_template
{
	my $self = shift;

local $dirs = $_[0];
$dirs =~ s/\t/\n/g;
$dirs = $self->substitute_template($dirs, $_[1]);
local @dirs = split(/\n/, $dirs);
local ($sudir, $ppdir);
foreach (@dirs) {
	$sudir++ if (/^\s*SuexecUserGroup\s/i || /^\s*User\s/i);
	$ppdir++ if (/^\s*ProxyPass\s/);
	}
local $tmpl = $self->get_template($_[1]->{'template'});
if (!$sudir && $_[2] && $_[1]->{'unix'}) {
	# Automatically add suexec directives if missing
	if ($main::apache_object->{'httpd_modules_hash'}->{'core'} >= 2.0) {
		if ($main::apache_object->{'httpd_modules_hash'}->{'mod_suexec'}) {
			unshift(@dirs, "SuexecUserGroup \"#$_[1]->{'uid'}\" ".
				       "\"#$_[1]->{'ugid'}\"");
			}
		}
	else {
		unshift(@dirs, "User \"#$_[1]->{'uid'}\"",
			       "Group \"#$_[1]->{'ugid'}\"");
		}
	}
if (!$ppdir && $_[1]->{'proxy_pass'}) {
	if ($_[1]->{'proxy_pass_mode'} == 1) {
		# Proxy to another server
		push(@dirs, "ProxyPass / $_[1]->{'proxy_pass'}",
			    "ProxyPassReverse / $_[1]->{'proxy_pass'}");
		}
	else {
		# Redirect to /framefwd.html
		local $ff = $self->framefwd_file($_[1]);
		push(@dirs, "AliasMatch ^/.*\$ $ff");
		}
	}
if ($tmpl->{'web_writelogs'}) {
	# Fix any CustomLog or ErrorLog directives to write via writelogs.pl
	foreach $d (@dirs) {
		if ($d =~ /^(CustomLog|ErrorLog)\s+(\S+)(\s*\S*)/) {
			$d = "$1 \"|$self->{'writelogs_cmd'} $_[1]->{'id'} $2\"$3";
			}
		}
	}
return @dirs;
}

# backup_web(&domain, file)
# Save the virtual server's Apache config as a separate file
sub backup_web
{
	my $self = shift;

return 1 if ($_[0]->{'alias'} && $_[0]->{'alias_mode'});
do { my $fn = $self->{'first_print'}; $self->$fn($self->{'text_hash'}->{'backup_apachecp'})};
local ($virt, $vconf) = $self->get_apache_virtual($_[0]->{'dom'},
					    $_[0]->{'web_port'});
local $lref = $self->read_file_lines($virt->{'file'});
local $l;
$self->open_tempfile(FILE, ">$_[1]");
foreach $l (@$lref[$virt->{'line'} .. $virt->{'eline'}]) {
	$self->print_tempfile(FILE, "$l\n");
	}
$self->close_tempfile(FILE);
do { my $fn = $self->{'second_print'}; $self->$fn($self->{'text_hash'}->{'setup_done'})};
return 1;
}

# restore_web(&domain, file, &options, &all-options)
# Update the virtual server's Apache configuration from a file. Does not
# change the actual <Virtualhost> lines!
sub restore_web
{
	my $self = shift;

return 1 if ($_[0]->{'alias'} && $_[0]->{'alias_mode'});
do { my $fn = $self->{'first_print'}; $self->$fn($self->{'text_hash'}->{'restore_apachecp'})};
local ($virt, $vconf) = $self->get_apache_virtual($_[0]->{'dom'},
					    $_[0]->{'web_port'});
local $srclref = $self->read_file_lines($_[1]);
local $dstlref = $self->read_file_lines($virt->{'file'});
$self->lock_file($virt->{'file'});
splice(@$dstlref, $virt->{'line'}+1, $virt->{'eline'}-$virt->{'line'}-1,
       @$srclref[1 .. @$srclref-2]);
if ($_[2]->{'fixip'}) {
	# Fix IP address in <Virtualhost> section (if needed)
	if ($dstlref->[$virt->{'line'}] =~
	    /^(.*<Virtualhost\s+)([0-9\.]+)(.*)$/i) {
		$dstlref->[$virt->{'line'}] = $1.$_[0]->{'ip'}.$3;
		}
	}
if ($_[3]->{'reuid'}) {
	# Fix up any UID or GID in suexec lines
	local $i;
	foreach $i ($virt->{'line'} .. $virt->{'eline'}) {
		if ($dstlref->[$i] =~ /^SuexecUserGroup\s/) {
			$dstlref->[$i] = "SuexecUserGroup \"#$_[0]->{'uid'}\" \"#$_[0]->{'ugid'}\"";
			}
		elsif ($dstlref->[$i] =~ /^User\s/) {
			$dstlref->[$i] = "User \"#$_[0]->{'uid'}\"";
			}
		elsif ($dstlref->[$i] =~ /^Group\s/) {
			$dstlref->[$i] = "Group \"#$_[0]->{'ugid'}\"";
			}
		}
	}
$self->flush_file_lines();
$self->unlock_file($virt->{'file'});
undef(@{$main::apache_object->{'get_config_cache_array'}});
do { my $fn = $self->{'second_print'}; $self->$fn($self->{'text_hash'}->{'setup_done'})};

foreach(@{$vconf})
	{if ($_->{'name'} eq "CustomLog" ){
		$self->{'custlog'} =$_->{'value'}}
	if ($_->{'name'} eq "ErrorLog" ){
		$self->{'errlog'} =$_->{'value'}}
	}

if ($self->{'custlog'} =~ /^(.+)\s/ ) {$self->{'custlog'}=$1};
if ($self->{'errlog'} =~ /^(.+)\s/ ) {$self->{'errlog'}=$1};

$self->system_logged("chown root:root ".quotemeta($self->{'custlog'}));
$self->system_logged("chown root:root ".quotemeta($self->{'errlog'}));

$self->register_post_action(\&restart_apache);
return 1;
}

# bandwidth_web(&domain, start, &bw-hash)
# Searches through log files for records after some date, and updates the
# day counters in the given hash
sub bandwidth_web
{
	my $self = shift;

require 'timelocal.pl';
local @logs = ( $self->get_apache_log($_[0]->{'dom'}, $_[0]->{'web_port'}),
		$self->get_apache_log($_[0]->{'dom'}, $_[0]->{'web_sslport'}) );
return if ($_[0]->{'alias'});	# never accounted separately
local $l;
local $max_ltime = $_[1];
foreach $l ($self->unique(@logs)) {
	local $f;
	foreach $f ($self->all_log_files($l, $max_ltime)) {
		if ($f =~ /\.gz$/i) {
			open(LOG, "gunzip -c ".quotemeta($f)." |");
			}
		elsif ($f =~ /\.Z$/i) {
			open(LOG, "uncompress -c ".quotemeta($f)." |");
			}
		else {
			open(LOG, $f);
			}
		while(<LOG>) {
			if (/^(\S+)\s+(\S+)\s+(\S+)\s+\[(\d+)\/(\S+)\/(\d+):(\d+):(\d+):(\d+)\s+(\S+)\]\s+"([^"]*)"\s+(\S+)\s+(\S+)/) {
				# Valid-looking log line .. work out the time
				local $ltime = timelocal($9, $8, $7, $4, $self->{'apache_mmap_hash'}->{lc($5)}, $6-1900);
				if ($ltime > $_[1]) {
					local $day = int($ltime / (24*60*60));
					$_[2]->{"web_".$day} += $13;
					}
				$max_ltime = $ltime if ($ltime > $max_ltime);
				}
			}
		close(LOG);
		}
	}
return $max_ltime;
}

# all_log_files(file, last-date)
# Returns all compressed rotated versions of some file, excluding those
# that have not been modified since some time
sub all_log_files
{
	my $self = shift;

$_[0] =~ /^(.*)\/([^\/]+)$/;
local $dir = $1;
local $base = $2;
local ($f, @rv);
opendir(DIR, $dir);
foreach $f (readdir(DIR)) {
	if ($f =~ /^\Q$base\E/ && -f "$dir/$f") {
		if ($f ne $base) {
			local @st = stat("$dir/$f");
			next if ($_[1] && $st[7] <= $_[1]);
			}
		push(@rv, "$dir/$f");
		}
	}
closedir(DIR);
return @rv;
}

# create_framefwd_file(&domain)
# Create a framefwd.html file for a server, if needed
sub create_framefwd_file
{
	my $self = shift;

if ($_[0]->{'proxy_pass_mode'} == 2) {
	local $template = $self->get_template($_[0]->{'template'});
	local $ff = $self->framefwd_file($_[0]);
	unlink($ff);
	local $text = $template->{'frame'};
	$self->open_tempfile(FRAME, ">$ff");
	local %subs = %{$_[0]};
	$subs{'proxy_title'} ||= $tmpl{'owner'};
	$subs{'proxy_meta'} ||= "";
	$subs{'proxy_meta'} = join("\n", split(/\t/, $subs{'proxy_meta'}));
	$self->print_tempfile(FRAME, $self->substitute_template($text, \%subs));
	$self->close_tempfile(FRAME);
	if ($_[0]->{'unix'}) {
		chown($_[0]->{'uid'}, $_[0]->{'gid'} || $_[0]->{'ugid'}, $ff);
		}

	# Create a blank HTML page too, used in the frameset
	local $bl = $self->frameblank_file($_[0]);
	unlink($bl);
	$self->open_tempfile(BLANK, ">$bl");
	$self->print_tempfile(BLANK, "<body bgcolor=#ffffff></body>\n");
	$self->close_tempfile(BLANK);
	if ($_[0]->{'unix'}) {
		chown($_[0]->{'uid'}, $_[0]->{'gid'} || $_[0]->{'ugid'}, $bl);
		}
	}
}

# public_html_dir(&domain, [relative])
sub public_html_dir
{
	my $self = shift;

local $tmpl = $self->get_template($_[0]->{'template'});
local ($hdir) = ($tmpl->{'web_html_dir'} || 'public_html');
$hdir = $self->substitute_template($hdir, $_[0]);
return $_[1] ? $hdir : "$_[0]->{'home'}/$hdir";
}

# framefwd_file(&domain)
sub framefwd_file
{
	my $self = shift;

local $hdir = $self->public_html_dir($_[0]);
return "$hdir/framefwd.html";
}

# frameblank_file(&domain)
sub frameblank_file
{
	my $self = shift;

local $hdir = $self->public_html_dir($_[0]);
return "$hdir/frameblank.html";
}

# check_depends_web(&dom)
# Ensure that a website has a Unix user, if not proxying
sub check_depends_web
{
	my $self = shift;

if ($_[0]->{'alias'}) {
	# If this is an alias domain, then no home is needed
	return undef;
	}
elsif ($_[0]->{'proxy_pass_mode'} == 2) {
	# If proxying using frame forwarding, a home is needed
	return $_[0]->{'dir'} ? undef : $self->{'text_hash'}->{'setup_edepframe'};
	}
elsif ($_[0]->{'proxy_pass_mode'} == 1) {
	# If proxying using ProxyPass, no home is needed
	return undef;
	}
else {
	# For a normal website, we need a home
	return $_[0]->{'dir'} ? undef : $self->{'text_hash'}->{'setup_edepweb'};
	}
}

sub frame_fwd_input
{
	my $self = shift;

local $rv;
if ($self->{'config_hash'}->{'proxy_pass'} == 1) {
	$rv .= "<tr> <td><b>".$self->hlink($self->{'text_hash'}->{'form_proxy'},
				    "proxypass")."</b></td>\n";
	}
else {
	$rv .= "<tr> <td><b>".$self->hlink($self->{'text_hash'}->{'form_framefwd'},
				    "framefwd")."</b></td>\n";
	}
$rv .= "<td colspan=3>";
$rv .= sprintf "<input type=radio name=proxy_def value=1 %s> %s\n",
      $_[0] ? "" : "checked", $self->{'text_hash'}->{'form_plocal'};
$rv .= sprintf "<input type=radio name=proxy_def value=0 %s> %s\n",
      $_[0] ? "checked" : "", $self->{'text_hash'}->{'form_purl'};
$rv .= "<input name=proxy size=40 value='$_[0]'></td> </tr>\n";
return $rv;
}

# show_restore_web(&options)
# Returns HTML for website restore option inputs
sub show_restore_web
{
	my $self = shift;

# Offer to update IP
return sprintf
	"(<input type=checkbox name=web_fixip value=1 %s> %s)",
	$self->{'opts_hash'}->{'fixip'} ? "checked" : "", $self->{'text_hash'}->{'restore_webfixip'};
}

# parse_restore_web(&in)
# Parses the inputs for website restore options
sub parse_restore_web
{
	my $self = shift;

local %in = %{$_[0]};
return { 'fixip' => $in{'web_fixip'} };
}


1;

