#!/usr/bin/perl
package virtual_server::Filter;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'virtual_server::Filter');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# filter.pl

# read sendmail module config
$self->{'p'} = -l $0 ? readlink($0) : $0;
$self->{'p'} =~ /^(.*)\/[^\/]+$/;
if (open(CONF, "$1/config")) {
	while(<CONF>) {
		if (/^(\S+)=(.*)/) {
			$self->{'config_hash'}->{$1} = $2;
			}
		}
	close(CONF);
	}
if (!$self->{'config_hash'}->{'sendmail_path'}) {
	# Make some guesses about sendmail
	if (-x "/usr/sbin/sendmail") {
		%{$self->{'config_hash'}} = ( 'sendmail_path' => '/usr/sbin/sendmail' );
		}
	elsif (-x "/usr/lib/sendmail") {
		%{$self->{'config_hash'}} = ( 'sendmail_path' => '/usr/lib/sendmail' );
		}
	else {
		die "Failed to find sendmail or config file";
		}
	}
# read headers and body
$self->{'fromline'} = <STDIN>;
while(<STDIN>) {
	$self->{'headers'} .= $_;
	s/\r|\n//g;
	if (/^(\S+):\s+(.*)/) {
		$self->{'header_hash'}->{lc($1)} = $2;
		}
	elsif (!$_) { last; }
	}
while(<STDIN>) {
	$self->{'body'} .= $_;
	}

# read the filter file
if (open(FILTER, $ARGV[0])) {
	while(<FILTER>) {
		s/\r|\n//g;
		if (/^(\S+)\s+(\S+)\s+(\S+)\s+(.*)$/) {
			push(@{$self->{'filter_array'}}, [ $1, $2, $3, $4 ]);
			}
		elsif (/^(\S+)\s+(\S+)$/) {
			push(@{$self->{'filter_array'}}, [ $1, $2 ]);
			}
		}
	close(FILTER);
	}
else {
	print STDERR "Filter file $ARGV[0] does not exist!\n";
	exit 1;
	}

# run the filter to find the first matching rule
open(LOG, ">>$ARGV[0].log");
foreach $f (@{$self->{'filter_array'}}) {
	 $self->{'field'} = $f->[2] eq 'body' ? $self->{'body'} : $self->{'header_hash'}->{$f->[2]};
	 $self->{'st'} = 0;
	if ($f->[0] == 0) {
		$self->{'st'} = ($self->{'field'} !~ /$f->[3]/i);
		}
	elsif ($f->[0] == 1) {
		$self->{'st'} = ($self->{'field'} =~ /$f->[3]/i);
		}
	elsif ($f->[0] == 2) {
		$self->{'st'} = 1;
		}
	if ($self->{'st'}) {
		# The rule matched!
		if ($f->[1] =~ /^\//) {
			# Write to a file
			open(MAIL, ">>$f->[1]") || die "Failed to open $f->[1] ; $!";
			print MAIL $self->{'fromline'};
			}
		else {
			# Forward to another address
			open(MAIL, "|$self->{'config_hash'}->{'sendmail_path'} ".
				   quotemeta($f->[1]));
			}
		print MAIL $self->{'headers'};
		print MAIL $self->{'body'};
		close(MAIL);
		$self->{'now'} = localtime(time());
		print LOG "[$self->{'now'}] [$self->{'header_hash'}->{'from'}] [",join(" ",@$f),"]\n";
		last;
		}
	}

1;
		return $self;
}


1;

