#!/usr/bin/perl
package virtual_server::Log_parser;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'virtual_server::Log_parser');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# log_parser.pl
# Functions for parsing this module's logs

&ModuleLoader::preload_module(ref($self), "virtual_server::VirtualserverLib");
$self = new virtual_server::VirtualserverLib:: ref($self), %$self; 

1;
		return $self;
}

# parse_webmin_log(user, script, action, type, object, &params)
# Converts logged information from this module into human-readable form
sub parse_webmin_log
{
	my $self = shift;

local ($user, $script, $action, $type, $object, $p, $long) = @_;
if ($type eq "user") {
	return $self->text('log_'.$action.'_user', "<tt>$object</tt>",
					     "<tt>$p->{'dom'}</tt>");
	}
elsif ($type eq "alias") {
	return $self->text('log_'.$action.'_alias', "<tt>$object</tt>");
	}
elsif ($type eq "domain") {
	return $self->text('log_'.$action.'_domain', "<tt>$object</tt>");
	}
elsif ($type eq "template") {
	return $self->text('log_'.$action.'_template', $object);
	}
elsif ($action eq "start" || $action eq "stop") {
	return $self->{'text_hash'}->{'log_'.$action.'_'.$type};
	}
elsif ($action eq "backup" || $action eq "restore") {
	local @doms = split(/\0/, $p->{'doms'});
	if ($long) {
		return $self->text('log_'.$action.'_l', join(" ", map { "<tt>$_</tt>" } @doms));
		}
	else {
		return $self->text('log_'.$action, scalar(@doms));
		}
	}
elsif ($action eq "sched") {
	return $self->{'text_hash'}->{'log_sched_'.$type};
	}
else {
	return $self->{'text_hash'}->{'log_'.$action};
	}
return undef;
}


1;

