#!/usr/bin/perl
package virtual_server::Useradmin_update;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'virtual_server::Useradmin_update');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;

&ModuleLoader::preload_module(ref($self), "virtual_server::VirtualserverLib");
$self = new virtual_server::VirtualserverLib:: ref($self), %$self; 

1;
		return $self;
}

# useradmin_create_user(&details)
# Does nothing
sub useradmin_create_user
{
	my $self = shift;

}

# useradmin_delete_user(&details)
# Does nothing (though maybe could delete the domain)
sub useradmin_delete_user
{
	my $self = shift;

}

# useradmin_modify_user(&details)
# If the domain user's password is being changed, update it in the domain's
# file as well
sub useradmin_modify_user
{
	my $self = shift;

if ($_[0]->{'passmode'} == 3) {
	local @doms = $self->list_domains();
	local ($d) = grep { $_->{'user'} eq $_[0]->{'user'} } @doms;
	if ($d && $d->{'unix'}) {
		# User is for a virtualmin domain
		$self->{'first_print'} = $self->{'second_print'} = \&null_print;
		$self->{'oldd'} = { %$d };
		$d->{'pass'} = $_[0]->{'plainpass'};
		if ($d->{'disabled'}) {
			# Clear any saved passwords, as they should
			# be reset at this point
			$d->{'disabled_oldpass'} = $_[0]->{'pass'};
			$d->{'disabled_mysqlpass'} = undef;
			$d->{'disabled_postgrespass'} = undef;
			}
		if ($d->{'mysql'} && $self->{'config_hash'}->{'mysql'}) {
			$self->require_mysql();
			if (!$self->{'mconfig_hash'}->{'sync_modify'}) {
				# Need to update password in MySQL db as well
				$self->modify_mysql($d, $self->{'oldd'});
				}
			}
		if ($d->{'postgres'} && $self->{'config_hash'}->{'postgres'}) {
			$self->require_postgres();
			if (!$self->{'qconfig_hash'}->{'sync_modify'}) {
				# Need to update password in PostgreSQL db too
				$self->modify_postgres($d, $self->{'oldd'});
				}
			}
		$self->modify_webmin($d, $self->{'oldd'});  # so that acl passwords are updated
		$self->save_domain($d);
		}
	}
}

sub null_print
{
	my $self = shift;

}


1;

