#!/usr/bin/perl
package virtual_server::Virtual_feature_api;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'virtual_server::Virtual_feature_api');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# Defines functions for this feature

1;

1;
		return $self;
}

# feature_name()
# Returns a short name for this feature
sub feature_name
{
	my $self = shift;

}

# feature_losing(&domain)
# Returns a description of what will be deleted when this feature is removed
sub feature_losing
{
	my $self = shift;

}

# feature_disname(&domain)
# Returns a description of what will be turned off when this feature is disabled
sub feature_disname
{
	my $self = shift;

}

# feature_label(in-edit-form)
# Returns the name of this feature, as displayed on the domain creation and
# editing form
sub feature_label
{
	my $self = shift;

}

# feature_check()
# Returns undef if all the needed programs for this feature are installed,
# or an error message if not
sub feature_check
{
	my $self = shift;

}

# feature_depends(&domain)
# Returns undef if all pre-requisite features for this domain are enabled,
# or an error message if not
sub feature_depends
{
	my $self = shift;

}

# feature_clash(&domain)
# Returns undef if there is no clash for this domain for this feature, or
# an error message if so
sub feature_clash
{
	my $self = shift;

}

# feature_suitable([&parentdom], [&aliasdom])
# Returns 1 if some feature can be used with the specified alias and
# parent domains
sub feature_suitable
{
	my $self = shift;

}

# feature_setup(&domain)
# Called when this feature is added, with the domain object as a parameter
sub feature_setup
{
	my $self = shift;

}

# feature_modify(&domain, &olddomain)
# Called when a domain with this feature is modified
sub feature_modify
{
	my $self = shift;

}

# feature_delete(&domain)
# Called when this feature is disabled, or when the domain is being deleted
sub feature_delete
{
	my $self = shift;

}

# feature_disable(&domain)
# Called when this feature is temporarily disabled for a domain
# (optional)
sub feature_disable
{
	my $self = shift;

}

# feature_enable(&domain)
# Called when this feature is re-enabled for a domain
# (optional)
sub feature_enable
{
	my $self = shift;

}

# feature_bandwidth(&domain, start, &bw-hash)
# Searches through log files for records after some date, and updates the
# day counters in the given hash
sub feature_bandwidth
{
	my $self = shift;

}

# feature_webmin(&main-domain, &all-domains)
# Returns a list of webmin module names and ACL hash references to be set for
# the Webmin user when this feature is enabled
# (optional)
sub feature_webmin
{
	my $self = shift;

}

# feature_import(domain-name, user-name, db-name)
# Returns 1 if this feature is already enabled for some domain being imported,
# or 0 if not
sub feature_import
{
	my $self = shift;

}

# feature_limits_input(&domain)
# Returns HTML for editing limits related to this plugin
sub feature_limits_input
{
	my $self = shift;

}

# feature_limits_parse(&domain, &in)
# Updates the domain with limit inputs generated by feature_limits_input
sub feature_limits_parse
{
	my $self = shift;

}

# feature_links(&domain)
# Returns an array of link objects for webmin modules for this feature
sub feature_links
{
	my $self = shift;

}

# mailbox_inputs(&user, new, &domain)
# Returns HTML for additional inputs on the mailbox form. These should be
# formatted to appear inside a table.
sub mailbox_inputs
{
	my $self = shift;

}

# mailbox_validate(&user, &old-user, &in, new, &domain)
# Validates inputs generated by mailbox_inputs, and returns either undef on
# success or an error message
sub mailbox_validate
{
	my $self = shift;

}

# mailbox_save(&user, &old-user, &in, new, &domain)
# Updates the user based on inputs generated by mailbox_inputs
sub mailbox_save
{
	my $self = shift;

}

# mailbox_modify(&user, &old-user, &domain)
# Called when a user is modified by some program other than the Edit User
# page, in order to make any other updates needed by this plugin.
sub mailbox_modify
{
	my $self = shift;

}

# mailbox_delete(&user, &domain)
# Removes any extra features for this user
sub mailbox_delete
{
	my $self = shift;

}

# mailbox_header(&domain)
# Returns a column header for the user display, or undef for none
sub mailbox_header
{
	my $self = shift;

}

# mailbox_column(&user, &domain)
# Returns the text to display in the column for some user
sub mailbox_column
{
	my $self = shift;

}

# virtusers_ignore(&domain)
# Returns a list of virtuser addresses (like foo@bar.com) that are created by
# this plugin and should not be displayed or included in counts
sub virtusers_ignore
{
	my $self = shift;

}

# database_name()
# Returns the name for this type of database
sub database_name
{
	my $self = shift;

}

# database_list(&domain)
# Returns a list of databases owned by a domain, according to this plugin
sub database_list
{
	my $self = shift;

}

# databases_all([&domain])
# Returns a list of all databases on the system, possibly limited to those
# associated with some domain
sub databases_all
{
	my $self = shift;

}

# database_clash(&domain, name)
# Returns 1 if the named database already exists
sub database_clash
{
	my $self = shift;

}

# database_create(&domain, dbname)
# Creates a new database for some domain. May call the *print functions to
# report progress
sub database_create
{
	my $self = shift;

}

# database_deletes(&domain, dbname)
# Creates an existing database for some domain. May call the *print functions to
# report progress
sub database_delete
{
	my $self = shift;

}

# database_size(&domain, dbname)
# Returns the on-disk size and number of tables in a database
sub database_size
{
	my $self = shift;

}


1;

