#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Show a form for backing up a single virtual server, or a bunch
#
# XXX support use by domain owners?

&ModuleLoader::preload_module('virtual_server_class', "virtual_server::VirtualserverLib");
$self = new virtual_server::VirtualserverLib:: 'virtual_server_class',%$self;

$self->ReadParse();
$self->master_admin() || $self->error($self->{'text_hash'}->{'backup_ecannot'});
	$self->ui_print_header(undef, $self->text('backup_title' ,$self->{'t_websites_mail'}), "",undef, 0, 1);
	print "<form action=backup.cgi method=post>\n";
	print "<table border>\n";
	print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'backup_header'}</b></td> </tr>\n";
	print "<tr $self->{'cb'}> <td><table>\n";

# Work out default backup selection
$self->{'dest'} = $self->{'config_hash'}->{'backup_dest'};
$self->{'backup_fmt'} = $self->{'config_hash'}->{'backup_fmt'};
$self->{'backup_errors'} = $self->{'config_hash'}->{'backup_errors'};
$self->{'backup_strftime'} = $self->{'config_hash'}->{'backup_strftime'};
print "<tr> <td valign=top><b>$self->{'text_hash'}->{'backup_doms'}</td> <td>\n";
if (defined($self->{'in_hash'}->{'dom'})) {
	# Just one domain
	$self->{'d'} = $self->get_domain($self->{'in_hash'}->{'dom'});
	if (defined($self->{'d'}->{'backup_dest'})) {
		$self->{'dest'} = $self->{'d'}->{'backup_dest'};
		}
	elsif ($self->{'config_hash'}->{'backup_fmt'} == 0 && $self->{'dest'}) {
		$self->{'dest'} .= "/$self->{'d'}->{'dom'}.tar.gz";
		}
	$self->{'backup_fmt'} = $self->{'d'}->{'backup_fmt'}
		if (defined($self->{'d'}->{'backup_fmt'}));
	$self->{'backup_errors'} = $self->{'d'}->{'backup_errors'}
		if (defined($self->{'d'}->{'backup_errors'}));
	$self->{'backup_strftime'} = $self->{'d'}->{'backup_strftime'}
		if (defined($self->{'d'}->{'backup_strftime'}));
	print $self->ui_hidden("dom", $self->{'in_hash'}->{'dom'}),"\n";
	print $self->ui_hidden("doms", $self->{'in_hash'}->{'dom'}),"\n";
	print $self->ui_hidden("backup_all", 0),"\n";
	print "<tt>$self->{'d'}->{'dom'}</tt>\n";
	}
else {
	# User can select which domains
	$self->{'backup_all'} = $self->{'config_hash'}->{'backup_all'};
	@{$self->{'bak_array'}} = split(/\s+/, $self->{'config_hash'}->{'backup_doms'});
	@{$self->{'doms_array'}} = $self->list_domains();
	printf "<input type=radio name=all value=1 %s> %s\n",
		$self->{'backup_all'} == 1 ? "checked" : "", $self->{'text_hash'}->{'backup_all'};
	printf "<input type=radio name=all value=0 %s> %s\n",
		$self->{'backup_all'} == 0 ? "checked" : "", $self->{'text_hash'}->{'backup_sel'};
	printf "<input type=radio name=all value=2 %s> %s\n",
		$self->{'backup_all'} == 2 ? "checked" : "", $self->{'text_hash'}->{'backup_exc'};
	print "<br>\n";
	print $self->servers_input("doms", \@{$self->{'bak_array'}}, \@{$self->{'doms_array'}});
	}
print "</td> </tr>\n";

# Show feature selection boxes
foreach $f (@{$self->{'backup_features_array'}}) {
	$self->{'bfunc'} = "backup_$f";
	if ($self->UNIVERSAL::can($self->{'bfunc'}) &&
	    ($self->{'config_hash'}->{$f} || $f eq "unix" || $f eq "virtualmin")) {
		printf "<input type=hidden name=feature value=%s>\n", $self->{'config_hash'}->{'backup_feature_'.$f} ? $f : '';
		$self->{'ofunc'} = "show_backup_$f";
		if ($self->UNIVERSAL::can($self->{'ofunc'})) {
			local %opts = map { split(/=/, $_) }
				 split(/,/, $self->{'config_hash'}->{'backup_opts_'.$f});
                      if ($f eq 'mail') {
                               print "<input type=hidden name=mail_mailfiles value=1>" if $opts{'mailfiles'};
                               }
                       elsif ($f eq 'dir') {
                               print "<input type=hidden name=dir_logs value=1>" if $opts{'dirnologs'};
                               }
                       else {
                               print "DEVELOPMENT ERROR: you should see sub $self->{'ofunc'} for website feature $f<br>\n";
                               }			
		    }
		}
	}

# Show destination fields
print "<tr> <td valign=top><b>$self->{'text_hash'}->{'backup_dest'}</td>\n";
print "<td>",$self->show_backup_destination("dest", $self->{'dest'}),
      "</td> </tr>\n";

print "<tr> <td></td>\n";
printf "<td><input type=checkbox name=strftime value=1 %s> %s</td> </tr>\n",
	$self->{'backup_strftime'} ? "checked" : "", $self->{'text_hash'}->{'backup_strftime'};

print "<tr> <td><b>$self->{'text_hash'}->{'backup_fmt'}</td> <td>\n";
printf "<input type=radio name=fmt value=0 %s> %s\n",
	$self->{'backup_fmt'} == 0 ? "checked" : "", $self->{'text_hash'}->{'backup_fmt0'};
printf "<input type=radio name=fmt value=1 %s> %s</td> </tr>\n",
	$self->{'backup_fmt'} == 1 ? "checked" : "", $self->{'text_hash'}->{'backup_fmt1'};

# Show error mode
print "<tr> <td><b>$self->{'text_hash'}->{'backup_errors'}</td> <td>\n";
printf "<input type=radio name=errors value=0 %s> %s\n",
	$self->{'backup_errors'} == 0 ? "checked" : "", $self->{'text_hash'}->{'backup_errors0'};
printf "<input type=radio name=errors value=1 %s> %s</td> </tr>\n",
	$self->{'backup_errors'} == 1 ? "checked" : "", $self->{'text_hash'}->{'backup_errors1'};

	# Show schedule inputs
	$self->foreign_require("cron", "cron-lib.pl");
	local @jobs = $main::cron_object->list_cron_jobs();
	local ($job) = grep { $_->{'user'} eq 'root' &&
			      $_->{'command'} eq $self->{'backup_cron_cmd'} } @jobs;

	# Enabled/disabled input
	print "<tr> <td><b>$self->{'text_hash'}->{'backup_enabled'}</b></td>\n";
	printf "<td><input type=radio name=enabled value=0 %s> %s\n",
		$job ? "" : "checked", $self->{'text_hash'}->{'no'};
	printf "<input type=radio name=enabled value=1 %s> %s</td> </tr>\n",
		$job ? "checked" : "", $self->{'text_hash'}->{'backup_enabledyes'};

	# Email input
	print "<tr> <td><b>$self->{'text_hash'}->{'backup_email'}</b></td>\n";
	printf "<td><input name=email size=40 value='%s'></td> </tr>\n",
		$self->{'config_hash'}->{'backup_email'};

	# Times input
	print "<tr> <td colspan=2><table border>\n";
	$job ||= { 'special' => 'daily' };
	$main::cron_object->show_times_input($job);
	print "</table></td> </tr>\n";

	print "</table></td></tr></table>\n";
print "<input type=submit name='sub_sched' value='$self->{'text_hash'}->{'backup_save'}'>\n";
print ("<input type=submit name='sub_backup' value='",$self->html_escape($self->text('backup_title' ,$self->{'t_websites_mail'})),"'></form>\n");

$self->ui_print_footer("$self->{'text_hash'}->{'index_mainpage_url'}", $self->{'text_hash'}->{'index_mainpage'},"",$self->text('index_return', $self->{'t_websites_mail'}));
1;
		
}


1;

