#!/usr/bin/perl

&MAIN();

 sub MAIN {
# bwgraph.cgi
# Show current bandwidth usage graphs

&ModuleLoader::preload_module('virtual_server_class', "virtual_server::VirtualserverLib");
$self = new virtual_server::VirtualserverLib:: 'virtual_server_class',%$self;

require 'timelocal.pl';

$self->ReadParse();
use POSIX;

# Work out which domains to show
if ($self->{'in_hash'}->{'dom'}) {
	@{$self->{'doms_array'}} = ( $self->get_domain($self->{'in_hash'}->{'dom'}) );
	$self->{'subh'} = $self->domain_in($self->{'doms_array'}->[0]);
	}
else {
	@{$self->{'doms_array'}} = grep { !$_->{'parent'} } $self->list_domains();
	}
foreach $d (@{$self->{'doms_array'}}) {
	$self->can_edit_domain($d) || $self->error($self->{'text_hash'}->{'newbw_ecannot'});
	}
$self->ui_print_header($self->{'subh'}, $self->{'text_hash'}->{'bwgraph_title'}, "",undef,0,1);

# Show current usage and limit for all virtual servers
$self->{'max'} = 0;
foreach $d (@{$self->{'doms_array'}}) {
	$self->{'max'} = $d->{'bw_usage'} if ($d->{'bw_usage'} > $self->{'max'});
	$self->{'max'} = $d->{'bw_limit'} if ($d->{'bw_limit'} > $self->{'max'});
	}
if ($self->{'max'}) {
	# Show links for mode
	print "<b>$self->{'text_hash'}->{'bwgraph_mode'}</b>\n";
 	foreach $m (0, 1, 2, 3) {
 		print "&nbsp;|&nbsp;\n" if ($m);
 		$self->{'t'} = $self->{'text_hash'}->{'bwgraph_mode_'.$m};
 		if ($m == $self->{'in_hash'}->{'mode'}) {
 			print $self->{'t'};
 			}
 		else {
 			print "<a href='bwgraph.cgi?mode=$m&dom=$self->{'in_hash'}->{'dom'}'>$self->{'t'}</a>\n";
 			}
 		}
	print "<p>\n";

	# Show table
	$self->{'width'} = 500;
	print "<table>\n";
	if ($self->{'in_hash'}->{'mode'} == 0 || $self->{'in_hash'}->{'mode'} == 1) {
		# By domain
		print "<tr> <td><b>$self->{'text_hash'}->{'newbw_dom'}</b></td>\n";
		print "<td><b>",$self->text('edit_bwpast_'.$self->{'config_hash'}->{'bw_past'},
				      $self->{'text_hash'}->{'newbw_graph'}, $self->{'config_hash'}->{'bw_period'}),
		      "</b></td>\n";
		print "<td><b>$self->{'text_hash'}->{'newbw_glimit'}</b></td>\n";
		print "<td><b>$self->{'text_hash'}->{'newbw_gusage'}</b></td>\n";
		print "</tr>\n";
		foreach $d (sort { $b->{'bw_usage'} <=> $a->{'bw_usage'} }
			    grep { !$_->{'parent'} }
			    @{$self->{'doms_array'}}) {
			$usage = $self->{'in_hash'}->{'mode'} == 1 ? $d->{'bw_usage_only'}
						  : $d->{'bw_usage'};
			if ($self->{'in_hash'}->{'dom'}) {
				print "<tr> <td>$d->{'dom'}</td> <td nowrap>\n";
				}
			else {
				print "<tr> <td><a href='bwgraph.cgi?dom=$d->{'id'}'>",
				      "$d->{'dom'}</td> <td nowrap>\n";
				}

			# Show nothing if this domain is disabled
			if (!$self->can_monitor_bandwidth($d)) {
				print "</td> <td colspan=2>$self->{'text_hash'}->{'bwgraph_dis'}</td> </tr>\n";
				next;
				}

			# Show limit, or grey box if unlimited
			if ($d->{'bw_limit'}) {
				printf "<img src=images/red.gif width=%s height=10>\n",
					int($self->{'width'}*$d->{'bw_limit'}/$self->{'max'})+1;
				}
			else {
				printf "<img src=images/grey.gif width=%s height=10>\n",
					$self->{'width'};
				}

			# Show usage by feature
			print "<br>";
			&usage_colours($d, $self->{'in_hash'}->{'mode'});

			print "</td>\n";
			print "<td>\n";
			if ($d->{'bw_limit'}) {
				print $self->nice_size($d->{'bw_limit'});
				}
			else {
				print $self->{'text_hash'}->{'newbw_unlim'};
				}
			print "</td>\n";
			print "<td>",$self->nice_size($usage),"</td>\n";
			print "</tr>\n";

			next if ($self->{'in_hash'}->{'mode'} != 1);

			# Show sub-servers
			$self->{'space'} = $d->{'bw_usage_only'};
			foreach $sd (grep { !$_->{'alias'} }
					  $self->get_domain_by("parent", $d->{'id'})) {
				print "<tr> <td>&nbsp;&nbsp;&nbsp;",
				      "$sd->{'dom'}</td> <td>\n";

				# Show nothing if this domain is disabled
				if (!$self->can_monitor_bandwidth($sd)) {
					print "</td> <td colspan=2>$self->{'text_hash'}->{'bwgraph_dis'}</td> </tr>\n";
					next;
					}

				printf "<img src=images/white.gif width=%s height=10>",
					int($self->{'width'}*$self->{'space'}/$self->{'max'});
				&usage_colours($sd, 1);
				print "</td>\n";
				print "<td></td>\n";
				print "<td>",$self->nice_size($sd->{'bw_usage_only'}),"</td>\n";
				print "</tr>\n";
				$self->{'space'} += $sd->{'bw_usage_only'};
				}
			}
		}
	elsif ($self->{'in_hash'}->{'mode'} == 2) {
		# By date, for current billing period
		print "<tr> <td><b>$self->{'text_hash'}->{'newbw_date'}</b></td>\n";
		print "<td><b>$self->{'text_hash'}->{'newbw_dusage'}</b></td>\n";
		print "<td><b>$self->{'text_hash'}->{'newbw_gusage'}</b></td>\n";
		print "</tr>\n";

		# Get bandwidth for relevant domains and sub-domains
		foreach $d (@{$self->{'doms_array'}}) {
			foreach $dd ($d, $self->get_domain_by("parent", $d->{'id'})) {
				local $bwinfo = $self->get_bandwidth($dd);
				push(@{$self->{'bands_array'}}, $bwinfo);
				}
			}

		# Work out the max day
		$self->{'now'} = time();
		$self->{'day'} = int($self->{'now'} / (24*60*60));
		$self->{'start_day'} = $self->bandwidth_period_start();
		$self->{'max'} = 0;
		for($i=$self->{'day'}; $i>=$self->{'start_day'}; $i--) {
			$usage = 0;
			foreach $f (@{$self->{'features_array'}}) {
				$usage += &usage_for_days($i, $i, $f, @{$self->{'bands_array'}});
				}
			$self->{'max'} = $usage if ($usage > $self->{'max'});
			}

		# Show the day table
		$self->{'max'} ||= 1;
		for($i=$self->{'day'}; $i>=$self->{'start_day'}; $i--) {
			print "<tr>\n";
			print "<td>",strftime("%d/%m/%Y", localtime($i*24*60*60)),"</td>\n";
			print "<td>";
			local $usage = 0;
			foreach $f (@{$self->{'features_array'}}) {
				local $fusage = &usage_for_days($i, $i, $f,
								@{$self->{'bands_array'}});
				$usage += $fusage;
				if ($fusage) {
					printf "<img src=images/usage-$f.gif width=%s height=10>",
						int($self->{'width'}*$fusage/$self->{'max'})+($f eq "web" ? 1 : 0);
					$self->{'donecolour_hash'}->{$f} += $fusage;
					}
				}
			print "</td>";
			print "<td>",$self->nice_size($usage),"</td>\n";
			print "</tr>\n";
			}
		}
	elsif ($self->{'in_hash'}->{'mode'} == 3) {
		# By month
		print "<tr> <td><b>$self->{'text_hash'}->{'newbw_month'}</b></td>\n";
		print "<td><b>$self->{'text_hash'}->{'newbw_dusage'}</b></td>\n";
		print "<td><b>$self->{'text_hash'}->{'newbw_gusage'}</b></td>\n";
		print "</tr>\n";

		# Get bandwidth for relevant domains and sub-domains, and
		# work out the earliest time
		$self->{'start_day'} = undef;
		foreach $d (@{$self->{'doms_array'}}) {
			foreach $dd ($d, $self->get_domain_by("parent", $d->{'id'})) {
				local $bwinfo = $self->get_bandwidth($dd);
				push(@{$self->{'bands_array'}}, $bwinfo);
				local $min = &minimum_day($bwinfo);
#				$self->{'start_day'} = $min if (!defined($self->{'start_day'}) ||   $min < $self->{'start_day'});
				$self->{'start_day'} = $self->bandwidth_period_start();
				}
			}

		# Work out the start and end months
		@{$self->{'start_tm_array'}} = localtime($self->{'start_day'} * (24*60*60));
		@{$self->{'end_tm_array'}} = localtime(time());
		$self->{'start_month'} = ($self->{'start_tm_array'}->[5]+1900)*12 + $self->{'start_tm_array'}->[4];
		$self->{'end_month'} = ($self->{'end_tm_array'}->[5]+1900)*12 + $self->{'end_tm_array'}->[4];

		# Work out the max usage for a month
		$self->{'max'} = 0;
		for($i=$self->{'end_month'}; $i>=$self->{'start_month'}; $i--) {
			@tm = ( 0, 0, 0, 1, $i%12, int($i/12)-1900 );
			$self->{'istart_array'}->[$i] = timelocal(@tm)/(24*60*60);
			@endtm = ( 0, 0, 0, 1, $tm[4]+1, $tm[5] );
			if ($endtm[4] == 12) { $endtm[4] = 0; $endtm[5]++ };
			$self->{'iend_array'}->[$i] = timelocal(@endtm)/(24*60*60) - 1;
			$usage = 0;
			foreach $f (@{$self->{'features_array'}}) {
				$usage += &usage_for_days(
					$self->{'istart_array'}->[$i], $self->{'iend_array'}->[$i], $f, @{$self->{'bands_array'}});
				}
			$self->{'max'} = $usage if ($usage > $self->{'max'});
			}

		# Show the day table
		$self->{'max'} ||= 1;
		for($i=$self->{'end_month'}; $i>=$self->{'start_month'}; $i--) {
			@tm = ( 0, 0, 0, 1, $i%12, int($i/12)-1900 );
			print "<tr>\n";
			print "<td>",strftime("%m/%Y", @tm),"</td>\n";
			print "<td>";
			local $usage = 0;
			foreach $f (@{$self->{'features_array'}}) {
				local $fusage = &usage_for_days(
					$self->{'istart_array'}->[$i], $self->{'iend_array'}->[$i], $f, @{$self->{'bands_array'}});
				$usage += $fusage;
				if ($fusage) {
					printf "<img src=images/usage-$f.gif width=%s height=10>",
						int($self->{'width'}*$fusage/$self->{'max'})+($f eq "web" ? 1 : 0);
					$self->{'donecolour_hash'}->{$f} += $fusage;
					}
				}
			print "</td>";
			print "<td>",$self->nice_size($usage),"</td>\n";
			print "</tr>\n";
			}
		}

	print "</table>\n";

	# Show colour keys
	print "<br>\n";
	foreach $f (@{$self->{'features_array'}}) {
		if ($self->{'donecolour_hash'}->{$f}) {
			print "<img src=images/usage-$f.gif width=10 height=10>\n";
			local $label = $self->{'text_hash'}->{'bandwidth_'.$f} ||
				       $self->{'text_hash'}->{'feature_'.$f};
			print $label," (",
			      $self->nice_size($self->{'donecolour_hash'}->{$f}),")\n";
			}
		}
	print "<br>\n";
	}
else {
	print "<b>$self->{'text_hash'}->{'bwgraph_none'}</b><p>\n";
	}

#&footer("$self->{'text_hash'}->{'index_mainpage_url'}", $self->{'text_hash'}->{'index_mainpage'});

if ($self->{'in_hash'}->{'dom'} && $self->master_admin()) {

#	 local $website = &ztl_get_text(\%apps, 'text_website:$web', 'text_domain:$dns');
	#$website= "Website";
	$self->ui_print_footer("$self->{'text_hash'}->{'index_mainpage_url'}", $self->{'text_hash'}->{'index_mainpage'},"bwgraph.cgi", $self->{'text_hash'}->{'newbw_return'},"", $self->text('index_return', $self->{'t_website'}), );

	}
else {
#		 local $website = &ztl_get_text(\%apps, 'text_website:$web', 'text_domain:$dns');
		#$website= "Website";
		$self->ui_print_footer("$self->{'text_hash'}->{'index_mainpage_url'}", $self->{'text_hash'}->{'index_mainpage'},"", $self->text('index_return', $self->{'t_website'}), );
	}

1;
		
}

# usage_colours(&domain, mode)
sub usage_colours
{
	shift if ($self == $_[0]);

local ($d, $mode) = @_;
local $f;
foreach $f (@{$self->{'features_array'}}) {
	local $fusage = $mode == 1 ? $d->{'bw_usage_only_'.$f}
			     	   : $d->{'bw_usage_'.$f};
	if ($fusage) {
		printf "<img src=images/usage-$f.gif width=%s height=10>",
			int($self->{'width'}*$fusage/$self->{'max'})+($f eq "web" ? 1 : 0);
		$self->{'donecolour_hash'}->{$f} += $fusage;
		}
	}
}

# minimum_day(&bandwidth)
sub minimum_day
{
	shift if ($self == $_[0]);

local $min = undef;
foreach $k (keys %{$_[0]}) {
	if ($k =~ /^(\S+)_(\d+)$/ && (!defined($min) || $2 < $min)) {
		$min = $2;
		}
	}
return $min;
}

# usage_for_days(start, end, feature, &bandwidth, ...)
sub usage_for_days
{
	shift if ($self == $_[0]);

local ($start, $end, $f, @bands) = @_;
local $usage = 0;
local ($i, $band);
for($i=int($start); $i<=int($end); $i++) {
	foreach $band (@bands) {
		$usage += $band->{$f.'_'.$i};
		}
	}
return $usage;
}


1;

