#!/usr/bin/perl

&MAIN();

 sub MAIN {
# cert_form.cgi
# Show a form for requesting a CSR, or installing a cert

&ModuleLoader::preload_module('virtual_server_class', "virtual_server::VirtualserverLib");
$self = new virtual_server::VirtualserverLib:: 'virtual_server_class',%$self;

$self->ReadParse();
$self->{'d'} = $self->get_domain($self->{'in_hash'}->{'dom'});
$self->{'access_hash'}->{'edit'} && $self->can_edit_domain($self->{'d'}) || $self->error($self->{'text_hash'}->{'edit_ecannot'});
$self->{'d'}->{'ssl'} && $self->{'d'}->{'dir'} || $self->error($self->{'text_hash'}->{'edit_no_ssl'});
$self->foreign_require("cpplus", "cpplus-lib.pl");
$self->ui_print_header($self->domain_in($self->{'d'}), $self->{'text_hash'}->{'cert_title'}, "", undef, undef, 1);

# Details of current cert
print "$self->{'text_hash'}->{'cert_desc2'}<p>\n";
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'cert_header2'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";
$self->{'info'} = $self->cert_info($self->{'d'});
foreach $i ('cn', 'o', 'issuer_cn', 'issuer_o', 'notafter', 'type') {
	if ($self->{'info'}->{$i}) {
		print "<tr>\n" if ($self->{'j'}%2 == 0);
		print "<td><b>",$self->{'text_hash'}->{'cert_'.$i},"</b></td>\n";
		print "<td>",$self->{'info'}->{$i},"</td>\n";
		print "</tr>\n" if ($self->{'j'}++%2 == 1);
		}
	}
print "</table></td></tr></table>\n";

print "<hr>\n";

# CSR generation form
print "$self->{'text_hash'}->{'cert_desc1'}<p>\n";

print "<form action=csr.cgi>\n";
print "<input type=hidden name=dom value='$self->{'in_hash'}->{'dom'}'>\n";
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'cert_header1'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

print "<tr> <td><b>$main::cpplus_object->{'text_hash'}->{'ssl_cn'}</b></td>\n";
printf "<td><input name=commonName size=30 value='%s'></td> </tr>\n",
	"www.$self->{'d'}->{'dom'}";

print "<tr> <td><b>$main::cpplus_object->{'text_hash'}->{'ca_email'}</b></td>\n";
printf "<td><input name=emailAddress size=30 value='%s'></td> </tr>\n",
	$self->{'d'}->{'email'} || $self->{'d'}->{'user'}.'@'.$self->{'d'}->{'dom'};

print "<tr> <td><b>$main::cpplus_object->{'text_hash'}->{'ca_ou'}</b></td>\n";
print "<td><input name=organizationalUnitName size=30></td> </tr>\n";

print "<tr> <td><b>$main::cpplus_object->{'text_hash'}->{'ca_o'}</b></td>\n";
printf "<td><input name=organizationName size=30 value='%s'></td> </tr>\n",
	$self->{'d'}->{'owner'};

# sets Country Code
print "<tr> <td><b>$main::cpplus_object->{'text_hash'}->{'ca_c'}</b></td>\n";
local @countr_list=&get_countries_info();
print "<td><select name=countryName >";
foreach  (@countr_list) {
      if($_->{'CC'} ne "  ")
        {printf "<option value=\"$_->{'CC'}\">$_->{'country'} ($_->{'CC'})\n" ;}
     else
        {printf "<option value=\"$_->{'CC'}\">$_->{'country'} \n" ;}
}
print "</select> </td> </tr>\n";

# sets State or Province name
print "<tr> <td><b>$main::cpplus_object->{'text_hash'}->{'ca_sp'}</b></td>\n";
local @state_list=&get_state_info();
print "<td><select name=stateOrProvinceName >";
foreach  (@state_list) {
      if($_->{'CC'} ne "-")
        {printf "<option value=\"$_->{'state'}\">$_->{'state'} ($_->{'CC'})\n" ;}
     else
        {printf "<option value=\"$_->{'state'}\">$_->{'state'} \n" ;}
}
print "</select> </td> </tr>\n";

local $key_size = $main::cpplus_object->{'default_key_size'};
print "<tr> <td><b>$main::cpplus_object->{'text_hash'}->{'ssl_size'}</b></td>\n";
print "<td><select name=size_def>\n";
foreach my $ks ($key_size, $key_size * 2, $key_size * 4) {
        printf "<option value=$ks %s>$ks\n", $ks == $key_size ? 'selected' : '';
}
print "</select> $main::cpplus_object->{'text_hash'}->{'ssl_bits'}</td> </tr>\n";

print "<tr> <td><b>$main::cpplus_object->{'text_hash'}->{'ssl_days'}</b></td>\n";
print "<td><input name=days size=8 value='1825'></td> </tr>\n";

print "</table></td></tr></table>\n";
print "<input type=submit value='$self->{'text_hash'}->{'cert_csrok'}'></form>\n";

print "<hr>\n";

# New key and cert form
print "$self->{'text_hash'}->{'cert_desc3'}<p>\n";

print "<form action=newkey.cgi method=post>\n";
print "<input type=hidden name=dom value='$self->{'in_hash'}->{'dom'}'>\n";
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'cert_header3'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

print "<tr> <td valign=top><b>$self->{'text_hash'}->{'cert_cert'}</b></td>\n";
print "<td><textarea name=cert rows=8 cols=70></textarea></td> </tr>\n";

if (-r $self->{'d'}->{'ssl_newkey'}) {
	$self->{'newkey'} = `cat $self->{'d'}->{'ssl_newkey'}`;
	}
print "<tr> <td valign=top><b>$self->{'text_hash'}->{'cert_newkey'}</b></td>\n";
print "<td><textarea name=newkey rows=8 cols=70>$self->{'newkey'}</textarea></td> </tr>\n";

print "</table></td></tr></table>\n";
print "<input type=submit value='$self->{'text_hash'}->{'cert_newok'}'></form>\n";

$self->ui_print_footer($self->{'text_hash'}->{'index_mainpage_url'}, $self->{'text_hash'}->{'index_mainpage'},"", $self->text('index_return', $self->{'t_websites'}), "edit_domain.cgi?dom=$self->{'in_hash'}->{'dom'}", $self->text('edit_return', $self->{'d'}->{'dom'}));

 sub get_countries_info{
   local (@a, @list);
  open (TAB, 'info.countries' );
        while(<TAB>) {
             @a= split(/=/, $_);
             chomp ($a[1]);
            push (@list, {'CC' => $a[0],  'country'=> $a[1] } );

          }
  close (TAB);
  return (@list)

 }

  sub get_state_info{
   local (@a, @list);
  open (TAB, 'info.states' );
        while(<TAB>) {
             @a= split(/=/, $_);
             chomp ($a[1]);
            push (@list, {'CC' => $a[0],  'state'=> $a[1] } );

          }
  close (TAB);
  return (@list)

 }
1;
		
}




1;

