#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Generate a CSR and private key for this domain

&ModuleLoader::preload_module('virtual_server_class', "virtual_server::VirtualserverLib");
$self = new virtual_server::VirtualserverLib:: 'virtual_server_class',%$self;

$self->ReadParse();
$self->{'d'} = $self->get_domain($self->{'in_hash'}->{'dom'});
$self->{'access_hash'}->{'edit'} && $self->can_edit_domain($self->{'d'}) || $self->error($self->{'text_hash'}->{'edit_ecannot'});
$self->foreign_require("cpplus", "cpplus-lib.pl");

# Validate inputs
$self->error_setup($self->{'text_hash'}->{'csr_err'});
$self->{'in_hash'}->{'commonName'} =~ /^[A-Za-z0-9\.\-]+$/ ||
	$self->error($main::cpplus_object->{'text_hash'}->{'newkey_ecn'});
$self->{'in_hash'}->{'size_def'} || $self->{'in_hash'}->{'size'} =~ /^\d+$/ ||
	$self->error($main::cpplus_object->{'text_hash'}->{'newkey_esize'});
$self->{'in_hash'}->{'days'} =~ /^\d+$/ || $self->error($main::cpplus_object->{'text_hash'}->{'newkey_edays'});
$self->{'size'} = $self->{'in_hash'}->{'size_def'} ? $main::cpplus_object->{'default_key_size'} : $self->{'in_hash'}->{'size'};

# Generate the private key
$self->{'d'}->{'ssl_csr'} ||= "$self->{'d'}->{'home'}/ssl.csr";
$self->{'d'}->{'ssl_newkey'} ||= "$self->{'d'}->{'home'}/ssl.newkey";
unlink($self->{'d'}->{'ssl_newkey'});
$self->{'out'} = $self->backquote_logged("openssl genrsa -out ".quotemeta($self->{'d'}->{'ssl_newkey'})." $self->{'size'} 2>&1 </dev/null");
chown($self->{'d'}->{'uid'}, $self->{'d'}->{'ugid'}, $self->{'d'}->{'ssl_newkey'});
chmod(0755, $self->{'d'}->{'ssl_newkey'});
if (!-r $self->{'d'}->{'ssl_newkey'} || $?) {
	$self->error($self->text('csr_ekey', "<pre>$self->{'out'}</pre>"));
	}

# Generate the CSR
$self->{'outtemp'} = $self->transname();
unlink($self->{'d'}->{'ssl_csr'});
open(CA, "| openssl req -new -key ".quotemeta($self->{'d'}->{'ssl_newkey'})." -out ".
	 quotemeta($self->{'d'}->{'ssl_csr'})." >$self->{'outtemp'} 2>&1");
print CA ($self->{'in_hash'}->{'countryName'} || "."),"\n";
print CA ($self->{'in_hash'}->{'stateOrProvinceName'} || "."),"\n";
print CA ".\n";
print CA ($self->{'in_hash'}->{'organizationName'} || "."),"\n";
print CA ($self->{'in_hash'}->{'organizationalUnitName'} || "."),"\n";
print CA ($self->{'in_hash'}->{'commonName_def'} ? "*" : $self->{'in_hash'}->{'commonName'}),"\n";
print CA ($self->{'in_hash'}->{'emailAddress'} || "."),"\n";
print CA ".\n";
print CA ".\n";
close(CA);
$self->{'rv'} = $?;
$self->{'out'} = `cat $self->{'outtemp'}`;
unlink($self->{'outtemp'});
chown($self->{'d'}->{'uid'}, $self->{'d'}->{'ugid'}, $self->{'d'}->{'ssl_csr'});
chmod(0755, $self->{'d'}->{'ssl_csr'});
if (!-r $self->{'d'}->{'ssl_csr'} || $?) {
	$self->error($self->text('csr_ecsr', "<pre>$self->{'out'}</pre>"));
	}

# Save the domain
$self->save_domain($self->{'d'});
$self->run_post_actions();

# Show the output
$self->ui_print_header($self->domain_in($self->{'d'}), $self->{'text_hash'}->{'csr_title'}, "", undef, undef, 1);

print "$self->{'text_hash'}->{'csr_done'}<p>\n";

print $self->text('csr_csr', "<tt>$self->{'d'}->{'ssl_csr'}</tt>"),"\n";
print "<pre>",`cat $self->{'d'}->{'ssl_csr'}`,"</pre>\n";

print $self->text('csr_key', "<tt>$self->{'d'}->{'ssl_newkey'}</tt>"),"\n";
print "<pre>",`cat $self->{'d'}->{'ssl_newkey'}`,"</pre>\n";

$self->ui_print_footer($self->{'text_hash'}->{'index_mainpage_url'}, $self->{'text_hash'}->{'index_mainpage'},"", $self->text('index_return', $self->{'t_websites'}), "edit_domain.cgi?dom=$self->{'in_hash'}->{'dom'}", $self->text('edit_return', $self->{'d'}->{'dom'}), "cert_form.cgi?dom=$self->{'in_hash'}->{'dom'}", $self->{'text_hash'}->{'cert_return'});
1;
		
}


1;

