#!/usr/bin/perl

&MAIN();

 sub MAIN {
# delete_domain.cgi
# Delete a domain, after asking first

&ModuleLoader::preload_module('virtual_server_class', "virtual_server::VirtualserverLib");
$self = new virtual_server::VirtualserverLib:: 'virtual_server_class',%$self;

$self->require_bind() if ($self->{'config_hash'}->{'dns'});
$self->require_useradmin();
$self->require_mail() if ($self->{'config_hash'}->{'mail'});
$self->ReadParse();
$self->{'d'} = $self->get_domain($self->{'in_hash'}->{'dom'});
$self->{'d'} && $self->{'d'}->{'uid'} && ($self->{'d'}->{'gid'} || $self->{'d'}->{'ugid'}) ||
	$self->error("Domain $self->{'in_hash'}->{'dom'} does not exist!");
$self->{'access_hash'}->{'edit'} && $self->can_edit_domain($self->{'d'}) || $self->error($self->{'text_hash'}->{'edit_ecannot'});
$self->master_admin() || $self->{'d'}->{'parent'} || $self->error($self->{'text_hash'}->{'edit_ecannot'});

$self->{'subh'} = $self->domain_in($self->{'d'});
if ($self->{'in_hash'}->{'confirm'}) {
	$self->ui_print_unbuffered_header($self->{'subh'}, $self->text('delete_title1', $self->{'t_website'}) , "" ,undef,0,1);
	}
else {
	$self->ui_print_header($self->{'subh'}, $self->text('delete_title', $self->{'t_website'}), "" ,undef,0,1);
	}

@{$self->{'users_array'}} = $self->list_domain_users($self->{'d'}, 1);
@{$self->{'aliases_array'}} = $self->list_domain_aliases($self->{'d'});
@{$self->{'subs_array'}} = $self->get_domain_by("parent", $self->{'d'}->{'id'});
@{$self->{'aliasdoms_array'}} = $self->get_domain_by("alias", $self->{'d'}->{'id'});
@{$self->{'aliasdoms_array'}} = grep { $_->{'parent'} != $self->{'d'}->{'id'} } @{$self->{'aliasdoms_array'}};
if (!$self->{'in_hash'}->{'confirm'}) {
	# Ask the user if he is sure
	print $self->check_clicks_function();
	if ($self->{'d'}->{'unix'}) {
		$self->{'sz'} = $self->disk_usage_kb($self->{'d'}->{'home'});
		print "<p>",$self->text('delete_rusure2', "<tt>$self->{'d'}->{'dom'}</tt>",
				  $self->nice_size($self->{'sz'}*1024)),"<p>\n";
		}
	else {
		print "<p>",$self->text('delete_rusure3', "<tt>$self->{'d'}->{'dom'}</tt>"),"<p>\n";
		}

	$self->{'pfx'} = $self->{'d'}->{'parent'} ? "sublosing_" : "losing_";
	print "<ul>\n";
	foreach $f (@{$self->{'features_array'}}) {
		if ($self->{'d'}->{$f} && ($self->{'config_hash'}->{$f} || $f eq 'unix')) {
			print "<li>",$self->{'text_hash'}->{'feature_'.$f}," - ",
				     $self->{'text_hash'}->{$self->{'pfx'}.$f},"<br>\n";
			}
		}
	foreach $f (@{$self->{'feature_plugins_array'}}) {
		if ($self->{'d'}->{$f}) {
			print "<li>",$self->plugin_call($f, "feature_name")," - ",
			     $self->plugin_call($f, "feature_losing"),"<br>\n";
			}
		}
	if (@{$self->{'users_array'}} || @{$self->{'aliases_array'}}) {
		print "<li>",$self->text('delete_mailboxes', scalar(@{$self->{'users_array'}}), scalar(@{$self->{'aliases_array'}})),"<br>\n";
		}
	print "</ul>\n";

	if (@{$self->{'subs_array'}}) {
		print "<p><font size=+1>",$self->text('delete_subs',
			join(", ", map { "<tt>$_->{'dom'}</tt>" } @{$self->{'subs_array'}})),
			"</font><p>\n";
		}
	if (@{$self->{'aliasdoms_array'}}) {
		print "<p><font size=+1>",$self->text('delete_aliasdoms',
			join(", ", map { "<tt>$_->{'dom'}</tt>" } @{$self->{'aliasdoms_array'}})),
			"</font><p>\n";
		}

	print "<center><form action=delete_domain.cgi>\n";
	print "<input type=hidden name=dom value='$self->{'in_hash'}->{'dom'}'>\n";
	print "<input type=submit name=confirm ",
	      "value='$self->{'text_hash'}->{'delete_ok'}' onClick='check_clicks(form)'>\n";
	if ($self->{'access_hash'}->{'edit'} == 1) {
		#print "<p><input type=checkbox name=only value=1> ",
		  #    "$self->{'text_hash'}->{'delete_only'}<br>\n";
		      print "<p><input type=hidden name=only value=0> ",
		}
	print "</form></center>\n";

	#$self->ui_print_footer("edit_domain.cgi?dom=$self->{'in_hash'}->{'dom'}", $self->{'text_hash'}->{'edit_return'},
	#	"", $self->{'text_hash'}->{'index_return'});

	$self->ui_print_footer("$self->{'text_hash'}->{'index_mainpage_url'}", $self->{'text_hash'}->{'index_mainpage'},"",  $self->text('index_return', $self->{'t_website'}),"edit_domain.cgi?dom=$self->{'in_hash'}->{'dom'}", $self->text('edit_return', $self->{'t_website'}) );

	}
else {
	# Go ahead and delete this domain and all sub-domains ..
	foreach $dd (@{$self->{'aliasdoms_array'}}, @{$self->{'subs_array'}}, $self->{'d'}) {
		# Run the before command
		$self->set_domain_envs($dd, "DELETE_DOMAIN");
		$self->{'merr'} = $self->making_changes();
		$self->error($self->text('delete_emaking', "<tt>$self->{'merr'}</tt>"))
			if (defined($self->{'merr'}));

		# Delete domain file
		print $self->text('delete_domain', "<tt>$dd->{'dom'}</tt>"),"<br>\n";
		$self->delete_domain($dd);
		print $self->{'text_hash'}->{'setup_done'},"<p>\n";

		$self->{'in_hash'}->{'only'} = 0 if ($self->{'access_hash'}->{'edit'} != 1);
		if (!$self->{'in_hash'}->{'only'}) {
			if (@{$self->{'users_array'}}) {
				# Delete mail users and their mail files
				print $self->{'text_hash'}->{'delete_users'},"<br>\n";
				foreach $u (@{$self->{'users_array'}}) {
					if ($self->UNIVERSAL::can('delete_samba_client')) {
	    					$self->delete_samba_client($u->{'user'});}
					$self->delete_user($u, $dd);
					$self->delete_mail_file($u);
					$self->system_logged("rm -rf '$u->{'home'}'")
						if (-d $u->{'home'} &&
						    $u->{'home'} ne "/");
					}
				print $self->{'text_hash'}->{'setup_done'},"<p>\n";
				}

			# Delete all virtusers
			if (@{$self->{'users_array'}} || @{$self->{'aliases_array'}}) {
				print $self->{'text_hash'}->{'delete_aliases'},"<br>\n";
				foreach $v ($self->list_virtusers()) {
					if ($v->{'from'} =~ /\@(\S+)$/ &&
					    $1 eq $dd->{'dom'}) {
						$self->delete_virtuser($v);
						}
					}
				print $self->{'text_hash'}->{'setup_done'},"<p>\n";
				}

			# Take down IP
			if ($dd->{'iface'}) {
				$self->delete_virt($dd);
				}
			}

		# Delete all features (or just 'webmin' if un-importing). Any
		# failures are ignored!
		local $f;
		if (!$self->{'in_hash'}->{'only'}) {
			# Delete all plugins
			foreach $f (@{$self->{'feature_plugins_array'}}) {
				if ($dd->{$f}) {
					local $main::error_must_die = 1;
					eval { $self->plugin_call($f,
						"feature_delete",$dd) };
					if ($@) {
						do { my $fn = $self->{'second_print'}; $self->$fn(
						    $self->text('delete_failure',
						    $self->plugin_call($f,
							"feature_name"), $@))};
						}
					}
				}
			}
		foreach $f ($self->{'in_hash'}->{'only'} ? ( "webmin" ) : reverse(@{$self->{'features_array'}})) {
			if ($self->{'config_hash'}->{$f} && $dd->{$f} || $f eq 'unix') {
				local $dfunc = "delete_$f";
				if (!$self->try_function($f, $dfunc, $dd)) {
					$dd->{$f} = 1;
					}
				}
			}

		# Update the parent domain Webmin user, so that his ACL
		# is refreshed
		if ($dd->{'parent'} && $dd->{'parent'} != $self->{'d'}->{'id'}) {
			$self->{'parentdom'} = $self->get_domain($self->{'d'}->{'parent'});
			$self->modify_webmin($self->{'parentdom'}, $self->{'parentdom'});
			}
		}

	# Run the after command
	$self->run_post_actions();
	$self->made_changes();
	$self->webmin_log("delete", "domain", $self->{'d'}->{'dom'}, $self->{'d'});

	#$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
	$self->ui_print_footer("$self->{'text_hash'}->{'index_mainpage_url'}", $self->{'text_hash'}->{'index_mainpage'},"",  $self->text('index_return', $self->{'t_website'}) );
	}

1;
		
}


1;

