#!/usr/bin/perl

&MAIN();

 sub MAIN {
# disable_domain.cgi
# Temporarily disable a domain, after asking first

&ModuleLoader::preload_module('virtual_server_class', "virtual_server::VirtualserverLib");
$self = new virtual_server::VirtualserverLib:: 'virtual_server_class',%$self;

$self->ReadParse();
$self->{'d'} = $self->get_domain($self->{'in_hash'}->{'dom'});
$self->{'access_hash'}->{'edit'} && $self->can_edit_domain($self->{'d'}) || $self->error($self->{'text_hash'}->{'edit_ecannot'});
$self->{'d'}->{'disabled'} && $self->error($self->{'text_hash'}->{'disable_ealready'});

$self->{'subh'} = $self->domain_in($self->{'d'});
if ($self->{'in_hash'}->{'confirm'}) {
	#$self->ui_print_unbuffered_header(undef, $self->{'text_hash'}->{'disable_title'}, "");
	$self->ui_print_unbuffered_header($self->{'subh'}, $self->text('disable_title1', $self->{'t_website'}), "" ,undef,0,1);
	}
else {
	#$self->ui_print_header(undef, $self->{'text_hash'}->{'_title'}, "");
	$self->ui_print_header($self->{'subh'}, $self->text('disable_title', $self->{'t_website'}), "" ,undef,0,1);
	}

# Work out what can be disabled
@{$self->{'disable_array'}} = grep { $self->{'d'}->{$_} && $self->{'config_hash'}->{$_} } split(/,/, $self->{'config_hash'}->{'disable'});
push(@{$self->{'disable_array'}}, "ssl") if ($self->indexof("web", @{$self->{'disable_array'}}) >= 0 && $self->{'d'}->{'ssl'});
@{$self->{'disable_array'}} = grep { $_ ne "unix" } @{$self->{'disable_array'}} if ($self->{'d'}->{'parent'});
push(@{$self->{'disable_array'}}, grep { $self->{'d'}->{$_} &&
	      $self->plugin_defined($_, "feature_disable") } @{$self->{'feature_plugins_array'}});

if (!@{$self->{'disable_array'}}) {
	# Nothing to do!
	print "<p>$self->{'text_hash'}->{'disable_nothing'}<p>\n";
	}
elsif (!$self->{'in_hash'}->{'confirm'}) {
	# Ask the user if he is sure
	@{$self->{'distext_array'}} = map { $self->{'text_hash'}->{"disable_f".$_} ||
			 $self->plugin_call($_, "feature_disname") } @{$self->{'disable_array'}};
	if (@{$self->{'distext_array'}} == 1) {
		$self->{'distext'} = $self->{'distext_array'}->[0];
		}
	elsif (@{$self->{'distext_array'}} == 2) {
		$self->{'distext'} = $self->text('disable_and', $self->{'distext_array'}->[0], $self->{'distext_array'}->[1]);
		}
	else {
		$self->{'dislast'} = pop(@{$self->{'distext_array'}});
		$self->{'distext'} = $self->text('disable_and', join(", ", @{$self->{'distext_array'}}), $self->{'dislast'});
		}

	print $self->check_clicks_function();
	print "<p>",$self->text('disable_rusure2', "<tt>$self->{'d'}->{'dom'}</tt>",
			  $self->{'distext'}),"<p>\n";
	print $self->{'text_hash'}->{'disable_undo'},"<p>\n";
	print "<center><form action=disable_domain.cgi>\n";
	print "<input type=hidden name=dom value='$self->{'in_hash'}->{'dom'}'>\n";
	print "<input type=submit name=confirm ",
	      "value='$self->{'text_hash'}->{'disable_ok'}' onClick='check_clicks(form)'>\n";
	print "</form></center>\n";
	}
else {
	# Go ahead and do it ..
	%{$self->{'disable_hash'}} = map { $_, 1 } @{$self->{'disable_array'}};

	# Run the before command
	$self->set_domain_envs($self->{'d'}, "DISABLE_DOMAIN");
	$self->{'merr'} = $self->making_changes();
	$self->error($self->text('disable_emaking', "<tt>$self->{'merr'}</tt>")) if (defined($self->{'merr'}));

	# Disable all configured features
	local $f;
	foreach $f (@{$self->{'features_array'}}) {
		if ($self->{'d'}->{$f} && $self->{'disable_hash'}->{$f}) {
			local $dfunc = "disable_$f";
			if ($self->try_function($f, $dfunc, $self->{'d'})) {
				push(@{$self->{'disabled_array'}}, $f);
				}
			}
		}
	foreach $f (@{$self->{'feature_plugins_array'}}) {
		if ($self->{'d'}->{$f} && $self->{'disable_hash'}->{$f}) {
			$self->plugin_call($f, "feature_disable", $self->{'d'});
			push(@{$self->{'disabled_array'}}, $f);
			}
		}

	# Save new domain details
	print $self->{'text_hash'}->{'save_domain'},"<br>\n";
	$self->{'d'}->{'disabled'} = join(",", @{$self->{'disabled_array'}});
	$self->{'d'}->{'disabled_reason'} = 'manual';
	$self->save_domain($self->{'d'});
	print $self->{'text_hash'}->{'setup_done'},"<p>\n";

	# Run the after command
	$self->run_post_actions();
	$self->set_domain_envs($self->{'d'}, "DISABLE_DOMAIN");
	$self->made_changes();
	$self->webmin_log("disable", "domain", $self->{'d'}->{'dom'}, $self->{'d'});
	}

#$self->ui_print_footer("edit_domain.cgi?dom=$self->{'in_hash'}->{'dom'}", $self->{'text_hash'}->{'edit_return'},
#"", $self->{'text_hash'}->{'index_return'});
		$self->ui_print_footer("$self->{'text_hash'}->{'index_mainpage_url'}", $self->{'text_hash'}->{'index_mainpage'},"",  $self->text('index_return', $self->{'t_website'}),"edit_domain.cgi?dom=$self->{'in_hash'}->{'dom'}", $self->text('edit_return', $self->{'t_website'}) );

1;
		
}


1;

