#!/usr/bin/perl

&MAIN();

 sub MAIN {
# domain_form.cgi
# Display a form for setting up a new virtual domain

&ModuleLoader::preload_module('virtual_server_class', "virtual_server::VirtualserverLib");
$self = new virtual_server::VirtualserverLib:: 'virtual_server_class',%$self;

$self->ReadParse();
#if ($self->{'in_hash'}->{'import'}) {
#	# Redirect to the import form
#	&redirect("import_form.cgi");
#	return;
#	}

# Get parent settings
$self->{'access_hash'}->{'create'} || $self->error($self->{'text_hash'}->{'form_ecannot'});
if ($self->{'in_hash'}->{'to'}) {
	# Creating an alias domain
	$self->{'aliasdom'} = $self->get_domain($self->{'in_hash'}->{'to'});
	$self->{'parentdom'} = $self->{'aliasdom'}->{'parent'} ?
		$self->get_domain($self->{'aliasdom'}->{'parent'}) : $self->{'aliasdom'};
	$self->{'parentuser'} = $self->{'parentdom'}->{'user'};
	}
elsif ($self->{'access_hash'}->{'create'} == 2) {
	# This user can only create a subdomain
	$self->{'parentuser'} = $self->{'remote_user'};
	}
elsif ($self->{'in_hash'}->{'parentuser'}) {
	# Creating subdomain explicitly
	$self->{'parentuser'} = $self->{'in_hash'}->{'parentuser'};
	}
if ($self->{'parentuser'} && !$self->{'parentdom'}) {
	$self->{'parentdom'} = $self->get_domain_by("user", $self->{'parentuser'}, "parent", "");
	$self->{'parentdom'} || $self->error($self->text('form_eparent', $self->{'parentuser'}));
	}

$self->ui_print_header(undef, $self->{'aliasdom'} ? $self->text('form_title3', $self->{'t_website'}) :
	$self->{'parentdom'} ? $self->{'text_hash'}->{'form_title2'} : $self->text('form_title', $self->{'t_website'}), "", undef, undef, 1);

print "<form action=domain_setup.cgi method=post>\n";
print "<input type=hidden name=parentuser value='$self->{'parentuser'}'>\n";
print "<input type=hidden name=to value='$self->{'in_hash'}->{'to'}'>\n";
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>" . $self->text('form_header', $self->{'t_website'}) . "</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

print "<tr> <td><b> $self->{'text_hash'}->{'form_domain'}</b></td>";
#print "<td colspan=3>",&ui_textbox("dom", $self->{'access_hash'}->{'forceunder'} && $self->{'parentdom'} ? ".$self->{'parentdom'}->{'dom'}" : undef, 50),"</td> </tr>\n";
print "<td colspan=3><input name=dom size=50>" . ($self->{'parentdom'} && !$self->{'aliasdom'} ? ".$self->{'parentdom'}->{'dom'}" : "") . "</td>\n";

print "<tr> <td><b> $self->{'text_hash'}->{'form_owner'}</b></td>";
print "<td colspan=3><input name=owner size=50></td>\n";

# Generate Javascript for template change
print "<script>\n";
print "function select_template(num)\n";
print "{\n";
foreach $t ($self->list_templates()) {
	local $tmpl = $self->get_template($t->{'id'});
	print "if (num == $tmpl->{'id'}) {\n";
	if (!$self->{'parentdom'}) {
		# Set group for unix user
		$self->{'num'} = $tmpl->{'ugroup'} eq "none" ? 0 : 1;
		$self->{'val'} = $tmpl->{'ugroup'} eq "none" ? "" : $tmpl->{'ugroup'};
		print "    document.forms[0].group_def[$self->{'num'}].checked = true;\n";
		print "    document.forms[0].group.value = \"$self->{'val'}\";\n";

		# Set quotas
		$self->{'val'} = $tmpl->{'quota'};
		print "    document.forms[0].quota.value = \"$self->{'val'}\";\n";
		$self->{'val'} = $tmpl->{'uquota'};
		print "    document.forms[0].uquota.value = \"$self->{'val'}\";\n";

		# Set limits
		foreach $l ("mailbox", "dbs", "bw") {
			next if ($l eq "bw" && !$self->{'config_hash'}->{'bw_active'});
			$self->{'num'} = $tmpl->{$l.'limit'} eq "none" ? 0 : 1;
			$self->{'val'} = $tmpl->{$l.'limit'} eq "none" ? "" :
				$tmpl->{$l.'limit'};
			print "    document.forms[0].${l}limit_def[$self->{'num'}].checked = true;\n";
			print "    document.forms[0].${l}limit.value = \"$self->{'val'}\";\n";
			}
		$self->{'num'} = $tmpl->{'domslimit'} eq "none" ? 1 :
		       $tmpl->{'domslimit'} eq "0" ? 0 : 2;
		$self->{'val'} = $self->{'num'} == 2 ? $tmpl->{'domslimit'} : "";
		print "    document.forms[0].domslimit_def[$self->{'num'}].checked = true;\n";
		print "    document.forms[0].domslimit.value = \"$self->{'val'}\";\n";
		}
	print "    }\n";
	}
print "}\n";
print "</script>\n";

# Show template selection field
#print "<tr> <td><b>",&hlink($self->{'text_hash'}->{'form_template'},"template"),"</b></td>\n";
#print "<td><select name=template onChange='select_template(options[selectedIndex].value)'>\n";
foreach $t ($self->list_templates()) {
	next if ($t->{'deleted'});
	next if (($self->{'parentdom'} && !$self->{'aliasdom'}) && !$t->{'for_sub'});
	next if (!$self->{'parentdom'} && !$t->{'for_parent'});
	next if (!$self->master_admin() && !$t->{'for_users'});
	next if ($self->{'aliasdom'} && !$t->{'for_alias'});
	$self->{'firsttemplate'} ||= $t;
# 	print "<option value=$t->{'id'}>$t->{'name'}\n";
	print "<input type=hidden name=template value=$t->{'id'}>\n";
	last;
	}
# print "</select></td> </tr>\n";
print "<tr> <td colspan=4><hr></td> </tr>\n";
print "<tr $self->{'tb'}> <td colspan=4><b>" . $self->text('form_header_owner', $self->{'t_website'}) . "</b></td> </tr>\n";

# These settings are not needed for a sub-domain, as they come from the owner
if (!$self->{'parentuser'}) {
	print "<tr> <td><b> $self->{'text_hash'}->{'form_user'}</b></td>";
# 	print "<td nowrap colspan=3><input type=radio name=user_def value=1 checked> ",
# 	      "$self->{'text_hash'}->{'form_auto'}";
# 	print "<input type=radio name=user_def value=0> $self->{'text_hash'}->{'form_nwuser'} ";
	print "<td nowrap colspan=3><input type=hidden name=user_def value=0>\n";
	print "<input name=domuser size=15></td> </tr>\n";

	print "<tr> <td><b> $self->{'text_hash'}->{'form_pass'}</b></td>";
	print "<td colspan=3>",
 		"<input type=hidden name=pass_def value=0>\n",
		$self->ui_password("dompass", undef, 15),"</td> </tr>\n";
	print "<tr> <td><b> $self->{'text_hash'}->{'form_pass_confirm'}</b></td>";
	print "<td colspan=3>",
		$self->ui_password("dompass2", undef, 15),"</td> </tr>\n";
# 	print "<td colspan=3>",
# 		&ui_radio("pass_def", 0, [ [ 1, $self->{'text_hash'}->{'form_pass1'} ],
# 					   [ 0, $self->{'text_hash'}->{'form_pass0'} ] ]),
# 		$self->ui_password("pass", undef, 15),"</td> </tr>\n";

	print "<input type=hidden name=mgroup_def value=1 checked>\n";
# 	print "<tr> <td><b>",&hlink($self->{'text_hash'}->{'form_mgroup'}, "mailgroupname"),"</b></td>";
# 	print "<td colspan=3><input type=radio name=mgroup_def value=1 checked> ",
# 	      "$self->{'text_hash'}->{'form_auto'}";
# 	print "<input type=radio name=mgroup_def value=0> $self->{'text_hash'}->{'form_nwgroup'} ",
# 	      "<input name=mgroup size=13></td> </tr>\n";

	print "<input type=hidden name=group_def value=1 checked>\n";
# 	print "<tr> <td><b>",&hlink($self->{'text_hash'}->{'form_group'}, "unixgroupname"),"</b></td>";
# 	print "<td colspan=3><input type=radio name=group_def value=1 checked> ",
# 	      "$self->{'text_hash'}->{'form_crgroup'}";
# 	print "<input type=radio name=group_def value=0> $self->{'text_hash'}->{'form_exgroup'}";
# 	print &unix_group_input("group"),"</td> </tr>\n";

	print "<tr> <td><b>$self->{'text_hash'}->{'form_email'}</b></td>";
	print "<input type=hidden name=email_def value=0>\n";
	print "<td colspan=3><input name=email size=30></td> </tr>\n";
# 	print "<tr> <td><b>", &hlink($self->{'text_hash'}->{'form_email'}, "ownersemail"), "</b></td>";
# 	print "<td colspan=3><input type=radio name=email_def value=1 checked> ",
# 	      $self->{'text_hash'}->{'form_email_def'};
# 	print "<input type=radio name=email_def value=0> $self->{'text_hash'}->{'form_email_set'}\n";
# 	print "<input name=email size=30></td> </tr>\n";
   }
elsif ($self->{'aliasdom'}) {
	# Show destination of alias
	print "<tr> <td><b> $self->{'text_hash'}->{'form_aliasdom'}</b></td>";
	print "<td><a href='edit_domain.cgi?dom=$self->{'parentdom'}->{'id'}'>$self->{'aliasdom'}->{'dom'}</a></td> </tr>\n";
	}
else {
	# Show parent domain
	print "<tr> <td><b> $self->{'text_hash'}->{'form_parentdom'}</b></td>";
	print "<td><a href='edit_domain.cgi?dom=$self->{'parentdom'}->{'id'}'>$self->{'parentdom'}->{'dom'}</a> (<tt>$self->{'parentuser'}</tt>)</td> </tr>\n";
	}

if (!$self->{'aliasdom'} && $self->max_username_length()) {
	# Show input for mail username prefix, if needed
#	print "<tr> <td><b>",&hlink($self->{'text_hash'}->{'form_prefix'}, "prefixname"),"</b></td>";
#	print "<td colspan=3><input type=radio name=prefix_def value=1 checked> ",
#	      "$self->{'text_hash'}->{'form_auto'}";
#	print "<input type=radio name=prefix_def value=0> ",
#	      "<input name=prefix size=13></td> </tr>\n";
	print "<input type=hidden name=prefix_def value=1>";
	}
else {
	print "<input type=hidden name=prefix_def value=1>\n";
	}

if (!$self->{'aliasdom'} && $self->database_feature() && !$self->{'access_hash'}->{'nodbname'}) {
	# Show database name field, iff this is not an alias domain
#	print "<tr> <td><b>",&hlink($self->{'text_hash'}->{'form_dbname'},"dbname"),"</b></td>\n";
#	print "<td colspan=3><input type=radio name=db_def value=1 checked> ",
#	      "$self->{'text_hash'}->{'form_auto'}";
#	print "<input type=radio name=db_def value=0> ",
#	      "<input name=db size=13></td> </tr>\n";
	print "<input type=hidden name=db_def value=1>";
	}

if (!$self->{'aliasdom'}) {
	# Show mail alias option, iff this is not an alias domain
	print "<input type=hidden name=mailbox value=1>\n";
#	print "<tr> <td><b>",&hlink($self->{'text_hash'}->{'form_mailbox'},"usermailbox"),"</b></td>\n";
#	print "<td><input type=radio name=mailbox value=1> $self->{'text_hash'}->{'yes'}\n";
#	print "<input type=radio name=mailbox value=0 checked> $self->{'text_hash'}->{'no'}</td></tr>\n";
	}
#print "<tr> <td colspan=4><hr></td> </tr>\n";

# Displays limits group header
if (!$self->{'parentuser'}) {
	print "<tr> <td colspan=4><hr></td> </tr>\n";
	print "<tr $self->{'tb'}> <td colspan=4><b>" . $self->text('form_header_limits', $self->{'t_website'}) . "</b></td> </tr>\n";
}

# Only display quota inputs if enabled, and if not creating a subdomain
if ($self->{'config_hash'}->{'home_quotas'} && !$self->{'parentuser'}) {
	print "<tr> <td><b> $self->{'text_hash'}->{'form_quota'}</b></td>\n";
	@{$self->{'defquota_array'}} = split (/ /,$self->{'config_hash'}->{'defquota'});
	printf "<td colspan=2><input type=radio name=quotalimit_def value=0 %s>\n",
		@{$self->{'defquota_array'}} ? "checked" : "";
	if ( !@{$self->{'defquota_array'}} or $#{$self->{'defquota_array'}} eq 0 ) {
	    print $self->quota_input("quota", $self->{'config_hash'}->{'defquota'},
				      $self->{'config_hash'}->{'home_quotas'}),"\n";
	} else {
	    print "<select name=quota>\n";
	    foreach $i (@{$self->{'defquota_array'}}) {
		chomp $i;
		print "<option value=\"$i\">$i</option>\n";
	    }
	    print "<option value=\"-1\">$self->{'text_hash'}->{'other'}</option></select>\n";
	    print $self->quota_input("otherquota", "",
			       $self->{'config_hash'}->{'home_quotas'}),"\n";
	}
	printf "<input type=radio name=quotalimit_def value=1 %s> %s</td>\n",
		@{$self->{'defquota_array'}} ? "" : "checked", $self->{'text_hash'}->{'form_unlimit'};
	print "</tr>\n";

#	print "<tr> <td><b>", &hlink($self->{'text_hash'}->{'form_uquota'}, "unixuserquota"), "</b></td>\n";
#	@defuquota = split (/ /,$self->{'config_hash'}->{'defuquota'});
#	if ( !@defuquota or $#defuquota eq 0 ) {
#	    print "<td>",$self->quota_input("uquota", $self->{'config_hash'}->{'defuquota'},
#				      $self->{'config_hash'}->{'home_quotas'}),"</td>\n";
#	} else {
#	    print "<td><select name=uquota>\n";
#	    foreach $i (@defuquota) {
#		chomp $i;
#		print "<option value=\"$i\">$i</option>\n";
#	    }
#	    print "<option value=\"-1\">$self->{'text_hash'}->{'other'}</option></select>\n";
#	    print $self->quota_input("otheruquota", "",
#			       $self->{'config_hash'}->{'home_quotas'}),"</td>\n";
#	}
#	print "</tr>\n";
}

if (!$self->{'parentdom'} && $self->{'config_hash'}->{'bw_active'}) {
	# Show bandwidth limit field
	print "<tr> <td><b> $self->{'text_hash'}->{'edit_bw'}</b></td> <td colspan=3>\n";
	print $self->bandwidth_input("bwlimit", $self->{'config_hash'}->{'defbwlimit'}*1024);
	print "</td> </tr>\n";
	}

if (!$self->{'parentuser'}) {
	# Show input for limit on number of mailboxes
	print "<tr> <td><b> $self->{'text_hash'}->{'form_mailboxlimit'}</b></td> <td colspan=2>\n";
	print $self->ui_opt_textbox("mailboxlimit", $self->{'config_hash'}->{'defmailboxlimit'}, 4,
	       $self->{'text_hash'}->{'form_unlimit'}, ""),"</td> </tr>\n";

	# And databases
	print "<tr> <td><b> $self->{'text_hash'}->{'form_dbslimit'}</b></td> <td colspan=2>\n";
	print $self->ui_opt_textbox("dbslimit", $self->{'config_hash'}->{'defdbslimit'}, 4,
		$self->{'text_hash'}->{'form_unlimit'}, ""),"</td> </tr>\n";

	# Show input for restriction of number of sub-domains this domain
	# owner can create
	local $dlm = $self->{'config_hash'}->{'defdomslimit'} eq "*" ? "" : $self->{'config_hash'}->{'defdomslimit'};
	print "<tr> <td><b> $self->{'text_hash'}->{'form_domslimit'}</b></td> <td colspan=2>\n";
	print $self->ui_opt_textbox("domslimit", $dlm, 4,
	       $self->{'text_hash'}->{'form_unlimit'}, ""),"</td> </tr>\n";

	# Show input for default database name limit
	print "<input type=hidden name=nodbname value=0>\n";
#	print "<tr> <td><b>$self->{'text_hash'}->{'limits_nodbname'}</b></td>\n";
#	print "<td>",&ui_radio("nodbname", $self->{'config_hash'}->{'defnodbname'} ? 1 : 0,
#	       [ [ 0, $self->{'text_hash'}->{'yes'} ], [ 1, $self->{'text_hash'}->{'no'} ] ]),"</td> </tr>\n";
	}

# Show section for custom fields, if any
#$fields = &show_custom_fields();
#if ($fields) {
#	print "<tr> <td colspan=4><hr></td> </tr>\n";
#	print $fields;
#	}

# Show radio buttons for features
#print "<tr> <td colspan=4><hr></td> </tr>\n";
$i = 0;
foreach $f ($self->{'aliasdom'} ? @{$self->{'opt_alias_features_array'}} : @{$self->{'opt_features_array'}}) {
	# Don't allow access to features that this user hasn't been
	# granted for his subdomains.
	next if ($self->{'access_hash'}->{'create'} == 2 &&
		 $self->{'parentdom'} && !$self->{'access_hash'}->{"feature_$f"});
	next if ($self->{'parentdom'} && $f eq "webmin");
	next if ($self->{'parentdom'} && $f eq "unix");
	next if ($self->{'aliasdom'} && !$self->{'aliasdom'}->{$f});
	$self->{'can_feature_hash'}->{$f}++;

        if ($self->{'config_hash'}->{$f} == 3) {
                # This feature is always on, so don't show it
                print $self->ui_hidden($f, 1),"\n";
                next;
                }

	if ($self->{'config_hash'}->{$f} || !defined($self->{'config_hash'}->{$f})) {
		printf "<input type=hidden name=%s value=%d>\n", $f, $self->{'config_hash'}->{$f} == 2 ? 0: 1 ;
		}
	}

# Show radio buttons for plugins
foreach $f (@{$self->{'feature_plugins_array'}}) {
	next if (!$self->plugin_call($f, "feature_suitable",
				$self->{'parentdom'}, $self->{'aliasdom'}));
	next if ($self->{'access_hash'}->{'create'} == 2 &&
		 $self->{'parentdom'} && !$self->{'access_hash'}->{"feature_$f"});
	next if ($self->{'aliasdom'} && !$self->{'aliasdom'}->{$f});

print "<input type=hidden name=%s value=1 %f>\n";
#	print "<tr>\n" if ($i%2 == 0);
#	$label = $self->plugin_call($f, "feature_label", 0);
#	print "<td><b>$label</b></td>\n";
#	print "<td nowrap>\n";
#	printf "<input type=radio name=%s value=1 %s> %s\n",
#		$f, "checked", $self->{'text_hash'}->{'yes'};
#	printf "<input type=radio name=%s value=0 %s> %s\n",
#		$f, "", $self->{'text_hash'}->{'no'};
#	print "</td>\n";
#	print "</tr>\n" if ($i++%2 == 1);
	}

# Show inputs for setting up a proxy-only virtual server
#if ($self->{'config_hash'}->{'proxy_pass'} && !$self->{'aliasdom'}) {
#	print &frame_fwd_input();
#	}

# Show field for mail forwarding
#if ($self->{'can_feature_hash'}->{'mail'} && !$self->{'aliasdom'}) {
#	print "<tr> <td><b>",&hlink($self->{'text_hash'}->{'form_fwdto'}, "fwdto"),"</b></td>\n";
#	print "<td colspan=3>",$self->ui_opt_textbox("fwdto", undef, 30, $self->{'text_hash'}->{'form_fwdto_none'}),"</td> </tr>\n";
#	}
print "<tr> <td colspan=4><hr></td> </tr>\n";

# Show IP address allocation section
if (!$self->{'aliasdom'} && ($self->{'access_hash'}->{'create'} != 2 || $self->{'access_hash'}->{"feature_virt"})) {
	print "<tr $self->{'tb'}> <td colspan=4><b>" . $self->text('form_header_net', $self->{'t_website'}) . "</b></td> </tr>\n";
	$self->foreign_require("net", "net-lib.pl");
	local @ifaces = grep { $_->{'name'} !~ /^lo\d*/ } $main::net_object->active_interfaces();
	local ($iface) = grep { $_->{'fullname'} eq $self->{'config_hash'}->{'iface'} } @ifaces;
	$self->{'defip'} = $self->{'parentdom'}->{'ip'} ? $self->{'parentdom'}->{'ip'} : $self->get_default_ip();
	$self->{'defip'} || $self->error($self->{'text_hash'}->{'index_eiface2'});
	$self->{'defbcast'} = $main::net_object->{'virtual_netmask'} eq "255.255.255.255" ? '' : $iface->{'broadcast'};
	$self->{'defmask'} = $main::net_object->{'virtual_netmask'} || $iface->{'netmask'};
	$self->{'device'} = $iface->{'name'};
	# create available IP list
	local $input_ips;
	if (scalar(@ifaces) <= 1) {
		$input_ips = $self->{'defip'};
		$input_ips .= "<input type=hidden name=ip_shared value=\"$self->{'defip'}\">\n";
		$input_ips .= "<input type=hidden name=def_netmask value=\"$self->{'defmask'}\">\n";
	} else {
		$input_ips = "<select name=ip_shared>\n";
		foreach  (@ifaces) {
			$input_ips .= sprintf "<option value=\"$_->{address}\" %s>$_->{address}\n", $_->{'address'} eq $self->{'defip'} ? "selected" : "";
		}
		$input_ips .= "</select>\n";
	}

	print "<tr> <td><b> $self->{'text_hash'}->{'form_iface'}</b></td>\n";
	if ($self->{'config_hash'}->{'all_namevirtual'}) {
		print "<td colspan=3>$self->{'text_hash'}->{'form_ip'}&nbsp;$input_ips",
		      "</td> </tr>\n";
		}
	else {
		print "<td colspan=3>\n";
		print "<input type=radio name=virt value=0 checked> ", $self->text('form_shared', $input_ips),"\n";
		print "</td></tr>\n";

		if ($self->{'config_hash'}->{'ip_ranges'}) {
			# Can do automatic allocation
			print "<tr><td>&nbsp;</td><td colspan=3\n";
			local $alloc = $self->free_ip_address();
			if ($alloc) {
				print "<input type=radio name=virt value=1> ",
				      $self->text('form_alloc', $alloc);
				}
			else {
				# None left!
				print $self->{'text_hash'}->{'form_noalloc'};
				}
			}
		else {
			# Ask the user to enter
			print "<tr><td>&nbsp;</td><td valign=top>\n";
			print "<input type=radio name=virt value=1> ", "$self->{'text_hash'}->{'form_vip'}\n";
			print "</td><td colspan=2>";
			print "<table border=0 cellspacing=0 cellpadding=0>";
			print "<tr><td>$self->{'text_hash'}->{'form_ip'}&nbsp;</td><td><input name=ip size=20 value=''></td></tr>\n";
			print "<tr><td>$self->{'text_hash'}->{'form_netmask'} &nbsp; </td><td><input type=radio name=automask checked value=0> $self->{'text_hash'}->{form_automatic} <input type=radio name=automask value=1> <input name=netmask size=20 value=''></td></tr>\n";
			print "<tr><td>$self->{'text_hash'}->{'form_device'}</td><td>";
			local @devices = map {$_->{'name'}} @ifaces;
			@devices = $self->unique(@devices);
			print "<select name=iface>\n";
			foreach  (@devices) {
				printf "<option value='$_'>$_\n";
			}
			print "</select>\n";
			print "</td></tr>\n";
			print "</table>";
# 			print "<input name=ip size=20>\n";
			}
		print "</td> </tr>\n";
		}
	print "<tr colspan=4><td>&nbsp;</td></tr>";
	}

print "</table></td></tr></table>\n";
print "<input type=submit value='" . $self->text('form_ok', $self->{'t_website'}) . "'></form>\n";
# print "<script>select_template($self->{'firsttemplate'}->{'id'});</script>\n";

$self->ui_print_footer($self->{'text_hash'}->{'index_mainpage_url'}, $self->{'text_hash'}->{'index_mainpage'}, "", $self->text('index_return', $self->{'t_websites'}));

1;
		
}


1;

