#!/usr/bin/perl

&MAIN();

 sub MAIN {
# domain_setup.cgi
# Create a new virtual domain

&ModuleLoader::preload_module('virtual_server_class', "virtual_server::VirtualserverLib");
$self = new virtual_server::VirtualserverLib:: 'virtual_server_class',%$self;

$self->{'access_hash'}->{'create'} || $self->error($self->{'text_hash'}->{'form_ecannot'});
$self->require_bind() if ($self->{'config_hash'}->{'dns'});
$self->require_useradmin();
$self->require_mail() if ($self->{'config_hash'}->{'mail'});
$self->require_mysql() if ($self->{'config_hash'}->{'mysql'});
$self->require_postgres() if ($self->{'config_hash'}->{'postgres'});
$self->require_acl();
$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'setup_err'});

$self->{'in_hash'}->{'ip'} = $self->{'in_hash'}->{'ip_shared'} if $self->{'config_hash'}->{'all_namevirtual'};
$self->{'in_hash'}->{'domslimit_def'} = $self->{'in_hash'}->{'domslimit_def'} ? 2 : 0;
$self->{'in_hash'}->{'mailbox'} = 0 unless $self->{'in_hash'}->{'mail'}; # do not create mail alias if mail feature is disabled 

# Get parent settings
if ($self->{'in_hash'}->{'to'}) {
	$self->{'aliasdom'} = $self->get_domain($self->{'in_hash'}->{'to'});
	$self->{'aliasdom'} || $self->error($self->{'text_hash'}->{'form_ealiasdom'});
	$self->{'parentdom'} = $self->{'aliasdom'}->{'parent'} ?
		$self->get_domain($self->{'aliasdom'}->{'parent'}) : $self->{'aliasdom'};
	$self->{'parentuser'} = $self->{'parentdom'}->{'user'};
	$self->can_edit_domain($self->{'aliasdom'}) || $self->error($self->{'text_hash'}->{'form_ecannot'});
	}
elsif ($self->{'access_hash'}->{'create'} == 2) {
	$self->{'parentuser'} = $self->{'remote_user'};
	}
elsif ($self->{'in_hash'}->{'parentuser'}) {
	$self->{'parentuser'} = $self->{'in_hash'}->{'parentuser'};
	}
if ($self->{'parentuser'} && !$self->{'parentdom'}) {
	$self->{'parentdom'} = $self->get_domain_by("user", $self->{'parentuser'}, "parent", "");
	$self->{'parentdom'} || $self->error($self->text('form_eparent', $self->{'parentuser'}));
	}

# Check if domains limit has been exceeded
if ($self->{'parentdom'}) {
	($self->{'dcount'}, $self->{'dmax'}) = $self->count_domains($self->{'parentdom'});
	$self->error($self->text('setup_emaxnone')) if (!$self->{'dmax'});
	$self->error($self->text('setup_emax', $self->{'dmax'})) if ($self->{'dcount'} > $self->{'dmax'});
	}

# Validate inputs (check domain name to see if in use)
$self->{'in_hash'}->{'dom'} =~ /^[A-Za-z0-9\.\-]+$/ || $self->error($self->{'text_hash'}->{'setup_edomain'});
$self->{'in_hash'}->{'dom'} = lc($self->{'in_hash'}->{'dom'});
$self->{'in_hash'}->{'dom'} = $self->{'parentdom'} && !$self->{'aliasdom'} ? "$self->{'in_hash'}->{'dom'}.$self->{'parentdom'}->{'dom'}" : $self->{'in_hash'}->{'dom'};
$self->{'in_hash'}->{'owner'} =~ s/\r|\n//g;
$self->{'in_hash'}->{'owner'} =~ /:/ && $self->error($self->{'text_hash'}->{'setup_eowner'});
foreach $d ($self->list_domains()) {
	$self->error($self->{'text_hash'}->{'setup_edomain2'}) if (lc($d->{'dom'}) eq lc($self->{'in_hash'}->{'dom'}));
	}
$self->{'tmpl'} = $self->get_template($self->{'in_hash'}->{'template'});
if (!$self->{'parentuser'}) {
	# Validate user and password-related inputs for top-level domain
	$self->{'in_hash'}->{'email_def'} || $self->{'in_hash'}->{'email'} =~ /\S/ ||
		$self->error($self->{'text_hash'}->{'setup_eemail'});
	if (!$self->{'in_hash'}->{'unix'}) {
		$self->{'tmpl'}->{'mail_on'} eq "none" || !$self->{'in_hash'}->{'email_def'} ||
			$self->error($self->{'text_hash'}->{'setup_eemail2'});
		}
	if ($self->{'in_hash'}->{'unix'} || $self->{'in_hash'}->{'webmin'}) {
		if ($self->{'in_hash'}->{'pass_def'}) {
			$self->{'pass'} = $self->random_password();
			}
		else {
			$self->{'in_hash'}->{'dompass'} =~ /\S/ || $self->error($self->{'text_hash'}->{'setup_epass'});
			$self->{'pass'} = $self->{'in_hash'}->{'dompass'};
			$self->{'in_hash'}->{'dompass'} == $self->{'in_hash'}->{'dompass2'} || $self->error($self->{'text_hash'}->{'setup_epassconfirm'});
			}
		}
	if ($self->{'in_hash'}->{'user_def'}) {
		($self->{'user'}, $self->{'try1'}, $self->{'try2'}) = $self->unixuser_name($self->{'in_hash'}->{'dom'});
		$self->{'user'} || $self->error($self->text('setup_eauto', $self->{'try1'}, $self->{'try2'}));
		}
	else {
		$self->{'in_hash'}->{'domuser'} = lc($self->{'in_hash'}->{'domuser'});
		$self->{'user'} = $self->{'in_hash'}->{'domuser'};
		$self->{'user'} =~ /^[^\t :]+$/ || $self->error($self->{'text_hash'}->{'setup_euser2'});
		defined(getpwnam($self->{'user'})) && $self->error($self->{'text_hash'}->{'setup_euser'});
		}
	if ($self->{'in_hash'}->{'mgroup_def'}) {
		$self->{'in_hash'}->{'dom'} =~ /^([^\.]+)/;
		$self->{'group'} = $self->{'config_hash'}->{'longname'} ? $self->{'in_hash'}->{'dom'} : $1;
		}
	else {
		$self->{'in_hash'}->{'mgroup'} = lc($self->{'in_hash'}->{'mgroup'});
		$self->{'group'} = $self->{'in_hash'}->{'mgroup'};
		$self->{'group'} =~ /^[^\t :]+$/ || $self->error($self->{'text_hash'}->{'setup_egroup2'});
		}
	if (!$self->{'in_hash'}->{'group_def'}) {
		$self->{'in_hash'}->{'group'} = lc($self->{'in_hash'}->{'group'});
		$self->{'in_hash'}->{'group'} eq $self->{'group'} && $self->error($self->text('setup_egroup3', $self->{'group'}));
		local ($sg) = $self->get_domain_by("group", $self->{'in_hash'}->{'group'});
		$sg && $self->error($self->text('setup_egroup4', $sg->{'dom'}));
		}
	$self->{'home_base'} || $self->error($self->{'text_hash'}->{'setup_ehomebase'});
	$self->{'uerr'} = $main::useradmin_object->check_username_restrictions($self->{'user'});
	if ($self->{'uerr'}) {
		$self->error($self->text('setup_eusername', $self->{'user'}, $self->{'uerr'}));
		}
	if ($self->{'config_hash'}->{'home_quotas'} && $self->{'in_hash'}->{'quotalimit_def'} == 0) {
		if ($self->{'in_hash'}->{'quota'} == -1) { $self->{'in_hash'}->{'quota'} = $self->{'in_hash'}->{'otherquota'} };
		if ($self->{'in_hash'}->{'uquota'} == -1) { $self->{'in_hash'}->{'uquota'} = $self->{'in_hash'}->{'otheruquota'} }; 
		$self->{'in_hash'}->{'quota'} =~ /^\d+(\.\d*)?$/ ||  $self->error($self->{'text_hash'}->{'setup_equota'});
		$self->{'in_hash'}->{'uquota'} = $self->{'in_hash'}->{'quota'};
		#$self->{'in_hash'}->{'uquota'} =~ /^\d+$/ ||  $self->error($self->{'text_hash'}->{'setup_euquota'});
		}
	$self->{'in_hash'}->{'mailboxlimit_def'} || $self->{'in_hash'}->{'mailboxlimit'} =~ /^\d+$/ ||
		$self->error($self->{'text_hash'}->{'setup_emailboxlimit'});
	$self->{'in_hash'}->{'dbslimit_def'} || $self->{'in_hash'}->{'dbslimit'} =~ /^\d+$/ ||
		$self->error($self->{'text_hash'}->{'setup_edbslimit'});
	if ($self->{'config_hash'}->{'bw_active'}) {
		$self->{'bw'} = $self->parse_bandwidth("bwlimit", $self->{'text_hash'}->{'setup_ebwlimit'});
		}
	$self->{'in_hash'}->{'domslimit_def'} || $self->{'in_hash'}->{'domslimit'} =~ /^\d+$/ ||
		$self->error($self->{'text_hash'}->{'setup_edomslimit'});
	}
if (!$self->{'aliasdom'}) {
	# Validate non-alias domain inputs
	$self->{'in_hash'}->{'mailbox'} && !$self->{'in_hash'}->{'mail'} && $self->error($self->{'text_hash'}->{'setup_emailbox'});
	if ($self->{'config_hash'}->{'proxy_pass'} && $self->{'in_hash'}->{'web'} && !$self->{'in_hash'}->{'proxy_def'}) {
		($self->{'proxy'} = $self->{'in_hash'}->{'proxy'}) =~ /^(http|https):\/\/\S+$/ ||
			$self->error($self->{'text_hash'}->{'setup_eproxy'});
		}
	if (!$self->{'in_hash'}->{'prefix_def'}) {
		$self->{'in_hash'}->{'prefix'} =~ /^[a-z0-9\.\-]+$/i ||
			$self->error($self->{'text_hash'}->{'setup_eprefix'});
		$self->{'pclash'} = $self->get_domain_by("prefix", $self->{'in_hash'}->{'prefix'});
		$self->{'pclash'} && $self->error($self->{'text_hash'}->{'setup_eprefix2'});
		}
	if ($self->database_feature() && !$self->{'access_hash'}->{'nodbname'} && !$self->{'in_hash'}->{'db_def'}) {
		$self->{'in_hash'}->{'db'} =~ /^[a-z0-9\-\_]+$/i ||
			$self->error($self->{'text_hash'}->{'setup_edbname'});
		}
	if (defined($self->{'in_hash'}->{'fwdto'}) && !$self->{'in_hash'}->{'fwdto_def'}) {
		$self->{'in_hash'}->{'mail'} ||
			$self->error($self->{'text_hash'}->{'setup_efwdtomail'});
		$self->{'in_hash'}->{'fwdto'} =~ /^\S+\@\S+$/ ||
			$self->error($self->{'text_hash'}->{'setup_efwdto'});
		$self->{'fwdto'} = { 'from' => "\@$self->{'in_hash'}->{'dom'}",
			   'to' => [ $self->{'in_hash'}->{'fwdto'} ] };
		}
	}

if (!$self->{'aliasdom'}) {
	$self->{'defip'} = $self->{'parentdom'} ? $self->{'parentdom'}->{'ip'} : $self->{'in_hash'}->{'ip_shared'}; #&get_default_ip();
	if ($self->{'config_hash'}->{'all_namevirtual'}) {
		# Make sure the IP *is* assigned
		$self->check_ipaddress($self->{'in_hash'}->{'ip'}) || $self->error($self->{'text_hash'}->{'setup_eip'});
		if (!$self->check_virt_clash($self->{'in_hash'}->{'ip'})) {
			$self->error($self->text('setup_evirtclash2'));
			}
		}
	elsif ($self->{'in_hash'}->{'virt'}) {
		if ($self->{'config_hash'}->{'ip_ranges'}) {
			# Allocate the IP now
			$self->{'in_hash'}->{'ip'} = $self->free_ip_address();
			$self->{'in_hash'}->{'ip'} || $self->text('setup_evirtalloc');
			}
		else {
			# Make sure the IP isn't assigned yet
			$self->check_ipaddress($self->{'in_hash'}->{'ip'}) || $self->error($self->{'text_hash'}->{'setup_eip'});
			if ($self->check_virt_clash($self->{'in_hash'}->{'ip'})) {
				$self->error($self->text('setup_evirtclash'));
				}
			}
		}
	}

if ($self->{'parentdom'}) {
	# Make sure domain is under parent
	local $derr = $self->valid_domain_name($self->{'parentdom'}, $self->{'in_hash'}->{'dom'});
	$self->error($derr) if ($derr);
	}

if ($self->{'parentuser'}) {
	# User and group IDs come from parent
	$self->{'gid'} = $self->{'parentdom'}->{'gid'};
	$self->{'ugid'} = $self->{'parentdom'}->{'ugid'};
	$self->{'user'} = $self->{'parentdom'}->{'user'};
	$self->{'group'} = $self->{'parentdom'}->{'group'};
	$self->{'uid'} = $self->{'parentdom'}->{'uid'};
	if ($self->{'in_hash'}->{'prefix_def'}) {
		if (1 || $self->{'config_hash'}->{'longname'}) {
			$self->{'prefix'} = $self->{'in_hash'}->{'dom'};
			}
		else {
			$self->{'in_hash'}->{'dom'} =~ /^([^\.]+)/;
			$self->{'prefix'} = $1;
			}
		}
	else {
		$self->{'prefix'} = $self->{'in_hash'}->{'prefix'};
		}
	}
else {
	# Work out user and group IDs
	$self->build_group_taken(\%{$self->{'gtaken_hash'}}, \%{$self->{'ggtaken_hash'}});
	$self->{'gid'} = $self->allocate_gid(\%{$self->{'gtaken_hash'}});
	$self->{'ugid'} = $self->{'in_hash'}->{'group_def'} ? $self->{'gid'} : getgrnam($self->{'in_hash'}->{'group'});
	$self->{'ugroup'} = $self->{'in_hash'}->{'group_def'} ? $self->{'group'} : $self->{'in_hash'}->{'group'};
	$self->build_taken(\%{$self->{'taken_hash'}}, \%{$self->{'utaken_hash'}});
	$self->{'uid'} = $self->allocate_uid(\%{$self->{'taken_hash'}});
	$self->{'prefix'} = $self->{'in_hash'}->{'prefix_def'} ? $self->{'in_hash'}->{'dom'} : $self->{'in_hash'}->{'prefix'};
	}

# Build up domain object
%{$self->{'dom_hash'}} = ( 'id', $self->domain_id(),
	 'dom', $self->{'in_hash'}->{'dom'},
	 'user', $self->{'user'},
	 'group', $self->{'group'},
	 'prefix', $self->{'prefix'},
	 'ugroup', $self->{'ugroup'},
	 $self->{'parentuser'} ?
		( 'pass', $self->{'parentdom'}->{'pass'} ) :
	 	( 'quota', $self->quota_parse('quota', $self->{'config_hash'}->{'home_quotas'}),
	 	  'uquota', $self->quota_parse('uquota', $self->{'config_hash'}->{'home_quotas'}),
		  'pass', $self->{'pass'} ),
	 'alias', $self->{'aliasdom'} ? $self->{'aliasdom'}->{'id'} : undef,
	 'uid', $self->{'uid'},
	 'gid', $self->{'gid'},
	 'ugid', $self->{'ugid'},
	 'owner', $self->{'in_hash'}->{'owner'},
	 'email', $self->{'parentdom'} ? $self->{'parentdom'}->{'email'} :
		  !$self->{'in_hash'}->{'email_def'} ? $self->{'in_hash'}->{'email'} :
		  $self->{'in_hash'}->{'mailbox'} ? $self->{'user'}."\@".$self->{'in_hash'}->{'dom'} :
				   undef,
#	 'name', $self->{'config_hash'}->{'all_namevirtual'} ? 1 : $self->{'in_hash'}->{'virt'} ? 0 : 1,
	 'name', $self->{'config_hash'}->{'all_namevirtual'} ? 1 : 0,
	 'ip', $self->{'aliasdom'} ? $self->{'aliasdom'}->{'ip'} :
	       $self->{'config_hash'}->{'all_namevirtual'} ? $self->{'in_hash'}->{'ip'} :
	       $self->{'in_hash'}->{'virt'} ? $self->{'in_hash'}->{'ip'} : $self->{'defip'},
	 'iface', $self->{'in_hash'}->{'iface'},
	 'dns_ip', $self->{'in_hash'}->{'virt'} || $self->{'config_hash'}->{'all_namevirtual'} ? undef :
		   $self->{'config_hash'}->{'dns_ip'},
	 'virt', $self->{'config_hash'}->{'all_namevirtual'} ? 0 : $self->{'in_hash'}->{'virt'},
	 'source', 'domain_setup.cgi',
	 'proxy_pass', $self->{'proxy'},
	 'proxy_pass_mode', $self->{'proxy'} ? $self->{'config_hash'}->{'proxy_pass'} : 0,
	 $self->{'parentuser'} ? ( ) :
		( 'mailboxlimit',
		  $self->{'in_hash'}->{'mailboxlimit_def'} ? undef : $self->{'in_hash'}->{'mailboxlimit'},
		  'dbslimit',
		  $self->{'in_hash'}->{'dbslimit_def'} ? undef : $self->{'in_hash'}->{'dbslimit'},
		  'bw_limit', $self->{'bw'},
		  'domslimit',
		  $self->{'in_hash'}->{'domslimit_def'} == 1 ? undef :
		  $self->{'in_hash'}->{'domslimit_def'} == 2 ? "*" : $self->{'in_hash'}->{'domslimit'},
		  'nodbname', $self->{'in_hash'}->{'nodbname'},
		),
	 'parent', $self->{'parentdom'} ? $self->{'parentdom'}->{'id'} : "",
	 'template', $self->{'in_hash'}->{'template'},
	);
$self->{'dom_hash'}->{'db'} = $self->{'in_hash'}->{'db_def'} || !$self->database_feature() || $self->{'access_hash'}->{'nodbname'} ?
		$self->database_name(\%{$self->{'dom_hash'}}) : $self->{'in_hash'}->{'db'};
local $f;
foreach $f (@{$self->{'features_array'}}, @{$self->{'feature_plugins_array'}}) {
	$self->{'dom_hash'}->{$f} = $self->{'in_hash'}->{$f};
	$self->{'dom_hash'}->{"limit_$f"} = $f eq "webmin" ? 0 : $self->{'in_hash'}->{$f};
	}
$self->{'dom_hash'}->{'home'} = $self->server_home_directory(\%{$self->{'dom_hash'}}, $self->{'parentdom'});

$self->foreign_require('net', 'net-lib.pl');
local @ifaces = grep { $_->{'name'} !~ /^lo\d*/ } $main::net_object->active_interfaces();
local ($iface) = grep { $_->{'fullname'} eq $self->{'dom_hash'}->{'iface'} } @ifaces;

$self->{'dom_hash'}->{'netmask'} = $self->{'in_hash'}->{'netmask'} ? $self->{'in_hash'}->{'netmask'} : $iface->{'netmask'};
$self->{'dom_hash'}->{'bcast'} = $main::net_object->compute_broadcast($self->{'dom_hash'}->{'ip'}, $self->{'dom_hash'}->{'netmask'});

# Check for various clashes
$derr = $self->virtual_server_depends(\%{$self->{'dom_hash'}});
$self->error($derr) if ($derr);
$self->{'cerr'} = $self->virtual_server_clashes(\%{$self->{'dom_hash'}});
$self->error($self->{'cerr'}) if ($self->{'cerr'});

# Update custom fields
$self->parse_custom_fields(\%{$self->{'dom_hash'}}, \%{$self->{'in_hash'}});

$self->ui_print_unbuffered_header($self->domain_in(\%{$self->{'dom_hash'}}), 
	$self->text('setup_title', $self->{'t_website'}), "", undef, undef, 1);

$self->{'err'} = $self->create_virtual_server(\%{$self->{'dom_hash'}}, $self->{'parentdom'}, $self->{'parentuser'});
$self->error($self->{'err'}) if ($self->{'err'});

if ($self->{'fwdto'}) {
	do { my $fn = $self->{'first_print'}; $self->$fn($self->text('setup_fwding', $self->{'in_hash'}->{'fwdto'}))};
	$self->create_virtuser($self->{'fwdto'});
	do { my $fn = $self->{'second_print'}; $self->$fn($self->{'text_hash'}->{'setup_done'})};
	}

$self->webmin_log("create", "domain", $self->{'dom_hash'}->{'dom'}, \%{$self->{'dom_hash'}});

$self->ui_print_footer($self->{'text_hash'}->{'index_mainpage_url'}, $self->{'text_hash'}->{'index_mainpage'}, "", $self->text('index_return', $self->{'t_websites'}));

1;
		
}


1;

