#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_domain.cgi
# Display details of a domain for editing

&ModuleLoader::preload_module('virtual_server_class', "virtual_server::VirtualserverLib");
$self = new virtual_server::VirtualserverLib:: 'virtual_server_class',%$self;

use POSIX;
$self->ReadParse();
$self->{'d'} = $self->get_domain($self->{'in_hash'}->{'dom'});
$self->{'access_hash'}->{'edit'} && $self->can_edit_domain($self->{'d'}) || $self->error($self->{'text_hash'}->{'edit_ecannot'});
if ($self->{'d'}->{'parent'}) {
	$self->{'parentdom'} = $self->get_domain($self->{'d'}->{'parent'});
	}
if ($self->{'d'}->{'alias'}) {
	$self->{'aliasdom'} = $self->get_domain($self->{'d'}->{'alias'});
	}
$self->ui_print_header($self->domain_in($self->{'d'}), $self->text('edit_title', $self->{'t_website'}), "", undef, undef, 1);

print "<form action=save_domain.cgi method=post>\n";
print "<input type=hidden name=dom value='$self->{'in_hash'}->{'dom'}'>\n";
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>" . $self->text('edit_header', $self->{'t_website'}) . "</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'edit_domain'}</b></td>\n";
print "<td><tt>$self->{'d'}->{'dom'}</tt></td>\n";

# Show description
print "<tr> <td><b>$self->{'text_hash'}->{'edit_owner'}</b></td>\n";
print "<td colspan=3><input name=owner size=50 value='",
	$self->html_escape($self->{'d'}->{'owner'}),"'></td> </tr>\n";

print "<tr> <td colspan=4><hr></td></tr>\n";
print "<tr $self->{'tb'}> <td colspan=4><b>" . $self->text('edit_header_owner', $self->{'t_website'}) . "</b></td> </tr>\n";

print "<td><b>$self->{'text_hash'}->{'edit_user'}</b></td>\n";
print "<td><tt>$self->{'d'}->{'user'}</tt></td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'edit_group'}</b></td>\n";
if ($self->{'d'}->{'unix'} && $self->{'d'}->{'group'}) {
	print "<td><tt>$self->{'d'}->{'group'}</tt></td>\n";
	}
else {
	print "<td>$self->{'text_hash'}->{'edit_nogroup'}</td>\n";
	}
if ($self->{'aliasdom'}) {
	# Show link to aliased domain
	print "<tr> <td><b>" . $self->text('edit_aliasto', $self->{'t_website'}) . "</b></td>\n";
	print "<td colspan=3><a href='edit_domain.cgi?dom=$self->{'d'}->{'alias'}'>",
	      "$self->{'aliasdom'}->{'dom'}</a></td> </tr>\n";
	}
elsif (!$self->{'parentdom'}) {
	# Show owner's email address and password
	print "<tr> <td><b>$self->{'text_hash'}->{'edit_pass'}</b></td> <td colspan=3>\n";
	print "<input type=radio name=passwd_def value=1 checked> $self->{'text_hash'}->{'edit_lv'}</td> </tr>\n";
	print "<tr> <td>&nbsp;</td> <td colspan=3>\n";
	print "<input type=radio name=passwd_def value=0> $self->{'text_hash'}->{'edit_set'}\n";
	print "<input type=password name=passwd size=20>\n";
	print "&nbsp;$self->{'text_hash'}->{'edit_pass_confirm'}&nbsp;<input type=password name=passwd2 size=20></td> </tr>\n";
	
	print "<tr> <td><b>$self->{'text_hash'}->{'edit_email'}</b></td> <td colspan=3>\n";
	if ($self->{'d'}->{'unix'}) {
		print "<input type=hidden name=email_def value=0>\n";
# 		printf "<input type=radio name=email_def value=1 %s> %s\n",
# 			$self->{'d'}->{'email'} ? "" : "checked", $self->{'text_hash'}->{'edit_email_def'};
# 		printf "<input type=radio name=email_def value=0 %s>\n",
# 			$self->{'d'}->{'email'} ? "checked" : "";
		}
	print "<input name=email size=50 value='",
		$self->html_escape($self->{'d'}->{'email'}),"'></td> </tr>\n";
	}
else {
	# Show link to parent domain
	print "<tr> <td><b>" . $self->text('edit_parent', $self->{'t_website'}) . "</b></td>\n";
	print "<td colspan=3><a href='edit_domain.cgi?dom=$self->{'d'}->{'parent'}'>",
	      "$self->{'parentdom'}->{'dom'}</a></td> </tr>\n";
	}

if (!$self->{'aliasdom'} && $self->{'d'}->{'unix'}) {
	# Show home directory
	print "<tr> <td><b>$self->{'text_hash'}->{'edit_home'}</b></td>\n";
	print "<td colspan=3><tt>$self->{'d'}->{'home'}</tt></td> </tr>\n";
	}

print "<tr> <td colspan=4><hr></td></tr>\n";

if (!$self->{'aliasdom'}) {
	# Only show database name for non-alias domains
	print "<tr $self->{'tb'}> <td colspan=4><b>$self->{'text_hash'}->{'edit_header_dbs'}</b></td> </tr>\n";
	print "<td><b>$self->{'text_hash'}->{'edit_dbs'}</b></td>\n";
	local @dbs = $self->domain_databases($self->{'d'});
	if (@dbs > 0) {
		local %tcount;
		foreach my $db (@dbs) {
			$tcount{$db->{'desc'}}++;
			}
		print "<td>",join(", ", map { "$tcount{$_} $_" } (keys %tcount)),"</td>\n";
		}
	else {
		print "<td>$self->{'text_hash'}->{'edit_nodbs'}</td> </tr>\n";
		}
	print "<tr> <td colspan=4><hr></td></tr>\n";
	}
#else {
#	print "</tr>\n";
#	}

if (!$self->{'aliasdom'}) {
	# Show IP-related options
	$self->foreign_require("net", "net-lib.pl");
	local @ifaces = grep { $_->{'name'} !~ /^lo\d*/ } $main::net_object->active_interfaces();
	local ($iface) = grep { $_->{'fullname'} eq $self->{'config_hash'}->{'iface'} } @ifaces;
	$self->{'defip'} = $self->{'d'}->{'ip'} ? $self->{'d'}->{'ip'} : $self->get_default_ip();
	$self->{'defbcast'} = $main::net_object->{'virtual_netmask'} eq "255.255.255.255" ? '' : $iface->{'broadcast'};
	$self->{'defmask'} = $main::net_object->{'virtual_netmask'} || $iface->{'netmask'};
	$self->{'device'} = $iface->{'name'};
	# create available IP list
	local $input_ips;
	if (scalar(@ifaces) <= 1) {
		$input_ips = $self->{'defip'};
		$input_ips .= "<input type=hidden name=ip_shared value=\"$self->{'defip'}\">\n";
		#$input_ips .= "<input type=hidden name=netmask size=20 value=\"$self->{'defmask'}\">\n";
	} else {
		$input_ips = "<select name=ip_shared>\n";
		foreach  (@ifaces) {
			$input_ips .= sprintf "<option value=\"$_->{address}\" %s>$_->{address}\n", $_->{'address'} eq $self->{'defip'} ? "selected" : "";
		}
		$input_ips .= "</select>\n";
	}

	print "<tr $self->{'tb'}> <td colspan=4><b>" . $self->text('edit_header_net', $self->{'t_website'}) . "</b></td> </tr>\n";
	print "<tr> <td><b>$self->{'text_hash'}->{'edit_ip'}</b></td>\n";
# 	print "<td colspan=3><tt>$self->{'d'}->{'ip'}</tt>\n";
# 	print "<tt>$self->{'d'}->{'ip'} &nbsp; [ $self->{'d'}->{'netmask'} ]</tt>";
# 	print $self->{'d'}->{'virt'} ? "&nbsp;<tt>[&nbsp;$self->{'d'}->{'netmask'}&nbsp;]</tt>" : $self->{'text_hash'}->{'edit_shared'};
# 	print "</td> </tr>\n";

#	print "<tr> <td><b>$self->{'text_hash'}->{'edit_virt'}</b></td>\n";
#	print "<td colspan=3>\n";
	if ($self->{'d'}->{'virt'}) {
		# Got a virtual IP
#		$iface = &get_address_iface($self->{'d'}->{'ip'});
#		print "<tt>$iface</tt>\n";
		print "<td colspan=3>\n";
		printf "<tt>$self->{'d'}->{'ip'} %s</tt></td></tr>", $self->{'d'}->{'netmask'} ? "[ $self->{'d'}->{'netmask'} ]" : '';
		print "<tr> <td><b>&nbsp;</b></td>\n";
		print "<td colspan=3><tt>$self->{'d'}->{'iface'}</tt>\n";
		print "<input type=hidden name=virt value=1>\n";
		}
	elsif ($self->{'config_hash'}->{'all_namevirtual'}) {
		# Always name-based, but IP can be changed
#		print "<input name=ip size=15 value='$self->{'d'}->{'ip'}'>\n";
		print "<td colspan=3>$input_ips\n";
		}
	elsif ($self->{'access_hash'}->{'edit'} == 2 && !$self->{'access_hash'}->{'feature_virt'}) {
		# Not allowed to add virtual IP
		print "<td colspan=3>";
		printf "<tt>$self->{'d'}->{'ip'} %s</tt></td></tr>", $self->{'d'}->{'netmask'} ? "[ $self->{'d'}->{'netmask'} ]" : '';
# 		print "<td colspan=3>$self->{'text_hash'}->{'edit_virtnone'}\n";
		}
	else {
		# Show option to add
		print "<td colspan=3>\n";
		print "<input type=radio name=virt value=0 checked> ",
		      $self->text('form_shared', $input_ips),"\n";
# 		      "$self->{'text_hash'}->{'edit_virtnone'}\n";
		print "</td></tr>\n";
		print "<tr>";
		if ($self->{'config_hash'}->{'ip_ranges'}) {
			# Can do automatic allocation
			print "<td>&nbsp;</td><td colspan=3 valign=top>\n";
			local $alloc = $self->free_ip_address();
			if ($alloc) {
				print "<input type=radio name=virt value=1> ",
				      $self->text('edit_alloc', $alloc);
				}
			else {
				# None left!
				print $self->{'text_hash'}->{'form_noalloc'};
				}
			}
		else {
			# Use must enter IP
			print "<tr><td>&nbsp;</td><td valign=top>\n";
			print "<input type=radio name=virt value=1> ", "$self->{'text_hash'}->{'form_vip'}\n";
			print "</td><td colspan=2>";
#			print "<input type=radio name=virt value=1> ",
#			      "$self->{'text_hash'}->{'edit_virtalloc'}\n";
#			print "<input name=ip size=15>\n";
			print "<table border=0 cellspacing=0 cellpadding=0>";
			print "<tr><td>$self->{'text_hash'}->{'form_ip'}&nbsp;</td><td><input name=ip size=20 value=\"\"></td></tr>\n";
			print "<tr><td>$self->{'text_hash'}->{'form_netmask'} &nbsp; </td><td><input type=radio name=automask checked value=0> &nbsp; $self->{'text_hash'}->{form_automatic} &nbsp; <input type=radio name=automask value=1> &nbsp; <input name=netmask size=20 value=\"\"></td></tr>\n";
			print "<tr><td>$self->{'text_hash'}->{'form_device'}</td><td>";
			local @devices = map {$_->{'name'}} @ifaces;
			@devices = $self->unique(@devices);
			print "<select name=iface>\n";
			foreach  (@devices) {
				printf "<option value=\"$_\">$_\n";
			}
			print "</select>\n";
			print "</td></tr>\n";
			print "</table>";

			}
		}
	print "</td> </tr>\n";
	print "<tr> <td colspan=4><hr></td></tr>\n";
	}

# Show source template
#print "<tr> <td><b>$self->{'text_hash'}->{'edit_tmpl'}</b></td>\n";
#$tmpl = &get_template($self->{'d'}->{'template'});
#print "<td colspan=3>$tmpl->{'name'}</tt></td> </tr>\n";

#if ($self->{'d'}->{'proxy_pass_mode'} && $self->{'d'}->{'proxy_pass'} && $self->{'d'}->{'web'}) {
#	# Show forwarding / proxy destination
#	print "<tr> <td><b>",$self->{'text_hash'}->{'edit_proxy'.$self->{'d'}->{'proxy_pass_mode'}},
#	      "</b></td>\n";
#	if ($self->{'d'}->{'proxy_pass_mode'} == 1) {
#		printf "<td colspan=3><input name=proxy_pass size=30 value='%s'></td> </tr>\n", $self->{'d'}->{'proxy_pass'};
#		}
#	else {
#		print "<td colspan=3><tt>$self->{'d'}->{'proxy_pass'}</tt></td> </tr>\n";
#		}
#	}

# Show any alias domains
#@aliasdoms = $self->get_domain_by("alias", $self->{'d'}->{'id'});
#if (@aliasdoms) {
#	print "<tr> <td><b>$self->{'text_hash'}->{'edit_aliasdoms'}</b></td>\n";
#	print "<td>",scalar(@aliasdoms),"\n",
#	      "<a href='search.cgi?field=alias&what=$self->{'d'}->{'dom'}'>",
#	      "$self->{'text_hash'}->{'edit_sublist'}</a></td> </tr>\n";
#	}

# Show user and group quota editing inputs
@{$self->{'users_array'}} = $self->list_domain_users($self->{'d'}, 0, 1);
($self->{'duser'}) = grep { $_->{'user'} eq $self->{'d'}->{'user'} } @{$self->{'users_array'}};
if ($self->{'config_hash'}->{'home_quotas'} && !$self->{'parentdom'} && $self->{'access_hash'}->{'edit'} == 1) {
print "<tr $self->{'tb'}> <td colspan=4><b>" . $self->text('edit_header_limits', $self->{'t_website'}) . "</b></td> </tr>\n";
	print "<tr> <td><b>$self->{'text_hash'}->{'edit_quota'}</b></td> <td colspan=3>\n";
	printf "<input type=radio name=quota_def value=0 %s>\n",
		$self->{'d'}->{'quota'} ? "checked" : "";
	print $self->quota_input("quota", $self->{'d'}->{'quota'}, $self->{'config_hash'}->{'home_quotas'});
	printf "<input type=radio name=quota_def value=1 %s> %s\n",
		$self->{'d'}->{'quota'} ? "" : "checked", $self->{'text_hash'}->{'form_unlimit'};
	print "</td> </tr>\n";
#
#	print "<tr> <td><b>$self->{'text_hash'}->{'edit_uquota'}</b></td> <td colspan=3>\n";
#	printf "<input type=radio name=uquota_def value=1 %s> %s\n",
#		$self->{'d'}->{'uquota'} ? "" : "checked", $self->{'text_hash'}->{'form_unlimit'};
#	printf "<input type=radio name=uquota_def value=0 %s>\n",
#		$self->{'d'}->{'uquota'} ? "checked" : "";
#	print $self->quota_input("uquota", $self->{'d'}->{'uquota'}, $self->{'config_hash'}->{'home_quotas'}),
#	      "</td> </tr>\n";
	}
if ($self->{'config_hash'}->{'bw_active'} && !$self->{'d'}->{'parent'}) {
	# Show bandwidth limit and usage
	print "<tr> <td><b>$self->{'text_hash'}->{'edit_bw'}</b></td> <td colspan=3>\n";
	if ($self->master_admin()) {
		print $self->bandwidth_input("bw", $self->{'d'}->{'bw_limit'});
		}
	else {
		print $self->{'d'}->{'bw_limit'} ?
		    $self->text('edit_bwpast_'.$self->{'config_hash'}->{'bw_past'},
		        $self->nice_size($self->{'d'}->{'bw_limit'}), $self->{'config_hash'}->{'bw_period'}) :
		    $self->{'text_hash'}->{'edit_bwnone'};
		}
	print "</td> </tr>\n";

	# Show usage over current period
	if (defined($self->{'d'}->{'bw_usage'})) {
		print "<tr> <td><b>",$self->text('edit_bwusage',
			strftime("%d/%m/%Y", localtime($self->{'d'}->{'bw_start'}*(24*60*60)))),
		      "</b></td> <td colspan=3>\n";
		if ($self->{'d'}->{'bw_limit'} && $self->{'d'}->{'bw_usage'} > $self->{'d'}->{'bw_limit'}) {
			print "<font color=#ff0000>".$self->nice_size($self->{'d'}->{'bw_usage'})."</font>\n";
			if ($self->{'d'}->{'bw_notify'}) {
				$self->{'notify'} = localtime($self->{'d'}->{'bw_notify'});
				print $self->text('edit_bwnotify', $self->{'notify'});
				}
			}
		else {
			print $self->nice_size($self->{'d'}->{'bw_usage'});
			}
		print "</td> </tr>\n";
		}
 	}
 
# Show domain limit inputs
if ($self->{'d'}->{'unix'} && $self->{'access_hash'}->{'edit'} == 1 && !$self->{'d'}->{'alias'}) {
	# Maximum allowed mailboxes
	print "<tr> <td><b>$self->{'text_hash'}->{'form_mailboxlimit'}</b></td> <td colspan=2>\n";
	print $self->ui_opt_textbox("mailboxlimit", $self->{'d'}->{'mailboxlimit'}, 4,
	      $self->{'text_hash'}->{'form_unlimit'}, ""),"</td> </tr>\n";

	# Maximum allowed dbs
	print "<tr> <td><b>$self->{'text_hash'}->{'form_dbslimit'}</b></td> <td colspan=2>\n";
	print $self->ui_opt_textbox("dbslimit", $self->{'d'}->{'dbslimit'}, 4,
	      $self->{'text_hash'}->{'form_unlimit'}, ""),"</td> </tr>\n";

	# Can create and edit domains?
	$self->{'dlm'} = $self->{'d'}->{'domslimit'} eq "*" ? undef : $self->{'d'}->{'domslimit'};
	print "<tr> <td><b>$self->{'text_hash'}->{'form_domslimit'}</b></td> <td colspan=2>\n";
	print $self->ui_opt_textbox("domslimit", $self->{'dlm'}, 4,
	      $self->{'text_hash'}->{'form_unlimit'}, ""),"</td> </tr>\n";
	}
print "<tr> <td colspan=4><hr></td> </tr>\n";

# Show disk usage fields
if ($self->{'config_hash'}->{'home_quotas'} && !$self->{'aliasdom'} && $self->{'d'}->{'unix'}) {
	# Show total usage by mail users
	print "<tr $self->{'tb'}> <td colspan=4><b>$self->{'text_hash'}->{'edit_header_space'}</b></td> </tr>\n";
	local @cds = $self->get_domain_by("parent", $self->{'d'}->{'id'});
	print "<tr> <td><b>$self->{'text_hash'}->{'edit_mailquota'}</b></td> <td colspan=3>\n";
	local $mailquota = 0;
	local $homequota = 0;
	foreach $u (@{$self->{'users_array'}}) {
		if ($u->{'user'} ne $self->{'d'}->{'user'}) {
			$homequota += $u->{'uquota'};
			$mailquota += $u->{'umquota'};
			}
		}
	print $self->text('edit_qon', $self->quota_show($homequota, $self->{'config_hash'}->{'home_quotas'}), $self->{'config_hash'}->{'home_quotas'}),"\n";
	local $mq = $self->{'config_hash'}->{'mail_quotas'} &&
		    $self->{'config_hash'}->{'mail_quotas'} ne $self->{'config_hash'}->{'home_quotas'};
	if ($mq) {
		print " , ",$self->text('edit_qon', $self->quota_show($mailquota, $self->{'config_hash'}->{'mail_quotas'}), $self->{'config_hash'}->{'mail_quotas'}),"\n";
		}
	print "</td> </tr>\n";

	# Show usage by subdomain mail users
	if (@cds) {
		print "<tr> <td><b>$self->{'text_hash'}->{'edit_subquota'}</b></td> <td colspan=3>\n";
		local $cdsmailquota = 0;
		local $cdshomequota = 0;
		local $cd;
		foreach $cd (@cds) {
			local @cdusers = $self->list_domain_users($cd, 0, 1);
			foreach $u (@cdusers) {
				$cdshomequota += $u->{'uquota'};
				$cdsmailquota += $u->{'umquota'};
				}
			}
		print $self->text('edit_qon', $self->quota_show($cdshomequota, $self->{'config_hash'}->{'home_quotas'}), $self->{'config_hash'}->{'home_quotas'}),"\n";
		if ($mq) {
			print " , ",$self->text('edit_qon', $self->quota_show($cdsmailquota, $self->{'config_hash'}->{'mail_quotas'}), $self->{'config_hash'}->{'mail_quotas'}),"\n";
			}
#		print "<a href='search.cgi?field=parent&what=$self->{'d'}->{'dom'}'>",
#		      "$self->{'text_hash'}->{'edit_sublist'}</a>\n";
		print "</td> </tr>\n";
		}
	print "<tr> <td colspan=4><hr></td></tr>\n";
	}

# Show section for custom fields, if any
$self->{'fields'} = $self->show_custom_fields($self->{'d'});
if ($self->{'fields'}) {
	print "<tr> <td colspan=4><hr></td> </tr>\n";
	print "<tr $self->{'tb'}> <td colspan=4><b>$self->{'text_hash'}->{'edit_header_custom'}</b></td> </tr>\n";
	print $self->{'fields'};
	print "<tr> <td colspan=4><hr></td> </tr>\n";
	}

# Show buttons for turning features on and off (if allowed)
print "<tr> <td colspan=4><hr></td> </tr>\n";
if ($self->{'d'}->{'disabled'}) {
	# Disabled, so tell the user that features cannot be changed
	print "<tr> <td colspan=4 align=center>&nbsp;<br><font color=#ff0000>",
	      "<b>",$self->{'text_hash'}->{'edit_disabled_'.$self->{'d'}->{'disabled_reason'}},"\n",
#	      $self->{'text_hash'}->{'edit_disabled'},
	      "</b></font><br>&nbsp;</td> </tr>\n";
	}
else {
	# Show features for this domain
	$self->{'i'} = 0;
	@{$self->{'dom_features_array'}} = $self->{'aliasdom'} ? @{$self->{'opt_alias_features_array'}} : @{$self->{'opt_features_array'}};
	foreach $f (@{$self->{'dom_features_array'}}) {
		# Webmin feature is not needed for subdomains
		next if ($self->{'d'}->{'parent'} && $f eq "webmin");

		# Unix feature is not needed for subdomains
		next if ($self->{'d'}->{'parent'} && $f eq "unix");

		# Cannot enable features not in alias
		next if ($self->{'aliasdom'} && !$self->{'aliasdom'}->{$f});

		# Don't show features that are always enabled
                if ($self->{'config_hash'}->{$f} == 3 && $self->{'d'}->{$f}) {
                        print $self->ui_hidden($f, 1),"\n";
                        next;
                        }

		if ($self->{'access_hash'}->{'edit'} == 2 && !$self->{'access_hash'}->{"feature_$f"}) {
			print "<input type=hidden name=$f value='$self->{'d'}->{$f}'>\n";
		}
		elsif ($self->{'config_hash'}->{$f} || !defined($self->{'config_hash'}->{$f})) {
			print "<input type=hidden name=$f value='1'>\n";
			}
#		print "<tr>\n" if ($self->{'i'}%2 == 0);
#		local $txt = $self->{'parentdom'} ? $self->{'text_hash'}->{'edit_sub'.$f} : undef;
#		$txt ||= $self->{'text_hash'}->{'edit_'.$f};
#		print "<td><b>",$txt,"</b></td>\n";
#		if ($self->{'access_hash'}->{'edit'} == 2 && !$self->{'access_hash'}->{"feature_$f"}) {
#			print "<td>",$self->{'d'}->{$f} ? $self->{'text_hash'}->{'yes'} : $self->{'text_hash'}->{'no'},"</td>\n";
#			print "<input type=hidden name=$f value='$self->{'d'}->{$f}'>\n";
#			}
#		elsif ($self->{'config_hash'}->{$f} || !defined($self->{'config_hash'}->{$f})) {
#			printf"<td><input type=radio name=$f value=1 %s> %s\n",
#				$self->{'d'}->{$f} ? "checked" : "", $self->{'text_hash'}->{'yes'};
#			printf"<input type=radio name=$f value=0 %s> %s</td>\n",
#				$self->{'d'}->{$f} ? "" : "checked", $self->{'text_hash'}->{'no'};
#			}
#		else {
#			print "<td><i>$self->{'text_hash'}->{'form_unavail'}</i></td>\n";
#			}
#		print "</tr>\n" if ($self->{'i'}++%2 == 1);
		}

	foreach $f (@{$self->{'feature_plugins_array'}}) {
		# Cannot enable features not in alias
		next if ($self->{'aliasdom'} && !$self->{'aliasdom'}->{$f});

		print "<tr>\n" if ($self->{'i'}%2 == 0);
		$self->{'label'} = $self->plugin_call($f, "feature_label", 1);
		print "<td><b>$self->{'label'}</b></td>\n";

		if ($self->{'access_hash'}->{'edit'} == 2 && !$self->{'access_hash'}->{"feature_$f"}) {
			print "<td>",$self->{'d'}->{$f} ? $self->{'text_hash'}->{'yes'} : $self->{'text_hash'}->{'no'},"</td>\n";
			print "<input type=hidden name=$f value='$self->{'d'}->{$f}'>\n";
			}
		else {
			printf"<td><input type=radio name=$f value=1 %s> %s\n",
				$self->{'d'}->{$f} ? "checked" : "", $self->{'text_hash'}->{'yes'};
			printf"<input type=radio name=$f value=0 %s> %s</td>\n",
				$self->{'d'}->{$f} ? "" : "checked", $self->{'text_hash'}->{'no'};
			}
		print "</tr>\n" if ($self->{'i'}++%2 == 1);
		}

	print "</tr>\n";

#	if (!$self->{'d'}->{'web'} && $self->{'config_hash'}->{'proxy_pass'} && !$self->{'d'}->{'alias'}) {
#		# Allow setting up of frame-forwarding with web
#		print &frame_fwd_input($self->{'d'}->{'proxy_pass'});
#		}
	}

print "</table></td></tr></table>\n";

# Save changes button
printf "<input type=submit value='%s'>\n", $self->text('edit_save', $self->{'t_website'});
print "</form>\n";

# if ($self->master_admin()) {
# 
print "<hr>\n";
print $self->ui_buttons_start();

if ($self->{'d'}->{'mail'}) {
	if (!$self->{'d'}->{'alias'}) {
		# Mailboxes button
		print &ui_buttons_row_xpressia("list_users.cgi?dom=$self->{'in_hash'}->{'dom'}", "images/web_users.gif",
				      $self->{'text_hash'}->{'edit_users2'},
				      $self->text('edit_usersdesc', $self->{'t_website'}));
		}

#	# Mail aliases button
#	print &ui_buttons_row("list_aliases.cgi",
#			      $self->{'text_hash'}->{'edit_aliases'},
#			      $self->{'text_hash'}->{'edit_aliasesdesc'},
#			      $self->ui_hidden("dom", $self->{'in_hash'}->{'dom'}));
	}

if ($self->database_feature($self->{'d'})) {
	# MySQL and PostgreSQL DBs button
	print &ui_buttons_row_xpressia("list_databases.cgi?dom=$self->{'in_hash'}->{'dom'}", "images/web_dbs.gif",
			      $self->{'text_hash'}->{'edit_databases'},
			      $self->text('edit_databasesdesc', $self->{'t_website'}));
	}

print $self->ui_buttons_hr() if ($self->{'d'}->{'mail'} || $self->{'d'}->{'mysql'} || $self->{'d'}->{'postgres'});

if (!$self->{'access_hash'}->{'norename'} && ($self->{'access_hash'}->{'edit'} == 1)) {
	# Rename domain button
	print &ui_buttons_row_xpressia("rename_form.cgi?dom=$self->{'in_hash'}->{'dom'}", "images/web_change.gif",
			      $self->{'text_hash'}->{'edit_rename'},
			      $self->text('edit_renamedesc', $self->{'t_website'}));
	}

$self->{'unixer'} = $self->{'parentdom'} || $self->{'d'};
if ($self->{'access_hash'}->{'create'} && !$self->{'d'}->{'alias'} && $self->{'unixer'}->{'unix'}) {
	# Domain alias button
	print &ui_buttons_row_xpressia("domain_form.cgi?to=$self->{'in_hash'}->{'dom'}", "images/web_alias.gif",
			      $self->text('edit_alias', $self->{'t_website'}),
			      $self->text('edit_aliasdesc', $self->{'t_website'}));
	}

if ($self->{'d'}->{'ssl'} && $self->{'d'}->{'dir'}) {
	# SSL options page button
	print &ui_buttons_row_xpressia("cert_form.cgi?dom=$self->{'in_hash'}->{'dom'}", "images/web_ssl.gif",
			      $self->{'text_hash'}->{'edit_cert'},
			      $self->text('edit_certdesc', $self->{'t_website'}));
	}

#if ($self->{'d'}->{'unix'} && $self->{'access_hash'}->{'edit'} == 1 && !$self->{'d'}->{'alias'}) {
#	# Domain limits button
#	print &ui_buttons_row("edit_limits.cgi",
#			      $self->{'text_hash'}->{'edit_limits'},
#			      $self->{'text_hash'}->{'edit_limitsdesc'},
#			      $self->ui_hidden("dom", $self->{'in_hash'}->{'dom'}));
#	}

#if ($self->{'d'}->{'proxy_pass_mode'} == 2 && $self->{'d'}->{'proxy_pass'}) {
#	# Frame-forwarding configuration button
#	print &ui_buttons_row("frame_form.cgi",
#			      $self->{'text_hash'}->{'edit_frame'},
#			      $self->{'text_hash'}->{'edit_framedesc'},
#			      $self->ui_hidden("dom", $self->{'in_hash'}->{'dom'}));
#	}

# Button to link to webalizer report (disabled for now)
if ($self->{'config_hash'}->{'webalizer'} && 0) {
	$self->require_webalizer();
	$self->read_acl(\%{$self->{'acl_hash'}});
	$self->{'alog'} = $self->get_apache_log($self->{'d'}->{'dom'}, $self->{'d'}->{'web_port'});
	$self->{'lconf'} = $main::webalizer_object->get_log_config($self->{'alog'});
	if ($self->{'d'}->{'webalizer'} && $self->{'acl_hash'}->{$self->{'base_remote_user'},"webalizer"} &&
	    $self->{'alog'} && -d $self->{'lconf'}->{'dir'} && -r "$self->{'lconf'}->{'dir'}/index.html") {
		# Button to show Webalizer report
		print &ui_buttons_row_xpressia("view_log.cgi/$self->{'d'}->{'id'}/index.html", "images/web_log.gif",
				      $self->{'text_hash'}->{'edit_weba'},
				      $self->text('edit_webadesc', $self->{'t_website'}));
		}
	}

# Button to show bandwidth graph
if ($self->{'config_hash'}->{'bw_active'} && !$self->{'d'}->{'parent'} && $self->can_monitor_bandwidth($self->{'d'})) {
	print &ui_buttons_row_xpressia("bwgraph.cgi?dom=$self->{'in_hash'}->{'dom'}", "images/web_bw.gif",
			      $self->{'text_hash'}->{'edit_bwgraph'},
			      $self->text('edit_bwgraphdesc', $self->{'t_website'}));
	}

# Buttons to backup and restore this server
if (!$self->{'d'}->{'alias'} && $self->master_admin()) {
	print $self->ui_buttons_hr();

	print &ui_buttons_row_xpressia("backup_form.cgi?dom=$self->{'in_hash'}->{'dom'}", "images/web_backup.gif",
			      $self->text('edit_backup', $self->{'t_website_mail'}),
			      $self->text('edit_backupdesc', $self->{'t_website'}));

	print &ui_buttons_row_xpressia("restore_form.cgi?dom=$self->{'in_hash'}->{'dom'}", "images/web_restore.gif",
			      $self->text('edit_restore', $self->{'t_website_mail'}),
			      $self->text('edit_restoredesc', $self->{'t_website'}));
	}

print $self->ui_buttons_hr();

if (($self->master_admin() || $self->{'d'}->{'parent'}) && !$self->{'d'}->{'alias'}) {
	# Enabled or disable buttons
	if ($self->{'d'}->{'disabled'}) {
		print &ui_buttons_row_xpressia("enable_domain.cgi?dom=$self->{'in_hash'}->{'dom'}", "images/web_enable.gif",
				      $self->text('edit_enable', $self->{'t_website'}),
				      $self->text('edit_enabledesc', $self->{'t_website'}));
		}
	else {
		print &ui_buttons_row_xpressia("disable_domain.cgi?dom=$self->{'in_hash'}->{'dom'}", "images/web_disable.gif",
				      $self->text('edit_disable', $self->{'t_website'}),
				      $self->text('edit_disabledesc', $self->{'t_website'}));
		}
	}

if ($self->master_admin() || $self->{'d'}->{'parent'}) {
	# Delete domain button
	print &ui_buttons_row_xpressia("delete_domain.cgi?dom=$self->{'in_hash'}->{'dom'}", "images/web_del.gif",
			      $self->text('edit_delete', $self->{'t_website'}),
			      $self->text('edit_deletedesc', $self->{'t_website'}));
	}

print $self->ui_buttons_end();
#}
 
# $self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
$self->ui_print_footer($self->{'text_hash'}->{'index_mainpage_url'}, $self->{'text_hash'}->{'index_mainpage'}, "", $self->text('index_return', $self->{'t_websites'}));
 
1;
		
}

# ---
# ui_buttons_row_xpressia(script, icon, button-label, description, [after-submit],
#		 [before-submit]) 
sub ui_buttons_row_xpressia
{
	shift if ($self == $_[0]);

# return &theme_ui_buttons_row(@_) if (defined(&theme_ui_buttons_row));
local ($script, $icon, $label, $desc, $after, $before) = @_;
# return "<form action=$script>\n".
return 
	"<tr> <td nowrap width=20%>".($before ? $before." " : "").
	"<a href='$script'><img border=0 src='$icon'>".
	$self->quote_escape($label).($after ? " ".$after : "")."</td>\n".
	"<td valign=top width=80%>$desc</td> </tr>\n";
}


1;

