#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_ffile.cgi
# Allow editing of a filter config file

&ModuleLoader::preload_module('virtual_server_class', "virtual_server::VirtualserverLib");
$self = new virtual_server::VirtualserverLib:: 'virtual_server_class',%$self;

$self->ReadParse();
$self->{'d'} = $self->get_domain($self->{'in_hash'}->{'dom'});
$self->can_edit_domain($self->{'d'}) || $self->error($self->{'text_hash'}->{'aliases_ecannot'});
$self->{'config_hash'}->{'edit_afiles'} || $self->master_admin() ||
	$self->error($self->{'text_hash'}->{'ffile_ecannot'});

$self->ui_print_header(undef, $self->{'text_hash'}->{'ffile_title'}, "");

$self->switch_to_domain_user($self->{'d'});
if (-e $self->{'in_hash'}->{'file'}) {
	open(FILE, $self->{'in_hash'}->{'file'}) ||
		$self->error($self->text('ffile_eread', $self->{'in_hash'}->{'file'}, $self->{'d'}->{'user'}, $!));
	while(<FILE>) {
		s/\r|\n//g;
		if (/^(\S+)\s+(\S+)\s+(\S+)\s+(.*)$/) {
			push(@{$self->{'filter_array'}}, [ $1, $2, $3, $4 ]);
			}
		elsif (/^(2)\s+(\S+)$/) {
			$self->{'other'} = $2;
			}
		}
	close(FILE);
	}

print "<b>",$self->text('ffile_desc', "<tt>$self->{'in_hash'}->{'file'}</tt>"),"</b><p>\n";

$self->{'what'} = $self->{'in_hash'}->{'alias'} ? 'alias' : 'user';
print "<form action=save_ffile.cgi method=post enctype=multipart/form-data>\n";
print "<input type=hidden name=file value=\"$self->{'in_hash'}->{'file'}\">\n";
print "<input type=hidden name=$self->{'what'} value=\"",$self->{'in_hash'}->{$self->{'what'}},"\">\n";
print "<input type=hidden name=dom value=\"$self->{'in_hash'}->{'dom'}\">\n";

$self->{'i'} = 0;
foreach $f (@{$self->{'filter_array'}}, [ 1, '', '', '' ],
		     [ 1, '', '', '' ],
		     [ 1, '', '', '' ],
		     [ 1, '', '', '' ],
		     [ 1, '', '', '' ]) {
	$self->{'field'} = "<select name=field_$self->{'i'}>\n";
	foreach $ft ('', 'from', 'to', 'subject', 'cc', 'body') {
		$self->{'field'} .= sprintf "<option value='%s' %s>%s\n",
			$ft, $f->[2] eq $ft ? "selected" : "",
			$ft ? $self->{'text_hash'}->{"ffile_$ft"} : "&nbsp";
		}
	$self->{'field'} .= "</select>\n";

	$self->{'what'} = "<select name=what_$self->{'i'}>\n";
	$self->{'what'} .= sprintf "<option value=0 %s>%s\n",
		$f->[0] == 0 ? "selected" : "", $self->{'text_hash'}->{"ffile_what0"};
	$self->{'what'} .= sprintf "<option value=1 %s>%s\n",
		$f->[0] == 1 ? "selected" : "", $self->{'text_hash'}->{"ffile_what1"};
	$self->{'what'} .= "</select>\n";

	$self->{'match'} = "<input name=match_$self->{'i'} size=20 value='$f->[3]'>\n";

	$self->{'action'} = "<input name=action_$self->{'i'} size=30 value='$f->[1]'>\n";

	print $self->text('ffile_line', $self->{'field'}, $self->{'what'}, $self->{'match'}, $self->{'action'}),"<br>\n";
	$self->{'i'}++;
	}
print $self->text('ffile_other',
	    "<input name=other size=30 value='$self->{'other'}'>"),"<br>\n";

print "<input type=submit value=\"$self->{'text_hash'}->{'save'}\">\n";
print "</form>\n";

$self->ui_print_footer("edit_$self->{'what'}.cgi?dom=$self->{'in_hash'}->{'dom'}&$self->{'what'}=$self->{'in_hash'}->{$self->{'what'}}",
	$self->{'text_hash'}->{$self->{'what'}.'_return'});

1;
		
}


1;

