#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_limits.cgi
# Display access control and usage limits for this domain's user

&ModuleLoader::preload_module('virtual_server_class', "virtual_server::VirtualserverLib");
$self = new virtual_server::VirtualserverLib:: 'virtual_server_class',%$self;

$self->ReadParse();
$self->{'d'} = $self->get_domain($self->{'in_hash'}->{'dom'});
$self->{'access_hash'}->{'edit'} == 1 && $self->can_edit_domain($self->{'d'}) || $self->error($self->{'text_hash'}->{'edit_ecannot'});

$self->ui_print_header($self->domain_in($self->{'d'}), $self->{'text_hash'}->{'limits_title'}, "");

#print "$self->{'text_hash'}->{'limits_desc'}<p>\n";

print "<form action=save_limits.cgi method=post>\n";
print "<input type=hidden name=dom value='$self->{'in_hash'}->{'dom'}'>\n";
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'limits_header'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'edit_domain'}</b></td>\n";
print "<td><tt>$self->{'d'}->{'dom'}</tt></td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'edit_user'}</b></td>\n";
print "<td><tt>$self->{'d'}->{'user'}</tt></td> </tr>\n";

# Maximum allowed mailboxes
print "<tr> <td><b>$self->{'text_hash'}->{'form_mailboxlimit'}</b></td> <td colspan=2>\n";
print $self->ui_opt_textbox("mailboxlimit", $self->{'d'}->{'mailboxlimit'}, 4,
	      $self->{'text_hash'}->{'form_unlimit'}, $self->{'text_hash'}->{'form_atmost'}),"</td> </tr>\n";

# Maximum allowed dbs
print "<tr> <td><b>$self->{'text_hash'}->{'form_dbslimit'}</b></td> <td colspan=2>\n";
print $self->ui_opt_textbox("dbslimit", $self->{'d'}->{'dbslimit'}, 4,
	      $self->{'text_hash'}->{'form_unlimit'}, $self->{'text_hash'}->{'form_atmost'}),"</td> </tr>\n";

# Can choose db name
print "<tr> <td><b>$self->{'text_hash'}->{'limits_nodbname'}</b></td>\n";
print "<td>",$self->ui_radio("nodbname", $self->{'d'}->{'nodbname'} ? 1 : 0,
	       [ [ 0, $self->{'text_hash'}->{'yes'} ], [ 1, $self->{'text_hash'}->{'no'} ] ]),"</td> </tr>\n";

# Can rename domains
print "<tr> <td><b>$self->{'text_hash'}->{'limits_norename'}</b></td>\n";
print "<td>",$self->ui_radio("norename", $self->{'d'}->{'norename'} ? 1 : 0,
	       [ [ 0, $self->{'text_hash'}->{'yes'} ], [ 1, $self->{'text_hash'}->{'no'} ] ]),"</td> </tr>\n";

# Force sub-domain under master domain
print "<tr> <td><b>$self->{'text_hash'}->{'limits_forceunder'}</b></td>\n";
print "<td>",$self->ui_radio("forceunder", $self->{'d'}->{'forceunder'} ? 1 : 0,
	       [ [ 1, $self->{'text_hash'}->{'yes'} ], [ 0, $self->{'text_hash'}->{'no'} ] ]),"</td> </tr>\n";

# Can create and edit domains?
$self->{'dlm'} = $self->{'d'}->{'domslimit'} eq "" ? 1 :
       $self->{'d'}->{'domslimit'} eq "*" ? 2 : 0;
print "<tr> <td><b>$self->{'text_hash'}->{'form_domslimit'}</b></td> <td colspan=2>\n";
printf "<input type=radio name=domslimit_def value=1 %s> %s\n",
	$self->{'dlm'} == 1 ? "checked" : "",
	$self->{'text_hash'}->{'no'};
printf "<input type=radio name=domslimit_def value=2 %s> %s\n",
	$self->{'dlm'} == 2 ? "checked" : "",
	$self->{'text_hash'}->{'form_domsunlimit'};
printf "<input type=radio name=domslimit_def value=0 %s> %s\n",
	$self->{'dlm'} == 0 ? "checked" : "",
	$self->{'text_hash'}->{'form_domsyes'};
printf "<input name=domslimit value='%s' size=4></td></tr>\n",
	$self->{'dlm'} == 0 ? $self->{'d'}->{'domslimit'} : "";

# Allowed features
print "<tr> <td valign=top><b>$self->{'text_hash'}->{'limits_features'}</b></td>\n";
print "<td colspan=3><table>\n";
$self->{'i'} = 0;
foreach $f (@{$self->{'opt_features_array'}}, "virt") {
	print "<tr>\n" if ($self->{'i'}%2 == 0);
	printf "<td><input type=checkbox name=features value=%s %s> %s</td>\n",
		$f, $self->{'d'}->{"limit_$f"} ? "checked" : "",
		$self->{'text_hash'}->{'feature_'.$f} || $f;
	print "</tr>\n" if ($self->{'i'}++%2 == 1);
	}
foreach $f (@{$self->{'feature_plugins_array'}}) {
	print "<tr>\n" if ($self->{'i'}%2 == 0);
	printf "<td><input type=checkbox name=features value=%s %s> %s</td>\n",
		$f, $self->{'d'}->{"limit_$f"} ? "checked" : "",
		$self->plugin_call($f, "feature_name");
	print "</tr>\n" if ($self->{'i'}++%2 == 1);
	}
print "</table></td> </tr>\n";

if ($self->master_admin()) {
        # Extra Webmin modules
	print "<tr> <td><b>$self->{'text_hash'}->{'limits_modules'}</b></td> <td colspan=2>\n";
	print $self->ui_textbox("modules", $self->{'d'}->{'webmin_modules'}, 30)."\n".
              $self->modules_chooser_button("modules", 1)."</td> </tr>\n";
        }

print "</table></td></tr></table>\n";
print "<input type=submit value='$self->{'text_hash'}->{'save'}'></form>\n";

$self->ui_print_footer("edit_domain.cgi?dom=$self->{'in_hash'}->{'dom'}", $self->{'text_hash'}->{'edit_return'},
		 "", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

