#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_newbw.cgi
# Display current bandwidth usage graphs, and allow enabling of scheduled
# checking

&ModuleLoader::preload_module('virtual_server_class', "virtual_server::VirtualserverLib");
$self = new virtual_server::VirtualserverLib:: 'virtual_server_class',%$self;

$self->master_admin() || $self->error($self->{'text_hash'}->{'newbw_ecannot'});
$self->ui_print_header(undef, $self->{'text_hash'}->{'newbw_title'}, "");

$self->{'job'} = $self->find_bandwidth_job();

print $self->text('newbw_desc', $self->{'t_websites'}),"<br>\n";

# Button to show graph
print "<hr>\n";
print $self->ui_buttons_start();
print $self->ui_buttons_row_xpressia("bwgraph.cgi", "images/web_bw.gif",
			$self->{'text_hash'}->{'newbw_graphbutton'},
			$self->text('newbw_graphdesc',$self->{'t_websites'}));
print $self->ui_buttons_end();
print "<hr>\n";

print $self->ui_form_start("save_newbw.cgi", "post");
print $self->ui_table_start($self->{'text_hash'}->{'newbw_header'}, undef, 2);

# Show active field
print $self->ui_table_row($self->{'text_hash'}->{'newbw_active'},
		$self->ui_radio("bw_active", $self->{'job'} && $self->{'config_hash'}->{'bw_active'} ? 1 : 0,
			[ [ 1, $self->{'text_hash'}->{'yes'} ], [ 0, $self->{'text_hash'}->{'no'} ] ]));

# Show field for monitoring period
print $self->ui_table_row($self->{'text_hash'}->{'newbw_period'},
			$self->ui_radio("bw_pastr", $self->{'config_hash'}->{'bw_past'} ? 0 : 1,
			[ [0, 
				$self->ui_select("bw_past", $self->{'config_hash'}->{'bw_past'} ? $self->{'config_hash'}->{'bw_past'} : 'month',
				[ [ 'week', $self->{'text_hash'}->{'newbw_past_week'} ],
				[ 'month', $self->{'text_hash'}->{'newbw_past_month'} ],
				[ 'year', $self->{'text_hash'}->{'newbw_past_year'} ],
				 ])],
			[1, $self->ui_textbox("bw_period", $self->{'config_hash'}->{'bw_period'}, 4)." ".$self->{'text_hash'}->{'newbw_days'}] ])
		);
    
# Show field for disable option
print $self->ui_table_row($self->{'text_hash'}->{'newbw_disable'},
		$self->ui_radio("bw_disable", $self->{'config_hash'}->{'bw_disable'} ? 1 : 0,
			[ [ 1, $self->{'text_hash'}->{'yes'} ], [ 0, $self->{'text_hash'}->{'no'} ] ]));

# Servers to check or exclude
if ($self->{'config_hash'}->{'bw_servers'} eq "") {
	$self->{'serversmode'} = 0;
	}
elsif ($self->{'config_hash'}->{'bw_servers'} =~ /^\!(.*)$/) {
	$self->{'serversmode'} = 2;
	@{$self->{'servers_array'}} = split(/\s+/, $1);
	}
else {
	$self->{'serversmode'} = 1;
	@{$self->{'servers_array'}} = split(/\s+/, $self->{'config_hash'}->{'bw_servers'});
	}
local @list_dom=$self->list_domains();
if (scalar(@list_dom) ){
print $self->ui_table_row($self->{'text_hash'}->{'newbw_servers'},
		    $self->ui_radio("serversmode", $self->{'serversmode'},
				[ [ 0, $self->{'text_hash'}->{'newbw_servers0'} ],
				[ 1, $self->{'text_hash'}->{'newbw_servers1'} ],
				[ 2, $self->{'text_hash'}->{'newbw_servers2'} ] ])."<br>\n".
		    $self->servers_input("servers", \@{$self->{'servers_array'}},[ $self->list_domains() ]));
	}
	else {
		print $self->ui_table_row($self->{'text_hash'}->{'newbw_servers'},$self->{'text_hash'}->{'newbw_servers0'});
		print $self->ui_hidden("serversmode",0);
		}

print $self->ui_hidden("bw_owner",1);		# Show email to owner field
print $self->ui_hidden("bw_email","");	# Show email to other address
print $self->ui_hidden("bw_notify",24);	# Show field for notification period

$self->{'file'} = $self->{'config_hash'}->{'bw_template'};
$self->{'file'} = "$self->{'module_config_directory'}/bw-template" if ($self->{'file'} eq "default");
print $self->ui_hidden("bw_template",$self->html_escape($self->cat_file($self->{'file'})));	# Show email for domains over limit

print $self->ui_hidden("bw_warn",0);	# Show field for warning percentage
print $self->ui_hidden("bw_warnlevel","");

$self->{'file'} = $self->{'config_hash'}->{'warnbw_template'};
$self->{'file'} = "$self->{'module_config_directory'}/warnbw-template" if ($self->{'file'} eq "default");
print $self->ui_hidden("warnbw_template",$self->html_escape($self->cat_file($self->{'file'})));	# Show email for domains over limit

# Log files for FTP and mail
if ($self->{'config_hash'}->{'ftp_system'} == 1) {
	$self->{'defftplog'} = $self->get_proftpd_log();
}
elsif ($self->{'config_hash'}->{'ftp_system'} == 2) {
	$self->{'defftplog'} = $self->get_vsftpd_log();
}

print $self->ui_hidden("ftplog_def","1");
#print $self->ui_hidden("ftplog","");
print $self->ui_hidden("ftplog_rotated","1");

#print $self->ui_hidden("maillog","");
print $self->ui_hidden("maillog_def","1");
print $self->ui_hidden("maillog_rotated","1");

print $self->ui_table_end();
print $self->ui_form_end([ [ "save", $self->{'text_hash'}->{'newbw_save'} ] ]);

$self->ui_print_footer($self->{'text_hash'}->{'index_mainpage_url'}, $self->{'text_hash'}->{'index_mainpage'});

1;
		
}


1;

