#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_user.cgi
# Display a form for editing or adding a user. This can be a local user,
# or a domain mailbox user

&ModuleLoader::preload_module('virtual_server_class', "virtual_server::VirtualserverLib");
$self = new virtual_server::VirtualserverLib:: 'virtual_server_class',%$self;

$self->ReadParse();
if ($self->{'in_hash'}->{'dom'}) {
	$self->{'d'} = $self->get_domain($self->{'in_hash'}->{'dom'});
	($self->{'d'} && $self->can_edit_domain($self->{'d'})) || $self->error($self->{'text_hash'}->{'users_ecannot'});
	}
else {
	$self->error($self->{'text_hash'}->{'users_ecannot2'});
	}

if ($self->{'in_hash'}->{'new'}) {
	if ($self->{'in_hash'}->{'type'} eq 'ftp') {
		$self->{'config_hash'}->{'ftp'} || $self->{'d'}->{'web'} || $self->error($self->{'text_hash'}->{'users_ecannotftp'});
		$self->ui_print_header($self->text('indom', $self->{'d'}->{'dom'}), $self->{'text_hash'}->{'label_add_ftp_user'}, "", undef, undef, 1);
	}
	elsif ($self->{'in_hash'}->{'type'} eq 'samba') {
		$self->{'d'}->{'samba'} || $self->error($self->{'text_hash'}->{'users_ecannotsmb'});
		$self->ui_print_header($self->text('indom', $self->{'d'}->{'dom'}), $self->{'text_hash'}->{'label_add_samba_user'}, "", undef, undef, 1);
	}
	else {
		$self->{'d'}->{'mail'} || $self->error($self->{'text_hash'}->{'users_ecannotmail'});
		$self->ui_print_header($self->text('indom', $self->{'d'}->{'dom'}), $self->{'text_hash'}->{'label_add_mail_user'}, "", undef, undef, 1);
	}
	$self->{'user'} = $self->create_initial_user($self->{'d'});
	}
else {
	$self->ui_print_header($self->text('indom', $self->{'d'}->{'dom'}), $self->{'text_hash'}->{'website_edit_end_user'}, "", undef, undef, 1);
	@{$self->{'users_array'}} = $self->list_domain_users($self->{'d'});
	($self->{'user'}) = grep { $_->{'user'} eq $self->{'in_hash'}->{'user'} &&
			 $_->{'unix'} == $self->{'in_hash'}->{'unix'} } @{$self->{'users_array'}};
	$self->{'mailbox'} = $self->{'d'} && $self->{'d'}->{'user'} eq $self->{'user'}->{'user'} && $self->{'user'}->{'unix'};
	}

print $self->check_clicks_function();
print "<form action=save_user.cgi>\n";
print "<input type=hidden name=new value='$self->{'in_hash'}->{'new'}'>\n";
print "<input type=hidden name=dom value='$self->{'in_hash'}->{'dom'}'>\n";
print "<input type=hidden name=old value='$self->{'in_hash'}->{'user'}'>\n";
print "<input type=hidden name=unix value='$self->{'in_hash'}->{'unix'}'>\n";

print "<table border width='100%'>\n";
$self->{'d_owner'} = " $self->{'text_hash'}->{'website_onwer2'}" if $self->{'mailbox'};
print "<tr $self->{'tb'}> <td><b>", $self->{'text_hash'}->{'user_details'}, "</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table>\n";

print "<tr><td width=150><b>$self->{'text_hash'}->{'user_user'}</b></td>\n";
if ($self->{'mailbox'}) {
	print "<td><tt>$self->{'user'}->{'user'}</tt></td> </tr>\n";
	$self->{'pop3'} = $self->{'user'}->{'user'};
	}
else {
	$self->{'pop3'} = $self->{'d'} && !$self->{'user'}->{'noappend'} ?
		$self->remove_userdom($self->{'user'}->{'user'}, $self->{'d'}) : $self->{'user'}->{'user'};
	print "<td><input name=mailuser size=20 value='$self->{'pop3'}'>",
		$self->{'d'} ? "\@$self->{'d'}->{'dom'}\n" : "\n";
		print "</td> </tr>\n";
	if ($self->{'pop3'} ne $self->{'user'}->{'user'}) {
	local ($samba_t, $mail_t, $ftp_t, $user_t);

	if ($self->{'d'}->{'samba'}) {$self->{'samb_t'} = $self->{'text_hash'}->{'samba_login'}};
	if ($self->{'d'}->{'mail'}) {$mail_t = $self->{'text_hash'}->{'mail_login'}};
	if ($self->{'config_hash'}->{'ftp'} || $self->{'d'}->{'web'}) {$ftp_t = $self->{'text_hash'}->{'ftp_login'}};

 		$user_t = "$mail_t/$ftp_t/$self->{'samb_t'}";
		$user_t =~ s/\/*$//s;
		$user_t =~ s/\/\//\//s;
		$user_t =~ s/^\/*//s;
		print "<tr><td><b>".$self->text('users_pop3', $user_t)."</b></td><td>$self->{'user'}->{'user'}</td></tr>\n";
		}
	print "<input type=hidden name=oldpop3 value='$self->{'pop3'}'>\n";
	}

# Real name - only for true Unix users or LDAP persons
if ($self->{'user'}->{'person'}) {
	print "<tr> <td><b>$self->{'text_hash'}->{'user_real'}</b></td>\n";
	if ($self->{'mailbox'}) {
		print "<td>$self->{'user'}->{'real'}</td> </tr>\n";
		}
	else {
		print "<td><input name=real size=25 value='$self->{'user'}->{'real'}'></td> </tr>\n";
		}
	}

# Password cannot be edited for domain owners (because it is the domain pass)
if (!$self->{'mailbox'}) {
	print "<tr><td><b>$self->{'text_hash'}->{'website_passwd'}</b></td>\n";
	if ($self->{'in_hash'}->{'new'}) {
		print "<td><input name=mailpass type=password size=30></td> </tr>\n";
		print "<tr><td><b>$self->{'text_hash'}->{'website_passwd_confirm'}</b></td>\n";
		print "<td><input name=mailpass2 type=password size=30></td> </tr>\n";
		}
	else {
		print "<td><input type=radio name=mailpass_def value=1 checked> ",
		      "$self->{'text_hash'}->{'user_passdef'}\n";
		if (defined($self->{'user'}->{'plainpass'})) {
			print "($self->{'user'}->{'plainpass'})\n";
			}
		print "</td></tr>\n";
		print "<tr><td>&nbsp;</td><td><input type=radio name=mailpass_def value=0> $self->{'text_hash'}->{'user_passset'}\n";
		print "<input name=mailpass type=password size=15>";
		print "$self->{'text_hash'}->{'website_passwd_confirm'}<input name=mailpass2 type=password size=15>";
		print "</td> </tr>\n";

		}
	}
else {
		local $opass= $self->{'d'}->{'pass'};
		print "<input type=hidden name=mailpass value='$opass'>\n";
		print "<input type=hidden name=mailpass2 value='$opass'>\n";
	}

if (($self->master_admin() || $self->{'config_hash'}->{'edit_homes'}) && $self->{'d'} && $self->{'d'}->{'home'} &&
    !$self->{'mailbox'} && !$self->{'user'}->{'fixedhome'} && !$self->{'user'}->{'brokenhome'}) {
	# Show home directory editing field
	local $auto = $self->{'in_hash'}->{'new'} || $self->{'user'}->{'home'} eq "$self->{'d'}->{'home'}/$self->{'config_hash'}->{'homes_dir'}/$self->{'pop3'}";
	printf "<input type=hidden name=home_def value=%d>\n", $auto ? 1 : 0;
	printf "<input type=hidden name=home value='%s'>\n", $auto ? "" : substr($self->{'user'}->{'home'}, length($self->{'d'}->{'home'})+1);
	}

if (($self->master_admin() || $self->{'config_hash'}->{'edit_ftp'}) && !$self->{'mailbox'} && $self->{'user'}->{'unix'}) {
	# Show FTP shell field
	if (!$self->{'in_hash'}->{new} || ($self->{'in_hash'}->{new} && $self->{'in_hash'}->{type} eq 'mail') || ($self->{'in_hash'}->{new} && $self->{'in_hash'}->{type} eq 'samba')) {
	local $disabled = 'disabled'  if (!($self->{'config_hash'}->{'ftp'} || $self->{'d'}->{'web'}) || $self->{'mailbox'});
	print "<tr> <td colspan=2><hr></td> </tr>\n";
	print "<tr> <td><b>$self->{'text_hash'}->{'user_ftp'}</b></td>\n";
	$self->{'ftp'} = $self->{'user'}->{'qmail'} && !$self->{'user'}->{'shell'} ? -2 :
	       $self->{'user'}->{'shell'} eq $self->{'config_hash'}->{'ftp_shell'} ? 1 :
	       $self->{'config_hash'}->{'jail_shell'} &&
		$self->{'user'}->{'shell'} eq $self->{'config_hash'}->{'jail_shell'} ? 2 :
	       $self->{'in_hash'}->{'new'} || $self->{'user'}->{'shell'} eq $self->{'config_hash'}->{'shell'} ? 0 : -1;
	print "<td>";
	if ($self->{'ftp'} == -1) {
		print $self->text('user_shell', "<tt>$self->{'user'}->{'shell'}</tt>");
		}
	elsif ($self->{'ftp'} == -2) {
		print $self->text('user_qmail');
		}
	else {
		printf "<input type=radio name=ftp $disabled value=1 %s> %s\n",
			$self->{'ftp'} == 1 || $self->{'mailbox'} ? "checked" : "", $self->{'text_hash'}->{'yes'};
		if ($self->{'config_hash'}->{'jail_shell'}) {
			printf "<input type=radio name=ftp $disabled value=2 %s> %s\n",
				$self->{'ftp'} == 2 ? "checked" : "", $self->{'text_hash'}->{'user_jail'};
			}
		printf "<input type=radio name=ftp $disabled value=0 %s> %s\n",
			$self->{'ftp'} == 0 ? "checked" : "", $self->{'text_hash'}->{'no'};
		}
	print "</td> </tr>\n";
	} elsif ($self->{'in_hash'}->{new} && ($self->{'in_hash'}->{type} eq 'ftp')) {
		printf "<input type=hidden name=ftp value=1>";
	        }
	}

# Find and show all plugin features
foreach $f (@{$self->{'mail_plugins_array'}}) {
	$self->{'input'} = $self->plugin_call($f, "mailbox_inputs", $self->{'user'}, $self->{'in_hash'}->{'new'}, $self->{'d'});
	print $self->{'input'};
	}

if (!$self->{'in_hash'}->{'new'}) {
	local ($sz, $umf) = $self->mail_file_size($self->{'user'});
	if ($self->{'user'}->{'shell'}) {
	if ($self->{'d'} && $self->{'ftp'}) {
		local $fdir = ($self->{'config_hash'}->{'ftp_dir'} || 'ftp');
		local $ftp_path = "$self->{'d'}->{'home'}/$fdir";
		print "<tr><td><b>$self->{'text_hash'}->{'website_ftppath'}</b></td><td><tt>$ftp_path</tt></td></tr>";
	}
	}
}

if ($self->{'d'} && !$self->{'user'}->{'noprimary'}) {
	# Show primary email address field
# 	local $disabled = 'disabled' if !$self->{'config_hash'}->{'mail'} || $self->{'mailbox'};
	local $disabled = 'disabled' if !$self->{'config_hash'}->{'mail'} || !$self->{'d'}->{'mail'};

	if (!$self->{'in_hash'}->{new} || ($self->{'in_hash'}->{new} && $self->{'in_hash'}->{type} eq 'ftp') || ($self->{'in_hash'}->{new} && $self->{'in_hash'}->{type} eq 'samba')) {
	print "<tr> <td colspan=2><hr></td> </tr>\n";
	print "<tr> <td><b>", $self->{'text_hash'}->{'user_mailbox'}, "</b></td>\n";
	printf "<td><input type=radio $disabled name=mailbox value=1 %s> %s\n",
		$self->{'user'}->{'email'}  ? "checked" : "", $self->{'text_hash'}->{'yes'};
	printf "<input type=radio $disabled name=mailbox value=0 %s> %s</td> </tr>\n",
		$self->{'user'}->{'email'}  ? "" : "checked", $self->{'text_hash'}->{'no'};
	} elsif ($self->{'in_hash'}->{new} && ($self->{'in_hash'}->{type} eq 'mail')) {
     		printf "<input type=hidden name=mailbox value=1>";
		}
}

if (!$self->{'in_hash'}->{'new'}) {
	local ($sz, $umf) = $self->mail_file_size($self->{'user'});
	if ($self->{'user'}->{'email'}) {
		print "<tr><td><b>$self->{'text_hash'}->{'user_mail'}</b></td>\n";
		local $link = $self->read_mail_link($self->{'user'});
		print "<td><tt>$umf</tt>\n";
		print "<a href='$link'>$self->{'text_hash'}->{'user_read'}</a></td>\n" if ($link);
		print "</tr>\n";
		}
	}

 # Show samba client field
 if ($self->{'config_hash'}->{'samba'} && $self->{'d'} && $self->{'user'}->{'unix'}) {
#  if ($self->{'d'} && $self->{'d'}->{'samba'} && $self->{'config_hash'}->{'samba'}) {
# 	local $disabled = 'disabled' if !$self->{'config_hash'}->{'samba'} || $self->{'mailbox'};
	local $disabled = 'disabled' if !$self->{'config_hash'}->{'samba'} || !$self->{'d'}->{'samba'};

	if (!$self->{'in_hash'}->{new} || ($self->{'in_hash'}->{new} && $self->{'in_hash'}->{type} eq 'ftp') || ($self->{'in_hash'}->{new} && $self->{'in_hash'}->{type} eq 'mail')) {
		print "<tr> <td colspan=2><hr></td> </tr>\n";
		print "<tr> <td><b>", $self->{'text_hash'}->{'user_samba'}, "</b></td>\n";
		printf "<td><input type=radio $disabled name=samba value=1 %s> $self->{'text_hash'}->{'yes'}\n", $self->{'user'}->{'samba'} ? "checked" : "";
		printf "<input type=radio $disabled name=samba value=0 %s> $self->{'text_hash'}->{'no'} %s</td></tr>\n", $self->{'user'}->{'samba'} ? "" : "checked",
			$self->{'user'}->{'samba'} || $disabled || $self->{'in_hash'}->{'new'} || $self->{'mailbox'} ? '' : $self->{'text_hash'}->{'edit_samba_warn'};
 	}
	elsif ($self->{'in_hash'}->{new} && ($self->{'in_hash'}->{type} eq 'samba')) {
		printf "<input type=hidden name=samba value=1>";
	}

	}

if ($self->{'user'}->{'mailquotafiles'}) {
	# Show Qmail files quota field
	print "<tr> <td><b>",$self->hlink($self->{'text_hash'}->{'user_qfiles'},"qmailfiles"),"</b></td>\n";
	print "<td>",$self->ui_radio("qfiles_def", $self->{'user'}->{'qfiles'} ? 0 : 1,
			       [ [ 1, $self->{'text_hash'}->{'form_unlimit'} ],
				 [ 0, " " ] ]);
	print $self->ui_textbox("qfiles", $self->{'user'}->{'qfiles'} || "", 10),
	      "</td> </tr>\n";
	}

if (!$self->{'mailbox'}) {
	# Show quotas field(s)
	print "<tr> <td colspan=2><hr></td> </tr>\n";
	$self->{'qsame'} = $self->{'config_hash'}->{'home_quotas'} eq $self->{'config_hash'}->{'mail_quotas'};
	if ($self->{'config_hash'}->{'home_quotas'}) {
		print "<tr><td><b>", $self->{'qsame'} ? $self->{'text_hash'}->{'user_umquota'} : $self->{'text_hash'}->{'user_uquota'}, "</b></td>\n";
		&quota_field("quota", $self->{'user'}->{'quota'}, $self->{'user'}->{'uquota'},
			     $self->{'config_hash'}->{'home_quotas'});
		}
	if ($self->{'config_hash'}->{'mail_quotas'} && !$self->{'qsame'}) {
		print "<tr><td><b>$self->{'text_hash'}->{'user_mquota'}</b></td>\n";
		&quota_field("mquota", $self->{'user'}->{'mquota'}, $self->{'user'}->{'umquota'},
			     $self->{'config_hash'}->{'mail_quotas'});
		}
	}

if (!$self->{'in_hash'}->{'new'}) {
	if ($self->{'user'}->{'home'}) {
		print "<tr> <td colspan=2><hr></td> </tr>\n";
		print "<tr><td><b>$self->{'text_hash'}->{'user_home'}</b></td>\n";
		print "<td>$self->{'user'}->{'home'}</td>\n";
		print "</tr>\n";
		}
	}

# Show address for confirmation email
if ($self->{'in_hash'}->{'new'} && $self->will_send_user_email($self->{'d'})) {
	print "<input type=hidden name=newmail_def value=1>\n";
	}

# Show secondary groups
@{$self->{'sgroups_array'}} = $self->allowed_secondary_groups($self->{'d'});
if (@{$self->{'sgroups_array'}} && $self->{'user'}->{'unix'}) {
        print "<tr> <td colspan=2><hr></td> </tr>\n";
        print "<tr> <td valign=top><b>",
              $self->hlink($self->{'text_hash'}->{'user_groups'},"usergroups"),"</b></td>\n";
        print "<td>",$self->ui_select("groups", $self->{'user'}->{'secs'},
                        [ map { [ $_ ] } @{$self->{'sgroups_array'}} ], 5, 1, 1),"</td> </tr>\n";
        }

print "</table></td></tr></table>\n";

print "<table><tr>\n";
if ($self->{'in_hash'}->{'new'}) {
	print "<td><input type=submit value='$self->{'text_hash'}->{'enduser_create'}'></td>\n";
	}
else {
	print "<td><input type=submit value='$self->{'text_hash'}->{'enduser_save'}'></td>\n";
	print "<td><input type=submit name=delete ",
	      "value='$self->{'text_hash'}->{'enduser_delete'}' onClick='check_clicks(form)'></td>\n"
		if (!$self->{'mailbox'});
	}
print "</table></form>\n";

$self->ui_print_footer($self->{'text_hash'}->{'index_mainpage_url'}, $self->{'text_hash'}->{'index_mainpage'},"", $self->text('index_return', $self->{'t_websites'}), "list_users.cgi?dom=$self->{'in_hash'}->{'dom'}", $self->{'text_hash'}->{'users_return'});

1;
		
}

# quota_field(name, value, used, filesystem)
sub quota_field
{
	shift if ($self == $_[0]);

local @defmquota = split (/ /,$self->{'config_hash'}->{'defmquota'});
if ($self->master_admin() || $self->{'config_hash'}->{'edit_quota'}) {
	# Show inputs for editing quotas
	printf "<td><input type=radio name=%s_def value=0 %s>\n",
		$_[0], ($self->{'config_hash'}->{'defmquota'} && $self->{'in_hash'}->{'new'}) || $_[1]  ? "checked" : "";	#|| $self->{'in_hash'}->{'new'}
	if (!$self->{'in_hash'}->{'new'}) {
		print $self->quota_input($_[0], $_[1] || "", $_[3]),"\n";
		print $self->text('user_used', $self->quota_show($_[2], $_[3])),"\n";
		}
	else {
		if ( !@defmquota or $#defmquota eq 0 ) {
			print $self->quota_input($_[0], $self->{'config_hash'}->{'defmquota'} || "", $_[3]),"\n";
		} else {
			print "<select name=$_[0]>\n";
			foreach $i (@defmquota) {
				chomp $i;
				print "<option value=\"$i\">$i</option>\n";
			}
			print "<option value=\"-1\">$self->{'text_hash'}->{'other'}</option></select>\n";
			print "<input name=other$_[0] size=15> $self->{'text_hash'}->{'form_b'}\n";
			}
		}
	printf "<input type=radio name=%s_def value=1 %s> %s\n",
		$_[0], ($self->{'config_hash'}->{'defmquota'} && $self->{'in_hash'}->{'new'}) || $_[1] ? "" : "checked", $self->{'text_hash'}->{'form_unlimit'};

	my $chd = $self->{'d'};     
	if($self->{'pdom'} = $chd->{'parent'}) { $chd = $self->get_domain($self->{'pdom'});}
        if($chd->{'quota'}) { 
	    my $uq; my @usr = $self->list_domain_users($chd);
	    foreach my $u (@usr) {
		$uq += $u->{'uquota'} + $u->{'umquota'};
	    }	 
	    print $self->text('quota_warn', 
	    $self->quota_show($chd->{'quota'},$self->{'config_hash'}->{'home_quotas'}),
	    $self->quota_show($uq,$self->{'config_hash'}->{'home_quotas'}));
	    }
	print "</td> </tr>\n";
	}
else {
	# Just show current settings, or default
	print "<td>";
	local $q = $self->{'in_hash'}->{'new'} ? $defmquota[0] : $_[1];
	print ($q ? $self->quota_show($q, $_[3]) : $self->{'text_hash'}->{'form_unlimit'}),"\n";
	print $self->text('user_used', $self->quota_show($_[2], $_[3])) if (!$self->{'in_hash'}->{'new'});
	print "</td> </tr>\n";
	}
}


1;

