#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_vfile.cgi
# Display the contents of an autoresponder file and alias settings

&ModuleLoader::preload_module('virtual_server_class', "virtual_server::VirtualserverLib");
$self = new virtual_server::VirtualserverLib:: 'virtual_server_class',%$self;

$self->ReadParse();
$self->{'d'} = $self->get_domain($self->{'in_hash'}->{'dom'});
$self->can_edit_domain($self->{'d'}) || $self->error($self->{'text_hash'}->{'aliases_ecannot'});
$self->{'config_hash'}->{'edit_afiles'} || $self->master_admin() ||
	$self->error($self->{'text_hash'}->{'vfile_ecannot'});

$self->ui_print_header(undef, $self->{'text_hash'}->{'vfile_title'}, "");
$self->{'what'} = $self->{'in_hash'}->{'alias'} ? 'alias' : 'user';

# Find the alias and its settings
if ($self->{'what'} eq "alias") {
	@{$self->{'aliases_array'}} = $self->list_domain_aliases($self->{'d'});
	($self->{'virt'}) = grep { $_->{'from'} eq $self->{'in_hash'}->{$self->{'what'}} } @{$self->{'aliases_array'}};
	@{$self->{'av_array'}} = $self->alias_type($self->{'virt'}->{'to'}->[$self->{'in_hash'}->{'idx'}]);
	}
else {
	@{$self->{'users_array'}} = $self->list_domain_users($self->{'d'});
	($self->{'user'}) = grep { $_->{'user'} eq $self->{'in_hash'}->{$self->{'what'}} } @{$self->{'users_array'}};
	@{$self->{'av_array'}} = $self->alias_type($self->{'user'}->{'to'}->[$self->{'in_hash'}->{'idx'}]);
	}

# Read the autoreply file
if (-e $self->{'in_hash'}->{'file'}) {
	open(FILE, $self->{'in_hash'}->{'file'}) ||
		$self->error($self->text('rfile_eread', $self->{'in_hash'}->{'file'}, $self->{'d'}->{'user'}, $!));
	while(<FILE>) {
		push(@{$self->{'lines_array'}}, $_);
		}
	close(FILE);
	}

print $self->text('vfile_desc', "<tt>$self->{'in_hash'}->{'file'}</tt>"),"<p>\n";
print "$self->{'text_hash'}->{'vfile_desc2'}<p>\n";

print "<form action=save_vfile.cgi method=post enctype=multipart/form-data>\n";
print "<input type=hidden name=file value=\"$self->{'in_hash'}->{'file'}\">\n";
print "<input type=hidden name=dom value=\"$self->{'in_hash'}->{'dom'}\">\n";
print "<input type=hidden name=$self->{'what'} value=\"",$self->{'in_hash'}->{$self->{'what'}},"\">\n";
print "<input type=hidden name=idx value=\"$self->{'in_hash'}->{'idx'}\">\n";

print "<table>\n";
print "<tr> <td colspan=2><textarea name=text rows=10 cols=80>",
	join("", @{$self->{'lines_array'}}),"</textarea></td> </tr>\n";

# Show timeouts
print "<tr> <td><b>$self->{'text_hash'}->{'vfile_time'}</b></td>\n";
print "<td>",$self->ui_textbox("time", $self->{'av_array'}->[2], 8)," ",$self->{'text_hash'}->{'vfile_secs'},
      "</td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'vfile_num'}</b></td>\n";
print "<td>",$self->ui_textbox("num", $self->{'av_array'}->[3], 8),"</td> </tr>\n";

# Show directory
print "<tr> <td><b>$self->{'text_hash'}->{'vfile_dir'}</b></td>\n";
print "<td>",$self->ui_opt_textbox("dir",
			     $self->{'av_array'}->[4] eq $self->{'in_hash'}->{'file'}.".log" ? undef : $self->{'av_array'}->[4], 30,
			     $self->{'text_hash'}->{'vfile_auto'}),"</td> </tr>\n";

# Show flag options
print "<tr> <td><b>$self->{'text_hash'}->{'vfile_flag'}</b></td>\n";
print "<td>",$self->ui_radio("flag", $self->{'av_array'}->[5],
	[ [ "", $self->{'text_hash'}->{'default'} ],
	  [ 1, $self->{'text_hash'}->{'yes'} ],
	  [ 0, $self->{'text_hash'}->{'no'} ] ]),"</td> </tr>\n";

# Show sender address
$self->{'other'} = $self->{'av_array'}->[6] eq "" || $self->{'av_array'}->[6] eq "+" || $self->{'av_array'}->[6] eq "\$" ? 0 : 1;
print "<tr> <td><b>$self->{'text_hash'}->{'vfile_from'}</b></td>\n";
print "<td>",$self->ui_radio("from", $self->{'other'} ? "other" : $self->{'av_array'}->[6],
	[ [ "", $self->{'text_hash'}->{'default'} ],
	  [ "+", $self->{'text_hash'}->{'vfile_blank'} ],
	  [ "\$", $self->{'text_hash'}->{'vfile_to'} ],
	  [ "other", $self->{'text_hash'}->{'vfile_other'} ] ]),"\n",
	$self->ui_textbox("other", $self->{'other'} ? $self->{'av_array'}->[6] : undef, 20),"</td> </tr>\n";

print "</table>\n";
print "<input type=submit value=\"$self->{'text_hash'}->{'save'}\"> ",
      "<input type=reset value=\"$self->{'text_hash'}->{'rfile_undo'}\">\n";
print "</form>\n";

$self->ui_print_footer("edit_$self->{'what'}.cgi?dom=$self->{'in_hash'}->{'dom'}&$self->{'what'}=$self->{'in_hash'}->{$self->{'what'}}",
	$self->{'text_hash'}->{$self->{'what'}.'_return'});
1;
		
}


1;

