#!/usr/bin/perl

&MAIN();

 sub MAIN {
# import.cgi
# Work out what will be imported, and either tell the user or actually do it

&ModuleLoader::preload_module('virtual_server_class', "virtual_server::VirtualserverLib");
$self = new virtual_server::VirtualserverLib:: 'virtual_server_class',%$self;

$self->{'access_hash'}->{'create'} && $self->{'access_hash'}->{'import'} || $self->error($self->{'text_hash'}->{'import_ecannot'});
$self->ReadParse();

$self->ui_print_header(undef, $self->{'text_hash'}->{'import_title'}, "");

# Check for domain clash
@{$self->{'doms_array'}} = $self->list_domains();
($self->{'clash'}) = grep { $_->{'dom'} eq $self->{'in_hash'}->{'dom'} } @{$self->{'doms_array'}};
$self->{'clash'} && &error_exit($self->{'text_hash'}->{'import_eexists'});

# Validate username
$self->{'in_hash'}->{'user_def'} || $self->{'in_hash'}->{'user'} =~ /^[^\t :]+$/ ||
	&error_exit($self->{'text_hash'}->{'setup_euser2'});
$self->{'in_hash'}->{'group_def'} || $self->{'in_hash'}->{'group'} =~ /^[^\t :]+$/ ||
	&error_exit($self->{'text_hash'}->{'import_egroup'});

# Validate quota
if ($self->{'config_hash'}->{'home_quotas'}) {
        if ($self->{'in_hash'}->{'quota'} == -1) { $self->{'in_hash'}->{'quota'} = $self->{'in_hash'}->{'otherquota'} };
	$self->{'in_hash'}->{'quota'} =~ /^\d+$/ ||  $self->error($self->{'text_hash'}->{'setup_equota'});
	}

# Make sure IP is valid
if ($self->{'in_hash'}->{'virt'}) {

     $self->foreign_require("net", "net-lib.pl");
     local @boot = $main::net_object->active_interfaces();
	 local ($iface) = grep { $_->{'fullname'} eq $self->{'in_hash'}->{'iface'} } @boot;

	local $b;
 	local $vmax = $self->{'config_hash'}->{'iface_base'} || int($main::net_object->{'min_virtual_number'});
 	foreach $b (@boot) {
 		$vmax = $b->{'virtual'}
 			if ($b->{'name'} eq $iface->{'name'} &&
 		    	$b->{'virtual'} > $vmax);
 		}
	local $virt = { 'address' => $self->{'in_hash'}->{'ip'},
		'netmask' => $self->{'in_hash'}->{'netmask'} ? $self->{'in_hash'}->{'netmask'} :
			$main::net_object->{'virtual_netmask'} || $iface->{'netmask'},
		'broadcast' => $self->{'in_hash'}->{'bcast'} ? $self->{'in_hash'}->{'bcast'} :
			$main::net_object->{'virtual_netmask'} eq "255.255.255.255" ? $self->{'in_hash'}->{'ip'} : $iface->{'broadcast'},
		'name' => $self->{'in_hash'}->{'iface'} ? $self->{'in_hash'}->{'iface'} : $iface->{'name'},
		'virtual' => $vmax+1,
		'up' => 1 };
 	$virt->{'fullname'} = $virt->{'name'}.":".$virt->{'virtual'};

	($iface) = grep { $_->{'address'} eq $self->{'in_hash'}->{'ip'} }
				( $main::net_object->boot_interfaces(),
				  $main::net_object->active_interfaces() );
	if (!$iface) {
 		$main::net_object->save_interface($virt);
 		$main::net_object->activate_interface($virt);
	}

	foreach $d (@{$self->{'doms_array'}}) {
		$d->{'ip'} eq $self->{'in_hash'}->{'ip'} &&
			&error_exit($self->text('import_eipclash', $d->{'dom'}));
		}
	$iface->{'virtual'} eq '' &&
		&error_exit($self->text('import_ereal', $iface->{'fullname'}));
	}

if ($self->{'in_hash'}->{'confirm'}) {
	# Go ahead and do it
	print "$self->{'text_hash'}->{'import_doing'}<p>\n";
	$self->require_useradmin();

	# Get existing group and user details
	$self->{'crgroup'} = $self->{'in_hash'}->{'crgroup'} || $self->{'in_hash'}->{'group'};
	@{$self->{'groups_array'}} = $self->foreign_call($self->{'usermodule'}, "list_groups");
	($ginfo) = grep { $_->{'group'} eq $self->{'crgroup'} } @{$self->{'groups_array'}};
	$self->build_group_taken(\%{$self->{'gtaken_hash'}}, \%{$self->{'ggtaken_hash'}});
	$self->{'gid'} = $ginfo ? $ginfo->{'gid'} : $self->allocate_gid(\%{$self->{'gtaken_hash'}});

	$self->{'cruser'} = $self->{'in_hash'}->{'cruser'} || $self->{'in_hash'}->{'user'};
	@{$self->{'users_array'}} = $self->foreign_call($self->{'usermodule'}, "list_users");
	($self->{'uinfo'}) = grep { $_->{'user'} eq $self->{'cruser'} } @{$self->{'users_array'}};
	$self->build_taken(\%{$self->{'taken_hash'}}, \%{$self->{'utaken_hash'}});
	$self->{'uid'} = $self->{'uinfo'} ? $self->{'uinfo'}->{'uid'} : $self->allocate_uid(\%{$self->{'taken_hash'}});
	$self->{'ugid'} = $self->{'uinfo'} ? $self->{'uinfo'}->{'gid'} : $self->{'gid'};
	$self->{'ugroup'} = $self->{'uinfo'} ? getgrgid($self->{'uinfo'}->{'gid'}) : $self->{'crgroup'};
	$self->{'owner'} = $self->{'uinfo'} ? $self->{'uinfo'}->{'real'} : "Imported domain $self->{'in_hash'}->{'dom'}";

	# Create domain details
	%{$self->{'found_hash'}} = map { $_, 1 } split(/\0/, $self->{'in_hash'}->{'found'});
	@{$self->{'dbs_array'}} = ( split(/\s+/, $self->{'in_hash'}->{'db_mysql'}),
		 split(/\s+/, $self->{'in_hash'}->{'db_postgres'}) );
	%{$self->{'dom_hash'}} = ( 'id', $self->domain_id(),
		 'dom', $self->{'in_hash'}->{'dom'},
		 'unix', 1,
		 'dir', 1,
		 'user', $self->{'cruser'},
		 'group', $self->{'crgroup'},
		 'ugroup', $self->{'ugroup'},
		 'quota', $self->quota_parse('quota', $self->{'config_hash'}->{'home_quotas'}),
		 'uid', $self->{'uid'},
		 'gid', $self->{'gid'},
		 'ugid', $self->{'ugid'},
		 'owner', $self->{'owner'},
		 'mail', int($self->{'found_hash'}->{'mail'}),
		 'web', int($self->{'found_hash'}->{'web'}),
		 'ftp', int($self->{'found_hash'}->{'ftp'}),
		 'webalizer', int($self->{'found_hash'}->{'webalizer'}),
		 'mysql', int($self->{'found_hash'}->{'mysql'}),
		 'postgres', int($self->{'found_hash'}->{'postgres'}),
		 'logrotate', int($self->{'found_hash'}->{'logrotate'}),
		 'webmin', $self->{'in_hash'}->{'webmin'},
		 'name', !$self->{'in_hash'}->{'virt'},
		 'ip', $self->{'in_hash'}->{'ip'},
		 'iface', $self->{'in_hash'}->{'virt'} ? $iface->{'fullname'} : "",
		 'virt', $self->{'in_hash'}->{'virt'},
		 'dns', int($self->{'found_hash'}->{'dns'}),
		 'pass', $self->{'in_hash'}->{'pass'},
		 'db', $self->{'dbs_array'}->[0],
		 'db_mysql', $self->{'in_hash'}->{'found_mysql'},
		 'db_postgres', $self->{'in_hash'}->{'found_postgres'},
		 'prefix',$self->{'in_hash'}->{'dom'},
		 'domslimit','*',
		 'source', 'import.cgi'
		);

	# Work out home directory
	$self->{'dom_hash'}->{'home'} = $self->{'uinfo'} ? $self->{'uinfo'}->{'home'}
			      : $self->server_home_directory(\%{$self->{'dom_hash'}});

	if (!$ginfo) {
		# Create the unix group
		print $self->text('setup_group', $self->{'crgroup'}),"<br>\n";
		$self->foreign_call($self->{'usermodule'}, "lock_user_files");
		%{$self->{'ginfo_hash'}} = ( 'group', $self->{'crgroup'},
			   'gid', $self->{'gid'} );
		$self->foreign_call($self->{'usermodule'}, "set_group_envs", \%{$self->{'ginfo_hash'}}, 'CREATE_GROUP');
		$self->foreign_call($self->{'usermodule'}, "making_changes");
		$self->foreign_call($self->{'usermodule'}, "create_group", \%{$self->{'ginfo_hash'}});
		$self->foreign_call($self->{'usermodule'}, "unlock_user_files");
		$self->foreign_call($self->{'usermodule'}, "made_changes");
		print $self->{'text_hash'}->{'setup_done'},"<p>\n";
		}
	else {
		%{$self->{'ginfo_hash'}} = %$ginfo;
		}

	if (!$self->{'uinfo'}) {
		# Create the Unix user
		# XXX use common function??
		print $self->text('setup_user', $self->{'cruser'}),"<br>\n";
		$self->foreign_call($self->{'usermodule'}, "lock_user_files");
		%{$self->{'uinfo_hash'}} = ( 'user', $self->{'cruser'},
			   'uid', $self->{'uid'},
			   'gid', $self->{'gid'},
			   'pass', $self->foreign_call($self->{'usermodule'},
					"encrypt_password", $self->{'in_hash'}->{'pass'}),
			   'real', $self->{'owner'},
			   'home', $self->{'dom_hash'}->{'home'},
			   'shell', $self->{'config_hash'}->{'unix_shell'},
			   'mailbox', $self->{'cruser'},
			   'dom', $self->{'in_hash'}->{'dom'},
			 );
		$self->set_pass_change(\%{$self->{'uinfo_hash'}});
		$self->foreign_call($self->{'usermodule'}, "set_user_envs", \%{$self->{'uinfo_hash'}}, 'CREATE_USER', $self->{'in_hash'}->{'pass'}, [ ]);
		$self->foreign_call($self->{'usermodule'}, "making_changes");
		$self->foreign_call($self->{'usermodule'}, "create_user", \%{$self->{'uinfo_hash'}});
		$self->foreign_call($self->{'usermodule'}, "unlock_user_files");
		$self->foreign_call($self->{'usermodule'}, "made_changes");
		$self->foreign_call($self->{'usermodule'}, "unlock_user_files");
		print $self->{'text_hash'}->{'setup_done'},"<p>\n";

		if (!-d $self->{'uinfo_hash'}->{'home'}) {
			# Create his home directory, and copy files into it
			print $self->{'text_hash'}->{'setup_home'},"<br>\n";
			$self->system_logged(
			  "mkdir '$self->{'uinfo_hash'}->{'home'}'");
			$self->system_logged(
			  "chmod '$self->{'uconfig_hash'}->{'homedir_perms'}' '$self->{'uinfo_hash'}->{'home'}'");
			$self->system_logged("chown $uid:$self->{'gid'} '$self->{'uinfo_hash'}->{'home'}'");
			$self->copy_skel_files($self->{'config_hash'}->{'virtual_skel'},
					 \%{$self->{'uinfo_hash'}}, $self->{'uinfo_hash'}->{'home'});
			print $self->{'text_hash'}->{'setup_done'},"<p>\n";
			}
		}
	else {
		%{$self->{'uinfo_hash'}} = %{$self->{'uinfo'}};
		}

	# Setup web directories
	print $self->{'text_hash'}->{'import_dirs'},"<br>\n";
	foreach $d ( [ $self->{'config_hash'}->{'html_dir'} || 'public_html', '755' ],
		     [ 'cgi-bin', '755' ],
		     [ 'logs', '755' ],
		     [ $self->{'config_hash'}->{'homes_dir'}, '755' ] ) {
		if (!-d "$self->{'uinfo_hash'}->{'home'}/$d->[0]") {
			$self->system_logged(
				"mkdir '$self->{'uinfo_hash'}->{'home'}/$d->[0]' 2>/dev/null");
			$self->system_logged(
				"chmod $d->[1] '$self->{'uinfo_hash'}->{'home'}/$d->[0]'");
			$self->system_logged(
				"chown $uid:$self->{'ugid'} '$self->{'uinfo_hash'}->{'home'}/$d->[0]'");
			}
		}
	print $self->{'text_hash'}->{'setup_done'},"<p>\n";

	# Create the domain details
	print $self->{'text_hash'}->{'setup_save'},"<br>\n";
	$self->save_domain(\%{$self->{'dom_hash'}});
	print $self->{'text_hash'}->{'setup_done'},"<p>\n";

	# Create or update webmin user
	if ($self->{'in_hash'}->{'webmin'}) {
		$self->require_acl();
		($self->{'wuser'}) = grep { $_->{'name'} eq $self->{'cruser'} } $main::acl_object->list_users();
		if ($self->{'wuser'}) {
			$self->modify_webmin(\%{$self->{'dom_hash'}}, \%{$self->{'dom_hash'}});
			}
		else {
			$self->setup_webmin(\%{$self->{'dom_hash'}});
			}
		}
	$self->run_post_actions();

	# Add to this user's list of domains if needed
	if (!$self->can_edit_domain(\%{$self->{'dom_hash'}})) {
		$self->{'access_hash'}->{'domains'} = join(" ", split(/\s+/, $self->{'access_hash'}->{'domains'}),
					       $self->{'dom_hash'}->{'id'});
		$self->save_module_acl(\%{$self->{'access_hash'}});
		}
	$self->webmin_log("import", "domain", $self->{'dom_hash'}->{'dom'});
	}
else {
	# Just work out what can be done
	print "$self->{'text_hash'}->{'import_idesc'}<p>\n";

	# Work out the Unix username
	if ($self->{'in_hash'}->{'user_def'}) {
		# Creating a new user with a name taken from the domain
		$self->{'in_hash'}->{'dom'} =~ /^([^\.]+)/;
		$self->{'try1'} = $self->{'user'} = $1;
		if (defined(getpwnam($1)) || $self->{'config_hash'}->{'longname'}) {
			$self->{'user'} = $self->{'in_hash'}->{'dom'};
			$self->{'try2'} = $self->{'user'};
			if (defined(getpwnam($self->{'user'}))) {
				&error_exit($self->text('setup_eauto', $self->{'try1'},$self->{'try2'}));
				}
			}
		print "<b>",$self->text('import_user1',
				  "<tt>$self->{'user'}</tt>"),"</b><p>\n";
		}
	else {
		# Using a specified name, which may or may not exist
		if (defined(getpwnam($self->{'in_hash'}->{'user'}))) {
			print "<b>",$self->text('import_user2',
					  "<tt>$self->{'in_hash'}->{'user'}</tt>"),"</b><p>\n";
			}
		else {
			print "<b>",$self->text('import_user3',
					  "<tt>$self->{'in_hash'}->{'user'}</tt>"),"</b><p>\n";
			}
		}

	if ($self->{'in_hash'}->{'group_def'}) {
		# Need to create new group with the same name as the user
		$self->{'group'} = $self->{'user'} || $self->{'in_hash'}->{'user'};
		print "<b>",$self->text('import_group1',
				  "<tt>$self->{'group'}</tt>"),"</b><p>\n";
		}
	else {
		# Using a specified group, which may or may not exist
		if (scalar(@{$self->{'ginfo_array'}} = getgrnam($self->{'in_hash'}->{'group'}))) {
			print "<b>",$self->text('import_group2',
					  "<tt>$self->{'in_hash'}->{'group'}</tt>"),"</b><p>\n";

			setpwent();
			while(@{$self->{'muinfo_array'}} = getpwent()) {
				$self->{'mcount'}++ if ($self->{'muinfo_array'}->[3] == $self->{'ginfo_array'}->[2]);
				}
			endpwent();
			if ($self->{'mcount'}) {
				print "<b>",$self->text('import_mailboxes', $self->{'mcount'},
					  "<tt>$self->{'in_hash'}->{'group'}</tt>"),"</b><p>\n";
				}
			}
		else {
			print "<b>",$self->text('import_group3',
					  "<tt>$self->{'in_hash'}->{'group'}</tt>"),"</b><p>\n";
			}
		}

	# Check for mail domain
	if ($self->{'config_hash'}->{'mail'}) {
		$self->require_mail();
		$self->{'found_hash'}->{'mail'}++ if ($self->is_local_domain($self->{'in_hash'}->{'dom'}));
		if ($self->{'found_hash'}->{'mail'}) {
			print "<b>",$self->text('import_mail',
				"<tt>$self->{'in_hash'}->{'dom'}</tt>"),"</b><p>\n";
			}
		else {
			print $self->text('import_nomail',
				"<tt>$self->{'in_hash'}->{'dom'}</tt>"),"<p>\n";
			}
		}

	# Check for an Apache virtualhost
	if ($self->{'config_hash'}->{'web'}) {
		$self->require_apache();
		($virt, $self->{'vconf'}) = $self->get_apache_virtual($self->{'in_hash'}->{'dom'}, $self->{'web_port'});
		if ($virt) {
			$self->{'found_hash'}->{'web'}++;
			$self->{'sn'} = $main::apache_object->find_directive(
				"ServerName", $virt->{'members'});
			$self->{'dr'} = $main::apache_object->find_directive(
				"DocumentRoot", $virt->{'members'});
			print "<b>",$self->text('import_web',
				"<tt>$self->{'sn'}</tt>", "<tt>$self->{'dr'}</tt>"),"</b><p>\n";
			}
		else {
			print $self->text('import_noweb',
				"<tt>$self->{'in_hash'}->{'dom'}</tt>"),"<p>\n";
			}
		}

	# Check for Webalizer on the virtual host logs
	if ($self->{'config_hash'}->{'webalizer'}) {
		$self->require_webalizer();
		$self->{'log'} = $self->get_apache_log($self->{'in_hash'}->{'dom'});
		if ($self->{'log'} && -r $main::webalizer_object->config_file_name($self->{'log'})) {
			$self->{'found_hash'}->{'webalizer'}++;
			print "<b>",$self->text('import_webalizer',
				    "<tt>$self->{'log'}</tt>"),"</b><p>\n";
			}
		else {
			print $self->text('import_nowebalizer',
				    "<tt>$self->{'log'}</tt>"),"<p>\n";
			}
		}

	# Check for a DNS domain
	if ($self->{'config_hash'}->{'dns'}) {
		$self->require_bind();
		$self->{'conf'} = $main::bind8_object->get_config();
		@{$self->{'zones_array'}} = $main::bind8_object->find("zone", $self->{'conf'});
		foreach $v ($main::bind8_object->find("view", $self->{'conf'})) {
			push(@{$self->{'zones_array'}}, $main::bind8_object->find("zone", $v->{'members'}));
			}
		foreach $z (@{$self->{'zones_array'}}) {
			if ($z->{'value'} eq $self->{'in_hash'}->{'dom'}) {
				$self->{'found_hash'}->{'dns'}++;
				last;
				}
			}
		if ($self->{'found_hash'}->{'dns'}) {
			print "<b>",$self->text('import_dns',
				"<tt>$self->{'in_hash'}->{'dom'}</tt>"),"</b><p>\n";
			}
		else {
			print $self->text('import_nodns',
				"<tt>$self->{'in_hash'}->{'dom'}</tt>"),"<p>\n";
			}
		}

	# Check for databases
	@{$self->{'alldbs_array'}} = $self->all_databases();
	foreach $t ('mysql', 'postgres') {
		foreach $db (split(/\s+/, $self->{'in_hash'}->{'db_'.$t})) {
			local ($got) = grep { $_->{'type'} eq $t &&
					      $_->{'name'} eq $db } @{$self->{'alldbs_array'}};
			if ($got) {
				$self->{'found_hash'}->{$t}++;
				print "<b>",$self->text('import_'.$t,
					"<tt>$db</tt>"),"</b><p>\n";
				}
			else {
				print $self->text('import_no'.$t,
					"<tt>$db</tt>"),"<p>\n";
				}
			push(@{$self->{'dbnames_hash'}->{$t}}, $db);
			}
		}

	# Check for a ProFTPd virtualhost
	if ($self->{'config_hash'}->{'ftp'} && $self->{'in_hash'}->{'virt'}) {
		$self->require_proftpd();
		($virt, $self->{'vconf'}, $self->{'anon'}, $self->{'aconf'}) = $self->get_proftpd_virtual($self->{'in_hash'}->{'ip'});
		if ($virt && $self->{'anon'}) {
			$self->{'found_hash'}->{'ftp'}++;
			print "<b>",$self->text('import_ftp',
				"<tt>$self->{'in_hash'}->{'ip'}</tt>",
				"<tt>$self->{'anon'}->{'value'}</tt>"),"</b><p>\n";
			}
		elsif ($virt) {
			$self->{'found_hash'}->{'ftp'}++;
			print "<b>",$self->text('import_ftpnoanon',
				"<tt>$self->{'in_hash'}->{'ip'}</tt>"),"</b><p>\n";
			}
		else {
			print $self->text('import_noftp',
				"<tt>$self->{'in_hash'}->{'ip'}</tt>"),"<p>\n";
			}
		}

	# Check for an existing logrotate configuration
	if ($self->{'config_hash'}->{'logrotate'}) {
		$self->{'log'} = $self->get_apache_log($self->{'in_hash'}->{'dom'});
		$self->{'lconf'} = $self->get_logrotate_section($self->{'log'});
		if ($self->{'log'} && $self->{'lconf'}) {
			$self->{'found_hash'}->{'logrotate'}++;
			print "<b>",$self->text('import_logrotate',
				    "<tt>$self->{'log'}</tt>"),"</b><p>\n";
			}
		else {
			print $self->text('import_nologrotate',
				    "<tt>$self->{'log'}</tt>"),"<p>\n";
			}
		}

	# Check for plugin features
	foreach $f (@{$self->{'feature_plugins_array'}}) {
		$self->{'pname'} = $self->plugin_call($f, "feature_name");
		if ($self->plugin_call($f, "feature_import", $self->{'in_hash'}->{'dom'},
				 $self->{'user'} || $self->{'in_hash'}->{'user'},
				 $self->{'in_hash'}->{'db'})) {
			$self->{'found_hash'}->{$self->{'p'}}++;
			print "<b>",$self->text('import_plugin', $self->{'pname'}),"</b><p>\n";
			}
		else {
			print $self->text('import_noplugin', $self->{'pname'}),"<p>\n";
			}
		}

	# Tell if a Webmin user will be created
	if ($self->{'in_hash'}->{'webmin'}) {
		$self->require_acl();
		($self->{'wuser'}) = grep { $_->{'name'} eq ($self->{'user'} || $self->{'in_hash'}->{'user'}) }
				$main::acl_object->list_users();
		if ($self->{'wuser'}) {
			print "<b>",$self->text('import_webmin1',
				  "<tt>$self->{'wuser'}->{'name'}</tt>"),"</b><p>\n";
			}
		else {
			print "<b>",$self->text('import_webmin2',
				  "<tt>$self->{'wuser'}->{'name'}</tt>"),"</b><p>\n";
			}
		}
	else {
		print "$self->{'text_hash'}->{'import_nowebmin'}<p>\n";
		}

	# Work out if IP would be assigned
	if ($self->{'in_hash'}->{'virt'}) {
		print "<b>",$self->text('import_virt',
				  "<tt>$iface->{'fullname'}</tt>"),"</b><p>\n";
		}
	else {
		print "$self->{'text_hash'}->{'import_novirt'}<p>\n";
		}

	# Output form with confirm button
	print $self->check_clicks_function();
	print "<center><form action=import.cgi method=post>\n";
	foreach $i (keys %{$self->{'in_hash'}}) {
		print "<input type=hidden name=$i value='",
			$self->html_escape($self->{'in_hash'}->{$i}),"'>\n";
		}
	foreach $f (keys %{$self->{'found_hash'}}) {
		print "<input type=hidden name=found value='$f'>\n";
		}
	foreach $t (keys %{$self->{'dbnames_hash'}}) {
		print "<input type=hidden name=found_$t value='",
		      join(" ", @{$self->{'dbnames_hash'}->{$t}}),"'>\n";
		}
	print "<input type=hidden name=cruser value='$self->{'user'}'>\n";
	print "<input type=hidden name=crgroup value='$self->{'group'}'>\n";
	print "<b>$self->{'text_hash'}->{'import_rusure'}</b><p>\n";
	print "<input type=submit name=confirm value='$self->{'text_hash'}->{'import_ok'}' ",
	      "onClick='check_clicks(form)'>\n";
	print "</form></center>\n";
	}

$self->ui_print_footer($self->{'text_hash'}->{'index_mainpage_url'}, $self->{'text_hash'}->{'index_mainpage'});

1;
		
}

sub error_exit
{
	shift if ($self == $_[0]);

print "<b>",$self->{'text_hash'}->{'import_err'}," : ",@_,"</b><p>\n";
$self->ui_print_footer($self->{'text_hash'}->{'index_mainpage_url'}, $self->{'text_hash'}->{'index_mainpage'});
exit;
}


1;

