#!/usr/bin/perl

&MAIN();

 sub MAIN {
# import_form.cgi
# Display a form for importing an existing mail domain, dns zone, apache
# virtual host and mysql database so that they can be controlled by this module.

&ModuleLoader::preload_module('virtual_server_class', "virtual_server::VirtualserverLib");
$self = new virtual_server::VirtualserverLib:: 'virtual_server_class',%$self;

$self->{'access_hash'}->{'create'} && $self->{'access_hash'}->{'import'} || $self->error($self->{'text_hash'}->{'import_ecannot'});

$self->ui_print_header(undef, $self->{'text_hash'}->{'import_title'}, "");

print "$self->{'text_hash'}->{'import_desc1'}<p>\n";
print "$self->{'text_hash'}->{'import_desc2'}<p>\n";
print "$self->{'text_hash'}->{'import_desc3'}<p>\n";

print "<form action=import.cgi method=post>\n";

print "<input type=hidden name=user_def value=0>";
print "<input type=hidden name=group_def value=0>";
print "<input type=hidden name=webmin value=1>";

print "<table border width=100%>\n";

print "<tr $self->{'tb'}> <td colspan=3><b>$self->{'text_hash'}->{'import_header'}</b></td> </tr>\n";
print "<tr $self->{'cb'}><td><b>$self->{'text_hash'}->{'import_dom'}</b></td> <td colspan=2><input name=dom size=40></td></tr>\n";

print "<tr $self->{'tb'}><td colspan=3><b>$self->{'text_hash'}->{'import_title1'}</b></td> </tr>\n";
print "<tr $self->{'cb'}><td><b>$self->{'text_hash'}->{'import_user'}</b></td> <td colspan=2>",$self->unix_user_input("user"),"</td></tr>\n";
print "<tr $self->{'cb'}><td><b>$self->{'text_hash'}->{'import_group'}</b></td> <td colspan=2>",$self->unix_group_input("group"),"</td></tr>\n";
print "<tr $self->{'cb'}><td><b>$self->{'text_hash'}->{'import_pass'}</b></td> <td colspan=2><input name=pass size=20 type=password></td></tr>\n";
print "<tr $self->{'cb'}><td><b>$self->{'text_hash'}->{'import_pass_confirm'}</b></td><td colspan=2><input name=pass2 size=20 type=password></td> </tr>\n";

if ($self->{'config_hash'}->{'home_quotas'}) {
	print "<tr $self->{'cb'}> <td><b>$self->{'text_hash'}->{'form_quota'}</b></td>\n";
	@{$self->{'defquota_array'}} = split (/ /,$self->{'config_hash'}->{'defquota'});
	if ( !@{$self->{'defquota_array'}} or $#{$self->{'defquota_array'}} eq 0 ) {
	    print "<td colspan=2>",$self->quota_input("quota", $self->{'config_hash'}->{'defquota'},
				      $self->{'config_hash'}->{'home_quotas'}),"</td>\n";
	} else {
	    print "<td colspan=2><select name=quota>\n";
	    foreach $i (@{$self->{'defquota_array'}}) {
		chomp $i;
		print "<option value=\"$i\">$i</option>\n";
	        }
	    print "<option value=\"-1\">$self->{'text_hash'}->{'other'}</option></select>\n";
	    print $self->quota_input("otherquota", "",
			       $self->{'config_hash'}->{'home_quotas'}),"</td>\n";
	    }
	print "</tr>\n";
	}
	
if ($self->{'config_hash'}->{'mysql'}) {
	print "<tr $self->{'cb'}> <td><b>$self->{'text_hash'}->{'import_db_mysql'}</b></td>\n";
	print "<td colspan=2><input name=db_mysql size=40></td> </tr>\n";
	}
if ($self->{'config_hash'}->{'postgres'}) {
	print "<tr $self->{'cb'}> <td><b>$self->{'text_hash'}->{'import_db_postgres'}</b></td>\n";
	print "<td colspan=2><input name=db_postgres size=40></td> </tr>\n";
	}

print "<tr $self->{'tb'}> <td colspan=4><b>" . $self->text('form_header_net', $self->{'t_website'}) . "</b></td> </tr>\n";
$self->foreign_require("net", "net-lib.pl");
local @ifaces = grep { $_->{'name'} !~ /^lo\d*/ } $main::net_object->active_interfaces();
local ($iface) = grep { $_->{'fullname'} eq $self->{'config_hash'}->{'iface'} } @ifaces;
$self->{'defip'} = $self->get_default_ip();
$self->{'defip'} || $self->error($self->{'text_hash'}->{'index_eiface2'});
$self->{'defbcast'} = $main::net_object->{'virtual_netmask'} eq "255.255.255.255" ? '' : $iface->{'broadcast'};
$self->{'defmask'} = $main::net_object->{'virtual_netmask'} || $iface->{'netmask'};
$self->{'device'} = $iface->{'name'};
# create available IP list
local $input_ips;
if (scalar(@ifaces) <= 1) {
            $input_ips = $self->{'defip'};
            $input_ips .= "<input type=hidden name=ip_shared value=\"$self->{'defip'}\">\n";
            $input_ips .= "<input type=hidden name=netmask value=\"$self->{'defmask'}\">\n";
        } else {
                $input_ips = "<select name=ip_shared>\n";
                foreach  (@ifaces) {
                        $input_ips .= sprintf "<option value=\"$_->{address}\" %s>$_->{address}\n", $_->{'address'} eq $self->{'defip'} ? "selected" : "";
                }
                $input_ips .= "</select>\n";
        }

print "<tr $self->{'cb'}> <td><b> $self->{'text_hash'}->{'form_iface'}</b></td>\n";
if ($self->{'config_hash'}->{'all_namevirtual'}) {
            print "<td colspan=3>$self->{'text_hash'}->{'form_ip'}&nbsp;$input_ips",
                  "</td> </tr>\n";
            }
    else {
            print "<td colspan=3>\n";
            print "<input type=radio name=virt value=0 checked> ", $self->text('form_shared', $input_ips),"\n";
            print "</td></tr>\n";

            if ($self->{'config_hash'}->{'ip_ranges'}) {
                    # Can do automatic allocation
                    print "<tr><td>&nbsp;</td><td colspan=3\n";
                    local $alloc = $self->free_ip_address();
                    if ($alloc) {
                                print "<input type=radio name=virt value=1> ", $self->text('form_alloc', $alloc);
                              }
                  else {
                      # None left!
                      print $self->{'text_hash'}->{'form_noalloc'};
                      }
              }
              else {
              # Ask the user to enter
                  print "<tr $self->{'cb'}><td>&nbsp;</td><td valign=top>\n";
                  print "<input type=radio name=virt value=1> ", "$self->{'text_hash'}->{'form_vip'}\n";
                  print "</td><td colspan=2>";
                  print "<table border=0 cellspacing=0 cellpadding=0>";
                  print "<tr><td>$self->{'text_hash'}->{'form_ip'}&nbsp;</td><td><input name=ip size=20 value=''></td></tr>\n";
                  print "<tr><td>$self->{'text_hash'}->{'form_netmask'} &nbsp; </td><td><input type=radio name=automask checked value=0> $self->{'text_hash'}->{form_automatic} <input type=radio name=automask value=1> <input name=netmask size=20 value=''></td></tr>\n";
                  print "<tr><td>$self->{'text_hash'}->{'form_device'}</td><td>";
                  local @devices = map {$_->{'name'}} @ifaces;
                  @devices = $self->unique(@devices);
                  print "<select name=iface>\n";
                  foreach  (@devices) {
                          printf "<option value='$_'>$_\n";
                          }
                  print "</select>\n";
                  print "</td></tr>\n";
                  print "</table>";
#                       print "<input name=ip size=20>\n";
                  }
              print "</td> </tr>\n";
          }
  print "<tr colspan=4><td>&nbsp;</td></tr>";

print "</table>\n";
print "<input type=submit value='$self->{'text_hash'}->{'import_show'}'></form>\n";
$self->ui_print_footer($self->{'text_hash'}->{'index_mainpage_url'}, $self->{'text_hash'}->{'index_mainpage'});

1;
		
}


1;

