#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Show all MySQL and PostgreSQL databases owned by this domain

&ModuleLoader::preload_module('virtual_server_class', "virtual_server::VirtualserverLib");
$self = new virtual_server::VirtualserverLib:: 'virtual_server_class',%$self;

$self->ReadParse();
$self->{'d'} = $self->get_domain($self->{'in_hash'}->{'dom'});
$self->can_edit_domain($self->{'d'}) || $self->error($self->{'text_hash'}->{'edit_ecannot'});

#$self->ui_print_header($self->domain_in($self->{'d'}),$self->{'text_hash'}->{'databases_title'}, "");
$self->ui_print_header($self->domain_in($self->{'d'}),$self->{'text_hash'}->{'databases_title'}, "", undef, undef, 1);

if(!$self->{'d'}->{'mysql'} && !$self->{'d'}->{'postgres'}) {$self->error($self->{'text_hash'}->{'db_ecannot'});};

# Build and show DB list
@{$self->{'dbs_array'}} = sort {$a->{'name'} cmp $b->{'name'}} $self->domain_databases($self->{'d'});
$self->foreign_require("mysql", "mysql-lib.pl");
push (@{$self->{'all_db_array'}},$main::mysql_object->list_databases($self->{'d'}));
$self->foreign_require("postgresql", "postgresql-lib.pl");
push (@{$self->{'all_db_array'}},$main::postgresql_object->list_databases($self->{'d'}));

if (@{$self->{'dbs_array'}}) {
	print $self->ui_columns_start([ $self->{'text_hash'}->{'databases_db'},
				  $self->{'text_hash'}->{'databases_type'} ], "100%");
	foreach $db (@{$self->{'dbs_array'}}) {
                if (grep { "$db->{'name'}" eq "$_" } @{$self->{'all_db_array'}}) {
                    print $self->ui_columns_row(["<a class=menu href='edit_database.cgi?dom=$self->{'in_hash'}->{'dom'}&name=$db->{'name'}&type=$db->{'type'}'>$db->{'name'}</a>", $db->{'desc'},]);
                  } else {
                    print $self->ui_columns_row(["$db->{'name'} ( <a class=menu href='save_database.cgi?dom=$self->{'in_hash'}->{'dom'}&name=$db->{'name'}&type=$db->{'type'}&disc=1'>$self->{'text_hash'}->{'database_disc'}</a> )", "deleted",]);
                    }
		}
	print $self->ui_columns_end();
	}
else {
	print ("<b>",$self->text('databases_none',$self->{'t_website'}),"</b><p>\n");
	}

local @doms = grep { $self->can_edit_domain($_) } $self->list_domains();
local $count = map($self->domain_databases($_),@doms);
local $limit = $self->{'d'}->{'parent'} ? $self->get_domain($self->{'d'}->{'parent'})->{'dbslimit'} : $self->{'d'}->{'dbslimit'};
if (($self->master_admin()) || !$limit || $count<$limit ){
			print "<tr><td>";
		print $self->ui_form_start("edit_database.cgi", "get");
		print $self->ui_hidden("dom", $self->{'in_hash'}->{'dom'}),"\n";
		print $self->ui_hidden("new", 1),"\n";
		print $self->ui_form_end([ [ "ok", $self->{'text_hash'}->{'databases_add'} ] ]);
		print "</td></tr>\n";
	#print "<a href='edit_database.cgi?dom=$self->{'in_hash'}->{'dom'}&new=1'>",
	  #    $self->{'text_hash'}->{'databases_add'},"</a><br>\n";
	}

if ($self->master_admin()) {
	# Show database import form, if there are any not owned by any user
	foreach $dd ($self->list_domains()) {
		foreach $db ($self->domain_databases($dd)) {
			$self->{'inuse_hash'}->{$db->{'type'},$db->{'name'}}++;
			}
		}
	@{$self->{'avail_array'}} = grep { !$self->{'inuse_hash'}->{$_->{'type'},$_->{'name'}} &&
		        !$_->{'special'} } $self->all_databases();
	if (@{$self->{'avail_array'}}) {

		print "<tr><td colspan=2>&nbsp;</td></tr>\n";
		#print "<hr>\n";
		print $self->ui_form_start("import_database.cgi", "post");
		print $self->ui_hidden("dom", $self->{'in_hash'}->{'dom'}),"\n";
		print "<tr $self->{'cb'}> <td><table width=100%>\n";
		print "<tr $self->{'tb'}> <td colspan=2><b>$self->{'text_hash'}->{'databases_iheader'}</b></td> </tr>\n";
		#print &ui_table_start($mtext{'databases_iheader'}, undef, 2);

		print "<tr $self->{'cb'}> <td valign=top><b>$self->{'text_hash'}->{'databases_ilist'}</b></td>\n<td>";
		print $self->ui_select("import", [ ],
			[ map { [ "$_->{'type'} $_->{'name'}", $_->{'name'}." (".$self->{'text_hash'}->{'databases_'.$_->{'type'}}.")"] } @{$self->{'avail_array'}} ], 5, 1);
		print "</td></tr></table></td></tr>";
		#print &ui_table_end();
		print "<tr><td>";
		print $self->ui_form_end([ [ "ok", $self->{'text_hash'}->{'databases_import'} ] ]);
		print "</td></tr>";
		}
	}

#local $website = &ztl_get_text(\%apps, 'text_website:$web', 'text_domain:$dns');

$self->ui_print_footer("", $self->text('index_return', $self->{'t_websites'}),
		 "edit_domain.cgi?dom=$self->{'in_hash'}->{'dom'}", $self->text('edit_return', $self->{'t_websites'}));

#$self->ui_print_footer("edit_domain.cgi?dom=$self->{'in_hash'}->{'dom'}", $self->{'text_hash'}->{'edit_return'},
	#	 "", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

