#!/usr/bin/perl

&MAIN();

 sub MAIN {
# newkey.cgi
# Install a new SSL cert and key

&ModuleLoader::preload_module('virtual_server_class', "virtual_server::VirtualserverLib");
$self = new virtual_server::VirtualserverLib:: 'virtual_server_class',%$self;

$self->ReadParse();
$self->{'d'} = $self->get_domain($self->{'in_hash'}->{'dom'});
$self->{'access_hash'}->{'edit'} && $self->can_edit_domain($self->{'d'}) || $self->error($self->{'text_hash'}->{'edit_ecannot'});

# Validate inputs
$self->error_setup($self->{'text_hash'}->{'newkey_err'});
$self->{'in_hash'}->{'cert'} =~ /BEGIN CERTIFICATE/ &&
  $self->{'in_hash'}->{'cert'} =~ /END CERTIFICATE/ || $self->error($self->{'text_hash'}->{'newkey_ecert'});
$self->{'in_hash'}->{'newkey'} =~ /BEGIN RSA PRIVATE KEY/ &&
  $self->{'in_hash'}->{'newkey'} =~ /END RSA PRIVATE KEY/ || $self->error($self->{'text_hash'}->{'newkey_enewkey'});

$self->ui_print_header("", $self->{'text_hash'}->{'newkey_title'}, "", undef, undef, 1);

# Make sure Apache is setup to use the right key files
$self->require_apache();
$self->{'conf'} = $main::apache_object->get_config();
($self->{'virt'}, $self->{'vconf'}) = $self->get_apache_virtual($self->{'d'}->{'dom'},
                                      $self->{'d'}->{'web_sslport'});
$self->{'d'}->{'ssl_cert'} ||= "$self->{'d'}->{'home'}/ssl.cert";
$self->{'d'}->{'ssl_key'} ||= "$self->{'d'}->{'home'}/ssl.key";
$self->lock_file($self->{'virt'}->{'file'});
$main::apache_object->save_directive("SSLCertificateFile", [ $self->{'d'}->{'ssl_cert'} ],
			$self->{'vconf'}, $self->{'conf'});
$main::apache_object->save_directive("SSLCertificateKeyFile", [ $self->{'d'}->{'ssl_key'} ],
			$self->{'vconf'}, $self->{'conf'});
$self->flush_file_lines();
$self->unlock_file($self->{'virt'}->{'file'});

# Save the cert and private keys
do { my $fn = $self->{'first_print'}; $self->$fn($self->{'text_hash'}->{'newkey_saving'})};
$self->lock_file($self->{'d'}->{'ssl_cert'});
unlink($self->{'d'}->{'ssl_cert'});
$self->open_tempfile(CERT, ">$self->{'d'}->{'ssl_cert'}");
$self->{'in_hash'}->{'cert'} =~ s/\r//g;
$self->print_tempfile(CERT, $self->{'in_hash'}->{'cert'});
$self->close_tempfile(CERT);
chown($self->{'d'}->{'uid'}, $self->{'d'}->{'ugid'}, $self->{'d'}->{'ssl_cert'});
chmod(0755, $self->{'d'}->{'ssl_cert'});
$self->unlock_file($self->{'d'}->{'ssl_cert'});

$self->lock_file($self->{'d'}->{'ssl_key'});
unlink($self->{'d'}->{'ssl_key'});
$self->open_tempfile(CERT, ">$self->{'d'}->{'ssl_key'}");
$self->{'in_hash'}->{'newkey'} =~ s/\r//g;
$self->print_tempfile(CERT, $self->{'in_hash'}->{'newkey'});
$self->close_tempfile(CERT);
chown($self->{'d'}->{'uid'}, $self->{'d'}->{'ugid'}, $self->{'d'}->{'ssl_key'});
chmod(0755, $self->{'d'}->{'ssl_key'});
$self->unlock_file($self->{'d'}->{'ssl_key'});
do { my $fn = $self->{'second_print'}; $self->$fn($self->{'text_hash'}->{'setup_done'})};

# Remove the new private key we just installed
if ($self->{'d'}->{'ssl_newkey'}) {
	$self->{'newkeyfile'} = `cat $self->{'d'}->{'ssl_newkey'}`;
	if ($self->{'newkeyfile'} eq $self->{'in_hash'}->{'newkey'}) {
		unlink($self->{'d'}->{'ssl_newkey'});
		delete($self->{'d'}->{'ssl_newkey'});
		$self->save_domain($self->{'d'});
		}
	}

# Re-start Apache
$self->register_post_action('restart_apache', 1);
$self->run_post_actions();
$self->webmin_log("newkey", "domain", $self->{'d'}->{'dom'}, $self->{'d'});

#$self->ui_print_footer("cert_form.cgi?dom=$self->{'in_hash'}->{'dom'}", $self->{'text_hash'}->{'cert_return'},
#	"edit_domain.cgi?dom=$self->{'in_hash'}->{'dom'}", $self->{'text_hash'}->{'edit_return'},
#	"", $self->{'text_hash'}->{'index_return'});

$self->ui_print_footer($self->{'text_hash'}->{'index_mainpage_url'}, $self->{'text_hash'}->{'index_mainpage'},"", $self->text('index_return', $self->{'t_websites'}), "edit_domain.cgi?dom=$self->{'in_hash'}->{'dom'}", $self->text('edit_return', $self->{'d'}->{'dom'}), "cert_form.cgi?dom=$self->{'in_hash'}->{'dom'}", $self->{'text_hash'}->{'cert_return'});
1;
		
}


1;

