#!/usr/bin/perl

&MAIN();

 sub MAIN {
# rename.cgi
# Actually rename a server

&ModuleLoader::preload_module('virtual_server_class', "virtual_server::VirtualserverLib");
$self = new virtual_server::VirtualserverLib:: 'virtual_server_class',%$self;

$self->ReadParse();
$self->{'d'} = $self->get_domain($self->{'in_hash'}->{'dom'});
$self->{'access_hash'}->{'norename'} && $self->error($self->{'text_hash'}->{'rename_ecannot'});
$self->{'access_hash'}->{'edit'} && $self->can_edit_domain($self->{'d'}) || $self->error($self->{'text_hash'}->{'edit_ecannot'});

# Validate inputs
$self->{'in_hash'}->{'new'} =~ /^[A-Za-z0-9\.\-]+$/ || $self->error($self->{'text_hash'}->{'rename_enew'});
$self->{'in_hash'}->{'new'} = lc($self->{'in_hash'}->{'new'});
$self->{'in_hash'}->{'new'} ne $self->{'d'}->{'dom'} || $self->error($self->{'text_hash'}->{'rename_esame'});
$self->{'in_hash'}->{'new'} .= $self->{'in_hash'}->{'parent'} if ($self->{'in_hash'}->{'parent'});
if (!$self->{'d'}->{'parent'} && $self->master_admin()) {
	if ($self->{'in_hash'}->{'user_mode'} == 1) {
		# Make up a new username
		($self->{'user'}, $self->{'try1'}, $self->{'try2'}) = $self->unixuser_name($self->{'in_hash'}->{'new'});
		$self->{'user'} || $self->error($self->text('setup_eauto', $self->{'try1'}, $self->{'try2'}));
		}
	elsif ($self->{'in_hash'}->{'user_mode'} == 2) {
		# Use the entered username
		$self->{'in_hash'}->{'user'} || $self->error($self->{'text_hash'}->{'rename_euser'});
		$self->{'user'} = $self->{'in_hash'}->{'user'};
		}
	}

# Make sure new domain is valid
local $parentdom = $self->{'d'}->{'parent'} ? $self->get_domain($self->{'d'}->{'parent'})
				  : undef;
if ($parentdom) {
	local $derr = $self->valid_domain_name($parentdom, $self->{'in_hash'}->{'new'});
	$self->error($derr) if ($derr);
	}

# Make sure no domain with the same name already exists
@{$self->{'doms_array'}} = $self->list_domains();
($self->{'clash'}) = grep { $_->{'dom'} eq $self->{'in_hash'}->{'new'} } @{$self->{'doms_array'}};
$self->{'clash'} && $self->error($self->{'text_hash'}->{'rename_eclash'});

# Update the domain object, where appropriate
%{$self->{'oldd_hash'}} = %{$self->{'d'}};
$self->{'d'}->{'dom'} = $self->{'in_hash'}->{'new'};
if ($self->{'user'}) {
	$self->{'d'}->{'user'} = $self->{'user'};
	}
if ($self->{'in_hash'}->{'home_mode'}) {
	$self->{'d'}->{'home'} = $self->server_home_directory($self->{'d'}, $parentdom);
	local $k;
	foreach $k (keys %{$self->{'d'}}) {
		if ($k ne "home") {
			$self->{'d'}->{$k} =~ s/$self->{'oldd_hash'}->{'home'}/$self->{'d'}->{'home'}/g;
			}
		}
	}

# Find any sub-domain objects and update them
if (!$self->{'d'}->{'parent'}) {
	@{$self->{'subs_array'}} = $self->get_domain_by("parent", $self->{'d'}->{'id'});
	foreach $sd (@{$self->{'subs_array'}}) {
		local %oldsd = %$sd;
		push(@{$self->{'oldsubs_array'}}, \%oldsd);
		if ($self->{'user'}) {
			$sd->{'user'} = $self->{'user'};
			}
		if ($self->{'in_hash'}->{'home_mode'}) {
			$sd->{'home'} = $self->server_home_directory($sd, $self->{'d'});
			local $k;
			foreach $k (keys %$sd) {
				$sd->{$k} =~ s/$oldsd{'home'}/$sd->{'home'}/g;
				}
			}
		}
	}

# Find any domains aliases to this one, excluding child domains
@{$self->{'aliases_array'}} = $self->get_domain_by("alias", $self->{'d'}->{'id'});
@{$self->{'aliases_array'}} = grep { $_->{'parent'} != $self->{'d'}->{'id'} } @{$self->{'aliases_array'}};
foreach $ad (@{$self->{'aliases_array'}}) {
	local %oldad = %$ad;
	push(@{$self->{'oldaliases_array'}}, \%oldad);
	}

# Check for domain name clash
local $f;
foreach $f (@{$self->{'features_array'}}) {
	if ($self->{'in_hash'}->{$f}) {
		local $cfunc = "check_${f}_clash";
		if ($self->$cfunc($self->{'d'}, 'dom')) {
			$self->error($self->text('setup_e'.$f, $self->{'in_hash'}->{'dom'}, $self->{'dom_hash'}->{'db'}, $self->{'user'}, $self->{'group'}));
			}
		if ($self->{'user'}) {
			if ($self->$cfunc($self->{'d'}, 'user')) {
				$self->error($self->text('setup_e'.$f, $self->{'in_hash'}->{'dom'},
					     $self->{'dom_hash'}->{'db'}, $self->{'user'}, $self->{'group'}));
				}
			}
		}
	}

# Run the before command
$self->set_domain_envs(\%{$self->{'oldd_hash'}}, "MODIFY_DOMAIN");
$self->{'merr'} = $self->making_changes();
$self->error($self->text('rename_emaking', "<tt>$self->{'merr'}</tt>")) if (defined($self->{'merr'}));

$self->ui_print_unbuffered_header($self->domain_in(\%{$self->{'oldd_hash'}}), $self->{'text_hash'}->{'rename_title'}, "");

print "<b>",$self->text('rename_doing', "<tt>$self->{'in_hash'}->{'new'}</tt>");
print $self->text('rename_doinguser', "<tt>$self->{'user'}</tt>"),"\n" if ($self->{'user'});
print "...</b><p>\n";

# Build the list of domains being changed
@{$self->{'doms_array'}} = ( $self->{'d'} );
@{$self->{'olddoms_array'}} = ( \%{$self->{'oldd_hash'}} );
push(@{$self->{'doms_array'}}, @{$self->{'subs_array'}}, @{$self->{'aliases_array'}});
push(@{$self->{'olddoms_array'}}, @{$self->{'oldsubs_array'}}, @{$self->{'oldaliases_array'}});

if (@{$self->{'doms_array'}} > 1) {
	$self->{'first_print'} = \&first_html_withdom;
	}

# Update all features in all domains
local $f;
foreach $f (@{$self->{'features_array'}}) {
	local $mfunc = "modify_$f";
	local $i;
	for($i=0; $i<@{$self->{'doms_array'}}; $i++) {
		if ($self->{'doms_array'}->[$i]->{$f} && $self->{'config_hash'}->{$f} || $f eq "unix") {
			$self->{'doing_dom'} = $self->{'doms_array'}->[$i];
			local $main::error_must_die = 1;
			eval {
				if ($self->{'doms_array'}->[$i]->{'alias'}) {
					# Is an alias domain, so pass in old
					# and new target domain objects
					local $aliasdom = $self->get_domain(
						$self->{'doms_array'}->[$i]->{'alias'});
					local $idx = $self->indexof($aliasdom, @{$self->{'doms_array'}});
					if ($idx >= 0) {
						$self->try_function($f, $mfunc,
						   $self->{'doms_array'}->[$i], $self->{'olddoms_array'}->[$i],
						   $self->{'doms_array'}->[$idx], $self->{'olddoms_array'}->[$idx]);
						}
					else {
						$self->try_function($f, $mfunc,
						   $self->{'doms_array'}->[$i], $self->{'olddoms_array'}->[$i],
						   $aliasdom, $aliasdom);
						}
					}
				else {
					# Not an alias domain
					$self->try_function($f, $mfunc,
						      $self->{'doms_array'}->[$i], $self->{'olddoms_array'}->[$i]);
					}
				};
			if ($@) {
				do { my $fn = $self->{'second_print'}; $self->$fn($self->text('setup_failure',
					$self->{'text_hash'}->{'feature_'.$f}, $@))};
				}
			}
		}
	}
foreach $f (@{$self->{'feature_plugins_array'}}) {
	for($i=0; $i<@{$self->{'doms_array'}}; $i++) {
		if ($self->{'doms_array'}->[$i]->{$f}) {
			$self->{'doing_dom'} = $self->{'doms_array'}->[$i];
			$self->plugin_call($f, "feature_modify", $self->{'doms_array'}->[$i], $self->{'olddoms_array'}->[$i]);
			}
		}
	}

if ($self->{'d'}->{'parent'}) {
	# Update the parent Webmin user to refresh ACLs for new domain
	$parentdom = $self->get_domain($self->{'d'}->{'parent'});
	$self->modify_webmin($parentdom, $parentdom);
	}
$self->run_post_actions();

# Save all new domain details
print $self->{'text_hash'}->{'save_domain'},"<br>\n";
for($i=0; $i<@{$self->{'doms_array'}}; $i++) {
	$self->save_domain($self->{'doms_array'}->[$i]);
	}
print $self->{'text_hash'}->{'setup_done'},"<p>\n";

# Run the after command
$self->set_domain_envs($self->{'d'}, "MODIFY_DOMAIN");
$self->made_changes();
$self->webmin_log("rename", "domain", $self->{'oldd_hash'}->{'dom'}, $self->{'d'});

#$self->ui_print_footer("edit_domain.cgi?dom=$self->{'in_hash'}->{'dom'}", $self->{'text_hash'}->{'edit_return'},
#	"", $self->{'text_hash'}->{'index_return'});
		$self->ui_print_footer("$self->{'text_hash'}->{'index_mainpage_url'}", $self->{'text_hash'}->{'index_mainpage'},"",  $self->text('index_return', $self->{'t_website'}),"edit_domain.cgi?dom=$self->{'in_hash'}->{'dom'}", $self->text('edit_return', $self->{'t_website'}) );
1;
		
}

# Setup print function to include domain name
sub first_html_withdom
{
	shift if ($self == $_[0]);

print $self->text('rename_dd', $self->{'doing_dom'}->{'dom'})," : ",@_,"<br>\n";
}


1;

