#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Actually restore some servers, after asking for confirmation

&ModuleLoader::preload_module('virtual_server_class', "virtual_server::VirtualserverLib");
$self = new virtual_server::VirtualserverLib:: 'virtual_server_class',%$self;

$self->master_admin() || $self->error($self->{'text_hash'}->{'restore_ecannot'});
$self->ReadParse();

# Validate inputs
$self->error_setup($self->{'text_hash'}->{'restore_err'});
if ($self->{'in_hash'}->{'src'}) {
	$self->{'src'} = $self->{'in_hash'}->{'src'};
	}
else {
	$self->{'src'} = $self->parse_backup_destination("src", \%{$self->{'in_hash'}});
	}
($self->{'mode'}) = $self->parse_backup_url($self->{'src'});
$self->{'mode'} > 0 || -r $self->{'src'} || -d $self->{'src'} || $self->error($self->{'text_hash'}->{'restore_esrc'});
@{$self->{'do_features_array'}} = split(/\0/, $self->{'in_hash'}->{'feature'});
@{$self->{'do_features_array'}} || $self->error($self->{'text_hash'}->{'restore_efeatures'});
%{$self->{'do_features_hash'}} = map { $_, 1 } @{$self->{'do_features_array'}};

# Parse option inputs
foreach $f (@{$self->{'do_features_array'}}) {
	local $ofunc = "parse_restore_$f";
	if ($self->can($ofunc)) {
		$self->{'options_hash'}->{$f} = $self->$ofunc(\%{$self->{'in_hash'}});
		}
	}
$self->{'options_hash'}->{'reuid'} = $self->{'in_hash'}->{'reuid'};

$self->{'cont'} = $self->backup_contents($self->{'src'});
if (!$self->{'in_hash'}->{'confirm'}) {
	# See what is in the tar file or directory
	ref($self->{'cont'}) || $self->error($self->text('restore_efile', $self->{'cont'}));
	(keys %{$self->{'cont'}}) || $self->error($self->{'text_hash'}->{'restore_enone'});
	}
else {
	# Find the selected domains
	foreach $d (split(/\0/, $self->{'in_hash'}->{'dom'})) {
		local $dinfo = $self->get_domain_by("dom", $d);
		if ($dinfo) {
			push(@{$self->{'doms_array'}}, $dinfo);
			}
		else {
			push(@{$self->{'doms_array'}}, { 'dom' => $d,
				      'missing' => 1 });
			}
		}
	@{$self->{'doms_array'}} || $self->error($self->{'text_hash'}->{'restore_edoms'});
	}

if ($self->{'in_hash'}->{'confirm'}) {
        $self->ui_print_unbuffered_header(undef, $self->text('restore_title1' ,$self->{'t_websites_mail'}), "",undef, 0, 1);
	#$self->ui_print_unbuffered_header(undef, $self->{'text_hash'}->{'restore_title'}, "");
	}
else {
	$self->ui_print_header(undef, $self->text('restore_title' ,$self->{'t_websites_mail'}), "",undef, 0, 1);
	#$self->ui_print_header(undef, $self->{'text_hash'}->{'restore_title'}, "");
	}

if (!$self->{'in_hash'}->{'confirm'}) {
	# Tell the user what will be done
	print "<form action=restore.cgi method=post>\n";
	print $self->text('restore_from', "<tt>$self->{'src'}</tt>"),"<p>\n";
	print "<dl>\n";
	foreach $d (sort { $a cmp $b } keys %{$self->{'cont'}}) {
		print "<dt><input type=checkbox name=dom ",
		      "value='$d' checked><b>$d</b>\n";
		if (!$self->get_domain_by("dom", $d)) {
			print "($self->{'text_hash'}->{'restore_create'})\n";
			}
		@{$self->{'dfeats_array'}} = grep { $self->{'do_features_hash'}->{$_} } @{$self->{'cont'}->{$d}};
		if (!@{$self->{'dfeats_array'}}) {
			print "<dd><i>$self->{'text_hash'}->{'restore_nofeat'}</i>\n";
			}
		else {
			print "<dd>",join("<br>",
				map { $self->{'text_hash'}->{'backup_feature_'.$_} ||
				      $self->{'text_hash'}->{'feature_'.$_} } @{$self->{'dfeats_array'}}),"\n";
			$self->{'any'}++;
			}
		}
	print "</dl>\n";
	if ($self->{'any'}) {
		# Pass all HTML inputs to program again, and show OK button
		print "<input type=hidden name=src value='",
		      $self->html_escape($self->{'src'}),"'>\n";
		foreach $i (keys %{$self->{'in_hash'}}) {
			next if ($i =~ /^src_/);
			foreach $v (split(/\0/, $self->{'in_hash'}->{$i})) {
				print "<input type=hidden name='$i' value='$v'>\n";
				}
			}
		print "<center><input type=submit name=confirm value='$self->{'text_hash'}->{'restore_now2'}'></center>\n";
		}
	else {
		print "$self->{'text_hash'}->{'restore_notany'}<p>\n";
		}
	print "</form>\n";
	}
else {
	# Actually execute the restore
	print "<p>",$self->text('restore_doing', scalar(@{$self->{'doms_array'}}), "<tt>$self->{'src'}</tt>"),"<p>\n";
	$self->{'ok'} = $self->restore_domains($self->{'src'}, \@{$self->{'doms_array'}}, \@{$self->{'do_features_array'}}, \%{$self->{'options_hash'}});
	$self->run_post_actions();
	if ($self->{'ok'}) {
		print $self->text('restore_done'),"<p>\n";
		}
	else {
		print $self->text('restore_failed'),"<p>\n";
		}
	$self->webmin_log("restore", $self->{'src'}, undef,
		    { 'doms' => [ map { $_->{'dom'} } @{$self->{'doms_array'}} ] });
	}

#$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
$self->ui_print_footer("$self->{'text_hash'}->{'index_mainpage_url'}", $self->{'text_hash'}->{'index_mainpage'},"",$self->text('index_return', $self->{'t_website'}));

1;
		
}


1;

