#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_alias.cgi
# Create, update or delete an alias

&ModuleLoader::preload_module('virtual_server_class', "virtual_server::VirtualserverLib");
$self = new virtual_server::VirtualserverLib:: 'virtual_server_class',%$self;

$self->ReadParse();
$self->{'d'} = $self->get_domain($self->{'in_hash'}->{'dom'});
$self->can_edit_domain($self->{'d'}) || $self->error($self->{'text_hash'}->{'aliases_ecannot'});
@{$self->{'aliases_array'}} = $self->list_domain_aliases($self->{'d'});
if (!$self->{'in_hash'}->{'new'}) {
	($self->{'virt'}) = grep { $_->{'from'} eq $self->{'in_hash'}->{'old'} } @{$self->{'aliases_array'}};
	%{$self->{'oldvirt_hash'}} = %{$self->{'virt'}};
	}
$self->error_setup($self->{'text_hash'}->{'alias_err'});

if ($self->{'in_hash'}->{'delete'}) {
	# Just delete the virtuser
	$self->delete_virtuser($self->{'virt'});
	$self->webmin_log("delete", "alias", $self->{'virt'}->{'from'}, $self->{'virt'});
	}
else {
	# Verify inputs
	$self->{'in_hash'}->{'name_def'} || $self->{'in_hash'}->{'name'} =~ /^[A-Za-z0-9\.\-\_]+$/ ||
		$self->error($self->{'text_hash'}->{'alias_ename'});
	$self->{'name'} = $self->{'in_hash'}->{'name_def'} ? "" : $self->{'in_hash'}->{'name'};
	$self->{'virt'}->{'from'} = $self->{'name'}."\@".$self->{'d'}->{'dom'};
	@{$self->{'values_array'}} = $self->parse_alias($self->{'in_hash'}->{'name_def'}, $self->{'in_hash'}->{'name'},
			       %{$self->{'oldvirt_hash'}} ? $self->{'oldvirt_hash'}->{'to'} : undef, "alias", $self->{'d'});
	@{$self->{'values_array'}} || $self->error($self->{'text_hash'}->{'alias_enone'});
	$self->{'virt'}->{'to'} = \@{$self->{'values_array'}};

	if ($self->{'in_hash'}->{'new'}) {
		# Check for a clash
		if ($self->check_clash($self->{'name'}, $self->{'d'}->{'dom'})) {
			$self->error($self->{'text_hash'}->{'alias_eclash'});
			}

		# Create the virtuser
		$self->create_virtuser($self->{'virt'});
		$self->webmin_log("create", "alias", $self->{'virt'}->{'from'}, $self->{'virt'});
		}
	else {
		if ($self->{'virt'}->{'from'} ne $self->{'in_hash'}->{'old'}) {
			# Has been renamed .. check for a clash
			if ($self->check_clash($self->{'name'}, $self->{'d'}->{'dom'})) {
				$self->error($self->{'text_hash'}->{'alias_eclash'});
				}
			}

		# Modify virtuser
		$self->modify_virtuser(\%{$self->{'oldvirt_hash'}}, $self->{'virt'});
		$self->webmin_log("modify", "alias", $self->{'virt'}->{'from'}, $self->{'virt'});
		}
	}
$self->redirect("list_aliases.cgi?dom=$self->{'in_hash'}->{'dom'}");

1;
		
}


1;

