#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Create or delete a database

&ModuleLoader::preload_module('virtual_server_class', "virtual_server::VirtualserverLib");
$self = new virtual_server::VirtualserverLib:: 'virtual_server_class',%$self;

$self->ReadParse();
$self->{'d'} = $self->get_domain($self->{'in_hash'}->{'dom'});
$self->can_edit_domain($self->{'d'}) || $self->error($self->{'text_hash'}->{'edit_ecannot'});
if ($self->{'in_hash'}->{'new'}) {
	# Create one, after checking for clashes
	$self->error_setup($self->{'text_hash'}->{'database_err'});
	$self->{'in_hash'}->{'name'} =~ /^[a-z0-9\_]+$/i && $self->{'in_hash'}->{'name'} =~ /^[a-z]/i ||
		$self->error($self->{'text_hash'}->{'database_ename'});
        if ($self->indexof($self->{'in_hash'}->{'type'}, @{$self->{'database_plugins_array'}}) >= 0) {
                $self->plugin_call($self->{'in_hash'}->{'type'}, "database_clash", $self->{'d'}, $self->{'in_hash'}->{'name'}) &&
                        $self->error($self->{'text_hash'}->{'database_eclash'});
                }
        else {
                $self->{'cfunc'} = "check_".$self->{'in_hash'}->{'type'}."_database_clash";
                do { my $fn = $self->{'cfunc'}; $self->$fn($self->{'d'}, $self->{'in_hash'}->{'name'}) &&
                        $self->error($self->{'text_hash'}->{'database_eclash'})};
                }

	local @doms = grep { $self->can_edit_domain($_) } $self->list_domains();
	local $count = map($self->domain_databases($_),@doms);
	local $limit = $self->{'d'}->{'parent'} ? $self->get_domain($self->{'d'}->{'parent'})->{'dbslimit'} : $self->{'d'}->{'dbslimit'};

	(!$limit || $count<$limit) || $self->error($self->{'text_hash'}->{'database_elimit'});

	# Go for it
	$self->ui_print_header($self->domain_in($self->{'d'}), $self->{'text_hash'}->{'database_title0'}, "");
        if ($self->indexof($self->{'in_hash'}->{'type'}, @{$self->{'database_plugins_array'}}) >= 0) {
                $self->plugin_call($self->{'in_hash'}->{'type'}, "database_create", $self->{'d'}, $self->{'in_hash'}->{'name'});
                }
        else {
                $self->{'crfunc'} = "create_".$self->{'in_hash'}->{'type'}."_database";
                do { my $fn = $self->{'crfunc'}; $self->$fn($self->{'d'}, $self->{'in_hash'}->{'name'})};
                }
	$self->save_domain($self->{'d'});
	&update_webmin_dbs();
	}
elsif ($self->{'in_hash'}->{'delete'} && !$self->{'in_hash'}->{'confirm'}) {
	# Ask the user if he wants to delete
	$self->ui_print_header($self->domain_in($self->{'d'}), $self->{'text_hash'}->{'database_title3'}, "");
	print "<center>",$self->text('database_rusure', $self->{'in_hash'}->{'name'}),"<p>\n";
	print $self->ui_form_start("save_database.cgi", "post");
	foreach $i ("dom", "name", "type", "delete") {
		print $self->ui_hidden($i, $self->{'in_hash'}->{$i}),"\n";
		}
	print $self->ui_submit($self->{'text_hash'}->{'database_ok'}, "confirm"),"</center>\n";
	print $self->ui_form_end();
	}
elsif ($self->{'in_hash'}->{'delete'}) {
	# Delete now
	$self->ui_print_header($self->domain_in($self->{'d'}), $self->{'text_hash'}->{'database_title3'}, "");
        if ($self->indexof($self->{'in_hash'}->{'type'}, @{$self->{'database_plugins_array'}}) >= 0) {
                $self->plugin_call($self->{'in_hash'}->{'type'}, "database_delete", $self->{'d'}, $self->{'in_hash'}->{'name'});
                }
        else {
                $self->{'dfunc'} = "delete_".$self->{'in_hash'}->{'type'}."_database";
                do { my $fn = $self->{'dfunc'}; $self->$fn($self->{'d'}, $self->{'in_hash'}->{'name'})};
                }
	&save_domain_print($self->{'d'});
	&update_webmin_dbs();
	}
elsif ($self->{'in_hash'}->{'disc'}) {
	# Remove from server's list
	$self->ui_print_header($self->domain_in($self->{'d'}), $self->{'text_hash'}->{'database_title4'}, "");
	@{$self->{'dbs_array'}} = split(/\s+/, $self->{'d'}->{'db_'.$self->{'in_hash'}->{'type'}});
	@{$self->{'dbs_array'}} = grep { $_ ne $self->{'in_hash'}->{'name'} } @{$self->{'dbs_array'}};
	$self->{'d'}->{'db_'.$self->{'in_hash'}->{'type'}} = join(" ", @{$self->{'dbs_array'}});
	&save_domain_print($self->{'d'});
	&update_webmin_dbs();
	}

#local $website = &ztl_get_text(\%apps, 'text_website:$web', 'text_domain:$dns');

$self->ui_print_footer("", $self->text('index_return', $self->{'t_website'}), "edit_domain.cgi?dom=$self->{'in_hash'}->{'dom'}", 
		$self->text('edit_return', $self->{'t_website'}), "list_databases.cgi?dom=$self->{'in_hash'}->{'dom'}",
		 $self->text('databases_return', $self->{'t_website'}));

#$self->ui_print_footer("list_databases.cgi?dom=$self->{'in_hash'}->{'dom'}", $self->{'text_hash'}->{'databases_return'},
#		 "edit_domain.cgi?dom=$self->{'in_hash'}->{'dom'}", $self->{'text_hash'}->{'edit_return'},
#		 "", $self->{'text_hash'}->{'index_return'});

1;
		
}

sub update_webmin_dbs
{
	shift if ($self == $_[0]);

if ($self->{'d'}->{'parent'}) {
	# Refresh parent Webmin user
	$self->{'parentdom'} = $self->get_domain($self->{'d'}->{'parent'});
	$self->modify_webmin($self->{'parentdom'}, $self->{'parentdom'});
	}
else {
	$self->modify_webmin($self->{'d'}, $self->{'d'});
	}
}

sub save_domain_print
{
	shift if ($self == $_[0]);

do { my $fn = $self->{'first_print'}; $self->$fn($self->{'text_hash'}->{'setup_save'})};
$self->save_domain($_[0]);
do { my $fn = $self->{'second_print'}; $self->$fn($self->{'text_hash'}->{'setup_done'})};
}


1;

