#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_domain.cgi
# Update or delete a domain

&ModuleLoader::preload_module('virtual_server_class', "virtual_server::VirtualserverLib");
$self = new virtual_server::VirtualserverLib:: 'virtual_server_class',%$self;

$self->require_bind() if ($self->{'config_hash'}->{'dns'});
$self->require_useradmin();
$self->require_mail() if ($self->{'config_hash'}->{'mail'});
$self->ReadParse();
$self->{'d'} = $self->get_domain($self->{'in_hash'}->{'dom'});
$self->{'access_hash'}->{'edit'} && $self->can_edit_domain($self->{'d'}) || $self->error($self->{'text_hash'}->{'edit_ecannot'});
$self->{'oldd'} = { %{$self->{'d'}} };

$self->{'in_hash'}->{'ip'} = $self->{'in_hash'}->{'ip_shared'} if $self->{'config_hash'}->{'all_namevirtual'} || (!$self->{'in_hash'}->{'virt'} && !$self->{'d'}->{'virt'} && $self->{'access_hash'}->{'edit'} == 1);
$self->{'in_hash'}->{'domslimit_def'} = $self->{'in_hash'}->{'domslimit_def'} ? 2 : 0;

# Validate inputs
$self->error_setup($self->{'text_hash'}->{'save_err'});
$self->{'in_hash'}->{'uquota_def'} = $self->{'in_hash'}->{'quota_def'};
if ($self->{'config_hash'}->{'home_quotas'} && !$self->{'d'}->{'parent'} && $self->{'access_hash'}->{'edit'} == 1 && $self->{'config_hash'}->{'quota_def'} == 0) {
	$self->{'in_hash'}->{'uquota'} = $self->{'in_hash'}->{'quota'};
	if ($self->{'in_hash'}->{'quota'} eq -1) { $self->{'in_hash'}->{'quota'} = $self->{'in_hash'}->{'otherquota'} };
# 	if ($self->{'in_hash'}->{'uquota'} eq -1) { $self->{'in_hash'}->{'uquota'} = $self->{'in_hash'}->{'otheruquota'} };
	$self->{'in_hash'}->{'quota_def'} || $self->{'in_hash'}->{'quota'} =~ /^\d+(\.\d*)?$/ ||
		$self->error($self->{'text_hash'}->{'save_equota'});
# 	$self->{'in_hash'}->{'uquota_def'} || $self->{'in_hash'}->{'uquota'} =~ /^\d+$/ ||
# 		$self->error($self->{'text_hash'}->{'save_euquota'});
	}
if ($self->{'config_hash'}->{'bw_active'} && !$self->{'d'}->{'parent'} && $self->master_admin()) {
	$self->{'d'}->{'bw_limit'} = $self->parse_bandwidth("bw", $self->{'text_hash'}->{'save_ebwlimit'});
	}
$self->{'d'}->{'db'} = $self->database_name($self->{'d'}) if (!$self->{'d'}->{'db'});
if ($self->{'d'}->{'proxy_pass_mode'} == 1 && !$self->{'d'}->{'web'}) {
	# Updating existing proxy
	$self->{'in_hash'}->{'proxy_pass'} =~ /^(http|https):\/\/\S+$/ ||
		$self->error($self->{'text_hash'}->{'setup_eproxy'});
	$self->{'d'}->{'proxy_pass'} = $self->{'in_hash'}->{'proxy_pass'};
	}
if (defined($self->{'in_hash'}->{'proxy'})) {
	if ($self->{'in_hash'}->{'proxy_def'}) {
		# Turning off proxying
		$self->{'d'}->{'proxy_pass'} = undef;
		$self->{'d'}->{'proxy_pass_mode'} = 0;
		}
	else {
		# Turning on proxying and web
		$self->{'in_hash'}->{'proxy'} =~ /^(http|https):\/\/\S+$/ ||
			$self->error($self->{'text_hash'}->{'setup_eproxy'});
		$self->{'d'}->{'proxy_pass'} = $self->{'in_hash'}->{'proxy'};
		$self->{'d'}->{'proxy_pass_mode'} = $self->{'config_hash'}->{'proxy_pass'};
		}
	}

# Work out which features are relevant
@{$self->{'dom_features_array'}} = $self->{'d'}->{'alias'} ? @{$self->{'alias_features_array'}} :
		$self->{'d'}->{'parent'} ? ( grep { $_ ne "webmin" } @{$self->{'features_array'}} ) :
			         @{$self->{'features_array'}};

# Work around possible bad 'db' name
if (!$self->{'d'}->{'mysql'} && $self->{'in_hash'}->{'mysql'} && $self->check_mysql_clash($self->{'d'}, 'db')) {
	$self->{'d'}->{'db'} = $self->database_name($self->{'d'});
	}

# Check for various clashes
%{$self->{'newdom_hash'}} = %{$self->{'d'}};
foreach $f (@{$self->{'dom_features_array'}}, @{$self->{'feature_plugins_array'}}) {
        if ($self->{'in_hash'}->{$f}) {
		$self->{'newdom_hash'}->{$f} = 1;
		if (!$self->{'d'}->{$f}) {
			$self->{'check_hash'}->{$f}++;
			}
		}
	else {
		$self->{'newdom_hash'}->{$f} = 0;
		}
	}
$self->{'newdom_hash'}->{'virt'} = $self->{'in_hash'}->{'virt'};
$self->{'newdom_hash'}->{'ip'} = $self->{'in_hash'}->{'ip'};
$self->{'derr'} = $self->virtual_server_depends(\%{$self->{'newdom_hash'}});
$self->error($self->{'derr'}) if ($self->{'derr'});
$self->{'cerr'} = $self->virtual_server_clashes(\%{$self->{'newdom_hash'}}, \%{$self->{'check_hash'}});
$self->error($self->{'cerr'}) if ($self->{'cerr'});

# Update features list what have been enabled
foreach $f (@{$self->{'dom_features_array'}}, @{$self->{'feature_plugins_array'}}) {
	$self->{'in_hash'}->{$f} = $self->{'newdom_hash'}->{$f};
	}

if (!$self->{'d'}->{'alias'}) {
	if ($self->{'config_hash'}->{'all_namevirtual'} || (!$self->{'in_hash'}->{'virt'} && !$self->{'d'}->{'virt'} && $self->{'access_hash'}->{'edit'} == 1)) {
		# Make sure any new IP *is* assigned
		$self->check_ipaddress($self->{'in_hash'}->{'ip'}) || $self->error($self->{'text_hash'}->{'setup_eip'});
		if ($self->{'d'}->{'ip'} ne $self->{'in_hash'}->{'ip'} && !$self->check_virt_clash($self->{'in_hash'}->{'ip'})) {
			$self->error($self->text('setup_evirtclash2'));
			}
		}
	elsif ($self->{'in_hash'}->{'virt'} && !$self->{'d'}->{'virt'}) {
		if ($self->{'config_hash'}->{'ip_ranges'}) {
			# Allocate the IP now
			$self->{'in_hash'}->{'ip'} = $self->free_ip_address();
			$self->{'in_hash'}->{'ip'} || $self->text('setup_evirtalloc');
			}
		else {
			# Make sure the IP isn't assigned yet
			$self->check_ipaddress($self->{'in_hash'}->{'ip'}) ||
				$self->error($self->{'text_hash'}->{'setup_eip'});
			if ($self->check_virt_clash($self->{'in_hash'}->{'ip'})) {
				$self->error($self->text('setup_evirtclash'));
				}
			}
		}
	}

# Check if any features are being deleted, and if so ask the user if
# he is sure
if (!$self->{'in_hash'}->{'confirm'} && !$self->{'d'}->{'disabled'}) {
	local @losing;
	foreach $f (@{$self->{'dom_features_array'}}) {
		if ($self->{'config_hash'}->{$f} && $self->{'d'}->{$f} && !$self->{'in_hash'}->{$f}) {
			push(@losing, $f);
			}
		}
	foreach $f (@{$self->{'feature_plugins_array'}}) {
		if ($self->{'d'}->{$f} && !$self->{'in_hash'}->{$f}) {
			push(@{$self->{'plosing_array'}}, $f);
			}
		}
	if (@losing || @{$self->{'plosing_array'}}) {
		$self->ui_print_header($self->domain_in($self->{'d'}), $self->text('save_title', $self->{'t_website'}), "", undef, undef, 1);

		print "<p>",$self->text('save_rusure',"<tt>$self->{'d'}->{'dom'}</tt>"),"<p>\n";
		print "<ul>\n";
		local $pfx = $self->{'d'}->{'parent'} ? "sublosing_" : "losing_";
		foreach $f (@losing) {
			print "<li>",$self->{'text_hash'}->{'feature_'.$f}," - ",
				     $self->{'text_hash'}->{$pfx.$f},"<br>\n";
			}
		foreach $f (@{$self->{'plosing_array'}}) {
			print "<li>",$self->plugin_call($f, "feature_name")," - ",
			     $self->plugin_call($f, "feature_losing"),"<br>\n";
			}
		print "</ul>\n";

		print $self->check_clicks_function();
		print "<center><form action=save_domain.cgi>\n";
		foreach $k (keys %{$self->{'in_hash'}}) {
			foreach $v (split(/\0/, $self->{'in_hash'}->{$k})) {
				print "<input type=hidden name=$k value='",
				      $self->html_escape($v),"'>\n";
				}
			}
		print "<input type=submit name=confirm ",
		      "value='$self->{'text_hash'}->{'save_dok'}' ",
		      "onClick='check_clicks(form)'>\n";
		print "</form></center>\n";

		$self->ui_print_footer($self->{'text_hash'}->{'index_mainpage_url'}, $self->{'text_hash'}->{'index_mainpage'},
			"", $self->text('index_return', $self->{'t_websites'}),
			"edit_domain.cgi?dom=$self->{'in_hash'}->{'dom'}", $self->text('edit_return', $self->{'t_website'}));
		exit;
		}
	}

# Make the changes
$self->ui_print_unbuffered_header($self->domain_in($self->{'d'}), $self->text('save_title2', $self->{'t_website'}), "", undef, undef, 1);

# Run the before command
$self->set_domain_envs($self->{'d'}, "MODIFY_DOMAIN");
$self->{'merr'} = $self->making_changes();
$self->error($self->text('save_emaking', "<tt>$self->{'merr'}</tt>")) if (defined($self->{'merr'}));

# Update description, password and quotas in domain object
$self->{'d'}->{'owner'} = $self->{'in_hash'}->{'owner'};
if (!$self->{'in_hash'}->{'passwd_def'}) {
	if ($self->{'d'}->{'disabled'}) {
		# Clear any saved passwords, as they should
		# be reset at this point
		$self->{'d'}->{'disabled_mysqlpass'} = undef;
		$self->{'d'}->{'disabled_postgrespass'} = undef;
		}
	$self->{'in_hash'}->{'passwd'} == $self->{'in_hash'}->{'passwd2'} || $self->error($self->{'text_hash'}->{'setup_epassconfirm'});
	$self->{'d'}->{'pass'} = $self->{'in_hash'}->{'passwd'};
	$self->{'d'}->{'pass_set'} = 1;	# indicates that the password has been changed
	}
else {
	$self->{'d'}->{'pass_set'} = 0;
	}
if ($self->{'config_hash'}->{'home_quotas'} && !$self->{'d'}->{'parent'} && $self->{'access_hash'}->{'edit'} == 1) {
	$self->{'d'}->{'uquota'} = $self->{'in_hash'}->{'uquota_def'} ? undef :
				$self->quota_parse('uquota', $self->{'config_hash'}->{'home_quotas'});
	$self->{'d'}->{'quota'} = $self->{'in_hash'}->{'quota_def'} ? undef :
				$self->quota_parse('quota', $self->{'config_hash'}->{'home_quotas'});
	}

# Validate and store limit inputs
if ($self->{'access_hash'}->{'edit'} == 1 && !$self->{'d'}->{'parent'}) {
	$self->{'in_hash'}->{'mailboxlimit_def'} || $self->{'in_hash'}->{'mailboxlimit'} =~ /^\d+$/ ||
		$self->error($self->{'text_hash'}->{'setup_emailboxlimit'});
	$self->{'d'}->{'mailboxlimit'} = $self->{'in_hash'}->{'mailboxlimit_def'} ? undef : $self->{'in_hash'}->{'mailboxlimit'};
	$self->{'in_hash'}->{'dbslimit_def'} || $self->{'in_hash'}->{'dbslimit'} =~ /^\d+$/ ||
		$self->error($self->{'text_hash'}->{'setup_edbslimit'});
	$self->{'d'}->{'dbslimit'} = $self->{'in_hash'}->{'dbslimit_def'} ? undef : $self->{'in_hash'}->{'dbslimit'};
	$self->{'in_hash'}->{'domslimit_def'} || $self->{'in_hash'}->{'domslimit'} =~ /^\d+$/ ||
		$self->error($self->{'text_hash'}->{'limit_edoms'});
	$self->{'d'}->{'domslimit'} = $self->{'in_hash'}->{'domslimit_def'} == 1 ? undef : $self->{'in_hash'}->{'domslimit_def'} == 2 ? "*" : $self->{'in_hash'}->{'domslimit'};
	}

$self->{'d'}->{'email'} = $self->{'in_hash'}->{'email_def'} ? undef : $self->{'in_hash'}->{'email'};

# Update password and email in subdomains
foreach $sd ($self->get_domain_by("parent", $self->{'d'}->{'id'})) {
	$sd->{'pass'} = $self->{'d'}->{'pass'};
	$sd->{'email'} = $self->{'d'}->{'email'};
	}

if (($self->{'config_hash'}->{'all_namevirtual'} || (!$self->{'in_hash'}->{'virt'} && !$self->{'oldd'}->{'virt'} && $self->{'access_hash'}->{'edit'} == 1)) && !$self->{'d'}->{'alias'}) {
	# Possibly changing IP
	$self->{'d'}->{'ip'} = $self->{'in_hash'}->{'ip'};
	delete($self->{'d'}->{'dns_ip'});
	}
elsif ($self->{'in_hash'}->{'virt'} && !$self->{'d'}->{'virt'}) {
	# Need to bring up IP
	$self->{'d'}->{'ip'} = $self->{'in_hash'}->{'ip'};
	$self->{'d'}->{'virt'} = 1;
	$self->{'d'}->{'name'} = 0;
	delete($self->{'d'}->{'dns_ip'});
	$self->setup_virt($self->{'d'});
	}
if ($self->{'d'}->{'alias'} && !$self->{'d'}->{'ip'}) {
	# IP lost bug to bug! Fix it up ..
	$self->{'aliasdom'} = $self->get_domain($self->{'d'}->{'alias'});
	$self->{'d'}->{'ip'} = $self->{'aliasdom'}->{'ip'};
	}

if (!$self->{'d'}->{'disabled'}) {
	# Enable or disable features
	local $f;
	foreach $f (@{$self->{'dom_features_array'}}) {
		if ($self->{'config_hash'}->{$f}) {
			$self->{'d'}->{$f} = $self->{'in_hash'}->{$f};
			}
		}
	foreach $f (@{$self->{'feature_plugins_array'}}) {
		$self->{'d'}->{$f} = $self->{'in_hash'}->{$f};
		}
	foreach $f (@{$self->{'dom_features_array'}}) {
		if ($self->{'config_hash'}->{$f}) {
			local $sfunc = "setup_$f";
			local $dfunc = "delete_$f";
			local $mfunc = "modify_$f";
			if ($self->{'in_hash'}->{$f} && !$self->{'oldd'}->{$f}) {
				# Setup some feature
				if (!$self->try_function($f, $sfunc, $self->{'d'})) {
					$self->{'d'}->{$f} = 0;
					}
				}
			elsif (!$self->{'in_hash'}->{$f} && $self->{'oldd'}->{$f}) {
				# Delete some feature
				if (!$self->try_function($f, $dfunc, $self->{'d'})) {
					$self->{'d'}->{$f} = 1;
					}
				}
			elsif ($self->{'in_hash'}->{$f}) {
				# Modify some feature
				$self->try_function($f, $mfunc, $self->{'d'}, $self->{'oldd'});
				}
			}
		}
	foreach $f (@{$self->{'feature_plugins_array'}}) {
		if ($self->{'in_hash'}->{$f} && !$self->{'oldd'}->{$f}) {
			$self->plugin_call($f, "feature_setup", $self->{'d'});
			}
		elsif (!$self->{'in_hash'}->{$f} && $self->{'oldd'}->{$f}) {
			$self->plugin_call($f, "feature_delete", $self->{'d'});
			}
		elsif ($self->{'in_hash'}->{$f}) {
			$self->plugin_call($f, "feature_modify", $self->{'d'}, $self->{'oldd'});
			}
		}
	}
else {
	# Only modify unix if disabled
	if ($self->{'d'}->{'unix'}) {
		$self->modify_unix($self->{'d'}, $self->{'oldd'});
		}
	}

if ($self->{'d'}->{'parent'}) {
	# Refresh parent Webmin user
	$self->{'parentdom'} = $self->get_domain($self->{'d'}->{'parent'});
	$self->modify_webmin($self->{'parentdom'}, $self->{'parentdom'});
	}

# Update custom fields
$self->parse_custom_fields($self->{'d'}, \%{$self->{'in_hash'}});

# Save new domain details
print $self->{'text_hash'}->{'save_domain'},"<br>\n";
$self->save_domain($self->{'d'});
print $self->{'text_hash'}->{'setup_done'},"<p>\n";

# Run the after command
$self->run_post_actions();
$self->set_domain_envs($self->{'d'}, "MODIFY_DOMAIN");
$self->made_changes();
$self->webmin_log("modify", "domain", $self->{'d'}->{'dom'}, $self->{'d'});

$self->ui_print_footer($self->{'text_hash'}->{'index_mainpage_url'}, $self->{'text_hash'}->{'index_mainpage'},
	"", $self->text('index_return', $self->{'t_websites'}),
	"edit_domain.cgi?dom=$self->{'in_hash'}->{'dom'}", $self->text('edit_return', $self->{'t_website'}));
# $self->ui_print_footer("edit_domain.cgi?dom=$self->{'in_hash'}->{'dom'}", $self->{'text_hash'}->{'edit_return'},
# 	"", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

