#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Update frame-forwarding settings

&ModuleLoader::preload_module('virtual_server_class', "virtual_server::VirtualserverLib");
$self = new virtual_server::VirtualserverLib:: 'virtual_server_class',%$self;

$self->ReadParse();
$self->{'d'} = $self->get_domain($self->{'in_hash'}->{'dom'});
$self->{'access_hash'}->{'edit'} && $self->can_edit_domain($self->{'d'}) || $self->error($self->{'text_hash'}->{'edit_ecannot'});

# Validate inputs
$self->error_setup($self->{'text_hash'}->{'frame_err'});
$self->{'in_hash'}->{'url'} =~ /^(http|https):\/\/\S+$/ || $self->error($self->{'text_hash'}->{'frame_eurl'});
$self->{'d'}->{'proxy_pass'} = $self->{'in_hash'}->{'url'};
$self->{'d'}->{'proxy_title'} = $self->{'in_hash'}->{'title'};
$self->{'in_hash'}->{'meta'} =~ s/\r//g;
$self->{'in_hash'}->{'meta'} =~ s/\n/\t/g;
$self->{'d'}->{'proxy_meta'} = $self->{'in_hash'}->{'meta'};

# Run the before command
$self->set_domain_envs(\%{$self->{'oldd_hash'}}, "MODIFY_DOMAIN");
$self->{'merr'} = $self->making_changes();
$self->error($self->text('rename_emaking', "<tt>$self->{'merr'}</tt>")) if (defined($self->{'merr'}));

$self->ui_print_unbuffered_header($self->domain_in($self->{'d'}), $self->{'text_hash'}->{'frame_title'}, "");

# Force frame re-generation
print $self->{'text_hash'}->{'frame_gen'},"<br>\n";
$self->create_framefwd_file($self->{'d'});
print $self->{'text_hash'}->{'setup_done'},"<p>\n";

# Save the domain
print $self->{'text_hash'}->{'save_domain'},"<br>\n";
$self->save_domain($self->{'d'});
print $self->{'text_hash'}->{'setup_done'},"<p>\n";

# Run the after command
$self->set_domain_envs($self->{'d'}, "MODIFY_DOMAIN");
$self->made_changes();
$self->webmin_log("frame", "domain", $self->{'d'}->{'dom'}, $self->{'d'});

$self->ui_print_footer("edit_domain.cgi?dom=$self->{'in_hash'}->{'dom'}", $self->{'text_hash'}->{'edit_return'},
	"", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

