#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_limits.cgi
# Display access control and usage limits for this domain's user

&ModuleLoader::preload_module('virtual_server_class', "virtual_server::VirtualserverLib");
$self = new virtual_server::VirtualserverLib:: 'virtual_server_class',%$self;

$self->ReadParse();
$self->{'d'} = $self->get_domain($self->{'in_hash'}->{'dom'});
$self->{'access_hash'}->{'edit'} == 1 && $self->can_edit_domain($self->{'d'}) || $self->error($self->{'text_hash'}->{'edit_ecannot'});

# Validate and store inputs
$self->error_setup($self->{'text_hash'}->{'limits_err'});
$self->{'in_hash'}->{'mailboxlimit_def'} || $self->{'in_hash'}->{'mailboxlimit'} =~ /^[1-9]\d*$/ ||
	$self->error($self->{'text_hash'}->{'setup_emailboxlimit'});
$self->{'d'}->{'mailboxlimit'} = $self->{'in_hash'}->{'mailboxlimit_def'} ? undef : $self->{'in_hash'}->{'mailboxlimit'};
$self->{'in_hash'}->{'dbslimit_def'} || $self->{'in_hash'}->{'dbslimit'} =~ /^[1-9]\d*$/ ||
	$self->error($self->{'text_hash'}->{'setup_edbslimit'});
$self->{'d'}->{'dbslimit'} = $self->{'in_hash'}->{'dbslimit_def'} ? undef : $self->{'in_hash'}->{'dbslimit'};
$self->{'in_hash'}->{'domslimit_def'} || $self->{'in_hash'}->{'domslimit'} =~ /^\d+$/ ||
	$self->error($self->{'text_hash'}->{'limit_edoms'});
$self->{'d'}->{'domslimit'} = $self->{'in_hash'}->{'domslimit_def'} == 1 ? undef :
		    $self->{'in_hash'}->{'domslimit_def'} == 2 ? "*" : $self->{'in_hash'}->{'domslimit'};
$self->{'d'}->{'nodbname'} = $self->{'in_hash'}->{'nodbname'};
$self->{'d'}->{'norename'} = $self->{'in_hash'}->{'norename'};
$self->{'d'}->{'forceunder'} = $self->{'in_hash'}->{'forceunder'};
%{$self->{'sel_features_hash'}} = map { $_, 1 } split(/\0/, $self->{'in_hash'}->{'features'});
foreach $f (@{$self->{'opt_features_array'}}, "virt", @{$self->{'feature_plugins_array'}}) {
	$self->{'d'}->{"limit_".$f} = $self->{'sel_features_hash'}->{$f};
	}
if ($self->master_admin()) {
	$self->{'d'}->{'webmin_modules'} = $self->{'in_hash'}->{'modules'};
	}

# Update files
$self->set_all_null_print();
$self->save_domain($self->{'d'});
$self->modify_webmin($self->{'d'}, $self->{'d'});
$self->run_post_actions();
$self->webmin_log("limits", "domain", $self->{'d'}->{'dom'}, $self->{'d'});

$self->redirect("edit_domain.cgi?dom=$self->{'in_hash'}->{'dom'}");

1;
		
}


1;

