#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_newbw.cgi
# Update bandwidth limit settings

&ModuleLoader::preload_module('virtual_server_class', "virtual_server::VirtualserverLib");
$self = new virtual_server::VirtualserverLib:: 'virtual_server_class',%$self;

$self->ReadParse();
$self->master_admin() || $self->error($self->{'text_hash'}->{'newbw_ecannot'});
$self->error_setup($self->{'text_hash'}->{'newbw_err'});

# Validate inputs
$self->{'in_hash'}->{'bw_pastr'} || $self->{'in_hash'}->{'bw_period'} =~ /^\d+$/ && $self->{'in_hash'}->{'bw_period'} > 0 || 
	$self->error($self->{'text_hash'}->{'newbw_eperiod'});
$self->{'in_hash'}->{'bw_notify'} =~ /^\d+$/ && $self->{'in_hash'}->{'bw_notify'} > 0 || 
	$self->error($self->{'text_hash'}->{'newbw_enotify'});
!$self->{'in_hash'}->{'bw_warn'} || ($self->{'in_hash'}->{'bw_warnlevel'} > 0 && $self->{'in_hash'}->{'bw_warnlevel'} <= 100) ||
	$self->error($self->{'text_hash'}->{'newbw_ewarn'});
$self->{'in_hash'}->{'ftplog_def'} || -r $self->{'in_hash'}->{'ftplog'} ||
	$self->error($self->{'text_hash'}->{'newbw_eftplog'});
$self->{'in_hash'}->{'maillog_def'} || -r $self->{'in_hash'}->{'maillog'} ||
	$self->error($self->{'text_hash'}->{'newbw_emaillog'});
if ($self->{'in_hash'}->{'serversmode'}) {
	@{$self->{'servers_array'}} = split(/\0/, $self->{'in_hash'}->{'servers'});
	@{$self->{'servers_array'}} || $self->error($self->{'text_hash'}->{'newbw_eservers'});
	}

# Save configuration and create cron job
$self->{'config_hash'}->{'bw_active'} = $self->{'in_hash'}->{'bw_active'};
$self->{'config_hash'}->{'bw_past'} = !$self->{'in_hash'}->{'bw_pastr'} ? $self->{'in_hash'}->{'bw_past'} : "";
$self->{'config_hash'}->{'bw_period'} = $self->{'in_hash'}->{'bw_period'};
$self->{'config_hash'}->{'bw_notify'} = $self->{'in_hash'}->{'bw_notify'};
$self->{'config_hash'}->{'bw_owner'} = $self->{'in_hash'}->{'bw_owner'};
$self->{'config_hash'}->{'bw_email'} = $self->{'in_hash'}->{'bw_email'};
$self->{'config_hash'}->{'bw_disable'} = $self->{'in_hash'}->{'bw_disable'};
$self->{'config_hash'}->{'bw_warn'} = $self->{'in_hash'}->{'bw_warn'} ? $self->{'in_hash'}->{'bw_warnlevel'} : undef;
$self->{'config_hash'}->{'bw_ftplog'} = $self->{'in_hash'}->{'ftplog_def'} ? undef : $self->{'in_hash'}->{'ftplog'};
$self->{'config_hash'}->{'bw_ftplog_rotated'} = $self->{'in_hash'}->{'ftplog_rotated'};
$self->{'config_hash'}->{'bw_maillog'} = $self->{'in_hash'}->{'maillog_def'} ? undef : $self->{'in_hash'}->{'maillog'};
$self->{'config_hash'}->{'bw_maillog_rotated'} = $self->{'in_hash'}->{'maillog_rotated'};
$self->{'config_hash'}->{'bw_servers'} = $self->{'in_hash'}->{'serversmode'} == 0 ? "" :
			$self->{'in_hash'}->{'serversmode'} == 1 ? join(" ", @{$self->{'servers_array'}}) :
						  "!".join(" ", @{$self->{'servers_array'}});
$self->lock_file($self->{'module_config_file'});
$self->{'config_hash'}->{'last_check'} = time()+1;	# no need for check.cgi to be run
$self->save_module_config();
$self->unlock_file($self->{'module_config_file'});

# Save main template
$self->{'file'} = $self->{'config_hash'}->{'bw_template'};
$self->{'file'} = "$self->{'module_config_directory'}/bw-template" if ($self->{'file'} eq 'default');
$self->{'in_hash'}->{'bw_template'} =~ s/\r//g;
$self->open_lock_tempfile(FILE, ">$self->{'file'}", 1) ||
	$self->error($self->text('efilewrite', $self->{'file'}, $!));
$self->print_tempfile(FILE, $self->{'in_hash'}->{'bw_template'});
$self->close_tempfile(FILE);

# Save warning template
$self->{'file'} = $self->{'config_hash'}->{'warnbw_template'};
$self->{'file'} = "$self->{'module_config_directory'}/warnbw-template" if ($self->{'file'} eq 'default');
$self->{'in_hash'}->{'warnbw_template'} =~ s/\r//g;
$self->open_tempfile(FILE, ">$self->{'file'}", 1) ||
	$self->error($self->text('efilewrite', $self->{'file'}, $!));
$self->print_tempfile(FILE, $self->{'in_hash'}->{'warnbw_template'});
$self->close_tempfile(FILE);

$self->{'job'} = $self->find_bandwidth_job();
if ($self->{'job'}) {
	$self->lock_file($main::cron_object->cron_file($self->{'job'}));
	$main::cron_object->delete_cron_job($self->{'job'});
	}
if ($self->{'in_hash'}->{'bw_active'}) {
	$self->{'job'} = { 'user' => 'root',
		 'command' => $self->{'bw_cron_cmd'},
		 'active' => 1,
		 'mins' => '0',
		 'hours' => '*',
		 'days' => '*',
		 'weekdays' => '*',
		 'months' => '*' };
	$self->lock_file($main::cron_object->cron_file($self->{'job'}));
	$main::cron_object->create_wrapper($self->{'bw_cron_cmd'}, $self->{'module_name'}, "bw.pl");
	$main::cron_object->create_cron_job($self->{'job'});
	}
$self->unlock_all_files();

$self->webmin_log("newbw");
$self->redirect($self->{'text_hash'}->{'index_mainpage_url'});

1;
		
}


1;

