#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Create, update or delete a template

&ModuleLoader::preload_module('virtual_server_class', "virtual_server::VirtualserverLib");
$self = new virtual_server::VirtualserverLib:: 'virtual_server_class',%$self;

$self->master_admin() || $self->error($self->{'text_hash'}->{'newtmpl_ecannot'});
$self->ReadParse();
@{$self->{'tmpls_array'}} = $self->list_templates();
if (!$self->{'in_hash'}->{'new'}) {
	($self->{'tmpl'}) = grep { $_->{'id'} == $self->{'in_hash'}->{'id'} } @{$self->{'tmpls_array'}};
	}
else {
	$self->{'tmpl'} = { };
	}

if ($self->{'in_hash'}->{'delete'}) {
	# Just delete this template
	$self->delete_template($self->{'tmpl'});
	$self->webmin_log("delete", "template", $self->{'tmpl'}->{'name'});
	$self->redirect("edit_newtmpl.cgi");
	exit;
	}

# Validate and store all inputs
$self->error_setup($self->{'text_hash'}->{'tmpl_err'});
if (!$self->{'tmpl'}->{'standard'}) {
	$self->{'in_hash'}->{'name'} || $self->error($self->{'text_hash'}->{'tmpl_ename'});
	$self->{'tmpl'}->{'name'} = $self->{'in_hash'}->{'name'};
	}

# Save global ACL
if ( $self->{'in_hash'}->{'tmpl_mode'}==1 || !$self->{'in_hash'}->{'tmpl_mode'} ) {
$self->{'tmpl'}->{'gacl'} = $self->{'in_hash'}->{'gacl'};
$self->{'tmpl'}->{'gacl_umode'} = $self->{'in_hash'}->{'gacl_umode'};
$self->{'tmpl'}->{'gacl_uusers'} = $self->{'in_hash'}->{'gacl_uusers'};
$self->{'tmpl'}->{'gacl_ugroups'} = $self->{'in_hash'}->{'gacl_ugroups'};
$self->{'tmpl'}->{'gacl_groups'} = $self->{'in_hash'}->{'gacl_groups'};
$self->{'tmpl'}->{'gacl_root'} = $self->{'in_hash'}->{'gacl_root'};

# Save skeleton directory
$self->{'tmpl'}->{'skel'} = &parse_none_def("skel");
if ($self->{'in_hash'}->{"skel_mode"} == 2) {
	-d $self->{'in_hash'}->{'skel'} || $self->error($self->{'text_hash'}->{'tmpl_eskel'});
	}
}

if (!$self->{'tmpl'}->{'standard'}) {
	# Save for-use-by list
	foreach $f ("parent", "sub", "alias", "users") {
		$self->{'tmpl'}->{"for_".$f} = $self->{'in_hash'}->{"for_".$f};
		}
	}

# Save new domain defaults
if ( $self->{'in_hash'}->{'tmpl_mode'}==2 || !$self->{'in_hash'}->{'tmpl_mode'} ) {
#$self->{'tmpl'}->{'ugroup'} = &parse_none_def("ugroup");
#if ($self->{'in_hash'}->{"ugroup_mode"} == 2) {
#	getgrnam($self->{'in_hash'}->{'ugroup'}) || $self->error($self->{'text_hash'}->{'tmpl_eugroup'});
#	}
#$self->{'tmpl'}->{'quota'} = &parse_none_def("quota");
#if ($self->{'in_hash'}->{"quota_mode"} == 2) {
#	$self->{'in_hash'}->{'quota'} =~ /^\d+$/ || $self->error($self->{'text_hash'}->{'tmpl_equota'});
#	}
#$self->{'tmpl'}->{'uquota'} = &parse_none_def("uquota");
#if ($self->{'in_hash'}->{"uquota_mode"} == 2) {
#	$self->{'in_hash'}->{'uquota'} =~ /^\d+$/ || $self->error($self->{'text_hash'}->{'tmpl_euquota'});
#	}
#foreach $l ("mailbox", "dbs", "doms", "bw") {
#	$self->{'tmpl'}->{$l.'limit'} = &parse_none_def($l.'limit');
#	if ($self->{'in_hash'}->{$l."limit_mode"} == 2) {
#		$self->{'in_hash'}->{$l.'limit'} =~ /^\d+$/ ||
#			$self->error($self->{'text_hash'}->{'tmpl_e'.$l.'limit'});
#		}
#	}
}

if ($self->{'config_hash'}->{'web'} && ($self->{'in_hash'}->{'tmpl_mode'}==3 || !$self->{'in_hash'}->{'tmpl_mode'})) {
	# Save web-related settings
	$self->{'old_web_port'} = $self->{'web_port'};
	$self->{'old_web_sslport'} = $self->{'web_sslport'};
	$self->{'tmpl'}->{'web'} = &parse_none_def("web");
	if ($self->{'in_hash'}->{"web_mode"} == 2) {
		$self->{'err'} = $self->check_apache_directives($self->{'in_hash'}->{"web"});
		$self->error($self->{'err'}) if ($self->{'err'});
		$self->{'tmpl'}->{'web_suexec'} = $self->{'in_hash'}->{'suexec'};
		$self->{'tmpl'}->{'web_writelogs'} = $self->{'in_hash'}->{'writelogs'};
		if ($self->{'in_hash'}->{'html_dir_def'}) {
			delete($self->{'tmpl'}->{'web_html_dir'});
			}
		else {
			$self->{'in_hash'}->{'html_dir'} =~ /^\S+$/ && $self->{'in_hash'}->{'html_dir'} !~ /^\// &&
			    $self->{'in_hash'}->{'html_dir'} !~ /\.\./ || $self->error($self->{'text_hash'}->{'newweb_ehtml'});
			$self->{'tmpl'}->{'web_html_dir'} = $self->{'in_hash'}->{'html_dir'};
			}
		$self->{'in_hash'}->{'html_perms'} =~ /^[0-7]{3,4}$/ ||
			$self->error($self->{'text_hash'}->{'newweb_ehtmlperms'});
		$self->{'tmpl'}->{'web_html_perms'} = $self->{'in_hash'}->{'html_perms'};
		delete($self->{'tmpl'}->{'web_stats_dir'});
		delete($self->{'tmpl'}->{'web_stats_hdir'});
		$self->{'smode'} = $self->{'in_hash'}->{'stats_mode'} == 1 ? "stats_dir" :
			 $self->{'in_hash'}->{'stats_mode'} == 2 ? "stats_hdir" : undef;
		if ($self->{'smode'}) {
			$self->{'in_hash'}->{$self->{'smode'}} =~ /^\S+$/ && $self->{'in_hash'}->{$self->{'smode'}} !~ /^\// &&
				$self->{'in_hash'}->{$self->{'smode'}} !~ /\.\./ || $self->error($self->{'text_hash'}->{'newweb_estats'});
			$self->{'tmpl'}->{"web_".$self->{'smode'}} = $self->{'in_hash'}->{$self->{'smode'}};
			}
		$self->{'tmpl'}->{'web_stats_pass'} = $self->{'in_hash'}->{'statspass'};
		if ($self->{'in_hash'}->{'user_def'}) {
			delete($self->{'tmpl'}->{'web_user'});
			}
		else {
			defined(getpwnam($self->{'in_hash'}->{'user'})) || $self->error($self->{'text_hash'}->{'newweb_euser'});
			$self->{'tmpl'}->{'web_user'} = $self->{'in_hash'}->{'user'};
			}
		$self->{'tmpl'}->{'web_alias'} = $self->{'in_hash'}->{'alias_mode'};
		$self->{'in_hash'}->{'web_port'} =~ /^\d+$/ && $self->{'in_hash'}->{'web_port'} > 0 &&
			$self->{'in_hash'}->{'web_port'} < 65536 || $self->error($self->{'text_hash'}->{'newweb_eport'});
		$self->{'tmpl'}->{'web_port'} = $self->{'in_hash'}->{'web_port'};
		$self->{'in_hash'}->{'web_sslport'} =~ /^\d+$/ && $self->{'in_hash'}->{'web_sslport'} > 0 &&
			$self->{'in_hash'}->{'web_sslport'} < 65536 ||
				$self->error($self->{'text_hash'}->{'newweb_esslport'});
		$self->{'in_hash'}->{'web_port'} != $self->{'in_hash'}->{'web_sslport'} ||
				$self->error($self->{'text_hash'}->{'newweb_esslport2'});
		$self->{'tmpl'}->{'web_sslport'} = $self->{'in_hash'}->{'web_sslport'};
		if ($self->get_webmin_version() >= 1.201) {
			$self->{'tmpl'}->{'web_webmin_ssl'} = $self->{'in_hash'}->{'web_webmin_ssl'};
			$self->{'tmpl'}->{'web_usermin_ssl'} = $self->{'in_hash'}->{'web_usermin_ssl'};
			}
		}
	$self->{'tmpl'}->{'webalizer'} = &parse_none_def("webalizer");
	if ($self->{'in_hash'}->{"webalizer_mode"} == 2) {
		-r $self->{'in_hash'}->{'webalizer'} || $self->error($self->{'text_hash'}->{'tmpl_ewebalizer'});
		}
	$self->{'tmpl'}->{'ugroup'} = &parse_none_def("ugroup");
	if ($self->{'in_hash'}->{"ugroup_mode"} == 2) {
		getgrnam($self->{'in_hash'}->{'ugroup'}) || $self->error($self->{'text_hash'}->{'tmpl_eugroup'});
		}
	}

if ($self->{'config_hash'}->{'dns'} && ($self->{'in_hash'}->{'tmpl_mode'}==4 || !$self->{'in_hash'}->{'tmpl_mode'})) {
	# Save DNS settings
	$self->{'tmpl'}->{'dns'} = &parse_none_def("dns");
	if ($self->{'in_hash'}->{"dns_mode"} == 2) {
		$self->{'tmpl'}->{'dns_replace'} = $self->{'in_hash'}->{'bind_replace'};
		$self->{'tmpl'}->{'dns_view'} = $self->{'in_hash'}->{'view'};

		$self->require_bind();
		$self->{'fakeip'} = "1.2.3.4";
		$self->{'fakedom'} = "foo.com";
		$self->{'recs'} = $self->substitute_template(
			join("\n", split(/\t+/, $self->{'in_hash'}->{'dns'}))."\n",
			{ 'ip' => $self->{'fakeip'},
			  'dom' => $self->{'fakedom'} });
		$self->{'temp'} = $self->transname();
		$self->open_tempfile(TEMP, ">$self->{'temp'}");
		$self->print_tempfile(TEMP, $self->{'recs'});
		$self->close_tempfile(TEMP);
		$main::bind8_object->{'config_hash'}->{'short_names'} = 0;	# force canonicalization
		$main::bind8_object->{'config_hash'}->{'chroot'} = '/';		# turn off chroot for temp path
		$main::bind8_object->{'config_hash'}->{'auto_chroot'} = undef;

		@{$self->{'recs_array'}} = $main::bind8_object->read_zone_file($self->{'temp'}, $self->{'fakedom'});
		unlink($self->{'temp'});
		foreach $r (@{$self->{'recs_array'}}) {
			$self->{'soa'}++ if ($r->{'name'} eq $self->{'fakedom'}."." &&
				   $r->{'type'} eq "SOA");
			$self->{'ns'}++ if ($r->{'name'} eq $self->{'fakedom'}."." &&
				  $r->{'type'} eq "NS");
			$self->{'dom'}++ if ($r->{'name'} eq $self->{'fakedom'}."." &&
				   ($r->{'type'} eq "A" || $r->{'type'} eq "MX"));
			$self->{'www'}++ if ($r->{'name'} eq "www.".$self->{'fakedom'}."." &&
				   $r->{'type'} eq "A");
			}

		if ($self->{'in_hash'}->{'bind_replace'}) {
			# Make sure an SOA and NS records exist
			$self->{'soa'} == 1 || $self->error($self->{'text_hash'}->{'newdns_esoa'});
			$self->{'ns'} || $self->error($self->{'text_hash'}->{'newdns_ens'});
			$self->{'dom'} || $self->error($self->{'text_hash'}->{'newdns_edom'});
			$self->{'www'} || $self->error($self->{'text_hash'}->{'newdns_ewww'});
			}
		else {
			# Make sure SOA doesn't exist
			$self->{'soa'} && $self->error($self->{'text_hash'}->{'newdns_esoa2'});
			}
		}
	}

if ($self->{'config_hash'}->{'ftp'} && (!$self->{'in_hash'}->{'tmpl_mode'} || $self->{'in_hash'}->{'tmpl_mode'} == 5 || $self->{'in_hash'}->{'tmpl_mode'} == 9)) {
	# Save FTP settings
	if ($self->{'config_hash'}->{'ftp_system'} == 2) {
		$self->{'tmpl'}->{'ftp_vsftpd'} = &parse_none_def("ftp_vsftpd");
		if ($self->{'in_hash'}->{'ftp_dir_def'}) {
			delete($self->{'tmpl'}->{'ftp_dir'});
			}
		else {
			$self->{'in_hash'}->{'ftp_dir'} =~ /^\S+$/ && $self->{'in_hash'}->{'ftp_dir'} !~ /^\// &&
			    $self->{'in_hash'}->{'ftp_dir'} !~ /\.\./ || $self->error($self->{'text_hash'}->{'newftp_edir'});
			$self->{'tmpl'}->{'ftp_dir'} = $self->{'in_hash'}->{'ftp_dir'};
			}
		}
	else {
		$self->{'tmpl'}->{'ftp'} = &parse_none_def("ftp");
		if ($self->{'in_hash'}->{"ftp_mode"} == 2) {
			$self->{'err'} = $self->check_proftpd_template($self->{'in_hash'}->{'ftp'});
			$self->error($self->{'err'}) if ($self->{'err'});
			if ($self->{'in_hash'}->{'ftp_dir_def'}) {
				delete($self->{'tmpl'}->{'ftp_dir'});
				}
			else {
				$self->{'in_hash'}->{'ftp_dir'} =~ /^\S+$/ && $self->{'in_hash'}->{'ftp_dir'} !~ /^\// &&
				    $self->{'in_hash'}->{'ftp_dir'} !~ /\.\./ || $self->error($self->{'text_hash'}->{'newftp_edir'});
				$self->{'tmpl'}->{'ftp_dir'} = $self->{'in_hash'}->{'ftp_dir'};
				}
			}
		}
	}

if ($self->{'config_hash'}->{'proxy_pass'} && ($self->{'in_hash'}->{'tmpl_mode'}==6 || !$self->{'in_hash'}->{'tmpl_mode'}) ) {
#if ($self->{'config_hash'}->{'proxy_pass'} == 2) {
	# Save frame-forwarding settings
	$self->{'tmpl'}->{'frame'} = &parse_none_def("frame");
	}

if ($self->{'config_hash'}->{'mail'} && ($self->{'in_hash'}->{'tmpl_mode'}==7 || !$self->{'in_hash'}->{'tmpl_mode'}) ) {
# Save mail settings
$self->{'tmpl'}->{'mail_on'} = $self->{'in_hash'}->{'mail_mode'} == 0 ? "none" :
		     $self->{'in_hash'}->{'mail_mode'} == 1 ? "" : "yes";
$self->{'in_hash'}->{'mail'} =~ s/\r//g;
$self->{'tmpl'}->{'mail'} = $self->{'in_hash'}->{'mail'};
$self->{'tmpl'}->{'mail_subject'} = $self->{'in_hash'}->{'subject'};
$self->{'tmpl'}->{'mail_cc'} = $self->{'in_hash'}->{'cc'};

# Save new user aliases
if ($self->{'in_hash'}->{'aliases_mode'} == 0) {
	$self->{'tmpl'}->{'user_aliases'} = "none";
	}
elsif ($self->{'in_hash'}->{'aliases_mode'} == 1) {
	$self->{'tmpl'}->{'user_aliases'} = "";
	}
else {
	@{$self->{'aliases_array'}} = $self->parse_alias(0, "NEWUSER");
	$self->{'tmpl'}->{'user_aliases'} = join("\t", @{$self->{'aliases_array'}});
	}
}

# Save new domain aliases
#if ($self->{'in_hash'}->{'domaliases_mode'} == 0) {
#	$self->{'text_hash'}->{'tmpl_domaliases'} = "none";
#	}
#elsif ($self->{'in_hash'}->{'domaliases_mode'} == 1) {
#	$self->{'text_hash'}->{'tmpl_domaliases'} = "";
#	}
#else {
#	@{$self->{'aliases_array'}} = ( );
#	for($i=0; defined($from = $self->{'in_hash'}->{"alias_from_$i"}); $i++) {
#		$to = $self->{'in_hash'}->{"alias_to_$i"};
#		next if (!$from);
#		$from =~ /^\S+$/ || $self->error(&text('tmpl_ealiasfrom', $i+1));
#		$to =~ /\S/ || $self->error(&text('tmpl_ealiasto', $i+1));
#		push(@{$self->{'aliases_array'}}, "$from=$to");
#		}
#	@{$self->{'aliases_array'}} || $self->error(&text('tmpl_ealiases'));
#	$self->{'tmpl'}->{'dom_aliases'} = join("\t", @{$self->{'aliases_array'}});
#	}

if ($self->{'config_hash'}->{'mysql'} && ($self->{'in_hash'}->{'tmpl_mode'}==8 || !$self->{'in_hash'}->{'tmpl_mode'})) {
# Save MySQL-related settings
if ($self->{'in_hash'}->{'mysql_mode'} == 1) {
	$self->{'tmpl'}->{'mysql'} = undef;
	}
else {
	$self->{'in_hash'}->{'mysql'} =~ /^\S+$/ || $self->error($self->{'text_hash'}->{'tmpl_emysql'});
	$self->{'tmpl'}->{'mysql'} = $self->{'in_hash'}->{'mysql'};
	}
if ($self->{'in_hash'}->{'mysql_wild_mode'} == 1) {
	$self->{'tmpl'}->{'mysql_wild'} = undef;
	}
else {
	$self->{'in_hash'}->{'mysql_wild'} =~ /^\S*$/ || $self->error($self->{'text_hash'}->{'tmpl_emysql_wild'});
	$self->{'tmpl'}->{'mysql_wild'} = $self->{'in_hash'}->{'mysql_wild'};
	}
if ($self->{'in_hash'}->{'mysql_hosts_mode'} == 0) {
	$self->{'tmpl'}->{'mysql_hosts'} = "none";
	}
elsif ($self->{'in_hash'}->{'mysql_hosts_mode'} == 1) {
	$self->{'tmpl'}->{'mysql_hosts'} = undef;
	}
else {
	$self->{'in_hash'}->{'mysql_hosts'} =~ /\S/ || $self->error($self->{'text_hash'}->{'tmpl_emysql_hosts'});
	$self->{'tmpl'}->{'mysql_hosts'} = $self->{'in_hash'}->{'mysql_hosts'};
	}
$self->{'tmpl'}->{'mysql_mkdb'} = $self->{'in_hash'}->{'mysql_mkdb'};
$self->{'tmpl'}->{'mysql_nopass'} = $self->{'in_hash'}->{'mysql_nopass'};
}

# Create or update the template
$self->save_template($self->{'tmpl'});
$self->webmin_log($self->{'in_hash'}->{'new'} ? "create" : "modify", "template", $self->{'tmpl'}->{'name'});
$self->redirect("index_config.cgi");

if ($self->{'tmpl'}->{'id'} == 0) {
	# If the web or SSL ports were changed, all existing virtual hosts
	# should be updated with the *old* setting to that we know what port
	# they were created on
	if ($self->{'old_web_port'} != $self->{'in_hash'}->{'web_port'} ||
	    $self->{'old_web_sslport'} != $self->{'in_hash'}->{'web_sslport'}) {
		foreach $d ($self->list_domains()) {
			$self->save_domain($d);
			}
		}
	}

1;
		
}

# parse_none_def(name)
sub parse_none_def
{
	shift if ($self == $_[0]);

if ($self->{'in_hash'}->{$_[0]."_mode"} == 0) {
	return "none";
	}
elsif ($self->{'in_hash'}->{$_[0]."_mode"} == 1) {
	return undef;
	}
else {
	$self->{'in_hash'}->{$_[0]} =~ s/\r//g;
	$self->{'in_hash'}->{$_[0]} =~ s/\n/\t/g;
	return $self->{'in_hash'}->{$_[0]};
	}
}


1;

