#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_user.cgi
# Create, update or delete a user

&ModuleLoader::preload_module('virtual_server_class', "virtual_server::VirtualserverLib");
$self = new virtual_server::VirtualserverLib:: 'virtual_server_class',%$self;

$self->ReadParse();
if ($self->{'in_hash'}->{'dom'}) {
	$self->{'d'} = $self->get_domain($self->{'in_hash'}->{'dom'});
	$self->can_edit_domain($self->{'d'}) || $self->error($self->{'text_hash'}->{'users_ecannot'});
	}
else {
	$self->{'access_hash'}->{'local'} || $self->error($self->{'text_hash'}->{'users_ecannot2'});
	}
$self->lock_user_db();
@{$self->{'users_array'}} = $self->list_domain_users($self->{'d'});

if (!$self->{'in_hash'}->{'new'}) {
	# Lookup user details
	($self->{'user'}) = grep { $_->{'user'} eq $self->{'in_hash'}->{'old'} &&
			 $_->{'unix'} == $self->{'in_hash'}->{'unix'} } @{$self->{'users_array'}};
	$self->{'user'} || $self->error("User does not exist!");
	%{$self->{'old_hash'}} = %{$self->{'user'}};
	$self->{'mailbox'} = $self->{'d'} && $self->{'d'}->{'user'} eq $self->{'user'}->{'user'} && $self->{'user'}->{'unix'};
	$self->{'user'}->{'olduser'} = $self->{'user'}->{'user'};
	}
else {
	# Construct initial user object
	$self->{'user'} = $self->create_initial_user($self->{'d'});
	}
if(($self->{'in_hash'}->{'mailpass_def'}!=1 && !$self->{'in_hash'}->{'mailpass'} || $self->{'in_hash'}->{'mailpass'} ne $self->{'in_hash'}->{'mailpass2'}) && !$self->{'in_hash'}->{'delete'}) 
{ $self->error($self->{'text_hash'}->{'incor_pass'});}

$self->error_setup($self->{'text_hash'}->{'user_err'});
$self->require_useradmin();

$self->build_taken(\%{$self->{'taken_hash'}}, \%{$self->{'utaken_hash'}});

if ($self->{'in_hash'}->{'delete'}) {
	if ($self->{'in_hash'}->{'confirm'}) {
		# Delete samba client
		$self->delete_samba_client($self->{'user'}->{'user'}) if $self->{'user'}->{'samba'};

		# Get rid of his mail file
		$self->{'mailbox'} && $self->error($self->{'text_hash'}->{'user_edelete'});
		$self->delete_mail_file($self->{'user'});

		# Delete the user, his virtusers and aliases
		$self->delete_user($self->{'user'}, $self->{'d'});

		if ($self->{'user'}->{'unix'}) {
			# Delete home dir
			$self->system_logged("rm -rf '$self->{'user'}->{'home'}'")
			  if (-d $self->{'user'}->{'home'} && $self->{'user'}->{'home'} ne "/");
			}

		# Delete in plugins
		foreach $f (@{$self->{'mail_plugins_array'}}) {
			$self->plugin_call($f, "mailbox_delete", $self->{'user'}, $self->{'d'});
			}

		# Delete in other modules
		if ($self->{'config_hash'}->{'other_users'}) {
			$self->foreign_call($self->{'usermodule'}, "other_modules",
				      "useradmin_delete_user", $self->{'user'});
			}

		# Zero out quotas
		if ($self->{'config_hash'}->{'home_quotas'}) {
			$self->set_quota($self->{'user'}->{'user'}, $self->{'config_hash'}->{'home_quotas'}, 0);
			}
		if ($self->{'config_hash'}->{'mail_quotas'}) {
			$self->set_quota($self->{'user'}->{'user'}, $self->{'config_hash'}->{'mail_quotas'}, 0);
			}

		$self->{'user'}->{'dom'} = $self->{'d'}->{'dom'};
		$self->run_post_actions();
		$self->webmin_log("delete", "user",
			    $self->remove_userdom($self->{'user'}->{'user'}, $self->{'d'}), $self->{'user'});
		}
	else {
		# Confirm deletion first
		$self->{'ind'} = $self->{'d'} ? $self->domain_in($self->{'d'}) : undef;
		$self->ui_print_header($self->{'ind'}, $self->{'text_hash'}->{'user_delete'}, "", undef, undef, 1);

		print $self->check_clicks_function();
		print "<form action=save_user.cgi>\n";
		print "<input type=hidden name=dom value='$self->{'in_hash'}->{'dom'}'>\n";
		print "<input type=hidden name=old value='$self->{'in_hash'}->{'old'}'>\n";
		print "<input type=hidden name=unix value='$self->{'in_hash'}->{'unix'}'>\n";
		print "<input type=hidden name=samba value='$self->{'in_hash'}->{'samba'}'>\n";
		print "<input type=hidden name=delete value=1>\n";
		local ($mailsz) = $self->mail_file_size($self->{'user'});
		local ($homesz) = $self->disk_usage_kb($self->{'user'}->{'home'});
		print "<p>",$self->text('user_rusure', "<tt>$self->{'in_hash'}->{'old'}</tt>",
			  	  $self->nice_size($mailsz),
				  $self->nice_size($homesz*1024),
				  "<tt>$self->{'user'}->{'home'}</tt>"),"<p>\n";
		print "<center><input type=submit name=confirm ",
		      "value='$self->{'text_hash'}->{'user_deleteok'}' ",
		      "onClick='check_clicks(form)'></center>\n";
		print "</form>\n";

		if ($self->{'d'}) {
			$self->ui_print_footer($self->{'text_hash'}->{'index_mainpage_url'}, $self->{'text_hash'}->{'index_mainpage'},"list_users.cgi?dom=$self->{'in_hash'}->{'dom'}",
				$self->{'text_hash'}->{'users_return'});
			}
		else {
			$self->ui_print_footer($self->{'text_hash'}->{'index_mainpage_url'}, $self->{'text_hash'}->{'index_mainpage'},"", $self->{'text_hash'}->{'index_return'});
			}
		exit;
		}
	}
else {
	# Require a new password when samba feature is being enabled
	if (!$self->{'in_hash'}->{'new'} && ((!$self->{'user'}->{'samba'} && $self->{'in_hash'}->{'samba'}) || (!$self->{'mailbox'} && $self->{'in_hash'}->{'mailuser'} ne $self->{'in_hash'}->{'oldpop3'})) && !$self->{'in_hash'}->{'mailpass'}) {
		$self->error($self->{'text_hash'}->{'setup_samba_pass'});
	}

	# Verify inputs
	local ($mcount, $mmax) = $self->count_mailboxes($self->{'d'});
	if ($self->{'in_hash'}->{'new'} && $self->{'d'} && defined($mmax) && $mcount > $mmax) {
		$self->error($self->{'text_hash'}->{'user_emailboxlimit'});
		}
	if (!$self->{'mailbox'}) {
		$self->{'in_hash'}->{'mailuser'} = lc($self->{'in_hash'}->{'mailuser'});
		$self->{'in_hash'}->{'mailuser'} =~ /^[^ \t:]+$/ || $self->error($self->{'text_hash'}->{'user_euser'});
		if ($self->{'user'}->{'person'}) {
			$self->{'in_hash'}->{'real'} =~ /^[^:,]*$/ || $self->error($self->{'text_hash'}->{'user_ereal'});
			$self->{'user'}->{'real'} = $self->{'in_hash'}->{'real'};
			}
		if ($self->{'in_hash'}->{'mailpass_def'}) {
			$self->{'user'}->{'passmode'} = 4;
			}
		else {
			if ($self->{'user'}->{'qmail'}) {
				# Force crypt mode
				local $salt = substr(time(), -2);
				$self->{'user'}->{'pass'} = crypt($self->{'in_hash'}->{'mailpass'}, $salt);
				}
			else {
				$self->{'user'}->{'pass'} = $self->foreign_call(
				  $self->{'usermodule'}, "encrypt_password", $self->{'in_hash'}->{'mailpass'});
				}
			$self->{'user'}->{'plainpass'} = $self->{'in_hash'}->{'mailpass'};
			$self->{'user'}->{'passmode'} = 3;
			$self->set_pass_change($self->{'user'});
			}
		if ($self->{'user'}->{'mailquota'}) {
			# Check qmail quota
			if (!$self->{'in_hash'}->{'qquota_def'}) {
				$self->{'in_hash'}->{'qquota'} =~ /^\d+(\.\d*)?$/ ||
					$self->error($self->{'text_hash'}->{'user_eqquota'});
				$self->{'user'}->{'qquota'} = $self->{'in_hash'}->{'qquota'};
				}
			else {
				$self->{'user'}->{'qquota'} = 0;
				}
			}

		if ($self->{'user'}->{'mailquotafiles'}) {
			# Check qmail files quota
			if (!$self->{'in_hash'}->{'qfiles_def'}) {
				$self->{'in_hash'}->{'qfiles'} =~ /^\d+$/ ||
					$self->error($self->{'text_hash'}->{'user_eqfiles'});
				$self->{'user'}->{'qfiles'} = $self->{'in_hash'}->{'qfiles'};
				}
			else {
				$self->{'user'}->{'qfiles'} = 0;
				}
			}

		if ($self->{'user'}->{'unix'}) {
			# Check quota inputs
			$self->{'qsame'} = $self->{'config_hash'}->{'mail_quotas'} eq $self->{'config_hash'}->{'home_quotas'};
			$self->{'qedit'} = $self->master_admin() || $self->{'config_hash'}->{'edit_quota'};
			if ($self->{'config_hash'}->{'home_quotas'} && $self->{'qedit'}) {
				if ( $self->{'in_hash'}->{'quota'} eq -1 ) {
					$self->{'in_hash'}->{'quota'} = $self->{'in_hash'}->{'otherquota'};
					}
				$self->{'in_hash'}->{'quota_def'} || $self->{'in_hash'}->{'quota'} =~ /^\d+(\.\d*)?$/ ||
					$self->error($self->{'text_hash'}->{'user_equota'});
                                local $bs = $self->quota_bsize($self->{'config_hash'}->{'home_quotas'});
				local ($squota, $chd, $pdom);
				$chd = $self->{'d'};
				if( $pdom = $self->{'d'}->{'parent'}) { $chd = $self->get_domain($pdom);} 
				if($bs) { $squota = $chd->{'quota'}*$bs/1024/1024;}
				else { $squota = $chd->{'quota'}/1024;}
				if(($chd->{'quota'} && $self->{'in_hash'}->{'quota'} &&
				($self->{'in_hash'}->{'quota'} > $squota))) {
				    $self->error($self->{'text_hash'}->{'quota_error'});
				    }
				}
			if ($self->{'config_hash'}->{'mail_quotas'} && !$self->{'qsame'} && $self->{'qedit'}) {
				if ( $self->{'in_hash'}->{'mquota'} eq -1 ) {
					$self->{'in_hash'}->{'mquota'} = $self->{'in_hash'}->{'othermquota'};
					}
				$self->{'in_hash'}->{'mquota_def'} || $self->{'in_hash'}->{'mquota'} =~ /^\d+(\.\d*)?$/ ||
					$self->error($self->{'text_hash'}->{'user_equota'});
				}
			}
		}

	# Save extra email addresses
	$eu = $self->{'mailbox'} ? $self->{'d'}->{'user'} : $self->{'in_hash'}->{'mailuser'};
	@{$self->{'extra_array'}} = split(/\s+/, $self->{'in_hash'}->{'extra'});
	foreach $e (@{$self->{'extra_array'}}) {
		$e = lc($e);
		if ($self->{'d'} && $e =~ /^([^\@ \t]+$)$/) {
			$e = "$e\@$self->{'d'}->{'dom'}";
			}
		if ($e !~ /^(\S*)\@(\S+)$/) {
			$self->error($self->text('user_eextra1', $e));
			}
                if ($e eq $eu."\@".$self->{'d'}->{'dom'}) {
                        $self->error($self->text('user_eextra5', $e));
                        }
		local ($eu, $ed) = ($1, $2);
		local $edom = $self->get_domain_by("dom", $ed);
		$edom && $edom->{'mail'} || $self->error($self->text('user_eextra2', $ed));
		$self->can_edit_domain($edom) || $self->error($self->text('user_eextra3', $ed));
		}

	if ($self->{'d'} && !$self->{'user'}->{'noprimary'}) {
		$self->{'user'}->{'email'} = $self->{'in_hash'}->{'mailbox'} ? $eu."\@".$self->{'d'}->{'dom'}
						  : undef;
		}
	$self->{'user'}->{'extraemail'} = \@{$self->{'extra_array'}};
	if ($self->{'in_hash'}->{'new'} && $self->will_send_user_email($self->{'d'}) && !$self->{'in_hash'}->{'newmail_def'}) {
		$self->{'in_hash'}->{'newmail'} =~ /^\S+$/ || $self->error($self->{'text_hash'}->{'user_enewmail'});
		$self->{'newmailto'} = $self->{'in_hash'}->{'newmail'};
		}

	# Validate plugins
	foreach $f (@{$self->{'mail_plugins_array'}}) {
		$self->{'err'} = $self->plugin_call($f, "mailbox_validate", $self->{'user'}, \%{$self->{'old_hash'}}, \%{$self->{'in_hash'}}, $self->{'in_hash'}->{'new'}, $self->{'d'});
		$self->error($self->{'err'}) if ($self->{'err'});
		}

	if (!$self->{'mailbox'} && !$self->{'user'}->{'fixedhome'} && !$self->{'user'}->{'brokenhome'}) {
		# Find home
		if (($self->master_admin() || $self->{'config_hash'}->{'edit_homes'}) &&
		    $self->{'d'} && $self->{'d'}->{'home'} && !$self->{'in_hash'}->{'home_def'}) {
			$self->{'in_hash'}->{'home'} =~ /^\S+$/ && $self->{'in_hash'}->{'home'} !~ /\.\./ ||
				$self->error($self->{'text_hash'}->{'user_ehome'});
			# Custom home directory for mailbox user
			$home = "$self->{'d'}->{'home'}/$self->{'in_hash'}->{'home'}";
			}
		elsif ($self->{'d'}) {
			# Auto home directory for mailbox user
			$home = "$self->{'d'}->{'home'}/$self->{'config_hash'}->{'homes_dir'}/$self->{'in_hash'}->{'mailuser'}";
			}
		else {
			# Auto home directory for local user
			$home = $main::useradmin_object->auto_home_dir(
				$self->{'home_base'}, $self->{'in_hash'}->{'mailuser'}, $self->{'config_hash'}->{'localgroup'});
			}
		}

        # Update secondary groups
        %{$self->{'cangroups_hash'}} = map { $_, 1 } ($self->allowed_secondary_groups($self->{'d'}),
                                    @{$self->{'user'}->{'secs'}});
        @secs = split(/\0/, $self->{'in_hash'}->{'groups'});
        foreach my $g (@secs) {
                $self->{'cangroups_hash'}->{$g} || $self->error($self->text('user_egroup', $g));
                }
        $self->{'user'}->{'secs'} = [ @secs ];

	# Create or update the user
	if ($self->{'in_hash'}->{'new'}) {
		# Set new user parameters
		if ($self->{'user'}->{'unix'}) {
			# UID needs to be unique
			$self->{'user'}->{'uid'} = $self->allocate_uid(\%{$self->{'taken_hash'}});
			}
		else {
			# UID is same as domain for Qmail users
			$self->{'user'}->{'uid'} = $self->{'d'}->{'uid'};
			}
		$self->{'user'}->{'gid'} = $self->{'d'} ? $self->{'d'}->{'gid'} :
				      getgrnam($self->{'config_hash'}->{'localgroup'});

		# Check for clash within this domain
		($self->{'clash'}) = grep { $_->{'user'} eq $self->{'in_hash'}->{'mailuser'} &&
			  	  $_->{'unix'} == $self->{'user'}->{'unix'} } @{$self->{'users_array'}};
		$self->{'clash'} && $self->error($self->{'text_hash'}->{'user_eclash2'});

		if ($self->{'user'}->{'unix'}) {
			if ($self->master_admin() || $self->{'config_hash'}->{'edit_ftp'}) {
				# Shell can be set based on FTP flag
				$self->{'user'}->{'shell'} =
					$self->{'in_hash'}->{'ftp'} == 1 ? $self->{'config_hash'}->{'ftp_shell'} :
					$self->{'in_hash'}->{'ftp'} == 2 ? $self->{'config_hash'}->{'jail_shell'} :
							  $self->{'config_hash'}->{'shell'};
				}
			elsif ($self->{'in_hash'}->{'new'}) {
				# For new users, shell is always non-FTP
				$self->{'user'}->{'shell'} = $self->{'config_hash'}->{'shell'};
				}
			}
		if (!$self->{'user'}->{'fixedmode'}) {
			$self->{'user'}->{'home'} = $home;
			}

		if (($self->{'utaken_hash'}->{$self->{'in_hash'}->{'mailuser'}} || ($self->{'d'} && $self->{'config_hash'}->{'append'})) &&
		    !$self->{'user'}->{'noappend'}) {
			# Need to append domain name
			if ($self->{'d'}) {
				# Add group name
				$self->{'user'}->{'user'} = $self->userdom_name($self->{'in_hash'}->{'mailuser'},$self->{'d'});
				}
			else {
				# No domain to add, so give up!
				$self->error($self->{'text_hash'}->{'user_eclash2'});
				}
			}
		else {
			$self->{'user'}->{'user'} = $self->{'in_hash'}->{'mailuser'};
			}
		$self->{'user'}->{'passmode'} = 3;
		$self->{'user'}->{'plainpass'} = $self->{'in_hash'}->{'mailpass'};

		if ($self->{'d'} && $self->{'user'}->{'unix'}) {
			# Check for a Unix clash
			if ($self->{'utaken_hash'}->{$self->{'user'}->{'user'}} ||
			    $self->check_clash($self->{'in_hash'}->{'mailuser'}, $self->{'d'}->{'dom'})) {
				$self->error($self->{'text_hash'}->{'user_eclash'});
				}
			}

		# Check if any extras clash
		foreach $e (@{$self->{'extra_array'}}) {
			$e =~ /^(\S*)\@(\S+)$/;
			if ($self->check_clash($1, $2)) {
				$self->error($self->text('user_eextra4', $e));
				}
			}

		# Check if the name is too long
		if ($self->{'user'}->{'unix'} &&
		    ($self->{'lerr'} = $self->too_long($self->{'user'}->{'user'}))) {
			$self->error($self->{'lerr'});
			}

		# Check if home directory already exists
		if (-e $home) {
			$self->error($self->text('user_emkhome', $home));
			}

		# Set mail file location
		if ($self->{'user'}->{'qmail'}) {
			$self->userdom_substitutions($self->{'user'}, $self->{'d'});
			$self->{'user'}->{'mailstore'} =
			 $self->substitute_template($self->{'config_hash'}->{'ldap_mailstore'}, $self->{'user'});
			}

		if (!$self->{'user'}->{'noalias'}) {
                        # Save alias
                        @{$self->{'values_array'}} = $self->parse_alias(undef, $self->{'user'}->{'user'},
                                               undef, "user", $self->{'d'});
                        $self->{'user'}->{'to'} = @{$self->{'values_array'}} ? \@{$self->{'values_array'}} : undef;
                        }

		# Create the user and virtusers and alias
		$self->create_user($self->{'user'}, $self->{'d'});

		if ($home) {
			# Create his homedir
			$self->system_logged("mkdir -p '$home'");
			$self->system_logged("chown $self->{'user'}->{'uid'}:$self->{'user'}->{'gid'} '$home'");
			$self->system_logged("chmod 755 '$home'");

			# Copy files into homedir
			$self->copy_skel_files($self->{'config_hash'}->{'mail_skel'}, $self->{'user'}, $home);
			}

		# Create an empty mail file
		$self->create_mail_file($self->{'user'});

		# Adds a new samba client
		$self->create_samba_client($self->{'user'}->{'user'}, $self->{'in_hash'}->{'mailpass'}) if $self->{'in_hash'}->{'samba'};

		# Send an email upon creation
		@{$self->{'erv_array'}} = $self->send_user_email($self->{'d'}, $self->{'user'}, $self->{'newmailto'}) if ($self->{'user'}->{'email'});		
		}
	else {
		# Check if any extras clash
		%{$self->{'oldextra_hash'}} = map { $_, 1 } @{$self->{'old_hash'}->{'extraemail'}};
		foreach $e (@{$self->{'extra_array'}}) {
			$e =~ /^(\S*)\@(\S+)$/;
			if (!$self->{'oldextra_hash'}->{$e} && $self->check_clash($1, $2)) {
				$self->error($self->text('user_eextra4', $e));
				}
			}

		# For any user except the domain owner, update his home and shel
		if (!$self->{'mailbox'}) {
			# Check if new homedir exists
			if (-e $home && $self->{'user'}->{'home'} ne $home) {
				$self->error($self->text('user_emkhome', $home));
				}

			# Update user parameters (handle rename and .group)
			if ($self->{'in_hash'}->{'mailuser'} ne $self->{'in_hash'}->{'oldpop3'}) {
				# Check for a clash in this domain
				($self->{'clash'}) = grep { $_->{'user'} eq $self->{'in_hash'}->{'mailuser'} &&
				  $_->{'unix'} == $self->{'user'}->{'unix'} } @{$self->{'users_array'}};
				$self->{'clash'} && $self->error($self->{'text_hash'}->{'user_eclash2'});

				# Has been renamed .. check for a username clash
				if ($self->{'d'} && ($self->{'utaken_hash'}->{$self->{'in_hash'}->{'mailuser'}} ||
					   $self->{'config_hash'}->{'append'}) &&
				    !$self->{'user'}->{'noappend'}) {
					# New name has to include group
					$self->{'user'}->{'user'} =
						$self->userdom_name($self->{'in_hash'}->{'mailuser'}, $self->{'d'});
					}
				else {
					# Can rename without the dot
					$self->{'user'}->{'user'} = $self->{'in_hash'}->{'mailuser'};
					}

				# Check if the name is too long
				if ($self->{'lerr'} = $self->too_long($self->{'user'}->{'user'})) {
					$self->error($self->{'lerr'});
					}

				# Check for a virtuser clash too
				if ($self->{'d'} && $self->check_clash($self->{'in_hash'}->{'mailuser'},
						       $self->{'d'}->{'dom'})) {
					$self->error($self->{'text_hash'}->{'user_eclash'});
					}
				}

			# Rename homedir
			if ($self->{'user'}->{'home'} ne $home && -d $self->{'user'}->{'home'} &&
			    !$self->{'user'}->{'fixedhome'} && !$self->{'user'}->{'brokenhome'}) {
				$self->system_logged("mv '$self->{'user'}->{'home'}' '$home'");
				$self->{'user'}->{'home'} = $home;
				}

			# Update shell
			if (defined($self->{'in_hash'}->{'ftp'})) {
				$self->{'user'}->{'shell'} =
				    $self->{'in_hash'}->{'ftp'} == 1 ? $self->{'config_hash'}->{'ftp_shell'} :
				    $self->{'in_hash'}->{'ftp'} == 2 ? $self->{'config_hash'}->{'jail_shell'} :
						      $self->{'config_hash'}->{'shell'};
				}

			# Set mail file location
			if ($self->{'user'}->{'qmail'}) {
				local $store = $self->substitute_template(
					$self->{'config_hash'}->{'ldap_mailstore'}, $self->{'user'});
				$self->{'user'}->{'mailstore'} = $store;
				}

			# Rename his mail file (if needed)
			$self->rename_mail_file($self->{'user'}, \%{$self->{'old_hash'}});
			}

		if (!$self->{'user'}->{'noalias'}) {
                        # Save aliases
                        @{$self->{'values_array'}} = $self->parse_alias(undef, $self->{'user'}->{'user'},
                                        $self->{'old_hash'}->{'to'}, "user", $self->{'d'});
                        $self->{'user'}->{'to'} = @{$self->{'values_array'}} ? \@{$self->{'values_array'}} : undef;
                        }

			# Gets Samba client details
			local $smbuser;
			$smbuser = $self->get_samba_user($self->{'old'}->{'user'}) if $self->{'old'}->{'samba'};
			# Delete Samba client if samba was enabled and now it is disabled or user name is changing
		 	if ($self->{'old_hash'}->{'samba'} && (!$self->{'in_hash'}->{'samba'} || $self->{'old_hash'}->{'user'} ne $self->{'user'}->{'user'})) {
				$self->delete_samba_client($self->{'old_hash'}->{'user'});
			}

			# Update the user and any virtusers and aliases
			$self->modify_user($self->{'user'}, \%{$self->{'old_hash'}}, $self->{'d'});
			
			# Create Samba client
		 	if ($self->{'in_hash'}->{'samba'}) {
				$smbuser->{'name'} = $self->{'user'}->{'user'};
				$smbuser->{'plainpass'} = $self->{'in_hash'}->{'mailpass'};
				$self->modify_samba_client($smbuser);
			}
		}

	if (!$self->{'mailbox'} && ($self->{'qedit'} || $self->{'in_hash'}->{'new'}) && $self->{'user'}->{'unix'}) {
		# Actually update quotas, if allowed
		@{$self->{'defmquota_array'}} = split (/ /,$self->{'config_hash'}->{'defmquota'});
		if ($self->{'config_hash'}->{'home_quotas'}) {
			# Set his home directory quota
			$self->set_quota($self->{'user'}->{'user'}, $self->{'config_hash'}->{'home_quotas'},
			   !$self->{'qedit'} ? $self->{'defmquota_array'}->[0] :
			    $self->{'in_hash'}->{'quota_def'} ? 0 :
				$self->quota_parse('quota', $self->{'config_hash'}->{'home_quotas'}));
			}
		if ($self->{'config_hash'}->{'mail_quotas'} && !$self->{'qsame'}) {
			# Set his home directory quota
			$self->set_quota($self->{'user'}->{'user'}, $self->{'config_hash'}->{'mail_quotas'},
			   !$self->{'qedit'} ? $self->{'defmquota_array'}->[0] :
			   $self->{'in_hash'}->{'mquota_def'} ? 0 :
				$self->quota_parse('mquota', $self->{'config_hash'}->{'mail_quotas'}));
			}
		}

	# Run plugin save functions
	foreach $f (@{$self->{'mail_plugins_array'}}) {
		$self->plugin_call($f, "mailbox_save", $self->{'user'}, \%{$self->{'old_hash'}}, \%{$self->{'in_hash'}}, $self->{'in_hash'}->{'new'}, $self->{'d'});
		}

	# Call other module functions
	if ($self->{'config_hash'}->{'other_users'}) {
		if ($self->{'in_hash'}->{'new'}) {
			$self->foreign_call($self->{'usermodule'}, "other_modules",
				      "useradmin_create_user", $self->{'user'});
			}
		else {
			$self->foreign_call($self->{'usermodule'}, "other_modules",
				      "useradmin_modify_user", $self->{'user'}, \%{$self->{'old_hash'}});
			}
		}

	$self->run_post_actions();
	$self->{'user'}->{'dom'} = $self->{'d'}->{'dom'};
	$self->webmin_log($self->{'in_hash'}->{'new'} ? "create" : "modify", "user",
		    $self->remove_userdom($self->{'user'}->{'user'}, $self->{'d'}), $self->{'user'});
	}
$self->unlock_user_db();
$self->redirect($self->{'d'} ? "list_users.cgi?dom=$self->{'in_hash'}->{'dom'}" : "index.cgi");

1;
		
}


1;

