#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_vfile.cgi
# Save an autoresponder file and alias

&ModuleLoader::preload_module('virtual_server_class', "virtual_server::VirtualserverLib");
$self = new virtual_server::VirtualserverLib:: 'virtual_server_class',%$self;

$self->ReadParseMime();
$self->{'d'} = $self->get_domain($self->{'in_hash'}->{'dom'});
$self->can_edit_domain($self->{'d'}) || $self->error($self->{'text_hash'}->{'aliases_ecannot'});
$self->{'config_hash'}->{'edit_afiles'} || $self->master_admin() ||
	$self->error($self->{'text_hash'}->{'vfile_ecannot'});
$self->{'what'} = $self->{'in_hash'}->{'alias'} ? 'alias' : 'user';

# Find the alias and its settings
if ($self->{'what'} eq "alias") {
	@{$self->{'aliases_array'}} = $self->list_domain_aliases($self->{'d'});
	($self->{'virt'}) = grep { $_->{'from'} eq $self->{'in_hash'}->{$self->{'what'}} } @{$self->{'aliases_array'}};
	}
else {
	@{$self->{'users_array'}} = $self->list_domain_users($self->{'d'});
	($self->{'user'}) = grep { $_->{'user'} eq $self->{'in_hash'}->{$self->{'what'}} } @{$self->{'users_array'}};
	}

# Validate inputs
$self->{'in_hash'}->{'time'} =~ /^\d+$/ || $self->error($self->{'text_hash'}->{'vfile_etime'});
$self->{'in_hash'}->{'num'} =~ /^\d+$/ || $self->error($self->{'text_hash'}->{'vfile_enum'});
$self->{'in_hash'}->{'dir_def'} || -d $self->{'in_hash'}->{'dir'} || $self->error($self->{'text_hash'}->{'vfile_edir'});
$self->{'in_hash'}->{'from'} ne 'other' || $self->{'in_hash'}->{'other'} =~ /^\S+$/ ||
	$self->error($self->{'text_hash'}->{'vfile_eother'});

# Update the alias
$self->{'val'} = "|$self->{'config_hash'}->{'vpopmail_auto'} $self->{'in_hash'}->{'time'} $self->{'in_hash'}->{'num'} $self->{'in_hash'}->{'file'}";
if ($self->{'in_hash'}->{'dir_def'}) {
	$self->{'val'} .= " ".$self->{'in_hash'}->{'file'}.".log";
	}
else {
	$self->{'val'} .= " ".$self->{'in_hash'}->{'dir'};
	}
if ($self->{'in_hash'}->{'flag'} ne "") {
	$self->{'val'} .= " ".$self->{'in_hash'}->{'flag'};
	}
elsif ($self->{'in_hash'}->{'from'} ne "") {
	$self->{'val'} .= " 0";
	}
if ($self->{'in_hash'}->{'from'} eq 'other') {
	$self->{'val'} .= " ".$self->{'in_hash'}->{'other'};
	}
elsif ($self->{'in_hash'}->{'from'} ne '') {
	$self->{'val'} .= " ".$self->{'in_hash'}->{'from'};
	}
if ($self->{'virt'}) {
	$self->{'virt'}->{'to'}->[$self->{'in_hash'}->{'idx'}] = $self->{'val'};
	$self->modify_virtuser($self->{'virt'}, $self->{'virt'});
	}
else {
	$self->{'user'}->{'to'}->[$self->{'in_hash'}->{'idx'}] = $self->{'val'};
	$self->modify_user($self->{'user'}, $self->{'user'}, $self->{'d'});
	}

# Save the file
$self->{'in_hash'}->{'text'} =~ s/\r//g;
$self->open_lock_tempfile(FILE, ">$self->{'in_hash'}->{'file'}", 1) ||
	$self->error($self->text('rfile_ewrite', $self->{'in_hash'}->{'file'}, $self->{'dom'}->{'user'}, $!));
$self->print_tempfile(FILE, $self->{'in_hash'}->{'text'});
$self->close_tempfile(FILE);
$self->webmin_log("save", "vfile", $self->{'in_hash'}->{'file'});

$self->redirect("edit_$self->{'what'}.cgi?$self->{'what'}=$self->{'in_hash'}->{$self->{'what'}}&dom=$self->{'in_hash'}->{'dom'}");

1;
		
}


1;

