#!/usr/bin/perl

&MAIN();

 sub MAIN {
# index.cgi
# Display a list of domains managed by this module

&ModuleLoader::preload_module('virtual_server_class', "virtual_server::VirtualserverLib");
$self = new virtual_server::VirtualserverLib:: 'virtual_server_class',%$self;


$self->ReadParse();
$self->{'redir_type'} = defined($self->{'in_hash'}->{'redir'}) ? $self->{'in_hash'}->{'redir'} : 2;
$self->{'bg_color'} = $self->{'tconfig_hash'}->{'cs_select'} ? "#$self->{'tconfig_hash'}->{'cs_select'}" : '#f2f2f2';
@{$self->{'redirs_array'}} = (
	'edit_user.cgi?new=1&type=mail&dom=$1', # add mail user
	'edit_user.cgi?new=1&type=ftp&dom=$1', # add ftp user
	'list_users.cgi?dom=$1', # list mail users
	'/bind8/edit_recs.cgi?type=ALL&view=&dom=$1', # dns management
	'/apache/apache_directives.cgi?type=101&dom=$1&home=1', # edit apache MIME dorectives
	'/apache/apache_directives.cgi?type=102&dom=$1&home=1', # edit apache REDIRECT directives
	'/apache/apache_directives.cgi?type=103&dom=$1&home=1', # edit apache ALIASES directives
	'/apache/apache_directives.cgi?type=104&dom=$1&home=1', # edit apache HANDLERS directives
	'domain_form.cgi?to=$1', # edit aliases
	'rename_form.cgi?dom=$1',
	'list_databases.cgi?dom=$1',
	'cert_form.cgi?dom=$1',
	'bwgraph.cgi?dom=$1',
	'edit_user.cgi?new=1&type=samba&dom=$1', # add samba user
	'/apache/apache_directives.cgi?type=105&dom=$1&home=1', # edit apache CUSTOM ERORROR PAGES directives
);
$self->{'text_hash'}->{'website_select_redir_href'} = $self->{'redirs_array'}->[$self->{'redir_type'}];

# Display domains
@{$self->{'doms_array'}} = grep { $self->can_edit_domain($_) } $self->list_domains();

if ((@{$self->{'doms_array'}}) && (scalar(@{$self->{'doms_array'}}) == 1 )) {
   $self->redirect($self->text('website_select_redir_href', @{$self->{'doms_array'}}[0]->{'id'}));
   } else {
     $self->header($self->text('website_select', $self->{'t_website'}), "", undef, undef, 1);
     print "<hr>\n";
     }

if (@{$self->{'doms_array'}}) {
	# Show domains in a table
	&home_domains_table(\@{$self->{'doms_array'}});
	}
else {
	print "<b>$self->{'text_hash'}->{'index_none'}</b><p>\n";
}

print "<hr>\n";
$self->ui_print_footer($self->{'text_hash'}->{'index_mainpage_url'}, $self->{'text_hash'}->{'index_mainpage'});

1;
		
}

# home_domains_table(&domains)
# Display a list of domains in a table, with links for editing
sub home_domains_table
{
	shift if ($self == $_[0]);

local @table_features = $self->{'config_hash'}->{'show_features'} ?
    (grep { $_ ne 'webmin' && $_ ne 'mail' && $_ ne 'unix' } @{$self->{'features_array'}}) : ( );
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'website_website'}</b></td> ",
      "<td><b>$self->{'text_hash'}->{'website_user'}</b></td> ",
      "<td><b>$self->{'text_hash'}->{'index_owner'}</b></td> ";
print "</tr>\n";
local $d;
local %done;
foreach $d (sort { $a->{'user'} cmp $b->{'user'} ||
		   $a->{'created'} <=> $b->{'created'} } @{$_[0]}) {
	$done{$d->{'id'}}++;
	$self->{'href'} = $self->text('website_select_redir_href', $d->{'id'}); #"website_useredit.cgi?new=1&dom=$d->{'id'}";
        print qq|<tr $self->{'cb'} style="cursor: hand" onMouseout="this.style.backgroundColor=''" onMouseover="this.style.backgroundColor='$self->{'bg_color'}'" onclick="location.href='$self->{'href'}'">\n|; 	local $dn = $d->{'disabled'} ? "<i>$d->{'dom'}</i>" : $d->{'dom'};
	local $pfx = $d->{'parent'} && $done{$d->{'parent'}} ?
		"&nbsp;&nbsp;" : "";
	print "<td>$pfx$dn</td>\n";
	print "<td>$d->{'user'}$self->{'create_subdomain'}</td>\n";
	print "<td>$d->{'owner'}</td>\n";
	# print actions column
	#print "<td><a href='website_useredit.cgi?new=1&dom=$d->{'id'}'>$self->{'text_hash'}->{'website_muser_add2'}</a></td>\n";
	print "</tr>\n";
	}
print "</table>\n";
}


1;

