#!/usr/bin/perl

&MAIN();

 sub MAIN {
# start_apache.cgi
# Start apache with the server root from the config files

&ModuleLoader::preload_module('virtual_server_class', "virtual_server::VirtualserverLib");
$self = new virtual_server::VirtualserverLib:: 'virtual_server_class',%$self;

$self->{'access_hash'}->{'stop'} || $self->error($self->{'text_hash'}->{'start_ecannot'});
$self->require_apache();
$self->ReadParse();
$self->error_setup($main::apache_object->{'text_hash'}->{'start_err'});

$self->clean_environment();

if ($main::apache_object->{'config_hash'}->{'start_cmd'}) {
	# use the configured start command
	if ($main::apache_object->{'config_hash'}->{'stop_cmd'}) {
		# execute the stop command to clear lock files
		$self->system_logged("( $main::apache_object->{'config_hash'}->{'stop_cmd'} ) >/dev/null 2>&1");
		}
	$self->{'out'} = $self->backquote_logged("( $main::apache_object->{'config_hash'}->{'start_cmd'} ) 2>&1");
	$self->reset_environment();
	if ($?) {
		$self->error("<pre>$self->{'out'}</pre>");
		}
	}
elsif (-x $main::apache_object->{'config_hash'}->{'apachectl_path'}) {
	# use the apachectl program
	$self->{'out'} = $self->backquote_logged("( $main::apache_object->{'config_hash'}->{'apachectl_path'} start ) 2>&1");
	$self->reset_environment();
	if ($self->{'out'} =~ /\S/ && $self->{'out'} !~ /httpd started/) {
		$self->error("<pre>$self->{'out'}</pre>");
		}
	}
else {
	# start manually
	$self->{'cmd'} = "$main::apache_object->{'config_hash'}->{'httpd_path'} -d $main::apache_object->{'config_hash'}->{'httpd_dir'}";
	if ($main::apache_object->{'config_hash'}->{'httpd_conf'}) { $self->{'cmd'} .= " -f $main::apache_object->{'config_hash'}->{'httpd_conf'}"; }
	$self->{'temp'} = $self->transname();
	$self->{'rv'} = $self->system_logged("( $self->{'cmd'} ) >$self->{'temp'} 2>&1 </dev/null");
	$self->{'out'} = `cat $self->{'temp'}`;
	unlink($self->{'temp'});
	$self->reset_environment();
	if ($self->{'out'} =~ /\S/ && $self->{'out'} !~ /httpd started/) {
		$self->error("<pre>$self->{'cmd'} :\n$self->{'out'}</pre>");
		}
	}

# check if startup was successful. Later apache version return no
# error code, but instead fail to start and write the reason to
# the error log file!
sleep(3);
$self->{'conf'} = $main::apache_object->get_config();
$self->{'pid'} = $self->get_apache_pid();
if (!$self->{'pid'} || !kill(0, $self->{'pid'})) {
	# Not running..  find out why
	$self->{'errorlogstr'} = $main::apache_object->find_directive_struct("ErrorLog", $self->{'conf'});
	$self->{'errorlog'} = $self->{'errorlogstr'} ? $self->{'errorlogstr'}->{'words'}->[0]
				 : "logs/error_log";
	if ($self->{'out'} =~ /\S/) {
		$self->error("<pre>$self->{'out'}</pre>");
		}
	elsif ($self->{'errorlog'} eq 'syslog' || $self->{'errorlog'} =~ /^\|/) {
		$self->error($main::apache_object->{'text_hash'}->{'start_eunknown'});
		}
	else {
		$self->{'errorlog'} = $main::apache_object->server_root($self->{'errorlog'}, $self->{'conf'});
		$self->{'out'} = `tail -5 $self->{'errorlog'}`;
		$self->error("<pre>$self->{'out'}</pre>");
		}
	}
$self->webmin_log("start", "web");
$self->redirect("");

1;
		
}


1;

