#!/usr/bin/perl

&MAIN();

 sub MAIN {
# stop_apache.cgi
# Shut down the Apache webserver

&ModuleLoader::preload_module('virtual_server_class', "virtual_server::VirtualserverLib");
$self = new virtual_server::VirtualserverLib:: 'virtual_server_class',%$self;

$self->{'access_hash'}->{'stop'} || $self->error($self->{'text_hash'}->{'stop_ecannot'});
$self->require_apache();
$self->error_setup($main::apache_object->{'text_hash'}->{'stop_err'});

if ($main::apache_object->{'config_hash'}->{'stop_cmd'}) {
	# use the configured stop command
	$self->{'out'} = $self->backquote_logged("( $main::apache_object->{'config_hash'}->{'stop_cmd'} ) 2>&1");
	if ($?) {
		$self->error("<pre>$self->{'out'}</pre>");
		}
	}
elsif (-x $main::apache_object->{'config_hash'}->{'apachectl_path'}) {
	# use the apachectl program
	$self->{'out'} = $self->backquote_logged("$main::apache_object->{'config_hash'}->{'apachectl_path'} stop 2>&1");
	if ($self->{'httpd_modules_hash'}->{'core'} >= 2 ? $? : $self->{'out'} !~ /httpd stopped/) {
		$self->error("<pre>$self->{'out'}</pre>");
		}
	}
else {
	# kill the process
	$self->{'pid'} = $self->get_apache_pid();
	$self->{'pid'} || $self->error($main::apache_object->text('stop_epid2', $self->{'pidfile'}));
	$self->kill_logged('TERM', $self->{'pid'}) || $self->error($main::apache_object->text('stop_esig', $self->{'pid'}));
	}
sleep(1);
$self->webmin_log("stop", "web");
$self->redirect("");

1;
		
}


1;

