#!/usr/bin/perl

&MAIN();

 sub MAIN {
# create_virt.cgi
# create new VsFTPd virtual server

# main part
&ModuleLoader::preload_module('vsftpd_class', "vsftpd::VsftpdLib");
$self = new vsftpd::VsftpdLib:: 'vsftpd_class',%$self;

$self->ReadParse();

# ACL error
$self->error($self->{'text_hash'}->{'virt_ecreate'}) unless ($self->{'access_hash'}->{'daemon'});

# get virtual server options
local ($name, $ip, $root) = ($self->{'in_hash'}->{'new_name'}, $self->{'in_hash'}->{'new_ip'}, $self->{'in_hash'}->{'new_root'});
local $port = $self->{'in_hash'}->{'new_port_def'} ? $self->{'in_hash'}->{'new_port'} : '21';

# define vsftpd virtual server config file
local $conf_file = "$self->{'config_hash'}->{'vsftpd_dir'}/vsftpd.$name.conf";

# valid name check
$self->error($self->{'text_hash'}->{'virt_ename'}) if (-e $conf_file);
  
# set new VSFTPd virtual server configuration options
local %conf = ('listen' => 'YES',
				'listen_address' => $ip,
				'listen_port' => $port,
				'pam_service_name' => 'vsftpd',
				'tcp_wrappers' => 'YES',
				'anonymous_enable' => 'YES',
				'anon_root' => $root,
				'local_enable' => 'YES',
				'local_umask' => 022,
				'userlist_enable' => 'YES',
				'write_enable' => 'YES',
				'xferlog_enable' => 'YES',
				'xferlog_std_format' => 'YES',
				'xferlog_file' => '/var/log/vsftpd.log',
				'connect_from_port_20' => 'YES',
				'dirmessage_enable' => 'YES',
				'ftpd_banner' => "Welcome to $name");
$self->open_tempfile(CONF, ">$conf_file");
foreach (keys %conf)
{
 print CONF "$_=$conf{$_}\n";
}
$self->close_tempfile(CONF);

# restart daemon vsftpd
$self->restart_vsftpd() if $self->status_vsftpd();

# redirect to index.cgi
$self->redirect("index.cgi");
1;
		
}


1;

