#!/usr/bin/perl

&MAIN();

 sub MAIN {
# index.cgi
# display the icons or list of vsftpd virtual servers

# main part
&ModuleLoader::preload_module('vsftpd_class', "vsftpd::VsftpdLib");
$self = new vsftpd::VsftpdLib:: 'vsftpd_class',%$self;

%{$self->{'access_hash'}} = $self->get_module_acl();
$self->ReadParse();

# error config messeges
if (!-d $self->{'config_hash'}->{'vsftpd_dir'}) 
{
 if ($self->{'gconfig_hash'}->{'ztl_mode'})
 {
  $self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", undef, 0, 0);
  $self->ui_print_endpage($self->text('index_ztl_edir',$self->{'config_hash'}->{'vsftpd_dir'}));
 }
 else
 {
  $self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", undef, 1, 1);
  $self->ui_print_endpage($self->ui_config_link('index_edir',[ "<tt>$self->{'config_hash'}->{'vsftpd_dir'}</tt>", undef ]));
 }
}
elsif (!$self->has_command($self->{'config_hash'}->{'vsftpd_cmd'})) 
{
 if ($self->{'gconfig_hash'}->{'ztl_mode'})
 {
  $self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", undef, 0, 0);
  $self->ui_print_endpage($self->text('index_ztl_ecmd',$self->{'config_hash'}->{'vsftpd_cmd'}));
 }
 else
 {
  $self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", undef, 1, 1);
  $self->ui_print_endpage($self->ui_config_link('index_ecmd',[ "<tt>$self->{'config_hash'}->{'vsftpd_cmd'}</tt>", undef ]));
 }
}
# get virtual servers list
local $servers = $self->list_virtual_server();
if (scalar(@{$servers}) == 1 && $self->{'access_hash'}->{'virts'} ne '*') 
{
 # redirect to virt.cgi
 $self->redirect("virt.cgi?idx=$servers->[0]->{'idx'}");
 exit;
}
# start, restart or stop service
if ($self->{'access_hash'}->{'daemon'})
{
 # start, restart or stop service
 if ($self->{'in_hash'}->{'start'}) { $self->start_vsftpd; }
 elsif ($self->{'in_hash'}->{'stop'}) { $self->stop_vsftpd; }
 elsif ($self->{'in_hash'}->{'restart'}) { $self->restart_vsftpd; }
}

# print header
local $version = $self->get_version_vsftpd();
$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, undef, undef, 1, undef, undef, undef, undef, undef, $version ? $self->text('index_version',"$version") : 0);

# sort servers list
local ($temp, @temp);
foreach (@{$servers})
{
 unless ($_->{'name'} eq 'default'){ push (@temp,$_); }
 else { $temp = $_; }
}
@{$servers} = sort {$a->{'name'} cmp $b->{'name'}} @temp;
@{$servers} = ($temp,@{$servers}) if ($temp);
 
# print virtual servers
local ($ip, $port,$anon,$url);
if ($self->{'config_hash'}->{show_list}==1)
{
 # show list
 print "<TABLE width=100% border=1><TR bgcolor=#00308B class='thfontcolor'>\n";
 print "<TD width=20%><b>$self->{'text_hash'}->{'server_name'}</b></TD>\n";
 print "<TD width=20%><b>$self->{'text_hash'}->{'server_ip'}</b></TD>\n";
 print "<TD width=20%><b>$self->{'text_hash'}->{'server_port'}</b></TD>\n";
 print "<TD width=20%><b>$self->{'text_hash'}->{'server_anon'}</b></TD>\n";
 print "<TD width=20%><b>$self->{'text_hash'}->{'server_url'}</b></TD></TR>\n";
 foreach (@{$servers})
 {
  # get listen ip & TCP-port
  if (($_->{'conf'}->{'listen'} eq 'YES'))
  {
   $ip = $_->{'conf'}->{'listen_address'} ? $_->{'conf'}->{'listen_address'} : 'ANY';
   $port = $_->{'conf'}->{'listen_port'} ? $_->{'conf'}->{'listen_port'} : '21';
   $url = $ip;
  }
  else 
  { 
   $ip = 'no standalone mode';
   $url = '';
  }
  # get anonymous directory
  $anon = $_->{'conf'}->{'anon_root'} ? $_->{'conf'}->{'anon_root'} : '/var/ftp';

  # print servers list
  print "<TR bgcolor=#eefaff>\n";
  print "<TD valign=top width=20%><a href='virt.cgi?idx=$_->{'idx'}'>$_->{'name'}</a></TD>\n";
  print "<TD valign=top width=20%>$ip</TD>\n";
  print "<TD valign=top width=20%>$port</TD>\n";
  print "<TD valign=top width=30%>$anon</TD>\n";
  print "<TD valign=top width=20%><a href=ftp://$url>$self->{'text_hash'}->{'index_view'} </a></TD></TR>\n";
 }
 print "<TR bgcolor=#eefaff><TD colspan=5>&nbsp;</TD></TR></TABLE>\n";
}
else
{
 # show icons
 print $self->ui_subheading($self->{'text_hash'}->{'virtual_servers'});
 print "<TABLE width=100% cellpadding=5>\n";
 foreach (@{$servers})
 {
  # get listen ip & TCP-port
  if (($_->{'conf'}->{'listen'} eq 'YES'))
  {
   $ip = $_->{'conf'}->{'listen_address'} ? $_->{'conf'}->{'listen_address'} : 'ANY';
   $port = $_->{'conf'}->{'listen_port'} ? $_->{'conf'}->{'listen_port'} : '21';
   $url = $self->html_escape($ip);
  }
  else 
  { 
   $ip = 'no standalone mode'; 
   $url = '';
  }
  # get anonymous directory
  $anon = $_->{'conf'}->{'anon_root'} ? $_->{'conf'}->{'anon_root'} : '/var/ftp';
  $anon = $self->html_escape($anon);
 
  # print servers icons
  print "<TR><TD width=20% valign=top align=center nowrap>\n";
  $self->generate_icon("images/virt.gif",$_->{'name'},"virt.cgi?idx=$_->{idx}",undef, undef, undef,undef);
  print "</TD><TD valign=top>".$self->text('index_defdesc',$_->{'name'})."<BR>\n";
  print "<TABLE width=100%>\n";
  print "<TR><TD width=30%><b>$self->{'text_hash'}->{'server_ip'}</b>&nbsp;&nbsp;".$self->html_escape($ip)."<BR>\n";
  print "<b>$self->{'text_hash'}->{'server_port'}</b>&nbsp;&nbsp;".$self->html_escape($port)."</TD>\n";
  print "<TD width=70%><b>$self->{'text_hash'}->{'server_anon'}</b>&nbsp;&nbsp;$anon<BR>\n";
  print "<b>$self->{'text_hash'}->{'server_url'}</b>&nbsp;&nbsp;<a href=ftp://$url>$self->{'text_hash'}->{'index_view'}</a>\n" if $url;
  print "</TD></TR></TABLE></TD></TR>";
 }
 print "</TABLE>\n";
}

if ($self->{'access_hash'}->{'daemon'})
{
 # print new virtual server form
 print $self->ui_form_start('create_virt.cgi','post')."\n";
 print $self->ui_table_start($self->{'text_hash'}->{'index_create'},'width=50%');
 print "<tr $self->{'cb'}><td valign=top><b>$self->{'text_hash'}->{'index_newname'}</b></td>\n";
 print "<td>".$self->ui_textbox('new_name', undef, 18)."</td></tr>\n";
 print "<tr $self->{'cb'}><td valign=top><b>$self->{'text_hash'}->{'index_newaddr'}</b></td>\n";
 print "<td>".$self->ui_textbox('new_ip', undef, 18)."</td></tr>\n";
 print "<tr $self->{'cb'}><td valign=top><b>$self->{'text_hash'}->{'index_newport'}</b></td>\n";
 print "<td>".$self->ui_radio('new_port_def', 0, [ [ 0, $self->{'text_hash'}->{'default'} ], [ 1, $self->ui_textbox('new_port', undef, 5) ]])."</td></tr>\n";
 print "<tr $self->{'cb'}><td valign=top><b>$self->{'text_hash'}->{'index_newroot'}</b></td>\n";
 print "<td><input name=new_root size=18>".$self->file_chooser_button("new_root", 1, 1)."</td> </tr>\n";
 print $self->ui_table_end();
 print $self->ui_submit($self->{'text_hash'}->{'index_create'});
 print $self->ui_form_end();
 
 # print submit start,restart or stop
 print "<TABLE width=100% border=1>\n";
 if ($self->{'config_hash'}->{show_list} ==1 )
 {
  print "<TR bgcolor=#00308B class='thfontcolor'>\n";
  print "<TD colspan=2><b>$self->{'text_hash'}->{'process_managment'}</b></TD></TR>\n";
 }
 else {print $self->ui_subheading($self->{'text_hash'}->{'process_managment'});}

 local $color = $self->{'cb'} if ($self->{'config_hash'}->{'show_list'});
 print "<FORM action=index.cgi><TR>\n";
 # index proces status
 if ($self->status_vsftpd())
 {
  # service started
  print "<TD $color width=15%><INPUT type=hidden name=stop value=1>\n";
  print "<INPUT style=width:120 type=submit value='$self->{'text_hash'}->{'index_stop'}'>\n";
  print "<TD $color>$self->{'text_hash'}->{'index_stopmsg'}</TD></FORM>\n";
  print "<FORM action=index.cgi><TR>\n";
  print "<TD $color width=15%><INPUT type=hidden name=restart value=1>\n";
  print "<INPUT style=width:120 type=submit value='$self->{'text_hash'}->{'index_restart'}'>\n";
  print "<TD $color>$self->{'text_hash'}->{'index_restartmsg'}\n";
 }
 else
 {
  # service stoped
  print "<TD $color width=15%><INPUT type=hidden name=start value=1>\n";
  print "<INPUT style=width:120 type=submit value='$self->{'text_hash'}->{'index_start'}'>\n";
  print "<TD $color>$self->{'text_hash'}->{'index_startmsg'}\n";
 }
 print "</TD></TR></FORM></TABLE>\n";
}

# print main page url
$self->ui_print_footer($self->{'text_hash'}->{'index_mainpage_url'}, $self->{'text_hash'}->{'index_mainpage'});
1;
		
}


1;

