#!/usr/bin/perl
package webalizer::Backup_config;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'webalizer::Backup_config');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;

&ModuleLoader::preload_module(ref($self), "webalizer::WebalizerLib");
$self = new webalizer::WebalizerLib:: ref($self), %$self; 

1;

1;
		return $self;
}

# backup_config_files()
# Returns files and directories that can be backed up
sub backup_config_files
{
	my $self = shift;

local @rv = ( $self->{'config_hash'}->{'webalizer_conf'} );
local $f;
opendir(DIR, $self->{'module_config_directory'});
while($f = readdir(DIR)) {
	if ($f =~ /\.conf$/ || $f =~ /\.log$/) {
		push(@rv, "$self->{'module_config_directory'}/$f");
		}
	}
closedir(DIR);
return @rv;
}

# pre_backup(&files)
# Called before the files are actually read
sub pre_backup
{
	my $self = shift;

return undef;
}

# post_backup(&files)
# Called after the files are actually read
sub post_backup
{
	my $self = shift;

return undef;
}

# pre_restore(&files)
# Called before the files are restored from a backup
sub pre_restore
{
	my $self = shift;

return undef;
}

# post_restore(&files)
# Called after the files are restored from a backup
sub post_restore
{
	my $self = shift;

# Re-setup all needed cron jobs
$self->foreign_require("cron", "cron-lib.pl");
local @jobs = $main::cron_object->list_cron_jobs();
foreach $log ($self->get_all_logs()) {
	local $lconf = $self->get_log_config($log->{'file'});
	if ($lconf->{'sched'}) {
		local ($job) = grep { $_->{'command'} eq
				      "$self->{'cron_cmd'} $log->{'file'}" } @jobs;
		if (!$job) {
			# Need to create!
			$job->{'user'} = 'root';
			$job->{'active'} = 1;
			$job->{'special'} = $lconf->{'special'};
			$job->{'mins'} = $lconf->{'mins'};
			$job->{'hours'} = $lconf->{'hours'};
			$job->{'days'} = $lconf->{'days'};
			$job->{'months'} = $lconf->{'months'};
			$job->{'weekdays'} = $lconf->{'weekdays'};
			$job->{'command'} = "$self->{'cron_cmd'} $log->{'file'}";
			$main::cron_object->create_cron_job($job);
			}
		}
	}
return undef;
}


1;

