#!/usr/bin/perl

&MAIN();

 sub MAIN {
# index.cgi
# Display available apache or squid logfiles

&ModuleLoader::preload_module('webalizer_class', "webalizer::WebalizerLib");
$self = new webalizer::WebalizerLib:: 'webalizer_class',%$self;

$self->foreign_require("cron", "cron-lib.pl");

# Check if webalizer is actually installed
if (!$self->has_command($self->{'config_hash'}->{'webalizer'})) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", undef, 1, 1, 0,
		$self->help_search_link("webalizer", "man", "doc", "google"));
	print $self->text('index_ewebalizer', "<tt>$self->{'config_hash'}->{'webalizer'}</tt>",
		  "$self->{'gconfig_hash'}->{'webprefix'}/config.cgi?$self->{'module_name'}"),"<p>\n";

	$self->foreign_require("software", "software-lib.pl");
	$self->{'lnk'} = $main::software_object->missing_install_link(
			"webalizer", $self->{'text_hash'}->{'index_webalizer'},
			"../$self->{'module_name'}/", $self->{'text_hash'}->{'index_title'});
	print $self->{'lnk'},"<p>\n" if ($self->{'lnk'});

	$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});
	exit;
	}

# Get the version number
$self->{'webalizer_version'} = $self->get_webalizer_version(\$self->{'out'});
if (!$self->{'webalizer_version'}) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", undef, 1, 1, 0,
		$self->help_search_link("webalizer", "man", "doc", "google"));
	print $self->text('index_egetversion',
			  "<tt>$self->{'config_hash'}->{'webalizer'} -v</tt>",
			  "<pre>$self->{'out'}</pre>"),"<p>\n";
	$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});
	exit;
	}

if ($self->{'webalizer_version'} < 2) {
	&main_header();
	print $self->text('index_eversion', "<tt>$self->{'config_hash'}->{'webalizer'}</tt>",
			  "$self->{'webalizer_version'}", "2.0"),"<p>\n";
	$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});
	exit;
	}

# Check if the config file exists
if (!-r $self->{'config_hash'}->{'webalizer_conf'} && -r $self->{'config_hash'}->{'alt_conf'}) {
	# No, but the sample one does
	system("cp '$self->{'config_hash'}->{'alt_conf'}' '$self->{'config_hash'}->{'webalizer_conf'}' >/dev/null 2>&1");
	}
if (!-r $self->{'config_hash'}->{'webalizer_conf'}) {
	&main_header();
	print $self->text('index_econf', "<tt>$self->{'config_hash'}->{'webalizer_conf'}</tt>",
		  "$self->{'gconfig_hash'}->{'webprefix'}/config.cgi?$self->{'module_name'}"),"<p>\n";
	$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});
	exit;
	}

# Query apache and squid for their logfiles
@{$self->{'logs_array'}} = $self->get_all_logs();

# Remove in-accessible logs, and redirect if only one
@{$self->{'logs_array'}} = grep { $self->can_edit_log($_->{'file'}) } @{$self->{'logs_array'}};
if (@{$self->{'logs_array'}} == 1 && -r $self->{'logs_array'}->[0]->{'file'} &&
    $self->{'access_hash'}->{'noconfig'} && !$self->{'access_hash'}->{'add'} && !$self->{'access_hash'}->{'global'}) {
	# User can only edit/view one log file ..
	local $l = $self->{'logs_array'}->[0];
	if ($self->{'access_hash'}->{'view'}) {
		$self->redirect("view_log.cgi/".$self->urlize($self->urlize($l->{'file'})).
			  "/index.html");
		}
	else {
		$self->redirect("edit_log.cgi?file=".$self->urlize($l->{'file'}).
                	  "&type=$l->{'type'}&custom=$l->{'custom'}");
		}
	exit;
	}

&main_header();
@{$self->{'links_array'}} = ( );
if (@{$self->{'logs_array'}}) {
	if (!$self->{'access_hash'}->{'view'}) {
		print $self->ui_form_start("mass.cgi", "post");
		push(@{$self->{'links_array'}}, $self->select_all_link("d"),
			     $self->select_invert_link("d"));
		}
	push(@{$self->{'links_array'}}, "<a href='edit_log.cgi?new=1'>$self->{'text_hash'}->{'index_add'}</a>")
		if (!$self->{'access_hash'}->{'view'} && $self->{'access_hash'}->{'add'});
	print $self->ui_links_row(\@{$self->{'links_array'}});
	local @tds = ( "width=5" );
	print $self->ui_columns_start([ $self->{'access_hash'}->{'view'} ? ( ) : ( "" ),
				  $self->{'text_hash'}->{'index_path'},
				  $self->{'text_hash'}->{'index_type'},
			 	  $self->{'text_hash'}->{'index_size'},
				  $self->{'text_hash'}->{'index_sched'},
				  $self->{'text_hash'}->{'index_rep'} ], 100, 0, \@tds);
	foreach $l (@{$self->{'logs_array'}}) {
		next if ($self->{'done_hash'}->{$l->{'file'}}++);
		local @files = $self->all_log_files($l->{'file'});
		next if (!@files);
		local $lconf = $self->get_log_config($l->{'file'});
		local @cols;
		local $short = $l->{'file'};
		if (length($short) > 40) {
			$short = "...".substr($short, -40);
			}
		if ($self->{'access_hash'}->{'view'}) {
			push(@cols, $short);
			}
		else {
			push(@cols, "<a href='edit_log.cgi?file=".
				   $self->urlize($l->{'file'}).
				   "&type=$l->{'type'}&custom=$l->{'custom'}'>".
				   "$short</a>");
			}
		push(@cols, $self->text('index_type'.$l->{'type'}));
		local ($size, $latest);
		foreach $f (@files) {
			local @st = stat($f);
			$size += $st[7];
			$latest = $st[9] if ($st[9] > $latest);
			}
		$latest = $latest ? localtime($latest) : "<br>";
		push(@cols, $size ? $self->nice_size($size) : $self->{'text_hash'}->{'index_empty'});
		push(@cols, $lconf->{'sched'} ?
			$self->text('index_when', $main::cron_object->when_text($lconf)) :
			$self->{'text_hash'}->{'no'});
		if ($lconf->{'dir'} && -r "$lconf->{'dir'}/index.html") {
			push(@cols, "<a href='view_log.cgi/".
				    $self->urlize($self->urlize($l->{'file'})).
				    "/index.html'>$self->{'text_hash'}->{'index_view'}</a>");
			}
		else {
			push(@cols, "");
			}
		if ($self->{'access_hash'}->{'view'}) {
			print $self->ui_columns_row(\@cols);
			}
		elsif (!%$lconf) {
			print $self->ui_columns_row([ "&nbsp;&nbsp;", @cols ]);
			}
		else {
			print $self->ui_checked_columns_row(\@cols, \@tds, "d",
						      $l->{'file'});
			}
		}
	print $self->ui_columns_end();
	}
else {
	print "<p><b>$self->{'text_hash'}->{'index_nologs'}</b><p>\n";
	push(@{$self->{'links_array'}}, "<a href='edit_log.cgi?new=1'>$self->{'text_hash'}->{'index_add'}</a>")
		if (!$self->{'access_hash'}->{'view'} && $self->{'access_hash'}->{'add'});
	}
print $self->ui_links_row(\@{$self->{'links_array'}});
if (@{$self->{'logs_array'}} && !$self->{'access_hash'}->{'view'}) {
	print $self->ui_form_end([ [ "enable", $self->{'text_hash'}->{'index_enable'} ],
			     [ "disable", $self->{'text_hash'}->{'index_disable'} ] ]);
	}

if (!$self->{'access_hash'}->{'view'} && $self->{'access_hash'}->{'global'}) {
	print "<hr>\n";
	print "<form action=edit_global.cgi>\n";
	print "<table width=100%><tr>\n";
	print "<td><input type=submit value='$self->{'text_hash'}->{'index_global'}'></td>\n";
	print "<td>$self->{'text_hash'}->{'index_globaldesc'}</td>\n";
	print "</tr></table></form>\n";
	}

$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});

1;
		
}

sub main_header
{
	shift if ($self == $_[0]);

$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", undef, 1, 1, 0,
	$self->help_search_link("webalizer", "man", "doc", "google"),
	undef, undef, $self->text('index_version', $self->{'webalizer_version'}));
}


1;

