#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Mass schedule or de-schedule a bunch of logs

&ModuleLoader::preload_module('webalizer_class', "webalizer::WebalizerLib");
$self = new webalizer::WebalizerLib:: 'webalizer_class',%$self;

$self->foreign_require("cron", "cron-lib.pl");
$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'mass_err'});
$self->{'access_hash'}->{'view'} && $self->error($self->{'text_hash'}->{'edit_ecannot'});

# Validate inputs
@{$self->{'d_array'}} = split(/\0/, $self->{'in_hash'}->{'d'});
@{$self->{'d_array'}} || $self->error($self->{'text_hash'}->{'mass_enone'});
@{$self->{'jobs_array'}} = $main::cron_object->list_cron_jobs();
foreach $file (@{$self->{'d_array'}}) {
	$self->can_edit_log($file) || $self->error($self->{'text_hash'}->{'edit_efilecannot'});
	($self->{'job_hash'}->{$file}) = grep { $_->{'command'} eq "$self->{'cron_cmd'} $file" } @{$self->{'jobs_array'}};
	}

$self->{'count'} = 0;
if ($self->{'in_hash'}->{'enable'}) {
	# Add cron jobs for selected
	foreach $file (@{$self->{'d_array'}}) {
		$self->{'cfile'} = $self->config_file_name($file);
		$self->{'lconf'} = $self->get_log_config($file);
		if (!$self->{'lconf'}->{'sched'}) {
			$self->lock_file($self->{'cfile'});
			$self->{'lconf'}->{'sched'} = 1;
			$self->{'job'} = $self->{'job_hash'}->{$file};
			if (!$self->{'job'}) {
				$self->{'job'} = { 'user' => 'root',
					 'active' => 1,
					 'command' => "$self->{'cron_cmd'} $file" };
				$self->lconf_to_cron($self->{'lconf'}, $self->{'job'});
				$self->lock_file($main::cron_object->cron_file($self->{'job'}));
				$main::cron_object->create_cron_job($self->{'job'});
				$self->unlock_file($main::cron_object->cron_file($self->{'job'}));
				}
			$self->save_log_config($file, $self->{'lconf'});
			$self->unlock_file($self->{'cfile'});
			$self->{'count'}++;
			}
		}
	}
else {
	# Cancel cron jobs for selected
	foreach $file (@{$self->{'d_array'}}) {
		$self->{'cfile'} = $self->config_file_name($file);
		$self->{'lconf'} = $self->get_log_config($file);
		if ($self->{'lconf'}->{'sched'}) {
			$self->lock_file($self->{'cfile'});
			$self->{'lconf'}->{'sched'} = 0;
			$self->{'job'} = $self->{'job_hash'}->{$file};
			if ($self->{'job'}) {
				$self->lock_file($main::cron_object->cron_file($self->{'job'}));
				$main::cron_object->delete_cron_job($self->{'job'});
				$self->unlock_file($main::cron_object->cron_file($self->{'job'}));
				}
			$self->save_log_config($file, $self->{'lconf'});
			$self->unlock_file($self->{'cfile'});
			$self->{'count'}++;
			}
		}
	$self->webmin_log("disable", "logs", $self->{'count'});
	}

$self->redirect("");

1;
		
}


1;

