#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_global.cgi
# Save options to a webalizer.conf file

&ModuleLoader::preload_module('webalizer_class', "webalizer::WebalizerLib");
$self = new webalizer::WebalizerLib:: 'webalizer_class',%$self;

$self->error_setup($self->{'text_hash'}->{'global_err'});
$self->{'access_hash'}->{'view'} && $self->error($self->{'text_hash'}->{'edit_ecannot'});
$self->ReadParse();
!$self->{'in_hash'}->{'file'} || $self->can_edit_log($self->{'in_hash'}->{'file'}) || $self->error($self->{'text_hash'}->{'edit_ecannot'});
$self->{'in_hash'}->{'file'} || $self->{'access_hash'}->{'global'} || $self->error($self->{'text_hash'}->{'edit_ecannot'});

$self->{'cfile'} = $self->config_file_name($self->{'in_hash'}->{'file'}) if ($self->{'in_hash'}->{'file'});
if ($self->{'in_hash'}->{'delete'}) {
	# Just delete the configuration for this logfile
	$self->unlink_logged($self->{'cfile'});
	$self->redirect("");
	exit;
	}

$self->lock_file($self->{'cfile'} || $self->{'config_hash'}->{'webalizer_conf'});
$self->{'conf'} = $self->get_config($self->{'in_hash'}->{'file'});

# Validate and store inputs
if ($self->{'in_hash'}->{'report_def'}) {
	$self->save_directive($self->{'conf'}, "ReportTitle");
	}
else {
	$self->{'in_hash'}->{'report'} =~ /\S/ || $self->error($self->{'text_hash'}->{'global_ereport'});
	$self->save_directive($self->{'conf'}, "ReportTitle", $self->{'in_hash'}->{'report'});
	}

if ($self->{'in_hash'}->{'host_def'}) {
	$self->save_directive($self->{'conf'}, "HostName");
	}
elsif (defined($self->{'in_hash'}->{'host'})) {
	$self->{'in_hash'}->{'host'} =~ /^\S+$/ || $self->error($self->{'text_hash'}->{'global_ehost'});
	$self->save_directive($self->{'conf'}, "HostName", $self->{'in_hash'}->{'host'});
	}

@{$self->{'pages_array'}} = split(/\s+/, $self->{'in_hash'}->{'page'});
$self->save_directive($self->{'conf'}, "PageType", @{$self->{'pages_array'}});

@{$self->{'index_array'}} = split(/\s+/, $self->{'in_hash'}->{'index'});
$self->save_directive($self->{'conf'}, "IndexAlias", @{$self->{'index_array'}});

if ($self->{'in_hash'}->{'gmt'}) {
	$self->save_directive($self->{'conf'}, "GMTTime", "yes");
	}
else {
	$self->save_directive($self->{'conf'}, "GMTTime");
	}

if ($self->{'in_hash'}->{'fold'}) {
	$self->save_directive($self->{'conf'}, "FoldSeqErr", "yes");
	}
else {
	$self->save_directive($self->{'conf'}, "FoldSeqErr");
	}

if ($self->{'in_hash'}->{'visit_def'}) {
	$self->save_directive($self->{'conf'}, "VisitTimeout");
	}
else {
	$self->{'in_hash'}->{'visit'} =~ /^\d+$/ || $self->error($self->{'text_hash'}->{'global_evisit'});
	$self->save_directive($self->{'conf'}, "VisitTimeout", $self->{'in_hash'}->{'visit'});
	}

if ($self->{'in_hash'}->{'dns_def'}) {
	$self->save_directive($self->{'conf'}, "DNSChildren");
	}
else {
	$self->{'in_hash'}->{'dns'} =~ /^\d+$/ || $self->error($self->{'text_hash'}->{'global_edns'});
	$self->save_directive($self->{'conf'}, "DNSChildren", $self->{'in_hash'}->{'dns'});
	}

if ($self->{'in_hash'}->{'history_def'}) {
	$self->save_directive($self->{'conf'}, "HistoryName");
	}
else {
	$self->{'in_hash'}->{'history'} =~ /^\S+$/ || $self->error($self->{'text_hash'}->{'global_ehistory'});
	$self->save_directive($self->{'conf'}, "HistoryName", $self->{'in_hash'}->{'history'});
	}

if ($self->{'in_hash'}->{'current_def'}) {
	$self->save_directive($self->{'conf'}, "IncrementalName");
	}
else {
	$self->{'in_hash'}->{'current'} =~ /^\S+$/ || $self->error($self->{'text_hash'}->{'global_ecurrent'});
	$self->save_directive($self->{'conf'}, "IncrementalName", $self->{'in_hash'}->{'current'});
	}

if ($self->{'in_hash'}->{'cache_def'}) {
	$self->save_directive($self->{'conf'}, "DNSCache");
	}
else {
	$self->{'in_hash'}->{'cache'} =~ /^\S+$/ || $self->error($self->{'text_hash'}->{'global_ecache'});
	$self->save_directive($self->{'conf'}, "DNSCache", $self->{'in_hash'}->{'cache'});
	}

foreach $g ('DailyGraph', 'DailyStats', 'HourlyGraph',
	    'HourlyStats', 'CountryGraph', 'GraphLegend') {
	if ($self->{'in_hash'}->{$g}) {
		$self->save_directive($self->{'conf'}, $g);
		}
	else {
		$self->save_directive($self->{'conf'}, $g, "no");
		}
	}

foreach $t ('TopSites', 'TopKSites', 'TopURLs', 'TopKURLs', 'TopReferrers',
	    'TopAgents', 'TopCountries', 'TopEntry', 'TopExit',
	    'TopSearch', 'TopUsers') {
	if ($self->{'in_hash'}->{"${t}_def"} == 1) {
		$self->save_directive($self->{'conf'}, $t);
		}
	elsif ($self->{'in_hash'}->{"${t}_def"} == 2) {
		$self->save_directive($self->{'conf'}, $t, "0");
		}
	else {
		$self->{'in_hash'}->{$t} =~ /^\d+$/ || $self->error($self->text('global_etable',
						   $self->{'text_hash'}->{"global_$t"}));
		$self->save_directive($self->{'conf'}, $t, $self->{'in_hash'}->{$t});
		}
	}

foreach $a ('AllSites', 'AllURLs', 'AllReferrers', 'AllAgents',
	    'AllSearchStr', 'AllUsers') {
	if ($self->{'in_hash'}->{$a}) {
		$self->save_directive($self->{'conf'}, $a, "yes");
		}
	else {
		$self->save_directive($self->{'conf'}, $a);
		}
	}

foreach $hid ("HideURL", "HideSite", "HideReferrer",
	      "HideUser", "HideAgent") {
	@{$self->{'hidv_array'}} = split(/\s+/, $self->{'in_hash'}->{lc($hid)});
	$self->save_directive($self->{'conf'}, $hid, @{$self->{'hidv_array'}});
	}

foreach $ign ("IgnoreURL", "IgnoreSite", "IgnoreReferrer",
	      "IgnoreUser", "IgnoreAgent") {
	@{$self->{'ignv_array'}} = split(/\s+/, $self->{'in_hash'}->{lc($ign)});
	$self->save_directive($self->{'conf'}, $ign, @{$self->{'ignv_array'}});
	}

foreach $inc ("IncludeURL", "IncludeSite", "IncludeReferrer",
	      "IncludeUser", "IncludeAgent") {
	@{$self->{'incv_array'}} = split(/\s+/, $self->{'in_hash'}->{lc($inc)});
	$self->save_directive($self->{'conf'}, $inc, @{$self->{'incv_array'}});
	}

$self->flush_file_lines();
$self->unlock_file($self->{'cfile'} || $self->{'config_hash'}->{'webalizer_conf'});
$self->webmin_log("modify", "global", $self->{'in_hash'}->{'file'});
$self->redirect($self->{'in_hash'}->{'file'} ? "edit_log.cgi?file=".$self->urlize($self->{'in_hash'}->{'file'}).
		        "&type=$self->{'in_hash'}->{'type'}&custom=$self->{'in_hash'}->{'custom'}" : "");

1;
		
}


1;

