#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_log.cgi
# Save, create or delete options for a log file

&ModuleLoader::preload_module('webalizer_class', "webalizer::WebalizerLib");
$self = new webalizer::WebalizerLib:: 'webalizer_class',%$self;

$self->foreign_require("cron", "cron-lib.pl");
$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'save_err'});
$self->{'access_hash'}->{'view'} && $self->error($self->{'text_hash'}->{'edit_ecannot'});
!$self->{'in_hash'}->{'new'} || $self->{'access_hash'}->{'add'} || $self->error($self->{'text_hash'}->{'edit_ecannot'});
$self->can_edit_log($self->{'in_hash'}->{'file'}) || $self->error($self->{'text_hash'}->{'edit_efilecannot'});

# Find the cron job
if (!$self->{'in_hash'}->{'new'} && !$self->{'in_hash'}->{'view'} && !$self->{'in_hash'}->{'run'}) {
	@{$self->{'jobs_array'}} = $main::cron_object->list_cron_jobs();
	foreach $j (@{$self->{'jobs_array'}}) {
		$self->{'job'} = $j if ($j->{'command'} eq "$self->{'cron_cmd'} $self->{'in_hash'}->{'file'}");
		}
	}

if ($self->{'in_hash'}->{'view'}) {
	# Re-direct to the view page
	$self->redirect("view_log.cgi/".$self->urlize($self->urlize($self->{'in_hash'}->{'file'}))."/index.html");
	}
elsif ($self->{'in_hash'}->{'global'}) {
	# Re-direct to the options page
	$self->redirect("edit_global.cgi?file=".$self->urlize($self->{'in_hash'}->{'file'})."&type=$self->{'in_hash'}->{'type'}&custom=$self->{'in_hash'}->{'custom'}");
	}
elsif ($self->{'in_hash'}->{'run'}) {
	# Force report generation and show the output
	$self->ui_print_unbuffered_header(undef, $self->{'text_hash'}->{'gen_title'}, "");

	$self->{'lconf'} = $self->get_log_config($self->{'in_hash'}->{'file'});
	print "<b>",$self->text('gen_header', "<tt>$self->{'in_hash'}->{'file'}</tt>"),"</b><br>\n";
	print "<pre>";
	$self->{'rv'} = $self->generate_report($self->{'in_hash'}->{'file'}, STDOUT, 1);
	print "</pre>\n";
	if ($self->{'rv'} && -r "$self->{'lconf'}->{'dir'}/index.html") {
		print "<b>$self->{'text_hash'}->{'gen_done'}</b><p>\n";
		print "<a href='view_log.cgi/",$self->urlize($self->urlize($self->{'in_hash'}->{'file'})),
		      "/index.html'>$self->{'text_hash'}->{'gen_view'}</a><p>\n";
		}
	elsif ($self->{'rv'}) {
		print "<b>$self->{'text_hash'}->{'gen_nothing'}</b><p>\n";
		}
	else {
		print "<b>$self->{'text_hash'}->{'gen_failed'}</b><p>\n";
		}

	$self->webmin_log("generate", "log", $self->{'in_hash'}->{'file'});
	$self->ui_print_footer("edit_log.cgi?file=".$self->urlize($self->{'in_hash'}->{'file'}).
	        "&type=$self->{'in_hash'}->{'type'}&custom=$self->{'in_hash'}->{'custom'}", $self->{'text_hash'}->{'edit_return'},
		"", $self->{'text_hash'}->{'index_return'});
	exit;
	}
elsif ($self->{'in_hash'}->{'delete'}) {
	# Delete this custom log file from the configuration
	$self->lock_file($self->{'custom_logs_file'});
	@{$self->{'custom_array'}} = $self->read_custom_logs();
	@{$self->{'custom_array'}} = grep { $_->{'file'} ne $self->{'in_hash'}->{'file'} } @{$self->{'custom_array'}};
	if ($self->{'job'}) {
		$self->lock_file($self->{'job'}->{'file'});
		$self->foreign_call("cron", "delete_cron_job", $self->{'job'});
		$self->unlock_file($self->{'job'}->{'file'});
		}
	$self->write_custom_logs(@{$self->{'custom_array'}});
	$self->unlock_file($self->{'custom_logs_file'});
	local $cfile = $self->log_config_name($self->{'in_hash'}->{'file'});
	$self->unlink_logged($cfile);
	$self->webmin_log("delete", "log", $self->{'in_hash'}->{'file'});
	}
else {
	# Validate and store inputs
	if ($self->{'in_hash'}->{'new'}) {
		-r $self->{'in_hash'}->{'file'} && !-d $self->{'in_hash'}->{'file'} ||
			$self->error($self->{'text_hash'}->{'save_efile'});
		}
	-d $self->{'in_hash'}->{'dir'} || $self->error($self->{'text_hash'}->{'save_edir'});
	$self->{'in_hash'}->{'cmode'} != 2 || -r $self->{'in_hash'}->{'cfile'} || $self->error($self->{'text_hash'}->{'save_ecfile'});
	if ($self->{'access_hash'}->{'user'} eq '*') {
		# Set the user to whatever was entered
		defined(getpwnam($self->{'in_hash'}->{'user'})) || $self->error($self->{'text_hash'}->{'save_euser'});
		$self->{'lconf'}->{'user'} = $self->{'in_hash'}->{'user'};
		}
	elsif (!$self->{'in_hash'}->{'new'} && $self->{'lconf'}->{'dir'}) {
		# This is not a new log, so the user cannot be changed
		}
	elsif ($self->{'access_hash'}->{'user'} eq '') {
		# This is a new log, or one that has not been saved for
		# the first time yet. Use the webmin user as the user
		defined(getpwnam($self->{'remote_user'})) ||
			$self->error($self->text('save_ewuser', $self->{'remote_user'}));
		$self->{'lconf'}->{'user'} = $self->{'remote_user'};
		}
	else {
		# This is a new log, or one that has not been saved for
		# the first time yet. Use the user set in the ACL
		$self->{'lconf'}->{'user'} = $self->{'access_hash'}->{'user'};
		}
	$self->{'lconf'}->{'dir'} = $self->{'in_hash'}->{'dir'};
	$self->{'lconf'}->{'sched'} = $self->{'in_hash'}->{'sched'};
	$self->{'lconf'}->{'type'} = $self->{'in_hash'}->{'type'};
	$self->{'lconf'}->{'over'} = $self->{'in_hash'}->{'over'};
	$self->{'lconf'}->{'clear'} = $self->{'in_hash'}->{'clear'};
	$main::cron_object->parse_times_input($self->{'lconf'}, \%{$self->{'in_hash'}});

	# Create or delete the cron job
	local $oldjob = $self->{'job'};
	if ($self->{'lconf'}->{'sched'}) {
		# Create cron job and script
		$self->{'job'}->{'user'} = 'root';
		$self->{'job'}->{'active'} = 1;
		$self->{'job'}->{'command'} = "$self->{'cron_cmd'} $self->{'in_hash'}->{'file'}";
		$self->lconf_to_cron($self->{'lconf'}, $self->{'job'});
		$self->lock_file($self->{'cron_cmd'});
		$main::cron_object->create_wrapper($self->{'cron_cmd'}, $self->{'module_name'}, "webalizer.pl");
		$self->unlock_file($self->{'cron_cmd'});
		}
	$self->lock_file($main::cron_object->cron_file($self->{'job'})) if ($self->{'job'});
	if ($self->{'lconf'}->{'sched'} && !$oldjob) {
		# Create the cron job
		$self->foreign_call("cron", "create_cron_job", $self->{'job'}); 
		}
	elsif ($self->{'lconf'}->{'sched'} && $oldjob) {
		# Update the cron job
		$self->foreign_call("cron", "change_cron_job", $self->{'job'}); 
		}
	elsif (!$self->{'lconf'}->{'sched'} && $oldjob) {
		# Delete the cron job
		$self->foreign_call("cron", "delete_cron_job", $self->{'job'});
		}
	$self->unlock_file($main::cron_object->cron_file($self->{'job'})) if ($self->{'job'});

	if ($self->{'in_hash'}->{'new'}) {
		# Add a new custom log file to the configuration
		$self->lock_file($self->{'custom_logs_file'});
		@{$self->{'custom_array'}} = $self->read_custom_logs();
		push(@{$self->{'custom_array'}}, { 'file' => $self->{'in_hash'}->{'file'}, 'type' => $self->{'in_hash'}->{'type'} });
		$self->write_custom_logs(@{$self->{'custom_array'}});
		$self->unlock_file($self->{'custom_logs_file'});
		}

	# Create or link the custom webalizer.conf file
	local $cfile = $self->config_file_name($self->{'in_hash'}->{'file'});
	if ($self->{'in_hash'}->{'cmode'} == 0) {
		# None at all
		$self->unlink_logged($cfile);
		}
	elsif ($self->{'in_hash'}->{'cmode'} == 1) {
		# File under /etc/webmin/webalizer
		if (-l $cfile) {
			$self->unlink_logged($cfile);
			}
		if (!-r $cfile) {
			# Need to copy into place
			$self->copy_source_dest($self->{'config_hash'}->{'webalizer_conf'}, $cfile);
			}
		}
	elsif ($self->{'in_hash'}->{'cmode'} == 2) {
		# Symbolic link to somewhere
		$self->unlink_logged($cfile);
		symlink($self->{'in_hash'}->{'cfile'}, $cfile);
		}

	# Update the log file's options
	local $cfile = $self->log_config_name($self->{'in_hash'}->{'file'});
	$self->lock_file($cfile);
	$self->save_log_config($self->{'in_hash'}->{'file'}, $self->{'lconf'});
	$self->unlock_file($cfile);
	$self->webmin_log($self->{'in_hash'}->{'new'} ? "create" : "modify", "log", $self->{'in_hash'}->{'file'});
	}
$self->redirect("");

1;
		
}


1;

