#!/usr/bin/perl

&MAIN();

 sub MAIN {
# view_log.cgi
# Display the report for some log file

&ModuleLoader::preload_module('webalizer_class', "webalizer::WebalizerLib");
$self = new webalizer::WebalizerLib:: 'webalizer_class',%$self;

$self->ReadParse();

if ($ENV{'PATH_INFO'} =~ /^\/([^\/]+)(\/[^\/]*)$/) {
	# Proper path escaping
	$self->{'escaped'} = $1;
	$self->{'file'} = $2;
	$self->{'log'} = $self->un_urlize($self->{'escaped'});
	}
elsif ($ENV{'PATH_INFO'} =~ /^(\/.*)(\/[^\/]*)$/) {
	# Path has been decode somehow, perhaps by proxy.. deal
	$self->{'log'} = $1;
	$self->{'file'} = $2;
	}
else {
	$self->error($self->{'text_hash'}->{'view_epath'});
	}
$self->{'file'} =~ /\.\./ || $self->{'file'} =~ /\<|\>|\||\0/ && $self->error($self->{'text_hash'}->{'view_efile'});
$self->can_edit_log($self->{'log'}) || $self->error($self->{'text_hash'}->{'view_ecannot'});

$self->{'lconf'} = $self->get_log_config($self->{'log'}) || $self->error($self->{'text_hash'}->{'view_elog'}." : $self->{'log'}");
$self->{'full'} = "$self->{'lconf'}->{'dir'}$self->{'file'}";
open(FILE, $self->{'full'}) || $self->error($self->{'text_hash'}->{'view_eopen'}." : $self->{'full'}");

# Display file contents
if ($self->{'full'} =~ /\.(html|htm)$/i && !$self->{'config_hash'}->{'naked'}) {
	while(read(FILE, $self->{'buf'}, 1024)) {
		$self->{'data'} .= $self->{'buf'};
		}
	close(FILE);
	$self->{'data'} =~ /<TITLE>(.*)<\/TITLE>/i;
	$self->{'title'} = $1;
	$self->{'data'} =~ s/^[\000-\377]*<BODY.*>//i;
	$self->{'data'} =~ s/<\/BODY>[\000-\377]*$//i;

	$self->ui_print_header(undef, $self->{'title'} || $self->{'text_hash'}->{'view_title'}, "");
	print $self->{'data'};
	if ($self->{'access_hash'}->{'view'}) {
		$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
		}
	else {
		$self->ui_print_footer(
			 "/$self->{'module_name'}/edit_log.cgi?file=$self->{'escaped'}",
			$self->{'text_hash'}->{'edit_return'},
			"", $self->{'text_hash'}->{'index_return'});
		}
	}
else {
	print "Content-type: ",$self->{'full'} =~ /\.png$/i ? "image/png" :
			       $self->{'full'} =~ /\.gif$/i ? "image/gif" :
			       $self->{'full'} =~ /\.(jpg|jpeg)$/i ? "image/jpeg" :
			       $self->{'full'} =~ /\.(html|htm)$/i ? "text/html" :
							   "text/plain","\n";
	print "\n";
	while(read(FILE, $self->{'buf'}, 1024)) {
		print $self->{'buf'};
		}
	close(FILE);
	}

1;
		
}


1;

