#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_acl.cgi
# Display access control options

&ModuleLoader::preload_module('wuftpd_class', "wuftpd::WuftpdLib");
$self = new wuftpd::WuftpdLib:: 'wuftpd_class',%$self;

$self->ui_print_header(undef, $self->{'text_hash'}->{'acl_title'}, "", "acl");

$self->{'conf'} = $self->get_ftpaccess();
@{$self->{'class_array'}} = $self->find_value("class", $self->{'conf'});

print "<form action=save_acl.cgi>\n";
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'acl_header'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

# Display addresses to deny from
@{$self->{'deny_array'}} = ( $self->find_value("deny", $self->{'conf'}), [ ] );
print "<tr> <td valign=top><b>$self->{'text_hash'}->{'acl_deny'}</b></td>\n";
print "<td colspan=3><table border>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'acl_daddrs'}</b></td>\n",
      "<td><b>$self->{'text_hash'}->{'acl_dmsg'}</b></td> </tr>\n";
$self->{'i'} = 0;
foreach $d (@{$self->{'deny_array'}}) {
	print "<tr $self->{'cb'}>\n";
	print "<td><input name=daddrs_$self->{'i'} size=20 value='$d->[0]'></td>\n";
	print "<td><input name=dmsg_$self->{'i'} size=35 value='$d->[1]'></td>\n";
	print "</tr>\n";
	$self->{'i'}++;
	}
print "</table></td> </tr>\n";
print "<tr> <td colspan=4><hr></td> </tr>\n";

# Display concurrent login limits
@{$self->{'limit_array'}} = ( $self->find_value("limit", $self->{'conf'}), [ ] );
print "<tr> <td valign=top><b>$self->{'text_hash'}->{'acl_limit'}</b></td>\n";
print "<td colspan=3><table border>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'acl_class'}</b></td>\n",
      "<td><b>$self->{'text_hash'}->{'acl_n'}</b></td>\n",
      "<td><b>$self->{'text_hash'}->{'acl_times'}</b></td>\n",
      "<td><b>$self->{'text_hash'}->{'acl_lmsg'}</b></td> </tr>\n";
$self->{'i'} = 0;
foreach $l (@{$self->{'limit_array'}}) {
	print "<tr $self->{'cb'}>\n";
	print "<td><select name=lclass_$self->{'i'}>\n";
	printf "<option value='' %s>&nbsp;\n", $l->[0] ? '' : 'checked';
	foreach $c (@{$self->{'class_array'}}) {
		printf "<option %s>%s\n",
			$l->[0] eq $c->[0] ? 'selected' : '', $c->[0];
		}
	print "</select></td>\n";

	printf "<td><input type=radio name=ln_def_$self->{'i'} value=1 %s> %s\n",
		$l->[1] =~ /^\d+$/ ? '' : 'checked', $self->{'text_hash'}->{'acl_unlimited'};
	printf "<input type=radio name=ln_def_$self->{'i'} value=0 %s>\n",
		$l->[1] =~ /^\d+$/ ? 'checked' : '';
	printf "<input name=ln_$self->{'i'} size=8 value='%s'></td>\n",
		$l->[1] =~ /^\d+$/ ? $l->[1] : '';

	printf "<td><input type=radio name=ltimes_def_$self->{'i'} value=1 %s> %s\n",
		lc($l->[2]) eq 'any' ? 'checked' : '', $self->{'text_hash'}->{'acl_any'};
	printf "<input type=radio name=ltimes_def_$self->{'i'} value=0 %s>\n",
		lc($l->[2]) eq 'any' ? '' : 'checked';
	printf "<input name=ltimes_$self->{'i'} size=10 value='%s'></td>\n",
		lc($l->[2]) eq 'any' ? '' : $l->[2];

	print "<td><input name=lmsg_$self->{'i'} size=20 value='$l->[3]'></td>\n";
	print "</tr>\n";
	$self->{'i'}++;
	}
print "</table></td> </tr>\n";
print "<tr> <td colspan=4><hr></td> </tr>\n";

# Display file and byte limits
@{$self->{'fblimit_array'}} = sort { $a->{'line'} <=> $b->{'line'} }
		( $self->find("file-limit", $self->{'conf'}), $self->find("data-limit", $self->{'conf'}) );
push(@{$self->{'fblimit_array'}}, { });
print "<tr> <td valign=top><b>$self->{'text_hash'}->{'acl_file'}</b></td>\n";
print "<td colspan=3><table border>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'acl_fblimit'}</b></td>\n",
      "<td><b>$self->{'text_hash'}->{'acl_inout'}</b></td>\n",
      "<td><b>$self->{'text_hash'}->{'acl_raw'}</b></td>\n",
      "<td><b>$self->{'text_hash'}->{'acl_count'}</b></td>\n",
      "<td><b>$self->{'text_hash'}->{'acl_class'}</b></td> </tr>\n";
$self->{'i'} = 0;
foreach $l (@{$self->{'fblimit_array'}}) {
	$self->{'f'} = $l->{'values'};
	splice(@{$self->{'f'}}, 0, 0, '0') if ($self->{'f'}->[0] ne 'raw');
	print "<tr $self->{'cb'}>\n";
	print "<td><select name=fblimit_$self->{'i'}>\n";
	printf "<option value='' %s>&nbsp;\n",
		$l->{'name'} ? '' : 'selected';
	printf "<option value=file-limit %s>%s\n",
		$l->{'name'} eq 'file-limit' ? 'selected' : '',
		$self->{'text_hash'}->{'acl_flimit'};
	printf "<option value=byte-limit %s>%s\n",
		$l->{'name'} eq 'byte-limit' ? 'selected' : '',
		$self->{'text_hash'}->{'acl_blimit'};
	print "</select></td>\n";

	print "<td><select name=fbinout_$self->{'i'}>\n";
	printf "<option value=total %s>%s\n",
		$self->{'f'}->[1] eq 'total' ? 'selected' : '', $self->{'text_hash'}->{'acl_total'};
	printf "<option value=in %s>%s\n",
		$self->{'f'}->[1] eq 'in' ? 'selected' : '', $self->{'text_hash'}->{'acl_in'};
	printf "<option value=out %s>%s\n",
		$self->{'f'}->[1] eq 'out' ? 'selected' : '', $self->{'text_hash'}->{'acl_out'};
	print "</select></td>\n";

	printf "<td><input type=radio name=fbraw_$self->{'i'} value=0 %s> %s\n",
		$self->{'f'}->[0] eq 'raw' ? '' : 'checked', $self->{'text_hash'}->{'yes'};
	printf "<input type=radio name=fbraw_$self->{'i'} value=1 %s> %s</td>\n",
		$self->{'f'}->[0] eq 'raw' ? 'checked' : '', $self->{'text_hash'}->{'no'};

	print "<td><input name=fbcount_$self->{'i'} size=10 value='$self->{'f'}->[2]'></td>\n";

	print "<td><select name=fbclass_$self->{'i'}>\n";
	printf "<option value='' %s> %s\n",
		$self->{'f'}->[3] ? '' : 'selected', $self->{'text_hash'}->{'acl_all'};
	foreach $c (@{$self->{'class_array'}}) {
		printf "<option %s>%s\n",
			$self->{'f'}->[3] eq $c->[0] ? 'selected' : '', $c->[0];
		}
	print "</select></td>\n";
	print "</tr>\n";
	$self->{'i'}++;
	}
print "</table></td> </tr>\n";
print "<tr> <td colspan=4><hr></td> </tr>\n";

# File access controls
@{$self->{'noret_array'}} = ( $self->find_value("noretrieve", $self->{'conf'}), [ ] );
print "<tr> <td valign=top><b>$self->{'text_hash'}->{'acl_noret'}</b></td>\n";
print "<td colspan=3><table border>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'acl_nfiles'}</b></td>\n",
      "<td><b>$self->{'text_hash'}->{'acl_nrel'}</b></td>\n",
      "<td><b>$self->{'text_hash'}->{'acl_nclass'}</b></td> </tr>\n";
$self->{'i'} = 0;
foreach $n (@{$self->{'noret_array'}}) {
	local (@f, %c);
	foreach $nn (@$n) {
		if ($nn =~ /^class=(\S+)/) { $c{$1}++; }
		elsif ($nn !~ /^(absolute|relative)$/) { push(@f, $nn); }
		}
	print "<tr $self->{'cb'}>\n";
	printf "<td><input name=nfiles_$self->{'i'} size=30 value='%s'></td>\n",
		join(" ", @f);
	printf "<td><input type=radio name=nrel_$self->{'i'} value=1 %s> %s\n",
		$n->[0] eq 'relative' ? 'checked' : '', $self->{'text_hash'}->{'yes'};
	printf "<input type=radio name=nrel_$self->{'i'} value=0 %s> %s</td>\n",
		$n->[0] eq 'relative' ? '' : 'checked', $self->{'text_hash'}->{'no'};
	print "<td>\n";
	foreach $c (@{$self->{'class_array'}}) {
		printf "<input type=checkbox name=nclass_$self->{'i'} value=%s %s> %s\n",
			$c->[0], !%c || $c{$c->[0]} ? 'checked' : '', $c->[0];
		}
	print "</tr>\n";
	$self->{'i'}++;
	}
print "</table></td> </tr>\n";

@{$self->{'allowret_array'}} = ( $self->find_value("allow-retrieve", $self->{'conf'}), [ ] );
print "<tr> <td valign=top><b>$self->{'text_hash'}->{'acl_allowret'}</b></td>\n";
print "<td colspan=3><table border>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'acl_afiles'}</b></td>\n",
      "<td><b>$self->{'text_hash'}->{'acl_arel'}</b></td>\n",
      "<td><b>$self->{'text_hash'}->{'acl_aclass'}</b></td> </tr>\n";
$self->{'i'} = 0;
foreach $n (@{$self->{'allowret_array'}}) {
	local (@f, %c);
	foreach $nn (@$n) {
		if ($nn =~ /^class=(\S+)/) { $c{$1}++; }
		elsif ($nn !~ /^(absolute|relative)$/) { push(@f, $nn); }
		}
	print "<tr $self->{'cb'}>\n";
	printf "<td><input name=afiles_$self->{'i'} size=30 value='%s'></td>\n",
		join(" ", @f);
	printf "<td><input type=radio name=arel_$self->{'i'} value=1 %s> %s\n",
		$n->[0] eq 'relative' ? 'checked' : '', $self->{'text_hash'}->{'yes'};
	printf "<input type=radio name=arel_$self->{'i'} value=0 %s> %s</td>\n",
		$n->[0] eq 'relative' ? '' : 'checked', $self->{'text_hash'}->{'no'};
	print "<td>\n";
	foreach $c (@{$self->{'class_array'}}) {
		printf "<input type=checkbox name=aclass_$self->{'i'} value=%s %s> %s\n",
			$c->[0], !%c || $c{$c->[0]} ? 'checked' : '', $c->[0];
		}
	print "</tr>\n";
	$self->{'i'}++;
	}
print "</table></td> </tr>\n";
print "<tr> <td colspan=4><hr></td> </tr>\n";

# Display time-limit options
foreach $l ($self->find_value("limit-time", $self->{'conf'})) {
	if ($l->[0] eq '*') {
		$self->{'limit_hash'}->{'anonymous'} = $self->{'limit_hash'}->{'guest'} = $l->[1];
		}
	else {
		$self->{'limit_hash'}->{$l->[0]} = $l->[1];
		}
	}
print "<tr> <td><b>$self->{'text_hash'}->{'acl_alimit'}</b></td>\n";
printf "<td><input type=radio name=alimit_def value=1 %s> %s\n",
	$self->{'limit_hash'}->{'anonymous'} ? '' : 'checked', $self->{'text_hash'}->{'acl_unlimited'};
printf "<input type=radio name=alimit_def value=0 %s>\n",
	$self->{'limit_hash'}->{'anonymous'} ? 'checked' : '';
printf "<input name=alimit size=6 value='%s'> %s</td>\n",
	$self->{'limit_hash'}->{'anonymous'}, $self->{'text_hash'}->{'acl_mins'};
print "<td><b>$self->{'text_hash'}->{'acl_glimit'}</b></td>\n";
printf "<td><input type=radio name=glimit_def value=1 %s> %s\n",
	$self->{'limit_hash'}->{'guest'} ? '' : 'checked', $self->{'text_hash'}->{'acl_unlimited'};
printf "<input type=radio name=glimit_def value=0 %s>\n",
	$self->{'limit_hash'}->{'guest'} ? 'checked' : '';
printf "<input name=glimit size=6 value='%s'> %s</td> </tr>\n",
	$self->{'limit_hash'}->{'guest'}, $self->{'text_hash'}->{'acl_mins'};

# Other security options
$self->{'lf'} = $self->find_value('loginfails', $self->{'conf'});
print "<tr> <td><b>$self->{'text_hash'}->{'acl_fails'}</b></td>\n";
printf "<td><input type=radio name=fails_def value=1 %s> %s\n",
	$self->{'lf'} ? '' : 'checked', $self->{'text_hash'}->{'default'};
printf "<input type=radio name=fails_def value=0 %s>\n",
	$self->{'lf'} ? 'checked' : '';
print "<input name=fails size=6 value='$self->{'lf'}->[0]'></td>\n";

$self->{'pr'} = $self->find_value('private', $self->{'conf'}); 
print "<td><b>$self->{'text_hash'}->{'acl_private'}</b></td>\n";
printf "<td><input type=radio name=private value=yes %s> %s\n",
	$self->{'pr'}->[0] eq 'yes' ? 'checked' : '', $self->{'text_hash'}->{'yes'};
printf "<input type=radio name=private value=no %s> %s</td> </tr>\n",
	$self->{'pr'}->[0] eq 'yes' ? '' : 'checked',  $self->{'text_hash'}->{'no'};

print "</table></td></tr></table>\n";
print "<input type=submit value=\"$self->{'text_hash'}->{'save'}\"></form>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

