#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_anon.cgi
# Display anonymous FTP options

&ModuleLoader::preload_module('wuftpd_class', "wuftpd::WuftpdLib");
$self = new wuftpd::WuftpdLib:: 'wuftpd_class',%$self;

$self->ui_print_header(undef, $self->{'text_hash'}->{'anon_title'}, "", "anon");

$self->{'conf'} = $self->get_ftpaccess();
@{$self->{'class_array'}} = $self->find_value("class", $self->{'conf'});

if (!getpwnam("ftp")) {
	print "<b>$self->{'text_hash'}->{'anon_eftp'}</b> <p>\n";
	}

print "<form action=save_anon.cgi>\n";
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'anon_header'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

# Display anonymous-root options
@{$self->{'root_array'}} = ( $self->find_value('anonymous-root', $self->{'conf'}), [ ] );
print "<tr> <td valign=top><b>$self->{'text_hash'}->{'anon_root'}</b></td>\n";
print "<td colspan=3><table border>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'anon_dir'}</b></td>\n",
      "<td><b>$self->{'text_hash'}->{'anon_class'}</b></td> </tr>\n";
$self->{'i'} = 0;
foreach $r (@{$self->{'root_array'}}) {
	print "<tr $self->{'cb'}>\n";
	printf "<td><input name=dir_$self->{'i'} size=35 value='%s'> %s</td>\n",
		$r->[0], $self->file_chooser_button("dir_$self->{'i'}", 1);
	print "<td><select name=class_$self->{'i'}>\n";
	printf "<option value='' %s>%s\n",
		$r->[1] ? '' : 'selected', $self->{'text_hash'}->{'anon_any'};
	foreach $c (@{$self->{'class_array'}}) {
		printf "<option %s>%s\n",
			$r->[1] eq $c->[0] ? 'selected' : '', $c->[0];
		}
	print "</select></td> </tr>\n";
	$self->{'i'}++;
	}
print "</table></td> </tr>\n";

# Display guest-root options
@{$self->{'root_array'}} = ( $self->find_value('guest-root', $self->{'conf'}), [ ] );
print "<tr> <td valign=top><b>$self->{'text_hash'}->{'anon_groot'}</b></td>\n";
print "<td colspan=3><table border>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'anon_dir'}</b></td>\n",
      "<td><b>$self->{'text_hash'}->{'anon_uids'}</b></td> </tr>\n";
$self->{'i'} = 0;
foreach $r (@{$self->{'root_array'}}) {
	print "<tr $self->{'cb'}>\n";
	printf "<td><input name=gdir_$self->{'i'} size=35 value='%s'> %s</td>\n",
		$r->[0], $self->file_chooser_button("gdir_$self->{'i'}", 1);
	printf "<td><input name=uids_$self->{'i'} size=20 value='%s'> %s</td>\n",
		join(" ", @$r[1..@$r-1]),
		$self->user_chooser_button("uids_$self->{'i'}", 1);
	print "</tr>\n";
	$self->{'i'}++;
	}
print "</table></td> </tr>\n";

print "<tr> <td colspan=4><hr></td> </tr>\n";

# Display autogroup options
@{$self->{'auto_array'}} = ( $self->find_value('autogroup', $self->{'conf'}), [ ] );
print "<tr> <td valign=top><b>$self->{'text_hash'}->{'anon_auto'}</b></td>\n";
print "<td colspan=3><table border>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'anon_group'}</b></td>\n",
      "<td><b>$self->{'text_hash'}->{'anon_classes'}</b></td> </tr>\n";
$self->{'i'} = 0;
foreach $a (@{$self->{'auto_array'}}) {
	local %aclass;
	map { $aclass{$_}++ } @$a[1..@$a-1];
	print "<tr $self->{'cb'}>\n";
	print "<td><input name=agroup_$self->{'i'} size=8 value='$a->[0]'> ",
		$self->group_chooser_button("agroup_$self->{'i'}"),"</td>\n";
	print "<td>\n";
	foreach $c (@{$self->{'class_array'}}) {
		printf "<input name=aclass_$self->{'i'} type=checkbox %s value=%s> %s\n",
			$aclass{$c->[0]} ? 'checked' : '', $c->[0], $c->[0];
		}
	print "</td> </tr>\n";
	$self->{'i'}++;
	}
print "</table></td> </tr>\n";
print "<tr> <td colspan=4><hr></td> </tr>\n";

# Display passwd-check field
$self->{'p'} = $self->find_value('passwd-check', $self->{'conf'});
print "<tr> <td><b>$self->{'text_hash'}->{'anon_passwd'}</b></td> <td colspan=3>\n";
printf "<input type=radio name=passwd_def value=1 %s> %s\n",
	$self->{'p'} ? '' : 'checked',  $self->{'text_hash'}->{'default'};
printf "<input type=radio name=passwd_def value=0 %s>\n",
	$self->{'p'} ? 'checked' : '';
print "<select name=level>\n";
foreach $l ('none', 'trivial', 'rfc822') {
	printf "<option %s value='%s'>%s\n",
		$self->{'p'}->[0] eq $l ? 'selected' : '', $l, $self->{'text_hash'}->{"anon_$l"};
	}
print "</select> <select name=action>\n";
foreach $a ('enforce', 'warn') {
	printf "<option %s value='%s'>%s\n",
		$self->{'p'}->[1] eq $a ? 'selected' : '', $a, $self->{'text_hash'}->{"anon_$a"};
	}
print "</select></td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'anon_email'}</b></td>\n";
printf "<td colspan=3><input name=email size=50 value='%s'></td> </tr>\n",
	join(" ", map { $_->[0] } $self->find_value('deny-email', $self->{'conf'}));

print "</table></td></tr></table>\n";
print "<input type=submit value=\"$self->{'text_hash'}->{'save'}\"></form>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

