#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_perm.cgi
# Display file permission options

&ModuleLoader::preload_module('wuftpd_class', "wuftpd::WuftpdLib");
$self = new wuftpd::WuftpdLib:: 'wuftpd_class',%$self;

$self->ui_print_header(undef, $self->{'text_hash'}->{'perm_title'}, "", "perm");

$self->{'conf'} = $self->get_ftpaccess();
@{$self->{'class_array'}} = $self->find_value("class", $self->{'conf'});

print "<form action=save_perm.cgi>\n";
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'perm_header'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

# Display permission options (chmod, delete, etc..)
@{$self->{'permtypes_array'}} = ( 'chmod', 'delete', 'overwrite', 'rename', 'umask' );
foreach $t (@{$self->{'permtypes_array'}}) {
	push(@{$self->{'perms_array'}}, $self->find($t, $self->{'conf'}));
	}
@{$self->{'perms_array'}} = ( ( sort { $a->{'line'} <=> $b->{'line'} } @{$self->{'perms_array'}} ), { } );
print "<tr> <td valign=top><b>$self->{'text_hash'}->{'perm_perms'}</b></td>\n";
print "<td colspan=3><table border>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'perm_type'}</b></td>\n",
      "<td><b>$self->{'text_hash'}->{'perm_can'}</b></td>\n",
      "<td><b>$self->{'text_hash'}->{'perm_users'}</b></td>\n",
      "<td><b>$self->{'text_hash'}->{'perm_classes'}</b></td> </tr>\n";
$self->{'i'} = 0;
foreach $p (@{$self->{'perms_array'}}) {
	$self->{'v'} = $p->{'values'};
	print "<tr $self->{'cb'}>\n";

	print "<td><select name=type_$self->{'i'}>\n";
	printf "<option %s>\n", $p->{'name'} ? '' : 'checked';
	foreach $t (@{$self->{'permtypes_array'}}) {
		printf "<option %s>%s\n",
			$p->{'name'} eq $t ? 'selected' : '', $t;
		}
	print "</select></td>\n";

	printf "<td><input type=radio name=can_$self->{'i'} value=yes %s> %s\n",
		lc($self->{'v'}->[0]) eq 'yes' ? 'checked' : '', $self->{'text_hash'}->{'yes'};
	printf "<input type=radio name=can_$self->{'i'} value=no %s> %s</td>\n",
		lc($self->{'v'}->[0]) eq 'yes' ? '' : 'checked', $self->{'text_hash'}->{'no'};

	local (%users, $notall);
	map { $users{$_}++; $notall++ if (/class=/) } split(/,/, $self->{'v'}->[1]);
	print "<td>\n";
	foreach $u ('anonymous', 'guest', 'real') {
		printf "<input name=users_%s type=checkbox value=%s %s> %s\n",
			$self->{'i'}, $u, $users{$u} ? 'checked' : '', $self->{'text_hash'}->{"perm_$u"};
		}
	print "</td>\n";

	if (!$notall) {
		map { $users{"class=".$_->[0]}++ } @{$self->{'class_array'}};
		}
	print "<td>\n";
	foreach $c (@{$self->{'class_array'}}) {
		printf "<input name=classes_%s type=checkbox value=%s %s> %s\n",
			$self->{'i'}, $c->[0], $users{"class=$c->[0]"} ? 'checked' : '',
			$c->[0];
		}
	print "</td> </tr>\n";
	$self->{'i'}++;
	}
print "</table><br>$self->{'text_hash'}->{'perm_note'}</td> </tr>\n";
print "<tr> <td colspan=4><hr></td> </tr>\n";

# Display path-filter options
@{$self->{'filter_array'}} = ( $self->find_value('path-filter', $self->{'conf'}), [ ] );
print "<tr> <td valign=top><b>$self->{'text_hash'}->{'perm_filter'}</b></td> <td colspan=3>\n";
print "<table border> <tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'perm_char'}</b></td>\n",
      "<td><b>$self->{'text_hash'}->{'perm_regexp'}</b></td>\n",
      "<td><b>$self->{'text_hash'}->{'perm_types'}</b></td>\n",
      "<td><b>$self->{'text_hash'}->{'perm_mesg'}</b></td> </tr>\n";
$self->{'i'} = 0;
foreach $f (@{$self->{'filter_array'}}) {
	print "<tr $self->{'cb'}>\n";
	print "<td><input name=char_$self->{'i'} size=15 value='$f->[2]'></td>\n";
	printf "<td><input name=regexp_$self->{'i'} size=25 value='%s'></td>\n",
		join(" ", @$f[3..@$f-1]);
	print "<td>\n";
	foreach $u ('anonymous', 'guest', 'real') {
		printf "<input name=types_%s type=checkbox value=%s %s> %s\n",
			$self->{'i'}, $u, $f->[0] =~ /$u/ ? 'checked' : '',
			$self->{'text_hash'}->{"perm_$u"};
		}
	print "</td>\n";
	print "<td><input name=mesg_$self->{'i'} size=20 value='$f->[1]'></td> </tr>\n";
	$self->{'i'}++;
	}
print "</table></td> </tr>\n";

print "</table></td></tr></table>\n";
print "<input type=submit value=\"$self->{'text_hash'}->{'save'}\"></form>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

