#!/usr/bin/perl

&MAIN();

 sub MAIN {
# index.cgi
# Display the wuFTPd main menu

&ModuleLoader::preload_module('wuftpd_class', "wuftpd::WuftpdLib");
$self = new wuftpd::WuftpdLib:: 'wuftpd_class',%$self;

use Socket;
$| = 1;

# Check if wuftpd is installed
if (!-x $self->{'config_hash'}->{'ftpd_path'}) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", "intro", 1, 1, 0,
		$self->help_search_link("wu-ftpd", "man", "doc", "google"));
	print $self->text('index_eftpd', "<tt>$self->{'config_hash'}->{'ftpd_path'}</tt>",
		  "$self->{'gconfig_hash'}->{'webprefix'}/config.cgi?$self->{'module_name'}"),"<p>\n";
	$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});
	exit;
	}

# Check if the ftpaccess file exists
if (!-r $self->{'config_hash'}->{'ftpaccess'}) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", "intro", 1, 1, 0,
		$self->help_search_link("wu-ftpd", "man", "doc", "google"));
	print $self->text('index_eftpaccess', "<tt>$self->{'config_hash'}->{'ftpaccess'}</tt>",
		  "$self->{'gconfig_hash'}->{'webprefix'}/config.cgi?$self->{'module_name'}"),"<p>\n";
	$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});
	exit;
	}

@{$self->{'st_array'}} = stat($self->{'config_hash'}->{'ftpd_path'});
$self->read_file("$self->{'module_config_directory'}/ftpd", \%{$self->{'ftpd_hash'}});
if ($self->{'ftpd_hash'}->{'size'} != $self->{'st_array'}->[7] || $self->{'ftpd_hash'}->{'mtime'} != $self->{'st_array'}->[9]) {
	# Run the ftpd to check if it is really wuftpd, by starting it
	# in a separate TCP server process
	$self->{'proto'} = getprotobyname('tcp');
	socket(MAIN, PF_INET, SOCK_STREAM, $self->{'proto'}) ||
		$self->error("socket failed : $!");
	setsockopt(MAIN, SOL_SOCKET, SO_REUSEADDR, pack("l", 1));
	$self->{'port'} = 10000;
	while(1) {
		$self->{'port'}++;
		last if (bind(MAIN, pack_sockaddr_in($self->{'port'}, INADDR_ANY)));
		}
	listen(MAIN, SOMAXCONN);
	if (!($self->{'pid'} = fork())) {
		accept(SOCK, MAIN) || exit(1);
		untie(*STDIN);
		untie(*STDOUT);
		untie(*STDERR);
		open(STDIN, "<&SOCK");
		open(STDOUT, ">&SOCK");
		open(STDERR, ">&SOCK");
		exec("$self->{'config_hash'}->{'ftpd_path'} -A");
		print "Exec failed : $!\n";
		exit;
		}
	close(MAIN);
	$self->open_socket("localhost", $self->{'port'}, CONN);
	select(CONN); $| = 1; select(STDOUT);
	print CONN "quit\n";
	local $out;
	while(<CONN>) {
		$self->{'version'} = $1 if (/Version\s+wu-(\d+\.\d+)/i);
		$out .= $_;
		}
	close(CONN);
	waitpid($self->{'pid'}, 0);
	if (!$self->{'version'}) {
		$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", "intro", 1, 1, 0,
			$self->help_search_link("wu-ftpd", "man", "doc", "google"));
		print $self->text('index_eversion',
			  "<tt>$self->{'config_hash'}->{'ftpd_path'}</tt>",
			  "$self->{'gconfig_hash'}->{'webprefix'}/config.cgi?$self->{'module_name'}",
			  "<pre>$out</pre>"),"<p>\n";
		$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});
		exit;
		}

	# Save version information
	$self->{'ftpd_hash'}->{'size'} = $self->{'st_array'}->[7];
	$self->{'ftpd_hash'}->{'mtime'} = $self->{'st_array'}->[9];
	$self->{'ftpd_hash'}->{'version'} = $self->{'version'};
	$self->write_file("$self->{'module_config_directory'}/ftpd", \%{$self->{'ftpd_hash'}});
	}

$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", "intro", 1, 1, 0,
	$self->help_search_link("wu-ftpd", "man", "doc", "google"), undef, undef,
	$self->text('index_version', $self->{'ftpd_hash'}->{'version'}));

# Display table of icons
@{$self->{'names_array'}} = ( 'class', 'message', 'acl', 'net', 'log',
	   'alias', 'anon', 'perm', 'misc' );
@{$self->{'links_array'}} = map { "edit_${_}.cgi" } @{$self->{'names_array'}};
@{$self->{'titles_array'}} = map { $self->{'text_hash'}->{"${_}_title"} } @{$self->{'names_array'}};
@{$self->{'icons_array'}} = map { "images/${_}.gif" } @{$self->{'names_array'}};
$self->icons_table(\@{$self->{'links_array'}}, \@{$self->{'titles_array'}}, \@{$self->{'icons_array'}}, 5);

($self->{'inet'}, $self->{'inet_mod'}) = $self->running_under_inetd();
if (!$self->{'inet'}) {
	# Get the FTP server pid
	$self->{'pid'} = $self->check_pid_file($self->{'config_hash'}->{'pid_file'});
	}

if (!$self->{'inet'} && $self->{'pid'}) {
	print "<hr>\n";
	print "<form action=restart.cgi>\n";
	print "<input type=hidden name=pid value='$self->{'pid'}'>\n";
	print "<table width=100%><tr>\n";
	print "<td><input type=submit value=\"$self->{'text_hash'}->{'index_apply'}\"></td>\n";
	print "<td>$self->{'text_hash'}->{'index_applymsg'}</td>\n";
	print "</tr></table></form>\n";
	}
elsif (!$self->{'inet'} && !$self->{'pid'}) {
	print "<hr>\n";
	print "<form action=start.cgi>\n";
	print "<table width=100%><tr>\n";
	print "<td><input type=submit value=\"$self->{'text_hash'}->{'index_start'}\"></td>\n";
	if ($self->{'inet_mod'}) {
		print "<td>",$self->text('index_startmsg', "/$self->{'inet_mod'}/"),"</td>\n";
		}
	else {
		print "<td>$self->{'text_hash'}->{'index_startmsg2'}</td>\n";
		}
	print "</tr></table></form>\n";
	}

$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});

1;
		
}


1;

