#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_alias.cgi
# Save alias options

&ModuleLoader::preload_module('wuftpd_class', "wuftpd::WuftpdLib");
$self = new wuftpd::WuftpdLib:: 'wuftpd_class',%$self;

$self->error_setup($self->{'text_hash'}->{'alias_err'});
$self->ReadParse();
$self->lock_file($self->{'config_hash'}->{'ftpaccess'});
$self->{'conf'} = $self->get_ftpaccess();

# save alias directives
for($i=0; defined($self->{'from'} = $self->{'in_hash'}->{"from_$i"}); $i++) {
	$self->{'to'} = $self->{'in_hash'}->{"to_$i"};
	next if (!$self->{'from'});
	$self->{'from'} =~ /^\S+$/ || $self->error($self->text('alias_efrom', $self->{'from'}));
	-d $self->{'to'} || $self->error($self->text('alias_eto', $self->{'to'}));
	push(@{$self->{'alias_array'}}, { 'name' => 'alias',
		       'values' => [ $self->{'from'}, $self->{'to'} ] } );
	}
$self->save_directive($self->{'conf'}, 'alias', \@{$self->{'alias_array'}});

# save cdpath directives
foreach $c (split(/\s+/, $self->{'in_hash'}->{'cdpath'})) {
	-d $c || $self->error($self->text('alias_ecdpath', $c));
	push(@{$self->{'cdpath_array'}}, { 'name' => 'cdpath',
			'values' => [ $c ] } );
	}
$self->save_directive($self->{'conf'}, 'cdpath', \@{$self->{'cdpath_array'}});

$self->flush_file_lines();
$self->unlock_file($self->{'config_hash'}->{'ftpaccess'});
$self->webmin_log("alias", undef, undef, \%{$self->{'in_hash'}});
$self->redirect("");
1;
		
}


1;

