#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_anon.cgi
# Save anonymous FTP

&ModuleLoader::preload_module('wuftpd_class', "wuftpd::WuftpdLib");
$self = new wuftpd::WuftpdLib:: 'wuftpd_class',%$self;

$self->error_setup($self->{'text_hash'}->{'anon_err'});
$self->ReadParse();
$self->lock_file($self->{'config_hash'}->{'ftpaccess'});
$self->{'conf'} = $self->get_ftpaccess();

# save anonymous-root options
for($i=0; defined($self->{'dir'} = $self->{'in_hash'}->{"dir_$i"}); $i++) {
	next if (!$self->{'dir'});
	-d $self->{'dir'} || $self->error($self->text('anon_edir', $self->{'dir'}));
	push(@{$self->{'aroot_array'}}, { 'name' => 'anonymous-root',
		       'values' => [ $self->{'dir'}, $self->{'in_hash'}->{"class_$i"} ] } );
	}
$self->save_directive($self->{'conf'}, 'anonymous-root', \@{$self->{'aroot_array'}});

#save guest-root options
for($i=0; defined($self->{'dir'} = $self->{'in_hash'}->{"gdir_$i"}); $i++) {
	next if (!$self->{'dir'});
	-d $self->{'dir'} || $self->error($self->text('anon_edir', $self->{'dir'}));
	push(@{$self->{'groot_array'}}, { 'name' => 'guest-root',
		       'values' => [ $self->{'dir'}, $self->{'in_hash'}->{"uids_$i"} ] } );
	}
$self->save_directive($self->{'conf'}, 'guest-root', \@{$self->{'groot_array'}});

# save autogroup options
for($i=0; defined($self->{'agroup'} = $self->{'in_hash'}->{"agroup_$i"}); $i++) {
	next if (!$self->{'agroup'});
	defined(getgrnam($self->{'agroup'})) || $self->error($self->text('anon_egroup', $self->{'agroup'}));
	push(@{$self->{'agroup_array'}}, { 'name' => 'autogroup',
			'values' => [ $self->{'agroup'},
				      split(/\0/, $self->{'in_hash'}->{"aclass_$i"}) ] } );
	}
$self->save_directive($self->{'conf'}, 'autogroup', \@{$self->{'agroup_array'}});

# save other options
if ($self->{'in_hash'}->{'passwd_def'}) {
	$self->save_directive($self->{'conf'}, 'passwd-check', [ ]);
	}
else {
	$self->save_directive($self->{'conf'}, 'passwd-check',
			[ { 'name' => 'passwd-check',
			    'values' => [ $self->{'in_hash'}->{'level'}, $self->{'in_hash'}->{'action'} ] } ] );
	}
foreach $a (split(/\s+/, $self->{'in_hash'}->{'email'})) {
	push(@{$self->{'email_array'}}, { 'name' => 'deny-email', 'values' => [ $a ] } );
	}
$self->save_directive($self->{'conf'}, 'deny-email', \@{$self->{'email_array'}});

$self->flush_file_lines();
$self->unlock_file($self->{'config_hash'}->{'ftpaccess'});
$self->webmin_log("anon", undef, undef, \%{$self->{'in_hash'}});
$self->redirect("");
1;
		
}


1;

