#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_class.cgi
# Save user classes

&ModuleLoader::preload_module('wuftpd_class', "wuftpd::WuftpdLib");
$self = new wuftpd::WuftpdLib:: 'wuftpd_class',%$self;

$self->error_setup($self->{'text_hash'}->{'class_err'});
$self->ReadParse();

$self->lock_file($self->{'config_hash'}->{'ftpaccess'});
$self->{'conf'} = $self->get_ftpaccess();

# save class options
for($i=0; defined($self->{'class'} = $self->{'in_hash'}->{"class_$i"}); $i++) {
	next if (!$self->{'class'});
	$self->{'class'} =~ /^\S+$/ || $self->error($self->text('class_eclass', $self->{'class'}));
	@{$self->{'types_array'}} = split(/\0/, $self->{'in_hash'}->{"types_$i"});
	@{$self->{'types_array'}} || $self->error($self->text('class_etypes', $self->{'class'}));
	@{$self->{'addrs_array'}} = split(/\s+/, $self->{'in_hash'}->{"addrs_$i"});
	@{$self->{'addrs_array'}} || $self->error($self->text('class_eaddrs', $self->{'class'}));
	push(@{$self->{'class_array'}}, { 'name' => 'class',
		       'star' => $self->{'addrs_array'}->[0] eq '*',
		       'values' => [ $self->{'class'}, join(",", @{$self->{'types_array'}}), @{$self->{'addrs_array'}} ] });
	}
@{$self->{'class_array'}} = sort { $a->{'star'} ? 1 : $b->{'star'} ? -1 : 0 } @{$self->{'class_array'}};
$self->save_directive($self->{'conf'}, 'class', \@{$self->{'class_array'}});

# save guest/real user/group options
foreach $g ('guestuser', 'guestgroup', 'realuser', 'realgroup') {
	if ($self->{'in_hash'}->{$g}) {
		$self->save_directive($self->{'conf'}, $g, [ { 'name' => $g,
					       'values' => [ $self->{'in_hash'}->{$g} ] } ] );
		}
	else {
		$self->save_directive($self->{'conf'}, $g, [ ]);
		}
	}

# save allow/deny uid/gid options
$self->lock_file($self->{'config_hash'}->{'ftpusers'});
if ($self->{'in_hash'}->{'ftpusers'}) {
	$self->open_tempfile(FTPUSERS, ">$self->{'config_hash'}->{'ftpusers'}");
	foreach $u (split(/\s+/, $self->{'in_hash'}->{'ftpusers'})) {
		$self->print_tempfile(FTPUSERS, $u,"\n");
		}
	$self->close_tempfile(FTPUSERS);
	}
else {
	unlink($self->{'config_hash'}->{'ftpusers'});
	}
$self->unlock_file($self->{'config_hash'}->{'ftpusers'});
foreach $g ('deny-uid', 'deny-gid', 'allow-uid', 'allow-gid') {
	($self->{'fg'} = $g) =~ s/-/_/g;
	if ($self->{'in_hash'}->{$self->{'fg'}}) {
		$self->save_directive($self->{'conf'}, $g, [ { 'name' => $g,
					       'values' => [ $self->{'in_hash'}->{$self->{'fg'}} ] } ] );
		}
	else {
		$self->save_directive($self->{'conf'}, $g, [ ]);
		}
	}

$self->flush_file_lines();
$self->unlock_file($self->{'config_hash'}->{'ftpaccess'});
$self->webmin_log("class", undef, undef, \%{$self->{'in_hash'}});
$self->redirect("");

1;
		
}


1;

