#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_message.cgi
# Save messages, banners and other options

&ModuleLoader::preload_module('wuftpd_class', "wuftpd::WuftpdLib");
$self = new wuftpd::WuftpdLib:: 'wuftpd_class',%$self;

$self->error_setup($self->{'text_hash'}->{'message_err'});
$self->ReadParse();

$self->lock_file($self->{'config_hash'}->{'ftpaccess'});
$self->{'conf'} = $self->get_ftpaccess();
foreach $c ($self->find_value('class', $self->{'conf'})) {
	$self->{'hasclass_hash'}->{$c->[0]}++;
	}

# Save messages 
for($i=0; defined($self->{'path'} = $self->{'in_hash'}->{"mpath_$i"}); $i++) {
	next if (!$self->{'path'});
	$self->{'path'} =~ /^\S+$/ || $self->error($self->text('message_epath', $self->{'path'}));
	if ($self->{'in_hash'}->{"mwhen_$i"} == 0) {
		$self->{'when'} = "login";
		}
	elsif ($self->{'in_hash'}->{"mwhen_$i"} == 1) {
		$self->{'when'} = "cwd=*";
		}
	else {
		$self->{'in_hash'}->{"mcwd_$i"} =~ /^\S+$/ ||
			$self->error($self->text('message_ecwd', $self->{'path'}));
		$self->{'when'} = "cwd=".$self->{'in_hash'}->{"mcwd_$i"};
		}
	@{$self->{'classes_array'}} = split(/\s+/, $self->{'in_hash'}->{"mclasses_$i"});
	foreach $c (@{$self->{'classes_array'}}) {
		$self->{'hasclass_hash'}->{$c} || $self->error($self->text('message_eclass', $c));
		}
	push(@{$self->{'message_array'}}, { 'name' => 'message',
			 'values' => [ $self->{'path'}, $self->{'when'}, @{$self->{'classes_array'}} ] } );
	}
$self->save_directive($self->{'conf'}, 'message', \@{$self->{'message_array'}});

# Save readme's
for($i=0; defined($self->{'path'} = $self->{'in_hash'}->{"rpath_$i"}); $i++) {
	next if (!$self->{'path'});
	$self->{'path'} =~ /^\S+$/ || $self->error($self->text('message_epath', $self->{'path'}));
	if ($self->{'in_hash'}->{"rwhen_$i"} == 0) {
		$self->{'when'} = "login";
		}
	elsif ($self->{'in_hash'}->{"rwhen_$i"} == 1) {
		$self->{'when'} = "cwd=*";
		}
	else {
		$self->{'in_hash'}->{"rcwd_$i"} =~ /^\S+$/ ||
			$self->error($self->text('message_ecwd', $self->{'path'}));
		$self->{'when'} = "cwd=".$self->{'in_hash'}->{"rcwd_$i"};
		}
	@{$self->{'classes_array'}} = split(/\s+/, $self->{'in_hash'}->{"rclasses_$i"});
	foreach $c (@{$self->{'classes_array'}}) {
		$self->{'hasclass_hash'}->{$c} || $self->error($self->text('message_eclass', $c));
		}
	push(@{$self->{'readme_array'}}, { 'name' => 'readme',
			 'values' => [ $self->{'path'}, $self->{'when'}, @{$self->{'classes_array'}} ] } );
	}
$self->save_directive($self->{'conf'}, 'readme', \@{$self->{'readme_array'}});

# save other options
$self->save_directive($self->{'conf'}, 'greeting', [ { 'name' => 'greeting',
				       'values' => [ $self->{'in_hash'}->{'greeting'} ] } ]);
if ($self->{'in_hash'}->{'banner_def'}) {
	$self->save_directive($self->{'conf'}, 'banner', [ ]);
	}
else {
	-r $self->{'in_hash'}->{'banner'} || $self->error($self->text('message_ebanner', $self->{'in_hash'}->{'banner'}));
	$self->save_directive($self->{'conf'}, 'banner', [ { 'name' => 'banner',
					     'values' => [ $self->{'in_hash'}->{'banner'} ] } ]);
	}
if ($self->{'in_hash'}->{'hostname_def'}) {
	$self->save_directive($self->{'conf'}, 'hostname', [ ]);
	}
else {
	$self->{'in_hash'}->{'hostname'} =~ /^\S+$/ || $self->error($self->{'text_hash'}->{'message_ehostname'});
	$self->save_directive($self->{'conf'}, 'hostname',
			[ { 'name' => 'hostname',
			    'values' => [ $self->{'in_hash'}->{'hostname'} ] } ]);
	}
if ($self->{'in_hash'}->{'email_def'}) {
	$self->save_directive($self->{'conf'}, 'email', [ ]);
	}
else {
	$self->{'in_hash'}->{'email'} =~ /^\S+$/ || $self->error($self->{'text_hash'}->{'message_eemail'});
	$self->save_directive($self->{'conf'}, 'email', [ { 'name' => 'email',
					    'values' => [ $self->{'in_hash'}->{'email'} ] } ]);
	}

$self->flush_file_lines();
$self->unlock_file($self->{'config_hash'}->{'ftpaccess'});
$self->webmin_log("message", undef, undef, \%{$self->{'in_hash'}});
$self->redirect("");

1;
		
}


1;

