#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_log.cgi
# Save miscellaneous options

&ModuleLoader::preload_module('wuftpd_class', "wuftpd::WuftpdLib");
$self = new wuftpd::WuftpdLib:: 'wuftpd_class',%$self;

$self->error_setup($self->{'text_hash'}->{'misc_err'});
$self->ReadParse();
$self->lock_file($self->{'config_hash'}->{'ftpaccess'});
$self->{'conf'} = $self->get_ftpaccess();

# Save ls* commands
foreach $l ('lslong', 'lsshort', 'lsplain') {
	if ($self->{'in_hash'}->{$l."_def"}) {
		$self->save_directive($self->{'conf'}, $l, [ ]);
		}
	elsif ($self->{'in_hash'}->{$l} !~ /\S/) {
		$self->error($self->{'text_hash'}->{"misc_e$l"});
		}
	else {
		$self->save_directive($self->{'conf'}, $l, [ { 'name' => $l,
					       'values' => [ $self->{'in_hash'}->{$l} ] } ] );
		}
	}

# Save shutdown command
if ($self->{'in_hash'}->{'shutdown_def'}) {
	$self->save_directive($self->{'conf'}, 'shutdown', [ ]);
	}
elsif ($self->{'in_hash'}->{'shutdown'} !~ /\S/) {
	$self->error($self->{'text_hash'}->{'misc_eshutdown'});
	}
else {
	$self->save_directive($self->{'conf'}, 'shutdown',
			[ { 'name' => 'shutdown',
			    'values' => [ $self->{'in_hash'}->{'shutdown'} ] } ] );
	}

# Save nice options
for($i=0; defined($self->{'ndelta'} = $self->{'in_hash'}->{"ndelta_$i"}); $i++) {
	next if ($self->{'ndelta'} eq '');
	$self->{'ndelta'} =~ /^[\-0-9]+$/ || $self->error($self->text('misc_edelta', $self->{'ndelta'}));
	push(@{$self->{'nice_array'}}, { 'name' => 'nice',
		      'values' => [ $self->{'ndelta'}, $self->{'in_hash'}->{"nclass_$i"} ] } );
	}
$self->save_directive($self->{'conf'}, 'nice', \@{$self->{'nice_array'}});

# Save defumask options
for($i=0; defined($self->{'umask'} = $self->{'in_hash'}->{"umask_$i"}); $i++) {
	next if ($self->{'umask'} eq '');
	$self->{'umask'} =~ /^[0-9]+$/ || $self->error($self->text('misc_eumask', $self->{'umask'}));
	push(@{$self->{'umask_array'}}, { 'name' => 'defumask',
		       'values' => [ $self->{'umask'}, $self->{'in_hash'}->{"uclass_$i"} ] } );
	}
$self->save_directive($self->{'conf'}, 'defumask', \@{$self->{'umask_array'}});

$self->flush_file_lines();
$self->unlock_file($self->{'config_hash'}->{'ftpaccess'});
$self->webmin_log("misc", undef, undef, \%{$self->{'in_hash'}});
$self->redirect("");
1;
		
}


1;

