#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_net.cgi
# Save networking options

&ModuleLoader::preload_module('wuftpd_class', "wuftpd::WuftpdLib");
$self = new wuftpd::WuftpdLib:: 'wuftpd_class',%$self;

$self->error_setup($self->{'text_hash'}->{'net_err'});
$self->ReadParse();

$self->lock_file($self->{'config_hash'}->{'ftpaccess'});
$self->{'conf'} = $self->get_ftpaccess();

# Save TCP windows
for($i=0; defined($self->{'tsize'} = $self->{'in_hash'}->{"tsize_$i"}); $i++) {
	next if (!$self->{'tsize'});
	$self->{'tsize'} =~ /^\d+$/ || $self->error($self->text('net_etsize', $self->{'tsize'}));
	push(@{$self->{'tcpwindow_array'}}, { 'name' => 'tcpwindow',
		           'values' => [ $self->{'tsize'}, $self->{'in_hash'}->{"tclass_$i"} ] } );
	}
$self->save_directive($self->{'conf'}, 'tcpwindow', \@{$self->{'tcpwindow_array'}});

# Save PASV options
for($i=0; defined($self->{'aip'} = $self->{'in_hash'}->{"aip_$i"}); $i++) {
	$self->{'anet'} = $self->{'in_hash'}->{"anet_$i"}; $self->{'acidr'} = $self->{'in_hash'}->{"acidr_$i"};
	next if (!$self->{'aip'});
	$self->check_ipaddress($self->{'aip'}) || $self->error($self->text('net_eip', $self->{'aip'}));
	$self->check_ipaddress($self->{'anet'}) || $self->error($self->text('net_enet', $self->{'anet'}));
	$self->{'acidr'} =~ /^\d+$/ && $self->{'acidr'} <= 32 || $self->error($self->text('net_ecidr', $self->{'acidr'}));
	push(@{$self->{'passive_array'}}, { 'name' => 'passive',
			 'values' => [ 'address', $self->{'aip'}, "$self->{'anet'}/$self->{'acidr'}" ] } );
	}
for($i=0; defined($self->{'pmin'} = $self->{'in_hash'}->{"pmin_$i"}); $i++) {
	$self->{'pmax'} = $self->{'in_hash'}->{"pmax_$i"}; $self->{'pnet'} = $self->{'in_hash'}->{"pnet_$i"};
	$self->{'pcidr'} = $self->{'in_hash'}->{"pcidr_$i"};
	next if ($self->{'pmin'} eq "" || $self->{'pmax'} eq "");
	$self->{'pmin'} =~ /^\d+$/ || $self->error($self->text('net_eport', $self->{'pmin'}));
	$self->{'pmax'} =~ /^\d+$/ || $self->error($self->text('net_eport', $self->{'pmax'}));
	$self->check_ipaddress($self->{'pnet'}) || $self->error($self->text('net_enet', $self->{'pnet'}));
	$self->{'pcidr'} =~ /^\d+$/ && $self->{'pcidr'} <= 32 || $self->error($self->text('net_ecidr', $self->{'pcidr'}));
	push(@{$self->{'passive_array'}},
		{ 'name' => 'passive',
		  'values' => [ 'ports', "$self->{'pnet'}/$self->{'pcidr'}", $self->{'pmin'}, $self->{'pmax'} ] } );
	}
$self->save_directive($self->{'conf'}, 'passive', \@{$self->{'passive_array'}});

$self->flush_file_lines();
$self->unlock_file($self->{'config_hash'}->{'ftpaccess'});
$self->webmin_log("net", undef, undef, \%{$self->{'in_hash'}});
$self->redirect("");

1;
		
}


1;

