#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_perm.cgi
# Save permission options

&ModuleLoader::preload_module('wuftpd_class', "wuftpd::WuftpdLib");
$self = new wuftpd::WuftpdLib:: 'wuftpd_class',%$self;

$self->error_setup($self->{'text_hash'}->{'perm_err'});
$self->ReadParse();
$self->lock_file($self->{'config_hash'}->{'ftpaccess'});
$self->{'conf'} = $self->get_ftpaccess();
@{$self->{'class_array'}} = $self->find_value("class", $self->{'conf'});

# Save chmod, delete, etc .. options
for($i=0; defined($self->{'type'} = $self->{'in_hash'}->{"type_$i"}); $i++) {
	next if (!$self->{'type'});
	local @users = split(/\0/, $self->{'in_hash'}->{"users_$i"});
	local @classes = map { "class=$_" } split(/\0/, $self->{'in_hash'}->{"classes_$i"});
	@classes = () if (scalar(@classes) == scalar(@{$self->{'class_array'}}));
	push(@{$self->{'type'}}, { 'name' => $self->{'type'},
		       'values' => [ $self->{'in_hash'}->{"can_$i"},
				     join(",", @users, @classes) ] } );
	}
@{$self->{'permtypes_array'}} = ( 'chmod', 'delete', 'overwrite', 'rename', 'umask' );
foreach $t (@{$self->{'permtypes_array'}}) {
	$self->save_directive($self->{'conf'}, $t, \@$t);
	}

# Save path-filter options
for($i=0; defined($self->{'char'} = $self->{'in_hash'}->{"char_$i"}); $i++) {
	next if (!$self->{'char'});
	$self->{'char'} =~ /^\S+$/ || $self->error($self->text('perm_echar', $self->{'char'}));
	$self->{'in_hash'}->{"types_$i"} || $self->error($self->{'text_hash'}->{'perm_etypes'});
	$self->{'in_hash'}->{"types_$i"} =~ s/\0/,/g;
	-r $self->{'in_hash'}->{"mesg_$i"} || $self->error($self->text('perm_emesg', $self->{'in_hash'}->{"mesg_$i"}));
	push(@{$self->{'filter_array'}}, { 'name' => 'path-filter',
			'values' => [ $self->{'in_hash'}->{"types_$i"}, $self->{'in_hash'}->{"mesg_$i"},
				      $self->{'char'}, split(/\s+/, $self->{'in_hash'}->{"regexp_$i"})
				    ] } );
	}
$self->save_directive($self->{'conf'}, 'path-filter', \@{$self->{'filter_array'}});

$self->flush_file_lines();
$self->unlock_file($self->{'config_hash'}->{'ftpaccess'});
$self->webmin_log("perm", undef, undef, \%{$self->{'in_hash'}});
$self->redirect("");

1;
		
}


1;

