#!/usr/bin/perl
package xinetd::Backup_config;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'xinetd::Backup_config');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;

&ModuleLoader::preload_module(ref($self), "xinetd::XinetdLib");
$self = new xinetd::XinetdLib:: ref($self), %$self; 

1;

1;
		return $self;
}

# backup_config_files()
# Returns files and directories that can be backed up
sub backup_config_files
{
	my $self = shift;

local @conf = $self->get_xinetd_config();
local @rv = map { $_->{'file'} } @conf;
return $self->unique(@rv);
}

# pre_backup(&files)
# Called before the files are actually read
sub pre_backup
{
	my $self = shift;

return undef;
}

# post_backup(&files)
# Called after the files are actually read
sub post_backup
{
	my $self = shift;

return undef;
}

# pre_restore(&files)
# Called before the files are restored from a backup
sub pre_restore
{
	my $self = shift;

return undef;
}

# post_restore(&files)
# Called after the files are restored from a backup
sub post_restore
{
	my $self = shift;

local $pid;
if ($pid = $self->is_xinetd_running()) {
	$self->kill_logged('USR2', $pid);
	}
return undef;
}


1;

