#!/usr/bin/perl
package xinetd::Log_parser;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'xinetd::Log_parser');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# log_parser.pl
# Functions for parsing this module's logs

&ModuleLoader::preload_module(ref($self), "xinetd::XinetdLib");
$self = new xinetd::XinetdLib:: ref($self), %$self; 

1;
		return $self;
}

# parse_webmin_log(user, script, action, type, object, &params)
# Converts logged information from this module into human-readable form
sub parse_webmin_log
{
	my $self = shift;

local ($user, $script, $action, $type, $object, $p, $long) = @_;
if ($type eq 'serv') {
	return $self->text("log_${action}_serv",
		     "<tt>".$self->html_escape($object)."</tt>",
		     uc($p->{'protocol'}));
	}
elsif ($action eq "enable" || $action eq "disable") {
	if ($long && $p->{'servs'}) {
		return $self->text('log_'.$action.'_l',
		     join(", ", map { "<tt>$_</tt>" } split(/\0/, $p->{'servs'})));
		}
	else {
		return $self->text('log_'.$action, $object);
		}
	}
else {
	return $self->{'text_hash'}->{'log_'.$action};
	}
}


1;

