#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_defaults.cgi
# Display a form for editing default options

&ModuleLoader::preload_module('xinetd_class', "xinetd::XinetdLib");
$self = new xinetd::XinetdLib:: 'xinetd_class',%$self;

$self->ui_print_header(undef, $self->{'text_hash'}->{'defs_title'}, "");

foreach $xi ($self->get_xinetd_config()) {
	if ($xi->{'name'} eq 'defaults') {
		$self->{'defs'} = $xi;
		}
	}
$self->{'q'} = $self->{'defs'}->{'quick'};

print "<form action=save_defaults.cgi>\n";
print "<input type=hidden name=idx value='$self->{'defs'}->{'index'}'>\n";
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'defs_header'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

print "<tr> <td valign=top><b>$self->{'text_hash'}->{'serv_from'}</b></td>\n";
printf "<td><input type=radio name=from_def value=1 %s> %s\n",
	$self->{'q'}->{'only_from'} ? '' : 'checked', $self->{'text_hash'}->{'serv_from_def'};
printf "<input type=radio name=from_def value=0 %s> %s<br>\n",
	$self->{'q'}->{'only_from'} ? 'checked' : '', $self->{'text_hash'}->{'serv_from_sel'};
print "<textarea name=from rows=4 cols=20>",
	join("\n", @{$self->{'q'}->{'only_from'}}),"</textarea></td>\n";

print "<td valign=top><b>$self->{'text_hash'}->{'serv_access'}</b></td>\n";
printf "<td><input type=radio name=access_def value=1 %s> %s\n",
	$self->{'q'}->{'no_access'} ? '' : 'checked', $self->{'text_hash'}->{'serv_access_def'};
printf "<input type=radio name=access_def value=0 %s> %s<br>\n",
	$self->{'q'}->{'no_access'} ? 'checked' : '', $self->{'text_hash'}->{'serv_access_sel'};
print "<textarea name=access rows=4 cols=20>",
	join("\n", @{$self->{'q'}->{'no_access'}}),"</textarea></td> </tr>\n";

print "<tr> <td colspan=4><hr></td> </tr>\n";

$self->{'lt'} = $self->{'q'}->{'log_type'}->[0] eq 'SYSLOG' ? 1 :
      $self->{'q'}->{'log_type'}->[0] eq 'FILE' ? 2 : 0;
print "<tr> <td valign=top><b>$self->{'text_hash'}->{'defs_log'}</b></td> <td colspan=3>\n";
printf "<input type=radio name=log_mode value=0 %s> %s<br>\n",
	$self->{'lt'} == 0 ? 'checked' : '', $self->{'text_hash'}->{'defs_log_def'};

printf "<input type=radio name=log_mode value=1 %s> %s\n",
	$self->{'lt'} == 1 ? 'checked' : '', $self->{'text_hash'}->{'defs_facility'};
%{$self->{'sconfig_hash'}} = $self->foreign_config("syslog");
$self->foreign_require("syslog", "syslog-lib.pl");
print "<select name=facility>\n";
foreach $f (split(/\s+/, $self->{'sconfig_hash'}->{'facilities'})) {
	printf "<option %s>%s\n",
		$self->{'lt'} == 1 && $self->{'q'}->{'log_type'}->[1] eq $f ? 'selected' : '', $f;
	}
print "</select> $self->{'text_hash'}->{'defs_level'}\n";
print "<select name=level>\n";
printf "<option value='' %s>%s\n",
	$self->{'lt'} != 1 || !$self->{'q'}->{'log_type'}->[2] ? 'selected' : '', $self->{'text_hash'}->{'default'};
foreach $l ($self->foreign_call("syslog", "list_priorities")) {
	printf "<option %s>%s\n",
		$self->{'lt'} == 1 && $self->{'q'}->{'log_type'}->[2] eq $l ? 'selected' : '', $l;
	}
print "</select><br>\n";

printf "<input type=radio name=log_mode value=2 %s> %s\n",
	$self->{'lt'} == 2 ? 'checked' : '', $self->{'text_hash'}->{'defs_file'};
printf "<input name=file size=35 value='%s'> %s<br>\n",
	$self->{'lt'} == 2 ? $self->{'q'}->{'log_type'}->[1] : '', $self->file_chooser_button("file");
printf "&nbsp;&nbsp;&nbsp;%s <input name=soft size=6 value='%s'>\n",
	$self->{'text_hash'}->{'defs_soft'}, $self->{'lt'} == 2 ? $self->{'q'}->{'log_type'}->[2] : '';
printf "&nbsp;&nbsp;%s <input name=hard size=6 value='%s'></td> </tr>\n",
	$self->{'text_hash'}->{'defs_hard'}, $self->{'lt'} == 2 ? $self->{'q'}->{'log_type'}->[3] : '';

print "<tr> <td valign=top><b>$self->{'text_hash'}->{'defs_success'}</b></td>\n";
print "<td><select name=success multiple size=5>\n";
foreach $s ('PID', 'HOST', 'USERID', 'EXIT', 'DURATION') {
	printf "<option value=%s %s>%s\n",
		$s, $self->indexof($s, @{$self->{'q'}->{'log_on_success'}})<0 ? '' : 'selected',
		$self->{'text_hash'}->{"defs_success_".lc($s)};
	}
print "</select></td>\n";

print "<td valign=top><b>$self->{'text_hash'}->{'defs_failure'}</b></td>\n";
print "<td><select name=failure multiple size=5>\n";
foreach $s ('HOST', 'USERID', 'ATTEMPT', 'RECORD') {
	printf "<option value=%s %s>%s\n",
		$s, $self->indexof($s, @{$self->{'q'}->{'log_on_failure'}})<0 ? '' : 'selected',
		$self->{'text_hash'}->{"defs_failure_".lc($s)};
	}
print "</select></td> </tr>\n";

print "</table></td></tr></table>\n";
print "<input type=submit value='$self->{'text_hash'}->{'save'}'></form>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

