#!/usr/bin/perl

&MAIN();

 sub MAIN {
# index.cgi
# Display all xinetd services

&ModuleLoader::preload_module('xinetd_class', "xinetd::XinetdLib");
$self = new xinetd::XinetdLib:: 'xinetd_class',%$self;

$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", undef, 1, 1, 0,
	$self->help_search_link("xinetd", "man", "doc", "google"));

# Check for config file
if (!-r $self->{'config_hash'}->{'xinetd_conf'}) {
	print "<p>",$self->text('index_econf', "<tt>$self->{'config_hash'}->{'xinetd_conf'}</tt>",
			  "$self->{'gconfig_hash'}->{'webprefix'}/config.cgi?$self->{'module_name'}"),"<p>\n";
	$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});
	exit;
	}

@{$self->{'conf_array'}} = $self->get_xinetd_config();
($self->{'defs'}) = grep { $_->{'name'} eq 'defaults' } @{$self->{'conf_array'}};
foreach $m (@{$self->{'defs'}->{'members'}}) {
	$self->{'ddisable_hash'}->{$m->{'value'}}++ if ($m->{'name'} eq 'disabled');
	}

# Show table header
print "<form action=mass_enable.cgi method=post>\n";
print $self->select_all_link("serv"),"\n";
print $self->select_invert_link("serv"),"\n";
print "<a href='edit_serv.cgi?new=1'>$self->{'text_hash'}->{'index_add_inet'}</a><br>\n";
@{$self->{'tds_array'}} = ( "width=5" );
print $self->ui_columns_start([ "",
			  $self->{'text_hash'}->{'index_name'},
			  $self->{'text_hash'}->{'index_type'},
			  $self->{'text_hash'}->{'index_port'},
			  $self->{'text_hash'}->{'index_proto'},
			  $self->{'text_hash'}->{'index_user'},
			  $self->{'text_hash'}->{'index_server'},
			  $self->{'text_hash'}->{'index_enabled'} ], 100, 0, \@{$self->{'tds_array'}});

# Show one row for each service
foreach $x (@{$self->{'conf_array'}}) {
	next if ($x->{'name'} ne 'service');
	local $q = $x->{'quick'};
	local @s;
	if ($q->{'type'}->[0] eq 'UNLISTED') {
		# Port and protocol specified
		@s = ( $x->{'name'}, undef, $q->{'port'}->[0],
		       $q->{'protocol'}->[0] );
		}
	elsif ($q->{'protocol'}) {
		# Protocol specified, find port from service
		if ($self->{'config_hash'}->{'lookup_servs'}) {
			@s = getservbyname($x->{'value'}, $q->{'protocol'}->[0]);
			}
		if (!@s) {
			@s = ( $x->{'name'}, undef, $q->{'port'}->[0],
			       $q->{'protocol'}->[0] );
			}
		}
	else {
		# Only service specified, check all protocols
		if ($self->{'config_hash'}->{'lookup_servs'}) {
			foreach $p ($self->list_protocols()) {
				@s = getservbyname($x->{'value'}, $p);
				last if (@s);
				}
			}
		}
	local @cols;
	local @mytds = @{$self->{'tds_array'}};
	push(@cols, "<a href='edit_serv.cgi?idx=$x->{'index'}'>".
		    $self->html_escape($x->{'value'})."</a>");
	push(@cols, $self->indexof('RPC', @{$q->{'type'}}) < 0 ?
		     $self->{'text_hash'}->{'index_inet'} : $self->{'text_hash'}->{'index_rpc'});
	if (@s) {
		push(@cols, $self->html_escape($s[2]) ||
			     "<i>$self->{'text_hash'}->{'index_noport'}</i>");
		push(@cols, $self->html_escape(uc($s[3])));
		}
	else {
		push(@cols, "<i>$self->{'text_hash'}->{'index_noport'}</i>");
		push(@mytds, "", "", "colspan=2");
		}
	push(@cols, $q->{'user'} ? $self->html_escape($q->{'user'}->[0]) : "");
	push(@cols, $self->indexof('INTERNAL', @{$q->{'type'}}) >= 0 ?
		     $self->{'text_hash'}->{'index_internal'} : $q->{'redirect'} ?
		     $self->text('index_redirect', "<tt>".$self->html_escape($q->{'redirect'}->[0])."</tt>") :
		     $self->html_escape($q->{'server'}->[0]));
	$self->{'id'} = $q->{'id'}->[0] || $x->{'value'};
	push(@cols, $q->{'disable'}->[0] eq 'yes' || $self->{'ddisable_hash'}->{$self->{'id'}} ?
	      "<font color=#ff0000>$self->{'text_hash'}->{'no'}</font>" : $self->{'text_hash'}->{'yes'});
	print $self->ui_checked_columns_row(\@cols, \@{$self->{'tds_array'}}, "serv", $x->{'index'});
	}
print $self->ui_columns_end();
print $self->select_all_link("serv"),"\n";
print $self->select_invert_link("serv"),"\n";
print "<a href='edit_serv.cgi?new=1'>$self->{'text_hash'}->{'index_add_inet'}</a><p>\n";

print "<input type=submit name=enable value='$self->{'text_hash'}->{'index_enable'}'>\n";
print "<input type=submit name=disable value='$self->{'text_hash'}->{'index_disable'}'>\n";
print "</form>\n";

print "<hr>\n";
print "<table>\n";
print "<form action=edit_defaults.cgi>\n";
print "<tr> <td><input type=submit value=\"$self->{'text_hash'}->{'index_defaults'}\"></td>\n";
print "<td>$self->{'text_hash'}->{'index_defaultsmsg'} \n";
print "</td> </tr>\n";
print "</form>\n";

if ($self->{'pid'} = $self->is_xinetd_running()) {
	print "<form action=restart.cgi>\n";
	print "<input type=hidden name=pid value=$self->{'pid'}>\n";
	print "<tr> <td><input type=submit value=\"$self->{'text_hash'}->{'index_apply'}\"></td>\n";
	print "<td>$self->{'text_hash'}->{'index_applymsg'} \n";
	print "</td></tr>\n";
	print "</form>\n";
	}
else {
	print "<form action=start.cgi>\n";
	print "<tr> <td><input type=submit value=\"$self->{'text_hash'}->{'index_start'}\"></td>\n";
	print "<td>$self->{'text_hash'}->{'index_startmsg'} \n";
	print "</td> </tr>\n";
	print "</form>\n";
	}
print "</table>\n";

$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});

1;
		
}


1;

