#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Enable or disable a bunch of services
# XXX what about line changes due to modifications??
# XXX changelog / ideas

&ModuleLoader::preload_module('xinetd_class', "xinetd::XinetdLib");
$self = new xinetd::XinetdLib:: 'xinetd_class',%$self;

$self->ReadParse();

@{$self->{'conf_array'}} = $self->get_xinetd_config();
@{$self->{'ids_array'}} = split(/\0/, $self->{'in_hash'}->{'serv'});
($self->{'defs'}) = grep { $_->{'name'} eq 'defaults' } @{$self->{'conf_array'}};
foreach $m (@{$self->{'defs'}->{'members'}}) {
	$self->{'ddisable_hash'}->{$m->{'value'}} = $m if ($m->{'name'} eq 'disabled');
	}

$self->lock_file($self->{'config_hash'}->{'xinetd_conf'});
if ($self->{'in_hash'}->{'enable'}) {
	# Enable all selected
	foreach $id (@{$self->{'ids_array'}}) {
		@{$self->{'conf_array'}} = $self->get_xinetd_config();
		$self->{'xinet'} = $self->{'conf_array'}->[$id];
		$self->lock_file($self->{'xinet'}->{'file'});
		$self->{'q'} = $self->{'xinet'}->{'quick'};
		$self->{'dis'} = $self->{'q'}->{'disable'}->[0] eq 'yes' || $self->{'ddisable_hash'}->{$id};
		if ($self->{'dis'}) {
			$self->set_member_value($self->{'xinet'}, 'disable', 'no');
			$self->modify_xinet($self->{'xinet'});
			if ($self->{'ddisable_hash'}->{$self->{'oldid'}}) {
				# Take out old global disabled
				$self->delete_xinet($self->{'ddisable_hash'}->{$self->{'oldid'}});
				}
			push(@{$self->{'servs_array'}}, $self->{'xinet'}->{'value'});
			}
		}
	}
else {
	# Disable all selected
	foreach $id (@{$self->{'ids_array'}}) {
		@{$self->{'conf_array'}} = $self->get_xinetd_config();
		$self->{'xinet'} = $self->{'conf_array'}->[$id];
		$self->lock_file($self->{'xinet'}->{'file'});
		$self->{'q'} = $self->{'xinet'}->{'quick'};
		$self->{'dis'} = $self->{'q'}->{'disable'}->[0] eq 'yes' || $self->{'ddisable_hash'}->{$id};
		if (!$self->{'dis'}) {
			$self->set_member_value($self->{'xinet'}, 'disable', 'yes');
			$self->modify_xinet($self->{'xinet'});
			push(@{$self->{'servs_array'}}, $self->{'xinet'}->{'value'});
			}
		}
	}

$self->unlock_all_files();
$self->webmin_log($self->{'in_hash'}->{'enable'} ? "enable" : "disable", undef, scalar(@{$self->{'ids_array'}}),
	    { 'servs' => \@{$self->{'servs_array'}} });
$self->redirect("");

1;
		
}


1;

