#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_defaults.cgi
# Save default options

&ModuleLoader::preload_module('xinetd_class', "xinetd::XinetdLib");
$self = new xinetd::XinetdLib:: 'xinetd_class',%$self;

$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'defs_err'});
$self->lock_file($self->{'config_hash'}->{'xinetd_conf'});
@{$self->{'conf_array'}} = $self->get_xinetd_config();
foreach $c (@{$self->{'conf_array'}}) {
	if ($c->{'name'} eq 'defaults') {
		$self->{'defs'} = $c;
		$self->{'found'}++;
		}
	}
if (!$self->{'found'}) {
	$self->{'defs'} = { 'name' => 'defaults',
		  'members' => [ ] };
	}

# Parse and save inputs
$self->set_member_value($self->{'defs'}, 'only_from', $self->{'in_hash'}->{'from_def'} ? undef :
		  $self->{'in_hash'}->{'from'} ? split(/\s+/, $self->{'in_hash'}->{'from'}) : ("") );
$self->set_member_value($self->{'defs'}, 'no_access', $self->{'in_hash'}->{'access_def'} ? undef :
		  $self->{'in_hash'}->{'access'} ? split(/\s+/, $self->{'in_hash'}->{'access'}) : ("") );
if ($self->{'in_hash'}->{'log_mode'} == 0) {
	$self->set_member_value($self->{'defs'}, 'log_type');
	}
elsif ($self->{'in_hash'}->{'log_mode'} == 1) {
	$self->set_member_value($self->{'defs'}, 'log_type', 'SYSLOG', $self->{'in_hash'}->{'facility'},
			  $self->{'in_hash'}->{'level'} ? ( $self->{'in_hash'}->{'level'} ) : ( ) );
	}
elsif ($self->{'in_hash'}->{'log_mode'} == 2) {
	$self->{'in_hash'}->{'file'} =~ /^\S+$/ || $self->error($self->{'text_hash'}->{'defs_efile'});
	$self->{'in_hash'}->{'soft'} =~ /^\d*$/ || $self->error($self->{'text_hash'}->{'defs_esoft'});
	$self->{'in_hash'}->{'hard'} =~ /^\d*$/ || $self->error($self->{'text_hash'}->{'defs_ehard'});
	$self->set_member_value($self->{'defs'}, 'log_type', 'FILE', $self->{'in_hash'}->{'file'},
			  $self->{'in_hash'}->{'soft'} ? ( $self->{'in_hash'}->{'soft'} ) : ( ),
			  $self->{'in_hash'}->{'hard'} ? ( $self->{'in_hash'}->{'hard'} ) : ( ) );
	}
$self->set_member_value($self->{'defs'}, 'log_on_success', split(/\0/, $self->{'in_hash'}->{'success'}));
$self->set_member_value($self->{'defs'}, 'log_on_failure', split(/\0/, $self->{'in_hash'}->{'failure'}));
if ($self->{'found'}) {
	$self->modify_xinet($self->{'defs'});
	}
else {
	$self->create_xinet($self->{'defs'});
	}
$self->unlock_file($self->{'config_hash'}->{'xinetd_conf'});
$self->webmin_log("defaults", undef, undef, $self->{'defs'}->{'quick'});
$self->redirect("");

1;
		
}


1;

