#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_serv.cgi
# Create, modify or delete an internet service

&ModuleLoader::preload_module('xinetd_class', "xinetd::XinetdLib");
$self = new xinetd::XinetdLib:: 'xinetd_class',%$self;

$self->ReadParse();
@{$self->{'conf_array'}} = $self->get_xinetd_config();
if ($self->{'in_hash'}->{'new'}) {
	$self->{'xinet'} = { 'name' => 'service',
		   'members' => [ ] };
	}
else {
	$self->{'xinet'} = $self->{'conf_array'}->[$self->{'in_hash'}->{'idx'}];
	($self->{'defs'}) = grep { $_->{'name'} eq 'defaults' } @{$self->{'conf_array'}};
	foreach $m (@{$self->{'defs'}->{'members'}}) {
		$self->{'ddisable_hash'}->{$m->{'value'}} = $m if ($m->{'name'} eq 'disabled');
		}
	$self->{'oldid'} = $self->{'xinet'}->{'quick'}->{'id'}->[0] || $self->{'xinet'}->{'value'};
	}

$self->lock_file($self->{'config_hash'}->{'xinetd_conf'});
if ($self->{'in_hash'}->{'delete'}) {
	# Delete a service
	$self->delete_xinet($self->{'xinet'});
	}
else {
	# Validate inputs
	$self->error_setup($self->{'text_hash'}->{'serv_err'});
	$self->{'in_hash'}->{'id'} =~ /^\S+$/ || $self->error($self->{'text_hash'}->{'serv_eid'});
	$self->{'in_hash'}->{'bind_def'} || $self->check_ipaddress($self->{'in_hash'}->{'bind'}) ||
	    $self->check_ip6address($self->{'in_hash'}->{'bind'}) ||
		$self->error($self->{'text_hash'}->{'serv_ebind'});
	foreach $p ($self->list_protocols()) {
		@{$self->{'ps_array'}} = getservbyname($self->{'in_hash'}->{'id'}, $p);
		last if (@{$self->{'ps_array'}});
		}
	if ($self->{'in_hash'}->{'port_def'}) {
		# make sure the service actually exists
		if ($self->{'in_hash'}->{'proto'}) {
			@{$self->{'s_array'}} = getservbyname($self->{'in_hash'}->{'id'}, $self->{'in_hash'}->{'proto'});
			}
		else {
			@{$self->{'s_array'}} = @{$self->{'ps_array'}};
			}
		@{$self->{'s_array'}} || $self->error($self->text('serv_estd', $self->{'in_hash'}->{'name'}));
		}
	else {
		$self->{'in_hash'}->{'port'} =~ /^\d+$/ || $self->error($self->{'text_hash'}->{'serv_eport'});
		$self->{'in_hash'}->{'proto'} || @{$self->{'ps_array'}} || $self->error($self->{'text_hash'}->{'serv_eproto'});
		}
	$self->{'in_hash'}->{'inst_def'} || $self->{'in_hash'}->{'inst'} =~ /^\d+$/ ||
		$self->error($self->{'text_hash'}->{'serv_einst'});
	$self->{'in_hash'}->{'user'} || $self->{'in_hash'}->{'prog'} == 0 || $self->error($self->{'text_hash'}->{'serv_euser'});
	$self->{'in_hash'}->{'group_def'} || $self->{'in_hash'}->{'group'} || $self->error($self->{'text_hash'}->{'serv_egroup'});
	$self->{'in_hash'}->{'nice_def'} || $self->{'in_hash'}->{'nice'} =~ /^\d+$/ ||
		$self->error($self->{'text_hash'}->{'serv_enice'});
	if (!$self->{'in_hash'}->{'cps_def'}) {
		$self->{'in_hash'}->{'cps0'} =~ /^\d+$/ || $self->error($self->{'text_hash'}->{'serv_ecps0'});
		$self->{'in_hash'}->{'cps1'} =~ /^\d+$/ || $self->error($self->{'text_hash'}->{'serv_ecps1'});
		}
	if (!$self->{'in_hash'}->{'times_def'}) {
		@{$self->{'times_array'}} = split(/\s+/, $self->{'in_hash'}->{'times'});
		map { $self->error($self->{'text_hash'}->{'serv_etimes'}) if (!/^\d+:\d+\-\d+:\d+$/) }
		    @{$self->{'times_array'}};
		}

	# Create service structure
	$self->{'xinet'}->{'values'} = [ $self->{'in_hash'}->{'id'} ];
	$self->set_member_value($self->{'xinet'}, 'disable', $self->{'in_hash'}->{'disable'} ? 'yes' : undef);
	$self->set_member_value($self->{'xinet'}, 'port',
			  $self->{'in_hash'}->{'port_def'} ? undef : $self->{'in_hash'}->{'port'});
	$self->set_member_value($self->{'xinet'}, 'bind',
			  $self->{'in_hash'}->{'bind_def'} ? undef : $self->{'in_hash'}->{'bind'});
	$self->set_member_value($self->{'xinet'}, 'socket_type', $self->{'in_hash'}->{'sock'});
	$self->set_member_value($self->{'xinet'}, 'protocol', $self->{'in_hash'}->{'proto'} ? $self->{'in_hash'}->{'proto'}
							   : undef);

	$self->set_member_value($self->{'xinet'}, 'user', $self->{'in_hash'}->{'user'}) if ($self->{'in_hash'}->{'user'});
	$self->set_member_value($self->{'xinet'}, 'group',
			  $self->{'in_hash'}->{'group_def'} ? undef : $self->{'in_hash'}->{'group'});
	@{$self->{'type_array'}} = @{$self->{'q'}->{'type'}};
	@{$self->{'flags_array'}} = @{$self->{'q'}->{'flags'}};
	if ($self->{'in_hash'}->{'prog'} == 0) {
		@{$self->{'type_array'}} = $self->unique(@{$self->{'type_array'}}, 'INTERNAL');
		$self->set_member_value($self->{'xinet'}, 'server');
		$self->set_member_value($self->{'xinet'}, 'server_args');
		$self->set_member_value($self->{'xinet'}, 'redirect');
		}
	elsif ($self->{'in_hash'}->{'prog'} == 1) {
		@{$self->{'type_array'}} = grep { $_ ne 'INTERNAL' } @{$self->{'type_array'}};
		@{$self->{'s_array'}} = split(/\s+/, $self->{'in_hash'}->{'server'});
		$self->{'in_hash'}->{'disable'} || @{$self->{'s_array'}} && -x $self->{'s_array'}->[0] ||
			$self->error($self->{'text_hash'}->{'serv_eserver'});
		$self->set_member_value($self->{'xinet'}, 'server', shift(@{$self->{'s_array'}}));
		$self->set_member_value($self->{'xinet'}, 'server_args', @{$self->{'s_array'}});
		$self->set_member_value($self->{'xinet'}, 'redirect');
		}
	else {
		gethostbyname($self->{'in_hash'}->{'rhost'}) || $self->error($self->{'text_hash'}->{'serv_erhost'});
		$self->{'in_hash'}->{'rport'} =~ /^\d+$/ || $self->error($self->{'text_hash'}->{'serv_erport'});
		@{$self->{'type_array'}} = grep { $_ ne 'INTERNAL' } @{$self->{'type_array'}};
		$self->set_member_value($self->{'xinet'}, 'server');
		$self->set_member_value($self->{'xinet'}, 'server_args');
		$self->set_member_value($self->{'xinet'}, 'redirect',
				  $self->{'in_hash'}->{'rhost'}, $self->{'in_hash'}->{'rport'});
		}
	if ($self->{'in_hash'}->{'port_def'} || (!$self->{'in_hash'}->{'port_def'} && !$self->{'in_hash'}->{'proto'} && @{$self->{'ps_array'}})) {
		@{$self->{'type_array'}} = grep { $_ ne 'UNLISTED' } @{$self->{'type_array'}};
		}
	else {
		@{$self->{'type_array'}} = $self->unique(@{$self->{'type_array'}}, 'UNLISTED');
		}
	$self->set_member_value($self->{'xinet'}, 'type', @{$self->{'type_array'}});
	$self->set_member_value($self->{'xinet'}, 'wait', $self->{'in_hash'}->{'wait'} ? 'yes' : 'no');
	$self->set_member_value($self->{'xinet'}, 'instances',
			  $self->{'in_hash'}->{'inst_def'} ? undef : $self->{'in_hash'}->{'inst'});
	$self->set_member_value($self->{'xinet'}, 'nice',
			  $self->{'in_hash'}->{'nice_def'} ? undef : $self->{'in_hash'}->{'nice'});
	$self->set_member_value($self->{'xinet'}, 'cps',
			  $self->{'in_hash'}->{'cps_def'} ? ( ) : ( $self->{'in_hash'}->{'cps0'},$self->{'in_hash'}->{'cps1'} ) );
	$self->set_member_value($self->{'xinet'}, 'only_from', $self->{'in_hash'}->{'from_def'} ? undef :
			  $self->{'in_hash'}->{'from'} ? split(/\s+/, $self->{'in_hash'}->{'from'}) : ("") );
	$self->set_member_value($self->{'xinet'}, 'no_access', $self->{'in_hash'}->{'access_def'} ? undef :
			  $self->{'in_hash'}->{'access'} ? split(/\s+/, $self->{'in_hash'}->{'access'}) : ("") );
	$self->set_member_value($self->{'xinet'}, 'access_times', $self->{'in_hash'}->{'times_def'} ? undef
								   : @{$self->{'times_array'}});

	if ($self->{'in_hash'}->{'new'}) {
		foreach $xi (@{$self->{'conf_array'}}) {
			if ($xi->{'name'} eq 'service' &&
			    $xi->{'value'} eq $self->{'in_hash'}->{'id'}) {
				# A service with the same name exists!
				$self->set_member_value(
					$self->{'xinet'}, 'id', "$self->{'in_hash'}->{'id'}-$self->{'in_hash'}->{'sock'}");
				}
			}
		if (-d $self->{'config_hash'}->{'add_dir'}) {
			$self->lock_file($self->{'newfile'});
			$self->{'newfile'} = "$self->{'config_hash'}->{'add_dir'}/$self->{'in_hash'}->{'id'}";
			$self->create_xinet($self->{'xinet'}, $self->{'newfile'});
			$self->unlock_file($self->{'newfile'});
			}
		else {
			$self->create_xinet($self->{'xinet'});
			}
		}
	else {
		$self->modify_xinet($self->{'xinet'});
		if ($self->{'ddisable_hash'}->{$self->{'oldid'}}) {
			# Take out old global disabled
			$self->delete_xinet($self->{'ddisable_hash'}->{$self->{'oldid'}});
			}
		}
	}
$self->unlock_file($self->{'config_hash'}->{'xinetd_conf'});
$self->webmin_log($self->{'in_hash'}->{'delete'} ? 'delete' : $self->{'in_hash'}->{'new'} ? 'create' : 'modify',
	    'serv', $self->{'xinet'}->{'values'}->[0], $self->{'xinet'}->{'quick'});
$self->redirect("");

1;
		
}


1;

